/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],se=function(W){for(var t=[],F=0,P=W.length;F<P;F++)t[F]=ie[W[F]];return t};const je=this,Ce=typeof global=="object"?global:{};var he;(function(W){W.global=je;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}W.Environment=t})(he||(he={}));var he;(function(W){class t{constructor(o,N,f){this.type=o,this.detail=N,this.timestamp=f}}W.LoaderEvent=t;class F{constructor(o){this._events=[new t(1,"",o)]}record(o,N){this._events.push(new t(o,N,W.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}W.LoaderEventRecorder=F;class P{record(o,N){}getEvents(){return[]}}P.INSTANCE=new P,W.NullLoaderEventRecorder=P})(he||(he={}));var he;(function(W){class t{static fileUriToFilePath(P,r){if(r=decodeURI(r).replace(/%23/g,"#"),P){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(P,r){return P.length>=r.length&&P.substr(0,r.length)===r}static endsWith(P,r){return P.length>=r.length&&P.substr(P.length-r.length)===r}static containsQueryString(P){return/^[^\#]*\?/gi.test(P)}static isAbsolutePath(P){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(P)}static forEachProperty(P,r){if(P){let o;for(o in P)P.hasOwnProperty(o)&&r(o,P[o])}}static isEmpty(P){let r=!0;return t.forEachProperty(P,()=>{r=!1}),r}static recursiveClone(P){if(!P||typeof P!="object"||P instanceof RegExp||!Array.isArray(P)&&Object.getPrototypeOf(P)!==Object.prototype)return P;let r=Array.isArray(P)?[]:{};return t.forEachProperty(P,(o,N)=>{N&&typeof N=="object"?r[o]=t.recursiveClone(N):r[o]=N}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(P){return t.startsWith(P,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,W.Utilities=t})(he||(he={}));var he;(function(W){function t(r){if(r instanceof Error)return r;const o=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(o.stack=r.stack),o}W.ensureError=t;class F{static validateConfigurationOptions(o){function N(f){if(f.phase==="loading"){console.error('Loading "'+f.moduleId+'" failed'),console.error(f),console.error("Here are the modules that depend on it:"),console.error(f.neededBy);return}if(f.phase==="factory"){console.error('The factory function of "'+f.moduleId+'" has thrown an exception'),console.error(f),console.error("Here are the modules that depend on it:"),console.error(f.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=N),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(W.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const f=t(new Error("INVALID cached data configuration, 'path' MUST be set"));f.phase="configuration",o.onError(f),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,N=null){let f=W.Utilities.recursiveClone(N||{});return W.Utilities.forEachProperty(o,(a,s)=>{a==="ignoreDuplicateModules"&&typeof f.ignoreDuplicateModules<"u"?f.ignoreDuplicateModules=f.ignoreDuplicateModules.concat(s):a==="paths"&&typeof f.paths<"u"?W.Utilities.forEachProperty(s,(h,A)=>f.paths[h]=A):a==="config"&&typeof f.config<"u"?W.Utilities.forEachProperty(s,(h,A)=>f.config[h]=A):f[a]=W.Utilities.recursiveClone(s)}),F.validateConfigurationOptions(f)}}W.ConfigurationOptionsUtil=F;class P{constructor(o,N){if(this._env=o,this.options=F.mergeConfigurationOptions(N),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let f=this.options.nodeRequire.main.filename,a=Math.max(f.lastIndexOf("/"),f.lastIndexOf("\\"));this.options.baseUrl=f.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,(o,N)=>{Array.isArray(N)?this.sortedPathsRules.push({from:o,to:N}):this.sortedPathsRules.push({from:o,to:[N]})}),this.sortedPathsRules.sort((o,N)=>N.from.length-o.from.length)}cloneAndMerge(o){return new P(this._env,F.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let N;for(let f=0,a=this.sortedPathsRules.length;f<a;f++)if(N=this.sortedPathsRules[f],W.Utilities.startsWith(o,N.from)){let s=[];for(let h=0,A=N.to.length;h<A;h++)s.push(N.to[h]+o.substr(N.from.length));return s}return[o]}_addUrlArgsToUrl(o){return W.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let N=0,f=o.length;N<f;N++)o[N]=this._addUrlArgsToUrl(o[N]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let N=o,f;if(!W.Utilities.endsWith(N,".js")&&!W.Utilities.isAbsolutePath(N)){f=this._applyPaths(N);for(let a=0,s=f.length;a<s;a++)this.isBuild()&&f[a]==="empty:"||(W.Utilities.isAbsolutePath(f[a])||(f[a]=this.options.baseUrl+f[a]),!W.Utilities.endsWith(f[a],".js")&&!W.Utilities.containsQueryString(f[a])&&(f[a]=f[a]+".js"))}else!W.Utilities.endsWith(N,".js")&&!W.Utilities.containsQueryString(N)&&(N=N+".js"),f=[N];return this._addUrlArgsIfNecessaryToUrls(f)}requireToUrl(o){let N=o;return W.Utilities.isAbsolutePath(N)||(N=this._applyPaths(N)[0],W.Utilities.isAbsolutePath(N)||(N=this.options.baseUrl+N)),this._addUrlArgsIfNecessaryToUrl(N)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||W.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}W.Configuration=P})(he||(he={}));var he;(function(W){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,h,A,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new F:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new F;let g={callback:A,errorback:b};if(this._callbackMap.hasOwnProperty(h)){this._callbackMap[h].push(g);return}this._callbackMap[h]=[g],this._scriptLoader.load(s,h,()=>this.triggerCallback(h),e=>this.triggerErrorback(h,e))}triggerCallback(s){let h=this._callbackMap[s];delete this._callbackMap[s];for(let A=0;A<h.length;A++)h[A].callback()}triggerErrorback(s,h){let A=this._callbackMap[s];delete this._callbackMap[s];for(let b=0;b<A.length;b++)A[b].errorback(h)}}class F{attachListeners(s,h,A){let b=()=>{s.removeEventListener("load",g),s.removeEventListener("error",e)},g=E=>{b(),h()},e=E=>{b(),A(E)};s.addEventListener("load",g),s.addEventListener("error",e)}load(s,h,A,b){if(/^node\|/.test(h)){let g=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),g.nodeRequire||W.global.nodeRequire),E=h.split("|"),R=null;try{R=e(E[1])}catch(L){b(L);return}s.enqueueDefineAnonymousModule([],()=>R),A()}else{let g=document.createElement("script");g.setAttribute("async","async"),g.setAttribute("type","text/javascript"),this.attachListeners(g,A,b);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(h=e.createScriptURL(h)),g.setAttribute("src",h);const{cspNonce:E}=s.getConfig().getOptionsLiteral();E&&g.setAttribute("nonce",E),document.getElementsByTagName("head")[0].appendChild(g)}}}function P(a){const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=P(s)),this._cachedCanUseEval}load(s,h,A,b){if(/^node\|/.test(h)){const g=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),g.nodeRequire||W.global.nodeRequire),E=h.split("|");let R=null;try{R=e(E[1])}catch(L){b(L);return}s.enqueueDefineAnonymousModule([],function(){return R}),A()}else{const{trustedTypesPolicy:g}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(h).then(E=>{if(E.status!==200)throw new Error(E.statusText);return E.text()}).then(E=>{E=`${E}
//# sourceURL=${h}`,(g?self.eval(g.createScript("",E)):new Function(E)).call(self),A()}).then(void 0,b);return}try{g&&(h=g.createScriptURL(h)),importScripts(h),A()}catch(E){b(E)}}}}class o{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,h){const{nodeCachedData:A}=h.getConfig().getOptionsLiteral();if(!A||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,g=s("module");function e(E){const R=E.constructor;let L=function(m){try{return E.require(m)}finally{}};return L.resolve=function(m,u){return R._resolveFilename(m,E,!1,u)},L.resolve.paths=function(m){return R._resolveLookupPaths(m,E)},L.main=process.mainModule,L.extensions=R._extensions,L.cache=R._cache,L}g.prototype._compile=function(E,R){const L=g.wrap(E.replace(/^#!.*/,"")),$=h.getRecorder(),m=b._getCachedDataPath(A,R),u={filename:R};let c;try{const M=b._fs.readFileSync(m);c=M.slice(0,16),u.cachedData=M.slice(16),$.record(60,m)}catch{$.record(61,m)}const n=new b._vm.Script(L,u),l=n.runInThisContext(u),v=b._path.dirname(R),d=e(this),w=[this.exports,d,this,R,v,process,Ce,Buffer],k=l.apply(this.exports,w);return b._handleCachedData(n,L,m,!u.cachedData,h),b._verifyCachedData(n,L,m,c,h),k}}load(s,h,A,b){const g=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),g.nodeRequire||W.global.nodeRequire),E=g.nodeInstrumenter||function(L){return L};this._init(e),this._initNodeRequire(e,s);let R=s.getRecorder();if(/^node\|/.test(h)){let L=h.split("|"),$=null;try{$=e(L[1])}catch(m){b(m);return}s.enqueueDefineAnonymousModule([],()=>$),A()}else{h=W.Utilities.fileUriToFilePath(this._env.isWindows,h);const L=this._path.normalize(h),$=this._getElectronRendererScriptPathOrUri(L),m=!!g.nodeCachedData,u=m?this._getCachedDataPath(g.nodeCachedData,h):void 0;this._readSourceAndCachedData(L,u,R,(c,n,l,v)=>{if(c){b(c);return}let d;n.charCodeAt(0)===o._BOM?d=o._PREFIX+n.substring(1)+o._SUFFIX:d=o._PREFIX+n+o._SUFFIX,d=E(d,L);const w={filename:$,cachedData:l},k=this._createAndEvalScript(s,d,w,A,b);this._handleCachedData(k,d,u,m&&!l,s),this._verifyCachedData(k,d,u,v,s)})}}_createAndEvalScript(s,h,A,b,g){const e=s.getRecorder();e.record(31,A.filename);const E=new this._vm.Script(h,A),R=E.runInThisContext(A),L=s.getGlobalAMDDefineFunc();let $=!1;const m=function(){return $=!0,L.apply(null,arguments)};return m.amd=L.amd,R.call(W.global,s.getGlobalAMDRequireFunc(),m,A.filename,this._path.dirname(A.filename)),e.record(32,A.filename),$?b():g(new Error(`Didn't receive define call in ${A.filename}!`)),E}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let h=s.match(/^([a-z])\:(.*)/i);return h?`file:///${(h[1].toUpperCase()+":"+h[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,h){const A=this._crypto.createHash("md5").update(h,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(h).replace(/\.js$/,"");return this._path.join(s.path,`${b}-${A}.code`)}_handleCachedData(s,h,A,b,g){s.cachedDataRejected?this._fs.unlink(A,e=>{g.getRecorder().record(62,A),this._createAndWriteCachedData(s,h,A,g),e&&g.getConfig().onError(e)}):b&&this._createAndWriteCachedData(s,h,A,g)}_createAndWriteCachedData(s,h,A,b){let g=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,E=0,R;const L=()=>{setTimeout(()=>{R||(R=this._crypto.createHash("md5").update(h,"utf8").digest());const $=s.createCachedData();if(!($.length===0||$.length===e||E>=5)){if($.length<e){L();return}e=$.length,this._fs.writeFile(A,Buffer.concat([R,$]),m=>{m&&b.getConfig().onError(m),b.getRecorder().record(63,A),L()})}},g*Math.pow(4,E++))};L()}_readSourceAndCachedData(s,h,A,b){if(!h)this._fs.readFile(s,{encoding:"utf8"},b);else{let g,e,E,R=2;const L=$=>{$?b($):--R===0&&b(void 0,g,e,E)};this._fs.readFile(s,{encoding:"utf8"},($,m)=>{g=m,L($)}),this._fs.readFile(h,($,m)=>{!$&&m&&m.length>0?(E=m.slice(0,16),e=m.slice(16),A.record(60,h)):A.record(61,h),L()})}}_verifyCachedData(s,h,A,b,g){b&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(h,"utf8").digest();b.equals(e)||(g.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${A}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(A,E=>{E&&g.getConfig().onError(E)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function N(a,s){if(s.__$__isRecorded)return s;const h=function(b){a.record(33,b);try{return s(b)}finally{a.record(34,b)}};return h.__$__isRecorded=!0,h}W.ensureRecordedNodeRequire=N;function f(a){return new t(a)}W.createScriptLoader=f})(he||(he={}));var he;(function(W){class t{constructor(a){let s=a.lastIndexOf("/");s!==-1?this.fromModulePath=a.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(a){let s=a,h;for(h=/\/\.\//;h.test(s);)s=s.replace(h,"/");for(s=s.replace(/^\.\//g,""),h=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;h.test(s);)s=s.replace(h,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(a){let s=a;return W.Utilities.isAbsolutePath(s)||(W.Utilities.startsWith(s,"./")||W.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),W.ModuleIdResolver=t;class F{constructor(a,s,h,A,b,g){this.id=a,this.strId=s,this.dependencies=h,this._callback=A,this._errorback=b,this.moduleIdResolver=g,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,s){try{return{returnedValue:a.apply(W.global,s),producedError:null}}catch(h){return{returnedValue:null,producedError:h}}}static _invokeFactory(a,s,h,A){return a.shouldInvokeFactory(s)?a.shouldCatchError()?this._safeInvokeFunction(h,A):{returnedValue:h.apply(W.global,A),producedError:null}:{returnedValue:null,producedError:null}}complete(a,s,h,A){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let g=F._invokeFactory(s,this.strId,this._callback,h);b=g.producedError,a.record(22,this.strId),!b&&typeof g.returnedValue<"u"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=g.returnedValue)}else this.exports=this._callback;if(b){let g=W.ensureError(b);g.phase="factory",g.moduleId=this.strId,g.neededBy=A(this.id),this.error=g,s.onError(g)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}W.Module=F;class P{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let s=this._strModuleIdToIntModuleId.get(a);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(a,s),this._intModuleIdToStrModuleId[s]=a),s}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class r{constructor(a){this.id=a}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),W.RegularDependency=r;class o{constructor(a,s,h){this.id=a,this.pluginId=s,this.pluginParam=h}}W.PluginDependency=o;class N{constructor(a,s,h,A,b=0){this._env=a,this._scriptLoader=s,this._loaderAvailableTimestamp=b,this._defineFunc=h,this._requireFunc=A,this._moduleIdProvider=new P,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new N(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,s){let h=g=>g.replace(/\\/g,"/"),A=h(a),b=s.split(/\n/);for(let g=0;g<b.length;g++){let e=b[g].match(/(.*):(\d+):(\d+)\)?$/);if(e){let E=e[1],R=e[2],L=e[3],$=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr($),E=h(E),E===A){let m={line:parseInt(R,10),col:parseInt(L,10)};return m.line===1&&(m.col-=53),m}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],s=0;for(let h=0,A=this._modules2.length;h<A;h++){let b=this._modules2[h];if(!b)continue;let g=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,E=this._buildInfoDependencies[b.id];a[s++]={id:b.strId,path:g,defineLocation:g&&e?N._findRelevantLocationInStack(g,e):null,dependencies:E,shim:null,exports:b.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let h=null;this._config.isBuild()&&(h=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:h,dependencies:a,callback:s}}defineModule(a,s,h,A,b,g=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let E=new F(e,a,this._normalizeDependencies(s,g),h,A,g);this._modules2[e]=E,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(E.dependencies||[]).map(R=>this._moduleIdProvider.getStrModuleId(R.id))),this._resolve(E)}_normalizeDependency(a,s){if(a==="exports")return r.EXPORTS;if(a==="module")return r.MODULE;if(a==="require")return r.REQUIRE;let h=a.indexOf("!");if(h>=0){let A=s.resolveModule(a.substr(0,h)),b=s.resolveModule(a.substr(h+1)),g=this._moduleIdProvider.getModuleId(A+"!"+b),e=this._moduleIdProvider.getModuleId(A);return new o(g,e,b)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(a)))}_normalizeDependencies(a,s){let h=[],A=0;for(let b=0,g=a.length;b<g;b++)h[A++]=this._normalizeDependency(a[b],s);return h}_relativeRequire(a,s,h,A){if(typeof s=="string")return this.synchronousRequire(s,a);this.defineModule(W.Utilities.generateAnonymousModule(),s,h,A,null,a)}synchronousRequire(a,s=new t(a)){let h=this._normalizeDependency(a,s),A=this._modules2[h.id];if(!A)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!A.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(A.error)throw A.error;return A.exports}configure(a,s){let h=this._config.shouldRecordStats();s?this._config=new W.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!h&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),s.dependencies,s.callback,null,s.stack)}}_createLoadError(a,s){let h=this._moduleIdProvider.getStrModuleId(a),A=(this._inverseDependencies2[a]||[]).map(g=>this._moduleIdProvider.getStrModuleId(g));const b=W.ensureError(s);return b.phase="loading",b.moduleId=h,b.neededBy=A,b}_onLoadError(a,s){const h=this._createLoadError(a,s);this._modules2[a]||(this._modules2[a]=new F(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let A=[];for(let e=0,E=this._moduleIdProvider.getMaxModuleId();e<E;e++)A[e]=!1;let b=!1,g=[];for(g.push(a),A[a]=!0;g.length>0;){let e=g.shift(),E=this._modules2[e];E&&(b=E.onDependencyError(h)||b);let R=this._inverseDependencies2[e];if(R)for(let L=0,$=R.length;L<$;L++){let m=R[L];A[m]||(g.push(m),A[m]=!0)}}b||this._config.onError(h)}_hasDependencyPath(a,s){let h=this._modules2[a];if(!h)return!1;let A=[];for(let g=0,e=this._moduleIdProvider.getMaxModuleId();g<e;g++)A[g]=!1;let b=[];for(b.push(h),A[a]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let E=0,R=e.length;E<R;E++){let L=e[E];if(L.id===s)return!0;let $=this._modules2[L.id];$&&!A[L.id]&&(A[L.id]=!0,b.push($))}}return!1}_findCyclePath(a,s,h){if(a===s||h===50)return[a];let A=this._modules2[a];if(!A)return null;let b=A.dependencies;if(b)for(let g=0,e=b.length;g<e;g++){let E=this._findCyclePath(b[g].id,s,h+1);if(E!==null)return E.push(a),E}return null}_createRequire(a){let s=(h,A,b)=>this._relativeRequire(a,h,A,b);return s.toUrl=h=>this._config.requireToUrl(a.resolveModule(h)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(h,A=!1)=>{this.configure(h,A)},s.__$__nodeRequire=W.global.nodeRequire,s}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let s=this._moduleIdProvider.getStrModuleId(a),h=this._config.moduleIdToPaths(s),A=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||A.test(s))&&h.push("node|"+s);let b=-1,g=e=>{if(b++,b>=h.length)this._onLoadError(a,e);else{let E=h[b],R=this.getRecorder();if(this._config.isBuild()&&E==="empty:"){this._buildInfoPath[a]=E,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}R.record(10,E),this._scriptLoader.load(this,E,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=E),R.record(11,E),this._onLoad(a)},L=>{R.record(12,E),g(L)})}};g(null)}_loadPluginDependency(a,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let h=A=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],A,null,null)};h.error=A=>{this._config.onError(this._createLoadError(s.id,A))},a.load(s.pluginParam,this._createRequire(t.ROOT),h,this._config.getOptionsLiteral())}_resolve(a){let s=a.dependencies;if(s)for(let h=0,A=s.length;h<A;h++){let b=s[h];if(b===r.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(b===r.MODULE){a.unresolvedDependenciesCount--;continue}if(b===r.REQUIRE){a.unresolvedDependenciesCount--;continue}let g=this._modules2[b.id];if(g&&g.isComplete()){if(g.error){a.onDependencyError(g.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,a.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(E=>this._moduleIdProvider.getStrModuleId(E)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(a.id),b instanceof o){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let E=this._inversePluginDependencies2.get(b.pluginId);E||(E=[],this._inversePluginDependencies2.set(b.pluginId,E)),E.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let s=this.getRecorder();if(a.isComplete())return;let h=a.dependencies,A=[];if(h)for(let E=0,R=h.length;E<R;E++){let L=h[E];if(L===r.EXPORTS){A[E]=a.exports;continue}if(L===r.MODULE){A[E]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(L===r.REQUIRE){A[E]=this._createRequire(a.moduleIdResolver);continue}let $=this._modules2[L.id];if($){A[E]=$.exports;continue}A[E]=null}const b=E=>(this._inverseDependencies2[E]||[]).map(R=>this._moduleIdProvider.getStrModuleId(R));a.complete(s,this._config,A,b);let g=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,g)for(let E=0,R=g.length;E<R;E++){let L=g[E],$=this._modules2[L];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let E=0,R=e.length;E<R;E++)this._loadPluginDependency(a.exports,e[E])}}}W.ModuleManager=N})(he||(he={}));var te,he;(function(W){const t=new W.Environment;let F=null;const P=function(f,a,s){typeof f!="string"&&(s=a,a=f,f=null),(typeof a!="object"||!Array.isArray(a))&&(s=a,a=null),a||(a=["require","exports","module"]),f?F.defineModule(f,a,s,null,null):F.enqueueDefineAnonymousModule(a,s)};P.amd={jQuery:!0};const r=function(f,a=!1){F.configure(f,a)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return F.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){F.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=r,o.getConfig=function(){return F.getConfig().getOptionsLiteral()},o.reset=function(){F=F.reset()},o.getBuildInfo=function(){return F.getBuildInfo()},o.getStats=function(){return F.getLoaderEvents()},o.define=P;function N(){if(typeof W.global.require<"u"||typeof require<"u"){const f=W.global.require||require;if(typeof f=="function"&&typeof f.resolve=="function"){const a=W.ensureRecordedNodeRequire(F.getRecorder(),f);W.global.nodeRequire=a,o.nodeRequire=a,o.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=o:(t.isElectronRenderer||(W.global.define=P),W.global.require=o)}W.init=N,(typeof W.global.define!="function"||!W.global.define.amd)&&(F=new W.ModuleManager(t,W.createScriptLoader(t),P,o,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require<"u"&&typeof W.global.require!="function"&&o.config(W.global.require),te=function(){return P.apply(null,arguments)},te.amd=P.amd,typeof doNotInitLoader>"u"&&N())})(he||(he={})),te(ie[69],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function F(f,a,s,h){if(h=h||{},(h["vs/css"]||{}).disabled){s({});return}const b=a.toUrl(f+".css");P(f,b,()=>{s({})},g=>{typeof s.error=="function"&&s.error("Could not find "+b+".")})}t.load=F;function P(f,a,s,h){if(r(f,a)){s();return}o(f,a,s,h)}function r(f,a){const s=window.document.getElementsByTagName("link");for(let h=0,A=s.length;h<A;h++){const b=s[h].getAttribute("data-name"),g=s[h].getAttribute("href");if(b===f||g===a)return!0}return!1}function o(f,a,s,h){const A=document.createElement("link");A.setAttribute("rel","stylesheet"),A.setAttribute("type","text/css"),A.setAttribute("data-name",f),N(f,A,s,h),A.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(A)}function N(f,a,s,h){const A=()=>{a.removeEventListener("load",b),a.removeEventListener("error",g)},b=e=>{A(),s()},g=e=>{A(),h(e)};a.addEventListener("load",b),a.addEventListener("error",g)}}),te("vs/nls",["require","exports"],function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let F=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const P="i-default";function r(R,L){let $;return L.length===0?$=R:$=R.replace(/\{(\d+)\}/g,(m,u)=>{const c=u[0],n=L[c];let l=m;return typeof n=="string"?l=n:(typeof n=="number"||typeof n=="boolean"||n===void 0||n===null)&&(l=String(n)),l}),F&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function o(R,L){let $=R[L];return $||($=R["*"],$)?$:null}function N(R){return R.charAt(R.length-1)==="/"?R:R+"/"}async function f(R,L,$){const m=N(R)+N(L)+"vscode/"+N($),u=await fetch(m);if(u.ok)return await u.json();throw new Error(`${u.status} - ${u.statusText}`)}function a(R){return function(L,$){const m=Array.prototype.slice.call(arguments,2);return r(R[L],m)}}function s(R){return(L,$,...m)=>({value:r(R[L],m),original:r($,m)})}function h(R,L,...$){return r(L,$)}t.localize=h;function A(R,L,...$){const m=r(L,$);return{value:m,original:m}}t.localize2=A;function b(R){}t.getConfiguredDefaultLocale=b;function g(R){F=R}t.setPseudoTranslation=g;function e(R,L){return{localize:a(L[R]),localize2:s(L[R]),getConfiguredDefaultLocale:L.getConfiguredDefaultLocale??($=>{})}}t.create=e;function E(R,L,$,m){const u=m["vs/nls"]??{};if(!R||R.length===0)return $({localize:h,localize2:A,getConfiguredDefaultLocale:()=>u.availableLanguages?.["*"]});const c=u.availableLanguages?o(u.availableLanguages,R):null,n=c===null||c===P;let l=".nls";n||(l=l+"."+c);const v=d=>{Array.isArray(d)?(d.localize=a(d),d.localize2=s(d)):(d.localize=a(d[R]),d.localize2=s(d[R])),d.getConfiguredDefaultLocale=()=>u.availableLanguages?.["*"],$(d)};typeof u.loadBundle=="function"?u.loadBundle(R,c,(d,w)=>{d?L([R+".nls"],v):v(w)}):u.translationServiceUrl&&!n?(async()=>{try{const d=await f(u.translationServiceUrl,c,R);return v(d)}catch(d){if(!c.includes("-"))return console.error(d),L([R+".nls"],v);try{const w=c.split("-")[0],k=await f(u.translationServiceUrl,w,R);return u.availableLanguages??={},u.availableLanguages["*"]=w,v(k)}catch(w){return console.error(w),L([R+".nls"],v)}}})():L([R+l],v,d=>{if(l===".nls"){console.error("Failed trying to load default language strings",d);return}console.error(`Failed to load message bundle for language ${c}. Falling back to the default language:`,d),L([R+".nls"],v)})}t.load=E}),function(){const W=globalThis.MonacoEnvironment,t=W&&W.baseUrl?W.baseUrl:"../../../";function F(h,A){if(W?.createTrustedTypesPolicy)try{return W.createTrustedTypesPolicy(h,A)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(h,A)}catch(b){console.warn(b);return}}const P=F("amdLoader",{createScriptURL:h=>h,createScript:(h,...A)=>{const b=A.slice(0,-1).join(","),g=A.pop().toString();return`(function anonymous(${b}) { ${g}
})`}});function r(){try{return(P?globalThis.eval(P.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((h,A)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return h();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(P?globalThis.eval(P.createScript("",e)):new Function(e)).call(globalThis),h()}).then(void 0,A);return}P?importScripts(P.createScriptURL(b)):importScripts(b),h()})}function N(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:P,amdModulesPattern:/^vs\//})}function f(h){o().then(()=>{N(),require([h],function(A){setTimeout(function(){const b=A.create((g,e)=>{globalThis.postMessage(g,e)},null);for(globalThis.onmessage=g=>b.onmessage(g.data,g.ports);s.length>0;){const g=s.shift();b.onmessage(g.data,g.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&N();let a=!0;const s=[];globalThis.onmessage=h=>{if(!a){s.push(h);return}a=!1,f(h.data)}}(),te(ie[9],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function F(E,R,L){const $=P(E,R);if($!==-1)return E[$]}t.$fb=F;function P(E,R,L=E.length-1){for(let $=L;$>=0;$--){const m=E[$];if(R(m))return $}return-1}t.$gb=P;function r(E,R){const L=o(E,R);return L===-1?void 0:E[L]}t.$hb=r;function o(E,R,L=0,$=E.length){let m=L,u=$;for(;m<u;){const c=Math.floor((m+u)/2);R(E[c])?m=c+1:u=c}return m-1}t.$ib=o;function N(E,R){const L=f(E,R);return L===E.length?void 0:E[L]}t.$jb=N;function f(E,R,L=0,$=E.length){let m=L,u=$;for(;m<u;){const c=Math.floor((m+u)/2);R(E[c])?u=c:m=c+1}return m}t.$kb=f;function a(E,R,L=0,$=E.length){const m=f(E,R,L,$);return m===E.length?-1:m}t.$lb=a;class s{static{this.assertInvariants=!1}constructor(R){this.e=R,this.c=0}findLastMonotonous(R){if(s.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!R($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=R}const L=o(this.e,R,this.c);return this.c=L+1,L===-1?void 0:this.e[L]}}t.$mb=s;function h(E,R){if(E.length===0)return;let L=E[0];for(let $=1;$<E.length;$++){const m=E[$];R(m,L)>0&&(L=m)}return L}t.$nb=h;function A(E,R){if(E.length===0)return;let L=E[0];for(let $=1;$<E.length;$++){const m=E[$];R(m,L)>=0&&(L=m)}return L}t.$ob=A;function b(E,R){return h(E,(L,$)=>-R(L,$))}t.$pb=b;function g(E,R){if(E.length===0)return-1;let L=0;for(let $=1;$<E.length;$++){const m=E[$];R(m,E[L])>0&&(L=$)}return L}t.$qb=g;function e(E,R){for(const L of E){const $=R(L);if($!==void 0)return $}}t.$rb=e}),te(ie[34],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function F(N,f){const a=Object.create(null);for(const s of N){const h=f(s);let A=a[h];A||(A=a[h]=[]),A.push(s)}return a}t.$K=F;function P(N,f){const a=[],s=[];for(const h of N)f.has(h)||a.push(h);for(const h of f)N.has(h)||s.push(h);return{removed:a,added:s}}t.$L=P;function r(N,f){const a=[],s=[];for(const[h,A]of N)f.has(h)||a.push(A);for(const[h,A]of f)N.has(h)||s.push(A);return{removed:a,added:s}}t.$M=r;function o(N,f){const a=new Set;for(const s of f)N.has(s)&&a.add(s);return a}t.$N=o}),te(ie[35],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xt=t.$wt=t.$vt=t.$ut=void 0;function F(f,a){const s=Math.pow(10,a);return Math.round(f*s)/s}class P{constructor(a,s,h,A=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=F(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.r===s.r&&a.g===s.g&&a.b===s.b&&a.a===s.a}}t.$ut=P;class r{constructor(a,s,h,A){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=F(Math.max(Math.min(1,s),0),3),this.l=F(Math.max(Math.min(1,h),0),3),this.a=F(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.l===s.l&&a.a===s.a}static fromRGBA(a){const s=a.r/255,h=a.g/255,A=a.b/255,b=a.a,g=Math.max(s,h,A),e=Math.min(s,h,A);let E=0,R=0;const L=(e+g)/2,$=g-e;if($>0){switch(R=Math.min(L<=.5?$/(2*L):$/(2-2*L),1),g){case s:E=(h-A)/$+(h<A?6:0);break;case h:E=(A-s)/$+2;break;case A:E=(s-h)/$+4;break}E*=60,E=Math.round(E)}return new r(E,R,L,b)}static i(a,s,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?a+(s-a)*6*h:h<1/2?s:h<2/3?a+(s-a)*(2/3-h)*6:a}static toRGBA(a){const s=a.h/360,{s:h,l:A,a:b}=a;let g,e,E;if(h===0)g=e=E=A;else{const R=A<.5?A*(1+h):A+h-A*h,L=2*A-R;g=r.i(L,R,s+1/3),e=r.i(L,R,s),E=r.i(L,R,s-1/3)}return new P(Math.round(g*255),Math.round(e*255),Math.round(E*255),b)}}t.$vt=r;class o{constructor(a,s,h,A){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=F(Math.max(Math.min(1,s),0),3),this.v=F(Math.max(Math.min(1,h),0),3),this.a=F(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.v===s.v&&a.a===s.a}static fromRGBA(a){const s=a.r/255,h=a.g/255,A=a.b/255,b=Math.max(s,h,A),g=Math.min(s,h,A),e=b-g,E=b===0?0:e/b;let R;return e===0?R=0:b===s?R=((h-A)/e%6+6)%6:b===h?R=(A-s)/e+2:R=(s-h)/e+4,new o(Math.round(R*60),E,b,a.a)}static toRGBA(a){const{h:s,s:h,v:A,a:b}=a,g=A*h,e=g*(1-Math.abs(s/60%2-1)),E=A-g;let[R,L,$]=[0,0,0];return s<60?(R=g,L=e):s<120?(R=e,L=g):s<180?(L=g,$=e):s<240?(L=e,$=g):s<300?(R=e,$=g):s<=360&&(R=g,$=e),R=Math.round((R+E)*255),L=Math.round((L+E)*255),$=Math.round(($+E)*255),new P(R,L,$,b)}}t.$wt=o;class N{static fromHex(a){return N.Format.CSS.parseHex(a)||N.red}static equals(a,s){return!a&&!s?!0:!a||!s?!1:a.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:o.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof P)this.rgba=a;else if(a instanceof r)this.i=a,this.rgba=r.toRGBA(a);else if(a instanceof o)this.j=a,this.rgba=o.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&P.equals(this.rgba,a.rgba)&&r.equals(this.hsla,a.hsla)&&o.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=N.k(this.rgba.r),s=N.k(this.rgba.g),h=N.k(this.rgba.b),A=.2126*a+.7152*s+.0722*h;return F(A,4)}static k(a){const s=a/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s>h?(s+.05)/(h+.05):(h+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s>h}isDarkerThan(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s<h}lighten(a){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:s,g:h,b:A,a:b}=this.rgba;return new N(new P(s,h,A,b*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new N(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const s=a.rgba,h=this.rgba.a,A=s.a,b=h+A*(1-h);if(b<1e-6)return N.transparent;const g=this.rgba.r*h/b+s.r*A*(1-h)/b,e=this.rgba.g*h/b+s.g*A*(1-h)/b,E=this.rgba.b*h/b+s.b*A*(1-h)/b;return new N(new P(g,e,E,b))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:s,g:h,b:A,a:b}=this.rgba;return new N(new P(a.rgba.r-b*(a.rgba.r-s),a.rgba.g-b*(a.rgba.g-h),a.rgba.b-b*(a.rgba.b-A),1))}flatten(...a){const s=a.reduceRight((h,A)=>N.o(A,h));return N.o(this,s)}static o(a,s){const h=1-a.rgba.a;return new N(new P(h*s.rgba.r+a.rgba.a*a.rgba.r,h*s.rgba.g+a.rgba.a*a.rgba.g,h*s.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=N.Format.CSS.format(this)),this.u}static getLighterColor(a,s,h){if(a.isLighterThan(s))return a;h=h||.5;const A=a.getRelativeLuminance(),b=s.getRelativeLuminance();return h=h*(b-A)/b,a.lighten(h)}static getDarkerColor(a,s,h){if(a.isDarkerThan(s))return a;h=h||.5;const A=a.getRelativeLuminance(),b=s.getRelativeLuminance();return h=h*(A-b)/A,a.darken(h)}static{this.white=new N(new P(255,255,255,1))}static{this.black=new N(new P(0,0,0,1))}static{this.red=new N(new P(255,0,0,1))}static{this.blue=new N(new P(0,0,255,1))}static{this.green=new N(new P(0,255,0,1))}static{this.cyan=new N(new P(0,255,255,1))}static{this.lightgrey=new N(new P(211,211,211,1))}static{this.transparent=new N(new P(0,0,0,0))}}t.$xt=N,function(f){let a;(function(s){let h;(function(A){function b(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:f.Format.CSS.formatRGBA(n)}A.formatRGB=b;function g(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}A.formatRGBA=g;function e(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:f.Format.CSS.formatHSLA(n)}A.formatHSL=e;function E(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}A.formatHSLA=E;function R(n){const l=n.toString(16);return l.length!==2?"0"+l:l}function L(n){return`#${R(n.rgba.r)}${R(n.rgba.g)}${R(n.rgba.b)}`}A.formatHex=L;function $(n,l=!1){return l&&n.rgba.a===1?f.Format.CSS.formatHex(n):`#${R(n.rgba.r)}${R(n.rgba.g)}${R(n.rgba.b)}${R(Math.round(n.rgba.a*255))}`}A.formatHexA=$;function m(n){return n.isOpaque()?f.Format.CSS.formatHex(n):f.Format.CSS.formatRGBA(n)}A.format=m;function u(n){const l=n.length;if(l===0||n.charCodeAt(0)!==35)return null;if(l===7){const v=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),d=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),w=16*c(n.charCodeAt(5))+c(n.charCodeAt(6));return new f(new P(v,d,w,1))}if(l===9){const v=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),d=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),w=16*c(n.charCodeAt(5))+c(n.charCodeAt(6)),k=16*c(n.charCodeAt(7))+c(n.charCodeAt(8));return new f(new P(v,d,w,k/255))}if(l===4){const v=c(n.charCodeAt(1)),d=c(n.charCodeAt(2)),w=c(n.charCodeAt(3));return new f(new P(16*v+v,16*d+d,16*w+w))}if(l===5){const v=c(n.charCodeAt(1)),d=c(n.charCodeAt(2)),w=c(n.charCodeAt(3)),k=c(n.charCodeAt(4));return new f(new P(16*v+v,16*d+d,16*w+w,(16*k+k)/255))}return null}A.parseHex=u;function c(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(h=s.CSS||(s.CSS={}))})(a=f.Format||(f.Format={}))}(N||(t.$xt=N={}))}),te(ie[36],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9s=void 0;class F{constructor(r,o,N,f){this.originalStart=r,this.originalLength=o,this.modifiedStart=N,this.modifiedLength=f}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$9s=F}),te(ie[3],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class F{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?m.isErrorNoTelemetry(n)?new m(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(l=>{l(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$W=F,t.$X=new F;function P(c){t.$X.setUnexpectedErrorHandler(c)}t.setUnexpectedErrorHandler=P;function r(c){if(!c||typeof c!="object")return!1;const n=c;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}t.$Z=r;function o(c){s(c)||t.$X.onUnexpectedError(c)}t.$1=o;function N(c){s(c)||t.$X.onUnexpectedExternalError(c)}t.$2=N;function f(c){if(c instanceof Error){const{name:n,message:l}=c,v=c.stacktrace||c.stack;return{$isError:!0,name:n,message:l,stack:v,noTelemetry:m.isErrorNoTelemetry(c)}}return c}t.$3=f;const a="Canceled";function s(c){return c instanceof h?!0:c instanceof Error&&c.name===a&&c.message===a}t.$4=s;class h extends Error{constructor(){super(a),this.name=this.message}}t.$5=h;function A(){const c=new Error(a);return c.name=c.message,c}t.$6=A;function b(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}t.$7=b;function g(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}t.$8=g;class e extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function E(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}t.$0=E;class R extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$$=R;class L extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$_=L;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class m extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof m)return n;const l=new m;return l.message=n.message,l.stack=n.stack,l}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$bb=m;class u extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}t.$cb=u}),te(ie[6],se([0,1,3,9]),function(W,t,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function r(O,C=0){return O[O.length-(1+C)]}t.$sb=r;function o(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}t.$tb=o;function N(O,C,j=(J,z)=>J===z){if(O===C)return!0;if(!O||!C||O.length!==C.length)return!1;for(let J=0,z=O.length;J<z;J++)if(!j(O[J],C[J]))return!1;return!0}t.$ub=N;function f(O,C){const j=O.length-1;C<j&&(O[C]=O[j]),O.pop()}t.$vb=f;function a(O,C,j){return s(O.length,J=>j(O[J],C))}t.$wb=a;function s(O,C){let j=0,J=O-1;for(;j<=J;){const z=(j+J)/2|0,G=C(z);if(G<0)j=z+1;else if(G>0)J=z-1;else return z}return-(j+1)}t.$xb=s;function h(O,C,j){if(O=O|0,O>=C.length)throw new TypeError("invalid index");const J=C[Math.floor(C.length*Math.random())],z=[],G=[],Z=[];for(const K of C){const ne=j(K,J);ne<0?z.push(K):ne>0?G.push(K):Z.push(K)}return O<z.length?h(O,z,j):O<z.length+Z.length?Z[0]:h(O-(z.length+Z.length),G,j)}t.$yb=h;function A(O,C){const j=[];let J;for(const z of O.slice(0).sort(C))!J||C(J[0],z)!==0?(J=[z],j.push(J)):J.push(z);return j}t.$zb=A;function*b(O,C){let j,J;for(const z of O)J!==void 0&&C(J,z)?j.push(z):(j&&(yield j),j=[z]),J=z;j&&(yield j)}t.$Ab=b;function g(O,C){for(let j=0;j<=O.length;j++)C(j===0?void 0:O[j-1],j===O.length?void 0:O[j])}t.$Bb=g;function e(O,C){for(let j=0;j<O.length;j++)C(j===0?void 0:O[j-1],O[j],j+1===O.length?void 0:O[j+1])}t.$Cb=e;function E(O,C,j){const J=[];function z(K,ne,ae){if(ne===0&&ae.length===0)return;const ce=J[J.length-1];ce&&ce.start+ce.deleteCount===K?(ce.deleteCount+=ne,ce.toInsert.push(...ae)):J.push({start:K,deleteCount:ne,toInsert:ae})}let G=0,Z=0;for(;;){if(G===O.length){z(G,0,C.slice(Z));break}if(Z===C.length){z(G,O.length-G,[]);break}const K=O[G],ne=C[Z],ae=j(K,ne);ae===0?(G+=1,Z+=1):ae<0?(z(G,1,[]),G+=1):ae>0&&(z(G,0,[ne]),Z+=1)}return J}t.$Db=E;function R(O,C,j){const J=E(O,C,j),z=[],G=[];for(const Z of J)z.push(...O.slice(Z.start,Z.start+Z.deleteCount)),G.push(...Z.toInsert);return{removed:z,added:G}}t.$Eb=R;function L(O,C,j){if(j===0)return[];const J=O.slice(0,j).sort(C);return m(O,C,J,j,O.length),J}t.top=L;function $(O,C,j,J,z){return j===0?Promise.resolve([]):new Promise((G,Z)=>{(async()=>{const K=O.length,ne=O.slice(0,j).sort(C);for(let ae=j,ce=Math.min(j+J,K);ae<K;ae=ce,ce=Math.min(ce+J,K)){if(ae>j&&await new Promise(fe=>setTimeout(fe)),z&&z.isCancellationRequested)throw new F.$5;m(O,C,ne,ae,ce)}return ne})().then(G,Z)})}t.$Gb=$;function m(O,C,j,J,z){for(const G=j.length;J<z;J++){const Z=O[J];if(C(Z,j[G-1])<0){j.pop();const K=(0,P.$kb)(j,ne=>C(Z,ne)<0);j.splice(K,0,Z)}}}function u(O){return O.filter(C=>!!C)}t.$Hb=u;function c(O){let C=0;for(let j=0;j<O.length;j++)O[j]&&(O[C]=O[j],C+=1);O.length=C}t.$Ib=c;function n(O,C,j){O.splice(j,0,O.splice(C,1)[0])}t.$Jb=n;function l(O){return!Array.isArray(O)||O.length===0}t.$Kb=l;function v(O){return Array.isArray(O)&&O.length>0}t.$Lb=v;function d(O,C=j=>j){const j=new Set;return O.filter(J=>{const z=C(J);return j.has(z)?!1:(j.add(z),!0)})}t.$Mb=d;function w(O){const C=new Set;return j=>{const J=O(j);return C.has(J)?!1:(C.add(J),!0)}}t.$Nb=w;function k(O,C){return O.length>0?O[0]:C}t.$Ob=k;function M(O,C){return O.length>0?O[O.length-1]:C}t.$Pb=M;function y(O,C,j=(J,z)=>J===z){let J=0;for(let z=0,G=Math.min(O.length,C.length);z<G&&j(O[z],C[z]);z++)J++;return J}t.$Qb=y;function D(O){return[].concat(...O)}t.$Rb=D;function p(O,C){let j=typeof C=="number"?O:0;typeof C=="number"?j=O:(j=0,C=O);const J=[];if(j<=C)for(let z=j;z<C;z++)J.push(z);else for(let z=j;z>C;z--)J.push(z);return J}t.$Sb=p;function S(O,C,j){return O.reduce((J,z)=>(J[C(z)]=j?j(z):z,J),Object.create(null))}t.$Tb=S;function _(O,C){return O.push(C),()=>q(O,C)}t.$Ub=_;function q(O,C){const j=O.indexOf(C);if(j>-1)return O.splice(j,1),C}t.$Vb=q;function V(O,C,j){const J=O.slice(0,C),z=O.slice(C);return J.concat(j,z)}t.$Wb=V;function x(O,C){let j;if(typeof C=="number"){let J=C;j=()=>{const z=Math.sin(J++)*179426549;return z-Math.floor(z)}}else j=Math.random;for(let J=O.length-1;J>0;J-=1){const z=Math.floor(j()*(J+1)),G=O[J];O[J]=O[z],O[z]=G}}t.$Xb=x;function ee(O,C){const j=O.indexOf(C);j>-1&&(O.splice(j,1),O.unshift(C))}t.$Yb=ee;function T(O,C){const j=O.indexOf(C);j>-1&&(O.splice(j,1),O.push(C))}t.$Zb=T;function U(O,C){for(const j of C)O.push(j)}t.$1b=U;function Y(O,C){return Array.isArray(O)?O.map(C):C(O)}t.$2b=Y;function X(O){return Array.isArray(O)?O:[O]}t.$3b=X;function re(O){return O[Math.floor(Math.random()*O.length)]}t.$4b=re;function ue(O,C,j){const J=de(O,C),z=O.length,G=j.length;O.length=z+G;for(let Z=z-1;Z>=J;Z--)O[Z+G]=O[Z];for(let Z=0;Z<G;Z++)O[Z+J]=j[Z]}t.$5b=ue;function i(O,C,j,J){const z=de(O,C);let G=O.splice(z,j);return G===void 0&&(G=[]),ue(O,z,J),G}t.$6b=i;function de(O,C){return C<0?Math.max(C+O.length,0):Math.min(C,O.length)}var we;(function(O){function C(G){return G<0}O.isLessThan=C;function j(G){return G<=0}O.isLessThanOrEqual=j;function J(G){return G>0}O.isGreaterThan=J;function z(G){return G===0}O.isNeitherLessOrGreaterThan=z,O.greaterThan=1,O.lessThan=-1,O.neitherLessOrGreaterThan=0})(we||(t.CompareResult=we={}));function Ae(O,C){return(j,J)=>C(O(j),O(J))}t.$7b=Ae;function $e(...O){return(C,j)=>{for(const J of O){const z=J(C,j);if(!we.isNeitherLessOrGreaterThan(z))return z}return we.neitherLessOrGreaterThan}}t.$8b=$e;const ye=(O,C)=>O-C;t.$9b=ye;const Pe=(O,C)=>(0,t.$9b)(O?1:0,C?1:0);t.$0b=Pe;function Se(O){return(C,j)=>-O(C,j)}t.$$b=Se;class Ie{constructor(C){this.g=C,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(C){let j=this.c;for(;j<this.g.length&&C(this.g[j]);)j++;const J=j===this.c?null:this.g.slice(this.c,j);return this.c=j,J}takeFromEndWhile(C){let j=this.d;for(;j>=0&&C(this.g[j]);)j--;const J=j===this.d?null:this.g.slice(j+1,this.d+1);return this.d=j,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const C=this.g[this.c];return this.c++,C}removeLast(){const C=this.g[this.d];return this.d--,C}takeCount(C){const j=this.g.slice(this.c,this.c+C);return this.c+=C,j}}t.$_b=Ie;class Re{static{this.empty=new Re(C=>{})}constructor(C){this.iterate=C}forEach(C){this.iterate(j=>(C(j),!0))}toArray(){const C=[];return this.iterate(j=>(C.push(j),!0)),C}filter(C){return new Re(j=>this.iterate(J=>C(J)?j(J):!0))}map(C){return new Re(j=>this.iterate(J=>j(C(J))))}some(C){let j=!1;return this.iterate(J=>(j=C(J),!j)),j}findFirst(C){let j;return this.iterate(J=>C(J)?(j=J,!1):!0),j}findLast(C){let j;return this.iterate(J=>(C(J)&&(j=J),!0)),j}findLastMaxBy(C){let j,J=!0;return this.iterate(z=>((J||we.isGreaterThan(C(z,j)))&&(J=!1,j=z),!0)),j}}t.$ac=Re}),te(ie[13],se([0,1,3]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.ok=void 0;function P(s,h){if(!s)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}t.ok=P;function r(s,h="Unreachable"){throw new Error(h)}t.$9c=r;function o(s){if(!s)throw new F.$cb("Assertion Failed")}t.$0c=o;function N(s){s||(0,F.$1)(new F.$cb("Assertion Failed"))}t.$$c=N;function f(s){if(!s()){debugger;s(),(0,F.$1)(new F.$cb("Assertion Failed"))}}t.$_c=f;function a(s,h){let A=0;for(;A<s.length-1;){const b=s[A],g=s[A+1];if(!h(b,g))return!1;A++}return!0}t.$ad=a}),te(ie[19],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function F(P,r){const o=this;let N=!1,f;return function(){if(N)return f;if(N=!0,r)try{f=P.apply(o,arguments)}finally{r()}else f=P.apply(o,arguments);return f}}t.$db=F}),te(ie[20],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var F;(function(P){function r(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}P.is=r;const o=Object.freeze([]);function N(){return o}P.empty=N;function*f(n){yield n}P.single=f;function a(n){return r(n)?n:f(n)}P.wrap=a;function s(n){return n||o}P.from=s;function*h(n){for(let l=n.length-1;l>=0;l--)yield n[l]}P.reverse=h;function A(n){return!n||n[Symbol.iterator]().next().done===!0}P.isEmpty=A;function b(n){return n[Symbol.iterator]().next().value}P.first=b;function g(n,l){for(const v of n)if(l(v))return!0;return!1}P.some=g;function e(n,l){for(const v of n)if(l(v))return v}P.find=e;function*E(n,l){for(const v of n)l(v)&&(yield v)}P.filter=E;function*R(n,l){let v=0;for(const d of n)yield l(d,v++)}P.map=R;function*L(...n){for(const l of n)yield*l}P.concat=L;function $(n,l,v){let d=v;for(const w of n)d=l(d,w);return d}P.reduce=$;function*m(n,l,v=n.length){for(l<0&&(l+=n.length),v<0?v+=n.length:v>n.length&&(v=n.length);l<v;l++)yield n[l]}P.slice=m;function u(n,l=Number.POSITIVE_INFINITY){const v=[];if(l===0)return[v,n];const d=n[Symbol.iterator]();for(let w=0;w<l;w++){const k=d.next();if(k.done)return[v,P.empty()];v.push(k.value)}return[v,{[Symbol.iterator](){return d}}]}P.consume=u;async function c(n){const l=[];for await(const v of n)l.push(v);return Promise.resolve(l)}P.asyncToArray=c})(F||(t.Iterable=F={}))}),te(ie[37],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fr=t.KeyMod=t.KeyCodeUtils=t.$er=t.$dr=t.$cr=t.$br=t.$ar=t.ScanCode=t.KeyCode=void 0;var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(F||(t.KeyCode=F={}));var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(P||(t.ScanCode=P={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(E,R){this._keyCodeToStr[E]=R,this._strToKeyCode[R.toLowerCase()]=E}keyCodeToStr(E){return this._keyCodeToStr[E]}strToKeyCode(E){return this._strToKeyCode[E.toLowerCase()]||0}}const o=new r,N=new r,f=new r;t.$ar=new Array(230),t.$br={};const a=[],s=Object.create(null),h=Object.create(null);t.$cr={lowerCaseToEnum:e=>h[e]||0,toEnum:e=>s[e]||0,toString:e=>a[e]||"None"},t.$dr=[],t.$er=[];for(let e=0;e<=193;e++)t.$dr[e]=-1;for(let e=0;e<=132;e++)t.$er[e]=-1;(function(){const e="",E=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],L=[];for(const $ of E){const[m,u,c,n,l,v,d,w,k]=$;if(L[u]||(L[u]=!0,a[u]=c,s[c]=u,h[c.toLowerCase()]=u,m&&(t.$dr[u]=n,n!==0&&n!==3&&n!==5&&n!==4&&n!==6&&n!==57&&(t.$er[n]=u))),!R[n]){if(R[n]=!0,!l)throw new Error(`String representation missing for key code ${n} around scan code ${c}`);o.define(n,l),N.define(n,w||l),f.define(n,k||w||l)}v&&(t.$ar[v]=n),d&&(t.$br[d]=n)}t.$er[3]=46})();var A;(function(e){function E(c){return o.keyCodeToStr(c)}e.toString=E;function R(c){return o.strToKeyCode(c)}e.fromString=R;function L(c){return N.keyCodeToStr(c)}e.toUserSettingsUS=L;function $(c){return f.keyCodeToStr(c)}e.toUserSettingsGeneral=$;function m(c){return N.strToKeyCode(c)||f.strToKeyCode(c)}e.fromUserSettings=m;function u(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(c)}e.toElectronAccelerator=u})(A||(t.KeyCodeUtils=A={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function g(e,E){const R=(E&65535)<<16>>>0;return(e|R)>>>0}t.$fr=g}),te(ie[38],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class F{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=F}),te(ie[21],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class F{static{this.Undefined=new F(void 0)}constructor(o){this.element=o,this.next=F.Undefined,this.prev=F.Undefined}}class P{constructor(){this.a=F.Undefined,this.b=F.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===F.Undefined}clear(){let o=this.a;for(;o!==F.Undefined;){const N=o.next;o.prev=F.Undefined,o.next=F.Undefined,o=N}this.a=F.Undefined,this.b=F.Undefined,this.c=0}unshift(o){return this.d(o,!1)}push(o){return this.d(o,!0)}d(o,N){const f=new F(o);if(this.a===F.Undefined)this.a=f,this.b=f;else if(N){const s=this.b;this.b=f,f.prev=s,s.next=f}else{const s=this.a;this.a=f,f.next=s,s.prev=f}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(f))}}shift(){if(this.a!==F.Undefined){const o=this.a.element;return this.e(this.a),o}}pop(){if(this.b!==F.Undefined){const o=this.b.element;return this.e(this.b),o}}e(o){if(o.prev!==F.Undefined&&o.next!==F.Undefined){const N=o.prev;N.next=o.next,o.next.prev=N}else o.prev===F.Undefined&&o.next===F.Undefined?(this.a=F.Undefined,this.b=F.Undefined):o.next===F.Undefined?(this.b=this.b.prev,this.b.next=F.Undefined):o.prev===F.Undefined&&(this.a=this.a.next,this.a.prev=F.Undefined);this.c-=1}*[Symbol.iterator](){let o=this.a;for(;o!==F.Undefined;)yield o.element,o=o.next}}t.$4c=P}),te(ie[22],se([0,1]),function(W,t){"use strict";var F,P,r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function o(m,u,c){let n=m.get(u);return n===void 0&&(n=c,m.set(u,n)),n}t.$xc=o;function N(m){const u=[];return m.forEach((c,n)=>{u.push(`${n} => ${c}`)}),`Map(${m.size}) {${u.join(", ")}}`}t.$yc=N;function f(m){const u=[];return m.forEach(c=>{u.push(c)}),`Set(${m.size}) {${u.join(", ")}}`}t.$zc=f;class a{constructor(u,c){this.uri=u,this.value=c}}function s(m){return Array.isArray(m)}class h{static{this.c=u=>u.toString()}constructor(u,c){if(this[F]="ResourceMap",u instanceof h)this.d=new Map(u.d),this.e=c??h.c;else if(s(u)){this.d=new Map,this.e=c??h.c;for(const[n,l]of u)this.set(n,l)}else this.d=new Map,this.e=u??h.c}set(u,c){return this.d.set(this.e(u),new a(u,c)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,c){typeof c<"u"&&(u=u.bind(c));for(const[n,l]of this.d)u(l.value,l.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(F=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}t.$Ac=h;class A{constructor(u,c){this[P]="ResourceSet",!u||typeof u=="function"?this.c=new h(u):(this.c=new h(c),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,c){this.c.forEach((n,l)=>u.call(c,l,l,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=A;var b;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class g{constructor(){this[r]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,c=0){const n=this.c.get(u);if(n)return c!==0&&this.l(n,c),n.value}set(u,c,n=0){let l=this.c.get(u);if(l)l.value=c,n!==0&&this.l(l,n);else{switch(l={key:u,value:c,next:void 0,previous:void 0},n){case 0:this.j(l);break;case 1:this.i(l);break;case 2:this.j(l);break;default:this.j(l);break}this.c.set(u,l),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const c=this.c.get(u);if(c)return this.c.delete(u),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.k(u),this.f--,u.value}forEach(u,c){const n=this.g;let l=this.d;for(;l;){if(c?u.bind(c)(l.value,l.key,this):u(l.value,l.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const u=this,c=this.g;let n=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.key,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return l}values(){const u=this,c=this.g;let n=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.value,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return l}entries(){const u=this,c=this.g;let n=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:[n.key,n.value],done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return l}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let c=this.d,n=this.size;for(;c&&n>u;)this.c.delete(c.key),c=c.next,n--;this.d=c,this.f=n,c&&(c.previous=void 0),this.g++}i(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}j(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}k(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const c=u.next,n=u.previous;if(!c||!n)throw new Error("Invalid list");c.previous=n,n.next=c}u.next=void 0,u.previous=void 0,this.g++}l(u,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(u===this.d)return;const n=u.next,l=u.previous;u===this.e?(l.next=void 0,this.e=l):(n.previous=l,l.next=n),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(c===2){if(u===this.e)return;const n=u.next,l=u.previous;u===this.d?(n.previous=void 0,this.d=n):(n.previous=l,l.next=n),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((c,n)=>{u.push([n,c])}),u}fromJSON(u){this.clear();for(const[c,n]of u)this.set(c,n)}}t.$Cc=g;class e extends g{constructor(u,c=1){super(),this.m=u,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(u){this.m=u,this.o()}get ratio(){return this.n}set ratio(u){this.n=Math.min(Math.max(0,u),1),this.o()}get(u,c=2){return super.get(u,c)}peek(u){return super.get(u,0)}set(u,c){return super.set(u,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class E{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let c=this.c.get(u)||0;return c===0?!1:(c--,c===0?this.c.delete(u):this.c.set(u,c),!0)}has(u){return this.c.has(u)}}t.$Ec=E;class R{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[c,n]of u)this.set(c,n)}clear(){this.c.clear(),this.d.clear()}set(u,c){this.c.set(u,c),this.d.set(c,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const c=this.c.get(u);return c===void 0?!1:(this.c.delete(u),this.d.delete(c),!0)}forEach(u,c){this.c.forEach((n,l)=>{u.call(c,n,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=R;class L{constructor(){this.c=new Map}add(u,c){let n=this.c.get(u);n||(n=new Set,this.c.set(u,n)),n.add(c)}delete(u,c){const n=this.c.get(u);n&&(n.delete(c),n.size===0&&this.c.delete(u))}forEach(u,c){const n=this.c.get(u);n&&n.forEach(c)}get(u){const c=this.c.get(u);return c||new Set}}t.$Gc=L;function $(m,u){if(m===u)return!0;if(m.size!==u.size)return!1;for(const[c,n]of m)if(!u.has(c)||u.get(c)!==n)return!1;for(const[c]of u)if(!m.has(c))return!1;return!0}t.$Hc=$}),te(ie[10],se([0,1,6,34,22,19,20]),function(W,t,F,P,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const f=!1;let a=null;class s{constructor(){this.b=new Map}static{this.a=0}c(_){let q=this.b.get(_);return q||(q={parent:null,source:null,isSingleton:!1,value:_,idx:s.a++},this.b.set(_,q)),q}trackDisposable(_){const q=this.c(_);q.source||(q.source=new Error().stack)}setParent(_,q){const V=this.c(_);V.parent=q}markAsDisposed(_){this.b.delete(_)}markAsSingleton(_){this.c(_).isSingleton=!0}f(_,q){const V=q.get(_);if(V)return V;const x=_.parent?this.f(this.c(_.parent),q):_;return q.set(_,x),x}getTrackedDisposables(){const _=new Map;return[...this.b.entries()].filter(([,V])=>V.source!==null&&!this.f(V,_).isSingleton).flatMap(([V])=>V)}computeLeakingDisposables(_=10,q){let V;if(q)V=q;else{const Y=new Map,X=[...this.b.values()].filter(ue=>ue.source!==null&&!this.f(ue,Y).isSingleton);if(X.length===0)return;const re=new Set(X.map(ue=>ue.value));if(V=X.filter(ue=>!(ue.parent&&re.has(ue.parent))),V.length===0)throw new Error("There are cyclic diposable chains!")}if(!V)return;function x(Y){function X(ue,i){for(;ue.length>0&&i.some(de=>typeof de=="string"?de===ue[0]:ue[0].match(de));)ue.shift()}const re=Y.source.split(`
`).map(ue=>ue.trim().replace("at ","")).filter(ue=>ue!=="");return X(re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),re.reverse()}const ee=new r.$Gc;for(const Y of V){const X=x(Y);for(let re=0;re<=X.length;re++)ee.add(X.slice(0,re).join(`
`),Y)}V.sort((0,F.$7b)(Y=>Y.idx,F.$9b));let T="",U=0;for(const Y of V.slice(0,_)){U++;const X=x(Y),re=[];for(let ue=0;ue<X.length;ue++){let i=X[ue];i=`(shared with ${ee.get(X.slice(0,ue+1).join(`
`)).size}/${V.length} leaks) at ${i}`;const we=ee.get(X.slice(0,ue).join(`
`)),Ae=(0,P.$K)([...we].map($e=>x($e)[ue]),$e=>$e);delete Ae[X[ue]];for(const[$e,ye]of Object.entries(Ae))re.unshift(`    - stacktraces of ${ye.length} other leaks continue with ${$e}`);re.unshift(i)}T+=`


==================== Leaking disposable ${U}/${V.length}: ${Y.value.constructor.name} ====================
${re.join(`
`)}
============================================================

`}return V.length>_&&(T+=`


... and ${V.length-_} more leaking disposables

`),{leaks:V,details:T}}}t.$Ic=s;function h(S){a=S}if(t.$Jc=h,f){const S="__is_disposable_tracked__";h(new class{trackDisposable(_){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{_[S]||console.log(q)},3e3)}setParent(_,q){if(_&&_!==n.None)try{_[S]=!0}catch{}}markAsDisposed(_){if(_&&_!==n.None)try{_[S]=!0}catch{}}markAsSingleton(_){}})}function A(S){return a?.trackDisposable(S),S}t.$Kc=A;function b(S){a?.markAsDisposed(S)}t.$Lc=b;function g(S,_){a?.setParent(S,_)}function e(S,_){if(a)for(const q of S)a.setParent(q,_)}function E(S){return a?.markAsSingleton(S),S}t.$Mc=E;function R(S){return typeof S.dispose=="function"&&S.dispose.length===0}t.$Nc=R;function L(S){if(N.Iterable.is(S)){const _=[];for(const q of S)if(q)try{q.dispose()}catch(V){_.push(V)}if(_.length===1)throw _[0];if(_.length>1)throw new AggregateError(_,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}t.$Oc=L;function $(S){for(const _ of S)R(_)&&_.dispose();return[]}t.$Pc=$;function m(...S){const _=u(()=>L(S));return e(S,_),_}t.$Qc=m;function u(S){const _=A({dispose:(0,o.$db)(()=>{b(_),S()})});return _}t.$Rc=u;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{L(this.f)}finally{this.f.clear()}}add(_){if(!_)return _;if(_===this)throw new Error("Cannot register a disposable on itself!");return g(_,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(_),_}delete(_){if(_){if(_===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(_),_.dispose()}}deleteAndLeak(_){_&&this.f.has(_)&&(this.f.delete(_),g(_,null))}}t.$Sc=c;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,A(this),g(this.q,this)}dispose(){b(this),this.q.dispose()}B(_){if(_===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(_)}}t.$Tc=n;class l{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(_){this.b||_===this.a||(this.a?.dispose(),_&&g(_,this),this.a=_)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const _=this.a;return this.a=void 0,_&&g(_,null),_}}t.$Uc=l;class v{constructor(_){this.a=new l,this.b=!1,this.a.value=_}get value(){return this.a.value}set value(_){this.b||_===this.a.value||(this.a.value=_)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=v;class d{constructor(_){this.b=_,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=d;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(_){let q=_;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,b(this))},this}}t.$Xc=w;class k{constructor(){this.a=new Map}acquire(_,...q){let V=this.a.get(_);V||(V={counter:0,object:this.b(_,...q)},this.a.set(_,V));const{object:x}=V,ee=(0,o.$db)(()=>{--V.counter===0&&(this.c(_,V.object),this.a.delete(_))});return V.counter++,{object:x,dispose:ee}}}t.$Yc=k;class M{constructor(_){this.a=_}async acquire(_,...q){const V=this.a.acquire(_,...q);try{return{object:await V.object,dispose:()=>V.dispose()}}catch(x){throw V.dispose(),x}}}t.$Zc=M;class y{constructor(_){this.object=_}dispose(){}}t.$1c=y;function D(S){const _=new c;try{S(_)}finally{_.dispose()}}t.$2c=D;class p{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(_){return this.a.has(_)}get size(){return this.a.size}get(_){return this.a.get(_)}set(_,q,V=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),V||this.a.get(_)?.dispose(),this.a.set(_,q)}deleteAndDispose(_){this.a.get(_)?.dispose(),this.a.delete(_)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=p}),te(ie[23],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1d=void 0;const F=globalThis.performance&&typeof globalThis.performance.now=="function";class P{static create(o){return new P(o)}constructor(o){this.c=F&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$1d=P}),te(ie[11],se([0,1,3,19,10,21,23]),function(W,t,F,P,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.Event=void 0;const f=!1,a=!1;var s;(function(D){D.None=()=>r.$Tc.None;function p(z){if(a){const{onDidAddListener:G}=z,Z=e.create();let K=0;z.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),G?.()}}}function S(z,G){return re(z,()=>{},0,void 0,!0,void 0,G)}D.defer=S;function _(z){return(G,Z=null,K)=>{let ne=!1,ae;return ae=z(ce=>{if(!ne)return ae?ae.dispose():ne=!0,G.call(Z,ce)},null,K),ne&&ae.dispose(),ae}}D.once=_;function q(z,G,Z){return Y((K,ne=null,ae)=>z(ce=>K.call(ne,G(ce)),null,ae),Z)}D.map=q;function V(z,G,Z){return Y((K,ne=null,ae)=>z(ce=>{G(ce),K.call(ne,ce)},null,ae),Z)}D.forEach=V;function x(z,G,Z){return Y((K,ne=null,ae)=>z(ce=>G(ce)&&K.call(ne,ce),null,ae),Z)}D.filter=x;function ee(z){return z}D.signal=ee;function T(...z){return(G,Z=null,K)=>{const ne=(0,r.$Qc)(...z.map(ae=>ae(ce=>G.call(Z,ce))));return X(ne,K)}}D.any=T;function U(z,G,Z,K){let ne=Z;return q(z,ae=>(ne=G(ne,ae),ne),K)}D.reduce=U;function Y(z,G){let Z;const K={onWillAddFirstListener(){Z=z(ne.fire,ne)},onDidRemoveLastListener(){Z?.dispose()}};G||p(K);const ne=new m(K);return G?.add(ne),ne.event}function X(z,G){return G instanceof Array?G.push(z):G&&G.add(z),z}function re(z,G,Z=100,K=!1,ne=!1,ae,ce){let fe,ge,pe,_e=0,Fe;const qe={leakWarningThreshold:ae,onWillAddFirstListener(){fe=z(ve=>{_e++,ge=G(ge,ve),K&&!pe&&(De.fire(ge),ge=void 0),Fe=()=>{const Oe=ge;ge=void 0,pe=void 0,(!K||_e>1)&&De.fire(Oe),_e=0},typeof Z=="number"?(clearTimeout(pe),pe=setTimeout(Fe,Z)):pe===void 0&&(pe=0,queueMicrotask(Fe))})},onWillRemoveListener(){ne&&_e>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,fe.dispose()}};ce||p(qe);const De=new m(qe);return ce?.add(De),De.event}D.debounce=re;function ue(z,G=0,Z){return D.debounce(z,(K,ne)=>K?(K.push(ne),K):[ne],G,void 0,!0,void 0,Z)}D.accumulate=ue;function i(z,G=(K,ne)=>K===ne,Z){let K=!0,ne;return x(z,ae=>{const ce=K||!G(ae,ne);return K=!1,ne=ae,ce},Z)}D.latch=i;function de(z,G,Z){return[D.filter(z,G,Z),D.filter(z,K=>!G(K),Z)]}D.split=de;function we(z,G=!1,Z=[],K){let ne=Z.slice(),ae=z(ge=>{ne?ne.push(ge):fe.fire(ge)});K&&K.add(ae);const ce=()=>{ne?.forEach(ge=>fe.fire(ge)),ne=null},fe=new m({onWillAddFirstListener(){ae||(ae=z(ge=>fe.fire(ge)),K&&K.add(ae))},onDidAddFirstListener(){ne&&(G?setTimeout(ce):ce())},onDidRemoveLastListener(){ae&&ae.dispose(),ae=null}});return K&&K.add(fe),fe.event}D.buffer=we;function Ae(z,G){return(K,ne,ae)=>{const ce=G(new ye);return z(function(fe){const ge=ce.evaluate(fe);ge!==$e&&K.call(ne,ge)},void 0,ae)}}D.chain=Ae;const $e=Symbol("HaltChainable");class ye{constructor(){this.f=[]}map(G){return this.f.push(G),this}forEach(G){return this.f.push(Z=>(G(Z),Z)),this}filter(G){return this.f.push(Z=>G(Z)?Z:$e),this}reduce(G,Z){let K=Z;return this.f.push(ne=>(K=G(K,ne),K)),this}latch(G=(Z,K)=>Z===K){let Z=!0,K;return this.f.push(ne=>{const ae=Z||!G(ne,K);return Z=!1,K=ne,ae?ne:$e}),this}evaluate(G){for(const Z of this.f)if(G=Z(G),G===$e)break;return G}}function Pe(z,G,Z=K=>K){const K=(...fe)=>ce.fire(Z(...fe)),ne=()=>z.on(G,K),ae=()=>z.removeListener(G,K),ce=new m({onWillAddFirstListener:ne,onDidRemoveLastListener:ae});return ce.event}D.fromNodeEventEmitter=Pe;function Se(z,G,Z=K=>K){const K=(...fe)=>ce.fire(Z(...fe)),ne=()=>z.addEventListener(G,K),ae=()=>z.removeEventListener(G,K),ce=new m({onWillAddFirstListener:ne,onDidRemoveLastListener:ae});return ce.event}D.fromDOMEventEmitter=Se;function Ie(z){return new Promise(G=>_(z)(G))}D.toPromise=Ie;function Re(z){const G=new m;return z.then(Z=>{G.fire(Z)},()=>{G.fire(void 0)}).finally(()=>{G.dispose()}),G.event}D.fromPromise=Re;function O(z,G,Z){return G(Z),z(K=>G(K))}D.runAndSubscribe=O;class C{constructor(G,Z){this._observable=G,this.f=0,this.g=!1;const K={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};Z||p(K),this.emitter=new m(K),Z&&Z.add(this.emitter)}beginUpdate(G){this.f++}handlePossibleChange(G){}handleChange(G,Z){this.g=!0}endUpdate(G){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function j(z,G){return new C(z,G).emitter.event}D.fromObservable=j;function J(z){return(G,Z,K)=>{let ne=0,ae=!1;const ce={beginUpdate(){ne++},endUpdate(){ne--,ne===0&&(z.reportChanges(),ae&&(ae=!1,G.call(Z)))},handlePossibleChange(){},handleChange(){ae=!0}};z.addObserver(ce),z.reportChanges();const fe={dispose(){z.removeObserver(ce)}};return K instanceof r.$Sc?K.add(fe):Array.isArray(K)&&K.push(fe),fe}}D.fromObservableLight=J})(s||(t.Event=s={}));class h{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${h.f++}`,h.all.add(this)}start(p){this.g=new N.$1d,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}t.$3d=h;let A=-1;function b(D){const p=A;return A=D,{dispose(){A=p}}}t.$4d=b;class g{constructor(p,S=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=S,this.g=0}dispose(){this.f?.clear()}check(p,S){const _=this.threshold;if(_<=0||S<_)return;this.f||(this.f=new Map);const q=this.f.get(p.value)||0;if(this.f.set(p.value,q+1),this.g-=1,this.g<=0){this.g=_*.5;let V,x=0;for(const[ee,T]of this.f)(!V||x<T)&&(V=ee,x=T);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${x}):`),console.warn(V)}return()=>{const V=this.f.get(p.value)||0;this.f.set(p.value,V-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class R{constructor(p){this.value=p,this.id=E++}}const L=2,$=(D,p)=>{if(D instanceof R)p(D);else for(let S=0;S<D.length;S++){const _=D[S];_&&p(_)}};class m{constructor(p){this.w=0,this.f=p,this.g=A>0||this.f?.leakWarningThreshold?new g(this.f?.leakWarningThreshold??A):void 0,this.j=this.f?._profName?new h(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(f){const p=this.t;queueMicrotask(()=>{$(p,S=>S.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,S,_)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Tc.None;if(this.m)return r.$Tc.None;S&&(p=p.bind(S));const q=new R(p);let V,x;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=e.create(),V=this.g.check(q.stack,this.w+1)),f&&(q.stack=x??e.create()),this.t?this.t instanceof R?(this.u??=new c,this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const ee=(0,r.$Rc)(()=>{V?.(),this.x(q)});return _ instanceof r.$Sc?_.add(ee):Array.isArray(_)&&_.push(ee),ee},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const S=this.t,_=S.indexOf(p);if(_===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,S[_]=void 0;const q=this.u.current===this;if(this.w*L<=S.length){let V=0;for(let x=0;x<S.length;x++)S[x]?S[V++]=S[x]:q&&(this.u.end--,V<this.u.i&&this.u.i--);S.length=V}}y(p,S){if(!p)return;const _=this.f?.onListenerError||F.$1;if(!_){p.value(S);return}try{p.value(S)}catch(q){_(q)}}z(p){const S=p.current.t;for(;p.i<p.end;)this.y(S[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof R)this.y(this.t,p);else{const S=this.u;S.enqueue(this,p,this.t.length),this.z(S)}this.j?.stop()}hasListeners(){return this.w>0}}t.$5d=m;const u=()=>new c;t.$6d=u;class c{constructor(){this.i=-1,this.end=0}enqueue(p,S,_){this.i=0,this.end=_,this.current=p,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends m{async fireAsync(p,S,_){if(this.t)for(this.h||(this.h=new o.$4c),$(this.t,q=>this.h.push([q.value,p]));this.h.size>0&&!S.isCancellationRequested;){const[q,V]=this.h.shift(),x=[],ee={...V,token:S,waitUntil:T=>{if(Object.isFrozen(x))throw new Error("waitUntil can NOT be called asynchronous");_&&(T=_(T,q)),x.push(T)}};try{q(ee)}catch(T){(0,F.$1)(T);continue}Object.freeze(x),await Promise.allSettled(x).then(T=>{for(const U of T)U.status==="rejected"&&(0,F.$1)(U.reason)})}}}t.$7d=n;class l extends m{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new o.$4c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}t.$8d=l;class v extends l{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}t.$9d=v;class d extends m{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(S=>super.fire(S)),this.h=[]}))}}t.$0d=d;class w{constructor(){this.g=!1,this.h=[],this.f=new m({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const S={event:p,listener:null};this.h.push(S),this.g&&this.m(S);const _=()=>{this.g&&this.o(S);const q=this.h.indexOf(S);this.h.splice(q,1)};return(0,r.$Rc)((0,P.$db)(_))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(S=>this.f.fire(S))}o(p){p.listener?.dispose(),p.listener=null}dispose(){this.f.dispose();for(const p of this.h)p.listener?.dispose();this.h=[]}}t.$$d=w;class k{constructor(p,S,_,q){this.f=new r.$Sc;const V=this.f.add(new w),x=this.f.add(new r.$3c);function ee(T){x.set(T,V.add(q(T)))}for(const T of p)ee(T);this.f.add(S(T=>{ee(T)})),this.f.add(_(T=>{x.deleteAndDispose(T)})),this.event=V.event}dispose(){this.f.dispose()}}t.$_d=k;class M{constructor(){this.f=[]}wrapEvent(p){return(S,_,q)=>p(V=>{const x=this.f[this.f.length-1];x?x.push(()=>S.call(_,V)):S.call(_,V)},void 0,q)}bufferEvents(p){const S=[];this.f.push(S);const _=p();return this.f.pop(),S.forEach(q=>q()),_}}t.$ae=M;class y{constructor(){this.f=!1,this.g=s.None,this.h=r.$Tc.None,this.j=new m({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$be=y}),te(ie[24],se([0,1,11]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ce=t.CancellationToken=void 0;const P=Object.freeze(function(f,a){const s=setTimeout(f.bind(a),0);return{dispose(){clearTimeout(s)}}});var r;(function(f){function a(s){return s===f.None||s===f.Cancelled||s instanceof o?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}f.isCancellationToken=a,f.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:F.Event.None}),f.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(r||(t.CancellationToken=r={}));class o{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?P:(this.b||(this.b=new F.$5d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new o),this.f}cancel(){this.f?this.f instanceof o&&this.f.cancel():this.f=r.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof o&&this.f.dispose():this.f=r.None}}t.$ce=N}),te(ie[39],se([0,1,24]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pe=t.$Oe=t.$Ne=void 0;class P{constructor(f){this.b=f,this.a=null}get(){if(this.a)return this.a;const f=new F.$ce,a=this.b(f.token);return this.a={promise:a,dispose:()=>{this.a=null,f.cancel(),f.dispose()}},this.a}}t.$Ne=P;class r{constructor(f){this.c=f,this.a=void 0,this.b=void 0}get(f){const a=JSON.stringify(f);return this.b!==a&&(this.b=a,this.a=this.c(f)),this.a}}t.$Oe=r;class o{get cachedValues(){return this.a}constructor(f){this.b=f,this.a=new Map}get(f){if(this.a.has(f))return this.a.get(f);const a=this.b(f);return this.a.set(f,a),a}}t.$Pe=o}),te(ie[7],se([0,1,39,38]),function(W,t,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rf=t.$Qf=t.$Pf=t.$Of=t.GraphemeBreakType=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=void 0;function r(I){return!I||typeof I!="string"?!0:I.trim().length===0}t.$Se=r;const o=/{(\d+)}/g;function N(I,...B){return B.length===0?I:I.replace(o,function(H,Q){const le=parseInt(Q,10);return isNaN(le)||le<0||le>=B.length?H:B[le]})}t.$Te=N;const f=/{([^}]+)}/g;function a(I,B){return Object.keys(B).length===0?I:I.replace(f,(H,Q)=>B[Q]??H)}t.$Ue=a;function s(I){return I.replace(/[<>"'&]/g,B=>{switch(B){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return B})}t.$Ve=s;function h(I){return I.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.$We=h;function A(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Xe=A;function b(I,B){let H=0;const Q=B.charCodeAt(0);for(let le=I.length-1;le>=0;le--)I.charCodeAt(le)===Q&&H++;return H}t.$Ye=b;function g(I,B,H="\u2026"){return I.length<=B?I:`${I.substr(0,B)}${H}`}t.$Ze=g;function e(I,B,H="\u2026"){if(I.length<=B)return I;const Q=Math.ceil(B/2)-H.length/2,le=Math.floor(B/2)-H.length/2;return`${I.substr(0,Q)}${H}${I.substr(I.length-le)}`}t.$1e=e;function E(I,B=" "){const H=R(I,B);return L(H,B)}t.$2e=E;function R(I,B){if(!I||!B)return I;const H=B.length;if(H===0||I.length===0)return I;let Q=0;for(;I.indexOf(B,Q)===Q;)Q=Q+H;return I.substring(Q)}t.$3e=R;function L(I,B){if(!I||!B)return I;const H=B.length,Q=I.length;if(H===0||Q===0)return I;let le=Q,oe=-1;for(;oe=I.lastIndexOf(B,le-1),!(oe===-1||oe+H!==le);){if(oe===0)return"";le=oe}return I.substring(0,le)}t.$4e=L;function $(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$5e=$;function m(I){return I.replace(/\*/g,"")}t.$6e=m;function u(I,B,H={}){if(!I)throw new Error("Cannot create regex from empty string");B||(I=A(I)),H.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let Q="";return H.global&&(Q+="g"),H.matchCase||(Q+="i"),H.multiline&&(Q+="m"),H.unicode&&(Q+="u"),new RegExp(I,Q)}t.$7e=u;function c(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}t.$8e=c;function n(I){return I.split(/\r\n|\r|\n/)}t.$9e=n;function l(I){const B=[],H=I.split(/(\r\n|\r|\n)/);for(let Q=0;Q<Math.ceil(H.length/2);Q++)B.push(H[2*Q]+(H[2*Q+1]??""));return B}t.$0e=l;function v(I){for(let B=0,H=I.length;B<H;B++){const Q=I.charCodeAt(B);if(Q!==32&&Q!==9)return B}return-1}t.$$e=v;function d(I,B=0,H=I.length){for(let Q=B;Q<H;Q++){const le=I.charCodeAt(Q);if(le!==32&&le!==9)return I.substring(B,Q)}return I.substring(B,H)}t.$_e=d;function w(I,B=I.length-1){for(let H=B;H>=0;H--){const Q=I.charCodeAt(H);if(Q!==32&&Q!==9)return H}return-1}t.$af=w;function k(I,B,H){const Q=[];let le=0;for(const oe of I.matchAll(B)){if(Q.push(I.slice(le,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");le=oe.index+oe[0].length,Q.push(H(oe[0],...oe.slice(1),oe.index,I,oe.groups))}return Q.push(I.slice(le)),Promise.all(Q).then(oe=>oe.join(""))}t.$bf=k;function M(I,B){return I<B?-1:I>B?1:0}t.$cf=M;function y(I,B,H=0,Q=I.length,le=0,oe=B.length){for(;H<Q&&le<oe;H++,le++){const Le=I.charCodeAt(H),Ne=B.charCodeAt(le);if(Le<Ne)return-1;if(Le>Ne)return 1}const me=Q-H,ke=oe-le;return me<ke?-1:me>ke?1:0}t.$df=y;function D(I,B){return p(I,B,0,I.length,0,B.length)}t.$ef=D;function p(I,B,H=0,Q=I.length,le=0,oe=B.length){for(;H<Q&&le<oe;H++,le++){let Le=I.charCodeAt(H),Ne=B.charCodeAt(le);if(Le===Ne)continue;if(Le>=128||Ne>=128)return y(I.toLowerCase(),B.toLowerCase(),H,Q,le,oe);_(Le)&&(Le-=32),_(Ne)&&(Ne-=32);const be=Le-Ne;if(be!==0)return be}const me=Q-H,ke=oe-le;return me<ke?-1:me>ke?1:0}t.$ff=p;function S(I){return I>=48&&I<=57}t.$gf=S;function _(I){return I>=97&&I<=122}t.$hf=_;function q(I){return I>=65&&I<=90}t.$if=q;function V(I,B){return I.length===B.length&&p(I,B)===0}t.$jf=V;function x(I,B){const H=B.length;return B.length>I.length?!1:p(I,B,0,H)===0}t.$kf=x;function ee(I,B){const H=Math.min(I.length,B.length);let Q;for(Q=0;Q<H;Q++)if(I.charCodeAt(Q)!==B.charCodeAt(Q))return Q;return H}t.$lf=ee;function T(I,B){const H=Math.min(I.length,B.length);let Q;const le=I.length-1,oe=B.length-1;for(Q=0;Q<H;Q++)if(I.charCodeAt(le-Q)!==B.charCodeAt(oe-Q))return Q;return H}t.$mf=T;function U(I){return 55296<=I&&I<=56319}t.$nf=U;function Y(I){return 56320<=I&&I<=57343}t.$of=Y;function X(I,B){return(I-55296<<10)+(B-56320)+65536}t.$pf=X;function re(I,B,H){const Q=I.charCodeAt(H);if(U(Q)&&H+1<B){const le=I.charCodeAt(H+1);if(Y(le))return X(Q,le)}return Q}t.$qf=re;function ue(I,B){const H=I.charCodeAt(B-1);if(Y(H)&&B>1){const Q=I.charCodeAt(B-2);if(U(Q))return X(Q,H)}return H}class i{get offset(){return this.e}constructor(B,H=0){this.c=B,this.d=B.length,this.e=H}setOffset(B){this.e=B}prevCodePoint(){const B=ue(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=re(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$rf=i;class de{get offset(){return this.c.offset}constructor(B,H=0){this.c=new i(B,H)}nextGraphemeLength(){const B=ve.getInstance(),H=this.c,Q=H.offset;let le=B.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const oe=H.offset,me=B.getGraphemeBreakType(H.nextCodePoint());if(qe(le,me)){H.setOffset(oe);break}le=me}return H.offset-Q}prevGraphemeLength(){const B=ve.getInstance(),H=this.c,Q=H.offset;let le=B.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const oe=H.offset,me=B.getGraphemeBreakType(H.prevCodePoint());if(qe(me,le)){H.setOffset(oe);break}le=me}return Q-H.offset}eol(){return this.c.eol()}}t.$sf=de;function we(I,B){return new de(I,B).nextGraphemeLength()}t.$tf=we;function Ae(I,B){return new de(I,B).prevGraphemeLength()}t.$uf=Ae;function $e(I,B){B>0&&Y(I.charCodeAt(B))&&B--;const H=B+we(I,B);return[H-Ae(I,H),H]}t.$vf=$e;function ye(I){const B=new de(I);let H=0;for(;!B.eol();)H++,B.nextGraphemeLength();return H}t.$wf=ye;let Pe;function Se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ie(I){return Pe||(Pe=Se()),Pe.test(I)}t.$xf=Ie;const Re=/^[\t\n\r\x20-\x7E]*$/;function O(I){return Re.test(I)}t.$yf=O,t.$zf=/[\u2028\u2029]/;function C(I){return t.$zf.test(I)}t.$Af=C;function j(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}t.$Bf=j;function J(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}t.$Cf=J;function z(I,B,H=""){const Q=I.trimStart();if(Q.length<B)return Q;const le=/\b/g;let oe=0;for(;le.test(Q)&&!(Q.length-le.lastIndex<B);)oe=le.lastIndex,le.lastIndex+=1;return oe===0?Q:H+Q.substring(oe).trimStart()}t.$Df=z;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Z=/\x1b\].*?\x07/g;function K(I){return I&&(I=I.replace(G,"").replace(Z,"")),I}t.$Ef=K,t.$Ff="\uFEFF";function ne(I){return!!(I&&I.length>0&&I.charCodeAt(0)===65279)}t.$Gf=ne;function ae(I){return ne(I)?I.substr(1):I}t.$Hf=ae;function ce(I,B){if(!I||!B||I.length<B.length)return!1;const H=B.length,Q=I.toLowerCase();let le=0,oe=-1;for(;le<H;){const me=Q.indexOf(B[le],oe+1);if(me<0)return!1;oe=me,le++}return!0}t.$If=ce;function fe(I,B=!1){return I?(B&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}t.$Jf=fe;function ge(I){return I.charAt(0).toUpperCase()+I.slice(1)}t.$Kf=ge;function pe(I,B=1){if(B===0)return"";let H=-1;do H=I.indexOf(`
`,H+1),B--;while(B>0&&H>=0);return H===-1?I:(I[H-1]==="\r"&&H--,I.substr(0,H))}t.$Lf=pe;function _e(I){return I=I%(2*26),I<26?String.fromCharCode(97+I):String.fromCharCode(65+I-26)}t.$Mf=_e;function Fe(I){return ve.getInstance().getGraphemeBreakType(I)}t.$Nf=Fe;function qe(I,B){return I===0?B!==5&&B!==7:I===2&&B===3?!1:I===4||I===2||I===3||B===4||B===2||B===3?!0:!(I===8&&(B===8||B===9||B===11||B===12)||(I===11||I===9)&&(B===9||B===10)||(I===12||I===10)&&B===10||B===5||B===13||B===7||I===1||I===13&&B===14||I===6&&B===6)}var De;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(De||(t.GraphemeBreakType=De={}));class ve{static{this.c=null}static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=Oe()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const H=this.d,Q=H.length/3;let le=1;for(;le<=Q;)if(B<H[3*le])le=2*le;else if(B>H[3*le+1])le=2*le+1;else return H[3*le+2];return 0}}function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(I,B){if(I===0)return 0;const H=xe(I,B);if(H!==void 0)return H;const Q=new i(B,I);return Q.prevCodePoint(),Q.offset}t.$Of=ze;function xe(I,B){const H=new i(B,I);let Q=H.prevCodePoint();for(;He(Q)||Q===65039||Q===8419;){if(H.offset===0)return;Q=H.prevCodePoint()}if(!J(Q))return;let le=H.offset;return le>0&&H.prevCodePoint()===8205&&(le=H.offset),le}function He(I){return 127995<=I&&I<=127999}var We;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),t.$Pf="\xA0";class Te{static{this.c=new P.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new F.$Oe(B=>{function H(be){const Me=new Map;for(let Ee=0;Ee<be.length;Ee+=2)Me.set(be[Ee],be[Ee+1]);return Me}function Q(be,Me){const Ee=new Map(be);for(const[Be,Ve]of Me)Ee.set(Be,Ve);return Ee}function le(be,Me){if(!be)return Me;const Ee=new Map;for(const[Be,Ve]of be)Me.has(Be)&&Ee.set(Be,Ve);return Ee}const oe=this.c.value;let me=B.filter(be=>!be.startsWith("_")&&be in oe);me.length===0&&(me=["_default"]);let ke;for(const be of me){const Me=H(oe[be]);ke=le(ke,Me)}const Le=H(oe._common),Ne=Q(Le,ke);return new Te(Ne)})}static getInstance(B){return Te.d.get(Array.from(B))}static{this.e=new P.$V(()=>Object.keys(Te.c.value).filter(B=>!B.startsWith("_")))}static getLocales(){return Te.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Qf=Te;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(B){return Ue.e().has(B)}static get codePoints(){return Ue.e()}}t.$Rf=Ue}),te(ie[40],se([0,1,7]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$i=t.$0i=t.$9i=t.$8i=t.$7i=t.$6i=t.$5i=void 0;function P(L){return r(L,0)}t.$5i=P;function r(L,$){switch(typeof L){case"object":return L===null?o(349,$):Array.isArray(L)?a(L,$):s(L,$);case"string":return f(L,$);case"boolean":return N(L,$);case"number":return o(L,$);case"undefined":return o(937,$);default:return o(617,$)}}t.$6i=r;function o(L,$){return($<<5)-$+L|0}t.$7i=o;function N(L,$){return o(L?433:863,$)}function f(L,$){$=o(149417,$);for(let m=0,u=L.length;m<u;m++)$=o(L.charCodeAt(m),$);return $}t.$8i=f;function a(L,$){return $=o(104579,$),L.reduce((m,u)=>r(u,m),$)}function s(L,$){return $=o(181387,$),Object.keys(L).sort().reduce((m,u)=>(m=f(u,m),r(L[u],m)),$)}class h{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=r($,this.g),this.g}}t.$9i=h;var A;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function b(L,$,m=32){const u=m-$,c=~((1<<u)-1);return(L<<$|(c&L)>>>u)>>>0}function g(L,$=0,m=L.byteLength,u=0){for(let c=0;c<m;c++)L[$+c]=u}function e(L,$,m="0"){for(;L.length<$;)L=m+L;return L}function E(L,$=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(m=>m.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),$/4)}t.$0i=E;class R{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const m=$.length;if(m===0)return;const u=this.p;let c=this.r,n=this.u,l,v;for(n!==0?(l=n,v=-1,n=0):(l=$.charCodeAt(0),v=0);;){let d=l;if(F.$nf(l))if(v+1<m){const w=$.charCodeAt(v+1);F.$of(w)?(v++,d=F.$pf(l,w)):d=65533}else{n=l;break}else F.$of(l)&&(d=65533);if(c=this.w(u,c,d),v++,v<m)l=$.charCodeAt(v);else break}this.r=c,this.u=n}w($,m,u){return u<128?$[m++]=u:u<2048?($[m++]=192|(u&1984)>>>6,$[m++]=128|(u&63)>>>0):u<65536?($[m++]=224|(u&61440)>>>12,$[m++]=128|(u&4032)>>>6,$[m++]=128|(u&63)>>>0):($[m++]=240|(u&1835008)>>>18,$[m++]=128|(u&258048)>>>12,$[m++]=128|(u&4032)>>>6,$[m++]=128|(u&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=R.g,m=this.q;for(let M=0;M<64;M+=4)$.setUint32(M,m.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)$.setUint32(M,b($.getUint32(M-12,!1)^$.getUint32(M-32,!1)^$.getUint32(M-56,!1)^$.getUint32(M-64,!1),1),!1);let u=this.h,c=this.l,n=this.m,l=this.n,v=this.o,d,w,k;for(let M=0;M<80;M++)M<20?(d=c&n|~c&l,w=1518500249):M<40?(d=c^n^l,w=1859775393):M<60?(d=c&n|c&l|n&l,w=2400959708):(d=c^n^l,w=3395469782),k=b(u,5)+d+v+w+$.getUint32(M*4,!1)&4294967295,v=l,l=n,n=b(c,30),c=u,u=k;this.h=this.h+u&4294967295,this.l=this.l+c&4294967295,this.m=this.m+n&4294967295,this.n=this.n+l&4294967295,this.o=this.o+v&4294967295}}t.$$i=R}),te(ie[25],se([0,1,36,40]),function(W,t,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_s=t.$$s=t.$0s=void 0;class r{constructor(b){this.a=b}getElements(){const b=this.a,g=new Int32Array(b.length);for(let e=0,E=b.length;e<E;e++)g[e]=b.charCodeAt(e);return g}}t.$0s=r;function o(A,b,g){return new h(new r(A),new r(b)).ComputeDiff(g).changes}t.$$s=o;class N{static Assert(b,g){if(!b)throw new Error(g)}}class f{static Copy(b,g,e,E,R){for(let L=0;L<R;L++)e[E+L]=b[g+L]}static Copy2(b,g,e,E,R){for(let L=0;L<R;L++)e[E+L]=b[g+L]}}var a;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new F.$9s(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(b,g){this.b=Math.min(this.b,b),this.c=Math.min(this.c,g),this.d++}AddModifiedElement(b,g){this.b=Math.min(this.b,b),this.c=Math.min(this.c,g),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class h{constructor(b,g,e=null){this.a=e,this.b=b,this.c=g;const[E,R,L]=h.o(b),[$,m,u]=h.o(g);this.d=L&&u,this.e=E,this.f=R,this.g=$,this.h=m,this.k=[],this.m=[]}static n(b){return b.length>0&&typeof b[0]=="string"}static o(b){const g=b.getElements();if(h.n(g)){const e=new Int32Array(g.length);for(let E=0,R=g.length;E<R;E++)e[E]=(0,P.$8i)(g[E],0);return[g,e,!0]}return g instanceof Int32Array?[[],g,!1]:[[],new Int32Array(g),!1]}p(b,g){return this.f[b]!==this.h[g]?!1:this.d?this.e[b]===this.g[g]:!0}q(b,g){if(!this.p(b,g))return!1;const e=h.r(this.b,b),E=h.r(this.c,g);return e===E}static r(b,g){return typeof b.getStrictElement=="function"?b.getStrictElement(g):null}s(b,g){return this.f[b]!==this.f[g]?!1:this.d?this.e[b]===this.e[g]:!0}u(b,g){return this.h[b]!==this.h[g]?!1:this.d?this.g[b]===this.g[g]:!0}ComputeDiff(b){return this.v(0,this.f.length-1,0,this.h.length-1,b)}v(b,g,e,E,R){const L=[!1];let $=this.w(b,g,e,E,L);return R&&($=this.z($)),{quitEarly:L[0],changes:$}}w(b,g,e,E,R){for(R[0]=!1;b<=g&&e<=E&&this.p(b,e);)b++,e++;for(;g>=b&&E>=e&&this.p(g,E);)g--,E--;if(b>g||e>E){let n;return e<=E?(N.Assert(b===g+1,"originalStart should only be one more than originalEnd"),n=[new F.$9s(b,0,e,E-e+1)]):b<=g?(N.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),n=[new F.$9s(b,g-b+1,e,0)]):(N.Assert(b===g+1,"originalStart should only be one more than originalEnd"),N.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),n=[]),n}const L=[0],$=[0],m=this.y(b,g,e,E,L,$,R),u=L[0],c=$[0];if(m!==null)return m;if(!R[0]){const n=this.w(b,u,e,c,R);let l=[];return R[0]?l=[new F.$9s(u+1,g-(u+1)+1,c+1,E-(c+1)+1)]:l=this.w(u+1,g,c+1,E,R),this.H(n,l)}return[new F.$9s(b,g-b+1,e,E-e+1)]}x(b,g,e,E,R,L,$,m,u,c,n,l,v,d,w,k,M,y){let D=null,p=null,S=new s,_=g,q=e,V=v[0]-k[0]-E,x=-1073741824,ee=this.k.length-1;do{const T=V+b;T===_||T<q&&u[T-1]<u[T+1]?(n=u[T+1],d=n-V-E,n<x&&S.MarkNextChange(),x=n,S.AddModifiedElement(n+1,d),V=T+1-b):(n=u[T-1]+1,d=n-V-E,n<x&&S.MarkNextChange(),x=n-1,S.AddOriginalElement(n,d+1),V=T-1-b),ee>=0&&(u=this.k[ee],b=u[0],_=1,q=u.length-1)}while(--ee>=-1);if(D=S.getReverseChanges(),y[0]){let T=v[0]+1,U=k[0]+1;if(D!==null&&D.length>0){const Y=D[D.length-1];T=Math.max(T,Y.getOriginalEnd()),U=Math.max(U,Y.getModifiedEnd())}p=[new F.$9s(T,l-T+1,U,w-U+1)]}else{S=new s,_=L,q=$,V=v[0]-k[0]-m,x=1073741824,ee=M?this.m.length-1:this.m.length-2;do{const T=V+R;T===_||T<q&&c[T-1]>=c[T+1]?(n=c[T+1]-1,d=n-V-m,n>x&&S.MarkNextChange(),x=n+1,S.AddOriginalElement(n+1,d+1),V=T+1-R):(n=c[T-1],d=n-V-m,n>x&&S.MarkNextChange(),x=n,S.AddModifiedElement(n+1,d+1),V=T-1-R),ee>=0&&(c=this.m[ee],R=c[0],_=1,q=c.length-1)}while(--ee>=-1);p=S.getChanges()}return this.H(D,p)}y(b,g,e,E,R,L,$){let m=0,u=0,c=0,n=0,l=0,v=0;b--,e--,R[0]=0,L[0]=0,this.k=[],this.m=[];const d=g-b+(E-e),w=d+1,k=new Int32Array(w),M=new Int32Array(w),y=E-e,D=g-b,p=b-e,S=g-E,q=(D-y)%2===0;k[y]=b,M[D]=g,$[0]=!1;for(let V=1;V<=d/2+1;V++){let x=0,ee=0;c=this.J(y-V,V,y,w),n=this.J(y+V,V,y,w);for(let U=c;U<=n;U+=2){U===c||U<n&&k[U-1]<k[U+1]?m=k[U+1]:m=k[U-1]+1,u=m-(U-y)-p;const Y=m;for(;m<g&&u<E&&this.p(m+1,u+1);)m++,u++;if(k[U]=m,m+u>x+ee&&(x=m,ee=u),!q&&Math.abs(U-D)<=V-1&&m>=M[U])return R[0]=m,L[0]=u,Y<=M[U]&&1447>0&&V<=1448?this.x(y,c,n,p,D,l,v,S,k,M,m,g,R,u,E,L,q,$):null}const T=(x-b+(ee-e)-V)/2;if(this.a!==null&&!this.a(x,T))return $[0]=!0,R[0]=x,L[0]=ee,T>0&&1447>0&&V<=1448?this.x(y,c,n,p,D,l,v,S,k,M,m,g,R,u,E,L,q,$):(b++,e++,[new F.$9s(b,g-b+1,e,E-e+1)]);l=this.J(D-V,V,D,w),v=this.J(D+V,V,D,w);for(let U=l;U<=v;U+=2){U===l||U<v&&M[U-1]>=M[U+1]?m=M[U+1]-1:m=M[U-1],u=m-(U-D)-S;const Y=m;for(;m>b&&u>e&&this.p(m,u);)m--,u--;if(M[U]=m,q&&Math.abs(U-y)<=V&&m<=k[U])return R[0]=m,L[0]=u,Y>=k[U]&&1447>0&&V<=1448?this.x(y,c,n,p,D,l,v,S,k,M,m,g,R,u,E,L,q,$):null}if(V<=1447){let U=new Int32Array(n-c+2);U[0]=y-c+1,f.Copy2(k,c,U,1,n-c+1),this.k.push(U),U=new Int32Array(v-l+2),U[0]=D-l+1,f.Copy2(M,l,U,1,v-l+1),this.m.push(U)}}return this.x(y,c,n,p,D,l,v,S,k,M,m,g,R,u,E,L,q,$)}z(b){for(let g=0;g<b.length;g++){const e=b[g],E=g<b.length-1?b[g+1].originalStart:this.f.length,R=g<b.length-1?b[g+1].modifiedStart:this.h.length,L=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<E&&e.modifiedStart+e.modifiedLength<R&&(!L||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const u=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!u)break;e.originalStart++,e.modifiedStart++}const m=[null];if(g<b.length-1&&this.I(b[g],b[g+1],m)){b[g]=m[0],b.splice(g+1,1),g--;continue}}for(let g=b.length-1;g>=0;g--){const e=b[g];let E=0,R=0;if(g>0){const n=b[g-1];E=n.originalStart+n.originalLength,R=n.modifiedStart+n.modifiedLength}const L=e.originalLength>0,$=e.modifiedLength>0;let m=0,u=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let n=1;;n++){const l=e.originalStart-n,v=e.modifiedStart-n;if(l<E||v<R||L&&!this.s(l,l+e.originalLength)||$&&!this.u(v,v+e.modifiedLength))break;const w=(l===E&&v===R?5:0)+this.G(l,e.originalLength,v,e.modifiedLength);w>u&&(u=w,m=n)}e.originalStart-=m,e.modifiedStart-=m;const c=[null];if(g>0&&this.I(b[g-1],b[g],c)){b[g-1]=c[0],b.splice(g,1),g++;continue}}if(this.d)for(let g=1,e=b.length;g<e;g++){const E=b[g-1],R=b[g],L=R.originalStart-E.originalStart-E.originalLength,$=E.originalStart,m=R.originalStart+R.originalLength,u=m-$,c=E.modifiedStart,n=R.modifiedStart+R.modifiedLength,l=n-c;if(L<5&&u<20&&l<20){const v=this.A($,u,c,l,L);if(v){const[d,w]=v;(d!==E.originalStart+E.originalLength||w!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=d-E.originalStart,E.modifiedLength=w-E.modifiedStart,R.originalStart=d+L,R.modifiedStart=w+L,R.originalLength=m-R.originalStart,R.modifiedLength=n-R.modifiedStart)}}}return b}A(b,g,e,E,R){if(g<R||E<R)return null;const L=b+g-R+1,$=e+E-R+1;let m=0,u=0,c=0;for(let n=b;n<L;n++)for(let l=e;l<$;l++){const v=this.B(n,l,R);v>0&&v>m&&(m=v,u=n,c=l)}return m>0?[u,c]:null}B(b,g,e){let E=0;for(let R=0;R<e;R++){if(!this.p(b+R,g+R))return 0;E+=this.e[b+R].length}return E}C(b){return b<=0||b>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[b])}D(b,g){if(this.C(b)||this.C(b-1))return!0;if(g>0){const e=b+g;if(this.C(e-1)||this.C(e))return!0}return!1}E(b){return b<=0||b>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[b])}F(b,g){if(this.E(b)||this.E(b-1))return!0;if(g>0){const e=b+g;if(this.E(e-1)||this.E(e))return!0}return!1}G(b,g,e,E){const R=this.D(b,g)?1:0,L=this.F(e,E)?1:0;return R+L}H(b,g){const e=[];if(b.length===0||g.length===0)return g.length>0?g:b;if(this.I(b[b.length-1],g[0],e)){const E=new Array(b.length+g.length-1);return f.Copy(b,0,E,0,b.length-1),E[b.length-1]=e[0],f.Copy(g,1,E,b.length,g.length-1),E}else{const E=new Array(b.length+g.length);return f.Copy(b,0,E,0,b.length),f.Copy(g,0,E,b.length,g.length),E}}I(b,g,e){if(N.Assert(b.originalStart<=g.originalStart,"Left change is not less than or equal to right change"),N.Assert(b.modifiedStart<=g.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=g.originalStart||b.modifiedStart+b.modifiedLength>=g.modifiedStart){const E=b.originalStart;let R=b.originalLength;const L=b.modifiedStart;let $=b.modifiedLength;return b.originalStart+b.originalLength>=g.originalStart&&(R=g.originalStart+g.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=g.modifiedStart&&($=g.modifiedStart+g.modifiedLength-b.modifiedStart),e[0]=new F.$9s(E,R,L,$),!0}else return e[0]=null,!1}J(b,g,e,E){if(b>=0&&b<E)return b;const R=e,L=E-e-1,$=g%2===0;if(b<0){const m=R%2===0;return $===m?0:1}else{const m=L%2===0;return $===m?E-1:E-2}}}t.$_s=h}),te(ie[26],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=void 0;function F(c){return typeof c=="string"}t.$Sf=F;function P(c){return Array.isArray(c)&&c.every(n=>F(n))}t.$Tf=P;function r(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.$Uf=r;function o(c){const n=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof n}t.$Vf=o;function N(c){return typeof c=="number"&&!isNaN(c)}t.$Wf=N;function f(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.$Xf=f;function a(c){return c===!0||c===!1}t.$Yf=a;function s(c){return typeof c>"u"}t.$Zf=s;function h(c){return!A(c)}t.$1f=h;function A(c){return s(c)||c===null}t.$2f=A;function b(c,n){if(!c)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}t.$3f=b;function g(c){if(A(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.$4f=g;function e(...c){const n=[];for(let l=0;l<c.length;l++){const v=c[l];if(A(v))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);n.push(v)}return n}t.$5f=e;const E=Object.prototype.hasOwnProperty;function R(c){if(!r(c))return!1;for(const n in c)if(E.call(c,n))return!1;return!0}t.$6f=R;function L(c){return typeof c=="function"}t.$7f=L;function $(...c){return c.length>0&&c.every(L)}t.$8f=$;function m(c,n){const l=Math.min(c.length,n.length);for(let v=0;v<l;v++)u(c[v],n[v])}t.$9f=m;function u(c,n){if(F(n)){if(typeof c!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(L(n)){try{if(c instanceof n)return}catch{}if(!A(c)&&c.constructor===n||n.length===1&&n.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$0f=u}),te(ie[41],se([0,1,26]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kk=t.$jk=t.$ik=void 0;const P=Object.create(null);function r(f,a){if((0,F.$Sf)(a)){const s=P[a];if(s===void 0)throw new Error(`${f} references an unknown codicon: ${a}`);a=s}return P[f]=a,{id:f}}function o(){return P}t.$ik=o;function N(){return Object.values(t.$kk)}t.$jk=N,t.$kk={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugBreakpointPending:r("debug-breakpoint-pending",60377),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),surroundWith:r("surround-with",60452),gitStash:r("git-stash",60454),gitStashApply:r("git-stash-apply",60455),gitStashPop:r("git-stash-pop",60456),coverage:r("coverage",60462),runAllCoverage:r("run-all-coverage",60461),runCoverage:r("run-all-coverage",60460),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),te(ie[14],se([0,1,26]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sn=t.$Rn=t.$Qn=t.$Pn=t.$On=t.$Nn=t.$Mn=t.$Ln=t.$Kn=t.$Jn=t.$In=t.$Hn=void 0;function P(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const $=Array.isArray(L)?[]:{};return Object.entries(L).forEach(([m,u])=>{$[m]=u&&typeof u=="object"?P(u):u}),$}t.$Hn=P;function r(L){if(!L||typeof L!="object")return L;const $=[L];for(;$.length>0;){const m=$.shift();Object.freeze(m);for(const u in m)if(o.call(m,u)){const c=m[u];typeof c=="object"&&!Object.isFrozen(c)&&!(0,F.$Vf)(c)&&$.push(c)}}return L}t.$In=r;const o=Object.prototype.hasOwnProperty;function N(L,$){return f(L,$,new Set)}t.$Jn=N;function f(L,$,m){if((0,F.$2f)(L))return L;const u=$(L);if(typeof u<"u")return u;if(Array.isArray(L)){const c=[];for(const n of L)c.push(f(n,$,m));return c}if((0,F.$Uf)(L)){if(m.has(L))throw new Error("Cannot clone recursive data-structure");m.add(L);const c={};for(const n in L)o.call(L,n)&&(c[n]=f(L[n],$,m));return m.delete(L),c}return L}function a(L,$,m=!0){return(0,F.$Uf)(L)?((0,F.$Uf)($)&&Object.keys($).forEach(u=>{u in L?m&&((0,F.$Uf)(L[u])&&(0,F.$Uf)($[u])?a(L[u],$[u],m):L[u]=$[u]):L[u]=$[u]}),L):$}t.$Kn=a;function s(L,$){if(L===$)return!0;if(L==null||$===null||$===void 0||typeof L!=typeof $||typeof L!="object"||Array.isArray(L)!==Array.isArray($))return!1;let m,u;if(Array.isArray(L)){if(L.length!==$.length)return!1;for(m=0;m<L.length;m++)if(!s(L[m],$[m]))return!1}else{const c=[];for(u in L)c.push(u);c.sort();const n=[];for(u in $)n.push(u);if(n.sort(),!s(c,n))return!1;for(m=0;m<c.length;m++)if(!s(L[c[m]],$[c[m]]))return!1}return!0}t.$Ln=s;function h(L){const $=new Set;return JSON.stringify(L,(m,u)=>{if((0,F.$Uf)(u)||Array.isArray(u)){if($.has(u))return"[Circular]";$.add(u)}return u})}t.$Mn=h;function A(L,$){const m=Object.create(null);return!L||!$||Object.keys($).forEach(c=>{const n=L[c],l=$[c];s(n,l)||(m[c]=l)}),m}t.$Nn=A;function b(L,$){const m=$.toLowerCase(),u=Object.keys(L).find(c=>c.toLowerCase()===m);return u?L[u]:L[$]}t.$On=b;function g(L,$){const m=Object.create(null);for(const[u,c]of Object.entries(L))$(u,c)&&(m[u]=c);return m}t.$Pn=g;function e(L){let $=[];for(;Object.prototype!==L;)$=$.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return $}t.$Qn=e;function E(L){const $=[];for(const m of e(L))typeof L[m]=="function"&&$.push(m);return $}t.$Rn=E;function R(L,$){const m=c=>function(){const n=Array.prototype.slice.call(arguments,0);return $(c,n)},u={};for(const c of L)u[c]=m(c);return u}t.$Sn=R}),te(ie[27],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Re=t.$Qe=t.Constants=void 0;var F;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(F||(t.Constants=F={}));function P(o){return o<0?0:o>255?255:o|0}t.$Qe=P;function r(o){return o<0?0:o>4294967295?4294967295:o|0}t.$Re=r}),te(ie[28],se([0,1,27]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rt=t.$qt=void 0;class P{constructor(f){const a=(0,F.$Qe)(f);this.c=a,this.a=P.d(a),this.b=new Map}static d(f){const a=new Uint8Array(256);return a.fill(f),a}set(f,a){const s=(0,F.$Qe)(a);f>=0&&f<256?this.a[f]=s:this.b.set(f,s)}get(f){return f>=0&&f<256?this.a[f]:this.b.get(f)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$qt=P;var r;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(r||(r={}));class o{constructor(){this.a=new P(0)}add(f){this.a.set(f,1)}has(f){return this.a.get(f)===1}clear(){return this.a.clear()}}t.$rt=o}),te(ie[4],se([0,1,3]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bt=t.$at=void 0;class P{static addRange(N,f){let a=0;for(;a<f.length&&f[a].endExclusive<N.start;)a++;let s=a;for(;s<f.length&&f[s].start<=N.endExclusive;)s++;if(a===s)f.splice(a,0,N);else{const h=Math.min(N.start,f[a].start),A=Math.max(N.endExclusive,f[s-1].endExclusive);f.splice(a,s-a,new P(h,A))}}static tryCreate(N,f){if(!(N>f))return new P(N,f)}static ofLength(N){return new P(0,N)}static ofStartAndLength(N,f){return new P(N,N+f)}constructor(N,f){if(this.start=N,this.endExclusive=f,N>f)throw new F.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(N){return new P(this.start+N,this.endExclusive+N)}deltaStart(N){return new P(this.start+N,this.endExclusive)}deltaEnd(N){return new P(this.start,this.endExclusive+N)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(N){return this.start===N.start&&this.endExclusive===N.endExclusive}containsRange(N){return this.start<=N.start&&N.endExclusive<=this.endExclusive}contains(N){return this.start<=N&&N<this.endExclusive}join(N){return new P(Math.min(this.start,N.start),Math.max(this.endExclusive,N.endExclusive))}intersect(N){const f=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);if(f<=a)return new P(f,a)}intersects(N){const f=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);return f<a}intersectsOrTouches(N){const f=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);return f<=a}isBefore(N){return this.endExclusive<=N.start}isAfter(N){return this.start>=N.endExclusive}slice(N){return N.slice(this.start,this.endExclusive)}substring(N){return N.substring(this.start,this.endExclusive)}clip(N){if(this.isEmpty)throw new F.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,N))}clipCyclic(N){if(this.isEmpty)throw new F.$cb(`Invalid clipping range: ${this.toString()}`);return N<this.start?this.endExclusive-(this.start-N)%this.length:N>=this.endExclusive?this.start+(N-this.start)%this.length:N}map(N){const f=[];for(let a=this.start;a<this.endExclusive;a++)f.push(N(a));return f}forEach(N){for(let f=this.start;f<this.endExclusive;f++)N(f)}}t.$at=P;class r{constructor(){this.a=[]}addRange(N){let f=0;for(;f<this.a.length&&this.a[f].endExclusive<N.start;)f++;let a=f;for(;a<this.a.length&&this.a[a].start<=N.endExclusive;)a++;if(f===a)this.a.splice(f,0,N);else{const s=Math.min(N.start,this.a[f].start),h=Math.max(N.endExclusive,this.a[a-1].endExclusive);this.a.splice(f,a-f,new P(s,h))}}toString(){return this.a.map(N=>N.toString()).join(", ")}intersectsStrict(N){let f=0;for(;f<this.a.length&&this.a[f].endExclusive<=N.start;)f++;return f<this.a.length&&this.a[f].start<N.endExclusive}intersectWithRange(N){const f=new r;for(const a of this.a){const s=a.intersect(N);s&&f.addRange(s)}return f}intersectWithRangeLength(N){return this.intersectWithRange(N).length}get length(){return this.a.reduce((N,f)=>N+f.length,0)}}t.$bt=r}),te(ie[5],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5s=void 0;class F{constructor(r,o){this.lineNumber=r,this.column=o}with(r=this.lineNumber,o=this.column){return r===this.lineNumber&&o===this.column?this:new F(r,o)}delta(r=0,o=0){return this.with(this.lineNumber+r,this.column+o)}equals(r){return F.equals(this,r)}static equals(r,o){return!r&&!o?!0:!!r&&!!o&&r.lineNumber===o.lineNumber&&r.column===o.column}isBefore(r){return F.isBefore(this,r)}static isBefore(r,o){return r.lineNumber<o.lineNumber?!0:o.lineNumber<r.lineNumber?!1:r.column<o.column}isBeforeOrEqual(r){return F.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,o){return r.lineNumber<o.lineNumber?!0:o.lineNumber<r.lineNumber?!1:r.column<=o.column}static compare(r,o){const N=r.lineNumber|0,f=o.lineNumber|0;if(N===f){const a=r.column|0,s=o.column|0;return a-s}return N-f}clone(){return new F(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new F(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$5s=F}),te(ie[2],se([0,1,5]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6s=void 0;class P{constructor(o,N,f,a){o>f||o===f&&N>a?(this.startLineNumber=f,this.startColumn=a,this.endLineNumber=o,this.endColumn=N):(this.startLineNumber=o,this.startColumn=N,this.endLineNumber=f,this.endColumn=a)}isEmpty(){return P.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return P.containsPosition(this,o)}static containsPosition(o,N){return!(N.lineNumber<o.startLineNumber||N.lineNumber>o.endLineNumber||N.lineNumber===o.startLineNumber&&N.column<o.startColumn||N.lineNumber===o.endLineNumber&&N.column>o.endColumn)}static strictContainsPosition(o,N){return!(N.lineNumber<o.startLineNumber||N.lineNumber>o.endLineNumber||N.lineNumber===o.startLineNumber&&N.column<=o.startColumn||N.lineNumber===o.endLineNumber&&N.column>=o.endColumn)}containsRange(o){return P.containsRange(this,o)}static containsRange(o,N){return!(N.startLineNumber<o.startLineNumber||N.endLineNumber<o.startLineNumber||N.startLineNumber>o.endLineNumber||N.endLineNumber>o.endLineNumber||N.startLineNumber===o.startLineNumber&&N.startColumn<o.startColumn||N.endLineNumber===o.endLineNumber&&N.endColumn>o.endColumn)}strictContainsRange(o){return P.strictContainsRange(this,o)}static strictContainsRange(o,N){return!(N.startLineNumber<o.startLineNumber||N.endLineNumber<o.startLineNumber||N.startLineNumber>o.endLineNumber||N.endLineNumber>o.endLineNumber||N.startLineNumber===o.startLineNumber&&N.startColumn<=o.startColumn||N.endLineNumber===o.endLineNumber&&N.endColumn>=o.endColumn)}plusRange(o){return P.plusRange(this,o)}static plusRange(o,N){let f,a,s,h;return N.startLineNumber<o.startLineNumber?(f=N.startLineNumber,a=N.startColumn):N.startLineNumber===o.startLineNumber?(f=N.startLineNumber,a=Math.min(N.startColumn,o.startColumn)):(f=o.startLineNumber,a=o.startColumn),N.endLineNumber>o.endLineNumber?(s=N.endLineNumber,h=N.endColumn):N.endLineNumber===o.endLineNumber?(s=N.endLineNumber,h=Math.max(N.endColumn,o.endColumn)):(s=o.endLineNumber,h=o.endColumn),new P(f,a,s,h)}intersectRanges(o){return P.intersectRanges(this,o)}static intersectRanges(o,N){let f=o.startLineNumber,a=o.startColumn,s=o.endLineNumber,h=o.endColumn;const A=N.startLineNumber,b=N.startColumn,g=N.endLineNumber,e=N.endColumn;return f<A?(f=A,a=b):f===A&&(a=Math.max(a,b)),s>g?(s=g,h=e):s===g&&(h=Math.min(h,e)),f>s||f===s&&a>h?null:new P(f,a,s,h)}equalsRange(o){return P.equalsRange(this,o)}static equalsRange(o,N){return!o&&!N?!0:!!o&&!!N&&o.startLineNumber===N.startLineNumber&&o.startColumn===N.startColumn&&o.endLineNumber===N.endLineNumber&&o.endColumn===N.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(o){return new F.$5s(o.endLineNumber,o.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(o){return new F.$5s(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,N){return new P(this.startLineNumber,this.startColumn,o,N)}setStartPosition(o,N){return new P(o,N,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(o){return new P(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return P.collapseToEnd(this)}static collapseToEnd(o){return new P(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new P(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,N=o){return new P(o.lineNumber,o.column,N.lineNumber,N.column)}static lift(o){return o?new P(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,N){return!(o.endLineNumber<N.startLineNumber||o.endLineNumber===N.startLineNumber&&o.endColumn<N.startColumn||N.endLineNumber<o.startLineNumber||N.endLineNumber===o.startLineNumber&&N.endColumn<o.startColumn)}static areIntersecting(o,N){return!(o.endLineNumber<N.startLineNumber||o.endLineNumber===N.startLineNumber&&o.endColumn<=N.startColumn||N.endLineNumber<o.startLineNumber||N.endLineNumber===o.startLineNumber&&N.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,N){if(o&&N){const s=o.startLineNumber|0,h=N.startLineNumber|0;if(s===h){const A=o.startColumn|0,b=N.startColumn|0;if(A===b){const g=o.endLineNumber|0,e=N.endLineNumber|0;if(g===e){const E=o.endColumn|0,R=N.endColumn|0;return E-R}return g-e}return A-b}return s-h}return(o?1:0)-(N?1:0)}static compareRangesUsingEnds(o,N){return o.endLineNumber===N.endLineNumber?o.endColumn===N.endColumn?o.startLineNumber===N.startLineNumber?o.startColumn-N.startColumn:o.startLineNumber-N.startLineNumber:o.endColumn-N.endColumn:o.endLineNumber-N.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}t.$6s=P}),te(ie[42],se([0,1,2]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7s=void 0;class P{static insert(o,N){return{range:new F.$6s(o.lineNumber,o.column,o.lineNumber,o.column),text:N,forceMoveMarkers:!0}}static delete(o){return{range:o,text:null}}static replace(o,N){return{range:o,text:N}}static replaceMove(o,N){return{range:o,text:N,forceMoveMarkers:!0}}}t.$7s=P}),te(ie[12],se([0,1,3,4,2,9]),function(W,t,F,P,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dt=t.$ct=void 0;class N{static fromRange(s){return new N(s.startLineNumber,s.endLineNumber)}static fromRangeInclusive(s){return new N(s.startLineNumber,s.endLineNumber+1)}static subtract(s,h){return h?s.startLineNumber<h.startLineNumber&&h.endLineNumberExclusive<s.endLineNumberExclusive?[new N(s.startLineNumber,h.startLineNumber),new N(h.endLineNumberExclusive,s.endLineNumberExclusive)]:h.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=h.endLineNumberExclusive?[]:h.endLineNumberExclusive<s.endLineNumberExclusive?[new N(Math.max(h.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new N(s.startLineNumber,Math.min(h.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let h=new f(s[0].slice());for(let A=1;A<s.length;A++)h=h.getUnion(new f(s[A].slice()));return h.ranges}static ofLength(s,h){return new N(s,s+h)}static deserialize(s){return new N(s[0],s[1])}constructor(s,h){if(s>h)throw new F.$cb(`startLineNumber ${s} cannot be after endLineNumberExclusive ${h}`);this.startLineNumber=s,this.endLineNumberExclusive=h}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new N(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new N(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new N(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const h=Math.max(this.startLineNumber,s.startLineNumber),A=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(h<=A)return new N(h,A)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$6s(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$6s(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const h=[];for(let A=this.startLineNumber;A<this.endLineNumberExclusive;A++)h.push(s(A));return h}forEach(s){for(let h=this.startLineNumber;h<this.endLineNumberExclusive;h++)s(h)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new P.$at(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$ct=N;class f{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const h=(0,o.$kb)(this.c,b=>b.endLineNumberExclusive>=s.startLineNumber),A=(0,o.$ib)(this.c,b=>b.startLineNumber<=s.endLineNumberExclusive)+1;if(h===A)this.c.splice(h,0,s);else if(h===A-1){const b=this.c[h];this.c[h]=b.join(s)}else{const b=this.c[h].join(this.c[A-1]).join(s);this.c.splice(h,A-h,b)}}contains(s){const h=(0,o.$hb)(this.c,A=>A.startLineNumber<=s);return!!h&&h.endLineNumberExclusive>s}intersects(s){const h=(0,o.$hb)(this.c,A=>A.startLineNumber<s.endLineNumberExclusive);return!!h&&h.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const h=[];let A=0,b=0,g=null;for(;A<this.c.length||b<s.c.length;){let e=null;if(A<this.c.length&&b<s.c.length){const E=this.c[A],R=s.c[b];E.startLineNumber<R.startLineNumber?(e=E,A++):(e=R,b++)}else A<this.c.length?(e=this.c[A],A++):(e=s.c[b],b++);g===null?g=e:g.endLineNumberExclusive>=e.startLineNumber?g=new N(g.startLineNumber,Math.max(g.endLineNumberExclusive,e.endLineNumberExclusive)):(h.push(g),g=e)}return g!==null&&h.push(g),new f(h)}subtractFrom(s){const h=(0,o.$kb)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),A=(0,o.$ib)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(h===A)return new f([s]);const b=[];let g=s.startLineNumber;for(let e=h;e<A;e++){const E=this.c[e];E.startLineNumber>g&&b.push(new N(g,E.startLineNumber)),g=E.endLineNumberExclusive}return g<s.endLineNumberExclusive&&b.push(new N(g,s.endLineNumberExclusive)),new f(b)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const h=[];let A=0,b=0;for(;A<this.c.length&&b<s.c.length;){const g=this.c[A],e=s.c[b],E=g.intersect(e);E&&!E.isEmpty&&h.push(E),g.endLineNumberExclusive<e.endLineNumberExclusive?A++:b++}return new f(h)}getWithDelta(s){return new f(this.c.map(h=>h.delta(s)))}}t.$dt=f}),te(ie[43],se([0,1,5,2]),function(W,t,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8s=t.SelectionDirection=void 0;var r;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class o extends P.$6s{constructor(f,a,s,h){super(f,a,s,h),this.selectionStartLineNumber=f,this.selectionStartColumn=a,this.positionLineNumber=s,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(f){return o.selectionsEqual(this,f)}static selectionsEqual(f,a){return f.selectionStartLineNumber===a.selectionStartLineNumber&&f.selectionStartColumn===a.selectionStartColumn&&f.positionLineNumber===a.positionLineNumber&&f.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(f,a){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,f,a):new o(f,a,this.startLineNumber,this.startColumn)}getPosition(){return new F.$5s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new F.$5s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(f,a){return this.getDirection()===0?new o(f,a,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,f,a)}static fromPositions(f,a=f){return new o(f.lineNumber,f.column,a.lineNumber,a.column)}static fromRange(f,a){return a===0?new o(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):new o(f.endLineNumber,f.endColumn,f.startLineNumber,f.startColumn)}static liftSelection(f){return new o(f.selectionStartLineNumber,f.selectionStartColumn,f.positionLineNumber,f.positionColumn)}static selectionsArrEqual(f,a){if(f&&!a||!f&&a)return!1;if(!f&&!a)return!0;if(f.length!==a.length)return!1;for(let s=0,h=f.length;s<h;s++)if(!this.selectionsEqual(f[s],a[s]))return!1;return!0}static isISelection(f){return f&&typeof f.selectionStartLineNumber=="number"&&typeof f.selectionStartColumn=="number"&&typeof f.positionLineNumber=="number"&&typeof f.positionColumn=="number"}static createWithDirection(f,a,s,h,A){return A===0?new o(f,a,s,h):new o(s,h,f,a)}}t.$8s=o}),te(ie[44],se([0,1,28]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tt=t.$st=t.WordCharacterClass=void 0;var P;(function(N){N[N.Regular=0]="Regular",N[N.Whitespace=1]="Whitespace",N[N.WordSeparator=2]="WordSeparator"})(P||(t.WordCharacterClass=P={}));class r extends F.$qt{constructor(f){super(0);for(let a=0,s=f.length;a<s;a++)this.set(f.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.$st=r;function o(N){const f={};return a=>(f.hasOwnProperty(a)||(f[a]=N(a)),f[a])}t.$tt=o(N=>new r(N))}),te(ie[29],se([0,1,20,10,21]),function(W,t,F,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Is=t.$Hs=t.$Gs=t.$Fs=t.$Es=void 0,t.$Es="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(A=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const g of t.$Es)A.indexOf(g)>=0||(b+="\\"+g);return b+="\\s]+)",new RegExp(b,"g")}t.$Fs=o();function N(A){let b=t.$Fs;if(A&&A instanceof RegExp)if(A.global)b=A;else{let g="g";A.ignoreCase&&(g+="i"),A.multiline&&(g+="m"),A.unicode&&(g+="u"),b=new RegExp(A.source,g)}return b.lastIndex=0,b}t.$Gs=N;const f=new r.$4c;f.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(A){const b=f.unshift(A);return(0,P.$Rc)(b)}t.$Hs=a;function s(A,b,g,e,E){if(b=N(b),E||(E=F.Iterable.first(f)),g.length>E.maxLen){let u=A-E.maxLen/2;return u<0?u=0:e+=u,g=g.substring(u,A+E.maxLen/2),s(A,b,g,e,E)}const R=Date.now(),L=A-1-e;let $=-1,m=null;for(let u=1;!(Date.now()-R>=E.timeBudget);u++){const c=L-E.windowSize*u;b.lastIndex=Math.max(0,c);const n=h(b,g,L,$);if(!n&&m||(m=n,c<=0))break;$=c}if(m){const u={word:m[0],startColumn:e+1+m.index,endColumn:e+1+m.index+m[0].length};return b.lastIndex=0,u}return null}t.$Is=s;function h(A,b,g,e){let E;for(;E=A.exec(b);){const R=E.index||0;if(R<=g&&A.lastIndex>=g)return E;if(e>0&&R>e)return null}return null}}),te(ie[8],se([0,1,6,3,4]),function(W,t,F,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_1=t.$$1=t.$01=t.$91=t.$81=void 0;class o{static trivial(A,b){return new o([new N(r.$at.ofLength(A.length),r.$at.ofLength(b.length))],!1)}static trivialTimedOut(A,b){return new o([new N(r.$at.ofLength(A.length),r.$at.ofLength(b.length))],!0)}constructor(A,b){this.diffs=A,this.hitTimeout=b}}t.$81=o;class N{static invert(A,b){const g=[];return(0,F.$Bb)(A,(e,E)=>{g.push(N.fromOffsetPairs(e?e.getEndExclusives():f.zero,E?E.getStarts():new f(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),g}static fromOffsetPairs(A,b){return new N(new r.$at(A.offset1,b.offset1),new r.$at(A.offset2,b.offset2))}constructor(A,b){this.seq1Range=A,this.seq2Range=b}swap(){return new N(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(A){return new N(this.seq1Range.join(A.seq1Range),this.seq2Range.join(A.seq2Range))}delta(A){return A===0?this:new N(this.seq1Range.delta(A),this.seq2Range.delta(A))}deltaStart(A){return A===0?this:new N(this.seq1Range.deltaStart(A),this.seq2Range.deltaStart(A))}deltaEnd(A){return A===0?this:new N(this.seq1Range.deltaEnd(A),this.seq2Range.deltaEnd(A))}intersectsOrTouches(A){return this.seq1Range.intersectsOrTouches(A.seq1Range)||this.seq2Range.intersectsOrTouches(A.seq2Range)}intersect(A){const b=this.seq1Range.intersect(A.seq1Range),g=this.seq2Range.intersect(A.seq2Range);if(!(!b||!g))return new N(b,g)}getStarts(){return new f(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new f(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$91=N;class f{static{this.zero=new f(0,0)}static{this.max=new f(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(A,b){this.offset1=A,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(A){return A===0?this:new f(this.offset1+A,this.offset2+A)}equals(A){return this.offset1===A.offset1&&this.offset2===A.offset2}}t.$01=f;class a{static{this.instance=new a}isValid(){return!0}}t.$$1=a;class s{constructor(A){if(this.e=A,this.c=Date.now(),this.d=!0,A<=0)throw new P.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$_1=s}),te(ie[30],se([0,1,4,8]),function(W,t,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$e2=void 0;class r{compute(s,h,A=P.$$1.instance){if(s.length===0||h.length===0)return P.$81.trivial(s,h);const b=s,g=h;function e(l,v){for(;l<b.length&&v<g.length&&b.getElement(l)===g.getElement(v);)l++,v++;return l}let E=0;const R=new N;R.set(0,e(0,0));const L=new f;L.set(0,R.get(0)===0?null:new o(null,0,0,R.get(0)));let $=0;e:for(;;){if(E++,!A.isValid())return P.$81.trivialTimedOut(b,g);const l=-Math.min(E,g.length+E%2),v=Math.min(E,b.length+E%2);for($=l;$<=v;$+=2){let d=0;const w=$===v?-1:R.get($+1),k=$===l?-1:R.get($-1)+1;d++;const M=Math.min(Math.max(w,k),b.length),y=M-$;if(d++,M>b.length||y>g.length)continue;const D=e(M,y);R.set($,D);const p=M===w?L.get($+1):L.get($-1);if(L.set($,D!==M?new o(p,M,y,D-M):p),R.get($)===b.length&&R.get($)-$===g.length)break e}}let m=L.get($);const u=[];let c=b.length,n=g.length;for(;;){const l=m?m.x+m.length:0,v=m?m.y+m.length:0;if((l!==c||v!==n)&&u.push(new P.$91(new F.$at(l,c),new F.$at(v,n))),!m)break;c=m.x,n=m.y,m=m.prev}return u.reverse(),new P.$81(u,!1)}}t.$e2=r;class o{constructor(s,h,A,b){this.prev=s,this.x=h,this.y=A,this.length=b}}class N{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,h){if(s<0){if(s=-s-1,s>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[s]=h}else{if(s>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[s]=h}}}class f{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,h){s<0?(s=-s-1,this.b[s]=h):this.a[s]=h}}}),te(ie[45],se([0,1,6,4,8]),function(W,t,F,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$m2=t.$l2=t.$k2=t.$j2=t.$i2=void 0;function o(e,E,R){let L=R;return L=N(e,E,L),L=N(e,E,L),L=f(e,E,L),L}t.$i2=o;function N(e,E,R){if(R.length===0)return R;const L=[];L.push(R[0]);for(let m=1;m<R.length;m++){const u=L[L.length-1];let c=R[m];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const n=c.seq1Range.start-u.seq1Range.endExclusive;let l;for(l=1;l<=n&&!(e.getElement(c.seq1Range.start-l)!==e.getElement(c.seq1Range.endExclusive-l)||E.getElement(c.seq2Range.start-l)!==E.getElement(c.seq2Range.endExclusive-l));l++);if(l--,l===n){L[L.length-1]=new r.$91(new P.$at(u.seq1Range.start,c.seq1Range.endExclusive-n),new P.$at(u.seq2Range.start,c.seq2Range.endExclusive-n));continue}c=c.delta(-l)}L.push(c)}const $=[];for(let m=0;m<L.length-1;m++){const u=L[m+1];let c=L[m];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const n=u.seq1Range.start-c.seq1Range.endExclusive;let l;for(l=0;l<n&&!(!e.isStronglyEqual(c.seq1Range.start+l,c.seq1Range.endExclusive+l)||!E.isStronglyEqual(c.seq2Range.start+l,c.seq2Range.endExclusive+l));l++);if(l===n){L[m+1]=new r.$91(new P.$at(c.seq1Range.start+n,u.seq1Range.endExclusive),new P.$at(c.seq2Range.start+n,u.seq2Range.endExclusive));continue}l>0&&(c=c.delta(l))}$.push(c)}return L.length>0&&$.push(L[L.length-1]),$}function f(e,E,R){if(!e.getBoundaryScore||!E.getBoundaryScore)return R;for(let L=0;L<R.length;L++){const $=L>0?R[L-1]:void 0,m=R[L],u=L+1<R.length?R[L+1]:void 0,c=new P.$at($?$.seq1Range.endExclusive+1:0,u?u.seq1Range.start-1:e.length),n=new P.$at($?$.seq2Range.endExclusive+1:0,u?u.seq2Range.start-1:E.length);m.seq1Range.isEmpty?R[L]=a(m,e,E,c,n):m.seq2Range.isEmpty&&(R[L]=a(m.swap(),E,e,n,c).swap())}return R}function a(e,E,R,L,$){let u=1;for(;e.seq1Range.start-u>=L.start&&e.seq2Range.start-u>=$.start&&R.isStronglyEqual(e.seq2Range.start-u,e.seq2Range.endExclusive-u)&&u<100;)u++;u--;let c=0;for(;e.seq1Range.start+c<L.endExclusive&&e.seq2Range.endExclusive+c<$.endExclusive&&R.isStronglyEqual(e.seq2Range.start+c,e.seq2Range.endExclusive+c)&&c<100;)c++;if(u===0&&c===0)return e;let n=0,l=-1;for(let v=-u;v<=c;v++){const d=e.seq2Range.start+v,w=e.seq2Range.endExclusive+v,k=e.seq1Range.start+v,M=E.getBoundaryScore(k)+R.getBoundaryScore(d)+R.getBoundaryScore(w);M>l&&(l=M,n=v)}return e.delta(n)}function s(e,E,R){const L=[];for(const $ of R){const m=L[L.length-1];if(!m){L.push($);continue}$.seq1Range.start-m.seq1Range.endExclusive<=2||$.seq2Range.start-m.seq2Range.endExclusive<=2?L[L.length-1]=new r.$91(m.seq1Range.join($.seq1Range),m.seq2Range.join($.seq2Range)):L.push($)}return L}t.$j2=s;function h(e,E,R){const L=r.$91.invert(R,e.length),$=[];let m=new r.$01(0,0);function u(n,l){if(n.offset1<m.offset1||n.offset2<m.offset2)return;const v=e.findWordContaining(n.offset1),d=E.findWordContaining(n.offset2);if(!v||!d)return;let w=new r.$91(v,d);const k=w.intersect(l);let M=k.seq1Range.length,y=k.seq2Range.length;for(;L.length>0;){const D=L[0];if(!(D.seq1Range.intersects(v)||D.seq2Range.intersects(d)))break;const S=e.findWordContaining(D.seq1Range.start),_=E.findWordContaining(D.seq2Range.start),q=new r.$91(S,_),V=q.intersect(D);if(M+=V.seq1Range.length,y+=V.seq2Range.length,w=w.join(q),w.seq1Range.endExclusive>=D.seq1Range.endExclusive)L.shift();else break}M+y<(w.seq1Range.length+w.seq2Range.length)*2/3&&$.push(w),m=w.getEndExclusives()}for(;L.length>0;){const n=L.shift();n.seq1Range.isEmpty||(u(n.getStarts(),n),u(n.getEndExclusives().delta(-1),n))}return A(R,$)}t.$k2=h;function A(e,E){const R=[];for(;e.length>0||E.length>0;){const L=e[0],$=E[0];let m;L&&(!$||L.seq1Range.start<$.seq1Range.start)?m=e.shift():m=E.shift(),R.length>0&&R[R.length-1].seq1Range.endExclusive>=m.seq1Range.start?R[R.length-1]=R[R.length-1].join(m):R.push(m)}return R}function b(e,E,R){let L=R;if(L.length===0)return L;let $=0,m;do{m=!1;const u=[L[0]];for(let c=1;c<L.length;c++){let v=function(w,k){const M=new P.$at(l.seq1Range.endExclusive,n.seq1Range.start);return e.getText(M).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||k.seq1Range.length+k.seq2Range.length>5)};const n=L[c],l=u[u.length-1];v(l,n)?(m=!0,u[u.length-1]=u[u.length-1].join(n)):u.push(n)}L=u}while($++<10&&m);return L}t.$l2=b;function g(e,E,R){let L=R;if(L.length===0)return L;let $=0,m;do{m=!1;const c=[L[0]];for(let n=1;n<L.length;n++){let d=function(k,M){const y=new P.$at(v.seq1Range.endExclusive,l.seq1Range.start);if(e.countLinesIn(y)>5||y.length>500)return!1;const p=e.getText(y).trim();if(p.length>20||p.split(/\r\n|\r|\n/).length>1)return!1;const S=e.countLinesIn(k.seq1Range),_=k.seq1Range.length,q=E.countLinesIn(k.seq2Range),V=k.seq2Range.length,x=e.countLinesIn(M.seq1Range),ee=M.seq1Range.length,T=E.countLinesIn(M.seq2Range),U=M.seq2Range.length,Y=2*40+50;function X(re){return Math.min(re,Y)}return Math.pow(Math.pow(X(S*40+_),1.5)+Math.pow(X(q*40+V),1.5),1.5)+Math.pow(Math.pow(X(x*40+ee),1.5)+Math.pow(X(T*40+U),1.5),1.5)>(Y**1.5)**1.5*1.3};const l=L[n],v=c[c.length-1];d(v,l)?(m=!0,c[c.length-1]=c[c.length-1].join(l)):c.push(l)}L=c}while($++<10&&m);const u=[];return(0,F.$Cb)(L,(c,n,l)=>{let v=n;function d(p){return p.length>0&&p.trim().length<=3&&n.seq1Range.length+n.seq2Range.length>100}const w=e.extendToFullLines(n.seq1Range),k=e.getText(new P.$at(w.start,n.seq1Range.start));d(k)&&(v=v.deltaStart(-k.length));const M=e.getText(new P.$at(n.seq1Range.endExclusive,w.endExclusive));d(M)&&(v=v.deltaEnd(M.length));const y=r.$91.fromOffsetPairs(c?c.getEndExclusives():r.$01.zero,l?l.getStarts():r.$01.max),D=v.intersect(y);u.length>0&&D.getStarts().equals(u[u.length-1].getEndExclusives())?u[u.length-1]=u[u.length-1].join(D):u.push(D)}),u}t.$m2=g}),te(ie[46],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$h2=void 0;class F{constructor(o,N){this.a=o,this.b=N}getElement(o){return this.a[o]}get length(){return this.a.length}getBoundaryScore(o){const N=o===0?0:P(this.b[o-1]),f=o===this.b.length?0:P(this.b[o]);return 1e3-(N+f)}getText(o){return this.b.slice(o.start,o.endExclusive).join(`
`)}isStronglyEqual(o,N){return this.b[o]===this.b[N]}}t.$h2=F;function P(r){let o=0;for(;o<r.length&&(r.charCodeAt(o)===32||r.charCodeAt(o)===9);)o++;return o}}),te(ie[15],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$c2=t.$b2=t.$a2=void 0;class F{constructor(N,f){this.width=N,this.height=f,this.a=[],this.a=new Array(N*f)}get(N,f){return this.a[N+f*this.width]}set(N,f,a){this.a[N+f*this.width]=a}}t.$a2=F;function P(o){return o===32||o===9}t.$b2=P;class r{static{this.a=new Map}static b(N){let f=this.a.get(N);return f===void 0&&(f=this.a.size,this.a.set(N,f)),f}constructor(N,f,a){this.range=N,this.lines=f,this.source=a,this.d=[];let s=0;for(let h=N.startLineNumber-1;h<N.endLineNumberExclusive-1;h++){const A=f[h];for(let g=0;g<A.length;g++){s++;const e=A[g],E=r.b(e);this.d[E]=(this.d[E]||0)+1}s++;const b=r.b(`
`);this.d[b]=(this.d[b]||0)+1}this.c=s}computeSimilarity(N){let f=0;const a=Math.max(this.d.length,N.d.length);for(let s=0;s<a;s++)f+=Math.abs((this.d[s]??0)-(N.d[s]??0));return 1-f/(this.c+N.c)}}t.$c2=r}),te(ie[47],se([0,1,4,8,15]),function(W,t,F,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$d2=void 0;class o{compute(f,a,s=P.$$1.instance,h){if(f.length===0||a.length===0)return P.$81.trivial(f,a);const A=new r.$a2(f.length,a.length),b=new r.$a2(f.length,a.length),g=new r.$a2(f.length,a.length);for(let u=0;u<f.length;u++)for(let c=0;c<a.length;c++){if(!s.isValid())return P.$81.trivialTimedOut(f,a);const n=u===0?0:A.get(u-1,c),l=c===0?0:A.get(u,c-1);let v;f.getElement(u)===a.getElement(c)?(u===0||c===0?v=0:v=A.get(u-1,c-1),u>0&&c>0&&b.get(u-1,c-1)===3&&(v+=g.get(u-1,c-1)),v+=h?h(u,c):1):v=-1;const d=Math.max(n,l,v);if(d===v){const w=u>0&&c>0?g.get(u-1,c-1):0;g.set(u,c,w+1),b.set(u,c,3)}else d===n?(g.set(u,c,0),b.set(u,c,1)):d===l&&(g.set(u,c,0),b.set(u,c,2));A.set(u,c,d)}const e=[];let E=f.length,R=a.length;function L(u,c){(u+1!==E||c+1!==R)&&e.push(new P.$91(new F.$at(u+1,E),new F.$at(c+1,R))),E=u,R=c}let $=f.length-1,m=a.length-1;for(;$>=0&&m>=0;)b.get($,m)===3?(L($,m),$--,m--):b.get($,m)===1?$--:m--;return L(-1,-1),e.reverse(),new P.$81(e,!1)}}t.$d2=o}),te(ie[31],se([0,1,9,4,5,2,15]),function(W,t,F,P,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$f2=void 0;class f{constructor(e,E,R){this.lines=e,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let L=!1;E.start>0&&E.endExclusive>=e.length&&(E=new P.$at(E.start-1,E.endExclusive),L=!0),this.lineRange=E,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let m=e[$],u=0;if(L)u=m.length,m="",L=!1;else if(!R){const c=m.trimStart();u=m.length-c.length,m=c.trimEnd()}this.d.push(u);for(let c=0;c<m.length;c++)this.b.push(m.charCodeAt(c));$<e.length-1&&(this.b.push(10),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new P.$at(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(E=>String.fromCharCode(E)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const E=b(e>0?this.b[e-1]:-1),R=b(e<this.b.length?this.b[e]:-1);if(E===7&&R===8)return 0;if(E===8)return 150;let L=0;return E!==R&&(L+=10,E===0&&R===1&&(L+=1)),L+=A(E),L+=A(R),L}translateOffset(e){if(this.lineRange.isEmpty)return new r.$5s(this.lineRange.start+1,1);const E=(0,F.$ib)(this.c,R=>R<=e);return new r.$5s(this.lineRange.start+E+1,e-this.c[E]+this.d[E]+1)}translateRange(e){return o.$6s.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!a(this.b[e]))return;let E=e;for(;E>0&&a(this.b[E-1]);)E--;let R=e;for(;R<this.b.length&&a(this.b[R]);)R++;return new P.$at(E,R)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,E){return this.b[e]===this.b[E]}extendToFullLines(e){const E=(0,F.$hb)(this.c,L=>L<=e.start)??0,R=(0,F.$jb)(this.c,L=>e.endExclusive<=L)??this.b.length;return new P.$at(E,R)}}t.$f2=f;function a(g){return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57}var s;(function(g){g[g.WordLower=0]="WordLower",g[g.WordUpper=1]="WordUpper",g[g.WordNumber=2]="WordNumber",g[g.End=3]="End",g[g.Other=4]="Other",g[g.Separator=5]="Separator",g[g.Space=6]="Space",g[g.LineBreakCR=7]="LineBreakCR",g[g.LineBreakLF=8]="LineBreakLF"})(s||(s={}));const h={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function A(g){return h[g]}function b(g){return g===10?8:g===13?7:(0,N.$b2)(g)?6:g>=97&&g<=122?0:g>=65&&g<=90?1:g>=48&&g<=57?2:g===-1?3:g===44||g===59?5:4}}),te(ie[32],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$it=t.$ht=void 0;class F{constructor(o,N,f){this.changes=o,this.moves=N,this.hitTimeout=f}}t.$ht=F;class P{constructor(o,N){this.lineRangeMapping=o,this.changes=N}flip(){return new P(this.lineRangeMapping.flip(),this.changes.map(o=>o.flip()))}}t.$it=P}),te(ie[16],se([0,1,12]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gt=t.$ft=t.$et=void 0;class P{static inverse(f,a,s){const h=[];let A=1,b=1;for(const e of f){const E=new P(new F.$ct(A,e.original.startLineNumber),new F.$ct(b,e.modified.startLineNumber));E.modified.isEmpty||h.push(E),A=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const g=new P(new F.$ct(A,a+1),new F.$ct(b,s+1));return g.modified.isEmpty||h.push(g),h}static clip(f,a,s){const h=[];for(const A of f){const b=A.original.intersect(a),g=A.modified.intersect(s);b&&!b.isEmpty&&g&&!g.isEmpty&&h.push(new P(b,g))}return h}constructor(f,a){this.original=f,this.modified=a}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new P(this.modified,this.original)}join(f){return new P(this.original.join(f.original),this.modified.join(f.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$et=P;class r extends P{constructor(f,a,s){super(f,a),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(f=>f.flip()))}}t.$ft=r;class o{constructor(f,a){this.originalRange=f,this.modifiedRange=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}t.$gt=o}),te(ie[48],se([0,1,8,16,6,9,22,12,4,31,15,30]),function(W,t,F,P,r,o,N,f,a,s,h,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$g2=void 0;function b(m,u,c,n,l,v){let{moves:d,excludedChanges:w}=e(m,u,c,v);if(!v.isValid())return[];const k=m.filter(y=>!w.has(y)),M=E(k,n,l,u,c,v);return(0,r.$1b)(d,M),d=L(d),d=d.filter(y=>{const D=y.original.toOffsetRange().slice(u).map(S=>S.trim());return D.join(`
`).length>=15&&g(D,S=>S.length>=2)>=2}),d=$(m,d),d}t.$g2=b;function g(m,u){let c=0;for(const n of m)u(n)&&c++;return c}function e(m,u,c,n){const l=[],v=m.filter(k=>k.modified.isEmpty&&k.original.length>=3).map(k=>new h.$c2(k.original,u,k)),d=new Set(m.filter(k=>k.original.isEmpty&&k.modified.length>=3).map(k=>new h.$c2(k.modified,c,k))),w=new Set;for(const k of v){let M=-1,y;for(const D of d){const p=k.computeSimilarity(D);p>M&&(M=p,y=D)}if(M>.9&&y&&(d.delete(y),l.push(new P.$et(k.range,y.range)),w.add(k.source),w.add(y.source)),!n.isValid())return{moves:l,excludedChanges:w}}return{moves:l,excludedChanges:w}}function E(m,u,c,n,l,v){const d=[],w=new N.$Gc;for(const p of m)for(let S=p.original.startLineNumber;S<p.original.endLineNumberExclusive-2;S++){const _=`${u[S-1]}:${u[S+1-1]}:${u[S+2-1]}`;w.add(_,{range:new f.$ct(S,S+3)})}const k=[];m.sort((0,r.$7b)(p=>p.modified.startLineNumber,r.$9b));for(const p of m){let S=[];for(let _=p.modified.startLineNumber;_<p.modified.endLineNumberExclusive-2;_++){const q=`${c[_-1]}:${c[_+1-1]}:${c[_+2-1]}`,V=new f.$ct(_,_+3),x=[];w.forEach(q,({range:ee})=>{for(const U of S)if(U.originalLineRange.endLineNumberExclusive+1===ee.endLineNumberExclusive&&U.modifiedLineRange.endLineNumberExclusive+1===V.endLineNumberExclusive){U.originalLineRange=new f.$ct(U.originalLineRange.startLineNumber,ee.endLineNumberExclusive),U.modifiedLineRange=new f.$ct(U.modifiedLineRange.startLineNumber,V.endLineNumberExclusive),x.push(U);return}const T={modifiedLineRange:V,originalLineRange:ee};k.push(T),x.push(T)}),S=x}if(!v.isValid())return[]}k.sort((0,r.$$b)((0,r.$7b)(p=>p.modifiedLineRange.length,r.$9b)));const M=new f.$dt,y=new f.$dt;for(const p of k){const S=p.modifiedLineRange.startLineNumber-p.originalLineRange.startLineNumber,_=M.subtractFrom(p.modifiedLineRange),q=y.subtractFrom(p.originalLineRange).getWithDelta(S),V=_.getIntersection(q);for(const x of V.ranges){if(x.length<3)continue;const ee=x,T=x.delta(-S);d.push(new P.$et(T,ee)),M.addRange(ee),y.addRange(T)}}d.sort((0,r.$7b)(p=>p.original.startLineNumber,r.$9b));const D=new o.$mb(m);for(let p=0;p<d.length;p++){const S=d[p],_=D.findLastMonotonous(X=>X.original.startLineNumber<=S.original.startLineNumber),q=(0,o.$hb)(m,X=>X.modified.startLineNumber<=S.modified.startLineNumber),V=Math.max(S.original.startLineNumber-_.original.startLineNumber,S.modified.startLineNumber-q.modified.startLineNumber),x=D.findLastMonotonous(X=>X.original.startLineNumber<S.original.endLineNumberExclusive),ee=(0,o.$hb)(m,X=>X.modified.startLineNumber<S.modified.endLineNumberExclusive),T=Math.max(x.original.endLineNumberExclusive-S.original.endLineNumberExclusive,ee.modified.endLineNumberExclusive-S.modified.endLineNumberExclusive);let U;for(U=0;U<V;U++){const X=S.original.startLineNumber-U-1,re=S.modified.startLineNumber-U-1;if(X>n.length||re>l.length||M.contains(re)||y.contains(X)||!R(n[X-1],l[re-1],v))break}U>0&&(y.addRange(new f.$ct(S.original.startLineNumber-U,S.original.startLineNumber)),M.addRange(new f.$ct(S.modified.startLineNumber-U,S.modified.startLineNumber)));let Y;for(Y=0;Y<T;Y++){const X=S.original.endLineNumberExclusive+Y,re=S.modified.endLineNumberExclusive+Y;if(X>n.length||re>l.length||M.contains(re)||y.contains(X)||!R(n[X-1],l[re-1],v))break}Y>0&&(y.addRange(new f.$ct(S.original.endLineNumberExclusive,S.original.endLineNumberExclusive+Y)),M.addRange(new f.$ct(S.modified.endLineNumberExclusive,S.modified.endLineNumberExclusive+Y))),(U>0||Y>0)&&(d[p]=new P.$et(new f.$ct(S.original.startLineNumber-U,S.original.endLineNumberExclusive+Y),new f.$ct(S.modified.startLineNumber-U,S.modified.endLineNumberExclusive+Y)))}return d}function R(m,u,c){if(m.trim()===u.trim())return!0;if(m.length>300&&u.length>300)return!1;const l=new A.$e2().compute(new s.$f2([m],new a.$at(0,1),!1),new s.$f2([u],new a.$at(0,1),!1),c);let v=0;const d=F.$91.invert(l.diffs,m.length);for(const y of d)y.seq1Range.forEach(D=>{(0,h.$b2)(m.charCodeAt(D))||v++});function w(y){let D=0;for(let p=0;p<m.length;p++)(0,h.$b2)(y.charCodeAt(p))||D++;return D}const k=w(m.length>u.length?m:u);return v/k>.6&&k>10}function L(m){if(m.length===0)return m;m.sort((0,r.$7b)(c=>c.original.startLineNumber,r.$9b));const u=[m[0]];for(let c=1;c<m.length;c++){const n=u[u.length-1],l=m[c],v=l.original.startLineNumber-n.original.endLineNumberExclusive,d=l.modified.startLineNumber-n.modified.endLineNumberExclusive;if(v>=0&&d>=0&&v+d<=2){u[u.length-1]=n.join(l);continue}u.push(l)}return u}function $(m,u){const c=new o.$mb(m);return u=u.filter(n=>{const l=c.findLastMonotonous(w=>w.original.startLineNumber<n.original.endLineNumberExclusive)||new P.$et(new f.$ct(1,1),new f.$ct(1,1)),v=(0,o.$hb)(m,w=>w.modified.startLineNumber<n.modified.endLineNumberExclusive);return l!==v}),u}}),te(ie[49],se([0,1,6,13,12,4,2,8,47,30,48,45,32,16,31,46]),function(W,t,F,P,r,o,N,f,a,s,h,A,b,g,e,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$p2=t.$o2=t.$n2=void 0;class R{constructor(){this.e=new a.$d2,this.f=new s.$e2}computeDiff(u,c,n){if(u.length<=1&&(0,F.$ub)(u,c,(Y,X)=>Y===X))return new b.$ht([],[],!1);if(u.length===1&&u[0].length===0||c.length===1&&c[0].length===0)return new b.$ht([new g.$ft(new r.$ct(1,u.length+1),new r.$ct(1,c.length+1),[new g.$gt(new N.$6s(1,1,u.length,u[0].length+1),new N.$6s(1,1,c.length,c[0].length+1))])],[],!1);const l=n.maxComputationTimeMs===0?f.$$1.instance:new f.$_1(n.maxComputationTimeMs),v=!n.ignoreTrimWhitespace,d=new Map;function w(Y){let X=d.get(Y);return X===void 0&&(X=d.size,d.set(Y,X)),X}const k=u.map(Y=>w(Y.trim())),M=c.map(Y=>w(Y.trim())),y=new E.$h2(k,u),D=new E.$h2(M,c),p=y.length+D.length<1700?this.e.compute(y,D,l,(Y,X)=>u[Y]===c[X]?c[X].length===0?.1:1+Math.log(1+c[X].length):.99):this.f.compute(y,D);let S=p.diffs,_=p.hitTimeout;S=(0,A.$i2)(y,D,S),S=(0,A.$l2)(y,D,S);const q=[],V=Y=>{if(v)for(let X=0;X<Y;X++){const re=x+X,ue=ee+X;if(u[re]!==c[ue]){const i=this.j(u,c,new f.$91(new o.$at(re,re+1),new o.$at(ue,ue+1)),l,v);for(const de of i.mappings)q.push(de);i.hitTimeout&&(_=!0)}}};let x=0,ee=0;for(const Y of S){(0,P.$_c)(()=>Y.seq1Range.start-x===Y.seq2Range.start-ee);const X=Y.seq1Range.start-x;V(X),x=Y.seq1Range.endExclusive,ee=Y.seq2Range.endExclusive;const re=this.j(u,c,Y,l,v);re.hitTimeout&&(_=!0);for(const ue of re.mappings)q.push(ue)}V(u.length-x);const T=L(q,u,c);let U=[];return n.computeMoves&&(U=this.h(T,u,c,k,M,l,v)),(0,P.$_c)(()=>{function Y(re,ue){if(re.lineNumber<1||re.lineNumber>ue.length)return!1;const i=ue[re.lineNumber-1];return!(re.column<1||re.column>i.length+1)}function X(re,ue){return!(re.startLineNumber<1||re.startLineNumber>ue.length+1||re.endLineNumberExclusive<1||re.endLineNumberExclusive>ue.length+1)}for(const re of T){if(!re.innerChanges)return!1;for(const ue of re.innerChanges)if(!(Y(ue.modifiedRange.getStartPosition(),c)&&Y(ue.modifiedRange.getEndPosition(),c)&&Y(ue.originalRange.getStartPosition(),u)&&Y(ue.originalRange.getEndPosition(),u)))return!1;if(!X(re.modified,c)||!X(re.original,u))return!1}return!0}),new b.$ht(T,U,_)}h(u,c,n,l,v,d,w){return(0,h.$g2)(u,c,n,l,v,d).map(y=>{const D=this.j(c,n,new f.$91(y.original.toOffsetRange(),y.modified.toOffsetRange()),d,w),p=L(D.mappings,c,n,!0);return new b.$it(y,p)})}j(u,c,n,l,v){const d=new e.$f2(u,n.seq1Range,v),w=new e.$f2(c,n.seq2Range,v),k=d.length+w.length<500?this.e.compute(d,w,l):this.f.compute(d,w,l);let M=k.diffs;return M=(0,A.$i2)(d,w,M),M=(0,A.$k2)(d,w,M),M=(0,A.$j2)(d,w,M),M=(0,A.$m2)(d,w,M),{mappings:M.map(D=>new g.$gt(d.translateRange(D.seq1Range),w.translateRange(D.seq2Range))),hitTimeout:k.hitTimeout}}}t.$n2=R;function L(m,u,c,n=!1){const l=[];for(const v of(0,F.$Ab)(m.map(d=>$(d,u,c)),(d,w)=>d.original.overlapOrTouch(w.original)||d.modified.overlapOrTouch(w.modified))){const d=v[0],w=v[v.length-1];l.push(new g.$ft(d.original.join(w.original),d.modified.join(w.modified),v.map(k=>k.innerChanges[0])))}return(0,P.$_c)(()=>!n&&l.length>0&&l[0].original.startLineNumber!==l[0].modified.startLineNumber?!1:(0,P.$ad)(l,(v,d)=>d.original.startLineNumber-v.original.endLineNumberExclusive===d.modified.startLineNumber-v.modified.endLineNumberExclusive&&v.original.endLineNumberExclusive<d.original.startLineNumber&&v.modified.endLineNumberExclusive<d.modified.startLineNumber)),l}t.$o2=L;function $(m,u,c){let n=0,l=0;m.modifiedRange.endColumn===1&&m.originalRange.endColumn===1&&m.originalRange.startLineNumber+n<=m.originalRange.endLineNumber&&m.modifiedRange.startLineNumber+n<=m.modifiedRange.endLineNumber&&(l=-1),m.modifiedRange.startColumn-1>=c[m.modifiedRange.startLineNumber-1].length&&m.originalRange.startColumn-1>=u[m.originalRange.startLineNumber-1].length&&m.originalRange.startLineNumber<=m.originalRange.endLineNumber+l&&m.modifiedRange.startLineNumber<=m.modifiedRange.endLineNumber+l&&(n=1);const v=new r.$ct(m.originalRange.startLineNumber+n,m.originalRange.endLineNumber+1+l),d=new r.$ct(m.modifiedRange.startLineNumber+n,m.modifiedRange.endLineNumber+1+l);return new g.$ft(v,d,[m])}t.$p2=$}),te(ie[33],se([0,1,25,32,16,7,2,13,12]),function(W,t,F,P,r,o,N,f,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kt=t.$jt=void 0;const s=3;class h{computeDiff(n,l,v){const w=new L(n,l,{maxComputationTime:v.maxComputationTimeMs,shouldIgnoreTrimWhitespace:v.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),k=[];let M=null;for(const y of w.changes){let D;y.originalEndLineNumber===0?D=new a.$ct(y.originalStartLineNumber+1,y.originalStartLineNumber+1):D=new a.$ct(y.originalStartLineNumber,y.originalEndLineNumber+1);let p;y.modifiedEndLineNumber===0?p=new a.$ct(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):p=new a.$ct(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let S=new r.$ft(D,p,y.charChanges?.map(_=>new r.$gt(new N.$6s(_.originalStartLineNumber,_.originalStartColumn,_.originalEndLineNumber,_.originalEndColumn),new N.$6s(_.modifiedStartLineNumber,_.modifiedStartColumn,_.modifiedEndLineNumber,_.modifiedEndColumn))));M&&(M.modified.endLineNumberExclusive===S.modified.startLineNumber||M.original.endLineNumberExclusive===S.original.startLineNumber)&&(S=new r.$ft(M.original.join(S.original),M.modified.join(S.modified),M.innerChanges&&S.innerChanges?M.innerChanges.concat(S.innerChanges):void 0),k.pop()),k.push(S),M=S}return(0,f.$_c)(()=>(0,f.$ad)(k,(y,D)=>D.original.startLineNumber-y.original.endLineNumberExclusive===D.modified.startLineNumber-y.modified.endLineNumberExclusive&&y.original.endLineNumberExclusive<D.original.startLineNumber&&y.modified.endLineNumberExclusive<D.modified.startLineNumber)),new P.$ht(k,[],w.quitEarly)}}t.$jt=h;function A(c,n,l,v){return new F.$_s(c,n,l).ComputeDiff(v)}class b{constructor(n){const l=[],v=[];for(let d=0,w=n.length;d<w;d++)l[d]=$(n[d],1),v[d]=m(n[d],1);this.lines=n,this.a=l,this.b=v}getElements(){const n=[];for(let l=0,v=this.lines.length;l<v;l++)n[l]=this.lines[l].substring(this.a[l]-1,this.b[l]-1);return n}getStrictElement(n){return this.lines[n]}getStartLineNumber(n){return n+1}getEndLineNumber(n){return n+1}createCharSequence(n,l,v){const d=[],w=[],k=[];let M=0;for(let y=l;y<=v;y++){const D=this.lines[y],p=n?this.a[y]:1,S=n?this.b[y]:D.length+1;for(let _=p;_<S;_++)d[M]=D.charCodeAt(_-1),w[M]=y+1,k[M]=_,M++;!n&&y<v&&(d[M]=10,w[M]=y+1,k[M]=D.length+1,M++)}return new g(d,w,k)}}class g{constructor(n,l,v){this.a=n,this.b=l,this.d=v}toString(){return"["+this.a.map((n,l)=>(n===10?"\\n":String.fromCharCode(n))+`-(${this.b[l]},${this.d[l]})`).join(", ")+"]"}e(n,l){if(n<0||n>=l.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(n){return n>0&&n===this.b.length?this.getEndLineNumber(n-1):(this.e(n,this.b),this.b[n])}getEndLineNumber(n){return n===-1?this.getStartLineNumber(n+1):(this.e(n,this.b),this.a[n]===10?this.b[n]+1:this.b[n])}getStartColumn(n){return n>0&&n===this.d.length?this.getEndColumn(n-1):(this.e(n,this.d),this.d[n])}getEndColumn(n){return n===-1?this.getStartColumn(n+1):(this.e(n,this.d),this.a[n]===10?1:this.d[n]+1)}}class e{constructor(n,l,v,d,w,k,M,y){this.originalStartLineNumber=n,this.originalStartColumn=l,this.originalEndLineNumber=v,this.originalEndColumn=d,this.modifiedStartLineNumber=w,this.modifiedStartColumn=k,this.modifiedEndLineNumber=M,this.modifiedEndColumn=y}static createFromDiffChange(n,l,v){const d=l.getStartLineNumber(n.originalStart),w=l.getStartColumn(n.originalStart),k=l.getEndLineNumber(n.originalStart+n.originalLength-1),M=l.getEndColumn(n.originalStart+n.originalLength-1),y=v.getStartLineNumber(n.modifiedStart),D=v.getStartColumn(n.modifiedStart),p=v.getEndLineNumber(n.modifiedStart+n.modifiedLength-1),S=v.getEndColumn(n.modifiedStart+n.modifiedLength-1);return new e(d,w,k,M,y,D,p,S)}}function E(c){if(c.length<=1)return c;const n=[c[0]];let l=n[0];for(let v=1,d=c.length;v<d;v++){const w=c[v],k=w.originalStart-(l.originalStart+l.originalLength),M=w.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(k,M)<s?(l.originalLength=w.originalStart+w.originalLength-l.originalStart,l.modifiedLength=w.modifiedStart+w.modifiedLength-l.modifiedStart):(n.push(w),l=w)}return n}class R{constructor(n,l,v,d,w){this.originalStartLineNumber=n,this.originalEndLineNumber=l,this.modifiedStartLineNumber=v,this.modifiedEndLineNumber=d,this.charChanges=w}static createFromDiffResult(n,l,v,d,w,k,M){let y,D,p,S,_;if(l.originalLength===0?(y=v.getStartLineNumber(l.originalStart)-1,D=0):(y=v.getStartLineNumber(l.originalStart),D=v.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(p=d.getStartLineNumber(l.modifiedStart)-1,S=0):(p=d.getStartLineNumber(l.modifiedStart),S=d.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),k&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&w()){const q=v.createCharSequence(n,l.originalStart,l.originalStart+l.originalLength-1),V=d.createCharSequence(n,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(q.getElements().length>0&&V.getElements().length>0){let x=A(q,V,w,!0).changes;M&&(x=E(x)),_=[];for(let ee=0,T=x.length;ee<T;ee++)_.push(e.createFromDiffChange(x[ee],q,V))}}return new R(y,D,p,S,_)}}class L{constructor(n,l,v){this.a=v.shouldComputeCharChanges,this.b=v.shouldPostProcessCharChanges,this.d=v.shouldIgnoreTrimWhitespace,this.e=v.shouldMakePrettyDiff,this.f=n,this.g=l,this.h=new b(n),this.j=new b(l),this.k=u(v.maxComputationTime),this.l=u(v.maxComputationTime===0?0:Math.min(v.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const n=A(this.h,this.j,this.k,this.e),l=n.changes,v=n.quitEarly;if(this.d){const M=[];for(let y=0,D=l.length;y<D;y++)M.push(R.createFromDiffResult(this.d,l[y],this.h,this.j,this.l,this.a,this.b));return{quitEarly:v,changes:M}}const d=[];let w=0,k=0;for(let M=-1,y=l.length;M<y;M++){const D=M+1<y?l[M+1]:null,p=D?D.originalStart:this.f.length,S=D?D.modifiedStart:this.g.length;for(;w<p&&k<S;){const _=this.f[w],q=this.g[k];if(_!==q){{let V=$(_,1),x=$(q,1);for(;V>1&&x>1;){const ee=_.charCodeAt(V-2),T=q.charCodeAt(x-2);if(ee!==T)break;V--,x--}(V>1||x>1)&&this.m(d,w+1,1,V,k+1,1,x)}{let V=m(_,1),x=m(q,1);const ee=_.length+1,T=q.length+1;for(;V<ee&&x<T;){const U=_.charCodeAt(V-1),Y=_.charCodeAt(x-1);if(U!==Y)break;V++,x++}(V<ee||x<T)&&this.m(d,w+1,V,ee,k+1,x,T)}}w++,k++}D&&(d.push(R.createFromDiffResult(this.d,D,this.h,this.j,this.l,this.a,this.b)),w+=D.originalLength,k+=D.modifiedLength)}return{quitEarly:v,changes:d}}m(n,l,v,d,w,k,M){if(this.n(n,l,v,d,w,k,M))return;let y;this.a&&(y=[new e(l,v,l,d,w,k,w,M)]),n.push(new R(l,l,w,w,y))}n(n,l,v,d,w,k,M){const y=n.length;if(y===0)return!1;const D=n[y-1];return D.originalEndLineNumber===0||D.modifiedEndLineNumber===0?!1:D.originalEndLineNumber===l&&D.modifiedEndLineNumber===w?(this.a&&D.charChanges&&D.charChanges.push(new e(l,v,l,d,w,k,w,M)),!0):D.originalEndLineNumber+1===l&&D.modifiedEndLineNumber+1===w?(D.originalEndLineNumber=l,D.modifiedEndLineNumber=w,this.a&&D.charChanges&&D.charChanges.push(new e(l,v,l,d,w,k,w,M)),!0):!1}}t.$kt=L;function $(c,n){const l=o.$$e(c);return l===-1?n:l+1}function m(c,n){const l=o.$af(c);return l===-1?n:l+2}function u(c){if(c===0)return()=>!0;const n=Date.now();return()=>Date.now()-n<c}}),te(ie[50],se([0,1,33,49]),function(W,t,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$q2=void 0,t.$q2={getLegacy:()=>new F.$jt,getDefault:()=>new P.$n2}}),te(ie[51],se([0,1,35]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$r2=void 0;function P(b){const g=[];for(const e of b){const E=Number(e);(E||E===0&&e.replace(/\s/g,"")!=="")&&g.push(E)}return g}function r(b,g,e,E){return{red:b/255,blue:e/255,green:g/255,alpha:E}}function o(b,g){const e=g.index,E=g[0].length;if(!e)return;const R=b.positionAt(e);return{startLineNumber:R.lineNumber,startColumn:R.column,endLineNumber:R.lineNumber,endColumn:R.column+E}}function N(b,g){if(!b)return;const e=F.$xt.Format.CSS.parseHex(g);if(e)return{range:b,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function f(b,g,e){if(!b||g.length!==1)return;const R=g[0].values(),L=P(R);return{range:b,color:r(L[0],L[1],L[2],e?L[3]:1)}}function a(b,g,e){if(!b||g.length!==1)return;const R=g[0].values(),L=P(R),$=new F.$xt(new F.$vt(L[0],L[1]/100,L[2]/100,e?L[3]:1));return{range:b,color:r($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function s(b,g){return typeof b=="string"?[...b.matchAll(g)]:b.findMatches(g)}function h(b){const g=[],E=s(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(E.length>0)for(const R of E){const L=R.filter(c=>c!==void 0),$=L[1],m=L[2];if(!m)continue;let u;if($==="rgb"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;u=f(o(b,R),s(m,c),!1)}else if($==="rgba"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;u=f(o(b,R),s(m,c),!0)}else if($==="hsl"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;u=a(o(b,R),s(m,c),!1)}else if($==="hsla"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;u=a(o(b,R),s(m,c),!0)}else $==="#"&&(u=N(o(b,R),$+m));u&&g.push(u)}return g}function A(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:h(b)}t.$r2=A}),te(ie[52],se([0,1,28]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$41=t.$31=t.$21=t.State=void 0;var P;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(P||(t.State=P={}));class r{constructor(e,E,R){const L=new Uint8Array(e*E);for(let $=0,m=e*E;$<m;$++)L[$]=R;this.a=L,this.rows=e,this.cols=E}get(e,E){return this.a[e*this.cols+E]}set(e,E,R){this.a[e*this.cols+E]=R}}class o{constructor(e){let E=0,R=0;for(let $=0,m=e.length;$<m;$++){const[u,c,n]=e[$];c>E&&(E=c),u>R&&(R=u),n>R&&(R=n)}E++,R++;const L=new r(R,E,0);for(let $=0,m=e.length;$<m;$++){const[u,c,n]=e[$];L.set(u,c,n)}this.a=L,this.b=E}nextState(e,E){return E<0||E>=this.b?0:this.a.get(e,E)}}t.$21=o;let N=null;function f(){return N===null&&(N=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var a;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let s=null;function h(){if(s===null){s=new F.$qt(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<g.length;E++)s.set(g.charCodeAt(E),1);const e=".,;:";for(let E=0;E<e.length;E++)s.set(e.charCodeAt(E),2)}return s}class A{static a(e,E,R,L,$){let m=$-1;do{const u=E.charCodeAt(m);if(e.get(u)!==2)break;m--}while(m>L);if(L>0){const u=E.charCodeAt(L-1),c=E.charCodeAt(m);(u===40&&c===41||u===91&&c===93||u===123&&c===125)&&m--}return{range:{startLineNumber:R,startColumn:L+1,endLineNumber:R,endColumn:m+2},url:E.substring(L,m+1)}}static computeLinks(e,E=f()){const R=h(),L=[];for(let $=1,m=e.getLineCount();$<=m;$++){const u=e.getLineContent($),c=u.length;let n=0,l=0,v=0,d=1,w=!1,k=!1,M=!1,y=!1;for(;n<c;){let D=!1;const p=u.charCodeAt(n);if(d===13){let S;switch(p){case 40:w=!0,S=0;break;case 41:S=w?0:1;break;case 91:M=!0,k=!0,S=0;break;case 93:M=!1,S=k?0:1;break;case 123:y=!0,S=0;break;case 125:S=y?0:1;break;case 39:case 34:case 96:v===p?S=1:v===39||v===34||v===96?S=0:S=1;break;case 42:S=v===42?1:0;break;case 124:S=v===124?1:0;break;case 32:S=M?0:1;break;default:S=R.get(p)}S===1&&(L.push(A.a(R,u,$,l,n)),D=!0)}else if(d===12){let S;p===91?(k=!0,S=0):S=R.get(p),S===1?D=!0:d=13}else d=E.nextState(d,p),d===0&&(D=!0);D&&(d=1,w=!1,k=!1,y=!1,l=n+1,v=p),n++}d===13&&L.push(A.a(R,u,$,l,c))}return L}}t.$31=A;function b(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:A.computeLinks(g)}t.$41=b}),te(ie[53],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$51=void 0;class F{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new F}navigateValueSet(r,o,N,f,a){if(r&&o){const s=this.a(o,a);if(s)return{range:r,value:s}}if(N&&f){const s=this.a(f,a);if(s)return{range:N,value:s}}return null}a(r,o){const N=this.b(r,o);return N!==null?N:this.d(r,o)}b(r,o){const N=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let f=Number(r);const a=parseFloat(r);return!isNaN(f)&&!isNaN(a)&&f===a?f===0&&!o?null:(f=Math.floor(f*N),f+=o?N:-N,String(f/N)):null}d(r,o){return this.e(this.c,r,o)}e(r,o,N){let f=null;for(let a=0,s=r.length;f===null&&a<s;a++)f=this.f(r[a],o,N);return f}f(r,o,N){let f=r.indexOf(o);return f>=0?(f+=N?1:-1,f<0?f=r.length-1:f%=r.length,r[f]):null}}t.$51=F}),te(ie[54],se([0,1,14]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rv=t.$qv=t.$pv=t.$ov=t.ModelConstants=t.PositionAffinity=t.$nv=t.TrackedRangeStickiness=t.$mv=t.$lv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var P;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(P||(t.OverviewRulerLane=P={}));var r;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=3]="Right"})(r||(t.GlyphMarginLane=r={}));var o;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(o||(t.MinimapPosition=o={}));var N;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(N||(t.InjectedTextCursorStops=N={}));var f;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(f||(t.EndOfLinePreference=f={}));var a;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(a||(t.DefaultEndOfLine=a={}));var s;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class h{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,F.$Ln)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}t.$lv=h;class A{constructor(c,n){this._findMatchBrand=void 0,this.range=c,this.matches=n}}t.$mv=A;var b;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function g(u){return u&&typeof u.read=="function"}t.$nv=g;var e;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None",u[u.LeftOfInjectedText=3]="LeftOfInjectedText",u[u.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var E;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(t.ModelConstants=E={}));class R{constructor(c,n,l,v,d,w){this.identifier=c,this.range=n,this.text=l,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=d,this._isTracked=w}}t.$ov=R;class L{constructor(c,n,l){this.regex=c,this.wordSeparators=n,this.simpleSearch=l}}t.$pv=L;class ${constructor(c,n,l){this.reverseEdits=c,this.changes=n,this.trimAutoWhitespaceLineNumbers=l}}t.$qv=$;function m(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}t.$rv=m}),te(ie[55],se([0,1,6,27]),function(W,t,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wv=t.$vv=t.$uv=void 0;class r{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,s){a=(0,P.$Re)(a);const h=this.a,A=this.b,b=s.length;return b===0?!1:(this.a=new Uint32Array(h.length+b),this.a.set(h.subarray(0,a),0),this.a.set(h.subarray(a),a+b),this.a.set(s,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}setValue(a,s){return a=(0,P.$Re)(a),s=(0,P.$Re)(s),this.a[a]===s?!1:(this.a[a]=s,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,s){a=(0,P.$Re)(a),s=(0,P.$Re)(s);const h=this.a,A=this.b;if(a>=h.length)return!1;const b=h.length-a;return s>=b&&(s=b),s===0?!1:(this.a=new Uint32Array(h.length-s),this.a.set(h.subarray(0,a),0),this.a.set(h.subarray(a+s),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,P.$Re)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),a>=this.a.length&&(a=this.a.length-1);for(let h=s;h<=a;h++)this.b[h]=this.b[h-1]+this.a[h];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let s=0,h=this.a.length-1,A=0,b=0,g=0;for(;s<=h;)if(A=s+(h-s)/2|0,b=this.b[A],g=b-this.a[A],a<g)h=A-1;else if(a>=b)s=A+1;else break;return new N(A,a-g)}}t.$uv=r;class o{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const s=this.e[a],h=s>0?this.d[s-1]:0;return new N(s,a-h)}removeValues(a,s){this.a.splice(a,s),this.f(a)}insertValues(a,s){this.a=(0,F.$Wb)(this.a,a,s),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,s=this.a.length;a<s;a++){const h=this.a[a],A=a>0?this.d[a-1]:0;this.d[a]=A+h;for(let b=0;b<h;b++)this.e[A+b]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,s){this.a[a]!==s&&(this.a[a]=s,this.f(a))}}t.$vv=o;class N{constructor(a,s){this.index=a,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=s}}t.$wv=N}),te(ie[56],se([0,1,7,5,55]),function(W,t,F,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xv=void 0;class o{constructor(f,a,s,h){this.d=f,this.f=a,this.g=s,this.h=h,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(f){f.eol&&f.eol!==this.g&&(this.g=f.eol,this.j=null);const a=f.changes;for(const s of a)this.o(s.range),this.p(new P.$5s(s.range.startLineNumber,s.range.startColumn),s.text);this.h=f.versionId,this.k=null}l(){if(!this.j){const f=this.g.length,a=this.f.length,s=new Uint32Array(a);for(let h=0;h<a;h++)s[h]=this.f[h].length+f;this.j=new r.$uv(s)}}n(f,a){this.f[f]=a,this.j&&this.j.setValue(f,this.f[f].length+this.g.length)}o(f){if(f.startLineNumber===f.endLineNumber){if(f.startColumn===f.endColumn)return;this.n(f.startLineNumber-1,this.f[f.startLineNumber-1].substring(0,f.startColumn-1)+this.f[f.startLineNumber-1].substring(f.endColumn-1));return}this.n(f.startLineNumber-1,this.f[f.startLineNumber-1].substring(0,f.startColumn-1)+this.f[f.endLineNumber-1].substring(f.endColumn-1)),this.f.splice(f.startLineNumber,f.endLineNumber-f.startLineNumber),this.j&&this.j.removeValues(f.startLineNumber,f.endLineNumber-f.startLineNumber)}p(f,a){if(a.length===0)return;const s=(0,F.$9e)(a);if(s.length===1){this.n(f.lineNumber-1,this.f[f.lineNumber-1].substring(0,f.column-1)+s[0]+this.f[f.lineNumber-1].substring(f.column-1));return}s[s.length-1]+=this.f[f.lineNumber-1].substring(f.column-1),this.n(f.lineNumber-1,this.f[f.lineNumber-1].substring(0,f.column-1)+s[0]);const h=new Uint32Array(s.length-1);for(let A=1;A<s.length;A++)this.f.splice(f.lineNumber+A-1,0,s[A]),h[A-1]=s[A].length+this.g.length;this.j&&this.j.insertValues(f.lineNumber,h)}}t.$xv=o}),te(ie[57],se([0,1,7,44,5,2,54]),function(W,t,F,P,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hC=t.$gC=t.$fC=t.$eC=t.$dC=t.$cC=void 0;const f=999;class a{constructor($,m,u,c){this.searchString=$,this.isRegex=m,this.matchCase=u,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=s(this.searchString):$=this.searchString.indexOf(`
`)>=0;let m=null;try{m=F.$7e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!m)return null;let u=!this.isRegex&&!$;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new N.$pv(m,this.wordSeparators?(0,P.$tt)(this.wordSeparators):null,u?this.searchString:null)}}t.$cC=a;function s(L){if(!L||L.length===0)return!1;for(let $=0,m=L.length;$<m;$++){const u=L.charCodeAt($);if(u===10)return!0;if(u===92){if($++,$>=m)break;const c=L.charCodeAt($);if(c===110||c===114||c===87)return!0}}return!1}t.$dC=s;function h(L,$,m){if(!m)return new N.$mv(L,null);const u=[];for(let c=0,n=$.length;c<n;c++)u[c]=$[c];return new N.$mv(L,u)}t.$eC=h;class A{constructor($){const m=[];let u=0;for(let c=0,n=$.length;c<n;c++)$.charCodeAt(c)===10&&(m[u++]=c);this.a=m}findLineFeedCountBeforeOffset($){const m=this.a;let u=0,c=m.length-1;if(c===-1||$<=m[0])return 0;for(;u<c;){const n=u+((c-u)/2>>0);m[n]>=$?c=n-1:m[n+1]>=$?(u=n,c=n):u=n+1}return u+1}}class b{static findMatches($,m,u,c,n){const l=m.parseSearchRequest();return l?l.regex.multiline?this.b($,u,new R(l.wordSeparators,l.regex),c,n):this.c($,u,l,c,n):[]}static a($,m,u,c,n,l){let v,d=0;c?(d=c.findLineFeedCountBeforeOffset(n),v=m+n+d):v=m+n;let w;if(c){const D=c.findLineFeedCountBeforeOffset(n+l.length)-d;w=v+l.length+D}else w=v+l.length;const k=$.getPositionAt(v),M=$.getPositionAt(w);return new o.$6s(k.lineNumber,k.column,M.lineNumber,M.column)}static b($,m,u,c,n){const l=$.getOffsetAt(m.getStartPosition()),v=$.getValueInRange(m,1),d=$.getEOL()===`\r
`?new A(v):null,w=[];let k=0,M;for(u.reset(0);M=u.next(v);)if(w[k++]=h(this.a($,l,v,d,M.index,M[0]),M,c),k>=n)return w;return w}static c($,m,u,c,n){const l=[];let v=0;if(m.startLineNumber===m.endLineNumber){const w=$.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return v=this.d(u,w,m.startLineNumber,m.startColumn-1,v,l,c,n),l}const d=$.getLineContent(m.startLineNumber).substring(m.startColumn-1);v=this.d(u,d,m.startLineNumber,m.startColumn-1,v,l,c,n);for(let w=m.startLineNumber+1;w<m.endLineNumber&&v<n;w++)v=this.d(u,$.getLineContent(w),w,0,v,l,c,n);if(v<n){const w=$.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);v=this.d(u,w,m.endLineNumber,0,v,l,c,n)}return l}static d($,m,u,c,n,l,v,d){const w=$.wordSeparators;if(!v&&$.simpleSearch){const y=$.simpleSearch,D=y.length,p=m.length;let S=-D;for(;(S=m.indexOf(y,S+D))!==-1;)if((!w||E(w,m,p,S,D))&&(l[n++]=new N.$mv(new o.$6s(u,S+1+c,u,S+1+D+c),null),n>=d))return n;return n}const k=new R($.wordSeparators,$.regex);let M;k.reset(0);do if(M=k.next(m),M&&(l[n++]=h(new o.$6s(u,M.index+1+c,u,M.index+1+M[0].length+c),M,v),n>=d))return n;while(M);return n}static findNextMatch($,m,u,c){const n=m.parseSearchRequest();if(!n)return null;const l=new R(n.wordSeparators,n.regex);return n.regex.multiline?this.e($,u,l,c):this.f($,u,l,c)}static e($,m,u,c){const n=new r.$5s(m.lineNumber,1),l=$.getOffsetAt(n),v=$.getLineCount(),d=$.getValueInRange(new o.$6s(n.lineNumber,n.column,v,$.getLineMaxColumn(v)),1),w=$.getEOL()===`\r
`?new A(d):null;u.reset(m.column-1);const k=u.next(d);return k?h(this.a($,l,d,w,k.index,k[0]),k,c):m.lineNumber!==1||m.column!==1?this.e($,new r.$5s(1,1),u,c):null}static f($,m,u,c){const n=$.getLineCount(),l=m.lineNumber,v=$.getLineContent(l),d=this.g(u,v,l,m.column,c);if(d)return d;for(let w=1;w<=n;w++){const k=(l+w-1)%n,M=$.getLineContent(k+1),y=this.g(u,M,k+1,1,c);if(y)return y}return null}static g($,m,u,c,n){$.reset(c-1);const l=$.next(m);return l?h(new o.$6s(u,l.index+1,u,l.index+1+l[0].length),l,n):null}static findPreviousMatch($,m,u,c){const n=m.parseSearchRequest();if(!n)return null;const l=new R(n.wordSeparators,n.regex);return n.regex.multiline?this.h($,u,l,c):this.j($,u,l,c)}static h($,m,u,c){const n=this.b($,new o.$6s(1,1,m.lineNumber,m.column),u,c,10*f);if(n.length>0)return n[n.length-1];const l=$.getLineCount();return m.lineNumber!==l||m.column!==$.getLineMaxColumn(l)?this.h($,new r.$5s(l,$.getLineMaxColumn(l)),u,c):null}static j($,m,u,c){const n=$.getLineCount(),l=m.lineNumber,v=$.getLineContent(l).substring(0,m.column-1),d=this.k(u,v,l,c);if(d)return d;for(let w=1;w<=n;w++){const k=(n+l-w-1)%n,M=$.getLineContent(k+1),y=this.k(u,M,k+1,c);if(y)return y}return null}static k($,m,u,c){let n=null,l;for($.reset(0);l=$.next(m);)n=h(new o.$6s(u,l.index+1,u,l.index+1+l[0].length),l,c);return n}}t.$fC=b;function g(L,$,m,u,c){if(u===0)return!0;const n=$.charCodeAt(u-1);if(L.get(n)!==0||n===13||n===10)return!0;if(c>0){const l=$.charCodeAt(u);if(L.get(l)!==0)return!0}return!1}function e(L,$,m,u,c){if(u+c===m)return!0;const n=$.charCodeAt(u+c);if(L.get(n)!==0||n===13||n===10)return!0;if(c>0){const l=$.charCodeAt(u+c-1);if(L.get(l)!==0)return!0}return!1}function E(L,$,m,u,c){return g(L,$,m,u,c)&&e(L,$,m,u,c)}t.$gC=E;class R{constructor($,m){this._wordSeparators=$,this.a=m,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const m=$.length;let u;do{if(this.b+this.c===m||(u=this.a.exec($),!u))return null;const c=u.index,n=u[0].length;if(c===this.b&&n===this.c){if(n===0){F.$qf($,m,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=n,!this._wordSeparators||E(this._wordSeparators,$,m,c,n))return u}while(u);return null}}t.$hC=R}),te(ie[58],se([0,1,2,57,7,13,29]),function(W,t,F,P,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$11=void 0;class f{static computeUnicodeHighlights(e,E,R){const L=R?R.startLineNumber:1,$=R?R.endLineNumber:e.getLineCount(),m=new h(E),u=m.getCandidateCodePoints();let c;u==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${a(Array.from(u))}`,"g");const n=new P.$hC(null,c),l=[];let v=!1,d,w=0,k=0,M=0;e:for(let y=L,D=$;y<=D;y++){const p=e.getLineContent(y),S=p.length;n.reset(0);do if(d=n.next(p),d){let _=d.index,q=d.index+d[0].length;if(_>0){const T=p.charCodeAt(_-1);r.$nf(T)&&_--}if(q+1<S){const T=p.charCodeAt(q-1);r.$nf(T)&&q++}const V=p.substring(_,q);let x=(0,N.$Is)(_+1,N.$Fs,p,0);x&&x.endColumn<=_+1&&(x=null);const ee=m.shouldHighlightNonBasicASCII(V,x?x.word:null);if(ee!==0){if(ee===3?w++:ee===2?k++:ee===1?M++:(0,o.$9c)(ee),l.length>=1e3){v=!0;break e}l.push(new F.$6s(y,_+1,y,q+1))}}while(d)}return{ranges:l,hasMore:v,ambiguousCharacterCount:w,invisibleCharacterCount:k,nonBasicAsciiCharacterCount:M}}static computeUnicodeHighlightReason(e,E){const R=new h(E);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),m=R.ambiguousCharacters.getPrimaryConfusable($),u=r.$Qf.getLocales().filter(c=>!r.$Qf.getInstance(new Set([...E.allowedLocales,c])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(m),notAmbiguousInLocales:u}}case 1:return{kind:2}}}}t.$11=f;function a(g,e){return`[${r.$Xe(g.map(R=>String.fromCodePoint(R)).join(""))}]`}var s;(function(g){g[g.Ambiguous=0]="Ambiguous",g[g.Invisible=1]="Invisible",g[g.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class h{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$Qf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const E of r.$Rf.codePoints)A(String.fromCodePoint(E))||e.add(E);if(this.b.ambiguousCharacters)for(const E of this.ambiguousCharacters.getConfusableCodePoints())e.add(E);for(const E of this.a)e.delete(E);return e}shouldHighlightNonBasicASCII(e,E){const R=e.codePointAt(0);if(this.a.has(R))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,$=!1;if(E)for(const m of E){const u=m.codePointAt(0),c=r.$yf(m);L=L||c,!c&&!this.ambiguousCharacters.isAmbiguous(u)&&!r.$Rf.isInvisibleCharacter(u)&&($=!0)}return!L&&$?0:this.b.invisibleCharacters&&!A(e)&&r.$Rf.isInvisibleCharacter(R)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function A(g){return g===" "||g===`
`||g==="	"}var b;(function(g){g[g.None=0]="None",g[g.NonBasicASCII=1]="NonBasicASCII",g[g.Invisible=2]="Invisible",g[g.Ambiguous=3]="Ambiguous"})(b||(b={}))}),te(ie[59],se([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var F;(function(i){i[i.Unknown=0]="Unknown",i[i.Disabled=1]="Disabled",i[i.Enabled=2]="Enabled"})(F||(t.AccessibilitySupport=F={}));var P;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(P||(t.CodeActionTriggerType=P={}));var r;(function(i){i[i.None=0]="None",i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var o;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(o||(t.CompletionItemKind=o={}));var N;(function(i){i[i.Deprecated=1]="Deprecated"})(N||(t.CompletionItemTag=N={}));var f;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(t.CompletionTriggerKind=f={}));var a;(function(i){i[i.EXACT=0]="EXACT",i[i.ABOVE=1]="ABOVE",i[i.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var s;(function(i){i[i.NotSet=0]="NotSet",i[i.ContentFlush=1]="ContentFlush",i[i.RecoverFromMarkers=2]="RecoverFromMarkers",i[i.Explicit=3]="Explicit",i[i.Paste=4]="Paste",i[i.Undo=5]="Undo",i[i.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var h;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(h||(t.DefaultEndOfLine=h={}));var A;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(A||(t.DocumentHighlightKind=A={}));var b;(function(i){i[i.None=0]="None",i[i.Keep=1]="Keep",i[i.Brackets=2]="Brackets",i[i.Advanced=3]="Advanced",i[i.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var g;(function(i){i[i.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",i[i.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",i[i.accessibilitySupport=2]="accessibilitySupport",i[i.accessibilityPageSize=3]="accessibilityPageSize",i[i.ariaLabel=4]="ariaLabel",i[i.ariaRequired=5]="ariaRequired",i[i.autoClosingBrackets=6]="autoClosingBrackets",i[i.autoClosingComments=7]="autoClosingComments",i[i.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",i[i.autoClosingDelete=9]="autoClosingDelete",i[i.autoClosingOvertype=10]="autoClosingOvertype",i[i.autoClosingQuotes=11]="autoClosingQuotes",i[i.autoIndent=12]="autoIndent",i[i.automaticLayout=13]="automaticLayout",i[i.autoSurround=14]="autoSurround",i[i.bracketPairColorization=15]="bracketPairColorization",i[i.guides=16]="guides",i[i.codeLens=17]="codeLens",i[i.codeLensFontFamily=18]="codeLensFontFamily",i[i.codeLensFontSize=19]="codeLensFontSize",i[i.colorDecorators=20]="colorDecorators",i[i.colorDecoratorsLimit=21]="colorDecoratorsLimit",i[i.columnSelection=22]="columnSelection",i[i.comments=23]="comments",i[i.contextmenu=24]="contextmenu",i[i.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",i[i.cursorBlinking=26]="cursorBlinking",i[i.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",i[i.cursorStyle=28]="cursorStyle",i[i.cursorSurroundingLines=29]="cursorSurroundingLines",i[i.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",i[i.cursorWidth=31]="cursorWidth",i[i.disableLayerHinting=32]="disableLayerHinting",i[i.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",i[i.domReadOnly=34]="domReadOnly",i[i.dragAndDrop=35]="dragAndDrop",i[i.dropIntoEditor=36]="dropIntoEditor",i[i.emptySelectionClipboard=37]="emptySelectionClipboard",i[i.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",i[i.extraEditorClassName=39]="extraEditorClassName",i[i.fastScrollSensitivity=40]="fastScrollSensitivity",i[i.find=41]="find",i[i.fixedOverflowWidgets=42]="fixedOverflowWidgets",i[i.folding=43]="folding",i[i.foldingStrategy=44]="foldingStrategy",i[i.foldingHighlight=45]="foldingHighlight",i[i.foldingImportsByDefault=46]="foldingImportsByDefault",i[i.foldingMaximumRegions=47]="foldingMaximumRegions",i[i.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",i[i.fontFamily=49]="fontFamily",i[i.fontInfo=50]="fontInfo",i[i.fontLigatures=51]="fontLigatures",i[i.fontSize=52]="fontSize",i[i.fontWeight=53]="fontWeight",i[i.fontVariations=54]="fontVariations",i[i.formatOnPaste=55]="formatOnPaste",i[i.formatOnType=56]="formatOnType",i[i.glyphMargin=57]="glyphMargin",i[i.gotoLocation=58]="gotoLocation",i[i.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",i[i.hover=60]="hover",i[i.inDiffEditor=61]="inDiffEditor",i[i.inlineSuggest=62]="inlineSuggest",i[i.inlineEdit=63]="inlineEdit",i[i.letterSpacing=64]="letterSpacing",i[i.lightbulb=65]="lightbulb",i[i.lineDecorationsWidth=66]="lineDecorationsWidth",i[i.lineHeight=67]="lineHeight",i[i.lineNumbers=68]="lineNumbers",i[i.lineNumbersMinChars=69]="lineNumbersMinChars",i[i.linkedEditing=70]="linkedEditing",i[i.links=71]="links",i[i.matchBrackets=72]="matchBrackets",i[i.minimap=73]="minimap",i[i.mouseStyle=74]="mouseStyle",i[i.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",i[i.mouseWheelZoom=76]="mouseWheelZoom",i[i.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",i[i.multiCursorModifier=78]="multiCursorModifier",i[i.multiCursorPaste=79]="multiCursorPaste",i[i.multiCursorLimit=80]="multiCursorLimit",i[i.occurrencesHighlight=81]="occurrencesHighlight",i[i.overviewRulerBorder=82]="overviewRulerBorder",i[i.overviewRulerLanes=83]="overviewRulerLanes",i[i.padding=84]="padding",i[i.pasteAs=85]="pasteAs",i[i.parameterHints=86]="parameterHints",i[i.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",i[i.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",i[i.quickSuggestions=89]="quickSuggestions",i[i.quickSuggestionsDelay=90]="quickSuggestionsDelay",i[i.readOnly=91]="readOnly",i[i.readOnlyMessage=92]="readOnlyMessage",i[i.renameOnType=93]="renameOnType",i[i.renderControlCharacters=94]="renderControlCharacters",i[i.renderFinalNewline=95]="renderFinalNewline",i[i.renderLineHighlight=96]="renderLineHighlight",i[i.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",i[i.renderValidationDecorations=98]="renderValidationDecorations",i[i.renderWhitespace=99]="renderWhitespace",i[i.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",i[i.roundedSelection=101]="roundedSelection",i[i.rulers=102]="rulers",i[i.scrollbar=103]="scrollbar",i[i.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",i[i.scrollBeyondLastLine=105]="scrollBeyondLastLine",i[i.scrollPredominantAxis=106]="scrollPredominantAxis",i[i.selectionClipboard=107]="selectionClipboard",i[i.selectionHighlight=108]="selectionHighlight",i[i.selectOnLineNumbers=109]="selectOnLineNumbers",i[i.showFoldingControls=110]="showFoldingControls",i[i.showUnused=111]="showUnused",i[i.snippetSuggestions=112]="snippetSuggestions",i[i.smartSelect=113]="smartSelect",i[i.smoothScrolling=114]="smoothScrolling",i[i.stickyScroll=115]="stickyScroll",i[i.stickyTabStops=116]="stickyTabStops",i[i.stopRenderingLineAfter=117]="stopRenderingLineAfter",i[i.suggest=118]="suggest",i[i.suggestFontSize=119]="suggestFontSize",i[i.suggestLineHeight=120]="suggestLineHeight",i[i.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",i[i.suggestSelection=122]="suggestSelection",i[i.tabCompletion=123]="tabCompletion",i[i.tabIndex=124]="tabIndex",i[i.unicodeHighlighting=125]="unicodeHighlighting",i[i.unusualLineTerminators=126]="unusualLineTerminators",i[i.useShadowDOM=127]="useShadowDOM",i[i.useTabStops=128]="useTabStops",i[i.wordBreak=129]="wordBreak",i[i.wordSeparators=130]="wordSeparators",i[i.wordWrap=131]="wordWrap",i[i.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",i[i.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",i[i.wordWrapColumn=134]="wordWrapColumn",i[i.wordWrapOverride1=135]="wordWrapOverride1",i[i.wordWrapOverride2=136]="wordWrapOverride2",i[i.wrappingIndent=137]="wrappingIndent",i[i.wrappingStrategy=138]="wrappingStrategy",i[i.showDeprecated=139]="showDeprecated",i[i.inlayHints=140]="inlayHints",i[i.editorClassName=141]="editorClassName",i[i.pixelRatio=142]="pixelRatio",i[i.tabFocusMode=143]="tabFocusMode",i[i.layoutInfo=144]="layoutInfo",i[i.wrappingInfo=145]="wrappingInfo",i[i.defaultColorDecorators=146]="defaultColorDecorators",i[i.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",i[i.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(g||(t.EditorOption=g={}));var e;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var E;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(E||(t.EndOfLineSequence=E={}));var R;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=3]="Right"})(R||(t.GlyphMarginLane=R={}));var L;(function(i){i[i.None=0]="None",i[i.Indent=1]="Indent",i[i.IndentOutdent=2]="IndentOutdent",i[i.Outdent=3]="Outdent"})(L||(t.IndentAction=L={}));var $;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var m;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(m||(t.InlayHintKind=m={}));var u;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(u||(t.InlineCompletionTriggerKind=u={}));var c;(function(i){i[i.Invoke=0]="Invoke",i[i.Automatic=1]="Automatic"})(c||(t.InlineEditTriggerKind=c={}));var n;(function(i){i[i.DependsOnKbLayout=-1]="DependsOnKbLayout",i[i.Unknown=0]="Unknown",i[i.Backspace=1]="Backspace",i[i.Tab=2]="Tab",i[i.Enter=3]="Enter",i[i.Shift=4]="Shift",i[i.Ctrl=5]="Ctrl",i[i.Alt=6]="Alt",i[i.PauseBreak=7]="PauseBreak",i[i.CapsLock=8]="CapsLock",i[i.Escape=9]="Escape",i[i.Space=10]="Space",i[i.PageUp=11]="PageUp",i[i.PageDown=12]="PageDown",i[i.End=13]="End",i[i.Home=14]="Home",i[i.LeftArrow=15]="LeftArrow",i[i.UpArrow=16]="UpArrow",i[i.RightArrow=17]="RightArrow",i[i.DownArrow=18]="DownArrow",i[i.Insert=19]="Insert",i[i.Delete=20]="Delete",i[i.Digit0=21]="Digit0",i[i.Digit1=22]="Digit1",i[i.Digit2=23]="Digit2",i[i.Digit3=24]="Digit3",i[i.Digit4=25]="Digit4",i[i.Digit5=26]="Digit5",i[i.Digit6=27]="Digit6",i[i.Digit7=28]="Digit7",i[i.Digit8=29]="Digit8",i[i.Digit9=30]="Digit9",i[i.KeyA=31]="KeyA",i[i.KeyB=32]="KeyB",i[i.KeyC=33]="KeyC",i[i.KeyD=34]="KeyD",i[i.KeyE=35]="KeyE",i[i.KeyF=36]="KeyF",i[i.KeyG=37]="KeyG",i[i.KeyH=38]="KeyH",i[i.KeyI=39]="KeyI",i[i.KeyJ=40]="KeyJ",i[i.KeyK=41]="KeyK",i[i.KeyL=42]="KeyL",i[i.KeyM=43]="KeyM",i[i.KeyN=44]="KeyN",i[i.KeyO=45]="KeyO",i[i.KeyP=46]="KeyP",i[i.KeyQ=47]="KeyQ",i[i.KeyR=48]="KeyR",i[i.KeyS=49]="KeyS",i[i.KeyT=50]="KeyT",i[i.KeyU=51]="KeyU",i[i.KeyV=52]="KeyV",i[i.KeyW=53]="KeyW",i[i.KeyX=54]="KeyX",i[i.KeyY=55]="KeyY",i[i.KeyZ=56]="KeyZ",i[i.Meta=57]="Meta",i[i.ContextMenu=58]="ContextMenu",i[i.F1=59]="F1",i[i.F2=60]="F2",i[i.F3=61]="F3",i[i.F4=62]="F4",i[i.F5=63]="F5",i[i.F6=64]="F6",i[i.F7=65]="F7",i[i.F8=66]="F8",i[i.F9=67]="F9",i[i.F10=68]="F10",i[i.F11=69]="F11",i[i.F12=70]="F12",i[i.F13=71]="F13",i[i.F14=72]="F14",i[i.F15=73]="F15",i[i.F16=74]="F16",i[i.F17=75]="F17",i[i.F18=76]="F18",i[i.F19=77]="F19",i[i.F20=78]="F20",i[i.F21=79]="F21",i[i.F22=80]="F22",i[i.F23=81]="F23",i[i.F24=82]="F24",i[i.NumLock=83]="NumLock",i[i.ScrollLock=84]="ScrollLock",i[i.Semicolon=85]="Semicolon",i[i.Equal=86]="Equal",i[i.Comma=87]="Comma",i[i.Minus=88]="Minus",i[i.Period=89]="Period",i[i.Slash=90]="Slash",i[i.Backquote=91]="Backquote",i[i.BracketLeft=92]="BracketLeft",i[i.Backslash=93]="Backslash",i[i.BracketRight=94]="BracketRight",i[i.Quote=95]="Quote",i[i.OEM_8=96]="OEM_8",i[i.IntlBackslash=97]="IntlBackslash",i[i.Numpad0=98]="Numpad0",i[i.Numpad1=99]="Numpad1",i[i.Numpad2=100]="Numpad2",i[i.Numpad3=101]="Numpad3",i[i.Numpad4=102]="Numpad4",i[i.Numpad5=103]="Numpad5",i[i.Numpad6=104]="Numpad6",i[i.Numpad7=105]="Numpad7",i[i.Numpad8=106]="Numpad8",i[i.Numpad9=107]="Numpad9",i[i.NumpadMultiply=108]="NumpadMultiply",i[i.NumpadAdd=109]="NumpadAdd",i[i.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",i[i.NumpadSubtract=111]="NumpadSubtract",i[i.NumpadDecimal=112]="NumpadDecimal",i[i.NumpadDivide=113]="NumpadDivide",i[i.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",i[i.ABNT_C1=115]="ABNT_C1",i[i.ABNT_C2=116]="ABNT_C2",i[i.AudioVolumeMute=117]="AudioVolumeMute",i[i.AudioVolumeUp=118]="AudioVolumeUp",i[i.AudioVolumeDown=119]="AudioVolumeDown",i[i.BrowserSearch=120]="BrowserSearch",i[i.BrowserHome=121]="BrowserHome",i[i.BrowserBack=122]="BrowserBack",i[i.BrowserForward=123]="BrowserForward",i[i.MediaTrackNext=124]="MediaTrackNext",i[i.MediaTrackPrevious=125]="MediaTrackPrevious",i[i.MediaStop=126]="MediaStop",i[i.MediaPlayPause=127]="MediaPlayPause",i[i.LaunchMediaPlayer=128]="LaunchMediaPlayer",i[i.LaunchMail=129]="LaunchMail",i[i.LaunchApp2=130]="LaunchApp2",i[i.Clear=131]="Clear",i[i.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var l;(function(i){i[i.Hint=1]="Hint",i[i.Info=2]="Info",i[i.Warning=4]="Warning",i[i.Error=8]="Error"})(l||(t.MarkerSeverity=l={}));var v;(function(i){i[i.Unnecessary=1]="Unnecessary",i[i.Deprecated=2]="Deprecated"})(v||(t.MarkerTag=v={}));var d;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(d||(t.MinimapPosition=d={}));var w;(function(i){i[i.UNKNOWN=0]="UNKNOWN",i[i.TEXTAREA=1]="TEXTAREA",i[i.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",i[i.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",i[i.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",i[i.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",i[i.CONTENT_TEXT=6]="CONTENT_TEXT",i[i.CONTENT_EMPTY=7]="CONTENT_EMPTY",i[i.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",i[i.CONTENT_WIDGET=9]="CONTENT_WIDGET",i[i.OVERVIEW_RULER=10]="OVERVIEW_RULER",i[i.SCROLLBAR=11]="SCROLLBAR",i[i.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",i[i.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(w||(t.MouseTargetType=w={}));var k;(function(i){i[i.AIGenerated=1]="AIGenerated"})(k||(t.NewSymbolNameTag=k={}));var M;(function(i){i[i.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",i[i.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",i[i.TOP_CENTER=2]="TOP_CENTER"})(M||(t.OverlayWidgetPositionPreference=M={}));var y;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(y||(t.OverviewRulerLane=y={}));var D;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(D||(t.PositionAffinity=D={}));var p;(function(i){i[i.Off=0]="Off",i[i.On=1]="On",i[i.Relative=2]="Relative",i[i.Interval=3]="Interval",i[i.Custom=4]="Custom"})(p||(t.RenderLineNumbersType=p={}));var S;(function(i){i[i.None=0]="None",i[i.Text=1]="Text",i[i.Blocks=2]="Blocks"})(S||(t.RenderMinimap=S={}));var _;(function(i){i[i.Smooth=0]="Smooth",i[i.Immediate=1]="Immediate"})(_||(t.ScrollType=_={}));var q;(function(i){i[i.Auto=1]="Auto",i[i.Hidden=2]="Hidden",i[i.Visible=3]="Visible"})(q||(t.ScrollbarVisibility=q={}));var V;(function(i){i[i.LTR=0]="LTR",i[i.RTL=1]="RTL"})(V||(t.SelectionDirection=V={}));var x;(function(i){i.Off="off",i.OnCode="onCode",i.On="on"})(x||(t.ShowLightbulbIconMode=x={}));var ee;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(ee||(t.SignatureHelpTriggerKind=ee={}));var T;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(T||(t.SymbolKind=T={}));var U;(function(i){i[i.Deprecated=1]="Deprecated"})(U||(t.SymbolTag=U={}));var Y;(function(i){i[i.Hidden=0]="Hidden",i[i.Blink=1]="Blink",i[i.Smooth=2]="Smooth",i[i.Phase=3]="Phase",i[i.Expand=4]="Expand",i[i.Solid=5]="Solid"})(Y||(t.TextEditorCursorBlinkingStyle=Y={}));var X;(function(i){i[i.Line=1]="Line",i[i.Block=2]="Block",i[i.Underline=3]="Underline",i[i.LineThin=4]="LineThin",i[i.BlockOutline=5]="BlockOutline",i[i.UnderlineThin=6]="UnderlineThin"})(X||(t.TextEditorCursorStyle=X={}));var re;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(re||(t.TrackedRangeStickiness=re={}));var ue;(function(i){i[i.None=0]="None",i[i.Same=1]="Same",i[i.Indent=2]="Indent",i[i.DeepIndent=3]="DeepIndent"})(ue||(t.WrappingIndent=ue={}))}),te(ie[60],se([0,1,11,10]),function(W,t,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Et=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new F.$5d,this.onDidChange=this.c.event,this.d=null}handleChange(f){this.c.fire({changedLanguages:f,changedColorMap:!1})}register(f,a){return this.a.set(f,a),this.handleChange([f]),(0,P.$Rc)(()=>{this.a.get(f)===a&&(this.a.delete(f),this.handleChange([f]))})}get(f){return this.a.get(f)||null}registerFactory(f,a){this.b.get(f)?.dispose();const s=new o(this,f,a);return this.b.set(f,s),(0,P.$Rc)(()=>{const h=this.b.get(f);!h||h!==s||(this.b.delete(f),h.dispose())})}async getOrCreate(f){const a=this.get(f);if(a)return a;const s=this.b.get(f);return!s||s.isResolved?null:(await s.resolve(),this.get(f))}isResolved(f){if(this.get(f))return!0;const s=this.b.get(f);return!!(!s||s.isResolved)}setColorMap(f){this.d=f,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Et=r;class o extends P.$Tc{get isResolved(){return this.c}constructor(f,a,s){super(),this.f=f,this.g=a,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const f=await this.h.tokenizationSupport;this.c=!0,f&&!this.a&&this.B(this.f.register(this.g,f))}}}),te(ie[61],se([62,63]),function(W,t){return W.create("vs/base/common/platform",t)}),te(ie[17],se([0,1,61]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let P=!1,r=!1,o=!1,N=!1,f=!1,a=!1,s=!1,h=!1,A=!1,b=!1,g,e=t.$g,E=t.$g,R,L;const $=globalThis;let m;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?m=$.vscode.process:typeof process<"u"&&(m=process);const u=typeof m?.versions?.electron=="string",c=u&&m?.type==="renderer";if(typeof m=="object"){P=m.platform==="win32",r=m.platform==="darwin",o=m.platform==="linux",N=o&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,s=u,A=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t.$g,e=t.$g;const p=m.env.VSCODE_NLS_CONFIG;if(p)try{const S=JSON.parse(p),_=S.availableLanguages["*"];g=S.locale,E=S.osLocale,e=_||t.$g,R=S._translationsConfigFile}catch{}f=!0}else typeof navigator=="object"&&!c?(L=navigator.userAgent,P=L.indexOf("Windows")>=0,r=L.indexOf("Macintosh")>=0,h=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,o=L.indexOf("Linux")>=0,b=L?.indexOf("Mobi")>=0,a=!0,g=F.getConfiguredDefaultLocale(F.localize(0,null))||t.$g,e=g,E=navigator.language):console.error("Unable to resolve platform.");var n;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(n||(t.Platform=n={}));function l(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=l;let v=0;r?v=1:P?v=3:o&&(v=2),t.$i=P,t.$j=r,t.$k=o,t.$l=N,t.$m=f,t.$n=s,t.$o=a,t.$p=a&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=h,t.$s=b,t.$t=A,t.$u=v,t.$v=L,t.$w=e;var d;(function(p){function S(){return t.$w}p.value=S;function _(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}p.isDefaultVariant=_;function q(){return t.$w==="en"}p.isDefault=q})(d||(t.Language=d={})),t.$x=g,t.$y=E,t.$z=R,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const p=[];$.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let q=0,V=p.length;q<V;q++){const x=p[q];if(x.id===_.data.vscodeScheduleAsyncWork){p.splice(q,1),x.callback();return}}});let S=0;return _=>{const q=++S;p.push({id:q,callback:_}),$.postMessage({vscodeScheduleAsyncWork:q},"*")}}return p=>setTimeout(p)})();var w;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(w||(t.OperatingSystem=w={})),t.OS=r||h?2:P?1:3;let k=!0,M=!1;function y(){if(!M){M=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,k=new Uint16Array(p.buffer)[0]===513}return k}t.$D=y,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function D(p){return parseFloat(p)>=20}t.$J=D}),te(ie[64],se([0,1,17]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let P;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const o=r.process;P={get platform(){return o.platform},get arch(){return o.arch},get env(){return o.env},cwd(){return o.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return F.$i?"win32":F.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.$dc=P.platform,t.$ec=P.arch}),te(ie[65],se([0,1,64]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const P=65,r=97,o=90,N=122,f=46,a=47,s=92,h=58,A=63;class b extends Error{constructor(l,v,d){let w;typeof v=="string"&&v.indexOf("not ")===0?(w="must not be",v=v.replace(/^not /,"")):w="must be";const k=l.indexOf(".")!==-1?"property":"argument";let M=`The "${l}" ${k} ${w} of type ${v}`;M+=`. Received type ${typeof d}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function g(n,l){if(n===null||typeof n!="object")throw new b(l,"Object",n)}function e(n,l){if(typeof n!="string")throw new b(l,"string",n)}const E=F.$dc==="win32";function R(n){return n===a||n===s}function L(n){return n===a}function $(n){return n>=P&&n<=o||n>=r&&n<=N}function m(n,l,v,d){let w="",k=0,M=-1,y=0,D=0;for(let p=0;p<=n.length;++p){if(p<n.length)D=n.charCodeAt(p);else{if(d(D))break;D=a}if(d(D)){if(!(M===p-1||y===1))if(y===2){if(w.length<2||k!==2||w.charCodeAt(w.length-1)!==f||w.charCodeAt(w.length-2)!==f){if(w.length>2){const S=w.lastIndexOf(v);S===-1?(w="",k=0):(w=w.slice(0,S),k=w.length-1-w.lastIndexOf(v)),M=p,y=0;continue}else if(w.length!==0){w="",k=0,M=p,y=0;continue}}l&&(w+=w.length>0?`${v}..`:"..",k=2)}else w.length>0?w+=`${v}${n.slice(M+1,p)}`:w=n.slice(M+1,p),k=p-M-1;M=p,y=0}else D===f&&y!==-1?++y:y=-1}return w}function u(n,l){g(l,"pathObject");const v=l.dir||l.root,d=l.base||`${l.name||""}${l.ext||""}`;return v?v===l.root?`${v}${d}`:`${v}${n}${d}`:d}t.$fc={resolve(...n){let l="",v="",d=!1;for(let w=n.length-1;w>=-1;w--){let k;if(w>=0){if(k=n[w],e(k,"path"),k.length===0)continue}else l.length===0?k=F.cwd():(k=F.env[`=${l}`]||F.cwd(),(k===void 0||k.slice(0,2).toLowerCase()!==l.toLowerCase()&&k.charCodeAt(2)===s)&&(k=`${l}\\`));const M=k.length;let y=0,D="",p=!1;const S=k.charCodeAt(0);if(M===1)R(S)&&(y=1,p=!0);else if(R(S))if(p=!0,R(k.charCodeAt(1))){let _=2,q=_;for(;_<M&&!R(k.charCodeAt(_));)_++;if(_<M&&_!==q){const V=k.slice(q,_);for(q=_;_<M&&R(k.charCodeAt(_));)_++;if(_<M&&_!==q){for(q=_;_<M&&!R(k.charCodeAt(_));)_++;(_===M||_!==q)&&(D=`\\\\${V}\\${k.slice(q,_)}`,y=_)}}}else y=1;else $(S)&&k.charCodeAt(1)===h&&(D=k.slice(0,2),y=2,M>2&&R(k.charCodeAt(2))&&(p=!0,y=3));if(D.length>0)if(l.length>0){if(D.toLowerCase()!==l.toLowerCase())continue}else l=D;if(d){if(l.length>0)break}else if(v=`${k.slice(y)}\\${v}`,d=p,p&&l.length>0)break}return v=m(v,!d,"\\",R),d?`${l}\\${v}`:`${l}${v}`||"."},normalize(n){e(n,"path");const l=n.length;if(l===0)return".";let v=0,d,w=!1;const k=n.charCodeAt(0);if(l===1)return L(k)?"\\":n;if(R(k))if(w=!0,R(n.charCodeAt(1))){let y=2,D=y;for(;y<l&&!R(n.charCodeAt(y));)y++;if(y<l&&y!==D){const p=n.slice(D,y);for(D=y;y<l&&R(n.charCodeAt(y));)y++;if(y<l&&y!==D){for(D=y;y<l&&!R(n.charCodeAt(y));)y++;if(y===l)return`\\\\${p}\\${n.slice(D)}\\`;y!==D&&(d=`\\\\${p}\\${n.slice(D,y)}`,v=y)}}}else v=1;else $(k)&&n.charCodeAt(1)===h&&(d=n.slice(0,2),v=2,l>2&&R(n.charCodeAt(2))&&(w=!0,v=3));let M=v<l?m(n.slice(v),!w,"\\",R):"";return M.length===0&&!w&&(M="."),M.length>0&&R(n.charCodeAt(l-1))&&(M+="\\"),d===void 0?w?`\\${M}`:M:w?`${d}\\${M}`:`${d}${M}`},isAbsolute(n){e(n,"path");const l=n.length;if(l===0)return!1;const v=n.charCodeAt(0);return R(v)||l>2&&$(v)&&n.charCodeAt(1)===h&&R(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let l,v;for(let k=0;k<n.length;++k){const M=n[k];e(M,"path"),M.length>0&&(l===void 0?l=v=M:l+=`\\${M}`)}if(l===void 0)return".";let d=!0,w=0;if(typeof v=="string"&&R(v.charCodeAt(0))){++w;const k=v.length;k>1&&R(v.charCodeAt(1))&&(++w,k>2&&(R(v.charCodeAt(2))?++w:d=!1))}if(d){for(;w<l.length&&R(l.charCodeAt(w));)w++;w>=2&&(l=`\\${l.slice(w)}`)}return t.$fc.normalize(l)},relative(n,l){if(e(n,"from"),e(l,"to"),n===l)return"";const v=t.$fc.resolve(n),d=t.$fc.resolve(l);if(v===d||(n=v.toLowerCase(),l=d.toLowerCase(),n===l))return"";let w=0;for(;w<n.length&&n.charCodeAt(w)===s;)w++;let k=n.length;for(;k-1>w&&n.charCodeAt(k-1)===s;)k--;const M=k-w;let y=0;for(;y<l.length&&l.charCodeAt(y)===s;)y++;let D=l.length;for(;D-1>y&&l.charCodeAt(D-1)===s;)D--;const p=D-y,S=M<p?M:p;let _=-1,q=0;for(;q<S;q++){const x=n.charCodeAt(w+q);if(x!==l.charCodeAt(y+q))break;x===s&&(_=q)}if(q!==S){if(_===-1)return d}else{if(p>S){if(l.charCodeAt(y+q)===s)return d.slice(y+q+1);if(q===2)return d.slice(y+q)}M>S&&(n.charCodeAt(w+q)===s?_=q:q===2&&(_=3)),_===-1&&(_=0)}let V="";for(q=w+_+1;q<=k;++q)(q===k||n.charCodeAt(q)===s)&&(V+=V.length===0?"..":"\\..");return y+=_,V.length>0?`${V}${d.slice(y,D)}`:(d.charCodeAt(y)===s&&++y,d.slice(y,D))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const l=t.$fc.resolve(n);if(l.length<=2)return n;if(l.charCodeAt(0)===s){if(l.charCodeAt(1)===s){const v=l.charCodeAt(2);if(v!==A&&v!==f)return`\\\\?\\UNC\\${l.slice(2)}`}}else if($(l.charCodeAt(0))&&l.charCodeAt(1)===h&&l.charCodeAt(2)===s)return`\\\\?\\${l}`;return n},dirname(n){e(n,"path");const l=n.length;if(l===0)return".";let v=-1,d=0;const w=n.charCodeAt(0);if(l===1)return R(w)?n:".";if(R(w)){if(v=d=1,R(n.charCodeAt(1))){let y=2,D=y;for(;y<l&&!R(n.charCodeAt(y));)y++;if(y<l&&y!==D){for(D=y;y<l&&R(n.charCodeAt(y));)y++;if(y<l&&y!==D){for(D=y;y<l&&!R(n.charCodeAt(y));)y++;if(y===l)return n;y!==D&&(v=d=y+1)}}}}else $(w)&&n.charCodeAt(1)===h&&(v=l>2&&R(n.charCodeAt(2))?3:2,d=v);let k=-1,M=!0;for(let y=l-1;y>=d;--y)if(R(n.charCodeAt(y))){if(!M){k=y;break}}else M=!1;if(k===-1){if(v===-1)return".";k=v}return n.slice(0,k)},basename(n,l){l!==void 0&&e(l,"ext"),e(n,"path");let v=0,d=-1,w=!0,k;if(n.length>=2&&$(n.charCodeAt(0))&&n.charCodeAt(1)===h&&(v=2),l!==void 0&&l.length>0&&l.length<=n.length){if(l===n)return"";let M=l.length-1,y=-1;for(k=n.length-1;k>=v;--k){const D=n.charCodeAt(k);if(R(D)){if(!w){v=k+1;break}}else y===-1&&(w=!1,y=k+1),M>=0&&(D===l.charCodeAt(M)?--M===-1&&(d=k):(M=-1,d=y))}return v===d?d=y:d===-1&&(d=n.length),n.slice(v,d)}for(k=n.length-1;k>=v;--k)if(R(n.charCodeAt(k))){if(!w){v=k+1;break}}else d===-1&&(w=!1,d=k+1);return d===-1?"":n.slice(v,d)},extname(n){e(n,"path");let l=0,v=-1,d=0,w=-1,k=!0,M=0;n.length>=2&&n.charCodeAt(1)===h&&$(n.charCodeAt(0))&&(l=d=2);for(let y=n.length-1;y>=l;--y){const D=n.charCodeAt(y);if(R(D)){if(!k){d=y+1;break}continue}w===-1&&(k=!1,w=y+1),D===f?v===-1?v=y:M!==1&&(M=1):v!==-1&&(M=-1)}return v===-1||w===-1||M===0||M===1&&v===w-1&&v===d+1?"":n.slice(v,w)},format:u.bind(null,"\\"),parse(n){e(n,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return l;const v=n.length;let d=0,w=n.charCodeAt(0);if(v===1)return R(w)?(l.root=l.dir=n,l):(l.base=l.name=n,l);if(R(w)){if(d=1,R(n.charCodeAt(1))){let _=2,q=_;for(;_<v&&!R(n.charCodeAt(_));)_++;if(_<v&&_!==q){for(q=_;_<v&&R(n.charCodeAt(_));)_++;if(_<v&&_!==q){for(q=_;_<v&&!R(n.charCodeAt(_));)_++;_===v?d=_:_!==q&&(d=_+1)}}}}else if($(w)&&n.charCodeAt(1)===h){if(v<=2)return l.root=l.dir=n,l;if(d=2,R(n.charCodeAt(2))){if(v===3)return l.root=l.dir=n,l;d=3}}d>0&&(l.root=n.slice(0,d));let k=-1,M=d,y=-1,D=!0,p=n.length-1,S=0;for(;p>=d;--p){if(w=n.charCodeAt(p),R(w)){if(!D){M=p+1;break}continue}y===-1&&(D=!1,y=p+1),w===f?k===-1?k=p:S!==1&&(S=1):k!==-1&&(S=-1)}return y!==-1&&(k===-1||S===0||S===1&&k===y-1&&k===M+1?l.base=l.name=n.slice(M,y):(l.name=n.slice(M,k),l.base=n.slice(M,y),l.ext=n.slice(k,y))),M>0&&M!==d?l.dir=n.slice(0,M-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(E){const n=/\\/g;return()=>{const l=F.cwd().replace(n,"/");return l.slice(l.indexOf("/"))}}return()=>F.cwd()})();t.$gc={resolve(...n){let l="",v=!1;for(let d=n.length-1;d>=-1&&!v;d--){const w=d>=0?n[d]:c();e(w,"path"),w.length!==0&&(l=`${w}/${l}`,v=w.charCodeAt(0)===a)}return l=m(l,!v,"/",L),v?`/${l}`:l.length>0?l:"."},normalize(n){if(e(n,"path"),n.length===0)return".";const l=n.charCodeAt(0)===a,v=n.charCodeAt(n.length-1)===a;return n=m(n,!l,"/",L),n.length===0?l?"/":v?"./":".":(v&&(n+="/"),l?`/${n}`:n)},isAbsolute(n){return e(n,"path"),n.length>0&&n.charCodeAt(0)===a},join(...n){if(n.length===0)return".";let l;for(let v=0;v<n.length;++v){const d=n[v];e(d,"path"),d.length>0&&(l===void 0?l=d:l+=`/${d}`)}return l===void 0?".":t.$gc.normalize(l)},relative(n,l){if(e(n,"from"),e(l,"to"),n===l||(n=t.$gc.resolve(n),l=t.$gc.resolve(l),n===l))return"";const v=1,d=n.length,w=d-v,k=1,M=l.length-k,y=w<M?w:M;let D=-1,p=0;for(;p<y;p++){const _=n.charCodeAt(v+p);if(_!==l.charCodeAt(k+p))break;_===a&&(D=p)}if(p===y)if(M>y){if(l.charCodeAt(k+p)===a)return l.slice(k+p+1);if(p===0)return l.slice(k+p)}else w>y&&(n.charCodeAt(v+p)===a?D=p:p===0&&(D=0));let S="";for(p=v+D+1;p<=d;++p)(p===d||n.charCodeAt(p)===a)&&(S+=S.length===0?"..":"/..");return`${S}${l.slice(k+D)}`},toNamespacedPath(n){return n},dirname(n){if(e(n,"path"),n.length===0)return".";const l=n.charCodeAt(0)===a;let v=-1,d=!0;for(let w=n.length-1;w>=1;--w)if(n.charCodeAt(w)===a){if(!d){v=w;break}}else d=!1;return v===-1?l?"/":".":l&&v===1?"//":n.slice(0,v)},basename(n,l){l!==void 0&&e(l,"ext"),e(n,"path");let v=0,d=-1,w=!0,k;if(l!==void 0&&l.length>0&&l.length<=n.length){if(l===n)return"";let M=l.length-1,y=-1;for(k=n.length-1;k>=0;--k){const D=n.charCodeAt(k);if(D===a){if(!w){v=k+1;break}}else y===-1&&(w=!1,y=k+1),M>=0&&(D===l.charCodeAt(M)?--M===-1&&(d=k):(M=-1,d=y))}return v===d?d=y:d===-1&&(d=n.length),n.slice(v,d)}for(k=n.length-1;k>=0;--k)if(n.charCodeAt(k)===a){if(!w){v=k+1;break}}else d===-1&&(w=!1,d=k+1);return d===-1?"":n.slice(v,d)},extname(n){e(n,"path");let l=-1,v=0,d=-1,w=!0,k=0;for(let M=n.length-1;M>=0;--M){const y=n.charCodeAt(M);if(y===a){if(!w){v=M+1;break}continue}d===-1&&(w=!1,d=M+1),y===f?l===-1?l=M:k!==1&&(k=1):l!==-1&&(k=-1)}return l===-1||d===-1||k===0||k===1&&l===d-1&&l===v+1?"":n.slice(l,d)},format:u.bind(null,"/"),parse(n){e(n,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return l;const v=n.charCodeAt(0)===a;let d;v?(l.root="/",d=1):d=0;let w=-1,k=0,M=-1,y=!0,D=n.length-1,p=0;for(;D>=d;--D){const S=n.charCodeAt(D);if(S===a){if(!y){k=D+1;break}continue}M===-1&&(y=!1,M=D+1),S===f?w===-1?w=D:p!==1&&(p=1):w!==-1&&(p=-1)}if(M!==-1){const S=k===0&&v?1:k;w===-1||p===0||p===1&&w===M-1&&w===k+1?l.base=l.name=n.slice(S,M):(l.name=n.slice(S,w),l.base=n.slice(S,M),l.ext=n.slice(w,M))}return k>0?l.dir=n.slice(0,k-1):v&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=E?t.$fc.normalize:t.$gc.normalize,t.$ic=E?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=E?t.$fc.join:t.$gc.join,t.$kc=E?t.$fc.resolve:t.$gc.resolve,t.$lc=E?t.$fc.relative:t.$gc.relative,t.$mc=E?t.$fc.dirname:t.$gc.dirname,t.$nc=E?t.$fc.basename:t.$gc.basename,t.$oc=E?t.$fc.extname:t.$gc.extname,t.$pc=E?t.$fc.format:t.$gc.format,t.$qc=E?t.$fc.parse:t.$gc.parse,t.$rc=E?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=E?t.$fc.sep:t.$gc.sep,t.$tc=E?t.$fc.delimiter:t.$gc.delimiter}),te(ie[18],se([0,1,65,17]),function(W,t,F,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,o=/^\//,N=/^\/\//;function f(d,w){if(!d.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!r.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!o.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(d,w){return!d&&!w?"file":d}function s(d,w){switch(d){case"https":case"http":case"file":w?w[0]!==A&&(w=A+w):w=A;break}return w}const h="",A="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(w){return w instanceof g?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,k,M,y,D,p=!1){typeof w=="object"?(this.scheme=w.scheme||h,this.authority=w.authority||h,this.path=w.path||h,this.query=w.query||h,this.fragment=w.fragment||h):(this.scheme=a(w,p),this.authority=k||h,this.path=s(this.scheme,M||h),this.query=y||h,this.fragment=D||h,f(this,p))}get fsPath(){return u(this,!1)}with(w){if(!w)return this;let{scheme:k,authority:M,path:y,query:D,fragment:p}=w;return k===void 0?k=this.scheme:k===null&&(k=h),M===void 0?M=this.authority:M===null&&(M=h),y===void 0?y=this.path:y===null&&(y=h),D===void 0?D=this.query:D===null&&(D=h),p===void 0?p=this.fragment:p===null&&(p=h),k===this.scheme&&M===this.authority&&y===this.path&&D===this.query&&p===this.fragment?this:new R(k,M,y,D,p)}static parse(w,k=!1){const M=b.exec(w);return M?new R(M[2]||h,v(M[4]||h),v(M[5]||h),v(M[7]||h),v(M[9]||h),k):new R(h,h,h,h,h)}static file(w){let k=h;if(P.$i&&(w=w.replace(/\\/g,A)),w[0]===A&&w[1]===A){const M=w.indexOf(A,2);M===-1?(k=w.substring(2),w=A):(k=w.substring(2,M),w=w.substring(M)||A)}return new R("file",k,w,h,h)}static from(w,k){return new R(w.scheme,w.authority,w.path,w.query,w.fragment,k)}static joinPath(w,...k){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return P.$i&&w.scheme==="file"?M=g.file(F.$fc.join(u(w,!0),...k)).path:M=F.$gc.join(w.path,...k),w.with({path:M})}toString(w=!1){return c(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof g)return w;{const k=new R(w);return k._formatted=w.external??null,k._fsPath=w._sep===E?w.fsPath??null:null,k}}else return w}}t.URI=g;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}t.$vc=e;const E=P.$i?1:void 0;class R extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(w=!1){return w?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=E),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const L={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function $(d,w,k){let M,y=-1;for(let D=0;D<d.length;D++){const p=d.charCodeAt(D);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||w&&p===47||k&&p===91||k&&p===93||k&&p===58)y!==-1&&(M+=encodeURIComponent(d.substring(y,D)),y=-1),M!==void 0&&(M+=d.charAt(D));else{M===void 0&&(M=d.substr(0,D));const S=L[p];S!==void 0?(y!==-1&&(M+=encodeURIComponent(d.substring(y,D)),y=-1),M+=S):y===-1&&(y=D)}}return y!==-1&&(M+=encodeURIComponent(d.substring(y))),M!==void 0?M:d}function m(d){let w;for(let k=0;k<d.length;k++){const M=d.charCodeAt(k);M===35||M===63?(w===void 0&&(w=d.substr(0,k)),w+=L[M]):w!==void 0&&(w+=d[k])}return w!==void 0?w:d}function u(d,w){let k;return d.authority&&d.path.length>1&&d.scheme==="file"?k=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?w?k=d.path.substr(1):k=d.path[1].toLowerCase()+d.path.substr(2):k=d.path,P.$i&&(k=k.replace(/\//g,"\\")),k}t.$wc=u;function c(d,w){const k=w?m:$;let M="",{scheme:y,authority:D,path:p,query:S,fragment:_}=d;if(y&&(M+=y,M+=":"),(D||y==="file")&&(M+=A,M+=A),D){let q=D.indexOf("@");if(q!==-1){const V=D.substr(0,q);D=D.substr(q+1),q=V.lastIndexOf(":"),q===-1?M+=k(V,!1,!1):(M+=k(V.substr(0,q),!1,!1),M+=":",M+=k(V.substr(q+1),!1,!0)),M+="@"}D=D.toLowerCase(),q=D.lastIndexOf(":"),q===-1?M+=k(D,!1,!0):(M+=k(D.substr(0,q),!1,!0),M+=D.substr(q))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const q=p.charCodeAt(1);q>=65&&q<=90&&(p=`/${String.fromCharCode(q+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const q=p.charCodeAt(0);q>=65&&q<=90&&(p=`${String.fromCharCode(q+32)}:${p.substr(2)}`)}M+=k(p,!0,!1)}return S&&(M+="?",M+=k(S,!1,!1)),_&&(M+="#",M+=w?_:$(_,!1,!1)),M}function n(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+n(d.substr(3)):d}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(d){return d.match(l)?d.replace(l,w=>n(w)):d}}),te(ie[70],se([0,1,3,11,10,14,17,7]),function(W,t,F,P,r,o,N,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let s=!1;function h(v){N.$o&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(v.message))}t.logOnceWebWorkerWarning=h;var A;(function(v){v[v.Request=0]="Request",v[v.Reply=1]="Reply",v[v.SubscribeEvent=2]="SubscribeEvent",v[v.Event=3]="Event",v[v.UnsubscribeEvent=4]="UnsubscribeEvent"})(A||(A={}));class b{constructor(d,w,k,M){this.vsWorker=d,this.req=w,this.method=k,this.args=M,this.type=0}}class g{constructor(d,w,k,M){this.vsWorker=d,this.seq=w,this.res=k,this.err=M,this.type=1}}class e{constructor(d,w,k,M){this.vsWorker=d,this.req=w,this.eventName=k,this.arg=M,this.type=2}}class E{constructor(d,w,k){this.vsWorker=d,this.req=w,this.event=k,this.type=3}}class R{constructor(d,w){this.vsWorker=d,this.req=w,this.type=4}}class L{constructor(d){this.a=-1,this.g=d,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(d){this.a=d}sendMessage(d,w){const k=String(++this.b);return new Promise((M,y)=>{this.c[k]={resolve:M,reject:y},this.o(new b(this.a,k,d,w))})}listen(d,w){let k=null;const M=new P.$5d({onWillAddFirstListener:()=>{k=String(++this.b),this.d.set(k,M),this.o(new e(this.a,k,d,w))},onDidRemoveLastListener:()=>{this.d.delete(k),this.o(new R(this.a,k)),k=null}});return M.event}handleMessage(d){!d||!d.vsWorker||this.a!==-1&&d.vsWorker!==this.a||this.h(d)}h(d){switch(d.type){case 1:return this.j(d);case 0:return this.k(d);case 2:return this.l(d);case 3:return this.m(d);case 4:return this.n(d)}}j(d){if(!this.c[d.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[d.seq];if(delete this.c[d.seq],d.err){let k=d.err;d.err.$isError&&(k=new Error,k.name=d.err.name,k.message=d.err.message,k.stack=d.err.stack),w.reject(k);return}w.resolve(d.res)}k(d){const w=d.req;this.g.handleMessage(d.method,d.args).then(M=>{this.o(new g(this.a,w,M,void 0))},M=>{M.detail instanceof Error&&(M.detail=(0,F.$3)(M.detail)),this.o(new g(this.a,w,void 0,(0,F.$3)(M)))})}l(d){const w=d.req,k=this.g.handleEvent(d.eventName,d.arg)(M=>{this.o(new E(this.a,w,M))});this.f.set(w,k)}m(d){if(!this.d.has(d.req)){console.warn("Got event for unknown req");return}this.d.get(d.req).fire(d.event)}n(d){if(!this.f.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(d.req).dispose(),this.f.delete(d.req)}o(d){const w=[];if(d.type===0)for(let k=0;k<d.args.length;k++)d.args[k]instanceof ArrayBuffer&&w.push(d.args[k]);else d.type===1&&d.res instanceof ArrayBuffer&&w.push(d.res);this.g.sendMessage(d,w)}}class $ extends r.$Tc{constructor(d,w,k){super();let M=null;this.a=this.B(d.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{M?.(q)})),this.c=new L({sendMessage:(q,V)=>{this.a.postMessage(q,V)},handleMessage:(q,V)=>{if(typeof k[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(k[q].apply(k,V))}catch(x){return Promise.reject(x)}},handleEvent:(q,V)=>{if(u(q)){const x=k[q].call(k,V);if(typeof x!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return x}if(m(q)){const x=k[q];if(typeof x!="function")throw new Error(`Missing event ${q} on main thread host.`);return x}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let y=null;const D=globalThis.require;typeof D<"u"&&typeof D.getConfig=="function"?y=D.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const p=(0,o.$Rn)(k);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(y)),w,p]);const S=(q,V)=>this.g(q,V),_=(q,V)=>this.c.listen(q,V);this.f=new Promise((q,V)=>{M=V,this.b.then(x=>{q(c(x,S,_))},x=>{V(x),this.h("Worker failed to load "+w,x)})})}getProxyObject(){return this.f}g(d,w){return new Promise((k,M)=>{this.b.then(()=>{this.c.sendMessage(d,w).then(k,M)},M)})}h(d,w){console.error(d),console.info(w)}}t.SimpleWorkerClient=$;function m(v){return v[0]==="o"&&v[1]==="n"&&f.$if(v.charCodeAt(2))}function u(v){return/^onDynamic/.test(v)&&f.$if(v.charCodeAt(9))}function c(v,d,w){const k=D=>function(){const p=Array.prototype.slice.call(arguments,0);return d(D,p)},M=D=>function(p){return w(D,p)},y={};for(const D of v){if(u(D)){y[D]=M(D);continue}if(m(D)){y[D]=w(D,void 0);continue}y[D]=k(D)}return y}class n{constructor(d,w){this.a=w,this.b=null,this.c=new L({sendMessage:(k,M)=>{d(k,M)},handleMessage:(k,M)=>this.d(k,M),handleEvent:(k,M)=>this.f(k,M)})}onmessage(d){this.c.handleMessage(d)}d(d,w){if(d===a)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this.b[d].apply(this.b,w))}catch(k){return Promise.reject(k)}}f(d,w){if(!this.b)throw new Error("Missing requestHandler");if(u(d)){const k=this.b[d].call(this.b,w);if(typeof k!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return k}if(m(d)){const k=this.b[d];if(typeof k!="function")throw new Error(`Missing event ${d} on request handler.`);return k}throw new Error(`Malformed event name ${d}`)}g(d,w,k,M){this.c.setWorkerId(d);const p=c(M,(S,_)=>this.c.sendMessage(S,_),(S,_)=>this.c.listen(S,_));return this.a?(this.b=this.a(p),Promise.resolve((0,o.$Rn)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy<"u"&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((S,_)=>{(globalThis.require||W)([k],V=>{if(this.b=V.create(p),!this.b){_(new Error("No RequestHandler!"));return}S((0,o.$Rn)(this.b))},_)}))}}t.SimpleWorkerServer=n;function l(v){return new n(v,null)}t.create=l}),te(ie[66],se([62,63]),function(W,t){return W.create("vs/editor/common/languages",t)}),te(ie[67],se([0,1,41,18,42,2,60,66]),function(W,t,F,P,r,o,N,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$Yt=t.$Xt=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTag=t.$Wt=t.$Vt=t.SymbolKinds=t.SymbolTag=t.$Ut=t.$Tt=t.SymbolKind=t.$St=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$Rt=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$Qt=t.$Pt=t.$Ot=void 0;class a{constructor(U,Y,X){this.offset=U,this.type=Y,this.language=X,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Ot=a;class s{constructor(U,Y){this.tokens=U,this.endState=Y,this._tokenizationResultBrand=void 0}}t.$Pt=s;class h{constructor(U,Y){this.tokens=U,this.endState=Y,this._encodedTokenizationResultBrand=void 0}}t.$Qt=h;var A;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(A||(t.CompletionItemKind=A={}));var b;(function(T){const U=new Map;U.set(0,F.$kk.symbolMethod),U.set(1,F.$kk.symbolFunction),U.set(2,F.$kk.symbolConstructor),U.set(3,F.$kk.symbolField),U.set(4,F.$kk.symbolVariable),U.set(5,F.$kk.symbolClass),U.set(6,F.$kk.symbolStruct),U.set(7,F.$kk.symbolInterface),U.set(8,F.$kk.symbolModule),U.set(9,F.$kk.symbolProperty),U.set(10,F.$kk.symbolEvent),U.set(11,F.$kk.symbolOperator),U.set(12,F.$kk.symbolUnit),U.set(13,F.$kk.symbolValue),U.set(15,F.$kk.symbolEnum),U.set(14,F.$kk.symbolConstant),U.set(15,F.$kk.symbolEnum),U.set(16,F.$kk.symbolEnumMember),U.set(17,F.$kk.symbolKeyword),U.set(27,F.$kk.symbolSnippet),U.set(18,F.$kk.symbolText),U.set(19,F.$kk.symbolColor),U.set(20,F.$kk.symbolFile),U.set(21,F.$kk.symbolReference),U.set(22,F.$kk.symbolCustomColor),U.set(23,F.$kk.symbolFolder),U.set(24,F.$kk.symbolTypeParameter),U.set(25,F.$kk.account),U.set(26,F.$kk.issues);function Y(ue){let i=U.get(ue);return i||(console.info("No codicon found for CompletionItemKind "+ue),i=F.$kk.symbolProperty),i}T.toIcon=Y;const X=new Map;X.set("method",0),X.set("function",1),X.set("constructor",2),X.set("field",3),X.set("variable",4),X.set("class",5),X.set("struct",6),X.set("interface",7),X.set("module",8),X.set("property",9),X.set("event",10),X.set("operator",11),X.set("unit",12),X.set("value",13),X.set("constant",14),X.set("enum",15),X.set("enum-member",16),X.set("enumMember",16),X.set("keyword",17),X.set("snippet",27),X.set("text",18),X.set("color",19),X.set("file",20),X.set("reference",21),X.set("customcolor",22),X.set("folder",23),X.set("type-parameter",24),X.set("typeParameter",24),X.set("account",25),X.set("issue",26);function re(ue,i){let de=X.get(ue);return typeof de>"u"&&!i&&(de=9),de}T.fromString=re})(b||(t.CompletionItemKinds=b={}));var g;(function(T){T[T.Deprecated=1]="Deprecated"})(g||(t.CompletionItemTag=g={}));var e;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var E;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(t.CompletionTriggerKind=E={}));var R;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(R||(t.InlineCompletionTriggerKind=R={}));class L{constructor(U,Y,X,re){this.range=U,this.text=Y,this.completionKind=X,this.isSnippetText=re}equals(U){return o.$6s.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}t.$Rt=L;var $;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})($||(t.CodeActionTriggerType=$={}));var m;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(m||(t.SignatureHelpTriggerKind=m={}));var u;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(u||(t.DocumentHighlightKind=u={}));function c(T){return T&&P.URI.isUri(T.uri)&&o.$6s.isIRange(T.range)&&(o.$6s.isIRange(T.originSelectionRange)||o.$6s.isIRange(T.targetSelectionRange))}t.$St=c;var n;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(n||(t.SymbolKind=n={})),t.$Tt={17:(0,f.localize)(0,null),16:(0,f.localize)(1,null),4:(0,f.localize)(2,null),13:(0,f.localize)(3,null),8:(0,f.localize)(4,null),9:(0,f.localize)(5,null),21:(0,f.localize)(6,null),23:(0,f.localize)(7,null),7:(0,f.localize)(8,null),0:(0,f.localize)(9,null),11:(0,f.localize)(10,null),10:(0,f.localize)(11,null),19:(0,f.localize)(12,null),5:(0,f.localize)(13,null),1:(0,f.localize)(14,null),2:(0,f.localize)(15,null),20:(0,f.localize)(16,null),15:(0,f.localize)(17,null),18:(0,f.localize)(18,null),24:(0,f.localize)(19,null),3:(0,f.localize)(20,null),6:(0,f.localize)(21,null),14:(0,f.localize)(22,null),22:(0,f.localize)(23,null),25:(0,f.localize)(24,null),12:(0,f.localize)(25,null)};function l(T,U){return(0,f.localize)(26,null,T,t.$Tt[U])}t.$Ut=l;var v;(function(T){T[T.Deprecated=1]="Deprecated"})(v||(t.SymbolTag=v={}));var d;(function(T){const U=new Map;U.set(0,F.$kk.symbolFile),U.set(1,F.$kk.symbolModule),U.set(2,F.$kk.symbolNamespace),U.set(3,F.$kk.symbolPackage),U.set(4,F.$kk.symbolClass),U.set(5,F.$kk.symbolMethod),U.set(6,F.$kk.symbolProperty),U.set(7,F.$kk.symbolField),U.set(8,F.$kk.symbolConstructor),U.set(9,F.$kk.symbolEnum),U.set(10,F.$kk.symbolInterface),U.set(11,F.$kk.symbolFunction),U.set(12,F.$kk.symbolVariable),U.set(13,F.$kk.symbolConstant),U.set(14,F.$kk.symbolString),U.set(15,F.$kk.symbolNumber),U.set(16,F.$kk.symbolBoolean),U.set(17,F.$kk.symbolArray),U.set(18,F.$kk.symbolObject),U.set(19,F.$kk.symbolKey),U.set(20,F.$kk.symbolNull),U.set(21,F.$kk.symbolEnumMember),U.set(22,F.$kk.symbolStruct),U.set(23,F.$kk.symbolEvent),U.set(24,F.$kk.symbolOperator),U.set(25,F.$kk.symbolTypeParameter);function Y(X){let re=U.get(X);return re||(console.info("No codicon found for SymbolKind "+X),re=F.$kk.symbolProperty),re}T.toIcon=Y})(d||(t.SymbolKinds=d={}));class w{static asEditOperation(U){return r.$7s.replace(o.$6s.lift(U.range),U.text)}}t.$Vt=w;class k{static{this.Comment=new k("comment")}static{this.Imports=new k("imports")}static{this.Region=new k("region")}static fromValue(U){switch(U){case"comment":return k.Comment;case"imports":return k.Imports;case"region":return k.Region}return new k(U)}constructor(U){this.value=U}}t.$Wt=k;var M;(function(T){T[T.AIGenerated=1]="AIGenerated"})(M||(t.NewSymbolNameTag=M={}));var y;(function(T){function U(Y){return!Y||typeof Y!="object"?!1:typeof Y.id=="string"&&typeof Y.title=="string"}T.is=U})(y||(t.Command=y={}));var D;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(D||(t.CommentThreadCollapsibleState=D={}));var p;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(p||(t.CommentThreadState=p={}));var S;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(S||(t.CommentMode=S={}));var _;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(_||(t.CommentState=_={}));var q;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(q||(t.InlayHintKind=q={}));class V{constructor(U){this.b=U,this.a=null}dispose(){this.a&&this.a.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$Xt=V,t.$Yt=new N.$Et;var x;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(x||(t.ExternalUriOpenerPriority=x={}));var ee;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(ee||(t.InlineEditTriggerKind=ee={}))}),te(ie[68],se([0,1,24,11,37,18,5,2,43,67,59]),function(W,t,F,P,r,o,N,f,a,s,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$71=t.$61=void 0;class A{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,E){return(0,r.$fr)(e,E)}}t.$61=A;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:F.$ce,Emitter:P.$5d,KeyCode:h.KeyCode,KeyMod:A,Position:N.$5s,Range:f.$6s,Selection:a.$8s,SelectionDirection:h.SelectionDirection,MarkerSeverity:h.MarkerSeverity,MarkerTag:h.MarkerTag,Uri:o.URI,Token:s.$Ot}}t.$71=b}),te(ie[71],se([0,1,25,18,5,2,56,29,52,53,68,23,58,33,50,14,3,51]),function(W,t,F,P,r,o,N,f,a,s,h,A,b,g,e,E,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class $ extends N.$xv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(n){const l=[];for(let v=0;v<this.f.length;v++){const d=this.f[v],w=this.offsetAt(new r.$5s(v+1,1)),k=d.matchAll(n);for(const M of k)(M.index||M.index===0)&&(M.index=M.index+w),l.push(M)}return l}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(n){return this.f[n-1]}getWordAtPosition(n,l){const v=(0,f.$Is)(n.column,(0,f.$Gs)(l),this.f[n.lineNumber-1],0);return v?new o.$6s(n.lineNumber,v.startColumn,n.lineNumber,v.endColumn):null}getWordUntilPosition(n,l){const v=this.getWordAtPosition(n,l);return v?{word:this.f[n.lineNumber-1].substring(v.startColumn-1,n.column-1),startColumn:v.startColumn,endColumn:n.column}:{word:"",startColumn:n.column,endColumn:n.column}}words(n){const l=this.f,v=this.q.bind(this);let d=0,w="",k=0,M=[];return{*[Symbol.iterator](){for(;;)if(k<M.length){const y=w.substring(M[k].start,M[k].end);k+=1,yield y}else if(d<l.length)w=l[d],M=v(w,n),k=0,d+=1;else break}}}getLineWords(n,l){const v=this.f[n-1],d=this.q(v,l),w=[];for(const k of d)w.push({word:v.substring(k.start,k.end),startColumn:k.start+1,endColumn:k.end+1});return w}q(n,l){const v=[];let d;for(l.lastIndex=0;(d=l.exec(n))&&d[0].length!==0;)v.push({start:d.index,end:d.index+d[0].length});return v}getValueInRange(n){if(n=this.r(n),n.startLineNumber===n.endLineNumber)return this.f[n.startLineNumber-1].substring(n.startColumn-1,n.endColumn-1);const l=this.g,v=n.startLineNumber-1,d=n.endLineNumber-1,w=[];w.push(this.f[v].substring(n.startColumn-1));for(let k=v+1;k<d;k++)w.push(this.f[k]);return w.push(this.f[d].substring(0,n.endColumn-1)),w.join(l)}offsetAt(n){return n=this.s(n),this.l(),this.j.getPrefixSum(n.lineNumber-2)+(n.column-1)}positionAt(n){n=Math.floor(n),n=Math.max(0,n),this.l();const l=this.j.getIndexOf(n),v=this.f[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,v)}}r(n){const l=this.s({lineNumber:n.startLineNumber,column:n.startColumn}),v=this.s({lineNumber:n.endLineNumber,column:n.endColumn});return l.lineNumber!==n.startLineNumber||l.column!==n.startColumn||v.lineNumber!==n.endLineNumber||v.column!==n.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:v.lineNumber,endColumn:v.column}:n}s(n){if(!r.$5s.isIPosition(n))throw new Error("bad position");let{lineNumber:l,column:v}=n,d=!1;if(l<1)l=1,v=1,d=!0;else if(l>this.f.length)l=this.f.length,v=this.f[l-1].length+1,d=!0;else{const w=this.f[l-1].length+1;v<1?(v=1,d=!0):v>w&&(v=w,d=!0)}return d?{lineNumber:l,column:v}:n}}class m{constructor(n,l){this.d=n,this.f=Object.create(null),this.g=l,this.h=null}dispose(){this.f=Object.create(null)}j(n){return this.f[n]}k(){const n=[];return Object.keys(this.f).forEach(l=>n.push(this.f[l])),n}acceptNewModel(n){this.f[n.url]=new $(P.URI.parse(n.url),n.lines,n.EOL,n.versionId)}acceptModelChanged(n,l){if(!this.f[n])return;this.f[n].onEvents(l)}acceptRemovedModel(n){this.f[n]&&delete this.f[n]}async computeUnicodeHighlights(n,l,v){const d=this.j(n);return d?b.$11.computeUnicodeHighlights(d,l,v):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(n,l,v,d){const w=this.j(n),k=this.j(l);return!w||!k?null:m.l(w,k,v,d)}static l(n,l,v,d){const w=d==="advanced"?e.$q2.getDefault():e.$q2.getLegacy(),k=n.getLinesContent(),M=l.getLinesContent(),y=w.computeDiff(k,M,v),D=y.changes.length>0?!1:this.n(n,l);function p(S){return S.map(_=>[_.original.startLineNumber,_.original.endLineNumberExclusive,_.modified.startLineNumber,_.modified.endLineNumberExclusive,_.innerChanges?.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])])}return{identical:D,quitEarly:y.hitTimeout,changes:p(y.changes),moves:y.moves.map(S=>[S.lineRangeMapping.original.startLineNumber,S.lineRangeMapping.original.endLineNumberExclusive,S.lineRangeMapping.modified.startLineNumber,S.lineRangeMapping.modified.endLineNumberExclusive,p(S.changes)])}}static n(n,l){const v=n.getLineCount(),d=l.getLineCount();if(v!==d)return!1;for(let w=1;w<=v;w++){const k=n.getLineContent(w),M=l.getLineContent(w);if(k!==M)return!1}return!0}async computeDirtyDiff(n,l,v){const d=this.j(n),w=this.j(l);if(!d||!w)return null;const k=d.getLinesContent(),M=w.getLinesContent();return new g.$kt(k,M,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:v,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(n,l,v){const d=this.j(n);if(!d)return l;const w=[];let k;l=l.slice(0).sort((y,D)=>{if(y.range&&D.range)return o.$6s.compareRangesUsingStarts(y.range,D.range);const p=y.range?0:1,S=D.range?0:1;return p-S});let M=0;for(let y=1;y<l.length;y++)o.$6s.getEndPosition(l[M].range).equals(o.$6s.getStartPosition(l[y].range))?(l[M].range=o.$6s.fromPositions(o.$6s.getStartPosition(l[M].range),o.$6s.getEndPosition(l[y].range)),l[M].text+=l[y].text):(M++,l[M]=l[y]);l.length=M+1;for(let{range:y,text:D,eol:p}of l){if(typeof p=="number"&&(k=p),o.$6s.isEmpty(y)&&!D)continue;const S=d.getValueInRange(y);if(D=D.replace(/\r\n|\n|\r/g,d.eol),S===D)continue;if(Math.max(D.length,S.length)>m.o){w.push({range:y,text:D});continue}const _=(0,F.$$s)(S,D,v),q=d.offsetAt(o.$6s.lift(y).getStartPosition());for(const V of _){const x=d.positionAt(q+V.originalStart),ee=d.positionAt(q+V.originalStart+V.originalLength),T={text:D.substr(V.modifiedStart,V.modifiedLength),range:{startLineNumber:x.lineNumber,startColumn:x.column,endLineNumber:ee.lineNumber,endColumn:ee.column}};d.getValueInRange(T.range)!==T.text&&w.push(T)}}return typeof k=="number"&&w.push({eol:k,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}computeHumanReadableDiff(n,l,v){const d=this.j(n);if(!d)return l;const w=[];let k;l=l.slice(0).sort((M,y)=>{if(M.range&&y.range)return o.$6s.compareRangesUsingStarts(M.range,y.range);const D=M.range?0:1,p=y.range?0:1;return D-p});for(let{range:M,text:y,eol:D}of l){let x=function(T,U){return new r.$5s(T.lineNumber+U.lineNumber-1,U.lineNumber===1?T.column+U.column-1:U.column)},ee=function(T,U){const Y=[];for(let X=U.startLineNumber;X<=U.endLineNumber;X++){const re=T[X-1];X===U.startLineNumber&&X===U.endLineNumber?Y.push(re.substring(U.startColumn-1,U.endColumn-1)):X===U.startLineNumber?Y.push(re.substring(U.startColumn-1)):X===U.endLineNumber?Y.push(re.substring(0,U.endColumn-1)):Y.push(re)}return Y};if(typeof D=="number"&&(k=D),o.$6s.isEmpty(M)&&!y)continue;const p=d.getValueInRange(M);if(y=y.replace(/\r\n|\n|\r/g,d.eol),p===y)continue;if(Math.max(y.length,p.length)>m.o){w.push({range:M,text:y});continue}const S=p.split(/\r\n|\n|\r/),_=y.split(/\r\n|\n|\r/),q=e.$q2.getDefault().computeDiff(S,_,v),V=o.$6s.lift(M).getStartPosition();for(const T of q.changes)if(T.innerChanges)for(const U of T.innerChanges)w.push({range:o.$6s.fromPositions(x(V,U.originalRange.getStartPosition()),x(V,U.originalRange.getEndPosition())),text:ee(_,U.modifiedRange).join(d.eol)});else throw new R.$cb("The experimental diff algorithm always produces inner changes")}return typeof k=="number"&&w.push({eol:k,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(n){const l=this.j(n);return l?(0,a.$41)(l):null}async computeDefaultDocumentColors(n){const l=this.j(n);return l?(0,L.$r2)(l):null}static{this.p=1e4}async textualSuggest(n,l,v,d){const w=new A.$1d,k=new RegExp(v,d),M=new Set;e:for(const y of n){const D=this.j(y);if(D){for(const p of D.words(k))if(!(p===l||!isNaN(Number(p)))&&(M.add(p),M.size>m.p))break e}}return{words:Array.from(M),duration:w.elapsed()}}async computeWordRanges(n,l,v,d){const w=this.j(n);if(!w)return Object.create(null);const k=new RegExp(v,d),M=Object.create(null);for(let y=l.startLineNumber;y<l.endLineNumber;y++){const D=w.getLineWords(y,k);for(const p of D){if(!isNaN(Number(p.word)))continue;let S=M[p.word];S||(S=[],M[p.word]=S),S.push({startLineNumber:y,startColumn:p.startColumn,endLineNumber:y,endColumn:p.endColumn})}}return M}async navigateValueSet(n,l,v,d,w){const k=this.j(n);if(!k)return null;const M=new RegExp(d,w);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const y=k.getValueInRange(l),D=k.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},M);if(!D)return null;const p=k.getValueInRange(D);return s.$51.INSTANCE.navigateValueSet(l,y,D,p,v)}loadForeignModule(n,l,v){const d=(M,y)=>this.d.fhr(M,y),k={host:(0,E.$Sn)(v,d),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(k,l),Promise.resolve((0,E.$Rn)(this.h))):new Promise((M,y)=>{W([n],D=>{this.h=D.create(k,l),M((0,E.$Rn)(this.h))},y)})}fmr(n,l){if(!this.h||typeof this.h[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this.h[n].apply(this.h,l))}catch(v){return Promise.reject(v)}}}t.EditorSimpleWorker=m;function u(c){return new m(c,null)}t.create=u,typeof importScripts=="function"&&(globalThis.monaco=(0,h.$71)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/00124e9e5830e3efc897db71c781899f8a676295/core/vs/base/worker/workerMain.js.map
