/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/remote/common/remoteHosts","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ce=function(Y){for(var e=[],S=0,D=Y.length;S<D;S++)e[S]=ae[Y[S]];return e};define(ae[135],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function S(p,k,u){const f=D(p,k);if(f!==-1)return p[f]}e.$fb=S;function D(p,k,u=p.length-1){for(let f=u;f>=0;f--){const d=p[f];if(k(d))return f}return-1}e.$gb=D;function s(p,k){const u=M(p,k);return u===-1?void 0:p[u]}e.$hb=s;function M(p,k,u=0,f=p.length){let d=u,$=f;for(;d<$;){const a=Math.floor((d+$)/2);k(p[a])?d=a+1:$=a}return d-1}e.$ib=M;function A(p,k){const u=P(p,k);return u===p.length?void 0:p[u]}e.$jb=A;function P(p,k,u=0,f=p.length){let d=u,$=f;for(;d<$;){const a=Math.floor((d+$)/2);k(p[a])?$=a:d=a+1}return d}e.$kb=P;function g(p,k,u=0,f=p.length){const d=P(p,k,u,f);return d===p.length?-1:d}e.$lb=g;class l{static{this.assertInvariants=!1}constructor(k){this.e=k,this.c=0}findLastMonotonous(k){if(l.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!k(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=k}const u=M(this.e,k,this.c);return this.c=u+1,u===-1?void 0:this.e[u]}}e.$mb=l;function w(p,k){if(p.length===0)return;let u=p[0];for(let f=1;f<p.length;f++){const d=p[f];k(d,u)>0&&(u=d)}return u}e.$nb=w;function v(p,k){if(p.length===0)return;let u=p[0];for(let f=1;f<p.length;f++){const d=p[f];k(d,u)>=0&&(u=d)}return u}e.$ob=v;function y(p,k){return w(p,(u,f)=>-k(u,f))}e.$pb=y;function h(p,k){if(p.length===0)return-1;let u=0;for(let f=1;f<p.length;f++){const d=p[f];k(d,p[u])>0&&(u=f)}return u}e.$qb=h;function m(p,k){for(const u of p){const f=k(u);if(f!==void 0)return f}}e.$rb=m}),define(ae[136],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function S(A,P){const g=Object.create(null);for(const l of A){const w=P(l);let v=g[w];v||(v=g[w]=[]),v.push(l)}return g}e.$K=S;function D(A,P){const g=[],l=[];for(const w of A)P.has(w)||g.push(w);for(const w of P)A.has(w)||l.push(w);return{removed:g,added:l}}e.$L=D;function s(A,P){const g=[],l=[];for(const[w,v]of A)P.has(w)||g.push(v);for(const[w,v]of P)A.has(w)||l.push(v);return{removed:g,added:l}}e.$M=s;function M(A,P){const g=new Set;for(const l of P)A.has(l)&&g.add(l);return g}e.$N=M}),define(ae[137],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.$wt=e.$vt=e.$ut=void 0;function S(P,g){const l=Math.pow(10,g);return Math.round(P*l)/l}class D{constructor(g,l,w,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=S(Math.max(Math.min(1,v),0),3)}static equals(g,l){return g.r===l.r&&g.g===l.g&&g.b===l.b&&g.a===l.a}}e.$ut=D;class s{constructor(g,l,w,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=S(Math.max(Math.min(1,l),0),3),this.l=S(Math.max(Math.min(1,w),0),3),this.a=S(Math.max(Math.min(1,v),0),3)}static equals(g,l){return g.h===l.h&&g.s===l.s&&g.l===l.l&&g.a===l.a}static fromRGBA(g){const l=g.r/255,w=g.g/255,v=g.b/255,y=g.a,h=Math.max(l,w,v),m=Math.min(l,w,v);let p=0,k=0;const u=(m+h)/2,f=h-m;if(f>0){switch(k=Math.min(u<=.5?f/(2*u):f/(2-2*u),1),h){case l:p=(w-v)/f+(w<v?6:0);break;case w:p=(v-l)/f+2;break;case v:p=(l-w)/f+4;break}p*=60,p=Math.round(p)}return new s(p,k,u,y)}static i(g,l,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?g+(l-g)*6*w:w<1/2?l:w<2/3?g+(l-g)*(2/3-w)*6:g}static toRGBA(g){const l=g.h/360,{s:w,l:v,a:y}=g;let h,m,p;if(w===0)h=m=p=v;else{const k=v<.5?v*(1+w):v+w-v*w,u=2*v-k;h=s.i(u,k,l+1/3),m=s.i(u,k,l),p=s.i(u,k,l-1/3)}return new D(Math.round(h*255),Math.round(m*255),Math.round(p*255),y)}}e.$vt=s;class M{constructor(g,l,w,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=S(Math.max(Math.min(1,l),0),3),this.v=S(Math.max(Math.min(1,w),0),3),this.a=S(Math.max(Math.min(1,v),0),3)}static equals(g,l){return g.h===l.h&&g.s===l.s&&g.v===l.v&&g.a===l.a}static fromRGBA(g){const l=g.r/255,w=g.g/255,v=g.b/255,y=Math.max(l,w,v),h=Math.min(l,w,v),m=y-h,p=y===0?0:m/y;let k;return m===0?k=0:y===l?k=((w-v)/m%6+6)%6:y===w?k=(v-l)/m+2:k=(l-w)/m+4,new M(Math.round(k*60),p,y,g.a)}static toRGBA(g){const{h:l,s:w,v,a:y}=g,h=v*w,m=h*(1-Math.abs(l/60%2-1)),p=v-h;let[k,u,f]=[0,0,0];return l<60?(k=h,u=m):l<120?(k=m,u=h):l<180?(u=h,f=m):l<240?(u=m,f=h):l<300?(k=m,f=h):l<=360&&(k=h,f=m),k=Math.round((k+p)*255),u=Math.round((u+p)*255),f=Math.round((f+p)*255),new D(k,u,f,y)}}e.$wt=M;class A{static fromHex(g){return A.Format.CSS.parseHex(g)||A.red}static equals(g,l){return!g&&!l?!0:!g||!l?!1:g.equals(l)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(g){if(g)if(g instanceof D)this.rgba=g;else if(g instanceof s)this.i=g,this.rgba=s.toRGBA(g);else if(g instanceof M)this.j=g,this.rgba=M.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(g){return!!g&&D.equals(this.rgba,g.rgba)&&s.equals(this.hsla,g.hsla)&&M.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=A.k(this.rgba.r),l=A.k(this.rgba.g),w=A.k(this.rgba.b),v=.2126*g+.7152*l+.0722*w;return S(v,4)}static k(g){const l=g/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(g){const l=this.getRelativeLuminance(),w=g.getRelativeLuminance();return l>w?(l+.05)/(w+.05):(w+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const l=this.getRelativeLuminance(),w=g.getRelativeLuminance();return l>w}isDarkerThan(g){const l=this.getRelativeLuminance(),w=g.getRelativeLuminance();return l<w}lighten(g){return new A(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new A(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:l,g:w,b:v,a:y}=this.rgba;return new A(new D(l,w,v,y*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const l=g.rgba,w=this.rgba.a,v=l.a,y=w+v*(1-w);if(y<1e-6)return A.transparent;const h=this.rgba.r*w/y+l.r*v*(1-w)/y,m=this.rgba.g*w/y+l.g*v*(1-w)/y,p=this.rgba.b*w/y+l.b*v*(1-w)/y;return new A(new D(h,m,p,y))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:l,g:w,b:v,a:y}=this.rgba;return new A(new D(g.rgba.r-y*(g.rgba.r-l),g.rgba.g-y*(g.rgba.g-w),g.rgba.b-y*(g.rgba.b-v),1))}flatten(...g){const l=g.reduceRight((w,v)=>A.o(v,w));return A.o(this,l)}static o(g,l){const w=1-g.rgba.a;return new A(new D(w*l.rgba.r+g.rgba.a*g.rgba.r,w*l.rgba.g+g.rgba.a*g.rgba.g,w*l.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(g,l,w){if(g.isLighterThan(l))return g;w=w||.5;const v=g.getRelativeLuminance(),y=l.getRelativeLuminance();return w=w*(y-v)/y,g.lighten(w)}static getDarkerColor(g,l,w){if(g.isDarkerThan(l))return g;w=w||.5;const v=g.getRelativeLuminance(),y=l.getRelativeLuminance();return w=w*(v-y)/v,g.darken(w)}static{this.white=new A(new D(255,255,255,1))}static{this.black=new A(new D(0,0,0,1))}static{this.red=new A(new D(255,0,0,1))}static{this.blue=new A(new D(0,0,255,1))}static{this.green=new A(new D(0,255,0,1))}static{this.cyan=new A(new D(0,255,255,1))}static{this.lightgrey=new A(new D(211,211,211,1))}static{this.transparent=new A(new D(0,0,0,0))}}e.$xt=A,function(P){let g;(function(l){let w;(function(v){function y(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}v.formatRGB=y;function h(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=h;function m(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}v.formatHSL=m;function p(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=p;function k(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function u(t){return`#${k(t.rgba.r)}${k(t.rgba.g)}${k(t.rgba.b)}`}v.formatHex=u;function f(t,o=!1){return o&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${k(t.rgba.r)}${k(t.rgba.g)}${k(t.rgba.b)}${k(Math.round(t.rgba.a*255))}`}v.formatHexA=f;function d(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}v.format=d;function $(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),n=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new P(new D(r,i,n,1))}if(o===9){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),n=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),c=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new P(new D(r,i,n,c/255))}if(o===4){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),n=a(t.charCodeAt(3));return new P(new D(16*r+r,16*i+i,16*n+n))}if(o===5){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),n=a(t.charCodeAt(3)),c=a(t.charCodeAt(4));return new P(new D(16*r+r,16*i+i,16*n+n,(16*c+c)/255))}return null}v.parseHex=$;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=l.CSS||(l.CSS={}))})(g=P.Format||(P.Format={}))}(A||(e.$xt=A={}))}),define(ae[50],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Jh=e.$Ih=void 0;function S(A){return(P,g,l)=>{let w=null,v=null;if(typeof l.value=="function"?(w="value",v=l.value):typeof l.get=="function"&&(w="get",v=l.get),!v)throw new Error("not supported");l[w]=A(v,g)}}function D(A,P,g){let l=null,w=null;if(typeof g.value=="function"?(l="value",w=g.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(l="get",w=g.get),!w)throw new Error("not supported");const v=`$memoize$${P}`;g[l]=function(...y){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,y)}),this[v]}}e.$Ih=D;function s(A,P,g){return S((l,w)=>{const v=`$debounce$${w}`,y=`$debounce$result$${w}`;return function(...h){this[y]||(this[y]=g?g():void 0),clearTimeout(this[v]),P&&(this[y]=P(this[y],...h),h=[this[y]]),this[v]=setTimeout(()=>{l.apply(this,h),this[y]=g?g():void 0},A)}})}e.$Jh=s;function M(A,P,g){return S((l,w)=>{const v=`$throttle$timer$${w}`,y=`$throttle$result$${w}`,h=`$throttle$lastRun$${w}`,m=`$throttle$pending$${w}`;return function(...p){if(this[y]||(this[y]=g?g():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...p)),this[m])return;const k=this[h]+A;k<=Date.now()?(this[h]=Date.now(),l.apply(this,[this[y]]),this[y]=g?g():void 0):(this[m]=!0,this[v]=setTimeout(()=>{this[m]=!1,this[h]=Date.now(),l.apply(this,[this[y]]),this[y]=g?g():void 0},k-Date.now()))}})}e.$Kh=M}),define(ae[14],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class S{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?d.isErrorNoTelemetry(t)?new d(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=S,e.$X=new S;function D(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=D;function s(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function M(a){l(a)||e.$X.onUnexpectedError(a)}e.$1=M;function A(a){l(a)||e.$X.onUnexpectedExternalError(a)}e.$2=A;function P(a){if(a instanceof Error){const{name:t,message:o}=a,r=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:d.isErrorNoTelemetry(a)}}return a}e.$3=P;const g="Canceled";function l(a){return a instanceof w?!0:a instanceof Error&&a.name===g&&a.message===g}e.$4=l;class w extends Error{constructor(){super(g),this.name=this.message}}e.$5=w;function v(){const a=new Error(g);return a.name=a.message,a}e.$6=v;function y(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=y;function h(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=h;class m extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=m;function p(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=p;class k extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=k;class u extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=u;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class d extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof d)return t;const o=new d;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=d;class $ extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}e.$cb=$}),define(ae[22],ce([0,1,14,135]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(N,Q=0){return N[N.length-(1+Q)]}e.$sb=s;function M(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.$tb=M;function A(N,Q,H=(_,z)=>_===z){if(N===Q)return!0;if(!N||!Q||N.length!==Q.length)return!1;for(let _=0,z=N.length;_<z;_++)if(!H(N[_],Q[_]))return!1;return!0}e.$ub=A;function P(N,Q){const H=N.length-1;Q<H&&(N[Q]=N[H]),N.pop()}e.$vb=P;function g(N,Q,H){return l(N.length,_=>H(N[_],Q))}e.$wb=g;function l(N,Q){let H=0,_=N-1;for(;H<=_;){const z=(H+_)/2|0,ee=Q(z);if(ee<0)H=z+1;else if(ee>0)_=z-1;else return z}return-(H+1)}e.$xb=l;function w(N,Q,H){if(N=N|0,N>=Q.length)throw new TypeError("invalid index");const _=Q[Math.floor(Q.length*Math.random())],z=[],ee=[],ie=[];for(const de of Q){const me=H(de,_);me<0?z.push(de):me>0?ee.push(de):ie.push(de)}return N<z.length?w(N,z,H):N<z.length+ie.length?ie[0]:w(N-(z.length+ie.length),ee,H)}e.$yb=w;function v(N,Q){const H=[];let _;for(const z of N.slice(0).sort(Q))!_||Q(_[0],z)!==0?(_=[z],H.push(_)):_.push(z);return H}e.$zb=v;function*y(N,Q){let H,_;for(const z of N)_!==void 0&&Q(_,z)?H.push(z):(H&&(yield H),H=[z]),_=z;H&&(yield H)}e.$Ab=y;function h(N,Q){for(let H=0;H<=N.length;H++)Q(H===0?void 0:N[H-1],H===N.length?void 0:N[H])}e.$Bb=h;function m(N,Q){for(let H=0;H<N.length;H++)Q(H===0?void 0:N[H-1],N[H],H+1===N.length?void 0:N[H+1])}e.$Cb=m;function p(N,Q,H){const _=[];function z(de,me,Ee){if(me===0&&Ee.length===0)return;const Pe=_[_.length-1];Pe&&Pe.start+Pe.deleteCount===de?(Pe.deleteCount+=me,Pe.toInsert.push(...Ee)):_.push({start:de,deleteCount:me,toInsert:Ee})}let ee=0,ie=0;for(;;){if(ee===N.length){z(ee,0,Q.slice(ie));break}if(ie===Q.length){z(ee,N.length-ee,[]);break}const de=N[ee],me=Q[ie],Ee=H(de,me);Ee===0?(ee+=1,ie+=1):Ee<0?(z(ee,1,[]),ee+=1):Ee>0&&(z(ee,0,[me]),ie+=1)}return _}e.$Db=p;function k(N,Q,H){const _=p(N,Q,H),z=[],ee=[];for(const ie of _)z.push(...N.slice(ie.start,ie.start+ie.deleteCount)),ee.push(...ie.toInsert);return{removed:z,added:ee}}e.$Eb=k;function u(N,Q,H){if(H===0)return[];const _=N.slice(0,H).sort(Q);return d(N,Q,_,H,N.length),_}e.top=u;function f(N,Q,H,_,z){return H===0?Promise.resolve([]):new Promise((ee,ie)=>{(async()=>{const de=N.length,me=N.slice(0,H).sort(Q);for(let Ee=H,Pe=Math.min(H+_,de);Ee<de;Ee=Pe,Pe=Math.min(Pe+_,de)){if(Ee>H&&await new Promise(Le=>setTimeout(Le)),z&&z.isCancellationRequested)throw new S.$5;d(N,Q,me,Ee,Pe)}return me})().then(ee,ie)})}e.$Gb=f;function d(N,Q,H,_,z){for(const ee=H.length;_<z;_++){const ie=N[_];if(Q(ie,H[ee-1])<0){H.pop();const de=(0,D.$kb)(H,me=>Q(ie,me)<0);H.splice(de,0,ie)}}}function $(N){return N.filter(Q=>!!Q)}e.$Hb=$;function a(N){let Q=0;for(let H=0;H<N.length;H++)N[H]&&(N[Q]=N[H],Q+=1);N.length=Q}e.$Ib=a;function t(N,Q,H){N.splice(H,0,N.splice(Q,1)[0])}e.$Jb=t;function o(N){return!Array.isArray(N)||N.length===0}e.$Kb=o;function r(N){return Array.isArray(N)&&N.length>0}e.$Lb=r;function i(N,Q=H=>H){const H=new Set;return N.filter(_=>{const z=Q(_);return H.has(z)?!1:(H.add(z),!0)})}e.$Mb=i;function n(N){const Q=new Set;return H=>{const _=N(H);return Q.has(_)?!1:(Q.add(_),!0)}}e.$Nb=n;function c(N,Q){return N.length>0?N[0]:Q}e.$Ob=c;function b(N,Q){return N.length>0?N[N.length-1]:Q}e.$Pb=b;function R(N,Q,H=(_,z)=>_===z){let _=0;for(let z=0,ee=Math.min(N.length,Q.length);z<ee&&H(N[z],Q[z]);z++)_++;return _}e.$Qb=R;function I(N){return[].concat(...N)}e.$Rb=I;function E(N,Q){let H=typeof Q=="number"?N:0;typeof Q=="number"?H=N:(H=0,Q=N);const _=[];if(H<=Q)for(let z=H;z<Q;z++)_.push(z);else for(let z=H;z>Q;z--)_.push(z);return _}e.$Sb=E;function C(N,Q,H){return N.reduce((_,z)=>(_[Q(z)]=H?H(z):z,_),Object.create(null))}e.$Tb=C;function j(N,Q){return N.push(Q),()=>U(N,Q)}e.$Ub=j;function U(N,Q){const H=N.indexOf(Q);if(H>-1)return N.splice(H,1),Q}e.$Vb=U;function F(N,Q,H){const _=N.slice(0,Q),z=N.slice(Q);return _.concat(H,z)}e.$Wb=F;function V(N,Q){let H;if(typeof Q=="number"){let _=Q;H=()=>{const z=Math.sin(_++)*179426549;return z-Math.floor(z)}}else H=Math.random;for(let _=N.length-1;_>0;_-=1){const z=Math.floor(H()*(_+1)),ee=N[_];N[_]=N[z],N[z]=ee}}e.$Xb=V;function J(N,Q){const H=N.indexOf(Q);H>-1&&(N.splice(H,1),N.unshift(Q))}e.$Yb=J;function le(N,Q){const H=N.indexOf(Q);H>-1&&(N.splice(H,1),N.push(Q))}e.$Zb=le;function re(N,Q){for(const H of Q)N.push(H)}e.$1b=re;function ue(N,Q){return Array.isArray(N)?N.map(Q):Q(N)}e.$2b=ue;function Z(N){return Array.isArray(N)?N:[N]}e.$3b=Z;function X(N){return N[Math.floor(Math.random()*N.length)]}e.$4b=X;function q(N,Q,H){const _=T(N,Q),z=N.length,ee=H.length;N.length=z+ee;for(let ie=z-1;ie>=_;ie--)N[ie+ee]=N[ie];for(let ie=0;ie<ee;ie++)N[ie+_]=H[ie]}e.$5b=q;function L(N,Q,H,_){const z=T(N,Q);let ee=N.splice(z,H);return ee===void 0&&(ee=[]),q(N,z,_),ee}e.$6b=L;function T(N,Q){return Q<0?Math.max(Q+N.length,0):Math.min(Q,N.length)}var G;(function(N){function Q(ee){return ee<0}N.isLessThan=Q;function H(ee){return ee<=0}N.isLessThanOrEqual=H;function _(ee){return ee>0}N.isGreaterThan=_;function z(ee){return ee===0}N.isNeitherLessOrGreaterThan=z,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function B(N,Q){return(H,_)=>Q(N(H),N(_))}e.$7b=B;function oe(...N){return(Q,H)=>{for(const _ of N){const z=_(Q,H);if(!G.isNeitherLessOrGreaterThan(z))return z}return G.neitherLessOrGreaterThan}}e.$8b=oe;const he=(N,Q)=>N-Q;e.$9b=he;const K=(N,Q)=>(0,e.$9b)(N?1:0,Q?1:0);e.$0b=K;function O(N){return(Q,H)=>-N(Q,H)}e.$$b=O;class W{constructor(Q){this.g=Q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let H=this.c;for(;H<this.g.length&&Q(this.g[H]);)H++;const _=H===this.c?null:this.g.slice(this.c,H);return this.c=H,_}takeFromEndWhile(Q){let H=this.d;for(;H>=0&&Q(this.g[H]);)H--;const _=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Q=this.g[this.c];return this.c++,Q}removeLast(){const Q=this.g[this.d];return this.d--,Q}takeCount(Q){const H=this.g.slice(this.c,this.c+Q);return this.c+=Q,H}}e.$_b=W;class x{static{this.empty=new x(Q=>{})}constructor(Q){this.iterate=Q}forEach(Q){this.iterate(H=>(Q(H),!0))}toArray(){const Q=[];return this.iterate(H=>(Q.push(H),!0)),Q}filter(Q){return new x(H=>this.iterate(_=>Q(_)?H(_):!0))}map(Q){return new x(H=>this.iterate(_=>H(Q(_))))}some(Q){let H=!1;return this.iterate(_=>(H=Q(_),!H)),H}findFirst(Q){let H;return this.iterate(_=>Q(_)?(H=_,!1):!0),H}findLast(Q){let H;return this.iterate(_=>(Q(_)&&(H=_),!0)),H}findLastMaxBy(Q){let H,_=!0;return this.iterate(z=>((_||G.isGreaterThan(Q(z,H)))&&(_=!1,H=z),!0)),H}}e.$ac=x}),define(ae[138],ce([0,1,14]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function D(l,w){if(!l)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=D;function s(l,w="Unreachable"){throw new Error(w)}e.$9c=s;function M(l){if(!l)throw new S.$cb("Assertion Failed")}e.$0c=M;function A(l){l||(0,S.$1)(new S.$cb("Assertion Failed"))}e.$$c=A;function P(l){if(!l()){debugger;l(),(0,S.$1)(new S.$cb("Assertion Failed"))}}e.$_c=P;function g(l,w){let v=0;for(;v<l.length-1;){const y=l[v],h=l[v+1];if(!w(y,h))return!1;v++}return!0}e.$ad=g}),define(ae[84],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function S(D,s){const M=this;let A=!1,P;return function(){if(A)return P;if(A=!0,s)try{P=D.apply(M,arguments)}finally{s()}else P=D.apply(M,arguments);return P}}e.$db=S}),define(ae[71],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(D){function s(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}D.is=s;const M=Object.freeze([]);function A(){return M}D.empty=A;function*P(t){yield t}D.single=P;function g(t){return s(t)?t:P(t)}D.wrap=g;function l(t){return t||M}D.from=l;function*w(t){for(let o=t.length-1;o>=0;o--)yield t[o]}D.reverse=w;function v(t){return!t||t[Symbol.iterator]().next().done===!0}D.isEmpty=v;function y(t){return t[Symbol.iterator]().next().value}D.first=y;function h(t,o){for(const r of t)if(o(r))return!0;return!1}D.some=h;function m(t,o){for(const r of t)if(o(r))return r}D.find=m;function*p(t,o){for(const r of t)o(r)&&(yield r)}D.filter=p;function*k(t,o){let r=0;for(const i of t)yield o(i,r++)}D.map=k;function*u(...t){for(const o of t)yield*o}D.concat=u;function f(t,o,r){let i=r;for(const n of t)i=o(i,n);return i}D.reduce=f;function*d(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}D.slice=d;function $(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let n=0;n<o;n++){const c=i.next();if(c.done)return[r,D.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return i}}]}D.consume=$;async function a(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}D.asyncToArray=a})(S||(e.Iterable=S={}))}),define(ae[42],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(t,o=!1){let r=0;const i=t.length;let n="",c=0,b=16,R=0;function I(J){let le=0,re=0;for(;le<J;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)re=re*16+ue-48;else if(ue>=65&&ue<=70)re=re*16+ue-65+10;else if(ue>=97&&ue<=102)re=re*16+ue-97+10;else break;r++,le++}return le<J&&(re=-1),re}function E(J){r=J,n="",c=0,b=16,R=0}function C(){const J=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&l(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&l(t.charCodeAt(r)))for(r++;r<t.length&&l(t.charCodeAt(r));)r++;else return R=3,t.substring(J,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&l(t.charCodeAt(r))){for(r++;r<t.length&&l(t.charCodeAt(r));)r++;le=r}else R=3;return t.substring(J,le)}function j(){let J="",le=r;for(;;){if(r>=i){J+=t.substring(le,r),R=2;break}const re=t.charCodeAt(r);if(re===34){J+=t.substring(le,r),r++;break}if(re===92){if(J+=t.substring(le,r),r++,r>=i){R=2;break}switch(t.charCodeAt(r++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const Z=I(4);Z>=0?J+=String.fromCharCode(Z):R=4;break}default:R=5}le=r;continue}if(re>=0&&re<=31)if(g(re)){J+=t.substring(le,r),R=2;break}else R=6;r++}return J}function U(){if(n="",R=0,c=r,r>=i)return c=i,b=17;let J=t.charCodeAt(r);if(P(J)){do r++,n+=String.fromCharCode(J),J=t.charCodeAt(r);while(P(J));return b=15}if(g(J))return r++,n+=String.fromCharCode(J),J===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),b=14;switch(J){case 123:return r++,b=1;case 125:return r++,b=2;case 91:return r++,b=3;case 93:return r++,b=4;case 58:return r++,b=6;case 44:return r++,b=5;case 34:return r++,n=j(),b=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!g(t.charCodeAt(r));)r++;return n=t.substring(le,r),b=12}if(t.charCodeAt(r+1)===42){r+=2;const re=i-1;let ue=!1;for(;r<re;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,R=1),n=t.substring(le,r),b=13}return n+=String.fromCharCode(J),r++,b=16}case 45:if(n+=String.fromCharCode(J),r++,r===i||!l(t.charCodeAt(r)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=C(),b=11;default:for(;r<i&&F(J);)r++,J=t.charCodeAt(r);if(c!==r){switch(n=t.substring(c,r),n){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return n+=String.fromCharCode(J),r++,b=16}}function F(J){if(P(J)||g(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let J;do J=U();while(J>=12&&J<=15);return J}return{setPosition:E,getPosition:()=>r,scan:o?V:U,getToken:()=>b,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>R}}e.$mn=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var w;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(w||(w={}));function v(t,o){const r=[],i=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function R(I,E,C,j){c.value=I,c.offset=E,c.length=C,c.type=j,c.colonOffset=void 0,n=c}try{d(t,{onObjectBegin:(I,E)=>{if(o<=I)throw i;n=void 0,b=o>I,r.push("")},onObjectProperty:(I,E,C)=>{if(o<E||(R(I,E,C,"property"),r[r.length-1]=I,o<=E+C))throw i},onObjectEnd:(I,E)=>{if(o<=I)throw i;n=void 0,r.pop()},onArrayBegin:(I,E)=>{if(o<=I)throw i;n=void 0,r.push(0)},onArrayEnd:(I,E)=>{if(o<=I)throw i;n=void 0,r.pop()},onLiteralValue:(I,E,C)=>{if(o<E||(R(I,E,C,a(I)),o<=E+C))throw i},onSeparator:(I,E,C)=>{if(o<=E)throw i;if(I===":"&&n&&n.type==="property")n.colonOffset=E,b=!1,n=void 0;else if(I===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(b=!0,r[r.length-1]=""),n=void 0}}})}catch(I){if(I!==i)throw I}return{path:r,previousNode:n,isAtPropertyKey:b,matches:I=>{let E=0;for(let C=0;E<I.length&&C<r.length;C++)if(I[E]===r[C]||I[E]==="*")E++;else if(I[E]!=="**")return!1;return E===I.length}}}e.$nn=v;function y(t,o=[],r=M.DEFAULT){let i=null,n=[];const c=[];function b(I){Array.isArray(n)?n.push(I):i!==null&&(n[i]=I)}return d(t,{onObjectBegin:()=>{const I={};b(I),c.push(n),n=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const I=[];b(I),c.push(n),n=I,i=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:b,onError:(I,E,C)=>{o.push({error:I,offset:E,length:C})}},r),n[0]}e.$on=y;function h(t,o=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function c(I){return i.children.push(I),I}d(t,{onObjectBegin:I=>{i=c({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,E,C)=>{i=c({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:E,length:C,parent:i})},onObjectEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,n(I+E)},onArrayBegin:(I,E)=>{i=c({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,n(I+E)},onLiteralValue:(I,E,C)=>{c({type:a(I),offset:E,length:C,parent:i,value:I}),n(E+C)},onSeparator:(I,E,C)=>{i.type==="property"&&(I===":"?i.colonOffset=E:I===","&&n(E))},onError:(I,E,C)=>{o.push({error:I,offset:E,length:C})}},r);const R=i.children[0];return R&&delete R.parent,R}e.$pn=h;function m(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===i){r=c.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$qn=m;function p(t){if(!t.parent||!t.parent.children)return[];const o=p(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}e.$rn=p;function k(t){switch(t.type){case"array":return t.children.map(k);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=k(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$sn=k;function u(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}e.$tn=u;function f(t,o,r=!1){if(u(t,o,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const c=f(i[n],o,r);if(c)return c}return t}}e.$un=f;function d(t,o,r=M.DEFAULT){const i=A(t,!1);function n(B){return B?()=>B(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(B){return B?oe=>B(oe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const b=n(o.onObjectBegin),R=c(o.onObjectProperty),I=n(o.onObjectEnd),E=n(o.onArrayBegin),C=n(o.onArrayEnd),j=c(o.onLiteralValue),U=c(o.onSeparator),F=n(o.onComment),V=c(o.onError),J=r&&r.disallowComments,le=r&&r.allowTrailingComma;function re(){for(;;){const B=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:J||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(B){case 12:case 13:J?ue(10):F();break;case 16:ue(1);break;case 15:case 14:break;default:return B}}}function ue(B,oe=[],he=[]){if(V(B),oe.length+he.length>0){let K=i.getToken();for(;K!==17;){if(oe.indexOf(K)!==-1){re();break}else if(he.indexOf(K)!==-1)break;K=re()}}}function Z(B){const oe=i.getTokenValue();return B?j(oe):R(oe),re(),!0}function X(){switch(i.getToken()){case 11:{let B=0;try{B=JSON.parse(i.getTokenValue()),typeof B!="number"&&(ue(2),B=0)}catch{ue(2)}j(B);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return re(),!0}function q(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(Z(!1),i.getToken()===6?(U(":"),re(),G()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function L(){b(),re();let B=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(B||ue(4,[],[]),U(","),re(),i.getToken()===2&&le)break}else B&&ue(6,[],[]);q()||ue(4,[],[2,5]),B=!0}return I(),i.getToken()!==2?ue(7,[2],[]):re(),!0}function T(){E(),re();let B=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(B||ue(4,[],[]),U(","),re(),i.getToken()===4&&le)break}else B&&ue(6,[],[]);G()||ue(4,[],[4,5]),B=!0}return C(),i.getToken()!==4?ue(8,[4],[]):re(),!0}function G(){switch(i.getToken()){case 3:return T();case 1:return L();case 10:return Z(!0);default:return X()}}return re(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):G()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.$vn=d;function $(t,o){const r=A(t),i=[];let n,c=0,b;do switch(b=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:c!==b&&i.push(t.substring(c,b)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),c=r.getPosition();break}while(n!==17);return i.join("")}e.$wn=$;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$xn=a}),define(ae[139],ce([0,1,42]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=void 0;function D(l,w,v){let y,h,m,p,k;if(w){for(p=w.offset,k=p+w.length,m=p;m>0&&!g(l,m-1);)m--;let b=k;for(;b<l.length&&!g(l,b);)b++;h=l.substring(m,b),y=A(h,v)}else h=l,y=0,m=0,p=0,k=l.length;const u=P(v,l);let f=!1,d=0,$;v.insertSpaces?$=M(" ",v.tabSize||4):$="	";const a=(0,S.$mn)(h,!1);let t=!1;function o(){return u+M($,y+d)}function r(){let b=a.scan();for(f=!1;b===15||b===14;)f=f||b===14,b=a.scan();return t=b===16||a.getTokenError()!==0,b}const i=[];function n(b,R,I){!t&&R<k&&I>p&&l.substring(R,I)!==b&&i.push({offset:R,length:I-R,content:b})}let c=r();if(c!==17){const b=a.getTokenOffset()+m,R=M($,y);n(R,m,b)}for(;c!==17;){let b=a.getTokenOffset()+a.getTokenLength()+m,R=r(),I="";for(;!f&&(R===12||R===13);){const C=a.getTokenOffset()+m;n(" ",b,C),b=a.getTokenOffset()+a.getTokenLength()+m,I=R===12?o():"",R=r()}if(R===2)c!==1&&(d--,I=o());else if(R===4)c!==3&&(d--,I=o());else{switch(c){case 3:case 1:d++,I=o();break;case 5:case 12:I=o();break;case 13:f?I=o():I=" ";break;case 6:I=" ";break;case 10:if(R===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:R===12||R===13?I=" ":R!==5&&R!==17&&(t=!0);break;case 16:t=!0;break}f&&(R===12||R===13)&&(I=o())}const E=a.getTokenOffset()+m;n(I,b,E),c=R}return i}e.$yn=D;function s(l,w){const v=JSON.stringify(l,void 0,w.insertSpaces?w.tabSize||4:"	");return w.eol!==void 0?v.replace(/\r\n|\r|\n/g,w.eol):v}e.$zn=s;function M(l,w){let v="";for(let y=0;y<w;y++)v+=l;return v}function A(l,w){let v=0,y=0;const h=w.tabSize||4;for(;v<l.length;){const m=l.charAt(v);if(m===" ")y++;else if(m==="	")y+=h;else break;v++}return Math.floor(y/h)}function P(l,w){for(let v=0;v<w.length;v++){const y=w.charAt(v);if(y==="\r")return v+1<w.length&&w.charAt(v+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return l&&l.eol||`
`}e.$An=P;function g(l,w){return`\r
`.indexOf(l.charAt(w))!==-1}e.$Bn=g}),define(ae[102],ce([0,1,42,139]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=void 0;function s(l,w,v){return M(l,w,void 0,v)}e.$Cn=s;function M(l,w,v,y,h){const m=w.slice(),p=[],k=(0,S.$pn)(l,p);let u,f;for(;m.length>0&&(f=m.pop(),u=(0,S.$qn)(k,m),u===void 0&&v!==void 0);)typeof f=="string"?v={[f]:v}:v=[v];if(u)if(u.type==="object"&&typeof f=="string"&&Array.isArray(u.children)){const d=(0,S.$qn)(u,[f]);if(d!==void 0)if(v===void 0){if(!d.parent)throw new Error("Malformed AST");const $=u.children.indexOf(d.parent);let a,t=d.parent.offset+d.parent.length;if($>0){const o=u.children[$-1];a=o.offset+o.length}else a=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return A(l,{offset:a,length:t-a,content:""},y)}else return A(l,{offset:d.offset,length:d.length,content:JSON.stringify(v)},y);else{if(v===void 0)return[];const $=`${JSON.stringify(f)}: ${JSON.stringify(v)}`,a=h?h(u.children.map(o=>o.children[0].value)):u.children.length;let t;if(a>0){const o=u.children[a-1];t={offset:o.offset+o.length,length:0,content:","+$}}else u.children.length===0?t={offset:u.offset+1,length:0,content:$}:t={offset:u.offset+1,length:0,content:$+","};return A(l,t,y)}}else if(u.type==="array"&&typeof f=="number"&&Array.isArray(u.children))if(v!==void 0){const d=`${JSON.stringify(v)}`;let $;if(u.children.length===0||f===0)$={offset:u.offset+1,length:0,content:u.children.length===0?d:d+","};else{const a=f===-1||f>u.children.length?u.children.length:f,t=u.children[a-1];$={offset:t.offset+t.length,length:0,content:","+d}}return A(l,$,y)}else{const d=f,$=u.children[d];let a;if(u.children.length===1)a={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===d){const t=u.children[d-1],o=t.offset+t.length,r=u.offset+u.length;a={offset:o,length:r-2-o,content:""}}else a={offset:$.offset,length:u.children[d+1].offset-$.offset,content:""};return A(l,a,y)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${u.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return A(l,{offset:k?k.offset:0,length:k?k.length:0,content:JSON.stringify(v)},y)}}e.$Dn=M;function A(l,w,v){let y=P(l,w),h=w.offset,m=w.offset+w.content.length;if(w.length===0||w.content.length===0){for(;h>0&&!(0,D.$Bn)(y,h-1);)h--;for(;m<y.length&&!(0,D.$Bn)(y,m);)m++}const p=(0,D.$yn)(y,{offset:h,length:m-h},v);for(let u=p.length-1;u>=0;u--){const f=p[u];y=P(y,f),h=Math.min(h,f.offset),m=Math.max(m,f.offset+f.length),m+=f.content.length-f.length}const k=l.length-(y.length-m)-h;return[{offset:h,length:k,content:y.substring(h,m)}]}e.$En=A;function P(l,w){return l.substring(0,w.offset)+w.content+l.substring(w.offset+w.length)}e.$Fn=P;function g(l,w){const v=w.slice(0).sort((h,m)=>{const p=h.offset-m.offset;return p===0?h.length-m.length:p});let y=l.length;for(let h=v.length-1;h>=0;h--){const m=v[h];if(m.offset+m.length<=y)l=P(l,m);else throw new Error("Overlapping edit");y=m.offset}return l}e.$Gn=g}),define(ae[62],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=S}),define(ae[103],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class S{static{this.Undefined=new S(void 0)}constructor(M){this.element=M,this.next=S.Undefined,this.prev=S.Undefined}}class D{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let M=this.a;for(;M!==S.Undefined;){const A=M.next;M.prev=S.Undefined,M.next=S.Undefined,M=A}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,A){const P=new S(M);if(this.a===S.Undefined)this.a=P,this.b=P;else if(A){const l=this.b;this.b=P,P.prev=l,l.next=P}else{const l=this.a;this.a=P,P.next=l,l.prev=P}this.c+=1;let g=!1;return()=>{g||(g=!0,this.e(P))}}shift(){if(this.a!==S.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==S.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==S.Undefined&&M.next!==S.Undefined){const A=M.prev;A.next=M.next,M.next.prev=A}else M.prev===S.Undefined&&M.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):M.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):M.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==S.Undefined;)yield M.element,M=M.next}}e.$4c=D}),define(ae[31],ce([0,1]),function(Y,e){"use strict";var S,D,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function M(d,$,a){let t=d.get($);return t===void 0&&(t=a,d.set($,t)),t}e.$xc=M;function A(d){const $=[];return d.forEach((a,t)=>{$.push(`${t} => ${a}`)}),`Map(${d.size}) {${$.join(", ")}}`}e.$yc=A;function P(d){const $=[];return d.forEach(a=>{$.push(a)}),`Set(${d.size}) {${$.join(", ")}}`}e.$zc=P;class g{constructor($,a){this.uri=$,this.value=a}}function l(d){return Array.isArray(d)}class w{static{this.c=$=>$.toString()}constructor($,a){if(this[S]="ResourceMap",$ instanceof w)this.d=new Map($.d),this.e=a??w.c;else if(l($)){this.d=new Map,this.e=a??w.c;for(const[t,o]of $)this.set(t,o)}else this.d=new Map,this.e=$??w.c}set($,a){return this.d.set(this.e($),new g($,a)),this}get($){return this.d.get(this.e($))?.value}has($){return this.d.has(this.e($))}get size(){return this.d.size}clear(){this.d.clear()}delete($){return this.d.delete(this.e($))}forEach($,a){typeof a<"u"&&($=$.bind(a));for(const[t,o]of this.d)$(o.value,o.uri,this)}*values(){for(const $ of this.d.values())yield $.value}*keys(){for(const $ of this.d.values())yield $.uri}*entries(){for(const $ of this.d.values())yield[$.uri,$.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,$]of this.d)yield[$.uri,$.value]}}e.$Ac=w;class v{constructor($,a){this[D]="ResourceSet",!$||typeof $=="function"?this.c=new w($):(this.c=new w(a),$.forEach(this.add,this))}get size(){return this.c.size}add($){return this.c.set($,$),this}clear(){this.c.clear()}delete($){return this.c.delete($)}forEach($,a){this.c.forEach((t,o)=>$.call(a,o,o,this))}has($){return this.c.has($)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=v;var y;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class h{constructor(){this[s]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has($){return this.c.has($)}get($,a=0){const t=this.c.get($);if(t)return a!==0&&this.l(t,a),t.value}set($,a,t=0){let o=this.c.get($);if(o)o.value=a,t!==0&&this.l(o,t);else{switch(o={key:$,value:a,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set($,o),this.f++}return this}delete($){return!!this.remove($)}remove($){const a=this.c.get($);if(a)return this.c.delete($),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const $=this.d;return this.c.delete($.key),this.k($),this.f--,$.value}forEach($,a){const t=this.g;let o=this.d;for(;o;){if(a?$.bind(a)(o.value,o.key,this):$(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const $=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if($.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}values(){const $=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if($.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}entries(){const $=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if($.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h($){if($>=this.size)return;if($===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>$;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i($){if(!this.d&&!this.e)this.e=$;else if(this.d)$.next=this.d,this.d.previous=$;else throw new Error("Invalid list");this.d=$,this.g++}j($){if(!this.d&&!this.e)this.d=$;else if(this.e)$.previous=this.e,this.e.next=$;else throw new Error("Invalid list");this.e=$,this.g++}k($){if($===this.d&&$===this.e)this.d=void 0,this.e=void 0;else if($===this.d){if(!$.next)throw new Error("Invalid list");$.next.previous=void 0,this.d=$.next}else if($===this.e){if(!$.previous)throw new Error("Invalid list");$.previous.next=void 0,this.e=$.previous}else{const a=$.next,t=$.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}$.next=void 0,$.previous=void 0,this.g++}l($,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if($===this.d)return;const t=$.next,o=$.previous;$===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),$.previous=void 0,$.next=this.d,this.d.previous=$,this.d=$,this.g++}else if(a===2){if($===this.e)return;const t=$.next,o=$.previous;$===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),$.next=void 0,$.previous=this.e,this.e.next=$,this.e=$,this.g++}}}toJSON(){const $=[];return this.forEach((a,t)=>{$.push([t,a])}),$}fromJSON($){this.clear();for(const[a,t]of $)this.set(a,t)}}e.$Cc=h;class m extends h{constructor($,a=1){super(),this.m=$,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit($){this.m=$,this.o()}get ratio(){return this.n}set ratio($){this.n=Math.min(Math.max(0,$),1),this.o()}get($,a=2){return super.get($,a)}peek($){return super.get($,0)}set($,a){return super.set($,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=m;class p{constructor(){this.c=new Map}add($){return this.c.set($,(this.c.get($)||0)+1),this}delete($){let a=this.c.get($)||0;return a===0?!1:(a--,a===0?this.c.delete($):this.c.set($,a),!0)}has($){return this.c.has($)}}e.$Ec=p;class k{constructor($){if(this.c=new Map,this.d=new Map,$)for(const[a,t]of $)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set($,a){this.c.set($,a),this.d.set(a,$)}get($){return this.c.get($)}getKey($){return this.d.get($)}delete($){const a=this.c.get($);return a===void 0?!1:(this.c.delete($),this.d.delete(a),!0)}forEach($,a){this.c.forEach((t,o)=>{$.call(a,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=k;class u{constructor(){this.c=new Map}add($,a){let t=this.c.get($);t||(t=new Set,this.c.set($,t)),t.add(a)}delete($,a){const t=this.c.get($);t&&(t.delete(a),t.size===0&&this.c.delete($))}forEach($,a){const t=this.c.get($);t&&t.forEach(a)}get($){const a=this.c.get($);return a||new Set}}e.$Gc=u;function f(d,$){if(d===$)return!0;if(d.size!==$.size)return!1;for(const[a,t]of d)if(!$.has(a)||$.get(a)!==t)return!1;for(const[a]of $)if(!d.has(a))return!1;return!0}e.$Hc=f}),define(ae[2],ce([0,1,22,136,31,84,71]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const P=!1;let g=null;class l{constructor(){this.b=new Map}static{this.a=0}c(j){let U=this.b.get(j);return U||(U={parent:null,source:null,isSingleton:!1,value:j,idx:l.a++},this.b.set(j,U)),U}trackDisposable(j){const U=this.c(j);U.source||(U.source=new Error().stack)}setParent(j,U){const F=this.c(j);F.parent=U}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,U){const F=U.get(j);if(F)return F;const V=j.parent?this.f(this.c(j.parent),U):j;return U.set(j,V),V}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,j).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(j=10,U){let F;if(U)F=U;else{const ue=new Map,Z=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,ue).isSingleton);if(Z.length===0)return;const X=new Set(Z.map(q=>q.value));if(F=Z.filter(q=>!(q.parent&&X.has(q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function V(ue){function Z(q,L){for(;q.length>0&&L.some(T=>typeof T=="string"?T===q[0]:q[0].match(T));)q.shift()}const X=ue.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return Z(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const J=new s.$Gc;for(const ue of F){const Z=V(ue);for(let X=0;X<=Z.length;X++)J.add(Z.slice(0,X).join(`
`),ue)}F.sort((0,S.$7b)(ue=>ue.idx,S.$9b));let le="",re=0;for(const ue of F.slice(0,j)){re++;const Z=V(ue),X=[];for(let q=0;q<Z.length;q++){let L=Z[q];L=`(shared with ${J.get(Z.slice(0,q+1).join(`
`)).size}/${F.length} leaks) at ${L}`;const G=J.get(Z.slice(0,q).join(`
`)),B=(0,D.$K)([...G].map(oe=>V(oe)[q]),oe=>oe);delete B[Z[q]];for(const[oe,he]of Object.entries(B))X.unshift(`    - stacktraces of ${he.length} other leaks continue with ${oe}`);X.unshift(L)}le+=`


==================== Leaking disposable ${re}/${F.length}: ${ue.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return F.length>j&&(le+=`


... and ${F.length-j} more leaking disposables

`),{leaks:F,details:le}}}e.$Ic=l;function w(C){g=C}if(e.$Jc=w,P){const C="__is_disposable_tracked__";w(new class{trackDisposable(j){const U=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[C]||console.log(U)},3e3)}setParent(j,U){if(j&&j!==t.None)try{j[C]=!0}catch{}}markAsDisposed(j){if(j&&j!==t.None)try{j[C]=!0}catch{}}markAsSingleton(j){}})}function v(C){return g?.trackDisposable(C),C}e.$Kc=v;function y(C){g?.markAsDisposed(C)}e.$Lc=y;function h(C,j){g?.setParent(C,j)}function m(C,j){if(g)for(const U of C)g.setParent(U,j)}function p(C){return g?.markAsSingleton(C),C}e.$Mc=p;function k(C){return typeof C.dispose=="function"&&C.dispose.length===0}e.$Nc=k;function u(C){if(A.Iterable.is(C)){const j=[];for(const U of C)if(U)try{U.dispose()}catch(F){j.push(F)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}e.$Oc=u;function f(C){for(const j of C)k(j)&&j.dispose();return[]}e.$Pc=f;function d(...C){const j=$(()=>u(C));return m(C,j),j}e.$Qc=d;function $(C){const j=v({dispose:(0,M.$db)(()=>{y(j),C()})});return j}e.$Rc=$;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return h(j,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),h(j,null))}}e.$Sc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,v(this),h(this.q,this)}dispose(){y(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}e.$Tc=t;class o{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&h(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&h(j,null),j}}e.$Uc=o;class r{constructor(j){this.a=new o,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=r;class i{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(j){let U=j;return this.unset=()=>U=void 0,this.isset=()=>U!==void 0,this.dispose=()=>{U&&(U(),U=void 0,y(this))},this}}e.$Xc=n;class c{constructor(){this.a=new Map}acquire(j,...U){let F=this.a.get(j);F||(F={counter:0,object:this.b(j,...U)},this.a.set(j,F));const{object:V}=F,J=(0,M.$db)(()=>{--F.counter===0&&(this.c(j,F.object),this.a.delete(j))});return F.counter++,{object:V,dispose:J}}}e.$Yc=c;class b{constructor(j){this.a=j}async acquire(j,...U){const F=this.a.acquire(j,...U);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(V){throw F.dispose(),V}}}e.$Zc=b;class R{constructor(j){this.object=j}dispose(){}}e.$1c=R;function I(C){const j=new a;try{C(j)}finally{j.dispose()}}e.$2c=I;class E{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,U,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(j)?.dispose(),this.a.set(j,U)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=E}),define(ae[85],ce([0,1,31]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=void 0;const D=new S.$Dc(1e4);function s(l){return g(l,"NFC",D)}e.$Rl=s;const M=new S.$Dc(1e4);function A(l){return g(l,"NFD",M)}e.$Sl=A;const P=/[^\u0000-\u0080]/;function g(l,w,v){if(!l)return l;const y=v.get(l);if(y)return y;let h;return P.test(l)?h=l.normalize(w):h=l,v.set(l,h),h}e.$Tl=function(){const l=/[\u0300-\u036f]/g;return function(w){return A(w).replace(l,"")}}()}),define(ae[140],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.rot=e.$fm=void 0;function S(P,g,l){return Math.min(Math.max(P,g),l)}e.$fm=S;function D(P,g){return(g+P%g)%g}e.rot=D;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$hm=s;class M{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$im=M;class A{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const l=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$jm=A}),function(){function Y(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function A(g){M.push(g,Date.now())}function P(){const g=[];for(let l=0;l<M.length;l+=2)g.push({name:M[l],startTime:M[l+1]});return g}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(s+A.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=S(D))}(),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var D in S)(typeof exports=="object"?exports:Y)[D]=S[D]}}(typeof self<"u"?self:this,function(){return function(Y){var e={};function S(D){if(e[D])return e[D].exports;var s=e[D]={i:D,l:!1,exports:{}};return Y[D].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=Y,S.c=e,S.d=function(D,s,M){S.o(D,s)||Object.defineProperty(D,s,{enumerable:!0,get:M})},S.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},S.t=function(D,s){if(1&s&&(D=S(D)),8&s||4&s&&typeof D=="object"&&D&&D.__esModule)return D;var M=Object.create(null);if(S.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:D}),2&s&&typeof D!="string")for(var A in D)S.d(M,A,function(P){return D[P]}.bind(null,A));return M},S.n=function(D){var s=D&&D.__esModule?function(){return D.default}:function(){return D};return S.d(s,"a",s),s},S.o=function(D,s){return Object.prototype.hasOwnProperty.call(D,s)},S.p="",S(S.s=0)}([function(Y,e,S){(function(D){var s;e=Y.exports=he,s=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var te=Array.prototype.slice.call(arguments,0);te.unshift("SEMVER"),console.log.apply(console,te)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],g=e.src=[],l=0,w=l++;g[w]="0|[1-9]\\d*";var v=l++;g[v]="[0-9]+";var y=l++;g[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=l++;g[h]="("+g[w]+")\\.("+g[w]+")\\.("+g[w]+")";var m=l++;g[m]="("+g[v]+")\\.("+g[v]+")\\.("+g[v]+")";var p=l++;g[p]="(?:"+g[w]+"|"+g[y]+")";var k=l++;g[k]="(?:"+g[v]+"|"+g[y]+")";var u=l++;g[u]="(?:-("+g[p]+"(?:\\."+g[p]+")*))";var f=l++;g[f]="(?:-?("+g[k]+"(?:\\."+g[k]+")*))";var d=l++;g[d]="[0-9A-Za-z-]+";var $=l++;g[$]="(?:\\+("+g[d]+"(?:\\."+g[d]+")*))";var a=l++,t="v?"+g[h]+g[u]+"?"+g[$]+"?";g[a]="^"+t+"$";var o="[v=\\s]*"+g[m]+g[f]+"?"+g[$]+"?",r=l++;g[r]="^"+o+"$";var i=l++;g[i]="((?:<|>)?=?)";var n=l++;g[n]=g[v]+"|x|X|\\*";var c=l++;g[c]=g[w]+"|x|X|\\*";var b=l++;g[b]="[v=\\s]*("+g[c]+")(?:\\.("+g[c]+")(?:\\.("+g[c]+")(?:"+g[u]+")?"+g[$]+"?)?)?";var R=l++;g[R]="[v=\\s]*("+g[n]+")(?:\\.("+g[n]+")(?:\\.("+g[n]+")(?:"+g[f]+")?"+g[$]+"?)?)?";var I=l++;g[I]="^"+g[i]+"\\s*"+g[b]+"$";var E=l++;g[E]="^"+g[i]+"\\s*"+g[R]+"$";var C=l++;g[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=l++;g[j]="(?:~>?)";var U=l++;g[U]="(\\s*)"+g[j]+"\\s+",P[U]=new RegExp(g[U],"g");var F=l++;g[F]="^"+g[j]+g[b]+"$";var V=l++;g[V]="^"+g[j]+g[R]+"$";var J=l++;g[J]="(?:\\^)";var le=l++;g[le]="(\\s*)"+g[J]+"\\s+",P[le]=new RegExp(g[le],"g");var re=l++;g[re]="^"+g[J]+g[b]+"$";var ue=l++;g[ue]="^"+g[J]+g[R]+"$";var Z=l++;g[Z]="^"+g[i]+"\\s*("+o+")$|^$";var X=l++;g[X]="^"+g[i]+"\\s*("+t+")$|^$";var q=l++;g[q]="(\\s*)"+g[i]+"\\s*("+o+"|"+g[b]+")",P[q]=new RegExp(g[q],"g");var L=l++;g[L]="^\\s*("+g[b]+")\\s+-\\s+("+g[b]+")\\s*$";var T=l++;g[T]="^\\s*("+g[R]+")\\s+-\\s+("+g[R]+")\\s*$";var G=l++;g[G]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)s(B,g[B]),P[B]||(P[B]=new RegExp(g[B]));function oe(te,fe){if(te instanceof he)return te;if(typeof te!="string"||te.length>M||!(fe?P[r]:P[a]).test(te))return null;try{return new he(te,fe)}catch{return null}}function he(te,fe){if(te instanceof he){if(te.loose===fe)return te;te=te.version}else if(typeof te!="string")throw new TypeError("Invalid Version: "+te);if(te.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof he))return new he(te,fe);s("SemVer",te,fe),this.loose=fe;var $e=te.trim().match(fe?P[r]:P[a]);if(!$e)throw new TypeError("Invalid Version: "+te);if(this.raw=te,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Oe=+Ce;if(Oe>=0&&Oe<A)return Oe}return Ce}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=oe,e.valid=function(te,fe){var $e=oe(te,fe);return $e?$e.version:null},e.clean=function(te,fe){var $e=oe(te.trim().replace(/^[=v]+/,""),fe);return $e?$e.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(te){return s("SemVer.compare",this.version,this.loose,te),te instanceof he||(te=new he(te,this.loose)),this.compareMain(te)||this.comparePre(te)},he.prototype.compareMain=function(te){return te instanceof he||(te=new he(te,this.loose)),O(this.major,te.major)||O(this.minor,te.minor)||O(this.patch,te.patch)},he.prototype.comparePre=function(te){if(te instanceof he||(te=new he(te,this.loose)),this.prerelease.length&&!te.prerelease.length)return-1;if(!this.prerelease.length&&te.prerelease.length)return 1;if(!this.prerelease.length&&!te.prerelease.length)return 0;var fe=0;do{var $e=this.prerelease[fe],Ce=te.prerelease[fe];if(s("prerelease compare",fe,$e,Ce),$e===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if($e===void 0)return-1;if($e!==Ce)return O($e,Ce)}while(++fe)},he.prototype.inc=function(te,fe){switch(te){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+te)}return this.format(),this.raw=this.version,this},e.inc=function(te,fe,$e,Ce){typeof $e=="string"&&(Ce=$e,$e=void 0);try{return new he(te,$e).inc(fe,Ce).version}catch{return null}},e.diff=function(te,fe){if(Q(te,fe))return null;var $e=oe(te),Ce=oe(fe);if($e.prerelease.length||Ce.prerelease.length){for(var Oe in $e)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&$e[Oe]!==Ce[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in $e)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&$e[Oe]!==Ce[Oe])return Oe},e.compareIdentifiers=O;var K=/^[0-9]+$/;function O(te,fe){var $e=K.test(te),Ce=K.test(fe);return $e&&Ce&&(te=+te,fe=+fe),$e&&!Ce?-1:Ce&&!$e?1:te<fe?-1:te>fe?1:0}function W(te,fe,$e){return new he(te,$e).compare(new he(fe,$e))}function x(te,fe,$e){return W(te,fe,$e)>0}function N(te,fe,$e){return W(te,fe,$e)<0}function Q(te,fe,$e){return W(te,fe,$e)===0}function H(te,fe,$e){return W(te,fe,$e)!==0}function _(te,fe,$e){return W(te,fe,$e)>=0}function z(te,fe,$e){return W(te,fe,$e)<=0}function ee(te,fe,$e,Ce){var Oe;switch(fe){case"===":typeof te=="object"&&(te=te.version),typeof $e=="object"&&($e=$e.version),Oe=te===$e;break;case"!==":typeof te=="object"&&(te=te.version),typeof $e=="object"&&($e=$e.version),Oe=te!==$e;break;case"":case"=":case"==":Oe=Q(te,$e,Ce);break;case"!=":Oe=H(te,$e,Ce);break;case">":Oe=x(te,$e,Ce);break;case">=":Oe=_(te,$e,Ce);break;case"<":Oe=N(te,$e,Ce);break;case"<=":Oe=z(te,$e,Ce);break;default:throw new TypeError("Invalid operator: "+fe)}return Oe}function ie(te,fe){if(te instanceof ie){if(te.loose===fe)return te;te=te.value}if(!(this instanceof ie))return new ie(te,fe);s("comparator",te,fe),this.loose=fe,this.parse(te),this.semver===de?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(te,fe){return O(fe,te)},e.major=function(te,fe){return new he(te,fe).major},e.minor=function(te,fe){return new he(te,fe).minor},e.patch=function(te,fe){return new he(te,fe).patch},e.compare=W,e.compareLoose=function(te,fe){return W(te,fe,!0)},e.rcompare=function(te,fe,$e){return W(fe,te,$e)},e.sort=function(te,fe){return te.sort(function($e,Ce){return e.compare($e,Ce,fe)})},e.rsort=function(te,fe){return te.sort(function($e,Ce){return e.rcompare($e,Ce,fe)})},e.gt=x,e.lt=N,e.eq=Q,e.neq=H,e.gte=_,e.lte=z,e.cmp=ee,e.Comparator=ie;var de={};function me(te,fe){if(te instanceof me)return te.loose===fe?te:new me(te.raw,fe);if(te instanceof ie)return new me(te.value,fe);if(!(this instanceof me))return new me(te,fe);if(this.loose=fe,this.raw=te,this.set=te.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+te);this.format()}function Ee(te){return!te||te.toLowerCase()==="x"||te==="*"}function Pe(te,fe,$e,Ce,Oe,Ue,je,Ge,qe,Ke,He,Be,ne){return((fe=Ee($e)?"":Ee(Ce)?">="+$e+".0.0":Ee(Oe)?">="+$e+"."+Ce+".0":">="+fe)+" "+(Ge=Ee(qe)?"":Ee(Ke)?"<"+(+qe+1)+".0.0":Ee(He)?"<"+qe+"."+(+Ke+1)+".0":Be?"<="+qe+"."+Ke+"."+He+"-"+Be:"<="+Ge)).trim()}function Le(te,fe){for(var $e=0;$e<te.length;$e++)if(!te[$e].test(fe))return!1;if(fe.prerelease.length){for($e=0;$e<te.length;$e++)if(s(te[$e].semver),te[$e].semver!==de&&te[$e].semver.prerelease.length>0){var Ce=te[$e].semver;if(Ce.major===fe.major&&Ce.minor===fe.minor&&Ce.patch===fe.patch)return!0}return!1}return!0}function ke(te,fe,$e){try{fe=new me(fe,$e)}catch{return!1}return fe.test(te)}function ye(te,fe,$e,Ce){var Oe,Ue,je,Ge,qe;switch(te=new he(te,Ce),fe=new me(fe,Ce),$e){case">":Oe=x,Ue=z,je=N,Ge=">",qe=">=";break;case"<":Oe=N,Ue=_,je=x,Ge="<",qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(te,fe,Ce))return!1;for(var Ke=0;Ke<fe.set.length;++Ke){var He=fe.set[Ke],Be=null,ne=null;if(He.forEach(function(ge){ge.semver===de&&(ge=new ie(">=0.0.0")),Be=Be||ge,ne=ne||ge,Oe(ge.semver,Be.semver,Ce)?Be=ge:je(ge.semver,ne.semver,Ce)&&(ne=ge)}),Be.operator===Ge||Be.operator===qe||(!ne.operator||ne.operator===Ge)&&Ue(te,ne.semver)||ne.operator===qe&&je(te,ne.semver))return!1}return!0}ie.prototype.parse=function(te){var fe=this.loose?P[Z]:P[X],$e=te.match(fe);if(!$e)throw new TypeError("Invalid comparator: "+te);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new he($e[2],this.loose):this.semver=de},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(te){return s("Comparator.test",te,this.loose),this.semver===de||(typeof te=="string"&&(te=new he(te,this.loose)),ee(te,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(te,fe){if(!(te instanceof ie))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new me(te.value,fe),ke(this.value,$e,fe);if(te.operator==="")return $e=new me(this.value,fe),ke(te.semver,$e,fe);var Ce=!(this.operator!==">="&&this.operator!==">"||te.operator!==">="&&te.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||te.operator!=="<="&&te.operator!=="<"),Ue=this.semver.version===te.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||te.operator!==">="&&te.operator!=="<="),Ge=ee(this.semver,"<",te.semver,fe)&&(this.operator===">="||this.operator===">")&&(te.operator==="<="||te.operator==="<"),qe=ee(this.semver,">",te.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(te.operator===">="||te.operator===">");return Ce||Oe||Ue&&je||Ge||qe},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(te){return te.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(te){var fe=this.loose;te=te.trim(),s("range",te,fe);var $e=fe?P[T]:P[L];te=te.replace($e,Pe),s("hyphen replace",te),te=te.replace(P[q],"$1$2$3"),s("comparator trim",te,P[q]),te=(te=(te=te.replace(P[U],"$1~")).replace(P[le],"$1^")).split(/\s+/).join(" ");var Ce=fe?P[Z]:P[X],Oe=te.split(" ").map(function(Ue){return function(je,Ge){return s("comp",je),je=function(qe,Ke){return qe.trim().split(/\s+/).map(function(He){return function(Be,ne){s("caret",Be,ne);var ge=ne?P[ue]:P[re];return Be.replace(ge,function(pe,be,Se,Me,Te){var Ye;return s("caret",Be,pe,be,Se,Me,Te),Ee(be)?Ye="":Ee(Se)?Ye=">="+be+".0.0 <"+(+be+1)+".0.0":Ee(Me)?Ye=be==="0"?">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+".0 <"+(+be+1)+".0.0":Te?(s("replaceCaret pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Ye=be==="0"?Se==="0"?">="+be+"."+Se+"."+Me+Te+" <"+be+"."+Se+"."+(+Me+1):">="+be+"."+Se+"."+Me+Te+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Me+Te+" <"+(+be+1)+".0.0"):(s("no pr"),Ye=be==="0"?Se==="0"?">="+be+"."+Se+"."+Me+" <"+be+"."+Se+"."+(+Me+1):">="+be+"."+Se+"."+Me+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Me+" <"+(+be+1)+".0.0"),s("caret return",Ye),Ye})}(He,Ke)}).join(" ")}(je,Ge),s("caret",je),je=function(qe,Ke){return qe.trim().split(/\s+/).map(function(He){return function(Be,ne){var ge=ne?P[V]:P[F];return Be.replace(ge,function(pe,be,Se,Me,Te){var Ye;return s("tilde",Be,pe,be,Se,Me,Te),Ee(be)?Ye="":Ee(Se)?Ye=">="+be+".0.0 <"+(+be+1)+".0.0":Ee(Me)?Ye=">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":Te?(s("replaceTilde pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),Ye=">="+be+"."+Se+"."+Me+Te+" <"+be+"."+(+Se+1)+".0"):Ye=">="+be+"."+Se+"."+Me+" <"+be+"."+(+Se+1)+".0",s("tilde return",Ye),Ye})}(He,Ke)}).join(" ")}(je,Ge),s("tildes",je),je=function(qe,Ke){return s("replaceXRanges",qe,Ke),qe.split(/\s+/).map(function(He){return function(Be,ne){Be=Be.trim();var ge=ne?P[E]:P[I];return Be.replace(ge,function(pe,be,Se,Me,Te,Ye){s("xRange",Be,pe,be,Se,Me,Te,Ye);var xe=Ee(Se),Qe=xe||Ee(Me),Ze=Qe||Ee(Te);return be==="="&&Ze&&(be=""),xe?pe=be===">"||be==="<"?"<0.0.0":"*":be&&Ze?(Qe&&(Me=0),Ze&&(Te=0),be===">"?(be=">=",Qe?(Se=+Se+1,Me=0,Te=0):Ze&&(Me=+Me+1,Te=0)):be==="<="&&(be="<",Qe?Se=+Se+1:Me=+Me+1),pe=be+Se+"."+Me+"."+Te):Qe?pe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ze&&(pe=">="+Se+"."+Me+".0 <"+Se+"."+(+Me+1)+".0"),s("xRange return",pe),pe})}(He,Ke)}).join(" ")}(je,Ge),s("xrange",je),je=function(qe,Ke){return s("replaceStars",qe,Ke),qe.trim().replace(P[G],"")}(je,Ge),s("stars",je),je}(Ue,fe)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Ue){return!!Ue.match(Ce)})),Oe=Oe.map(function(Ue){return new ie(Ue,fe)})},me.prototype.intersects=function(te,fe){if(!(te instanceof me))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Ce){return te.set.some(function(Oe){return Oe.every(function(Ue){return Ce.intersects(Ue,fe)})})})})},e.toComparators=function(te,fe){return new me(te,fe).set.map(function($e){return $e.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},me.prototype.test=function(te){if(!te)return!1;typeof te=="string"&&(te=new he(te,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Le(this.set[fe],te))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(te,fe,$e){var Ce=null,Oe=null;try{var Ue=new me(fe,$e)}catch{return null}return te.forEach(function(je){Ue.test(je)&&(Ce&&Oe.compare(je)!==-1||(Oe=new he(Ce=je,$e)))}),Ce},e.minSatisfying=function(te,fe,$e){var Ce=null,Oe=null;try{var Ue=new me(fe,$e)}catch{return null}return te.forEach(function(je){Ue.test(je)&&(Ce&&Oe.compare(je)!==1||(Oe=new he(Ce=je,$e)))}),Ce},e.validRange=function(te,fe){try{return new me(te,fe).range||"*"}catch{return null}},e.ltr=function(te,fe,$e){return ye(te,fe,"<",$e)},e.gtr=function(te,fe,$e){return ye(te,fe,">",$e)},e.outside=ye,e.prerelease=function(te,fe){var $e=oe(te,fe);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(te,fe,$e){return te=new me(te,$e),fe=new me(fe,$e),te.intersects(fe)},e.coerce=function(te){if(te instanceof he)return te;if(typeof te!="string")return null;var fe=te.match(P[C]);return fe==null?null:oe((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,S(1))},function(Y,e){var S,D,s=Y.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(k){if(S===setTimeout)return setTimeout(k,0);if((S===M||!S)&&setTimeout)return S=setTimeout,setTimeout(k,0);try{return S(k,0)}catch{try{return S.call(null,k,0)}catch{return S.call(this,k,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:M}catch{S=M}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var g,l=[],w=!1,v=-1;function y(){w&&g&&(w=!1,g.length?l=g.concat(l):v=-1,l.length&&h())}function h(){if(!w){var k=P(y);w=!0;for(var u=l.length;u;){for(g=l,l=[];++v<u;)g&&g[v].run();v=-1,u=l.length}g=null,w=!1,function(f){if(D===clearTimeout)return clearTimeout(f);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(f);try{D(f)}catch{try{return D.call(null,f)}catch{return D.call(this,f)}}}(k)}}function m(k,u){this.fun=k,this.array=u}function p(){}s.nextTick=function(k){var u=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)u[f-1]=arguments[f];l.push(new m(k,u)),l.length!==1||w||P(h)},m.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=p,s.addListener=p,s.once=p,s.off=p,s.removeListener=p,s.removeAllListeners=p,s.emit=p,s.prependListener=p,s.prependOnceListener=p,s.listeners=function(k){return[]},s.binding=function(k){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(k){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ae[141],ce([0,1]),function(Y,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0;class D{constructor(P,g,l){this.level=P,this.key=g,this.value=l,this.forward=[]}}const s=void 0;class M{constructor(P,g=2**16){this.comparator=P,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new D(this.c,s,s)}get size(){return this.f}clear(){this.e=new D(this.c,s,s),this.f=0}has(P){return!!M.g(this,P,this.comparator)}get(P){return M.g(this,P,this.comparator)?.value}set(P,g){return M.h(this,P,g,this.comparator)&&(this.f+=1),this}delete(P){const g=M.k(this,P,this.comparator);return g&&(this.f-=1),g}forEach(P,g){let l=this.e.forward[0];for(;l;)P.call(g,l.value,l.key,this),l=l.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",g=this.e.forward[0];for(;g;)P+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return P}static g(P,g,l){let w=P.e;for(let v=P.d-1;v>=0;v--)for(;w.forward[v]&&l(w.forward[v].key,g)<0;)w=w.forward[v];if(w=w.forward[0],w&&l(w.key,g)===0)return w}static h(P,g,l,w){const v=[];let y=P.e;for(let h=P.d-1;h>=0;h--){for(;y.forward[h]&&w(y.forward[h].key,g)<0;)y=y.forward[h];v[h]=y}if(y=y.forward[0],y&&w(y.key,g)===0)return y.value=l,!1;{const h=M.j(P);if(h>P.d){for(let m=P.d;m<h;m++)v[m]=P.e;P.d=h}y=new D(h,g,l);for(let m=0;m<h;m++)y.forward[m]=v[m].forward[m],v[m].forward[m]=y;return!0}}static j(P,g=.5){let l=1;for(;Math.random()<g&&l<P.c;)l+=1;return l}static k(P,g,l){const w=[];let v=P.e;for(let y=P.d-1;y>=0;y--){for(;v.forward[y]&&l(v.forward[y].key,g)<0;)v=v.forward[y];w[y]=v}if(v=v.forward[0],!v||l(v.key,g)!==0)return!1;for(let y=0;y<P.d&&w[y].forward[y]===v;y++)w[y].forward[y]=v.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$_r=M}),define(ae[72],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(M){return new D(M)}constructor(M){this.c=S&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$1d=D}),define(ae[3],ce([0,1,14,84,2,103,72]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.Event=void 0;const P=!1,g=!1;var l;(function(I){I.None=()=>s.$Tc.None;function E(z){if(g){const{onDidAddListener:ee}=z,ie=m.create();let de=0;z.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ie.print()),ee?.()}}}function C(z,ee){return X(z,()=>{},0,void 0,!0,void 0,ee)}I.defer=C;function j(z){return(ee,ie=null,de)=>{let me=!1,Ee;return Ee=z(Pe=>{if(!me)return Ee?Ee.dispose():me=!0,ee.call(ie,Pe)},null,de),me&&Ee.dispose(),Ee}}I.once=j;function U(z,ee,ie){return ue((de,me=null,Ee)=>z(Pe=>de.call(me,ee(Pe)),null,Ee),ie)}I.map=U;function F(z,ee,ie){return ue((de,me=null,Ee)=>z(Pe=>{ee(Pe),de.call(me,Pe)},null,Ee),ie)}I.forEach=F;function V(z,ee,ie){return ue((de,me=null,Ee)=>z(Pe=>ee(Pe)&&de.call(me,Pe),null,Ee),ie)}I.filter=V;function J(z){return z}I.signal=J;function le(...z){return(ee,ie=null,de)=>{const me=(0,s.$Qc)(...z.map(Ee=>Ee(Pe=>ee.call(ie,Pe))));return Z(me,de)}}I.any=le;function re(z,ee,ie,de){let me=ie;return U(z,Ee=>(me=ee(me,Ee),me),de)}I.reduce=re;function ue(z,ee){let ie;const de={onWillAddFirstListener(){ie=z(me.fire,me)},onDidRemoveLastListener(){ie?.dispose()}};ee||E(de);const me=new d(de);return ee?.add(me),me.event}function Z(z,ee){return ee instanceof Array?ee.push(z):ee&&ee.add(z),z}function X(z,ee,ie=100,de=!1,me=!1,Ee,Pe){let Le,ke,ye,te=0,fe;const $e={leakWarningThreshold:Ee,onWillAddFirstListener(){Le=z(Oe=>{te++,ke=ee(ke,Oe),de&&!ye&&(Ce.fire(ke),ke=void 0),fe=()=>{const Ue=ke;ke=void 0,ye=void 0,(!de||te>1)&&Ce.fire(Ue),te=0},typeof ie=="number"?(clearTimeout(ye),ye=setTimeout(fe,ie)):ye===void 0&&(ye=0,queueMicrotask(fe))})},onWillRemoveListener(){me&&te>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,Le.dispose()}};Pe||E($e);const Ce=new d($e);return Pe?.add(Ce),Ce.event}I.debounce=X;function q(z,ee=0,ie){return I.debounce(z,(de,me)=>de?(de.push(me),de):[me],ee,void 0,!0,void 0,ie)}I.accumulate=q;function L(z,ee=(de,me)=>de===me,ie){let de=!0,me;return V(z,Ee=>{const Pe=de||!ee(Ee,me);return de=!1,me=Ee,Pe},ie)}I.latch=L;function T(z,ee,ie){return[I.filter(z,ee,ie),I.filter(z,de=>!ee(de),ie)]}I.split=T;function G(z,ee=!1,ie=[],de){let me=ie.slice(),Ee=z(ke=>{me?me.push(ke):Le.fire(ke)});de&&de.add(Ee);const Pe=()=>{me?.forEach(ke=>Le.fire(ke)),me=null},Le=new d({onWillAddFirstListener(){Ee||(Ee=z(ke=>Le.fire(ke)),de&&de.add(Ee))},onDidAddFirstListener(){me&&(ee?setTimeout(Pe):Pe())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return de&&de.add(Le),Le.event}I.buffer=G;function B(z,ee){return(de,me,Ee)=>{const Pe=ee(new he);return z(function(Le){const ke=Pe.evaluate(Le);ke!==oe&&de.call(me,ke)},void 0,Ee)}}I.chain=B;const oe=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(ie=>(ee(ie),ie)),this}filter(ee){return this.f.push(ie=>ee(ie)?ie:oe),this}reduce(ee,ie){let de=ie;return this.f.push(me=>(de=ee(de,me),de)),this}latch(ee=(ie,de)=>ie===de){let ie=!0,de;return this.f.push(me=>{const Ee=ie||!ee(me,de);return ie=!1,de=me,Ee?me:oe}),this}evaluate(ee){for(const ie of this.f)if(ee=ie(ee),ee===oe)break;return ee}}function K(z,ee,ie=de=>de){const de=(...Le)=>Pe.fire(ie(...Le)),me=()=>z.on(ee,de),Ee=()=>z.removeListener(ee,de),Pe=new d({onWillAddFirstListener:me,onDidRemoveLastListener:Ee});return Pe.event}I.fromNodeEventEmitter=K;function O(z,ee,ie=de=>de){const de=(...Le)=>Pe.fire(ie(...Le)),me=()=>z.addEventListener(ee,de),Ee=()=>z.removeEventListener(ee,de),Pe=new d({onWillAddFirstListener:me,onDidRemoveLastListener:Ee});return Pe.event}I.fromDOMEventEmitter=O;function W(z){return new Promise(ee=>j(z)(ee))}I.toPromise=W;function x(z){const ee=new d;return z.then(ie=>{ee.fire(ie)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}I.fromPromise=x;function N(z,ee,ie){return ee(ie),z(de=>ee(de))}I.runAndSubscribe=N;class Q{constructor(ee,ie){this._observable=ee,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};ie||E(de),this.emitter=new d(de),ie&&ie.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,ie){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function H(z,ee){return new Q(z,ee).emitter.event}I.fromObservable=H;function _(z){return(ee,ie,de)=>{let me=0,Ee=!1;const Pe={beginUpdate(){me++},endUpdate(){me--,me===0&&(z.reportChanges(),Ee&&(Ee=!1,ee.call(ie)))},handlePossibleChange(){},handleChange(){Ee=!0}};z.addObserver(Pe),z.reportChanges();const Le={dispose(){z.removeObserver(Pe)}};return de instanceof s.$Sc?de.add(Le):Array.isArray(de)&&de.push(Le),Le}}I.fromObservableLight=_})(l||(e.Event=l={}));class w{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${w.f++}`,w.all.add(this)}start(E){this.g=new A.$1d,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$3d=w;let v=-1;function y(I){const E=v;return v=I,{dispose(){v=E}}}e.$4d=y;class h{constructor(E,C=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=C,this.g=0}dispose(){this.f?.clear()}check(E,C){const j=this.threshold;if(j<=0||C<j)return;this.f||(this.f=new Map);const U=this.f.get(E.value)||0;if(this.f.set(E.value,U+1),this.g-=1,this.g<=0){this.g=j*.5;let F,V=0;for(const[J,le]of this.f)(!F||V<le)&&(F=J,V=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${V}):`),console.warn(F)}return()=>{const F=this.f.get(E.value)||0;this.f.set(E.value,F-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class k{constructor(E){this.value=E,this.id=p++}}const u=2,f=(I,E)=>{if(I instanceof k)E(I);else for(let C=0;C<I.length;C++){const j=I[C];j&&E(j)}};class d{constructor(E){this.w=0,this.f=E,this.g=v>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new w(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const E=this.t;queueMicrotask(()=>{f(E,C=>C.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,C,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Tc.None;if(this.m)return s.$Tc.None;C&&(E=E.bind(C));const U=new k(E);let F,V;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(U.stack=m.create(),F=this.g.check(U.stack,this.w+1)),P&&(U.stack=V??m.create()),this.t?this.t instanceof k?(this.u??=new a,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.w++;const J=(0,s.$Rc)(()=>{F?.(),this.x(U)});return j instanceof s.$Sc?j.add(J):Array.isArray(j)&&j.push(J),J},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const C=this.t,j=C.indexOf(E);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,C[j]=void 0;const U=this.u.current===this;if(this.w*u<=C.length){let F=0;for(let V=0;V<C.length;V++)C[V]?C[F++]=C[V]:U&&(this.u.end--,F<this.u.i&&this.u.i--);C.length=F}}y(E,C){if(!E)return;const j=this.f?.onListenerError||S.$1;if(!j){E.value(C);return}try{E.value(C)}catch(U){j(U)}}z(E){const C=E.current.t;for(;E.i<E.end;)this.y(C[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof k)this.y(this.t,E);else{const C=this.u;C.enqueue(this,E,this.t.length),this.z(C)}this.j?.stop()}hasListeners(){return this.w>0}}e.$5d=d;const $=()=>new a;e.$6d=$;class a{constructor(){this.i=-1,this.end=0}enqueue(E,C,j){this.i=0,this.end=j,this.current=E,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends d{async fireAsync(E,C,j){if(this.t)for(this.h||(this.h=new M.$4c),f(this.t,U=>this.h.push([U.value,E]));this.h.size>0&&!C.isCancellationRequested;){const[U,F]=this.h.shift(),V=[],J={...F,token:C,waitUntil:le=>{if(Object.isFrozen(V))throw new Error("waitUntil can NOT be called asynchronous");j&&(le=j(le,U)),V.push(le)}};try{U(J)}catch(le){(0,S.$1)(le);continue}Object.freeze(V),await Promise.allSettled(V).then(le=>{for(const re of le)re.status==="rejected"&&(0,S.$1)(re.reason)})}}}e.$7d=t;class o extends d{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new M.$4c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$8d=o;class r extends o{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$9d=r;class i extends d{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}e.$0d=i;class n{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const C={event:E,listener:null};this.h.push(C),this.g&&this.m(C);const j=()=>{this.g&&this.o(C);const U=this.h.indexOf(C);this.h.splice(U,1)};return(0,s.$Rc)((0,D.$db)(j))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(C=>this.f.fire(C))}o(E){E.listener?.dispose(),E.listener=null}dispose(){this.f.dispose();for(const E of this.h)E.listener?.dispose();this.h=[]}}e.$$d=n;class c{constructor(E,C,j,U){this.f=new s.$Sc;const F=this.f.add(new n),V=this.f.add(new s.$3c);function J(le){V.set(le,F.add(U(le)))}for(const le of E)J(le);this.f.add(C(le=>{J(le)})),this.f.add(j(le=>{V.deleteAndDispose(le)})),this.event=F.event}dispose(){this.f.dispose()}}e.$_d=c;class b{constructor(){this.f=[]}wrapEvent(E){return(C,j,U)=>E(F=>{const V=this.f[this.f.length-1];V?V.push(()=>C.call(j,F)):C.call(j,F)},void 0,U)}bufferEvents(E){const C=[];this.f.push(C);const j=E();return this.f.pop(),C.forEach(U=>U()),j}}e.$ae=b;class R{constructor(){this.f=!1,this.g=l.None,this.h=s.$Tc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$be=R}),define(ae[23],ce([0,1,3]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.CancellationToken=void 0;const D=Object.freeze(function(P,g){const l=setTimeout(P.bind(g),0);return{dispose(){clearTimeout(l)}}});var s;(function(P){function g(l){return l===P.None||l===P.Cancelled||l instanceof M?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}P.isCancellationToken=g,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new S.$5d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(g){this.f=void 0,this.g=void 0,this.g=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(g=!1){g&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$ce=A}),define(ae[142],ce([0,1,23]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=void 0;class D{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new S.$ce,g=this.b(P.token);return this.a={promise:g,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$Ne=D;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const g=JSON.stringify(P);return this.b!==g&&(this.b=g,this.a=this.c(P)),this.a}}e.$Oe=s;class M{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const g=this.b(P);return this.a.set(P,g),g}}e.$Pe=M}),define(ae[63],ce([0,1,14,2]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function s($){const a=$;return a?typeof a.read=="function":!1}e.$de=s;function M($){const a=$;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$ee=M;function A($){const a=$;return a?M(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$fe=A;function P($,a){return new g($,a)}e.$ge=P;class g{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,S.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let o;switch(a){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l($,a){const t=[];let o;for(;(o=$.read())!==null;)t.push(o);return a(t)}e.$he=l;function w($,a,t){const o=[];let r;for(;(r=$.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return $.read()}}}e.$ie=w;function v($,a){return new Promise((t,o)=>{const r=[];y($,{onData:i=>{a&&r.push(i)},onError:i=>{a?o(i):t(void 0)},onEnd:()=>{t(a?a(r):void 0)}})})}e.$je=v;function y($,a,t){$.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),$.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),$.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}e.$ke=y;function h($,a){return new Promise((t,o)=>{const r=new D.$Sc,i=[],n=R=>{if(i.push(R),i.length>a)return r.dispose(),$.pause(),t({stream:$,buffer:i,ended:!1})},c=R=>(r.dispose(),o(R)),b=()=>(r.dispose(),t({stream:$,buffer:i,ended:!0}));r.add((0,D.$Rc)(()=>$.removeListener("error",c))),$.on("error",c),r.add((0,D.$Rc)(()=>$.removeListener("end",b))),$.on("end",b),r.add((0,D.$Rc)(()=>$.removeListener("data",n))),$.on("data",n)})}e.$le=h;function m($,a){const t=P(a);return t.end($),t}e.$me=m;function p(){const $=P(()=>{throw new Error("not supported")});return $.end(),$}e.$ne=p;function k($){let a=!1;return{read:()=>a?null:(a=!0,$)}}e.$oe=k;function u($,a,t){const o=P(t);return y($,{onData:r=>o.write(a.data(r)),onError:r=>o.error(a.error?a.error(r):r),onEnd:()=>o.end()}),o}e.$pe=u;function f($,a,t){let o=!1;return{read:()=>{const r=a.read();return o?r:(o=!0,r!==null?t([$,r]):$)}}}e.$qe=f;function d($,a,t){let o=!1;const r=P(t);return y(a,{onData:i=>o?r.write(i):(o=!0,r.write(t([$,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write($)),r.end()}}),r}e.$re=d}),define(ae[17],ce([0,1,62,63]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const s=typeof Buffer<"u",M=new S.$V(()=>new Uint8Array(256));let A,P;class g{static alloc(C){return s?new g(Buffer.allocUnsafe(C)):new g(new Uint8Array(C))}static wrap(C){return s&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new g(C)}static fromString(C,j){return!(j?.dontUseNodeBuffer||!1)&&s?new g(Buffer.from(C)):(A||(A=new TextEncoder),new g(A.encode(C)))}static fromByteArray(C){const j=g.alloc(C.length);for(let U=0,F=C.length;U<F;U++)j.buffer[U]=C[U];return j}static concat(C,j){if(typeof j>"u"){j=0;for(let V=0,J=C.length;V<J;V++)j+=C[V].byteLength}const U=g.alloc(j);let F=0;for(let V=0,J=C.length;V<J;V++){const le=C[V];U.set(le,F),F+=le.byteLength}return U}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=g.alloc(this.byteLength);return C.set(this),C}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(C,j){return new g(this.buffer.subarray(C,j))}set(C,j){if(C instanceof g)this.buffer.set(C.buffer,j);else if(C instanceof Uint8Array)this.buffer.set(C,j);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),j);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return y(this.buffer,C)}writeUInt32BE(C,j){h(this.buffer,C,j)}readUInt32LE(C){return m(this.buffer,C)}writeUInt32LE(C,j){p(this.buffer,C,j)}readUInt8(C){return k(this.buffer,C)}writeUInt8(C,j){u(this.buffer,C,j)}indexOf(C,j=0){return l(this.buffer,C instanceof g?C.buffer:C,j)}}e.$se=g;function l(E,C,j=0){const U=C.byteLength,F=E.byteLength;if(U===0)return 0;if(U===1)return E.indexOf(C[0]);if(U>F-j)return-1;const V=M.value;V.fill(C.length);for(let ue=0;ue<C.length;ue++)V[C[ue]]=C.length-ue-1;let J=j+C.length-1,le=J,re=-1;for(;J<F;)if(E[J]===C[le]){if(le===0){re=J;break}J--,le--}else J+=Math.max(C.length-le,V[E[J]]),le=C.length-1;return re}e.$te=l;function w(E,C){return E[C+0]<<0>>>0|E[C+1]<<8>>>0}e.$ue=w;function v(E,C,j){E[j+0]=C&255,C=C>>>8,E[j+1]=C&255}e.$ve=v;function y(E,C){return E[C]*2**24+E[C+1]*2**16+E[C+2]*2**8+E[C+3]}e.$we=y;function h(E,C,j){E[j+3]=C,C=C>>>8,E[j+2]=C,C=C>>>8,E[j+1]=C,C=C>>>8,E[j]=C}e.$xe=h;function m(E,C){return E[C+0]<<0>>>0|E[C+1]<<8>>>0|E[C+2]<<16>>>0|E[C+3]<<24>>>0}e.$ye=m;function p(E,C,j){E[j+0]=C&255,C=C>>>8,E[j+1]=C&255,C=C>>>8,E[j+2]=C&255,C=C>>>8,E[j+3]=C&255}e.$ze=p;function k(E,C){return E[C]}e.$Ae=k;function u(E,C,j){E[j]=C}e.$Be=u;function f(E){return D.$he(E,C=>g.concat(C))}e.$Ce=f;function d(E){return D.$oe(E)}e.$De=d;function $(E){return D.$je(E,C=>g.concat(C))}e.$Ee=$;async function a(E){return E.ended?g.concat(E.buffer):g.concat([...E.buffer,await $(E.stream)])}e.$Fe=a;function t(E){return D.$me(E,C=>g.concat(C))}e.$Ge=t;function o(E){return D.$pe(E,{data:C=>typeof C=="string"?g.fromString(C):g.wrap(C)},C=>g.concat(C))}e.$He=o;function r(E){return D.$ge(C=>g.concat(C),E)}e.$Ie=r;function i(E,C){return D.$qe(E,C,j=>g.concat(j))}e.$Je=i;function n(E,C){return D.$re(E,C,j=>g.concat(j))}e.$Ke=n;function c(E){let C=0,j=0,U=0;const F=new Uint8Array(Math.floor(E.length/4*3)),V=le=>{switch(j){case 3:F[U++]=C|le,j=0;break;case 2:F[U++]=C|le>>>2,C=le<<6,j=3;break;case 1:F[U++]=C|le>>>4,C=le<<4,j=2;break;default:C=le<<2,j=1}};for(let le=0;le<E.length;le++){const re=E.charCodeAt(le);if(re>=65&&re<=90)V(re-65);else if(re>=97&&re<=122)V(re-97+26);else if(re>=48&&re<=57)V(re-48+52);else if(re===43||re===45)V(62);else if(re===47||re===95)V(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${E[le]}`)}}const J=U;for(;j>0;)V(0);return g.wrap(F).slice(0,J)}e.$Le=c;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:E},C=!0,j=!1){const U=j?R:b;let F="";const V=E.byteLength%3;let J=0;for(;J<E.byteLength-V;J+=3){const le=E[J+0],re=E[J+1],ue=E[J+2];F+=U[le>>>2],F+=U[(le<<4|re>>>4)&63],F+=U[(re<<2|ue>>>6)&63],F+=U[ue&63]}if(V===1){const le=E[J+0];F+=U[le>>>2],F+=U[le<<4&63],C&&(F+="==")}else if(V===2){const le=E[J+0],re=E[J+1];F+=U[le>>>2],F+=U[(le<<4|re>>>4)&63],F+=U[re<<2&63],C&&(F+="=")}return F}e.$Me=I}),define(ae[25],ce([0,1,142,62]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rf=e.$Qf=e.$Pf=e.$Of=e.GraphemeBreakType=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=void 0;function s(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.$Se=s;const M=/{(\d+)}/g;function A(ne,...ge){return ge.length===0?ne:ne.replace(M,function(pe,be){const Se=parseInt(be,10);return isNaN(Se)||Se<0||Se>=ge.length?pe:ge[Se]})}e.$Te=A;const P=/{([^}]+)}/g;function g(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(P,(pe,be)=>ge[be]??pe)}e.$Ue=g;function l(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}e.$Ve=l;function w(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.$We=w;function v(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Xe=v;function y(ne,ge){let pe=0;const be=ge.charCodeAt(0);for(let Se=ne.length-1;Se>=0;Se--)ne.charCodeAt(Se)===be&&pe++;return pe}e.$Ye=y;function h(ne,ge,pe="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${pe}`}e.$Ze=h;function m(ne,ge,pe="\u2026"){if(ne.length<=ge)return ne;const be=Math.ceil(ge/2)-pe.length/2,Se=Math.floor(ge/2)-pe.length/2;return`${ne.substr(0,be)}${pe}${ne.substr(ne.length-Se)}`}e.$1e=m;function p(ne,ge=" "){const pe=k(ne,ge);return u(pe,ge)}e.$2e=p;function k(ne,ge){if(!ne||!ge)return ne;const pe=ge.length;if(pe===0||ne.length===0)return ne;let be=0;for(;ne.indexOf(ge,be)===be;)be=be+pe;return ne.substring(be)}e.$3e=k;function u(ne,ge){if(!ne||!ge)return ne;const pe=ge.length,be=ne.length;if(pe===0||be===0)return ne;let Se=be,Me=-1;for(;Me=ne.lastIndexOf(ge,Se-1),!(Me===-1||Me+pe!==Se);){if(Me===0)return"";Se=Me}return ne.substring(0,Se)}e.$4e=u;function f(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$5e=f;function d(ne){return ne.replace(/\*/g,"")}e.$6e=d;function $(ne,ge,pe={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=v(ne)),pe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let be="";return pe.global&&(be+="g"),pe.matchCase||(be+="i"),pe.multiline&&(be+="m"),pe.unicode&&(be+="u"),new RegExp(ne,be)}e.$7e=$;function a(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.$8e=a;function t(ne){return ne.split(/\r\n|\r|\n/)}e.$9e=t;function o(ne){const ge=[],pe=ne.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(pe.length/2);be++)ge.push(pe[2*be]+(pe[2*be+1]??""));return ge}e.$0e=o;function r(ne){for(let ge=0,pe=ne.length;ge<pe;ge++){const be=ne.charCodeAt(ge);if(be!==32&&be!==9)return ge}return-1}e.$$e=r;function i(ne,ge=0,pe=ne.length){for(let be=ge;be<pe;be++){const Se=ne.charCodeAt(be);if(Se!==32&&Se!==9)return ne.substring(ge,be)}return ne.substring(ge,pe)}e.$_e=i;function n(ne,ge=ne.length-1){for(let pe=ge;pe>=0;pe--){const be=ne.charCodeAt(pe);if(be!==32&&be!==9)return pe}return-1}e.$af=n;function c(ne,ge,pe){const be=[];let Se=0;for(const Me of ne.matchAll(ge)){if(be.push(ne.slice(Se,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Se=Me.index+Me[0].length,be.push(pe(Me[0],...Me.slice(1),Me.index,ne,Me.groups))}return be.push(ne.slice(Se)),Promise.all(be).then(Me=>Me.join(""))}e.$bf=c;function b(ne,ge){return ne<ge?-1:ne>ge?1:0}e.$cf=b;function R(ne,ge,pe=0,be=ne.length,Se=0,Me=ge.length){for(;pe<be&&Se<Me;pe++,Se++){const xe=ne.charCodeAt(pe),Qe=ge.charCodeAt(Se);if(xe<Qe)return-1;if(xe>Qe)return 1}const Te=be-pe,Ye=Me-Se;return Te<Ye?-1:Te>Ye?1:0}e.$df=R;function I(ne,ge){return E(ne,ge,0,ne.length,0,ge.length)}e.$ef=I;function E(ne,ge,pe=0,be=ne.length,Se=0,Me=ge.length){for(;pe<be&&Se<Me;pe++,Se++){let xe=ne.charCodeAt(pe),Qe=ge.charCodeAt(Se);if(xe===Qe)continue;if(xe>=128||Qe>=128)return R(ne.toLowerCase(),ge.toLowerCase(),pe,be,Se,Me);j(xe)&&(xe-=32),j(Qe)&&(Qe-=32);const Ze=xe-Qe;if(Ze!==0)return Ze}const Te=be-pe,Ye=Me-Se;return Te<Ye?-1:Te>Ye?1:0}e.$ff=E;function C(ne){return ne>=48&&ne<=57}e.$gf=C;function j(ne){return ne>=97&&ne<=122}e.$hf=j;function U(ne){return ne>=65&&ne<=90}e.$if=U;function F(ne,ge){return ne.length===ge.length&&E(ne,ge)===0}e.$jf=F;function V(ne,ge){const pe=ge.length;return ge.length>ne.length?!1:E(ne,ge,0,pe)===0}e.$kf=V;function J(ne,ge){const pe=Math.min(ne.length,ge.length);let be;for(be=0;be<pe;be++)if(ne.charCodeAt(be)!==ge.charCodeAt(be))return be;return pe}e.$lf=J;function le(ne,ge){const pe=Math.min(ne.length,ge.length);let be;const Se=ne.length-1,Me=ge.length-1;for(be=0;be<pe;be++)if(ne.charCodeAt(Se-be)!==ge.charCodeAt(Me-be))return be;return pe}e.$mf=le;function re(ne){return 55296<=ne&&ne<=56319}e.$nf=re;function ue(ne){return 56320<=ne&&ne<=57343}e.$of=ue;function Z(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}e.$pf=Z;function X(ne,ge,pe){const be=ne.charCodeAt(pe);if(re(be)&&pe+1<ge){const Se=ne.charCodeAt(pe+1);if(ue(Se))return Z(be,Se)}return be}e.$qf=X;function q(ne,ge){const pe=ne.charCodeAt(ge-1);if(ue(pe)&&ge>1){const be=ne.charCodeAt(ge-2);if(re(be))return Z(be,pe)}return pe}class L{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=q(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=X(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$rf=L;class T{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new L(ge,pe)}nextGraphemeLength(){const ge=Oe.getInstance(),pe=this.c,be=pe.offset;let Se=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Me=pe.offset,Te=ge.getGraphemeBreakType(pe.nextCodePoint());if($e(Se,Te)){pe.setOffset(Me);break}Se=Te}return pe.offset-be}prevGraphemeLength(){const ge=Oe.getInstance(),pe=this.c,be=pe.offset;let Se=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Me=pe.offset,Te=ge.getGraphemeBreakType(pe.prevCodePoint());if($e(Te,Se)){pe.setOffset(Me);break}Se=Te}return be-pe.offset}eol(){return this.c.eol()}}e.$sf=T;function G(ne,ge){return new T(ne,ge).nextGraphemeLength()}e.$tf=G;function B(ne,ge){return new T(ne,ge).prevGraphemeLength()}e.$uf=B;function oe(ne,ge){ge>0&&ue(ne.charCodeAt(ge))&&ge--;const pe=ge+G(ne,ge);return[pe-B(ne,pe),pe]}e.$vf=oe;function he(ne){const ge=new T(ne);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}e.$wf=he;let K;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(ne){return K||(K=O()),K.test(ne)}e.$xf=W;const x=/^[\t\n\r\x20-\x7E]*$/;function N(ne){return x.test(ne)}e.$yf=N,e.$zf=/[\u2028\u2029]/;function Q(ne){return e.$zf.test(ne)}e.$Af=Q;function H(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.$Bf=H;function _(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.$Cf=_;function z(ne,ge,pe=""){const be=ne.trimStart();if(be.length<ge)return be;const Se=/\b/g;let Me=0;for(;Se.test(be)&&!(be.length-Se.lastIndex<ge);)Me=Se.lastIndex,Se.lastIndex+=1;return Me===0?be:pe+be.substring(Me).trimStart()}e.$Df=z;const ee=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function de(ne){return ne&&(ne=ne.replace(ee,"").replace(ie,"")),ne}e.$Ef=de,e.$Ff="\uFEFF";function me(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.$Gf=me;function Ee(ne){return me(ne)?ne.substr(1):ne}e.$Hf=Ee;function Pe(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const pe=ge.length,be=ne.toLowerCase();let Se=0,Me=-1;for(;Se<pe;){const Te=be.indexOf(ge[Se],Me+1);if(Te<0)return!1;Me=Te,Se++}return!0}e.$If=Pe;function Le(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.$Jf=Le;function ke(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.$Kf=ke;function ye(ne,ge=1){if(ge===0)return"";let pe=-1;do pe=ne.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?ne:(ne[pe-1]==="\r"&&pe--,ne.substr(0,pe))}e.$Lf=ye;function te(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.$Mf=te;function fe(ne){return Oe.getInstance().getGraphemeBreakType(ne)}e.$Nf=fe;function $e(ne,ge){return ne===0?ge!==5&&ge!==7:ne===2&&ge===3?!1:ne===4||ne===2||ne===3||ge===4||ge===2||ge===3?!0:!(ne===8&&(ge===8||ge===9||ge===11||ge===12)||(ne===11||ne===9)&&(ge===9||ge===10)||(ne===12||ne===10)&&ge===10||ge===5||ge===13||ge===7||ne===1||ne===13&&ge===14||ne===6&&ge===6)}var Ce;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class Oe{static{this.c=null}static getInstance(){return Oe.c||(Oe.c=new Oe),Oe.c}constructor(){this.d=Ue()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const pe=this.d,be=pe.length/3;let Se=1;for(;Se<=be;)if(ge<pe[3*Se])Se=2*Se;else if(ge>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(ne,ge){if(ne===0)return 0;const pe=Ge(ne,ge);if(pe!==void 0)return pe;const be=new L(ge,ne);return be.prevCodePoint(),be.offset}e.$Of=je;function Ge(ne,ge){const pe=new L(ge,ne);let be=pe.prevCodePoint();for(;qe(be)||be===65039||be===8419;){if(pe.offset===0)return;be=pe.prevCodePoint()}if(!_(be))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function qe(ne){return 127995<=ne&&ne<=127999}var Ke;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Ke||(Ke={})),e.$Pf="\xA0";class He{static{this.c=new D.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$Oe(ge=>{function pe(Ze){const st=new Map;for(let tt=0;tt<Ze.length;tt+=2)st.set(Ze[tt],Ze[tt+1]);return st}function be(Ze,st){const tt=new Map(Ze);for(const[ot,at]of st)tt.set(ot,at);return tt}function Se(Ze,st){if(!Ze)return st;const tt=new Map;for(const[ot,at]of Ze)st.has(ot)&&tt.set(ot,at);return tt}const Me=this.c.value;let Te=ge.filter(Ze=>!Ze.startsWith("_")&&Ze in Me);Te.length===0&&(Te=["_default"]);let Ye;for(const Ze of Te){const st=pe(Me[Ze]);Ye=Se(Ye,st)}const xe=pe(Me._common),Qe=be(xe,Ye);return new He(Qe)})}static getInstance(ge){return He.d.get(Array.from(ge))}static{this.e=new D.$V(()=>Object.keys(He.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return He.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Qf=He;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(ge){return Be.e().has(ge)}static get codePoints(){return Be.e()}}e.$Rf=Be}),define(ae[45],ce([0,1,25]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=void 0;function D(u){return s(u,0)}e.$5i=D;function s(u,f){switch(typeof u){case"object":return u===null?M(349,f):Array.isArray(u)?g(u,f):l(u,f);case"string":return P(u,f);case"boolean":return A(u,f);case"number":return M(u,f);case"undefined":return M(937,f);default:return M(617,f)}}e.$6i=s;function M(u,f){return(f<<5)-f+u|0}e.$7i=M;function A(u,f){return M(u?433:863,f)}function P(u,f){f=M(149417,f);for(let d=0,$=u.length;d<$;d++)f=M(u.charCodeAt(d),f);return f}e.$8i=P;function g(u,f){return f=M(104579,f),u.reduce((d,$)=>s($,d),f)}function l(u,f){return f=M(181387,f),Object.keys(u).sort().reduce((d,$)=>(d=P($,d),s(u[$],d)),f)}class w{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=s(f,this.g),this.g}}e.$9i=w;var v;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function y(u,f,d=32){const $=d-f,a=~((1<<$)-1);return(u<<f|(a&u)>>>$)>>>0}function h(u,f=0,d=u.byteLength,$=0){for(let a=0;a<d;a++)u[f+a]=$}function m(u,f,d="0"){for(;u.length<f;)u=d+u;return u}function p(u,f=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(d=>d.toString(16).padStart(2,"0")).join(""):m((u>>>0).toString(16),f/4)}e.$0i=p;class k{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const d=f.length;if(d===0)return;const $=this.p;let a=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=f.charCodeAt(0),r=0);;){let i=o;if(S.$nf(o))if(r+1<d){const n=f.charCodeAt(r+1);S.$of(n)?(r++,i=S.$pf(o,n)):i=65533}else{t=o;break}else S.$of(o)&&(i=65533);if(a=this.w($,a,i),r++,r<d)o=f.charCodeAt(r);else break}this.r=a,this.u=t}w(f,d,$){return $<128?f[d++]=$:$<2048?(f[d++]=192|($&1984)>>>6,f[d++]=128|($&63)>>>0):$<65536?(f[d++]=224|($&61440)>>>12,f[d++]=128|($&4032)>>>6,f[d++]=128|($&63)>>>0):(f[d++]=240|($&1835008)>>>18,f[d++]=128|($&258048)>>>12,f[d++]=128|($&4032)>>>6,f[d++]=128|($&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=k.g,d=this.q;for(let b=0;b<64;b+=4)f.setUint32(b,d.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)f.setUint32(b,y(f.getUint32(b-12,!1)^f.getUint32(b-32,!1)^f.getUint32(b-56,!1)^f.getUint32(b-64,!1),1),!1);let $=this.h,a=this.l,t=this.m,o=this.n,r=this.o,i,n,c;for(let b=0;b<80;b++)b<20?(i=a&t|~a&o,n=1518500249):b<40?(i=a^t^o,n=1859775393):b<60?(i=a&t|a&o|t&o,n=2400959708):(i=a^t^o,n=3395469782),c=y($,5)+i+r+n+f.getUint32(b*4,!1)&4294967295,r=o,o=t,t=y(a,30),a=$,$=c;this.h=this.h+$&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$$i=k}),define(ae[73],ce([0,1,25]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(D||(D={})),function(s){const M="error",A="warning",P="warn",g="info",l="ignore";function w(y){return y?S.$jf(M,y)?s.Error:S.$jf(A,y)||S.$jf(P,y)?s.Warning:S.$jf(g,y)?s.Info:s.Ignore:s.Ignore}s.fromValue=w;function v(y){switch(y){case s.Error:return M;case s.Warning:return A;case s.Info:return g;default:return l}}s.toString=v}(D||(D={})),e.default=D}),define(ae[143],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0,e.$2d=Symbol("MicrotaskDelay")}),define(ae[59],ce([0,1,22,25]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;class s{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const m=h.charCodeAt(0),p=this.b.charCodeAt(this.c);return m-p}value(){return this.b[this.c]}}e.$gi=s;class M{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,D.$df)(h,this.b,0,h.length,this.c,this.d):(0,D.$ff)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$hi=M;class A{constructor(h=!0,m=!0){this.f=h,this.g=m}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let m=h.length-1;m>=0;m--,this.c--){const p=this.b.charCodeAt(m);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,D.$df)(h,this.b,0,h.length,this.d,this.e):(0,D.$ff)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ii=A;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class g{constructor(h,m){this.f=h,this.g=m,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,D.$ef)(h,this.c.scheme);if(this.d[this.e]===2)return(0,D.$ef)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,D.$cf)(h,this.c.query);if(this.d[this.e]===5)return(0,D.$cf)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ji=g;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(w||(w={}));class v{static forUris(h=()=>!1,m=()=>!1){return new v(new g(h,m))}static forPaths(h=!1){return new v(new A(void 0,!h))}static forStrings(){return new v(new s)}static forConfigKeys(){return new v(new M)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,m){if(m){const p=m.slice(0);(0,S.$Xb)(p);for(const k of p)this.set(k,h)}else{const p=h.slice(0);(0,S.$Xb)(p);for(const k of p)this.set(k[0],k[1])}}set(h,m){const p=this.b.reset(h);let k;this.c||(this.c=new l,this.c.segment=p.value());const u=[];for(k=this.c;;){const d=p.cmp(k.segment);if(d>0)k.left||(k.left=new l,k.left.segment=p.value()),u.push([-1,k]),k=k.left;else if(d<0)k.right||(k.right=new l,k.right.segment=p.value()),u.push([1,k]),k=k.right;else if(p.hasNext())p.next(),k.mid||(k.mid=new l,k.mid.segment=p.value()),u.push([0,k]),k=k.mid;else break}const f=k.value;k.value=m,k.key=h;for(let d=u.length-1;d>=0;d--){const $=u[d][1];$.updateHeight();const a=$.balanceFactor();if(a<-1||a>1){const t=u[d][0],o=u[d+1][0];if(t===1&&o===1)u[d][1]=$.rotateLeft();else if(t===-1&&o===-1)u[d][1]=$.rotateRight();else if(t===1&&o===-1)$.right=u[d+1][1]=u[d+1][1].rotateRight(),u[d][1]=$.rotateLeft();else if(t===-1&&o===1)$.left=u[d+1][1]=u[d+1][1].rotateLeft(),u[d][1]=$.rotateRight();else throw new Error;if(d>0)switch(u[d-1][0]){case-1:u[d-1][1].left=u[d][1];break;case 1:u[d-1][1].right=u[d][1];break;case 0:u[d-1][1].mid=u[d][1];break}else this.c=u[0][1]}}return f}get(h){return this.d(h)?.value}d(h){const m=this.b.reset(h);let p=this.c;for(;p;){const k=m.cmp(p.segment);if(k>0)p=p.left;else if(k<0)p=p.right;else if(m.hasNext())m.next(),p=p.mid;else break}return p}has(h){const m=this.d(h);return!(m?.value===void 0&&m?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,m){const p=this.b.reset(h),k=[];let u=this.c;for(;u;){const f=p.cmp(u.segment);if(f>0)k.push([-1,u]),u=u.left;else if(f<0)k.push([1,u]),u=u.right;else if(p.hasNext())p.next(),k.push([0,u]),u=u.mid;else break}if(u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const f=this.f(u.right);if(f.key){const{key:d,value:$,segment:a}=f;this.e(f.key,!1),u.key=d,u.value=$,u.segment=a}}else{const f=u.left??u.right;if(k.length>0){const[d,$]=k[k.length-1];switch(d){case-1:$.left=f;break;case 0:$.mid=f;break;case 1:$.right=f;break}}else this.c=f}for(let f=k.length-1;f>=0;f--){const d=k[f][1];d.updateHeight();const $=d.balanceFactor();if($>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),k[f][1]=d.rotateLeft()):$<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),k[f][1]=d.rotateRight()),f>0)switch(k[f-1][0]){case-1:k[f-1][1].left=k[f][1];break;case 1:k[f-1][1].right=k[f][1];break;case 0:k[f-1][1].mid=k[f][1];break}else this.c=k[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const m=this.b.reset(h);let p=this.c,k;for(;p;){const u=m.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(m.hasNext())m.next(),k=p.value||k,p=p.mid;else break}return p&&p.value||k}findSuperstr(h){return this.g(h,!1)}g(h,m){const p=this.b.reset(h);let k=this.c;for(;k;){const u=p.cmp(k.segment);if(u>0)k=k.left;else if(u<0)k=k.right;else if(p.hasNext())p.next(),k=k.mid;else return k.mid?this.h(k.mid):m?k.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[m,p]of this)h(p,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const m=[];return this.j(h,m),m[Symbol.iterator]()}j(h,m){h&&(h.left&&this.j(h.left,m),h.value&&m.push([h.key,h.value]),h.mid&&this.j(h.mid,m),h.right&&this.j(h.right,m))}_isBalanced(){const h=m=>{if(!m)return!0;const p=m.balanceFactor();return p<-1||p>1?!1:h(m.left)&&h(m.right)};return h(this.c)}}e.$ki=v}),define(ae[12],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=void 0;function S(a){return typeof a=="string"}e.$Sf=S;function D(a){return Array.isArray(a)&&a.every(t=>S(t))}e.$Tf=D;function s(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Uf=s;function M(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Vf=M;function A(a){return typeof a=="number"&&!isNaN(a)}e.$Wf=A;function P(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Xf=P;function g(a){return a===!0||a===!1}e.$Yf=g;function l(a){return typeof a>"u"}e.$Zf=l;function w(a){return!v(a)}e.$1f=w;function v(a){return l(a)||a===null}e.$2f=v;function y(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$3f=y;function h(a){if(v(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$4f=h;function m(...a){const t=[];for(let o=0;o<a.length;o++){const r=a[o];if(v(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}e.$5f=m;const p=Object.prototype.hasOwnProperty;function k(a){if(!s(a))return!1;for(const t in a)if(p.call(a,t))return!1;return!0}e.$6f=k;function u(a){return typeof a=="function"}e.$7f=u;function f(...a){return a.length>0&&a.every(u)}e.$8f=f;function d(a,t){const o=Math.min(a.length,t.length);for(let r=0;r<o;r++)$(a[r],t[r])}e.$9f=d;function $(a,t){if(S(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(a instanceof t)return}catch{}if(!v(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$0f=$}),define(ae[74],ce([0,1,12]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=void 0;const D=Object.create(null);function s(P,g){if((0,S.$Sf)(g)){const l=D[g];if(l===void 0)throw new Error(`${P} references an unknown codicon: ${g}`);g=l}return D[P]=g,{id:P}}function M(){return D}e.$ik=M;function A(){return Object.values(e.$kk)}e.$jk=A,e.$kk={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugBreakpointPending:s("debug-breakpoint-pending",60377),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),diffSingle:s("diff-single",60450),diffMultiple:s("diff-multiple",60451),surroundWith:s("surround-with",60452),gitStash:s("git-stash",60454),gitStashApply:s("git-stash-apply",60455),gitStashPop:s("git-stash-pop",60456),coverage:s("coverage",60462),runAllCoverage:s("run-all-coverage",60461),runCoverage:s("run-all-coverage",60460),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ae[35],ce([0,1,12]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function D(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const f=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([d,$])=>{f[d]=$&&typeof $=="object"?D($):$}),f}e.$Hn=D;function s(u){if(!u||typeof u!="object")return u;const f=[u];for(;f.length>0;){const d=f.shift();Object.freeze(d);for(const $ in d)if(M.call(d,$)){const a=d[$];typeof a=="object"&&!Object.isFrozen(a)&&!(0,S.$Vf)(a)&&f.push(a)}}return u}e.$In=s;const M=Object.prototype.hasOwnProperty;function A(u,f){return P(u,f,new Set)}e.$Jn=A;function P(u,f,d){if((0,S.$2f)(u))return u;const $=f(u);if(typeof $<"u")return $;if(Array.isArray(u)){const a=[];for(const t of u)a.push(P(t,f,d));return a}if((0,S.$Uf)(u)){if(d.has(u))throw new Error("Cannot clone recursive data-structure");d.add(u);const a={};for(const t in u)M.call(u,t)&&(a[t]=P(u[t],f,d));return d.delete(u),a}return u}function g(u,f,d=!0){return(0,S.$Uf)(u)?((0,S.$Uf)(f)&&Object.keys(f).forEach($=>{$ in u?d&&((0,S.$Uf)(u[$])&&(0,S.$Uf)(f[$])?g(u[$],f[$],d):u[$]=f[$]):u[$]=f[$]}),u):f}e.$Kn=g;function l(u,f){if(u===f)return!0;if(u==null||f===null||f===void 0||typeof u!=typeof f||typeof u!="object"||Array.isArray(u)!==Array.isArray(f))return!1;let d,$;if(Array.isArray(u)){if(u.length!==f.length)return!1;for(d=0;d<u.length;d++)if(!l(u[d],f[d]))return!1}else{const a=[];for($ in u)a.push($);a.sort();const t=[];for($ in f)t.push($);if(t.sort(),!l(a,t))return!1;for(d=0;d<a.length;d++)if(!l(u[a[d]],f[a[d]]))return!1}return!0}e.$Ln=l;function w(u){const f=new Set;return JSON.stringify(u,(d,$)=>{if((0,S.$Uf)($)||Array.isArray($)){if(f.has($))return"[Circular]";f.add($)}return $})}e.$Mn=w;function v(u,f){const d=Object.create(null);return!u||!f||Object.keys(f).forEach(a=>{const t=u[a],o=f[a];l(t,o)||(d[a]=o)}),d}e.$Nn=v;function y(u,f){const d=f.toLowerCase(),$=Object.keys(u).find(a=>a.toLowerCase()===d);return $?u[$]:u[f]}e.$On=y;function h(u,f){const d=Object.create(null);for(const[$,a]of Object.entries(u))f($,a)&&(d[$]=a);return d}e.$Pn=h;function m(u){let f=[];for(;Object.prototype!==u;)f=f.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return f}e.$Qn=m;function p(u){const f=[];for(const d of m(u))typeof u[d]=="function"&&f.push(d);return f}e.$Rn=p;function k(u,f){const d=a=>function(){const t=Array.prototype.slice.call(arguments,0);return f(a,t)},$={};for(const a of u)$[a]=d(a);return $}e.$Sn=k}),define(ae[104],ce([0,1,74]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$lk=e.ThemeColor=void 0;var D;(function(A){function P(g){return g&&typeof g=="object"&&typeof g.id=="string"}A.isThemeColor=P})(D||(e.ThemeColor=D={}));function s(A){return{id:A}}e.$lk=s;var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function g(f){const d=P.exec(f.id);if(!d)return g(S.$kk.error);const[,$,a]=d,t=["codicon","codicon-"+$];return a&&t.push("codicon-modifier-"+a.substring(1)),t}A.asClassNameArray=g;function l(f){return g(f).join(" ")}A.asClassName=l;function w(f){return"."+g(f).join(".")}A.asCSSSelector=w;function v(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||D.isThemeColor(f.color))}A.isThemeIcon=v;const y=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function h(f){const d=y.exec(f);if(!d)return;const[,$]=d;return{id:$}}A.fromString=h;function m(f){return{id:f}}A.fromId=m;function p(f,d){let $=f.id;const a=$.lastIndexOf("~");return a!==-1&&($=$.substring(0,a)),d&&($=`${$}~${d}`),{id:$}}A.modify=p;function k(f){const d=f.id.lastIndexOf("~");if(d!==-1)return f.id.substring(d+1)}A.getModifier=k;function u(f,d){return f.id===d.id&&f.color?.id===d.color?.id}A.isEqual=u})(M||(e.ThemeIcon=M={}))}),define(ae[32],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=e.$zg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(s){return S.test(s)}e.$zg=D,e.$Ag=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let g=0;g<P.length;g++)P[g]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let g=0,l="";return l+=A[M[g++]],l+=A[M[g++]],l+=A[M[g++]],l+=A[M[g++]],l+="-",l+=A[M[g++]],l+=A[M[g++]],l+="-",l+=A[M[g++]],l+=A[M[g++]],l+="-",l+=A[M[g++]],l+=A[M[g++]],l+="-",l+=A[M[g++]],l+=A[M[g++]],l+=A[M[g++]],l+=A[M[g++]],l+=A[M[g++]],l+=A[M[g++]],l}}()}),define(ae[144],ce([0,1,86,46,84]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vV=void 0;async function M(A,P){if(await new Promise((w,v)=>{const y=D.createReadStream(A),h=S.createHash("sha256");y.pipe(h);const m=(0,s.$db)((p,k)=>{y.removeAllListeners(),h.removeAllListeners(),p?v(p):w(k)});y.once("error",m),y.once("end",m),h.once("error",m),h.once("data",p=>m(void 0,p.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$vV=M}),define(ae[145],ce([0,1,26]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(A){const P=A.replace(/\-/g,":").toLowerCase();return!D.has(P)}function M(){const A=(0,S.networkInterfaces)();for(const P in A){const g=A[P];if(g){for(const{mac:l}of g)if(s(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$in=M}),define(ae[105],ce([0,1,87]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.$Dg=e.$Cg=void 0;function D(P,g,l,w=1){let v=!1;return new Promise(y=>{const h=setTimeout(()=>{if(!v)return v=!0,y(0)},l);s(P,g,w,m=>{if(!v)return v=!0,clearTimeout(h),y(m)})})}e.$Cg=D;function s(P,g,l,w){if(g===0)return w(0);const v=new S.Socket;v.once("connect",()=>(A(v),s(P+l,g-1,l,w))),v.once("data",()=>{}),v.once("error",y=>(A(v),y.code!=="ECONNREFUSED"?s(P+l,g-1,l,w):w(P))),v.connect(P,"127.0.0.1")}e.$Dg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(P,g,l,w="127.0.0.1"){let v=!1,y,h=1;const m=S.createServer({pauseOnConnect:!0});function p(k,u){v||(v=!0,m.removeAllListeners(),m.close(),y&&clearTimeout(y),u(k))}return new Promise(k=>{y=setTimeout(()=>{p(0,k)},l),m.on("listening",()=>{p(P,k)}),m.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&h<g?(P++,h++,m.listen(P,w)):p(0,k)}),m.on("close",()=>{p(0,k)}),m.listen(P,w)})}e.$Eg=M;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(g){console.error(g)}}}),function(){function Y(){function e(){return process.uncHostAllowlist}function S(g){const l=new Set;if(Array.isArray(g))for(const w of g)typeof w=="string"&&l.add(w);return Array.from(l)}function D(){const g=e();return g?Array.from(g):[]}function s(g){if(process.platform!=="win32")return;const l=e();if(l)if(typeof g=="string")l.add(g.toLowerCase());else for(const w of S(g))s(w)}function M(g){if(typeof g!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let w;for(const v of l){if(g.indexOf(v)!==0)continue;const h=g.indexOf("\\",v.length);if(h===-1)continue;const m=g.substring(v.length,h);if(m){w=m;break}}return w}function A(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:D,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:A,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Y()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Y():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ae[146],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zV=e.$yV=void 0,e.$yV="vscode:contextmenu",e.$zV="vscode:onCloseContextMenu"}),define(ae[147],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GV=void 0;class S{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$GV=S}),define(ae[148],ce([11,10]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(ae[149],ce([0,1,148]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=e.$Gm=void 0;const D=60,s=D*60,M=s*24,A=M*7,P=M*30,g=M*365;function l(y,h,m,p){typeof y!="number"&&(y=y.getTime());const k=Math.round((new Date().getTime()-y)/1e3);if(k<-30)return(0,S.localize)(0,null,l(new Date().getTime()+k*1e3,!1));if(!p&&k<30)return(0,S.localize)(1,null);let u;return k<D?(u=k,h?u===1?m?(0,S.localize)(2,null,u):(0,S.localize)(3,null,u):m?(0,S.localize)(4,null,u):(0,S.localize)(5,null,u):u===1?m?(0,S.localize)(6,null,u):(0,S.localize)(7,null,u):m?(0,S.localize)(8,null,u):(0,S.localize)(9,null,u)):k<s?(u=Math.floor(k/D),h?u===1?m?(0,S.localize)(10,null,u):(0,S.localize)(11,null,u):m?(0,S.localize)(12,null,u):(0,S.localize)(13,null,u):u===1?m?(0,S.localize)(14,null,u):(0,S.localize)(15,null,u):m?(0,S.localize)(16,null,u):(0,S.localize)(17,null,u)):k<M?(u=Math.floor(k/s),h?u===1?m?(0,S.localize)(18,null,u):(0,S.localize)(19,null,u):m?(0,S.localize)(20,null,u):(0,S.localize)(21,null,u):u===1?m?(0,S.localize)(22,null,u):(0,S.localize)(23,null,u):m?(0,S.localize)(24,null,u):(0,S.localize)(25,null,u)):k<A?(u=Math.floor(k/M),h?u===1?(0,S.localize)(26,null,u):(0,S.localize)(27,null,u):u===1?(0,S.localize)(28,null,u):(0,S.localize)(29,null,u)):k<P?(u=Math.floor(k/A),h?u===1?m?(0,S.localize)(30,null,u):(0,S.localize)(31,null,u):m?(0,S.localize)(32,null,u):(0,S.localize)(33,null,u):u===1?m?(0,S.localize)(34,null,u):(0,S.localize)(35,null,u):m?(0,S.localize)(36,null,u):(0,S.localize)(37,null,u)):k<g?(u=Math.floor(k/P),h?u===1?m?(0,S.localize)(38,null,u):(0,S.localize)(39,null,u):m?(0,S.localize)(40,null,u):(0,S.localize)(41,null,u):u===1?m?(0,S.localize)(42,null,u):(0,S.localize)(43,null,u):m?(0,S.localize)(44,null,u):(0,S.localize)(45,null,u)):(u=Math.floor(k/g),h?u===1?m?(0,S.localize)(46,null,u):(0,S.localize)(47,null,u):m?(0,S.localize)(48,null,u):(0,S.localize)(49,null,u):u===1?m?(0,S.localize)(50,null,u):(0,S.localize)(51,null,u):m?(0,S.localize)(52,null,u):(0,S.localize)(53,null,u))}e.$Gm=l;function w(y,h){const m=Math.abs(y/1e3);return m<1?h?(0,S.localize)(54,null,y):(0,S.localize)(55,null,y):m<D?h?(0,S.localize)(56,null,Math.round(y)/1e3):(0,S.localize)(57,null,Math.round(y)/1e3):m<s?h?(0,S.localize)(58,null,Math.round(y/(1e3*D))):(0,S.localize)(59,null,Math.round(y/(1e3*D))):m<M?h?(0,S.localize)(60,null,Math.round(y/(1e3*s))):(0,S.localize)(61,null,Math.round(y/(1e3*s))):(0,S.localize)(62,null,Math.round(y/(1e3*M)))}e.$Hm=w;function v(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Im=v}),define(ae[150],ce([11,10]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ae[51],ce([0,1,22,12,150]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=void 0;function M(v,y){return y&&(v.stack||v.stacktrace)?s.localize(0,null,P(v),A(v.stack)||A(v.stacktrace)):P(v)}function A(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?s.localize(1,null,v.message):v.message||s.localize(2,null)}function g(v=null,y=!1){if(!v)return s.localize(3,null);if(Array.isArray(v)){const h=S.$Hb(v),m=g(h[0],y);return h.length>1?s.localize(4,null,m,h.length):m}if(D.$Sf(v))return v;if(v.detail){const h=v.detail;if(h.error)return M(h.error,y);if(h.exception)return M(h.exception,y)}return v.stack?M(v,y):v.message?v.message:s.localize(5,null)}e.$2i=g;function l(v){const y=v;return y instanceof Error&&Array.isArray(y.actions)}e.$3i=l;function w(v,y){let h;return typeof v=="string"?h=new Error(v):h=v,h.actions=y,h}e.$4i=w}),define(ae[151],ce([11,10]),function(Y,e){return Y.create("vs/base/common/jsonErrorMessages",e)}),define(ae[152],ce([0,1,151]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;function D(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$9p=D}),define(ae[153],ce([11,10]),function(Y,e){return Y.create("vs/base/common/platform",e)}),define(ae[4],ce([0,1,153]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let D=!1,s=!1,M=!1,A=!1,P=!1,g=!1,l=!1,w=!1,v=!1,y=!1,h,m=e.$g,p=e.$g,k,u;const f=globalThis;let d;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?d=f.vscode.process:typeof process<"u"&&(d=process);const $=typeof d?.versions?.electron=="string",a=$&&d?.type==="renderer";if(typeof d=="object"){D=d.platform==="win32",s=d.platform==="darwin",M=d.platform==="linux",A=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,l=$,v=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$g,m=e.$g;const E=d.env.VSCODE_NLS_CONFIG;if(E)try{const C=JSON.parse(E),j=C.availableLanguages["*"];h=C.locale,p=C.osLocale,m=j||e.$g,k=C._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!a?(u=navigator.userAgent,D=u.indexOf("Windows")>=0,s=u.indexOf("Macintosh")>=0,w=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=u.indexOf("Linux")>=0,y=u?.indexOf("Mobi")>=0,g=!0,h=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$g,m=h,p=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;s?r=1:D?r=3:M&&(r=2),e.$i=D,e.$j=s,e.$k=M,e.$l=A,e.$m=P,e.$n=l,e.$o=g,e.$p=g&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=w,e.$s=y,e.$t=v,e.$u=r,e.$v=u,e.$w=m;var i;(function(E){function C(){return e.$w}E.value=C;function j(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=j;function U(){return e.$w==="en"}E.isDefault=U})(i||(e.Language=i={})),e.$x=h,e.$y=p,e.$z=k,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const E=[];f.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let U=0,F=E.length;U<F;U++){const V=E[U];if(V.id===j.data.vscodeScheduleAsyncWork){E.splice(U,1),V.callback();return}}});let C=0;return j=>{const U=++C;E.push({id:U,callback:j}),f.postMessage({vscodeScheduleAsyncWork:U},"*")}}return E=>setTimeout(E)})();var n;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||w?2:D?1:3;let c=!0,b=!1;function R(){if(!b){b=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,c=new Uint16Array(E.buffer)[0]===513}return c}e.$D=R,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(E){return parseFloat(E)>=20}e.$J=I}),define(ae[36],ce([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let D;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const M=s.process;D={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return S.$i?"win32":S.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.$dc=D.platform,e.$ec=D.arch}),define(ae[9],ce([0,1,36]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const D=65,s=97,M=90,A=122,P=46,g=47,l=92,w=58,v=63;class y extends Error{constructor(o,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const c=o.indexOf(".")!==-1?"property":"argument";let b=`The "${o}" ${c} ${n} of type ${r}`;b+=`. Received type ${typeof i}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,o){if(t===null||typeof t!="object")throw new y(o,"Object",t)}function m(t,o){if(typeof t!="string")throw new y(o,"string",t)}const p=S.$dc==="win32";function k(t){return t===g||t===l}function u(t){return t===g}function f(t){return t>=D&&t<=M||t>=s&&t<=A}function d(t,o,r,i){let n="",c=0,b=-1,R=0,I=0;for(let E=0;E<=t.length;++E){if(E<t.length)I=t.charCodeAt(E);else{if(i(I))break;I=g}if(i(I)){if(!(b===E-1||R===1))if(R===2){if(n.length<2||c!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const C=n.lastIndexOf(r);C===-1?(n="",c=0):(n=n.slice(0,C),c=n.length-1-n.lastIndexOf(r)),b=E,R=0;continue}else if(n.length!==0){n="",c=0,b=E,R=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",c=2)}else n.length>0?n+=`${r}${t.slice(b+1,E)}`:n=t.slice(b+1,E),c=E-b-1;b=E,R=0}else I===P&&R!==-1?++R:R=-1}return n}function $(t,o){h(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$fc={resolve(...t){let o="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let c;if(n>=0){if(c=t[n],m(c,"path"),c.length===0)continue}else o.length===0?c=S.cwd():(c=S.env[`=${o}`]||S.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==o.toLowerCase()&&c.charCodeAt(2)===l)&&(c=`${o}\\`));const b=c.length;let R=0,I="",E=!1;const C=c.charCodeAt(0);if(b===1)k(C)&&(R=1,E=!0);else if(k(C))if(E=!0,k(c.charCodeAt(1))){let j=2,U=j;for(;j<b&&!k(c.charCodeAt(j));)j++;if(j<b&&j!==U){const F=c.slice(U,j);for(U=j;j<b&&k(c.charCodeAt(j));)j++;if(j<b&&j!==U){for(U=j;j<b&&!k(c.charCodeAt(j));)j++;(j===b||j!==U)&&(I=`\\\\${F}\\${c.slice(U,j)}`,R=j)}}}else R=1;else f(C)&&c.charCodeAt(1)===w&&(I=c.slice(0,2),R=2,b>2&&k(c.charCodeAt(2))&&(E=!0,R=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(i){if(o.length>0)break}else if(r=`${c.slice(R)}\\${r}`,i=E,E&&o.length>0)break}return r=d(r,!i,"\\",k),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){m(t,"path");const o=t.length;if(o===0)return".";let r=0,i,n=!1;const c=t.charCodeAt(0);if(o===1)return u(c)?"\\":t;if(k(c))if(n=!0,k(t.charCodeAt(1))){let R=2,I=R;for(;R<o&&!k(t.charCodeAt(R));)R++;if(R<o&&R!==I){const E=t.slice(I,R);for(I=R;R<o&&k(t.charCodeAt(R));)R++;if(R<o&&R!==I){for(I=R;R<o&&!k(t.charCodeAt(R));)R++;if(R===o)return`\\\\${E}\\${t.slice(I)}\\`;R!==I&&(i=`\\\\${E}\\${t.slice(I,R)}`,r=R)}}}else r=1;else f(c)&&t.charCodeAt(1)===w&&(i=t.slice(0,2),r=2,o>2&&k(t.charCodeAt(2))&&(n=!0,r=3));let b=r<o?d(t.slice(r),!n,"\\",k):"";return b.length===0&&!n&&(b="."),b.length>0&&k(t.charCodeAt(o-1))&&(b+="\\"),i===void 0?n?`\\${b}`:b:n?`${i}\\${b}`:`${i}${b}`},isAbsolute(t){m(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return k(r)||o>2&&f(r)&&t.charCodeAt(1)===w&&k(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let c=0;c<t.length;++c){const b=t[c];m(b,"path"),b.length>0&&(o===void 0?o=r=b:o+=`\\${b}`)}if(o===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&k(r.charCodeAt(0))){++n;const c=r.length;c>1&&k(r.charCodeAt(1))&&(++n,c>2&&(k(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<o.length&&k(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$fc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o)return"";const r=e.$fc.resolve(t),i=e.$fc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===l;)n++;let c=t.length;for(;c-1>n&&t.charCodeAt(c-1)===l;)c--;const b=c-n;let R=0;for(;R<o.length&&o.charCodeAt(R)===l;)R++;let I=o.length;for(;I-1>R&&o.charCodeAt(I-1)===l;)I--;const E=I-R,C=b<E?b:E;let j=-1,U=0;for(;U<C;U++){const V=t.charCodeAt(n+U);if(V!==o.charCodeAt(R+U))break;V===l&&(j=U)}if(U!==C){if(j===-1)return i}else{if(E>C){if(o.charCodeAt(R+U)===l)return i.slice(R+U+1);if(U===2)return i.slice(R+U)}b>C&&(t.charCodeAt(n+U)===l?j=U:U===2&&(j=3)),j===-1&&(j=0)}let F="";for(U=n+j+1;U<=c;++U)(U===c||t.charCodeAt(U)===l)&&(F+=F.length===0?"..":"\\..");return R+=j,F.length>0?`${F}${i.slice(R,I)}`:(i.charCodeAt(R)===l&&++R,i.slice(R,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===l){if(o.charCodeAt(1)===l){const r=o.charCodeAt(2);if(r!==v&&r!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===w&&o.charCodeAt(2)===l)return`\\\\?\\${o}`;return t},dirname(t){m(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(o===1)return k(n)?t:".";if(k(n)){if(r=i=1,k(t.charCodeAt(1))){let R=2,I=R;for(;R<o&&!k(t.charCodeAt(R));)R++;if(R<o&&R!==I){for(I=R;R<o&&k(t.charCodeAt(R));)R++;if(R<o&&R!==I){for(I=R;R<o&&!k(t.charCodeAt(R));)R++;if(R===o)return t;R!==I&&(r=i=R+1)}}}}else f(n)&&t.charCodeAt(1)===w&&(r=o>2&&k(t.charCodeAt(2))?3:2,i=r);let c=-1,b=!0;for(let R=o-1;R>=i;--R)if(k(t.charCodeAt(R))){if(!b){c=R;break}}else b=!1;if(c===-1){if(r===-1)return".";c=r}return t.slice(0,c)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,n=!0,c;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===w&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,R=-1;for(c=t.length-1;c>=r;--c){const I=t.charCodeAt(c);if(k(I)){if(!n){r=c+1;break}}else R===-1&&(n=!1,R=c+1),b>=0&&(I===o.charCodeAt(b)?--b===-1&&(i=c):(b=-1,i=R))}return r===i?i=R:i===-1&&(i=t.length),t.slice(r,i)}for(c=t.length-1;c>=r;--c)if(k(t.charCodeAt(c))){if(!n){r=c+1;break}}else i===-1&&(n=!1,i=c+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=0,r=-1,i=0,n=-1,c=!0,b=0;t.length>=2&&t.charCodeAt(1)===w&&f(t.charCodeAt(0))&&(o=i=2);for(let R=t.length-1;R>=o;--R){const I=t.charCodeAt(R);if(k(I)){if(!c){i=R+1;break}continue}n===-1&&(c=!1,n=R+1),I===P?r===-1?r=R:b!==1&&(b=1):r!==-1&&(b=-1)}return r===-1||n===-1||b===0||b===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:$.bind(null,"\\"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return k(n)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(k(n)){if(i=1,k(t.charCodeAt(1))){let j=2,U=j;for(;j<r&&!k(t.charCodeAt(j));)j++;if(j<r&&j!==U){for(U=j;j<r&&k(t.charCodeAt(j));)j++;if(j<r&&j!==U){for(U=j;j<r&&!k(t.charCodeAt(j));)j++;j===r?i=j:j!==U&&(i=j+1)}}}}else if(f(n)&&t.charCodeAt(1)===w){if(r<=2)return o.root=o.dir=t,o;if(i=2,k(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let c=-1,b=i,R=-1,I=!0,E=t.length-1,C=0;for(;E>=i;--E){if(n=t.charCodeAt(E),k(n)){if(!I){b=E+1;break}continue}R===-1&&(I=!1,R=E+1),n===P?c===-1?c=E:C!==1&&(C=1):c!==-1&&(C=-1)}return R!==-1&&(c===-1||C===0||C===1&&c===R-1&&c===b+1?o.base=o.name=t.slice(b,R):(o.name=t.slice(b,c),o.base=t.slice(b,R),o.ext=t.slice(c,R))),b>0&&b!==i?o.dir=t.slice(0,b-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(p){const t=/\\/g;return()=>{const o=S.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>S.cwd()})();e.$gc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:a();m(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===g)}return o=d(o,!r,"/",u),r?`/${o}`:o.length>0?o:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===g,r=t.charCodeAt(t.length-1)===g;return t=d(t,!o,"/",u),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===g},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];m(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const r=1,i=t.length,n=i-r,c=1,b=o.length-c,R=n<b?n:b;let I=-1,E=0;for(;E<R;E++){const j=t.charCodeAt(r+E);if(j!==o.charCodeAt(c+E))break;j===g&&(I=E)}if(E===R)if(b>R){if(o.charCodeAt(c+E)===g)return o.slice(c+E+1);if(E===0)return o.slice(c+E)}else n>R&&(t.charCodeAt(r+E)===g?I=E:E===0&&(I=0));let C="";for(E=r+I+1;E<=i;++E)(E===i||t.charCodeAt(E)===g)&&(C+=C.length===0?"..":"/..");return`${C}${o.slice(c+I)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===g;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===g){if(!i){r=n;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,n=!0,c;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,R=-1;for(c=t.length-1;c>=0;--c){const I=t.charCodeAt(c);if(I===g){if(!n){r=c+1;break}}else R===-1&&(n=!1,R=c+1),b>=0&&(I===o.charCodeAt(b)?--b===-1&&(i=c):(b=-1,i=R))}return r===i?i=R:i===-1&&(i=t.length),t.slice(r,i)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===g){if(!n){r=c+1;break}}else i===-1&&(n=!1,i=c+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=-1,r=0,i=-1,n=!0,c=0;for(let b=t.length-1;b>=0;--b){const R=t.charCodeAt(b);if(R===g){if(!n){r=b+1;break}continue}i===-1&&(n=!1,i=b+1),R===P?o===-1?o=b:c!==1&&(c=1):o!==-1&&(c=-1)}return o===-1||i===-1||c===0||c===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:$.bind(null,"/"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===g;let i;r?(o.root="/",i=1):i=0;let n=-1,c=0,b=-1,R=!0,I=t.length-1,E=0;for(;I>=i;--I){const C=t.charCodeAt(I);if(C===g){if(!R){c=I+1;break}continue}b===-1&&(R=!1,b=I+1),C===P?n===-1?n=I:E!==1&&(E=1):n!==-1&&(E=-1)}if(b!==-1){const C=c===0&&r?1:c;n===-1||E===0||E===1&&n===b-1&&n===c+1?o.base=o.name=t.slice(C,b):(o.name=t.slice(C,n),o.base=t.slice(C,b),o.ext=t.slice(n,b))}return c>0?o.dir=t.slice(0,c-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=p?e.$fc.normalize:e.$gc.normalize,e.$ic=p?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=p?e.$fc.join:e.$gc.join,e.$kc=p?e.$fc.resolve:e.$gc.resolve,e.$lc=p?e.$fc.relative:e.$gc.relative,e.$mc=p?e.$fc.dirname:e.$gc.dirname,e.$nc=p?e.$fc.basename:e.$gc.basename,e.$oc=p?e.$fc.extname:e.$gc.extname,e.$pc=p?e.$fc.format:e.$gc.format,e.$qc=p?e.$fc.parse:e.$gc.parse,e.$rc=p?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=p?e.$fc.sep:e.$gc.sep,e.$tc=p?e.$fc.delimiter:e.$gc.delimiter}),define(ae[33],ce([0,1,9,4,25,12]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=void 0;function A(c){return c===47||c===92}e.$$f=A;function P(c){return c.replace(/[\\/]/g,S.$gc.sep)}e.$_f=P;function g(c){return c.indexOf("/")===-1&&(c=P(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$ag=g;function l(c,b=S.$gc.sep){if(!c)return"";const R=c.length,I=c.charCodeAt(0);if(A(I)){if(A(c.charCodeAt(1))&&!A(c.charCodeAt(2))){let C=3;const j=C;for(;C<R&&!A(c.charCodeAt(C));C++);if(j!==C&&!A(c.charCodeAt(C+1))){for(C+=1;C<R;C++)if(A(c.charCodeAt(C)))return c.slice(0,C+1).replace(/[\\/]/g,b)}}return b}else if(u(I)&&c.charCodeAt(1)===58)return A(c.charCodeAt(2))?c.slice(0,2)+b:c.slice(0,2);let E=c.indexOf("://");if(E!==-1){for(E+=3;E<R;E++)if(A(c.charCodeAt(E)))return c.slice(0,E+1)}return""}e.$bg=l;function w(c){if(!D.$i||!c||c.length<5)return!1;let b=c.charCodeAt(0);if(b!==92||(b=c.charCodeAt(1),b!==92))return!1;let R=2;const I=R;for(;R<c.length&&(b=c.charCodeAt(R),b!==92);R++);return!(I===R||(b=c.charCodeAt(R+1),isNaN(b)||b===92))}e.$cg=w;const v=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(c,b=D.$i){const R=b?v:y;return!(!c||c.length===0||/^\s+$/.test(c)||(R.lastIndex=0,R.test(c))||b&&h.test(c)||c==="."||c===".."||b&&c[c.length-1]==="."||b&&c.length!==c.trim().length||c.length>255)}e.$dg=m;function p(c,b,R){const I=c===b;return!R||I?I:!c||!b?!1:(0,s.$jf)(c,b)}e.$eg=p;function k(c,b,R,I=S.sep){if(c===b)return!0;if(!c||!b||b.length>c.length)return!1;if(R){if(!(0,s.$kf)(c,b))return!1;if(b.length===c.length)return!0;let C=b.length;return b.charAt(b.length-1)===I&&C--,c.charAt(C)===I}return b.charAt(b.length-1)!==I&&(b+=I),c.indexOf(b)===0}e.$fg=k;function u(c){return c>=65&&c<=90||c>=97&&c<=122}e.$gg=u;function f(c,b){return D.$i&&c.endsWith(":")&&(c+=S.sep),(0,S.$ic)(c)||(c=(0,S.$jc)(b,c)),c=(0,S.$hc)(c),D.$i?(c=(0,s.$4e)(c,S.sep),c.endsWith(":")&&(c+=S.sep)):(c=(0,s.$4e)(c,S.sep),c||(c=S.sep)),c}e.$hg=f;function d(c){const b=(0,S.$hc)(c);return D.$i?c.length>3?!1:$(b)&&(c.length===2||b.charCodeAt(2)===92):b===S.$gc.sep}e.$ig=d;function $(c,b=D.$i){return b?u(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$jg=$;function a(c,b=D.$i){return $(c,b)?c[0]:void 0}e.$kg=a;function t(c,b,R){return b.length>c.length?-1:c===b?0:(R&&(c=c.toLowerCase(),b=b.toLowerCase()),c.indexOf(b))}e.$lg=t;function o(c){const b=c.split(":");let R,I,E;for(const C of b){const j=Number(C);(0,M.$Wf)(j)?I===void 0?I=j:E===void 0&&(E=j):R=R?[R,C].join(":"):C}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:I!==void 0?I:void 0,column:E!==void 0?E:I!==void 0?1:void 0}}e.$mg=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(c,b,R=8){let I="";for(let C=0;C<R;C++){let j;C===0&&D.$i&&!b&&(R===3||R===4)?j=i:j=r,I+=j.charAt(Math.floor(Math.random()*j.length))}let E;return b?E=`${b}-${I}`:E=I,c?(0,S.$jc)(c,E):E}e.$ng=n}),define(ae[75],ce([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.TerminateResponseCode=e.Source=void 0;var D;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(D||(e.Source=D={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(P,...g){const l=g.reduce((y,h)=>(y[h]=!0,y),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!l[y]).forEach(y=>{for(let h=0;h<w.length;h++)if(y.search(w[h])!==-1){delete P[y];break}})}e.$3l=M;function A(P){P&&(delete P.DEBUG,S.$j&&delete P.DYLD_LIBRARY_PATH,S.$k&&delete P.LD_PRELOAD)}e.$4l=A}),define(ae[7],ce([0,1,9,4]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,A=/^\/\//;function P(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==v&&(n=v+n):n=v;break}return n}const w="",v="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(n){return n instanceof h?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,c,b,R,I,E=!1){typeof n=="object"?(this.scheme=n.scheme||w,this.authority=n.authority||w,this.path=n.path||w,this.query=n.query||w,this.fragment=n.fragment||w):(this.scheme=g(n,E),this.authority=c||w,this.path=l(this.scheme,b||w),this.query=R||w,this.fragment=I||w,P(this,E))}get fsPath(){return $(this,!1)}with(n){if(!n)return this;let{scheme:c,authority:b,path:R,query:I,fragment:E}=n;return c===void 0?c=this.scheme:c===null&&(c=w),b===void 0?b=this.authority:b===null&&(b=w),R===void 0?R=this.path:R===null&&(R=w),I===void 0?I=this.query:I===null&&(I=w),E===void 0?E=this.fragment:E===null&&(E=w),c===this.scheme&&b===this.authority&&R===this.path&&I===this.query&&E===this.fragment?this:new k(c,b,R,I,E)}static parse(n,c=!1){const b=y.exec(n);return b?new k(b[2]||w,r(b[4]||w),r(b[5]||w),r(b[7]||w),r(b[9]||w),c):new k(w,w,w,w,w)}static file(n){let c=w;if(D.$i&&(n=n.replace(/\\/g,v)),n[0]===v&&n[1]===v){const b=n.indexOf(v,2);b===-1?(c=n.substring(2),n=v):(c=n.substring(2,b),n=n.substring(b)||v)}return new k("file",c,n,w,w)}static from(n,c){return new k(n.scheme,n.authority,n.path,n.query,n.fragment,c)}static joinPath(n,...c){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return D.$i&&n.scheme==="file"?b=h.file(S.$fc.join($(n,!0),...c)).path:b=S.$gc.join(n.path,...c),n.with({path:b})}toString(n=!1){return a(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof h)return n;{const c=new k(n);return c._formatted=n.external??null,c._fsPath=n._sep===p?n.fsPath??null:null,c}}else return n}}e.URI=h;function m(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=m;const p=D.$i?1:void 0;class k extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(n=!1){return n?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=p),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(i,n,c){let b,R=-1;for(let I=0;I<i.length;I++){const E=i.charCodeAt(I);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47||c&&E===91||c&&E===93||c&&E===58)R!==-1&&(b+=encodeURIComponent(i.substring(R,I)),R=-1),b!==void 0&&(b+=i.charAt(I));else{b===void 0&&(b=i.substr(0,I));const C=u[E];C!==void 0?(R!==-1&&(b+=encodeURIComponent(i.substring(R,I)),R=-1),b+=C):R===-1&&(R=I)}}return R!==-1&&(b+=encodeURIComponent(i.substring(R))),b!==void 0?b:i}function d(i){let n;for(let c=0;c<i.length;c++){const b=i.charCodeAt(c);b===35||b===63?(n===void 0&&(n=i.substr(0,c)),n+=u[b]):n!==void 0&&(n+=i[c])}return n!==void 0?n:i}function $(i,n){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,D.$i&&(c=c.replace(/\//g,"\\")),c}e.$wc=$;function a(i,n){const c=n?d:f;let b="",{scheme:R,authority:I,path:E,query:C,fragment:j}=i;if(R&&(b+=R,b+=":"),(I||R==="file")&&(b+=v,b+=v),I){let U=I.indexOf("@");if(U!==-1){const F=I.substr(0,U);I=I.substr(U+1),U=F.lastIndexOf(":"),U===-1?b+=c(F,!1,!1):(b+=c(F.substr(0,U),!1,!1),b+=":",b+=c(F.substr(U+1),!1,!0)),b+="@"}I=I.toLowerCase(),U=I.lastIndexOf(":"),U===-1?b+=c(I,!1,!0):(b+=c(I.substr(0,U),!1,!0),b+=I.substr(U))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const U=E.charCodeAt(1);U>=65&&U<=90&&(E=`/${String.fromCharCode(U+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const U=E.charCodeAt(0);U>=65&&U<=90&&(E=`${String.fromCharCode(U+32)}:${E.substr(2)}`)}b+=c(E,!0,!1)}return C&&(b+="?",b+=c(C,!1,!1)),j&&(b+="#",b+=n?j:f(j,!1,!1)),b}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,n=>t(n)):i}}),define(ae[154],ce([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$zq=e.$yq=e.$xq=void 0;function D(l){const w=l;return w&&typeof w.type=="string"&&typeof w.severity=="string"}e.$xq=D;function s(l){const w=[];let v;try{const y=JSON.parse(l.arguments),h=y[y.length-1];h&&h.__$stack&&(y.pop(),v=h.__$stack),w.push(...y)}catch{w.push("Unable to log remote console arguments",l.arguments)}return{args:w,stack:v}}e.$yq=s;function M(l){if(typeof l!="string")return M(s(l).stack);const w=l;if(w){const v=A(w),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$zq=M;function A(l){if(!l)return l;const w=l.indexOf(`
`);return w===-1?l:l.substring(0,w)}function P(l,w){const{args:v,stack:y}=s(l),h=typeof v[0]=="string"&&v.length===1;let m=A(y);m&&(m=`(${m.trim()})`);let p=[];if(typeof v[0]=="string"?m&&h?p=[`%c[${w}] %c${v[0]} %c${m}`,g("blue"),g(""),g("grey")]:p=[`%c[${w}] %c${v[0]}`,g("blue"),g(""),...v.slice(1)]:p=[`%c[${w}]%`,g("blue"),...v],m&&!h&&p.push(m),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,p)}e.log=P;function g(l){return`color: ${l}`}}),define(ae[76],ce([0,1,17,7]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=void 0;function s(g){return JSON.stringify(g,A)}e.$Lh=s;function M(g){let l=JSON.parse(g);return l=P(l),l}e.$Mh=M;function A(g,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function P(g,l=0){if(!g||l>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return D.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof S.$se||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let w=0;w<g.length;++w)g[w]=P(g[w],l+1);else for(const w in g)Object.hasOwnProperty.call(g,w)&&(g[w]=P(g[w],l+1))}return g}e.$Nh=P}),define(ae[13],ce([0,1,14,4,25,7]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.Schemas=void 0;var A;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeManagedRemoteResource="vscode-managed-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.vscodeChatCodeBlock="vscode-chat-code-block",y.vscodeChatSesssion="vscode-chat-editor",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm",y.codeSetting="code-setting",y.codeFeature="code-feature"})(A||(e.Schemas=A={}));function P(y,h){return M.URI.isUri(y)?(0,s.$jf)(y.scheme,h):(0,s.$kf)(y,h+":")}e.$og=P;function g(y,...h){return h.some(m=>P(y,m))}e.$pg=g,e.$qg="vscode-tkn",e.$rg="tkn";class l{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${A.vscodeRemoteResource}`}set(h,m,p){this.a[h]=m,this.b[h]=p}setConnectionToken(h,m){this.c[h]=m}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(d){return S.$1(d),h}const m=h.authority;let p=this.a[m];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const k=this.b[m],u=this.c[m];let f=`path=${encodeURIComponent(h.path)}`;return typeof u=="string"&&(f+=`&${e.$rg}=${encodeURIComponent(u)}`),M.URI.from({scheme:D.$o?this.d:A.vscodeRemoteResource,authority:`${p}:${k}`,path:this.f,query:f})}}e.$sg=new l,e.$tg="vs/../../extensions",e.$ug="vs/../../node_modules",e.$vg="vs/../../node_modules.asar",e.$wg="vs/../../node_modules.asar.unpacked",e.$xg="vscode-app";class w{static{this.a=e.$xg}asBrowserUri(h){const m=this.b(h,Y);return this.uriToBrowserUri(m)}uriToBrowserUri(h){return h.scheme===A.vscodeRemote?e.$sg.rewrite(h):h.scheme===A.file&&(D.$m||D.$q===`${A.vscodeFileResource}://${w.a}`)?h.with({scheme:A.vscodeFileResource,authority:h.authority||w.a,query:null,fragment:null}):h}asFileUri(h){const m=this.b(h,Y);return this.uriToFileUri(m)}uriToFileUri(h){return h.scheme===A.vscodeFileResource?h.with({scheme:A.file,authority:h.authority!==w.a?h.authority:null,query:null,fragment:null}):h}b(h,m){return M.URI.isUri(h)?h:M.URI.parse(m.toUrl(h))}}e.$yg=new w;var v;(function(y){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(h.get("3"));const m="vscode-coi";function p(u){let f;typeof u=="string"?f=new URL(u).searchParams:u instanceof URL?f=u.searchParams:M.URI.isUri(u)&&(f=new URL(u.toString(!0)).searchParams);const d=f?.get(m);if(d)return h.get(d)}y.getHeadersFromQuery=p;function k(u,f,d){if(!globalThis.crossOriginIsolated)return;const $=f&&d?"3":d?"2":"1";u instanceof URLSearchParams?u.set(m,$):u[m]=$}y.addSearchParam=k})(v||(e.COI=v={}))}),define(ae[19],ce([0,1,33,13,9,4,25,7]),function(Y,e,S,D,s,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=e.DataUri=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function g(h){return(0,P.$wc)(h,!0)}e.$Fg=g;class l{constructor(m){this.a=m}compare(m,p,k=!1){return m===p?0:(0,A.$cf)(this.getComparisonKey(m,k),this.getComparisonKey(p,k))}isEqual(m,p,k=!1){return m===p?!0:!m||!p?!1:this.getComparisonKey(m,k)===this.getComparisonKey(p,k)}getComparisonKey(m,p=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,p,k=!1){if(m.scheme===p.scheme){if(m.scheme===D.Schemas.file)return S.$fg(g(m),g(p),this.a(m))&&m.query===p.query&&(k||m.fragment===p.fragment);if((0,e.$Wg)(m.authority,p.authority))return S.$fg(m.path,p.path,this.a(m),"/")&&m.query===p.query&&(k||m.fragment===p.fragment)}return!1}joinPath(m,...p){return P.URI.joinPath(m,...p)}basenameOrAuthority(m){return(0,e.$Og)(m)||m.authority}basename(m){return s.$gc.basename(m.path)}extname(m){return s.$gc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let p;return m.scheme===D.Schemas.file?p=P.URI.file(s.$mc(g(m))).path:(p=s.$gc.dirname(m.path),m.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),p="/")),m.with({path:p})}normalizePath(m){if(!m.path.length)return m;let p;return m.scheme===D.Schemas.file?p=P.URI.file(s.$hc(g(m))).path:p=s.$gc.normalize(m.path),m.with({path:p})}relativePath(m,p){if(m.scheme!==p.scheme||!(0,e.$Wg)(m.authority,p.authority))return;if(m.scheme===D.Schemas.file){const f=s.$lc(g(m),g(p));return M.$i?S.$_f(f):f}let k=m.path||"/";const u=p.path||"/";if(this.a(m)){let f=0;for(const d=Math.min(k.length,u.length);f<d&&!(k.charCodeAt(f)!==u.charCodeAt(f)&&k.charAt(f).toLowerCase()!==u.charAt(f).toLowerCase());f++);k=u.substr(0,f)+k.substr(f)}return s.$gc.relative(k,u)}resolvePath(m,p){if(m.scheme===D.Schemas.file){const k=P.URI.file(s.$kc(g(m),p));return m.with({authority:k.authority,path:k.path})}return p=S.$ag(p),m.with({path:s.$gc.resolve(m.path,p)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,p){return m===p||m!==void 0&&p!==void 0&&(0,A.$jf)(m,p)}hasTrailingPathSeparator(m,p=s.sep){if(m.scheme===D.Schemas.file){const k=g(m);return k.length>S.$bg(k).length&&k[k.length-1]===p}else{const k=m.path;return k.length>1&&k.charCodeAt(k.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,p=s.sep){return(0,e.$Xg)(m,p)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,p=s.sep){let k=!1;if(m.scheme===D.Schemas.file){const u=g(m);k=u!==void 0&&u.length===S.$bg(u).length&&u[u.length-1]===p}else{p="/";const u=m.path;k=u.length===1&&u.charCodeAt(u.length-1)===47}return!k&&!(0,e.$Xg)(m,p)?m.with({path:m.path+"/"}):m}}e.$Gg=l,e.$Hg=new l(()=>!1),e.$Ig=new l(h=>h.scheme===D.Schemas.file?!M.$k:!0),e.$Jg=new l(h=>!0),e.$Kg=e.$Hg.isEqual.bind(e.$Hg),e.$Lg=e.$Hg.isEqualOrParent.bind(e.$Hg),e.$Mg=e.$Hg.getComparisonKey.bind(e.$Hg),e.$Ng=e.$Hg.basenameOrAuthority.bind(e.$Hg),e.$Og=e.$Hg.basename.bind(e.$Hg),e.$Pg=e.$Hg.extname.bind(e.$Hg),e.$Qg=e.$Hg.dirname.bind(e.$Hg),e.$Rg=e.$Hg.joinPath.bind(e.$Hg),e.$Sg=e.$Hg.normalizePath.bind(e.$Hg),e.$Tg=e.$Hg.relativePath.bind(e.$Hg),e.$Ug=e.$Hg.resolvePath.bind(e.$Hg),e.$Vg=e.$Hg.isAbsolutePath.bind(e.$Hg),e.$Wg=e.$Hg.isEqualAuthority.bind(e.$Hg),e.$Xg=e.$Hg.hasTrailingPathSeparator.bind(e.$Hg),e.$Yg=e.$Hg.removeTrailingPathSeparator.bind(e.$Hg),e.$Zg=e.$Hg.addTrailingPathSeparator.bind(e.$Hg);function w(h,m){const p=[];for(let k=0;k<h.length;k++){const u=m(h[k]);h.some((f,d)=>d===k?!1:(0,e.$Lg)(u,m(f)))||p.push(h[k])}return p}e.$1g=w;var v;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function m(p){const k=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(d=>{const[$,a]=d.split(":");$&&a&&k.set($,a)});const f=p.path.substring(0,p.path.indexOf(";"));return f&&k.set(h.META_DATA_MIME,f),k}h.parseMetaData=m})(v||(e.DataUri=v={}));function y(h,m,p){if(m){let k=h.path;return k&&k[0]!==s.$gc.sep&&(k=s.$gc.sep+k),h.with({scheme:p,authority:m,path:k})}return h.with({scheme:p})}e.$2g=y}),define(ae[8],ce([0,1,23,14,3,2,19,4,143,62]),function(Y,e,S,D,s,M,A,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.Promises=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0;function w(_){return!!_&&typeof _.then=="function"}e.$3g=w;function v(_){const z=new S.$ce,ee=_(z.token),ie=new Promise((de,me)=>{const Ee=z.token.onCancellationRequested(()=>{Ee.dispose(),me(new D.$5)});Promise.resolve(ee).then(Pe=>{Ee.dispose(),z.dispose(),de(Pe)},Pe=>{Ee.dispose(),z.dispose(),me(Pe)})});return new class{cancel(){z.cancel(),z.dispose()}then(de,me){return ie.then(de,me)}catch(de){return this.then(void 0,de)}finally(de){return ie.finally(de)}}}e.$4g=v;function y(_,z,ee){return new Promise((ie,de)=>{const me=z.onCancellationRequested(()=>{me.dispose(),ie(ee)});_.then(ie,de).finally(()=>me.dispose())})}e.$5g=y;function h(_,z){return new Promise((ee,ie)=>{const de=z.onCancellationRequested(()=>{de.dispose(),ie(new D.$5)});_.then(ee,ie).finally(()=>de.dispose())})}e.$6g=h;async function m(_){let z=-1;const ee=_.map((ie,de)=>ie.then(me=>(z=de,me)));try{return await Promise.race(ee)}finally{_.forEach((ie,de)=>{de!==z&&ie.cancel()})}}e.$7g=m;function p(_,z,ee){let ie;const de=setTimeout(()=>{ie?.(void 0),ee?.()},z);return Promise.race([_.finally(()=>clearTimeout(de)),new Promise(me=>ie=me)])}e.$8g=p;function k(_){return new Promise((z,ee)=>{const ie=_();w(ie)?ie.then(z,ee):z(ie)})}e.$9g=k;function u(){let _,z;return{promise:new Promise((ie,de)=>{_=ie,z=de}),resolve:_,reject:z}}e.$0g=u;class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=z,!this.b){const ee=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(ee,ee).then(ie)})}return new Promise((ee,ie)=>{this.b.then(ee,ie)})}return this.a=z(),new Promise((ee,ie)=>{this.a.then(de=>{this.a=null,ee(de)},de=>{this.a=null,ie(de)})})}dispose(){this.f=!0}}e.$$g=f;class d{constructor(){this.a=Promise.resolve(null)}queue(z){return this.a=this.a.then(()=>z(),()=>z())}}e.$_g=d;class ${constructor(){this.a=new Map}queue(z,ee){const de=(this.a.get(z)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.a.get(z)===de&&this.a.delete(z)});return this.a.set(z,de),de}}e.$ah=$;const a=(_,z)=>{let ee=!0;const ie=setTimeout(()=>{ee=!1,z()},_);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(ie),ee=!1}}},t=_=>{let z=!0;return queueMicrotask(()=>{z&&(z=!1,_())}),{isTriggered:()=>z,dispose:()=>{z=!1}}};class o{constructor(z){this.defaultDelay=z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(z,ee=this.defaultDelay){this.g=z,this.h(),this.b||(this.b=new Promise((de,me)=>{this.d=de,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=ee===g.$2d?t(ie):a(ee,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new D.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$bh=o;class r{constructor(z){this.a=new o(z),this.b=new f}trigger(z,ee){return this.a.trigger(()=>this.b.queue(z),ee)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ch=r;class i{constructor(){this.a=!1,this.b=new Promise((z,ee)=>{this.d=z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$dh=i;class n extends i{constructor(z){super(),this.f=setTimeout(()=>this.open(),z)}open(){clearTimeout(this.f),super.open()}}e.$eh=n;function c(_,z){return z?new Promise((ee,ie)=>{const de=setTimeout(()=>{me.dispose(),ee()},_),me=z.onCancellationRequested(()=>{clearTimeout(de),me.dispose(),ie(new D.$5)})}):v(ee=>c(_,ee))}e.$fh=c;function b(_,z=0,ee){const ie=setTimeout(()=>{_(),ee&&de.dispose()},z),de=(0,M.$Rc)(()=>{clearTimeout(ie),ee?.deleteAndLeak(de)});return ee?.add(de),de}e.$gh=b;function R(_){const z=[];let ee=0;const ie=_.length;function de(){return ee<ie?_[ee++]():null}function me(Ee){Ee!=null&&z.push(Ee);const Pe=de();return Pe?Pe.then(me):Promise.resolve(z)}return Promise.resolve(null).then(me)}e.$hh=R;function I(_,z=ie=>!!ie,ee=null){let ie=0;const de=_.length,me=()=>{if(ie>=de)return Promise.resolve(ee);const Ee=_[ie++];return Promise.resolve(Ee()).then(Le=>z(Le)?Promise.resolve(Le):me())};return me()}e.$ih=I;function E(_,z=ie=>!!ie,ee=null){if(_.length===0)return Promise.resolve(ee);let ie=_.length;const de=()=>{ie=-1;for(const me of _)me.cancel?.()};return new Promise((me,Ee)=>{for(const Pe of _)Pe.then(Le=>{--ie>=0&&z(Le)?(de(),me(Le)):ie===0&&me(ee)}).catch(Le=>{--ie>=0&&(de(),Ee(Le))})})}e.$jh=E;class C{constructor(z){this.a=0,this.b=!1,this.f=z,this.g=[],this.d=0,this.h=new s.$5d}whenIdle(){return this.size>0?s.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ee,ie)=>{this.g.push({factory:z,c:ee,e:ie}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const z=this.g.shift();this.d++;const ee=z.factory();ee.then(z.c,z.e),ee.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$kh=C;class j extends C{constructor(){super(1)}}e.$lh=j;class U{constructor(){this.a=new T,this.b=0}queue(z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,z())):this.a.run(this.b++,z())}}e.$mh=U;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const z=new oe;return this.b.add(z),z.p}g(){for(const[,z]of this.a)if(z.size>0)return!1;return!0}queueSize(z,ee=A.$Hg){const ie=ee.getComparisonKey(z);return this.a.get(ie)?.size??0}queueFor(z,ee,ie=A.$Hg){const de=ie.getComparisonKey(z);let me=this.a.get(de);if(!me){me=new j;const Ee=this.f++,Pe=s.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$3c),this.d.set(Ee,Pe),this.a.set(de,me)}return me.queue(ee)}h(){this.g()&&this.j()}j(){for(const z of this.b)z.complete();this.b.clear()}dispose(){for(const[,z]of this.a)z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$nh=F;class V{constructor(z,ee){this.a=-1,typeof z=="function"&&typeof ee=="number"&&this.setIfNotSet(z,ee)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(z,ee){this.cancel(),this.a=setTimeout(()=>{this.a=-1,z()},ee)}setIfNotSet(z,ee){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,z()},ee))}}e.$oh=V;class J{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(z,ee,ie=globalThis){this.cancel();const de=ie.setInterval(()=>{z()},ee);this.d=(0,M.$Rc)(()=>{ie.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$ph=J;class le{constructor(z,ee){this.b=-1,this.a=z,this.d=ee,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(z=this.d){this.cancel(),this.b=setTimeout(this.f,z)}get delay(){return this.d}set delay(z){this.d=z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$qh=le;class re{constructor(z,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.a=z,this.b=ee,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(z=this.b){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$rh=re;class ue extends le{constructor(z,ee){super(z,ee),this.j=[]}work(z){this.j.push(z),this.isScheduled()||this.schedule()}h(){const z=this.j;this.j=[],this.a?.(z)}dispose(){this.j=[],super.dispose()}}e.$sh=ue;class Z extends M.$Tc{constructor(z,ee){super(),this.g=z,this.h=ee,this.a=[],this.b=this.B(new M.$Uc),this.f=!1}get pending(){return this.a.length}work(z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+z.length>this.g.maxBufferedWork)return!1}else if(this.pending+z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ee of z)this.a.push(ee);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$th=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$vh=(_,z)=>{(0,P.$B)(()=>{if(ee)return;const ie=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$vh=(_,z,ee)=>{const ie=_.requestIdleCallback(z,typeof ee=="number"?{timeout:ee}:void 0);let de=!1;return{dispose(){de||(de=!0,_.cancelIdleCallback(ie))}}},e.$uh=_=>(0,e.$vh)(globalThis,_)}();class X{constructor(z,ee){this.g=!1,this.d=()=>{try{this.j=ee()}catch(ie){this.l=ie}finally{this.g=!0}},this.f=(0,e.$vh)(z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$wh=X;class q extends X{constructor(z){super(globalThis,z)}}e.$xh=q;async function L(_,z,ee){let ie;for(let de=0;de<ee;de++)try{return await _()}catch(me){ie=me,await c(z)}throw ie}e.$yh=L;class T{isRunning(z){return typeof z=="number"?this.a?.taskId===z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(z,ee,ie){return this.a={taskId:z,cancel:()=>ie?.(),promise:ee},ee.then(()=>this.d(z),()=>this.d(z)),ee}d(z){this.a&&z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const z=this.b;this.b=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}queue(z){if(this.b)this.b.run=z;else{const{promise:ee,resolve:ie,reject:de}=u();this.b={run:z,promise:ee,promiseResolve:ie,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$zh=T;class G{constructor(z,ee=()=>Date.now()){this.d=z,this.f=ee,this.a=0,this.b=0}increment(){const z=this.f();return z-this.a>this.d&&(this.a=z,this.b=0),this.b++,this.b}}e.$Ah=G;var B;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(B||(B={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((z,ee)=>{this.a=z,this.b=ee})}complete(z){return new Promise(ee=>{this.a(z),this.d={outcome:0,value:z},ee()})}error(z){return new Promise(ee=>{this.b(z),this.d={outcome:1,value:z},ee()})}cancel(){return this.error(new D.$5)}}e.$Bh=oe;var he;(function(_){async function z(ie){let de;const me=await Promise.all(ie.map(Ee=>Ee.then(Pe=>Pe,Pe=>{de||(de=Pe)})));if(typeof de<"u")throw de;return me}_.settled=z;function ee(ie){return new Promise(async(de,me)=>{try{await ie(de,me)}catch(Ee){me(Ee)}})}_.withAsyncBody=ee})(he||(e.Promises=he={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=z.then(ee=>(this.a=ee,this.d=!0,ee),ee=>{throw this.b=ee,this.d=!0,ee})}requireValue(){if(!this.d)throw new D.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ch=K;class O{constructor(z){this.b=z,this.a=new l.$V(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Dh=O;var W;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(W||(W={}));class x{static fromArray(z){return new x(ee=>{ee.emitMany(z)})}static fromPromise(z){return new x(async ee=>{ee.emitMany(await z)})}static fromPromises(z){return new x(async ee=>{await Promise.all(z.map(async ie=>ee.emitOne(await ie)))})}static merge(z){return new x(async ee=>{await Promise.all(z.map(async ie=>{for await(const de of ie)ee.emitOne(de)}))})}static{this.EMPTY=x.fromArray([])}constructor(z){this.a=0,this.b=[],this.d=null,this.f=new s.$5d,queueMicrotask(async()=>{const ee={emitOne:ie=>this.g(ie),emitMany:ie=>this.h(ie),reject:ie=>this.k(ie)};try{await Promise.resolve(z(ee)),this.j()}catch(ie){this.k(ie)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(z<this.b.length)return{done:!1,value:this.b[z++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(z,ee){return new x(async ie=>{for await(const de of z)ie.emitOne(ee(de))})}map(z){return x.map(this,z)}static filter(z,ee){return new x(async ie=>{for await(const de of z)ee(de)&&ie.emitOne(de)})}filter(z){return x.filter(this,z)}static coalesce(z){return x.filter(z,ee=>!!ee)}coalesce(){return x.coalesce(this)}static async toPromise(z){const ee=[];for await(const ie of z)ee.push(ie);return ee}toPromise(){return x.toPromise(this)}g(z){this.a===0&&(this.b.push(z),this.f.fire())}h(z){this.a===0&&(this.b=this.b.concat(z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(z){this.a===0&&(this.a=2,this.d=z,this.f.fire())}}e.$Eh=x;class N extends x{constructor(z,ee){super(ee),this.l=z}cancel(){this.l.cancel()}}e.$Fh=N;function Q(_){const z=new S.$ce,ee=_(z.token);return new N(z,async ie=>{const de=z.token.onCancellationRequested(()=>{de.dispose(),z.dispose(),ie.reject(new D.$5)});try{for await(const me of ee){if(z.token.isCancellationRequested)return;ie.emitOne(me)}de.dispose(),z.dispose()}catch(me){de.dispose(),z.dispose(),ie.reject(me)}})}e.$Gh=Q;class H{constructor(){this.a=new oe,this.b=new x(ie=>{if(z){ie.reject(z);return}return ee&&ie.emitMany(ee),this.d=de=>ie.reject(de),this.f=de=>ie.emitOne(de),this.a.p});let z,ee;this.f=ie=>{ee||(ee=[]),ee.push(ie)},this.d=ie=>{z||(z=ie)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(z){this.d(z),this.a.complete()}emitOne(z){this.f(z)}}e.$Hh=H}),define(ae[106],ce([0,1,22,8,33,31,9,4,25]),function(Y,e,S,D,s,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;function l(){return Object.create(null)}e.$Sj=l,e.$Tj="**",e.$Uj="/";const w="[/\\\\]",v="[^/\\\\]",y=/\//g;function h(X,q){switch(X){case 0:return"";case 1:return`${v}*?`;default:return`(?:${w}|${v}+${w}${q?`|${w}${v}+`:""})*?`}}function m(X,q){if(!X)return[];const L=[];let T=!1,G=!1,B="";for(const oe of X){switch(oe){case q:if(!T&&!G){L.push(B),B="";continue}break;case"{":T=!0;break;case"}":T=!1;break;case"[":G=!0;break;case"]":G=!1;break}B+=oe}return B&&L.push(B),L}e.$Vj=m;function p(X){if(!X)return"";let q="";const L=m(X,e.$Uj);if(L.every(T=>T===e.$Tj))q=".*";else{let T=!1;L.forEach((G,B)=>{if(G===e.$Tj){if(T)return;q+=h(2,B===L.length-1)}else{let oe=!1,he="",K=!1,O="";for(const W of G){if(W!=="}"&&oe){he+=W;continue}if(K&&(W!=="]"||!O)){let x;W==="-"?x=W:(W==="^"||W==="!")&&!O?x="^":W===e.$Uj?x="":x=(0,g.$Xe)(W),O+=x;continue}switch(W){case"{":oe=!0;continue;case"[":K=!0;continue;case"}":{const N=`(?:${m(he,",").map(Q=>p(Q)).join("|")})`;q+=N,oe=!1,he="";break}case"]":{q+="["+O+"]",K=!1,O="";break}case"?":q+=v;continue;case"*":q+=h(1);continue;default:q+=(0,g.$Xe)(W)}}B<L.length-1&&(L[B+1]!==e.$Tj||B+2<L.length)&&(q+=w)}T=G===e.$Tj})}return q}const k=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,$=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Dc(1e4),o=function(){return!1},r=function(){return null};function i(X,q){if(!X)return r;let L;typeof X!="string"?L=X.pattern:L=X,L=L.trim();const T=`${L}_${!!q.trimForExclusions}`;let G=t.get(T);if(G)return n(G,X);let B;return k.test(L)?G=b(L.substr(4),L):(B=u.exec(c(L,q)))?G=R(B[1],L):(q.trimForExclusions?d:f).test(L)?G=I(L,q):(B=$.exec(c(L,q)))?G=E(B[1].substr(1),L,!0):(B=a.exec(c(L,q)))?G=E(B[1],L,!1):G=C(L),t.set(T,G),n(G,X)}function n(X,q){if(typeof q=="string")return X;const L=function(T,G){return(0,s.$fg)(T,q.base,!P.$k)?X((0,g.$3e)(T.substr(q.base.length),A.sep),G):null};return L.allBasenames=X.allBasenames,L.allPaths=X.allPaths,L.basenames=X.basenames,L.patterns=X.patterns,L}function c(X,q){return q.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function b(X,q){return function(L,T){return typeof L=="string"&&L.endsWith(X)?q:null}}function R(X,q){const L=`/${X}`,T=`\\${X}`,G=function(oe,he){return typeof oe!="string"?null:he?he===X?q:null:oe===X||oe.endsWith(L)||oe.endsWith(T)?q:null},B=[X];return G.basenames=B,G.patterns=[q],G.allBasenames=B,G}function I(X,q){const L=ue(X.slice(1,-1).split(",").map(he=>i(he,q)).filter(he=>he!==r),X),T=L.length;if(!T)return r;if(T===1)return L[0];const G=function(he,K){for(let O=0,W=L.length;O<W;O++)if(L[O](he,K))return X;return null},B=L.find(he=>!!he.allBasenames);B&&(G.allBasenames=B.allBasenames);const oe=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return oe.length&&(G.allPaths=oe),G}function E(X,q,L){const T=A.sep===A.$gc.sep,G=T?X:X.replace(y,A.sep),B=A.sep+G,oe=A.$gc.sep+X;let he;return L?he=function(K,O){return typeof K=="string"&&(K===G||K.endsWith(B)||!T&&(K===X||K.endsWith(oe)))?q:null}:he=function(K,O){return typeof K=="string"&&(K===G||!T&&K===X)?q:null},he.allPaths=[(L?"*/":"./")+X],he}function C(X){try{const q=new RegExp(`^${p(X)}$`);return function(L){return q.lastIndex=0,typeof L=="string"&&q.test(L)?X:null}}catch{return r}}function j(X,q,L){return!X||typeof q!="string"?!1:U(X)(q,void 0,L)}e.$Wj=j;function U(X,q={}){if(!X)return o;if(typeof X=="string"||F(X)){const L=i(X,q);if(L===r)return o;const T=function(G,B){return!!L(G,B)};return L.allBasenames&&(T.allBasenames=L.allBasenames),L.allPaths&&(T.allPaths=L.allPaths),T}return le(X,q)}e.$Xj=U;function F(X){const q=X;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.$Yj=F;function V(X){return X.allBasenames||[]}e.$Zj=V;function J(X){return X.allPaths||[]}e.$1j=J;function le(X,q){const L=ue(Object.getOwnPropertyNames(X).map(he=>re(he,X[he],q)).filter(he=>he!==r)),T=L.length;if(!T)return r;if(!L.some(he=>!!he.requiresSiblings)){if(T===1)return L[0];const he=function(W,x){let N;for(let Q=0,H=L.length;Q<H;Q++){const _=L[Q](W,x);if(typeof _=="string")return _;(0,D.$3g)(_)&&(N||(N=[]),N.push(_))}return N?(async()=>{for(const Q of N){const H=await Q;if(typeof H=="string")return H}return null})():null},K=L.find(W=>!!W.allBasenames);K&&(he.allBasenames=K.allBasenames);const O=L.reduce((W,x)=>x.allPaths?W.concat(x.allPaths):W,[]);return O.length&&(he.allPaths=O),he}const G=function(he,K,O){let W,x;for(let N=0,Q=L.length;N<Q;N++){const H=L[N];H.requiresSiblings&&O&&(K||(K=(0,A.$nc)(he)),W||(W=K.substr(0,K.length-(0,A.$oc)(he).length)));const _=H(he,K,W,O);if(typeof _=="string")return _;(0,D.$3g)(_)&&(x||(x=[]),x.push(_))}return x?(async()=>{for(const N of x){const Q=await N;if(typeof Q=="string")return Q}return null})():null},B=L.find(he=>!!he.allBasenames);B&&(G.allBasenames=B.allBasenames);const oe=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return oe.length&&(G.allPaths=oe),G}function re(X,q,L){if(q===!1)return r;const T=i(X,L);if(T===r)return r;if(typeof q=="boolean")return T;if(q){const G=q.when;if(typeof G=="string"){const B=(oe,he,K,O)=>{if(!O||!T(oe,he))return null;const W=G.replace("$(basename)",()=>K),x=O(W);return(0,D.$3g)(x)?x.then(N=>N?X:null):x?X:null};return B.requiresSiblings=!0,B}}return T}function ue(X,q){const L=X.filter(he=>!!he.basenames);if(L.length<2)return X;const T=L.reduce((he,K)=>{const O=K.basenames;return O?he.concat(O):he},[]);let G;if(q){G=[];for(let he=0,K=T.length;he<K;he++)G.push(q)}else G=L.reduce((he,K)=>{const O=K.patterns;return O?he.concat(O):he},[]);const B=function(he,K){if(typeof he!="string")return null;if(!K){let W;for(W=he.length;W>0;W--){const x=he.charCodeAt(W-1);if(x===47||x===92)break}K=he.substr(W)}const O=T.indexOf(K);return O!==-1?G[O]:null};B.basenames=T,B.patterns=G,B.allBasenames=T;const oe=X.filter(he=>!he.basenames);return oe.push(B),oe}function Z(X,q){return(0,S.$ub)(X,q,(L,T)=>typeof L=="string"&&typeof T=="string"?L===T:typeof L!="string"&&typeof T!="string"?L.base===T.base&&L.pattern===T.pattern:!1)}e.$2j=Z}),define(ae[47],ce([0,1,22,33,9,4,19,25]),function(Y,e,S,D,s,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=void 0;function g(i,n){const{os:c,tildify:b,relative:R}=n;if(R){const C=l(i,R,c);if(typeof C=="string")return C}let I=i.fsPath;if(c===1&&!M.$i?I=I.replace(/\//g,"\\"):c!==1&&M.$i&&(I=I.replace(/\\/g,"/")),c!==1&&b?.userHome){const C=b.userHome.fsPath;let j;i.scheme!==b.userHome.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep?j=b.userHome.with({path:i.path}).fsPath:j=I,I=y(j,C,c)}return(c===1?s.$fc:s.$gc).normalize(w(I,c===1))}e.$8v=g;function l(i,n,c){const b=c===1?s.$fc:s.$gc,R=c===3?A.$Hg:A.$Jg,I=n.getWorkspace(),E=(0,S.$Ob)(I.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep&&(i=E.uri.with({path:i.path}));const C=n.getWorkspaceFolder(i);if(!C)return;let j;if(R.isEqual(C.uri,i)?j="":j=R.relativePath(C.uri,i)??"",j&&(j=b.normalize(j)),I.folders.length>1&&!n.noPrefix){const U=C.name?C.name:R.basenameOrAuthority(C.uri);j=j?`${U} \u2022 ${j}`:U}return j}function w(i,n=M.$i){return(0,D.$jg)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$9v=w;let v=Object.create(null);function y(i,n,c=M.OS){if(c===1||!i||!n)return i;let b=v.original===n?v.normalized:void 0;b||(b=n,M.$i&&(b=(0,D.$_f)(b)),b=`${(0,P.$4e)(b,s.$gc.sep)}${s.$gc.sep}`,v={original:n,normalized:b});let R=i;return M.$i&&(R=(0,D.$_f)(R)),(c===3?R.startsWith(b):(0,P.$kf)(R,b))?`~/${R.substr(b.length)}`:i}e.$0v=y;function h(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$$v=h;const m="\u2026",p="\\\\",k="~";function u(i,n=s.sep){const c=new Array(i.length);let b=!1;for(let R=0;R<i.length;R++){const I=i[R];if(I===""){c[R]=`.${n}`;continue}if(!I){c[R]=I;continue}b=!0;let E="",C=I;C.indexOf(p)===0?(E=C.substr(0,C.indexOf(p)+p.length),C=C.substr(C.indexOf(p)+p.length)):C.indexOf(n)===0?(E=C.substr(0,C.indexOf(n)+n.length),C=C.substr(C.indexOf(n)+n.length)):C.indexOf(k)===0&&(E=C.substr(0,C.indexOf(k)+k.length),C=C.substr(C.indexOf(k)+k.length));const j=C.split(n);for(let U=1;b&&U<=j.length;U++)for(let F=j.length-U;b&&F>=0;F--){b=!1;let V=j.slice(F,F+U).join(n);for(let J=0;!b&&J<i.length;J++)if(J!==R&&i[J]&&i[J].indexOf(V)>-1){const le=F+U===j.length,re=F>0&&i[J].indexOf(n)>-1?n+V:V,ue=i[J].endsWith(re);b=!le||ue}if(!b){let J="";(j[0].endsWith(":")||E!=="")&&(F===1&&(F=0,U++,V=j[0]+n+V),F>0&&(J=j[0]+n),J=E+J),F>0&&(J=J+m+n),J=J+V,F+U<j.length&&(J=J+n+m),c[R]=J}}b&&(c[R]=I)}return c}e.$_v=u;var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function d(i,n=Object.create(null)){const c=[];let b=!1,R="";for(const I of i)if(I==="$"||b&&I==="{")R&&c.push({value:R,type:f.TEXT}),R="",b=!0;else if(I==="}"&&b){const E=n[R];if(typeof E=="string")E.length&&c.push({value:E,type:f.VARIABLE});else if(E){const C=c[c.length-1];(!C||C.type!==f.SEPARATOR)&&c.push({value:E.label,type:f.SEPARATOR})}R="",b=!1}else R+=I;return R&&!b&&c.push({value:R,type:f.TEXT}),c.filter((I,E)=>{if(I.type===f.SEPARATOR){const C=c[E-1],j=c[E+1];return[C,j].every(U=>U&&(U.type===f.VARIABLE||U.type===f.TEXT)&&U.value.length>0)}return!0}).map(I=>I.value).join("")}e.$aw=d;function $(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.$bw=$;function a(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$cw=a;function t(i){return i.replace(/&/g,"&&")}e.$dw=t;function o(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const c=r(i.substring(0,n)),b=i.substring(n);return{name:c.name+b,parentPath:c.parentPath}}}return r(i)}e.$ew=o;function r(i){const n=i.indexOf("/")!==-1?s.$gc:s.$fc,c=n.basename(i),b=n.dirname(i);return c.length?{name:c,parentPath:b}:{name:b,parentPath:""}}}),define(ae[155],ce([0,1,17,7]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=void 0;function s(v){return v.toJSON()}class M{constructor(y){this.a=y}transformIncoming(y){const h=this.a.transformIncoming(y);return h===y?y:s(D.URI.from(h))}transformOutgoing(y){const h=this.a.transformOutgoing(y);return h===y?y:s(D.URI.from(h))}transformOutgoingURI(y){const h=this.a.transformOutgoing(y);return h===y?y:D.URI.from(h)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$dn=M,e.$en=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function A(v,y,h){if(!v||h>200)return null;if(typeof v=="object"){if(v instanceof D.URI)return y.transformOutgoing(v);for(const m in v)if(Object.hasOwnProperty.call(v,m)){const p=A(v[m],y,h+1);p!==null&&(v[m]=p)}}return null}function P(v,y){const h=A(v,y,0);return h===null?v:h}e.$fn=P;function g(v,y,h,m){if(!v||m>200)return null;if(typeof v=="object"){if(v.$mid===1)return h?D.URI.revive(y.transformIncoming(v)):y.transformIncoming(v);if(v instanceof S.$se)return null;for(const p in v)if(Object.hasOwnProperty.call(v,p)){const k=g(v[p],y,h,m+1);k!==null&&(v[p]=k)}}return null}function l(v,y){const h=g(v,y,!1,0);return h===null?v:h}e.$gn=l;function w(v,y){const h=g(v,y,!0,0);return h===null?v:h}e.$hn=w}),define(ae[88],ce([0,1,26,59,32,145,4]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=void 0,e.$jn=new class{c(y){return this.a||(this.a=D.$ki.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,h=0;const m=(0,S.networkInterfaces)();for(const p in m){const k=m[p];if(k)for(const{mac:u,internal:f}of k)f||(h+=1,this.c(u.toUpperCase())&&(y+=1))}this.b=h>0?y/h:0}return this.b}};let P;async function g(y){return P||(P=(async()=>await l(y)||s.$Ag())()),P}e.$kn=g;async function l(y){try{const h=await new Promise((p,k)=>{Y(["crypto"],p,k)}),m=(0,M.$in)();return h.createHash("sha256").update(m,"utf8").digest("hex")}catch(h){y(h);return}}const w="Software\\Microsoft\\SQMClient";async function v(y){if(A.$i){const h=await new Promise((m,p)=>{Y(["@vscode/windows-registry"],m,p)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",w,"MachineId")||""}catch(m){return y(m),""}}return""}e.$ln=v}),define(ae[21],ce([0,1,46,26,156,8,33,85,9,4,19,7]),function(Y,e,S,D,s,M,A,P,g,l,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function h(re,ue=y.UNLINK,Z){if((0,A.$ig)(re))throw new Error("rimraf - will refuse to recursively delete root");return ue===y.UNLINK?p(re):m(re,Z)}async function m(re,ue=(0,A.$ng)((0,D.tmpdir)())){try{try{await S.promises.rename(re,ue)}catch(Z){return Z.code==="ENOENT"?void 0:p(re)}p(ue).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function p(re){return(0,s.promisify)(S.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function k(re){if((0,A.$ig)(re))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=k;async function u(re,ue){return $(await(ue?f(re):(0,s.promisify)(S.readdir)(re)))}async function f(re){try{return await(0,s.promisify)(S.readdir)(re,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const ue=[],Z=await u(re);for(const X of Z){let q=!1,L=!1,T=!1;try{const G=await e.Promises.lstat((0,g.$jc)(re,X));q=G.isFile(),L=G.isDirectory(),T=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ue.push({name:X,isFile:()=>q,isDirectory:()=>L,isSymbolicLink:()=>T})}return ue}function d(re){return $(S.readdirSync(re))}e.readdirSync=d;function $(re){return re.map(ue=>typeof ue=="string"?l.$j?(0,P.$Rl)(ue):ue:(ue.name=l.$j?(0,P.$Rl)(ue.name):ue.name,ue))}async function a(re){const ue=await u(re),Z=[];for(const X of ue)await o.existsDirectory((0,g.$jc)(re,X))&&Z.push(X);return Z}function t(re,ue=1e3){return new Promise(Z=>{let X=!1;const q=setInterval(()=>{X||(X=!0,S.access(re,L=>{X=!1,L&&(clearInterval(q),Z(void 0))}))},ue)})}e.whenDeleted=t;var o;(function(re){async function ue(q){let L;try{if(L=await e.Promises.lstat(q),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(l.$i&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw G}throw T}}re.stat=ue;async function Z(q){try{const{stat:L,symbolicLink:T}=await re.stat(q);return L.isFile()&&T?.dangling!==!0}catch{}return!1}re.existsFile=Z;async function X(q){try{const{stat:L,symbolicLink:T}=await re.stat(q);return L.isDirectory()&&T?.dangling!==!0}catch{}return!1}re.existsDirectory=X})(o||(e.SymlinkSupport=o={}));const r=new M.$nh;function i(re,ue,Z){return r.queueFor(v.URI.file(re),()=>{const X=I(Z);return new Promise((q,L)=>b(re,ue,X,T=>T?L(T):q()))},w.$Ig)}let n=!0;function c(re){n=re}e.configureFlushOnWrite=c;function b(re,ue,Z,X){if(!n)return S.writeFile(re,ue,{mode:Z.mode,flag:Z.flag},X);S.open(re,Z.flag,Z.mode,(q,L)=>{if(q)return X(q);S.writeFile(L,ue,T=>{if(T)return S.close(L,()=>X(T));S.fdatasync(L,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),c(!1)),S.close(L,B=>X(B))))})})}function R(re,ue,Z){const X=I(Z);if(!n)return S.writeFileSync(re,ue,{mode:X.mode,flag:X.flag});const q=S.openSync(re,X.flag,X.mode);try{S.writeFileSync(q,ue);try{S.fdatasyncSync(q)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),c(!1)}}finally{S.closeSync(q)}}e.writeFileSync=R;function I(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function E(re,ue,Z=6e4){if(re!==ue)try{l.$i&&typeof Z=="number"?await C(re,ue,Date.now(),Z):await(0,s.promisify)(S.rename)(re,ue)}catch(X){if(re.toLowerCase()!==ue.toLowerCase()&&X.code==="EXDEV"||re.endsWith("."))await j(re,ue,{preserveSymlinks:!1}),await h(re,y.MOVE);else throw X}}async function C(re,ue,Z,X,q=0){try{return await(0,s.promisify)(S.rename)(re,ue)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-Z>=X)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${L}`),L;if(q===0){let T=!1;try{const{stat:G}=await o.stat(ue);G.isFile()||(T=!0)}catch{}if(T)throw L}return await(0,M.$fh)(Math.min(100,q*10)),C(re,ue,Z,X,q+1)}}async function j(re,ue,Z){return F(re,ue,{root:{source:re,target:ue},options:Z,handledSourcePaths:new Set})}const U=511;async function F(re,ue,Z){if(Z.handledSourcePaths.has(re))return;Z.handledSourcePaths.add(re);const{stat:X,symbolicLink:q}=await o.stat(re);if(q){if(Z.options.preserveSymlinks)try{return await le(re,ue,Z)}catch{}if(q.dangling)return}return X.isDirectory()?V(re,ue,X.mode&U,Z):J(re,ue,X.mode&U)}async function V(re,ue,Z,X){await e.Promises.mkdir(ue,{recursive:!0,mode:Z});const q=await u(re);for(const L of q)await F((0,g.$jc)(re,L),(0,g.$jc)(ue,L),X)}async function J(re,ue,Z){await e.Promises.copyFile(re,ue),await e.Promises.chmod(ue,Z)}async function le(re,ue,Z){let X=await e.Promises.readlink(re);(0,A.$fg)(X,Z.root.source,!l.$k)&&(X=(0,g.$jc)(Z.root.target,X.substr(Z.root.source.length+1))),await e.Promises.symlink(X,ue)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(re,ue,Z,X,q)=>new Promise((L,T)=>{S.read(re,ue,Z,X,q,(G,B,oe)=>G?T(G):L({bytesRead:B,buffer:oe}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(re,ue,Z,X,q)=>new Promise((L,T)=>{S.write(re,ue,Z,X,q,(G,B,oe)=>G?T(G):L({bytesWritten:B,buffer:oe}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return h}get rename(){return E}get copy(){return j}}}),define(ae[107],ce([0,1,46,9,4,25,21]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.$Eq=void 0;function P(y){if(s.$k)return y;const h=(0,D.$mc)(y);if(y===h)return y;const m=((0,D.$nc)(y)||y).toLowerCase();try{const k=(0,A.readdirSync)(h).filter(u=>u.toLowerCase()===m);if(k.length===1){const u=P(h);if(u)return(0,D.$jc)(u,k[0])}else if(k.length>1){const u=k.indexOf(m);if(u>=0){const f=P(h);if(f)return(0,D.$jc)(f,k[u])}}}catch{}return null}e.$Eq=P;async function g(y){if(s.$k)return y;const h=(0,D.$mc)(y);if(y===h)return y;const m=((0,D.$nc)(y)||y).toLowerCase();try{const k=(await A.Promises.readdir(h)).filter(u=>u.toLowerCase()===m);if(k.length===1){const u=await g(h);if(u)return(0,D.$jc)(u,k[0])}else if(k.length>1){const u=k.indexOf(m);if(u>=0){const f=await g(h);if(f)return(0,D.$jc)(f,k[u])}}}catch{}return null}e.$Fq=g;async function l(y){try{return await A.Promises.realpath(y)}catch{const m=v(y);return await A.Promises.access(m,S.constants.R_OK),m}}e.$Gq=l;function w(y){try{return S.realpathSync(y)}catch{const m=v(y);return S.accessSync(m,S.constants.R_OK),m}}e.$Hq=w;function v(y){return(0,M.$4e)((0,D.$hc)(y),D.sep)}}),define(ae[108],ce([0,1,26,9,21]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=void 0;const M=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var g;(function($){$[$.x64=0]="x64",$[$.x86=1]="x86",$[$.ARM=2]="ARM"})(g||(g={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class v{constructor(a,t,o){this.exePath=a,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:$=!1}={}){return $?l===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:$=!1,findPreview:a=!1}={}){const t=y({useAlternateBitness:$});if(!t)return null;const o=D.$jc(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const b of await s.Promises.readdir(o)){let R=-1;if(a){const E=b.indexOf("-");if(E<0)continue;const C=b.substring(0,E);if(!M.test(C)||b.substring(E+1)!=="preview")continue;R=parseInt(C,10)}else{if(!M.test(b))continue;R=parseInt(b,10)}if(R<=r)continue;const I=D.$jc(o,b,"pwsh.exe");await s.SymlinkSupport.existsFile(I)&&(i=I,r=R)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",c=a?" Preview":"";return new v(i,`PowerShell${c}${n}`,!0)}async function m({findPreview:$}={}){if(!process.env.LOCALAPPDATA)return null;const a=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=$?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(a))if(t.test(r)){const i=D.$jc(a,r,"pwsh.exe");return new v(i,o)}return null}function p(){const $=D.$jc(S.homedir(),".dotnet","tools","pwsh.exe");return new v($,".NET Core PowerShell Global Tool")}function k(){const $=D.$jc(process.env.windir,l===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v($,"Windows PowerShell",!0)}async function*u(){let $=await h();$&&(yield $),$=await h({useAlternateBitness:!0}),$&&(yield $),$=await m(),$&&(yield $),$=p(),$&&(yield $),$=await h({findPreview:!0}),$&&(yield $),$=await m({findPreview:!0}),$&&(yield $),$=await h({useAlternateBitness:!0,findPreview:!0}),$&&(yield $),$=k(),$&&(yield $)}async function*f(){for await(const $ of u())await $.exists()&&(yield $)}e.$1l=f;async function d(){for await(const $ of f())return $;return null}e.$2l=d}),define(ae[89],ce([0,1,9,4,36,75,12,21]),function(Y,e,S,D,s,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$6l=e.$5l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function g(v=s.env){return v.comspec||"cmd.exe"}e.$5l=g;function l(v){let y=[],h=!1;const m=function(p){if(h){y.push(p);return}(!v.send(p,u=>{if(u&&console.error(u),h=!1,y.length>0){const f=y.slice(0);y=[],f.forEach(d=>m(d))}})||D.$i)&&(h=!0)};return{send:m}}e.$6l=l;var w;(function(v){async function y(h,m,p){if(S.$ic(h))return h;if(m===void 0&&(m=s.cwd()),S.$mc(h)!=="."||(p===void 0&&A.$Sf(s.env.PATH)&&(p=s.env.PATH.split(S.$tc)),p===void 0||p.length===0))return S.$jc(m,h);async function u(f){if(await P.Promises.exists(f)){let d;try{d=await P.Promises.stat(f)}catch($){$.message.startsWith("EACCES")&&(d=await P.Promises.lstat(f))}return d?!d.isDirectory():!1}return!1}for(const f of p){let d;if(S.$ic(f)?d=S.$jc(f,h):d=S.$jc(m,f,h),await u(d))return d;let $=d+".com";if(await u($)||($=d+".exe",await u($)))return $}return S.$jc(m,h)}v.findExecutable=y})(w||(e.win32=w={}))}),define(ae[109],ce([0,1,48,13]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0;function s(A){return new Promise((P,g)=>{let l;const w=new Map;function v(h,m,p,k,u){const f=w.get(m);if(h===A||f){const d={name:y(p),cmd:p,pid:h,ppid:m,load:k,mem:u};w.set(h,d),h===A&&(l=d),f&&(f.children||(f.children=[]),f.children.push(d),f.children.length>1&&(f.children=f.children.sort(($,a)=>$.pid-a.pid)))}}function y(h){const m=/--utility-sub-type=network/i,p=/--crashes-directory/i,k=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(p.exec(h))return"electron-crash-reporter";if(k.exec(h))return"winpty-agent";if(u.exec(h))return"conpty-agent";let d=f.exec(h);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?m.exec(h)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const $=/[a-zA-Z-]+\.js/g;let a="";do d=$.exec(h),d&&(a+=d+" ");while(d);return a&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${a})`:h}if(process.platform==="win32"){const h=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,p)=>{Y(["@vscode/windows-process-tree"],m,p)}).then(m=>{m.getProcessList(A,p=>{if(!p){g(new Error(`Root process ${A} not found`));return}m.getProcessCpuUsage(p,k=>{const u=new Map;k.forEach(f=>{const d=h(f.commandLine||"");u.set(f.pid,{name:y(d),cmd:d,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),l=u.get(A),l?(u.forEach(f=>{const d=u.get(f.ppid);d&&(d.children||(d.children=[]),d.children.push(f))}),u.forEach(f=>{f.children&&(f.children=f.children.sort((d,$)=>d.pid-$.pid))}),P(l)):g(new Error(`Root process ${A} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let h=function(){let m=[l];const p=[];for(;m.length;){const u=m.shift();u&&(p.push(u.pid),u.children&&(m=m.concat(u.children)))}let k=JSON.stringify(D.$yg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);k+=" "+p.join(" "),(0,S.exec)(k,{},(u,f,d)=>{if(u||d)g(u||new Error(d.toString()));else{const $=f.toString().split(`
`);for(let a=0;a<p.length;a++){const t=w.get(p[a]);t.load=parseFloat($[a])}if(!l){g(new Error(`Root process ${A} not found`));return}P(l)}})};(0,S.exec)("which ps",{},(m,p,k)=>{if(m||k)if(process.platform!=="linux")g(m||new Error(k.toString()));else{const u=JSON.stringify(D.$yg.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(u,{},(f,d,$)=>{f||$?g(f||new Error($.toString())):(M(d,v),h())})}else{const u=p.toString().trim();(0,S.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,$,a)=>{d||a&&!a.includes("screen size is bogus")?g(d||new Error(a.toString())):(M($,v),process.platform==="linux"?h():l?P(l):g(new Error(`Root process ${A} not found`)))})}})}})}e.$ds=s;function M(A,P){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=A.toString().split(`
`);for(const w of l){const v=g.exec(w.trim());v&&v.length===6&&P(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ae[110],ce([0,1,26,4,108,89]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=void 0;async function A(v,y){return v===1?D.$i?w():M.$5l(y):g(v,y)}e.$7l=A;let P=null;function g(v,y){if(D.$k&&v===2||D.$j&&v===3)return"/bin/bash";if(!P){let h;if(D.$i)h="/bin/bash";else{if(h=y.SHELL,!h)try{h=(0,S.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}P=h}return P}let l=null;async function w(){return l||(l=(await(0,s.$2l)()).exePath),l}});var ve=this&&this.__decorate||function(Y,e,S,D){var s=arguments.length,M=s<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,S):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Y,e,S,D);else for(var P=Y.length-1;P>=0;P--)(A=Y[P])&&(M=(s<3?A(M):s>3?A(e,S,M):A(e,S))||M);return s>3&&M&&Object.defineProperty(e,S,M),M};define(ae[43],ce([0,1,22,8,17,23,50,14,3,2,76,25,12]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.ProxyChannel=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.RequestInitiator=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=void 0;var h;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(h||(h={}));function m(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(p||(p={}));function k(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(u||(u={}));function f(q){let L=0;for(let T=0;;T+=7){const G=q.read(1);if(L|=(G.buffer[0]&127)<<T,!(G.buffer[0]&128))return L}}const d=r(0);function $(q,L){if(L===0){q.write(d);return}let T=0;for(let B=L;B!==0;B=B>>>7)T++;const G=s.$se.alloc(T);for(let B=0;L!==0;B++)G.buffer[B]=L&127,L=L>>>7,L>0&&(G.buffer[B]|=128);q.write(G)}class a{constructor(L){this.b=L,this.a=0}read(L){const T=this.b.slice(this.a,this.a+L);return this.a+=T.byteLength,T}}e.$Oh=a;class t{constructor(){this.a=[]}get buffer(){return s.$se.concat(this.a)}write(L){this.a.push(L)}}e.$Ph=t;var o;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(o||(o={}));function r(q){const L=s.$se.alloc(1);return L.writeUInt8(q,0),L}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function c(q,L){if(typeof L>"u")q.write(i.Undefined);else if(typeof L=="string"){const T=s.$se.fromString(L);q.write(i.String),$(q,T.byteLength),q.write(T)}else if(n&&Buffer.isBuffer(L)){const T=s.$se.wrap(L);q.write(i.Buffer),$(q,T.byteLength),q.write(T)}else if(L instanceof s.$se)q.write(i.VSBuffer),$(q,L.byteLength),q.write(L);else if(Array.isArray(L)){q.write(i.Array),$(q,L.length);for(const T of L)c(q,T)}else if(typeof L=="number"&&(L|0)===L)q.write(i.Uint),$(q,L);else{const T=s.$se.fromString(JSON.stringify(L));q.write(i.Object),$(q,T.byteLength),q.write(T)}}e.$Qh=c;function b(q){switch(q.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return q.read(f(q)).toString();case o.Buffer:return q.read(f(q)).buffer;case o.VSBuffer:return q.read(f(q));case o.Array:{const T=f(q),G=[];for(let B=0;B<T;B++)G.push(b(q));return G}case o.Object:return JSON.parse(q.read(f(q)).toString());case o.Int:return f(q)}}e.$Rh=b;class R{constructor(L,T,G=null,B=1e3){this.h=L,this.j=T,this.k=G,this.l=B,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(L,T){this.b.set(L,T),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const T=this.o([L.type]);this.k?.logOutgoing(T,0,1,k(L.type));return}case 201:case 202:case 204:case 203:{const T=this.o([L.type,L.id],L.data);this.k?.logOutgoing(T,L.id,1,k(L.type),L.data);return}}}o(L,T=void 0){const G=new t;return c(G,L),c(G,T),this.p(G.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const T=new a(L),G=b(T),B=b(T),oe=G[0];switch(oe){case 100:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}: ${G[2]}.${G[3]}`,B),this.s({type:oe,id:G[1],channelName:G[2],name:G[3],arg:B});case 102:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}: ${G[2]}.${G[3]}`,B),this.t({type:oe,id:G[1],channelName:G[2],name:G[3],arg:B});case 101:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}`),this.u({type:oe,id:G[1]});case 103:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}`),this.u({type:oe,id:G[1]})}}s(L){const T=this.b.get(L.channelName);if(!T){this.v(L);return}const G=new M.$ce;let B;try{B=T.call(this.j,L.name,L.arg,G.token)}catch(K){B=Promise.reject(K)}const oe=L.id;B.then(K=>{this.m({id:oe,data:K,type:201})},K=>{K instanceof Error?this.m({id:oe,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:oe,data:K,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,l.$Rc)(()=>G.cancel());this.d.set(L.id,he)}t(L){const T=this.b.get(L.channelName);if(!T){this.v(L);return}const G=L.id,oe=T.listen(this.j,L.name,L.arg)(he=>this.m({id:G,data:he,type:204}));this.d.set(L.id,oe)}u(L){const T=this.d.get(L.id);T&&(T.dispose(),this.d.delete(L.id))}v(L){let T=this.g.get(L.channelName);T||(T=[],this.g.set(L.channelName,T));const G=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);T.push({request:L,timeoutTimer:G})}w(L){const T=this.g.get(L);if(T){for(const G of T)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Oc)(this.d.values()),this.d.clear()}}e.$Sh=R;var I;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class E{constructor(L,T=null){this.l=L,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.$5d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=T}getChannel(L){const T=this;return{call(G,B,oe){return T.a?Promise.reject(new P.$5):T.m(L,G,B,oe)},listen(G,B){return T.a?g.Event.None:T.o(L,G,B)}}}m(L,T,G,B=M.CancellationToken.None){const oe=this.g++,K={id:oe,type:100,channelName:L,name:T,arg:G};if(B.isCancellationRequested)return Promise.reject(new P.$5);let O;return new Promise((x,N)=>{if(B.isCancellationRequested)return N(new P.$5);const Q=()=>{const ee=ie=>{switch(ie.type){case 201:this.f.delete(oe),x(ie.data);break;case 202:{this.f.delete(oe);const de=new Error(ie.data.message);de.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,de.name=ie.data.name,N(de);break}case 203:this.f.delete(oe),N(ie.data);break}};this.f.set(oe,ee),this.p(K)};let H=null;this.b===u.Idle?Q():(H=(0,D.$4g)(ee=>this.u()),H.then(()=>{H=null,Q()}));const _=()=>{H?(H.cancel(),H=null):this.p({id:oe,type:101}),N(new P.$5)},z=B.onCancellationRequested(_);O=(0,l.$Qc)((0,l.$Rc)(_),z),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(L,T,G){const B=this.g++,he={id:B,type:102,channelName:L,name:T,arg:G};let K=null;const O=new g.$5d({onWillAddFirstListener:()=>{K=(0,D.$4g)(x=>this.u()),K.then(()=>{K=null,this.d.add(O),this.p(he)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(O),this.p({id:B,type:103}))}}),W=x=>O.fire(x.data);return this.f.set(B,W),O.event}p(L){switch(L.type){case 100:case 102:{const T=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(T,L.id,0,`${m(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const T=this.q([L.type,L.id]);this.j?.logOutgoing(T,L.id,0,m(L.type));return}}}q(L,T=void 0){const G=new t;return c(G,L),c(G,T),this.r(G.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const T=new a(L),G=b(T),B=b(T),oe=G[0];switch(oe){case 200:return this.j?.logIncoming(L.byteLength,0,0,k(oe)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,G[1],0,k(oe),B),this.t({type:G[0],id:G[1],data:B})}}t(L){if(L.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Oc)(this.d.values()),this.d.clear()}}e.$Th=E,ve([A.$Ih],E.prototype,"onDidInitializePromise",null);class C{get connections(){const L=[];return this.f.forEach(T=>L.push(T)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new g.$5d,this.onDidAddConnection=this.g.event,this.h=new g.$5d,this.onDidRemoveConnection=this.h.event,this.j=new l.$Sc,this.j.add(L(({protocol:T,onDidClientDisconnect:G})=>{const B=g.Event.once(T.onMessage);this.j.add(B(oe=>{const he=new a(oe),K=b(he),O=new R(T,K),W=new E(T);this.a.forEach((N,Q)=>O.registerChannel(Q,N));const x={channelServer:O,channelClient:W,ctx:K};this.f.add(x),this.g.fire(x),this.j.add(G(()=>{O.dispose(),W.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(L,T){const G=this;return{call(B,oe,he){let K;if((0,y.$7f)(T)){const W=(0,S.$4b)(G.connections.filter(T));K=W?Promise.resolve(W):g.Event.toPromise(g.Event.filter(G.onDidAddConnection,T))}else K=T.routeCall(G,B,oe);const O=K.then(W=>W.channelClient.getChannel(L));return U(O).call(B,oe,he)},listen(B,oe){if((0,y.$7f)(T))return G.k(L,T,B,oe);const he=T.routeEvent(G,B,oe).then(K=>K.channelClient.getChannel(L));return U(he).listen(B,oe)}}}k(L,T,G,B){const oe=this;let he;const K=new g.$5d({onWillAddFirstListener:()=>{he=new l.$Sc;const O=new g.$$d,W=new Map,x=Q=>{const _=Q.channelClient.getChannel(L).listen(G,B),z=O.add(_);W.set(Q,z)},N=Q=>{const H=W.get(Q);H&&(H.dispose(),W.delete(Q))};oe.connections.filter(T).forEach(x),g.Event.filter(oe.onDidAddConnection,T)(x,void 0,he),oe.onDidRemoveConnection(N,void 0,he),O.event(K.fire,K,he),he.add(O)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return K.event}registerChannel(L,T){this.a.set(L,T);for(const G of this.f)G.channelServer.registerChannel(L,T)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Uh=C;class j{constructor(L,T,G=null){const B=new t;c(B,T),L.send(B.buffer),this.a=new E(L,G),this.d=new R(L,T,G)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,T){this.d.registerChannel(L,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Vh=j;function U(q){return{call(L,T,G){return q.then(B=>B.call(L,T,G))},listen(L,T){const G=new g.$be;return q.then(B=>G.input=B.listen(L,T)),G.event}}}e.$Wh=U;function F(q){let L=!1;return{call(T,G,B){return L?q.call(T,G,B):(0,D.$fh)(0).then(()=>L=!0).then(()=>q.call(T,G,B))},listen(T,G){if(L)return q.listen(T,G);const B=new g.$be;return(0,D.$fh)(0).then(()=>L=!0).then(()=>B.input=q.listen(T,G)),B.event}}}e.$Xh=F;class V{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const T of L.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await g.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$Yh=V;var J;(function(q){function L(oe,he,K){const O=oe,W=K&&K.disableMarshalling,x=new Map;for(const N in O)G(N)&&x.set(N,g.Event.buffer(O[N],!0,void 0,he));return new class{listen(N,Q,H){const _=x.get(Q);if(_)return _;if(B(Q)){const z=O[Q];if(typeof z=="function")return z.call(O,H)}throw new P.$bb(`Event not found: ${Q}`)}call(N,Q,H){const _=O[Q];if(typeof _=="function"){if(!W&&Array.isArray(H))for(let ee=0;ee<H.length;ee++)H[ee]=(0,w.$Nh)(H[ee]);let z=_.apply(O,H);return z instanceof Promise||(z=Promise.resolve(z)),z}throw new P.$bb(`Method not found: ${Q}`)}}}q.fromService=L;function T(oe,he){const K=he&&he.disableMarshalling;return new Proxy({},{get(O,W){if(typeof W=="string")return he?.properties?.has(W)?he.properties.get(W):B(W)?function(x){return oe.listen(W,x)}:G(W)?oe.listen(W):async function(...x){let N;he&&!(0,y.$2f)(he.context)?N=[he.context,...x]:N=x;const Q=await oe.call(W,N);return K?Q:(0,w.$Nh)(Q)};throw new P.$bb(`Property not found: ${String(W)}`)}})}q.toService=T;function G(oe){return oe[0]==="o"&&oe[1]==="n"&&v.$if(oe.charCodeAt(2))}function B(oe){return/^onDynamic/.test(oe)&&v.$if(oe.charCodeAt(9))}})(J||(e.ProxyChannel=J={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const L=q.toString();if(L!=="[object Object]")return L}return q}function ue(q){return Array.isArray(q)?q.map(re):re(q)}function Z(q,L,T,G,B,oe,he){he=ue(he);const K=le[B],O=K[G%K.length];let W=[`%c[${q}]%c[${String(L).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(oe)?(W=W.concat(he),W.push(")")):W.push(he),console.log.apply(console,W)}class X{constructor(L,T){this.d=L,this.f=T,this.a=0,this.b=0}logOutgoing(L,T,G,B,oe){this.b+=L,Z(this.d,this.b,L,T,G,B,oe)}logIncoming(L,T,G,B,oe){this.a+=L,Z(this.f,this.a,L,T,G,B,oe)}}e.$Zh=X}),define(ae[157],ce([0,1,17,3,43]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EV=e.$DV=void 0;class M{constructor(g){this.a=g,this.onMessage=D.Event.fromDOMEventEmitter(this.a,"message",l=>l.data?S.$se.wrap(l.data):S.$se.alloc(0)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}e.$DV=M;class A extends s.$Vh{constructor(g,l){const w=new M(g);super(w,l),this.b=w}dispose(){this.b.disconnect(),super.dispose()}}e.$EV=A}),define(ae[111],ce([0,1,17,3,2,43]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e.$2h=e.ProtocolConstants=e.$1h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let c=0;function b(I,E){if(!n.has(I)){const C=String(++c);n.set(I,C)}return n.get(I)}function R(I,E,C,j){if(!i.enableDiagnostics)return;const U=b(I,E);if(j instanceof S.$se||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const F=S.$se.alloc(j.byteLength);F.set(j),i.records.push({timestamp:Date.now(),id:U,label:E,type:C,buff:F})}else i.records.push({timestamp:Date.now(),id:U,label:E,type:C,data:j})}i.traceSocketEvent=R})(P||(e.SocketDiagnostics=P={}));var g;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g||(e.SocketCloseEventType=g={}));let l=null;function w(){return l||(l=S.$se.alloc(0)),l}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,c){if(n===0)return w();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const E=this.a[0];return c&&(this.a.shift(),this.b-=n),E}if(this.a[0].byteLength>n){const E=this.a[0].slice(0,n);return c&&(this.a[0]=this.a[0].slice(n),this.b-=n),E}const b=S.$se.alloc(n);let R=0,I=0;for(;n>0;){const E=this.a[I];if(E.byteLength>n){const C=E.slice(0,n);b.set(C,R),R+=n,c&&(this.a[I]=E.slice(n),this.b-=n),n-=n}else b.set(E,R),R+=E.byteLength,c?(this.a.shift(),this.b-=E.byteLength):I++,n-=E.byteLength}return b}}e.$1h=v;var y;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(y||(y={}));function h(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(m||(e.ProtocolConstants=m={}));class p{constructor(n,c,b,R){this.type=n,this.id=c,this.ack=b,this.data=R,this.writtenTime=0}get size(){return this.data.byteLength}}class k extends s.$Tc{constructor(n){super(),this.f=this.B(new D.$5d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new v,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,R=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new p(b,R,I,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=S.$se.alloc(13);c.writeUInt8(n.type,0),c.writeUInt32BE(n.id,1),c.writeUInt32BE(n.ack,5),c.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(c,n.data)}g(n,c){const b=this.f===0;return this.d.push(n,c),this.f+=n.byteLength+c.byteLength,b}h(){const n=S.$se.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,c){this.g(n,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class f extends s.$Tc{constructor(n){super(),this.f=new D.$5d,this.onMessage=this.f.event,this.g=new D.$5d,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new u(this.a)),this.c=this.B(new k(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new p(1,0,0,n))}}e.$2h=f;class d extends M.$Vh{static fromSocket(n,c){return new d(new f(n),c)}get onDidDispose(){return this.b.onDidDispose}constructor(n,c,b=null){super(n,c,b),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$3h=d;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.$5d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$4h=$;class a{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,c=this.a;for(;c;)c=c.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let c=0,b=this.a;for(;b;)n[c++]=b.data,b=b.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const c=new a(n);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let c=0;c<o.a;c++)this.c[c]=n-1e3*c;setInterval(()=>{for(let c=o.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),c=(1+o.a)*1e3;let b=0;for(let R=0;R<o.a;R++)n-this.c[R]<=c&&b++;return 1-b/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new $,this.onControlMessage=this.u.event,this.v=new $,this.onMessage=this.v.event,this.w=new $,this.onDidDispose=this.w.event,this.x=new $,this.onSocketClose=this.x.event,this.y=new $,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Sc,this.o=n.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new k(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new p(5,0,0,w());this.p.write(n),this.p.flush()}sendPause(){const n=new p(7,0,0,w());this.p.write(n)}sendResume(){const n=new p(8,0,0,w());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,c){this.a=!0,this.r.dispose(),this.r=new s.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new k(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new p(3,0,this.h,w());this.p.write(n);const c=this.b.toArray();for(let b=0,R=c.length;b<R;b++)this.p.write(c[b]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const c=this.b.peek();if(c&&c.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new p(6,0,0,w())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const c=this.b.toArray();for(let b=0,R=c.length;b<R;b++)this.p.write(c[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const c=++this.c;this.h=this.g;const b=new p(1,c,this.h,n);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(n){const c=new p(2,0,0,n);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),c=Date.now()-n.writtenTime,b=Date.now()-this.q.lastReadTime,R=Date.now()-this.n;if(c>=2e4&&b>=2e4&&R>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:b});return}const I=Math.max(2e4-c,2e4-b,2e4-R,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new p(3,0,this.h,w());this.p.write(n)}D(){this.h=this.g;const n=new p(9,0,this.h,w());this.p.write(n)}}e.$5h=r}),define(ae[37],ce([0,1,15,14,13]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AV=void 0;class M{constructor(){this.a=new WeakMap}on(P,g){const l=(w,...v)=>{this.b(P,w)&&g(w,...v)};return this.a.set(g,l),S.ipcMain.on(P,l),this}once(P,g){return S.ipcMain.once(P,(l,...w)=>{this.b(P,l)&&g(l,...w)}),this}handle(P,g){return S.ipcMain.handle(P,(l,...w)=>this.b(P,l)?g(l,...w):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return S.ipcMain.removeHandler(P),this}removeListener(P,g){const l=this.a.get(g);return l&&(S.ipcMain.removeListener(P,l),this.a.delete(g)),this}b(P,g){if(!P||!P.startsWith("vscode:"))return(0,D.$1)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const l=g.senderFrame,w=l.url;if(!w||w==="about:blank")return!0;let v="unknown";try{v=new URL(w).host}catch{return(0,D.$1)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${w}'.`),!1}return v!==s.$xg?((0,D.$1)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${v}'.`),!1):l.parent!==null?((0,D.$1)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${v}' is not a main frame.`),!1):!0}}e.$AV=new M}),define(ae[158],ce([0,1,15,37,146]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BV=void 0;function M(){D.$AV.on(s.$yV,(P,g,l,w,v)=>{const y=A(P,w,l);y.popup({x:v?v.x:void 0,y:v?v.y:void 0,positioningItem:v?v.positioningItem:void 0,callback:()=>{y&&P.sender.send(s.$zV,g)}})})}e.$BV=M;function A(P,g,l){const w=new S.Menu;return l.forEach(v=>{let y;v.type==="separator"?y=new S.MenuItem({type:v.type}):Array.isArray(v.submenu)?y=new S.MenuItem({submenu:A(P,g,v.submenu),label:v.label}):y=new S.MenuItem({label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:v.enabled,visible:v.visible,click:(h,m,p)=>P.sender.send(g,v.id,p)}),w.append(y)}),w}}),define(ae[159],ce([0,1,37,17,3,2,43,147]),function(Y,e,S,D,s,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HV=void 0;function g(w,v){const y=s.Event.fromNodeEventEmitter(S.$AV,v,(m,p)=>({event:m,message:p})),h=s.Event.filter(y,({event:m})=>m.sender.id===w);return s.Event.map(h,({message:m})=>m&&D.$se.wrap(m))}class l extends A.$Uh{static{this.b=new Map}static d(){const v=s.Event.fromNodeEventEmitter(S.$AV,"vscode:hello",({sender:y})=>y);return s.Event.map(v,y=>{const h=y.id;l.b.get(h)?.dispose();const p=new s.$5d;l.b.set(h,(0,M.$Rc)(()=>p.fire()));const k=g(h,"vscode:message"),u=s.Event.any(s.Event.signal(g(h,"vscode:disconnect")),p.event);return{protocol:new P.$GV(y,k),onDidClientDisconnect:u}})}constructor(){super(l.d())}}e.$HV=l}),define(ae[112],ce([0,1,37,3,32,157]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JV=e.$IV=void 0;class A extends M.$EV{constructor(l,w){super({addEventListener:(v,y)=>l.addListener(v,y),removeEventListener:(v,y)=>l.removeListener(v,y),postMessage:v=>l.postMessage(v),start:()=>l.start(),close:()=>l.close()},w)}}e.$IV=A;async function P(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,s.$Ag)();g.webContents.send("vscode:createMessageChannel",l);const w=D.Event.fromNodeEventEmitter(S.$AV,"vscode:createMessageChannelResult",(y,h)=>({nonce:h,port:y.ports[0]})),{port:v}=await D.Event.toPromise(D.Event.once(D.Event.filter(w,y=>y.nonce===l)));return v}e.$JV=P}),define(ae[160],ce([0,1,48,8,17,23,154,14,3,2,35,89,75,43]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=void 0;class m extends h.$Sh{constructor(u){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",f=>s.$se.wrap(Buffer.from(f,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$Bq=m;class p{constructor(u,f){this.i=u,this.j=f,this.c=new Set,this.g=new Map,this.h=new g.$5d,this.onDidProcessExit=this.h.event;const d=f&&f.timeout?f.timeout:6e4;this.b=new D.$bh(d),this.d=null,this.f=null}getChannel(u){const f=this;return{call(d,$,a){return f.k(u,d,$,a)},listen(d,$){return f.l(u,d,$)}}}k(u,f,d,$=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const a=this.n(u),t=(0,D.$4g)(i=>a.call(f,d,i)),o=$.onCancellationRequested(()=>t.cancel()),r=(0,l.$Rc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,f,d){if(!this.b)return g.Event.None;this.b.cancel();let $;const a=new g.$5d({onWillAddFirstListener:()=>{$=this.n(u).listen(f,d)(a.fire,a),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,w.$Hn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.$4l)(f.env),this.d=(0,S.fork)(this.i,u,f);const d=new g.$5d;g.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,A.$xq)(n)){(0,A.log)(n,`IPC Library: ${this.j.serverName}`);return}d.fire(s.$se.wrap(Buffer.from(n,"base64")))});const a=this.j.useQueue?(0,v.$6l)(this.d):this.d,t=n=>this.d&&this.d.connected&&a.send(n.buffer.toString("base64")),o=d.event,r={send:t,onMessage:o};this.f=new h.$Th(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,c)=>{process.removeListener("exit",i),this.c.forEach(b=>(0,l.$Oc)(b)),this.c.clear(),n!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:c})})}return this.f}n(u){let f=this.g.get(u);return f||(f=this.m.getChannel(u),this.g.set(u,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Cq=p}),define(ae[113],ce([0,1,8,3,2,76,12]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.StorageState=e.$Ap=e.StorageHint=void 0;var P;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function g(y){const h=y;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$Ap=g;var l;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(l||(e.StorageState=l={}));class w extends s.$Tc{static{this.a=100}constructor(h,m=Object.create(null)){super(),this.r=h,this.s=m,this.b=this.B(new D.$8d),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new S.$ch(w.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach((m,p)=>this.w(p,m)),h.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(h,m){if(this.c===l.Closed)return;let p=!1;(0,A.$2f)(m)?p=this.f.delete(h):this.f.get(h)!==m&&(this.f.set(h,m),p=!0),p&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,m){const p=this.f.get(h);return(0,A.$2f)(p)?m:p}getBoolean(h,m){const p=this.get(h);return(0,A.$2f)(p)?m:p==="true"}getNumber(h,m){const p=this.get(h);return(0,A.$2f)(p)?m:parseInt(p,10)}getObject(h,m){const p=this.get(h);return(0,A.$2f)(p)?m:(0,M.$Mh)(p)}async set(h,m,p=!1){if(this.c===l.Closed)return;if((0,A.$2f)(m))return this.delete(h,p);const k=(0,A.$Uf)(m)||Array.isArray(m)?(0,M.$Lh)(m):String(m);if(this.f.get(h)!==k)return this.f.set(h,k),this.j.set(h,k),this.h.delete(h),this.b.fire({key:h,external:p}),this.D()}async delete(h,m=!1){if(!(this.c===l.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:m}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(this.z)return this.D(h)}async D(h){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$Bp=w;class v{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((m,p)=>this.a.set(p,m)),h.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$Cp=v}),define(ae[161],ce([0,1,8,3,31,9,21]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6V=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return D.Event.None}static{this.a=2e3}static{this.b=256}constructor(w,v=Object.create(null)){this.g=w,this.h=v,this.c=(0,M.$nc)(this.g),this.d=new g(this.h.logging),this.f=this.n(this.g)}async getItems(){const w=await this.f,v=new Map;return(await this.s(w,"SELECT * FROM ItemTable")).forEach(h=>v.set(h.key,h.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(w){const v=await this.f;return this.j(v,w)}j(w,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,s.$yc)(v.insert):"0"}), delete(${v.delete?(0,s.$zc)(v.delete):"0"})`),this.t(w,()=>{const y=v.insert,h=v.delete;if(y&&y.size>0){const m=[];m.push([]);let p=0;y.forEach((k,u)=>{let f=m[p];f.length>P.b&&(p++,f=[],m.push(f)),f.push(u,k)}),m.forEach(k=>{this.u(w,`INSERT INTO ItemTable VALUES ${new Array(k.length/2).fill("(?,?)").join(",")}`,u=>u.run(k),()=>{const u=[];let f=0;return y.forEach((d,$)=>{u.push($),f+=d.length}),`Keys: ${u.join(", ")} Length: ${f}`})})}if(h&&h.size){const m=[];m.push([]);let p=0;h.forEach(k=>{let u=m[p];u.length>P.b&&(p++,u=[],m.push(u)),u.push(k)}),m.forEach(k=>{this.u(w,`DELETE FROM ItemTable WHERE key IN (${new Array(k.length).fill("?").join(",")})`,u=>u.run(k),()=>{const u=[];return h.forEach(f=>{u.push(f)}),`Keys: ${u.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const w=await this.f;return this.q(w,"VACUUM")}async close(w){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,w)}k(w,v){return new Promise((y,h)=>{w.db.close(m=>(m&&this.o(w,`[storage ${this.c}] close(): ${m}`),this.g===P.IN_MEMORY_PATH?y():!w.isErroneous&&!w.isInMemory?this.l().then(y,p=>(this.d.error(`[storage ${this.c}] backup(): ${p}`),y())):typeof v=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(p=>{const k=()=>this.k(p,void 0);return this.j(p,{insert:v()}).then(()=>k(),u=>(k(),Promise.reject(u)))})).then(y,h):h(m||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const w=this.m(this.g);return A.Promises.copy(this.g,w,{preserveSymlinks:!1})}m(w){return`${w}.backup`}async checkIntegrity(w){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${w})`);const v=await this.f,y=await this.r(v,w?"PRAGMA integrity_check":"PRAGMA quick_check"),h=w?y.integrity_check:y.quick_check;return v.isErroneous?`${h} (last error: ${v.lastError})`:v.isInMemory?`${h} (in-memory!)`:h}async n(w,v=!0){this.d.trace(`[storage ${this.c}] open(${w}, retryOnBusy: ${v})`);try{return await this.p(w)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&v)return await(0,S.$fh)(P.a),this.n(w,!1);try{await A.Promises.unlink(w);try{await A.Promises.rename(this.m(w),w,!1)}catch{}return await this.p(w)}catch(h){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${h}`),this.p(P.IN_MEMORY_PATH)}}}o(w,v){w.isErroneous=!0,w.lastError=v,this.d.error(v)}p(w){return new Promise((v,y)=>{new Promise((h,m)=>{Y(["@vscode/sqlite3"],h,m)}).then(h=>{const m={db:new(this.d.isTracing?h.verbose().Database:h.Database)(w,p=>p?m.db&&p.code!=="SQLITE_CANTOPEN"?m.db.close(()=>y(p)):y(p):this.q(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(m),k=>m.db.close(()=>y(k)))),isInMemory:w===P.IN_MEMORY_PATH};m.db.on("error",p=>this.o(m,`[storage ${this.c}] Error (event): ${p}`)),this.d.isTracing&&m.db.on("trace",p=>this.d.trace(`[storage ${this.c}] Trace (event): ${p}`))},y)})}q(w,v){return new Promise((y,h)=>{w.db.exec(v,m=>m?(this.o(w,`[storage ${this.c}] exec(): ${m}`),h(m)):y())})}r(w,v){return new Promise((y,h)=>{w.db.get(v,(m,p)=>m?(this.o(w,`[storage ${this.c}] get(): ${m}`),h(m)):y(p))})}s(w,v){return new Promise((y,h)=>{w.db.all(v,(m,p)=>m?(this.o(w,`[storage ${this.c}] all(): ${m}`),h(m)):y(p))})}t(w,v){return new Promise((y,h)=>{w.db.serialize(()=>{w.db.run("BEGIN TRANSACTION"),v(),w.db.run("END TRANSACTION",m=>m?(this.o(w,`[storage ${this.c}] transaction(): ${m}`),h(m)):y())})})}u(w,v,y,h){const m=w.db.prepare(v),p=k=>{this.o(w,`[storage ${this.c}] prepare(): ${k} (${v}). Details: ${h()}`)};m.on("error",p),y(m),m.finalize(k=>{k&&p(k),m.removeListener("error",p)})}}e.$6V=P;class g{static{this.a="VSCODE_TRACE_STORAGE"}constructor(w){w&&typeof w.logTrace=="function"&&process.env[g.a]&&(this.b=w.logTrace),w&&typeof w.logError=="function"&&(this.c=w.logError)}get isTracing(){return!!this.b}trace(w){this.b?.(w)}error(w){this.c?.(w)}}}),define(ae[162],ce([11,10]),function(Y,e){return Y.create("vs/code/electron-main/app",e)}),define(ae[163],ce([11,10]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[164],ce([11,10]),function(Y,e){return Y.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[165],ce([11,10]),function(Y,e){return Y.create("vs/platform/contextkey/common/scanner",e)}),define(ae[166],ce([11,10]),function(Y,e){return Y.create("vs/platform/dialogs/common/dialogs",e)}),define(ae[167],ce([11,10]),function(Y,e){return Y.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ae[168],ce([11,10]),function(Y,e){return Y.create("vs/platform/environment/node/argv",e)}),define(ae[169],ce([11,10]),function(Y,e){return Y.create("vs/platform/environment/node/argvHelper",e)}),define(ae[170],ce([11,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[171],ce([11,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[172],ce([11,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[173],ce([11,10]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[174],ce([11,10]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ae[175],ce([11,10]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(ae[176],ce([11,10]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ae[177],ce([11,10]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(ae[178],ce([11,10]),function(Y,e){return Y.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ae[179],ce([11,10]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[180],ce([11,10]),function(Y,e){return Y.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ae[181],ce([11,10]),function(Y,e){return Y.create("vs/platform/menubar/electron-main/menubar",e)}),define(ae[182],ce([11,10]),function(Y,e){return Y.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ae[183],ce([11,10]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(ae[184],ce([11,10]),function(Y,e){return Y.create("vs/platform/shell/node/shellEnv",e)}),define(ae[185],ce([11,10]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[186],ce([11,10]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ae[187],ce([11,10]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ae[188],ce([11,10]),function(Y,e){return Y.create("vs/platform/update/common/update.config.contribution",e)}),define(ae[189],ce([11,10]),function(Y,e){return Y.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[190],ce([11,10]),function(Y,e){return Y.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ae[191],ce([11,10]),function(Y,e){return Y.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ae[192],ce([11,10]),function(Y,e){return Y.create("vs/platform/workspace/common/workspace",e)}),define(ae[193],ce([11,10]),function(Y,e){return Y.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ae[194],ce([11,10]),function(Y,e){return Y.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ae[195],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$db=e.$0db=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$0db=S;function D(s){return s&&s.hasOwnProperty("workspace")}e.$$db=D}),define(ae[196],ce([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m$b=e.$l$b=e.$k$b=void 0;function D(A){return typeof A?.backupFolder=="string"}e.$k$b=D;function s(A){let P=[];try{Array.isArray(A.workspaces)&&(P=A.workspaces.map(g=>({workspace:{id:g.id,configPath:S.URI.parse(g.configURIPath)},remoteAuthority:g.remoteAuthority})))}catch{}return P}e.$l$b=s;function M(A){let P=[];try{Array.isArray(A.folders)&&(P=A.folders.map(g=>({folderUri:S.URI.parse(g.folderUri),remoteAuthority:g.remoteAuthority})))}catch{}return P}e.$m$b=M}),define(ae[197],ce([0,1,14,165]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.TokenType=void 0;var s;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...l){switch(l.length){case 1:return(0,D.localize)(0,null,l[0]);case 2:return(0,D.localize)(1,null,l[0],l[1]);case 3:return(0,D.localize)(2,null,l[0],l[1],l[2]);default:return}}const A=(0,D.localize)(3,null),P=(0,D.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return w.isTripleEq?"===":"==";case 4:return w.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return w.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return w.lexeme;case 18:return w.lexeme;case 19:return w.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(w){return this.c=w,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(w){return this.r()||this.c.charCodeAt(this.e)!==w?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(w){this.f.push({type:w,offset:this.d})}l(w){const v=this.d,y=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:y};this.g.push({offset:v,lexeme:y,additionalInfo:w}),this.f.push(h)}n(){this.m.lastIndex=this.d;const w=this.m.exec(this.c);if(w){this.e=this.d+w[0].length;const v=this.c.substring(this.d,this.e),y=g.b.get(v);y?this.k(y):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let w=this.e,v=!1,y=!1;for(;;){if(w>=this.c.length){this.e=w,this.l(P);return}const m=this.c.charCodeAt(w);if(v)v=!1;else if(m===47&&!y){w++;break}else m===91?y=!0:m===92?v=!0:m===93&&(y=!1);w++}for(;w<this.c.length&&g.a.has(this.c.charCodeAt(w));)w++;this.e=w;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$_i=g}),define(ae[198],ce([0,1,3,2]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;class s{constructor(){this.a=new S.$5d,this.b=new S.$5d,this.c=new S.$5d,this.d=new S.$5d}static{this.ChannelName="extensionhostdebugservice"}call(P,g,l){switch(g){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(P,g,l){switch(g){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$no=s;class M extends D.$Tc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,g,l){this.b.call("attach",[P,g,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,g){this.b.call("terminate",[P,g])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,g){return this.b.call("openExtensionDevelopmentHostWindow",[P,g])}}e.$oo=M}),define(ae[199],ce([0,1,149,50,13,9,36,19,7]),function(Y,e,S,D,s,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=e.$Jm=void 0,e.$Jm=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,M.$mc)(s.$yg.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,M.$jc)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,P.$Rg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$Rg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,S.$Im)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$jc)(this.userDataPath,"logs",h)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$Rg)(g.URI.file((0,M.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$Rg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$Rg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$Rg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=A.env.VSCODE_PORTABLE;return h?g.URI.file((0,M.$jc)(h,"argv.json")):(0,P.$Rg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,M.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,M.$kc)(h):(0,M.$hc)((0,M.$jc)(s.$yg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?g.URI.file((0,M.$kc)(h)):g.URI.file((0,M.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,M.$kc)(h);const m=A.env.VSCODE_EXTENSIONS;if(m)return m;const p=A.env.VSCODE_PORTABLE;return p?(0,M.$jc)(p,"extensions"):(0,P.$Rg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(m=>/^[^:/?#]+?:\/\//.test(m)?g.URI.parse(m):g.URI.file((0,M.$hc)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?g.URI.parse(h):g.URI.file((0,M.$hc)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Jm.test(h))}get extensionLogLevel(){const h=[];for(const m of this.args.log||[]){const p=e.$Jm.exec(m);p&&p[1]&&p[2]&&h.push([p[1],p[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,P.$Rg)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=A.env.VSCODE_PORTABLE;return h?g.URI.file((0,M.$jc)(h,"policy.json")):(0,P.$Rg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,m,p){this.a=h,this.b=m,this.c=p,this.editSessionId=this.args.editSessionId}}e.$Km=l,ve([D.$Ih],l.prototype,"appRoot",null),ve([D.$Ih],l.prototype,"userHome",null),ve([D.$Ih],l.prototype,"userDataPath",null),ve([D.$Ih],l.prototype,"appSettingsHome",null),ve([D.$Ih],l.prototype,"tmpDir",null),ve([D.$Ih],l.prototype,"cacheHome",null),ve([D.$Ih],l.prototype,"stateResource",null),ve([D.$Ih],l.prototype,"userRoamingDataHome",null),ve([D.$Ih],l.prototype,"userDataSyncHome",null),ve([D.$Ih],l.prototype,"sync",null),ve([D.$Ih],l.prototype,"machineSettingsResource",null),ve([D.$Ih],l.prototype,"workspaceStorageHome",null),ve([D.$Ih],l.prototype,"localHistoryHome",null),ve([D.$Ih],l.prototype,"keyboardLayoutResource",null),ve([D.$Ih],l.prototype,"argvResource",null),ve([D.$Ih],l.prototype,"isExtensionDevelopment",null),ve([D.$Ih],l.prototype,"untitledWorkspacesHome",null),ve([D.$Ih],l.prototype,"builtinExtensionsPath",null),ve([D.$Ih],l.prototype,"extensionsPath",null),ve([D.$Ih],l.prototype,"extensionDevelopmentLocationURI",null),ve([D.$Ih],l.prototype,"extensionDevelopmentKind",null),ve([D.$Ih],l.prototype,"extensionTestsLocationURI",null),ve([D.$Ih],l.prototype,"debugExtensionHost",null),ve([D.$Ih],l.prototype,"logLevel",null),ve([D.$Ih],l.prototype,"extensionLogLevel",null),ve([D.$Ih],l.prototype,"serviceMachineIdResource",null),ve([D.$Ih],l.prototype,"disableTelemetry",null),ve([D.$Ih],l.prototype,"disableWorkspaceTrust",null),ve([D.$Ih],l.prototype,"useInMemorySecretStorage",null),ve([D.$Ih],l.prototype,"policyFile",null);function w(y,h){return v(y["inspect-extensions"],y["inspect-brk-extensions"],5870,h,y.debugId,y.extensionEnvironment)}e.$Lm=w;function v(y,h,m,p,k,u){const d=Number(h||y)||(p?null:m),$=d?!!h:!1;let a;if(u)try{a=JSON.parse(u)}catch{}return{port:d,break:$,debugId:k,env:a}}e.$Mm=v}),define(ae[114],ce([0,1,309,4,168]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$8l=["tunnel","serve-web"],e.$9l={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(p,k,u=A){const f=p.find(c=>c.length>0&&c[0]!=="-"),d={},$=["_"],a=[],t={};let o;for(const c in k){const b=k[c];b.type==="subcommand"?c===f&&(o=b):(b.alias&&(d[c]=b.alias),b.type==="string"||b.type==="string[]"?($.push(c),b.deprecates&&$.push(...b.deprecates)):b.type==="boolean"&&(a.push(c),b.deprecates&&a.push(...b.deprecates)),b.global&&(t[c]=b))}if(o&&f){const c=t;for(const E in o.options)c[E]=o.options[E];const b=p.filter(E=>E!==f),R=u.getSubcommandReporter?u.getSubcommandReporter(f):void 0,I=P(b,c,R);return{[f]:I,_:[]}}const r=S(p,{string:$,boolean:a,alias:d}),i={},n=r;i._=r._.map(c=>String(c)).filter(c=>c.length>0),delete n._;for(const c in k){const b=k[c];if(b.type==="subcommand")continue;b.alias&&delete n[b.alias];let R=n[c];if(b.deprecates)for(const I of b.deprecates)n.hasOwnProperty(I)&&(R||(R=n[I],R&&u.onDeprecatedOption(I,b.deprecationMessage||(0,s.localize)(38,null,c))),delete n[I]);if(typeof R<"u"){if(b.type==="string[]"){if(Array.isArray(R)||(R=[R]),!b.allowEmptyValue){const I=R.filter(E=>E.length>0);I.length!==R.length&&(u.onEmptyValue(c),R=I.length>0?I:void 0)}}else b.type==="string"&&(Array.isArray(R)?(R=R.pop(),u.onMultipleValues(c,R)):!R&&!b.allowEmptyValue&&(u.onEmptyValue(c),R=void 0));i[c]=R,b.deprecationMessage&&u.onDeprecatedOption(c,b.deprecationMessage)}delete n[c]}for(const c in n)u.onUnknownOption(c);return i}e.$0l=P;function g(p,k){let u="";return k.args&&(Array.isArray(k.args)?u=` <${k.args.join("> <")}>`:u=` <${k.args}>`),k.alias?`-${k.alias} --${p}${u}`:`--${p}${u}`}function l(p,k){const u=[];for(const f in p){const d=p[f],$=g(f,d);u.push([$,d.description])}return w(u,k)}e.$$l=l;function w(p,k){const f=p.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(k-f<25)return p.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const d=k-f-1,$=[];for(const a of p){const t=a[0],o=y(a[1],d),r=v(f-t.length-2);$.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)$.push(v(f)+o[i])}return $}function v(p){return" ".repeat(p)}function y(p,k){const u=[];for(;p.length;){const f=p.length<k?p.length:p.lastIndexOf(" ",k),d=p.slice(0,f).trim();p=p.slice(f),u.push(d)}return u}function h(p,k,u,f,d){const $=process.stdout.isTTY&&process.stdout.columns||80,a=d?.noInputFiles!==!0?`[${(0,s.localize)(39,null)}...]`:"",t=[`${p} ${u}`];t.push(""),t.push(`${(0,s.localize)(40,null)}: ${k} [${(0,s.localize)(41,null)}]${a}`),t.push(""),d?.noPipe!==!0&&(D.$i?t.push((0,s.localize)(42,null,k)):t.push((0,s.localize)(43,null,k)),t.push(""));const o={},r=[];for(const i in f){const n=f[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let c=o[n.cat];c||(o[n.cat]=c={}),c[i]=n}}for(const i in o){const n=i,c=o[n];c&&(t.push(M[n]),t.push(...l(c,$)),t.push(""))}return r.length&&(t.push((0,s.localize)(44,null)),t.push(...w(r.map(i=>[i.command,i.description]),$)),t.push("")),t.join(`
`)}e.$_l=h;function m(p,k){return`${p||(0,s.localize)(45,null)}
${k||(0,s.localize)(46,null)}
${process.arch}`}e.$am=m}),define(ae[200],ce([0,1,87,198,114]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=void 0;class M extends D.$no{constructor(P){super(),this.f=P}call(P,g,l){return g==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(P,g,l)}async g(P,g){const l=(0,s.$0l)(P,s.$9l);l.debugRenderer=g;const w=l.extensionDevelopmentPath;if(!w)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(w,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!g)return{success:!0};const y=v.win;if(!y)return{success:!0};const h=y.webContents.debugger;let m=h.isAttached()?1/0:0;const p=(0,S.createServer)(k=>{m++===0&&h.attach();let u=!1;const f=a=>{u||k.write(JSON.stringify(a)+"\0")},d=(a,t,o,r)=>f({method:t,params:o,sessionId:r});y.on("close",()=>{h.removeListener("message",d),k.end(),u=!0}),h.addListener("message",d);let $=Buffer.alloc(0);k.on("data",a=>{$=Buffer.concat([$,a]);for(let t=$.indexOf(0);t!==-1;t=$.indexOf(0)){let o;try{const r=$.slice(0,t).toString("utf8");$=$.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}h.sendCommand(o.method,o.params,o.sessionId).then(r=>f({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>f({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),k.on("error",a=>{console.error("error on cdp pipe:",a)}),k.on("close",()=>{u=!0,--m===0&&h.detach()})});return await new Promise(k=>p.listen(0,k)),y.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.$Y$b=M}),define(ae[64],ce([0,1,310,169,114]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=e.$cm=e.$bm=void 0;function M(v,y){const h=(d,$)=>{console.warn((0,D.localize)(0,null,d,$))},m=d=>{console.warn((0,D.localize)(1,null,d))},p=(d,$)=>{console.warn((0,D.localize)(2,null,d,$))},k=d=>({onUnknownOption:$=>{s.$8l.includes(d)||console.warn((0,D.localize)(3,null,$,d))},onMultipleValues:h,onEmptyValue:m,onDeprecatedOption:p,getSubcommandReporter:s.$8l.includes(d)?k:void 0}),u={onUnknownOption:d=>{console.warn((0,D.localize)(4,null,d))},onMultipleValues:h,onEmptyValue:m,onDeprecatedOption:p,getSubcommandReporter:k},f=(0,s.$0l)(v,s.$9l,y?u:void 0);return f.goto&&f._.forEach(d=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(d),(0,D.localize)(5,null))),f}function A(v){const y=v.findIndex(h=>!/^-/.test(h));if(y>-1)return[...v.slice(0,y),...v.slice(y+1)]}function P(v){let[,...y]=v;process.env.VSCODE_DEV&&(y=A(y)||[]);const h=!w(process.env);return M(y,h)}e.$bm=P;function g(v){let[,,...y]=v;return process.env.VSCODE_DEV&&(y=A(y)||[]),M(y,!0)}e.$cm=g;function l(v,...y){const h=v.indexOf("--");return h===-1?v.push(...y):v.splice(h,0,...y),v}e.$dm=l;function w(v){return v.VSCODE_CLI==="1"}e.$em=w}),function(){"use strict";function Y(e,S,D){function s(A,P){const g=M(A,P),l=[g];return e.isAbsolute(g)||l.unshift(D),e.resolve(...l)}function M(A,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,P);const w=A["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(v,"AppData","Roaming")}break;case"darwin":l=e.join(S.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,P)}return{getUserDataPath:s}}if(typeof define=="function")define(ae[201],ce([115,26,36]),function(e,S,D){return Y(e,S,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=Y(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[90],ce([0,1,26,199,201]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0;class M extends D.$Km{constructor(l,w){super(l,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(l,w.nameShort)},w)}}e.$Nm=M;function A(g,l){return(0,D.$Mm)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,l,g.extensionEnvironment)}e.$Om=A;function P(g,l){return(0,D.$Mm)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,l,g.extensionEnvironment)}e.$Pm=P}),define(ae[202],ce([0,1,46,26,33]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fac=void 0;function M(A){const P=(0,s.$ng)((0,D.tmpdir)());try{return(0,S.writeFileSync)(P,""),A&&console.log(`Marker file for --wait created: ${P}`),P}catch(g){A&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.$fac=M}),define(ae[203],ce([0,1,12,171]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;function s(A,P,g,l){try{M(A,P,g,l)}catch(w){A.error(w?.message??w)}return P}e.$0p=s;function M(A,P,g,l){const w=(v,y,h)=>{const m=v[y];if((0,S.$Sf)(m)){const p=m,k=p.length;if(k>1&&p[0]==="%"&&p[k-1]==="%"){const u=p.substr(1,k-2);let f=g[u];f===void 0&&l&&(f=l[u]);const d=typeof f=="string"?f:f?.message,$=l?.[u],a=typeof $=="string"?$:$?.message;if(!d){a||A.warn(`[${P.name}]: ${(0,D.localize)(0,null,u)}`);return}if(h&&(y==="title"||y==="category")&&a&&a!==d){const t={value:d,original:a};v[y]=t}else v[y]=d}}else if((0,S.$Uf)(m))for(const p in m)m.hasOwnProperty(p)&&(p==="commands"?w(m,p,!0):w(m,p,h));else if(Array.isArray(m))for(let p=0;p<m.length;p++)w(m,p,h)};for(const v in P)P.hasOwnProperty(v)&&w(P,v)}}),define(ae[204],ce([0,1,19,73,173,205]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function g(u){return u=u.trim(),u==="*"||A.test(u)}e.$lp=g;function l(u){if(!g(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=u.match(A);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$mp=l;function w(u){if(!u)return null;const f=u.majorBase,d=u.majorMustEqual,$=u.minorBase;let a=u.minorMustEqual;const t=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(f===0||(a=!1),o=!1);let r=0;if(u.preRelease){const i=P.exec(u.preRelease);if(i){const[,n,c,b]=i;r=Date.UTC(Number(n),Number(c)-1,Number(b))}}return{majorBase:f,majorMustEqual:d,minorBase:$,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:r}}e.$np=w;function v(u,f,d){let $;typeof u=="string"?$=w(l(u)):$=u;let a;f instanceof Date?a=f.getTime():typeof f=="string"&&(a=new Date(f).getTime());let t;if(typeof d=="string"?t=w(l(d)):t=d,!$||!t)return!1;const o=$.majorBase,r=$.minorBase,i=$.patchBase;let n=t.majorBase,c=t.minorBase,b=t.patchBase;const R=t.notBefore;let I=t.majorMustEqual,E=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:r>c?!0:r<c||a&&a<R?!1:i>=b:(o===1&&n===0&&(!I||!E||!C)&&(n=1,c=0,b=0,I=!0,E=!1,C=!1),o<n?!1:o>n?!I:r<c?!1:r>c?!E:i<b?!1:i>b?!C:!(a&&a<R))}e.$op=v;function y(u,f,d,$,a){const t=[];if(typeof $.publisher<"u"&&typeof $.publisher!="string")return t.push([D.default.Error,s.localize(0,null)]),t;if(typeof $.name!="string")return t.push([D.default.Error,s.localize(1,null,"name")]),t;if(typeof $.version!="string")return t.push([D.default.Error,s.localize(2,null,"version")]),t;if(!$.engines)return t.push([D.default.Error,s.localize(3,null,"engines")]),t;if(typeof $.engines.vscode!="string")return t.push([D.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof $.extensionDependencies<"u"&&!k($.extensionDependencies))return t.push([D.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof $.activationEvents<"u"){if(!k($.activationEvents))return t.push([D.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof $.main>"u"&&typeof $.browser>"u")return t.push([D.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof $.extensionKind<"u"&&typeof $.main>"u"&&t.push([D.default.Warning,s.localize(8,null,"extensionKind")]),typeof $.main<"u"){if(typeof $.main!="string")return t.push([D.default.Error,s.localize(9,null,"main")]),t;{const i=(0,S.$Rg)(d,$.main);(0,S.$Lg)(i,d)||t.push([D.default.Warning,s.localize(10,null,i.path,d.path)])}}if(typeof $.browser<"u"){if(typeof $.browser!="string")return t.push([D.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,S.$Rg)(d,$.browser);(0,S.$Lg)(i,d)||t.push([D.default.Warning,s.localize(12,null,i.path,d.path)])}}if(!M.valid($.version))return t.push([D.default.Error,s.localize(13,null)]),t;const o=[];if(!h(u,f,$,a,o))for(const i of o)t.push([D.default.Error,i]);return t}e.$pp=y;function h(u,f,d,$,a){return $||typeof d.main>"u"&&typeof d.browser>"u"?!0:p(u,f,d.engines.vscode,a)}e.$qp=h;function m(u,f,d){return u==="*"||p(f,d,u)}e.$rp=m;function p(u,f,d,$=[]){const a=w(l(d));if(!a)return $.push(s.localize(14,null,d)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return $.push(s.localize(15,null,d)),!1}else if(!a.majorMustEqual)return $.push(s.localize(16,null,d)),!1;return v(u,f,a)?!0:($.push(s.localize(17,null,u,d)),!1)}function k(u){if(!Array.isArray(u))return!1;for(let f=0,d=u.length;f<d;f++)if(typeof u[f]!="string")return!1;return!0}}),define(ae[206],ce([0,1,17,32]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;async function s(M,A,P){let g=P&&P.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const w=(await A.readFile(M.serviceMachineIdResource)).value.toString();g=(0,D.$zg)(w)?w:null}catch{g=null}if(!g){g=(0,D.$Ag)();try{await A.writeFile(M.serviceMachineIdResource,S.$se.fromString(g))}catch{}}return P?.store("storage.serviceMachineId",g,-1,1),g}e.$Lp=s}),define(ae[77],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=void 0;class S{constructor(s,M=[],A=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$bi=S}),define(ae[207],ce([0,1,77]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.InstantiationType=void 0;const D=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(P,g,l){g instanceof S.$bi||(g=new S.$bi(g,[],!!l)),D.push([P,g])}e.$0r=M;function A(){return D}e.$$r=A}),define(ae[208],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=void 0;class S{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Nq=S;class D{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const P=this.lookupOrInsertNode(M),g=this.lookupOrInsertNode(A);P.outgoing.set(g.key,g),g.incoming.set(P.key,P)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const P of this.a.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let P=this.a.get(A);return P||(P=new S(A,M),this.a.set(A,P)),P}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,P]of this.a)M.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const P=new Set([M]),g=this.c(A,P);if(g)return g}}c(M,A){for(const[P,g]of M.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const l=this.c(g,A);if(l)return l;A.delete(P)}}}e.$Oq=D}),define(ae[6],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e._util=void 0;var S;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(g){return g[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(S||(e._util=S={})),e.$di=s("instantiationService");function D(A,P,g){P[S.DI_TARGET]===P?P[S.DI_DEPENDENCIES].push({id:A,index:g}):(P[S.DI_DEPENDENCIES]=[{id:A,index:g}],P[S.DI_TARGET]=P)}function s(A){if(S.serviceIds.has(A))return S.serviceIds.get(A);const P=function(g,l,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(P,g,w)};return P.toString=()=>A,S.serviceIds.set(A,P),P}e.$ei=s;function M(A){return A}e.$fi=M}),define(ae[78],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_b=void 0,e.$e_b=(0,S.$ei)("auxiliaryWindowsMainService")}),define(ae[65],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n$b=void 0,e.$n$b=(0,S.$ei)("backupMainService")}),define(ae[18],ce([0,1,12,7,6]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ConfigurationTarget=e.$Mi=e.$Li=e.$Ki=void 0,e.$Ki=(0,s.$ei)("configurationService");function M(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof D.URI)}e.$Li=M;function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof D.URI)}e.$Mi=A;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function g(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ni=g;function l(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$Oi=l;function w(u,f){const d=Object.create(null);for(const $ in u)v(d,$,u[$],f);return d}e.$Pi=w;function v(u,f,d,$){const a=f.split("."),t=a.pop();let o=u;for(let r=0;r<a.length;r++){const i=a[r];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:$(`Ignoring ${f} as ${a.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=d}catch{$(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}else $(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.$Qi=v;function y(u,f){const d=f.split(".");h(u,d)}e.$Ri=y;function h(u,f){const d=f.shift();if(f.length===0){delete u[d];return}if(Object.keys(u).indexOf(d)!==-1){const $=u[d];typeof $=="object"&&!Array.isArray($)&&(h($,f),Object.keys($).length===0&&delete u[d])}}function m(u,f,d){function $(o,r){let i=o;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const a=f.split("."),t=$(u,a);return typeof t>"u"?d:t}e.$Si=m;function p(u,f,d){Object.keys(f).forEach($=>{$!=="__proto__"&&($ in u?S.$Uf(u[$])&&S.$Uf(f[$])?p(u[$],f[$],d):d&&(u[$]=f[$]):u[$]=f[$])})}e.$Ti=p;function k(u){return u.replace(/[\[\]]/g,"")}e.$Ui=k}),define(ae[116],ce([0,1,4,25,197,6,164,14]),function(Y,e,S,D,s,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.ContextKeyExprType=e.$aj=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",S.$j),g.set("isLinux",S.$k),g.set("isWindows",S.$i),g.set("isWeb",S.$o),g.set("isMacNative",S.$j&&!S.$o),g.set("isEdge",S.$H),g.set("isFirefox",S.$F),g.set("isChrome",S.$E),g.set("isSafari",S.$G);function l(K,O){if(g.get(K)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(K,O)}e.$aj=l;const w=Object.prototype.hasOwnProperty;var v;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const y={regexParsingWithErrorRecovery:!0},h=(0,A.localize)(0,null),m=(0,A.localize)(1,null),p=(0,A.localize)(2,null),k=(0,A.localize)(3,null),u=(0,A.localize)(4,null),f=(0,A.localize)(5,null),d=(0,A.localize)(6,null),$=(0,A.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=y){this.k=O,this.d=new s.$_i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const W=this.l();if(!this.E()){const x=this.D(),N=x.type===17?f:void 0;throw this.h.push({message:u,offset:x.offset,lexeme:s.$_i.getLexeme(x),additionalInfo:N}),a.c}return W}catch(W){if(W!==a.c)throw W;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const W=this.o();O.push(W)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const W=this.s();O.push(W)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const W=this.l();return this.A(1,k),W?.negate()}case 17:return this.z(),j.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const W=this.l();return this.A(1,k),W}case 17:{const W=O.lexeme;if(this.z(),this.y(9)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==10)throw this.B("REGEX",N);const Q=N.lexeme,H=Q.lastIndexOf("/"),_=H===Q.length-1?void 0:this.w(Q.substring(H+1));let z;try{z=new RegExp(Q.substring(1,H),_)}catch{throw this.B("REGEX",N)}return re.create(W,z)}switch(N.type){case 10:case 19:{const Q=[N.lexeme];this.z();let H=this.D(),_=0;for(let me=0;me<N.lexeme.length;me++)N.lexeme.charCodeAt(me)===40?_++:N.lexeme.charCodeAt(me)===41&&_--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let me=0;me<H.lexeme.length;me++)H.lexeme.charCodeAt(me)===40?_++:N.lexeme.charCodeAt(me)===41&&_--}if(_<0)break;Q.push(s.$_i.getLexeme(H)),this.z(),H=this.D()}const z=Q.join(""),ee=z.lastIndexOf("/"),ie=ee===z.length-1?void 0:this.w(z.substring(ee+1));let de;try{de=new RegExp(z.substring(1,ee),ie)}catch{throw this.B("REGEX",N)}return t.regex(W,de)}case 18:{const Q=N.lexeme;this.z();let H=null;if(!(0,D.$Se)(Q)){const _=Q.indexOf("/"),z=Q.lastIndexOf("/");if(_!==z&&_>=0){const ee=Q.slice(_+1,z),ie=Q[z+1]==="i"?"i":"";try{H=new RegExp(ee,ie)}catch{throw this.B("REGEX",N)}}}if(H===null)throw this.B("REGEX",N);return re.create(W,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const N=this.u();return t.notIn(W,N)}switch(this.D().type){case 3:{this.z();const N=this.u();if(this.x().type===18)return t.equals(W,N);switch(N){case"true":return t.has(W);case"false":return t.not(W);default:return t.equals(W,N)}}case 4:{this.z();const N=this.u();if(this.x().type===18)return t.notEquals(W,N);switch(N){case"true":return t.not(W);case"false":return t.has(W);default:return t.notEquals(W,N)}}case 5:return this.z(),J.create(W,this.u());case 6:return this.z(),le.create(W,this.u());case 7:return this.z(),F.create(W,this.u());case 8:return this.z(),V.create(W,this.u());case 13:return this.z(),t.in(W,this.u());default:return t.has(W)}}case 20:throw this.h.push({message:d,offset:O.offset,lexeme:"",additionalInfo:$}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,W){if(this.C(O))return this.z();throw this.B(W,this.D())}B(O,W,x){const N=(0,A.localize)(8,null,O,s.$_i.getLexeme(W)),Q=W.offset,H=s.$_i.getLexeme(W);return this.h.push({message:N,offset:Q,lexeme:H,additionalInfo:x}),a.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$bj=a;class t{static false(){return n.INSTANCE}static true(){return c.INSTANCE}static has(O){return b.create(O)}static equals(O,W){return R.create(O,W)}static notEquals(O,W){return C.create(O,W)}static regex(O,W){return re.create(O,W)}static in(O,W){return I.create(O,W)}static notIn(O,W){return E.create(O,W)}static not(O){return j.create(O)}static and(...O){return X.create(O,null,!0)}static or(...O){return q.create(O,null,!0)}static greater(O,W){return F.create(O,W)}static greaterEquals(O,W){return V.create(O,W)}static smaller(O,W){return J.create(O,W)}static smallerEquals(O,W){return le.create(O,W)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$cj=t;function o(K){const O=new a({regexParsingWithErrorRecovery:!1});return K.map(W=>(O.parse(W),O.lexingErrors.length>0?O.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,A.localize)(9,null,x.additionalInfo):(0,A.localize)(10,null),offset:x.offset,length:x.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.$dj=o;function r(K,O){const W=K?K.substituteConstants():void 0,x=O?O.substituteConstants():void 0;return!W&&!x?!0:!W||!x?!1:W.equals(x)}e.$ej=r;function i(K,O){return K.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return c.INSTANCE}}e.$fj=n;class c{static{this.INSTANCE=new c}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$gj=c;class b{static create(O,W=null){const x=g.get(O);return typeof x=="boolean"?x?c.INSTANCE:n.INSTANCE:new b(O,W)}constructor(O,W){this.key=O,this.c=W,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:T(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=g.get(this.key);return typeof O=="boolean"?O?c.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$hj=b;class R{static create(O,W,x=null){if(typeof W=="boolean")return W?b.create(O,x):j.create(O,x);const N=g.get(O);return typeof N=="boolean"?W===(N?"true":"false")?c.INSTANCE:n.INSTANCE:new R(O,W,x)}constructor(O,W,x){this.c=O,this.d=W,this.f=x,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=g.get(this.c);if(typeof O=="boolean"){const W=O?"true":"false";return this.d===W?c.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$ij=R;class I{static create(O,W){return new I(O,W)}constructor(O,W){this.d=O,this.f=W,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:G(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const W=O.getValue(this.f),x=O.getValue(this.d);return Array.isArray(W)?W.includes(x):typeof x=="string"&&typeof W=="object"&&W!==null?w.call(W,x):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$jj=I;class E{static create(O,W){return new E(O,W)}constructor(O,W){this.d=O,this.f=W,this.type=11,this.c=I.create(O,W)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$kj=E;class C{static create(O,W,x=null){if(typeof W=="boolean")return W?j.create(O,x):b.create(O,x);const N=g.get(O);return typeof N=="boolean"?W===(N?"true":"false")?n.INSTANCE:c.INSTANCE:new C(O,W,x)}constructor(O,W,x){this.c=O,this.d=W,this.f=x,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=g.get(this.c);if(typeof O=="boolean"){const W=O?"true":"false";return this.d===W?n.INSTANCE:c.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$lj=C;class j{static create(O,W=null){const x=g.get(O);return typeof x=="boolean"?x?n.INSTANCE:c.INSTANCE:new j(O,W)}constructor(O,W){this.c=O,this.d=W,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:T(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=g.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:c.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$mj=j;function U(K,O){if(typeof K=="string"){const W=parseFloat(K);isNaN(W)||(K=W)}return typeof K=="string"||typeof K=="number"?O(K):n.INSTANCE}class F{static create(O,W,x=null){return U(W,N=>new F(O,N,x))}constructor(O,W,x){this.c=O,this.d=W,this.f=x,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$nj=F;class V{static create(O,W,x=null){return U(W,N=>new V(O,N,x))}constructor(O,W,x){this.c=O,this.d=W,this.f=x,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$oj=V;class J{static create(O,W,x=null){return U(W,N=>new J(O,N,x))}constructor(O,W,x){this.c=O,this.d=W,this.f=x,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$pj=J;class le{static create(O,W,x=null){return U(W,N=>new le(O,N,x))}constructor(O,W,x){this.c=O,this.d=W,this.f=x,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$qj=le;class re{static create(O,W){return new re(O,W)}constructor(O,W){this.d=O,this.f=W,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const W=this.f?this.f.source:"",x=O.f?O.f.source:"";return W<x?-1:W>x?1:0}equals(O){if(O.type===this.type){const W=this.f?this.f.source:"",x=O.f?O.f.source:"";return this.d===O.d&&W===x}return!1}substituteConstants(){return this}evaluate(O){const W=O.getValue(this.d);return this.f?this.f.test(W):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$rj=re;class ue{static create(O){return new ue(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ue(this.c.map(O))}negate(){return this.c}}e.$sj=ue;function Z(K){let O=null;for(let W=0,x=K.length;W<x;W++){const N=K[W].substituteConstants();if(K[W]!==N&&O===null){O=[];for(let Q=0;Q<W;Q++)O[Q]=K[Q]}O!==null&&(O[W]=N)}return O===null?K:O}class X{static create(O,W,x){return X.d(O,W,x)}constructor(O,W){this.expr=O,this.c=W,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let W=0,x=this.expr.length;W<x;W++){const N=i(this.expr[W],O.expr[W]);if(N!==0)return N}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let W=0,x=this.expr.length;W<x;W++)if(!this.expr[W].equals(O.expr[W]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:X.create(O,this.c,!1)}evaluate(O){for(let W=0,x=this.expr.length;W<x;W++)if(!this.expr[W].evaluate(O))return!1;return!0}static d(O,W,x){const N=[];let Q=!1;for(const H of O)if(H){if(H.type===1){Q=!0;continue}if(H.type===0)return n.INSTANCE;if(H.type===6){N.push(...H.expr);continue}N.push(H)}if(N.length===0&&Q)return c.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(i);for(let H=1;H<N.length;H++)N[H-1].equals(N[H])&&(N.splice(H,1),H--);if(N.length===1)return N[0];for(;N.length>1;){const H=N[N.length-1];if(H.type!==9)break;N.pop();const _=N.pop(),z=N.length===0,ee=q.create(H.expr.map(ie=>X.create([ie,_],null,x)),null,z);ee&&(N.push(ee),N.sort(i))}if(N.length===1)return N[0];if(x){for(let H=0;H<N.length;H++)for(let _=H+1;_<N.length;_++)if(N[H].negate().equals(N[_]))return n.INSTANCE;if(N.length===1)return N[0]}return new X(N,W)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const W of this.expr)O.push(...W.keys());return O}map(O){return new X(this.expr.map(W=>W.map(O)),null)}negate(){if(!this.c){const O=[];for(const W of this.expr)O.push(W.negate());this.c=q.create(O,this,!0)}return this.c}}e.$tj=X;class q{static create(O,W,x){return q.d(O,W,x)}constructor(O,W){this.expr=O,this.c=W,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let W=0,x=this.expr.length;W<x;W++){const N=i(this.expr[W],O.expr[W]);if(N!==0)return N}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let W=0,x=this.expr.length;W<x;W++)if(!this.expr[W].equals(O.expr[W]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:q.create(O,this.c,!1)}evaluate(O){for(let W=0,x=this.expr.length;W<x;W++)if(this.expr[W].evaluate(O))return!0;return!1}static d(O,W,x){let N=[],Q=!1;if(O){for(let H=0,_=O.length;H<_;H++){const z=O[H];if(z){if(z.type===0){Q=!0;continue}if(z.type===1)return c.INSTANCE;if(z.type===9){N=N.concat(z.expr);continue}N.push(z)}}if(N.length===0&&Q)return n.INSTANCE;N.sort(i)}if(N.length!==0){if(N.length===1)return N[0];for(let H=1;H<N.length;H++)N[H-1].equals(N[H])&&(N.splice(H,1),H--);if(N.length===1)return N[0];if(x){for(let H=0;H<N.length;H++)for(let _=H+1;_<N.length;_++)if(N[H].negate().equals(N[_]))return c.INSTANCE;if(N.length===1)return N[0]}return new q(N,W)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const W of this.expr)O.push(...W.keys());return O}map(O){return new q(this.expr.map(W=>W.map(O)),null)}negate(){if(!this.c){const O=[];for(const W of this.expr)O.push(W.negate());for(;O.length>1;){const W=O.shift(),x=O.shift(),N=[];for(const Q of he(W))for(const H of he(x))N.push(X.create([Q,H],null,!1));O.unshift(q.create(N,null,!1))}this.c=q.create(O,this,!0)}return this.c}}e.$uj=q;class L extends b{static{this.d=[]}static all(){return L.d.values()}constructor(O,W,x){super(O,null),this.f=W,typeof x=="object"?L.d.push({...x,key:O}):x!==!0&&L.d.push({key:O,description:x,type:W!=null?typeof W:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return R.create(this.key,O)}notEqualsTo(O){return C.create(this.key,O)}}e.$vj=L,e.$wj=(0,M.$ei)("contextKeyService");function T(K,O){return K<O?-1:K>O?1:0}function G(K,O,W,x){return K<W?-1:K>W?1:O<x?-1:O>x?1:0}function B(K,O){if(K.type===0||O.type===1)return!0;if(K.type===9)return O.type===9?oe(K.expr,O.expr):!1;if(O.type===9){for(const W of O.expr)if(B(K,W))return!0;return!1}if(K.type===6){if(O.type===6)return oe(O.expr,K.expr);for(const W of K.expr)if(B(W,O))return!0;return!1}return K.equals(O)}e.$xj=B;function oe(K,O){let W=0,x=0;for(;W<K.length&&x<O.length;){const N=K[W].cmp(O[x]);if(N<0)return!1;N===0&&W++,x++}return W===K.length}function he(K){return K.type===9?K.expr:[K]}}),define(ae[91],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=e.ID=void 0,e.ID="diagnosticsService",e.$Um=(0,S.$ei)(e.ID);function D(M){return!!M.hostName&&!!M.errorMessage}e.$Vm=D;class s{async getPerformanceInfo(A,P){return{}}async getSystemInfo(A,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,P){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$Wm=s}),define(ae[117],ce([0,1,19,73,166,6,47,4,35]),function(Y,e,S,D,s,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jw=e.$iw=e.ConfirmResult=e.$hw=e.$gw=e.$fw=void 0,e.$fw=(0,M.$ei)("dialogService");var l;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(l||(l={}));class w{a(k){return this.d(k,l.Confirmation)}b(k){return this.d(k,l.Prompt)}c(k){return this.d(k,l.Input)}d(k,u){const f=[];switch(u){case l.Confirmation:{const d=k;d.primaryButton?f.push(d.primaryButton):f.push((0,s.localize)(0,null)),d.cancelButton?f.push(d.cancelButton):f.push((0,s.localize)(1,null));break}case l.Prompt:{const d=k;Array.isArray(d.buttons)&&d.buttons.length>0&&f.push(...d.buttons.map($=>$.label)),d.cancelButton&&(d.cancelButton===!0?f.push((0,s.localize)(2,null)):typeof d.cancelButton=="string"?f.push(d.cancelButton):d.cancelButton.label?f.push(d.cancelButton.label):f.push((0,s.localize)(3,null))),f.length===0&&f.push((0,s.localize)(4,null));break}case l.Input:{const d=k;d.primaryButton?f.push(d.primaryButton):f.push((0,s.localize)(5,null)),d.cancelButton?f.push(d.cancelButton):f.push((0,s.localize)(6,null));break}}return f}e(k){if(typeof k=="string")return k;if(typeof k=="number")return k===D.default.Info?"info":k===D.default.Error?"error":k===D.default.Warning?"warning":"none"}f(k,u,f){const d=[...k.buttons??[]];k.cancelButton&&typeof k.cancelButton!="string"&&typeof k.cancelButton!="boolean"&&d.push(k.cancelButton);let $=d[u]?.run({checkboxChecked:f});return $ instanceof Promise||($=Promise.resolve($)),{result:$,checkboxChecked:f}}}e.$gw=w,e.$hw=(0,M.$ei)("fileDialogService");var v;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(v||(e.ConfirmResult=v={}));const y=10;function h(p){const k=[];return k.push(...p.slice(0,y).map(u=>typeof u=="string"?u:(0,S.$Og)(u))),p.length>y&&(p.length-y===1?k.push((0,s.localize)(7,null)):k.push((0,s.localize)(8,null,p.length-y))),k.push(""),k.join(`
`)}e.$iw=h;function m(p,k){const u=(0,g.$Hn)(p);let f=(u.buttons??[]).map(t=>(0,A.$cw)(t)),d=(p.buttons||[]).map((t,o)=>o),$=0,a=u.cancelId??f.length-1;if(f.length>1){const t=typeof a=="number"?f[a]:void 0;if(P.$k||P.$j){if(typeof t=="string"&&f.length>1&&a!==1){f.splice(a,1),f.splice(1,0,t);const o=d[a];d.splice(a,1),d.splice(1,0,o),a=1}P.$k&&f.length>1&&(f=f.reverse(),d=d.reverse(),$=f.length-1,typeof t=="string"&&(a=$-1))}else if(P.$i&&typeof t=="string"&&f.length>1&&a!==f.length-1){f.splice(a,1),f.push(t);const o=d[a];d.splice(a,1),d.push(o),a=f.length-1}}return u.buttons=f,u.defaultId=$,u.cancelId=a,u.noLink=!0,u.title=u.title||k.nameLong,{options:u,buttonIndeces:d}}e.$jw=m}),define(ae[118],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lW=e.$kW=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$jW=e.$iW=void 0,e.$iW=(0,S.$ei)("encryptionService"),e.$jW=(0,S.$ei)("encryptionMainService");var D;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(D||(e.PasswordStoreCLIOption=D={}));var s;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$kW=M;function A(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$lW=A}),define(ae[38],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=void 0,e.$li=(0,S.$ei)("environmentService"),e.$mi=(0,S.$fi)(e.$li)}),define(ae[119],ce([0,1,170,6]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.ExtensionGalleryErrorCode=e.$Lo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ko=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0,e.$yo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$zo=new RegExp(e.$yo),e.$Ao="__web_extension",e.$Bo="skipWalkthrough",e.$Co="extensionsSync",e.$Do="dependecyOrPackExtensionInstall";function s(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Eo=s;function M(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Fo=M;function A(d,$){switch(d){case 3:return $==="x64"?"win32-x64":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Go=A;function P(d,$){return $==="web"&&!d.includes("web")}e.$Ho=P;function g(d,$,a){return P($,a)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===a}e.$Io=g;function l(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.$Jo=l;var w;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var v;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var y;(function(d){d.Install="install",d.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var h;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$Ko=(0,D.$ei)("extensionGalleryService");var m;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.DownloadSignature="DownloadSignature",d.UpdateMetadata="UpdateMetadata",d.Extract="Extract",d.Scanning="Scanning",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.NotAllowed="NotAllowed",d.Gallery="Gallery",d.Unknown="Unknown",d.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var p;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class k extends Error{constructor($,a){super($),this.code=a,this.name=a}}e.$Lo=k;var u;(function(d){d.Timeout="Timeout",d.Cancelled="Cancelled",d.Failed="Failed"})(u||(e.ExtensionGalleryErrorCode=u={}));class f extends Error{constructor($,a){super($),this.code=a,this.name=a}}e.$Mo=f,e.$No=(0,D.$ei)("extensionManagementService"),e.$Oo="extensionsIdentifiers/disabled",e.$Po="extensionsIdentifiers/enabled",e.$Qo=(0,D.$ei)("IGlobalExtensionEnablementService"),e.$Ro=(0,D.$ei)("IExtensionTipsService"),e.$So=(0,S.localize2)(0,"Extensions"),e.$To=(0,S.localize2)(1,"Preferences")}),define(ae[209],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=e.$6$b=void 0,e.$6$b=(0,S.$ei)("extensionHostStarter"),e.$7$b="extensionHostStarter"}),define(ae[210],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_3b=e.$$3b=void 0,e.$$3b=(0,S.$ei)("externalTerminal"),e.$_3b="Terminal.app"}),define(ae[211],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9$b=void 0,e.$9$b=(0,S.$ei)("externalTerminal")}),define(ae[212],ce([0,1,48,50,13,9,4,75,21,89,174,210]),function(Y,e,S,D,s,M,A,P,g,l,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_$b=e.$$$b=e.$0$b=void 0;const y=w.localize(0,null);class h{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await k.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends h{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(S,a,l.$5l(),t)}spawnTerminal(a,t,o,r){const i=t.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=M.$nc(i,".exe").toLowerCase();if(n==="cmder")return a.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return i.indexOf(" ")>=0&&c.push('""'),c.push(i),n==="wt"&&c.push("-d ."),new Promise((b,R)=>{const I=u(process),E=a.spawn(o,c,{cwd:r,env:I,detached:!0});E.on("error",R),E.on("exit",()=>b())})}async runInTerminal(a,t,o,r,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:m.getDefaultTerminalWindows(),c=await m.f();return new Promise((b,R)=>{const I=`"${t} - ${y}"`,E=`""${o.join('" "')}" & pause"`,C=Object.assign({},u(process),r);Object.keys(C).filter(J=>C[J]===null).forEach(J=>delete C[J]);const j={cwd:t,env:C,windowsVerbatimArguments:!0};let U,F;M.$nc(n,".exe")==="wt"?(U=n,F=["-d",".",m.b,"/c",E]):c?(U=c,F=["-d",t||".",n,"/c",E]):(U=m.b,F=["/c","start",I,"/wait",n,"/c",E]),S.spawn(U,F,j).on("error",J=>{R(f(J))}),b(void 0)})}static getDefaultTerminalWindows(){if(!m.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return m.d}static async f(){try{const a=await l.win32.findExecutable("wt");return await g.Promises.exists(a)?a:void 0}catch{return}}}e.$0$b=m,ve([D.$Ih],m,"f",null);class p extends h{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(S,a,t)}runInTerminal(a,t,o,r,i){const n=i.osxExec||v.$_3b;return new Promise((c,b)=>{if(n===v.$_3b||n==="iTerm.app"){const R=n===v.$_3b?"TerminalHelper":"iTermHelper",E=[s.$yg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${R}.scpt`).fsPath,"-t",a||y,"-w",t];for(const U of o)E.push("-a"),E.push(U);if(r){const U=Object.assign({},u(process),r);for(const F in U){const V=U[F];V===null?(E.push("-u"),E.push(F)):(E.push("-e"),E.push(`${F}=${V}`))}}let C="";const j=S.spawn(p.b,E);j.on("error",U=>{b(f(U))}),j.stderr.on("data",U=>{C+=U.toString()}),j.on("exit",U=>{if(U===0)c(void 0);else if(C){const F=C.split(`
`,1);b(new Error(F[0]))}else b(new Error(w.localize(1,null,R,U)))})}else b(new Error(w.localize(2,null,n)))})}spawnTerminal(a,t,o){const r=t.osxExec||v.$_3b;return new Promise((i,n)=>{const c=["-a",r];o&&c.push(o);const b=u(process),R=a.spawn("/usr/bin/open",c,{cwd:o,env:b});R.on("error",n),R.on("exit",()=>i())})}}e.$$$b=p;class k extends h{static{this.b=w.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(S,a,t)}runInTerminal(a,t,o,r,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):k.getDefaultTerminalLinuxReady();return new Promise((c,b)=>{const R=[];n.then(I=>{I.indexOf("gnome-terminal")>=0?R.push("-x"):R.push("-e"),R.push("bash"),R.push("-c");const E=`${d(o)}; echo; read -p "${k.b}" -n1;`;R.push(`''${E}''`);const C=Object.assign({},u(process),r);Object.keys(C).filter(V=>C[V]===null).forEach(V=>delete C[V]);const j={cwd:t,env:C};let U="";const F=S.spawn(I,R,j);F.on("error",V=>{b(f(V))}),F.stderr.on("data",V=>{U+=V.toString()}),F.on("exit",V=>{if(V===0)c(void 0);else if(U){const J=U.split(`
`,1);b(new Error(J[0]))}else b(new Error(w.localize(4,null,I,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!k.d)if(!A.$k)k.d=Promise.resolve("xterm");else{const a=await g.Promises.exists("/etc/debian_version");k.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return k.d}spawnTerminal(a,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):k.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{r.then(c=>{const b=u(process),R=a.spawn(c,[],{cwd:o,env:b});R.on("error",n),R.on("exit",()=>i())})})}}e.$_$b=k;function u($){const a={...$.env};return(0,P.$3l)(a),a}function f($){return"errno"in $&&$.errno==="ENOENT"&&"path"in $&&typeof $.path=="string"?new Error(w.localize(5,null,$.path)):$}function d($){let a="";for(const t of $)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(ae[16],ce([0,1,59,9,25,12,7,176,6,4,13,62]),function(Y,e,S,D,s,M,A,P,g,l,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.FileKind=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileOperationResult=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileChangeType=e.$Tk=e.FileOperation=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileSystemProviderErrorCode=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderCapabilities=e.$Dk=e.FilePermission=e.FileType=e.$Ck=e.$Bk=void 0,e.$Bk=(0,g.$ei)("fileService");function y(B){return B.create===!0}e.$Ck=y;var h;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var m;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function p(B){const oe=B;return!!oe&&typeof oe.onDidChange=="function"}e.$Dk=p;var k;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(k||(e.FileSystemProviderCapabilities=k={}));function u(B){return!!(B.capabilities&2)}e.$Ek=u;function f(B){return!!(B.capabilities&8)}e.$Fk=f;function d(B){return!!(B.capabilities&131072)}e.$Gk=d;function $(B){return!!(B.capabilities&4)}e.$Hk=$;function a(B){return!!(B.capabilities&16)}e.$Ik=a;function t(B){return u(B)?!!(B.capabilities&16384):!1}e.$Jk=t;function o(B){return u(B)?!!(B.capabilities&32768):!1}e.$Kk=o;function r(B){return!!(B.capabilities&65536)}e.$Lk=r;function i(B){return!!(B.capabilities&2048)}e.$Mk=i;var n;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class c extends Error{static create(oe,he){const K=new c(oe.toString(),he);return I(K,he),K}constructor(oe,he){super(oe),this.code=he}}e.$Nk=c;function b(B,oe){return c.create(B,oe)}e.$Ok=b;function R(B){return B||b((0,P.localize)(0,null),n.Unknown)}e.$Pk=R;function I(B,oe){return B.name=oe?`${oe} (FileSystemError)`:"FileSystemError",B}e.$Qk=I;function E(B){if(!B)return n.Unknown;if(B instanceof c)return B.code;const oe=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!oe)return n.Unknown;switch(oe[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$Rk=E;function C(B){if(B instanceof le)return B.fileOperationResult;switch(E(B)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$Sk=C;var j;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class U{constructor(oe,he,K){this.resource=oe,this.operation=he,this.target=K}isOperation(oe){return this.operation===oe}}e.$Tk=U;var F;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class V{static{this.a=null}constructor(oe,he){this.c=he,this.b=void 0,this.d=new v.$V(()=>{const K=S.$ki.forUris(()=>this.c);return K.fill(this.rawAdded.map(O=>[O,!0])),K}),this.f=new v.$V(()=>{const K=S.$ki.forUris(()=>this.c);return K.fill(this.rawUpdated.map(O=>[O,!0])),K}),this.g=new v.$V(()=>{const K=S.$ki.forUris(()=>this.c);return K.fill(this.rawDeleted.map(O=>[O,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of oe){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==V.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(oe,...he){return this.h(oe,{includeChildren:!1},...he)}affects(oe,...he){return this.h(oe,{includeChildren:!0},...he)}h(oe,he,...K){if(!oe)return!1;const O=K.length>0;return!!((!O||K.includes(1))&&(this.d.value.get(oe)||he.includeChildren&&this.d.value.findSuperstr(oe))||(!O||K.includes(0))&&(this.f.value.get(oe)||he.includeChildren&&this.f.value.findSuperstr(oe))||(!O||K.includes(2))&&(this.g.value.findSubstr(oe)||he.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$Uk=V;function J(B,oe,he){return!B||!oe||B===oe||oe.length>B.length?!1:(oe.charAt(oe.length-1)!==D.sep&&(oe+=D.sep),he?(0,s.$kf)(B,oe):B.indexOf(oe)===0)}e.$Vk=J;class le extends Error{constructor(oe,he,K){super(oe),this.fileOperationResult=he,this.options=K}}e.$Wk=le;class re extends le{constructor(oe,he,K,O){super(oe,he,O),this.fileOperationResult=he,this.size=K}}e.$Xk=re;class ue extends le{constructor(oe,he,K){super(oe,2,K),this.stat=he}}e.$Yk=ue;var Z;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$Zk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$1k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$2k="files.associations",e.$3k="files.exclude",e.$4k="files.readonlyInclude",e.$5k="files.readonlyExclude",e.$6k="files.readonlyFromPermissions";var X;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$7k="";function q(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.$8k=q;async function L(B,oe){if(!oe.hasProvider(A.URI.from({scheme:B.scheme})))return new Promise(he=>{const K=oe.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===B.scheme&&O.added&&(K.dispose(),he())})})}e.$9k=L;class T{static{this.KB=1024}static{this.MB=T.KB*T.KB}static{this.GB=T.MB*T.KB}static{this.TB=T.GB*T.KB}static formatSize(oe){return(0,M.$Wf)(oe)||(oe=0),oe<T.KB?(0,P.localize)(1,null,oe.toFixed(0)):oe<T.MB?(0,P.localize)(2,null,(oe/T.KB).toFixed(2)):oe<T.GB?(0,P.localize)(3,null,(oe/T.MB).toFixed(2)):oe<T.TB?(0,P.localize)(4,null,(oe/T.GB).toFixed(2)):(0,P.localize)(5,null,(oe/T.TB).toFixed(2))}}e.$0k=T;function G(B){const oe=typeof B=="string"||B?.scheme===w.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===w.Schemas.file?1024*T.MB:oe?10*T.MB:l.$o?50*T.MB:1024*T.MB}e.$$k=G}),define(ae[120],ce([0,1,17,14,177,16]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;async function A(w,v,y,h,m,p){let k;try{await P(w,v,y,h,m,p)}catch(u){k=u}finally{k&&m.errorTransformer&&(k=m.errorTransformer(k)),typeof k<"u"&&y.error(k),y.end()}}e.$mq=A;async function P(w,v,y,h,m,p){g(p);const k=await w.open(v,{create:!1});try{g(p);let u=0,f=0,d=m&&typeof m.length=="number"?m.length:void 0,$=S.$se.alloc(Math.min(m.bufferSize,typeof d=="number"?d:m.bufferSize)),a=m&&typeof m.position=="number"?m.position:0,t=0;do f=await w.read(k,a,$.buffer,t,$.byteLength-t),a+=f,t+=f,u+=f,typeof d=="number"&&(d-=f),t===$.byteLength&&(await y.write(h($)),$=S.$se.alloc(Math.min(m.bufferSize,typeof d=="number"?d:m.bufferSize)),t=0);while(f>0&&(typeof d!="number"||d>0)&&g(p)&&l(u,m));if(t>0){let o=t;typeof d=="number"&&(o=Math.min(t,d)),y.write(h($.slice(0,o)))}}catch(u){throw(0,M.$Pk)(u)}finally{await w.close(k)}}function g(w){if(w.isCancellationRequested)throw(0,D.$6)();return!0}function l(w,v){if(typeof v?.limits?.size=="number"&&w>v.limits.size)throw(0,M.$Ok)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[66],ce([0,1,106,2,9,4,7,16]),function(Y,e,S,D,s,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=void 0;function g(u){return u.recursive===!0}e.$oq=g;class l extends D.$Tc{static{this.a=5}constructor(f,d,$,a){super(),this.h=f,this.j=d,this.m=$,this.n=a,this.c=this.B(new D.$Uc),this.f=void 0,this.g=0}s(){const f=new D.$Sc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(d=>this.h(d))),f.add(this.b.onDidLogMessage(d=>this.j(d))),f.add(this.b.onDidError(d=>this.t(d)))}t(f){this.n.restartOnError?this.g<l.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$pq=l;class w extends l{constructor(f,d,$){super(f,d,$,{type:"node.js",restartOnError:!1})}}e.$qq=w;class v extends l{constructor(f,d,$){super(f,d,$,{type:"universal",restartOnError:!0})}}e.$rq=v;function y(u){return u.map(f=>({type:f.type,resource:A.URI.revive(f.resource),cId:f.cId}))}e.$sq=y;function h(u){const f=new k;for(const d of u)f.processEvent(d);return f.coalesce()}e.$tq=h;function m(u,f){return typeof f=="string"&&!f.startsWith(S.$Tj)&&!(0,s.$ic)(f)?{base:u,pattern:f}:f}e.$uq=m;function p(u,f){const d=[];for(const $ of f)d.push((0,S.$Xj)(m(u,$)));return d}e.$vq=p;class k{constructor(){this.a=new Set,this.b=new Map}c(f){return M.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const d=this.b.get(this.c(f));let $=!1;if(d){const a=d.type,t=f.type;d.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?$=!0:a===1&&t===2?(this.b.delete(this.c(f)),this.a.delete(d)):a===2&&t===1?d.type=0:a===1&&t===0||(d.type=t)}else $=!0;$&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],d=[];return Array.from(this.a).filter($=>$.type!==2?(f.push($),!1):!0).sort(($,a)=>$.resource.fsPath.length-a.resource.fsPath.length).filter($=>d.some(a=>(0,P.$Vk)($.resource.fsPath,a,!M.$k))?!1:(d.push($.resource.fsPath),!0)).concat(f)}}}),define(ae[213],ce([0,1,17,51,14,3,2,63,32,16,66]),function(Y,e,S,D,s,M,A,P,g,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jP=e.$iP=void 0,e.$iP="localFilesystem";class v extends A.$Tc{constructor(h,m){super(),this.a=h,this.b=m,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$5d),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$5d),this.onDidWatchError=this.g.event,this.h=(0,g.$Ag)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,m){const{buffer:p}=await this.a.call("readFile",[h,m]);return p}readFileStream(h,m,p){const k=(0,P.$ge)(f=>S.$se.concat(f.map(d=>S.$se.wrap(d))).buffer),u=new A.$Sc;return u.add(this.a.listen("readFileStream",[h,m])(f=>{if(f instanceof S.$se)k.write(f.buffer);else{if(f==="end")k.end();else{let d;if(f instanceof Error)d=f;else{const $=f;d=(0,l.$Ok)($.message??(0,D.$2i)($),$.code??l.FileSystemProviderErrorCode.Unknown)}k.error(d),k.end()}u.dispose()}})),u.add(p.onCancellationRequested(()=>{k.error((0,s.$6)()),k.end(),u.dispose()})),k}writeFile(h,m,p){return this.a.call("writeFile",[h,S.$se.wrap(m),p])}open(h,m){return this.a.call("open",[h,m])}close(h){return this.a.call("close",[h])}async read(h,m,p,k,u){const[f,d]=await this.a.call("read",[h,m,u]);return p.set(f.buffer.slice(0,d),k),d}write(h,m,p,k,u){return this.a.call("write",[h,m,S.$se.wrap(p),k,u])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,m){return this.a.call("delete",[h,m])}rename(h,m,p){return this.a.call("rename",[h,m,p])}copy(h,m,p){return this.a.call("copy",[h,m,p])}cloneFile(h,m){return this.a.call("cloneFile",[h,m])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const m=h;this.f.fire((0,w.$sq)(m))}else{const m=h;this.g.fire(m)}}))}watch(h,m){const p=(0,g.$Ag)();return this.a.call("watch",[this.h,p,h,m]),(0,A.$Rc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$jP=v}),define(ae[214],ce([0,1,46,8,23,33,2,85,9,4,19,7,107,21,66]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=void 0;class p extends A.$Tc{static{this.a=100}static{this.b=75}constructor(f,d,$,a){super(),this.m=f,this.n=d,this.r=$,this.s=a,this.c=this.B(new D.$th({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new D.$sh(t=>this.z(t),p.b)),this.g=(0,m.$vq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,m.$vq)(this.m.path,this.m.includes):void 0,this.j=new s.$ce,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const d=await h.Promises.stat(f);this.B(await this.w(f,d.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let d=f.path;try{d=await h.Promises.realpath(f.path),f.path===d&&(d=await(0,y.$Fq)(f.path)??f.path),f.path!==d&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${d})`)}catch{}return d}async w(f,d){if(l.$j&&(0,M.$fg)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Tc.None;const $=new s.$ce(this.j.token),a=new A.$Sc;try{const t=v.URI.file(this.m.path),o=(0,g.$nc)(f),r=(0,S.watch)(f);a.add((0,A.$Rc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${f}'`);const i=new Set;if(d)try{for(const c of await h.Promises.readdir(f))i.add(c)}catch(c){this.D(c)}const n=new Map;a.add((0,A.$Rc)(()=>{for(const[,c]of n)c.dispose();n.clear()})),r.on("error",(c,b)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${c}, ${b})`),this.dispose()}),r.on("change",(c,b)=>{if($.token.isCancellationRequested)return;this.G(`[raw] ["${c}"] ${b}`);let R="";if(b&&(R=b.toString(),l.$j&&(R=(0,P.$Rl)(R))),!(!R||c!=="change"&&c!=="rename"))if(d)if(c==="rename"){n.get(R)?.dispose();const I=setTimeout(async()=>{if(n.delete(R),R===o&&!await h.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,g.$jc)(f,R));if($.token.isCancellationRequested)return;let C;E?i.has(R)?C=0:(C=1,i.add(R)):(i.delete(R),C=2),this.y({resource:(0,w.$Rg)(t,R),type:C,cId:this.m.correlationId})},p.a);n.set(R,(0,A.$Rc)(()=>clearTimeout(I)))}else{let I;i.has(R)?I=0:(I=1,i.add(R)),this.y({resource:(0,w.$Rg)(t,R),type:I,cId:this.m.correlationId})}else if(c==="rename"||R!==o){const I=setTimeout(async()=>{const E=await h.Promises.exists(f);$.token.isCancellationRequested||(E?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(f,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);a.clear(),a.add((0,A.$Rc)(()=>clearTimeout(I)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await h.Promises.exists(f)&&!$.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Rc)(()=>{$.dispose(!0),a.dispose()})}y(f,d=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!d&&this.g.some($=>$(f.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${f.resource.fsPath}`):!d&&this.h&&this.h.length>0&&!this.h.some($=>$(f.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}z(f){const d=(0,m.$tq)(f);if(d.length>0){if(this.s)for(const a of d)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(d)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if(l.$k)return h.Promises.exists(f);try{const d=(0,g.$nc)(f);return(await h.Promises.readdir((0,g.$mc)(f))).some(a=>a===d)}catch(d){return this.G(d),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Iq=p;async function k(u,f,d,$,a=512){const t=await h.Promises.open(u,"r"),o=Buffer.allocUnsafe(a),r=new s.$ce($);let i,n=!1;const c={path:u,excludes:[],recursive:!1},b=new p(c,R=>{(async()=>{for(const{type:I}of R)if(I===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await h.Promises.read(t,o,0,a,null);if(!E||r.token.isCancellationRequested)break;f(o.slice(0,E))}}catch(E){i=new Error(E),r.dispose(!0)}finally{n=!1}}})()});return await b.ready,d(),new Promise((R,I)=>{r.token.onCancellationRequested(async()=>{b.dispose();try{await h.Promises.close(t)}catch(E){i=new Error(E)}i?I(i):R()})})}e.$Jq=k}),define(ae[215],ce([0,1,3,106,2,4,214]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;class P extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new S.$5d),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$5d),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(l){const w=this.j(l),v=w.filter(h=>{const m=this.c.get(h.path);return m?!(0,D.$2j)(m.request.excludes,h.excludes)||!(0,D.$2j)(m.request.includes,h.includes):!0}),y=Array.from(this.c.values()).filter(({request:h})=>!w.find(m=>m.path===h.path&&(0,D.$2j)(m.excludes,h.excludes)&&(0,D.$2j)(m.includes,h.includes))).map(({request:h})=>h.path);v.length&&this.m(`Request to start watching: ${v.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const h of y)this.h(h);for(const h of v)this.g(h)}g(l){const w=new A.$Iq(l,y=>this.a.fire(y),y=>this.b.fire(y),this.f),v={request:l,instance:w};this.c.set(l.path,v)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const w=this.c.get(l);w&&(this.c.delete(l),w.instance.dispose())}j(l){const w=new Map;for(const v of l){const y=M.$k?v.path:v.path.toLowerCase();let h=w.get(v.correlationId);h||(h=new Map,w.set(v.correlationId,h)),h.set(y,v)}return Array.from(w.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(l){this.f=l;for(const[,w]of this.c)w.instance.setVerboseLogging(l)}m(l){this.f&&this.b.fire({type:"trace",message:this.n(l)})}n(l,w){return w?`[File Watcher (node.js)] ${l} (path: ${w.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$Kq=P}),define(ae[216],ce([0,1,66,215]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class s extends S.$qq{constructor(A,P,g){super(A,P,g),this.s()}r(A){return A.add(new D.$Kq)}}e.$Lq=s}),define(ae[217],ce([0,1,13,43,160,66]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;class A extends M.$rq{constructor(g,l,w){super(g,l,w),this.s()}r(g){const l=g.add(new s.$Cq(S.$yg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(l.onDidProcessExit(({code:w,signal:v})=>this.t(`terminated by itself with code ${w}, signal: ${v}`))),D.ProxyChannel.toService((0,D.$Xh)(l.getChannel("watcher")))}}e.$Dq=A}),define(ae[92],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=void 0;class S{constructor(...s){this.a=new Map;for(const[M,A]of s)this.set(M,A)}set(s,M){const A=this.a.get(s);return this.a.set(s,M),A}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$ci=S}),define(ae[218],ce([0,1,8,14,2,77,208,6,92,103]),function(Y,e,S,D,s,M,A,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=void 0;const w=!1;class v extends Error{constructor(k){super("cyclic dependency between services"),this.message=k.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${k.toString()}`}}class y{constructor(k=new g.$ci,u=!1,f,d=w){this.f=k,this.g=u,this.h=f,this.i=d,this.o=new Set,this.f.set(P.$di,this),this._globalGraph=d?f?._globalGraph??new A.$Oq($=>$):void 0}createChild(k){return new y(k,this.g,this,this.i)}invokeFunction(k,...u){const f=m.traceInvocation(this.i,k);let d=!1;try{return k({get:a=>{if(d)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,f);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...u)}finally{d=!0,f.stop()}}createInstance(k,...u){let f,d;return k instanceof M.$bi?(f=m.traceCreation(this.i,k.ctor),d=this.j(k.ctor,k.staticArguments.concat(u),f)):(f=m.traceCreation(this.i,k),d=this.j(k,u,f)),f.stop(),d}j(k,u=[],f){const d=P._util.getServiceDependencies(k).sort((t,o)=>t.index-o.index),$=[];for(const t of d){const o=this.m(t.id,f);o||this.u(`[createInstance] ${k.name} depends on UNKNOWN service ${t.id}.`,!1),$.push(o)}const a=d.length>0?d[0].index:u.length;if(u.length!==a){console.trace(`[createInstance] First service dependency of ${k.name} at position ${a+1} conflicts with ${u.length} static arguments`);const t=a-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,a)}return Reflect.construct(k,u.concat($))}k(k,u){if(this.f.get(k)instanceof M.$bi)this.f.set(k,u);else if(this.h)this.h.k(k,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(k){const u=this.f.get(k);return!u&&this.h?this.h.l(k):u}m(k,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(k));const f=this.l(k);return f instanceof M.$bi?this.q(k,f,u.branch(k,!0)):(u.branch(k,!1),f)}q(k,u,f){if(this.o.has(k))throw new Error(`illegal state - RECURSIVELY instantiating service '${k}'`);this.o.add(k);try{return this.r(k,u,f)}finally{this.o.delete(k)}}r(k,u,f){const d=new A.$Oq(t=>t.id.toString());let $=0;const a=[{id:k,desc:u,_trace:f}];for(;a.length;){const t=a.pop();if(d.lookupOrInsertNode(t),$++>1e3)throw new v(d);for(const o of P._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${k} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof M.$bi){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};d.insertEdge(t,i),a.push(i)}}}for(;;){const t=d.roots();if(t.length===0){if(!d.isEmpty())throw new v(d);break}for(const{data:o}of t){if(this.l(o.id)instanceof M.$bi){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}d.removeNode(o)}}return this.l(k)}s(k,u,f=[],d,$){if(this.f.get(k)instanceof M.$bi)return this.t(k,u,f,d,$);if(this.h)return this.h.s(k,u,f,d,$);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(k,u,f=[],d,$){if(d){const a=new y(void 0,this.g,this,this.i);a.c=String(k);const t=new Map,o=new S.$xh(()=>{const r=a.j(u,f,$);for(const[i,n]of t){const c=r[i];if(typeof c=="function")for(const b of n)b.disposable=c.apply(r,b.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=t.get(i);return b||(b=new l.$4c,t.set(i,b)),(I,E,C)=>{if(o.isInitialized)return o.value[i](I,E,C);{const j={listener:[I,E,C],disposable:void 0},U=b.push(j);return(0,s.$Rc)(()=>{U(),j.disposable?.dispose()})}}}if(i in r)return r[i];const n=o.value;let c=n[i];return typeof c!="function"||(c=c.bind(n),r[i]=c),c},set(r,i,n){return o.value[i]=n,!0},getPrototypeOf(r){return u.prototype}})}else return this.j(u,f,$)}u(k,u){if(u&&console.warn(k),this.g)throw new Error(k)}}e.$Pq=y;var h;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(h||(h={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(k,u){return k?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(k,u){return k?new m(1,u.name):m.c}static{this.f=0}constructor(k,u){this.type=k,this.name=u,this.g=Date.now(),this.h=[]}branch(k,u){const f=new m(3,k.toString());return this.h.push([k,u,f]),f}stop(){const k=Date.now()-this.g;m.f+=k;let u=!1;function f($,a){const t=[],o=new Array($+1).join("	");for(const[r,i,n]of a.h)if(i&&n){u=!0,t.push(`${o}CREATES -> ${r}`);const c=f($+1,n);c&&t.push(c)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${k.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(k>2||u)&&m.all.add(d.join(`
`))}}e.$Qq=m}),define(ae[219],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iBb=e.IssueType=void 0;var D;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(D||(e.IssueType=D={})),e.$iBb=(0,S.$ei)("issueService")}),define(ae[5],ce([0,1,51,3,45,2,31,4,19,12,7,116,6]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.log=e.$Bj=e.LogLevel=e.$Aj=e.$zj=e.$yj=void 0,e.$yj=(0,y.$ei)("logService"),e.$zj=(0,y.$ei)("loggerService");function h(){return new Date().toISOString()}function m(I){return(0,l.$Wf)(I)}e.$Aj=m;var p;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$Bj=p.Info;function k(I,E,C){switch(E){case p.Trace:I.trace(C);break;case p.Debug:I.debug(C);break;case p.Info:I.info(C);break;case p.Warning:I.warn(C);break;case p.Error:I.error(C);break;case p.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=k;function u(I,E=!1){let C="";for(let j=0;j<I.length;j++){let U=I[j];if(U instanceof Error&&(U=(0,S.$2i)(U,E)),typeof U=="object")try{U=JSON.stringify(U)}catch{}C+=(j>0?" ":"")+U}return C}class f extends M.$Tc{constructor(){super(...arguments),this.b=e.$Bj,this.c=this.B(new D.$5d),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==p.Off&&this.b<=E}}e.$Dj=f;class d extends f{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...C){this.f(p.Trace)&&this.g(p.Trace,u([E,...C],!0))}debug(E,...C){this.f(p.Debug)&&this.g(p.Debug,u([E,...C]))}info(E,...C){this.f(p.Info)&&this.g(p.Info,u([E,...C]))}warn(E,...C){this.f(p.Warning)&&this.g(p.Warning,u([E,...C]))}error(E,...C){if(this.f(p.Error))if(E instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=E.stack,this.g(p.Error,u(j))}else this.g(p.Error,u([E,...C]))}flush(){}}e.$Ej=d;class $ extends f{constructor(E=e.$Bj){super(),this.setLevel(E),this.g=!P.$i}trace(E,...C){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,E,...C):console.log(`[main ${h()}]`,E,...C))}debug(E,...C){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,E,...C):console.log(`[main ${h()}]`,E,...C))}info(E,...C){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,E,...C):console.log(`[main ${h()}]`,E,...C))}warn(E,...C){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,E,...C):console.warn(`[main ${h()}]`,E,...C))}error(E,...C){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,E,...C):console.error(`[main ${h()}]`,E,...C))}flush(){}}e.$Fj=$;class a extends f{constructor(E=e.$Bj,C=!0){super(),this.g=C,this.setLevel(E)}trace(E,...C){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...C):console.log(E,...C))}debug(E,...C){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...C):console.log(E,...C))}info(E,...C){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...C):console.log(E,...C))}warn(E,...C){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...C):console.log(E,...C))}error(E,...C){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...C):console.error(E,...C))}flush(){}}e.$Gj=a;class t extends f{constructor(E,C=e.$Bj){super(),this.g=E,this.setLevel(C)}trace(E,...C){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(E),...C])}debug(E,...C){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(E),...C])}info(E,...C){this.f(p.Info)&&this.g.log(p.Info,[this.h(E),...C])}warn(E,...C){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(E),...C])}error(E,...C){this.f(p.Error)&&this.g.log(p.Error,[this.h(E),...C])}h(E){return typeof E=="string"?E:(0,S.$2i)(E,this.f(p.Trace))}flush(){}}e.$Hj=t;class o extends f{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const C of this.g)C.setLevel(E);super.setLevel(E)}trace(E,...C){for(const j of this.g)j.trace(E,...C)}debug(E,...C){for(const j of this.g)j.debug(E,...C)}info(E,...C){for(const j of this.g)j.info(E,...C)}warn(E,...C){for(const j of this.g)j.warn(E,...C)}error(E,...C){for(const j of this.g)j.error(E,...C)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$Ij=o;class r extends M.$Tc{constructor(E,C,j){if(super(),this.h=E,this.j=C,this.b=new A.$Ac,this.c=this.B(new D.$5d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$5d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$5d),this.onDidChangeVisibility=this.g.event,j)for(const U of j)this.b.set(U.resource,{logger:void 0,info:U})}m(E){return(0,l.$Sf)(E)?[...this.b.values()].find(C=>C.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,C){const j=this.n(E),U=(0,l.$Sf)(E)?E:C?.id??(0,s.$5i)(j.toString()).toString(16);let F=this.b.get(j)?.logger;const V=C?.logLevel==="always"?p.Trace:C?.logLevel;F||(F=this.s(j,V??this.getLogLevel(j)??this.h,{...C,id:U}));const J={logger:F,info:{resource:j,id:U,logLevel:V,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(J.info),this.b.set(j,J),F}n(E){return(0,l.$Sf)(E)?(0,g.$Rg)(this.j,`${E}.log`):E}setLogLevel(E,C){if(w.URI.isUri(E)){const j=E,U=C,F=this.b.get(j);F&&U!==F.info.logLevel&&(F.info.logLevel=U===this.h?void 0:U,F.logger?.setLevel(U),this.b.set(F.info.resource,F),this.f.fire([j,U]))}else{this.h=E;for(const[j,U]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,C){const j=this.m(E);j&&C!==!j.info.hidden&&(j.info.hidden=!C,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,C]))}getLogLevel(E){let C;return E&&(C=this.b.get(E)?.info.logLevel),C??this.h}registerLogger(E){const C=this.b.get(E.resource);C?C.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const C=this.b.get(E);C&&(C.logger&&C.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Jj=r;class i{constructor(){this.onDidChangeLogLevel=new D.$5d().event}setLevel(E){}getLevel(){return p.Info}trace(E,...C){}debug(E,...C){}info(E,...C){}warn(E,...C){}error(E,...C){}critical(E,...C){}dispose(){}flush(){}}e.$Kj=i;class n extends i{}e.$Lj=n;function c(I){if(I.verbose)return p.Trace;if(typeof I.logLevel=="string"){const E=R(I.logLevel.toLowerCase());if(E!==void 0)return E}return e.$Bj}e.$Mj=c;function b(I){switch(I){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$Nj=b;function R(I){switch(I){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$Oj=R,e.$Pj=new v.$vj("logLevel",b(p.Info))});var se=this&&this.__param||function(Y,e){return function(S,D){e(S,D,Y)}};define(ae[220],ce([0,1,15,4,5]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=void 0;const M=S.safeStorage;let A=class{constructor(g){this.a=g,S.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(g){this.a.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(M.encryptString(g));return this.a.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.a.error(l),l}}async decrypt(g){let l;try{if(l=JSON.parse(g),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${g}`);const w=Buffer.from(l.data);this.a.trace("[EncryptionMainService] Decrypting value.");const v=M.decryptString(w);return this.a.trace("[EncryptionMainService] Decrypted value."),v}catch(w){throw this.a.error(w),w}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(D.$i)return Promise.resolve("dpapi");if(D.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const g=M.getSelectedStorageBackend();return Promise.resolve(g)}catch(g){this.a.error(g)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(D.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(D.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$5$b=A,e.$5$b=A=ve([se(0,s.$yj)],A)}),define(ae[221],ce([0,1,22,8,14,3,2,9,66,5]),function(Y,e,S,D,s,M,A,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=void 0;class w extends A.$Tc{constructor(y,h){super(),this.a=y,this.b=h,this.c=this.B(new M.$5d),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$5d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$ch(0)),this.w=[],this.y=this.B(new D.$ch(0))}watch(y,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n(y,h):this.z(y,h)}n(y,h){const m={path:this.H(y),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},p=(0,S.$Ub)(this.j,m);return this.r(),(0,A.$Rc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,s.$1)(y))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,g.$sq)(h)),h=>this.G(h),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const h of this.j)(0,g.$oq)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const h of this.j)(0,g.$oq)(h)&&y.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,h){const m={path:this.H(y),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},p=(0,S.$Ub)(this.w,m);return this.C(),(0,A.$Rc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,s.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,g.$sq)(y)),y=>this.G(y),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,P.$hc)(y.fsPath)}}e.$wq=w}),define(ae[222],ce([0,1,22,8,17,23,3,45,71,2,59,13,67,19,63,175,16,120,5,14]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;let a=class extends l.$Tc{static{$=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new A.$5d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$5d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$5d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$5d),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$5d),this.Y=this.B(new A.$5d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$5d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$nh)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${o}`);const i=new l.$Sc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(n=>{const c=new k.$Uk(n,!this.S(r));this.X.fire(c),c.hasCorrelation()||this.Y.fire(c)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,l.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,l.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await D.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return g.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,h.$Vg)(o))throw new k.$Wk((0,p.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new d.$bb;throw i.message=(0,p.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,k.$Hk)(r)||(0,k.$Ek)(r)||(0,k.$Ik)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,k.$Hk)(r)||(0,k.$Ek)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,k.$Rk)(i)===k.FileSystemProviderErrorCode.FileNotFound?new k.$Wk((0,p.localize)(2,null,this.sb(o)),1):(0,k.$Pk)(i)}}async s(o,r){const i=await this.j(o),n=this.S(i),c=r?.resolveTo,b=r?.resolveSingleChildDescendants,R=r?.resolveMetadata,I=await i.stat(o);let E;return this.t(i,o,I,void 0,!!R,(C,j)=>(E||(E=w.$ki.forUris(()=>!n),E.set(o,!0),c&&E.fill(!0,c)),E.get(C.resource)||E.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&b?j===1:!1))}async t(o,r,i,n,c,b){const{providerExtUri:R}=this.R(o),I={resource:r,name:R.basename(r),isFile:(i.type&k.FileType.File)!==0,isDirectory:(i.type&k.FileType.Directory)!==0,isSymbolicLink:(i.type&k.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&k.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&k.FilePermission.Locked),etag:(0,k.$8k)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&b(I,n)){try{const E=await o.readdir(r),C=await D.Promises.settled(E.map(async([j,U])=>{try{const F=R.joinPath(r,j),V=c?await o.stat(F):{type:U};return await this.t(o,F,V,E.length,c,b)}catch(F){return this.b.trace(F),null}}));I.children=(0,S.$Hb)(C)}catch(E){this.b.trace(E),I.children=[]}return I}return I}async resolveAll(o){return D.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new k.$Wk((0,p.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$se.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,r);return this.r.fire(new k.$Tk(o,0,n)),n}async writeFile(o,r,i){const n=this.qb(await this.n(o),o),{providerExtUri:c}=this.R(n);let b=i;if((0,k.$Kk)(n)&&!b?.atomic){const R=n.enforceAtomicWriteFile?.(o);R&&(b={...i,atomic:R})}try{await this.w(n,o,b)||await this.U(n,c.dirname(o));let I;if((0,k.$Ek)(n)&&!(r instanceof s.$se))if((0,m.$ee)(r)){const E=await(0,m.$le)(r,3);E.ended?I=s.$se.concat(E.buffer):I=E}else I=(0,m.$ie)(r,E=>s.$se.concat(E),3);else I=r;!(0,k.$Hk)(n)||(0,k.$Ek)(n)&&I instanceof s.$se||(0,k.$Ek)(n)&&(0,k.$Kk)(n)&&b?.atomic?await this.hb(n,o,b,I):await this.db(n,o,b,I instanceof s.$se?(0,s.$De)(I):I),this.r.fire(new k.$Tk(o,4))}catch(R){throw new k.$Wk((0,p.localize)(4,null,this.sb(o),(0,k.$Pk)(R).toString()),(0,k.$Sk)(R),b)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(r)));if(n)throw new Error((0,p.localize)(8,null,this.sb(r)))}let b;try{b=await o.stat(r)}catch{return}if(b.type&k.FileType.Directory)throw new k.$Wk((0,p.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,b),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==k.$7k&&typeof b.mtime=="number"&&typeof b.size=="number"&&i.mtime<b.mtime&&i.etag!==(0,k.$8k)({mtime:i.mtime,size:b.size}))throw new k.$Wk((0,p.localize)(10,null),3,i);return b}async readFile(o,r,i){const n=await this.m(o);return r?.atomic?this.z(n,o,r,i):this.C(n,o,r,i)}async z(o,r,i,n){return new Promise((c,b)=>{this.cb.queueFor(r,async()=>{try{const R=await this.C(o,r,i,n);c(R)}catch(R){b(R)}},this.R(o).providerExtUri)})}async C(o,r,i,n){const c=await this.D(o,r,{...i,preferUnbuffered:!0},n);return{...c,value:await(0,s.$Ee)(c.value)}}async readFileStream(o,r,i){const n=await this.m(o);return this.D(n,o,r,i)}async D(o,r,i,n){const c=new M.$ce(n);let b=i;(0,k.$Jk)(o)&&o.enforceAtomicReadFile?.(r)&&(b={...i,atomic:!0});const R=this.J(r,b).then(E=>E,E=>{throw c.dispose(!0),E});let I;try{return typeof b?.etag=="string"&&b.etag!==k.$7k&&await R,b?.atomic&&(0,k.$Jk)(o)||!((0,k.$Hk)(o)||(0,k.$Ik)(o))||(0,k.$Ek)(o)&&b?.preferUnbuffered?I=this.I(o,r,b):(0,k.$Ik)(o)?I=this.G(o,r,c.token,b):I=this.H(o,r,c.token,b),I.on("end",()=>c.dispose()),I.on("error",()=>c.dispose()),{...await R,value:I}}catch(E){throw I&&await(0,m.$je)(I),this.F(E,r,b)}}F(o,r,i){const n=(0,p.localize)(11,null,this.sb(r),(0,k.$Pk)(o).toString());return o instanceof k.$Yk?new k.$Yk(n,o.stat,i):o instanceof k.$Xk?new k.$Xk(n,o.fileOperationResult,o.size,o.options):new k.$Wk(n,(0,k.$Sk)(o),i)}G(o,r,i,n=Object.create(null)){const c=o.readFileStream(r,n,i);return(0,m.$pe)(c,{data:b=>b instanceof s.$se?b:s.$se.wrap(b),error:b=>this.F(b,r,n)},b=>s.$se.concat(b))}H(o,r,i,n=Object.create(null)){const c=(0,s.$Ie)();return(0,u.$mq)(o,r,c,b=>b,{...n,bufferSize:this.a,errorTransformer:b=>this.F(b,r,n)},i),c}I(o,r,i){const n=(0,m.$ge)(c=>s.$se.concat(c));return(async()=>{try{let c;i?.atomic&&(0,k.$Jk)(o)?c=await o.readFile(r,{atomic:!0}):c=await o.readFile(r),typeof i?.position=="number"&&(c=c.slice(i.position)),typeof i?.length=="number"&&(c=c.slice(0,i.length)),this.L(r,c.byteLength,i),n.end(s.$se.wrap(c))}catch(c){n.error(c),n.end()}})(),n}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new k.$Wk((0,p.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==k.$7k&&r.etag===i.etag)throw new k.$Yk((0,p.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new k.$Xk((0,p.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,n){if(o.toString()!==r.toString())try{const c=i==="move"?this.qb(await this.n(o),o):await this.m(o),b=this.qb(await this.n(r),r);await this.Q(c,o,b,r,i,n)}catch(c){return c}return!0}async move(o,r,i){const n=this.qb(await this.n(o),o),c=this.qb(await this.n(r),r),b=await this.N(n,o,c,r,"move",!!i),R=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new k.$Tk(o,b==="move"?2:3,R)),R}async copy(o,r,i){const n=await this.m(o),c=this.qb(await this.n(r),r),b=await this.N(n,o,c,r,"copy",!!i),R=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new k.$Tk(o,b==="copy"?3:2,R)),R}async N(o,r,i,n,c,b){if(r.toString()===n.toString())return c;const{exists:R,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,i,n,c,b);if(R&&!I&&b&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),c==="copy"){if(o===i&&(0,k.$Fk)(o))await o.copy(r,n,{overwrite:b});else{const E=await this.resolve(r);E.isDirectory?await this.P(o,E,i,n):await this.O(o,r,i,n)}return c}else return o===i?(await o.rename(r,n,{overwrite:b}),c):(await this.N(o,r,i,n,"copy",b),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,n){if((0,k.$Hk)(o)&&(0,k.$Hk)(i))return this.jb(o,r,i,n);if((0,k.$Hk)(o)&&(0,k.$Ek)(i))return this.pb(o,r,i,n);if((0,k.$Ek)(o)&&(0,k.$Hk)(i))return this.nb(o,r,i,n);if((0,k.$Ek)(o)&&(0,k.$Ek)(i))return this.lb(o,r,i,n)}async P(o,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await D.Promises.settled(r.children.map(async c=>{const b=this.R(i).providerExtUri.joinPath(n,c.name);return c.isDirectory?this.P(o,await this.resolve(c.resource),i,b):this.O(o,c.resource,i,b)}))}async Q(o,r,i,n,c,b){let R=!1;if(o===i){const{providerExtUri:E,isPathCaseSensitive:C}=this.R(o);if(C||(R=E.isEqual(r,n)),R&&c==="copy")throw new Error((0,p.localize)(15,null,this.sb(r),this.sb(n)));if(!R&&E.isEqualOrParent(n,r))throw new Error((0,p.localize)(16,null,this.sb(r),this.sb(n)))}const I=await this.exists(n);if(I&&!R){if(!b)throw new k.$Wk((0,p.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===i){const{providerExtUri:E}=this.R(o);if(E.isEqualOrParent(r,n))throw new Error((0,p.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:R}}R(o){const r=this.S(o);return{providerExtUri:r?h.$Hg:h.$Jg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new k.$Tk(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&k.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(r)));break}catch(c){if((0,k.$Rk)(c)!==k.FileSystemProviderErrorCode.FileNotFound)throw c;i.push(n.basename(r)),r=n.dirname(r)}for(let c=i.length-1;c>=0;c--){r=n.joinPath(r,i[c]);try{await o.mkdir(r)}catch(b){if((0,k.$Rk)(b)!==k.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(o)));const c=r?.atomic;if(c&&!(i.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(o)));if(n&&c)throw new Error((0,p.localize)(22,null,this.sb(o)));let b;try{b=await i.stat(o)}catch{}if(b)this.rb(o,b);else throw new k.$Wk((0,p.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let n=r;if((0,k.$Lk)(i)&&!n?.atomic){const I=i.enforceAtomicDelete?.(o);I&&(n={...r,atomic:I})}const c=!!n?.useTrash,b=!!n?.recursive,R=n?.atomic??!1;await i.delete(o,{recursive:b,useTrash:c,atomic:R}),this.r.fire(new k.$Tk(o,1))}async cloneFile(o,r){const i=await this.j(o),n=this.qb(await this.n(r),r);if(!(i===n&&this.R(i).providerExtUri.isEqual(o,r)))return i===n&&(0,k.$Gk)(i)?i.cloneFile(o,r):(await this.U(n,this.R(n).providerExtUri.dirname(r)),i===n&&(0,k.$Fk)(i)?this.cb.queueFor(o,()=>i.copy(o,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,n,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:$.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new l.$Sc;let n=!1,c=()=>{n=!0};i.add((0,l.$Rc)(()=>c())),(async()=>{try{const R=await this.bb(o,r);n?(0,l.$Oc)(R):c=()=>(0,l.$Oc)(R)}catch(R){this.b.error(R)}})();const b=r.correlationId;if(typeof b=="number"){const R=i.add(new A.$5d);return i.add(this.X.event(E=>{E.correlates(b)&&R.fire(E)})),{onDidChange:R.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),n=(0,P.$5i)([this.R(i).providerExtUri.getComparisonKey(o),r]);let c=this.$.get(n);return c||(c={count:0,disposable:i.watch(o,r)},this.$.set(n,c)),c.count+=1,(0,l.$Rc)(()=>{c&&(c.count--,c.count===0&&((0,l.$Oc)(c.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,l.$Oc)(o.disposable);this.$.clear()}async db(o,r,i,n){return this.cb.queueFor(r,async()=>{const c=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,m.$ee)(n)||(0,m.$fe)(n)?await this.eb(o,c,n):await this.fb(o,c,n)}catch(b){throw(0,k.$Pk)(b)}finally{await o.close(c)}},this.R(o).providerExtUri)}async eb(o,r,i){let n=0,c;if((0,m.$fe)(i)){if(i.buffer.length>0){const b=s.$se.concat(i.buffer);await this.gb(o,r,b,b.byteLength,n,0),n+=b.byteLength}if(i.ended)return;c=i.stream}else c=i;return new Promise((b,R)=>{(0,m.$ke)(c,{onData:async I=>{c.pause();try{await this.gb(o,r,I,I.byteLength,n,0)}catch(E){return R(E)}n+=I.byteLength,setTimeout(()=>c.resume())},onError:I=>R(I),onEnd:()=>b()})})}async fb(o,r,i){let n=0,c;for(;(c=i.read())!==null;)await this.gb(o,r,c,c.byteLength,n,0),n+=c.byteLength}async gb(o,r,i,n,c,b){let R=0;for(;R<n;){const I=await o.write(r,c+R,i.buffer,b+R,n-R);R+=I}}async hb(o,r,i,n){return this.cb.queueFor(r,()=>this.ib(o,r,i,n),this.R(o).providerExtUri)}async ib(o,r,i,n){let c;n instanceof s.$se?c=n:(0,m.$ee)(n)?c=await(0,s.$Ee)(n):(0,m.$fe)(n)?c=await(0,s.$Fe)(n):c=(0,s.$Ce)(n),await o.writeFile(r,c.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,n){return this.cb.queueFor(n,()=>this.kb(o,r,i,n),this.R(i).providerExtUri)}async kb(o,r,i,n){let c,b;try{c=await o.open(r,{create:!1}),b=await i.open(n,{create:!0,unlock:!1});const R=s.$se.alloc(this.a);let I=0,E=0,C=0;do C=await o.read(c,I,R.buffer,E,R.byteLength-E),await this.gb(i,b,R,C,I,E),I+=C,E+=C,E===R.byteLength&&(E=0);while(C>0)}catch(R){throw(0,k.$Pk)(R)}finally{await D.Promises.settled([typeof c=="number"?o.close(c):Promise.resolve(),typeof b=="number"?i.close(b):Promise.resolve()])}}async lb(o,r,i,n){return this.cb.queueFor(n,()=>this.mb(o,r,i,n),this.R(i).providerExtUri)}async mb(o,r,i,n){return i.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,n){return this.cb.queueFor(n,()=>this.ob(o,r,i,n),this.R(i).providerExtUri)}async ob(o,r,i,n){const c=await i.open(n,{create:!0,unlock:!1});try{const b=await o.readFile(r);await this.gb(i,c,s.$se.wrap(b),b.byteLength,0,0)}catch(b){throw(0,k.$Pk)(b)}finally{await i.close(c)}}async pb(o,r,i,n){const c=await(0,s.$Ee)(this.H(o,r,M.CancellationToken.None));await this.hb(i,n,void 0,c)}qb(o,r){if(o.capabilities&2048)throw new k.$Wk((0,p.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&k.FilePermission.Readonly)throw new k.$Wk((0,p.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};e.$nq=a,e.$nq=a=$=ve([se(0,f.$yj)],a)}),define(ae[93],ce([0,1,46,311,8,31,17,3,33,2,9,4,19,63,21,179,16,120,221,51,217,216]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0,(()=>{try{(0,D.gracefulify)(S)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.$2i)(o)}`)}})();class t extends f.$wq{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=P.Event.None,this.N=new M.$Ac(n=>y.$Ig.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await m.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:k.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await m.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async c=>{try{let b;c.isSymbolicLink()?b=(await this.stat((0,y.$Rg)(r,c.name))).type:b=this.M(c),n.push([c.name,b])}catch(b){this.a.trace(b)}})),n}catch(i){throw this.fb(i)}}M(r,i){let n;return i?.dangling?n=k.FileType.Unknown:r.isFile()?n=k.FileType.File:r.isDirectory()?n=k.FileType.Directory:n=k.FileType.Unknown,i&&(n|=k.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const c=new s.$dh;return this.N.set(r,c),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===c&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),c.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const c=this.H(r);return await m.Promises.readFile(c)}catch(c){throw this.fb(c)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const c=(0,h.$ge)(b=>A.$se.concat(b.map(R=>A.$se.wrap(R))).buffer);return(0,u.$mq)(this,r,c,b=>b.buffer,{...i,bufferSize:256*1024},n),c}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,y.$Rg)((0,y.$Qg)(r),`${(0,y.$Og)(r)}${n.atomic.postfix}`),i,n):this.S(r,i,n)}async Q(r){try{const i=this.H(r),{symbolicLink:n}=await m.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(r,i,n,c){const b=new l.$Sc;try{b.add(await this.O(r)),b.add(await this.O(i)),await this.S(i,n,c,!0);try{await this.rename(i,r,{overwrite:!0})}catch(R){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw R}}finally{b.dispose()}}async S(r,i,n,c){let b;try{const R=this.H(r);if(!n.create||!n.overwrite){if(await m.Promises.exists(R)){if(!n.overwrite)throw(0,k.$Ok)((0,p.localize)(0,null),k.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,k.$Ok)((0,p.localize)(1,null),k.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(r,{create:!0,unlock:n.unlock},c),await this.write(b,0,i,0,i.byteLength)}catch(R){throw await this.gb(r,R)}finally{typeof b=="number"&&await this.close(b)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,n){const c=this.H(r);let b;(0,k.$Ck)(i)&&!n&&(b=await this.O(r));let R;try{if((0,k.$Ck)(i)&&i.unlock)try{const{stat:E}=await m.SymlinkSupport.stat(c);E.mode&128||await m.Promises.chmod(c,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let I;if((0,k.$Ck)(i)){if(v.$i)try{await m.Promises.truncate(c,0),I="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}I||(I="w")}else I="r";R=await m.Promises.open(c,I)}catch(I){throw b?.dispose(),(0,k.$Ck)(i)?await this.gb(r,I):this.fb(I)}if(this.U.set(R,0),(0,k.$Ck)(i)&&this.X.set(R,r),b){const I=this.W.get(R);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${R} (${c})`),this.W.set(R,b),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${R} (${c})`),I.dispose())}return R}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await m.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await m.Promises.close(r)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,c,b){const R=this.Z(r,i);let I=null;try{I=(await m.Promises.read(r,n,c,b,R)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(r,R,I)}return I}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,n){const c=this.U.get(r);typeof c=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(r,c+n):this.U.delete(r)))}async write(r,i,n,c,b){return(0,s.$yh)(()=>this.ab(r,i,n,c,b),100,3)}async ab(r,i,n,c,b){const R=this.Z(r,i);let I=null;try{I=(await m.Promises.write(r,n,c,b,R)).bytesWritten}catch(E){throw await this.gb(this.X.get(r),E)}finally{this.$(r,R,I)}return I}async mkdir(r){try{await m.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let c;i?.atomic!==!1&&i.atomic.postfix&&(c=(0,w.$jc)((0,w.$mc)(n),`${(0,w.$nc)(n)}${i.atomic.postfix}`)),await m.Promises.rm(n,m.RimRafMode.MOVE,c)}else try{await m.Promises.unlink(n)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let b=!1;try{const{stat:R,symbolicLink:I}=await m.SymlinkSupport.stat(n);b=R.isDirectory()&&!I}catch{}if(b)await m.Promises.rmdir(n);else throw c}else throw c}}catch(n){throw this.fb(n)}}async rename(r,i,n){const c=this.H(r),b=this.H(i);if(c!==b)try{await this.bb(r,i,"move",n.overwrite),await m.Promises.rename(c,b)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,p.localize)(2,null,(0,w.$nc)(c),(0,w.$nc)((0,w.$mc)(b)),R.toString()))),this.fb(R)}}async copy(r,i,n){const c=this.H(r),b=this.H(i);if(c!==b)try{await this.bb(r,i,"copy",n.overwrite),await m.Promises.copy(c,b,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,p.localize)(3,null,(0,w.$nc)(c),(0,w.$nc)((0,w.$mc)(b)),R.toString()))),this.fb(R)}}async bb(r,i,n,c){const b=this.H(r),R=this.H(i);let I=!1;if(!!(this.capabilities&1024)||(I=(0,g.$eg)(b,R,!0)),I){if(n==="copy")throw(0,k.$Ok)((0,p.localize)(4,null),k.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const C=await this.L(r);if(!C)throw(0,k.$Ok)((0,p.localize)(5,null),k.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(i);if(j){if(!c)throw(0,k.$Ok)((0,p.localize)(6,null),k.FileSystemProviderErrorCode.FileExists);C.type&k.FileType.File&&j.type&k.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,n){const c=this.H(r),b=this.H(i),R=!!(this.capabilities&1024);if((0,g.$eg)(c,b,!R))return;const I=new l.$Sc;try{I.add(await this.O(r)),I.add(await this.O(i)),n&&await m.Promises.mkdir((0,w.$mc)(b),{recursive:!0}),await m.Promises.copyFile(c,b)}catch(E){if(E.code==="ENOENT"&&!n)return this.cb(r,i,!0);throw this.fb(E)}finally{I.dispose()}}t(r,i,n){return new $.$Dq(c=>r(c),c=>i(c),n)}F(r,i,n){return new a.$Lq(c=>r(c),c=>i(c),n)}fb(r){if(r instanceof k.$Nk)return r;let i=r,n;switch(r.code){case"ENOENT":n=k.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=k.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=k.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=k.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=k.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=k.FileSystemProviderErrorCode.Unknown;break;default:n=k.FileSystemProviderErrorCode.Unknown}return(0,k.$Ok)(i,n)}async gb(r,i){let n=this.fb(i);if(r&&n.code===k.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await m.SymlinkSupport.stat(this.H(r));c.mode&128||(n=(0,k.$Ok)(i,k.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return n}}e.$Mq=t}),define(ae[223],ce([0,1,3,93,2,17,63,23]),function(Y,e,S,D,s,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=e.$js=void 0;class g extends s.$Tc{constructor(v,y){super(),this.a=v,this.b=y,this.F=new Map,this.G=new Map}call(v,y,h){const m=this.c(v);switch(y){case"stat":return this.g(m,h[0]);case"readdir":return this.h(m,h[0]);case"open":return this.r(m,h[0],h[1]);case"close":return this.s(h[0]);case"read":return this.t(h[0],h[1],h[2]);case"readFile":return this.j(m,h[0],h[1]);case"write":return this.u(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.n(m,h[0],h[1],h[2]);case"rename":return this.z(m,h[0],h[1],h[2]);case"copy":return this.C(m,h[0],h[1],h[2]);case"cloneFile":return this.D(m,h[0],h[1]);case"mkdir":return this.w(m,h[0]);case"delete":return this.y(m,h[0],h[1]);case"watch":return this.I(m,h[0],h[1],h[2],h[3]);case"unwatch":return this.J(h[0],h[1])}throw new Error(`IPC Command ${y} not found`)}listen(v,y,h){const m=this.c(v);switch(y){case"fileChange":return this.H(m,h[0]);case"readFileStream":return this.m(m,h[0],h[1])}throw new Error(`Unknown event ${y}`)}g(v,y){const h=this.f(v,y,!0);return this.a.stat(h)}h(v,y){const h=this.f(v,y);return this.a.readdir(h)}async j(v,y,h){const m=this.f(v,y,!0),p=await this.a.readFile(m,h);return M.$se.wrap(p)}m(v,y,h){const m=this.f(v,y,!0),p=new P.$ce,k=new S.$5d({onDidRemoveLastListener:()=>{p.cancel()}}),u=this.a.readFileStream(m,h,p.token);return(0,A.$ke)(u,{onData:f=>k.fire(M.$se.wrap(f)),onError:f=>k.fire(f),onEnd:()=>{k.fire("end"),k.dispose(),p.dispose()}}),k.event}n(v,y,h,m){const p=this.f(v,y);return this.a.writeFile(p,h.buffer,m)}r(v,y,h){const m=this.f(v,y,!0);return this.a.open(m,h)}s(v){return this.a.close(v)}async t(v,y,h){const m=M.$se.alloc(h),k=await this.a.read(v,y,m.buffer,0,h);return[m,k]}u(v,y,h,m,p){return this.a.write(v,y,h.buffer,m,p)}w(v,y){const h=this.f(v,y);return this.a.mkdir(h)}y(v,y,h){const m=this.f(v,y);return this.a.delete(m,h)}z(v,y,h,m){const p=this.f(v,y),k=this.f(v,h);return this.a.rename(p,k,m)}C(v,y,h,m){const p=this.f(v,y),k=this.f(v,h);return this.a.copy(p,k,m)}D(v,y,h){const m=this.f(v,y),p=this.f(v,h);return this.a.cloneFile(m,p)}H(v,y){const h=new S.$5d({onWillAddFirstListener:()=>{this.F.set(y,this.L(v,h))},onDidRemoveLastListener:()=>{(0,s.$Oc)(this.F.get(y)),this.F.delete(y)}});return h.event}async I(v,y,h,m,p){const k=this.F.get(y);if(k){const u=this.f(v,m),f=k.watch(h,u,p);this.G.set(y+h,f)}}async J(v,y){const h=v+y,m=this.G.get(h);m&&((0,s.$Oc)(m),this.G.delete(h))}dispose(){super.dispose();for(const[,v]of this.G)v.dispose();this.G.clear();for(const[,v]of this.F)v.dispose();this.F.clear()}}e.$js=g;class l extends s.$Tc{constructor(v,y,h,m){super(),this.c=v,this.f=h,this.g=m,this.a=new Map,this.b=this.B(new D.$Mq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(v){const y=this.B(new S.$5d);this.B(y.event(h=>{v.fire(h.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type,cId:m.cId})))})),this.B(this.b.onDidChangeFile(h=>y.fire(h))),this.B(this.b.onDidWatchError(h=>v.fire(h)))}j(v){}m(v){}watch(v,y,h){const m=this.m(this.g);return Array.isArray(m)&&(h.excludes=[...h.excludes,...m]),this.a.set(v,this.b.watch(y,h)),(0,s.$Rc)(()=>{(0,s.$Oc)(this.a.get(v)),this.a.delete(v)})}dispose(){for(const[,v]of this.a)v.dispose();this.a.clear(),super.dispose()}}e.$ks=l}),define(ae[224],ce([0,1,15,178,4,7,16,9,223,155]),function(Y,e,S,D,s,M,A,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a_b=void 0;class w extends g.$js{constructor(h,m,p){super(h,m),this.M=p}c(h){return l.$en}f(h,m){return M.URI.revive(m)}async y(h,m,p){if(!p.useTrash)return super.y(h,m,p);const k=this.f(h,m),u=(0,P.$hc)(k.fsPath);try{await S.shell.trashItem(u)}catch{throw(0,A.$Ok)(s.$i?(0,D.localize)(0,null,(0,P.$nc)(u)):(0,D.localize)(1,null,(0,P.$nc)(u)),A.FileSystemProviderErrorCode.Unknown)}}L(h,m){return new v(h,m,this.b,this.M)}}e.$a_b=w;class v extends g.$ks{watch(h,m,p){if(p.recursive)throw(0,A.$Ok)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(h,m,p)}}}),define(ae[225],ce([0,1,5]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$48b=void 0;class D extends S.$Ej{constructor(M=S.$Bj){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(A=>{this.n?.setLevel(A)}))}set logger(M){this.n=M;for(const{level:A,message:P}of this.m)(0,S.log)(M,A,P);this.m=[]}g(M,A){this.n?(0,S.log)(this.n,M,A):this.getLevel()<=M&&this.m.push({level:M,message:A})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$48b=D}),define(ae[226],ce([0,1,7,3,5,2]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=e.$Lr=void 0;class A extends s.$Jj{constructor(v,y,h,m,p){super(y,h,m),this.r=v,this.t=p,this.B(p.listen("onDidChangeLogLevel",v)(k=>{(0,s.$Aj)(k)?super.setLogLevel(k):super.setLogLevel(S.URI.revive(k[0]),k[1])})),this.B(p.listen("onDidChangeVisibility",v)(([k,u])=>super.setVisibility(S.URI.revive(k),u))),this.B(p.listen("onDidChangeLoggers",v)(({added:k,removed:u})=>{for(const f of k)super.registerLogger({...f,resource:S.URI.revive(f.resource)});for(const f of u)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new s.$Hj({log:(v,y)=>{this.t.call("consoleLog",[v,y])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,y){super.setLogLevel(v,y),this.t.call("setLogLevel",[v,y])}setVisibility(v,y){super.setVisibility(v,y),this.t.call("setVisibility",[this.n(v),y])}s(v,y,h){return new P(this.t,v,y,h,this.r)}static setLogLevel(v,y,h){return v.call("setLogLevel",[y,h])}}e.$Lr=A;class P extends s.$Ej{constructor(v,y,h,m,p){super(m?.logLevel==="always"),this.r=v,this.s=y,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[y,m,p]).then(()=>{this.u(this.n),this.m=!0})}g(v,y){const h=[[v,y]];this.m?this.u(h):this.n.push(...h)}u(v){this.r.call("log",[this.s,v])}}class g{constructor(v,y){this.a=v,this.b=y}listen(v,y){const h=this.b(v);switch(y){case"onDidChangeLoggers":return D.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(p=>this.c(p,h)),removed:[...m.removed].map(p=>this.c(p,h))}));case"onDidChangeVisibility":return D.Event.map(this.a.onDidChangeVisibility,m=>[h.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return D.Event.map(this.a.onDidChangeLogLevel,m=>(0,s.$Aj)(m)?m:[h.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${y}`)}async call(v,y,h){const m=this.b(v);switch(y){case"setLogLevel":return(0,s.$Aj)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(S.URI.revive(m.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,m)))}throw new Error(`Call not found: ${y}`)}c(v,y){return{...v,resource:y.transformOutgoingURI(v.resource)}}}e.$Mr=g;class l extends M.$Tc{constructor(v,y){super(),y.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(h=>y.call("setLogLevel",[h]))),y.call("getRegisteredLoggers").then(h=>{for(const m of h)v.registerLogger({...m,resource:S.URI.revive(m.resource)})}),this.B(y.listen("onDidChangeVisibility")(([h,m])=>v.setVisibility(S.URI.revive(h),m))),this.B(y.listen("onDidChangeLoggers")(({added:h,removed:m})=>{for(const p of h)v.registerLogger({...p,resource:S.URI.revive(p.resource)});for(const p of m)v.deregisterLogger(p.resource)}))}}e.$Nr=l}),define(ae[227],ce([0,1,2,5]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=void 0;class s extends S.$Tc{constructor(A,P=[]){super(),this.a=new D.$Ij([A,...P]),this.B(A.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...P){this.a.trace(A,...P)}debug(A,...P){this.a.debug(A,...P)}info(A,...P){this.a.info(A,...P)}warn(A,...P){this.a.warn(A,...P)}error(A,...P){this.a.error(A,...P)}flush(){this.a.flush()}}e.$AP=s}),define(ae[228],ce([0,1,31,7,5]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8_b=void 0;class M{constructor(P){this.b=P,this.a=new S.$Ac}listen(P,g,l){switch(g){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${g}`)}async call(P,g,l){switch(g){case"createLogger":this.c(D.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(D.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,s.$Aj)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(D.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(D.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:D.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(D.URI.revive(l[0]))}throw new Error(`Call not found: ${g}`)}c(P,g,l){this.a.set(P,this.b.createLogger(P,g,l))}d(P,g){let l=console.log;switch(P){case s.LogLevel.Error:l=console.error;break;case s.LogLevel.Warning:l=console.warn;break;case s.LogLevel.Info:l=console.info;break}l.call(console,...g)}e(P,g){const l=this.a.get(P);if(!l)throw new Error("Create the logger before logging");for(const[w,v]of g)(0,s.log)(l,w,v)}}e.$8_b=M}),define(ae[229],ce([0,1,16,5]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=void 0;var s;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(s||(s={}));async function M(l,w,v,y,h){try{const m=await new Promise((k,u)=>{Y(["@vscode/spdlog"],k,u)});m.setFlushOn(s.Trace);const p=await m.createAsyncRotatingLogger(l,w,v,y);return h?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(m){console.error(m)}return null}function A(l,w,v){switch(w){case D.LogLevel.Trace:l.trace(v);break;case D.LogLevel.Debug:l.debug(v);break;case D.LogLevel.Info:l.info(v);break;case D.LogLevel.Warning:l.warn(v);break;case D.LogLevel.Error:l.error(v);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function P(l,w){switch(w){case D.LogLevel.Trace:l.setLevel(s.Trace);break;case D.LogLevel.Debug:l.setLevel(s.Debug);break;case D.LogLevel.Info:l.setLevel(s.Info);break;case D.LogLevel.Warning:l.setLevel(s.Warning);break;case D.LogLevel.Error:l.setLevel(s.Error);break;case D.LogLevel.Off:l.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class g extends D.$Ej{constructor(w,v,y,h,m){super(),this.m=[],this.setLevel(m),this.n=this.s(w,v,y,h),this.B(this.onDidChangeLogLevel(p=>{this.r&&P(this.r,p)}))}async s(w,v,y,h){const m=y?6:1,p=30/m*S.$0k.MB,k=await M(w,v,p,m,h);if(k){this.r=k,P(this.r,this.getLevel());for(const{level:u,message:f}of this.m)A(this.r,u,f);this.m=[]}}g(w,v){this.r?A(this.r,w,v):this.getLevel()<=w&&this.m.push({level:w,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$pP=g}),define(ae[230],ce([0,1,32,5,229]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=void 0;class M extends D.$Jj{s(P,g,l){return new s.$pP((0,S.$Ag)(),P.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,g)}}e.$qP=M}),define(ae[68],ce([0,1,31,3,6,5,230]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=e.$H$b=void 0,e.$H$b=(0,s.$fi)(M.$zj);class P extends A.$qP{constructor(){super(...arguments),this.u=new S.$Ac}createLogger(l,w,v){v!==void 0&&this.u.set(this.n(l),v);try{return super.createLogger(l,w)}catch(y){throw this.u.delete(this.n(l)),y}}registerLogger(l,w){w!==void 0&&this.u.set(l.resource,w),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const w=[];for(const v of super.getRegisteredLoggers())l===this.u.get(v.resource)&&w.push(v);return w}getOnDidChangeLogLevelEvent(l){return D.Event.filter(this.onDidChangeLogLevel,w=>(0,M.$Aj)(w)||this.w(w[0],l))}getOnDidChangeVisibilityEvent(l){return D.Event.filter(this.onDidChangeVisibility,([w])=>this.w(w,l))}getOnDidChangeLoggersEvent(l){return D.Event.filter(D.Event.map(this.onDidChangeLoggers,w=>({added:[...w.added].filter(y=>this.w(y.resource,l)),removed:[...w.removed].filter(y=>this.w(y.resource,l))})),w=>w.added.length>0||w.removed.length>0)}deregisterLoggers(l){for(const[w,v]of this.u)v===l&&this.deregisterLogger(w)}w(l,w){const v=this.u.get(l);return v===void 0||v===w}dispose(){super.dispose(),this.u.clear()}}e.$I$b=P}),define(ae[231],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q_b=e.$p_b=e.$o_b=e.$n_b=void 0;function S(A){return A.submenu!==void 0}e.$n_b=S;function D(A){return A.id==="vscode.menubar.separator"}e.$o_b=D;function s(A){return A.uri!==void 0}e.$p_b=s;function M(A){return!S(A)&&!D(A)&&!s(A)}e.$q_b=M}),define(ae[39],ce([0,1,3,71,2,6]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=e.$Wn=e.$Vn=void 0,e.$Vn=(0,M.$ei)("policy");class A extends s.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$5d),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const w=Object.keys(this.f).length;return this.f={...l,...this.f},w!==Object.keys(this.f).length&&await this.j(l),D.Iterable.reduce(this.g.entries(),(v,[y,h])=>({...v,[y]:h}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(l,[w,v])=>({...l,[w]:{definition:v,value:this.g.get(w)}}),{})}}e.$Wn=A;class P{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Xn=P}),define(ae[232],ce([0,1,8,3,71,12,16,5,39]),function(Y,e,S,D,s,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;function l(v,y){const h=[];for(const m of new Set(s.Iterable.concat(v.keys(),y.keys())))v.get(m)!==y.get(m)&&h.push(m);return h}let w=class extends g.$Wn{constructor(y,h,m){super(),this.m=y,this.n=h,this.s=m,this.c=this.B(new S.$ch(500));const p=D.Event.filter(h.onDidFilesChange,k=>k.affects(y));this.B(h.watch(y)),this.B(p(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const h=await this.n.readFile(this.m),m=JSON.parse(h.value.toString());if(!(0,M.$Uf)(m))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(m))this.f[p]&&y.set(p,m[p])}catch(h){h.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",h)}return y}async w(){const y=await this.u(),h=l(this.g,y);this.g=y,h.length>0&&this.h.fire(h)}};e.$oac=w,e.$oac=w=ve([se(1,A.$Bk),se(2,P.$yj)],w)}),define(ae[233],ce([0,1,3,2,39]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=e.$Y_b=void 0;class M{constructor(g){this.b=g,this.a=new D.$Sc}listen(g,l){switch(l){case"onDidChange":return S.Event.map(this.b.onDidChange,w=>w.reduce((v,y)=>({...v,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(g,l,w){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(w)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$Y_b=M;class A extends s.$Wn{constructor(g,l){super(),this.a=l;for(const w in g){const{definition:v,value:y}=g[w];this.f[w]=v,y!==void 0&&this.g.set(w,y)}this.a.listen("onDidChange")(w=>{for(const v in w){const y=w[v];y===null?this.g.delete(v):this.g.set(v,y)}this.h.fire(Object.keys(w))})}async j(g){const l=await this.a.call("updatePolicyDefinitions",g);for(const w in l)this.g.set(w,l[w])}}e.$Z_b=A}),define(ae[234],ce([0,1,39,8,2,5]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=void 0;let A=class extends S.$Wn{constructor(g,l){super(),this.m=g,this.n=l,this.a=new D.$$g,this.b=this.B(new s.$Uc)}async j(g){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`);const{createWatcher:l}=await new Promise((w,v)=>{Y(["@vscode/policy-watcher"],w,v)});await this.a.queue(()=>new Promise((w,v)=>{try{this.b.value=l(this.n,g,y=>{this.t(y),w()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),v(y)}}))}t(g){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const l in g){const w=g[l];w===void 0?this.g.delete(l):this.g.set(l,w)}this.h.fire(Object.keys(g))}};e.$nac=A,e.$nac=A=ve([se(0,M.$yj)],A)}),define(ae[79],ce([0,1,36]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const M=s.context.configuration();if(M)D=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,S.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:M.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(ae[27],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=void 0,e.$Qj=(0,S.$ei)("productService"),e.$Rj="vscode://schemas/vscode-product"}),define(ae[235],ce([0,1,8,5]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d_b=void 0;let s=class{constructor(A,P,g){this.a=A,this.b=P,this.c=g}async inspect(A){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$fh)(A);const g=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),g.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};e.$d_b=s,e.$d_b=s=ve([se(2,D.$yj)],s)}),define(ae[80],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q$b=void 0,e.$q$b=(0,S.$ei)("protocolMainService")}),define(ae[44],ce([0,1,138,12]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=void 0;class s{constructor(){this.a=new Map}add(A,P){S.ok(D.$Sf(A)),S.ok(D.$Uf(P)),S.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,P)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Tn=new s}),define(ae[236],ce([0,1,3,44]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=void 0,e.$Un={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this.b=new S.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,l){this.a[s(g)]=l,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;D.$Tn.add(e.$Un.JSONContribution,A)}),define(ae[52],ce([0,1,22,3,12,163,18,236,44]),function(Y,e,S,D,s,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ConfigurationScope=e.$Yn=e.EditPresentationTypes=void 0;var l;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$Yn={Configuration:"base.contributions.configuration"};var w;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w||(e.ConfigurationScope=w={})),e.$Zn={properties:{},patternProperties:{}},e.$1n={properties:{},patternProperties:{}},e.$2n={properties:{},patternProperties:{}},e.$3n={properties:{},patternProperties:{}},e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n="vscode://schemas/settings/resourceLanguage",e.$7n="vscode://schemas/settings/configurationDefaults";const v=g.$Tn.as(P.$Un.JSONContribution);class y{constructor(){this.h=new Set,this.i=new D.$5d,this.onDidSchemaChange=this.i.event,this.j=new D.$5d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$6n,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),v.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),v.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),v.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:n}of t)for(const c in i)if(o.add(c),e.$9n.test(c)){const b=this.a.get(c),R=b?.valuesSources??new Map;if(n)for(const j of Object.keys(i[c]))R.set(j,n);const I={...b?.value||{},...i[c]};this.a.set(c,{source:n,value:I,valuesSources:R});const E=(0,A.$Ui)(c),C={type:"object",default:I,description:M.localize(1,null,E),$ref:e.$6n,defaultDefaultValue:I,source:s.$Sf(n)?void 0:n,defaultValueSource:n};r.push(...p(c)),this.d[c]=C,this.b.properties[c]=C}else{this.a.set(c,{value:i[c],source:n});const b=this.d[c];b&&(this.w(c,b),this.r(c,b))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const n in r){const c=this.a.get(n),b=s.$Sf(i)?i:i?.id,R=s.$Sf(c?.source)?c?.source:c?.source?.id;if(b===R)if(o.add(n),this.a.delete(n),e.$9n.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const n in i.properties){o.add(n);const c=this.d[n];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,o=!0,r,i,n=3,c){n=s.$2f(t.scope)?n:t.scope;const b=t.properties;if(b)for(const I in b){const E=b[I];if(o&&d(I,E)){delete b[I];continue}if(E.source=r,E.defaultDefaultValue=b[I].default,this.w(I,E),e.$9n.test(I)?E.scope=void 0:(E.scope=s.$2f(E.scope)?n:E.scope,E.restricted=s.$2f(E.restricted)?!!i?.includes(I):E.restricted),b[I].hasOwnProperty("included")&&!b[I].included){this.f[I]=b[I],delete b[I];continue}else this.d[I]=b[I],b[I].policy?.name&&this.e.set(b[I].policy.name,I);!b[I].deprecationMessage&&b[I].markdownDeprecationMessage&&(b[I].deprecationMessage=b[I].markdownDeprecationMessage),c.add(I)}const R=t.allOf;if(R)for(const I of R)this.p(I,o,r,i,n,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const c in i)this.r(c,i[c]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$Zn.properties[t]=o,o.scope){case 1:e.$1n.properties[t]=o;break;case 2:e.$2n.properties[t]=o;break;case 6:e.$3n.properties[t]=o;break;case 3:e.$4n.properties[t]=o;break;case 4:e.$5n.properties[t]=o;break;case 5:e.$5n.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$Zn.properties[t],o.scope){case 1:delete e.$1n.properties[t];break;case 2:delete e.$2n.properties[t];break;case 6:delete e.$3n.properties[t];break;case 3:delete e.$4n.properties[t];break;case 4:case 5:delete e.$5n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$6n};this.w(o,r),e.$Zn.properties[o]=r,e.$1n.properties[o]=r,e.$2n.properties[o]=r,e.$3n.properties[o]=r,e.$4n.properties[o]=r,e.$5n.properties[o]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$6n};e.$Zn.patternProperties[e.$8n]=t,e.$1n.patternProperties[e.$8n]=t,e.$2n.patternProperties[e.$8n]=t,e.$3n.patternProperties[e.$8n]=t,e.$4n.patternProperties[e.$8n]=t,e.$5n.patternProperties[e.$8n]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$Zf(i)&&(i=o.defaultDefaultValue,n=void 0),s.$Zf(i)&&(i=u(o.type)),o.default=i,o.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",m=new RegExp(h,"g");e.$8n=`^(${h})+$`,e.$9n=new RegExp(e.$8n);function p(a){const t=[];if(e.$9n.test(a)){let o=m.exec(a);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=m.exec(a)}}return(0,S.$Mb)(t)}e.$0n=p;function k(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}e.$$n=k;function u(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$_n=u;const f=new y;g.$Tn.add(e.$Yn.Configuration,f);function d(a,t){return a.trim()?e.$9n.test(a)?M.localize(7,null,a):f.getConfigurationProperties()[a]!==void 0?M.localize(8,null,a):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,a,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$ao=d;function $(){const a=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$bo=$}),define(ae[121],ce([0,1,22,3,42,2,31,35,12,7,18,52,44]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=void 0;function h(o){return Object.isFrozen(o)?o:P.$In(o)}class m{constructor(r={},i=[],n=[],c){this.b=r,this.c=i,this.d=n,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof m)return i;const n=new p("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,w.$Si)(this.contents,r):this.contents}inspect(r,i){const n=this;return{get value(){return h(n.rawConfiguration.getValue(r))},get override(){return i?h(n.rawConfiguration.getOverrideValue(r,i)):void 0},get merged(){return h(i?n.rawConfiguration.override(i).getValue(r):n.rawConfiguration.getValue(r))},get overrides(){const c=[];for(const{contents:b,identifiers:R,keys:I}of n.rawConfiguration.overrides){const E=new m(b,I).getValue(r);E!==void 0&&c.push({identifiers:R,value:E})}return c.length?h(c):void 0}}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,w.$Si)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return S.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return S.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=P.$Hn(this.contents),n=P.$Hn(this.overrides),c=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const R of r)if(b.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.h(i,R.contents);for(const I of R.overrides){const[E]=n.filter(C=>S.$ub(C.identifiers,I.identifiers));E?(this.h(E.contents,I.contents),E.keys.push(...I.keys),E.keys=S.$Mb(E.keys)):n.push(P.$Hn(I))}for(const I of R.keys)c.indexOf(I)===-1&&c.push(I)}return new m(i,c,n,b.every(R=>R instanceof m)?void 0:b)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const c of S.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let b=this.contents[c];const R=i[c];R&&(typeof b=="object"&&typeof R=="object"?(b=P.$Hn(b),this.h(b,R)):b=R),n[c]=b}return new m(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&g.$Uf(r[n])&&g.$Uf(i[n])){this.h(r[n],i[n]);continue}r[n]=P.$Hn(i[n])}}i(r){let i=null,n=null;const c=b=>{b&&(n?this.h(n,b):n=P.$Hn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===r?i=b.contents:b.identifiers.includes(r)&&c(b.contents);return c(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,w.$Ri)(this.contents,r),v.$9n.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>S.$ub(n.identifiers,(0,v.$0n)(r))),1))}j(r,i,n){(0,w.$Qi)(this.contents,r,i,c=>console.error(c)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),v.$9n.test(r)&&this.overrides.push({identifiers:(0,v.$0n)(r),keys:Object.keys(this.contents[r]),contents:(0,w.$Pi)(this.contents[r],c=>console.error(c))})}}e.$co=m;class p{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!g.$2f(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:c,overrides:b,restricted:R,hasExcludedProperties:I}=this.h(r,i);this.b=new m(n,c,b,I?[r]:void 0),this.c=R||[]}g(r){let i={},n=null,c=[];const b=[],R=[];function I(C){Array.isArray(c)?c.push(C):n!==null&&(c[n]=C)}const E={onObjectBegin:()=>{const C={};I(C),b.push(c),c=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{c=b.pop()},onArrayBegin:()=>{const C=[];I(C),b.push(c),c=C,n=null},onArrayEnd:()=>{c=b.pop()},onLiteralValue:I,onError:(C,j,U)=>{R.push({error:C,offset:j,length:U})}};if(r)try{s.$vn(r,E),i=c[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return i}h(r,i){const n=y.$Tn.as(v.$Yn.Configuration).getConfigurationProperties(),c=this.i(r,n,!0,i);r=c.raw;const b=(0,w.$Pi)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),R=Object.keys(r),I=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:b,keys:R,overrides:I,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(r,i,n,c){let b=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:b};const R={},I=[];for(const E in r)if(v.$9n.test(E)&&n){const C=this.i(r[E],i,!1,c);R[E]=C.raw,b=b||C.hasExcludedProperties,I.push(...C.restricted)}else{const C=i[E],j=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&I.push(E),!c.exclude?.includes(E)&&(c.include?.includes(E)||(j===void 0||c.scopes===void 0||c.scopes.includes(j))&&!(c.skipRestricted&&C?.restricted))?R[E]=r[E]:b=!0}return{raw:R,restricted:I,hasExcludedProperties:b}}j(r,i){const n=[];for(const c of Object.keys(r))if(v.$9n.test(c)){const b={};for(const R in r[c])b[R]=r[c][R];n.push({identifiers:(0,v.$0n)(c),keys:Object.keys(b),contents:(0,w.$Pi)(b,i)})}return n}}e.$do=p;class k extends M.$Tc{constructor(r,i,n,c){super(),this.c=r,this.f=i,this.g=c,this.b=this.B(new D.$5d),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&n.isEqual(b.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$eo=k;class u{constructor(r,i,n,c,b,R,I,E,C,j,U,F,V){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=c,this.d=b,this.f=R,this.g=I,this.h=E,this.i=C,this.j=j,this.k=U,this.l=F,this.m=V}get value(){return h(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(r,i,n,c,b=new m,R=new m,I=new A.$Ac,E=new m,C=new A.$Ac){this.c=r,this.d=i,this.f=n,this.g=c,this.h=b,this.i=R,this.j=I,this.l=E,this.m=C,this.a=null,this.b=new A.$Ac,this.n=null}getValue(r,i,n){return this.p(r,i,n).getValue(r)}updateValue(r,i,n={}){let c;n.resource?(c=this.m.get(n.resource),c||(c=new m,this.m.set(n.resource,c))):c=this.l,i===void 0?c.removeValue(r):c.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const c=this.p(r,i,n),b=this.t(i.resource,n),R=i.resource?this.m.get(i.resource)||this.l:this.l,I=new Set;for(const E of c.overrides)for(const C of E.identifiers)c.getOverrideValue(r,C)!==void 0&&I.add(C);return new u(r,i,c.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,b||void 0,R)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:c,updated:b,removed:R}=a(this.c,r);i=[...c,...b,...R]}for(const c of i)for(const b of(0,v.$0n)(c)){const R=this.c.getKeysForOverrideIdentifier(b),I=r.getKeysForOverrideIdentifier(b),E=[...I.filter(C=>R.indexOf(C)===-1),...R.filter(C=>I.indexOf(C)===-1),...R.filter(C=>!P.$Ln(this.c.override(b).getValue(C),r.override(b).getValue(C)))];n.push([b,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:c}=a(this.d,r),b=[...i,...n,...c];return b.length&&this.updatePolicyConfiguration(r),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:c,overrides:b}=a(this.applicationConfiguration,r),R=[...i,...n,...c];return R.length&&this.updateApplicationConfiguration(r),{keys:R,overrides:b}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:c,overrides:b}=a(this.localUserConfiguration,r),R=[...i,...n,...c];return R.length&&this.updateLocalUserConfiguration(r),{keys:R,overrides:b}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:c,overrides:b}=a(this.remoteUserConfiguration,r),R=[...i,...n,...c];return R.length&&this.updateRemoteUserConfiguration(r),{keys:R,overrides:b}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:c,overrides:b}=a(this.workspaceConfiguration,r),R=[...i,...n,...c];return R.length&&this.updateWorkspaceConfiguration(r),{keys:R,overrides:b}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:c,updated:b,removed:R,overrides:I}=a(n,i),E=[...c,...b,...R];return(E.length||!n)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:I}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:c,removed:b,overrides:R}=a(i,void 0);return{keys:[...n,...c,...b],overrides:R}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,n){let c=this.q(i,n);return i.overrideIdentifier&&(c=c.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(c=c.merge(this.d)),c}q({resource:r},i){let n=this.r();if(i&&r){const c=i.getFolder(r);c&&(n=this.s(c.uri)||n);const b=this.m.get(r);b&&(n=n.merge(b))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const n=this.r(),c=this.j.get(r);c?(i=n.merge(c),this.b.set(r,i)):i=n}return i}t(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:c,keys:b}=this.j.get(i);return r.push([i,{contents:n,overrides:c,keys:b}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c))),[...i.values()]}static parse(r){const i=this.w(r.defaults),n=this.w(r.policy),c=this.w(r.application),b=this.w(r.user),R=this.w(r.workspace),I=r.folders.reduce((E,C)=>(E.set(l.URI.revive(C[0]),this.w(C[1])),E),new A.$Ac);return new f(i,n,c,b,new m,R,I,new m,new A.$Ac)}static w(r){return new m(r.contents,r.keys,r.overrides)}}e.$fo=f;function d(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const c of o)c.keys.forEach(b=>r.add(b)),c.overrides.forEach(([b,R])=>{const I=(0,A.$xc)(i,b,new Set);R.forEach(E=>I.add(E))});const n=[];return i.forEach((c,b)=>n.push([b,[...c.values()]])),{keys:[...r.values()],overrides:n}}e.$go=d;class ${constructor(r,i,n,c){this.change=r,this.f=i,this.g=n,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const b of r.keys)this.affectedKeys.add(b);for(const[,b]of r.overrides)for(const R of b)this.affectedKeys.add(R);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,c=this.d.indexOf(n);if(c<0)return!1;const b=c+n.length;if(b>=this.d.length)return!1;const R=this.d.charCodeAt(b);if(R!==this.b&&R!==this.c)return!1;if(i){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,E=this.g.getValue(r,i,this.h);return!P.$Ln(I,E)}return!0}}e.$ho=$;function a(o,r){const{added:i,removed:n,updated:c}=t(r?.rawConfiguration,o?.rawConfiguration),b=[],R=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const E=I.filter(C=>!R.includes(C));for(const C of E)b.push([C,r.getKeysForOverrideIdentifier(C)])}if(o){const E=R.filter(C=>!I.includes(C));for(const C of E)b.push([C,o.getKeysForOverrideIdentifier(C)])}if(r&&o){for(const E of R)if(I.includes(E)){const C=t({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});b.push([E,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:n,updated:c,overrides:b}}function t(o,r){const i=o?r?o.keys.filter(b=>r.keys.indexOf(b)===-1):[...o.keys]:[],n=r?o?r.keys.filter(b=>o.keys.indexOf(b)===-1):[...r.keys]:[],c=[];if(o&&r){for(const b of r.keys)if(o.keys.indexOf(b)!==-1){const R=(0,w.$Si)(r.contents,b),I=(0,w.$Si)(o.contents,b);P.$Ln(R,I)||c.push(b)}}return{added:i,removed:n,updated:c}}}),define(ae[237],ce([0,1,22,3,2,35,12,121,52,5,39,44]),function(Y,e,S,D,s,M,A,P,g,l,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=void 0;class y extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$5d),this.onDidChangeConfiguration=this.a.event,this.b=new P.$co}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$Tn.as(g.$Yn.Configuration).onDidUpdateConfiguration(({properties:k,defaultsOverrides:u})=>this.c(Array.from(k),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(k,u){this.h(k,v.$Tn.as(g.$Yn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:k})}f(){return{}}g(){this.b=new P.$co;const k=v.$Tn.as(g.$Yn.Configuration).getConfigurationProperties();this.h(Object.keys(k),k)}h(k,u){const f=this.f();for(const d of k){const $=f[d],a=u[d];$!==void 0?this.b.addValue(d,$):a?this.b.addValue(d,a.default):this.b.removeValue(d)}}}e.$io=y;class h{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new P.$co}async initialize(){return this.configurationModel}}e.$jo=h;let m=class extends s.$Tc{get configurationModel(){return this.b}constructor(k,u,f){super(),this.c=k,this.f=u,this.g=f,this.a=this.B(new D.$5d),this.onDidChangeConfiguration=this.a.event,this.b=new P.$co}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(k=>this.j(k))),this.B(this.c.onDidChangeConfiguration(async({properties:k})=>this.m(await this.h(k),!0))),this.b}async h(k){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",k);const u={},f=[],d=v.$Tn.as(g.$Yn.Configuration).getConfigurationProperties();for(const $ of k){const a=d[$];if(!a){f.push($);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}f.push($),u[a.policy.name]={type:a.type}}}return(0,A.$6f)(u)||await this.f.updatePolicyDefinitions(u),f}j(k){this.g.trace("PolicyConfiguration#onDidChangePolicies",k);const u=v.$Tn.as(g.$Yn.Configuration).getPolicyConfigurations(),f=(0,S.$Hb)(k.map(d=>u.get(d)));this.m(f,!0)}m(k,u){this.g.trace("PolicyConfiguration#update",k);const f=v.$Tn.as(g.$Yn.Configuration).getConfigurationProperties(),d=[],$=this.b.isEmpty();for(const a of k){const t=f[a]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);($?o!==void 0:!(0,M.$Ln)(this.b.getValue(a),o))&&d.push([a,o])}else this.b.getValue(a)!==void 0&&d.push([a,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const a=this.b;this.b=new P.$co;for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,o]of d)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);u&&this.a.fire(this.b)}}};e.$ko=m,e.$ko=m=ve([se(1,w.$Vn),se(2,l.$yj)],m)}),define(ae[238],ce([0,1,22,8,17,3,42,102,2,35,4,19,18,121,52,237,39]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=void 0;class u extends g.$Tc{constructor($,a,t,o){super(),this.m=$,this.h=this.B(new M.$5d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$io),this.c=t instanceof k.$Xn?new p.$jo:this.B(new p.$ko(this.b,t,o)),this.f=this.B(new h.$eo(this.m,{},v.$Ig,a)),this.a=new h.$fo(this.b.configurationModel,this.c.configurationModel,new h.$co,new h.$co),this.j=new f($,a,this),this.g=this.B(new D.$qh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:i})=>this.r(r,i))),this.B(this.c.onDidChangeConfiguration(r=>this.s(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,a,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$fo($,a,new h.$co,t)}getConfigurationData(){return this.a.toData()}getValue($,a){const t=typeof $=="string"?$:void 0,o=(0,y.$Li)($)?$:(0,y.$Li)(a)?a:{};return this.a.getValue(t,o,void 0)}async updateValue($,a,t,o,r){const i=(0,y.$Mi)(t)?t:(0,y.$Li)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,n=i?o:t;if(n!==void 0&&n!==3&&n!==2)throw new Error(`Unable to write ${$} to target ${n}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,S.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const c=this.inspect($,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(c.policyValue!==void 0)throw new Error(`Unable to write ${$} because it is configured in system policy.`);if((0,l.$Ln)(a,c.defaultValue)&&(a=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const R=i.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(E=>(0,S.$ub)([...E.identifiers].sort(),R));I&&(i.overrideIdentifiers=I.identifiers)}const b=i?.overrideIdentifiers?.length?[(0,m.$$n)(i.overrideIdentifiers),$]:[$];await this.j.write(b,a),await this.reloadConfiguration()}inspect($,a={}){return this.a.inspect($,a,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.n($)}n($){const a=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration($);this.t(t,a,2)}r($,a){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration($,a);this.t(o,t,7)}s($){const a=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration($);this.t(t,a,7)}t($,a,t){const o=new h.$ho($,{data:a},this.a);o.source=t,this.h.fire(o)}}e.$lo=u;class f{constructor($,a,t){this.b=$,this.c=a,this.d=t,this.a=new D.$lh}write($,a){return this.a.queue(()=>this.e($,a))}async e($,a){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,A.$on)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(t,$,a);t=(0,P.$Gn)(t,r),await this.c.writeFile(this.b,s.$se.fromString(t))}f($,a,t){const{tabSize:o,insertSpaces:r,eol:i}=this.h;if(!a.length){const n=JSON.stringify(t,null,r?" ".repeat(o):"	");return[{content:n,length:n.length,offset:0}]}return(0,P.$Dn)($,a,t,{tabSize:o,insertSpaces:r,eol:i})}get h(){if(!this.g){let $=w.OS===3||w.OS===2?`
`:`\r
`;const a=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});a&&typeof a=="string"&&a!=="auto"&&($=a),this.g={eol:$,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[239],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=e.$bac=e.$aac=void 0,e.$aac="request",e.$bac="remoteResourceHandler";class S{async routeCall(s,M,A){if(M!==e.$aac)throw new Error(`Call not found: ${M}`);const P=A[0];if(P?.authority){const g=s.connections.find(l=>l.ctx===P.authority);if(g)return g}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$cac=S}),define(ae[240],ce([0,1,14,6]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.RemoteAuthorityResolverErrorCode=e.$il=e.$hl=e.RemoteConnectionType=e.$gl=void 0,e.$gl=(0,D.$ei)("remoteAuthorityResolverService");var s;(function(w){w[w.WebSocket=0]="WebSocket",w[w.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$hl=M;class A{constructor(v,y){this.host=v,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$il=A;var P;(function(w){w.Unknown="Unknown",w.NotAvailable="NotAvailable",w.TemporarilyNotAvailable="TemporarilyNotAvailable",w.NoResolverFound="NoResolverFound",w.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class g extends S.$bb{static isNotAvailable(v){return v instanceof g&&v._code===P.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof g&&v._code===P.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof g&&v._code===P.NoResolverFound}static isInvalidAuthority(v){return v instanceof g&&v._code===P.InvalidAuthority}static isHandled(v){return v instanceof g&&v.isHandled}constructor(v,y=P.Unknown,h){super(v),this._message=v,this._code=y,this._detail=h,this.isHandled=y===P.NotAvailable&&h===!0,Object.setPrototypeOf(this,g.prototype)}}e.$jl=g;function l(w){const v=w.indexOf("+");return v===-1?w:w.substring(0,v)}e.$kl=l}),define(ae[60],ce([0,1,13]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=void 0;function D(l){return l.scheme===S.Schemas.vscodeRemote?l.authority:void 0}e.$ll=D;function s(l){if(!l)return;const w=l.indexOf("+");return w<0?l:l.substr(0,w)}e.$ml=s;function M(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$nl=M;function A(l){const{host:w,port:v}=g(l);if(typeof v>"u")throw new Error(`Invalid remote authority: ${l}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:w,port:v}}e.$ol=A;function P(l,w){let{host:v,port:y}=g(l);return typeof y>"u"&&(y=w),{host:v,port:y}}e.$pl=P;function g(l){const w=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const v=l.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const y=l.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:l,port:void 0}}}),define(ae[122],ce([0,1,25,6,60]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.TargetPlatform=e.ExtensionType=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=e.$qm=void 0,e.$qm="extensions.user.cache",e.$rm="extensions.builtin.cache",e.$sm="undefined_publisher",e.$tm=["ui","workspace","web"];function M(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$um=M,e.$vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(A||(e.ExtensionType=A={}));var P;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class g{constructor(k){this.value=k,this._lower=k.toLowerCase()}static equals(k,u){if(typeof k>"u"||k===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof k=="string"||typeof u=="string"){const f=typeof k=="string"?k:k.value,d=typeof u=="string"?u:u.value;return S.$jf(f,d)}return k._lower===u._lower}static toKey(k){return typeof k=="string"?k.toLowerCase():k._lower}}e.$wm=g;class l{get size(){return this.c.size}constructor(k){if(this.c=new Set,k)for(const u of k)this.add(u)}add(k){this.c.add(g.toKey(k))}delete(k){return this.c.delete(g.toKey(k))}has(k){return this.c.has(g.toKey(k))}}e.$xm=l;class w{constructor(){this.c=new Map}clear(){this.c.clear()}delete(k){this.c.delete(g.toKey(k))}get(k){return this.c.get(g.toKey(k))}has(k){return this.c.has(g.toKey(k))}set(k,u){this.c.set(g.toKey(k),u)}values(){return this.c.values()}forEach(k){this.c.forEach(k)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$ym=w;function v(p){return y(p)}e.$zm=v;function y(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$Am=y;function h(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$Bm=h;function m(p,k){if(k){const u=`onResolveRemoteAuthority:${(0,s.$ml)(k)}`;return!!p.activationEvents?.includes(u)}return!1}e.$Cm=m,e.$Dm=(0,D.$ei)("IBuiltinExtensionsScannerService")}),define(ae[241],ce([0,1,8,17,23,14,3,2,67,72,32,111,240,60]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.PersistentConnectionEventType=e.$wl=e.$vl=e.$ul=e.ConnectionType=void 0;const m=30*1e3;var p;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function k(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(K){const O=new s.$ce;return setTimeout(()=>O.cancel(),K),O.token}function f(K,O){if(K.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const W=new s.$ce;return K.onCancellationRequested(()=>W.cancel()),O.onCancellationRequested(()=>W.cancel()),W.token}class d{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new P.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,S.$0g)(),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function $(K,O){const W=new d(O);return W.registerDisposable(K.onControlMessage(x=>{const N=JSON.parse(x.toString()),Q=L(N);Q?W.reject(Q):W.resolve(N)})),W.promise}function a(K,O,W,x,N,Q,H,_){const z=new d(_),ee=l.$1d.create(!1);return K.info(`Creating a socket (${H})...`),g.mark(`code/willCreateSocket/${Q}`),O.connect(W,x,N,H).then(ie=>{z.didTimeout?(g.mark(`code/didCreateSocketError/${Q}`),K.info(`Creating a socket (${H}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),ie?.dispose()):(g.mark(`code/didCreateSocketOK/${Q}`),K.info(`Creating a socket (${H}) was successful after ${ee.elapsed()} ms.`),z.resolve(ie))},ie=>{g.mark(`code/didCreateSocketError/${Q}`),K.info(`Creating a socket (${H}) returned an error after ${ee.elapsed()} ms.`),K.error(ie),z.reject(ie)}),z.promise}function t(K,O){const W=new d(O);return K.then(x=>{W.didTimeout||W.resolve(x)},x=>{W.didTimeout||W.reject(x)}),W.promise}async function o(K,O,W,x){const N=oe(K,O);K.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await a(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,h.$nl)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,k(O),`renderer-${k(O)}-${K.reconnectionToken}`,x)}catch(ie){throw K.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ie),ie}K.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let H,_;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(Q,null),H=K.reconnectionProtocol,_=!1):(H=new v.$5h({socket:Q}),_=!0),K.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const z=await t(K.signService.createNewMessage((0,w.$Ag)()),x),ee={type:"auth",auth:K.connectionToken||"00000000000000000000",data:z.data};H.sendControl(D.$se.fromString(JSON.stringify(ee)));try{const ie=await $(H,f(x,u(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(K.logService.trace(`${N} 4/6. received SignRequest control message.`),!await t(K.signService.validate(z,ie.signedData),x)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const me=await t(K.signService.sign(ie.data),x),Ee={type:"connectionType",commit:K.commit,signedData:me,desiredConnectionType:O};return W&&(Ee.args=W),K.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(D.$se.fromString(JSON.stringify(Ee))),{protocol:H,ownsProtocol:_}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(K.logService.error(`${N} the handshake timed out. Error:`),K.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${N} received error control message when negotiating connection. Error:`),K.logService.error(ie)),_&&q(H),ie}}async function r(K,O,W,x){const N=Date.now(),Q=oe(K,O),{protocol:H,ownsProtocol:_}=await o(K,O,W,x),z=new d(x);return z.registerDisposable(H.onControlMessage(ee=>{const ie=JSON.parse(ee.toString()),de=L(ie);de?(K.logService.error(`${Q} received error control message when negotiating connection. Error:`),K.logService.error(de),_&&q(H),z.reject(de)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${he(N)}!`),z.resolve({protocol:H,firstMessage:ie}))})),z.promise}async function i(K,O){const{protocol:W}=await r(K,1,void 0,O);return{protocol:W}}async function n(K,O,W){const{protocol:x,firstMessage:N}=await r(K,2,O,W),Q=N&&N.debugPort;return{protocol:x,debugPort:Q}}async function c(K,O,W){const x=Date.now(),N=oe(K,3),{protocol:Q}=await o(K,3,O,W);return K.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${he(x)}!`),Q}async function b(K,O,W){const{connectTo:x,connectionToken:N}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:x,connectionToken:N,reconnectionToken:O,reconnectionProtocol:W,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function R(K,O,W){return E(K,async x=>{const{protocol:N}=await i(x,s.CancellationToken.None);return new Z(K,O,W,x.reconnectionToken,N)})}e.$ul=R;async function I(K,O){return E(K,async W=>{const{protocol:x,debugPort:N}=await n(W,O,s.CancellationToken.None);return new X(K,O,W.reconnectionToken,x,N)})}e.$vl=I;async function E(K,O){for(let x=1;;x++)try{const N=(0,w.$Ag)(),Q=await b(K,N,null);return await O(Q)}catch(N){if(x<5)K.logService.error(`[remote-connection][attempt ${x}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(N);else throw K.logService.error(`[remote-connection][attempt ${x}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(N),ue.triggerPermanentFailure(0,0,y.$jl.isHandled(N)),N}}async function C(K,O,W){const x=await b(K,(0,w.$Ag)(),null);return await c(x,{host:O,port:W},s.CancellationToken.None)}e.$wl=C;function j(K){return(0,S.$4g)(O=>new Promise((W,x)=>{const N=setTimeout(W,K*1e3);O.onCancellationRequested(()=>{clearTimeout(N),W()})}))}var U;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class F{constructor(O,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.type=0}}e.$xl=F;class V{constructor(O,W,x,N){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.durationSeconds=x,this.c=N,this.type=1}skipWait(){this.c.cancel()}}e.$yl=V;class J{constructor(O,W,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.attempt=x,this.type=2}}e.$zl=J;class le{constructor(O,W,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.attempt=x,this.type=4}}e.$Al=le;class re{constructor(O,W,x,N){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.attempt=x,this.handled=N,this.type=3}}e.$Bl=re;class ue extends P.$Tc{static triggerPermanentFailure(O,W,x){this._permanentFailure=!0,this.f=O,this.g=W,this.h=x,this.j.forEach(N=>N.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(O,W,x,N,Q){super(),this.t=O,this.u=W,this.reconnectionToken=x,this.protocol=N,this.w=Q,this.m=this.B(new A.$5d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(N.onSocketClose(H=>{const _=B(this.t,this.reconnectionToken,!0);H?H.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${H.hadError}).`),H.error&&this.u.logService.error(H.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this.u.logService.error(H.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(N.onSocketTimeout(H=>{const _=B(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,P.$Rc)(()=>{const H=ue.j.indexOf(this);H>=0&&ue.j.splice(H,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=B(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const N=x<W.length?W[x]:W[W.length-1];try{if(N>0){const H=j(N);this.m.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,H)),this.u.logService.info(`${O} waiting for ${N} seconds before reconnecting...`);try{await H}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this.u.logService.info(`${O} resolving connection...`);const Q=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${Q.connectTo}...`),await this.G(Q,u(m)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(y.$jl.isTemporarilyNotAvailable(Q)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((0,M.$4)(Q)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if(Q instanceof y.$jl){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,y.$jl.isHandled(Q));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!this.n&&!this.s)}C(O,W,x){this.w?ue.triggerPermanentFailure(O,W,x):this.D(O,W,x)}D(O,W,x){this.m.fire(new re(this.reconnectionToken,O,W,x)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Cl=ue;class Z extends ue{constructor(O,W,x,N,Q){super(1,O,N,Q,!0),this.client=this.B(new v.$3h(Q,{remoteAuthority:W,clientId:x},O.ipcLogger))}async G(O,W){await i(O,W)}}e.$Dl=Z;class X extends ue{constructor(O,W,x,N,Q){super(2,O,x,N,!1),this.H=W,this.debugPort=Q}async G(O,W){await n(O,this.H,W)}}e.$El=X;function q(K){try{K.acceptDisconnect();const O=K.getSocket();K.dispose(),O.dispose()}catch(O){(0,M.$1)(O)}}function L(K){if(K&&K.type==="error"){const O=new Error(`Connection error: ${K.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function T(K,O){for(;K.length<O;)K+=" ";return K}function G(K,O){return`[remote-connection][${T(k(K),13)}][${O.substr(0,5)}\u2026]`}function B(K,O,W){return`${G(K,O)}[${W?"reconnect":"initial"}]`}function oe(K,O){return`${B(O,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function he(K){return`${Date.now()-K} ms`}}),define(ae[242],ce([0,1,2,6]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0,e.$ql=(0,D.$ei)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(A,P){return this.a[A]??=[],this.a[A].push(P),(0,S.$Rc)(()=>{const g=this.a[A]?.indexOf(P);typeof g=="number"&&g>=0&&this.a[A]?.splice(g,1)})}b(A){return(this.a[A.type]||[]).find(g=>g.supports(A))}connect(A,P,g,l){const w=this.b(A);if(!w)throw new Error(`No socket factory found for ${A}`);return w.connect(A,P,g,l)}}e.$rl=s}),define(ae[243],ce([0,1,26,48,21,115]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c_b=void 0;let A;async function P(h=!1){return(A===void 0||h)&&(A=g()),A}e.$c_b=P;async function g(){const h=l();if(h===void 0)return!1;if(h>=22e3){const m=v();if(m)return new Promise(p=>{D.execFile(m,["--status"],k=>p(!k))})}else{const m=y();if(m)try{if((await s.Promises.stat(m)).isFile())return!0}catch{}}return!1}function l(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(h)return parseInt(h[3])}function w(h){const m=process.env.SystemRoot;if(m){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(m,p?"Sysnative":"System32",h)}}function v(){return w("wsl.exe")}function y(){return w("lxss\\LxssManager.dll")}}),define(ae[53],ce([0,1,17,14,2,183,52,6,5,44]),function(Y,e,S,D,s,M,A,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=void 0,e.$sp=(0,P.$ei)("requestService");class w{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class v extends s.$Tc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,M.localize)(0,null),when:g.$Pj.isEqualTo((0,g.$Nj)(g.LogLevel.Trace)).serialize()})}async c(a,t,o){const r=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new w(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,D.$0)(i)),i}}}e.$tp=v;function y($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}e.$up=y;function h($){return $.res.statusCode===204}e.$vp=h;async function m($){return h($)?null:(await(0,S.$Ee)($.stream)).toString()}e.$wp=m;async function p($){if(!y($))throw new Error("Server returned "+$.res.statusCode);return m($)}e.$xp=p;async function k($){if(!y($))throw new Error("Server returned "+$.res.statusCode);if(h($))return null;const t=(await(0,S.$Ee)($.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$yp=k;function u($){d($)}e.$zp=u;let f;function d($){const a=l.$Tn.as(A.$Yn.Configuration),t=f;f={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[f],remove:t?[t]:[]})}d(1)}),define(ae[244],ce([0,1,17,23]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;class s{constructor(P){this.a=P}listen(P,g){throw new Error("Invalid listen")}call(P,g,l,w=D.CancellationToken.None){switch(g){case"request":return this.a.request(l[0],w).then(async({res:v,stream:y})=>{const h=await(0,S.$Ee)(y);return[{statusCode:v.statusCode,headers:v.headers},h]});case"resolveProxy":return this.a.resolveProxy(l[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$vr=s;class M{constructor(P){this.a=P}async request(P,g){const[l,w]=await this.a.call("request",[P],g);return{res:l,stream:(0,S.$Ge)(w)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$wr=M}),define(ae[245],ce([0,1,246,12]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;function s(A,P){return A.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:A.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function M(A,P,g={}){const l=(0,S.parse)(A),w=g.proxyUrl||s(l,P);if(!w)return null;const v=(0,S.parse)(w);if(!/^https?:$/.test(v.protocol||""))return null;const y={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,D.$Yf)(g.strictSSL)?g.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((h,m)=>{Y(["http-proxy-agent"],h,m)})).HttpProxyAgent(w,y):new(await new Promise((h,m)=>{Y(["https-proxy-agent"],h,m)})).HttpsProxyAgent(w,y)}e.$xr=M}),define(ae[247],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y_b=e.$x_b=e.$w_b=void 0,e.$w_b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$x_b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$y_b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[94],ce([0,1,48,9,184,23,51,14,4,32,110,64,8,140]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=void 0;let m;async function p(u,f,d,$){return d["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$em)($)&&!d["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$em)($)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=y.Promises.withAsyncBody(async(a,t)=>{const o=new M.$ce;let r=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,h.$fm)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{a(await k(f,o.token))}catch(c){!(0,P.$4)(c)&&!o.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,A.$2i)(c)))):a({})}finally{clearTimeout(n),o.dispose()}})),m)}e.$km=p;async function k(u,f){const d=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",d);const $=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",$);const a=(0,l.$Ag)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const r=await(0,w.$7l)(g.OS,o);return u.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(f.isCancellationRequested)return n(new P.$5);const c=(0,D.$nc)(r);let b,R;const I="";/^pwsh(-preview)?$/.test(c)?(b=`& '${process.execPath}' ${I} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,R=["-Login","-Command"]):c==="nu"?(b=`^'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,R=["-i","-l","-c"]):c==="xonsh"?(b=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,R=["-i","-l","-c"]):(b=`'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"||c==="csh"?R=["-ic"]:R=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),b);const E=(0,S.spawn)(r,[...R,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(E.kill(),n(new P.$5))),E.on("error",U=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,A.$2i)(U)),n(U)});const C=[];E.stdout.on("data",U=>C.push(U));const j=[];E.stderr.on("data",U=>j.push(U)),E.on("close",(U,F)=>{const V=Buffer.concat(C).toString("utf8");u.trace("getUnixShellEnvironment#raw",V);const J=Buffer.concat(j).toString("utf8");if(J.trim()&&u.trace("getUnixShellEnvironment#stderr",J),U||F)return n(new Error((0,s.localize)(2,null,U,F)));const le=t.exec(V),re=le?le[1]:"{}";try{const ue=JSON.parse(re);d?ue.ELECTRON_RUN_AS_NODE=d:delete ue.ELECTRON_RUN_AS_NODE,$?ue.ELECTRON_NO_ATTACH_CONSOLE=$:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){u.error("getUnixShellEnvironment#errorCaught",(0,A.$2i)(ue)),n(ue)}})})}}),define(ae[248],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const A=String(S.a++);return this.b.set(A,M),{id:A,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const A=this.b.get(s.id);if(!A)return!1;this.b.delete(s.id);try{return A.validate(M)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$t8b=S}),define(ae[95],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=void 0,e.$sl="signService",e.$tl=(0,S.$ei)(e.$sl)}),define(ae[249],ce([0,1,248]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mac=void 0;class D extends S.$t8b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(A=>new A.signer().sign(M))}h(){return new Promise((M,A)=>Y(["vsda"],M,A))}}e.$mac=D}),define(ae[34],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=e.$rP=void 0,e.$rP=(0,S.$ei)("stateReadService"),e.$sP=(0,S.$ei)("stateService")}),define(ae[123],ce([0,1,8,17,2,12,38,16,5]),function(Y,e,S,D,s,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=e.$uP=e.$tP=e.SaveStrategy=void 0;var l;(function(h){h[h.IMMEDIATE=0]="IMMEDIATE",h[h.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class w extends s.$Tc{constructor(m,p,k,u){super(),this.h=m,this.j=p,this.m=k,this.n=u,this.a=Object.create(null),this.b="",this.c=this.B(new S.$ch(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.m.error(m)}}getItem(m,p){const k=this.a[m];return(0,M.$2f)(k)?p:k}setItem(m,p){this.setItems([{key:m,data:p}])}setItems(m){let p=!1;for(const{key:k,data:u}of m)this.a[k]!==u&&((0,M.$2f)(u)?(0,M.$Zf)(this.a[k])||(this.a[k]=void 0,p=!0):(this.a[k]=u,p=!0));p&&this.s()}removeItem(m){(0,M.$Zf)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,D.$se.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(p){this.m.error(p)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$tP=w;let v=class extends s.$Tc{constructor(m,p,k,u){super(),this.a=this.B(new w(p.stateResource,m,k,u))}async init(){await this.a.init()}getItem(m,p){return this.a.getItem(m,p)}};e.$uP=v,e.$uP=v=ve([se(1,A.$li),se(2,g.$yj),se(3,P.$Bk)],v);class y extends v{setItem(m,p){this.a.setItem(m,p)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$vP=y}),define(ae[124],ce([0,1,4,36,32]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=void 0;function M(g){if(S.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function A(g,l,w,v,y,h,m,p,k){const u=Object.create(null);u["common.machineId"]=h,u["common.sqmId"]=m,u.sessionID=(0,s.$Ag)()+Date.now(),u.commitHash=v,u.version=y,u["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,S.$h)(S.$u),u["common.nodePlatform"]=D.$dc,u["common.nodeArch"]=w,u["common.product"]=k||"desktop",p&&(u["common.msftInternal"]=p);let f=0;const d=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),S.$l&&(u["common.snap"]="true");const $=M(l);return $&&(u["common.platformDetail"]=$),u}e.$Uo=A;function P(g){const l=D.env.USERDNSDOMAIN;if(!l)return!1;const w=l.toLowerCase();return g.some(v=>w===v)}e.$Vo=P}),define(ae[28],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,S.$ei)("telemetryService"),e.$Gl=(0,S.$ei)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var D;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(ae[250],ce([0,1,26,8,42,13,9,4,7,88,21,109,91,16,27,28]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=e.$fs=e.$es=void 0;const k=new Map;async function u(t,o){const r=`${t}::${o.join(":")}`,i=k.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,b=new Map,R=2e4;function I(C,j,U,F){const V=j.substring(C.length+1);return D.Promises.withAsyncBody(async J=>{let le;try{le=await w.Promises.readdir(j,{withFileTypes:!0})}catch{J();return}if(F.count>=R){F.count+=le.length,F.maxReached=!0,J();return}let re=le.length;if(re===0){J();return}let ue=le;F.count+le.length>R&&(F.maxReached=!0,re=R-F.count,ue=le.slice(0,re)),F.count+=le.length;for(const Z of ue)if(Z.isDirectory()){if(U.includes(Z.name)||await I(C,(0,A.$jc)(j,Z.name),U,F),--re===0){J();return}}else{const X=Z.name.lastIndexOf(".");if(X>=0){const q=Z.name.substring(X+1);q&&c.set(q,(c.get(q)??0)+1)}for(const q of n)q.relativePathPattern?.test(V)!==!1&&q.filePattern.test(Z.name)&&b.set(q.tag,(b.get(q.tag)??0)+1);if(--re===0){J();return}}})}const E=D.Promises.withAsyncBody(async C=>{const j={count:0,maxReached:!1};await I(t,t,o,j);const U=await $(t);C({configFiles:f(b),fileTypes:f(c),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:U})});return k.set(r,E),E}e.$es=u;function f(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function d(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/h.$0k.GB).toFixed(2)}GB (${(S.freemem()/h.$0k.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.$jn.value()*100)}%`},o=S.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$fs=d;async function $(t){try{const o=new Map,r=(0,A.$jc)(t,".vscode","launch.json"),i=await w.Promises.readFile(r),n=[],c=(0,s.$on)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$xn)(c)==="object"&&c.configurations)for(const b of c.configurations){const R=b.type;R&&(o.has(R)?o.set(R,o.get(R)+1):o.set(R,1))}return f(o)}catch{return[]}}e.$gs=$;let a=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const i=S.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/h.$0k.GB).toFixed(2)}GB (${(S.freemem()/h.$0k.GB).toFixed(2)}GB free)`),P.$i||r.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(l.$jn.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,v.$ds)(o.mainPID),this.k(o)]).then(async i=>{let[n,c]=i,b=this.m(o,n);return r.forEach(R=>{if((0,y.$Vm)(R))b+=`
${R.errorMessage}`,c+=`
${R.errorMessage}`;else if(b+=`

Remote: ${R.hostName}`,R.processes&&(b+=`
${this.m(o,R.processes)}`),R.workspaceMetadata){c+=`
|  Remote: ${R.hostName}`;for(const I of Object.keys(R.workspaceMetadata)){const E=R.workspaceMetadata[I];let C=`${E.fileCount} files`;E.maxFilesReached&&(C=`more than ${C}`),c+=`|    Folder (${I}): ${C}`,c+=this.h(E)}}}),{processInfo:b,workspaceInfo:c}})}async getSystemInfo(o,r){const{memory:i,vmHint:n,os:c,cpus:b}=d(),R={os:c,memory:i,cpus:b,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return P.$i||(R.load=`${S.loadavg().map(I=>Math.round(I)).join(", ")}`),P.$k&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(o,r){const i=[];return(0,v.$ds)(o.mainPID).then(async n=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,n)),o.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(c=>{if((0,y.$Vm)(c))i.push(`
${c.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${c.hostName}`),i.push(this.f(c.machineInfo)),c.processes&&i.push(this.m(o,c.processes)),c.workspaceMetadata)for(const b of Object.keys(c.workspaceMetadata)){const R=c.workspaceMetadata[b];let I=`${R.fileCount} files`;R.maxFilesReached&&(I=`more than ${I}`),i.push(`Folder (${b}): ${I}`),i.push(this.h(R))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let n=0;const c=(E,C)=>{const j=` ${E}(${C})`;n+j.length>60?(r.push(b),b="|                 ",n=b.length):n+=j.length,b+=j};let b="|      File types:";const R=10,I=o.fileTypes.length>R?R:o.fileTypes.length;for(let E=0;E<I;E++){const C=o.fileTypes[E];c(C.name,C.count)}if(r.push(b),o.configFiles.length>=0&&(b="|      Conf files:",n=0,o.configFiles.forEach(E=>{c(E.name,E.count)}),r.push(b)),o.launchConfigFiles.length>0){let E="|      Launch Configs:";o.launchConfigFiles.forEach(C=>{const j=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;E+=j}),r.push(E)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(c=>{const b=g.URI.revive(c);if(b.scheme===M.Schemas.file){const R=b.fsPath;i.push(u(R,["node_modules",".git"]).then(I=>{let E=`${I.fileCount} files`;I.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,A.$nc)(R)}): ${E}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${R} (${I.toString()})`)}))}else r.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const i=new Map;o.windows.forEach(c=>i.set(c.pid,`window [${c.id}] (${c.title})`)),o.pidToNames.forEach(({pid:c,name:b})=>i.set(c,b));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,n,r,0),n.join(`
`)}n(o,r,i,n,c){const b=c===0;let R;b?R=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?R=r.get(n.pid):R=`${"  ".repeat(c)} ${n.name}`;const I=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(I/h.$0k.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(n.children)&&n.children.forEach(E=>this.n(o,r,i,E,c+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const n=g.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const c=n.fsPath;try{(await u(c,["node_modules",".git"])).fileTypes.forEach(R=>r.add(R.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=g.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const c=await u(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),c.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),c.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),c.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$hs=a,e.$hs=a=ve([se(0,p.$Fl),se(1,m.$Qj)],a)}),define(ae[251],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C_b=e.$B_b=void 0;class S{constructor(M){this.b=M}listen(M,A){throw new Error(`Event not found: ${A}`)}call(M,A,{eventName:P,data:g}){return this.b.forEach(l=>l.log(P,g)),Promise.resolve(null)}}e.$B_b=S;class D{constructor(M){this.b=M}log(M,A){return this.b.call("log",{eventName:M,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$C_b=D}),define(ae[54],ce([0,1,35,12,60,124,28]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0;class P{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$Wo=P;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Xo=g,e.$Yo=new g;class l{async publicLog(o,r,i){}async publicLogError(o,r,i){}}e.$Zo=l,e.$1o="telemetry",e.$2o="extensionTelemetryLog",e.$3o={log:()=>null,flush:()=>Promise.resolve(null)};function w(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}e.$4o=w;function v(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$5o=v;function y(t){const o=t.getValue(A.$Nl),r=t.getValue(A.$Ol);if(t.getValue(A.$Pl)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$6o=y;function h(t){const o={},r={},i={};k(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const c=i[n];typeof c=="number"?r[n]=c:typeof c=="boolean"?r[n]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${c.length}`),o[n]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(o[n]=c)}return{properties:o,measurements:r}}e.$7o=h;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(t){if(!t)return"none";const o=(0,s.$ml)(t);return m.has(o)?o:"other"}e.$8o=p;function k(t,o,r=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const c=t[n],b=i?i+n:n;Array.isArray(c)?o[b]=(0,S.$Mn)(c):c instanceof Date?o[b]=c.toISOString():(0,D.$Uf)(c)?r<2?k(c,o,r+1,b+"."):o[b]=(0,S.$Mn)(c):o[b]=c}}function u(t,o){const r=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,M.$Vo)(r)||i}e.$9o=u;function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$0o=f;function d(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const R of o)for(;;){const I=R.exec(t);if(!I)break;i.push([I.index,R.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(r="";;){const R=c.exec(t);if(!R)break;const I=i.some(([E,C])=>R.index<C&&E<c.lastIndex);!n.test(R[0])&&!I&&(r+=t.substring(b,R.index)+"<REDACTED: user-file-path>",b=c.lastIndex)}return b<t.length&&(r+=t.substr(b)),r}function $(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function a(t,o){return(0,S.$Jn)(t,r=>{if(r instanceof P||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=d(i,o);for(const n of o)i=i.replace(n,"");return i=$(i),i}})}e.$$o=a}),define(ae[125],ce([0,1,25,119,122,4,7,14,36,54]),function(Y,e,S,D,s,M,A,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0;function w(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,S.$ef)(r.id,i.id)===0}e.$_o=w;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const n=i.manifest?i.manifest.version:i.version,c=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,n,c)}static parse(i){const n=v.exec(i);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,c="undefined"){this.version=n,this.targetPlatform=c,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?w(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$ap=y;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const i=h.exec(r);return i&&i[1]?[k(i[1]),i[2]]:[k(r),void 0]}e.$bp=m;function p(r,i){return`${r}.${i}`}e.$cp=p;function k(r){return r.toLowerCase()}e.$dp=k;function u(r,i){return k(p(r??s.$sm,i))}e.$ep=u;function f(r,i){const n=[],c=b=>{for(const R of n)if(R.some(I=>w(i(I),i(b))))return R;return null};for(const b of r){const R=c(b);R?R.push(b):n.push([b])}return n}e.$fp=f;function d(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$gp=d;function $(r){return{id:new l.$Wo(r.identifier.id),name:new l.$Wo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$hp=$,e.$ip=new s.$wm("pprice.better-merge");function a(r,i){const n=[],c=i.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const b=c.shift();if(b&&n.every(R=>!w(R.identifier,{id:b}))){const R=r.filter(I=>w(I.identifier,{id:b}));R.length===1&&(n.push(R[0]),c.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$jp=a;async function t(r,i){if(!M.$k)return!1;let n;try{n=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){i.debug("Error while getting the os-release file.",(0,P.$0)(b))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const n=await t(r,i),c=(0,D.$Go)(n?"alpine":M.$u,g.$ec);return i.debug("ComputeTargetPlatform:",c),c}e.$kp=o}),define(ae[252],ce([0,1,206,54]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;async function s(M,A,P,g,l,w,v){const y={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${A.nameShort})`};if((0,D.$4o)(A,P)&&(0,D.$6o)(g)===3){const h=await(0,S.$Lp)(P,l,w);y["X-Market-User-Id"]=h,y["VSCode-SessionId"]=v.machineId||h}return y}e.$Mp=s}),define(ae[253],ce([0,1,2,35,4,25,185,18,52,79,27,44,28,54]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,f,d){this.k=f,this.l=d,this.d={},this.i=new S.$Sc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,M.$Xe)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Xe)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(y.$Nl)||$.affectsConfiguration(y.$Pl)||$.affectsConfiguration(y.$Ol))&&this.m()}))}setExperimentProperty(u,f){this.d[u]=f}m(){let u=(0,h.$6o)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const d=f.usage?3:f.error?2:0;u=Math.min(u,d)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,f,d){this.g<f||(d=(0,D.$Kn)(d,this.d),d=(0,h.$$o)(d,this.j),d=(0,D.$Kn)(d,this.c),this.b.forEach($=>$.log(u,d)))}publicLog(u,f){this.n(u,3,f)}publicLog2(u,f){this.publicLog(u,f)}publicLogError(u,f){this.h&&this.n(u,2,f)}publicLogError2(u,f){this.publicLogError(u,f)}};e.$Ar=m,e.$Ar=m=ve([se(1,P.$Ki),se(2,w.$Qj)],m);function p(){const k=(0,A.localize)(0,null,l.default.nameLong),u=l.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=s.$o?"":(0,A.localize)(3,null),d=(0,A.localize)(4,null),$=(0,A.localize)(5,null),a=(0,A.localize)(6,null),t=(0,A.localize)(7,null),o=`
|       | ${d} | ${$} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,A.localize)(8,null);return`
${k} ${u} ${f}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}v.$Tn.as(g.$Yn.Configuration).registerConfiguration({id:y.$Ml,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[y.$Nl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$Tn.as(g.$Yn.Configuration).registerConfiguration({id:y.$Ml,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[y.$Pl]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,A.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,A.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${y.$Nl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[254],ce([0,1,4,88,28]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5_b=e.$4_b=void 0;async function M(P,g){let l=P.getItem(s.$Kl);return(typeof l!="string"||S.$j&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,D.$kn)(g.error.bind(g))),l}e.$4_b=M;async function A(P,g){let l=P.getItem(s.$Ll);return typeof l!="string"&&(l=await(0,D.$ln)(g.error.bind(g))),l}e.$5_b=A}),define(ae[255],ce([0,1,28,254]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7_b=e.$6_b=void 0;async function s(A,P){const g=await(0,D.$4_b)(A,P);return A.setItem(S.$Kl,g),g}e.$6_b=s;async function M(A,P){const g=await(0,D.$5_b)(A,P);return A.setItem(S.$Ll,g),g}e.$7_b=M}),define(ae[126],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(ae[256],ce([0,1,4,126]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;const s=new Map([[D.EnvironmentVariableMutatorType.Append,"APPEND"],[D.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[D.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(w){this.collections=w,this.a=new Map,this.b=new Map,w.forEach((v,y)=>{this.d(v,y);const h=v.map.entries();let m=h.next();for(;!m.done;){const p=m.value[1],k=m.value[0];let u=this.a.get(k);if(u||(u=[],this.a.set(k,u)),u.length>0&&u[0].type===D.EnvironmentVariableMutatorType.Replace){m=h.next();continue}const f={extensionIdentifier:y,value:p.value,type:p.type,scope:p.scope,variable:p.variable,options:p.options};f.scope||delete f.scope,u.unshift(f),m=h.next()}})}async applyToProcessEnvironment(w,v,y){let h;S.$i&&(h={},Object.keys(w).forEach(m=>h[m.toLowerCase()]=m));for(const[m,p]of this.getVariableMap(v)){const k=S.$i&&h[m.toLowerCase()]||m;for(const u of p){const f=y?await y(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case D.EnvironmentVariableMutatorType.Append:w[k]=(w[k]||"")+f;break;case D.EnvironmentVariableMutatorType.Prepend:w[k]=f+(w[k]||"");break;case D.EnvironmentVariableMutatorType.Replace:w[k]=f;break}if(u.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${s.get(u.type)}`;w[d]=(w[d]?w[d]+":":"")+m+"="+this.c(f)}}}}c(w){return w.replaceAll(":","\\x3a")}diff(w,v){const y=new Map,h=new Map,m=new Map;if(w.getVariableMap(v).forEach((p,k)=>{const u=this.getVariableMap(v).get(k),f=P(p,u);f&&y.set(k,f)}),this.getVariableMap(v).forEach((p,k)=>{const u=w.getVariableMap(v).get(k),f=P(p,u);f&&m.set(k,f)}),this.getVariableMap(v).forEach((p,k)=>{const u=w.getVariableMap(v).get(k),f=g(p,u);f&&h.set(k,f)}),!(y.size===0&&h.size===0&&m.size===0))return{added:y,changed:h,removed:m}}getVariableMap(w){const v=new Map;for(const y of this.a.values()){const h=y.filter(m=>A(m,w));h.length>0&&v.set(h[0].variable,h)}return v}getDescriptionMap(w){const v=new Map;for(const y of this.b.values()){const h=y.filter(m=>A(m,w,!0));for(const m of h)v.set(m.extensionIdentifier,m.description)}return v}d(w,v){if(!w.descriptionMap)return;const y=w.descriptionMap.entries();let h=y.next();for(;!h.done;){const m=h.value[1],p=h.value[0];let k=this.b.get(p);k||(k=[],this.b.set(p,k));const u={extensionIdentifier:v,scope:m.scope,description:m.description};u.scope||delete u.scope,k.push(u),h=y.next()}}}e.$4r=M;function A(l,w,v=!1){return l.scope?!!(l.scope.workspaceFolder&&w?.workspaceFolder&&l.scope.workspaceFolder.index===w.workspaceFolder.index):v?w===l.scope:!0}function P(l,w){if(!w)return l;const v=new Set;w.forEach(h=>v.add(h.extensionIdentifier));const y=[];return l.forEach(h=>{v.has(h.extensionIdentifier)||y.push(h)}),y.length===0?void 0:y}function g(l,w){if(!w)return;const v=new Map;w.forEach(h=>v.set(h.extensionIdentifier,h));const y=[];return l.forEach(h=>{const m=v.get(h.extensionIdentifier);m&&(h.type!==m.type||h.value!==m.value||h.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&y.push(m)}),y.length===0?void 0:y}}),define(ae[257],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=e.$2r=e.$1r=e.$Zr=e.$Yr=e.$Xr=void 0;function S(g){return[...g.entries()]}e.$Xr=S;function D(g){return g?[...g.entries()]:[]}e.$Yr=D;function s(g){return new Map(g)}e.$Zr=s;function M(g){return new Map(g??[])}e.$1r=M;function A(g){return Array.from(g.entries()).map(l=>[l[0],S(l[1].map),D(l[1].descriptionMap)])}e.$2r=A;function P(g){return new Map(g.map(l=>[l[0],{map:s(l[1]),descriptionMap:M(l[2])}]))}e.$3r=P}),define(ae[258],ce([0,1,8,23,3,2,5]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=void 0;let P=class extends M.$Tc{constructor(l,w){super(),this.h=w,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$5d),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,M.$Rc)(()=>{for(const v of this.f.values())(0,M.$Oc)(v)}))}createRequest(l){return new Promise((w,v)=>{const y=++this.a;this.c.set(y,w),this.g.fire({requestId:y,...l});const h=new D.$ce;(0,S.$fh)(this.b,h.token).then(()=>v(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,M.$Rc)(()=>h.cancel())])})}acceptReply(l,w){const v=this.c.get(l);v?(this.c.delete(l),(0,M.$Oc)(this.f.get(l)||[]),this.f.delete(l),v(w)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$Or=P,e.$Or=P=ve([se(1,A.$yj)],P)}),define(ae[127],ce([0,1,6,116,44]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.$Ir=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Hr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Gr=void 0,e.$Gr=new D.$vj("terminalTabFocusMode",!1,!0);var M;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var A;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var P;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(P||(e.PosixShellType=P={}));var g;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(g||(e.WindowsShellType=g={}));var l;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var w;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(w||(e.TerminalIpcChannels=w={}));var v;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$Hr=(0,S.$ei)("ptyService");var y;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var h;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(h||(e.TerminalLocation=h={}));var m;(function(a){a.TerminalView="view",a.Editor="editor"})(m||(e.TerminalLocationString=m={}));var p;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(p||(e.LocalReconnectConstants=p={}));var k;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(k||(e.FlowControlConstants=k={}));var u;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var f;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var d;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(d||(e.TerminalExitReason=d={})),e.$Ir={Backend:"workbench.contributions.terminal.processBackend"};class ${constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$Tn.add(e.$Ir.Backend,new $),e.$Jr=(0,S.$ei)("localPtyService"),e.$Kr=(0,S.$ei)("terminalLogService")}),define(ae[259],ce([0,1,74,7,187,104]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=e.$Qr=e.$Pr=void 0;function A(y,h){const m=[{name:null,description:(0,s.localize)(0,null)}];return m.push(...y.map(p=>({name:p.profileName,description:P(p)}))),h&&m.push(...h.map(p=>({name:p.title,description:g(p)}))),{values:m.map(p=>p.name),markdownDescriptions:m.map(p=>p.description)}}e.$Pr=A;function P(y){let h=`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$kk.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?h+=`
- args: "${y.args}"`:h+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(h+=`
- overrideName: ${y.overrideName}`),y.color&&(h+=`
- color: ${y.color}`),y.env&&(h+=`
- env: ${JSON.stringify(y.env)}`),h}function g(y){return`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$kk.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function l(y,h){if(!y&&!h)return!0;if(typeof y=="string"&&typeof h=="string")return y===h;if(Array.isArray(y)&&Array.isArray(h)){if(y.length!==h.length)return!1;for(let m=0;m<y.length;m++)if(y[m]!==h[m])return!1;return!0}return!1}e.$Qr=l;function w(y,h){if(!y&&!h)return!0;if(!y||!h)return!1;if(M.ThemeIcon.isThemeIcon(y)&&M.ThemeIcon.isThemeIcon(h))return y.id===h.id&&y.color===h.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof h=="object"&&"light"in h&&"dark"in h){const m=y,p=h;if((D.URI.isUri(m.light)||v(m.light))&&(D.URI.isUri(m.dark)||v(m.dark))&&(D.URI.isUri(p.light)||v(p.light))&&(D.URI.isUri(p.dark)||v(p.dark)))return m.light.path===p.light.path&&m.dark.path===p.dark.path}if(D.URI.isUri(y)&&D.URI.isUri(h)||v(y)||v(h)){const m=y,p=h;return m.path===p.path&&m.scheme===p.scheme}return!1}e.$Rr=w;function v(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$Sr=v}),define(ae[260],ce([0,1,74,4,186,52,44,259]),function(Y,e,S,D,s,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=e.$Tr=void 0,e.$Tr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Ur={type:"string",enum:Array.from((0,S.$jk)(),k=>k.id),markdownEnumDescriptions:Array.from((0,S.$jk)(),k=>`$(${k.id})`)};const g={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$Ur},color:{description:(0,s.localize)(3,null),...e.$Tr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...g}},w={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...g}};function v(k){const u=k===2?"linux":k===1?"osx":"windows";return(0,s.localize)(7,null,(0,D.$h)(k),'```json\n"terminal.integrated.profile.'+u+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:v(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...g}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...g}},{type:"null"},l]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:v(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...g}},{type:"null"},l]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:v(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...g}},{type:"null"},l]}},"terminal.integrated.useWslProfiles":{description:(0,s.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){A.$Tn.as(M.$Yn.Configuration).registerConfiguration(y),p()}e.$Vr=h;let m;function p(k,u){const f=A.$Tn.as(M.$Yn.Configuration);let d;k&&(d=(0,P.$Pr)(k?.profiles,u));const $=m;m={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:k?.os===3?d?.values:void 0,markdownEnumDescriptions:k?.os===3?d?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:k?.os===2?d?.values:void 0,markdownEnumDescriptions:k?.os===2?d?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:k?.os===1?d?.values:void 0,markdownEnumDescriptions:k?.os===1?d?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[m],remove:$?[$]:[]})}e.$Wr=p}),define(ae[261],ce([0,1,26,13,35,9,4,36,25,12,21,126,257,256]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=e.$6r=e.$5r=void 0;function m(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$5r=m;async function p(i,n,c,b=P.env,R=w.Promises.exists){if(M.$ic(i))return await R(i)?i:void 0;if(n===void 0&&(n=P.cwd()),M.$mc(i)!=="."){const j=M.$jc(n,i);return await R(j)?j:void 0}const E=(0,s.$On)(b,"PATH");if(c===void 0&&(0,l.$Sf)(E)&&(c=E.split(M.$tc)),c===void 0||c.length===0){const j=M.$jc(n,i);return await R(j)?j:void 0}for(const j of c){let U;if(M.$ic(j)?U=M.$jc(j,i):U=M.$jc(n,j,i),await R(U))return U;if(A.$i){let F=U+".com";if(await R(F)||(F=U+".exe",await R(F)))return F}}const C=M.$jc(n,i);return await R(C)?C:void 0}e.$6r=p;function k(i,n,c,b,R){const I=A.$i&&(!n.windowsEnableConpty||m()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||I)return;const E=i.args,C=P.$dc==="win32"?M.$nc(i.executable).toLowerCase():M.$nc(i.executable),j=M.$mc(D.$yg.asFileUri("").fsPath);let U;const F={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(F.VSCODE_NONCE=n.shellIntegration.nonce),A.$i){if(C==="pwsh.exe"||C==="powershell.exe")return!E||o(E)?U=d.get(f.WindowsPwsh):t(E)&&(U=d.get(f.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,g.$Te)(U[U.length-1],j,""),n.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),{newArgs:U,envMixin:F}):void 0;b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(C){case"bash":return!E||E.length===0?U=d.get(f.Bash):r(E)&&(F.VSCODE_SHELL_LOGIN="1",u(n,F),U=d.get(f.Bash)),U?(U=[...U],U[U.length-1]=(0,g.$Te)(U[U.length-1],j),{newArgs:U,envMixin:F}):void 0;case"fish":{const V=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",J=M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return F.XDG_DATA_DIRS=`${V}:${J}`,u(n,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!E||o(E)?U=d.get(f.Pwsh):t(E)&&(U=d.get(f.PwshLogin)),U?(n.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),U=[...U],U[U.length-1]=(0,g.$Te)(U[U.length-1],j,""),{newArgs:U,envMixin:F}):void 0;case"zsh":{if(!E||E.length===0?U=d.get(f.Zsh):r(E)?(U=d.get(f.ZshLogin),u(n,F)):(E===d.get(f.Zsh)||E===d.get(f.ZshLogin))&&(U=E),!U)return;U=[...U],U[U.length-1]=(0,g.$Te)(U[U.length-1],j);let V;try{V=S.userInfo().username}catch{V="unknown"}const J=M.$jc(S.tmpdir(),`${V}-${R.applicationName}-zsh`);F.ZDOTDIR=J;const le=c?.ZDOTDIR??S.homedir()??"~";F.USER_ZDOTDIR=le;const re=[];return re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$jc(J,".zshrc")}),re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$jc(J,".zprofile")}),re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$jc(J,".zshenv")}),re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$jc(J,".zlogin")}),{newArgs:U,envMixin:F,filesToCopy:re}}}b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$7r=k;function u(i,n){if(A.$j&&i.environmentVariableCollections){const c=(0,y.$3r)(i.environmentVariableCollections),R=new h.$4r(c).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),I=[];if(R)for(const E of R)E.type===v.EnvironmentVariableMutatorType.Prepend&&I.push(E.value);I.length>0&&(n.VSCODE_PATH_PREFIX=I.join(""))}}var f;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(f||(f={}));const d=new Map;d.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(f.Zsh,["-i"]),d.set(f.ZshLogin,["-il"]),d.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const $=["-login","-l"],a=["-nol","-nologo"];function t(i){return typeof i=="string"?$.includes(i.toLowerCase()):i.length===1&&$.includes(i[0].toLowerCase())||i.length===2&&($.includes(i[0].toLowerCase())||$.includes(i[1].toLowerCase()))&&(a.includes(i[0].toLowerCase())||a.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?a.includes(i.toLowerCase()):i.length===0||i?.length===1&&a.includes(i[0].toLowerCase())}function r(i){return i==="string"&&$.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&$.includes(i[0].toLowerCase())}}),define(ae[262],ce([0,1,48,74,9,4,12,21,108,261,115]),function(Y,e,S,D,s,M,A,P,g,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=void 0;var v;(function(c){c.UnixShellsPath="/etc/shells"})(v||(v={}));let y,h=!0;function m(c,b,R,I,E=process.env,C,j,U,F){return C=C||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},M.$i?p(R,C,E,j,I.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:I.getValue("terminal.integrated.profiles.windows"),typeof b=="string"?b:I.getValue("terminal.integrated.defaultProfile.windows"),F,U):r(C,j,R,c&&typeof c=="object"?{...c}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof b=="string"?b:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,U,E)}e.$8r=m;async function p(c,b,R,I,E,C,j,U,F){const V=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),J=`${process.env.windir}\\${V?"Sysnative":"System32"}`;let le=!1;(0,l.$5r)()>=16299&&(le=!0),await d(U);const re=new Map;if(c){re.set("PowerShell",{source:"PowerShell",icon:D.$kk.terminalPowershell,isAutoDetected:!0}),re.set("Windows PowerShell",{path:`${J}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.$kk.terminalPowershell,isAutoDetected:!0}),re.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),re.set("Command Prompt",{path:`${J}\\cmd.exe`,icon:D.$kk.terminalCmd,isAutoDetected:!0}),re.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),re.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:D.$kk.terminalBash,isAutoDetected:!0});const Z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;re.set("Cmder",{path:`${J}\\cmd.exe`,args:["/K",Z],requiresPath:process.env.CMDER_ROOT?Z:{path:Z,isUnsafe:!0},isAutoDetected:!0})}i(C,re);const ue=await k(re.entries(),j,b,R,I,F);if(c&&E)try{const Z=await t(`${J}\\${le?"wsl":"bash"}.exe`,j);for(const X of Z)(!C||!(X.profileName in C))&&ue.push(X)}catch{h&&(I?.trace("WSL is not installed, so could not detect WSL profiles"),h=!1)}return ue}async function k(c,b,R,I=process.env,E,C){const j=[];for(const[U,F]of c)j.push(u(U,F,b,R,I,E,C));return(await Promise.all(j)).filter(U=>!!U)}async function u(c,b,R,I,E=process.env,C,j){if(b===null)return;let U,F,V;if("source"in b&&!("path"in b)){const ue=y?.get(b.source);if(!ue)return;U=ue.paths,F=b.args||ue.args,b.icon?V=f(b.icon):ue.icon&&(V=ue.icon)}else U=Array.isArray(b.path)?b.path:[b.path],F=M.$i||Array.isArray(b.args)?b.args:void 0,V=f(b.icon);let J;if(j){const ue=U.map(X=>typeof X=="string"?X:X.path),Z=await j(ue);J=new Array(U.length);for(let X=0;X<U.length;X++)typeof U[X]=="string"?J[X]=Z[X]:J[X]={path:Z[X],isUnsafe:!0}}else J=U.slice();let le;if(b.requiresPath){let ue;if((0,A.$Sf)(b.requiresPath)?ue=b.requiresPath:(ue=b.requiresPath.path,b.requiresPath.isUnsafe&&(le=ue)),!await I.existsFile(ue))return}const re=await n(c,R,J,I,E,F,b.env,b.overrideName,b.isAutoDetected,le);if(!re){C?.debug("Terminal profile not validated",c,U);return}return re.isAutoDetected=b.isAutoDetected,re.icon=V,re.color=b.color,re}function f(c){return typeof c=="string"?{id:c}:c}async function d(c){if(y&&!c)return;const[b,R]=await Promise.all([$(),c||a()]);y=new Map,y.set("Git Bash",{profileName:"Git Bash",paths:b,args:["--login","-i"]}),y.set("PowerShell",{profileName:"PowerShell",paths:R,icon:D.$kk.terminalPowershell})}async function $(){const c=new Set,b=await(0,l.$6r)("git.exe");if(b){const E=(0,w.dirname)(b);c.add((0,w.resolve)(E,"../.."))}function R(E,C){C&&E.add(C)}R(c,process.env.ProgramW6432),R(c,process.env.ProgramFiles),R(c,process.env["ProgramFiles(X86)"]),R(c,`${process.env.LocalAppData}\\Program`);const I=[];for(const E of c)I.push(`${E}\\Git\\bin\\bash.exe`,`${E}\\Git\\usr\\bin\\bash.exe`,`${E}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function a(){const c=[];for await(const b of(0,g.$1l)())c.push(b.exePath);return c}async function t(c,b){const R=[],I=await new Promise((j,U)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,V)=>{if(F)return U("Problem occurred when getting wsl distros");j(V)})});if(!I)return[];const E=new RegExp(/[\r?\n]/),C=I.split(E).filter(j=>j.trim().length>0&&j!=="");for(const j of C){if(j===""||j.startsWith("docker-desktop"))continue;const U=`${j} (WSL)`,F={profileName:U,path:c,args:["-d",`${j}`],isDefault:U===b,icon:o(j),isAutoDetected:!1};R.push(F)}return R}function o(c){return c.includes("Ubuntu")?D.$kk.terminalUbuntu:c.includes("Debian")?D.$kk.terminalDebian:D.$kk.terminalLinux}async function r(c,b,R,I,E,C,j,U){const F=new Map;if(R&&await c.existsFile("/etc/shells")){const V=(await c.readFile("/etc/shells")).toString(),J=(C||V.split(`
`)).map(re=>{const ue=re.indexOf("#");return ue===-1?re:re.substring(0,ue)}).filter(re=>re.trim().length>0),le=new Map;for(const re of J){let ue=(0,s.$nc)(re),Z=le.get(ue)||0;Z++,Z>1&&(ue=`${ue} (${Z})`),le.set(ue,Z),F.set(ue,{path:re,isAutoDetected:!0})}}return i(I,F),await k(F.entries(),E,c,U,b,j)}function i(c,b){if(c)for(const[R,I]of Object.entries(c))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?b.delete(R):(I.icon=I.icon||b.get(R)?.icon,b.set(R,I))}async function n(c,b,R,I,E,C,j,U,F,V){if(R.length===0)return Promise.resolve(void 0);const J=R.shift();if(J==="")return n(c,b,R,I,E,C,j,U,F);const le=typeof J!="string"&&J.isUnsafe,re=typeof J=="string"?J:J.path,ue={profileName:c,path:re,args:C,env:j,overrideName:U,isAutoDetected:F,isDefault:c===b,isUnsafePath:le,requiresUnsafePath:V};if((0,s.$nc)(re)===re){const X=E.PATH?E.PATH.split(s.$tc):void 0,q=await(0,l.$6r)(re,void 0,X,void 0,I.existsFile);return q?(ue.path=q,ue.isFromPath=!0,ue):n(c,b,R,I,E,C)}return await I.existsFile((0,s.$hc)(re))?ue:n(c,b,R,I,E,C,j,U,F)}}),define(ae[263],ce([0,1,3,2,4,43,18,5,226,94,258,127,260,262,110,72]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0;var k;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(k||(k={}));let u=class extends D.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(d,$,a,t){super(),this.M=d,this.N=$,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$5d),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$5d),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$5d),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$5d),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$5d),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$5d),this.onProcessData=this.D.event,this.F=this.B(new S.$5d),this.onProcessReady=this.F.event,this.G=this.B(new S.$5d),this.onProcessReplay=this.G.event,this.H=this.B(new S.$5d),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$5d),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$5d),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$5d),this.onProcessExit=this.L.event,(0,y.$Vr)(),this.B(this.M),this.B((0,D.$Rc)(()=>this.W())),this.j=this.B(new w.$Or(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,l.$km)(this.N,this.O,{_:[]},process.env)}catch(d){return this.O.error("ptyHost was unable to resolve shell environment",d),{}}}U(){const d=this.M.start(),$=d.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService($.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(d.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=k.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=M.ProxyChannel.toService($.getChannel(v.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new g.$Nr(this.P,$.getChannel(v.TerminalIpcChannels.Logger))),this.a=d,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[d,t]}async createProcess(d,$,a,t,o,r,i,n,c,b,R){const I=setTimeout(()=>this.$(),v.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(d,$,a,t,o,r,i,n,c,b,R);return clearTimeout(I),E}updateTitle(d,$,a){return this.f.updateTitle(d,$,a)}updateIcon(d,$,a,t){return this.f.updateIcon(d,$,a,t)}attachToProcess(d){return this.f.attachToProcess(d)}detachFromProcess(d,$){return this.f.detachFromProcess(d,$)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(d){return this.f.start(d)}shutdown(d,$){return this.f.shutdown(d,$)}input(d,$){return this.f.input(d,$)}processBinary(d,$){return this.f.processBinary(d,$)}resize(d,$,a){return this.f.resize(d,$,a)}clearBuffer(d){return this.f.clearBuffer(d)}acknowledgeDataEvent(d,$){return this.f.acknowledgeDataEvent(d,$)}setUnicodeVersion(d,$){return this.f.setUnicodeVersion(d,$)}getInitialCwd(d){return this.f.getInitialCwd(d)}getCwd(d){return this.f.getCwd(d)}async getLatency(){const d=new p.$1d,$=await this.f.getLatency();return d.stop(),[{label:"ptyhostservice<->ptyhost",latency:d.elapsed()},...$]}orphanQuestionReply(d){return this.f.orphanQuestionReply(d)}installAutoReply(d,$){return this.f.installAutoReply(d,$)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(d){return this.f.uninstallAutoReply(d)}getDefaultSystemShell(d){return this.g?.getDefaultSystemShell(d)??(0,m.$7l)(d??s.OS,process.env)}async getProfiles(d,$,a,t=!1){const o=await this.S();return(0,h.$8r)($,a,t,this.N,o,void 0,this.O,this.bb.bind(this,d))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(d,$){return this.f.getWslPath(d,$)}getRevivedPtyNewId(d,$){return this.f.getRevivedPtyNewId(d,$)}setTerminalLayoutInfo(d){return this.f.setTerminalLayoutInfo(d)}async getTerminalLayoutInfo(d){return this.g?.getTerminalLayoutInfo(d)}async requestDetachInstance(d,$){return this.f.requestDetachInstance(d,$)}async acceptDetachInstanceReply(d,$){return this.f.acceptDetachInstanceReply(d,$)}async freePortKillProcess(d){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(d)}async serializeTerminalState(d){return this.f.serializeTerminalState(d)}async reviveTerminalProcesses(d,$,a){return this.f.reviveTerminalProcesses(d,$,a)}async refreshProperty(d,$){return this.f.refreshProperty(d,$)}async updateProperty(d,$,a){return this.f.updateProperty(d,$,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(d){this.ab(),this.s=setTimeout(()=>this.Y(),d?v.HeartbeatConstants.ConnectingBeatInterval:v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(d,$){return this.j.createRequest({workspaceId:d,originalText:$})}async acceptPtyHostResolvedVariables(d,$){this.j.acceptReply(d,$)}};e.$9r=u,e.$9r=u=ve([se(1,A.$Ki),se(2,P.$yj),se(3,P.$zj)],u)}),define(ae[69],ce([0,1,15,3,2,4,18,6,34]),function(Y,e,S,D,s,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s$b=e.$r$b=void 0;const l="#FFFFFF",w="#1E1E1E",v="#000000",y="#FFFFFF",h="theme",m="themeBackground",p="windowSplash";e.$r$b=(0,P.$ei)("themeMainService");let k=class extends s.$Tc{constructor(f,d){super(),this.b=f,this.c=d,this.a=this.B(new D.$5d),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration($=>{$.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(D.Event.fromNodeEventEmitter(S.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":S.nativeTheme.themeSource="dark";break;case"light":S.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":S.nativeTheme.themeSource="light";break;case"vs-dark":S.nativeTheme.themeSource="dark";break;default:S.nativeTheme.themeSource="system"}break;default:S.nativeTheme.themeSource="system";break}}getColorScheme(){if(M.$i){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?v:y;let d=this.b.getItem(m,null);if(!d)switch(this.g()){case"vs":d=l;break;case"hc-black":d=v;break;case"hc-light":d=y;break;default:d=w}return M.$j&&d.toUpperCase()===w&&(d="#171717"),d}g(){switch(this.b.getItem(h,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(f,d){this.b.setItems([{key:h,data:d.baseTheme},{key:m,data:d.colorInfo.background},{key:p,data:d}]),typeof f=="number"&&this.h(f,d),this.f()}h(f,d){for(const $ of S.BrowserWindow.getAllWindows())if($.id===f){$.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(p)}};e.$s$b=k,e.$s$b=k=ve([se(0,g.$sP),se(1,A.$Ki)],k)}),define(ae[128],ce([0,1,3,18,6,5]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.$Pv=e.ProvidedOnAutoForward=e.$Ov=e.TunnelPrivacyId=e.TunnelProtocol=e.$Nv=e.$Mv=void 0,e.$Mv=(0,s.$ei)("tunnelService"),e.$Nv=(0,s.$ei)("sharedTunnelsService");var A;(function(k){k.Http="http",k.Https="https"})(A||(e.TunnelProtocol=A={}));var P;(function(k){k.ConstantPrivate="constantPrivate",k.Private="private",k.Public="public"})(P||(e.TunnelPrivacyId=P={}));function g(k){return!!k.forwardPort}e.$Ov=g;var l;(function(k){k[k.Notify=1]="Notify",k[k.OpenBrowser=2]="OpenBrowser",k[k.OpenPreview=3]="OpenPreview",k[k.Silent=4]="Silent",k[k.Ignore=5]="Ignore",k[k.OpenBrowserOnce=6]="OpenBrowserOnce"})(l||(e.ProvidedOnAutoForward=l={}));function w(k){if(k.scheme!=="http"&&k.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(k.authority);if(u)return{address:u[1],port:+u[2]}}e.$Pv=w,e.$Qv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(k){return e.$Qv.indexOf(k)>=0}e.$Rv=v,e.$Sv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(k){return e.$Sv.indexOf(k)>=0}e.$Tv=y;function h(k,u,f,d){if(f===1)return!1;if(f===2&&y(u)){const $=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if($?.length===4&&parseInt($[1])>=18)return!1}return k<1024}e.$Uv=h;class m{constructor(u,f,d){this.remoteAddress=u,this.localAddress=f,this.b=d,this.a=new S.$5d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Vv=m;let p=class{constructor(u,f){this.k=u,this.l=f,this.a=new S.$5d,this.onTunnelOpened=this.a.event,this.b=new S.$5d,this.onTunnelClosed=this.b.event,this.c=new S.$5d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const u=this.l.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.f=u,u?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.g=u.elevation,this.i=u.privacyOptions,this.h=u.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const u=[],f=Array.from(this.e.values());for(const d of f){const $=Array.from(d.values());for(const a of $){const t=await a.value;t&&typeof t!="string"&&u.push(t)}}return u}async dispose(){for(const u of this.e.values()){for(const{value:f}of u.values())await f.then(d=>typeof d!="string"?d?.dispose():void 0);u.clear()}this.e.clear()}setEnvironmentTunnel(u,f,d,$,a){this.q(u,f,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:f,localAddress:d,privacy:$,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,f){(y(u)||v(u))&&(u=e.$Qv[0]);const d=this.s(u,f);if(d)return++d.refcount,d.value}openTunnel(u,f,d,$,a,t=!1,o,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${d} on local port ${a}.`);const i=this.f??u;if(!i)return;if(f||(f="localhost"),$||($=this.m),this.f&&this.j.has(d)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.t(i,f,d,$,a,t,o,r);return n?n.then(c=>{if(c){if(typeof c=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(f,d),c}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(f,d);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.o(c);return(c.tunnelRemoteHost!==f||c.tunnelRemotePort!==d)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&c.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}o(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const f=this.e.get(u.tunnelRemoteHost);if(f){const d=f.get(u.tunnelRemotePort);d&&(d.refcount--,await this.p(u.tunnelRemoteHost,u.tunnelRemotePort,d))}}}}async p(u,f,d){if(d.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${f}.`);const $=d.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(u)&&this.e.get(u).delete(f),$}}async closeTunnel(u,f){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${f} `);const d=this.e.get(u);if(d&&d.has(f)){const $=d.get(f);$.refcount=0,await this.p(u,f,$)}}q(u,f,d){this.e.has(u)||this.e.set(u,new Map),this.e.get(u).set(f,{refcount:1,value:d})}async r(u,f){const d=this.e.get(u);if(d){const $=d.get(f),a=$?await $.value:void 0;(!a||typeof a=="string")&&d.delete(f),d.size===0&&this.e.delete(u)}}s(u,f){const d=[u];v(u)?(d.push(...e.$Qv),d.push(...e.$Sv)):y(u)&&d.push(...e.$Sv);const $=d.map(a=>this.e.get(a));for(const a of $){const t=a?.get(f);if(t)return t}}canTunnel(u){return!!w(u)}u(u,f,d,$,a,t,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${d} on local port ${$}.`);const r=d;this.j.add(r);const i=$===void 0?d:$,n={elevationRequired:a?this.isPortPrivileged(i):!1},c={remoteAddress:{host:f,port:d},localAddressPort:$,privacy:t,public:t?t!==P.Private:void 0,protocol:o},b=u.forwardPort(c,n);return b?(this.q(f,d,b),b.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),b}};e.$Wv=p,e.$Wv=p=ve([se(0,M.$yj),se(1,D.$Ki)],p)}),define(ae[49],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zW=e.$yW=e.DisablementReason=e.UpdateType=e.StateType=void 0;var D;(function(A){A.Uninitialized="uninitialized",A.Idle="idle",A.Disabled="disabled",A.CheckingForUpdates="checking for updates",A.AvailableForDownload="available for download",A.Downloading="downloading",A.Downloaded="downloaded",A.Updating="updating",A.Ready="ready"})(D||(e.StateType=D={}));var s;(function(A){A[A.Setup=0]="Setup",A[A.Archive=1]="Archive",A[A.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(A){A[A.NotBuilt=0]="NotBuilt",A[A.DisabledByEnvironment=1]="DisabledByEnvironment",A[A.ManuallyDisabled=2]="ManuallyDisabled",A[A.MissingConfiguration=3]="MissingConfiguration",A[A.InvalidConfiguration=4]="InvalidConfiguration",A[A.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$yW={Uninitialized:{type:"uninitialized"},Disabled:A=>({type:"disabled",reason:A}),Idle:(A,P)=>({type:"idle",updateType:A,error:P}),CheckingForUpdates:A=>({type:"checking for updates",explicit:A}),AvailableForDownload:A=>({type:"available for download",update:A}),Downloading:A=>({type:"downloading",update:A}),Downloaded:A=>({type:"downloaded",update:A}),Updating:A=>({type:"updating",update:A}),Ready:A=>({type:"ready",update:A})},e.$zW=(0,S.$ei)("updateService")}),define(ae[264],ce([0,1,4,188,52,44]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$Tn.as(s.$Yn.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:S.$i&&!S.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ae[265],ce([0,1,3,49]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E_b=e.$D_b=void 0;class s{constructor(P){this.a=P}listen(P,g){switch(g){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${g}`)}call(P,g,l){switch(g){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${g}`)}}e.$D_b=s;class M{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new S.$5d,this.onStateChange=this.a.event,this.b=D.$yW.Uninitialized,this.c.listen("onStateChange")(g=>this.state=g),this.c.call("_getInitialState").then(g=>this.state=g)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$E_b=M}),define(ae[40],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=void 0,e.$_k=(0,S.$ei)("IUriIdentityService")}),define(ae[266],ce([0,1,40,207,16,19,141,3,2]),function(Y,e,S,D,s,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0;class l{static{this._clock=0}constructor(y){this.uri=y,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let w=class{constructor(y){this.g=y,this.c=new g.$Sc,this.f=2**16;const h=new Map,m=p=>{let k=h.get(p.scheme);return k===void 0&&(k=y.hasProvider(p)&&!this.g.hasCapability(p,1024),h.set(p.scheme,k)),k};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(p=>{h.delete(p.scheme)})),this.extUri=new M.$Gg(m),this.d=new A.$_r((p,k)=>this.extUri.compare(p,k,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,M.$Sg)(y));const h=this.d.get(y);return h?h.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new l(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((m,p)=>m[1].time<p[1].time?1:m[1].time>p[1].time?-1:0);l._clock=0,this.d.clear();const h=this.f*.5;for(let m=0;m<h;m++)this.d.set(y[m][0],y[m][1].touch())}};e.$as=w,e.$as=w=ve([se(0,s.$Bk)],w),(0,D.$0r)(S.$_k,w,1)}),define(ae[129],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pW=void 0,e.$pW=(0,S.$ei)("urlService")}),define(ae[267],ce([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N_b=e.$M_b=e.$L_b=void 0;class D{constructor(P){this.a=P}listen(P,g){throw new Error(`Event not found: ${g}`)}call(P,g,l){switch(g){case"handleURL":return this.a.handleURL(S.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${g}`)}}e.$L_b=D;class s{constructor(P){this.a=P}handleURL(P,g){return this.a.call("handleURL",[P.toJSON(),g])}}e.$M_b=s;class M{constructor(P,g){this.a=P,this.b=g}async routeCall(P,g,l,w){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(Array.isArray(l)&&l.length>0){const v=S.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const y=/\bwindowId=(\d+)/.exec(v.query);if(y){const h=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${h}"`,v.toString(!0));const m=new RegExp(`window:${h}`),p=P.connections.find(k=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",k.ctx),m.test(k.ctx)));if(p)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),p;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,g,l,w)}routeEvent(P,g){throw new Error(`Event not found: ${g}`)}}e.$N_b=M}),define(ae[268],ce([0,1,8,2,7,27]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rW=e.$qW=void 0;class A extends D.$Tc{constructor(){super(...arguments),this.a=new Set}open(l,w){const v=[...this.a.values()];return(0,S.$ih)(v.map(y=>()=>y.handleURL(l,w)),void 0,!1).then(y=>y||!1)}registerHandler(l){return this.a.add(l),(0,D.$Rc)(()=>this.a.delete(l))}}e.$qW=A;let P=class extends A{constructor(l){super(),this.b=l}create(l){let{authority:w,path:v,query:y,fragment:h}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return w&&v&&v.indexOf("/")!==0&&(v=`/${v}`),s.URI.from({scheme:this.b.urlProtocol,authority:w,path:v,query:y,fragment:h})}};e.$rW=P,e.$rW=P=ve([se(0,M.$Qj)],P)}),define(ae[269],ce([0,1,15,8,3,2,4,7]),function(Y,e,S,D,s,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O_b=void 0;class g extends M.$Tc{constructor(w,v,y,h,m,p){if(super(),this.c=v,this.f=p,this.a=[],this.b=0,w&&(p.trace("ElectronURLListener initialUrisToHandle:",w.map(f=>f.originalUrl)),this.a=w),A.$i){const f=h.isBuilt?[]:[`"${h.appRoot}"`];f.push("--open-url","--"),S.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,f)}const k=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(f,d)=>({event:f,url:d})),({event:f,url:d})=>(f.preventDefault(),d));this.B(k(f=>{const d=this.g(f);d&&this.c.open(d,{originalUrl:f})})),y.getWindows().filter(f=>f.isReady).length>0?(p.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(p.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(y.onDidSignalReadyWindow)(()=>this.h())))}g(w){try{return P.URI.parse(w)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const w=[];for(const v of this.a)await this.c.open(v.uri,{originalUrl:v.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),w.push(v));w.length!==0&&(this.a=w,(0,D.$gh)(()=>this.h(),500,this.q))}}e.$O_b=g}),define(ae[270],ce([0,1,3,2,16,59,31]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0;class P extends D.$Tc{constructor(l,w,v,y,h,m){super(),this.f=l,this.g=w,this.h=v,this.j=y,this.m=h,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$5d),this.onDidChangeFile=this.a.event,this.b=M.$ki.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,w){return this.g.open(this.t(l),w)}close(l){return this.g.close(l)}read(l,w,v,y,h){return this.g.read(l,w,v,y,h)}write(l,w,v,y,h){return this.g.write(l,w,v,y,h)}watch(l,w){this.b.set(l,l);const v=this.g.watch(this.t(l),w);return(0,D.$Rc)(()=>{this.b.delete(l),v.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,w,v){return this.g.rename(this.t(l),this.t(w),v)}readFile(l,w){return this.g.readFile(this.t(l),w)}readFileStream(l,w,v){return this.g.readFileStream(this.t(l),w,v)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,w,v){return this.g.writeFile(this.t(l),w,v)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,w){return this.g.delete(this.t(l),w)}copy(l,w,v){if((0,s.$Fk)(this.g))return this.g.copy(this.t(l),this.t(w),v);throw new Error("copy not supported")}cloneFile(l,w){if((0,s.$Gk)(this.g))return this.g.cloneFile(this.t(l),this.t(w));throw new Error("clone not supported")}s(l){const w=[];for(const v of l){if(v.resource.scheme!==this.f)continue;const y=this.u(v.resource);this.b.findSubstr(y)&&w.push({resource:y,type:v.type,cId:v.cId})}w.length&&(this.n.debug("User data changed"),this.a.fire(w))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$pac=P}),define(ae[271],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9_b=void 0,e.$9_b="utilityProcessWorker"}),define(ae[272],ce([0,1,6]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P_b=void 0,e.$P_b=(0,S.$ei)("webviewManagerService")}),define(ae[273],ce([0,1,15,2,13,7]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=void 0;class A extends D.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const g=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,g)}b(g,l){try{const w=M.URI.parse(g.url),v=A.a.get(w.path);if(typeof v=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${v}`,h=s.$yg.asFileUri(y);return l({path:h.fsPath,headers:{...s.COI.getHeadersFromQuery(g.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$Q_b=A}),define(ae[55],ce([0,1,4]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=e.$0C=e.$9C=e.$8C=e.$7C=e.$6C=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$5C=e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=void 0,e.$ZC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(u){return typeof u.parentId=="number"}e.$1C=D;function s(u){return!!u.workspaceUri}e.$2C=s;function M(u){return!!u.folderUri}e.$3C=M;function A(u){return!!u.fileUri}e.$4C=A;function P(u){const f=y(u),d=u.getValue("window.menuBarVisibility");return d==="default"||f&&d==="compact"||S.$j&&S.$m?"classic":d}e.$5C=P;var g;(function(u){u.TITLE_BAR_STYLE="window.titleBarStyle",u.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(g||(e.TitleBarSetting=g={}));var l;(function(u){u.NATIVE="native",u.CUSTOM="custom"})(l||(e.TitlebarStyle=l={}));var w;(function(u){u.AUTO="auto",u.WINDOWED="windowed",u.NEVER="never"})(w||(e.CustomTitleBarVisibility=w={}));function v(u,f){return!0}e.$6C=v;function y(u,f){return f||(f=h(u)),f==="native"}e.$7C=y;function h(u){if(S.$o)return"custom";const f=u.getValue("window");if(f){if(S.$j&&f.nativeTabs===!0||S.$j&&f.nativeFullScreen===!1)return"native";const a=f.titleBarStyle;if(a==="native"||a==="custom")return a}return S.$k?"native":"custom"}e.$8C=h;function m(u){return!(!S.$i||S.$o||y(u))}e.$9C=m;function p(u){const f=u.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}e.$0C=p;function k(u=0){return Math.pow(1.2,u)}e.$$C=k}),define(ae[96],ce([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$h$b=e.UnloadReason=e.LoadReason=void 0;var S;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var D;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(D||(e.UnloadReason=D={}));const s=function(P=1){return{width:1024,height:768,mode:P}};e.$h$b=s;var M;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var A;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(A||(e.WindowError=A={}))}),define(ae[274],ce([0,1,8,3,2]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W_b=void 0;class M extends s.$Tc{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:g,getActiveWindowId:l}){super(),this.a=this.B(new s.$Sc),D.Event.latch(D.Event.any(P,g))(this.f,this,this.a),this.b=(0,S.$4g)(()=>l()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$W_b=M}),define(ae[30],ce([0,1,192,9,59,19,7,6,13]),function(Y,e,S,D,s,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.WorkbenchState=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0,e.$ni=(0,P.$ei)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.$oi=l;function w(i){return typeof i?.id=="string"&&!l(i)&&!y(i)}e.$pi=w,e.$qi={id:"ext-dev"},e.$ri={id:"empty-window"};function v(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$nc)(i)}:n?e.$qi:e.$ri;const c=i;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.$si=v;function y(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.$ti=y;function h(i){const n=i;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const c=i;if(c?.configPath)return{id:c.id,configPath:A.URI.revive(c.configPath)};if(i?.id)return{id:i.id}}e.$ui=h;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$vi=p;function k(i){const n=i;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$wi=k;class u{constructor(n,c,b,R,I){this.h=n,this.j=b,this.k=R,this.l=I,this.c=s.$ki.forUris(this.l,()=>!0),this.folders=c}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$ki.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$xi=u;class f{constructor(n,c){this.raw=c,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$Rg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$yi=f;function d(i){return new f({uri:i,index:0,name:(0,M.$Ng)(i)},{uri:i.toString()})}e.$zi=d,e.$Ai="code-workspace",e.$Bi=`.${e.$Ai}`,e.$Ci=[{name:(0,S.localize)(0,null),extensions:[e.$Ai]}],e.$Di="workspace.json";function $(i,n){return M.$Ig.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$Ei=$;function a(i){let n;return A.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.$Fi=a,e.$Gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Gi}e.$Hi=t;function o(i,n){return!$(i,n)&&!a(i)}e.$Ii=o;function r(i){return(typeof i=="string"?(0,D.$oc)(i):(0,M.$Pg)(i))===e.$Bi}e.$Ji=r}),define(ae[56],ce([0,1,15,8,45,47,2,85,4,21,167,117,6,5,27,30]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p$b=e.$o$b=void 0,e.$o$b=(0,y.$ei)("dialogMainService");let k=class{constructor(f,d){this.d=f,this.e=d,this.a=new Map,this.b=new Map,this.c=new D.$lh}pickFileFolder(f,d){return this.f({...f,pickFolders:!0,pickFiles:!0,title:(0,w.localize)(0,null)},d)}pickFolder(f,d){return this.f({...f,pickFolders:!0,title:(0,w.localize)(1,null)},d)}pickFile(f,d){return this.f({...f,pickFiles:!0,title:(0,w.localize)(2,null)},d)}pickWorkspace(f,d){const $=(0,w.localize)(3,null),a=(0,M.$cw)((0,w.localize)(4,null)),t=p.$Ci;return this.f({...f,pickFiles:!0,title:$,filters:t,buttonLabel:a},d)}async f(f,d){const $={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&($.properties=void 0,f.pickFiles&&f.pickFolders&&($.properties=["multiSelections","openDirectory","openFile","createDirectory"])),$.properties||($.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),g.$j&&$.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog($,(d||S.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(f){if(f){let d=this.b.get(f.id);return d||(d=new D.$lh,this.b.set(f.id,d)),d}else return this.c}showMessageBox(f,d){return this.g(d).queue(async()=>{const{options:$,buttonIndeces:a}=(0,v.$jw)(f,this.e);let t;return d?t=await S.dialog.showMessageBox(d,$):t=await S.dialog.showMessageBox($),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(f,d){const $=this.j(f,d);if(!$)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(d).queue(async()=>{let a;return d?a=await S.dialog.showSaveDialog(d,f):a=await S.dialog.showSaveDialog(f),a.filePath=this.h(a.filePath),a})}finally{(0,A.$Oc)($)}}h(f){return f&&g.$j&&(f=(0,P.$Rl)(f)),f}i(f){return f.map(d=>this.h(d))}async showOpenDialog(f,d){f.defaultPath&&(await l.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const $=this.j(f,d);if(!$)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(d).queue(async()=>{let a;return d?a=await S.dialog.showOpenDialog(d,f):a=await S.dialog.showOpenDialog(f),a.filePaths=this.i(a.filePaths),a})}finally{(0,A.$Oc)($)}}j(f,d){if(!d)return A.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",f);let $=this.a.get(d.id);$||($=new Set,this.a.set(d.id,$));const a=(0,s.$5i)(f);if(!$.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",f),$.add(a),(0,A.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",f),$?.delete(a),$?.size===0&&this.a.delete(d.id)})}};e.$p$b=k,e.$p$b=k=ve([se(0,h.$yj),se(1,m.$Qj)],k)}),define(ae[275],ce([0,1,3,2,76,30]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=void 0;class A extends D.$Tc{static{this.a=100}constructor(g,l){super(),this.f=g,this.g=l,this.b=this.B(new S.$5d),this.c=new Map,this.h(l.applicationStorage,this.b)}h(g,l){this.B(S.Event.debounce(g.onDidChangeStorage,(w,v)=>(w?w.push(v):w=[v],w),A.a)(w=>{w.length&&l.fire(this.j(w,g))}))}j(g,l){const w=new Map,v=new Set;return g.forEach(y=>{const h=l.get(y.key);typeof h=="string"?w.set(y.key,h):v.add(y.key)}),{changed:Array.from(w.entries()),deleted:Array.from(v.values())}}listen(g,l,w){switch(l){case"onDidChangeStorage":{const v=w.profile?(0,s.$Nh)(w.profile):void 0;if(!v)return this.b.event;let y=this.c.get(v.id);return y||(y=this.B(new S.$5d),this.h(this.g.profileStorage(v),y),this.c.set(v.id,y)),y.event}}throw new Error(`Event not found: ${l}`)}async call(g,l,w){const v=w.profile?(0,s.$Nh)(w.profile):void 0,y=(0,M.$ui)(w.workspace),h=await this.m(v,y);switch(l){case"getItems":return Array.from(h.items.entries());case"updateItems":{const m=w;if(m.insert)for(const[p,k]of m.insert)h.set(p,k);m.delete?.forEach(p=>h.delete(p));break}case"optimize":return h.optimize();case"isUsed":{const m=w.payload;if(typeof m=="string")return this.g.isUsed(m)}default:throw new Error(`Call not found: ${l}`)}}async m(g,l){let w;l?w=this.g.workspaceStorage(l):g?w=this.g.profileStorage(g):w=this.g.applicationStorage;try{await w.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":g?"profile":"application"} storage due to ${v}`)}return w}}e.$A_b=A}),define(ae[41],ce([0,1,45,3,2,19,7,189,38,16,6,5,30,31,40,8,32,25,12]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.ProfileResourceType=void 0;var d;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function $(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.$al=$,e.$bl=(0,w.$ei)("IUserDataProfilesService");function a(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:n}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$cl=a;function t(i,n,c,b,R,I){return{id:i,name:n,location:c,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:I&&R?.useDefaultFlags?.globalState?I.globalStorageHome:(0,M.$Rg)(c,"globalStorage"),settingsResource:I&&R?.useDefaultFlags?.settings?I.settingsResource:(0,M.$Rg)(c,"settings.json"),keybindingsResource:I&&R?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,M.$Rg)(c,"keybindings.json"),tasksResource:I&&R?.useDefaultFlags?.tasks?I.tasksResource:(0,M.$Rg)(c,"tasks.json"),snippetsHome:I&&R?.useDefaultFlags?.snippets?I.snippetsHome:(0,M.$Rg)(c,"snippets"),extensionsResource:I&&R?.useDefaultFlags?.extensions?I.extensionsResource:(0,M.$Rg)(c,"extensions.json"),cacheHome:(0,M.$Rg)(b,i),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}e.$dl=t;let o=class extends s.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,c,b,R){super(),this.t=n,this.u=c,this.w=b,this.y=R,this.f=!0,this.h=this.B(new D.$5d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$5d),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$5d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$5d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$Ac,emptyWindows:new Map},this.profilesHome=(0,M.$Rg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$Rg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),c=[n];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,f.$Sf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}c.push(t((0,M.$Og)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.y.error(I)}const b=new h.$Ac,R=new Map;if(c.length)try{const I=this.Q();if(I.workspaces)for(const[E,C]of Object.entries(I.workspaces)){const j=A.URI.parse(E),U=c.find(F=>F.id===C);U&&b.set(j,U)}if(I.emptyWindows)for(const[E,C]of Object.entries(I.emptyWindows)){const j=c.find(U=>U.id===C);j&&R.set(E,j)}}catch(I){this.y.error(I)}this.z={profiles:c,workspaces:b,emptyWindows:R}}return this.z}D(){const n=t("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const c="Temp",b=new RegExp(`${(0,u.$Xe)(c)}\\s(\\d+)`);let R=0;for(const E of this.profiles){const C=b.exec(E.name),j=C?parseInt(C[1]):0;R=j>R?j:R}const I=`${c} ${R+1}`;return this.createProfile((0,S.$5i)((0,k.$Ag)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,c,b){return this.createProfile((0,S.$5i)((0,k.$Ag)()).toString(16),n,c,b)}async createProfile(n,c,b,R){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(n,c,b);return R&&await this.setProfileForWorkspace(R,I),I}async F(n,c,b){if(!(0,f.$Sf)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.r.get(c);return R||(R=(async()=>{try{const I=this.profiles.find(j=>j.name===c||j.id===n);if(I)return I;const E=t(n,c,(0,M.$Rg)(this.profilesHome,n),this.g,b,this.defaultProfile);await this.u.createFolder(E.location);const C=[];return this.j.fire({profile:E,join(j){C.push(j)}}),await p.Promises.settled(C),this.I([E],[],[]),E}finally{this.r.delete(c)}})(),this.r.set(c,R)),R}async updateProfile(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(R=>R.id===n.id);if(!b)throw new Error(`Profile '${n.name}' does not exist`);return b=t(b.id,c.name??b.name,b.location,this.g,{shortName:c.shortName??b.shortName,icon:c.icon===null?void 0:c.icon??b.icon,transient:c.transient??b.isTransient,useDefaultFlags:c.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(R=>R.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);const b=[];this.m.fire({profile:c,join(R){b.push(R)}});try{await Promise.allSettled(b)}catch(R){this.y.error(R)}for(const R of[...this.C.emptyWindows.keys()])c.id===this.C.emptyWindows.get(R)?.id&&this.C.emptyWindows.delete(R);for(const R of[...this.C.workspaces.keys()])c.id===this.C.workspaces.get(R)?.id&&this.C.workspaces.delete(R);this.M(),this.I([],[c],[]);try{await this.u.del(c.cacheHome,{recursive:!0})}catch(R){(0,l.$Sk)(R)!==1&&this.y.error(R)}}async setProfileForWorkspace(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(R=>R.id===c.id);if(!b)throw new Error(`Profile '${c.name}' does not exist`);this.L(n,b)}unsetWorkspace(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,c)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(c=>c.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,c.resource))).map(c=>this.u.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(c=>!this.H(c));await Promise.allSettled(n.map(c=>this.removeProfile(c)))}getProfileForWorkspace(n){const c=this.G(n);return A.URI.isUri(c)?this.s.workspaces.get(c)??this.C.workspaces.get(c):this.s.emptyWindows.get(c)??this.C.emptyWindows.get(c)}G(n){return(0,y.$oi)(n)?n.uri:(0,y.$ti)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.s.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.C.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.C.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,n.location)))}I(n,c,b){const R=[...this.profiles,...n],I=[];this.s.profiles=[];for(let E of R)E.isDefault||c.some(C=>E.id===C.id)||(E=b.find(C=>E.id===C.id)??E,E.isTransient?this.s.profiles.push(E):I.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(I),this.z=void 0,this.J(n,c,b)}J(n,c,b){this.h.fire({added:n,removed:c,updated:b,all:this.profiles})}L(n,c,b){b=c?.isTransient?!0:b,b||this.L(n,void 0,!0);const R=this.G(n),I=b?this.s:this.C;A.URI.isUri(R)?(I.workspaces.delete(R),c&&I.workspaces.set(R,c)):(I.emptyWindows.delete(R),c&&I.emptyWindows.set(R,c)),b||this.M()}M(){const n={};for(const[b,R]of this.C.workspaces.entries())n[b.toString()]=R.id;const c={};for(const[b,R]of this.C.emptyWindows.entries())c[b.toString()]=R.id;this.R({workspaces:n,emptyWindows:c}),this.z=void 0}N(n){const c={},b=this.D();if(n.workspaces)for(const[I,E]of Object.entries(n.workspaces)){const C=A.URI.parse(E);c[I]=this.w.extUri.isEqual(C,b.location)?b.id:this.w.extUri.basename(C)}const R={};if(n.emptyWindows)for(const[I,E]of Object.entries(n.emptyWindows)){const C=A.URI.parse(E);R[I]=this.w.extUri.isEqual(C,b.location)?b.id:this.w.extUri.basename(C)}return{workspaces:c,emptyWindows:R}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$el=o,e.$el=o=ve([se(0,g.$li),se(1,l.$Bk),se(2,m.$_k),se(3,v.$yj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$fl=r}),define(ae[81],ce([0,1,8,17,2,3,31,7,119,125,16,6,5,41,40,12,14,28]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=e.$6p=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class d extends Error{constructor(r,i){super(r),this.code=i}}e.$6p=d,e.$7p=(0,v.$ei)("IExtensionsProfileScannerService");let $=class extends s.$Tc{constructor(r,i,n,c,b,R){super(),this.j=r,this.m=i,this.n=n,this.r=c,this.s=b,this.t=R,this.b=this.B(new M.$5d),this.onAddExtensions=this.b.event,this.c=this.B(new M.$5d),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$5d),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$5d),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],c=[];try{return await this.u(i,b=>{const R=[];for(const I of b)r.some(([E])=>(0,l.$_o)(E.identifier,I.identifier)&&E.manifest.version!==I.version)?n.push(I):R.push(I);for(const[I,E]of r){const C=R.findIndex(U=>(0,l.$_o)(U.identifier,I.identifier)&&U.version===I.manifest.version),j={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:E};C===-1?(c.push(j),R.push(j)):R.splice(C,1,j)}return c.length&&this.b.fire({extensions:c,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),R}),c.length&&this.c.fire({extensions:c,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),c}catch(b){throw c.length&&this.c.fire({extensions:c,error:b,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:b,profileLocation:i}),b}}async updateMetadata(r,i){const n=[];return await this.u(i,c=>{const b=[];for(const R of c){const I=r.find(([E])=>(0,l.$_o)(E.identifier,R.identifier)&&E.manifest.version===R.version);I&&(R.metadata={...R.metadata,...I[1]},n.push(R)),b.push(R)}return b}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,c=>{const b=[];for(const R of c)(0,l.$_o)(R.identifier,r.identifier)?n.push(R):b.push(R);return n.length&&this.f.fire({extensions:n,profileLocation:i}),b}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(c){throw n.length&&this.g.fire({extensions:n,error:c,profileLocation:i}),c}}async u(r,i,n){return this.F(r).queue(async()=>{let c=[],b;try{const R=await this.m.readFile(r);b=JSON.parse(R.value.toString().trim()||"[]")}catch(R){if((0,w.$Sk)(R)!==1)throw R;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&n?.bailOutWhenFileNotFound)throw new d((0,k.$0)(R),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(r);let R=!1;for(const I of b){a(I)||this.w(r);let E;if((0,p.$Sf)(I.relativeLocation)&&I.relativeLocation)E=this.z(I.relativeLocation);else if((0,p.$Sf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{E=P.URI.revive(I.location);const C=this.y(E);C&&(R=!0,I.relativeLocation=C)}(0,p.$Zf)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(R=!0,I.metadata.hasPreReleaseVersion=!0),c.push({identifier:I.identifier,location:E,version:I.version,metadata:I.metadata})}R&&await this.m.writeFile(r,D.$se.fromString(JSON.stringify(b)))}if(i){c=i(c);const R=c.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,D.$se.fromString(JSON.stringify(R)))}return c})}w(r){const i=new d(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(b){if((0,w.$Sk)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",r.toString());let c;try{const b=JSON.parse(n);Array.isArray(b)&&b.every(R=>a(R))?c=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(c)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$se.fromString(JSON.stringify(c)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,w.$Sk)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(r)}catch(b){(0,w.$Sk)(b)!==1&&this.t.error(b)}try{await this.m.del(i)}catch(b){(0,w.$Sk)(b)!==1&&this.t.error(b)}return c})()),this.C}F(r){let i=this.h.get(r);return i||(i=new S.$lh,this.h.set(r,i)),i}};e.$8p=$,e.$8p=$=ve([se(1,w.$Bk),se(2,h.$bl),se(3,m.$_k),se(4,u.$Fl),se(5,y.$yj)],$);function a(o){return(0,p.$Uf)(o)&&(0,g.$Jo)(o.identifier)&&(t(o.location)||(0,p.$Sf)(o.location)&&o.location)&&((0,p.$Zf)(o.relativeLocation)||(0,p.$Sf)(o.relativeLocation))&&o.version&&(0,p.$Sf)(o.version)}function t(o){return o?(0,p.$Sf)(o.path)&&(0,p.$Sf)(o.scheme):!1}}),define(ae[130],ce([0,1,22,8,35,17,14,42,152,2,13,9,4,19,205,73,12,7,172,38,125,122,204,16,6,5,27,3,76,81,41,40,203]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d,$,a,t,o,r,i,n,c,b,R,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.Translations=void 0;var j;(function(ue){function Z(X,q){if(X===q)return!0;const L=Object.keys(X),T=new Set;for(const G of Object.keys(q))T.add(G);if(L.length!==T.size)return!1;for(const G of L){if(X[G]!==q[G])return!1;T.delete(G)}return T.size===0}ue.equals=Z})(j||(e.Translations=j={})),e.$$p=(0,r.$ei)("IExtensionsScannerService");let U=class extends l.$Tc{constructor(Z,X,q,L,T,G,B,oe,he,K,O,W){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=X,this.r=q,this.s=L,this.t=T,this.u=G,this.w=B,this.y=oe,this.z=he,this.C=K,this.D=O,this.F=W,this.g=this.B(new c.$5d),this.onDidChangeCache=this.g.event,this.h=(0,h.$Rg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(J,this.s,this.h)),this.m=this.B(this.F.createInstance(J,this.s,this.h)),this.n=this.B(this.F.createInstance(V,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,$.$kp)(this.w,this.y)),this.G}async scanAllExtensions(Z,X,q){const[L,T]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(X)]),G=q?await this.scanExtensionsUnderDevelopment(Z,[...L,...T]):[];return this.L(L,T,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const X=[];X.push(this.M(!!Z.useCache,Z.language)),X.push(this.N(Z.language,!!Z.checkControlFile));const[q,L]=await Promise.all(X);return this.J([...q,...L],0,Z,!1)}async scanUserExtensions(Z){const X=Z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const q=this.D.extUri.isEqual(Z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(X,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,q),T=Z.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let G;try{G=await T.scanExtensions(L)}catch(B){if(B instanceof R.$6p&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await T.scanExtensions(L);else throw B}return G=await this.J(G,1,Z,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Z,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===w.Schemas.file).map(async L=>{const T=await this.P(L,!1,1,!0,Z.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(T)).map(B=>(B.type=X.find(oe=>(0,$.$_o)(oe.identifier,B.identifier))?.type??B.type,this.n.validate(B,T)))}))).flat();return this.J(q,"development",Z,!0)}return[]}async scanExistingExtension(Z,X,q){const L=await this.P(Z,!1,X,!0,q.language,!0,void 0),T=await this.n.scanExtension(L);return!T||!q.includeInvalid&&!T.isValid?null:T}async scanOneOrMultipleExtensions(Z,X,q){const L=await this.P(Z,!1,X,!0,q.language,!0,void 0),T=await this.n.scanOneOrMultipleExtensions(L);return this.J(T,X,q,!0)}async scanMetadata(Z){const X=(0,h.$Rg)(Z,"package.json"),q=(await this.w.readFile(X)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(Z,X){const q=(0,h.$Rg)(Z,"package.json"),L=(await this.w.readFile(q)).value.toString(),T=JSON.parse(L);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,T.__metadata={...T.__metadata,...X},await this.w.writeFile((0,h.$Rg)(Z,"package.json"),M.$se.fromString(JSON.stringify(T,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof R.$6p&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.u.addExtensionsToProfile(Z.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$se.fromString(JSON.stringify([])))}catch(X){(0,o.$Sk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.y.error(Z)}finally{this.H=void 0}})()),this.H}async J(Z,X,q,L){return q.includeAllVersions||(Z=this.L(X===0?Z:void 0,X===1?Z:void 0,X==="development"?Z:void 0,await this.getTargetPlatform(),L)),q.includeInvalid||(Z=Z.filter(T=>T.isValid)),Z.sort((T,G)=>{const B=v.$nc(T.location.fsPath),oe=v.$nc(G.location.fsPath);return B<oe?-1:B>oe?1:0})}L(Z,X,q,L,T){const G=(oe,he,K)=>{if(oe.isValid&&!he.isValid)return!1;if(oe.isValid===he.isValid){if(T&&m.gt(oe.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(m.eq(oe.manifest.version,he.manifest.version)){if(oe.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`),!0},B=new a.$ym;return Z?.forEach(oe=>{const he=B.get(oe.identifier.id);(!he||G(he,oe,!1))&&B.set(oe.identifier.id,oe)}),X?.forEach(oe=>{const he=B.get(oe.identifier.id);if(!he&&Z&&oe.type===0){this.y.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!he||G(he,oe,!1))&&B.set(oe.identifier.id,oe)}),q?.forEach(oe=>{const he=B.get(oe.identifier.id);(!he||G(he,oe,!0))&&B.set(oe.identifier.id,oe),B.set(oe.identifier.id,oe)}),[...B.values()]}async M(Z,X){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),T=await(Z&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",T.length),T}async N(Z,X){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const L=X?await this.O():{},T=[],G=u.URI.file(v.$hc(v.$jc(w.$yg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of q){const he=L[oe.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":T.push((0,h.$Rg)(G,oe.name));break;default:T.push(u.URI.file(he));break}}const B=await Promise.all(T.map(async oe=>this.n.scanExtension(await this.P(oe,!1,0,!0,Z,!0,void 0))));return this.y.trace("Scanned dev system extensions:",B.length),(0,S.$Hb)(B)}async O(){try{const Z=await this.w.readFile(this.r);return JSON.parse(Z.value.toString())}catch{return{}}}async P(Z,X,q,L,T,G,B){const oe=await this.f(T??y.$w),he=await this.Q(Z),K=X&&!this.D.extUri.isEqual(Z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=K?await this.Q(K):void 0;return new F(Z,he,K,O,X,B,q,L,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,T,oe)}async Q(Z){try{const X=await this.w.stat(Z);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$_p=U,e.$_p=U=ve([se(4,I.$bl),se(5,R.$7p),se(6,o.$Bk),se(7,i.$yj),se(8,d.$li),se(9,n.$Qj),se(10,E.$_k),se(11,r.$di)],U);class F{constructor(Z,X,q,L,T,G,B,oe,he,K,O,W,x,N,Q){this.location=Z,this.mtime=X,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=L,this.profile=T,this.profileScanOptions=G,this.type=B,this.excludeObsolete=oe,this.validate=he,this.productVersion=K,this.productDate=O,this.productCommit=W,this.devMode=x,this.language=N,this.translations=Q}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,X){return(0,h.$Kg)(Z.location,X.location)&&Z.mtime===X.mtime&&(0,h.$Kg)(Z.applicationExtensionslocation,X.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&Z.profile===X.profile&&s.$Ln(Z.profileScanOptions,X.profileScanOptions)&&Z.type===X.type&&Z.excludeObsolete===X.excludeObsolete&&Z.validate===X.validate&&Z.productVersion===X.productVersion&&Z.productDate===X.productDate&&Z.productCommit===X.productCommit&&Z.devMode===X.devMode&&Z.language===X.language&&j.equals(Z.translations,X.translations)}}e.$aq=F;let V=class extends l.$Tc{constructor(Z,X,q,L,T){super(),this.f=Z,this.g=X,this.h=q,this.j=L,this.m=T}async scanExtensions(Z){const X=Z.profile?await this.r(Z):await this.n(Z);let q={};if(Z.excludeObsolete&&Z.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(L)}catch{}return(0,k.$6f)(q)?X:X.filter(L=>!q[$.$ap.create(L).toString()])}async n(Z){const X=await this.j.resolve(Z.location);if(!X.children?.length)return[];const q=await Promise.all(X.children.map(async L=>{if(!L.isDirectory||Z.type===1&&(0,h.$Og)(L.resource).indexOf(".")===0)return null;const T=new F(L.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(T)}));return(0,S.$Hb)(q).sort((L,T)=>L.location.path<T.location.path?-1:1)}async r(Z){let X=await this.s(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){X=X.filter(L=>!L.metadata?.isApplicationScoped);const q=await this.s(Z.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,Z);X.push(...q)}return X}async s(Z,X,q){const L=await this.g.scanProfileExtensions(Z,q.profileScanOptions);if(!L.length)return[];const T=await Promise.all(L.map(async G=>{if(X(G)){const B=new F(G.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B,G.metadata)}return null}));return(0,S.$Hb)(T)}async scanOneOrMultipleExtensions(Z){try{if(await this.j.exists((0,h.$Rg)(Z.location,"package.json"))){const X=await this.scanExtension(Z);return X?[X]:[]}else return await this.scanExtensions(Z)}catch(X){return this.m.error(`Error scanning extensions at ${Z.location.path}:`,(0,A.$0)(X)),[]}}async scanExtension(Z,X){try{let q=await this.scanExtensionManifest(Z.location);if(q){q.publisher||(q.publisher=a.$sm),X=X??q.__metadata,delete q.__metadata;const L=(0,$.$ep)(q.publisher,q.name),T=X?.id?{id:L,uuid:X.id}:{id:L},G=X?.isSystem?0:Z.type,B=G===0||!!X?.isBuiltin;q=await this.t(Z.location,q,F.createNlsConfiguration(Z));const oe={type:G,identifier:T,manifest:q,location:Z.location,isBuiltin:B,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return Z.validate?this.validate(oe,Z):oe}}catch(q){Z.type!==0&&this.m.error(q)}return null}validate(Z,X){let q=!0;const L=(0,t.$pp)(X.productVersion,X.productDate,X.location,Z.manifest,Z.isBuiltin);for(const[T,G]of L)T===p.default.Error&&(q=!1,this.m.error(this.z(X.location,G)));return Z.isValid=q,Z.validations=L,Z}async scanExtensionManifest(Z){const X=(0,h.$Rg)(Z,"package.json");let q;try{q=(await this.j.readFile(X)).value.toString()}catch(T){return(0,o.$Sk)(T)!==1&&this.m.error(this.z(Z,(0,f.localize)(0,null,X.path,T.message))),null}let L;try{L=JSON.parse(q)}catch{const G=[];(0,P.$on)(q,G);for(const B of G)this.m.error(this.z(Z,(0,f.localize)(1,null,X.path,B.offset,B.length,(0,g.$9p)(B.error))));return null}return(0,P.$xn)(L)!=="object"?(this.m.error(this.z(Z,(0,f.localize)(2,null,X.path))),null):L}async t(Z,X,q){const L=await this.u(Z,X,q);if(L)try{const T=[],G=await this.w(L.default,T);if(T.length>0)return T.forEach(oe=>{this.m.error(this.z(Z,(0,f.localize)(3,null,L.default?.path,(0,g.$9p)(oe.error))))}),X;if((0,P.$xn)(L)!=="object")return this.m.error(this.z(Z,(0,f.localize)(4,null,L.default?.path))),X;const B=L.values||Object.create(null);return(0,C.$0p)(this.m,X,B,G)}catch{}return X}async u(Z,X,q){const L=(0,h.$Rg)(Z,"package.nls.json"),T=(he,K)=>{K.forEach(O=>{this.m.error(this.z(Z,(0,f.localize)(5,null,he?.path,(0,g.$9p)(O.error))))})},G=he=>{this.m.error(this.z(Z,(0,f.localize)(6,null,he?.path)))},B=`${X.publisher}.${X.name}`,oe=q.translations[B];if(oe)try{const he=u.URI.file(oe),K=(await this.j.readFile(he)).value.toString(),O=[],W=(0,P.$on)(K,O);return O.length>0?(T(he,O),{values:void 0,default:L}):(0,P.$xn)(W)!=="object"?(G(he),{values:void 0,default:L}):{values:W.contents?W.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let K;try{K=await this.y(Z,q)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const O=(await this.j.readFile(K.localized)).value.toString(),W=[],x=(0,P.$on)(O,W);return W.length>0?(T(K.localized,W),{values:void 0,default:K.original}):(0,P.$xn)(x)!=="object"?(G(K.localized),{values:void 0,default:K.original}):{values:x,default:K.original}}catch{return{values:void 0,default:K.original}}}}async w(Z,X){if(Z)try{const q=(await this.j.readFile(Z)).value.toString();return(0,P.$on)(q,X)}catch{}}y(Z,X){return new Promise((q,L)=>{const T=G=>{const B=(0,h.$Rg)(Z,`package.nls.${G}.json`);this.j.exists(B).then(oe=>{oe&&q({localized:B,original:(0,h.$Rg)(Z,"package.nls.json")});const he=G.lastIndexOf("-");he===-1?q({localized:(0,h.$Rg)(Z,"package.nls.json"),original:null}):(G=G.substring(0,he),T(G))})};if(X.devMode||X.pseudo||!X.language)return q({localized:(0,h.$Rg)(Z,"package.nls.json"),original:null});T(X.language)})}z(Z,X){return`[${Z.path}]: ${X}`}};V=ve([se(1,R.$7p),se(2,E.$_k),se(3,o.$Bk),se(4,i.$yj)],V);let J=class extends V{constructor(Z,X,q,L,T,G,B){super(X,L,T,G,B),this.G=Z,this.H=q,this.D=this.B(new D.$ch(3e3)),this.F=this.B(new c.$5d),this.onDidChangeCache=this.F.event}async scanExtensions(Z){const X=this.M(Z),q=await this.I(X);if(this.C=Z,q&&q.input&&F.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",Z.location.toString()),this.D.trigger(()=>this.L()),q.result.map(T=>(T.location=u.URI.revive(T.location),T));const L=await super.scanExtensions(Z);return await this.J(X,{input:Z,result:L}),L}async I(Z){try{const X=await this.j.readFile(Z),q=JSON.parse(X.value.toString());return{result:q.result,input:(0,b.$Nh)(q.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",Z.path,(0,A.$0)(X))}return null}async J(Z,X){try{await this.j.writeFile(Z,M.$se.fromString(JSON.stringify(X)))}catch(q){this.m.debug("Error while writing the extension cache file:",Z.path,(0,A.$0)(q))}}async L(){if(!this.C)return;const Z=this.M(this.C),X=await this.I(Z);if(!X)return;const q=X.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$Ln(L,q))try{this.m.info("Invalidating Cache",q,L),await this.j.del(Z),this.F.fire()}catch(T){this.m.error(T)}}M(Z){const X=this.N(Z);return this.h.extUri.joinPath(X.cacheHome,Z.type===0?a.$rm:a.$qm)}N(Z){return Z.type===0?this.H.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(Z.location,X.extensionsResource))??this.G:this.H.defaultProfile}};J=ve([se(2,I.$bl),se(3,R.$7p),se(4,E.$_k),se(5,o.$Bk),se(6,i.$yj)],J);function le(ue,Z){const X=(0,$.$cp)(ue.manifest.publisher,ue.manifest.name);return{id:X,identifier:new a.$wm(X),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Z,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.$bq=le;class re extends U{constructor(Z,X,q,L,T,G,B,oe,he,K,O,W){super(Z,X,(0,h.$Rg)(q,".vscode-oss-dev","extensions","control.json"),L,T,G,B,oe,he,K,O,W),this.R=(async()=>{if(y.$z)try{const x=await this.w.readFile(u.URI.file(y.$z));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.R}}e.$cq=re}),define(ae[276],ce([0,1,5,41,40,28,81,16,38,7]),function(Y,e,S,D,s,M,A,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=void 0;let w=class extends A.$8p{constructor(y,h,m,p,k,u){super(l.URI.file(y.extensionsPath),h,m,p,k,u)}};e.$zP=w,e.$zP=w=ve([se(0,g.$mi),se(1,P.$Bk),se(2,D.$bl),se(3,s.$_k),se(4,M.$Fl),se(5,S.$yj)],w)}),define(ae[277],ce([0,1,7,38,81,130,16,6,5,27,40,41]),function(Y,e,S,D,s,M,A,P,g,l,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1_b=void 0;let y=class extends M.$cq{constructor(m,p,k,u,f,d,$,a){super(S.URI.file(f.builtinExtensionsPath),S.URI.file(f.extensionsPath),f.userHome,m.defaultProfile,m,p,k,u,f,d,$,a)}};e.$1_b=y,e.$1_b=y=ve([se(0,v.$bl),se(1,s.$7p),se(2,A.$Bk),se(3,g.$yj),se(4,D.$mi),se(5,l.$Qj),se(6,w.$_k),se(7,P.$di)],y)}),define(ae[278],ce([0,1,15,2,13,9,4,59,7,32,37,38,5,41]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=void 0;let m=class extends D.$Tc{constructor(k,u,f){super(),this.c=k,this.f=f,this.a=P.$ki.forPaths(!A.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(k.appRoot),this.addValidFileRoot(k.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(k.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:k}=S.session;k.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(u,f)=>this.j(u,f)),k.protocol.interceptFileProtocol(s.Schemas.file,(u,f)=>this.h(u,f)),this.B((0,D.$Rc)(()=>{k.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),k.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(k){const u=(0,M.$hc)(k);return this.a.get(u)?D.$Tc.None:(this.a.set(u,!0),(0,D.$Rc)(()=>this.a.delete(u)))}h(k,u){const f=g.URI.parse(k.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${s.Schemas.file}: protocol (original URL: ${k.url})`),u({error:-3})}j(k,u){const f=this.m(k);let d;return this.c.crossOriginIsolated&&((0,M.$nc)(f)==="workbench.html"||(0,M.$nc)(f)==="workbench-dev.html"?d=s.COI.CoopAndCoep:d=s.COI.getHeadersFromQuery(k.url)),this.a.findSubstr(f)?u({path:f,headers:d}):this.b.has((0,M.$oc)(f).toLowerCase())?u({path:f}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${k.url})`),u({error:-3}))}m(k){const u=g.URI.parse(k.url),f=s.$yg.uriToFileUri(u);return(0,M.$hc)(f.fsPath)}createIPCObjectUrl(){let k;const u=g.URI.from({scheme:"vscode",path:(0,l.$Ag)()}),f=u.toString(),d=async()=>k;return w.$AV.handle(f,d),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:u,update:$=>k=$,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),w.$AV.removeHandler(f)}}}};e.$gac=m,e.$gac=m=ve([se(0,v.$mi),se(1,h.$bl),se(2,y.$yj)],m)}),define(ae[97],ce([0,1,8,3,2,67,12,113,6,41]),function(Y,e,S,D,s,M,A,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Fp=e.$Ep=e.$Dp=void 0,e.$Dp="__$__isNewStorageMarker",e.$Ep="__$__targetStorageMarker",e.$Fp=(0,g.$ei)("storageService");var w;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(w||(e.WillSaveStateReason=w={}));var v;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var y;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function h(f){const d=f.get(e.$Ep);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.$Gp=h;class m extends s.$Tc{static{this.a=60*1e3}constructor(d={flushInterval:m.a}){super(),this.m=d,this.b=this.B(new D.$8d),this.c=this.B(new D.$8d),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$5d),this.onWillSaveState=this.f.event,this.h=this.B(new S.$qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,$,a){return D.Event.filter(this.b.event,t=>t.scope===d&&($===void 0||t.key===$),a)}n(){this.j.value=(0,S.$uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,$){const{key:a,external:t}=$;if(a===e.$Ep){switch(d){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:a,target:this.J(d)[a],external:t})}w(d){this.f.fire({reason:d})}get(d,$,a){return this.P($)?.get(d,a)}getBoolean(d,$,a){return this.P($)?.getBoolean(d,a)}getNumber(d,$,a){return this.P($)?.getNumber(d,a)}getObject(d,$,a){return this.P($)?.getObject(d,a)}storeAll(d,$){this.y(()=>{for(const a of d)this.store(a.key,a.value,a.scope,a.target,$)})}store(d,$,a,t,o=!1){if((0,A.$2f)($)){this.remove(d,a,o);return}this.y(()=>{this.z(d,a,t),this.P(a)?.set(d,$,o)})}remove(d,$,a=!1){this.y(()=>{this.z(d,$,void 0),this.P($)?.delete(d,a)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,$){const a=[],t=this.J(d);for(const o of Object.keys(t))t[o]===$&&a.push(o);return a}z(d,$,a,t=!1){const o=this.J($);typeof a=="number"?o[d]!==a&&(o[d]=a,this.P($)?.set(e.$Ep,JSON.stringify(o),t)):typeof o[d]=="number"&&(delete o[d],this.P($)?.set(e.$Ep,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(d){switch(d){case-1:return this.I;case 0:return this.G;default:return this.D}}L(d){const $=this.P(d);return $?h($):Object.create(null)}isNew(d){return this.getBoolean(e.$Dp,d)===!0}async flush(d=w.NONE){this.f.fire({reason:d});const $=this.P(-1),a=this.P(0),t=this.P(1);switch(d){case w.NONE:await S.Promises.settled([$?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await S.Promises.settled([$?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(-1)?.items??new Map,$=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return u(d,$,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,$){return this.w(w.NONE),(0,l.$al)(d)?this.R(d,$):this.S(d,$)}M(d,$){return!(d.id===$.id||p($)&&p(d))}N(d,$,a){this.y(()=>{const t=new Set;for(const[o,r]of d)t.add(o),$.get(o)!==r&&this.u(a,{key:o,external:!0});for(const[o]of $.items)t.has(o)||this.u(a,{key:o,external:!0})})}}e.$Hp=m;function p(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$Ip=p;class k extends m{constructor(){super(),this.U=this.B(new P.$Bp(new P.$Cp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$Bp(new P.$Cp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$Bp(new P.$Cp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(1,d))),this.B(this.W.onDidChangeStorage(d=>this.u(0,d))),this.B(this.U.onDidChangeStorage(d=>this.u(-1,d)))}P(d){switch(d){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$Jp=k;async function u(f,d,$,a,t,o){const r=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,n=new Map;f.forEach((j,U)=>{i.set(U,j),n.set(U,r(j))});const c=new Map,b=new Map;d.forEach((j,U)=>{c.set(U,j),b.set(U,r(j))});const R=new Map,I=new Map;$.forEach((j,U)=>{R.set(U,j),I.set(U,r(j))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const E=[];if(i.forEach((j,U)=>{E.push({key:U,value:j})}),console.table(E),console.groupEnd(),console.log(n),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];c.forEach((U,F)=>{j.push({key:F,value:U})}),console.table(j),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${o})`);const C=[];R.forEach((j,U)=>{C.push({key:U,value:j})}),console.table(C),console.groupEnd(),console.log(I)}e.$Kp=u}),define(ae[279],ce([0,1,22,8,3,2,9,72,7,21,113,161,5,97,28,30,13]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R$b=e.$Q$b=e.$P$b=e.$O$b=void 0;class u extends M.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$5d),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$5d),this.onDidCloseStorage=this.c.event,this.f=this.B(new w.$Bp(new w.$Cp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new D.$Bh,this.whenInit=this.h.p,this.j=w.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===w.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(h.$Dp);i===void 0?r.set(h.$Dp,!0):i&&r.set(h.$Dp,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=w.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===y.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new P.$1d(!1);await this.w(),r.stop(),r.elapsed()>u.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,S.top)(Array.from(this.f.items.entries()).map(([c,b])=>({key:c,length:b.length})),(c,b)=>b.length-c.length,5).map(c=>`${c.key}:${c.length}`).join(", "),n=(await this.n.stat(g.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=w.StorageState.Closed,await this.f.close()}}class f extends u{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,A.$jc)(this.z.globalStorageHome.with({scheme:k.Schemas.file}).fsPath,f.y)}constructor(r,i,n,c){super(n,c),this.z=r,this.C=i}async t(){return new w.$Bp(new v.$6V(this.path??v.$6V.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:w.StorageHint.STORAGE_IN_MEMORY})}}class d extends f{constructor(r,i,n,c){super(r,i,n,c)}}e.$O$b=d;class $ extends f{constructor(r,i,n,c){super(i.defaultProfile,r,n,c)}async s(r){await super.s(r),this.G(r)}G(r){r.get(m.$Il,void 0)===void 0&&r.set(m.$Il,new Date().toUTCString());const n=r.get(m.$Hl,void 0),c=new Date().toUTCString();r.set(m.$Jl,typeof n>"u"?null:n),r.set(m.$Hl,c)}}e.$P$b=$;class a extends u{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,A.$jc)(this.F.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,this.C.id,a.y)}constructor(r,i,n,c,b){super(n,b),this.C=r,this.D=i,this.F=c}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new w.$Bp(new v.$6V(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?w.StorageHint.STORAGE_IN_MEMORY:i?w.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:v.$6V.IN_MEMORY_PATH,wasCreated:!0};const r=(0,A.$jc)(this.F.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,this.C.id),i=(0,A.$jc)(r,a.y);return await l.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,p.$oi)(this.C)?i={folder:this.C.uri.toString()}:(0,p.$ti)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,A.$jc)(r,a.z);await l.Promises.exists(n)||await l.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$Q$b=a;class t extends u{get path(){}async t(){return new w.$Bp(new w.$Cp,{hint:w.StorageHint.STORAGE_IN_MEMORY})}}e.$R$b=t}),define(ae[280],ce([0,1,3,2,97]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=void 0;class M extends D.$Tc{constructor(P,g,l){super(),this.b=P,this.c=g,this.f=l;const w=this.B(new D.$Uc);this.a=this.B(new S.$5d({onWillAddFirstListener:()=>w.value=this.g(),onDidRemoveLastListener:()=>w.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new D.$Sc;return P.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(g,l)=>(g?g.push(l.key):g=[l.key],g),100)(g=>this.h(g))),P.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(g,l)=>{g||(g=new Map);let w=g.get(l.profile.id);return w||g.set(l.profile.id,w={profile:l.profile,keys:[],storage:l.storage}),w.keys.push(l.key),g},100)(g=>this.j(g))),P}h(P){const g=P.includes(s.$Ep)?[this.c.defaultProfile]:[],l=[];if(P=P.filter(w=>w!==s.$Ep),P.length){const w=(0,s.$Gp)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:P.map(v=>({key:v,scope:0,target:w[v]}))})}this.m(g,l)}j(P){const g=[],l=new Map;for(const[w,v]of P.entries()){v.keys.includes(s.$Ep)&&g.push(v.profile);const y=v.keys.filter(h=>h!==s.$Ep);if(y.length){const h=(0,s.$Gp)(v.storage.storage);l.set(w,{profile:v.profile,changes:y.map(m=>({key:m,scope:0,target:h[m]}))})}}this.m(g,[...l.values()])}m(P,g){(P.length||g.length)&&this.a.fire({valueChanges:g,targetChanges:P})}listen(P,g,l){switch(g){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${g}`)}async call(P,g){throw new Error(`Call not found: ${g}`)}}e.$3_b=M}),define(ae[281],ce([0,1,7,38,16,5,34,40,41,12,123]),function(Y,e,S,D,s,M,A,P,g,l,w){"use strict";var v,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.$xP=e.$wP=void 0;let h=class extends g.$el{static{v=this}static{this.a="profileAssociationsMigration"}constructor(u,f,d,$,a){super(d,$,f,a),this.U=u,this.W=d}O(){return this.U.getItem(v.b,[]).map(f=>({...f,location:(0,l.$Sf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):S.URI.revive(f.location)}))}Q(){const u=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$wP=h,e.$wP=h=v=ve([se(0,A.$rP),se(1,P.$_k),se(2,D.$mi),se(3,s.$Bk),se(4,M.$yj)],h);let m=y=class extends h{constructor(u,f,d,$,a){super(u,f,d,$,a),this.$=u}P(u){u.length?this.$.setItem(y.b,u.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(y.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(y.c,u):this.$.removeItem(y.c)}Q(){const u="workspaceAndProfileInfo",f=this.$.getItem(u,void 0);if(f){this.$.removeItem(u);const $=f.reduce((a,{workspace:t,profile:o})=>(a[S.URI.revive(t).toString()]=S.URI.revive(o).toString(),a),{});this.$.setItem(y.c,{workspaces:$})}const d=super.Q();return this.$.getItem(y.a,!1)||(this.R(d),this.$.setItem(y.a,!0)),d}};e.$xP=m,e.$xP=m=y=ve([se(0,A.$sP),se(1,P.$_k),se(2,D.$mi),se(3,s.$Bk),se(4,M.$yj)],m);let p=class extends m{constructor(u,f,d,$){super(new w.$vP(0,f,$,d),u,f,d,$)}async init(){return await this.$.init(),super.init()}};e.$yP=p,e.$yP=p=ve([se(0,P.$_k),se(1,D.$mi),se(2,s.$Bk),se(3,M.$yj)],p)}),define(ae[57],ce([0,1,38,16,6,5,40,41,281,34]),function(Y,e,S,D,s,M,A,P,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$b=e.$w$b=void 0,e.$w$b=(0,s.$fi)(P.$bl);let w=class extends g.$xP{constructor(y,h,m,p,k){super(y,h,m,p,k)}getAssociatedEmptyWindows(){const y=[];for(const h of this.C.emptyWindows.keys())y.push({id:h});return y}};e.$x$b=w,e.$x$b=w=ve([se(0,l.$sP),se(1,A.$_k),se(2,S.$mi),se(3,D.$Bk),se(4,M.$yj)],w)}),define(ae[131],ce([0,1,19,7,30]),function(Y,e,S,D,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A$b=e.$z$b=e.$y$b=void 0;async function M(g,l,w){for(const y of g){const h=y.openedWorkspace;if((0,s.$ti)(h)){const m=await w(h);if(m){if(m.folders.some(p=>S.$Ig.isEqualOrParent(l,p.uri)))return y}else if(S.$Ig.isEqualOrParent(l,h.configPath))return y}}const v=g.filter(y=>(0,s.$oi)(y.openedWorkspace)&&S.$Ig.isEqualOrParent(l,y.openedWorkspace.uri));if(v.length)return v.sort((y,h)=>-(y.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.$y$b=M;function A(g,l){for(const w of g)if((0,s.$ti)(w.openedWorkspace)&&S.$Ig.isEqual(w.openedWorkspace.configPath,l)||(0,s.$oi)(w.openedWorkspace)&&S.$Ig.isEqual(w.openedWorkspace.uri,l))return w}e.$z$b=A;function P(g,l){const w=v=>l.some(y=>S.$Ig.isEqual(D.URI.file(y),D.URI.file(v)));for(const v of g)if(v.config?.extensionDevelopmentPath?.some(y=>w(y)))return v}e.$A$b=P}),define(ae[98],ce([0,1,33,42,102,47,13,9,4,19,7,6,60,30]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ieb=e.$heb=e.$geb=e.$feb=e.$eeb=e.$deb=e.$ceb=e.$beb=e.$aeb=e.$_db=void 0,e.$_db=(0,v.$ei)("workspacesService");function m(I){return I.hasOwnProperty("workspace")}e.$aeb=m;function p(I){return I.hasOwnProperty("folderUri")}e.$beb=p;function k(I){return I.hasOwnProperty("fileUri")}e.$ceb=k;function u(I){return f(I)||d(I)}e.$deb=u;function f(I){const E=I;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function d(I){const E=I;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function $(I,E,C,j,U){if(I.scheme!==j.scheme)return{name:C,uri:I.toString(!0)};let F=E?void 0:U.relativePath(j,I);if(F!==void 0)F.length===0?F=".":g.$i&&(F=a(F));else if(I.scheme===A.Schemas.file)F=I.fsPath,g.$i&&(F=a(F));else if(U.isEqualAuthority(I.authority,j.authority))F=I.path;else return{name:C,uri:I.toString(!0)};return{name:C,path:F}}e.$eeb=$;function a(I){return I=(0,M.$9v)(I),(0,S.$cg)(I)||(I=(0,S.$_f)(I)),I}function t(I,E,C){const j=[],U=new Set,F=C.dirname(E);for(const V of I){let J;if(f(V))V.path&&(J=C.resolvePath(F,V.path));else if(d(V))try{J=w.URI.parse(V.uri),J.path[0]!==P.$gc.sep&&(J=J.with({path:P.$gc.sep+J.path}))}catch(le){console.warn(le)}if(J){const le=C.getComparisonKey(J);if(!U.has(le)){U.add(le);const re=V.name||C.basenameOrAuthority(J);j.push(new h.$yi({uri:J,name:re,index:j.length},V))}}}return j}e.$feb=t;function o(I,E,C,j,U){const F=r(E,I),V=U.dirname(E),J=U.dirname(j),le=[];for(const X of F.folders){const q=f(X)?U.resolvePath(V,X.path):w.URI.parse(X.uri);let L;C?L=!1:L=!f(X)||(0,P.$ic)(X.path),le.push($(q,L,X.name,J,U))}const re={insertSpaces:!1,tabSize:4,eol:g.$k||g.$j?`
`:`\r
`},ue=s.$Dn(I,["folders"],le,re);let Z=s.$Gn(I,ue);return(0,l.$Wg)(F.remoteAuthority,(0,y.$ll)(j))&&(Z=s.$Gn(Z,s.$Cn(Z,["remoteAuthority"],re))),Z}e.$geb=o;function r(I,E){const C=D.$on(E);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(j=>u(j));else throw new Error(`${I} looks like an invalid workspace file.`);return C}function i(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function n(I){return typeof I.folderUri=="string"}function c(I){return typeof I.fileUri=="string"}function b(I,E){const C={workspaces:[],files:[]};if(I){const j=function(F,V){for(let J=0;J<F.length;J++)try{V(F[J],J)}catch(le){E.warn(`Error restoring recent entry ${JSON.stringify(F[J])}: ${le.toString()}. Skip entry.`)}},U=I;Array.isArray(U.entries)&&j(U.entries,F=>{const V=F.label,J=F.remoteAuthority;i(F)?C.workspaces.push({label:V,remoteAuthority:J,workspace:{id:F.workspace.id,configPath:w.URI.parse(F.workspace.configPath)}}):n(F)?C.workspaces.push({label:V,remoteAuthority:J,folderUri:w.URI.parse(F.folderUri)}):c(F)&&C.files.push({label:V,remoteAuthority:J,fileUri:w.URI.parse(F.fileUri)})})}return C}e.$heb=b;function R(I){const E={entries:[]};for(const C of I.workspaces)p(C)?E.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):E.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of I.files)E.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return E}e.$ieb=R}),define(ae[99],ce([0,1,86,13,4,19]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=e.$D$b=e.$C$b=e.$B$b=void 0,e.$B$b=128/4;function A(l){function w(){let v=l.scheme===D.Schemas.file?(0,M.$Fg)(l):l.toString();return s.$k||(v=v.toLowerCase()),(0,S.createHash)("md5").update(v).digest("hex")}return{id:w(),configPath:l}}e.$C$b=A;function P(l,w){function v(){if(l.scheme!==D.Schemas.file)return(0,S.createHash)("md5").update(l.toString()).digest("hex");if(!w)return;let h;return s.$k?h=w.ino:s.$j?h=w.birthtime.getTime():s.$i&&(typeof w.birthtimeMs=="number"?h=Math.floor(w.birthtimeMs):h=w.birthtime.getTime()),(0,S.createHash)("md5").update(l.fsPath).update(h?String(h):"").digest("hex")}const y=v();if(typeof y=="string")return{id:y,uri:l}}e.$D$b=P;function g(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$E$b=g}),define(ae[100],ce([0,1,86,87,26,282,17,14,3,2,9,4,32,43,111]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=void 0;class p{traceSocketEvent(E,C){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,C)}constructor(E,C=""){this.f=!0,this.debugLabel=C,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,P.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const C=j=>{this.traceSocketEvent("read",j),E(A.$se.wrap(j))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(E){const C=j=>{E({type:0,hadError:j,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(E){const C=()=>{E()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,P.$1)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,P.$1)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$6h=p;var k;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(k||(k={}));var u;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(u||(u={}));class f extends l.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,C){this.socket.traceSocketEvent(E,C)}constructor(E,C,j,U){super(),this.f=this.B(new g.$5d),this.g=this.B(new g.$5d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:j?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new d(this,C,j,U,this.f,(F,V)=>this.m(F,V))),this.B(this.a.onError(F=>{console.error(F),(0,P.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new m.$1h,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await g.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let C=0;for(;C<E.byteLength;)this.a.writeMessage(E.slice(C,Math.min(C+262144,E.byteLength)),{compressed:!0,opcode:2}),C+=262144}m(E,{compressed:C,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let U=2;E.byteLength<126?U+=0:E.byteLength<2**16?U+=2:U+=8;const F=A.$se.alloc(U),V=C?64:0,J=j&15;if(F.writeUInt8(128|V|J,0),E.byteLength<126)F.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){F.writeUInt8(126,1);let le=1;F.writeUInt8(E.byteLength>>>8&255,++le),F.writeUInt8(E.byteLength>>>0&255,++le)}else{F.writeUInt8(127,1);let le=1;F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(E.byteLength>>>24&255,++le),F.writeUInt8(E.byteLength>>>16&255,++le),F.writeUInt8(E.byteLength>>>8&255,++le),F.writeUInt8(E.byteLength>>>0&255,++le)}this.socket.write(A.$se.concat([F,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const C=this.b.peek(this.j.readLen),j=C.readUInt8(0),U=(j&128)>>>7,F=(j&64)>>>6,V=j&15,J=C.readUInt8(1),le=(J&128)>>>7,re=J&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(re===126?2:0)+(re===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const C=this.b.read(this.j.readLen),j=C.readUInt8(1),U=(j&128)>>>7;let F=j&127,V=1;F===126?F=C.readUInt8(++V)*2**8+C.readUInt8(++V):F===127&&(F=C.readUInt8(++V)*0+C.readUInt8(++V)*0+C.readUInt8(++V)*0+C.readUInt8(++V)*0+C.readUInt8(++V)*2**24+C.readUInt8(++V)*2**16+C.readUInt8(++V)*2**8+C.readUInt8(++V));let J=0;U&&(J=C.readUInt8(++V)*2**24+C.readUInt8(++V)*2**16+C.readUInt8(++V)*2**8+C.readUInt8(++V)),this.j.state=3,this.j.readLen=F,this.j.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const C=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),t(C,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(C,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(C,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await g.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$7h=f;class d extends l.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$se.alloc(0)}constructor(E,C,j,U,F,V){super(),this.n=E,this.r=F,this.s=V,this.a=this.B(new g.$5d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new g.$5d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new g.$5d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,C?(this.b=this.B(new $(this.n,U,j,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(J=>this.a.fire(J))),this.B(this.f.onError(J=>this.a.fire(J)))):(this.b=null,this.f=null)}writeMessage(E,C){this.g.push({data:E,options:C}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:C}=this.g.shift();if(this.f&&C.compressed){const j=await this.w(this.f,E);this.s(j,C)}else this.s(E,{...C,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,C){return new Promise((j,U)=>{E.write(C),E.flush(F=>j(F))})}acceptFrame(E,C,j){this.h.push({data:E,isCompressed:C,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const C=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(C)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,C,j){return new Promise((U,F)=>{E.write(C),j&&E.write(A.$se.fromByteArray([0,0,255,255])),E.flush(V=>U(V))})}}class $ extends l.$Tc{get recordedInflateBytes(){return this.j?A.$se.concat(this.f):A.$se.alloc(0)}constructor(E,C,j,U){super(),this.h=E,this.j=C,this.a=this.B(new g.$5d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(U),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(A.$se.wrap(F))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const C=A.$se.concat(this.g);this.g.length=0,E(C)})}}class a extends l.$Tc{constructor(E,C){super(),this.g=E,this.a=this.B(new g.$5d),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(A.$se.wrap(j))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let C=A.$se.concat(this.f);this.f.length=0,C=C.slice(0,C.byteLength-4),E(C)})}}function t(I,E){if(E===0)return;const C=I.byteLength>>>2;for(let le=0;le<C;le++){const re=I.readUInt32BE(le*4);I.writeUInt32BE(re^E,le*4)}const j=C*4,U=I.byteLength-j,F=E>>>24&255,V=E>>>16&255,J=E>>>8&255;U>=1&&I.writeUInt8(I.readUInt8(j)^F,j),U>=2&&I.writeUInt8(I.readUInt8(j+1)^V,j+1),U>=3&&I.writeUInt8(I.readUInt8(j+2)^J,j+2)}e.$8h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function r(){const I=(0,y.$Ag)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const E=process.platform!=="darwin"&&e.$8h?e.$8h:(0,s.tmpdir)(),C=(0,w.$jc)(E,`vscode-ipc-${I}.sock`);return n(C),C}e.$9h=r;function i(I,E,C){const U=(0,S.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${C}-${E}-sock`;const F=C.substr(0,4),V=E.substr(0,6);let J;return process.platform!=="darwin"&&e.$8h&&!process.env.VSCODE_PORTABLE?J=(0,w.$jc)(e.$8h,`vscode-${U}-${F}-${V}.sock`):J=(0,w.$jc)(I,`${F}-${V}.sock`),n(J),J}e.$0h=i;function n(I){const E=o[v.$u];typeof E=="number"&&I.length>=E&&console.warn(`WARNING: IPC handle "${I}" is longer than ${E} chars, try a shorter --user-data-dir`)}class c extends h.$Uh{static b(E){const C=g.Event.fromNodeEventEmitter(E,"connection");return g.Event.map(C,j=>({protocol:new m.$2h(new p(j,"ipc-server-connection")),onDidClientDisconnect:g.Event.once(g.Event.fromNodeEventEmitter(j,"close"))}))}constructor(E){super(c.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$$h=c;function b(I){return new Promise((E,C)=>{const j=(0,D.createServer)();j.on("error",C),j.listen(I,()=>{j.removeListener("error",C),E(new c(j))})})}e.$_h=b;function R(I,E){return new Promise((C,j)=>{const U=(0,D.createConnection)(I,()=>{U.removeListener("error",j),C(m.$3h.fromSocket(new p(U,`ipc-client${E}`),E))});U.once("error",j)})}e.$ai=R}),define(ae[24],ce([0,1,50,9,4,100,38,90,6]),function(Y,e,S,D,s,M,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j$b=e.$i$b=void 0,e.$i$b=(0,g.$fi)(A.$li);class l extends P.$Nm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,D.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,D.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$0h)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,D.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const v in process.env)if(v.endsWith("_VSCODE_SNAP_ORIG")){const y=v.slice(0,-17);if(this.d[y])continue;process.env[y]&&(this.d[y]=process.env[y]),process.env[v]?process.env[y]=process.env[v]:delete process.env[y]}}}restoreSnapExportedVariables(){if(s.$k)for(const v in this.d)process.env[v]=this.d[v],delete this.d[v]}}e.$j$b=l,ve([S.$Ih],l.prototype,"cachedLanguagesPath",null),ve([S.$Ih],l.prototype,"backupHome",null),ve([S.$Ih],l.prototype,"mainIPCHandle",null),ve([S.$Ih],l.prototype,"mainLockfile",null),ve([S.$Ih],l.prototype,"disableUpdates",null),ve([S.$Ih],l.prototype,"crossOriginIsolated",null),ve([S.$Ih],l.prototype,"codeCachePath",null),ve([S.$Ih],l.prototype,"useCodeCache",null)}),define(ae[283],ce([0,1,86,33,13,9,4,19,21,196,18,24,34,16,5,195,30,99]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$X$b=void 0;let d=class{static{f=this}static{this.a="backupWorkspaces"}constructor(a,t,o,r){this.j=a,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$Ig,this.i={isEqual:(i,n)=>(0,D.$eg)(i,n,!A.$k)}}async initialize(){const a=this.m.getItem(f.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,l.$l$b)(a)),this.e=await this.v((0,l.$m$b)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==h.$1k.OFF}q(){return this.s()===h.$1k.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||h.$1k.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(r=>a.workspace.id===r.workspace.id)||(this.d.push(a),this.C());const o=(0,M.$jc)(this.c,a.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(a,t){if(await g.Promises.exists(a)&&await this.z(a),await g.Promises.exists(t))try{await g.Promises.rename(t,a,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,M.$jc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,M.$jc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const r of a){const i=r.workspace;if(!(0,k.$ti)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$jc)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await g.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!o.has(n)){o.add(n);const c=(0,M.$jc)(this.c,this.D(r));await this.B(c)?i.scheme!==s.Schemas.file||await g.Promises.exists(i.fsPath)?t.push(r):await this.z(c):await this.x(c)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const n=(0,M.$jc)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(a){try{await g.Promises.rm(a,g.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,u.$E$b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,u.$E$b)();return{backupFolder:a.id}}async z(a){const t=this.y(),o=(0,M.$jc)(this.c,t.backupFolder);try{await g.Promises.rename(a,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,l.$k$b)(a)?t=(0,M.$jc)(this.c,a.backupFolder):(0,p.$0db)(a)?t=(0,M.$jc)(this.c,this.D(a)):t=(0,M.$jc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await g.Promises.readdir(a);for(const o of t)try{if((await g.Promises.readdir((0,M.$jc)(a,o))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(f.a,a)}D(a){const t=a.folderUri;let o;return t.scheme===s.Schemas.file?o=A.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,S.createHash)("md5").update(o).digest("hex")}};e.$X$b=d,e.$X$b=d=f=ve([se(0,v.$i$b),se(1,w.$Ki),se(2,m.$yj),se(3,y.$sP)],d)}),define(ae[20],ce([0,1,15,37,8,3,2,4,36,12,6,5,34,24]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$N$b=e.LifecycleMainPhase=e.ShutdownReason=e.$M$b=void 0,e.$M$b=(0,w.$ei)("lifecycleMainService");var p;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(p||(e.ShutdownReason=p={}));var k;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(k||(e.LifecycleMainPhase=k={}));let u=class extends A.$Tc{static{m=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(d,$,a){super(),this.F=d,this.G=$,this.H=a,this.c=this.B(new M.$5d),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$5d),this.onWillShutdown=this.f.event,this.g=this.B(new M.$5d),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$5d),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(m.b),this.m&&this.G.removeItem(m.b)}J(){const d=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$j&&this.t===0&&this.L(1))};S.app.addListener("before-quit",d);const $=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$j)&&S.app.quit()};S.app.addListener("window-all-closed",$),S.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",d),S.app.removeListener("window-all-closed",$),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(d){if(this.y)return this.y;const $=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:d,join(t,o){$.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{$.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(d){if(d<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===d)return;this.S(`lifecycle (main): phase changed (value: ${d})`),this.n=d;const $=this.C.get(this.n);$&&($.open(),this.C.delete(this.n))}async when(d){if(d<=this.n)return;let $=this.C.get(d);$||($=new s.$dh,this.C.set(d,$)),await $.wait()}registerWindow(d){const $=new A.$Sc;this.t++,$.add(d.onWillLoad(t=>this.g.fire({window:d,workspace:t.workspace,reason:t.reason})));const a=(0,l.$4f)(d.win);a.on("close",t=>{const o=d.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${d.id}`),t.preventDefault(),this.unload(d,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(d),d.close()})}),a.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${d.id}`),this.t--,$.dispose(),this.t===0&&(!P.$j||this.j)&&this.L(1)})}registerAuxWindow(d){const $=(0,l.$4f)(d.win);$.on("close",a=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${d.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),a.preventDefault())}),$.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${d.id}`)})}async reload(d,$){await this.unload(d,3)||d.reload($)}unload(d,$){const a=this.z.get(d.id);if(a)return a;const t=this.M(d,$).finally(()=>{this.z.delete(d.id)});return this.z.set(d.id,t),t}async M(d,$){if(!d.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${d.id}`);const a=this.j?2:$,t=await this.P(d,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${d.id})`),this.N(t)):(await this.Q(d,a),!1)}N(d){return d?(this.O(!0),this.j=!1,!0):!1}O(d){this.w&&(this.w(d),this.w=void 0,this.u=void 0)}P(d,$){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;D.$AV.once(o,()=>{a(!1)}),D.$AV.once(r,()=>{a(!0)}),d.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:$})})}Q(d,$){return new Promise(a=>{const o=`vscode:reply${this.s++}`;D.$AV.once(o,()=>a()),d.send("vscode:onWillUnload",{replyChannel:o,reason:$})})}quit(d){return this.R(d).then($=>{if(!$&&d)try{if(P.$i){const a=(0,g.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return $})}R(d){return this.S(`Lifecycle#quit() - begin (willRestart: ${d})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(d&&this.G.setItem(m.b,!0),this.u=new Promise($=>{this.w=$,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(d){this.H.args["enable-smoke-test-driver"]?this.F.info(d):this.F.trace(d)}setRelaunchHandler(d){this.D=d}async relaunch(d){this.S("Lifecycle#relaunch()");const $=process.argv.slice(1);if(d?.addArgs&&$.push(...d.addArgs),d?.removeArgs)for(const o of d.removeArgs){const r=$.indexOf(o);r>=0&&$.splice(r,1)}const a=()=>{this.D?.handleRelaunch(d)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:$}))};S.app.once("quit",a),await this.quit(!0)&&S.app.removeListener("quit",a)}async kill(d){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$fh)(1e3),(async()=>{for(const $ of S.BrowserWindow.getAllWindows())if($&&!$.isDestroyed()){let a;$.webContents&&!$.webContents.isDestroyed()?a=new Promise(t=>$.once("closed",t)):a=Promise.resolve(),$.destroy(),await a}})()]),S.app.exit(d)}};e.$N$b=u,e.$N$b=u=m=ve([se(0,v.$yj),se(1,y.$sP),se(2,h.$i$b)],u)}),define(ae[284],ce([0,1,4,3,2,6,20]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=e.$i_b=void 0,e.$i_b=(0,M.$ei)("keyboardLayoutMainService");let P=class extends s.$Tc{constructor(w){super(),this.a=this.B(new D.$5d),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,w.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const w=await new Promise((v,y)=>{Y(["native-keymap"],v,y)});this.c=g(w),S.$t||w.onDidChangeKeyboardLayout(()=>{this.c=g(w),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$j_b=P,e.$j_b=P=ve([se(0,A.$M$b)],P);function g(l){const w=l.getKeyMap(),v=l.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:v}}}),define(ae[285],ce([0,1,246,8,17,14,12,18,38,94,5,53,245,282]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=void 0;let m=class extends v.$tp{constructor(f,d,$,a){super(a),this.m=f,this.n=d,this.r=$,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,d){const{f:$,g:a}=this;let t;try{t=await(0,l.$km)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$0)(i)))}const o={...process.env,...t},r=f.agent?f.agent:await(0,y.$xr)(f.url||"",o,{proxyUrl:$,strictSSL:a});return f.agent=r,f.strictSSL=a,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>k(f,d))}async resolveProxy(f){}async loadCertificates(){return(await new Promise((d,$)=>{Y(["@vscode/proxy-agent"],d,$)})).loadSystemCertificates({log:this.r})}};e.$yr=m,e.$yr=m=ve([se(0,P.$Ki),se(1,g.$mi),se(2,w.$yj),se(3,w.$zj)],m);async function p(u){return((0,S.parse)(u.url).protocol==="https:"?await new Promise(($,a)=>{Y(["https"],$,a)}):await new Promise(($,a)=>{Y(["http"],$,a)})).request}async function k(u,f){return D.Promises.withAsyncBody(async(d,$)=>{const a=(0,S.parse)(u.url),t=u.getRawRequest?u.getRawRequest(u):await p(u),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,A.$Yf)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(o.auth=u.user+":"+u.password);const r=t(o,i=>{const n=(0,A.$Wf)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)k({...u,url:i.headers.location,followRedirects:n-1},f).then(d,$);else{let c=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(c=i.pipe((0,h.createGunzip)())),d({res:i,stream:(0,s.$He)(c)})}});r.on("error",$),u.timeout&&r.setTimeout(u.timeout),u.isChromiumNetwork&&r.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&r.write(u.data),r.end(),f.onCancellationRequested(()=>{r.abort(),$(new M.$5)})})}e.$zr=k}),define(ae[286],ce([0,1,15,285]),function(Y,e,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=void 0;function s(A){return S.net.request}class M extends D.$yr{request(P,g){return super.request({...P||{},getRawRequest:s,isChromiumNetwork:!0},g)}}e.$lac=M}),define(ae[82],ce([0,1,7,3,2,38,16,6,20,5,97,279,41,57,40,13]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=e.$U$b=e.$T$b=e.$S$b=void 0,e.$S$b=(0,P.$ei)("storageMainService");let k=class extends s.$Tc{constructor(d,$,a,t,o,r){super(),this.c=d,this.f=$,this.g=a,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new D.$5d),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(d=>{d.window.profile&&this.profileStorage(d.window.profile).init(),d.workspace&&this.workspaceStorage(d.workspace).init()})),this.B(this.h.onWillShutdown(d=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=d.reason,d.join("applicationStorage",this.applicationStorage.close());for(const[,$]of this.t)d.join("profileStorage",$.close());for(const[,$]of this.w)d.join("workspaceStorage",$.close())})),this.B(this.g.onWillCreateProfile(d=>{d.join((async()=>{await this.j.exists(d.profile.globalStorageHome)||await this.j.createFolder(d.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(d=>{const $=this.t.get(d.profile.id);$&&d.join($.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const d=new v.$P$b(this.n(),this.g,this.c,this.j);return this.B(D.Event.once(d.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),d}profileStorage(d){if((0,w.$Ip)(d))return this.applicationStorage;let $=this.t.get(d.id);if(!$){this.c.trace(`StorageMainService: creating profile storage (${d.name})`),$=this.B(this.u(d)),this.t.set(d.id,$);const a=this.B($.onDidChangeStorage(t=>this.b.fire({...t,storage:$,profile:d})));this.B(D.Event.once($.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${d.name})`),this.t.delete(d.id),a.dispose()}))}return $}u(d){return this.a===2?new v.$R$b(this.c,this.j):new v.$O$b(d,this.n(),this.c,this.j)}workspaceStorage(d){let $=this.w.get(d.id);return $||(this.c.trace(`StorageMainService: creating workspace storage (${d.id})`),$=this.B(this.y(d)),this.w.set(d.id,$),this.B(D.Event.once($.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${d.id})`),this.w.delete(d.id)}))),$}y(d){return this.a===2?new v.$R$b(this.c,this.j):new v.$Q$b(d,this.n(),this.c,this.f,this.j)}isUsed(d){const $=S.URI.file(d);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(S.URI.file(a.path),$))return!0;return!1}};e.$T$b=k,e.$T$b=k=ve([se(0,l.$yj),se(1,M.$li),se(2,h.$w$b),se(3,g.$M$b),se(4,A.$Bk),se(5,m.$_k)],k),e.$U$b=(0,P.$ei)("applicationStorageMainService");let u=class extends w.$Hp{constructor(d,$){super(),this.s=d,this.U=$,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(d){if(d===-1)return this.U.applicationStorage.storage}Q(d){if(d===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$V$b=u,e.$V$b=u=ve([se(0,y.$bl),se(1,e.$S$b)],u)}),define(ae[287],ce([0,1,87,26,105,100,8,2,4,18,5,27,241,242,95,128,17]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=e.$jac=e.$iac=e.$hac=void 0;async function u(t,o,r,i,n){let c;for(let b=3;b&&(c?.dispose(),c=await new f(t,o,r,i,n).waitForReady(),!(n&&s.$Dg[n]||!s.$Dg[c.tunnelLocalPort]));b--);return c}class f extends P.$Tc{constructor(o,r,i,n,c){super(),this.m=r,this.n=c,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=S.createServer(),this.c=new A.$dh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,p.$Tv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$Eg)(o,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,p.$Rv)(this.tunnelRemoteHost)||(0,p.$Tv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,y.$wl)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),c=i.readEntireBuffer();i.dispose(),c.byteLength>0&&o.write(c.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof M.$6h?n.socket.destroy():n.end()}),n instanceof M.$6h?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write(k.$se.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$hac=f;let d=class extends p.$Wv{constructor(o,r,i,n,c){super(r,c),this.v=o,this.w=i,this.y=n}isPortPrivileged(o){return(0,p.$Uv)(o,this.m,g.OS,D.release())}t(o,r,i,n,c,b,R,I){const E=this.s(r,i);if(E)return++E.refcount,E.value;if((0,p.$Ov)(o))return this.u(o,r,i,c,b,R,I);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${c}.`);const C={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},j=u(C,n,r,i,c);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,i,j),j}}};e.$iac=d,e.$iac=d=ve([se(0,h.$ql),se(1,w.$yj),se(2,m.$tl),se(3,v.$Qj),se(4,l.$Ki)],d);let $=class extends d{constructor(o,r,i,n,c){super(o,r,i,n,c)}};e.$jac=$,e.$jac=$=ve([se(0,h.$ql),se(1,w.$yj),se(2,m.$tl),se(3,v.$Qj),se(4,l.$Ki)],$);let a=class extends P.$Tc{constructor(o,r,i,n,c){super(),this.b=o,this.c=r,this.f=i,this.g=n,this.h=c,this.a=new Map}async openTunnel(o,r,i,n,c,b,R,I,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${b}.`),!this.a.has(o)){const C=new $(this.b,this.c,this.g,this.f,this.h);this.B(C),this.a.set(o,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,n,c,b,R,I,E)}};e.$kac=a,e.$kac=a=ve([se(0,h.$ql),se(1,w.$yj),se(2,v.$Qj),se(3,m.$tl),se(4,l.$Ki)],a)}),define(ae[101],ce([0,1,8,23,3,18,24,20,5,27,53,49]),function(Y,e,S,D,s,M,A,P,g,l,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G_b=e.$F_b=void 0;function y(m,p,k){return`${k.updateUrl}/api/update/${m}/${p}/${k.commit}`}e.$F_b=y;let h=class{get state(){return this.b}d(p){this.j.info("update#setState",p.type),this.b=p,this.c.fire(p)}constructor(p,k,u,f,d,$){this.f=p,this.g=k,this.h=u,this.i=f,this.j=d,this.k=$,this.b=v.$yW.Uninitialized,this.c=new s.$5d,this.onStateChange=this.c.event,p.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(v.$yW.Disabled(0));return}if(this.h.disableUpdates){this.d(v.$yW.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(v.$yW.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.g.getValue("update.mode"),k=this.m(p);if(!k){this.d(v.$yW.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(k),!this.a){this.d(v.$yW.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const u=new URL(this.a);u.searchParams.set("prss","true"),this.a=u.toString()}if(this.d(v.$yW.Idle(this.q())),p==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,u=>this.j.error(u))}m(p){return p==="none"?void 0:this.k.quality}n(p=60*60*1e3){return(0,S.$fh)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(p){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(p)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(p){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},D.CancellationToken.None)).res.statusCode===204}catch(k){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(k);return}}async _applySpecificUpdate(p){}q(){return 1}r(){}};e.$G_b=h,e.$G_b=h=ve([se(0,P.$M$b),se(1,M.$Ki),se(2,A.$i$b),se(3,w.$sp),se(4,g.$yj),se(5,l.$Qj)],h)}),define(ae[288],ce([0,1,15,50,3,45,2,18,24,20,5,27,53,28,49,101]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=void 0;let k=class extends p.$G_b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",(f,d)=>d)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(f,d,$)=>({url:d,version:$,productVersion:$}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(f,d,$,a)=>({releaseNotes:d,version:$,productVersion:$,date:a}))}constructor(f,d,$,a,t,o,r){super(f,d,a,t,o,r),this.z=$,this.u=new A.$Sc,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(f){this.z.publicLog2("update:error",{messageHash:String((0,M.$5i)(String(f)))}),this.j.error("UpdateService error:",f);const d=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.d(m.$yW.Idle(1,d))}s(f){let d;this.k.darwinUniversalAssetId?d=this.k.darwinUniversalAssetId:d=process.arch==="x64"?"darwin":"darwin-arm64";const $=(0,p.$F_b)(d,f,this.k);try{S.autoUpdater.setFeedURL({url:$})}catch(a){this.j.error("Failed to set update feed URL",a);return}return $}t(f){this.d(m.$yW.CheckingForUpdates(f)),S.autoUpdater.checkForUpdates()}E(f){this.state.type==="checking for updates"&&this.d(m.$yW.Downloading(f))}F(f){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:f.version}),this.d(m.$yW.Ready(f)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(m.$yW.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$H_b=k,ve([D.$Ih],k.prototype,"v",null),ve([D.$Ih],k.prototype,"w",null),ve([D.$Ih],k.prototype,"x",null),ve([D.$Ih],k.prototype,"y",null),e.$H_b=k=ve([se(0,l.$M$b),se(1,P.$Ki),se(2,h.$Fl),se(3,g.$i$b),se(4,y.$sp),se(5,w.$yj),se(6,v.$Qj)],k)}),define(ae[289],ce([0,1,48,46,8,3,9,24,20,5,28,49]),function(Y,e,S,D,s,M,A,P,g,l,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=void 0;let y=class{get state(){return this.a}d(p){this.g.info("update#setState",p.type),this.a=p,this.b.fire(p)}constructor(p,k,u){if(this.f=p,this.g=u,this.a=v.$yW.Uninitialized,this.b=new M.$5d,this.onStateChange=this.b.event,k.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.$yW.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(p=60*60*1e3){return(0,s.$fh)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(p){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(p)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(p){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(p){}};y=ve([se(0,g.$M$b),se(1,P.$i$b),se(2,l.$yj)],y);let h=class extends y{constructor(p,k,u,f,d,$){super(u,f,d),this.o=p,this.p=k,this.q=$;const a=(0,D.watch)(A.$mc(this.o)),t=M.Event.fromNodeEventEmitter(a,"change",(n,c)=>c),o=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(o,(n,c)=>c,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(v.$yW.CheckingForUpdates(!1)),this.u().then(p=>{p?this.d(v.$yW.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$yW.Idle(2)))},p=>{this.g.error(p),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$yW.Idle(2,p.message||p))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+A.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const p=await new Promise((u,f)=>(0,D.realpath)(`${A.$mc(this.o)}/current`,(d,$)=>d?f(d):u($))),k=A.$nc(p);return this.p!==k}isLatestVersion(){return this.u().then(void 0,p=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$J_b=h,e.$J_b=h=ve([se(2,g.$M$b),se(3,P.$i$b),se(4,l.$yj),se(5,w.$Fl)],h)}),define(ae[29],ce([0,1,15,4,6,96,55,69,27,18,24,9,137]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.$v$b=e.$u$b=e.OpenContext=e.$t$b=void 0,e.$t$b=(0,s.$ei)("windowsMainService");var h;(function(u){u[u.CLI=0]="CLI",u[u.DOCK=1]="DOCK",u[u.MENU=2]="MENU",u[u.DIALOG=3]="DIALOG",u[u.DESKTOP=4]="DESKTOP",u[u.API=5]="API"})(h||(e.OpenContext=h={}));function m(u,f,d){const $=u.get(P.$r$b),a=u.get(g.$Qj),t=u.get(l.$Ki),o=u.get(w.$i$b),r=t.getValue("window"),i={backgroundColor:$.getBackgroundColor(),minWidth:A.$ZC.WIDTH,minHeight:A.$ZC.HEIGHT,title:a.nameLong,...d,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,A.$$C)(f?.zoomLevel??r?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...d?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(f&&(i.x=f.x,i.y=f.y,i.width=f.width,i.height=f.height),D.$k?i.icon=(0,v.$jc)(o.appRoot,"resources/linux/code.png"):D.$i&&!o.isBuilt&&(i.icon=(0,v.$jc)(o.appRoot,"resources/win32/code_150x150.png")),D.$j&&(i.acceptFirstMouse=!0,r?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),D.$j&&!(0,A.$0C)(t)&&(i.fullscreenable=!1),D.$j&&r?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,A.$7C)(t)&&(i.titleBarStyle="hidden",D.$j||(i.frame=!1),(0,A.$9C)(t))){const b=$.getWindowSplash()?.colorInfo.titleBarBackground??$.getBackgroundColor(),R=y.$xt.fromHex(b).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:b,symbolColor:R}}return i}e.$u$b=m;function p(u){let f,d=Number.MIN_VALUE;for(const $ of u)$.lastFocusTime>d&&(d=$.lastFocusTime,f=$);return f}e.$v$b=p;var k;(function(u){function f($,a,t=S.screen.getAllDisplays()){if($.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){$.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){$.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=d(t[0]);if(i){let n=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};$.trace("window#validateWindowState: 1 monitor working area",i),n(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),n()}return a}if(a.display&&a.mode===3){const i=t.find(n=>n.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){$.trace("window#validateWindowState: restoring fullscreen to previous display");const n=(0,M.$h$b)(3);return n.x=i.bounds.x,n.y=i.bounds.y,n}}let o,r;try{o=S.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),r=d(o)}catch{}if(o&&r&&a.x+a.width>r.x&&a.y+a.height>r.y&&a.x<r.x+r.width&&a.y<r.y+r.height)return $.trace("window#validateWindowState: multi-monitor working area",r),a}u.validateWindowState=f;function d($){if($.workArea.width>0&&$.workArea.height>0)return $.workArea;if($.bounds.width>0&&$.bounds.height>0)return $.bounds}})(k||(e.WindowStateValidator=k={}))}),define(ae[290],ce([0,1,15,23,3,45,2,32,118,5,82,29]),function(Y,e,S,D,s,M,A,P,g,l,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=void 0;var y;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let h=class extends A.$Tc{constructor(p,k,u,f){super(),this.g=p,this.h=k,this.j=u,this.m=f,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const p=s.Event.fromNodeEventEmitter(S.app,"login",(k,u,f,d,$)=>({event:k,webContents:u,req:f,authInfo:d,callback:$}));this.B(p(this.r,this))}async r({event:p,authInfo:k,req:u,callback:f}){if(!k.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&u.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}p.preventDefault();let d;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),d=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(k);try{d=await this.b}finally{this.b=void 0}}f(d?.username,d?.password)}async s(p){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const k=await this.t(p);if(k)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),k;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(p){this.g.trace("auth#doResolveProxyCredentials - enter",p);const k=String((0,M.$5i)({scheme:p.scheme,host:p.host,port:p.port}));let u,f;try{const t=this.m.get(this.a+k,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));u=o.username,f=o.password}}catch(t){this.g.error(t)}if(this.c!==y.StoredCredentialsUsed&&typeof u=="string"&&typeof f=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:u,password:f};const d=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!d){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${d.id} to handle proxy login`);const $={authInfo:p,username:this.f?.username??u,password:this.f?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,P.$Ag)()}`};d.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,$),this.c=y.LoginDialogShown;const a=await new Promise(t=>{const o=async(r,i,n)=>{if(i===$.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${d.id}`),d.win?.webContents.off("ipc-message",o),n){const c={username:n.username,password:n.password};try{if(n.remember){const b=await this.j.encrypt(JSON.stringify(c));this.m.store(this.a+k,b,-1,1)}else this.m.remove(this.a+k,-1)}catch(b){this.g.error(b)}t({username:c.username,password:c.password})}else t(void 0)};d.win?.webContents.on("ipc-message",o)});return this.f=a,a}};e.$W$b=h,e.$W$b=h=ve([se(0,l.$yj),se(1,v.$t$b),se(2,g.$jW),se(3,w.$U$b)],h)}),define(ae[291],ce([0,1,15,22,4,7,21,18,64,6,5,129,29]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=e.$l_b=e.ID=void 0,e.ID="launchMainService",e.$l_b=(0,l.$ei)(e.ID);let h=class{constructor(p,k,u,f){this.a=p,this.b=k,this.c=u,this.d=f}async start(p,k){this.a.trace("Received data from other instance: ",p,k),s.$j&&S.app.focus({steal:!0});const u=this.e(p);if(u.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const d=(0,D.$Ob)(await this.b.openEmptyWindow({context:4}));d&&(f=d.ready())}f.then(()=>{for(const{uri:d,originalUrl:$}of u)this.c.open(d,{originalUrl:$})})}else return this.f(p,k)}e(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,D.$Hb)(p._urls.map(k=>{try{return{uri:M.URI.parse(k),originalUrl:k}}catch{return null}})):[]}async f(p,k){const u=(0,g.$em)(k)?0:4;let f=[];const d=p.wait&&p.waitMarkerFilePath?M.URI.file(p.waitMarkerFilePath):void 0,$=p.remote||void 0,a={context:u,cli:p,userEnv:p["preserve-env"]||u===0?k:void 0,waitMarkerFileURI:d,remoteAuthority:$,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,a);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let t=!1;if(p["new-window"]||p["unity-launch"]||a.forceProfile||a.forceTempProfile)t=!0;else if(p["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)f=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,a),f=[o]):f=await this.b.open({...a,forceEmpty:!0})}}else f=await this.b.open({...a,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(d&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,A.whenDeleted)(d.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$m_b=h,e.$m_b=h=ve([se(0,w.$yj),se(1,y.$t$b),se(2,v.$pW),se(3,P.$Ki)],h)}),define(ae[292],ce([0,1,2,20,57,30,8,29]),function(Y,e,S,D,s,M,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2_b=void 0;let g=class extends S.$Tc{constructor(w,v,y){super(),this.a=v,this.b=y,this.B(w.onWillLoadWindow(h=>{h.reason===2&&this.c(h.window)})),this.B(w.onBeforeCloseWindow(h=>this.c(h))),this.B(new A.$qh(()=>this.g(),30*1e3)).schedule()}async c(w){const v=this.f(w),y=this.a.getProfileForWorkspace(v);y?.isTransient&&(this.a.unsetWorkspace(v,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(w){return w.openedWorkspace??(0,M.$si)(w.backupPath,w.isExtensionDevelopmentHost)}g(){const w=this.a.getAssociatedEmptyWindows();if(w.length===0)return;const v=this.b.getWindows().map(y=>this.f(y));for(const y of w)v.some(h=>h.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$2_b=g,e.$2_b=g=ve([se(0,D.$M$b),se(1,s.$w$b),se(2,P.$t$b)],g)}),define(ae[61],ce([0,1,15,2,3,5,312,8,13,29,73,28,20,75,35,4,132]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$1$b=e.$Z$b=void 0;function f(a){return typeof a.responseWindowId=="number"}let d=class extends D.$Tc{static{u=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(u.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++u.a),this.f=this.B(new s.$5d),this.onStdout=this.f.event,this.g=this.B(new s.$5d),this.onStderr=this.g.event,this.h=this.B(new s.$5d),this.onMessage=this.h.event,this.j=this.B(new s.$5d),this.onSpawn=this.j.event,this.m=this.B(new s.$5d),this.onExit=this.m.event,this.n=this.B(new s.$5d),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case w.default.Error:this.u.error(r);break;case w.default.Warning:this.u.warn(r);break;case w.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",w.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=g.$yg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],n=this.t.execArgv??[],c=this.t.allowLoadingUnsignedLibraries,b=this.t.forceAllocationsToV8Sandbox,R="pipe",I=this.F(t);return this.z("creating new...",w.default.Info),this.r=S.utilityProcess.fork(r,i,{serviceName:o,env:I,execArgv:n,allowLoadingUnsignedLibraries:c,forceAllocationsToV8Sandbox:b,stdio:R}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,m.$Hn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,p.$i&&((0,k.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,k.getUNCHostAllowlist)().join("\\")),(0,h.$4l)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new A.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new A.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&u.b.set(t.pid,{pid:t.pid,name:f(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",w.default.Info),this.j.fire(t.pid)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,w.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,w.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){this.r&&this.r.postMessage(t,o)}connect(t){const{port1:o,port2:r}=new S.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",w.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",w.default.Info),this.r.kill()?(this.z("successfully killed the process",w.default.Info),this.H()):this.z("unable to kill the process",w.default.Warning)}H(){typeof this.s=="number"&&u.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",w.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,P.$fh)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,w.default.Info),this.kill()))}};e.$Z$b=d,e.$Z$b=d=u=ve([se(0,M.$yj),se(1,v.$Fl),se(2,y.$M$b)],d);let $=class extends d{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",w.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$1$b=$,e.$1$b=$=ve([se(0,M.$yj),se(1,l.$t$b),se(2,v.$Fl),se(3,y.$M$b)],$)}),define(ae[293],ce([0,1,14,3,5,20,8,61,29,28]),function(Y,e,S,D,s,M,A,P,g,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$8$b=void 0;let v=class{static{w=this}static{this.a=0}constructor(h,m,p,k){this.d=h,this.f=m,this.g=p,this.h=k,this.b=new Map,this.c=!1,this.f.onWillShutdown(u=>{this.c=!0,u.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(h){const m=this.b.get(h);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout(h){return this.i(h).onStdout}onDynamicStderr(h){return this.i(h).onStderr}onDynamicMessage(h){return this.i(h).onMessage}onDynamicExit(h){return this.i(h).onExit}async createExtensionHost(){if(this.c)throw(0,S.$6)();const h=String(++w.a),m=new P.$1$b(this.d,this.g,this.h,this.f);return this.b.set(h,m),m.onExit(({pid:p,code:k,signal:u})=>{this.d.info(`Extension host with pid ${p} exited with code: ${k}, signal: ${u}.`),setTimeout(()=>{m.dispose(),this.b.delete(h)}),setTimeout(()=>{try{process.kill(p,0),this.d.error(`Extension host with pid ${p} still exists, forcefully killing it...`),process.kill(p)}catch{}},1e3)}),{id:h}}async start(h,m){if(this.c)throw(0,S.$6)();const p=this.i(h);return p.start({...m,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:m.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:h}),{pid:await D.Event.toPromise(p.onSpawn)}}async enableInspectPort(h){if(this.c)throw(0,S.$6)();const m=this.b.get(h);return m?m.enableInspectPort():!1}async kill(h){if(this.c)throw(0,S.$6)();const m=this.b.get(h);m&&m.kill()}async _killAllNow(){for(const[,h]of this.b)h.kill()}async _waitForAllExit(h){const m=[];for(const[,p]of this.b)m.push(p.waitForExit(h));return A.Promises.settled(m).then(()=>{})}};e.$8$b=v,e.$8$b=v=w=ve([se(0,s.$yj),se(1,M.$M$b),se(2,g.$t$b),se(3,l.$Fl)],v)}),define(ae[294],ce([0,1,37,8,2,24,20,5,41,39,68,61,54,90,12,247]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z_b=void 0;let k=class extends s.$Tc{constructor(f,d,$,a,t,o,r,i){super(),this.c=f,this.f=d,this.g=$,this.h=a,this.j=t,this.m=o,this.n=r,this.r=i,this.a=new D.$dh,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){S.$AV.on(p.$x_b.request,(f,d)=>this.t(f,d,p.$x_b.response)),S.$AV.on(p.$y_b.request,(f,d)=>this.t(f,d,p.$y_b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(f,d,$){this.m.trace(`[SharedProcess] onWindowConnection for: ${$}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect($);if(f.sender.isDestroyed())return a.close();f.sender.postMessage($,d,[a])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(p.$w_b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const f=new D.$Bh;this.b?this.b.once(p.$w_b.initDone,()=>f.complete()):S.$AV.once(p.$w_b.initDone,()=>f.complete()),await f.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const f=new D.$Bh;this.b?this.b.once(p.$w_b.ipcReady,()=>f.complete()):S.$AV.once(p.$w_b.ipcReady,()=>f.complete()),await f.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new v.$Z$b(this.m,y.$Yo,this.j));const f=(0,h.$Pm)(this.g.args,this.g.isBuilt);let d;f.port&&(d=["--nolazy"],f.break?d.push(`--inspect-brk=${f.port}`):d.push(`--inspect=${f.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:d})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(f){return await this.z,(0,m.$4f)(this.b).connect(f)}};e.$z_b=k,e.$z_b=k=ve([se(2,M.$i$b),se(3,g.$bl),se(4,A.$M$b),se(5,P.$yj),se(6,w.$H$b),se(7,l.$Vn)],k)}),define(ae[295],ce([0,1,24,90,20,5,54,61,112,37,2,3,35,18,13]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=void 0;let p=class extends w.$Tc{constructor(u,f,d,$,a){super(),this.f=u,this.g=f,this.h=d,this.j=$,this.m=a,this.a=void 0,this.b=new v.$5d,this.onRequestConnection=this.b.event,this.c=new v.$5d,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),l.$AV.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,w.$Rc)(()=>{l.$AV.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$Z$b(this.m,A.$Yo,this.j);const u=(0,D.$Om)(this.h.args,this.h.isBuilt),f=u.port?["--nolazy",`--inspect${u.break?"-brk":""}=${u.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this.h.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this.n()});const d=this.a.connect(),$=new g.$IV(d,"ptyHost"),a=new w.$Sc;return a.add($),a.add((0,w.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:$,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const u={...(0,y.$Hn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},f=this.g.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&(u.VSCODE_LATENCY=String(f));const d=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return d&&typeof d=="number"&&(u.VSCODE_STARTUP_DELAY=String(d)),this.h.restoreSnapExportedVariables(),u}r(u,f){this.b.fire();const d=this.a.connect();if(u.sender.isDestroyed()){d.close();return}u.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[d])}};e.$__b=p,e.$__b=p=ve([se(1,h.$Ki),se(2,S.$i$b),se(3,s.$M$b),se(4,M.$yj)],p)}),define(ae[296],ce([0,1,2,6,5,29,61,28,45,3,8,20]),function(Y,e,S,D,s,M,A,P,g,l,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$_b=e.$0_b=void 0,e.$0_b=(0,D.$ei)("utilityProcessWorker");let y=class extends S.$Tc{constructor(p,k,u,f){super(),this.b=p,this.c=k,this.f=u,this.g=f,this.a=new Map}async createWorker(p){const k=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${k})`);const u=this.h(p);this.a.has(u)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${k})`),this.disposeWorker(p));const f=new h(this.b,this.c,this.f,this.g,p);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(u,f);const d=new w.$Bh;return l.Event.once(f.onDidTerminate)($=>{$.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${$.code}, signal: ${$.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${$.code}, signal: ${$.signal}`),this.a.delete(u),d.complete({reason:$})}),d.p}h(p){return(0,g.$5i)({moduleId:p.process.moduleId,windowId:p.reply.windowId})}async disposeWorker(p){const k=this.h(p),u=this.a.get(k);u&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),u.kill(),this.a.delete(k))}};e.$$_b=y,e.$$_b=y=ve([se(0,s.$yj),se(1,M.$t$b),se(2,P.$Fl),se(3,v.$M$b)],y);let h=class extends S.$Tc{constructor(p,k,u,f,d){super(),this.c=p,this.f=k,this.g=u,this.h=f,this.j=d,this.a=this.B(new l.$5d),this.onDidTerminate=this.a.event,this.b=new A.$1$b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(p=>this.a.fire({code:p.code,signal:p.signal}))),this.B(this.b.onCrash(p=>this.a.fire({code:p.code,signal:"ECRASH"})))}spawn(){const k=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:k,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};h=ve([se(0,s.$yj),se(1,M.$t$b),se(2,P.$Fl),se(3,v.$M$b)],h)}),define(ae[297],ce([0,1,15,3,2,273,29]),function(Y,e,S,D,s,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R_b=void 0;let P=class extends s.$Tc{constructor(l){super(),this.b=l,this.a=this.B(new D.$5d),this.onFoundInFrame=this.a.event,this.B(new M.$Q_b)}async setIgnoreMenuShortcuts(l,w){let v;if(typeof l.windowId=="number"){const{windowId:y}=l,h=this.b.getWindowById(y);if(!h?.win)throw new Error(`Invalid windowId: ${y}`);v=h.win.webContents}else{const{webContentsId:y}=l;if(v=S.webContents.fromId(y),!v)throw new Error(`Invalid webContentsId: ${y}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(w)}async findInFrame(l,w,v,y){const m=this.c(l,w);if(typeof m.findInFrame=="function"){m.findInFrame(v,{findNext:y.findNext,forward:y.forward});const p=(k,u)=>{u.finalUpdate&&(this.a.fire(u),m.removeListener("found-in-frame",p))};m.on("found-in-frame",p)}}async stopFindInFrame(l,w,v){const h=this.c(l,w);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(l,w){const v=this.b.getWindowById(l.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${l}`);const y=v.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===w);if(!y)throw new Error(`Unknown frame: ${w}`);return y}};e.$R_b=P,e.$R_b=P=ve([se(0,A.$t$b)],P)}),define(ae[298],ce([0,1,15,2,4,19,7,18,20,5,34,29,96,30]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$U_b=e.$T_b=e.$S_b=void 0;let p=class extends D.$Tc{static{m=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,o,r,i){super(),this.g=a,this.h=t,this.j=o,this.m=r,this.n=i,this.b=k(this.h.getItem(m.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(a.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):a.add(n.uiState.display)),n}));const r=f(t);this.h.setItem(m.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,h.$ti)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,i=(0,h.$oi)(a.openedWorkspace)&&o.folderUri&&M.$Ig.isEqual(o.folderUri,a.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,h.$ti)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,h.$oi)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=a.workspace;if((0,h.$ti)(b)){const I=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===b.id).map(E=>E.uiState);if(I.length)return I[0]}if((0,h.$oi)(b)){const I=this.state.openedWindows.filter(E=>E.folderUri&&M.$Ig.isEqual(E.folderUri,b.uri)).map(E=>E.uiState);if(I.length)return I[0]}else if(a.backupPath){const I=this.state.openedWindows.filter(E=>E.backupPath===a.backupPath).map(E=>E.uiState);if(I.length)return I[0]}const R=this.c||this.state.lastActiveWindow;if(!t&&R)return R.uiState}let o;const r=S.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$j){const b=S.screen.getCursorScreenPoint();o=S.screen.getDisplayNearestPoint(b)}!o&&t&&(o=S.screen.getDisplayMatching(t.getBounds())),o||(o=S.screen.getPrimaryDisplay()||r[0])}let i=(0,y.$h$b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const n=this.n.getValue("window");let c=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,c=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,c=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===3?i.mode=3:i={...b,zoomLevel:void 0},c=i.mode!==3&&n.newWindowDimensions==="offset"}}return c&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.$S_b=p,e.$S_b=p=m=ve([se(0,v.$t$b),se(1,w.$sP),se(2,g.$M$b),se(3,l.$yj),se(4,P.$Ki)],p);function k($){const a={openedWindows:[]},t=$||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=u(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=u(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>u(o))),a}e.$T_b=k;function u($){const a={uiState:$.uiState};return $.backupPath&&(a.backupPath=$.backupPath),$.remoteAuthority&&(a.remoteAuthority=$.remoteAuthority),$.folder&&(a.folderUri=A.URI.parse($.folder)),$.workspaceIdentifier&&(a.workspace={id:$.workspaceIdentifier.id,configPath:A.URI.parse($.workspaceIdentifier.configURIPath)}),a}function f($){return{lastActiveWindow:$.lastActiveWindow&&d($.lastActiveWindow),lastPluginDevelopmentHostWindow:$.lastPluginDevelopmentHostWindow&&d($.lastPluginDevelopmentHostWindow),openedWindows:$.openedWindows.map(a=>d(a))}}e.$U_b=f;function d($){return{workspaceIdentifier:$.workspace&&{id:$.workspace.id,configURIPath:$.workspace.configPath.toString()},folder:$.folderUri&&$.folderUri.toString(),backupPath:$.backupPath,remoteAuthority:$.remoteAuthority,uiState:$.uiState}}}),define(ae[58],ce([0,1,15,3,42,2,13,9,19,21,194,65,56,24,6,5,57,131,30,98,99]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G$b=e.$F$b=void 0,e.$F$b=(0,m.$ei)("workspacesManagementMainService");let a=class extends M.$Tc{constructor(o,r,i,n,c){super(),this.g=o,this.h=r,this.j=i,this.m=n,this.n=c,this.a=this.B(new D.$5d),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new D.$5d),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await l.Promises.readdir(this.c.with({scheme:A.Schemas.file}).fsPath)).map(r=>(0,g.$Rg)(this.c,r,f.$Di));for(const r of o){const i=(0,$.$C$b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>l.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===A.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(n=>this.t(o,n),n=>{}):this.t(o,i)}catch{return}}s(o){return(0,f.$Ei)(o,this.g)||(0,f.$Ji)(o)}t(o,r){try{const i=this.u(o,r),n=(0,$.$C$b)(o);return{id:n.id,configPath:n.configPath,folders:(0,d.$feb)(i.folders,n.configPath,g.$Ig),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,s.$on)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,d.$deb)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:n}=this.w(o,r),c=i.configPath.fsPath;return await l.Promises.mkdir((0,P.$mc)(c),{recursive:!0}),await l.Promises.writeFile(c,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,g.$Rg)(this.c,i),c=(0,g.$Rg)(n,f.$Di),b=[];for(const R of o)b.push((0,d.$eeb)(R.uri,!0,R.name,n,g.$Ig));return{workspace:(0,$.$C$b)(c),storedWorkspace:{folders:b,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,$.$C$b)(o)}isUntitledWorkspace(o){return(0,f.$Ei)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,g.$Fg)(o.configPath);try{await l.Promises.rm((0,P.$mc)(r));const i=(0,P.$jc)(this.g.workspaceStorageHome.with({scheme:A.Schemas.file}).fsPath,o.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,P.$jc)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const c=await this.C(o,(0,$.$C$b)(i));if(c)return this.b.fire({window:o,workspace:c.workspace}),c}async z(o,r,i){return i?(0,f.$ti)(o.openedWorkspace)&&g.$Ig.isEqual(o.openedWorkspace.configPath,i)?!1:(0,u.$z$b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,w.localize)(0,null)],message:(0,w.localize)(1,null,(0,g.$Og)(i)),detail:(0,w.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,f.$ti)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$G$b=a,e.$G$b=a=ve([se(0,h.$i$b),se(1,p.$yj),se(2,k.$w$b),se(3,v.$n$b),se(4,y.$o$b)],a)}),define(ae[133],ce([0,1,15,37,23,6,29,30,58,12,5,61]),function(Y,e,S,D,s,M,A,P,g,l,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=e.$3$b=e.ID=void 0,e.ID="diagnosticsMainService",e.$3$b=(0,M.$ei)(e.ID);let y=class{constructor(m,p,k){this.a=m,this.b=p,this.c=k}async getRemoteDiagnostics(m){const p=this.a.getWindows();return(await Promise.all(p.map(async u=>{const f=u.remoteAuthority;if(!f)return;const d=`vscode:getDiagnosticInfoResponse${u.id}`,$={includeProcesses:m.includeProcesses,folders:m.includeWorkspaceMetadata?await this.f(u):void 0};return new Promise(a=>{u.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:d,args:$}),D.$AV.once(d,(t,o)=>{o||a({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),a(o)}),setTimeout(()=>{a({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter(u=>!!u)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const m=[];for(const k of S.BrowserWindow.getAllWindows()){const u=this.a.getWindowById(k.id);u?m.push(await this.d(u)):m.push(this.e(k))}const p=[];for(const{pid:k,name:u}of v.$Z$b.getAll())p.push({pid:k,name:u});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:m,pidToNames:p,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(m){const p=await this.f(m),k=(0,l.$4f)(m.win);return this.e(k,p,m.remoteAuthority)}e(m,p=[],k){return{id:m.id,pid:m.webContents.getOSProcessId(),title:m.getTitle(),folderURIs:p,remoteAuthority:k}}async f(m){const p=[],k=m.openedWorkspace;if((0,P.$oi)(k))p.push(k.uri);else if((0,P.$ti)(k)){const u=await this.b.resolveLocalWorkspace(k.configPath);u&&u.folders.forEach(d=>{p.push(d.uri)})}return p}};e.$4$b=y,e.$4$b=y=ve([se(0,A.$t$b),se(1,g.$F$b),se(2,w.$yj)],y)}),define(ae[70],ce([0,1,48,15,26,156,50,3,2,13,9,4,7,107,88,21,105,182,56,24,6,20,5,27,69,29,30,58,17,243,235,78,14]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d,$,a,t,o,r,i,n,c,b,R,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g_b=e.$f_b=void 0,e.$f_b=(0,$.$ei)("nativeHostMainService");let j=class extends g.$Tc{constructor(F,V,J,le,re,ue,Z,X,q){super(),this.a=F,this.b=V,this.c=J,this.f=le,this.g=re,this.h=ue,this.j=Z,this.m=X,this.n=q,this.onDidOpenMainWindow=P.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=P.Event.any(P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:T,y:G})=>({windowId:L.id,x:T,y:G})),({windowId:L})=>!!this.a.getWindowById(L)),P.Event.filter(P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:T,y:G})=>({windowId:L.id,x:T,y:G})),({windowId:L})=>!!this.b.getWindowById(L))),this.onDidMaximizeWindow=P.Event.any(P.Event.filter(P.Event.map(this.a.onDidMaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),P.Event.filter(P.Event.map(this.b.onDidMaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidUnmaximizeWindow=P.Event.any(P.Event.filter(P.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),P.Event.filter(P.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidChangeWindowFullScreen=P.Event.any(P.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),P.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(L,T)=>T.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(L,T)=>T.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=P.Event.any(this.onDidBlurMainWindow,P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(L,T)=>T.id),L=>!!this.b.getWindowById(L))),this.onDidFocusMainOrAuxiliaryWindow=P.Event.any(this.onDidFocusMainWindow,P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(L,T)=>T.id),L=>!!this.b.getWindowById(L))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new P.$5d),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(L,T,G)=>G),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),P.Event.fromNodeEventEmitter(D.screen,"display-added"),P.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,V){const J=this.a.getWindows().map(re=>({id:re.id,workspace:re.openedWorkspace??(0,n.$si)(re.backupPath,re.isExtensionDevelopmentHost),title:re.win?.getTitle()??"",filename:re.getRepresentedFilename(),dirty:re.isDocumentEdited()})),le=[];return V.includeAuxiliaryWindows&&le.push(...this.b.getWindows().map(re=>({id:re.id,parentId:re.parentId,title:re.win?.getTitle()??"",filename:re.getRepresentedFilename()}))),[...J,...le]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const V=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(V)return V.id}openWindow(F,V,J){return Array.isArray(V)?this.s(F,V,J):this.t(F,V)}async s(F,V,J=Object.create(null)){V.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:V,cli:this.g.args,forceNewWindow:J.forceNewWindow,forceReuseWindow:J.forceReuseWindow,preferNewWindow:J.preferNewWindow,diffMode:J.diffMode,mergeMode:J.mergeMode,addMode:J.addMode,gotoLineMode:J.gotoLineMode,noRecentEntry:J.noRecentEntry,waitMarkerFileURI:J.waitMarkerFileURI,remoteAuthority:J.remoteAuthority||void 0,forceProfile:J.forceProfile,forceTempProfile:J.forceTempProfile})}async t(F,V){await this.a.openEmptyWindow({context:5,contextWindowId:F},V)}async toggleFullScreen(F,V){this.C(V?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,V){this.C(V?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const V=D.screen.getCursorScreenPoint(),J=D.screen.getDisplayNearestPoint(V);return{point:V,display:J.bounds}}async isMaximized(F,V){return this.C(V?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,V){this.C(V?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,V){this.C(V?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,V){this.C(V?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,V){this.C(V?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,V,J){const le=this.C(J?.targetWindowId,F);if(le?.win){if(le.win.isFullScreen()){const re=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await re}le.win.setBounds(V)}}async updateWindowControls(F,V){this.C(V?.targetWindowId,F)?.updateWindowControls(V)}async focusWindow(F,V){this.C(V?.targetWindowId,F)?.focus({force:V?.force??!1})}async setMinimumSize(F,V,J){const le=this.D(F);if(le?.win){const[re,ue]=le.win.getSize(),[Z,X]=le.win.getMinimumSize(),[q,L]=[V??Z,J??X],[T,G]=[Math.max(re,q),Math.max(ue,L)];(Z!==q||X!==L)&&le.win.setMinimumSize(q,L),(re!==T||ue!==G)&&le.win.setSize(T,G)}}async saveWindowSplash(F,V){this.m.saveWindowSplash(F,V)}async installShellCommand(F){const{source:V,target:J}=await this.u();try{const{symbolicLink:le}=await p.SymlinkSupport.stat(V);if(le&&!le.dangling){const re=await(0,h.$Gq)(V);if(J===re)return}await p.Promises.unlink(V)}catch(le){if(le.code!=="ENOENT")throw le}try{await p.Promises.symlink(J,V)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:re}=await this.showMessageBox(F,{type:"info",message:(0,u.localize)(0,null,this.j.nameShort),buttons:[(0,u.localize)(1,null),(0,u.localize)(2,null)]});if(re===1)throw new C.$5;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${J}' '${V}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(ue)}catch{throw new Error((0,u.localize)(3,null,V))}}}async uninstallShellCommand(F){const{source:V}=await this.u();try{await p.Promises.unlink(V)}catch(J){switch(J.code){case"EACCES":{const{response:le}=await this.showMessageBox(F,{type:"info",message:(0,u.localize)(4,null,this.j.nameShort),buttons:[(0,u.localize)(5,null),(0,u.localize)(6,null)]});if(le===1)throw new C.$5;try{const re=`osascript -e "do shell script \\"rm '${V}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(re)}catch{throw new Error((0,u.localize)(7,null,V))}break}case"ENOENT":break;default:throw J}}}async u(){const F=(0,w.$kc)(this.g.appRoot,"bin","code"),V=`/usr/local/bin/${this.j.applicationName}`;if(!await p.Promises.exists(F))throw new Error((0,u.localize)(8,null,F));return{source:V,target:F}}async showMessageBox(F,V){const J=this.C(V?.targetWindowId,F);return this.c.showMessageBox(V,J?.win??void 0)}async showSaveDialog(F,V){const J=this.C(V?.targetWindowId,F);return this.c.showSaveDialog(V,J?.win??void 0)}async showOpenDialog(F,V){const J=this.C(V?.targetWindowId,F);return this.c.showOpenDialog(V,J?.win??void 0)}async pickFileFolderAndOpen(F,V){const J=await this.c.pickFileFolder(V);J&&await this.w(await Promise.all(J.map(async le=>await p.SymlinkSupport.existsDirectory(le)?{folderUri:y.URI.file(le)}:{fileUri:y.URI.file(le)})),V,F)}async pickFolderAndOpen(F,V){const J=await this.c.pickFolder(V);J&&await this.w(J.map(le=>({folderUri:y.URI.file(le)})),V,F)}async pickFileAndOpen(F,V){const J=await this.c.pickFile(V);J&&await this.w(J.map(le=>({fileUri:y.URI.file(le)})),V,F)}async pickWorkspaceAndOpen(F,V){const J=await this.c.pickWorkspace(V);J&&await this.w(J.map(le=>({workspaceUri:y.URI.file(le)})),V,F)}async w(F,V,J){await this.a.open({context:3,contextWindowId:J,cli:this.g.args,urisToOpen:F,forceNewWindow:V.forceNewWindow})}async showItemInFolder(F,V){D.shell.showItemInFolder(V)}async setRepresentedFilename(F,V,J){this.C(J?.targetWindowId,F)?.setRepresentedFilename(V)}async setDocumentEdited(F,V,J){this.C(J?.targetWindowId,F)?.setDocumentEdited(V)}async openExternal(F,V){return this.g.unsetSnapExportedVariables(),D.shell.openExternal(V),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,V){return D.shell.trashItem(V)}async isAdmin(){let F;return v.$i?F=(await new Promise((V,J)=>{Y(["native-is-elevated"],V,J)}))():F=process.getuid?.()===0,F}async writeElevated(F,V,J,le){const re=await new Promise((ue,Z)=>{Y(["@vscode/sudo-prompt"],ue,Z)});return new Promise((ue,Z)=>{const X=[`"${this.z}"`];le?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${V.fsPath}"`,`"${J.fsPath}"`);const q={name:this.j.nameLong.replace("-",""),icns:v.$j&&this.g.isBuilt?(0,w.$jc)((0,w.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};re.exec(X.join(" "),q,(L,T,G)=>{T&&this.h.trace(`[sudo-prompt] received stdout: ${T}`),G&&this.h.trace(`[sudo-prompt] received stderr: ${G}`),L?Z(L):ue(void 0)})})}async isRunningUnderARM64Translation(){return v.$k||v.$i?!1:D.app.runningUnderARM64Translation}get z(){return v.$i?this.g.isBuilt?(0,w.$jc)((0,w.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,w.$jc)(this.g.appRoot,"scripts","code-cli.bat"):v.$k?this.g.isBuilt?(0,w.$jc)((0,w.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,w.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,w.$jc)(this.g.appRoot,"bin","code"):(0,w.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return m.$jn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return v.$i&&(0,R.$c_b)()}async killProcess(F,V,J){process.kill(V,J)}async readClipboardText(F,V){return D.clipboard.readText(V)}async writeClipboardText(F,V,J){return D.clipboard.writeText(V,J)}async readClipboardFindText(F){return D.clipboard.readFindText()}async writeClipboardFindText(F,V){return D.clipboard.writeFindText(V)}async writeClipboardBuffer(F,V,J,le){return D.clipboard.writeBuffer(V,Buffer.from(J.buffer),le)}async readClipboardBuffer(F,V){return b.$se.wrap(D.clipboard.readBuffer(V))}async hasClipboard(F,V,J){return D.clipboard.has(V,J)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,V){this.D(F)?.updateTouchBar(V)}async notifyReady(F){this.D(F)?.setReady()}async relaunch(F,V){return this.f.relaunch(V)}async reload(F,V){const J=this.D(F);if(J){if((0,n.$ti)(J.openedWorkspace)){const le=J.openedWorkspace.configPath;if(le.scheme===l.Schemas.file&&(await this.n.resolveLocalWorkspace(le))?.transient)return this.openWindow(J.id,{forceReuseWindow:!0})}return this.f.reload(J,V?.disableExtensions!==void 0?{_:[],"disable-extensions":V.disableExtensions}:void 0)}}async closeWindow(F,V){return this.C(V?.targetWindowId,F)?.win?.close()}async quit(F){const V=this.a.getLastActiveWindow();V?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&V.win?V.win.close():this.f.quit()}async exit(F,V){await this.f.kill(V)}async resolveProxy(F,V){return this.D(F)?.win?.webContents?.session?.resolveProxy(V)}async loadCertificates(F){return(await new Promise((J,le)=>{Y(["@vscode/proxy-agent"],J,le)})).loadSystemCertificates({log:this.h})}findFreePort(F,V,J,le,re=1){return(0,k.$Cg)(V,J,le,re)}async openDevTools(F,V){this.C(V?.targetWindowId,F)?.win?.webContents.openDevTools(V?.mode?{mode:V.mode,activate:V.activate}:void 0)}async toggleDevTools(F,V){this.C(V?.targetWindowId,F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,V,J){const le=this.D(F);if(!le||!le.win)throw new Error;return await new I.$d_b(le.win,V,this.h).inspect(J)}async windowsGetStringRegKey(F,V,J,le){if(!v.$i)return;const re=await new Promise((ue,Z)=>{Y(["@vscode/windows-registry"],ue,Z)});try{return re.GetStringRegKey(V,J,le)}catch{return}}C(F,V){return this.D(F)??this.F(F)??this.D(V)}D(F){if(typeof F=="number")return this.a.getWindowById(F)}F(F){if(typeof F=="number")return this.b.getWindowById(F)}};e.$g_b=j,ve([A.$Ih],j.prototype,"z",null),e.$g_b=j=ve([se(0,i.$t$b),se(1,E.$e_b),se(2,f.$o$b),se(3,a.$M$b),se(4,d.$i$b),se(5,t.$yj),se(6,o.$Qj),se(7,r.$r$b),se(8,c.$F$b)],j)}),define(ae[299],ce([0,1,15,26,8,23,33,2,13,4,7,109,37,180,91,133,56,24,5,70,79,27,80,34,61,55,29]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d,$,a,t,o,r,i,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$h_b=void 0;const b="issue.processExplorerWindowState";let R=class{static{c=this}static{this.a="#1E1E1E"}constructor(C,j,U,F,V,J,le,re,ue,Z,X){this.g=C,this.h=j,this.i=U,this.j=F,this.k=V,this.l=J,this.m=le,this.n=re,this.o=ue,this.p=Z,this.q=X,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){y.$AV.on("vscode:listProcesses",async C=>{const j=[];try{j.push({name:(0,h.localize)(0,null),rootProcess:await(0,v.$ds)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(F=>{(0,m.$Vm)(F)?j.push({name:F.hostName,rootProcess:F}):F.processes&&j.push({name:F.hostName,rootProcess:F.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(C,"vscode:listProcessesResponse",j)}),y.$AV.on("vscode:workbenchCommand",(C,j)=>{const{id:U,from:F,args:V}=j;let J;switch(F){case"processExplorer":J=this.f;break;default:throw new Error(`Unexpected command source: ${F}`)}J?.webContents.send("vscode:runAction",{id:U,from:F,args:V})}),y.$AV.on("vscode:closeProcessExplorer",C=>{this.d?.close()}),y.$AV.on("vscode:pidToNameRequest",async C=>{const j=await this.k.getMainDiagnostics(),U=[];for(const F of j.windows)U.push([F.pid,`window [${F.id}] (${F.title})`]);for(const{pid:F,name:V}of r.$Z$b.getAll())U.push([F,V]);this.t(C,"vscode:pidToNameResponse",U)})}async openReporter(C){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const j=new P.$Sc,U=j.add(this.n.createIPCObjectUrl()),F=this.v(this.c,700,800);this.b=this.u(F,U,{backgroundColor:C.styles.backgroundColor,title:(0,h.localize)(1,null),zoomLevel:C.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:C,disableExtensions:!!this.h.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:$.default}),this.b.loadURL(g.$yg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(C){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const j=new P.$Sc,U=j.add(this.n.createIPCObjectUrl()),F=this.p.getItem(b,void 0),V=I(F)?F:this.v(this.f,800,500);this.d=this.u(V,U,{backgroundColor:C.styles.backgroundColor,title:(0,h.localize)(2,null),zoomLevel:C.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:C,product:$.default}),this.d.loadURL(g.$yg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const J=()=>{if(!this.d)return;const le=this.d.getSize(),re=this.d.getPosition();if(!le||!re)return;const ue={width:le[0],height:le[1],x:re[0],y:re[1]};this.p.setItem(b,ue)};this.d.on("moved",J),this.d.on("resized",J)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const C=await S.contentTracing.stopRecording(`${(0,A.$ng)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null,C),buttons:[(0,h.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,C)}async getSystemStatus(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(C,j)}async $getSystemInfo(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(C,j)}async $getPerformanceInfo(){try{const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(C,j)}catch(C){throw this.i.warn("issueService#getPerformanceInfo ",C.message),C}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(C){this.i.error(C)}}async $showConfirmCloseDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,h.localize)(6,null),buttons:[(0,h.localize)(7,null),(0,h.localize)(8,null)]},this.b);C===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,h.localize)(9,null),buttons:[(0,h.localize)(10,null),(0,h.localize)(11,null)]},this.b);return C===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const C=this.q.getWindowById(this.c.id);if(!C)throw new Error("Window not found");return C}async $getIssueReporterUri(C){const j=this.issueReporterWindowCheck(),U=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return s.Promises.withAsyncBody(async(F,V)=>{const J=new M.$ce;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",J.token,{replyChannel:U,extensionId:C}),y.$AV.once(U,(le,re)=>{F(w.URI.parse(re))});try{await(0,s.$fh)(5e3),J.cancel(),V(new Error("Timed out waiting for issue reporter URI"))}finally{y.$AV.removeHandler(U)}})}async $getIssueReporterData(C){const j=this.issueReporterWindowCheck(),U=`vscode:triggerIssueDataProviderResponse${j.id}`;return s.Promises.withAsyncBody(async F=>{const V=new M.$ce;j.sendWhenReady("vscode:triggerIssueDataProvider",V.token,{replyChannel:U,extensionId:C}),y.$AV.once(U,(J,le)=>{F(le)});try{await(0,s.$fh)(5e3),V.cancel(),F("Error: Extension timed out waiting for issue reporter data")}finally{y.$AV.removeHandler(U)}})}async $getIssueReporterTemplate(C){const j=this.issueReporterWindowCheck(),U=`vscode:triggerIssueDataTemplateResponse${j.id}`;return s.Promises.withAsyncBody(async F=>{const V=new M.$ce;j.sendWhenReady("vscode:triggerIssueDataTemplate",V.token,{replyChannel:U,extensionId:C}),y.$AV.once(U,(J,le)=>{F(le)});try{await(0,s.$fh)(5e3),V.cancel(),F("Error: Extension timed out waiting for issue reporter template")}finally{y.$AV.removeHandler(U)}})}async $getReporterStatus(C,j){const U=[!1,!1],F=this.issueReporterWindowCheck(),V="vscode:triggerReporterStatus",J=new M.$ce;return F.sendWhenReady(V,J.token,{replyChannel:V,extensionId:C,extensionName:j}),await(0,s.$8g)(new Promise(re=>y.$AV.once("vscode:triggerReporterStatusResponse",(ue,Z)=>re(Z))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),J.cancel()})??U}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(C){C.isMinimized()&&C.restore(),C.focus()}t(C,j,...U){C.sender.isDestroyed()||C.sender.send(j,...U)}u(C,j,U,F){const V=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:C.width,height:C.height,minWidth:300,minHeight:200,x:C.x,y:C.y,title:U.title,backgroundColor:U.backgroundColor||c.a,webPreferences:{preload:g.$yg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$$C)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return V.setMenuBarVisibility(!1),V}v(C,j,U){let F;const V=S.screen.getAllDisplays();if(V.length===1)F=V[0];else{if(l.$j){const re=S.screen.getCursorScreenPoint();F=S.screen.getDisplayNearestPoint(re)}!F&&C&&(F=S.screen.getDisplayMatching(C.getBounds())),F||(F=S.screen.getPrimaryDisplay()||V[0])}const J=F.bounds,le={width:j,height:U,x:J.x+J.width/2-j/2,y:J.y+J.height/2-U/2};return J.width>0&&J.height>0&&(le.x<J.x&&(le.x=J.x),le.y<J.y&&(le.y=J.y),le.x>J.x+J.width&&(le.x=J.x),le.y>J.y+J.height&&(le.y=J.y),le.width>J.width&&(le.width=J.width),le.height>J.height&&(le.height=J.height)),le}};e.$h_b=R,e.$h_b=R=c=ve([se(1,u.$i$b),se(2,f.$yj),se(3,m.$Um),se(4,p.$3$b),se(5,k.$o$b),se(6,d.$f_b),se(7,t.$q$b),se(8,a.$Qj),se(9,o.$sP),se(10,n.$t$b)],R);function I(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(ae[300],ce([0,1,23,18,24,20,5,70,27,53,28,49,101]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=void 0;let h=class extends y.$G_b{constructor(p,k,u,f,d,$,a,t){super(p,k,f,d,$,t),this.e=u,this.u=a}s(p){return(0,y.$F_b)(`linux-${process.arch}`,p,this.k)}t(p){this.a&&(this.d(v.$yW.CheckingForUpdates(p)),this.i.request({url:this.a},S.CancellationToken.None).then(l.$yp).then(k=>{!k||!k.url||!k.version||!k.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!p}),this.d(v.$yW.Idle(1))):this.d(v.$yW.AvailableForDownload(k))}).then(void 0,k=>{this.j.error(k);const u=p?k.message||k:void 0;this.d(v.$yW.Idle(1,u))}))}async o(p){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):p.update.url&&this.u.openExternal(void 0,p.update.url),this.d(v.$yW.Idle(1))}};e.$I_b=h,e.$I_b=h=ve([se(0,M.$M$b),se(1,D.$Ki),se(2,w.$Fl),se(3,s.$i$b),se(4,l.$sp),se(5,A.$yj),se(6,P.$f_b),se(7,g.$Qj)],h)}),define(ae[301],ce([0,1,48,46,26,8,23,50,45,9,7,144,21,18,24,16,20,5,70,27,53,28,49,101]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d,$,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K_b=void 0;async function r(b,R=1e3){for(;!b();)await(0,M.$fh)(R)}let i;function n(){return typeof i>"u"&&(i=D.existsSync(l.$jc(l.$mc(process.execPath),"unins000.exe"))?0:1),i}let c=class extends o.$G_b{get cachePath(){const R=l.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return y.Promises.mkdir(R,{recursive:!0}).then(()=>R)}constructor(R,I,E,C,j,U,F,V,J){super(R,I,C,j,U,J),this.u=E,this.v=F,this.w=V,R.setRelaunchHandler(this)}handleRelaunch(R){return R?.addArgs||R?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$yW.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(R){let I=`win32-${process.arch}`;return n()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$F_b)(I,R,this.k)}t(R){this.a&&(this.d(t.$yW.CheckingForUpdates(R)),this.i.request({url:this.a},A.CancellationToken.None).then($.$yp).then(I=>{const E=n();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!R}),this.d(t.$yW.Idle(E)),Promise.resolve(null)):E===1?(this.d(t.$yW.AvailableForDownload(I)),Promise.resolve(null)):(this.d(t.$yW.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(C=>y.Promises.exists(C).then(j=>{if(j)return Promise.resolve(C);const U=`${C}.tmp`;return this.i.request({url:I.url},A.CancellationToken.None).then(F=>this.v.writeFile(w.URI.file(U),F.stream)).then(I.sha256hash?()=>(0,v.$vV)(U,I.sha256hash):()=>{}).then(()=>y.Promises.rename(U,C,!1)).then(()=>C)})).then(C=>{const j=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:C},j?this.k.target==="user"?this.p():this.d(t.$yW.Downloaded(I)):this.d(t.$yW.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,g.$5i)(String(I)))}),this.j.error(I);const E=R?I.message||I:void 0;this.d(t.$yW.Idle(n(),E))}))}async o(R){R.update.url&&this.w.openExternal(void 0,R.update.url),this.d(t.$yW.Idle(n()))}async B(R){const I=await this.cachePath;return l.$jc(I,`CodeSetup-${this.k.quality}-${R}.exe`)}async C(R=null){const I=R?U=>!new RegExp(`${this.k.quality}-${R}\\.exe$`).test(U):()=>!0,E=await this.cachePath,j=(await y.Promises.readdir(E)).filter(I).map(async U=>{try{await y.Promises.unlink(l.$jc(E,U))}catch{}});await Promise.all(j)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const R=this.state.update;this.d(t.$yW.Updating(R));const I=await this.cachePath;this.e.updateFilePath=l.$jc(I,`CodeSetup-${this.k.quality}-${R.version}.flag`),await y.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$yW.Idle(n()))});const C=`${this.k.win32MutexName}-ready`,j=await new Promise((U,F)=>{Y(["@vscode/windows-mutex"],U,F)});r(()=>j.isActive(C)).then(()=>this.d(t.$yW.Ready(R)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?D.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(R){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),E={version:"unknown",productVersion:"unknown"};this.d(t.$yW.Downloading(E)),this.e={packagePath:R},I?this.k.target==="user"?this.p():this.d(t.$yW.Downloaded(E)):this.d(t.$yW.Ready(E))}};e.$K_b=c,ve([P.$Ih],c.prototype,"cachePath",null),e.$K_b=c=ve([se(0,k.$M$b),se(1,h.$Ki),se(2,a.$Fl),se(3,m.$i$b),se(4,$.$sp),se(5,u.$yj),se(6,p.$Bk),se(7,f.$f_b),se(8,d.$Qj)],c)}),define(ae[134],ce([0,1,15,8,23,51,3,2,13,67,4,7,190,26,65,18,56,24,64,16,20,5,27,80,252,82,28,104,69,55,29,30,58,96,39,34,57,68,22,6]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d,$,a,t,o,r,i,n,c,b,R,I,E,C,j,U,F,V,J,le,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=e.$J$b=void 0;var ue;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(ue||(ue={}));class Z extends P.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(A.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(A.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(A.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(A.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(A.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(A.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const T=!(0,R.$7C)(this.r);if(w.$j&&T&&L.setSheetOffset((0,w.$J)((0,h.release)())?28:22),T&&(w.$i&&(0,R.$9C)(this.r)||w.$j)){const G=this.s.getItem(Z.C);G&&this.updateWindowControls({height:G})}w.$i&&T&&L.hookWindowMessage(278,()=>{const[B,oe]=L.getPosition(),he=S.screen.getCursorScreenPoint(),K=he.x-B,O=he.y-oe;return!(K>30&&O>=0&&O<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:K,y:O})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),w.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.G?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.G?.complete(!0)})))}constructor(L,T,G,B){super(),this.r=L,this.s=T,this.t=G,this.u=B,this.a=this.B(new A.$5d),this.onDidClose=this.a.event,this.b=this.B(new A.$5d),this.onDidMaximize=this.b.event,this.c=this.B(new A.$5d),this.onDidUnmaximize=this.c.event,this.f=this.B(new A.$5d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new A.$5d),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new A.$5d),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.D=(0,R.$9C)(this.r),this.F=void 0,this.G=void 0}setRepresentedFilename(L){w.$j?this.win?.setRepresentedFilename(L):this.w=L}getRepresentedFilename(){return w.$j?this.win?.getRepresentedFilename():this.w}setDocumentEdited(L){w.$j&&this.win?.setDocumentEdited(L),this.z=L}isDocumentEdited(){return w.$j?!!this.win?.isDocumentEdited():!!this.z}focus(L){w.$j&&L?.force&&S.app.focus({steal:!0});const T=this.win;T&&(T.isMinimized()&&T.restore(),T.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(w.$j)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.C="windowControlHeight"}updateWindowControls(L){const T=this.win;if(T){if(L.height&&this.s.setItem(X.C,L.height),w.$i&&this.D)T.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(w.$j&&L.height!==void 0){const G=(L.height-15)/2;G?T.setWindowButtonPosition({x:G,y:G}):T.setWindowButtonPosition(null)}}}toggleFullScreen(){this.H(!this.isFullScreen,!1)}H(L,T){(0,R.$0C)(this.r)?this.I(L,T):this.L(L)}get isFullScreen(){if(w.$j&&typeof this.F=="boolean")return this.F;const L=this.win,T=L?.isFullScreen(),G=L?.isSimpleFullScreen();return!!(T||G)}I(L,T){const G=this.win;G?.isSimpleFullScreen()&&G?.setSimpleFullScreen(!1),this.J(L,T)}J(L,T){if(w.$j){this.F=L;const B=this.G=new D.$Bh;(async()=>{const oe=await Promise.race([B.p,(0,D.$fh)(1e4).then(()=>!1)]);this.G===B&&(this.F=void 0,this.G=void 0,!oe&&L&&T&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}L(L){const T=this.win;T?.isFullScreen()&&this.J(!1,!1),T?.setSimpleFullScreen(L),T?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$J$b=Z;let X=class extends Z{get id(){return this.P}get backupPath(){return this.R?.backupPath}get openedWorkspace(){return this.R?.workspace}get profile(){if(!this.config)return;const L=this.gb.profiles.find(T=>T.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.gb.getProfileForWorkspace(this.config.workspace??(0,E.$si)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.R?.remoteAuthority}get config(){return this.R}get isExtensionDevelopmentHost(){return!!this.R?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.R?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.R?.debugId}constructor(L,T,G,B,oe,he,K,O,W,x,N,Q,H,_,z,ee,ie,de,me,Ee,Pe){super(x,Ee,B,T),this.eb=G,this.fb=oe,this.gb=he,this.hb=K,this.ib=O,this.jb=W,this.kb=N,this.lb=Q,this.mb=H,this.nb=_,this.ob=z,this.pb=ee,this.qb=ie,this.rb=de,this.sb=me,this.M=this.B(new A.$5d),this.onWillLoad=this.M.event,this.N=this.B(new A.$5d),this.onDidSignalReady=this.N.event,this.O=this.B(new A.$5d),this.onDidDestroy=this.O.event,this.W=[],this.X=[],this.Y=void 0,this.Z=void 0,this.$=void 0,this.ab=this.B(this.rb.createIPCObjectUrl()),this.db=!1,this.tb=0;{const[Le,ke]=this.Db(L.state);this.S=Le,this.u.trace("window#ctor: using window state",Le);const ye=this.S.mode===0||this.S.mode===3,te=Pe.invokeFunction(I.$u$b,this.S,{show:!ye,webPreferences:{preload:g.$yg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.ab.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,l.mark)("code/willCreateCodeBrowserWindow"),this.m=new S.BrowserWindow(te),(0,l.mark)("code/didCreateCodeBrowserWindow"),this.P=this.m.id,this.n(this.m);const fe=this.r.getValue("window"),$e=w.$j&&fe?.nativeTabs===!0;(w.$j||w.$i)&&ke&&(!$e||S.BrowserWindow.getAllWindows().length===1)&&[this.S.width,this.S.height,this.S.x,this.S.y].every(Ce=>typeof Ce=="number")&&this.m.setBounds({width:this.S.width,height:this.S.height,x:this.S.x,y:this.S.y}),ye&&((0,l.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.S.mode===3&&this.H(!0,!0),this.m.show(),(0,l.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Jb(),this.ub()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.P})`),this.tb=2;this.W.length;)this.W.pop()(this);this.N.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.W.push(L)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(L=>{function T(){G.dispose(),B.dispose(),L()}const G=this.onDidClose(()=>T()),B=this.onWillLoad(()=>T())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(T,G)=>this.xb(2,{...G})),this.m.webContents.on("did-fail-load",(T,G,B)=>this.xb(3,{reason:B,exitCode:G})),this.m.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.bb&&(this.R=this.bb,this.bb=void 0)}),this.B(this.onDidMaximize(()=>{this.R&&(this.R.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.R&&(this.R.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(T=>this.Ab(T))),this.B(this.lb.onDidDeleteUntitledWorkspace(T=>this.zb(T)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(T,G)=>{const B=await this.wb();G({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,B)})})}wb(){return this.vb||(this.vb=(0,r.$Mp)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(L,T){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:L,reason:T?.reason,code:T?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:B}=await this.ob.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null),(0,y.localize)(2,null)],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),checkboxLabel:this.R?.workspace?(0,y.localize)(5,null):void 0},this.m);if(G!==2){const oe=G===0;await this.yb(oe,B)}}else if(L===2){let G;T?G=(0,y.localize)(7,null,T.reason,T.exitCode??"<unknown>"):G=(0,y.localize)(6,null);const{response:B,checkboxChecked:oe}=await this.ob.showMessageBox({type:"warning",buttons:[this.R?.workspace?(0,y.localize)(8,null):(0,y.localize)(9,null),(0,y.localize)(10,null)],message:G,detail:this.R?.workspace?(0,y.localize)(11,null):(0,y.localize)(12,null),checkboxLabel:this.R?.workspace?(0,y.localize)(13,null):void 0},this.m),he=B===0;await this.yb(he,oe)}break}}async yb(L,T){const G=this.R?.workspace;if(T&&G)try{const B=this.jb.workspaceStorage(G);await B.init(),B.delete("memento/workbench.parts.editor"),await B.close()}catch(B){this.u.error(B)}this.O.fire();try{if(L&&this.R){let B,oe;(0,E.$oi)(G)?B={folderUri:G.uri}:(0,E.$ti)(G)?B={workspaceUri:G.configPath}:oe=!0,(0,le.$Ob)(await this.sb.open({context:5,userEnv:this.R.userEnv,cli:{...this.t.args,_:[]},urisToOpen:B?[B]:void 0,forceEmpty:oe,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(L){this.R?.workspace?.id===L.id&&(this.R.workspace=void 0)}Ab(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const T=this.Fb();T!==this.U&&(this.U=T,this.Gb(T))}if(!L||L.affectsConfiguration("http.proxy")){let T=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.Y||G!==this.Z)){this.Y=T,this.Z=G;const B=T||"",oe=G?`${G},<local>`:"<local>";this.u.trace(`Setting proxy to '${B}', bypassing '${oe}'`),this.m.webContents.session.setProxy({proxyRules:B,proxyBypassRules:oe,pacScript:""})}}}addTabbedWindow(L){w.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,T=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.P})`),this.isDocumentEdited()&&(!T.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(L,T),this.tb===0?this.R=L:this.bb=L,this.tb=1,this.m.loadURL(g.$yg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.db;this.db=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new D.$qh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.M.fire({workspace:L.workspace,reason:T.isReload?3:G?2:1})}Bb(L,T){const G=(this.R??this.bb)?.userEnv;if(G){const B=(0,f.$em)(G)&&!(0,f.$em)(L.userEnv),oe=this.isExtensionDevelopmentHost;(B||oe)&&(L.userEnv={...G,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(L["disable-extensions"]=T.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.kb.getWindowSplash(),L.zoomLevel=this.Ib(),L.isCustomZoomLevel=typeof this.$=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),L.perfMarks=(0,l.getMarks)(),this.ab.update(L)}async reload(L){const T=Object.assign({},this.R);T.workspace=await this.Cb(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&L&&(T.verbose=L.verbose,T.debugId=L.debugId,T.extensionEnvironment=L.extensionEnvironment,T["inspect-extensions"]=L["inspect-extensions"],T["inspect-brk-extensions"]=L["inspect-brk-extensions"],T["extensions-dir"]=L["extensions-dir"]),T.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),T.isInitialStartup=!1,T.policiesData=this.fb.serialize(),T.continueOn=this.t.continueOn,T.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},T.logLevel=this.eb.getLogLevel(),T.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(T,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Cb(L){if((0,E.$ti)(L.workspace)){const T=L.workspace.configPath;if(T.scheme===g.Schemas.file&&!await this.hb.exists(T))return}else if((0,E.$oi)(L.workspace)){const T=L.workspace.uri;if(T.scheme===g.Schemas.file&&!await this.hb.exists(T))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,j.$h$b)();if(this.isFullScreen){let G;try{G=S.screen.getDisplayMatching(this.getBounds())}catch{}const B=(0,j.$h$b)();return{mode:3,display:G?G.id:void 0,width:this.S.width||B.width,height:this.S.height||B.height,x:this.S.x||0,y:this.S.y||0,zoomLevel:this.$}}const L=Object.create(null);let T;if(!w.$j&&this.m.isMaximized()?T=0:T=1,T===0?L.mode=0:L.mode=1,T===1||T===0){let G;T===1?G=this.getBounds():G=this.m.getNormalBounds(),L.x=G.x,L.y=G.y,L.width=G.width,L.height=G.height}return L.zoomLevel=this.$,L}Db(L){(0,l.mark)("code/willRestoreCodeWindowState");let T=!1;if(L){this.$=L.zoomLevel;try{const G=S.screen.getAllDisplays();T=G.length>1,L=I.WindowStateValidator.validateWindowState(this.u,L,G)}catch(G){this.u.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[L||(0,j.$h$b)(),T]}getBounds(){const[L,T]=this.m.getPosition(),[G,B]=this.m.getSize();return{x:L,y:T,width:G,height:B}}H(L,T){super.H(L,T),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.U&&this.Gb(this.U,!1)}Fb(){let L=(0,R.$5C)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Gb(L,T=!0){w.$j||(L==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,y.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Hb(L)}):this.Hb(L))}Hb(L){const T=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!T),this.m.autoHideMenuBar=T;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.$=L}Ib(){return typeof this.$=="number"?this.$:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,T,...G){this.isReady?this.send(L,...G):this.ready().then(()=>{T.isCancellationRequested||this.send(L,...G)})}send(L,...T){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...T)}catch(G){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.P}: ${(0,M.$2i)(G)}`)}}}updateTouchBar(L){w.$j&&this.X.forEach((T,G)=>{const B=L[G];T.segments=this.Lb(B)})}Jb(){if(w.$j){for(let L=0;L<10;L++){const T=this.Kb();this.X.push(T)}this.m.setTouchBar(new S.TouchBar({items:this.X}))}}Kb(L=[]){const T=this.Lb(L),G=new S.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:B=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:G.segments[B].id,from:"touchbar"})}});return G}Lb(L=[]){return L.map(G=>{let B;G.icon&&!c.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===g.Schemas.file&&(B=S.nativeImage.createFromPath(v.URI.revive(G.icon.dark).fsPath),B.isEmpty()&&(B=void 0));let oe;return typeof G.title=="string"?oe=G.title:oe=G.title.value,{id:G.id,label:B?void 0:oe,icon:B}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$K$b=X,e.$K$b=X=ve([se(1,a.$yj),se(2,J.$H$b),se(3,u.$i$b),se(4,U.$Vn),se(5,V.$w$b),se(6,d.$Bk),se(7,i.$U$b),se(8,i.$S$b),se(9,p.$Ki),se(10,b.$r$b),se(11,C.$F$b),se(12,m.$n$b),se(13,n.$Fl),se(14,k.$o$b),se(15,$.$M$b),se(16,t.$Qj),se(17,o.$q$b),se(18,I.$t$b),se(19,F.$sP),se(20,re.$di)],X)}),define(ae[302],ce([0,1,15,4,18,24,20,5,34,55,134]),function(Y,e,S,D,s,M,A,P,g,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=void 0;let v=class extends w.$J$b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(h,m,p,k,u,f){super(k,u,m,p),this.M=h,this.N=f,this.id=this.M.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.M.isDestroyed())return;const h=S.BrowserWindow.fromWebContents(this.M);h&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(h),h.setMenu(null),(D.$i||D.$k)&&(0,l.$7C)(this.r)&&h.setAutoHideMenuBar(!0),this.N.registerAuxWindow(this))}};e.$L$b=v,e.$L$b=v=ve([se(1,M.$i$b),se(2,P.$yj),se(3,s.$Ki),se(4,g.$sP),se(5,A.$M$b)],v)}),define(ae[303],ce([0,1,15,3,2,13,37,302,6,5,29]),function(Y,e,S,D,s,M,A,P,g,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dac=void 0;let v=class extends s.$Tc{constructor(h,m){super(),this.h=h,this.j=m,this.a=this.B(new D.$5d),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new D.$5d),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new D.$5d),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new D.$5d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){S.app.on("browser-window-created",(h,m)=>{const p=this.getWindowById(m.id);p&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow())}),A.$AV.handle("vscode:registerAuxiliaryWindow",async(h,m)=>{const p=this.getWindowById(h.sender.id);return p&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=m),h.sender.id})}createWindow(h){return this.h.invokeFunction(w.$u$b,this.n(h),{webPreferences:{preload:M.$yg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}n(h){const m={},p=h.features.split(",");for(const k of p){const[u,f]=k.split("=");switch(u){case"width":m.width=parseInt(f,10);break;case"height":m.height=parseInt(f,10);break;case"left":m.x=parseInt(f,10);break;case"top":m.y=parseInt(f,10);break}}return w.WindowStateValidator.validateWindowState(this.j,m)}registerWindow(h){const m=new s.$Sc,p=this.h.createInstance(P.$L$b,h);this.g.set(p.id,p),m.add((0,s.$Rc)(()=>this.g.delete(p.id))),m.add(p.onDidMaximize(()=>this.a.fire(p))),m.add(p.onDidUnmaximize(()=>this.b.fire(p))),m.add(p.onDidEnterFullScreen(()=>this.c.fire({window:p,fullscreen:!0}))),m.add(p.onDidLeaveFullScreen(()=>this.c.fire({window:p,fullscreen:!1}))),m.add(p.onDidTriggerSystemContextMenu(({x:k,y:u})=>this.f.fire({window:p,x:k,y:u}))),D.Event.once(p.onDidClose)(()=>m.dispose())}getWindowById(h){return this.g.get(h)}getFocusedWindow(){const h=S.BrowserWindow.getFocusedWindow();if(h)return this.getWindowById(h.id)}getLastActiveWindow(){return(0,w.$v$b)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$dac=v,e.$dac=v=ve([se(0,g.$di),se(1,l.$yj)],v)}),define(ae[83],ce([0,1,15,22,8,3,47,2,13,4,19,7,21,193,6,20,5,82,98,30,58,31,56]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d,$,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$s_b=e.$r_b=void 0,e.$r_b=(0,m.$ei)("workspacesHistoryMainService");let r=class extends P.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(n,c,b,R,I){super(),this.f=n,this.g=c,this.h=b,this.j=R,this.m=I,this.c=this.B(new M.$5d),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new s.$ch(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let c=[],b=[];for(const I of n)if((0,f.$aeb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(c,I.workspace)&&c.push(I);else if((0,f.$beb)(I))this.y(c,I.folderUri)||c.push(I);else{const E=this.z(b,I.fileUri),C=I.fileUri.scheme===g.Schemas.file&&o.G.indexOf((0,w.$Og)(I.fileUri))>=0;!E&&!C&&(b.push(I),l.$i&&I.fileUri.scheme===g.Schemas.file&&S.app.addRecentDocument(I.fileUri.fsPath))}const R=await this.r({workspaces:c,files:b});c=R.workspaces,b=R.files,c.length>o.a&&(c.length=o.a),b.length>o.a&&(b.length=o.a),await this.t({workspaces:c,files:b}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(n){const c=E=>{const C=this.u(E);for(const j of n)if(w.$Ig.isEqual(j,C))return!1;return!0},b=await this.getRecentlyOpened(),R=b.workspaces.filter(c),I=b.files.filter(c);(R.length!==b.workspaces.length||I.length!==b.files.length)&&(await this.t({files:I,workspaces:R}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:c}=await this.m.showMessageBox({type:"warning",buttons:[(0,h.localize)(0,null),(0,h.localize)(1,null)],message:(0,h.localize)(2,null),detail:(0,h.localize)(3,null),cancelId:1});if(c!==0)return}await this.t({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(n){const c=new a.$Ac(I=>w.$Ig.getComparisonKey(I));if(n?.workspaces)for(const I of n.workspaces)c.set(this.u(I),I);const b=new a.$Ac(I=>w.$Ig.getComparisonKey(I));if(n?.files)for(const I of n.files)b.set(this.u(I),I);const R=await this.s();for(const I of R.workspaces){const E=c.get(this.u(I));E?E.label=E.label??I.label:c.set(this.u(I),I)}for(const I of R.files){const E=b.get(this.u(I));E?E.label=E.label??I.label:b.set(this.u(I),I)}return{workspaces:[...c.values()],files:[...b.values()]}}async s(){await this.j.whenReady;let n;const c=this.j.get(o.b,-1);if(typeof c=="string")try{n=JSON.parse(c)}catch(b){this.f.error("Unexpected error parsing opened paths list",b)}return(0,f.$heb)(n,this.f)}async t(n){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,f.$ieb)(n)),-1,1)}u(n){return(0,f.$beb)(n)?n.folderUri:(0,f.$ceb)(n)?n.fileUri:n.workspace.configPath}w(n,c){return!!n.find(b=>(0,f.$aeb)(b)&&b.workspace.id===c.id)}y(n,c){return!!n.find(b=>(0,f.$beb)(b)&&w.$Ig.isEqual(b.folderUri,c))}z(n,c){return!!n.find(b=>w.$Ig.isEqual(b.fileUri,c))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){l.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!l.$i)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(4,null),description:(0,h.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const c=[];for(const I of S.app.getJumpListSettings().removedItems){const E=I.args;if(E){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(E);C&&c.push(v.URI.parse(C[2]))}}await this.removeRecentlyOpened(c);let b=!1;const R=(0,D.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const E=(0,f.$aeb)(I)?I.workspace:I.folderUri,{title:C,description:j}=this.L(E,I.label);let U;return v.URI.isUri(E)?U=`--folder-uri "${E.toString()}"`:(b=!0,U=`--file-uri "${E.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:j.substr(0,255),program:process.execPath,args:U,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&n.push({type:"custom",name:b?(0,h.localize)(6,null):(0,h.localize)(7,null),items:R})}n.push({type:"recent"});try{const c=S.app.setJumpList(n);c&&c!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${c}`)}catch(c){this.f.warn("updateWindowsJumpList#setJumpList",c)}}L(n,c){if(c)return{title:(0,A.$ew)(c).name,description:c};if(v.URI.isUri(n))return{title:(0,w.$Og)(n),description:this.M(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,h.localize)(8,null),description:""};let b=(0,w.$Og)(n.configPath);return b.endsWith(d.$Ai)&&(b=b.substr(0,b.length-d.$Ai.length-1)),{title:(0,h.localize)(9,null,b),description:this.M(n.configPath)}}M(n){return n.scheme==="file"?(0,A.$9v)(n.fsPath):n.toString()}async N(){if(!l.$j)return;S.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),c=[];let b=0;for(let I=0;I<n.workspaces.length&&b<o.C;I++){const E=this.u(n.workspaces[I]);if(E.scheme===g.Schemas.file){const C=(0,w.$Fg)(E);await y.Promises.exists(C)&&(c.push(C),b++)}}const R=[];for(let I=0;I<n.files.length&&b<o.D;I++){const E=this.u(n.files[I]);if(E.scheme===g.Schemas.file){const C=(0,w.$Fg)(E);if(o.G.includes((0,w.$Og)(E))||c.includes(C))continue;await y.Promises.exists(C)&&(R.push(C),b++)}}R.reverse().forEach(I=>S.app.addRecentDocument(I)),c.reverse().forEach(I=>S.app.addRecentDocument(I))}};e.$s_b=r,e.$s_b=r=o=ve([se(0,k.$yj),se(1,$.$F$b),se(2,p.$M$b),se(3,u.$U$b),se(4,t.$o$b)],r)}),define(ae[304],ce([0,1,15,8,23,47,4,7,181,78,18,24,20,5,231,70,27,34,28,49,55,29,83]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d,$,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$t_b=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(b,R,I,E,C,j,U,F,V,J,le,re){this.n=b,this.o=R,this.p=I,this.q=E,this.r=C,this.s=j,this.t=U,this.u=F,this.v=V,this.w=J,this.x=le,this.y=re,this.m=Object.create(null),this.g=new D.$qh(()=>this.F(),0),this.h=new D.$qh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.$j||(0,$.$7C)(R))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const b=this.t.getItem(o.a);b&&(b.menus&&(this.k=b.menus),b.keybindings&&(this.l=b.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(j,U,F)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:U?.id})},this.m["workbench.action.newWindow"]=(j,U,F)=>this.p.openEmptyWindow({context:2,contextWindowId:U?.id}),this.m["workbench.action.files.openFileFolder"]=(j,U,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(j,U,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(j,U,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const b=this.x.youTubeUrl;b&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(b,"openYouTubeUrl"));const R=this.x.requestFeatureUrl;R&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(R,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const E=this.x.licenseUrl;E&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.$w){const j=E.indexOf("?")>0?"&":"?";this.ab(`${E}${j}lang=${A.$w}`,"openLicenseUrl")}else this.ab(E,"openLicenseUrl")});const C=this.x.privacyStatementUrl;C&&E&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(C,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(b=>this.G(b)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const b=this.o.getValue("window.enableMenuBarMnemonics");return typeof b!="boolean"?!0:b}get D(){if(!A.$j)return!1;const b=this.o.getValue("window.nativeTabs");return typeof b!="boolean"?!1:b}updateMenu(b,R){this.k=b.menus,this.l=b.keybindings,this.t.setItem(o.a,b),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(b){A.$j&&(b.oldCount===0&&b.newCount>0||b.oldCount>0&&b.newCount===0)&&(this.d=b.newCount===0,this.E())}H(){if(!A.$j)return;const b=S.BrowserWindow.getFocusedWindow();this.f=!b||!!this.y.getWindowById(b.id),this.E()}I(){const b=S.Menu.getApplicationMenu();if(b&&this.j.push(b),Object.keys(this.k).length===0){this.J(A.$j?new S.Menu:null);return}const R=new S.Menu;let I;if(A.$j){const C=new S.Menu;I=new S.MenuItem({label:this.x.nameShort,submenu:C}),this.K(C),R.append(I)}if(A.$j&&!this.c){this.c=!0;const C=new S.Menu;C.append(new S.MenuItem({label:this.cb(g.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(C)}if(this.M("File")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(1,null)),submenu:C});this.O(C,"File"),R.append(j)}if(this.M("Edit")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(2,null)),submenu:C});this.O(C,"Edit"),R.append(j)}if(this.M("Selection")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(3,null)),submenu:C});this.O(C,"Selection"),R.append(j)}if(this.M("View")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(4,null)),submenu:C});this.O(C,"View"),R.append(j)}if(this.M("Go")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(5,null)),submenu:C});this.O(C,"Go"),R.append(j)}if(this.M("Run")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(6,null)),submenu:C});this.O(C,"Run"),R.append(j)}if(this.M("Terminal")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(7,null)),submenu:C});this.O(C,"Terminal"),R.append(j)}let E;if(this.M("Window")){const C=new S.Menu;E=new S.MenuItem({label:this.cb(g.localize(8,null)),submenu:C,role:"window"}),this.U(C)}if(E&&R.append(E),this.M("Help")){const C=new S.Menu,j=new S.MenuItem({label:this.cb(g.localize(9,null)),submenu:C,role:"help"});this.O(C,"Help"),R.append(j)}R.items&&R.items.length>0?this.J(R):this.J(null),this.h.schedule()}J(b){if(S.Menu.setApplicationMenu(b),b)for(const R of this.y.getWindows())R.win?.setMenu(null)}K(b){const R=this.W(g.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let E;if(this.M("Preferences")){const re=new S.Menu;this.O(re,"Preferences"),E=new S.MenuItem({label:this.cb(g.localize(11,null)),submenu:re})}const C=new S.Menu,j=new S.MenuItem({label:g.localize(12,null),role:"services",submenu:C}),U=new S.MenuItem({label:g.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new S.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),V=new S.MenuItem({label:g.localize(15,null),role:"unhide"}),J=new S.MenuItem(this.$("workbench.action.quit",{label:g.localize(16,null,this.x.nameLong),click:async(re,ue,Z)=>{const X=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||X?.win?.isMinimized())&&await this.L(Z)&&this.w.quit(void 0)}})),le=[R];le.push(...I),E&&le.push(n(),E),le.push(n(),j,n(),U,F,V,n(),J),le.forEach(re=>b.append(re))}async L(b){if(this.p.getWindowCount()===0)return!0;const R=this.o.getValue("window.confirmBeforeClose");if(R==="always"||R==="keyboardOnly"&&this.S(b)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[g.localize(17,null),g.localize(18,null)],message:g.localize(19,null)});return I===0}return!0}M(b){if(!A.$j&&!(0,$.$7C)(this.o))return!1;switch(b){case"File":case"Help":if(A.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[b];case"Window":if(A.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[b]}}N(b,R){R.forEach(I=>{if((0,m.$o_b)(I))b.append(n());else if((0,m.$n_b)(I)){const E=new S.Menu,C=new S.MenuItem({label:this.cb(I.label),submenu:E});this.N(E,I.submenu.items),b.append(C)}else(0,m.$p_b)(I)?b.append(this.Q(I)):(0,m.$q_b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(b),A.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?b.append(new S.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):b.append(this.W(I.label,I.id,!1,I.checked)):b.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):b.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(b,R){this.k&&this.k[R]&&this.N(b,this.k[R].items)}P(b){const R=this.V();R.length&&(R.forEach(I=>b.append(I)),b.append(n()))}Q(b){const R=P.URI.revive(b.uri),I=b.id,E=I==="openRecentFile"?{fileUri:R}:I==="openRecentWorkspace"?{workspaceUri:R}:{folderUri:R};return new S.MenuItem(this.$(I,{label:b.label,click:async(C,j,U)=>{const F=this.R(U);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[E],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:b.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([R])}},!1))}R(b){return!!(b&&(!A.$j&&(b.ctrlKey||b.shiftKey)||A.$j&&(b.metaKey||b.altKey)))}S(b){return!!(b.triggeredByAccelerator||b.altKey||b.ctrlKey||b.metaKey||b.shiftKey)}T(b,R,I){const E={label:this.cb(b),role:I,enabled:!0};return new S.MenuItem(this.Z(R,E))}U(b){const R=new S.MenuItem({label:g.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new S.MenuItem({label:g.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),E=new S.MenuItem({label:g.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),C=this.W(g.localize(23,null),"workbench.action.switchWindow"),j=[];this.D&&(j.push(n()),j.push(this.W(g.localize(24,null),"workbench.action.newWindowTab")),j.push(this.T(g.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),j.push(this.T(g.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),j.push(this.T(g.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),j.push(this.T(g.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[R,I,n(),C,...j,n(),E].forEach(U=>b.append(U))}V(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.cb(g.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:g.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.cb(g.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:g.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.cb(g.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:g.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.cb(g.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(b,R,I,E){const C=this.cb(b),j=typeof R=="function"?R:(le,re,ue)=>{const Z=le?le.userSettingsLabel:null;let X=R;Array.isArray(R)&&(X=this.R(ue)?R[1]:R[0]),Z&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Z}):this.Y({type:"commandId",commandId:X})},U=typeof I=="boolean"?I:this.p.getWindowCount()>0,F=typeof E=="boolean"?E:!1,V={label:C,click:j,enabled:U};F&&(V.type="checkbox",V.checked=F);let J;return typeof R=="string"?J=R:Array.isArray(R)&&(J=R[0]),A.$j&&(J==="editor.action.clipboardCutAction"?V.role="cut":J==="editor.action.clipboardCopyAction"?V.role="copy":J==="editor.action.clipboardPasteAction"&&(V.role="paste"),J==="undo"?V.click=this.X(j,{inDevTools:le=>le.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):J==="redo"?V.click=this.X(j,{inDevTools:le=>le.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):J==="editor.action.selectAll"&&(V.click=this.X(j,{inDevTools:le=>le.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.Z(J,V))}X(b,R){return(I,E,C)=>{const j=S.BrowserWindow.getFocusedWindow();if(!j)return R.inNoWindow();if(j.webContents.isDevToolsFocused()&&j.webContents.devToolsWebContents)return R.inDevTools(j.webContents.devToolsWebContents);b(I,E||j,C)}}Y(b){let R=S.BrowserWindow.getFocusedWindow();if(R){const E=this.y.getWindowById(R.id);E&&(R=this.p.getWindowById(E.parentId)?.win??null)}if(!R){const E=this.p.getLastActiveWindow();E?.win?.isMinimized()&&(R=E.win)}const I=R?this.p.getWindowById(R.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",b),A.$j&&!this.q.isBuilt&&!I.isReady&&(b.type==="commandId"&&b.commandId==="workbench.action.toggleDevTools"||b.type!=="commandId"&&b.userSettingsLabel==="alt+cmd+i"))return!1;if(b.type==="commandId"){const E={id:b.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,E)}else{const E={userSettingsLabel:b.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,E)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",b),!1}Z(b,R){const I=typeof b=="string"?this.l[b]:void 0;if(I?.label){if(I.isNative!==!1)R.accelerator=I.label,R.userSettingsLabel=I.userSettingsLabel;else if(typeof R.label=="string"){const E=R.label.indexOf("[");E>=0?R.label=`${R.label.substr(0,E)} [${I.label}]`:R.label=`${R.label} [${I.label}]`}}else R.accelerator=void 0;return R}$(b,R,I=!R.accelerator){I&&(R=this.Z(b,R));const E=R.click;return R.click=(C,j,U)=>{this.bb(b),E?.(C,j,U)},R}ab(b,R){this.w.openExternal(void 0,b),this.bb(R)}bb(b){this.r.publicLog2("workbenchActionExecuted",{id:b,from:r})}cb(b){return(0,M.$bw)(b,!this.C)}};e.$t_b=i,e.$t_b=i=o=ve([se(0,d.$zW),se(1,w.$Ki),se(2,a.$t$b),se(3,v.$i$b),se(4,f.$Fl),se(5,t.$r_b),se(6,u.$sP),se(7,y.$M$b),se(8,h.$yj),se(9,p.$f_b),se(10,k.$Qj),se(11,l.$e_b)],i);function n(){return new S.MenuItem({type:"separator"})}}),define(ae[305],ce([0,1,6,20,5,304]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=e.$u_b=void 0,e.$u_b=(0,S.$ei)("menubarMainService");let A=class{constructor(g,l,w){this.b=g,this.c=l,this.d=w,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$t_b)}async updateMenubar(g,l){this.d.trace("menubarService#updateMenubar",g),(await this.a).updateMenu(l,g)}};e.$v_b=A,e.$v_b=A=ve([se(0,S.$di),se(1,D.$M$b),se(2,s.$yj)],A)}),define(ae[306],ce([0,1,15,21,132,26,22,23,3,33,47,2,13,9,67,4,36,19,12,7,191,65,18,56,24,16,6,20,5,79,80,60,34,55,134,29,131,298,30,99,83,58,69,39,57,68,78]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d,$,a,t,o,r,i,n,c,b,R,I,E,C,j,U,F,V,J,le,re,ue,Z,X,q,L,T,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=void 0;function B(K){return(0,le.$ti)(K?.workspace)}function oe(K){return(0,le.$oi)(K?.workspace)}let he=class extends v.$Tc{constructor(O,W,x,N,Q,H,_,z,ee,ie,de,me,Ee,Pe,Le,ke,ye,te,fe,$e){super(),this.s=O,this.t=W,this.u=x,this.w=N,this.z=Q,this.C=H,this.D=_,this.F=z,this.G=ee,this.H=ie,this.I=de,this.J=me,this.L=Ee,this.M=Pe,this.N=Le,this.O=ke,this.P=ye,this.Q=te,this.R=fe,this.S=$e,this.a=this.B(new g.$5d),this.onDidOpenWindow=this.a.event,this.b=this.B(new g.$5d),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new g.$5d),this.onDidDestroyWindow=this.c.event,this.f=this.B(new g.$5d),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new g.$5d),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new g.$5d),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new g.$5d),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new g.$5d),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new J.$S_b(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const W=new v.$Sc;if(W.add(g.Event.any(O.onDidClose,O.onDidDestroy)(()=>W.dispose())),O.config.extensionDevelopmentPath)for(const x of O.config.extensionDevelopmentPath)W.add(this.Q.addValidFileRoot(x));O.config.extensionTestsPath&&W.add(this.Q.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,W){const x=this.F.args,N=W?.remoteAuthority||void 0,Q=!0,H=W?.forceReuseWindow,_=!H;return this.open({...O,cli:x,forceEmpty:Q,forceNewWindow:_,forceReuseWindow:H,remoteAuthority:N})}openExistingWindow(O,W){O.focus(),this.W(W,[O])}async open(O){this.w.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const W=[],x=[],N=[],Q=[],H=[];let _,z=0;const ee=await this.cb(O);this.w.trace("windowsManager#open pathsToOpen",ee);for(const Pe of ee)oe(Pe)?O.addMode?W.push(Pe):x.push(Pe):B(Pe)?N.push(Pe):Pe.fileUri?(_||(_={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),_.filesToOpenOrCreate.push(Pe)):Pe.backupPath?H.push({backupFolder:(0,h.$nc)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):z++;O.diffMode&&_&&_.filesToOpenOrCreate.length>=2&&(_.filesToDiff=_.filesToOpenOrCreate.slice(0,2),_.filesToOpenOrCreate=[]),O.mergeMode&&_&&_.filesToOpenOrCreate.length===4&&(_.filesToMerge=_.filesToOpenOrCreate.slice(0,4),_.filesToOpenOrCreate=[],_.filesToDiff=[]),_&&O.waitMarkerFileURI&&(_.filesToWait={paths:(0,A.$Hb)([..._.filesToDiff,_.filesToMerge[3],..._.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(Q.push(...this.M.getUntitledWorkspaces()),N.push(...Q),H.push(...this.I.getEmptyWindowBackups())):H.length=0;const{windows:ie,filesOpenedInWindow:de}=await this.X(O,N,x,H,z,_,W);if(this.w.trace(`windowsManager#open used window count ${ie.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${x.length}, emptyToRestore: ${H.length}, emptyToOpen: ${z})`),ie.length>1)if(de)de.focus();else{const Pe=this.r.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Le=!0,ke=!0;if(Pe){const ye=ie.filter(te=>this.r.state.lastActiveWindow&&te.backupPath===this.r.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),Le=!1,ke=!1)}if(Le)for(let ye=ie.length-1;ye>=0;ye--){const te=ie[ye];if(!(te.openedWorkspace&&Q.some(fe=>te.openedWorkspace&&fe.workspace.id===te.openedWorkspace.id)||te.backupPath&&H.some(fe=>te.backupPath&&fe.backupFolder===(0,h.$nc)(te.backupPath)))){te.focus(),ke=!1;break}}ke&&ie[ie.length-1].focus()}const me=_&&_.filesToDiff.length>0,Ee=_&&_.filesToMerge.length>0;if(!ie.some(Pe=>Pe.isExtensionDevelopmentHost)&&!me&&!Ee&&!O.noRecentEntry){const Pe=[];for(const Le of ee)B(Le)&&!Le.transient?Pe.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):oe(Le)?Pe.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Pe.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.L.addRecentlyOpened(Pe)}return this.W(O,ie),ie}W(O,W){const x=O.waitMarkerFileURI;O.context===0&&x&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.P.del(x)}catch{}})()}async X(O,W,x,N,Q,H,_){const z=[];let ee;function ie(ye,te){z.push(ye),te&&(ee=ye,H=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:me}=this.ob(O);if(!O.initialStartup&&_.length>0){const ye=_[0].remoteAuthority,te=this.ub(ye);te&&ie(this.$(te,_.map(fe=>fe.workspace.uri)))}const Ee=x.length+W.length+N.length;if(H&&Ee===0){const ye=H.filesToOpenOrCreate[0]||H.filesToDiff[0]||H.filesToMerge[3],te=this.getWindows().filter($e=>H&&(0,u.$Wg)($e.remoteAuthority,H.remoteAuthority));let fe;ye?.fileUri&&!me&&((O.context===4||O.context===0||O.context===1)&&(fe=await(0,V.$y$b)(te,ye.fileUri,async $e=>$e.configPath.scheme===y.Schemas.file?this.M.resolveLocalWorkspace($e.configPath):void 0)),fe||(fe=this.vb(te))),fe?(0,le.$ti)(fe.openedWorkspace)?W.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,le.$oi)(fe.openedWorkspace)?x.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):ie(this.Y(O,fe,H),!0):ie(await this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:H,forceNewWindow:!0,remoteAuthority:H.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Pe=(0,A.$Mb)(W,ye=>ye.workspace.id);if(Pe.length>0){const ye=(0,A.$Hb)(Pe.map(te=>(0,V.$z$b)(this.getWindows(),te.workspace.configPath)));if(ye.length>0){const te=ye[0],fe=(0,u.$Wg)(H?.remoteAuthority,te.remoteAuthority)?H:void 0;ie(this.Y(O,te,fe),!!fe),de=!0}for(const te of Pe){if(ye.some(Ce=>Ce.openedWorkspace&&Ce.openedWorkspace.id===te.workspace.id))continue;const fe=te.remoteAuthority,$e=(0,u.$Wg)(H?.remoteAuthority,fe)?H:void 0;ie(await this.bb(O,te,de,$e),!!$e),de=!0}}const Le=(0,A.$Mb)(x,ye=>u.$Ig.getComparisonKey(ye.workspace.uri));if(Le.length>0){const ye=(0,A.$Hb)(Le.map(te=>(0,V.$z$b)(this.getWindows(),te.workspace.uri)));if(ye.length>0){const te=ye[0],fe=(0,u.$Wg)(H?.remoteAuthority,te.remoteAuthority)?H:void 0;ie(this.Y(O,te,fe),!!fe),de=!0}for(const te of Le){if(ye.some(Ce=>(0,le.$oi)(Ce.openedWorkspace)&&u.$Ig.isEqual(Ce.openedWorkspace.uri,te.workspace.uri)))continue;const fe=te.remoteAuthority,$e=(0,u.$Wg)(H?.remoteAuthority,fe)?H:void 0;ie(await this.bb(O,te,de,$e),!!$e),de=!0}}const ke=(0,A.$Mb)(N,ye=>ye.backupFolder);if(ke.length>0)for(const ye of ke){const te=ye.remoteAuthority,fe=(0,u.$Wg)(H?.remoteAuthority,te)?H:void 0;ie(await this.ab(O,!0,te,fe,ye),!!fe),de=!0}if(z.length===0||H){H&&!Q&&Q++;const ye=H?H.remoteAuthority:O.remoteAuthority;for(let te=0;te<Q;te++)ie(await this.ab(O,de,ye,H),!!H),de=!0}return{windows:(0,A.$Mb)(z),filesOpenedInWindow:ee}}Y(O,W,x){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:x}),this.Z(W);const N={filesToOpenOrCreate:x?.filesToOpenOrCreate,filesToDiff:x?.filesToDiff,filesToMerge:x?.filesToMerge,filesToWait:x?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",P.CancellationToken.None,N),W}Z(O){let W=O;const x=S.BrowserWindow.getFocusedWindow();if(x&&x.id!==O.id){const N=this.S.getWindowById(x.id);N&&N.parentId===O.id&&(W=N)}W.focus()}$(O,W){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),O.focus();const x={foldersToAdd:W};return O.sendWhenReady("vscode:addFolders",P.CancellationToken.None,x),O}ab(O,W,x,N,Q){this.w.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:x,filesToOpen:N,forceNewWindow:W});let H;return!W&&typeof O.contextWindowId=="number"&&(H=this.getWindowById(O.contextWindowId)),this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:x,forceNewWindow:W,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:N,windowToUse:H,emptyWindowBackupInfo:Q,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}bb(O,W,x,N,Q){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:N}),!x&&!Q&&typeof O.contextWindowId=="number"&&(Q=this.getWindowById(O.contextWindowId)),this.pb({workspace:W.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:x,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:N,windowToUse:Q,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async cb(O){let W,x=!1,N=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(W=await this.db(O),x=!0):O.forceEmpty?W=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(W=await this.eb(O.cli),W.length===0&&W.push(Object.create(null)),x=!0):(W=await this.gb(),W.length===0&&W.push(Object.create(null)),N=!0),!O.addMode&&x){const Q=W.filter(H=>oe(H));if(Q.length>1){const H=Q[0].remoteAuthority;if(Q.every(_=>(0,u.$Wg)(_.remoteAuthority,H))){const _=await this.M.createUntitledWorkspace(Q.map(z=>({uri:z.workspace.uri})));W.push({workspace:_,remoteAuthority:H}),W=W.filter(z=>!oe(z))}}}if(O.initialStartup&&!N&&this.J.getValue("window")?.restoreWindows==="preserve"){const Q=await this.gb();W.unshift(...Q.filter(H=>B(H)||oe(H)||H.backupPath))}return W}async db(O){const W={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},x=await Promise.all((0,A.$Hb)(O.urisToOpen||[]).map(async N=>{const Q=await this.ib(N,W);if(Q)return Q.label=N.label,Q;const H=this.kb(N);this.O.showMessageBox({type:"info",buttons:[(0,$.localize)(0,null)],message:H.scheme===y.Schemas.file?(0,$.localize)(1,null):(0,$.localize)(2,null),detail:H.scheme===y.Schemas.file?(0,$.localize)(3,null,(0,w.$8v)(H,{os:p.OS,tildify:this.F})):(0,$.localize)(4,null,H.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,A.$Hb)(x)}async eb(O){const W=[],x={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},N=O["folder-uri"];if(N){const _=await Promise.all(N.map(z=>{const ee=this.fb(z);if(ee)return this.ib({folderUri:ee},x)}));W.push(...(0,A.$Hb)(_))}const Q=O["file-uri"];if(Q){const _=await Promise.all(Q.map(z=>{const ee=this.fb(z);if(ee)return this.ib((0,le.$Ji)(z)?{workspaceUri:ee}:{fileUri:ee},x)}));W.push(...(0,A.$Hb)(_))}const H=await Promise.all(O._.map(_=>x.remoteAuthority?this.nb(_,x):this.lb(_,x)));return W.push(...(0,A.$Hb)(H)),W}fb(O){try{const W=d.URI.parse(O);if(!W.scheme){this.w.error(`Invalid URI input string, scheme missing: ${O}`);return}return W.path?W:W.with({path:"/"})}catch(W){this.w.error(`Invalid URI input string: ${O}, ${W.message}`)}}async gb(){const O=this.hb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];O!=="one"&&W.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&W.push(this.r.state.lastActiveWindow);const x=await Promise.all(W.map(async N=>{if(N.workspace){const Q=await this.ib({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});if(B(Q))return Q}else if(N.folderUri){const Q=await this.ib({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});if(oe(Q))return Q}else if(O!=="folders"&&N.backupPath)return{backupPath:N.backupPath,remoteAuthority:N.remoteAuthority}}));return(0,A.$Hb)(x)}}}hb(){let O;return this.H.wasRestarted?O="all":(O=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async ib(O,W=Object.create(null)){const x=this.kb(O);return x.scheme===y.Schemas.file?((0,j.$4C)(O)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.lb(x.fsPath,W)):this.jb(O,W)}jb(O,W){let x=this.kb(O);const N=(0,E.$ll)(x)||W.remoteAuthority;if(x=(0,u.$Yg)((0,u.$Sg)(x)),(0,j.$4C)(O)){if(W.gotoLineMode){const{path:Q,line:H,column:_}=(0,l.$mg)(x.path);return{fileUri:x.with({path:Q}),options:{selection:H?{startLineNumber:H,startColumn:_||1}:void 0},remoteAuthority:N}}return{fileUri:x,remoteAuthority:N}}else if((0,j.$2C)(O))return{workspace:(0,re.$C$b)(x),remoteAuthority:N};return{workspace:(0,re.$D$b)(x),remoteAuthority:N}}kb(O){return(0,j.$2C)(O)?O.workspaceUri:(0,j.$3C)(O)?O.folderUri:O.fileUri}async lb(O,W,x){let N,Q;W.gotoLineMode&&({path:O,line:N,column:Q}=(0,l.$mg)(O)),O=(0,l.$hg)((0,h.$hc)(O),(0,k.cwd)());try{const H=await D.Promises.stat(O);if(H.isFile()){if(!W.forceOpenWorkspaceAsFile){const _=await this.M.resolveLocalWorkspace(d.URI.file(O));if(_)return _.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:_.id,configPath:_.configPath},type:i.FileType.File,exists:!0,remoteAuthority:_.remoteAuthority,transient:_.transient}}return{fileUri:d.URI.file(O),type:i.FileType.File,exists:!0,options:{selection:N?{startLineNumber:N,startColumn:Q||1}:void 0}}}else{if(H.isDirectory())return{workspace:(0,re.$D$b)(d.URI.file(O),H),type:i.FileType.Directory,exists:!0};if(!p.$i&&O==="/dev/null")return{fileUri:d.URI.file(O),type:i.FileType.File,exists:!0}}}catch(H){if(H.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!x)return this.mb(O,W);const _=d.URI.file(O);if(this.L.removeRecentlyOpened([_]),W.ignoreFileNotFound)return{fileUri:_,type:i.FileType.File,exists:!1}}}async mb(O,W){const x=d.URI.file(O),{response:N,checkboxChecked:Q}=await this.O.showMessageBox({type:"warning",buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null),(0,$.localize)(7,null)],message:(0,$.localize)(8,null,x.authority),detail:(0,$.localize)(9,null,(0,w.$8v)(x,{os:p.OS,tildify:this.F})),checkboxLabel:(0,$.localize)(10,null,x.authority),cancelId:1});if(N===0){if((0,s.addUNCHostToAllowlist)(x.authority),Q){const H={channel:"vscode:configureAllowedUNCHost",args:x.authority};this.sendToFocused(H.channel,H.args),this.sendToOpeningWindow(H.channel,H.args)}return this.lb(O,W,!0)}if(N===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(O,W)}nb(O,W){const x=O.charCodeAt(0),N=W.remoteAuthority;let Q,H;W.gotoLineMode&&({path:O,line:Q,column:H}=(0,l.$mg)(O)),x!==47&&((0,l.$gg)(x)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,l.$_f)(O)),O=`/${O}`);const _=d.URI.from({scheme:y.Schemas.vscodeRemote,authority:N,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,le.$Ji)(O))return W.forceOpenWorkspaceAsFile?{fileUri:_,options:{selection:Q?{startLineNumber:Q,startColumn:H||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,re.$C$b)(_),remoteAuthority:N};if(W.gotoLineMode||h.$gc.basename(O).indexOf(".")!==-1)return{fileUri:_,options:{selection:Q?{startLineNumber:Q,startColumn:H||1}:void 0},remoteAuthority:N}}return{workspace:(0,re.$D$b)(_),remoteAuthority:N}}ob(O){const W=this.J.getValue("window"),x=W?.openFoldersInNewWindow||"default",N=W?.openFilesInNewWindow||"off";let Q=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(x==="on"||x==="off")&&(Q=x==="on");let H=!1;return O.forceNewWindow||O.forceReuseWindow?H=!!O.forceNewWindow&&!O.forceReuseWindow:(p.$j?O.context===1&&(H=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(H=!0),!O.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(H=N==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:H}}async openExtensionDevelopmentHostWindow(O,W){const x=(0,V.$A$b)(this.getWindows(),O);if(x)return this.H.reload(x,W.cli),x.focus(),[x];let N=W.cli["folder-uri"]||[],Q=W.cli["file-uri"]||[],H=W.cli._;if(!H.length&&!N.length&&!Q.length&&!W.cli.extensionTestsPath){const ee=this.r.state.lastPluginDevelopmentHostWindow,ie=ee?.workspace??ee?.folderUri;ie&&(d.URI.isUri(ie)?ie.scheme===y.Schemas.file?H=[ie.fsPath]:N=[ie.toString()]:ie.configPath.scheme===y.Schemas.file?H=[(0,u.$Fg)(ie.configPath)]:Q=[ie.configPath.toString()])}let _=W.remoteAuthority;for(const ee of O)if(ee.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ie=d.URI.parse(ee),de=(0,E.$ll)(ie);de&&(_?(0,u.$Wg)(de,_)||this.w.error("more than one extension development path authority"):_=de)}H=H.filter(ee=>{const ie=d.URI.file(ee);return(0,V.$z$b)(this.getWindows(),ie)?!1:(0,u.$Wg)((0,E.$ll)(ie),_)}),N=N.filter(ee=>{const ie=this.fb(ee);return ie&&(0,V.$z$b)(this.getWindows(),ie)?!1:ie?(0,u.$Wg)((0,E.$ll)(ie),_):!1}),Q=Q.filter(ee=>{const ie=this.fb(ee);return ie&&(0,V.$z$b)(this.getWindows(),ie)?!1:ie?(0,u.$Wg)((0,E.$ll)(ie),_):!1}),W.cli._=H,W.cli["folder-uri"]=N,W.cli["file-uri"]=Q;const z={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!H.length&&!N.length&&!Q.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:_,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(z)}async pb(O){const W=this.J.getValue("window"),x=this.getLastActiveWindow(),N=x?.profile??this.G.defaultProfile;let Q;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(Q=O.windowToUse||x,Q&&Q.focus());const H={...this.F.args,...O.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,h.$jc)(this.F.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:N},homeDir:this.F.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.u,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:y.Schemas.file}).fsPath,product:R.default,isInitialStartup:O.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(Q){const _=Q.config;!H.extensionDevelopmentPath&&_?.extensionDevelopmentPath&&(H.extensionDevelopmentPath=_.extensionDevelopmentPath,H.extensionDevelopmentKind=_.extensionDevelopmentKind,H["enable-proposed-api"]=_["enable-proposed-api"],H.verbose=_.verbose,H["inspect-extensions"]=_["inspect-extensions"],H["inspect-brk-extensions"]=_["inspect-brk-extensions"],H.debugId=_.debugId,H.extensionEnvironment=_.extensionEnvironment,H["extensions-dir"]=_["extensions-dir"],H["disable-extensions"]=_["disable-extensions"]),H.loggers={global:H.loggers.global,window:_?.loggers.window??H.loggers.window}}else{const _=this.r.getNewWindowState(H);(0,m.mark)("code/willCreateCodeWindow");const z=Q=this.N.createInstance(U.$K$b,{state:_,extensionDevelopmentPath:H.extensionDevelopmentPath,isExtensionTestHost:!!H.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(z),this.n.set(z.id,z),this.a.fire(z),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ee=new v.$Sc;ee.add(z.onDidSignalReady(()=>this.b.fire(z))),ee.add(g.Event.once(z.onDidClose)(()=>this.sb(z,ee))),ee.add(g.Event.once(z.onDidDestroy)(()=>this.tb(z))),ee.add(z.onDidMaximize(()=>this.g.fire(z))),ee.add(z.onDidUnmaximize(()=>this.h.fire(z))),ee.add(z.onDidEnterFullScreen(()=>this.j.fire({window:z,fullscreen:!0}))),ee.add(z.onDidLeaveFullScreen(()=>this.j.fire({window:z,fullscreen:!1}))),ee.add(z.onDidTriggerSystemContextMenu(({x:de,y:me})=>this.m.fire({window:z,x:de,y:me})));const ie=(0,f.$4f)(z.win?.webContents);ie.removeAllListeners("devtools-reload-page"),ie.on("devtools-reload-page",()=>this.H.reload(z)),this.H.registerWindow(z)}return H.windowId=Q.id,Q.isReady?this.H.unload(Q,4).then(async _=>{_||await this.qb(Q,H,O,N)}):await this.qb(Q,H,O,N),Q}async qb(O,W,x,N){if(W.extensionDevelopmentPath||((0,le.$ti)(W.workspace)?W.backupPath=this.I.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,le.$oi)(W.workspace)?W.backupPath=this.I.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.I.registerEmptyWindowBackup({backupFolder:x.emptyWindowBackupInfo?.backupFolder??(0,re.$E$b)().id,remoteAuthority:W.remoteAuthority})),this.G.isEnabled()){const Q=W.workspace??(0,le.$si)(W.backupPath,!1),H=this.rb(x,Q,N),_=H instanceof Promise?await H:H;W.profiles.profile=_,W.extensionDevelopmentPath||await this.G.setProfileForWorkspace(Q,_)}O.load(W)}rb(O,W,x){return O.forceProfile?this.G.profiles.find(N=>N.name===O.forceProfile)??this.G.createNamedProfile(O.forceProfile):O.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(W)??x}sb(O,W){this.n.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),W.dispose()}tb(O){this.n.delete(O.id),this.c.fire(O)}getFocusedWindow(){const O=S.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(O){return this.vb(this.getWindows().filter(W=>(0,u.$Wg)(W.remoteAuthority,O)))}vb(O){return(0,F.$v$b)(O)}sendToFocused(O,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,P.CancellationToken.None,...W)}sendToOpeningWindow(O,...W){this.B(g.Event.once(this.onDidSignalReadyWindow)(x=>{x.sendWhenReady(O,P.CancellationToken.None,...W)}))}sendToAll(O,W,x){for(const N of this.getWindows())x&&x.indexOf(N.id)>=0||N.sendWhenReady(O,P.CancellationToken.None,W)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(O){return this.n.get(O)}getWindowByWebContents(O){const W=S.BrowserWindow.fromWebContents(O);if(W)return this.getWindowById(W.id)}};e.$V_b=he,e.$V_b=he=ve([se(3,b.$yj),se(4,T.$H$b),se(5,C.$sP),se(6,q.$Vn),se(7,r.$i$b),se(8,L.$w$b),se(9,c.$M$b),se(10,a.$n$b),se(11,t.$Ki),se(12,ue.$r_b),se(13,Z.$F$b),se(14,n.$di),se(15,o.$o$b),se(16,i.$Bk),se(17,I.$q$b),se(18,X.$r$b),se(19,G.$e_b)],he)}),define(ae[307],ce([0,1,65,29,83,58]),function(Y,e,S,D,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=void 0;let A=class{constructor(g,l,w,v){this.a=g,this.b=l,this.c=w,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(g,l){const w=this.b.getWindowById(g);if(w)return this.a.enterWorkspace(w,this.b.getWindows(),l)}createUntitledWorkspace(g,l,w){return this.a.createUntitledWorkspace(l,w)}deleteUntitledWorkspace(g,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(g,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(g){return this.c.getRecentlyOpened()}addRecentlyOpened(g,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(g,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(g){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$X_b=A,e.$X_b=A=ve([se(0,M.$F$b),se(1,D.$t$b),se(2,s.$r_b),se(3,S.$n$b)],A)}),define(ae[308],ce([0,1,15,132,37,26,17,51,14,33,3,42,47,2,13,9,4,12,7,32,158,43,159,112,290,162,65,283,18,200,91,133,56,118,220,24,64,94,209,293,211,212,213,16,224,93,77,6,92,219,299,284,291,20,5,305,70,27,60,294,95,34,275,82,124,28,251,253,54,49,265,288,300,289,301,129,267,268,269,272,297,55,29,306,274,30,98,83,307,58,39,233,57,244,53,81,130,277,292,280,8,255,276,228,68,296,271,22,127,295,263,239,62,78,303]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d,$,a,t,o,r,i,n,c,b,R,I,E,C,j,U,F,V,J,le,re,ue,Z,X,q,L,T,G,B,oe,he,K,O,W,x,N,Q,H,_,z,ee,ie,de,me,Ee,Pe,Le,ke,ye,te,fe,$e,Ce,Oe,Ue,je,Ge,qe,Ke,He,Be,ne,ge,pe,be,Se,Me,Te,Ye,xe,Qe,Ze,st,tt,ot,at,yt,vt,kt,Et,St,ct,gt,Pt,It,Ct,lt,At,$t,ut,Rt,Dt,ht,Ot,mt,Mt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$eac=void 0;let dt=class extends h.$Tc{static{ft=this}static{this.a={[m.Schemas.file]:"security.promptForLocalFileProtocolHandling",[m.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ie,Ae,De,we,Re,Ne,ze,Je,We,Fe,Ve,Xe){super(),this.g=Ie,this.h=Ae,this.j=De,this.m=we,this.n=Re,this.s=Ne,this.t=ze,this.u=Je,this.w=We,this.y=Fe,this.z=Ve,this.C=Xe,this.D(),this.F()}D(){const Ie=We=>We?.startsWith(`${m.Schemas.vscodeWebview}://`),Ae=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((We,Fe,Ve,Xe)=>Ie(Xe.requestingUrl)?Ve(Ae.has(Fe)):Ve(!1)),S.session.defaultSession.setPermissionCheckHandler((We,Fe,Ve,Xe)=>Ie(Xe.requestingUrl)?Ae.has(Fe):!1);const De=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,m.Schemas.vscodeManagedRemoteResource,"devtools"]),we=We=>{for(let Fe=We;Fe;Fe=Fe.parent)if(Fe.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},Re=We=>We.resourceType==="xhr"||we(We.frame),Ne=We=>{const Fe=We.frame;if(!Fe||!this.b)return!1;const Ve=S.BrowserWindow.getAllWindows();for(const Xe of Ve)if(Fe.processId===Xe.webContents.mainFrame.processId)return!0;return!1},ze=(We,Fe)=>{if(We.path!=="/index.html")return!0;const Ve=Fe.frame;if(!Ve||!this.b)return!1;for(const Xe of this.b.getWindows())if(Xe.win&&Ve.processId===Xe.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((We,Fe)=>{const Ve=f.URI.parse(We.url);return Ve.scheme===m.Schemas.vscodeWebview&&!ze(Ve,We)?(this.m.error("Blocked vscode-webview request",We.url),Fe({cancel:!0})):Ve.scheme===m.Schemas.vscodeFileResource&&!Ne(We)?(this.m.error("Blocked vscode-file request",We.url),Fe({cancel:!0})):Ve.path.endsWith(".svg")&&!De.has(Ve.scheme)?Fe({cancel:!Re(We)}):Fe({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((We,Fe)=>{const Ve=We.responseHeaders,Xe=Ve["content-type"]||Ve["Content-Type"];if(Xe&&Array.isArray(Xe)){const _e=f.URI.parse(We.url);if(_e.path.endsWith(".svg")&&De.has(_e.scheme))return Ve["Content-Type"]=["image/svg+xml"],Fe({cancel:!1,responseHeaders:Ve});if(!_e.path.endsWith(m.Schemas.vscodeRemoteResource)&&Xe.some(it=>it.toLowerCase().includes("image/svg")))return Fe({cancel:!Re(We)})}return Fe({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((We,Fe)=>{if(We.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ve=We.responseHeaders??Object.create(null);if(Ve["Access-Control-Allow-Origin"]===void 0)return Ve["Access-Control-Allow-Origin"]=["*"],Fe({cancel:!1,responseHeaders:Ve})}return Fe({cancel:!1})});const Je=S.session.defaultSession;typeof Je.setCodeCachePath=="function"&&this.s.codeCachePath&&Je.setCodeCachePath((0,p.$jc)(this.s.codeCachePath,"chrome")),k.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,D.disableUNCAccessRestrictions)():(0,D.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,g.setUnexpectedErrorHandler)(De=>this.H(De)),process.on("uncaughtException",De=>{(0,g.$Z)(De)||(0,g.$1)(De)}),process.on("unhandledRejection",De=>(0,g.$1)(De)),this.t.onWillShutdown(()=>this.dispose()),(0,$.$BV)(),S.app.on("accessibility-support-changed",(De,we)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",we)}),S.app.on("activate",async(De,we)=>{this.m.trace("app#activate"),we||await this.b?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(De,we)=>{we?.opener?.url.startsWith(`${m.Schemas.vscodeFileResource}://${m.$xg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(we)),we.on("will-navigate",Re=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),we.setWindowOpenHandler(Re=>Re.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Re)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Re.url}}`),this.f?.openExternal(void 0,Re.url),{action:"deny"}))});let Ie=[],Ae;S.app.on("open-file",(De,we)=>{this.m.trace("app#open-file: ",we),De.preventDefault(),Ie.push((0,Me.$Ji)(we)?{workspaceUri:f.URI.file(we)}:{fileUri:f.URI.file(we)}),Ae!==void 0&&(clearTimeout(Ae),Ae=void 0),Ae=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],Ae=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$AV.handle("vscode:fetchShellEnv",De=>{const we=this.b?.getWindowByWebContents(De.sender);let Re,Ne;return we?.config?(Re=we.config,Ne={...process.env,...we.config.userEnv}):(Re=this.s.args,Ne=process.env),this.X(Re,Ne,!1)}),s.$AV.handle("vscode:writeNlsFile",(De,we,Re)=>{const Ne=this.G([we]);if(!Ne||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Ne,A.$se.fromString(Re))}),s.$AV.handle("vscode:readNlsFile",async(De,...we)=>{const Re=this.G(we);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Re)).value.toString()}),s.$AV.on("vscode:toggleDevTools",De=>De.sender.toggleDevTools()),s.$AV.on("vscode:openDevTools",De=>De.sender.openDevTools()),s.$AV.on("vscode:reloadWindow",De=>De.sender.reload()),s.$AV.handle("vscode:notifyZoomLevel",async(De,we)=>{const Re=this.b?.getWindowById(De.sender.id);Re&&Re.notifyZoomLevel(we)})}G(Ie){let Ae;for(const De of Ie)typeof De=="string"&&(typeof Ae!="string"?Ae=De:Ae=(0,p.$jc)(Ae,De));if(!(typeof Ae!="string"||!(0,p.$ic)(Ae)||!(0,l.$fg)(Ae,this.s.cachedLanguagesPath,!k.$k)))return f.URI.file(Ae)}H(Ie){if(Ie){const Ae={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ae))}this.m.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.m.error(Ie.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ie=this.z.win32AppUserModelId;k.$i&&Ie&&S.app.setAppUserModelId(Ie);try{k.$j&&this.u.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.m.error(Fe)}const Ae=new t.$HV;this.t.onWillShutdown(Fe=>{Fe.reason===2&&Ae.dispose()}),this.m.trace("Resolving machine identifier...");const[De,we]=await Promise.all([(0,gt.$6_b)(this.w,this.m),(0,gt.$7_b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${De}`);const{sharedProcessReady:Re,sharedProcessClient:Ne}=this.P(De,we),ze=await this.Q(De,we,Re);this.B(ze.createInstance(r.$W$b)),this.B(ze.createInstance(Et.$2_b)),ze.invokeFunction(Fe=>this.R(Fe,Ae,Ne));const Je=await ze.invokeFunction(Fe=>this.I(Fe,Ae));this.J(Ae),this.t.phase=2,await ze.invokeFunction(Fe=>this.S(Fe,Je)),this.t.phase=3,this.U(),this.B(new ct.$qh(()=>{this.B((0,ct.$uh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ie,Ae){const De=this.b=Ie.get(pe.$t$b),we=Ie.get(Ge.$pW),Re=this.f=Ie.get(H.$f_b),Ne=Ie.get(C.$o$b),ze=this;we.registerHandler({async handleURL(_e,it){return ze.O(De,Ne,we,_e,it)}});const Je=this.B(new Se.$W_b({onDidOpenMainWindow:Re.onDidOpenMainWindow,onDidFocusMainWindow:Re.onDidFocusMainWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),We=new a.$Yh(_e=>Je.getActiveClientId().then(it=>_e===it)),Fe=new qe.$N_b(We,this.m),Ve=Ae.getChannel("urlHandler",Fe);we.registerHandler(new qe.$M_b(Ve));const Xe=await this.L(De,Ne);return this.B(new He.$O_b(Xe?.urls,we,De,this.s,this.z,this.m)),Xe}J(Ie){const Ae=()=>({statusCode:404,data:"Not found"}),De=new Ot.$V(()=>Ie.getChannel(ht.$bac,new ht.$cac));S.protocol.registerBufferProtocol(m.Schemas.vscodeManagedRemoteResource,(we,Re)=>{const Ne=f.URI.parse(we.url);if(!Ne.authority.startsWith("window:"))return Re(Ae());De.value.call(ht.$aac,[Ne]).then(ze=>Re({...ze,data:Buffer.from(ze.body,"base64")}),ze=>{this.m.warn("error dispatching remote resource call",ze),Re({statusCode:500,data:String(ze)})})})}async L(Ie,Ae){const De=this.s.args["open-url"]?this.s.args._urls||[]:[];De.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",De);const we=global.getOpenUrls()||[];if(we.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),De.length+we.length===0)return;const Re=[...De,...we].map(Je=>{try{return{uri:f.URI.parse(Je),originalUrl:Je}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Je);return}}),Ne=[],ze=[];for(const Je of Re){if(!Je)continue;const We=this.N(Je.uri);if(We)if(await this.M(We,Ie,Ae)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Je.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Je.uri.toString(!0),We),Ne.push(We);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Je.uri.toString(!0)),ze.push(Je)}return{urls:ze,openables:Ne}}async M(Ie,Ae,De){let we,Re;if((0,ge.$2C)(Ie)?(we=Ie.workspaceUri,Re=(0,i.localize)(0,null,we.scheme===m.Schemas.file?(0,y.$8v)(we,{os:k.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(0,ge.$3C)(Ie)?(we=Ie.folderUri,Re=(0,i.localize)(1,null,we.scheme===m.Schemas.file?(0,y.$8v)(we,{os:k.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(we=Ie.fileUri,Re=(0,i.localize)(2,null,we.scheme===m.Schemas.file?(0,y.$8v)(we,{os:k.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)),we.scheme!==m.Schemas.file&&we.scheme!==m.Schemas.vscodeRemote||this.u.getValue(ft.a[we.scheme])===!1)return!1;const{response:ze,checkboxChecked:Je}=await De.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Re,detail:(0,i.localize)(5,null),checkboxLabel:we.scheme===m.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(ze!==0)return!0;if(Je){const We={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===m.Schemas.file?"local":"remote"};Ae.sendToFocused(We.channel,We.args),Ae.sendToOpeningWindow(We.channel,We.args)}return!1}N(Ie){if(Ie.path){if(Ie.authority===m.Schemas.file){const Ae=f.URI.file(Ie.fsPath);return(0,Me.$Ji)(Ae)?{workspaceUri:Ae}:{fileUri:Ae}}else if(Ie.authority===m.Schemas.vscodeRemote){const Ae=Ie.path.indexOf(p.$gc.sep,1);if(Ae!==-1){const De=Ie.path.substring(1,Ae),we=Ie.path.substring(Ae);let Re=Ie.query;const Ne=new URLSearchParams(Ie.query);Ne.get("windowId")==="_blank"&&(Ne.delete("windowId"),Re=Ne.toString());const ze=f.URI.from({scheme:m.Schemas.vscodeRemote,authority:De,path:we,query:Re,fragment:Ie.fragment});return(0,Me.$Ji)(we)?{workspaceUri:ze}:/:[\d]+$/.test(we)?{fileUri:ze}:{folderUri:ze}}}}}async O(Ie,Ae,De,we,Re){this.m.trace("app#handleProtocolUrl():",we.toString(!0),Re),we.scheme===this.z.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:f.URI.parse(we.query).path,query:""}));let Ne=!1;const ze=new URLSearchParams(we.query);ze.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),ze.delete("windowId"),we=we.with({query:ze.toString()}),Ne=!0):k.$j&&Ie.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),Ne=!0);const Je=ze.get("continueOn");Je!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),ze.delete("continueOn"),we=we.with({query:ze.toString()}),this.s.continueOn=Je??void 0);const We=this.N(we);return We?await this.M(We,Ie,Ae)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",We,we.toString(!0)),(0,$t.$Ob)(await Ie.open({context:5,cli:{...this.s.args},urisToOpen:[We],forceNewWindow:Ne,gotoLineMode:!0}))?.focus(),!0):Ne?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,$t.$Ob)(await Ie.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,z.$ll)(we)}))?.ready(),De.open(we,Re)):(this.m.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Re),!1)}P(Ie,Ae){const De=this.B(this.j.createInstance(ee.$z_b,Ie,Ae)),we=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ne=await De.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$IV(Ne,"main")})();return{sharedProcessReady:(async()=>(await De.whenReady(),we))(),sharedProcessClient:we}}async Q(Ie,Ae,De){const we=new oe.$ci;switch(process.platform){case"win32":we.set(fe.$zW,new G.$bi(je.$K_b));break;case"linux":k.$l?we.set(fe.$zW,new G.$bi(Ue.$J_b,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(fe.$zW,new G.$bi(Oe.$I_b));break;case"darwin":we.set(fe.$zW,new G.$bi(Ce.$H_b));break}we.set(pe.$t$b,new G.$bi(be.$V_b,[Ie,Ae,this.h],!1)),we.set(mt.$e_b,new G.$bi(Mt.$dac,void 0,!1));const Re=new C.$p$b(this.m,this.z);we.set(C.$o$b,Re),we.set(W.$l_b,new G.$bi(W.$m_b,void 0,!1)),we.set(E.$3$b,new G.$bi(E.$4$b,void 0,!1)),we.set(I.$Um,a.ProxyChannel.toService((0,a.$Wh)(De.then(Fe=>Fe.getChannel("diagnostics"))))),we.set(he.$iBb,new G.$bi(K.$h_b,[this.h])),we.set(j.$jW,new G.$bi(U.$5$b)),we.set(O.$i_b,new G.$bi(O.$j_b)),we.set(H.$f_b,new G.$bi(H.$g_b,void 0,!1)),we.set(Be.$P_b,new G.$bi(ne.$R_b)),we.set(Q.$u_b,new G.$bi(Q.$v_b)),we.set(le.$6$b,new G.$bi(re.$8$b)),we.set(Ee.$S$b,new G.$bi(Ee.$T$b)),we.set(Ee.$U$b,new G.$bi(Ee.$V$b));const Ne=new Rt.$__b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),ze=new Dt.$9r(Ne,this.u,this.m,this.n);we.set(ut.$Jr,ze),k.$i?we.set(ue.$9$b,new G.$bi(Z.$0$b)):k.$j?we.set(ue.$9$b,new G.$bi(Z.$$$b)):k.$k&&we.set(ue.$9$b,new G.$bi(Z.$_$b));const Je=new c.$X$b(this.s,this.u,this.m,this.w);we.set(n.$n$b,Je);const We=new Qe.$G$b(this.s,this.m,this.C,Je,Re);if(we.set(Qe.$F$b,We),we.set(Te.$_db,new G.$bi(xe.$X_b,void 0,!1)),we.set(Ye.$r_b,new G.$bi(Ye.$s_b,void 0,!1)),we.set(Ge.$pW,new G.$bi(Ke.$rW,void 0,!1)),(0,te.$4o)(this.z,this.s)){const Fe=(0,te.$9o)(this.z,this.u),Ve=(0,a.$Wh)(De.then(rt=>rt.getChannel("telemetryAppender"))),Xe=new ke.$C_b(Ve),_e=(0,Pe.$Uo)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,Ie,Ae,Fe),it=(0,te.$0o)(this.s),nt={appenders:[Xe],commonProperties:_e,piiPaths:it,sendErrorTelemetry:!0};we.set(Le.$Fl,new G.$bi(ye.$Ar,[nt],!1))}else we.set(Le.$Fl,te.$Yo);return we.set(yt.$7p,new G.$bi(Pt.$zP,void 0,!0)),we.set(vt.$$p,new G.$bi(kt.$1_b,void 0,!0)),we.set(lt.$0_b,new G.$bi(lt.$$_b,void 0,!0)),await ct.Promises.settled([Je.initialize(),We.initialize()]),this.j.createChild(we)}R(Ie,Ae,De){const we=this.B(new h.$Sc),Re=a.ProxyChannel.fromService(Ie.get(W.$l_b),we,{disableMarshalling:!0});this.g.registerChannel("launch",Re);const Ne=a.ProxyChannel.fromService(Ie.get(E.$3$b),we,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Ne);const ze=new st.$Y_b(Ie.get(Ze.$Vn));Ae.registerChannel("policy",ze),De.then(et=>et.registerChannel("policy",ze));const Je=this.y.getProvider(m.Schemas.file);(0,u.$3f)(Je instanceof T.$Mq);const We=new L.$a_b(Je,this.m,this.s);Ae.registerChannel(X.$iP,We),De.then(et=>et.registerChannel(X.$iP,We));const Fe=a.ProxyChannel.fromService(Ie.get(tt.$w$b),we);Ae.registerChannel("userDataProfiles",Fe),De.then(et=>et.registerChannel("userDataProfiles",Fe));const Ve=new ot.$vr(Ie.get(at.$sp));De.then(et=>et.registerChannel("request",Ve));const Xe=new $e.$D_b(Ie.get(fe.$zW));Ae.registerChannel("update",Xe);const _e=a.ProxyChannel.fromService(Ie.get(he.$iBb),we);Ae.registerChannel("issue",_e);const it=a.ProxyChannel.fromService(Ie.get(j.$jW),we);Ae.registerChannel("encryption",it);const nt=a.ProxyChannel.fromService(Ie.get(ie.$tl),we);Ae.registerChannel("sign",nt);const rt=a.ProxyChannel.fromService(Ie.get(O.$i_b),we);Ae.registerChannel("keyboardLayout",rt),this.f=Ie.get(H.$f_b);const wt=a.ProxyChannel.fromService(this.f,we);Ae.registerChannel("nativeHost",wt),De.then(et=>et.registerChannel("nativeHost",wt));const jt=a.ProxyChannel.fromService(Ie.get(Te.$_db),we);Ae.registerChannel("workspaces",jt);const Lt=a.ProxyChannel.fromService(Ie.get(Q.$u_b),we);Ae.registerChannel("menubar",Lt);const Wt=a.ProxyChannel.fromService(Ie.get(Ge.$pW),we);Ae.registerChannel("url",Wt);const Ft=a.ProxyChannel.fromService(Ie.get(Be.$P_b),we);Ae.registerChannel("webview",Ft);const bt=this.B(new me.$A_b(this.m,Ie.get(Ee.$S$b)));Ae.registerChannel("storage",bt),De.then(et=>et.registerChannel("storage",bt));const Ut=this.B(new St.$3_b(Ie.get(Ee.$S$b),Ie.get(tt.$w$b),this.m));De.then(et=>et.registerChannel("profileStorageListener",Ut));const Tt=a.ProxyChannel.fromService(Ie.get(ut.$Jr),we);Ae.registerChannel(ut.TerminalIpcChannels.LocalPty,Tt);const Nt=a.ProxyChannel.fromService(Ie.get(ue.$9$b),we);Ae.registerChannel("externalTerminal",Nt);const pt=new It.$8_b(Ie.get(Ct.$H$b));Ae.registerChannel("logger",pt),De.then(et=>et.registerChannel("logger",pt));const zt=new R.$Y$b(Ie.get(pe.$t$b));Ae.registerChannel("extensionhostdebugservice",zt);const Bt=a.ProxyChannel.fromService(Ie.get(le.$6$b),we);Ae.registerChannel(le.$7$b,Bt);const qt=a.ProxyChannel.fromService(Ie.get(lt.$0_b),we);Ae.registerChannel(At.$9_b,qt)}async S(Ie,Ae){const De=this.b=Ie.get(pe.$t$b);this.c=Ie.get(mt.$e_b);const we=(0,V.$em)(process.env)?0:4,Re=this.s.args;if(Ae){if(Ae.openables.length>0)return De.open({context:we,cli:Re,urisToOpen:Ae.openables,gotoLineMode:!0,initialStartup:!0});if(Ae.urls.length>0)for(const nt of Ae.urls){const rt=new URLSearchParams(nt.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:rt.toString()}),De.open({context:we,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,ze=Re._.length,Je=!!Re["folder-uri"],We=!!Re["file-uri"],Fe=Re["skip-add-to-recently-opened"]===!0,Ve=Re.wait&&Re.waitMarkerFilePath?f.URI.file(Re.waitMarkerFilePath):void 0,Xe=Re.remote||void 0,_e=Re.profile,it=Re["profile-temp"];if(!ze&&!Je&&!We){if(Re["new-window"]||_e||it)return De.open({context:we,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Fe,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Xe,forceProfile:_e,forceTempProfile:it});if(Ne.length)return De.open({context:1,cli:Re,urisToOpen:Ne.map(nt=>(0,Me.$Ji)(nt)?{workspaceUri:f.URI.file(nt)}:{fileUri:f.URI.file(nt)}),noRecentEntry:Fe,waitMarkerFileURI:Ve,initialStartup:!0})}return De.open({context:we,cli:Re,forceNewWindow:Re["new-window"]||!ze&&Re["unity-launch"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:Fe,waitMarkerFileURI:Ve,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Xe,forceProfile:_e,forceTempProfile:it})}U(){this.W(),S.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(Ie,Ae)=>{Ae({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.X(this.s.args,process.env,!0),this.Y(),k.$j&&S.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ie=this.z.win32MutexName;if(k.$i&&Ie)try{const Ae=await new Promise((we,Re)=>{Y(["@vscode/windows-mutex"],we,Re)}),De=new Ae.Mutex(Ie);w.Event.once(this.t.onWillShutdown)(()=>De.release())}catch(Ae){this.m.error(Ae)}}async X(Ie,Ae,De){try{return await(0,J.$km)(this.u,this.m,Ie,Ae)}catch(we){const Re=(0,P.$2i)(we);De?this.b?.sendToFocused("vscode:showResolveShellEnvError",Re):this.m.error(Re)}return{}}async Y(){try{const Ae=(await this.y.readFile(this.s.argvResource)).value.toString(),De=JSON.parse((0,v.$wn)(Ae)),Re=(0,te.$6o)(this.u)>=1;if(De["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,d.$Ag)()}"`,"}"],ze=Ae.substring(0,Ae.length-2).concat(`,
`,Ne.join(`
`));await this.y.writeFile(this.s.argvResource,A.$se.fromString(ze))}else{const Ne=Ae.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);Ne!==Ae&&await this.y.writeFile(this.s.argvResource,A.$se.fromString(Ne))}}catch(Ie){this.m.error(Ie)}}};e.$eac=dt,e.$eac=dt=ft=ve([se(2,B.$di),se(3,N.$yj),se(4,N.$zj),se(5,F.$i$b),se(6,x.$M$b),se(7,b.$Ki),se(8,de.$sP),se(9,q.$Bk),se(10,_.$Qj),se(11,tt.$w$b)],dt)}),define(ae[313],ce([0,1,15,46,7,22,8,51,14,33,3,47,13,9,67,4,36,25,21,43,100,308,10,18,238,250,24,64,202,16,222,93,77,218,92,20,225,5,79,27,80,278,128,287,53,286,95,249,34,54,69,57,39,234,232,2,40,266,68,227,117,123,270,264]),function(Y,e,S,D,s,M,A,P,g,l,w,v,y,h,m,p,k,u,f,d,$,a,t,o,r,i,n,c,b,R,I,E,C,j,U,F,V,J,le,re,ue,Z,X,q,L,T,G,B,oe,he,K,O,W,x,N,Q,H,_,z,ee,ie,de,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ee{main(){try{this.a()}catch(ke){console.error(ke.message),S.app.exit(1)}}async a(){(0,g.setUnexpectedErrorHandler)(je=>console.error(je));const[ke,ye,te,fe,$e,Ce,Oe,Ue]=this.b();try{try{await this.d(te,Ue,fe,$e,Oe)}catch(je){throw this.f(te,Oe,je),je}await ke.invokeFunction(async je=>{const Ge=je.get(J.$yj),qe=je.get(F.$M$b),Ke=je.get(R.$Bk),He=je.get(J.$zj),Be=await this.e(Ge,te,qe,ke,Oe,!0);return f.Promises.writeFile(te.mainLockfile,String(process.pid)).catch(ne=>{Ge.warn(`app#startup(): Error writing main lockfile: ${ne.stack}`)}),Ce.logger=He.createLogger("main",{name:(0,t.localize)(0,null)}),w.Event.once(qe.onWillShutdown)(ne=>{Ke.dispose(),fe.dispose(),ne.join("instanceLockfile",f.Promises.unlink(te.mainLockfile).catch(()=>{}))}),ke.createInstance(a.$eac,Be,ye).startup()})}catch(je){ke.invokeFunction(this.i,je)}}b(){const ke=new U.$ci,ye=new Q.$Sc;process.once("exit",()=>ye.dispose());const te={_serviceBrand:void 0,...le.default};ke.set(re.$Qj,te);const fe=new n.$j$b(this.j(),te),$e=this.c(fe);ke.set(n.$i$b,fe);const Ce=new z.$I$b((0,J.$Mj)(fe),fe.logsHome);ke.set(z.$H$b,Ce);const Oe=new V.$48b(Ce.getLogLevel()),Ue=ye.add(new ee.$AP(Oe,[new J.$Fj(Ce.getLogLevel())]));ke.set(J.$yj,Ue);const je=new I.$nq(Ue);ke.set(R.$Bk,je);const Ge=new E.$Mq(Ue);je.registerProvider(y.Schemas.file,Ge);const qe=new _.$as(je);ke.set(H.$_k,qe);const Ke=new de.$vP(1,fe,Ue,je);ke.set(oe.$rP,Ke),ke.set(oe.$sP,Ke);const He=new O.$x$b(Ke,qe,fe,je,Ue);ke.set(O.$w$b,He),je.registerProvider(y.Schemas.vscodeUserData,new me.$pac(y.Schemas.file,Ge,y.Schemas.vscodeUserData,He,qe,Ue));const Be=p.$i&&te.win32RegValueName?ye.add(new x.$nac(Ue,te.win32RegValueName)):fe.policyFile?ye.add(new N.$oac(fe.policyFile,je,Ue)):new W.$Xn;ke.set(W.$Vn,Be);const ne=new r.$lo(He.defaultProfile.settingsResource,je,Be,Ue);return ke.set(o.$Ki,ne),ke.set(F.$M$b,new C.$bi(F.$N$b,void 0,!1)),ke.set(L.$sp,new C.$bi(T.$lac,void 0,!0)),ke.set(K.$r$b,new C.$bi(K.$s$b)),ke.set(G.$tl,new C.$bi(B.$mac,void 0,!1)),ke.set(X.$Mv,new C.$bi(q.$jac)),ke.set(ue.$q$b,new Z.$gac(fe,He,Ue)),[new j.$Pq(ke,!0),$e,fe,ne,Ke,Oe,te,He]}c(ke){const ye={VSCODE_IPC_HOOK:ke.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(te=>{const fe=process.env[te];typeof fe=="string"&&(ye[te]=fe)}),Object.assign(process.env,ye),ye}async d(ke,ye,te,fe,$e){await A.Promises.settled([Promise.all([ke.extensionsPath,ke.codeCachePath,ke.logsHome.with({scheme:y.Schemas.file}).fsPath,ye.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,ke.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,ke.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,ke.backupHome].map(Ce=>Ce?f.Promises.mkdir(Ce,{recursive:!0}):void 0)),fe.init(),te.initialize()]),ye.init()}async e(ke,ye,te,fe,$e,Ce){let Oe;try{(0,m.mark)("code/willStartMainServer"),Oe=await(0,$.$_h)(ye.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),w.Event.once(te.onWillShutdown)(()=>Oe.dispose())}catch(Ue){if(Ue.code!=="EADDRINUSE")throw this.f(ye,$e,Ue),Ue;let je;try{je=await(0,$.$ai)(ye.mainIPCHandle,"main")}catch(He){if(!Ce||p.$i||He.code!=="ECONNREFUSED")throw He.code==="EPERM"&&this.g((0,t.localize)(1,null,$e.nameShort),(0,t.localize)(2,null),$e),He;try{(0,D.unlinkSync)(ye.mainIPCHandle)}catch(Be){throw ke.warn("Could not delete obsolete instance handle",Be),Be}return this.e(ke,ye,te,fe,$e,!1)}if(ye.extensionTestsLocationURI&&!ye.debugExtensionHost.break){const He=`Running extension tests from the command line is currently only supported if no other instance of ${$e.nameShort} is running.`;throw ke.error(He),je.dispose(),new Error(He)}let Ge;!ye.args.wait&&!ye.args.status&&(Ge=setTimeout(()=>{this.g((0,t.localize)(3,null,$e.nameShort),(0,t.localize)(4,null),$e)},1e4));const qe=d.ProxyChannel.toService(je.getChannel("launch"),{disableMarshalling:!0}),Ke=d.ProxyChannel.toService(je.getChannel("diagnostics"),{disableMarshalling:!0});if(ye.args.status)return fe.invokeFunction(async()=>{const He=new i.$hs(he.$Yo,$e),Be=await Ke.getMainDiagnostics(),ne=await Ke.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ge=await He.getDiagnostics(Be,ne);throw console.log(ge),new g.$ab});throw p.$i&&await this.h(qe,ke),ke.trace("Sending env to running instance..."),await qe.start(ye.args,process.env),je.dispose(),Ge&&clearTimeout(Ge),new g.$ab("Sent env to running instance. Terminating...")}if(ye.args.status)throw console.log((0,t.localize)(5,null,$e.nameShort)),new g.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Oe}f(ke,ye,te){if(te.code==="EACCES"||te.code==="EPERM"){const fe=(0,M.$Hb)([ke.userDataPath,ke.extensionsPath,$.$8h]).map($e=>(0,v.$8v)(s.URI.file($e),{os:p.OS,tildify:ke}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,P.$2i)(te),fe.join(`
`)),ye)}}g(ke,ye,te){S.dialog.showMessageBoxSync((0,ie.$jw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ke,detail:ye},te).options)}async h(ke,ye){if(p.$i){const te=await ke.getMainProcessId();ye.trace("Sending some foreground love to the running instance:",te);try{(await new Promise((fe,$e)=>{Y(["windows-foreground-love"],fe,$e)})).allowSetForegroundWindow(te)}catch(fe){ye.error(fe)}}}i(ke,ye){const te=ke.get(J.$yj),fe=ke.get(F.$M$b);let $e=0;ye&&(ye.isExpected?ye.message&&te.trace(ye.message):($e=1,ye.stack?te.error(ye.stack):te.error(`Startup error: ${ye.toString()}`))),fe.kill($e)}j(){const ke=this.k((0,c.$bm)(process.argv));if(ke.wait&&!ke.waitMarkerFilePath){const ye=(0,b.$fac)(ke.verbose);ye&&((0,c.$dm)(process.argv,"--waitMarkerFilePath",ye),ke.waitMarkerFilePath=ye)}return ke}k(ke){if(ke["open-url"]&&(ke._urls=ke._,ke._=[]),!ke.remote){const ye=this.l(ke._,ke.goto);ke._=ye}return ke}l(ke,ye){const te=(0,k.cwd)(),fe=ke.map(Oe=>{let Ue=String(Oe),je;ye&&(je=(0,l.$mg)(Ue),Ue=je.path),Ue&&(Ue=this.m(te,Ue));const Ge=(0,l.$hg)(Ue,te),qe=(0,h.$nc)(Ge);return qe&&!(0,l.$dg)(qe)?null:ye&&je?(je.path=Ge,this.n(je)):Ge}),$e=p.$i||p.$j,Ce=(0,M.$Mb)(fe,Oe=>Oe&&$e?Oe.toLowerCase():Oe||"");return(0,M.$Hb)(Ce)}m(ke,ye){return p.$i&&(ye=(0,u.$4e)(ye,'"')),ye=(0,u.$2e)((0,u.$2e)(ye," "),"	"),p.$i&&(ye=(0,h.$kc)(ke,ye),ye=(0,u.$4e)(ye,".")),ye}n(ke){const ye=[ke.path];return typeof ke.line=="number"&&ye.push(String(ke.line)),typeof ke.column=="number"&&ye.push(String(ke.column)),ye.join(":")}}new Ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/00124e9e5830e3efc897db71c781899f8a676295/core/vs/code/electron-main/main.js.map
