/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/browser/dom","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/browser/ui/hover/hoverDelegate","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/numbers","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/base/browser/ui/iconLabel/iconLabelHover","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(se){for(var e=[],A=0,N=se.length;A<N;A++)e[A]=me[se[A]];return e};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Ht,setPrototypeOf:zt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Tt,construct:Nt}=typeof Reflect<"u"&&Reflect;Tt||(Tt=function(e,A,N){return e.apply(A,N)}),ot||(ot=function(e){return e}),ft||(ft=function(e){return e}),Nt||(Nt=function(e,A){return new e(...A)});const oi=ut(Array.prototype.forEach),Ut=ut(Array.prototype.pop),vt=ut(Array.prototype.push),At=ut(String.prototype.toLowerCase),Rt=ut(String.prototype.toString),li=ut(String.prototype.match),dt=ut(String.prototype.replace),ai=ut(String.prototype.indexOf),hi=ut(String.prototype.trim),ht=ut(RegExp.prototype.test),Dt=ui(TypeError);function ut(se){return function(e){for(var A=arguments.length,N=new Array(A>1?A-1:0),n=1;n<A;n++)N[n-1]=arguments[n];return Tt(se,e,N)}}function ui(se){return function(){for(var e=arguments.length,A=new Array(e),N=0;N<e;N++)A[N]=arguments[N];return Nt(se,A)}}function je(se,e,A){var N;A=(N=A)!==null&&N!==void 0?N:At,zt&&zt(se,null);let n=e.length;for(;n--;){let W=e[n];if(typeof W=="string"){const D=A(W);D!==W&&(ii(e)||(e[n]=D),W=D)}se[W]=!0}return se}function $t(se){const e=ri(null);for(const[A,N]of Ht(se))e[A]=N;return e}function kt(se,e){for(;se!==null;){const N=si(se,e);if(N){if(N.get)return ut(N.get);if(typeof N.value=="function")return ut(N.value)}se=ni(se)}function A(N){return console.warn("fallback value for",N),null}return A}const jt=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),It=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Mt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Vt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Pt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),_t=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),St=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),qt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Kt=ft(/^html$/i);var Qt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Kt});const vi=()=>typeof window>"u"?null:window,Di=function(e,A){if(typeof e!="object"||typeof e.createPolicy!="function")return null;let N=null;const n="data-tt-policy-suffix";A&&A.hasAttribute(n)&&(N=A.getAttribute(n));const W="dompurify"+(N?"#"+N:"");try{return e.createPolicy(W,{createHTML(D){return D},createScriptURL(D){return D}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Gt(){let se=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const e=He=>Gt(He);if(e.version="3.0.5",e.removed=[],!se||!se.document||se.document.nodeType!==9)return e.isSupported=!1,e;const A=se.document,N=A.currentScript;let{document:n}=se;const{DocumentFragment:W,HTMLTemplateElement:D,Node:S,Element:b,NodeFilter:$,NamedNodeMap:p=se.NamedNodeMap||se.MozNamedAttrMap,HTMLFormElement:O,DOMParser:l,trustedTypes:f}=se,t=b.prototype,s=kt(t,"cloneNode"),c=kt(t,"nextSibling"),g=kt(t,"childNodes"),u=kt(t,"parentNode");if(typeof D=="function"){const He=n.createElement("template");He.content&&He.content.ownerDocument&&(n=He.content.ownerDocument)}let w,h="";const{implementation:m,createNodeIterator:a,createDocumentFragment:y,getElementsByTagName:L}=n,{importNode:R}=A;let z={};e.isSupported=typeof Ht=="function"&&typeof u=="function"&&m&&m.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:H,ERB_EXPR:E,TMPLIT_EXPR:B,DATA_ATTR:j,ARIA_ATTR:F,IS_SCRIPT_OR_DATA:M,ATTR_WHITESPACE:I}=Qt;let{IS_ALLOWED_URI:x}=Qt,X=null;const de=je({},[...jt,...Lt,...It,...Mt,...Wt]);let ue=null;const te=je({},[...Vt,...Pt,..._t,...St]);let ge=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Le=null,Te=null,Be=!0,le=!0,J=!1,ae=!0,re=!1,Y=!1,Q=!1,ie=!1,fe=!1,ye=!1,Ce=!1,ke=!0,q=!1;const d="user-content-";let k=!0,C=!1,r={},i=null;const o=je({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let v=null;const P=je({},["audio","video","img","source","image","track"]);let T=null;const U=je({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),_="http://www.w3.org/1998/Math/MathML",Z="http://www.w3.org/2000/svg",oe="http://www.w3.org/1999/xhtml";let be=oe,De=!1,ve=null;const Se=je({},[_,Z,oe],Rt);let we;const Ne=["application/xhtml+xml","text/html"],Me="text/html";let Pe,Xe=null;const nt=n.createElement("form"),Qe=function(he){return he instanceof RegExp||he instanceof Function},Ze=function(he){if(!(Xe&&Xe===he)){if((!he||typeof he!="object")&&(he={}),he=$t(he),we=Ne.indexOf(he.PARSER_MEDIA_TYPE)===-1?we=Me:we=he.PARSER_MEDIA_TYPE,Pe=we==="application/xhtml+xml"?Rt:At,X="ALLOWED_TAGS"in he?je({},he.ALLOWED_TAGS,Pe):de,ue="ALLOWED_ATTR"in he?je({},he.ALLOWED_ATTR,Pe):te,ve="ALLOWED_NAMESPACES"in he?je({},he.ALLOWED_NAMESPACES,Rt):Se,T="ADD_URI_SAFE_ATTR"in he?je($t(U),he.ADD_URI_SAFE_ATTR,Pe):U,v="ADD_DATA_URI_TAGS"in he?je($t(P),he.ADD_DATA_URI_TAGS,Pe):P,i="FORBID_CONTENTS"in he?je({},he.FORBID_CONTENTS,Pe):o,Le="FORBID_TAGS"in he?je({},he.FORBID_TAGS,Pe):{},Te="FORBID_ATTR"in he?je({},he.FORBID_ATTR,Pe):{},r="USE_PROFILES"in he?he.USE_PROFILES:!1,Be=he.ALLOW_ARIA_ATTR!==!1,le=he.ALLOW_DATA_ATTR!==!1,J=he.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,re=he.SAFE_FOR_TEMPLATES||!1,Y=he.WHOLE_DOCUMENT||!1,fe=he.RETURN_DOM||!1,ye=he.RETURN_DOM_FRAGMENT||!1,Ce=he.RETURN_TRUSTED_TYPE||!1,ie=he.FORCE_BODY||!1,ke=he.SANITIZE_DOM!==!1,q=he.SANITIZE_NAMED_PROPS||!1,k=he.KEEP_CONTENT!==!1,C=he.IN_PLACE||!1,x=he.ALLOWED_URI_REGEXP||qt,be=he.NAMESPACE||oe,ge=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&Qe(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ge.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&Qe(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ge.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ge.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),re&&(le=!1),ye&&(fe=!0),r&&(X=je({},[...Wt]),ue=[],r.html===!0&&(je(X,jt),je(ue,Vt)),r.svg===!0&&(je(X,Lt),je(ue,Pt),je(ue,St)),r.svgFilters===!0&&(je(X,It),je(ue,Pt),je(ue,St)),r.mathMl===!0&&(je(X,Mt),je(ue,_t),je(ue,St))),he.ADD_TAGS&&(X===de&&(X=$t(X)),je(X,he.ADD_TAGS,Pe)),he.ADD_ATTR&&(ue===te&&(ue=$t(ue)),je(ue,he.ADD_ATTR,Pe)),he.ADD_URI_SAFE_ATTR&&je(T,he.ADD_URI_SAFE_ATTR,Pe),he.FORBID_CONTENTS&&(i===o&&(i=$t(i)),je(i,he.FORBID_CONTENTS,Pe)),k&&(X["#text"]=!0),Y&&je(X,["html","head","body"]),X.table&&(je(X,["tbody"]),delete Le.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw Dt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw Dt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');w=he.TRUSTED_TYPES_POLICY,h=w.createHTML("")}else w===void 0&&(w=Di(f,N)),w!==null&&typeof h=="string"&&(h=w.createHTML(""));ot&&ot(he),Xe=he}},G=je({},["mi","mo","mn","ms","mtext"]),ne=je({},["foreignobject","desc","title","annotation-xml"]),pe=je({},["title","style","font","a","script"]),Ee=je({},Lt);je(Ee,It),je(Ee,ci);const Re=je({},Mt);je(Re,fi);const Ue=function(he){let Fe=u(he);(!Fe||!Fe.tagName)&&(Fe={namespaceURI:be,tagName:"template"});const Ie=At(he.tagName),_e=At(Fe.tagName);return ve[he.namespaceURI]?he.namespaceURI===Z?Fe.namespaceURI===oe?Ie==="svg":Fe.namespaceURI===_?Ie==="svg"&&(_e==="annotation-xml"||G[_e]):!!Ee[Ie]:he.namespaceURI===_?Fe.namespaceURI===oe?Ie==="math":Fe.namespaceURI===Z?Ie==="math"&&ne[_e]:!!Re[Ie]:he.namespaceURI===oe?Fe.namespaceURI===Z&&!ne[_e]||Fe.namespaceURI===_&&!G[_e]?!1:!Re[Ie]&&(pe[Ie]||!Ee[Ie]):!!(we==="application/xhtml+xml"&&ve[he.namespaceURI]):!1},Ve=function(he){vt(e.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},Je=function(he,Fe){try{vt(e.removed,{attribute:Fe.getAttributeNode(he),from:Fe})}catch{vt(e.removed,{attribute:null,from:Fe})}if(Fe.removeAttribute(he),he==="is"&&!ue[he])if(fe||ye)try{Ve(Fe)}catch{}else try{Fe.setAttribute(he,"")}catch{}},tt=function(he){let Fe,Ie;if(ie)he="<remove></remove>"+he;else{const lt=li(he,/^[\r\n\t ]+/);Ie=lt&&lt[0]}we==="application/xhtml+xml"&&be===oe&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const _e=w?w.createHTML(he):he;if(be===oe)try{Fe=new l().parseFromString(_e,we)}catch{}if(!Fe||!Fe.documentElement){Fe=m.createDocument(be,"template",null);try{Fe.documentElement.innerHTML=De?h:_e}catch{}}const it=Fe.body||Fe.documentElement;return he&&Ie&&it.insertBefore(n.createTextNode(Ie),it.childNodes[0]||null),be===oe?L.call(Fe,Y?"html":"body")[0]:Y?Fe.documentElement:it},st=function(he){return a.call(he.ownerDocument||he,he,$.SHOW_ELEMENT|$.SHOW_COMMENT|$.SHOW_TEXT,null,!1)},Ye=function(he){return he instanceof O&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof p)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},rt=function(he){return typeof S=="object"?he instanceof S:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},et=function(he,Fe,Ie){z[he]&&oi(z[he],_e=>{_e.call(e,Fe,Ie,Xe)})},gt=function(he){let Fe;if(et("beforeSanitizeElements",he,null),Ye(he))return Ve(he),!0;const Ie=Pe(he.nodeName);if(et("uponSanitizeElement",he,{tagName:Ie,allowedTags:X}),he.hasChildNodes()&&!rt(he.firstElementChild)&&(!rt(he.content)||!rt(he.content.firstElementChild))&&ht(/<[/\w]/g,he.innerHTML)&&ht(/<[/\w]/g,he.textContent))return Ve(he),!0;if(!X[Ie]||Le[Ie]){if(!Le[Ie]&&bt(Ie)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Ie)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Ie)))return!1;if(k&&!i[Ie]){const _e=u(he)||he.parentNode,it=g(he)||he.childNodes;if(it&&_e){const lt=it.length;for(let Ge=lt-1;Ge>=0;--Ge)_e.insertBefore(s(it[Ge],!0),c(he))}}return Ve(he),!0}return he instanceof b&&!Ue(he)||(Ie==="noscript"||Ie==="noembed"||Ie==="noframes")&&ht(/<\/no(script|embed|frames)/i,he.innerHTML)?(Ve(he),!0):(re&&he.nodeType===3&&(Fe=he.textContent,Fe=dt(Fe,H," "),Fe=dt(Fe,E," "),Fe=dt(Fe,B," "),he.textContent!==Fe&&(vt(e.removed,{element:he.cloneNode()}),he.textContent=Fe)),et("afterSanitizeElements",he,null),!1)},mt=function(he,Fe,Ie){if(ke&&(Fe==="id"||Fe==="name")&&(Ie in n||Ie in nt))return!1;if(!(le&&!Te[Fe]&&ht(j,Fe))){if(!(Be&&ht(F,Fe))){if(!ue[Fe]||Te[Fe]){if(!(bt(he)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,he)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(he))&&(ge.attributeNameCheck instanceof RegExp&&ht(ge.attributeNameCheck,Fe)||ge.attributeNameCheck instanceof Function&&ge.attributeNameCheck(Fe))||Fe==="is"&&ge.allowCustomizedBuiltInElements&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Ie)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Ie))))return!1}else if(!T[Fe]){if(!ht(x,dt(Ie,I,""))){if(!((Fe==="src"||Fe==="xlink:href"||Fe==="href")&&he!=="script"&&ai(Ie,"data:")===0&&v[he])){if(!(J&&!ht(M,dt(Ie,I,"")))){if(Ie)return!1}}}}}}return!0},bt=function(he){return he.indexOf("-")>0},Ft=function(he){let Fe,Ie,_e,it;et("beforeSanitizeAttributes",he,null);const{attributes:lt}=he;if(!lt)return;const Ge={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ue};for(it=lt.length;it--;){Fe=lt[it];const{name:ct,namespaceURI:pt}=Fe;if(Ie=ct==="value"?Fe.value:hi(Fe.value),_e=Pe(ct),Ge.attrName=_e,Ge.attrValue=Ie,Ge.keepAttr=!0,Ge.forceKeepAttr=void 0,et("uponSanitizeAttribute",he,Ge),Ie=Ge.attrValue,Ge.forceKeepAttr||(Je(ct,he),!Ge.keepAttr))continue;if(!ae&&ht(/\/>/i,Ie)){Je(ct,he);continue}re&&(Ie=dt(Ie,H," "),Ie=dt(Ie,E," "),Ie=dt(Ie,B," "));const yt=Pe(he.nodeName);if(mt(yt,_e,Ie)){if(q&&(_e==="id"||_e==="name")&&(Je(ct,he),Ie=d+Ie),w&&typeof f=="object"&&typeof f.getAttributeType=="function"&&!pt)switch(f.getAttributeType(yt,_e)){case"TrustedHTML":{Ie=w.createHTML(Ie);break}case"TrustedScriptURL":{Ie=w.createScriptURL(Ie);break}}try{pt?he.setAttributeNS(pt,ct,Ie):he.setAttribute(ct,Ie),Ut(e.removed)}catch{}}}et("afterSanitizeAttributes",he,null)},Ot=function He(he){let Fe;const Ie=st(he);for(et("beforeSanitizeShadowDOM",he,null);Fe=Ie.nextNode();)et("uponSanitizeShadowNode",Fe,null),!gt(Fe)&&(Fe.content instanceof W&&He(Fe.content),Ft(Fe));et("afterSanitizeShadowDOM",he,null)};return e.sanitize=function(He){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Fe,Ie,_e,it;if(De=!He,De&&(He="<!-->"),typeof He!="string"&&!rt(He))if(typeof He.toString=="function"){if(He=He.toString(),typeof He!="string")throw Dt("dirty is not a string, aborting")}else throw Dt("toString is not a function");if(!e.isSupported)return He;if(Q||Ze(he),e.removed=[],typeof He=="string"&&(C=!1),C){if(He.nodeName){const ct=Pe(He.nodeName);if(!X[ct]||Le[ct])throw Dt("root node is forbidden and cannot be sanitized in-place")}}else if(He instanceof S)Fe=tt("<!---->"),Ie=Fe.ownerDocument.importNode(He,!0),Ie.nodeType===1&&Ie.nodeName==="BODY"||Ie.nodeName==="HTML"?Fe=Ie:Fe.appendChild(Ie);else{if(!fe&&!re&&!Y&&He.indexOf("<")===-1)return w&&Ce?w.createHTML(He):He;if(Fe=tt(He),!Fe)return fe?null:Ce?h:""}Fe&&ie&&Ve(Fe.firstChild);const lt=st(C?He:Fe);for(;_e=lt.nextNode();)gt(_e)||(_e.content instanceof W&&Ot(_e.content),Ft(_e));if(C)return He;if(fe){if(ye)for(it=y.call(Fe.ownerDocument);Fe.firstChild;)it.appendChild(Fe.firstChild);else it=Fe;return(ue.shadowroot||ue.shadowrootmode)&&(it=R.call(A,it,!0)),it}let Ge=Y?Fe.outerHTML:Fe.innerHTML;return Y&&X["!doctype"]&&Fe.ownerDocument&&Fe.ownerDocument.doctype&&Fe.ownerDocument.doctype.name&&ht(Kt,Fe.ownerDocument.doctype.name)&&(Ge="<!DOCTYPE "+Fe.ownerDocument.doctype.name+`>
`+Ge),re&&(Ge=dt(Ge,H," "),Ge=dt(Ge,E," "),Ge=dt(Ge,B," ")),w&&Ce?w.createHTML(Ge):Ge},e.setConfig=function(He){Ze(He),Q=!0},e.clearConfig=function(){Xe=null,Q=!1},e.isValidAttribute=function(He,he,Fe){Xe||Ze({});const Ie=Pe(He),_e=Pe(he);return mt(Ie,_e,Fe)},e.addHook=function(He,he){typeof he=="function"&&(z[He]=z[He]||[],vt(z[He],he))},e.removeHook=function(He){if(z[He])return Ut(z[He])},e.removeHooks=function(He){z[He]&&(z[He]=[])},e.removeAllHooks=function(){z={}},e}var yi=Gt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(me[44],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gS=e.$fS=void 0;class A{constructor(D){this.domNode=D,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(D){const S=N(D);this.a!==S&&(this.a=S,this.domNode.style.maxWidth=this.a)}setWidth(D){const S=N(D);this.b!==S&&(this.b=S,this.domNode.style.width=this.b)}setHeight(D){const S=N(D);this.c!==S&&(this.c=S,this.domNode.style.height=this.c)}setTop(D){const S=N(D);this.d!==S&&(this.d=S,this.domNode.style.top=this.d)}setLeft(D){const S=N(D);this.e!==S&&(this.e=S,this.domNode.style.left=this.e)}setBottom(D){const S=N(D);this.f!==S&&(this.f=S,this.domNode.style.bottom=this.f)}setRight(D){const S=N(D);this.g!==S&&(this.g=S,this.domNode.style.right=this.g)}setPaddingTop(D){const S=N(D);this.h!==S&&(this.h=S,this.domNode.style.paddingTop=this.h)}setPaddingLeft(D){const S=N(D);this.i!==S&&(this.i=S,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(D){const S=N(D);this.j!==S&&(this.j=S,this.domNode.style.paddingBottom=this.j)}setPaddingRight(D){const S=N(D);this.k!==S&&(this.k=S,this.domNode.style.paddingRight=this.k)}setFontFamily(D){this.l!==D&&(this.l=D,this.domNode.style.fontFamily=this.l)}setFontWeight(D){this.m!==D&&(this.m=D,this.domNode.style.fontWeight=this.m)}setFontSize(D){const S=N(D);this.n!==S&&(this.n=S,this.domNode.style.fontSize=this.n)}setFontStyle(D){this.o!==D&&(this.o=D,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(D){this.p!==D&&(this.p=D,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(D){this.q!==D&&(this.q=D,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(D){this.r!==D&&(this.r=D,this.domNode.style.textDecoration=this.r)}setLineHeight(D){const S=N(D);this.s!==S&&(this.s=S,this.domNode.style.lineHeight=this.s)}setLetterSpacing(D){const S=N(D);this.t!==S&&(this.t=S,this.domNode.style.letterSpacing=this.t)}setClassName(D){this.u!==D&&(this.u=D,this.domNode.className=this.u)}toggleClassName(D,S){this.domNode.classList.toggle(D,S),this.u=this.domNode.className}setDisplay(D){this.v!==D&&(this.v=D,this.domNode.style.display=this.v)}setPosition(D){this.w!==D&&(this.w=D,this.domNode.style.position=this.w)}setVisibility(D){this.x!==D&&(this.x=D,this.domNode.style.visibility=this.x)}setColor(D){this.y!==D&&(this.y=D,this.domNode.style.color=this.y)}setBackgroundColor(D){this.z!==D&&(this.z=D,this.domNode.style.backgroundColor=this.z)}setLayerHinting(D){this.A!==D&&(this.A=D,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(D){this.C!==D&&(this.C=D,this.domNode.style.boxShadow=D)}setContain(D){this.B!==D&&(this.B=D,this.domNode.style.contain=this.B)}setAttribute(D,S){this.domNode.setAttribute(D,S)}removeAttribute(D){this.domNode.removeAttribute(D)}appendChild(D){this.domNode.appendChild(D.domNode)}removeChild(D){this.domNode.removeChild(D.domNode)}}e.$fS=A;function N(W){return typeof W=="number"?`${W}px`:W}function n(W){return new A(W)}e.$gS=n}),define(me[71],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=e.$wQ=void 0;const A=new WeakMap;function N(S){if(!S.parent||S.parent===S)return null;try{const b=S.location,$=S.parent.location;if(b.origin!=="null"&&$.origin!=="null"&&b.origin!==$.origin)return null}catch{return null}return S.parent}class n{static a(b){let $=A.get(b);if(!$){$=[],A.set(b,$);let p=b,O;do O=N(p),O?$.push({window:new WeakRef(p),iframeElement:p.frameElement||null}):$.push({window:new WeakRef(p),iframeElement:null}),p=O;while(p)}return $.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(b,$){if(!$||b===$)return{top:0,left:0};let p=0,O=0;const l=this.a(b);for(const f of l){const t=f.window.deref();if(p+=t?.scrollY??0,O+=t?.scrollX??0,t===$||!f.iframeElement)break;const s=f.iframeElement.getBoundingClientRect();p+=s.top,O+=s.left}return{top:p,left:O}}}e.$wQ=n;async function W(S,b){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const $=JSON.stringify({parentOrigin:S,salt:b}),O=new TextEncoder().encode($),l=await crypto.subtle.digest("sha-256",O);return D(l)}e.$xQ=W;function D(S){const $=Array.from(new Uint8Array(S)).map(p=>p.toString(16).padStart(2,"0")).join("");return BigInt(`0x${$}`).toString(32).padStart(52,"0")}}),define(me[72],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1S=e.$ZS=e.$YS=e.ListDragOverEffectPosition=e.ListDragOverEffectType=void 0;var A;(function(D){D[D.Copy=0]="Copy",D[D.Move=1]="Move"})(A||(e.ListDragOverEffectType=A={}));var N;(function(D){D.Over="drop-target",D.Before="drop-target-before",D.After="drop-target-after"})(N||(e.ListDragOverEffectPosition=N={})),e.$YS={reject(){return{accept:!1}},accept(){return{accept:!0}}};class n extends Error{constructor(S,b){super(`ListError [${S}] ${b}`)}}e.$ZS=n;class W{constructor(){this.c=new WeakMap}getHeight(S){return this.c.get(S)??this.d(S)}setDynamicHeight(S,b){b>0&&this.c.set(S,b)}}e.$1S=W}),define(me[73],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OS=void 0;class A{constructor(n){this.a=n}splice(n,W,D){this.a.forEach(S=>S.splice(n,W,D))}}e.$OS=A}),define(me[45],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lS=void 0;const A=20;class N{constructor(W,D,S,b,$,p){this.a=Math.round(D),this.b=Math.round(S),this.c=Math.round(W),this.d=b,this.e=$,this.f=p,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new N(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(W){const D=Math.round(W);return this.d!==D?(this.d=D,this.m(),!0):!1}setScrollSize(W){const D=Math.round(W);return this.e!==D?(this.e=D,this.m(),!0):!1}setScrollPosition(W){const D=Math.round(W);return this.f!==D?(this.f=D,this.m(),!0):!1}setScrollbarSize(W){this.a=Math.round(W)}setOppositeScrollbarSize(W){this.b=Math.round(W)}static l(W,D,S,b,$){const p=Math.max(0,S-W),O=Math.max(0,p-2*D),l=b>0&&b>S;if(!l)return{computedAvailableSize:Math.round(p),computedIsNeeded:l,computedSliderSize:Math.round(O),computedSliderRatio:0,computedSliderPosition:0};const f=Math.round(Math.max(A,Math.floor(S*O/b))),t=(O-f)/(b-S),s=$*t;return{computedAvailableSize:Math.round(p),computedIsNeeded:l,computedSliderSize:Math.round(f),computedSliderRatio:t,computedSliderPosition:Math.round(s)}}m(){const W=N.l(this.b,this.c,this.d,this.e,this.f);this.g=W.computedAvailableSize,this.h=W.computedIsNeeded,this.i=W.computedSliderSize,this.j=W.computedSliderRatio,this.k=W.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(W){if(!this.h)return 0;const D=W-this.c-this.i/2;return Math.round(D/this.j)}getDesiredScrollPositionFromOffsetPaged(W){if(!this.h)return 0;const D=W-this.c;let S=this.f;return D<this.k?S-=this.d:S+=this.d,S}getDesiredScrollPositionFromDelta(W){if(!this.h)return 0;const D=this.k+W;return Math.round(D/this.j)}}e.$lS=N}),define(me[26],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SU=e.$RU=e.$QU=e.TreeDragOverBubble=e.TreeMouseEventTarget=e.ObjectTreeElementCollapseState=e.TreeVisibility=void 0;var A;(function(b){b[b.Hidden=0]="Hidden",b[b.Visible=1]="Visible",b[b.Recurse=2]="Recurse"})(A||(e.TreeVisibility=A={}));var N;(function(b){b[b.Expanded=0]="Expanded",b[b.Collapsed=1]="Collapsed",b[b.PreserveOrExpanded=2]="PreserveOrExpanded",b[b.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(N||(e.ObjectTreeElementCollapseState=N={}));var n;(function(b){b[b.Unknown=0]="Unknown",b[b.Twistie=1]="Twistie",b[b.Element=2]="Element",b[b.Filter=3]="Filter"})(n||(e.TreeMouseEventTarget=n={}));var W;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(W||(e.TreeDragOverBubble=W={})),e.$QU={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(b=!1){return{accept:!0,bubble:0,autoExpand:b}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(b=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:b}}};class D extends Error{constructor($,p){super(`TreeError [${$}] ${p}`)}}e.$RU=D;class S{constructor($){this.a=$,this.b=new WeakMap}map($){let p=this.b.get($);return p||(p=this.a($),this.b.set($,p)),p}}e.$SU=S}),define(me[21],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=e.$window=e.$_P=e.$$P=void 0;function A(n,W){const D=n;typeof D.vscodeWindowId!="number"&&Object.defineProperty(D,"vscodeWindowId",{get:()=>W})}e.$$P=A,e.$_P=window,e.$window=e.$_P;function N(n){return n===e.$_P?!1:typeof n?.vscodeWindowId=="number"}e.$bQ=N}),define(me[74],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function A(s,c,g){const u=N(s,c);if(u!==-1)return s[u]}e.$fb=A;function N(s,c,g=s.length-1){for(let u=g;u>=0;u--){const w=s[u];if(c(w))return u}return-1}e.$gb=N;function n(s,c){const g=W(s,c);return g===-1?void 0:s[g]}e.$hb=n;function W(s,c,g=0,u=s.length){let w=g,h=u;for(;w<h;){const m=Math.floor((w+h)/2);c(s[m])?w=m+1:h=m}return w-1}e.$ib=W;function D(s,c){const g=S(s,c);return g===s.length?void 0:s[g]}e.$jb=D;function S(s,c,g=0,u=s.length){let w=g,h=u;for(;w<h;){const m=Math.floor((w+h)/2);c(s[m])?h=m:w=m+1}return w}e.$kb=S;function b(s,c,g=0,u=s.length){const w=S(s,c,g,u);return w===s.length?-1:w}e.$lb=b;class ${static{this.assertInvariants=!1}constructor(c){this.e=c,this.c=0}findLastMonotonous(c){if($.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!c(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=c}const g=W(this.e,c,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$mb=$;function p(s,c){if(s.length===0)return;let g=s[0];for(let u=1;u<s.length;u++){const w=s[u];c(w,g)>0&&(g=w)}return g}e.$nb=p;function O(s,c){if(s.length===0)return;let g=s[0];for(let u=1;u<s.length;u++){const w=s[u];c(w,g)>=0&&(g=w)}return g}e.$ob=O;function l(s,c){return p(s,(g,u)=>-c(g,u))}e.$pb=l;function f(s,c){if(s.length===0)return-1;let g=0;for(let u=1;u<s.length;u++){const w=s[u];c(w,s[g])>0&&(g=u)}return g}e.$qb=f;function t(s,c){for(const g of s){const u=c(g);if(u!==void 0)return u}}e.$rb=t}),define(me[75],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function A(D,S){const b=Object.create(null);for(const $ of D){const p=S($);let O=b[p];O||(O=b[p]=[]),O.push($)}return b}e.$K=A;function N(D,S){const b=[],$=[];for(const p of D)S.has(p)||b.push(p);for(const p of S)D.has(p)||$.push(p);return{removed:b,added:$}}e.$L=N;function n(D,S){const b=[],$=[];for(const[p,O]of D)S.has(p)||b.push(O);for(const[p,O]of S)D.has(p)||$.push(O);return{removed:b,added:$}}e.$M=n;function W(D,S){const b=new Set;for(const $ of S)D.has($)&&b.add($);return b}e.$N=W}),define(me[76],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.$wt=e.$vt=e.$ut=void 0;function A(S,b){const $=Math.pow(10,b);return Math.round(S*$)/$}class N{constructor(b,$,p,O=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,b))|0,this.g=Math.min(255,Math.max(0,$))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=A(Math.max(Math.min(1,O),0),3)}static equals(b,$){return b.r===$.r&&b.g===$.g&&b.b===$.b&&b.a===$.a}}e.$ut=N;class n{constructor(b,$,p,O){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=A(Math.max(Math.min(1,$),0),3),this.l=A(Math.max(Math.min(1,p),0),3),this.a=A(Math.max(Math.min(1,O),0),3)}static equals(b,$){return b.h===$.h&&b.s===$.s&&b.l===$.l&&b.a===$.a}static fromRGBA(b){const $=b.r/255,p=b.g/255,O=b.b/255,l=b.a,f=Math.max($,p,O),t=Math.min($,p,O);let s=0,c=0;const g=(t+f)/2,u=f-t;if(u>0){switch(c=Math.min(g<=.5?u/(2*g):u/(2-2*g),1),f){case $:s=(p-O)/u+(p<O?6:0);break;case p:s=(O-$)/u+2;break;case O:s=($-p)/u+4;break}s*=60,s=Math.round(s)}return new n(s,c,g,l)}static i(b,$,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?b+($-b)*6*p:p<1/2?$:p<2/3?b+($-b)*(2/3-p)*6:b}static toRGBA(b){const $=b.h/360,{s:p,l:O,a:l}=b;let f,t,s;if(p===0)f=t=s=O;else{const c=O<.5?O*(1+p):O+p-O*p,g=2*O-c;f=n.i(g,c,$+1/3),t=n.i(g,c,$),s=n.i(g,c,$-1/3)}return new N(Math.round(f*255),Math.round(t*255),Math.round(s*255),l)}}e.$vt=n;class W{constructor(b,$,p,O){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=A(Math.max(Math.min(1,$),0),3),this.v=A(Math.max(Math.min(1,p),0),3),this.a=A(Math.max(Math.min(1,O),0),3)}static equals(b,$){return b.h===$.h&&b.s===$.s&&b.v===$.v&&b.a===$.a}static fromRGBA(b){const $=b.r/255,p=b.g/255,O=b.b/255,l=Math.max($,p,O),f=Math.min($,p,O),t=l-f,s=l===0?0:t/l;let c;return t===0?c=0:l===$?c=((p-O)/t%6+6)%6:l===p?c=(O-$)/t+2:c=($-p)/t+4,new W(Math.round(c*60),s,l,b.a)}static toRGBA(b){const{h:$,s:p,v:O,a:l}=b,f=O*p,t=f*(1-Math.abs($/60%2-1)),s=O-f;let[c,g,u]=[0,0,0];return $<60?(c=f,g=t):$<120?(c=t,g=f):$<180?(g=f,u=t):$<240?(g=t,u=f):$<300?(c=t,u=f):$<=360&&(c=f,u=t),c=Math.round((c+s)*255),g=Math.round((g+s)*255),u=Math.round((u+s)*255),new N(c,g,u,l)}}e.$wt=W;class D{static fromHex(b){return D.Format.CSS.parseHex(b)||D.red}static equals(b,$){return!b&&!$?!0:!b||!$?!1:b.equals($)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:W.fromRGBA(this.rgba)}constructor(b){if(b)if(b instanceof N)this.rgba=b;else if(b instanceof n)this.i=b,this.rgba=n.toRGBA(b);else if(b instanceof W)this.j=b,this.rgba=W.toRGBA(b);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(b){return!!b&&N.equals(this.rgba,b.rgba)&&n.equals(this.hsla,b.hsla)&&W.equals(this.hsva,b.hsva)}getRelativeLuminance(){const b=D.k(this.rgba.r),$=D.k(this.rgba.g),p=D.k(this.rgba.b),O=.2126*b+.7152*$+.0722*p;return A(O,4)}static k(b){const $=b/255;return $<=.03928?$/12.92:Math.pow(($+.055)/1.055,2.4)}getContrastRatio(b){const $=this.getRelativeLuminance(),p=b.getRelativeLuminance();return $>p?($+.05)/(p+.05):(p+.05)/($+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(b){const $=this.getRelativeLuminance(),p=b.getRelativeLuminance();return $>p}isDarkerThan(b){const $=this.getRelativeLuminance(),p=b.getRelativeLuminance();return $<p}lighten(b){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*b,this.hsla.a))}darken(b){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*b,this.hsla.a))}transparent(b){const{r:$,g:p,b:O,a:l}=this.rgba;return new D(new N($,p,O,l*b))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new N(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(b){const $=b.rgba,p=this.rgba.a,O=$.a,l=p+O*(1-p);if(l<1e-6)return D.transparent;const f=this.rgba.r*p/l+$.r*O*(1-p)/l,t=this.rgba.g*p/l+$.g*O*(1-p)/l,s=this.rgba.b*p/l+$.b*O*(1-p)/l;return new D(new N(f,t,s,l))}makeOpaque(b){if(this.isOpaque()||b.rgba.a!==1)return this;const{r:$,g:p,b:O,a:l}=this.rgba;return new D(new N(b.rgba.r-l*(b.rgba.r-$),b.rgba.g-l*(b.rgba.g-p),b.rgba.b-l*(b.rgba.b-O),1))}flatten(...b){const $=b.reduceRight((p,O)=>D.o(O,p));return D.o(this,$)}static o(b,$){const p=1-b.rgba.a;return new D(new N(p*$.rgba.r+b.rgba.a*b.rgba.r,p*$.rgba.g+b.rgba.a*b.rgba.g,p*$.rgba.b+b.rgba.a*b.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(b,$,p){if(b.isLighterThan($))return b;p=p||.5;const O=b.getRelativeLuminance(),l=$.getRelativeLuminance();return p=p*(l-O)/l,b.lighten(p)}static getDarkerColor(b,$,p){if(b.isDarkerThan($))return b;p=p||.5;const O=b.getRelativeLuminance(),l=$.getRelativeLuminance();return p=p*(O-l)/O,b.darken(p)}static{this.white=new D(new N(255,255,255,1))}static{this.black=new D(new N(0,0,0,1))}static{this.red=new D(new N(255,0,0,1))}static{this.blue=new D(new N(0,0,255,1))}static{this.green=new D(new N(0,255,0,1))}static{this.cyan=new D(new N(0,255,255,1))}static{this.lightgrey=new D(new N(211,211,211,1))}static{this.transparent=new D(new N(0,0,0,0))}}e.$xt=D,function(S){let b;(function($){let p;(function(O){function l(a){return a.rgba.a===1?`rgb(${a.rgba.r}, ${a.rgba.g}, ${a.rgba.b})`:S.Format.CSS.formatRGBA(a)}O.formatRGB=l;function f(a){return`rgba(${a.rgba.r}, ${a.rgba.g}, ${a.rgba.b}, ${+a.rgba.a.toFixed(2)})`}O.formatRGBA=f;function t(a){return a.hsla.a===1?`hsl(${a.hsla.h}, ${(a.hsla.s*100).toFixed(2)}%, ${(a.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(a)}O.formatHSL=t;function s(a){return`hsla(${a.hsla.h}, ${(a.hsla.s*100).toFixed(2)}%, ${(a.hsla.l*100).toFixed(2)}%, ${a.hsla.a.toFixed(2)})`}O.formatHSLA=s;function c(a){const y=a.toString(16);return y.length!==2?"0"+y:y}function g(a){return`#${c(a.rgba.r)}${c(a.rgba.g)}${c(a.rgba.b)}`}O.formatHex=g;function u(a,y=!1){return y&&a.rgba.a===1?S.Format.CSS.formatHex(a):`#${c(a.rgba.r)}${c(a.rgba.g)}${c(a.rgba.b)}${c(Math.round(a.rgba.a*255))}`}O.formatHexA=u;function w(a){return a.isOpaque()?S.Format.CSS.formatHex(a):S.Format.CSS.formatRGBA(a)}O.format=w;function h(a){const y=a.length;if(y===0||a.charCodeAt(0)!==35)return null;if(y===7){const L=16*m(a.charCodeAt(1))+m(a.charCodeAt(2)),R=16*m(a.charCodeAt(3))+m(a.charCodeAt(4)),z=16*m(a.charCodeAt(5))+m(a.charCodeAt(6));return new S(new N(L,R,z,1))}if(y===9){const L=16*m(a.charCodeAt(1))+m(a.charCodeAt(2)),R=16*m(a.charCodeAt(3))+m(a.charCodeAt(4)),z=16*m(a.charCodeAt(5))+m(a.charCodeAt(6)),H=16*m(a.charCodeAt(7))+m(a.charCodeAt(8));return new S(new N(L,R,z,H/255))}if(y===4){const L=m(a.charCodeAt(1)),R=m(a.charCodeAt(2)),z=m(a.charCodeAt(3));return new S(new N(16*L+L,16*R+R,16*z+z))}if(y===5){const L=m(a.charCodeAt(1)),R=m(a.charCodeAt(2)),z=m(a.charCodeAt(3)),H=m(a.charCodeAt(4));return new S(new N(16*L+L,16*R+R,16*z+z,(16*H+H)/255))}return null}O.parseHex=h;function m(a){switch(a){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=$.CSS||($.CSS={}))})(b=S.Format||(S.Format={}))}(D||(e.$xt=D={}))}),define(me[27],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Jh=e.$Ih=void 0;function A(D){return(S,b,$)=>{let p=null,O=null;if(typeof $.value=="function"?(p="value",O=$.value):typeof $.get=="function"&&(p="get",O=$.get),!O)throw new Error("not supported");$[p]=D(O,b)}}function N(D,S,b){let $=null,p=null;if(typeof b.value=="function"?($="value",p=b.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&($="get",p=b.get),!p)throw new Error("not supported");const O=`$memoize$${S}`;b[$]=function(...l){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,l)}),this[O]}}e.$Ih=N;function n(D,S,b){return A(($,p)=>{const O=`$debounce$${p}`,l=`$debounce$result$${p}`;return function(...f){this[l]||(this[l]=b?b():void 0),clearTimeout(this[O]),S&&(this[l]=S(this[l],...f),f=[this[l]]),this[O]=setTimeout(()=>{$.apply(this,f),this[l]=b?b():void 0},D)}})}e.$Jh=n;function W(D,S,b){return A(($,p)=>{const O=`$throttle$timer$${p}`,l=`$throttle$result$${p}`,f=`$throttle$lastRun$${p}`,t=`$throttle$pending$${p}`;return function(...s){if(this[l]||(this[l]=b?b():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),S&&(this[l]=S(this[l],...s)),this[t])return;const c=this[f]+D;c<=Date.now()?(this[f]=Date.now(),$.apply(this,[this[l]]),this[l]=b?b():void 0):(this[t]=!0,this[O]=setTimeout(()=>{this[t]=!1,this[f]=Date.now(),$.apply(this,[this[l]]),this[l]=b?b():void 0},c-Date.now()))}})}e.$Kh=W}),define(me[77],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0;class A{constructor(n,W,D,S){this.originalStart=n,this.originalLength=W,this.modifiedStart=D,this.modifiedLength=S}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}e.$9s=A}),define(me[6],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class A{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?w.isErrorNoTelemetry(a)?new w(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(y=>{y(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}e.$W=A,e.$X=new A;function N(m){e.$X.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=N;function n(m){if(!m||typeof m!="object")return!1;const a=m;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.$Z=n;function W(m){$(m)||e.$X.onUnexpectedError(m)}e.$1=W;function D(m){$(m)||e.$X.onUnexpectedExternalError(m)}e.$2=D;function S(m){if(m instanceof Error){const{name:a,message:y}=m,L=m.stacktrace||m.stack;return{$isError:!0,name:a,message:y,stack:L,noTelemetry:w.isErrorNoTelemetry(m)}}return m}e.$3=S;const b="Canceled";function $(m){return m instanceof p?!0:m instanceof Error&&m.name===b&&m.message===b}e.$4=$;class p extends Error{constructor(){super(b),this.name=this.message}}e.$5=p;function O(){const m=new Error(b);return m.name=m.message,m}e.$6=O;function l(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.$7=l;function f(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.$8=f;class t extends TypeError{constructor(a){super(a?`${a} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=t;function s(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.$0=s;class c extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.$$=c;class g extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.$_=g;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class w extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof w)return a;const y=new w;return y.message=a.message,y.stack=a.stack,y}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.$bb=w;class h extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype)}}e.$cb=h}),define(me[12],$e([1,0,6,74]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function n(q,d=0){return q[q.length-(1+d)]}e.$sb=n;function W(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.$tb=W;function D(q,d,k=(C,r)=>C===r){if(q===d)return!0;if(!q||!d||q.length!==d.length)return!1;for(let C=0,r=q.length;C<r;C++)if(!k(q[C],d[C]))return!1;return!0}e.$ub=D;function S(q,d){const k=q.length-1;d<k&&(q[d]=q[k]),q.pop()}e.$vb=S;function b(q,d,k){return $(q.length,C=>k(q[C],d))}e.$wb=b;function $(q,d){let k=0,C=q-1;for(;k<=C;){const r=(k+C)/2|0,i=d(r);if(i<0)k=r+1;else if(i>0)C=r-1;else return r}return-(k+1)}e.$xb=$;function p(q,d,k){if(q=q|0,q>=d.length)throw new TypeError("invalid index");const C=d[Math.floor(d.length*Math.random())],r=[],i=[],o=[];for(const v of d){const P=k(v,C);P<0?r.push(v):P>0?i.push(v):o.push(v)}return q<r.length?p(q,r,k):q<r.length+o.length?o[0]:p(q-(r.length+o.length),i,k)}e.$yb=p;function O(q,d){const k=[];let C;for(const r of q.slice(0).sort(d))!C||d(C[0],r)!==0?(C=[r],k.push(C)):C.push(r);return k}e.$zb=O;function*l(q,d){let k,C;for(const r of q)C!==void 0&&d(C,r)?k.push(r):(k&&(yield k),k=[r]),C=r;k&&(yield k)}e.$Ab=l;function f(q,d){for(let k=0;k<=q.length;k++)d(k===0?void 0:q[k-1],k===q.length?void 0:q[k])}e.$Bb=f;function t(q,d){for(let k=0;k<q.length;k++)d(k===0?void 0:q[k-1],q[k],k+1===q.length?void 0:q[k+1])}e.$Cb=t;function s(q,d,k){const C=[];function r(v,P,T){if(P===0&&T.length===0)return;const U=C[C.length-1];U&&U.start+U.deleteCount===v?(U.deleteCount+=P,U.toInsert.push(...T)):C.push({start:v,deleteCount:P,toInsert:T})}let i=0,o=0;for(;;){if(i===q.length){r(i,0,d.slice(o));break}if(o===d.length){r(i,q.length-i,[]);break}const v=q[i],P=d[o],T=k(v,P);T===0?(i+=1,o+=1):T<0?(r(i,1,[]),i+=1):T>0&&(r(i,0,[P]),o+=1)}return C}e.$Db=s;function c(q,d,k){const C=s(q,d,k),r=[],i=[];for(const o of C)r.push(...q.slice(o.start,o.start+o.deleteCount)),i.push(...o.toInsert);return{removed:r,added:i}}e.$Eb=c;function g(q,d,k){if(k===0)return[];const C=q.slice(0,k).sort(d);return w(q,d,C,k,q.length),C}e.top=g;function u(q,d,k,C,r){return k===0?Promise.resolve([]):new Promise((i,o)=>{(async()=>{const v=q.length,P=q.slice(0,k).sort(d);for(let T=k,U=Math.min(k+C,v);T<v;T=U,U=Math.min(U+C,v)){if(T>k&&await new Promise(_=>setTimeout(_)),r&&r.isCancellationRequested)throw new A.$5;w(q,d,P,T,U)}return P})().then(i,o)})}e.$Gb=u;function w(q,d,k,C,r){for(const i=k.length;C<r;C++){const o=q[C];if(d(o,k[i-1])<0){k.pop();const v=(0,N.$kb)(k,P=>d(o,P)<0);k.splice(v,0,o)}}}function h(q){return q.filter(d=>!!d)}e.$Hb=h;function m(q){let d=0;for(let k=0;k<q.length;k++)q[k]&&(q[d]=q[k],d+=1);q.length=d}e.$Ib=m;function a(q,d,k){q.splice(k,0,q.splice(d,1)[0])}e.$Jb=a;function y(q){return!Array.isArray(q)||q.length===0}e.$Kb=y;function L(q){return Array.isArray(q)&&q.length>0}e.$Lb=L;function R(q,d=k=>k){const k=new Set;return q.filter(C=>{const r=d(C);return k.has(r)?!1:(k.add(r),!0)})}e.$Mb=R;function z(q){const d=new Set;return k=>{const C=q(k);return d.has(C)?!1:(d.add(C),!0)}}e.$Nb=z;function H(q,d){return q.length>0?q[0]:d}e.$Ob=H;function E(q,d){return q.length>0?q[q.length-1]:d}e.$Pb=E;function B(q,d,k=(C,r)=>C===r){let C=0;for(let r=0,i=Math.min(q.length,d.length);r<i&&k(q[r],d[r]);r++)C++;return C}e.$Qb=B;function j(q){return[].concat(...q)}e.$Rb=j;function F(q,d){let k=typeof d=="number"?q:0;typeof d=="number"?k=q:(k=0,d=q);const C=[];if(k<=d)for(let r=k;r<d;r++)C.push(r);else for(let r=k;r>d;r--)C.push(r);return C}e.$Sb=F;function M(q,d,k){return q.reduce((C,r)=>(C[d(r)]=k?k(r):r,C),Object.create(null))}e.$Tb=M;function I(q,d){return q.push(d),()=>x(q,d)}e.$Ub=I;function x(q,d){const k=q.indexOf(d);if(k>-1)return q.splice(k,1),d}e.$Vb=x;function X(q,d,k){const C=q.slice(0,d),r=q.slice(d);return C.concat(k,r)}e.$Wb=X;function de(q,d){let k;if(typeof d=="number"){let C=d;k=()=>{const r=Math.sin(C++)*179426549;return r-Math.floor(r)}}else k=Math.random;for(let C=q.length-1;C>0;C-=1){const r=Math.floor(k()*(C+1)),i=q[C];q[C]=q[r],q[r]=i}}e.$Xb=de;function ue(q,d){const k=q.indexOf(d);k>-1&&(q.splice(k,1),q.unshift(d))}e.$Yb=ue;function te(q,d){const k=q.indexOf(d);k>-1&&(q.splice(k,1),q.push(d))}e.$Zb=te;function ge(q,d){for(const k of d)q.push(k)}e.$1b=ge;function Le(q,d){return Array.isArray(q)?q.map(d):d(q)}e.$2b=Le;function Te(q){return Array.isArray(q)?q:[q]}e.$3b=Te;function Be(q){return q[Math.floor(Math.random()*q.length)]}e.$4b=Be;function le(q,d,k){const C=ae(q,d),r=q.length,i=k.length;q.length=r+i;for(let o=r-1;o>=C;o--)q[o+i]=q[o];for(let o=0;o<i;o++)q[o+C]=k[o]}e.$5b=le;function J(q,d,k,C){const r=ae(q,d);let i=q.splice(r,k);return i===void 0&&(i=[]),le(q,r,C),i}e.$6b=J;function ae(q,d){return d<0?Math.max(d+q.length,0):Math.min(d,q.length)}var re;(function(q){function d(i){return i<0}q.isLessThan=d;function k(i){return i<=0}q.isLessThanOrEqual=k;function C(i){return i>0}q.isGreaterThan=C;function r(i){return i===0}q.isNeitherLessOrGreaterThan=r,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function Y(q,d){return(k,C)=>d(q(k),q(C))}e.$7b=Y;function Q(...q){return(d,k)=>{for(const C of q){const r=C(d,k);if(!re.isNeitherLessOrGreaterThan(r))return r}return re.neitherLessOrGreaterThan}}e.$8b=Q;const ie=(q,d)=>q-d;e.$9b=ie;const fe=(q,d)=>(0,e.$9b)(q?1:0,d?1:0);e.$0b=fe;function ye(q){return(d,k)=>-q(d,k)}e.$$b=ye;class Ce{constructor(d){this.g=d,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(d){let k=this.c;for(;k<this.g.length&&d(this.g[k]);)k++;const C=k===this.c?null:this.g.slice(this.c,k);return this.c=k,C}takeFromEndWhile(d){let k=this.d;for(;k>=0&&d(this.g[k]);)k--;const C=k===this.d?null:this.g.slice(k+1,this.d+1);return this.d=k,C}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const d=this.g[this.c];return this.c++,d}removeLast(){const d=this.g[this.d];return this.d--,d}takeCount(d){const k=this.g.slice(this.c,this.c+d);return this.c+=d,k}}e.$_b=Ce;class ke{static{this.empty=new ke(d=>{})}constructor(d){this.iterate=d}forEach(d){this.iterate(k=>(d(k),!0))}toArray(){const d=[];return this.iterate(k=>(d.push(k),!0)),d}filter(d){return new ke(k=>this.iterate(C=>d(C)?k(C):!0))}map(d){return new ke(k=>this.iterate(C=>k(d(C))))}some(d){let k=!1;return this.iterate(C=>(k=d(C),!k)),k}findFirst(d){let k;return this.iterate(C=>d(C)?(k=C,!1):!0),k}findLast(d){let k;return this.iterate(C=>(d(C)&&(k=C),!0)),k}findLastMaxBy(d){let k,C=!0;return this.iterate(r=>((C||re.isGreaterThan(d(r,k)))&&(C=!1,k=r),!0)),k}}e.$ac=ke}),define(me[78],$e([1,0,6]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function N($,p){if(!$)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}e.ok=N;function n($,p="Unreachable"){throw new Error(p)}e.$9c=n;function W($){if(!$)throw new A.$cb("Assertion Failed")}e.$0c=W;function D($){$||(0,A.$1)(new A.$cb("Assertion Failed"))}e.$$c=D;function S($){if(!$()){debugger;$(),(0,A.$1)(new A.$cb("Assertion Failed"))}}e.$_c=S;function b($,p){let O=0;for(;O<$.length-1;){const l=$[O],f=$[O+1];if(!p(l,f))return!1;O++}return!0}e.$ad=b}),define(me[46],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function A(N,n){const W=this;let D=!1,S;return function(){if(D)return S;if(D=!0,n)try{S=N.apply(W,arguments)}finally{n()}else S=N.apply(W,arguments);return S}}e.$db=A}),define(me[79],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=e.$iO=void 0;class A{constructor(n){this.a=n,this.b=0}nextId(){return this.a+ ++this.b}}e.$iO=A,e.$jO=new A("id#")}),define(me[28],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var A;(function(N){function n(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}N.is=n;const W=Object.freeze([]);function D(){return W}N.empty=D;function*S(a){yield a}N.single=S;function b(a){return n(a)?a:S(a)}N.wrap=b;function $(a){return a||W}N.from=$;function*p(a){for(let y=a.length-1;y>=0;y--)yield a[y]}N.reverse=p;function O(a){return!a||a[Symbol.iterator]().next().done===!0}N.isEmpty=O;function l(a){return a[Symbol.iterator]().next().value}N.first=l;function f(a,y){for(const L of a)if(y(L))return!0;return!1}N.some=f;function t(a,y){for(const L of a)if(y(L))return L}N.find=t;function*s(a,y){for(const L of a)y(L)&&(yield L)}N.filter=s;function*c(a,y){let L=0;for(const R of a)yield y(R,L++)}N.map=c;function*g(...a){for(const y of a)yield*y}N.concat=g;function u(a,y,L){let R=L;for(const z of a)R=y(R,z);return R}N.reduce=u;function*w(a,y,L=a.length){for(y<0&&(y+=a.length),L<0?L+=a.length:L>a.length&&(L=a.length);y<L;y++)yield a[y]}N.slice=w;function h(a,y=Number.POSITIVE_INFINITY){const L=[];if(y===0)return[L,a];const R=a[Symbol.iterator]();for(let z=0;z<y;z++){const H=R.next();if(H.done)return[L,N.empty()];L.push(H.value)}return[L,{[Symbol.iterator](){return R}}]}N.consume=h;async function m(a){const y=[];for await(const L of a)y.push(L);return Promise.resolve(y)}N.asyncToArray=m})(A||(e.Iterable=A={}))}),define(me[47],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.KeyMod=e.KeyCodeUtils=e.$er=e.$dr=e.$cr=e.$br=e.$ar=e.ScanCode=e.KeyCode=void 0;var A;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(A||(e.KeyCode=A={}));var N;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(N||(e.ScanCode=N={}));class n{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,c){this._keyCodeToStr[s]=c,this._strToKeyCode[c.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const W=new n,D=new n,S=new n;e.$ar=new Array(230),e.$br={};const b=[],$=Object.create(null),p=Object.create(null);e.$cr={lowerCaseToEnum:t=>p[t]||0,toEnum:t=>$[t]||0,toString:t=>b[t]||"None"},e.$dr=[],e.$er=[];for(let t=0;t<=193;t++)e.$dr[t]=-1;for(let t=0;t<=132;t++)e.$er[t]=-1;(function(){const t="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[1,1,"Hyper",0,t,0,t,t,t],[1,2,"Super",0,t,0,t,t,t],[1,3,"Fn",0,t,0,t,t,t],[1,4,"FnLock",0,t,0,t,t,t],[1,5,"Suspend",0,t,0,t,t,t],[1,6,"Resume",0,t,0,t,t,t],[1,7,"Turbo",0,t,0,t,t,t],[1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[1,9,"WakeUp",0,t,0,t,t,t],[0,10,"KeyA",31,"A",65,"VK_A",t,t],[0,11,"KeyB",32,"B",66,"VK_B",t,t],[0,12,"KeyC",33,"C",67,"VK_C",t,t],[0,13,"KeyD",34,"D",68,"VK_D",t,t],[0,14,"KeyE",35,"E",69,"VK_E",t,t],[0,15,"KeyF",36,"F",70,"VK_F",t,t],[0,16,"KeyG",37,"G",71,"VK_G",t,t],[0,17,"KeyH",38,"H",72,"VK_H",t,t],[0,18,"KeyI",39,"I",73,"VK_I",t,t],[0,19,"KeyJ",40,"J",74,"VK_J",t,t],[0,20,"KeyK",41,"K",75,"VK_K",t,t],[0,21,"KeyL",42,"L",76,"VK_L",t,t],[0,22,"KeyM",43,"M",77,"VK_M",t,t],[0,23,"KeyN",44,"N",78,"VK_N",t,t],[0,24,"KeyO",45,"O",79,"VK_O",t,t],[0,25,"KeyP",46,"P",80,"VK_P",t,t],[0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[0,27,"KeyR",48,"R",82,"VK_R",t,t],[0,28,"KeyS",49,"S",83,"VK_S",t,t],[0,29,"KeyT",50,"T",84,"VK_T",t,t],[0,30,"KeyU",51,"U",85,"VK_U",t,t],[0,31,"KeyV",52,"V",86,"VK_V",t,t],[0,32,"KeyW",53,"W",87,"VK_W",t,t],[0,33,"KeyX",54,"X",88,"VK_X",t,t],[0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[0,36,"Digit1",22,"1",49,"VK_1",t,t],[0,37,"Digit2",23,"2",50,"VK_2",t,t],[0,38,"Digit3",24,"3",51,"VK_3",t,t],[0,39,"Digit4",25,"4",52,"VK_4",t,t],[0,40,"Digit5",26,"5",53,"VK_5",t,t],[0,41,"Digit6",27,"6",54,"VK_6",t,t],[0,42,"Digit7",28,"7",55,"VK_7",t,t],[0,43,"Digit8",29,"8",56,"VK_8",t,t],[0,44,"Digit9",30,"9",57,"VK_9",t,t],[0,45,"Digit0",21,"0",48,"VK_0",t,t],[1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,t,0,t,t,t],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[1,64,"F1",59,"F1",112,"VK_F1",t,t],[1,65,"F2",60,"F2",113,"VK_F2",t,t],[1,66,"F3",61,"F3",114,"VK_F3",t,t],[1,67,"F4",62,"F4",115,"VK_F4",t,t],[1,68,"F5",63,"F5",116,"VK_F5",t,t],[1,69,"F6",64,"F6",117,"VK_F6",t,t],[1,70,"F7",65,"F7",118,"VK_F7",t,t],[1,71,"F8",66,"F8",119,"VK_F8",t,t],[1,72,"F9",67,"F9",120,"VK_F9",t,t],[1,73,"F10",68,"F10",121,"VK_F10",t,t],[1,74,"F11",69,"F11",122,"VK_F11",t,t],[1,75,"F12",70,"F12",123,"VK_F12",t,t],[1,76,"PrintScreen",0,t,0,t,t,t],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",t,t],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[1,80,"Home",14,"Home",36,"VK_HOME",t,t],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[1,83,"End",13,"End",35,"VK_END",t,t],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",t,t],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",t,t],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",t,t],[1,94,"NumpadEnter",3,t,0,t,t,t],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",t,t],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",t,t],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",t,t],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",t,t],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",t,t],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",t,t],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",t,t],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",t,t],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",t,t],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",t,t],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",t,t],[1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[1,108,"Power",0,t,0,t,t,t],[1,109,"NumpadEqual",0,t,0,t,t,t],[1,110,"F13",71,"F13",124,"VK_F13",t,t],[1,111,"F14",72,"F14",125,"VK_F14",t,t],[1,112,"F15",73,"F15",126,"VK_F15",t,t],[1,113,"F16",74,"F16",127,"VK_F16",t,t],[1,114,"F17",75,"F17",128,"VK_F17",t,t],[1,115,"F18",76,"F18",129,"VK_F18",t,t],[1,116,"F19",77,"F19",130,"VK_F19",t,t],[1,117,"F20",78,"F20",131,"VK_F20",t,t],[1,118,"F21",79,"F21",132,"VK_F21",t,t],[1,119,"F22",80,"F22",133,"VK_F22",t,t],[1,120,"F23",81,"F23",134,"VK_F23",t,t],[1,121,"F24",82,"F24",135,"VK_F24",t,t],[1,122,"Open",0,t,0,t,t,t],[1,123,"Help",0,t,0,t,t,t],[1,124,"Select",0,t,0,t,t,t],[1,125,"Again",0,t,0,t,t,t],[1,126,"Undo",0,t,0,t,t,t],[1,127,"Cut",0,t,0,t,t,t],[1,128,"Copy",0,t,0,t,t,t],[1,129,"Paste",0,t,0,t,t,t],[1,130,"Find",0,t,0,t,t,t],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",t,t],[1,136,"KanaMode",0,t,0,t,t,t],[0,137,"IntlYen",0,t,0,t,t,t],[1,138,"Convert",0,t,0,t,t,t],[1,139,"NonConvert",0,t,0,t,t,t],[1,140,"Lang1",0,t,0,t,t,t],[1,141,"Lang2",0,t,0,t,t,t],[1,142,"Lang3",0,t,0,t,t,t],[1,143,"Lang4",0,t,0,t,t,t],[1,144,"Lang5",0,t,0,t,t,t],[1,145,"Abort",0,t,0,t,t,t],[1,146,"Props",0,t,0,t,t,t],[1,147,"NumpadParenLeft",0,t,0,t,t,t],[1,148,"NumpadParenRight",0,t,0,t,t,t],[1,149,"NumpadBackspace",0,t,0,t,t,t],[1,150,"NumpadMemoryStore",0,t,0,t,t,t],[1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[1,152,"NumpadMemoryClear",0,t,0,t,t,t],[1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",t,t],[1,156,"NumpadClearEntry",0,t,0,t,t,t],[1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[1,0,t,6,"Alt",18,"VK_MENU",t,t],[1,0,t,57,"Meta",91,"VK_COMMAND",t,t],[1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[1,165,"BrightnessUp",0,t,0,t,t,t],[1,166,"BrightnessDown",0,t,0,t,t,t],[1,167,"MediaPlay",0,t,0,t,t,t],[1,168,"MediaRecord",0,t,0,t,t,t],[1,169,"MediaFastForward",0,t,0,t,t,t],[1,170,"MediaRewind",0,t,0,t,t,t],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",t,t],[1,174,"Eject",0,t,0,t,t,t],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[1,180,"SelectTask",0,t,0,t,t,t],[1,181,"LaunchScreenSaver",0,t,0,t,t,t],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[1,189,"ZoomToggle",0,t,0,t,t,t],[1,190,"MailReply",0,t,0,t,t,t],[1,191,"MailForward",0,t,0,t,t,t],[1,192,"MailSend",0,t,0,t,t,t],[1,0,t,114,"KeyInComposition",229,t,t,t],[1,0,t,116,"ABNT_C2",194,"VK_ABNT_C2",t,t],[1,0,t,96,"OEM_8",223,"VK_OEM_8",t,t],[1,0,t,0,t,0,"VK_KANA",t,t],[1,0,t,0,t,0,"VK_HANGUL",t,t],[1,0,t,0,t,0,"VK_JUNJA",t,t],[1,0,t,0,t,0,"VK_FINAL",t,t],[1,0,t,0,t,0,"VK_HANJA",t,t],[1,0,t,0,t,0,"VK_KANJI",t,t],[1,0,t,0,t,0,"VK_CONVERT",t,t],[1,0,t,0,t,0,"VK_NONCONVERT",t,t],[1,0,t,0,t,0,"VK_ACCEPT",t,t],[1,0,t,0,t,0,"VK_MODECHANGE",t,t],[1,0,t,0,t,0,"VK_SELECT",t,t],[1,0,t,0,t,0,"VK_PRINT",t,t],[1,0,t,0,t,0,"VK_EXECUTE",t,t],[1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[1,0,t,0,t,0,"VK_HELP",t,t],[1,0,t,0,t,0,"VK_APPS",t,t],[1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[1,0,t,0,t,0,"VK_PACKET",t,t],[1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[1,0,t,0,t,0,"VK_ATTN",t,t],[1,0,t,0,t,0,"VK_CRSEL",t,t],[1,0,t,0,t,0,"VK_EXSEL",t,t],[1,0,t,0,t,0,"VK_EREOF",t,t],[1,0,t,0,t,0,"VK_PLAY",t,t],[1,0,t,0,t,0,"VK_ZOOM",t,t],[1,0,t,0,t,0,"VK_NONAME",t,t],[1,0,t,0,t,0,"VK_PA1",t,t],[1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]],c=[],g=[];for(const u of s){const[w,h,m,a,y,L,R,z,H]=u;if(g[h]||(g[h]=!0,b[h]=m,$[m]=h,p[m.toLowerCase()]=h,w&&(e.$dr[h]=a,a!==0&&a!==3&&a!==5&&a!==4&&a!==6&&a!==57&&(e.$er[a]=h))),!c[a]){if(c[a]=!0,!y)throw new Error(`String representation missing for key code ${a} around scan code ${m}`);W.define(a,y),D.define(a,z||y),S.define(a,H||z||y)}L&&(e.$ar[L]=a),R&&(e.$br[R]=a)}e.$er[3]=46})();var O;(function(t){function s(m){return W.keyCodeToStr(m)}t.toString=s;function c(m){return W.strToKeyCode(m)}t.fromString=c;function g(m){return D.keyCodeToStr(m)}t.toUserSettingsUS=g;function u(m){return S.keyCodeToStr(m)}t.toUserSettingsGeneral=u;function w(m){return D.strToKeyCode(m)||S.strToKeyCode(m)}t.fromUserSettings=w;function h(m){if(m>=98&&m<=113)return null;switch(m){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(m)}t.toElectronAccelerator=h})(O||(e.KeyCodeUtils=O={}));var l;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(l||(e.KeyMod=l={}));function f(t,s){const c=(s&65535)<<16>>>0;return(t|c)>>>0}e.$fr=f}),define(me[80],$e([1,0,6]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=e.$kr=e.$jr=e.$ir=e.$hr=e.$gr=void 0;var N;(function(O){O[O.CtrlCmd=2048]="CtrlCmd",O[O.Shift=1024]="Shift",O[O.Alt=512]="Alt",O[O.WinCtrl=256]="WinCtrl",O[O.KeyCode=255]="KeyCode"})(N||(N={}));function n(O,l){if(typeof O=="number"){if(O===0)return null;const f=(O&65535)>>>0,t=(O&4294901760)>>>16;return t!==0?new b([W(f,l),W(t,l)]):new b([W(f,l)])}else{const f=[];for(let t=0;t<O.length;t++)f.push(W(O[t],l));return new b(f)}}e.$gr=n;function W(O,l){const f=!!(O&2048),t=!!(O&256),s=l===2?t:f,c=!!(O&1024),g=!!(O&512),u=l===2?f:t,w=O&255;return new D(s,c,g,u,w)}e.$hr=W;class D{constructor(l,f,t,s,c){this.ctrlKey=l,this.shiftKey=f,this.altKey=t,this.metaKey=s,this.keyCode=c}equals(l){return l instanceof D&&this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.keyCode===l.keyCode}getHashCode(){const l=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",t=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${l}${f}${t}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.$ir=D;class S{constructor(l,f,t,s,c){this.ctrlKey=l,this.shiftKey=f,this.altKey=t,this.metaKey=s,this.scanCode=c}equals(l){return l instanceof S&&this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.scanCode===l.scanCode}getHashCode(){const l=this.ctrlKey?"1":"0",f=this.shiftKey?"1":"0",t=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${l}${f}${t}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.$jr=S;class b{constructor(l){if(l.length===0)throw(0,A.$7)("chords");this.chords=l}getHashCode(){let l="";for(let f=0,t=this.chords.length;f<t;f++)f!==0&&(l+=";"),l+=this.chords[f].getHashCode();return l}equals(l){if(l===null||this.chords.length!==l.chords.length)return!1;for(let f=0;f<this.chords.length;f++)if(!this.chords[f].equals(l.chords[f]))return!1;return!0}}e.$kr=b;class ${constructor(l,f,t,s,c,g){this.ctrlKey=l,this.shiftKey=f,this.altKey=t,this.metaKey=s,this.keyLabel=c,this.keyAriaLabel=g}}e.$lr=$;class p{}e.$mr=p}),define(me[22],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class A{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=A}),define(me[29],$e([1,0,22]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BS=e.$AS=void 0;let n=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const W=new A.$V(()=>n("mouse",!1)),D=new A.$V(()=>n("element",!1));function S($){n=$}e.$AS=S;function b($,p){return p?n($,!0):$==="element"?D.value:W.value}e.$BS=b}),define(me[48],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class A{static{this.Undefined=new A(void 0)}constructor(W){this.element=W,this.next=A.Undefined,this.prev=A.Undefined}}class N{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let W=this.a;for(;W!==A.Undefined;){const D=W.next;W.prev=A.Undefined,W.next=A.Undefined,W=D}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(W){return this.d(W,!1)}push(W){return this.d(W,!0)}d(W,D){const S=new A(W);if(this.a===A.Undefined)this.a=S,this.b=S;else if(D){const $=this.b;this.b=S,S.prev=$,$.next=S}else{const $=this.a;this.a=S,S.next=$,$.prev=S}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(S))}}shift(){if(this.a!==A.Undefined){const W=this.a.element;return this.e(this.a),W}}pop(){if(this.b!==A.Undefined){const W=this.b.element;return this.e(this.b),W}}e(W){if(W.prev!==A.Undefined&&W.next!==A.Undefined){const D=W.prev;D.next=W.next,W.next.prev=D}else W.prev===A.Undefined&&W.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):W.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):W.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let W=this.a;for(;W!==A.Undefined;)yield W.element,W=W.next}}e.$4c=N}),define(me[33],$e([1,0]),function(se,e){"use strict";var A,N,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function W(w,h,m){let a=w.get(h);return a===void 0&&(a=m,w.set(h,a)),a}e.$xc=W;function D(w){const h=[];return w.forEach((m,a)=>{h.push(`${a} => ${m}`)}),`Map(${w.size}) {${h.join(", ")}}`}e.$yc=D;function S(w){const h=[];return w.forEach(m=>{h.push(m)}),`Set(${w.size}) {${h.join(", ")}}`}e.$zc=S;class b{constructor(h,m){this.uri=h,this.value=m}}function $(w){return Array.isArray(w)}class p{static{this.c=h=>h.toString()}constructor(h,m){if(this[A]="ResourceMap",h instanceof p)this.d=new Map(h.d),this.e=m??p.c;else if($(h)){this.d=new Map,this.e=m??p.c;for(const[a,y]of h)this.set(a,y)}else this.d=new Map,this.e=h??p.c}set(h,m){return this.d.set(this.e(h),new b(h,m)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,m){typeof m<"u"&&(h=h.bind(m));for(const[a,y]of this.d)h(y.value,y.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$Ac=p;class O{constructor(h,m){this[N]="ResourceSet",!h||typeof h=="function"?this.c=new p(h):(this.c=new p(m),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,m){this.c.forEach((a,y)=>h.call(m,y,y,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=O;var l;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(l||(e.Touch=l={}));class f{constructor(){this[n]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,m=0){const a=this.c.get(h);if(a)return m!==0&&this.l(a,m),a.value}set(h,m,a=0){let y=this.c.get(h);if(y)y.value=m,a!==0&&this.l(y,a);else{switch(y={key:h,value:m,next:void 0,previous:void 0},a){case 0:this.j(y);break;case 1:this.i(y);break;case 2:this.j(y);break;default:this.j(y);break}this.c.set(h,y),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const m=this.c.get(h);if(m)return this.c.delete(h),this.k(m),this.f--,m.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.k(h),this.f--,h.value}forEach(h,m){const a=this.g;let y=this.d;for(;y;){if(m?h.bind(m)(y.value,y.key,this):h(y.value,y.key,this),this.g!==a)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const h=this,m=this.g;let a=this.d;const y={[Symbol.iterator](){return y},next(){if(h.g!==m)throw new Error("LinkedMap got modified during iteration.");if(a){const L={value:a.key,done:!1};return a=a.next,L}else return{value:void 0,done:!0}}};return y}values(){const h=this,m=this.g;let a=this.d;const y={[Symbol.iterator](){return y},next(){if(h.g!==m)throw new Error("LinkedMap got modified during iteration.");if(a){const L={value:a.value,done:!1};return a=a.next,L}else return{value:void 0,done:!0}}};return y}entries(){const h=this,m=this.g;let a=this.d;const y={[Symbol.iterator](){return y},next(){if(h.g!==m)throw new Error("LinkedMap got modified during iteration.");if(a){const L={value:[a.key,a.value],done:!1};return a=a.next,L}else return{value:void 0,done:!0}}};return y}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let m=this.d,a=this.size;for(;m&&a>h;)this.c.delete(m.key),m=m.next,a--;this.d=m,this.f=a,m&&(m.previous=void 0),this.g++}i(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}j(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}k(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const m=h.next,a=h.previous;if(!m||!a)throw new Error("Invalid list");m.previous=a,a.next=m}h.next=void 0,h.previous=void 0,this.g++}l(h,m){if(!this.d||!this.e)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(h===this.d)return;const a=h.next,y=h.previous;h===this.e?(y.next=void 0,this.e=y):(a.previous=y,y.next=a),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(m===2){if(h===this.e)return;const a=h.next,y=h.previous;h===this.d?(a.previous=void 0,this.d=a):(a.previous=y,y.next=a),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((m,a)=>{h.push([a,m])}),h}fromJSON(h){this.clear();for(const[m,a]of h)this.set(m,a)}}e.$Cc=f;class t extends f{constructor(h,m=1){super(),this.m=h,this.n=Math.min(Math.max(0,m),1)}get limit(){return this.m}set limit(h){this.m=h,this.o()}get ratio(){return this.n}set ratio(h){this.n=Math.min(Math.max(0,h),1),this.o()}get(h,m=2){return super.get(h,m)}peek(h){return super.get(h,0)}set(h,m){return super.set(h,m,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=t;class s{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let m=this.c.get(h)||0;return m===0?!1:(m--,m===0?this.c.delete(h):this.c.set(h,m),!0)}has(h){return this.c.has(h)}}e.$Ec=s;class c{constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[m,a]of h)this.set(m,a)}clear(){this.c.clear(),this.d.clear()}set(h,m){this.c.set(h,m),this.d.set(m,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const m=this.c.get(h);return m===void 0?!1:(this.c.delete(h),this.d.delete(m),!0)}forEach(h,m){this.c.forEach((a,y)=>{h.call(m,a,y,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=c;class g{constructor(){this.c=new Map}add(h,m){let a=this.c.get(h);a||(a=new Set,this.c.set(h,a)),a.add(m)}delete(h,m){const a=this.c.get(h);a&&(a.delete(m),a.size===0&&this.c.delete(h))}forEach(h,m){const a=this.c.get(h);a&&a.forEach(m)}get(h){const m=this.c.get(h);return m||new Set}}e.$Gc=g;function u(w,h){if(w===h)return!0;if(w.size!==h.size)return!1;for(const[m,a]of w)if(!h.has(m)||h.get(m)!==a)return!1;for(const[m]of h)if(!w.has(m))return!1;return!0}e.$Hc=u}),define(me[3],$e([1,0,12,75,33,46,28]),function(se,e,A,N,n,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const S=!1;let b=null;class ${constructor(){this.b=new Map}static{this.a=0}c(I){let x=this.b.get(I);return x||(x={parent:null,source:null,isSingleton:!1,value:I,idx:$.a++},this.b.set(I,x)),x}trackDisposable(I){const x=this.c(I);x.source||(x.source=new Error().stack)}setParent(I,x){const X=this.c(I);X.parent=x}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,x){const X=x.get(I);if(X)return X;const de=I.parent?this.f(this.c(I.parent),x):I;return x.set(I,de),de}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,X])=>X.source!==null&&!this.f(X,I).isSingleton).flatMap(([X])=>X)}computeLeakingDisposables(I=10,x){let X;if(x)X=x;else{const Le=new Map,Te=[...this.b.values()].filter(le=>le.source!==null&&!this.f(le,Le).isSingleton);if(Te.length===0)return;const Be=new Set(Te.map(le=>le.value));if(X=Te.filter(le=>!(le.parent&&Be.has(le.parent))),X.length===0)throw new Error("There are cyclic diposable chains!")}if(!X)return;function de(Le){function Te(le,J){for(;le.length>0&&J.some(ae=>typeof ae=="string"?ae===le[0]:le[0].match(ae));)le.shift()}const Be=Le.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Te(Be,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Be.reverse()}const ue=new n.$Gc;for(const Le of X){const Te=de(Le);for(let Be=0;Be<=Te.length;Be++)ue.add(Te.slice(0,Be).join(`
`),Le)}X.sort((0,A.$7b)(Le=>Le.idx,A.$9b));let te="",ge=0;for(const Le of X.slice(0,I)){ge++;const Te=de(Le),Be=[];for(let le=0;le<Te.length;le++){let J=Te[le];J=`(shared with ${ue.get(Te.slice(0,le+1).join(`
`)).size}/${X.length} leaks) at ${J}`;const re=ue.get(Te.slice(0,le).join(`
`)),Y=(0,N.$K)([...re].map(Q=>de(Q)[le]),Q=>Q);delete Y[Te[le]];for(const[Q,ie]of Object.entries(Y))Be.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${Q}`);Be.unshift(J)}te+=`


==================== Leaking disposable ${ge}/${X.length}: ${Le.value.constructor.name} ====================
${Be.join(`
`)}
============================================================

`}return X.length>I&&(te+=`


... and ${X.length-I} more leaking disposables

`),{leaks:X,details:te}}}e.$Ic=$;function p(M){b=M}if(e.$Jc=p,S){const M="__is_disposable_tracked__";p(new class{trackDisposable(I){const x=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[M]||console.log(x)},3e3)}setParent(I,x){if(I&&I!==a.None)try{I[M]=!0}catch{}}markAsDisposed(I){if(I&&I!==a.None)try{I[M]=!0}catch{}}markAsSingleton(I){}})}function O(M){return b?.trackDisposable(M),M}e.$Kc=O;function l(M){b?.markAsDisposed(M)}e.$Lc=l;function f(M,I){b?.setParent(M,I)}function t(M,I){if(b)for(const x of M)b.setParent(x,I)}function s(M){return b?.markAsSingleton(M),M}e.$Mc=s;function c(M){return typeof M.dispose=="function"&&M.dispose.length===0}e.$Nc=c;function g(M){if(D.Iterable.is(M)){const I=[];for(const x of M)if(x)try{x.dispose()}catch(X){I.push(X)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(M)?[]:M}else if(M)return M.dispose(),M}e.$Oc=g;function u(M){for(const I of M)c(I)&&I.dispose();return[]}e.$Pc=u;function w(...M){const I=h(()=>g(M));return t(M,I),I}e.$Qc=w;function h(M){const I=O({dispose:(0,W.$db)(()=>{l(I),M()})});return I}e.$Rc=h;class m{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,O(this)}dispose(){this.g||(l(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return f(I,this),this.g?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),f(I,null))}}e.$Sc=m;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new m,O(this),f(this.q,this)}dispose(){l(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Tc=a;class y{constructor(){this.b=!1,O(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&f(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,l(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&f(I,null),I}}e.$Uc=y;class L{constructor(I){this.a=new y,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=L;class R{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=R;class z{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,O(this)}set(I){let x=I;return this.unset=()=>x=void 0,this.isset=()=>x!==void 0,this.dispose=()=>{x&&(x(),x=void 0,l(this))},this}}e.$Xc=z;class H{constructor(){this.a=new Map}acquire(I,...x){let X=this.a.get(I);X||(X={counter:0,object:this.b(I,...x)},this.a.set(I,X));const{object:de}=X,ue=(0,W.$db)(()=>{--X.counter===0&&(this.c(I,X.object),this.a.delete(I))});return X.counter++,{object:de,dispose:ue}}}e.$Yc=H;class E{constructor(I){this.a=I}async acquire(I,...x){const X=this.a.acquire(I,...x);try{return{object:await X.object,dispose:()=>X.dispose()}}catch(de){throw X.dispose(),de}}}e.$Zc=E;class B{constructor(I){this.object=I}dispose(){}}e.$1c=B;function j(M){const I=new m;try{M(I)}finally{I.dispose()}}e.$2c=j;class F{constructor(){this.a=new Map,this.b=!1,O(this)}dispose(){l(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,x,X=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),X||this.a.get(I)?.dispose(),this.a.set(I,x)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=F}),function(se,e){typeof define=="function"&&define.amd?define(me[81],$e([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(se=typeof globalThis<"u"?globalThis:se||self,e(se.marked={}))}(this,function(se){"use strict";function e(d,k){for(var C=0;C<k.length;C++){var r=k[C];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(d,r.key,r)}}function A(d,k,C){return k&&e(d.prototype,k),C&&e(d,C),Object.defineProperty(d,"prototype",{writable:!1}),d}function N(d,k){if(d){if(typeof d=="string")return n(d,k);var C=Object.prototype.toString.call(d).slice(8,-1);if(C==="Object"&&d.constructor&&(C=d.constructor.name),C==="Map"||C==="Set")return Array.from(d);if(C==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(C))return n(d,k)}}function n(d,k){(k==null||k>d.length)&&(k=d.length);for(var C=0,r=new Array(k);C<k;C++)r[C]=d[C];return r}function W(d,k){var C=typeof Symbol<"u"&&d[Symbol.iterator]||d["@@iterator"];if(C)return(C=C.call(d)).next.bind(C);if(Array.isArray(d)||(C=N(d))||k&&d&&typeof d.length=="number"){C&&(d=C);var r=0;return function(){return r>=d.length?{done:!0}:{done:!1,value:d[r++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=D();function S(d){se.defaults=d}var b=/[&<>"']/,$=/[&<>"']/g,p=/[<>"']|&(?!#?\w+;)/,O=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(k){return l[k]};function t(d,k){if(k){if(b.test(d))return d.replace($,f)}else if(p.test(d))return d.replace(O,f);return d}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(d){return d.replace(s,function(k,C){return C=C.toLowerCase(),C==="colon"?":":C.charAt(0)==="#"?C.charAt(1)==="x"?String.fromCharCode(parseInt(C.substring(2),16)):String.fromCharCode(+C.substring(1)):""})}var g=/(^|[^\[])\^/g;function u(d,k){d=typeof d=="string"?d:d.source,k=k||"";var C={replace:function(i,o){return o=o.source||o,o=o.replace(g,"$1"),d=d.replace(i,o),C},getRegex:function(){return new RegExp(d,k)}};return C}var w=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(d,k,C){if(d){var r;try{r=decodeURIComponent(c(C)).replace(w,"").toLowerCase()}catch{return null}if(r.indexOf("javascript:")===0||r.indexOf("vbscript:")===0||r.indexOf("data:")===0)return null}k&&!h.test(C)&&(C=z(k,C));try{C=encodeURI(C).replace(/%25/g,"%")}catch{return null}return C}var a={},y=/^[^:]+:\/*[^/]*$/,L=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function z(d,k){a[" "+d]||(y.test(d)?a[" "+d]=d+"/":a[" "+d]=j(d,"/",!0)),d=a[" "+d];var C=d.indexOf(":")===-1;return k.substring(0,2)==="//"?C?k:d.replace(L,"$1")+k:k.charAt(0)==="/"?C?k:d.replace(R,"$1")+k:d+k}var H={exec:function(){}};function E(d){for(var k=1,C,r;k<arguments.length;k++){C=arguments[k];for(r in C)Object.prototype.hasOwnProperty.call(C,r)&&(d[r]=C[r])}return d}function B(d,k){var C=d.replace(/\|/g,function(o,v,P){for(var T=!1,U=v;--U>=0&&P[U]==="\\";)T=!T;return T?"|":" |"}),r=C.split(/ \|/),i=0;if(r[0].trim()||r.shift(),r.length>0&&!r[r.length-1].trim()&&r.pop(),r.length>k)r.splice(k);else for(;r.length<k;)r.push("");for(;i<r.length;i++)r[i]=r[i].trim().replace(/\\\|/g,"|");return r}function j(d,k,C){var r=d.length;if(r===0)return"";for(var i=0;i<r;){var o=d.charAt(r-i-1);if(o===k&&!C)i++;else if(o!==k&&C)i++;else break}return d.slice(0,r-i)}function F(d,k){if(d.indexOf(k[1])===-1)return-1;for(var C=d.length,r=0,i=0;i<C;i++)if(d[i]==="\\")i++;else if(d[i]===k[0])r++;else if(d[i]===k[1]&&(r--,r<0))return i;return-1}function M(d){d&&d.sanitize&&!d.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(d,k){if(k<1)return"";for(var C="";k>1;)k&1&&(C+=d),k>>=1,d+=d;return C+d}function x(d,k,C,r){var i=k.href,o=k.title?t(k.title):null,v=d[1].replace(/\\([\[\]])/g,"$1");if(d[0].charAt(0)!=="!"){r.state.inLink=!0;var P={type:"link",raw:C,href:i,title:o,text:v,tokens:r.inlineTokens(v)};return r.state.inLink=!1,P}return{type:"image",raw:C,href:i,title:o,text:t(v)}}function X(d,k){var C=d.match(/^(\s+)(?:```)/);if(C===null)return k;var r=C[1];return k.split(`
`).map(function(i){var o=i.match(/^\s+/);if(o===null)return i;var v=o[0];return v.length>=r.length?i.slice(r.length):i}).join(`
`)}var de=function(){function d(C){this.options=C||se.defaults}var k=d.prototype;return k.space=function(r){var i=this.rules.block.newline.exec(r);if(i&&i[0].length>0)return{type:"space",raw:i[0]}},k.code=function(r){var i=this.rules.block.code.exec(r);if(i){var o=i[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:i[0],codeBlockStyle:"indented",text:this.options.pedantic?o:j(o,`
`)}}},k.fences=function(r){var i=this.rules.block.fences.exec(r);if(i){var o=i[0],v=X(o,i[3]||"");return{type:"code",raw:o,lang:i[2]?i[2].trim():i[2],text:v}}},k.heading=function(r){var i=this.rules.block.heading.exec(r);if(i){var o=i[2].trim();if(/#$/.test(o)){var v=j(o,"#");(this.options.pedantic||!v||/ $/.test(v))&&(o=v.trim())}return{type:"heading",raw:i[0],depth:i[1].length,text:o,tokens:this.lexer.inline(o)}}},k.hr=function(r){var i=this.rules.block.hr.exec(r);if(i)return{type:"hr",raw:i[0]}},k.blockquote=function(r){var i=this.rules.block.blockquote.exec(r);if(i){var o=i[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:i[0],tokens:this.lexer.blockTokens(o,[]),text:o}}},k.list=function(r){var i=this.rules.block.list.exec(r);if(i){var o,v,P,T,U,_,Z,oe,be,De,ve,Se,we=i[1].trim(),Ne=we.length>1,Me={type:"list",raw:"",ordered:Ne,start:Ne?+we.slice(0,-1):"",loose:!1,items:[]};we=Ne?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Ne?we:"[*+-]");for(var Pe=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");r&&(Se=!1,!(!(i=Pe.exec(r))||this.rules.block.hr.test(r)));){if(o=i[0],r=r.substring(o.length),oe=i[2].split(`
`,1)[0],be=r.split(`
`,1)[0],this.options.pedantic?(T=2,ve=oe.trimLeft()):(T=i[2].search(/[^ ]/),T=T>4?1:T,ve=oe.slice(T),T+=i[1].length),_=!1,!oe&&/^ *$/.test(be)&&(o+=be+`
`,r=r.substring(be.length+1),Se=!0),!Se)for(var Xe=new RegExp("^ {0,"+Math.min(3,T-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,T-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Qe=new RegExp("^ {0,"+Math.min(3,T-1)+"}(?:```|~~~)"),Ze=new RegExp("^ {0,"+Math.min(3,T-1)+"}#");r&&(De=r.split(`
`,1)[0],oe=De,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Qe.test(oe)||Ze.test(oe)||Xe.test(oe)||nt.test(r)));){if(oe.search(/[^ ]/)>=T||!oe.trim())ve+=`
`+oe.slice(T);else if(!_)ve+=`
`+oe;else break;!_&&!oe.trim()&&(_=!0),o+=De+`
`,r=r.substring(De.length+1)}Me.loose||(Z?Me.loose=!0:/\n *\n *$/.test(o)&&(Z=!0)),this.options.gfm&&(v=/^\[[ xX]\] /.exec(ve),v&&(P=v[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Me.items.push({type:"list_item",raw:o,task:!!v,checked:P,loose:!1,text:ve}),Me.raw+=o}Me.items[Me.items.length-1].raw=o.trimRight(),Me.items[Me.items.length-1].text=ve.trimRight(),Me.raw=Me.raw.trimRight();var G=Me.items.length;for(U=0;U<G;U++){this.lexer.state.top=!1,Me.items[U].tokens=this.lexer.blockTokens(Me.items[U].text,[]);var ne=Me.items[U].tokens.filter(function(Ee){return Ee.type==="space"}),pe=ne.every(function(Ee){for(var Re=Ee.raw.split(""),Ue=0,Ve=W(Re),Je;!(Je=Ve()).done;){var tt=Je.value;if(tt===`
`&&(Ue+=1),Ue>1)return!0}return!1});!Me.loose&&ne.length&&pe&&(Me.loose=!0,Me.items[U].loose=!0)}return Me}},k.html=function(r){var i=this.rules.block.html.exec(r);if(i){var o={type:"html",raw:i[0],pre:!this.options.sanitizer&&(i[1]==="pre"||i[1]==="script"||i[1]==="style"),text:i[0]};if(this.options.sanitize){var v=this.options.sanitizer?this.options.sanitizer(i[0]):t(i[0]);o.type="paragraph",o.text=v,o.tokens=this.lexer.inline(v)}return o}},k.def=function(r){var i=this.rules.block.def.exec(r);if(i){i[3]&&(i[3]=i[3].substring(1,i[3].length-1));var o=i[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:o,raw:i[0],href:i[2],title:i[3]}}},k.table=function(r){var i=this.rules.block.table.exec(r);if(i){var o={type:"table",header:B(i[1]).map(function(Z){return{text:Z}}),align:i[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:i[3]&&i[3].trim()?i[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(o.header.length===o.align.length){o.raw=i[0];var v=o.align.length,P,T,U,_;for(P=0;P<v;P++)/^ *-+: *$/.test(o.align[P])?o.align[P]="right":/^ *:-+: *$/.test(o.align[P])?o.align[P]="center":/^ *:-+ *$/.test(o.align[P])?o.align[P]="left":o.align[P]=null;for(v=o.rows.length,P=0;P<v;P++)o.rows[P]=B(o.rows[P],o.header.length).map(function(Z){return{text:Z}});for(v=o.header.length,T=0;T<v;T++)o.header[T].tokens=this.lexer.inline(o.header[T].text);for(v=o.rows.length,T=0;T<v;T++)for(_=o.rows[T],U=0;U<_.length;U++)_[U].tokens=this.lexer.inline(_[U].text);return o}}},k.lheading=function(r){var i=this.rules.block.lheading.exec(r);if(i)return{type:"heading",raw:i[0],depth:i[2].charAt(0)==="="?1:2,text:i[1],tokens:this.lexer.inline(i[1])}},k.paragraph=function(r){var i=this.rules.block.paragraph.exec(r);if(i){var o=i[1].charAt(i[1].length-1)===`
`?i[1].slice(0,-1):i[1];return{type:"paragraph",raw:i[0],text:o,tokens:this.lexer.inline(o)}}},k.text=function(r){var i=this.rules.block.text.exec(r);if(i)return{type:"text",raw:i[0],text:i[0],tokens:this.lexer.inline(i[0])}},k.escape=function(r){var i=this.rules.inline.escape.exec(r);if(i)return{type:"escape",raw:i[0],text:t(i[1])}},k.tag=function(r){var i=this.rules.inline.tag.exec(r);if(i)return!this.lexer.state.inLink&&/^<a /i.test(i[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(i[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(i[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(i[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:i[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(i[0]):t(i[0]):i[0]}},k.link=function(r){var i=this.rules.inline.link.exec(r);if(i){var o=i[2].trim();if(!this.options.pedantic&&/^</.test(o)){if(!/>$/.test(o))return;var v=j(o.slice(0,-1),"\\");if((o.length-v.length)%2===0)return}else{var P=F(i[2],"()");if(P>-1){var T=i[0].indexOf("!")===0?5:4,U=T+i[1].length+P;i[2]=i[2].substring(0,P),i[0]=i[0].substring(0,U).trim(),i[3]=""}}var _=i[2],Z="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(_);oe&&(_=oe[1],Z=oe[3])}else Z=i[3]?i[3].slice(1,-1):"";return _=_.trim(),/^</.test(_)&&(this.options.pedantic&&!/>$/.test(o)?_=_.slice(1):_=_.slice(1,-1)),x(i,{href:_&&_.replace(this.rules.inline._escapes,"$1"),title:Z&&Z.replace(this.rules.inline._escapes,"$1")},i[0],this.lexer)}},k.reflink=function(r,i){var o;if((o=this.rules.inline.reflink.exec(r))||(o=this.rules.inline.nolink.exec(r))){var v=(o[2]||o[1]).replace(/\s+/g," ");if(v=i[v.toLowerCase()],!v||!v.href){var P=o[0].charAt(0);return{type:"text",raw:P,text:P}}return x(o,v,o[0],this.lexer)}},k.emStrong=function(r,i,o){o===void 0&&(o="");var v=this.rules.inline.emStrong.lDelim.exec(r);if(v&&!(v[3]&&o.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var P=v[1]||v[2]||"";if(!P||P&&(o===""||this.rules.inline.punctuation.exec(o))){var T=v[0].length-1,U,_,Z=T,oe=0,be=v[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(be.lastIndex=0,i=i.slice(-1*r.length+T);(v=be.exec(i))!=null;)if(U=v[1]||v[2]||v[3]||v[4]||v[5]||v[6],!!U){if(_=U.length,v[3]||v[4]){Z+=_;continue}else if((v[5]||v[6])&&T%3&&!((T+_)%3)){oe+=_;continue}if(Z-=_,!(Z>0)){if(_=Math.min(_,_+Z+oe),Math.min(T,_)%2){var De=r.slice(1,T+v.index+_);return{type:"em",raw:r.slice(0,T+v.index+_+1),text:De,tokens:this.lexer.inlineTokens(De)}}var ve=r.slice(2,T+v.index+_-1);return{type:"strong",raw:r.slice(0,T+v.index+_+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},k.codespan=function(r){var i=this.rules.inline.code.exec(r);if(i){var o=i[2].replace(/\n/g," "),v=/[^ ]/.test(o),P=/^ /.test(o)&&/ $/.test(o);return v&&P&&(o=o.substring(1,o.length-1)),o=t(o,!0),{type:"codespan",raw:i[0],text:o}}},k.br=function(r){var i=this.rules.inline.br.exec(r);if(i)return{type:"br",raw:i[0]}},k.del=function(r){var i=this.rules.inline.del.exec(r);if(i)return{type:"del",raw:i[0],text:i[2],tokens:this.lexer.inlineTokens(i[2])}},k.autolink=function(r,i){var o=this.rules.inline.autolink.exec(r);if(o){var v,P;return o[2]==="@"?(v=t(this.options.mangle?i(o[1]):o[1]),P="mailto:"+v):(v=t(o[1]),P=v),{type:"link",raw:o[0],text:v,href:P,tokens:[{type:"text",raw:v,text:v}]}}},k.url=function(r,i){var o;if(o=this.rules.inline.url.exec(r)){var v,P;if(o[2]==="@")v=t(this.options.mangle?i(o[0]):o[0]),P="mailto:"+v;else{var T;do T=o[0],o[0]=this.rules.inline._backpedal.exec(o[0])[0];while(T!==o[0]);v=t(o[0]),o[1]==="www."?P="http://"+v:P=v}return{type:"link",raw:o[0],text:v,href:P,tokens:[{type:"text",raw:v,text:v}]}}},k.inlineText=function(r,i){var o=this.rules.inline.text.exec(r);if(o){var v;return this.lexer.state.inRawBlock?v=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(o[0]):t(o[0]):o[0]:v=t(this.options.smartypants?i(o[0]):o[0]),{type:"text",raw:o[0],text:v}}},d}(),ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:H,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=u(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=u(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=u(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=u(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=u(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=u(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=E({},ue),ue.gfm=E({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=u(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.gfm.paragraph=u(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ue.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=E({},ue.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:H,paragraph:u(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:H,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:H,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=u(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=u(ue._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=u(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=u(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=u(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=u(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=u(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=u(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=u(te.reflink).replace("label",te._label).replace("ref",ue._label).getRegex(),te.nolink=u(te.nolink).replace("ref",ue._label).getRegex(),te.reflinkSearch=u(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=E({},te),te.pedantic=E({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=E({},te.normal,{escape:u(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=u(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=E({},te.gfm,{br:u(te.br).replace("{2,}","*").getRegex(),text:u(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(d){return d.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Le(d){var k="",C,r,i=d.length;for(C=0;C<i;C++)r=d.charCodeAt(C),Math.random()>.5&&(r="x"+r.toString(16)),k+="&#"+r+";";return k}var Te=function(){function d(C){this.tokens=[],this.tokens.links=Object.create(null),this.options=C||se.defaults,this.options.tokenizer=this.options.tokenizer||new de,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var r={block:ue.normal,inline:te.normal};this.options.pedantic?(r.block=ue.pedantic,r.inline=te.pedantic):this.options.gfm&&(r.block=ue.gfm,this.options.breaks?r.inline=te.breaks:r.inline=te.gfm),this.tokenizer.rules=r}d.lex=function(r,i){var o=new d(i);return o.lex(r)},d.lexInline=function(r,i){var o=new d(i);return o.inlineTokens(r)};var k=d.prototype;return k.lex=function(r){r=r.replace(/\r\n|\r/g,`
`),this.blockTokens(r,this.tokens);for(var i;i=this.inlineQueue.shift();)this.inlineTokens(i.src,i.tokens);return this.tokens},k.blockTokens=function(r,i){var o=this;i===void 0&&(i=[]),this.options.pedantic?r=r.replace(/\t/g,"    ").replace(/^ +$/gm,""):r=r.replace(/^( *)(\t+)/gm,function(Z,oe,be){return oe+"    ".repeat(be.length)});for(var v,P,T,U;r;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Z){return(v=Z.call({lexer:o},r,i))?(r=r.substring(v.raw.length),i.push(v),!0):!1}))){if(v=this.tokenizer.space(r)){r=r.substring(v.raw.length),v.raw.length===1&&i.length>0?i[i.length-1].raw+=`
`:i.push(v);continue}if(v=this.tokenizer.code(r)){r=r.substring(v.raw.length),P=i[i.length-1],P&&(P.type==="paragraph"||P.type==="text")?(P.raw+=`
`+v.raw,P.text+=`
`+v.text,this.inlineQueue[this.inlineQueue.length-1].src=P.text):i.push(v);continue}if(v=this.tokenizer.fences(r)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.heading(r)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.hr(r)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.blockquote(r)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.list(r)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.html(r)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.def(r)){r=r.substring(v.raw.length),P=i[i.length-1],P&&(P.type==="paragraph"||P.type==="text")?(P.raw+=`
`+v.raw,P.text+=`
`+v.raw,this.inlineQueue[this.inlineQueue.length-1].src=P.text):this.tokens.links[v.tag]||(this.tokens.links[v.tag]={href:v.href,title:v.title});continue}if(v=this.tokenizer.table(r)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.lheading(r)){r=r.substring(v.raw.length),i.push(v);continue}if(T=r,this.options.extensions&&this.options.extensions.startBlock&&function(){var Z=1/0,oe=r.slice(1),be=void 0;o.options.extensions.startBlock.forEach(function(De){be=De.call({lexer:this},oe),typeof be=="number"&&be>=0&&(Z=Math.min(Z,be))}),Z<1/0&&Z>=0&&(T=r.substring(0,Z+1))}(),this.state.top&&(v=this.tokenizer.paragraph(T))){P=i[i.length-1],U&&P.type==="paragraph"?(P.raw+=`
`+v.raw,P.text+=`
`+v.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=P.text):i.push(v),U=T.length!==r.length,r=r.substring(v.raw.length);continue}if(v=this.tokenizer.text(r)){r=r.substring(v.raw.length),P=i[i.length-1],P&&P.type==="text"?(P.raw+=`
`+v.raw,P.text+=`
`+v.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=P.text):i.push(v);continue}if(r){var _="Infinite loop on byte: "+r.charCodeAt(0);if(this.options.silent){console.error(_);break}else throw new Error(_)}}return this.state.top=!0,i},k.inline=function(r,i){return i===void 0&&(i=[]),this.inlineQueue.push({src:r,tokens:i}),i},k.inlineTokens=function(r,i){var o=this;i===void 0&&(i=[]);var v,P,T,U=r,_,Z,oe;if(this.tokens.links){var be=Object.keys(this.tokens.links);if(be.length>0)for(;(_=this.tokenizer.rules.inline.reflinkSearch.exec(U))!=null;)be.includes(_[0].slice(_[0].lastIndexOf("[")+1,-1))&&(U=U.slice(0,_.index)+"["+I("a",_[0].length-2)+"]"+U.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(_=this.tokenizer.rules.inline.blockSkip.exec(U))!=null;)U=U.slice(0,_.index)+"["+I("a",_[0].length-2)+"]"+U.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(_=this.tokenizer.rules.inline.escapedEmSt.exec(U))!=null;)U=U.slice(0,_.index)+"++"+U.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;r;)if(Z||(oe=""),Z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(v=ve.call({lexer:o},r,i))?(r=r.substring(v.raw.length),i.push(v),!0):!1}))){if(v=this.tokenizer.escape(r)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.tag(r)){r=r.substring(v.raw.length),P=i[i.length-1],P&&v.type==="text"&&P.type==="text"?(P.raw+=v.raw,P.text+=v.text):i.push(v);continue}if(v=this.tokenizer.link(r)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.reflink(r,this.tokens.links)){r=r.substring(v.raw.length),P=i[i.length-1],P&&v.type==="text"&&P.type==="text"?(P.raw+=v.raw,P.text+=v.text):i.push(v);continue}if(v=this.tokenizer.emStrong(r,U,oe)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.codespan(r)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.br(r)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.del(r)){r=r.substring(v.raw.length),i.push(v);continue}if(v=this.tokenizer.autolink(r,Le)){r=r.substring(v.raw.length),i.push(v);continue}if(!this.state.inLink&&(v=this.tokenizer.url(r,Le))){r=r.substring(v.raw.length),i.push(v);continue}if(T=r,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Se=r.slice(1),we=void 0;o.options.extensions.startInline.forEach(function(Ne){we=Ne.call({lexer:this},Se),typeof we=="number"&&we>=0&&(ve=Math.min(ve,we))}),ve<1/0&&ve>=0&&(T=r.substring(0,ve+1))}(),v=this.tokenizer.inlineText(T,ge)){r=r.substring(v.raw.length),v.raw.slice(-1)!=="_"&&(oe=v.raw.slice(-1)),Z=!0,P=i[i.length-1],P&&P.type==="text"?(P.raw+=v.raw,P.text+=v.text):i.push(v);continue}if(r){var De="Infinite loop on byte: "+r.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return i},A(d,null,[{key:"rules",get:function(){return{block:ue,inline:te}}}]),d}(),Be=function(){function d(C){this.options=C||se.defaults}var k=d.prototype;return k.code=function(r,i,o){var v=(i||"").match(/\S*/)[0];if(this.options.highlight){var P=this.options.highlight(r,v);P!=null&&P!==r&&(o=!0,r=P)}return r=r.replace(/\n$/,"")+`
`,v?'<pre><code class="'+this.options.langPrefix+t(v,!0)+'">'+(o?r:t(r,!0))+`</code></pre>
`:"<pre><code>"+(o?r:t(r,!0))+`</code></pre>
`},k.blockquote=function(r){return`<blockquote>
`+r+`</blockquote>
`},k.html=function(r){return r},k.heading=function(r,i,o,v){if(this.options.headerIds){var P=this.options.headerPrefix+v.slug(o);return"<h"+i+' id="'+P+'">'+r+"</h"+i+`>
`}return"<h"+i+">"+r+"</h"+i+`>
`},k.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},k.list=function(r,i,o){var v=i?"ol":"ul",P=i&&o!==1?' start="'+o+'"':"";return"<"+v+P+`>
`+r+"</"+v+`>
`},k.listitem=function(r){return"<li>"+r+`</li>
`},k.checkbox=function(r){return"<input "+(r?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},k.paragraph=function(r){return"<p>"+r+`</p>
`},k.table=function(r,i){return i&&(i="<tbody>"+i+"</tbody>"),`<table>
<thead>
`+r+`</thead>
`+i+`</table>
`},k.tablerow=function(r){return`<tr>
`+r+`</tr>
`},k.tablecell=function(r,i){var o=i.header?"th":"td",v=i.align?"<"+o+' align="'+i.align+'">':"<"+o+">";return v+r+("</"+o+`>
`)},k.strong=function(r){return"<strong>"+r+"</strong>"},k.em=function(r){return"<em>"+r+"</em>"},k.codespan=function(r){return"<code>"+r+"</code>"},k.br=function(){return this.options.xhtml?"<br/>":"<br>"},k.del=function(r){return"<del>"+r+"</del>"},k.link=function(r,i,o){if(r=m(this.options.sanitize,this.options.baseUrl,r),r===null)return o;var v='<a href="'+t(r)+'"';return i&&(v+=' title="'+i+'"'),v+=">"+o+"</a>",v},k.image=function(r,i,o){if(r=m(this.options.sanitize,this.options.baseUrl,r),r===null)return o;var v='<img src="'+r+'" alt="'+o+'"';return i&&(v+=' title="'+i+'"'),v+=this.options.xhtml?"/>":">",v},k.text=function(r){return r},d}(),le=function(){function d(){}var k=d.prototype;return k.strong=function(r){return r},k.em=function(r){return r},k.codespan=function(r){return r},k.del=function(r){return r},k.html=function(r){return r},k.text=function(r){return r},k.link=function(r,i,o){return""+o},k.image=function(r,i,o){return""+o},k.br=function(){return""},d}(),J=function(){function d(){this.seen={}}var k=d.prototype;return k.serialize=function(r){return r.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},k.getNextSafeSlug=function(r,i){var o=r,v=0;if(this.seen.hasOwnProperty(o)){v=this.seen[r];do v++,o=r+"-"+v;while(this.seen.hasOwnProperty(o))}return i||(this.seen[r]=v,this.seen[o]=0),o},k.slug=function(r,i){i===void 0&&(i={});var o=this.serialize(r);return this.getNextSafeSlug(o,i.dryrun)},d}(),ae=function(){function d(C){this.options=C||se.defaults,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new J}d.parse=function(r,i){var o=new d(i);return o.parse(r)},d.parseInline=function(r,i){var o=new d(i);return o.parseInline(r)};var k=d.prototype;return k.parse=function(r,i){i===void 0&&(i=!0);var o="",v,P,T,U,_,Z,oe,be,De,ve,Se,we,Ne,Me,Pe,Xe,nt,Qe,Ze,G=r.length;for(v=0;v<G;v++){if(ve=r[v],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Ze=this.options.extensions.renderers[ve.type].call({parser:this},ve),Ze!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){o+=Ze||"";continue}switch(ve.type){case"space":continue;case"hr":{o+=this.renderer.hr();continue}case"heading":{o+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,c(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{o+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(be="",oe="",U=ve.header.length,P=0;P<U;P++)oe+=this.renderer.tablecell(this.parseInline(ve.header[P].tokens),{header:!0,align:ve.align[P]});for(be+=this.renderer.tablerow(oe),De="",U=ve.rows.length,P=0;P<U;P++){for(Z=ve.rows[P],oe="",_=Z.length,T=0;T<_;T++)oe+=this.renderer.tablecell(this.parseInline(Z[T].tokens),{header:!1,align:ve.align[T]});De+=this.renderer.tablerow(oe)}o+=this.renderer.table(be,De);continue}case"blockquote":{De=this.parse(ve.tokens),o+=this.renderer.blockquote(De);continue}case"list":{for(Se=ve.ordered,we=ve.start,Ne=ve.loose,U=ve.items.length,De="",P=0;P<U;P++)Pe=ve.items[P],Xe=Pe.checked,nt=Pe.task,Me="",Pe.task&&(Qe=this.renderer.checkbox(Xe),Ne?Pe.tokens.length>0&&Pe.tokens[0].type==="paragraph"?(Pe.tokens[0].text=Qe+" "+Pe.tokens[0].text,Pe.tokens[0].tokens&&Pe.tokens[0].tokens.length>0&&Pe.tokens[0].tokens[0].type==="text"&&(Pe.tokens[0].tokens[0].text=Qe+" "+Pe.tokens[0].tokens[0].text)):Pe.tokens.unshift({type:"text",text:Qe}):Me+=Qe),Me+=this.parse(Pe.tokens,Ne),De+=this.renderer.listitem(Me,nt,Xe);o+=this.renderer.list(De,Se,we);continue}case"html":{o+=this.renderer.html(ve.text);continue}case"paragraph":{o+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(De=ve.tokens?this.parseInline(ve.tokens):ve.text;v+1<G&&r[v+1].type==="text";)ve=r[++v],De+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);o+=i?this.renderer.paragraph(De):De;continue}default:{var ne='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return o},k.parseInline=function(r,i){i=i||this.renderer;var o="",v,P,T,U=r.length;for(v=0;v<U;v++){if(P=r[v],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[P.type]&&(T=this.options.extensions.renderers[P.type].call({parser:this},P),T!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(P.type))){o+=T||"";continue}switch(P.type){case"escape":{o+=i.text(P.text);break}case"html":{o+=i.html(P.text);break}case"link":{o+=i.link(P.href,P.title,this.parseInline(P.tokens,i));break}case"image":{o+=i.image(P.href,P.title,P.text);break}case"strong":{o+=i.strong(this.parseInline(P.tokens,i));break}case"em":{o+=i.em(this.parseInline(P.tokens,i));break}case"codespan":{o+=i.codespan(P.text);break}case"br":{o+=i.br();break}case"del":{o+=i.del(this.parseInline(P.tokens,i));break}case"text":{o+=i.text(P.text);break}default:{var _='Token with "'+P.type+'" type was not found.';if(this.options.silent){console.error(_);return}else throw new Error(_)}}}return o},d}();function re(d,k,C){if(typeof d>"u"||d===null)throw new Error("marked(): input parameter is undefined or null");if(typeof d!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(d)+", string expected");if(typeof k=="function"&&(C=k,k=null),k=E({},re.defaults,k||{}),M(k),C){var r=k.highlight,i;try{i=Te.lex(d,k)}catch(U){return C(U)}var o=function(_){var Z;if(!_)try{k.walkTokens&&re.walkTokens(i,k.walkTokens),Z=ae.parse(i,k)}catch(oe){_=oe}return k.highlight=r,_?C(_):C(null,Z)};if(!r||r.length<3||(delete k.highlight,!i.length))return o();var v=0;re.walkTokens(i,function(U){U.type==="code"&&(v++,setTimeout(function(){r(U.text,U.lang,function(_,Z){if(_)return o(_);Z!=null&&Z!==U.text&&(U.text=Z,U.escaped=!0),v--,v===0&&o()})},0))}),v===0&&o();return}function P(U){if(U.message+=`
Please report this to https://github.com/markedjs/marked.`,k.silent)return"<p>An error occurred:</p><pre>"+t(U.message+"",!0)+"</pre>";throw U}try{var T=Te.lex(d,k);if(k.walkTokens){if(k.async)return Promise.all(re.walkTokens(T,k.walkTokens)).then(function(){return ae.parse(T,k)}).catch(P);re.walkTokens(T,k.walkTokens)}return ae.parse(T,k)}catch(U){P(U)}}re.options=re.setOptions=function(d){return E(re.defaults,d),S(re.defaults),re},re.getDefaults=D,re.defaults=se.defaults,re.use=function(){for(var d=arguments.length,k=new Array(d),C=0;C<d;C++)k[C]=arguments[C];var r=E.apply(void 0,[{}].concat(k)),i=re.defaults.extensions||{renderers:{},childTokens:{}},o;k.forEach(function(v){if(v.extensions&&(o=!0,v.extensions.forEach(function(T){if(!T.name)throw new Error("extension name required");if(T.renderer){var U=i.renderers?i.renderers[T.name]:null;U?i.renderers[T.name]=function(){for(var _=arguments.length,Z=new Array(_),oe=0;oe<_;oe++)Z[oe]=arguments[oe];var be=T.renderer.apply(this,Z);return be===!1&&(be=U.apply(this,Z)),be}:i.renderers[T.name]=T.renderer}if(T.tokenizer){if(!T.level||T.level!=="block"&&T.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");i[T.level]?i[T.level].unshift(T.tokenizer):i[T.level]=[T.tokenizer],T.start&&(T.level==="block"?i.startBlock?i.startBlock.push(T.start):i.startBlock=[T.start]:T.level==="inline"&&(i.startInline?i.startInline.push(T.start):i.startInline=[T.start]))}T.childTokens&&(i.childTokens[T.name]=T.childTokens)})),v.renderer&&function(){var T=re.defaults.renderer||new Be,U=function(oe){var be=T[oe];T[oe]=function(){for(var De=arguments.length,ve=new Array(De),Se=0;Se<De;Se++)ve[Se]=arguments[Se];var we=v.renderer[oe].apply(T,ve);return we===!1&&(we=be.apply(T,ve)),we}};for(var _ in v.renderer)U(_);r.renderer=T}(),v.tokenizer&&function(){var T=re.defaults.tokenizer||new de,U=function(oe){var be=T[oe];T[oe]=function(){for(var De=arguments.length,ve=new Array(De),Se=0;Se<De;Se++)ve[Se]=arguments[Se];var we=v.tokenizer[oe].apply(T,ve);return we===!1&&(we=be.apply(T,ve)),we}};for(var _ in v.tokenizer)U(_);r.tokenizer=T}(),v.walkTokens){var P=re.defaults.walkTokens;r.walkTokens=function(T){var U=[];return U.push(v.walkTokens.call(this,T)),P&&(U=U.concat(P.call(this,T))),U}}o&&(r.extensions=i),re.setOptions(r)})},re.walkTokens=function(d,k){for(var C=[],r=function(){var P=o.value;switch(C=C.concat(k.call(re,P)),P.type){case"table":{for(var T=W(P.header),U;!(U=T()).done;){var _=U.value;C=C.concat(re.walkTokens(_.tokens,k))}for(var Z=W(P.rows),oe;!(oe=Z()).done;)for(var be=oe.value,De=W(be),ve;!(ve=De()).done;){var Se=ve.value;C=C.concat(re.walkTokens(Se.tokens,k))}break}case"list":{C=C.concat(re.walkTokens(P.items,k));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[P.type]?re.defaults.extensions.childTokens[P.type].forEach(function(we){C=C.concat(re.walkTokens(P[we],k))}):P.tokens&&(C=C.concat(re.walkTokens(P.tokens,k)))}},i=W(d),o;!(o=i()).done;)r();return C},re.parseInline=function(d,k){if(typeof d>"u"||d===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof d!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(d)+", string expected");k=E({},re.defaults,k||{}),M(k);try{var C=Te.lexInline(d,k);return k.walkTokens&&re.walkTokens(C,k.walkTokens),ae.parseInline(C,k)}catch(r){if(r.message+=`
Please report this to https://github.com/markedjs/marked.`,k.silent)return"<p>An error occurred:</p><pre>"+t(r.message+"",!0)+"</pre>";throw r}},re.Parser=ae,re.parser=ae.parse,re.Renderer=Be,re.TextRenderer=le,re.Lexer=Te,re.lexer=Te.lex,re.Tokenizer=de,re.Slugger=J,re.parse=re;var Y=re.options,Q=re.setOptions,ie=re.use,fe=re.walkTokens,ye=re.parseInline,Ce=re,ke=ae.parse,q=Te.lex;se.Lexer=Te,se.Parser=ae,se.Renderer=Be,se.Slugger=J,se.TextRenderer=le,se.Tokenizer=de,se.getDefaults=D,se.lexer=q,se.marked=re,se.options=Y,se.parse=Ce,se.parseInline=ye,se.parser=ke,se.setOptions=Q,se.use=ie,se.walkTokens=fe,Object.defineProperty(se,"__esModule",{value:!0})}),define(me[82],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0;function A(s){const c=W(s);if(c&&c.length>0)return new Uint32Array(c)}e.$3j=A;let N=0;const n=new Uint32Array(10);function W(s){if(N=0,D(s,O,4352),N>0||(D(s,l,4449),N>0)||(D(s,f,4520),N>0)||(D(s,t,12593),N))return n.subarray(0,N);if(s>=44032&&s<=55203){const c=s-44032,g=c%588,u=Math.floor(c/588),w=Math.floor(g/28),h=g%28-1;if(u<O.length?D(u,O,0):4352+u-12593<t.length&&D(4352+u,t,12593),w<l.length?D(w,l,0):4449+w-12593<t.length&&D(4449+w-12593,t,12593),h>=0&&(h<f.length?D(h,f,0):4520+h-12593<t.length&&D(4520+h-12593,t,12593)),N>0)return n.subarray(0,N)}}function D(s,c,g){s>=g&&s<g+c.length&&S(c[s-g])}function S(s){s!==0&&(n[N++]=s&255,s>>8&&(n[N++]=s>>8&255),s>>16&&(n[N++]=s>>16&255))}var b;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var $;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})($||($={}));var p;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(p||(p={}));const O=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),f=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),t=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(me[83],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0T=void 0;class A{constructor(n,W=0,D=n.length,S=W-1){this.a=n,this.b=W,this.c=D,this.d=S}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}e.$0T=A}),define(me[84],$e([1,0,83]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_T=e.$$T=void 0;class N{constructor(D=[],S=10){this.h(D),this.b=S,this.d()}getHistory(){return this.j}add(D){this.a.delete(D),this.a.add(D),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(D){return this.a.has(D)}clear(){this.h([]),this.d()}d(){this.f();const D=this.j;this.c=new A.$0T(D,0,D.length,D.length)}f(){const D=this.j;D.length>this.b&&this.h(D.slice(D.length-this.b))}g(){const D=this.c.current();return D?this.j.indexOf(D):-1}h(D){this.a=new Set;for(const S of D)this.a.add(S)}get j(){const D=[];return this.a.forEach(S=>D.push(S)),D}}e.$$T=N;class n{get size(){return this.f}constructor(D,S=10){if(this.g=S,D.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:D[0],previous:void 0,next:void 0},this.a=new Set([D[0]]);for(let b=1;b<D.length;b++)this.add(D[b])}add(D){const S={value:D,previous:this.c,next:void 0};for(this.c.next=S,this.c=S,this.d=this.c,this.f++,this.a.has(D)?this.h(D):this.a.add(D);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(D){if(this.c.value===D)return D;const S=this.c.value;return this.a.delete(S),this.c.value=D,this.a.has(D)?this.h(D):this.a.add(D),S}prepend(D){if(this.f===this.g||this.a.has(D))return;const S={value:D,previous:void 0,next:this.b};this.b.previous=S,this.b=S,this.f++,this.a.add(D)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(D){return this.a.has(D)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let D=this.b;for(;D;)yield D.value,D=D.next}h(D){let S=this.b;for(;S!==this.c;)S.value===D&&(S===this.b?(this.b=this.b.next,this.b.previous=void 0):(S.previous.next=S.next,S.next.previous=S.previous),this.f--),S=S.next}}e.$_T=n}),define(me[34],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.rot=e.$fm=void 0;function A(S,b,$){return Math.min(Math.max(S,b),$)}e.$fm=A;function N(S,b){return(b+S%b)%b}e.rot=N;class n{constructor(){this.a=0}getNext(){return this.a++}}e.$hm=n;class W{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$im=W;class D{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const $=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$jm=D}),define(me[49],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;var A;(function(N){function n(b,$){if(b.start>=$.end||$.start>=b.end)return{start:0,end:0};const p=Math.max(b.start,$.start),O=Math.min(b.end,$.end);return O-p<=0?{start:0,end:0}:{start:p,end:O}}N.intersect=n;function W(b){return b.end-b.start<=0}N.isEmpty=W;function D(b,$){return!W(n(b,$))}N.intersects=D;function S(b,$){const p=[],O={start:b.start,end:Math.min($.start,b.end)},l={start:Math.max($.end,b.start),end:b.end};return W(O)||p.push(O),W(l)||p.push(l),p}N.relativeComplement=S})(A||(e.Range=A={}))}),define(me[85],$e([1,0,49]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SS=e.$RS=e.$QS=e.$PS=void 0;function N(b,$){const p=[];for(const O of $){if(b.start>=O.range.end)continue;if(b.end<O.range.start)break;const l=A.Range.intersect(b,O.range);A.Range.isEmpty(l)||p.push({range:l,size:O.size})}return p}e.$PS=N;function n({start:b,end:$},p){return{start:b+p,end:$+p}}e.$QS=n;function W(b){const $=[];let p=null;for(const O of b){const l=O.range.start,f=O.range.end,t=O.size;if(p&&t===p.size){p.range.end=f;continue}p={range:{start:l,end:f},size:t},$.push(p)}return $}e.$RS=W;function D(...b){return W(b.reduce(($,p)=>$.concat(p),[]))}class S{get paddingTop(){return this.c}set paddingTop($){this.b=this.b+$-this.c,this.c=$}constructor($){this.a=[],this.b=0,this.c=0,this.c=$??0,this.b=this.c}splice($,p,O=[]){const l=O.length-p,f=N({start:0,end:$},this.a),t=N({start:$+p,end:Number.POSITIVE_INFINITY},this.a).map(c=>({range:n(c.range,l),size:c.size})),s=O.map((c,g)=>({range:{start:$+g,end:$+g+1},size:c.size}));this.a=D(f,s,t),this.b=this.c+this.a.reduce((c,g)=>c+g.size*(g.range.end-g.range.start),0)}get count(){const $=this.a.length;return $?this.a[$-1].range.end:0}get size(){return this.b}indexAt($){if($<0)return-1;if($<this.c)return 0;let p=0,O=this.c;for(const l of this.a){const f=l.range.end-l.range.start,t=O+f*l.size;if($<t)return p+Math.floor(($-O)/l.size);p+=f,O=t}return p}indexAfter($){return Math.min(this.indexAt($)+1,this.count)}positionAt($){if($<0)return-1;let p=0,O=0;for(const l of this.a){const f=l.range.end-l.range.start,t=O+f;if($<t)return this.c+p+($-O)*l.size;p+=f*l.size,O=t}return-1}}e.$SS=S}),define(me[86],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=void 0;const A=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(W){return new N(W)}constructor(W){this.c=A&&W===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$1d=N}),define(me[4],$e([1,0,6,46,3,48,86]),function(se,e,A,N,n,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.Event=void 0;const S=!1,b=!1;var $;(function(j){j.None=()=>n.$Tc.None;function F(r){if(b){const{onDidAddListener:i}=r,o=t.create();let v=0;r.onDidAddListener=()=>{++v===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),o.print()),i?.()}}}function M(r,i){return Be(r,()=>{},0,void 0,!0,void 0,i)}j.defer=M;function I(r){return(i,o=null,v)=>{let P=!1,T;return T=r(U=>{if(!P)return T?T.dispose():P=!0,i.call(o,U)},null,v),P&&T.dispose(),T}}j.once=I;function x(r,i,o){return Le((v,P=null,T)=>r(U=>v.call(P,i(U)),null,T),o)}j.map=x;function X(r,i,o){return Le((v,P=null,T)=>r(U=>{i(U),v.call(P,U)},null,T),o)}j.forEach=X;function de(r,i,o){return Le((v,P=null,T)=>r(U=>i(U)&&v.call(P,U),null,T),o)}j.filter=de;function ue(r){return r}j.signal=ue;function te(...r){return(i,o=null,v)=>{const P=(0,n.$Qc)(...r.map(T=>T(U=>i.call(o,U))));return Te(P,v)}}j.any=te;function ge(r,i,o,v){let P=o;return x(r,T=>(P=i(P,T),P),v)}j.reduce=ge;function Le(r,i){let o;const v={onWillAddFirstListener(){o=r(P.fire,P)},onDidRemoveLastListener(){o?.dispose()}};i||F(v);const P=new w(v);return i?.add(P),P.event}function Te(r,i){return i instanceof Array?i.push(r):i&&i.add(r),r}function Be(r,i,o=100,v=!1,P=!1,T,U){let _,Z,oe,be=0,De;const ve={leakWarningThreshold:T,onWillAddFirstListener(){_=r(we=>{be++,Z=i(Z,we),v&&!oe&&(Se.fire(Z),Z=void 0),De=()=>{const Ne=Z;Z=void 0,oe=void 0,(!v||be>1)&&Se.fire(Ne),be=0},typeof o=="number"?(clearTimeout(oe),oe=setTimeout(De,o)):oe===void 0&&(oe=0,queueMicrotask(De))})},onWillRemoveListener(){P&&be>0&&De?.()},onDidRemoveLastListener(){De=void 0,_.dispose()}};U||F(ve);const Se=new w(ve);return U?.add(Se),Se.event}j.debounce=Be;function le(r,i=0,o){return j.debounce(r,(v,P)=>v?(v.push(P),v):[P],i,void 0,!0,void 0,o)}j.accumulate=le;function J(r,i=(v,P)=>v===P,o){let v=!0,P;return de(r,T=>{const U=v||!i(T,P);return v=!1,P=T,U},o)}j.latch=J;function ae(r,i,o){return[j.filter(r,i,o),j.filter(r,v=>!i(v),o)]}j.split=ae;function re(r,i=!1,o=[],v){let P=o.slice(),T=r(Z=>{P?P.push(Z):_.fire(Z)});v&&v.add(T);const U=()=>{P?.forEach(Z=>_.fire(Z)),P=null},_=new w({onWillAddFirstListener(){T||(T=r(Z=>_.fire(Z)),v&&v.add(T))},onDidAddFirstListener(){P&&(i?setTimeout(U):U())},onDidRemoveLastListener(){T&&T.dispose(),T=null}});return v&&v.add(_),_.event}j.buffer=re;function Y(r,i){return(v,P,T)=>{const U=i(new ie);return r(function(_){const Z=U.evaluate(_);Z!==Q&&v.call(P,Z)},void 0,T)}}j.chain=Y;const Q=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(i){return this.f.push(i),this}forEach(i){return this.f.push(o=>(i(o),o)),this}filter(i){return this.f.push(o=>i(o)?o:Q),this}reduce(i,o){let v=o;return this.f.push(P=>(v=i(v,P),v)),this}latch(i=(o,v)=>o===v){let o=!0,v;return this.f.push(P=>{const T=o||!i(P,v);return o=!1,v=P,T?P:Q}),this}evaluate(i){for(const o of this.f)if(i=o(i),i===Q)break;return i}}function fe(r,i,o=v=>v){const v=(..._)=>U.fire(o(..._)),P=()=>r.on(i,v),T=()=>r.removeListener(i,v),U=new w({onWillAddFirstListener:P,onDidRemoveLastListener:T});return U.event}j.fromNodeEventEmitter=fe;function ye(r,i,o=v=>v){const v=(..._)=>U.fire(o(..._)),P=()=>r.addEventListener(i,v),T=()=>r.removeEventListener(i,v),U=new w({onWillAddFirstListener:P,onDidRemoveLastListener:T});return U.event}j.fromDOMEventEmitter=ye;function Ce(r){return new Promise(i=>I(r)(i))}j.toPromise=Ce;function ke(r){const i=new w;return r.then(o=>{i.fire(o)},()=>{i.fire(void 0)}).finally(()=>{i.dispose()}),i.event}j.fromPromise=ke;function q(r,i,o){return i(o),r(v=>i(v))}j.runAndSubscribe=q;class d{constructor(i,o){this._observable=i,this.f=0,this.g=!1;const v={onWillAddFirstListener:()=>{i.addObserver(this)},onDidRemoveLastListener:()=>{i.removeObserver(this)}};o||F(v),this.emitter=new w(v),o&&o.add(this.emitter)}beginUpdate(i){this.f++}handlePossibleChange(i){}handleChange(i,o){this.g=!0}endUpdate(i){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function k(r,i){return new d(r,i).emitter.event}j.fromObservable=k;function C(r){return(i,o,v)=>{let P=0,T=!1;const U={beginUpdate(){P++},endUpdate(){P--,P===0&&(r.reportChanges(),T&&(T=!1,i.call(o)))},handlePossibleChange(){},handleChange(){T=!0}};r.addObserver(U),r.reportChanges();const _={dispose(){r.removeObserver(U)}};return v instanceof n.$Sc?v.add(_):Array.isArray(v)&&v.push(_),_}}j.fromObservableLight=C})($||(e.Event=$={}));class p{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${p.f++}`,p.all.add(this)}start(F){this.g=new D.$1d,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$3d=p;let O=-1;function l(j){const F=O;return O=j,{dispose(){O=F}}}e.$4d=l;class f{constructor(F,M=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=M,this.g=0}dispose(){this.f?.clear()}check(F,M){const I=this.threshold;if(I<=0||M<I)return;this.f||(this.f=new Map);const x=this.f.get(F.value)||0;if(this.f.set(F.value,x+1),this.g-=1,this.g<=0){this.g=I*.5;let X,de=0;for(const[ue,te]of this.f)(!X||de<te)&&(X=ue,de=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${M} listeners already. MOST frequent listener (${de}):`),console.warn(X)}return()=>{const X=this.f.get(F.value)||0;this.f.set(F.value,X-1)}}}class t{static create(){return new t(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class c{constructor(F){this.value=F,this.id=s++}}const g=2,u=(j,F)=>{if(j instanceof c)F(j);else for(let M=0;M<j.length;M++){const I=j[M];I&&F(I)}};class w{constructor(F){this.w=0,this.f=F,this.g=O>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??O):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const F=this.t;queueMicrotask(()=>{u(F,M=>M.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,M,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.$Tc.None;if(this.m)return n.$Tc.None;M&&(F=F.bind(M));const x=new c(F);let X,de;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(x.stack=t.create(),X=this.g.check(x.stack,this.w+1)),S&&(x.stack=de??t.create()),this.t?this.t instanceof c?(this.u??=new m,this.t=[this.t,x]):this.t.push(x):(this.f?.onWillAddFirstListener?.(this),this.t=x,this.f?.onDidAddFirstListener?.(this)),this.w++;const ue=(0,n.$Rc)(()=>{X?.(),this.x(x)});return I instanceof n.$Sc?I.add(ue):Array.isArray(I)&&I.push(ue),ue},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const M=this.t,I=M.indexOf(F);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,M[I]=void 0;const x=this.u.current===this;if(this.w*g<=M.length){let X=0;for(let de=0;de<M.length;de++)M[de]?M[X++]=M[de]:x&&(this.u.end--,X<this.u.i&&this.u.i--);M.length=X}}y(F,M){if(!F)return;const I=this.f?.onListenerError||A.$1;if(!I){F.value(M);return}try{F.value(M)}catch(x){I(x)}}z(F){const M=F.current.t;for(;F.i<F.end;)this.y(M[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof c)this.y(this.t,F);else{const M=this.u;M.enqueue(this,F,this.t.length),this.z(M)}this.j?.stop()}hasListeners(){return this.w>0}}e.$5d=w;const h=()=>new m;e.$6d=h;class m{constructor(){this.i=-1,this.end=0}enqueue(F,M,I){this.i=0,this.end=I,this.current=F,this.value=M}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class a extends w{async fireAsync(F,M,I){if(this.t)for(this.h||(this.h=new W.$4c),u(this.t,x=>this.h.push([x.value,F]));this.h.size>0&&!M.isCancellationRequested;){const[x,X]=this.h.shift(),de=[],ue={...X,token:M,waitUntil:te=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");I&&(te=I(te,x)),de.push(te)}};try{x(ue)}catch(te){(0,A.$1)(te);continue}Object.freeze(de),await Promise.allSettled(de).then(te=>{for(const ge of te)ge.status==="rejected"&&(0,A.$1)(ge.reason)})}}}e.$7d=a;class y extends w{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new W.$4c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$8d=y;class L extends y{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$9d=L;class R extends w{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(M=>super.fire(M)),this.h=[]}))}}e.$0d=R;class z{constructor(){this.g=!1,this.h=[],this.f=new w({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const M={event:F,listener:null};this.h.push(M),this.g&&this.m(M);const I=()=>{this.g&&this.o(M);const x=this.h.indexOf(M);this.h.splice(x,1)};return(0,n.$Rc)((0,N.$db)(I))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(M=>this.f.fire(M))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$$d=z;class H{constructor(F,M,I,x){this.f=new n.$Sc;const X=this.f.add(new z),de=this.f.add(new n.$3c);function ue(te){de.set(te,X.add(x(te)))}for(const te of F)ue(te);this.f.add(M(te=>{ue(te)})),this.f.add(I(te=>{de.deleteAndDispose(te)})),this.event=X.event}dispose(){this.f.dispose()}}e.$_d=H;class E{constructor(){this.f=[]}wrapEvent(F){return(M,I,x)=>F(X=>{const de=this.f[this.f.length-1];de?de.push(()=>M.call(I,X)):M.call(I,X)},void 0,x)}bufferEvents(F){const M=[];this.f.push(M);const I=F();return this.f.pop(),M.forEach(x=>x()),I}}e.$ae=E;class B{constructor(){this.f=!1,this.g=$.None,this.h=n.$Tc.None,this.j=new w({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$be=B}),define(me[16],$e([1,0,21,4]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=e.$tQ=e.$sQ=e.$rQ=e.$qQ=e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=e.$iQ=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.$dQ=void 0;class n{constructor(){this.a=new Map,this.b=new N.$5d,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new N.$5d,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new n}getZoomLevel(g){return this.a.get(this.f(g))??0}setZoomLevel(g,u){if(this.getZoomLevel(u)===g)return;const w=this.f(u);this.a.set(w,g),this.b.fire(w)}getZoomFactor(g){return this.c.get(this.f(g))??1}setZoomFactor(g,u){this.c.set(this.f(u),g)}setFullscreen(g,u){if(this.isFullscreen(u)===g)return;const w=this.f(u);this.e.set(w,g),this.d.fire(w)}isFullscreen(g){return!!this.e.get(this.f(g))}f(g){return g.vscodeWindowId}}function W(c,g,u){typeof g=="string"&&(g=c.matchMedia(g)),g.addEventListener("change",u)}e.$dQ=W;function D(c,g){n.INSTANCE.setZoomLevel(c,g)}e.$eQ=D;function S(c){return n.INSTANCE.getZoomLevel(c)}e.$fQ=S,e.$gQ=n.INSTANCE.onDidChangeZoomLevel;function b(c){return n.INSTANCE.getZoomFactor(c)}e.$hQ=b;function $(c,g){n.INSTANCE.setZoomFactor(c,g)}e.$iQ=$;function p(c,g){n.INSTANCE.setFullscreen(c,g)}e.$jQ=p;function O(c){return n.INSTANCE.isFullscreen(c)}e.$kQ=O,e.$lQ=n.INSTANCE.onDidChangeFullscreen;const l=navigator.userAgent;e.$mQ=l.indexOf("Firefox")>=0,e.$nQ=l.indexOf("AppleWebKit")>=0,e.$oQ=l.indexOf("Chrome")>=0,e.$pQ=!e.$oQ&&l.indexOf("Safari")>=0,e.$qQ=!e.$oQ&&!e.$pQ&&e.$nQ,e.$rQ=l.indexOf("Electron/")>=0,e.$sQ=l.indexOf("Android")>=0;let f=!1;if(typeof A.$_P.matchMedia=="function"){const c=A.$_P.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),g=A.$_P.matchMedia("(display-mode: fullscreen)");f=c.matches,W(A.$_P,c,({matches:u})=>{f&&g.matches||(f=u)})}function t(){return f}e.$tQ=t;function s(){return navigator?.windowControlsOverlay?.visible}e.$uQ=s}),define(me[23],$e([1,0,4]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KS=void 0;class N{get event(){return this.a.event}constructor(W,D,S){const b=$=>this.a.fire($);this.a=new A.$5d({onWillAddFirstListener:()=>W.addEventListener(D,b,S),onDidRemoveLastListener:()=>W.removeEventListener(D,b,S)})}dispose(){this.a.dispose()}}e.$KS=N}),define(me[30],$e([1,0,4]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.CancellationToken=void 0;const N=Object.freeze(function(S,b){const $=setTimeout(S.bind(b),0);return{dispose(){clearTimeout($)}}});var n;(function(S){function b($){return $===S.None||$===S.Cancelled||$ instanceof W?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}S.isCancellationToken=b,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(n||(e.CancellationToken=n={}));class W{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new A.$5d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new W),this.f}cancel(){this.f?this.f instanceof W&&this.f.cancel():this.f=n.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof W&&this.f.dispose():this.f=n.None}}e.$ce=D}),define(me[87],$e([1,0,30]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=void 0;class N{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new A.$ce,b=this.b(S.token);return this.a={promise:b,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$Ne=N;class n{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const b=JSON.stringify(S);return this.b!==b&&(this.b=b,this.a=this.c(S)),this.a}}e.$Oe=n;class W{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const b=this.b(S);return this.a.set(S,b),b}}e.$Pe=W}),define(me[50],$e([1,0,4,3]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=e.$vs=e.ScrollbarVisibility=void 0;var n;(function(f){f[f.Auto=1]="Auto",f[f.Hidden=2]="Hidden",f[f.Visible=3]="Visible"})(n||(e.ScrollbarVisibility=n={}));class W{constructor(t,s,c,g,u,w,h){this.c=t,this._scrollStateBrand=void 0,this.c&&(s=s|0,c=c|0,g=g|0,u=u|0,w=w|0,h=h|0),this.rawScrollLeft=g,this.rawScrollTop=h,s<0&&(s=0),g+s>c&&(g=c-s),g<0&&(g=0),u<0&&(u=0),h+u>w&&(h=w-u),h<0&&(h=0),this.width=s,this.scrollWidth=c,this.scrollLeft=g,this.height=u,this.scrollHeight=w,this.scrollTop=h}equals(t){return this.rawScrollLeft===t.rawScrollLeft&&this.rawScrollTop===t.rawScrollTop&&this.width===t.width&&this.scrollWidth===t.scrollWidth&&this.scrollLeft===t.scrollLeft&&this.height===t.height&&this.scrollHeight===t.scrollHeight&&this.scrollTop===t.scrollTop}withScrollDimensions(t,s){return new W(this.c,typeof t.width<"u"?t.width:this.width,typeof t.scrollWidth<"u"?t.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof t.height<"u"?t.height:this.height,typeof t.scrollHeight<"u"?t.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(t){return new W(this.c,this.width,this.scrollWidth,typeof t.scrollLeft<"u"?t.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof t.scrollTop<"u"?t.scrollTop:this.rawScrollTop)}createScrollEvent(t,s){const c=this.width!==t.width,g=this.scrollWidth!==t.scrollWidth,u=this.scrollLeft!==t.scrollLeft,w=this.height!==t.height,h=this.scrollHeight!==t.scrollHeight,m=this.scrollTop!==t.scrollTop;return{inSmoothScrolling:s,oldWidth:t.width,oldScrollWidth:t.scrollWidth,oldScrollLeft:t.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:t.height,oldScrollHeight:t.scrollHeight,oldScrollTop:t.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:c,scrollWidthChanged:g,scrollLeftChanged:u,heightChanged:w,scrollHeightChanged:h,scrollTopChanged:m}}}e.$vs=W;class D extends N.$Tc{constructor(t){super(),this._scrollableBrand=void 0,this.j=this.B(new A.$5d),this.onScroll=this.j.event,this.c=t.smoothScrollDuration,this.f=t.scheduleAtNextAnimationFrame,this.g=new W(t.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(t){this.c=t}validateScrollPosition(t){return this.g.withScrollPosition(t)}getScrollDimensions(){return this.g}setScrollDimensions(t,s){const c=this.g.withScrollDimensions(t,s);this.n(c,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(t){const s=this.g.withScrollPosition(t);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(t,s){if(this.c===0)return this.setScrollPositionNow(t);if(this.h){t={scrollLeft:typeof t.scrollLeft>"u"?this.h.to.scrollLeft:t.scrollLeft,scrollTop:typeof t.scrollTop>"u"?this.h.to.scrollTop:t.scrollTop};const c=this.g.withScrollPosition(t);if(this.h.to.scrollLeft===c.scrollLeft&&this.h.to.scrollTop===c.scrollTop)return;let g;s?g=new p(this.h.from,c,this.h.startTime,this.h.duration):g=this.h.combine(this.g,c,this.c),this.h.dispose(),this.h=g}else{const c=this.g.withScrollPosition(t);this.h=p.start(this.g,c,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const t=this.h.tick(),s=this.g.withScrollPosition(t);if(this.n(s,!0),!!this.h){if(t.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(t,s){const c=this.g;c.equals(t)||(this.g=t,this.j.fire(this.g.createScrollEvent(c,s)))}}e.$ws=D;class S{constructor(t,s,c){this.scrollLeft=t,this.scrollTop=s,this.isDone=c}}e.$xs=S;function b(f,t){const s=t-f;return function(c){return f+s*l(c)}}function $(f,t,s){return function(c){return c<s?f(c/s):t((c-s)/(1-s))}}class p{constructor(t,s,c,g){this.from=t,this.to=s,this.duration=g,this.startTime=c,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(t,s,c){if(Math.abs(t-s)>2.5*c){let u,w;return t<s?(u=t+.75*c,w=s-.75*c):(u=t-.75*c,w=s+.75*c),$(b(t,u),b(w,s),.33)}return b(t,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(t){this.to=t.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(t){const s=(t-this.startTime)/this.duration;if(s<1){const c=this.c(s),g=this.d(s);return new S(c,g,!1)}return new S(this.to.scrollLeft,this.to.scrollTop,!0)}combine(t,s,c){return p.start(t,s,c)}static start(t,s,c){c=c+10;const g=Date.now()-10;return new p(t,s,g,c)}}e.$ys=p;function O(f){return Math.pow(f,3)}function l(f){return 1-O(1-f)}}),define(me[88],$e([1,0,6,3]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function n(h){const m=h;return m?typeof m.read=="function":!1}e.$de=n;function W(h){const m=h;return m?[m.on,m.pause,m.resume,m.destroy].every(a=>typeof a=="function"):!1}e.$ee=W;function D(h){const m=h;return m?W(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.$fe=D;function S(h,m){return new b(h,m)}e.$ge=S;class b{constructor(m,a){this.e=m,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(a=>a(m))}h(m){this.c.error.length===0?(0,A.$1)(m):this.c.error.slice(0).forEach(a=>a(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,a){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(m,a){if(this.a.destroyed)return;let y;switch(m){case"data":y=this.c.data;break;case"end":y=this.c.end;break;case"error":y=this.c.error;break}if(y){const L=y.indexOf(a);L>=0&&y.splice(L,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(y=>y())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(h,m){const a=[];let y;for(;(y=h.read())!==null;)a.push(y);return m(a)}e.$he=$;function p(h,m,a){const y=[];let L;for(;(L=h.read())!==null&&y.length<a;)y.push(L);return L===null&&y.length>0?m(y):{read:()=>{if(y.length>0)return y.shift();if(typeof L<"u"){const R=L;return L=void 0,R}return h.read()}}}e.$ie=p;function O(h,m){return new Promise((a,y)=>{const L=[];l(h,{onData:R=>{m&&L.push(R)},onError:R=>{m?y(R):a(void 0)},onEnd:()=>{a(m?m(L):void 0)}})})}e.$je=O;function l(h,m,a){h.on("error",y=>{a?.isCancellationRequested||m.onError(y)}),h.on("end",()=>{a?.isCancellationRequested||m.onEnd()}),h.on("data",y=>{a?.isCancellationRequested||m.onData(y)})}e.$ke=l;function f(h,m){return new Promise((a,y)=>{const L=new N.$Sc,R=[],z=B=>{if(R.push(B),R.length>m)return L.dispose(),h.pause(),a({stream:h,buffer:R,ended:!1})},H=B=>(L.dispose(),y(B)),E=()=>(L.dispose(),a({stream:h,buffer:R,ended:!0}));L.add((0,N.$Rc)(()=>h.removeListener("error",H))),h.on("error",H),L.add((0,N.$Rc)(()=>h.removeListener("end",E))),h.on("end",E),L.add((0,N.$Rc)(()=>h.removeListener("data",z))),h.on("data",z)})}e.$le=f;function t(h,m){const a=S(m);return a.end(h),a}e.$me=t;function s(){const h=S(()=>{throw new Error("not supported")});return h.end(),h}e.$ne=s;function c(h){let m=!1;return{read:()=>m?null:(m=!0,h)}}e.$oe=c;function g(h,m,a){const y=S(a);return l(h,{onData:L=>y.write(m.data(L)),onError:L=>y.error(m.error?m.error(L):L),onEnd:()=>y.end()}),y}e.$pe=g;function u(h,m,a){let y=!1;return{read:()=>{const L=m.read();return y?L:(y=!0,L!==null?a([h,L]):h)}}}e.$qe=u;function w(h,m,a){let y=!1;const L=S(a);return l(m,{onData:R=>y?L.write(R):(y=!0,L.write(a([h,R]))),onError:R=>L.error(R),onEnd:()=>{y||(y=!0,L.write(h)),L.end()}}),L}e.$re=w}),define(me[35],$e([1,0,22,88]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const n=typeof Buffer<"u",W=new A.$V(()=>new Uint8Array(256));let D,S;class b{static alloc(M){return n?new b(Buffer.allocUnsafe(M)):new b(new Uint8Array(M))}static wrap(M){return n&&!Buffer.isBuffer(M)&&(M=Buffer.from(M.buffer,M.byteOffset,M.byteLength)),new b(M)}static fromString(M,I){return!(I?.dontUseNodeBuffer||!1)&&n?new b(Buffer.from(M)):(D||(D=new TextEncoder),new b(D.encode(M)))}static fromByteArray(M){const I=b.alloc(M.length);for(let x=0,X=M.length;x<X;x++)I.buffer[x]=M[x];return I}static concat(M,I){if(typeof I>"u"){I=0;for(let de=0,ue=M.length;de<ue;de++)I+=M[de].byteLength}const x=b.alloc(I);let X=0;for(let de=0,ue=M.length;de<ue;de++){const te=M[de];x.set(te,X),X+=te.byteLength}return x}constructor(M){this.buffer=M,this.byteLength=this.buffer.byteLength}clone(){const M=b.alloc(this.byteLength);return M.set(this),M}toString(){return n?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(M,I){return new b(this.buffer.subarray(M,I))}set(M,I){if(M instanceof b)this.buffer.set(M.buffer,I);else if(M instanceof Uint8Array)this.buffer.set(M,I);else if(M instanceof ArrayBuffer)this.buffer.set(new Uint8Array(M),I);else if(ArrayBuffer.isView(M))this.buffer.set(new Uint8Array(M.buffer,M.byteOffset,M.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(M){return l(this.buffer,M)}writeUInt32BE(M,I){f(this.buffer,M,I)}readUInt32LE(M){return t(this.buffer,M)}writeUInt32LE(M,I){s(this.buffer,M,I)}readUInt8(M){return c(this.buffer,M)}writeUInt8(M,I){g(this.buffer,M,I)}indexOf(M,I=0){return $(this.buffer,M instanceof b?M.buffer:M,I)}}e.$se=b;function $(F,M,I=0){const x=M.byteLength,X=F.byteLength;if(x===0)return 0;if(x===1)return F.indexOf(M[0]);if(x>X-I)return-1;const de=W.value;de.fill(M.length);for(let Le=0;Le<M.length;Le++)de[M[Le]]=M.length-Le-1;let ue=I+M.length-1,te=ue,ge=-1;for(;ue<X;)if(F[ue]===M[te]){if(te===0){ge=ue;break}ue--,te--}else ue+=Math.max(M.length-te,de[F[ue]]),te=M.length-1;return ge}e.$te=$;function p(F,M){return F[M+0]<<0>>>0|F[M+1]<<8>>>0}e.$ue=p;function O(F,M,I){F[I+0]=M&255,M=M>>>8,F[I+1]=M&255}e.$ve=O;function l(F,M){return F[M]*2**24+F[M+1]*2**16+F[M+2]*2**8+F[M+3]}e.$we=l;function f(F,M,I){F[I+3]=M,M=M>>>8,F[I+2]=M,M=M>>>8,F[I+1]=M,M=M>>>8,F[I]=M}e.$xe=f;function t(F,M){return F[M+0]<<0>>>0|F[M+1]<<8>>>0|F[M+2]<<16>>>0|F[M+3]<<24>>>0}e.$ye=t;function s(F,M,I){F[I+0]=M&255,M=M>>>8,F[I+1]=M&255,M=M>>>8,F[I+2]=M&255,M=M>>>8,F[I+3]=M&255}e.$ze=s;function c(F,M){return F[M]}e.$Ae=c;function g(F,M,I){F[I]=M}e.$Be=g;function u(F){return N.$he(F,M=>b.concat(M))}e.$Ce=u;function w(F){return N.$oe(F)}e.$De=w;function h(F){return N.$je(F,M=>b.concat(M))}e.$Ee=h;async function m(F){return F.ended?b.concat(F.buffer):b.concat([...F.buffer,await h(F.stream)])}e.$Fe=m;function a(F){return N.$me(F,M=>b.concat(M))}e.$Ge=a;function y(F){return N.$pe(F,{data:M=>typeof M=="string"?b.fromString(M):b.wrap(M)},M=>b.concat(M))}e.$He=y;function L(F){return N.$ge(M=>b.concat(M),F)}e.$Ie=L;function R(F,M){return N.$qe(F,M,I=>b.concat(I))}e.$Je=R;function z(F,M){return N.$re(F,M,I=>b.concat(I))}e.$Ke=z;function H(F){let M=0,I=0,x=0;const X=new Uint8Array(Math.floor(F.length/4*3)),de=te=>{switch(I){case 3:X[x++]=M|te,I=0;break;case 2:X[x++]=M|te>>>2,M=te<<6,I=3;break;case 1:X[x++]=M|te>>>4,M=te<<4,I=2;break;default:M=te<<2,I=1}};for(let te=0;te<F.length;te++){const ge=F.charCodeAt(te);if(ge>=65&&ge<=90)de(ge-65);else if(ge>=97&&ge<=122)de(ge-97+26);else if(ge>=48&&ge<=57)de(ge-48+52);else if(ge===43||ge===45)de(62);else if(ge===47||ge===95)de(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${F[te]}`)}}const ue=x;for(;I>0;)de(0);return b.wrap(X).slice(0,ue)}e.$Le=H;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function j({buffer:F},M=!0,I=!1){const x=I?B:E;let X="";const de=F.byteLength%3;let ue=0;for(;ue<F.byteLength-de;ue+=3){const te=F[ue+0],ge=F[ue+1],Le=F[ue+2];X+=x[te>>>2],X+=x[(te<<4|ge>>>4)&63],X+=x[(ge<<2|Le>>>6)&63],X+=x[Le&63]}if(de===1){const te=F[ue+0];X+=x[te>>>2],X+=x[te<<4&63],M&&(X+="==")}else if(de===2){const te=F[ue+0],ge=F[ue+1];X+=x[te>>>2],X+=x[(te<<4|ge>>>4)&63],X+=x[ge<<2&63],M&&(X+="=")}return X}e.$Me=j}),define(me[10],$e([1,0,87,22]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rf=e.$Qf=e.$Pf=e.$Of=e.GraphemeBreakType=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=void 0;function n(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.$Se=n;const W=/{(\d+)}/g;function D(G,...ne){return ne.length===0?G:G.replace(W,function(pe,Ee){const Re=parseInt(Ee,10);return isNaN(Re)||Re<0||Re>=ne.length?pe:ne[Re]})}e.$Te=D;const S=/{([^}]+)}/g;function b(G,ne){return Object.keys(ne).length===0?G:G.replace(S,(pe,Ee)=>ne[Ee]??pe)}e.$Ue=b;function $(G){return G.replace(/[<>"'&]/g,ne=>{switch(ne){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ne})}e.$Ve=$;function p(G){return G.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.$We=p;function O(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Xe=O;function l(G,ne){let pe=0;const Ee=ne.charCodeAt(0);for(let Re=G.length-1;Re>=0;Re--)G.charCodeAt(Re)===Ee&&pe++;return pe}e.$Ye=l;function f(G,ne,pe="\u2026"){return G.length<=ne?G:`${G.substr(0,ne)}${pe}`}e.$Ze=f;function t(G,ne,pe="\u2026"){if(G.length<=ne)return G;const Ee=Math.ceil(ne/2)-pe.length/2,Re=Math.floor(ne/2)-pe.length/2;return`${G.substr(0,Ee)}${pe}${G.substr(G.length-Re)}`}e.$1e=t;function s(G,ne=" "){const pe=c(G,ne);return g(pe,ne)}e.$2e=s;function c(G,ne){if(!G||!ne)return G;const pe=ne.length;if(pe===0||G.length===0)return G;let Ee=0;for(;G.indexOf(ne,Ee)===Ee;)Ee=Ee+pe;return G.substring(Ee)}e.$3e=c;function g(G,ne){if(!G||!ne)return G;const pe=ne.length,Ee=G.length;if(pe===0||Ee===0)return G;let Re=Ee,Ue=-1;for(;Ue=G.lastIndexOf(ne,Re-1),!(Ue===-1||Ue+pe!==Re);){if(Ue===0)return"";Re=Ue}return G.substring(0,Re)}e.$4e=g;function u(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$5e=u;function w(G){return G.replace(/\*/g,"")}e.$6e=w;function h(G,ne,pe={}){if(!G)throw new Error("Cannot create regex from empty string");ne||(G=O(G)),pe.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let Ee="";return pe.global&&(Ee+="g"),pe.matchCase||(Ee+="i"),pe.multiline&&(Ee+="m"),pe.unicode&&(Ee+="u"),new RegExp(G,Ee)}e.$7e=h;function m(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.$8e=m;function a(G){return G.split(/\r\n|\r|\n/)}e.$9e=a;function y(G){const ne=[],pe=G.split(/(\r\n|\r|\n)/);for(let Ee=0;Ee<Math.ceil(pe.length/2);Ee++)ne.push(pe[2*Ee]+(pe[2*Ee+1]??""));return ne}e.$0e=y;function L(G){for(let ne=0,pe=G.length;ne<pe;ne++){const Ee=G.charCodeAt(ne);if(Ee!==32&&Ee!==9)return ne}return-1}e.$$e=L;function R(G,ne=0,pe=G.length){for(let Ee=ne;Ee<pe;Ee++){const Re=G.charCodeAt(Ee);if(Re!==32&&Re!==9)return G.substring(ne,Ee)}return G.substring(ne,pe)}e.$_e=R;function z(G,ne=G.length-1){for(let pe=ne;pe>=0;pe--){const Ee=G.charCodeAt(pe);if(Ee!==32&&Ee!==9)return pe}return-1}e.$af=z;function H(G,ne,pe){const Ee=[];let Re=0;for(const Ue of G.matchAll(ne)){if(Ee.push(G.slice(Re,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Re=Ue.index+Ue[0].length,Ee.push(pe(Ue[0],...Ue.slice(1),Ue.index,G,Ue.groups))}return Ee.push(G.slice(Re)),Promise.all(Ee).then(Ue=>Ue.join(""))}e.$bf=H;function E(G,ne){return G<ne?-1:G>ne?1:0}e.$cf=E;function B(G,ne,pe=0,Ee=G.length,Re=0,Ue=ne.length){for(;pe<Ee&&Re<Ue;pe++,Re++){const tt=G.charCodeAt(pe),st=ne.charCodeAt(Re);if(tt<st)return-1;if(tt>st)return 1}const Ve=Ee-pe,Je=Ue-Re;return Ve<Je?-1:Ve>Je?1:0}e.$df=B;function j(G,ne){return F(G,ne,0,G.length,0,ne.length)}e.$ef=j;function F(G,ne,pe=0,Ee=G.length,Re=0,Ue=ne.length){for(;pe<Ee&&Re<Ue;pe++,Re++){let tt=G.charCodeAt(pe),st=ne.charCodeAt(Re);if(tt===st)continue;if(tt>=128||st>=128)return B(G.toLowerCase(),ne.toLowerCase(),pe,Ee,Re,Ue);I(tt)&&(tt-=32),I(st)&&(st-=32);const Ye=tt-st;if(Ye!==0)return Ye}const Ve=Ee-pe,Je=Ue-Re;return Ve<Je?-1:Ve>Je?1:0}e.$ff=F;function M(G){return G>=48&&G<=57}e.$gf=M;function I(G){return G>=97&&G<=122}e.$hf=I;function x(G){return G>=65&&G<=90}e.$if=x;function X(G,ne){return G.length===ne.length&&F(G,ne)===0}e.$jf=X;function de(G,ne){const pe=ne.length;return ne.length>G.length?!1:F(G,ne,0,pe)===0}e.$kf=de;function ue(G,ne){const pe=Math.min(G.length,ne.length);let Ee;for(Ee=0;Ee<pe;Ee++)if(G.charCodeAt(Ee)!==ne.charCodeAt(Ee))return Ee;return pe}e.$lf=ue;function te(G,ne){const pe=Math.min(G.length,ne.length);let Ee;const Re=G.length-1,Ue=ne.length-1;for(Ee=0;Ee<pe;Ee++)if(G.charCodeAt(Re-Ee)!==ne.charCodeAt(Ue-Ee))return Ee;return pe}e.$mf=te;function ge(G){return 55296<=G&&G<=56319}e.$nf=ge;function Le(G){return 56320<=G&&G<=57343}e.$of=Le;function Te(G,ne){return(G-55296<<10)+(ne-56320)+65536}e.$pf=Te;function Be(G,ne,pe){const Ee=G.charCodeAt(pe);if(ge(Ee)&&pe+1<ne){const Re=G.charCodeAt(pe+1);if(Le(Re))return Te(Ee,Re)}return Ee}e.$qf=Be;function le(G,ne){const pe=G.charCodeAt(ne-1);if(Le(pe)&&ne>1){const Ee=G.charCodeAt(ne-2);if(ge(Ee))return Te(Ee,pe)}return pe}class J{get offset(){return this.e}constructor(ne,pe=0){this.c=ne,this.d=ne.length,this.e=pe}setOffset(ne){this.e=ne}prevCodePoint(){const ne=le(this.c,this.e);return this.e-=ne>=65536?2:1,ne}nextCodePoint(){const ne=Be(this.c,this.d,this.e);return this.e+=ne>=65536?2:1,ne}eol(){return this.e>=this.d}}e.$rf=J;class ae{get offset(){return this.c.offset}constructor(ne,pe=0){this.c=new J(ne,pe)}nextGraphemeLength(){const ne=we.getInstance(),pe=this.c,Ee=pe.offset;let Re=ne.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ue=pe.offset,Ve=ne.getGraphemeBreakType(pe.nextCodePoint());if(ve(Re,Ve)){pe.setOffset(Ue);break}Re=Ve}return pe.offset-Ee}prevGraphemeLength(){const ne=we.getInstance(),pe=this.c,Ee=pe.offset;let Re=ne.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ue=pe.offset,Ve=ne.getGraphemeBreakType(pe.prevCodePoint());if(ve(Ve,Re)){pe.setOffset(Ue);break}Re=Ve}return Ee-pe.offset}eol(){return this.c.eol()}}e.$sf=ae;function re(G,ne){return new ae(G,ne).nextGraphemeLength()}e.$tf=re;function Y(G,ne){return new ae(G,ne).prevGraphemeLength()}e.$uf=Y;function Q(G,ne){ne>0&&Le(G.charCodeAt(ne))&&ne--;const pe=ne+re(G,ne);return[pe-Y(G,pe),pe]}e.$vf=Q;function ie(G){const ne=new ae(G);let pe=0;for(;!ne.eol();)pe++,ne.nextGraphemeLength();return pe}e.$wf=ie;let fe;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ce(G){return fe||(fe=ye()),fe.test(G)}e.$xf=Ce;const ke=/^[\t\n\r\x20-\x7E]*$/;function q(G){return ke.test(G)}e.$yf=q,e.$zf=/[\u2028\u2029]/;function d(G){return e.$zf.test(G)}e.$Af=d;function k(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.$Bf=k;function C(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.$Cf=C;function r(G,ne,pe=""){const Ee=G.trimStart();if(Ee.length<ne)return Ee;const Re=/\b/g;let Ue=0;for(;Re.test(Ee)&&!(Ee.length-Re.lastIndex<ne);)Ue=Re.lastIndex,Re.lastIndex+=1;return Ue===0?Ee:pe+Ee.substring(Ue).trimStart()}e.$Df=r;const i=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,o=/\x1b\].*?\x07/g;function v(G){return G&&(G=G.replace(i,"").replace(o,"")),G}e.$Ef=v,e.$Ff="\uFEFF";function P(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.$Gf=P;function T(G){return P(G)?G.substr(1):G}e.$Hf=T;function U(G,ne){if(!G||!ne||G.length<ne.length)return!1;const pe=ne.length,Ee=G.toLowerCase();let Re=0,Ue=-1;for(;Re<pe;){const Ve=Ee.indexOf(ne[Re],Ue+1);if(Ve<0)return!1;Ue=Ve,Re++}return!0}e.$If=U;function _(G,ne=!1){return G?(ne&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.$Jf=_;function Z(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.$Kf=Z;function oe(G,ne=1){if(ne===0)return"";let pe=-1;do pe=G.indexOf(`
`,pe+1),ne--;while(ne>0&&pe>=0);return pe===-1?G:(G[pe-1]==="\r"&&pe--,G.substr(0,pe))}e.$Lf=oe;function be(G){return G=G%(2*26),G<26?String.fromCharCode(97+G):String.fromCharCode(65+G-26)}e.$Mf=be;function De(G){return we.getInstance().getGraphemeBreakType(G)}e.$Nf=De;function ve(G,ne){return G===0?ne!==5&&ne!==7:G===2&&ne===3?!1:G===4||G===2||G===3||ne===4||ne===2||ne===3?!0:!(G===8&&(ne===8||ne===9||ne===11||ne===12)||(G===11||G===9)&&(ne===9||ne===10)||(G===12||G===10)&&ne===10||ne===5||ne===13||ne===7||G===1||G===13&&ne===14||G===6&&ne===6)}var Se;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Se||(e.GraphemeBreakType=Se={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=Ne()}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const pe=this.d,Ee=pe.length/3;let Re=1;for(;Re<=Ee;)if(ne<pe[3*Re])Re=2*Re;else if(ne>pe[3*Re+1])Re=2*Re+1;else return pe[3*Re+2];return 0}}function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(G,ne){if(G===0)return 0;const pe=Pe(G,ne);if(pe!==void 0)return pe;const Ee=new J(ne,G);return Ee.prevCodePoint(),Ee.offset}e.$Of=Me;function Pe(G,ne){const pe=new J(ne,G);let Ee=pe.prevCodePoint();for(;Xe(Ee)||Ee===65039||Ee===8419;){if(pe.offset===0)return;Ee=pe.prevCodePoint()}if(!C(Ee))return;let Re=pe.offset;return Re>0&&pe.prevCodePoint()===8205&&(Re=pe.offset),Re}function Xe(G){return 127995<=G&&G<=127999}var nt;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),e.$Pf="\xA0";class Qe{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new A.$Oe(ne=>{function pe(Ye){const rt=new Map;for(let et=0;et<Ye.length;et+=2)rt.set(Ye[et],Ye[et+1]);return rt}function Ee(Ye,rt){const et=new Map(Ye);for(const[gt,mt]of rt)et.set(gt,mt);return et}function Re(Ye,rt){if(!Ye)return rt;const et=new Map;for(const[gt,mt]of Ye)rt.has(gt)&&et.set(gt,mt);return et}const Ue=this.c.value;let Ve=ne.filter(Ye=>!Ye.startsWith("_")&&Ye in Ue);Ve.length===0&&(Ve=["_default"]);let Je;for(const Ye of Ve){const rt=pe(Ue[Ye]);Je=Re(Je,rt)}const tt=pe(Ue._common),st=Ee(tt,Je);return new Qe(st)})}static getInstance(ne){return Qe.d.get(Array.from(ne))}static{this.e=new N.$V(()=>Object.keys(Qe.c.value).filter(ne=>!ne.startsWith("_")))}static getLocales(){return Qe.e.value}constructor(ne){this.f=ne}isAmbiguous(ne){return this.f.has(ne)}getPrimaryConfusable(ne){return this.f.get(ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Qf=Qe;class Ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ze.c())),this.d}static isInvisibleCharacter(ne){return Ze.e().has(ne)}static get codePoints(){return Ze.e()}}e.$Rf=Ze}),define(me[36],$e([1,0,33,82,10]),function(se,e,A,N,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.FuzzyScore=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.or=void 0;function W(...T){return function(U,_){for(let Z=0,oe=T.length;Z<oe;Z++){const be=T[Z](U,_);if(be)return be}return null}}e.or=W,e.$5j=D.bind(void 0,!1),e.$6j=D.bind(void 0,!0);function D(T,U,_){if(!_||_.length<U.length)return null;let Z;return T?Z=n.$kf(_,U):Z=_.indexOf(U)===0,Z?U.length>0?[{start:0,end:U.length}]:[]:null}function S(T,U){const _=U.toLowerCase().indexOf(T.toLowerCase());return _===-1?null:[{start:_,end:_+T.length}]}e.$7j=S;function b(T,U){return $(T.toLowerCase(),U.toLowerCase(),0,0)}e.$8j=b;function $(T,U,_,Z){if(_===T.length)return[];if(Z===U.length)return null;if(T[_]===U[Z]){let oe=null;return(oe=$(T,U,_+1,Z+1))?h({start:Z,end:Z+1},oe):null}return $(T,U,_,Z+1)}function p(T){return 97<=T&&T<=122}function O(T){return 65<=T&&T<=90}e.$9j=O;function l(T){return 48<=T&&T<=57}function f(T){return T===32||T===9||T===10||T===13}const t=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(T=>t.add(T.charCodeAt(0)));function s(T){return f(T)||t.has(T)}function c(T,U){return T===U||s(T)&&s(U)}const g=new Map;function u(T){if(g.has(T))return g.get(T);let U;const _=(0,N.$3j)(T);return _&&(U=_),g.set(T,U),U}function w(T){return p(T)||O(T)||l(T)}function h(T,U){return U.length===0?U=[T]:T.end===U[0].start?U[0].start=T.start:U.unshift(T),U}function m(T,U){for(let _=U;_<T.length;_++){const Z=T.charCodeAt(_);if(O(Z)||l(Z)||_>0&&!w(T.charCodeAt(_-1)))return _}return T.length}function a(T,U,_,Z){if(_===T.length)return[];if(Z===U.length)return null;if(T[_]!==U[Z].toLowerCase())return null;{let oe=null,be=Z+1;for(oe=a(T,U,_+1,Z+1);!oe&&(be=m(U,be))<U.length;)oe=a(T,U,_+1,be),be++;return oe===null?null:h({start:Z,end:Z+1},oe)}}function y(T){let U=0,_=0,Z=0,oe=0,be=0;for(let Ne=0;Ne<T.length;Ne++)be=T.charCodeAt(Ne),O(be)&&U++,p(be)&&_++,w(be)&&Z++,l(be)&&oe++;const De=U/T.length,ve=_/T.length,Se=Z/T.length,we=oe/T.length;return{upperPercent:De,lowerPercent:ve,alphaPercent:Se,numericPercent:we}}function L(T){const{upperPercent:U,lowerPercent:_}=T;return _===0&&U>.6}function R(T){const{upperPercent:U,lowerPercent:_,alphaPercent:Z,numericPercent:oe}=T;return _>.2&&U<.8&&Z>.6&&oe<.2}function z(T){let U=0,_=0,Z=0,oe=0;for(let be=0;be<T.length;be++)Z=T.charCodeAt(be),O(Z)&&U++,p(Z)&&_++,f(Z)&&oe++;return(U===0||_===0)&&oe===0?T.length<=30:U<=5}function H(T,U){if(!U||(U=U.trim(),U.length===0)||!z(T))return null;U.length>60&&(U=U.substring(0,60));const _=y(U);if(!R(_)){if(!L(_))return null;U=U.toLowerCase()}let Z=null,oe=0;for(T=T.toLowerCase();oe<U.length&&(Z=a(T,U,0,oe))===null;)oe=m(U,oe+1);return Z}e.$0j=H;function E(T,U,_=!1){if(!U||U.length===0)return null;let Z=null,oe=0;for(T=T.toLowerCase(),U=U.toLowerCase();oe<U.length&&(Z=B(T,U,0,oe,_),Z===null);)oe=j(U,oe+1);return Z}e.$$j=E;function B(T,U,_,Z,oe){let be=0;if(_===T.length)return[];if(Z===U.length)return null;if(!c(T.charCodeAt(_),U.charCodeAt(Z))){const Se=u(T.charCodeAt(_));if(!Se)return null;for(let we=0;we<Se.length;we++)if(!c(Se[we],U.charCodeAt(Z+we)))return null;be+=Se.length-1}let De=null,ve=Z+be+1;if(De=B(T,U,_+1,ve,oe),!oe)for(;!De&&(ve=j(U,ve))<U.length;)De=B(T,U,_+1,ve,oe),ve++;if(!De)return null;if(T.charCodeAt(_)!==U.charCodeAt(Z)){const Se=u(T.charCodeAt(_));if(!Se)return De;for(let we=0;we<Se.length;we++)if(Se[we]!==U.charCodeAt(Z+we))return De}return h({start:Z,end:Z+be+1},De)}function j(T,U){for(let _=U;_<T.length;_++)if(s(T.charCodeAt(_))||_>0&&s(T.charCodeAt(_-1)))return _;return T.length}const F=W(e.$6j,H,S),M=W(e.$6j,H,b),I=new A.$Dc(1e4);function x(T,U,_=!1){if(typeof T!="string"||typeof U!="string")return null;let Z=I.get(T);Z||(Z=new RegExp(n.$5e(T),"i"),I.set(T,Z));const oe=Z.exec(U);return oe?[{start:oe.index,end:oe.index+oe[0].length}]:_?M(T,U):F(T,U)}e.$_j=x;function X(T,U){const _=k(T,T.toLowerCase(),0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?ue(_):null}e.$ak=X;function de(T,U,_,Z,oe,be){const De=Math.min(13,T.length);for(;_<De;_++){const ve=k(T,U,_,Z,oe,be,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ve)return ve}return[0,be]}e.$bk=de;function ue(T){if(typeof T>"u")return[];const U=[],_=T[1];for(let Z=T.length-1;Z>1;Z--){const oe=T[Z]+_,be=U[U.length-1];be&&be.end===oe?be.end=oe+1:U.push({start:oe,end:oe+1})}return U}e.$ck=ue;const te=128;function ge(){const T=[],U=[];for(let _=0;_<=te;_++)U[_]=0;for(let _=0;_<=te;_++)T.push(U.slice(0));return T}function Le(T){const U=[];for(let _=0;_<=T;_++)U[_]=0;return U}const Te=Le(2*te),Be=Le(2*te),le=ge(),J=ge(),ae=ge(),re=!1;function Y(T,U,_,Z,oe){function be(ve,Se,we=" "){for(;ve.length<Se;)ve=we+ve;return ve}let De=` |   |${Z.split("").map(ve=>be(ve,3)).join("|")}
`;for(let ve=0;ve<=_;ve++)ve===0?De+=" |":De+=`${U[ve-1]}|`,De+=T[ve].slice(0,oe+1).map(Se=>be(Se.toString(),3)).join("|")+`
`;return De}function Q(T,U,_,Z){T=T.substr(U),_=_.substr(Z),console.log(Y(J,T,T.length,_,_.length)),console.log(Y(ae,T,T.length,_,_.length)),console.log(Y(le,T,T.length,_,_.length))}function ie(T,U){if(U<0||U>=T.length)return!1;const _=T.codePointAt(U);switch(_){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!n.$Cf(_)}}function fe(T,U){if(U<0||U>=T.length)return!1;switch(T.charCodeAt(U)){case 32:case 9:return!0;default:return!1}}function ye(T,U,_){return U[T]!==_[T]}function Ce(T,U,_,Z,oe,be,De=!1){for(;U<_&&oe<be;)T[U]===Z[oe]&&(De&&(Te[U]=oe),U+=1),oe+=1;return U===_}e.$dk=Ce;var ke;(function(T){T[T.Diag=1]="Diag",T[T.Left=2]="Left",T[T.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var q;(function(T){T.Default=[-100,0];function U(_){return!_||_.length===2&&_[0]===-100&&_[1]===0}T.isDefault=U})(q||(e.FuzzyScore=q={}));class d{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(U,_){this.firstMatchCanBeWeak=U,this.boostFullMatch=_}}e.$ek=d;function k(T,U,_,Z,oe,be,De=d.default){const ve=T.length>te?te:T.length,Se=Z.length>te?te:Z.length;if(_>=ve||be>=Se||ve-_>Se-be||!Ce(U,_,ve,oe,be,Se,!0))return;C(ve,Se,_,be,U,oe);let we=1,Ne=1,Me=_,Pe=be;const Xe=[!1];for(we=1,Me=_;Me<ve;we++,Me++){const ne=Te[Me],pe=Be[Me],Ee=Me+1<ve?Be[Me+1]:Se;for(Ne=ne-be+1,Pe=ne;Pe<Ee;Ne++,Pe++){let Re=Number.MIN_SAFE_INTEGER,Ue=!1;Pe<=pe&&(Re=r(T,U,Me,_,Z,oe,Pe,Se,be,le[we-1][Ne-1]===0,Xe));let Ve=0;Re!==Number.MAX_SAFE_INTEGER&&(Ue=!0,Ve=Re+J[we-1][Ne-1]);const Je=Pe>ne,tt=Je?J[we][Ne-1]+(le[we][Ne-1]>0?-5:0):0,st=Pe>ne+1&&le[we][Ne-1]>0,Ye=st?J[we][Ne-2]+(le[we][Ne-2]>0?-5:0):0;if(st&&(!Je||Ye>=tt)&&(!Ue||Ye>=Ve))J[we][Ne]=Ye,ae[we][Ne]=3,le[we][Ne]=0;else if(Je&&(!Ue||tt>=Ve))J[we][Ne]=tt,ae[we][Ne]=2,le[we][Ne]=0;else if(Ue)J[we][Ne]=Ve,ae[we][Ne]=1,le[we][Ne]=le[we-1][Ne-1]+1;else throw new Error("not possible")}}if(re&&Q(T,_,Z,be),!Xe[0]&&!De.firstMatchCanBeWeak)return;we--,Ne--;const nt=[J[we][Ne],be];let Qe=0,Ze=0;for(;we>=1;){let ne=Ne;do{const pe=ae[we][ne];if(pe===3)ne=ne-2;else if(pe===2)ne=ne-1;else break}while(ne>=1);Qe>1&&U[_+we-1]===oe[be+Ne-1]&&!ye(ne+be-1,Z,oe)&&Qe+1>le[we][ne]&&(ne=Ne),ne===Ne?Qe++:Qe=1,Ze||(Ze=ne),we--,Ne=ne-1,nt.push(Ne)}Se===ve&&De.boostFullMatch&&(nt[0]+=2);const G=Ze-ve;return nt[0]-=G,nt}e.$fk=k;function C(T,U,_,Z,oe,be){let De=T-1,ve=U-1;for(;De>=_&&ve>=Z;)oe[De]===be[ve]&&(Be[De]=ve,De--),ve--}function r(T,U,_,Z,oe,be,De,ve,Se,we,Ne){if(U[_]!==be[De])return Number.MIN_SAFE_INTEGER;let Me=1,Pe=!1;return De===_-Z?Me=T[_]===oe[De]?7:5:ye(De,oe,be)&&(De===0||!ye(De-1,oe,be))?(Me=T[_]===oe[De]?7:5,Pe=!0):ie(be,De)&&(De===0||!ie(be,De-1))?Me=5:(ie(be,De-1)||fe(be,De-1))&&(Me=5,Pe=!0),Me>1&&_===Z&&(Ne[0]=!0),Pe||(Pe=ye(De,oe,be)||ie(be,De-1)||fe(be,De-1)),_===Z?De>Se&&(Me-=Pe?3:5):we?Me+=Pe?2:0:Me+=Pe?0:1,De+1===ve&&(Me-=Pe?3:5),Me}function i(T,U,_,Z,oe,be,De){return v(T,U,_,Z,oe,be,!0,De)}e.$gk=i;function o(T,U,_,Z,oe,be,De){return v(T,U,_,Z,oe,be,!1,De)}e.$hk=o;function v(T,U,_,Z,oe,be,De,ve){let Se=k(T,U,_,Z,oe,be,ve);if(Se&&!De)return Se;if(T.length>=3){const we=Math.min(7,T.length-1);for(let Ne=_+1;Ne<we;Ne++){const Me=P(T,Ne);if(Me){const Pe=k(Me,Me.toLowerCase(),_,Z,oe,be,ve);Pe&&(Pe[0]-=3,(!Se||Pe[0]>Se[0])&&(Se=Pe))}}}return Se}function P(T,U){if(U+1>=T.length)return;const _=T[U],Z=T[U+1];if(_!==Z)return T.slice(0,U)+Z+_+T.slice(U+2)}}),define(me[51],$e([1,0,10]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=void 0;function N(g){return n(g,0)}e.$5i=N;function n(g,u){switch(typeof g){case"object":return g===null?W(349,u):Array.isArray(g)?b(g,u):$(g,u);case"string":return S(g,u);case"boolean":return D(g,u);case"number":return W(g,u);case"undefined":return W(937,u);default:return W(617,u)}}e.$6i=n;function W(g,u){return(u<<5)-u+g|0}e.$7i=W;function D(g,u){return W(g?433:863,u)}function S(g,u){u=W(149417,u);for(let w=0,h=g.length;w<h;w++)u=W(g.charCodeAt(w),u);return u}e.$8i=S;function b(g,u){return u=W(104579,u),g.reduce((w,h)=>n(h,w),u)}function $(g,u){return u=W(181387,u),Object.keys(g).sort().reduce((w,h)=>(w=S(h,w),n(g[h],w)),u)}class p{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=n(u,this.g),this.g}}e.$9i=p;var O;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function l(g,u,w=32){const h=w-u,m=~((1<<h)-1);return(g<<u|(m&g)>>>h)>>>0}function f(g,u=0,w=g.byteLength,h=0){for(let m=0;m<w;m++)g[u+m]=h}function t(g,u,w="0"){for(;g.length<u;)g=w+g;return g}function s(g,u=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(w=>w.toString(16).padStart(2,"0")).join(""):t((g>>>0).toString(16),u/4)}e.$0i=s;class c{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const w=u.length;if(w===0)return;const h=this.p;let m=this.r,a=this.u,y,L;for(a!==0?(y=a,L=-1,a=0):(y=u.charCodeAt(0),L=0);;){let R=y;if(A.$nf(y))if(L+1<w){const z=u.charCodeAt(L+1);A.$of(z)?(L++,R=A.$pf(y,z)):R=65533}else{a=y;break}else A.$of(y)&&(R=65533);if(m=this.w(h,m,R),L++,L<w)y=u.charCodeAt(L);else break}this.r=m,this.u=a}w(u,w,h){return h<128?u[w++]=h:h<2048?(u[w++]=192|(h&1984)>>>6,u[w++]=128|(h&63)>>>0):h<65536?(u[w++]=224|(h&61440)>>>12,u[w++]=128|(h&4032)>>>6,u[w++]=128|(h&63)>>>0):(u[w++]=240|(h&1835008)>>>18,u[w++]=128|(h&258048)>>>12,u[w++]=128|(h&4032)>>>6,u[w++]=128|(h&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=c.g,w=this.q;for(let E=0;E<64;E+=4)u.setUint32(E,w.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)u.setUint32(E,l(u.getUint32(E-12,!1)^u.getUint32(E-32,!1)^u.getUint32(E-56,!1)^u.getUint32(E-64,!1),1),!1);let h=this.h,m=this.l,a=this.m,y=this.n,L=this.o,R,z,H;for(let E=0;E<80;E++)E<20?(R=m&a|~m&y,z=1518500249):E<40?(R=m^a^y,z=1859775393):E<60?(R=m&a|m&y|a&y,z=2400959708):(R=m^a^y,z=3395469782),H=l(h,5)+R+L+z+u.getUint32(E*4,!1)&4294967295,L=y,y=a,a=l(m,30),m=h,h=H;this.h=this.h+h&4294967295,this.l=this.l+m&4294967295,this.m=this.m+a&4294967295,this.n=this.n+y&4294967295,this.o=this.o+L&4294967295}}e.$$i=c}),define(me[89],$e([1,0,77,51]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.$$s=e.$0s=void 0;class n{constructor(l){this.a=l}getElements(){const l=this.a,f=new Int32Array(l.length);for(let t=0,s=l.length;t<s;t++)f[t]=l.charCodeAt(t);return f}}e.$0s=n;function W(O,l,f){return new p(new n(O),new n(l)).ComputeDiff(f).changes}e.$$s=W;class D{static Assert(l,f){if(!l)throw new Error(f)}}class S{static Copy(l,f,t,s,c){for(let g=0;g<c;g++)t[s+g]=l[f+g]}static Copy2(l,f,t,s,c){for(let g=0;g<c;g++)t[s+g]=l[f+g]}}var b;(function(O){O[O.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(b||(b={}));class ${constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new A.$9s(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(l,f){this.b=Math.min(this.b,l),this.c=Math.min(this.c,f),this.d++}AddModifiedElement(l,f){this.b=Math.min(this.b,l),this.c=Math.min(this.c,f),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class p{constructor(l,f,t=null){this.a=t,this.b=l,this.c=f;const[s,c,g]=p.o(l),[u,w,h]=p.o(f);this.d=g&&h,this.e=s,this.f=c,this.g=u,this.h=w,this.k=[],this.m=[]}static n(l){return l.length>0&&typeof l[0]=="string"}static o(l){const f=l.getElements();if(p.n(f)){const t=new Int32Array(f.length);for(let s=0,c=f.length;s<c;s++)t[s]=(0,N.$8i)(f[s],0);return[f,t,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}p(l,f){return this.f[l]!==this.h[f]?!1:this.d?this.e[l]===this.g[f]:!0}q(l,f){if(!this.p(l,f))return!1;const t=p.r(this.b,l),s=p.r(this.c,f);return t===s}static r(l,f){return typeof l.getStrictElement=="function"?l.getStrictElement(f):null}s(l,f){return this.f[l]!==this.f[f]?!1:this.d?this.e[l]===this.e[f]:!0}u(l,f){return this.h[l]!==this.h[f]?!1:this.d?this.g[l]===this.g[f]:!0}ComputeDiff(l){return this.v(0,this.f.length-1,0,this.h.length-1,l)}v(l,f,t,s,c){const g=[!1];let u=this.w(l,f,t,s,g);return c&&(u=this.z(u)),{quitEarly:g[0],changes:u}}w(l,f,t,s,c){for(c[0]=!1;l<=f&&t<=s&&this.p(l,t);)l++,t++;for(;f>=l&&s>=t&&this.p(f,s);)f--,s--;if(l>f||t>s){let a;return t<=s?(D.Assert(l===f+1,"originalStart should only be one more than originalEnd"),a=[new A.$9s(l,0,t,s-t+1)]):l<=f?(D.Assert(t===s+1,"modifiedStart should only be one more than modifiedEnd"),a=[new A.$9s(l,f-l+1,t,0)]):(D.Assert(l===f+1,"originalStart should only be one more than originalEnd"),D.Assert(t===s+1,"modifiedStart should only be one more than modifiedEnd"),a=[]),a}const g=[0],u=[0],w=this.y(l,f,t,s,g,u,c),h=g[0],m=u[0];if(w!==null)return w;if(!c[0]){const a=this.w(l,h,t,m,c);let y=[];return c[0]?y=[new A.$9s(h+1,f-(h+1)+1,m+1,s-(m+1)+1)]:y=this.w(h+1,f,m+1,s,c),this.H(a,y)}return[new A.$9s(l,f-l+1,t,s-t+1)]}x(l,f,t,s,c,g,u,w,h,m,a,y,L,R,z,H,E,B){let j=null,F=null,M=new $,I=f,x=t,X=L[0]-H[0]-s,de=-1073741824,ue=this.k.length-1;do{const te=X+l;te===I||te<x&&h[te-1]<h[te+1]?(a=h[te+1],R=a-X-s,a<de&&M.MarkNextChange(),de=a,M.AddModifiedElement(a+1,R),X=te+1-l):(a=h[te-1]+1,R=a-X-s,a<de&&M.MarkNextChange(),de=a-1,M.AddOriginalElement(a,R+1),X=te-1-l),ue>=0&&(h=this.k[ue],l=h[0],I=1,x=h.length-1)}while(--ue>=-1);if(j=M.getReverseChanges(),B[0]){let te=L[0]+1,ge=H[0]+1;if(j!==null&&j.length>0){const Le=j[j.length-1];te=Math.max(te,Le.getOriginalEnd()),ge=Math.max(ge,Le.getModifiedEnd())}F=[new A.$9s(te,y-te+1,ge,z-ge+1)]}else{M=new $,I=g,x=u,X=L[0]-H[0]-w,de=1073741824,ue=E?this.m.length-1:this.m.length-2;do{const te=X+c;te===I||te<x&&m[te-1]>=m[te+1]?(a=m[te+1]-1,R=a-X-w,a>de&&M.MarkNextChange(),de=a+1,M.AddOriginalElement(a+1,R+1),X=te+1-c):(a=m[te-1],R=a-X-w,a>de&&M.MarkNextChange(),de=a,M.AddModifiedElement(a+1,R+1),X=te-1-c),ue>=0&&(m=this.m[ue],c=m[0],I=1,x=m.length-1)}while(--ue>=-1);F=M.getChanges()}return this.H(j,F)}y(l,f,t,s,c,g,u){let w=0,h=0,m=0,a=0,y=0,L=0;l--,t--,c[0]=0,g[0]=0,this.k=[],this.m=[];const R=f-l+(s-t),z=R+1,H=new Int32Array(z),E=new Int32Array(z),B=s-t,j=f-l,F=l-t,M=f-s,x=(j-B)%2===0;H[B]=l,E[j]=f,u[0]=!1;for(let X=1;X<=R/2+1;X++){let de=0,ue=0;m=this.J(B-X,X,B,z),a=this.J(B+X,X,B,z);for(let ge=m;ge<=a;ge+=2){ge===m||ge<a&&H[ge-1]<H[ge+1]?w=H[ge+1]:w=H[ge-1]+1,h=w-(ge-B)-F;const Le=w;for(;w<f&&h<s&&this.p(w+1,h+1);)w++,h++;if(H[ge]=w,w+h>de+ue&&(de=w,ue=h),!x&&Math.abs(ge-j)<=X-1&&w>=E[ge])return c[0]=w,g[0]=h,Le<=E[ge]&&1447>0&&X<=1448?this.x(B,m,a,F,j,y,L,M,H,E,w,f,c,h,s,g,x,u):null}const te=(de-l+(ue-t)-X)/2;if(this.a!==null&&!this.a(de,te))return u[0]=!0,c[0]=de,g[0]=ue,te>0&&1447>0&&X<=1448?this.x(B,m,a,F,j,y,L,M,H,E,w,f,c,h,s,g,x,u):(l++,t++,[new A.$9s(l,f-l+1,t,s-t+1)]);y=this.J(j-X,X,j,z),L=this.J(j+X,X,j,z);for(let ge=y;ge<=L;ge+=2){ge===y||ge<L&&E[ge-1]>=E[ge+1]?w=E[ge+1]-1:w=E[ge-1],h=w-(ge-j)-M;const Le=w;for(;w>l&&h>t&&this.p(w,h);)w--,h--;if(E[ge]=w,x&&Math.abs(ge-B)<=X&&w<=H[ge])return c[0]=w,g[0]=h,Le>=H[ge]&&1447>0&&X<=1448?this.x(B,m,a,F,j,y,L,M,H,E,w,f,c,h,s,g,x,u):null}if(X<=1447){let ge=new Int32Array(a-m+2);ge[0]=B-m+1,S.Copy2(H,m,ge,1,a-m+1),this.k.push(ge),ge=new Int32Array(L-y+2),ge[0]=j-y+1,S.Copy2(E,y,ge,1,L-y+1),this.m.push(ge)}}return this.x(B,m,a,F,j,y,L,M,H,E,w,f,c,h,s,g,x,u)}z(l){for(let f=0;f<l.length;f++){const t=l[f],s=f<l.length-1?l[f+1].originalStart:this.f.length,c=f<l.length-1?l[f+1].modifiedStart:this.h.length,g=t.originalLength>0,u=t.modifiedLength>0;for(;t.originalStart+t.originalLength<s&&t.modifiedStart+t.modifiedLength<c&&(!g||this.s(t.originalStart,t.originalStart+t.originalLength))&&(!u||this.u(t.modifiedStart,t.modifiedStart+t.modifiedLength));){const h=this.q(t.originalStart,t.modifiedStart);if(this.q(t.originalStart+t.originalLength,t.modifiedStart+t.modifiedLength)&&!h)break;t.originalStart++,t.modifiedStart++}const w=[null];if(f<l.length-1&&this.I(l[f],l[f+1],w)){l[f]=w[0],l.splice(f+1,1),f--;continue}}for(let f=l.length-1;f>=0;f--){const t=l[f];let s=0,c=0;if(f>0){const a=l[f-1];s=a.originalStart+a.originalLength,c=a.modifiedStart+a.modifiedLength}const g=t.originalLength>0,u=t.modifiedLength>0;let w=0,h=this.G(t.originalStart,t.originalLength,t.modifiedStart,t.modifiedLength);for(let a=1;;a++){const y=t.originalStart-a,L=t.modifiedStart-a;if(y<s||L<c||g&&!this.s(y,y+t.originalLength)||u&&!this.u(L,L+t.modifiedLength))break;const z=(y===s&&L===c?5:0)+this.G(y,t.originalLength,L,t.modifiedLength);z>h&&(h=z,w=a)}t.originalStart-=w,t.modifiedStart-=w;const m=[null];if(f>0&&this.I(l[f-1],l[f],m)){l[f-1]=m[0],l.splice(f,1),f++;continue}}if(this.d)for(let f=1,t=l.length;f<t;f++){const s=l[f-1],c=l[f],g=c.originalStart-s.originalStart-s.originalLength,u=s.originalStart,w=c.originalStart+c.originalLength,h=w-u,m=s.modifiedStart,a=c.modifiedStart+c.modifiedLength,y=a-m;if(g<5&&h<20&&y<20){const L=this.A(u,h,m,y,g);if(L){const[R,z]=L;(R!==s.originalStart+s.originalLength||z!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=R-s.originalStart,s.modifiedLength=z-s.modifiedStart,c.originalStart=R+g,c.modifiedStart=z+g,c.originalLength=w-c.originalStart,c.modifiedLength=a-c.modifiedStart)}}}return l}A(l,f,t,s,c){if(f<c||s<c)return null;const g=l+f-c+1,u=t+s-c+1;let w=0,h=0,m=0;for(let a=l;a<g;a++)for(let y=t;y<u;y++){const L=this.B(a,y,c);L>0&&L>w&&(w=L,h=a,m=y)}return w>0?[h,m]:null}B(l,f,t){let s=0;for(let c=0;c<t;c++){if(!this.p(l+c,f+c))return 0;s+=this.e[l+c].length}return s}C(l){return l<=0||l>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[l])}D(l,f){if(this.C(l)||this.C(l-1))return!0;if(f>0){const t=l+f;if(this.C(t-1)||this.C(t))return!0}return!1}E(l){return l<=0||l>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[l])}F(l,f){if(this.E(l)||this.E(l-1))return!0;if(f>0){const t=l+f;if(this.E(t-1)||this.E(t))return!0}return!1}G(l,f,t,s){const c=this.D(l,f)?1:0,g=this.F(t,s)?1:0;return c+g}H(l,f){const t=[];if(l.length===0||f.length===0)return f.length>0?f:l;if(this.I(l[l.length-1],f[0],t)){const s=new Array(l.length+f.length-1);return S.Copy(l,0,s,0,l.length-1),s[l.length-1]=t[0],S.Copy(f,1,s,l.length,f.length-1),s}else{const s=new Array(l.length+f.length);return S.Copy(l,0,s,0,l.length),S.Copy(f,0,s,l.length,f.length),s}}I(l,f,t){if(D.Assert(l.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),D.Assert(l.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),l.originalStart+l.originalLength>=f.originalStart||l.modifiedStart+l.modifiedLength>=f.modifiedStart){const s=l.originalStart;let c=l.originalLength;const g=l.modifiedStart;let u=l.modifiedLength;return l.originalStart+l.originalLength>=f.originalStart&&(c=f.originalStart+f.originalLength-l.originalStart),l.modifiedStart+l.modifiedLength>=f.modifiedStart&&(u=f.modifiedStart+f.modifiedLength-l.modifiedStart),t[0]=new A.$9s(s,c,g,u),!0}else return t[0]=null,!1}J(l,f,t,s){if(l>=0&&l<s)return l;const c=t,g=s-t-1,u=f%2===0;if(l<0){const w=c%2===0;return u===w?0:1}else{const w=g%2===0;return u===w?s-1:s-2}}}e.$_s=p}),define(me[52],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0,e.$2d=Symbol("MicrotaskDelay")}),define(me[90],$e([1,0,12,10]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;class n{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const t=f.charCodeAt(0),s=this.b.charCodeAt(this.c);return t-s}value(){return this.b[this.c]}}e.$gi=n;class W{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,N.$df)(f,this.b,0,f.length,this.c,this.d):(0,N.$ff)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$hi=W;class D{constructor(f=!0,t=!0){this.f=f,this.g=t}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let t=f.length-1;t>=0;t--,this.c--){const s=this.b.charCodeAt(t);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const t=this.b.charCodeAt(this.e);if(t===47||this.f&&t===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,N.$df)(f,this.b,0,f.length,this.d,this.e):(0,N.$ff)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ii=D;var S;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(S||(S={}));class b{constructor(f,t){this.f=f,this.g=t,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,N.$ef)(f,this.c.scheme);if(this.d[this.e]===2)return(0,N.$ef)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,N.$cf)(f,this.c.query);if(this.d[this.e]===5)return(0,N.$cf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ji=b;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(p||(p={}));class O{static forUris(f=()=>!1,t=()=>!1){return new O(new b(f,t))}static forPaths(f=!1){return new O(new D(void 0,!f))}static forStrings(){return new O(new n)}static forConfigKeys(){return new O(new W)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,t){if(t){const s=t.slice(0);(0,A.$Xb)(s);for(const c of s)this.set(c,f)}else{const s=f.slice(0);(0,A.$Xb)(s);for(const c of s)this.set(c[0],c[1])}}set(f,t){const s=this.b.reset(f);let c;this.c||(this.c=new $,this.c.segment=s.value());const g=[];for(c=this.c;;){const w=s.cmp(c.segment);if(w>0)c.left||(c.left=new $,c.left.segment=s.value()),g.push([-1,c]),c=c.left;else if(w<0)c.right||(c.right=new $,c.right.segment=s.value()),g.push([1,c]),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new $,c.mid.segment=s.value()),g.push([0,c]),c=c.mid;else break}const u=c.value;c.value=t,c.key=f;for(let w=g.length-1;w>=0;w--){const h=g[w][1];h.updateHeight();const m=h.balanceFactor();if(m<-1||m>1){const a=g[w][0],y=g[w+1][0];if(a===1&&y===1)g[w][1]=h.rotateLeft();else if(a===-1&&y===-1)g[w][1]=h.rotateRight();else if(a===1&&y===-1)h.right=g[w+1][1]=g[w+1][1].rotateRight(),g[w][1]=h.rotateLeft();else if(a===-1&&y===1)h.left=g[w+1][1]=g[w+1][1].rotateLeft(),g[w][1]=h.rotateRight();else throw new Error;if(w>0)switch(g[w-1][0]){case-1:g[w-1][1].left=g[w][1];break;case 1:g[w-1][1].right=g[w][1];break;case 0:g[w-1][1].mid=g[w][1];break}else this.c=g[0][1]}}return u}get(f){return this.d(f)?.value}d(f){const t=this.b.reset(f);let s=this.c;for(;s;){const c=t.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(t.hasNext())t.next(),s=s.mid;else break}return s}has(f){const t=this.d(f);return!(t?.value===void 0&&t?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,t){const s=this.b.reset(f),c=[];let g=this.c;for(;g;){const u=s.cmp(g.segment);if(u>0)c.push([-1,g]),g=g.left;else if(u<0)c.push([1,g]),g=g.right;else if(s.hasNext())s.next(),c.push([0,g]),g=g.mid;else break}if(g){if(t?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const u=this.f(g.right);if(u.key){const{key:w,value:h,segment:m}=u;this.e(u.key,!1),g.key=w,g.value=h,g.segment=m}}else{const u=g.left??g.right;if(c.length>0){const[w,h]=c[c.length-1];switch(w){case-1:h.left=u;break;case 0:h.mid=u;break;case 1:h.right=u;break}}else this.c=u}for(let u=c.length-1;u>=0;u--){const w=c[u][1];w.updateHeight();const h=w.balanceFactor();if(h>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),c[u][1]=w.rotateLeft()):h<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),c[u][1]=w.rotateRight()),u>0)switch(c[u-1][0]){case-1:c[u-1][1].left=c[u][1];break;case 1:c[u-1][1].right=c[u][1];break;case 0:c[u-1][1].mid=c[u][1];break}else this.c=c[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const t=this.b.reset(f);let s=this.c,c;for(;s;){const g=t.cmp(s.segment);if(g>0)s=s.left;else if(g<0)s=s.right;else if(t.hasNext())t.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(f){return this.g(f,!1)}g(f,t){const s=this.b.reset(f);let c=this.c;for(;c;){const g=s.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this.h(c.mid):t?c.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[t,s]of this)f(s,t)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const t=[];return this.j(f,t),t[Symbol.iterator]()}j(f,t){f&&(f.left&&this.j(f.left,t),f.value&&t.push([f.key,f.value]),f.mid&&this.j(f.mid,t),f.right&&this.j(f.right,t))}_isBalanced(){const f=t=>{if(!t)return!0;const s=t.balanceFactor();return s<-1||s>1?!1:f(t.left)&&f(t.right)};return f(this.c)}}e.$ki=O}),define(me[7],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=void 0;function A(m){return typeof m=="string"}e.$Sf=A;function N(m){return Array.isArray(m)&&m.every(a=>A(a))}e.$Tf=N;function n(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.$Uf=n;function W(m){const a=Object.getPrototypeOf(Uint8Array);return typeof m=="object"&&m instanceof a}e.$Vf=W;function D(m){return typeof m=="number"&&!isNaN(m)}e.$Wf=D;function S(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.$Xf=S;function b(m){return m===!0||m===!1}e.$Yf=b;function $(m){return typeof m>"u"}e.$Zf=$;function p(m){return!O(m)}e.$1f=p;function O(m){return $(m)||m===null}e.$2f=O;function l(m,a){if(!m)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.$3f=l;function f(m){if(O(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.$4f=f;function t(...m){const a=[];for(let y=0;y<m.length;y++){const L=m[y];if(O(L))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);a.push(L)}return a}e.$5f=t;const s=Object.prototype.hasOwnProperty;function c(m){if(!n(m))return!1;for(const a in m)if(s.call(m,a))return!1;return!0}e.$6f=c;function g(m){return typeof m=="function"}e.$7f=g;function u(...m){return m.length>0&&m.every(g)}e.$8f=u;function w(m,a){const y=Math.min(m.length,a.length);for(let L=0;L<y;L++)h(m[L],a[L])}e.$9f=w;function h(m,a){if(A(a)){if(typeof m!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(g(a)){try{if(m instanceof a)return}catch{}if(!O(m)&&m.constructor===a||a.length===1&&a.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$0f=h}),define(me[17],$e([1,0,7]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=void 0;const N=Object.create(null);function n(S,b){if((0,A.$Sf)(b)){const $=N[b];if($===void 0)throw new Error(`${S} references an unknown codicon: ${b}`);b=$}return N[S]=b,{id:S}}function W(){return N}e.$ik=W;function D(){return Object.values(e.$kk)}e.$jk=D,e.$kk={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),gitPullRequestLabel:n("git-pull-request-label",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugBreakpointPending:n("debug-breakpoint-pending",60377),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),gitPullRequestMilestone:n("git-pull-request-milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),gitPullRequestReviewer:n("git-pull-request-reviewer",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),gitPullRequestAssignee:n("git-pull-request-assignee",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),mic:n("mic",60434),thumbsDownFilled:n("thumbsdown-filled",60435),thumbsUpFilled:n("thumbsup-filled",60436),coffee:n("coffee",60437),snake:n("snake",60438),game:n("game",60439),vr:n("vr",60440),chip:n("chip",60441),piano:n("piano",60442),music:n("music",60443),micFilled:n("mic-filled",60444),gitFetch:n("git-fetch",60445),copilot:n("copilot",60446),lightbulbSparkle:n("lightbulb-sparkle",60447),lightbulbSparkleAutofix:n("lightbulb-sparkle-autofix",60447),robot:n("robot",60448),sparkleFilled:n("sparkle-filled",60449),diffSingle:n("diff-single",60450),diffMultiple:n("diff-multiple",60451),surroundWith:n("surround-with",60452),gitStash:n("git-stash",60454),gitStashApply:n("git-stash-apply",60455),gitStashPop:n("git-stash-pop",60456),coverage:n("coverage",60462),runAllCoverage:n("run-all-coverage",60461),runCoverage:n("run-all-coverage",60460),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(me[53],$e([1,0,7]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function N(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const u=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([w,h])=>{u[w]=h&&typeof h=="object"?N(h):h}),u}e.$Hn=N;function n(g){if(!g||typeof g!="object")return g;const u=[g];for(;u.length>0;){const w=u.shift();Object.freeze(w);for(const h in w)if(W.call(w,h)){const m=w[h];typeof m=="object"&&!Object.isFrozen(m)&&!(0,A.$Vf)(m)&&u.push(m)}}return g}e.$In=n;const W=Object.prototype.hasOwnProperty;function D(g,u){return S(g,u,new Set)}e.$Jn=D;function S(g,u,w){if((0,A.$2f)(g))return g;const h=u(g);if(typeof h<"u")return h;if(Array.isArray(g)){const m=[];for(const a of g)m.push(S(a,u,w));return m}if((0,A.$Uf)(g)){if(w.has(g))throw new Error("Cannot clone recursive data-structure");w.add(g);const m={};for(const a in g)W.call(g,a)&&(m[a]=S(g[a],u,w));return w.delete(g),m}return g}function b(g,u,w=!0){return(0,A.$Uf)(g)?((0,A.$Uf)(u)&&Object.keys(u).forEach(h=>{h in g?w&&((0,A.$Uf)(g[h])&&(0,A.$Uf)(u[h])?b(g[h],u[h],w):g[h]=u[h]):g[h]=u[h]}),g):u}e.$Kn=b;function $(g,u){if(g===u)return!0;if(g==null||u===null||u===void 0||typeof g!=typeof u||typeof g!="object"||Array.isArray(g)!==Array.isArray(u))return!1;let w,h;if(Array.isArray(g)){if(g.length!==u.length)return!1;for(w=0;w<g.length;w++)if(!$(g[w],u[w]))return!1}else{const m=[];for(h in g)m.push(h);m.sort();const a=[];for(h in u)a.push(h);if(a.sort(),!$(m,a))return!1;for(w=0;w<m.length;w++)if(!$(g[m[w]],u[m[w]]))return!1}return!0}e.$Ln=$;function p(g){const u=new Set;return JSON.stringify(g,(w,h)=>{if((0,A.$Uf)(h)||Array.isArray(h)){if(u.has(h))return"[Circular]";u.add(h)}return h})}e.$Mn=p;function O(g,u){const w=Object.create(null);return!g||!u||Object.keys(u).forEach(m=>{const a=g[m],y=u[m];$(a,y)||(w[m]=y)}),w}e.$Nn=O;function l(g,u){const w=u.toLowerCase(),h=Object.keys(g).find(m=>m.toLowerCase()===w);return h?g[h]:g[u]}e.$On=l;function f(g,u){const w=Object.create(null);for(const[h,m]of Object.entries(g))u(h,m)&&(w[h]=m);return w}e.$Pn=f;function t(g){let u=[];for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}e.$Qn=t;function s(g){const u=[];for(const w of t(g))typeof g[w]=="function"&&u.push(w);return u}e.$Rn=s;function c(g,u){const w=m=>function(){const a=Array.prototype.slice.call(arguments,0);return u(m,a)},h={};for(const m of g)h[m]=w(m);return h}e.$Sn=c}),define(me[18],$e([1,0,17]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$lk=e.ThemeColor=void 0;var N;(function(D){function S(b){return b&&typeof b=="object"&&typeof b.id=="string"}D.isThemeColor=S})(N||(e.ThemeColor=N={}));function n(D){return{id:D}}e.$lk=n;var W;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function b(u){const w=S.exec(u.id);if(!w)return b(A.$kk.error);const[,h,m]=w,a=["codicon","codicon-"+h];return m&&a.push("codicon-modifier-"+m.substring(1)),a}D.asClassNameArray=b;function $(u){return b(u).join(" ")}D.asClassName=$;function p(u){return"."+b(u).join(".")}D.asCSSSelector=p;function O(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||N.isThemeColor(u.color))}D.isThemeIcon=O;const l=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function f(u){const w=l.exec(u);if(!w)return;const[,h]=w;return{id:h}}D.fromString=f;function t(u){return{id:u}}D.fromId=t;function s(u,w){let h=u.id;const m=h.lastIndexOf("~");return m!==-1&&(h=h.substring(0,m)),w&&(h=`${h}~${w}`),{id:h}}D.modify=s;function c(u){const w=u.id.lastIndexOf("~");if(w!==-1)return u.id.substring(w+1)}D.getModifier=c;function g(u,w){return u.id===w.id&&u.color?.id===w.color?.id}D.isEqual=g})(W||(e.ThemeIcon=W={}))}),define(me[37],$e([1,0,36,10,18]),function(se,e,A,N,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=void 0;const W="$(",D=new RegExp(`\\$\\(${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${D.source}`,"g");function b(g){return g.replace(S,(u,w)=>w?u:`\\${u}`)}e.$mk=b;const $=new RegExp(`\\\\${D.source}`,"g");function p(g){return g.replace($,u=>`\\${u}`)}e.$nk=p;const O=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function l(g){return g.indexOf(W)===-1?g:g.replace(O,(u,w,h,m)=>h?u:w||m||"")}e.$ok=l;function f(g){return g?g.replace(/\$\((.*?)\)/g,(u,w)=>` ${w} `).trim():""}e.$pk=f;const t=new RegExp(`\\$\\(${n.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(g){t.lastIndex=0;let u="";const w=[];let h=0;for(;;){const m=t.lastIndex,a=t.exec(g),y=g.substring(m,a?.index);if(y.length>0){u+=y;for(let L=0;L<y.length;L++)w.push(h)}if(!a)break;h+=a[0].length}return{text:u,iconOffsets:w}}e.$qk=s;function c(g,u,w=!1){const{text:h,iconOffsets:m}=u;if(!m||m.length===0)return(0,A.$_j)(g,h,w);const a=(0,N.$3e)(h," "),y=h.length-a.length,L=(0,A.$_j)(g,a,w);if(L)for(const R of L){const z=m[R.start+y]+y;R.start+=z,R.end+=z}return L}e.$rk=c}),define(me[91],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zV=e.$yV=void 0,e.$yV="vscode:contextmenu",e.$zV="vscode:onCloseContextMenu"}),define(me[92],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GV=void 0;class A{constructor(n,W){this.a=n,this.onMessage=W}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$GV=A}),define(me[31],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=e.$Q=e.$P=e.$O=void 0;const A=globalThis.vscode;e.$O=A.ipcRenderer,e.$P=A.ipcMessagePort,e.$Q=A.webFrame,e.$R=A.process,e.$S=A.context}),define(me[93],$e([1,0,91,31]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CV=void 0;let n=0;function W(S,b,$){const p=[],O=n++,l=`vscode:onContextMenu${O}`,f=(t,s,c)=>{p[s].click?.(c)};N.$O.once(l,f),N.$O.once(A.$zV,(t,s)=>{s===O&&(N.$O.removeListener(l,f),$?.())}),N.$O.send(A.$yV,O,S.map(t=>D(t,p)),l,b)}e.$CV=W;function D(S,b){const $={id:b.length,label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:typeof S.enabled=="boolean"?S.enabled:!0,visible:typeof S.visible=="boolean"?S.visible:!0};return b.push(S),Array.isArray(S.submenu)&&($.submenu=S.submenu.map(p=>D(p,b))),$}}),define(me[54],$e([8]),{}),define(me[94],$e([8]),{}),define(me[95],$e([8]),{}),define(me[96],$e([8]),{}),define(me[97],$e([1,0,95,96]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0})}),define(me[98],$e([8]),{}),define(me[99],$e([8]),{}),define(me[100],$e([8]),{}),define(me[101],$e([8]),{}),define(me[102],$e([8]),{}),define(me[103],$e([8]),{}),define(me[104],$e([8]),{}),define(me[105],$e([8]),{}),define(me[106],$e([8]),{}),define(me[107],$e([13,11]),function(se,e){return se.create("vs/base/browser/ui/actionbar/actionViewItems",e)}),define(me[108],$e([13,11]),function(se,e){return se.create("vs/base/browser/ui/findinput/findInput",e)}),define(me[109],$e([13,11]),function(se,e){return se.create("vs/base/browser/ui/findinput/findInputToggles",e)}),define(me[110],$e([13,11]),function(se,e){return se.create("vs/base/browser/ui/iconLabel/iconLabelHover",e)}),define(me[111],$e([13,11]),function(se,e){return se.create("vs/base/browser/ui/inputbox/inputBox",e)}),define(me[112],$e([13,11]),function(se,e){return se.create("vs/base/browser/ui/selectBox/selectBoxCustom",e)}),define(me[113],$e([13,11]),function(se,e){return se.create("vs/base/browser/ui/tree/abstractTree",e)}),define(me[114],$e([13,11]),function(se,e){return se.create("vs/base/common/actions",e)}),define(me[38],$e([1,0,4,3,114]),function(se,e,A,N,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;class W extends N.$Tc{constructor(l,f="",t="",s=!0,c){super(),this.h=this.B(new A.$5d),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=f,this.u=t,this.w=s,this.C=c}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,f){this.C&&await this.C(l)}}e.$Vi=W;class D extends N.$Tc{constructor(){super(...arguments),this.f=this.B(new A.$5d),this.onWillRun=this.f.event,this.m=this.B(new A.$5d),this.onDidRun=this.m.event}async run(l,f){if(!l.enabled)return;this.f.fire({action:l});let t;try{await this.u(l,f)}catch(s){t=s}this.m.fire({action:l,error:t})}async u(l,f){await l.run(f)}}e.$Wi=D;class S{constructor(){this.id=S.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let f=[];for(const t of l)t.length&&(f.length?f=[...f,new S,...t]:f=t);return f}static{this.ID="vs.actions.separator"}async run(){}}e.$Xi=S;class b{get actions(){return this.a}constructor(l,f,t,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=f,this.class=s,this.a=t}async run(){}}e.$Yi=b;class $ extends W{static{this.ID="vs.actions.empty"}constructor(){super($.ID,n.localize(0,null),void 0,!1)}}e.$Zi=$;function p(O){return{id:O.id,label:O.label,class:O.class,enabled:O.enabled??!0,checked:O.checked,run:async(...l)=>O.run(...l),tooltip:O.label}}e.$1i=p}),define(me[115],$e([13,11]),function(se,e){return se.create("vs/base/common/platform",e)}),define(me[5],$e([1,0,115]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let N=!1,n=!1,W=!1,D=!1,S=!1,b=!1,$=!1,p=!1,O=!1,l=!1,f,t=e.$g,s=e.$g,c,g;const u=globalThis;let w;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?w=u.vscode.process:typeof process<"u"&&(w=process);const h=typeof w?.versions?.electron=="string",m=h&&w?.type==="renderer";if(typeof w=="object"){N=w.platform==="win32",n=w.platform==="darwin",W=w.platform==="linux",D=W&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,$=h,O=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$g,t=e.$g;const F=w.env.VSCODE_NLS_CONFIG;if(F)try{const M=JSON.parse(F),I=M.availableLanguages["*"];f=M.locale,s=M.osLocale,t=I||e.$g,c=M._translationsConfigFile}catch{}S=!0}else typeof navigator=="object"&&!m?(g=navigator.userAgent,N=g.indexOf("Windows")>=0,n=g.indexOf("Macintosh")>=0,p=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=g.indexOf("Linux")>=0,l=g?.indexOf("Mobi")>=0,b=!0,f=A.getConfiguredDefaultLocale(A.localize(0,null))||e.$g,t=f,s=navigator.language):console.error("Unable to resolve platform.");var a;(function(F){F[F.Web=0]="Web",F[F.Mac=1]="Mac",F[F.Linux=2]="Linux",F[F.Windows=3]="Windows"})(a||(e.Platform=a={}));function y(F){switch(F){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=y;let L=0;n?L=1:N?L=3:W&&(L=2),e.$i=N,e.$j=n,e.$k=W,e.$l=D,e.$m=S,e.$n=$,e.$o=b,e.$p=b&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=p,e.$s=l,e.$t=O,e.$u=L,e.$v=g,e.$w=t;var R;(function(F){function M(){return e.$w}F.value=M;function I(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}F.isDefaultVariant=I;function x(){return e.$w==="en"}F.isDefault=x})(R||(e.Language=R={})),e.$x=f,e.$y=s,e.$z=c,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const F=[];u.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let x=0,X=F.length;x<X;x++){const de=F[x];if(de.id===I.data.vscodeScheduleAsyncWork){F.splice(x,1),de.callback();return}}});let M=0;return I=>{const x=++M;F.push({id:x,callback:I}),u.postMessage({vscodeScheduleAsyncWork:x},"*")}}return F=>setTimeout(F)})();var z;(function(F){F[F.Windows=1]="Windows",F[F.Macintosh=2]="Macintosh",F[F.Linux=3]="Linux"})(z||(e.OperatingSystem=z={})),e.OS=n||p?2:N?1:3;let H=!0,E=!1;function B(){if(!E){E=!0;const F=new Uint8Array(2);F[0]=1,F[1]=2,H=new Uint16Array(F.buffer)[0]===513}return H}e.$D=B,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function j(F){return parseFloat(F)>=20}e.$J=j}),define(me[116],$e([1,0,16,21,5]),function(se,e,A,N,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=e.KeyboardSupport=void 0;var W;(function(D){D[D.Always=0]="Always",D[D.FullScreen=1]="FullScreen",D[D.None=2]="None"})(W||(e.KeyboardSupport=W={})),e.$vQ={clipboard:{writeText:n.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:n.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:n.$m||A.$tQ()?0:navigator.keyboard||A.$pQ?1:2,touch:"ontouchstart"in N.$_P||navigator.maxTouchPoints>0,pointerEvents:N.$_P.PointerEvent&&("ontouchstart"in N.$_P||navigator.maxTouchPoints>0)}}),define(me[14],$e([1,0,16,47,80,5]),function(se,e,A,N,n,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=e.$CQ=e.$BQ=void 0;function D(t){if(t.charCode){const c=String.fromCharCode(t.charCode).toUpperCase();return N.KeyCodeUtils.fromString(c)}const s=t.keyCode;if(s===3)return 7;if(A.$mQ)switch(s){case 59:return 85;case 60:if(W.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(W.$j)return 57;break}else if(A.$nQ){if(W.$j&&s===93)return 57;if(!W.$j&&s===92)return 57}return N.$ar[s]||0}const S=W.$j?256:2048,b=512,$=1024,p=W.$j?2048:256;function O(t){const s=[];return t.ctrlKey&&s.push("ctrl"),t.shiftKey&&s.push("shift"),t.altKey&&s.push("alt"),t.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${t.code}, keyCode: ${t.keyCode}, key: ${t.key}`}e.$BQ=O;function l(t){const s=[];return t.ctrlKey&&s.push("ctrl"),t.shiftKey&&s.push("shift"),t.altKey&&s.push("alt"),t.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${t.code}, keyCode: ${t.keyCode} ('${N.KeyCodeUtils.toString(t.keyCode)}')`}e.$CQ=l;class f{constructor(s){this._standardKeyboardEventBrand=!0;const c=s;this.browserEvent=c,this.target=c.target,this.ctrlKey=c.ctrlKey,this.shiftKey=c.shiftKey,this.altKey=c.altKey,this.metaKey=c.metaKey,this.altGraphKey=c.getModifierState("AltGraph"),this.keyCode=D(c),this.code=c.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let c=0;return this.ctrlKey&&(c|=S),this.altKey&&(c|=b),this.shiftKey&&(c|=$),this.metaKey&&(c|=p),c|=s,c}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new n.$ir(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}e.$DQ=f}),define(me[19],$e([1,0,16,71,5]),function(se,e,A,N,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=e.$zQ=e.$yQ=void 0;class W{constructor($,p){this.timestamp=Date.now(),this.browserEvent=p,this.leftButton=p.button===0,this.middleButton=p.button===1,this.rightButton=p.button===2,this.buttons=p.buttons,this.target=p.target,this.detail=p.detail||1,p.type==="dblclick"&&(this.detail=2),this.ctrlKey=p.ctrlKey,this.shiftKey=p.shiftKey,this.altKey=p.altKey,this.metaKey=p.metaKey,typeof p.pageX=="number"?(this.posx=p.pageX,this.posy=p.pageY):(this.posx=p.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=p.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const O=N.$wQ.getPositionOfChildWindowRelativeToAncestorWindow($,p.view);this.posx-=O.left,this.posy-=O.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}e.$yQ=W;class D extends W{constructor($,p){super($,p),this.dataTransfer=p.dataTransfer}}e.$zQ=D;class S{constructor($,p=0,O=0){this.browserEvent=$||null,this.target=$?$.target||$.targetNode||$.srcElement:null,this.deltaY=O,this.deltaX=p;let l=!1;if(A.$oQ){const f=navigator.userAgent.match(/Chrome\/(\d+)/);l=(f?parseInt(f[1]):123)<=122}if($){const f=$,t=$,s=$.view?.devicePixelRatio||1;if(typeof f.wheelDeltaY<"u")l?this.deltaY=f.wheelDeltaY/(120*s):this.deltaY=f.wheelDeltaY/120;else if(typeof t.VERTICAL_AXIS<"u"&&t.axis===t.VERTICAL_AXIS)this.deltaY=-t.detail/3;else if($.type==="wheel"){const c=$;c.deltaMode===c.DOM_DELTA_LINE?A.$mQ&&!n.$j?this.deltaY=-$.deltaY/3:this.deltaY=-$.deltaY:this.deltaY=-$.deltaY/40}if(typeof f.wheelDeltaX<"u")A.$pQ&&n.$i?this.deltaX=-(f.wheelDeltaX/120):l?this.deltaX=f.wheelDeltaX/(120*s):this.deltaX=f.wheelDeltaX/120;else if(typeof t.HORIZONTAL_AXIS<"u"&&t.axis===t.HORIZONTAL_AXIS)this.deltaX=-$.detail/3;else if($.type==="wheel"){const c=$;c.deltaMode===c.DOM_DELTA_LINE?A.$mQ&&!n.$j?this.deltaX=-$.deltaX/3:this.deltaX=-$.deltaX:this.deltaX=-$.deltaX/40}this.deltaY===0&&this.deltaX===0&&$.wheelDelta&&(l?this.deltaY=$.wheelDelta/(120*s):this.deltaY=$.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}e.$AQ=S}),define(me[117],$e([1,0,5]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const n=globalThis.vscode;if(typeof n<"u"&&typeof n.process<"u"){const W=n.process;N={get platform(){return W.platform},get arch(){return W.arch},get env(){return W.env},cwd(){return W.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return A.$i?"win32":A.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(me[24],$e([1,0,117]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,n=97,W=90,D=122,S=46,b=47,$=92,p=58,O=63;class l extends Error{constructor(y,L,R){let z;typeof L=="string"&&L.indexOf("not ")===0?(z="must not be",L=L.replace(/^not /,"")):z="must be";const H=y.indexOf(".")!==-1?"property":"argument";let E=`The "${y}" ${H} ${z} of type ${L}`;E+=`. Received type ${typeof R}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function f(a,y){if(a===null||typeof a!="object")throw new l(y,"Object",a)}function t(a,y){if(typeof a!="string")throw new l(y,"string",a)}const s=A.$dc==="win32";function c(a){return a===b||a===$}function g(a){return a===b}function u(a){return a>=N&&a<=W||a>=n&&a<=D}function w(a,y,L,R){let z="",H=0,E=-1,B=0,j=0;for(let F=0;F<=a.length;++F){if(F<a.length)j=a.charCodeAt(F);else{if(R(j))break;j=b}if(R(j)){if(!(E===F-1||B===1))if(B===2){if(z.length<2||H!==2||z.charCodeAt(z.length-1)!==S||z.charCodeAt(z.length-2)!==S){if(z.length>2){const M=z.lastIndexOf(L);M===-1?(z="",H=0):(z=z.slice(0,M),H=z.length-1-z.lastIndexOf(L)),E=F,B=0;continue}else if(z.length!==0){z="",H=0,E=F,B=0;continue}}y&&(z+=z.length>0?`${L}..`:"..",H=2)}else z.length>0?z+=`${L}${a.slice(E+1,F)}`:z=a.slice(E+1,F),H=F-E-1;E=F,B=0}else j===S&&B!==-1?++B:B=-1}return z}function h(a,y){f(y,"pathObject");const L=y.dir||y.root,R=y.base||`${y.name||""}${y.ext||""}`;return L?L===y.root?`${L}${R}`:`${L}${a}${R}`:R}e.$fc={resolve(...a){let y="",L="",R=!1;for(let z=a.length-1;z>=-1;z--){let H;if(z>=0){if(H=a[z],t(H,"path"),H.length===0)continue}else y.length===0?H=A.cwd():(H=A.env[`=${y}`]||A.cwd(),(H===void 0||H.slice(0,2).toLowerCase()!==y.toLowerCase()&&H.charCodeAt(2)===$)&&(H=`${y}\\`));const E=H.length;let B=0,j="",F=!1;const M=H.charCodeAt(0);if(E===1)c(M)&&(B=1,F=!0);else if(c(M))if(F=!0,c(H.charCodeAt(1))){let I=2,x=I;for(;I<E&&!c(H.charCodeAt(I));)I++;if(I<E&&I!==x){const X=H.slice(x,I);for(x=I;I<E&&c(H.charCodeAt(I));)I++;if(I<E&&I!==x){for(x=I;I<E&&!c(H.charCodeAt(I));)I++;(I===E||I!==x)&&(j=`\\\\${X}\\${H.slice(x,I)}`,B=I)}}}else B=1;else u(M)&&H.charCodeAt(1)===p&&(j=H.slice(0,2),B=2,E>2&&c(H.charCodeAt(2))&&(F=!0,B=3));if(j.length>0)if(y.length>0){if(j.toLowerCase()!==y.toLowerCase())continue}else y=j;if(R){if(y.length>0)break}else if(L=`${H.slice(B)}\\${L}`,R=F,F&&y.length>0)break}return L=w(L,!R,"\\",c),R?`${y}\\${L}`:`${y}${L}`||"."},normalize(a){t(a,"path");const y=a.length;if(y===0)return".";let L=0,R,z=!1;const H=a.charCodeAt(0);if(y===1)return g(H)?"\\":a;if(c(H))if(z=!0,c(a.charCodeAt(1))){let B=2,j=B;for(;B<y&&!c(a.charCodeAt(B));)B++;if(B<y&&B!==j){const F=a.slice(j,B);for(j=B;B<y&&c(a.charCodeAt(B));)B++;if(B<y&&B!==j){for(j=B;B<y&&!c(a.charCodeAt(B));)B++;if(B===y)return`\\\\${F}\\${a.slice(j)}\\`;B!==j&&(R=`\\\\${F}\\${a.slice(j,B)}`,L=B)}}}else L=1;else u(H)&&a.charCodeAt(1)===p&&(R=a.slice(0,2),L=2,y>2&&c(a.charCodeAt(2))&&(z=!0,L=3));let E=L<y?w(a.slice(L),!z,"\\",c):"";return E.length===0&&!z&&(E="."),E.length>0&&c(a.charCodeAt(y-1))&&(E+="\\"),R===void 0?z?`\\${E}`:E:z?`${R}\\${E}`:`${R}${E}`},isAbsolute(a){t(a,"path");const y=a.length;if(y===0)return!1;const L=a.charCodeAt(0);return c(L)||y>2&&u(L)&&a.charCodeAt(1)===p&&c(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let y,L;for(let H=0;H<a.length;++H){const E=a[H];t(E,"path"),E.length>0&&(y===void 0?y=L=E:y+=`\\${E}`)}if(y===void 0)return".";let R=!0,z=0;if(typeof L=="string"&&c(L.charCodeAt(0))){++z;const H=L.length;H>1&&c(L.charCodeAt(1))&&(++z,H>2&&(c(L.charCodeAt(2))?++z:R=!1))}if(R){for(;z<y.length&&c(y.charCodeAt(z));)z++;z>=2&&(y=`\\${y.slice(z)}`)}return e.$fc.normalize(y)},relative(a,y){if(t(a,"from"),t(y,"to"),a===y)return"";const L=e.$fc.resolve(a),R=e.$fc.resolve(y);if(L===R||(a=L.toLowerCase(),y=R.toLowerCase(),a===y))return"";let z=0;for(;z<a.length&&a.charCodeAt(z)===$;)z++;let H=a.length;for(;H-1>z&&a.charCodeAt(H-1)===$;)H--;const E=H-z;let B=0;for(;B<y.length&&y.charCodeAt(B)===$;)B++;let j=y.length;for(;j-1>B&&y.charCodeAt(j-1)===$;)j--;const F=j-B,M=E<F?E:F;let I=-1,x=0;for(;x<M;x++){const de=a.charCodeAt(z+x);if(de!==y.charCodeAt(B+x))break;de===$&&(I=x)}if(x!==M){if(I===-1)return R}else{if(F>M){if(y.charCodeAt(B+x)===$)return R.slice(B+x+1);if(x===2)return R.slice(B+x)}E>M&&(a.charCodeAt(z+x)===$?I=x:x===2&&(I=3)),I===-1&&(I=0)}let X="";for(x=z+I+1;x<=H;++x)(x===H||a.charCodeAt(x)===$)&&(X+=X.length===0?"..":"\\..");return B+=I,X.length>0?`${X}${R.slice(B,j)}`:(R.charCodeAt(B)===$&&++B,R.slice(B,j))},toNamespacedPath(a){if(typeof a!="string"||a.length===0)return a;const y=e.$fc.resolve(a);if(y.length<=2)return a;if(y.charCodeAt(0)===$){if(y.charCodeAt(1)===$){const L=y.charCodeAt(2);if(L!==O&&L!==S)return`\\\\?\\UNC\\${y.slice(2)}`}}else if(u(y.charCodeAt(0))&&y.charCodeAt(1)===p&&y.charCodeAt(2)===$)return`\\\\?\\${y}`;return a},dirname(a){t(a,"path");const y=a.length;if(y===0)return".";let L=-1,R=0;const z=a.charCodeAt(0);if(y===1)return c(z)?a:".";if(c(z)){if(L=R=1,c(a.charCodeAt(1))){let B=2,j=B;for(;B<y&&!c(a.charCodeAt(B));)B++;if(B<y&&B!==j){for(j=B;B<y&&c(a.charCodeAt(B));)B++;if(B<y&&B!==j){for(j=B;B<y&&!c(a.charCodeAt(B));)B++;if(B===y)return a;B!==j&&(L=R=B+1)}}}}else u(z)&&a.charCodeAt(1)===p&&(L=y>2&&c(a.charCodeAt(2))?3:2,R=L);let H=-1,E=!0;for(let B=y-1;B>=R;--B)if(c(a.charCodeAt(B))){if(!E){H=B;break}}else E=!1;if(H===-1){if(L===-1)return".";H=L}return a.slice(0,H)},basename(a,y){y!==void 0&&t(y,"ext"),t(a,"path");let L=0,R=-1,z=!0,H;if(a.length>=2&&u(a.charCodeAt(0))&&a.charCodeAt(1)===p&&(L=2),y!==void 0&&y.length>0&&y.length<=a.length){if(y===a)return"";let E=y.length-1,B=-1;for(H=a.length-1;H>=L;--H){const j=a.charCodeAt(H);if(c(j)){if(!z){L=H+1;break}}else B===-1&&(z=!1,B=H+1),E>=0&&(j===y.charCodeAt(E)?--E===-1&&(R=H):(E=-1,R=B))}return L===R?R=B:R===-1&&(R=a.length),a.slice(L,R)}for(H=a.length-1;H>=L;--H)if(c(a.charCodeAt(H))){if(!z){L=H+1;break}}else R===-1&&(z=!1,R=H+1);return R===-1?"":a.slice(L,R)},extname(a){t(a,"path");let y=0,L=-1,R=0,z=-1,H=!0,E=0;a.length>=2&&a.charCodeAt(1)===p&&u(a.charCodeAt(0))&&(y=R=2);for(let B=a.length-1;B>=y;--B){const j=a.charCodeAt(B);if(c(j)){if(!H){R=B+1;break}continue}z===-1&&(H=!1,z=B+1),j===S?L===-1?L=B:E!==1&&(E=1):L!==-1&&(E=-1)}return L===-1||z===-1||E===0||E===1&&L===z-1&&L===R+1?"":a.slice(L,z)},format:h.bind(null,"\\"),parse(a){t(a,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return y;const L=a.length;let R=0,z=a.charCodeAt(0);if(L===1)return c(z)?(y.root=y.dir=a,y):(y.base=y.name=a,y);if(c(z)){if(R=1,c(a.charCodeAt(1))){let I=2,x=I;for(;I<L&&!c(a.charCodeAt(I));)I++;if(I<L&&I!==x){for(x=I;I<L&&c(a.charCodeAt(I));)I++;if(I<L&&I!==x){for(x=I;I<L&&!c(a.charCodeAt(I));)I++;I===L?R=I:I!==x&&(R=I+1)}}}}else if(u(z)&&a.charCodeAt(1)===p){if(L<=2)return y.root=y.dir=a,y;if(R=2,c(a.charCodeAt(2))){if(L===3)return y.root=y.dir=a,y;R=3}}R>0&&(y.root=a.slice(0,R));let H=-1,E=R,B=-1,j=!0,F=a.length-1,M=0;for(;F>=R;--F){if(z=a.charCodeAt(F),c(z)){if(!j){E=F+1;break}continue}B===-1&&(j=!1,B=F+1),z===S?H===-1?H=F:M!==1&&(M=1):H!==-1&&(M=-1)}return B!==-1&&(H===-1||M===0||M===1&&H===B-1&&H===E+1?y.base=y.name=a.slice(E,B):(y.name=a.slice(E,H),y.base=a.slice(E,B),y.ext=a.slice(H,B))),E>0&&E!==R?y.dir=a.slice(0,E-1):y.dir=y.root,y},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(s){const a=/\\/g;return()=>{const y=A.cwd().replace(a,"/");return y.slice(y.indexOf("/"))}}return()=>A.cwd()})();e.$gc={resolve(...a){let y="",L=!1;for(let R=a.length-1;R>=-1&&!L;R--){const z=R>=0?a[R]:m();t(z,"path"),z.length!==0&&(y=`${z}/${y}`,L=z.charCodeAt(0)===b)}return y=w(y,!L,"/",g),L?`/${y}`:y.length>0?y:"."},normalize(a){if(t(a,"path"),a.length===0)return".";const y=a.charCodeAt(0)===b,L=a.charCodeAt(a.length-1)===b;return a=w(a,!y,"/",g),a.length===0?y?"/":L?"./":".":(L&&(a+="/"),y?`/${a}`:a)},isAbsolute(a){return t(a,"path"),a.length>0&&a.charCodeAt(0)===b},join(...a){if(a.length===0)return".";let y;for(let L=0;L<a.length;++L){const R=a[L];t(R,"path"),R.length>0&&(y===void 0?y=R:y+=`/${R}`)}return y===void 0?".":e.$gc.normalize(y)},relative(a,y){if(t(a,"from"),t(y,"to"),a===y||(a=e.$gc.resolve(a),y=e.$gc.resolve(y),a===y))return"";const L=1,R=a.length,z=R-L,H=1,E=y.length-H,B=z<E?z:E;let j=-1,F=0;for(;F<B;F++){const I=a.charCodeAt(L+F);if(I!==y.charCodeAt(H+F))break;I===b&&(j=F)}if(F===B)if(E>B){if(y.charCodeAt(H+F)===b)return y.slice(H+F+1);if(F===0)return y.slice(H+F)}else z>B&&(a.charCodeAt(L+F)===b?j=F:F===0&&(j=0));let M="";for(F=L+j+1;F<=R;++F)(F===R||a.charCodeAt(F)===b)&&(M+=M.length===0?"..":"/..");return`${M}${y.slice(H+j)}`},toNamespacedPath(a){return a},dirname(a){if(t(a,"path"),a.length===0)return".";const y=a.charCodeAt(0)===b;let L=-1,R=!0;for(let z=a.length-1;z>=1;--z)if(a.charCodeAt(z)===b){if(!R){L=z;break}}else R=!1;return L===-1?y?"/":".":y&&L===1?"//":a.slice(0,L)},basename(a,y){y!==void 0&&t(y,"ext"),t(a,"path");let L=0,R=-1,z=!0,H;if(y!==void 0&&y.length>0&&y.length<=a.length){if(y===a)return"";let E=y.length-1,B=-1;for(H=a.length-1;H>=0;--H){const j=a.charCodeAt(H);if(j===b){if(!z){L=H+1;break}}else B===-1&&(z=!1,B=H+1),E>=0&&(j===y.charCodeAt(E)?--E===-1&&(R=H):(E=-1,R=B))}return L===R?R=B:R===-1&&(R=a.length),a.slice(L,R)}for(H=a.length-1;H>=0;--H)if(a.charCodeAt(H)===b){if(!z){L=H+1;break}}else R===-1&&(z=!1,R=H+1);return R===-1?"":a.slice(L,R)},extname(a){t(a,"path");let y=-1,L=0,R=-1,z=!0,H=0;for(let E=a.length-1;E>=0;--E){const B=a.charCodeAt(E);if(B===b){if(!z){L=E+1;break}continue}R===-1&&(z=!1,R=E+1),B===S?y===-1?y=E:H!==1&&(H=1):y!==-1&&(H=-1)}return y===-1||R===-1||H===0||H===1&&y===R-1&&y===L+1?"":a.slice(y,R)},format:h.bind(null,"/"),parse(a){t(a,"path");const y={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return y;const L=a.charCodeAt(0)===b;let R;L?(y.root="/",R=1):R=0;let z=-1,H=0,E=-1,B=!0,j=a.length-1,F=0;for(;j>=R;--j){const M=a.charCodeAt(j);if(M===b){if(!B){H=j+1;break}continue}E===-1&&(B=!1,E=j+1),M===S?z===-1?z=j:F!==1&&(F=1):z!==-1&&(F=-1)}if(E!==-1){const M=H===0&&L?1:H;z===-1||F===0||F===1&&z===E-1&&z===H+1?y.base=y.name=a.slice(M,E):(y.name=a.slice(M,z),y.base=a.slice(M,E),y.ext=a.slice(z,E))}return H>0?y.dir=a.slice(0,H-1):L&&(y.dir="/"),y},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=s?e.$fc.normalize:e.$gc.normalize,e.$ic=s?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=s?e.$fc.join:e.$gc.join,e.$kc=s?e.$fc.resolve:e.$gc.resolve,e.$lc=s?e.$fc.relative:e.$gc.relative,e.$mc=s?e.$fc.dirname:e.$gc.dirname,e.$nc=s?e.$fc.basename:e.$gc.basename,e.$oc=s?e.$fc.extname:e.$gc.extname,e.$pc=s?e.$fc.format:e.$gc.format,e.$qc=s?e.$fc.parse:e.$gc.parse,e.$rc=s?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=s?e.$fc.sep:e.$gc.sep,e.$tc=s?e.$fc.delimiter:e.$gc.delimiter}),define(me[118],$e([1,0,24,5,10,7]),function(se,e,A,N,n,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=void 0;function D(H){return H===47||H===92}e.$$f=D;function S(H){return H.replace(/[\\/]/g,A.$gc.sep)}e.$_f=S;function b(H){return H.indexOf("/")===-1&&(H=S(H)),/^[a-zA-Z]:(\/|$)/.test(H)&&(H="/"+H),H}e.$ag=b;function $(H,E=A.$gc.sep){if(!H)return"";const B=H.length,j=H.charCodeAt(0);if(D(j)){if(D(H.charCodeAt(1))&&!D(H.charCodeAt(2))){let M=3;const I=M;for(;M<B&&!D(H.charCodeAt(M));M++);if(I!==M&&!D(H.charCodeAt(M+1))){for(M+=1;M<B;M++)if(D(H.charCodeAt(M)))return H.slice(0,M+1).replace(/[\\/]/g,E)}}return E}else if(g(j)&&H.charCodeAt(1)===58)return D(H.charCodeAt(2))?H.slice(0,2)+E:H.slice(0,2);let F=H.indexOf("://");if(F!==-1){for(F+=3;F<B;F++)if(D(H.charCodeAt(F)))return H.slice(0,F+1)}return""}e.$bg=$;function p(H){if(!N.$i||!H||H.length<5)return!1;let E=H.charCodeAt(0);if(E!==92||(E=H.charCodeAt(1),E!==92))return!1;let B=2;const j=B;for(;B<H.length&&(E=H.charCodeAt(B),E!==92);B++);return!(j===B||(E=H.charCodeAt(B+1),isNaN(E)||E===92))}e.$cg=p;const O=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(H,E=N.$i){const B=E?O:l;return!(!H||H.length===0||/^\s+$/.test(H)||(B.lastIndex=0,B.test(H))||E&&f.test(H)||H==="."||H===".."||E&&H[H.length-1]==="."||E&&H.length!==H.trim().length||H.length>255)}e.$dg=t;function s(H,E,B){const j=H===E;return!B||j?j:!H||!E?!1:(0,n.$jf)(H,E)}e.$eg=s;function c(H,E,B,j=A.sep){if(H===E)return!0;if(!H||!E||E.length>H.length)return!1;if(B){if(!(0,n.$kf)(H,E))return!1;if(E.length===H.length)return!0;let M=E.length;return E.charAt(E.length-1)===j&&M--,H.charAt(M)===j}return E.charAt(E.length-1)!==j&&(E+=j),H.indexOf(E)===0}e.$fg=c;function g(H){return H>=65&&H<=90||H>=97&&H<=122}e.$gg=g;function u(H,E){return N.$i&&H.endsWith(":")&&(H+=A.sep),(0,A.$ic)(H)||(H=(0,A.$jc)(E,H)),H=(0,A.$hc)(H),N.$i?(H=(0,n.$4e)(H,A.sep),H.endsWith(":")&&(H+=A.sep)):(H=(0,n.$4e)(H,A.sep),H||(H=A.sep)),H}e.$hg=u;function w(H){const E=(0,A.$hc)(H);return N.$i?H.length>3?!1:h(E)&&(H.length===2||E.charCodeAt(2)===92):E===A.$gc.sep}e.$ig=w;function h(H,E=N.$i){return E?g(H.charCodeAt(0))&&H.charCodeAt(1)===58:!1}e.$jg=h;function m(H,E=N.$i){return h(H,E)?H[0]:void 0}e.$kg=m;function a(H,E,B){return E.length>H.length?-1:H===E?0:(B&&(H=H.toLowerCase(),E=E.toLowerCase()),H.indexOf(E))}e.$lg=a;function y(H){const E=H.split(":");let B,j,F;for(const M of E){const I=Number(M);(0,W.$Wf)(I)?j===void 0?j=I:F===void 0&&(F=I):B=B?[B,M].join(":"):M}if(!B)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:B,line:j!==void 0?j:void 0,column:F!==void 0?F:j!==void 0?1:void 0}}e.$mg=y;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function z(H,E,B=8){let j="";for(let M=0;M<B;M++){let I;M===0&&N.$i&&!E&&(B===3||B===4)?I=R:I=L,j+=I.charAt(Math.floor(Math.random()*I.length))}let F;return E?F=`${E}-${j}`:F=j,H?(0,A.$jc)(H,F):F}e.$ng=z}),define(me[119],$e([1,0,24]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=e.$ts=e.$ss=e.$rs=e.$qs=void 0,e.$qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},n={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(p){const O=(0,A.$oc)(p),l=N[O.toLowerCase()];return l!==void 0?l:D(p)}e.$rs=W;function D(p){const O=(0,A.$oc)(p);return n[O.toLowerCase()]}e.$ss=D;function S(p){for(const O in n)if(n[O]===p)return O}e.$ts=S;const b=/^(.+)\/(.+?)(;.+)?$/;function $(p,O){const l=b.exec(p);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:O?void 0:p}e.$us=$}),define(me[15],$e([1,0,24,5]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,W=/^\//,D=/^\/\//;function S(R,z){if(!R.scheme&&z)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!n.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!W.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(R,z){return!R&&!z?"file":R}function $(R,z){switch(R){case"https":case"http":case"file":z?z[0]!==O&&(z=O+z):z=O;break}return z}const p="",O="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(z){return z instanceof f?!0:z?typeof z.authority=="string"&&typeof z.fragment=="string"&&typeof z.path=="string"&&typeof z.query=="string"&&typeof z.scheme=="string"&&typeof z.fsPath=="string"&&typeof z.with=="function"&&typeof z.toString=="function":!1}constructor(z,H,E,B,j,F=!1){typeof z=="object"?(this.scheme=z.scheme||p,this.authority=z.authority||p,this.path=z.path||p,this.query=z.query||p,this.fragment=z.fragment||p):(this.scheme=b(z,F),this.authority=H||p,this.path=$(this.scheme,E||p),this.query=B||p,this.fragment=j||p,S(this,F))}get fsPath(){return h(this,!1)}with(z){if(!z)return this;let{scheme:H,authority:E,path:B,query:j,fragment:F}=z;return H===void 0?H=this.scheme:H===null&&(H=p),E===void 0?E=this.authority:E===null&&(E=p),B===void 0?B=this.path:B===null&&(B=p),j===void 0?j=this.query:j===null&&(j=p),F===void 0?F=this.fragment:F===null&&(F=p),H===this.scheme&&E===this.authority&&B===this.path&&j===this.query&&F===this.fragment?this:new c(H,E,B,j,F)}static parse(z,H=!1){const E=l.exec(z);return E?new c(E[2]||p,L(E[4]||p),L(E[5]||p),L(E[7]||p),L(E[9]||p),H):new c(p,p,p,p,p)}static file(z){let H=p;if(N.$i&&(z=z.replace(/\\/g,O)),z[0]===O&&z[1]===O){const E=z.indexOf(O,2);E===-1?(H=z.substring(2),z=O):(H=z.substring(2,E),z=z.substring(E)||O)}return new c("file",H,z,p,p)}static from(z,H){return new c(z.scheme,z.authority,z.path,z.query,z.fragment,H)}static joinPath(z,...H){if(!z.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return N.$i&&z.scheme==="file"?E=f.file(A.$fc.join(h(z,!0),...H)).path:E=A.$gc.join(z.path,...H),z.with({path:E})}toString(z=!1){return m(this,z)}toJSON(){return this}static revive(z){if(z){if(z instanceof f)return z;{const H=new c(z);return H._formatted=z.external??null,H._fsPath=z._sep===s?z.fsPath??null:null,H}}else return z}}e.URI=f;function t(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}e.$vc=t;const s=N.$i?1:void 0;class c extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(z=!1){return z?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const z={$mid:1};return this._fsPath&&(z.fsPath=this._fsPath,z._sep=s),this._formatted&&(z.external=this._formatted),this.path&&(z.path=this.path),this.scheme&&(z.scheme=this.scheme),this.authority&&(z.authority=this.authority),this.query&&(z.query=this.query),this.fragment&&(z.fragment=this.fragment),z}}const g={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function u(R,z,H){let E,B=-1;for(let j=0;j<R.length;j++){const F=R.charCodeAt(j);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||z&&F===47||H&&F===91||H&&F===93||H&&F===58)B!==-1&&(E+=encodeURIComponent(R.substring(B,j)),B=-1),E!==void 0&&(E+=R.charAt(j));else{E===void 0&&(E=R.substr(0,j));const M=g[F];M!==void 0?(B!==-1&&(E+=encodeURIComponent(R.substring(B,j)),B=-1),E+=M):B===-1&&(B=j)}}return B!==-1&&(E+=encodeURIComponent(R.substring(B))),E!==void 0?E:R}function w(R){let z;for(let H=0;H<R.length;H++){const E=R.charCodeAt(H);E===35||E===63?(z===void 0&&(z=R.substr(0,H)),z+=g[E]):z!==void 0&&(z+=R[H])}return z!==void 0?z:R}function h(R,z){let H;return R.authority&&R.path.length>1&&R.scheme==="file"?H=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?z?H=R.path.substr(1):H=R.path[1].toLowerCase()+R.path.substr(2):H=R.path,N.$i&&(H=H.replace(/\//g,"\\")),H}e.$wc=h;function m(R,z){const H=z?w:u;let E="",{scheme:B,authority:j,path:F,query:M,fragment:I}=R;if(B&&(E+=B,E+=":"),(j||B==="file")&&(E+=O,E+=O),j){let x=j.indexOf("@");if(x!==-1){const X=j.substr(0,x);j=j.substr(x+1),x=X.lastIndexOf(":"),x===-1?E+=H(X,!1,!1):(E+=H(X.substr(0,x),!1,!1),E+=":",E+=H(X.substr(x+1),!1,!0)),E+="@"}j=j.toLowerCase(),x=j.lastIndexOf(":"),x===-1?E+=H(j,!1,!0):(E+=H(j.substr(0,x),!1,!0),E+=j.substr(x))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const x=F.charCodeAt(1);x>=65&&x<=90&&(F=`/${String.fromCharCode(x+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const x=F.charCodeAt(0);x>=65&&x<=90&&(F=`${String.fromCharCode(x+32)}:${F.substr(2)}`)}E+=H(F,!0,!1)}return M&&(E+="?",E+=H(M,!1,!1)),I&&(E+="#",E+=z?I:u(I,!1,!1)),E}function a(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+a(R.substr(3)):R}}const y=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(R){return R.match(y)?R.replace(y,z=>a(z)):R}}),define(me[55],$e([1,0,35,15]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=void 0;function n(b){return JSON.stringify(b,D)}e.$Lh=n;function W(b){let $=JSON.parse(b);return $=S($),$}e.$Mh=W;function D(b,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function S(b,$=0){if(!b||$>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return N.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof A.$se||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let p=0;p<b.length;++p)b[p]=S(b[p],$+1);else for(const p in b)Object.hasOwnProperty.call(b,p)&&(b[p]=S(b[p],$+1))}return b}e.$Nh=S}),define(me[32],$e([1,0,6,5,10,15]),function(se,e,A,N,n,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.Schemas=void 0;var D;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.codeSetting="code-setting",l.codeFeature="code-feature"})(D||(e.Schemas=D={}));function S(l,f){return W.URI.isUri(l)?(0,n.$jf)(l.scheme,f):(0,n.$kf)(l,f+":")}e.$og=S;function b(l,...f){return f.some(t=>S(l,t))}e.$pg=b,e.$qg="vscode-tkn",e.$rg="tkn";class ${constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f){this.f=`${f}/${D.vscodeRemoteResource}`}set(f,t,s){this.a[f]=t,this.b[f]=s}setConnectionToken(f,t){this.c[f]=t}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(w){return A.$1(w),f}const t=f.authority;let s=this.a[t];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const c=this.b[t],g=this.c[t];let u=`path=${encodeURIComponent(f.path)}`;return typeof g=="string"&&(u+=`&${e.$rg}=${encodeURIComponent(g)}`),W.URI.from({scheme:N.$o?this.d:D.vscodeRemoteResource,authority:`${s}:${c}`,path:this.f,query:u})}}e.$sg=new $,e.$tg="vs/../../extensions",e.$ug="vs/../../node_modules",e.$vg="vs/../../node_modules.asar",e.$wg="vs/../../node_modules.asar.unpacked",e.$xg="vscode-app";class p{static{this.a=e.$xg}asBrowserUri(f){const t=this.b(f,se);return this.uriToBrowserUri(t)}uriToBrowserUri(f){return f.scheme===D.vscodeRemote?e.$sg.rewrite(f):f.scheme===D.file&&(N.$m||N.$q===`${D.vscodeFileResource}://${p.a}`)?f.with({scheme:D.vscodeFileResource,authority:f.authority||p.a,query:null,fragment:null}):f}asFileUri(f){const t=this.b(f,se);return this.uriToFileUri(t)}uriToFileUri(f){return f.scheme===D.vscodeFileResource?f.with({scheme:D.file,authority:f.authority!==p.a?f.authority:null,query:null,fragment:null}):f}b(f,t){return W.URI.isUri(f)?f:W.URI.parse(t.toUrl(f))}}e.$yg=new p;var O;(function(l){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(f.get("3"));const t="vscode-coi";function s(g){let u;typeof g=="string"?u=new URL(g).searchParams:g instanceof URL?u=g.searchParams:W.URI.isUri(g)&&(u=new URL(g.toString(!0)).searchParams);const w=u?.get(t);if(w)return f.get(w)}l.getHeadersFromQuery=s;function c(g,u,w){if(!globalThis.crossOriginIsolated)return;const h=u&&w?"3":w?"2":"1";g instanceof URLSearchParams?g.set(t,h):g[t]=h}l.addSearchParam=c})(O||(e.COI=O={}))}),define(me[39],$e([1,0,118,32,24,5,10,15]),function(se,e,A,N,n,W,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=e.DataUri=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function b(f){return(0,S.$wc)(f,!0)}e.$Fg=b;class ${constructor(t){this.a=t}compare(t,s,c=!1){return t===s?0:(0,D.$cf)(this.getComparisonKey(t,c),this.getComparisonKey(s,c))}isEqual(t,s,c=!1){return t===s?!0:!t||!s?!1:this.getComparisonKey(t,c)===this.getComparisonKey(s,c)}getComparisonKey(t,s=!1){return t.with({path:this.a(t)?t.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(t){return this.a(t)}isEqualOrParent(t,s,c=!1){if(t.scheme===s.scheme){if(t.scheme===N.Schemas.file)return A.$fg(b(t),b(s),this.a(t))&&t.query===s.query&&(c||t.fragment===s.fragment);if((0,e.$Wg)(t.authority,s.authority))return A.$fg(t.path,s.path,this.a(t),"/")&&t.query===s.query&&(c||t.fragment===s.fragment)}return!1}joinPath(t,...s){return S.URI.joinPath(t,...s)}basenameOrAuthority(t){return(0,e.$Og)(t)||t.authority}basename(t){return n.$gc.basename(t.path)}extname(t){return n.$gc.extname(t.path)}dirname(t){if(t.path.length===0)return t;let s;return t.scheme===N.Schemas.file?s=S.URI.file(n.$mc(b(t))).path:(s=n.$gc.dirname(t.path),t.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),s="/")),t.with({path:s})}normalizePath(t){if(!t.path.length)return t;let s;return t.scheme===N.Schemas.file?s=S.URI.file(n.$hc(b(t))).path:s=n.$gc.normalize(t.path),t.with({path:s})}relativePath(t,s){if(t.scheme!==s.scheme||!(0,e.$Wg)(t.authority,s.authority))return;if(t.scheme===N.Schemas.file){const u=n.$lc(b(t),b(s));return W.$i?A.$_f(u):u}let c=t.path||"/";const g=s.path||"/";if(this.a(t)){let u=0;for(const w=Math.min(c.length,g.length);u<w&&!(c.charCodeAt(u)!==g.charCodeAt(u)&&c.charAt(u).toLowerCase()!==g.charAt(u).toLowerCase());u++);c=g.substr(0,u)+c.substr(u)}return n.$gc.relative(c,g)}resolvePath(t,s){if(t.scheme===N.Schemas.file){const c=S.URI.file(n.$kc(b(t),s));return t.with({authority:c.authority,path:c.path})}return s=A.$ag(s),t.with({path:n.$gc.resolve(t.path,s)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,s){return t===s||t!==void 0&&s!==void 0&&(0,D.$jf)(t,s)}hasTrailingPathSeparator(t,s=n.sep){if(t.scheme===N.Schemas.file){const c=b(t);return c.length>A.$bg(c).length&&c[c.length-1]===s}else{const c=t.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,s=n.sep){return(0,e.$Xg)(t,s)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,s=n.sep){let c=!1;if(t.scheme===N.Schemas.file){const g=b(t);c=g!==void 0&&g.length===A.$bg(g).length&&g[g.length-1]===s}else{s="/";const g=t.path;c=g.length===1&&g.charCodeAt(g.length-1)===47}return!c&&!(0,e.$Xg)(t,s)?t.with({path:t.path+"/"}):t}}e.$Gg=$,e.$Hg=new $(()=>!1),e.$Ig=new $(f=>f.scheme===N.Schemas.file?!W.$k:!0),e.$Jg=new $(f=>!0),e.$Kg=e.$Hg.isEqual.bind(e.$Hg),e.$Lg=e.$Hg.isEqualOrParent.bind(e.$Hg),e.$Mg=e.$Hg.getComparisonKey.bind(e.$Hg),e.$Ng=e.$Hg.basenameOrAuthority.bind(e.$Hg),e.$Og=e.$Hg.basename.bind(e.$Hg),e.$Pg=e.$Hg.extname.bind(e.$Hg),e.$Qg=e.$Hg.dirname.bind(e.$Hg),e.$Rg=e.$Hg.joinPath.bind(e.$Hg),e.$Sg=e.$Hg.normalizePath.bind(e.$Hg),e.$Tg=e.$Hg.relativePath.bind(e.$Hg),e.$Ug=e.$Hg.resolvePath.bind(e.$Hg),e.$Vg=e.$Hg.isAbsolutePath.bind(e.$Hg),e.$Wg=e.$Hg.isEqualAuthority.bind(e.$Hg),e.$Xg=e.$Hg.hasTrailingPathSeparator.bind(e.$Hg),e.$Yg=e.$Hg.removeTrailingPathSeparator.bind(e.$Hg),e.$Zg=e.$Hg.addTrailingPathSeparator.bind(e.$Hg);function p(f,t){const s=[];for(let c=0;c<f.length;c++){const g=t(f[c]);f.some((u,w)=>w===c?!1:(0,e.$Lg)(g,t(u)))||s.push(f[c])}return s}e.$1g=p;var O;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function t(s){const c=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(w=>{const[h,m]=w.split(":");h&&m&&c.set(h,m)});const u=s.path.substring(0,s.path.indexOf(";"));return u&&c.set(f.META_DATA_MIME,u),c}f.parseMetaData=t})(O||(e.DataUri=O={}));function l(f,t,s){if(t){let c=f.path;return c&&c[0]!==n.$gc.sep&&(c=n.$gc.sep+c),f.with({scheme:s,authority:t,path:c})}return f.with({scheme:s})}e.$2g=l}),define(me[9],$e([1,0,30,6,4,3,39,5,52,22]),function(se,e,A,N,n,W,D,S,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.Promises=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0;function p(C){return!!C&&typeof C.then=="function"}e.$3g=p;function O(C){const r=new A.$ce,i=C(r.token),o=new Promise((v,P)=>{const T=r.token.onCancellationRequested(()=>{T.dispose(),P(new N.$5)});Promise.resolve(i).then(U=>{T.dispose(),r.dispose(),v(U)},U=>{T.dispose(),r.dispose(),P(U)})});return new class{cancel(){r.cancel(),r.dispose()}then(v,P){return o.then(v,P)}catch(v){return this.then(void 0,v)}finally(v){return o.finally(v)}}}e.$4g=O;function l(C,r,i){return new Promise((o,v)=>{const P=r.onCancellationRequested(()=>{P.dispose(),o(i)});C.then(o,v).finally(()=>P.dispose())})}e.$5g=l;function f(C,r){return new Promise((i,o)=>{const v=r.onCancellationRequested(()=>{v.dispose(),o(new N.$5)});C.then(i,o).finally(()=>v.dispose())})}e.$6g=f;async function t(C){let r=-1;const i=C.map((o,v)=>o.then(P=>(r=v,P)));try{return await Promise.race(i)}finally{C.forEach((o,v)=>{v!==r&&o.cancel()})}}e.$7g=t;function s(C,r,i){let o;const v=setTimeout(()=>{o?.(void 0),i?.()},r);return Promise.race([C.finally(()=>clearTimeout(v)),new Promise(P=>o=P)])}e.$8g=s;function c(C){return new Promise((r,i)=>{const o=C();p(o)?o.then(r,i):r(o)})}e.$9g=c;function g(){let C,r;return{promise:new Promise((o,v)=>{C=o,r=v}),resolve:C,reject:r}}e.$0g=g;class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(r){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=r,!this.b){const i=()=>{if(this.b=null,this.f)return;const o=this.queue(this.d);return this.d=null,o};this.b=new Promise(o=>{this.a.then(i,i).then(o)})}return new Promise((i,o)=>{this.b.then(i,o)})}return this.a=r(),new Promise((i,o)=>{this.a.then(v=>{this.a=null,i(v)},v=>{this.a=null,o(v)})})}dispose(){this.f=!0}}e.$$g=u;class w{constructor(){this.a=Promise.resolve(null)}queue(r){return this.a=this.a.then(()=>r(),()=>r())}}e.$_g=w;class h{constructor(){this.a=new Map}queue(r,i){const v=(this.a.get(r)??Promise.resolve()).catch(()=>{}).then(i).finally(()=>{this.a.get(r)===v&&this.a.delete(r)});return this.a.set(r,v),v}}e.$ah=h;const m=(C,r)=>{let i=!0;const o=setTimeout(()=>{i=!1,r()},C);return{isTriggered:()=>i,dispose:()=>{clearTimeout(o),i=!1}}},a=C=>{let r=!0;return queueMicrotask(()=>{r&&(r=!1,C())}),{isTriggered:()=>r,dispose:()=>{r=!1}}};class y{constructor(r){this.defaultDelay=r,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(r,i=this.defaultDelay){this.g=r,this.h(),this.b||(this.b=new Promise((v,P)=>{this.d=v,this.f=P}).then(()=>{if(this.b=null,this.d=null,this.g){const v=this.g;return this.g=null,v()}}));const o=()=>{this.a=null,this.d?.(null)};return this.a=i===b.$2d?a(o):m(i,o),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$bh=y;class L{constructor(r){this.a=new y(r),this.b=new u}trigger(r,i){return this.a.trigger(()=>this.b.queue(r),i)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ch=L;class R{constructor(){this.a=!1,this.b=new Promise((r,i)=>{this.d=r})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$dh=R;class z extends R{constructor(r){super(),this.f=setTimeout(()=>this.open(),r)}open(){clearTimeout(this.f),super.open()}}e.$eh=z;function H(C,r){return r?new Promise((i,o)=>{const v=setTimeout(()=>{P.dispose(),i()},C),P=r.onCancellationRequested(()=>{clearTimeout(v),P.dispose(),o(new N.$5)})}):O(i=>H(C,i))}e.$fh=H;function E(C,r=0,i){const o=setTimeout(()=>{C(),i&&v.dispose()},r),v=(0,W.$Rc)(()=>{clearTimeout(o),i?.deleteAndLeak(v)});return i?.add(v),v}e.$gh=E;function B(C){const r=[];let i=0;const o=C.length;function v(){return i<o?C[i++]():null}function P(T){T!=null&&r.push(T);const U=v();return U?U.then(P):Promise.resolve(r)}return Promise.resolve(null).then(P)}e.$hh=B;function j(C,r=o=>!!o,i=null){let o=0;const v=C.length,P=()=>{if(o>=v)return Promise.resolve(i);const T=C[o++];return Promise.resolve(T()).then(_=>r(_)?Promise.resolve(_):P())};return P()}e.$ih=j;function F(C,r=o=>!!o,i=null){if(C.length===0)return Promise.resolve(i);let o=C.length;const v=()=>{o=-1;for(const P of C)P.cancel?.()};return new Promise((P,T)=>{for(const U of C)U.then(_=>{--o>=0&&r(_)?(v(),P(_)):o===0&&P(i)}).catch(_=>{--o>=0&&(v(),T(_))})})}e.$jh=F;class M{constructor(r){this.a=0,this.b=!1,this.f=r,this.g=[],this.d=0,this.h=new n.$5d}whenIdle(){return this.size>0?n.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(r){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((i,o)=>{this.g.push({factory:r,c:i,e:o}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const r=this.g.shift();this.d++;const i=r.factory();i.then(r.c,r.e),i.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$kh=M;class I extends M{constructor(){super(1)}}e.$lh=I;class x{constructor(){this.a=new ae,this.b=0}queue(r){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,r())):this.a.run(this.b++,r())}}e.$mh=x;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const r=new Q;return this.b.add(r),r.p}g(){for(const[,r]of this.a)if(r.size>0)return!1;return!0}queueSize(r,i=D.$Hg){const o=i.getComparisonKey(r);return this.a.get(o)?.size??0}queueFor(r,i,o=D.$Hg){const v=o.getComparisonKey(r);let P=this.a.get(v);if(!P){P=new I;const T=this.f++,U=n.Event.once(P.onDrained)(()=>{P?.dispose(),this.a.delete(v),this.h(),this.d?.deleteAndDispose(T),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new W.$3c),this.d.set(T,U),this.a.set(v,P)}return P.queue(i)}h(){this.g()&&this.j()}j(){for(const r of this.b)r.complete();this.b.clear()}dispose(){for(const[,r]of this.a)r.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$nh=X;class de{constructor(r,i){this.a=-1,typeof r=="function"&&typeof i=="number"&&this.setIfNotSet(r,i)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(r,i){this.cancel(),this.a=setTimeout(()=>{this.a=-1,r()},i)}setIfNotSet(r,i){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,r()},i))}}e.$oh=de;class ue{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(r,i,o=globalThis){this.cancel();const v=o.setInterval(()=>{r()},i);this.d=(0,W.$Rc)(()=>{o.clearInterval(v),this.d=void 0})}dispose(){this.cancel()}}e.$ph=ue;class te{constructor(r,i){this.b=-1,this.a=r,this.d=i,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(r=this.d){this.cancel(),this.b=setTimeout(this.f,r)}get delay(){return this.d}set delay(r){this.d=r}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$qh=te;class ge{constructor(r,i){i%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${i}ms is not a multiple of 1000ms.`),this.a=r,this.b=i,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(r=this.b){r%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${r}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(r/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$rh=ge;class Le extends te{constructor(r,i){super(r,i),this.j=[]}work(r){this.j.push(r),this.isScheduled()||this.schedule()}h(){const r=this.j;this.j=[],this.a?.(r)}dispose(){this.j=[],super.dispose()}}e.$sh=Le;class Te extends W.$Tc{constructor(r,i){super(),this.g=r,this.h=i,this.a=[],this.b=this.B(new W.$Uc),this.f=!1}get pending(){return this.a.length}work(r){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+r.length>this.g.maxBufferedWork)return!1}else if(this.pending+r.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const i of r)this.a.push(i);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$th=Te,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$vh=(C,r)=>{(0,S.$B)(()=>{if(i)return;const o=Date.now()+15;r(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,o-Date.now())}}))});let i=!1;return{dispose(){i||(i=!0)}}}:e.$vh=(C,r,i)=>{const o=C.requestIdleCallback(r,typeof i=="number"?{timeout:i}:void 0);let v=!1;return{dispose(){v||(v=!0,C.cancelIdleCallback(o))}}},e.$uh=C=>(0,e.$vh)(globalThis,C)}();class Be{constructor(r,i){this.g=!1,this.d=()=>{try{this.j=i()}catch(o){this.l=o}finally{this.g=!0}},this.f=(0,e.$vh)(r,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$wh=Be;class le extends Be{constructor(r){super(globalThis,r)}}e.$xh=le;async function J(C,r,i){let o;for(let v=0;v<i;v++)try{return await C()}catch(P){o=P,await H(r)}throw o}e.$yh=J;class ae{isRunning(r){return typeof r=="number"?this.a?.taskId===r:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(r,i,o){return this.a={taskId:r,cancel:()=>o?.(),promise:i},i.then(()=>this.d(r),()=>this.d(r)),i}d(r){this.a&&r===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const r=this.b;this.b=void 0,r.run().then(r.promiseResolve,r.promiseReject)}}queue(r){if(this.b)this.b.run=r;else{const{promise:i,resolve:o,reject:v}=g();this.b={run:r,promise:i,promiseResolve:o,promiseReject:v}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$zh=ae;class re{constructor(r,i=()=>Date.now()){this.d=r,this.f=i,this.a=0,this.b=0}increment(){const r=this.f();return r-this.a>this.d&&(this.a=r,this.b=0),this.b++,this.b}}e.$Ah=re;var Y;(function(C){C[C.Resolved=0]="Resolved",C[C.Rejected=1]="Rejected"})(Y||(Y={}));class Q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((r,i)=>{this.a=r,this.b=i})}complete(r){return new Promise(i=>{this.a(r),this.d={outcome:0,value:r},i()})}error(r){return new Promise(i=>{this.b(r),this.d={outcome:1,value:r},i()})}cancel(){return this.error(new N.$5)}}e.$Bh=Q;var ie;(function(C){async function r(o){let v;const P=await Promise.all(o.map(T=>T.then(U=>U,U=>{v||(v=U)})));if(typeof v<"u")throw v;return P}C.settled=r;function i(o){return new Promise(async(v,P)=>{try{await o(v,P)}catch(T){P(T)}})}C.withAsyncBody=i})(ie||(e.Promises=ie={}));class fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(r){this.a=void 0,this.b=void 0,this.d=!1,this.promise=r.then(i=>(this.a=i,this.d=!0,i),i=>{throw this.b=i,this.d=!0,i})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ch=fe;class ye{constructor(r){this.b=r,this.a=new $.$V(()=>new fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Dh=ye;var Ce;(function(C){C[C.Initial=0]="Initial",C[C.DoneOK=1]="DoneOK",C[C.DoneError=2]="DoneError"})(Ce||(Ce={}));class ke{static fromArray(r){return new ke(i=>{i.emitMany(r)})}static fromPromise(r){return new ke(async i=>{i.emitMany(await r)})}static fromPromises(r){return new ke(async i=>{await Promise.all(r.map(async o=>i.emitOne(await o)))})}static merge(r){return new ke(async i=>{await Promise.all(r.map(async o=>{for await(const v of o)i.emitOne(v)}))})}static{this.EMPTY=ke.fromArray([])}constructor(r){this.a=0,this.b=[],this.d=null,this.f=new n.$5d,queueMicrotask(async()=>{const i={emitOne:o=>this.g(o),emitMany:o=>this.h(o),reject:o=>this.k(o)};try{await Promise.resolve(r(i)),this.j()}catch(o){this.k(o)}finally{i.emitOne=void 0,i.emitMany=void 0,i.reject=void 0}})}[Symbol.asyncIterator](){let r=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(r<this.b.length)return{done:!1,value:this.b[r++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(r,i){return new ke(async o=>{for await(const v of r)o.emitOne(i(v))})}map(r){return ke.map(this,r)}static filter(r,i){return new ke(async o=>{for await(const v of r)i(v)&&o.emitOne(v)})}filter(r){return ke.filter(this,r)}static coalesce(r){return ke.filter(r,i=>!!i)}coalesce(){return ke.coalesce(this)}static async toPromise(r){const i=[];for await(const o of r)i.push(o);return i}toPromise(){return ke.toPromise(this)}g(r){this.a===0&&(this.b.push(r),this.f.fire())}h(r){this.a===0&&(this.b=this.b.concat(r),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(r){this.a===0&&(this.a=2,this.d=r,this.f.fire())}}e.$Eh=ke;class q extends ke{constructor(r,i){super(i),this.l=r}cancel(){this.l.cancel()}}e.$Fh=q;function d(C){const r=new A.$ce,i=C(r.token);return new q(r,async o=>{const v=r.token.onCancellationRequested(()=>{v.dispose(),r.dispose(),o.reject(new N.$5)});try{for await(const P of i){if(r.token.isCancellationRequested)return;o.emitOne(P)}v.dispose(),r.dispose()}catch(P){v.dispose(),r.dispose(),o.reject(P)}})}e.$Gh=d;class k{constructor(){this.a=new Q,this.b=new ke(o=>{if(r){o.reject(r);return}return i&&o.emitMany(i),this.d=v=>o.reject(v),this.f=v=>o.emitOne(v),this.a.p});let r,i;this.f=o=>{i||(i=[]),i.push(o)},this.d=o=>{r||(r=o)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(r){this.d(r),this.a.complete()}emitOne(r){this.f(r)}}e.$Hh=k}),define(me[2],$e([1,0,16,116,14,19,9,6,4,120,3,32,5,15,51,21]),function(se,e,A,N,n,W,D,S,b,$,p,O,l,f,t,s){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$aS=e.$_R=e.h=e.$0R=e.$9R=e.$8R=e.$7R=e.$6R=e.$5R=e.$4R=e.$3R=e.DetectedFullscreenMode=e.$2R=e.$1R=e.$ZR=e.$YR=e.$XR=e.$WR=e.$VR=e.$UR=e.$TR=e.$SR=e.$RR=e.$QR=e.$PR=e.$OR=e.$NR=e.$MR=e.$LR=e.$=e.Namespace=e.$JR=e.$IR=e.$HR=e.$GR=e.$FR=e.$ER=e.$DR=e.$CR=e.$BR=e.$AR=e.$zR=e.$yR=e.$xR=e.$wR=e.$vR=e.$uR=e.$tR=e.$sR=e.$rR=e.$qR=e.$pR=e.$oR=e.$nR=e.$mR=e.$lR=e.$kR=e.$jR=e.$iR=e.$hR=e.$gR=e.$fR=e.$eR=e.$dR=e.$cR=e.$bR=e.$aR=e.$_Q=e.$$Q=e.$0Q=e.$9Q=e.$8Q=e.$7Q=e.$6Q=e.$5Q=e.$4Q=e.$3Q=e.$2Q=e.$1Q=e.$ZQ=e.$YQ=e.$XQ=e.$WQ=e.$VQ=e.$UQ=e.$TQ=e.$SQ=e.$RQ=e.$QQ=e.$PQ=e.$OQ=e.$NQ=e.$MQ=e.$LQ=e.$KQ=e.$JQ=e.$IQ=e.$HQ=e.$GQ=e.$FQ=e.onDidUnregisterWindow=e.onWillUnregisterWindow=e.onDidRegisterWindow=e.hasWindow=e.getWindowById=e.getWindowId=e.getWindowsCount=e.getWindows=e.getDocument=e.getWindow=e.registerWindow=void 0,c=function(){const V=new Map;(0,s.$$P)(s.$_P,1);const K={window:s.$_P,disposables:new p.$Sc};V.set(s.$_P.vscodeWindowId,K);const ee=new b.$5d,ce=new b.$5d,Ae=new b.$5d;function ze(Oe,We){return(typeof Oe=="number"?V.get(Oe):void 0)??(We?K:void 0)}return{onDidRegisterWindow:ee.event,onWillUnregisterWindow:Ae.event,onDidUnregisterWindow:ce.event,registerWindow(Oe){if(V.has(Oe.vscodeWindowId))return p.$Tc.None;const We=new p.$Sc,qe={window:Oe,disposables:We.add(new p.$Sc)};return V.set(Oe.vscodeWindowId,qe),We.add((0,p.$Rc)(()=>{V.delete(Oe.vscodeWindowId),ce.fire(Oe)})),We.add(w(Oe,e.$AR.BEFORE_UNLOAD,()=>{Ae.fire(Oe)})),ee.fire(qe),We},getWindows(){return V.values()},getWindowsCount(){return V.size},getWindowId(Oe){return Oe.vscodeWindowId},hasWindow(Oe){return V.has(Oe)},getWindowById:ze,getWindow(Oe){const We=Oe;if(We?.ownerDocument?.defaultView)return We.ownerDocument.defaultView.window;const qe=Oe;return qe?.view?qe.view.window:s.$_P},getDocument(Oe){const We=Oe;return(0,e.getWindow)(We).document}}}(),e.registerWindow=c.registerWindow,e.getWindow=c.getWindow,e.getDocument=c.getDocument,e.getWindows=c.getWindows,e.getWindowsCount=c.getWindowsCount,e.getWindowId=c.getWindowId,e.getWindowById=c.getWindowById,e.hasWindow=c.hasWindow,e.onDidRegisterWindow=c.onDidRegisterWindow,e.onWillUnregisterWindow=c.onWillUnregisterWindow,e.onDidUnregisterWindow=c.onDidUnregisterWindow;function g(V){for(;V.firstChild;)V.firstChild.remove()}e.$FQ=g;class u{constructor(K,ee,ce,Ae){this.f=K,this.g=ee,this.d=ce,this.j=Ae||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function w(V,K,ee,ce){return new u(V,K,ee,ce)}e.$GQ=w;function h(V,K){return function(ee){return K(new W.$yQ(V,ee))}}function m(V){return function(K){return V(new n.$DQ(K))}}const a=function(K,ee,ce,Ae){let ze=ce;return ee==="click"||ee==="mousedown"?ze=h((0,e.getWindow)(K),ce):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(ze=m(ce)),w(K,ee,ze,Ae)};e.$HQ=a;const y=function(K,ee,ce){const Ae=h((0,e.getWindow)(K),ee);return R(K,Ae,ce)};e.$IQ=y;const L=function(K,ee,ce){const Ae=h((0,e.getWindow)(K),ee);return H(K,Ae,ce)};e.$JQ=L;function R(V,K,ee){return w(V,l.$r&&N.$vQ.pointerEvents?e.$AR.POINTER_DOWN:e.$AR.MOUSE_DOWN,K,ee)}e.$KQ=R;function z(V,K,ee){return w(V,l.$r&&N.$vQ.pointerEvents?e.$AR.POINTER_MOVE:e.$AR.MOUSE_MOVE,K,ee)}e.$LQ=z;function H(V,K,ee){return w(V,l.$r&&N.$vQ.pointerEvents?e.$AR.POINTER_UP:e.$AR.MOUSE_UP,K,ee)}e.$MQ=H;function E(V,K,ee){return(0,D.$vh)(V,K,ee)}e.$NQ=E;class B extends D.$wh{constructor(K,ee){super(K,ee)}}e.$OQ=B;function j(V,K,ee,ce){let Ae=0;const ze=V.setInterval(()=>{Ae++,(typeof ce=="number"&&Ae>=ce||K()===!0)&&Oe.dispose()},ee),Oe=(0,p.$Rc)(()=>{V.clearInterval(ze)});return Oe}e.$RQ=j;class F extends D.$ph{constructor(K){super(),this.f=K&&(0,e.getWindow)(K)}cancelAndSet(K,ee,ce){return super.cancelAndSet(K,ee,ce??this.f)}}e.$SQ=F;class M{constructor(K,ee=0){this.d=K,this.priority=ee,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(K){(0,S.$1)(K)}}static sort(K,ee){return ee.priority-K.priority}}(function(){const V=new Map,K=new Map,ee=new Map,ce=new Map,Ae=ze=>{ee.set(ze,!1);const Oe=V.get(ze)??[];for(K.set(ze,Oe),V.set(ze,[]),ce.set(ze,!0);Oe.length>0;)Oe.sort(M.sort),Oe.shift().execute();ce.set(ze,!1)};e.$QQ=(ze,Oe,We=0)=>{const qe=(0,e.getWindowId)(ze),Ke=new M(Oe,We);let at=V.get(qe);return at||(at=[],V.set(qe,at)),at.push(Ke),ee.get(qe)||(ee.set(qe,!0),ze.requestAnimationFrame(()=>Ae(qe))),Ke},e.$PQ=(ze,Oe,We)=>{const qe=(0,e.getWindowId)(ze);if(ce.get(qe)){const Ke=new M(Oe,We);let at=K.get(qe);return at||(at=[],K.set(qe,at)),at.push(Ke),Ke}else return(0,e.$QQ)(ze,Oe,We)}})();function I(V,K){return(0,e.$QQ)(V,K,1e4)}e.$TQ=I;function x(V,K){return(0,e.$QQ)(V,K,-1e4)}e.$UQ=x;const X=8,de=function(V,K){return K};class ue extends p.$Tc{constructor(K,ee,ce,Ae=de,ze=X){super();let Oe=null,We=0;const qe=this.B(new D.$oh),Ke=()=>{We=new Date().getTime(),ce(Oe),Oe=null};this.B(w(K,ee,at=>{Oe=Ae(Oe,at);const Ct=new Date().getTime()-We;Ct>=ze?(qe.cancel(),Ke()):qe.setIfNotSet(Ke,ze-Ct)}))}}function te(V,K,ee,ce,Ae){return new ue(V,K,ee,ce,Ae)}e.$VQ=te;function ge(V){return(0,e.getWindow)(V).getComputedStyle(V,null)}e.$WQ=ge;function Le(V,K){const ee=(0,e.getWindow)(V),ce=ee.document;if(V!==ce.body)return new Be(V.clientWidth,V.clientHeight);if(l.$r&&ee?.visualViewport)return new Be(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new Be(ee.innerWidth,ee.innerHeight);if(ce.body&&ce.body.clientWidth&&ce.body.clientHeight)return new Be(ce.body.clientWidth,ce.body.clientHeight);if(ce.documentElement&&ce.documentElement.clientWidth&&ce.documentElement.clientHeight)return new Be(ce.documentElement.clientWidth,ce.documentElement.clientHeight);if(K)return Le(K);throw new Error("Unable to figure out browser width and height")}e.$XQ=Le;class Te{static d(K,ee){return parseFloat(ee)||0}static f(K,ee,ce){const Ae=ge(K),ze=Ae?Ae.getPropertyValue(ee):"0";return Te.d(K,ze)}static getBorderLeftWidth(K){return Te.f(K,"border-left-width","borderLeftWidth")}static getBorderRightWidth(K){return Te.f(K,"border-right-width","borderRightWidth")}static getBorderTopWidth(K){return Te.f(K,"border-top-width","borderTopWidth")}static getBorderBottomWidth(K){return Te.f(K,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(K){return Te.f(K,"padding-left","paddingLeft")}static getPaddingRight(K){return Te.f(K,"padding-right","paddingRight")}static getPaddingTop(K){return Te.f(K,"padding-top","paddingTop")}static getPaddingBottom(K){return Te.f(K,"padding-bottom","paddingBottom")}static getMarginLeft(K){return Te.f(K,"margin-left","marginLeft")}static getMarginTop(K){return Te.f(K,"margin-top","marginTop")}static getMarginRight(K){return Te.f(K,"margin-right","marginRight")}static getMarginBottom(K){return Te.f(K,"margin-bottom","marginBottom")}}class Be{static{this.None=new Be(0,0)}constructor(K,ee){this.width=K,this.height=ee}with(K=this.width,ee=this.height){return K!==this.width||ee!==this.height?new Be(K,ee):this}static is(K){return typeof K=="object"&&typeof K.height=="number"&&typeof K.width=="number"}static lift(K){return K instanceof Be?K:new Be(K.width,K.height)}static equals(K,ee){return K===ee?!0:!K||!ee?!1:K.width===ee.width&&K.height===ee.height}}e.$YQ=Be;function le(V){let K=V.offsetParent,ee=V.offsetTop,ce=V.offsetLeft;for(;(V=V.parentNode)!==null&&V!==V.ownerDocument.body&&V!==V.ownerDocument.documentElement;){ee-=V.scrollTop;const Ae=P(V)?null:ge(V);Ae&&(ce-=Ae.direction!=="rtl"?V.scrollLeft:-V.scrollLeft),V===K&&(ce+=Te.getBorderLeftWidth(V),ee+=Te.getBorderTopWidth(V),ee+=V.offsetTop,ce+=V.offsetLeft,K=V.offsetParent)}return{left:ce,top:ee}}e.$ZQ=le;function J(V,K,ee){typeof K=="number"&&(V.style.width=`${K}px`),typeof ee=="number"&&(V.style.height=`${ee}px`)}e.$1Q=J;function ae(V,K,ee,ce,Ae,ze="absolute"){typeof K=="number"&&(V.style.top=`${K}px`),typeof ee=="number"&&(V.style.right=`${ee}px`),typeof ce=="number"&&(V.style.bottom=`${ce}px`),typeof Ae=="number"&&(V.style.left=`${Ae}px`),V.style.position=ze}e.$2Q=ae;function re(V){const K=V.getBoundingClientRect(),ee=(0,e.getWindow)(V);return{left:K.left+ee.scrollX,top:K.top+ee.scrollY,width:K.width,height:K.height}}e.$3Q=re;function Y(V){let K=V,ee=1;do{const ce=ge(K).zoom;ce!=null&&ce!=="1"&&(ee*=ce),K=K.parentElement}while(K!==null&&K!==K.ownerDocument.documentElement);return ee}e.$4Q=Y;function Q(V){const K=Te.getMarginLeft(V)+Te.getMarginRight(V);return V.offsetWidth+K}e.$5Q=Q;function ie(V){const K=Te.getBorderLeftWidth(V)+Te.getBorderRightWidth(V),ee=Te.getPaddingLeft(V)+Te.getPaddingRight(V);return V.offsetWidth-K-ee}e.$6Q=ie;function fe(V){const K=Te.getMarginLeft(V)+Te.getMarginRight(V);return V.scrollWidth+K}e.$7Q=fe;function ye(V){const K=Te.getBorderTopWidth(V)+Te.getBorderBottomWidth(V),ee=Te.getPaddingTop(V)+Te.getPaddingBottom(V);return V.offsetHeight-K-ee}e.$8Q=ye;function Ce(V){const K=Te.getMarginTop(V)+Te.getMarginBottom(V);return V.offsetHeight+K}e.$9Q=Ce;function ke(V,K){if(V===null)return 0;const ee=le(V),ce=le(K);return ee.left-ce.left}function q(V,K){const ee=K.map(Ae=>Math.max(fe(Ae),Q(Ae))+ke(Ae,V)||0);return Math.max(...ee)}e.$0Q=q;function d(V,K){return!!K?.contains(V)}e.$$Q=d;const k="parentFlowToElementId";function C(V,K){V.dataset[k]=K.id}e.$_Q=C;function r(V){const K=V.dataset[k];return typeof K=="string"?V.ownerDocument.getElementById(K):null}function i(V,K){let ee=V;for(;ee;){if(ee===K)return!0;if(ee instanceof HTMLElement){const ce=r(ee);if(ce){ee=ce;continue}}ee=ee.parentNode}return!1}e.$aR=i;function o(V,K,ee){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V.classList.contains(K))return V;if(ee){if(typeof ee=="string"){if(V.classList.contains(ee))return null}else if(V===ee)return null}V=V.parentNode}return null}e.$bR=o;function v(V,K,ee){return!!o(V,K,ee)}e.$cR=v;function P(V){return V&&!!V.host&&!!V.mode}e.$dR=P;function T(V){return!!U(V)}e.$eR=T;function U(V){for(;V.parentNode;){if(V===V.ownerDocument?.body)return null;V=V.parentNode}return P(V)?V:null}e.$fR=U;function _(){let V=De().activeElement;for(;V?.shadowRoot;)V=V.shadowRoot.activeElement;return V}e.$gR=_;function Z(V){return _()===V}e.$hR=Z;function oe(V){return d(_(),V)}e.$iR=oe;function be(V){return V.ownerDocument===De()}e.$jR=be;function De(){return(0,e.getWindowsCount)()<=1?s.$_P.document:Array.from((0,e.getWindows)()).map(({window:K})=>K.document).find(K=>K.hasFocus())??s.$_P.document}e.$kR=De;function ve(){return De().defaultView?.window??s.$_P}e.$lR=ve;function Se(V){const K=(0,e.getWindow)(V);K.document.hasFocus()||K.focus()}e.$mR=Se;const we=new Map;function Ne(V){return we.has(V)}e.$nR=Ne;function Me(){return new Pe}e.$oR=Me;class Pe{constructor(){this.d="",this.f=void 0}setStyle(K){K!==this.d&&(this.d=K,this.f?this.f.innerText=K:this.f=Xe(s.$_P.document.head,ee=>ee.innerText=K))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Xe(V=s.$_P.document.head,K,ee){const ce=document.createElement("style");if(ce.type="text/css",ce.media="screen",K?.(ce),V.appendChild(ce),ee&&ee.add((0,p.$Rc)(()=>V.removeChild(ce))),V===s.$_P.document.head){const Ae=new Set;we.set(ce,Ae);for(const{window:ze,disposables:Oe}of(0,e.getWindows)()){if(ze===s.$_P)continue;const We=Oe.add(Qe(ce,Ae,ze));ee?.add(We)}}return ce}e.$pR=Xe;function nt(V){const K=new p.$Sc;for(const[ee,ce]of we)K.add(Qe(ee,ce,V));return K}e.$qR=nt;function Qe(V,K,ee){const ce=new p.$Sc,Ae=V.cloneNode(!0);ee.document.head.appendChild(Ae),ce.add((0,p.$Rc)(()=>ee.document.head.removeChild(Ae)));for(const ze of Re(V))Ae.sheet?.insertRule(ze.cssText,Ae.sheet?.cssRules.length);return ce.add(e.$rR.observe(V,ce,{childList:!0})(()=>{Ae.textContent=V.textContent})),K.add(Ae),ce.add((0,p.$Rc)(()=>K.delete(Ae))),ce}e.$rR=new class{constructor(){this.mutationObservers=new Map}observe(V,K,ee){let ce=this.mutationObservers.get(V);ce||(ce=new Map,this.mutationObservers.set(V,ce));const Ae=(0,t.$5i)(ee);let ze=ce.get(Ae);if(ze)ze.users+=1;else{const Oe=new b.$5d,We=new MutationObserver(Ke=>Oe.fire(Ke));We.observe(V,ee);const qe=ze={users:1,observer:We,onDidMutate:Oe.event};K.add((0,p.$Rc)(()=>{qe.users-=1,qe.users===0&&(Oe.dispose(),We.disconnect(),ce?.delete(Ae),ce?.size===0&&this.mutationObservers.delete(V))})),ce.set(Ae,ze)}return ze.onDidMutate}};function Ze(V=s.$_P.document.head){return ne("meta",V)}e.$sR=Ze;function G(V=s.$_P.document.head){return ne("link",V)}e.$tR=G;function ne(V,K=s.$_P.document.head){const ee=document.createElement(V);return K.appendChild(ee),ee}let pe=null;function Ee(){return pe||(pe=Xe()),pe}function Re(V){return V?.sheet?.rules?V.sheet.rules:V?.sheet?.cssRules?V.sheet.cssRules:[]}function Ue(V,K,ee=Ee()){if(!(!ee||!K)){ee.sheet?.insertRule(`${V} {${K}}`,0);for(const ce of we.get(ee)??[])Ue(V,K,ce)}}e.$uR=Ue;function Ve(V,K=Ee()){if(!K)return;const ee=Re(K),ce=[];for(let Ae=0;Ae<ee.length;Ae++){const ze=ee[Ae];Je(ze)&&ze.selectorText.indexOf(V)!==-1&&ce.push(Ae)}for(let Ae=ce.length-1;Ae>=0;Ae--)K.sheet?.deleteRule(ce[Ae]);for(const Ae of we.get(K)??[])Ve(V,Ae)}e.$vR=Ve;function Je(V){return typeof V.selectorText=="string"}function tt(V){return V instanceof MouseEvent||V instanceof(0,e.getWindow)(V).MouseEvent}e.$wR=tt;function st(V){return V instanceof KeyboardEvent||V instanceof(0,e.getWindow)(V).KeyboardEvent}e.$xR=st;function Ye(V){return V instanceof PointerEvent||V instanceof(0,e.getWindow)(V).PointerEvent}e.$yR=Ye;function rt(V){return V instanceof DragEvent||V instanceof(0,e.getWindow)(V).DragEvent}e.$zR=rt,e.$AR={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:A.$nQ?"webkitAnimationStart":"animationstart",ANIMATION_END:A.$nQ?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:A.$nQ?"webkitAnimationIteration":"animationiteration"};function et(V){const K=V;return!!(K&&typeof K.preventDefault=="function"&&typeof K.stopPropagation=="function")}e.$BR=et,e.$CR={stop:(V,K)=>(V.preventDefault(),K&&V.stopPropagation(),V)};function gt(V){const K=[];for(let ee=0;V&&V.nodeType===V.ELEMENT_NODE;ee++)K[ee]=V.scrollTop,V=V.parentNode;return K}e.$DR=gt;function mt(V,K){for(let ee=0;V&&V.nodeType===V.ELEMENT_NODE;ee++)V.scrollTop!==K[ee]&&(V.scrollTop=K[ee]),V=V.parentNode}e.$ER=mt;class bt extends p.$Tc{static m(K){if(K instanceof HTMLElement){const ee=U(K),ce=ee?ee.activeElement:K.ownerDocument.activeElement;return d(ce,K)}else{const ee=K;return d(ee.document.activeElement,ee.document)}}constructor(K){super(),this.f=this.B(new b.$5d),this.onDidFocus=this.f.event,this.g=this.B(new b.$5d),this.onDidBlur=this.g.event;let ee=bt.m(K),ce=!1;const Ae=()=>{ce=!1,ee||(ee=!0,this.f.fire())},ze=()=>{ee&&(ce=!0,(K instanceof HTMLElement?(0,e.getWindow)(K):K).setTimeout(()=>{ce&&(ce=!1,ee=!1,this.g.fire())},0))};this.j=()=>{bt.m(K)!==ee&&(ee?ze():Ae())},this.B(w(K,e.$AR.FOCUS,Ae,!0)),this.B(w(K,e.$AR.BLUR,ze,!0)),K instanceof HTMLElement&&(this.B(w(K,e.$AR.FOCUS_IN,()=>this.j())),this.B(w(K,e.$AR.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function Ft(V){return new bt(V)}e.$FR=Ft;function Ot(V,K){return V.after(K),K}e.$GR=Ot;function He(V,...K){if(V.append(...K),K.length===1&&typeof K[0]!="string")return K[0]}e.$HR=He;function he(V,K){return V.insertBefore(K,V.firstChild),K}e.$IR=he;function Fe(V,...K){V.innerText="",He(V,...K)}e.$JR=Fe;const Ie=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var _e;(function(V){V.HTML="http://www.w3.org/1999/xhtml",V.SVG="http://www.w3.org/2000/svg"})(_e||(e.Namespace=_e={}));function it(V,K,ee,...ce){const Ae=Ie.exec(K);if(!Ae)throw new Error("Bad use of emmet");const ze=Ae[1]||"div";let Oe;return V!==_e.HTML?Oe=document.createElementNS(V,ze):Oe=document.createElement(ze),Ae[3]&&(Oe.id=Ae[3]),Ae[4]&&(Oe.className=Ae[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([We,qe])=>{typeof qe>"u"||(/^on\w+$/.test(We)?Oe[We]=qe:We==="selected"?qe&&Oe.setAttribute(We,"true"):Oe.setAttribute(We,qe))}),Oe.append(...ce),Oe}function lt(V,K,...ee){return it(_e.HTML,V,K,...ee)}e.$=lt,lt.SVG=function(V,K,...ee){return it(_e.SVG,V,K,...ee)};function Ge(V,K){const ee=[];return V.forEach((ce,Ae)=>{Ae>0&&(K instanceof Node?ee.push(K.cloneNode()):ee.push(document.createTextNode(K))),ee.push(ce)}),ee}e.$LR=Ge;function ct(V,...K){V?pt(...K):yt(...K)}e.$MR=ct;function pt(...V){for(const K of V)K.style.display="",K.removeAttribute("aria-hidden")}e.$NR=pt;function yt(...V){for(const K of V)K.style.display="none",K.setAttribute("aria-hidden","true")}e.$OR=yt;function xt(V,K){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V instanceof HTMLElement&&V.hasAttribute(K))return V;V=V.parentNode}return null}function Ai(V){!V||!V.hasAttribute("tabIndex")||(V.ownerDocument.activeElement===V&&xt(V.parentElement,"tabIndex")?.focus(),V.removeAttribute("tabindex"))}e.$PR=Ai;function ki(V){return K=>{K.preventDefault(),K.stopPropagation(),V(K)}}e.$QR=ki;function Si(V){return new Promise(K=>{if(V.document.readyState==="complete"||V.document&&V.document.body!==null)K(void 0);else{const ce=()=>{V.window.removeEventListener("DOMContentLoaded",ce,!1),K()};V.window.addEventListener("DOMContentLoaded",ce,!1)}})}e.$RR=Si;function Fi(V,K){const ee=V.devicePixelRatio*K;return Math.max(1,Math.floor(ee))/V.devicePixelRatio}e.$SR=Fi;function Ci(V){s.$_P.open(V,"_blank","noopener")}e.$TR=Ci;const Yt=780,Xt=640;function Ti(V){const K=Math.floor(s.$_P.screenLeft+s.$_P.innerWidth/2-Yt/2),ee=Math.floor(s.$_P.screenTop+s.$_P.innerHeight/2-Xt/2);s.$_P.open(V,"_blank",`width=${Yt},height=${Xt},top=${ee},left=${K}`)}e.$UR=Ti;function Ni(V,K=!0){const ee=s.$_P.open();return ee?(K&&(ee.opener=null),ee.location.href=V,!0):!1}e.$VR=Ni;function Ri(V,K){const ee=()=>{K(),ce=(0,e.$QQ)(V,ee)};let ce=(0,e.$QQ)(V,ee);return(0,p.$Rc)(()=>ce.dispose())}e.$WR=Ri,O.$sg.setPreferredWebSchema(/^https:/.test(s.$_P.location.href)?"https":"http");function Li(V){return V?`url('${O.$yg.uriToBrowserUri(V).toString(!0).replace(/'/g,"%27")}')`:"url('')"}e.$XR=Li;function Ii(V){return`'${V.replace(/'/g,"%27")}'`}e.$YR=Ii;function Zt(V,K){if(V!==void 0){const ee=V.match(/^\s*var\((.+)\)$/);if(ee){const ce=ee[1].split(",",2);return ce.length===2&&(K=Zt(ce[1].trim(),K)),`var(${ce[0]}, ${K})`}return V}return K}e.$ZR=Zt;function Mi(V,K){let ee;if(f.URI.isUri(V))ee=V.toString(!0);else{const ze=new Blob([V]);ee=URL.createObjectURL(ze),setTimeout(()=>URL.revokeObjectURL(ee))}const ce=ve(),Ae=document.createElement("a");ce.document.body.appendChild(Ae),Ae.download=K,Ae.href=ee,Ae.click(),setTimeout(()=>ce.document.body.removeChild(Ae))}e.$1R=Mi;function Pi(){return new Promise(V=>{const K=ve(),ee=document.createElement("input");K.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,b.Event.once(b.Event.fromDOMEventEmitter(ee,"input"))(()=>{V(ee.files??void 0)}),ee.click(),setTimeout(()=>K.document.body.removeChild(ee))})}e.$2R=Pi;var Et;(function(V){V[V.DOCUMENT=1]="DOCUMENT",V[V.BROWSER=2]="BROWSER"})(Et||(e.DetectedFullscreenMode=Et={}));function Oi(V){return V.document.fullscreenElement||V.document.webkitFullscreenElement||V.document.webkitIsFullScreen?{mode:Et.DOCUMENT,guess:!1}:V.innerHeight===V.screen.height?{mode:Et.BROWSER,guess:!1}:(l.$j||l.$k)&&V.outerHeight===V.screen.height&&V.outerWidth===V.screen.width?{mode:Et.BROWSER,guess:!0}:null}e.$3R=Oi;function Jt(V,K=!1){const ee=document.createElement("a");return $.addHook("afterSanitizeAttributes",ce=>{for(const Ae of["href","src"])if(ce.hasAttribute(Ae)){const ze=ce.getAttribute(Ae);if(Ae==="href"&&ze.startsWith("#"))continue;if(ee.href=ze,!V.includes(ee.protocol.replace(/:$/,""))){if(K&&Ae==="src"&&ee.href.startsWith("data:"))continue;ce.removeAttribute(Ae)}}}),(0,p.$Rc)(()=>{$.removeHook("afterSanitizeAttributes")})}e.$4R=Jt;const Bi=[O.Schemas.http,O.Schemas.https,O.Schemas.command];e.$5R=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Hi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function zi(V,K){const ee=Jt(Bi);try{const ce=$.sanitize(K,Hi);V.innerHTML=ce}finally{ee.dispose()}}e.$6R=zi;function Ui(V){const K=new Uint16Array(V.length);for(let Ae=0;Ae<K.length;Ae++)K[Ae]=V.charCodeAt(Ae);let ee="";const ce=new Uint8Array(K.buffer);for(let Ae=0;Ae<ce.length;Ae++)ee+=String.fromCharCode(ce[Ae]);return ee}function ji(V){return btoa(Ui(V))}e.$7R=ji;class wt extends b.$5d{constructor(){super(),this.o=new p.$Sc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(b.Event.runAndSubscribe(e.onDidRegisterWindow,({window:K,disposables:ee})=>this.C(K,ee),{window:s.$_P,disposables:this.o}))}C(K,ee){ee.add(w(K,"keydown",ce=>{if(ce.defaultPrevented)return;const Ae=new n.$DQ(ce);if(!(Ae.keyCode===6&&ce.repeat)){if(ce.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(ce.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(ce.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(ce.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Ae.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=ce.altKey,this.A.ctrlKey=ce.ctrlKey,this.A.metaKey=ce.metaKey,this.A.shiftKey=ce.shiftKey,this.A.lastKeyPressed&&(this.A.event=ce,this.fire(this.A))}},!0)),ee.add(w(K,"keyup",ce=>{ce.defaultPrevented||(!ce.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!ce.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!ce.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!ce.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=ce.altKey,this.A.ctrlKey=ce.ctrlKey,this.A.metaKey=ce.metaKey,this.A.shiftKey=ce.shiftKey,this.A.lastKeyReleased&&(this.A.event=ce,this.fire(this.A)))},!0)),ee.add(w(K.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add(w(K.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add(w(K.document.body,"mousemove",ce=>{ce.buttons&&(this.A.lastKeyPressed=void 0)},!0)),ee.add(w(K,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return wt.B||(wt.B=new wt),wt.B}dispose(){super.dispose(),this.o.dispose()}}e.$8R=wt;function Wi(V){const K=document.cookie.match("(^|[^;]+)\\s*"+V+"\\s*=\\s*([^;]+)");return K?K.pop():void 0}e.$9R=Wi;class Vi extends p.$Tc{constructor(K,ee){super(),this.j=K,this.m=ee,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(w(this.j,e.$AR.DRAG_START,K=>{this.m.onDragStart?.(K)})),this.m.onDrag&&this.B(w(this.j,e.$AR.DRAG,K=>{this.m.onDrag?.(K)})),this.B(w(this.j,e.$AR.DRAG_ENTER,K=>{this.f++,this.g=K.timeStamp,this.m.onDragEnter?.(K)})),this.B(w(this.j,e.$AR.DRAG_OVER,K=>{K.preventDefault(),this.m.onDragOver?.(K,K.timeStamp-this.g)})),this.B(w(this.j,e.$AR.DRAG_LEAVE,K=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(K))})),this.B(w(this.j,e.$AR.DRAG_END,K=>{this.f=0,this.g=0,this.m.onDragEnd?.(K)})),this.B(w(this.j,e.$AR.DROP,K=>{this.f=0,this.g=0,this.m.onDrop?.(K)}))}}e.$0R=Vi;const _i=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(V,...K){let ee,ce;Array.isArray(K[0])?(ee={},ce=K[0]):(ee=K[0]||{},ce=K[1]);const Ae=_i.exec(V);if(!Ae||!Ae.groups)throw new Error("Bad use of h");const ze=Ae.groups.tag||"div",Oe=document.createElement(ze);Ae.groups.id&&(Oe.id=Ae.groups.id);const We=[];if(Ae.groups.class)for(const Ke of Ae.groups.class.split("."))Ke!==""&&We.push(Ke);if(ee.className!==void 0)for(const Ke of ee.className.split("."))Ke!==""&&We.push(Ke);We.length>0&&(Oe.className=We.join(" "));const qe={};if(Ae.groups.name&&(qe[Ae.groups.name]=Oe),ce)for(const Ke of ce)Ke instanceof HTMLElement?Oe.appendChild(Ke):typeof Ke=="string"?Oe.append(Ke):"root"in Ke&&(Object.assign(qe,Ke),Oe.appendChild(Ke.root));for(const[Ke,at]of Object.entries(ee))if(Ke!=="className")if(Ke==="style")for(const[Ct,Bt]of Object.entries(at))Oe.style.setProperty(ei(Ct),typeof Bt=="number"?Bt+"px":""+Bt);else Ke==="tabIndex"?Oe.tabIndex=at:Oe.setAttribute(ei(Ke),at.toString());return qe.root=Oe,qe}e.h=qi;function ei(V){return V.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(V,K,ee){for(const{name:ce,value:Ae}of V.attributes)(!ee||ee.includes(ce))&&K.setAttribute(ce,Ae)}e.$_R=ti;function Ki(V,K,ee){const ce=V.getAttribute(ee);ce?K.setAttribute(ee,ce):K.removeAttribute(ee)}function Qi(V,K,ee){ti(V,K,ee);const ce=new p.$Sc;return ce.add(e.$rR.observe(V,ce,{attributes:!0,attributeFilter:ee})(Ae=>{for(const ze of Ae)ze.type==="attributes"&&ze.attributeName&&Ki(V,K,ze.attributeName)})),ce}e.$aS=Qi}),define(me[56],$e([1,0,2,3,119]),function(se,e,A,N,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dS=e.$cS=e.$bS=void 0;class W extends N.$Tc{constructor(b,$){super(),this.B((0,A.$GQ)(b,"dragover",p=>{p.preventDefault(),this.a||(this.a=setTimeout(()=>{$(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(p=>{this.B((0,A.$GQ)(b,p,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}e.$bS=W,e.$cS={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:n.$qs.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function D(S,b,$,p,O){const l=document.createElement("div");if(l.className=$,l.textContent=b,O&&(l.style.color=O),p&&(l.style.background=p),S.dataTransfer){const f=(0,A.getWindow)(S).document;f.body.appendChild(l),S.dataTransfer.setDragImage(l,-10,-10),setTimeout(()=>f.body.removeChild(l),0)}}e.$dS=D}),define(me[57],$e([1,0,2]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JS=e.$IS=e.$HS=void 0;function N(l,f={}){const t=W(f);return t.textContent=l,t}e.$HS=N;function n(l,f={}){const t=W(f);return b(t,$(l,!!f.renderCodeSegments),f.actionHandler,f.renderCodeSegments),t}e.$IS=n;function W(l){const f=l.inline?"span":"div",t=document.createElement(f);return l.className&&(t.className=l.className),t}e.$JS=W;class D{constructor(f){this.b=f,this.c=0}eos(){return this.c>=this.b.length}next(){const f=this.peek();return this.advance(),f}peek(){return this.b[this.c]}advance(){this.c++}}var S;(function(l){l[l.Invalid=0]="Invalid",l[l.Root=1]="Root",l[l.Text=2]="Text",l[l.Bold=3]="Bold",l[l.Italics=4]="Italics",l[l.Action=5]="Action",l[l.ActionClose=6]="ActionClose",l[l.Code=7]="Code",l[l.NewLine=8]="NewLine"})(S||(S={}));function b(l,f,t,s){let c;if(f.type===2)c=document.createTextNode(f.content||"");else if(f.type===3)c=document.createElement("b");else if(f.type===4)c=document.createElement("i");else if(f.type===7&&s)c=document.createElement("code");else if(f.type===5&&t){const g=document.createElement("a");t.disposables.add(A.$HQ(g,"click",u=>{t.callback(String(f.index),u)})),c=g}else f.type===8?c=document.createElement("br"):f.type===1&&(c=l);c&&l!==c&&l.appendChild(c),c&&Array.isArray(f.children)&&f.children.forEach(g=>{b(c,g,t,s)})}function $(l,f){const t={type:1,children:[]};let s=0,c=t;const g=[],u=new D(l);for(;!u.eos();){let w=u.next();const h=w==="\\"&&O(u.peek(),f)!==0;if(h&&(w=u.next()),!h&&p(w,f)&&w===u.peek()){u.advance(),c.type===2&&(c=g.pop());const m=O(w,f);if(c.type===m||c.type===5&&m===6)c=g.pop();else{const a={type:m,children:[]};m===5&&(a.index=s,s++),c.children.push(a),g.push(c),c=a}}else if(w===`
`)c.type===2&&(c=g.pop()),c.children.push({type:8});else if(c.type!==2){const m={type:2,content:w};c.children.push(m),g.push(c),c=m}else c.content+=w}return c.type===2&&(c=g.pop()),g.length,t}function p(l,f){return O(l,f)!==0}function O(l,f){switch(l){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return f?7:0;default:return 0}}}),define(me[58],$e([1,0,2,3]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hS=void 0;class n{constructor(){this.a=new N.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(D,S){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const b=this.c;this.c=null,D&&b&&b(S)}isMonitoring(){return!!this.b}startMonitoring(D,S,b,$,p){this.isMonitoring()&&this.stopMonitoring(!1),this.b=$,this.c=p;let O=D;try{D.setPointerCapture(S),this.a.add((0,N.$Rc)(()=>{try{D.releasePointerCapture(S)}catch{}}))}catch{O=A.getWindow(D)}this.a.add(A.$GQ(O,A.$AR.POINTER_MOVE,l=>{if(l.buttons!==b){this.stopMonitoring(!0);return}l.preventDefault(),this.b(l)})),this.a.add(A.$GQ(O,A.$AR.POINTER_UP,l=>this.stopMonitoring(!0)))}}e.$hS=n});var xe=this&&this.__decorate||function(se,e,A,N){var n=arguments.length,W=n<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,A):N,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(se,e,A,N);else for(var S=se.length-1;S>=0;S--)(D=se[S])&&(W=(n<3?D(W):n>3?D(e,A,W):D(e,A))||W);return n>3&&W&&Object.defineProperty(e,A,W),W};define(me[25],$e([1,0,2,21,12,27,4,3,48]),function(se,e,A,N,n,W,D,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eS=e.EventType=void 0;var $;(function(O){O.Tap="-monaco-gesturetap",O.Change="-monaco-gesturechange",O.Start="-monaco-gesturestart",O.End="-monaco-gesturesend",O.Contextmenu="-monaco-gesturecontextmenu"})($||(e.EventType=$={}));class p extends S.$Tc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new b.$4c,this.h=new b.$4c,this.m={},this.j=null,this.n=0,this.B(D.Event.runAndSubscribe(A.onDidRegisterWindow,({window:l,disposables:f})=>{f.add(A.$GQ(l.document,"touchstart",t=>this.s(t),{passive:!1})),f.add(A.$GQ(l.document,"touchend",t=>this.u(l,t))),f.add(A.$GQ(l.document,"touchmove",t=>this.D(t),{passive:!1}))},{window:N.$_P,disposables:this.q}))}static addTarget(l){if(!p.isTouchDevice())return S.$Tc.None;p.b||(p.b=(0,S.$Mc)(new p));const f=p.b.g.push(l);return(0,S.$Rc)(f)}static ignoreTarget(l){if(!p.isTouchDevice())return S.$Tc.None;p.b||(p.b=(0,S.$Mc)(new p));const f=p.b.h.push(l);return(0,S.$Rc)(f)}static isTouchDevice(){return"ontouchstart"in N.$_P||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(l){const f=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let t=0,s=l.targetTouches.length;t<s;t++){const c=l.targetTouches.item(t);this.m[c.identifier]={id:c.identifier,initialTarget:c.target,initialTimeStamp:f,initialPageX:c.pageX,initialPageY:c.pageY,rollingTimestamps:[f],rollingPageX:[c.pageX],rollingPageY:[c.pageY]};const g=this.w($.Start,c.target);g.pageX=c.pageX,g.pageY=c.pageY,this.z(g)}this.f&&(l.preventDefault(),l.stopPropagation(),this.f=!1)}u(l,f){const t=Date.now(),s=Object.keys(this.m).length;for(let c=0,g=f.changedTouches.length;c<g;c++){const u=f.changedTouches.item(c);if(!this.m.hasOwnProperty(String(u.identifier))){console.warn("move of an UNKNOWN touch",u);continue}const w=this.m[u.identifier],h=Date.now()-w.initialTimeStamp;if(h<p.c&&Math.abs(w.initialPageX-n.$sb(w.rollingPageX))<30&&Math.abs(w.initialPageY-n.$sb(w.rollingPageY))<30){const m=this.w($.Tap,w.initialTarget);m.pageX=n.$sb(w.rollingPageX),m.pageY=n.$sb(w.rollingPageY),this.z(m)}else if(h>=p.c&&Math.abs(w.initialPageX-n.$sb(w.rollingPageX))<30&&Math.abs(w.initialPageY-n.$sb(w.rollingPageY))<30){const m=this.w($.Contextmenu,w.initialTarget);m.pageX=n.$sb(w.rollingPageX),m.pageY=n.$sb(w.rollingPageY),this.z(m)}else if(s===1){const m=n.$sb(w.rollingPageX),a=n.$sb(w.rollingPageY),y=n.$sb(w.rollingTimestamps)-w.rollingTimestamps[0],L=m-w.rollingPageX[0],R=a-w.rollingPageY[0],z=[...this.g].filter(H=>w.initialTarget instanceof Node&&H.contains(w.initialTarget));this.C(l,z,t,Math.abs(L)/y,L>0?1:-1,m,Math.abs(R)/y,R>0?1:-1,a)}this.z(this.w($.End,w.initialTarget)),delete this.m[u.identifier]}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}w(l,f){const t=document.createEvent("CustomEvent");return t.initEvent(l,!1,!0),t.initialTarget=f,t.tapCount=0,t}z(l){if(l.type===$.Tap){const f=new Date().getTime();let t=0;f-this.n>p.r?t=1:t=2,this.n=f,l.tapCount=t}else(l.type===$.Change||l.type===$.Contextmenu)&&(this.n=0);if(l.initialTarget instanceof Node){for(const f of this.h)if(f.contains(l.initialTarget))return;for(const f of this.g)f.contains(l.initialTarget)&&(f.dispatchEvent(l),this.f=!0)}}C(l,f,t,s,c,g,u,w,h){this.j=A.$QQ(l,()=>{const m=Date.now(),a=m-t;let y=0,L=0,R=!0;s+=p.a*a,u+=p.a*a,s>0&&(R=!1,y=c*s*a),u>0&&(R=!1,L=w*u*a);const z=this.w($.Change);z.translationX=y,z.translationY=L,f.forEach(H=>H.dispatchEvent(z)),R||this.C(l,f,m,s,c,g+y,u,w,h+L)})}D(l){const f=Date.now();for(let t=0,s=l.changedTouches.length;t<s;t++){const c=l.changedTouches.item(t);if(!this.m.hasOwnProperty(String(c.identifier))){console.warn("end of an UNKNOWN touch",c);continue}const g=this.m[c.identifier],u=this.w($.Change,g.initialTarget);u.translationX=c.pageX-n.$sb(g.rollingPageX),u.translationY=c.pageY-n.$sb(g.rollingPageY),u.pageX=c.pageX,u.pageY=c.pageY,this.z(u),g.rollingPageX.length>3&&(g.rollingPageX.shift(),g.rollingPageY.shift(),g.rollingTimestamps.shift()),g.rollingPageX.push(c.pageX),g.rollingPageY.push(c.pageY),g.rollingTimestamps.push(f)}this.f&&(l.preventDefault(),l.stopPropagation(),this.f=!1)}}e.$eS=p,xe([W.$Ih],p,"isTouchDevice",null)}),define(me[59],$e([1,0,2,94]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NS=e.$MS=e.$LS=void 0;const N=2e4;let n,W,D,S,b;function $(f){n=document.createElement("div"),n.className="monaco-aria-container";const t=()=>{const c=document.createElement("div");return c.className="monaco-alert",c.setAttribute("role","alert"),c.setAttribute("aria-atomic","true"),n.appendChild(c),c};W=t(),D=t();const s=()=>{const c=document.createElement("div");return c.className="monaco-status",c.setAttribute("aria-live","polite"),c.setAttribute("aria-atomic","true"),n.appendChild(c),c};S=s(),b=s(),f.appendChild(n)}e.$LS=$;function p(f){n&&(W.textContent!==f?(A.$FQ(D),l(W,f)):(A.$FQ(W),l(D,f)))}e.$MS=p;function O(f){n&&(S.textContent!==f?(A.$FQ(b),l(S,f)):(A.$FQ(S),l(b,f)))}e.$NS=O;function l(f,t){A.$FQ(f),t.length>N&&(t=t.substr(0,N)),f.textContent=t,f.style.visibility="hidden",f.style.visibility="visible"}}),define(me[121],$e([1,0,2,18]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fT=e.$eT=void 0;const n=new RegExp(`(\\\\)?\\$\\((${N.ThemeIcon.iconNameExpression}(?:${N.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(S){const b=new Array;let $,p=0,O=0;for(;($=n.exec(S))!==null;){O=$.index||0,p<O&&b.push(S.substring(p,O)),p=($.index||0)+$[0].length;const[,l,f]=$;b.push(l?`$(${f})`:D({id:f}))}return p<S.length&&b.push(S.substring(p)),b}e.$eT=W;function D(S){const b=A.$("span");return b.classList.add(...N.ThemeIcon.asClassNameArray(S)),b}e.$fT=D}),define(me[122],$e([1,0,2]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TS=void 0;function N(W){try{W.parentElement?.removeChild(W)}catch{}}class n{constructor(D){this.d=D,this.a=new Map,this.b=new Set,this.c=!1}alloc(D){let S=this.h(D).pop(),b=!1;if(S)b=this.b.has(S.domNode),b&&this.b.delete(S.domNode);else{const $=(0,A.$)(".monaco-list-row"),O=this.i(D).renderTemplate($);S={domNode:$,templateId:D,templateData:O}}return{row:S,isReusingConnectedDomNode:b}}release(D){D&&this.f(D)}transact(D){if(this.c)throw new Error("Already in transaction");this.c=!0;try{D()}finally{for(const S of this.b)this.g(S);this.b.clear(),this.c=!1}}f(D){const{domNode:S,templateId:b}=D;S&&(this.c?this.b.add(S):this.g(S)),this.h(b).push(D)}g(D){D.classList.remove("scrolling"),N(D)}h(D){let S=this.a.get(D);return S||(S=[],this.a.set(D,S)),S}dispose(){this.a.forEach((D,S)=>{for(const b of D)this.i(S).disposeTemplate(b.templateData),b.templateData=null}),this.a.clear(),this.b.clear()}i(D){const S=this.d.get(D);if(!S)throw new Error(`No renderer found for ${D}`);return S}}e.$TS=n}),define(me[123],$e([1,0,9,3]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mS=void 0;class n extends N.$Tc{constructor(D,S,b){super(),this.a=D,this.b=S,this.c=b,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new A.$oh)}setVisibility(D){this.a!==D&&(this.a=D,this.s())}setShouldBeVisible(D){this.g=D,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const D=this.r();this.h!==D&&(this.h=D,this.ensureVisibility())}setIsNeeded(D){this.j!==D&&(this.j=D,this.ensureVisibility())}setDomNode(D){this.f=D,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(D){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(D?" fade":"")))}}e.$mS=n}),define(me[124],$e([1,0,2,25,12,4,3,5]),function(se,e,A,N,n,W,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mT=void 0;class b extends D.$Tc{constructor(p,O,l,f){super(),this.f=0,this.b=f||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new W.$5d),this.h=l,this.j(),this.setOptions(p,O)}j(){this.B(N.$eS.addTarget(this.a)),[N.EventType.Tap].forEach(p=>{this.B(A.$GQ(this.a,p,O=>{this.a.focus()}))}),this.B(A.$HQ(this.a,"click",p=>{A.$CR.stop(p,!0)})),this.B(A.$HQ(this.a,"change",p=>{this.a.title=p.target.value,this.g.fire({index:p.target.selectedIndex,selected:p.target.value})})),this.B(A.$HQ(this.a,"keydown",p=>{let O=!1;S.$j?(p.keyCode===18||p.keyCode===16||p.keyCode===10)&&(O=!0):(p.keyCode===18&&p.altKey||p.keyCode===10||p.keyCode===3)&&(O=!0),O&&p.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(p,O){(!this.c||!n.$ub(this.c,p))&&(this.c=p,this.a.options.length=0,this.c.forEach((l,f)=>{this.a.add(this.m(l.text,f,l.isDisabled))})),O!==void 0&&this.select(O)}select(p){this.c.length===0?this.f=0:p>=0&&p<this.c.length?this.f=p:p>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(p){this.b.ariaLabel=p,this.a.setAttribute("aria-label",p)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(p){this.a.tabIndex=p?0:-1}render(p){p.classList.add("select-container"),p.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(p){this.h=p,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(p,O,l){const f=document.createElement("option");return f.value=p,f.text=p,f.disabled=!!l,f}}e.$mT=b}),define(me[60],$e([1,0,26,12,9,52,89,4,28]),function(se,e,A,N,n,W,D,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VU=e.$UU=e.$TU=void 0;function $(f){return typeof f=="object"&&"visibility"in f&&"data"in f}e.$TU=$;function p(f){switch(f){case!0:return 1;case!1:return 0;default:return f}}e.$UU=p;function O(f){return typeof f.collapsible=="boolean"}class l{constructor(t,s,c,g={}){this.o=t,this.p=s,this.rootRef=[],this.d=new S.$ae,this.f=new S.$5d,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new S.$5d,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new S.$5d,this.onDidSplice=this.l.event,this.m=new n.$bh(W.$2d),this.h=typeof g.collapseByDefault>"u"?!1:g.collapseByDefault,this.j=g.filter,this.k=typeof g.autoExpandSingleChildren>"u"?!1:g.autoExpandSingleChildren,this.c={parent:void 0,element:c,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(t,s,c=b.Iterable.empty(),g={}){if(t.length===0)throw new A.$RU(this.o,"Invalid tree location");g.diffIdentityProvider?this.q(g.diffIdentityProvider,t,s,c,g):this.s(t,s,c,g)}q(t,s,c,g=b.Iterable.empty(),u,w=u.diffDepth??0){const{parentNode:h}=this.G(s);if(!h.lastDiffIds)return this.s(s,c,g,u);const m=[...g],a=s[s.length-1],y=new D.$_s({getElements:()=>h.lastDiffIds},{getElements:()=>[...h.children.slice(0,a),...m,...h.children.slice(a+c)].map(E=>t.getId(E.element).toString())}).ComputeDiff(!1);if(y.quitEarly)return h.lastDiffIds=void 0,this.s(s,c,m,u);const L=s.slice(0,-1),R=(E,B,j)=>{if(w>0)for(let F=0;F<j;F++)E--,B--,this.q(t,[...L,E,0],Number.MAX_SAFE_INTEGER,m[B].children,u,w-1)};let z=Math.min(h.children.length,a+c),H=m.length;for(const E of y.changes.sort((B,j)=>j.originalStart-B.originalStart))R(z,H,z-(E.originalStart+E.originalLength)),z=E.originalStart,H=E.modifiedStart-a,this.s([...L,z],E.originalLength,b.Iterable.slice(m,H,H+E.modifiedLength),u);R(z,H,z)}s(t,s,c=b.Iterable.empty(),{onDidCreateNode:g,onDidDeleteNode:u,diffIdentityProvider:w}){const{parentNode:h,listIndex:m,revealed:a,visible:y}=this.G(t),L=[],R=b.Iterable.map(c,x=>this.w(x,h,h.visible?1:0,a,L,g)),z=t[t.length-1];let H=0;for(let x=z;x>=0&&x<h.children.length;x--){const X=h.children[x];if(X.visible){H=X.visibleChildIndex;break}}const E=[];let B=0,j=0;for(const x of R)E.push(x),j+=x.renderNodeCount,x.visible&&(x.visibleChildIndex=H+B++);const F=(0,N.$6b)(h.children,z,s,E);w?h.lastDiffIds?(0,N.$6b)(h.lastDiffIds,z,s,E.map(x=>w.getId(x.element).toString())):h.lastDiffIds=h.children.map(x=>w.getId(x.element).toString()):h.lastDiffIds=void 0;let M=0;for(const x of F)x.visible&&M++;if(M!==0)for(let x=z+E.length;x<h.children.length;x++){const X=h.children[x];X.visible&&(X.visibleChildIndex-=M)}if(h.visibleChildrenCount+=B-M,a&&y){const x=F.reduce((X,de)=>X+(de.visible?de.renderNodeCount:0),0);this.B(h,j-x),this.p.splice(m,x,L)}if(F.length>0&&u){const x=X=>{u(X),X.children.forEach(x)};F.forEach(x)}this.l.fire({insertedNodes:E,deletedNodes:F});let I=h;for(;I;){if(I.visibility===2){this.m.trigger(()=>this.refilter());break}I=I.parent}}rerender(t){if(t.length===0)throw new A.$RU(this.o,"Invalid tree location");const{node:s,listIndex:c,revealed:g}=this.F(t);s.visible&&g&&this.p.splice(c,1,[s])}updateElementHeight(t,s){if(t.length===0)throw new A.$RU(this.o,"Invalid tree location");const{listIndex:c}=this.F(t);this.p.updateElementHeight(c,s)}has(t){return this.D(t)}getListIndex(t){const{listIndex:s,visible:c,revealed:g}=this.F(t);return c&&g?s:-1}getListRenderCount(t){return this.E(t).renderNodeCount}isCollapsible(t){return this.E(t).collapsible}setCollapsible(t,s){const c=this.E(t);typeof s>"u"&&(s=!c.collapsible);const g={collapsible:s};return this.d.bufferEvents(()=>this.t(t,g))}isCollapsed(t){return this.E(t).collapsed}setCollapsed(t,s,c){const g=this.E(t);typeof s>"u"&&(s=!g.collapsed);const u={collapsed:s,recursive:c||!1};return this.d.bufferEvents(()=>this.t(t,u))}t(t,s){const{node:c,listIndex:g,revealed:u}=this.F(t),w=this.u(c,g,u,s);if(c!==this.c&&this.k&&w&&!O(s)&&c.collapsible&&!c.collapsed&&!s.recursive){let h=-1;for(let m=0;m<c.children.length;m++)if(c.children[m].visible)if(h>-1){h=-1;break}else h=m;h>-1&&this.t([...t,h],s)}return w}u(t,s,c,g){const u=this.v(t,g,!1);if(!c||!t.visible||!u)return u;const w=t.renderNodeCount,h=this.x(t),m=w-(s===-1?0:1);return this.p.splice(s+1,m,h.slice(1)),u}v(t,s,c){let g;if(t===this.c?g=!1:(O(s)?(g=t.collapsible!==s.collapsible,t.collapsible=s.collapsible):t.collapsible?(g=t.collapsed!==s.collapsed,t.collapsed=s.collapsed):g=!1,g&&this.f.fire({node:t,deep:c})),!O(s)&&s.recursive)for(const u of t.children)g=this.v(u,s,!0)||g;return g}expandTo(t){this.d.bufferEvents(()=>{let s=this.E(t);for(;s.parent;)s=s.parent,t=t.slice(0,t.length-1),s.collapsed&&this.t(t,{collapsed:!1,recursive:!1})})}refilter(){const t=this.c.renderNodeCount,s=this.z(this.c);this.p.splice(0,t,s),this.m.cancel()}w(t,s,c,g,u,w){const h={parent:s,element:t.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof t.collapsible=="boolean"?t.collapsible:typeof t.collapsed<"u",collapsed:typeof t.collapsed>"u"?this.h:t.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},m=this.C(h,c);h.visibility=m,g&&u.push(h);const a=t.children||b.Iterable.empty(),y=g&&m!==0&&!h.collapsed;let L=0,R=1;for(const z of a){const H=this.w(z,h,m,y,u,w);h.children.push(H),R+=H.renderNodeCount,H.visible&&(H.visibleChildIndex=L++)}return h.collapsible=h.collapsible||h.children.length>0,h.visibleChildrenCount=L,h.visible=m===2?L>0:m===1,h.visible?h.collapsed||(h.renderNodeCount=R):(h.renderNodeCount=0,g&&u.pop()),w?.(h),h}x(t){const s=t.renderNodeCount,c=[];return this.y(t,c),this.B(t.parent,c.length-s),c}y(t,s){if(t.visible===!1)return 0;if(s.push(t),t.renderNodeCount=1,!t.collapsed)for(const c of t.children)t.renderNodeCount+=this.y(c,s);return this.g.fire(t),t.renderNodeCount}z(t){const s=t.renderNodeCount,c=[];return this.A(t,t.visible?1:0,c),this.B(t.parent,c.length-s),c}A(t,s,c,g=!0){let u;if(t!==this.c){if(u=this.C(t,s),u===0)return t.visible=!1,t.renderNodeCount=0,!1;g&&c.push(t)}const w=c.length;t.renderNodeCount=t===this.c?0:1;let h=!1;if(!t.collapsed||u!==0){let m=0;for(const a of t.children)h=this.A(a,u,c,g&&!t.collapsed)||h,a.visible&&(a.visibleChildIndex=m++);t.visibleChildrenCount=m}else t.visibleChildrenCount=0;return t!==this.c&&(t.visible=u===2?h:u===1,t.visibility=u),t.visible?t.collapsed||(t.renderNodeCount+=c.length-w):(t.renderNodeCount=0,g&&c.pop()),this.g.fire(t),t.visible}B(t,s){if(s!==0)for(;t;)t.renderNodeCount+=s,this.g.fire(t),t=t.parent}C(t,s){const c=this.j?this.j.filter(t.element,s):1;return typeof c=="boolean"?(t.filterData=void 0,c?1:0):$(c)?(t.filterData=c.data,p(c.visibility)):(t.filterData=void 0,p(c))}D(t,s=this.c){if(!t||t.length===0)return!0;const[c,...g]=t;return c<0||c>s.children.length?!1:this.D(g,s.children[c])}E(t,s=this.c){if(!t||t.length===0)return s;const[c,...g]=t;if(c<0||c>s.children.length)throw new A.$RU(this.o,"Invalid tree location");return this.E(g,s.children[c])}F(t){if(t.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:c,revealed:g,visible:u}=this.G(t),w=t[t.length-1];if(w<0||w>s.children.length)throw new A.$RU(this.o,"Invalid tree location");const h=s.children[w];return{node:h,listIndex:c,revealed:g,visible:u&&h.visible}}G(t,s=this.c,c=0,g=!0,u=!0){const[w,...h]=t;if(w<0||w>s.children.length)throw new A.$RU(this.o,"Invalid tree location");for(let m=0;m<w;m++)c+=s.children[m].renderNodeCount;return g=g&&!s.collapsed,u=u&&s.visible,h.length===0?{parentNode:s,listIndex:c,revealed:g,visible:u}:this.G(h,s.children[w],c+1,g,u)}getNode(t=[]){return this.E(t)}getNodeLocation(t){const s=[];let c=t;for(;c.parent;)s.push(c.parent.children.indexOf(c)),c=c.parent;return s.reverse()}getParentNodeLocation(t){if(t.length!==0)return t.length===1?[]:(0,N.$tb)(t)[0]}getFirstElementChild(t){const s=this.E(t);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(t=[]){const s=this.E(t);if(s.children.length!==0)return this.H(s)}H(t){return t.children.length===0?t.element:this.H(t.children[t.children.length-1])}}e.$VU=l}),define(me[125],$e([1,0,60,26,28]),function(se,e,A,N,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3U=void 0;class W{get size(){return this.d.size}constructor(S,b,$={}){this.k=S,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new A.$VU(S,b,null,$),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,$.sorter&&(this.j={compare(p,O){return $.sorter.compare(p.element,O.element)}}),this.h=$.identityProvider}setChildren(S,b=n.Iterable.empty(),$={}){const p=this.o(S);this.l(p,this.m(b),$)}l(S,b=n.Iterable.empty(),$){const p=new Set,O=new Set,l=t=>{if(t.element===null)return;const s=t;if(p.add(s.element),this.d.set(s.element,s),this.h){const c=this.h.getId(s.element).toString();O.add(c),this.f.set(c,s)}$.onDidCreateNode?.(s)},f=t=>{if(t.element===null)return;const s=t;if(p.has(s.element)||this.d.delete(s.element),this.h){const c=this.h.getId(s.element).toString();O.has(c)||this.f.delete(c)}$.onDidDeleteNode?.(s)};this.c.splice([...S,0],Number.MAX_VALUE,b,{...$,onDidCreateNode:l,onDidDeleteNode:f})}m(S=n.Iterable.empty()){return this.j&&(S=[...S].sort(this.j.compare.bind(this.j))),n.Iterable.map(S,b=>{let $=this.d.get(b.element);if(!$&&this.h){const l=this.h.getId(b.element).toString();$=this.f.get(l)}if(!$){let l;return typeof b.collapsed>"u"?l=void 0:b.collapsed===N.ObjectTreeElementCollapseState.Collapsed||b.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed?l=!0:b.collapsed===N.ObjectTreeElementCollapseState.Expanded||b.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?l=!1:l=!!b.collapsed,{...b,children:this.m(b.children),collapsed:l}}const p=typeof b.collapsible=="boolean"?b.collapsible:$.collapsible;let O;return typeof b.collapsed>"u"||b.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed||b.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?O=$.collapsed:b.collapsed===N.ObjectTreeElementCollapseState.Collapsed?O=!0:b.collapsed===N.ObjectTreeElementCollapseState.Expanded?O=!1:O=!!b.collapsed,{...b,collapsible:p,collapsed:O,children:this.m(b.children)}})}rerender(S){const b=this.o(S);this.c.rerender(b)}updateElementHeight(S,b){const $=this.o(S);this.c.updateElementHeight($,b)}resort(S=null,b=!0){if(!this.j)return;const $=this.o(S),p=this.c.getNode($);this.l($,this.n(p,b),{})}n(S,b,$=!0){let p=[...S.children];return(b||$)&&(p=p.sort(this.j.compare.bind(this.j))),n.Iterable.map(p,O=>({element:O.element,collapsible:O.collapsible,collapsed:O.collapsed,children:this.n(O,b,!1)}))}getFirstElementChild(S=null){const b=this.o(S);return this.c.getFirstElementChild(b)}getLastElementAncestor(S=null){const b=this.o(S);return this.c.getLastElementAncestor(b)}has(S){return this.d.has(S)}getListIndex(S){const b=this.o(S);return this.c.getListIndex(b)}getListRenderCount(S){const b=this.o(S);return this.c.getListRenderCount(b)}isCollapsible(S){const b=this.o(S);return this.c.isCollapsible(b)}setCollapsible(S,b){const $=this.o(S);return this.c.setCollapsible($,b)}isCollapsed(S){const b=this.o(S);return this.c.isCollapsed(b)}setCollapsed(S,b,$){const p=this.o(S);return this.c.setCollapsed(p,b,$)}expandTo(S){const b=this.o(S);this.c.expandTo(b)}refilter(){this.c.refilter()}getNode(S=null){if(S===null)return this.c.getNode(this.c.rootRef);const b=this.d.get(S);if(!b)throw new N.$RU(this.k,`Tree element not found: ${S}`);return b}getNodeLocation(S){return S.element}getParentNodeLocation(S){if(S===null)throw new N.$RU(this.k,"Invalid getParentNodeLocation call");const b=this.d.get(S);if(!b)throw new N.$RU(this.k,`Tree element not found: ${S}`);const $=this.c.getNodeLocation(b),p=this.c.getParentNodeLocation($);return this.c.getNode(p).element}o(S){if(S===null)return[];const b=this.d.get(S);if(!b)throw new N.$RU(this.k,`Tree element not found: ${S}`);return this.c.getNodeLocation(b)}}e.$3U=W}),define(me[20],$e([1,0,2,14,19,25,3]),function(se,e,A,N,n,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iS=void 0;class S extends D.$Tc{f($,p){this.B(A.$GQ($,A.$AR.CLICK,O=>p(new n.$yQ(A.getWindow($),O))))}j($,p){this.B(A.$GQ($,A.$AR.MOUSE_DOWN,O=>p(new n.$yQ(A.getWindow($),O))))}m($,p){this.B(A.$GQ($,A.$AR.MOUSE_OVER,O=>p(new n.$yQ(A.getWindow($),O))))}u($,p){this.B(A.$GQ($,A.$AR.MOUSE_LEAVE,O=>p(new n.$yQ(A.getWindow($),O))))}z($,p){this.B(A.$GQ($,A.$AR.KEY_DOWN,O=>p(new N.$DQ(O))))}C($,p){this.B(A.$GQ($,A.$AR.KEY_UP,O=>p(new N.$DQ(O))))}D($,p){this.B(A.$GQ($,A.$AR.INPUT,p))}F($,p){this.B(A.$GQ($,A.$AR.BLUR,p))}G($,p){this.B(A.$GQ($,A.$AR.FOCUS,p))}H($,p){this.B(A.$GQ($,A.$AR.CHANGE,p))}I($){return W.$eS.ignoreTarget($)}}e.$iS=S}),define(me[40],$e([1,0,58,20,9,18,2]),function(se,e,A,N,n,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kS=e.$jS=void 0,e.$jS=11;class S extends N.$iS{constructor($){super(),this.a=$.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=$.bgWidth+"px",this.bgDomNode.style.height=$.bgHeight+"px",typeof $.top<"u"&&(this.bgDomNode.style.top="0px"),typeof $.left<"u"&&(this.bgDomNode.style.left="0px"),typeof $.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof $.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=$.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray($.icon)),this.domNode.style.position="absolute",this.domNode.style.width=e.$jS+"px",this.domNode.style.height=e.$jS+"px",typeof $.top<"u"&&(this.domNode.style.top=$.top+"px"),typeof $.left<"u"&&(this.domNode.style.left=$.left+"px"),typeof $.bottom<"u"&&(this.domNode.style.bottom=$.bottom+"px"),typeof $.right<"u"&&(this.domNode.style.right=$.right+"px"),this.g=this.B(new A.$hS),this.B(D.$HQ(this.bgDomNode,D.$AR.POINTER_DOWN,p=>this.h(p))),this.B(D.$HQ(this.domNode,D.$AR.POINTER_DOWN,p=>this.h(p))),this.b=this.B(new D.$SQ),this.c=this.B(new n.$oh)}h($){if(!$.target||!($.target instanceof Element))return;const p=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,D.getWindow($))};this.a(),this.b.cancel(),this.c.cancelAndSet(p,200),this.g.startMonitoring($.target,$.pointerId,$.buttons,O=>{},()=>{this.b.cancel(),this.c.cancel()}),$.preventDefault()}}e.$kS=S}),define(me[61],$e([1,0,2,44,58,40,123,20,5]),function(se,e,A,N,n,W,D,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nS=void 0;const $=140;class p extends S.$iS{constructor(l){super(),this.g=l.lazyRender,this.a=l.host,this.b=l.scrollable,this.c=l.scrollByPage,this.h=l.scrollbarState,this.n=this.B(new D.$mS(l.visibility,"visible scrollbar "+l.extraScrollbarClassName,"invisible scrollbar "+l.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new n.$hS),this.s=!0,this.domNode=(0,N.$gS)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(A.$GQ(this.domNode.domNode,A.$AR.POINTER_DOWN,f=>this.M(f)))}t(l){const f=this.B(new W.$kS(l));this.domNode.domNode.appendChild(f.bgDomNode),this.domNode.domNode.appendChild(f.domNode)}w(l,f,t,s){this.slider=(0,N.$gS)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(l),this.slider.setLeft(f),typeof t=="number"&&this.slider.setWidth(t),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(A.$GQ(this.slider.domNode,A.$AR.POINTER_DOWN,c=>{c.button===0&&(c.preventDefault(),this.O(c))})),this.f(this.slider.domNode,c=>{c.leftButton&&c.stopPropagation()})}y(l){return this.h.setVisibleSize(l)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(l){return this.h.setScrollSize(l)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(l){return this.h.setScrollPosition(l)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(l){l.target===this.domNode.domNode&&this.N(l)}delegatePointerDown(l){const f=this.domNode.domNode.getClientRects()[0].top,t=f+this.h.getSliderPosition(),s=f+this.h.getSliderPosition()+this.h.getSliderSize(),c=this.U(l);t<=c&&c<=s?l.button===0&&(l.preventDefault(),this.O(l)):this.N(l)}N(l){let f,t;if(l.target===this.domNode.domNode&&typeof l.offsetX=="number"&&typeof l.offsetY=="number")f=l.offsetX,t=l.offsetY;else{const c=A.$3Q(this.domNode.domNode);f=l.pageX-c.left,t=l.pageY-c.top}const s=this.S(f,t);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),l.button===0&&(l.preventDefault(),this.O(l))}O(l){if(!l.target||!(l.target instanceof Element))return;const f=this.U(l),t=this.W(l),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(l.target,l.pointerId,l.buttons,c=>{const g=this.W(c),u=Math.abs(g-t);if(b.$i&&u>$){this.P(s.getScrollPosition());return}const h=this.U(c)-f;this.P(s.getDesiredScrollPositionFromDelta(h))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(l){const f={};this.writeScrollPosition(f,l),this.b.setScrollPositionNow(f)}updateScrollbarSize(l){this.X(l),this.h.setScrollbarSize(l),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}e.$nS=p}),define(me[126],$e([1,0,19,61,40,45,17]),function(se,e,A,N,n,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oS=void 0;class S extends N.$nS{constructor($,p,O){const l=$.getScrollDimensions(),f=$.getCurrentScrollPosition();if(super({lazyRender:p.lazyRender,host:O,scrollbarState:new W.$lS(p.horizontalHasArrows?p.arrowSize:0,p.horizontal===2?0:p.horizontalScrollbarSize,p.vertical===2?0:p.verticalScrollbarSize,l.width,l.scrollWidth,f.scrollLeft),visibility:p.horizontal,extraScrollbarClassName:"horizontal",scrollable:$,scrollByPage:p.scrollByPage}),p.horizontalHasArrows){const t=(p.arrowSize-n.$jS)/2,s=(p.horizontalScrollbarSize-n.$jS)/2;this.t({className:"scra",icon:D.$kk.scrollbarButtonLeft,top:s,left:t,bottom:void 0,right:void 0,bgWidth:p.arrowSize,bgHeight:p.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new A.$AQ(null,1,0))}),this.t({className:"scra",icon:D.$kk.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:t,bgWidth:p.arrowSize,bgHeight:p.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new A.$AQ(null,-1,0))})}this.w(Math.floor((p.horizontalScrollbarSize-p.horizontalSliderSize)/2),0,void 0,p.horizontalSliderSize)}R($,p){this.slider.setWidth($),this.slider.setLeft(p)}Q($,p){this.domNode.setWidth($),this.domNode.setHeight(p),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll($){return this.s=this.J($.scrollWidth)||this.s,this.s=this.L($.scrollLeft)||this.s,this.s=this.y($.width)||this.s,this.s}S($,p){return $}U($){return $.pageX}W($){return $.pageY}X($){this.slider.setHeight($)}writeScrollPosition($,p){$.scrollLeft=p}updateOptions($){this.updateScrollbarSize($.horizontal===2?0:$.horizontalScrollbarSize),this.h.setOppositeScrollbarSize($.vertical===2?0:$.verticalScrollbarSize),this.n.setVisibility($.horizontal),this.c=$.scrollByPage}}e.$oS=S}),define(me[127],$e([1,0,19,61,40,45,17]),function(se,e,A,N,n,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pS=void 0;class S extends N.$nS{constructor($,p,O){const l=$.getScrollDimensions(),f=$.getCurrentScrollPosition();if(super({lazyRender:p.lazyRender,host:O,scrollbarState:new W.$lS(p.verticalHasArrows?p.arrowSize:0,p.vertical===2?0:p.verticalScrollbarSize,0,l.height,l.scrollHeight,f.scrollTop),visibility:p.vertical,extraScrollbarClassName:"vertical",scrollable:$,scrollByPage:p.scrollByPage}),p.verticalHasArrows){const t=(p.arrowSize-n.$jS)/2,s=(p.verticalScrollbarSize-n.$jS)/2;this.t({className:"scra",icon:D.$kk.scrollbarButtonUp,top:t,left:s,bottom:void 0,right:void 0,bgWidth:p.verticalScrollbarSize,bgHeight:p.arrowSize,onActivate:()=>this.a.onMouseWheel(new A.$AQ(null,0,1))}),this.t({className:"scra",icon:D.$kk.scrollbarButtonDown,top:void 0,left:s,bottom:t,right:void 0,bgWidth:p.verticalScrollbarSize,bgHeight:p.arrowSize,onActivate:()=>this.a.onMouseWheel(new A.$AQ(null,0,-1))})}this.w(0,Math.floor((p.verticalScrollbarSize-p.verticalSliderSize)/2),p.verticalSliderSize,void 0)}R($,p){this.slider.setHeight($),this.slider.setTop(p)}Q($,p){this.domNode.setWidth(p),this.domNode.setHeight($),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll($){return this.s=this.J($.scrollHeight)||this.s,this.s=this.L($.scrollTop)||this.s,this.s=this.y($.height)||this.s,this.s}S($,p){return p}U($){return $.pageY}W($){return $.pageX}X($){this.slider.setWidth($)}writeScrollPosition($,p){$.scrollTop=p}updateOptions($){this.updateScrollbarSize($.vertical===2?0:$.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility($.vertical),this.c=$.scrollByPage}}e.$pS=S}),define(me[62],$e([1,0,16,2,44,19,126,127,20,9,4,3,5,50,101]),function(se,e,A,N,n,W,D,S,b,$,p,O,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uS=e.$tS=e.$sS=e.$rS=e.$qS=void 0;const t=500,s=50,c=!0;class g{constructor(R,z,H){this.timestamp=R,this.deltaX=z,this.deltaY=H,this.score=0}}class u{static{this.INSTANCE=new u}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,z=0,H=1,E=this.d;do{const B=E===this.c?R:Math.pow(2,-H);if(R-=B,z+=this.b[E].score*B,E===this.c)break;E=(this.a+E-1)%this.a,H++}while(!0);return z<=.5}acceptStandardWheelEvent(R){if(A.$oQ){const z=N.getWindow(R.browserEvent),H=(0,A.$hQ)(z);this.accept(Date.now(),R.deltaX*H,R.deltaY*H)}else this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,z,H){const E=new g(R,z,H);E.score=this.f(E),this.c===-1&&this.d===-1?(this.b[0]=E,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=E)}f(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let z=.5;const H=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(R.deltaX)||!this.g(R.deltaY))&&(z+=.25),Math.min(Math.max(z,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}e.$qS=u;class w extends b.$iS{get options(){return this.a}constructor(R,z,H){super(),this.O=this.B(new p.$5d),this.onScroll=this.O.event,this.P=this.B(new p.$5d),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=y(z),this.b=H,this.B(this.b.onScroll(B=>{this.P.fire(B),this.S(B),this.O.fire(B)}));const E={onMouseWheel:B=>this.R(B),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new S.$pS(this.b,this.a,E)),this.g=this.B(new D.$oS(this.b,this.a,E)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,n.$gS)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,n.$gS)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,n.$gS)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,B=>this.Z(B)),this.u(this.t,B=>this.Y(B)),this.L=this.B(new $.$oh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,O.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,l.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new W.$AQ(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,O.$Oc)(this.w),R)){const H=E=>{this.R(new W.$AQ(E))};this.w.push(N.$GQ(this.t,N.$AR.MOUSE_WHEEL,H,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const z=u.INSTANCE;c&&z.acceptStandardWheelEvent(R);let H=!1;if(R.deltaY||R.deltaX){let B=R.deltaY*this.a.mouseWheelScrollSensitivity,j=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&j+B===0?j=B=0:Math.abs(B)>=Math.abs(j)?j=0:B=0),this.a.flipAxes&&([B,j]=[j,B]);const F=!l.$j&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||F)&&!j&&(j=B,B=0),R.browserEvent&&R.browserEvent.altKey&&(j=j*this.a.fastScrollSensitivity,B=B*this.a.fastScrollSensitivity);const M=this.b.getFutureScrollPosition();let I={};if(B){const x=s*B,X=M.scrollTop-(x<0?Math.floor(x):Math.ceil(x));this.c.writeScrollPosition(I,X)}if(j){const x=s*j,X=M.scrollLeft-(x<0?Math.floor(x):Math.ceil(x));this.g.writeScrollPosition(I,X)}I=this.b.validateScrollPosition(I),(M.scrollLeft!==I.scrollLeft||M.scrollTop!==I.scrollTop)&&(c&&this.a.mouseWheelSmoothScroll&&z.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(I):this.b.setScrollPositionNow(I),H=!0)}let E=H;!E&&this.a.alwaysConsumeMouseWheel&&(E=!0),!E&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(E=!0),E&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),z=R.scrollTop>0,H=R.scrollLeft>0,E=H?" left":"",B=z?" top":"",j=H||z?" top-left-corner":"";this.n.setClassName(`shadow${E}`),this.r.setClassName(`shadow${B}`),this.s.setClassName(`shadow${j}${B}${E}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),t)}}e.$rS=w;class h extends w{constructor(R,z){z=z||{},z.mouseWheelSmoothScroll=!1;const H=new f.$ws({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:E=>N.$QQ(N.getWindow(R),E)});super(R,z,H),this.B(H)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}e.$sS=h;class m extends w{constructor(R,z,H){super(R,z,H)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}e.$tS=m;class a extends w{constructor(R,z){z=z||{},z.mouseWheelSmoothScroll=!1;const H=new f.$ws({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:E=>N.$QQ(N.getWindow(R),E)});super(R,z,H),this.B(H),this.cb=R,this.B(this.onScroll(E=>{E.scrollTopChanged&&(this.cb.scrollTop=E.scrollTop),E.scrollLeftChanged&&(this.cb.scrollLeft=E.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}e.$uS=a;function y(L){const R={lazyRender:typeof L.lazyRender<"u"?L.lazyRender:!1,className:typeof L.className<"u"?L.className:"",useShadows:typeof L.useShadows<"u"?L.useShadows:!0,handleMouseWheel:typeof L.handleMouseWheel<"u"?L.handleMouseWheel:!0,flipAxes:typeof L.flipAxes<"u"?L.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof L.consumeMouseWheelIfScrollbarIsNeeded<"u"?L.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof L.alwaysConsumeMouseWheel<"u"?L.alwaysConsumeMouseWheel:!1,scrollYToX:typeof L.scrollYToX<"u"?L.scrollYToX:!1,mouseWheelScrollSensitivity:typeof L.mouseWheelScrollSensitivity<"u"?L.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof L.fastScrollSensitivity<"u"?L.fastScrollSensitivity:5,scrollPredominantAxis:typeof L.scrollPredominantAxis<"u"?L.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof L.mouseWheelSmoothScroll<"u"?L.mouseWheelSmoothScroll:!0,arrowSize:typeof L.arrowSize<"u"?L.arrowSize:11,listenOnDomNode:typeof L.listenOnDomNode<"u"?L.listenOnDomNode:null,horizontal:typeof L.horizontal<"u"?L.horizontal:1,horizontalScrollbarSize:typeof L.horizontalScrollbarSize<"u"?L.horizontalScrollbarSize:10,horizontalSliderSize:typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:0,horizontalHasArrows:typeof L.horizontalHasArrows<"u"?L.horizontalHasArrows:!1,vertical:typeof L.vertical<"u"?L.vertical:1,verticalScrollbarSize:typeof L.verticalScrollbarSize<"u"?L.verticalScrollbarSize:10,verticalHasArrows:typeof L.verticalHasArrows<"u"?L.verticalHasArrows:!1,verticalSliderSize:typeof L.verticalSliderSize<"u"?L.verticalSliderSize:0,scrollByPage:typeof L.scrollByPage<"u"?L.scrollByPage:!1};return R.horizontalSliderSize=typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof L.verticalSliderSize<"u"?L.verticalSliderSize:R.verticalScrollbarSize,l.$j&&(R.className+=" mac"),R}}),define(me[63],$e([1,0,56,2,23,25,62,12,9,27,4,3,49,50,85,122,6,34]),function(se,e,A,N,n,W,D,S,b,$,p,O,l,f,t,s,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XS=e.$WS=e.$VS=e.$US=e.ListViewTargetSector=void 0;const u={CurrentDragAndDropData:void 0};var w;(function(H){H[H.TOP=0]="TOP",H[H.CENTER_TOP=1]="CENTER_TOP",H[H.CENTER_BOTTOM=2]="CENTER_BOTTOM",H[H.BOTTOM=3]="BOTTOM"})(w||(e.ListViewTargetSector=w={}));const h={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(H){return[H]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class m{get context(){return this.d}set context(E){this.d=E}constructor(E){this.elements=E}update(){}getData(){return this.elements}}e.$US=m;class a{constructor(E){this.elements=E}update(){}getData(){return this.elements}}e.$VS=a;class y{constructor(){this.types=[],this.files=[]}update(E){if(E.types&&this.types.splice(0,this.types.length,...E.types),E.files){this.files.splice(0,this.files.length);for(let B=0;B<E.files.length;B++){const j=E.files.item(B);j&&(j.size||j.type)&&this.files.push(j)}}}getData(){return{types:this.types,files:this.files}}}e.$WS=y;function L(H,E){return Array.isArray(H)&&Array.isArray(E)?(0,S.$ub)(H,E):H===E}class R{constructor(E){E?.getSetSize?this.getSetSize=E.getSetSize.bind(E):this.getSetSize=(B,j,F)=>F,E?.getPosInSet?this.getPosInSet=E.getPosInSet.bind(E):this.getPosInSet=(B,j)=>j+1,E?.getRole?this.getRole=E.getRole.bind(E):this.getRole=B=>"listitem",E?.isChecked?this.isChecked=E.isChecked.bind(E):this.isChecked=B=>{}}}class z{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(E){if(E!==this.P){if(E&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=E,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const B of this.d)this.ab(B);this.X(),this.q.setScrollDimensions({width:(0,N.$6Q)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(E,B,j,F=h){if(this.R=B,this.domId=`list_id_${++z.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new b.$bh(50),this.v=!1,this.x=O.$Tc.None,this.y=0,this.G=!1,this.K=O.$Tc.None,this.L=O.$Tc.None,this.M=new O.$Sc,this.N=new p.$5d,this.O=new p.$5d,this.onDidChangeContentHeight=p.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=p.Event.latch(this.O.event,void 0,this.M),this.P=!1,F.horizontalScrolling&&F.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(F.paddingTop??0);for(const I of j)this.j.set(I.templateId,I);this.h=this.M.add(new s.$TS(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof F.mouseSupport=="boolean"?F.mouseSupport:!0),this.P=F.horizontalScrolling??h.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof F.paddingBottom>"u"?0:F.paddingBottom,this.D=new R(F.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(F.transformOptimization??h.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(W.$eS.addTarget(this.o)),this.p=this.M.add(new f.$ws({forceIntegerValues:!0,smoothScrollDuration:F.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:I=>(0,N.$QQ)((0,N.getWindow)(this.domNode),I)})),this.q=this.M.add(new D.$tS(this.o,{alwaysConsumeMouseWheel:F.alwaysConsumeMouseWheel??h.alwaysConsumeMouseWheel,horizontal:1,vertical:F.verticalScrollMode??h.verticalScrollMode,useShadows:F.useShadows??h.useShadows,mouseWheelScrollSensitivity:F.mouseWheelScrollSensitivity,fastScrollSensitivity:F.fastScrollSensitivity,scrollByPage:F.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),E.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,N.$GQ)(this.o,W.EventType.Change,I=>this.jb(I))),this.M.add((0,N.$GQ)(this.q.getDomNode(),"scroll",I=>I.target.scrollTop=0)),this.M.add((0,N.$GQ)(this.domNode,"dragover",I=>this.lb(this.hb(I)))),this.M.add((0,N.$GQ)(this.domNode,"drop",I=>this.nb(this.hb(I)))),this.M.add((0,N.$GQ)(this.domNode,"dragleave",I=>this.mb(this.hb(I)))),this.M.add((0,N.$GQ)(this.domNode,"dragend",I=>this.ob(I))),this.z=F.setRowLineHeight??h.setRowLineHeight,this.A=F.setRowHeight??h.setRowHeight,this.B=F.supportDynamicHeights??h.supportDynamicHeights,this.F=F.dnd??this.M.add(h.dnd),this.layout(F.initialSize?.height,F.initialSize?.width)}updateOptions(E){E.paddingBottom!==void 0&&(this.C=E.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),E.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(E.smoothScrolling?125:0),E.horizontalScrolling!==void 0&&(this.Q=E.horizontalScrolling);let B;if(E.scrollByPage!==void 0&&(B={...B??{},scrollByPage:E.scrollByPage}),E.mouseWheelScrollSensitivity!==void 0&&(B={...B??{},mouseWheelScrollSensitivity:E.mouseWheelScrollSensitivity}),E.fastScrollSensitivity!==void 0&&(B={...B??{},fastScrollSensitivity:E.fastScrollSensitivity}),B&&this.q.updateOptions(B),E.paddingTop!==void 0&&E.paddingTop!==this.g.paddingTop){const j=this.vb(this.k,this.m),F=E.paddingTop-this.g.paddingTop;this.g.paddingTop=E.paddingTop,this.Y(j,Math.max(0,this.k+F),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(E){this.q.delegateScrollFromMouseWheelEvent(E)}delegateVerticalScrollbarPointerDown(E){this.q.delegateVerticalScrollbarPointerDown(E)}updateElementHeight(E,B,j){if(E<0||E>=this.d.length)return;const F=this.d[E].size;if(typeof B>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[E].lastDynamicHeightWidth=void 0,B=F+this.xb(E)}if(F===B)return;const M=this.vb(this.k,this.m);let I=0;E<M.start||j!==null&&j>E&&j<M.end?I=B-F:I=0,this.g.splice(E,1,[{size:B}]),this.d[E].size=B,this.Y(M,Math.max(0,this.k+I),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(E){return new t.$SS(E)}splice(E,B,j=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(E,B,j)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(E,B,j=[]){const F=this.vb(this.k,this.m),M={start:E,end:E+B},I=l.Range.intersect(F,M),x=new Map;for(let Q=I.end-1;Q>=I.start;Q--){const ie=this.d[Q];if(ie.dragStartDisposable.dispose(),ie.checkedDisposable.dispose(),ie.row){let fe=x.get(ie.templateId);fe||(fe=[],x.set(ie.templateId,fe));const ye=this.j.get(ie.templateId);ye&&ye.disposeElement&&ye.disposeElement(ie.element,Q,ie.row.templateData,ie.size),fe.push(ie.row)}ie.row=null,ie.stale=!0}const X={start:E+B,end:this.d.length},de=l.Range.intersect(X,F),ue=l.Range.relativeComplement(X,F),te=j.map(Q=>({id:String(this.f++),element:Q,templateId:this.R.getTemplateId(Q),size:this.R.getHeight(Q),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(Q),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:O.$Tc.None,checkedDisposable:O.$Tc.None,stale:!1}));let ge;E===0&&B>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,te),ge=this.d,this.d=te):(this.g.splice(E,B,te),ge=this.d.splice(E,B,...te));const Le=j.length-B,Te=this.vb(this.k,this.m),Be=(0,t.$QS)(de,Le),le=l.Range.intersect(Te,Be);for(let Q=le.start;Q<le.end;Q++)this.bb(this.d[Q],Q);const J=l.Range.relativeComplement(Be,Te);for(const Q of J)for(let ie=Q.start;ie<Q.end;ie++)this.db(ie);const ae=ue.map(Q=>(0,t.$QS)(Q,Le)),Y=[{start:E,end:E+j.length},...ae].map(Q=>l.Range.intersect(Te,Q)).reverse();for(const Q of Y)for(let ie=Q.end-1;ie>=Q.start;ie--){const fe=this.d[ie],Ce=x.get(fe.templateId)?.pop();this.Z(ie,Ce)}for(const Q of x.values())for(const ie of Q)this.h.release(ie);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),ge.map(Q=>Q.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,N.$QQ)((0,N.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let E=0;for(const B of this.d)typeof B.width<"u"&&(E=Math.max(E,B.width));this.E=E,this.q.setScrollDimensions({scrollWidth:E===0?0:E+10}),this.O.fire(this.E)}updateWidth(E){if(!this.Q||typeof this.E>"u")return;const B=this.d[E];this.ab(B),typeof B.width<"u"&&B.width>this.E&&(this.E=B.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const E of this.d)E.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const E=this.firstVisibleIndex,B=this.g.positionAt(E),j=this.g.positionAt(E+1);return j!==-1&&(j-B)/2+B<this.scrollTop?E+1:E}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(E){return this.d[E].element}indexOf(E){return this.d.findIndex(B=>B.element===E)}domElement(E){const B=this.d[E].row;return B&&B.domNode}elementHeight(E){return this.d[E].size}elementTop(E){return this.g.positionAt(E)}indexAt(E){return this.g.indexAt(E)}indexAfter(E){return this.g.indexAfter(E)}layout(E,B){const j={height:typeof E=="number"?E:(0,N.$8Q)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,j.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(j),typeof B<"u"&&(this.n=B,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof B=="number"?B:(0,N.$6Q)(this.domNode)})}Y(E,B,j,F,M,I=!1){const x=this.vb(B,j),X=l.Range.relativeComplement(x,E).reverse(),de=l.Range.relativeComplement(E,x);if(I){const ue=l.Range.intersect(E,x);for(let te=ue.start;te<ue.end;te++)this.bb(this.d[te],te)}this.h.transact(()=>{for(const ue of de)for(let te=ue.start;te<ue.end;te++)this.db(te);for(const ue of X)for(let te=ue.end-1;te>=ue.start;te--)this.Z(te)}),F!==void 0&&(this.o.style.left=`-${F}px`),this.o.style.top=`-${B}px`,this.Q&&M!==void 0&&(this.o.style.width=`${Math.max(M,this.n)}px`),this.k=B,this.m=j}Z(E,B){const j=this.d[E];if(!j.row)if(B)j.row=B,j.stale=!0;else{const X=this.h.alloc(j.templateId);j.row=X.row,j.stale||=X.isReusingConnectedDomNode}const F=this.D.getRole(j.element)||"listitem";j.row.domNode.setAttribute("role",F);const M=this.D.isChecked(j.element);if(typeof M=="boolean")j.row.domNode.setAttribute("aria-checked",String(!!M));else if(M){const X=de=>j.row.domNode.setAttribute("aria-checked",String(!!de));X(M.value),j.checkedDisposable=M.onDidChange(X)}if(j.stale||!j.row.domNode.parentElement){const X=this.d.at(E+1)?.row?.domNode??null;this.o.insertBefore(j.row.domNode,X),j.stale=!1}this.bb(j,E);const I=this.j.get(j.templateId);if(!I)throw new Error(`No renderer found for template id ${j.templateId}`);I?.renderElement(j.element,E,j.row.templateData,j.size);const x=this.F.getDragURI(j.element);j.dragStartDisposable.dispose(),j.row.domNode.draggable=!!x,x&&(j.dragStartDisposable=(0,N.$GQ)(j.row.domNode,"dragstart",X=>this.kb(j.element,x,X))),this.Q&&(this.ab(j),this.W())}ab(E){if(!E.row||!E.row.domNode)return;E.row.domNode.style.width="fit-content",E.width=(0,N.$6Q)(E.row.domNode);const B=(0,N.getWindow)(E.row.domNode).getComputedStyle(E.row.domNode);B.paddingLeft&&(E.width+=parseFloat(B.paddingLeft)),B.paddingRight&&(E.width+=parseFloat(B.paddingRight)),E.row.domNode.style.width=""}bb(E,B){E.row.domNode.style.top=`${this.elementTop(B)}px`,this.A&&(E.row.domNode.style.height=`${E.size}px`),this.z&&(E.row.domNode.style.lineHeight=`${E.size}px`),E.row.domNode.setAttribute("data-index",`${B}`),E.row.domNode.setAttribute("data-last-element",B===this.length-1?"true":"false"),E.row.domNode.setAttribute("data-parity",B%2===0?"even":"odd"),E.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(E.element,B,this.length))),E.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(E.element,B))),E.row.domNode.setAttribute("id",this.getElementDomId(B)),E.row.domNode.classList.toggle("drop-target",E.dropTarget)}db(E){const B=this.d[E];if(B.dragStartDisposable.dispose(),B.checkedDisposable.dispose(),B.row){const j=this.j.get(B.templateId);j&&j.disposeElement&&j.disposeElement(B.element,E,B.row.templateData,B.size),this.h.release(B.row),B.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(E,B){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:E,reuseAnimation:B})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(E){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:E})}get scrollTop(){return this.getScrollTop()}set scrollTop(E){this.setScrollTop(E)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return p.Event.map(this.M.add(new n.$KS(this.domNode,"click")).event,E=>this.eb(E),this.M)}get onMouseDblClick(){return p.Event.map(this.M.add(new n.$KS(this.domNode,"dblclick")).event,E=>this.eb(E),this.M)}get onMouseMiddleClick(){return p.Event.filter(p.Event.map(this.M.add(new n.$KS(this.domNode,"auxclick")).event,E=>this.eb(E),this.M),E=>E.browserEvent.button===1,this.M)}get onMouseUp(){return p.Event.map(this.M.add(new n.$KS(this.domNode,"mouseup")).event,E=>this.eb(E),this.M)}get onMouseDown(){return p.Event.map(this.M.add(new n.$KS(this.domNode,"mousedown")).event,E=>this.eb(E),this.M)}get onMouseOver(){return p.Event.map(this.M.add(new n.$KS(this.domNode,"mouseover")).event,E=>this.eb(E),this.M)}get onMouseMove(){return p.Event.map(this.M.add(new n.$KS(this.domNode,"mousemove")).event,E=>this.eb(E),this.M)}get onMouseOut(){return p.Event.map(this.M.add(new n.$KS(this.domNode,"mouseout")).event,E=>this.eb(E),this.M)}get onContextMenu(){return p.Event.any(p.Event.map(this.M.add(new n.$KS(this.domNode,"contextmenu")).event,E=>this.eb(E),this.M),p.Event.map(this.M.add(new n.$KS(this.domNode,W.EventType.Contextmenu)).event,E=>this.gb(E),this.M))}get onTouchStart(){return p.Event.map(this.M.add(new n.$KS(this.domNode,"touchstart")).event,E=>this.fb(E),this.M)}get onTap(){return p.Event.map(this.M.add(new n.$KS(this.o,W.EventType.Tap)).event,E=>this.gb(E),this.M)}eb(E){const B=this.ub(E.target||null),j=typeof B>"u"?void 0:this.d[B],F=j&&j.element;return{browserEvent:E,index:B,element:F}}fb(E){const B=this.ub(E.target||null),j=typeof B>"u"?void 0:this.d[B],F=j&&j.element;return{browserEvent:E,index:B,element:F}}gb(E){const B=this.ub(E.initialTarget||null),j=typeof B>"u"?void 0:this.d[B],F=j&&j.element;return{browserEvent:E,index:B,element:F}}hb(E){const B=this.ub(E.target||null),j=typeof B>"u"?void 0:this.d[B],F=j&&j.element,M=this.tb(E,B);return{browserEvent:E,index:B,element:F,sector:M}}ib(E){try{const B=this.vb(this.k,this.m);this.Y(B,E.scrollTop,E.height,E.scrollLeft,E.scrollWidth),this.B&&this.wb(E.scrollTop,E.height,E.inSmoothScrolling)}catch(B){throw console.error("Got bad scroll event:",E),B}}jb(E){E.preventDefault(),E.stopPropagation(),this.scrollTop-=E.translationY}kb(E,B,j){if(!j.dataTransfer)return;const F=this.F.getDragElements(E);if(j.dataTransfer.effectAllowed="copyMove",j.dataTransfer.setData(A.$cS.TEXT,B),j.dataTransfer.setDragImage){let M;this.F.getDragLabel&&(M=this.F.getDragLabel(F,j)),typeof M>"u"&&(M=String(F.length));const I=(0,N.$)(".monaco-drag-image");I.textContent=M;const X=(de=>{for(;de&&!de.classList.contains("monaco-workbench");)de=de.parentElement;return de||this.domNode.ownerDocument})(this.domNode);X.appendChild(I),j.dataTransfer.setDragImage(I,-10,-10),setTimeout(()=>X.removeChild(I),0)}this.domNode.classList.add("dragging"),this.H=new m(F),u.CurrentDragAndDropData=new a(F),this.F.onDragStart?.(this.H,j)}lb(E){if(E.browserEvent.preventDefault(),this.L.dispose(),u.CurrentDragAndDropData&&u.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(E.browserEvent),!E.browserEvent.dataTransfer))return!1;if(!this.H)if(u.CurrentDragAndDropData)this.H=u.CurrentDragAndDropData;else{if(!E.browserEvent.dataTransfer.types)return!1;this.H=new y}const B=this.F.onDragOver(this.H,E.element,E.index,E.sector,E.browserEvent);if(this.G=typeof B=="boolean"?B:B.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;E.browserEvent.dataTransfer.dropEffect=typeof B!="boolean"&&B.effect?.type===0?"copy":"move";let j;typeof B!="boolean"&&B.feedback?j=B.feedback:typeof E.index>"u"?j=[-1]:j=[E.index],j=(0,S.$Mb)(j).filter(M=>M>=-1&&M<this.length).sort((M,I)=>M-I),j=j[0]===-1?[-1]:j;let F=typeof B!="boolean"&&B.effect&&B.effect.position?B.effect.position:"drop-target";if(L(this.I,j)&&this.J===F)return!0;if(this.I=j,this.J=F,this.K.dispose(),j[0]===-1)this.domNode.classList.add(F),this.o.classList.add(F),this.K=(0,O.$Rc)(()=>{this.domNode.classList.remove(F),this.o.classList.remove(F)});else{if(j.length>1&&F!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");F==="drop-target-after"&&j[0]<this.length-1&&(j[0]+=1,F="drop-target-before");for(const M of j){const I=this.d[M];I.dropTarget=!0,I.row?.domNode.classList.add(F)}this.K=(0,O.$Rc)(()=>{for(const M of j){const I=this.d[M];I.dropTarget=!1,I.row?.domNode.classList.remove(F)}})}return!0}mb(E){this.L.dispose(),this.L=(0,b.$gh)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,E.element,E.index,E.browserEvent)}nb(E){if(!this.G)return;const B=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,u.CurrentDragAndDropData=void 0,!(!B||!E.browserEvent.dataTransfer)&&(E.browserEvent.preventDefault(),B.update(E.browserEvent.dataTransfer),this.F.drop(B,E.element,E.index,E.sector,E.browserEvent))}ob(E){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,u.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(E)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=O.$Tc.None}qb(E){if(!this.w){const B=(0,N.$ZQ)(this.domNode).top;this.w=(0,N.$WR)((0,N.getWindow)(this.domNode),this.rb.bind(this,B))}this.x.dispose(),this.x=(0,b.$gh)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=E.pageY}rb(E){if(this.y===void 0)return;const B=this.y-E,j=this.renderHeight-35;B<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(B-35))):B>j&&(this.scrollTop+=Math.min(14,Math.floor(.3*(B-j))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(E,B){if(B===void 0)return;const j=E.offsetY/this.d[B].size,F=Math.floor(j/.25);return(0,g.$fm)(F,0,3)}ub(E){const B=this.q.getDomNode();let j=E;for(;j instanceof HTMLElement&&j!==this.o&&B.contains(j);){const F=j.getAttribute("data-index");if(F){const M=Number(F);if(!isNaN(M))return M}j=j.parentElement}}vb(E,B){return{start:this.g.indexAt(E),end:this.g.indexAfter(E+B-1)}}wb(E,B,j){const F=this.vb(E,B);let M,I;E===this.elementTop(F.start)?(M=F.start,I=0):F.end-F.start>1&&(M=F.start+1,I=this.elementTop(M)-E);let x=0;for(;;){const X=this.vb(E,B);let de=!1;for(let ue=X.start;ue<X.end;ue++){const te=this.xb(ue);te!==0&&this.g.splice(ue,1,[this.d[ue]]),x+=te,de=de||te!==0}if(!de){x!==0&&this.V();const ue=l.Range.relativeComplement(F,X);for(const ge of ue)for(let Le=ge.start;Le<ge.end;Le++)this.d[Le].row&&this.db(Le);const te=l.Range.relativeComplement(X,F).reverse();for(const ge of te)for(let Le=ge.end-1;Le>=ge.start;Le--)this.Z(Le);for(let ge=X.start;ge<X.end;ge++)this.d[ge].row&&this.bb(this.d[ge],ge);if(typeof M=="number"){const ge=this.p.getFutureScrollPosition().scrollTop-E,Le=this.elementTop(M)-I+ge;this.setScrollTop(Le,j)}this.N.fire(this.contentHeight);return}}}xb(E){const B=this.d[E];if(this.R.getDynamicHeight){const I=this.R.getDynamicHeight(B.element);if(I!==null){const x=B.size;return B.size=I,B.lastDynamicHeightWidth=this.n,I-x}}if(!B.hasDynamicHeight||B.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(B.element))return 0;const j=B.size;if(B.row)return B.row.domNode.style.height="",B.size=B.row.domNode.offsetHeight,B.lastDynamicHeightWidth=this.n,B.size-j;const{row:F}=this.h.alloc(B.templateId);F.domNode.style.height="",this.o.appendChild(F.domNode);const M=this.j.get(B.templateId);if(!M)throw new c.$cb("Missing renderer for templateId: "+B.templateId);return M.renderElement(B.element,E,F.templateData,void 0),B.size=F.domNode.offsetHeight,M.disposeElement?.(B.element,E,F.templateData,void 0),this.R.setDynamicHeight?.(B.element,B.size),B.lastDynamicHeightWidth=this.n,this.o.removeChild(F.domNode),this.h.release(F),B.size-j}getElementDomId(E){return`${this.domId}_${E}`}dispose(){for(const E of this.d)if(E.dragStartDisposable.dispose(),E.checkedDisposable.dispose(),E.row){const B=this.j.get(E.row.templateId);B&&(B.disposeElement?.(E.element,-1,E.row.templateData,void 0),B.disposeTemplate(E.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}e.$XS=z,xe([$.$Ih],z.prototype,"onMouseClick",null),xe([$.$Ih],z.prototype,"onMouseDblClick",null),xe([$.$Ih],z.prototype,"onMouseMiddleClick",null),xe([$.$Ih],z.prototype,"onMouseUp",null),xe([$.$Ih],z.prototype,"onMouseDown",null),xe([$.$Ih],z.prototype,"onMouseOver",null),xe([$.$Ih],z.prototype,"onMouseMove",null),xe([$.$Ih],z.prototype,"onMouseOut",null),xe([$.$Ih],z.prototype,"onContextMenu",null),xe([$.$Ih],z.prototype,"onTouchStart",null),xe([$.$Ih],z.prototype,"onTap",null)}),define(me[41],$e([1,0,2,23,14,25,59,73,12,9,76,27,4,36,3,34,5,7,72,63,19,100]),function(se,e,A,N,n,W,D,S,b,$,p,O,l,f,t,s,c,g,u,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dT=e.$cT=e.$bT=e.$aT=e.$_S=e.$$S=e.$0S=e.TypeNavigationMode=e.$9S=e.$8S=e.$7S=e.$6S=e.$5S=e.$4S=e.$3S=e.$2S=void 0;class m{constructor(d){this.d=d,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(d){return d}renderElement(d,k,C){const r=this.c.findIndex(i=>i.templateData===C);if(r>=0){const i=this.c[r];this.d.unrender(C),i.index=k}else{const i={index:k,templateData:C};this.c.push(i)}this.d.renderIndex(k,C)}splice(d,k,C){const r=[];for(const i of this.c)i.index<d?r.push(i):i.index>=d+k&&r.push({index:i.index+C-k,templateData:i.templateData});this.c=r}renderIndexes(d){for(const{index:k,templateData:C}of this.c)d.indexOf(k)>-1&&this.d.renderIndex(k,C)}disposeTemplate(d){const k=this.c.findIndex(C=>C.templateData===d);k<0||this.c.splice(k,1)}}class a{get name(){return this.g}get renderer(){return new m(this)}constructor(d){this.g=d,this.c=[],this.d=[],this.f=new l.$5d,this.onChange=this.f.event}splice(d,k,C){const r=C.length-k,i=d+k,o=[];let v=0;for(;v<this.d.length&&this.d[v]<d;)o.push(this.d[v++]);for(let P=0;P<C.length;P++)C[P]&&o.push(P+d);for(;v<this.d.length&&this.d[v]>=i;)o.push(this.d[v++]+r);this.renderer.splice(d,k,C.length),this.h(o,o)}renderIndex(d,k){k.classList.toggle(this.g,this.contains(d))}unrender(d){d.classList.remove(this.g)}set(d,k){return this.h(d,[...d].sort(ie),k)}h(d,k,C){const r=this.c,i=this.d;this.c=d,this.d=k;const o=Y(i,d);return this.renderer.renderIndexes(o),this.f.fire({indexes:d,browserEvent:C}),r}get(){return this.c}contains(d){return(0,b.$wb)(this.d,d,ie)>=0}dispose(){(0,t.$Oc)(this.f)}}xe([O.$Ih],a.prototype,"renderer",null);class y extends a{constructor(d){super("selected"),this.k=d}renderIndex(d,k){super.renderIndex(d,k),this.k&&(this.contains(d)?k.setAttribute("aria-selected","true"):k.setAttribute("aria-selected","false"))}}class L{constructor(d,k,C){this.c=d,this.d=k,this.f=C}splice(d,k,C){if(!this.f)return this.c.splice(d,k,new Array(C.length).fill(!1));const r=this.c.get().map(v=>this.f.getId(this.d.element(v)).toString());if(r.length===0)return this.c.splice(d,k,new Array(C.length).fill(!1));const i=new Set(r),o=C.map(v=>i.has(this.f.getId(v).toString()));this.c.splice(d,k,o)}}function R(q){return q.tagName==="INPUT"||q.tagName==="TEXTAREA"}e.$2S=R;function z(q,d){return q.classList.contains(d)?!0:q.classList.contains("monaco-list")||!q.parentElement?!1:z(q.parentElement,d)}function H(q){return z(q,"monaco-editor")}e.$3S=H;function E(q){return z(q,"monaco-custom-toggle")}e.$4S=E;function B(q){return z(q,"action-item")}e.$5S=B;function j(q){return z(q,"monaco-tl-twistie")}e.$6S=j;function F(q){return z(q,"monaco-tree-sticky-row")}e.$7S=F;function M(q){return q.classList.contains("monaco-tree-sticky-container")}e.$8S=M;function I(q){return q.tagName==="A"&&q.classList.contains("monaco-button")||q.tagName==="DIV"&&q.classList.contains("monaco-button-dropdown")?!0:q.classList.contains("monaco-list")||!q.parentElement?!1:I(q.parentElement)}e.$9S=I;class x{get g(){return l.Event.chain(this.c.add(new N.$KS(this.k.domNode,"keydown")).event,d=>d.filter(k=>!R(k.target)).map(k=>new n.$DQ(k)))}constructor(d,k,C){this.h=d,this.k=k,this.c=new t.$Sc,this.d=new t.$Sc,this.f=C.multipleSelectionSupport,this.c.add(this.g(r=>{switch(r.keyCode){case 3:return this.l(r);case 16:return this.o(r);case 18:return this.p(r);case 11:return this.q(r);case 12:return this.s(r);case 9:return this.u(r);case 31:this.f&&(c.$j?r.metaKey:r.ctrlKey)&&this.t(r)}}))}updateOptions(d){d.multipleSelectionSupport!==void 0&&(this.f=d.multipleSelectionSupport)}l(d){d.preventDefault(),d.stopPropagation(),this.h.setSelection(this.h.getFocus(),d.browserEvent)}o(d){d.preventDefault(),d.stopPropagation(),this.h.focusPrevious(1,!1,d.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}p(d){d.preventDefault(),d.stopPropagation(),this.h.focusNext(1,!1,d.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}q(d){d.preventDefault(),d.stopPropagation(),this.h.focusPreviousPage(d.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}s(d){d.preventDefault(),d.stopPropagation(),this.h.focusNextPage(d.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}t(d){d.preventDefault(),d.stopPropagation(),this.h.setSelection((0,b.$Sb)(this.h.length),d.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(d){this.h.getSelection().length&&(d.preventDefault(),d.stopPropagation(),this.h.setSelection([],d.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}xe([O.$Ih],x.prototype,"g",null);var X;(function(q){q[q.Automatic=0]="Automatic",q[q.Trigger=1]="Trigger"})(X||(e.TypeNavigationMode=X={}));var de;(function(q){q[q.Idle=0]="Idle",q[q.Typing=1]="Typing"})(de||(de={})),e.$0S=new class{mightProducePrintableCharacter(q){return q.ctrlKey||q.metaKey||q.altKey?!1:q.keyCode>=31&&q.keyCode<=56||q.keyCode>=21&&q.keyCode<=30||q.keyCode>=98&&q.keyCode<=107||q.keyCode>=85&&q.keyCode<=95}};class ue{constructor(d,k,C,r,i){this.o=d,this.p=k,this.q=C,this.s=r,this.t=i,this.c=!1,this.d=de.Idle,this.f=X.Automatic,this.g=!1,this.h=-1,this.k=new t.$Sc,this.l=new t.$Sc,this.updateOptions(d.options)}updateOptions(d){d.typeNavigationEnabled??!0?this.u():this.v(),this.f=d.typeNavigationMode??X.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let d=!1;const k=l.Event.chain(this.k.add(new N.$KS(this.p.domNode,"keydown")).event,i=>i.filter(o=>!R(o.target)).filter(()=>this.f===X.Automatic||this.g).map(o=>new n.$DQ(o)).filter(o=>d||this.s(o)).filter(o=>this.t.mightProducePrintableCharacter(o)).forEach(o=>A.$CR.stop(o,!0)).map(o=>o.browserEvent.key)),C=l.Event.debounce(k,()=>null,800,void 0,void 0,void 0,this.k);l.Event.reduce(l.Event.any(k,C),(i,o)=>o===null?null:(i||"")+o,void 0,this.k)(this.x,this,this.k),C(this.w,this,this.k),k(()=>d=!0,void 0,this.k),C(()=>d=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const d=this.o.getFocus();if(d.length>0&&d[0]===this.h){const k=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(d[0]));k&&(0,D.$MS)(k)}this.h=-1}x(d){if(!d){this.d=de.Idle,this.g=!1;return}const k=this.o.getFocus(),C=k.length>0?k[0]:0,r=this.d===de.Idle?1:0;this.d=de.Typing;for(let i=0;i<this.o.length;i++){const o=(C+i+r)%this.o.length,v=this.q.getKeyboardNavigationLabel(this.p.element(o)),P=v&&v.toString();if(this.o.options.typeNavigationEnabled){if(typeof P<"u"){if((0,f.$6j)(d,P)){this.h=C,this.o.setFocus([o]),this.o.reveal(o);return}const T=(0,f.$ak)(d,P);if(T&&T[0].end-T[0].start>1&&T.length===1){this.h=C,this.o.setFocus([o]),this.o.reveal(o);return}}}else if(typeof P>"u"||(0,f.$6j)(d,P)){this.h=C,this.o.setFocus([o]),this.o.reveal(o);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class te{constructor(d,k){this.d=d,this.f=k,this.c=new t.$Sc;const C=l.Event.chain(this.c.add(new N.$KS(k.domNode,"keydown")).event,i=>i.filter(o=>!R(o.target)).map(o=>new n.$DQ(o)));l.Event.chain(C,i=>i.filter(o=>o.keyCode===2&&!o.ctrlKey&&!o.metaKey&&!o.shiftKey&&!o.altKey))(this.g,this,this.c)}g(d){if(d.target!==this.f.domNode)return;const k=this.d.getFocus();if(k.length===0)return;const C=this.f.domElement(k[0]);if(!C)return;const r=C.querySelector("[tabIndex]");if(!r||!(r instanceof HTMLElement)||r.tabIndex===-1)return;const i=(0,A.getWindow)(r).getComputedStyle(r);i.visibility==="hidden"||i.display==="none"||(d.preventDefault(),d.stopPropagation(),r.focus())}dispose(){this.c.dispose()}}function ge(q){return c.$j?q.browserEvent.metaKey:q.browserEvent.ctrlKey}e.$$S=ge;function Le(q){return q.browserEvent.shiftKey}e.$_S=Le;function Te(q){return(0,A.$wR)(q)&&q.button===2}const Be={isSelectionSingleChangeEvent:ge,isSelectionRangeChangeEvent:Le};class le{constructor(d){this.k=d,this.f=new t.$Sc,this.g=new l.$5d,this.onPointer=this.g.event,d.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Be),this.d=typeof d.options.mouseSupport>"u"||!!d.options.mouseSupport,this.d&&(d.onMouseDown(this.s,this,this.f),d.onContextMenu(this.t,this,this.f),d.onMouseDblClick(this.v,this,this.f),d.onTouchStart(this.s,this,this.f),this.f.add(W.$eS.addTarget(d.getHTMLElement()))),l.Event.any(d.onMouseClick,d.onMouseMiddleClick,d.onTap)(this.u,this,this.f)}updateOptions(d){d.multipleSelectionSupport!==void 0&&(this.c=void 0,d.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Be))}o(d){return this.c?this.c.isSelectionSingleChangeEvent(d):!1}p(d){return this.c?this.c.isSelectionRangeChangeEvent(d):!1}q(d){return this.o(d)||this.p(d)}s(d){H(d.browserEvent.target)||(0,A.$gR)()!==d.browserEvent.target&&this.k.domFocus()}t(d){if(R(d.browserEvent.target)||H(d.browserEvent.target))return;const k=typeof d.index>"u"?[]:[d.index];this.k.setFocus(k,d.browserEvent)}u(d){if(!this.d||R(d.browserEvent.target)||H(d.browserEvent.target)||d.browserEvent.isHandledByList)return;d.browserEvent.isHandledByList=!0;const k=d.index;if(typeof k>"u"){this.k.setFocus([],d.browserEvent),this.k.setSelection([],d.browserEvent),this.k.setAnchor(void 0);return}if(this.q(d))return this.w(d);this.k.setFocus([k],d.browserEvent),this.k.setAnchor(k),Te(d.browserEvent)||this.k.setSelection([k],d.browserEvent),this.g.fire(d)}v(d){if(R(d.browserEvent.target)||H(d.browserEvent.target)||this.q(d)||d.browserEvent.isHandledByList)return;d.browserEvent.isHandledByList=!0;const k=this.k.getFocus();this.k.setSelection(k,d.browserEvent)}w(d){const k=d.index;let C=this.k.getAnchor();if(this.p(d)){typeof C>"u"&&(C=this.k.getFocus()[0]??k,this.k.setAnchor(C));const r=Math.min(C,k),i=Math.max(C,k),o=(0,b.$Sb)(r,i+1),v=this.k.getSelection(),P=re(Y(v,[C]),C);if(P.length===0)return;const T=Y(o,Q(v,P));this.k.setSelection(T,d.browserEvent),this.k.setFocus([k],d.browserEvent)}else if(this.o(d)){const r=this.k.getSelection(),i=r.filter(o=>o!==k);this.k.setFocus([k]),this.k.setAnchor(k),r.length===i.length?this.k.setSelection([...i,k],d.browserEvent):this.k.setSelection(i,d.browserEvent)}}dispose(){this.f.dispose()}}e.$aT=le;class J{constructor(d,k){this.c=d,this.d=k}style(d){const k=this.d&&`.${this.d}`,C=[];d.listBackground&&C.push(`.monaco-list${k} .monaco-list-rows { background: ${d.listBackground}; }`),d.listFocusBackground&&(C.push(`.monaco-list${k}:focus .monaco-list-row.focused { background-color: ${d.listFocusBackground}; }`),C.push(`.monaco-list${k}:focus .monaco-list-row.focused:hover { background-color: ${d.listFocusBackground}; }`)),d.listFocusForeground&&C.push(`.monaco-list${k}:focus .monaco-list-row.focused { color: ${d.listFocusForeground}; }`),d.listActiveSelectionBackground&&(C.push(`.monaco-list${k}:focus .monaco-list-row.selected { background-color: ${d.listActiveSelectionBackground}; }`),C.push(`.monaco-list${k}:focus .monaco-list-row.selected:hover { background-color: ${d.listActiveSelectionBackground}; }`)),d.listActiveSelectionForeground&&C.push(`.monaco-list${k}:focus .monaco-list-row.selected { color: ${d.listActiveSelectionForeground}; }`),d.listActiveSelectionIconForeground&&C.push(`.monaco-list${k}:focus .monaco-list-row.selected .codicon { color: ${d.listActiveSelectionIconForeground}; }`),d.listFocusAndSelectionBackground&&C.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.selected.focused { background-color: ${d.listFocusAndSelectionBackground}; }
			`),d.listFocusAndSelectionForeground&&C.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.selected.focused { color: ${d.listFocusAndSelectionForeground}; }
			`),d.listInactiveFocusForeground&&(C.push(`.monaco-list${k} .monaco-list-row.focused { color:  ${d.listInactiveFocusForeground}; }`),C.push(`.monaco-list${k} .monaco-list-row.focused:hover { color:  ${d.listInactiveFocusForeground}; }`)),d.listInactiveSelectionIconForeground&&C.push(`.monaco-list${k} .monaco-list-row.focused .codicon { color:  ${d.listInactiveSelectionIconForeground}; }`),d.listInactiveFocusBackground&&(C.push(`.monaco-list${k} .monaco-list-row.focused { background-color:  ${d.listInactiveFocusBackground}; }`),C.push(`.monaco-list${k} .monaco-list-row.focused:hover { background-color:  ${d.listInactiveFocusBackground}; }`)),d.listInactiveSelectionBackground&&(C.push(`.monaco-list${k} .monaco-list-row.selected { background-color:  ${d.listInactiveSelectionBackground}; }`),C.push(`.monaco-list${k} .monaco-list-row.selected:hover { background-color:  ${d.listInactiveSelectionBackground}; }`)),d.listInactiveSelectionForeground&&C.push(`.monaco-list${k} .monaco-list-row.selected { color: ${d.listInactiveSelectionForeground}; }`),d.listHoverBackground&&C.push(`.monaco-list${k}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${d.listHoverBackground}; }`),d.listHoverForeground&&C.push(`.monaco-list${k}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${d.listHoverForeground}; }`);const r=(0,A.$ZR)(d.listFocusAndSelectionOutline,(0,A.$ZR)(d.listSelectionOutline,d.listFocusOutline??""));r&&C.push(`.monaco-list${k}:focus .monaco-list-row.focused.selected { outline: 1px solid ${r}; outline-offset: -1px;}`),d.listFocusOutline&&C.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.focused { outline: 1px solid ${d.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${k}.last-focused .monaco-list-row.focused { outline: 1px solid ${d.listFocusOutline}; outline-offset: -1px; }
			`);const i=(0,A.$ZR)(d.listSelectionOutline,d.listInactiveFocusOutline??"");i&&C.push(`.monaco-list${k} .monaco-list-row.focused.selected { outline: 1px dotted ${i}; outline-offset: -1px; }`),d.listSelectionOutline&&C.push(`.monaco-list${k} .monaco-list-row.selected { outline: 1px dotted ${d.listSelectionOutline}; outline-offset: -1px; }`),d.listInactiveFocusOutline&&C.push(`.monaco-list${k} .monaco-list-row.focused { outline: 1px dotted ${d.listInactiveFocusOutline}; outline-offset: -1px; }`),d.listHoverOutline&&C.push(`.monaco-list${k} .monaco-list-row:hover { outline: 1px dashed ${d.listHoverOutline}; outline-offset: -1px; }`),d.listDropOverBackground&&C.push(`
				.monaco-list${k}.drop-target,
				.monaco-list${k} .monaco-list-rows.drop-target,
				.monaco-list${k} .monaco-list-row.drop-target { background-color: ${d.listDropOverBackground} !important; color: inherit !important; }
			`),d.listDropBetweenBackground&&(C.push(`
			.monaco-list${k} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${k} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${d.listDropBetweenBackground};
			}`),C.push(`
			.monaco-list${k} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${k} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${d.listDropBetweenBackground};
			}`)),d.tableColumnsBorder&&C.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${d.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),d.tableOddRowsBackgroundColor&&C.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${d.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=C.join(`
`)}}e.$bT=J,e.$cT={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:p.$xt.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:p.$xt.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:p.$xt.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ae={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function re(q,d){const k=q.indexOf(d);if(k===-1)return[];const C=[];let r=k-1;for(;r>=0&&q[r]===d-(k-r);)C.push(q[r--]);for(C.reverse(),r=k;r<q.length&&q[r]===d+(r-k);)C.push(q[r++]);return C}function Y(q,d){const k=[];let C=0,r=0;for(;C<q.length||r<d.length;)if(C>=q.length)k.push(d[r++]);else if(r>=d.length)k.push(q[C++]);else if(q[C]===d[r]){k.push(q[C]),C++,r++;continue}else q[C]<d[r]?k.push(q[C++]):k.push(d[r++]);return k}function Q(q,d){const k=[];let C=0,r=0;for(;C<q.length||r<d.length;)if(C>=q.length)k.push(d[r++]);else if(r>=d.length)k.push(q[C++]);else if(q[C]===d[r]){C++,r++;continue}else q[C]<d[r]?k.push(q[C++]):r++;return k}const ie=(q,d)=>q-d;class fe{constructor(d,k){this.c=d,this.d=k}get templateId(){return this.c}renderTemplate(d){return this.d.map(k=>k.renderTemplate(d))}renderElement(d,k,C,r){let i=0;for(const o of this.d)o.renderElement(d,k,C[i++],r)}disposeElement(d,k,C,r){let i=0;for(const o of this.d)o.disposeElement?.(d,k,C[i],r),i+=1}disposeTemplate(d){let k=0;for(const C of this.d)C.disposeTemplate(d[k++])}}class ye{constructor(d){this.c=d,this.templateId="a18n"}renderTemplate(d){return d}renderElement(d,k,C){const r=this.c.getAriaLabel(d);r?C.setAttribute("aria-label",r):C.removeAttribute("aria-label");const i=this.c.getAriaLevel&&this.c.getAriaLevel(d);typeof i=="number"?C.setAttribute("aria-level",`${i}`):C.removeAttribute("aria-level")}disposeTemplate(d){}}class Ce{constructor(d,k){this.c=d,this.d=k}getDragElements(d){const k=this.c.getSelectedElements();return k.indexOf(d)>-1?k:[d]}getDragURI(d){return this.d.getDragURI(d)}getDragLabel(d,k){if(this.d.getDragLabel)return this.d.getDragLabel(d,k)}onDragStart(d,k){this.d.onDragStart?.(d,k)}onDragOver(d,k,C,r,i){return this.d.onDragOver(d,k,C,r,i)}onDragLeave(d,k,C,r){this.d.onDragLeave?.(d,k,C,r)}onDragEnd(d){this.d.onDragEnd?.(d)}drop(d,k,C,r,i){this.d.drop(d,k,C,r,i)}dispose(){this.d.dispose()}}class ke{get onDidChangeFocus(){return l.Event.map(this.g.wrapEvent(this.c.onChange),d=>this.G(d),this.y)}get onDidChangeSelection(){return l.Event.map(this.g.wrapEvent(this.d.onChange),d=>this.G(d),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let d=!1;const k=l.Event.chain(this.y.add(new N.$KS(this.k.domNode,"keydown")).event,i=>i.map(o=>new n.$DQ(o)).filter(o=>d=o.keyCode===58||o.shiftKey&&o.keyCode===68).map(o=>A.$CR.stop(o,!0)).filter(()=>!1)),C=l.Event.chain(this.y.add(new N.$KS(this.k.domNode,"keyup")).event,i=>i.forEach(()=>d=!1).map(o=>new n.$DQ(o)).filter(o=>o.keyCode===58||o.shiftKey&&o.keyCode===68).map(o=>A.$CR.stop(o,!0)).map(({browserEvent:o})=>{const v=this.getFocus(),P=v.length?v[0]:void 0,T=typeof P<"u"?this.k.element(P):void 0,U=typeof P<"u"?this.k.domElement(P):this.k.domNode;return{index:P,element:T,anchor:U,browserEvent:o}})),r=l.Event.chain(this.k.onContextMenu,i=>i.filter(o=>!d).map(({element:o,index:v,browserEvent:P})=>({element:o,index:v,anchor:new h.$yQ((0,A.getWindow)(this.k.domNode),P),browserEvent:P})));return l.Event.any(k,C,r)}get onKeyDown(){return this.y.add(new N.$KS(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new N.$KS(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new N.$KS(this.k.domNode,"keypress")).event}get onDidFocus(){return l.Event.signal(this.y.add(new N.$KS(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return l.Event.signal(this.y.add(new N.$KS(this.k.domNode,"blur",!0)).event)}constructor(d,k,C,r,i=ae){this.A=d,this.B=i,this.c=new a("focused"),this.f=new a("anchor"),this.g=new l.$ae,this.x="",this.y=new t.$Sc,this.z=new l.$5d,this.onDidDispose=this.z.event;const o=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new y(o!=="listbox");const v=[this.c.renderer,this.d.renderer];this.u=i.accessibilityProvider,this.u&&(v.push(new ye(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),r=r.map(T=>new fe(T.templateId,[...v,T]));const P={...i,dnd:i.dnd&&new Ce(this,i.dnd)};if(this.k=this.C(k,C,r,P),this.k.domNode.setAttribute("role",o),i.styleController)this.q=i.styleController(this.k.domId);else{const T=(0,A.$pR)(this.k.domNode);this.q=new J(T,this.k.domId)}if(this.o=new S.$OS([new L(this.c,this.k,i.identityProvider),new L(this.d,this.k,i.identityProvider),new L(this.f,this.k,i.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new te(this,this.k)),(typeof i.keyboardSupport!="boolean"||i.keyboardSupport)&&(this.v=new x(this,this.k,i),this.y.add(this.v)),i.keyboardNavigationLabelProvider){const T=i.keyboardNavigationDelegate||e.$0S;this.t=new ue(this,this.k,i.keyboardNavigationLabelProvider,i.keyboardNavigationEventFilter??(()=>!0),T),this.y.add(this.t)}this.w=this.D(i),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(d,k,C,r){return new w.$XS(d,k,C,r)}D(d){return new le(this)}updateOptions(d={}){this.B={...this.B,...d},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(d),this.v?.updateOptions(d),this.k.updateOptions(d)}get options(){return this.B}splice(d,k,C=[]){if(d<0||d>this.k.length)throw new u.$ZS(this.A,`Invalid start index: ${d}`);if(k<0)throw new u.$ZS(this.A,`Invalid delete count: ${k}`);k===0&&C.length===0||this.g.bufferEvents(()=>this.o.splice(d,k,C))}updateWidth(d){this.k.updateWidth(d)}updateElementHeight(d,k){this.k.updateElementHeight(d,k,null)}rerender(){this.k.rerender()}element(d){return this.k.element(d)}indexOf(d){return this.k.indexOf(d)}indexAt(d){return this.k.indexAt(d)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(d){this.k.setScrollTop(d)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(d){this.k.setScrollLeft(d)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(d){this.x=d,this.k.domNode.setAttribute("aria-label",d)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(d,k){this.k.layout(d,k)}triggerTypeNavigation(){this.t?.trigger()}setSelection(d,k){for(const C of d)if(C<0||C>=this.length)throw new u.$ZS(this.A,`Invalid index ${C}`);this.d.set(d,k)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(d=>this.k.element(d))}setAnchor(d){if(typeof d>"u"){this.f.set([]);return}if(d<0||d>=this.length)throw new u.$ZS(this.A,`Invalid index ${d}`);this.f.set([d])}getAnchor(){return(0,b.$Ob)(this.f.get(),void 0)}getAnchorElement(){const d=this.getAnchor();return typeof d>"u"?void 0:this.element(d)}setFocus(d,k){for(const C of d)if(C<0||C>=this.length)throw new u.$ZS(this.A,`Invalid index ${C}`);this.c.set(d,k)}focusNext(d=1,k=!1,C,r){if(this.length===0)return;const i=this.c.get(),o=this.E(i.length>0?i[0]+d:0,k,r);o>-1&&this.setFocus([o],C)}focusPrevious(d=1,k=!1,C,r){if(this.length===0)return;const i=this.c.get(),o=this.F(i.length>0?i[0]-d:0,k,r);o>-1&&this.setFocus([o],C)}async focusNextPage(d,k){let C=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);C=C===0?0:C-1;const r=this.getFocus()[0];if(r!==C&&(r===void 0||C>r)){const i=this.F(C,!1,k);i>-1&&r!==i?this.setFocus([i],d):this.setFocus([C],d)}else{const i=this.k.getScrollTop();let o=i+this.k.renderHeight;C>r&&(o-=this.k.elementHeight(C)),this.k.setScrollTop(o),this.k.getScrollTop()!==i&&(this.setFocus([]),await(0,$.$fh)(0),await this.focusNextPage(d,k))}}async focusPreviousPage(d,k,C=()=>0){let r;const i=C(),o=this.k.getScrollTop()+i;o===0?r=this.k.indexAt(o):r=this.k.indexAfter(o-1);const v=this.getFocus()[0];if(v!==r&&(v===void 0||v>=r)){const P=this.E(r,!1,k);P>-1&&v!==P?this.setFocus([P],d):this.setFocus([r],d)}else{const P=o;this.k.setScrollTop(o-this.k.renderHeight-i),this.k.getScrollTop()+C()!==P&&(this.setFocus([]),await(0,$.$fh)(0),await this.focusPreviousPage(d,k,C))}}focusLast(d,k){if(this.length===0)return;const C=this.F(this.length-1,!1,k);C>-1&&this.setFocus([C],d)}focusFirst(d,k){this.focusNth(0,d,k)}focusNth(d,k,C){if(this.length===0)return;const r=this.E(d,!1,C);r>-1&&this.setFocus([r],k)}E(d,k=!1,C){for(let r=0;r<this.length;r++){if(d>=this.length&&!k)return-1;if(d=d%this.length,!C||C(this.element(d)))return d;d++}return-1}F(d,k=!1,C){for(let r=0;r<this.length;r++){if(d<0&&!k)return-1;if(d=(this.length+d%this.length)%this.length,!C||C(this.element(d)))return d;d--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(d=>this.k.element(d))}reveal(d,k,C=0){if(d<0||d>=this.length)throw new u.$ZS(this.A,`Invalid index ${d}`);const r=this.k.getScrollTop(),i=this.k.elementTop(d),o=this.k.elementHeight(d);if((0,g.$Wf)(k)){const v=o-this.k.renderHeight+C;this.k.setScrollTop(v*(0,s.$fm)(k,0,1)+i-C)}else{const v=i+o,P=r+this.k.renderHeight;i<r+C&&v>=P||(i<r+C||v>=P&&o>=this.k.renderHeight?this.k.setScrollTop(i-C):v>=P&&this.k.setScrollTop(v-this.k.renderHeight))}}getRelativeTop(d,k=0){if(d<0||d>=this.length)throw new u.$ZS(this.A,`Invalid index ${d}`);const C=this.k.getScrollTop(),r=this.k.elementTop(d),i=this.k.elementHeight(d);if(r<C+k||r+i>C+this.k.renderHeight)return null;const o=i-this.k.renderHeight+k;return Math.abs((C+k-r)/o)}isDOMFocused(){return(0,A.$hR)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(d){return this.k.getElementDomId(d)}getElementTop(d){return this.k.elementTop(d)}style(d){this.q.style(d)}G({indexes:d,browserEvent:k}){return{indexes:d,elements:d.map(C=>this.k.element(C)),browserEvent:k}}H(){const d=this.c.get();this.k.domNode.classList.toggle("element-focused",d.length>0),this.I()}I(){const d=this.c.get();if(d.length>0){let k;this.u?.getActiveDescendantId&&(k=this.u.getActiveDescendantId(this.k.element(d[0]))),this.k.domNode.setAttribute("aria-activedescendant",k||this.k.getElementDomId(d[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const d=this.d.get();this.k.domNode.classList.toggle("selection-none",d.length===0),this.k.domNode.classList.toggle("selection-single",d.length===1),this.k.domNode.classList.toggle("selection-multiple",d.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}e.$dT=ke,xe([O.$Ih],ke.prototype,"onDidChangeFocus",null),xe([O.$Ih],ke.prototype,"onDidChangeSelection",null),xe([O.$Ih],ke.prototype,"onContextMenu",null),xe([O.$Ih],ke.prototype,"onKeyDown",null),xe([O.$Ih],ke.prototype,"onKeyUp",null),xe([O.$Ih],ke.prototype,"onKeyPress",null),xe([O.$Ih],ke.prototype,"onDidFocus",null),xe([O.$Ih],ke.prototype,"onDidBlur",null)}),define(me[64],$e([1,0,6,37,39,10,15]),function(se,e,A,N,n,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(S||(e.MarkdownStringTextNewlineStyle=S={}));class b{constructor(u="",w=!1){if(this.value=u,typeof this.value!="string")throw(0,A.$7)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=w.isTrusted??void 0,this.supportThemeIcons=w.supportThemeIcons??!1,this.supportHtml=w.supportHtml??!1)}appendText(u,w=0){return this.value+=l(this.supportThemeIcons?(0,N.$mk)(u):u).replace(/([ \t]+)/g,(h,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,w){return this.value+=`
${f(w,u)}
`,this}appendLink(u,w,h){return this.value+="[",this.value+=this.c(w,"]"),this.value+="](",this.value+=this.c(String(u),")"),h&&(this.value+=` "${this.c(this.c(h,'"'),")")}"`),this.value+=")",this}c(u,w){const h=new RegExp((0,W.$Xe)(w),"g");return u.replace(h,(m,a)=>u.charAt(a-1)!=="\\"?`\\${m}`:m)}}e.$sk=b;function $(g){return p(g)?!g.value:Array.isArray(g)?g.every($):!0}e.$tk=$;function p(g){return g instanceof b?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||typeof g.isTrusted=="object"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.$uk=p;function O(g,u){return g===u?!0:!g||!u?!1:g.value===u.value&&g.isTrusted===u.isTrusted&&g.supportThemeIcons===u.supportThemeIcons&&g.supportHtml===u.supportHtml&&(g.baseUri===u.baseUri||!!g.baseUri&&!!u.baseUri&&(0,n.$Kg)(D.URI.from(g.baseUri),D.URI.from(u.baseUri)))}e.$vk=O;function l(g){return g.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$wk=l;function f(g,u){const w=g.match(/^`+/gm)?.reduce((m,a)=>m.length>a.length?m:a).length??0,h=w>=3?w+1:3;return[`${"`".repeat(h)}${u}`,g,`${"`".repeat(h)}`].join(`
`)}e.$xk=f;function t(g){return g.replace(/"/g,"&quot;")}e.$yk=t;function s(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$zk=s;function c(g){const u=[],w=g.split("|").map(m=>m.trim());g=w[0];const h=w[1];if(h){const m=/height=(\d+)/.exec(h),a=/width=(\d+)/.exec(h),y=m?m[1]:"",L=a?a[1]:"",R=isFinite(parseInt(L)),z=isFinite(parseInt(y));R&&u.push(`width="${L}"`),z&&u.push(`height="${y}"`)}return{href:g,dimensions:u}}e.$Ak=c}),define(me[128],$e([1,0,2,120,23,57,14,19,121,6,4,64,37,79,22,3,81,55,32,53,39,10,15]),function(se,e,A,N,n,W,D,S,b,$,p,O,l,f,t,s,c,g,u,w,h,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kT=e.$jT=e.$iT=e.$hT=e.$gT=void 0;const y=Object.freeze({image:(Q,ie,fe)=>{let ye=[],Ce=[];return Q&&({href:Q,dimensions:ye}=(0,O.$Ak)(Q),Ce.push(`src="${(0,O.$yk)(Q)}"`)),fe&&Ce.push(`alt="${(0,O.$yk)(fe)}"`),ie&&Ce.push(`title="${(0,O.$yk)(ie)}"`),ye.length&&(Ce=Ce.concat(ye)),"<img "+Ce.join(" ")+">"},paragraph:Q=>`<p>${Q}</p>`,link:(Q,ie,fe)=>typeof Q!="string"?"":(Q===fe&&(fe=(0,O.$zk)(fe)),ie=typeof ie=="string"?(0,O.$yk)((0,O.$zk)(ie)):"",Q=(0,O.$zk)(Q),Q=Q.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Q}" title="${ie||Q}" draggable="false">${fe}</a>`)});function L(Q,ie={},fe={}){const ye=new s.$Sc;let Ce=!1;const ke=(0,W.$JS)(ie),q=function(T){let U;try{U=(0,g.$Mh)(decodeURIComponent(T))}catch{}return U?(U=(0,w.$Jn)(U,_=>{if(Q.uris&&Q.uris[_])return a.URI.revive(Q.uris[_])}),encodeURIComponent(JSON.stringify(U))):T},d=function(T,U){const _=Q.uris&&Q.uris[T];let Z=a.URI.revive(_);return U?T.startsWith(u.Schemas.data+":")?T:(Z||(Z=a.URI.parse(T)),u.$yg.uriToBrowserUri(Z).toString(!0)):!Z||a.URI.parse(T).toString()===Z.toString()?T:(Z.query&&(Z=Z.with({query:q(Z.query)})),Z.toString())},k=new c.marked.Renderer;k.image=y.image,k.link=y.link,k.paragraph=y.paragraph;const C=[],r=[];if(ie.codeBlockRendererSync?k.code=(T,U)=>{const _=f.$jO.nextId(),Z=ie.codeBlockRendererSync(R(U),T);return r.push([_,Z]),`<div class="code" data-code="${_}">${(0,m.$We)(T)}</div>`}:ie.codeBlockRenderer&&(k.code=(T,U)=>{const _=f.$jO.nextId(),Z=ie.codeBlockRenderer(R(U),T);return C.push(Z.then(oe=>[_,oe])),`<div class="code" data-code="${_}">${(0,m.$We)(T)}</div>`}),ie.actionHandler){const T=function(Z){let oe=Z.target;if(!(oe.tagName!=="A"&&(oe=oe.parentElement,!oe||oe.tagName!=="A")))try{let be=oe.dataset.href;be&&(Q.baseUri&&(be=z(a.URI.from(Q.baseUri),be)),ie.actionHandler.callback(be,Z))}catch(be){(0,$.$1)(be)}finally{Z.preventDefault()}},U=ie.actionHandler.disposables.add(new n.$KS(ke,"click")),_=ie.actionHandler.disposables.add(new n.$KS(ke,"auxclick"));ie.actionHandler.disposables.add(p.Event.any(U.event,_.event)(Z=>{const oe=new S.$yQ(A.getWindow(ke),Z);!oe.leftButton&&!oe.middleButton||T(oe)})),ie.actionHandler.disposables.add(A.$GQ(ke,"keydown",Z=>{const oe=new D.$DQ(Z);!oe.equals(10)&&!oe.equals(3)||T(oe)}))}Q.supportHtml||(fe.sanitizer=T=>(Q.isTrusted?T.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?T:"",fe.sanitize=!0,fe.silent=!0),fe.renderer=k;let i=Q.value??"";i.length>1e5&&(i=`${i.substr(0,1e5)}\u2026`),Q.supportThemeIcons&&(i=(0,l.$nk)(i));let o;if(ie.fillInIncompleteTokens){const T={...c.marked.defaults,...fe},U=c.marked.lexer(i,T),_=de(U);o=c.marked.parser(_,T)}else o=c.marked.parse(i,fe);Q.supportThemeIcons&&(o=(0,b.$eT)(o).map(U=>typeof U=="string"?U:U.outerHTML).join(""));const P=new DOMParser().parseFromString(H(Q,o),"text/html");if(P.body.querySelectorAll("img").forEach(T=>{const U=T.getAttribute("src");if(U){let _=U;try{Q.baseUri&&(_=z(a.URI.from(Q.baseUri),_))}catch{}T.src=d(_,!0)}}),P.body.querySelectorAll("a").forEach(T=>{const U=T.getAttribute("href");if(T.setAttribute("href",""),!U||/^data:|javascript:/i.test(U)||/^command:/i.test(U)&&!Q.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(U))T.replaceWith(...T.childNodes);else{let _=d(U,!1);Q.baseUri&&(_=z(a.URI.from(Q.baseUri),U)),T.dataset.href=_}}),ke.innerHTML=H(Q,P.body.innerHTML),C.length>0)Promise.all(C).then(T=>{if(Ce)return;const U=new Map(T),_=ke.querySelectorAll("div[data-code]");for(const Z of _){const oe=U.get(Z.dataset.code??"");oe&&A.$JR(Z,oe)}ie.asyncRenderCallback?.()});else if(r.length>0){const T=new Map(r),U=ke.querySelectorAll("div[data-code]");for(const _ of U){const Z=T.get(_.dataset.code??"");Z&&A.$JR(_,Z)}}if(ie.asyncRenderCallback)for(const T of ke.getElementsByTagName("img")){const U=ye.add(A.$GQ(T,"load",()=>{U.dispose(),ie.asyncRenderCallback()}))}return{element:ke,dispose:()=>{Ce=!0,ye.dispose()}}}e.$gT=L;function R(Q){if(!Q)return"";const ie=Q.split(/[\s+|:|,|\{|\?]/,1);return ie.length?ie[0]:Q}function z(Q,ie){return/^\w[\w\d+.-]*:/.test(ie)?ie:Q.path.endsWith("/")?(0,h.$Ug)(Q,ie).toString():(0,h.$Ug)((0,h.$Qg)(Q),ie).toString()}function H(Q,ie){const{config:fe,allowedSchemes:ye}=E(Q);N.addHook("uponSanitizeAttribute",(ke,q)=>{if(q.attrName==="style"||q.attrName==="class"){if(ke.tagName==="SPAN"){if(q.attrName==="style"){q.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(q.attrValue);return}else if(q.attrName==="class"){q.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(q.attrValue);return}}q.keepAttr=!1;return}else if(ke.tagName==="INPUT"&&ke.attributes.getNamedItem("type")?.value==="checkbox"){if(q.attrName==="type"&&q.attrValue==="checkbox"||q.attrName==="disabled"||q.attrName==="checked"){q.keepAttr=!0;return}q.keepAttr=!1}}),N.addHook("uponSanitizeElement",(ke,q)=>{q.tagName==="input"&&(ke.attributes.getNamedItem("type")?.value==="checkbox"?ke.setAttribute("disabled",""):ke.parentElement?.removeChild(ke))});const Ce=A.$4R(ye);try{return N.sanitize(ie,{...fe,RETURN_TRUSTED_TYPE:!0})}finally{N.removeHook("uponSanitizeAttribute"),Ce.dispose()}}e.$hT=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function E(Q){const ie=[u.Schemas.http,u.Schemas.https,u.Schemas.mailto,u.Schemas.data,u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemote,u.Schemas.vscodeRemoteResource];return Q.isTrusted&&ie.push(u.Schemas.command),{config:{ALLOWED_TAGS:[...A.$5R],ALLOWED_ATTR:e.$hT,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ie}}function B(Q){return typeof Q=="string"?Q:j(Q)}e.$iT=B;function j(Q){let ie=Q.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`);const fe=c.marked.parse(ie,{renderer:M.value}).replace(/&(#\d+|[a-zA-Z]+);/g,ye=>F.get(ye)??ye);return H({isTrusted:!1},fe).toString()}e.$jT=j;const F=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),M=new t.$V(()=>{const Q=new c.marked.Renderer;return Q.code=ie=>ie,Q.blockquote=ie=>ie,Q.html=ie=>"",Q.heading=(ie,fe,ye)=>ie+`
`,Q.hr=()=>"",Q.list=(ie,fe)=>ie,Q.listitem=ie=>ie+`
`,Q.paragraph=ie=>ie+`
`,Q.table=(ie,fe)=>ie+fe+`
`,Q.tablerow=ie=>ie,Q.tablecell=(ie,fe)=>ie+" ",Q.strong=ie=>ie,Q.em=ie=>ie,Q.codespan=ie=>ie,Q.br=()=>`
`,Q.del=ie=>ie,Q.image=(ie,fe,ye)=>"",Q.text=ie=>ie,Q.link=(ie,fe,ye)=>ye,Q});function I(Q){let ie="";return Q.forEach(fe=>{ie+=fe.raw}),ie}function x(Q){for(let ie=0;ie<Q.tokens.length;ie++){const fe=Q.tokens[ie];if(fe.type==="text"){const ye=fe.raw.split(`
`),Ce=ye[ye.length-1];if(Ce.includes("`"))return te(Q);if(Ce.includes("**"))return J(Q);if(Ce.match(/\*\w/))return ge(Q);if(Ce.match(/(^|\s)__\w/))return ae(Q);if(Ce.match(/(^|\s)_\w/))return Le(Q);if(Ce.match(/(^|\s)\[.*\]\(\w*/)){const ke=Q.tokens.slice(ie+1);return ke[0]?.type==="link"&&ke[1]?.type==="text"&&ke[1].raw.match(/^ *"[^"]*$/)?Be(Q):Te(Q)}else{if(X(Ce))return Te(Q);if(Ce.match(/(^|\s)\[\w/)&&!Q.tokens.slice(ie+1).some(ke=>X(ke.raw)))return le(Q)}}}}function X(Q){return!!Q.match(/^[^\[]*\]\([^\)]*$/)}function de(Q){let ie,fe;for(ie=0;ie<Q.length;ie++){const ye=Q[ie];let Ce;if(ye.type==="paragraph"&&(Ce=ye.raw.match(/(\n|^)(````*)/))){const ke=Ce[2];fe=ue(Q.slice(ie),ke);break}if(ye.type==="paragraph"&&ye.raw.match(/(\n|^)\|/)){fe=Y(Q.slice(ie));break}if(ie===Q.length-1&&ye.type==="paragraph"){const ke=x(ye);if(ke){fe=[ke];break}}}if(fe){const ye=[...Q.slice(0,ie),...fe];return ye.links=Q.links,ye}return Q}e.$kT=de;function ue(Q,ie){const fe=I(Q);return c.marked.lexer(fe+`
${ie}`)}function te(Q){return re(Q,"`")}function ge(Q){return re(Q,"*")}function Le(Q){return re(Q,"_")}function Te(Q){return re(Q,")")}function Be(Q){return re(Q,'")')}function le(Q){return re(Q,"](about:blank)")}function J(Q){return re(Q,"**")}function ae(Q){return re(Q,"__")}function re(Q,ie){const fe=I(Array.isArray(Q)?Q:[Q]);return c.marked.lexer(fe+ie)[0]}function Y(Q){const ie=I(Q),fe=ie.split(`
`);let ye,Ce=!1;for(let ke=0;ke<fe.length;ke++){const q=fe[ke].trim();if(typeof ye>"u"&&q.match(/^\s*\|/)){const d=q.match(/(\|[^\|]+)(?=\||$)/g);d&&(ye=d.length)}else if(typeof ye=="number")if(q.match(/^\s*\|/)){if(ke!==fe.length-1)return;Ce=!0}else return}if(typeof ye=="number"&&ye>0){const ke=Ce?fe.slice(0,-1).join(`
`):ie,q=!!ke.match(/\|\s*$/),d=ke+(q?"":"|")+`
|${" --- |".repeat(ye)}`;return c.marked.lexer(d)}}}),define(me[42],$e([1,0,2,9,30,64,37,3,7,110]),function(se,e,A,N,n,W,D,S,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zS=e.$yS=void 0;function p(f,t){(0,b.$Sf)(t)?f.title=(0,D.$ok)(t):t?.markdownNotSupportedFallback?f.title=t.markdownNotSupportedFallback:f.removeAttribute("title")}e.$yS=p;class O{constructor(t,s,c){this.c=t,this.d=s,this.f=c}async update(t,s,c){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let g;if(t===void 0||(0,b.$Sf)(t)||t instanceof HTMLElement)g=t;else if(!(0,b.$7f)(t.markdown))g=t.markdown??t.markdownNotSupportedFallback;else{this.a||this.g((0,$.localize)(0,null),s),this.b=new n.$ce;const u=this.b.token;if(g=await t.markdown(u),g===void 0&&(g=t.markdownNotSupportedFallback),this.isDisposed||u.isCancellationRequested)return}this.g(g,s,c)}g(t,s,c){const g=this.a;if(this.h(t)){const u={content:t,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!g},position:{hoverPosition:2},...c};this.a=this.c.showHover(u,s)}g?.dispose()}h(t){return t?(0,W.$uk)(t)?!!t.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function l(f,t,s,c){let g,u;const w=(j,F)=>{const M=u!==void 0;j&&(u?.dispose(),u=void 0),F&&(g?.dispose(),g=void 0),M&&f.onDidHideHover?.()},h=(j,F,M)=>new N.$oh(async()=>{(!u||u.isDisposed)&&(u=new O(f,M||t,j>0),await u.update(s,F,c))},j);let m=!1;const a=A.$GQ(t,A.$AR.MOUSE_DOWN,()=>{m=!0,w(!0,!0)},!0),y=A.$GQ(t,A.$AR.MOUSE_UP,()=>{m=!1},!0),L=A.$GQ(t,A.$AR.MOUSE_LEAVE,j=>{m=!1,w(!1,j.fromElement===t)},!0),R=()=>{if(g)return;const j=new S.$Sc,F={targetElements:[t],dispose:()=>{}};if(f.placement===void 0||f.placement==="mouse"){const M=I=>{F.x=I.x+10,I.target instanceof HTMLElement&&I.target.classList.contains("action-label")&&w(!0,!0)};j.add(A.$GQ(t,A.$AR.MOUSE_MOVE,M,!0))}j.add(h(f.delay,!1,F)),g=j},z=A.$GQ(t,A.$AR.MOUSE_OVER,R,!0),H=()=>{if(m||g)return;const j={targetElements:[t],dispose:()=>{}},F=new S.$Sc,M=()=>w(!0,!0);F.add(A.$GQ(t,A.$AR.BLUR,M,!0)),F.add(h(f.delay,!1,j)),g=F},E=A.$GQ(t,A.$AR.FOCUS,H,!0);return{show:j=>{w(!1,!0),h(0,j)},hide:()=>{w(!0,!0)},update:async(j,F)=>{s=j,await u?.update(s,void 0,F)},dispose:()=>{z.dispose(),L.dispose(),a.dispose(),y.dispose(),E.dispose(),w(!0,!0)}}}e.$zS=l}),define(me[129],$e([1,0,2,23,14,128,29,42,41,12,4,47,3,5,112,103]),function(se,e,A,N,n,W,D,S,b,$,p,O,l,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lT=void 0;const s=A.$,c="selectOption.entry.template";class g{get templateId(){return c}renderTemplate(h){const m=Object.create(null);return m.root=h,m.text=A.$HR(h,s(".option-text")),m.detail=A.$HR(h,s(".option-detail")),m.decoratorRight=A.$HR(h,s(".option-decorator-right")),m}renderElement(h,m,a){const y=a,L=h.text,R=h.detail,z=h.decoratorRight,H=h.isDisabled;y.text.textContent=L,y.detail.textContent=R||"",y.decoratorRight.innerText=z||"",H?y.root.classList.add("option-disabled"):y.root.classList.remove("option-disabled")}disposeTemplate(h){}}class u extends l.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(h,m,a,y,L){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=y,this.g=L||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=u.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.M=this.B((0,S.$zS)((0,D.$BS)("mouse"),this.h,"")),this.r=new p.$5d,this.B(this.r),this.P(),this.O(a),this.n=m||0,h&&this.setOptions(h,m),this.R()}getHeight(){return 22}getTemplateId(){return c}O(h){this.u=h,this.w=A.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=A.$HR(this.w,s(".select-box-details-pane"));const m=A.$HR(this.w,s(".select-box-dropdown-container-width-control")),a=A.$HR(m,s(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",A.$HR(a,this.D),this.G=0,this.y=A.$pR(this.w),this.w.setAttribute("draggable","true"),this.B(A.$GQ(this.w,A.$AR.DRAG_START,y=>{A.$CR.stop(y,!0)}))}P(){this.B(A.$HQ(this.h,"change",m=>{this.n=m.target.selectedIndex,this.r.fire({index:m.target.selectedIndex,selected:m.target.value}),this.m[this.n]&&this.m[this.n].text&&this.M.update(this.m[this.n].text)})),this.B(A.$GQ(this.h,A.$AR.CLICK,m=>{A.$CR.stop(m),this.f?this.Y(!0):this.X()})),this.B(A.$GQ(this.h,A.$AR.MOUSE_DOWN,m=>{A.$CR.stop(m)}));let h;this.B(A.$GQ(this.h,"touchstart",m=>{h=this.f})),this.B(A.$GQ(this.h,"touchend",m=>{A.$CR.stop(m),h?this.Y(!0):this.X()})),this.B(A.$GQ(this.h,A.$AR.KEY_DOWN,m=>{const a=new n.$DQ(m);let y=!1;f.$j?(a.keyCode===18||a.keyCode===16||a.keyCode===10||a.keyCode===3)&&(y=!0):(a.keyCode===18&&a.altKey||a.keyCode===16&&a.altKey||a.keyCode===10||a.keyCode===3)&&(y=!0),y&&(this.X(),A.$CR.stop(m,!0))}))}get onDidSelect(){return this.r.event}setOptions(h,m){$.$ub(this.m,h)||(this.m=h,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((a,y)=>{this.h.add(this.W(a.text,y,a.isDisabled)),typeof a.description=="string"&&(this.H=!0)})),m!==void 0&&(this.select(m),this.F=this.n)}Q(){this.z?.splice(0,this.z.length,this.m)}select(h){h>=0&&h<this.m.length?this.n=h:h>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.M.update(this.m[this.n].text)}setAriaLabel(h){this.g.ariaLabel=h,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(h){this.h.tabIndex=h?0:-1}render(h){this.j=h,h.classList.add("select-container"),h.appendChild(this.h),this.S()}R(){const h=[];this.s.listFocusBackground&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(h.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),h.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),h.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(h.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),h.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&h.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),h.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),h.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=h.join(`
`)}S(){const h=this.s.selectBackground??"",m=this.s.selectForeground??"",a=this.s.selectBorder??"";this.h.style.backgroundColor=h,this.h.style.color=m,this.h.style.borderColor=a}U(){const h=this.s.selectBackground??"",m=A.$ZR(this.s.selectListBackground,h);this.C.style.backgroundColor=m,this.I.style.backgroundColor=m;const a=this.s.focusBorder??"";this.w.style.outlineColor=a,this.w.style.outlineOffset="-1px",this.z.style(this.s)}W(h,m,a){const y=document.createElement("option");return y.value=h,y.text=h,y.disabled=!!a,y}X(){this.I.innerText="",!(!this.u||this.f)&&(this.db(this.w),this.Q(),this.u.showContextView({getAnchor:()=>this.h,render:h=>this.Z(h,!0),layout:()=>{this.bb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Y(!1),this.u.showContextView({getAnchor:()=>this.h,render:h=>this.Z(h),layout:()=>this.bb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Y(h){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),h&&this.h.focus(),this.u.hideContextView())}Z(h,m){return h.appendChild(this.w),this.bb(m),{dispose:()=>{try{h.removeChild(this.w)}catch{}}}}ab(){let h=0;return this.m.forEach((m,a)=>{this.ib(a),this.I.offsetHeight>h&&(h=this.I.offsetHeight)}),h}bb(h){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const m=A.getWindow(this.h),a=A.$3Q(this.h),y=A.getWindow(this.h).getComputedStyle(this.h),L=parseFloat(y.getPropertyValue("--dropdown-padding-top"))+parseFloat(y.getPropertyValue("--dropdown-padding-bottom")),R=m.innerHeight-a.top-a.height-(this.g.minBottomMargin||0),z=a.top-u.b,H=this.h.offsetWidth,E=this.cb(this.D),B=Math.max(E,Math.round(H)).toString()+"px";this.w.style.width=B,this.z.getHTMLElement().style.height="",this.z.layout();let j=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.ab());const F=this.H?this.L:0,M=j+L+F,I=Math.floor((R-L-F)/this.getHeight()),x=Math.floor((z-L-F)/this.getHeight());if(h)return a.top+a.height>m.innerHeight-22||a.top<u.b||I<1&&x<1?!1:(I<u.c&&x>I&&this.m.length>I?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(a.top+a.height>m.innerHeight-22||a.top<u.b||this.G===0&&I<1||this.G===1&&x<1)return this.Y(!0),!1;if(this.G===0){if(this.f&&I+x<1)return this.Y(!0),!1;M>R&&(j=I*this.getHeight())}else M>z&&(j=x*this.getHeight());return this.z.layout(j),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=j+L+"px",this.w.style.height=""):this.w.style.height=j+L+"px",this.ib(this.n),this.w.style.width=B,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}cb(h){let m=0;if(h){let a=0,y=0;this.m.forEach((L,R)=>{const z=L.detail?L.detail.length:0,H=L.decoratorRight?L.decoratorRight.length:0,E=L.text.length+z+H;E>y&&(a=R,y=E)}),h.textContent=this.m[a].text+(this.m[a].decoratorRight?this.m[a].decoratorRight+" ":""),m=A.$5Q(h)}return m}db(h){if(this.z)return;this.C=A.$HR(h,s(".select-box-dropdown-list-container")),this.t=new g,this.z=new b.$dT("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:y=>{let L=y.text;return y.detail&&(L+=`. ${y.detail}`),y.decoratorRight&&(L+=`. ${y.decoratorRight}`),y.description&&(L+=`. ${y.description}`),L},getWidgetAriaLabel:()=>(0,t.localize)(0,null),getRole:()=>f.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const m=this.B(new N.$KS(this.C,"keydown")),a=p.Event.chain(m.event,y=>y.filter(()=>this.z.length>0).map(L=>new n.$DQ(L)));this.B(p.Event.chain(a,y=>y.filter(L=>L.keyCode===3))(this.kb,this)),this.B(p.Event.chain(a,y=>y.filter(L=>L.keyCode===2))(this.kb,this)),this.B(p.Event.chain(a,y=>y.filter(L=>L.keyCode===9))(this.jb,this)),this.B(p.Event.chain(a,y=>y.filter(L=>L.keyCode===16))(this.mb,this)),this.B(p.Event.chain(a,y=>y.filter(L=>L.keyCode===18))(this.lb,this)),this.B(p.Event.chain(a,y=>y.filter(L=>L.keyCode===12))(this.ob,this)),this.B(p.Event.chain(a,y=>y.filter(L=>L.keyCode===11))(this.nb,this)),this.B(p.Event.chain(a,y=>y.filter(L=>L.keyCode===14))(this.pb,this)),this.B(p.Event.chain(a,y=>y.filter(L=>L.keyCode===13))(this.qb,this)),this.B(p.Event.chain(a,y=>y.filter(L=>L.keyCode>=21&&L.keyCode<=56||L.keyCode>=85&&L.keyCode<=113))(this.rb,this)),this.B(A.$GQ(this.z.getHTMLElement(),A.$AR.POINTER_UP,y=>this.eb(y))),this.B(this.z.onMouseOver(y=>typeof y.index<"u"&&this.z.setFocus([y.index]))),this.B(this.z.onDidChangeFocus(y=>this.hb(y))),this.B(A.$GQ(this.w,A.$AR.FOCUS_OUT,y=>{!this.f||A.$$Q(y.relatedTarget,this.w)||this.fb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.U()}eb(h){if(!this.z.length)return;A.$CR.stop(h);const m=h.target;if(!m||m.classList.contains("slider"))return;const a=m.closest(".monaco-list-row");if(!a)return;const y=Number(a.getAttribute("data-index")),L=a.classList.contains("option-disabled");y>=0&&y<this.m.length&&!L&&(this.n=y,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.M.update(this.m[this.n].text)),this.Y(!0))}fb(){this.N||(this.n!==this.F&&this.select(this.F),this.Y(!1))}gb(h,m){const a=L=>{for(let R=0;R<L.childNodes.length;R++){const z=L.childNodes.item(R);(z.tagName&&z.tagName.toLowerCase())==="img"?L.removeChild(z):a(z)}},y=(0,W.$gT)({value:h,supportThemeIcons:!0},{actionHandler:m});return y.element.classList.add("select-box-description-markdown"),a(y.element),y.element}hb(h){!this.f||!this.H||this.ib(h.indexes[0])}ib(h){this.I.innerText="";const m=this.m[h],a=m?.description??"",y=m?.descriptionIsMarkdown??!1;if(a){if(y){const L=m.descriptionMarkdownActionHandler;this.I.appendChild(this.gb(a,L))}else this.I.innerText=a;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}jb(h){A.$CR.stop(h),this.select(this.F),this.Y(!0)}kb(h){A.$CR.stop(h),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.M.update(this.m[this.n].text)),this.Y(!0)}lb(h){if(this.n<this.m.length-1){A.$CR.stop(h,!0);const m=this.m[this.n+1].isDisabled;if(m&&this.m.length>this.n+2)this.n+=2;else{if(m)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}mb(h){this.n>0&&(A.$CR.stop(h,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}nb(h){A.$CR.stop(h),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(h){A.$CR.stop(h),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(h){A.$CR.stop(h),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(h){A.$CR.stop(h),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(h){const m=O.KeyCodeUtils.toString(h.keyCode);let a=-1;for(let y=0;y<this.m.length-1;y++)if(a=(y+this.n+1)%this.m.length,this.m[a].text.charAt(0).toUpperCase()===m&&!this.m[a].isDisabled){this.select(a),this.z.setFocus([a]),this.z.reveal(this.z.getFocus()[0]),A.$CR.stop(h);break}}dispose(){this.Y(!1),super.dispose()}}e.$lT=u}),define(me[130],$e([1,0,41,129,124,20,5,102]),function(se,e,A,N,n,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oT=e.$nT=void 0,e.$nT={...A.$cT,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class S extends W.$iS{constructor($,p,O,l,f){super(),D.$j&&!f?.useCustomDrawn?this.a=new n.$mT($,p,l,f):this.a=new N.$lT($,p,O,l,f),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions($,p){this.a.setOptions($,p)}select($){this.a.select($)}setAriaLabel($){this.a.setAriaLabel($)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable($){this.a.setFocusable($)}render($){this.a.render($)}}e.$oT=S}),define(me[65],$e([1,0,16,56,2,25,29,42,130,38,3,5,7,107,54]),function(se,e,A,N,n,W,D,S,b,$,p,O,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wT=e.$vT=e.$uT=void 0;class t extends p.$Tc{get action(){return this._action}constructor(u,w,h={}){super(),this.m=h,this._context=u||this,this._action=w,w instanceof $.$Vi&&this.B(w.onDidChange(m=>{this.element&&this.t(m)}))}t(u){u.enabled!==void 0&&this.u(),u.checked!==void 0&&this.H(),u.class!==void 0&&this.G(),u.label!==void 0&&(this.w(),this.D()),u.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new $.$Wi)),this.j}set actionRunner(u){this.j=u}isEnabled(){return this._action.enabled}setActionContext(u){this._context=u}render(u){const w=this.element=u;this.B(W.$eS.addTarget(u));const h=this.m&&this.m.draggable;h&&(u.draggable=!0,A.$mQ&&this.B((0,n.$GQ)(u,n.$AR.DRAG_START,m=>m.dataTransfer?.setData(N.$cS.TEXT,this._action.label)))),this.B((0,n.$GQ)(w,W.EventType.Tap,m=>this.onClick(m,!0))),this.B((0,n.$GQ)(w,n.$AR.MOUSE_DOWN,m=>{h||n.$CR.stop(m,!0),this._action.enabled&&m.button===0&&w.classList.add("active")})),O.$j&&this.B((0,n.$GQ)(w,n.$AR.CONTEXT_MENU,m=>{m.button===0&&m.ctrlKey===!0&&this.onClick(m)})),this.B((0,n.$GQ)(w,n.$AR.CLICK,m=>{n.$CR.stop(m,!0),this.m&&this.m.isMenu||this.onClick(m)})),this.B((0,n.$GQ)(w,n.$AR.DBLCLICK,m=>{n.$CR.stop(m,!0)})),[n.$AR.MOUSE_UP,n.$AR.MOUSE_OUT].forEach(m=>{this.B((0,n.$GQ)(w,m,a=>{n.$CR.stop(a),w.classList.remove("active")}))})}onClick(u,w=!1){n.$CR.stop(u,!0);const h=l.$2f(this._context)?this.m?.useEventAsContext?u:{preserveFocus:w}:this._context;this.actionRunner.run(this._action,h)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(u){this.element&&(this.element.tabIndex=u?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const u=this.C()??"";if(this.F(),this.f)this.f.update(u);else{const w=this.m.hoverDelegate??(0,D.$BS)("element");this.f=(0,S.$zS)(w,this.element,u),this.q.add(this.f)}}F(){if(this.element){const u=this.C()??"";this.element.setAttribute("aria-label",u)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}e.$uT=t;class s extends t{constructor(u,w,h){super(u,w,h),this.m=h,this.m.icon=h.icon!==void 0?h.icon:!1,this.m.label=h.label!==void 0?h.label:!0,this.L=""}render(u){super.render(u),l.$3f(this.element);const w=document.createElement("a");if(w.classList.add("action-label"),w.setAttribute("role",this.M()),this.I=w,this.element.appendChild(w),this.m.label&&this.m.keybinding){const h=document.createElement("span");h.classList.add("keybinding"),h.textContent=this.m.keybinding,this.element.appendChild(h)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===$.$Xi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(u){this.I&&(this.I.tabIndex=u?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let u=null;return this.action.tooltip?u=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(u=this.action.label,this.m.keybinding&&(u=f.localize(0,null,u,this.m.keybinding))),u??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const u=this.C()??"";this.I.setAttribute("aria-label",u)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}e.$vT=s;class c extends t{constructor(u,w,h,m,a,y,L){super(u,w),this.b=new b.$oT(h,m,a,y,L),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(u,w){this.b.setOptions(u,w)}select(u){this.b.select(u)}g(){this.B(this.b.onDidSelect(u=>this.n(u.selected,u.index)))}n(u,w){this.actionRunner.run(this._action,this.r(u,w))}r(u,w){return u}setFocusable(u){this.b.setFocusable(u)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(u){this.b.render(u)}}e.$wT=c}),define(me[66],$e([1,0,2,14,65,29,38,4,3,7,54]),function(se,e,A,N,n,W,D,S,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DS=e.$CS=e.ActionsOrientation=void 0;var p;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(p||(e.ActionsOrientation=p={}));class O extends b.$Tc{constructor(t,s={}){super(),this.j=this.B(new b.$Sc),this.s=this.B(new b.$3c),this.y=!1,this.z=!0,this.D=this.B(new S.$5d),this.onDidBlur=this.D.event,this.F=this.B(new S.$5d({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new S.$5d),this.onDidRun=this.H.event,this.I=this.B(new S.$5d),this.onWillRun=this.I.event,this.b=s,this.m=s.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=s.hoverDelegate??this.B((0,W.$BS)("element",!0)),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new D.$Wi,this.j.add(this.g)),this.j.add(this.g.onDidRun(u=>this.H.fire(u))),this.j.add(this.g.onWillRun(u=>this.I.fire(u))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",s.animated!==!1&&this.domNode.classList.add("animated");let c,g;switch(this.n){case 0:c=[15],g=[17];break;case 1:c=[16],g=[18],this.domNode.className+=" vertical";break}this.B(A.$GQ(this.domNode,A.$AR.KEY_DOWN,u=>{const w=new N.$DQ(u);let h=!0;const m=typeof this.u=="number"?this.viewItems[this.u]:void 0;c&&(w.equals(c[0])||w.equals(c[1]))?h=this.Q():g&&(w.equals(g[0])||w.equals(g[1]))?h=this.P():w.equals(9)&&this.G?this.F.fire():w.equals(14)?h=this.N():w.equals(13)?h=this.O():w.equals(2)&&m instanceof n.$uT&&m.trapsArrowNavigation?h=this.P():this.L(w)?this.r.keyDown?this.S(w):this.y=!0:h=!1,h&&(w.preventDefault(),w.stopPropagation())})),this.B(A.$GQ(this.domNode,A.$AR.KEY_UP,u=>{const w=new N.$DQ(u);this.L(w)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(w)),w.preventDefault(),w.stopPropagation()):(w.equals(2)||w.equals(1026)||w.equals(16)||w.equals(18)||w.equals(15)||w.equals(17))&&this.M()})),this.w=this.B(A.$FR(this.domNode)),this.B(this.w.onDidBlur(()=>{(A.$gR()===this.domNode||!A.$$Q(A.$gR(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),t.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(t){t?this.C.setAttribute("aria-label",t):this.C.removeAttribute("aria-label")}setFocusable(t){if(this.z=t,this.z){const s=this.viewItems.find(c=>c instanceof n.$uT&&c.isEnabled());s instanceof n.$uT&&s.setFocusable(!0)}else this.viewItems.forEach(s=>{s instanceof n.$uT&&s.setFocusable(!1)})}L(t){let s=!1;return this.r.keys.forEach(c=>{s=s||t.equals(c)}),s}M(){for(let t=0;t<this.C.children.length;t++){const s=this.C.children[t];if(A.$$Q(A.$gR(),s)){this.u=t,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(t){this.m=t,this.viewItems.forEach(s=>s.setActionContext(t))}get actionRunner(){return this.g}set actionRunner(t){this.g=t,this.j.clear(),this.j.add(this.g.onDidRun(s=>this.H.fire(s))),this.j.add(this.g.onWillRun(s=>this.I.fire(s))),this.viewItems.forEach(s=>s.actionRunner=t)}getContainer(){return this.domNode}hasAction(t){return this.viewItems.findIndex(s=>s.action.id===t.id)!==-1}getAction(t){if(typeof t=="number")return this.viewItems[t]?.action;if(t instanceof HTMLElement){for(;t.parentElement!==this.C;){if(!t.parentElement)return;t=t.parentElement}for(let s=0;s<this.C.childNodes.length;s++)if(this.C.childNodes[s]===t)return this.viewItems[s].action}}push(t,s={}){const c=Array.isArray(t)?t:[t];let g=$.$Wf(s.index)?s.index:null;c.forEach(u=>{const w=document.createElement("li");w.className="action-item",w.setAttribute("role","presentation");let h;const m={hoverDelegate:this.f,...s};this.b.actionViewItemProvider&&(h=this.b.actionViewItemProvider(u,m)),h||(h=new n.$vT(this.context,u,m)),this.b.allowContextMenu||this.s.set(h,A.$GQ(w,A.$AR.CONTEXT_MENU,a=>{A.$CR.stop(a,!0)})),h.actionRunner=this.g,h.setActionContext(this.context),h.render(w),this.z&&h instanceof n.$uT&&this.viewItems.length===0&&h.setFocusable(!0),g===null||g<0||g>=this.C.children.length?(this.C.appendChild(w),this.viewItems.push(h)):(this.C.insertBefore(w,this.C.children[g]),this.viewItems.splice(g,0,h),g++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(t){if(t>=0&&t<this.C.children.length){const s=this.C.children.item(t);if(s)return s.clientWidth}return 0}getHeight(t){if(t>=0&&t<this.C.children.length){const s=this.C.children.item(t);if(s)return s.clientHeight}return 0}pull(t){t>=0&&t<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[t]),this.s.deleteAndDispose(this.viewItems[t]),(0,b.$Oc)(this.viewItems.splice(t,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,b.$Oc)(this.viewItems),this.s.clearAndDisposeAll(),A.$FQ(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(t){let s=!1,c;if(t===void 0?s=!0:typeof t=="number"?c=t:typeof t=="boolean"&&(s=t),s&&typeof this.u>"u"){const g=this.viewItems.findIndex(u=>u.isEnabled());this.u=g===-1?void 0:g,this.R(void 0,void 0,!0)}else c!==void 0&&(this.u=c),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(t){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const s=this.u;let c;do{if(!t&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=s,!1;this.u=(this.u+1)%this.viewItems.length,c=this.viewItems[this.u]}while(this.u!==s&&(this.b.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===D.$Xi.ID));return this.R(),!0}Q(t){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const s=this.u;let c;do{if(this.u=this.u-1,this.u<0){if(!t&&this.b.preventLoopNavigation)return this.u=s,!1;this.u=this.viewItems.length-1}c=this.viewItems[this.u]}while(this.u!==s&&(this.b.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===D.$Xi.ID));return this.R(!0),!0}R(t,s,c=!1){typeof this.u>"u"&&this.C.focus({preventScroll:s}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const g=this.u!==void 0?this.viewItems[this.u]:void 0;if(g){let u=!0;$.$7f(g.focus)||(u=!1),this.b.focusOnlyEnabledItems&&$.$7f(g.isEnabled)&&!g.isEnabled()&&(u=!1),g.action.id===D.$Xi.ID&&(u=!1),u?(c||this.t!==this.u)&&(g.focus(t),this.t=this.u):(this.C.focus({preventScroll:s}),this.t=void 0),u&&g.showHover?.()}}S(t){if(typeof this.u>"u")return;const s=this.viewItems[this.u];if(s instanceof n.$uT){const c=s._context===null||s._context===void 0?t:s._context;this.run(s._action,c)}}async run(t,s){await this.g.run(t,s)}dispose(){this.m=void 0,this.viewItems=(0,b.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}e.$CS=O;function l(f){if(!f.length)return f;let t=-1;for(let c=0;c<f.length;c++)if(f[c].id!==D.$Xi.ID){t=c;break}if(t===-1)return[];f=f.slice(t);for(let c=f.length-1;c>=0&&f[c].id===D.$Xi.ID;c--)f.splice(c,1);let s=!1;for(let c=f.length-1;c>=0;c--){const g=f[c].id===D.$Xi.ID;g&&!s?f.splice(c,1):g?g&&(s=!1):s=!0}return f}e.$DS=l}),define(me[67],$e([1,0,2,23,57,66,59,62,20,4,84,53,111,99]),function(se,e,A,N,n,W,D,S,b,$,p,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cU=e.$bU=e.$aU=e.MessageType=void 0;const f=A.$;var t;(function(g){g[g.INFO=1]="INFO",g[g.WARNING=2]="WARNING",g[g.ERROR=3]="ERROR"})(t||(e.MessageType=t={})),e.$aU={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class s extends b.$iS{constructor(u,w,h){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new $.$5d),this.onDidChange=this.O.event,this.P=this.B(new $.$5d),this.onDidHeightChange=this.P.event,this.a=w,this.g=h,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=A.$HR(u,f(".monaco-inputbox.idle"));const m=this.g.flexibleHeight?"textarea":"input",a=A.$HR(this.element,f(".ibwrapper"));if(this.b=A.$HR(a,f(m+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=A.$HR(a,f("div.mirror")),this.y.innerText="\xA0",this.N=new S.$sS(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),A.$HR(u,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(R=>this.b.scrollTop=R.scrollTop));const y=this.B(new N.$KS(u.ownerDocument,"selectionchange")),L=$.Event.filter(y.event,()=>u.ownerDocument.getSelection()?.anchorNode===a);this.B(L(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new W.$CS(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(u){this.n=u,this.b.setAttribute("placeholder",u)}setTooltip(u){this.r=u,this.b.title=u}setAriaLabel(u){this.s=u,u?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(u){this.b.value!==u&&(this.b.value=u,this.Y())}get step(){return this.b.step}set step(u){this.b.step=u}get height(){return typeof this.J=="number"?this.J:A.$9Q(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return A.$hR(this.b)}select(u=null){this.b.select(),u&&(this.b.setSelectionRange(u.start,u.end),u.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(u){u?this.enable():this.disable()}get width(){return A.$5Q(this.b)}set width(u){if(this.g.flexibleHeight&&this.g.flexibleWidth){let w=0;if(this.y){const h=parseFloat(this.y.style.paddingLeft||"")||0,m=parseFloat(this.y.style.paddingRight||"")||0;w=h+m}this.b.style.width=u-w+"px"}else this.b.style.width=u+"px";this.y&&(this.y.style.width=u+"px")}set paddingRight(u){this.b.style.width=`calc(100% - ${u}px)`,this.y&&(this.y.style.paddingRight=u+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const u=this.L,w=this.J,h=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:u,height:w}),this.N.setScrollPosition({scrollTop:h})}showMessage(u,w){if(this.w==="open"&&(0,O.$Ln)(this.h,u))return;this.h=u,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(u.type));const h=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${A.$ZR(h.border,"transparent")}`,this.h.content&&(this.hasFocus()||w)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let u=null;return this.t&&(u=this.t(this.value),u?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(u)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),u?.type}stylesForType(u){const w=this.g.inputBoxStyles;switch(u){case 1:return{border:w.inputValidationInfoBorder,background:w.inputValidationInfoBackground,foreground:w.inputValidationInfoForeground};case 2:return{border:w.inputValidationWarningBorder,background:w.inputValidationWarningBackground,foreground:w.inputValidationWarningForeground};default:return{border:w.inputValidationErrorBorder,background:w.inputValidationErrorBackground,foreground:w.inputValidationErrorForeground}}}U(u){switch(u){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let u;const w=()=>u.style.width=A.$5Q(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:m=>{if(!this.h)return null;u=A.$HR(m,f(".monaco-inputbox-container")),w();const a={inline:!0,className:"monaco-inputbox-message"},y=this.h.formatContent?(0,n.$IS)(this.h.content,a):(0,n.$HS)(this.h.content,a);y.classList.add(this.U(this.h.type));const L=this.stylesForType(this.h.type);return y.style.backgroundColor=L.background??"",y.style.color=L.foreground??"",y.style.border=L.border?`1px solid ${L.border}`:"",A.$HR(u,y),null},onHide:()=>{this.w="closed"},layout:w});let h;this.h.type===3?h=l.localize(0,null,this.h.content):this.h.type===2?h=l.localize(1,null,this.h.content):h=l.localize(2,null,this.h.content),D.$MS(h),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const u=this.value,h=u.charCodeAt(u.length-1)===10?" ":"";(u+h).replace(/\u000c/g,"")?this.y.textContent=u+h:this.y.innerText="\xA0",this.layout()}ab(){const u=this.g.inputBoxStyles,w=u.inputBackground??"",h=u.inputForeground??"",m=u.inputBorder??"";this.element.style.backgroundColor=w,this.element.style.color=h,this.b.style.backgroundColor="inherit",this.b.style.color=h,this.element.style.border=`1px solid ${A.$ZR(m,"transparent")}`}layout(){if(!this.y)return;const u=this.L;this.L=A.$9Q(this.y),u!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(u){const w=this.inputElement,h=w.selectionStart,m=w.selectionEnd,a=w.value;h!==null&&m!==null&&(this.value=a.substr(0,h)+u+a.substr(m),w.setSelectionRange(h+1,h+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}e.$bU=s;class c extends s{constructor(u,w,h){const m=l.localize(3,null,"\u21C5"),a=l.localize(4,null,"\u21C5");super(u,w,h),this.db=this.B(new $.$5d),this.onDidFocus=this.db.event,this.eb=this.B(new $.$5d),this.onDidBlur=this.eb.event,this.bb=new p.$$T(h.history,100);const y=()=>{if(h.showHistoryHint&&h.showHistoryHint()&&!this.n.endsWith(m)&&!this.n.endsWith(a)&&this.bb.getHistory().length){const L=this.n.endsWith(")")?m:a,R=this.n+L;h.showPlaceholderOnFocus&&!A.$hR(this.b)?this.n=R:this.setPlaceHolder(R)}};this.cb=new MutationObserver((L,R)=>{L.forEach(z=>{z.target.textContent||y()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>y()),this.F(this.b,()=>{const L=R=>{if(this.n.endsWith(R)){const z=this.n.slice(0,this.n.length-R.length);return h.showPlaceholderOnFocus?this.n=z:this.setPlaceHolder(z),!0}else return!1};L(a)||L(m)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(u){this.value&&(u||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(u){const w=this.getHistory();this.clearHistory(),u.forEach(h=>{this.bb.add(h)}),w.forEach(h=>{this.bb.add(h)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let u=this.jb();u&&(u=u===this.value?this.jb():u),this.value=u??"",D.$NS(this.value?this.value:l.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let u=this.ib();u&&(u=u===this.value?this.ib():u),u&&(this.value=u,D.$NS(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(u){super.setPlaceHolder(u),this.setTooltip(u)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let u=this.bb.current();return u||(u=this.bb.last(),this.bb.next()),u}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}e.$cU=c}),define(me[68],$e([1,0,65,20,17,18,4,2,42,29,104]),function(se,e,A,N,n,W,D,S,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tT=e.$sT=e.$rT=e.$qT=e.$pT=void 0,e.$pT={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class p extends A.$uT{constructor(s,c,g){super(s,c,g),this.a=this.B(new O({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:g.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:g.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:g.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(s){this.element=s,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}e.$qT=p;class O extends N.$iS{constructor(s){super(),this.a=this.B(new D.$5d),this.onChange=this.a.event,this.b=this.B(new D.$5d),this.onKeyDown=this.b.event,this.c=s,this.s=this.c.isChecked;const c=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,c.push(...W.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&c.push(...this.c.actionClassName.split(" ")),this.s&&c.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,b.$zS)((0,$.$BS)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...c),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,g=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),g.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,g=>{if(g.keyCode===10||g.keyCode===3){this.checked=!this.s,this.a.fire(!0),g.preventDefault(),g.stopPropagation();return}this.b.fire(g)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(s){this.s=s,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(s){this.g&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this.g)),this.g=s,this.g&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this.t.update(s),this.domNode.setAttribute("aria-label",s)}}e.$rT=O;class l extends N.$iS{constructor(s,c,g){super(),this.g=s,this.h=c,this.a=this.B(new D.$5d),this.onChange=this.a.event,this.b=new O({title:this.g,isChecked:this.h,icon:n.$kk.check,actionClassName:"monaco-checkbox",...e.$pT}),this.domNode=this.b.domNode,this.c=g,this.n(),this.B(this.b.onChange(u=>{this.n(),this.a.fire(u)}))}get checked(){return this.b.checked}set checked(s){this.b.checked=s,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,S.$hR)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}e.$sT=l;class f extends A.$uT{constructor(s,c,g){super(s,c,g),this.a=this.B(new l(this._action.label,!!this._action.checked,g.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(s){if(this.element=s,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const c=this.element.appendChild((0,S.$)("span.checkbox-label",void 0,this._action.label));this.B((0,S.$GQ)(c,S.$AR.CLICK,g=>{this.a.checked=!this.a.checked,g.stopPropagation(),g.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}e.$tT=f}),define(me[131],$e([1,0,68,17,109]),function(se,e,A,N,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pU=e.$oU=e.$nU=void 0;const W=n.localize(0,null),D=n.localize(1,null),S=n.localize(2,null);class b extends A.$rT{constructor(l){super({icon:N.$kk.caseSensitive,title:W+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}e.$nU=b;class $ extends A.$rT{constructor(l){super({icon:N.$kk.wholeWord,title:D+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}e.$oU=$;class p extends A.$rT{constructor(l){super({icon:N.$kk.regex,title:S+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}e.$pU=p}),define(me[132],$e([1,0,2,131,67,20,4,108,3,98]),function(se,e,A,N,n,W,D,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qU=void 0;const $=S.localize(0,null);class p extends W.$iS{static{this.OPTION_CHANGE="optionChange"}constructor(l,f,t){super(),this.n=!0,this.s=!1,this.w=this.B(new b.$Uc),this.N=[],this.O=this.B(new D.$5d),this.onDidOptionChange=this.O.event,this.P=this.B(new D.$5d),this.onKeyDown=this.P.event,this.Q=this.B(new D.$5d),this.onMouseDown=this.Q.event,this.R=this.B(new D.$5d),this.onInput=this.R.event,this.S=this.B(new D.$5d),this.onKeyUp=this.S.event,this.U=this.B(new D.$5d),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new D.$5d),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=t.placeholder||"",this.b=t.validation,this.c=t.label||$,this.h=!!t.showCommonFindToggles;const s=t.appendCaseSensitiveLabel||"",c=t.appendWholeWordsLabel||"",g=t.appendRegexLabel||"",u=t.history||[],w=!!t.flexibleHeight,h=!!t.flexibleWidth,m=t.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new n.$cU(this.domNode,f,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:u,showHistoryHint:t.showHistoryHint,flexibleHeight:w,flexibleWidth:h,flexibleMaxHeight:m,inputBoxStyles:t.inputBoxStyles})),this.h){this.J=this.B(new N.$pU({appendTitle:g,isChecked:!1,...t.toggleStyles})),this.B(this.J.onChange(y=>{this.O.fire(y),!y&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(y=>{this.W.fire(y)})),this.L=this.B(new N.$oU({appendTitle:c,isChecked:!1,...t.toggleStyles})),this.B(this.L.onChange(y=>{this.O.fire(y),!y&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new N.$nU({appendTitle:s,isChecked:!1,...t.toggleStyles})),this.B(this.M.onChange(y=>{this.O.fire(y),!y&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(y=>{this.U.fire(y)}));const a=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,y=>{if(y.equals(15)||y.equals(17)||y.equals(9)){const L=a.indexOf(this.domNode.ownerDocument.activeElement);if(L>=0){let R=-1;y.equals(17)?R=(L+1)%a.length:y.equals(15)&&(L===0?R=a.length-1:R=L-1),y.equals(9)?(a[L].blur(),this.inputBox.focus()):R>=0&&a[R].focus(),A.$CR.stop(y,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(t?.additionalToggles),this.y&&this.domNode.appendChild(this.y),l?.appendChild(this.domNode),this.B(A.$GQ(this.inputBox.inputElement,"compositionstart",a=>{this.s=!0})),this.B(A.$GQ(this.inputBox.inputElement,"compositionend",a=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,a=>this.P.fire(a)),this.C(this.inputBox.inputElement,a=>this.S.fire(a)),this.D(this.inputBox.inputElement,a=>this.R.fire()),this.j(this.inputBox.inputElement,a=>this.Q.fire(a))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(l){this.inputBox.layout(),this.X(l.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const l of this.N)l.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const l of this.N)l.disable()}setFocusInputOnOptionClick(l){this.n=l}setEnabled(l){l?this.enable():this.disable()}setAdditionalToggles(l){for(const f of this.N)f.domNode.remove();this.N=[],this.w.value=new b.$Sc;for(const f of l??[])this.w.value.add(f),this.y.appendChild(f.domNode),this.w.value.add(f.onChange(t=>{this.O.fire(t),!t&&this.n&&this.inputBox.focus()})),this.N.push(f);this.N.length>0&&(this.y.style.display=""),this.X()}X(l=!1){l?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((f,t)=>f+t.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(l){this.inputBox.value!==l&&(this.inputBox.value=l)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(l){this.M&&(this.M.checked=l)}getWholeWords(){return this.L?.checked??!1}setWholeWords(l){this.L&&(this.L.checked=l)}getRegex(){return this.J?.checked??!1}setRegex(l){this.J&&(this.J.checked=l,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(l){this.inputBox.showMessage(l)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}e.$qU=p}),define(me[133],$e([1,0,2,23,14,66,132,67,63,41,68,60,26,38,12,9,17,18,33,4,36,3,34,7,113,105]),function(se,e,A,N,n,W,D,S,b,$,p,O,l,f,t,s,c,g,u,w,h,m,a,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2U=e.AbstractTreePart=e.TreeFindMatchType=e.TreeFindMode=e.$1U=e.$ZU=e.$YU=e.RenderIndentGuides=e.$XU=e.$WU=void 0;class R extends b.$US{set context(i){this.c.context=i}get context(){return this.c.context}constructor(i){super(i.elements.map(o=>o.element)),this.c=i}}function z(r){return r instanceof b.$US?new R(r):r}class H{constructor(i,o){this.d=i,this.f=o,this.b=m.$Tc.None,this.c=new m.$Sc}getDragURI(i){return this.f.getDragURI(i.element)}getDragLabel(i,o){if(this.f.getDragLabel)return this.f.getDragLabel(i.map(v=>v.element),o)}onDragStart(i,o){this.f.onDragStart?.(z(i),o)}onDragOver(i,o,v,P,T,U=!0){const _=this.f.onDragOver(z(i),o&&o.element,v,P,T),Z=this.a!==o;if(Z&&(this.b.dispose(),this.a=o),typeof o>"u")return _;if(Z&&typeof _!="boolean"&&_.autoExpand&&(this.b=(0,s.$gh)(()=>{const Se=this.d(),we=Se.getNodeLocation(o);Se.isCollapsed(we)&&Se.setCollapsed(we,!1),this.a=void 0},500,this.c)),typeof _=="boolean"||!_.accept||typeof _.bubble>"u"||_.feedback){if(!U){const Se=typeof _=="boolean"?_:_.accept,we=typeof _=="boolean"?void 0:_.effect;return{accept:Se,effect:we,feedback:[v]}}return _}if(_.bubble===1){const Se=this.d(),we=Se.getNodeLocation(o),Ne=Se.getParentNodeLocation(we),Me=Se.getNode(Ne),Pe=Ne&&Se.getListIndex(Ne);return this.onDragOver(i,Me,Pe,P,T,!1)}const oe=this.d(),be=oe.getNodeLocation(o),De=oe.getListIndex(be),ve=oe.getListRenderCount(be);return{..._,feedback:(0,t.$Sb)(De,De+ve)}}drop(i,o,v,P,T){this.b.dispose(),this.a=void 0,this.f.drop(z(i),o&&o.element,v,P,T)}onDragEnd(i){this.f.onDragEnd?.(i)}dispose(){this.c.dispose(),this.f.dispose()}}function E(r,i){return i&&{...i,identityProvider:i.identityProvider&&{getId(o){return i.identityProvider.getId(o.element)}},dnd:i.dnd&&new H(r,i.dnd),multipleSelectionController:i.multipleSelectionController&&{isSelectionSingleChangeEvent(o){return i.multipleSelectionController.isSelectionSingleChangeEvent({...o,element:o.element})},isSelectionRangeChangeEvent(o){return i.multipleSelectionController.isSelectionRangeChangeEvent({...o,element:o.element})}},accessibilityProvider:i.accessibilityProvider&&{...i.accessibilityProvider,getSetSize(o){const v=r(),P=v.getNodeLocation(o),T=v.getParentNodeLocation(P);return v.getNode(T).visibleChildrenCount},getPosInSet(o){return o.visibleChildIndex+1},isChecked:i.accessibilityProvider&&i.accessibilityProvider.isChecked?o=>i.accessibilityProvider.isChecked(o.element):void 0,getRole:i.accessibilityProvider&&i.accessibilityProvider.getRole?o=>i.accessibilityProvider.getRole(o.element):()=>"treeitem",getAriaLabel(o){return i.accessibilityProvider.getAriaLabel(o.element)},getWidgetAriaLabel(){return i.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:i.accessibilityProvider&&i.accessibilityProvider.getWidgetRole?()=>i.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:i.accessibilityProvider&&i.accessibilityProvider.getAriaLevel?o=>i.accessibilityProvider.getAriaLevel(o.element):o=>o.depth,getActiveDescendantId:i.accessibilityProvider.getActiveDescendantId&&(o=>i.accessibilityProvider.getActiveDescendantId(o.element))},keyboardNavigationLabelProvider:i.keyboardNavigationLabelProvider&&{...i.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(o){return i.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(o.element)}}}}class B{constructor(i){this.a=i}getHeight(i){return this.a.getHeight(i.element)}getTemplateId(i){return this.a.getTemplateId(i.element)}hasDynamicHeight(i){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(i.element)}setDynamicHeight(i,o){this.a.setDynamicHeight?.(i.element,o)}}e.$WU=B;class j{static lift(i){return i instanceof j?i:new j(i)}static empty(i=0){return new j({focus:[],selection:[],expanded:Object.create(null),scrollTop:i})}constructor(i){if(this.focus=new Set(i.focus),this.selection=new Set(i.selection),i.expanded instanceof Array){this.expanded=Object.create(null);for(const o of i.expanded)this.expanded[o]=1}else this.expanded=i.expanded;this.expanded=i.expanded,this.scrollTop=i.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}e.$XU=j;var F;(function(r){r.None="none",r.OnHover="onHover",r.Always="always"})(F||(e.RenderIndentGuides=F={}));class M{get elements(){return this.b}constructor(i,o=[]){this.b=o,this.a=new m.$Sc,this.onDidChange=w.Event.forEach(i,v=>this.b=v,this.a)}dispose(){this.a.dispose()}}class I{static{this.a=8}constructor(i,o,v,P,T,U={}){this.o=i,this.p=o,this.q=P,this.s=T,this.b=new Map,this.c=new Map,this.d=I.a,this.f=!1,this.g=!1,this.j=new Set,this.k=m.$Tc.None,this.m=new m.$Sc,this.templateId=i.templateId,this.updateOptions(U),w.Event.map(v,_=>_.node)(this.u,this,this.m),i.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(i={}){if(typeof i.indent<"u"){const o=(0,a.$fm)(i.indent,0,40);if(o!==this.d){this.d=o;for(const[v,P]of this.c)this.v(v,P)}}if(typeof i.renderIndentGuides<"u"){const o=i.renderIndentGuides!==F.None;if(o!==this.g){this.g=o;for(const[v,P]of this.c)this.w(v,P);if(this.k.dispose(),o){const v=new m.$Sc;this.q.onDidChange(this.x,this,v),this.k=v,this.x(this.q.elements)}}}typeof i.hideTwistiesOfChildlessElements<"u"&&(this.f=i.hideTwistiesOfChildlessElements)}renderTemplate(i){const o=(0,A.$HR)(i,(0,A.$)(".monaco-tl-row")),v=(0,A.$HR)(o,(0,A.$)(".monaco-tl-indent")),P=(0,A.$HR)(o,(0,A.$)(".monaco-tl-twistie")),T=(0,A.$HR)(o,(0,A.$)(".monaco-tl-contents")),U=this.o.renderTemplate(T);return{container:i,indent:v,twistie:P,indentGuidesDisposable:m.$Tc.None,templateData:U}}renderElement(i,o,v,P){this.c.set(i,v),this.b.set(i.element,i),this.v(i,v),this.o.renderElement(i,o,v.templateData,P)}disposeElement(i,o,v,P){v.indentGuidesDisposable.dispose(),this.o.disposeElement?.(i,o,v.templateData,P),typeof P=="number"&&(this.c.delete(i),this.b.delete(i.element))}disposeTemplate(i){this.o.disposeTemplate(i.templateData)}t(i){const o=this.b.get(i);o&&this.u(o)}u(i){const o=this.c.get(i);o&&(this.x(this.q.elements),this.v(i,o))}v(i,o){const v=I.a+(i.depth-1)*this.d;o.twistie.style.paddingLeft=`${v}px`,o.indent.style.width=`${v+this.d-16}px`,i.collapsible?o.container.setAttribute("aria-expanded",String(!i.collapsed)):o.container.removeAttribute("aria-expanded"),o.twistie.classList.remove(...g.ThemeIcon.asClassNameArray(c.$kk.treeItemExpanded));let P=!1;this.o.renderTwistie&&(P=this.o.renderTwistie(i.element,o.twistie)),i.collapsible&&(!this.f||i.visibleChildrenCount>0)?(P||o.twistie.classList.add(...g.ThemeIcon.asClassNameArray(c.$kk.treeItemExpanded)),o.twistie.classList.add("collapsible"),o.twistie.classList.toggle("collapsed",i.collapsed)):o.twistie.classList.remove("collapsible","collapsed"),this.w(i,o)}w(i,o){if((0,A.$FQ)(o.indent),o.indentGuidesDisposable.dispose(),!this.g)return;const v=new m.$Sc,P=this.p();for(;;){const T=P.getNodeLocation(i),U=P.getParentNodeLocation(T);if(!U)break;const _=P.getNode(U),Z=(0,A.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(_)&&Z.classList.add("active"),o.indent.childElementCount===0?o.indent.appendChild(Z):o.indent.insertBefore(Z,o.indent.firstElementChild),this.s.add(_,Z),v.add((0,m.$Rc)(()=>this.s.delete(_,Z))),i=_}o.indentGuidesDisposable=v}x(i){if(!this.g)return;const o=new Set,v=this.p();i.forEach(P=>{const T=v.getNodeLocation(P);try{const U=v.getParentNodeLocation(T);P.collapsible&&P.children.length>0&&!P.collapsed?o.add(P):U&&o.add(v.getNode(U))}catch{}}),this.j.forEach(P=>{o.has(P)||this.s.forEach(P,T=>T.classList.remove("active"))}),o.forEach(P=>{this.j.has(P)||this.s.forEach(P,T=>T.classList.add("active"))}),this.j=o}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,m.$Oc)(this.m)}}e.$YU=I;class x{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(i){this.c=i,this.d=i.toLowerCase()}constructor(i,o,v){this.g=i,this.j=o,this.k=v,this.a=0,this.b=0,this.c="",this.d="",this.f=new m.$Sc,i.onWillRefilter(this.m,this,this.f)}filter(i,o){let v=1;if(this.k){const U=this.k.filter(i,o);if(typeof U=="boolean"?v=U?1:0:(0,O.$TU)(U)?v=(0,O.$UU)(U.visibility):v=U,v===0)return!1}if(this.a++,!this.c)return this.b++,{data:h.FuzzyScore.Default,visibility:v};const P=this.j.getKeyboardNavigationLabel(i),T=Array.isArray(P)?P:[P];for(const U of T){const _=U&&U.toString();if(typeof _>"u")return{data:h.FuzzyScore.Default,visibility:v};let Z;if(this.g.findMatchType===ge.Contiguous){const oe=_.toLowerCase().indexOf(this.d);if(oe>-1){Z=[Number.MAX_SAFE_INTEGER,0];for(let be=this.d.length;be>0;be--)Z.push(oe+be-1)}}else Z=(0,h.$fk)(this.c,this.d,0,_,_.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return this.b++,T.length===1?{data:Z,visibility:v}:{data:{label:_,score:Z},visibility:v}}return this.g.findMode===te.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(i):2:{data:h.FuzzyScore.Default,visibility:v}}m(){this.a=0,this.b=0}dispose(){(0,m.$Oc)(this.f)}}class X extends p.$rT{constructor(i){super({icon:c.$kk.listFilter,title:(0,L.localize)(0,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}e.$ZU=X;class de extends p.$rT{constructor(i){super({icon:c.$kk.searchFuzzy,title:(0,L.localize)(1,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}e.$1U=de;const ue={inputBoxStyles:S.$aU,toggleStyles:p.$pT,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var te;(function(r){r[r.Highlight=0]="Highlight",r[r.Filter=1]="Filter"})(te||(e.TreeFindMode=te={}));var ge;(function(r){r[r.Fuzzy=0]="Fuzzy",r[r.Contiguous=1]="Contiguous"})(ge||(e.TreeFindMatchType=ge={}));class Le extends m.$Tc{set mode(i){this.b.checked=i===te.Filter,this.f.inputBox.setPlaceHolder(i===te.Filter?(0,L.localize)(2,null):(0,L.localize)(3,null))}set matchType(i){this.c.checked=i===ge.Fuzzy}get value(){return this.f.inputBox.value}set value(i){this.f.inputBox.value=i}constructor(i,o,v,P,T,U){super(),this.t=o,this.a=(0,A.h)(".monaco-tree-type-filter",[(0,A.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,A.h)(".monaco-tree-type-filter-input@findInput"),(0,A.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new w.$5d,this.onDidDisable=this._onDidDisable.event,i.appendChild(this.a.root),this.B((0,m.$Rc)(()=>i.removeChild(this.a.root)));const _=U?.styles??ue;_.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=_.listFilterWidgetBackground),_.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${_.listFilterWidgetShadow}`),this.b=this.B(new X({..._.toggleStyles,isChecked:P===te.Filter})),this.c=this.B(new de({..._.toggleStyles,isChecked:T===ge.Fuzzy})),this.onDidChangeMode=w.Event.map(this.b.onChange,()=>this.b.checked?te.Filter:te.Highlight,this.q),this.onDidChangeMatchType=w.Event.map(this.c.onChange,()=>this.c.checked?ge.Fuzzy:ge.Contiguous,this.q),this.f=this.B(new D.$qU(this.a.findInput,v,{label:(0,L.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:_.inputBoxStyles,toggleStyles:_.toggleStyles,history:U?.history})),this.g=this.B(new W.$CS(this.a.actionbar)),this.mode=P;const Z=this.B(new N.$KS(this.f.inputBox.inputElement,"keydown")),oe=w.Event.chain(Z.event,Se=>Se.map(we=>new n.$DQ(we)));this.B(oe(Se=>{if(Se.equals(3)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Se.equals(18)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Se.equals(16)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const be=this.B(new f.$Vi("close",(0,L.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(be,{icon:!0,label:!1});const De=this.B(new N.$KS(this.a.grab,"mousedown"));this.B(De.event(Se=>{const we=new m.$Sc,Ne=we.add(new N.$KS((0,A.getWindow)(Se),"mousemove")),Me=we.add(new N.$KS((0,A.getWindow)(Se),"mouseup")),Pe=this.m,Xe=Se.pageX,nt=this.s,Qe=Se.pageY;this.a.grab.classList.add("grabbing");const Ze=this.a.root.style.transition;this.a.root.style.transition="unset";const G=ne=>{const pe=ne.pageX-Xe;this.m=Pe-pe;const Ee=ne.pageY-Qe;this.s=nt+Ee,this.layout()};we.add(Ne.event(G)),we.add(Me.event(ne=>{G(ne),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ze,we.dispose()}))}));const ve=w.Event.chain(this.B(new N.$KS(this.a.grab,"keydown")).event,Se=>Se.map(we=>new n.$DQ(we)));this.B(ve(Se=>{let we,Ne;if(Se.keyCode===15?we=Number.POSITIVE_INFINITY:Se.keyCode===17?we=0:Se.keyCode===10&&(we=this.m===0?Number.POSITIVE_INFINITY:0),Se.keyCode===16?Ne=0:Se.keyCode===18&&(Ne=Number.POSITIVE_INFINITY),we!==void 0&&(Se.preventDefault(),Se.stopPropagation(),this.m=we,this.layout()),Ne!==void 0){Se.preventDefault(),Se.stopPropagation(),this.s=Ne;const Me=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Me},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(i=this.j){this.j=i,this.m=(0,a.$fm)(this.m,0,Math.max(0,i-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,a.$fm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(i){this.f.showMessage(i)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$fh)(300),super.dispose()}}class Te{get pattern(){return this.b}get mode(){return this.d}set mode(i){i!==this.d&&(this.d=i,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(i))}get matchType(){return this.f}set matchType(i){i!==this.f&&(this.f=i,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(i))}constructor(i,o,v,P,T,U={}){this.t=i,this.u=v,this.v=P,this.w=T,this.x=U,this.b="",this.c="",this.j=0,this.k=new w.$5d,this.onDidChangeMode=this.k.event,this.m=new w.$5d,this.onDidChangeMatchType=this.m.event,this.o=new w.$5d,this.onDidChangePattern=this.o.event,this.p=new w.$5d,this.onDidChangeOpenState=this.p.event,this.q=new m.$Sc,this.s=new m.$Sc,this.d=i.options.defaultFindMode??te.Highlight,this.f=i.options.defaultFindMatchType??ge.Fuzzy,o.onDidSplice(this.z,this,this.s)}updateOptions(i={}){i.defaultFindMode!==void 0&&(this.mode=i.defaultFindMode),i.defaultFindMatchType!==void 0&&(this.matchType=i.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Le(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(i=>this.mode=i,void 0,this.q),this.g.onDidChangeMatchType(i=>this.matchType=i,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(i){this.b=i,this.o.fire(i),this.v.pattern=i,this.t.refilter(),i&&this.t.focusNext(0,!0,void 0,v=>!h.FuzzyScore.isDefault(v.filterData));const o=this.t.getFocus();if(o.length>0){const v=o[0];this.t.getRelativeTop(v)===null&&this.t.reveal(v,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const i=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&i?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,L.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(i){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!h.FuzzyScore.isDefault(i.filterData)}layout(i){this.j=i,this.g?.layout(i)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Be(r,i){return r.position===i.position&&le(r,i)}function le(r,i){return r.node.element===i.node.element&&r.startIndex===i.startIndex&&r.height===i.height&&r.endIndex===i.endIndex}class J{constructor(i=[]){this.stickyNodes=i}get count(){return this.stickyNodes.length}equal(i){return(0,t.$ub)(this.stickyNodes,i.stickyNodes,Be)}lastNodePartiallyVisible(){if(this.count===0)return!1;const i=this.stickyNodes[this.count-1];if(this.count===1)return i.position!==0;const o=this.stickyNodes[this.count-2];return o.position+o.height!==i.position}animationStateChanged(i){if(!(0,t.$ub)(this.stickyNodes,i.stickyNodes,le)||this.count===0)return!1;const o=this.stickyNodes[this.count-1],v=i.stickyNodes[i.count-1];return o.position!==v.position}}class ae{constrainStickyScrollNodes(i,o,v){for(let P=0;P<i.length;P++){const T=i[P];if(T.position+T.height>v||P>=o)return i.slice(0,P)}return i}}class re extends m.$Tc{constructor(i,o,v,P,T,U={}){super(),this.g=i,this.j=o,this.m=v,this.s=T,this.c=.4;const _=this.validateStickySettings(U);this.b=_.stickyScrollMaxItemCount,this.a=U.stickyScrollDelegate??new ae,this.f=this.B(new Y(v.getScrollableElement(),v,i,P,T,U.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(v.onDidScroll(()=>this.u())),this.B(v.onDidChangeContentHeight(()=>this.u())),this.B(i.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(i){return this.f.getNode(i)}t(i){let o;if(i===0?o=this.m.firstVisibleIndex:o=this.m.indexAt(i+this.m.scrollTop),!(o<0||o>=this.m.length))return this.m.element(o)}u(){const i=this.t(0);if(!i||this.g.scrollTop===0){this.f.setState(void 0);return}const o=this.w(i);this.f.setState(o)}w(i){const o=[];let v=i,P=0,T=this.z(v,void 0,P);for(;T&&(o.push(T),P+=T.height,!(o.length<=this.b&&(v=this.y(T),!v)));)T=this.z(v,T.node,P);const U=this.H(o);return U.length?new J(U):void 0}y(i){return this.t(i.position+i.height)}z(i,o,v){const P=this.F(i,o);if(P&&!(P===i&&(!this.J(i)||this.C(i,v))))return this.D(P,v)}C(i,o){const v=this.L(i),P=this.m.getElementTop(v),T=o;return this.m.scrollTop===P-T}D(i,o){const v=this.s.getHeight(i),{startIndex:P,endIndex:T}=this.M(i),U=this.G(T,o,v);return{node:i,position:U,height:v,startIndex:P,endIndex:T}}F(i,o=void 0){let v=i,P=this.I(v);for(;P;){if(P===o)return v;v=P,P=this.I(v)}if(o===void 0)return v}G(i,o,v){let P=this.m.getRelativeTop(i);if(P===null&&this.m.firstVisibleIndex===i&&i+1<this.m.length){const oe=this.s.getHeight(this.m.element(i)),be=this.m.getRelativeTop(i+1);P=be?be-oe/this.m.renderHeight:null}if(P===null)return o;const T=this.m.element(i),U=this.s.getHeight(T),Z=P*this.m.renderHeight+U;return o+v>Z&&o<=Z?Z-v:o}H(i){if(i.length===0)return[];const o=this.m.renderHeight*this.c,v=i[i.length-1];if(i.length<=this.b&&v.position+v.height<=o)return i;const P=this.a.constrainStickyScrollNodes(i,this.b,o);if(!P.length)return[];const T=P[P.length-1];if(P.length>this.b||T.position+T.height>o)throw new Error("stickyScrollDelegate violates constraints");return P}I(i){const o=this.j.getNodeLocation(i),v=this.j.getParentNodeLocation(o);return v?this.j.getNode(v):void 0}J(i){const o=this.j.getNodeLocation(i);return this.j.getListRenderCount(o)>1}L(i){const o=this.j.getNodeLocation(i);return this.j.getListIndex(o)}M(i){const o=this.j.getNodeLocation(i),v=this.j.getListIndex(o);if(v<0)throw new Error("Node not found in tree");const P=this.j.getListRenderCount(o),T=v+P-1;return{startIndex:v,endIndex:T}}nodePositionTopBelowWidget(i){const o=[];let v=this.I(i);for(;v;)o.push(v),v=this.I(v);let P=0;for(let T=0;T<o.length&&T<this.b;T++)P+=this.s.getHeight(o[T]);return P}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(i={}){if(!i.stickyScrollMaxItemCount)return;const o=this.validateStickySettings(i);this.b!==o.stickyScrollMaxItemCount&&(this.b=o.stickyScrollMaxItemCount,this.u())}validateStickySettings(i){let o=7;return typeof i.stickyScrollMaxItemCount=="number"&&(o=Math.max(i.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:o}}}class Y{constructor(i,o,v,P,T,U){this.g=o,this.j=v,this.k=P,this.m=T,this.o=U,this.c=[],this.d=new m.$Sc,this.a=(0,A.$)(".monaco-tree-sticky-container.empty"),i.appendChild(this.a);const _=(0,A.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(_),this.f=new Q(this.a,o),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const i=this.b.stickyNodes[this.b.count-1];return i.position+i.height}get count(){return this.b?.count??0}getNode(i){return this.b?.stickyNodes.find(o=>o.node===i)}setState(i){const o=!!this.b&&this.b.count>0,v=!!i&&i.count>0;if(!o&&!v||o&&v&&this.b.equal(i))return;if(o!==v&&this.s(v),!v){this.b=void 0,this.c=[],this.d.clear();return}const P=i.stickyNodes[i.count-1];if(this.b&&i.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${P.position}px`;else{this.d.clear();const T=Array(i.count);for(let U=i.count-1;U>=0;U--){const _=i.stickyNodes[U],{element:Z,disposable:oe}=this.p(_,U,i.count);T[U]=Z,this.a.appendChild(Z),this.d.add(oe)}this.f.updateElements(T,i),this.c=T}this.b=i,this.a.style.height=`${P.position+P.height}px`}p(i,o,v){const P=i.startIndex,T=document.createElement("div");T.style.top=`${i.position}px`,T.style.height=`${i.height}px`,T.style.lineHeight=`${i.height}px`,T.classList.add("monaco-tree-sticky-row"),T.classList.add("monaco-list-row"),T.setAttribute("data-index",`${P}`),T.setAttribute("data-parity",P%2===0?"even":"odd"),T.setAttribute("id",this.g.getElementID(P)),this.q(T,i.node.element,o,v);const U=this.m.getTemplateId(i.node),_=this.k.find(De=>De.templateId===U);if(!_)throw new Error(`No renderer found for template id ${U}`);let Z=i.node;Z===this.j.getNode(this.j.getNodeLocation(i.node))&&(Z=new Proxy(i.node,{}));const oe=_.renderTemplate(T);_.renderElement(Z,i.startIndex,oe,i.height);const be=(0,m.$Rc)(()=>{_.disposeElement(Z,i.startIndex,oe,i.height),_.disposeTemplate(oe),T.remove()});return{element:T,disposable:be}}q(i,o,v,P){if(!this.o)return;this.o.getSetSize&&i.setAttribute("aria-setsize",String(this.o.getSetSize(o,v,P))),this.o.getPosInSet&&i.setAttribute("aria-posinset",String(this.o.getPosInSet(o,v))),this.o.getRole&&i.setAttribute("role",this.o.getRole(o)??"treeitem");const T=this.o.getAriaLabel(o);T&&i.setAttribute("aria-label",T);const U=this.o.getAriaLevel&&this.o.getAriaLevel(o);typeof U=="number"&&i.setAttribute("aria-level",`${U}`),i.setAttribute("aria-selected",String(!1))}s(i){this.a.classList.toggle("empty",!i),i||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class Q extends m.$Tc{get m(){return this.j}set m(i){i!==this.j&&(this.f.fire(i),this.j=i)}constructor(i,o){super(),this.s=i,this.t=o,this.a=-1,this.b=[],this.f=new w.$5d,this.onDidChangeHasFocus=this.f.event,this.g=new w.$5d,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.I()),this.s.addEventListener("blur",()=>this.J()),this.B(this.t.onDidFocus(()=>this.H(!1))),this.B(this.t.onKeyDown(v=>this.w(v))),this.B(this.t.onMouseDown(v=>this.y(v))),this.B(this.t.onContextMenu(v=>this.u(v)))}u(i){const o=i.browserEvent.target;if(!(0,$.$8S)(o)&&!(0,$.$7S)(o)){this.focusedLast()&&this.t.domFocus();return}if(!(0,A.$xR)(i.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const U=this.c.stickyNodes.findIndex(_=>_.node.element===i.element?.element);if(U===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(U);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const P=this.c.stickyNodes[this.a].node.element,T=this.b[this.a];this.g.fire({element:P,anchor:T,browserEvent:i.browserEvent,isStickyScroll:!0})}w(i){if(this.m&&this.c){if(i.key==="ArrowUp")this.z(Math.max(0,this.a-1)),i.preventDefault(),i.stopPropagation();else if(i.key==="ArrowDown"||i.key==="ArrowRight"){if(this.a>=this.c.count-1){const o=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([o]),this.C(o,this.c)}else this.z(this.a+1);i.preventDefault(),i.stopPropagation()}}}y(i){const o=i.browserEvent.target;!(0,$.$8S)(o)&&!(0,$.$7S)(o)||(i.browserEvent.preventDefault(),i.browserEvent.stopPropagation())}updateElements(i,o){if(o&&o.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(o&&o.count!==i.length)throw new Error("Sticky scroll focus received illigel state");const v=this.a;if(this.D(),this.b=i,this.c=o,o){const P=(0,a.$fm)(v,0,o.count-1);this.F(P)}else this.m&&this.t.domFocus();this.s.tabIndex=o?0:-1}z(i){const o=this.c;if(!o)throw new Error("Cannot set focus when state is undefined");if(this.F(i),!(i<o.count-1)&&o.lastNodePartiallyVisible()){const v=o.stickyNodes[i];this.C(v.endIndex+1,o)}}C(i,o){const v=o.stickyNodes[o.count-1],P=o.count>1?o.stickyNodes[o.count-2]:void 0,T=this.t.getElementTop(i),U=P?P.position+P.height+v.height:v.height;this.t.scrollTop=T-U}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(i){if(0>i)throw new Error("addFocus() can not remove focus");if(!this.c&&i>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&i>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const o=this.a;o>=0&&this.G(this.b[o],!1),i>=0&&this.G(this.b[i],!0),this.a=i}G(i,o){i.classList.toggle("focused",o)}H(i){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",i)}I(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.H(!0),this.a===-1&&this.F(0)}J(){this.m=!1}dispose(){this.H(!1),this.f.fire(!1),super.dispose()}}function ie(r){let i=l.TreeMouseEventTarget.Unknown;return(0,A.$cR)(r.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?i=l.TreeMouseEventTarget.Twistie:(0,A.$cR)(r.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?i=l.TreeMouseEventTarget.Element:(0,A.$cR)(r.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(i=l.TreeMouseEventTarget.Filter),{browserEvent:r.browserEvent,element:r.element?r.element.element:null,target:i}}function fe(r){const i=(0,$.$8S)(r.browserEvent.target);return{element:r.element?r.element.element:null,browserEvent:r.browserEvent,anchor:r.anchor,isStickyScroll:i}}function ye(r,i){i(r),r.children.forEach(o=>ye(o,i))}class Ce{get f(){return this.d||(this.d=this.m()),this.d}constructor(i,o){this.g=i,this.j=o,this.a=[],this.c=new w.$5d,this.onDidChange=this.c.event}set(i,o){!o?.__forceEvent&&(0,t.$ub)(this.a,i)||this.k(i,!1,o)}k(i,o,v){if(this.a=[...i],this.b=void 0,this.d=void 0,!o){const P=this;this.c.fire({get elements(){return P.get()},browserEvent:v})}}get(){return this.b||(this.b=this.a.map(i=>i.element)),[...this.b]}getNodes(){return this.a}has(i){return this.f.has(i)}onDidModelSplice({insertedNodes:i,deletedNodes:o}){if(!this.j){const Z=this.m(),oe=be=>Z.delete(be);o.forEach(be=>ye(be,oe)),this.set([...Z.values()]);return}const v=new Set,P=Z=>v.add(this.j.getId(Z.element).toString());o.forEach(Z=>ye(Z,P));const T=new Map,U=Z=>T.set(this.j.getId(Z.element).toString(),Z);i.forEach(Z=>ye(Z,U));const _=[];for(const Z of this.a){const oe=this.j.getId(Z.element).toString();if(!v.has(oe))_.push(Z);else{const De=T.get(oe);De&&De.visible&&_.push(De)}}if(this.a.length>0&&_.length===0){const Z=this.g();Z&&_.push(Z)}this.k(_,!0)}m(){const i=new Set;for(const o of this.a)i.add(o);return i}}class ke extends $.$aT{constructor(i,o,v){super(i),this.x=o,this.y=v}u(i){if((0,$.$9S)(i.browserEvent.target)||(0,$.$2S)(i.browserEvent.target)||(0,$.$3S)(i.browserEvent.target)||i.browserEvent.isHandledByList)return;const o=i.element;if(!o)return super.u(i);if(this.p(i)||this.o(i))return super.u(i);const v=i.browserEvent.target,P=v.classList.contains("monaco-tl-twistie")||v.classList.contains("monaco-icon-label")&&v.classList.contains("folder-icon")&&i.browserEvent.offsetX<16,T=(0,$.$7S)(i.browserEvent.target);let U=!1;if(T?U=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?U=this.x.expandOnlyOnTwistieClick(o.element):U=!!this.x.expandOnlyOnTwistieClick,T)this.A(i,o);else{if(U&&!P&&i.browserEvent.detail!==2)return super.u(i);if(!this.x.expandOnDoubleClick&&i.browserEvent.detail===2)return super.u(i)}if(o.collapsible&&(!T||P)){const _=this.x.getNodeLocation(o),Z=i.browserEvent.altKey;if(this.x.setFocus([_]),this.x.toggleCollapsed(_,Z),U&&P){i.browserEvent.isHandledByList=!0;return}}T||super.u(i)}A(i,o){if((0,$.$4S)(i.browserEvent.target)||(0,$.$5S)(i.browserEvent.target))return;const v=this.y();if(!v)throw new Error("Sticky scroll controller not found");const P=this.k.indexOf(o),T=this.k.getElementTop(P),U=v.nodePositionTopBelowWidget(o);this.x.scrollTop=T-U,this.k.domFocus(),this.k.setFocus([P]),this.k.setSelection([P])}v(i){i.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||i.browserEvent.isHandledByList||super.v(i)}s(i){const o=i.browserEvent.target;if(!(0,$.$8S)(o)&&!(0,$.$7S)(o)){super.s(i);return}}t(i){const o=i.browserEvent.target;if(!(0,$.$8S)(o)&&!(0,$.$7S)(o)){super.t(i);return}}}class q extends $.$dT{constructor(i,o,v,P,T,U,_,Z){super(i,o,v,P,Z),this.p=T,this.s=U,this.K=_}D(i){return new ke(this,i.tree,i.stickyScrollProvider)}splice(i,o,v=[]){if(super.splice(i,o,v),v.length===0)return;const P=[],T=[];let U;v.forEach((_,Z)=>{this.p.has(_)&&P.push(i+Z),this.s.has(_)&&T.push(i+Z),this.K.has(_)&&(U=i+Z)}),P.length>0&&super.setFocus((0,t.$Mb)([...super.getFocus(),...P])),T.length>0&&super.setSelection((0,t.$Mb)([...super.getSelection(),...T])),typeof U=="number"&&super.setAnchor(U)}setFocus(i,o,v=!1){super.setFocus(i,o),v||this.p.set(i.map(P=>this.element(P)),o)}setSelection(i,o,v=!1){super.setSelection(i,o),v||this.s.set(i.map(P=>this.element(P)),o)}setAnchor(i,o=!1){super.setAnchor(i),o||(typeof i>"u"?this.K.set([]):this.K.set([this.element(i)]))}}var d;(function(r){r[r.Tree=0]="Tree",r[r.StickyScroll=1]="StickyScroll"})(d||(e.AbstractTreePart=d={}));class k{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return w.Event.map(this.j.onMouseClick,ie)}get onMouseDblClick(){return w.Event.filter(w.Event.map(this.j.onMouseDblClick,ie),i=>i.target!==l.TreeMouseEventTarget.Filter)}get onContextMenu(){return w.Event.any(w.Event.filter(w.Event.map(this.j.onContextMenu,fe),i=>!i.isStickyScroll),this.B?.onContextMenu??w.Event.None)}get onTap(){return w.Event.map(this.j.onTap,ie)}get onPointer(){return w.Event.map(this.j.onPointer,ie)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return w.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??te.Highlight}set findMode(i){this.z&&(this.z.mode=i)}get findMatchType(){return this.z?.matchType??ge.Fuzzy}set findMatchType(i){this.z&&(this.z.matchType=i)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:w.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(i,o,v,P,T={}){this.G=i,this.H=T,this.y=new w.$ae,this.onDidChangeFindOpenState=w.Event.None,this.onDidChangeStickyScrollFocused=w.Event.None,this.D=new m.$Sc,this.E=new w.$5d,this.onWillRefilter=this.E.event,this.F=new w.$5d,this.onDidUpdateOptions=this.F.event,this.p=new B(v);const U=new w.$be,_=new w.$be,Z=this.D.add(new M(_.event)),oe=new u.$Gc;this.k=P.map(we=>new I(we,()=>this.o,U.event,Z,oe,T));for(const we of this.k)this.D.add(we);let be;T.keyboardNavigationLabelProvider&&(be=new x(this,T.keyboardNavigationLabelProvider,T.filter),T={...T,filter:be},this.D.add(be)),this.q=new Ce(()=>this.j.getFocusedElements()[0],T.identityProvider),this.w=new Ce(()=>this.j.getSelectedElements()[0],T.identityProvider),this.x=new Ce(()=>this.j.getAnchorElement(),T.identityProvider),this.j=new q(i,o,this.p,this.k,this.q,this.w,this.x,{...E(()=>this.o,T),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(i,this.j,T),U.input=this.o.onDidChangeCollapseState;const De=w.Event.forEach(this.o.onDidSplice,we=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(we),this.w.onDidModelSplice(we)})},this.D);De(()=>null,null,this.D);const ve=this.D.add(new w.$5d),Se=this.D.add(new s.$bh(0));if(this.D.add(w.Event.any(De,this.q.onDidChange,this.w.onDidChange)(()=>{Se.trigger(()=>{const we=new Set;for(const Ne of this.q.getNodes())we.add(Ne);for(const Ne of this.w.getNodes())we.add(Ne);ve.fire([...we.values()])})})),_.input=ve.event,T.keyboardSupport!==!1){const we=w.Event.chain(this.j.onKeyDown,Ne=>Ne.filter(Me=>!(0,$.$2S)(Me.target)).map(Me=>new n.$DQ(Me)));w.Event.chain(we,Ne=>Ne.filter(Me=>Me.keyCode===15))(this.J,this,this.D),w.Event.chain(we,Ne=>Ne.filter(Me=>Me.keyCode===17))(this.K,this,this.D),w.Event.chain(we,Ne=>Ne.filter(Me=>Me.keyCode===10))(this.L,this,this.D)}if((T.findWidgetEnabled??!0)&&T.keyboardNavigationLabelProvider&&T.contextViewProvider){const we=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Te(this,this.o,this.j,be,T.contextViewProvider,we),this.A=Ne=>this.z.shouldAllowFocus(Ne),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=w.Event.None,this.onDidChangeFindMatchType=w.Event.None;T.enableStickyScroll&&(this.B=new re(this,this.o,this.j,this.k,this.p,T),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,A.$pR)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===F.Always)}updateOptions(i={}){this.H={...this.H,...i};for(const o of this.k)o.updateOptions(i);this.j.updateOptions(this.H),this.z?.updateOptions(i),this.I(i),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===F.Always)}get options(){return this.H}I(i){!this.B&&this.H.enableStickyScroll?(this.B=new re(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=w.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(i)}updateWidth(i){const o=this.o.getListIndex(i);o!==-1&&this.j.updateWidth(o)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(i){this.j.scrollTop=i}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(i){this.j.scrollLeft=i}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let i=this.j.firstVisibleIndex;return this.B&&(i+=this.B.count),i<0||i>=this.j.length?void 0:this.j.element(i).element}get lastVisibleElement(){const i=this.j.lastVisibleIndex;return this.j.element(i).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(i){this.j.ariaLabel=i}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,A.$hR)(this.getHTMLElement())}layout(i,o){this.j.layout(i,o),(0,y.$Wf)(o)&&this.z?.layout(o)}style(i){const o=`.${this.j.domId}`,v=[];i.treeIndentGuidesStroke&&(v.push(`.monaco-list${o}:hover .monaco-tl-indent > .indent-guide, .monaco-list${o}.always .monaco-tl-indent > .indent-guide  { border-color: ${i.treeInactiveIndentGuidesStroke}; }`),v.push(`.monaco-list${o} .monaco-tl-indent > .indent-guide.active { border-color: ${i.treeIndentGuidesStroke}; }`)),i.listBackground&&(v.push(`.monaco-list${o} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${i.listBackground}; }`),v.push(`.monaco-list${o} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${i.listBackground}; }`)),i.listFocusForeground&&(v.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${i.listFocusForeground}; }`),v.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const P=(0,A.$ZR)(i.listFocusAndSelectionOutline,(0,A.$ZR)(i.listSelectionOutline,i.listFocusOutline??""));P&&(v.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${P}; outline-offset: -1px;}`),v.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),i.listFocusOutline&&(v.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${i.listFocusOutline}; outline-offset: -1px; }`),v.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),v.push(`.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),v.push(`.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=v.join(`
`),this.j.style(i)}getParentElement(i){const o=this.o.getParentNodeLocation(i);return this.o.getNode(o).element}getFirstElementChild(i){return this.o.getFirstElementChild(i)}getNode(i){return this.o.getNode(i)}getNodeLocation(i){return this.o.getNodeLocation(i)}collapse(i,o=!1){return this.o.setCollapsed(i,!0,o)}expand(i,o=!1){return this.o.setCollapsed(i,!1,o)}toggleCollapsed(i,o=!1){return this.o.setCollapsed(i,void 0,o)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(i){return this.o.isCollapsible(i)}setCollapsible(i,o){return this.o.setCollapsible(i,o)}isCollapsed(i){return this.o.isCollapsed(i)}expandTo(i){this.o.expandTo(i)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(i){if(typeof i>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const o=this.o.getNode(i);this.x.set([o]);const v=this.o.getListIndex(i);v>-1&&this.j.setAnchor(v,!0)})}getAnchor(){return(0,t.$Ob)(this.x.get(),void 0)}setSelection(i,o){this.y.bufferEvents(()=>{const v=i.map(T=>this.o.getNode(T));this.w.set(v,o);const P=i.map(T=>this.o.getListIndex(T)).filter(T=>T>-1);this.j.setSelection(P,o,!0)})}getSelection(){return this.w.get()}setFocus(i,o){this.y.bufferEvents(()=>{const v=i.map(T=>this.o.getNode(T));this.q.set(v,o);const P=i.map(T=>this.o.getListIndex(T)).filter(T=>T>-1);this.j.setFocus(P,o,!0)})}focusNext(i=1,o=!1,v,P=(0,A.$xR)(v)&&v.altKey?void 0:this.A){this.j.focusNext(i,o,v,P)}focusPrevious(i=1,o=!1,v,P=(0,A.$xR)(v)&&v.altKey?void 0:this.A){this.j.focusPrevious(i,o,v,P)}focusNextPage(i,o=(0,A.$xR)(i)&&i.altKey?void 0:this.A){return this.j.focusNextPage(i,o)}focusPreviousPage(i,o=(0,A.$xR)(i)&&i.altKey?void 0:this.A){return this.j.focusPreviousPage(i,o,()=>this.B?.height??0)}focusLast(i,o=(0,A.$xR)(i)&&i.altKey?void 0:this.A){this.j.focusLast(i,o)}focusFirst(i,o=(0,A.$xR)(i)&&i.altKey?void 0:this.A){this.j.focusFirst(i,o)}getFocus(){return this.q.get()}getStickyScrollFocus(){const i=this.B?.getFocus();return i!==void 0?[i]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(i,o){this.o.expandTo(i);const v=this.o.getListIndex(i);if(v!==-1)if(!this.B)this.j.reveal(v,o);else{const P=this.B.nodePositionTopBelowWidget(this.getNode(i));this.j.reveal(v,o,P)}}getRelativeTop(i){const o=this.o.getListIndex(i);if(o===-1)return null;const v=this.B?.getNode(this.getNode(i));return this.j.getRelativeTop(o,v?.position??this.B?.height)}getViewState(i=this.options.identityProvider){if(!i)throw new l.$RU(this.G,"Can't get tree view state without an identity provider");const o=U=>i.getId(U).toString(),v=j.empty(this.scrollTop);for(const U of this.getFocus())v.focus.add(o(U));for(const U of this.getSelection())v.selection.add(o(U));const P=this.o.getNode(),T=[P];for(;T.length>0;){const U=T.shift();U!==P&&U.collapsible&&(v.expanded[o(U.element)]=U.collapsed?0:1),T.push(...U.children)}return v}J(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const v=o[0],P=this.o.getNodeLocation(v);if(!this.o.setCollapsed(P,!0)){const U=this.o.getParentNodeLocation(P);if(!U)return;const _=this.o.getListIndex(U);this.j.reveal(_),this.j.setFocus([_])}}K(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const v=o[0],P=this.o.getNodeLocation(v);if(!this.o.setCollapsed(P,!1)){if(!v.children.some(Z=>Z.visible))return;const[U]=this.j.getFocus(),_=U+1;this.j.reveal(_),this.j.setFocus([_])}}L(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const v=o[0],P=this.o.getNodeLocation(v),T=i.browserEvent.altKey;this.o.setCollapsed(P,void 0,T)}navigate(i){return new C(this.j,this.o,i)}dispose(){(0,m.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}e.$2U=k;class C{constructor(i,o,v){this.b=i,this.c=o,v?this.a=this.c.getListIndex(v):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[134],$e([1,0,133,125,26,28]),function(se,e,A,N,n,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aV=void 0;class D extends A.$2U{constructor(b,$,p,O,l,f={}){super(b,$,p,O,f),this.f=b,this.g=l,this.d=new Map,this.c=f.identityProvider}getInput(){return this.b}setInput(b,$){if($&&!this.c)throw new n.$RU(this.f,"Can't restore tree view state without an identity provider");if(this.b=b,!b){this.d.clear(),this.o.setChildren(null,W.Iterable.empty());return}if(!$){this.m(b);return}const p=[],O=[],l=t=>{const s=this.c.getId(t).toString();return!$.expanded[s]},f=t=>{const s=this.c.getId(t.element).toString();$.focus.has(s)&&p.push(t.element),$.selection.has(s)&&O.push(t.element)};this.m(b,l,f),this.setFocus(p),this.setSelection(O),$&&typeof $.scrollTop=="number"&&(this.scrollTop=$.scrollTop)}updateChildren(b=this.b){if(typeof this.b>"u")throw new n.$RU(this.f,"Tree input not set");let $;this.c&&($=p=>{const O=this.c.getId(p).toString(),l=this.d.get(O);if(l)return l.collapsed}),this.m(b,$)}resort(b=this.b,$=!0){this.o.resort(b===this.b?null:b,$)}refresh(b){if(b===void 0){this.j.rerender();return}this.o.rerender(b)}m(b,$,p){let O;if(this.c){const l=new Set,f=p;p=t=>{const s=this.c.getId(t.element).toString();l.add(s),this.d.set(s,t),f?.(t)},O=t=>{const s=this.c.getId(t.element).toString();l.has(s)||this.d.delete(s)}}this.o.setChildren(b===this.b?null:b,this.s(b,$).elements,{onDidCreateNode:p,onDidDeleteNode:O})}s(b,$){const p=[...this.g.getChildren(b)];return{elements:W.Iterable.map(p,l=>{const{elements:f,size:t}=this.s(l,$),s=this.g.hasChildren?this.g.hasChildren(l):void 0,c=t===0?void 0:$&&$(l);return{element:l,children:f,collapsible:s,collapsed:c}}),size:p.length}}M(b,$,p){return new N.$3U(b,$,p)}}e.$aV=D}),define(me[69],$e([1,0,12,9,35,30,27,6,4,3,55,10,7]),function(se,e,A,N,n,W,D,S,b,$,p,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.ProxyChannel=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.RequestInitiator=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=void 0;var f;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(f||(f={}));function t(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(s||(s={}));function c(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(g||(g={}));function u(le){let J=0;for(let ae=0;;ae+=7){const re=le.read(1);if(J|=(re.buffer[0]&127)<<ae,!(re.buffer[0]&128))return J}}const w=L(0);function h(le,J){if(J===0){le.write(w);return}let ae=0;for(let Y=J;Y!==0;Y=Y>>>7)ae++;const re=n.$se.alloc(ae);for(let Y=0;J!==0;Y++)re.buffer[Y]=J&127,J=J>>>7,J>0&&(re.buffer[Y]|=128);le.write(re)}class m{constructor(J){this.b=J,this.a=0}read(J){const ae=this.b.slice(this.a,this.a+J);return this.a+=ae.byteLength,ae}}e.$Oh=m;class a{constructor(){this.a=[]}get buffer(){return n.$se.concat(this.a)}write(J){this.a.push(J)}}e.$Ph=a;var y;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(y||(y={}));function L(le){const J=n.$se.alloc(1);return J.writeUInt8(le,0),J}const R={Undefined:L(y.Undefined),String:L(y.String),Buffer:L(y.Buffer),VSBuffer:L(y.VSBuffer),Array:L(y.Array),Object:L(y.Object),Uint:L(y.Int)},z=typeof Buffer<"u";function H(le,J){if(typeof J>"u")le.write(R.Undefined);else if(typeof J=="string"){const ae=n.$se.fromString(J);le.write(R.String),h(le,ae.byteLength),le.write(ae)}else if(z&&Buffer.isBuffer(J)){const ae=n.$se.wrap(J);le.write(R.Buffer),h(le,ae.byteLength),le.write(ae)}else if(J instanceof n.$se)le.write(R.VSBuffer),h(le,J.byteLength),le.write(J);else if(Array.isArray(J)){le.write(R.Array),h(le,J.length);for(const ae of J)H(le,ae)}else if(typeof J=="number"&&(J|0)===J)le.write(R.Uint),h(le,J);else{const ae=n.$se.fromString(JSON.stringify(J));le.write(R.Object),h(le,ae.byteLength),le.write(ae)}}e.$Qh=H;function E(le){switch(le.read(1).readUInt8(0)){case y.Undefined:return;case y.String:return le.read(u(le)).toString();case y.Buffer:return le.read(u(le)).buffer;case y.VSBuffer:return le.read(u(le));case y.Array:{const ae=u(le),re=[];for(let Y=0;Y<ae;Y++)re.push(E(le));return re}case y.Object:return JSON.parse(le.read(u(le)).toString());case y.Int:return u(le)}}e.$Rh=E;class B{constructor(J,ae,re=null,Y=1e3){this.h=J,this.j=ae,this.k=re,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(J,ae){this.b.set(J,ae),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const ae=this.o([J.type]);this.k?.logOutgoing(ae,0,1,c(J.type));return}case 201:case 202:case 204:case 203:{const ae=this.o([J.type,J.id],J.data);this.k?.logOutgoing(ae,J.id,1,c(J.type),J.data);return}}}o(J,ae=void 0){const re=new a;return H(re,J),H(re,ae),this.p(re.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const ae=new m(J),re=E(ae),Y=E(ae),Q=re[0];switch(Q){case 100:return this.k?.logIncoming(J.byteLength,re[1],1,`${t(Q)}: ${re[2]}.${re[3]}`,Y),this.s({type:Q,id:re[1],channelName:re[2],name:re[3],arg:Y});case 102:return this.k?.logIncoming(J.byteLength,re[1],1,`${t(Q)}: ${re[2]}.${re[3]}`,Y),this.t({type:Q,id:re[1],channelName:re[2],name:re[3],arg:Y});case 101:return this.k?.logIncoming(J.byteLength,re[1],1,`${t(Q)}`),this.u({type:Q,id:re[1]});case 103:return this.k?.logIncoming(J.byteLength,re[1],1,`${t(Q)}`),this.u({type:Q,id:re[1]})}}s(J){const ae=this.b.get(J.channelName);if(!ae){this.v(J);return}const re=new W.$ce;let Y;try{Y=ae.call(this.j,J.name,J.arg,re.token)}catch(fe){Y=Promise.reject(fe)}const Q=J.id;Y.then(fe=>{this.m({id:Q,data:fe,type:201})},fe=>{fe instanceof Error?this.m({id:Q,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.m({id:Q,data:fe,type:203})}).finally(()=>{ie.dispose(),this.d.delete(J.id)});const ie=(0,$.$Rc)(()=>re.cancel());this.d.set(J.id,ie)}t(J){const ae=this.b.get(J.channelName);if(!ae){this.v(J);return}const re=J.id,Q=ae.listen(this.j,J.name,J.arg)(ie=>this.m({id:re,data:ie,type:204}));this.d.set(J.id,Q)}u(J){const ae=this.d.get(J.id);ae&&(ae.dispose(),this.d.delete(J.id))}v(J){let ae=this.g.get(J.channelName);ae||(ae=[],this.g.set(J.channelName,ae));const re=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ae.push({request:J,timeoutTimer:re})}w(J){const ae=this.g.get(J);if(ae){for(const re of ae)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$Oc)(this.d.values()),this.d.clear()}}e.$Sh=B;var j;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(j||(e.RequestInitiator=j={}));class F{constructor(J,ae=null){this.l=J,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$5d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ae}getChannel(J){const ae=this;return{call(re,Y,Q){return ae.a?Promise.reject(new S.$5):ae.m(J,re,Y,Q)},listen(re,Y){return ae.a?b.Event.None:ae.o(J,re,Y)}}}m(J,ae,re,Y=W.CancellationToken.None){const Q=this.g++,fe={id:Q,type:100,channelName:J,name:ae,arg:re};if(Y.isCancellationRequested)return Promise.reject(new S.$5);let ye;return new Promise((ke,q)=>{if(Y.isCancellationRequested)return q(new S.$5);const d=()=>{const i=o=>{switch(o.type){case 201:this.f.delete(Q),ke(o.data);break;case 202:{this.f.delete(Q);const v=new Error(o.data.message);v.stack=Array.isArray(o.data.stack)?o.data.stack.join(`
`):o.data.stack,v.name=o.data.name,q(v);break}case 203:this.f.delete(Q),q(o.data);break}};this.f.set(Q,i),this.p(fe)};let k=null;this.b===g.Idle?d():(k=(0,N.$4g)(i=>this.u()),k.then(()=>{k=null,d()}));const C=()=>{k?(k.cancel(),k=null):this.p({id:Q,type:101}),q(new S.$5)},r=Y.onCancellationRequested(C);ye=(0,$.$Qc)((0,$.$Rc)(C),r),this.d.add(ye)}).finally(()=>{ye.dispose(),this.d.delete(ye)})}o(J,ae,re){const Y=this.g++,ie={id:Y,type:102,channelName:J,name:ae,arg:re};let fe=null;const ye=new b.$5d({onWillAddFirstListener:()=>{fe=(0,N.$4g)(ke=>this.u()),fe.then(()=>{fe=null,this.d.add(ye),this.p(ie)})},onDidRemoveLastListener:()=>{fe?(fe.cancel(),fe=null):(this.d.delete(ye),this.p({id:Y,type:103}))}}),Ce=ke=>ye.fire(ke.data);return this.f.set(Y,Ce),ye.event}p(J){switch(J.type){case 100:case 102:{const ae=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(ae,J.id,0,`${t(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const ae=this.q([J.type,J.id]);this.j?.logOutgoing(ae,J.id,0,t(J.type));return}}}q(J,ae=void 0){const re=new a;return H(re,J),H(re,ae),this.r(re.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const ae=new m(J),re=E(ae),Y=E(ae),Q=re[0];switch(Q){case 200:return this.j?.logIncoming(J.byteLength,0,0,c(Q)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,re[1],0,c(Q),Y),this.t({type:re[0],id:re[1],data:Y})}}t(J){if(J.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$Oc)(this.d.values()),this.d.clear()}}e.$Th=F,xe([D.$Ih],F.prototype,"onDidInitializePromise",null);class M{get connections(){const J=[];return this.f.forEach(ae=>J.push(ae)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new b.$5d,this.onDidAddConnection=this.g.event,this.h=new b.$5d,this.onDidRemoveConnection=this.h.event,this.j=new $.$Sc,this.j.add(J(({protocol:ae,onDidClientDisconnect:re})=>{const Y=b.Event.once(ae.onMessage);this.j.add(Y(Q=>{const ie=new m(Q),fe=E(ie),ye=new B(ae,fe),Ce=new F(ae);this.a.forEach((q,d)=>ye.registerChannel(d,q));const ke={channelServer:ye,channelClient:Ce,ctx:fe};this.f.add(ke),this.g.fire(ke),this.j.add(re(()=>{ye.dispose(),Ce.dispose(),this.f.delete(ke),this.h.fire(ke)}))}))}))}getChannel(J,ae){const re=this;return{call(Y,Q,ie){let fe;if((0,l.$7f)(ae)){const Ce=(0,A.$4b)(re.connections.filter(ae));fe=Ce?Promise.resolve(Ce):b.Event.toPromise(b.Event.filter(re.onDidAddConnection,ae))}else fe=ae.routeCall(re,Y,Q);const ye=fe.then(Ce=>Ce.channelClient.getChannel(J));return x(ye).call(Y,Q,ie)},listen(Y,Q){if((0,l.$7f)(ae))return re.k(J,ae,Y,Q);const ie=ae.routeEvent(re,Y,Q).then(fe=>fe.channelClient.getChannel(J));return x(ie).listen(Y,Q)}}}k(J,ae,re,Y){const Q=this;let ie;const fe=new b.$5d({onWillAddFirstListener:()=>{ie=new $.$Sc;const ye=new b.$$d,Ce=new Map,ke=d=>{const C=d.channelClient.getChannel(J).listen(re,Y),r=ye.add(C);Ce.set(d,r)},q=d=>{const k=Ce.get(d);k&&(k.dispose(),Ce.delete(d))};Q.connections.filter(ae).forEach(ke),b.Event.filter(Q.onDidAddConnection,ae)(ke,void 0,ie),Q.onDidRemoveConnection(q,void 0,ie),ye.event(fe.fire,fe,ie),ie.add(ye)},onDidRemoveLastListener:()=>{ie?.dispose(),ie=void 0}});return fe.event}registerChannel(J,ae){this.a.set(J,ae);for(const re of this.f)re.channelServer.registerChannel(J,ae)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Uh=M;class I{constructor(J,ae,re=null){const Y=new a;H(Y,ae),J.send(Y.buffer),this.a=new F(J,re),this.d=new B(J,ae,re)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,ae){this.d.registerChannel(J,ae)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Vh=I;function x(le){return{call(J,ae,re){return le.then(Y=>Y.call(J,ae,re))},listen(J,ae){const re=new b.$be;return le.then(Y=>re.input=Y.listen(J,ae)),re.event}}}e.$Wh=x;function X(le){let J=!1;return{call(ae,re,Y){return J?le.call(ae,re,Y):(0,N.$fh)(0).then(()=>J=!0).then(()=>le.call(ae,re,Y))},listen(ae,re){if(J)return le.listen(ae,re);const Y=new b.$be;return(0,N.$fh)(0).then(()=>J=!0).then(()=>Y.input=le.listen(ae,re)),Y.event}}}e.$Xh=X;class de{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const ae of J.connections)if(await Promise.resolve(this.a(ae.ctx)))return Promise.resolve(ae);return await b.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$Yh=de;var ue;(function(le){function J(Q,ie,fe){const ye=Q,Ce=fe&&fe.disableMarshalling,ke=new Map;for(const q in ye)re(q)&&ke.set(q,b.Event.buffer(ye[q],!0,void 0,ie));return new class{listen(q,d,k){const C=ke.get(d);if(C)return C;if(Y(d)){const r=ye[d];if(typeof r=="function")return r.call(ye,k)}throw new S.$bb(`Event not found: ${d}`)}call(q,d,k){const C=ye[d];if(typeof C=="function"){if(!Ce&&Array.isArray(k))for(let i=0;i<k.length;i++)k[i]=(0,p.$Nh)(k[i]);let r=C.apply(ye,k);return r instanceof Promise||(r=Promise.resolve(r)),r}throw new S.$bb(`Method not found: ${d}`)}}}le.fromService=J;function ae(Q,ie){const fe=ie&&ie.disableMarshalling;return new Proxy({},{get(ye,Ce){if(typeof Ce=="string")return ie?.properties?.has(Ce)?ie.properties.get(Ce):Y(Ce)?function(ke){return Q.listen(Ce,ke)}:re(Ce)?Q.listen(Ce):async function(...ke){let q;ie&&!(0,l.$2f)(ie.context)?q=[ie.context,...ke]:q=ke;const d=await Q.call(Ce,q);return fe?d:(0,p.$Nh)(d)};throw new S.$bb(`Property not found: ${String(Ce)}`)}})}le.toService=ae;function re(Q){return Q[0]==="o"&&Q[1]==="n"&&O.$if(Q.charCodeAt(2))}function Y(Q){return/^onDynamic/.test(Q)&&O.$if(Q.charCodeAt(9))}})(ue||(e.ProxyChannel=ue={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const J=le.toString();if(J!=="[object Object]")return J}return le}function Le(le){return Array.isArray(le)?le.map(ge):ge(le)}function Te(le,J,ae,re,Y,Q,ie){ie=Le(ie);const fe=te[Y],ye=fe[re%fe.length];let Ce=[`%c[${le}]%c[${String(J).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(Q)?(Ce=Ce.concat(ie),Ce.push(")")):Ce.push(ie),console.log.apply(console,Ce)}class Be{constructor(J,ae){this.d=J,this.f=ae,this.a=0,this.b=0}logOutgoing(J,ae,re,Y,Q){this.b+=J,Te(this.d,this.b,J,ae,re,Y,Q)}logIncoming(J,ae,re,Y,Q){this.a+=J,Te(this.f,this.a,J,ae,re,Y,Q)}}e.$Zh=Be}),define(me[135],$e([1,0,35,4,69,92,31]),function(se,e,A,N,n,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KV=void 0;class S extends n.$Vh{static f(){const $=N.Event.fromNodeEventEmitter(D.$O,"vscode:message",(p,O)=>A.$se.wrap(O));return D.$O.send("vscode:hello"),new W.$GV(D.$O,$)}constructor($){const p=S.f();super(p,$),this.b=p}dispose(){this.b.disconnect(),super.dispose()}}e.$KV=S}),define(me[136],$e([13,11]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(me[137],$e([13,11]),function(se,e){return se.create("vs/platform/theme/common/iconRegistry",e)}),define(me[43],$e([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e._util=void 0;var A;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(b){return b[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(A||(e._util=A={})),e.$di=n("instantiationService");function N(D,S,b){S[A.DI_TARGET]===S?S[A.DI_DEPENDENCIES].push({id:D,index:b}):(S[A.DI_DEPENDENCIES]=[{id:D,index:b}],S[A.DI_TARGET]=S)}function n(D){if(A.serviceIds.has(D))return A.serviceIds.get(D);const S=function(b,$,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(S,b,p)};return S.toString=()=>D,A.serviceIds.set(D,S),S}e.$ei=n;function W(D){return D}e.$fi=W}),define(me[138],$e([1,0,43]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=e.ID=void 0,e.ID="diagnosticsService",e.$Um=(0,A.$ei)(e.ID);function N(W){return!!W.hostName&&!!W.errorMessage}e.$Vm=N;class n{async getPerformanceInfo(D,S){return{}}async getSystemInfo(D,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,S){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$Wm=n}),define(me[139],$e([1,0,90,24,10,7,15,136,43,5,32,22]),function(se,e,A,N,n,W,D,S,b,$,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.FileKind=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileOperationResult=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileChangeType=e.$Tk=e.FileOperation=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileSystemProviderErrorCode=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderCapabilities=e.$Dk=e.FilePermission=e.FileType=e.$Ck=e.$Bk=void 0,e.$Bk=(0,b.$ei)("fileService");function l(Y){return Y.create===!0}e.$Ck=l;var f;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var t;(function(Y){Y[Y.Readonly=1]="Readonly",Y[Y.Locked=2]="Locked"})(t||(e.FilePermission=t={}));function s(Y){const Q=Y;return!!Q&&typeof Q.onDidChange=="function"}e.$Dk=s;var c;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileAtomicWrite=32768]="FileAtomicWrite",Y[Y.FileAtomicDelete=65536]="FileAtomicDelete",Y[Y.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function g(Y){return!!(Y.capabilities&2)}e.$Ek=g;function u(Y){return!!(Y.capabilities&8)}e.$Fk=u;function w(Y){return!!(Y.capabilities&131072)}e.$Gk=w;function h(Y){return!!(Y.capabilities&4)}e.$Hk=h;function m(Y){return!!(Y.capabilities&16)}e.$Ik=m;function a(Y){return g(Y)?!!(Y.capabilities&16384):!1}e.$Jk=a;function y(Y){return g(Y)?!!(Y.capabilities&32768):!1}e.$Kk=y;function L(Y){return!!(Y.capabilities&65536)}e.$Lk=L;function R(Y){return!!(Y.capabilities&2048)}e.$Mk=R;var z;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(z||(e.FileSystemProviderErrorCode=z={}));class H extends Error{static create(Q,ie){const fe=new H(Q.toString(),ie);return j(fe,ie),fe}constructor(Q,ie){super(Q),this.code=ie}}e.$Nk=H;function E(Y,Q){return H.create(Y,Q)}e.$Ok=E;function B(Y){return Y||E((0,S.localize)(0,null),z.Unknown)}e.$Pk=B;function j(Y,Q){return Y.name=Q?`${Q} (FileSystemError)`:"FileSystemError",Y}e.$Qk=j;function F(Y){if(!Y)return z.Unknown;if(Y instanceof H)return Y.code;const Q=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!Q)return z.Unknown;switch(Q[1]){case z.FileExists:return z.FileExists;case z.FileIsADirectory:return z.FileIsADirectory;case z.FileNotADirectory:return z.FileNotADirectory;case z.FileNotFound:return z.FileNotFound;case z.FileTooLarge:return z.FileTooLarge;case z.FileWriteLocked:return z.FileWriteLocked;case z.NoPermissions:return z.NoPermissions;case z.Unavailable:return z.Unavailable}return z.Unknown}e.$Rk=F;function M(Y){if(Y instanceof te)return Y.fileOperationResult;switch(F(Y)){case z.FileNotFound:return 1;case z.FileIsADirectory:return 0;case z.FileNotADirectory:return 9;case z.FileWriteLocked:return 5;case z.NoPermissions:return 6;case z.FileExists:return 4;case z.FileTooLarge:return 7;default:return 10}}e.$Sk=M;var I;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class x{constructor(Q,ie,fe){this.resource=Q,this.operation=ie,this.target=fe}isOperation(Q){return this.operation===Q}}e.$Tk=x;var X;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(X||(e.FileChangeType=X={}));class de{static{this.a=null}constructor(Q,ie){this.c=ie,this.b=void 0,this.d=new O.$V(()=>{const fe=A.$ki.forUris(()=>this.c);return fe.fill(this.rawAdded.map(ye=>[ye,!0])),fe}),this.f=new O.$V(()=>{const fe=A.$ki.forUris(()=>this.c);return fe.fill(this.rawUpdated.map(ye=>[ye,!0])),fe}),this.g=new O.$V(()=>{const fe=A.$ki.forUris(()=>this.c);return fe.fill(this.rawDeleted.map(ye=>[ye,!0])),fe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const fe of Q){switch(fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}this.b!==de.a&&(typeof fe.cId=="number"?this.b===void 0?this.b=fe.cId:this.b!==fe.cId&&(this.b=de.a):this.b!==void 0&&(this.b=de.a))}}contains(Q,...ie){return this.h(Q,{includeChildren:!1},...ie)}affects(Q,...ie){return this.h(Q,{includeChildren:!0},...ie)}h(Q,ie,...fe){if(!Q)return!1;const ye=fe.length>0;return!!((!ye||fe.includes(1))&&(this.d.value.get(Q)||ie.includeChildren&&this.d.value.findSuperstr(Q))||(!ye||fe.includes(0))&&(this.f.value.get(Q)||ie.includeChildren&&this.f.value.findSuperstr(Q))||(!ye||fe.includes(2))&&(this.g.value.findSubstr(Q)||ie.includeChildren&&this.g.value.findSuperstr(Q)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Q){return this.b===Q}hasCorrelation(){return typeof this.b=="number"}}e.$Uk=de;function ue(Y,Q,ie){return!Y||!Q||Y===Q||Q.length>Y.length?!1:(Q.charAt(Q.length-1)!==N.sep&&(Q+=N.sep),ie?(0,n.$kf)(Y,Q):Y.indexOf(Q)===0)}e.$Vk=ue;class te extends Error{constructor(Q,ie,fe){super(Q),this.fileOperationResult=ie,this.options=fe}}e.$Wk=te;class ge extends te{constructor(Q,ie,fe,ye){super(Q,ie,ye),this.fileOperationResult=ie,this.size=fe}}e.$Xk=ge;class Le extends te{constructor(Q,ie,fe){super(Q,2,fe),this.stat=ie}}e.$Yk=Le;var Te;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Te||(e.FileOperationResult=Te={})),e.$Zk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$1k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$2k="files.associations",e.$3k="files.exclude",e.$4k="files.readonlyInclude",e.$5k="files.readonlyExclude",e.$6k="files.readonlyFromPermissions";var Be;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(Be||(e.FileKind=Be={})),e.$7k="";function le(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.$8k=le;async function J(Y,Q){if(!Q.hasProvider(D.URI.from({scheme:Y.scheme})))return new Promise(ie=>{const fe=Q.onDidChangeFileSystemProviderRegistrations(ye=>{ye.scheme===Y.scheme&&ye.added&&(fe.dispose(),ie())})})}e.$9k=J;class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(Q){return(0,W.$Wf)(Q)||(Q=0),Q<ae.KB?(0,S.localize)(1,null,Q.toFixed(0)):Q<ae.MB?(0,S.localize)(2,null,(Q/ae.KB).toFixed(2)):Q<ae.GB?(0,S.localize)(3,null,(Q/ae.MB).toFixed(2)):Q<ae.TB?(0,S.localize)(4,null,(Q/ae.GB).toFixed(2)):(0,S.localize)(5,null,(Q/ae.TB).toFixed(2))}}e.$0k=ae;function re(Y){const Q=typeof Y=="string"||Y?.scheme===p.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===p.Schemas.file?1024*ae.MB:Q?10*ae.MB:$.$o?50*ae.MB:1024*ae.MB}e.$$k=re}),define(me[140],$e([1,0,43]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=e.$qac=void 0,e.$qac=(0,A.$ei)("mainProcessService");class N{constructor(W,D){this.a=W,this.b=D}getChannel(W){return this.a.getChannel(W,this.b)}registerChannel(W,D){this.a.registerChannel(W,D)}}e.$rac=N}),define(me[141],$e([1,0,3,135]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=void 0;class n extends A.$Tc{constructor(D){super(),this.a=this.B(new N.$KV(`window:${D}`))}getChannel(D){return this.a.getChannel(D)}registerChannel(D,S){this.a.registerChannel(D,S)}}e.$sac=n});var Ei=this&&this.__param||function(se,e){return function(A,N){e(A,N,se)}};define(me[142],$e([1,0,69,140]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=void 0;let n=class{constructor(D,S){return this.windowId=D,A.ProxyChannel.toService(S.getChannel("nativeHost"),{context:D,properties:(()=>{const b=new Map;return b.set("windowId",D),b})()})}};e.$wac=n,e.$wac=n=xe([Ei(1,N.$qac)],n)}),define(me[70],$e([1,0,78,7]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=void 0;class n{constructor(){this.a=new Map}add(D,S){A.ok(N.$Sf(D)),A.ok(N.$Uf(S)),A.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$Tn=new n}),define(me[143],$e([1,0,4,70]),function(se,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=void 0,e.$Un={JSONContribution:"base.contributions.json"};function n(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class W{constructor(){this.b=new A.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,$){this.a[n(b)]=$,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const D=new W;N.$Tn.add(e.$Un.JSONContribution,D)}),define(me[144],$e([1,0,9,17,18,4,7,15,137,143,70]),function(se,e,A,N,n,W,D,S,b,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qw=e.$Pw=e.$Ow=e.$Nw=e.$Mw=e.$Lw=e.$Kw=e.$Jw=e.IconFontDefinition=e.IconContribution=e.$Iw=void 0,e.$Iw={IconContribution:"base.contributions.icons"};var O;(function(h){function m(a,y){let L=a.defaults;for(;n.ThemeIcon.isThemeIcon(L);){const R=t.getIcon(L.id);if(!R)return;L=R.defaults}return L}h.getDefinition=m})(O||(e.IconContribution=O={}));var l;(function(h){function m(y){return{weight:y.weight,style:y.style,src:y.src.map(L=>({format:L.format,location:L.location.toString()}))}}h.toJSONObject=m;function a(y){const L=R=>(0,D.$Sf)(R)?R:void 0;if(y&&Array.isArray(y.src)&&y.src.every(R=>(0,D.$Sf)(R.format)&&(0,D.$Sf)(R.location)))return{weight:L(y.weight),style:L(y.style),src:y.src.map(R=>({format:R.format,location:S.URI.parse(R.location)}))}}h.fromJSONObject=a})(l||(e.IconFontDefinition=l={}));class f{constructor(){this.a=new W.$5d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${n.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(m,a,y,L){const R=this.b[m];if(R){if(y&&!R.description){R.description=y,this.d.properties[m].markdownDescription=`${y} $(${m})`;const E=this.e.enum.indexOf(m);E!==-1&&(this.e.enumDescriptions[E]=y),this.a.fire()}return R}const z={id:m,description:y,defaults:a,deprecationMessage:L};this.b[m]=z;const H={$ref:"#/definitions/icons"};return L&&(H.deprecationMessage=L),y&&(H.markdownDescription=`${y}: $(${m})`),this.d.properties[m]=H,this.e.enum.push(m),this.e.enumDescriptions.push(y||""),this.a.fire(),{id:m}}deregisterIcon(m){delete this.b[m],delete this.d.properties[m];const a=this.e.enum.indexOf(m);a!==-1&&(this.e.enum.splice(a,1),this.e.enumDescriptions.splice(a,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(m=>this.b[m])}getIcon(m){return this.b[m]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(m,a){const y=this.f[m];return y||(this.f[m]=a,this.a.fire(),a)}deregisterIconFont(m){delete this.f[m]}getIconFont(m){return this.f[m]}toString(){const m=(R,z)=>R.id.localeCompare(z.id),a=R=>{for(;n.ThemeIcon.isThemeIcon(R.defaults);)R=this.b[R.defaults.id];return`codicon codicon-${R?R.id:""}`},y=[];y.push("| preview     | identifier                        | default codicon ID                | description"),y.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const L=Object.keys(this.b).map(R=>this.b[R]);for(const R of L.filter(z=>!!z.description).sort(m))y.push(`|<i class="${a(R)}"></i>|${R.id}|${n.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);y.push("| preview     | identifier                        "),y.push("| ----------- | --------------------------------- |");for(const R of L.filter(z=>!n.ThemeIcon.isThemeIcon(z.defaults)).sort(m))y.push(`|<i class="${a(R)}"></i>|${R.id}|`);return y.join(`
`)}}const t=new f;p.$Tn.add(e.$Iw.IconContribution,t);function s(h,m,a,y){return t.registerIcon(h,m,a,y)}e.$Jw=s;function c(){return t}e.$Kw=c;function g(){const h=(0,N.$ik)();for(const m in h){const a="\\"+h[m].toString(16);t.registerIcon(m,{fontCharacter:a})}}g(),e.$Lw="vscode://schemas/icons";const u=p.$Tn.as($.$Un.JSONContribution);u.registerSchema(e.$Lw,t.getIconSchema());const w=new A.$qh(()=>u.notifySchemaChanged(e.$Lw),200);t.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.$Mw=s("widget-close",N.$kk.close,(0,b.localize)(2,null)),e.$Nw=s("goto-previous-location",N.$kk.arrowUp,(0,b.localize)(3,null)),e.$Ow=s("goto-next-location",N.$kk.arrowDown,(0,b.localize)(4,null)),e.$Pw=n.ThemeIcon.modify(N.$kk.sync,"spin"),e.$Qw=n.ThemeIcon.modify(N.$kk.loading,"spin")}),define(me[145],$e([1,0,2,4,3,18,144]),function(se,e,A,N,n,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KGb=e.$JGb=void 0;function S($){const p=new n.$Sc,O=p.add(new N.$5d),l=(0,D.$Kw)();return p.add(l.onDidChange(()=>O.fire())),$&&p.add($.onDidProductIconThemeChange(()=>O.fire())),{dispose:()=>p.dispose(),onDidChange:O.event,getCSS(){const f=$?$.getProductIconTheme():new b,t={},s=g=>{const u=f.getIcon(g);if(!u)return;const w=u.font;return w?(t[w.id]=w.definition,`.codicon-${g.id}:before { content: '${u.fontCharacter}'; font-family: ${(0,A.$YR)(w.id)}; }`):`.codicon-${g.id}:before { content: '${u.fontCharacter}'; }`},c=[];for(const g of l.getIcons()){const u=s(g);u&&c.push(u)}for(const g in t){const u=t[g],w=u.weight?`font-weight: ${u.weight};`:"",h=u.style?`font-style: ${u.style};`:"",m=u.src.map(a=>`${(0,A.$XR)(a.location)} format('${a.format}')`).join(", ");c.push(`@font-face { src: ${m}; font-family: ${(0,A.$YR)(g)};${w}${h} font-display: block; }`)}return c.join(`
`)}}}e.$JGb=S;class b{getIcon(p){const O=(0,D.$Kw)();let l=p.defaults;for(;W.ThemeIcon.isThemeIcon(l);){const f=O.getIcon(l.id);if(!f)return;l=f.defaults}return l}}e.$KGb=b}),define(me[146],$e([1,0,5]),function(se,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=e.$0C=e.$9C=e.$8C=e.$7C=e.$6C=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$5C=e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=void 0,e.$ZC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function N(g){return typeof g.parentId=="number"}e.$1C=N;function n(g){return!!g.workspaceUri}e.$2C=n;function W(g){return!!g.folderUri}e.$3C=W;function D(g){return!!g.fileUri}e.$4C=D;function S(g){const u=l(g),w=g.getValue("window.menuBarVisibility");return w==="default"||u&&w==="compact"||A.$j&&A.$m?"classic":w}e.$5C=S;var b;(function(g){g.TITLE_BAR_STYLE="window.titleBarStyle",g.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(b||(e.TitleBarSetting=b={}));var $;(function(g){g.NATIVE="native",g.CUSTOM="custom"})($||(e.TitlebarStyle=$={}));var p;(function(g){g.AUTO="auto",g.WINDOWED="windowed",g.NEVER="never"})(p||(e.CustomTitleBarVisibility=p={}));function O(g,u){return!0}e.$6C=O;function l(g,u){return u||(u=f(g)),u==="native"}e.$7C=l;function f(g){if(A.$o)return"custom";const u=g.getValue("window");if(u){if(A.$j&&u.nativeTabs===!0||A.$j&&u.nativeFullScreen===!1)return"native";const m=u.titleBarStyle;if(m==="native"||m==="custom")return m}return A.$k?"native":"custom"}e.$8C=f;function t(g){return!(!A.$i||A.$o||l(g))}e.$9C=t;function s(g){const u=g.getValue("window");return!u||typeof u.nativeFullScreen!="boolean"||u.nativeTabs?!0:u.nativeFullScreen!==!1}e.$0C=s;function c(g=0){return Math.pow(1.2,g)}e.$$C=c}),define(me[147],$e([1,0,16,2,21,31,146]),function(se,e,A,N,n,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=e.$Bac=e.$Aac=e.$zac=e.$yac=e.ApplyZoomTarget=void 0;var S;(function(l){l[l.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",l[l.ALL_WINDOWS=2]="ALL_WINDOWS"})(S||(e.ApplyZoomTarget=S={})),e.$yac=8,e.$zac=-8;function b(l,f){l=Math.min(Math.max(l,e.$zac),e.$yac);const t=[];f===S.ACTIVE_WINDOW?t.push((0,N.$lR)()):f===S.ALL_WINDOWS?t.push(...Array.from((0,N.getWindows)()).map(({window:s})=>s)):t.push(f);for(const s of t)$(s)?.webFrame?.setZoomLevel(l),(0,A.$iQ)((0,D.$$C)(l),s),(0,A.$eQ)(l,s)}e.$Aac=b;function $(l){if(l===n.$_P)return{ipcRenderer:W.$O,webFrame:W.$Q};{const f=l;if(f?.vscode?.ipcRenderer&&f?.vscode?.webFrame)return f.vscode}}function p(l){b((0,A.$fQ)(typeof l=="number"?(0,N.$lR)():l)+1,l)}e.$Bac=p;function O(l){b((0,A.$fQ)(typeof l=="number"?(0,N.$lR)():l)-1,l)}e.$Cac=O}),define(me[148],$e([1,0,11,2,134,9,93,31,138,139,141,142,145,147,14,21,106,97]),function(se,e,A,N,n,W,D,S,b,$,p,O,l,f,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startup=void 0;const c=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,g=/\s--inspect-port=(?<port>\d+)/;class u{getHeight(F){return 22}getTemplateId(F){return z(F)?"process":L(F)?"machine":(0,b.$Vm)(F)?"error":R(F)?"header":""}}class w{hasChildren(F){return(0,b.$Vm)(F)?!1:z(F)?!!F.children?.length:!0}getChildren(F){return z(F)?F.children?F.children:[]:(0,b.$Vm)(F)?[]:R(F)?F.processRoots.length>1?F.processRoots:[F.processRoots[0].rootProcess]:L(F)?[F.rootProcess]:[F.processes]}}class h{constructor(){this.templateId="header"}renderTemplate(F){const M=(0,N.$HR)(F,(0,N.$)(".row")),I=(0,N.$HR)(M,(0,N.$)(".nameLabel")),x=(0,N.$HR)(M,(0,N.$)(".cpu")),X=(0,N.$HR)(M,(0,N.$)(".memory")),de=(0,N.$HR)(M,(0,N.$)(".pid"));return{name:I,CPU:x,memory:X,PID:de}}renderElement(F,M,I,x){I.name.textContent=(0,A.localize)(0,null),I.CPU.textContent=(0,A.localize)(1,null),I.PID.textContent=(0,A.localize)(2,null),I.memory.textContent=(0,A.localize)(3,null)}disposeTemplate(F){}}class m{constructor(){this.templateId="machine"}renderTemplate(F){const M=Object.create(null),I=(0,N.$HR)(F,(0,N.$)(".row"));return M.name=(0,N.$HR)(I,(0,N.$)(".nameLabel")),M}renderElement(F,M,I,x){I.name.textContent=F.element.name}disposeTemplate(F){}}class a{constructor(){this.templateId="error"}renderTemplate(F){const M=Object.create(null),I=(0,N.$HR)(F,(0,N.$)(".row"));return M.name=(0,N.$HR)(I,(0,N.$)(".nameLabel")),M}renderElement(F,M,I,x){I.name.textContent=F.element.errorMessage}disposeTemplate(F){}}class y{constructor(F,M,I){this.a=F,this.b=M,this.c=I,this.templateId="process"}renderTemplate(F){const M=(0,N.$HR)(F,(0,N.$)(".row")),I=(0,N.$HR)(M,(0,N.$)(".nameLabel")),x=(0,N.$HR)(M,(0,N.$)(".cpu")),X=(0,N.$HR)(M,(0,N.$)(".memory")),de=(0,N.$HR)(M,(0,N.$)(".pid"));return{name:I,CPU:x,PID:de,memory:X}}renderElement(F,M,I,x){const{element:X}=F,de=X.pid.toFixed(0);let ue=X.name;this.c.has(X.pid)&&(ue=this.c.get(X.pid)),I.name.textContent=ue,I.name.title=X.cmd,I.CPU.textContent=X.load.toFixed(0),I.PID.textContent=de,I.PID.parentElement.id=`pid-${de}`;const te=this.a==="win32"?X.mem:this.b*(X.mem/100);I.memory.textContent=(te/$.$0k.MB).toFixed(0)}disposeTemplate(F){}}function L(j){return!!j.name&&!!j.rootProcess}function R(j){return!!j.processRoots}function z(j){return!!j.pid}class H{constructor(F,M){this.f=M,this.b=new Map;const I=new p.$sac(F);this.c=new O.$wac(F,I),this.k(M.styles),this.g(M),S.$O.on("vscode:pidToNameResponse",(x,X)=>{this.b.clear();for(const[de,ue]of X)this.b.set(de,ue)}),S.$O.on("vscode:listProcessesResponse",async(x,X)=>{X.forEach((de,ue)=>{z(de.rootProcess)&&(de.rootProcess.name=ue===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:X}}),this.d.layout(s.$_P.innerHeight,s.$_P.innerWidth)):await this.h(X),this.m(0)}),this.a=Date.now(),S.$O.send("vscode:pidToNameRequest"),S.$O.send("vscode:listProcesses")}g(F){s.$_P.document.onkeydown=M=>{const I=F.platform==="darwin"?M.metaKey:M.ctrlKey;I&&M.keyCode===87&&(M.stopPropagation(),M.preventDefault(),S.$O.send("vscode:closeProcessExplorer")),I&&M.keyCode===187&&(0,f.$Bac)(s.$_P),I&&M.keyCode===189&&(0,f.$Cac)(s.$_P)}}async h(F){const M=s.$_P.document.getElementById("process-list");if(!M)return;const{totalmem:I}=await this.c.getOSStatistics(),x=[new y(this.f.platform,I,this.b),new h,new m,new a];this.d=new n.$aV("processExplorer",M,new u,x,new w,{identityProvider:{getId:X=>z(X)?X.pid.toString():(0,b.$Vm)(X)?X.hostName:R(X)?"processes":L(X)?X.name:"header"}}),this.d.setInput({processes:{processRoots:F}}),this.d.layout(s.$_P.innerHeight,s.$_P.innerWidth),this.d.onKeyDown(X=>{const de=new t.$DQ(X);if(de.keyCode===35&&de.altKey){const ue=this.n();Promise.all(ue.map(te=>this.c.killProcess(te,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(X=>{z(X.element)&&this.l(X.element,!0)}),M.style.height=`${s.$_P.innerHeight}px`,s.$_P.addEventListener("resize",()=>{M.style.height=`${s.$_P.innerHeight}px`,this.d?.layout(s.$_P.innerHeight,s.$_P.innerWidth)})}i(F){const M=c.exec(F);return M&&M.groups.port!=="0"||F.indexOf("node ")>=0||F.indexOf("node.exe")>=0}j(F){const M={type:"node",request:"attach",name:`process ${F.pid}`};let I=c.exec(F.cmd);I?M.port=Number(I.groups.port):M.processId=String(F.pid),I=g.exec(F.cmd),I&&(M.port=Number(I.groups.port)),S.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[M]})}k(F){const M=(0,N.$pR)(),I=[];F.listFocusBackground&&(I.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${F.listFocusBackground}; }`),I.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${F.listFocusBackground}; }`)),F.listFocusForeground&&I.push(`.monaco-list:focus .monaco-list-row.focused { color: ${F.listFocusForeground}; }`),F.listActiveSelectionBackground&&(I.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${F.listActiveSelectionBackground}; }`),I.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${F.listActiveSelectionBackground}; }`)),F.listActiveSelectionForeground&&I.push(`.monaco-list:focus .monaco-list-row.selected { color: ${F.listActiveSelectionForeground}; }`),F.listHoverBackground&&I.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${F.listHoverBackground}; }`),F.listHoverForeground&&I.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${F.listHoverForeground}; }`),F.listFocusOutline&&I.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${F.listFocusOutline}; outline-offset: -1px; }`),F.listHoverOutline&&I.push(`.monaco-list-row:hover { outline: 1px dashed ${F.listHoverOutline}; outline-offset: -1px; }`),F.scrollbarShadowColor&&I.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${F.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${F.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${F.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),F.scrollbarSliderBackgroundColor&&I.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${F.scrollbarSliderBackgroundColor};
				}
			`),F.scrollbarSliderHoverBackgroundColor&&I.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${F.scrollbarSliderHoverBackgroundColor};
				}
			`),F.scrollbarSliderActiveBackgroundColor&&I.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${F.scrollbarSliderActiveBackgroundColor};
				}
			`),M.textContent=I.join(`
`),F.color&&(s.$_P.document.body.style.color=F.color)}l(F,M){const I=[],x=Number(F.pid);M&&(I.push({accelerator:"Alt+E",label:(0,A.localize)(4,null),click:()=>{this.c.killProcess(x,"SIGTERM")}}),I.push({label:(0,A.localize)(5,null),click:()=>{this.c.killProcess(x,"SIGKILL")}}),I.push({type:"separator"})),I.push({label:(0,A.localize)(6,null),click:()=>{const X=this.n();X?.includes(x)||(X.length=0,X.push(x));const de=X?.map(ue=>s.$_P.document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(de){const ue=de.map(te=>te.innerText).filter(te=>!!te);this.c.writeClipboardText(ue.join(`
`))}}}),I.push({label:(0,A.localize)(7,null),click:()=>{const X=s.$_P.document.getElementById("process-list");X&&this.c.writeClipboardText(X.innerText)}}),F&&M&&this.i(F.cmd)&&(I.push({type:"separator"}),I.push({label:(0,A.localize)(8,null),click:()=>{this.j(F)}})),(0,D.$CV)(I)}m(F){setTimeout(()=>{const M=Date.now(),I=F+M-this.a;this.a=M,I>1e3?(S.$O.send("vscode:pidToNameRequest"),S.$O.send("vscode:listProcesses")):this.m(I)},200)}n(){return this.d?.getSelection()?.map(F=>{if(!(!F||!("pid"in F)))return F.pid}).filter(F=>!!F)}}function E(){const j=(0,N.$pR)();j.id="codiconStyles";const F=(0,l.$JGb)(void 0);function M(){j.textContent=F.getCSS()}const I=new W.$qh(M,0);F.onDidChange(()=>I.schedule()),I.schedule()}function B(j){const F=j.data.platform==="win32"?"windows":j.data.platform==="linux"?"linux":"mac";s.$_P.document.body.classList.add(F),E(),(0,f.$Aac)(j.data.zoomLevel,s.$_P),new H(j.windowId,j.data)}e.startup=B})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/00124e9e5830e3efc897db71c781899f8a676295/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
