/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/platform/log/common/log","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/base/common/errors","vs/nls","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(J){for(var e=[],L=0,D=J.length;L<D;L++)e[L]=ie[J[L]];return e};define(ie[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const O=new Map,N=new Map,A=new Map,S=new Map;function h(m,w){m.has(w.detail)||m.set(w.detail,-w.timestamp)}function a(m,w){const k=m.get(w.detail);k&&(k>=0||m.set(w.detail,k+w.timestamp))}let y=[];typeof J=="function"&&typeof J.getStats=="function"&&(y=J.getStats().slice(0).sort((m,w)=>m.timestamp-w.timestamp));for(const m of y)switch(m.type){case 10:h(O,m);break;case 11:case 12:a(O,m);break;case 21:h(N,m);break;case 22:a(N,m);break;case 33:h(A,m);break;case 34:a(A,m);break;case 31:h(S,m);break;case 32:a(S,m);break}let E=0;A.forEach(m=>E+=m);function d(m){const w=[];return m.forEach((k,b)=>w.push([b,k])),w}return{amdLoad:d(O),amdInvoke:d(N),nodeRequire:d(A),nodeEval:d(S),nodeRequireTotal:E}}static toMarkdownTable(O,N){let A="";const S=[];return O.forEach((h,a)=>{S[a]=h.length}),N.forEach(h=>{h.forEach((a,y)=>{typeof a>"u"&&(a=h[y]="-");const E=a.toString().length;S[y]=Math.max(E,S[y])})}),O.forEach((h,a)=>{A+=`| ${h+" ".repeat(S[a]-h.toString().length)} `}),A+=`|
`,O.forEach((h,a)=>{A+=`| ${"-".repeat(S[a])} `}),A+=`|
`,N.forEach(h=>{h.forEach((a,y)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(S[y]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=L}),define(ie[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Jh=e.$Ih=void 0;function L(A){return(S,h,a)=>{let y=null,E=null;if(typeof a.value=="function"?(y="value",E=a.value):typeof a.get=="function"&&(y="get",E=a.get),!E)throw new Error("not supported");a[y]=A(E,h)}}function D(A,S,h){let a=null,y=null;if(typeof h.value=="function"?(a="value",y=h.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(a="get",y=h.get),!y)throw new Error("not supported");const E=`$memoize$${S}`;h[a]=function(...d){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,d)}),this[E]}}e.$Ih=D;function O(A,S,h){return L((a,y)=>{const E=`$debounce$${y}`,d=`$debounce$result$${y}`;return function(...m){this[d]||(this[d]=h?h():void 0),clearTimeout(this[E]),S&&(this[d]=S(this[d],...m),m=[this[d]]),this[E]=setTimeout(()=>{a.apply(this,m),this[d]=h?h():void 0},A)}})}e.$Jh=O;function N(A,S,h){return L((a,y)=>{const E=`$throttle$timer$${y}`,d=`$throttle$result$${y}`,m=`$throttle$lastRun$${y}`,w=`$throttle$pending$${y}`;return function(...k){if(this[d]||(this[d]=h?h():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),S&&(this[d]=S(this[d],...k)),this[w])return;const b=this[m]+A;b<=Date.now()?(this[m]=Date.now(),a.apply(this,[this[d]]),this[d]=h?h():void 0):(this[w]=!0,this[E]=setTimeout(()=>{this[w]=!1,this[m]=Date.now(),a.apply(this,[this[d]]),this[d]=h?h():void 0},b-Date.now()))}})}e.$Kh=N}),define(ie[71],ne([0,1,7]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function D(a,y){if(!a)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=D;function O(a,y="Unreachable"){throw new Error(y)}e.$9c=O;function N(a){if(!a)throw new L.$cb("Assertion Failed")}e.$0c=N;function A(a){a||(0,L.$1)(new L.$cb("Assertion Failed"))}e.$$c=A;function S(a){if(!a()){debugger;a(),(0,L.$1)(new L.$cb("Assertion Failed"))}}e.$_c=S;function h(a,y){let E=0;for(;E<a.length-1;){const d=a[E],m=a[E+1];if(!y(d,m))return!1;E++}return!0}e.$ad=h}),define(ie[38],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var O;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(O||(e.ParseErrorCode=O={}));var N;(function(i){i.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(i,r=!1){let t=0;const n=i.length;let s="",o=0,l=16,R=0;function I(re){let he=0,de=0;for(;he<re;){const ae=i.charCodeAt(t);if(ae>=48&&ae<=57)de=de*16+ae-48;else if(ae>=65&&ae<=70)de=de*16+ae-65+10;else if(ae>=97&&ae<=102)de=de*16+ae-97+10;else break;t++,he++}return he<re&&(de=-1),de}function v(re){t=re,s="",o=0,l=16,R=0}function j(){const re=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return R=3,i.substring(re,t);let he=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;he=t}else R=3;return i.substring(re,he)}function q(){let re="",he=t;for(;;){if(t>=n){re+=i.substring(he,t),R=2;break}const de=i.charCodeAt(t);if(de===34){re+=i.substring(he,t),t++;break}if(de===92){if(re+=i.substring(he,t),t++,t>=n){R=2;break}switch(i.charCodeAt(t++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const B=I(4);B>=0?re+=String.fromCharCode(B):R=4;break}default:R=5}he=t;continue}if(de>=0&&de<=31)if(h(de)){re+=i.substring(he,t),R=2;break}else R=6;t++}return re}function Q(){if(s="",R=0,o=t,t>=n)return o=n,l=17;let re=i.charCodeAt(t);if(S(re)){do t++,s+=String.fromCharCode(re),re=i.charCodeAt(t);while(S(re));return l=15}if(h(re))return t++,s+=String.fromCharCode(re),re===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(re){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=q(),l=10;case 47:{const he=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!h(i.charCodeAt(t));)t++;return s=i.substring(he,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const de=n-1;let ae=!1;for(;t<de;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,R=1),s=i.substring(he,t),l=13}return s+=String.fromCharCode(re),t++,l=16}case 45:if(s+=String.fromCharCode(re),t++,t===n||!a(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),l=11;default:for(;t<n&&Z(re);)t++,re=i.charCodeAt(t);if(o!==t){switch(s=i.substring(o,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(re),t++,l=16}}function Z(re){if(S(re)||h(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let re;do re=Q();while(re>=12&&re<=15);return re}return{setPosition:v,getPosition:()=>t,scan:r?oe:Q,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>R}}e.$mn=A;function S(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function h(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var y;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(y||(y={}));function E(i,r){const t=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function R(I,v,j,q){o.value=I,o.offset=v,o.length=j,o.type=q,o.colonOffset=void 0,s=o}try{$(i,{onObjectBegin:(I,v)=>{if(r<=I)throw n;s=void 0,l=r>I,t.push("")},onObjectProperty:(I,v,j)=>{if(r<v||(R(I,v,j,"property"),t[t.length-1]=I,r<=v+j))throw n},onObjectEnd:(I,v)=>{if(r<=I)throw n;s=void 0,t.pop()},onArrayBegin:(I,v)=>{if(r<=I)throw n;s=void 0,t.push(0)},onArrayEnd:(I,v)=>{if(r<=I)throw n;s=void 0,t.pop()},onLiteralValue:(I,v,j)=>{if(r<v||(R(I,v,j,g(I)),r<=v+j))throw n},onSeparator:(I,v,j)=>{if(r<=v)throw n;if(I===":"&&s&&s.type==="property")s.colonOffset=v,l=!1,s=void 0;else if(I===","){const q=t[t.length-1];typeof q=="number"?t[t.length-1]=q+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(I){if(I!==n)throw I}return{path:t,previousNode:s,isAtPropertyKey:l,matches:I=>{let v=0;for(let j=0;v<I.length&&j<t.length;j++)if(I[v]===t[j]||I[v]==="*")v++;else if(I[v]!=="**")return!1;return v===I.length}}}e.$nn=E;function d(i,r=[],t=N.DEFAULT){let n=null,s=[];const o=[];function l(I){Array.isArray(s)?s.push(I):n!==null&&(s[n]=I)}return $(i,{onObjectBegin:()=>{const I={};l(I),o.push(s),s=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const I=[];l(I),o.push(s),s=I,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(I,v,j)=>{r.push({error:I,offset:v,length:j})}},t),s[0]}e.$on=d;function m(i,r=[],t=N.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function o(I){return n.children.push(I),I}$(i,{onObjectBegin:I=>{n=o({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,v,j)=>{n=o({type:"property",offset:v,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:v,length:j,parent:n})},onObjectEnd:(I,v)=>{n.length=I+v-n.offset,n=n.parent,s(I+v)},onArrayBegin:(I,v)=>{n=o({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,v)=>{n.length=I+v-n.offset,n=n.parent,s(I+v)},onLiteralValue:(I,v,j)=>{o({type:g(I),offset:v,length:j,parent:n,value:I}),s(v+j)},onSeparator:(I,v,j)=>{n.type==="property"&&(I===":"?n.colonOffset=v:I===","&&s(v))},onError:(I,v,j)=>{r.push({error:I,offset:v,length:j})}},t);const R=n.children[0];return R&&delete R.parent,R}e.$pn=m;function w(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.$qn=w;function k(i){if(!i.parent||!i.parent.children)return[];const r=k(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}e.$rn=k;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=b(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$sn=b;function c(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}e.$tn=c;function p(i,r,t=!1){if(c(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const o=p(n[s],r,t);if(o)return o}return i}}e.$un=p;function $(i,r,t=N.DEFAULT){const n=A(i,!1);function s(Y){return Y?()=>Y(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Y){return Y?_=>Y(_,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),R=o(r.onObjectProperty),I=s(r.onObjectEnd),v=s(r.onArrayBegin),j=s(r.onArrayEnd),q=o(r.onLiteralValue),Q=o(r.onSeparator),Z=s(r.onComment),oe=o(r.onError),re=t&&t.disallowComments,he=t&&t.allowTrailingComma;function de(){for(;;){const Y=n.scan();switch(n.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:re||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(Y){case 12:case 13:re?ae(10):Z();break;case 16:ae(1);break;case 15:case 14:break;default:return Y}}}function ae(Y,_=[],U=[]){if(oe(Y),_.length+U.length>0){let F=n.getToken();for(;F!==17;){if(_.indexOf(F)!==-1){de();break}else if(U.indexOf(F)!==-1)break;F=de()}}}function B(Y){const _=n.getTokenValue();return Y?q(_):R(_),de(),!0}function X(){switch(n.getToken()){case 11:{let Y=0;try{Y=JSON.parse(n.getTokenValue()),typeof Y!="number"&&(ae(2),Y=0)}catch{ae(2)}q(Y);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return de(),!0}function T(){return n.getToken()!==10?(ae(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(Q(":"),de(),K()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function C(){l(),de();let Y=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ae(4,[],[]),Q(","),de(),n.getToken()===2&&he)break}else Y&&ae(6,[],[]);T()||ae(4,[],[2,5]),Y=!0}return I(),n.getToken()!==2?ae(7,[2],[]):de(),!0}function H(){v(),de();let Y=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ae(4,[],[]),Q(","),de(),n.getToken()===4&&he)break}else Y&&ae(6,[],[]);K()||ae(4,[],[4,5]),Y=!0}return j(),n.getToken()!==4?ae(8,[4],[]):de(),!0}function K(){switch(n.getToken()){case 3:return H();case 1:return C();case 10:return B(!0);default:return X()}}return de(),n.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):K()?(n.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$vn=$;function u(i,r){const t=A(i),n=[];let s,o=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==l&&n.push(i.substring(o,l)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return n.join("")}e.$wn=u;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$xn=g}),define(ie[72],ne([0,1,38]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=void 0;function D(a,y,E){let d,m,w,k,b;if(y){for(k=y.offset,b=k+y.length,w=k;w>0&&!h(a,w-1);)w--;let l=b;for(;l<a.length&&!h(a,l);)l++;m=a.substring(w,l),d=A(m,E)}else m=a,d=0,w=0,k=0,b=a.length;const c=S(E,a);let p=!1,$=0,u;E.insertSpaces?u=N(" ",E.tabSize||4):u="	";const g=(0,L.$mn)(m,!1);let i=!1;function r(){return c+N(u,d+$)}function t(){let l=g.scan();for(p=!1;l===15||l===14;)p=p||l===14,l=g.scan();return i=l===16||g.getTokenError()!==0,l}const n=[];function s(l,R,I){!i&&R<b&&I>k&&a.substring(R,I)!==l&&n.push({offset:R,length:I-R,content:l})}let o=t();if(o!==17){const l=g.getTokenOffset()+w,R=N(u,d);s(R,w,l)}for(;o!==17;){let l=g.getTokenOffset()+g.getTokenLength()+w,R=t(),I="";for(;!p&&(R===12||R===13);){const j=g.getTokenOffset()+w;s(" ",l,j),l=g.getTokenOffset()+g.getTokenLength()+w,I=R===12?r():"",R=t()}if(R===2)o!==1&&($--,I=r());else if(R===4)o!==3&&($--,I=r());else{switch(o){case 3:case 1:$++,I=r();break;case 5:case 12:I=r();break;case 13:p?I=r():I=" ";break;case 6:I=" ";break;case 10:if(R===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:R===12||R===13?I=" ":R!==5&&R!==17&&(i=!0);break;case 16:i=!0;break}p&&(R===12||R===13)&&(I=r())}const v=g.getTokenOffset()+w;s(I,l,v),o=R}return n}e.$yn=D;function O(a,y){const E=JSON.stringify(a,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?E.replace(/\r\n|\r|\n/g,y.eol):E}e.$zn=O;function N(a,y){let E="";for(let d=0;d<y;d++)E+=a;return E}function A(a,y){let E=0,d=0;const m=y.tabSize||4;for(;E<a.length;){const w=a.charAt(E);if(w===" ")d++;else if(w==="	")d+=m;else break;E++}return Math.floor(d/m)}function S(a,y){for(let E=0;E<y.length;E++){const d=y.charAt(E);if(d==="\r")return E+1<y.length&&y.charAt(E+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}e.$An=S;function h(a,y){return`\r
`.indexOf(a.charAt(y))!==-1}e.$Bn=h}),define(ie[73],ne([0,1,38,72]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=void 0;function O(a,y,E){return N(a,y,void 0,E)}e.$Cn=O;function N(a,y,E,d,m){const w=y.slice(),k=[],b=(0,L.$pn)(a,k);let c,p;for(;w.length>0&&(p=w.pop(),c=(0,L.$qn)(b,w),c===void 0&&E!==void 0);)typeof p=="string"?E={[p]:E}:E=[E];if(c)if(c.type==="object"&&typeof p=="string"&&Array.isArray(c.children)){const $=(0,L.$qn)(c,[p]);if($!==void 0)if(E===void 0){if(!$.parent)throw new Error("Malformed AST");const u=c.children.indexOf($.parent);let g,i=$.parent.offset+$.parent.length;if(u>0){const r=c.children[u-1];g=r.offset+r.length}else g=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return A(a,{offset:g,length:i-g,content:""},d)}else return A(a,{offset:$.offset,length:$.length,content:JSON.stringify(E)},d);else{if(E===void 0)return[];const u=`${JSON.stringify(p)}: ${JSON.stringify(E)}`,g=m?m(c.children.map(r=>r.children[0].value)):c.children.length;let i;if(g>0){const r=c.children[g-1];i={offset:r.offset+r.length,length:0,content:","+u}}else c.children.length===0?i={offset:c.offset+1,length:0,content:u}:i={offset:c.offset+1,length:0,content:u+","};return A(a,i,d)}}else if(c.type==="array"&&typeof p=="number"&&Array.isArray(c.children))if(E!==void 0){const $=`${JSON.stringify(E)}`;let u;if(c.children.length===0||p===0)u={offset:c.offset+1,length:0,content:c.children.length===0?$:$+","};else{const g=p===-1||p>c.children.length?c.children.length:p,i=c.children[g-1];u={offset:i.offset+i.length,length:0,content:","+$}}return A(a,u,d)}else{const $=p,u=c.children[$];let g;if(c.children.length===1)g={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===$){const i=c.children[$-1],r=i.offset+i.length,t=c.offset+c.length;g={offset:r,length:t-2-r,content:""}}else g={offset:u.offset,length:c.children[$+1].offset-u.offset,content:""};return A(a,g,d)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${c.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(a,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(E)},d)}}e.$Dn=N;function A(a,y,E){let d=S(a,y),m=y.offset,w=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;m>0&&!(0,D.$Bn)(d,m-1);)m--;for(;w<d.length&&!(0,D.$Bn)(d,w);)w++}const k=(0,D.$yn)(d,{offset:m,length:w-m},E);for(let c=k.length-1;c>=0;c--){const p=k[c];d=S(d,p),m=Math.min(m,p.offset),w=Math.max(w,p.offset+p.length),w+=p.content.length-p.length}const b=a.length-(d.length-w)-m;return[{offset:m,length:b,content:d.substring(m,w)}]}e.$En=A;function S(a,y){return a.substring(0,y.offset)+y.content+a.substring(y.offset+y.length)}e.$Fn=S;function h(a,y){const E=y.slice(0).sort((m,w)=>{const k=m.offset-w.offset;return k===0?m.length-w.length:k});let d=a.length;for(let m=E.length-1;m>=0;m--){const w=E[m];if(w.offset+w.length<=d)a=S(a,w);else throw new Error("Overlapping edit");d=w.offset}return a}e.$Gn=h}),define(ie[74],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.rot=e.$fm=void 0;function L(S,h,a){return Math.min(Math.max(S,h),a)}e.$fm=L;function D(S,h){return(h+S%h)%h}e.rot=D;class O{constructor(){this.a=0}getNext(){return this.a++}}e.$hm=O;class N{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$im=N;class A{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const a=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$jm=A}),function(){function J(O){const N=[];typeof O=="number"&&N.push("code/timeOrigin",O);function A(h){N.push(h,Date.now())}function S(){const h=[];for(let a=0;a<N.length;a+=2)h.push({name:N[a],startTime:N[a+1]});return h}return{mark:A,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(O+A.startTime)});return N}};if(typeof process=="object"){const O=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:J)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(D){if(e[D])return e[D].exports;var O=e[D]={i:D,l:!1,exports:{}};return J[D].call(O.exports,O,O.exports,L),O.l=!0,O.exports}return L.m=J,L.c=e,L.d=function(D,O,N){L.o(D,O)||Object.defineProperty(D,O,{enumerable:!0,get:N})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,O){if(1&O&&(D=L(D)),8&O||4&O&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(L.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&O&&typeof D!="string")for(var A in D)L.d(N,A,function(S){return D[S]}.bind(null,A));return N},L.n=function(D){var O=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(O,"a",O),O},L.o=function(D,O){return Object.prototype.hasOwnProperty.call(D,O)},L.p="",L(L.s=0)}([function(J,e,L){(function(D){var O;e=J.exports=U,O=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],h=e.src=[],a=0,y=a++;h[y]="0|[1-9]\\d*";var E=a++;h[E]="[0-9]+";var d=a++;h[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=a++;h[m]="("+h[y]+")\\.("+h[y]+")\\.("+h[y]+")";var w=a++;h[w]="("+h[E]+")\\.("+h[E]+")\\.("+h[E]+")";var k=a++;h[k]="(?:"+h[y]+"|"+h[d]+")";var b=a++;h[b]="(?:"+h[E]+"|"+h[d]+")";var c=a++;h[c]="(?:-("+h[k]+"(?:\\."+h[k]+")*))";var p=a++;h[p]="(?:-?("+h[b]+"(?:\\."+h[b]+")*))";var $=a++;h[$]="[0-9A-Za-z-]+";var u=a++;h[u]="(?:\\+("+h[$]+"(?:\\."+h[$]+")*))";var g=a++,i="v?"+h[m]+h[c]+"?"+h[u]+"?";h[g]="^"+i+"$";var r="[v=\\s]*"+h[w]+h[p]+"?"+h[u]+"?",t=a++;h[t]="^"+r+"$";var n=a++;h[n]="((?:<|>)?=?)";var s=a++;h[s]=h[E]+"|x|X|\\*";var o=a++;h[o]=h[y]+"|x|X|\\*";var l=a++;h[l]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[c]+")?"+h[u]+"?)?)?";var R=a++;h[R]="[v=\\s]*("+h[s]+")(?:\\.("+h[s]+")(?:\\.("+h[s]+")(?:"+h[p]+")?"+h[u]+"?)?)?";var I=a++;h[I]="^"+h[n]+"\\s*"+h[l]+"$";var v=a++;h[v]="^"+h[n]+"\\s*"+h[R]+"$";var j=a++;h[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=a++;h[q]="(?:~>?)";var Q=a++;h[Q]="(\\s*)"+h[q]+"\\s+",S[Q]=new RegExp(h[Q],"g");var Z=a++;h[Z]="^"+h[q]+h[l]+"$";var oe=a++;h[oe]="^"+h[q]+h[R]+"$";var re=a++;h[re]="(?:\\^)";var he=a++;h[he]="(\\s*)"+h[re]+"\\s+",S[he]=new RegExp(h[he],"g");var de=a++;h[de]="^"+h[re]+h[l]+"$";var ae=a++;h[ae]="^"+h[re]+h[R]+"$";var B=a++;h[B]="^"+h[n]+"\\s*("+r+")$|^$";var X=a++;h[X]="^"+h[n]+"\\s*("+i+")$|^$";var T=a++;h[T]="(\\s*)"+h[n]+"\\s*("+r+"|"+h[l]+")",S[T]=new RegExp(h[T],"g");var C=a++;h[C]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var H=a++;h[H]="^\\s*("+h[R]+")\\s+-\\s+("+h[R]+")\\s*$";var K=a++;h[K]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)O(Y,h[Y]),S[Y]||(S[Y]=new RegExp(h[Y]));function _(V,x){if(V instanceof U)return V;if(typeof V!="string"||V.length>N||!(x?S[t]:S[g]).test(V))return null;try{return new U(V,x)}catch{return null}}function U(V,x){if(V instanceof U){if(V.loose===x)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof U))return new U(V,x);O("SemVer",V,x),this.loose=x;var ee=V.trim().match(x?S[t]:S[g]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ye=+ge;if(ye>=0&&ye<A)return ye}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(V,x){var ee=_(V,x);return ee?ee.version:null},e.clean=function(V,x){var ee=_(V.trim().replace(/^[=v]+/,""),x);return ee?ee.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(V){return O("SemVer.compare",this.version,this.loose,V),V instanceof U||(V=new U(V,this.loose)),this.compareMain(V)||this.comparePre(V)},U.prototype.compareMain=function(V){return V instanceof U||(V=new U(V,this.loose)),f(this.major,V.major)||f(this.minor,V.minor)||f(this.patch,V.patch)},U.prototype.comparePre=function(V){if(V instanceof U||(V=new U(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var x=0;do{var ee=this.prerelease[x],ge=V.prerelease[x];if(O("prerelease compare",x,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return f(ee,ge)}while(++x)},U.prototype.inc=function(V,x){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,x,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new U(V,ee).inc(x,ge).version}catch{return null}},e.diff=function(V,x){if(W(V,x))return null;var ee=_(V),ge=_(x);if(ee.prerelease.length||ge.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==ge[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==ge[ye])return ye},e.compareIdentifiers=f;var F=/^[0-9]+$/;function f(V,x){var ee=F.test(V),ge=F.test(x);return ee&&ge&&(V=+V,x=+x),ee&&!ge?-1:ge&&!ee?1:V<x?-1:V>x?1:0}function P(V,x,ee){return new U(V,ee).compare(new U(x,ee))}function z(V,x,ee){return P(V,x,ee)>0}function M(V,x,ee){return P(V,x,ee)<0}function W(V,x,ee){return P(V,x,ee)===0}function G(V,x,ee){return P(V,x,ee)!==0}function te(V,x,ee){return P(V,x,ee)>=0}function le(V,x,ee){return P(V,x,ee)<=0}function ue(V,x,ee,ge){var ye;switch(x){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=W(V,ee,ge);break;case"!=":ye=G(V,ee,ge);break;case">":ye=z(V,ee,ge);break;case">=":ye=te(V,ee,ge);break;case"<":ye=M(V,ee,ge);break;case"<=":ye=le(V,ee,ge);break;default:throw new TypeError("Invalid operator: "+x)}return ye}function $e(V,x){if(V instanceof $e){if(V.loose===x)return V;V=V.value}if(!(this instanceof $e))return new $e(V,x);O("comparator",V,x),this.loose=x,this.parse(V),this.semver===we?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(V,x){return f(x,V)},e.major=function(V,x){return new U(V,x).major},e.minor=function(V,x){return new U(V,x).minor},e.patch=function(V,x){return new U(V,x).patch},e.compare=P,e.compareLoose=function(V,x){return P(V,x,!0)},e.rcompare=function(V,x,ee){return P(x,V,ee)},e.sort=function(V,x){return V.sort(function(ee,ge){return e.compare(ee,ge,x)})},e.rsort=function(V,x){return V.sort(function(ee,ge){return e.rcompare(ee,ge,x)})},e.gt=z,e.lt=M,e.eq=W,e.neq=G,e.gte=te,e.lte=le,e.cmp=ue,e.Comparator=$e;var we={};function fe(V,x){if(V instanceof fe)return V.loose===x?V:new fe(V.raw,x);if(V instanceof $e)return new fe(V.value,x);if(!(this instanceof fe))return new fe(V,x);if(this.loose=x,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function ce(V){return!V||V.toLowerCase()==="x"||V==="*"}function pe(V,x,ee,ge,ye,De,Pe,ze,Ie,Le,Me,Re,Ae){return((x=ce(ee)?"":ce(ge)?">="+ee+".0.0":ce(ye)?">="+ee+"."+ge+".0":">="+x)+" "+(ze=ce(Ie)?"":ce(Le)?"<"+(+Ie+1)+".0.0":ce(Me)?"<"+Ie+"."+(+Le+1)+".0":Re?"<="+Ie+"."+Le+"."+Me+"-"+Re:"<="+ze)).trim()}function be(V,x){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(x))return!1;if(x.prerelease.length){for(ee=0;ee<V.length;ee++)if(O(V[ee].semver),V[ee].semver!==we&&V[ee].semver.prerelease.length>0){var ge=V[ee].semver;if(ge.major===x.major&&ge.minor===x.minor&&ge.patch===x.patch)return!0}return!1}return!0}function Se(V,x,ee){try{x=new fe(x,ee)}catch{return!1}return x.test(V)}function je(V,x,ee,ge){var ye,De,Pe,ze,Ie;switch(V=new U(V,ge),x=new fe(x,ge),ee){case">":ye=z,De=le,Pe=M,ze=">",Ie=">=";break;case"<":ye=M,De=te,Pe=z,ze="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(V,x,ge))return!1;for(var Le=0;Le<x.set.length;++Le){var Me=x.set[Le],Re=null,Ae=null;if(Me.forEach(function(Fe){Fe.semver===we&&(Fe=new $e(">=0.0.0")),Re=Re||Fe,Ae=Ae||Fe,ye(Fe.semver,Re.semver,ge)?Re=Fe:Pe(Fe.semver,Ae.semver,ge)&&(Ae=Fe)}),Re.operator===ze||Re.operator===Ie||(!Ae.operator||Ae.operator===ze)&&De(V,Ae.semver)||Ae.operator===Ie&&Pe(V,Ae.semver))return!1}return!0}$e.prototype.parse=function(V){var x=this.loose?S[B]:S[X],ee=V.match(x);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new U(ee[2],this.loose):this.semver=we},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(V){return O("Comparator.test",V,this.loose),this.semver===we||(typeof V=="string"&&(V=new U(V,this.loose)),ue(V,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(V,x){if(!(V instanceof $e))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,x),Se(this.value,ee,x);if(V.operator==="")return ee=new fe(this.value,x),Se(V.semver,ee,x);var ge=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),ze=ue(this.semver,"<",V.semver,x)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=ue(this.semver,">",V.semver,x)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return ge||ye||De&&Pe||ze||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var x=this.loose;V=V.trim(),O("range",V,x);var ee=x?S[H]:S[C];V=V.replace(ee,pe),O("hyphen replace",V),V=V.replace(S[T],"$1$2$3"),O("comparator trim",V,S[T]),V=(V=(V=V.replace(S[Q],"$1~")).replace(S[he],"$1^")).split(/\s+/).join(" ");var ge=x?S[B]:S[X],ye=V.split(" ").map(function(De){return function(Pe,ze){return O("comp",Pe),Pe=function(Ie,Le){return Ie.trim().split(/\s+/).map(function(Me){return function(Re,Ae){O("caret",Re,Ae);var Fe=Ae?S[ae]:S[de];return Re.replace(Fe,function(Ne,ve,Ee,ke,Oe){var Ue;return O("caret",Re,Ne,ve,Ee,ke,Oe),ce(ve)?Ue="":ce(Ee)?Ue=">="+ve+".0.0 <"+(+ve+1)+".0.0":ce(ke)?Ue=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Oe?(O("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+ke+Oe+" <"+ve+"."+Ee+"."+(+ke+1):">="+ve+"."+Ee+"."+ke+Oe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+ke+Oe+" <"+(+ve+1)+".0.0"):(O("no pr"),Ue=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+ke+" <"+ve+"."+Ee+"."+(+ke+1):">="+ve+"."+Ee+"."+ke+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+ke+" <"+(+ve+1)+".0.0"),O("caret return",Ue),Ue})}(Me,Le)}).join(" ")}(Pe,ze),O("caret",Pe),Pe=function(Ie,Le){return Ie.trim().split(/\s+/).map(function(Me){return function(Re,Ae){var Fe=Ae?S[oe]:S[Z];return Re.replace(Fe,function(Ne,ve,Ee,ke,Oe){var Ue;return O("tilde",Re,Ne,ve,Ee,ke,Oe),ce(ve)?Ue="":ce(Ee)?Ue=">="+ve+".0.0 <"+(+ve+1)+".0.0":ce(ke)?Ue=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Oe?(O("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=">="+ve+"."+Ee+"."+ke+Oe+" <"+ve+"."+(+Ee+1)+".0"):Ue=">="+ve+"."+Ee+"."+ke+" <"+ve+"."+(+Ee+1)+".0",O("tilde return",Ue),Ue})}(Me,Le)}).join(" ")}(Pe,ze),O("tildes",Pe),Pe=function(Ie,Le){return O("replaceXRanges",Ie,Le),Ie.split(/\s+/).map(function(Me){return function(Re,Ae){Re=Re.trim();var Fe=Ae?S[v]:S[I];return Re.replace(Fe,function(Ne,ve,Ee,ke,Oe,Ue){O("xRange",Re,Ne,ve,Ee,ke,Oe,Ue);var qe=ce(Ee),Ce=qe||ce(ke),Te=Ce||ce(Oe);return ve==="="&&Te&&(ve=""),qe?Ne=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Ce&&(ke=0),Te&&(Oe=0),ve===">"?(ve=">=",Ce?(Ee=+Ee+1,ke=0,Oe=0):Te&&(ke=+ke+1,Oe=0)):ve==="<="&&(ve="<",Ce?Ee=+Ee+1:ke=+ke+1),Ne=ve+Ee+"."+ke+"."+Oe):Ce?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ne=">="+Ee+"."+ke+".0 <"+Ee+"."+(+ke+1)+".0"),O("xRange return",Ne),Ne})}(Me,Le)}).join(" ")}(Pe,ze),O("xrange",Pe),Pe=function(Ie,Le){return O("replaceStars",Ie,Le),Ie.trim().replace(S[K],"")}(Pe,ze),O("stars",Pe),Pe}(De,x)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match(ge)})),ye=ye.map(function(De){return new $e(De,x)})},fe.prototype.intersects=function(V,x){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return V.set.some(function(ye){return ye.every(function(De){return ge.intersects(De,x)})})})})},e.toComparators=function(V,x){return new fe(V,x).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new U(V,this.loose));for(var x=0;x<this.set.length;x++)if(be(this.set[x],V))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(V,x,ee){var ge=null,ye=null;try{var De=new fe(x,ee)}catch{return null}return V.forEach(function(Pe){De.test(Pe)&&(ge&&ye.compare(Pe)!==-1||(ye=new U(ge=Pe,ee)))}),ge},e.minSatisfying=function(V,x,ee){var ge=null,ye=null;try{var De=new fe(x,ee)}catch{return null}return V.forEach(function(Pe){De.test(Pe)&&(ge&&ye.compare(Pe)!==1||(ye=new U(ge=Pe,ee)))}),ge},e.validRange=function(V,x){try{return new fe(V,x).range||"*"}catch{return null}},e.ltr=function(V,x,ee){return je(V,x,"<",ee)},e.gtr=function(V,x,ee){return je(V,x,">",ee)},e.outside=je,e.prerelease=function(V,x){var ee=_(V,x);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,x,ee){return V=new fe(V,ee),x=new fe(x,ee),V.intersects(x)},e.coerce=function(V){if(V instanceof U)return V;if(typeof V!="string")return null;var x=V.match(S[j]);return x==null?null:_((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,L(1))},function(J,e){var L,D,O=J.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function S(b){if(L===setTimeout)return setTimeout(b,0);if((L===N||!L)&&setTimeout)return L=setTimeout,setTimeout(b,0);try{return L(b,0)}catch{try{return L.call(null,b,0)}catch{return L.call(this,b,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:N}catch{L=N}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var h,a=[],y=!1,E=-1;function d(){y&&h&&(y=!1,h.length?a=h.concat(a):E=-1,a.length&&m())}function m(){if(!y){var b=S(d);y=!0;for(var c=a.length;c;){for(h=a,a=[];++E<c;)h&&h[E].run();E=-1,c=a.length}h=null,y=!1,function(p){if(D===clearTimeout)return clearTimeout(p);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(p);try{D(p)}catch{try{return D.call(null,p)}catch{return D.call(this,p)}}}(b)}}function w(b,c){this.fun=b,this.array=c}function k(){}O.nextTick=function(b){var c=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)c[p-1]=arguments[p];a.push(new w(b,c)),a.length!==1||y||S(m)},w.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=k,O.addListener=k,O.once=k,O.off=k,O.removeListener=k,O.removeAllListeners=k,O.emit=k,O.prependListener=k,O.prependOnceListener=k,O.listeners=function(b){return[]},O.binding=function(b){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(b){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(ie[75],ne([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0;class D{constructor(S,h,a){this.level=S,this.key=h,this.value=a,this.forward=[]}}const O=void 0;class N{constructor(S,h=2**16){this.comparator=S,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new D(this.c,O,O)}get size(){return this.f}clear(){this.e=new D(this.c,O,O),this.f=0}has(S){return!!N.g(this,S,this.comparator)}get(S){return N.g(this,S,this.comparator)?.value}set(S,h){return N.h(this,S,h,this.comparator)&&(this.f+=1),this}delete(S){const h=N.k(this,S,this.comparator);return h&&(this.f-=1),h}forEach(S,h){let a=this.e.forward[0];for(;a;)S.call(h,a.value,a.key,this),a=a.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",h=this.e.forward[0];for(;h;)S+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return S}static g(S,h,a){let y=S.e;for(let E=S.d-1;E>=0;E--)for(;y.forward[E]&&a(y.forward[E].key,h)<0;)y=y.forward[E];if(y=y.forward[0],y&&a(y.key,h)===0)return y}static h(S,h,a,y){const E=[];let d=S.e;for(let m=S.d-1;m>=0;m--){for(;d.forward[m]&&y(d.forward[m].key,h)<0;)d=d.forward[m];E[m]=d}if(d=d.forward[0],d&&y(d.key,h)===0)return d.value=a,!1;{const m=N.j(S);if(m>S.d){for(let w=S.d;w<m;w++)E[w]=S.e;S.d=m}d=new D(m,h,a);for(let w=0;w<m;w++)d.forward[w]=E[w].forward[w],E[w].forward[w]=d;return!0}}static j(S,h=.5){let a=1;for(;Math.random()<h&&a<S.c;)a+=1;return a}static k(S,h,a){const y=[];let E=S.e;for(let d=S.d-1;d>=0;d--){for(;E.forward[d]&&a(E.forward[d].key,h)<0;)E=E.forward[d];y[d]=E}if(E=E.forward[0],!E||a(E.key,h)!==0)return!1;for(let d=0;d<S.d&&y[d].forward[d]===E;d++)y[d].forward[d]=E.forward[d];for(;S.d>0&&S.e.forward[S.d-1]===O;)S.d-=1;return!0}}e.$_r=N}),define(ie[46],ne([0,1,7,2]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function O(u){const g=u;return g?typeof g.read=="function":!1}e.$de=O;function N(u){const g=u;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.$ee=N;function A(u){const g=u;return g?N(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.$fe=A;function S(u,g){return new h(u,g)}e.$ge=S;class h{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,L.$1)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let r;switch(g){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(u,g){const i=[];let r;for(;(r=u.read())!==null;)i.push(r);return g(i)}e.$he=a;function y(u,g,i){const r=[];let t;for(;(t=u.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?g(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return u.read()}}}e.$ie=y;function E(u,g){return new Promise((i,r)=>{const t=[];d(u,{onData:n=>{g&&t.push(n)},onError:n=>{g?r(n):i(void 0)},onEnd:()=>{i(g?g(t):void 0)}})})}e.$je=E;function d(u,g,i){u.on("error",r=>{i?.isCancellationRequested||g.onError(r)}),u.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),u.on("data",r=>{i?.isCancellationRequested||g.onData(r)})}e.$ke=d;function m(u,g){return new Promise((i,r)=>{const t=new D.$Sc,n=[],s=R=>{if(n.push(R),n.length>g)return t.dispose(),u.pause(),i({stream:u,buffer:n,ended:!1})},o=R=>(t.dispose(),r(R)),l=()=>(t.dispose(),i({stream:u,buffer:n,ended:!0}));t.add((0,D.$Rc)(()=>u.removeListener("error",o))),u.on("error",o),t.add((0,D.$Rc)(()=>u.removeListener("end",l))),u.on("end",l),t.add((0,D.$Rc)(()=>u.removeListener("data",s))),u.on("data",s)})}e.$le=m;function w(u,g){const i=S(g);return i.end(u),i}e.$me=w;function k(){const u=S(()=>{throw new Error("not supported")});return u.end(),u}e.$ne=k;function b(u){let g=!1;return{read:()=>g?null:(g=!0,u)}}e.$oe=b;function c(u,g,i){const r=S(i);return d(u,{onData:t=>r.write(g.data(t)),onError:t=>r.error(g.error?g.error(t):t),onEnd:()=>r.end()}),r}e.$pe=c;function p(u,g,i){let r=!1;return{read:()=>{const t=g.read();return r?t:(r=!0,t!==null?i([u,t]):u)}}}e.$qe=p;function $(u,g,i){let r=!1;const t=S(i);return d(g,{onData:n=>r?t.write(n):(r=!0,t.write(i([u,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(u)),t.end()}}),t}e.$re=$}),define(ie[14],ne([0,1,166,46]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const O=typeof Buffer<"u",N=new L.$V(()=>new Uint8Array(256));let A,S;class h{static alloc(j){return O?new h(Buffer.allocUnsafe(j)):new h(new Uint8Array(j))}static wrap(j){return O&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new h(j)}static fromString(j,q){return!(q?.dontUseNodeBuffer||!1)&&O?new h(Buffer.from(j)):(A||(A=new TextEncoder),new h(A.encode(j)))}static fromByteArray(j){const q=h.alloc(j.length);for(let Q=0,Z=j.length;Q<Z;Q++)q.buffer[Q]=j[Q];return q}static concat(j,q){if(typeof q>"u"){q=0;for(let oe=0,re=j.length;oe<re;oe++)q+=j[oe].byteLength}const Q=h.alloc(q);let Z=0;for(let oe=0,re=j.length;oe<re;oe++){const he=j[oe];Q.set(he,Z),Z+=he.byteLength}return Q}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=h.alloc(this.byteLength);return j.set(this),j}toString(){return O?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(j,q){return new h(this.buffer.subarray(j,q))}set(j,q){if(j instanceof h)this.buffer.set(j.buffer,q);else if(j instanceof Uint8Array)this.buffer.set(j,q);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),q);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),q);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return d(this.buffer,j)}writeUInt32BE(j,q){m(this.buffer,j,q)}readUInt32LE(j){return w(this.buffer,j)}writeUInt32LE(j,q){k(this.buffer,j,q)}readUInt8(j){return b(this.buffer,j)}writeUInt8(j,q){c(this.buffer,j,q)}indexOf(j,q=0){return a(this.buffer,j instanceof h?j.buffer:j,q)}}e.$se=h;function a(v,j,q=0){const Q=j.byteLength,Z=v.byteLength;if(Q===0)return 0;if(Q===1)return v.indexOf(j[0]);if(Q>Z-q)return-1;const oe=N.value;oe.fill(j.length);for(let ae=0;ae<j.length;ae++)oe[j[ae]]=j.length-ae-1;let re=q+j.length-1,he=re,de=-1;for(;re<Z;)if(v[re]===j[he]){if(he===0){de=re;break}re--,he--}else re+=Math.max(j.length-he,oe[v[re]]),he=j.length-1;return de}e.$te=a;function y(v,j){return v[j+0]<<0>>>0|v[j+1]<<8>>>0}e.$ue=y;function E(v,j,q){v[q+0]=j&255,j=j>>>8,v[q+1]=j&255}e.$ve=E;function d(v,j){return v[j]*2**24+v[j+1]*2**16+v[j+2]*2**8+v[j+3]}e.$we=d;function m(v,j,q){v[q+3]=j,j=j>>>8,v[q+2]=j,j=j>>>8,v[q+1]=j,j=j>>>8,v[q]=j}e.$xe=m;function w(v,j){return v[j+0]<<0>>>0|v[j+1]<<8>>>0|v[j+2]<<16>>>0|v[j+3]<<24>>>0}e.$ye=w;function k(v,j,q){v[q+0]=j&255,j=j>>>8,v[q+1]=j&255,j=j>>>8,v[q+2]=j&255,j=j>>>8,v[q+3]=j&255}e.$ze=k;function b(v,j){return v[j]}e.$Ae=b;function c(v,j,q){v[q]=j}e.$Be=c;function p(v){return D.$he(v,j=>h.concat(j))}e.$Ce=p;function $(v){return D.$oe(v)}e.$De=$;function u(v){return D.$je(v,j=>h.concat(j))}e.$Ee=u;async function g(v){return v.ended?h.concat(v.buffer):h.concat([...v.buffer,await u(v.stream)])}e.$Fe=g;function i(v){return D.$me(v,j=>h.concat(j))}e.$Ge=i;function r(v){return D.$pe(v,{data:j=>typeof j=="string"?h.fromString(j):h.wrap(j)},j=>h.concat(j))}e.$He=r;function t(v){return D.$ge(j=>h.concat(j),v)}e.$Ie=t;function n(v,j){return D.$qe(v,j,q=>h.concat(q))}e.$Je=n;function s(v,j){return D.$re(v,j,q=>h.concat(q))}e.$Ke=s;function o(v){let j=0,q=0,Q=0;const Z=new Uint8Array(Math.floor(v.length/4*3)),oe=he=>{switch(q){case 3:Z[Q++]=j|he,q=0;break;case 2:Z[Q++]=j|he>>>2,j=he<<6,q=3;break;case 1:Z[Q++]=j|he>>>4,j=he<<4,q=2;break;default:j=he<<2,q=1}};for(let he=0;he<v.length;he++){const de=v.charCodeAt(he);if(de>=65&&de<=90)oe(de-65);else if(de>=97&&de<=122)oe(de-97+26);else if(de>=48&&de<=57)oe(de-48+52);else if(de===43||de===45)oe(62);else if(de===47||de===95)oe(63);else{if(de===61)break;throw new SyntaxError(`Unexpected base64 character ${v[he]}`)}}const re=Q;for(;q>0;)oe(0);return h.wrap(Z).slice(0,re)}e.$Le=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:v},j=!0,q=!1){const Q=q?R:l;let Z="";const oe=v.byteLength%3;let re=0;for(;re<v.byteLength-oe;re+=3){const he=v[re+0],de=v[re+1],ae=v[re+2];Z+=Q[he>>>2],Z+=Q[(he<<4|de>>>4)&63],Z+=Q[(de<<2|ae>>>6)&63],Z+=Q[ae&63]}if(oe===1){const he=v[re+0];Z+=Q[he>>>2],Z+=Q[he<<4&63],j&&(Z+="==")}else if(oe===2){const he=v[re+0],de=v[re+1];Z+=Q[he>>>2],Z+=Q[(he<<4|de>>>4)&63],Z+=Q[de<<2&63],j&&(Z+="=")}return Z}e.$Me=I}),define(ie[43],ne([0,1,30]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=void 0;function D(c){return O(c,0)}e.$5i=D;function O(c,p){switch(typeof c){case"object":return c===null?N(349,p):Array.isArray(c)?h(c,p):a(c,p);case"string":return S(c,p);case"boolean":return A(c,p);case"number":return N(c,p);case"undefined":return N(937,p);default:return N(617,p)}}e.$6i=O;function N(c,p){return(p<<5)-p+c|0}e.$7i=N;function A(c,p){return N(c?433:863,p)}function S(c,p){p=N(149417,p);for(let $=0,u=c.length;$<u;$++)p=N(c.charCodeAt($),p);return p}e.$8i=S;function h(c,p){return p=N(104579,p),c.reduce(($,u)=>O(u,$),p)}function a(c,p){return p=N(181387,p),Object.keys(c).sort().reduce(($,u)=>($=S(u,$),O(c[u],$)),p)}class y{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=O(p,this.g),this.g}}e.$9i=y;var E;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(c,p,$=32){const u=$-p,g=~((1<<u)-1);return(c<<p|(g&c)>>>u)>>>0}function m(c,p=0,$=c.byteLength,u=0){for(let g=0;g<$;g++)c[p+g]=u}function w(c,p,$="0"){for(;c.length<p;)c=$+c;return c}function k(c,p=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map($=>$.toString(16).padStart(2,"0")).join(""):w((c>>>0).toString(16),p/4)}e.$0i=k;class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const $=p.length;if($===0)return;const u=this.p;let g=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=p.charCodeAt(0),t=0);;){let n=r;if(L.$nf(r))if(t+1<$){const s=p.charCodeAt(t+1);L.$of(s)?(t++,n=L.$pf(r,s)):n=65533}else{i=r;break}else L.$of(r)&&(n=65533);if(g=this.w(u,g,n),t++,t<$)r=p.charCodeAt(t);else break}this.r=g,this.u=i}w(p,$,u){return u<128?p[$++]=u:u<2048?(p[$++]=192|(u&1984)>>>6,p[$++]=128|(u&63)>>>0):u<65536?(p[$++]=224|(u&61440)>>>12,p[$++]=128|(u&4032)>>>6,p[$++]=128|(u&63)>>>0):(p[$++]=240|(u&1835008)>>>18,p[$++]=128|(u&258048)>>>12,p[$++]=128|(u&4032)>>>6,p[$++]=128|(u&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,p[0]=p[64],p[1]=p[65],p[2]=p[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),k(this.h)+k(this.l)+k(this.m)+k(this.n)+k(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=b.g,$=this.q;for(let l=0;l<64;l+=4)p.setUint32(l,$.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,d(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let u=this.h,g=this.l,i=this.m,r=this.n,t=this.o,n,s,o;for(let l=0;l<80;l++)l<20?(n=g&i|~g&r,s=1518500249):l<40?(n=g^i^r,s=1859775393):l<60?(n=g&i|g&r|i&r,s=2400959708):(n=g^i^r,s=3395469782),o=d(u,5)+n+t+s+p.getUint32(l*4,!1)&4294967295,t=r,r=i,i=d(g,30),g=u,u=o;this.h=this.h+u&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$$i=b}),define(ie[54],ne([0,1,30]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(O){O[O.Ignore=0]="Ignore",O[O.Info=1]="Info",O[O.Warning=2]="Warning",O[O.Error=3]="Error"})(D||(D={})),function(O){const N="error",A="warning",S="warn",h="info",a="ignore";function y(d){return d?L.$jf(N,d)?O.Error:L.$jf(A,d)||L.$jf(S,d)?O.Warning:L.$jf(h,d)?O.Info:O.Ignore:O.Ignore}O.fromValue=y;function E(d){switch(d){case O.Error:return N;case O.Warning:return A;case O.Info:return h;default:return a}}O.toString=E}(D||(D={})),e.default=D}),define(ie[27],ne([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([$,u])=>{p[$]=u&&typeof u=="object"?D(u):u}),p}e.$Hn=D;function O(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const $=p.shift();Object.freeze($);for(const u in $)if(N.call($,u)){const g=$[u];typeof g=="object"&&!Object.isFrozen(g)&&!(0,L.$Vf)(g)&&p.push(g)}}return c}e.$In=O;const N=Object.prototype.hasOwnProperty;function A(c,p){return S(c,p,new Set)}e.$Jn=A;function S(c,p,$){if((0,L.$2f)(c))return c;const u=p(c);if(typeof u<"u")return u;if(Array.isArray(c)){const g=[];for(const i of c)g.push(S(i,p,$));return g}if((0,L.$Uf)(c)){if($.has(c))throw new Error("Cannot clone recursive data-structure");$.add(c);const g={};for(const i in c)N.call(c,i)&&(g[i]=S(c[i],p,$));return $.delete(c),g}return c}function h(c,p,$=!0){return(0,L.$Uf)(c)?((0,L.$Uf)(p)&&Object.keys(p).forEach(u=>{u in c?$&&((0,L.$Uf)(c[u])&&(0,L.$Uf)(p[u])?h(c[u],p[u],$):c[u]=p[u]):c[u]=p[u]}),c):p}e.$Kn=h;function a(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let $,u;if(Array.isArray(c)){if(c.length!==p.length)return!1;for($=0;$<c.length;$++)if(!a(c[$],p[$]))return!1}else{const g=[];for(u in c)g.push(u);g.sort();const i=[];for(u in p)i.push(u);if(i.sort(),!a(g,i))return!1;for($=0;$<g.length;$++)if(!a(c[g[$]],p[g[$]]))return!1}return!0}e.$Ln=a;function y(c){const p=new Set;return JSON.stringify(c,($,u)=>{if((0,L.$Uf)(u)||Array.isArray(u)){if(p.has(u))return"[Circular]";p.add(u)}return u})}e.$Mn=y;function E(c,p){const $=Object.create(null);return!c||!p||Object.keys(p).forEach(g=>{const i=c[g],r=p[g];a(i,r)||($[g]=r)}),$}e.$Nn=E;function d(c,p){const $=p.toLowerCase(),u=Object.keys(c).find(g=>g.toLowerCase()===$);return u?c[u]:c[p]}e.$On=d;function m(c,p){const $=Object.create(null);for(const[u,g]of Object.entries(c))p(u,g)&&($[u]=g);return $}e.$Pn=m;function w(c){let p=[];for(;Object.prototype!==c;)p=p.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return p}e.$Qn=w;function k(c){const p=[];for(const $ of w(c))typeof c[$]=="function"&&p.push($);return p}e.$Rn=k;function b(c,p){const $=g=>function(){const i=Array.prototype.slice.call(arguments,0);return p(g,i)},u={};for(const g of c)u[g]=$(g);return u}e.$Sn=b}),define(ie[28],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=e.$zg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(O){return L.test(O)}e.$zg=D,e.$Ag=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(S){for(let h=0;h<S.length;h++)S[h]=Math.floor(Math.random()*256);return S};const N=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));return function(){O(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let h=0,a="";return a+=A[N[h++]],a+=A[N[h++]],a+=A[N[h++]],a+=A[N[h++]],a+="-",a+=A[N[h++]],a+=A[N[h++]],a+="-",a+=A[N[h++]],a+=A[N[h++]],a+="-",a+=A[N[h++]],a+=A[N[h++]],a+="-",a+=A[N[h++]],a+=A[N[h++]],a+=A[N[h++]],a+=A[N[h++]],a+=A[N[h++]],a+=A[N[h++]],a}}()}),define(ie[76],ne([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function O(A){const S=A.replace(/\-/g,":").toLowerCase();return!D.has(S)}function N(){const A=(0,L.networkInterfaces)();for(const S in A){const h=A[S];if(h){for(const{mac:a}of h)if(O(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$in=N}),define(ie[77],ne([8,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ie[78],ne([0,1,77]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=e.$Gm=void 0;const D=60,O=D*60,N=O*24,A=N*7,S=N*30,h=N*365;function a(d,m,w,k){typeof d!="number"&&(d=d.getTime());const b=Math.round((new Date().getTime()-d)/1e3);if(b<-30)return(0,L.localize)(0,null,a(new Date().getTime()+b*1e3,!1));if(!k&&b<30)return(0,L.localize)(1,null);let c;return b<D?(c=b,m?c===1?w?(0,L.localize)(2,null,c):(0,L.localize)(3,null,c):w?(0,L.localize)(4,null,c):(0,L.localize)(5,null,c):c===1?w?(0,L.localize)(6,null,c):(0,L.localize)(7,null,c):w?(0,L.localize)(8,null,c):(0,L.localize)(9,null,c)):b<O?(c=Math.floor(b/D),m?c===1?w?(0,L.localize)(10,null,c):(0,L.localize)(11,null,c):w?(0,L.localize)(12,null,c):(0,L.localize)(13,null,c):c===1?w?(0,L.localize)(14,null,c):(0,L.localize)(15,null,c):w?(0,L.localize)(16,null,c):(0,L.localize)(17,null,c)):b<N?(c=Math.floor(b/O),m?c===1?w?(0,L.localize)(18,null,c):(0,L.localize)(19,null,c):w?(0,L.localize)(20,null,c):(0,L.localize)(21,null,c):c===1?w?(0,L.localize)(22,null,c):(0,L.localize)(23,null,c):w?(0,L.localize)(24,null,c):(0,L.localize)(25,null,c)):b<A?(c=Math.floor(b/N),m?c===1?(0,L.localize)(26,null,c):(0,L.localize)(27,null,c):c===1?(0,L.localize)(28,null,c):(0,L.localize)(29,null,c)):b<S?(c=Math.floor(b/A),m?c===1?w?(0,L.localize)(30,null,c):(0,L.localize)(31,null,c):w?(0,L.localize)(32,null,c):(0,L.localize)(33,null,c):c===1?w?(0,L.localize)(34,null,c):(0,L.localize)(35,null,c):w?(0,L.localize)(36,null,c):(0,L.localize)(37,null,c)):b<h?(c=Math.floor(b/S),m?c===1?w?(0,L.localize)(38,null,c):(0,L.localize)(39,null,c):w?(0,L.localize)(40,null,c):(0,L.localize)(41,null,c):c===1?w?(0,L.localize)(42,null,c):(0,L.localize)(43,null,c):w?(0,L.localize)(44,null,c):(0,L.localize)(45,null,c)):(c=Math.floor(b/h),m?c===1?w?(0,L.localize)(46,null,c):(0,L.localize)(47,null,c):w?(0,L.localize)(48,null,c):(0,L.localize)(49,null,c):c===1?w?(0,L.localize)(50,null,c):(0,L.localize)(51,null,c):w?(0,L.localize)(52,null,c):(0,L.localize)(53,null,c))}e.$Gm=a;function y(d,m){const w=Math.abs(d/1e3);return w<1?m?(0,L.localize)(54,null,d):(0,L.localize)(55,null,d):w<D?m?(0,L.localize)(56,null,Math.round(d)/1e3):(0,L.localize)(57,null,Math.round(d)/1e3):w<O?m?(0,L.localize)(58,null,Math.round(d/(1e3*D))):(0,L.localize)(59,null,Math.round(d/(1e3*D))):w<N?m?(0,L.localize)(60,null,Math.round(d/(1e3*O))):(0,L.localize)(61,null,Math.round(d/(1e3*O))):(0,L.localize)(62,null,Math.round(d/(1e3*N)))}e.$Hm=y;function E(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Im=E}),define(ie[79],ne([8,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ie[34],ne([0,1,19,3,79]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=void 0;function N(E,d){return d&&(E.stack||E.stacktrace)?O.localize(0,null,S(E),A(E.stack)||A(E.stacktrace)):S(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function S(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?O.localize(1,null,E.message):E.message||O.localize(2,null)}function h(E=null,d=!1){if(!E)return O.localize(3,null);if(Array.isArray(E)){const m=L.$Hb(E),w=h(m[0],d);return m.length>1?O.localize(4,null,w,m.length):w}if(D.$Sf(E))return E;if(E.detail){const m=E.detail;if(m.error)return N(m.error,d);if(m.exception)return N(m.exception,d)}return E.stack?N(E,d):E.message?E.message:O.localize(5,null)}e.$2i=h;function a(E){const d=E;return d instanceof Error&&Array.isArray(d.actions)}e.$3i=a;function y(E,d){let m;return typeof E=="string"?m=new Error(E):m=E,m.actions=d,m}e.$4i=y}),define(ie[80],ne([8,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ie[81],ne([0,1,80]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;function D(O){switch(O){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$9p=D}),define(ie[55],ne([0,1,12]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.TerminateResponseCode=e.Source=void 0;var D;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(D||(e.Source=D={}));var O;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(O||(e.TerminateResponseCode=O={}));function N(S,...h){const a=h.reduce((d,m)=>(d[m]=!0,d),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(d=>!a[d]).forEach(d=>{for(let m=0;m<y.length;m++)if(d.search(y[m])!==-1){delete S[d];break}})}e.$3l=N;function A(S){S&&(delete S.DEBUG,L.$j&&delete S.DYLD_LIBRARY_PATH,L.$k&&delete S.LD_PRELOAD)}e.$4l=A}),define(ie[82],ne([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$zq=e.$yq=e.$xq=void 0;function D(a){const y=a;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.$xq=D;function O(a){const y=[];let E;try{const d=JSON.parse(a.arguments),m=d[d.length-1];m&&m.__$stack&&(d.pop(),E=m.__$stack),y.push(...d)}catch{y.push("Unable to log remote console arguments",a.arguments)}return{args:y,stack:E}}e.$yq=O;function N(a){if(typeof a!="string")return N(O(a).stack);const y=a;if(y){const E=A(y),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(d&&d.length===4)return{uri:L.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$zq=N;function A(a){if(!a)return a;const y=a.indexOf(`
`);return y===-1?a:a.substring(0,y)}function S(a,y){const{args:E,stack:d}=O(a),m=typeof E[0]=="string"&&E.length===1;let w=A(d);w&&(w=`(${w.trim()})`);let k=[];if(typeof E[0]=="string"?w&&m?k=[`%c[${y}] %c${E[0]} %c${w}`,h("blue"),h(""),h("grey")]:k=[`%c[${y}] %c${E[0]}`,h("blue"),h(""),...E.slice(1)]:k=[`%c[${y}]%`,h("blue"),...E],w&&!m&&k.push(w),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,k)}e.log=S;function h(a){return`color: ${a}`}}),define(ie[47],ne([0,1,14,11]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=void 0;function O(h){return JSON.stringify(h,A)}e.$Lh=O;function N(h){let a=JSON.parse(h);return a=S(a),a}e.$Mh=N;function A(h,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function S(h,a=0){if(!h||a>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof L.$se||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let y=0;y<h.length;++y)h[y]=S(h[y],a+1);else for(const y in h)Object.hasOwnProperty.call(h,y)&&(h[y]=S(h[y],a+1))}return h}e.$Nh=S}),define(ie[83],ne([0,1,70,15,12,11]),function(J,e,L,D,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tD=void 0;class A{constructor(d,m,w){this.id=d,this.dependencies=m,this.callback=w}}class S{static{this.INSTANCE=new S}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,m,w)=>{typeof d!="string"&&(w=m,m=d,d=null),(typeof m!="object"||!Array.isArray(m))&&(w=m,m=null),this.c.push(new A(d,m,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const m=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!m)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}h(d){return new Promise((m,w)=>{const k=document.createElement("script");k.setAttribute("async","async"),k.setAttribute("type","text/javascript");const b=()=>{k.removeEventListener("load",c),k.removeEventListener("error",p)},c=$=>{b(),m(this.c.pop())},p=$=>{b(),w($)};k.addEventListener("load",c),k.addEventListener("error",p),this.f&&(d=this.f.createScriptURL(d)),k.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(k)})}i(d){return new Promise((m,w)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),m(this.c.pop())}catch(k){w(k)}})}async j(d){try{const m=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,k=globalThis._VSCODE_NODE_MODULES.module,b=N.URI.parse(d).fsPath,c=m.readFileSync(b).toString(),p=k.wrap(c.replace(/^#!.*/,""));return new w.Script(p).runInThisContext().apply(),this.c.pop()}catch(m){throw m}}}const h=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function y(E,d,m){if(L.$T){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[E]&&(E=a[E]);const w=`${E}/${d}`;if(h.has(w))return h.get(w);let k;if(/^\w[\w\d+.-]*:\/\//.test(w))k=w;else{const $=`${m&&!O.$o?D.$vg:D.$ug}/${w}`;k=D.$yg.asBrowserUri($).toString(!0)}const b=S.INSTANCE.load(k);return h.set(w,b),b}else return await new Promise((w,k)=>{J([E],w,k)})}e.$tD=y}),define(ie[84],ne([0,1,33,48,28,76,12]),function(J,e,L,D,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=void 0,e.$jn=new class{c(d){return this.a||(this.a=D.$ki.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,m=0;const w=(0,L.networkInterfaces)();for(const k in w){const b=w[k];if(b)for(const{mac:c,internal:p}of b)p||(m+=1,this.c(c.toUpperCase())&&(d+=1))}this.b=m>0?d/m:0}return this.b}};let S;async function h(d){return S||(S=(async()=>await a(d)||O.$Ag())()),S}e.$kn=h;async function a(d){try{const m=await new Promise((k,b)=>{J(["crypto"],k,b)}),w=(0,N.$in)();return m.createHash("sha256").update(w,"utf8").digest("hex")}catch(m){d(m);return}}const y="Software\\Microsoft\\SQMClient";async function E(d){if(A.$i){const m=await new Promise((w,k)=>{J(["@vscode/windows-registry"],w,k)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(w){return d(w),""}}return""}e.$ln=E}),define(ie[85],ne([0,1,33,16,24]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=void 0;const N=/^\d+$/,A=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var h;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(h||(h={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class E{constructor(g,i,r){this.exePath=g,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await O.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:u=!1}={}){return u?a===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:u=!1,findPreview:g=!1}={}){const i=d({useAlternateBitness:u});if(!i)return null;const r=D.$jc(i,"PowerShell");if(!await O.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const l of await O.Promises.readdir(r)){let R=-1;if(g){const v=l.indexOf("-");if(v<0)continue;const j=l.substring(0,v);if(!N.test(j)||l.substring(v+1)!=="preview")continue;R=parseInt(j,10)}else{if(!N.test(l))continue;R=parseInt(l,10)}if(R<=t)continue;const I=D.$jc(r,l,"pwsh.exe");await O.SymlinkSupport.existsFile(I)&&(n=I,t=R)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=g?" Preview":"";return new E(n,`PowerShell${o}${s}`,!0)}async function w({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const g=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await O.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=u?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await O.Promises.readdir(g))if(i.test(t)){const n=D.$jc(g,t,"pwsh.exe");return new E(n,r)}return null}function k(){const u=D.$jc(L.homedir(),".dotnet","tools","pwsh.exe");return new E(u,".NET Core PowerShell Global Tool")}function b(){const u=D.$jc(process.env.windir,a===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(u,"Windows PowerShell",!0)}async function*c(){let u=await m();u&&(yield u),u=await m({useAlternateBitness:!0}),u&&(yield u),u=await w(),u&&(yield u),u=k(),u&&(yield u),u=await m({findPreview:!0}),u&&(yield u),u=await w({findPreview:!0}),u&&(yield u),u=await m({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=b(),u&&(yield u)}async function*p(){for await(const u of c())await u.exists()&&(yield u)}e.$1l=p;async function $(){for await(const u of p())return u;return null}e.$2l=$}),define(ie[56],ne([0,1,16,12,35,55,3,24]),function(J,e,L,D,O,N,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$6l=e.$5l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function h(E=O.env){return E.comspec||"cmd.exe"}e.$5l=h;function a(E){let d=[],m=!1;const w=function(k){if(m){d.push(k);return}(!E.send(k,c=>{if(c&&console.error(c),m=!1,d.length>0){const p=d.slice(0);d=[],p.forEach($=>w($))}})||D.$i)&&(m=!0)};return{send:w}}e.$6l=a;var y;(function(E){async function d(m,w,k){if(L.$ic(m))return m;if(w===void 0&&(w=O.cwd()),L.$mc(m)!=="."||(k===void 0&&A.$Sf(O.env.PATH)&&(k=O.env.PATH.split(L.$tc)),k===void 0||k.length===0))return L.$jc(w,m);async function c(p){if(await S.Promises.exists(p)){let $;try{$=await S.Promises.stat(p)}catch(u){u.message.startsWith("EACCES")&&($=await S.Promises.lstat(p))}return $?!$.isDirectory():!1}return!1}for(const p of k){let $;if(L.$ic(p)?$=L.$jc(p,m):$=L.$jc(w,p,m),await c($))return $;let u=$+".com";if(await c(u)||(u=$+".exe",await c(u)))return u}return L.$jc(w,m)}E.findExecutable=d})(y||(e.win32=y={}))}),define(ie[86],ne([0,1,33,12,85,56]),function(J,e,L,D,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=void 0;async function A(E,d){return E===1?D.$i?y():N.$5l(d):h(E,d)}e.$7l=A;let S=null;function h(E,d){if(D.$k&&E===2||D.$j&&E===3)return"/bin/bash";if(!S){let m;if(D.$i)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=(0,L.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}S=m}return S}let a=null;async function y(){return a||(a=(await(0,O.$2l)()).exePath),a}});var me=this&&this.__decorate||function(J,e,L,D){var O=arguments.length,N=O<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(J,e,L,D);else for(var S=J.length-1;S>=0;S--)(A=J[S])&&(N=(O<3?A(N):O>3?A(e,L,N):A(e,L))||N);return O>3&&N&&Object.defineProperty(e,L,N),N};define(ie[57],ne([0,1,19,9,14,20,53,7,6,2,47,30,3]),function(J,e,L,D,O,N,A,S,h,a,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.ProxyChannel=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.RequestInitiator=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=void 0;var m;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(m||(m={}));function w(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var k;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(k||(k={}));function b(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(c||(c={}));function p(T){let C=0;for(let H=0;;H+=7){const K=T.read(1);if(C|=(K.buffer[0]&127)<<H,!(K.buffer[0]&128))return C}}const $=t(0);function u(T,C){if(C===0){T.write($);return}let H=0;for(let Y=C;Y!==0;Y=Y>>>7)H++;const K=O.$se.alloc(H);for(let Y=0;C!==0;Y++)K.buffer[Y]=C&127,C=C>>>7,C>0&&(K.buffer[Y]|=128);T.write(K)}class g{constructor(C){this.b=C,this.a=0}read(C){const H=this.b.slice(this.a,this.a+C);return this.a+=H.byteLength,H}}e.$Oh=g;class i{constructor(){this.a=[]}get buffer(){return O.$se.concat(this.a)}write(C){this.a.push(C)}}e.$Ph=i;var r;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(r||(r={}));function t(T){const C=O.$se.alloc(1);return C.writeUInt8(T,0),C}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(T,C){if(typeof C>"u")T.write(n.Undefined);else if(typeof C=="string"){const H=O.$se.fromString(C);T.write(n.String),u(T,H.byteLength),T.write(H)}else if(s&&Buffer.isBuffer(C)){const H=O.$se.wrap(C);T.write(n.Buffer),u(T,H.byteLength),T.write(H)}else if(C instanceof O.$se)T.write(n.VSBuffer),u(T,C.byteLength),T.write(C);else if(Array.isArray(C)){T.write(n.Array),u(T,C.length);for(const H of C)o(T,H)}else if(typeof C=="number"&&(C|0)===C)T.write(n.Uint),u(T,C);else{const H=O.$se.fromString(JSON.stringify(C));T.write(n.Object),u(T,H.byteLength),T.write(H)}}e.$Qh=o;function l(T){switch(T.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return T.read(p(T)).toString();case r.Buffer:return T.read(p(T)).buffer;case r.VSBuffer:return T.read(p(T));case r.Array:{const H=p(T),K=[];for(let Y=0;Y<H;Y++)K.push(l(T));return K}case r.Object:return JSON.parse(T.read(p(T)).toString());case r.Int:return p(T)}}e.$Rh=l;class R{constructor(C,H,K=null,Y=1e3){this.h=C,this.j=H,this.k=K,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(C,H){this.b.set(C,H),setTimeout(()=>this.w(C),0)}m(C){switch(C.type){case 200:{const H=this.o([C.type]);this.k?.logOutgoing(H,0,1,b(C.type));return}case 201:case 202:case 204:case 203:{const H=this.o([C.type,C.id],C.data);this.k?.logOutgoing(H,C.id,1,b(C.type),C.data);return}}}o(C,H=void 0){const K=new i;return o(K,C),o(K,H),this.p(K.buffer)}p(C){try{return this.h.send(C),C.byteLength}catch{return 0}}q(C){const H=new g(C),K=l(H),Y=l(H),_=K[0];switch(_){case 100:return this.k?.logIncoming(C.byteLength,K[1],1,`${w(_)}: ${K[2]}.${K[3]}`,Y),this.s({type:_,id:K[1],channelName:K[2],name:K[3],arg:Y});case 102:return this.k?.logIncoming(C.byteLength,K[1],1,`${w(_)}: ${K[2]}.${K[3]}`,Y),this.t({type:_,id:K[1],channelName:K[2],name:K[3],arg:Y});case 101:return this.k?.logIncoming(C.byteLength,K[1],1,`${w(_)}`),this.u({type:_,id:K[1]});case 103:return this.k?.logIncoming(C.byteLength,K[1],1,`${w(_)}`),this.u({type:_,id:K[1]})}}s(C){const H=this.b.get(C.channelName);if(!H){this.v(C);return}const K=new N.$ce;let Y;try{Y=H.call(this.j,C.name,C.arg,K.token)}catch(F){Y=Promise.reject(F)}const _=C.id;Y.then(F=>{this.m({id:_,data:F,type:201})},F=>{F instanceof Error?this.m({id:_,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:_,data:F,type:203})}).finally(()=>{U.dispose(),this.d.delete(C.id)});const U=(0,a.$Rc)(()=>K.cancel());this.d.set(C.id,U)}t(C){const H=this.b.get(C.channelName);if(!H){this.v(C);return}const K=C.id,_=H.listen(this.j,C.name,C.arg)(U=>this.m({id:K,data:U,type:204}));this.d.set(C.id,_)}u(C){const H=this.d.get(C.id);H&&(H.dispose(),this.d.delete(C.id))}v(C){let H=this.g.get(C.channelName);H||(H=[],this.g.set(C.channelName,H));const K=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.m({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:C,timeoutTimer:K})}w(C){const H=this.g.get(C);if(H){for(const K of H)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.s(K.request);break;case 102:this.t(K.request);break}this.g.delete(C)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Sh=R;var I;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class v{constructor(C,H=null){this.l=C,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$5d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=H}getChannel(C){const H=this;return{call(K,Y,_){return H.a?Promise.reject(new S.$5):H.m(C,K,Y,_)},listen(K,Y){return H.a?h.Event.None:H.o(C,K,Y)}}}m(C,H,K,Y=N.CancellationToken.None){const _=this.g++,F={id:_,type:100,channelName:C,name:H,arg:K};if(Y.isCancellationRequested)return Promise.reject(new S.$5);let f;return new Promise((z,M)=>{if(Y.isCancellationRequested)return M(new S.$5);const W=()=>{const ue=$e=>{switch($e.type){case 201:this.f.delete(_),z($e.data);break;case 202:{this.f.delete(_);const we=new Error($e.data.message);we.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,we.name=$e.data.name,M(we);break}case 203:this.f.delete(_),M($e.data);break}};this.f.set(_,ue),this.p(F)};let G=null;this.b===c.Idle?W():(G=(0,D.$4g)(ue=>this.u()),G.then(()=>{G=null,W()}));const te=()=>{G?(G.cancel(),G=null):this.p({id:_,type:101}),M(new S.$5)},le=Y.onCancellationRequested(te);f=(0,a.$Qc)((0,a.$Rc)(te),le),this.d.add(f)}).finally(()=>{f.dispose(),this.d.delete(f)})}o(C,H,K){const Y=this.g++,U={id:Y,type:102,channelName:C,name:H,arg:K};let F=null;const f=new h.$5d({onWillAddFirstListener:()=>{F=(0,D.$4g)(z=>this.u()),F.then(()=>{F=null,this.d.add(f),this.p(U)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(f),this.p({id:Y,type:103}))}}),P=z=>f.fire(z.data);return this.f.set(Y,P),f.event}p(C){switch(C.type){case 100:case 102:{const H=this.q([C.type,C.id,C.channelName,C.name],C.arg);this.j?.logOutgoing(H,C.id,0,`${w(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const H=this.q([C.type,C.id]);this.j?.logOutgoing(H,C.id,0,w(C.type));return}}}q(C,H=void 0){const K=new i;return o(K,C),o(K,H),this.r(K.buffer)}r(C){try{return this.l.send(C),C.byteLength}catch{return 0}}s(C){const H=new g(C),K=l(H),Y=l(H),_=K[0];switch(_){case 200:return this.j?.logIncoming(C.byteLength,0,0,b(_)),this.t({type:K[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(C.byteLength,K[1],0,b(_),Y),this.t({type:K[0],id:K[1],data:Y})}}t(C){if(C.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(C.id)?.(C)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Th=v,me([A.$Ih],v.prototype,"onDidInitializePromise",null);class j{get connections(){const C=[];return this.f.forEach(H=>C.push(H)),C}constructor(C){this.a=new Map,this.f=new Set,this.g=new h.$5d,this.onDidAddConnection=this.g.event,this.h=new h.$5d,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(C(({protocol:H,onDidClientDisconnect:K})=>{const Y=h.Event.once(H.onMessage);this.j.add(Y(_=>{const U=new g(_),F=l(U),f=new R(H,F),P=new v(H);this.a.forEach((M,W)=>f.registerChannel(W,M));const z={channelServer:f,channelClient:P,ctx:F};this.f.add(z),this.g.fire(z),this.j.add(K(()=>{f.dispose(),P.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(C,H){const K=this;return{call(Y,_,U){let F;if((0,d.$7f)(H)){const P=(0,L.$4b)(K.connections.filter(H));F=P?Promise.resolve(P):h.Event.toPromise(h.Event.filter(K.onDidAddConnection,H))}else F=H.routeCall(K,Y,_);const f=F.then(P=>P.channelClient.getChannel(C));return Q(f).call(Y,_,U)},listen(Y,_){if((0,d.$7f)(H))return K.k(C,H,Y,_);const U=H.routeEvent(K,Y,_).then(F=>F.channelClient.getChannel(C));return Q(U).listen(Y,_)}}}k(C,H,K,Y){const _=this;let U;const F=new h.$5d({onWillAddFirstListener:()=>{U=new a.$Sc;const f=new h.$$d,P=new Map,z=W=>{const te=W.channelClient.getChannel(C).listen(K,Y),le=f.add(te);P.set(W,le)},M=W=>{const G=P.get(W);G&&(G.dispose(),P.delete(W))};_.connections.filter(H).forEach(z),h.Event.filter(_.onDidAddConnection,H)(z,void 0,U),_.onDidRemoveConnection(M,void 0,U),f.event(F.fire,F,U),U.add(f)},onDidRemoveLastListener:()=>{U?.dispose(),U=void 0}});return F.event}registerChannel(C,H){this.a.set(C,H);for(const K of this.f)K.channelServer.registerChannel(C,H)}dispose(){this.j.dispose();for(const C of this.f)C.channelClient.dispose(),C.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Uh=j;class q{constructor(C,H,K=null){const Y=new i;o(Y,H),C.send(Y.buffer),this.a=new v(C,K),this.d=new R(C,H,K)}getChannel(C){return this.a.getChannel(C)}registerChannel(C,H){this.d.registerChannel(C,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Vh=q;function Q(T){return{call(C,H,K){return T.then(Y=>Y.call(C,H,K))},listen(C,H){const K=new h.$be;return T.then(Y=>K.input=Y.listen(C,H)),K.event}}}e.$Wh=Q;function Z(T){let C=!1;return{call(H,K,Y){return C?T.call(H,K,Y):(0,D.$fh)(0).then(()=>C=!0).then(()=>T.call(H,K,Y))},listen(H,K){if(C)return T.listen(H,K);const Y=new h.$be;return(0,D.$fh)(0).then(()=>C=!0).then(()=>Y.input=T.listen(H,K)),Y.event}}}e.$Xh=Z;class oe{constructor(C){this.a=C}routeCall(C){return this.b(C)}routeEvent(C){return this.b(C)}async b(C){for(const H of C.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await h.Event.toPromise(C.onDidAddConnection),await this.b(C)}}e.$Yh=oe;var re;(function(T){function C(_,U,F){const f=_,P=F&&F.disableMarshalling,z=new Map;for(const M in f)K(M)&&z.set(M,h.Event.buffer(f[M],!0,void 0,U));return new class{listen(M,W,G){const te=z.get(W);if(te)return te;if(Y(W)){const le=f[W];if(typeof le=="function")return le.call(f,G)}throw new S.$bb(`Event not found: ${W}`)}call(M,W,G){const te=f[W];if(typeof te=="function"){if(!P&&Array.isArray(G))for(let ue=0;ue<G.length;ue++)G[ue]=(0,y.$Nh)(G[ue]);let le=te.apply(f,G);return le instanceof Promise||(le=Promise.resolve(le)),le}throw new S.$bb(`Method not found: ${W}`)}}}T.fromService=C;function H(_,U){const F=U&&U.disableMarshalling;return new Proxy({},{get(f,P){if(typeof P=="string")return U?.properties?.has(P)?U.properties.get(P):Y(P)?function(z){return _.listen(P,z)}:K(P)?_.listen(P):async function(...z){let M;U&&!(0,d.$2f)(U.context)?M=[U.context,...z]:M=z;const W=await _.call(P,M);return F?W:(0,y.$Nh)(W)};throw new S.$bb(`Property not found: ${String(P)}`)}})}T.toService=H;function K(_){return _[0]==="o"&&_[1]==="n"&&E.$if(_.charCodeAt(2))}function Y(_){return/^onDynamic/.test(_)&&E.$if(_.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const C=T.toString();if(C!=="[object Object]")return C}return T}function ae(T){return Array.isArray(T)?T.map(de):de(T)}function B(T,C,H,K,Y,_,U){U=ae(U);const F=he[Y],f=F[K%F.length];let P=[`%c[${T}]%c[${String(C).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(_)?(P=P.concat(U),P.push(")")):P.push(U),console.log.apply(console,P)}class X{constructor(C,H){this.d=C,this.f=H,this.a=0,this.b=0}logOutgoing(C,H,K,Y,_){this.b+=C,B(this.d,this.b,C,H,K,Y,_)}logIncoming(C,H,K,Y,_){this.a+=C,B(this.f,this.a,C,H,K,Y,_)}}e.$Zh=X}),define(ie[87],ne([0,1,58,9,14,20,82,7,6,2,27,56,55,57]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=void 0;class w extends m.$Sh{constructor(c){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",p=>O.$se.wrap(Buffer.from(p,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Bq=w;class k{constructor(c,p){this.i=c,this.j=p,this.c=new Set,this.g=new Map,this.h=new h.$5d,this.onDidProcessExit=this.h.event;const $=p&&p.timeout?p.timeout:6e4;this.b=new D.$bh($),this.d=null,this.f=null}getChannel(c){const p=this;return{call($,u,g){return p.k(c,$,u,g)},listen($,u){return p.l(c,$,u)}}}k(c,p,$,u=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const g=this.n(c),i=(0,D.$4g)(n=>g.call(p,$,n)),r=u.onCancellationRequested(()=>i.cancel()),t=(0,a.$Rc)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,p,$){if(!this.b)return h.Event.None;this.b.cancel();let u;const g=new h.$5d({onWillAddFirstListener:()=>{u=this.n(c).listen(p,$)(g.fire,g),this.c.add(u)},onDidRemoveLastListener:()=>{this.c.delete(u),u.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,y.$Hn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,d.$4l)(p.env),this.d=(0,L.fork)(this.i,c,p);const $=new h.$5d;h.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,A.$xq)(s)){(0,A.log)(s,`IPC Library: ${this.j.serverName}`);return}$.fire(O.$se.wrap(Buffer.from(s,"base64")))});const g=this.j.useQueue?(0,E.$6l)(this.d):this.d,i=s=>this.d&&this.d.connected&&g.send(s.buffer.toString("base64")),r=$.event,t={send:i,onMessage:r};this.f=new m.$Th(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",n),this.c.forEach(l=>(0,a.$Oc)(l)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(c){let p=this.g.get(c);return p||(p=this.m.getChannel(c),this.g.set(c,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Cq=k}),define(ie[88],ne([0,1,9,6,2,47,3]),function(J,e,L,D,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.StorageState=e.$Ap=e.StorageHint=void 0;var S;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function h(d){const m=d;return m?.changed instanceof Map||m?.deleted instanceof Set}e.$Ap=h;var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class y extends O.$Tc{static{this.a=100}constructor(m,w=Object.create(null)){super(),this.r=m,this.s=w,this.b=this.B(new D.$8d),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new L.$ch(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(m=>this.u(m)))}u(m){this.b.pause();try{m.changed?.forEach((w,k)=>this.w(k,w)),m.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(m,w){if(this.c===a.Closed)return;let k=!1;(0,A.$2f)(w)?k=this.f.delete(m):this.f.get(m)!==w&&(this.f.set(m,w),k=!0),k&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(m,w){const k=this.f.get(m);return(0,A.$2f)(k)?w:k}getBoolean(m,w){const k=this.get(m);return(0,A.$2f)(k)?w:k==="true"}getNumber(m,w){const k=this.get(m);return(0,A.$2f)(k)?w:parseInt(k,10)}getObject(m,w){const k=this.get(m);return(0,A.$2f)(k)?w:(0,N.$Mh)(k)}async set(m,w,k=!1){if(this.c===a.Closed)return;if((0,A.$2f)(w))return this.delete(m,k);const b=(0,A.$Uf)(w)||Array.isArray(w)?(0,N.$Lh)(w):String(w);if(this.f.get(m)!==b)return this.f.set(m,b),this.j.set(m,b),this.h.delete(m),this.b.fire({key:m,external:k}),this.D()}async delete(m,w=!1){if(!(this.c===a.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:w}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(m).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(m){if(this.z)return this.D(m)}async D(m){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),m)}async whenFlushed(){if(this.z)return new Promise(m=>this.n.push(m))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Bp=y;class E{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((w,k)=>this.a.set(k,w)),m.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$Cp=E}),define(ie[89],ne([8,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ie[49],ne([0,1,90,9,16,3,24,89]),function(J,e,L,D,O,N,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.zip=e.$Xp=e.$Wp=void 0,e.$Wp="end of central directory record signature not found";const h=new RegExp(e.$Wp);class a extends Error{constructor(g,i){let r=i.message;switch(g){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=g,this.cause=i}}e.$Xp=a;function y(u){const g=u.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,r)=>i+r,g&61440)}function E(u){if(u instanceof a)return u;let g;return h.test(u.message)&&(g="CorruptZip"),new a(g,u)}function d(u,g,i,r,t,n){const s=O.$mc(g),o=O.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(S.localize(0,null,g)));const l=O.$jc(r,g);let R;return n.onCancellationRequested(()=>{R?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((I,v)=>{if(!n.isCancellationRequested)try{R=(0,L.createWriteStream)(l,{mode:i}),R.once("close",()=>I()),R.once("error",v),u.once("error",v),u.pipe(R)}catch(j){v(j)}}))}function m(u,g,i,r){let t=(0,D.$4g)(()=>Promise.resolve()),n=0;const s=r.onCancellationRequested(()=>{t.cancel(),u.close()});return new Promise((o,l)=>{const R=new D.$_g,I=v=>{v.isCancellationRequested||(n++,u.readEntry())};u.once("error",l),u.once("close",()=>t.then(()=>{r.isCancellationRequested||u.entryCount===n?o():l(new a("Incomplete",new Error(S.localize(1,null,n,u.entryCount))))},l)),u.readEntry(),u.on("entry",v=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(v.fileName)){I(r);return}const j=v.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(j)){const Z=O.$jc(g,j);t=(0,D.$4g)(oe=>A.Promises.mkdir(Z,{recursive:!0}).then(()=>I(oe)).then(void 0,l));return}const q=k(u,v),Q=y(v);t=(0,D.$4g)(Z=>R.queue(()=>q.then(oe=>d(oe,j,Q,g,i,Z).then(()=>I(Z)))).then(null,l))})}).finally(()=>s.dispose())}async function w(u,g=!1){const{open:i}=await new Promise((r,t)=>{J(["yauzl"],r,t)});return new Promise((r,t)=>{i(u,g?{lazyEntries:!0}:void 0,(n,s)=>{n?t(E(n)):r((0,N.$4f)(s))})})}function k(u,g){return new Promise((i,r)=>{u.openReadStream(g,(t,n)=>{t?r(E(t)):i((0,N.$4f)(n))})})}async function b(u,g){const{ZipFile:i}=await new Promise((r,t)=>{J(["yazl"],r,t)});return new Promise((r,t)=>{const n=new i;g.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,L.createWriteStream)(u);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(u))})}e.zip=b;function c(u,g,i={},r){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=w(u,!0);return i.overwrite&&(n=n.then(s=>A.Promises.rm(g).then(()=>s))),n.then(s=>m(s,g,{sourcePathRegex:t},r))}e.$Zp=c;function p(u,g){return w(u).then(i=>new Promise((r,t)=>{i.on("entry",n=>{n.fileName===g&&k(i,n).then(s=>r(s),s=>t(s))}),i.once("close",()=>t(new Error(S.localize(2,null,g))))}))}function $(u,g){return p(u,g).then(i=>new Promise((r,t)=>{const n=[];i.once("error",t),i.on("data",s=>n.push(s)),i.on("end",()=>r(Buffer.concat(n)))}))}e.$1p=$}),define(ie[91],ne([8,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[92],ne([8,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[93],ne([8,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ie[94],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[95],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[96],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[97],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[98],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[99],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[100],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[101],ne([8,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[102],ne([8,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ie[103],ne([8,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ie[104],ne([8,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[105],ne([8,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[106],ne([8,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ie[107],ne([8,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ie[108],ne([8,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[109],ne([8,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[110],ne([8,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ie[111],ne([0,1,7,93]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.TokenType=void 0;var O;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(O||(e.TokenType=O={}));function N(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,D.localize)(3,null),S=(0,D.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,L.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const E=this.d,d=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:d};this.g.push({offset:E,lexeme:d,additionalInfo:y}),this.f.push(m)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const E=this.c.substring(this.d,this.e),d=h.b.get(E);d?this.k(d):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,E=!1,d=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(S);return}const w=this.c.charCodeAt(y);if(E)E=!1;else if(w===47&&!d){y++;break}else w===91?d=!0:w===92?E=!0:w===93&&(d=!1);y++}for(;y<this.c.length&&h.a.has(this.c.charCodeAt(y));)y++;this.e=y;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$_i=h}),define(ie[112],ne([0,1,78,53,15,16,35,17,11]),function(J,e,L,D,O,N,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=e.$Jm=void 0,e.$Jm=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,N.$mc)(O.$yg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,N.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,S.$Rg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:O.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$Rg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,L.$Im)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.$jc)(this.userDataPath,"logs",m)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$Rg)(h.URI.file((0,N.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$Rg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$Rg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$Rg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=A.env.VSCODE_PORTABLE;return m?h.URI.file((0,N.$jc)(m,"argv.json")):(0,S.$Rg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,N.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,N.$kc)(m):(0,N.$hc)((0,N.$jc)(O.$yg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?h.URI.file((0,N.$kc)(m)):h.URI.file((0,N.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,N.$kc)(m);const w=A.env.VSCODE_EXTENSIONS;if(w)return w;const k=A.env.VSCODE_PORTABLE;return k?(0,N.$jc)(k,"extensions"):(0,S.$Rg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(w=>/^[^:/?#]+?:\/\//.test(w)?h.URI.parse(w):h.URI.file((0,N.$hc)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?h.URI.parse(m):h.URI.file((0,N.$hc)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$Jm.test(m))}get extensionLogLevel(){const m=[];for(const w of this.args.log||[]){const k=e.$Jm.exec(w);k&&k[1]&&k[2]&&m.push([k[1],k[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,S.$Rg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=A.env.VSCODE_PORTABLE;return m?h.URI.file((0,N.$jc)(m,"policy.json")):(0,S.$Rg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,w,k){this.a=m,this.b=w,this.c=k,this.editSessionId=this.args.editSessionId}}e.$Km=a,me([D.$Ih],a.prototype,"appRoot",null),me([D.$Ih],a.prototype,"userHome",null),me([D.$Ih],a.prototype,"userDataPath",null),me([D.$Ih],a.prototype,"appSettingsHome",null),me([D.$Ih],a.prototype,"tmpDir",null),me([D.$Ih],a.prototype,"cacheHome",null),me([D.$Ih],a.prototype,"stateResource",null),me([D.$Ih],a.prototype,"userRoamingDataHome",null),me([D.$Ih],a.prototype,"userDataSyncHome",null),me([D.$Ih],a.prototype,"sync",null),me([D.$Ih],a.prototype,"machineSettingsResource",null),me([D.$Ih],a.prototype,"workspaceStorageHome",null),me([D.$Ih],a.prototype,"localHistoryHome",null),me([D.$Ih],a.prototype,"keyboardLayoutResource",null),me([D.$Ih],a.prototype,"argvResource",null),me([D.$Ih],a.prototype,"isExtensionDevelopment",null),me([D.$Ih],a.prototype,"untitledWorkspacesHome",null),me([D.$Ih],a.prototype,"builtinExtensionsPath",null),me([D.$Ih],a.prototype,"extensionsPath",null),me([D.$Ih],a.prototype,"extensionDevelopmentLocationURI",null),me([D.$Ih],a.prototype,"extensionDevelopmentKind",null),me([D.$Ih],a.prototype,"extensionTestsLocationURI",null),me([D.$Ih],a.prototype,"debugExtensionHost",null),me([D.$Ih],a.prototype,"logLevel",null),me([D.$Ih],a.prototype,"extensionLogLevel",null),me([D.$Ih],a.prototype,"serviceMachineIdResource",null),me([D.$Ih],a.prototype,"disableTelemetry",null),me([D.$Ih],a.prototype,"disableWorkspaceTrust",null),me([D.$Ih],a.prototype,"useInMemorySecretStorage",null),me([D.$Ih],a.prototype,"policyFile",null);function y(d,m){return E(d["inspect-extensions"],d["inspect-brk-extensions"],5870,m,d.debugId,d.extensionEnvironment)}e.$Lm=y;function E(d,m,w,k,b,c){const $=Number(m||d)||(k?null:w),u=$?!!m:!1;let g;if(c)try{g=JSON.parse(c)}catch{}return{port:$,break:u,debugId:b,env:g}}e.$Mm=E}),function(){"use strict";function J(e,L,D){function O(A,S){const h=N(A,S),a=[h];return e.isAbsolute(h)||a.unshift(D),e.resolve(...a)}function N(A,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,S);const y=A["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(E,"AppData","Roaming")}break;case"darwin":a=e.join(L.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,S)}return{getUserDataPath:O}}if(typeof define=="function")define(ie[113],ne([167,33,35]),function(e,L,D){return J(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[114],ne([0,1,33,112,113]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0;class N extends D.$Km{constructor(a,y){super(a,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,O.getUserDataPath)(a,y.nameShort)},y)}}e.$Nm=N;function A(h,a){return(0,D.$Mm)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,a,h.extensionEnvironment)}e.$Om=A;function S(h,a){return(0,D.$Mm)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,a,h.extensionEnvironment)}e.$Pm=S}),define(ie[115],ne([0,1,3,97]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;function O(A,S,h,a){try{N(A,S,h,a)}catch(y){A.error(y?.message??y)}return S}e.$0p=O;function N(A,S,h,a){const y=(E,d,m)=>{const w=E[d];if((0,L.$Sf)(w)){const k=w,b=k.length;if(b>1&&k[0]==="%"&&k[b-1]==="%"){const c=k.substr(1,b-2);let p=h[c];p===void 0&&a&&(p=a[c]);const $=typeof p=="string"?p:p?.message,u=a?.[c],g=typeof u=="string"?u:u?.message;if(!$){g||A.warn(`[${S.name}]: ${(0,D.localize)(0,null,c)}`);return}if(m&&(d==="title"||d==="category")&&g&&g!==$){const i={value:$,original:g};E[d]=i}else E[d]=$}}else if((0,L.$Uf)(w))for(const k in w)w.hasOwnProperty(k)&&(k==="commands"?y(w,k,!0):y(w,k,m));else if(Array.isArray(w))for(let k=0;k<w.length;k++)y(w,k,m)};for(const E in S)S.hasOwnProperty(E)&&y(S,E)}}),define(ie[116],ne([0,1,49,100]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;function O(N){return(0,L.$1p)(N,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$fq=O}),define(ie[50],ne([0,1,17,54,101,44]),function(J,e,L,D,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function h(c){return c=c.trim(),c==="*"||A.test(c)}e.$lp=h;function a(c){if(!h(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=c.match(A);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.$mp=a;function y(c){if(!c)return null;const p=c.majorBase,$=c.majorMustEqual,u=c.minorBase;let g=c.minorMustEqual;const i=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(p===0||(g=!1),r=!1);let t=0;if(c.preRelease){const n=S.exec(c.preRelease);if(n){const[,s,o,l]=n;t=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:p,majorMustEqual:$,minorBase:u,minorMustEqual:g,patchBase:i,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}e.$np=y;function E(c,p,$){let u;typeof c=="string"?u=y(a(c)):u=c;let g;p instanceof Date?g=p.getTime():typeof p=="string"&&(g=new Date(p).getTime());let i;if(typeof $=="string"?i=y(a($)):i=$,!u||!i)return!1;const r=u.majorBase,t=u.minorBase,n=u.patchBase;let s=i.majorBase,o=i.minorBase,l=i.patchBase;const R=i.notBefore;let I=i.majorMustEqual,v=i.minorMustEqual,j=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||g&&g<R?!1:n>=l:(r===1&&s===0&&(!I||!v||!j)&&(s=1,o=0,l=0,I=!0,v=!1,j=!1),r<s?!1:r>s?!I:t<o?!1:t>o?!v:n<l?!1:n>l?!j:!(g&&g<R))}e.$op=E;function d(c,p,$,u,g){const i=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return i.push([D.default.Error,O.localize(0,null)]),i;if(typeof u.name!="string")return i.push([D.default.Error,O.localize(1,null,"name")]),i;if(typeof u.version!="string")return i.push([D.default.Error,O.localize(2,null,"version")]),i;if(!u.engines)return i.push([D.default.Error,O.localize(3,null,"engines")]),i;if(typeof u.engines.vscode!="string")return i.push([D.default.Error,O.localize(4,null,"engines.vscode")]),i;if(typeof u.extensionDependencies<"u"&&!b(u.extensionDependencies))return i.push([D.default.Error,O.localize(5,null,"extensionDependencies")]),i;if(typeof u.activationEvents<"u"){if(!b(u.activationEvents))return i.push([D.default.Error,O.localize(6,null,"activationEvents")]),i;if(typeof u.main>"u"&&typeof u.browser>"u")return i.push([D.default.Error,O.localize(7,null,"activationEvents","main","browser")]),i}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&i.push([D.default.Warning,O.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return i.push([D.default.Error,O.localize(9,null,"main")]),i;{const n=(0,L.$Rg)($,u.main);(0,L.$Lg)(n,$)||i.push([D.default.Warning,O.localize(10,null,n.path,$.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return i.push([D.default.Error,O.localize(11,null,"browser")]),i;{const n=(0,L.$Rg)($,u.browser);(0,L.$Lg)(n,$)||i.push([D.default.Warning,O.localize(12,null,n.path,$.path)])}}if(!N.valid(u.version))return i.push([D.default.Error,O.localize(13,null)]),i;const r=[];if(!m(c,p,u,g,r))for(const n of r)i.push([D.default.Error,n]);return i}e.$pp=d;function m(c,p,$,u,g){return u||typeof $.main>"u"&&typeof $.browser>"u"?!0:k(c,p,$.engines.vscode,g)}e.$qp=m;function w(c,p,$){return c==="*"||k(p,$,c)}e.$rp=w;function k(c,p,$,u=[]){const g=y(a($));if(!g)return u.push(O.localize(14,null,$)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return u.push(O.localize(15,null,$)),!1}else if(!g.majorMustEqual)return u.push(O.localize(16,null,$)),!1;return E(c,p,g)?!0:(u.push(O.localize(17,null,c,$)),!1)}function b(c){if(!Array.isArray(c))return!1;for(let p=0,$=c.length;p<$;p++)if(typeof c[p]!="string")return!1;return!0}}),define(ie[117],ne([0,1,14,28]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;async function O(N,A,S){let h=S&&S.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const y=(await A.readFile(N.serviceMachineIdResource)).value.toString();h=(0,D.$zg)(y)?y:null}catch{h=null}if(!h){h=(0,D.$Ag)();try{await A.writeFile(N.serviceMachineIdResource,L.$se.fromString(h))}catch{}}return S?.store("storage.serviceMachineId",h,-1,1),h}e.$Lp=O}),define(ie[51],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=void 0;class L{constructor(O,N=[],A=!1){this.ctor=O,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$bi=L}),define(ie[118],ne([0,1,51]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.InstantiationType=void 0;const D=[];var O;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(O||(e.InstantiationType=O={}));function N(S,h,a){h instanceof L.$bi||(h=new L.$bi(h,[],!!a)),D.push([S,h])}e.$0r=N;function A(){return D}e.$$r=A}),define(ie[119],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=void 0;class L{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Nq=L;class D{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const S=this.lookupOrInsertNode(N),h=this.lookupOrInsertNode(A);S.outgoing.set(h.key,h),h.incoming.set(S.key,S)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const S of this.a.values())S.outgoing.delete(A),S.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let S=this.a.get(A);return S||(S=new L(A,N),this.a.set(A,S)),S}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,S]of this.a)N.push(`${A}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const S=new Set([N]),h=this.c(A,S);if(h)return h}}c(N,A){for(const[S,h]of N.outgoing){if(A.has(S))return[...A,S].join(" -> ");A.add(S);const a=this.c(h,A);if(a)return a;A.delete(S)}}}e.$Oq=D}),define(ie[29],ne([0,1,3,11,10]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ConfigurationTarget=e.$Mi=e.$Li=e.$Ki=void 0,e.$Ki=(0,O.$ei)("configurationService");function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}e.$Li=N;function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}e.$Mi=A;var S;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function h(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ni=h;function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$Oi=a;function y(c,p){const $=Object.create(null);for(const u in c)E($,u,c[u],p);return $}e.$Pi=y;function E(c,p,$,u){const g=p.split("."),i=g.pop();let r=c;for(let t=0;t<g.length;t++){const n=g[t];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${p} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=$}catch{u(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(r)}`)}else u(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(r)}`)}e.$Qi=E;function d(c,p){const $=p.split(".");m(c,$)}e.$Ri=d;function m(c,p){const $=p.shift();if(p.length===0){delete c[$];return}if(Object.keys(c).indexOf($)!==-1){const u=c[$];typeof u=="object"&&!Array.isArray(u)&&(m(u,p),Object.keys(u).length===0&&delete c[$])}}function w(c,p,$){function u(r,t){let n=r;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const g=p.split("."),i=u(c,g);return typeof i>"u"?$:i}e.$Si=w;function k(c,p,$){Object.keys(p).forEach(u=>{u!=="__proto__"&&(u in c?L.$Uf(c[u])&&L.$Uf(p[u])?k(c[u],p[u],$):$&&(c[u]=p[u]):c[u]=p[u])})}e.$Ti=k;function b(c){return c.replace(/[\[\]]/g,"")}e.$Ui=b}),define(ie[120],ne([0,1,12,30,111,10,92,7]),function(J,e,L,D,O,N,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.ContextKeyExprType=e.$aj=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",L.$j),h.set("isLinux",L.$k),h.set("isWindows",L.$i),h.set("isWeb",L.$o),h.set("isMacNative",L.$j&&!L.$o),h.set("isEdge",L.$H),h.set("isFirefox",L.$F),h.set("isChrome",L.$E),h.set("isSafari",L.$G);function a(F,f){if(h.get(F)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(F,f)}e.$aj=a;const y=Object.prototype.hasOwnProperty;var E;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const d={regexParsingWithErrorRecovery:!0},m=(0,A.localize)(0,null),w=(0,A.localize)(1,null),k=(0,A.localize)(2,null),b=(0,A.localize)(3,null),c=(0,A.localize)(4,null),p=(0,A.localize)(5,null),$=(0,A.localize)(6,null),u=(0,A.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(f=d){this.k=f,this.d=new O.$_i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(f){if(f===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(f).scan(),this.g=0,this.h=[];try{const P=this.l();if(!this.E()){const z=this.D(),M=z.type===17?p:void 0;throw this.h.push({message:c,offset:z.offset,lexeme:O.$_i.getLexeme(z),additionalInfo:M}),g.c}return P}catch(P){if(P!==g.c)throw P;return}}l(){return this.m()}m(){const f=[this.o()];for(;this.y(16);){const P=this.o();f.push(P)}return f.length===1?f[0]:i.or(...f)}o(){const f=[this.s()];for(;this.y(15);){const P=this.s();f.push(P)}return f.length===1?f[0]:i.and(...f)}s(){if(this.y(2)){const f=this.D();switch(f.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const P=this.l();return this.A(1,b),P?.negate()}case 17:return this.z(),q.create(f.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",f)}}return this.t()}t(){const f=this.D();switch(f.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const P=this.l();return this.A(1,b),P}case 17:{const P=f.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const W=M.lexeme,G=W.lastIndexOf("/"),te=G===W.length-1?void 0:this.w(W.substring(G+1));let le;try{le=new RegExp(W.substring(1,G),te)}catch{throw this.B("REGEX",M)}return de.create(P,le)}switch(M.type){case 10:case 19:{const W=[M.lexeme];this.z();let G=this.D(),te=0;for(let fe=0;fe<M.lexeme.length;fe++)M.lexeme.charCodeAt(fe)===40?te++:M.lexeme.charCodeAt(fe)===41&&te--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let fe=0;fe<G.lexeme.length;fe++)G.lexeme.charCodeAt(fe)===40?te++:M.lexeme.charCodeAt(fe)===41&&te--}if(te<0)break;W.push(O.$_i.getLexeme(G)),this.z(),G=this.D()}const le=W.join(""),ue=le.lastIndexOf("/"),$e=ue===le.length-1?void 0:this.w(le.substring(ue+1));let we;try{we=new RegExp(le.substring(1,ue),$e)}catch{throw this.B("REGEX",M)}return i.regex(P,we)}case 18:{const W=M.lexeme;this.z();let G=null;if(!(0,D.$Se)(W)){const te=W.indexOf("/"),le=W.lastIndexOf("/");if(te!==le&&te>=0){const ue=W.slice(te+1,le),$e=W[le+1]==="i"?"i":"";try{G=new RegExp(ue,$e)}catch{throw this.B("REGEX",M)}}}if(G===null)throw this.B("REGEX",M);return de.create(P,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,k);const M=this.u();return i.notIn(P,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return i.equals(P,M);switch(M){case"true":return i.has(P);case"false":return i.not(P);default:return i.equals(P,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return i.notEquals(P,M);switch(M){case"true":return i.not(P);case"false":return i.has(P);default:return i.notEquals(P,M)}}case 5:return this.z(),re.create(P,this.u());case 6:return this.z(),he.create(P,this.u());case 7:return this.z(),Z.create(P,this.u());case 8:return this.z(),oe.create(P,this.u());case 13:return this.z(),i.in(P,this.u());default:return i.has(P)}}case 20:throw this.h.push({message:$,offset:f.offset,lexeme:"",additionalInfo:u}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const f=this.D();switch(f.type){case 17:case 18:return this.z(),f.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(f){return f.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(f){return this.C(f)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(f,P){if(this.C(f))return this.z();throw this.B(P,this.D())}B(f,P,z){const M=(0,A.localize)(8,null,f,O.$_i.getLexeme(P)),W=P.offset,G=O.$_i.getLexeme(P);return this.h.push({message:M,offset:W,lexeme:G,additionalInfo:z}),g.c}C(f){return this.D().type===f}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$bj=g;class i{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(f){return l.create(f)}static equals(f,P){return R.create(f,P)}static notEquals(f,P){return j.create(f,P)}static regex(f,P){return de.create(f,P)}static in(f,P){return I.create(f,P)}static notIn(f,P){return v.create(f,P)}static not(f){return q.create(f)}static and(...f){return X.create(f,null,!0)}static or(...f){return T.create(f,null,!0)}static greater(f,P){return Z.create(f,P)}static greaterEquals(f,P){return oe.create(f,P)}static smaller(f,P){return re.create(f,P)}static smallerEquals(f,P){return he.create(f,P)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this.c.parse(f)}}e.$cj=i;function r(F){const f=new g({regexParsingWithErrorRecovery:!1});return F.map(P=>(f.parse(P),f.lexingErrors.length>0?f.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$dj=r;function t(F,f){const P=F?F.substituteConstants():void 0,z=f?f.substituteConstants():void 0;return!P&&!z?!0:!P||!z?!1:P.equals(z)}e.$ej=t;function n(F,f){return F.cmp(f)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return o.INSTANCE}}e.$fj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return s.INSTANCE}}e.$gj=o;class l{static create(f,P=null){const z=h.get(f);return typeof z=="boolean"?z?o.INSTANCE:s.INSTANCE:new l(f,P)}constructor(f,P){this.key=f,this.c=P,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:H(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=h.get(this.key);return typeof f=="boolean"?f?o.INSTANCE:s.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.c||(this.c=q.create(this.key,this)),this.c}}e.$hj=l;class R{static create(f,P,z=null){if(typeof P=="boolean")return P?l.create(f,z):q.create(f,z);const M=h.get(f);return typeof M=="boolean"?P===(M?"true":"false")?o.INSTANCE:s.INSTANCE:new R(f,P,z)}constructor(f,P,z){this.c=f,this.d=P,this.f=z,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=h.get(this.c);if(typeof f=="boolean"){const P=f?"true":"false";return this.d===P?o.INSTANCE:s.INSTANCE}return this}evaluate(f){return f.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(f){return f.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$ij=R;class I{static create(f,P){return new I(f,P)}constructor(f,P){this.d=f,this.f=P,this.type=10,this.c=null}cmp(f){return f.type!==this.type?this.type-f.type:K(this.d,this.f,f.d,f.f)}equals(f){return f.type===this.type?this.d===f.d&&this.f===f.f:!1}substituteConstants(){return this}evaluate(f){const P=f.getValue(this.f),z=f.getValue(this.d);return Array.isArray(P)?P.includes(z):typeof z=="string"&&typeof P=="object"&&P!==null?y.call(P,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(f){return f.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$jj=I;class v{static create(f,P){return new v(f,P)}constructor(f,P){this.d=f,this.f=P,this.type=11,this.c=I.create(f,P)}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(f){return f.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$kj=v;class j{static create(f,P,z=null){if(typeof P=="boolean")return P?q.create(f,z):l.create(f,z);const M=h.get(f);return typeof M=="boolean"?P===(M?"true":"false")?s.INSTANCE:o.INSTANCE:new j(f,P,z)}constructor(f,P,z){this.c=f,this.d=P,this.f=z,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=h.get(this.c);if(typeof f=="boolean"){const P=f?"true":"false";return this.d===P?s.INSTANCE:o.INSTANCE}return this}evaluate(f){return f.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(f){return f.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$lj=j;class q{static create(f,P=null){const z=h.get(f);return typeof z=="boolean"?z?s.INSTANCE:o.INSTANCE:new q(f,P)}constructor(f,P){this.c=f,this.d=P,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:H(this.c,f.c)}equals(f){return f.type===this.type?this.c===f.c:!1}substituteConstants(){const f=h.get(this.c);return typeof f=="boolean"?f?s.INSTANCE:o.INSTANCE:this}evaluate(f){return!f.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(f){return f.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$mj=q;function Q(F,f){if(typeof F=="string"){const P=parseFloat(F);isNaN(P)||(F=P)}return typeof F=="string"||typeof F=="number"?f(F):s.INSTANCE}class Z{static create(f,P,z=null){return Q(P,M=>new Z(f,M,z))}constructor(f,P,z){this.c=f,this.d=P,this.f=z,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$nj=Z;class oe{static create(f,P,z=null){return Q(P,M=>new oe(f,M,z))}constructor(f,P,z){this.c=f,this.d=P,this.f=z,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$oj=oe;class re{static create(f,P,z=null){return Q(P,M=>new re(f,M,z))}constructor(f,P,z){this.c=f,this.d=P,this.f=z,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$pj=re;class he{static create(f,P,z=null){return Q(P,M=>new he(f,M,z))}constructor(f,P,z){this.c=f,this.d=P,this.f=z,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$qj=he;class de{static create(f,P){return new de(f,P)}constructor(f,P){this.d=f,this.f=P,this.type=7,this.c=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.d<f.d)return-1;if(this.d>f.d)return 1;const P=this.f?this.f.source:"",z=f.f?f.f.source:"";return P<z?-1:P>z?1:0}equals(f){if(f.type===this.type){const P=this.f?this.f.source:"",z=f.f?f.f.source:"";return this.d===f.d&&P===z}return!1}substituteConstants(){return this}evaluate(f){const P=f.getValue(this.d);return this.f?this.f.test(P):!1}serialize(){const f=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${f}`}keys(){return[this.d]}map(f){return f.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$rj=de;class ae{static create(f){return new ae(f)}constructor(f){this.c=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(f){return new ae(this.c.map(f))}negate(){return this.c}}e.$sj=ae;function B(F){let f=null;for(let P=0,z=F.length;P<z;P++){const M=F[P].substituteConstants();if(F[P]!==M&&f===null){f=[];for(let W=0;W<P;W++)f[W]=F[W]}f!==null&&(f[P]=M)}return f===null?F:f}class X{static create(f,P,z){return X.d(f,P,z)}constructor(f,P){this.expr=f,this.c=P,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let P=0,z=this.expr.length;P<z;P++){const M=n(this.expr[P],f.expr[P]);if(M!==0)return M}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].equals(f.expr[P]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:X.create(f,this.c,!1)}evaluate(f){for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].evaluate(f))return!1;return!0}static d(f,P,z){const M=[];let W=!1;for(const G of f)if(G){if(G.type===1){W=!0;continue}if(G.type===0)return s.INSTANCE;if(G.type===6){M.push(...G.expr);continue}M.push(G)}if(M.length===0&&W)return o.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(n);for(let G=1;G<M.length;G++)M[G-1].equals(M[G])&&(M.splice(G,1),G--);if(M.length===1)return M[0];for(;M.length>1;){const G=M[M.length-1];if(G.type!==9)break;M.pop();const te=M.pop(),le=M.length===0,ue=T.create(G.expr.map($e=>X.create([$e,te],null,z)),null,le);ue&&(M.push(ue),M.sort(n))}if(M.length===1)return M[0];if(z){for(let G=0;G<M.length;G++)for(let te=G+1;te<M.length;te++)if(M[G].negate().equals(M[te]))return s.INSTANCE;if(M.length===1)return M[0]}return new X(M,P)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const P of this.expr)f.push(...P.keys());return f}map(f){return new X(this.expr.map(P=>P.map(f)),null)}negate(){if(!this.c){const f=[];for(const P of this.expr)f.push(P.negate());this.c=T.create(f,this,!0)}return this.c}}e.$tj=X;class T{static create(f,P,z){return T.d(f,P,z)}constructor(f,P){this.expr=f,this.c=P,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let P=0,z=this.expr.length;P<z;P++){const M=n(this.expr[P],f.expr[P]);if(M!==0)return M}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].equals(f.expr[P]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:T.create(f,this.c,!1)}evaluate(f){for(let P=0,z=this.expr.length;P<z;P++)if(this.expr[P].evaluate(f))return!0;return!1}static d(f,P,z){let M=[],W=!1;if(f){for(let G=0,te=f.length;G<te;G++){const le=f[G];if(le){if(le.type===0){W=!0;continue}if(le.type===1)return o.INSTANCE;if(le.type===9){M=M.concat(le.expr);continue}M.push(le)}}if(M.length===0&&W)return s.INSTANCE;M.sort(n)}if(M.length!==0){if(M.length===1)return M[0];for(let G=1;G<M.length;G++)M[G-1].equals(M[G])&&(M.splice(G,1),G--);if(M.length===1)return M[0];if(z){for(let G=0;G<M.length;G++)for(let te=G+1;te<M.length;te++)if(M[G].negate().equals(M[te]))return o.INSTANCE;if(M.length===1)return M[0]}return new T(M,P)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const P of this.expr)f.push(...P.keys());return f}map(f){return new T(this.expr.map(P=>P.map(f)),null)}negate(){if(!this.c){const f=[];for(const P of this.expr)f.push(P.negate());for(;f.length>1;){const P=f.shift(),z=f.shift(),M=[];for(const W of U(P))for(const G of U(z))M.push(X.create([W,G],null,!1));f.unshift(T.create(M,null,!1))}this.c=T.create(f,this,!0)}return this.c}}e.$uj=T;class C extends l{static{this.d=[]}static all(){return C.d.values()}constructor(f,P,z){super(f,null),this.f=P,typeof z=="object"?C.d.push({...z,key:f}):z!==!0&&C.d.push({key:f,description:z,type:P!=null?typeof P:void 0})}bindTo(f){return f.createKey(this.key,this.f)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return R.create(this.key,f)}notEqualsTo(f){return j.create(this.key,f)}}e.$vj=C,e.$wj=(0,N.$ei)("contextKeyService");function H(F,f){return F<f?-1:F>f?1:0}function K(F,f,P,z){return F<P?-1:F>P?1:f<z?-1:f>z?1:0}function Y(F,f){if(F.type===0||f.type===1)return!0;if(F.type===9)return f.type===9?_(F.expr,f.expr):!1;if(f.type===9){for(const P of f.expr)if(Y(F,P))return!0;return!1}if(F.type===6){if(f.type===6)return _(f.expr,F.expr);for(const P of F.expr)if(Y(P,f))return!0;return!1}return F.equals(f)}e.$xj=Y;function _(F,f){let P=0,z=0;for(;P<F.length&&z<f.length;){const M=F[P].cmp(f[z]);if(M<0)return!1;M===0&&P++,z++}return P===F.length}function U(F){return F.type===9?F.expr:[F]}}),define(ie[59],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,e.$po=(0,L.$ei)("downloadService")}),define(ie[18],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=void 0,e.$li=(0,L.$ei)("environmentService"),e.$mi=(0,L.$fi)(e.$li)}),define(ie[21],ne([0,1,95,10]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.ExtensionGalleryErrorCode=e.$Lo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ko=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0,e.$yo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$zo=new RegExp(e.$yo),e.$Ao="__web_extension",e.$Bo="skipWalkthrough",e.$Co="extensionsSync",e.$Do="dependecyOrPackExtensionInstall";function O($){switch($){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Eo=O;function N($){switch($){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Fo=N;function A($,u){switch($){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Go=A;function S($,u){return u==="web"&&!$.includes("web")}e.$Ho=S;function h($,u,g){return S(u,g)?!1:$==="undefined"||$==="universal"?!0:$==="unknown"?!1:$===g}e.$Io=h;function a($){return $&&typeof $=="object"&&typeof $.id=="string"&&(!$.uuid||typeof $.uuid=="string")}e.$Jo=a;var y;(function($){$[$.NoneOrRelevance=0]="NoneOrRelevance",$[$.LastUpdatedDate=1]="LastUpdatedDate",$[$.Title=2]="Title",$[$.PublisherName=3]="PublisherName",$[$.InstallCount=4]="InstallCount",$[$.PublishedDate=10]="PublishedDate",$[$.AverageRating=6]="AverageRating",$[$.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var E;(function($){$[$.Default=0]="Default",$[$.Ascending=1]="Ascending",$[$.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var d;(function($){$.Install="install",$.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var m;(function($){$[$.None=1]="None",$[$.Install=2]="Install",$[$.Update=3]="Update",$[$.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$Ko=(0,D.$ei)("extensionGalleryService");var w;(function($){$.Unsupported="Unsupported",$.Deprecated="Deprecated",$.Malicious="Malicious",$.Incompatible="Incompatible",$.IncompatibleTargetPlatform="IncompatibleTargetPlatform",$.ReleaseVersionNotFound="ReleaseVersionNotFound",$.Invalid="Invalid",$.Download="Download",$.DownloadSignature="DownloadSignature",$.UpdateMetadata="UpdateMetadata",$.Extract="Extract",$.Scanning="Scanning",$.Delete="Delete",$.Rename="Rename",$.CorruptZip="CorruptZip",$.IncompleteZip="IncompleteZip",$.Signature="Signature",$.NotAllowed="NotAllowed",$.Gallery="Gallery",$.Unknown="Unknown",$.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var k;(function($){$.UnknownError="UnknownError",$.PackageIsInvalidZip="PackageIsInvalidZip",$.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(k||(e.ExtensionSignaturetErrorCode=k={}));class b extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}e.$Lo=b;var c;(function($){$.Timeout="Timeout",$.Cancelled="Cancelled",$.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class p extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}e.$Mo=p,e.$No=(0,D.$ei)("extensionManagementService"),e.$Oo="extensionsIdentifiers/disabled",e.$Po="extensionsIdentifiers/enabled",e.$Qo=(0,D.$ei)("IGlobalExtensionEnablementService"),e.$Ro=(0,D.$ei)("IExtensionTipsService"),e.$So=(0,L.localize2)(0,"Extensions"),e.$To=(0,L.localize2)(1,"Preferences")}),define(ie[60],ne([0,1,14,7,103,13]),function(J,e,L,D,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;async function A(y,E,d,m,w,k){let b;try{await S(y,E,d,m,w,k)}catch(c){b=c}finally{b&&w.errorTransformer&&(b=w.errorTransformer(b)),typeof b<"u"&&d.error(b),d.end()}}e.$mq=A;async function S(y,E,d,m,w,k){h(k);const b=await y.open(E,{create:!1});try{h(k);let c=0,p=0,$=w&&typeof w.length=="number"?w.length:void 0,u=L.$se.alloc(Math.min(w.bufferSize,typeof $=="number"?$:w.bufferSize)),g=w&&typeof w.position=="number"?w.position:0,i=0;do p=await y.read(b,g,u.buffer,i,u.byteLength-i),g+=p,i+=p,c+=p,typeof $=="number"&&($-=p),i===u.byteLength&&(await d.write(m(u)),u=L.$se.alloc(Math.min(w.bufferSize,typeof $=="number"?$:w.bufferSize)),i=0);while(p>0&&(typeof $!="number"||$>0)&&h(k)&&a(c,w));if(i>0){let r=i;typeof $=="number"&&(r=Math.min(i,$)),d.write(m(u.slice(0,r)))}}catch(c){throw(0,N.$Pk)(c)}finally{await y.close(b)}}function h(y){if(y.isCancellationRequested)throw(0,D.$6)();return!0}function a(y,E){if(typeof E?.limits?.size=="number"&&y>E.limits.size)throw(0,N.$Ok)((0,O.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[121],ne([0,1,6,168,2,12,169]),function(J,e,L,D,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;class S extends O.$Tc{constructor(){super(...arguments),this.a=this.B(new L.$5d),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$5d),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(a){const y=this.j(a),E=y.filter(m=>{const w=this.c.get(m.path);return w?!(0,D.$2j)(w.request.excludes,m.excludes)||!(0,D.$2j)(w.request.includes,m.includes):!0}),d=Array.from(this.c.values()).filter(({request:m})=>!y.find(w=>w.path===m.path&&(0,D.$2j)(w.excludes,m.excludes)&&(0,D.$2j)(w.includes,m.includes))).map(({request:m})=>m.path);E.length&&this.m(`Request to start watching: ${E.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"}, correlationId: ${typeof m.correlationId=="number"?m.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const m of d)this.h(m);for(const m of E)this.g(m)}g(a){const y=new A.$Iq(a,d=>this.a.fire(d),d=>this.b.fire(d),this.f),E={request:a,instance:y};this.c.set(a.path,E)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const y=this.c.get(a);y&&(this.c.delete(a),y.instance.dispose())}j(a){const y=new Map;for(const E of a){const d=N.$k?E.path:E.path.toLowerCase();let m=y.get(E.correlationId);m||(m=new Map,y.set(E.correlationId,m)),m.set(d,E)}return Array.from(y.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,y]of this.c)y.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,y){return y?`[File Watcher (node.js)] ${a} (path: ${y.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$Kq=S}),define(ie[122],ne([0,1,61,121]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class O extends L.$qq{constructor(A,S,h){super(A,S,h),this.s()}r(A){return A.add(new D.$Kq)}}e.$Lq=O}),define(ie[123],ne([0,1,15,57,87,61]),function(J,e,L,D,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;class A extends N.$rq{constructor(h,a,y){super(h,a,y),this.s()}r(h){const a=h.add(new O.$Cq(L.$yg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(a.onDidProcessExit(({code:y,signal:E})=>this.t(`terminated by itself with code ${y}, signal: ${E}`))),D.ProxyChannel.toService((0,D.$Xh)(a.getChannel("watcher")))}}e.$Dq=A}),define(ie[62],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=void 0;class L{constructor(...O){this.a=new Map;for(const[N,A]of O)this.set(N,A)}set(O,N){const A=this.a.get(O);return this.a.set(O,N),A}has(O){return this.a.has(O)}get(O){return this.a.get(O)}}e.$ci=L}),define(ie[124],ne([0,1,9,7,2,51,119,10,62,170]),function(J,e,L,D,O,N,A,S,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=void 0;const y=!1;class E extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class d{constructor(b=new h.$ci,c=!1,p,$=y){this.f=b,this.g=c,this.h=p,this.i=$,this.o=new Set,this.f.set(S.$di,this),this._globalGraph=$?p?._globalGraph??new A.$Oq(u=>u):void 0}createChild(b){return new d(b,this.g,this,this.i)}invokeFunction(b,...c){const p=w.traceInvocation(this.i,b);let $=!1;try{return b({get:g=>{if($)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(g,p);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...c)}finally{$=!0,p.stop()}}createInstance(b,...c){let p,$;return b instanceof N.$bi?(p=w.traceCreation(this.i,b.ctor),$=this.j(b.ctor,b.staticArguments.concat(c),p)):(p=w.traceCreation(this.i,b),$=this.j(b,c,p)),p.stop(),$}j(b,c=[],p){const $=S._util.getServiceDependencies(b).sort((i,r)=>i.index-r.index),u=[];for(const i of $){const r=this.m(i.id,p);r||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${i.id}.`,!1),u.push(r)}const g=$.length>0?$[0].index:c.length;if(c.length!==g){console.trace(`[createInstance] First service dependency of ${b.name} at position ${g+1} conflicts with ${c.length} static arguments`);const i=g-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,g)}return Reflect.construct(b,c.concat(u))}k(b,c){if(this.f.get(b)instanceof N.$bi)this.f.set(b,c);else if(this.h)this.h.k(b,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const c=this.f.get(b);return!c&&this.h?this.h.l(b):c}m(b,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const p=this.l(b);return p instanceof N.$bi?this.q(b,p,c.branch(b,!0)):(c.branch(b,!1),p)}q(b,c,p){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,c,p)}finally{this.o.delete(b)}}r(b,c,p){const $=new A.$Oq(i=>i.id.toString());let u=0;const g=[{id:b,desc:c,_trace:p}];for(;g.length;){const i=g.pop();if($.lookupOrInsertNode(i),u++>1e3)throw new E($);for(const r of S._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${b} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof N.$bi){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};$.insertEdge(i,n),g.push(n)}}}for(;;){const i=$.roots();if(i.length===0){if(!$.isEmpty())throw new E($);break}for(const{data:r}of i){if(this.l(r.id)instanceof N.$bi){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}$.removeNode(r)}}return this.l(b)}s(b,c,p=[],$,u){if(this.f.get(b)instanceof N.$bi)return this.t(b,c,p,$,u);if(this.h)return this.h.s(b,c,p,$,u);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(b,c,p=[],$,u){if($){const g=new d(void 0,this.g,this,this.i);g.c=String(b);const i=new Map,r=new L.$xh(()=>{const t=g.j(c,p,u);for(const[n,s]of i){const o=t[n];if(typeof o=="function")for(const l of s)l.disposable=o.apply(t,l.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=i.get(n);return l||(l=new a.$4c,i.set(n,l)),(I,v,j)=>{if(r.isInitialized)return r.value[n](I,v,j);{const q={listener:[I,v,j],disposable:void 0},Q=l.push(q);return(0,O.$Rc)(()=>{Q(),q.disposable?.dispose()})}}}if(n in t)return t[n];const s=r.value;let o=s[n];return typeof o!="function"||(o=o.bind(s),t[n]=o),o},set(t,n,s){return r.value[n]=s,!0},getPrototypeOf(t){return c.prototype}})}else return this.j(c,p,u)}u(b,c){if(c&&console.warn(b),this.g)throw new Error(b)}}e.$Pq=d;var m;(function(k){k[k.None=0]="None",k[k.Creation=1]="Creation",k[k.Invocation=2]="Invocation",k[k.Branch=3]="Branch"})(m||(m={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(b,c){return b?new w(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(b,c){return b?new w(1,c.name):w.c}static{this.f=0}constructor(b,c){this.type=b,this.name=c,this.g=Date.now(),this.h=[]}branch(b,c){const p=new w(3,b.toString());return this.h.push([b,c,p]),p}stop(){const b=Date.now()-this.g;w.f+=b;let c=!1;function p(u,g){const i=[],r=new Array(u+1).join("	");for(const[t,n,s]of g.h)if(n&&s){c=!0,i.push(`${r}CREATES -> ${t}`);const o=p(u+1,s);o&&i.push(o)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(b>2||c)&&w.all.add($.join(`
`))}}e.$Qq=w});var se=this&&this.__param||function(J,e){return function(L,D){e(L,D,J)}};define(ie[63],ne([0,1,20,2,12,105,21,10]),function(J,e,L,D,O,N,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.$rr=void 0;function h(y){return y.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$rr=h,e.$sr=(0,S.$ei)("languagePackService");let a=class extends D.$Tc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new L.$ce;setTimeout(()=>E.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const w=d.firstPage.filter(k=>k.properties.localizedLanguages?.length&&k.tags.some(b=>b.startsWith("lp-"))).map(k=>{const b=k.properties.localizedLanguages?.[0],c=h(k);return{...this.f(c,b,k),extensionId:k.identifier.id,galleryExtension:k}});return w.push(this.f("en","English")),w}f(E,d,m){const w=d??E;let k;if(w!==E&&(k=`(${E})`),E.toLowerCase()===O.$w.toLowerCase()&&(k??="",k+=(0,N.localize)(0,null)),m?.installCount){k??="";const b=m.installCount;let c;b>1e6?c=`${Math.floor(b/1e5)/10}M`:b>1e3?c=`${Math.floor(b/1e3)}K`:c=String(b),k+=` $(cloud-download) ${c}`}return{id:E,label:w,description:k}}};e.$tr=a,e.$tr=a=me([se(0,A.$Ko)],a)}),define(ie[4],ne([0,1,34,6,43,2,31,12,17,3,11,120,10]),function(J,e,L,D,O,N,A,S,h,a,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.log=e.$Bj=e.LogLevel=e.$Aj=e.$zj=e.$yj=void 0,e.$yj=(0,d.$ei)("logService"),e.$zj=(0,d.$ei)("loggerService");function m(){return new Date().toISOString()}function w(I){return(0,a.$Wf)(I)}e.$Aj=w;var k;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(k||(e.LogLevel=k={})),e.$Bj=k.Info;function b(I,v,j){switch(v){case k.Trace:I.trace(j);break;case k.Debug:I.debug(j);break;case k.Info:I.info(j);break;case k.Warning:I.warn(j);break;case k.Error:I.error(j);break;case k.Off:break;default:throw new Error(`Invalid log level ${v}`)}}e.log=b;function c(I,v=!1){let j="";for(let q=0;q<I.length;q++){let Q=I[q];if(Q instanceof Error&&(Q=(0,L.$2i)(Q,v)),typeof Q=="object")try{Q=JSON.stringify(Q)}catch{}j+=(q>0?" ":"")+Q}return j}class p extends N.$Tc{constructor(){super(...arguments),this.b=e.$Bj,this.c=this.B(new D.$5d),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==k.Off&&this.b<=v}}e.$Dj=p;class $ extends p{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...j){this.f(k.Trace)&&this.g(k.Trace,c([v,...j],!0))}debug(v,...j){this.f(k.Debug)&&this.g(k.Debug,c([v,...j]))}info(v,...j){this.f(k.Info)&&this.g(k.Info,c([v,...j]))}warn(v,...j){this.f(k.Warning)&&this.g(k.Warning,c([v,...j]))}error(v,...j){if(this.f(k.Error))if(v instanceof Error){const q=Array.prototype.slice.call(arguments);q[0]=v.stack,this.g(k.Error,c(q))}else this.g(k.Error,c([v,...j]))}flush(){}}e.$Ej=$;class u extends p{constructor(v=e.$Bj){super(),this.setLevel(v),this.g=!S.$i}trace(v,...j){this.f(k.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,v,...j):console.log(`[main ${m()}]`,v,...j))}debug(v,...j){this.f(k.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,v,...j):console.log(`[main ${m()}]`,v,...j))}info(v,...j){this.f(k.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,v,...j):console.log(`[main ${m()}]`,v,...j))}warn(v,...j){this.f(k.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,v,...j):console.warn(`[main ${m()}]`,v,...j))}error(v,...j){this.f(k.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,v,...j):console.error(`[main ${m()}]`,v,...j))}flush(){}}e.$Fj=u;class g extends p{constructor(v=e.$Bj,j=!0){super(),this.g=j,this.setLevel(v)}trace(v,...j){this.f(k.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...j):console.log(v,...j))}debug(v,...j){this.f(k.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...j):console.log(v,...j))}info(v,...j){this.f(k.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...j):console.log(v,...j))}warn(v,...j){this.f(k.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...j):console.log(v,...j))}error(v,...j){this.f(k.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...j):console.error(v,...j))}flush(){}}e.$Gj=g;class i extends p{constructor(v,j=e.$Bj){super(),this.g=v,this.setLevel(j)}trace(v,...j){this.f(k.Trace)&&this.g.log(k.Trace,[this.h(v),...j])}debug(v,...j){this.f(k.Debug)&&this.g.log(k.Debug,[this.h(v),...j])}info(v,...j){this.f(k.Info)&&this.g.log(k.Info,[this.h(v),...j])}warn(v,...j){this.f(k.Warning)&&this.g.log(k.Warning,[this.h(v),...j])}error(v,...j){this.f(k.Error)&&this.g.log(k.Error,[this.h(v),...j])}h(v){return typeof v=="string"?v:(0,L.$2i)(v,this.f(k.Trace))}flush(){}}e.$Hj=i;class r extends p{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const j of this.g)j.setLevel(v);super.setLevel(v)}trace(v,...j){for(const q of this.g)q.trace(v,...j)}debug(v,...j){for(const q of this.g)q.debug(v,...j)}info(v,...j){for(const q of this.g)q.info(v,...j)}warn(v,...j){for(const q of this.g)q.warn(v,...j)}error(v,...j){for(const q of this.g)q.error(v,...j)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$Ij=r;class t extends N.$Tc{constructor(v,j,q){if(super(),this.h=v,this.j=j,this.b=new A.$Ac,this.c=this.B(new D.$5d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$5d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$5d),this.onDidChangeVisibility=this.g.event,q)for(const Q of q)this.b.set(Q.resource,{logger:void 0,info:Q})}m(v){return(0,a.$Sf)(v)?[...this.b.values()].find(j=>j.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,j){const q=this.n(v),Q=(0,a.$Sf)(v)?v:j?.id??(0,O.$5i)(q.toString()).toString(16);let Z=this.b.get(q)?.logger;const oe=j?.logLevel==="always"?k.Trace:j?.logLevel;Z||(Z=this.s(q,oe??this.getLogLevel(q)??this.h,{...j,id:Q}));const re={logger:Z,info:{resource:q,id:Q,logLevel:oe,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(re.info),this.b.set(q,re),Z}n(v){return(0,a.$Sf)(v)?(0,h.$Rg)(this.j,`${v}.log`):v}setLogLevel(v,j){if(y.URI.isUri(v)){const q=v,Q=j,Z=this.b.get(q);Z&&Q!==Z.info.logLevel&&(Z.info.logLevel=Q===this.h?void 0:Q,Z.logger?.setLevel(Q),this.b.set(Z.info.resource,Z),this.f.fire([q,Q]))}else{this.h=v;for(const[q,Q]of this.b.entries())this.b.get(q)?.info.logLevel===void 0&&Q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,j){const q=this.m(v);q&&j!==!q.info.hidden&&(q.info.hidden=!j,this.b.set(q.info.resource,q),this.g.fire([q.info.resource,j]))}getLogLevel(v){let j;return v&&(j=this.b.get(v)?.info.logLevel),j??this.h}registerLogger(v){const j=this.b.get(v.resource);j?j.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const j=this.b.get(v);j&&(j.logger&&j.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Jj=t;class n{constructor(){this.onDidChangeLogLevel=new D.$5d().event}setLevel(v){}getLevel(){return k.Info}trace(v,...j){}debug(v,...j){}info(v,...j){}warn(v,...j){}error(v,...j){}critical(v,...j){}dispose(){}flush(){}}e.$Kj=n;class s extends n{}e.$Lj=s;function o(I){if(I.verbose)return k.Trace;if(typeof I.logLevel=="string"){const v=R(I.logLevel.toLowerCase());if(v!==void 0)return v}return e.$Bj}e.$Mj=o;function l(I){switch(I){case k.Trace:return"trace";case k.Debug:return"debug";case k.Info:return"info";case k.Warning:return"warn";case k.Error:return"error";case k.Off:return"off"}}e.$Nj=l;function R(I){switch(I){case"trace":return k.Trace;case"debug":return k.Debug;case"info":return k.Info;case"warn":return k.Warning;case"error":return k.Error;case"critical":return k.Error;case"off":return k.Off}}e.$Oj=R,e.$Pj=new E.$vj("logLevel",l(k.Info))}),define(ie[64],ne([0,1,7,10,4]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0,e.$Qp=(0,D.$ei)("IExtensionSignatureVerificationService");let N=class{constructor(S){this.b=S}c(){return this.a||(this.a=new Promise((S,h)=>J(["node-vsce-sign"],async a=>S(a),h))),this.a}async verify(S,h,a){let y;try{y=await this.c()}catch(E){return this.b.error("Could not load vsce-sign module",(0,L.$0)(E)),!1}return y.verify(S,h,a)}};e.$Rp=N,e.$Rp=N=me([se(0,O.$yj)],N)}),define(ie[125],ne([0,1,19,9,7,6,2,16,61,4]),function(J,e,L,D,O,N,A,S,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=void 0;class y extends A.$Tc{constructor(d,m){super(),this.a=d,this.b=m,this.c=this.B(new N.$5d),this.onDidChangeFile=this.c.event,this.g=this.B(new N.$5d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$ch(0)),this.w=[],this.y=this.B(new D.$ch(0))}watch(d,m){return m.recursive||this.b?.watcher?.forceUniversal?this.n(d,m):this.z(d,m)}n(d,m){const w={path:this.H(d),excludes:m.excludes,includes:m.includes,recursive:m.recursive,correlationId:m.correlationId},k=(0,L.$Ub)(this.j,w);return this.r(),(0,A.$Rc)(()=>{k(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,O.$1)(d))}s(){this.h||(this.h=this.B(this.t(m=>this.c.fire((0,h.$sq)(m)),m=>this.G(m),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const m of this.j)(0,h.$oq)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const m of this.j)(0,h.$oq)(m)&&d.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,m){const w={path:this.H(d),excludes:m.excludes,includes:m.includes,recursive:!1,correlationId:m.correlationId},k=(0,L.$Ub)(this.w,w);return this.C(),(0,A.$Rc)(()=>{k(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,O.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,h.$sq)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,S.$hc)(d.fsPath)}}e.$wq=y}),define(ie[126],ne([0,1,19,9,14,20,6,43,65,2,48,15,127,17,46,102,13,60,4,7]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m,w,k,b,c,p,$){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;let g=class extends a.$Tc{static{u=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new A.$5d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$5d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$5d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$5d),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$5d),this.Y=this.B(new A.$5d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$5d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$nh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${r}`);const n=new a.$Sc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),n.add(t.onDidChangeFile(s=>{const o=new b.$Uk(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Oc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(n){t.push(n)}}),!this.h.has(r)&&await D.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return h.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,m.$Vg)(r))throw new b.$Wk((0,k.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const n=new $.$bb;throw n.message=(0,k.localize)(1,null,r.toString()),n}return t}async m(r){const t=await this.j(r);if((0,b.$Hk)(t)||(0,b.$Ek)(t)||(0,b.$Ik)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,b.$Hk)(t)||(0,b.$Ek)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(n){throw(0,b.$Rk)(n)===b.FileSystemProviderErrorCode.FileNotFound?new b.$Wk((0,k.localize)(2,null,this.sb(r)),1):(0,b.$Pk)(n)}}async s(r,t){const n=await this.j(r),s=this.S(n),o=t?.resolveTo,l=t?.resolveSingleChildDescendants,R=t?.resolveMetadata,I=await n.stat(r);let v;return this.t(n,r,I,void 0,!!R,(j,q)=>(v||(v=y.$ki.forUris(()=>!s),v.set(r,!0),o&&v.fill(!0,o)),v.get(j.resource)||v.findSuperstr(j.resource.with({query:null,fragment:null}))?!0:j.isDirectory&&l?q===1:!1))}async t(r,t,n,s,o,l){const{providerExtUri:R}=this.R(r),I={resource:t,name:R.basename(t),isFile:(n.type&b.FileType.File)!==0,isDirectory:(n.type&b.FileType.Directory)!==0,isSymbolicLink:(n.type&b.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&b.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&b.FilePermission.Locked),etag:(0,b.$8k)({mtime:n.mtime,size:n.size}),children:void 0};if(I.isDirectory&&l(I,s)){try{const v=await r.readdir(t),j=await D.Promises.settled(v.map(async([q,Q])=>{try{const Z=R.joinPath(t,q),oe=o?await r.stat(Z):{type:Q};return await this.t(r,Z,oe,v.length,o,l)}catch(Z){return this.b.trace(Z),null}}));I.children=(0,L.$Hb)(j)}catch(v){this.b.trace(v),I.children=[]}return I}return I}async resolveAll(r){return D.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),n=await t.stat(r);return this.t(t,r,n,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(n){return n}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new b.$Wk((0,k.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=O.$se.fromString(""),n){await this.u(r,n);const s=await this.writeFile(r,t);return this.r.fire(new b.$Tk(r,0,s)),s}async writeFile(r,t,n){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let l=n;if((0,b.$Kk)(s)&&!l?.atomic){const R=s.enforceAtomicWriteFile?.(r);R&&(l={...n,atomic:R})}try{await this.w(s,r,l)||await this.U(s,o.dirname(r));let I;if((0,b.$Ek)(s)&&!(t instanceof O.$se))if((0,w.$ee)(t)){const v=await(0,w.$le)(t,3);v.ended?I=O.$se.concat(v.buffer):I=v}else I=(0,w.$ie)(t,v=>O.$se.concat(v),3);else I=t;!(0,b.$Hk)(s)||(0,b.$Ek)(s)&&I instanceof O.$se||(0,b.$Ek)(s)&&(0,b.$Kk)(s)&&l?.atomic?await this.hb(s,r,l,I):await this.db(s,r,l,I instanceof O.$se?(0,O.$De)(I):I),this.r.fire(new b.$Tk(r,4))}catch(R){throw new b.$Wk((0,k.localize)(4,null,this.sb(r),(0,b.$Pk)(R).toString()),(0,b.$Sk)(R),l)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,n){const s=!!n?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,k.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,k.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,k.localize)(7,null,this.sb(t)));if(s)throw new Error((0,k.localize)(8,null,this.sb(t)))}let l;try{l=await r.stat(t)}catch{return}if(l.type&b.FileType.Directory)throw new b.$Wk((0,k.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,l),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==b.$7k&&typeof l.mtime=="number"&&typeof l.size=="number"&&n.mtime<l.mtime&&n.etag!==(0,b.$8k)({mtime:n.mtime,size:l.size}))throw new b.$Wk((0,k.localize)(10,null),3,n);return l}async readFile(r,t,n){const s=await this.m(r);return t?.atomic?this.z(s,r,t,n):this.C(s,r,t,n)}async z(r,t,n,s){return new Promise((o,l)=>{this.cb.queueFor(t,async()=>{try{const R=await this.C(r,t,n,s);o(R)}catch(R){l(R)}},this.R(r).providerExtUri)})}async C(r,t,n,s){const o=await this.D(r,t,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,O.$Ee)(o.value)}}async readFileStream(r,t,n){const s=await this.m(r);return this.D(s,r,t,n)}async D(r,t,n,s){const o=new N.$ce(s);let l=n;(0,b.$Jk)(r)&&r.enforceAtomicReadFile?.(t)&&(l={...n,atomic:!0});const R=this.J(t,l).then(v=>v,v=>{throw o.dispose(!0),v});let I;try{return typeof l?.etag=="string"&&l.etag!==b.$7k&&await R,l?.atomic&&(0,b.$Jk)(r)||!((0,b.$Hk)(r)||(0,b.$Ik)(r))||(0,b.$Ek)(r)&&l?.preferUnbuffered?I=this.I(r,t,l):(0,b.$Ik)(r)?I=this.G(r,t,o.token,l):I=this.H(r,t,o.token,l),I.on("end",()=>o.dispose()),I.on("error",()=>o.dispose()),{...await R,value:I}}catch(v){throw I&&await(0,w.$je)(I),this.F(v,t,l)}}F(r,t,n){const s=(0,k.localize)(11,null,this.sb(t),(0,b.$Pk)(r).toString());return r instanceof b.$Yk?new b.$Yk(s,r.stat,n):r instanceof b.$Xk?new b.$Xk(s,r.fileOperationResult,r.size,r.options):new b.$Wk(s,(0,b.$Sk)(r),n)}G(r,t,n,s=Object.create(null)){const o=r.readFileStream(t,s,n);return(0,w.$pe)(o,{data:l=>l instanceof O.$se?l:O.$se.wrap(l),error:l=>this.F(l,t,s)},l=>O.$se.concat(l))}H(r,t,n,s=Object.create(null)){const o=(0,O.$Ie)();return(0,c.$mq)(r,t,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.F(l,t,s)},n),o}I(r,t,n){const s=(0,w.$ge)(o=>O.$se.concat(o));return(async()=>{try{let o;n?.atomic&&(0,b.$Jk)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(t,o.byteLength,n),s.end(O.$se.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new b.$Wk((0,k.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==b.$7k&&t.etag===n.etag)throw new b.$Yk((0,k.localize)(13,null),n,t);return this.L(r,n.size,t),n}L(r,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new b.$Xk((0,k.localize)(14,null,this.sb(r)),7,t,n)}async canMove(r,t,n){return this.M(r,t,"move",n)}async canCopy(r,t,n){return this.M(r,t,"copy",n)}async M(r,t,n,s){if(r.toString()!==t.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),l=this.qb(await this.n(t),t);await this.Q(o,r,l,t,n,s)}catch(o){return o}return!0}async move(r,t,n){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"move",!!n),R=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new b.$Tk(r,l==="move"?2:3,R)),R}async copy(r,t,n){const s=await this.m(r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"copy",!!n),R=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new b.$Tk(r,l==="copy"?3:2,R)),R}async N(r,t,n,s,o,l){if(t.toString()===s.toString())return o;const{exists:R,isSameResourceWithDifferentPathCase:I}=await this.Q(r,t,n,s,o,l);if(R&&!I&&l&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),o==="copy"){if(r===n&&(0,b.$Fk)(r))await r.copy(t,s,{overwrite:l});else{const v=await this.resolve(t);v.isDirectory?await this.P(r,v,n,s):await this.O(r,t,n,s)}return o}else return r===n?(await r.rename(t,s,{overwrite:l}),o):(await this.N(r,t,n,s,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(r,t,n,s){if((0,b.$Hk)(r)&&(0,b.$Hk)(n))return this.jb(r,t,n,s);if((0,b.$Hk)(r)&&(0,b.$Ek)(n))return this.pb(r,t,n,s);if((0,b.$Ek)(r)&&(0,b.$Hk)(n))return this.nb(r,t,n,s);if((0,b.$Ek)(r)&&(0,b.$Ek)(n))return this.lb(r,t,n,s)}async P(r,t,n,s){await n.mkdir(s),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async o=>{const l=this.R(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,l):this.O(r,o.resource,n,l)}))}async Q(r,t,n,s,o,l){let R=!1;if(r===n){const{providerExtUri:v,isPathCaseSensitive:j}=this.R(r);if(j||(R=v.isEqual(t,s)),R&&o==="copy")throw new Error((0,k.localize)(15,null,this.sb(t),this.sb(s)));if(!R&&v.isEqualOrParent(s,t))throw new Error((0,k.localize)(16,null,this.sb(t),this.sb(s)))}const I=await this.exists(s);if(I&&!R){if(!l)throw new b.$Wk((0,k.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===n){const{providerExtUri:v}=this.R(r);if(v.isEqualOrParent(t,s))throw new Error((0,k.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:R}}R(r){const t=this.S(r);return{providerExtUri:t?m.$Hg:m.$Jg,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$Tk(r,0,n)),n}async U(r,t){const n=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&b.FileType.Directory))throw new Error((0,k.localize)(19,null,this.sb(t)));break}catch(o){if((0,b.$Rk)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(t)),t=s.dirname(t)}for(let o=n.length-1;o>=0;o--){t=s.joinPath(t,n[o]);try{await r.mkdir(t)}catch(l){if((0,b.$Rk)(l)!==b.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,t){try{await this.W(r,t)}catch(n){return n}return!0}async W(r,t){const n=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,k.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,k.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,k.localize)(22,null,this.sb(r)));let l;try{l=await n.stat(r)}catch{}if(l)this.rb(r,l);else throw new b.$Wk((0,k.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const I=await this.resolve(r);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,k.localize)(24,null,this.sb(r)))}return n}async del(r,t){const n=await this.W(r,t);let s=t;if((0,b.$Lk)(n)&&!s?.atomic){const I=n.enforceAtomicDelete?.(r);I&&(s={...t,atomic:I})}const o=!!s?.useTrash,l=!!s?.recursive,R=s?.atomic??!1;await n.delete(r,{recursive:l,useTrash:o,atomic:R}),this.r.fire(new b.$Tk(r,1))}async cloneFile(r,t){const n=await this.j(r),s=this.qb(await this.n(t),t);if(!(n===s&&this.R(n).providerExtUri.isEqual(r,t)))return n===s&&(0,b.$Gk)(n)?n.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),n===s&&(0,b.$Fk)(n)?this.cb.queueFor(r,()=>n.copy(r,t,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,s,t),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:u.ab++})}watch(r,t={recursive:!1,excludes:[]}){const n=new a.$Sc;let s=!1,o=()=>{s=!0};n.add((0,a.$Rc)(()=>o())),(async()=>{try{const R=await this.bb(r,t);s?(0,a.$Oc)(R):o=()=>(0,a.$Oc)(R)}catch(R){this.b.error(R)}})();const l=t.correlationId;if(typeof l=="number"){const R=n.add(new A.$5d);return n.add(this.X.event(v=>{v.correlates(l)&&R.fire(v)})),{onDidChange:R.event,dispose:()=>n.dispose()}}return n}async bb(r,t){const n=await this.j(r),s=(0,S.$5i)([this.R(n).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:n.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Rc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Oc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Oc)(r.disposable);this.$.clear()}async db(r,t,n,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,w.$ee)(s)||(0,w.$fe)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(l){throw(0,b.$Pk)(l)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,n){let s=0,o;if((0,w.$fe)(n)){if(n.buffer.length>0){const l=O.$se.concat(n.buffer);await this.gb(r,t,l,l.byteLength,s,0),s+=l.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((l,R)=>{(0,w.$ke)(o,{onData:async I=>{o.pause();try{await this.gb(r,t,I,I.byteLength,s,0)}catch(v){return R(v)}s+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>R(I),onEnd:()=>l()})})}async fb(r,t,n){let s=0,o;for(;(o=n.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,n,s,o,l){let R=0;for(;R<s;){const I=await r.write(t,o+R,n.buffer,l+R,s-R);R+=I}}async hb(r,t,n,s){return this.cb.queueFor(t,()=>this.ib(r,t,n,s),this.R(r).providerExtUri)}async ib(r,t,n,s){let o;s instanceof O.$se?o=s:(0,w.$ee)(s)?o=await(0,O.$Ee)(s):(0,w.$fe)(s)?o=await(0,O.$Fe)(s):o=(0,O.$Ce)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,t,n,s){return this.cb.queueFor(s,()=>this.kb(r,t,n,s),this.R(n).providerExtUri)}async kb(r,t,n,s){let o,l;try{o=await r.open(t,{create:!1}),l=await n.open(s,{create:!0,unlock:!1});const R=O.$se.alloc(this.a);let I=0,v=0,j=0;do j=await r.read(o,I,R.buffer,v,R.byteLength-v),await this.gb(n,l,R,j,I,v),I+=j,v+=j,v===R.byteLength&&(v=0);while(j>0)}catch(R){throw(0,b.$Pk)(R)}finally{await D.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async lb(r,t,n,s){return this.cb.queueFor(s,()=>this.mb(r,t,n,s),this.R(n).providerExtUri)}async mb(r,t,n,s){return n.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,n,s){return this.cb.queueFor(s,()=>this.ob(r,t,n,s),this.R(n).providerExtUri)}async ob(r,t,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const l=await r.readFile(t);await this.gb(n,o,O.$se.wrap(l),l.byteLength,0,0)}catch(l){throw(0,b.$Pk)(l)}finally{await n.close(o)}}async pb(r,t,n,s){const o=await(0,O.$Ee)(this.H(r,t,N.CancellationToken.None));await this.hb(n,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new b.$Wk((0,k.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&b.FilePermission.Readonly)throw new b.$Wk((0,k.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===E.Schemas.file?r.fsPath:r.toString(!0)}};e.$nq=g,e.$nq=g=u=me([se(0,p.$yj)],g)}),define(ie[128],ne([0,1,90,171,9,31,14,6,172,2,16,12,17,46,24,104,13,60,125,34,123,122]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m,w,k,b,c,p,$,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(r){console.error(`Error enabling graceful-fs: ${(0,$.$2i)(r)}`)}})();class i extends p.$wq{static{this.I=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=S.Event.None,this.N=new N.$Ac(s=>d.$Ig.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:n,symbolicLink:s}=await w.SymlinkSupport.stat(this.H(t));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:b.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await w.Promises.readdir(this.H(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,d.$Rg)(t,o.name))).type:l=this.M(o),s.push([o.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.fb(n)}}M(t,n){let s;return n?.dangling?s=b.FileType.Unknown:t.isFile()?s=b.FileType.File:t.isDirectory()?s=b.FileType.Directory:s=b.FileType.Unknown,n&&(s|=b.FileType.SymbolicLink),s}async O(t){const n=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new O.$dh;return this.N.set(t,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(t)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),s=await this.O(t));const o=this.H(t);return await w.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{s?.dispose()}}P(t){i.I&&this.a.trace(t)}readFileStream(t,n,s){const o=(0,m.$ge)(l=>A.$se.concat(l.map(R=>A.$se.wrap(R))).buffer);return(0,c.$mq)(this,t,o,l=>l.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(t,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$Rg)((0,d.$Qg)(t),`${(0,d.$Og)(t)}${s.atomic.postfix}`),n,s):this.S(t,n,s)}async Q(t){try{const n=this.H(t),{symbolicLink:s}=await w.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async R(t,n,s,o){const l=new a.$Sc;try{l.add(await this.O(t)),l.add(await this.O(n)),await this.S(n,s,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(R){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw R}}finally{l.dispose()}}async S(t,n,s,o){let l;try{const R=this.H(t);if(!s.create||!s.overwrite){if(await w.Promises.exists(R)){if(!s.overwrite)throw(0,b.$Ok)((0,k.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,b.$Ok)((0,k.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(l,0,n,0,n.byteLength)}catch(R){throw await this.gb(t,R)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){i.Y=t}async open(t,n,s){const o=this.H(t);let l;(0,b.$Ck)(n)&&!s&&(l=await this.O(t));let R;try{if((0,b.$Ck)(n)&&n.unlock)try{const{stat:v}=await w.SymlinkSupport.stat(o);v.mode&128||await w.Promises.chmod(o,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let I;if((0,b.$Ck)(n)){if(E.$i)try{await w.Promises.truncate(o,0),I="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}I||(I="w")}else I="r";R=await w.Promises.open(o,I)}catch(I){throw l?.dispose(),(0,b.$Ck)(n)?await this.gb(t,I):this.fb(I)}if(this.U.set(R,0),(0,b.$Ck)(n)&&this.X.set(R,t),l){const I=this.W.get(R);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${R} (${o})`),this.W.set(R,l),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${R} (${o})`),I.dispose())}return R}async close(t){const n=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&i.Y)try{await w.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await w.Promises.close(t)}catch(s){throw this.fb(s)}finally{n&&(this.W.get(t)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,o,l){const R=this.Z(t,n);let I=null;try{I=(await w.Promises.read(t,s,o,l,R)).bytesRead}catch(v){throw this.fb(v)}finally{this.$(t,R,I)}return I}Z(t,n){return n===this.U.get(t)?null:n}$(t,n,s){const o=this.U.get(t);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.U.set(t,o+s):this.U.delete(t)))}async write(t,n,s,o,l){return(0,O.$yh)(()=>this.ab(t,n,s,o,l),100,3)}async ab(t,n,s,o,l){const R=this.Z(t,n);let I=null;try{I=(await w.Promises.write(t,s,o,l,R)).bytesWritten}catch(v){throw await this.gb(this.X.get(t),v)}finally{this.$(t,R,I)}return I}async mkdir(t){try{await w.Promises.mkdir(this.H(t))}catch(n){throw this.fb(n)}}async delete(t,n){try{const s=this.H(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,y.$jc)((0,y.$mc)(s),`${(0,y.$nc)(s)}${n.atomic.postfix}`)),await w.Promises.rm(s,w.RimRafMode.MOVE,o)}else try{await w.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:R,symbolicLink:I}=await w.SymlinkSupport.stat(s);l=R.isDirectory()&&!I}catch{}if(l)await w.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.fb(s)}}async rename(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"move",s.overwrite),await w.Promises.rename(o,l)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,k.localize)(2,null,(0,y.$nc)(o),(0,y.$nc)((0,y.$mc)(l)),R.toString()))),this.fb(R)}}async copy(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"copy",s.overwrite),await w.Promises.copy(o,l,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,k.localize)(3,null,(0,y.$nc)(o),(0,y.$nc)((0,y.$mc)(l)),R.toString()))),this.fb(R)}}async bb(t,n,s,o){const l=this.H(t),R=this.H(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,h.$eg)(l,R,!0)),I){if(s==="copy")throw(0,b.$Ok)((0,k.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const j=await this.L(t);if(!j)throw(0,b.$Ok)((0,k.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const q=await this.L(n);if(q){if(!o)throw(0,b.$Ok)((0,k.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);j.type&b.FileType.File&&q.type&b.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.cb(t,n,!1)}async cb(t,n,s){const o=this.H(t),l=this.H(n),R=!!(this.capabilities&1024);if((0,h.$eg)(o,l,!R))return;const I=new a.$Sc;try{I.add(await this.O(t)),I.add(await this.O(n)),s&&await w.Promises.mkdir((0,y.$mc)(l),{recursive:!0}),await w.Promises.copyFile(o,l)}catch(v){if(v.code==="ENOENT"&&!s)return this.cb(t,n,!0);throw this.fb(v)}finally{I.dispose()}}t(t,n,s){return new u.$Dq(o=>t(o),o=>n(o),s)}F(t,n,s){return new g.$Lq(o=>t(o),o=>n(o),s)}fb(t){if(t instanceof b.$Nk)return t;let n=t,s;switch(t.code){case"ENOENT":s=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=b.FileSystemProviderErrorCode.Unknown;break;default:s=b.FileSystemProviderErrorCode.Unknown}return(0,b.$Ok)(n,s)}async gb(t,n){let s=this.fb(n);if(t&&s.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await w.SymlinkSupport.stat(this.H(t));o.mode&128||(s=(0,b.$Ok)(n,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$Mq=i}),define(ie[129],ne([0,1,2,4]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=void 0;class O extends L.$Tc{constructor(A,S=[]){super(),this.a=new D.$Ij([A,...S]),this.B(A.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...S){this.a.trace(A,...S)}debug(A,...S){this.a.debug(A,...S)}info(A,...S){this.a.info(A,...S)}warn(A,...S){this.a.warn(A,...S)}error(A,...S){this.a.error(A,...S)}flush(){this.a.flush()}}e.$AP=O}),define(ie[130],ne([0,1,13,4]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=void 0;var O;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(O||(O={}));async function N(a,y,E,d,m){try{const w=await new Promise((b,c)=>{J(["@vscode/spdlog"],b,c)});w.setFlushOn(O.Trace);const k=await w.createAsyncRotatingLogger(a,y,E,d);return m?k.clearFormatters():k.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),k}catch(w){console.error(w)}return null}function A(a,y,E){switch(y){case D.LogLevel.Trace:a.trace(E);break;case D.LogLevel.Debug:a.debug(E);break;case D.LogLevel.Info:a.info(E);break;case D.LogLevel.Warning:a.warn(E);break;case D.LogLevel.Error:a.error(E);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function S(a,y){switch(y){case D.LogLevel.Trace:a.setLevel(O.Trace);break;case D.LogLevel.Debug:a.setLevel(O.Debug);break;case D.LogLevel.Info:a.setLevel(O.Info);break;case D.LogLevel.Warning:a.setLevel(O.Warning);break;case D.LogLevel.Error:a.setLevel(O.Error);break;case D.LogLevel.Off:a.setLevel(O.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class h extends D.$Ej{constructor(y,E,d,m,w){super(),this.m=[],this.setLevel(w),this.n=this.s(y,E,d,m),this.B(this.onDidChangeLogLevel(k=>{this.r&&S(this.r,k)}))}async s(y,E,d,m){const w=d?6:1,k=30/w*L.$0k.MB,b=await N(y,E,k,w,m);if(b){this.r=b,S(this.r,this.getLevel());for(const{level:c,message:p}of this.m)A(this.r,c,p);this.m=[]}}g(y,E){this.r?A(this.r,y,E):this.getLevel()<=y&&this.m.push({level:y,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$pP=h}),define(ie[131],ne([0,1,28,4,130]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=void 0;class N extends D.$Jj{s(S,h,a){return new O.$pP((0,L.$Ag)(),S.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,h)}}e.$qP=N}),define(ie[39],ne([0,1,6,65,2,10]),function(J,e,L,D,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=e.$Wn=e.$Vn=void 0,e.$Vn=(0,N.$ei)("policy");class A extends O.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$5d),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const y=Object.keys(this.f).length;return this.f={...a,...this.f},y!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(E,[d,m])=>({...E,[d]:m}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[y,E])=>({...a,[y]:{definition:E,value:this.g.get(y)}}),{})}}e.$Wn=A;class S{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Xn=S}),define(ie[132],ne([0,1,9,6,65,3,13,4,39]),function(J,e,L,D,O,N,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;function a(E,d){const m=[];for(const w of new Set(O.Iterable.concat(E.keys(),d.keys())))E.get(w)!==d.get(w)&&m.push(w);return m}let y=class extends h.$Wn{constructor(d,m,w){super(),this.m=d,this.n=m,this.s=w,this.c=this.B(new L.$ch(500));const k=D.Event.filter(m.onDidFilesChange,b=>b.affects(d));this.B(m.watch(d)),this.B(k(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const m=await this.n.readFile(this.m),w=JSON.parse(m.value.toString());if(!(0,N.$Uf)(w))throw new Error("Policy file isn't a JSON object");for(const k of Object.keys(w))this.f[k]&&d.set(k,w[k])}catch(m){m.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",m)}return d}async w(){const d=await this.u(),m=a(this.g,d);this.g=d,m.length>0&&this.h.fire(m)}};e.$oac=y,e.$oac=y=me([se(1,A.$Bk),se(2,S.$yj)],y)}),define(ie[133],ne([0,1,39,9,2,4]),function(J,e,L,D,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=void 0;let A=class extends L.$Wn{constructor(h,a){super(),this.m=h,this.n=a,this.a=new D.$$g,this.b=this.B(new O.$Uc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:a}=await new Promise((y,E)=>{J(["@vscode/policy-watcher"],y,E)});await this.a.queue(()=>new Promise((y,E)=>{try{this.b.value=a(this.n,h,d=>{this.t(d),y()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),E(d)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const a in h){const y=h[a];y===void 0?this.g.delete(a):this.g.set(a,y)}this.h.fire(Object.keys(h))}};e.$nac=A,e.$nac=A=me([se(0,N.$yj)],A)}),define(ie[32],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=void 0,e.$Qj=(0,L.$ei)("productService"),e.$Rj="vscode://schemas/vscode-product"}),define(ie[36],ne([0,1,71,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=void 0;class O{constructor(){this.a=new Map}add(A,S){L.ok(D.$Sf(A)),L.ok(D.$Uf(S)),L.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,S)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Tn=new O}),define(ie[134],ne([0,1,6,36]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=void 0,e.$Un={JSONContribution:"base.contributions.json"};function O(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class N{constructor(){this.b=new L.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,a){this.a[O(h)]=a,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;D.$Tn.add(e.$Un.JSONContribution,A)}),define(ie[40],ne([0,1,19,6,3,91,29,134,36]),function(J,e,L,D,O,N,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ConfigurationScope=e.$Yn=e.EditPresentationTypes=void 0;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$Yn={Configuration:"base.contributions.configuration"};var y;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$Zn={properties:{},patternProperties:{}},e.$1n={properties:{},patternProperties:{}},e.$2n={properties:{},patternProperties:{}},e.$3n={properties:{},patternProperties:{}},e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n="vscode://schemas/settings/resourceLanguage",e.$7n="vscode://schemas/settings/configurationDefaults";const E=h.$Tn.as(S.$Un.JSONContribution);class d{constructor(){this.h=new Set,this.i=new D.$5d,this.onDidSchemaChange=this.i.event,this.j=new D.$5d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$6n,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),E.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),E.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),E.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const o in n)if(r.add(o),e.$9n.test(o)){const l=this.a.get(o),R=l?.valuesSources??new Map;if(s)for(const q of Object.keys(n[o]))R.set(q,s);const I={...l?.value||{},...n[o]};this.a.set(o,{source:s,value:I,valuesSources:R});const v=(0,A.$Ui)(o),j={type:"object",default:I,description:N.localize(1,null,v),$ref:e.$6n,defaultDefaultValue:I,source:O.$Sf(s)?void 0:s,defaultValueSource:s};t.push(...k(o)),this.d[o]=j,this.b.properties[o]=j}else{this.a.set(o,{value:n[o],source:s});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const o=this.a.get(s),l=O.$Sf(n)?n:n?.id,R=O.$Sf(o?.source)?o?.source:o?.source?.id;if(l===R)if(r.add(s),this.a.delete(s),e.$9n.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,o){s=O.$2f(i.scope)?s:i.scope;const l=i.properties;if(l)for(const I in l){const v=l[I];if(r&&$(I,v)){delete l[I];continue}if(v.source=t,v.defaultDefaultValue=l[I].default,this.w(I,v),e.$9n.test(I)?v.scope=void 0:(v.scope=O.$2f(v.scope)?s:v.scope,v.restricted=O.$2f(v.restricted)?!!n?.includes(I):v.restricted),l[I].hasOwnProperty("included")&&!l[I].included){this.f[I]=l[I],delete l[I];continue}else this.d[I]=l[I],l[I].policy?.name&&this.e.set(l[I].policy.name,I);!l[I].deprecationMessage&&l[I].markdownDeprecationMessage&&(l[I].deprecationMessage=l[I].markdownDeprecationMessage),o.add(I)}const R=i.allOf;if(R)for(const I of R)this.p(I,r,t,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$Zn.properties[i]=r,r.scope){case 1:e.$1n.properties[i]=r;break;case 2:e.$2n.properties[i]=r;break;case 6:e.$3n.properties[i]=r;break;case 3:e.$4n.properties[i]=r;break;case 4:e.$5n.properties[i]=r;break;case 5:e.$5n.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$Zn.properties[i],r.scope){case 1:delete e.$1n.properties[i];break;case 2:delete e.$2n.properties[i];break;case 6:delete e.$3n.properties[i];break;case 3:delete e.$4n.properties[i];break;case 4:case 5:delete e.$5n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$6n};this.w(r,t),e.$Zn.properties[r]=t,e.$1n.properties[r]=t,e.$2n.properties[r]=t,e.$3n.properties[r]=t,e.$4n.properties[r]=t,e.$5n.properties[r]=t}}v(){const i={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$6n};e.$Zn.patternProperties[e.$8n]=i,e.$1n.patternProperties[e.$8n]=i,e.$2n.patternProperties[e.$8n]=i,e.$3n.patternProperties[e.$8n]=i,e.$4n.patternProperties[e.$8n]=i,e.$5n.patternProperties[e.$8n]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;O.$Zf(n)&&(n=r.defaultDefaultValue,s=void 0),O.$Zf(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=s}}const m="\\[([^\\]]+)\\]",w=new RegExp(m,"g");e.$8n=`^(${m})+$`,e.$9n=new RegExp(e.$8n);function k(g){const i=[];if(e.$9n.test(g)){let r=w.exec(g);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=w.exec(g)}}return(0,L.$Mb)(i)}e.$0n=k;function b(g){return g.reduce((i,r)=>`${i}[${r}]`,"")}e.$$n=b;function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$_n=c;const p=new d;h.$Tn.add(e.$Yn.Configuration,p);function $(g,i){return g.trim()?e.$9n.test(g)?N.localize(7,null,g):p.getConfigurationProperties()[g]!==void 0?N.localize(8,null,g):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?N.localize(9,null,g,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:N.localize(6,null)}e.$ao=$;function u(){const g=[],i=p.getConfigurationProperties();for(const r of Object.keys(i))g.push([r,i[r].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.$bo=u}),define(ie[66],ne([0,1,19,6,38,2,31,27,3,11,29,40,36]),function(J,e,L,D,O,N,A,S,h,a,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=void 0;function m(r){return Object.isFrozen(r)?r:S.$In(r)}class w{constructor(t={},n=[],s=[],o){this.b=t,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof w)return n;const s=new k("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,y.$Si)(this.contents,t):this.contents}inspect(t,n){const s=this;return{get value(){return m(s.rawConfiguration.getValue(t))},get override(){return n?m(s.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return m(n?s.rawConfiguration.override(n).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:l,identifiers:R,keys:I}of s.rawConfiguration.overrides){const v=new w(l,I).getValue(t);v!==void 0&&o.push({identifiers:R,value:v})}return o.length?m(o):void 0}}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,y.$Si)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return L.$Mb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return L.$Mb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=S.$Hn(this.contents),s=S.$Hn(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const R of t)if(l.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.h(n,R.contents);for(const I of R.overrides){const[v]=s.filter(j=>L.$ub(j.identifiers,I.identifiers));v?(this.h(v.contents,I.contents),v.keys.push(...I.keys),v.keys=L.$Mb(v.keys)):s.push(S.$Hn(I))}for(const I of R.keys)o.indexOf(I)===-1&&o.push(I)}return new w(n,o,s,l.every(R=>R instanceof w)?void 0:l)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of L.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[o];const R=n[o];R&&(typeof l=="object"&&typeof R=="object"?(l=S.$Hn(l),this.h(l,R)):l=R),s[o]=l}return new w(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&h.$Uf(t[s])&&h.$Uf(n[s])){this.h(t[s],n[s]);continue}t[s]=S.$Hn(n[s])}}i(t){let n=null,s=null;const o=l=>{l&&(s?this.h(s,l):s=S.$Hn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?n=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,y.$Ri)(this.contents,t),E.$9n.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>L.$ub(s.identifiers,(0,E.$0n)(t))),1))}j(t,n,s){(0,y.$Qi)(this.contents,t,n,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),E.$9n.test(t)&&this.overrides.push({identifiers:(0,E.$0n)(t),keys:Object.keys(this.contents[t]),contents:(0,y.$Pi)(this.contents[t],o=>console.error(o))})}}e.$co=w;class k{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!h.$2f(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:o,overrides:l,restricted:R,hasExcludedProperties:I}=this.h(t,n);this.b=new w(s,o,l,I?[t]:void 0),this.c=R||[]}g(t){let n={},s=null,o=[];const l=[],R=[];function I(j){Array.isArray(o)?o.push(j):s!==null&&(o[s]=j)}const v={onObjectBegin:()=>{const j={};I(j),l.push(o),o=j,s=null},onObjectProperty:j=>{s=j},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const j=[];I(j),l.push(o),o=j,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:I,onError:(j,q,Q)=>{R.push({error:j,offset:q,length:Q})}};if(t)try{O.$vn(t,v),n=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return n}h(t,n){const s=d.$Tn.as(E.$Yn.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,n);t=o.raw;const l=(0,y.$Pi)(t,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),R=Object.keys(t),I=this.j(t,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:l,keys:R,overrides:I,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const R={},I=[];for(const v in t)if(E.$9n.test(v)&&s){const j=this.i(t[v],n,!1,o);R[v]=j.raw,l=l||j.hasExcludedProperties,I.push(...j.restricted)}else{const j=n[v],q=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&I.push(v),!o.exclude?.includes(v)&&(o.include?.includes(v)||(q===void 0||o.scopes===void 0||o.scopes.includes(q))&&!(o.skipRestricted&&j?.restricted))?R[v]=t[v]:l=!0}return{raw:R,restricted:I,hasExcludedProperties:l}}j(t,n){const s=[];for(const o of Object.keys(t))if(E.$9n.test(o)){const l={};for(const R in t[o])l[R]=t[o][R];s.push({identifiers:(0,E.$0n)(o),keys:Object.keys(l),contents:(0,y.$Pi)(l,n)})}return s}}e.$do=k;class b extends N.$Tc{constructor(t,n,s,o){super(),this.c=t,this.f=n,this.g=o,this.b=this.B(new D.$5d),this.onDidChange=this.b.event,this.a=new k(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new w}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$eo=b;class c{constructor(t,n,s,o,l,R,I,v,j,q,Q,Z,oe){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=l,this.f=R,this.g=I,this.h=v,this.i=j,this.j=q,this.k=Q,this.l=Z,this.m=oe}get value(){return m(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class p{constructor(t,n,s,o,l=new w,R=new w,I=new A.$Ac,v=new w,j=new A.$Ac){this.c=t,this.d=n,this.f=s,this.g=o,this.h=l,this.i=R,this.j=I,this.l=v,this.m=j,this.a=null,this.b=new A.$Ac,this.n=null}getValue(t,n,s){return this.p(t,n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new w,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const o=this.p(t,n,s),l=this.t(n.resource,s),R=n.resource?this.m.get(n.resource)||this.l:this.l,I=new Set;for(const v of o.overrides)for(const j of v.identifiers)o.getOverrideValue(t,j)!==void 0&&I.add(j);return new c(t,n,o.getValue(t),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,R)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:o,updated:l,removed:R}=g(this.c,t);n=[...o,...l,...R]}for(const o of n)for(const l of(0,E.$0n)(o)){const R=this.c.getKeysForOverrideIdentifier(l),I=t.getKeysForOverrideIdentifier(l),v=[...I.filter(j=>R.indexOf(j)===-1),...R.filter(j=>I.indexOf(j)===-1),...R.filter(j=>!S.$Ln(this.c.override(l).getValue(j),t.override(l).getValue(j)))];s.push([l,v])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:o}=g(this.d,t),l=[...n,...s,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.applicationConfiguration,t),R=[...n,...s,...o];return R.length&&this.updateApplicationConfiguration(t),{keys:R,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.localUserConfiguration,t),R=[...n,...s,...o];return R.length&&this.updateLocalUserConfiguration(t),{keys:R,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.remoteUserConfiguration,t),R=[...n,...s,...o];return R.length&&this.updateRemoteUserConfiguration(t),{keys:R,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.workspaceConfiguration,t),R=[...n,...s,...o];return R.length&&this.updateWorkspaceConfiguration(t),{keys:R,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:l,removed:R,overrides:I}=g(s,n),v=[...o,...l,...R];return(v.length||!s)&&this.updateFolderConfiguration(t,n),{keys:v,overrides:I}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:l,overrides:R}=g(n,void 0);return{keys:[...s,...o,...l],overrides:R}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,s){let o=this.q(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}q({resource:t},n){let s=this.r();if(n&&t){const o=n.getFolder(t);o&&(s=this.s(o.uri)||s);const l=this.m.get(t);l&&(s=s.merge(l))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const s=this.r(),o=this.j.get(t);o?(n=s.merge(o),this.b.set(t,n)):n=s}return n}t(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:l}=this.j.get(n);return t.push([n,{contents:s,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.w(t.defaults),s=this.w(t.policy),o=this.w(t.application),l=this.w(t.user),R=this.w(t.workspace),I=t.folders.reduce((v,j)=>(v.set(a.URI.revive(j[0]),this.w(j[1])),v),new A.$Ac);return new p(n,s,o,l,new w,R,I,new w,new A.$Ac)}static w(t){return new w(t.contents,t.keys,t.overrides)}}e.$fo=p;function $(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,R])=>{const I=(0,A.$xc)(n,l,new Set);R.forEach(v=>I.add(v))});const s=[];return n.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.$go=$;class u{constructor(t,n,s,o){this.change=t,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const R of l)this.affectedKeys.add(R);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this.d.length)return!1;const R=this.d.charCodeAt(l);if(R!==this.b&&R!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,v=this.g.getValue(t,n,this.h);return!S.$Ln(I,v)}return!0}}e.$ho=u;function g(r,t){const{added:n,removed:s,updated:o}=i(t?.rawConfiguration,r?.rawConfiguration),l=[],R=r?.getAllOverrideIdentifiers()||[],I=t?.getAllOverrideIdentifiers()||[];if(t){const v=I.filter(j=>!R.includes(j));for(const j of v)l.push([j,t.getKeysForOverrideIdentifier(j)])}if(r){const v=R.filter(j=>!I.includes(j));for(const j of v)l.push([j,r.getKeysForOverrideIdentifier(j)])}if(t&&r){for(const v of R)if(I.includes(v)){const j=i({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:t.getOverrideValue(void 0,v)||{},keys:t.getKeysForOverrideIdentifier(v)});l.push([v,[...j.added,...j.removed,...j.updated]])}}return{added:n,removed:s,updated:o,overrides:l}}function i(r,t){const n=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const R=(0,y.$Si)(t.contents,l),I=(0,y.$Si)(r.contents,l);S.$Ln(R,I)||o.push(l)}}return{added:n,removed:s,updated:o}}}),define(ie[135],ne([0,1,19,6,2,27,3,66,40,4,39,36]),function(J,e,L,D,O,N,A,S,h,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=void 0;class d extends O.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$5d),this.onDidChangeConfiguration=this.a.event,this.b=new S.$co}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$Tn.as(h.$Yn.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:c})=>this.c(Array.from(b),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(b,c){this.h(b,E.$Tn.as(h.$Yn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}f(){return{}}g(){this.b=new S.$co;const b=E.$Tn.as(h.$Yn.Configuration).getConfigurationProperties();this.h(Object.keys(b),b)}h(b,c){const p=this.f();for(const $ of b){const u=p[$],g=c[$];u!==void 0?this.b.addValue($,u):g?this.b.addValue($,g.default):this.b.removeValue($)}}}e.$io=d;class m{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new S.$co}async initialize(){return this.configurationModel}}e.$jo=m;let w=class extends O.$Tc{get configurationModel(){return this.b}constructor(b,c,p){super(),this.c=b,this.f=c,this.g=p,this.a=this.B(new D.$5d),this.onDidChangeConfiguration=this.a.event,this.b=new S.$co}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const c={},p=[],$=E.$Tn.as(h.$Yn.Configuration).getConfigurationProperties();for(const u of b){const g=$[u];if(!g){p.push(u);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}p.push(u),c[g.policy.name]={type:g.type}}}return(0,A.$6f)(c)||await this.f.updatePolicyDefinitions(c),p}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const c=E.$Tn.as(h.$Yn.Configuration).getPolicyConfigurations(),p=(0,L.$Hb)(b.map($=>c.get($)));this.m(p,!0)}m(b,c){this.g.trace("PolicyConfiguration#update",b);const p=E.$Tn.as(h.$Yn.Configuration).getConfigurationProperties(),$=[],u=this.b.isEmpty();for(const g of b){const i=p[g]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(u?r!==void 0:!(0,N.$Ln)(this.b.getValue(g),r))&&$.push([g,r])}else this.b.getValue(g)!==void 0&&$.push([g,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const g=this.b;this.b=new S.$co;for(const i of g.keys)this.b.setValue(i,g.getValue(i));for(const[i,r]of $)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);c&&this.a.fire(this.b)}}};e.$ko=w,e.$ko=w=me([se(1,y.$Vn),se(2,a.$yj)],w)}),define(ie[136],ne([0,1,19,9,14,6,38,73,2,27,12,17,29,66,40,135,39]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m,w,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=void 0;class c extends h.$Tc{constructor(u,g,i,r){super(),this.m=u,this.h=this.B(new N.$5d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new k.$io),this.c=i instanceof b.$Xn?new k.$jo:this.B(new k.$ko(this.b,i,r)),this.f=this.B(new m.$eo(this.m,{},E.$Ig,g)),this.a=new m.$fo(this.b.configurationModel,this.c.configurationModel,new m.$co,new m.$co),this.j=new p(u,g,this),this.g=this.B(new D.$qh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:n})=>this.r(t,n))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[u,g,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new m.$fo(u,g,new m.$co,i)}getConfigurationData(){return this.a.toData()}getValue(u,g){const i=typeof u=="string"?u:void 0,r=(0,d.$Li)(u)?u:(0,d.$Li)(g)?g:{};return this.a.getValue(i,r,void 0)}async updateValue(u,g,i,r,t){const n=(0,d.$Mi)(i)?i:(0,d.$Li)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,s=n?r:i;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${u} to target ${s}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,L.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(u,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,a.$Ln)(g,o.defaultValue)&&(g=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const R=n.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(v=>(0,L.$ub)([...v.identifiers].sort(),R));I&&(n.overrideIdentifiers=I.identifiers)}const l=n?.overrideIdentifiers?.length?[(0,w.$$n)(n.overrideIdentifiers),u]:[u];await this.j.write(l,g),await this.reloadConfiguration()}inspect(u,g={}){return this.a.inspect(u,g,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const u=await this.f.loadConfiguration();this.n(u)}n(u){const g=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(u);this.t(i,g,2)}r(u,g){const i=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(u,g);this.t(r,i,7)}s(u){const g=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(u);this.t(i,g,7)}t(u,g,i){const r=new m.$ho(u,{data:g},this.a);r.source=i,this.h.fire(r)}}e.$lo=c;class p{constructor(u,g,i){this.b=u,this.c=g,this.d=i,this.a=new D.$lh}write(u,g){return this.a.queue(()=>this.e(u,g))}async e(u,g){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const r=[];if((0,A.$on)(i,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(i,u,g);i=(0,S.$Gn)(i,t),await this.c.writeFile(this.b,O.$se.fromString(i))}f(u,g,i){const{tabSize:r,insertSpaces:t,eol:n}=this.h;if(!g.length){const s=JSON.stringify(i,null,t?" ".repeat(r):"	");return[{content:s,length:s.length,offset:0}]}return(0,S.$Dn)(u,g,i,{tabSize:r,insertSpaces:t,eol:n})}get h(){if(!this.g){let u=y.OS===3||y.OS===2?`
`:`\r
`;const g=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(u=g),this.g={eol:u,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ie[67],ne([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=void 0;function D(a){return a.scheme===L.Schemas.vscodeRemote?a.authority:void 0}e.$ll=D;function O(a){if(!a)return;const y=a.indexOf("+");return y<0?a:a.substr(0,y)}e.$ml=O;function N(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$nl=N;function A(a){const{host:y,port:E}=h(a);if(typeof E>"u")throw new Error(`Invalid remote authority: ${a}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:E}}e.$ol=A;function S(a,y){let{host:E,port:d}=h(a);return typeof d>"u"&&(d=y),{host:E,port:d}}e.$pl=S;function h(a){const y=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const E=a.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const d=a.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:a,port:void 0}}}),define(ie[37],ne([0,1,30,10,67]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.TargetPlatform=e.ExtensionType=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=e.$qm=void 0,e.$qm="extensions.user.cache",e.$rm="extensions.builtin.cache",e.$sm="undefined_publisher",e.$tm=["ui","workspace","web"];function N(k){if(typeof k=="object"&&k!==null&&k.supported!==!0)return k.description}e.$um=N,e.$vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(A||(e.ExtensionType=A={}));var S;(function(k){k.WIN32_X64="win32-x64",k.WIN32_ARM64="win32-arm64",k.LINUX_X64="linux-x64",k.LINUX_ARM64="linux-arm64",k.LINUX_ARMHF="linux-armhf",k.ALPINE_X64="alpine-x64",k.ALPINE_ARM64="alpine-arm64",k.DARWIN_X64="darwin-x64",k.DARWIN_ARM64="darwin-arm64",k.WEB="web",k.UNIVERSAL="universal",k.UNKNOWN="unknown",k.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class h{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,c){if(typeof b>"u"||b===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof b=="string"||typeof c=="string"){const p=typeof b=="string"?b:b.value,$=typeof c=="string"?c:c.value;return L.$jf(p,$)}return b._lower===c._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$wm=h;class a{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const c of b)this.add(c)}add(b){this.c.add(h.toKey(b))}delete(b){return this.c.delete(h.toKey(b))}has(b){return this.c.has(h.toKey(b))}}e.$xm=a;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(h.toKey(b))}get(b){return this.c.get(h.toKey(b))}has(b){return this.c.has(h.toKey(b))}set(b,c){this.c.set(h.toKey(b),c)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$ym=y;function E(k){return d(k)}e.$zm=E;function d(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.$Am=d;function m(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.$Bm=m;function w(k,b){if(b){const c=`onResolveRemoteAuthority:${(0,O.$ml)(b)}`;return!!k.activationEvents?.includes(c)}return!1}e.$Cm=w,e.$Dm=(0,D.$ei)("IBuiltinExtensionsScannerService")}),define(ie[137],ne([0,1,2,37,13]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;class N extends L.$Tc{constructor(S,h,a,y,E){super(),this.a=S,this.b=h,this.c=a,this.f=E,this.B(y.onDidInstallExtensions(d=>this.g(d))),this.B(y.onDidUninstallExtension(d=>this.h(d)))}g(S){for(const h of S)h.local&&this.invalidate(h.profileLocation)}h(S){S.error||this.invalidate(S.profileLocation)}async invalidate(S){if(S)for(const h of this.a.profiles)this.c.extUri.isEqual(h.extensionsResource,S)&&await this.j(h);else await this.j(this.a.defaultProfile)}async j(S){try{await this.b.del(this.c.extUri.joinPath(S.cacheHome,D.$qm))}catch(h){(0,O.$Sk)(h)!==1&&this.f.error(h)}}}e.$gq=N}),define(ie[45],ne([0,1,14,7,2,106,40,10,4,36]),function(J,e,L,D,O,N,A,S,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=void 0,e.$sp=(0,S.$ei)("requestService");class y{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.b[i];this.a=g}return this.a}}class E extends O.$Tc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,N.localize)(0,null),when:h.$Pj.isEqualTo((0,h.$Nj)(h.LogLevel.Trace)).serialize()})}async c(g,i,r){const t=`${g} #${++this.b}: ${i.url}`;this.a.trace(`${t} - begin`,i.type,new y(i.headers??{}));try{const n=await r();return this.a.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,i.type,(0,D.$0)(n)),n}}}e.$tp=E;function d(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.$up=d;function m(u){return u.res.statusCode===204}e.$vp=m;async function w(u){return m(u)?null:(await(0,L.$Ee)(u.stream)).toString()}e.$wp=w;async function k(u){if(!d(u))throw new Error("Server returned "+u.res.statusCode);return w(u)}e.$xp=k;async function b(u){if(!d(u))throw new Error("Server returned "+u.res.statusCode);if(m(u))return null;const i=(await(0,L.$Ee)(u.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}e.$yp=b;function c(u){$(u)}e.$zp=c;let p;function $(u){const g=a.$Tn.as(A.$Yn.Configuration),i=p;p={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[p],remove:i?[i]:[]})}$(1)}),define(ie[138],ne([0,1,20,15,13,45]),function(J,e,L,D,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=void 0;let A=class{constructor(h,a){this.a=h,this.b=a}async download(h,a,y=L.CancellationToken.None){if(h.scheme===D.Schemas.file||h.scheme===D.Schemas.vscodeRemote){await this.b.copy(h,a);return}const E={type:"GET",url:h.toString(!0)},d=await this.a.request(E,y);if(d.res.statusCode===200)await this.b.writeFile(a,d.stream);else{const m=await(0,N.$xp)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${m}`)}}};e.$PP=A,e.$PP=A=me([se(0,N.$sp),se(1,O.$Bk)],A)}),define(ie[139],ne([0,1,140,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;function O(A,S){return A.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:A.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function N(A,S,h={}){const a=(0,L.parse)(A),y=h.proxyUrl||O(a,S);if(!y)return null;const E=(0,L.parse)(y);if(!/^https?:$/.test(E.protocol||""))return null;const d={host:E.hostname||"",port:(E.port?+E.port:0)||(E.protocol==="https"?443:80),auth:E.auth,rejectUnauthorized:(0,D.$Yf)(h.strictSSL)?h.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((m,w)=>{J(["http-proxy-agent"],m,w)})).HttpProxyAgent(y,d):new(await new Promise((m,w)=>{J(["https-proxy-agent"],m,w)})).HttpsProxyAgent(y,d)}e.$xr=N}),define(ie[141],ne([0,1,58,16,107,20,34,7,12,28,86,173,9,74]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=void 0;let w;async function k(c,p,$,u){return $["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.$em)(u)&&!$["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.$em)(u)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=d.Promises.withAsyncBody(async(g,i)=>{const r=new N.$ce;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,m.$fm)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,O.localize)(0,null)))},t);try{g(await b(p,r.token))}catch(o){!(0,S.$4)(o)&&!r.token.isCancellationRequested?i(new Error((0,O.localize)(1,null,(0,A.$2i)(o)))):g({})}finally{clearTimeout(s),r.dispose()}})),w)}e.$km=k;async function b(c,p){const $=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",$);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",u);const g=(0,a.$Ag)().replace(/-/g,"").substr(0,12),i=new RegExp(g+"({.*})"+g),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,y.$7l)(h.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(p.isCancellationRequested)return s(new S.$5);const o=(0,D.$nc)(t);let l,R;const I="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${I} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,R=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,R=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,R=["-i","-l","-c"]):(l=`'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?R=["-ic"]:R=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),l);const v=(0,L.spawn)(t,[...R,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});p.onCancellationRequested(()=>(v.kill(),s(new S.$5))),v.on("error",Q=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,A.$2i)(Q)),s(Q)});const j=[];v.stdout.on("data",Q=>j.push(Q));const q=[];v.stderr.on("data",Q=>q.push(Q)),v.on("close",(Q,Z)=>{const oe=Buffer.concat(j).toString("utf8");c.trace("getUnixShellEnvironment#raw",oe);const re=Buffer.concat(q).toString("utf8");if(re.trim()&&c.trace("getUnixShellEnvironment#stderr",re),Q||Z)return s(new Error((0,O.localize)(2,null,Q,Z)));const he=i.exec(oe),de=he?he[1]:"{}";try{const ae=JSON.parse(de);$?ae.ELECTRON_RUN_AS_NODE=$:delete ae.ELECTRON_RUN_AS_NODE,u?ae.ELECTRON_NO_ATTACH_CONSOLE=u:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),n(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,A.$2i)(ae)),s(ae)}})})}}),define(ie[142],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=e.$rP=void 0,e.$rP=(0,L.$ei)("stateReadService"),e.$sP=(0,L.$ei)("stateService")}),define(ie[68],ne([0,1,9,14,2,3,18,13,4]),function(J,e,L,D,O,N,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=e.$uP=e.$tP=e.SaveStrategy=void 0;var a;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class y extends O.$Tc{constructor(w,k,b,c){super(),this.h=w,this.j=k,this.m=b,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new L.$ch(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(w){w.fileOperationResult!==1&&this.m.error(w)}}getItem(w,k){const b=this.a[w];return(0,N.$2f)(b)?k:b}setItem(w,k){this.setItems([{key:w,data:k}])}setItems(w){let k=!1;for(const{key:b,data:c}of w)this.a[b]!==c&&((0,N.$2f)(c)?(0,N.$Zf)(this.a[b])||(this.a[b]=void 0,k=!0):(this.a[b]=c,k=!0));k&&this.s()}removeItem(w){(0,N.$Zf)(this.a[w])||(this.a[w]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const w=JSON.stringify(this.a,null,4);if(w!==this.b)try{await this.n.writeFile(this.h,D.$se.fromString(w),{atomic:{postfix:".vsctmp"}}),this.b=w}catch(k){this.m.error(k)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$tP=y;let E=class extends O.$Tc{constructor(w,k,b,c){super(),this.a=this.B(new y(k.stateResource,w,b,c))}async init(){await this.a.init()}getItem(w,k){return this.a.getItem(w,k)}};e.$uP=E,e.$uP=E=me([se(1,A.$li),se(2,h.$yj),se(3,S.$Bk)],E);class d extends E{setItem(w,k){this.a.setItem(w,k)}setItems(w){this.a.setItems(w)}removeItem(w){this.a.removeItem(w)}close(){return this.a.close()}}e.$vP=d}),define(ie[69],ne([0,1,12,35,28]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=void 0;function N(h){if(L.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function A(h,a,y,E,d,m,w,k,b){const c=Object.create(null);c["common.machineId"]=m,c["common.sqmId"]=w,c.sessionID=(0,O.$Ag)()+Date.now(),c.commitHash=E,c.version=d,c["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,L.$h)(L.$u),c["common.nodePlatform"]=D.$dc,c["common.nodeArch"]=y,c["common.product"]=b||"desktop",k&&(c["common.msftInternal"]=k);let p=0;const $=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),L.$l&&(c["common.snap"]="true");const u=N(a);return u&&(c["common.platformDetail"]=u),c}e.$Uo=A;function S(h){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const y=a.toLowerCase();return h.some(E=>y===E)}e.$Vo=S}),define(ie[25],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,L.$ei)("telemetryService"),e.$Gl=(0,L.$ei)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var D;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var O;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(O||(e.TelemetryConfiguration=O={}))}),define(ie[41],ne([0,1,27,3,67,69,25]),function(J,e,L,D,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0;class S{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$Wo=S;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Xo=h,e.$Yo=new h;class a{async publicLog(r,t,n){}async publicLogError(r,t,n){}}e.$Zo=a,e.$1o="telemetry",e.$2o="extensionTelemetryLog",e.$3o={log:()=>null,flush:()=>Promise.resolve(null)};function y(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}e.$4o=y;function E(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$5o=E;function d(i){const r=i.getValue(A.$Nl),t=i.getValue(A.$Ol);if(i.getValue(A.$Pl)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$6o=d;function m(i){const r={},t={},n={};b(i,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const o=n[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}e.$7o=m;const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function k(i){if(!i)return"none";const r=(0,O.$ml)(i);return w.has(r)?r:"other"}e.$8o=k;function b(i,r,t=0,n){if(i)for(const s of Object.getOwnPropertyNames(i)){const o=i[s],l=n?n+s:s;Array.isArray(o)?r[l]=(0,L.$Mn)(o):o instanceof Date?r[l]=o.toISOString():(0,D.$Uf)(o)?t<2?b(o,r,t+1,l+"."):r[l]=(0,L.$Mn)(o):r[l]=o}}function c(i,r){const t=i.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,N.$Vo)(t)||n}e.$9o=c;function p(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$0o=p;function $(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const R of r)for(;;){const I=R.exec(i);if(!I)break;n.push([I.index,R.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(t="";;){const R=o.exec(i);if(!R)break;const I=n.some(([v,j])=>R.index<j&&v<o.lastIndex);!s.test(R[0])&&!I&&(t+=i.substring(l,R.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<i.length&&(t+=i.substr(l)),t}function u(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function g(i,r){return(0,L.$Jn)(i,t=>{if(t instanceof S||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=$(n,r);for(const s of r)n=n.replace(s,"");return n=u(n),n}})}e.$$o=g}),define(ie[26],ne([0,1,30,21,37,12,11,7,35,41]),function(J,e,L,D,O,N,A,S,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0;function y(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,L.$ef)(t.id,n.id)===0}e.$_o=y;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,s,o)}static parse(n){const s=E.exec(n);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?y(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$ap=d;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(t){const n=m.exec(t);return n&&n[1]?[b(n[1]),n[2]]:[b(t),void 0]}e.$bp=w;function k(t,n){return`${t}.${n}`}e.$cp=k;function b(t){return t.toLowerCase()}e.$dp=b;function c(t,n){return b(k(t??O.$sm,n))}e.$ep=c;function p(t,n){const s=[],o=l=>{for(const R of s)if(R.some(I=>y(n(I),n(l))))return R;return null};for(const l of t){const R=o(l);R?R.push(l):s.push([l])}return s}e.$fp=p;function $(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$gp=$;function u(t){return{id:new a.$Wo(t.identifier.id),name:new a.$Wo(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$hp=u,e.$ip=new O.$wm("pprice.better-merge");function g(t,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(R=>!y(R.identifier,{id:l}))){const R=t.filter(I=>y(I.identifier,{id:l}));R.length===1&&(s.push(R[0]),o.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$jp=g;async function i(t,n){if(!N.$k)return!1;let s;try{s=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,S.$0)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),o=(0,D.$Go)(s?"alpine":N.$u,h.$ec);return n.debug("ComputeTargetPlatform:",o),o}e.$kp=r}),define(ie[143],ne([0,1,20,7,15,17,44,11,96,21,26,37]),function(J,e,L,D,O,N,A,S,h,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;const d=k=>(0,h.localize)(0,null,k),m=(0,h.localize)(1,null,"ms-dotnettools.csharp");let w=class{constructor(b,c,p){this.a=b,this.b=c,this.d=p}get f(){}async listExtensions(b,c,p){let $=await this.b.getInstalled(1,p);const u=E.$vm.map(i=>i.toLowerCase());if(c&&c!==""){if(u.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),u.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,h.localize)(2,null,this.f)),$=$.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let g;for(const i of $)g!==i.identifier.id&&(g=i.identifier.id,this.a.info(b?`${g}@${i.manifest.version}`:g))}async installExtensions(b,c,p,$){const u=[];try{b.length&&this.a.info(this.f?(0,h.localize)(3,null,this.f):(0,h.localize)(4,null));const g=[],i=[],r=(n,s,o)=>{i.push({id:n,version:s!=="prerelease"?s:void 0,installOptions:{...p,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||p.installPreReleaseVersion}})};for(const n of b)if(n instanceof S.URI)g.push({vsix:n,installOptions:p});else{const[s,o]=(0,y.$bp)(n);r(s,o,!1)}for(const n of c)if(n instanceof S.URI)g.push({vsix:n,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,y.$bp)(n);r(s,o,!0)}const t=await this.b.getInstalled(1,p.profileLocation);if(g.length&&await Promise.all(g.map(async({vsix:n,installOptions:s})=>{try{await this.h(n,s,$,t)}catch(o){this.a.error(o),u.push(n.toString())}})),i.length){const n=await this.g(i,t,$);u.push(...n)}}catch(g){throw this.a.error((0,h.localize)(5,null,(0,D.$0)(g))),g}if(u.length)throw new Error((0,h.localize)(6,null,u.join(", ")))}async updateExtensions(b){const c=await this.b.getInstalled(1,b),p=[];for(const i of c)i.identifier.uuid&&p.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,h.localize)(7,null,p.length));const $=await this.d.getExtensions(p,{compatible:!0},L.CancellationToken.None),u=[];for(const i of $)for(const r of c)(0,y.$_o)(r.identifier,i.identifier)&&(0,A.gt)(i.version,r.manifest.version)&&u.push({extension:i,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!u.length){this.a.info((0,h.localize)(8,null));return}this.a.info((0,h.localize)(9,null,u.map(i=>i.extension.identifier.id).join(", ")));const g=await this.b.installGalleryExtensions(u);for(const i of g)i.error?this.a.error((0,h.localize)(10,null,i.identifier.id,(0,D.$0)(i.error))):this.a.info((0,h.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(b,c,p){if(b=b.filter(({id:i,version:r})=>{const t=c.find(n=>(0,y.$_o)(n.identifier,{id:i}));if(t){if(!p&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,h.localize)(12,null,i,t.manifest.version,i)),!1;if(r&&t.manifest.version===r)return this.a.info((0,h.localize)(13,null,`${i}@${r}`)),!1}return!0}),!b.length)return[];const $=[],u=[],g=await this.j(b);if(await Promise.all(b.map(async({id:i,version:r,installOptions:t})=>{const n=g.get(i.toLowerCase());if(!n){this.a.error(`${d(r?`${i}@${r}`:i)}
${m}`),$.push(i);return}try{const o=await this.d.getManifest(n,L.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),$.push(i);return}const s=c.find(o=>(0,y.$_o)(o.identifier,n.identifier));if(s){if(n.version===s.manifest.version){this.a.info((0,h.localize)(14,null,r?`${i}@${r}`:i));return}this.a.info((0,h.localize)(15,null,i,n.version))}t.isBuiltin?this.a.info(r?(0,h.localize)(16,null,i,r):(0,h.localize)(17,null,i)):this.a.info(r?(0,h.localize)(18,null,i,r):(0,h.localize)(19,null,i)),u.push({extension:n,options:{...t,installGivenVersion:!!r}})})),u.length){const i=await this.b.installGalleryExtensions(u);for(const r of i)r.error?(this.a.error((0,h.localize)(20,null,r.identifier.id,(0,D.$0)(r.error))),$.push(r.identifier.id)):this.a.info((0,h.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return $}async h(b,c,p,$){const u=await this.b.getManifest(b);if(!u)throw new Error("Invalid vsix");if(await this.l(u,p,c.profileLocation,$))try{await this.b.install(b,c),this.a.info((0,h.localize)(22,null,(0,N.$Og)(b)))}catch(i){if((0,D.$4)(i))this.a.info((0,h.localize)(23,null,(0,N.$Og)(b)));else throw i}}async j(b){const c=new Map,p=b.some(g=>g.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),u=[];for(const g of b)a.$zo.test(g.id)&&u.push({...g,preRelease:p});if(u.length){const g=await this.d.getExtensions(u,{targetPlatform:$},L.CancellationToken.None);for(const i of g)c.set(i.identifier.id.toLowerCase(),i)}return c}k(b){return!0}async l(b,c,p,$){if(!c){const u={id:(0,y.$ep)(b.publisher,b.name)},g=$.find(i=>(0,y.$_o)(u,i.identifier)&&(0,A.gt)(i.manifest.version,b.version));if(g)return this.a.info((0,h.localize)(24,null,g.identifier.id,g.manifest.version,b.version)),!1}return this.k(b)}async uninstallExtensions(b,c,p){const $=async g=>{if(g instanceof S.URI){const i=await this.b.getManifest(g);return(0,y.$cp)(i.publisher,i.name)}return g},u=[];for(const g of b){const i=await $(g),t=(await this.b.getInstalled(void 0,p)).filter(n=>(0,y.$_o)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.m(i)}
${m}`);if(t.some(n=>n.type===0)){this.a.info((0,h.localize)(25,null,i));return}if(!c&&t.some(n=>n.isBuiltin)){this.a.info((0,h.localize)(26,null,i));return}this.a.info((0,h.localize)(27,null,i));for(const n of t)await this.b.uninstall(n,{profileLocation:p}),u.push(n);this.f?this.a.info((0,h.localize)(28,null,i,this.f)):this.a.info((0,h.localize)(29,null,i))}}async locateExtension(b){const c=await this.b.getInstalled();b.forEach(p=>{c.forEach($=>{if($.identifier.id===p&&$.location.scheme===O.Schemas.file){this.a.info($.location.fsPath);return}})})}m(b){return this.f?(0,h.localize)(30,null,b,this.f):(0,h.localize)(31,null,b)}};e.$Sp=w,e.$Sp=w=me([se(1,a.$No),se(2,a.$Ko)],w)}),define(ie[144],ne([0,1,9,7,2,15,17,44,3,28,24,49,29,18,21,26,64,13,4]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m,w,k,b,c,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;let u=class extends O.$Tc{static{$=this}static{this.c=".sigzip"}constructor(i,r,t,n,s,o){super(),this.h=r,this.j=t,this.m=n,this.n=s,this.r=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,r,t){await this.g;const n=(0,A.$Rg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,o=>this.j.download(i,o,r))}catch(o){throw new w.$Lo(o.message,w.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(i)){const o=await this.u(i);try{s=await this.n.verify(n.fsPath,o.fsPath,this.r.getLevel()===p.LogLevel.Trace)}catch(l){const R=l;if(s=R.code,R.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${R.output}`),s===w.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===w.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(I){this.r.error(I)}throw new w.$Lo(E.$Wp,w.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:n,verificationStatus:s}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,h.$Yf)(r)?r:!0}async u(i){await this.g;const r=(0,A.$Rg)(this.extensionsDownloadDir,`${this.z(i)}${$.c}`);try{await this.w(i,r,t=>this.j.downloadSignatureArchive(i,t))}catch(t){throw new w.$Lo(t.message,w.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==N.Schemas.file){await t(r);return}const n=(0,A.$Rg)(this.extensionsDownloadDir,`.${(0,a.$Ag)()}`);await this.h.exists(n)||await t(n);try{await y.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const l of i.children)if(l.name.endsWith($.c))n.push(l.resource);else{const R=k.$ap.parse(l.name);R&&t.push([R,l])}const s=(0,k.$fp)(t,([l])=>l),o=[];for(const l of s)l.sort((R,I)=>S.rcompare(R[0].version,I[0].version)),r.push(...l.slice(1).map(R=>R[1].resource)),o.push(l[0][1]);o.sort((l,R)=>l.mtime-R.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),r.push(...n),await L.Promises.settled(r.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(i){this.r.error(i)}}z(i){return this.f?k.$ap.create(i).toString().toLowerCase():(0,a.$Ag)()}};e.$dq=u,e.$dq=u=$=me([se(0,m.$mi),se(1,c.$Bk),se(2,w.$Ko),se(3,d.$Ki),se(4,b.$Qp),se(5,p.$yj)],u)}),define(ie[145],ne([0,1,6,2,31,26,37]),function(J,e,L,D,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=void 0;class S extends D.$Tc{constructor(a,y,E,d,m,w,k){super(),this.f=a,this.g=y,this.h=E,this.j=d,this.m=m,this.n=w,this.r=k,this.a=this.B(new L.$5d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$3c),this.s().then(null,b=>k.error(b))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(y=>(this.c.set(y.id,(0,D.$Qc)(this.n.watch(this.m.extUri.dirname(y.extensionsResource)),this.n.watch(y.extensionsResource))),this.G(y.extensionsResource))))}catch(y){throw this.r.error(y),y}}async w(a){for(const y of a.extensions)this.I(this.L(y.identifier,y.version),a.profileLocation)}async y(a){for(const y of a.extensions){const E=this.L(y.identifier,y.version);a.error?this.J(E,a.profileLocation):this.I(E,a.profileLocation)}}async z(a){for(const y of a.extensions)this.J(this.L(y.identifier,y.version),a.profileLocation)}async C(a){const y=[],E=[];for(const d of a.extensions){const m=this.L(d.identifier,d.version);a.error?this.I(m,a.profileLocation):(this.J(m,a.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),E.push(this.f.scanInstalledExtensionAtLocation(d.location).then(w=>{w?y.push(w):this.r.info("Extension not found at the location",d.location.toString())},w=>this.r.error(w)))))}try{await Promise.all(E),y.length&&await this.H(y)}catch(d){this.r.error(d)}}D(a){for(const y of this.h.profiles)a.contains(y.extensionsResource,0,1)&&this.F(y.extensionsResource)}async F(a){const y=[],E=[],d=await this.j.scanProfileExtensions(a),m=new Set,w=new Set;for(const[k,b]of this.b)b.has(a)&&w.add(k);for(const k of d){const b=this.L(k.identifier,k.version);m.add(b),w.has(b)||(y.push(k.identifier),this.I(b,a))}for(const k of w)if(!m.has(k)){const b=this.M(k);b&&(E.push(b.identifier),this.J(k,a))}(y.length||E.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:a}:void 0,removed:E.length?{extensions:E,profileLocation:a}:void 0})}async G(a){const y=await this.j.scanProfileExtensions(a);for(const E of y)this.I(this.L(E.identifier,E.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,y){let E=this.b.get(a);E||this.b.set(a,E=new O.$Bc(d=>this.m.extUri.getComparisonKey(d))),E.add(y)}J(a,y){const E=this.b.get(a);E&&E.delete(y),E?.size||this.b.delete(a)}L(a,y){return`${A.$wm.toKey(a.id)}@${y}`}M(a){const[y,E]=(0,N.$bp)(a);return E?{identifier:{id:y},version:E}:void 0}}e.$hq=S}),define(ie[146],ne([0,1,117,41]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;async function O(N,A,S,h,a,y,E){const d={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${A.nameShort})`};if((0,D.$4o)(A,S)&&(0,D.$6o)(h)===3){const m=await(0,L.$Lp)(S,a,y);d["X-Market-User-Id"]=m,d["VSCode-SessionId"]=E.machineId||m}return d}e.$Mp=O}),define(ie[147],ne([0,1,174,19,9,2,15,16,24,18,21,26,4,63,11]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;let k=class extends m.$tr{constructor($,u,g,i){super(g),this.h=$,this.j=i,this.g=this.B(new b(u,i)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri($,u){const i=(await this.g.getLanguagePacks())[u];if(!i){this.j.warn(`No language pack found for ${u}`);return}const r=i.translations[$];return r?w.URI.file(r):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),u=Object.keys($).map(g=>{const i=$[g];return{...this.f(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return u.push(this.f("en","English")),u.sort((g,i)=>g.label.localeCompare(i.label)),u}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const u=await this.g.getLanguagePacks();Object.keys(u).some(g=>u[g]&&u[g].extensions.some(i=>(0,E.$_o)(i.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,u]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),g=await this.g.update(u);return!(0,D.$ub)(Object.keys($),Object.keys(g))}};e.$ur=k,e.$ur=k=me([se(0,y.$No),se(1,a.$mi),se(2,y.$Ko),se(3,d.$yj)],k);let b=class extends N.$Tc{constructor($,u){super(),this.j=u,this.c={},this.f=(0,S.$jc)($.userDataPath,"languagepacks.json"),this.g=new O.$lh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(u=>{Object.keys(u).forEach(g=>delete u[g]),this.m(u,...$)}).then(()=>this.c)}m($,...u){for(const g of u)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.n($,g);Object.keys($).forEach(g=>this.r($[g]))}n($,u){const g=u.identifier,i=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const r of i)if(u.location.scheme===A.Schemas.file&&c(r)){let t=$[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},$[r.languageId]=t);const n=t.extensions.filter(s=>(0,E.$_o)(s.extensionIdentifier,g))[0];n?n.version=u.manifest.version:t.extensions.push({extensionIdentifier:g,version:u.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,S.$jc)(u.location.fsPath,s.path)}}r($){if($){const u=(0,L.createHash)("md5");for(const g of $.extensions)u.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);$.hash=u.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let u=null;return h.Promises.readFile(this.f,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(u=$(g),g)).then(g=>{for(const r of Object.keys(g))g[r]||delete g[r];this.c=g,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),h.Promises.writeFile(this.f,i)}).then(()=>u,g=>this.j.error(g))})}};b=me([se(0,a.$mi),se(1,d.$yj)],b);function c(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const $ of p.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ie[148],ne([0,1,83,7,27,41]),function(J,e,L,D,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",S="https://mobile.events.data.microsoft.com/ping";async function h(y,E,d){const m=await(0,L.$tD)("@microsoft/1ds-core-js","dist/ms.core.js"),w=await(0,L.$tD)("@microsoft/1ds-post-js","dist/ms.post.js"),k=new m.AppInsightsCore,b=new w.PostChannel,c={instrumentationKey:y,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(d){c.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};c.extensionConfig[b.identifier]=p}return k.initialize(c,[]),k.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',E&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),k}class a{constructor(E,d,m,w,k){this.e=E,this.f=d,this.g=m,this.h=k,this.c=A,this.d=S,this.g||(this.g={}),typeof w=="function"?this.a=w():this.a=w,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=h(this.a,this.e,this.h)),this.b.then(d=>{E(d)},d=>{(0,D.$1)(d),console.error(d)})}}log(E,d){if(!this.a)return;d=(0,O.$Kn)(d,this.g),d=(0,N.$7o)(d);const m=this.f+"/"+E;try{this.i(w=>{w.pluginVersionString=d?.properties.version??"Unknown",w.track({name:m,baseData:{name:m,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$nP=a}),define(ie[149],ne([0,1,2,27,12,30,108,29,40,150,32,36,25,41]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;let w=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,p,$){this.k=p,this.l=$,this.d={},this.i=new L.$Sc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const u of this.f)this.j.push(new RegExp((0,N.$Xe)(u),"gi")),u.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.$Xe)(u.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(u=>{(u.affectsConfiguration(d.$Nl)||u.affectsConfiguration(d.$Pl)||u.affectsConfiguration(d.$Ol))&&this.m()}))}setExperimentProperty(c,p){this.d[c]=p}m(){let c=(0,m.$6o)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const $=p.usage?3:p.error?2:0;c=Math.min(c,$)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,p,$){this.g<p||($=(0,D.$Kn)($,this.d),$=(0,m.$$o)($,this.j),$=(0,D.$Kn)($,this.c),this.b.forEach(u=>u.log(c,$)))}publicLog(c,p){this.n(c,3,p)}publicLog2(c,p){this.publicLog(c,p)}publicLogError(c,p){this.h&&this.n(c,2,p)}publicLogError2(c,p){this.publicLogError(c,p)}};e.$Ar=w,e.$Ar=w=me([se(1,S.$Ki),se(2,y.$Qj)],w);function k(){const b=(0,A.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=O.$o?"":(0,A.localize)(3,null),$=(0,A.localize)(4,null),u=(0,A.localize)(5,null),g=(0,A.localize)(6,null),i=(0,A.localize)(7,null),r=`
|       | ${$} | ${u} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${b} ${c} ${p}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}E.$Tn.as(h.$Yn.Configuration).registerConfiguration({id:d.$Ml,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[d.$Nl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:k(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$Tn.as(h.$Yn.Configuration).registerConfiguration({id:d.$Ml,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[d.$Pl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${d.$Nl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[151],ne([0,1,14,20,175,148]),function(J,e,L,D,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=void 0;async function A(y,E){const d=await E.request(y,D.CancellationToken.None),m=(await(0,L.$Ee)(d.stream)).toString(),w=d.res.statusCode??200;return{headers:d.res.headers,statusCode:w,responseData:m}}async function S(y){const E={method:y.type,headers:y.headers};return new Promise((m,w)=>{const k=O.request(y.url??"",E,b=>{b.on("data",function(c){m({headers:b.headers,statusCode:b.statusCode??200,responseData:c.toString()})}),b.on("error",function(c){w(c)})});k.write(y.data,b=>{b&&w(b)}),k.end()})}async function h(y,E,d){const m=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),w={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:m};try{const k=y?await A(w,y):await S(w);d(k.statusCode,k.headers,k.responseData)}catch{d(0,{})}}class a extends N.$nP{constructor(E,d,m,w,k){const b={sendPOST:(c,p)=>{h(E,c,p)}};super(d,m,w,k,b)}}e.$oP=a}),define(ie[152],ne([0,1,16,24]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=void 0;async function O(N,A){const S=Object.create(null),h=(y,E)=>{const d=JSON.parse(y);S[E]=d};if(A){const y=[],E=await D.Promises.readdir(A);for(const m of E)try{(await D.Promises.stat((0,L.$jc)(A,m))).isDirectory()&&y.push(m)}catch{}const d=[];for(const m of y)(await D.Promises.readdir((0,L.$jc)(A,m))).filter(k=>k==="telemetry.json").length===1&&d.push(m);for(const m of d){const w=(await D.Promises.readFile((0,L.$jc)(A,m,"telemetry.json"))).toString();h(w,m)}}let a=(await D.Promises.readFile((0,L.$jc)(N,"telemetry-core.json"))).toString();return h(a,"vscode-core"),a=(await D.Promises.readFile((0,L.$jc)(N,"telemetry-extensions.json"))).toString(),h(a,"vscode-extensions"),JSON.stringify(S,null,4)}e.$Nac=O}),define(ie[153],ne([0,1,12,84,25]),function(J,e,L,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5_b=e.$4_b=void 0;async function N(S,h){let a=S.getItem(O.$Kl);return(typeof a!="string"||L.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.$kn)(h.error.bind(h))),a}e.$4_b=N;async function A(S,h){let a=S.getItem(O.$Ll);return typeof a!="string"&&(a=await(0,D.$ln)(h.error.bind(h))),a}e.$5_b=A}),define(ie[22],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=void 0,e.$_k=(0,L.$ei)("IUriIdentityService")}),define(ie[154],ne([0,1,22,118,13,17,75,6,2]),function(J,e,L,D,O,N,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let y=class{constructor(d){this.g=d,this.c=new h.$Sc,this.f=2**16;const m=new Map,w=k=>{let b=m.get(k.scheme);return b===void 0&&(b=d.hasProvider(k)&&!this.g.hasCapability(k,1024),m.set(k.scheme,b)),b};this.c.add(S.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(k=>{m.delete(k.scheme)})),this.extUri=new N.$Gg(w),this.d=new A.$_r((k,b)=>this.extUri.compare(k,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,N.$Sg)(d));const m=this.d.get(d);return m?m.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new a(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((w,k)=>w[1].time<k[1].time?1:w[1].time>k[1].time?-1:0);a._clock=0,this.d.clear();const m=this.f*.5;for(let w=0;w<m;w++)this.d.set(d[w][0],d[w][1].touch())}};e.$as=y,e.$as=y=me([se(0,O.$Bk)],y),(0,D.$0r)(L.$_k,y,1)}),define(ie[155],ne([0,1,6,2,13,48,31]),function(J,e,L,D,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0;class S extends D.$Tc{constructor(a,y,E,d,m,w){super(),this.f=a,this.g=y,this.h=E,this.j=d,this.m=m,this.n=w,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$5d),this.onDidChangeFile=this.a.event,this.b=N.$ki.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(k=>this.m.extUri.getComparisonKey(this.t(k))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(k=>this.s(k)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,y){return this.g.open(this.t(a),y)}close(a){return this.g.close(a)}read(a,y,E,d,m){return this.g.read(a,y,E,d,m)}write(a,y,E,d,m){return this.g.write(a,y,E,d,m)}watch(a,y){this.b.set(a,a);const E=this.g.watch(this.t(a),y);return(0,D.$Rc)(()=>{this.b.delete(a),E.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,y,E){return this.g.rename(this.t(a),this.t(y),E)}readFile(a,y){return this.g.readFile(this.t(a),y)}readFileStream(a,y,E){return this.g.readFileStream(this.t(a),y,E)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,y,E){return this.g.writeFile(this.t(a),y,E)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,y){return this.g.delete(this.t(a),y)}copy(a,y,E){if((0,O.$Fk)(this.g))return this.g.copy(this.t(a),this.t(y),E);throw new Error("copy not supported")}cloneFile(a,y){if((0,O.$Gk)(this.g))return this.g.cloneFile(this.t(a),this.t(y));throw new Error("clone not supported")}s(a){const y=[];for(const E of a){if(E.resource.scheme!==this.f)continue;const d=this.u(E.resource);this.b.findSubstr(d)&&y.push({resource:d,type:E.type,cId:E.cId})}y.length&&(this.n.debug("User data changed"),this.a.fire(y))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$pac=S}),define(ie[156],ne([0,1,110,16,48,17,11,10,15]),function(J,e,L,D,O,N,A,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.WorkbenchState=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0,e.$ni=(0,S.$ei)("contextService");function a(n){const s=n;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}e.$oi=a;function y(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.$pi=y,e.$qi={id:"ext-dev"},e.$ri={id:"empty-window"};function E(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.$nc)(n)}:s?e.$qi:e.$ri;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$si=E;function d(n){const s=n;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}e.$ti=d;function m(n){const s=n;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.$ui=m;var w;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function k(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$vi=k;function b(n){const s=n;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$wi=b;class c{constructor(s,o,l,R,I){this.h=s,this.j=l,this.k=R,this.l=I,this.c=O.$ki.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=O.$ki.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$xi=c;class p{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,N.$Rg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$yi=p;function $(n){return new p({uri:n,index:0,name:(0,N.$Ng)(n)},{uri:n.toString()})}e.$zi=$,e.$Ai="code-workspace",e.$Bi=`.${e.$Ai}`,e.$Ci=[{name:(0,L.localize)(0,null),extensions:[e.$Ai]}],e.$Di="workspace.json";function u(n,s){return N.$Ig.isEqualOrParent(n,s.untitledWorkspacesHome)}e.$Ei=u;function g(n){let s;return A.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===h.Schemas.tmp}e.$Fi=g,e.$Gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$Gi}e.$Hi=i;function r(n,s){return!u(n,s)&&!g(n)}e.$Ii=r;function t(n){return(typeof n=="string"?(0,D.$oc)(n):(0,N.$Pg)(n))===e.$Bi}e.$Ji=t}),define(ie[23],ne([0,1,43,6,2,17,11,109,18,13,10,4,156,31,22,9,28,30,3]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m,w,k,b,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.ProfileResourceType=void 0;var $;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function u(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$al=u,e.$bl=(0,y.$ei)("IUserDataProfilesService");function g(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:A.URI.revive(n.location).with({scheme:s}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$cl=g;function i(n,s,o,l,R,I){return{id:n,name:s,location:o,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:I&&R?.useDefaultFlags?.globalState?I.globalStorageHome:(0,N.$Rg)(o,"globalStorage"),settingsResource:I&&R?.useDefaultFlags?.settings?I.settingsResource:(0,N.$Rg)(o,"settings.json"),keybindingsResource:I&&R?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,N.$Rg)(o,"keybindings.json"),tasksResource:I&&R?.useDefaultFlags?.tasks?I.tasksResource:(0,N.$Rg)(o,"tasks.json"),snippetsHome:I&&R?.useDefaultFlags?.snippets?I.snippetsHome:(0,N.$Rg)(o,"snippets"),extensionsResource:I&&R?.useDefaultFlags?.extensions?I.extensionsResource:(0,N.$Rg)(o,"extensions.json"),cacheHome:(0,N.$Rg)(l,n),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}e.$dl=i;let r=class extends O.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,l,R){super(),this.t=s,this.u=o,this.w=l,this.y=R,this.f=!0,this.h=this.B(new D.$5d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$5d),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$5d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$5d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new m.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$Rg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$Rg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,p.$Sf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}o.push(i((0,N.$Og)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const l=new m.$Ac,R=new Map;if(o.length)try{const I=this.Q();if(I.workspaces)for(const[v,j]of Object.entries(I.workspaces)){const q=A.URI.parse(v),Q=o.find(Z=>Z.id===j);Q&&l.set(q,Q)}if(I.emptyWindows)for(const[v,j]of Object.entries(I.emptyWindows)){const q=o.find(Q=>Q.id===j);q&&R.set(v,q)}}catch(I){this.y.error(I)}this.z={profiles:o,workspaces:l,emptyWindows:R}}return this.z}D(){const s=i("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,c.$Xe)(o)}\\s(\\d+)`);let R=0;for(const v of this.profiles){const j=l.exec(v.name),q=j?parseInt(j[1]):0;R=q>R?q:R}const I=`${o} ${R+1}`;return this.createProfile((0,L.$5i)((0,b.$Ag)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,L.$5i)((0,b.$Ag)()).toString(16),s,o,l)}async createProfile(s,o,l,R){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,o,l);return R&&await this.setProfileForWorkspace(R,I),I}async F(s,o,l){if(!(0,p.$Sf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.r.get(o);return R||(R=(async()=>{try{const I=this.profiles.find(q=>q.name===o||q.id===s);if(I)return I;const v=i(s,o,(0,N.$Rg)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(v.location);const j=[];return this.j.fire({profile:v,join(q){j.push(q)}}),await k.Promises.settled(j),this.I([v],[],[]),v}finally{this.r.delete(o)}})(),this.r.set(o,R)),R}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(R=>R.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=i(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(R=>R.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:o,join(R){l.push(R)}});try{await Promise.allSettled(l)}catch(R){this.y.error(R)}for(const R of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(R)?.id&&this.C.emptyWindows.delete(R);for(const R of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(R)?.id&&this.C.workspaces.delete(R);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(R){(0,a.$Sk)(R)!==1&&this.y.error(R)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(R=>R.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,d.$oi)(s)?s.uri:(0,d.$ti)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,l){const R=[...this.profiles,...s],I=[];this.s.profiles=[];for(let v of R)v.isDefault||o.some(j=>v.id===j.id)||(v=l.find(j=>v.id===j.id)??v,v.isTransient?this.s.profiles.push(v):I.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,o,l)}J(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}L(s,o,l){l=o?.isTransient?!0:l,l||this.L(s,void 0,!0);const R=this.G(s),I=l?this.s:this.C;A.URI.isUri(R)?(I.workspaces.delete(R),o&&I.workspaces.set(R,o)):(I.emptyWindows.delete(R),o&&I.emptyWindows.set(R,o)),l||this.M()}M(){const s={};for(const[l,R]of this.C.workspaces.entries())s[l.toString()]=R.id;const o={};for(const[l,R]of this.C.emptyWindows.entries())o[l.toString()]=R.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},l=this.D();if(s.workspaces)for(const[I,v]of Object.entries(s.workspaces)){const j=A.URI.parse(v);o[I]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}const R={};if(s.emptyWindows)for(const[I,v]of Object.entries(s.emptyWindows)){const j=A.URI.parse(v);R[I]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}return{workspaces:o,emptyWindows:R}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$el=r,e.$el=r=me([se(0,h.$li),se(1,a.$Bk),se(2,w.$_k),se(3,E.$yj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$fl=t}),define(ie[157],ne([0,1,19,9,20,7,6,2,12,3,11,94,21,26,37,4,32,25,22,23]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m,w,k,b,c,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=e.$3p=e.$2p=void 0;let u=class extends S.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,l,R,I,v){super(),this.z=s,this.C=o,this.D=l,this.F=R,this.G=I,this.H=v,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$5d),this.s=this.B(new A.$5d),this.t=this.B(new A.$5d),this.u=this.B(new A.$5d),this.w=this.B(new A.$5d),this.y=[],this.B((0,S.$Rc)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,d.$Io)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const R=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:I})=>(0,m.$_o)(I,s.identifier));if(R?.local)return R?.local;throw R?.error?R.error:new d.$Lo(`Unknown error while installing extension ${s.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(l){throw i(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new d.$Lo(E.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],l=[];await Promise.allSettled(s.map(async({extension:R,options:I})=>{try{const v=await this.N(R,!!I?.installGivenVersion,!!I?.installPreReleaseVersion);l.push({...v,options:I})}catch(v){o.push({identifier:R.identifier,operation:2,source:R,error:v})}})),l.length&&o.push(...await this.I(l));for(const R of o)R.error&&(this.F.error("Failed to install extension.",R.identifier.id),this.F.error(R.error),R.source&&!y.URI.isUri(R.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,m.$hp)(R.source),error:R.error}));return o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,w.$zm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(l=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const R of this.H.profiles){const I=(await this.getInstalled(1,R.extensionsResource)).find(v=>(0,m.$_o)(v.identifier,s.identifier));I?this.w.fire(I):this.u.fire({identifier:s.identifier,profileLocation:R.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=[],l=new Map,R=[],I=[],v=(q,Q)=>`${m.$ap.create(q).toString()}-${Q.toString()}`,j=(q,Q,Z)=>{const oe=this.Y(q,Q,Z),re=y.URI.isUri(Q)?Q.path:`${Q.identifier.id.toLowerCase()}-${Z.profileLocation.toString()}`;l.set(re,{task:oe,manifest:q}),this.n.fire({identifier:oe.identifier,source:Q,profileLocation:Z.profileLocation}),this.F.info("Installing extension:",oe.identifier.id),y.URI.isUri(Q)||this.j.set(v(Q,Z.profileLocation),{task:oe,waitingTasks:[]})};try{for(const{manifest:q,extension:Q,options:Z}of s){const oe=Z.isApplicationScoped||Z.isBuiltin||(0,w.$zm)(q),re={...Z,installOnlyNewlyAddedFromExtensionPack:y.URI.isUri(Q)?Z.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:oe,profileLocation:oe?this.H.defaultProfile.extensionsResource:Z.profileLocation??this.X()},he=y.URI.isUri(Q)?void 0:this.j.get(v(Q,re.profileLocation));he?(this.F.info("Extension is already requested to install",he.task.identifier.id),R.push(he.task.waitUntilTaskIsFinished())):j(q,Q,re)}await Promise.all([...l.values()].map(async({task:q,manifest:Q})=>{if(q.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",q.identifier.id);else try{const Z=await this.M(q.identifier,Q,!!q.options.installOnlyNewlyAddedFromExtensionPack,!!q.options.installPreReleaseVersion,q.options.profileLocation),oe=await this.getInstalled(void 0,q.options.profileLocation),re={...q.options,donotIncludePackAndDependencies:!0,context:{...q.options.context,[d.$Do]:!0}};for(const{gallery:he,manifest:de}of(0,L.$Mb)(Z,({gallery:ae})=>ae.identifier.id)){if(l.has(`${he.identifier.id.toLowerCase()}-${re.profileLocation.toString()}`))continue;const ae=this.j.get(v(he,re.profileLocation));if(ae){if(this.J(q,ae.task)){const B=ae.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,q.identifier.id),ae.waitingTasks.push(q),R.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,X=>X.some(T=>(0,m.$_o)(T.identifier,B)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,q.identifier.id),!X.find(C=>(0,m.$_o)(C.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else oe.some(({identifier:B})=>(0,m.$_o)(B,he.identifier))||j(de,he,re)}}catch(Z){if(y.URI.isUri(q.source))(0,L.$Lb)(Q.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",q.identifier.id,Z.message),(0,L.$Lb)(Q.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",q.identifier.id,Z.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",q.identifier.id),Z}})),await this.L([...l.values()].map(async({task:q})=>{const Q=new Date().getTime();try{const Z=await q.run();if(await this.L(this.y.map(oe=>oe.postInstall(Z,q.source,q.options,O.CancellationToken.None))),!y.URI.isUri(q.source)){const oe=q.operation===3,re=oe?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(r(this.C,oe?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$hp)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:re}),h.$o&&q.operation!==3)try{await this.z.reportStatistic(Z.manifest.publisher,Z.manifest.name,Z.manifest.version,"install")}catch{}}I.push({local:Z,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:Z.isApplicationScoped})}catch(Z){throw this.F.error("Error while installing the extension",q.identifier.id,(0,N.$0)(Z)),Z}})),R.length&&await this.L(R);for(const q of I)this.F.info("Extension installed successfully:",q.identifier.id),o.push(q);return o}catch(q){I.length&&await Promise.allSettled(I.map(async({local:Q,profileLocation:Z})=>{try{await this.Z(Q,{versionOnly:!0,profileLocation:Z}).run(),this.F.info("Rollback: Uninstalled extension",Q.identifier.id)}catch(oe){this.F.warn("Rollback: Error while uninstalling extension",Q.identifier.id,(0,N.$0)(oe))}}));for(const{task:Q}of l.values())Q.cancel(),o.push({identifier:Q.identifier,operation:2,source:Q.source,context:Q.options.context,profileLocation:Q.profileLocation,error:q});throw q}finally{for(const{task:q}of l.values())q.source&&!y.URI.isUri(q.source)&&this.j.delete(v(q.source,q.profileLocation));o.length&&this.s.fire(o)}}J(s,o){for(const[,{task:l,waitingTasks:R}]of this.j.entries())if(l===s&&(R.includes(o)||R.some(I=>this.J(I,o)))||l===o&&R[0]&&!this.J(s,R[0]))return!1;return!0}async L(s){const o=[],l=[],R=await Promise.allSettled(s);for(const I of R)I.status==="fulfilled"?o.push(I.value):l.push(I.reason);if(l.length)throw g(l);return o}async M(s,o,l,R,I){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,I),j=[],q=[],Q=async(Z,oe)=>{j.push(Z);const re=oe.extensionDependencies||[],he=[...re];if(oe.extensionPack){const de=l?v.find(ae=>(0,m.$_o)(ae.identifier,Z)):void 0;for(const ae of oe.extensionPack)de&&de.manifest.extensionPack&&de.manifest.extensionPack.some(B=>(0,m.$_o)({id:B},{id:ae}))||he.every(B=>!(0,m.$_o)({id:B},{id:ae}))&&he.push(ae)}if(he.length){const de=he.filter(ae=>j.every(B=>!(0,m.$_o)(B,{id:ae})));if(de.length){const ae=await this.z.getExtensions(de.map(B=>({id:B,preRelease:R})),O.CancellationToken.None);for(const B of ae){if(j.find(C=>(0,m.$_o)(C,B.identifier)))continue;const X=re.some(C=>(0,m.$_o)({id:C},B.identifier));let T;try{T=await this.N(B,!1,R)}catch(C){if(X)throw C;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,N.$0)(C));continue}q.push({gallery:T.extension,manifest:T.manifest}),await Q(T.extension.identifier,T.manifest)}}}};return await Q(s,o),q}async N(s,o,l){let R;const I=await this.getExtensionsControlManifest();if(I.malicious.some(q=>(0,m.$_o)(s.identifier,q)))throw new d.$Lo(E.localize(1,null,s.identifier.id),d.ExtensionManagementErrorCode.Malicious);const v=I.deprecated[s.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),R=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0],!R)throw new d.$Lo(E.localize(2,null,s.identifier.id,v.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const q=await this.getTargetPlatform();throw new d.$Lo(E.localize(3,null,s.identifier.id,this.G.nameLong,(0,d.$Eo)(q)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(R=await this.O(s,o,l),!R)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],O.CancellationToken.None))[0]?new d.$Lo(E.localize(4,null,s.displayName??s.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$Lo(E.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",R.identifier.id);const j=await this.z.getManifest(R,O.CancellationToken.None);if(j===null)throw new d.$Lo(`Missing manifest for extension ${R.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(j.version!==R.version)throw new d.$Lo(`Cannot install '${R.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:R,manifest:j}}async O(s,o,l){const R=await this.getTargetPlatform();let I=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(I=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:R,compatible:!0},O.CancellationToken.None))[0]||null),!I&&await this.z.isExtensionCompatible(s,l,R)&&(I=s),I||(o?I=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:R,compatible:!0},O.CancellationToken.None))[0]||null:I=await this.z.getCompatibleExtension(s,l,R)),I}async P(s,o){const l={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},R=Z=>`${Z.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,I=this.m.get(R(s.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),I.waitUntilTaskIsFinished();const v=Z=>{const oe=this.Z(Z,l);return this.m.set(R(oe.extension.identifier),oe),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Z.identifier.id}@${Z.manifest.version}`),this.t.fire({identifier:Z.identifier,profileLocation:l.profileLocation,applicationScoped:Z.isApplicationScoped}),oe},j=(Z,oe)=>{oe?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,l.profileLocation.toString(),oe.message):this.F.error("Failed to uninstall extension:",`${Z.identifier.id}@${Z.manifest.version}`,oe.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Z.identifier.id}@${Z.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Z.identifier.id}@${Z.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,m.$gp)(Z),error:oe}),this.u.fire({identifier:Z.identifier,error:oe?.code,profileLocation:l.profileLocation,applicationScoped:Z.isApplicationScoped})},q=[],Q=[];try{q.push(v(s));const Z=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const oe=this.S(s,Z);for(const re of oe)this.m.has(R(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):q.push(v(re))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(q.map(oe=>oe.extension),Z,s),await this.L(q.map(async oe=>{try{if(await oe.run(),await this.L(this.y.map(re=>re.postUninstall(oe.extension,l,O.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.z.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}j(oe.extension)}catch(re){const he=re instanceof d.$Lo?re:new d.$Lo((0,N.$0)(re),d.ExtensionManagementErrorCode.Internal);throw j(oe.extension,he),he}finally{Q.push(oe)}}))}catch(Z){const oe=Z instanceof d.$Lo?Z:new d.$Lo((0,N.$0)(Z),d.ExtensionManagementErrorCode.Internal);for(const re of q){try{re.cancel()}catch{}Q.includes(re)||j(re.extension,oe)}throw oe}finally{for(const Z of q)this.m.delete(R(Z.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Z.extension.identifier.id)}}Q(s,o,l){for(const R of s){const I=this.U(R,o);if(I.length){const v=I.filter(j=>!s.some(q=>(0,m.$_o)(q.identifier,j.identifier)));if(v.length)throw new Error(this.R(R,v,l))}}}R(s,o,l){return l===s?o.length===1?E.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?E.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const R=s.manifest.extensionPack?s.manifest.extensionPack:[];if(R.length){const I=o.filter(j=>!j.isBuiltin&&R.some(q=>(0,m.$_o)({id:q},j.identifier))),v=[];for(const j of I)v.push(...this.S(j,o,l));return[...I,...v]}return[]}U(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(R=>(0,m.$_o)({id:R},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,N.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$2p=u,e.$2p=u=me([se(0,d.$Ko),se(1,c.$Fl),se(2,p.$_k),se(3,k.$yj),se(4,b.$Qj),se(5,$.$bl)],u);function g(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$3p=g;function i(n){if(n instanceof d.$Lo)return n;if(n instanceof d.$Mo){const o=new d.$Lo(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const s=new d.$Lo(n.message,d.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}e.$4p=i;function r(n,s,{extensionData:o,verificationStatus:l,duration:R,error:I,durationSinceUpdate:v}){let j,q;(0,a.$1f)(l)&&(l===!0?l="Verified":(l===!1||(j=d.ExtensionManagementErrorCode.Signature,q=l),l="Unverified")),I&&(I instanceof d.$Lo||I instanceof d.$Mo?(j=I.code,I.code===d.ExtensionManagementErrorCode.Signature&&(q=I.message)):j=d.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:l,success:!I,duration:R,errorcode:j,errorcodeDetail:q,durationSinceUpdate:v})}class t{constructor(){this.d=new D.$dh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$4g)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$4g)(s=>new Promise((o,l)=>{const R=s.onCancellationRequested(()=>{R.dispose(),l(new N.$5)})})),this.d.open()),this.g.cancel()}}e.$5p=t}),define(ie[42],ne([0,1,9,14,2,6,31,11,21,26,13,10,4,23,22,3,7,25]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m,w,k,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=e.$6p=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class $ extends Error{constructor(t,n){super(t),this.code=n}}e.$6p=$,e.$7p=(0,E.$ei)("IExtensionsProfileScannerService");let u=class extends O.$Tc{constructor(t,n,s,o,l,R){super(),this.j=t,this.m=n,this.n=s,this.r=o,this.s=l,this.t=R,this.b=this.B(new N.$5d),this.onAddExtensions=this.b.event,this.c=this.B(new N.$5d),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.$5d),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.$5d),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n){const s=[],o=[];try{return await this.u(n,l=>{const R=[];for(const I of l)t.some(([v])=>(0,a.$_o)(v.identifier,I.identifier)&&v.manifest.version!==I.version)?s.push(I):R.push(I);for(const[I,v]of t){const j=R.findIndex(Q=>(0,a.$_o)(Q.identifier,I.identifier)&&Q.version===I.manifest.version),q={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:v};j===-1?(o.push(q),R.push(q)):R.splice(j,1,q)}return o.length&&this.b.fire({extensions:o,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),R}),o.length&&this.c.fire({extensions:o,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),o}catch(l){throw o.length&&this.c.fire({extensions:o,error:l,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:l,profileLocation:n}),l}}async updateMetadata(t,n){const s=[];return await this.u(n,o=>{const l=[];for(const R of o){const I=t.find(([v])=>(0,a.$_o)(v.identifier,R.identifier)&&v.manifest.version===R.version);I&&(R.metadata={...R.metadata,...I[1]},s.push(R)),l.push(R)}return l}),s}async removeExtensionFromProfile(t,n){const s=[];try{await this.u(n,o=>{const l=[];for(const R of o)(0,a.$_o)(R.identifier,t.identifier)?s.push(R):l.push(R);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async u(t,n,s){return this.F(t).queue(async()=>{let o=[],l;try{const R=await this.m.readFile(t);l=JSON.parse(R.value.toString().trim()||"[]")}catch(R){if((0,y.$Sk)(R)!==1)throw R;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new $((0,b.$0)(R),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let R=!1;for(const I of l){g(I)||this.w(t);let v;if((0,k.$Sf)(I.relativeLocation)&&I.relativeLocation)v=this.z(I.relativeLocation);else if((0,k.$Sf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{v=S.URI.revive(I.location);const j=this.y(v);j&&(R=!0,I.relativeLocation=j)}(0,k.$Zf)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(R=!0,I.metadata.hasPreReleaseVersion=!0),o.push({identifier:I.identifier,location:v,version:I.version,metadata:I.metadata})}R&&await this.m.writeFile(t,D.$se.fromString(JSON.stringify(l)))}if(n){o=n(o);const R=o.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(t,D.$se.fromString(JSON.stringify(R)))}return o})}w(t){const n=new $(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(l){if((0,y.$Sk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(R=>g(R))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$se.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,y.$Sk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,y.$Sk)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,y.$Sk)(l)!==1&&this.t.error(l)}return o})()),this.C}F(t){let n=this.h.get(t);return n||(n=new L.$lh,this.h.set(t,n)),n}};e.$8p=u,e.$8p=u=me([se(1,y.$Bk),se(2,m.$bl),se(3,w.$_k),se(4,c.$Fl),se(5,d.$yj)],u);function g(r){return(0,k.$Uf)(r)&&(0,h.$Jo)(r.identifier)&&(i(r.location)||(0,k.$Sf)(r.location)&&r.location)&&((0,k.$Zf)(r.relativeLocation)||(0,k.$Sf)(r.relativeLocation))&&r.version&&(0,k.$Sf)(r.version)}function i(r){return r?(0,k.$Sf)(r.path)&&(0,k.$Sf)(r.scheme):!1}}),define(ie[52],ne([0,1,19,9,27,14,7,38,81,2,15,16,12,17,44,54,3,11,98,18,26,37,50,13,10,4,32,6,47,42,23,22,115]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m,w,k,b,c,p,$,u,g,i,r,t,n,s,o,l,R,I,v,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.Translations=void 0;var q;(function(ae){function B(X,T){if(X===T)return!0;const C=Object.keys(X),H=new Set;for(const K of Object.keys(T))H.add(K);if(C.length!==H.size)return!1;for(const K of C){if(X[K]!==T[K])return!1;H.delete(K)}return H.size===0}ae.equals=B})(q||(e.Translations=q={})),e.$$p=(0,t.$ei)("IExtensionsScannerService");let Q=class extends a.$Tc{constructor(B,X,T,C,H,K,Y,_,U,F,f,P){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=X,this.r=T,this.s=C,this.t=H,this.u=K,this.w=Y,this.y=_,this.z=U,this.C=F,this.D=f,this.F=P,this.g=this.B(new o.$5d),this.onDidChangeCache=this.g.event,this.h=(0,m.$Rg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,u.$kp)(this.w,this.y)),this.G}async scanAllExtensions(B,X,T){const[C,H]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(X)]),K=T?await this.scanExtensionsUnderDevelopment(B,[...C,...H]):[];return this.L(C,H,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const X=[];X.push(this.M(!!B.useCache,B.language)),X.push(this.N(B.language,!!B.checkControlFile));const[T,C]=await Promise.all(X);return this.J([...T,...C],0,B,!1)}async scanUserExtensions(B){const X=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const T=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,C=await this.P(X,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,T),H=B.useCache&&!C.devMode&&C.excludeObsolete?this.m:this.n;let K;try{K=await H.scanExtensions(C)}catch(Y){if(Y instanceof R.$6p&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),K=await H.scanExtensions(C);else throw Y}return K=await this.J(K,1,B,!0),this.y.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(B,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(C=>C.scheme===y.Schemas.file).map(async C=>{const H=await this.P(C,!1,1,!0,B.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(H)).map(Y=>(Y.type=X.find(_=>(0,u.$_o)(_.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,H)))}))).flat();return this.J(T,"development",B,!0)}return[]}async scanExistingExtension(B,X,T){const C=await this.P(B,!1,X,!0,T.language,!0,void 0),H=await this.n.scanExtension(C);return!H||!T.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(B,X,T){const C=await this.P(B,!1,X,!0,T.language,!0,void 0),H=await this.n.scanOneOrMultipleExtensions(C);return this.J(H,X,T,!0)}async scanMetadata(B){const X=(0,m.$Rg)(B,"package.json"),T=(await this.w.readFile(X)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(B,X){const T=(0,m.$Rg)(B,"package.json"),C=(await this.w.readFile(T)).value.toString(),H=JSON.parse(C);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,H.__metadata={...H.__metadata,...X},await this.w.writeFile((0,m.$Rg)(B,"package.json"),N.$se.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof R.$6p&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,N.$se.fromString(JSON.stringify([])))}catch(X){(0,r.$Sk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,X,T,C){return T.includeAllVersions||(B=this.L(X===0?B:void 0,X===1?B:void 0,X==="development"?B:void 0,await this.getTargetPlatform(),C)),T.includeInvalid||(B=B.filter(H=>H.isValid)),B.sort((H,K)=>{const Y=E.$nc(H.location.fsPath),_=E.$nc(K.location.fsPath);return Y<_?-1:Y>_?1:0})}L(B,X,T,C,H){const K=(_,U,F)=>{if(_.isValid&&!U.isValid)return!1;if(_.isValid===U.isValid){if(H&&w.gt(_.manifest.version,U.manifest.version))return this.y.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(w.eq(_.manifest.version,U.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${U.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===C)return this.y.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${_.location.path} with ${U.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${U.location.path}.`),!0},Y=new g.$ym;return B?.forEach(_=>{const U=Y.get(_.identifier.id);(!U||K(U,_,!1))&&Y.set(_.identifier.id,_)}),X?.forEach(_=>{const U=Y.get(_.identifier.id);if(!U&&B&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!U||K(U,_,!1))&&Y.set(_.identifier.id,_)}),T?.forEach(_=>{const U=Y.get(_.identifier.id);(!U||K(U,_,!0))&&Y.set(_.identifier.id,_),Y.set(_.identifier.id,_)}),[...Y.values()]}async M(B,X){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),H=await(B&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",H.length),H}async N(B,X){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const C=X?await this.O():{},H=[],K=c.URI.file(E.$hc(E.$jc(y.$yg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of T){const U=C[_.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":H.push((0,m.$Rg)(K,_.name));break;default:H.push(c.URI.file(U));break}}const Y=await Promise.all(H.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,B,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,L.$Hb)(Y)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,X,T,C,H,K,Y){const _=await this.f(H??d.$w),U=await this.Q(B),F=X&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,f=F?await this.Q(F):void 0;return new Z(B,U,F,f,X,Y,T,C,K,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,H,_)}async Q(B){try{const X=await this.w.stat(B);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$_p=Q,e.$_p=Q=me([se(4,I.$bl),se(5,R.$7p),se(6,r.$Bk),se(7,n.$yj),se(8,$.$li),se(9,s.$Qj),se(10,v.$_k),se(11,t.$di)],Q);class Z{constructor(B,X,T,C,H,K,Y,_,U,F,f,P,z,M,W){this.location=B,this.mtime=X,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=C,this.profile=H,this.profileScanOptions=K,this.type=Y,this.excludeObsolete=_,this.validate=U,this.productVersion=F,this.productDate=f,this.productCommit=P,this.devMode=z,this.language=M,this.translations=W}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,X){return(0,m.$Kg)(B.location,X.location)&&B.mtime===X.mtime&&(0,m.$Kg)(B.applicationExtensionslocation,X.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&B.profile===X.profile&&O.$Ln(B.profileScanOptions,X.profileScanOptions)&&B.type===X.type&&B.excludeObsolete===X.excludeObsolete&&B.validate===X.validate&&B.productVersion===X.productVersion&&B.productDate===X.productDate&&B.productCommit===X.productCommit&&B.devMode===X.devMode&&B.language===X.language&&q.equals(B.translations,X.translations)}}e.$aq=Z;let oe=class extends a.$Tc{constructor(B,X,T,C,H){super(),this.f=B,this.g=X,this.h=T,this.j=C,this.m=H}async scanExtensions(B){const X=B.profile?await this.r(B):await this.n(B);let T={};if(B.excludeObsolete&&B.type===1)try{const C=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(C)}catch{}return(0,b.$6f)(T)?X:X.filter(C=>!T[u.$ap.create(C).toString()])}async n(B){const X=await this.j.resolve(B.location);if(!X.children?.length)return[];const T=await Promise.all(X.children.map(async C=>{if(!C.isDirectory||B.type===1&&(0,m.$Og)(C.resource).indexOf(".")===0)return null;const H=new Z(C.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(H)}));return(0,L.$Hb)(T).sort((C,H)=>C.location.path<H.location.path?-1:1)}async r(B){let X=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){X=X.filter(C=>!C.metadata?.isApplicationScoped);const T=await this.s(B.applicationExtensionslocation,C=>!!C.metadata?.isBuiltin||!!C.metadata?.isApplicationScoped,B);X.push(...T)}return X}async s(B,X,T){const C=await this.g.scanProfileExtensions(B,T.profileScanOptions);if(!C.length)return[];const H=await Promise.all(C.map(async K=>{if(X(K)){const Y=new Z(K.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Y,K.metadata)}return null}));return(0,L.$Hb)(H)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,m.$Rg)(B.location,"package.json"))){const X=await this.scanExtension(B);return X?[X]:[]}else return await this.scanExtensions(B)}catch(X){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,A.$0)(X)),[]}}async scanExtension(B,X){try{let T=await this.scanExtensionManifest(B.location);if(T){T.publisher||(T.publisher=g.$sm),X=X??T.__metadata,delete T.__metadata;const C=(0,u.$ep)(T.publisher,T.name),H=X?.id?{id:C,uuid:X.id}:{id:C},K=X?.isSystem?0:B.type,Y=K===0||!!X?.isBuiltin;T=await this.t(B.location,T,Z.createNlsConfiguration(B));const _={type:K,identifier:H,manifest:T,location:B.location,isBuiltin:Y,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return B.validate?this.validate(_,B):_}}catch(T){B.type!==0&&this.m.error(T)}return null}validate(B,X){let T=!0;const C=(0,i.$pp)(X.productVersion,X.productDate,X.location,B.manifest,B.isBuiltin);for(const[H,K]of C)H===k.default.Error&&(T=!1,this.m.error(this.z(X.location,K)));return B.isValid=T,B.validations=C,B}async scanExtensionManifest(B){const X=(0,m.$Rg)(B,"package.json");let T;try{T=(await this.j.readFile(X)).value.toString()}catch(H){return(0,r.$Sk)(H)!==1&&this.m.error(this.z(B,(0,p.localize)(0,null,X.path,H.message))),null}let C;try{C=JSON.parse(T)}catch{const K=[];(0,S.$on)(T,K);for(const Y of K)this.m.error(this.z(B,(0,p.localize)(1,null,X.path,Y.offset,Y.length,(0,h.$9p)(Y.error))));return null}return(0,S.$xn)(C)!=="object"?(this.m.error(this.z(B,(0,p.localize)(2,null,X.path))),null):C}async t(B,X,T){const C=await this.u(B,X,T);if(C)try{const H=[],K=await this.w(C.default,H);if(H.length>0)return H.forEach(_=>{this.m.error(this.z(B,(0,p.localize)(3,null,C.default?.path,(0,h.$9p)(_.error))))}),X;if((0,S.$xn)(C)!=="object")return this.m.error(this.z(B,(0,p.localize)(4,null,C.default?.path))),X;const Y=C.values||Object.create(null);return(0,j.$0p)(this.m,X,Y,K)}catch{}return X}async u(B,X,T){const C=(0,m.$Rg)(B,"package.nls.json"),H=(U,F)=>{F.forEach(f=>{this.m.error(this.z(B,(0,p.localize)(5,null,U?.path,(0,h.$9p)(f.error))))})},K=U=>{this.m.error(this.z(B,(0,p.localize)(6,null,U?.path)))},Y=`${X.publisher}.${X.name}`,_=T.translations[Y];if(_)try{const U=c.URI.file(_),F=(await this.j.readFile(U)).value.toString(),f=[],P=(0,S.$on)(F,f);return f.length>0?(H(U,f),{values:void 0,default:C}):(0,S.$xn)(P)!=="object"?(K(U),{values:void 0,default:C}):{values:P.contents?P.contents.package:void 0,default:C}}catch{return{values:void 0,default:C}}else{if(!await this.j.exists(C))return;let F;try{F=await this.y(B,T)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const f=(await this.j.readFile(F.localized)).value.toString(),P=[],z=(0,S.$on)(f,P);return P.length>0?(H(F.localized,P),{values:void 0,default:F.original}):(0,S.$xn)(z)!=="object"?(K(F.localized),{values:void 0,default:F.original}):{values:z,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(B,X){if(B)try{const T=(await this.j.readFile(B)).value.toString();return(0,S.$on)(T,X)}catch{}}y(B,X){return new Promise((T,C)=>{const H=K=>{const Y=(0,m.$Rg)(B,`package.nls.${K}.json`);this.j.exists(Y).then(_=>{_&&T({localized:Y,original:(0,m.$Rg)(B,"package.nls.json")});const U=K.lastIndexOf("-");U===-1?T({localized:(0,m.$Rg)(B,"package.nls.json"),original:null}):(K=K.substring(0,U),H(K))})};if(X.devMode||X.pseudo||!X.language)return T({localized:(0,m.$Rg)(B,"package.nls.json"),original:null});H(X.language)})}z(B,X){return`[${B.path}]: ${X}`}};oe=me([se(1,R.$7p),se(2,v.$_k),se(3,r.$Bk),se(4,n.$yj)],oe);let re=class extends oe{constructor(B,X,T,C,H,K,Y){super(X,C,H,K,Y),this.G=B,this.H=T,this.D=this.B(new D.$ch(3e3)),this.F=this.B(new o.$5d),this.onDidChangeCache=this.F.event}async scanExtensions(B){const X=this.M(B),T=await this.I(X);if(this.C=B,T&&T.input&&Z.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),T.result.map(H=>(H.location=c.URI.revive(H.location),H));const C=await super.scanExtensions(B);return await this.J(X,{input:B,result:C}),C}async I(B){try{const X=await this.j.readFile(B),T=JSON.parse(X.value.toString());return{result:T.result,input:(0,l.$Nh)(T.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",B.path,(0,A.$0)(X))}return null}async J(B,X){try{await this.j.writeFile(B,N.$se.fromString(JSON.stringify(X)))}catch(T){this.m.debug("Error while writing the extension cache file:",B.path,(0,A.$0)(T))}}async L(){if(!this.C)return;const B=this.M(this.C),X=await this.I(B);if(!X)return;const T=X.result,C=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!O.$Ln(C,T))try{this.m.info("Invalidating Cache",T,C),await this.j.del(B),this.F.fire()}catch(H){this.m.error(H)}}M(B){const X=this.N(B);return this.h.extUri.joinPath(X.cacheHome,B.type===0?g.$rm:g.$qm)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(B.location,X.extensionsResource))??this.G:this.H.defaultProfile}};re=me([se(2,I.$bl),se(3,R.$7p),se(4,v.$_k),se(5,r.$Bk),se(6,n.$yj)],re);function he(ae,B){const X=(0,u.$cp)(ae.manifest.publisher,ae.manifest.name);return{id:X,identifier:new g.$wm(X),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:B,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.$bq=he;class de extends Q{constructor(B,X,T,C,H,K,Y,_,U,F,f,P){super(B,X,(0,m.$Rg)(T,".vscode-oss-dev","extensions","control.json"),C,H,K,Y,_,U,F,f,P),this.R=(async()=>{if(d.$z)try{const z=await this.w.readFile(c.URI.file(d.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(B){return this.R}}e.$cq=de}),define(ie[158],ne([0,1,58,9,34,6,2,15,16,24,4,23]),function(J,e,L,D,O,N,A,S,h,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;let d=class extends A.$Tc{constructor(w,k){super(),this.b=w,this.f=k,this.a=new D.$kh(5)}async postUninstall(w){const k=this.g(w,"uninstall");k&&(this.f.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(k.script,"uninstall",k.args,!0,w),this.f.info("Finished running post uninstall script",w.identifier.id,w.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",w.identifier.id,w.manifest.version),this.f.error(b)}}));try{await a.Promises.rm(this.m(w))}catch(b){this.f.error("Error while removing extension storage path",w.identifier.id),this.f.error(b)}}g(w,k){const b=`vscode:${k}`;if(w.location.scheme===S.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[b]=="string"){const c=w.manifest.scripts[b].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(w.identifier.id,w.manifest.version,`${b} should be a node script`),null):{script:(0,h.$jc)(w.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(w,k,b,c,p){return new Promise(($,u)=>{const g=this.j(w,k,b,p);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?u(t):$(void 0)};g.on("error",t=>{r((0,O.$2i)(t)||"Unknown")}),g.on("exit",(t,n)=>{r(t?`post-${k} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,g.kill(),u("timed out")},5e3))})}j(w,k,b,c){const p={silent:!0,execArgv:void 0},$=(0,L.fork)(w,[`--type=extension-post-${k}`,...b],p);$.stdout.setEncoding("utf8"),$.stderr.setEncoding("utf8");const u=N.Event.fromNodeEventEmitter($.stdout,"data"),g=N.Event.fromNodeEventEmitter($.stderr,"data");u(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${k}`,t)),g(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${k}`,t));const i=N.Event.any(N.Event.map(u,t=>({data:`%c${t}`,format:[""]})),N.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]})));return N.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),$}m(w){return(0,h.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};e.$eq=d,e.$eq=d=me([se(0,E.$bl),se(1,y.$yj)],d)}),define(ie[159],ne([0,1,9,14,20,34,7,6,43,2,31,15,16,17,44,3,11,28,24,49,99,59,18,157,21,26,42,52,144,158,116,137,145,50,13,10,4,32,25,22,23]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m,w,k,b,c,p,$,u,g,i,r,t,n,s,o,l,R,I,v,j,q,Q,Z,oe,re,he,de,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=e.$iq=void 0,e.$iq=(0,Z.$fi)(t.$No);const B=".vsctmp";let X=class extends r.$2p{constructor(U,F,f,P,z,M,W,G,te,le,ue,$e){super(U,F,ue,f,le,$e),this.eb=z,this.fb=M,this.gb=W,this.hb=te,this.db=new Map,this.qb=new y.$Bc;const we=this.B(G.createInstance(R.$eq));this.ab=this.B(G.createInstance(T,ce=>we.postUninstall(ce))),this.bb=this.B(new v.$gq($e,te,ue,this,this.F)),this.cb=this.B(G.createInstance(l.$dq));const fe=this.B(new j.$hq(this,this.eb,$e,M,ue,te,f));this.B(fe.onDidChangeExtensionsByAnotherSource(ce=>this.pb(ce))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,n.$kp)(this.hb,this.F)),this.ib}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const F=await this.ob(U),f=await(0,$.zip)((0,m.$Rg)(this.cb.extensionsDownloadDir,(0,c.$Ag)()).fsPath,F);return b.URI.file(f)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:F,cleanup:f}=await this.kb(U),P=d.$kc(F.fsPath);try{return await(0,I.$fq)(P)}finally{await f()}}getInstalled(U,F=this.H.defaultProfile.extensionsResource){return this.ab.scanExtensions(U??null,F)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.ab.scanUserExtensionAtLocation(U)}async install(U,F={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:f,cleanup:P}=await this.kb(U);try{const z=await(0,I.$fq)(d.$kc(f.fsPath)),M=(0,n.$ep)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,q.$rp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(u.localize(0,null,M,this.G.version));const G=(await this.I([{manifest:z,extension:f,options:F}])).find(({identifier:te})=>(0,n.$_o)(te,{id:M}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$4p)(new Error(`Unknown error while installing extension ${M}`))}finally{await P()}}async installFromLocation(U,F){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const f=await this.ab.scanUserExtensionAtLocation(U);if(!f||!f.manifest.name||!f.manifest.version)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.tb([[f,void 0]],F),this.F.info("Successfully installed extension",f.identifier.id,F.toString()),f}async installExtensionsFromProfile(U,F,f){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,F.toString(),f.toString());const P=(await this.ab.scanExtensions(1,F)).filter(z=>U.some(M=>(0,n.$_o)(M,z.identifier)));if(P.length){const z=await Promise.all(P.map(M=>this.ab.scanMetadata(M,F)));await this.tb(P.map((M,W)=>[M,z[W]]),f),this.F.info("Successfully installed extensions",P.map(M=>M.identifier.id),f.toString())}return P}async updateMetadata(U,F,f=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0,F.hasPreReleaseVersion=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),U=await this.ab.updateMetadata(U,F,f),this.bb.invalidate(f),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(u.localize(1,null));const F=await this.getTargetPlatform(),[f]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:F,compatible:!0},O.CancellationToken.None);if(!f)throw new Error(u.localize(2,null));await this.ab.setUninstalled(U);try{await this.ab.removeUninstalledExtension(U)}catch(P){throw new Error(u.localize(3,null,(0,N.$2i)(P)))}return this.installFromGallery(f)}$(U,F,f,P){return this.ab.copyExtension(U,F,f,P)}copyExtensions(U,F){return this.ab.copyExtensions(U,F)}markAsUninstalled(...U){return this.ab.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(U){this.F.error(U)}}async download(U,F,f){const{location:P}=await this.cb.download(U,F,!f);return P}async kb(U){if(U.scheme===E.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const F=(0,m.$Rg)(this.cb.extensionsDownloadDir,(0,c.$Ag)());return await this.gb.download(U,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.hb.del(F)}catch(P){this.F.error(P)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(U,F,f){if(b.URI.isUri(F))return new K(U,F,f,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const P=n.$ap.create(F).toString();let z=this.db.get(P);return z||(this.db.set(P,z=new H(U,F,f,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(P))),z}Z(U,F){return new Y(U,F.profileLocation,this.fb)}async ob(U){const F=async P=>{let z=await p.Promises.readdir(P);z=z.map(G=>d.$jc(P,G));const M=await Promise.all(z.map(G=>p.Promises.stat(G)));let W=Promise.resolve([]);return M.forEach((G,te)=>{const le=z[te];G.isFile()&&(W=W.then(ue=>[...ue,le])),G.isDirectory()&&(W=W.then(ue=>F(le).then($e=>[...ue,...$e])))}),W};return(await F(U.location.fsPath)).map(P=>({path:`extension/${d.$lc(U.location.fsPath,P)}`,localPath:P}))}async pb({added:U,removed:F}){if(F){const f=U&&this.D.extUri.isEqual(F.profileLocation,U.profileLocation)?F.extensions.filter(P=>U.extensions.every(z=>!(0,n.$_o)(z,P))):F.extensions;for(const P of f)this.F.info("Extensions removed from another source",P.id,F.profileLocation.toString()),this.u.fire({identifier:P,profileLocation:F.profileLocation})}if(U){const P=(await this.ab.scanExtensions(1,U.profileLocation)).filter(z=>U.extensions.some(M=>(0,n.$_o)(M,z.identifier)));this.s.fire(P.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,U.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:U.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(F=>this.qb.add(F)));const U=await this.hb.resolve(this.eb.userExtensionsLocation);for(const F of U.children??[])F.isDirectory&&this.qb.add(F.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(F=>this.sb(F)))}async sb(U){if(!U.affects(this.eb.userExtensionsLocation,1))return;const F=[];for(const f of U.rawAdded){if(this.qb.has(f)||!this.D.extUri.isEqual(this.D.extUri.dirname(f),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(f,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(f).startsWith(".")||!(await this.hb.stat(f)).isDirectory)continue;const P=await this.ab.scanUserExtensionAtLocation(f);P&&P.installedTimestamp===void 0&&(this.qb.add(f),F.push(P))}F.length&&(await this.tb(F.map(f=>[f,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(f=>f.identifier.id)))}async tb(U,F){const f=U.map(P=>P[0]);await this.ub(f),await this.fb.addExtensionsToProfile(U,F),this.s.fire(f.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:F})))}async ub(U){const F=await this.ab.getUninstalledExtensions();for(const f of U){const P=n.$ap.create(f);F[P.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",P.id),await this.ab.setInstalled(P),this.F.info("Removed the extension from uninstalled list:",P.id))}}};e.$jq=X,e.$jq=X=me([se(0,t.$Ko),se(1,he.$Fl),se(2,oe.$yj),se(3,i.$mi),se(4,o.$$p),se(5,s.$7p),se(6,g.$po),se(7,Z.$di),se(8,Q.$Bk),se(9,re.$Qj),se(10,de.$_k),se(11,ae.$bl)],X);let T=class extends a.$Tc{constructor(U,F,f,P,z,M){super(),this.j=U,this.m=F,this.n=f,this.s=P,this.t=z,this.u=M,this.h=this.B(new S.$5d),this.onExtract=this.h.event,this.c=(0,m.$Rg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$lh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,F){const f={includeInvalid:!0,profileLocation:F};let P=[];return U===null||U===0?P.push(...await this.n.scanAllExtensions({includeInvalid:!0},f,!1)):U===1&&P.push(...await this.n.scanUserExtensions(f)),P=U!==null?P.filter(z=>z.type===U):P,Promise.all(P.map(z=>this.F(z)))}async scanAllUserExtensions(U){const F=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(F.map(f=>this.F(f)))}async scanUserExtensionAtLocation(U){try{const F=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(U,F,f,P,z){const M=U.toString(),W=b.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Ag)()}`)),G=b.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,M));let te=await this.m.exists(G);if(te&&P){try{await this.y(U.id,G,"removeExisting")}catch{throw new t.$Lo(u.localize(4,null,G.fsPath,U.id),t.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.n.updateMetadata(G,f);else try{try{this.u.trace(`Started extracting the extension from ${F} to ${G.fsPath}`),await(0,$.$Zp)(F,W.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${G}:`,U.id)}catch(le){let ue=t.ExtensionManagementErrorCode.Extract;throw le instanceof $.$Xp&&(le.type==="CorruptZip"?ue=t.ExtensionManagementErrorCode.CorruptZip:le.type==="Incomplete"&&(ue=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$Lo(le.message,ue)}await this.n.updateMetadata(W,f);try{this.u.trace(`Started renaming the extension from ${W.fsPath} to ${G.fsPath}`),await this.C(W.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(le){if(le.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(le)}. Deleted from extracted location`,W),le}this.h.fire(G)}catch(le){try{await this.m.del(W,{recursive:!0})}catch{}throw le}return this.D(G,1)}async scanMetadata(U,F){return F?(await this.w(U,F))?.metadata:this.n.scanMetadata(U.location)}async w(U,F){return(await this.s.scanProfileExtensions(F)).find(P=>(0,n.$_o)(P.identifier,U.identifier))}async updateMetadata(U,F,f){return f?await this.s.updateMetadata([[U,F]],f):await this.n.updateMetadata(U.location,F),this.D(U.location,U.type,f)}getUninstalledExtensions(){return this.z()}async setUninstalled(...U){const F=U.map(f=>n.$ap.create(f));await this.z(f=>F.forEach(P=>{f[P.toString()]=!0,this.u.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(U){await this.z(F=>delete F[U.toString()])}async removeExtension(U,F){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,F)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(F=>delete F[n.$ap.create(U).toString()])}async copyExtension(U,F,f,P){const z=await this.w(U,F),M=await this.w(U,f);if(P={...z?.metadata,...P},M)if(this.t.extUri.isEqual(M.location,U.location))await this.s.updateMetadata([[U,{...M.metadata,...P}]],f);else{const W=await this.D(M.location,U.type,f);await this.s.removeExtensionFromProfile(W,f),await this.s.addExtensionsToProfile([[U,{...M.metadata,...P}]],f)}else await this.s.addExtensionsToProfile([[U,P]],f);return this.D(U.location,U.type,f)}async copyExtensions(U,F){const f=await this.scanExtensions(1,U),P=await Promise.all(f.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,U)]));await this.s.addExtensionsToProfile(P,F)}async y(U,F,f){this.u.trace(`Deleting ${f} extension from disk`,U,F.fsPath);const P=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,h.$5i)((0,c.$Ag)()).toString(16)}${B}`);await this.C(F.fsPath,P.fsPath),await this.m.del(P,{recursive:!0}),this.u.info(`Deleted ${f} extension from disk`,U,F.fsPath)}async z(U){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,Q.$Sk)(P)!==1)throw P}let f={};if(F)try{f=JSON.parse(F)}catch{}return U&&(U(f),Object.keys(f).length?await this.m.writeFile(this.c,D.$se.fromString(JSON.stringify(f))):await this.m.del(this.c)),f})}async C(U,F){try{await p.Promises.rename(U,F,2*60*1e3)}catch(f){throw new t.$Lo(f.message||u.localize(5,null,U,F),f.code||t.ExtensionManagementErrorCode.Rename)}}async D(U,F,f){if(f){const z=(await this.n.scanUserExtensions({profileLocation:f})).find(M=>this.t.extUri.isEqual(M.location,U));if(z)return this.F(z)}else{const P=await this.n.scanExistingExtension(U,F,{includeInvalid:!0});if(P)return this.F(P)}throw new Error(u.localize(6,null,U.path))}async F(U){const F=await this.m.resolve(U.location);let f,P;return F.children&&(f=F.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,P=F.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:f,changelogUrl:P,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!U.metadata?.hasPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),f=new Set;for(const z of F)U[n.$ap.create(z).toString()]||f.add(z.identifier.id.toLowerCase());try{const z=(0,n.$fp)(F,M=>M.identifier);await L.Promises.settled(z.map(async M=>{const W=M.sort((G,te)=>w.rcompare(G.manifest.version,te.manifest.version))[0];f.has(W.identifier.id.toLowerCase())||await this.j(await this.F(W))}))}catch(z){this.u.error(z)}const P=F.filter(z=>z.metadata&&U[n.$ap.create(z).toString()]);await Promise.allSettled(P.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,Q.$Sk)(F)!==1&&this.u.error(F);return}if(U?.children)try{await Promise.allSettled(U.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(f){(0,Q.$Sk)(f)!==1&&this.u.error(f)}}}))}catch{}}};e.$kq=T,e.$kq=T=me([se(1,Q.$Bk),se(2,o.$$p),se(3,s.$7p),se(4,de.$_k),se(5,oe.$yj)],T);class C extends r.$5p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,k.$Zf)(this.options.operation)?this.l:this.options.operation}constructor(U,F,f,P,z,M,W,G,te){super(),this.identifier=U,this.source=F,this.options=f,this.m=P,this.n=z,this.o=M,this.p=W,this.q=G,this.s=te,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[F,f]=await this.x(U);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,f]],this.j),F}async u({zipPath:U,key:F,metadata:f},P,z){let M=await this.v(F);return M?M=await this.m.updateMetadata(M,f):(this.s.trace("Extracting extension...",F.id),M=await this.m.extractUserExtension(F,U,f,P,z),this.s.info("Extracting extension completed.",F.id)),M}async v(U){return await this.w(U)?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(P=>n.$ap.create(P).equals(U))):void 0}async w(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}}class H extends C{constructor(U,F,f,P,z,M,W,G,te,le){super(F.identifier,F,f,z,M,W,G,te,le),this.y=F,this.z=P}async x(U){let F;try{F=await this.m.scanExtensions(null,this.options.profileLocation)}catch(W){throw new t.$Lo(W,t.ExtensionManagementErrorCode.Scanning)}const f=F.find(W=>(0,n.$_o)(W.identifier,this.y.identifier));f&&(this.l=3);const P={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||f?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||f?.isMachineScoped,isBuiltin:this.options.isBuiltin||f?.isBuiltin,isSystem:f?.type===0?!0:void 0,updated:!!f,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:f?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??f?.pinned,preRelease:(0,k.$Yf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||f?.preRelease};if(f?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(f,P),P]}catch(W){throw new t.$Lo((0,A.$0)(W),t.ExtensionManagementErrorCode.UpdateMetadata)}const{location:z,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:n.$ap.create(this.y),metadata:P},!1,U),P]}catch(W){try{await this.z.delete(z)}catch(G){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,A.$0)(G))}throw W}}async B(U){try{await(0,I.$fq)(U)}catch(F){throw new t.$Lo((0,r.$3p)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$lq=H;class K extends C{constructor(U,F,f,P,z,M,W,G,te,le){super({id:(0,n.$ep)(U.publisher,U.name)},F,f,z,M,W,G,te,le),this.y=U,this.z=F,this.A=P}async h(U){const F=await super.h(U);return this.D(F,U),F}async x(U){const F=new n.$ap(this.identifier,this.y.version),P=(await this.m.scanExtensions(1,this.options.profileLocation)).find(W=>(0,n.$_o)(this.identifier,W.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??P?.pinned};if(P)if(this.l=3,F.equals(new n.$ap(P.identifier,P.manifest.version)))try{await this.m.removeExtension(P,"existing")}catch{throw new Error(u.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&w.gt(P.manifest.version,this.y.version)&&await this.m.setUninstalled(P);else{const W=await this.v(F);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(u.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$kc(this.z.fsPath),key:F,metadata:z},!0,U),z]}async D(U,F){try{let[f]=await this.A.getExtensions([{id:U.identifier.id,version:U.manifest.version}],F);if(f||([f]=await this.A.getExtensions([{id:U.identifier.id}],F)),f){const P={id:f.identifier.uuid,publisherDisplayName:f.publisherDisplayName,publisherId:f.publisherId,isPreReleaseVersion:f.properties.isPreReleaseVersion,hasPreReleaseVersion:U.hasPreReleaseVersion||f.properties.isPreReleaseVersion,preRelease:f.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,P,this.options.profileLocation)}}catch{}}}class Y extends r.$5p{constructor(U,F,f){super(),this.extension=U,this.j=F,this.k=f}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ie[160],ne([0,1,4,23,22,25,42,13,18,11]),function(J,e,L,D,O,N,A,S,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=void 0;let y=class extends A.$8p{constructor(d,m,w,k,b,c){super(a.URI.file(d.extensionsPath),m,w,k,b,c)}};e.$zP=y,e.$zP=y=me([se(0,h.$mi),se(1,S.$Bk),se(2,D.$bl),se(3,O.$_k),se(4,N.$Fl),se(5,L.$yj)],y)}),define(ie[161],ne([0,1,11,18,42,52,13,10,4,32,22,23]),function(J,e,L,D,O,N,A,S,h,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1_b=void 0;let d=class extends N.$cq{constructor(w,k,b,c,p,$,u,g){super(L.URI.file(p.builtinExtensionsPath),L.URI.file(p.extensionsPath),p.userHome,w.defaultProfile,w,k,b,c,p,$,u,g)}};e.$1_b=d,e.$1_b=d=me([se(0,E.$bl),se(1,O.$7p),se(2,A.$Bk),se(3,h.$yj),se(4,D.$mi),se(5,a.$Qj),se(6,y.$_k),se(7,S.$di)],d)}),define(ie[162],ne([0,1,9,6,2,127,3,88,10,23]),function(J,e,L,D,O,N,A,S,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Fp=e.$Ep=e.$Dp=void 0,e.$Dp="__$__isNewStorageMarker",e.$Ep="__$__targetStorageMarker",e.$Fp=(0,h.$ei)("storageService");var y;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var E;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var d;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function m(p){const $=p.get(e.$Ep);if($)try{return JSON.parse($)}catch{}return Object.create(null)}e.$Gp=m;class w extends O.$Tc{static{this.a=60*1e3}constructor($={flushInterval:w.a}){super(),this.m=$,this.b=this.B(new D.$8d),this.c=this.B(new D.$8d),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$5d),this.onWillSaveState=this.f.event,this.h=this.B(new L.$qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new O.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,u,g){return D.Event.filter(this.b.event,i=>i.scope===$&&(u===void 0||i.key===u),g)}n(){this.j.value=(0,L.$uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,O.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,u){const{key:g,external:i}=u;if(g===e.$Ep){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:g,target:this.J($)[g],external:i})}w($){this.f.fire({reason:$})}get($,u,g){return this.P(u)?.get($,g)}getBoolean($,u,g){return this.P(u)?.getBoolean($,g)}getNumber($,u,g){return this.P(u)?.getNumber($,g)}getObject($,u,g){return this.P(u)?.getObject($,g)}storeAll($,u){this.y(()=>{for(const g of $)this.store(g.key,g.value,g.scope,g.target,u)})}store($,u,g,i,r=!1){if((0,A.$2f)(u)){this.remove($,g,r);return}this.y(()=>{this.z($,g,i),this.P(g)?.set($,u,r)})}remove($,u,g=!1){this.y(()=>{this.z($,u,void 0),this.P(u)?.delete($,g)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,u){const g=[],i=this.J($);for(const r of Object.keys(i))i[r]===u&&g.push(r);return g}z($,u,g,i=!1){const r=this.J(u);typeof g=="number"?r[$]!==g&&(r[$]=g,this.P(u)?.set(e.$Ep,JSON.stringify(r),i)):typeof r[$]=="number"&&(delete r[$],this.P(u)?.set(e.$Ep,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const u=this.P($);return u?m(u):Object.create(null)}isNew($){return this.getBoolean(e.$Dp,$)===!0}async flush($=y.NONE){this.f.fire({reason:$});const u=this.P(-1),g=this.P(0),i=this.P(1);switch($){case y.NONE:await L.Promises.settled([u?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await L.Promises.settled([u?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,u=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return c($,u,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,u){return this.w(y.NONE),(0,a.$al)($)?this.R($,u):this.S($,u)}M($,u){return!($.id===u.id||k(u)&&k($))}N($,u,g){this.y(()=>{const i=new Set;for(const[r,t]of $)i.add(r),u.get(r)!==t&&this.u(g,{key:r,external:!0});for(const[r]of u.items)i.has(r)||this.u(g,{key:r,external:!0})})}}e.$Hp=w;function k(p){return p.isDefault||!!p.useDefaultFlags?.globalState}e.$Ip=k;class b extends w{constructor(){super(),this.U=this.B(new S.$Bp(new S.$Cp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Bp(new S.$Cp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Bp(new S.$Cp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$Jp=b;async function c(p,$,u,g,i,r){const t=q=>{try{return JSON.parse(q)}catch{return q}},n=new Map,s=new Map;p.forEach((q,Q)=>{n.set(Q,q),s.set(Q,t(q))});const o=new Map,l=new Map;$.forEach((q,Q)=>{o.set(Q,q),l.set(Q,t(q))});const R=new Map,I=new Map;u.forEach((q,Q)=>{R.set(Q,q),I.set(Q,t(q))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const v=[];if(n.forEach((q,Q)=>{v.push({key:Q,value:q})}),console.table(v),console.groupEnd(),console.log(s),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const q=[];o.forEach((Q,Z)=>{q.push({key:Z,value:Q})}),console.table(q),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const j=[];R.forEach((q,Q)=>{j.push({key:Q,value:q})}),console.table(j),console.groupEnd(),console.log(I)}e.$Kp=c}),define(ie[163],ne([0,1,19,20,7,12,35,3,11,29,18,21,26,50,13,4,32,45,146,162,25,176]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m,w,k,b,c,p,$,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.$Np=void 0;const i=N.$o?"web":(0,E.$Go)(N.$u,A.$ec),r="X-Market-Search-Activity-Id";var t;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...P){return String(P.reduce((z,M)=>z|M,0))}var s;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class v{constructor(z=I){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,M=this.d.pageSize){return new v({...this.d,pageNumber:z,pageSize:M})}withFilter(z,...M){const W=[...this.d.criteria,...M.length?M.map(G=>({filterType:z,value:G})):[{filterType:z}]];return new v({...this.d,criteria:W})}withSortBy(z){return new v({...this.d,sortBy:z})}withSortOrder(z){return new v({...this.d,sortOrder:z})}withFlags(...z){return new v({...this.d,flags:z.reduce((M,W)=>M|W,0)})}withAssetTypes(...z){return new v({...this.d,assetTypes:z})}withSource(z){return new v({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:M,pageSize:W,sortBy:G,sortOrder:te,flags:le,assetTypes:ue}=this.d;return{filters:[{criteria:z,pageNumber:M,pageSize:W,sortBy:G,sortOrder:te}],assetTypes:ue,flags:le}}get searchText(){const z=this.d.criteria.filter(M=>M.filterType===s.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(P,z){const M=(P||[]).filter(W=>W.statisticName===z)[0];return M?M.value:0}function q(P){const z="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(W=>W.assetType.indexOf(z)===0).reduce((W,G)=>{const te=oe(P,G.assetType);return te&&W.push([G.assetType.substring(z.length),te]),W},[])}function Q(P){if(P.properties){const z=P.properties.filter(G=>G.key===o.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=z.filter(G=>M.test(G.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return oe(P,o.Repository)}function Z(P){return{uri:`${P.fallbackAssetUri}/${o.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${o.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function oe(P,z){return P.files.filter(W=>W.assetType===z)[0]?{uri:`${P.assetUri}/${z}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${z}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function re(P,z){const M=P.properties?P.properties.filter(G=>G.key===z):[],W=M.length>0&&M[0].value;return W?W.split(",").map(G=>(0,d.$dp)(G)):[]}function he(P){const z=P.properties?P.properties.filter(M=>M.key===l.Engine):[];return z.length>0&&z[0].value||""}function de(P){const z=P.properties?P.properties.filter(M=>M.key===l.PreRelease):[];return z.length>0&&z[0].value==="true"}function ae(P){const z=P.properties?P.properties.filter(W=>W.key===l.LocalizedLanguages):[],M=z.length>0&&z[0].value||"";return M?M.split(","):[]}function B(P){return P.properties?.find(z=>z.key===l.SponsorLink)?.value}function X(P){return P.properties?.find(z=>z.key===l.SupportLink)?.value}function T(P){return P.indexOf("preview")!==-1}function C(P){return P.targetPlatform?(0,E.$Fo)(P.targetPlatform):"undefined"}function H(P){const z=(0,L.$Mb)(P.versions.map(C)),M=!!P.tags?.includes(E.$Ao),W=z.indexOf("web");return M?W===-1&&z.push("web"):W!==-1&&z.splice(W,1),z}function K(P,z){for(let M=0;M<P.length;M++){const W=P[M];if(W.version===P[M-1]?.version){let G=M;if(C(W)===z)for(;G>0&&P[G-1].version===W.version;)G--;G!==M&&(P.splice(M,1),P.splice(G,0,W))}}return P}e.$Np=K;function Y(P,z,M){P.telemetryData={index:z,querySource:M,queryActivityId:P.queryContext?.[r]}}function _(P,z,M,W){const G=P.versions[0],te={manifest:oe(z,o.Manifest),readme:oe(z,o.Details),changelog:oe(z,o.Changelog),license:oe(z,o.License),repository:Q(z),download:Z(z),icon:oe(z,o.Icon),signature:oe(z,o.Signature),coreTranslations:q(z)};return{identifier:{id:(0,d.$ep)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:z.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(G),description:P.shortDescription||"",installCount:j(P.statistics,"install"),rating:j(P.statistics,"averagerating"),ratingCount:j(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:M,assets:te,properties:{dependencies:re(z,l.Dependency),extensionPack:re(z,l.ExtensionPack),engine:he(z),localizedLanguages:ae(z),targetPlatform:C(z),isPreReleaseVersion:de(z)},hasPreReleaseVersion:de(G),hasReleaseVersion:!0,preview:T(P.flags),isSigned:!!te.signature,queryContext:W,supportLink:X(G)}}let U=class{constructor(z,M,W,G,te,le,ue,$e){this.k=M,this.l=W,this.n=G,this.o=te,this.q=le,this.u=ue,this.w=$e;const we=ue.extensionsGallery,fe=we?.servicePPEUrl&&$e.getValue("_extensionsGallery.enablePPE");this.d=fe?we.servicePPEUrl:we?.serviceUrl,this.g=fe?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,p.$Mp)(ue.version,ue,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,M,W){const G=D.CancellationToken.isCancellationToken(M)?{}:M,te=D.CancellationToken.isCancellationToken(M)?M:W,le=[],ue=[],$e=[],we=[];let fe=!0;for(const be of z){be.uuid?ue.push(be.uuid):le.push(be.id);const Se=!!(be.version||be.preRelease);$e.push({id:be.id,uuid:be.uuid,includePreRelease:Se}),be.version&&we.push({id:be.id,uuid:be.uuid,version:be.version}),fe=fe&&!!be.hasPreRelease&&!Se}if(!ue.length&&!le.length)return[];let ce=new v().withPage(1,z.length);ue.length&&(ce=ce.withFilter(s.ExtensionId,...ue)),le.length&&(ce=ce.withFilter(s.ExtensionName,...le)),(G.queryAllVersions||fe)&&(ce=ce.withFlags(ce.flags,t.IncludeVersions)),G.source&&(ce=ce.withSource(G.source));const{extensions:pe}=await this.z(ce,{targetPlatform:G.targetPlatform??i,includePreRelease:$e,versions:we,compatible:!!G.compatible},te);return G.source&&pe.forEach((be,Se)=>Y(be,Se,G.source)),pe}async getCompatibleExtension(z,M,W){if((0,E.$Ho)(z.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(z,M,W))return z;const G=new v().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,z.identifier.uuid),{extensions:te}=await this.z(G,{targetPlatform:W,compatible:!0,includePreRelease:M},D.CancellationToken.None);return te[0]||null}async isExtensionCompatible(z,M,W){if(!(0,E.$Io)(z.properties.targetPlatform,z.allTargetPlatforms,W)||!M&&z.properties.isPreReleaseVersion)return!1;let G=z.properties.engine;if(!G){const te=await this.getManifest(z,D.CancellationToken.None);if(!te)throw new Error("Manifest was not found");G=te.engines.vscode}return(0,m.$rp)(G,this.u.version,this.u.date)}async y(z,M,W,G,te){if(!(0,E.$Io)(C(z),G,te)||M!=="any"&&de(z)!==(M==="prerelease"))return!1;if(W)try{const le=await this.E(z);if(!(0,m.$rp)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${z.version}.`,(0,O.$0)(le)),!1}return!0}async query(z,M){let W=z.text||"";const G=z.pageSize??50;let te=new v().withPage(1,G);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ce,pe)=>(te=te.withFilter(s.Category,pe||ce),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ce,pe)=>(te=te.withFilter(s.Tag,pe||ce),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(s.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),te=te.withFilter(s.SearchText,W)),te=te.withSortBy(0)):z.ids?te=te.withFilter(s.ExtensionId,...z.ids):z.names?te=te.withFilter(s.ExtensionName,...z.names):te=te.withSortBy(4),typeof z.sortBy=="number"&&(te=te.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(te=te.withSortOrder(z.sortOrder)),z.source&&(te=te.withSource(z.source));const le=async(fe,ce)=>{const{extensions:pe,total:be}=await this.z(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!z.includePreRelease},ce);return pe.forEach((Se,je)=>Y(Se,(fe.pageNumber-1)*fe.pageSize+je,z.source)),{extensions:pe,total:be}},{extensions:ue,total:$e}=await le(te,M),we=async(fe,ce)=>{if(ce.isCancellationRequested)throw new O.$5;const{extensions:pe}=await le(te.withPage(fe+1),ce);return pe};return{firstPage:ue,total:$e,pageSize:te.pageSize,getPage:we}}async z(z,M,W){const G=z.flags;z.flags&t.IncludeLatestVersionOnly&&z.flags&t.IncludeVersions&&(z=z.withFlags(z.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(z.flags&t.IncludeLatestVersionOnly)&&!(z.flags&t.IncludeVersions)&&(z=z.withFlags(z.flags,t.IncludeLatestVersionOnly)),M.versions?.length&&(z=z.withFlags(z.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),z=z.withFlags(z.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:le,context:ue}=await this.B(z,W);if(!(z.flags&t.IncludeLatestVersionOnly)){const ce=[];for(const pe of te){const be=await this.A(pe,M,ue);be&&ce.push(be)}return{extensions:ce,total:le}}const we=[],fe=new Map;for(let ce=0;ce<te.length;ce++){const pe=te[ce],be={id:(0,d.$ep)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Se=(0,S.$Yf)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(V=>(0,d.$_o)(V,be))?.includePreRelease;if(M.compatible&&(0,E.$Ho)(H(pe),M.targetPlatform))continue;const je=await this.A(pe,M,ue);!je||je.properties.isPreReleaseVersion&&(!Se||!je.hasReleaseVersion)||!je.properties.isPreReleaseVersion&&je.properties.targetPlatform!==M.targetPlatform&&je.hasPreReleaseVersion?fe.set(pe.extensionId,ce):we.push([ce,je])}if(fe.size){const ce=new g.$1d,pe=new v().withFlags(G&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:be}=await this.z(pe,M,W);this.o.publicLog2("galleryService:additionalQuery",{duration:ce.elapsed(),count:fe.size});for(const Se of be){const je=fe.get(Se.identifier.uuid);we.push([je,Se])}}return{extensions:we.sort((ce,pe)=>ce[0]-pe[0]).map(([,ce])=>ce),total:le}}async A(z,M,W){const G={id:(0,d.$ep)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},te=M.versions?.find(we=>(0,d.$_o)(we,G))?.version,le=(0,S.$Yf)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(we=>(0,d.$_o)(we,G))?.includePreRelease,ue=H(z),$e=K(z.versions,M.targetPlatform);if(M.compatible&&(0,E.$Ho)(ue,M.targetPlatform))return null;for(let we=0;we<$e.length;we++){const fe=$e[we];if(!(te&&fe.version!==te)){if(await this.y(fe,le?"any":"release",M.compatible,ue,M.targetPlatform))return _(z,fe,ue,W);if(te&&fe.version===te)return null}}return te||M.compatible?null:_(z,z.versions[0],ue)}async B(z,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(t.Unpublished));const W=await this.j,G=JSON.stringify(z.raw),te={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},le=new g.$1d;let ue,$e,we=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&z.criteria.some(ce=>ce.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:te},M),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:we};const fe=await(0,c.$yp)(ue);if(fe){const ce=fe.results[0],pe=ce.extensions,be=ce.resultMetadata&&ce.resultMetadata.filter(Se=>Se.metadataType==="ResultCount")[0];return we=be&&be.metadataItems.filter(Se=>Se.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:we,context:{[r]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(fe){const ce=(0,O.$4)(fe)?E.ExtensionGalleryErrorCode.Cancelled:(0,O.$0)(fe).startsWith("XHR timeout")?E.ExtensionGalleryErrorCode.Timeout:E.ExtensionGalleryErrorCode.Failed;throw $e=new E.$Mo((0,O.$0)(fe),ce),$e}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(G.length),duration:le.elapsed(),success:!!ue&&(0,c.$up)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:$e?.code,count:String(we)})}}async reportStatistic(z,M,W,G){if(!this.isEnabled())return;const te=N.$o?this.x(`/itemName/${z}.${M}/version/${W}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${M}/${W}/stats?statType=${G}`),le=N.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",$e={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:te,headers:$e},D.CancellationToken.None)}catch{}}async download(z,M,W){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const G=(0,d.$hp)(z),te=new Date().getTime(),le=ce=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:ce}),ue=W===2?"install":W===3?"update":"",$e=ue?{uri:`${z.assets.download.uri}${h.URI.parse(z.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${z.assets.download.fallbackUri}${h.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:z.assets.download,we=z.queryContext?.[r]?{[r]:z.queryContext[r]}:void 0,fe=await this.D($e,we?{headers:we}:void 0);await this.q.writeFile(M,fe.stream),le(new Date().getTime()-te)}async downloadSignatureArchive(z,M){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const W=await this.D(z.assets.signature);await this.q.writeFile(M,W.stream)}async getReadme(z,M){if(z.assets.readme){const W=await this.D(z.assets.readme,{},M);return await(0,c.$xp)(W)||""}return""}async getManifest(z,M){if(z.assets.manifest){const W=await this.D(z.assets.manifest,{},M),G=await(0,c.$xp)(W);return G?JSON.parse(G):null}return null}async C(z,M){const W=oe(z,o.Manifest);if(!W)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},te=await this.D(W,{headers:G});return await(0,c.$yp)(te)}async getCoreTranslation(z,M){const W=z.assets.coreTranslations.filter(G=>G[0]===M.toUpperCase())[0];if(W){const G=await this.D(W[1]),te=await(0,c.$xp)(G);return te?JSON.parse(te):null}return null}async getChangelog(z,M){if(z.assets.changelog){const W=await this.D(z.assets.changelog,{},M);return await(0,c.$xp)(W)||""}return""}async getAllCompatibleVersions(z,M,W){let G=new v().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?G=G.withFilter(s.ExtensionId,z.identifier.uuid):G=G.withFilter(s.ExtensionName,z.identifier.id);const{galleryExtensions:te}=await this.B(G,D.CancellationToken.None);if(!te.length)return[];const le=H(te[0]);if((0,E.$Ho)(le,W))return[];const ue=[];await Promise.all(te[0].versions.map(async fe=>{try{await this.y(fe,M?"any":"release",!0,le,W)&&ue.push(fe)}catch{}}));const $e=[],we=new Set;for(const fe of K(ue,W))we.has(fe.version)||(we.add(fe.version),$e.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:de(fe)}));return $e}async D(z,M={},W=D.CancellationToken.None){const G=await this.j,te={type:"GET"},le={...G,...M.headers||{}};M={...M,...te,headers:le};const ue=z.uri,$e=z.fallbackUri,we={...M,url:ue};try{const fe=await this.k.request(we,W);if(fe.res.statusCode===200)return fe;const ce=await(0,c.$xp)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${ce}`)}catch(fe){if((0,O.$4)(fe))throw fe;const ce=(0,O.$0)(fe);this.o.publicLog2("galleryService:cdnFallback",{url:ue,message:ce});const pe={...M,url:$e};return this.k.request(pe,W)}}async E(z){let M=he(z);if(!M){const W=await this.C(z,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");M=W.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,c.$yp)(z),W=[],G={},te=[];if(M){for(const le of M.malicious)W.push({id:le});if(M.migrateToPreRelease)for(const[le,ue]of Object.entries(M.migrateToPreRelease))(!ue.engine||(0,m.$rp)(ue.engine,this.u.version,this.u.date))&&(G[le.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[le,ue]of Object.entries(M.deprecated))ue&&(G[le.toLowerCase()]=(0,S.$Yf)(ue)?{}:ue);if(M.search)for(const le of M.search)te.push(le)}return{malicious:W,deprecated:G,search:te}}};U=me([se(1,c.$sp),se(2,k.$yj),se(3,y.$li),se(4,u.$Fl),se(5,w.$Bk),se(6,b.$Qj),se(7,a.$Ki)],U);let F=class extends U{constructor(z,M,W,G,te,le,ue,$e){super(z,M,W,G,te,le,ue,$e)}};e.$Op=F,e.$Op=F=me([se(0,$.$Fp),se(1,c.$sp),se(2,k.$yj),se(3,y.$li),se(4,u.$Fl),se(5,w.$Bk),se(6,b.$Qj),se(7,a.$Ki)],F);let f=class extends U{constructor(z,M,W,G,te,le,ue){super(void 0,z,M,W,G,te,le,ue)}};e.$Pp=f,e.$Pp=f=me([se(0,c.$sp),se(1,k.$yj),se(2,y.$li),se(3,u.$Fl),se(4,w.$Bk),se(5,b.$Qj),se(6,a.$Ki)],f)}),define(ie[164],ne([0,1,11,18,13,4,142,22,23,3,68]),function(J,e,L,D,O,N,A,S,h,a,y){"use strict";var E,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.$xP=e.$wP=void 0;let m=class extends h.$el{static{E=this}static{this.a="profileAssociationsMigration"}constructor(c,p,$,u,g){super($,u,p,g),this.U=c,this.W=$}O(){return this.U.getItem(E.b,[]).map(p=>({...p,location:(0,a.$Sf)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):L.URI.revive(p.location)}))}Q(){const c=this.U.getItem(E.c,{});return this.U.getItem(E.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$wP=m,e.$wP=m=E=me([se(0,A.$rP),se(1,S.$_k),se(2,D.$mi),se(3,O.$Bk),se(4,N.$yj)],m);let w=d=class extends m{constructor(c,p,$,u,g){super(c,p,$,u,g),this.$=c}P(c){c.length?this.$.setItem(d.b,c.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(d.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(d.c,c):this.$.removeItem(d.c)}Q(){const c="workspaceAndProfileInfo",p=this.$.getItem(c,void 0);if(p){this.$.removeItem(c);const u=p.reduce((g,{workspace:i,profile:r})=>(g[L.URI.revive(i).toString()]=L.URI.revive(r).toString(),g),{});this.$.setItem(d.c,{workspaces:u})}const $=super.Q();return this.$.getItem(d.a,!1)||(this.R($),this.$.setItem(d.a,!0)),$}};e.$xP=w,e.$xP=w=d=me([se(0,A.$sP),se(1,S.$_k),se(2,D.$mi),se(3,O.$Bk),se(4,N.$yj)],w);let k=class extends w{constructor(c,p,$,u){super(new y.$vP(0,p,u,$),c,p,$,u)}async init(){return await this.$.init(),super.init()}};e.$yP=k,e.$yP=k=me([se(0,S.$_k),se(1,D.$mi),se(2,O.$Bk),se(3,N.$yj)],k)}),define(ie[165],ne([0,1,140,9,14,7,3,29,18,141,4,45,139,177]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=void 0;let w=class extends E.$tp{constructor(p,$,u,g){super(g),this.m=p,this.n=$,this.r=u,this.s(),this.B(p.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,$){const{f:u,g}=this;let i;try{i=await(0,a.$km)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,N.$0)(n)))}const r={...process.env,...i},t=p.agent?p.agent:await(0,d.$xr)(p.url||"",r,{proxyUrl:u,strictSSL:g});return p.agent=t,p.strictSSL=g,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>b(p,$))}async resolveProxy(p){}async loadCertificates(){return(await new Promise(($,u)=>{J(["@vscode/proxy-agent"],$,u)})).loadSystemCertificates({log:this.r})}};e.$yr=w,e.$yr=w=me([se(0,S.$Ki),se(1,h.$mi),se(2,y.$yj),se(3,y.$zj)],w);async function k(c){return((0,L.parse)(c.url).protocol==="https:"?await new Promise((u,g)=>{J(["https"],u,g)}):await new Promise((u,g)=>{J(["http"],u,g)})).request}async function b(c,p){return D.Promises.withAsyncBody(async($,u)=>{const g=(0,L.parse)(c.url),i=c.getRawRequest?c.getRawRequest(c):await k(c),r={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,A.$Yf)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=i(r,n=>{const s=(0,A.$Wf)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)b({...c,url:n.headers.location,followRedirects:s-1},p).then($,u);else{let o=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,m.createGunzip)())),$({res:n,stream:(0,O.$He)(o)})}});t.on("error",u),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),p.onCancellationRequested(()=>{t.abort(),u(new N.$5)})})}e.$zr=b}),define(ie[178],ne([0,1,33,9,34,7,2,15,16,12,35,11,24,29,136,59,138,18,114,163,21,64,143,42,52,159,161,13,126,128,51,124,62,63,147,4,132,39,133,150,32,45,165,68,69,25,149,41,151,152,22,154,23,164,153,160,129,131,5,155]),function(J,e,L,D,O,N,A,S,h,a,y,E,d,m,w,k,b,c,p,$,u,g,i,r,t,n,s,o,l,R,I,v,j,q,Q,Z,oe,re,he,de,ae,B,X,T,C,H,K,Y,_,U,F,f,P,z,M,W,G,te,le,ue){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class $e extends A.$Tc{constructor(ce){super(),this.b=ce,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[ce,pe]=await this.f();return ce.invokeFunction(async be=>{const Se=be.get(Z.$yj),je=be.get(o.$Bk),V=be.get(c.$mi),x=be.get(P.$bl);Se.info("CLI main",this.b),this.g(Se),await this.h(V,je,x,ce),await Promise.all(pe.map(ee=>{(0,D.$8g)(ee.flush(),1e3)}))})}async f(){const ce=new j.$ci,pe={_serviceBrand:void 0,...de.default};ce.set(ae.$Qj,pe);const be=new p.$Nm(this.b,pe);ce.set(c.$mi,be),await Promise.all([be.appSettingsHome.with({scheme:S.Schemas.file}).fsPath,be.extensionsPath].map(Ne=>Ne?d.Promises.mkdir(Ne,{recursive:!0}):void 0));const Se=new te.$qP((0,Z.$Mj)(be),be.logsHome);ce.set(Z.$zj,Se);const je=this.B(Se.createLogger("cli",{name:(0,le.localize)(0,null)})),V=[];Se.getLogLevel()===Z.LogLevel.Trace&&V.push(new Z.$Gj(Se.getLogLevel()));const x=this.B(new G.$AP(je,V));ce.set(Z.$yj,x);const ee=this.B(new l.$nq(x));ce.set(o.$Bk,ee);const ge=this.B(new R.$Mq(x));ee.registerProvider(S.Schemas.file,ge);const ye=new f.$as(ee);ce.set(F.$_k,ye);const De=new T.$uP(1,be,x,ee),Pe=new z.$wP(De,ye,be,ee,x);ce.set(P.$bl,Pe),ee.registerProvider(S.Schemas.vscodeUserData,new ue.$pac(S.Schemas.file,ge,S.Schemas.vscodeUserData,Pe,ye,x));const ze=a.$i&&pe.win32RegValueName?this.B(new he.$nac(x,pe.win32RegValueName)):be.policyFile?this.B(new oe.$oac(be.policyFile,ee,x)):new re.$Xn;ce.set(re.$Vn,ze);const Ie=this.B(new w.$lo(Pe.defaultProfile.settingsResource,ee,ze,x));ce.set(m.$Ki,Ie),await Promise.all([De.init(),Ie.initialize()]);let Le;try{Le=await(0,M.$4_b)(De,x)}catch(Ne){Ne.code!=="ENOENT"&&x.error(Ne)}const Me=await(0,M.$5_b)(De,x);Pe.init(),ce.set(F.$_k,new f.$as(ee));const Re=new X.$yr(Ie,be,x,Se);ce.set(B.$sp,Re),ce.set(k.$po,new I.$bi(b.$PP,void 0,!0)),ce.set(r.$7p,new I.$bi(W.$zP,void 0,!0)),ce.set(t.$$p,new I.$bi(s.$1_b,void 0,!0)),ce.set(g.$Qp,new I.$bi(g.$Rp,void 0,!0)),ce.set(n.$iq,new I.$bi(n.$jq,void 0,!0)),ce.set(u.$Ko,new I.$bi($.$Pp,void 0,!0)),ce.set(q.$sr,new I.$bi(Q.$ur,void 0,!1));const Ae=[],Fe=(0,Y.$9o)(pe,Ie);if((0,Y.$4o)(pe,be)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ae.push(new _.$oP(Re,Fe,"monacoworkbench",null,pe.aiConfig.ariaKey));const Ne={appenders:Ae,sendErrorTelemetry:!1,commonProperties:(0,C.$Uo)((0,L.release)(),(0,L.hostname)(),process.arch,pe.commit,pe.version,Le,Me,Fe),piiPaths:(0,Y.$0o)(be)};ce.set(H.$Fl,new I.$bi(K.$Ar,[Ne],!1))}else ce.set(H.$Fl,Y.$Yo);return[new v.$Pq(ce),Ae]}g(ce){(0,N.setUnexpectedErrorHandler)(pe=>{const be=(0,O.$2i)(pe,!0);be&&ce.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",pe=>{(0,N.$Z)(pe)||(0,N.$1)(pe)}),process.on("unhandledRejection",pe=>(0,N.$1)(pe))}async h(ce,pe,be,Se){let je;if(ce.args.profile&&(je=be.profiles.find(x=>x.name===ce.args.profile),!je))throw new Error(`Profile '${ce.args.profile}' not found.`);const V=(je??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(i.$Sp,new Z.$Gj(Z.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const x={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Se.createInstance(i.$Sp,new Z.$Gj(Z.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),x,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(i.$Sp,new Z.$Gj(Z.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["update-extensions"])return Se.createInstance(i.$Sp,new Z.$Gj(Z.LogLevel.Info,!1)).updateExtensions(V);if(this.b["locate-extension"])return Se.createInstance(i.$Sp,new Z.$Gj(Z.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.$Nac)(ce.appRoot,ce.extensionsPath))}}j(ce){return ce.map(pe=>/\.vsix$/i.test(pe)?E.URI.file((0,h.$ic)(pe)?pe:(0,h.$jc)((0,y.cwd)(),pe)):pe)}}async function we(fe){const ce=new $e(fe);try{await ce.run()}finally{ce.dispose()}}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/00124e9e5830e3efc897db71c781899f8a676295/core/vs/code/node/cliProcessMain.js.map
