/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(se){for(var e=[],O=0,A=se.length;O<A;O++)e[O]=le[se[O]];return e};define(le[124],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class O{static get(){const D=new Map,L=new Map,I=new Map,R=new Map;function k(h,$){h.has($.detail)||h.set($.detail,-$.timestamp)}function g(h,$){const b=h.get($.detail);b&&(b>=0||h.set($.detail,b+$.timestamp))}let C=[];typeof se=="function"&&typeof se.getStats=="function"&&(C=se.getStats().slice(0).sort((h,$)=>h.timestamp-$.timestamp));for(const h of C)switch(h.type){case 10:k(D,h);break;case 11:case 12:g(D,h);break;case 21:k(L,h);break;case 22:g(L,h);break;case 33:k(I,h);break;case 34:g(I,h);break;case 31:k(R,h);break;case 32:g(R,h);break}let S=0;I.forEach(h=>S+=h);function m(h){const $=[];return h.forEach((b,y)=>$.push([y,b])),$}return{amdLoad:m(D),amdInvoke:m(L),nodeRequire:m(I),nodeEval:m(R),nodeRequireTotal:S}}static toMarkdownTable(D,L){let I="";const R=[];return D.forEach((k,g)=>{R[g]=k.length}),L.forEach(k=>{k.forEach((g,C)=>{typeof g>"u"&&(g=k[C]="-");const S=g.toString().length;R[C]=Math.max(S,R[C])})}),D.forEach((k,g)=>{I+=`| ${k+" ".repeat(R[g]-k.toString().length)} `}),I+=`|
`,D.forEach((k,g)=>{I+=`| ${"-".repeat(R[g])} `}),I+=`|
`,L.forEach(k=>{k.forEach((g,C)=>{typeof g<"u"&&(I+=`| ${g+" ".repeat(R[C]-g.toString().length)} `)}),I+=`|
`}),I}}e.$U=O}),define(le[125],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function O(b,y,c){const f=A(b,y);if(f!==-1)return b[f]}e.$fb=O;function A(b,y,c=b.length-1){for(let f=c;f>=0;f--){const d=b[f];if(y(d))return f}return-1}e.$gb=A;function D(b,y){const c=L(b,y);return c===-1?void 0:b[c]}e.$hb=D;function L(b,y,c=0,f=b.length){let d=c,l=f;for(;d<l;){const v=Math.floor((d+l)/2);y(b[v])?d=v+1:l=v}return d-1}e.$ib=L;function I(b,y){const c=R(b,y);return c===b.length?void 0:b[c]}e.$jb=I;function R(b,y,c=0,f=b.length){let d=c,l=f;for(;d<l;){const v=Math.floor((d+l)/2);y(b[v])?l=v:d=v+1}return d}e.$kb=R;function k(b,y,c=0,f=b.length){const d=R(b,y,c,f);return d===b.length?-1:d}e.$lb=k;class g{static{this.assertInvariants=!1}constructor(y){this.e=y,this.c=0}findLastMonotonous(y){if(g.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!y(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=y}const c=L(this.e,y,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$mb=g;function C(b,y){if(b.length===0)return;let c=b[0];for(let f=1;f<b.length;f++){const d=b[f];y(d,c)>0&&(c=d)}return c}e.$nb=C;function S(b,y){if(b.length===0)return;let c=b[0];for(let f=1;f<b.length;f++){const d=b[f];y(d,c)>=0&&(c=d)}return c}e.$ob=S;function m(b,y){return C(b,(c,f)=>-y(c,f))}e.$pb=m;function h(b,y){if(b.length===0)return-1;let c=0;for(let f=1;f<b.length;f++){const d=b[f];y(d,b[c])>0&&(c=f)}return c}e.$qb=h;function $(b,y){for(const c of b){const f=y(c);if(f!==void 0)return f}}e.$rb=$}),define(le[126],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function O(I,R){const k=Object.create(null);for(const g of I){const C=R(g);let S=k[C];S||(S=k[C]=[]),S.push(g)}return k}e.$K=O;function A(I,R){const k=[],g=[];for(const C of I)R.has(C)||k.push(C);for(const C of R)I.has(C)||g.push(C);return{removed:k,added:g}}e.$L=A;function D(I,R){const k=[],g=[];for(const[C,S]of I)R.has(C)||k.push(S);for(const[C,S]of R)I.has(C)||g.push(S);return{removed:k,added:g}}e.$M=D;function L(I,R){const k=new Set;for(const g of R)I.has(g)&&k.add(g);return k}e.$N=L}),define(le[85],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Jh=e.$Ih=void 0;function O(I){return(R,k,g)=>{let C=null,S=null;if(typeof g.value=="function"?(C="value",S=g.value):typeof g.get=="function"&&(C="get",S=g.get),!S)throw new Error("not supported");g[C]=I(S,k)}}function A(I,R,k){let g=null,C=null;if(typeof k.value=="function"?(g="value",C=k.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(g="get",C=k.get),!C)throw new Error("not supported");const S=`$memoize$${R}`;k[g]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,m)}),this[S]}}e.$Ih=A;function D(I,R,k){return O((g,C)=>{const S=`$debounce$${C}`,m=`$debounce$result$${C}`;return function(...h){this[m]||(this[m]=k?k():void 0),clearTimeout(this[S]),R&&(this[m]=R(this[m],...h),h=[this[m]]),this[S]=setTimeout(()=>{g.apply(this,h),this[m]=k?k():void 0},I)}})}e.$Jh=D;function L(I,R,k){return O((g,C)=>{const S=`$throttle$timer$${C}`,m=`$throttle$result$${C}`,h=`$throttle$lastRun$${C}`,$=`$throttle$pending$${C}`;return function(...b){if(this[m]||(this[m]=k?k():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...b)),this[$])return;const y=this[h]+I;y<=Date.now()?(this[h]=Date.now(),g.apply(this,[this[m]]),this[m]=k?k():void 0):(this[$]=!0,this[S]=setTimeout(()=>{this[$]=!1,this[h]=Date.now(),g.apply(this,[this[m]]),this[m]=k?k():void 0},y-Date.now()))}})}e.$Kh=L}),define(le[7],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class O{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?d.isErrorNoTelemetry(i)?new d(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=O,e.$X=new O;function A(v){e.$X.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=A;function D(v){if(!v||typeof v!="object")return!1;const i=v;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=D;function L(v){g(v)||e.$X.onUnexpectedError(v)}e.$1=L;function I(v){g(v)||e.$X.onUnexpectedExternalError(v)}e.$2=I;function R(v){if(v instanceof Error){const{name:i,message:o}=v,n=v.stacktrace||v.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:d.isErrorNoTelemetry(v)}}return v}e.$3=R;const k="Canceled";function g(v){return v instanceof C?!0:v instanceof Error&&v.name===k&&v.message===k}e.$4=g;class C extends Error{constructor(){super(k),this.name=this.message}}e.$5=C;function S(){const v=new Error(k);return v.name=v.message,v}e.$6=S;function m(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.$7=m;function h(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.$8=h;class $ extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=$;function b(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.$0=b;class y extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=y;class c extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=c;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class d extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof d)return i;const o=new d;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=d;class l extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype)}}e.$cb=l}),define(le[17],he([0,1,7,125]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function D(q,Z=0){return q[q.length-(1+Z)]}e.$sb=D;function L(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.$tb=L;function I(q,Z,_=(ie,J)=>ie===J){if(q===Z)return!0;if(!q||!Z||q.length!==Z.length)return!1;for(let ie=0,J=q.length;ie<J;ie++)if(!_(q[ie],Z[ie]))return!1;return!0}e.$ub=I;function R(q,Z){const _=q.length-1;Z<_&&(q[Z]=q[_]),q.pop()}e.$vb=R;function k(q,Z,_){return g(q.length,ie=>_(q[ie],Z))}e.$wb=k;function g(q,Z){let _=0,ie=q-1;for(;_<=ie;){const J=(_+ie)/2|0,ne=Z(J);if(ne<0)_=J+1;else if(ne>0)ie=J-1;else return J}return-(_+1)}e.$xb=g;function C(q,Z,_){if(q=q|0,q>=Z.length)throw new TypeError("invalid index");const ie=Z[Math.floor(Z.length*Math.random())],J=[],ne=[],ce=[];for(const fe of Z){const de=_(fe,ie);de<0?J.push(fe):de>0?ne.push(fe):ce.push(fe)}return q<J.length?C(q,J,_):q<J.length+ce.length?ce[0]:C(q-(J.length+ce.length),ne,_)}e.$yb=C;function S(q,Z){const _=[];let ie;for(const J of q.slice(0).sort(Z))!ie||Z(ie[0],J)!==0?(ie=[J],_.push(ie)):ie.push(J);return _}e.$zb=S;function*m(q,Z){let _,ie;for(const J of q)ie!==void 0&&Z(ie,J)?_.push(J):(_&&(yield _),_=[J]),ie=J;_&&(yield _)}e.$Ab=m;function h(q,Z){for(let _=0;_<=q.length;_++)Z(_===0?void 0:q[_-1],_===q.length?void 0:q[_])}e.$Bb=h;function $(q,Z){for(let _=0;_<q.length;_++)Z(_===0?void 0:q[_-1],q[_],_+1===q.length?void 0:q[_+1])}e.$Cb=$;function b(q,Z,_){const ie=[];function J(fe,de,me){if(de===0&&me.length===0)return;const Ee=ie[ie.length-1];Ee&&Ee.start+Ee.deleteCount===fe?(Ee.deleteCount+=de,Ee.toInsert.push(...me)):ie.push({start:fe,deleteCount:de,toInsert:me})}let ne=0,ce=0;for(;;){if(ne===q.length){J(ne,0,Z.slice(ce));break}if(ce===Z.length){J(ne,q.length-ne,[]);break}const fe=q[ne],de=Z[ce],me=_(fe,de);me===0?(ne+=1,ce+=1):me<0?(J(ne,1,[]),ne+=1):me>0&&(J(ne,0,[de]),ce+=1)}return ie}e.$Db=b;function y(q,Z,_){const ie=b(q,Z,_),J=[],ne=[];for(const ce of ie)J.push(...q.slice(ce.start,ce.start+ce.deleteCount)),ne.push(...ce.toInsert);return{removed:J,added:ne}}e.$Eb=y;function c(q,Z,_){if(_===0)return[];const ie=q.slice(0,_).sort(Z);return d(q,Z,ie,_,q.length),ie}e.top=c;function f(q,Z,_,ie,J){return _===0?Promise.resolve([]):new Promise((ne,ce)=>{(async()=>{const fe=q.length,de=q.slice(0,_).sort(Z);for(let me=_,Ee=Math.min(_+ie,fe);me<fe;me=Ee,Ee=Math.min(Ee+ie,fe)){if(me>_&&await new Promise(Re=>setTimeout(Re)),J&&J.isCancellationRequested)throw new O.$5;d(q,Z,de,me,Ee)}return de})().then(ne,ce)})}e.$Gb=f;function d(q,Z,_,ie,J){for(const ne=_.length;ie<J;ie++){const ce=q[ie];if(Z(ce,_[ne-1])<0){_.pop();const fe=(0,A.$kb)(_,de=>Z(ce,de)<0);_.splice(fe,0,ce)}}}function l(q){return q.filter(Z=>!!Z)}e.$Hb=l;function v(q){let Z=0;for(let _=0;_<q.length;_++)q[_]&&(q[Z]=q[_],Z+=1);q.length=Z}e.$Ib=v;function i(q,Z,_){q.splice(_,0,q.splice(Z,1)[0])}e.$Jb=i;function o(q){return!Array.isArray(q)||q.length===0}e.$Kb=o;function n(q){return Array.isArray(q)&&q.length>0}e.$Lb=n;function s(q,Z=_=>_){const _=new Set;return q.filter(ie=>{const J=Z(ie);return _.has(J)?!1:(_.add(J),!0)})}e.$Mb=s;function t(q){const Z=new Set;return _=>{const ie=q(_);return Z.has(ie)?!1:(Z.add(ie),!0)}}e.$Nb=t;function r(q,Z){return q.length>0?q[0]:Z}e.$Ob=r;function a(q,Z){return q.length>0?q[q.length-1]:Z}e.$Pb=a;function E(q,Z,_=(ie,J)=>ie===J){let ie=0;for(let J=0,ne=Math.min(q.length,Z.length);J<ne&&_(q[J],Z[J]);J++)ie++;return ie}e.$Qb=E;function w(q){return[].concat(...q)}e.$Rb=w;function u(q,Z){let _=typeof Z=="number"?q:0;typeof Z=="number"?_=q:(_=0,Z=q);const ie=[];if(_<=Z)for(let J=_;J<Z;J++)ie.push(J);else for(let J=_;J>Z;J--)ie.push(J);return ie}e.$Sb=u;function p(q,Z,_){return q.reduce((ie,J)=>(ie[Z(J)]=_?_(J):J,ie),Object.create(null))}e.$Tb=p;function P(q,Z){return q.push(Z),()=>N(q,Z)}e.$Ub=P;function N(q,Z){const _=q.indexOf(Z);if(_>-1)return q.splice(_,1),Z}e.$Vb=N;function F(q,Z,_){const ie=q.slice(0,Z),J=q.slice(Z);return ie.concat(_,J)}e.$Wb=F;function M(q,Z){let _;if(typeof Z=="number"){let ie=Z;_=()=>{const J=Math.sin(ie++)*179426549;return J-Math.floor(J)}}else _=Math.random;for(let ie=q.length-1;ie>0;ie-=1){const J=Math.floor(_()*(ie+1)),ne=q[ie];q[ie]=q[J],q[J]=ne}}e.$Xb=M;function z(q,Z){const _=q.indexOf(Z);_>-1&&(q.splice(_,1),q.unshift(Z))}e.$Yb=z;function Y(q,Z){const _=q.indexOf(Z);_>-1&&(q.splice(_,1),q.push(Z))}e.$Zb=Y;function Q(q,Z){for(const _ of Z)q.push(_)}e.$1b=Q;function x(q,Z){return Array.isArray(q)?q.map(Z):Z(q)}e.$2b=x;function W(q){return Array.isArray(q)?q:[q]}e.$3b=W;function X(q){return q[Math.floor(Math.random()*q.length)]}e.$4b=X;function H(q,Z,_){const ie=te(q,Z),J=q.length,ne=_.length;q.length=J+ne;for(let ce=J-1;ce>=ie;ce--)q[ce+ne]=q[ce];for(let ce=0;ce<ne;ce++)q[ce+ie]=_[ce]}e.$5b=H;function V(q,Z,_,ie){const J=te(q,Z);let ne=q.splice(J,_);return ne===void 0&&(ne=[]),H(q,J,ie),ne}e.$6b=V;function te(q,Z){return Z<0?Math.max(Z+q.length,0):Math.min(Z,q.length)}var oe;(function(q){function Z(ne){return ne<0}q.isLessThan=Z;function _(ne){return ne<=0}q.isLessThanOrEqual=_;function ie(ne){return ne>0}q.isGreaterThan=ie;function J(ne){return ne===0}q.isNeitherLessOrGreaterThan=J,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function ee(q,Z){return(_,ie)=>Z(q(_),q(ie))}e.$7b=ee;function ae(...q){return(Z,_)=>{for(const ie of q){const J=ie(Z,_);if(!oe.isNeitherLessOrGreaterThan(J))return J}return oe.neitherLessOrGreaterThan}}e.$8b=ae;const G=(q,Z)=>q-Z;e.$9b=G;const U=(q,Z)=>(0,e.$9b)(q?1:0,Z?1:0);e.$0b=U;function j(q){return(Z,_)=>-q(Z,_)}e.$$b=j;class T{constructor(Z){this.g=Z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let _=this.c;for(;_<this.g.length&&Z(this.g[_]);)_++;const ie=_===this.c?null:this.g.slice(this.c,_);return this.c=_,ie}takeFromEndWhile(Z){let _=this.d;for(;_>=0&&Z(this.g[_]);)_--;const ie=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Z=this.g[this.c];return this.c++,Z}removeLast(){const Z=this.g[this.d];return this.d--,Z}takeCount(Z){const _=this.g.slice(this.c,this.c+Z);return this.c+=Z,_}}e.$_b=T;class B{static{this.empty=new B(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(_=>(Z(_),!0))}toArray(){const Z=[];return this.iterate(_=>(Z.push(_),!0)),Z}filter(Z){return new B(_=>this.iterate(ie=>Z(ie)?_(ie):!0))}map(Z){return new B(_=>this.iterate(ie=>_(Z(ie))))}some(Z){let _=!1;return this.iterate(ie=>(_=Z(ie),!_)),_}findFirst(Z){let _;return this.iterate(ie=>Z(ie)?(_=ie,!1):!0),_}findLast(Z){let _;return this.iterate(ie=>(Z(ie)&&(_=ie),!0)),_}findLastMaxBy(Z){let _,ie=!0;return this.iterate(J=>((ie||oe.isGreaterThan(Z(J,_)))&&(ie=!1,_=J),!0)),_}}e.$ac=B}),define(le[127],he([0,1,7]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function A(g,C){if(!g)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=A;function D(g,C="Unreachable"){throw new Error(C)}e.$9c=D;function L(g){if(!g)throw new O.$cb("Assertion Failed")}e.$0c=L;function I(g){g||(0,O.$1)(new O.$cb("Assertion Failed"))}e.$$c=I;function R(g){if(!g()){debugger;g(),(0,O.$1)(new O.$cb("Assertion Failed"))}}e.$_c=R;function k(g,C){let S=0;for(;S<g.length-1;){const m=g[S],h=g[S+1];if(!C(m,h))return!1;S++}return!0}e.$ad=k}),define(le[86],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function O(A,D){const L=this;let I=!1,R;return function(){if(I)return R;if(I=!0,D)try{R=A.apply(L,arguments)}finally{D()}else R=A.apply(L,arguments);return R}}e.$db=O}),define(le[61],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var O;(function(A){function D(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}A.is=D;const L=Object.freeze([]);function I(){return L}A.empty=I;function*R(i){yield i}A.single=R;function k(i){return D(i)?i:R(i)}A.wrap=k;function g(i){return i||L}A.from=g;function*C(i){for(let o=i.length-1;o>=0;o--)yield i[o]}A.reverse=C;function S(i){return!i||i[Symbol.iterator]().next().done===!0}A.isEmpty=S;function m(i){return i[Symbol.iterator]().next().value}A.first=m;function h(i,o){for(const n of i)if(o(n))return!0;return!1}A.some=h;function $(i,o){for(const n of i)if(o(n))return n}A.find=$;function*b(i,o){for(const n of i)o(n)&&(yield n)}A.filter=b;function*y(i,o){let n=0;for(const s of i)yield o(s,n++)}A.map=y;function*c(...i){for(const o of i)yield*o}A.concat=c;function f(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}A.reduce=f;function*d(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}A.slice=d;function l(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,A.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}A.consume=l;async function v(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}A.asyncToArray=v})(O||(e.Iterable=O={}))}),define(le[34],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function I(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,E=0;function w(z){let Y=0,Q=0;for(;Y<z;){const x=i.charCodeAt(n);if(x>=48&&x<=57)Q=Q*16+x-48;else if(x>=65&&x<=70)Q=Q*16+x-65+10;else if(x>=97&&x<=102)Q=Q*16+x-97+10;else break;n++,Y++}return Y<z&&(Q=-1),Q}function u(z){n=z,t="",r=0,a=16,E=0}function p(){const z=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&g(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&g(i.charCodeAt(n)))for(n++;n<i.length&&g(i.charCodeAt(n));)n++;else return E=3,i.substring(z,n);let Y=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&g(i.charCodeAt(n))){for(n++;n<i.length&&g(i.charCodeAt(n));)n++;Y=n}else E=3;return i.substring(z,Y)}function P(){let z="",Y=n;for(;;){if(n>=s){z+=i.substring(Y,n),E=2;break}const Q=i.charCodeAt(n);if(Q===34){z+=i.substring(Y,n),n++;break}if(Q===92){if(z+=i.substring(Y,n),n++,n>=s){E=2;break}switch(i.charCodeAt(n++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const W=w(4);W>=0?z+=String.fromCharCode(W):E=4;break}default:E=5}Y=n;continue}if(Q>=0&&Q<=31)if(k(Q)){z+=i.substring(Y,n),E=2;break}else E=6;n++}return z}function N(){if(t="",E=0,r=n,n>=s)return r=s,a=17;let z=i.charCodeAt(n);if(R(z)){do n++,t+=String.fromCharCode(z),z=i.charCodeAt(n);while(R(z));return a=15}if(k(z))return n++,t+=String.fromCharCode(z),z===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(z){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=P(),a=10;case 47:{const Y=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!k(i.charCodeAt(n));)n++;return t=i.substring(Y,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const Q=s-1;let x=!1;for(;n<Q;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,E=1),t=i.substring(Y,n),a=13}return t+=String.fromCharCode(z),n++,a=16}case 45:if(t+=String.fromCharCode(z),n++,n===s||!g(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=p(),a=11;default:for(;n<s&&F(z);)n++,z=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(z),n++,a=16}}function F(z){if(R(z)||k(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let z;do z=N();while(z>=12&&z<=15);return z}return{setPosition:u,getPosition:()=>n,scan:o?M:N,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>E}}e.$mn=I;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function k(i){return i===10||i===13||i===8232||i===8233}function g(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function S(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function E(w,u,p,P){r.value=w,r.offset=u,r.length=p,r.type=P,r.colonOffset=void 0,t=r}try{d(i,{onObjectBegin:(w,u)=>{if(o<=w)throw s;t=void 0,a=o>w,n.push("")},onObjectProperty:(w,u,p)=>{if(o<u||(E(w,u,p,"property"),n[n.length-1]=w,o<=u+p))throw s},onObjectEnd:(w,u)=>{if(o<=w)throw s;t=void 0,n.pop()},onArrayBegin:(w,u)=>{if(o<=w)throw s;t=void 0,n.push(0)},onArrayEnd:(w,u)=>{if(o<=w)throw s;t=void 0,n.pop()},onLiteralValue:(w,u,p)=>{if(o<u||(E(w,u,p,v(w)),o<=u+p))throw s},onSeparator:(w,u,p)=>{if(o<=u)throw s;if(w===":"&&t&&t.type==="property")t.colonOffset=u,a=!1,t=void 0;else if(w===","){const P=n[n.length-1];typeof P=="number"?n[n.length-1]=P+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(w){if(w!==s)throw w}return{path:n,previousNode:t,isAtPropertyKey:a,matches:w=>{let u=0;for(let p=0;u<w.length&&p<n.length;p++)if(w[u]===n[p]||w[u]==="*")u++;else if(w[u]!=="**")return!1;return u===w.length}}}e.$nn=S;function m(i,o=[],n=L.DEFAULT){let s=null,t=[];const r=[];function a(w){Array.isArray(t)?t.push(w):s!==null&&(t[s]=w)}return d(i,{onObjectBegin:()=>{const w={};a(w),r.push(t),t=w,s=null},onObjectProperty:w=>{s=w},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const w=[];a(w),r.push(t),t=w,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(w,u,p)=>{o.push({error:w,offset:u,length:p})}},n),t[0]}e.$on=m;function h(i,o=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(w){s.type==="property"&&(s.length=w-s.offset,s=s.parent)}function r(w){return s.children.push(w),w}d(i,{onObjectBegin:w=>{s=r({type:"object",offset:w,length:-1,parent:s,children:[]})},onObjectProperty:(w,u,p)=>{s=r({type:"property",offset:u,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:w,offset:u,length:p,parent:s})},onObjectEnd:(w,u)=>{s.length=w+u-s.offset,s=s.parent,t(w+u)},onArrayBegin:(w,u)=>{s=r({type:"array",offset:w,length:-1,parent:s,children:[]})},onArrayEnd:(w,u)=>{s.length=w+u-s.offset,s=s.parent,t(w+u)},onLiteralValue:(w,u,p)=>{r({type:v(w),offset:u,length:p,parent:s,value:w}),t(u+p)},onSeparator:(w,u,p)=>{s.type==="property"&&(w===":"?s.colonOffset=u:w===","&&t(u))},onError:(w,u,p)=>{o.push({error:w,offset:u,length:p})}},n);const E=s.children[0];return E&&delete E.parent,E}e.$pn=h;function $(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$qn=$;function b(i){if(!i.parent||!i.parent.children)return[];const o=b(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.$rn=b;function y(i){switch(i.type){case"array":return i.children.map(y);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=y(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$sn=y;function c(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.$tn=c;function f(i,o,n=!1){if(c(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=f(s[t],o,n);if(r)return r}return i}}e.$un=f;function d(i,o,n=L.DEFAULT){const s=I(i,!1);function t(ee){return ee?()=>ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ee){return ee?ae=>ee(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),E=r(o.onObjectProperty),w=t(o.onObjectEnd),u=t(o.onArrayBegin),p=t(o.onArrayEnd),P=r(o.onLiteralValue),N=r(o.onSeparator),F=t(o.onComment),M=r(o.onError),z=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function Q(){for(;;){const ee=s.scan();switch(s.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ee){case 12:case 13:z?x(10):F();break;case 16:x(1);break;case 15:case 14:break;default:return ee}}}function x(ee,ae=[],G=[]){if(M(ee),ae.length+G.length>0){let U=s.getToken();for(;U!==17;){if(ae.indexOf(U)!==-1){Q();break}else if(G.indexOf(U)!==-1)break;U=Q()}}}function W(ee){const ae=s.getTokenValue();return ee?P(ae):E(ae),Q(),!0}function X(){switch(s.getToken()){case 11:{let ee=0;try{ee=JSON.parse(s.getTokenValue()),typeof ee!="number"&&(x(2),ee=0)}catch{x(2)}P(ee);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return Q(),!0}function H(){return s.getToken()!==10?(x(3,[],[2,5]),!1):(W(!1),s.getToken()===6?(N(":"),Q(),oe()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function V(){a(),Q();let ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ee||x(4,[],[]),N(","),Q(),s.getToken()===2&&Y)break}else ee&&x(6,[],[]);H()||x(4,[],[2,5]),ee=!0}return w(),s.getToken()!==2?x(7,[2],[]):Q(),!0}function te(){u(),Q();let ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ee||x(4,[],[]),N(","),Q(),s.getToken()===4&&Y)break}else ee&&x(6,[],[]);oe()||x(4,[],[4,5]),ee=!0}return p(),s.getToken()!==4?x(8,[4],[]):Q(),!0}function oe(){switch(s.getToken()){case 3:return te();case 1:return V();case 10:return W(!0);default:return X()}}return Q(),s.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):oe()?(s.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$vn=d;function l(i,o){const n=I(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}e.$wn=l;function v(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$xn=v}),define(le[42],he([0,1,34]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=void 0;function A(g,C,S){let m,h,$,b,y;if(C){for(b=C.offset,y=b+C.length,$=b;$>0&&!k(g,$-1);)$--;let a=y;for(;a<g.length&&!k(g,a);)a++;h=g.substring($,a),m=I(h,S)}else h=g,m=0,$=0,b=0,y=g.length;const c=R(S,g);let f=!1,d=0,l;S.insertSpaces?l=L(" ",S.tabSize||4):l="	";const v=(0,O.$mn)(h,!1);let i=!1;function o(){return c+L(l,m+d)}function n(){let a=v.scan();for(f=!1;a===15||a===14;)f=f||a===14,a=v.scan();return i=a===16||v.getTokenError()!==0,a}const s=[];function t(a,E,w){!i&&E<y&&w>b&&g.substring(E,w)!==a&&s.push({offset:E,length:w-E,content:a})}let r=n();if(r!==17){const a=v.getTokenOffset()+$,E=L(l,m);t(E,$,a)}for(;r!==17;){let a=v.getTokenOffset()+v.getTokenLength()+$,E=n(),w="";for(;!f&&(E===12||E===13);){const p=v.getTokenOffset()+$;t(" ",a,p),a=v.getTokenOffset()+v.getTokenLength()+$,w=E===12?o():"",E=n()}if(E===2)r!==1&&(d--,w=o());else if(E===4)r!==3&&(d--,w=o());else{switch(r){case 3:case 1:d++,w=o();break;case 5:case 12:w=o();break;case 13:f?w=o():w=" ";break;case 6:w=" ";break;case 10:if(E===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?w=" ":E!==5&&E!==17&&(i=!0);break;case 16:i=!0;break}f&&(E===12||E===13)&&(w=o())}const u=v.getTokenOffset()+$;t(w,a,u),r=E}return s}e.$yn=A;function D(g,C){const S=JSON.stringify(g,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?S.replace(/\r\n|\r|\n/g,C.eol):S}e.$zn=D;function L(g,C){let S="";for(let m=0;m<C;m++)S+=g;return S}function I(g,C){let S=0,m=0;const h=C.tabSize||4;for(;S<g.length;){const $=g.charAt(S);if($===" ")m++;else if($==="	")m+=h;else break;S++}return Math.floor(m/h)}function R(g,C){for(let S=0;S<C.length;S++){const m=C.charAt(S);if(m==="\r")return S+1<C.length&&C.charAt(S+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return g&&g.eol||`
`}e.$An=R;function k(g,C){return`\r
`.indexOf(g.charAt(C))!==-1}e.$Bn=k}),define(le[62],he([0,1,34,42]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=void 0;function D(g,C,S){return L(g,C,void 0,S)}e.$Cn=D;function L(g,C,S,m,h){const $=C.slice(),b=[],y=(0,O.$pn)(g,b);let c,f;for(;$.length>0&&(f=$.pop(),c=(0,O.$qn)(y,$),c===void 0&&S!==void 0);)typeof f=="string"?S={[f]:S}:S=[S];if(c)if(c.type==="object"&&typeof f=="string"&&Array.isArray(c.children)){const d=(0,O.$qn)(c,[f]);if(d!==void 0)if(S===void 0){if(!d.parent)throw new Error("Malformed AST");const l=c.children.indexOf(d.parent);let v,i=d.parent.offset+d.parent.length;if(l>0){const o=c.children[l-1];v=o.offset+o.length}else v=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return I(g,{offset:v,length:i-v,content:""},m)}else return I(g,{offset:d.offset,length:d.length,content:JSON.stringify(S)},m);else{if(S===void 0)return[];const l=`${JSON.stringify(f)}: ${JSON.stringify(S)}`,v=h?h(c.children.map(o=>o.children[0].value)):c.children.length;let i;if(v>0){const o=c.children[v-1];i={offset:o.offset+o.length,length:0,content:","+l}}else c.children.length===0?i={offset:c.offset+1,length:0,content:l}:i={offset:c.offset+1,length:0,content:l+","};return I(g,i,m)}}else if(c.type==="array"&&typeof f=="number"&&Array.isArray(c.children))if(S!==void 0){const d=`${JSON.stringify(S)}`;let l;if(c.children.length===0||f===0)l={offset:c.offset+1,length:0,content:c.children.length===0?d:d+","};else{const v=f===-1||f>c.children.length?c.children.length:f,i=c.children[v-1];l={offset:i.offset+i.length,length:0,content:","+d}}return I(g,l,m)}else{const d=f,l=c.children[d];let v;if(c.children.length===1)v={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===d){const i=c.children[d-1],o=i.offset+i.length,n=c.offset+c.length;v={offset:o,length:n-2-o,content:""}}else v={offset:l.offset,length:c.children[d+1].offset-l.offset,content:""};return I(g,v,m)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${c.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return I(g,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(S)},m)}}e.$Dn=L;function I(g,C,S){let m=R(g,C),h=C.offset,$=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;h>0&&!(0,A.$Bn)(m,h-1);)h--;for(;$<m.length&&!(0,A.$Bn)(m,$);)$++}const b=(0,A.$yn)(m,{offset:h,length:$-h},S);for(let c=b.length-1;c>=0;c--){const f=b[c];m=R(m,f),h=Math.min(h,f.offset),$=Math.max($,f.offset+f.length),$+=f.content.length-f.length}const y=g.length-(m.length-$)-h;return[{offset:h,length:y,content:m.substring(h,$)}]}e.$En=I;function R(g,C){return g.substring(0,C.offset)+C.content+g.substring(C.offset+C.length)}e.$Fn=R;function k(g,C){const S=C.slice(0).sort((h,$)=>{const b=h.offset-$.offset;return b===0?h.length-$.length:b});let m=g.length;for(let h=S.length-1;h>=0;h--){const $=S[h];if($.offset+$.length<=m)g=R(g,$);else throw new Error("Overlapping edit");m=$.offset}return g}e.$Gn=k}),define(le[52],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class O{constructor(D){this.d=D,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=O}),define(le[87],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class O{static{this.Undefined=new O(void 0)}constructor(L){this.element=L,this.next=O.Undefined,this.prev=O.Undefined}}class A{constructor(){this.a=O.Undefined,this.b=O.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===O.Undefined}clear(){let L=this.a;for(;L!==O.Undefined;){const I=L.next;L.prev=O.Undefined,L.next=O.Undefined,L=I}this.a=O.Undefined,this.b=O.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,I){const R=new O(L);if(this.a===O.Undefined)this.a=R,this.b=R;else if(I){const g=this.b;this.b=R,R.prev=g,g.next=R}else{const g=this.a;this.a=R,R.next=g,g.prev=R}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(R))}}shift(){if(this.a!==O.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==O.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==O.Undefined&&L.next!==O.Undefined){const I=L.prev;I.next=L.next,L.next.prev=I}else L.prev===O.Undefined&&L.next===O.Undefined?(this.a=O.Undefined,this.b=O.Undefined):L.next===O.Undefined?(this.b=this.b.prev,this.b.next=O.Undefined):L.prev===O.Undefined&&(this.a=this.a.next,this.a.prev=O.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==O.Undefined;)yield L.element,L=L.next}}e.$4c=A}),define(le[35],he([0,1]),function(se,e){"use strict";var O,A,D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function L(d,l,v){let i=d.get(l);return i===void 0&&(i=v,d.set(l,i)),i}e.$xc=L;function I(d){const l=[];return d.forEach((v,i)=>{l.push(`${i} => ${v}`)}),`Map(${d.size}) {${l.join(", ")}}`}e.$yc=I;function R(d){const l=[];return d.forEach(v=>{l.push(v)}),`Set(${d.size}) {${l.join(", ")}}`}e.$zc=R;class k{constructor(l,v){this.uri=l,this.value=v}}function g(d){return Array.isArray(d)}class C{static{this.c=l=>l.toString()}constructor(l,v){if(this[O]="ResourceMap",l instanceof C)this.d=new Map(l.d),this.e=v??C.c;else if(g(l)){this.d=new Map,this.e=v??C.c;for(const[i,o]of l)this.set(i,o)}else this.d=new Map,this.e=l??C.c}set(l,v){return this.d.set(this.e(l),new k(l,v)),this}get(l){return this.d.get(this.e(l))?.value}has(l){return this.d.has(this.e(l))}get size(){return this.d.size}clear(){this.d.clear()}delete(l){return this.d.delete(this.e(l))}forEach(l,v){typeof v<"u"&&(l=l.bind(v));for(const[i,o]of this.d)l(o.value,o.uri,this)}*values(){for(const l of this.d.values())yield l.value}*keys(){for(const l of this.d.values())yield l.uri}*entries(){for(const l of this.d.values())yield[l.uri,l.value]}*[(O=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.d)yield[l.uri,l.value]}}e.$Ac=C;class S{constructor(l,v){this[A]="ResourceSet",!l||typeof l=="function"?this.c=new C(l):(this.c=new C(v),l.forEach(this.add,this))}get size(){return this.c.size}add(l){return this.c.set(l,l),this}clear(){this.c.clear()}delete(l){return this.c.delete(l)}forEach(l,v){this.c.forEach((i,o)=>l.call(v,o,o,this))}has(l){return this.c.has(l)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=S;var m;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class h{constructor(){this[D]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(l){return this.c.has(l)}get(l,v=0){const i=this.c.get(l);if(i)return v!==0&&this.l(i,v),i.value}set(l,v,i=0){let o=this.c.get(l);if(o)o.value=v,i!==0&&this.l(o,i);else{switch(o={key:l,value:v,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(l,o),this.f++}return this}delete(l){return!!this.remove(l)}remove(l){const v=this.c.get(l);if(v)return this.c.delete(l),this.k(v),this.f--,v.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const l=this.d;return this.c.delete(l.key),this.k(l),this.f--,l.value}forEach(l,v){const i=this.g;let o=this.d;for(;o;){if(v?l.bind(v)(o.value,o.key,this):l(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const l=this,v=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(l.g!==v)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const l=this,v=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(l.g!==v)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const l=this,v=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(l.g!==v)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(l){if(l>=this.size)return;if(l===0){this.clear();return}let v=this.d,i=this.size;for(;v&&i>l;)this.c.delete(v.key),v=v.next,i--;this.d=v,this.f=i,v&&(v.previous=void 0),this.g++}i(l){if(!this.d&&!this.e)this.e=l;else if(this.d)l.next=this.d,this.d.previous=l;else throw new Error("Invalid list");this.d=l,this.g++}j(l){if(!this.d&&!this.e)this.d=l;else if(this.e)l.previous=this.e,this.e.next=l;else throw new Error("Invalid list");this.e=l,this.g++}k(l){if(l===this.d&&l===this.e)this.d=void 0,this.e=void 0;else if(l===this.d){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.d=l.next}else if(l===this.e){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.e=l.previous}else{const v=l.next,i=l.previous;if(!v||!i)throw new Error("Invalid list");v.previous=i,i.next=v}l.next=void 0,l.previous=void 0,this.g++}l(l,v){if(!this.d||!this.e)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(l===this.d)return;const i=l.next,o=l.previous;l===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),l.previous=void 0,l.next=this.d,this.d.previous=l,this.d=l,this.g++}else if(v===2){if(l===this.e)return;const i=l.next,o=l.previous;l===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),l.next=void 0,l.previous=this.e,this.e.next=l,this.e=l,this.g++}}}toJSON(){const l=[];return this.forEach((v,i)=>{l.push([i,v])}),l}fromJSON(l){this.clear();for(const[v,i]of l)this.set(v,i)}}e.$Cc=h;class $ extends h{constructor(l,v=1){super(),this.m=l,this.n=Math.min(Math.max(0,v),1)}get limit(){return this.m}set limit(l){this.m=l,this.o()}get ratio(){return this.n}set ratio(l){this.n=Math.min(Math.max(0,l),1),this.o()}get(l,v=2){return super.get(l,v)}peek(l){return super.get(l,0)}set(l,v){return super.set(l,v,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=$;class b{constructor(){this.c=new Map}add(l){return this.c.set(l,(this.c.get(l)||0)+1),this}delete(l){let v=this.c.get(l)||0;return v===0?!1:(v--,v===0?this.c.delete(l):this.c.set(l,v),!0)}has(l){return this.c.has(l)}}e.$Ec=b;class y{constructor(l){if(this.c=new Map,this.d=new Map,l)for(const[v,i]of l)this.set(v,i)}clear(){this.c.clear(),this.d.clear()}set(l,v){this.c.set(l,v),this.d.set(v,l)}get(l){return this.c.get(l)}getKey(l){return this.d.get(l)}delete(l){const v=this.c.get(l);return v===void 0?!1:(this.c.delete(l),this.d.delete(v),!0)}forEach(l,v){this.c.forEach((i,o)=>{l.call(v,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=y;class c{constructor(){this.c=new Map}add(l,v){let i=this.c.get(l);i||(i=new Set,this.c.set(l,i)),i.add(v)}delete(l,v){const i=this.c.get(l);i&&(i.delete(v),i.size===0&&this.c.delete(l))}forEach(l,v){const i=this.c.get(l);i&&i.forEach(v)}get(l){const v=this.c.get(l);return v||new Set}}e.$Gc=c;function f(d,l){if(d===l)return!0;if(d.size!==l.size)return!1;for(const[v,i]of d)if(!l.has(v)||l.get(v)!==i)return!1;for(const[v]of l)if(!d.has(v))return!1;return!0}e.$Hc=f}),define(le[2],he([0,1,17,126,35,86,61]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const R=!1;let k=null;class g{constructor(){this.b=new Map}static{this.a=0}c(P){let N=this.b.get(P);return N||(N={parent:null,source:null,isSingleton:!1,value:P,idx:g.a++},this.b.set(P,N)),N}trackDisposable(P){const N=this.c(P);N.source||(N.source=new Error().stack)}setParent(P,N){const F=this.c(P);F.parent=N}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,N){const F=N.get(P);if(F)return F;const M=P.parent?this.f(this.c(P.parent),N):P;return N.set(P,M),M}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,P).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(P=10,N){let F;if(N)F=N;else{const x=new Map,W=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,x).isSingleton);if(W.length===0)return;const X=new Set(W.map(H=>H.value));if(F=W.filter(H=>!(H.parent&&X.has(H.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function M(x){function W(H,V){for(;H.length>0&&V.some(te=>typeof te=="string"?te===H[0]:H[0].match(te));)H.shift()}const X=x.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return W(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const z=new D.$Gc;for(const x of F){const W=M(x);for(let X=0;X<=W.length;X++)z.add(W.slice(0,X).join(`
`),x)}F.sort((0,O.$7b)(x=>x.idx,O.$9b));let Y="",Q=0;for(const x of F.slice(0,P)){Q++;const W=M(x),X=[];for(let H=0;H<W.length;H++){let V=W[H];V=`(shared with ${z.get(W.slice(0,H+1).join(`
`)).size}/${F.length} leaks) at ${V}`;const oe=z.get(W.slice(0,H).join(`
`)),ee=(0,A.$K)([...oe].map(ae=>M(ae)[H]),ae=>ae);delete ee[W[H]];for(const[ae,G]of Object.entries(ee))X.unshift(`    - stacktraces of ${G.length} other leaks continue with ${ae}`);X.unshift(V)}Y+=`


==================== Leaking disposable ${Q}/${F.length}: ${x.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return F.length>P&&(Y+=`


... and ${F.length-P} more leaking disposables

`),{leaks:F,details:Y}}}e.$Ic=g;function C(p){k=p}if(e.$Jc=C,R){const p="__is_disposable_tracked__";C(new class{trackDisposable(P){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[p]||console.log(N)},3e3)}setParent(P,N){if(P&&P!==i.None)try{P[p]=!0}catch{}}markAsDisposed(P){if(P&&P!==i.None)try{P[p]=!0}catch{}}markAsSingleton(P){}})}function S(p){return k?.trackDisposable(p),p}e.$Kc=S;function m(p){k?.markAsDisposed(p)}e.$Lc=m;function h(p,P){k?.setParent(p,P)}function $(p,P){if(k)for(const N of p)k.setParent(N,P)}function b(p){return k?.markAsSingleton(p),p}e.$Mc=b;function y(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.$Nc=y;function c(p){if(I.Iterable.is(p)){const P=[];for(const N of p)if(N)try{N.dispose()}catch(F){P.push(F)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}e.$Oc=c;function f(p){for(const P of p)y(P)&&P.dispose();return[]}e.$Pc=f;function d(...p){const P=l(()=>c(p));return $(p,P),P}e.$Qc=d;function l(p){const P=S({dispose:(0,L.$db)(()=>{m(P),p()})});return P}e.$Rc=l;class v{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return h(P,this),this.g?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),h(P,null))}}e.$Sc=v;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new v,S(this),h(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Tc=i;class o{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&h(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&h(P,null),P}}e.$Uc=o;class n{constructor(P){this.a=new o,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=n;class s{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(P){let N=P;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,m(this))},this}}e.$Xc=t;class r{constructor(){this.a=new Map}acquire(P,...N){let F=this.a.get(P);F||(F={counter:0,object:this.b(P,...N)},this.a.set(P,F));const{object:M}=F,z=(0,L.$db)(()=>{--F.counter===0&&(this.c(P,F.object),this.a.delete(P))});return F.counter++,{object:M,dispose:z}}}e.$Yc=r;class a{constructor(P){this.a=P}async acquire(P,...N){const F=this.a.acquire(P,...N);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(M){throw F.dispose(),M}}}e.$Zc=a;class E{constructor(P){this.object=P}dispose(){}}e.$1c=E;function w(p){const P=new v;try{p(P)}finally{P.dispose()}}e.$2c=w;class u{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,N,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(P)?.dispose(),this.a.set(P,N)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=u}),define(le[88],he([0,1,35]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=void 0;const A=new O.$Dc(1e4);function D(g){return k(g,"NFC",A)}e.$Rl=D;const L=new O.$Dc(1e4);function I(g){return k(g,"NFD",L)}e.$Sl=I;const R=/[^\u0000-\u0080]/;function k(g,C,S){if(!g)return g;const m=S.get(g);if(m)return m;let h;return R.test(g)?h=g.normalize(C):h=g,S.set(g,h),h}e.$Tl=function(){const g=/[\u0300-\u036f]/g;return function(C){return I(C).replace(g,"")}}()}),function(){function se(D){const L=[];typeof D=="number"&&L.push("code/timeOrigin",D);function I(k){L.push(k,Date.now())}function R(){const k=[];for(let g=0;g<L.length;g+=2)k.push({name:L[g],startTime:L[g+1]});return k}return{mark:I,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const I of performance.getEntriesByType("mark"))L.push({name:I.name,startTime:Math.round(D+I.startTime)});return L}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function O(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=O(A))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var A in O)(typeof exports=="object"?exports:se)[A]=O[A]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function O(A){if(e[A])return e[A].exports;var D=e[A]={i:A,l:!1,exports:{}};return se[A].call(D.exports,D,D.exports,O),D.l=!0,D.exports}return O.m=se,O.c=e,O.d=function(A,D,L){O.o(A,D)||Object.defineProperty(A,D,{enumerable:!0,get:L})},O.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},O.t=function(A,D){if(1&D&&(A=O(A)),8&D||4&D&&typeof A=="object"&&A&&A.__esModule)return A;var L=Object.create(null);if(O.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:A}),2&D&&typeof A!="string")for(var I in A)O.d(L,I,function(R){return A[R]}.bind(null,I));return L},O.n=function(A){var D=A&&A.__esModule?function(){return A.default}:function(){return A};return O.d(D,"a",D),D},O.o=function(A,D){return Object.prototype.hasOwnProperty.call(A,D)},O.p="",O(O.s=0)}([function(se,e,O){(function(A){var D;e=se.exports=G,D=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],k=e.src=[],g=0,C=g++;k[C]="0|[1-9]\\d*";var S=g++;k[S]="[0-9]+";var m=g++;k[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=g++;k[h]="("+k[C]+")\\.("+k[C]+")\\.("+k[C]+")";var $=g++;k[$]="("+k[S]+")\\.("+k[S]+")\\.("+k[S]+")";var b=g++;k[b]="(?:"+k[C]+"|"+k[m]+")";var y=g++;k[y]="(?:"+k[S]+"|"+k[m]+")";var c=g++;k[c]="(?:-("+k[b]+"(?:\\."+k[b]+")*))";var f=g++;k[f]="(?:-?("+k[y]+"(?:\\."+k[y]+")*))";var d=g++;k[d]="[0-9A-Za-z-]+";var l=g++;k[l]="(?:\\+("+k[d]+"(?:\\."+k[d]+")*))";var v=g++,i="v?"+k[h]+k[c]+"?"+k[l]+"?";k[v]="^"+i+"$";var o="[v=\\s]*"+k[$]+k[f]+"?"+k[l]+"?",n=g++;k[n]="^"+o+"$";var s=g++;k[s]="((?:<|>)?=?)";var t=g++;k[t]=k[S]+"|x|X|\\*";var r=g++;k[r]=k[C]+"|x|X|\\*";var a=g++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[c]+")?"+k[l]+"?)?)?";var E=g++;k[E]="[v=\\s]*("+k[t]+")(?:\\.("+k[t]+")(?:\\.("+k[t]+")(?:"+k[f]+")?"+k[l]+"?)?)?";var w=g++;k[w]="^"+k[s]+"\\s*"+k[a]+"$";var u=g++;k[u]="^"+k[s]+"\\s*"+k[E]+"$";var p=g++;k[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=g++;k[P]="(?:~>?)";var N=g++;k[N]="(\\s*)"+k[P]+"\\s+",R[N]=new RegExp(k[N],"g");var F=g++;k[F]="^"+k[P]+k[a]+"$";var M=g++;k[M]="^"+k[P]+k[E]+"$";var z=g++;k[z]="(?:\\^)";var Y=g++;k[Y]="(\\s*)"+k[z]+"\\s+",R[Y]=new RegExp(k[Y],"g");var Q=g++;k[Q]="^"+k[z]+k[a]+"$";var x=g++;k[x]="^"+k[z]+k[E]+"$";var W=g++;k[W]="^"+k[s]+"\\s*("+o+")$|^$";var X=g++;k[X]="^"+k[s]+"\\s*("+i+")$|^$";var H=g++;k[H]="(\\s*)"+k[s]+"\\s*("+o+"|"+k[a]+")",R[H]=new RegExp(k[H],"g");var V=g++;k[V]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var te=g++;k[te]="^\\s*("+k[E]+")\\s+-\\s+("+k[E]+")\\s*$";var oe=g++;k[oe]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)D(ee,k[ee]),R[ee]||(R[ee]=new RegExp(k[ee]));function ae(ue,ge){if(ue instanceof G)return ue;if(typeof ue!="string"||ue.length>L||!(ge?R[n]:R[v]).test(ue))return null;try{return new G(ue,ge)}catch{return null}}function G(ue,ge){if(ue instanceof G){if(ue.loose===ge)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof G))return new G(ue,ge);D("SemVer",ue,ge),this.loose=ge;var be=ue.trim().match(ge?R[n]:R[v]);if(!be)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Ce=+Pe;if(Ce>=0&&Ce<I)return Ce}return Pe}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ue,ge){var be=ae(ue,ge);return be?be.version:null},e.clean=function(ue,ge){var be=ae(ue.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(ue){return D("SemVer.compare",this.version,this.loose,ue),ue instanceof G||(ue=new G(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},G.prototype.compareMain=function(ue){return ue instanceof G||(ue=new G(ue,this.loose)),j(this.major,ue.major)||j(this.minor,ue.minor)||j(this.patch,ue.patch)},G.prototype.comparePre=function(ue){if(ue instanceof G||(ue=new G(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],Pe=ue.prerelease[ge];if(D("prerelease compare",ge,be,Pe),be===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(be===void 0)return-1;if(be!==Pe)return j(be,Pe)}while(++ge)},G.prototype.inc=function(ue,ge){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,ge,be,Pe){typeof be=="string"&&(Pe=be,be=void 0);try{return new G(ue,be).inc(ge,Pe).version}catch{return null}},e.diff=function(ue,ge){if(Z(ue,ge))return null;var be=ae(ue),Pe=ae(ge);if(be.prerelease.length||Pe.prerelease.length){for(var Ce in be)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&be[Ce]!==Pe[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in be)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&be[Ce]!==Pe[Ce])return Ce},e.compareIdentifiers=j;var U=/^[0-9]+$/;function j(ue,ge){var be=U.test(ue),Pe=U.test(ge);return be&&Pe&&(ue=+ue,ge=+ge),be&&!Pe?-1:Pe&&!be?1:ue<ge?-1:ue>ge?1:0}function T(ue,ge,be){return new G(ue,be).compare(new G(ge,be))}function B(ue,ge,be){return T(ue,ge,be)>0}function q(ue,ge,be){return T(ue,ge,be)<0}function Z(ue,ge,be){return T(ue,ge,be)===0}function _(ue,ge,be){return T(ue,ge,be)!==0}function ie(ue,ge,be){return T(ue,ge,be)>=0}function J(ue,ge,be){return T(ue,ge,be)<=0}function ne(ue,ge,be,Pe){var Ce;switch(ge){case"===":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),Ce=ue===be;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),Ce=ue!==be;break;case"":case"=":case"==":Ce=Z(ue,be,Pe);break;case"!=":Ce=_(ue,be,Pe);break;case">":Ce=B(ue,be,Pe);break;case">=":Ce=ie(ue,be,Pe);break;case"<":Ce=q(ue,be,Pe);break;case"<=":Ce=J(ue,be,Pe);break;default:throw new TypeError("Invalid operator: "+ge)}return Ce}function ce(ue,ge){if(ue instanceof ce){if(ue.loose===ge)return ue;ue=ue.value}if(!(this instanceof ce))return new ce(ue,ge);D("comparator",ue,ge),this.loose=ge,this.parse(ue),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ue,ge){return j(ge,ue)},e.major=function(ue,ge){return new G(ue,ge).major},e.minor=function(ue,ge){return new G(ue,ge).minor},e.patch=function(ue,ge){return new G(ue,ge).patch},e.compare=T,e.compareLoose=function(ue,ge){return T(ue,ge,!0)},e.rcompare=function(ue,ge,be){return T(ge,ue,be)},e.sort=function(ue,ge){return ue.sort(function(be,Pe){return e.compare(be,Pe,ge)})},e.rsort=function(ue,ge){return ue.sort(function(be,Pe){return e.rcompare(be,Pe,ge)})},e.gt=B,e.lt=q,e.eq=Z,e.neq=_,e.gte=ie,e.lte=J,e.cmp=ne,e.Comparator=ce;var fe={};function de(ue,ge){if(ue instanceof de)return ue.loose===ge?ue:new de(ue.raw,ge);if(ue instanceof ce)return new de(ue.value,ge);if(!(this instanceof de))return new de(ue,ge);if(this.loose=ge,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function me(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function Ee(ue,ge,be,Pe,Ce,Fe,je,ze,Te,qe,Ue,Le,re){return((ge=me(be)?"":me(Pe)?">="+be+".0.0":me(Ce)?">="+be+"."+Pe+".0":">="+ge)+" "+(ze=me(Te)?"":me(qe)?"<"+(+Te+1)+".0.0":me(Ue)?"<"+Te+"."+(+qe+1)+".0":Le?"<="+Te+"."+qe+"."+Ue+"-"+Le:"<="+ze)).trim()}function Re(ue,ge){for(var be=0;be<ue.length;be++)if(!ue[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<ue.length;be++)if(D(ue[be].semver),ue[be].semver!==fe&&ue[be].semver.prerelease.length>0){var Pe=ue[be].semver;if(Pe.major===ge.major&&Pe.minor===ge.minor&&Pe.patch===ge.patch)return!0}return!1}return!0}function Oe(ue,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(ue)}function Ne(ue,ge,be,Pe){var Ce,Fe,je,ze,Te;switch(ue=new G(ue,Pe),ge=new de(ge,Pe),be){case">":Ce=B,Fe=J,je=q,ze=">",Te=">=";break;case"<":Ce=q,Fe=ie,je=B,ze="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(ue,ge,Pe))return!1;for(var qe=0;qe<ge.set.length;++qe){var Ue=ge.set[qe],Le=null,re=null;if(Ue.forEach(function($e){$e.semver===fe&&($e=new ce(">=0.0.0")),Le=Le||$e,re=re||$e,Ce($e.semver,Le.semver,Pe)?Le=$e:je($e.semver,re.semver,Pe)&&(re=$e)}),Le.operator===ze||Le.operator===Te||(!re.operator||re.operator===ze)&&Fe(ue,re.semver)||re.operator===Te&&je(ue,re.semver))return!1}return!0}ce.prototype.parse=function(ue){var ge=this.loose?R[W]:R[X],be=ue.match(ge);if(!be)throw new TypeError("Invalid comparator: "+ue);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new G(be[2],this.loose):this.semver=fe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(ue){return D("Comparator.test",ue,this.loose),this.semver===fe||(typeof ue=="string"&&(ue=new G(ue,this.loose)),ne(ue,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(ue,ge){if(!(ue instanceof ce))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(ue.value,ge),Oe(this.value,be,ge);if(ue.operator==="")return be=new de(this.value,ge),Oe(ue.semver,be,ge);var Pe=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),Fe=this.semver.version===ue.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),ze=ne(this.semver,"<",ue.semver,ge)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),Te=ne(this.semver,">",ue.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Pe||Ce||Fe&&je||ze||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ue){var ge=this.loose;ue=ue.trim(),D("range",ue,ge);var be=ge?R[te]:R[V];ue=ue.replace(be,Ee),D("hyphen replace",ue),ue=ue.replace(R[H],"$1$2$3"),D("comparator trim",ue,R[H]),ue=(ue=(ue=ue.replace(R[N],"$1~")).replace(R[Y],"$1^")).split(/\s+/).join(" ");var Pe=ge?R[W]:R[X],Ce=ue.split(" ").map(function(Fe){return function(je,ze){return D("comp",je),je=function(Te,qe){return Te.trim().split(/\s+/).map(function(Ue){return function(Le,re){D("caret",Le,re);var $e=re?R[x]:R[Q];return Le.replace($e,function(pe,we,ve,ke,Ie){var Ae;return D("caret",Le,pe,we,ve,ke,Ie),me(we)?Ae="":me(ve)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":me(ke)?Ae=we==="0"?">="+we+"."+ve+".0 <"+we+"."+(+ve+1)+".0":">="+we+"."+ve+".0 <"+(+we+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=we==="0"?ve==="0"?">="+we+"."+ve+"."+ke+Ie+" <"+we+"."+ve+"."+(+ke+1):">="+we+"."+ve+"."+ke+Ie+" <"+we+"."+(+ve+1)+".0":">="+we+"."+ve+"."+ke+Ie+" <"+(+we+1)+".0.0"):(D("no pr"),Ae=we==="0"?ve==="0"?">="+we+"."+ve+"."+ke+" <"+we+"."+ve+"."+(+ke+1):">="+we+"."+ve+"."+ke+" <"+we+"."+(+ve+1)+".0":">="+we+"."+ve+"."+ke+" <"+(+we+1)+".0.0"),D("caret return",Ae),Ae})}(Ue,qe)}).join(" ")}(je,ze),D("caret",je),je=function(Te,qe){return Te.trim().split(/\s+/).map(function(Ue){return function(Le,re){var $e=re?R[M]:R[F];return Le.replace($e,function(pe,we,ve,ke,Ie){var Ae;return D("tilde",Le,pe,we,ve,ke,Ie),me(we)?Ae="":me(ve)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":me(ke)?Ae=">="+we+"."+ve+".0 <"+we+"."+(+ve+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=">="+we+"."+ve+"."+ke+Ie+" <"+we+"."+(+ve+1)+".0"):Ae=">="+we+"."+ve+"."+ke+" <"+we+"."+(+ve+1)+".0",D("tilde return",Ae),Ae})}(Ue,qe)}).join(" ")}(je,ze),D("tildes",je),je=function(Te,qe){return D("replaceXRanges",Te,qe),Te.split(/\s+/).map(function(Ue){return function(Le,re){Le=Le.trim();var $e=re?R[u]:R[w];return Le.replace($e,function(pe,we,ve,ke,Ie,Ae){D("xRange",Le,pe,we,ve,ke,Ie,Ae);var Ve=me(ve),Be=Ve||me(ke),Me=Be||me(Ie);return we==="="&&Me&&(we=""),Ve?pe=we===">"||we==="<"?"<0.0.0":"*":we&&Me?(Be&&(ke=0),Me&&(Ie=0),we===">"?(we=">=",Be?(ve=+ve+1,ke=0,Ie=0):Me&&(ke=+ke+1,Ie=0)):we==="<="&&(we="<",Be?ve=+ve+1:ke=+ke+1),pe=we+ve+"."+ke+"."+Ie):Be?pe=">="+ve+".0.0 <"+(+ve+1)+".0.0":Me&&(pe=">="+ve+"."+ke+".0 <"+ve+"."+(+ke+1)+".0"),D("xRange return",pe),pe})}(Ue,qe)}).join(" ")}(je,ze),D("xrange",je),je=function(Te,qe){return D("replaceStars",Te,qe),Te.trim().replace(R[oe],"")}(je,ze),D("stars",je),je}(Fe,ge)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(Pe)})),Ce=Ce.map(function(Fe){return new ce(Fe,ge)})},de.prototype.intersects=function(ue,ge){if(!(ue instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Pe){return ue.set.some(function(Ce){return Ce.every(function(Fe){return Pe.intersects(Fe,ge)})})})})},e.toComparators=function(ue,ge){return new de(ue,ge).set.map(function(be){return be.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new G(ue,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Re(this.set[ge],ue))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(ue,ge,be){var Pe=null,Ce=null;try{var Fe=new de(ge,be)}catch{return null}return ue.forEach(function(je){Fe.test(je)&&(Pe&&Ce.compare(je)!==-1||(Ce=new G(Pe=je,be)))}),Pe},e.minSatisfying=function(ue,ge,be){var Pe=null,Ce=null;try{var Fe=new de(ge,be)}catch{return null}return ue.forEach(function(je){Fe.test(je)&&(Pe&&Ce.compare(je)!==1||(Ce=new G(Pe=je,be)))}),Pe},e.validRange=function(ue,ge){try{return new de(ue,ge).range||"*"}catch{return null}},e.ltr=function(ue,ge,be){return Ne(ue,ge,"<",be)},e.gtr=function(ue,ge,be){return Ne(ue,ge,">",be)},e.outside=Ne,e.prerelease=function(ue,ge){var be=ae(ue,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ue,ge,be){return ue=new de(ue,be),ge=new de(ge,be),ue.intersects(ge)},e.coerce=function(ue){if(ue instanceof G)return ue;if(typeof ue!="string")return null;var ge=ue.match(R[p]);return ge==null?null:ae((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,O(1))},function(se,e){var O,A,D=se.exports={};function L(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function R(y){if(O===setTimeout)return setTimeout(y,0);if((O===L||!O)&&setTimeout)return O=setTimeout,setTimeout(y,0);try{return O(y,0)}catch{try{return O.call(null,y,0)}catch{return O.call(this,y,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:L}catch{O=L}try{A=typeof clearTimeout=="function"?clearTimeout:I}catch{A=I}})();var k,g=[],C=!1,S=-1;function m(){C&&k&&(C=!1,k.length?g=k.concat(g):S=-1,g.length&&h())}function h(){if(!C){var y=R(m);C=!0;for(var c=g.length;c;){for(k=g,g=[];++S<c;)k&&k[S].run();S=-1,c=g.length}k=null,C=!1,function(f){if(A===clearTimeout)return clearTimeout(f);if((A===I||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(f);try{A(f)}catch{try{return A.call(null,f)}catch{return A.call(this,f)}}}(y)}}function $(y,c){this.fun=y,this.array=c}function b(){}D.nextTick=function(y){var c=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)c[f-1]=arguments[f];g.push(new $(y,c)),g.length!==1||C||R(h)},$.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=b,D.addListener=b,D.once=b,D.off=b,D.removeListener=b,D.removeAllListeners=b,D.emit=b,D.prependListener=b,D.prependOnceListener=b,D.listeners=function(y){return[]},D.binding=function(y){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(y){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(le[128],he([0,1]),function(se,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0;class A{constructor(R,k,g){this.level=R,this.key=k,this.value=g,this.forward=[]}}const D=void 0;class L{constructor(R,k=2**16){this.comparator=R,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new A(this.c,D,D)}get size(){return this.f}clear(){this.e=new A(this.c,D,D),this.f=0}has(R){return!!L.g(this,R,this.comparator)}get(R){return L.g(this,R,this.comparator)?.value}set(R,k){return L.h(this,R,k,this.comparator)&&(this.f+=1),this}delete(R){const k=L.k(this,R,this.comparator);return k&&(this.f-=1),k}forEach(R,k){let g=this.e.forward[0];for(;g;)R.call(k,g.value,g.key,this),g=g.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",k=this.e.forward[0];for(;k;)R+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return R}static g(R,k,g){let C=R.e;for(let S=R.d-1;S>=0;S--)for(;C.forward[S]&&g(C.forward[S].key,k)<0;)C=C.forward[S];if(C=C.forward[0],C&&g(C.key,k)===0)return C}static h(R,k,g,C){const S=[];let m=R.e;for(let h=R.d-1;h>=0;h--){for(;m.forward[h]&&C(m.forward[h].key,k)<0;)m=m.forward[h];S[h]=m}if(m=m.forward[0],m&&C(m.key,k)===0)return m.value=g,!1;{const h=L.j(R);if(h>R.d){for(let $=R.d;$<h;$++)S[$]=R.e;R.d=h}m=new A(h,k,g);for(let $=0;$<h;$++)m.forward[$]=S[$].forward[$],S[$].forward[$]=m;return!0}}static j(R,k=.5){let g=1;for(;Math.random()<k&&g<R.c;)g+=1;return g}static k(R,k,g){const C=[];let S=R.e;for(let m=R.d-1;m>=0;m--){for(;S.forward[m]&&g(S.forward[m].key,k)<0;)S=S.forward[m];C[m]=S}if(S=S.forward[0],!S||g(S.key,k)!==0)return!1;for(let m=0;m<R.d&&C[m].forward[m]===S;m++)C[m].forward[m]=S.forward[m];for(;R.d>0&&R.e.forward[R.d-1]===D;)R.d-=1;return!0}}e.$_r=L}),define(le[63],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=void 0;const O=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(L){return new A(L)}constructor(L){this.c=O&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$1d=A}),define(le[3],he([0,1,7,86,2,87,63]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.Event=void 0;const R=!1,k=!1;var g;(function(w){w.None=()=>D.$Tc.None;function u(J){if(k){const{onDidAddListener:ne}=J,ce=$.create();let fe=0;J.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),ne?.()}}}function p(J,ne){return X(J,()=>{},0,void 0,!0,void 0,ne)}w.defer=p;function P(J){return(ne,ce=null,fe)=>{let de=!1,me;return me=J(Ee=>{if(!de)return me?me.dispose():de=!0,ne.call(ce,Ee)},null,fe),de&&me.dispose(),me}}w.once=P;function N(J,ne,ce){return x((fe,de=null,me)=>J(Ee=>fe.call(de,ne(Ee)),null,me),ce)}w.map=N;function F(J,ne,ce){return x((fe,de=null,me)=>J(Ee=>{ne(Ee),fe.call(de,Ee)},null,me),ce)}w.forEach=F;function M(J,ne,ce){return x((fe,de=null,me)=>J(Ee=>ne(Ee)&&fe.call(de,Ee),null,me),ce)}w.filter=M;function z(J){return J}w.signal=z;function Y(...J){return(ne,ce=null,fe)=>{const de=(0,D.$Qc)(...J.map(me=>me(Ee=>ne.call(ce,Ee))));return W(de,fe)}}w.any=Y;function Q(J,ne,ce,fe){let de=ce;return N(J,me=>(de=ne(de,me),de),fe)}w.reduce=Q;function x(J,ne){let ce;const fe={onWillAddFirstListener(){ce=J(de.fire,de)},onDidRemoveLastListener(){ce?.dispose()}};ne||u(fe);const de=new d(fe);return ne?.add(de),de.event}function W(J,ne){return ne instanceof Array?ne.push(J):ne&&ne.add(J),J}function X(J,ne,ce=100,fe=!1,de=!1,me,Ee){let Re,Oe,Ne,ue=0,ge;const be={leakWarningThreshold:me,onWillAddFirstListener(){Re=J(Ce=>{ue++,Oe=ne(Oe,Ce),fe&&!Ne&&(Pe.fire(Oe),Oe=void 0),ge=()=>{const Fe=Oe;Oe=void 0,Ne=void 0,(!fe||ue>1)&&Pe.fire(Fe),ue=0},typeof ce=="number"?(clearTimeout(Ne),Ne=setTimeout(ge,ce)):Ne===void 0&&(Ne=0,queueMicrotask(ge))})},onWillRemoveListener(){de&&ue>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,Re.dispose()}};Ee||u(be);const Pe=new d(be);return Ee?.add(Pe),Pe.event}w.debounce=X;function H(J,ne=0,ce){return w.debounce(J,(fe,de)=>fe?(fe.push(de),fe):[de],ne,void 0,!0,void 0,ce)}w.accumulate=H;function V(J,ne=(fe,de)=>fe===de,ce){let fe=!0,de;return M(J,me=>{const Ee=fe||!ne(me,de);return fe=!1,de=me,Ee},ce)}w.latch=V;function te(J,ne,ce){return[w.filter(J,ne,ce),w.filter(J,fe=>!ne(fe),ce)]}w.split=te;function oe(J,ne=!1,ce=[],fe){let de=ce.slice(),me=J(Oe=>{de?de.push(Oe):Re.fire(Oe)});fe&&fe.add(me);const Ee=()=>{de?.forEach(Oe=>Re.fire(Oe)),de=null},Re=new d({onWillAddFirstListener(){me||(me=J(Oe=>Re.fire(Oe)),fe&&fe.add(me))},onDidAddFirstListener(){de&&(ne?setTimeout(Ee):Ee())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return fe&&fe.add(Re),Re.event}w.buffer=oe;function ee(J,ne){return(fe,de,me)=>{const Ee=ne(new G);return J(function(Re){const Oe=Ee.evaluate(Re);Oe!==ae&&fe.call(de,Oe)},void 0,me)}}w.chain=ee;const ae=Symbol("HaltChainable");class G{constructor(){this.f=[]}map(ne){return this.f.push(ne),this}forEach(ne){return this.f.push(ce=>(ne(ce),ce)),this}filter(ne){return this.f.push(ce=>ne(ce)?ce:ae),this}reduce(ne,ce){let fe=ce;return this.f.push(de=>(fe=ne(fe,de),fe)),this}latch(ne=(ce,fe)=>ce===fe){let ce=!0,fe;return this.f.push(de=>{const me=ce||!ne(de,fe);return ce=!1,fe=de,me?de:ae}),this}evaluate(ne){for(const ce of this.f)if(ne=ce(ne),ne===ae)break;return ne}}function U(J,ne,ce=fe=>fe){const fe=(...Re)=>Ee.fire(ce(...Re)),de=()=>J.on(ne,fe),me=()=>J.removeListener(ne,fe),Ee=new d({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Ee.event}w.fromNodeEventEmitter=U;function j(J,ne,ce=fe=>fe){const fe=(...Re)=>Ee.fire(ce(...Re)),de=()=>J.addEventListener(ne,fe),me=()=>J.removeEventListener(ne,fe),Ee=new d({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Ee.event}w.fromDOMEventEmitter=j;function T(J){return new Promise(ne=>P(J)(ne))}w.toPromise=T;function B(J){const ne=new d;return J.then(ce=>{ne.fire(ce)},()=>{ne.fire(void 0)}).finally(()=>{ne.dispose()}),ne.event}w.fromPromise=B;function q(J,ne,ce){return ne(ce),J(fe=>ne(fe))}w.runAndSubscribe=q;class Z{constructor(ne,ce){this._observable=ne,this.f=0,this.g=!1;const fe={onWillAddFirstListener:()=>{ne.addObserver(this)},onDidRemoveLastListener:()=>{ne.removeObserver(this)}};ce||u(fe),this.emitter=new d(fe),ce&&ce.add(this.emitter)}beginUpdate(ne){this.f++}handlePossibleChange(ne){}handleChange(ne,ce){this.g=!0}endUpdate(ne){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _(J,ne){return new Z(J,ne).emitter.event}w.fromObservable=_;function ie(J){return(ne,ce,fe)=>{let de=0,me=!1;const Ee={beginUpdate(){de++},endUpdate(){de--,de===0&&(J.reportChanges(),me&&(me=!1,ne.call(ce)))},handlePossibleChange(){},handleChange(){me=!0}};J.addObserver(Ee),J.reportChanges();const Re={dispose(){J.removeObserver(Ee)}};return fe instanceof D.$Sc?fe.add(Re):Array.isArray(fe)&&fe.push(Re),Re}}w.fromObservableLight=ie})(g||(e.Event=g={}));class C{static{this.all=new Set}static{this.f=0}constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${C.f++}`,C.all.add(this)}start(u){this.g=new I.$1d,this.listenerCount=u}stop(){if(this.g){const u=this.g.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.g=void 0}}}e.$3d=C;let S=-1;function m(w){const u=S;return S=w,{dispose(){S=u}}}e.$4d=m;class h{constructor(u,p=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=p,this.g=0}dispose(){this.f?.clear()}check(u,p){const P=this.threshold;if(P<=0||p<P)return;this.f||(this.f=new Map);const N=this.f.get(u.value)||0;if(this.f.set(u.value,N+1),this.g-=1,this.g<=0){this.g=P*.5;let F,M=0;for(const[z,Y]of this.f)(!F||M<Y)&&(F=z,M=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${M}):`),console.warn(F)}return()=>{const F=this.f.get(u.value)||0;this.f.set(u.value,F-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class y{constructor(u){this.value=u,this.id=b++}}const c=2,f=(w,u)=>{if(w instanceof y)u(w);else for(let p=0;p<w.length;p++){const P=w[p];P&&u(P)}};class d{constructor(u){this.w=0,this.f=u,this.g=S>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??S):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const u=this.t;queueMicrotask(()=>{f(u,p=>p.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(u,p,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.$Tc.None;if(this.m)return D.$Tc.None;p&&(u=u.bind(p));const N=new y(u);let F,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=$.create(),F=this.g.check(N.stack,this.w+1)),R&&(N.stack=M??$.create()),this.t?this.t instanceof y?(this.u??=new v,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const z=(0,D.$Rc)(()=>{F?.(),this.x(N)});return P instanceof D.$Sc?P.add(z):Array.isArray(P)&&P.push(z),z},this.q}x(u){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const p=this.t,P=p.indexOf(u);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,p[P]=void 0;const N=this.u.current===this;if(this.w*c<=p.length){let F=0;for(let M=0;M<p.length;M++)p[M]?p[F++]=p[M]:N&&(this.u.end--,F<this.u.i&&this.u.i--);p.length=F}}y(u,p){if(!u)return;const P=this.f?.onListenerError||O.$1;if(!P){u.value(p);return}try{u.value(p)}catch(N){P(N)}}z(u){const p=u.current.t;for(;u.i<u.end;)this.y(p[u.i++],u.value);u.reset()}fire(u){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof y)this.y(this.t,u);else{const p=this.u;p.enqueue(this,u,this.t.length),this.z(p)}this.j?.stop()}hasListeners(){return this.w>0}}e.$5d=d;const l=()=>new v;e.$6d=l;class v{constructor(){this.i=-1,this.end=0}enqueue(u,p,P){this.i=0,this.end=P,this.current=u,this.value=p}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends d{async fireAsync(u,p,P){if(this.t)for(this.h||(this.h=new L.$4c),f(this.t,N=>this.h.push([N.value,u]));this.h.size>0&&!p.isCancellationRequested;){const[N,F]=this.h.shift(),M=[],z={...F,token:p,waitUntil:Y=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");P&&(Y=P(Y,N)),M.push(Y)}};try{N(z)}catch(Y){(0,O.$1)(Y);continue}Object.freeze(M),await Promise.allSettled(M).then(Y=>{for(const Q of Y)Q.status==="rejected"&&(0,O.$1)(Q.reason)})}}}e.$7d=i;class o extends d{get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new L.$4c,this.A=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.A(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.w&&(this.h!==0?this.s.push(u):super.fire(u))}}e.$8d=o;class n extends o{constructor(u){super(u),this.k=u.delay??100}fire(u){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(u)}}e.$9d=n;class s extends d{constructor(u){super(u),this.h=[],this.k=u?.merge}fire(u){this.hasListeners()&&(this.h.push(u),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(p=>super.fire(p)),this.h=[]}))}}e.$0d=s;class t{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(u){const p={event:u,listener:null};this.h.push(p),this.g&&this.m(p);const P=()=>{this.g&&this.o(p);const N=this.h.indexOf(p);this.h.splice(N,1)};return(0,D.$Rc)((0,A.$db)(P))}j(){this.g=!0,this.h.forEach(u=>this.m(u))}k(){this.g=!1,this.h.forEach(u=>this.o(u))}m(u){u.listener=u.event(p=>this.f.fire(p))}o(u){u.listener?.dispose(),u.listener=null}dispose(){this.f.dispose();for(const u of this.h)u.listener?.dispose();this.h=[]}}e.$$d=t;class r{constructor(u,p,P,N){this.f=new D.$Sc;const F=this.f.add(new t),M=this.f.add(new D.$3c);function z(Y){M.set(Y,F.add(N(Y)))}for(const Y of u)z(Y);this.f.add(p(Y=>{z(Y)})),this.f.add(P(Y=>{M.deleteAndDispose(Y)})),this.event=F.event}dispose(){this.f.dispose()}}e.$_d=r;class a{constructor(){this.f=[]}wrapEvent(u){return(p,P,N)=>u(F=>{const M=this.f[this.f.length-1];M?M.push(()=>p.call(P,F)):p.call(P,F)},void 0,N)}bufferEvents(u){const p=[];this.f.push(p);const P=u();return this.f.pop(),p.forEach(N=>N()),P}}e.$ae=a;class E{constructor(){this.f=!1,this.g=g.None,this.h=D.$Tc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(u){this.g=u,this.f&&(this.h.dispose(),this.h=u(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$be=E}),define(le[26],he([0,1,3]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.CancellationToken=void 0;const A=Object.freeze(function(R,k){const g=setTimeout(R.bind(k),0);return{dispose(){clearTimeout(g)}}});var D;(function(R){function k(g){return g===R.None||g===R.Cancelled||g instanceof L?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=k,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:O.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(D||(e.CancellationToken=D={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new O.$5d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=D.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=D.None}}e.$ce=I}),define(le[129],he([0,1,26]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=void 0;class A{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new O.$ce,k=this.b(R.token);return this.a={promise:k,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$Ne=A;class D{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const k=JSON.stringify(R);return this.b!==k&&(this.b=k,this.a=this.c(R)),this.a}}e.$Oe=D;class L{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const k=this.b(R);return this.a.set(R,k),k}}e.$Pe=L}),define(le[47],he([0,1,7,2]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function D(l){const v=l;return v?typeof v.read=="function":!1}e.$de=D;function L(l){const v=l;return v?[v.on,v.pause,v.resume,v.destroy].every(i=>typeof i=="function"):!1}e.$ee=L;function I(l){const v=l;return v?L(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$fe=I;function R(l,v){return new k(l,v)}e.$ge=R;class k{constructor(v,i){this.e=v,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(i=>i(v))}h(v){this.c.error.length===0?(0,O.$1)(v):this.c.error.slice(0).forEach(i=>i(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,i){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(v,i){if(this.a.destroyed)return;let o;switch(v){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(l,v){const i=[];let o;for(;(o=l.read())!==null;)i.push(o);return v(i)}e.$he=g;function C(l,v,i){const o=[];let n;for(;(n=l.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?v(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return l.read()}}}e.$ie=C;function S(l,v){return new Promise((i,o)=>{const n=[];m(l,{onData:s=>{v&&n.push(s)},onError:s=>{v?o(s):i(void 0)},onEnd:()=>{i(v?v(n):void 0)}})})}e.$je=S;function m(l,v,i){l.on("error",o=>{i?.isCancellationRequested||v.onError(o)}),l.on("end",()=>{i?.isCancellationRequested||v.onEnd()}),l.on("data",o=>{i?.isCancellationRequested||v.onData(o)})}e.$ke=m;function h(l,v){return new Promise((i,o)=>{const n=new A.$Sc,s=[],t=E=>{if(s.push(E),s.length>v)return n.dispose(),l.pause(),i({stream:l,buffer:s,ended:!1})},r=E=>(n.dispose(),o(E)),a=()=>(n.dispose(),i({stream:l,buffer:s,ended:!0}));n.add((0,A.$Rc)(()=>l.removeListener("error",r))),l.on("error",r),n.add((0,A.$Rc)(()=>l.removeListener("end",a))),l.on("end",a),n.add((0,A.$Rc)(()=>l.removeListener("data",t))),l.on("data",t)})}e.$le=h;function $(l,v){const i=R(v);return i.end(l),i}e.$me=$;function b(){const l=R(()=>{throw new Error("not supported")});return l.end(),l}e.$ne=b;function y(l){let v=!1;return{read:()=>v?null:(v=!0,l)}}e.$oe=y;function c(l,v,i){const o=R(i);return m(l,{onData:n=>o.write(v.data(n)),onError:n=>o.error(v.error?v.error(n):n),onEnd:()=>o.end()}),o}e.$pe=c;function f(l,v,i){let o=!1;return{read:()=>{const n=v.read();return o?n:(o=!0,n!==null?i([l,n]):l)}}}e.$qe=f;function d(l,v,i){let o=!1;const n=R(i);return m(v,{onData:s=>o?n.write(s):(o=!0,n.write(i([l,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(l)),n.end()}}),n}e.$re=d}),define(le[14],he([0,1,52,47]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const D=typeof Buffer<"u",L=new O.$V(()=>new Uint8Array(256));let I,R;class k{static alloc(p){return D?new k(Buffer.allocUnsafe(p)):new k(new Uint8Array(p))}static wrap(p){return D&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new k(p)}static fromString(p,P){return!(P?.dontUseNodeBuffer||!1)&&D?new k(Buffer.from(p)):(I||(I=new TextEncoder),new k(I.encode(p)))}static fromByteArray(p){const P=k.alloc(p.length);for(let N=0,F=p.length;N<F;N++)P.buffer[N]=p[N];return P}static concat(p,P){if(typeof P>"u"){P=0;for(let M=0,z=p.length;M<z;M++)P+=p[M].byteLength}const N=k.alloc(P);let F=0;for(let M=0,z=p.length;M<z;M++){const Y=p[M];N.set(Y,F),F+=Y.byteLength}return N}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=k.alloc(this.byteLength);return p.set(this),p}toString(){return D?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(p,P){return new k(this.buffer.subarray(p,P))}set(p,P){if(p instanceof k)this.buffer.set(p.buffer,P);else if(p instanceof Uint8Array)this.buffer.set(p,P);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),P);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return m(this.buffer,p)}writeUInt32BE(p,P){h(this.buffer,p,P)}readUInt32LE(p){return $(this.buffer,p)}writeUInt32LE(p,P){b(this.buffer,p,P)}readUInt8(p){return y(this.buffer,p)}writeUInt8(p,P){c(this.buffer,p,P)}indexOf(p,P=0){return g(this.buffer,p instanceof k?p.buffer:p,P)}}e.$se=k;function g(u,p,P=0){const N=p.byteLength,F=u.byteLength;if(N===0)return 0;if(N===1)return u.indexOf(p[0]);if(N>F-P)return-1;const M=L.value;M.fill(p.length);for(let x=0;x<p.length;x++)M[p[x]]=p.length-x-1;let z=P+p.length-1,Y=z,Q=-1;for(;z<F;)if(u[z]===p[Y]){if(Y===0){Q=z;break}z--,Y--}else z+=Math.max(p.length-Y,M[u[z]]),Y=p.length-1;return Q}e.$te=g;function C(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0}e.$ue=C;function S(u,p,P){u[P+0]=p&255,p=p>>>8,u[P+1]=p&255}e.$ve=S;function m(u,p){return u[p]*2**24+u[p+1]*2**16+u[p+2]*2**8+u[p+3]}e.$we=m;function h(u,p,P){u[P+3]=p,p=p>>>8,u[P+2]=p,p=p>>>8,u[P+1]=p,p=p>>>8,u[P]=p}e.$xe=h;function $(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0|u[p+2]<<16>>>0|u[p+3]<<24>>>0}e.$ye=$;function b(u,p,P){u[P+0]=p&255,p=p>>>8,u[P+1]=p&255,p=p>>>8,u[P+2]=p&255,p=p>>>8,u[P+3]=p&255}e.$ze=b;function y(u,p){return u[p]}e.$Ae=y;function c(u,p,P){u[P]=p}e.$Be=c;function f(u){return A.$he(u,p=>k.concat(p))}e.$Ce=f;function d(u){return A.$oe(u)}e.$De=d;function l(u){return A.$je(u,p=>k.concat(p))}e.$Ee=l;async function v(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await l(u.stream)])}e.$Fe=v;function i(u){return A.$me(u,p=>k.concat(p))}e.$Ge=i;function o(u){return A.$pe(u,{data:p=>typeof p=="string"?k.fromString(p):k.wrap(p)},p=>k.concat(p))}e.$He=o;function n(u){return A.$ge(p=>k.concat(p),u)}e.$Ie=n;function s(u,p){return A.$qe(u,p,P=>k.concat(P))}e.$Je=s;function t(u,p){return A.$re(u,p,P=>k.concat(P))}e.$Ke=t;function r(u){let p=0,P=0,N=0;const F=new Uint8Array(Math.floor(u.length/4*3)),M=Y=>{switch(P){case 3:F[N++]=p|Y,P=0;break;case 2:F[N++]=p|Y>>>2,p=Y<<6,P=3;break;case 1:F[N++]=p|Y>>>4,p=Y<<4,P=2;break;default:p=Y<<2,P=1}};for(let Y=0;Y<u.length;Y++){const Q=u.charCodeAt(Y);if(Q>=65&&Q<=90)M(Q-65);else if(Q>=97&&Q<=122)M(Q-97+26);else if(Q>=48&&Q<=57)M(Q-48+52);else if(Q===43||Q===45)M(62);else if(Q===47||Q===95)M(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${u[Y]}`)}}const z=N;for(;P>0;)M(0);return k.wrap(F).slice(0,z)}e.$Le=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:u},p=!0,P=!1){const N=P?E:a;let F="";const M=u.byteLength%3;let z=0;for(;z<u.byteLength-M;z+=3){const Y=u[z+0],Q=u[z+1],x=u[z+2];F+=N[Y>>>2],F+=N[(Y<<4|Q>>>4)&63],F+=N[(Q<<2|x>>>6)&63],F+=N[x&63]}if(M===1){const Y=u[z+0];F+=N[Y>>>2],F+=N[Y<<4&63],p&&(F+="==")}else if(M===2){const Y=u[z+0],Q=u[z+1];F+=N[Y>>>2],F+=N[(Y<<4|Q>>>4)&63],F+=N[Q<<2&63],p&&(F+="=")}return F}e.$Me=w}),define(le[27],he([0,1,129,52]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rf=e.$Qf=e.$Pf=e.$Of=e.GraphemeBreakType=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=void 0;function D(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.$Se=D;const L=/{(\d+)}/g;function I(re,...$e){return $e.length===0?re:re.replace(L,function(pe,we){const ve=parseInt(we,10);return isNaN(ve)||ve<0||ve>=$e.length?pe:$e[ve]})}e.$Te=I;const R=/{([^}]+)}/g;function k(re,$e){return Object.keys($e).length===0?re:re.replace(R,(pe,we)=>$e[we]??pe)}e.$Ue=k;function g(re){return re.replace(/[<>"'&]/g,$e=>{switch($e){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return $e})}e.$Ve=g;function C(re){return re.replace(/[<>&]/g,function($e){switch($e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return $e}})}e.$We=C;function S(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Xe=S;function m(re,$e){let pe=0;const we=$e.charCodeAt(0);for(let ve=re.length-1;ve>=0;ve--)re.charCodeAt(ve)===we&&pe++;return pe}e.$Ye=m;function h(re,$e,pe="\u2026"){return re.length<=$e?re:`${re.substr(0,$e)}${pe}`}e.$Ze=h;function $(re,$e,pe="\u2026"){if(re.length<=$e)return re;const we=Math.ceil($e/2)-pe.length/2,ve=Math.floor($e/2)-pe.length/2;return`${re.substr(0,we)}${pe}${re.substr(re.length-ve)}`}e.$1e=$;function b(re,$e=" "){const pe=y(re,$e);return c(pe,$e)}e.$2e=b;function y(re,$e){if(!re||!$e)return re;const pe=$e.length;if(pe===0||re.length===0)return re;let we=0;for(;re.indexOf($e,we)===we;)we=we+pe;return re.substring(we)}e.$3e=y;function c(re,$e){if(!re||!$e)return re;const pe=$e.length,we=re.length;if(pe===0||we===0)return re;let ve=we,ke=-1;for(;ke=re.lastIndexOf($e,ve-1),!(ke===-1||ke+pe!==ve);){if(ke===0)return"";ve=ke}return re.substring(0,ve)}e.$4e=c;function f(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$5e=f;function d(re){return re.replace(/\*/g,"")}e.$6e=d;function l(re,$e,pe={}){if(!re)throw new Error("Cannot create regex from empty string");$e||(re=S(re)),pe.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let we="";return pe.global&&(we+="g"),pe.matchCase||(we+="i"),pe.multiline&&(we+="m"),pe.unicode&&(we+="u"),new RegExp(re,we)}e.$7e=l;function v(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.$8e=v;function i(re){return re.split(/\r\n|\r|\n/)}e.$9e=i;function o(re){const $e=[],pe=re.split(/(\r\n|\r|\n)/);for(let we=0;we<Math.ceil(pe.length/2);we++)$e.push(pe[2*we]+(pe[2*we+1]??""));return $e}e.$0e=o;function n(re){for(let $e=0,pe=re.length;$e<pe;$e++){const we=re.charCodeAt($e);if(we!==32&&we!==9)return $e}return-1}e.$$e=n;function s(re,$e=0,pe=re.length){for(let we=$e;we<pe;we++){const ve=re.charCodeAt(we);if(ve!==32&&ve!==9)return re.substring($e,we)}return re.substring($e,pe)}e.$_e=s;function t(re,$e=re.length-1){for(let pe=$e;pe>=0;pe--){const we=re.charCodeAt(pe);if(we!==32&&we!==9)return pe}return-1}e.$af=t;function r(re,$e,pe){const we=[];let ve=0;for(const ke of re.matchAll($e)){if(we.push(re.slice(ve,ke.index)),ke.index===void 0)throw new Error("match.index should be defined");ve=ke.index+ke[0].length,we.push(pe(ke[0],...ke.slice(1),ke.index,re,ke.groups))}return we.push(re.slice(ve)),Promise.all(we).then(ke=>ke.join(""))}e.$bf=r;function a(re,$e){return re<$e?-1:re>$e?1:0}e.$cf=a;function E(re,$e,pe=0,we=re.length,ve=0,ke=$e.length){for(;pe<we&&ve<ke;pe++,ve++){const Ve=re.charCodeAt(pe),Be=$e.charCodeAt(ve);if(Ve<Be)return-1;if(Ve>Be)return 1}const Ie=we-pe,Ae=ke-ve;return Ie<Ae?-1:Ie>Ae?1:0}e.$df=E;function w(re,$e){return u(re,$e,0,re.length,0,$e.length)}e.$ef=w;function u(re,$e,pe=0,we=re.length,ve=0,ke=$e.length){for(;pe<we&&ve<ke;pe++,ve++){let Ve=re.charCodeAt(pe),Be=$e.charCodeAt(ve);if(Ve===Be)continue;if(Ve>=128||Be>=128)return E(re.toLowerCase(),$e.toLowerCase(),pe,we,ve,ke);P(Ve)&&(Ve-=32),P(Be)&&(Be-=32);const Me=Ve-Be;if(Me!==0)return Me}const Ie=we-pe,Ae=ke-ve;return Ie<Ae?-1:Ie>Ae?1:0}e.$ff=u;function p(re){return re>=48&&re<=57}e.$gf=p;function P(re){return re>=97&&re<=122}e.$hf=P;function N(re){return re>=65&&re<=90}e.$if=N;function F(re,$e){return re.length===$e.length&&u(re,$e)===0}e.$jf=F;function M(re,$e){const pe=$e.length;return $e.length>re.length?!1:u(re,$e,0,pe)===0}e.$kf=M;function z(re,$e){const pe=Math.min(re.length,$e.length);let we;for(we=0;we<pe;we++)if(re.charCodeAt(we)!==$e.charCodeAt(we))return we;return pe}e.$lf=z;function Y(re,$e){const pe=Math.min(re.length,$e.length);let we;const ve=re.length-1,ke=$e.length-1;for(we=0;we<pe;we++)if(re.charCodeAt(ve-we)!==$e.charCodeAt(ke-we))return we;return pe}e.$mf=Y;function Q(re){return 55296<=re&&re<=56319}e.$nf=Q;function x(re){return 56320<=re&&re<=57343}e.$of=x;function W(re,$e){return(re-55296<<10)+($e-56320)+65536}e.$pf=W;function X(re,$e,pe){const we=re.charCodeAt(pe);if(Q(we)&&pe+1<$e){const ve=re.charCodeAt(pe+1);if(x(ve))return W(we,ve)}return we}e.$qf=X;function H(re,$e){const pe=re.charCodeAt($e-1);if(x(pe)&&$e>1){const we=re.charCodeAt($e-2);if(Q(we))return W(we,pe)}return pe}class V{get offset(){return this.e}constructor($e,pe=0){this.c=$e,this.d=$e.length,this.e=pe}setOffset($e){this.e=$e}prevCodePoint(){const $e=H(this.c,this.e);return this.e-=$e>=65536?2:1,$e}nextCodePoint(){const $e=X(this.c,this.d,this.e);return this.e+=$e>=65536?2:1,$e}eol(){return this.e>=this.d}}e.$rf=V;class te{get offset(){return this.c.offset}constructor($e,pe=0){this.c=new V($e,pe)}nextGraphemeLength(){const $e=Ce.getInstance(),pe=this.c,we=pe.offset;let ve=$e.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const ke=pe.offset,Ie=$e.getGraphemeBreakType(pe.nextCodePoint());if(be(ve,Ie)){pe.setOffset(ke);break}ve=Ie}return pe.offset-we}prevGraphemeLength(){const $e=Ce.getInstance(),pe=this.c,we=pe.offset;let ve=$e.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const ke=pe.offset,Ie=$e.getGraphemeBreakType(pe.prevCodePoint());if(be(Ie,ve)){pe.setOffset(ke);break}ve=Ie}return we-pe.offset}eol(){return this.c.eol()}}e.$sf=te;function oe(re,$e){return new te(re,$e).nextGraphemeLength()}e.$tf=oe;function ee(re,$e){return new te(re,$e).prevGraphemeLength()}e.$uf=ee;function ae(re,$e){$e>0&&x(re.charCodeAt($e))&&$e--;const pe=$e+oe(re,$e);return[pe-ee(re,pe),pe]}e.$vf=ae;function G(re){const $e=new te(re);let pe=0;for(;!$e.eol();)pe++,$e.nextGraphemeLength();return pe}e.$wf=G;let U;function j(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function T(re){return U||(U=j()),U.test(re)}e.$xf=T;const B=/^[\t\n\r\x20-\x7E]*$/;function q(re){return B.test(re)}e.$yf=q,e.$zf=/[\u2028\u2029]/;function Z(re){return e.$zf.test(re)}e.$Af=Z;function _(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.$Bf=_;function ie(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.$Cf=ie;function J(re,$e,pe=""){const we=re.trimStart();if(we.length<$e)return we;const ve=/\b/g;let ke=0;for(;ve.test(we)&&!(we.length-ve.lastIndex<$e);)ke=ve.lastIndex,ve.lastIndex+=1;return ke===0?we:pe+we.substring(ke).trimStart()}e.$Df=J;const ne=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function fe(re){return re&&(re=re.replace(ne,"").replace(ce,"")),re}e.$Ef=fe,e.$Ff="\uFEFF";function de(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.$Gf=de;function me(re){return de(re)?re.substr(1):re}e.$Hf=me;function Ee(re,$e){if(!re||!$e||re.length<$e.length)return!1;const pe=$e.length,we=re.toLowerCase();let ve=0,ke=-1;for(;ve<pe;){const Ie=we.indexOf($e[ve],ke+1);if(Ie<0)return!1;ke=Ie,ve++}return!0}e.$If=Ee;function Re(re,$e=!1){return re?($e&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.$Jf=Re;function Oe(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.$Kf=Oe;function Ne(re,$e=1){if($e===0)return"";let pe=-1;do pe=re.indexOf(`
`,pe+1),$e--;while($e>0&&pe>=0);return pe===-1?re:(re[pe-1]==="\r"&&pe--,re.substr(0,pe))}e.$Lf=Ne;function ue(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.$Mf=ue;function ge(re){return Ce.getInstance().getGraphemeBreakType(re)}e.$Nf=ge;function be(re,$e){return re===0?$e!==5&&$e!==7:re===2&&$e===3?!1:re===4||re===2||re===3||$e===4||$e===2||$e===3?!0:!(re===8&&($e===8||$e===9||$e===11||$e===12)||(re===11||re===9)&&($e===9||$e===10)||(re===12||re===10)&&$e===10||$e===5||$e===13||$e===7||re===1||re===13&&$e===14||re===6&&$e===6)}var Pe;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Ce{static{this.c=null}static getInstance(){return Ce.c||(Ce.c=new Ce),Ce.c}constructor(){this.d=Fe()}getGraphemeBreakType($e){if($e<32)return $e===10?3:$e===13?2:4;if($e<127)return 0;const pe=this.d,we=pe.length/3;let ve=1;for(;ve<=we;)if($e<pe[3*ve])ve=2*ve;else if($e>pe[3*ve+1])ve=2*ve+1;else return pe[3*ve+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(re,$e){if(re===0)return 0;const pe=ze(re,$e);if(pe!==void 0)return pe;const we=new V($e,re);return we.prevCodePoint(),we.offset}e.$Of=je;function ze(re,$e){const pe=new V($e,re);let we=pe.prevCodePoint();for(;Te(we)||we===65039||we===8419;){if(pe.offset===0)return;we=pe.prevCodePoint()}if(!ie(we))return;let ve=pe.offset;return ve>0&&pe.prevCodePoint()===8205&&(ve=pe.offset),ve}function Te(re){return 127995<=re&&re<=127999}var qe;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$Pf="\xA0";class Ue{static{this.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new O.$Oe($e=>{function pe(Me){const Je=new Map;for(let He=0;He<Me.length;He+=2)Je.set(Me[He],Me[He+1]);return Je}function we(Me,Je){const He=new Map(Me);for(const[_e,tt]of Je)He.set(_e,tt);return He}function ve(Me,Je){if(!Me)return Je;const He=new Map;for(const[_e,tt]of Me)Je.has(_e)&&He.set(_e,tt);return He}const ke=this.c.value;let Ie=$e.filter(Me=>!Me.startsWith("_")&&Me in ke);Ie.length===0&&(Ie=["_default"]);let Ae;for(const Me of Ie){const Je=pe(ke[Me]);Ae=ve(Ae,Je)}const Ve=pe(ke._common),Be=we(Ve,Ae);return new Ue(Be)})}static getInstance($e){return Ue.d.get(Array.from($e))}static{this.e=new A.$V(()=>Object.keys(Ue.c.value).filter($e=>!$e.startsWith("_")))}static getLocales(){return Ue.e.value}constructor($e){this.f=$e}isAmbiguous($e){return this.f.has($e)}getPrimaryConfusable($e){return this.f.get($e)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Qf=Ue;class Le{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Le.c())),this.d}static isInvisibleCharacter($e){return Le.e().has($e)}static get codePoints(){return Le.e()}}e.$Rf=Le}),define(le[53],he([0,1,27]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=void 0;function A(c){return D(c,0)}e.$5i=A;function D(c,f){switch(typeof c){case"object":return c===null?L(349,f):Array.isArray(c)?k(c,f):g(c,f);case"string":return R(c,f);case"boolean":return I(c,f);case"number":return L(c,f);case"undefined":return L(937,f);default:return L(617,f)}}e.$6i=D;function L(c,f){return(f<<5)-f+c|0}e.$7i=L;function I(c,f){return L(c?433:863,f)}function R(c,f){f=L(149417,f);for(let d=0,l=c.length;d<l;d++)f=L(c.charCodeAt(d),f);return f}e.$8i=R;function k(c,f){return f=L(104579,f),c.reduce((d,l)=>D(l,d),f)}function g(c,f){return f=L(181387,f),Object.keys(c).sort().reduce((d,l)=>(d=R(l,d),D(c[l],d)),f)}class C{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=D(f,this.g),this.g}}e.$9i=C;var S;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function m(c,f,d=32){const l=d-f,v=~((1<<l)-1);return(c<<f|(v&c)>>>l)>>>0}function h(c,f=0,d=c.byteLength,l=0){for(let v=0;v<d;v++)c[f+v]=l}function $(c,f,d="0"){for(;c.length<f;)c=d+c;return c}function b(c,f=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(d=>d.toString(16).padStart(2,"0")).join(""):$((c>>>0).toString(16),f/4)}e.$0i=b;class y{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const d=f.length;if(d===0)return;const l=this.p;let v=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=f.charCodeAt(0),n=0);;){let s=o;if(O.$nf(o))if(n+1<d){const t=f.charCodeAt(n+1);O.$of(t)?(n++,s=O.$pf(o,t)):s=65533}else{i=o;break}else O.$of(o)&&(s=65533);if(v=this.w(l,v,s),n++,n<d)o=f.charCodeAt(n);else break}this.r=v,this.u=i}w(f,d,l){return l<128?f[d++]=l:l<2048?(f[d++]=192|(l&1984)>>>6,f[d++]=128|(l&63)>>>0):l<65536?(f[d++]=224|(l&61440)>>>12,f[d++]=128|(l&4032)>>>6,f[d++]=128|(l&63)>>>0):(f[d++]=240|(l&1835008)>>>18,f[d++]=128|(l&258048)>>>12,f[d++]=128|(l&4032)>>>6,f[d++]=128|(l&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=y.g,d=this.q;for(let a=0;a<64;a+=4)f.setUint32(a,d.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)f.setUint32(a,m(f.getUint32(a-12,!1)^f.getUint32(a-32,!1)^f.getUint32(a-56,!1)^f.getUint32(a-64,!1),1),!1);let l=this.h,v=this.l,i=this.m,o=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=v&i|~v&o,t=1518500249):a<40?(s=v^i^o,t=1859775393):a<60?(s=v&i|v&o|i&o,t=2400959708):(s=v^i^o,t=3395469782),r=m(l,5)+s+n+t+f.getUint32(a*4,!1)&4294967295,n=o,o=i,i=m(v,30),v=l,l=r;this.h=this.h+l&4294967295,this.l=this.l+v&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$$i=y}),define(le[89],he([0,1,27]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(A||(A={})),function(D){const L="error",I="warning",R="warn",k="info",g="ignore";function C(m){return m?O.$jf(L,m)?D.Error:O.$jf(I,m)||O.$jf(R,m)?D.Warning:O.$jf(k,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=C;function S(m){switch(m){case D.Error:return L;case D.Warning:return I;case D.Info:return k;default:return g}}D.toString=S}(A||(A={})),e.default=A}),define(le[130],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0,e.$2d=Symbol("MicrotaskDelay")}),define(le[48],he([0,1,17,27]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;class D{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const $=h.charCodeAt(0),b=this.b.charCodeAt(this.c);return $-b}value(){return this.b[this.c]}}e.$gi=D;class L{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,A.$df)(h,this.b,0,h.length,this.c,this.d):(0,A.$ff)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$hi=L;class I{constructor(h=!0,$=!0){this.f=h,this.g=$}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let $=h.length-1;$>=0;$--,this.c--){const b=this.b.charCodeAt($);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,A.$df)(h,this.b,0,h.length,this.d,this.e):(0,A.$ff)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ii=I;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class k{constructor(h,$){this.f=h,this.g=$,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,A.$ef)(h,this.c.scheme);if(this.d[this.e]===2)return(0,A.$ef)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,A.$cf)(h,this.c.query);if(this.d[this.e]===5)return(0,A.$cf)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ji=k;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(C||(C={}));class S{static forUris(h=()=>!1,$=()=>!1){return new S(new k(h,$))}static forPaths(h=!1){return new S(new I(void 0,!h))}static forStrings(){return new S(new D)}static forConfigKeys(){return new S(new L)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,$){if($){const b=$.slice(0);(0,O.$Xb)(b);for(const y of b)this.set(y,h)}else{const b=h.slice(0);(0,O.$Xb)(b);for(const y of b)this.set(y[0],y[1])}}set(h,$){const b=this.b.reset(h);let y;this.c||(this.c=new g,this.c.segment=b.value());const c=[];for(y=this.c;;){const d=b.cmp(y.segment);if(d>0)y.left||(y.left=new g,y.left.segment=b.value()),c.push([-1,y]),y=y.left;else if(d<0)y.right||(y.right=new g,y.right.segment=b.value()),c.push([1,y]),y=y.right;else if(b.hasNext())b.next(),y.mid||(y.mid=new g,y.mid.segment=b.value()),c.push([0,y]),y=y.mid;else break}const f=y.value;y.value=$,y.key=h;for(let d=c.length-1;d>=0;d--){const l=c[d][1];l.updateHeight();const v=l.balanceFactor();if(v<-1||v>1){const i=c[d][0],o=c[d+1][0];if(i===1&&o===1)c[d][1]=l.rotateLeft();else if(i===-1&&o===-1)c[d][1]=l.rotateRight();else if(i===1&&o===-1)l.right=c[d+1][1]=c[d+1][1].rotateRight(),c[d][1]=l.rotateLeft();else if(i===-1&&o===1)l.left=c[d+1][1]=c[d+1][1].rotateLeft(),c[d][1]=l.rotateRight();else throw new Error;if(d>0)switch(c[d-1][0]){case-1:c[d-1][1].left=c[d][1];break;case 1:c[d-1][1].right=c[d][1];break;case 0:c[d-1][1].mid=c[d][1];break}else this.c=c[0][1]}}return f}get(h){return this.d(h)?.value}d(h){const $=this.b.reset(h);let b=this.c;for(;b;){const y=$.cmp(b.segment);if(y>0)b=b.left;else if(y<0)b=b.right;else if($.hasNext())$.next(),b=b.mid;else break}return b}has(h){const $=this.d(h);return!($?.value===void 0&&$?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,$){const b=this.b.reset(h),y=[];let c=this.c;for(;c;){const f=b.cmp(c.segment);if(f>0)y.push([-1,c]),c=c.left;else if(f<0)y.push([1,c]),c=c.right;else if(b.hasNext())b.next(),y.push([0,c]),c=c.mid;else break}if(c){if($?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const f=this.f(c.right);if(f.key){const{key:d,value:l,segment:v}=f;this.e(f.key,!1),c.key=d,c.value=l,c.segment=v}}else{const f=c.left??c.right;if(y.length>0){const[d,l]=y[y.length-1];switch(d){case-1:l.left=f;break;case 0:l.mid=f;break;case 1:l.right=f;break}}else this.c=f}for(let f=y.length-1;f>=0;f--){const d=y[f][1];d.updateHeight();const l=d.balanceFactor();if(l>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),y[f][1]=d.rotateLeft()):l<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),y[f][1]=d.rotateRight()),f>0)switch(y[f-1][0]){case-1:y[f-1][1].left=y[f][1];break;case 1:y[f-1][1].right=y[f][1];break;case 0:y[f-1][1].mid=y[f][1];break}else this.c=y[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const $=this.b.reset(h);let b=this.c,y;for(;b;){const c=$.cmp(b.segment);if(c>0)b=b.left;else if(c<0)b=b.right;else if($.hasNext())$.next(),y=b.value||y,b=b.mid;else break}return b&&b.value||y}findSuperstr(h){return this.g(h,!1)}g(h,$){const b=this.b.reset(h);let y=this.c;for(;y;){const c=b.cmp(y.segment);if(c>0)y=y.left;else if(c<0)y=y.right;else if(b.hasNext())b.next(),y=y.mid;else return y.mid?this.h(y.mid):$?y.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[$,b]of this)h(b,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const $=[];return this.j(h,$),$[Symbol.iterator]()}j(h,$){h&&(h.left&&this.j(h.left,$),h.value&&$.push([h.key,h.value]),h.mid&&this.j(h.mid,$),h.right&&this.j(h.right,$))}_isBalanced(){const h=$=>{if(!$)return!0;const b=$.balanceFactor();return b<-1||b>1?!1:h($.left)&&h($.right)};return h(this.c)}}e.$ki=S}),define(le[12],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=void 0;function O(v){return typeof v=="string"}e.$Sf=O;function A(v){return Array.isArray(v)&&v.every(i=>O(i))}e.$Tf=A;function D(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.$Uf=D;function L(v){const i=Object.getPrototypeOf(Uint8Array);return typeof v=="object"&&v instanceof i}e.$Vf=L;function I(v){return typeof v=="number"&&!isNaN(v)}e.$Wf=I;function R(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.$Xf=R;function k(v){return v===!0||v===!1}e.$Yf=k;function g(v){return typeof v>"u"}e.$Zf=g;function C(v){return!S(v)}e.$1f=C;function S(v){return g(v)||v===null}e.$2f=S;function m(v,i){if(!v)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$3f=m;function h(v){if(S(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.$4f=h;function $(...v){const i=[];for(let o=0;o<v.length;o++){const n=v[o];if(S(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}e.$5f=$;const b=Object.prototype.hasOwnProperty;function y(v){if(!D(v))return!1;for(const i in v)if(b.call(v,i))return!1;return!0}e.$6f=y;function c(v){return typeof v=="function"}e.$7f=c;function f(...v){return v.length>0&&v.every(c)}e.$8f=f;function d(v,i){const o=Math.min(v.length,i.length);for(let n=0;n<o;n++)l(v[n],i[n])}e.$9f=d;function l(v,i){if(O(i)){if(typeof v!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(c(i)){try{if(v instanceof i)return}catch{}if(!S(v)&&v.constructor===i||i.length===1&&i.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$0f=l}),define(le[30],he([0,1,12]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function A(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const f=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([d,l])=>{f[d]=l&&typeof l=="object"?A(l):l}),f}e.$Hn=A;function D(c){if(!c||typeof c!="object")return c;const f=[c];for(;f.length>0;){const d=f.shift();Object.freeze(d);for(const l in d)if(L.call(d,l)){const v=d[l];typeof v=="object"&&!Object.isFrozen(v)&&!(0,O.$Vf)(v)&&f.push(v)}}return c}e.$In=D;const L=Object.prototype.hasOwnProperty;function I(c,f){return R(c,f,new Set)}e.$Jn=I;function R(c,f,d){if((0,O.$2f)(c))return c;const l=f(c);if(typeof l<"u")return l;if(Array.isArray(c)){const v=[];for(const i of c)v.push(R(i,f,d));return v}if((0,O.$Uf)(c)){if(d.has(c))throw new Error("Cannot clone recursive data-structure");d.add(c);const v={};for(const i in c)L.call(c,i)&&(v[i]=R(c[i],f,d));return d.delete(c),v}return c}function k(c,f,d=!0){return(0,O.$Uf)(c)?((0,O.$Uf)(f)&&Object.keys(f).forEach(l=>{l in c?d&&((0,O.$Uf)(c[l])&&(0,O.$Uf)(f[l])?k(c[l],f[l],d):c[l]=f[l]):c[l]=f[l]}),c):f}e.$Kn=k;function g(c,f){if(c===f)return!0;if(c==null||f===null||f===void 0||typeof c!=typeof f||typeof c!="object"||Array.isArray(c)!==Array.isArray(f))return!1;let d,l;if(Array.isArray(c)){if(c.length!==f.length)return!1;for(d=0;d<c.length;d++)if(!g(c[d],f[d]))return!1}else{const v=[];for(l in c)v.push(l);v.sort();const i=[];for(l in f)i.push(l);if(i.sort(),!g(v,i))return!1;for(d=0;d<v.length;d++)if(!g(c[v[d]],f[v[d]]))return!1}return!0}e.$Ln=g;function C(c){const f=new Set;return JSON.stringify(c,(d,l)=>{if((0,O.$Uf)(l)||Array.isArray(l)){if(f.has(l))return"[Circular]";f.add(l)}return l})}e.$Mn=C;function S(c,f){const d=Object.create(null);return!c||!f||Object.keys(f).forEach(v=>{const i=c[v],o=f[v];g(i,o)||(d[v]=o)}),d}e.$Nn=S;function m(c,f){const d=f.toLowerCase(),l=Object.keys(c).find(v=>v.toLowerCase()===d);return l?c[l]:c[f]}e.$On=m;function h(c,f){const d=Object.create(null);for(const[l,v]of Object.entries(c))f(l,v)&&(d[l]=v);return d}e.$Pn=h;function $(c){let f=[];for(;Object.prototype!==c;)f=f.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return f}e.$Qn=$;function b(c){const f=[];for(const d of $(c))typeof c[d]=="function"&&f.push(d);return f}e.$Rn=b;function y(c,f){const d=v=>function(){const i=Array.prototype.slice.call(arguments,0);return f(v,i)},l={};for(const v of c)l[v]=d(v);return l}e.$Sn=y}),define(le[32],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=e.$zg=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(D){return O.test(D)}e.$zg=A,e.$Ag=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let k=0;k<R.length;k++)R[k]=Math.floor(Math.random()*256);return R};const L=new Uint8Array(16),I=[];for(let R=0;R<256;R++)I.push(R.toString(16).padStart(2,"0"));return function(){D(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let k=0,g="";return g+=I[L[k++]],g+=I[L[k++]],g+=I[L[k++]],g+=I[L[k++]],g+="-",g+=I[L[k++]],g+=I[L[k++]],g+="-",g+=I[L[k++]],g+=I[L[k++]],g+="-",g+=I[L[k++]],g+=I[L[k++]],g+="-",g+=I[L[k++]],g+=I[L[k++]],g+=I[L[k++]],g+=I[L[k++]],g+=I[L[k++]],g+=I[L[k++]],g}}()}),define(le[131],he([0,1,36]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(I){const R=I.replace(/\-/g,":").toLowerCase();return!A.has(R)}function L(){const I=(0,O.networkInterfaces)();for(const R in I){const k=I[R];if(k){for(const{mac:g}of k)if(D(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$in=L}),define(le[132],he([0,1,267,14]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wV=void 0;class D extends O.Transform{constructor(I){if(super(),typeof I=="number")this.b=I,this.c=1;else{const R=Buffer.isBuffer(I)?I:Buffer.from(I);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(I,R,k){this.a?this.a=Buffer.concat([this.a,I]):this.a=I;let g=0;for(;g<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,A.$te)(this.a,this.b,g);if(C===-1)break;this.push(this.a.slice(g,C+this.c)),g=C+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),k()}_flush(I){this.a&&this.push(this.a),I()}}e.$wV=D}),define(le[133],he([0,1,64]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.$Dg=e.$Cg=void 0;function A(R,k,g,C=1){let S=!1;return new Promise(m=>{const h=setTimeout(()=>{if(!S)return S=!0,m(0)},g);D(R,k,C,$=>{if(!S)return S=!0,clearTimeout(h),m($)})})}e.$Cg=A;function D(R,k,g,C){if(k===0)return C(0);const S=new O.Socket;S.once("connect",()=>(I(S),D(R+g,k-1,g,C))),S.once("data",()=>{}),S.once("error",m=>(I(S),m.code!=="ECONNREFUSED"?D(R+g,k-1,g,C):C(R))),S.connect(R,"127.0.0.1")}e.$Dg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(R,k,g,C="127.0.0.1"){let S=!1,m,h=1;const $=O.createServer({pauseOnConnect:!0});function b(y,c){S||(S=!0,$.removeAllListeners(),$.close(),m&&clearTimeout(m),c(y))}return new Promise(y=>{m=setTimeout(()=>{b(0,y)},g),$.on("listening",()=>{b(R,y)}),$.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&h<k?(R++,h++,$.listen(R,C)):b(0,y)}),$.on("close",()=>{b(0,y)}),$.listen(R,C)})}e.$Eg=L;function I(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(k){console.error(k)}}}),define(le[134],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MV=void 0;function O(A){return!!A.parentPort}e.$MV=O}),define(le[135],he([13,9]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],he([0,1,135]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=e.$Gm=void 0;const A=60,D=A*60,L=D*24,I=L*7,R=L*30,k=L*365;function g(m,h,$,b){typeof m!="number"&&(m=m.getTime());const y=Math.round((new Date().getTime()-m)/1e3);if(y<-30)return(0,O.localize)(0,null,g(new Date().getTime()+y*1e3,!1));if(!b&&y<30)return(0,O.localize)(1,null);let c;return y<A?(c=y,h?c===1?$?(0,O.localize)(2,null,c):(0,O.localize)(3,null,c):$?(0,O.localize)(4,null,c):(0,O.localize)(5,null,c):c===1?$?(0,O.localize)(6,null,c):(0,O.localize)(7,null,c):$?(0,O.localize)(8,null,c):(0,O.localize)(9,null,c)):y<D?(c=Math.floor(y/A),h?c===1?$?(0,O.localize)(10,null,c):(0,O.localize)(11,null,c):$?(0,O.localize)(12,null,c):(0,O.localize)(13,null,c):c===1?$?(0,O.localize)(14,null,c):(0,O.localize)(15,null,c):$?(0,O.localize)(16,null,c):(0,O.localize)(17,null,c)):y<L?(c=Math.floor(y/D),h?c===1?$?(0,O.localize)(18,null,c):(0,O.localize)(19,null,c):$?(0,O.localize)(20,null,c):(0,O.localize)(21,null,c):c===1?$?(0,O.localize)(22,null,c):(0,O.localize)(23,null,c):$?(0,O.localize)(24,null,c):(0,O.localize)(25,null,c)):y<I?(c=Math.floor(y/L),h?c===1?(0,O.localize)(26,null,c):(0,O.localize)(27,null,c):c===1?(0,O.localize)(28,null,c):(0,O.localize)(29,null,c)):y<R?(c=Math.floor(y/I),h?c===1?$?(0,O.localize)(30,null,c):(0,O.localize)(31,null,c):$?(0,O.localize)(32,null,c):(0,O.localize)(33,null,c):c===1?$?(0,O.localize)(34,null,c):(0,O.localize)(35,null,c):$?(0,O.localize)(36,null,c):(0,O.localize)(37,null,c)):y<k?(c=Math.floor(y/R),h?c===1?$?(0,O.localize)(38,null,c):(0,O.localize)(39,null,c):$?(0,O.localize)(40,null,c):(0,O.localize)(41,null,c):c===1?$?(0,O.localize)(42,null,c):(0,O.localize)(43,null,c):$?(0,O.localize)(44,null,c):(0,O.localize)(45,null,c)):(c=Math.floor(y/k),h?c===1?$?(0,O.localize)(46,null,c):(0,O.localize)(47,null,c):$?(0,O.localize)(48,null,c):(0,O.localize)(49,null,c):c===1?$?(0,O.localize)(50,null,c):(0,O.localize)(51,null,c):$?(0,O.localize)(52,null,c):(0,O.localize)(53,null,c))}e.$Gm=g;function C(m,h){const $=Math.abs(m/1e3);return $<1?h?(0,O.localize)(54,null,m):(0,O.localize)(55,null,m):$<A?h?(0,O.localize)(56,null,Math.round(m)/1e3):(0,O.localize)(57,null,Math.round(m)/1e3):$<D?h?(0,O.localize)(58,null,Math.round(m/(1e3*A))):(0,O.localize)(59,null,Math.round(m/(1e3*A))):$<L?h?(0,O.localize)(60,null,Math.round(m/(1e3*D))):(0,O.localize)(61,null,Math.round(m/(1e3*D))):(0,O.localize)(62,null,Math.round(m/(1e3*L)))}e.$Hm=C;function S(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Im=S}),define(le[136],he([13,9]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,17,12,136]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=void 0;function L(S,m){return m&&(S.stack||S.stacktrace)?D.localize(0,null,R(S),I(S.stack)||I(S.stacktrace)):R(S)}function I(S){return Array.isArray(S)?S.join(`
`):S}function R(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?D.localize(1,null,S.message):S.message||D.localize(2,null)}function k(S=null,m=!1){if(!S)return D.localize(3,null);if(Array.isArray(S)){const h=O.$Hb(S),$=k(h[0],m);return h.length>1?D.localize(4,null,$,h.length):$}if(A.$Sf(S))return S;if(S.detail){const h=S.detail;if(h.error)return L(h.error,m);if(h.exception)return L(h.exception,m)}return S.stack?L(S,m):S.message?S.message:D.localize(5,null)}e.$2i=k;function g(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}e.$3i=g;function C(S,m){let h;return typeof S=="string"?h=new Error(S):h=S,h.actions=m,h}e.$4i=C}),define(le[137],he([13,9]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],he([0,1,137]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;function A(D){switch(D){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.$9p=A}),define(le[139],he([13,9]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],he([0,1,139]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let A=!1,D=!1,L=!1,I=!1,R=!1,k=!1,g=!1,C=!1,S=!1,m=!1,h,$=e.$g,b=e.$g,y,c;const f=globalThis;let d;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?d=f.vscode.process:typeof process<"u"&&(d=process);const l=typeof d?.versions?.electron=="string",v=l&&d?.type==="renderer";if(typeof d=="object"){A=d.platform==="win32",D=d.platform==="darwin",L=d.platform==="linux",I=L&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,g=l,S=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$g,$=e.$g;const u=d.env.VSCODE_NLS_CONFIG;if(u)try{const p=JSON.parse(u),P=p.availableLanguages["*"];h=p.locale,b=p.osLocale,$=P||e.$g,y=p._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!v?(c=navigator.userAgent,A=c.indexOf("Windows")>=0,D=c.indexOf("Macintosh")>=0,C=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=c.indexOf("Linux")>=0,m=c?.indexOf("Mobi")>=0,k=!0,h=O.getConfiguredDefaultLocale(O.localize(0,null))||e.$g,$=h,b=navigator.language):console.error("Unable to resolve platform.");var i;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let n=0;D?n=1:A?n=3:L&&(n=2),e.$i=A,e.$j=D,e.$k=L,e.$l=I,e.$m=R,e.$n=g,e.$o=k,e.$p=k&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=C,e.$s=m,e.$t=S,e.$u=n,e.$v=c,e.$w=$;var s;(function(u){function p(){return e.$w}u.value=p;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}u.isDefaultVariant=P;function N(){return e.$w==="en"}u.isDefault=N})(s||(e.Language=s={})),e.$x=h,e.$y=b,e.$z=y,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const u=[];f.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let N=0,F=u.length;N<F;N++){const M=u[N];if(M.id===P.data.vscodeScheduleAsyncWork){u.splice(N,1),M.callback();return}}});let p=0;return P=>{const N=++p;u.push({id:N,callback:P}),f.postMessage({vscodeScheduleAsyncWork:N},"*")}}return u=>setTimeout(u)})();var t;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=D||C?2:A?1:3;let r=!0,a=!1;function E(){if(!a){a=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===513}return r}e.$D=E,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(u){return parseFloat(u)>=20}e.$J=w}),define(le[37],he([0,1,5]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let A;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.process<"u"){const L=D.process;A={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return O.$i?"win32":O.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$dc=A.platform,e.$ec=A.arch}),define(le[16],he([0,1,37]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const A=65,D=97,L=90,I=122,R=46,k=47,g=92,C=58,S=63;class m extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function $(i,o){if(typeof i!="string")throw new m(o,"string",i)}const b=O.$dc==="win32";function y(i){return i===k||i===g}function c(i){return i===k}function f(i){return i>=A&&i<=L||i>=D&&i<=I}function d(i,o,n,s){let t="",r=0,a=-1,E=0,w=0;for(let u=0;u<=i.length;++u){if(u<i.length)w=i.charCodeAt(u);else{if(s(w))break;w=k}if(s(w)){if(!(a===u-1||E===1))if(E===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const p=t.lastIndexOf(n);p===-1?(t="",r=0):(t=t.slice(0,p),r=t.length-1-t.lastIndexOf(n)),a=u,E=0;continue}else if(t.length!==0){t="",r=0,a=u,E=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,u)}`:t=i.slice(a+1,u),r=u-a-1;a=u,E=0}else w===R&&E!==-1?++E:E=-1}return t}function l(i,o){h(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.$fc={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],$(r,"path"),r.length===0)continue}else o.length===0?r=O.cwd():(r=O.env[`=${o}`]||O.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let E=0,w="",u=!1;const p=r.charCodeAt(0);if(a===1)y(p)&&(E=1,u=!0);else if(y(p))if(u=!0,y(r.charCodeAt(1))){let P=2,N=P;for(;P<a&&!y(r.charCodeAt(P));)P++;if(P<a&&P!==N){const F=r.slice(N,P);for(N=P;P<a&&y(r.charCodeAt(P));)P++;if(P<a&&P!==N){for(N=P;P<a&&!y(r.charCodeAt(P));)P++;(P===a||P!==N)&&(w=`\\\\${F}\\${r.slice(N,P)}`,E=P)}}}else E=1;else f(p)&&r.charCodeAt(1)===C&&(w=r.slice(0,2),E=2,a>2&&y(r.charCodeAt(2))&&(u=!0,E=3));if(w.length>0)if(o.length>0){if(w.toLowerCase()!==o.toLowerCase())continue}else o=w;if(s){if(o.length>0)break}else if(n=`${r.slice(E)}\\${n}`,s=u,u&&o.length>0)break}return n=d(n,!s,"\\",y),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){$(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return c(r)?"\\":i;if(y(r))if(t=!0,y(i.charCodeAt(1))){let E=2,w=E;for(;E<o&&!y(i.charCodeAt(E));)E++;if(E<o&&E!==w){const u=i.slice(w,E);for(w=E;E<o&&y(i.charCodeAt(E));)E++;if(E<o&&E!==w){for(w=E;E<o&&!y(i.charCodeAt(E));)E++;if(E===o)return`\\\\${u}\\${i.slice(w)}\\`;E!==w&&(s=`\\\\${u}\\${i.slice(w,E)}`,n=E)}}}else n=1;else f(r)&&i.charCodeAt(1)===C&&(s=i.slice(0,2),n=2,o>2&&y(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?d(i.slice(n),!t,"\\",y):"";return a.length===0&&!t&&(a="."),a.length>0&&y(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){$(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return y(n)||o>2&&f(n)&&i.charCodeAt(1)===C&&y(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];$(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&y(n.charCodeAt(0))){++t;const r=n.length;r>1&&y(n.charCodeAt(1))&&(++t,r>2&&(y(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&y(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$fc.normalize(o)},relative(i,o){if($(i,"from"),$(o,"to"),i===o)return"";const n=e.$fc.resolve(i),s=e.$fc.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===g;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===g;)r--;const a=r-t;let E=0;for(;E<o.length&&o.charCodeAt(E)===g;)E++;let w=o.length;for(;w-1>E&&o.charCodeAt(w-1)===g;)w--;const u=w-E,p=a<u?a:u;let P=-1,N=0;for(;N<p;N++){const M=i.charCodeAt(t+N);if(M!==o.charCodeAt(E+N))break;M===g&&(P=N)}if(N!==p){if(P===-1)return s}else{if(u>p){if(o.charCodeAt(E+N)===g)return s.slice(E+N+1);if(N===2)return s.slice(E+N)}a>p&&(i.charCodeAt(t+N)===g?P=N:N===2&&(P=3)),P===-1&&(P=0)}let F="";for(N=t+P+1;N<=r;++N)(N===r||i.charCodeAt(N)===g)&&(F+=F.length===0?"..":"\\..");return E+=P,F.length>0?`${F}${s.slice(E,w)}`:(s.charCodeAt(E)===g&&++E,s.slice(E,w))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$fc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const n=o.charCodeAt(2);if(n!==S&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return i},dirname(i){$(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return y(t)?i:".";if(y(t)){if(n=s=1,y(i.charCodeAt(1))){let E=2,w=E;for(;E<o&&!y(i.charCodeAt(E));)E++;if(E<o&&E!==w){for(w=E;E<o&&y(i.charCodeAt(E));)E++;if(E<o&&E!==w){for(w=E;E<o&&!y(i.charCodeAt(E));)E++;if(E===o)return i;E!==w&&(n=s=E+1)}}}}else f(t)&&i.charCodeAt(1)===C&&(n=o>2&&y(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let E=o-1;E>=s;--E)if(y(i.charCodeAt(E))){if(!a){r=E;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&$(o,"ext"),$(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&f(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,E=-1;for(r=i.length-1;r>=n;--r){const w=i.charCodeAt(r);if(y(w)){if(!t){n=r+1;break}}else E===-1&&(t=!1,E=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=E))}return n===s?s=E:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(y(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){$(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===C&&f(i.charCodeAt(0))&&(o=s=2);for(let E=i.length-1;E>=o;--E){const w=i.charCodeAt(E);if(y(w)){if(!r){s=E+1;break}continue}t===-1&&(r=!1,t=E+1),w===R?n===-1?n=E:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:l.bind(null,"\\"),parse(i){$(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return y(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(y(t)){if(s=1,y(i.charCodeAt(1))){let P=2,N=P;for(;P<n&&!y(i.charCodeAt(P));)P++;if(P<n&&P!==N){for(N=P;P<n&&y(i.charCodeAt(P));)P++;if(P<n&&P!==N){for(N=P;P<n&&!y(i.charCodeAt(P));)P++;P===n?s=P:P!==N&&(s=P+1)}}}}else if(f(t)&&i.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=i,o;if(s=2,y(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,E=-1,w=!0,u=i.length-1,p=0;for(;u>=s;--u){if(t=i.charCodeAt(u),y(t)){if(!w){a=u+1;break}continue}E===-1&&(w=!1,E=u+1),t===R?r===-1?r=u:p!==1&&(p=1):r!==-1&&(p=-1)}return E!==-1&&(r===-1||p===0||p===1&&r===E-1&&r===a+1?o.base=o.name=i.slice(a,E):(o.name=i.slice(a,r),o.base=i.slice(a,E),o.ext=i.slice(r,E))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const v=(()=>{if(b){const i=/\\/g;return()=>{const o=O.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>O.cwd()})();e.$gc={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:v();$(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===k)}return o=d(o,!n,"/",c),n?`/${o}`:o.length>0?o:"."},normalize(i){if($(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===k,n=i.charCodeAt(i.length-1)===k;return i=d(i,!o,"/",c),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return $(i,"path"),i.length>0&&i.charCodeAt(0)===k},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];$(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$gc.normalize(o)},relative(i,o){if($(i,"from"),$(o,"to"),i===o||(i=e.$gc.resolve(i),o=e.$gc.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,E=t<a?t:a;let w=-1,u=0;for(;u<E;u++){const P=i.charCodeAt(n+u);if(P!==o.charCodeAt(r+u))break;P===k&&(w=u)}if(u===E)if(a>E){if(o.charCodeAt(r+u)===k)return o.slice(r+u+1);if(u===0)return o.slice(r+u)}else t>E&&(i.charCodeAt(n+u)===k?w=u:u===0&&(w=0));let p="";for(u=n+w+1;u<=s;++u)(u===s||i.charCodeAt(u)===k)&&(p+=p.length===0?"..":"/..");return`${p}${o.slice(r+w)}`},toNamespacedPath(i){return i},dirname(i){if($(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===k;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===k){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&$(o,"ext"),$(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,E=-1;for(r=i.length-1;r>=0;--r){const w=i.charCodeAt(r);if(w===k){if(!t){n=r+1;break}}else E===-1&&(t=!1,E=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=E))}return n===s?s=E:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===k){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){$(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const E=i.charCodeAt(a);if(E===k){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),E===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:l.bind(null,"/"),parse(i){$(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===k;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,E=!0,w=i.length-1,u=0;for(;w>=s;--w){const p=i.charCodeAt(w);if(p===k){if(!E){r=w+1;break}continue}a===-1&&(E=!1,a=w+1),p===R?t===-1?t=w:u!==1&&(u=1):t!==-1&&(u=-1)}if(a!==-1){const p=r===0&&n?1:r;t===-1||u===0||u===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(p,a):(o.name=i.slice(p,t),o.base=i.slice(p,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=b?e.$fc.normalize:e.$gc.normalize,e.$ic=b?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=b?e.$fc.join:e.$gc.join,e.$kc=b?e.$fc.resolve:e.$gc.resolve,e.$lc=b?e.$fc.relative:e.$gc.relative,e.$mc=b?e.$fc.dirname:e.$gc.dirname,e.$nc=b?e.$fc.basename:e.$gc.basename,e.$oc=b?e.$fc.extname:e.$gc.extname,e.$pc=b?e.$fc.format:e.$gc.format,e.$qc=b?e.$fc.parse:e.$gc.parse,e.$rc=b?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=b?e.$fc.sep:e.$gc.sep,e.$tc=b?e.$fc.delimiter:e.$gc.delimiter}),define(le[49],he([0,1,16,5,27,12]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=void 0;function I(r){return r===47||r===92}e.$$f=I;function R(r){return r.replace(/[\\/]/g,O.$gc.sep)}e.$_f=R;function k(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$ag=k;function g(r,a=O.$gc.sep){if(!r)return"";const E=r.length,w=r.charCodeAt(0);if(I(w)){if(I(r.charCodeAt(1))&&!I(r.charCodeAt(2))){let p=3;const P=p;for(;p<E&&!I(r.charCodeAt(p));p++);if(P!==p&&!I(r.charCodeAt(p+1))){for(p+=1;p<E;p++)if(I(r.charCodeAt(p)))return r.slice(0,p+1).replace(/[\\/]/g,a)}}return a}else if(c(w)&&r.charCodeAt(1)===58)return I(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<E;u++)if(I(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.$bg=g;function C(r){if(!A.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let E=2;const w=E;for(;E<r.length&&(a=r.charCodeAt(E),a!==92);E++);return!(w===E||(a=r.charCodeAt(E+1),isNaN(a)||a===92))}e.$cg=C;const S=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(r,a=A.$i){const E=a?S:m;return!(!r||r.length===0||/^\s+$/.test(r)||(E.lastIndex=0,E.test(r))||a&&h.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$dg=$;function b(r,a,E){const w=r===a;return!E||w?w:!r||!a?!1:(0,D.$jf)(r,a)}e.$eg=b;function y(r,a,E,w=O.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(E){if(!(0,D.$kf)(r,a))return!1;if(a.length===r.length)return!0;let p=a.length;return a.charAt(a.length-1)===w&&p--,r.charAt(p)===w}return a.charAt(a.length-1)!==w&&(a+=w),r.indexOf(a)===0}e.$fg=y;function c(r){return r>=65&&r<=90||r>=97&&r<=122}e.$gg=c;function f(r,a){return A.$i&&r.endsWith(":")&&(r+=O.sep),(0,O.$ic)(r)||(r=(0,O.$jc)(a,r)),r=(0,O.$hc)(r),A.$i?(r=(0,D.$4e)(r,O.sep),r.endsWith(":")&&(r+=O.sep)):(r=(0,D.$4e)(r,O.sep),r||(r=O.sep)),r}e.$hg=f;function d(r){const a=(0,O.$hc)(r);return A.$i?r.length>3?!1:l(a)&&(r.length===2||a.charCodeAt(2)===92):a===O.$gc.sep}e.$ig=d;function l(r,a=A.$i){return a?c(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$jg=l;function v(r,a=A.$i){return l(r,a)?r[0]:void 0}e.$kg=v;function i(r,a,E){return a.length>r.length?-1:r===a?0:(E&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$lg=i;function o(r){const a=r.split(":");let E,w,u;for(const p of a){const P=Number(p);(0,L.$Wf)(P)?w===void 0?w=P:u===void 0&&(u=P):E=E?[E,p].join(":"):p}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:w!==void 0?w:void 0,column:u!==void 0?u:w!==void 0?1:void 0}}e.$mg=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,E=8){let w="";for(let p=0;p<E;p++){let P;p===0&&A.$i&&!a&&(E===3||E===4)?P=s:P=n,w+=P.charAt(Math.floor(Math.random()*P.length))}let u;return a?u=`${a}-${w}`:u=w,r?(0,O.$jc)(r,u):u}e.$ng=t}),define(le[140],he([0,1,16]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=e.$ts=e.$ss=e.$rs=e.$qs=void 0,e.$qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(C){const S=(0,O.$oc)(C),m=A[S.toLowerCase()];return m!==void 0?m:I(C)}e.$rs=L;function I(C){const S=(0,O.$oc)(C);return D[S.toLowerCase()]}e.$ss=I;function R(C){for(const S in D)if(D[S]===C)return S}e.$ts=R;const k=/^(.+)\/(.+?)(;.+)?$/;function g(C,S){const m=k.exec(C);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:S?void 0:C}e.$us=g}),define(le[90],he([0,1,5]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.TerminateResponseCode=e.Source=void 0;var A;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(A||(e.Source=A={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function L(R,...k){const g=k.reduce((m,h)=>(m[h]=!0,m),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(m=>!g[m]).forEach(m=>{for(let h=0;h<C.length;h++)if(m.search(C[h])!==-1){delete R[m];break}})}e.$3l=L;function I(R){R&&(delete R.DEBUG,O.$j&&delete R.DYLD_LIBRARY_PATH,O.$k&&delete R.LD_PRELOAD)}e.$4l=I}),define(le[10],he([0,1,16,5]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,L=/^\//,I=/^\/\//;function R(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!L.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(s,t){return!s&&!t?"file":s}function g(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==S&&(t=S+t):t=S;break}return t}const C="",S="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(t){return t instanceof h?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,E,w,u=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=k(t,u),this.authority=r||C,this.path=g(this.scheme,a||C),this.query=E||C,this.fragment=w||C,R(this,u))}get fsPath(){return l(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:E,query:w,fragment:u}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),E===void 0?E=this.path:E===null&&(E=C),w===void 0?w=this.query:w===null&&(w=C),u===void 0?u=this.fragment:u===null&&(u=C),r===this.scheme&&a===this.authority&&E===this.path&&w===this.query&&u===this.fragment?this:new y(r,a,E,w,u)}static parse(t,r=!1){const a=m.exec(t);return a?new y(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new y(C,C,C,C,C)}static file(t){let r=C;if(A.$i&&(t=t.replace(/\\/g,S)),t[0]===S&&t[1]===S){const a=t.indexOf(S,2);a===-1?(r=t.substring(2),t=S):(r=t.substring(2,a),t=t.substring(a)||S)}return new y("file",r,t,C,C)}static from(t,r){return new y(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return A.$i&&t.scheme==="file"?a=h.file(O.$fc.join(l(t,!0),...r)).path:a=O.$gc.join(t.path,...r),t.with({path:a})}toString(t=!1){return v(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof h)return t;{const r=new y(t);return r._formatted=t.external??null,r._fsPath=t._sep===b?t.fsPath??null:null,r}}else return t}}e.URI=h;function $(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$vc=$;const b=A.$i?1:void 0;class y extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(t=!1){return t?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=b),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(s,t,r){let a,E=-1;for(let w=0;w<s.length;w++){const u=s.charCodeAt(w);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47||r&&u===91||r&&u===93||r&&u===58)E!==-1&&(a+=encodeURIComponent(s.substring(E,w)),E=-1),a!==void 0&&(a+=s.charAt(w));else{a===void 0&&(a=s.substr(0,w));const p=c[u];p!==void 0?(E!==-1&&(a+=encodeURIComponent(s.substring(E,w)),E=-1),a+=p):E===-1&&(E=w)}}return E!==-1&&(a+=encodeURIComponent(s.substring(E))),a!==void 0?a:s}function d(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=c[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function l(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,A.$i&&(r=r.replace(/\//g,"\\")),r}e.$wc=l;function v(s,t){const r=t?d:f;let a="",{scheme:E,authority:w,path:u,query:p,fragment:P}=s;if(E&&(a+=E,a+=":"),(w||E==="file")&&(a+=S,a+=S),w){let N=w.indexOf("@");if(N!==-1){const F=w.substr(0,N);w=w.substr(N+1),N=F.lastIndexOf(":"),N===-1?a+=r(F,!1,!1):(a+=r(F.substr(0,N),!1,!1),a+=":",a+=r(F.substr(N+1),!1,!0)),a+="@"}w=w.toLowerCase(),N=w.lastIndexOf(":"),N===-1?a+=r(w,!1,!0):(a+=r(w.substr(0,N),!1,!0),a+=w.substr(N))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const N=u.charCodeAt(1);N>=65&&N<=90&&(u=`/${String.fromCharCode(N+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const N=u.charCodeAt(0);N>=65&&N<=90&&(u=`${String.fromCharCode(N+32)}:${u.substr(2)}`)}a+=r(u,!0,!1)}return p&&(a+="?",a+=r(p,!1,!1)),P&&(a+="#",a+=t?P:f(P,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[141],he([0,1,10]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$zq=e.$yq=e.$xq=void 0;function A(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$xq=A;function D(g){const C=[];let S;try{const m=JSON.parse(g.arguments),h=m[m.length-1];h&&h.__$stack&&(m.pop(),S=h.__$stack),C.push(...m)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:S}}e.$yq=D;function L(g){if(typeof g!="string")return L(D(g).stack);const C=g;if(C){const S=I(C),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(m&&m.length===4)return{uri:O.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$zq=L;function I(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function R(g,C){const{args:S,stack:m}=D(g),h=typeof S[0]=="string"&&S.length===1;let $=I(m);$&&($=`(${$.trim()})`);let b=[];if(typeof S[0]=="string"?$&&h?b=[`%c[${C}] %c${S[0]} %c${$}`,k("blue"),k(""),k("grey")]:b=[`%c[${C}] %c${S[0]}`,k("blue"),k(""),...S.slice(1)]:b=[`%c[${C}]%`,k("blue"),...S],$&&!h&&b.push($),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,b)}e.log=R;function k(g){return`color: ${g}`}}),define(le[66],he([0,1,14,10]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=void 0;function D(k){return JSON.stringify(k,I)}e.$Lh=D;function L(k){let g=JSON.parse(k);return g=R(g),g}e.$Mh=L;function I(k,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(k,g=0){if(!k||g>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return A.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof O.$se||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=R(k[C],g+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=R(k[C],g+1))}return k}e.$Nh=R}),define(le[23],he([0,1,7,5,27,10]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.Schemas=void 0;var I;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting",m.codeFeature="code-feature"})(I||(e.Schemas=I={}));function R(m,h){return L.URI.isUri(m)?(0,D.$jf)(m.scheme,h):(0,D.$kf)(m,h+":")}e.$og=R;function k(m,...h){return h.some($=>R(m,$))}e.$pg=k,e.$qg="vscode-tkn",e.$rg="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${I.vscodeRemoteResource}`}set(h,$,b){this.a[h]=$,this.b[h]=b}setConnectionToken(h,$){this.c[h]=$}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(d){return O.$1(d),h}const $=h.authority;let b=this.a[$];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const y=this.b[$],c=this.c[$];let f=`path=${encodeURIComponent(h.path)}`;return typeof c=="string"&&(f+=`&${e.$rg}=${encodeURIComponent(c)}`),L.URI.from({scheme:A.$o?this.d:I.vscodeRemoteResource,authority:`${b}:${y}`,path:this.f,query:f})}}e.$sg=new g,e.$tg="vs/../../extensions",e.$ug="vs/../../node_modules",e.$vg="vs/../../node_modules.asar",e.$wg="vs/../../node_modules.asar.unpacked",e.$xg="vscode-app";class C{static{this.a=e.$xg}asBrowserUri(h){const $=this.b(h,se);return this.uriToBrowserUri($)}uriToBrowserUri(h){return h.scheme===I.vscodeRemote?e.$sg.rewrite(h):h.scheme===I.file&&(A.$m||A.$q===`${I.vscodeFileResource}://${C.a}`)?h.with({scheme:I.vscodeFileResource,authority:h.authority||C.a,query:null,fragment:null}):h}asFileUri(h){const $=this.b(h,se);return this.uriToFileUri($)}uriToFileUri(h){return h.scheme===I.vscodeFileResource?h.with({scheme:I.file,authority:h.authority!==C.a?h.authority:null,query:null,fragment:null}):h}b(h,$){return L.URI.isUri(h)?h:L.URI.parse($.toUrl(h))}}e.$yg=new C;var S;(function(m){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(h.get("3"));const $="vscode-coi";function b(c){let f;typeof c=="string"?f=new URL(c).searchParams:c instanceof URL?f=c.searchParams:L.URI.isUri(c)&&(f=new URL(c.toString(!0)).searchParams);const d=f?.get($);if(d)return h.get(d)}m.getHeadersFromQuery=b;function y(c,f,d){if(!globalThis.crossOriginIsolated)return;const l=f&&d?"3":d?"2":"1";c instanceof URLSearchParams?c.set($,l):c[$]=l}m.addSearchParam=y})(S||(e.COI=S={}))}),define(le[142],he([0,1,124,23,5,10]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tD=void 0;class I{constructor(m,h,$){this.id=m,this.dependencies=h,this.callback=$}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,h,$)=>{typeof m!="string"&&($=h,h=m,m=null),(typeof h!="object"||!Array.isArray(h))&&($=h,h=null),this.c.push(new I(m,h,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const h=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!h)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(m){return new Promise((h,$)=>{const b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript");const y=()=>{b.removeEventListener("load",c),b.removeEventListener("error",f)},c=d=>{y(),h(this.c.pop())},f=d=>{y(),$(d)};b.addEventListener("load",c),b.addEventListener("error",f),this.f&&(m=this.f.createScriptURL(m)),b.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(b)})}i(m){return new Promise((h,$)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),h(this.c.pop())}catch(b){$(b)}})}async j(m){try{const h=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,b=globalThis._VSCODE_NODE_MODULES.module,y=L.URI.parse(m).fsPath,c=h.readFileSync(y).toString(),f=b.wrap(c.replace(/^#!.*/,""));return new $.Script(f).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const k=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function C(S,m,h){if(O.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[S]&&(S=g[S]);const $=`${S}/${m}`;if(k.has($))return k.get($);let b;if(/^\w[\w\d+.-]*:\/\//.test($))b=$;else{const d=`${h&&!D.$o?A.$vg:A.$ug}/${$}`;b=A.$yg.asBrowserUri(d).toString(!0)}const y=R.INSTANCE.load(b);return k.set($,y),y}else return await new Promise(($,b)=>{se([S],$,b)})}e.$tD=C}),define(le[20],he([0,1,49,23,16,5,27,10]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=e.DataUri=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function k(h){return(0,R.$wc)(h,!0)}e.$Fg=k;class g{constructor($){this.a=$}compare($,b,y=!1){return $===b?0:(0,I.$cf)(this.getComparisonKey($,y),this.getComparisonKey(b,y))}isEqual($,b,y=!1){return $===b?!0:!$||!b?!1:this.getComparisonKey($,y)===this.getComparisonKey(b,y)}getComparisonKey($,b=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,b,y=!1){if($.scheme===b.scheme){if($.scheme===A.Schemas.file)return O.$fg(k($),k(b),this.a($))&&$.query===b.query&&(y||$.fragment===b.fragment);if((0,e.$Wg)($.authority,b.authority))return O.$fg($.path,b.path,this.a($),"/")&&$.query===b.query&&(y||$.fragment===b.fragment)}return!1}joinPath($,...b){return R.URI.joinPath($,...b)}basenameOrAuthority($){return(0,e.$Og)($)||$.authority}basename($){return D.$gc.basename($.path)}extname($){return D.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let b;return $.scheme===A.Schemas.file?b=R.URI.file(D.$mc(k($))).path:(b=D.$gc.dirname($.path),$.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),b="/")),$.with({path:b})}normalizePath($){if(!$.path.length)return $;let b;return $.scheme===A.Schemas.file?b=R.URI.file(D.$hc(k($))).path:b=D.$gc.normalize($.path),$.with({path:b})}relativePath($,b){if($.scheme!==b.scheme||!(0,e.$Wg)($.authority,b.authority))return;if($.scheme===A.Schemas.file){const f=D.$lc(k($),k(b));return L.$i?O.$_f(f):f}let y=$.path||"/";const c=b.path||"/";if(this.a($)){let f=0;for(const d=Math.min(y.length,c.length);f<d&&!(y.charCodeAt(f)!==c.charCodeAt(f)&&y.charAt(f).toLowerCase()!==c.charAt(f).toLowerCase());f++);y=c.substr(0,f)+y.substr(f)}return D.$gc.relative(y,c)}resolvePath($,b){if($.scheme===A.Schemas.file){const y=R.URI.file(D.$kc(k($),b));return $.with({authority:y.authority,path:y.path})}return b=O.$ag(b),$.with({path:D.$gc.resolve($.path,b)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,b){return $===b||$!==void 0&&b!==void 0&&(0,I.$jf)($,b)}hasTrailingPathSeparator($,b=D.sep){if($.scheme===A.Schemas.file){const y=k($);return y.length>O.$bg(y).length&&y[y.length-1]===b}else{const y=$.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,b=D.sep){return(0,e.$Xg)($,b)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,b=D.sep){let y=!1;if($.scheme===A.Schemas.file){const c=k($);y=c!==void 0&&c.length===O.$bg(c).length&&c[c.length-1]===b}else{b="/";const c=$.path;y=c.length===1&&c.charCodeAt(c.length-1)===47}return!y&&!(0,e.$Xg)($,b)?$.with({path:$.path+"/"}):$}}e.$Gg=g,e.$Hg=new g(()=>!1),e.$Ig=new g(h=>h.scheme===A.Schemas.file?!L.$k:!0),e.$Jg=new g(h=>!0),e.$Kg=e.$Hg.isEqual.bind(e.$Hg),e.$Lg=e.$Hg.isEqualOrParent.bind(e.$Hg),e.$Mg=e.$Hg.getComparisonKey.bind(e.$Hg),e.$Ng=e.$Hg.basenameOrAuthority.bind(e.$Hg),e.$Og=e.$Hg.basename.bind(e.$Hg),e.$Pg=e.$Hg.extname.bind(e.$Hg),e.$Qg=e.$Hg.dirname.bind(e.$Hg),e.$Rg=e.$Hg.joinPath.bind(e.$Hg),e.$Sg=e.$Hg.normalizePath.bind(e.$Hg),e.$Tg=e.$Hg.relativePath.bind(e.$Hg),e.$Ug=e.$Hg.resolvePath.bind(e.$Hg),e.$Vg=e.$Hg.isAbsolutePath.bind(e.$Hg),e.$Wg=e.$Hg.isEqualAuthority.bind(e.$Hg),e.$Xg=e.$Hg.hasTrailingPathSeparator.bind(e.$Hg),e.$Yg=e.$Hg.removeTrailingPathSeparator.bind(e.$Hg),e.$Zg=e.$Hg.addTrailingPathSeparator.bind(e.$Hg);function C(h,$){const b=[];for(let y=0;y<h.length;y++){const c=$(h[y]);h.some((f,d)=>d===y?!1:(0,e.$Lg)(c,$(f)))||b.push(h[y])}return b}e.$1g=C;var S;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function $(b){const y=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(d=>{const[l,v]=d.split(":");l&&v&&y.set(l,v)});const f=b.path.substring(0,b.path.indexOf(";"));return f&&y.set(h.META_DATA_MIME,f),y}h.parseMetaData=$})(S||(e.DataUri=S={}));function m(h,$,b){if($){let y=h.path;return y&&y[0]!==D.$gc.sep&&(y=D.$gc.sep+y),h.with({scheme:b,authority:$,path:y})}return h.with({scheme:b})}e.$2g=m}),define(le[6],he([0,1,26,7,3,2,20,5,130,52]),function(se,e,O,A,D,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.Promises=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0;function C(ie){return!!ie&&typeof ie.then=="function"}e.$3g=C;function S(ie){const J=new O.$ce,ne=ie(J.token),ce=new Promise((fe,de)=>{const me=J.token.onCancellationRequested(()=>{me.dispose(),de(new A.$5)});Promise.resolve(ne).then(Ee=>{me.dispose(),J.dispose(),fe(Ee)},Ee=>{me.dispose(),J.dispose(),de(Ee)})});return new class{cancel(){J.cancel(),J.dispose()}then(fe,de){return ce.then(fe,de)}catch(fe){return this.then(void 0,fe)}finally(fe){return ce.finally(fe)}}}e.$4g=S;function m(ie,J,ne){return new Promise((ce,fe)=>{const de=J.onCancellationRequested(()=>{de.dispose(),ce(ne)});ie.then(ce,fe).finally(()=>de.dispose())})}e.$5g=m;function h(ie,J){return new Promise((ne,ce)=>{const fe=J.onCancellationRequested(()=>{fe.dispose(),ce(new A.$5)});ie.then(ne,ce).finally(()=>fe.dispose())})}e.$6g=h;async function $(ie){let J=-1;const ne=ie.map((ce,fe)=>ce.then(de=>(J=fe,de)));try{return await Promise.race(ne)}finally{ie.forEach((ce,fe)=>{fe!==J&&ce.cancel()})}}e.$7g=$;function b(ie,J,ne){let ce;const fe=setTimeout(()=>{ce?.(void 0),ne?.()},J);return Promise.race([ie.finally(()=>clearTimeout(fe)),new Promise(de=>ce=de)])}e.$8g=b;function y(ie){return new Promise((J,ne)=>{const ce=ie();C(ce)?ce.then(J,ne):J(ce)})}e.$9g=y;function c(){let ie,J;return{promise:new Promise((ce,fe)=>{ie=ce,J=fe}),resolve:ie,reject:J}}e.$0g=c;class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const ne=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(ne,ne).then(ce)})}return new Promise((ne,ce)=>{this.b.then(ne,ce)})}return this.a=J(),new Promise((ne,ce)=>{this.a.then(fe=>{this.a=null,ne(fe)},fe=>{this.a=null,ce(fe)})})}dispose(){this.f=!0}}e.$$g=f;class d{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$_g=d;class l{constructor(){this.a=new Map}queue(J,ne){const fe=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.a.get(J)===fe&&this.a.delete(J)});return this.a.set(J,fe),fe}}e.$ah=l;const v=(ie,J)=>{let ne=!0;const ce=setTimeout(()=>{ne=!1,J()},ie);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(ce),ne=!1}}},i=ie=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ie())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class o{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,ne=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((fe,de)=>{this.d=fe,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=ne===k.$2d?i(ce):v(ne,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$bh=o;class n{constructor(J){this.a=new o(J),this.b=new f}trigger(J,ne){return this.a.trigger(()=>this.b.queue(J),ne)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ch=n;class s{constructor(){this.a=!1,this.b=new Promise((J,ne)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$dh=s;class t extends s{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$eh=t;function r(ie,J){return J?new Promise((ne,ce)=>{const fe=setTimeout(()=>{de.dispose(),ne()},ie),de=J.onCancellationRequested(()=>{clearTimeout(fe),de.dispose(),ce(new A.$5)})}):S(ne=>r(ie,ne))}e.$fh=r;function a(ie,J=0,ne){const ce=setTimeout(()=>{ie(),ne&&fe.dispose()},J),fe=(0,L.$Rc)(()=>{clearTimeout(ce),ne?.deleteAndLeak(fe)});return ne?.add(fe),fe}e.$gh=a;function E(ie){const J=[];let ne=0;const ce=ie.length;function fe(){return ne<ce?ie[ne++]():null}function de(me){me!=null&&J.push(me);const Ee=fe();return Ee?Ee.then(de):Promise.resolve(J)}return Promise.resolve(null).then(de)}e.$hh=E;function w(ie,J=ce=>!!ce,ne=null){let ce=0;const fe=ie.length,de=()=>{if(ce>=fe)return Promise.resolve(ne);const me=ie[ce++];return Promise.resolve(me()).then(Re=>J(Re)?Promise.resolve(Re):de())};return de()}e.$ih=w;function u(ie,J=ce=>!!ce,ne=null){if(ie.length===0)return Promise.resolve(ne);let ce=ie.length;const fe=()=>{ce=-1;for(const de of ie)de.cancel?.()};return new Promise((de,me)=>{for(const Ee of ie)Ee.then(Re=>{--ce>=0&&J(Re)?(fe(),de(Re)):ce===0&&de(ne)}).catch(Re=>{--ce>=0&&(fe(),me(Re))})})}e.$jh=u;class p{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new D.$5d}whenIdle(){return this.size>0?D.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ne,ce)=>{this.g.push({factory:J,c:ne,e:ce}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const ne=J.factory();ne.then(J.c,J.e),ne.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$kh=p;class P extends p{constructor(){super(1)}}e.$lh=P;class N{constructor(){this.a=new te,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$mh=N;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new ae;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,ne=I.$Hg){const ce=ne.getComparisonKey(J);return this.a.get(ce)?.size??0}queueFor(J,ne,ce=I.$Hg){const fe=ce.getComparisonKey(J);let de=this.a.get(fe);if(!de){de=new P;const me=this.f++,Ee=D.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$3c),this.d.set(me,Ee),this.a.set(fe,de)}return de.queue(ne)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$nh=F;class M{constructor(J,ne){this.a=-1,typeof J=="function"&&typeof ne=="number"&&this.setIfNotSet(J,ne)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,ne){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},ne)}setIfNotSet(J,ne){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},ne))}}e.$oh=M;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,ne,ce=globalThis){this.cancel();const fe=ce.setInterval(()=>{J()},ne);this.d=(0,L.$Rc)(()=>{ce.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$ph=z;class Y{constructor(J,ne){this.b=-1,this.a=J,this.d=ne,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$qh=Y;class Q{constructor(J,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.a=J,this.b=ne,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$rh=Q;class x extends Y{constructor(J,ne){super(J,ne),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$sh=x;class W extends L.$Tc{constructor(J,ne){super(),this.g=J,this.h=ne,this.a=[],this.b=this.B(new L.$Uc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ne of J)this.a.push(ne);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Y(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$th=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$vh=(ie,J)=>{(0,R.$B)(()=>{if(ne)return;const ce=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$vh=(ie,J,ne)=>{const ce=ie.requestIdleCallback(J,typeof ne=="number"?{timeout:ne}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,ie.cancelIdleCallback(ce))}}},e.$uh=ie=>(0,e.$vh)(globalThis,ie)}();class X{constructor(J,ne){this.g=!1,this.d=()=>{try{this.j=ne()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$vh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$wh=X;class H extends X{constructor(J){super(globalThis,J)}}e.$xh=H;async function V(ie,J,ne){let ce;for(let fe=0;fe<ne;fe++)try{return await ie()}catch(de){ce=de,await r(J)}throw ce}e.$yh=V;class te{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,ne,ce){return this.a={taskId:J,cancel:()=>ce?.(),promise:ne},ne.then(()=>this.d(J),()=>this.d(J)),ne}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:ne,resolve:ce,reject:fe}=c();this.b={run:J,promise:ne,promiseResolve:ce,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$zh=te;class oe{constructor(J,ne=()=>Date.now()){this.d=J,this.f=ne,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Ah=oe;var ee;(function(ie){ie[ie.Resolved=0]="Resolved",ie[ie.Rejected=1]="Rejected"})(ee||(ee={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,ne)=>{this.a=J,this.b=ne})}complete(J){return new Promise(ne=>{this.a(J),this.d={outcome:0,value:J},ne()})}error(J){return new Promise(ne=>{this.b(J),this.d={outcome:1,value:J},ne()})}cancel(){return this.error(new A.$5)}}e.$Bh=ae;var G;(function(ie){async function J(ce){let fe;const de=await Promise.all(ce.map(me=>me.then(Ee=>Ee,Ee=>{fe||(fe=Ee)})));if(typeof fe<"u")throw fe;return de}ie.settled=J;function ne(ce){return new Promise(async(fe,de)=>{try{await ce(fe,de)}catch(me){de(me)}})}ie.withAsyncBody=ne})(G||(e.Promises=G={}));class U{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(ne=>(this.a=ne,this.d=!0,ne),ne=>{throw this.b=ne,this.d=!0,ne})}requireValue(){if(!this.d)throw new A.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ch=U;class j{constructor(J){this.b=J,this.a=new g.$V(()=>new U(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Dh=j;var T;(function(ie){ie[ie.Initial=0]="Initial",ie[ie.DoneOK=1]="DoneOK",ie[ie.DoneError=2]="DoneError"})(T||(T={}));class B{static fromArray(J){return new B(ne=>{ne.emitMany(J)})}static fromPromise(J){return new B(async ne=>{ne.emitMany(await J)})}static fromPromises(J){return new B(async ne=>{await Promise.all(J.map(async ce=>ne.emitOne(await ce)))})}static merge(J){return new B(async ne=>{await Promise.all(J.map(async ce=>{for await(const fe of ce)ne.emitOne(fe)}))})}static{this.EMPTY=B.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new D.$5d,queueMicrotask(async()=>{const ne={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(J(ne)),this.j()}catch(ce){this.k(ce)}finally{ne.emitOne=void 0,ne.emitMany=void 0,ne.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(J,ne){return new B(async ce=>{for await(const fe of J)ce.emitOne(ne(fe))})}map(J){return B.map(this,J)}static filter(J,ne){return new B(async ce=>{for await(const fe of J)ne(fe)&&ce.emitOne(fe)})}filter(J){return B.filter(this,J)}static coalesce(J){return B.filter(J,ne=>!!ne)}coalesce(){return B.coalesce(this)}static async toPromise(J){const ne=[];for await(const ce of J)ne.push(ce);return ne}toPromise(){return B.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$Eh=B;class q extends B{constructor(J,ne){super(ne),this.l=J}cancel(){this.l.cancel()}}e.$Fh=q;function Z(ie){const J=new O.$ce,ne=ie(J.token);return new q(J,async ce=>{const fe=J.token.onCancellationRequested(()=>{fe.dispose(),J.dispose(),ce.reject(new A.$5)});try{for await(const de of ne){if(J.token.isCancellationRequested)return;ce.emitOne(de)}fe.dispose(),J.dispose()}catch(de){fe.dispose(),J.dispose(),ce.reject(de)}})}e.$Gh=Z;class _{constructor(){this.a=new ae,this.b=new B(ce=>{if(J){ce.reject(J);return}return ne&&ce.emitMany(ne),this.d=fe=>ce.reject(fe),this.f=fe=>ce.emitOne(fe),this.a.p});let J,ne;this.f=ce=>{ne||(ne=[]),ne.push(ce)},this.d=ce=>{J||(J=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Hh=_}),define(le[91],he([0,1,17,6,49,35,16,5,27]),function(se,e,O,A,D,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;function g(){return Object.create(null)}e.$Sj=g,e.$Tj="**",e.$Uj="/";const C="[/\\\\]",S="[^/\\\\]",m=/\//g;function h(X,H){switch(X){case 0:return"";case 1:return`${S}*?`;default:return`(?:${C}|${S}+${C}${H?`|${C}${S}+`:""})*?`}}function $(X,H){if(!X)return[];const V=[];let te=!1,oe=!1,ee="";for(const ae of X){switch(ae){case H:if(!te&&!oe){V.push(ee),ee="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ee+=ae}return ee&&V.push(ee),V}e.$Vj=$;function b(X){if(!X)return"";let H="";const V=$(X,e.$Uj);if(V.every(te=>te===e.$Tj))H=".*";else{let te=!1;V.forEach((oe,ee)=>{if(oe===e.$Tj){if(te)return;H+=h(2,ee===V.length-1)}else{let ae=!1,G="",U=!1,j="";for(const T of oe){if(T!=="}"&&ae){G+=T;continue}if(U&&(T!=="]"||!j)){let B;T==="-"?B=T:(T==="^"||T==="!")&&!j?B="^":T===e.$Uj?B="":B=(0,k.$Xe)(T),j+=B;continue}switch(T){case"{":ae=!0;continue;case"[":U=!0;continue;case"}":{const q=`(?:${$(G,",").map(Z=>b(Z)).join("|")})`;H+=q,ae=!1,G="";break}case"]":{H+="["+j+"]",U=!1,j="";break}case"?":H+=S;continue;case"*":H+=h(1);continue;default:H+=(0,k.$Xe)(T)}}ee<V.length-1&&(V[ee+1]!==e.$Tj||ee+2<V.length)&&(H+=C)}te=oe===e.$Tj})}return H}const y=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.$Dc(1e4),o=function(){return!1},n=function(){return null};function s(X,H){if(!X)return n;let V;typeof X!="string"?V=X.pattern:V=X,V=V.trim();const te=`${V}_${!!H.trimForExclusions}`;let oe=i.get(te);if(oe)return t(oe,X);let ee;return y.test(V)?oe=a(V.substr(4),V):(ee=c.exec(r(V,H)))?oe=E(ee[1],V):(H.trimForExclusions?d:f).test(V)?oe=w(V,H):(ee=l.exec(r(V,H)))?oe=u(ee[1].substr(1),V,!0):(ee=v.exec(r(V,H)))?oe=u(ee[1],V,!1):oe=p(V),i.set(te,oe),t(oe,X)}function t(X,H){if(typeof H=="string")return X;const V=function(te,oe){return(0,D.$fg)(te,H.base,!R.$k)?X((0,k.$3e)(te.substr(H.base.length),I.sep),oe):null};return V.allBasenames=X.allBasenames,V.allPaths=X.allPaths,V.basenames=X.basenames,V.patterns=X.patterns,V}function r(X,H){return H.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function a(X,H){return function(V,te){return typeof V=="string"&&V.endsWith(X)?H:null}}function E(X,H){const V=`/${X}`,te=`\\${X}`,oe=function(ae,G){return typeof ae!="string"?null:G?G===X?H:null:ae===X||ae.endsWith(V)||ae.endsWith(te)?H:null},ee=[X];return oe.basenames=ee,oe.patterns=[H],oe.allBasenames=ee,oe}function w(X,H){const V=x(X.slice(1,-1).split(",").map(G=>s(G,H)).filter(G=>G!==n),X),te=V.length;if(!te)return n;if(te===1)return V[0];const oe=function(G,U){for(let j=0,T=V.length;j<T;j++)if(V[j](G,U))return X;return null},ee=V.find(G=>!!G.allBasenames);ee&&(oe.allBasenames=ee.allBasenames);const ae=V.reduce((G,U)=>U.allPaths?G.concat(U.allPaths):G,[]);return ae.length&&(oe.allPaths=ae),oe}function u(X,H,V){const te=I.sep===I.$gc.sep,oe=te?X:X.replace(m,I.sep),ee=I.sep+oe,ae=I.$gc.sep+X;let G;return V?G=function(U,j){return typeof U=="string"&&(U===oe||U.endsWith(ee)||!te&&(U===X||U.endsWith(ae)))?H:null}:G=function(U,j){return typeof U=="string"&&(U===oe||!te&&U===X)?H:null},G.allPaths=[(V?"*/":"./")+X],G}function p(X){try{const H=new RegExp(`^${b(X)}$`);return function(V){return H.lastIndex=0,typeof V=="string"&&H.test(V)?X:null}}catch{return n}}function P(X,H,V){return!X||typeof H!="string"?!1:N(X)(H,void 0,V)}e.$Wj=P;function N(X,H={}){if(!X)return o;if(typeof X=="string"||F(X)){const V=s(X,H);if(V===n)return o;const te=function(oe,ee){return!!V(oe,ee)};return V.allBasenames&&(te.allBasenames=V.allBasenames),V.allPaths&&(te.allPaths=V.allPaths),te}return Y(X,H)}e.$Xj=N;function F(X){const H=X;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$Yj=F;function M(X){return X.allBasenames||[]}e.$Zj=M;function z(X){return X.allPaths||[]}e.$1j=z;function Y(X,H){const V=x(Object.getOwnPropertyNames(X).map(G=>Q(G,X[G],H)).filter(G=>G!==n)),te=V.length;if(!te)return n;if(!V.some(G=>!!G.requiresSiblings)){if(te===1)return V[0];const G=function(T,B){let q;for(let Z=0,_=V.length;Z<_;Z++){const ie=V[Z](T,B);if(typeof ie=="string")return ie;(0,A.$3g)(ie)&&(q||(q=[]),q.push(ie))}return q?(async()=>{for(const Z of q){const _=await Z;if(typeof _=="string")return _}return null})():null},U=V.find(T=>!!T.allBasenames);U&&(G.allBasenames=U.allBasenames);const j=V.reduce((T,B)=>B.allPaths?T.concat(B.allPaths):T,[]);return j.length&&(G.allPaths=j),G}const oe=function(G,U,j){let T,B;for(let q=0,Z=V.length;q<Z;q++){const _=V[q];_.requiresSiblings&&j&&(U||(U=(0,I.$nc)(G)),T||(T=U.substr(0,U.length-(0,I.$oc)(G).length)));const ie=_(G,U,T,j);if(typeof ie=="string")return ie;(0,A.$3g)(ie)&&(B||(B=[]),B.push(ie))}return B?(async()=>{for(const q of B){const Z=await q;if(typeof Z=="string")return Z}return null})():null},ee=V.find(G=>!!G.allBasenames);ee&&(oe.allBasenames=ee.allBasenames);const ae=V.reduce((G,U)=>U.allPaths?G.concat(U.allPaths):G,[]);return ae.length&&(oe.allPaths=ae),oe}function Q(X,H,V){if(H===!1)return n;const te=s(X,V);if(te===n)return n;if(typeof H=="boolean")return te;if(H){const oe=H.when;if(typeof oe=="string"){const ee=(ae,G,U,j)=>{if(!j||!te(ae,G))return null;const T=oe.replace("$(basename)",()=>U),B=j(T);return(0,A.$3g)(B)?B.then(q=>q?X:null):B?X:null};return ee.requiresSiblings=!0,ee}}return te}function x(X,H){const V=X.filter(G=>!!G.basenames);if(V.length<2)return X;const te=V.reduce((G,U)=>{const j=U.basenames;return j?G.concat(j):G},[]);let oe;if(H){oe=[];for(let G=0,U=te.length;G<U;G++)oe.push(H)}else oe=V.reduce((G,U)=>{const j=U.patterns;return j?G.concat(j):G},[]);const ee=function(G,U){if(typeof G!="string")return null;if(!U){let T;for(T=G.length;T>0;T--){const B=G.charCodeAt(T-1);if(B===47||B===92)break}U=G.substr(T)}const j=te.indexOf(U);return j!==-1?oe[j]:null};ee.basenames=te,ee.patterns=oe,ee.allBasenames=te;const ae=X.filter(G=>!G.basenames);return ae.push(ee),ae}function W(X,H){return(0,O.$ub)(X,H,(V,te)=>typeof V=="string"&&typeof te=="string"?V===te:typeof V!="string"&&typeof te!="string"?V.base===te.base&&V.pattern===te.pattern:!1)}e.$2j=W}),define(le[92],he([0,1,14,10]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=void 0;function D(S){return S.toJSON()}class L{constructor(m){this.a=m}transformIncoming(m){const h=this.a.transformIncoming(m);return h===m?m:D(A.URI.from(h))}transformOutgoing(m){const h=this.a.transformOutgoing(m);return h===m?m:D(A.URI.from(h))}transformOutgoingURI(m){const h=this.a.transformOutgoing(m);return h===m?m:A.URI.from(h)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$dn=L,e.$en=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function I(S,m,h){if(!S||h>200)return null;if(typeof S=="object"){if(S instanceof A.URI)return m.transformOutgoing(S);for(const $ in S)if(Object.hasOwnProperty.call(S,$)){const b=I(S[$],m,h+1);b!==null&&(S[$]=b)}}return null}function R(S,m){const h=I(S,m,0);return h===null?S:h}e.$fn=R;function k(S,m,h,$){if(!S||$>200)return null;if(typeof S=="object"){if(S.$mid===1)return h?A.URI.revive(m.transformIncoming(S)):m.transformIncoming(S);if(S instanceof O.$se)return null;for(const b in S)if(Object.hasOwnProperty.call(S,b)){const y=k(S[b],m,h,$+1);y!==null&&(S[b]=y)}}return null}function g(S,m){const h=k(S,m,!1,0);return h===null?S:h}e.$gn=g;function C(S,m){const h=k(S,m,!0,0);return h===null?S:h}e.$hn=C}),define(le[143],he([0,1,36,48,32,131,5]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=void 0,e.$jn=new class{c(m){return this.a||(this.a=A.$ki.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,h=0;const $=(0,O.networkInterfaces)();for(const b in $){const y=$[b];if(y)for(const{mac:c,internal:f}of y)f||(h+=1,this.c(c.toUpperCase())&&(m+=1))}this.b=h>0?m/h:0}return this.b}};let R;async function k(m){return R||(R=(async()=>await g(m)||D.$Ag())()),R}e.$kn=k;async function g(m){try{const h=await new Promise((b,y)=>{se(["crypto"],b,y)}),$=(0,L.$in)();return h.createHash("sha256").update($,"utf8").digest("hex")}catch(h){m(h);return}}const C="Software\\Microsoft\\SQMClient";async function S(m){if(I.$i){const h=await new Promise(($,b)=>{se(["@vscode/windows-registry"],$,b)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch($){return m($),""}}return""}e.$ln=S}),define(le[31],he([0,1,54,36,268,6,49,88,16,5,20,10]),function(se,e,O,A,D,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function h(Q,x=m.UNLINK,W){if((0,I.$ig)(Q))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?b(Q):$(Q,W)}async function $(Q,x=(0,I.$ng)((0,A.tmpdir)())){try{try{await O.promises.rename(Q,x)}catch(W){return W.code==="ENOENT"?void 0:b(Q)}b(x).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function b(Q){return(0,D.promisify)(O.rm)(Q,{recursive:!0,force:!0,maxRetries:3})}function y(Q){if((0,I.$ig)(Q))throw new Error("rimraf - will refuse to recursively delete root");O.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function c(Q,x){return l(await(x?f(Q):(0,D.promisify)(O.readdir)(Q)))}async function f(Q){try{return await(0,D.promisify)(O.readdir)(Q,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const x=[],W=await c(Q);for(const X of W){let H=!1,V=!1,te=!1;try{const oe=await e.Promises.lstat((0,k.$jc)(Q,X));H=oe.isFile(),V=oe.isDirectory(),te=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}x.push({name:X,isFile:()=>H,isDirectory:()=>V,isSymbolicLink:()=>te})}return x}function d(Q){return l(O.readdirSync(Q))}e.readdirSync=d;function l(Q){return Q.map(x=>typeof x=="string"?g.$j?(0,R.$Rl)(x):x:(x.name=g.$j?(0,R.$Rl)(x.name):x.name,x))}async function v(Q){const x=await c(Q),W=[];for(const X of x)await o.existsDirectory((0,k.$jc)(Q,X))&&W.push(X);return W}function i(Q,x=1e3){return new Promise(W=>{let X=!1;const H=setInterval(()=>{X||(X=!0,O.access(Q,V=>{X=!1,V&&(clearInterval(H),W(void 0))}))},x)})}e.whenDeleted=i;var o;(function(Q){async function x(H){let V;try{if(V=await e.Promises.lstat(H),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(g.$i&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw oe}throw te}}Q.stat=x;async function W(H){try{const{stat:V,symbolicLink:te}=await Q.stat(H);return V.isFile()&&te?.dangling!==!0}catch{}return!1}Q.existsFile=W;async function X(H){try{const{stat:V,symbolicLink:te}=await Q.stat(H);return V.isDirectory()&&te?.dangling!==!0}catch{}return!1}Q.existsDirectory=X})(o||(e.SymlinkSupport=o={}));const n=new L.$nh;function s(Q,x,W){return n.queueFor(S.URI.file(Q),()=>{const X=w(W);return new Promise((H,V)=>a(Q,x,X,te=>te?V(te):H()))},C.$Ig)}let t=!0;function r(Q){t=Q}e.configureFlushOnWrite=r;function a(Q,x,W,X){if(!t)return O.writeFile(Q,x,{mode:W.mode,flag:W.flag},X);O.open(Q,W.flag,W.mode,(H,V)=>{if(H)return X(H);O.writeFile(V,x,te=>{if(te)return O.close(V,()=>X(te));O.fdatasync(V,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),r(!1)),O.close(V,ee=>X(ee))))})})}function E(Q,x,W){const X=w(W);if(!t)return O.writeFileSync(Q,x,{mode:X.mode,flag:X.flag});const H=O.openSync(Q,X.flag,X.mode);try{O.writeFileSync(H,x);try{O.fdatasyncSync(H)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{O.closeSync(H)}}e.writeFileSync=E;function w(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function u(Q,x,W=6e4){if(Q!==x)try{g.$i&&typeof W=="number"?await p(Q,x,Date.now(),W):await(0,D.promisify)(O.rename)(Q,x)}catch(X){if(Q.toLowerCase()!==x.toLowerCase()&&X.code==="EXDEV"||Q.endsWith("."))await P(Q,x,{preserveSymlinks:!1}),await h(Q,m.MOVE);else throw X}}async function p(Q,x,W,X,H=0){try{return await(0,D.promisify)(O.rename)(Q,x)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-W>=X)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${V}`),V;if(H===0){let te=!1;try{const{stat:oe}=await o.stat(x);oe.isFile()||(te=!0)}catch{}if(te)throw V}return await(0,L.$fh)(Math.min(100,H*10)),p(Q,x,W,X,H+1)}}async function P(Q,x,W){return F(Q,x,{root:{source:Q,target:x},options:W,handledSourcePaths:new Set})}const N=511;async function F(Q,x,W){if(W.handledSourcePaths.has(Q))return;W.handledSourcePaths.add(Q);const{stat:X,symbolicLink:H}=await o.stat(Q);if(H){if(W.options.preserveSymlinks)try{return await Y(Q,x,W)}catch{}if(H.dangling)return}return X.isDirectory()?M(Q,x,X.mode&N,W):z(Q,x,X.mode&N)}async function M(Q,x,W,X){await e.Promises.mkdir(x,{recursive:!0,mode:W});const H=await c(Q);for(const V of H)await F((0,k.$jc)(Q,V),(0,k.$jc)(x,V),X)}async function z(Q,x,W){await e.Promises.copyFile(Q,x),await e.Promises.chmod(x,W)}async function Y(Q,x,W){let X=await e.Promises.readlink(Q);(0,I.$fg)(X,W.root.source,!g.$k)&&(X=(0,k.$jc)(W.root.target,X.substr(W.root.source.length+1))),await e.Promises.symlink(X,x)}e.Promises=new class{get access(){return(0,D.promisify)(O.access)}get stat(){return(0,D.promisify)(O.stat)}get lstat(){return(0,D.promisify)(O.lstat)}get utimes(){return(0,D.promisify)(O.utimes)}get read(){return(Q,x,W,X,H)=>new Promise((V,te)=>{O.read(Q,x,W,X,H,(oe,ee,ae)=>oe?te(oe):V({bytesRead:ee,buffer:ae}))})}get readFile(){return(0,D.promisify)(O.readFile)}get write(){return(Q,x,W,X,H)=>new Promise((V,te)=>{O.write(Q,x,W,X,H,(oe,ee,ae)=>oe?te(oe):V({bytesWritten:ee,buffer:ae}))})}get appendFile(){return(0,D.promisify)(O.appendFile)}get fdatasync(){return(0,D.promisify)(O.fdatasync)}get truncate(){return(0,D.promisify)(O.truncate)}get copyFile(){return(0,D.promisify)(O.copyFile)}get open(){return(0,D.promisify)(O.open)}get close(){return(0,D.promisify)(O.close)}get symlink(){return(0,D.promisify)(O.symlink)}get readlink(){return(0,D.promisify)(O.readlink)}get chmod(){return(0,D.promisify)(O.chmod)}get mkdir(){return(0,D.promisify)(O.mkdir)}get unlink(){return(0,D.promisify)(O.unlink)}get rmdir(){return(0,D.promisify)(O.rmdir)}get realpath(){return(0,D.promisify)(O.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return v}get writeFile(){return s}get rm(){return h}get rename(){return u}get copy(){return P}}}),define(le[144],he([0,1,54,16,5,27,31]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.$Eq=void 0;function R(m){if(D.$k)return m;const h=(0,A.$mc)(m);if(m===h)return m;const $=((0,A.$nc)(m)||m).toLowerCase();try{const y=(0,I.readdirSync)(h).filter(c=>c.toLowerCase()===$);if(y.length===1){const c=R(h);if(c)return(0,A.$jc)(c,y[0])}else if(y.length>1){const c=y.indexOf($);if(c>=0){const f=R(h);if(f)return(0,A.$jc)(f,y[c])}}}catch{}return null}e.$Eq=R;async function k(m){if(D.$k)return m;const h=(0,A.$mc)(m);if(m===h)return m;const $=((0,A.$nc)(m)||m).toLowerCase();try{const y=(await I.Promises.readdir(h)).filter(c=>c.toLowerCase()===$);if(y.length===1){const c=await k(h);if(c)return(0,A.$jc)(c,y[0])}else if(y.length>1){const c=y.indexOf($);if(c>=0){const f=await k(h);if(f)return(0,A.$jc)(f,y[c])}}}catch{}return null}e.$Fq=k;async function g(m){try{return await I.Promises.realpath(m)}catch{const $=S(m);return await I.Promises.access($,O.constants.R_OK),$}}e.$Gq=g;function C(m){try{return O.realpathSync(m)}catch{const $=S(m);return O.accessSync($,O.constants.R_OK),$}}e.$Hq=C;function S(m){return(0,L.$4e)((0,A.$hc)(m),A.sep)}}),define(le[145],he([0,1,16,5,37,90,12,31]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$6l=e.$5l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function k(S=D.env){return S.comspec||"cmd.exe"}e.$5l=k;function g(S){let m=[],h=!1;const $=function(b){if(h){m.push(b);return}(!S.send(b,c=>{if(c&&console.error(c),h=!1,m.length>0){const f=m.slice(0);m=[],f.forEach(d=>$(d))}})||A.$i)&&(h=!0)};return{send:$}}e.$6l=g;var C;(function(S){async function m(h,$,b){if(O.$ic(h))return h;if($===void 0&&($=D.cwd()),O.$mc(h)!=="."||(b===void 0&&I.$Sf(D.env.PATH)&&(b=D.env.PATH.split(O.$tc)),b===void 0||b.length===0))return O.$jc($,h);async function c(f){if(await R.Promises.exists(f)){let d;try{d=await R.Promises.stat(f)}catch(l){l.message.startsWith("EACCES")&&(d=await R.Promises.lstat(f))}return d?!d.isDirectory():!1}return!1}for(const f of b){let d;if(O.$ic(f)?d=O.$jc(f,h):d=O.$jc($,f,h),await c(d))return d;let l=d+".com";if(await c(l)||(l=d+".exe",await c(l)))return l}return O.$jc($,h)}S.findExecutable=m})(C||(e.win32=C={}))}),define(le[146],he([0,1,67,23]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0;function D(I){return new Promise((R,k)=>{let g;const C=new Map;function S(h,$,b,y,c){const f=C.get($);if(h===I||f){const d={name:m(b),cmd:b,pid:h,ppid:$,load:y,mem:c};C.set(h,d),h===I&&(g=d),f&&(f.children||(f.children=[]),f.children.push(d),f.children.length>1&&(f.children=f.children.sort((l,v)=>l.pid-v.pid)))}}function m(h){const $=/--utility-sub-type=network/i,b=/--crashes-directory/i,y=/\\pipe\\winpty-control/i,c=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(b.exec(h))return"electron-crash-reporter";if(y.exec(h))return"winpty-agent";if(c.exec(h))return"conpty-agent";let d=f.exec(h);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?$.exec(h)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const l=/[a-zA-Z-]+\.js/g;let v="";do d=l.exec(h),d&&(v+=d+" ");while(d);return v&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${v})`:h}if(process.platform==="win32"){const h=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,b)=>{se(["@vscode/windows-process-tree"],$,b)}).then($=>{$.getProcessList(I,b=>{if(!b){k(new Error(`Root process ${I} not found`));return}$.getProcessCpuUsage(b,y=>{const c=new Map;y.forEach(f=>{const d=h(f.commandLine||"");c.set(f.pid,{name:m(d),cmd:d,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),g=c.get(I),g?(c.forEach(f=>{const d=c.get(f.ppid);d&&(d.children||(d.children=[]),d.children.push(f))}),c.forEach(f=>{f.children&&(f.children=f.children.sort((d,l)=>d.pid-l.pid))}),R(g)):k(new Error(`Root process ${I} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let h=function(){let $=[g];const b=[];for(;$.length;){const c=$.shift();c&&(b.push(c.pid),c.children&&($=$.concat(c.children)))}let y=JSON.stringify(A.$yg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);y+=" "+b.join(" "),(0,O.exec)(y,{},(c,f,d)=>{if(c||d)k(c||new Error(d.toString()));else{const l=f.toString().split(`
`);for(let v=0;v<b.length;v++){const i=C.get(b[v]);i.load=parseFloat(l[v])}if(!g){k(new Error(`Root process ${I} not found`));return}R(g)}})};(0,O.exec)("which ps",{},($,b,y)=>{if($||y)if(process.platform!=="linux")k($||new Error(y.toString()));else{const c=JSON.stringify(A.$yg.asFileUri("vs/base/node/ps.sh").fsPath);(0,O.exec)(c,{},(f,d,l)=>{f||l?k(f||new Error(l.toString())):(L(d,S),h())})}else{const c=b.toString().trim();(0,O.exec)(`${c} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,l,v)=>{d||v&&!v.includes("screen size is bogus")?k(d||new Error(v.toString())):(L(l,S),process.platform==="linux"?h():g?R(g):k(new Error(`Root process ${I} not found`)))})}})}})}e.$ds=D;function L(I,R){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=I.toString().split(`
`);for(const C of g){const S=k.exec(C.trim());S&&S.length===6&&R(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}});var ye=this&&this.__decorate||function(se,e,O,A){var D=arguments.length,L=D<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,O):A,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(se,e,O,A);else for(var R=se.length-1;R>=0;R--)(I=se[R])&&(L=(D<3?I(L):D>3?I(e,O,L):I(e,O))||L);return D>3&&L&&Object.defineProperty(e,O,L),L};define(le[40],he([0,1,17,6,14,26,85,7,3,2,66,27,12]),function(se,e,O,A,D,L,I,R,k,g,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.ProxyChannel=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.RequestInitiator=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=void 0;var h;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(h||(h={}));function $(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(b||(b={}));function y(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(c||(c={}));function f(H){let V=0;for(let te=0;;te+=7){const oe=H.read(1);if(V|=(oe.buffer[0]&127)<<te,!(oe.buffer[0]&128))return V}}const d=n(0);function l(H,V){if(V===0){H.write(d);return}let te=0;for(let ee=V;ee!==0;ee=ee>>>7)te++;const oe=D.$se.alloc(te);for(let ee=0;V!==0;ee++)oe.buffer[ee]=V&127,V=V>>>7,V>0&&(oe.buffer[ee]|=128);H.write(oe)}class v{constructor(V){this.b=V,this.a=0}read(V){const te=this.b.slice(this.a,this.a+V);return this.a+=te.byteLength,te}}e.$Oh=v;class i{constructor(){this.a=[]}get buffer(){return D.$se.concat(this.a)}write(V){this.a.push(V)}}e.$Ph=i;var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(o||(o={}));function n(H){const V=D.$se.alloc(1);return V.writeUInt8(H,0),V}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(H,V){if(typeof V>"u")H.write(s.Undefined);else if(typeof V=="string"){const te=D.$se.fromString(V);H.write(s.String),l(H,te.byteLength),H.write(te)}else if(t&&Buffer.isBuffer(V)){const te=D.$se.wrap(V);H.write(s.Buffer),l(H,te.byteLength),H.write(te)}else if(V instanceof D.$se)H.write(s.VSBuffer),l(H,V.byteLength),H.write(V);else if(Array.isArray(V)){H.write(s.Array),l(H,V.length);for(const te of V)r(H,te)}else if(typeof V=="number"&&(V|0)===V)H.write(s.Uint),l(H,V);else{const te=D.$se.fromString(JSON.stringify(V));H.write(s.Object),l(H,te.byteLength),H.write(te)}}e.$Qh=r;function a(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(f(H)).toString();case o.Buffer:return H.read(f(H)).buffer;case o.VSBuffer:return H.read(f(H));case o.Array:{const te=f(H),oe=[];for(let ee=0;ee<te;ee++)oe.push(a(H));return oe}case o.Object:return JSON.parse(H.read(f(H)).toString());case o.Int:return f(H)}}e.$Rh=a;class E{constructor(V,te,oe=null,ee=1e3){this.h=V,this.j=te,this.k=oe,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(V,te){this.b.set(V,te),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const te=this.o([V.type]);this.k?.logOutgoing(te,0,1,y(V.type));return}case 201:case 202:case 204:case 203:{const te=this.o([V.type,V.id],V.data);this.k?.logOutgoing(te,V.id,1,y(V.type),V.data);return}}}o(V,te=void 0){const oe=new i;return r(oe,V),r(oe,te),this.p(oe.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const te=new v(V),oe=a(te),ee=a(te),ae=oe[0];switch(ae){case 100:return this.k?.logIncoming(V.byteLength,oe[1],1,`${$(ae)}: ${oe[2]}.${oe[3]}`,ee),this.s({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:ee});case 102:return this.k?.logIncoming(V.byteLength,oe[1],1,`${$(ae)}: ${oe[2]}.${oe[3]}`,ee),this.t({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:ee});case 101:return this.k?.logIncoming(V.byteLength,oe[1],1,`${$(ae)}`),this.u({type:ae,id:oe[1]});case 103:return this.k?.logIncoming(V.byteLength,oe[1],1,`${$(ae)}`),this.u({type:ae,id:oe[1]})}}s(V){const te=this.b.get(V.channelName);if(!te){this.v(V);return}const oe=new L.$ce;let ee;try{ee=te.call(this.j,V.name,V.arg,oe.token)}catch(U){ee=Promise.reject(U)}const ae=V.id;ee.then(U=>{this.m({id:ae,data:U,type:201})},U=>{U instanceof Error?this.m({id:ae,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:ae,data:U,type:203})}).finally(()=>{G.dispose(),this.d.delete(V.id)});const G=(0,g.$Rc)(()=>oe.cancel());this.d.set(V.id,G)}t(V){const te=this.b.get(V.channelName);if(!te){this.v(V);return}const oe=V.id,ae=te.listen(this.j,V.name,V.arg)(G=>this.m({id:oe,data:G,type:204}));this.d.set(V.id,ae)}u(V){const te=this.d.get(V.id);te&&(te.dispose(),this.d.delete(V.id))}v(V){let te=this.g.get(V.channelName);te||(te=[],this.g.set(V.channelName,te));const oe=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);te.push({request:V,timeoutTimer:oe})}w(V){const te=this.g.get(V);if(te){for(const oe of te)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Sh=E;var w;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class u{constructor(V,te=null){this.l=V,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$5d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=te}getChannel(V){const te=this;return{call(oe,ee,ae){return te.a?Promise.reject(new R.$5):te.m(V,oe,ee,ae)},listen(oe,ee){return te.a?k.Event.None:te.o(V,oe,ee)}}}m(V,te,oe,ee=L.CancellationToken.None){const ae=this.g++,U={id:ae,type:100,channelName:V,name:te,arg:oe};if(ee.isCancellationRequested)return Promise.reject(new R.$5);let j;return new Promise((B,q)=>{if(ee.isCancellationRequested)return q(new R.$5);const Z=()=>{const ne=ce=>{switch(ce.type){case 201:this.f.delete(ae),B(ce.data);break;case 202:{this.f.delete(ae);const fe=new Error(ce.data.message);fe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,fe.name=ce.data.name,q(fe);break}case 203:this.f.delete(ae),q(ce.data);break}};this.f.set(ae,ne),this.p(U)};let _=null;this.b===c.Idle?Z():(_=(0,A.$4g)(ne=>this.u()),_.then(()=>{_=null,Z()}));const ie=()=>{_?(_.cancel(),_=null):this.p({id:ae,type:101}),q(new R.$5)},J=ee.onCancellationRequested(ie);j=(0,g.$Qc)((0,g.$Rc)(ie),J),this.d.add(j)}).finally(()=>{j.dispose(),this.d.delete(j)})}o(V,te,oe){const ee=this.g++,G={id:ee,type:102,channelName:V,name:te,arg:oe};let U=null;const j=new k.$5d({onWillAddFirstListener:()=>{U=(0,A.$4g)(B=>this.u()),U.then(()=>{U=null,this.d.add(j),this.p(G)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(j),this.p({id:ee,type:103}))}}),T=B=>j.fire(B.data);return this.f.set(ee,T),j.event}p(V){switch(V.type){case 100:case 102:{const te=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(te,V.id,0,`${$(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const te=this.q([V.type,V.id]);this.j?.logOutgoing(te,V.id,0,$(V.type));return}}}q(V,te=void 0){const oe=new i;return r(oe,V),r(oe,te),this.r(oe.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const te=new v(V),oe=a(te),ee=a(te),ae=oe[0];switch(ae){case 200:return this.j?.logIncoming(V.byteLength,0,0,y(ae)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,oe[1],0,y(ae),ee),this.t({type:oe[0],id:oe[1],data:ee})}}t(V){if(V.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Th=u,ye([I.$Ih],u.prototype,"onDidInitializePromise",null);class p{get connections(){const V=[];return this.f.forEach(te=>V.push(te)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new k.$5d,this.onDidAddConnection=this.g.event,this.h=new k.$5d,this.onDidRemoveConnection=this.h.event,this.j=new g.$Sc,this.j.add(V(({protocol:te,onDidClientDisconnect:oe})=>{const ee=k.Event.once(te.onMessage);this.j.add(ee(ae=>{const G=new v(ae),U=a(G),j=new E(te,U),T=new u(te);this.a.forEach((q,Z)=>j.registerChannel(Z,q));const B={channelServer:j,channelClient:T,ctx:U};this.f.add(B),this.g.fire(B),this.j.add(oe(()=>{j.dispose(),T.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(V,te){const oe=this;return{call(ee,ae,G){let U;if((0,m.$7f)(te)){const T=(0,O.$4b)(oe.connections.filter(te));U=T?Promise.resolve(T):k.Event.toPromise(k.Event.filter(oe.onDidAddConnection,te))}else U=te.routeCall(oe,ee,ae);const j=U.then(T=>T.channelClient.getChannel(V));return N(j).call(ee,ae,G)},listen(ee,ae){if((0,m.$7f)(te))return oe.k(V,te,ee,ae);const G=te.routeEvent(oe,ee,ae).then(U=>U.channelClient.getChannel(V));return N(G).listen(ee,ae)}}}k(V,te,oe,ee){const ae=this;let G;const U=new k.$5d({onWillAddFirstListener:()=>{G=new g.$Sc;const j=new k.$$d,T=new Map,B=Z=>{const ie=Z.channelClient.getChannel(V).listen(oe,ee),J=j.add(ie);T.set(Z,J)},q=Z=>{const _=T.get(Z);_&&(_.dispose(),T.delete(Z))};ae.connections.filter(te).forEach(B),k.Event.filter(ae.onDidAddConnection,te)(B,void 0,G),ae.onDidRemoveConnection(q,void 0,G),j.event(U.fire,U,G),G.add(j)},onDidRemoveLastListener:()=>{G?.dispose(),G=void 0}});return U.event}registerChannel(V,te){this.a.set(V,te);for(const oe of this.f)oe.channelServer.registerChannel(V,te)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Uh=p;class P{constructor(V,te,oe=null){const ee=new i;r(ee,te),V.send(ee.buffer),this.a=new u(V,oe),this.d=new E(V,te,oe)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,te){this.d.registerChannel(V,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Vh=P;function N(H){return{call(V,te,oe){return H.then(ee=>ee.call(V,te,oe))},listen(V,te){const oe=new k.$be;return H.then(ee=>oe.input=ee.listen(V,te)),oe.event}}}e.$Wh=N;function F(H){let V=!1;return{call(te,oe,ee){return V?H.call(te,oe,ee):(0,A.$fh)(0).then(()=>V=!0).then(()=>H.call(te,oe,ee))},listen(te,oe){if(V)return H.listen(te,oe);const ee=new k.$be;return(0,A.$fh)(0).then(()=>V=!0).then(()=>ee.input=H.listen(te,oe)),ee.event}}}e.$Xh=F;class M{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const te of V.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await k.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$Yh=M;var z;(function(H){function V(ae,G,U){const j=ae,T=U&&U.disableMarshalling,B=new Map;for(const q in j)oe(q)&&B.set(q,k.Event.buffer(j[q],!0,void 0,G));return new class{listen(q,Z,_){const ie=B.get(Z);if(ie)return ie;if(ee(Z)){const J=j[Z];if(typeof J=="function")return J.call(j,_)}throw new R.$bb(`Event not found: ${Z}`)}call(q,Z,_){const ie=j[Z];if(typeof ie=="function"){if(!T&&Array.isArray(_))for(let ne=0;ne<_.length;ne++)_[ne]=(0,C.$Nh)(_[ne]);let J=ie.apply(j,_);return J instanceof Promise||(J=Promise.resolve(J)),J}throw new R.$bb(`Method not found: ${Z}`)}}}H.fromService=V;function te(ae,G){const U=G&&G.disableMarshalling;return new Proxy({},{get(j,T){if(typeof T=="string")return G?.properties?.has(T)?G.properties.get(T):ee(T)?function(B){return ae.listen(T,B)}:oe(T)?ae.listen(T):async function(...B){let q;G&&!(0,m.$2f)(G.context)?q=[G.context,...B]:q=B;const Z=await ae.call(T,q);return U?Z:(0,C.$Nh)(Z)};throw new R.$bb(`Property not found: ${String(T)}`)}})}H.toService=te;function oe(ae){return ae[0]==="o"&&ae[1]==="n"&&S.$if(ae.charCodeAt(2))}function ee(ae){return/^onDynamic/.test(ae)&&S.$if(ae.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const V=H.toString();if(V!=="[object Object]")return V}return H}function x(H){return Array.isArray(H)?H.map(Q):Q(H)}function W(H,V,te,oe,ee,ae,G){G=x(G);const U=Y[ee],j=U[oe%U.length];let T=[`%c[${H}]%c[${String(V).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${j}`];/\($/.test(ae)?(T=T.concat(G),T.push(")")):T.push(G),console.log.apply(console,T)}class X{constructor(V,te){this.d=V,this.f=te,this.a=0,this.b=0}logOutgoing(V,te,oe,ee,ae){this.b+=V,W(this.d,this.b,V,te,oe,ee,ae)}logIncoming(V,te,oe,ee,ae){this.a+=V,W(this.f,this.a,V,te,oe,ee,ae)}}e.$Zh=X}),define(le[68],he([0,1,14,3,2,40]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e.$2h=e.ProtocolConstants=e.$1h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(w,u){if(!t.has(w)){const p=String(++r);t.set(w,p)}return t.get(w)}function E(w,u,p,P){if(!s.enableDiagnostics)return;const N=a(w,u);if(P instanceof O.$se||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const F=O.$se.alloc(P.byteLength);F.set(P),s.records.push({timestamp:Date.now(),id:N,label:u,type:p,buff:F})}else s.records.push({timestamp:Date.now(),id:N,label:u,type:p,data:P})}s.traceSocketEvent=E})(R||(e.SocketDiagnostics=R={}));var k;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let g=null;function C(){return g||(g=O.$se.alloc(0)),g}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const u=this.a[0];return r&&(this.a.shift(),this.b-=t),u}if(this.a[0].byteLength>t){const u=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),u}const a=O.$se.alloc(t);let E=0,w=0;for(;t>0;){const u=this.a[w];if(u.byteLength>t){const p=u.slice(0,t);a.set(p,E),E+=t,r&&(this.a[w]=u.slice(t),this.b-=t),t-=t}else a.set(u,E),E+=u.byteLength,r?(this.a.shift(),this.b-=u.byteLength):w++,t-=u.byteLength}return a}}e.$1h=S;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class b{constructor(t,r,a,E){this.type=t,this.id=r,this.ack=a,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends D.$Tc{constructor(t){super(),this.f=this.B(new A.$5d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new S,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,E=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new b(a,E,w,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=O.$se.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=O.$se.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class f extends D.$Tc{constructor(t){super(),this.f=new A.$5d,this.onMessage=this.f.event,this.g=new A.$5d,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new c(this.a)),this.c=this.B(new y(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new b(1,0,0,t))}}e.$2h=f;class d extends L.$Vh{static fromSocket(t,r){return new d(new f(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$3h=d;class l{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$5d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$4h=l;class v{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new v(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let E=0;E<o.a;E++)t-this.c[E]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new l,this.onControlMessage=this.u.event,this.v=new l,this.onMessage=this.v.event,this.w=new l,this.onDidDispose=this.w.event,this.x=new l,this.onSocketClose=this.x.event,this.y=new l,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new D.$Sc,this.o=t.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new b(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new b(7,0,0,C());this.p.write(t)}sendResume(){const t=new b(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new D.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new b(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,E=r.length;a<E;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new b(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,E=r.length;a<E;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new b(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new b(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(r>=2e4&&a>=2e4&&E>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const w=Math.max(2e4-r,2e4-a,2e4-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new b(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new b(9,0,this.h,C());this.p.write(t)}}e.$5h=n}),define(le[93],he([0,1,67,6,14,26,141,7,3,2,30,145,90,40]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=void 0;class $ extends h.$Sh{constructor(c){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",f=>D.$se.wrap(Buffer.from(f,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Bq=$;class b{constructor(c,f){this.i=c,this.j=f,this.c=new Set,this.g=new Map,this.h=new k.$5d,this.onDidProcessExit=this.h.event;const d=f&&f.timeout?f.timeout:6e4;this.b=new A.$bh(d),this.d=null,this.f=null}getChannel(c){const f=this;return{call(d,l,v){return f.k(c,d,l,v)},listen(d,l){return f.l(c,d,l)}}}k(c,f,d,l=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const v=this.n(c),i=(0,A.$4g)(s=>v.call(f,d,s)),o=l.onCancellationRequested(()=>i.cancel()),n=(0,g.$Rc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,f,d){if(!this.b)return k.Event.None;this.b.cancel();let l;const v=new k.$5d({onWillAddFirstListener:()=>{l=this.n(c).listen(f,d)(v.fire,v),this.c.add(l)},onDidRemoveLastListener:()=>{this.c.delete(l),l.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return v.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,C.$Hn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,m.$4l)(f.env),this.d=(0,O.fork)(this.i,c,f);const d=new k.$5d;k.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,I.$xq)(t)){(0,I.log)(t,`IPC Library: ${this.j.serverName}`);return}d.fire(D.$se.wrap(Buffer.from(t,"base64")))});const v=this.j.useQueue?(0,S.$6l)(this.d):this.d,i=t=>this.d&&this.d.connected&&v.send(t.buffer.toString("base64")),o=d.event,n={send:i,onMessage:o};this.f=new h.$Th(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,g.$Oc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(c){let f=this.g.get(c);return f||(f=this.m.getChannel(c),this.g.set(c,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Cq=b}),define(le[147],he([0,1,134,14,40,3,12,17]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OV=e.$NV=void 0;class k{constructor(m){this.a=m,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",h=>h.data?A.$se.wrap(h.data):A.$se.alloc(0)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class g extends D.$Uh{static b(m){(0,I.$3f)((0,O.$MV)(process),"Electron Utility Process");const h=new L.$5d;return process.parentPort.on("message",$=>{if(m?.handledClientConnection($))return;const b=(0,R.$Ob)($.ports);b&&h.fire(b)}),L.Event.map(h.event,$=>({protocol:new k($),onDidClientDisconnect:L.Event.fromNodeEventEmitter($,"close")}))}constructor(m){super(g.b(m))}}e.$NV=g;function C(S,m,h){const $=b=>{b.data===m&&(S.removeListener("message",$),h())};S.on("message",$)}e.$OV=C}),define(le[69],he([0,1,6,3,2,66,12]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.StorageState=e.$Ap=e.StorageHint=void 0;var R;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function k(m){const h=m;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$Ap=k;var g;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(g||(e.StorageState=g={}));class C extends D.$Tc{static{this.a=100}constructor(h,$=Object.create(null)){super(),this.r=h,this.s=$,this.b=this.B(new A.$8d),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new O.$ch(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach(($,b)=>this.w(b,$)),h.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(h,$){if(this.c===g.Closed)return;let b=!1;(0,I.$2f)($)?b=this.f.delete(h):this.f.get(h)!==$&&(this.f.set(h,$),b=!0),b&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,$){const b=this.f.get(h);return(0,I.$2f)(b)?$:b}getBoolean(h,$){const b=this.get(h);return(0,I.$2f)(b)?$:b==="true"}getNumber(h,$){const b=this.get(h);return(0,I.$2f)(b)?$:parseInt(b,10)}getObject(h,$){const b=this.get(h);return(0,I.$2f)(b)?$:(0,L.$Mh)(b)}async set(h,$,b=!1){if(this.c===g.Closed)return;if((0,I.$2f)($))return this.delete(h,b);const y=(0,I.$Uf)($)||Array.isArray($)?(0,L.$Lh)($):String($);if(this.f.get(h)!==y)return this.f.set(h,y),this.j.set(h,y),this.h.delete(h),this.b.fire({key:h,external:b}),this.D()}async delete(h,$=!1){if(!(this.c===g.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:$}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(this.z)return this.D(h)}async D(h){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$Bp=C;class S{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach(($,b)=>this.a.set(b,$)),h.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$Cp=S}),define(le[148],he([13,9]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],he([0,1,54,6,16,12,31,148]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.zip=e.$Xp=e.$Wp=void 0,e.$Wp="end of central directory record signature not found";const k=new RegExp(e.$Wp);class g extends Error{constructor(v,i){let o=i.message;switch(v){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=v,this.cause=i}}e.$Xp=g;function C(l){const v=l.externalFileAttributes>>16||33188;return[448,56,7].map(i=>v&i).reduce((i,o)=>i+o,v&61440)}function S(l){if(l instanceof g)return l;let v;return k.test(l.message)&&(v="CorruptZip"),new g(v,l)}function m(l,v,i,o,n,s){const t=D.$mc(v),r=D.$jc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,v)));const a=D.$jc(o,v);let E;return s.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(I.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((w,u)=>{if(!s.isCancellationRequested)try{E=(0,O.createWriteStream)(a,{mode:i}),E.once("close",()=>w()),E.once("error",u),l.once("error",u),l.pipe(E)}catch(p){u(p)}}))}function h(l,v,i,o){let n=(0,A.$4g)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),l.close()});return new Promise((r,a)=>{const E=new A.$_g,w=u=>{u.isCancellationRequested||(s++,l.readEntry())};l.once("error",a),l.once("close",()=>n.then(()=>{o.isCancellationRequested||l.entryCount===s?r():a(new g("Incomplete",new Error(R.localize(1,null,s,l.entryCount))))},a)),l.readEntry(),l.on("entry",u=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(u.fileName)){w(o);return}const p=u.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(p)){const F=D.$jc(v,p);n=(0,A.$4g)(M=>I.Promises.mkdir(F,{recursive:!0}).then(()=>w(M)).then(void 0,a));return}const P=b(l,u),N=C(u);n=(0,A.$4g)(F=>E.queue(()=>P.then(M=>m(M,p,N,v,i,F).then(()=>w(F)))).then(null,a))})}).finally(()=>t.dispose())}async function $(l,v=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(l,v?{lazyEntries:!0}:void 0,(s,t)=>{s?n(S(s)):o((0,L.$4f)(t))})})}function b(l,v){return new Promise((i,o)=>{l.openReadStream(v,(n,s)=>{n?o(S(n)):i((0,L.$4f)(s))})})}async function y(l,v){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;v.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,O.createWriteStream)(l);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(l))})}e.zip=y;function c(l,v,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=$(l,!0);return i.overwrite&&(s=s.then(t=>I.Promises.rm(v).then(()=>t))),s.then(t=>h(t,v,{sourcePathRegex:n},o))}e.$Zp=c;function f(l,v){return $(l).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===v&&b(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(R.localize(2,null,v))))}))}function d(l,v){return f(l,v).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}e.$1p=d}),define(le[149],he([13,9]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[150],he([13,9]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[151],he([13,9]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[152],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[153],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[154],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[155],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[156],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[157],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[158],he([13,9]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[159],he([13,9]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[160],he([13,9]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[161],he([13,9]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[162],he([13,9]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[163],he([13,9]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[164],he([13,9]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[165],he([13,9]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[166],he([13,9]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[167],he([13,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[168],he([13,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[169],he([13,9]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[170],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[171],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[172],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[173],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[174],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[175],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[176],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[177],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[178],he([13,9]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[179],he([0,1,7,151]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.TokenType=void 0;var D;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(D||(e.TokenType=D={}));function L(...g){switch(g.length){case 1:return(0,A.localize)(0,null,g[0]);case 2:return(0,A.localize)(1,null,g[0],g[1]);case 3:return(0,A.localize)(2,null,g[0],g[1],g[2]);default:return}}const I=(0,A.localize)(3,null),R=(0,A.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,O.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const S=this.d,m=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:m};this.g.push({offset:S,lexeme:m,additionalInfo:C}),this.f.push(h)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const S=this.c.substring(this.d,this.e),m=k.b.get(S);m?this.k(m):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,S=!1,m=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const $=this.c.charCodeAt(C);if(S)S=!1;else if($===47&&!m){C++;break}else $===91?m=!0:$===92?S=!0:$===93&&(m=!1);C++}for(;C<this.c.length&&k.a.has(this.c.charCodeAt(C));)C++;this.e=C;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$_i=k}),define(le[180],he([0,1,65,85,23,16,37,20,10]),function(se,e,O,A,D,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=e.$Jm=void 0,e.$Jm=/^([^.]+\..+)[:=](.+)$/;class g{get appRoot(){return(0,L.$mc)(D.$yg.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,L.$jc)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,R.$Rg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$Rg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,O.$Im)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$jc)(this.userDataPath,"logs",h)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$Rg)(k.URI.file((0,L.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$Rg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$Rg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$Rg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=I.env.VSCODE_PORTABLE;return h?k.URI.file((0,L.$jc)(h,"argv.json")):(0,R.$Rg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,L.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,L.$kc)(h):(0,L.$hc)((0,L.$jc)(D.$yg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?k.URI.file((0,L.$kc)(h)):k.URI.file((0,L.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,L.$kc)(h);const $=I.env.VSCODE_EXTENSIONS;if($)return $;const b=I.env.VSCODE_PORTABLE;return b?(0,L.$jc)(b,"extensions"):(0,R.$Rg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map($=>/^[^:/?#]+?:\/\//.test($)?k.URI.parse($):k.URI.file((0,L.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?k.URI.parse(h):k.URI.file((0,L.$hc)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Jm.test(h))}get extensionLogLevel(){const h=[];for(const $ of this.args.log||[]){const b=e.$Jm.exec($);b&&b[1]&&b[2]&&h.push([b[1],b[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.$Rg)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=I.env.VSCODE_PORTABLE;return h?k.URI.file((0,L.$jc)(h,"policy.json")):(0,R.$Rg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,$,b){this.a=h,this.b=$,this.c=b,this.editSessionId=this.args.editSessionId}}e.$Km=g,ye([A.$Ih],g.prototype,"appRoot",null),ye([A.$Ih],g.prototype,"userHome",null),ye([A.$Ih],g.prototype,"userDataPath",null),ye([A.$Ih],g.prototype,"appSettingsHome",null),ye([A.$Ih],g.prototype,"tmpDir",null),ye([A.$Ih],g.prototype,"cacheHome",null),ye([A.$Ih],g.prototype,"stateResource",null),ye([A.$Ih],g.prototype,"userRoamingDataHome",null),ye([A.$Ih],g.prototype,"userDataSyncHome",null),ye([A.$Ih],g.prototype,"sync",null),ye([A.$Ih],g.prototype,"machineSettingsResource",null),ye([A.$Ih],g.prototype,"workspaceStorageHome",null),ye([A.$Ih],g.prototype,"localHistoryHome",null),ye([A.$Ih],g.prototype,"keyboardLayoutResource",null),ye([A.$Ih],g.prototype,"argvResource",null),ye([A.$Ih],g.prototype,"isExtensionDevelopment",null),ye([A.$Ih],g.prototype,"untitledWorkspacesHome",null),ye([A.$Ih],g.prototype,"builtinExtensionsPath",null),ye([A.$Ih],g.prototype,"extensionsPath",null),ye([A.$Ih],g.prototype,"extensionDevelopmentLocationURI",null),ye([A.$Ih],g.prototype,"extensionDevelopmentKind",null),ye([A.$Ih],g.prototype,"extensionTestsLocationURI",null),ye([A.$Ih],g.prototype,"debugExtensionHost",null),ye([A.$Ih],g.prototype,"logLevel",null),ye([A.$Ih],g.prototype,"extensionLogLevel",null),ye([A.$Ih],g.prototype,"serviceMachineIdResource",null),ye([A.$Ih],g.prototype,"disableTelemetry",null),ye([A.$Ih],g.prototype,"disableWorkspaceTrust",null),ye([A.$Ih],g.prototype,"useInMemorySecretStorage",null),ye([A.$Ih],g.prototype,"policyFile",null);function C(m,h){return S(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId,m.extensionEnvironment)}e.$Lm=C;function S(m,h,$,b,y,c){const d=Number(h||m)||(b?null:$),l=d?!!h:!1;let v;if(c)try{v=JSON.parse(c)}catch{}return{port:d,break:l,debugId:y,env:v}}e.$Mm=S}),function(){"use strict";function se(e,O,A){function D(I,R){const k=L(I,R),g=[k];return e.isAbsolute(k)||g.unshift(A),e.resolve(...g)}function L(I,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const C=I["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(S,"AppData","Roaming")}break;case"darwin":g=e.join(O.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:D}}if(typeof define=="function")define(le[181],he([269,36,37]),function(e,O,A){return se(e,O,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=se(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[182],he([0,1,36,180,181]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0;class L extends A.$Km{constructor(g,C){super(g,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,D.getUserDataPath)(g,C.nameShort)},C)}}e.$Nm=L;function I(k,g){return(0,A.$Mm)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,g,k.extensionEnvironment)}e.$Om=I;function R(k,g){return(0,A.$Mm)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,g,k.extensionEnvironment)}e.$Pm=R}),define(le[183],he([0,1,12,154]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;function D(I,R,k,g){try{L(I,R,k,g)}catch(C){I.error(C?.message??C)}return R}e.$0p=D;function L(I,R,k,g){const C=(S,m,h)=>{const $=S[m];if((0,O.$Sf)($)){const b=$,y=b.length;if(y>1&&b[0]==="%"&&b[y-1]==="%"){const c=b.substr(1,y-2);let f=k[c];f===void 0&&g&&(f=g[c]);const d=typeof f=="string"?f:f?.message,l=g?.[c],v=typeof l=="string"?l:l?.message;if(!d){v||I.warn(`[${R.name}]: ${(0,A.localize)(0,null,c)}`);return}if(h&&(m==="title"||m==="category")&&v&&v!==d){const i={value:d,original:v};S[m]=i}else S[m]=d}}else if((0,O.$Uf)($))for(const b in $)$.hasOwnProperty(b)&&(b==="commands"?C($,b,!0):C($,b,h));else if(Array.isArray($))for(let b=0;b<$.length;b++)C($,b,h)};for(const S in R)R.hasOwnProperty(S)&&C(R,S)}}),define(le[184],he([0,1,70,157]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;function D(L){return(0,O.$1p)(L,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.$fq=D}),define(le[185],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=e.$ibc=void 0;class O{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$ibc=O;class A{constructor(L){this.a=L}listen(L,I){throw new Error(`Event not found: ${I}`)}call(L,I,R){switch(I){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${I}`)}}e.$jbc=A}),define(le[71],he([0,1,20,89,158,55]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(c){return c=c.trim(),c==="*"||I.test(c)}e.$lp=k;function g(c){if(!k(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=c.match(I);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$mp=g;function C(c){if(!c)return null;const f=c.majorBase,d=c.majorMustEqual,l=c.minorBase;let v=c.minorMustEqual;const i=c.patchBase;let o=c.patchMustEqual;c.hasCaret&&(f===0||(v=!1),o=!1);let n=0;if(c.preRelease){const s=R.exec(c.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:f,majorMustEqual:d,minorBase:l,minorMustEqual:v,patchBase:i,patchMustEqual:o,isMinimum:c.hasGreaterEquals,notBefore:n}}e.$np=C;function S(c,f,d){let l;typeof c=="string"?l=C(g(c)):l=c;let v;f instanceof Date?v=f.getTime():typeof f=="string"&&(v=new Date(f).getTime());let i;if(typeof d=="string"?i=C(g(d)):i=d,!l||!i)return!1;const o=l.majorBase,n=l.minorBase,s=l.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const E=i.notBefore;let w=i.majorMustEqual,u=i.minorMustEqual,p=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||v&&v<E?!1:s>=a:(o===1&&t===0&&(!w||!u||!p)&&(t=1,r=0,a=0,w=!0,u=!1,p=!1),o<t?!1:o>t?!w:n<r?!1:n>r?!u:s<a?!1:s>a?!p:!(v&&v<E))}e.$op=S;function m(c,f,d,l,v){const i=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return i.push([A.default.Error,D.localize(0,null)]),i;if(typeof l.name!="string")return i.push([A.default.Error,D.localize(1,null,"name")]),i;if(typeof l.version!="string")return i.push([A.default.Error,D.localize(2,null,"version")]),i;if(!l.engines)return i.push([A.default.Error,D.localize(3,null,"engines")]),i;if(typeof l.engines.vscode!="string")return i.push([A.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof l.extensionDependencies<"u"&&!y(l.extensionDependencies))return i.push([A.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof l.activationEvents<"u"){if(!y(l.activationEvents))return i.push([A.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof l.main>"u"&&typeof l.browser>"u")return i.push([A.default.Error,D.localize(7,null,"activationEvents","main","browser")]),i}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&i.push([A.default.Warning,D.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return i.push([A.default.Error,D.localize(9,null,"main")]),i;{const s=(0,O.$Rg)(d,l.main);(0,O.$Lg)(s,d)||i.push([A.default.Warning,D.localize(10,null,s.path,d.path)])}}if(typeof l.browser<"u"){if(typeof l.browser!="string")return i.push([A.default.Error,D.localize(11,null,"browser")]),i;{const s=(0,O.$Rg)(d,l.browser);(0,O.$Lg)(s,d)||i.push([A.default.Warning,D.localize(12,null,s.path,d.path)])}}if(!L.valid(l.version))return i.push([A.default.Error,D.localize(13,null)]),i;const o=[];if(!h(c,f,l,v,o))for(const s of o)i.push([A.default.Error,s]);return i}e.$pp=m;function h(c,f,d,l,v){return l||typeof d.main>"u"&&typeof d.browser>"u"?!0:b(c,f,d.engines.vscode,v)}e.$qp=h;function $(c,f,d){return c==="*"||b(f,d,c)}e.$rp=$;function b(c,f,d,l=[]){const v=C(g(d));if(!v)return l.push(D.localize(14,null,d)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return l.push(D.localize(15,null,d)),!1}else if(!v.majorMustEqual)return l.push(D.localize(16,null,d)),!1;return S(c,f,v)?!0:(l.push(D.localize(17,null,c,d)),!1)}function y(c){if(!Array.isArray(c))return!1;for(let f=0,d=c.length;f<d;f++)if(typeof c[f]!="string")return!1;return!0}}),define(le[43],he([0,1,14,32]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;async function D(L,I,R){let k=R&&R.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const C=(await I.readFile(L.serviceMachineIdResource)).value.toString();k=(0,A.$zg)(C)?C:null}catch{k=null}if(!k){k=(0,A.$Ag)();try{await I.writeFile(L.serviceMachineIdResource,O.$se.fromString(k))}catch{}}return R?.store("storage.serviceMachineId",k,-1,1),k}e.$Lp=D}),define(le[72],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=void 0;class O{constructor(D,L=[],I=!1){this.ctor=D,this.staticArguments=L,this.supportsDelayedInstantiation=I}}e.$bi=O}),define(le[186],he([0,1,72]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.InstantiationType=void 0;const A=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function L(R,k,g){k instanceof O.$bi||(k=new O.$bi(k,[],!!g)),A.push([R,k])}e.$0r=L;function I(){return A}e.$$r=I}),define(le[187],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=void 0;class O{constructor(L,I){this.key=L,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$Nq=O;class A{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const I of this.a.values())I.outgoing.size===0&&L.push(I);return L}insertEdge(L,I){const R=this.lookupOrInsertNode(L),k=this.lookupOrInsertNode(I);R.outgoing.set(k.key,k),k.incoming.set(R.key,R)}removeNode(L){const I=this.b(L);this.a.delete(I);for(const R of this.a.values())R.outgoing.delete(I),R.incoming.delete(I)}lookupOrInsertNode(L){const I=this.b(L);let R=this.a.get(I);return R||(R=new O(I,L),this.a.set(I,R)),R}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[I,R]of this.a)L.push(`${I}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,I]of this.a){const R=new Set([L]),k=this.c(I,R);if(k)return k}}c(L,I){for(const[R,k]of L.outgoing){if(I.has(R))return[...I,R].join(" -> ");I.add(R);const g=this.c(k,I);if(g)return g;I.delete(R)}}}e.$Oq=A}),define(le[4],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e._util=void 0;var O;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function R(k){return k[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=R})(O||(e._util=O={})),e.$di=D("instantiationService");function A(I,R,k){R[O.DI_TARGET]===R?R[O.DI_DEPENDENCIES].push({id:I,index:k}):(R[O.DI_DEPENDENCIES]=[{id:I,index:k}],R[O.DI_TARGET]=R)}function D(I){if(O.serviceIds.has(I))return O.serviceIds.get(I);const R=function(k,g,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(R,k,C)};return R.toString=()=>I,O.serviceIds.set(I,R),R}e.$ei=D;function L(I){return I}e.$fi=L}),define(le[188],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=void 0,e.$Uac=(0,O.$ei)("checksumService")}),define(le[21],he([0,1,12,10,4]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ConfigurationTarget=e.$Mi=e.$Li=e.$Ki=void 0,e.$Ki=(0,D.$ei)("configurationService");function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof A.URI)}e.$Li=L;function I(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof A.URI)}e.$Mi=I;var R;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function k(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ni=k;function g(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$Oi=g;function C(c,f){const d=Object.create(null);for(const l in c)S(d,l,c[l],f);return d}e.$Pi=C;function S(c,f,d,l){const v=f.split("."),i=v.pop();let o=c;for(let n=0;n<v.length;n++){const s=v[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:l(`Ignoring ${f} as ${v.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=d}catch{l(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(o)}`)}else l(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(o)}`)}e.$Qi=S;function m(c,f){const d=f.split(".");h(c,d)}e.$Ri=m;function h(c,f){const d=f.shift();if(f.length===0){delete c[d];return}if(Object.keys(c).indexOf(d)!==-1){const l=c[d];typeof l=="object"&&!Array.isArray(l)&&(h(l,f),Object.keys(l).length===0&&delete c[d])}}function $(c,f,d){function l(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const v=f.split("."),i=l(c,v);return typeof i>"u"?d:i}e.$Si=$;function b(c,f,d){Object.keys(f).forEach(l=>{l!=="__proto__"&&(l in c?O.$Uf(c[l])&&O.$Uf(f[l])?b(c[l],f[l],d):d&&(c[l]=f[l]):c[l]=f[l])})}e.$Ti=b;function y(c){return c.replace(/[\[\]]/g,"")}e.$Ui=y}),define(le[94],he([0,1,5,27,179,4,150,7]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.ContextKeyExprType=e.$aj=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",O.$j),k.set("isLinux",O.$k),k.set("isWindows",O.$i),k.set("isWeb",O.$o),k.set("isMacNative",O.$j&&!O.$o),k.set("isEdge",O.$H),k.set("isFirefox",O.$F),k.set("isChrome",O.$E),k.set("isSafari",O.$G);function g(U,j){if(k.get(U)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(U,j)}e.$aj=g;const C=Object.prototype.hasOwnProperty;var S;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const m={regexParsingWithErrorRecovery:!0},h=(0,I.localize)(0,null),$=(0,I.localize)(1,null),b=(0,I.localize)(2,null),y=(0,I.localize)(3,null),c=(0,I.localize)(4,null),f=(0,I.localize)(5,null),d=(0,I.localize)(6,null),l=(0,I.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=m){this.k=j,this.d=new D.$_i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const T=this.l();if(!this.E()){const B=this.D(),q=B.type===17?f:void 0;throw this.h.push({message:c,offset:B.offset,lexeme:D.$_i.getLexeme(B),additionalInfo:q}),v.c}return T}catch(T){if(T!==v.c)throw T;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const T=this.o();j.push(T)}return j.length===1?j[0]:i.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const T=this.s();j.push(T)}return j.length===1?j[0]:i.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const T=this.l();return this.A(1,y),T?.negate()}case 17:return this.z(),P.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const T=this.l();return this.A(1,y),T}case 17:{const T=j.lexeme;if(this.z(),this.y(9)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==10)throw this.B("REGEX",q);const Z=q.lexeme,_=Z.lastIndexOf("/"),ie=_===Z.length-1?void 0:this.w(Z.substring(_+1));let J;try{J=new RegExp(Z.substring(1,_),ie)}catch{throw this.B("REGEX",q)}return Q.create(T,J)}switch(q.type){case 10:case 19:{const Z=[q.lexeme];this.z();let _=this.D(),ie=0;for(let de=0;de<q.lexeme.length;de++)q.lexeme.charCodeAt(de)===40?ie++:q.lexeme.charCodeAt(de)===41&&ie--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let de=0;de<_.lexeme.length;de++)_.lexeme.charCodeAt(de)===40?ie++:q.lexeme.charCodeAt(de)===41&&ie--}if(ie<0)break;Z.push(D.$_i.getLexeme(_)),this.z(),_=this.D()}const J=Z.join(""),ne=J.lastIndexOf("/"),ce=ne===J.length-1?void 0:this.w(J.substring(ne+1));let fe;try{fe=new RegExp(J.substring(1,ne),ce)}catch{throw this.B("REGEX",q)}return i.regex(T,fe)}case 18:{const Z=q.lexeme;this.z();let _=null;if(!(0,A.$Se)(Z)){const ie=Z.indexOf("/"),J=Z.lastIndexOf("/");if(ie!==J&&ie>=0){const ne=Z.slice(ie+1,J),ce=Z[J+1]==="i"?"i":"";try{_=new RegExp(ne,ce)}catch{throw this.B("REGEX",q)}}}if(_===null)throw this.B("REGEX",q);return Q.create(T,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const q=this.u();return i.notIn(T,q)}switch(this.D().type){case 3:{this.z();const q=this.u();if(this.x().type===18)return i.equals(T,q);switch(q){case"true":return i.has(T);case"false":return i.not(T);default:return i.equals(T,q)}}case 4:{this.z();const q=this.u();if(this.x().type===18)return i.notEquals(T,q);switch(q){case"true":return i.not(T);case"false":return i.has(T);default:return i.notEquals(T,q)}}case 5:return this.z(),z.create(T,this.u());case 6:return this.z(),Y.create(T,this.u());case 7:return this.z(),F.create(T,this.u());case 8:return this.z(),M.create(T,this.u());case 13:return this.z(),i.in(T,this.u());default:return i.has(T)}}case 20:throw this.h.push({message:d,offset:j.offset,lexeme:"",additionalInfo:l}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,T){if(this.C(j))return this.z();throw this.B(T,this.D())}B(j,T,B){const q=(0,I.localize)(8,null,j,D.$_i.getLexeme(T)),Z=T.offset,_=D.$_i.getLexeme(T);return this.h.push({message:q,offset:Z,lexeme:_,additionalInfo:B}),v.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$bj=v;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(j){return a.create(j)}static equals(j,T){return E.create(j,T)}static notEquals(j,T){return p.create(j,T)}static regex(j,T){return Q.create(j,T)}static in(j,T){return w.create(j,T)}static notIn(j,T){return u.create(j,T)}static not(j){return P.create(j)}static and(...j){return X.create(j,null,!0)}static or(...j){return H.create(j,null,!0)}static greater(j,T){return F.create(j,T)}static greaterEquals(j,T){return M.create(j,T)}static smaller(j,T){return z.create(j,T)}static smallerEquals(j,T){return Y.create(j,T)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$cj=i;function o(U){const j=new v({regexParsingWithErrorRecovery:!1});return U.map(T=>(j.parse(T),j.lexingErrors.length>0?j.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,I.localize)(9,null,B.additionalInfo):(0,I.localize)(10,null),offset:B.offset,length:B.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$dj=o;function n(U,j){const T=U?U.substituteConstants():void 0,B=j?j.substituteConstants():void 0;return!T&&!B?!0:!T||!B?!1:T.equals(B)}e.$ej=n;function s(U,j){return U.cmp(j)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return r.INSTANCE}}e.$fj=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return t.INSTANCE}}e.$gj=r;class a{static create(j,T=null){const B=k.get(j);return typeof B=="boolean"?B?r.INSTANCE:t.INSTANCE:new a(j,T)}constructor(j,T){this.key=j,this.c=T,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:te(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=k.get(this.key);return typeof j=="boolean"?j?r.INSTANCE:t.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$hj=a;class E{static create(j,T,B=null){if(typeof T=="boolean")return T?a.create(j,B):P.create(j,B);const q=k.get(j);return typeof q=="boolean"?T===(q?"true":"false")?r.INSTANCE:t.INSTANCE:new E(j,T,B)}constructor(j,T,B){this.c=j,this.d=T,this.f=B,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=k.get(this.c);if(typeof j=="boolean"){const T=j?"true":"false";return this.d===T?r.INSTANCE:t.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$ij=E;class w{static create(j,T){return new w(j,T)}constructor(j,T){this.d=j,this.f=T,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const T=j.getValue(this.f),B=j.getValue(this.d);return Array.isArray(T)?T.includes(B):typeof B=="string"&&typeof T=="object"&&T!==null?C.call(T,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$jj=w;class u{static create(j,T){return new u(j,T)}constructor(j,T){this.d=j,this.f=T,this.type=11,this.c=w.create(j,T)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$kj=u;class p{static create(j,T,B=null){if(typeof T=="boolean")return T?P.create(j,B):a.create(j,B);const q=k.get(j);return typeof q=="boolean"?T===(q?"true":"false")?t.INSTANCE:r.INSTANCE:new p(j,T,B)}constructor(j,T,B){this.c=j,this.d=T,this.f=B,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=k.get(this.c);if(typeof j=="boolean"){const T=j?"true":"false";return this.d===T?t.INSTANCE:r.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$lj=p;class P{static create(j,T=null){const B=k.get(j);return typeof B=="boolean"?B?t.INSTANCE:r.INSTANCE:new P(j,T)}constructor(j,T){this.c=j,this.d=T,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:te(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=k.get(this.c);return typeof j=="boolean"?j?t.INSTANCE:r.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$mj=P;function N(U,j){if(typeof U=="string"){const T=parseFloat(U);isNaN(T)||(U=T)}return typeof U=="string"||typeof U=="number"?j(U):t.INSTANCE}class F{static create(j,T,B=null){return N(T,q=>new F(j,q,B))}constructor(j,T,B){this.c=j,this.d=T,this.f=B,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$nj=F;class M{static create(j,T,B=null){return N(T,q=>new M(j,q,B))}constructor(j,T,B){this.c=j,this.d=T,this.f=B,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$oj=M;class z{static create(j,T,B=null){return N(T,q=>new z(j,q,B))}constructor(j,T,B){this.c=j,this.d=T,this.f=B,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$pj=z;class Y{static create(j,T,B=null){return N(T,q=>new Y(j,q,B))}constructor(j,T,B){this.c=j,this.d=T,this.f=B,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:oe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$qj=Y;class Q{static create(j,T){return new Q(j,T)}constructor(j,T){this.d=j,this.f=T,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const T=this.f?this.f.source:"",B=j.f?j.f.source:"";return T<B?-1:T>B?1:0}equals(j){if(j.type===this.type){const T=this.f?this.f.source:"",B=j.f?j.f.source:"";return this.d===j.d&&T===B}return!1}substituteConstants(){return this}evaluate(j){const T=j.getValue(this.d);return this.f?this.f.test(T):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$rj=Q;class x{static create(j){return new x(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new x(this.c.map(j))}negate(){return this.c}}e.$sj=x;function W(U){let j=null;for(let T=0,B=U.length;T<B;T++){const q=U[T].substituteConstants();if(U[T]!==q&&j===null){j=[];for(let Z=0;Z<T;Z++)j[Z]=U[Z]}j!==null&&(j[T]=q)}return j===null?U:j}class X{static create(j,T,B){return X.d(j,T,B)}constructor(j,T){this.expr=j,this.c=T,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let T=0,B=this.expr.length;T<B;T++){const q=s(this.expr[T],j.expr[T]);if(q!==0)return q}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].equals(j.expr[T]))return!1;return!0}return!1}substituteConstants(){const j=W(this.expr);return j===this.expr?this:X.create(j,this.c,!1)}evaluate(j){for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].evaluate(j))return!1;return!0}static d(j,T,B){const q=[];let Z=!1;for(const _ of j)if(_){if(_.type===1){Z=!0;continue}if(_.type===0)return t.INSTANCE;if(_.type===6){q.push(..._.expr);continue}q.push(_)}if(q.length===0&&Z)return r.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(s);for(let _=1;_<q.length;_++)q[_-1].equals(q[_])&&(q.splice(_,1),_--);if(q.length===1)return q[0];for(;q.length>1;){const _=q[q.length-1];if(_.type!==9)break;q.pop();const ie=q.pop(),J=q.length===0,ne=H.create(_.expr.map(ce=>X.create([ce,ie],null,B)),null,J);ne&&(q.push(ne),q.sort(s))}if(q.length===1)return q[0];if(B){for(let _=0;_<q.length;_++)for(let ie=_+1;ie<q.length;ie++)if(q[_].negate().equals(q[ie]))return t.INSTANCE;if(q.length===1)return q[0]}return new X(q,T)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const T of this.expr)j.push(...T.keys());return j}map(j){return new X(this.expr.map(T=>T.map(j)),null)}negate(){if(!this.c){const j=[];for(const T of this.expr)j.push(T.negate());this.c=H.create(j,this,!0)}return this.c}}e.$tj=X;class H{static create(j,T,B){return H.d(j,T,B)}constructor(j,T){this.expr=j,this.c=T,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let T=0,B=this.expr.length;T<B;T++){const q=s(this.expr[T],j.expr[T]);if(q!==0)return q}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].equals(j.expr[T]))return!1;return!0}return!1}substituteConstants(){const j=W(this.expr);return j===this.expr?this:H.create(j,this.c,!1)}evaluate(j){for(let T=0,B=this.expr.length;T<B;T++)if(this.expr[T].evaluate(j))return!0;return!1}static d(j,T,B){let q=[],Z=!1;if(j){for(let _=0,ie=j.length;_<ie;_++){const J=j[_];if(J){if(J.type===0){Z=!0;continue}if(J.type===1)return r.INSTANCE;if(J.type===9){q=q.concat(J.expr);continue}q.push(J)}}if(q.length===0&&Z)return t.INSTANCE;q.sort(s)}if(q.length!==0){if(q.length===1)return q[0];for(let _=1;_<q.length;_++)q[_-1].equals(q[_])&&(q.splice(_,1),_--);if(q.length===1)return q[0];if(B){for(let _=0;_<q.length;_++)for(let ie=_+1;ie<q.length;ie++)if(q[_].negate().equals(q[ie]))return r.INSTANCE;if(q.length===1)return q[0]}return new H(q,T)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const T of this.expr)j.push(...T.keys());return j}map(j){return new H(this.expr.map(T=>T.map(j)),null)}negate(){if(!this.c){const j=[];for(const T of this.expr)j.push(T.negate());for(;j.length>1;){const T=j.shift(),B=j.shift(),q=[];for(const Z of G(T))for(const _ of G(B))q.push(X.create([Z,_],null,!1));j.unshift(H.create(q,null,!1))}this.c=H.create(j,this,!0)}return this.c}}e.$uj=H;class V extends a{static{this.d=[]}static all(){return V.d.values()}constructor(j,T,B){super(j,null),this.f=T,typeof B=="object"?V.d.push({...B,key:j}):B!==!0&&V.d.push({key:j,description:B,type:T!=null?typeof T:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return E.create(this.key,j)}notEqualsTo(j){return p.create(this.key,j)}}e.$vj=V,e.$wj=(0,L.$ei)("contextKeyService");function te(U,j){return U<j?-1:U>j?1:0}function oe(U,j,T,B){return U<T?-1:U>T?1:j<B?-1:j>B?1:0}function ee(U,j){if(U.type===0||j.type===1)return!0;if(U.type===9)return j.type===9?ae(U.expr,j.expr):!1;if(j.type===9){for(const T of j.expr)if(ee(U,T))return!0;return!1}if(U.type===6){if(j.type===6)return ae(j.expr,U.expr);for(const T of U.expr)if(ee(T,j))return!0;return!1}return U.equals(j)}e.$xj=ee;function ae(U,j){let T=0,B=0;for(;T<U.length&&B<j.length;){const q=U[T].cmp(j[B]);if(q<0)return!1;q===0&&T++,B++}return T===U.length}function G(U){return U.type===9?U.expr:[U]}}),define(le[95],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=e.$Um=e.ID=void 0,e.ID="diagnosticsService",e.$Um=(0,O.$ei)(e.ID);function A(L){return!!L.hostName&&!!L.errorMessage}e.$Vm=A;class D{async getPerformanceInfo(I,R){return{}}async getSystemInfo(I,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,R){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$Wm=D}),define(le[96],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,e.$po=(0,O.$ei)("downloadService")}),define(le[15],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=void 0,e.$li=(0,O.$ei)("environmentService"),e.$mi=(0,O.$fi)(e.$li)}),define(le[29],he([0,1,153,4]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.ExtensionGalleryErrorCode=e.$Lo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ko=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0,e.$yo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$zo=new RegExp(e.$yo),e.$Ao="__web_extension",e.$Bo="skipWalkthrough",e.$Co="extensionsSync",e.$Do="dependecyOrPackExtensionInstall";function D(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Eo=D;function L(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Fo=L;function I(d,l){switch(d){case 3:return l==="x64"?"win32-x64":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Go=I;function R(d,l){return l==="web"&&!d.includes("web")}e.$Ho=R;function k(d,l,v){return R(l,v)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===v}e.$Io=k;function g(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.$Jo=g;var C;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var S;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var m;(function(d){d.Install="install",d.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var h;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$Ko=(0,A.$ei)("extensionGalleryService");var $;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.DownloadSignature="DownloadSignature",d.UpdateMetadata="UpdateMetadata",d.Extract="Extract",d.Scanning="Scanning",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.NotAllowed="NotAllowed",d.Gallery="Gallery",d.Unknown="Unknown",d.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var b;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(b||(e.ExtensionSignaturetErrorCode=b={}));class y extends Error{constructor(l,v){super(l),this.code=v,this.name=v}}e.$Lo=y;var c;(function(d){d.Timeout="Timeout",d.Cancelled="Cancelled",d.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class f extends Error{constructor(l,v){super(l),this.code=v,this.name=v}}e.$Mo=f,e.$No=(0,A.$ei)("extensionManagementService"),e.$Oo="extensionsIdentifiers/disabled",e.$Po="extensionsIdentifiers/enabled",e.$Qo=(0,A.$ei)("IGlobalExtensionEnablementService"),e.$Ro=(0,A.$ei)("IExtensionTipsService"),e.$So=(0,O.localize2)(0,"Extensions"),e.$To=(0,O.localize2)(1,"Preferences")}),define(le[189],he([0,1,3,2,30,10,92,29]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=void 0;function k(y,c){return y?L.URI.revive(c?c.transformIncoming(y):y):void 0}function g(y,c){return c?c.transformOutgoingURI(y):y}function C(y,c){c=c||I.$en;const f=y.manifest;return{...(0,I.$hn)({...y,manifest:void 0},c),manifest:f}}function S(y,c){return y?.profileLocation?(0,I.$hn)(y,c??I.$en):y}function m(y,c){return c?(0,D.$Jn)(y,f=>f instanceof L.URI?c.transformOutgoingURI(f):void 0):y}class h{constructor(c,f){this.a=c,this.b=f,this.onInstallExtension=O.Event.buffer(c.onInstallExtension,!0),this.onDidInstallExtensions=O.Event.buffer(c.onDidInstallExtensions,!0),this.onUninstallExtension=O.Event.buffer(c.onUninstallExtension,!0),this.onDidUninstallExtension=O.Event.buffer(c.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=O.Event.buffer(c.onDidUpdateExtensionMetadata,!0)}listen(c,f){const d=this.b(c);switch(f){case"onInstallExtension":return O.Event.map(this.onInstallExtension,l=>({...l,profileLocation:l.profileLocation?g(l.profileLocation,d):l.profileLocation}));case"onDidInstallExtensions":return O.Event.map(this.onDidInstallExtensions,l=>l.map(v=>({...v,local:v.local?m(v.local,d):v.local,profileLocation:v.profileLocation?g(v.profileLocation,d):v.profileLocation})));case"onUninstallExtension":return O.Event.map(this.onUninstallExtension,l=>({...l,profileLocation:l.profileLocation?g(l.profileLocation,d):l.profileLocation}));case"onDidUninstallExtension":return O.Event.map(this.onDidUninstallExtension,l=>({...l,profileLocation:l.profileLocation?g(l.profileLocation,d):l.profileLocation}));case"onDidUpdateExtensionMetadata":return O.Event.map(this.onDidUpdateExtensionMetadata,l=>m(l,d))}throw new Error("Invalid listen")}async call(c,f,d){const l=this.b(c);switch(f){case"zip":{const v=C(d[0],l),i=await this.a.zip(v);return g(i,l)}case"unzip":return this.a.unzip(k(d[0],l));case"install":return this.a.install(k(d[0],l),S(d[1],l));case"installFromLocation":return this.a.installFromLocation(k(d[0],l),k(d[1],l));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(d[0],k(d[1],l),k(d[2],l));case"getManifest":return this.a.getManifest(k(d[0],l));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],S(d[1],l));case"installGalleryExtensions":{const v=d[0];return this.a.installGalleryExtensions(v.map(({extension:i,options:o})=>({extension:i,options:S(o,l)??{}})))}case"uninstall":return this.a.uninstall(C(d[0],l),S(d[1],l));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(d[0],l));case"getInstalled":return(await this.a.getInstalled(d[0],k(d[1],l))).map(i=>m(i,l));case"toggleAppliationScope":{const v=await this.a.toggleAppliationScope(C(d[0],l),k(d[1],l));return m(v,l)}case"copyExtensions":return this.a.copyExtensions(k(d[0],l),k(d[1],l));case"updateMetadata":{const v=await this.a.updateMetadata(C(d[0],l),d[1],k(d[2],l));return m(v,l)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1],d[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Tp=h;class $ extends A.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(c){super(),this.m=c,this.c=this.B(new O.$5d),this.f=this.B(new O.$5d),this.g=this.B(new O.$5d),this.h=this.B(new O.$5d),this.j=this.B(new O.$5d),this.B(this.m.listen("onInstallExtension")(f=>this.n(this.c,{...f,source:this.r(f.source)?L.URI.revive(f.source):f.source,profileLocation:L.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(f=>this.n(this.f,f.map(d=>({...d,local:d.local?C(d.local,null):d.local,source:this.r(d.source)?L.URI.revive(d.source):d.source,profileLocation:L.URI.revive(d.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(f=>this.n(this.g,{...f,profileLocation:L.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(f=>this.n(this.h,{...f,profileLocation:L.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(f=>this.j.fire(C(f,null))))}n(c,f){c.fire(f)}r(c){return c?typeof c.path=="string"&&typeof c.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(c){const f=await this.getTargetPlatform();return c.allTargetPlatforms.some(d=>(0,R.$Io)(d,c.allTargetPlatforms,f))}zip(c){return Promise.resolve(this.m.call("zip",[c]).then(f=>L.URI.revive(f)))}unzip(c){return Promise.resolve(this.m.call("unzip",[c]))}install(c,f){return Promise.resolve(this.m.call("install",[c,f])).then(d=>C(d,null))}installFromLocation(c,f){return Promise.resolve(this.m.call("installFromLocation",[c,f])).then(d=>C(d,null))}async installExtensionsFromProfile(c,f,d){return(await this.m.call("installExtensionsFromProfile",[c,f,d])).map(v=>C(v,null))}getManifest(c){return Promise.resolve(this.m.call("getManifest",[c]))}installFromGallery(c,f){return Promise.resolve(this.m.call("installFromGallery",[c,f])).then(d=>C(d,null))}async installGalleryExtensions(c){return(await this.m.call("installGalleryExtensions",[c])).map(d=>({...d,local:d.local?C(d.local,null):d.local,source:this.r(d.source)?L.URI.revive(d.source):d.source,profileLocation:L.URI.revive(d.profileLocation)}))}uninstall(c,f){return Promise.resolve(this.m.call("uninstall",[c,f]))}reinstallFromGallery(c){return Promise.resolve(this.m.call("reinstallFromGallery",[c])).then(f=>C(f,null))}getInstalled(c=null,f){return Promise.resolve(this.m.call("getInstalled",[c,f])).then(d=>d.map(l=>C(l,null)))}updateMetadata(c,f,d){return Promise.resolve(this.m.call("updateMetadata",[c,f,d])).then(l=>C(l,null))}toggleAppliationScope(c,f){return this.m.call("toggleAppliationScope",[c,f]).then(d=>C(d,null))}copyExtensions(c,f){return this.m.call("copyExtensions",[c,f])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(c,f,d){const l=await this.m.call("download",[c,f,d]);return L.URI.revive(l)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Up=$;class b{constructor(c){this.a=c}listen(c,f){throw new Error("Invalid listen")}call(c,f,d){switch(f){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Vp=b}),define(le[97],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u1b=e.RecommendationsNotificationResult=e.$t1b=e.RecommendationSource=void 0;var A;(function(I){I[I.FILE=1]="FILE",I[I.WORKSPACE=2]="WORKSPACE",I[I.EXE=3]="EXE"})(A||(e.RecommendationSource=A={}));function D(I){switch(I){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$t1b=D;var L;(function(I){I.Ignored="ignored",I.Cancelled="cancelled",I.TooMany="toomany",I.IncompatibleWindow="incompatibleWindow",I.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$u1b=(0,O.$ei)("IExtensionRecommendationNotificationService")}),define(le[11],he([0,1,48,16,27,12,10,160,4,5,23,52]),function(se,e,O,A,D,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.FileKind=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileOperationResult=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileChangeType=e.$Tk=e.FileOperation=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileSystemProviderErrorCode=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderCapabilities=e.$Dk=e.FilePermission=e.FileType=e.$Ck=e.$Bk=void 0,e.$Bk=(0,k.$ei)("fileService");function m(ee){return ee.create===!0}e.$Ck=m;var h;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var $;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})($||(e.FilePermission=$={}));function b(ee){const ae=ee;return!!ae&&typeof ae.onDidChange=="function"}e.$Dk=b;var y;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function c(ee){return!!(ee.capabilities&2)}e.$Ek=c;function f(ee){return!!(ee.capabilities&8)}e.$Fk=f;function d(ee){return!!(ee.capabilities&131072)}e.$Gk=d;function l(ee){return!!(ee.capabilities&4)}e.$Hk=l;function v(ee){return!!(ee.capabilities&16)}e.$Ik=v;function i(ee){return c(ee)?!!(ee.capabilities&16384):!1}e.$Jk=i;function o(ee){return c(ee)?!!(ee.capabilities&32768):!1}e.$Kk=o;function n(ee){return!!(ee.capabilities&65536)}e.$Lk=n;function s(ee){return!!(ee.capabilities&2048)}e.$Mk=s;var t;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ae,G){const U=new r(ae.toString(),G);return w(U,G),U}constructor(ae,G){super(ae),this.code=G}}e.$Nk=r;function a(ee,ae){return r.create(ee,ae)}e.$Ok=a;function E(ee){return ee||a((0,R.localize)(0,null),t.Unknown)}e.$Pk=E;function w(ee,ae){return ee.name=ae?`${ae} (FileSystemError)`:"FileSystemError",ee}e.$Qk=w;function u(ee){if(!ee)return t.Unknown;if(ee instanceof r)return ee.code;const ae=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!ae)return t.Unknown;switch(ae[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$Rk=u;function p(ee){if(ee instanceof Y)return ee.fileOperationResult;switch(u(ee)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$Sk=p;var P;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class N{constructor(ae,G,U){this.resource=ae,this.operation=G,this.target=U}isOperation(ae){return this.operation===ae}}e.$Tk=N;var F;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.a=null}constructor(ae,G){this.c=G,this.b=void 0,this.d=new S.$V(()=>{const U=O.$ki.forUris(()=>this.c);return U.fill(this.rawAdded.map(j=>[j,!0])),U}),this.f=new S.$V(()=>{const U=O.$ki.forUris(()=>this.c);return U.fill(this.rawUpdated.map(j=>[j,!0])),U}),this.g=new S.$V(()=>{const U=O.$ki.forUris(()=>this.c);return U.fill(this.rawDeleted.map(j=>[j,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of ae){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==M.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ae,...G){return this.h(ae,{includeChildren:!1},...G)}affects(ae,...G){return this.h(ae,{includeChildren:!0},...G)}h(ae,G,...U){if(!ae)return!1;const j=U.length>0;return!!((!j||U.includes(1))&&(this.d.value.get(ae)||G.includeChildren&&this.d.value.findSuperstr(ae))||(!j||U.includes(0))&&(this.f.value.get(ae)||G.includeChildren&&this.f.value.findSuperstr(ae))||(!j||U.includes(2))&&(this.g.value.findSubstr(ae)||G.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$Uk=M;function z(ee,ae,G){return!ee||!ae||ee===ae||ae.length>ee.length?!1:(ae.charAt(ae.length-1)!==A.sep&&(ae+=A.sep),G?(0,D.$kf)(ee,ae):ee.indexOf(ae)===0)}e.$Vk=z;class Y extends Error{constructor(ae,G,U){super(ae),this.fileOperationResult=G,this.options=U}}e.$Wk=Y;class Q extends Y{constructor(ae,G,U,j){super(ae,G,j),this.fileOperationResult=G,this.size=U}}e.$Xk=Q;class x extends Y{constructor(ae,G,U){super(ae,2,U),this.stat=G}}e.$Yk=x;var W;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$Zk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$1k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$2k="files.associations",e.$3k="files.exclude",e.$4k="files.readonlyInclude",e.$5k="files.readonlyExclude",e.$6k="files.readonlyFromPermissions";var X;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$7k="";function H(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}e.$8k=H;async function V(ee,ae){if(!ae.hasProvider(I.URI.from({scheme:ee.scheme})))return new Promise(G=>{const U=ae.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===ee.scheme&&j.added&&(U.dispose(),G())})})}e.$9k=V;class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(ae){return(0,L.$Wf)(ae)||(ae=0),ae<te.KB?(0,R.localize)(1,null,ae.toFixed(0)):ae<te.MB?(0,R.localize)(2,null,(ae/te.KB).toFixed(2)):ae<te.GB?(0,R.localize)(3,null,(ae/te.MB).toFixed(2)):ae<te.TB?(0,R.localize)(4,null,(ae/te.GB).toFixed(2)):(0,R.localize)(5,null,(ae/te.TB).toFixed(2))}}e.$0k=te;function oe(ee){const ae=typeof ee=="string"||ee?.scheme===C.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===C.Schemas.file?1024*te.MB:ae?10*te.MB:g.$o?50*te.MB:1024*te.MB}e.$$k=oe});var K=this&&this.__param||function(se,e){return function(O,A){e(O,A,se)}};define(le[190],he([0,1,73,47,11]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=void 0;let L=class{constructor(R){this.a=R}async checksum(R){const k=(await this.a.readFileStream(R)).value;return new Promise((g,C)=>{const S=(0,O.createHash)("sha256");(0,A.$ke)(k,{onData:m=>S.update(m.buffer),onError:m=>C(m),onEnd:()=>g(S.digest("base64").replace(/=+$/,""))})})}};e.$Vac=L,e.$Vac=L=ye([K(0,D.$Bk)],L)}),define(le[98],he([0,1,14,7,161,11]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;async function I(C,S,m,h,$,b){let y;try{await R(C,S,m,h,$,b)}catch(c){y=c}finally{y&&$.errorTransformer&&(y=$.errorTransformer(y)),typeof y<"u"&&m.error(y),m.end()}}e.$mq=I;async function R(C,S,m,h,$,b){k(b);const y=await C.open(S,{create:!1});try{k(b);let c=0,f=0,d=$&&typeof $.length=="number"?$.length:void 0,l=O.$se.alloc(Math.min($.bufferSize,typeof d=="number"?d:$.bufferSize)),v=$&&typeof $.position=="number"?$.position:0,i=0;do f=await C.read(y,v,l.buffer,i,l.byteLength-i),v+=f,i+=f,c+=f,typeof d=="number"&&(d-=f),i===l.byteLength&&(await m.write(h(l)),l=O.$se.alloc(Math.min($.bufferSize,typeof d=="number"?d:$.bufferSize)),i=0);while(f>0&&(typeof d!="number"||d>0)&&k(b)&&g(c,$));if(i>0){let o=i;typeof d=="number"&&(o=Math.min(i,d)),m.write(h(l.slice(0,o)))}}catch(c){throw(0,L.$Pk)(c)}finally{await C.close(y)}}function k(C){if(C.isCancellationRequested)throw(0,A.$6)();return!0}function g(C,S){if(typeof S?.limits?.size=="number"&&C>S.limits.size)throw(0,L.$Ok)((0,D.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[50],he([0,1,91,2,16,5,10,11]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=void 0;function k(c){return c.recursive===!0}e.$oq=k;class g extends A.$Tc{static{this.a=5}constructor(f,d,l,v){super(),this.h=f,this.j=d,this.m=l,this.n=v,this.c=this.B(new A.$Uc),this.f=void 0,this.g=0}s(){const f=new A.$Sc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(d=>this.h(d))),f.add(this.b.onDidLogMessage(d=>this.j(d))),f.add(this.b.onDidError(d=>this.t(d)))}t(f){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$pq=g;class C extends g{constructor(f,d,l){super(f,d,l,{type:"node.js",restartOnError:!1})}}e.$qq=C;class S extends g{constructor(f,d,l){super(f,d,l,{type:"universal",restartOnError:!0})}}e.$rq=S;function m(c){return c.map(f=>({type:f.type,resource:I.URI.revive(f.resource),cId:f.cId}))}e.$sq=m;function h(c){const f=new y;for(const d of c)f.processEvent(d);return f.coalesce()}e.$tq=h;function $(c,f){return typeof f=="string"&&!f.startsWith(O.$Tj)&&!(0,D.$ic)(f)?{base:c,pattern:f}:f}e.$uq=$;function b(c,f){const d=[];for(const l of f)d.push((0,O.$Xj)($(c,l)));return d}e.$vq=b;class y{constructor(){this.a=new Set,this.b=new Map}c(f){return L.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const d=this.b.get(this.c(f));let l=!1;if(d){const v=d.type,i=f.type;d.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?l=!0:v===1&&i===2?(this.b.delete(this.c(f)),this.a.delete(d)):v===2&&i===1?d.type=0:v===1&&i===0||(d.type=i)}else l=!0;l&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],d=[];return Array.from(this.a).filter(l=>l.type!==2?(f.push(l),!1):!0).sort((l,v)=>l.resource.fsPath.length-v.resource.fsPath.length).filter(l=>d.some(v=>(0,R.$Vk)(l.resource.fsPath,v,!L.$k))?!1:(d.push(l.resource.fsPath),!0)).concat(f)}}}),define(le[191],he([0,1,14,38,7,3,2,47,32,11,50]),function(se,e,O,A,D,L,I,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jP=e.$iP=void 0,e.$iP="localFilesystem";class S extends I.$Tc{constructor(h,$){super(),this.a=h,this.b=$,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$5d),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$5d),this.onDidWatchError=this.g.event,this.h=(0,k.$Ag)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,$){const{buffer:b}=await this.a.call("readFile",[h,$]);return b}readFileStream(h,$,b){const y=(0,R.$ge)(f=>O.$se.concat(f.map(d=>O.$se.wrap(d))).buffer),c=new I.$Sc;return c.add(this.a.listen("readFileStream",[h,$])(f=>{if(f instanceof O.$se)y.write(f.buffer);else{if(f==="end")y.end();else{let d;if(f instanceof Error)d=f;else{const l=f;d=(0,g.$Ok)(l.message??(0,A.$2i)(l),l.code??g.FileSystemProviderErrorCode.Unknown)}y.error(d),y.end()}c.dispose()}})),c.add(b.onCancellationRequested(()=>{y.error((0,D.$6)()),y.end(),c.dispose()})),y}writeFile(h,$,b){return this.a.call("writeFile",[h,O.$se.wrap($),b])}open(h,$){return this.a.call("open",[h,$])}close(h){return this.a.call("close",[h])}async read(h,$,b,y,c){const[f,d]=await this.a.call("read",[h,$,c]);return b.set(f.buffer.slice(0,d),y),d}write(h,$,b,y,c){return this.a.call("write",[h,$,O.$se.wrap(b),y,c])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,$){return this.a.call("delete",[h,$])}rename(h,$,b){return this.a.call("rename",[h,$,b])}copy(h,$,b){return this.a.call("copy",[h,$,b])}cloneFile(h,$){return this.a.call("cloneFile",[h,$])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const $=h;this.f.fire((0,C.$sq)($))}else{const $=h;this.g.fire($)}}))}watch(h,$){const b=(0,k.$Ag)();return this.a.call("watch",[this.h,b,h,$]),(0,I.$Rc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$jP=S}),define(le[192],he([0,1,54,6,26,49,2,88,16,5,20,10,144,31,50]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=void 0;class b extends I.$Tc{static{this.a=100}static{this.b=75}constructor(f,d,l,v){super(),this.m=f,this.n=d,this.r=l,this.s=v,this.c=this.B(new A.$th({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new A.$sh(i=>this.z(i),b.b)),this.g=(0,$.$vq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$vq)(this.m.path,this.m.includes):void 0,this.j=new D.$ce,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const d=await h.Promises.stat(f);this.B(await this.w(f,d.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let d=f.path;try{d=await h.Promises.realpath(f.path),f.path===d&&(d=await(0,m.$Fq)(f.path)??f.path),f.path!==d&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${d})`)}catch{}return d}async w(f,d){if(g.$j&&(0,L.$fg)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.$Tc.None;const l=new D.$ce(this.j.token),v=new I.$Sc;try{const i=S.URI.file(this.m.path),o=(0,k.$nc)(f),n=(0,O.watch)(f);v.add((0,I.$Rc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${f}'`);const s=new Set;if(d)try{for(const r of await h.Promises.readdir(f))s.add(r)}catch(r){this.D(r)}const t=new Map;v.add((0,I.$Rc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(l.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let E="";if(a&&(E=a.toString(),g.$j&&(E=(0,R.$Rl)(E))),!(!E||r!=="change"&&r!=="rename"))if(d)if(r==="rename"){t.get(E)?.dispose();const w=setTimeout(async()=>{if(t.delete(E),E===o&&!await h.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.C((0,k.$jc)(f,E));if(l.token.isCancellationRequested)return;let p;u?s.has(E)?p=0:(p=1,s.add(E)):(s.delete(E),p=2),this.y({resource:(0,C.$Rg)(i,E),type:p,cId:this.m.correlationId})},b.a);t.set(E,(0,I.$Rc)(()=>clearTimeout(w)))}else{let w;s.has(E)?w=0:(w=1,s.add(E)),this.y({resource:(0,C.$Rg)(i,E),type:w,cId:this.m.correlationId})}else if(r==="rename"||E!==o){const w=setTimeout(async()=>{const u=await h.Promises.exists(f);l.token.isCancellationRequested||(u?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),v.add(await this.w(f,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},b.a);v.clear(),v.add((0,I.$Rc)(()=>clearTimeout(w)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await h.Promises.exists(f)&&!l.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${i.toString()})`)}return(0,I.$Rc)(()=>{l.dispose(!0),v.dispose()})}y(f,d=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!d&&this.g.some(l=>l(f.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${f.resource.fsPath}`):!d&&this.h&&this.h.length>0&&!this.h.some(l=>l(f.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}z(f){const d=(0,$.$tq)(f);if(d.length>0){if(this.s)for(const v of d)this.G(` >> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`);this.c.work(d)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if(g.$k)return h.Promises.exists(f);try{const d=(0,k.$nc)(f);return(await h.Promises.readdir((0,k.$mc)(f))).some(v=>v===d)}catch(d){return this.G(d),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Iq=b;async function y(c,f,d,l,v=512){const i=await h.Promises.open(c,"r"),o=Buffer.allocUnsafe(v),n=new D.$ce(l);let s,t=!1;const r={path:c,excludes:[],recursive:!1},a=new b(r,E=>{(async()=>{for(const{type:w}of E)if(w===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:u}=await h.Promises.read(i,o,0,v,null);if(!u||n.token.isCancellationRequested)break;f(o.slice(0,u))}}catch(u){s=new Error(u),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,d(),new Promise((E,w)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await h.Promises.close(i)}catch(u){s=new Error(u)}s?w(s):E()})})}e.$Jq=y}),define(le[193],he([0,1,3,91,2,5,192]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;class R extends D.$Tc{constructor(){super(...arguments),this.a=this.B(new O.$5d),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$5d),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(g){const C=this.j(g),S=C.filter(h=>{const $=this.c.get(h.path);return $?!(0,A.$2j)($.request.excludes,h.excludes)||!(0,A.$2j)($.request.includes,h.includes):!0}),m=Array.from(this.c.values()).filter(({request:h})=>!C.find($=>$.path===h.path&&(0,A.$2j)($.excludes,h.excludes)&&(0,A.$2j)($.includes,h.includes))).map(({request:h})=>h.path);S.length&&this.m(`Request to start watching: ${S.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const h of m)this.h(h);for(const h of S)this.g(h)}g(g){const C=new I.$Iq(g,m=>this.a.fire(m),m=>this.b.fire(m),this.f),S={request:g,instance:C};this.c.set(g.path,S)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const C=this.c.get(g);C&&(this.c.delete(g),C.instance.dispose())}j(g){const C=new Map;for(const S of g){const m=L.$k?S.path:S.path.toLowerCase();let h=C.get(S.correlationId);h||(h=new Map,C.set(S.correlationId,h)),h.set(m,S)}return Array.from(C.values()).map(S=>Array.from(S.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,C]of this.c)C.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,C){return C?`[File Watcher (node.js)] ${g} (path: ${C.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$Kq=R}),define(le[194],he([0,1,50,193]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class D extends O.$qq{constructor(I,R,k){super(I,R,k),this.s()}r(I){return I.add(new A.$Kq)}}e.$Lq=D}),define(le[195],he([0,1,23,40,93,50]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;class I extends L.$rq{constructor(k,g,C){super(k,g,C),this.s()}r(k){const g=k.add(new D.$Cq(O.$yg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(g.onDidProcessExit(({code:C,signal:S})=>this.t(`terminated by itself with code ${C}, signal: ${S}`))),A.ProxyChannel.toService((0,A.$Xh)(g.getChannel("watcher")))}}e.$Dq=I}),define(le[74],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=void 0;class O{constructor(...D){this.a=new Map;for(const[L,I]of D)this.set(L,I)}set(D,L){const I=this.a.get(D);return this.a.set(D,L),I}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$ci=O}),define(le[196],he([0,1,6,7,2,72,187,4,74,87]),function(se,e,O,A,D,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=void 0;const C=!1;class S extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class m{constructor(y=new k.$ci,c=!1,f,d=C){this.f=y,this.g=c,this.h=f,this.i=d,this.o=new Set,this.f.set(R.$di,this),this._globalGraph=d?f?._globalGraph??new I.$Oq(l=>l):void 0}createChild(y){return new m(y,this.g,this,this.i)}invokeFunction(y,...c){const f=$.traceInvocation(this.i,y);let d=!1;try{return y({get:v=>{if(d)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(v,f);if(!i)throw new Error(`[invokeFunction] unknown service '${v}'`);return i}},...c)}finally{d=!0,f.stop()}}createInstance(y,...c){let f,d;return y instanceof L.$bi?(f=$.traceCreation(this.i,y.ctor),d=this.j(y.ctor,y.staticArguments.concat(c),f)):(f=$.traceCreation(this.i,y),d=this.j(y,c,f)),f.stop(),d}j(y,c=[],f){const d=R._util.getServiceDependencies(y).sort((i,o)=>i.index-o.index),l=[];for(const i of d){const o=this.m(i.id,f);o||this.u(`[createInstance] ${y.name} depends on UNKNOWN service ${i.id}.`,!1),l.push(o)}const v=d.length>0?d[0].index:c.length;if(c.length!==v){console.trace(`[createInstance] First service dependency of ${y.name} at position ${v+1} conflicts with ${c.length} static arguments`);const i=v-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,v)}return Reflect.construct(y,c.concat(l))}k(y,c){if(this.f.get(y)instanceof L.$bi)this.f.set(y,c);else if(this.h)this.h.k(y,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(y){const c=this.f.get(y);return!c&&this.h?this.h.l(y):c}m(y,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(y));const f=this.l(y);return f instanceof L.$bi?this.q(y,f,c.branch(y,!0)):(c.branch(y,!1),f)}q(y,c,f){if(this.o.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this.o.add(y);try{return this.r(y,c,f)}finally{this.o.delete(y)}}r(y,c,f){const d=new I.$Oq(i=>i.id.toString());let l=0;const v=[{id:y,desc:c,_trace:f}];for(;v.length;){const i=v.pop();if(d.lookupOrInsertNode(i),l++>1e3)throw new S(d);for(const o of R._util.getServiceDependencies(i.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${y} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof L.$bi){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};d.insertEdge(i,s),v.push(s)}}}for(;;){const i=d.roots();if(i.length===0){if(!d.isEmpty())throw new S(d);break}for(const{data:o}of i){if(this.l(o.id)instanceof L.$bi){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}d.removeNode(o)}}return this.l(y)}s(y,c,f=[],d,l){if(this.f.get(y)instanceof L.$bi)return this.t(y,c,f,d,l);if(this.h)return this.h.s(y,c,f,d,l);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(y,c,f=[],d,l){if(d){const v=new m(void 0,this.g,this,this.i);v.c=String(y);const i=new Map,o=new O.$xh(()=>{const n=v.j(c,f,l);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)a.disposable=r.apply(n,a.listener)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new g.$4c,i.set(s,a)),(w,u,p)=>{if(o.isInitialized)return o.value[s](w,u,p);{const P={listener:[w,u,p],disposable:void 0},N=a.push(P);return(0,D.$Rc)(()=>{N(),P.disposable?.dispose()})}}}if(s in n)return n[s];const t=o.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return o.value[s]=t,!0},getPrototypeOf(n){return c.prototype}})}else return this.j(c,f,l)}u(y,c){if(c&&console.warn(y),this.g)throw new Error(y)}}e.$Pq=m;var h;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(h||(h={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(y,c){return y?new $(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(y,c){return y?new $(1,c.name):$.c}static{this.f=0}constructor(y,c){this.type=y,this.name=c,this.g=Date.now(),this.h=[]}branch(y,c){const f=new $(3,y.toString());return this.h.push([y,c,f]),f}stop(){const y=Date.now()-this.g;$.f+=y;let c=!1;function f(l,v){const i=[],o=new Array(l+1).join("	");for(const[n,s,t]of v.h)if(s&&t){c=!0,i.push(`${o}CREATES -> ${n}`);const r=f(l+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(y>2||c)&&$.all.add(d.join(`
`))}}e.$Qq=$}),define(le[56],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=e.$qac=void 0,e.$qac=(0,O.$ei)("mainProcessService");class A{constructor(L,I){this.a=L,this.b=I}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,I){this.a.registerChannel(L,I)}}e.$rac=A}),define(le[75],he([0,1,26,2,5,163,29,4]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.$rr=void 0;function k(C){return C.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.$rr=k,e.$sr=(0,R.$ei)("languagePackService");let g=class extends A.$Tc{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new O.$ce;setTimeout(()=>S.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const $=m.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(y=>y.startsWith("lp-"))).map(b=>{const y=b.properties.localizedLanguages?.[0],c=k(b);return{...this.f(c,y,b),extensionId:b.identifier.id,galleryExtension:b}});return $.push(this.f("en","English")),$}f(S,m,h){const $=m??S;let b;if($!==S&&(b=`(${S})`),S.toLowerCase()===D.$w.toLowerCase()&&(b??="",b+=(0,L.localize)(0,null)),h?.installCount){b??="";const y=h.installCount;let c;y>1e6?c=`${Math.floor(y/1e5)/10}M`:y>1e3?c=`${Math.floor(y/1e3)}K`:c=String(y),b+=` $(cloud-download) ${c}`}return{id:S,label:$,description:b}}};e.$tr=g,e.$tr=g=ye([K(0,I.$Ko)],g)}),define(le[197],he([0,1,2,75]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=void 0;let D=class extends O.$Tc{constructor(I){super(),this.a=I,this.b()}b(){this.a.update()}};e.$Rac=D,e.$Rac=D=ye([K(0,A.$sr)],D)}),define(le[8],he([0,1,38,3,53,2,35,5,20,12,10,94,4]),function(se,e,O,A,D,L,I,R,k,g,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.log=e.$Bj=e.LogLevel=e.$Aj=e.$zj=e.$yj=void 0,e.$yj=(0,m.$ei)("logService"),e.$zj=(0,m.$ei)("loggerService");function h(){return new Date().toISOString()}function $(w){return(0,g.$Wf)(w)}e.$Aj=$;var b;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$Bj=b.Info;function y(w,u,p){switch(u){case b.Trace:w.trace(p);break;case b.Debug:w.debug(p);break;case b.Info:w.info(p);break;case b.Warning:w.warn(p);break;case b.Error:w.error(p);break;case b.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=y;function c(w,u=!1){let p="";for(let P=0;P<w.length;P++){let N=w[P];if(N instanceof Error&&(N=(0,O.$2i)(N,u)),typeof N=="object")try{N=JSON.stringify(N)}catch{}p+=(P>0?" ":"")+N}return p}class f extends L.$Tc{constructor(){super(...arguments),this.b=e.$Bj,this.c=this.B(new A.$5d),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==b.Off&&this.b<=u}}e.$Dj=f;class d extends f{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...p){this.f(b.Trace)&&this.g(b.Trace,c([u,...p],!0))}debug(u,...p){this.f(b.Debug)&&this.g(b.Debug,c([u,...p]))}info(u,...p){this.f(b.Info)&&this.g(b.Info,c([u,...p]))}warn(u,...p){this.f(b.Warning)&&this.g(b.Warning,c([u,...p]))}error(u,...p){if(this.f(b.Error))if(u instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=u.stack,this.g(b.Error,c(P))}else this.g(b.Error,c([u,...p]))}flush(){}}e.$Ej=d;class l extends f{constructor(u=e.$Bj){super(),this.setLevel(u),this.g=!R.$i}trace(u,...p){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,u,...p):console.log(`[main ${h()}]`,u,...p))}debug(u,...p){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,u,...p):console.log(`[main ${h()}]`,u,...p))}info(u,...p){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,u,...p):console.log(`[main ${h()}]`,u,...p))}warn(u,...p){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,u,...p):console.warn(`[main ${h()}]`,u,...p))}error(u,...p){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,u,...p):console.error(`[main ${h()}]`,u,...p))}flush(){}}e.$Fj=l;class v extends f{constructor(u=e.$Bj,p=!0){super(),this.g=p,this.setLevel(u)}trace(u,...p){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...p):console.log(u,...p))}debug(u,...p){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...p):console.log(u,...p))}info(u,...p){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...p):console.log(u,...p))}warn(u,...p){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...p):console.log(u,...p))}error(u,...p){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...p):console.error(u,...p))}flush(){}}e.$Gj=v;class i extends f{constructor(u,p=e.$Bj){super(),this.g=u,this.setLevel(p)}trace(u,...p){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(u),...p])}debug(u,...p){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(u),...p])}info(u,...p){this.f(b.Info)&&this.g.log(b.Info,[this.h(u),...p])}warn(u,...p){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(u),...p])}error(u,...p){this.f(b.Error)&&this.g.log(b.Error,[this.h(u),...p])}h(u){return typeof u=="string"?u:(0,O.$2i)(u,this.f(b.Trace))}flush(){}}e.$Hj=i;class o extends f{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const p of this.g)p.setLevel(u);super.setLevel(u)}trace(u,...p){for(const P of this.g)P.trace(u,...p)}debug(u,...p){for(const P of this.g)P.debug(u,...p)}info(u,...p){for(const P of this.g)P.info(u,...p)}warn(u,...p){for(const P of this.g)P.warn(u,...p)}error(u,...p){for(const P of this.g)P.error(u,...p)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose();super.dispose()}}e.$Ij=o;class n extends L.$Tc{constructor(u,p,P){if(super(),this.h=u,this.j=p,this.b=new I.$Ac,this.c=this.B(new A.$5d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$5d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$5d),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}m(u){return(0,g.$Sf)(u)?[...this.b.values()].find(p=>p.info.id===u):this.b.get(u)}getLogger(u){return this.m(u)?.logger}createLogger(u,p){const P=this.n(u),N=(0,g.$Sf)(u)?u:p?.id??(0,D.$5i)(P.toString()).toString(16);let F=this.b.get(P)?.logger;const M=p?.logLevel==="always"?b.Trace:p?.logLevel;F||(F=this.s(P,M??this.getLogLevel(P)??this.h,{...p,id:N}));const z={logger:F,info:{resource:P,id:N,logLevel:M,name:p?.name,hidden:p?.hidden,extensionId:p?.extensionId,when:p?.when}};return this.registerLogger(z.info),this.b.set(P,z),F}n(u){return(0,g.$Sf)(u)?(0,k.$Rg)(this.j,`${u}.log`):u}setLogLevel(u,p){if(C.URI.isUri(u)){const P=u,N=p,F=this.b.get(P);F&&N!==F.info.logLevel&&(F.info.logLevel=N===this.h?void 0:N,F.logger?.setLevel(N),this.b.set(F.info.resource,F),this.f.fire([P,N]))}else{this.h=u;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,p){const P=this.m(u);P&&p!==!P.info.hidden&&(P.info.hidden=!p,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,p]))}getLogLevel(u){let p;return u&&(p=this.b.get(u)?.info.logLevel),p??this.h}registerLogger(u){const p=this.b.get(u.resource);p?p.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const p=this.b.get(u);p&&(p.logger&&p.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[p.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Jj=n;class s{constructor(){this.onDidChangeLogLevel=new A.$5d().event}setLevel(u){}getLevel(){return b.Info}trace(u,...p){}debug(u,...p){}info(u,...p){}warn(u,...p){}error(u,...p){}critical(u,...p){}dispose(){}flush(){}}e.$Kj=s;class t extends s{}e.$Lj=t;function r(w){if(w.verbose)return b.Trace;if(typeof w.logLevel=="string"){const u=E(w.logLevel.toLowerCase());if(u!==void 0)return u}return e.$Bj}e.$Mj=r;function a(w){switch(w){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.$Nj=a;function E(w){switch(w){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$Oj=E,e.$Pj=new S.$vj("logLevel",a(b.Info))}),define(le[198],he([0,1,6,7,2,23,16,20,31,15,8]),function(se,e,O,A,D,L,I,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=void 0;let S=class extends D.$Tc{constructor(h,$){super(),this.a=h,this.b=$,this.B(new O.$qh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const h=(0,R.$Og)(this.a.logsHome),$=(0,R.$Qg)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,c=(await k.Promises.readdir($)).filter(d=>/^\d{8}T\d{6}$/.test(d)).sort().filter(d=>d!==h),f=c.slice(0,Math.max(0,c.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(d=>k.Promises.rm((0,I.$jc)($,d)))))}catch(h){(0,A.$1)(h)}}};e.$Sac=S,e.$Sac=S=ye([K(0,g.$li),K(1,C.$yj)],S)}),define(le[99],he([0,1,7,4,8]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0,e.$Qp=(0,A.$ei)("IExtensionSignatureVerificationService");let L=class{constructor(R){this.b=R}c(){return this.a||(this.a=new Promise((R,k)=>se(["node-vsce-sign"],async g=>R(g),k))),this.a}async verify(R,k,g){let C;try{C=await this.c()}catch(S){return this.b.error("Could not load vsce-sign module",(0,O.$0)(S)),!1}return C.verify(R,k,g)}};e.$Rp=L,e.$Rp=L=ye([K(0,D.$yj)],L)}),define(le[199],he([0,1,17,6,7,3,2,16,50,8]),function(se,e,O,A,D,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=void 0;class C extends I.$Tc{constructor(m,h){super(),this.a=m,this.b=h,this.c=this.B(new L.$5d),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$5d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$ch(0)),this.w=[],this.y=this.B(new A.$ch(0))}watch(m,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n(m,h):this.z(m,h)}n(m,h){const $={path:this.H(m),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},b=(0,O.$Ub)(this.j,$);return this.r(),(0,I.$Rc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,D.$1)(m))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,k.$sq)(h)),h=>this.G(h),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const h of this.j)(0,k.$oq)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const h of this.j)(0,k.$oq)(h)&&m.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,h){const $={path:this.H(m),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},b=(0,O.$Ub)(this.w,$);return this.C(),(0,I.$Rc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,D.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,k.$sq)(m)),m=>this.G(m),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,R.$hc)(m.fsPath)}}e.$wq=C}),define(le[200],he([0,1,17,6,14,26,3,53,61,2,48,23,100,20,47,159,11,98,8,7]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;let v=class extends g.$Tc{static{l=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new I.$5d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$5d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$5d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new I.$5d),this.onDidRunOperation=this.r.event,this.X=this.B(new I.$5d),this.Y=this.B(new I.$5d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new I.$5d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$nh)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const s=new g.$Sc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new y.$Uk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,g.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,g.$Oc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await A.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return k.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,h.$Vg)(o))throw new y.$Wk((0,b.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new d.$bb;throw s.message=(0,b.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,y.$Hk)(n)||(0,y.$Ek)(n)||(0,y.$Ik)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,y.$Hk)(n)||(0,y.$Ek)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,y.$Rk)(s)===y.FileSystemProviderErrorCode.FileNotFound?new y.$Wk((0,b.localize)(2,null,this.sb(o)),1):(0,y.$Pk)(s)}}async s(o,n){const s=await this.j(o),t=this.S(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,E=n?.resolveMetadata,w=await s.stat(o);let u;return this.t(s,o,w,void 0,!!E,(p,P)=>(u||(u=C.$ki.forUris(()=>!t),u.set(o,!0),r&&u.fill(!0,r)),u.get(p.resource)||u.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&a?P===1:!1))}async t(o,n,s,t,r,a){const{providerExtUri:E}=this.R(o),w={resource:n,name:E.basename(n),isFile:(s.type&y.FileType.File)!==0,isDirectory:(s.type&y.FileType.Directory)!==0,isSymbolicLink:(s.type&y.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&y.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&y.FilePermission.Locked),etag:(0,y.$8k)({mtime:s.mtime,size:s.size}),children:void 0};if(w.isDirectory&&a(w,t)){try{const u=await o.readdir(n),p=await A.Promises.settled(u.map(async([P,N])=>{try{const F=E.joinPath(n,P),M=r?await o.stat(F):{type:N};return await this.t(o,F,M,u.length,r,a)}catch(F){return this.b.trace(F),null}}));w.children=(0,O.$Hb)(p)}catch(u){this.b.trace(u),w.children=[]}return w}return w}async resolveAll(o){return A.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new y.$Wk((0,b.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=D.$se.fromString(""),s){await this.u(o,s);const t=await this.writeFile(o,n);return this.r.fire(new y.$Tk(o,0,t)),t}async writeFile(o,n,s){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=s;if((0,y.$Kk)(t)&&!a?.atomic){const E=t.enforceAtomicWriteFile?.(o);E&&(a={...s,atomic:E})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let w;if((0,y.$Ek)(t)&&!(n instanceof D.$se))if((0,$.$ee)(n)){const u=await(0,$.$le)(n,3);u.ended?w=D.$se.concat(u.buffer):w=u}else w=(0,$.$ie)(n,u=>D.$se.concat(u),3);else w=n;!(0,y.$Hk)(t)||(0,y.$Ek)(t)&&w instanceof D.$se||(0,y.$Ek)(t)&&(0,y.$Kk)(t)&&a?.atomic?await this.hb(t,o,a,w):await this.db(t,o,a,w instanceof D.$se?(0,D.$De)(w):w),this.r.fire(new y.$Tk(o,4))}catch(E){throw new y.$Wk((0,b.localize)(4,null,this.sb(o),(0,y.$Pk)(E).toString()),(0,y.$Sk)(E),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,b.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,b.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,b.localize)(7,null,this.sb(n)));if(t)throw new Error((0,b.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&y.FileType.Directory)throw new y.$Wk((0,b.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==y.$7k&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,y.$8k)({mtime:s.mtime,size:a.size}))throw new y.$Wk((0,b.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.m(o);return n?.atomic?this.z(t,o,n,s):this.C(t,o,n,s)}async z(o,n,s,t){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const E=await this.C(o,n,s,t);r(E)}catch(E){a(E)}},this.R(o).providerExtUri)})}async C(o,n,s,t){const r=await this.D(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,D.$Ee)(r.value)}}async readFileStream(o,n,s){const t=await this.m(o);return this.D(t,o,n,s)}async D(o,n,s,t){const r=new L.$ce(t);let a=s;(0,y.$Jk)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const E=this.J(n,a).then(u=>u,u=>{throw r.dispose(!0),u});let w;try{return typeof a?.etag=="string"&&a.etag!==y.$7k&&await E,a?.atomic&&(0,y.$Jk)(o)||!((0,y.$Hk)(o)||(0,y.$Ik)(o))||(0,y.$Ek)(o)&&a?.preferUnbuffered?w=this.I(o,n,a):(0,y.$Ik)(o)?w=this.G(o,n,r.token,a):w=this.H(o,n,r.token,a),w.on("end",()=>r.dispose()),w.on("error",()=>r.dispose()),{...await E,value:w}}catch(u){throw w&&await(0,$.$je)(w),this.F(u,n,a)}}F(o,n,s){const t=(0,b.localize)(11,null,this.sb(n),(0,y.$Pk)(o).toString());return o instanceof y.$Yk?new y.$Yk(t,o.stat,s):o instanceof y.$Xk?new y.$Xk(t,o.fileOperationResult,o.size,o.options):new y.$Wk(t,(0,y.$Sk)(o),s)}G(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,$.$pe)(r,{data:a=>a instanceof D.$se?a:D.$se.wrap(a),error:a=>this.F(a,n,t)},a=>D.$se.concat(a))}H(o,n,s,t=Object.create(null)){const r=(0,D.$Ie)();return(0,c.$mq)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},s),r}I(o,n,s){const t=(0,$.$ge)(r=>D.$se.concat(r));return(async()=>{try{let r;s?.atomic&&(0,y.$Jk)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.L(n,r.byteLength,s),t.end(D.$se.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new y.$Wk((0,b.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==y.$7k&&n.etag===s.etag)throw new y.$Yk((0,b.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new y.$Xk((0,b.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!s),E=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new y.$Tk(o,a==="move"?2:3,E)),E}async copy(o,n,s){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!s),E=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new y.$Tk(o,a==="copy"?3:2,E)),E}async N(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:E,isSameResourceWithDifferentPathCase:w}=await this.Q(o,n,s,t,r,a);if(E&&!w&&a&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,y.$Fk)(o))await o.copy(n,t,{overwrite:a});else{const u=await this.resolve(n);u.isDirectory?await this.P(o,u,s,t):await this.O(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,t){if((0,y.$Hk)(o)&&(0,y.$Hk)(s))return this.jb(o,n,s,t);if((0,y.$Hk)(o)&&(0,y.$Ek)(s))return this.pb(o,n,s,t);if((0,y.$Ek)(o)&&(0,y.$Hk)(s))return this.nb(o,n,s,t);if((0,y.$Ek)(o)&&(0,y.$Ek)(s))return this.lb(o,n,s,t)}async P(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await A.Promises.settled(n.children.map(async r=>{const a=this.R(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),s,a):this.O(o,r.resource,s,a)}))}async Q(o,n,s,t,r,a){let E=!1;if(o===s){const{providerExtUri:u,isPathCaseSensitive:p}=this.R(o);if(p||(E=u.isEqual(n,t)),E&&r==="copy")throw new Error((0,b.localize)(15,null,this.sb(n),this.sb(t)));if(!E&&u.isEqualOrParent(t,n))throw new Error((0,b.localize)(16,null,this.sb(n),this.sb(t)))}const w=await this.exists(t);if(w&&!E){if(!a)throw new y.$Wk((0,b.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===s){const{providerExtUri:u}=this.R(o);if(u.isEqualOrParent(n,t))throw new Error((0,b.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:w,isSameResourceWithDifferentPathCase:E}}R(o){const n=this.S(o);return{providerExtUri:n?h.$Hg:h.$Jg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new y.$Tk(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&y.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(n)));break}catch(r){if((0,y.$Rk)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,y.$Rk)(a)!==y.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,b.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,b.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,b.localize)(22,null,this.sb(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.rb(o,a);else throw new y.$Wk((0,b.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const w=await this.resolve(o);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let t=n;if((0,y.$Lk)(s)&&!t?.atomic){const w=s.enforceAtomicDelete?.(o);w&&(t={...n,atomic:w})}const r=!!t?.useTrash,a=!!t?.recursive,E=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:E}),this.r.fire(new y.$Tk(o,1))}async cloneFile(o,n){const s=await this.j(o),t=this.qb(await this.n(n),n);if(!(s===t&&this.R(s).providerExtUri.isEqual(o,n)))return s===t&&(0,y.$Gk)(s)?s.cloneFile(o,n):(await this.U(t,this.R(t).providerExtUri.dirname(n)),s===t&&(0,y.$Fk)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,t,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:l.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new g.$Sc;let t=!1,r=()=>{t=!0};s.add((0,g.$Rc)(()=>r())),(async()=>{try{const E=await this.bb(o,n);t?(0,g.$Oc)(E):r=()=>(0,g.$Oc)(E)}catch(E){this.b.error(E)}})();const a=n.correlationId;if(typeof a=="number"){const E=s.add(new I.$5d);return s.add(this.X.event(u=>{u.correlates(a)&&E.fire(u)})),{onDidChange:E.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),t=(0,R.$5i)([this.R(s).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,g.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Oc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,g.$Oc)(o.disposable);this.$.clear()}async db(o,n,s,t){return this.cb.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,$.$ee)(t)||(0,$.$fe)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,y.$Pk)(a)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,n,s){let t=0,r;if((0,$.$fe)(s)){if(s.buffer.length>0){const a=D.$se.concat(s.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,E)=>{(0,$.$ke)(r,{onData:async w=>{r.pause();try{await this.gb(o,n,w,w.byteLength,t,0)}catch(u){return E(u)}t+=w.byteLength,setTimeout(()=>r.resume())},onError:w=>E(w),onEnd:()=>a()})})}async fb(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,s,t,r,a){let E=0;for(;E<t;){const w=await o.write(n,r+E,s.buffer,a+E,t-E);E+=w}}async hb(o,n,s,t){return this.cb.queueFor(n,()=>this.ib(o,n,s,t),this.R(o).providerExtUri)}async ib(o,n,s,t){let r;t instanceof D.$se?r=t:(0,$.$ee)(t)?r=await(0,D.$Ee)(t):(0,$.$fe)(t)?r=await(0,D.$Fe)(t):r=(0,D.$Ce)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,t){return this.cb.queueFor(t,()=>this.kb(o,n,s,t),this.R(s).providerExtUri)}async kb(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const E=D.$se.alloc(this.a);let w=0,u=0,p=0;do p=await o.read(r,w,E.buffer,u,E.byteLength-u),await this.gb(s,a,E,p,w,u),w+=p,u+=p,u===E.byteLength&&(u=0);while(p>0)}catch(E){throw(0,y.$Pk)(E)}finally{await A.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(o,n,s,t){return this.cb.queueFor(t,()=>this.mb(o,n,s,t),this.R(s).providerExtUri)}async mb(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,t){return this.cb.queueFor(t,()=>this.ob(o,n,s,t),this.R(s).providerExtUri)}async ob(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(s,r,D.$se.wrap(a),a.byteLength,0,0)}catch(a){throw(0,y.$Pk)(a)}finally{await s.close(r)}}async pb(o,n,s,t){const r=await(0,D.$Ee)(this.H(o,n,L.CancellationToken.None));await this.hb(s,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new y.$Wk((0,b.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&y.FilePermission.Readonly)throw new y.$Wk((0,b.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===S.Schemas.file?o.fsPath:o.toString(!0)}};e.$nq=v,e.$nq=v=l=ye([K(0,f.$yj)],v)}),define(le[201],he([0,1,54,270,6,35,14,3,49,2,16,5,20,47,31,162,11,98,199,38,195,194]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0,(()=>{try{(0,A.gracefulify)(O)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.$2i)(o)}`)}})();class i extends f.$wq{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.N=new L.$Ac(t=>m.$Ig.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,S.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:t}=await $.SymlinkSupport.stat(this.H(n));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:y.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await $.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,m.$Rg)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.fb(s)}}M(n,s){let t;return s?.dangling?t=y.FileType.Unknown:n.isFile()?t=y.FileType.File:n.isDirectory()?t=y.FileType.Directory:t=y.FileType.Unknown,s&&(t|=y.FileType.SymbolicLink),t}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new D.$dh;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,g.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await $.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){i.I&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,h.$ge)(a=>I.$se.concat(a.map(E=>I.$se.wrap(E))).buffer);return(0,c.$mq)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,m.$Rg)((0,m.$Qg)(n),`${(0,m.$Og)(n)}${t.atomic.postfix}`),s,t):this.S(n,s,t)}async Q(n){try{const s=this.H(n),{symbolicLink:t}=await $.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async R(n,s,t,r){const a=new g.$Sc;try{a.add(await this.O(n)),a.add(await this.O(s)),await this.S(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(E){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{a.dispose()}}async S(n,s,t,r){let a;try{const E=this.H(n);if(!t.create||!t.overwrite){if(await $.Promises.exists(E)){if(!t.overwrite)throw(0,y.$Ok)((0,b.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,y.$Ok)((0,b.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(E){throw await this.gb(n,E)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){i.Y=n}async open(n,s,t){const r=this.H(n);let a;(0,y.$Ck)(s)&&!t&&(a=await this.O(n));let E;try{if((0,y.$Ck)(s)&&s.unlock)try{const{stat:u}=await $.SymlinkSupport.stat(r);u.mode&128||await $.Promises.chmod(r,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let w;if((0,y.$Ck)(s)){if(S.$i)try{await $.Promises.truncate(r,0),w="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}w||(w="w")}else w="r";E=await $.Promises.open(r,w)}catch(w){throw a?.dispose(),(0,y.$Ck)(s)?await this.gb(n,w):this.fb(w)}if(this.U.set(E,0),(0,y.$Ck)(s)&&this.X.set(E,n),a){const w=this.W.get(E);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${r})`),this.W.set(E,a),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${r})`),w.dispose())}return E}async close(n){const s=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&i.Y)try{await $.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await $.Promises.close(n)}catch(t){throw this.fb(t)}finally{s&&(this.W.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const E=this.Z(n,s);let w=null;try{w=(await $.Promises.read(n,t,r,a,E)).bytesRead}catch(u){throw this.fb(u)}finally{this.$(n,E,w)}return w}Z(n,s){return s===this.U.get(n)?null:s}$(n,s,t){const r=this.U.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,s,t,r,a){return(0,D.$yh)(()=>this.ab(n,s,t,r,a),100,3)}async ab(n,s,t,r,a){const E=this.Z(n,s);let w=null;try{w=(await $.Promises.write(n,t,r,a,E)).bytesWritten}catch(u){throw await this.gb(this.X.get(n),u)}finally{this.$(n,E,w)}return w}async mkdir(n){try{await $.Promises.mkdir(this.H(n))}catch(s){throw this.fb(s)}}async delete(n,s){try{const t=this.H(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,C.$jc)((0,C.$mc)(t),`${(0,C.$nc)(t)}${s.atomic.postfix}`)),await $.Promises.rm(t,$.RimRafMode.MOVE,r)}else try{await $.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:E,symbolicLink:w}=await $.SymlinkSupport.stat(t);a=E.isDirectory()&&!w}catch{}if(a)await $.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"move",t.overwrite),await $.Promises.rename(r,a)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,b.localize)(2,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),E.toString()))),this.fb(E)}}async copy(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"copy",t.overwrite),await $.Promises.copy(r,a,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,b.localize)(3,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),E.toString()))),this.fb(E)}}async bb(n,s,t,r){const a=this.H(n),E=this.H(s);let w=!1;if(!!(this.capabilities&1024)||(w=(0,k.$eg)(a,E,!0)),w){if(t==="copy")throw(0,y.$Ok)((0,b.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const p=await this.L(n);if(!p)throw(0,y.$Ok)((0,b.localize)(5,null),y.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(s);if(P){if(!r)throw(0,y.$Ok)((0,b.localize)(6,null),y.FileSystemProviderErrorCode.FileExists);p.type&y.FileType.File&&P.type&y.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.cb(n,s,!1)}async cb(n,s,t){const r=this.H(n),a=this.H(s),E=!!(this.capabilities&1024);if((0,k.$eg)(r,a,!E))return;const w=new g.$Sc;try{w.add(await this.O(n)),w.add(await this.O(s)),t&&await $.Promises.mkdir((0,C.$mc)(a),{recursive:!0}),await $.Promises.copyFile(r,a)}catch(u){if(u.code==="ENOENT"&&!t)return this.cb(n,s,!0);throw this.fb(u)}finally{w.dispose()}}t(n,s,t){return new l.$Dq(r=>n(r),r=>s(r),t)}F(n,s,t){return new v.$Lq(r=>n(r),r=>s(r),t)}fb(n){if(n instanceof y.$Nk)return n;let s=n,t;switch(n.code){case"ENOENT":t=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=y.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=y.FileSystemProviderErrorCode.Unknown;break;default:t=y.FileSystemProviderErrorCode.Unknown}return(0,y.$Ok)(s,t)}async gb(n,s){let t=this.fb(s);if(n&&t.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,y.$Ok)(s,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$Mq=i}),define(le[101],he([0,1,3,2,4,8]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=e.$fbc=void 0,e.$fbc=(0,D.$ei)("sharedProcessLifecycleService");let I=class extends A.$Tc{constructor(k){super(),this.b=k,this.a=this.B(new O.$5d),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$gbc=I,e.$gbc=I=ye([K(0,L.$yj)],I)}),define(le[202],he([0,1,10,3,8,2]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=e.$Lr=void 0;class I extends D.$Jj{constructor(S,m,h,$,b){super(m,h,$),this.r=S,this.t=b,this.B(b.listen("onDidChangeLogLevel",S)(y=>{(0,D.$Aj)(y)?super.setLogLevel(y):super.setLogLevel(O.URI.revive(y[0]),y[1])})),this.B(b.listen("onDidChangeVisibility",S)(([y,c])=>super.setVisibility(O.URI.revive(y),c))),this.B(b.listen("onDidChangeLoggers",S)(({added:y,removed:c})=>{for(const f of y)super.registerLogger({...f,resource:O.URI.revive(f.resource)});for(const f of c)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new D.$Hj({log:(S,m)=>{this.t.call("consoleLog",[S,m])}})}registerLogger(S){super.registerLogger(S),this.t.call("registerLogger",[S,this.r])}deregisterLogger(S){super.deregisterLogger(S),this.t.call("deregisterLogger",[S,this.r])}setLogLevel(S,m){super.setLogLevel(S,m),this.t.call("setLogLevel",[S,m])}setVisibility(S,m){super.setVisibility(S,m),this.t.call("setVisibility",[this.n(S),m])}s(S,m,h){return new R(this.t,S,m,h,this.r)}static setLogLevel(S,m,h){return S.call("setLogLevel",[m,h])}}e.$Lr=I;class R extends D.$Ej{constructor(S,m,h,$,b){super($?.logLevel==="always"),this.r=S,this.s=m,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[m,$,b]).then(()=>{this.u(this.n),this.m=!0})}g(S,m){const h=[[S,m]];this.m?this.u(h):this.n.push(...h)}u(S){this.r.call("log",[this.s,S])}}class k{constructor(S,m){this.a=S,this.b=m}listen(S,m){const h=this.b(S);switch(m){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(b=>this.c(b,h)),removed:[...$.removed].map(b=>this.c(b,h))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,$=>[h.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,$=>(0,D.$Aj)($)?$:[h.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${m}`)}async call(S,m,h){const $=this.b(S);switch(m){case"setLogLevel":return(0,D.$Aj)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(O.URI.revive($.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,$)))}throw new Error(`Call not found: ${m}`)}c(S,m){return{...S,resource:m.transformOutgoingURI(S.resource)}}}e.$Mr=k;class g extends L.$Tc{constructor(S,m){super(),m.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(h=>m.call("setLogLevel",[h]))),m.call("getRegisteredLoggers").then(h=>{for(const $ of h)S.registerLogger({...$,resource:O.URI.revive($.resource)})}),this.B(m.listen("onDidChangeVisibility")(([h,$])=>S.setVisibility(O.URI.revive(h),$))),this.B(m.listen("onDidChangeLoggers")(({added:h,removed:$})=>{for(const b of h)S.registerLogger({...b,resource:O.URI.revive(b.resource)});for(const b of $)S.deregisterLogger(b.resource)}))}}e.$Nr=g}),define(le[203],he([0,1,2,8]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=void 0;class D extends O.$Tc{constructor(I,R=[]){super(),this.a=new A.$Ij([I,...R]),this.B(I.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...R){this.a.trace(I,...R)}debug(I,...R){this.a.debug(I,...R)}info(I,...R){this.a.info(I,...R)}warn(I,...R){this.a.warn(I,...R)}error(I,...R){this.a.error(I,...R)}flush(){this.a.flush()}}e.$AP=D}),define(le[57],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b_b=void 0,e.$b_b=(0,O.$ei)("nativeHostService")}),define(le[204],he([0,1,40,56]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=void 0;let D=class{constructor(I,R){return this.windowId=I,O.ProxyChannel.toService(R.getChannel("nativeHost"),{context:I,properties:(()=>{const k=new Map;return k.set("windowId",I),k})()})}};e.$wac=D,e.$wac=D=ye([K(1,A.$qac)],D)}),define(le[58],he([0,1,3,61,2,4]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=e.$Wn=e.$Vn=void 0,e.$Vn=(0,L.$ei)("policy");class I extends D.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$5d),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const C=Object.keys(this.f).length;return this.f={...g,...this.f},C!==Object.keys(this.f).length&&await this.j(g),A.Iterable.reduce(this.g.entries(),(S,[m,h])=>({...S,[m]:h}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(g,[C,S])=>({...g,[C]:{definition:S,value:this.g.get(C)}}),{})}}e.$Wn=I;class R{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Xn=R}),define(le[205],he([0,1,3,2,58]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=e.$Y_b=void 0;class L{constructor(k){this.b=k,this.a=new A.$Sc}listen(k,g){switch(g){case"onDidChange":return O.Event.map(this.b.onDidChange,C=>C.reduce((S,m)=>({...S,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(k,g,C){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$Y_b=L;class I extends D.$Wn{constructor(k,g){super(),this.a=g;for(const C in k){const{definition:S,value:m}=k[C];this.f[C]=S,m!==void 0&&this.g.set(C,m)}this.a.listen("onDidChange")(C=>{for(const S in C){const m=C[S];m===null?this.g.delete(S):this.g.set(S,m)}this.h.fire(Object.keys(C))})}async j(k){const g=await this.a.call("updatePolicyDefinitions",k);for(const C in g)this.g.set(C,g[C])}}e.$Z_b=I}),define(le[102],he([0,1,37]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.context<"u"){const L=D.context.configuration();if(L)A=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:L.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(le[24],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=void 0,e.$Qj=(0,O.$ei)("productService"),e.$Rj="vscode://schemas/vscode-product"}),define(le[206],he([0,1,6,7,2,16,31,8,24]),function(se,e,O,A,D,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=void 0;let g=class extends D.$Tc{constructor(S,m,h){super(),this.b=m,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this.B(new O.$qh(()=>{this.f(S)},3e4)).schedule()}async f(S){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),h=(0,L.$mc)(S),$=(0,L.$nc)(S),b=await I.Promises.readdir(h);await Promise.all(b.map(async y=>{if(y===$)return;const c=(0,L.$jc)(h,y),f=await I.Promises.stat(c);if(f.isDirectory()&&m-f.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),I.Promises.rm(c)}))}catch(m){(0,A.$1)(m)}}};e.$Pac=g,e.$Pac=g=ye([K(1,k.$Qj),K(2,R.$yj)],g)}),define(le[207],he([0,1,6,7,2,16,31,15,8,24]),function(se,e,O,A,D,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=void 0;let C=class extends D.$Tc{constructor(m,h,$){super(),this.b=m,this.c=h,this.f=$,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new O.$qh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),h=JSON.parse(await I.Promises.readFile((0,L.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(h)){const d=h[f];m[`${d.hash}.${f}`]=!0}const $=(0,L.$jc)(this.b.userDataPath,"clp");if(!await I.Promises.exists($))return;const y=await I.Promises.readdir($);for(const f of y){if(m[f]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await I.Promises.rm((0,L.$jc)($,f))}const c=Date.now();for(const f of Object.keys(m)){const d=(0,L.$jc)($,f),l=await I.Promises.readdir(d);for(const v of l){if(v==="tcf.json")continue;const i=(0,L.$jc)(d,v),o=await I.Promises.stat(i);o.isDirectory()&&c-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.$jc)(f,v)}`),await I.Promises.rm(i))}}}catch(m){(0,A.$1)(m)}}};e.$Qac=C,e.$Qac=C=ye([K(0,R.$mi),K(1,k.$yj),K(2,g.$Qj)],C)}),define(le[208],he([0,1,16,4]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$BF=void 0,e.$BF=(0,A.$ei)("IV8InspectProfilingService");var D;(function(L){function I(k){return!!(k.samples&&k.timeDeltas)}L.isValidProfile=I;function R(k,g="noAbsolutePaths"){for(const C of k.nodes)C.callFrame&&C.callFrame.url&&((0,O.$ic)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,O.$jc)(g,(0,O.$nc)(C.callFrame.url)));return k}L.rewriteAbsolutePaths=R})(D||(e.Utils=D={}))}),define(le[209],he([0,1,32]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=void 0;class A{constructor(){this.a=new Map}async startProfiling(L){const R=await(await new Promise((g,C)=>{se(["v8-inspect-profiler"],g,C)})).startProfiling({port:L.port,checkForPaused:!0}),k=(0,O.$Ag)();return this.a.set(k,R),k}async stopProfiling(L){const I=this.a.get(L);if(!I)throw new Error(`UNKNOWN session '${L}'`);const R=await I.stop();return this.a.delete(L),R.profile}}e.$8ac=A}),define(le[41],he([0,1,127,12]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=void 0;class D{constructor(){this.a=new Map}add(I,R){O.ok(A.$Sf(I)),O.ok(A.$Uf(R)),O.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,R)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$Tn=new D}),define(le[103],he([0,1,3,41]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=void 0,e.$Un={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this.b=new O.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,g){this.a[D(k)]=g,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const I=new L;A.$Tn.add(e.$Un.JSONContribution,I)}),define(le[44],he([0,1,17,3,12,149,21,103,41]),function(se,e,O,A,D,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ConfigurationScope=e.$Yn=e.EditPresentationTypes=void 0;var g;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$Yn={Configuration:"base.contributions.configuration"};var C;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$Zn={properties:{},patternProperties:{}},e.$1n={properties:{},patternProperties:{}},e.$2n={properties:{},patternProperties:{}},e.$3n={properties:{},patternProperties:{}},e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n="vscode://schemas/settings/resourceLanguage",e.$7n="vscode://schemas/settings/configurationDefaults";const S=k.$Tn.as(R.$Un.JSONContribution);class m{constructor(){this.h=new Set,this.i=new A.$5d,this.onDidSchemaChange=this.i.event,this.j=new A.$5d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$6n,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),S.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),S.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),S.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.$9n.test(r)){const a=this.a.get(r),E=a?.valuesSources??new Map;if(t)for(const P of Object.keys(s[r]))E.set(P,t);const w={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:w,valuesSources:E});const u=(0,I.$Ui)(r),p={type:"object",default:w,description:L.localize(1,null,u),$ref:e.$6n,defaultDefaultValue:w,source:D.$Sf(t)?void 0:t,defaultValueSource:t};n.push(...b(r)),this.d[r]=p,this.b.properties[r]=p}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=D.$Sf(s)?s:s?.id,E=D.$Sf(r?.source)?r?.source:r?.source?.id;if(a===E)if(o.add(t),this.a.delete(t),e.$9n.test(t))delete this.d[t],delete this.b.properties[t];else{const w=this.d[t];w&&(this.w(t,w),this.r(t,w))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,n,s,t=3,r){t=D.$2f(i.scope)?t:i.scope;const a=i.properties;if(a)for(const w in a){const u=a[w];if(o&&d(w,u)){delete a[w];continue}if(u.source=n,u.defaultDefaultValue=a[w].default,this.w(w,u),e.$9n.test(w)?u.scope=void 0:(u.scope=D.$2f(u.scope)?t:u.scope,u.restricted=D.$2f(u.restricted)?!!s?.includes(w):u.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.f[w]=a[w],delete a[w];continue}else this.d[w]=a[w],a[w].policy?.name&&this.e.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),r.add(w)}const E=i.allOf;if(E)for(const w of E)this.p(w,o,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$Zn.properties[i]=o,o.scope){case 1:e.$1n.properties[i]=o;break;case 2:e.$2n.properties[i]=o;break;case 6:e.$3n.properties[i]=o;break;case 3:e.$4n.properties[i]=o;break;case 4:e.$5n.properties[i]=o;break;case 5:e.$5n.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$Zn.properties[i],o.scope){case 1:delete e.$1n.properties[i];break;case 2:delete e.$2n.properties[i];break;case 6:delete e.$3n.properties[i];break;case 3:delete e.$4n.properties[i];break;case 4:case 5:delete e.$5n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$6n};this.w(o,n),e.$Zn.properties[o]=n,e.$1n.properties[o]=n,e.$2n.properties[o]=n,e.$3n.properties[o]=n,e.$4n.properties[o]=n,e.$5n.properties[o]=n}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$6n};e.$Zn.patternProperties[e.$8n]=i,e.$1n.patternProperties[e.$8n]=i,e.$2n.patternProperties[e.$8n]=i,e.$3n.patternProperties[e.$8n]=i,e.$4n.patternProperties[e.$8n]=i,e.$5n.patternProperties[e.$8n]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let s=n?.value,t=n?.source;D.$Zf(s)&&(s=o.defaultDefaultValue,t=void 0),D.$Zf(s)&&(s=c(o.type)),o.default=s,o.defaultValueSource=t}}const h="\\[([^\\]]+)\\]",$=new RegExp(h,"g");e.$8n=`^(${h})+$`,e.$9n=new RegExp(e.$8n);function b(v){const i=[];if(e.$9n.test(v)){let o=$.exec(v);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=$.exec(v)}}return(0,O.$Mb)(i)}e.$0n=b;function y(v){return v.reduce((i,o)=>`${i}[${o}]`,"")}e.$$n=y;function c(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$_n=c;const f=new m;k.$Tn.add(e.$Yn.Configuration,f);function d(v,i){return v.trim()?e.$9n.test(v)?L.localize(7,null,v):f.getConfigurationProperties()[v]!==void 0?L.localize(8,null,v):i.policy?.name&&f.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,v,i.policy?.name,f.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$ao=d;function l(){const v=[],i=f.getConfigurationProperties();for(const o of Object.keys(i))v.push([o,i[o].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$bo=l}),define(le[76],he([0,1,17,3,34,2,35,30,12,10,21,44,41]),function(se,e,O,A,D,L,I,R,k,g,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=void 0;function h(o){return Object.isFrozen(o)?o:R.$In(o)}class ${constructor(n={},s=[],t=[],r){this.b=n,this.c=s,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof $)return s;const t=new b("");return t.parseRaw(s),t.configurationModel});this.f=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$Si)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return h(t.rawConfiguration.getValue(n))},get override(){return s?h(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return h(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:E,keys:w}of t.rawConfiguration.overrides){const u=new $(a,w).getValue(n);u!==void 0&&r.push({identifiers:E,value:u})}return r.length?h(r):void 0}}}getOverrideValue(n,s){const t=this.i(s);return t?n?(0,C.$Si)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return O.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return O.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=R.$Hn(this.contents),t=R.$Hn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const E of n)if(a.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(s,E.contents);for(const w of E.overrides){const[u]=t.filter(p=>O.$ub(p.identifiers,w.identifiers));u?(this.h(u.contents,w.contents),u.keys.push(...w.keys),u.keys=O.$Mb(u.keys)):t.push(R.$Hn(w))}for(const w of E.keys)r.indexOf(w)===-1&&r.push(w)}return new $(s,r,t,a.every(E=>E instanceof $)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of O.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const E=s[r];E&&(typeof a=="object"&&typeof E=="object"?(a=R.$Hn(a),this.h(a,E)):a=E),t[r]=a}return new $(t,this.keys,this.overrides)}h(n,s){for(const t of Object.keys(s)){if(t in n&&k.$Uf(n[t])&&k.$Uf(s[t])){this.h(n[t],s[t]);continue}n[t]=R.$Hn(s[t])}}i(n){let s=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$Hn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,C.$Ri)(this.contents,n),S.$9n.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>O.$ub(t.identifiers,(0,S.$0n)(n))),1))}j(n,s,t){(0,C.$Qi)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),S.$9n.test(n)&&this.overrides.push({identifiers:(0,S.$0n)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$Pi)(this.contents[n],r=>console.error(r))})}}e.$co=$;class b{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!k.$2f(n)){const t=this.g(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:E,hasExcludedProperties:w}=this.h(n,s);this.b=new $(t,r,a,w?[n]:void 0),this.c=E||[]}g(n){let s={},t=null,r=[];const a=[],E=[];function w(p){Array.isArray(r)?r.push(p):t!==null&&(r[t]=p)}const u={onObjectBegin:()=>{const p={};w(p),a.push(r),r=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const p=[];w(p),a.push(r),r=p,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:w,onError:(p,P,N)=>{E.push({error:p,offset:P,length:N})}};if(n)try{D.$vn(n,u),s=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this.f}: ${p}`),this.d=[p]}return s}h(n,s){const t=m.$Tn.as(S.$Yn.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,s);n=r.raw;const a=(0,C.$Pi)(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),E=Object.keys(n),w=this.j(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:a,keys:E,overrides:w,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const E={},w=[];for(const u in n)if(S.$9n.test(u)&&t){const p=this.i(n[u],s,!1,r);E[u]=p.raw,a=a||p.hasExcludedProperties,w.push(...p.restricted)}else{const p=s[u],P=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&w.push(u),!r.exclude?.includes(u)&&(r.include?.includes(u)||(P===void 0||r.scopes===void 0||r.scopes.includes(P))&&!(r.skipRestricted&&p?.restricted))?E[u]=n[u]:a=!0}return{raw:E,restricted:w,hasExcludedProperties:a}}j(n,s){const t=[];for(const r of Object.keys(n))if(S.$9n.test(r)){const a={};for(const E in n[r])a[E]=n[r][E];t.push({identifiers:(0,S.$0n)(r),keys:Object.keys(a),contents:(0,C.$Pi)(a,s)})}return t}}e.$do=b;class y extends L.$Tc{constructor(n,s,t,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new A.$5d),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$eo=y;class c{constructor(n,s,t,r,a,E,w,u,p,P,N,F,M){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=E,this.g=w,this.h=u,this.i=p,this.j=P,this.k=N,this.l=F,this.m=M}get value(){return h(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(n,s,t,r,a=new $,E=new $,w=new I.$Ac,u=new $,p=new I.$Ac){this.c=n,this.d=s,this.f=t,this.g=r,this.h=a,this.i=E,this.j=w,this.l=u,this.m=p,this.a=null,this.b=new I.$Ac,this.n=null}getValue(n,s,t){return this.p(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new $,this.m.set(t.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.a=null)}inspect(n,s,t){const r=this.p(n,s,t),a=this.t(s.resource,t),E=s.resource?this.m.get(s.resource)||this.l:this.l,w=new Set;for(const u of r.overrides)for(const p of u.identifiers)r.getOverrideValue(n,p)!==void 0&&w.add(p);return new c(n,s,r.getValue(n),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,E)}keys(n){const s=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:E}=v(this.c,n);s=[...r,...a,...E]}for(const r of s)for(const a of(0,S.$0n)(r)){const E=this.c.getKeysForOverrideIdentifier(a),w=n.getKeysForOverrideIdentifier(a),u=[...w.filter(p=>E.indexOf(p)===-1),...E.filter(p=>w.indexOf(p)===-1),...E.filter(p=>!R.$Ln(this.c.override(a).getValue(p),n.override(a).getValue(p)))];t.push([a,u])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=v(this.d,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=v(this.applicationConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateApplicationConfiguration(n),{keys:E,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=v(this.localUserConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateLocalUserConfiguration(n),{keys:E,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=v(this.remoteUserConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateRemoteUserConfiguration(n),{keys:E,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=v(this.workspaceConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateWorkspaceConfiguration(n),{keys:E,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:E,overrides:w}=v(t,s),u=[...r,...a,...E];return(u.length||!t)&&this.updateFolderConfiguration(n,s),{keys:u,overrides:w}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:E}=v(s,void 0);return{keys:[...t,...r,...a],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,s,t){let r=this.q(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},s){let t=this.r();if(s&&n){const r=s.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let s=this.b.get(n);if(!s){const t=this.r(),r=this.j.get(n);r?(s=t.merge(r),this.b.set(n,s)):s=t}return s}t(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),E=this.w(n.workspace),w=n.folders.reduce((u,p)=>(u.set(g.URI.revive(p[0]),this.w(p[1])),u),new I.$Ac);return new f(s,t,r,a,new $,E,w,new $,new I.$Ac)}static w(n){return new $(n.contents,n.keys,n.overrides)}}e.$fo=f;function d(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,E])=>{const w=(0,I.$xc)(s,a,new Set);E.forEach(u=>w.add(u))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$go=d;class l{constructor(n,s,t,r){this.change=n,this.f=s,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const E of a)this.affectedKeys.add(E);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const E=this.d.charCodeAt(a);if(E!==this.b&&E!==this.c)return!1;if(s){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,u=this.g.getValue(n,s,this.h);return!R.$Ln(w,u)}return!0}}e.$ho=l;function v(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],E=o?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const u=w.filter(p=>!E.includes(p));for(const p of u)a.push([p,n.getKeysForOverrideIdentifier(p)])}if(o){const u=E.filter(p=>!w.includes(p));for(const p of u)a.push([p,o.getKeysForOverrideIdentifier(p)])}if(n&&o){for(const u of E)if(w.includes(u)){const p=i({contents:o.getOverrideValue(void 0,u)||{},keys:o.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});a.push([u,[...p.added,...p.removed,...p.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const E=(0,C.$Si)(n.contents,a),w=(0,C.$Si)(o.contents,a);R.$Ln(E,w)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[210],he([0,1,17,3,2,30,12,76,44,8,58,41]),function(se,e,O,A,D,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=void 0;class m extends D.$Tc{constructor(){super(...arguments),this.a=this.B(new A.$5d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$co}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.$Tn.as(k.$Yn.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:c})=>this.c(Array.from(y),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(y,c){this.h(y,S.$Tn.as(k.$Yn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:y})}f(){return{}}g(){this.b=new R.$co;const y=S.$Tn.as(k.$Yn.Configuration).getConfigurationProperties();this.h(Object.keys(y),y)}h(y,c){const f=this.f();for(const d of y){const l=f[d],v=c[d];l!==void 0?this.b.addValue(d,l):v?this.b.addValue(d,v.default):this.b.removeValue(d)}}}e.$io=m;class h{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new R.$co}async initialize(){return this.configurationModel}}e.$jo=h;let $=class extends D.$Tc{get configurationModel(){return this.b}constructor(y,c,f){super(),this.c=y,this.f=c,this.g=f,this.a=this.B(new A.$5d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$co}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(y=>this.j(y))),this.B(this.c.onDidChangeConfiguration(async({properties:y})=>this.m(await this.h(y),!0))),this.b}async h(y){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",y);const c={},f=[],d=S.$Tn.as(k.$Yn.Configuration).getConfigurationProperties();for(const l of y){const v=d[l];if(!v){f.push(l);continue}if(v.policy){if(v.type!=="string"&&v.type!=="number"){this.g.warn(`Policy ${v.policy.name} has unsupported type ${v.type}`);continue}f.push(l),c[v.policy.name]={type:v.type}}}return(0,I.$6f)(c)||await this.f.updatePolicyDefinitions(c),f}j(y){this.g.trace("PolicyConfiguration#onDidChangePolicies",y);const c=S.$Tn.as(k.$Yn.Configuration).getPolicyConfigurations(),f=(0,O.$Hb)(y.map(d=>c.get(d)));this.m(f,!0)}m(y,c){this.g.trace("PolicyConfiguration#update",y);const f=S.$Tn.as(k.$Yn.Configuration).getConfigurationProperties(),d=[],l=this.b.isEmpty();for(const v of y){const i=f[v]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(l?o!==void 0:!(0,L.$Ln)(this.b.getValue(v),o))&&d.push([v,o])}else this.b.getValue(v)!==void 0&&d.push([v,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const v=this.b;this.b=new R.$co;for(const i of v.keys)this.b.setValue(i,v.getValue(i));for(const[i,o]of d)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);c&&this.a.fire(this.b)}}};e.$ko=$,e.$ko=$=ye([K(1,C.$Vn),K(2,g.$yj)],$)}),define(le[211],he([0,1,17,6,14,3,34,62,2,30,5,20,21,76,44,210,58]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=void 0;class c extends k.$Tc{constructor(l,v,i,o){super(),this.m=l,this.h=this.B(new L.$5d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$io),this.c=i instanceof y.$Xn?new b.$jo:this.B(new b.$ko(this.b,i,o)),this.f=this.B(new h.$eo(this.m,{},S.$Ig,v)),this.a=new h.$fo(this.b.configurationModel,this.c.configurationModel,new h.$co,new h.$co),this.j=new f(l,v,this),this.g=this.B(new A.$qh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:s})=>this.r(n,s))),this.B(this.c.onDidChangeConfiguration(n=>this.s(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[l,v,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$fo(l,v,new h.$co,i)}getConfigurationData(){return this.a.toData()}getValue(l,v){const i=typeof l=="string"?l:void 0,o=(0,m.$Li)(l)?l:(0,m.$Li)(v)?v:{};return this.a.getValue(i,o,void 0)}async updateValue(l,v,i,o,n){const s=(0,m.$Mi)(i)?i:(0,m.$Li)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${l} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,O.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(l,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,g.$Ln)(v,r.defaultValue)&&(v=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const E=s.overrideIdentifiers.sort(),w=this.a.localUserConfiguration.overrides.find(u=>(0,O.$ub)([...u.identifiers].sort(),E));w&&(s.overrideIdentifiers=w.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,$.$$n)(s.overrideIdentifiers),l]:[l];await this.j.write(a,v),await this.reloadConfiguration()}inspect(l,v={}){return this.a.inspect(l,v,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const l=await this.f.loadConfiguration();this.n(l)}n(l){const v=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(l);this.t(i,v,2)}r(l,v){const i=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(l,v);this.t(o,i,7)}s(l){const v=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(l);this.t(i,v,7)}t(l,v,i){const o=new h.$ho(l,{data:v},this.a);o.source=i,this.h.fire(o)}}e.$lo=c;class f{constructor(l,v,i){this.b=l,this.c=v,this.d=i,this.a=new A.$lh}write(l,v){return this.a.queue(()=>this.e(l,v))}async e(l,v){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,I.$on)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(i,l,v);i=(0,R.$Gn)(i,n),await this.c.writeFile(this.b,D.$se.fromString(i))}f(l,v,i){const{tabSize:o,insertSpaces:n,eol:s}=this.h;if(!v.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,R.$Dn)(l,v,i,{tabSize:o,insertSpaces:n,eol:s})}get h(){if(!this.g){let l=C.OS===3||C.OS===2?`
`:`\r
`;const v=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});v&&typeof v=="string"&&v!=="auto"&&(l=v),this.g={eol:l,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[212],he([0,1,14,3,2,68]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ntb=e.$mtb=e.$ltb=e.$ktb=void 0;const I=(g,C,S)=>{const m=new Uint8Array(16);for(let b=0;b<16;b++)m[b]=Math.round(Math.random()*256);const h=(0,O.$Me)(O.$se.wrap(m));return[`GET ws://localhost${g}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`].join(`\r
`)+`\r
\r
`};e.$ktb=I,e.$ltb=O.$se.fromString(`\r
\r
`);async function R(g,C,S,m,h){g.write(O.$se.fromString((0,e.$ktb)(C,S,m)));const $=new D.$Sc;try{return await new Promise((b,y)=>{let c;$.add(g.onData(f=>{c?c=O.$se.concat([c,f],c.byteLength+f.byteLength):c=f;const d=c.indexOf(e.$ltb);if(d===-1)return;b(g),g.pauseData();const l=c.slice(d+e.$ltb.byteLength);l.byteLength&&h.onData.fire(l)})),$.add(g.onClose(f=>y(f??new Error("socket closed")))),$.add(g.onEnd(()=>y(new Error("socket ended"))))})}catch(b){throw g.dispose(),b}finally{$.dispose()}}e.$mtb=R;class k extends D.$Tc{constructor(C,S){super(),this.g=C,this.a=this.B(new A.$8d),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new A.$5d),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event(m=>this.a.fire(m))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,S){L.SocketDiagnostics.traceSocketEvent(this,this.g,C,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$ntb=k}),define(le[213],he([0,1,7,4]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.RemoteAuthorityResolverErrorCode=e.$il=e.$hl=e.RemoteConnectionType=e.$gl=void 0,e.$gl=(0,A.$ei)("remoteAuthorityResolverService");var D;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(D||(e.RemoteConnectionType=D={}));class L{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$hl=L;class I{constructor(S,m){this.host=S,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$il=I;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class k extends O.$bb{static isNotAvailable(S){return S instanceof k&&S._code===R.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof k&&S._code===R.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof k&&S._code===R.NoResolverFound}static isInvalidAuthority(S){return S instanceof k&&S._code===R.InvalidAuthority}static isHandled(S){return S instanceof k&&S.isHandled}constructor(S,m=R.Unknown,h){super(S),this._message=S,this._code=m,this._detail=h,this.isHandled=m===R.NotAvailable&&h===!0,Object.setPrototypeOf(this,k.prototype)}}e.$jl=k;function g(C){const S=C.indexOf("+");return S===-1?C:C.substring(0,S)}e.$kl=g}),define(le[77],he([0,1,23]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=void 0;function A(g){return g.scheme===O.Schemas.vscodeRemote?g.authority:void 0}e.$ll=A;function D(g){if(!g)return;const C=g.indexOf("+");return C<0?g:g.substr(0,C)}e.$ml=D;function L(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$nl=L;function I(g){const{host:C,port:S}=k(g);if(typeof S>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:C,port:S}}e.$ol=I;function R(g,C){let{host:S,port:m}=k(g);return typeof m>"u"&&(m=C),{host:S,port:m}}e.$pl=R;function k(g){const C=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const S=g.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=g.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:g,port:void 0}}}),define(le[45],he([0,1,27,4,77]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.TargetPlatform=e.ExtensionType=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=e.$qm=void 0,e.$qm="extensions.user.cache",e.$rm="extensions.builtin.cache",e.$sm="undefined_publisher",e.$tm=["ui","workspace","web"];function L(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$um=L,e.$vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(I||(e.ExtensionType=I={}));var R;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class k{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,c){if(typeof y>"u"||y===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof y=="string"||typeof c=="string"){const f=typeof y=="string"?y:y.value,d=typeof c=="string"?c:c.value;return O.$jf(f,d)}return y._lower===c._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.$wm=k;class g{get size(){return this.c.size}constructor(y){if(this.c=new Set,y)for(const c of y)this.add(c)}add(y){this.c.add(k.toKey(y))}delete(y){return this.c.delete(k.toKey(y))}has(y){return this.c.has(k.toKey(y))}}e.$xm=g;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(y){this.c.delete(k.toKey(y))}get(y){return this.c.get(k.toKey(y))}has(y){return this.c.has(k.toKey(y))}set(y,c){this.c.set(k.toKey(y),c)}values(){return this.c.values()}forEach(y){this.c.forEach(y)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$ym=C;function S(b){return m(b)}e.$zm=S;function m(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.$Am=m;function h(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.$Bm=h;function $(b,y){if(y){const c=`onResolveRemoteAuthority:${(0,D.$ml)(y)}`;return!!b.activationEvents?.includes(c)}return!1}e.$Cm=$,e.$Dm=(0,A.$ei)("IBuiltinExtensionsScannerService")}),define(le[214],he([0,1,2,45,11]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;class L extends O.$Tc{constructor(R,k,g,C,S){super(),this.a=R,this.b=k,this.c=g,this.f=S,this.B(C.onDidInstallExtensions(m=>this.g(m))),this.B(C.onDidUninstallExtension(m=>this.h(m)))}g(R){for(const k of R)k.local&&this.invalidate(k.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,R)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,A.$qm))}catch(k){(0,D.$Sk)(k)!==1&&this.f.error(k)}}}e.$gq=L}),define(le[215],he([0,1,6,14,26,7,3,2,100,63,32,68,213,77]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.PersistentConnectionEventType=e.$wl=e.$vl=e.$ul=e.ConnectionType=void 0;const $=30*1e3;var b;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function y(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(U){const j=new D.$ce;return setTimeout(()=>j.cancel(),U),j.token}function f(U,j){if(U.isCancellationRequested||j.isCancellationRequested)return D.CancellationToken.Cancelled;const T=new D.$ce;return U.onCancellationRequested(()=>T.cancel()),j.onCancellationRequested(()=>T.cancel()),T.token}class d{get didTimeout(){return this.c==="timedout"}constructor(j){this.c="pending",this.d=new R.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,O.$0g)(),j.isCancellationRequested?this.h():this.d.add(j.onCancellationRequested(()=>this.h()))}registerDisposable(j){this.c==="pending"?this.d.add(j):j.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(j))}reject(j){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(j))}}function l(U,j){const T=new d(j);return T.registerDisposable(U.onControlMessage(B=>{const q=JSON.parse(B.toString()),Z=V(q);Z?T.reject(Z):T.resolve(q)})),T.promise}function v(U,j,T,B,q,Z,_,ie){const J=new d(ie),ne=g.$1d.create(!1);return U.info(`Creating a socket (${_})...`),k.mark(`code/willCreateSocket/${Z}`),j.connect(T,B,q,_).then(ce=>{J.didTimeout?(k.mark(`code/didCreateSocketError/${Z}`),U.info(`Creating a socket (${_}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),ce?.dispose()):(k.mark(`code/didCreateSocketOK/${Z}`),U.info(`Creating a socket (${_}) was successful after ${ne.elapsed()} ms.`),J.resolve(ce))},ce=>{k.mark(`code/didCreateSocketError/${Z}`),U.info(`Creating a socket (${_}) returned an error after ${ne.elapsed()} ms.`),U.error(ce),J.reject(ce)}),J.promise}function i(U,j){const T=new d(j);return U.then(B=>{T.didTimeout||T.resolve(B)},B=>{T.didTimeout||T.reject(B)}),T.promise}async function o(U,j,T,B){const q=ae(U,j);U.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await v(U.logService,U.remoteSocketFactoryService,U.connectTo,(0,h.$nl)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,y(j),`renderer-${y(j)}-${U.reconnectionToken}`,B)}catch(ce){throw U.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),U.logService.error(ce),ce}U.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let _,ie;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(Z,null),_=U.reconnectionProtocol,ie=!1):(_=new S.$5h({socket:Z}),ie=!0),U.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const J=await i(U.signService.createNewMessage((0,C.$Ag)()),B),ne={type:"auth",auth:U.connectionToken||"00000000000000000000",data:J.data};_.sendControl(A.$se.fromString(JSON.stringify(ne)));try{const ce=await l(_,f(B,c(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(U.logService.trace(`${q} 4/6. received SignRequest control message.`),!await i(U.signService.validate(J,ce.signedData),B)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await i(U.signService.sign(ce.data),B),me={type:"connectionType",commit:U.commit,signedData:de,desiredConnectionType:j};return T&&(me.args=T),U.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(A.$se.fromString(JSON.stringify(me))),{protocol:_,ownsProtocol:ie}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(U.logService.error(`${q} the handshake timed out. Error:`),U.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${q} received error control message when negotiating connection. Error:`),U.logService.error(ce)),ie&&H(_),ce}}async function n(U,j,T,B){const q=Date.now(),Z=ae(U,j),{protocol:_,ownsProtocol:ie}=await o(U,j,T,B),J=new d(B);return J.registerDisposable(_.onControlMessage(ne=>{const ce=JSON.parse(ne.toString()),fe=V(ce);fe?(U.logService.error(`${Z} received error control message when negotiating connection. Error:`),U.logService.error(fe),ie&&H(_),J.reject(fe)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${G(q)}!`),J.resolve({protocol:_,firstMessage:ce}))})),J.promise}async function s(U,j){const{protocol:T}=await n(U,1,void 0,j);return{protocol:T}}async function t(U,j,T){const{protocol:B,firstMessage:q}=await n(U,2,j,T),Z=q&&q.debugPort;return{protocol:B,debugPort:Z}}async function r(U,j,T){const B=Date.now(),q=ae(U,3),{protocol:Z}=await o(U,3,j,T);return U.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${G(B)}!`),Z}async function a(U,j,T){const{connectTo:B,connectionToken:q}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,connectTo:B,connectionToken:q,reconnectionToken:j,reconnectionProtocol:T,remoteSocketFactoryService:U.remoteSocketFactoryService,signService:U.signService,logService:U.logService}}async function E(U,j,T){return u(U,async B=>{const{protocol:q}=await s(B,D.CancellationToken.None);return new W(U,j,T,B.reconnectionToken,q)})}e.$ul=E;async function w(U,j){return u(U,async T=>{const{protocol:B,debugPort:q}=await t(T,j,D.CancellationToken.None);return new X(U,j,T.reconnectionToken,B,q)})}e.$vl=w;async function u(U,j){for(let B=1;;B++)try{const q=(0,C.$Ag)(),Z=await a(U,q,null);return await j(Z)}catch(q){if(B<5)U.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(q);else throw U.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(q),x.triggerPermanentFailure(0,0,m.$jl.isHandled(q)),q}}async function p(U,j,T){const B=await a(U,(0,C.$Ag)(),null);return await r(B,{host:j,port:T},D.CancellationToken.None)}e.$wl=p;function P(U){return(0,O.$4g)(j=>new Promise((T,B)=>{const q=setTimeout(T,U*1e3);j.onCancellationRequested(()=>{clearTimeout(q),T()})}))}var N;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class F{constructor(j,T){this.reconnectionToken=j,this.millisSinceLastIncomingData=T,this.type=0}}e.$xl=F;class M{constructor(j,T,B,q){this.reconnectionToken=j,this.millisSinceLastIncomingData=T,this.durationSeconds=B,this.c=q,this.type=1}skipWait(){this.c.cancel()}}e.$yl=M;class z{constructor(j,T,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=T,this.attempt=B,this.type=2}}e.$zl=z;class Y{constructor(j,T,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=T,this.attempt=B,this.type=4}}e.$Al=Y;class Q{constructor(j,T,B,q){this.reconnectionToken=j,this.millisSinceLastIncomingData=T,this.attempt=B,this.handled=q,this.type=3}}e.$Bl=Q;class x extends R.$Tc{static triggerPermanentFailure(j,T,B){this._permanentFailure=!0,this.f=j,this.g=T,this.h=B,this.j.forEach(q=>q.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(j=>j.y())}static debugPauseSocketWriting(){this.j.forEach(j=>j.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(j,T,B,q,Z){super(),this.t=j,this.u=T,this.reconnectionToken=B,this.protocol=q,this.w=Z,this.m=this.B(new I.$5d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(q.onSocketClose(_=>{const ie=ee(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ie} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ie} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ie} received socket close event.`),this.y()})),this.B(q.onSocketTimeout(_=>{const ie=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Rc)(()=>{const _=x.j.indexOf(this);_>=0&&x.j.splice(_,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const j=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const q=B<T.length?T[B]:T[T.length-1];try{if(q>0){const _=P(q);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,_)),this.u.logService.info(`${j} waiting for ${q} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${j} resolving connection...`);const Z=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${j} connecting to ${Z.connectTo}...`),await this.G(Z,c($)),this.u.logService.info(`${j} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(m.$jl.isTemporarilyNotAvailable(Z)){this.u.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.u.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((0,L.$4)(Z)){this.u.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if(Z instanceof m.$jl){this.u.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,m.$jl.isHandled(Z));break}this.u.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(j,T,B){this.w?x.triggerPermanentFailure(j,T,B):this.D(j,T,B)}D(j,T,B){this.m.fire(new Q(this.reconnectionToken,j,T,B)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Cl=x;class W extends x{constructor(j,T,B,q,Z){super(1,j,q,Z,!0),this.client=this.B(new S.$3h(Z,{remoteAuthority:T,clientId:B},j.ipcLogger))}async G(j,T){await s(j,T)}}e.$Dl=W;class X extends x{constructor(j,T,B,q,Z){super(2,j,B,q,!1),this.H=T,this.debugPort=Z}async G(j,T){await t(j,this.H,T)}}e.$El=X;function H(U){try{U.acceptDisconnect();const j=U.getSocket();U.dispose(),j.dispose()}catch(j){(0,L.$1)(j)}}function V(U){if(U&&U.type==="error"){const j=new Error(`Connection error: ${U.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function te(U,j){for(;U.length<j;)U+=" ";return U}function oe(U,j){return`[remote-connection][${te(y(U),13)}][${j.substr(0,5)}\u2026]`}function ee(U,j,T){return`${oe(U,j)}[${T?"reconnect":"initial"}]`}function ae(U,j){return`${ee(j,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.connectTo}]`}function G(U){return`${Date.now()-U} ms`}}),define(le[104],he([0,1,2,4]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0,e.$ql=(0,A.$ei)("remoteSocketFactoryService");class D{constructor(){this.a={}}register(I,R){return this.a[I]??=[],this.a[I].push(R),(0,O.$Rc)(()=>{const k=this.a[I]?.indexOf(R);typeof k=="number"&&k>=0&&this.a[I]?.splice(k,1)})}b(I){return(this.a[I.type]||[]).find(k=>k.supports(I))}connect(I,R,k,g){const C=this.b(I);if(!C)throw new Error(`No socket factory found for ${I}`);return C.connect(I,R,k,g)}}e.$rl=D}),define(le[216],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ac=e.$5ac=void 0,e.$5ac=(0,O.$ei)("sharedProcessTunnelService"),e.$6ac="sharedProcessTunnel"}),define(le[105],he([0,1,4,164]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=e.$cbc=e.$bbc=e.$abc=e.$_ac=e.TunnelStates=e.$$ac=e.$0ac=void 0,e.$0ac=(0,O.$ei)("IRemoteTunnelService"),e.$$ac={active:!1};var D;(function(L){L.disconnected=I=>({type:"disconnected",onTokenFailed:I}),L.connected=(I,R)=>({type:"connected",info:I,serviceInstallFailed:R}),L.connecting=I=>({type:"connecting",progress:I}),L.uninitialized={type:"uninitialized"}})(D||(e.TunnelStates=D={})),e.$_ac="remote.tunnels.access",e.$abc=e.$_ac+".hostNameOverride",e.$bbc=e.$_ac+".preventSleep",e.$cbc="remoteTunnelService",e.$dbc=(0,A.localize)(0,null)}),define(le[59],he([0,1,14,7,2,166,44,4,8,41]),function(se,e,O,A,D,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=void 0,e.$sp=(0,R.$ei)("requestService");class C{constructor(v){this.b=v}toJSON(){if(!this.a){const v=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?v[i]="*****":v[i]=this.b[i];this.a=v}return this.a}}class S extends D.$Tc{constructor(v){super(),this.b=0,this.a=v.createLogger("network",{name:(0,L.localize)(0,null),when:k.$Pj.isEqualTo((0,k.$Nj)(k.LogLevel.Trace)).serialize()})}async c(v,i,o){const n=`${v} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new C(i.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,A.$0)(s)),s}}}e.$tp=S;function m(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}e.$up=m;function h(l){return l.res.statusCode===204}e.$vp=h;async function $(l){return h(l)?null:(await(0,O.$Ee)(l.stream)).toString()}e.$wp=$;async function b(l){if(!m(l))throw new Error("Server returned "+l.res.statusCode);return $(l)}e.$xp=b;async function y(l){if(!m(l))throw new Error("Server returned "+l.res.statusCode);if(h(l))return null;const i=(await(0,O.$Ee)(l.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.$yp=y;function c(l){d(l)}e.$zp=c;let f;function d(l){const v=g.$Tn.as(I.$Yn.Configuration),i=f;f={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},v.updateConfigurations({add:[f],remove:i?[i]:[]})}d(1)}),define(le[217],he([0,1,26,23,11,59]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=void 0;let I=class{constructor(k,g){this.a=k,this.b=g}async download(k,g,C=O.CancellationToken.None){if(k.scheme===A.Schemas.file||k.scheme===A.Schemas.vscodeRemote){await this.b.copy(k,g);return}const S={type:"GET",url:k.toString(!0)},m=await this.a.request(S,C);if(m.res.statusCode===200)await this.b.writeFile(g,m.stream);else{const h=await(0,L.$xp)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${h}`)}}};e.$PP=I,e.$PP=I=ye([K(0,L.$sp),K(1,D.$Bk)],I)}),define(le[218],he([0,1,14,26]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;class D{constructor(R){this.a=R}listen(R,k){throw new Error("Invalid listen")}call(R,k,g,C=A.CancellationToken.None){switch(k){case"request":return this.a.request(g[0],C).then(async({res:S,stream:m})=>{const h=await(0,O.$Ee)(m);return[{statusCode:S.statusCode,headers:S.headers},h]});case"resolveProxy":return this.a.resolveProxy(g[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$vr=D;class L{constructor(R){this.a=R}async request(R,k){const[g,C]=await this.a.call("request",[R],k);return{res:g,stream:(0,O.$Ge)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$wr=L}),define(le[219],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y_b=e.$x_b=e.$w_b=void 0,e.$w_b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$x_b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$y_b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[220],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=void 0;class O{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(D){try{const L=await this.c();if(L){const I=String(O.a++);return this.b.set(I,L),{id:I,data:L.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,L){if(!D.id)return!0;const I=this.b.get(D.id);if(!I)return!1;this.b.delete(D.id);try{return I.validate(L)==="ok"}catch{return!1}finally{I.dispose?.()}}async sign(D){try{return await this.d(D)}catch{}return D}}e.$t8b=O}),define(le[106],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=void 0,e.$sl="signService",e.$tl=(0,O.$ei)(e.$sl)}),define(le[221],he([0,1,220]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mac=void 0;class A extends O.$t8b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(I=>new I.signer().sign(L))}h(){return new Promise((L,I)=>se(["vsda"],L,I))}}e.$mac=A}),define(le[78],he([0,1,3,2]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oHb=e.$nHb=e.$mHb=e.$lHb=void 0;class D extends A.$Tc{constructor(S,m,h){super(),this.a=S,this.b=m,this.c=h}async getItems(){const S={profile:this.b,workspace:this.c},m=await this.a.call("getItems",S);return new Map(m)}updateItems(S){const m={profile:this.b,workspace:this.c};return S.insert&&(m.insert=Array.from(S.insert.entries())),S.delete&&(m.delete=Array.from(S.delete.values())),this.a.call("updateItems",m)}optimize(){const S={profile:this.b,workspace:this.c};return this.a.call("optimize",S)}}class L extends D{constructor(S,m){super(S,m,void 0),this.f=this.B(new O.$5d),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(S=>this.h(S)))}h(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this.f.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class I extends L{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.$lHb=I;class R extends L{constructor(S,m){super(S,m)}async close(){this.dispose()}}e.$mHb=R;class k extends D{constructor(S,m){super(S,void 0,m),this.onDidChangeItemsExternal=O.Event.None}async close(){this.dispose()}}e.$nHb=k;class g{constructor(S){this.a=S}isUsed(S){const m={payload:S,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.$oHb=g}),define(le[107],he([0,1,5,37,32]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=void 0;function L(k){if(O.$u===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function I(k,g,C,S,m,h,$,b,y){const c=Object.create(null);c["common.machineId"]=h,c["common.sqmId"]=$,c.sessionID=(0,D.$Ag)()+Date.now(),c.commitHash=S,c.version=m,c["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,O.$h)(O.$u),c["common.nodePlatform"]=A.$dc,c["common.nodeArch"]=C,c["common.product"]=y||"desktop",b&&(c["common.msftInternal"]=b);let f=0;const d=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),O.$l&&(c["common.snap"]="true");const l=L(g);return l&&(c["common.platformDetail"]=l),c}e.$Uo=I;function R(k){const g=A.env.USERDNSDOMAIN;if(!g)return!1;const C=g.toLowerCase();return k.some(S=>C===S)}e.$Vo=R}),define(le[22],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,O.$ei)("telemetryService"),e.$Gl=(0,O.$ei)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var A;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var D;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(le[222],he([0,1,36,6,34,23,16,5,10,143,31,146,95,11,24,22]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=e.$fs=e.$es=void 0;const y=new Map;async function c(i,o){const n=`${i}::${o.join(":")}`,s=y.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,E=2e4;function w(p,P,N,F){const M=P.substring(p.length+1);return A.Promises.withAsyncBody(async z=>{let Y;try{Y=await C.Promises.readdir(P,{withFileTypes:!0})}catch{z();return}if(F.count>=E){F.count+=Y.length,F.maxReached=!0,z();return}let Q=Y.length;if(Q===0){z();return}let x=Y;F.count+Y.length>E&&(F.maxReached=!0,Q=E-F.count,x=Y.slice(0,Q)),F.count+=Y.length;for(const W of x)if(W.isDirectory()){if(N.includes(W.name)||await w(p,(0,I.$jc)(P,W.name),N,F),--Q===0){z();return}}else{const X=W.name.lastIndexOf(".");if(X>=0){const H=W.name.substring(X+1);H&&r.set(H,(r.get(H)??0)+1)}for(const H of t)H.relativePathPattern?.test(M)!==!1&&H.filePattern.test(W.name)&&a.set(H.tag,(a.get(H.tag)??0)+1);if(--Q===0){z();return}}})}const u=A.Promises.withAsyncBody(async p=>{const P={count:0,maxReached:!1};await w(i,i,o,P);const N=await l(i);p({configFiles:f(a),fileTypes:f(r),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:N})});return y.set(n,u),u}e.$es=c;function f(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function d(){const i={os:`${O.type()} ${O.arch()} ${O.release()}`,memory:`${(O.totalmem()/h.$0k.GB).toFixed(2)}GB (${(O.freemem()/h.$0k.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$jn.value()*100)}%`},o=O.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.$fs=d;async function l(i){try{const o=new Map,n=(0,I.$jc)(i,".vscode","launch.json"),s=await C.Promises.readFile(n),t=[],r=(0,D.$on)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,D.$xn)(r)==="object"&&r.configurations)for(const a of r.configurations){const E=a.type;E&&(o.has(E)?o.set(E,o.get(E)+1):o.set(E,1))}return f(o)}catch{return[]}}e.$gs=l;let v=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${O.type()} ${O.arch()} ${O.release()}`);const s=O.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(O.totalmem()/h.$0k.GB).toFixed(2)}GB (${(O.freemem()/h.$0k.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${O.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(g.$jn.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,S.$ds)(o.mainPID),this.k(o)]).then(async s=>{let[t,r]=s,a=this.m(o,t);return n.forEach(E=>{if((0,m.$Vm)(E))a+=`
${E.errorMessage}`,r+=`
${E.errorMessage}`;else if(a+=`

Remote: ${E.hostName}`,E.processes&&(a+=`
${this.m(o,E.processes)}`),E.workspaceMetadata){r+=`
|  Remote: ${E.hostName}`;for(const w of Object.keys(E.workspaceMetadata)){const u=E.workspaceMetadata[w];let p=`${u.fileCount} files`;u.maxFilesReached&&(p=`more than ${p}`),r+=`|    Folder (${w}): ${p}`,r+=this.h(u)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=d(),E={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(E.load=`${O.loadavg().map(w=>Math.round(w)).join(", ")}`),R.$k&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(o,n){const s=[];return(0,S.$ds)(o.mainPID).then(async t=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,m.$Vm)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const E=r.workspaceMetadata[a];let w=`${E.fileCount} files`;E.maxFilesReached&&(w=`more than ${w}`),s.push(`Folder (${a}): ${w}`),s.push(this.h(E))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let t=0;const r=(u,p)=>{const P=` ${u}(${p})`;t+P.length>60?(n.push(a),a="|                 ",t=a.length):t+=P.length,a+=P};let a="|      File types:";const E=10,w=o.fileTypes.length>E?E:o.fileTypes.length;for(let u=0;u<w;u++){const p=o.fileTypes[u];r(p.name,p.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(u=>{r(u.name,u.count)}),n.push(a)),o.launchConfigFiles.length>0){let u="|      Launch Configs:";o.launchConfigFiles.forEach(p=>{const P=p.count>1?` ${p.name}(${p.count})`:` ${p.name}`;u+=P}),n.push(u)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=k.URI.revive(r);if(a.scheme===L.Schemas.file){const E=a.fsPath;s.push(c(E,["node_modules",".git"]).then(w=>{let u=`${w.fileCount} files`;w.maxFilesReached&&(u=`more than ${u}`),n.push(`|    Folder (${(0,I.$nc)(E)}): ${u}`),n.push(this.h(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${E} (${w.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,t,n,0),t.join(`
`)}n(o,n,s,t,r){const a=r===0;let E;a?E=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?E=n.get(t.pid):E=`${"  ".repeat(r)} ${t.name}`;const w=process.platform==="win32"?t.mem:O.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(w/h.$0k.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(t.children)&&t.children.forEach(u=>this.n(o,n,s,u,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=k.URI.revive(s);if(t.scheme!==L.Schemas.file)continue;const r=t.fsPath;try{(await c(r,["node_modules",".git"])).fileTypes.forEach(E=>n.add(E.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=k.URI.revive(n);if(s.scheme!==L.Schemas.file)continue;const t=s.fsPath;try{const r=await c(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$hs=v,e.$hs=v=ye([K(0,b.$Fl),K(1,$.$Qj)],v)}),define(le[108],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C_b=e.$B_b=void 0;class O{constructor(L){this.b=L}listen(L,I){throw new Error(`Event not found: ${I}`)}call(L,I,{eventName:R,data:k}){return this.b.forEach(g=>g.log(R,k)),Promise.resolve(null)}}e.$B_b=O;class A{constructor(L){this.b=L}log(L,I){return this.b.call("log",{eventName:L,data:I}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$C_b=A}),define(le[46],he([0,1,30,12,77,107,22]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0;class R{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$Wo=R;class k{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Xo=k,e.$Yo=new k;class g{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$Zo=g,e.$1o="telemetry",e.$2o="extensionTelemetryLog",e.$3o={log:()=>null,flush:()=>Promise.resolve(null)};function C(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}e.$4o=C;function S(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$5o=S;function m(i){const o=i.getValue(I.$Nl),n=i.getValue(I.$Ol);if(i.getValue(I.$Pl)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$6o=m;function h(i){const o={},n={},s={};y(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}e.$7o=h;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function b(i){if(!i)return"none";const o=(0,D.$ml)(i);return $.has(o)?o:"other"}e.$8o=b;function y(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,O.$Mn)(r):r instanceof Date?o[a]=r.toISOString():(0,A.$Uf)(r)?n<2?y(r,o,n+1,a+"."):o[a]=(0,O.$Mn)(r):o[a]=r}}function c(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,L.$Vo)(n)||s}e.$9o=c;function f(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$0o=f;function d(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const E of o)for(;;){const w=E.exec(i);if(!w)break;s.push([w.index,E.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const E=r.exec(i);if(!E)break;const w=s.some(([u,p])=>E.index<p&&u<r.lastIndex);!t.test(E[0])&&!w&&(n+=i.substring(a,E.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function l(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function v(i,o){return(0,O.$Jn)(i,n=>{if(n instanceof R||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=d(s,o);for(const t of o)s=s.replace(t,"");return s=l(s),s}})}e.$$o=v}),define(le[33],he([0,1,27,29,45,5,10,7,37,46]),function(se,e,O,A,D,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0;function C(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,O.$ef)(n.id,s.id)===0}e.$_o=C;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,t,r)}static parse(s){const t=S.exec(s);return t&&t[1]&&t[2]?new m({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$ap=m;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const s=h.exec(n);return s&&s[1]?[y(s[1]),s[2]]:[y(n),void 0]}e.$bp=$;function b(n,s){return`${n}.${s}`}e.$cp=b;function y(n){return n.toLowerCase()}e.$dp=y;function c(n,s){return y(b(n??D.$sm,s))}e.$ep=c;function f(n,s){const t=[],r=a=>{for(const E of t)if(E.some(w=>C(s(w),s(a))))return E;return null};for(const a of n){const E=r(a);E?E.push(a):t.push([a])}return t}e.$fp=f;function d(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$gp=d;function l(n){return{id:new g.$Wo(n.identifier.id),name:new g.$Wo(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$hp=l,e.$ip=new D.$wm("pprice.better-merge");function v(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(E=>!C(E.identifier,{id:a}))){const E=n.filter(w=>C(w.identifier,{id:a}));E.length===1&&(t.push(E[0]),r.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$jp=v;async function i(n,s){if(!L.$k)return!1;let t;try{t=(await n.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,A.$Go)(t?"alpine":L.$u,k.$ec);return s.debug("ComputeTargetPlatform:",r),r}e.$kp=o}),define(le[223],he([0,1,17,2,20,10,11,24,6,3,16,5,37,33]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B0b=e.$A0b=void 0;let $=class extends A.$Tc{constructor(d,l){super(),this.b=d,this.c=l,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,v])=>this.a.set(v.configPath,v))}getConfigBasedTips(d){return this.f(d)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(d){const l=[];for(const[v,i]of this.a)if(!(i.configScheme&&i.configScheme!==d.scheme))try{const o=(await this.b.readFile((0,D.$Rg)(d,v))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&l.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return l}};e.$A0b=$,e.$A0b=$=ye([K(0,I.$Bk),K(1,R.$Qj)],$);const b="extensionTips/promptedExecutableTips",y="extensionTips/lastPromptedMediumImpExeTime";class c extends ${constructor(d,l,v,i,o,n,s,t){super(s,t),this.r=d,this.s=l,this.t=v,this.u=i,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const E=[],w=[],u=[];Object.entries(a.recommendations).forEach(([p,P])=>{P.important?a.important?E.push({extensionId:p,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):w.push({extensionId:p,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):u.push({extensionId:p,extensionName:P.name,isExtensionPack:!!P.isExtensionPack})}),E.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:E}),w.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),u.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:u})}),(0,k.$gh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const d=await this.O(this.g),l=await this.O(this.h);return[...d,...l]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const d=await this.O(this.g),l=await this.O(this.h),v=await this.u.getInstalled();this.m=this.D(d,v),this.n=this.D(l,v)}D(d,l){const v=new Map;d.forEach(t=>v.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...v.keys()],l);for(const t of i){const r=v.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=v.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of o){const r=v.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[d,l]=[...this.m.entries()][0];this.H(l).then(v=>{switch(v){case"reacted":this.M(l[0].exeName,l);break;case"ignored":this.m.delete(d);break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new A.$Uc);i.value=(0,k.$gh)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const d=this.I(),l=Date.now()-d,v=7*24*60*60*1e3;if(l<v){const n=this.B(new A.$Uc);n.value=(0,k.$gh)(()=>{n.dispose(),this.G()},v-l);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const s=this.B(new A.$Uc);s.value=(0,k.$gh)(()=>{s.dispose(),this.G()},v);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new A.$Uc);s.value=(0,k.$gh)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(d){const l=await this.u.getInstalled(1),v=d.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>l.every(n=>!(0,h.$_o)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:v,source:3,name:d[0].exeFriendlyName,searchValue:`@exe:"${d[0].exeName}"`})}I(){let d=this.w.getNumber(y,-1);return d||(d=Date.now(),this.J(d)),d}J(d){this.w.store(y,d,-1,1)}L(){return JSON.parse(this.w.get(b,-1,"{}"))}M(d,l){const v=this.L();v[d]=l.map(({extensionId:i})=>i.toLowerCase()),this.w.store(b,JSON.stringify(v),-1,0)}N(d,l){const v=[],i=[],o=l.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return d.forEach(n=>{o.has(n.toLowerCase())?v.push(n):i.push(n)}),{installed:v,uninstalled:i}}async O(d){const l=[],v=new Map;for(const i of d.keys()){const o=d.get(i);if(!o||!(0,O.$Lb)(o.recommendations))continue;const n=[];S.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(n.push((0,C.$jc)("/usr/local/bin",i)),n.push((0,C.$jc)("/usr/bin",i)),n.push((0,C.$jc)(this.r.fsPath,i)));for(const s of n){let t=v.get(s);if(t===void 0&&(t=await this.b.exists(L.URI.file(s)),v.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:E,whenNotInstalled:w}of o.recommendations)l.push({extensionId:r,extensionName:a,isExtensionPack:E,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:w})}}return l}}e.$B0b=c}),define(le[224],he([0,1,26,33]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K1b=void 0;async function D(L,I,R,k,g){try{const C=await L.getExtensionsControlManifest();if(!C.deprecated)return;const S=await L.getInstalled(1);for(const[m,h]of Object.entries(C.deprecated)){if(!h?.extension)continue;const{id:$,autoMigrate:b,preRelease:y}=h.extension;if(!b)continue;const c=S.find(d=>(0,A.$_o)(d.identifier,{id:m}));if(!c)continue;const f=(await I.getExtensions([{id:$,preRelease:y}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0];if(!f){g.info(`Skipping migrating '${c.identifier.id}' extension because, the comaptible target '${$}' extension is not found`);continue}try{g.info(`Migrating '${c.identifier.id}' extension to '${$}' extension...`);const d=!k.getDisabledExtensions().some(v=>(0,A.$_o)(v,c.identifier));await L.uninstall(c),g.info(`Uninstalled the unsupported extension '${c.identifier.id}'`);let l=S.find(v=>(0,A.$_o)(v.identifier,{id:$}));(!l||!l.isPreReleaseVersion&&d)&&(l=await L.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:c.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${l.identifier.id}'`),d||(await k.disableExtension(l.identifier),g.info(`Disabled the pre-release extension '${l.identifier.id}' because the unsupported extension '${c.identifier.id}' is disabled`)),b.storage&&(R.addToMigrationList((0,A.$cp)(c.manifest.publisher,c.manifest.name),(0,A.$cp)(l.manifest.publisher,l.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${c.identifier.id}' extension to '${$}' extension.`)}catch(d){g.error(d)}}}catch(C){g.error(C)}}e.$K1b=D}),define(le[225],he([0,1,6,7,2,23,20,55,12,32,31,70,21,15,29,33,99,11,8]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;let l=class extends D.$Tc{static{d=this}static{this.c=".sigzip"}constructor(i,o,n,s,t,r){super(),this.h=o,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,n){await this.g;const s=(0,I.$Rg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,o))}catch(r){throw new $.$Lo(r.message,$.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(a){const E=a;if(t=E.code,E.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${E.output}`),t===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(w){this.r.error(w)}throw new $.$Lo(S.$Wp,$.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,k.$Yf)(o)?o:!0}async u(i){await this.g;const o=(0,I.$Rg)(this.extensionsDownloadDir,`${this.z(i)}${d.c}`);try{await this.w(i,o,n=>this.j.downloadSignatureArchive(i,n))}catch(n){throw new $.$Lo(n.message,$.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==L.Schemas.file){await n(o);return}const s=(0,I.$Rg)(this.extensionsDownloadDir,`.${(0,g.$Ag)()}`);await this.h.exists(s)||await n(s);try{await C.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,A.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(d.c))s.push(a.resource);else{const E=b.$ap.parse(a.name);E&&n.push([E,a])}const t=(0,b.$fp)(n,([a])=>a),r=[];for(const a of t)a.sort((E,w)=>R.rcompare(E[0].version,w[0].version)),o.push(...a.slice(1).map(E=>E[1].resource)),r.push(a[0][1]);r.sort((a,E)=>a.mtime-E.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await O.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?b.$ap.create(i).toString().toLowerCase():(0,g.$Ag)()}};e.$dq=l,e.$dq=l=d=ye([K(0,h.$mi),K(1,c.$Bk),K(2,$.$Ko),K(3,m.$Ki),K(4,y.$Qp),K(5,f.$yj)],l)}),define(le[226],he([0,1,3,2,35,33,45]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=void 0;class R extends A.$Tc{constructor(g,C,S,m,h,$,b){super(),this.f=g,this.g=C,this.h=S,this.j=m,this.m=h,this.n=$,this.r=b,this.a=this.B(new O.$5d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$3c),this.s().then(null,y=>b.error(y))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(C=>(this.c.set(C.id,(0,A.$Qc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(g){for(const C of g.extensions)this.I(this.L(C.identifier,C.version),g.profileLocation)}async y(g){for(const C of g.extensions){const S=this.L(C.identifier,C.version);g.error?this.J(S,g.profileLocation):this.I(S,g.profileLocation)}}async z(g){for(const C of g.extensions)this.J(this.L(C.identifier,C.version),g.profileLocation)}async C(g){const C=[],S=[];for(const m of g.extensions){const h=this.L(m.identifier,m.version);g.error?this.I(h,g.profileLocation):(this.J(h,g.profileLocation),this.b.has(h)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),S.push(this.f.scanInstalledExtensionAtLocation(m.location).then($=>{$?C.push($):this.r.info("Extension not found at the location",m.location.toString())},$=>this.r.error($)))))}try{await Promise.all(S),C.length&&await this.H(C)}catch(m){this.r.error(m)}}D(g){for(const C of this.h.profiles)g.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(g){const C=[],S=[],m=await this.j.scanProfileExtensions(g),h=new Set,$=new Set;for(const[b,y]of this.b)y.has(g)&&$.add(b);for(const b of m){const y=this.L(b.identifier,b.version);h.add(y),$.has(y)||(C.push(b.identifier),this.I(y,g))}for(const b of $)if(!h.has(b)){const y=this.M(b);y&&(S.push(y.identifier),this.J(b,g))}(C.length||S.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:g}:void 0,removed:S.length?{extensions:S,profileLocation:g}:void 0})}async G(g){const C=await this.j.scanProfileExtensions(g);for(const S of C)this.I(this.L(S.identifier,S.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.L(S.identifier,S.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,C){let S=this.b.get(g);S||this.b.set(g,S=new D.$Bc(m=>this.m.extUri.getComparisonKey(m))),S.add(C)}J(g,C){const S=this.b.get(g);S&&S.delete(C),S?.size||this.b.delete(g)}L(g,C){return`${I.$wm.toKey(g.id)}@${C}`}M(g){const[C,S]=(0,L.$bp)(g);return S?{identifier:{id:C},version:S}:void 0}}e.$hq=R}),define(le[227],he([0,1,43,46]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;async function D(L,I,R,k,g,C,S){const m={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${I.nameShort})`};if((0,A.$4o)(I,R)&&(0,A.$6o)(k)===3){const h=await(0,O.$Lp)(R,g,C);m["X-Market-User-Id"]=h,m["VSCode-SessionId"]=S.machineId||h}return m}e.$Mp=D}),define(le[228],he([0,1,73,17,6,2,23,16,31,15,29,33,8,75,10]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;let b=class extends h.$tr{constructor(d,l,v,i){super(v),this.h=d,this.j=i,this.g=this.B(new y(l,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(d,l){const i=(await this.g.getLanguagePacks())[l];if(!i){this.j.warn(`No language pack found for ${l}`);return}const o=i.translations[d];return o?$.URI.file(o):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),l=Object.keys(d).map(v=>{const i=d[v];return{...this.f(v,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return l.push(this.f("en","English")),l.sort((v,i)=>v.label.localeCompare(i.label)),l}async m(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",d.identifier.id),await this.update())}async n(d){const l=await this.g.getLanguagePacks();Object.keys(l).some(v=>l[v]&&l[v].extensions.some(i=>(0,S.$_o)(i.extensionIdentifier,d.identifier)))&&(this.j.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,l]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),v=await this.g.update(l);return!(0,A.$ub)(Object.keys(d),Object.keys(v))}};e.$ur=b,e.$ur=b=ye([K(0,C.$No),K(1,g.$mi),K(2,C.$Ko),K(3,m.$yj)],b);let y=class extends L.$Tc{constructor(d,l){super(),this.j=l,this.c={},this.f=(0,R.$jc)(d.userDataPath,"languagepacks.json"),this.g=new D.$lh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.s(l=>{Object.keys(l).forEach(v=>delete l[v]),this.m(l,...d)}).then(()=>this.c)}m(d,...l){for(const v of l)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.n(d,v);Object.keys(d).forEach(v=>this.r(d[v]))}n(d,l){const v=l.identifier,i=l.manifest.contributes&&l.manifest.contributes.localizations?l.manifest.contributes.localizations:[];for(const o of i)if(l.location.scheme===I.Schemas.file&&c(o)){let n=d[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},d[o.languageId]=n);const s=n.extensions.filter(t=>(0,S.$_o)(t.extensionIdentifier,v))[0];s?s.version=l.manifest.version:n.extensions.push({extensionIdentifier:v,version:l.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.$jc)(l.location.fsPath,t.path)}}r(d){if(d){const l=(0,O.createHash)("md5");for(const v of d.extensions)l.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);d.hash=l.digest("hex")}}s(d=()=>null){return this.g.queue(()=>{let l=null;return k.Promises.readFile(this.f,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch{return{}}}).then(v=>(l=d(v),v)).then(v=>{for(const o of Object.keys(v))v[o]||delete v[o];this.c=v,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),k.Promises.writeFile(this.f,i)}).then(()=>l,v=>this.j.error(v))})}};y=ye([K(0,g.$mi),K(1,m.$yj)],y);function c(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const d of f.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(le[229],he([0,1,142,7,30,46]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function k(C,S,m){const h=await(0,O.$tD)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,O.$tD)("@microsoft/1ds-post-js","dist/ms.post.js"),b=new h.AppInsightsCore,y=new $.PostChannel,c={instrumentationKey:C,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(m){c.extensionConfig={};const f={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};c.extensionConfig[y.identifier]=f}return b.initialize(c,[]),b.addTelemetryInitializer(f=>{f.ext=f.ext??{},f.ext.web=f.ext.web??{},f.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',S&&(f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),b}class g{constructor(S,m,h,$,b){this.e=S,this.f=m,this.g=h,this.h=b,this.c=I,this.d=R,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(S){if(this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(m=>{S(m)},m=>{(0,A.$1)(m),console.error(m)})}}log(S,m){if(!this.a)return;m=(0,D.$Kn)(m,this.g),m=(0,L.$7o)(m);const h=this.f+"/"+S;try{this.i($=>{$.pluginVersionString=m?.properties.version??"Unknown",$.track({name:h,baseData:{name:h,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.$nP=g}),define(le[109],he([0,1,2,167,15,8,24,46]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$19b=void 0;let k=class extends O.$Tc{constructor(C,S,m,h,$=""){super(),this.b=$;const b=S.getLogger(R.$1o);if(b)this.a=this.B(b);else{const c=(0,R.$5o)(h,m)?" (Not Sent)":"",f=()=>(0,R.$4o)(h,m)&&C.getLevel()===L.LogLevel.Trace;this.a=this.B(S.createLogger(R.$1o,{name:(0,A.localize)(0,null,c),hidden:!f()})),this.B(C.onDidChangeLogLevel(()=>S.setVisibility(R.$1o,f()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,S){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$7o)(S))}};e.$19b=k,e.$19b=k=ye([K(0,L.$yj),K(1,L.$zj),K(2,D.$li),K(3,I.$Qj)],k)}),define(le[110],he([0,1,2,30,5,27,168,21,44,102,24,41,22,46]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,f,d){this.k=f,this.l=d,this.d={},this.i=new O.$Sc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const l of this.f)this.j.push(new RegExp((0,L.$Xe)(l),"gi")),l.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$Xe)(l.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(l=>{(l.affectsConfiguration(m.$Nl)||l.affectsConfiguration(m.$Pl)||l.affectsConfiguration(m.$Ol))&&this.m()}))}setExperimentProperty(c,f){this.d[c]=f}m(){let c=(0,h.$6o)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const d=f.usage?3:f.error?2:0;c=Math.min(c,d)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,f,d){this.g<f||(d=(0,A.$Kn)(d,this.d),d=(0,h.$$o)(d,this.j),d=(0,A.$Kn)(d,this.c),this.b.forEach(l=>l.log(c,d)))}publicLog(c,f){this.n(c,3,f)}publicLog2(c,f){this.publicLog(c,f)}publicLogError(c,f){this.h&&this.n(c,2,f)}publicLogError2(c,f){this.publicLogError(c,f)}};e.$Ar=$,e.$Ar=$=ye([K(1,R.$Ki),K(2,C.$Qj)],$);function b(){const y=(0,I.localize)(0,null,g.default.nameLong),c=g.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=D.$o?"":(0,I.localize)(3,null),d=(0,I.localize)(4,null),l=(0,I.localize)(5,null),v=(0,I.localize)(6,null),i=(0,I.localize)(7,null),o=`
|       | ${d} | ${l} | ${v} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,I.localize)(8,null);return`
${y} ${c} ${f}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}S.$Tn.as(k.$Yn.Configuration).registerConfiguration({id:m.$Ml,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[m.$Nl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.$Tn.as(k.$Yn.Configuration).registerConfiguration({id:m.$Ml,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[m.$Pl]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,I.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,I.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${m.$Nl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[230],he([0,1,14,26,271,229]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=void 0;async function I(C,S){const m=await S.request(C,A.CancellationToken.None),h=(await(0,O.$Ee)(m.stream)).toString(),$=m.res.statusCode??200;return{headers:m.res.headers,statusCode:$,responseData:h}}async function R(C){const S={method:C.type,headers:C.headers};return new Promise((h,$)=>{const b=D.request(C.url??"",S,y=>{y.on("data",function(c){h({headers:y.headers,statusCode:y.statusCode??200,responseData:c.toString()})}),y.on("error",function(c){$(c)})});b.write(C.data,y=>{y&&$(y)}),b.end()})}async function k(C,S,m){const h=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),$={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:h};try{const b=C?await I($,C):await R($);m(b.statusCode,b.headers,b.responseData)}catch{m(0,{})}}class g extends L.$nP{constructor(S,m,h,$,b){const y={sendPOST:(c,f)=>{k(S,c,f)}};super(m,h,$,b,y)}}e.$oP=g}),define(le[231],he([0,1,23,93,21,15,8,24,22,108,109,110]),function(se,e,O,A,D,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=void 0;let m=class{constructor($,b,y,c,f,d){this.b=$,this.c=b,this.d=y,this.e=c,this.f=f,this.g=d,this.a=new Map}h($){if(!this.a.has($.id)){const b=Object.create(null);b["common.vscodemachineid"]=this.c.machineId,b["common.vscodesessionid"]=this.c.sessionId;const y=[$.id,JSON.stringify(b),$.aiKey],f=new A.$Cq(O.$yg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:y,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),d=[new g.$C_b(f),new C.$19b(this.d,this.e,this.f,this.g,`[${$.id}] `)];this.a.set($.id,new S.$Ar({appenders:d,sendErrorTelemetry:$.sendErrorTelemetry},this.b,this.g))}return this.a.get($.id)}publicLog($,b,y){this.h($).publicLog(b,y)}publicLogError($,b,y){this.h($).publicLogError(b,y)}};e.$Wac=m,e.$Wac=m=ye([K(0,D.$Ki),K(1,k.$Fl),K(2,I.$yj),K(3,I.$zj),K(4,L.$li),K(5,R.$Qj)],m)}),define(le[79],he([0,1,3,21,4,8]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.$Pv=e.ProvidedOnAutoForward=e.$Ov=e.TunnelPrivacyId=e.TunnelProtocol=e.$Nv=e.$Mv=void 0,e.$Mv=(0,D.$ei)("tunnelService"),e.$Nv=(0,D.$ei)("sharedTunnelsService");var I;(function(y){y.Http="http",y.Https="https"})(I||(e.TunnelProtocol=I={}));var R;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(R||(e.TunnelPrivacyId=R={}));function k(y){return!!y.forwardPort}e.$Ov=k;var g;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function C(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(c)return{address:c[1],port:+c[2]}}e.$Pv=C,e.$Qv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(y){return e.$Qv.indexOf(y)>=0}e.$Rv=S,e.$Sv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(y){return e.$Sv.indexOf(y)>=0}e.$Tv=m;function h(y,c,f,d){if(f===1)return!1;if(f===2&&m(c)){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(l?.length===4&&parseInt(l[1])>=18)return!1}return y<1024}e.$Uv=h;class ${constructor(c,f,d){this.remoteAddress=c,this.localAddress=f,this.b=d,this.a=new O.$5d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Vv=$;let b=class{constructor(c,f){this.k=c,this.l=f,this.a=new O.$5d,this.onTunnelOpened=this.a.event,this.b=new O.$5d,this.onTunnelClosed=this.b.event,this.c=new O.$5d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const c=this.l.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.i=c.privacyOptions,this.h=c.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const c=[],f=Array.from(this.e.values());for(const d of f){const l=Array.from(d.values());for(const v of l){const i=await v.value;i&&typeof i!="string"&&c.push(i)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:f}of c.values())await f.then(d=>typeof d!="string"?d?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,f,d,l,v){this.q(c,f,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:f,localAddress:d,privacy:l,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,f){(m(c)||S(c))&&(c=e.$Qv[0]);const d=this.s(c,f);if(d)return++d.refcount,d.value}openTunnel(c,f,d,l,v,i=!1,o,n){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${d} on local port ${v}.`);const s=this.f??c;if(!s)return;if(f||(f="localhost"),l||(l=this.m),this.f&&this.j.has(d)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.t(s,f,d,l,v,i,o,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(f,d),r}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(f,d);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.o(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==d)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}o(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const f=this.e.get(c.tunnelRemoteHost);if(f){const d=f.get(c.tunnelRemotePort);d&&(d.refcount--,await this.p(c.tunnelRemoteHost,c.tunnelRemotePort,d))}}}}async p(c,f,d){if(d.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${f}.`);const l=d.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(f),l}}async closeTunnel(c,f){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${f} `);const d=this.e.get(c);if(d&&d.has(f)){const l=d.get(f);l.refcount=0,await this.p(c,f,l)}}q(c,f,d){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(f,{refcount:1,value:d})}async r(c,f){const d=this.e.get(c);if(d){const l=d.get(f),v=l?await l.value:void 0;(!v||typeof v=="string")&&d.delete(f),d.size===0&&this.e.delete(c)}}s(c,f){const d=[c];S(c)?(d.push(...e.$Qv),d.push(...e.$Sv)):m(c)&&d.push(...e.$Sv);const l=d.map(v=>this.e.get(v));for(const v of l){const i=v?.get(f);if(i)return i}}canTunnel(c){return!!C(c)}u(c,f,d,l,v,i,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${d} on local port ${l}.`);const n=d;this.j.add(n);const s=l===void 0?d:l,t={elevationRequired:v?this.isPortPrivileged(s):!1},r={remoteAddress:{host:f,port:d},localAddressPort:l,privacy:i,public:i?i!==R.Private:void 0,protocol:o},a=c.forwardPort(r,t);return a?(this.q(f,d,a),a.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(n)})):this.j.delete(n),a}};e.$Wv=b,e.$Wv=b=ye([K(0,L.$yj),K(1,A.$Ki)],b)}),define(le[232],he([0,1,8,79,2,7,6]),function(se,e,O,A,D,L,I){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$7ac=void 0;class k extends D.$Tc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new I.$Bh),this.b.p)}setAddress(S){this.a=S,this.b&&(this.b.complete(S),this.b=null)}setTunnel(S){this.B(S)}}let g=class extends D.$Tc{static{R=this}static{this.a=0}constructor(S,m){super(),this.f=S,this.g=m,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(S=>S.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(S,m,h,$,b,y,c){const f=new k,d=await Promise.resolve(this.f.openTunnel(S,f,h,$,b,y,c));if(!d||typeof d=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${h}:${$} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has(m))throw this.c.delete(m),f.dispose(),await d.dispose(),(0,L.$6)();return f.setTunnel(d),this.b.set(m,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${m}: ${d.localAddress} (local) to ${h}:${$} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(S,m){const h=this.b.get(S);h&&h.setAddress(m)}async destroyTunnel(S){const m=this.b.get(S);if(m){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${S}.`),this.b.delete(S),await m.dispose();return}this.c.add(S)}};e.$7ac=g,e.$7ac=g=R=ye([K(0,A.$Nv),K(1,O.$yj)],g)}),define(le[28],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=void 0,e.$_k=(0,O.$ei)("IUriIdentityService")}),define(le[233],he([0,1,28,186,11,20,128,3,2]),function(se,e,O,A,D,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0;class g{static{this._clock=0}constructor(m){this.uri=m,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let C=class{constructor(m){this.g=m,this.c=new k.$Sc,this.f=2**16;const h=new Map,$=b=>{let y=h.get(b.scheme);return y===void 0&&(y=m.hasProvider(b)&&!this.g.hasCapability(b,1024),h.set(b.scheme,y)),y};this.c.add(R.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(b=>{h.delete(b.scheme)})),this.extUri=new L.$Gg($),this.d=new I.$_r((b,y)=>this.extUri.compare(b,y,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,L.$Sg)(m));const h=this.d.get(m);return h?h.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new g(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort(($,b)=>$[1].time<b[1].time?1:$[1].time>b[1].time?-1:0);g._clock=0,this.d.clear();const h=this.f*.5;for(let $=0;$<h;$++)this.d.set(m[$][0],m[$][1].touch())}};e.$as=C,e.$as=C=ye([K(0,D.$Bk)],C),(0,A.$0r)(O.$_k,C,1)}),define(le[234],he([0,1,3,2,11,48,35]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0;class R extends A.$Tc{constructor(g,C,S,m,h,$){super(),this.f=g,this.g=C,this.h=S,this.j=m,this.m=h,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$5d),this.onDidChangeFile=this.a.event,this.b=L.$ki.forUris(()=>!(this.capabilities&1024)),this.c=new I.$Bc(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,C){return this.g.open(this.t(g),C)}close(g){return this.g.close(g)}read(g,C,S,m,h){return this.g.read(g,C,S,m,h)}write(g,C,S,m,h){return this.g.write(g,C,S,m,h)}watch(g,C){this.b.set(g,g);const S=this.g.watch(this.t(g),C);return(0,A.$Rc)(()=>{this.b.delete(g),S.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,C,S){return this.g.rename(this.t(g),this.t(C),S)}readFile(g,C){return this.g.readFile(this.t(g),C)}readFileStream(g,C,S){return this.g.readFileStream(this.t(g),C,S)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,C,S){return this.g.writeFile(this.t(g),C,S)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,C){return this.g.delete(this.t(g),C)}copy(g,C,S){if((0,D.$Fk)(this.g))return this.g.copy(this.t(g),this.t(C),S);throw new Error("copy not supported")}cloneFile(g,C){if((0,D.$Gk)(this.g))return this.g.cloneFile(this.t(g),this.t(C));throw new Error("clone not supported")}s(g){const C=[];for(const S of g){if(S.resource.scheme!==this.f)continue;const m=this.u(S.resource);this.b.findSubstr(m)&&C.push({resource:m,type:S.type,cId:S.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$pac=R}),define(le[80],he([0,1,62]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Gb=e.$4Gb=e.edit=void 0;function A(I,R,k,g){const C=(0,O.$Dn)(I,R,k,g)[0];return C&&(I=I.substring(0,C.offset)+C.content+I.substring(C.offset+C.length)),I}e.edit=A;function D(I,R,k){let g=k;for(;g>=0;){if(I.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&I.charAt(g)===R.charAt(0))return g+2}return 0}e.$4Gb=D;function L(I,R,k){let g=k;for(;g>=0;)if(I.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&I.charAt(g)===R.charAt(1)))return g;return I.length-1}e.$5Gb=L}),define(le[235],he([0,1,30,55,12]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=void 0;function L(h,$,b,y,c,f){const d=[],l=[],v=[];if(!$){const z=h.filter(({identifier:Y})=>c.every(Q=>Q.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:d,removed:l,updated:v},remote:z.length>0?{added:z,updated:[],removed:[],all:z}:null}}h=h.map(S),$=$.map(S),b=b?b.map(S):null;const i=new Map,o=z=>{z.uuid&&i.set(z.id.toLowerCase(),z.uuid)};h.forEach(({identifier:z})=>o(z)),$.forEach(({identifier:z})=>o(z)),b?.forEach(({identifier:z})=>o(z)),y?.forEach(({identifier:z})=>o(z)),f?.forEach(z=>o(z));const n=z=>{const Y=z.identifier.uuid||i.get(z.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${z.identifier.id.toLowerCase()}`},s=(z,Y)=>(z.set(n(Y),Y),z),t=h.reduce(s,new Map),r=$.reduce(s,new Map),a=$.reduce((z,Y)=>s(z,(0,O.$Hn)(Y)),new Map),E=b?b.reduce(s,new Map):null,w=y.reduce(s,new Map),u=c.reduce((z,Y)=>{const Q=i.get(Y.toLowerCase());return z.add(Q?`uuid:${Q}`:`id:${Y.toLowerCase()}`)},new Set),p=f?f.reduce((z,{id:Y,uuid:Q})=>(Q=Q??i.get(Y.toLowerCase()),z.add(Q?`uuid:${Q}`:`id:${Y.toLowerCase()}`)),new Set):null,P=I(t,r,u,!1);if(P.added.size>0||P.removed.size>0||P.updated.size>0){const z=I(E,t,u,!1),Y=I(E,r,u,!0),Q=(x,W,X,H)=>{let V,te,oe;return W.installed?(V=H.pinned,oe=H.preRelease,V&&(te=H.version)):(V=X.pinned,oe=X.preRelease,V&&(te=X.version)),V===void 0&&(V=W.pinned,V&&(te=W.version)),oe===void 0&&(oe=W.preRelease),{...H,installed:W.installed||X.installed,pinned:V,preRelease:oe,version:te??(X.version&&(!W.installed||A.gt(X.version,W.version))?X.version:W.version),state:k(W,X,E?.get(x))}};for(const x of Y.removed.values()){const W=t.get(x);if(!W)continue;const X=(0,D.$4f)(E?.get(x)),H=p&&!p.has(x)&&X.installed;W.installed&&H?l.push(W.identifier):a.set(x,W)}for(const x of Y.added.values()){const W=(0,D.$4f)(r.get(x)),X=t.get(x);if(X){if(P.updated.has(x)){const H=Q(x,X,W,W);R(X,W,!1,!1)||v.push(m(H,x)),a.set(x,H)}}else W.installed&&d.push(m(W,x))}for(const x of Y.updated.values()){const W=(0,D.$4f)(r.get(x)),X=(0,D.$4f)(E?.get(x)),H=t.get(x);if(H)if(p&&!p.has(x)&&X.installed&&H.installed&&!W.installed)l.push(H.identifier);else{const te=Q(x,H,W,W);v.push(m(te,x)),a.set(x,te)}else W.installed&&d.push(m(W,x))}for(const x of z.added.values())Y.added.has(x)||a.set(x,(0,D.$4f)(t.get(x)));for(const x of z.updated.values()){if(Y.removed.has(x)||Y.updated.has(x))continue;const W=(0,D.$4f)(t.get(x)),X=(0,D.$4f)(r.get(x));a.set(x,Q(x,W,X,W))}for(const x of z.removed.values())Y.updated.has(x)||Y.removed.has(x)||w.has(x)||(0,D.$4f)(r.get(x)).installed&&p&&(p.has(x)||!(0,D.$4f)(E?.get(x)).installed||a.delete(x))}const N=[],F=I(r,a,new Set,!0),M=F.added.size>0||F.updated.size>0||F.removed.size>0;return M&&a.forEach((z,Y)=>N.push(m(z,Y))),{local:{added:d,removed:l,updated:v},remote:M?{added:[...F.added].map(z=>a.get(z)),updated:[...F.updated].map(z=>a.get(z)),removed:[...F.removed].map(z=>r.get(z)),all:N}:null}}e.$G8b=L;function I(h,$,b,y){const c=h?[...h.keys()].filter(i=>!b.has(i)):[],f=[...$.keys()].filter(i=>!b.has(i)),d=f.filter(i=>!c.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),l=c.filter(i=>!f.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),v=new Set;for(const i of c){if(l.has(i))continue;const o=h.get(i),n=$.get(i);(!n||!R(o,n,y,!0))&&v.add(i)}return{added:d,removed:l,updated:v}}function R(h,$,b,y){return!(h.disabled!==$.disabled||!!h.isApplicationScoped!=!!$.isApplicationScoped||y&&h.installed!==$.installed||h.installed&&$.installed&&(h.preRelease!==$.preRelease||h.pinned!==$.pinned||$.pinned&&h.version!==$.version)||!C(h.state,$.state)||b&&h.version!==$.version)}function k(h,$,b){const y=h.state,c=$.state,f=b?.state;if(!$.version||y&&A.gt(h.version,$.version))return y;if(c&&A.gt($.version,h.version)||!y)return c;if(!c)return y;const d=(0,O.$Hn)(y),l=f?g(f,c):{added:Object.keys(c).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},v=f?g(f,y):{added:Object.keys(y).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...l.added.values(),...l.updated.values()])d[i]=c[i];for(const i of l.removed.values())v.updated.has(i)||delete d[i];return d}function g(h,$){const b=Object.keys(h),y=Object.keys($),c=y.filter(l=>!b.includes(l)).reduce((l,v)=>(l.add(v),l),new Set),f=b.filter(l=>!y.includes(l)).reduce((l,v)=>(l.add(v),l),new Set),d=new Set;for(const l of b){if(f.has(l))continue;const v=h[l],i=$[l];(0,O.$Ln)(v,i)||d.add(l)}return{added:c,removed:f,updated:d}}function C(h={},$={}){const{added:b,removed:y,updated:c}=g(h,$);return b.size===0&&y.size===0&&c.size===0}function S(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function m(h,$){const b={...h,identifier:{id:h.identifier.id,uuid:$.startsWith("uuid:")?$.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete b.disabled,h.installed||delete b.installed,h.state||delete b.state,h.isApplicationScoped||delete b.isApplicationScoped,b}}),define(le[111],he([0,1,17,21,4]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Ib=e.$9Ib=void 0,e.$9Ib=(0,D.$ei)("IIgnoredExtensionsManagementService");let L=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const k=R.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),g=this.b().map(m=>m.toLowerCase()),C=[],S=[];if(Array.isArray(g))for(const m of g)m.startsWith("-")?S.push(m.substring(1)):C.push(m);return(0,O.$Mb)([...k,...C].filter(m=>!S.includes(m)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$0Ib=L,e.$0Ib=L=ye([K(0,A.$Ki)],L)}),define(le[236],he([0,1,17,34,30,94,80]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M8b=void 0;function R(l){return(0,A.$on)(l)||[]}async function k(l,v,i,o,n){const s=R(l),t=R(v),r=i?R(i):null,a=[...s,...t,...r||[]].map(Q=>Q.key),E=await n.resolveUserBindings(a),w=C(s,t,r,E);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:l,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};const u=m(s),p=m(t),P=r?m(r):null,N=$(u,p,E),F=P?$(P,u,E):{added:[...u.keys()].reduce((Q,x)=>(Q.add(x),Q),new Set),removed:new Set,updated:new Set},M=P?$(P,p,E):{added:[...p.keys()].reduce((Q,x)=>(Q.add(x),Q),new Set),removed:new Set,updated:new Set},z=g(N,F,M);let Y=l;for(const Q of z.removed.values())z.conflicts.has(Q)||(Y=f(Y,Q,o));for(const Q of z.added.values()){if(z.conflicts.has(Q))continue;const x=p.get(Q);if(x.some(W=>W.command!==`-${Q}`&&w.conflicts.has(E[W.key]))){z.conflicts.add(Q);continue}Y=c(Y,x,o)}for(const Q of z.updated.values()){if(z.conflicts.has(Q))continue;const x=p.get(Q);if(x.some(W=>W.command!==`-${Q}`&&w.conflicts.has(E[W.key]))){z.conflicts.add(Q);continue}Y=d(Y,Q,x,o)}return{mergeContent:Y,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.$M8b=k;function g(l,v,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of v.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(v.updated.has(r)?t.add(r):n.add(r));for(const r of v.added.values())t.has(r)||i.added.has(r)&&l.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(v.added.has(r)?l.updated.has(r)&&t.add(r):o.add(r));for(const r of v.updated.values())t.has(r)||i.updated.has(r)&&l.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(v.updated.has(r)?l.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function C(l,v,i,o){const n=new Set,s=S(l,o),t=S(v,o),r=i?S(i,o):null,a=h(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const E=r?h(r,s):{added:[...s.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=r?h(r,t):{added:[...t.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:u,removed:p,updated:P,conflicts:N}=g(a,E,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:p,updated:P,conflicts:N}}function S(l,v){const i=new Map;for(const o of l){const n=v[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function m(l){const v=new Map;for(const i of l){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=v.get(o);n||(n=[],v.set(o,n)),n.push(i)}return v}function h(l,v){const i=[...l.keys()],o=[...v.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=l.get(r).map(w=>({...w,key:r})),E=v.get(r).map(w=>({...w,key:r}));(0,O.$ub)(a,E,(w,u)=>y(w,u))||t.add(r)}return{added:n,removed:s,updated:t}}function $(l,v,i){const o=[...l.keys()],n=[...v.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,E)=>(a.add(E),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,E)=>(a.add(E),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const E=l.get(a).map(u=>({...u,key:i[u.key]})),w=v.get(a).map(u=>({...u,key:i[u.key]}));b(E,w)||r.add(a)}return{added:s,removed:t,updated:r}}function b(l,v){return!(!(0,O.$ub)(l.filter(({command:i})=>i[0]!=="-"),v.filter(({command:i})=>i[0]!=="-"),(i,o)=>y(i,o))||!(0,O.$ub)(l.filter(({command:i})=>i[0]==="-"),v.filter(({command:i})=>i[0]==="-"),(i,o)=>y(i,o)))}function y(l,v){if(l.command!==v.command||l.key!==v.key)return!1;const i=L.$cj.deserialize(l.when),o=L.$cj.deserialize(v.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!D.$Ln(l.args,v.args))}function c(l,v,i){for(const o of v)l=I.edit(l,[-1],o,i);return l}function f(l,v,i){const o=R(l);for(let n=o.length-1;n>=0;n--)(o[n].command===v||o[n].command===`-${v}`)&&(l=I.edit(l,[n],void 0,i));return l}function d(l,v,i,o){const n=R(l),s=n.findIndex(t=>t.command===v||t.command===`-${v}`);for(let t=n.length-1;t>=0;t--)(n[t].command===v||n[t].command===`-${v}`)&&(l=I.edit(l,[t],void 0,o));for(let t=i.length-1;t>=0;t--)l=I.edit(l,[s],i[t],o);return l}}),define(le[237],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U8b=e.$T8b=void 0;function O(L,I,R){const k={},g={},C=new Set;if(!I)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const S=A(L,I);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=A(R,L),h=A(R,I),$={},b={},y=new Set,c=new Set;for(const f of m.removed.values())h.updated.has(f)?k[f]=I[f]:y.add(f);for(const f of h.removed.values())c.has(f)||(m.updated.has(f)?c.add(f):C.add(f));for(const f of m.updated.values())c.has(f)||(h.updated.has(f)?S.updated.has(f)&&c.add(f):b[f]=L[f]);for(const f of h.updated.values())c.has(f)||(m.updated.has(f)?S.updated.has(f)&&c.add(f):L[f]!==void 0&&(g[f]=I[f]));for(const f of m.added.values())c.has(f)||(h.added.has(f)?S.updated.has(f)&&c.add(f):$[f]=L[f]);for(const f of h.added.values())c.has(f)||(m.added.has(f)?S.updated.has(f)&&c.add(f):k[f]=I[f]);return{local:{added:k,removed:[...C.values()],updated:g},remote:{added:$,removed:[...y.values()],updated:b},conflicts:[...c.values()]}}e.$T8b=O;function A(L,I){const R=L?Object.keys(L):[],k=I?Object.keys(I):[],g=k.filter(m=>!R.includes(m)).reduce((m,h)=>(m.add(h),m),new Set),C=R.filter(m=>!k.includes(m)).reduce((m,h)=>(m.add(h),m),new Set),S=new Set;for(const m of R){if(C.has(m))continue;const h=L[m],$=I[m];h!==$&&S.add(m)}return{added:g,removed:C,updated:S}}function D(L,I){const{added:R,removed:k,updated:g}=A(L,I);return R.size===0&&k.size===0&&g.size===0}e.$U8b=D}),define(le[238],he([0,1,30]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E0b=void 0;function A(L,I,R,k){const g={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!I){const m=L.filter(({id:h})=>!k.includes(h));return m.length?C.added=m:C=null,{local:g,remote:C}}const S=D(L,I,k);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const m=D(R,L,k),h=D(R,I,k);for(const $ of h.removed){const b=L.find(y=>y.id===$);b&&g.removed.push(b)}for(const $ of h.added){const b=I.find(y=>y.id===$);m.added.includes($)?S.updated.includes($)&&g.updated.push(b):g.added.push(b)}for(const $ of h.updated)g.updated.push(I.find(b=>b.id===$));for(const $ of m.added)h.added.includes($)||C.added.push(L.find(b=>b.id===$));for(const $ of m.updated)h.removed.includes($)||h.updated.includes($)||C.updated.push(L.find(b=>b.id===$));for(const $ of m.removed){const b=I.find(y=>y.id===$);b&&C.removed.push(b)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:g,remote:C}}e.$E0b=A;function D(L,I,R){L=L?L.filter(({id:h})=>!R.includes(h)):[],I=I.filter(({id:h})=>!R.includes(h));const k=L.map(({id:h})=>h),g=I.map(({id:h})=>h),C=g.filter(h=>!k.includes(h)),S=k.filter(h=>!g.includes(h)),m=[];for(const{id:h,name:$,shortName:b,icon:y,useDefaultFlags:c}of L){if(S.includes(h))continue;const f=I.find(d=>d.id===h);(!f||f.name!==$||f.shortName!==b||f.icon!==y||!(0,O.$Ln)(f.useDefaultFlags,c))&&m.push(h)}return{added:C,removed:S,updated:m}}}),define(le[25],he([0,1,17,12,174,44,29,4,103,41]),function(se,e,O,A,D,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jpb=e.$ipb=e.$hpb=e.$gpb=e.$fpb=e.$epb=e.$dpb=e.$cpb=e.$bpb=e.$apb=e.$_ob=e.MergeState=e.Change=e.SyncStatus=e.$$ob=e.$0ob=e.$9ob=e.UserDataSyncErrorCode=e.$8ob=e.$7ob=e.$6ob=e.$5ob=e.$4ob=e.$3ob=e.$2ob=e.$1ob=e.$Zob=e.SyncResource=e.$Yob=e.$Xob=e.$Wob=e.$Vob=e.$Uob=e.$Tob=void 0;function C(){const t=g.$Tn.as(L.$Yn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$Tob=C;function S(){const t=g.$Tn.as(L.$Yn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(w=>!!t[w].ignoreSync),a=Object.keys(t).filter(w=>t[w].scope===2||t[w].scope===6),E=C();return(0,O.$Mb)([...r,...a,...E])}e.$Uob=S,e.$Vob="settingsSync",e.$Wob="settingsSync.keybindingsPerPlatform";function m(){const t="vscode://schemas/ignoredSettings",r=g.$Tn.as(L.$Yn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.$Wob]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:I.$yo,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.$Tn.as(k.$Un.JSONContribution),E=()=>{const w=C(),u=S(),p=Object.keys(L.$Zn.properties).filter(F=>!u.includes(F)),P=u.filter(F=>!w.includes(F)),N={items:{type:"string",enum:[...p,...P.map(F=>`-${F}`)]}};a.registerSchema(t,N)};return r.onDidUpdateConfiguration(()=>E())}e.$Xob=m;function h(t){return t&&(0,A.$Uf)(t)&&(0,A.$Sf)(t.id)&&Array.isArray(t.scopes)}e.$Yob=h;var $;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})($||(e.SyncResource=$={})),e.$Zob=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function b(t,...r){return t?[t,...r]:r}e.$1ob=b;function y(t,r,a,E){return E.joinPath(a.userDataSyncHome,...b(t,r,`lastSync${r}.json`))}e.$2ob=y,e.$3ob=(0,R.$ei)("IUserDataSyncStoreManagementService"),e.$4ob=(0,R.$ei)("IUserDataSyncStoreService"),e.$5ob=(0,R.$ei)("IUserDataSyncLocalStoreService"),e.$6ob="x-operation-id",e.$7ob="X-Execution-Id";function c(t){const r={};return r[e.$7ob]=t,r}e.$8ob=c;var f;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(f||(e.UserDataSyncErrorCode=f={}));class d extends Error{constructor(r,a,E,w){super(r),this.code=a,this.resource=E,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$9ob=d;class l extends d{constructor(r,a,E,w,u){super(r,E,void 0,u),this.url=a,this.serverCode=w}}e.$0ob=l;class v extends d{constructor(r,a){super(r,a)}}e.$$ob=v,function(t){function r(a){if(a instanceof t)return a;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(E&&E[1]){const w=E[2]==="unknown"?void 0:E[2],u=E[3]==="unknown"?void 0:E[3];return new t(a.message,E[1],w,u)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(d||(e.$9ob=d={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$_ob="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$apb=s,e.$bpb=(0,R.$ei)("IUserDataSyncEnablementService"),e.$cpb=(0,R.$ei)("IUserDataSyncService"),e.$dpb=(0,R.$ei)("IUserDataSyncResourceProviderService"),e.$epb=(0,R.$ei)("IUserDataAutoSyncService"),e.$fpb=(0,R.$ei)("IUserDataSyncUtilService"),e.$gpb=(0,R.$ei)("IUserDataSyncLogService"),e.$hpb="userDataSync",e.$ipb="vscode-userdata-sync",e.$jpb="preview"}),define(le[239],he([0,1,30,25]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rIb=void 0;function D(I,R,k,g,C){if(!R)return{remote:{added:Object.keys(I),removed:[],updated:[],all:Object.keys(I).length>0?I:null},local:{added:{},removed:[],updated:{}}};const S=L(I,R);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=k?L(k,R):{added:Object.keys(R).reduce((f,d)=>(f.add(d),f),new Set),removed:new Set,updated:new Set},h=k?L(k,I):{added:Object.keys(I).reduce((f,d)=>(f.add(d),f),new Set),removed:new Set,updated:new Set},$={added:{},removed:[],updated:{}},b=O.$Hn(R),y=!k;for(const f of h.added.values())f!==A.$_ob&&y&&m.added.has(f)||(b[f]=I[f]);for(const f of h.updated.values())b[f]=I[f];for(const f of h.removed.values())g.unregistered.includes(f)||delete b[f];for(const f of m.added.values()){const d=R[f];if(g.machine.includes(f)){C.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(k&&h.added.has(f))continue;const l=I[f];l&&l.value===d.value||f===A.$_ob&&y&&h.added.has(f)||(l?$.updated[f]=d:$.added[f]=d)}for(const f of m.updated.values()){const d=R[f];if(g.machine.includes(f)){C.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(f)||h.removed.has(f))continue;const l=I[f];l&&l.value===d.value||($.updated[f]=d)}for(const f of m.removed.values()){if(g.machine.includes(f)){C.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}h.updated.has(f)||h.removed.has(f)||$.removed.push(f)}const c=L(R,b);return{local:$,remote:{added:[...c.added],updated:[...c.updated],removed:[...c.removed],all:c.added.size===0&&c.removed.size===0&&c.updated.size===0?null:b}}}e.$rIb=D;function L(I,R){const k=Object.keys(I),g=Object.keys(R),C=g.filter(h=>!k.includes(h)).reduce((h,$)=>(h.add($),h),new Set),S=k.filter(h=>!g.includes(h)).reduce((h,$)=>(h.add($),h),new Set),m=new Set;for(const h of k){if(S.has(h))continue;const $=I[h],b=R[h];O.$Ln($,b)||m.add(h)}return{added:C,removed:S,updated:m}}}),define(le[240],he([0,1,17,34,62,42,30,80,25]),function(se,e,O,A,D,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Gb=e.$0Gb=e.$9Gb=e.$8Gb=e.$7Gb=e.$6Gb=void 0;function g(a,E,w){let u=[];w?u=S(w):u=C(E);const p=[],P=[...(0,k.$Tob)()];if(Array.isArray(u))for(const N of u)N.startsWith("-")?P.push(N.substring(1)):p.push(N);return(0,O.$Mb)([...a,...p].filter(N=>!P.includes(N)))}e.$6Gb=g;function C(a){let E=a.inspect("settingsSync.ignoredSettings").userValue;return E!==void 0||(E=a.inspect("sync.ignoredSettings").userValue,E!==void 0)?E:a.getValue("settingsSync.ignoredSettings")||[]}function S(a){const E=(0,A.$on)(a);return E?E["settingsSync.ignoredSettings"]||E["sync.ignoredSettings"]||[]:[]}function m(a,E){const w=(0,A.$on)(a)||{};let u="{}";for(const p of Object.keys(w)){const P=(0,D.$Dn)(u,[p],w[p],E);u=(0,D.$Gn)(u,P)}return u}e.$7Gb=m;function h(a,E,w,u){if(w.length){const p=r(E),P=(0,A.$on)(E)||{},N=(0,A.$on)(a);if(!N)return a;const F=[];for(const M of w){const z=P[M],Y=N[M];z===void 0?a=R.edit(a,[M],void 0,u):Y!==void 0?a=R.edit(a,[M],z,u):F.push(i(M,p))}F.sort((M,z)=>M.startOffset-z.startOffset),F.forEach(M=>a=f(M.setting.key,E,a,u))}return a}e.$8Gb=h;function $(a,E,w,u,p,P){const N=h(a,E,u,P),F=w!==N,M=w!==E;if(!F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:h(E,a,u,P),remoteContent:null,hasConflicts:!1};if(w===null&&y(a)){const T=b(a,E,u)?null:h(E,a,u,P);return{conflictsSettings:[],localContent:T,remoteContent:null,hasConflicts:!1}}let z=a,Y=E;const Q=(0,A.$on)(a),x=(0,A.$on)(E),W=w?(0,A.$on)(w):null,X=u.reduce((T,B)=>(T.add(B),T),new Set),H=c(Q,x,X),V=c(W,Q,X),te=c(W,x,X),oe=new Map,ee=new Set,ae=T=>{ee.add(T);const B=p.filter(({key:q})=>q===T)[0];B?(z=R.edit(z,[T],B.value,P),Y=R.edit(Y,[T],B.value,P)):oe.set(T,{key:T,localValue:Q[T],remoteValue:x[T]})};for(const T of V.removed.values())te.updated.has(T)?ae(T):Y=R.edit(Y,[T],void 0,P);for(const T of te.removed.values())ee.has(T)||(V.updated.has(T)?ae(T):z=R.edit(z,[T],void 0,P));for(const T of V.updated.values())ee.has(T)||(te.updated.has(T)?H.updated.has(T)&&ae(T):Y=R.edit(Y,[T],Q[T],P));for(const T of te.updated.values())ee.has(T)||(V.updated.has(T)?H.updated.has(T)&&ae(T):z=R.edit(z,[T],x[T],P));for(const T of V.added.values())ee.has(T)||(te.added.has(T)?H.updated.has(T)&&ae(T):Y=f(T,z,Y,P));for(const T of te.added.values())ee.has(T)||(V.added.has(T)?H.updated.has(T)&&ae(T):z=f(T,Y,z,P));const G=oe.size>0||!b(z,Y,u),U=G||!b(z,a,[]),j=G||!b(Y,E,[]);return{localContent:U?z:null,remoteContent:j?Y:null,conflictsSettings:[...oe.values()],hasConflicts:G}}e.$9Gb=$;function b(a,E,w){if(a===E)return!0;const u=(0,A.$on)(a),p=(0,A.$on)(E),P=w.reduce((M,z)=>(M.add(z),M),new Set),N=r(a).filter(M=>!(M.setting&&P.has(M.setting.key))),F=r(E).filter(M=>!(M.setting&&P.has(M.setting.key)));if(N.length!==F.length)return!1;for(let M=0;M<N.length;M++){const z=N[M],Y=F[M];if(z.setting&&Y.setting){if(z.setting.key!==Y.setting.key||!I.$Ln(u[z.setting.key],p[z.setting.key]))return!1}else if(!z.setting&&!Y.setting){if(z.value!==Y.value)return!1}else return!1}return!0}function y(a){return a?r(a).length===0:!0}e.$0Gb=y;function c(a,E,w){const u=a?Object.keys(a).filter(M=>!w.has(M)):[],p=Object.keys(E).filter(M=>!w.has(M)),P=p.filter(M=>!u.includes(M)).reduce((M,z)=>(M.add(z),M),new Set),N=u.filter(M=>!p.includes(M)).reduce((M,z)=>(M.add(z),M),new Set),F=new Set;if(a)for(const M of u){if(N.has(M))continue;const z=a[M],Y=E[M];I.$Ln(z,Y)||F.add(M)}return{added:P,removed:N,updated:F}}function f(a,E,w,u){const p=(0,A.$on)(E),P=r(E),N=r(w),F=d(a,P,N);return l(w,a,p[a],F,N,u)}e.$$Gb=f;function d(a,E,w){const u=E.findIndex(P=>P.setting?.key===a),p=E[u-1];if(p){if(p.setting){const N=i(p.setting.key,w);if(N)return{index:w.indexOf(N),insertAfter:!0}}else{const N=o(u,E);if(N){const F=i(N.setting.key,w);if(F){const M=n(w.indexOf(F),w),z=s(E,N,E[u]);if(M){const Y=s(w,F,M),Q=t(z,Y);return Q?{index:w.indexOf(Q),insertAfter:!0}:{index:w.indexOf(M),insertAfter:!1}}else{const Y=s(w,F,w[w.length-1]),Q=t(z,Y);return Q?{index:w.indexOf(Q),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const P=E[u+1];if(P)if(P.setting){const N=i(P.setting.key,w);if(N)return{index:w.indexOf(N),insertAfter:!1}}else{const N=n(u,E);if(N){const F=i(N.setting.key,w);if(F){const M=o(w.indexOf(F),w),z=s(E,E[u],N);if(M){const Y=s(w,M,F),Q=t(z.reverse(),Y.reverse());return Q?{index:w.indexOf(Q),insertAfter:!1}:{index:w.indexOf(M),insertAfter:!0}}else{const Y=s(w,w[0],F),Q=t(z.reverse(),Y.reverse());return Q?{index:w.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function l(a,E,w,u,p,P){let N;return u.index===-1?N=(0,D.$Dn)(a,[E],w,P):N=v(a,E,w,u,p,P).map(F=>(0,D.$En)(a,F,P)[0]),(0,D.$Gn)(a,N)}function v(a,E,w,u,p,P){const N=`${JSON.stringify(E)}: ${JSON.stringify(w)}`,F=(0,L.$An)(P,a),M=p[u.index];if(u.insertAfter){const z=[];if(M.setting)z.push({offset:M.endOffset,length:0,content:","+N});else{const Y=n(u.index,p),Q=o(u.index,p),x=Q?.setting?.commaOffset;Q&&x===void 0&&z.push({offset:Q.endOffset,length:0,content:","});const W=x!==void 0&&x>M.endOffset;z.push({offset:W?x+1:M.endOffset,length:0,content:Y?F+N+",":F+N})}return z}else{if(M.setting)return[{offset:M.startOffset,length:0,content:N+","}];const z=(p[u.index-1]&&!p[u.index-1].setting?F:"")+N+(n(u.index,p)?",":"")+F;return[{offset:M.startOffset,length:0,content:z}]}}function i(a,E){return E.filter(w=>w.setting?.key===a)[0]}function o(a,E){for(let w=a-1;w>=0;w--)if(E[w].setting)return E[w]}function n(a,E){for(let w=a+1;w<E.length;w++)if(E[w].setting)return E[w]}function s(a,E,w){const u=a.indexOf(E),p=a.indexOf(w);return a.filter((P,N)=>u<N&&N<p)}function t(a,E){if(a.length&&E.length){let w=0;for(;w<E.length&&w<a.length;w++)if(a[w].value!==E[w].value)return E[w-1];return E[w-1]}}function r(a){const E=[];let w=-1,u,p;const P={onObjectBegin:N=>{w++},onObjectProperty:(N,F,M)=>{w===0&&(u=F,p=N)},onObjectEnd:(N,F)=>{w--,w===0&&E.push({startOffset:u,endOffset:N+F,value:a.substring(u,N+F),setting:{key:p,commaOffset:void 0}})},onArrayBegin:(N,F)=>{w++},onArrayEnd:(N,F)=>{w--,w===0&&E.push({startOffset:u,endOffset:N+F,value:a.substring(u,N+F),setting:{key:p,commaOffset:void 0}})},onLiteralValue:(N,F,M)=>{w===0&&E.push({startOffset:u,endOffset:F+M,value:a.substring(u,F+M),setting:{key:p,commaOffset:void 0}})},onSeparator:(N,F,M)=>{if(w===0&&N===","){let z=E.length-1;for(;z>=0&&!E[z].setting;z--);const Y=E[z];Y&&E.splice(z,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:F}})}},onComment:(N,F)=>{w===0&&E.push({startOffset:N,endOffset:N+F,value:a.substring(N,N+F)})}};return(0,A.$vn)(a,P),E}}),define(le[81],he([0,1,3,2,4,25]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QGb=e.$PGb=void 0,e.$PGb=(0,D.$ei)("IUserDataSyncAccountService");let I=class extends A.$Tc{get account(){return this.a}constructor(k,g){super(),this.g=k,this.h=g,this.b=this.B(new O.$5d),this.onDidChangeAccount=this.b.event,this.c=this.B(new O.$5d),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$QGb=I,e.$QGb=I=ye([K(0,L.$4ob),K(1,L.$gpb)],I)}),define(le[241],he([0,1,20,175,15,8,25]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Ib=void 0;let R=class extends L.$Dj{constructor(g,C){super(),this.g=this.B(g.createLogger((0,O.$Rg)(C.logsHome,`${I.$hpb}.log`),{id:I.$hpb,name:(0,A.localize)(0,null)}))}trace(g,...C){this.g.trace(g,...C)}debug(g,...C){this.g.debug(g,...C)}info(g,...C){this.g.info(g,...C)}warn(g,...C){this.g.warn(g,...C)}error(g,...C){this.g.error(g,...C)}flush(){this.g.flush()}};e.$$Ib=R,e.$$Ib=R=ye([K(0,L.$zj),K(1,D.$li)],R)}),define(le[242],he([0,1,6,3,2]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W_b=void 0;class L extends D.$Tc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:k,getActiveWindowId:g}){super(),this.a=this.B(new D.$Sc),A.Event.latch(A.Event.any(R,k))(this.f,this,this.a),this.b=(0,O.$4g)(()=>g()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$W_b=L}),define(le[112],he([0,1,178,16,48,20,10,4,23]),function(se,e,O,A,D,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.WorkbenchState=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0,e.$ni=(0,R.$ei)("contextService");function g(s){const t=s;return typeof t?.id=="string"&&I.URI.isUri(t.uri)}e.$oi=g;function C(s){return typeof s?.id=="string"&&!g(s)&&!m(s)}e.$pi=C,e.$qi={id:"ext-dev"},e.$ri={id:"empty-window"};function S(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,A.$nc)(s)}:t?e.$qi:e.$ri;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$si=S;function m(s){const t=s;return typeof t?.id=="string"&&I.URI.isUri(t.configPath)}e.$ti=m;function h(s){const t=s;if(t?.uri)return{id:t.id,uri:I.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:I.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$ui=h;var $;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function b(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$vi=b;function y(s){const t=s;return!!(t&&typeof t=="object"&&I.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$wi=y;class c{constructor(t,r,a,E,w){this.h=t,this.j=a,this.k=E,this.l=w,this.c=D.$ki.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=D.$ki.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$xi=c;class f{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.$Rg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$yi=f;function d(s){return new f({uri:s,index:0,name:(0,L.$Ng)(s)},{uri:s.toString()})}e.$zi=d,e.$Ai="code-workspace",e.$Bi=`.${e.$Ai}`,e.$Ci=[{name:(0,O.localize)(0,null),extensions:[e.$Ai]}],e.$Di="workspace.json";function l(s,t){return L.$Ig.isEqualOrParent(s,t.untitledWorkspacesHome)}e.$Ei=l;function v(s){let t;return I.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===k.Schemas.tmp}e.$Fi=v,e.$Gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$Gi}e.$Hi=i;function o(s,t){return!l(s,t)&&!v(s)}e.$Ii=o;function n(s){return(typeof s=="string"?(0,A.$oc)(s):(0,L.$Pg)(s))===e.$Bi}e.$Ji=n}),define(le[18],he([0,1,53,3,2,20,10,169,15,11,4,8,112,35,28,6,32,27,12]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.ProfileResourceType=void 0;var d;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function l(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&I.URI.isUri(t.location)&&I.URI.isUri(t.globalStorageHome)&&I.URI.isUri(t.settingsResource)&&I.URI.isUri(t.keybindingsResource)&&I.URI.isUri(t.tasksResource)&&I.URI.isUri(t.snippetsHome)&&I.URI.isUri(t.extensionsResource))}e.$al=l,e.$bl=(0,C.$ei)("IUserDataProfilesService");function v(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:I.URI.revive(s.location).with({scheme:t}),globalStorageHome:I.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:I.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:I.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:I.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:I.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:I.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:I.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$cl=v;function i(s,t,r,a,E,w){return{id:s,name:t,location:r,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:w&&E?.useDefaultFlags?.globalState?w.globalStorageHome:(0,L.$Rg)(r,"globalStorage"),settingsResource:w&&E?.useDefaultFlags?.settings?w.settingsResource:(0,L.$Rg)(r,"settings.json"),keybindingsResource:w&&E?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,L.$Rg)(r,"keybindings.json"),tasksResource:w&&E?.useDefaultFlags?.tasks?w.tasksResource:(0,L.$Rg)(r,"tasks.json"),snippetsHome:w&&E?.useDefaultFlags?.snippets?w.snippetsHome:(0,L.$Rg)(r,"snippets"),extensionsResource:w&&E?.useDefaultFlags?.extensions?w.extensionsResource:(0,L.$Rg)(r,"extensions.json"),cacheHome:(0,L.$Rg)(a,s),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}e.$dl=i;let o=class extends D.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,E){super(),this.t=t,this.u=r,this.w=a,this.y=E,this.f=!0,this.h=this.B(new A.$5d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$5d),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$5d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$5d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$Rg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$Rg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,f.$Sf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}r.push(i((0,L.$Og)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},t))}}catch(w){this.y.error(w)}const a=new h.$Ac,E=new Map;if(r.length)try{const w=this.Q();if(w.workspaces)for(const[u,p]of Object.entries(w.workspaces)){const P=I.URI.parse(u),N=r.find(F=>F.id===p);N&&a.set(P,N)}if(w.emptyWindows)for(const[u,p]of Object.entries(w.emptyWindows)){const P=r.find(N=>N.id===p);P&&E.set(u,P)}}catch(w){this.y.error(w)}this.z={profiles:r,workspaces:a,emptyWindows:E}}return this.z}D(){const t=i("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,c.$Xe)(r)}\\s(\\d+)`);let E=0;for(const u of this.profiles){const p=a.exec(u.name),P=p?parseInt(p[1]):0;E=P>E?P:E}const w=`${r} ${E+1}`;return this.createProfile((0,O.$5i)((0,y.$Ag)()).toString(16),w,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,O.$5i)((0,y.$Ag)()).toString(16),t,r,a)}async createProfile(t,r,a,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(t,r,a);return E&&await this.setProfileForWorkspace(E,w),w}async F(t,r,a){if(!(0,f.$Sf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(r);return E||(E=(async()=>{try{const w=this.profiles.find(P=>P.name===r||P.id===t);if(w)return w;const u=i(t,r,(0,L.$Rg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(u.location);const p=[];return this.j.fire({profile:u,join(P){p.push(P)}}),await b.Promises.settled(p),this.I([u],[],[]),u}finally{this.r.delete(r)}})(),this.r.set(r,E)),E}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(E=>E.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(E=>E.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(E){a.push(E)}});try{await Promise.allSettled(a)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(E){(0,g.$Sk)(E)!==1&&this.y.error(E)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(E=>E.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return I.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,m.$oi)(t)?t.uri:(0,m.$ti)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const E=[...this.profiles,...t],w=[];this.s.profiles=[];for(let u of E)u.isDefault||r.some(p=>u.id===p.id)||(u=a.find(p=>u.id===p.id)??u,u.isTransient?this.s.profiles.push(u):w.push({location:u.location,name:u.name,shortName:u.shortName,icon:u.icon,useDefaultFlags:u.useDefaultFlags}));this.P(w),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const E=this.G(t),w=a?this.s:this.C;I.URI.isUri(E)?(w.workspaces.delete(E),r&&w.workspaces.set(E,r)):(w.emptyWindows.delete(E),r&&w.emptyWindows.set(E,r)),a||this.M()}M(){const t={};for(const[a,E]of this.C.workspaces.entries())t[a.toString()]=E.id;const r={};for(const[a,E]of this.C.emptyWindows.entries())r[a.toString()]=E.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[w,u]of Object.entries(t.workspaces)){const p=I.URI.parse(u);r[w]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}const E={};if(t.emptyWindows)for(const[w,u]of Object.entries(t.emptyWindows)){const p=I.URI.parse(u);E[w]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}return{workspaces:r,emptyWindows:E}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$el=o,e.$el=o=ye([K(0,k.$li),K(1,g.$Bk),K(2,$.$_k),K(3,S.$yj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$fl=n}),define(le[243],he([0,1,6,2,18]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=void 0;let L=class extends A.$Tc{constructor(R){super(),this.B(new O.$qh(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$9ac=L,e.$9ac=L=ye([K(0,D.$bl)],L)}),define(le[244],he([0,1,17,6,26,7,3,2,5,12,10,152,29,33,45,8,24,22,28,18]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=e.$3p=e.$2p=void 0;let l=class extends R.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,E,w,u){super(),this.z=t,this.C=r,this.D=a,this.F=E,this.G=w,this.H=u,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new I.$5d),this.s=this.B(new I.$5d),this.t=this.B(new I.$5d),this.u=this.B(new I.$5d),this.w=this.B(new I.$5d),this.y=[],this.B((0,R.$Rc)(()=>{this.j.forEach(({task:p})=>p.cancel()),this.m.forEach(p=>p.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,m.$Io)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const E=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:w})=>(0,h.$_o)(w,t.identifier));if(E?.local)return E?.local;throw E?.error?E.error:new m.$Lo(`Unknown error while installing extension ${t.identifier.id}`,m.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new m.$Lo(S.localize(0,null),m.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:E,options:w})=>{try{const u=await this.N(E,!!w?.installGivenVersion,!!w?.installPreReleaseVersion);a.push({...u,options:w})}catch(u){r.push({identifier:E.identifier,operation:2,source:E,error:u})}})),a.length&&r.push(...await this.I(a));for(const E of r)E.error&&(this.F.error("Failed to install extension.",E.identifier.id),this.F.error(E.error),E.source&&!C.URI.isUri(E.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,h.$hp)(E.source),error:E.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,r)}async toggleAppliationScope(t,r){if((0,$.$zm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(t,this.H.defaultProfile.extensionsResource,r));for(const E of this.H.profiles){const w=(await this.getInstalled(1,E.extensionsResource)).find(u=>(0,h.$_o)(u.identifier,t.identifier));w?this.w.fire(w):this.u.fire({identifier:t.identifier,profileLocation:E.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[],a=new Map,E=[],w=[],u=(P,N)=>`${h.$ap.create(P).toString()}-${N.toString()}`,p=(P,N,F)=>{const M=this.Y(P,N,F),z=C.URI.isUri(N)?N.path:`${N.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`;a.set(z,{task:M,manifest:P}),this.n.fire({identifier:M.identifier,source:N,profileLocation:F.profileLocation}),this.F.info("Installing extension:",M.identifier.id),C.URI.isUri(N)||this.j.set(u(N,F.profileLocation),{task:M,waitingTasks:[]})};try{for(const{manifest:P,extension:N,options:F}of t){const M=F.isApplicationScoped||F.isBuiltin||(0,$.$zm)(P),z={...F,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(N)?F.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:M,profileLocation:M?this.H.defaultProfile.extensionsResource:F.profileLocation??this.X()},Y=C.URI.isUri(N)?void 0:this.j.get(u(N,z.profileLocation));Y?(this.F.info("Extension is already requested to install",Y.task.identifier.id),E.push(Y.task.waitUntilTaskIsFinished())):p(P,N,z)}await Promise.all([...a.values()].map(async({task:P,manifest:N})=>{if(P.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",P.identifier.id);else try{const F=await this.M(P.identifier,N,!!P.options.installOnlyNewlyAddedFromExtensionPack,!!P.options.installPreReleaseVersion,P.options.profileLocation),M=await this.getInstalled(void 0,P.options.profileLocation),z={...P.options,donotIncludePackAndDependencies:!0,context:{...P.options.context,[m.$Do]:!0}};for(const{gallery:Y,manifest:Q}of(0,O.$Mb)(F,({gallery:x})=>x.identifier.id)){if(a.has(`${Y.identifier.id.toLowerCase()}-${z.profileLocation.toString()}`))continue;const x=this.j.get(u(Y,z.profileLocation));if(x){if(this.J(P,x.task)){const W=x.task.identifier;this.F.info("Waiting for already requested installing extension",W.id,P.identifier.id),x.waitingTasks.push(P),E.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,X=>X.some(H=>(0,h.$_o)(H.identifier,W)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",W.id,P.identifier.id),!X.find(V=>(0,h.$_o)(V.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else M.some(({identifier:W})=>(0,h.$_o)(W,Y.identifier))||p(Q,Y,z)}}catch(F){if(C.URI.isUri(P.source))(0,O.$Lb)(N.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",P.identifier.id,F.message),(0,O.$Lb)(N.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",P.identifier.id,F.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",P.identifier.id),F}})),await this.L([...a.values()].map(async({task:P})=>{const N=new Date().getTime();try{const F=await P.run();if(await this.L(this.y.map(M=>M.postInstall(F,P.source,P.options,D.CancellationToken.None))),!C.URI.isUri(P.source)){const M=P.operation===3,z=M?void 0:(new Date().getTime()-P.source.lastUpdated)/1e3;if(o(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$hp)(P.source),verificationStatus:P.verificationStatus,duration:new Date().getTime()-N,durationSinceUpdate:z}),k.$o&&P.operation!==3)try{await this.z.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,"install")}catch{}}w.push({local:F,identifier:P.identifier,operation:P.operation,source:P.source,context:P.options.context,profileLocation:P.profileLocation,applicationScoped:F.isApplicationScoped})}catch(F){throw this.F.error("Error while installing the extension",P.identifier.id,(0,L.$0)(F)),F}})),E.length&&await this.L(E);for(const P of w)this.F.info("Extension installed successfully:",P.identifier.id),r.push(P);return r}catch(P){w.length&&await Promise.allSettled(w.map(async({local:N,profileLocation:F})=>{try{await this.Z(N,{versionOnly:!0,profileLocation:F}).run(),this.F.info("Rollback: Uninstalled extension",N.identifier.id)}catch(M){this.F.warn("Rollback: Error while uninstalling extension",N.identifier.id,(0,L.$0)(M))}}));for(const{task:N}of a.values())N.cancel(),r.push({identifier:N.identifier,operation:2,source:N.source,context:N.options.context,profileLocation:N.profileLocation,error:P});throw P}finally{for(const{task:P}of a.values())P.source&&!C.URI.isUri(P.source)&&this.j.delete(u(P.source,P.profileLocation));r.length&&this.s.fire(r)}}J(t,r){for(const[,{task:a,waitingTasks:E}]of this.j.entries())if(a===t&&(E.includes(r)||E.some(w=>this.J(w,r)))||a===r&&E[0]&&!this.J(t,E[0]))return!1;return!0}async L(t){const r=[],a=[],E=await Promise.allSettled(t);for(const w of E)w.status==="fulfilled"?r.push(w.value):a.push(w.reason);if(a.length)throw v(a);return r}async M(t,r,a,E,w){if(!this.z.isEnabled())return[];const u=await this.getInstalled(void 0,w),p=[],P=[],N=async(F,M)=>{p.push(F);const z=M.extensionDependencies||[],Y=[...z];if(M.extensionPack){const Q=a?u.find(x=>(0,h.$_o)(x.identifier,F)):void 0;for(const x of M.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(W=>(0,h.$_o)({id:W},{id:x}))||Y.every(W=>!(0,h.$_o)({id:W},{id:x}))&&Y.push(x)}if(Y.length){const Q=Y.filter(x=>p.every(W=>!(0,h.$_o)(W,{id:x})));if(Q.length){const x=await this.z.getExtensions(Q.map(W=>({id:W,preRelease:E})),D.CancellationToken.None);for(const W of x){if(p.find(V=>(0,h.$_o)(V,W.identifier)))continue;const X=z.some(V=>(0,h.$_o)({id:V},W.identifier));let H;try{H=await this.N(W,!1,E)}catch(V){if(X)throw V;this.F.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,L.$0)(V));continue}P.push({gallery:H.extension,manifest:H.manifest}),await N(H.extension.identifier,H.manifest)}}}};return await N(t,r),P}async N(t,r,a){let E;const w=await this.getExtensionsControlManifest();if(w.malicious.some(P=>(0,h.$_o)(t.identifier,P)))throw new m.$Lo(S.localize(1,null,t.identifier.id),m.ExtensionManagementErrorCode.Malicious);const u=w.deprecated[t.identifier.id.toLowerCase()];if(u?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${u.extension.id}' extension instead.`),E=(await this.z.getExtensions([{id:u.extension.id,preRelease:u.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0],!E)throw new m.$Lo(S.localize(2,null,t.identifier.id,u.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const P=await this.getTargetPlatform();throw new m.$Lo(S.localize(3,null,t.identifier.id,this.G.nameLong,(0,m.$Eo)(P)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(E=await this.O(t,r,a),!E)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],D.CancellationToken.None))[0]?new m.$Lo(S.localize(4,null,t.displayName??t.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$Lo(S.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",E.identifier.id);const p=await this.z.getManifest(E,D.CancellationToken.None);if(p===null)throw new m.$Lo(`Missing manifest for extension ${E.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(p.version!==E.version)throw new m.$Lo(`Cannot install '${E.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:p}}async O(t,r,a){const E=await this.getTargetPlatform();let w=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(w=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:E,compatible:!0},D.CancellationToken.None))[0]||null),!w&&await this.z.isExtensionCompatible(t,a,E)&&(w=t),w||(r?w=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:E,compatible:!0},D.CancellationToken.None))[0]||null:w=await this.z.getCompatibleExtension(t,a,E)),w}async P(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},E=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,w=this.m.get(E(t.identifier));if(w)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),w.waitUntilTaskIsFinished();const u=F=>{const M=this.Z(F,a);return this.m.set(E(M.extension.identifier),M),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.t.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),M},p=(F,M)=>{M?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),M.message):this.F.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,M.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,h.$gp)(F),error:M}),this.u.fire({identifier:F.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},P=[],N=[];try{P.push(u(t));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const M=this.S(t,F);for(const z of M)this.m.has(E(z.identifier))?this.F.info("Extensions is already requested to uninstall",z.identifier.id):P.push(u(z))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(P.map(M=>M.extension),F,t),await this.L(P.map(async M=>{try{if(await M.run(),await this.L(this.y.map(z=>z.postUninstall(M.extension,a,D.CancellationToken.None))),M.extension.identifier.uuid)try{await this.z.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}p(M.extension)}catch(z){const Y=z instanceof m.$Lo?z:new m.$Lo((0,L.$0)(z),m.ExtensionManagementErrorCode.Internal);throw p(M.extension,Y),Y}finally{N.push(M)}}))}catch(F){const M=F instanceof m.$Lo?F:new m.$Lo((0,L.$0)(F),m.ExtensionManagementErrorCode.Internal);for(const z of P){try{z.cancel()}catch{}N.includes(z)||p(z.extension,M)}throw M}finally{for(const F of P)this.m.delete(E(F.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}Q(t,r,a){for(const E of t){const w=this.U(E,r);if(w.length){const u=w.filter(p=>!t.some(P=>(0,h.$_o)(P.identifier,p.identifier)));if(u.length)throw new Error(this.R(E,u,a))}}}R(t,r,a){return a===t?r.length===1?S.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?S.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const E=t.manifest.extensionPack?t.manifest.extensionPack:[];if(E.length){const w=r.filter(p=>!p.isBuiltin&&E.some(P=>(0,h.$_o)({id:P},p.identifier))),u=[];for(const p of w)u.push(...this.S(p,r,a));return[...w,...u]}return[]}U(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(E=>(0,h.$_o)({id:E},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$0)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$2p=l,e.$2p=l=ye([K(0,m.$Ko),K(1,c.$Fl),K(2,f.$_k),K(3,b.$yj),K(4,y.$Qj),K(5,d.$bl)],l);function v(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$3p=v;function i(s){if(s instanceof m.$Lo)return s;if(s instanceof m.$Mo){const r=new m.$Lo(s.message,m.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new m.$Lo(s.message,m.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}e.$4p=i;function o(s,t,{extensionData:r,verificationStatus:a,duration:E,error:w,durationSinceUpdate:u}){let p,P;(0,g.$1f)(a)&&(a===!0?a="Verified":(a===!1||(p=m.ExtensionManagementErrorCode.Signature,P=a),a="Unverified")),w&&(w instanceof m.$Lo||w instanceof m.$Mo?(p=w.code,w.code===m.ExtensionManagementErrorCode.Signature&&(P=w.message)):p=m.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!w,duration:E,errorcode:p,errorcodeDetail:P,durationSinceUpdate:u})}class n{constructor(){this.d=new A.$dh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.$4g)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$4g)(t=>new Promise((r,a)=>{const E=t.onCancellationRequested(()=>{E.dispose(),a(new L.$5)})})),this.d.open()),this.g.cancel()}}e.$5p=n}),define(le[51],he([0,1,6,14,2,3,35,10,29,33,11,4,8,18,28,12,7,22]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=e.$6p=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class d extends Error{constructor(n,s){super(n),this.code=s}}e.$6p=d,e.$7p=(0,S.$ei)("IExtensionsProfileScannerService");let l=class extends D.$Tc{constructor(n,s,t,r,a,E){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=E,this.b=this.B(new L.$5d),this.onAddExtensions=this.b.event,this.c=this.B(new L.$5d),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$5d),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$5d),this.onDidRemoveExtensions=this.g.event,this.h=new I.$Ac}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s){const t=[],r=[];try{return await this.u(s,a=>{const E=[];for(const w of a)n.some(([u])=>(0,g.$_o)(u.identifier,w.identifier)&&u.manifest.version!==w.version)?t.push(w):E.push(w);for(const[w,u]of n){const p=E.findIndex(N=>(0,g.$_o)(N.identifier,w.identifier)&&N.version===w.manifest.version),P={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:u};p===-1?(r.push(P),E.push(P)):E.splice(p,1,P)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),t.length&&this.f.fire({extensions:t,profileLocation:s}),E}),r.length&&this.c.fire({extensions:r,profileLocation:s}),t.length&&this.g.fire({extensions:t,profileLocation:s}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:s}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const E of r){const w=n.find(([u])=>(0,g.$_o)(u.identifier,E.identifier)&&u.manifest.version===E.version);w&&(E.metadata={...E.metadata,...w[1]},t.push(E)),a.push(E)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const E of r)(0,g.$_o)(E.identifier,n.identifier)?t.push(E):a.push(E);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const E=await this.m.readFile(n);a=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,C.$Sk)(E)!==1)throw E;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new d((0,y.$0)(E),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let E=!1;for(const w of a){v(w)||this.w(n);let u;if((0,b.$Sf)(w.relativeLocation)&&w.relativeLocation)u=this.z(w.relativeLocation);else if((0,b.$Sf)(w.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${w.location}`);continue}else{u=R.URI.revive(w.location);const p=this.y(u);p&&(E=!0,w.relativeLocation=p)}(0,b.$Zf)(w.metadata?.hasPreReleaseVersion)&&w.metadata?.preRelease&&(E=!0,w.metadata.hasPreReleaseVersion=!0),r.push({identifier:w.identifier,location:u,version:w.version,metadata:w.metadata})}E&&await this.m.writeFile(n,A.$se.fromString(JSON.stringify(a)))}if(s){r=s(r);const E=r.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.y(w.location),metadata:w.metadata}));await this.m.writeFile(n,A.$se.fromString(JSON.stringify(E)))}return r})}w(n){const s=new d(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$Sk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(E=>v(E))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$se.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$Sk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$Sk)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,C.$Sk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new O.$lh,this.h.set(n,s)),s}};e.$8p=l,e.$8p=l=ye([K(1,C.$Bk),K(2,h.$bl),K(3,$.$_k),K(4,c.$Fl),K(5,m.$yj)],l);function v(o){return(0,b.$Uf)(o)&&(0,k.$Jo)(o.identifier)&&(i(o.location)||(0,b.$Sf)(o.location)&&o.location)&&((0,b.$Zf)(o.relativeLocation)||(0,b.$Sf)(o.relativeLocation))&&o.version&&(0,b.$Sf)(o.version)}function i(o){return o?(0,b.$Sf)(o.path)&&(0,b.$Sf)(o.scheme):!1}}),define(le[82],he([0,1,17,6,30,14,7,34,138,2,23,16,5,20,55,89,12,10,155,15,33,45,71,11,4,8,24,3,66,51,18,28,183]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d,l,v,i,o,n,s,t,r,a,E,w,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.Translations=void 0;var P;(function(x){function W(X,H){if(X===H)return!0;const V=Object.keys(X),te=new Set;for(const oe of Object.keys(H))te.add(oe);if(V.length!==te.size)return!1;for(const oe of V){if(X[oe]!==H[oe])return!1;te.delete(oe)}return te.size===0}x.equals=W})(P||(e.Translations=P={})),e.$$p=(0,n.$ei)("IExtensionsScannerService");let N=class extends g.$Tc{constructor(W,X,H,V,te,oe,ee,ae,G,U,j,T){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=X,this.r=H,this.s=V,this.t=te,this.u=oe,this.w=ee,this.y=ae,this.z=G,this.C=U,this.D=j,this.F=T,this.g=this.B(new r.$5d),this.onDidChangeCache=this.g.event,this.h=(0,h.$Rg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(z,this.s,this.h)),this.m=this.B(this.F.createInstance(z,this.s,this.h)),this.n=this.B(this.F.createInstance(M,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,l.$kp)(this.w,this.y)),this.G}async scanAllExtensions(W,X,H){const[V,te]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(X)]),oe=H?await this.scanExtensionsUnderDevelopment(W,[...V,...te]):[];return this.L(V,te,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const X=[];X.push(this.M(!!W.useCache,W.language)),X.push(this.N(W.language,!!W.checkControlFile));const[H,V]=await Promise.all(X);return this.J([...H,...V],0,W,!1)}async scanUserExtensions(W){const X=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const H=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(X,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,H),te=W.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let oe;try{oe=await te.scanExtensions(V)}catch(ee){if(ee instanceof E.$6p&&ee.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),oe=await te.scanExtensions(V);else throw ee}return oe=await this.J(oe,1,W,!0),this.y.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(W,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===C.Schemas.file).map(async V=>{const te=await this.P(V,!1,1,!0,W.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(te)).map(ee=>(ee.type=X.find(ae=>(0,l.$_o)(ae.identifier,ee.identifier))?.type??ee.type,this.n.validate(ee,te)))}))).flat();return this.J(H,"development",W,!0)}return[]}async scanExistingExtension(W,X,H){const V=await this.P(W,!1,X,!0,H.language,!0,void 0),te=await this.n.scanExtension(V);return!te||!H.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(W,X,H){const V=await this.P(W,!1,X,!0,H.language,!0,void 0),te=await this.n.scanOneOrMultipleExtensions(V);return this.J(te,X,H,!0)}async scanMetadata(W){const X=(0,h.$Rg)(W,"package.json"),H=(await this.w.readFile(X)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(W,X){const H=(0,h.$Rg)(W,"package.json"),V=(await this.w.readFile(H)).value.toString(),te=JSON.parse(V);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,te.__metadata={...te.__metadata,...X},await this.w.writeFile((0,h.$Rg)(W,"package.json"),L.$se.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof E.$6p&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$se.fromString(JSON.stringify([])))}catch(X){(0,o.$Sk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,X,H,V){return H.includeAllVersions||(W=this.L(X===0?W:void 0,X===1?W:void 0,X==="development"?W:void 0,await this.getTargetPlatform(),V)),H.includeInvalid||(W=W.filter(te=>te.isValid)),W.sort((te,oe)=>{const ee=S.$nc(te.location.fsPath),ae=S.$nc(oe.location.fsPath);return ee<ae?-1:ee>ae?1:0})}L(W,X,H,V,te){const oe=(ae,G,U)=>{if(ae.isValid&&!G.isValid)return!1;if(ae.isValid===G.isValid){if(te&&$.gt(ae.manifest.version,G.manifest.version))return this.y.debug(`Skipping extension ${G.location.path} with lower version ${G.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if($.eq(ae.manifest.version,G.manifest.version)){if(ae.type===0)return this.y.debug(`Skipping extension ${G.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===V)return this.y.debug(`Skipping extension ${G.location.path} from different target platform ${G.targetPlatform}`),!1}}return U?this.y.warn(`Overwriting user extension ${ae.location.path} with ${G.location.path}.`):this.y.debug(`Overwriting user extension ${ae.location.path} with ${G.location.path}.`),!0},ee=new v.$ym;return W?.forEach(ae=>{const G=ee.get(ae.identifier.id);(!G||oe(G,ae,!1))&&ee.set(ae.identifier.id,ae)}),X?.forEach(ae=>{const G=ee.get(ae.identifier.id);if(!G&&W&&ae.type===0){this.y.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!G||oe(G,ae,!1))&&ee.set(ae.identifier.id,ae)}),H?.forEach(ae=>{const G=ee.get(ae.identifier.id);(!G||oe(G,ae,!0))&&ee.set(ae.identifier.id,ae),ee.set(ae.identifier.id,ae)}),[...ee.values()]}async M(W,X){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),te=await(W&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",te.length),te}async N(W,X){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const V=X?await this.O():{},te=[],oe=c.URI.file(S.$hc(S.$jc(C.$yg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of H){const G=V[ae.name]||"marketplace";switch(G){case"disabled":break;case"marketplace":te.push((0,h.$Rg)(oe,ae.name));break;default:te.push(c.URI.file(G));break}}const ee=await Promise.all(te.map(async ae=>this.n.scanExtension(await this.P(ae,!1,0,!0,W,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ee.length),(0,O.$Hb)(ee)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,X,H,V,te,oe,ee){const ae=await this.f(te??m.$w),G=await this.Q(W),U=X&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,j=U?await this.Q(U):void 0;return new F(W,G,U,j,X,ee,H,V,oe,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,te,ae)}async Q(W){try{const X=await this.w.stat(W);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$_p=N,e.$_p=N=ye([K(4,w.$bl),K(5,E.$7p),K(6,o.$Bk),K(7,s.$yj),K(8,d.$li),K(9,t.$Qj),K(10,u.$_k),K(11,n.$di)],N);class F{constructor(W,X,H,V,te,oe,ee,ae,G,U,j,T,B,q,Z){this.location=W,this.mtime=X,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=V,this.profile=te,this.profileScanOptions=oe,this.type=ee,this.excludeObsolete=ae,this.validate=G,this.productVersion=U,this.productDate=j,this.productCommit=T,this.devMode=B,this.language=q,this.translations=Z}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,X){return(0,h.$Kg)(W.location,X.location)&&W.mtime===X.mtime&&(0,h.$Kg)(W.applicationExtensionslocation,X.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&W.profile===X.profile&&D.$Ln(W.profileScanOptions,X.profileScanOptions)&&W.type===X.type&&W.excludeObsolete===X.excludeObsolete&&W.validate===X.validate&&W.productVersion===X.productVersion&&W.productDate===X.productDate&&W.productCommit===X.productCommit&&W.devMode===X.devMode&&W.language===X.language&&P.equals(W.translations,X.translations)}}e.$aq=F;let M=class extends g.$Tc{constructor(W,X,H,V,te){super(),this.f=W,this.g=X,this.h=H,this.j=V,this.m=te}async scanExtensions(W){const X=W.profile?await this.r(W):await this.n(W);let H={};if(W.excludeObsolete&&W.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(V)}catch{}return(0,y.$6f)(H)?X:X.filter(V=>!H[l.$ap.create(V).toString()])}async n(W){const X=await this.j.resolve(W.location);if(!X.children?.length)return[];const H=await Promise.all(X.children.map(async V=>{if(!V.isDirectory||W.type===1&&(0,h.$Og)(V.resource).indexOf(".")===0)return null;const te=new F(V.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(te)}));return(0,O.$Hb)(H).sort((V,te)=>V.location.path<te.location.path?-1:1)}async r(W){let X=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){X=X.filter(V=>!V.metadata?.isApplicationScoped);const H=await this.s(W.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,W);X.push(...H)}return X}async s(W,X,H){const V=await this.g.scanProfileExtensions(W,H.profileScanOptions);if(!V.length)return[];const te=await Promise.all(V.map(async oe=>{if(X(oe)){const ee=new F(oe.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee,oe.metadata)}return null}));return(0,O.$Hb)(te)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,h.$Rg)(W.location,"package.json"))){const X=await this.scanExtension(W);return X?[X]:[]}else return await this.scanExtensions(W)}catch(X){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,I.$0)(X)),[]}}async scanExtension(W,X){try{let H=await this.scanExtensionManifest(W.location);if(H){H.publisher||(H.publisher=v.$sm),X=X??H.__metadata,delete H.__metadata;const V=(0,l.$ep)(H.publisher,H.name),te=X?.id?{id:V,uuid:X.id}:{id:V},oe=X?.isSystem?0:W.type,ee=oe===0||!!X?.isBuiltin;H=await this.t(W.location,H,F.createNlsConfiguration(W));const ae={type:oe,identifier:te,manifest:H,location:W.location,isBuiltin:ee,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return W.validate?this.validate(ae,W):ae}}catch(H){W.type!==0&&this.m.error(H)}return null}validate(W,X){let H=!0;const V=(0,i.$pp)(X.productVersion,X.productDate,X.location,W.manifest,W.isBuiltin);for(const[te,oe]of V)te===b.default.Error&&(H=!1,this.m.error(this.z(X.location,oe)));return W.isValid=H,W.validations=V,W}async scanExtensionManifest(W){const X=(0,h.$Rg)(W,"package.json");let H;try{H=(await this.j.readFile(X)).value.toString()}catch(te){return(0,o.$Sk)(te)!==1&&this.m.error(this.z(W,(0,f.localize)(0,null,X.path,te.message))),null}let V;try{V=JSON.parse(H)}catch{const oe=[];(0,R.$on)(H,oe);for(const ee of oe)this.m.error(this.z(W,(0,f.localize)(1,null,X.path,ee.offset,ee.length,(0,k.$9p)(ee.error))));return null}return(0,R.$xn)(V)!=="object"?(this.m.error(this.z(W,(0,f.localize)(2,null,X.path))),null):V}async t(W,X,H){const V=await this.u(W,X,H);if(V)try{const te=[],oe=await this.w(V.default,te);if(te.length>0)return te.forEach(ae=>{this.m.error(this.z(W,(0,f.localize)(3,null,V.default?.path,(0,k.$9p)(ae.error))))}),X;if((0,R.$xn)(V)!=="object")return this.m.error(this.z(W,(0,f.localize)(4,null,V.default?.path))),X;const ee=V.values||Object.create(null);return(0,p.$0p)(this.m,X,ee,oe)}catch{}return X}async u(W,X,H){const V=(0,h.$Rg)(W,"package.nls.json"),te=(G,U)=>{U.forEach(j=>{this.m.error(this.z(W,(0,f.localize)(5,null,G?.path,(0,k.$9p)(j.error))))})},oe=G=>{this.m.error(this.z(W,(0,f.localize)(6,null,G?.path)))},ee=`${X.publisher}.${X.name}`,ae=H.translations[ee];if(ae)try{const G=c.URI.file(ae),U=(await this.j.readFile(G)).value.toString(),j=[],T=(0,R.$on)(U,j);return j.length>0?(te(G,j),{values:void 0,default:V}):(0,R.$xn)(T)!=="object"?(oe(G),{values:void 0,default:V}):{values:T.contents?T.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let U;try{U=await this.y(W,H)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const j=(await this.j.readFile(U.localized)).value.toString(),T=[],B=(0,R.$on)(j,T);return T.length>0?(te(U.localized,T),{values:void 0,default:U.original}):(0,R.$xn)(B)!=="object"?(oe(U.localized),{values:void 0,default:U.original}):{values:B,default:U.original}}catch{return{values:void 0,default:U.original}}}}async w(W,X){if(W)try{const H=(await this.j.readFile(W)).value.toString();return(0,R.$on)(H,X)}catch{}}y(W,X){return new Promise((H,V)=>{const te=oe=>{const ee=(0,h.$Rg)(W,`package.nls.${oe}.json`);this.j.exists(ee).then(ae=>{ae&&H({localized:ee,original:(0,h.$Rg)(W,"package.nls.json")});const G=oe.lastIndexOf("-");G===-1?H({localized:(0,h.$Rg)(W,"package.nls.json"),original:null}):(oe=oe.substring(0,G),te(oe))})};if(X.devMode||X.pseudo||!X.language)return H({localized:(0,h.$Rg)(W,"package.nls.json"),original:null});te(X.language)})}z(W,X){return`[${W.path}]: ${X}`}};M=ye([K(1,E.$7p),K(2,u.$_k),K(3,o.$Bk),K(4,s.$yj)],M);let z=class extends M{constructor(W,X,H,V,te,oe,ee){super(X,V,te,oe,ee),this.G=W,this.H=H,this.D=this.B(new A.$ch(3e3)),this.F=this.B(new r.$5d),this.onDidChangeCache=this.F.event}async scanExtensions(W){const X=this.M(W),H=await this.I(X);if(this.C=W,H&&H.input&&F.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),H.result.map(te=>(te.location=c.URI.revive(te.location),te));const V=await super.scanExtensions(W);return await this.J(X,{input:W,result:V}),V}async I(W){try{const X=await this.j.readFile(W),H=JSON.parse(X.value.toString());return{result:H.result,input:(0,a.$Nh)(H.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",W.path,(0,I.$0)(X))}return null}async J(W,X){try{await this.j.writeFile(W,L.$se.fromString(JSON.stringify(X)))}catch(H){this.m.debug("Error while writing the extension cache file:",W.path,(0,I.$0)(H))}}async L(){if(!this.C)return;const W=this.M(this.C),X=await this.I(W);if(!X)return;const H=X.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!D.$Ln(V,H))try{this.m.info("Invalidating Cache",H,V),await this.j.del(W),this.F.fire()}catch(te){this.m.error(te)}}M(W){const X=this.N(W);return this.h.extUri.joinPath(X.cacheHome,W.type===0?v.$rm:v.$qm)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(W.location,X.extensionsResource))??this.G:this.H.defaultProfile}};z=ye([K(2,w.$bl),K(3,E.$7p),K(4,u.$_k),K(5,o.$Bk),K(6,s.$yj)],z);function Y(x,W){const X=(0,l.$cp)(x.manifest.publisher,x.manifest.name);return{id:X,identifier:new v.$wm(X),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:W,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$bq=Y;class Q extends N{constructor(W,X,H,V,te,oe,ee,ae,G,U,j,T){super(W,X,(0,h.$Rg)(H,".vscode-oss-dev","extensions","control.json"),V,te,oe,ee,ae,G,U,j,T),this.R=(async()=>{if(m.$z)try{const B=await this.w.readFile(c.URI.file(m.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(W){return this.R}}e.$cq=Q}),define(le[245],he([0,1,67,6,38,3,2,23,16,31,8,18]),function(se,e,O,A,D,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;let m=class extends I.$Tc{constructor($,b){super(),this.b=$,this.f=b,this.a=new A.$kh(5)}async postUninstall($){const b=this.g($,"uninstall");b&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(y){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(y)}}));try{await g.Promises.rm(this.m($))}catch(y){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(y)}}g($,b){const y=`vscode:${b}`;if($.location.scheme===R.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[y]=="string"){const c=$.manifest.scripts[y].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn($.identifier.id,$.manifest.version,`${y} should be a node script`),null):{script:(0,k.$jc)($.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h($,b,y,c,f){return new Promise((d,l)=>{const v=this.j($,b,y,f);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?l(n):d(void 0)};v.on("error",n=>{o((0,D.$2i)(n)||"Unknown")}),v.on("exit",(n,s)=>{o(n?`post-${b} process exited with code ${n}`:void 0)}),c&&(i=setTimeout(()=>{i=null,v.kill(),l("timed out")},5e3))})}j($,b,y,c){const f={silent:!0,execArgv:void 0},d=(0,O.fork)($,[`--type=extension-post-${b}`,...y],f);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const l=L.Event.fromNodeEventEmitter(d.stdout,"data"),v=L.Event.fromNodeEventEmitter(d.stderr,"data");l(n=>this.f.info(c.identifier.id,c.manifest.version,`post-${b}`,n)),v(n=>this.f.error(c.identifier.id,c.manifest.version,`post-${b}`,n));const i=L.Event.any(L.Event.map(l,n=>({data:`%c${n}`,format:[""]})),L.Event.map(v,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(c.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),d}m($){return(0,k.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$eq=m,e.$eq=m=ye([K(0,S.$bl),K(1,C.$yj)],m)}),define(le[113],he([0,1,6,14,26,38,7,3,53,2,35,23,16,20,55,12,10,32,31,70,156,96,15,244,29,33,51,82,225,245,184,214,226,71,11,4,8,24,22,28,18]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d,l,v,i,o,n,s,t,r,a,E,w,u,p,P,N,F,M,z,Y,Q,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=e.$iq=void 0,e.$iq=(0,F.$fi)(n.$No);const W=".vsctmp";let X=class extends o.$2p{constructor(G,U,j,T,B,q,Z,_,ie,J,ne,ce){super(G,U,ne,j,J,ce),this.eb=B,this.fb=q,this.gb=Z,this.hb=ie,this.db=new Map,this.qb=new C.$Bc;const fe=this.B(_.createInstance(E.$eq));this.ab=this.B(_.createInstance(H,me=>fe.postUninstall(me))),this.bb=this.B(new u.$gq(ce,ie,ne,this,this.F)),this.cb=this.B(_.createInstance(a.$dq));const de=this.B(new p.$hq(this,this.eb,ce,q,ne,ie,j));this.B(de.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$kp)(this.hb,this.F)),this.ib}async zip(G){this.F.trace("ExtensionManagementService#zip",G.identifier.id);const U=await this.ob(G),j=await(0,d.zip)((0,h.$Rg)(this.cb.extensionsDownloadDir,(0,c.$Ag)()).fsPath,U);return y.URI.file(j)}async unzip(G){return this.F.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const{location:U,cleanup:j}=await this.kb(G),T=m.$kc(U.fsPath);try{return await(0,w.$fq)(T)}finally{await j()}}getInstalled(G,U=this.H.defaultProfile.extensionsResource){return this.ab.scanExtensions(G??null,U)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(G){return this.ab.scanUserExtensionAtLocation(G)}async install(G,U={}){this.F.trace("ExtensionManagementService#install",G.toString());const{location:j,cleanup:T}=await this.kb(G);try{const B=await(0,w.$fq)(m.$kc(j.fsPath)),q=(0,s.$ep)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,P.$rp)(B.engines.vscode,this.G.version,this.G.date))throw new Error(l.localize(0,null,q,this.G.version));const _=(await this.I([{manifest:B,extension:j,options:U}])).find(({identifier:ie})=>(0,s.$_o)(ie,{id:q}));if(_?.local)return _.local;throw _?.error?_.error:(0,o.$4p)(new Error(`Unknown error while installing extension ${q}`))}finally{await T()}}async installFromLocation(G,U){this.F.trace("ExtensionManagementService#installFromLocation",G.toString());const j=await this.ab.scanUserExtensionAtLocation(G);if(!j||!j.manifest.name||!j.manifest.version)throw new Error(`Cannot find a valid extension from the location ${G.toString()}`);return await this.tb([[j,void 0]],U),this.F.info("Successfully installed extension",j.identifier.id,U.toString()),j}async installExtensionsFromProfile(G,U,j){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",G,U.toString(),j.toString());const T=(await this.ab.scanExtensions(1,U)).filter(B=>G.some(q=>(0,s.$_o)(q,B.identifier)));if(T.length){const B=await Promise.all(T.map(q=>this.ab.scanMetadata(q,U)));await this.tb(T.map((q,Z)=>[q,B[Z]]),j),this.F.info("Successfully installed extensions",T.map(q=>q.identifier.id),j.toString())}return T}async updateMetadata(G,U,j=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",G.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0,U.hasPreReleaseVersion=!0),U.isMachineScoped===!1&&(U.isMachineScoped=void 0),U.isBuiltin===!1&&(U.isBuiltin=void 0),U.pinned===!1&&(U.pinned=void 0),G=await this.ab.updateMetadata(G,U,j),this.bb.invalidate(j),this.w.fire(G),G}async reinstallFromGallery(G){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",G.identifier.id),!this.z.isEnabled())throw new Error(l.localize(1,null));const U=await this.getTargetPlatform(),[j]=await this.z.getExtensions([{...G.identifier,preRelease:G.preRelease}],{targetPlatform:U,compatible:!0},D.CancellationToken.None);if(!j)throw new Error(l.localize(2,null));await this.ab.setUninstalled(G);try{await this.ab.removeUninstalledExtension(G)}catch(T){throw new Error(l.localize(3,null,(0,L.$2i)(T)))}return this.installFromGallery(j)}$(G,U,j,T){return this.ab.copyExtension(G,U,j,T)}copyExtensions(G,U){return this.ab.copyExtensions(G,U)}markAsUninstalled(...G){return this.ab.setUninstalled(...G)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(G){this.F.error(G)}}async download(G,U,j){const{location:T}=await this.cb.download(G,U,!j);return T}async kb(G){if(G.scheme===S.Schemas.file)return{location:G,async cleanup(){}};this.F.trace("Downloading extension from",G.toString());const U=(0,h.$Rg)(this.cb.extensionsDownloadDir,(0,c.$Ag)());return await this.gb.download(G,U),this.F.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.hb.del(U)}catch(T){this.F.error(T)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(G,U,j){if(y.URI.isUri(U))return new oe(G,U,j,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const T=s.$ap.create(U).toString();let B=this.db.get(T);return B||(this.db.set(T,B=new te(G,U,j,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),B.waitUntilTaskIsFinished().finally(()=>this.db.delete(T))),B}Z(G,U){return new ee(G,U.profileLocation,this.fb)}async ob(G){const U=async T=>{let B=await f.Promises.readdir(T);B=B.map(_=>m.$jc(T,_));const q=await Promise.all(B.map(_=>f.Promises.stat(_)));let Z=Promise.resolve([]);return q.forEach((_,ie)=>{const J=B[ie];_.isFile()&&(Z=Z.then(ne=>[...ne,J])),_.isDirectory()&&(Z=Z.then(ne=>U(J).then(ce=>[...ne,...ce])))}),Z};return(await U(G.location.fsPath)).map(T=>({path:`extension/${m.$lc(G.location.fsPath,T)}`,localPath:T}))}async pb({added:G,removed:U}){if(U){const j=G&&this.D.extUri.isEqual(U.profileLocation,G.profileLocation)?U.extensions.filter(T=>G.extensions.every(B=>!(0,s.$_o)(B,T))):U.extensions;for(const T of j)this.F.info("Extensions removed from another source",T.id,U.profileLocation.toString()),this.u.fire({identifier:T,profileLocation:U.profileLocation})}if(G){const T=(await this.ab.scanExtensions(1,G.profileLocation)).filter(B=>G.extensions.some(q=>(0,s.$_o)(q,B.identifier)));this.s.fire(T.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,G.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:G.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(U=>this.qb.add(U)));const G=await this.hb.resolve(this.eb.userExtensionsLocation);for(const U of G.children??[])U.isDirectory&&this.qb.add(U.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(U=>this.sb(U)))}async sb(G){if(!G.affects(this.eb.userExtensionsLocation,1))return;const U=[];for(const j of G.rawAdded){if(this.qb.has(j)||!this.D.extUri.isEqual(this.D.extUri.dirname(j),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(j,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(j).startsWith(".")||!(await this.hb.stat(j)).isDirectory)continue;const T=await this.ab.scanUserExtensionAtLocation(j);T&&T.installedTimestamp===void 0&&(this.qb.add(j),U.push(T))}U.length&&(await this.tb(U.map(j=>[j,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",U.map(j=>j.identifier.id)))}async tb(G,U){const j=G.map(T=>T[0]);await this.ub(j),await this.fb.addExtensionsToProfile(G,U),this.s.fire(j.map(T=>({local:T,identifier:T.identifier,operation:1,profileLocation:U})))}async ub(G){const U=await this.ab.getUninstalledExtensions();for(const j of G){const T=s.$ap.create(j);U[T.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",T.id),await this.ab.setInstalled(T),this.F.info("Removed the extension from uninstalled list:",T.id))}}};e.$jq=X,e.$jq=X=ye([K(0,n.$Ko),K(1,Y.$Fl),K(2,M.$yj),K(3,i.$mi),K(4,r.$$p),K(5,t.$7p),K(6,v.$po),K(7,F.$di),K(8,N.$Bk),K(9,z.$Qj),K(10,Q.$_k),K(11,x.$bl)],X);let H=class extends g.$Tc{constructor(G,U,j,T,B,q){super(),this.j=G,this.m=U,this.n=j,this.s=T,this.t=B,this.u=q,this.h=this.B(new R.$5d),this.onExtract=this.h.event,this.c=(0,h.$Rg)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$lh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(G,U){const j={includeInvalid:!0,profileLocation:U};let T=[];return G===null||G===0?T.push(...await this.n.scanAllExtensions({includeInvalid:!0},j,!1)):G===1&&T.push(...await this.n.scanUserExtensions(j)),T=G!==null?T.filter(B=>B.type===G):T,Promise.all(T.map(B=>this.F(B)))}async scanAllUserExtensions(G){const U=await this.n.scanUserExtensions({includeAllVersions:!G,includeInvalid:!0});return Promise.all(U.map(j=>this.F(j)))}async scanUserExtensionAtLocation(G){try{const U=await this.n.scanExistingExtension(G,1,{includeInvalid:!0});if(U)return await this.F(U)}catch(U){this.u.error(U)}return null}async extractUserExtension(G,U,j,T,B){const q=G.toString(),Z=y.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Ag)()}`)),_=y.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,q));let ie=await this.m.exists(_);if(ie&&T){try{await this.y(G.id,_,"removeExisting")}catch{throw new n.$Lo(l.localize(4,null,_.fsPath,G.id),n.ExtensionManagementErrorCode.Delete)}ie=!1}if(ie)await this.n.updateMetadata(_,j);else try{try{this.u.trace(`Started extracting the extension from ${U} to ${_.fsPath}`),await(0,d.$Zp)(U,Z.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${_}:`,G.id)}catch(J){let ne=n.ExtensionManagementErrorCode.Extract;throw J instanceof d.$Xp&&(J.type==="CorruptZip"?ne=n.ExtensionManagementErrorCode.CorruptZip:J.type==="Incomplete"&&(ne=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Lo(J.message,ne)}await this.n.updateMetadata(Z,j);try{this.u.trace(`Started renaming the extension from ${Z.fsPath} to ${_.fsPath}`),await this.C(Z.fsPath,_.fsPath),this.u.info("Renamed to",_.fsPath)}catch(J){if(J.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",G.id);else throw this.u.info(`Rename failed because of ${(0,I.$0)(J)}. Deleted from extracted location`,Z),J}this.h.fire(_)}catch(J){try{await this.m.del(Z,{recursive:!0})}catch{}throw J}return this.D(_,1)}async scanMetadata(G,U){return U?(await this.w(G,U))?.metadata:this.n.scanMetadata(G.location)}async w(G,U){return(await this.s.scanProfileExtensions(U)).find(T=>(0,s.$_o)(T.identifier,G.identifier))}async updateMetadata(G,U,j){return j?await this.s.updateMetadata([[G,U]],j):await this.n.updateMetadata(G.location,U),this.D(G.location,G.type,j)}getUninstalledExtensions(){return this.z()}async setUninstalled(...G){const U=G.map(j=>s.$ap.create(j));await this.z(j=>U.forEach(T=>{j[T.toString()]=!0,this.u.info("Marked extension as uninstalled",T.toString())}))}async setInstalled(G){await this.z(U=>delete U[G.toString()])}async removeExtension(G,U){if(this.t.extUri.isEqualOrParent(G.location,this.n.userExtensionsLocation))return this.y(G.identifier.id,G.location,U)}async removeUninstalledExtension(G){await this.removeExtension(G,"uninstalled"),await this.z(U=>delete U[s.$ap.create(G).toString()])}async copyExtension(G,U,j,T){const B=await this.w(G,U),q=await this.w(G,j);if(T={...B?.metadata,...T},q)if(this.t.extUri.isEqual(q.location,G.location))await this.s.updateMetadata([[G,{...q.metadata,...T}]],j);else{const Z=await this.D(q.location,G.type,j);await this.s.removeExtensionFromProfile(Z,j),await this.s.addExtensionsToProfile([[G,{...q.metadata,...T}]],j)}else await this.s.addExtensionsToProfile([[G,T]],j);return this.D(G.location,G.type,j)}async copyExtensions(G,U){const j=await this.scanExtensions(1,G),T=await Promise.all(j.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,G)]));await this.s.addExtensionsToProfile(T,U)}async y(G,U,j){this.u.trace(`Deleting ${j} extension from disk`,G,U.fsPath);const T=this.t.extUri.joinPath(this.t.extUri.dirname(U),`${this.t.extUri.basename(U)}.${(0,k.$5i)((0,c.$Ag)()).toString(16)}${W}`);await this.C(U.fsPath,T.fsPath),await this.m.del(T,{recursive:!0}),this.u.info(`Deleted ${j} extension from disk`,G,U.fsPath)}async z(G){return this.g.queue(async()=>{let U;try{U=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(T){if((0,N.$Sk)(T)!==1)throw T}let j={};if(U)try{j=JSON.parse(U)}catch{}return G&&(G(j),Object.keys(j).length?await this.m.writeFile(this.c,A.$se.fromString(JSON.stringify(j))):await this.m.del(this.c)),j})}async C(G,U){try{await f.Promises.rename(G,U,2*60*1e3)}catch(j){throw new n.$Lo(j.message||l.localize(5,null,G,U),j.code||n.ExtensionManagementErrorCode.Rename)}}async D(G,U,j){if(j){const B=(await this.n.scanUserExtensions({profileLocation:j})).find(q=>this.t.extUri.isEqual(q.location,G));if(B)return this.F(B)}else{const T=await this.n.scanExistingExtension(G,U,{includeInvalid:!0});if(T)return this.F(T)}throw new Error(l.localize(6,null,G.path))}async F(G){const U=await this.m.resolve(G.location);let j,T;return U.children&&(j=U.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,T=U.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:G.identifier,type:G.type,isBuiltin:G.isBuiltin||!!G.metadata?.isBuiltin,location:G.location,manifest:G.manifest,targetPlatform:G.targetPlatform,validations:G.validations,isValid:G.isValid,readmeUrl:j,changelogUrl:T,publisherDisplayName:G.metadata?.publisherDisplayName||null,publisherId:G.metadata?.publisherId||null,isApplicationScoped:!!G.metadata?.isApplicationScoped,isMachineScoped:!!G.metadata?.isMachineScoped,isPreReleaseVersion:!!G.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!G.metadata?.hasPreReleaseVersion,preRelease:!!G.metadata?.preRelease,installedTimestamp:G.metadata?.installedTimestamp,updated:!!G.metadata?.updated,pinned:!!G.metadata?.pinned}}async G(){const G=await this.getUninstalledExtensions();if(Object.keys(G).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(G));const U=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),j=new Set;for(const B of U)G[s.$ap.create(B).toString()]||j.add(B.identifier.id.toLowerCase());try{const B=(0,s.$fp)(U,q=>q.identifier);await O.Promises.settled(B.map(async q=>{const Z=q.sort((_,ie)=>$.rcompare(_.manifest.version,ie.manifest.version))[0];j.has(Z.identifier.id.toLowerCase())||await this.j(await this.F(Z))}))}catch(B){this.u.error(B)}const T=U.filter(B=>B.metadata&&G[s.$ap.create(B).toString()]);await Promise.allSettled(T.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let G;try{G=await this.m.resolve(this.n.userExtensionsLocation)}catch(U){(0,N.$Sk)(U)!==1&&this.u.error(U);return}if(G?.children)try{await Promise.allSettled(G.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.m.del(U.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(j){(0,N.$Sk)(j)!==1&&this.u.error(j)}}}))}catch{}}};e.$kq=H,e.$kq=H=ye([K(1,N.$Bk),K(2,r.$$p),K(3,t.$7p),K(4,Q.$_k),K(5,M.$yj)],H);class V extends o.$5p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,b.$Zf)(this.options.operation)?this.l:this.options.operation}constructor(G,U,j,T,B,q,Z,_,ie){super(),this.identifier=G,this.source=U,this.options=j,this.m=T,this.n=B,this.o=q,this.p=Z,this.q=_,this.s=ie,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(G){const[U,j]=await this.x(G);return this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[U,j]],this.j),U}async u({zipPath:G,key:U,metadata:j},T,B){let q=await this.v(U);return q?q=await this.m.updateMetadata(q,j):(this.s.trace("Extracting extension...",U.id),q=await this.m.extractUserExtension(U,G,j,T,B),this.s.info("Extracting extension completed.",U.id)),q}async v(G){return await this.w(G)?(this.s.trace("Removing the extension from uninstalled list:",G.id),await this.m.setInstalled(G),this.s.info("Removed the extension from uninstalled list:",G.id),(await this.m.scanAllUserExtensions(!0)).find(T=>s.$ap.create(T).equals(G))):void 0}async w(G){return!!(await this.m.getUninstalledExtensions())[G.toString()]}}class te extends V{constructor(G,U,j,T,B,q,Z,_,ie,J){super(U.identifier,U,j,B,q,Z,_,ie,J),this.y=U,this.z=T}async x(G){let U;try{U=await this.m.scanExtensions(null,this.options.profileLocation)}catch(Z){throw new n.$Lo(Z,n.ExtensionManagementErrorCode.Scanning)}const j=U.find(Z=>(0,s.$_o)(Z.identifier,this.y.identifier));j&&(this.l=3);const T={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||j?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||j?.isMachineScoped,isBuiltin:this.options.isBuiltin||j?.isBuiltin,isSystem:j?.type===0?!0:void 0,updated:!!j,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:j?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??j?.pinned,preRelease:(0,b.$Yf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||j?.preRelease};if(j?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(j,T),T]}catch(Z){throw new n.$Lo((0,I.$0)(Z),n.ExtensionManagementErrorCode.UpdateMetadata)}const{location:B,verificationStatus:q}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=q,this.B(B.fsPath),[await this.u({zipPath:B.fsPath,key:s.$ap.create(this.y),metadata:T},!1,G),T]}catch(Z){try{await this.z.delete(B)}catch(_){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,I.$0)(_))}throw Z}}async B(G){try{await(0,w.$fq)(G)}catch(U){throw new n.$Lo((0,o.$3p)(U).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$lq=te;class oe extends V{constructor(G,U,j,T,B,q,Z,_,ie,J){super({id:(0,s.$ep)(G.publisher,G.name)},U,j,B,q,Z,_,ie,J),this.y=G,this.z=U,this.A=T}async h(G){const U=await super.h(G);return this.D(U,G),U}async x(G){const U=new s.$ap(this.identifier,this.y.version),T=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Z=>(0,s.$_o)(this.identifier,Z.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??T?.pinned};if(T)if(this.l=3,U.equals(new s.$ap(T.identifier,T.manifest.version)))try{await this.m.removeExtension(T,"existing")}catch{throw new Error(l.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&$.gt(T.manifest.version,this.y.version)&&await this.m.setUninstalled(T);else{const Z=await this.v(U);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error(l.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:m.$kc(this.z.fsPath),key:U,metadata:B},!0,G),B]}async D(G,U){try{let[j]=await this.A.getExtensions([{id:G.identifier.id,version:G.manifest.version}],U);if(j||([j]=await this.A.getExtensions([{id:G.identifier.id}],U)),j){const T={id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId,isPreReleaseVersion:j.properties.isPreReleaseVersion,hasPreReleaseVersion:G.hasPreReleaseVersion||j.properties.isPreReleaseVersion,preRelease:j.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(G,T,this.options.profileLocation)}}catch{}}}class ee extends o.$5p{constructor(G,U,j){super(),this.extension=G,this.j=U,this.k=j}async h(G){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[246],he([0,1,8,18,28,22,51,11,15,10]),function(se,e,O,A,D,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zP=void 0;let C=class extends I.$8p{constructor(m,h,$,b,y,c){super(g.URI.file(m.extensionsPath),h,$,b,y,c)}};e.$zP=C,e.$zP=C=ye([K(0,k.$mi),K(1,R.$Bk),K(2,A.$bl),K(3,D.$_k),K(4,L.$Fl),K(5,O.$yj)],C)}),define(le[247],he([0,1,10,15,51,82,11,4,8,24,28,18]),function(se,e,O,A,D,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1_b=void 0;let m=class extends L.$cq{constructor($,b,y,c,f,d,l,v){super(O.URI.file(f.builtinExtensionsPath),O.URI.file(f.extensionsPath),f.userHome,$.defaultProfile,$,b,y,c,f,d,l,v)}};e.$1_b=m,e.$1_b=m=ye([K(0,S.$bl),K(1,D.$7p),K(2,I.$Bk),K(3,k.$yj),K(4,A.$mi),K(5,g.$Qj),K(6,C.$_k),K(7,R.$di)],m)}),define(le[19],he([0,1,6,3,2,100,12,69,4,18]),function(se,e,O,A,D,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Fp=e.$Ep=e.$Dp=void 0,e.$Dp="__$__isNewStorageMarker",e.$Ep="__$__targetStorageMarker",e.$Fp=(0,k.$ei)("storageService");var C;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var S;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var m;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function h(f){const d=f.get(e.$Ep);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.$Gp=h;class $ extends D.$Tc{static{this.a=60*1e3}constructor(d={flushInterval:$.a}){super(),this.m=d,this.b=this.B(new A.$8d),this.c=this.B(new A.$8d),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$5d),this.onWillSaveState=this.f.event,this.h=this.B(new O.$qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new D.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,l,v){return A.Event.filter(this.b.event,i=>i.scope===d&&(l===void 0||i.key===l),v)}n(){this.j.value=(0,O.$uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,D.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,l){const{key:v,external:i}=l;if(v===e.$Ep){switch(d){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:v,target:this.J(d)[v],external:i})}w(d){this.f.fire({reason:d})}get(d,l,v){return this.P(l)?.get(d,v)}getBoolean(d,l,v){return this.P(l)?.getBoolean(d,v)}getNumber(d,l,v){return this.P(l)?.getNumber(d,v)}getObject(d,l,v){return this.P(l)?.getObject(d,v)}storeAll(d,l){this.y(()=>{for(const v of d)this.store(v.key,v.value,v.scope,v.target,l)})}store(d,l,v,i,o=!1){if((0,I.$2f)(l)){this.remove(d,v,o);return}this.y(()=>{this.z(d,v,i),this.P(v)?.set(d,l,o)})}remove(d,l,v=!1){this.y(()=>{this.z(d,l,void 0),this.P(l)?.delete(d,v)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,l){const v=[],i=this.J(d);for(const o of Object.keys(i))i[o]===l&&v.push(o);return v}z(d,l,v,i=!1){const o=this.J(l);typeof v=="number"?o[d]!==v&&(o[d]=v,this.P(l)?.set(e.$Ep,JSON.stringify(o),i)):typeof o[d]=="number"&&(delete o[d],this.P(l)?.set(e.$Ep,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(d){switch(d){case-1:return this.I;case 0:return this.G;default:return this.D}}L(d){const l=this.P(d);return l?h(l):Object.create(null)}isNew(d){return this.getBoolean(e.$Dp,d)===!0}async flush(d=C.NONE){this.f.fire({reason:d});const l=this.P(-1),v=this.P(0),i=this.P(1);switch(d){case C.NONE:await O.Promises.settled([l?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await O.Promises.settled([l?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(-1)?.items??new Map,l=this.P(0)?.items??new Map,v=this.P(1)?.items??new Map;return c(d,l,v,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,l){return this.w(C.NONE),(0,g.$al)(d)?this.R(d,l):this.S(d,l)}M(d,l){return!(d.id===l.id||b(l)&&b(d))}N(d,l,v){this.y(()=>{const i=new Set;for(const[o,n]of d)i.add(o),l.get(o)!==n&&this.u(v,{key:o,external:!0});for(const[o]of l.items)i.has(o)||this.u(v,{key:o,external:!0})})}}e.$Hp=$;function b(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$Ip=b;class y extends ${constructor(){super(),this.U=this.B(new R.$Bp(new R.$Cp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$Bp(new R.$Cp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$Bp(new R.$Cp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(1,d))),this.B(this.W.onDidChangeStorage(d=>this.u(0,d))),this.B(this.U.onDidChangeStorage(d=>this.u(-1,d)))}P(d){switch(d){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$Jp=y;async function c(f,d,l,v,i,o){const n=P=>{try{return JSON.parse(P)}catch{return P}},s=new Map,t=new Map;f.forEach((P,N)=>{s.set(N,P),t.set(N,n(P))});const r=new Map,a=new Map;d.forEach((P,N)=>{r.set(N,P),a.set(N,n(P))});const E=new Map,w=new Map;l.forEach((P,N)=>{E.set(N,P),w.set(N,n(P))}),console.group(v!==i?`Storage: Application (path: ${v})`:`Storage: Application & Profile (path: ${v}, default profile)`);const u=[];if(s.forEach((P,N)=>{u.push({key:N,value:P})}),console.table(u),console.groupEnd(),console.log(t),v!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const P=[];r.forEach((N,F)=>{P.push({key:F,value:N})}),console.table(P),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const p=[];E.forEach((P,N)=>{p.push({key:N,value:P})}),console.table(p),console.groupEnd(),console.log(w)}e.$Kp=c}),define(le[114],he([0,1,3,2,12,29,33,19]),function(se,e,O,A,D,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OGb=e.$NGb=void 0;let k=class extends A.$Tc{constructor(S,m){super(),this.a=new O.$5d,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(S)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(m.onDidInstallExtensions(h=>h.forEach(({local:$,operation:b})=>{$&&b===4&&this.f($.identifier)})))}async enableExtension(S,m){return this.f(S)?(this.a.fire({extensions:[S],source:m}),!0):!1}async disableExtension(S,m){return this.c(S)?(this.a.fire({extensions:[S],source:m}),!0):!1}getDisabledExtensions(){return this.h(L.$Oo)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(S){const m=this.getDisabledExtensions();return m.every(h=>!(0,I.$_o)(h,S))?(m.push(S),this.g(m),!0):!1}f(S){const m=this.getDisabledExtensions();for(let h=0;h<m.length;h++){const $=m[h];if((0,I.$_o)($,S))return m.splice(h,1),this.g(m),!0}return!1}g(S){this.j(L.$Oo,S)}h(S){return this.b.get(S,0)}j(S,m){this.b.set(S,m,0)}};e.$NGb=k,e.$NGb=k=ye([K(0,R.$Fp),K(1,L.$No)],k);class g extends A.$Tc{constructor(S){super(),this.c=S,this.a=Object.create(null),this.b=this.B(new O.$5d),this.onDidChange=this.b.event,this.B(S.onDidChangeValue(0,void 0,this.B(new A.$Sc))(m=>this.f(m)))}get(S,m){let h;return m===0?((0,D.$2f)(this.a[S])&&(this.a[S]=this.g(S,m)),h=this.a[S]):h=this.g(S,m),JSON.parse(h)}set(S,m,h){const $=JSON.stringify(m.map(({id:y,uuid:c})=>({id:y,uuid:c})));this.g(S,h)!==$&&(h===0&&(m.length?this.a[S]=$:delete this.a[S]),this.h(S,m.length?$:void 0,h))}f(S){if(!(0,D.$2f)(this.a[S.key])&&this.g(S.key,S.scope)!==this.a[S.key]){const h=this.get(S.key,S.scope);delete this.a[S.key];const $=this.get(S.key,S.scope),b=h.filter(c=>!$.some(f=>(0,I.$_o)(c,f))),y=$.filter(c=>!h.some(f=>(0,I.$_o)(f,c)));(b.length||y.length)&&this.b.fire([...b,...y])}}g(S,m){return this.c.get(S,m,"[]")}h(S,m,h){m?this.c.store(S,m,h,1):this.c.remove(S,h)}}e.$OGb=g}),define(le[248],he([0,1,17,26,7,5,37,12,10,21,15,29,33,71,11,8,24,59,227,19,22,63]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.$Np=void 0;const i=L.$o?"web":(0,S.$Go)(L.$u,I.$ec),o="X-Market-Search-Activity-Id";var n;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...T){return String(T.reduce((B,q)=>B|q,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class u{constructor(B=w){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,q=this.d.pageSize){return new u({...this.d,pageNumber:B,pageSize:q})}withFilter(B,...q){const Z=[...this.d.criteria,...q.length?q.map(_=>({filterType:B,value:_})):[{filterType:B}]];return new u({...this.d,criteria:Z})}withSortBy(B){return new u({...this.d,sortBy:B})}withSortOrder(B){return new u({...this.d,sortOrder:B})}withFlags(...B){return new u({...this.d,flags:B.reduce((q,Z)=>q|Z,0)})}withAssetTypes(...B){return new u({...this.d,assetTypes:B})}withSource(B){return new u({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:q,pageSize:Z,sortBy:_,sortOrder:ie,flags:J,assetTypes:ne}=this.d;return{filters:[{criteria:B,pageNumber:q,pageSize:Z,sortBy:_,sortOrder:ie}],assetTypes:ne,flags:J}}get searchText(){const B=this.d.criteria.filter(q=>q.filterType===t.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function p(T,B){const q=(T||[]).filter(Z=>Z.statisticName===B)[0];return q?q.value:0}function P(T){const B="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(Z=>Z.assetType.indexOf(B)===0).reduce((Z,_)=>{const ie=M(T,_.assetType);return ie&&Z.push([_.assetType.substring(B.length),ie]),Z},[])}function N(T){if(T.properties){const B=T.properties.filter(_=>_.key===r.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Z=B.filter(_=>q.test(_.value))[0];return Z?{uri:Z.value,fallbackUri:Z.value}:null}return M(T,r.Repository)}function F(T){return{uri:`${T.fallbackAssetUri}/${r.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${r.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function M(T,B){return T.files.filter(Z=>Z.assetType===B)[0]?{uri:`${T.assetUri}/${B}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${B}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function z(T,B){const q=T.properties?T.properties.filter(_=>_.key===B):[],Z=q.length>0&&q[0].value;return Z?Z.split(",").map(_=>(0,m.$dp)(_)):[]}function Y(T){const B=T.properties?T.properties.filter(q=>q.key===a.Engine):[];return B.length>0&&B[0].value||""}function Q(T){const B=T.properties?T.properties.filter(q=>q.key===a.PreRelease):[];return B.length>0&&B[0].value==="true"}function x(T){const B=T.properties?T.properties.filter(Z=>Z.key===a.LocalizedLanguages):[],q=B.length>0&&B[0].value||"";return q?q.split(","):[]}function W(T){return T.properties?.find(B=>B.key===a.SponsorLink)?.value}function X(T){return T.properties?.find(B=>B.key===a.SupportLink)?.value}function H(T){return T.indexOf("preview")!==-1}function V(T){return T.targetPlatform?(0,S.$Fo)(T.targetPlatform):"undefined"}function te(T){const B=(0,O.$Mb)(T.versions.map(V)),q=!!T.tags?.includes(S.$Ao),Z=B.indexOf("web");return q?Z===-1&&B.push("web"):Z!==-1&&B.splice(Z,1),B}function oe(T,B){for(let q=0;q<T.length;q++){const Z=T[q];if(Z.version===T[q-1]?.version){let _=q;if(V(Z)===B)for(;_>0&&T[_-1].version===Z.version;)_--;_!==q&&(T.splice(q,1),T.splice(_,0,Z))}}return T}e.$Np=oe;function ee(T,B,q){T.telemetryData={index:B,querySource:q,queryActivityId:T.queryContext?.[o]}}function ae(T,B,q,Z){const _=T.versions[0],ie={manifest:M(B,r.Manifest),readme:M(B,r.Details),changelog:M(B,r.Changelog),license:M(B,r.License),repository:N(B),download:F(B),icon:M(B,r.Icon),signature:M(B,r.Signature),coreTranslations:P(B)};return{identifier:{id:(0,m.$ep)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:B.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(_),description:T.shortDescription||"",installCount:p(T.statistics,"install"),rating:p(T.statistics,"averagerating"),ratingCount:p(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:q,assets:ie,properties:{dependencies:z(B,a.Dependency),extensionPack:z(B,a.ExtensionPack),engine:Y(B),localizedLanguages:x(B),targetPlatform:V(B),isPreReleaseVersion:Q(B)},hasPreReleaseVersion:Q(_),hasReleaseVersion:!0,preview:H(T.flags),isSigned:!!ie.signature,queryContext:Z,supportLink:X(_)}}let G=class{constructor(B,q,Z,_,ie,J,ne,ce){this.k=q,this.l=Z,this.n=_,this.o=ie,this.q=J,this.u=ne,this.w=ce;const fe=ne.extensionsGallery,de=fe?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=de?fe.servicePPEUrl:fe?.serviceUrl,this.g=de?void 0:fe?.searchUrl,this.h=fe?.controlUrl,this.j=(0,f.$Mp)(ne.version,ne,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,q,Z){const _=A.CancellationToken.isCancellationToken(q)?{}:q,ie=A.CancellationToken.isCancellationToken(q)?q:Z,J=[],ne=[],ce=[],fe=[];let de=!0;for(const Re of B){Re.uuid?ne.push(Re.uuid):J.push(Re.id);const Oe=!!(Re.version||Re.preRelease);ce.push({id:Re.id,uuid:Re.uuid,includePreRelease:Oe}),Re.version&&fe.push({id:Re.id,uuid:Re.uuid,version:Re.version}),de=de&&!!Re.hasPreRelease&&!Oe}if(!ne.length&&!J.length)return[];let me=new u().withPage(1,B.length);ne.length&&(me=me.withFilter(t.ExtensionId,...ne)),J.length&&(me=me.withFilter(t.ExtensionName,...J)),(_.queryAllVersions||de)&&(me=me.withFlags(me.flags,n.IncludeVersions)),_.source&&(me=me.withSource(_.source));const{extensions:Ee}=await this.z(me,{targetPlatform:_.targetPlatform??i,includePreRelease:ce,versions:fe,compatible:!!_.compatible},ie);return _.source&&Ee.forEach((Re,Oe)=>ee(Re,Oe,_.source)),Ee}async getCompatibleExtension(B,q,Z){if((0,S.$Ho)(B.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(B,q,Z))return B;const _=new u().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,B.identifier.uuid),{extensions:ie}=await this.z(_,{targetPlatform:Z,compatible:!0,includePreRelease:q},A.CancellationToken.None);return ie[0]||null}async isExtensionCompatible(B,q,Z){if(!(0,S.$Io)(B.properties.targetPlatform,B.allTargetPlatforms,Z)||!q&&B.properties.isPreReleaseVersion)return!1;let _=B.properties.engine;if(!_){const ie=await this.getManifest(B,A.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");_=ie.engines.vscode}return(0,h.$rp)(_,this.u.version,this.u.date)}async y(B,q,Z,_,ie){if(!(0,S.$Io)(V(B),_,ie)||q!=="any"&&Q(B)!==(q==="prerelease"))return!1;if(Z)try{const J=await this.E(B);if(!(0,h.$rp)(J,this.u.version,this.u.date))return!1}catch(J){return this.l.error(`Error while getting the engine for the version ${B.version}.`,(0,D.$0)(J)),!1}return!0}async query(B,q){let Z=B.text||"";const _=B.pageSize??50;let ie=new u().withPage(1,_);Z?(Z=Z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(ie=ie.withFilter(t.Category,Ee||me),"")),Z=Z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(ie=ie.withFilter(t.Tag,Ee||me),"")),Z=Z.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(t.Featured),"")),Z=Z.trim(),Z&&(Z=Z.length<200?Z:Z.substring(0,200),ie=ie.withFilter(t.SearchText,Z)),ie=ie.withSortBy(0)):B.ids?ie=ie.withFilter(t.ExtensionId,...B.ids):B.names?ie=ie.withFilter(t.ExtensionName,...B.names):ie=ie.withSortBy(4),typeof B.sortBy=="number"&&(ie=ie.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(ie=ie.withSortOrder(B.sortOrder)),B.source&&(ie=ie.withSource(B.source));const J=async(de,me)=>{const{extensions:Ee,total:Re}=await this.z(de,{targetPlatform:i,compatible:!1,includePreRelease:!!B.includePreRelease},me);return Ee.forEach((Oe,Ne)=>ee(Oe,(de.pageNumber-1)*de.pageSize+Ne,B.source)),{extensions:Ee,total:Re}},{extensions:ne,total:ce}=await J(ie,q),fe=async(de,me)=>{if(me.isCancellationRequested)throw new D.$5;const{extensions:Ee}=await J(ie.withPage(de+1),me);return Ee};return{firstPage:ne,total:ce,pageSize:ie.pageSize,getPage:fe}}async z(B,q,Z){const _=B.flags;B.flags&n.IncludeLatestVersionOnly&&B.flags&n.IncludeVersions&&(B=B.withFlags(B.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(B.flags&n.IncludeLatestVersionOnly)&&!(B.flags&n.IncludeVersions)&&(B=B.withFlags(B.flags,n.IncludeLatestVersionOnly)),q.versions?.length&&(B=B.withFlags(B.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),B=B.withFlags(B.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:ie,total:J,context:ne}=await this.B(B,Z);if(!(B.flags&n.IncludeLatestVersionOnly)){const me=[];for(const Ee of ie){const Re=await this.A(Ee,q,ne);Re&&me.push(Re)}return{extensions:me,total:J}}const fe=[],de=new Map;for(let me=0;me<ie.length;me++){const Ee=ie[me],Re={id:(0,m.$ep)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Oe=(0,R.$Yf)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ue=>(0,m.$_o)(ue,Re))?.includePreRelease;if(q.compatible&&(0,S.$Ho)(te(Ee),q.targetPlatform))continue;const Ne=await this.A(Ee,q,ne);!Ne||Ne.properties.isPreReleaseVersion&&(!Oe||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==q.targetPlatform&&Ne.hasPreReleaseVersion?de.set(Ee.extensionId,me):fe.push([me,Ne])}if(de.size){const me=new v.$1d,Ee=new u().withFlags(_&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(t.ExtensionId,...de.keys()),{extensions:Re}=await this.z(Ee,q,Z);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:de.size});for(const Oe of Re){const Ne=de.get(Oe.identifier.uuid);fe.push([Ne,Oe])}}return{extensions:fe.sort((me,Ee)=>me[0]-Ee[0]).map(([,me])=>me),total:J}}async A(B,q,Z){const _={id:(0,m.$ep)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},ie=q.versions?.find(fe=>(0,m.$_o)(fe,_))?.version,J=(0,R.$Yf)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(fe=>(0,m.$_o)(fe,_))?.includePreRelease,ne=te(B),ce=oe(B.versions,q.targetPlatform);if(q.compatible&&(0,S.$Ho)(ne,q.targetPlatform))return null;for(let fe=0;fe<ce.length;fe++){const de=ce[fe];if(!(ie&&de.version!==ie)){if(await this.y(de,J?"any":"release",q.compatible,ne,q.targetPlatform))return ae(B,de,ne,Z);if(ie&&de.version===ie)return null}}return ie||q.compatible?null:ae(B,B.versions[0],ne)}async B(B,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const Z=await this.j,_=JSON.stringify(B.raw),ie={...Z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},J=new v.$1d;let ne,ce,fe=0;try{if(ne=await this.k.request({type:"POST",url:this.g&&B.criteria.some(me=>me.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:ie},q),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:fe};const de=await(0,c.$yp)(ne);if(de){const me=de.results[0],Ee=me.extensions,Re=me.resultMetadata&&me.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return fe=Re&&Re.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:fe,context:{[o]:ne.res.headers.activityid}}}return{galleryExtensions:[],total:fe}}catch(de){const me=(0,D.$4)(de)?S.ExtensionGalleryErrorCode.Cancelled:(0,D.$0)(de).startsWith("XHR timeout")?S.ExtensionGalleryErrorCode.Timeout:S.ExtensionGalleryErrorCode.Failed;throw ce=new S.$Mo((0,D.$0)(de),me),ce}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(_.length),duration:J.elapsed(),success:!!ne&&(0,c.$up)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:ce?.code,count:String(fe)})}}async reportStatistic(B,q,Z,_){if(!this.isEnabled())return;const ie=L.$o?this.x(`/itemName/${B}.${q}/version/${Z}/statType/${_==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${q}/${Z}/stats?statType=${_}`),J=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:J};try{await this.k.request({type:"POST",url:ie,headers:ce},A.CancellationToken.None)}catch{}}async download(B,q,Z){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const _=(0,m.$hp)(B),ie=new Date().getTime(),J=me=>this.o.publicLog("galleryService:downloadVSIX",{..._,duration:me}),ne=Z===2?"install":Z===3?"update":"",ce=ne?{uri:`${B.assets.download.uri}${k.URI.parse(B.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${B.assets.download.fallbackUri}${k.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:B.assets.download,fe=B.queryContext?.[o]?{[o]:B.queryContext[o]}:void 0,de=await this.D(ce,fe?{headers:fe}:void 0);await this.q.writeFile(q,de.stream),J(new Date().getTime()-ie)}async downloadSignatureArchive(B,q){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const Z=await this.D(B.assets.signature);await this.q.writeFile(q,Z.stream)}async getReadme(B,q){if(B.assets.readme){const Z=await this.D(B.assets.readme,{},q);return await(0,c.$xp)(Z)||""}return""}async getManifest(B,q){if(B.assets.manifest){const Z=await this.D(B.assets.manifest,{},q),_=await(0,c.$xp)(Z);return _?JSON.parse(_):null}return null}async C(B,q){const Z=M(B,r.Manifest);if(!Z)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},ie=await this.D(Z,{headers:_});return await(0,c.$yp)(ie)}async getCoreTranslation(B,q){const Z=B.assets.coreTranslations.filter(_=>_[0]===q.toUpperCase())[0];if(Z){const _=await this.D(Z[1]),ie=await(0,c.$xp)(_);return ie?JSON.parse(ie):null}return null}async getChangelog(B,q){if(B.assets.changelog){const Z=await this.D(B.assets.changelog,{},q);return await(0,c.$xp)(Z)||""}return""}async getAllCompatibleVersions(B,q,Z){let _=new u().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?_=_.withFilter(t.ExtensionId,B.identifier.uuid):_=_.withFilter(t.ExtensionName,B.identifier.id);const{galleryExtensions:ie}=await this.B(_,A.CancellationToken.None);if(!ie.length)return[];const J=te(ie[0]);if((0,S.$Ho)(J,Z))return[];const ne=[];await Promise.all(ie[0].versions.map(async de=>{try{await this.y(de,q?"any":"release",!0,J,Z)&&ne.push(de)}catch{}}));const ce=[],fe=new Set;for(const de of oe(ne,Z))fe.has(de.version)||(fe.add(de.version),ce.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:Q(de)}));return ce}async D(B,q={},Z=A.CancellationToken.None){const _=await this.j,ie={type:"GET"},J={..._,...q.headers||{}};q={...q,...ie,headers:J};const ne=B.uri,ce=B.fallbackUri,fe={...q,url:ne};try{const de=await this.k.request(fe,Z);if(de.res.statusCode===200)return de;const me=await(0,c.$xp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${me}`)}catch(de){if((0,D.$4)(de))throw de;const me=(0,D.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{url:ne,message:me});const Ee={...q,url:ce};return this.k.request(Ee,Z)}}async E(B){let q=Y(B);if(!q){const Z=await this.C(B,A.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");q=Z.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const B=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,c.$yp)(B),Z=[],_={},ie=[];if(q){for(const J of q.malicious)Z.push({id:J});if(q.migrateToPreRelease)for(const[J,ne]of Object.entries(q.migrateToPreRelease))(!ne.engine||(0,h.$rp)(ne.engine,this.u.version,this.u.date))&&(_[J.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[J,ne]of Object.entries(q.deprecated))ne&&(_[J.toLowerCase()]=(0,R.$Yf)(ne)?{}:ne);if(q.search)for(const J of q.search)ie.push(J)}return{malicious:Z,deprecated:_,search:ie}}};G=ye([K(1,c.$sp),K(2,b.$yj),K(3,C.$li),K(4,l.$Fl),K(5,$.$Bk),K(6,y.$Qj),K(7,g.$Ki)],G);let U=class extends G{constructor(B,q,Z,_,ie,J,ne,ce){super(B,q,Z,_,ie,J,ne,ce)}};e.$Op=U,e.$Op=U=ye([K(0,d.$Fp),K(1,c.$sp),K(2,b.$yj),K(3,C.$li),K(4,l.$Fl),K(5,$.$Bk),K(6,y.$Qj),K(7,g.$Ki)],U);let j=class extends G{constructor(B,q,Z,_,ie,J,ne){super(void 0,B,q,Z,_,ie,J,ne)}};e.$Pp=j,e.$Pp=j=ye([K(0,c.$sp),K(1,b.$yj),K(2,C.$li),K(3,l.$Fl),K(4,$.$Bk),K(5,y.$Qj),K(6,g.$Ki)],j)}),define(le[83],he([0,1,4,3,2,19,33,24,17,8,12]),function(se,e,O,A,D,L,I,R,k,g,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=void 0,e.$yv=(0,O.$ei)("IExtensionStorageService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let h=class extends D.$Tc{static{S=this}static{this.a=512*1024}static b(b){return`extensionKeys/${(0,I.$dp)(b.id)}@${b.version}`}static c(b){const y=m.exec(b);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(b,y){const c=await b.getInstalled(),f=[];for(const[d,l]of S.f(y)){const v=c.find(i=>(0,I.$_o)(i.identifier,{id:d}))?.manifest.version;for(const i of l)v!==i&&f.push(S.b({id:d,version:i}))}for(const d of f)y.remove(d,0)}static f(b){const y=new Map,c=b.keys(0,1);for(const f of c){const d=S.c(f);if(d){let l=y.get(d.id.toLowerCase());l||y.set(d.id.toLowerCase(),l=[]),l.push(d.version)}}return y}constructor(b,y,c){super(),this.j=b,this.m=y,this.n=c,this.g=this.B(new A.$5d),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=S.f(b),this.B(this.j.onDidChangeValue(0,void 0,this.B(new D.$Sc))(f=>this.r(f)))}r(b){if(this.h.has(b.key.toLowerCase())){this.g.fire();return}const y=S.c(b.key);if(y){if(this.j.get(b.key,0)===void 0)this.h.delete(y.id.toLowerCase());else{let c=this.h.get(y.id.toLowerCase());c||this.h.set(y.id.toLowerCase(),c=[]),c.push(y.version),this.g.fire()}return}}s(b){if((0,C.$Sf)(b))return b;const y=b.manifest?b.manifest.publisher:b.publisher,c=b.manifest?b.manifest.name:b.name;return(0,I.$cp)(y,c)}getExtensionState(b,y){const c=this.s(b),f=this.getExtensionStateRaw(b,y);if(f)try{return JSON.parse(f)}catch(d){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${y}): ${d}`)}}getExtensionStateRaw(b,y){const c=this.s(b),f=this.j.get(c,y?0:1);return f&&f?.length>S.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${y}): ${f.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),f}setExtensionState(b,y,c){const f=this.s(b);y===void 0?this.j.remove(f,c?0:1):this.j.store(f,JSON.stringify(y),c?0:1,1)}setKeysForSync(b,y){this.j.store(S.b(b),JSON.stringify(y),0,1)}getKeysForSync(b){const y=this.m.extensionSyncedKeys?.[b.id.toLowerCase()],c=this.j.get(S.b(b),0),f=c?JSON.parse(c):void 0;return f&&y?(0,k.$Mb)([...f,...y]):f||y}addToMigrationList(b,y){if(b!==y){const c=this.t.filter(f=>!f.includes(b)&&!f.includes(y));c.push([b,y]),this.t=c}}getSourceExtensionToMigrate(b){const y=this.t.find(([,c])=>b===c);return y?y[0]:void 0}get t(){const b=this.j.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(b);if(Array.isArray(y))return y}catch{}return[]}set t(b){b.length?this.j.store("extensionStorage.migrationList",JSON.stringify(b),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$zv=h,e.$zv=h=S=ye([K(0,L.$Fp),K(1,R.$Qj),K(2,g.$yj)],h)}),define(le[249],he([0,1,2,29,83,224,113,8,19]),function(se,e,O,A,D,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=void 0;let g=class extends O.$Tc{constructor(S,m,h,$,b,y){super(),S.cleanUp(),(0,L.$K1b)(S,m,h,$,y),D.$zv.removeOutdatedExtensionVersions(S,b)}};e.$ebc=g,e.$ebc=g=ye([K(0,I.$iq),K(1,A.$Ko),K(2,D.$yv),K(3,A.$Qo),K(4,k.$Fp),K(5,R.$yj)],g)}),define(le[250],he([0,1,29,11,24,15,97,57,19,22,223]),function(se,e,O,A,D,L,I,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;let S=class extends C.$B0b{constructor(h,$,b,y,c,f,d,l){super(h.userHome,c,$,b,y,f,d,l)}};e.$lbc=S,e.$lbc=S=ye([K(0,L.$mi),K(1,g.$Fl),K(2,O.$No),K(3,k.$Fp),K(4,R.$b_b),K(5,I.$u1b),K(6,A.$Bk),K(7,D.$Qj)],S)}),define(le[251],he([0,1,105,3,22,15,2,8,16,67,24,5,6,101,21,165,36,19,12,132,20]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=void 0;const v=[O.$abc,O.$bbc],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends I.$Tc{constructor(a,E,w,u,p,P,N){super(),this.y=a,this.z=E,this.C=w,this.D=P,this.F=N,this.f=new A.$5d,this.onDidTokenFailed=this.f.event,this.g=new A.$5d,this.onDidChangeTunnelStatus=this.g.event,this.h=new A.$5d,this.onDidChangeMode=this.h.event,this.n=O.$$ac,this.w=!1,this.I=(F,M)=>{M?this.j.error(F):this.j.info(F)},this.j=this.B(u.createLogger((0,l.$Rg)(w.logsHome,`${O.$cbc}.log`),{id:O.$cbc,name:O.$dbc})),this.t=new m.$bh(100),this.B(this.j.onDidChangeLogLevel(F=>this.j.info("Log level changed to "+(0,R.$Nj)(F)))),this.B(p.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(P.onDidChangeConfiguration(F=>{v.some(M=>F.affectsConfiguration(M))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=O.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(E){this.j.error(E)}return this.s}J(){if(!this.u){let a;S.$j?a=this.C.appRoot:a=(0,k.$mc)((0,k.$mc)(this.C.appRoot)),this.u=(0,k.$jc)(a,"bin",`${this.z.tunnelApplicationName}${S.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(E){this.j.error(E)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(O.$$ac);try{a&&this.O("uninstallService",["service","uninstall"])}catch(E){this.j.error(E)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(O.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",E=!1;const w=(M,z)=>{z?this.j.error(M):a+=M,!this.C.isBuilt&&M.startsWith("   Compiling")&&this.G(O.TunnelStates.connecting((0,b.localize)(0,null)))},u=this.O("status",["status"],w);this.r=u;try{if(await u,this.r!==u)return;let M;try{M=JSON.parse(a.trim().split(`
`).find(z=>z.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(O.TunnelStates.disconnected());return}if(E=M.service_installed,this.j.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this.n.active){this.G(O.TunnelStates.disconnected());return}}catch(M){this.j.error(M),this.G(O.TunnelStates.disconnected());return}finally{this.r===u&&(this.r=void 0)}const p=this.n.active?this.n.session:void 0;if(p&&p.token){const M=p.token;this.G(O.TunnelStates.connecting((0,b.localize)(1,null,p.accountLabel,p.providerId)));const z=(Q,x)=>{Q=Q.replaceAll(M,"*".repeat(4)),w(Q,x)},Y=this.O("login",["user","login","--provider",p.providerId,"--access-token",M,"--log",(0,R.$Nj)(this.j.getLevel())],z);this.r=Y;try{if(await Y,this.r!==Y)return}catch(Q){this.j.error(Q),this.r=void 0,this.f.fire(p),this.G(O.TunnelStates.disconnected(p));return}}const P=this.Q();P?this.G(O.TunnelStates.connecting((0,b.localize)(2,null,P))):this.G(O.TunnelStates.connecting((0,b.localize)(3,null)));const N=["--accept-server-license-terms","--log",(0,R.$Nj)(this.j.getLevel())];P?N.push("--name",P):N.push("--random-name");let F=!1;return this.n.active&&this.n.asService&&!E&&(F=await this.M(N)===!1),this.N(p,N,F)}async M(a){let E;try{E=await this.O("serviceInstall",["service","install",...a])}catch(w){this.j.error(w),E=1}if(E!==0){const w=(0,b.localize)(4,null);return this.j.warn(w),this.G(O.TunnelStates.connecting(w)),!1}return!0}async N(a,E,w){E.push("--parent-process-id",String(process.pid)),this.P()&&E.push("--no-sleep");let u=!1;const p=this.O("tunnel",E,(P,N)=>{N?this.j.error(P):this.j.info(P),P.includes("Connected to an existing tunnel process")&&(u=!0);const F=P.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const M={link:F[1],domain:F[2],tunnelName:F[4],isAttached:u};this.G(O.TunnelStates.connected(M,w))}else P.match(/error refreshing token/)&&(p.cancel(),this.f.fire(a),this.G(O.TunnelStates.disconnected(a)))});this.r=p,p.finally(()=>{p===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=O.$$ac,this.G(O.TunnelStates.disconnected()))})}O(a,E,w=this.I){return(0,m.$4g)(u=>new Promise((p,P)=>{u.isCancellationRequested&&p(-1);let N;const F=["ignore","pipe","pipe"];if(u.onCancellationRequested(()=>{N&&(this.j.info(`${a} terminating(${N.pid})`),N.kill())}),!this.C.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${a} Spawning: cargo run -- tunnel ${E.join(" ")}
`,!1),N=(0,g.spawn)("cargo",["run","--","tunnel",...E],{cwd:(0,k.$jc)(this.C.appRoot,"cli"),stdio:F});else{w(`Running tunnel CLI
`,!1);const M=this.J();w(`${a} Spawning: ${M} tunnel ${E.join(" ")}
`,!1),N=(0,g.spawn)(M,["tunnel",...E],{cwd:(0,y.homedir)(),stdio:F})}N.stdout.pipe(new d.$wV(`
`)).on("data",M=>{if(N){const z=M.toString();w(z,!1)}}),N.stderr.pipe(new d.$wV(`
`)).on("data",M=>{if(N){const z=M.toString();w(z,!0)}}),N.on("exit",M=>{N&&(w(`${a} exit(${N.pid}): + ${M} `,!1),N=void 0,p(M||0))}),N.on("error",M=>{N&&(w(`${a} error(${N.pid}): + ${M} `,!0),N=void 0,P())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(O.$bbc)}Q(){let a=this.D.getValue(O.$abc)||(0,y.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),E=this.F.getBoolean(o,-1,!1);if(a){const w=JSON.parse(a);if(w&&(0,f.$Sf)(w.accountLabel)&&(0,f.$Sf)(w.sessionId)&&(0,f.$Sf)(w.providerId))return{active:!0,session:w,asService:E};this.j.error("Problems restoring session from storage, invalid format",w)}}catch(a){this.j.error("Problems restoring session from storage",a)}return O.$$ac}S(a){if(a.active){const E={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(E),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$hbc=n,e.$hbc=n=ye([K(0,D.$Fl),K(1,C.$Qj),K(2,L.$mi),K(3,R.$zj),K(4,h.$fbc),K(5,$.$Ki),K(6,c.$Fp)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[252],he([0,1,6,2,23,20,69,19,78,18]),function(se,e,O,A,D,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=void 0;class C extends R.$Hp{constructor(m,h,$,b){super(),this.bb=m,this.cb=h,this.db=$,this.eb=b,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new A.$Sc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new A.$Sc),this.ab=this.hb(this.bb)}fb(){const m=this.B(new k.$lHb(this.db.getChannel("storage"))),h=this.B(new I.$Bp(m));return this.B(h.onDidChangeStorage($=>this.u(-1,$))),h}gb(m){this.X.clear(),this.W=m;let h;if((0,R.$Ip)(m))h=this.U;else{const $=this.X.add(new k.$mHb(this.db.getChannel("storage"),m));h=this.X.add(new I.$Bp($))}return this.X.add(h.onDidChangeStorage($=>this.u(0,$))),h}hb(m){this.$.clear(),this.Z=m?.id;let h;if(m){const $=this.$.add(new k.$nHb(this.db.getChannel("storage"),m));h=this.$.add(new I.$Bp($)),this.$.add(h.onDidChangeStorage(b=>this.u(1,b)))}return h}async O(){await O.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(m){switch(m){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(m){switch(m){case-1:return this.s.globalStorageHome.with({scheme:D.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:D.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$Rg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:D.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await O.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(m){if(!this.M(this.W,m))return;const h=this.Y,$=h.items;h!==this.U&&await h.close(),this.Y=this.gb(m),await this.Y.init(),this.N($,this.Y,0)}async S(m,h){const $=this.ab,b=$?.items??new Map;await $?.close(),this.ab=this.hb(m),await this.ab.init(),this.N(b,this.ab,1)}hasScope(m){return(0,g.$al)(m)?this.W.id===m.id:this.Z===m.id}}e.$mbc=C}),define(le[253],he([0,1,3,2,18,92]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.$GP=void 0;class I{constructor(g,C){this.a=g,this.b=C}listen(g,C){const S=this.b(g);switch(C){case"onDidChangeProfiles":return O.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(h=>(0,L.$fn)({...h},S)),added:m.added.map(h=>(0,L.$fn)({...h},S)),removed:m.removed.map(h=>(0,L.$fn)({...h},S)),updated:m.updated.map(h=>(0,L.$fn)({...h},S))}))}throw new Error(`Invalid listen ${C}`)}async call(g,C,S){const m=this.b(g);switch(C){case"createProfile":{const h=await this.a.createProfile(S[0],S[1],S[2]);return(0,L.$fn)({...h},m)}case"updateProfile":{let h=(0,D.$cl)((0,L.$gn)(S[0],m),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,S[1]),(0,L.$fn)({...h},m)}case"removeProfile":{const h=(0,D.$cl)((0,L.$gn)(S[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${C}`)}}e.$GP=I;class R extends A.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,C,S){super(),this.profilesHome=C,this.f=S,this.a=[],this.b=this.B(new O.$5d),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(m=>(0,D.$cl)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const h=m.added.map(y=>(0,D.$cl)(y,this.profilesHome.scheme)),$=m.removed.map(y=>(0,D.$cl)(y,this.profilesHome.scheme)),b=m.updated.map(y=>(0,D.$cl)(y,this.profilesHome.scheme));this.a=m.all.map(y=>(0,D.$cl)(y,this.profilesHome.scheme)),this.b.fire({added:h,removed:$,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,C,S){const m=await this.f.call("createNamedProfile",[g,C,S]);return(0,D.$cl)(m,this.profilesHome.scheme)}async createProfile(g,C,S,m){const h=await this.f.call("createProfile",[g,C,S,m]);return(0,D.$cl)(h,this.profilesHome.scheme)}async createTransientProfile(g){const C=await this.f.call("createTransientProfile",[g]);return(0,D.$cl)(C,this.profilesHome.scheme)}async setProfileForWorkspace(g,C){await this.f.call("setProfileForWorkspace",[g,C])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,C){const S=await this.f.call("updateProfile",[g,C]);return(0,D.$cl)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$HP=R}),define(le[60],he([0,1,2,69,4,19,3,78,18]),function(se,e,O,A,D,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rHb=e.$qHb=e.$pHb=void 0,e.$pHb=(0,D.$ei)("IUserDataProfileStorageService");let g=class extends O.$Tc{constructor(h){super(),this.a=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async $=>this.b($))}async updateStorageData(h,$,b){return this.withProfileScopedStorageService(h,async y=>this.c(y,$,b))}async withProfileScopedStorageService(h,$){if(this.a.hasScope(h))return $(this.a);const b=await this.g(h),y=new S(b);try{await y.initialize();const c=await $(y);return await y.flush(),c}finally{y.dispose(),await this.f(b)}}b(h){const $=new Map,b=y=>{for(const c of h.keys(0,y))$.set(c,{value:h.get(c,0),target:y})};return b(0),b(1),$}c(h,$,b){h.storeAll(Array.from($.entries()).map(([y,c])=>({key:y,value:c,scope:0,target:b})),!0)}async f(h){try{await h.close()}finally{(0,O.$Nc)(h)&&h.dispose()}}};e.$qHb=g,e.$qHb=g=ye([K(0,L.$Fp)],g);class C extends g{constructor(h,$,b,y){super(b),this.j=h;const c=h.getChannel("profileStorageListener"),f=this.B(new O.$Uc);this.h=this.B(new I.$5d({onWillAddFirstListener:()=>{f.value=c.listen("onDidChange")(d=>{y.trace("profile storage changes",d),this.h.fire({targetChanges:d.targetChanges.map(l=>(0,k.$cl)(l,$.profilesHome.scheme)),valueChanges:d.valueChanges.map(l=>({...l,profile:(0,k.$cl)(l.profile,$.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>f.value=void 0})),this.onDidChange=this.h.event}async g(h){const $=this.j.getChannel("storage");return(0,L.$Ip)(h)?new R.$lHb($):new R.$mHb($,h)}}e.$rHb=C;class S extends L.$Hp{constructor(h){super({flushInterval:100}),this.s=this.B(new A.$Bp(h))}O(){return this.s.init()}P(h){return h===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[254],he([0,1,19,8,18,56,60]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=void 0;let R=class extends I.$rHb{constructor(g,C,S,m){super(g,C,S,m)}};e.$4ac=R,e.$4ac=R=ye([K(0,L.$qac),K(1,D.$bl),K(2,O.$Fp),K(3,A.$yj)],R)}),define(le[39],he([0,1,17,6,14,26,3,34,2,27,12,170,21,15,11,8,43,19,22,28,25,18]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qIb=e.$pIb=e.$oIb=e.$nIb=e.$mIb=e.$lIb=e.$kIb=void 0;function i(E){return!!(E&&E.ref!==void 0&&typeof E.ref=="string"&&E.ref!==""&&E.syncData!==void 0&&(E.syncData===null||o(E.syncData)))}e.$kIb=i;function o(E){return!!(E&&E.version!==void 0&&typeof E.version=="number"&&E.content!==void 0&&typeof E.content=="string"&&(Object.keys(E).length===2||Object.keys(E).length===3&&E.machineId!==void 0&&typeof E.machineId=="string"))}e.$lIb=o;function n(E,w){return`${(0,g.$Kf)(E)}${w.isDefault?"":` (${w.name})`}`}e.$mIb=n;let s=class extends k.$Tc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(w,u,p,P,N,F,M,z,Y,Q,x,W){super(),this.syncResource=w,this.collection=u,this.G=p,this.H=P,this.I=N,this.J=F,this.L=M,this.M=z,this.N=Y,this.O=Q,this.P=x,this.c=null,this.m="idle",this.n=this.B(new I.$5d),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new I.$5d),this.onDidChangeConflicts=this.t.event,this.u=this.B(new A.$ch(50)),this.w=this.B(new I.$5d),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(w.syncResource,w.profile),this.h=W.extUri,this.f=this.h.joinPath(P.userDataSyncHome,...(0,l.$1ob)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,l.$jpb),this.y=(0,l.$2ob)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,P,this.h),this.j=(0,y.$Lp)(P,p,N)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const u=await this.Y(w.remoteUserData,w.lastSyncUserData,!0,this.ob());this.S(u)}else{this.O.trace(`${this.D}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.ub(w):!0)&&this.w.fire()}}S(w){this.m!==w&&(this.m=w,this.n.fire(w))}async sync(w,u={}){await this.U(w,!0,this.ob(),u)}async preview(w,u,p={}){return this.U(w,!1,u,p)}async apply(w,u={}){try{this.F={...u};const p=await this.ab(w);return this.S(p),this.c}finally{this.F={}}}async U(w,u,p,P){try{if(this.F={...P},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let N="idle";try{const F=await this.getLastSyncUserData(),M=await this.X(w,F);return N=await this.Y(M,F,u,p),N==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(N)}}finally{this.F={}}}async replace(w){const u=this.kb(w);if(!u)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const p=await this.getLastSyncUserData(),P=await this.X(null,p),N=await this.W(P),F=await this.qb({ref:P.ref,syncData:u},p,N,this.ob(),L.CancellationToken.None),M=[];for(const z of F){const Y=await this.sb(z,z.remoteResource,void 0,L.CancellationToken.None),{remoteChange:Q}=await this.sb(z,z.previewResource,z.remoteContent,L.CancellationToken.None);M.push([z,{...Y,remoteChange:Q!==0?Q:2}])}await this.tb(P,p,M,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(w){const u=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===u}async X(w,u){if(u){const p=w?w[this.resource]:void 0;if(u.ref===p||p===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async Y(w,u,p,P){if(w.syncData&&w.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new l.$9ob((0,S.localize)(0,null,this.resource,this.pb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(w,u,p,P)}catch(N){if(N instanceof l.$9ob)switch(N.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(w,u,p,P);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.Y(w,u,p,P)}throw N}}async Z(w,u,p,P){try{const N=await this.W(w),F=!N&&u===null&&this.gb()!==void 0,M=p&&!F;this.c||(this.c=(0,A.$4g)(Y=>this.eb(w,u,N,M,P,Y)));let z=await this.c;if(p&&F){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of z.resourcePreviews)z=await this.accept(Y.remoteResource)||z}return this.cb(z.resourcePreviews),z.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":p?await this.ab(!1):"syncing"}catch(N){throw this.c=null,N}}async merge(w){return await this.$(w,async u=>{const p=await this.rb(u,L.CancellationToken.None);await this.G.writeFile(u.previewResource,D.$se.fromString(p?.content||""));const P=p&&!p.hasConflicts?await this.sb(u,u.previewResource,void 0,L.CancellationToken.None):void 0;return u.acceptResult=P,u.mergeState=p.hasConflicts?"conflict":P?"accepted":"preview",u.localChange=P?P.localChange:p.localChange,u.remoteChange=P?P.remoteChange:p.remoteChange,u}),this.c}async accept(w,u){return await this.$(w,async p=>{const P=await this.sb(p,w,u,L.CancellationToken.None);return p.acceptResult=P,p.mergeState="accepted",p.localChange=P.localChange,p.remoteChange=P.remoteChange,p}),this.c}async discard(w){return await this.$(w,async u=>{const p=await this.rb(u,L.CancellationToken.None);return await this.G.writeFile(u.previewResource,D.$se.fromString(p.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=p.localChange,u.remoteChange=p.remoteChange,u}),this.c}async $(w,u){if(!this.c)return;let p=await this.c;const P=p.resourcePreviews.findIndex(({localResource:N,remoteResource:F,previewResource:M})=>this.h.isEqual(N,w)||this.h.isEqual(F,w)||this.h.isEqual(M,w));P!==-1&&(this.c=(0,A.$4g)(async N=>{const F=[...p.resourcePreviews];return F[P]=await u(F[P]),{...p,resourcePreviews:F}}),p=await this.c,this.cb(p.resourcePreviews),p.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(w){if(!this.c)return"idle";const u=await this.c;return u.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.tb(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(p=>[p,p.acceptResult]),w),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(w){const u=w.filter(({mergeState:p})=>p==="conflict");(0,O.$ub)(this.s,u,(p,P)=>this.h.isEqual(p.previewResource,P.previewResource))||(this.s=u,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async db(w){const u=this.c?await this.c:null;if(u)for(const p of u.resourcePreviews){if(this.h.isEqual(p.acceptedResource,w))return p.acceptResult?p.acceptResult.content:null;if(this.h.isEqual(p.remoteResource,w))return p.remoteContent;if(this.h.isEqual(p.localResource,w))return p.localContent;if(this.h.isEqual(p.baseResource,w))return p.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(w){(0,$.$Sk)(w)!==1&&this.O.error(w)}}async eb(w,u,p,P,N,F){const M=await this.qb(w,u,p,N,F),z=[];for(const Y of M){const Q=Y.previewResource.with({scheme:l.$ipb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)z.push({...Y,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=P?await this.rb(Y,F):void 0;if(F.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,D.$se.fromString(x?.content||""));const W=x&&!x.hasConflicts?await this.sb(Y,Y.previewResource,void 0,F):void 0;z.push({...Y,acceptResult:W,mergeState:x?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:x?x.localChange:Y.localChange,remoteChange:W?W.remoteChange:x?x.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:u,resourcePreviews:z,isLastSyncFromCurrentMachine:p}}async getLastSyncUserData(){let w=this.gb();if(w||(w=await this.jb()),!w)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const u=JSON.parse(w),p=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!u.version&&!!p&&u.version!==p,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;let P,N=1;for(;P===void 0&&N++<6;)try{const F=await this.hb();F&&(F.ref===u.ref?P=F.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof $.$Wk&&F.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(F instanceof l.$9ob)throw F;this.O.error(F,N)}}if(P===void 0)try{const F=await this.J.resolveResourceContent(this.resource,u.ref,this.collection,this.F);P=F===null?null:this.kb(F),await this.ib({ref:u.ref,syncData:P})}catch(F){if(F instanceof l.$9ob&&F.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw F}return P===void 0?null:{...u,syncData:P}}async fb(w,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p=this.M.getResourceSyncStateVersion(this.resource),P={ref:w.ref,version:p,...u};this.I.store(this.z,JSON.stringify(P),-1,1),await this.ib(w)}gb(){return this.I.get(this.z,-1)}async hb(){const w=(await this.G.readFile(this.y)).value.toString();try{const u=w?JSON.parse(w):void 0;if(i(u))return u}catch(u){this.O.error(u)}}async ib(w){await this.G.writeFile(this.y,D.$se.fromString(JSON.stringify(w)))}async jb(){try{const w=await this.G.readFile(this.y),u=JSON.parse(w.value.toString());await this.G.del(this.y),u.ref&&u.content!==void 0?(this.I.store(this.z,JSON.stringify({...u,content:void 0}),-1,1),await this.ib({ref:u.ref,syncData:u.content===null?null:JSON.parse(u.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,u)}catch(w){w instanceof $.$Wk&&w.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(w)}return this.I.get(this.z,-1)}async getRemoteUserData(w){const{ref:u,content:p}=await this.lb(w);let P=null;return p!==null&&(P=this.kb(p)),{ref:u,syncData:P}}kb(w){try{const u=JSON.parse(w);if(o(u))return u}catch(u){this.O.error(u)}throw new l.$9ob((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(w){const u=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.J.readResource(this.resource,u,this.collection,this.F)}async mb(w,u){const p=await this.j,P={version:this.pb,machineId:p,content:w};try{return u=await this.J.writeResource(this.resource,JSON.stringify(P),u,this.collection,this.F),{ref:u,syncData:P}}catch(N){throw N instanceof l.$9ob&&N.code==="TooLarge"&&(N=new l.$9ob(N.message,N.code,this.resource)),N}}async nb(w){const u={version:this.pb,content:w};return this.L.writeResource(this.resource,JSON.stringify(u),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(l.$Vob)}};e.$nIb=s,e.$nIb=s=ye([K(2,$.$Bk),K(3,h.$li),K(4,c.$Fp),K(5,l.$4ob),K(6,l.$5ob),K(7,l.$bpb),K(8,f.$Fl),K(9,l.$gpb),K(10,m.$Ki),K(11,d.$_k)],s);let t=class extends s{constructor(w,u,p,P,N,F,M,z,Y,Q,x,W,X){super(u,p,P,N,F,M,z,Y,Q,x,W,X),this.r=w,this.B(this.G.watch(this.h.dirname(w))),this.B(this.G.onDidFilesChange(H=>this.yb(H)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(w,u,p){try{u?await this.G.writeFile(this.r,D.$se.fromString(w),p?void 0:u):await this.G.createFile(this.r,D.$se.fromString(w),{overwrite:p})}catch(P){throw P instanceof $.$Wk&&P.fileOperationResult===1||P instanceof $.$Wk&&P.fileOperationResult===3?new l.$9ob(P.message,"LocalPreconditionFailed"):P}}async xb(){try{await this.G.del(this.r)}catch(w){if(!(w instanceof $.$Wk&&w.fileOperationResult===1))throw w}}yb(w){w.contains(this.r)&&this.Q()}};e.$oIb=t,e.$oIb=t=ye([K(3,$.$Bk),K(4,h.$li),K(5,c.$Fp),K(6,l.$4ob),K(7,l.$5ob),K(8,l.$bpb),K(9,f.$Fl),K(10,l.$gpb),K(11,m.$Ki),K(12,d.$_k)],t);let r=class extends t{constructor(w,u,p,P,N,F,M,z,Y,Q,x,W,X,H){super(w,u,p,P,N,F,M,z,Y,Q,x,X,H),this.zb=W,this.Bb=void 0}Ab(w,u){const p=[],P=(0,R.$on)(w,p,{allowEmptyContent:!0,allowTrailingComma:!0});return p.length>0||!(0,C.$Zf)(P)&&u!==Array.isArray(P)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$pIb=r,e.$pIb=r=ye([K(3,$.$Bk),K(4,h.$li),K(5,c.$Fp),K(6,l.$4ob),K(7,l.$5ob),K(8,l.$bpb),K(9,f.$Fl),K(10,l.$gpb),K(11,l.$fpb),K(12,m.$Ki),K(13,d.$_k)],r);let a=class{constructor(w,u,p,P,N,F,M){this.resource=w,this.g=u,this.h=p,this.j=P,this.k=N,this.l=F,this.d=M.extUri,this.f=(0,l.$2ob)(void 0,this.resource,p,this.d)}async initialize({ref:w,content:u}){if(!u){this.j.info("Remote content does not exist.",this.resource);return}const p=this.m(u);if(p)try{await this.o({ref:w,syncData:p})}catch(P){this.j.error(P)}}m(w){try{const u=JSON.parse(w);if(o(u))return u}catch(u){this.j.error(u)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p={ref:w.ref,version:void 0,...u};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(p),-1,1),await this.k.writeFile(this.f,D.$se.fromString(JSON.stringify(w)))}};e.$qIb=a,e.$qIb=a=ye([K(1,v.$bl),K(2,h.$li),K(3,b.$yj),K(4,$.$Bk),K(5,c.$Fp),K(6,d.$_k)],a)}),define(le[115],he([0,1,6,26,7,3,42,2,27,21,15,114,29,33,83,45,11,4,74,8,19,22,28,18,39,235,111,25,60]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d,l,v,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L8b=e.$K8b=e.$J8b=e.$I8b=e.$H8b=void 0;async function E(F,M){const z=JSON.parse(F.content);if(F.version===1||F.version===2){const Y=(await M.getInstalled(0)).filter(Q=>Q.isBuiltin);for(const Q of z)F.version===1&&(Q.enabled===!1&&(Q.disabled=!0),delete Q.enabled),F.version===2&&Y.every(x=>!(0,h.$_o)(x.identifier,Q.identifier))&&(Q.installed=!0)}return z}function w(F){return JSON.parse(F.content)}e.$H8b=w;function u(F,M){return F.sort((z,Y)=>!z.identifier.uuid&&Y.identifier.uuid?-1:z.identifier.uuid&&!Y.identifier.uuid?1:(0,k.$cf)(z.identifier.id,Y.identifier.id)),M?(0,I.$zn)(F,{}):JSON.stringify(F)}e.$I8b=u;let p=class extends n.$nIb{constructor(M,z,Y,Q,x,W,X,H,V,te,oe,ee,ae,G,U,j,T){super({syncResource:"extensions",profile:M},z,Q,Y,x,W,X,ee,ae,te,oe,U),this.Cb=H,this.Db=V,this.Eb=T,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$ipb,authority:"base"}),this.yb=this.wb.with({scheme:r.$ipb,authority:"local"}),this.zb=this.wb.with({scheme:r.$ipb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$ipb,authority:"accepted"}),this.Bb=this.Eb.createInstance(P),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:q})=>!!q)),L.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),L.Event.filter(j.onDidChange,B=>B.valueChanges.some(({profile:q,changes:Z})=>this.syncResource.profile.id===q.id&&Z.some(_=>_.key===m.$Oo))),G.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(M,z){const Y=M.syncData?await E(M.syncData,this.Cb):null,Q=z?.skippedExtensions??[],x=z?.builtinExtensions??null,W=z?.syncData?await E(z.syncData,this.Cb):null,{localExtensions:X,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:te}=(0,s.$G8b)(X,Y,W,Q,H,x),oe={local:V,remote:te,content:this.Hb(X,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:te!==null?2:0},ee=this.Ob(X,!1);return[{skippedExtensions:Q,builtinExtensions:x,baseResource:this.xb,baseContent:W?this.Ob(W,!1):ee,localResource:this.yb,localContent:ee,localExtensions:X,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:oe,localChange:oe.localChange,remoteChange:oe.remoteChange,acceptedResource:this.Ab}]}async ub(M){const z=M.syncData?await E(M.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:Q}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,s.$G8b)(Y,z,z,M.skippedExtensions||[],Q,M.builtinExtensions||[]);return x!==null}Hb(M,z,Y,Q){const x=[...z,...Y],W=new Set,X=H=>{W.add(H.id.toLowerCase()),H.uuid&&W.add(H.uuid)};x.forEach(({identifier:H})=>X(H)),Q.forEach(X);for(const H of M)W.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&W.has(H.identifier.uuid)||x.push(H);return this.Ob(x,!1)}async rb(M,z){return{...M.previewResult,hasConflicts:!1}}async sb(M,z,Y,Q){if(this.h.isEqual(z,this.yb))return this.Kb(M);if(this.h.isEqual(z,this.zb))return this.Lb(M);if(this.h.isEqual(z,this.wb))return M.previewResult;throw new Error(`Invalid Resource: ${z.toString()}`)}async Kb(M){const z=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(z),Q=(0,s.$G8b)(M.localExtensions,null,null,M.skippedExtensions,Y,M.builtinExtensions),{local:x,remote:W}=Q;return{content:M.localContent,local:x,remote:W,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(M){const z=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(z),Q=M.remoteContent?JSON.parse(M.remoteContent):null;if(Q!==null){const x=(0,s.$G8b)(M.localExtensions,Q,M.localExtensions,[],Y,M.builtinExtensions),{local:W,remote:X}=x;return{content:M.remoteContent,local:W,remote:X,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:X!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(M,z,Y,Q){let{skippedExtensions:x,builtinExtensions:W,localExtensions:X}=Y[0][0];const{local:H,remote:V,localChange:te,remoteChange:oe}=Y[0][1];if(te===0&&oe===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),te!==0&&(await this.nb(JSON.stringify(X)),x=await this.Bb.updateLocalExtensions(H.added,H.removed,H.updated,x,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const ee=JSON.stringify(V.all);M=await this.mb(ee,Q?null:M.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(ae=>ae.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(ae=>ae.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(ae=>ae.identifier.id))}.`:""}`)}z?.ref!==M.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(X,W),await this.fb(M,{skippedExtensions:x,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ee=>ee.identifier.id))}.`:""}`))}Nb(M,z){const Y=new Set,Q=[];for(const x of M)Y.add(x.identifier.id.toLowerCase()),x.installed||Q.push(x.identifier);if(z)for(const x of z)Y.has(x.id.toLowerCase())||Q.push(x);return Q}async resolveContent(M){if(this.h.isEqual(this.zb,M)||this.h.isEqual(this.xb,M)||this.h.isEqual(this.yb,M)||this.h.isEqual(this.Ab,M)){const z=await this.db(M);return z&&this.Ob(JSON.parse(z),!0)}return null}Ob(M,z){return u(M,z)}async hasLocalData(){try{const{localExtensions:M}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(M.some(z=>z.installed||z.disabled))return!0}catch{}return!1}};e.$J8b=p,e.$J8b=p=ye([K(2,C.$li),K(3,y.$Bk),K(4,l.$Fp),K(5,r.$4ob),K(6,r.$5ob),K(7,m.$No),K(8,t.$9Ib),K(9,r.$gpb),K(10,g.$Ki),K(11,r.$bpb),K(12,v.$Fl),K(13,$.$yv),K(14,i.$_k),K(15,a.$pHb),K(16,c.$di)],p);let P=class{constructor(M,z,Y,Q,x,W){this.a=M,this.b=z,this.c=Y,this.d=Q,this.f=x,this.g=W}async getLocalExtensions(M){const z=await this.a.getInstalled(void 0,M.extensionsResource),Y=this.d.getIgnoredExtensions(z);return{localExtensions:await this.j(M,async(x,W)=>{const X=x.getDisabledExtensions();return z.map(H=>{const{identifier:V,isBuiltin:te,manifest:oe,preRelease:ee,pinned:ae,isApplicationScoped:G}=H,U={identifier:V,preRelease:ee,version:oe.version,pinned:!!ae};G&&!(0,b.$zm)(oe)&&(U.isApplicationScoped=G),X.some(j=>(0,h.$_o)(j,V))&&(U.disabled=!0),te||(U.installed=!0);try{const j=W.getKeysForSync({id:V.id,version:oe.version});if(j){const T=W.getExtensionState(H,!0)||{};U.state=Object.keys(T).reduce((B,q)=>(j.includes(q)&&(B[q]=T[q]),B),{})}}catch(j){this.g.info(`${(0,n.$mIb)("extensions",M)}: Error while parsing extension state`,(0,D.$0)(j))}return U})}),ignoredExtensions:Y}}async updateLocalExtensions(M,z,Y,Q,x){const W=(0,n.$mIb)("extensions",x),X=[],H=new Map,V=[],te=[],oe=await this.a.getInstalled(void 0,x.extensionsResource);if((M.length||Y.length)&&await this.j(x,async(G,U)=>{await O.Promises.settled([...M,...Y].map(async j=>{const T=oe.find(Z=>(0,h.$_o)(Z.identifier,j.identifier));if(T&&T.isBuiltin){j.state&&T.manifest.version===j.version&&this.h(j.state,T,T.manifest.version,U),G.getDisabledExtensions().some(_=>(0,h.$_o)(_,j.identifier))!==!!j.disabled&&(j.disabled?(this.g.trace(`${W}: Disabling extension...`,j.identifier.id),await G.disableExtension(j.identifier),this.g.info(`${W}: Disabled extension`,j.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,j.identifier.id),await G.enableExtension(j.identifier),this.g.info(`${W}: Enabled extension`,j.identifier.id))),V.push(j.identifier);return}const B=j.pinned?j.version:void 0,q=(await this.c.getExtensions([{...j.identifier,version:B,preRelease:B?void 0:j.preRelease}],A.CancellationToken.None))[0];if(j.state&&(T?T.manifest.version===j.version:q)&&this.h(j.state,T||q,T?.manifest.version,U),q)try{G.getDisabledExtensions().some(_=>(0,h.$_o)(_,j.identifier))!==!!j.disabled&&(j.disabled?(this.g.trace(`${W}: Disabling extension...`,j.identifier.id,q.version),await G.disableExtension(q.identifier),this.g.info(`${W}: Disabled extension`,j.identifier.id,q.version)):(this.g.trace(`${W}: Enabling extension...`,j.identifier.id,q.version),await G.enableExtension(q.identifier),this.g.info(`${W}: Enabled extension`,j.identifier.id,q.version))),(!T||T.preRelease!==j.preRelease||T.pinned!==j.pinned||B&&T.manifest.version!==B)&&(await this.a.canInstall(q)?(X.push({extension:q,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:j.pinned&&!!j.version,installPreReleaseVersion:j.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:j.isApplicationScoped,context:{[m.$Bo]:!0,[m.$Co]:!0}}}),H.set(q.identifier.id.toLowerCase(),j)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),te.push(j)))}catch(Z){te.push(j),this.g.error(Z),this.g.info(`${W}: Skipped synchronizing extension`,q.displayName||q.identifier.id)}else te.push(j),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,j.identifier.id)}))}),z.length){const G=oe.filter(({identifier:U,isBuiltin:j})=>!j&&z.some(T=>(0,h.$_o)(U,T)));await O.Promises.settled(G.map(async U=>{this.g.trace(`${W}: Uninstalling local extension...`,U.identifier.id),await this.a.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,U.identifier.id),V.push(U.identifier)}))}const ee=await this.a.installGalleryExtensions(X);for(const{identifier:G,local:U,error:j,source:T}of ee){const B=T;if(U)this.g.info(`${W}: Installed extension.`,G.id,B.version),V.push(G);else{const q=H.get(G.id.toLowerCase());q&&(te.push(q),this.g.info(`${W}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),j instanceof m.$Lo&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(j.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):j&&this.g.error(j)}}const ae=[];for(const G of Q)V.some(U=>(0,h.$_o)(U,G.identifier))||ae.push(G);for(const G of te)ae.some(U=>(0,h.$_o)(U.identifier,G.identifier))||ae.push(G);return ae}h(M,z,Y,Q){const x=Q.getExtensionState(z,!0)||{},W=Y?Q.getKeysForSync({id:z.identifier.id,version:Y}):void 0;W?W.forEach(X=>{x[X]=M[X]}):Object.keys(M).forEach(X=>x[X]=M[X]),Q.setExtensionState(z,x,!0)}async j(M,z){return this.b.withProfileScopedStorageService(M,async Y=>{const Q=new R.$Sc,x=this.f.createChild(new f.$ci([l.$Fp,Y])),W=Q.add(x.createInstance(S.$NGb)),X=Q.add(x.createInstance($.$zv));try{return await z(W,X)}finally{Q.dispose()}})}};e.$K8b=P,e.$K8b=P=ye([K(0,m.$No),K(1,a.$pHb),K(2,m.$Ko),K(3,t.$9Ib),K(4,c.$di),K(5,r.$gpb)],P);let N=class extends n.$qIb{constructor(M,z,Y,Q,x,W,X,H){super("extensions",Q,x,W,Y,X,H),this.p=M,this.q=z}async t(M){return M.syncData?await E(M.syncData,this.p):null}u(M,z){const Y=[],Q=[],x=[];for(const W of M){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const X=z.find(H=>(0,h.$_o)(H.identifier,W.identifier));X?(Y.push(X),W.disabled&&x.push(W.identifier)):W.installed&&(Q.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&x.push(W.identifier))}return{installedExtensions:Y,newExtensions:Q,disabledExtensions:x,remoteExtensions:M}}};e.$L8b=N,e.$L8b=N=ye([K(0,m.$No),K(1,t.$9Ib),K(2,y.$Bk),K(3,o.$bl),K(4,C.$li),K(5,d.$yj),K(6,l.$Fp),K(7,i.$_k)],N)}),define(le[116],he([0,1,14,7,3,34,42,5,32,21,15,11,8,43,19,22,28,39,80,239,25,18,60,4]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d,l,v,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wIb=e.$vIb=e.$uIb=e.$tIb=e.$sIb=void 0;const n="globalState.argv.",s=["locale"];function t(p,P){const N=p.storage?Object.keys(p.storage).sort():[],F={};return N.forEach(M=>F[M]=p.storage[M]),p.storage=F,P?(0,I.$zn)(p,{}):JSON.stringify(p)}e.$sIb=t;const r=1;let a=class extends c.$nIb{constructor(P,N,F,M,z,Y,Q,x,W,X,H,V,te,oe){super({syncResource:"globalState",profile:P},N,M,x,V,z,Y,W,X,Q,H,te),this.Bb=F,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:l.$ipb,authority:"base"}),this.xb=this.vb.with({scheme:l.$ipb,authority:"local"}),this.yb=this.vb.with({scheme:l.$ipb,authority:"remote"}),this.zb=this.vb.with({scheme:l.$ipb,authority:"accepted"}),this.Ab=oe.createInstance(E),this.B(M.watch(this.h.dirname(this.H.argvResource))),this.B(D.Event.any(D.Event.filter(M.onDidFilesChange,ee=>ee.contains(this.H.argvResource)),D.Event.filter(F.onDidChange,ee=>!!(ee.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||ee.valueChanges.some(({profile:ae,changes:G})=>this.syncResource.profile.id===ae.id&&G.some(U=>U.target===0)))))(()=>this.Q()))}async qb(P,N,F){const M=P.syncData?JSON.parse(P.syncData.content):null;N=N===null&&F?P:N;const z=N&&N.syncData?JSON.parse(N.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);M?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.Jb(z),{local:x,remote:W}=(0,d.$rIb)(Y.storage,M?M.storage:null,z?z.storage:null,Q,this.O),X={content:null,local:x,remote:W,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:W.all!==null?2:0},H=t(Y,!1);return[{baseResource:this.wb,baseContent:z?t(z,!1):H,localResource:this.xb,localContent:H,localUserData:Y,remoteResource:this.yb,remoteContent:M?t(M,!1):null,previewResource:this.vb,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.zb,storageKeys:Q}]}async ub(P){const N=P.syncData?JSON.parse(P.syncData.content):null;if(N===null)return!0;const F=await this.Ab.getLocalGlobalState(this.syncResource.profile),M=await this.Jb(N),{remote:z}=(0,d.$rIb)(F.storage,N.storage,N.storage,M,this.O);return z.all!==null}async rb(P,N){return{...P.previewResult,hasConflicts:!1}}async sb(P,N,F,M){if(this.h.isEqual(N,this.xb))return this.Gb(P);if(this.h.isEqual(N,this.yb))return this.Hb(P);if(this.h.isEqual(N,this.vb))return P.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async Gb(P){return{content:P.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(P.localUserData.storage),removed:[],updated:[],all:P.localUserData.storage},localChange:0,remoteChange:2}}async Hb(P){if(P.remoteContent!==null){const N=JSON.parse(P.remoteContent),{local:F,remote:M}=(0,d.$rIb)(P.localUserData.storage,N.storage,null,P.storageKeys,this.O);return{content:P.remoteContent,local:F,remote:M,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:P.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(P,N,F,M){const{localUserData:z}=F[0][0],{local:Y,remote:Q,localChange:x,remoteChange:W}=F[0][1];if(x===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(z)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const X=JSON.stringify({storage:Q.all});P=await this.mb(X,M?null:P.ref),this.O.info(`${this.D}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}N?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(P){if(this.h.isEqual(this.yb,P)||this.h.isEqual(this.wb,P)||this.h.isEqual(this.xb,P)||this.h.isEqual(this.zb,P)){const N=await this.db(P);return N&&t(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:P}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(P).length>1||P[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(P){const N=await this.Bb.readStorageData(this.syncResource.profile),F=[],M=[];for(const[Q,x]of N)x.target===0?F.push(Q):x.target===1&&M.push(Q);const z=[...F,...M],Y=P?.storage?Object.keys(P.storage).filter(Q=>!Q.startsWith(n)&&!z.includes(Q)&&N.get(Q)!==void 0):[];if(!R.$o){const Q=[...l.$Zob.map(x=>(0,l.$apb)(x)),l.$_ob];Y.push(...Q),M.push(...Q)}return{user:F,machine:M,unregistered:Y}}};e.$tIb=a,e.$tIb=a=ye([K(2,i.$pHb),K(3,S.$Bk),K(4,l.$4ob),K(5,l.$5ob),K(6,l.$gpb),K(7,C.$li),K(8,l.$bpb),K(9,b.$Fl),K(10,g.$Ki),K(11,$.$Fp),K(12,y.$_k),K(13,o.$di)],a);let E=class{constructor(P,N,F,M){this.a=P,this.b=N,this.c=F,this.d=M}async getLocalGlobalState(P){const N={};if(P.isDefault){const M=await this.f(),z=(0,L.$on)(M);for(const Y of s)z[Y]!==void 0&&(N[`${n}${Y}`]={version:1,value:z[Y]})}const F=await this.c.readStorageData(P);for(const[M,z]of F)z.value&&z.target===0&&(N[M]={version:1,value:z.value});return{storage:N}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const P=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),P.value.toString()}catch(P){this.d.debug((0,A.$0)(P))}return"{}"}async writeLocalGlobalState({added:P,removed:N,updated:F},M){const z=(0,c.$mIb)("globalState",M),Y={},Q=new Map,x=await this.c.readStorageData(M),W=(X,H)=>{for(const V of X){if(V.startsWith(n)){Y[V.substring(n.length)]=H?H[V].value:void 0;continue}if(H){const te=H[V];te.value!==x.get(V)?.value&&Q.set(V,te.value)}else x.get(V)!==void 0&&Q.set(V,void 0)}};if(W(Object.keys(P),P),W(Object.keys(F),F),W(N),Object.keys(Y).length){this.d.trace(`${z}: Updating locale...`);const X=await this.f();let H=X;for(const V of Object.keys(Y))H=(0,f.edit)(H,[V],Y[V],{});X!==H&&(this.d.trace(`${z}: Updating locale...`),await this.a.writeFile(this.b.argvResource,O.$se.fromString(H)),this.d.info(`${z}: Updated locale.`)),this.d.info(`${z}: Updated locale`)}Q.size&&(this.d.trace(`${z}: Updating global state...`),await this.c.updateStorageData(M,Q,0),this.d.info(`${z}: Updated global state`,[...Q.keys()]))}};e.$uIb=E,e.$uIb=E=ye([K(0,S.$Bk),K(1,C.$li),K(2,i.$pHb),K(3,l.$gpb)],E);let w=class extends c.$qIb{constructor(P,N,F,M,z,Y){super("globalState",F,M,z,N,P,Y)}async o(P){const N=P.syncData?JSON.parse(P.syncData.content):null;if(!N){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},M={};for(const z of Object.keys(N.storage))z.startsWith(n)?F[z.substring(n.length)]=N.storage[z].value:this.l.get(z,0)===void 0&&(M[z]=N.storage[z].value);if(Object.keys(F).length){let z="{}";try{z=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(F))z=(0,f.edit)(z,[Y],F[Y],{});await this.k.writeFile(this.h.argvResource,O.$se.fromString(z))}if(Object.keys(M).length){const z=[];for(const Y of Object.keys(M))z.push({key:Y,value:M[Y],scope:0,target:0});this.l.storeAll(z,!0)}}};e.$vIb=w,e.$vIb=w=ye([K(0,$.$Fp),K(1,S.$Bk),K(2,v.$bl),K(3,C.$li),K(4,l.$gpb),K(5,y.$_k)],w);let u=class{constructor(P,N,F,M,z){this.a=P,this.b=N,this.c=F,this.d=M,this.f=z}getSyncStoreType(P){return this.h(P)?.storage[l.$_ob]?.value}async sync(P){const N=(0,l.$8ob)((0,k.$Ag)());try{return await this.g(P,N)}catch(F){if(F instanceof l.$9ob)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(P,N)}throw F}}async g(P,N){const F=await this.a.readResource("globalState",null,void 0,N),M=this.h(F)||{storage:{}};M.storage[l.$_ob]={value:P,version:r};const z=await(0,h.$Lp)(this.c,this.d,this.b),Y={version:r,machineId:z,content:t(M,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),F.ref,void 0,N)}h({content:P}){if(!P)return null;const N=JSON.parse(P);if((0,c.$lIb)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.$wIb=u,e.$wIb=u=ye([K(1,$.$Fp),K(2,C.$li),K(3,S.$Bk),K(4,m.$yj)],u)}),define(le[117],he([0,1,17,14,3,34,5,12,171,21,15,11,19,22,28,18,39,236,25]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P8b=e.$O8b=e.$N8b=void 0;function d(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,R.$Zf)(s.all)?null:s.all;switch(I.OS){case 2:return(0,R.$Zf)(s.mac)?null:s.mac;case 3:return(0,R.$Zf)(s.linux)?null:s.linux;case 1:return(0,R.$Zf)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.$N8b=d;let l=class extends y.$pIb{constructor(o,n,s,t,r,a,E,w,u,p,P,N,F){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,w,u,p,s,t,E,N,r,P,a,F),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:f.$ipb,authority:"base"}),this.Gb=this.Eb.with({scheme:f.$ipb,authority:"local"}),this.Hb=this.Eb.with({scheme:f.$ipb,authority:"remote"}),this.Ib=this.Eb.with({scheme:f.$ipb,authority:"accepted"}),this.B(D.Event.filter(a.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,s,t){const r=o.syncData?d(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?o:n;const a=n?this.Ob(n):null,E=await this.vb(),w=await this.Cb();let u=null,p=!1,P=!1,N=!1;if(r){let z=E?E.value.toString():"[]";if(z=z||"[]",this.Ab(z,!0))throw new f.$9ob((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==z||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,c.$M8b)(z,r,a,w,this.zb);Y.hasChanges&&(u=Y.mergeContent,N=Y.hasConflicts,p=N||Y.mergeContent!==z,P=N||Y.mergeContent!==r)}}else E&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=E.value.toString(),P=!0);const F={content:N?a:u,localChange:p?E?2:1:0,remoteChange:P?2:0,hasConflicts:N},M=E?E.value.toString():null;return[{fileContent:E,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:M,localChange:F.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.Eb,previewResult:F,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,c.$M8b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:E,remoteChange:w}=s[0][1];if(E===0&&w===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new f.$9ob((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(E!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),w!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const u=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(u,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,L.$on)(o.value.toString());if((0,O.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:d(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=o,I.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(f.$Wob)}};e.$O8b=l,e.$O8b=l=ye([K(2,f.$4ob),K(3,f.$5ob),K(4,f.$gpb),K(5,g.$Ki),K(6,f.$bpb),K(7,S.$Bk),K(8,C.$li),K(9,m.$Fp),K(10,f.$fpb),K(11,h.$Fl),K(12,$.$_k)],l);let v=class extends y.$qIb{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,A.$se.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,L.$on)(o.value.toString());return!(0,O.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return d(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$P8b=v,e.$P8b=v=ye([K(0,S.$Bk),K(1,b.$bl),K(2,C.$li),K(3,f.$gpb),K(4,m.$Fp),K(5,$.$_k)],v)}),define(le[118],he([0,1,14,3,172,21,76,15,29,11,19,22,28,18,39,240,25]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S8b=e.$R8b=e.$Q8b=void 0;function c(v){return v&&v.settings&&typeof v.settings=="string"&&Object.keys(v).length===1}function f(v){const i=JSON.parse(v);return c(i)?i:{settings:v}}e.$Q8b=f;let d=class extends $.$pIb{constructor(i,o,n,s,t,r,a,E,w,u,p,P,N,F){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,p,P,E,w,u,F),this.Eb=N,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:y.$ipb,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.$ipb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.$ipb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.$ipb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.X(i,o),s=this.Lb(n),t=new I.$do(y.$Vob);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(y.$Vob)||{}}async qb(i,o,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&n?i:o;const a=o?this.Lb(o):null,E=await this.Pb();let w=null,u=!1,p=!1,P=!1;if(r){let z=s?s.value.toString().trim():"{}";z=z||"{}",this.Qb(z),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,b.$9Gb)(z,r.settings,a?a.settings:null,E,[],t);w=Y.localContent||Y.remoteContent,u=Y.localContent!==null,p=Y.remoteContent!==null,P=Y.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),w=s.value.toString().trim()||"{}",this.Qb(w),p=!0);const N=s?s.value.toString():null,F=a?.settings??null,M={content:P?F:w,localChange:u?2:0,remoteChange:p?2:0,hasConflicts:P};return[{fileContent:s,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:N,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,b.$9Gb)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,b.$8Gb)(i.previewResult.content,"{}",s,n):null}}async sb(i,o,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,b.$8Gb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,b.$8Gb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,b.$8Gb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:E}=n[0][1];if(a===0&&E===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),E!==0){const w=await this.Cb(),u=this.Lb(i),p=await this.Pb(r);r=(0,b.$8Gb)(r,u?u.settings:"{}",p,w),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,b.$0Gb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const n=await this.Cb(),s=await this.Pb();o=(0,b.$8Gb)(o,"{}",s,n)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return f(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(A.Event.any(A.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),A.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,b.$6Gb)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new y.$9ob((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$R8b=d,e.$R8b=d=ye([K(2,g.$Bk),K(3,R.$li),K(4,C.$Fp),K(5,y.$4ob),K(6,y.$5ob),K(7,y.$gpb),K(8,y.$fpb),K(9,L.$Ki),K(10,y.$bpb),K(11,S.$Fl),K(12,k.$No),K(13,m.$_k)],d);let l=class extends $.$qIb{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,O.$se.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,b.$0Gb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return f(i)}catch(o){this.j.error(o)}return null}};e.$S8b=l,e.$S8b=l=ye([K(0,g.$Bk),K(1,h.$bl),K(2,R.$li),K(3,y.$gpb),K(4,C.$Fp),K(5,m.$_k)],l)}),define(le[119],he([0,1,14,3,30,21,15,11,19,22,28,18,39,237,25]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X8b=e.$W8b=e.$V8b=void 0;function b(f){return JSON.parse(f.content)}e.$V8b=b;let y=class extends m.$nIb{constructor(d,l,v,i,o,n,s,t,r,a,E,w){super({syncResource:"snippets",profile:d},l,i,v,o,n,s,a,E,t,r,w),this.pb=1,this.vb=d.snippetsHome,this.B(this.G.watch(v.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(A.Event.filter(this.G.onDidFilesChange,u=>u.affects(this.vb))(()=>this.Q()))}async qb(d,l,v){const i=await this.Hb(),o=this.Gb(i),n=d.syncData?this.Fb(d.syncData):null;l=l===null&&v?d:l;const s=l&&l.syncData?this.Fb(l.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,h.$T8b)(o,n,s);return this.Bb(t,i,n||{},s||{})}async ub(d){const l=d.syncData?this.Fb(d.syncData):null;if(l===null)return!0;const v=await this.Hb(),i=this.Gb(v),o=(0,h.$T8b)(i,l,l);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(d,l){return d.previewResult}async sb(d,l,v,i){if(this.h.isEqualOrParent(l,this.g.with({scheme:$.$ipb,authority:"local"})))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:d.fileContent?d.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(l,this.g.with({scheme:$.$ipb,authority:"remote"})))return{content:d.remoteContent,localChange:d.remoteContent!==null?d.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(l,this.g))return v===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:v,localChange:v===null?d.fileContent!==null?3:0:2,remoteChange:v===null?d.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${l.toString()}`)}async tb(d,l,v,i){const o=v.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:n})=>n!==0)&&(d=await this.Eb(o,d,i)),l?.ref!==d.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(d),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(d,l,v,i){const o=new Map;for(const n of Object.keys(d.local.added)){const s={content:d.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"remote"}),remoteContent:v[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"accepted"})})}for(const n of Object.keys(d.local.updated)){const s={content:d.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=l[n]?l[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"local"}),fileContent:l[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"remote"}),remoteContent:v[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"accepted"})})}for(const n of d.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=l[n]?l[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"local"}),fileContent:l[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"accepted"})})}for(const n of Object.keys(d.remote.added)){const s={content:d.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=l[n]?l[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"local"}),fileContent:l[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"accepted"})})}for(const n of Object.keys(d.remote.updated)){const s={content:d.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=l[n]?l[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"local"}),fileContent:l[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"remote"}),remoteContent:v[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"accepted"})})}for(const n of d.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"remote"}),remoteContent:v[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"accepted"})})}for(const n of d.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:l[n]?2:1,remoteChange:v[n]?2:1},t=l[n]?l[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"local"}),fileContent:l[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"remote"}),remoteContent:v[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"accepted"})})}for(const n of Object.keys(l))if(!o.has(n)){const s={content:l[n]?l[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=l[n]?l[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"local"}),fileContent:l[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"remote"}),remoteContent:v[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$ipb,authority:"accepted"})})}return[...o.values()]}async resolveContent(d){return this.h.isEqualOrParent(d,this.g.with({scheme:$.$ipb,authority:"remote"}))||this.h.isEqualOrParent(d,this.g.with({scheme:$.$ipb,authority:"local"}))||this.h.isEqualOrParent(d,this.g.with({scheme:$.$ipb,authority:"base"}))||this.h.isEqualOrParent(d,this.g.with({scheme:$.$ipb,authority:"accepted"}))?this.db(d):null}async hasLocalData(){try{const d=await this.Hb();if(Object.keys(d).length)return!0}catch{}return!1}async Cb(d){const l={};for(const v of d)v.fileContent&&(l[this.h.basename(v.localResource)]=v.fileContent);await this.nb(JSON.stringify(this.Gb(l)))}async Db(d,l){for(const{fileContent:v,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of d)if(s!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,O.$se.fromString(i.content),{overwrite:l}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,O.$se.fromString(i.content),l?void 0:v),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(d,l,v){const i=l.syncData?this.Fb(l.syncData):{},o=(0,D.$Hn)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of d)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,h.$U8b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),l=await this.mb(JSON.stringify(o),v?null:l.ref),this.O.info(`${this.D}: Updated remote snippets`)),l}Fb(d){return b(d)}Gb(d){const l={};for(const v of Object.keys(d))l[v]=d[v].value.toString();return l}async Hb(){const d={};let l;try{l=await this.G.resolve(this.vb)}catch(v){if(v instanceof R.$Wk&&v.fileOperationResult===1)return d;throw v}for(const v of l.children||[]){const i=v.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);d[n]=s}}return d}};e.$W8b=y,e.$W8b=y=ye([K(2,I.$li),K(3,R.$Bk),K(4,k.$Fp),K(5,$.$4ob),K(6,$.$5ob),K(7,$.$gpb),K(8,L.$Ki),K(9,$.$bpb),K(10,g.$Fl),K(11,C.$_k)],y);let c=class extends m.$qIb{constructor(d,l,v,i,o,n){super("snippets",l,v,i,d,o,n)}async o(d){const l=d.syncData?JSON.parse(d.syncData.content):null;if(!l){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(l)){const o=l[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,O.$se.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(d)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(d){return d.fileOperationResult===1}}};e.$X8b=c,e.$X8b=c=ye([K(0,R.$Bk),K(1,S.$bl),K(2,I.$li),K(3,$.$gpb),K(4,k.$Fp),K(5,C.$_k)],c)}),define(le[120],he([0,1,14,21,15,11,19,22,28,18,39,25]),function(se,e,O,A,D,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$18b=e.$Z8b=e.$Y8b=void 0;function m(y,c){try{return JSON.parse(y).tasks??null}catch(f){return c.error(f),null}}e.$Y8b=m;let h=class extends C.$oIb{constructor(c,f,d,l,v,i,o,n,s,t,r,a){super(c.tasksResource,{syncResource:"tasks",profile:c},f,n,s,t,d,l,o,r,v,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:S.$ipb,authority:"base"}),this.Cb=this.Ab.with({scheme:S.$ipb,authority:"local"}),this.Db=this.Ab.with({scheme:S.$ipb,authority:"remote"}),this.Eb=this.Ab.with({scheme:S.$ipb,authority:"accepted"})}async qb(c,f,d,l){const v=c.syncData?m(c.syncData.content,this.O):null;f=f===null&&d?c:f;const i=f?.syncData?m(f.syncData.content,this.O):null,o=await this.vb();let n=null,s=!1,t=!1,r=!1;if(c.syncData){const w=o?o.value.toString():null;if(!i||i!==w||i!==v){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const u=b(w,v,i);n=u.content,r=u.hasConflicts,s=u.hasLocalChanged,t=u.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},E=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:E,localChange:a.localChange,remoteResource:this.Db,remoteContent:v,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(c){const f=c?.syncData?m(c.syncData.content,this.O):null;if(f===null)return!0;const d=await this.vb(),l=d?d.value.toString():null,v=b(l,f,f);return v.hasLocalChanged||v.hasRemoteChanged}async rb(c,f){return c.previewResult}async sb(c,f,d,l){if(this.h.isEqual(f,this.Cb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(f,this.Db))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(f,this.Ab))return d===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:d,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async tb(c,f,d,l){const{fileContent:v}=d[0][0],{content:i,localChange:o,remoteChange:n}=d[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),v&&await this.nb(JSON.stringify(this.Kb(v.value.toString()))),i?await this.wb(i,v,l):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));c=await this.mb(s,l?null:c.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}f?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(c),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(c){return this.h.isEqual(this.Db,c)||this.h.isEqual(this.Bb,c)||this.h.isEqual(this.Cb,c)||this.h.isEqual(this.Eb,c)?this.db(c):null}Kb(c){return c?{tasks:c}:{}}};e.$Z8b=h,e.$Z8b=h=ye([K(2,S.$4ob),K(3,S.$5ob),K(4,S.$gpb),K(5,A.$Ki),K(6,S.$bpb),K(7,L.$Bk),K(8,D.$li),K(9,I.$Fp),K(10,R.$Fl),K(11,k.$_k)],h);let $=class extends C.$qIb{constructor(c,f,d,l,v,i){super("tasks",f,d,l,c,v,i),this.c=this.g.defaultProfile.tasksResource}async o(c){const f=c.syncData?m(c.syncData.content,this.j):null;if(!f){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,O.$se.fromString(f)),await this.n(c)}async p(){return this.k.exists(this.c)}};e.$18b=$,e.$18b=$=ye([K(0,L.$Bk),K(1,g.$bl),K(2,D.$li),K(3,S.$gpb),K(4,I.$Fp),K(5,k.$_k)],$);function b(y,c,f){if(y===null&&c===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===c)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const d=f!==y,l=f!==c;return!d&&!l?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:d&&!l?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:l&&!d?{content:c,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,42,21,15,11,19,22,28,18,39,238,25]),function(se,e,O,A,D,L,I,R,k,g,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0b=e.$G0b=e.$F0b=void 0;let h=class extends C.$nIb{constructor(c,f,d,l,v,i,o,n,s,t,r,a,E){super({syncResource:"profiles",profile:c},f,l,v,i,o,n,r,a,s,t,E),this.vb=d,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.$ipb,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$ipb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$ipb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$ipb,authority:"accepted"}),this.B(d.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const c=await this.getLastSyncUserData();return c?.syncData?b(c.syncData):null}async getRemoteSyncedProfiles(c){const f=await this.getLastSyncUserData(),d=await this.X(c,f);return d?.syncData?b(d.syncData):null}async qb(c,f,d){if(!this.vb.isEnabled())throw new m.$9ob("Cannot sync profiles because they are disabled","LocalError");const l=c.syncData?b(c.syncData):null,v=f?.syncData?b(f.syncData):null,i=this.Db(),{local:o,remote:n}=(0,S.$E0b)(i,l,v,[]),s={local:o,remote:n,content:v?this.Eb(v):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=$(i,!1);return[{baseResource:this.baseResource,baseContent:v?this.Eb(v):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:l?this.Eb(l):null,remoteProfiles:l,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(c){const f=c?.syncData?b(c.syncData):null,d=this.Db(),{remote:l}=(0,S.$E0b)(d,f,f,[]);return!!l?.added.length||!!l?.removed.length||!!l?.updated.length}async rb(c,f){return{...c.previewResult,hasConflicts:!1}}async sb(c,f,d,l){if(this.h.isEqual(f,this.localResource))return this.Ab(c);if(this.h.isEqual(f,this.remoteResource))return this.Bb(c);if(this.h.isEqual(f,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async Ab(c){const f=this.Db(),d=(0,S.$E0b)(f,null,null,[]),{local:l,remote:v}=d;return{content:c.localContent,local:l,remote:v,localChange:l.added.length>0||l.removed.length>0||l.updated.length>0?2:0,remoteChange:v!==null?2:0}}async Bb(c){const f=c.remoteContent?JSON.parse(c.remoteContent):null,d=[],l=[];for(const v of this.Db()){const i=f?.find(o=>o.id===v.id);i&&(d.push({id:v.id,name:v.name,collection:i.collection}),l.push(v))}if(f!==null){const v=(0,S.$E0b)(l,f,d,[]),{local:i,remote:o}=v;return{content:c.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(c,f,d,l){const{local:v,remote:i,localChange:o,remoteChange:n}=d[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=d[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.$9ob("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb($(this.Db(),!1));const t=[];for(const r of v.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of v.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of v.updated){const a=this.vb.profiles.find(E=>E.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const E=await this.J.createCollection(this.F);t.push(E),s.push({id:a.id,name:a.name,collection:E,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:E})=>a.id===E),1);for(const a of i?.updated||[]){const E=s.find(({id:w})=>a.id===w);E&&s.splice(s.indexOf(E),1,{...E,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{c=await this.updateRemoteProfiles(s,l?null:c.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const E of t)await this.J.deleteCollection(E,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}f?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(c),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(c,f){return this.mb(this.Eb(c),f)}async hasLocalData(){return this.Db().length>0}async resolveContent(c){if(this.h.isEqual(this.remoteResource,c)||this.h.isEqual(this.baseResource,c)||this.h.isEqual(this.localResource,c)||this.h.isEqual(this.acceptedResource,c)){const f=await this.db(c);return f&&(0,O.$zn)(JSON.parse(f),{})}return null}Db(){return this.vb.profiles.filter(c=>!c.isDefault&&!c.isTransient)}Eb(c){return JSON.stringify([...c].sort((f,d)=>f.name.localeCompare(d.name)))}};e.$F0b=h,e.$F0b=h=ye([K(2,g.$bl),K(3,L.$Bk),K(4,D.$li),K(5,I.$Fp),K(6,m.$4ob),K(7,m.$5ob),K(8,m.$gpb),K(9,A.$Ki),K(10,m.$bpb),K(11,R.$Fl),K(12,k.$_k)],h);function $(y,c){const f=[...y].sort((d,l)=>d.name.localeCompare(l.name)).map(d=>({id:d.id,name:d.name}));return c?(0,O.$zn)(f,{}):JSON.stringify(f)}e.$G0b=$;function b(y){return JSON.parse(y.content)}e.$H0b=b}),define(le[255],he([0,1,3,2,5,15,19,22,25]),function(se,e,O,A,D,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s0b=void 0;const g="sync.enable";let C=class extends A.$Tc{constructor(m,h,$,b){super(),this.c=m,this.f=h,this.g=$,this.h=b,this.a=new O.$5d,this.onDidChangeEnablement=this.a.event,this.b=new O.$5d,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(-1,void 0,this.B(new A.$Sc))(y=>this.m(y)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:m}),this.c.store(g,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,k.$apb)(m),-1,!0)}setResourceEnablement(m,h){if(this.isResourceEnabled(m)!==h){const $=(0,k.$apb)(m);this.j($,h)}}getResourceSyncStateVersion(m){}j(m,h){this.c.store(m,h,-1,D.$o?0:1)}m(m){if(g===m.key){this.a.fire(this.isEnabled());return}const h=k.$Zob.filter($=>(0,k.$apb)($)===m.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};e.$s0b=C,e.$s0b=C=ye([K(0,I.$Fp),K(1,R.$Fl),K(2,L.$li),K(3,k.$3ob)],C)}),define(le[256],he([0,1,6,14,65,2,20,21,15,11,18,25]),function(se,e,O,A,D,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D0b=void 0;let m=class extends L.$Tc{constructor($,b,y,c,f){super(),this.a=$,this.b=b,this.c=y,this.f=c,this.g=f,this.h()}async h(){for(const b of this.g.profiles)for(const y of S.$Zob)try{await this.m(this.j(y,b.isDefault?void 0:b.id))}catch(c){this.f.error(c)}let $;try{$=await this.b.resolve(this.a.userDataSyncHome)}catch(b){(0,g.$Sk)(b)!==1&&this.f.error(b);return}if($.children){for(const b of $.children)if(b.isDirectory&&!this.g.profiles.some(y=>y.id===b.name))try{this.f.info("Deleting non existing profile from backup",b.resource.path),await this.b.del(b.resource,{recursive:!0})}catch(y){this.f.error(y)}}}async getAllResourceRefs($,b,y){const c=this.j($,b,y);try{const f=await this.b.resolve(c);if(f.children)return f.children.filter(l=>l.isFile&&!l.name.startsWith("lastSync")).sort().reverse().map(l=>({ref:l.name,created:this.n(l)}))}catch(f){if((0,g.$Sk)(f)!==1)throw f}return[]}async resolveResourceContent($,b,y,c){const f=this.j($,y,c),d=(0,I.$Rg)(f,b);try{return(await this.b.readFile(d)).value.toString()}catch(l){return this.f.error(l),null}}async writeResource($,b,y,c,f){const d=this.j($,c,f),l=(0,I.$Rg)(d,`${(0,D.$Im)(y).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(l,A.$se.fromString(b))}catch(v){this.f.error(v)}}j($,b,y=this.a.userDataSyncHome){return(0,I.$Rg)(y,...b?[b,$]:[$])}async m($){try{try{if(!await this.b.exists($))return}catch{return}const b=await this.b.resolve($);if(b.children){const y=b.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort(),c=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let f=y.filter(l=>Date.now()-this.n(l)>c);const d=y.length-f.length;d<10&&(f=f.slice(10-d)),await O.Promises.settled(f.map(async l=>{this.f.info("Deleting from backup",l.resource.path),await this.b.del(l.resource)}))}}catch(b){this.f.error(b)}}n($){return new Date(parseInt($.name.substring(0,4)),parseInt($.name.substring(4,6))-1,parseInt($.name.substring(6,8)),parseInt($.name.substring(9,11)),parseInt($.name.substring(11,13)),parseInt($.name.substring(13,15))).getTime()}};e.$D0b=m,e.$D0b=m=ye([K(0,k.$li),K(1,g.$Bk),K(2,R.$Ki),K(3,S.$gpb),K(4,C.$bl)],m)}),define(le[84],he([0,1,3,2,5,27,176,15,11,4,24,43,19,25]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sob=e.$Rob=e.$Qob=void 0,e.$Qob=(0,g.$ei)("IUserDataSyncMachinesService");const b="sync.currentMachineName",y="Safari",c="Chrome",f="Edge",d="Firefox",l="Android";function v(n){switch(n){case y:case c:case f:case d:case l:case(0,D.$h)(0):return!0}return!1}e.$Rob=v;function i(){return D.$G?y:D.$E?c:D.$H?f:D.$F?d:D.$I?l:(0,D.$h)(D.$o?0:D.$u)}let o=class extends A.$Tc{static{$=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,E,w){super(),this.h=r,this.j=a,this.m=E,this.n=w,this.c=this.B(new O.$5d),this.onDidChange=this.c.event,this.g=null,this.f=(0,S.$Lp)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:E})=>E!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),E=a.machines.find(({id:w})=>w===s);if(E){E.name=t,await this.t(a);const w=await this.f;s===w&&this.h.store(b,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const E=t.machines.find(w=>w.id===r);E&&(E.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(b,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,L.$Xe)(r)}\\s#(\\d+)`);let E=0;for(const w of s){const u=a.exec(w.name),p=u?parseInt(u[1]):0;E=p>E?p:E}return`${r} #${E+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==$.a)throw new Error((0,I.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource($.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[$.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource($.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:$.a,machines:[]}}};e.$Sob=o,e.$Sob=o=$=ye([K(0,R.$li),K(1,k.$Bk),K(2,m.$Fp),K(3,h.$4ob),K(4,h.$gpb),K(5,C.$Qj)],o)}),define(le[257],he([0,1,6,65,38,7,3,2,5,20,10,173,24,19,22,25,81,84]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0b=void 0;const f="sync.disableMachineEventually",d="sync.sessionId",l="sync.storeUrl",v="sync.productQuality";let i=class extends R.$Tc{get n(){const s=this.H.get(l,-1);return s?C.URI.parse(s):void 0}set n(s){s?this.H.store(l,s.toString(),-1,1):this.H.remove(l,-1)}get s(){return this.H.get(v,-1)}set s(s){s?this.H.store(v,s,-1,1):this.H.remove(v,-1)}constructor(s,t,r,a,E,w,u,p,P,N){super(),this.u=t,this.w=r,this.y=a,this.z=E,this.C=w,this.D=u,this.F=p,this.G=P,this.H=N,this.a=this.B(new R.$Uc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new I.$5d),this.onError=this.h.event,this.S=[],this.f=this.B(new O.$ch(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$Kg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(u.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(E.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(I.Event.filter(this.y.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,A.$Im)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(d,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=b.$9ob.toUserDataSyncError(s);t instanceof b.$$ob&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?k.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(f,!0,-1,1),await(0,O.$fh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(f,-1,!1)}R(){this.H.remove(f,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$J0b=i,e.$J0b=i=ye([K(0,m.$Qj),K(1,b.$3ob),K(2,b.$4ob),K(3,b.$bpb),K(4,b.$cpb),K(5,b.$gpb),K(6,y.$PGb),K(7,$.$Fl),K(8,c.$Qob),K(9,h.$Fp)],i);class o extends R.$Tc{static{this.a="Interval"}constructor(s,t,r,a,E,w,u,p,P){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=E,this.w=w,this.y=u,this.z=p,this.C=P,this.b=this.B(new R.$Uc),this.c=this.B(new I.$5d),this.onDidStartSync=this.c.event,this.f=this.B(new I.$5d),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Rc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,O.$gh)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(s,t){const r=(0,O.$4g)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(E){if((0,L.$4)(E))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$Kg)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,g.$Kg)(t.defaultUrl,s.defaultUrl)||!(0,g.$Kg)(t.insidersUrl,s.insidersUrl)||!(0,g.$Kg)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(E){if(this.y.error(E),a=E,b.$9ob.toUserDataSyncError(E).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(w){this.y.error(w),a=w}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new b.$$ob((0,S.localize)(0,null),"DefaultServiceChanged"):new b.$$ob((0,S.localize)(1,null),"ServiceChanged"):new b.$$ob((0,S.localize)(2,null),"TurnedOff");const r=this.C.get(d,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new b.$$ob((0,S.localize)(3,null),"DefaultServiceChanged"):new b.$$ob((0,S.localize)(4,null),"ServiceChanged"):new b.$$ob((0,S.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const E=a.find(u=>u.isCurrent);if(E?.disabled)throw new b.$$ob((0,S.localize)(6,null),"TurnedOff");const w=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-w}),this.g===null)try{this.g=await this.s.manifest(null)}catch(u){throw new b.$$ob((0,D.$2i)(u),u instanceof b.$9ob?u.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(d,this.g.session,-1,1),!t.isCancellationRequested&&(E||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(le[258],he([0,1,10,177,15,11,43,19,28,25,18,39,119,118,117,21,120,115,116,4,121,42,27]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d,l,v,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$f$b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,E,w,u,p,P,N,F){this.e=t,this.f=r,this.g=a,this.h=w,this.i=u,this.j=p,this.k=P,this.l=N,this.n=F,this.d=E.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,l.$H0b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const E=this.L(a,"profiles");return(0,l.$H0b)(E)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(w=>({...w,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:E,ref:w})=>({created:E,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:w,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:w,ref:u})=>({created:w,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:u,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(E=>E.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(E=>E.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,I.$Lp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,E,w){if(t){const{content:u}=await this.M(r,E,a);return u}return this.f.resolveResourceContent(r,E,a,w)}q(t,r,a){const E=this.L(r,t);switch(t){case"settings":return this.t(E,a);case"keybindings":return this.v(E,a);case"tasks":return this.x(E,a);case"snippets":return this.z(E,a);case"globalState":return this.E(E,a);case"extensions":return this.B(E,a);case"profiles":return this.H(E,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(E=>E.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),E=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}t(t,r){switch(r){case"settings.json":return(0,h.$Q8b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),E=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}v(t,r){switch(r){case"keybindings.json":return(0,$.$N8b)(t.content,!!this.l.getValue(g.$Wob),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),E=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}x(t,r){switch(r){case"tasks.json":return(0,y.$Y8b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const E=this.L(a,"snippets");if(E){const w=(0,m.$V8b)(E),u=[];for(const p of Object.keys(w)){const P=this.d.joinPath(t,p),N=r?this.d.joinPath(r.snippetsHome,p):this.d.joinPath(t,o.a);u.push({resource:P,comparableResource:N})}return u}}return[]}z(t,r){return(0,m.$V8b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),E=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}B(t,r){switch(r){case"extensions.json":return(0,c.$I8b)((0,c.$H8b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(c.$K8b).getLocalExtensions(t);return(0,c.$I8b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),E=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}E(t,r){switch(r){case"globalState.json":return(0,f.$sIb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(f.$uIb).getLocalGlobalState(t);return(0,f.$sIb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),E=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:E}]}H(t,r){switch(r){case"profiles.json":return(0,v.$zn)(JSON.parse(t.content),{})}return null}async I(t){return(0,l.$G0b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$2e)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(O.URI.from({scheme:g.$ipb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==g.$ipb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let E,w;const u=[];let p,P,N,F,M;for(;r.length;){const z=r.shift();z.startsWith("scheme:")?E=z.substring(7):z.startsWith("authority:")?w=z.substring(10):z.startsWith("syncResource:")?p=z.substring(13):z.startsWith("profile:")?P=z.substring(8):z.startsWith("collection:")?N=z.substring(11):z.startsWith("ref:")?F=z.substring(4):p?M=z:u.push(z)}return{remote:a,syncResource:p,profile:P,collection:N,ref:F,node:M,location:E&&w!==void 0?this.d.joinPath(O.URI.from({scheme:E,authority:w,query:t.query,fragment:t.fragment,path:"/"}),...u):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,S.$lIb)(a))return a}catch(a){this.g.error(a)}throw new g.$9ob((0,A.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const E=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:E}}};e.$f$b=n,e.$f$b=n=o=ye([K(0,g.$4ob),K(1,g.$5ob),K(2,g.$gpb),K(3,k.$_k),K(4,D.$li),K(5,R.$Fp),K(6,L.$Bk),K(7,C.$bl),K(8,b.$Ki),K(9,d.$di)],n)}),define(le[259],he([0,1,17,6,26,38,3,2,20,12,32,21,29,11,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d,l,v,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I0b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Tc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(p,P,N,F,M,z,Y,Q,x,W,X){super(),this.C=p,this.D=P,this.F=N,this.G=F,this.H=M,this.I=z,this.J=Y,this.L=Q,this.M=x,this.N=W,this.O=X,this.f="uninitialized",this.g=this.B(new I.$5d),this.onDidChangeStatus=this.g.event,this.h=this.B(new I.$5d),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new I.$5d),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new I.$5d),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new I.$5d),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new I.$5d),this.onDidResetLocal=this.w.event,this.y=this.B(new I.$5d),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=N.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Rc)(()=>this.bb()))}async createSyncTask(p,P){this.cb(),this.H.info("Sync started.");const N=new Date().getTime(),F=(0,C.$Ag)();try{const Q=(0,s.$8ob)(F);P&&(Q["Cache-Control"]="no-cache"),p=await this.D.manifest(p,Q)}catch(Q){const x=s.$9ob.toUserDataSyncError(Q);throw w(x,F,this.F,this.I),x}const M=!1,z=this;let Y;return{manifest:p,async run(){if(M)throw new Error("Can run a task only once");Y=(0,A.$4g)(Q=>z.P(p,!1,F,Q)),await Y.finally(()=>Y=void 0),z.H.info(`Sync done. Took ${new Date().getTime()-N}ms`),z.$()},stop(){return Y?.cancel(),z.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$9ob("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const p=new Date().getTime(),P=(0,C.$Ag)(),N=(0,s.$8ob)(P);let F;try{F=await this.D.manifest(null,N)}catch(Y){const Q=s.$9ob.toUserDataSyncError(Y);throw w(Q,P,this.F,this.I),Q}await this.resetLocal();const M=this,z=new D.$ce;return{id:P,async merge(){return M.P(F,!0,P,z.token)},async apply(){try{try{await M.R(F,P,z.token)}catch(Y){if(s.$9ob.toUserDataSyncError(Y).code==="MethodNotFound")M.H.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.H.info("Applying manual sync again..."),await M.R(F,P,z.token);else throw Y}}catch(Y){throw M.H.error(Y),Y}M.H.info(`Sync done. Took ${new Date().getTime()-p}ms`),M.$()},async stop(){z.cancel(),await M.U(),await M.resetLocal()}}}async P(p,P,N,F){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(M,p,P,N,F));const z=M.enabled.find(Y=>Y.resource==="profiles");if(z){const Y=await z.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.Q(Y,p,P,N,F)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(p,P,N,F,M){for(const z of p){if(M.isCancellationRequested)return;const Y=this.M.profiles.find(x=>x.id===z.id);if(!Y){this.H.error(`Profile with id:${z.id} and name: ${z.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",z.name);const Q=this.getOrCreateActiveProfileSynchronizer(Y,z);this.n.push(...await this.S(Q,P,N,F,M))}for(const[z,Y]of this.z.entries())this.M.profiles.some(Q=>Q.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(z))}async R(p,P,N){const F=this.ab();for(const x of F){if(N.isCancellationRequested)return;await x.apply(P,N)}const M=F.find(x=>x.profile.isDefault);if(!M)return;const z=M.enabled.find(x=>x.resource==="profiles");if(!z)return;const Q=(await z.getRemoteSyncedProfiles(p?.latest??null)||[]).filter(x=>F.every(W=>W.profile.id!==x.id));Q.length&&await this.Q(Q,p,!1,P,N)}async S(p,P,N,F,M){return(await p.sync(P,N,F,M)).map(([Y,Q])=>({profile:p.profile,syncResource:Y,error:Q}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(p=>p.stop()))}async resolveContent(p){const P=await this.N.resolveContent(p);if(P)return P;for(const N of this.ab())for(const F of N.enabled){const M=await F.resolveContent(p);if(M)return M}return null}async replace(p){this.cb();const P=this.N.resolveUserDataSyncResource(p);if(!P)return;const N=await this.resolveContent(p.uri);N&&await this.W(P.profile,async F=>{if(P.syncResource===F.resource)return await F.replace(N),!0})}async accept(p,P,N,F){this.cb(),await this.W(p.profile,async M=>{if(p.syncResource===M.resource)return await M.accept(P,N),F&&await M.apply((0,g.$Yf)(F)?!1:F.force,(0,s.$8ob)((0,C.$Ag)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async P=>{if(P.resource!=="globalState"&&await P.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async P=>{if(await P.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(p){this.H.error(p)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[p]of this.z.values())try{await p.resetLocal()}catch(P){this.H.error(P)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const p=await this.N.getRemoteSyncedProfiles(),P=p.map(z=>z.collection),N=await this.D.getAllCollections(),F=N.filter(z=>!P.includes(z));F.length&&(this.H.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(z=>this.D.deleteCollection(z))),this.H.info("Deleted redundant collections on server"));const M=p.filter(z=>N.includes(z.collection));if(M.length!==p.length){const z=this.G.createInstance(n.$F0b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await z.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await z.updateRemoteProfiles(M,null),this.H.info("Updated remote profiles on server")}finally{z.dispose()}}}async saveRemoteActivityData(p){this.cb();const P=await this.D.getActivityData();await this.C.writeFile(p,P)}async extractActivityData(p,P){const N=(await this.C.readFile(p)).value.toString(),F=JSON.parse(N);if(F.resources)for(const M in F.resources)for(const z of F.resources[M])await this.O.writeResource(M,z.content,new Date(z.created*1e3),void 0,P);if(F.collections)for(const M in F.collections)for(const z in F.collections[M].resources)for(const Y of F.collections[M].resources?.[z]??[])await this.O.writeResource(z,Y.content,new Date(Y.created*1e3),M,P)}async W(p,P){const N=new R.$Sc;try{const F=this.z.get(p.id);if(F){const x=await this.X(F[0],P,N);return(0,g.$Zf)(x)?null:x}if(p.isDefault){const x=N.add(this.G.createInstance(a,p,void 0)),W=await this.X(x,P,N);return(0,g.$Zf)(W)?null:W}if(this.M.isEnabled())return null;const M=N.add(this.G.createInstance(n.$F0b,p,void 0)),z=await this.D.manifest(null),Q=(await M.getRemoteSyncedProfiles(z?.latest??null)||[]).find(x=>x.id===p.id);if(Q){const x=N.add(this.G.createInstance(a,p,Q.collection)),W=await this.X(x,P,N);return(0,g.$Zf)(W)?null:W}return null}finally{N.dispose()}}async X(p,P,N){const F=[...p.enabled,...p.disabled.reduce((M,z)=>(z!=="workspaceState"&&M.push(N.add(p.createSynchronizer(z))),M),[])];for(const M of F){const z=await P(M);if(!(0,g.$Zf)(z))return z}}Y(p){const P=this.f;this.f!==p&&(this.f=p,this.g.fire(p),P==="hasConflicts"&&this.$())}Z(){const p=this.ab().map(P=>P.conflicts).flat();(0,O.$ub)(this.j,p,(P,N)=>P.profile.id===N.profile.id&&P.syncResource===N.syncResource&&(0,O.$ub)(P.conflicts,N.conflicts,(F,M)=>(0,k.$Kg)(F.previewResource,M.previewResource)))||(this.j=p,this.m.fire(p))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(p,P){let N=this.z.get(p.id);if(N&&N[0].collection!==P?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.z.delete(p.id)),!N){const F=new R.$Sc,M=F.add(this.G.createInstance(a,p,P?.collection));F.add(M.onDidChangeStatus(z=>this.Y(z))),F.add(M.onDidChangeConflicts(z=>this.Z())),F.add(M.onDidChangeLocal(z=>this.h.fire(z))),this.z.set(p.id,N=[M,F])}return N[0]}ab(){const p=[];for(const[P]of this.z.values())p.push(P);return p}bb(){this.z.forEach(([,p])=>p.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$I0b=r,e.$I0b=r=ye([K(0,h.$Bk),K(1,s.$4ob),K(2,s.$3ob),K(3,$.$di),K(4,s.$gpb),K(5,y.$Fl),K(6,b.$Fp),K(7,s.$bpb),K(8,c.$bl),K(9,s.$dpb),K(10,s.$5ob)],r);let a=class extends R.$Tc{get enabled(){return this.f.sort((p,P)=>p[1]-P[1]).map(([p])=>p)}get disabled(){return s.$Zob.filter(p=>!this.r.isResourceEnabled(p))}get status(){return this.g}get conflicts(){return this.m}constructor(p,P,N,F,M,z,Y,Q,x,W){super(),this.profile=p,this.collection=P,this.r=N,this.t=F,this.u=M,this.w=z,this.y=Y,this.z=Q,this.C=x,this.D=W,this.f=[],this.g="idle",this.h=this.B(new I.$5d),this.onDidChangeStatus=this.h.event,this.j=this.B(new I.$5d),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new I.$5d),this.onDidChangeConflicts=this.n.event,this.B(N.onDidChangeResourceEnablement(([X,H])=>this.F(X,H))),this.B((0,R.$Rc)(()=>this.f.splice(0,this.f.length).forEach(([,,X])=>X.dispose())));for(const X of s.$Zob)N.isResourceEnabled(X)&&this.G(X)}F(p,P){P?this.G(p):this.H(p)}G(p){if(this.f.some(([M])=>M.resource===p))return;if(p==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(p==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||p==="workspaceState")return;if(p!=="profiles"&&this.profile.useDefaultFlags?.[p]){this.z.debug(`Skipping syncing ${p} in ${this.profile.name} because it is already synced by default profile`);return}const P=new R.$Sc,N=P.add(this.createSynchronizer(p));P.add(N.onDidChangeStatus(()=>this.L())),P.add(N.onDidChangeConflicts(()=>this.M())),P.add(N.onDidChangeLocal(()=>this.j.fire(p)));const F=this.N(p);this.f.push([N,F,P])}H(p){const P=this.f.findIndex(([N])=>N.resource===p);if(P!==-1){const[[N,,F]]=this.f.splice(P,1);F.dispose(),this.L(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,M=>this.z.error(M))}}createSynchronizer(p){switch(p){case"settings":return this.t.createInstance(v.$R8b,this.profile,this.collection);case"keybindings":return this.t.createInstance(l.$O8b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$W8b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$Z8b,this.profile,this.collection);case"globalState":return this.t.createInstance(d.$tIb,this.profile,this.collection);case"extensions":return this.t.createInstance(f.$J8b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$F0b,this.profile,this.collection)}}async sync(p,P,N,F){if(F.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const z=[],Y=(0,s.$8ob)(N),Q=(this.collection?p?.collections?.[this.collection]?.latest:p?.latest)??null,x=P?await this.I(Q):{};for(const W of M){if(F.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(P){const X=await W.preview(Q,x,Y);if(X)for(const H of X.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await W.merge(H.previewResource)}else await W.sync(Q,Y)}catch(X){const H=s.$9ob.toUserDataSyncError(X);if(w(H,N,this.w,this.y),E(X))throw H;this.z.error(X),this.z.error(`${W.resource}: ${(0,L.$2i)(X)}`),z.push([W.resource,H])}}return z}finally{this.L()}}async apply(p,P){const N=(0,s.$8ob)(p);for(const F of this.enabled){if(P.isCancellationRequested)return;try{await F.apply(!1,N)}catch(M){const z=s.$9ob.toUserDataSyncError(M);if(w(z,p,this.w,this.y),E(M))throw z;this.z.error(M),this.z.error(`${F.resource}: ${(0,L.$2i)(M)}`)}}}async stop(){for(const p of this.enabled)try{p.status!=="idle"&&await p.stop()}catch(P){this.z.error(P)}}async resetLocal(){for(const p of this.enabled)try{await p.resetLocal()}catch(P){this.z.error(`${p.resource}: ${(0,L.$2i)(P)}`),this.z.error(P)}}async I(p){if(!this.profile.isDefault)return{};const P=this.D.getValue(s.$Vob),N=this.enabled.find(F=>F instanceof v.$R8b);if(N){const F=await N.getRemoteUserDataSyncConfiguration(p);return{...P,...F}}return P}J(p){this.g!==p&&(this.g=p,this.h.fire(p))}L(){return this.M(),this.enabled.some(p=>p.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(p=>p.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const p=this.enabled.filter(P=>P.status==="hasConflicts").filter(P=>P.conflicts.conflicts.length>0).map(P=>P.conflicts);(0,O.$ub)(this.m,p,(P,N)=>P.syncResource===N.syncResource&&(0,O.$ub)(P.conflicts,N.conflicts,(F,M)=>(0,k.$Kg)(F.previewResource,M.previewResource)))||(this.m=p,this.n.fire(p))}N(p){switch(p){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([K(2,s.$bpb),K(3,$.$di),K(4,m.$Ko),K(5,s.$3ob),K(6,y.$Fl),K(7,s.$gpb),K(8,c.$bl),K(9,S.$Ki)],a);function E(u){if(u instanceof s.$9ob)switch(u.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(u,p,P,N){N.publicLog2("sync/error",{code:u.code,serverCode:u instanceof s.$0ob?String(u.serverCode):void 0,url:u instanceof s.$0ob?u.url:void 0,resource:u.resource,executionId:p,service:P.userDataSyncStore.url.toString()})}}),define(le[260],he([0,1,3,2,10,18,25]),function(se,e,O,A,D,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=e.$2ac=void 0;function R(m,h){return{...m,profile:(0,L.$cl)(m.profile,h.profilesHome.scheme)}}function k(m){return{created:m.created,uri:D.URI.revive(m.uri)}}class g{constructor(h,$,b){this.c=h,this.d=$,this.f=b,this.a=new Map,this.b=new O.$5d}listen(h,$){switch($){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${$}`)}async call(h,$,b){try{return await this.g(h,$,b)}catch(y){throw this.f.error(y),y}}async g(h,$,b){switch($){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(b[0]));case"accept":return this.c.accept(R(b[0],this.d),D.URI.revive(b[1]),b[2],b[3]);case"replace":return this.c.replace(k(b[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(D.URI.revive(b[0]));case"extractActivityData":return this.c.extractActivityData(D.URI.revive(b[0]),D.URI.revive(b[1]));case"createManualSyncTask":return this.i()}if($.startsWith("manualSync/")){const y=$.substring(11),c=b[0],f=this.h(c);switch(b=b.slice(1),y){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.a.delete(this.j(f.id)));case"stop":return f.stop().finally(()=>this.a.delete(this.j(f.id)))}}throw new Error("Invalid call")}h(h){const $=this.a.get(this.j(h));if(!$)throw new Error(`Manual sync taks not found: ${h}`);return $}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.$2ac=g;let C=class extends A.$Tc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,$){super(),this.n=$,this.b="uninitialized",this.c=this.B(new O.$5d),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new O.$5d),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new O.$5d),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new O.$5d),this.onSyncErrors=this.m.event,this.a={call(b,y,c){return h.call(b,y,c).then(null,f=>{throw I.$9ob.toUserDataSyncError(f)})},listen(b,y){return h.listen(b,y)}},this.a.call("_getInitialData").then(([b,y,c])=>{this.s(b),this.t(y),c&&this.u(c),this.B(this.a.listen("onDidChangeStatus")(f=>this.s(f))),this.B(this.a.listen("onDidChangeLastSyncTime")(f=>this.u(f)))}),this.B(this.a.listen("onDidChangeConflicts")(b=>this.t(b))),this.B(this.a.listen("onSyncErrors")(b=>this.m.fire(b.map(y=>({...y,error:I.$9ob.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),$=this;return new S(h,{async call(y,c,f){return $.a.call(`manualSync/${y}`,[h,...Array.isArray(c)?c:[c]],f)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,$,b,y){return this.a.call("accept",[h,$,b,y])}resolveContent(h){return this.a.call("resolveContent",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}saveRemoteActivityData(h){return this.a.call("getRemoteActivityData",[h])}extractActivityData(h,$){return this.a.call("extractActivityData",[h,$])}async s(h){this.b=h,this.c.fire(h)}async t(h){this.f=h.map($=>({syncResource:$.syncResource,profile:(0,L.$cl)($.profile,this.n.profilesHome.scheme),conflicts:$.conflicts.map(b=>({...b,baseResource:D.URI.revive(b.baseResource),localResource:D.URI.revive(b.localResource),remoteResource:D.URI.revive(b.remoteResource),previewResource:D.URI.revive(b.previewResource)}))})),this.g.fire(this.f)}u(h){this.h!==h&&(this.h=h,this.j.fire(h))}};e.$3ac=C,e.$3ac=C=ye([K(1,L.$bl)],C);class S extends A.$Tc{constructor(h,$){super(),this.id=h,this.a=$}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[122],he([0,1,6,26,7,3,2,140,5,20,12,10,32,21,15,11,24,59,43,19,25]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jIb=e.$iIb=e.$hIb=e.$gIb=e.$fIb=void 0;const v="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends I.$Tc{get userDataSyncStore(){return this.b}get c(){return this.h.get(l.$_ob,-1)}set c(N){this.h.store(l.$_ob,N,-1,k.$o?0:1)}constructor(N,F,M){super(),this.f=N,this.g=F,this.h=M,this.a=this.B(new L.$5d),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const z=this.B(new I.$Sc);this.B(L.Event.filter(M.onDidChangeValue(-1,l.$_ob,z),()=>this.c!==this.userDataSyncStore?.type,z)(()=>this.j()))}j(){this.b=this.m(this.f[v]),this.a.fire()}m(N){if(N&&(N=k.$o&&N.web?{...N,...N.web}:N,(0,C.$Sf)(N.url)&&(0,C.$Uf)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(F=>Array.isArray(N.authenticationProviders[F].scopes)))){const F=N,M=!!F.canSwitch,z=F.url===F.insidersUrl?"insiders":"stable",Y=(M?this.c:void 0)||z,Q=Y==="insiders"?F.insidersUrl:Y==="stable"?F.stableUrl:F.url;return{url:S.URI.parse(Q),type:Y,defaultType:z,defaultUrl:S.URI.parse(F.url),stableUrl:S.URI.parse(F.stableUrl),insidersUrl:S.URI.parse(F.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(F.authenticationProviders).reduce((x,W)=>(x.push({id:W,scopes:F.authenticationProviders[W].scopes}),x),[])}}}};e.$fIb=a,e.$fIb=a=ye([K(0,y.$Qj),K(1,h.$Ki),K(2,d.$Fp)],a);let E=class extends a{constructor(N,F,M){super(N,F,M);const z=this.h.get(i,-1);z&&(this.n=JSON.parse(z));const Y=this.f[v];Y?this.h.store(i,JSON.stringify(Y),-1,1):this.h.remove(i,-1)}async switch(N){N!==this.c&&(this.c=N,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$gIb=E,e.$gIb=E=ye([K(0,y.$Qj),K(1,h.$Ki),K(2,d.$Fp)],E);let w=class extends I.$Tc{get donotMakeRequestsUntil(){return this.j}constructor(N,F,M,z,Y,Q,x){super(),this.n=M,this.r=z,this.s=x,this.g=this.B(new L.$5d),this.onTokenFailed=this.g.event,this.h=this.B(new L.$5d),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$5d),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(N),this.c=(0,f.$Lp)(Y,Q,x).then(W=>{const X={"X-Client-Name":`${F.applicationName}${k.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(X["X-Client-Commit"]=F.commit),X}),this.f=new p(t,r,this.n,this.r),this.u(),this.B((0,I.$Rc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(N,F){this.b={token:N,type:F}}t(N){this.a=N?(0,g.$Rg)(N,"v1"):void 0}u(){const N=this.s.getNumber(o,-1);N&&Date.now()<N&&this.y(new Date(N))}y(N){this.j?.getTime()!==N?.getTime()&&(this.j=N,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,O.$4g)(F=>(0,O.$fh)(this.j.getTime()-Date.now(),F).then(()=>this.y(void 0))),this.w.then(null,F=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$Rg)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const M=await this.D(F,{type:"GET",headers:N},[],A.CancellationToken.None);return(await(0,c.$yp)(M))?.map(({id:z})=>z)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$Rg)(this.a,"collection").toString();N={...N},N["Content-Type"]=R.$qs.text;const M=await this.D(F,{type:"POST",headers:N},[],A.CancellationToken.None),z=await(0,c.$xp)(M);if(!z)throw new l.$0ob("Server did not return the collection id",F,"NoCollection",M.res.statusCode,M.res.headers[l.$6ob]);return z}async deleteCollection(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=N?(0,g.$Rg)(this.a,"collection",N).toString():(0,g.$Rg)(this.a,"collection").toString();F={...F},await this.D(M,{type:"DELETE",headers:F},[],A.CancellationToken.None)}async getAllResourceRefs(N,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=this.z(this.a,F,N),z={},Y=await this.D(M.toString(),{type:"GET",headers:z},[],A.CancellationToken.None);return(await(0,c.$yp)(Y)||[]).map(({url:x,created:W})=>({ref:(0,g.$Tg)(M,M.with({path:x})),created:W*1e3}))}async resolveResourceContent(N,F,M,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,g.$Rg)(this.z(this.a,M,N),F).toString();z={...z},z["Cache-Control"]="no-cache";const Q=await this.D(Y,{type:"GET",headers:z},[],A.CancellationToken.None);return await(0,c.$xp)(Q)}async deleteResource(N,F,M){if(!this.a)throw new Error("No settings sync store url configured.");const z=F!==null?(0,g.$Rg)(this.z(this.a,M,N),F).toString():this.z(this.a,M,N).toString(),Y={};await this.D(z,{type:"DELETE",headers:Y},[],A.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,g.$Rg)(this.a,"resource").toString(),F={"Content-Type":R.$qs.text};await this.D(N,{type:"DELETE",headers:F},[],A.CancellationToken.None)}async readResource(N,F,M,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,g.$Rg)(this.z(this.a,M,N),"latest").toString();z={...z},z["Cache-Control"]="no-cache",F&&(z["If-None-Match"]=F.ref);const Q=await this.D(Y,{type:"GET",headers:z},[304],A.CancellationToken.None);let x=null;if(Q.res.statusCode===304&&(x=F),x===null){const W=Q.res.headers.etag;if(!W)throw new l.$0ob("Server did not return the ref",Y,"NoRef",Q.res.statusCode,Q.res.headers[l.$6ob]);const X=await(0,c.$xp)(Q);if(!X&&Q.res.statusCode===304)throw new l.$0ob("Empty response",Y,"EmptyResponse",Q.res.statusCode,Q.res.headers[l.$6ob]);x={ref:W,content:X}}return x}async writeResource(N,F,M,z,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=this.z(this.a,z,N).toString();Y={...Y},Y["Content-Type"]=R.$qs.text,M&&(Y["If-Match"]=M);const x=await this.D(Q,{type:"POST",data:F,headers:Y},[],A.CancellationToken.None),W=x.res.headers.etag;if(!W)throw new l.$0ob("Server did not return the ref",Q,"NoRef",x.res.statusCode,x.res.headers[l.$6ob]);return W}async manifest(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,g.$Rg)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",N&&(F["If-None-Match"]=N.ref);const z=await this.D(M,{type:"GET",headers:F},[304],A.CancellationToken.None);let Y=null;if(z.res.statusCode===304&&(Y=N),!Y){const x=z.res.headers.etag;if(!x)throw new l.$0ob("Server did not return the ref",M,"NoRef",z.res.statusCode,z.res.headers[l.$6ob]);const W=await(0,c.$xp)(z);if(!W&&z.res.statusCode===304)throw new l.$0ob("Empty response",M,"EmptyResponse",z.res.statusCode,z.res.headers[l.$6ob]);W&&(Y={...JSON.parse(W),ref:x})}const Q=this.s.get(n,-1);return Q&&Y&&Q!==Y.session&&this.C(),Y===null&&Q&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,g.$Rg)(this.a,"download").toString(),F={},M=await this.D(N,{type:"GET",headers:F},[],A.CancellationToken.None);if(!(0,c.$up)(M))throw new l.$0ob("Server returned "+M.res.statusCode,N,"EmptyResponse",M.res.statusCode,M.res.headers[l.$6ob]);if((0,c.$vp)(M))throw new l.$0ob("Empty response",N,"EmptyResponse",M.res.statusCode,M.res.headers[l.$6ob]);return M.stream}z(N,F,M){return F?(0,g.$Rg)(N,"collection",F,"resource",M):(0,g.$Rg)(N,"resource",M)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(N,F,M,z){if(!this.b)throw new l.$0ob("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new l.$0ob(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;F.headers={...F.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(F.headers),this.r.trace("Sending request to server",{url:N,type:F.type,headers:{...F.headers,authorization:void 0}});let Q;try{Q=await this.f.request(N,F,z)}catch(V){if(!(V instanceof l.$0ob)){let te="RequestFailed";const oe=(0,D.$0)(V).toLowerCase();oe.includes("xhr timeout")?te="RequestTimeout":oe.includes("protocol")&&oe.includes("not supported")?te="RequestProtocolNotSupported":oe.includes("request path contains unescaped characters")?te="RequestPathNotEscaped":oe.includes("headers must be an object")?te="RequestHeadersNotObject":(0,D.$4)(V)&&(te="RequestCanceled"),V=new l.$0ob(`Connection refused for the request '${N}'.`,N,te,void 0,void 0)}throw this.r.info("Request failed",N),V}const x=Q.res.headers[l.$6ob],W={url:N,status:Q.res.statusCode,"execution-id":F.headers[l.$7ob],"operation-id":x},X=(0,c.$up)(Q)||Q.res.statusCode&&M.includes(Q.res.statusCode);let H="";if(X?this.r.trace("Request succeeded",W):(H=await(0,c.$wp)(Q)||"",this.r.info("Request failed",W,H)),Q.res.statusCode===401||Q.res.statusCode===403){if(this.b=void 0,Q.res.statusCode===401)throw this.g.fire("Unauthorized"),new l.$0ob(`${F.type} request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",Q.res.statusCode,x);if(Q.res.statusCode===403)throw this.g.fire("Forbidden"),new l.$0ob(`${F.type} request '${N}' failed because the access is forbidden (403).`,N,"Forbidden",Q.res.statusCode,x)}if(this.h.fire(),Q.res.statusCode===404)throw new l.$0ob(`${F.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",Q.res.statusCode,x);if(Q.res.statusCode===405)throw new l.$0ob(`${F.type} request '${N}' failed because the requested endpoint is not found (405). ${H}`,N,"MethodNotFound",Q.res.statusCode,x);if(Q.res.statusCode===409)throw new l.$0ob(`${F.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",Q.res.statusCode,x);if(Q.res.statusCode===410)throw new l.$0ob(`${F.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",Q.res.statusCode,x);if(Q.res.statusCode===412)throw new l.$0ob(`${F.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",Q.res.statusCode,x);if(Q.res.statusCode===413)throw new l.$0ob(`${F.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",Q.res.statusCode,x);if(Q.res.statusCode===426)throw new l.$0ob(`${F.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",Q.res.statusCode,x);if(Q.res.statusCode===429){const V=Q.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new l.$0ob(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",Q.res.statusCode,x)):new l.$0ob(`${F.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",Q.res.statusCode,x)}if(!X)throw new l.$0ob("Server returned "+Q.res.statusCode,N,"Unknown",Q.res.statusCode,x);return Q}F(N){let F=this.s.get(s,-1);F===void 0&&(F=(0,m.$Ag)(),this.s.store(s,F,-1,1)),N["X-Machine-Session-Id"]=F;const M=this.s.get(n,-1);M!==void 0&&(N["X-User-Session-Id"]=M)}};e.$hIb=w,e.$hIb=w=ye([K(1,y.$Qj),K(2,c.$sp),K(3,l.$gpb),K(4,$.$li),K(5,b.$Bk),K(6,d.$Fp)],w);let u=class extends w{constructor(N,F,M,z,Y,Q,x){super(N.userDataSyncStore?.url,F,M,z,Y,Q,x),this.B(N.onDidChangeUserDataSyncStore(()=>this.t(N.userDataSyncStore?.url)))}};e.$iIb=u,e.$iIb=u=ye([K(0,l.$3ob),K(1,y.$Qj),K(2,c.$sp),K(3,l.$gpb),K(4,$.$li),K(5,b.$Bk),K(6,d.$Fp)],u);class p{constructor(N,F,M,z){this.c=N,this.d=F,this.f=M,this.g=z,this.a=[],this.b=void 0}request(N,F,M){if(this.h()&&this.i(),F.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new l.$0ob(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(F,M)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$jIb=p}),define(le[261],he([0,1,3,2,10,21,24,19,122]),function(se,e,O,A,D,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=e.$Zac=e.$Yac=e.$Xac=void 0;class g{constructor($){this.a=$}listen($,b){switch(b){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${b}`)}call($,b,y){switch(b){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(y)}throw new Error("Invalid call")}}e.$Xac=g;class C extends A.$Tc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor($){super(),this.c=$,this.b=this.B(new O.$5d),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(b=>{this.a=b,this.B(this.c.listen("onDidChangeAccount")(y=>{this.a=y,this.b.fire(y)}))})}updateAccount($){return this.c.call("updateAccount",$)}}e.$Yac=C;class S{constructor($){this.a=$}listen($,b){switch(b){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${b}`)}call($,b,y){switch(b){case"switch":return this.a.switch(y[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Zac=S;let m=class extends k.$fIb{constructor($,b,y,c){super(b,y,c),this.n=$,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch($){return this.n.call("switch",[$])}async getPreviousUserDataSyncStore(){const $=await this.n.call("getPreviousUserDataSyncStore");return this.r($)}r($){return{url:D.URI.revive($.url),type:$.type,defaultUrl:D.URI.revive($.defaultUrl),insidersUrl:D.URI.revive($.insidersUrl),stableUrl:D.URI.revive($.stableUrl),canSwitch:$.canSwitch,authenticationProviders:$.authenticationProviders}}};e.$1ac=m,e.$1ac=m=ye([K(1,I.$Qj),K(2,L.$Ki),K(3,R.$Fp)],m)}),define(le[262],he([0,1,3,57,24,19,22,257,25,81,84]),function(se,e,O,A,D,L,I,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;let S=class extends R.$J0b{constructor(h,$,b,y,c,f,d,l,v,i,o){super(h,$,b,y,c,d,l,v,i,o),this.B(O.Event.debounce(O.Event.any(O.Event.map(f.onDidFocusMainWindow,()=>"windowFocus"),O.Event.map(f.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$kbc=S,e.$kbc=S=ye([K(0,D.$Qj),K(1,k.$3ob),K(2,k.$4ob),K(3,k.$bpb),K(4,k.$cpb),K(5,A.$b_b),K(6,k.$gpb),K(7,g.$PGb),K(8,I.$Fl),K(9,C.$Qob),K(10,L.$Fp)],S)}),define(le[263],he([0,1,73,23,5,20]),function(se,e,O,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=e.$D$b=e.$C$b=e.$B$b=void 0,e.$B$b=128/4;function I(g){function C(){let S=g.scheme===A.Schemas.file?(0,L.$Fg)(g):g.toString();return D.$k||(S=S.toLowerCase()),(0,O.createHash)("md5").update(S).digest("hex")}return{id:C(),configPath:g}}e.$C$b=I;function R(g,C){function S(){if(g.scheme!==A.Schemas.file)return(0,O.createHash)("md5").update(g.toString()).digest("hex");if(!C)return;let h;return D.$k?h=C.ino:D.$j?h=C.birthtime.getTime():D.$i&&(typeof C.birthtimeMs=="number"?h=Math.floor(C.birthtimeMs):h=C.birthtime.getTime()),(0,O.createHash)("md5").update(g.fsPath).update(h?String(h):"").digest("hex")}const m=S();if(typeof m=="string")return{id:m,uri:g}}e.$D$b=R;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$E$b=k}),define(le[264],he([0,1,6,7,2,16,31,15,8,78,112,263,57,56,23]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=void 0;let b=class extends D.$Tc{constructor(c,f,d,l){super(),this.a=c,this.b=f,this.c=d,this.f=l,this.B(new O.$qh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=this.a.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,f=await I.Promises.readdir(c),d=new g.$oHb(this.f.getChannel("storage"));await Promise.all(f.map(async l=>{const v=(0,L.$jc)(c,l);l.length===S.$B$b||l===C.$qi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===l)||await d.isUsed(v)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${l} as it seems to be an unused empty workspace.`),await I.Promises.rm(v))}))}catch(c){(0,A.$1)(c)}}};e.$Tac=b,e.$Tac=b=ye([K(0,R.$mi),K(1,k.$yj),K(2,m.$b_b),K(3,h.$qac)],b)}),define(le[123],he([0,1,73,64,36,272,14,7,3,2,16,5,32,40,68]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=void 0;class b{traceSocketEvent(u,p){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,p)}constructor(u,p=""){this.f=!0,this.debugLabel=p,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,R.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(u){const p=P=>{this.traceSocketEvent("read",P),u(I.$se.wrap(P))};return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(u){const p=P=>{u({type:0,hadError:P,error:void 0})};return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(u){const p=()=>{u()};return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(u){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,R.$1)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,R.$1)(p)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,p)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$6h=b;var y;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(y||(y={}));var c;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(c||(c={}));class f extends g.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(u,p){this.socket.traceSocketEvent(u,p)}constructor(u,p,P,N){super(),this.f=this.B(new k.$5d),this.g=this.B(new k.$5d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:p,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new d(this,p,P,N,this.f,(F,M)=>this.m(F,M))),this.B(this.a.onError(F=>{console.error(F),(0,R.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new $.$1h,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this.f.event(u)}onClose(u){return this.g.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let p=0;for(;p<u.byteLength;)this.a.writeMessage(u.slice(p,Math.min(p+262144,u.byteLength)),{compressed:!0,opcode:2}),p+=262144}m(u,{compressed:p,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let N=2;u.byteLength<126?N+=0:u.byteLength<2**16?N+=2:N+=8;const F=I.$se.alloc(N),M=p?64:0,z=P&15;if(F.writeUInt8(128|M|z,0),u.byteLength<126)F.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){F.writeUInt8(126,1);let Y=1;F.writeUInt8(u.byteLength>>>8&255,++Y),F.writeUInt8(u.byteLength>>>0&255,++Y)}else{F.writeUInt8(127,1);let Y=1;F.writeUInt8(0,++Y),F.writeUInt8(0,++Y),F.writeUInt8(0,++Y),F.writeUInt8(0,++Y),F.writeUInt8(u.byteLength>>>24&255,++Y),F.writeUInt8(u.byteLength>>>16&255,++Y),F.writeUInt8(u.byteLength>>>8&255,++Y),F.writeUInt8(u.byteLength>>>0&255,++Y)}this.socket.write(I.$se.concat([F,u]))}end(){this.h=!0,this.socket.end()}n(u){if(u.byteLength!==0){for(this.b.acceptChunk(u);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const p=this.b.peek(this.j.readLen),P=p.readUInt8(0),N=(P&128)>>>7,F=(P&64)>>>6,M=P&15,z=p.readUInt8(1),Y=(z&128)>>>7,Q=z&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(Q===126?2:0)+(Q===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const p=this.b.read(this.j.readLen),P=p.readUInt8(1),N=(P&128)>>>7;let F=P&127,M=1;F===126?F=p.readUInt8(++M)*2**8+p.readUInt8(++M):F===127&&(F=p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*2**24+p.readUInt8(++M)*2**16+p.readUInt8(++M)*2**8+p.readUInt8(++M));let z=0;N&&(z=p.readUInt8(++M)*2**24+p.readUInt8(++M)*2**16+p.readUInt8(++M)*2**8+p.readUInt8(++M)),this.j.state=3,this.j.readLen=F,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const p=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",p),i(p,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",p),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(p,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(p,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$7h=f;class d extends g.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$se.alloc(0)}constructor(u,p,P,N,F,M){super(),this.n=u,this.r=F,this.s=M,this.a=this.B(new k.$5d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$5d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$5d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,p?(this.b=this.B(new l(this.n,N,P,{windowBits:15})),this.f=this.B(new v(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(u,p){this.g.push({data:u,options:p}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:u,options:p}=this.g.shift();if(this.f&&p.compressed){const P=await this.w(this.f,u);this.s(P,p)}else this.s(u,{...p,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(u,p){return new Promise((P,N)=>{u.write(p),u.flush(F=>P(F))})}acceptFrame(u,p,P){this.h.push({data:u,isCompressed:p,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const u=this.h.shift();if(this.b&&u.isCompressed){const p=await this.C(this.b,u.data,u.isLastFrameOfMessage);this.r.fire(p)}else this.r.fire(u.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(u,p,P){return new Promise((N,F)=>{u.write(p),P&&u.write(I.$se.fromByteArray([0,0,255,255])),u.flush(M=>N(M))})}}class l extends g.$Tc{get recordedInflateBytes(){return this.j?I.$se.concat(this.f):I.$se.alloc(0)}constructor(u,p,P,N){super(),this.h=u,this.j=p,this.a=this.B(new k.$5d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(N),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(I.$se.wrap(F))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(u){this.j&&this.f.push(u.clone()),this.h.traceSocketEvent("zlibInflateWrite",u),this.b.write(u.buffer)}flush(u){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const p=I.$se.concat(this.g);this.g.length=0,u(p)})}}class v extends g.$Tc{constructor(u,p){super(),this.g=u,this.a=this.B(new k.$5d),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(I.$se.wrap(P))})}write(u){this.g.traceSocketEvent("zlibDeflateWrite",u.buffer),this.b.write(u.buffer)}flush(u){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let p=I.$se.concat(this.f);this.f.length=0,p=p.slice(0,p.byteLength-4),u(p)})}}function i(w,u){if(u===0)return;const p=w.byteLength>>>2;for(let Y=0;Y<p;Y++){const Q=w.readUInt32BE(Y*4);w.writeUInt32BE(Q^u,Y*4)}const P=p*4,N=w.byteLength-P,F=u>>>24&255,M=u>>>16&255,z=u>>>8&255;N>=1&&w.writeUInt8(w.readUInt8(P)^F,P),N>=2&&w.writeUInt8(w.readUInt8(P+1)^M,P+1),N>=3&&w.writeUInt8(w.readUInt8(P+2)^z,P+2)}e.$8h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const w=(0,m.$Ag)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const u=process.platform!=="darwin"&&e.$8h?e.$8h:(0,D.tmpdir)(),p=(0,C.$jc)(u,`vscode-ipc-${w}.sock`);return t(p),p}e.$9h=n;function s(w,u,p){const N=(0,O.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${p}-${u}-sock`;const F=p.substr(0,4),M=u.substr(0,6);let z;return process.platform!=="darwin"&&e.$8h&&!process.env.VSCODE_PORTABLE?z=(0,C.$jc)(e.$8h,`vscode-${N}-${F}-${M}.sock`):z=(0,C.$jc)(w,`${F}-${M}.sock`),t(z),z}e.$0h=s;function t(w){const u=o[S.$u];typeof u=="number"&&w.length>=u&&console.warn(`WARNING: IPC handle "${w}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends h.$Uh{static b(u){const p=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(p,P=>({protocol:new $.$2h(new b(P,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(P,"close"))}))}constructor(u){super(r.b(u)),this.d=u}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$$h=r;function a(w){return new Promise((u,p)=>{const P=(0,A.createServer)();P.on("error",p),P.listen(w,()=>{P.removeListener("error",p),u(new r(P))})})}e.$_h=a;function E(w,u){return new Promise((p,P)=>{const N=(0,A.createConnection)(w,()=>{N.removeListener("error",P),p($.$3h.fromSocket(new b(N,`ipc-client${u}`),u))});N.once("error",P)})}e.$ai=E}),define(le[265],he([0,1,64,123,212]),function(se,e,O,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=void 0,e.$nbc=new class{supports(L){return!0}connect({host:L,port:I},R,k,g){return new Promise((C,S)=>{const m=O.createConnection({host:L,port:I},()=>{m.removeListener("error",S),m.write((0,D.$ktb)(R,k,g));const h=$=>{$.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",h),C(new A.$6h(m,g)))};m.on("data",h)});m.setNoDelay(!0),m.once("error",S)})}}}),define(le[266],he([0,1,64,36,133,123,6,2,5,21,8,24,215,104,106,79,14]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=e.$jac=e.$iac=e.$hac=void 0;async function c(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new f(i,o,n,s,t).waitForReady(),!(t&&D.$Dg[t]||!D.$Dg[r.tunnelLocalPort]));a--);return r}class f extends R.$Tc{constructor(o,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=O.createServer(),this.c=new I.$dh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,b.$Tv)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,D.$Eg)(o,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,b.$Rv)(this.tunnelRemoteHost)||(0,b.$Tv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,m.$wl)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof L.$6h?t.socket.destroy():t.end()}),t instanceof L.$6h?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(y.$se.wrap(s))),o.resume()}t(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.$hac=f;let d=class extends b.$Wv{constructor(o,n,s,t,r){super(n,r),this.v=o,this.w=s,this.y=t}isPortPrivileged(o){return(0,b.$Uv)(o,this.m,k.OS,A.release())}t(o,n,s,t,r,a,E,w){const u=this.s(n,s);if(u)return++u.refcount,u.value;if((0,b.$Ov)(o))return this.u(o,n,s,r,a,E,w);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const p={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=c(p,t,n,s,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,P),P}}};e.$iac=d,e.$iac=d=ye([K(0,h.$ql),K(1,C.$yj),K(2,$.$tl),K(3,S.$Qj),K(4,g.$Ki)],d);let l=class extends d{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.$jac=l,e.$jac=l=ye([K(0,h.$ql),K(1,C.$yj),K(2,$.$tl),K(3,S.$Qj),K(4,g.$Ki)],l);let v=class extends R.$Tc{constructor(o,n,s,t,r){super(),this.b=o,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,s,t,r,a,E,w,u){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(o)){const p=new l(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(o,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,s,t,r,a,E,w,u)}};e.$kac=v,e.$kac=v=ye([K(0,h.$ql),K(1,C.$yj),K(2,S.$Qj),K(3,$.$tl),K(4,g.$Ki)],v)}),define(le[273],he([0,1,36,38,7,2,23,10,17,3,40,147,206,207,197,198,264,188,190,21,211,95,222,96,217,15,114,248,29,99,189,113,97,11,200,201,72,4,196,74,75,228,8,202,102,24,59,19,107,22,108,109,110,46,231,83,111,25,81,256,261,241,84,255,259,260,122,60,254,242,106,221,79,266,216,232,28,233,5,234,191,209,208,82,247,18,51,205,58,253,230,243,105,258,249,9,203,101,251,246,218,185,57,204,262,250,56,252,104,265,182,219]),function(se,e,O,A,D,L,I,R,k,g,C,S,m,h,$,b,y,c,f,d,l,v,i,o,n,s,t,r,a,E,w,u,p,P,N,F,M,z,Y,Q,x,W,X,H,V,te,oe,ee,ae,G,U,j,T,B,q,Z,_,ie,J,ne,ce,fe,de,me,Ee,Re,Oe,Ne,ue,ge,be,Pe,Ce,Fe,je,ze,Te,qe,Ue,Le,re,$e,pe,we,ve,ke,Ie,Ae,Ve,Be,Me,Je,He,_e,tt,Et,St,$t,kt,Pt,Ct,Rt,It,Ot,jt,Dt,gt,Lt,mt,At,Nt,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends L.$Tc{constructor(Se){super(),this.f=Se,this.a=this.B(new S.$NV(this)),this.b=void 0,this.c=this.B(new g.$5d),this.g()}g(){let Se=!1;const De=()=>{Se||(Se=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",De),(0,S.$OV)(process.parentPort,st.$w_b.exit,De)}async init(){const Se=await this.h();(0,ie.$Xob)(),Se.invokeFunction(De=>{const Xe=De.get(X.$yj),We=De.get(G.$Fl),Ze=De.get(ke.$bl);Xe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(De),this.m(Xe),this.n(We,Ze),this.B(Ze.onDidChangeProfiles(()=>this.n(We,Ze)))}),this.B((0,L.$Qc)(Se.createInstance(m.$Pac,this.f.codeCachePath),Se.createInstance(h.$Qac),Se.createInstance(y.$Tac),Se.createInstance(b.$Sac),Se.createInstance($.$Rac),Se.createInstance(tt.$ebc),Se.createInstance(Je.$9ac)))}async h(){const Se=new Q.$ci,De={_serviceBrand:void 0,...V.default};Se.set(te.$Qj,De);const Xe=new C.$Yh(Ge=>Ge==="main"),We=new gt.$rac(this.a,Xe);Se.set(gt.$qac,We);const Ze=this.f.policiesData?new Ae.$Z_b(this.f.policiesData,We.getChannel("policy")):new Ve.$Xn;Se.set(Ve.$Vn,Ze);const Ke=new Nt.$Nm(this.f.args,De);Se.set(s.$mi,Ke);const et=new H.$Lr(void 0,this.f.logLevel,Ke.logsHome,this.f.loggers.map(Ge=>({...Ge,resource:R.URI.revive(Ge.resource)})),We.getChannel("logger"));Se.set(X.$zj,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ht=this.B(new X.$Gj(ot.getLevel())),Qe=this.B(new St.$AP(ot,[ht]));Se.set(X.$yj,Qe),this.b=this.B(new $t.$gbc(Qe)),Se.set($t.$fbc,this.b);const Ye=this.B(new N.$nq(Qe));Se.set(P.$Bk,Ye);const ut=this.B(new F.$Mq(Qe));Ye.registerProvider(I.Schemas.file,ut);const at=new qe.$as(Ye);Se.set(Te.$_k,at);const xe=this.B(new Be.$HP(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ke.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));Se.set(ke.$bl,xe);const ft=this.B(new Le.$pac(I.Schemas.file,this.B(new re.$jP(We.getChannel(re.$iP),{pathCaseSensitive:Ue.$k})),I.Schemas.vscodeUserData,xe,at,Qe));Ye.registerProvider(I.Schemas.vscodeUserData,ft);const it=this.B(new l.$lo(xe.defaultProfile.settingsResource,Ye,Ze,Qe));Se.set(d.$Ki,it);const dt=new Lt.$mbc(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},We,Ke);Se.set(ee.$Fp,dt),this.B((0,L.$Rc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const bt=new Ct.$wr(We.getChannel("request"));Se.set(oe.$sp,bt),Se.set(c.$Uac,new M.$bi(f.$Vac,void 0,!1)),Se.set(pe.$BF,new M.$bi($e.$8ac,void 0,!1));const pt=new Ot.$wac(-1,We);Se.set(It.$b_b,pt),Se.set(o.$po,new M.$bi(n.$PP,void 0,!0));const Ft=this.B(new ge.$W_b(pt)),Mt=new C.$Yh(Ge=>Ft.getActiveClientId().then(lt=>Ge===lt));Se.set(p.$u1b,new Rt.$ibc(this.a.getChannel("extensionRecommendationNotification",Mt)));let ct;const nt=[],yt=(0,B.$9o)(De,it);if((0,B.$4o)(De,Ke)){const Ge=new j.$19b(Qe,et,Ke,De);if(nt.push(Ge),!(0,B.$5o)(De,Ke)&&De.aiConfig?.ariaKey){const lt=new Me.$oP(bt,yt,"monacoworkbench",null,De.aiConfig.ariaKey);this.B((0,L.$Rc)(()=>lt.flush())),nt.push(lt)}ct=new T.$Ar({appenders:nt,commonProperties:(0,ae.$Uo)((0,O.release)(),(0,O.hostname)(),process.arch,De.commit,De.version,this.f.machineId,this.f.sqmId,yt),sendErrorTelemetry:!0,piiPaths:(0,B.$0o)(Ke)},it,De)}else{ct=B.$Yo;const Ge=B.$3o;nt.push(Ge)}this.a.registerChannel("telemetryAppender",new U.$B_b(nt)),Se.set(G.$Fl,ct);const qt=new q.$Wac(it,ct,Qe,et,Ke,De);Se.set(G.$Gl,qt),Se.set(Ie.$7p,new M.$bi(Pt.$zP,void 0,!0)),Se.set(we.$$p,new M.$bi(ve.$1_b,void 0,!0)),Se.set(E.$Qp,new M.$bi(E.$Rp,void 0,!0)),Se.set(u.$iq,new M.$bi(u.$jq,void 0,!0)),Se.set(a.$Ko,new M.$bi(r.$Op,void 0,!0)),Se.set(a.$Ro,new M.$bi(Dt.$lbc,void 0,!1)),Se.set(x.$sr,new M.$bi(W.$ur,void 0,!1)),Se.set(v.$Um,new M.$bi(i.$hs,void 0,!1)),Se.set(J.$PGb,new M.$bi(J.$QGb,void 0,!0)),Se.set(ie.$gpb,new M.$bi(fe.$$Ib,void 0,!0)),Se.set(ie.$fpb,C.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),Se.set(a.$Qo,new M.$bi(t.$NGb,void 0,!1)),Se.set(_.$9Ib,new M.$bi(_.$0Ib,void 0,!0)),Se.set(Z.$yv,new M.$bi(Z.$zv)),Se.set(ie.$3ob,new M.$bi(Oe.$gIb,void 0,!0)),Se.set(ie.$4ob,new M.$bi(Oe.$iIb,void 0,!0)),Se.set(de.$Qob,new M.$bi(de.$Sob,void 0,!0)),Se.set(ie.$5ob,new M.$bi(ne.$D0b,void 0,!1)),Se.set(ie.$bpb,new M.$bi(me.$s0b,void 0,!0)),Se.set(ie.$cpb,new M.$bi(Ee.$I0b,void 0,!1)),Se.set(Ne.$pHb,new M.$bi(ue.$4ac,void 0,!0)),Se.set(ie.$dpb,new M.$bi(_e.$f$b,void 0,!0)),Se.set(be.$tl,new M.$bi(Pe.$mac,void 0,!1));const vt=new mt.$rl;return Se.set(mt.$ql,vt),vt.register(0,At.$nbc),Se.set(Ce.$Nv,new M.$bi(Fe.$kac)),Se.set(je.$5ac,new M.$bi(ze.$7ac)),Se.set(He.$0ac,new M.$bi(kt.$hbc)),new Y.$Pq(Se)}j(Se){const De=new w.$Tp(Se.get(a.$No),()=>null);this.a.registerChannel("extensions",De);const Xe=C.ProxyChannel.fromService(Se.get(x.$sr),this.q);this.a.registerChannel("languagePacks",Xe);const We=C.ProxyChannel.fromService(Se.get(v.$Um),this.q);this.a.registerChannel("diagnostics",We);const Ze=new w.$Vp(Se.get(a.$Ro));this.a.registerChannel("extensionTipsService",Ze);const Ke=C.ProxyChannel.fromService(Se.get(c.$Uac),this.q);this.a.registerChannel("checksum",Ke);const et=C.ProxyChannel.fromService(Se.get(pe.$BF),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=C.ProxyChannel.fromService(Se.get(de.$Qob),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=C.ProxyChannel.fromService(Se.get(G.$Gl),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Qe=new ce.$Xac(Se.get(J.$PGb));this.a.registerChannel("userDataSyncAccount",Qe);const Ye=new ce.$Zac(Se.get(ie.$3ob));this.a.registerChannel("userDataSyncStoreManagement",Ye);const ut=new Re.$2ac(Se.get(ie.$cpb),Se.get(ke.$bl),Se.get(X.$yj));this.a.registerChannel("userDataSync",ut);const at=this.B(Se.get(z.$di).createInstance(jt.$kbc));this.a.registerChannel("userDataAutoSync",C.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(Se.get(ie.$dpb),this.q));const xe=C.ProxyChannel.fromService(Se.get(je.$5ac),this.q);this.a.registerChannel(je.$6ac,xe);const ft=C.ProxyChannel.fromService(Se.get(He.$0ac),this.q);this.a.registerChannel("remoteTunnel",ft)}m(Se){process.on("uncaughtException",De=>(0,D.$1)(De)),process.on("unhandledRejection",De=>(0,D.$1)(De)),(0,D.setUnexpectedErrorHandler)(De=>{const Xe=(0,A.$2i)(De,!0);Xe&&Se.error(`[uncaught exception in sharedProcess]: ${Xe}`)})}n(Se,De){Se.publicLog2("profilesInfo",{count:De.profiles.length})}handledClientConnection(Se){if(Se.data!==st.$y_b.response)return!1;const De=(0,k.$Ob)(Se.ports);return De?(this.c.fire(De),!0):!1}}async function wt(rt){const Se=new Tt(rt);process.parentPort.postMessage(st.$w_b.ipcReady),await Se.init(),process.parentPort.postMessage(st.$w_b.initDone)}e.main=wt,process.parentPort.once("message",rt=>{wt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/00124e9e5830e3efc897db71c781899f8a676295/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
