/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/htmlContent","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostChatProvider","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Me=function(fe){for(var e=[],S=0,L=fe.length;S<L;S++)e[S]=Ae[fe[S]];return e};define(Ae[67],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Jh=e.$Ih=void 0;function S(R){return(g,f,k)=>{let A=null,D=null;if(typeof k.value=="function"?(A="value",D=k.value):typeof k.get=="function"&&(A="get",D=k.get),!D)throw new Error("not supported");k[A]=R(D,f)}}function L(R,g,f){let k=null,A=null;if(typeof f.value=="function"?(k="value",A=f.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(k="get",A=f.get),!A)throw new Error("not supported");const D=`$memoize$${g}`;f[k]=function(...h){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,h)}),this[D]}}e.$Ih=L;function P(R,g,f){return S((k,A)=>{const D=`$debounce$${A}`,h=`$debounce$result$${A}`;return function(...v){this[h]||(this[h]=f?f():void 0),clearTimeout(this[D]),g&&(this[h]=g(this[h],...v),v=[this[h]]),this[D]=setTimeout(()=>{k.apply(this,v),this[h]=f?f():void 0},R)}})}e.$Jh=P;function F(R,g,f){return S((k,A)=>{const D=`$throttle$timer$${A}`,h=`$throttle$result$${A}`,v=`$throttle$lastRun$${A}`,p=`$throttle$pending$${A}`;return function(...s){if(this[h]||(this[h]=f?f():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),g&&(this[h]=g(this[h],...s)),this[p])return;const o=this[v]+R;o<=Date.now()?(this[v]=Date.now(),k.apply(this,[this[h]]),this[h]=f?f():void 0):(this[p]=!0,this[D]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),k.apply(this,[this[h]]),this[h]=f?f():void 0},o-Date.now()))}})}e.$Kh=F}),define(Ae[88],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=e.$iO=void 0;class S{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$iO=S,e.$jO=new S("id#")}),define(Ae[120],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var F;(function(i){i.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function R(i,$=!1){let a=0;const c=i.length;let E="",y=0,m=16,I=0;function d(U){let C=0,O=0;for(;C<U;){const V=i.charCodeAt(a);if(V>=48&&V<=57)O=O*16+V-48;else if(V>=65&&V<=70)O=O*16+V-65+10;else if(V>=97&&V<=102)O=O*16+V-97+10;else break;a++,C++}return C<U&&(O=-1),O}function w(U){a=U,E="",y=0,m=16,I=0}function b(){const U=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&k(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&k(i.charCodeAt(a)))for(a++;a<i.length&&k(i.charCodeAt(a));)a++;else return I=3,i.substring(U,a);let C=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&k(i.charCodeAt(a))){for(a++;a<i.length&&k(i.charCodeAt(a));)a++;C=a}else I=3;return i.substring(U,C)}function M(){let U="",C=a;for(;;){if(a>=c){U+=i.substring(C,a),I=2;break}const O=i.charCodeAt(a);if(O===34){U+=i.substring(C,a),a++;break}if(O===92){if(U+=i.substring(C,a),a++,a>=c){I=2;break}switch(i.charCodeAt(a++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const re=d(4);re>=0?U+=String.fromCharCode(re):I=4;break}default:I=5}C=a;continue}if(O>=0&&O<=31)if(f(O)){U+=i.substring(C,a),I=2;break}else I=6;a++}return U}function T(){if(E="",I=0,y=a,a>=c)return y=c,m=17;let U=i.charCodeAt(a);if(g(U)){do a++,E+=String.fromCharCode(U),U=i.charCodeAt(a);while(g(U));return m=15}if(f(U))return a++,E+=String.fromCharCode(U),U===13&&i.charCodeAt(a)===10&&(a++,E+=`
`),m=14;switch(U){case 123:return a++,m=1;case 125:return a++,m=2;case 91:return a++,m=3;case 93:return a++,m=4;case 58:return a++,m=6;case 44:return a++,m=5;case 34:return a++,E=M(),m=10;case 47:{const C=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<c&&!f(i.charCodeAt(a));)a++;return E=i.substring(C,a),m=12}if(i.charCodeAt(a+1)===42){a+=2;const O=c-1;let V=!1;for(;a<O;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,V=!0;break}a++}return V||(a++,I=1),E=i.substring(C,a),m=13}return E+=String.fromCharCode(U),a++,m=16}case 45:if(E+=String.fromCharCode(U),a++,a===c||!k(i.charCodeAt(a)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return E+=b(),m=11;default:for(;a<c&&G(U);)a++,U=i.charCodeAt(a);if(y!==a){switch(E=i.substring(y,a),E){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return E+=String.fromCharCode(U),a++,m=16}}function G(U){if(g(U)||f(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let U;do U=T();while(U>=12&&U<=15);return U}return{setPosition:w,getPosition:()=>a,scan:$?W:T,getToken:()=>m,getTokenValue:()=>E,getTokenOffset:()=>y,getTokenLength:()=>a-y,getTokenError:()=>I}}e.$mn=R;function g(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function k(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function D(i,$){const a=[],c=new Object;let E;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function I(d,w,b,M){y.value=d,y.offset=w,y.length=b,y.type=M,y.colonOffset=void 0,E=y}try{r(i,{onObjectBegin:(d,w)=>{if($<=d)throw c;E=void 0,m=$>d,a.push("")},onObjectProperty:(d,w,b)=>{if($<w||(I(d,w,b,"property"),a[a.length-1]=d,$<=w+b))throw c},onObjectEnd:(d,w)=>{if($<=d)throw c;E=void 0,a.pop()},onArrayBegin:(d,w)=>{if($<=d)throw c;E=void 0,a.push(0)},onArrayEnd:(d,w)=>{if($<=d)throw c;E=void 0,a.pop()},onLiteralValue:(d,w,b)=>{if($<w||(I(d,w,b,l(d)),$<=w+b))throw c},onSeparator:(d,w,b)=>{if($<=w)throw c;if(d===":"&&E&&E.type==="property")E.colonOffset=w,m=!1,E=void 0;else if(d===","){const M=a[a.length-1];typeof M=="number"?a[a.length-1]=M+1:(m=!0,a[a.length-1]=""),E=void 0}}})}catch(d){if(d!==c)throw d}return{path:a,previousNode:E,isAtPropertyKey:m,matches:d=>{let w=0;for(let b=0;w<d.length&&b<a.length;b++)if(d[w]===a[b]||d[w]==="*")w++;else if(d[w]!=="**")return!1;return w===d.length}}}e.$nn=D;function h(i,$=[],a=F.DEFAULT){let c=null,E=[];const y=[];function m(d){Array.isArray(E)?E.push(d):c!==null&&(E[c]=d)}return r(i,{onObjectBegin:()=>{const d={};m(d),y.push(E),E=d,c=null},onObjectProperty:d=>{c=d},onObjectEnd:()=>{E=y.pop()},onArrayBegin:()=>{const d=[];m(d),y.push(E),E=d,c=null},onArrayEnd:()=>{E=y.pop()},onLiteralValue:m,onError:(d,w,b)=>{$.push({error:d,offset:w,length:b})}},a),E[0]}e.$on=h;function v(i,$=[],a=F.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function E(d){c.type==="property"&&(c.length=d-c.offset,c=c.parent)}function y(d){return c.children.push(d),d}r(i,{onObjectBegin:d=>{c=y({type:"object",offset:d,length:-1,parent:c,children:[]})},onObjectProperty:(d,w,b)=>{c=y({type:"property",offset:w,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:d,offset:w,length:b,parent:c})},onObjectEnd:(d,w)=>{c.length=d+w-c.offset,c=c.parent,E(d+w)},onArrayBegin:(d,w)=>{c=y({type:"array",offset:d,length:-1,parent:c,children:[]})},onArrayEnd:(d,w)=>{c.length=d+w-c.offset,c=c.parent,E(d+w)},onLiteralValue:(d,w,b)=>{y({type:l(d),offset:w,length:b,parent:c,value:d}),E(w+b)},onSeparator:(d,w,b)=>{c.type==="property"&&(d===":"?c.colonOffset=w:d===","&&E(w))},onError:(d,w,b)=>{$.push({error:d,offset:w,length:b})}},a);const I=c.children[0];return I&&delete I.parent,I}e.$pn=v;function p(i,$){if(!i)return;let a=i;for(const c of $)if(typeof c=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let E=!1;for(const y of a.children)if(Array.isArray(y.children)&&y.children[0].value===c){a=y.children[1],E=!0;break}if(!E)return}else{const E=c;if(a.type!=="array"||E<0||!Array.isArray(a.children)||E>=a.children.length)return;a=a.children[E]}return a}e.$qn=p;function s(i){if(!i.parent||!i.parent.children)return[];const $=s(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;$.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&$.push(a)}return $}e.$rn=s;function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const $=Object.create(null);for(const a of i.children){const c=a.children[1];c&&($[a.children[0].value]=o(c))}return $}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$sn=o;function t(i,$,a=!1){return $>=i.offset&&$<i.offset+i.length||a&&$===i.offset+i.length}e.$tn=t;function n(i,$,a=!1){if(t(i,$,a)){const c=i.children;if(Array.isArray(c))for(let E=0;E<c.length&&c[E].offset<=$;E++){const y=n(c[E],$,a);if(y)return y}return i}}e.$un=n;function r(i,$,a=F.DEFAULT){const c=R(i,!1);function E(se){return se?()=>se(c.getTokenOffset(),c.getTokenLength()):()=>!0}function y(se){return se?$e=>se($e,c.getTokenOffset(),c.getTokenLength()):()=>!0}const m=E($.onObjectBegin),I=y($.onObjectProperty),d=E($.onObjectEnd),w=E($.onArrayBegin),b=E($.onArrayEnd),M=y($.onLiteralValue),T=y($.onSeparator),G=E($.onComment),W=y($.onError),U=a&&a.disallowComments,C=a&&a.allowTrailingComma;function O(){for(;;){const se=c.scan();switch(c.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:U||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(se){case 12:case 13:U?V(10):G();break;case 16:V(1);break;case 15:case 14:break;default:return se}}}function V(se,$e=[],ee=[]){if(W(se),$e.length+ee.length>0){let Y=c.getToken();for(;Y!==17;){if($e.indexOf(Y)!==-1){O();break}else if(ee.indexOf(Y)!==-1)break;Y=O()}}}function re(se){const $e=c.getTokenValue();return se?M($e):I($e),O(),!0}function ce(){switch(c.getToken()){case 11:{let se=0;try{se=JSON.parse(c.getTokenValue()),typeof se!="number"&&(V(2),se=0)}catch{V(2)}M(se);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return O(),!0}function ye(){return c.getToken()!==10?(V(3,[],[2,5]),!1):(re(!1),c.getToken()===6?(T(":"),O(),ve()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function De(){m(),O();let se=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(se||V(4,[],[]),T(","),O(),c.getToken()===2&&C)break}else se&&V(6,[],[]);ye()||V(4,[],[2,5]),se=!0}return d(),c.getToken()!==2?V(7,[2],[]):O(),!0}function he(){w(),O();let se=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(se||V(4,[],[]),T(","),O(),c.getToken()===4&&C)break}else se&&V(6,[],[]);ve()||V(4,[],[4,5]),se=!0}return b(),c.getToken()!==4?V(8,[4],[]):O(),!0}function ve(){switch(c.getToken()){case 3:return he();case 1:return De();case 10:return re(!0);default:return ce()}}return O(),c.getToken()===17?a.allowEmptyContent?!0:(V(4,[],[]),!1):ve()?(c.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.$vn=r;function u(i,$){const a=R(i),c=[];let E,y=0,m;do switch(m=a.getPosition(),E=a.scan(),E){case 12:case 13:case 17:y!==m&&c.push(i.substring(y,m)),$!==void 0&&c.push(a.getTokenValue().replace(/[^\r\n]/g,$)),y=a.getPosition();break}while(E!==17);return c.join("")}e.$wn=u;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$xn=l}),function(fe,e){typeof define=="function"&&define.amd?define(Ae[121],Me([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(Ce,be){for(var ge=0;ge<be.length;ge++){var X=be[ge];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(Ce,X.key,X)}}function S(Ce,be,ge){return be&&e(Ce.prototype,be),ge&&e(Ce,ge),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function L(Ce,be){if(Ce){if(typeof Ce=="string")return P(Ce,be);var ge=Object.prototype.toString.call(Ce).slice(8,-1);if(ge==="Object"&&Ce.constructor&&(ge=Ce.constructor.name),ge==="Map"||ge==="Set")return Array.from(Ce);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return P(Ce,be)}}function P(Ce,be){(be==null||be>Ce.length)&&(be=Ce.length);for(var ge=0,X=new Array(be);ge<be;ge++)X[ge]=Ce[ge];return X}function F(Ce,be){var ge=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(ge)return(ge=ge.call(Ce)).next.bind(ge);if(Array.isArray(Ce)||(ge=L(Ce))||be&&Ce&&typeof Ce.length=="number"){ge&&(Ce=ge);var X=0;return function(){return X>=Ce.length?{done:!0}:{done:!1,value:Ce[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=R();function g(Ce){fe.defaults=Ce}var f=/[&<>"']/,k=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(be){return h[be]};function p(Ce,be){if(be){if(f.test(Ce))return Ce.replace(k,v)}else if(A.test(Ce))return Ce.replace(D,v);return Ce}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ce){return Ce.replace(s,function(be,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(Ce,be){Ce=typeof Ce=="string"?Ce:Ce.source,be=be||"";var ge={replace:function(x,le){return le=le.source||le,le=le.replace(t,"$1"),Ce=Ce.replace(x,le),ge},getRegex:function(){return new RegExp(Ce,be)}};return ge}var r=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(Ce,be,ge){if(Ce){var X;try{X=decodeURIComponent(o(ge)).replace(r,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}be&&!u.test(ge)&&(ge=E(be,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var i={},$=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function E(Ce,be){i[" "+Ce]||($.test(Ce)?i[" "+Ce]=Ce+"/":i[" "+Ce]=d(Ce,"/",!0)),Ce=i[" "+Ce];var ge=Ce.indexOf(":")===-1;return be.substring(0,2)==="//"?ge?be:Ce.replace(a,"$1")+be:be.charAt(0)==="/"?ge?be:Ce.replace(c,"$1")+be:Ce+be}var y={exec:function(){}};function m(Ce){for(var be=1,ge,X;be<arguments.length;be++){ge=arguments[be];for(X in ge)Object.prototype.hasOwnProperty.call(ge,X)&&(Ce[X]=ge[X])}return Ce}function I(Ce,be){var ge=Ce.replace(/\|/g,function(le,de,Pe){for(var me=!1,Ie=de;--Ie>=0&&Pe[Ie]==="\\";)me=!me;return me?"|":" |"}),X=ge.split(/ \|/),x=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>be)X.splice(be);else for(;X.length<be;)X.push("");for(;x<X.length;x++)X[x]=X[x].trim().replace(/\\\|/g,"|");return X}function d(Ce,be,ge){var X=Ce.length;if(X===0)return"";for(var x=0;x<X;){var le=Ce.charAt(X-x-1);if(le===be&&!ge)x++;else if(le!==be&&ge)x++;else break}return Ce.slice(0,X-x)}function w(Ce,be){if(Ce.indexOf(be[1])===-1)return-1;for(var ge=Ce.length,X=0,x=0;x<ge;x++)if(Ce[x]==="\\")x++;else if(Ce[x]===be[0])X++;else if(Ce[x]===be[1]&&(X--,X<0))return x;return-1}function b(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(Ce,be){if(be<1)return"";for(var ge="";be>1;)be&1&&(ge+=Ce),be>>=1,Ce+=Ce;return ge+Ce}function T(Ce,be,ge,X){var x=be.href,le=be.title?p(be.title):null,de=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){X.state.inLink=!0;var Pe={type:"link",raw:ge,href:x,title:le,text:de,tokens:X.inlineTokens(de)};return X.state.inLink=!1,Pe}return{type:"image",raw:ge,href:x,title:le,text:p(de)}}function G(Ce,be){var ge=Ce.match(/^(\s+)(?:```)/);if(ge===null)return be;var X=ge[1];return be.split(`
`).map(function(x){var le=x.match(/^\s+/);if(le===null)return x;var de=le[0];return de.length>=X.length?x.slice(X.length):x}).join(`
`)}var W=function(){function Ce(ge){this.options=ge||fe.defaults}var be=Ce.prototype;return be.space=function(X){var x=this.rules.block.newline.exec(X);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},be.code=function(X){var x=this.rules.block.code.exec(X);if(x){var le=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?le:d(le,`
`)}}},be.fences=function(X){var x=this.rules.block.fences.exec(X);if(x){var le=x[0],de=G(le,x[3]||"");return{type:"code",raw:le,lang:x[2]?x[2].trim():x[2],text:de}}},be.heading=function(X){var x=this.rules.block.heading.exec(X);if(x){var le=x[2].trim();if(/#$/.test(le)){var de=d(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:le,tokens:this.lexer.inline(le)}}},be.hr=function(X){var x=this.rules.block.hr.exec(X);if(x)return{type:"hr",raw:x[0]}},be.blockquote=function(X){var x=this.rules.block.blockquote.exec(X);if(x){var le=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},be.list=function(X){var x=this.rules.block.list.exec(X);if(x){var le,de,Pe,me,Ie,Le,ze,N,j,K,H,te,oe=x[1].trim(),Oe=oe.length>1,Ve={type:"list",raw:"",ordered:Oe,start:Oe?+oe.slice(0,-1):"",loose:!1,items:[]};oe=Oe?"\\d{1,9}\\"+oe.slice(-1):"\\"+oe,this.options.pedantic&&(oe=Oe?oe:"[*+-]");for(var He=new RegExp("^( {0,3}"+oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(te=!1,!(!(x=He.exec(X))||this.rules.block.hr.test(X)));){if(le=x[0],X=X.substring(le.length),N=x[2].split(`
`,1)[0],j=X.split(`
`,1)[0],this.options.pedantic?(me=2,H=N.trimLeft()):(me=x[2].search(/[^ ]/),me=me>4?1:me,H=N.slice(me),me+=x[1].length),Le=!1,!N&&/^ *$/.test(j)&&(le+=j+`
`,X=X.substring(j.length+1),te=!0),!te)for(var xe=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,me-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),lt=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,me-1)+"}#");X&&(K=X.split(`
`,1)[0],N=K,this.options.pedantic&&(N=N.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(lt.test(N)||rt.test(N)||xe.test(N)||tt.test(X)));){if(N.search(/[^ ]/)>=me||!N.trim())H+=`
`+N.slice(me);else if(!Le)H+=`
`+N;else break;!Le&&!N.trim()&&(Le=!0),le+=K+`
`,X=X.substring(K.length+1)}Ve.loose||(ze?Ve.loose=!0:/\n *\n *$/.test(le)&&(ze=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(H),de&&(Pe=de[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:le,task:!!de,checked:Pe,loose:!1,text:H}),Ve.raw+=le}Ve.items[Ve.items.length-1].raw=le.trimRight(),Ve.items[Ve.items.length-1].text=H.trimRight(),Ve.raw=Ve.raw.trimRight();var it=Ve.items.length;for(Ie=0;Ie<it;Ie++){this.lexer.state.top=!1,Ve.items[Ie].tokens=this.lexer.blockTokens(Ve.items[Ie].text,[]);var ot=Ve.items[Ie].tokens.filter(function(et){return et.type==="space"}),Be=ot.every(function(et){for(var Q=et.raw.split(""),Z=0,pe=F(Q),We;!(We=pe()).done;){var Ye=We.value;if(Ye===`
`&&(Z+=1),Z>1)return!0}return!1});!Ve.loose&&ot.length&&Be&&(Ve.loose=!0,Ve.items[Ie].loose=!0)}return Ve}},be.html=function(X){var x=this.rules.block.html.exec(X);if(x){var le={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(x[0]):p(x[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},be.def=function(X){var x=this.rules.block.def.exec(X);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var le=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:x[0],href:x[2],title:x[3]}}},be.table=function(X){var x=this.rules.block.table.exec(X);if(x){var le={type:"table",header:I(x[1]).map(function(ze){return{text:ze}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=x[0];var de=le.align.length,Pe,me,Ie,Le;for(Pe=0;Pe<de;Pe++)/^ *-+: *$/.test(le.align[Pe])?le.align[Pe]="right":/^ *:-+: *$/.test(le.align[Pe])?le.align[Pe]="center":/^ *:-+ *$/.test(le.align[Pe])?le.align[Pe]="left":le.align[Pe]=null;for(de=le.rows.length,Pe=0;Pe<de;Pe++)le.rows[Pe]=I(le.rows[Pe],le.header.length).map(function(ze){return{text:ze}});for(de=le.header.length,me=0;me<de;me++)le.header[me].tokens=this.lexer.inline(le.header[me].text);for(de=le.rows.length,me=0;me<de;me++)for(Le=le.rows[me],Ie=0;Ie<Le.length;Ie++)Le[Ie].tokens=this.lexer.inline(Le[Ie].text);return le}}},be.lheading=function(X){var x=this.rules.block.lheading.exec(X);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},be.paragraph=function(X){var x=this.rules.block.paragraph.exec(X);if(x){var le=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:le,tokens:this.lexer.inline(le)}}},be.text=function(X){var x=this.rules.block.text.exec(X);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},be.escape=function(X){var x=this.rules.inline.escape.exec(X);if(x)return{type:"escape",raw:x[0],text:p(x[1])}},be.tag=function(X){var x=this.rules.inline.tag.exec(X);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):p(x[0]):x[0]}},be.link=function(X){var x=this.rules.inline.link.exec(X);if(x){var le=x[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=d(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Pe=w(x[2],"()");if(Pe>-1){var me=x[0].indexOf("!")===0?5:4,Ie=me+x[1].length+Pe;x[2]=x[2].substring(0,Pe),x[0]=x[0].substring(0,Ie).trim(),x[3]=""}}var Le=x[2],ze="";if(this.options.pedantic){var N=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Le);N&&(Le=N[1],ze=N[3])}else ze=x[3]?x[3].slice(1,-1):"";return Le=Le.trim(),/^</.test(Le)&&(this.options.pedantic&&!/>$/.test(le)?Le=Le.slice(1):Le=Le.slice(1,-1)),T(x,{href:Le&&Le.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},be.reflink=function(X,x){var le;if((le=this.rules.inline.reflink.exec(X))||(le=this.rules.inline.nolink.exec(X))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=x[de.toLowerCase()],!de||!de.href){var Pe=le[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return T(le,de,le[0],this.lexer)}},be.emStrong=function(X,x,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(X);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=de[1]||de[2]||"";if(!Pe||Pe&&(le===""||this.rules.inline.punctuation.exec(le))){var me=de[0].length-1,Ie,Le,ze=me,N=0,j=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,x=x.slice(-1*X.length+me);(de=j.exec(x))!=null;)if(Ie=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Ie){if(Le=Ie.length,de[3]||de[4]){ze+=Le;continue}else if((de[5]||de[6])&&me%3&&!((me+Le)%3)){N+=Le;continue}if(ze-=Le,!(ze>0)){if(Le=Math.min(Le,Le+ze+N),Math.min(me,Le)%2){var K=X.slice(1,me+de.index+Le);return{type:"em",raw:X.slice(0,me+de.index+Le+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=X.slice(2,me+de.index+Le-1);return{type:"strong",raw:X.slice(0,me+de.index+Le+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},be.codespan=function(X){var x=this.rules.inline.code.exec(X);if(x){var le=x[2].replace(/\n/g," "),de=/[^ ]/.test(le),Pe=/^ /.test(le)&&/ $/.test(le);return de&&Pe&&(le=le.substring(1,le.length-1)),le=p(le,!0),{type:"codespan",raw:x[0],text:le}}},be.br=function(X){var x=this.rules.inline.br.exec(X);if(x)return{type:"br",raw:x[0]}},be.del=function(X){var x=this.rules.inline.del.exec(X);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},be.autolink=function(X,x){var le=this.rules.inline.autolink.exec(X);if(le){var de,Pe;return le[2]==="@"?(de=p(this.options.mangle?x(le[1]):le[1]),Pe="mailto:"+de):(de=p(le[1]),Pe=de),{type:"link",raw:le[0],text:de,href:Pe,tokens:[{type:"text",raw:de,text:de}]}}},be.url=function(X,x){var le;if(le=this.rules.inline.url.exec(X)){var de,Pe;if(le[2]==="@")de=p(this.options.mangle?x(le[0]):le[0]),Pe="mailto:"+de;else{var me;do me=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(me!==le[0]);de=p(le[0]),le[1]==="www."?Pe="http://"+de:Pe=de}return{type:"link",raw:le[0],text:de,href:Pe,tokens:[{type:"text",raw:de,text:de}]}}},be.inlineText=function(X,x){var le=this.rules.inline.text.exec(X);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):p(le[0]):le[0]:de=p(this.options.smartypants?x(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},Ce}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=n(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=n(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=n(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=n(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=n(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=m({},U),U.gfm=m({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=n(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=m({},U.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:n(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=n(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=n(U._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=n(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=n(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=n(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=n(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=n(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=n(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=n(C.reflink).replace("label",C._label).replace("ref",U._label).getRegex(),C.nolink=n(C.nolink).replace("ref",U._label).getRegex(),C.reflinkSearch=n(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=m({},C),C.pedantic=m({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=m({},C.normal,{escape:n(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=n(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=m({},C.gfm,{br:n(C.br).replace("{2,}","*").getRegex(),text:n(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Ce){var be="",ge,X,x=Ce.length;for(ge=0;ge<x;ge++)X=Ce.charCodeAt(ge),Math.random()>.5&&(X="x"+X.toString(16)),be+="&#"+X+";";return be}var re=function(){function Ce(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||fe.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:U.normal,inline:C.normal};this.options.pedantic?(X.block=U.pedantic,X.inline=C.pedantic):this.options.gfm&&(X.block=U.gfm,this.options.breaks?X.inline=C.breaks:X.inline=C.gfm),this.tokenizer.rules=X}Ce.lex=function(X,x){var le=new Ce(x);return le.lex(X)},Ce.lexInline=function(X,x){var le=new Ce(x);return le.inlineTokens(X)};var be=Ce.prototype;return be.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},be.blockTokens=function(X,x){var le=this;x===void 0&&(x=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(ze,N,j){return N+"    ".repeat(j.length)});for(var de,Pe,me,Ie;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(de=ze.call({lexer:le},X,x))?(X=X.substring(de.raw.length),x.push(de),!0):!1}))){if(de=this.tokenizer.space(X)){X=X.substring(de.raw.length),de.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(de);continue}if(de=this.tokenizer.code(X)){X=X.substring(de.raw.length),Pe=x[x.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+de.raw,Pe.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):x.push(de);continue}if(de=this.tokenizer.fences(X)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.heading(X)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.hr(X)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.blockquote(X)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.list(X)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.html(X)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.def(X)){X=X.substring(de.raw.length),Pe=x[x.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+de.raw,Pe.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(X)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.lheading(X)){X=X.substring(de.raw.length),x.push(de);continue}if(me=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,N=X.slice(1),j=void 0;le.options.extensions.startBlock.forEach(function(K){j=K.call({lexer:this},N),typeof j=="number"&&j>=0&&(ze=Math.min(ze,j))}),ze<1/0&&ze>=0&&(me=X.substring(0,ze+1))}(),this.state.top&&(de=this.tokenizer.paragraph(me))){Pe=x[x.length-1],Ie&&Pe.type==="paragraph"?(Pe.raw+=`
`+de.raw,Pe.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):x.push(de),Ie=me.length!==X.length,X=X.substring(de.raw.length);continue}if(de=this.tokenizer.text(X)){X=X.substring(de.raw.length),Pe=x[x.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+de.raw,Pe.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):x.push(de);continue}if(X){var Le="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Le);break}else throw new Error(Le)}}return this.state.top=!0,x},be.inline=function(X,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:X,tokens:x}),x},be.inlineTokens=function(X,x){var le=this;x===void 0&&(x=[]);var de,Pe,me,Ie=X,Le,ze,N;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Le=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)j.includes(Le[0].slice(Le[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Le.index)+"["+M("a",Le[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Le=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Le.index)+"["+M("a",Le[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Le=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Le.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(ze||(N=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(de=H.call({lexer:le},X,x))?(X=X.substring(de.raw.length),x.push(de),!0):!1}))){if(de=this.tokenizer.escape(X)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.tag(X)){X=X.substring(de.raw.length),Pe=x[x.length-1],Pe&&de.type==="text"&&Pe.type==="text"?(Pe.raw+=de.raw,Pe.text+=de.text):x.push(de);continue}if(de=this.tokenizer.link(X)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(de.raw.length),Pe=x[x.length-1],Pe&&de.type==="text"&&Pe.type==="text"?(Pe.raw+=de.raw,Pe.text+=de.text):x.push(de);continue}if(de=this.tokenizer.emStrong(X,Ie,N)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.codespan(X)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.br(X)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.del(X)){X=X.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.autolink(X,V)){X=X.substring(de.raw.length),x.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(X,V))){X=X.substring(de.raw.length),x.push(de);continue}if(me=X,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,te=X.slice(1),oe=void 0;le.options.extensions.startInline.forEach(function(Oe){oe=Oe.call({lexer:this},te),typeof oe=="number"&&oe>=0&&(H=Math.min(H,oe))}),H<1/0&&H>=0&&(me=X.substring(0,H+1))}(),de=this.tokenizer.inlineText(me,O)){X=X.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(N=de.raw.slice(-1)),ze=!0,Pe=x[x.length-1],Pe&&Pe.type==="text"?(Pe.raw+=de.raw,Pe.text+=de.text):x.push(de);continue}if(X){var K="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return x},S(Ce,null,[{key:"rules",get:function(){return{block:U,inline:C}}}]),Ce}(),ce=function(){function Ce(ge){this.options=ge||fe.defaults}var be=Ce.prototype;return be.code=function(X,x,le){var de=(x||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(X,de);Pe!=null&&Pe!==X&&(le=!0,X=Pe)}return X=X.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+p(de,!0)+'">'+(le?X:p(X,!0))+`</code></pre>
`:"<pre><code>"+(le?X:p(X,!0))+`</code></pre>
`},be.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},be.html=function(X){return X},be.heading=function(X,x,le,de){if(this.options.headerIds){var Pe=this.options.headerPrefix+de.slug(le);return"<h"+x+' id="'+Pe+'">'+X+"</h"+x+`>
`}return"<h"+x+">"+X+"</h"+x+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(X,x,le){var de=x?"ol":"ul",Pe=x&&le!==1?' start="'+le+'"':"";return"<"+de+Pe+`>
`+X+"</"+de+`>
`},be.listitem=function(X){return"<li>"+X+`</li>
`},be.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(X){return"<p>"+X+`</p>
`},be.table=function(X,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+x+`</table>
`},be.tablerow=function(X){return`<tr>
`+X+`</tr>
`},be.tablecell=function(X,x){var le=x.header?"th":"td",de=x.align?"<"+le+' align="'+x.align+'">':"<"+le+">";return de+X+("</"+le+`>
`)},be.strong=function(X){return"<strong>"+X+"</strong>"},be.em=function(X){return"<em>"+X+"</em>"},be.codespan=function(X){return"<code>"+X+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(X){return"<del>"+X+"</del>"},be.link=function(X,x,le){if(X=l(this.options.sanitize,this.options.baseUrl,X),X===null)return le;var de='<a href="'+p(X)+'"';return x&&(de+=' title="'+x+'"'),de+=">"+le+"</a>",de},be.image=function(X,x,le){if(X=l(this.options.sanitize,this.options.baseUrl,X),X===null)return le;var de='<img src="'+X+'" alt="'+le+'"';return x&&(de+=' title="'+x+'"'),de+=this.options.xhtml?"/>":">",de},be.text=function(X){return X},Ce}(),ye=function(){function Ce(){}var be=Ce.prototype;return be.strong=function(X){return X},be.em=function(X){return X},be.codespan=function(X){return X},be.del=function(X){return X},be.html=function(X){return X},be.text=function(X){return X},be.link=function(X,x,le){return""+le},be.image=function(X,x,le){return""+le},be.br=function(){return""},Ce}(),De=function(){function Ce(){this.seen={}}var be=Ce.prototype;return be.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(X,x){var le=X,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[X];do de++,le=X+"-"+de;while(this.seen.hasOwnProperty(le))}return x||(this.seen[X]=de,this.seen[le]=0),le},be.slug=function(X,x){x===void 0&&(x={});var le=this.serialize(X);return this.getNextSafeSlug(le,x.dryrun)},Ce}(),he=function(){function Ce(ge){this.options=ge||fe.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new De}Ce.parse=function(X,x){var le=new Ce(x);return le.parse(X)},Ce.parseInline=function(X,x){var le=new Ce(x);return le.parseInline(X)};var be=Ce.prototype;return be.parse=function(X,x){x===void 0&&(x=!0);var le="",de,Pe,me,Ie,Le,ze,N,j,K,H,te,oe,Oe,Ve,He,xe,tt,lt,rt,it=X.length;for(de=0;de<it;de++){if(H=X[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(rt=this.options.extensions.renderers[H.type].call({parser:this},H),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){le+=rt||"";continue}switch(H.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(j="",N="",Ie=H.header.length,Pe=0;Pe<Ie;Pe++)N+=this.renderer.tablecell(this.parseInline(H.header[Pe].tokens),{header:!0,align:H.align[Pe]});for(j+=this.renderer.tablerow(N),K="",Ie=H.rows.length,Pe=0;Pe<Ie;Pe++){for(ze=H.rows[Pe],N="",Le=ze.length,me=0;me<Le;me++)N+=this.renderer.tablecell(this.parseInline(ze[me].tokens),{header:!1,align:H.align[me]});K+=this.renderer.tablerow(N)}le+=this.renderer.table(j,K);continue}case"blockquote":{K=this.parse(H.tokens),le+=this.renderer.blockquote(K);continue}case"list":{for(te=H.ordered,oe=H.start,Oe=H.loose,Ie=H.items.length,K="",Pe=0;Pe<Ie;Pe++)He=H.items[Pe],xe=He.checked,tt=He.task,Ve="",He.task&&(lt=this.renderer.checkbox(xe),Oe?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=lt+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=lt+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:lt}):Ve+=lt),Ve+=this.parse(He.tokens,Oe),K+=this.renderer.listitem(Ve,tt,xe);le+=this.renderer.list(K,te,oe);continue}case"html":{le+=this.renderer.html(H.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;de+1<it&&X[de+1].type==="text";)H=X[++de],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);le+=x?this.renderer.paragraph(K):K;continue}default:{var ot='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ot);return}else throw new Error(ot)}}}return le},be.parseInline=function(X,x){x=x||this.renderer;var le="",de,Pe,me,Ie=X.length;for(de=0;de<Ie;de++){if(Pe=X[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(me=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),me!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){le+=me||"";continue}switch(Pe.type){case"escape":{le+=x.text(Pe.text);break}case"html":{le+=x.html(Pe.text);break}case"link":{le+=x.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,x));break}case"image":{le+=x.image(Pe.href,Pe.title,Pe.text);break}case"strong":{le+=x.strong(this.parseInline(Pe.tokens,x));break}case"em":{le+=x.em(this.parseInline(Pe.tokens,x));break}case"codespan":{le+=x.codespan(Pe.text);break}case"br":{le+=x.br();break}case"del":{le+=x.del(this.parseInline(Pe.tokens,x));break}case"text":{le+=x.text(Pe.text);break}default:{var Le='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Le);return}else throw new Error(Le)}}}return le},Ce}();function ve(Ce,be,ge){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof be=="function"&&(ge=be,be=null),be=m({},ve.defaults,be||{}),b(be),ge){var X=be.highlight,x;try{x=re.lex(Ce,be)}catch(Ie){return ge(Ie)}var le=function(Le){var ze;if(!Le)try{be.walkTokens&&ve.walkTokens(x,be.walkTokens),ze=he.parse(x,be)}catch(N){Le=N}return be.highlight=X,Le?ge(Le):ge(null,ze)};if(!X||X.length<3||(delete be.highlight,!x.length))return le();var de=0;ve.walkTokens(x,function(Ie){Ie.type==="code"&&(de++,setTimeout(function(){X(Ie.text,Ie.lang,function(Le,ze){if(Le)return le(Le);ze!=null&&ze!==Ie.text&&(Ie.text=ze,Ie.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Pe(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+p(Ie.message+"",!0)+"</pre>";throw Ie}try{var me=re.lex(Ce,be);if(be.walkTokens){if(be.async)return Promise.all(ve.walkTokens(me,be.walkTokens)).then(function(){return he.parse(me,be)}).catch(Pe);ve.walkTokens(me,be.walkTokens)}return he.parse(me,be)}catch(Ie){Pe(Ie)}}ve.options=ve.setOptions=function(Ce){return m(ve.defaults,Ce),g(ve.defaults),ve},ve.getDefaults=R,ve.defaults=fe.defaults,ve.use=function(){for(var Ce=arguments.length,be=new Array(Ce),ge=0;ge<Ce;ge++)be[ge]=arguments[ge];var X=m.apply(void 0,[{}].concat(be)),x=ve.defaults.extensions||{renderers:{},childTokens:{}},le;be.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(me){if(!me.name)throw new Error("extension name required");if(me.renderer){var Ie=x.renderers?x.renderers[me.name]:null;Ie?x.renderers[me.name]=function(){for(var Le=arguments.length,ze=new Array(Le),N=0;N<Le;N++)ze[N]=arguments[N];var j=me.renderer.apply(this,ze);return j===!1&&(j=Ie.apply(this,ze)),j}:x.renderers[me.name]=me.renderer}if(me.tokenizer){if(!me.level||me.level!=="block"&&me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[me.level]?x[me.level].unshift(me.tokenizer):x[me.level]=[me.tokenizer],me.start&&(me.level==="block"?x.startBlock?x.startBlock.push(me.start):x.startBlock=[me.start]:me.level==="inline"&&(x.startInline?x.startInline.push(me.start):x.startInline=[me.start]))}me.childTokens&&(x.childTokens[me.name]=me.childTokens)})),de.renderer&&function(){var me=ve.defaults.renderer||new ce,Ie=function(N){var j=me[N];me[N]=function(){for(var K=arguments.length,H=new Array(K),te=0;te<K;te++)H[te]=arguments[te];var oe=de.renderer[N].apply(me,H);return oe===!1&&(oe=j.apply(me,H)),oe}};for(var Le in de.renderer)Ie(Le);X.renderer=me}(),de.tokenizer&&function(){var me=ve.defaults.tokenizer||new W,Ie=function(N){var j=me[N];me[N]=function(){for(var K=arguments.length,H=new Array(K),te=0;te<K;te++)H[te]=arguments[te];var oe=de.tokenizer[N].apply(me,H);return oe===!1&&(oe=j.apply(me,H)),oe}};for(var Le in de.tokenizer)Ie(Le);X.tokenizer=me}(),de.walkTokens){var Pe=ve.defaults.walkTokens;X.walkTokens=function(me){var Ie=[];return Ie.push(de.walkTokens.call(this,me)),Pe&&(Ie=Ie.concat(Pe.call(this,me))),Ie}}le&&(X.extensions=x),ve.setOptions(X)})},ve.walkTokens=function(Ce,be){for(var ge=[],X=function(){var Pe=le.value;switch(ge=ge.concat(be.call(ve,Pe)),Pe.type){case"table":{for(var me=F(Pe.header),Ie;!(Ie=me()).done;){var Le=Ie.value;ge=ge.concat(ve.walkTokens(Le.tokens,be))}for(var ze=F(Pe.rows),N;!(N=ze()).done;)for(var j=N.value,K=F(j),H;!(H=K()).done;){var te=H.value;ge=ge.concat(ve.walkTokens(te.tokens,be))}break}case"list":{ge=ge.concat(ve.walkTokens(Pe.items,be));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Pe.type]?ve.defaults.extensions.childTokens[Pe.type].forEach(function(oe){ge=ge.concat(ve.walkTokens(Pe[oe],be))}):Pe.tokens&&(ge=ge.concat(ve.walkTokens(Pe.tokens,be)))}},x=F(Ce),le;!(le=x()).done;)X();return ge},ve.parseInline=function(Ce,be){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");be=m({},ve.defaults,be||{}),b(be);try{var ge=re.lexInline(Ce,be);return be.walkTokens&&ve.walkTokens(ge,be.walkTokens),he.parseInline(ge,be)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+p(X.message+"",!0)+"</pre>";throw X}},ve.Parser=he,ve.parser=he.parse,ve.Renderer=ce,ve.TextRenderer=ye,ve.Lexer=re,ve.lexer=re.lex,ve.Tokenizer=W,ve.Slugger=De,ve.parse=ve;var se=ve.options,$e=ve.setOptions,ee=ve.use,Y=ve.walkTokens,q=ve.parseInline,ne=ve,Se=he.parse,Te=re.lex;fe.Lexer=re,fe.Parser=he,fe.Renderer=ce,fe.Slugger=De,fe.TextRenderer=ye,fe.Tokenizer=W,fe.getDefaults=R,fe.lexer=Te,fe.marked=ve,fe.options=se,fe.parse=ne,fe.parseInline=q,fe.parser=Se,fe.setOptions=$e,fe.use=ee,fe.walkTokens=Y,Object.defineProperty(fe,"__esModule",{value:!0})}),define(Ae[122],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0;function S(s){const o=F(s);if(o&&o.length>0)return new Uint32Array(o)}e.$3j=S;let L=0;const P=new Uint32Array(10);function F(s){if(L=0,R(s,D,4352),L>0||(R(s,h,4449),L>0)||(R(s,v,4520),L>0)||(R(s,p,12593),L))return P.subarray(0,L);if(s>=44032&&s<=55203){const o=s-44032,t=o%588,n=Math.floor(o/588),r=Math.floor(t/28),u=t%28-1;if(n<D.length?R(n,D,0):4352+n-12593<p.length&&R(4352+n,p,12593),r<h.length?R(r,h,0):4449+r-12593<p.length&&R(4449+r-12593,p,12593),u>=0&&(u<v.length?R(u,v,0):4520+u-12593<p.length&&R(4520+u-12593,p,12593)),L>0)return P.subarray(0,L)}}function R(s,o,t){s>=t&&s<t+o.length&&g(o[s-t])}function g(s){s!==0&&(P[L++]=s&255,s>>8&&(P[L++]=s>>8&255),s>>16&&(P[L++]=s>>16&255))}var f;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var k;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(k||(k={}));var A;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(A||(A={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),h=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),p=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ae[123],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.rot=e.$fm=void 0;function S(g,f,k){return Math.min(Math.max(g,f),k)}e.$fm=S;function L(g,f){return(f+g%f)%f}e.rot=L;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$hm=P;class F{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$im=F;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const k=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$jm=R}),function(){function fe(P){const F=[];typeof P=="number"&&F.push("code/timeOrigin",P);function R(f){F.push(f,Date.now())}function g(){const f=[];for(let k=0;k<F.length;k+=2)f.push({name:F[k],startTime:F[k+1]});return f}return{mark:R,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))F.push({name:R.name,startTime:Math.round(P+R.startTime)});return F}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function S(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=S(L))}(),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var L in S)(typeof exports=="object"?exports:fe)[L]=S[L]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function S(L){if(e[L])return e[L].exports;var P=e[L]={i:L,l:!1,exports:{}};return fe[L].call(P.exports,P,P.exports,S),P.l=!0,P.exports}return S.m=fe,S.c=e,S.d=function(L,P,F){S.o(L,P)||Object.defineProperty(L,P,{enumerable:!0,get:F})},S.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},S.t=function(L,P){if(1&P&&(L=S(L)),8&P||4&P&&typeof L=="object"&&L&&L.__esModule)return L;var F=Object.create(null);if(S.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:L}),2&P&&typeof L!="string")for(var R in L)S.d(F,R,function(g){return L[g]}.bind(null,R));return F},S.n=function(L){var P=L&&L.__esModule?function(){return L.default}:function(){return L};return S.d(P,"a",P),P},S.o=function(L,P){return Object.prototype.hasOwnProperty.call(L,P)},S.p="",S(S.s=0)}([function(fe,e,S){(function(L){var P;e=fe.exports=ee,P=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],f=e.src=[],k=0,A=k++;f[A]="0|[1-9]\\d*";var D=k++;f[D]="[0-9]+";var h=k++;f[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=k++;f[v]="("+f[A]+")\\.("+f[A]+")\\.("+f[A]+")";var p=k++;f[p]="("+f[D]+")\\.("+f[D]+")\\.("+f[D]+")";var s=k++;f[s]="(?:"+f[A]+"|"+f[h]+")";var o=k++;f[o]="(?:"+f[D]+"|"+f[h]+")";var t=k++;f[t]="(?:-("+f[s]+"(?:\\."+f[s]+")*))";var n=k++;f[n]="(?:-?("+f[o]+"(?:\\."+f[o]+")*))";var r=k++;f[r]="[0-9A-Za-z-]+";var u=k++;f[u]="(?:\\+("+f[r]+"(?:\\."+f[r]+")*))";var l=k++,i="v?"+f[v]+f[t]+"?"+f[u]+"?";f[l]="^"+i+"$";var $="[v=\\s]*"+f[p]+f[n]+"?"+f[u]+"?",a=k++;f[a]="^"+$+"$";var c=k++;f[c]="((?:<|>)?=?)";var E=k++;f[E]=f[D]+"|x|X|\\*";var y=k++;f[y]=f[A]+"|x|X|\\*";var m=k++;f[m]="[v=\\s]*("+f[y]+")(?:\\.("+f[y]+")(?:\\.("+f[y]+")(?:"+f[t]+")?"+f[u]+"?)?)?";var I=k++;f[I]="[v=\\s]*("+f[E]+")(?:\\.("+f[E]+")(?:\\.("+f[E]+")(?:"+f[n]+")?"+f[u]+"?)?)?";var d=k++;f[d]="^"+f[c]+"\\s*"+f[m]+"$";var w=k++;f[w]="^"+f[c]+"\\s*"+f[I]+"$";var b=k++;f[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=k++;f[M]="(?:~>?)";var T=k++;f[T]="(\\s*)"+f[M]+"\\s+",g[T]=new RegExp(f[T],"g");var G=k++;f[G]="^"+f[M]+f[m]+"$";var W=k++;f[W]="^"+f[M]+f[I]+"$";var U=k++;f[U]="(?:\\^)";var C=k++;f[C]="(\\s*)"+f[U]+"\\s+",g[C]=new RegExp(f[C],"g");var O=k++;f[O]="^"+f[U]+f[m]+"$";var V=k++;f[V]="^"+f[U]+f[I]+"$";var re=k++;f[re]="^"+f[c]+"\\s*("+$+")$|^$";var ce=k++;f[ce]="^"+f[c]+"\\s*("+i+")$|^$";var ye=k++;f[ye]="(\\s*)"+f[c]+"\\s*("+$+"|"+f[m]+")",g[ye]=new RegExp(f[ye],"g");var De=k++;f[De]="^\\s*("+f[m]+")\\s+-\\s+("+f[m]+")\\s*$";var he=k++;f[he]="^\\s*("+f[I]+")\\s+-\\s+("+f[I]+")\\s*$";var ve=k++;f[ve]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)P(se,f[se]),g[se]||(g[se]=new RegExp(f[se]));function $e(j,K){if(j instanceof ee)return j;if(typeof j!="string"||j.length>F||!(K?g[a]:g[l]).test(j))return null;try{return new ee(j,K)}catch{return null}}function ee(j,K){if(j instanceof ee){if(j.loose===K)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof ee))return new ee(j,K);P("SemVer",j,K),this.loose=K;var H=j.trim().match(K?g[a]:g[l]);if(!H)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(te){if(/^[0-9]+$/.test(te)){var oe=+te;if(oe>=0&&oe<R)return oe}return te}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=$e,e.valid=function(j,K){var H=$e(j,K);return H?H.version:null},e.clean=function(j,K){var H=$e(j.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(j){return P("SemVer.compare",this.version,this.loose,j),j instanceof ee||(j=new ee(j,this.loose)),this.compareMain(j)||this.comparePre(j)},ee.prototype.compareMain=function(j){return j instanceof ee||(j=new ee(j,this.loose)),q(this.major,j.major)||q(this.minor,j.minor)||q(this.patch,j.patch)},ee.prototype.comparePre=function(j){if(j instanceof ee||(j=new ee(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],te=j.prerelease[K];if(P("prerelease compare",K,H,te),H===void 0&&te===void 0)return 0;if(te===void 0)return 1;if(H===void 0)return-1;if(H!==te)return q(H,te)}while(++K)},ee.prototype.inc=function(j,K){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,K,H,te){typeof H=="string"&&(te=H,H=void 0);try{return new ee(j,H).inc(K,te).version}catch{return null}},e.diff=function(j,K){if(Ce(j,K))return null;var H=$e(j),te=$e(K);if(H.prerelease.length||te.prerelease.length){for(var oe in H)if((oe==="major"||oe==="minor"||oe==="patch")&&H[oe]!==te[oe])return"pre"+oe;return"prerelease"}for(var oe in H)if((oe==="major"||oe==="minor"||oe==="patch")&&H[oe]!==te[oe])return oe},e.compareIdentifiers=q;var Y=/^[0-9]+$/;function q(j,K){var H=Y.test(j),te=Y.test(K);return H&&te&&(j=+j,K=+K),H&&!te?-1:te&&!H?1:j<K?-1:j>K?1:0}function ne(j,K,H){return new ee(j,H).compare(new ee(K,H))}function Se(j,K,H){return ne(j,K,H)>0}function Te(j,K,H){return ne(j,K,H)<0}function Ce(j,K,H){return ne(j,K,H)===0}function be(j,K,H){return ne(j,K,H)!==0}function ge(j,K,H){return ne(j,K,H)>=0}function X(j,K,H){return ne(j,K,H)<=0}function x(j,K,H,te){var oe;switch(K){case"===":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),oe=j===H;break;case"!==":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),oe=j!==H;break;case"":case"=":case"==":oe=Ce(j,H,te);break;case"!=":oe=be(j,H,te);break;case">":oe=Se(j,H,te);break;case">=":oe=ge(j,H,te);break;case"<":oe=Te(j,H,te);break;case"<=":oe=X(j,H,te);break;default:throw new TypeError("Invalid operator: "+K)}return oe}function le(j,K){if(j instanceof le){if(j.loose===K)return j;j=j.value}if(!(this instanceof le))return new le(j,K);P("comparator",j,K),this.loose=K,this.parse(j),this.semver===de?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(j,K){return q(K,j)},e.major=function(j,K){return new ee(j,K).major},e.minor=function(j,K){return new ee(j,K).minor},e.patch=function(j,K){return new ee(j,K).patch},e.compare=ne,e.compareLoose=function(j,K){return ne(j,K,!0)},e.rcompare=function(j,K,H){return ne(K,j,H)},e.sort=function(j,K){return j.sort(function(H,te){return e.compare(H,te,K)})},e.rsort=function(j,K){return j.sort(function(H,te){return e.rcompare(H,te,K)})},e.gt=Se,e.lt=Te,e.eq=Ce,e.neq=be,e.gte=ge,e.lte=X,e.cmp=x,e.Comparator=le;var de={};function Pe(j,K){if(j instanceof Pe)return j.loose===K?j:new Pe(j.raw,K);if(j instanceof le)return new Pe(j.value,K);if(!(this instanceof Pe))return new Pe(j,K);if(this.loose=K,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function me(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ie(j,K,H,te,oe,Oe,Ve,He,xe,tt,lt,rt,it){return((K=me(H)?"":me(te)?">="+H+".0.0":me(oe)?">="+H+"."+te+".0":">="+K)+" "+(He=me(xe)?"":me(tt)?"<"+(+xe+1)+".0.0":me(lt)?"<"+xe+"."+(+tt+1)+".0":rt?"<="+xe+"."+tt+"."+lt+"-"+rt:"<="+He)).trim()}function Le(j,K){for(var H=0;H<j.length;H++)if(!j[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<j.length;H++)if(P(j[H].semver),j[H].semver!==de&&j[H].semver.prerelease.length>0){var te=j[H].semver;if(te.major===K.major&&te.minor===K.minor&&te.patch===K.patch)return!0}return!1}return!0}function ze(j,K,H){try{K=new Pe(K,H)}catch{return!1}return K.test(j)}function N(j,K,H,te){var oe,Oe,Ve,He,xe;switch(j=new ee(j,te),K=new Pe(K,te),H){case">":oe=Se,Oe=X,Ve=Te,He=">",xe=">=";break;case"<":oe=Te,Oe=ge,Ve=Se,He="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(j,K,te))return!1;for(var tt=0;tt<K.set.length;++tt){var lt=K.set[tt],rt=null,it=null;if(lt.forEach(function(ot){ot.semver===de&&(ot=new le(">=0.0.0")),rt=rt||ot,it=it||ot,oe(ot.semver,rt.semver,te)?rt=ot:Ve(ot.semver,it.semver,te)&&(it=ot)}),rt.operator===He||rt.operator===xe||(!it.operator||it.operator===He)&&Oe(j,it.semver)||it.operator===xe&&Ve(j,it.semver))return!1}return!0}le.prototype.parse=function(j){var K=this.loose?g[re]:g[ce],H=j.match(K);if(!H)throw new TypeError("Invalid comparator: "+j);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new ee(H[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(j){return P("Comparator.test",j,this.loose),this.semver===de||(typeof j=="string"&&(j=new ee(j,this.loose)),x(j,this.operator,this.semver,this.loose))},le.prototype.intersects=function(j,K){if(!(j instanceof le))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Pe(j.value,K),ze(this.value,H,K);if(j.operator==="")return H=new Pe(this.value,K),ze(j.semver,H,K);var te=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Oe=this.semver.version===j.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),He=x(this.semver,"<",j.semver,K)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),xe=x(this.semver,">",j.semver,K)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return te||oe||Oe&&Ve||He||xe},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(j){var K=this.loose;j=j.trim(),P("range",j,K);var H=K?g[he]:g[De];j=j.replace(H,Ie),P("hyphen replace",j),j=j.replace(g[ye],"$1$2$3"),P("comparator trim",j,g[ye]),j=(j=(j=j.replace(g[T],"$1~")).replace(g[C],"$1^")).split(/\s+/).join(" ");var te=K?g[re]:g[ce],oe=j.split(" ").map(function(Oe){return function(Ve,He){return P("comp",Ve),Ve=function(xe,tt){return xe.trim().split(/\s+/).map(function(lt){return function(rt,it){P("caret",rt,it);var ot=it?g[V]:g[O];return rt.replace(ot,function(Be,et,Q,Z,pe){var We;return P("caret",rt,Be,et,Q,Z,pe),me(et)?We="":me(Q)?We=">="+et+".0.0 <"+(+et+1)+".0.0":me(Z)?We=et==="0"?">="+et+"."+Q+".0 <"+et+"."+(+Q+1)+".0":">="+et+"."+Q+".0 <"+(+et+1)+".0.0":pe?(P("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),We=et==="0"?Q==="0"?">="+et+"."+Q+"."+Z+pe+" <"+et+"."+Q+"."+(+Z+1):">="+et+"."+Q+"."+Z+pe+" <"+et+"."+(+Q+1)+".0":">="+et+"."+Q+"."+Z+pe+" <"+(+et+1)+".0.0"):(P("no pr"),We=et==="0"?Q==="0"?">="+et+"."+Q+"."+Z+" <"+et+"."+Q+"."+(+Z+1):">="+et+"."+Q+"."+Z+" <"+et+"."+(+Q+1)+".0":">="+et+"."+Q+"."+Z+" <"+(+et+1)+".0.0"),P("caret return",We),We})}(lt,tt)}).join(" ")}(Ve,He),P("caret",Ve),Ve=function(xe,tt){return xe.trim().split(/\s+/).map(function(lt){return function(rt,it){var ot=it?g[W]:g[G];return rt.replace(ot,function(Be,et,Q,Z,pe){var We;return P("tilde",rt,Be,et,Q,Z,pe),me(et)?We="":me(Q)?We=">="+et+".0.0 <"+(+et+1)+".0.0":me(Z)?We=">="+et+"."+Q+".0 <"+et+"."+(+Q+1)+".0":pe?(P("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),We=">="+et+"."+Q+"."+Z+pe+" <"+et+"."+(+Q+1)+".0"):We=">="+et+"."+Q+"."+Z+" <"+et+"."+(+Q+1)+".0",P("tilde return",We),We})}(lt,tt)}).join(" ")}(Ve,He),P("tildes",Ve),Ve=function(xe,tt){return P("replaceXRanges",xe,tt),xe.split(/\s+/).map(function(lt){return function(rt,it){rt=rt.trim();var ot=it?g[w]:g[d];return rt.replace(ot,function(Be,et,Q,Z,pe,We){P("xRange",rt,Be,et,Q,Z,pe,We);var Ye=me(Q),st=Ye||me(Z),Fe=st||me(pe);return et==="="&&Fe&&(et=""),Ye?Be=et===">"||et==="<"?"<0.0.0":"*":et&&Fe?(st&&(Z=0),Fe&&(pe=0),et===">"?(et=">=",st?(Q=+Q+1,Z=0,pe=0):Fe&&(Z=+Z+1,pe=0)):et==="<="&&(et="<",st?Q=+Q+1:Z=+Z+1),Be=et+Q+"."+Z+"."+pe):st?Be=">="+Q+".0.0 <"+(+Q+1)+".0.0":Fe&&(Be=">="+Q+"."+Z+".0 <"+Q+"."+(+Z+1)+".0"),P("xRange return",Be),Be})}(lt,tt)}).join(" ")}(Ve,He),P("xrange",Ve),Ve=function(xe,tt){return P("replaceStars",xe,tt),xe.trim().replace(g[ve],"")}(Ve,He),P("stars",Ve),Ve}(Oe,K)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(Oe){return!!Oe.match(te)})),oe=oe.map(function(Oe){return new le(Oe,K)})},Pe.prototype.intersects=function(j,K){if(!(j instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(te){return j.set.some(function(oe){return oe.every(function(Oe){return te.intersects(Oe,K)})})})})},e.toComparators=function(j,K){return new Pe(j,K).set.map(function(H){return H.map(function(te){return te.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new ee(j,this.loose));for(var K=0;K<this.set.length;K++)if(Le(this.set[K],j))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(j,K,H){var te=null,oe=null;try{var Oe=new Pe(K,H)}catch{return null}return j.forEach(function(Ve){Oe.test(Ve)&&(te&&oe.compare(Ve)!==-1||(oe=new ee(te=Ve,H)))}),te},e.minSatisfying=function(j,K,H){var te=null,oe=null;try{var Oe=new Pe(K,H)}catch{return null}return j.forEach(function(Ve){Oe.test(Ve)&&(te&&oe.compare(Ve)!==1||(oe=new ee(te=Ve,H)))}),te},e.validRange=function(j,K){try{return new Pe(j,K).range||"*"}catch{return null}},e.ltr=function(j,K,H){return N(j,K,"<",H)},e.gtr=function(j,K,H){return N(j,K,">",H)},e.outside=N,e.prerelease=function(j,K){var H=$e(j,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(j,K,H){return j=new Pe(j,H),K=new Pe(K,H),j.intersects(K)},e.coerce=function(j){if(j instanceof ee)return j;if(typeof j!="string")return null;var K=j.match(g[b]);return K==null?null:$e((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,S(1))},function(fe,e){var S,L,P=fe.exports={};function F(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function g(o){if(S===setTimeout)return setTimeout(o,0);if((S===F||!S)&&setTimeout)return S=setTimeout,setTimeout(o,0);try{return S(o,0)}catch{try{return S.call(null,o,0)}catch{return S.call(this,o,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:F}catch{S=F}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var f,k=[],A=!1,D=-1;function h(){A&&f&&(A=!1,f.length?k=f.concat(k):D=-1,k.length&&v())}function v(){if(!A){var o=g(h);A=!0;for(var t=k.length;t;){for(f=k,k=[];++D<t;)f&&f[D].run();D=-1,t=k.length}f=null,A=!1,function(n){if(L===clearTimeout)return clearTimeout(n);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(n);try{L(n)}catch{try{return L.call(null,n)}catch{return L.call(this,n)}}}(o)}}function p(o,t){this.fun=o,this.array=t}function s(){}P.nextTick=function(o){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];k.push(new p(o,t)),k.length!==1||A||g(v)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=s,P.addListener=s,P.once=s,P.off=s,P.removeListener=s,P.removeAllListeners=s,P.emit=s,P.prependListener=s,P.prependOnceListener=s,P.listeners=function(o){return[]},P.binding=function(o){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(o){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ae[124],Me([1,0,15,6]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function P(u){const l=u;return l?typeof l.read=="function":!1}e.$de=P;function F(u){const l=u;return l?[l.on,l.pause,l.resume,l.destroy].every(i=>typeof i=="function"):!1}e.$ee=F;function R(u){const l=u;return l?F(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$fe=R;function g(u,l){return new f(u,l)}e.$ge=g;class f{constructor(l,i){this.e=l,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(i=>i(l))}h(l){this.c.error.length===0?(0,S.$1)(l):this.c.error.slice(0).forEach(i=>i(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,i){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(l,i){if(this.a.destroyed)return;let $;switch(l){case"data":$=this.c.data;break;case"end":$=this.c.end;break;case"error":$=this.c.error;break}if($){const a=$.indexOf(i);a>=0&&$.splice(a,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach($=>$())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(u,l){const i=[];let $;for(;($=u.read())!==null;)i.push($);return l(i)}e.$he=k;function A(u,l,i){const $=[];let a;for(;(a=u.read())!==null&&$.length<i;)$.push(a);return a===null&&$.length>0?l($):{read:()=>{if($.length>0)return $.shift();if(typeof a<"u"){const c=a;return a=void 0,c}return u.read()}}}e.$ie=A;function D(u,l){return new Promise((i,$)=>{const a=[];h(u,{onData:c=>{l&&a.push(c)},onError:c=>{l?$(c):i(void 0)},onEnd:()=>{i(l?l(a):void 0)}})})}e.$je=D;function h(u,l,i){u.on("error",$=>{i?.isCancellationRequested||l.onError($)}),u.on("end",()=>{i?.isCancellationRequested||l.onEnd()}),u.on("data",$=>{i?.isCancellationRequested||l.onData($)})}e.$ke=h;function v(u,l){return new Promise((i,$)=>{const a=new L.$Sc,c=[],E=I=>{if(c.push(I),c.length>l)return a.dispose(),u.pause(),i({stream:u,buffer:c,ended:!1})},y=I=>(a.dispose(),$(I)),m=()=>(a.dispose(),i({stream:u,buffer:c,ended:!0}));a.add((0,L.$Rc)(()=>u.removeListener("error",y))),u.on("error",y),a.add((0,L.$Rc)(()=>u.removeListener("end",m))),u.on("end",m),a.add((0,L.$Rc)(()=>u.removeListener("data",E))),u.on("data",E)})}e.$le=v;function p(u,l){const i=g(l);return i.end(u),i}e.$me=p;function s(){const u=g(()=>{throw new Error("not supported")});return u.end(),u}e.$ne=s;function o(u){let l=!1;return{read:()=>l?null:(l=!0,u)}}e.$oe=o;function t(u,l,i){const $=g(i);return h(u,{onData:a=>$.write(l.data(a)),onError:a=>$.error(l.error?l.error(a):a),onEnd:()=>$.end()}),$}e.$pe=t;function n(u,l,i){let $=!1;return{read:()=>{const a=l.read();return $?a:($=!0,a!==null?i([u,a]):u)}}}e.$qe=n;function r(u,l,i){let $=!1;const a=g(i);return h(l,{onData:c=>$?a.write(c):($=!0,a.write(i([u,c]))),onError:c=>a.error(c),onEnd:()=>{$||($=!0,a.write(u)),a.end()}}),a}e.$re=r}),define(Ae[24],Me([1,0,39,124]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const P=typeof Buffer<"u",F=new S.$V(()=>new Uint8Array(256));let R,g;class f{static alloc(b){return P?new f(Buffer.allocUnsafe(b)):new f(new Uint8Array(b))}static wrap(b){return P&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new f(b)}static fromString(b,M){return!(M?.dontUseNodeBuffer||!1)&&P?new f(Buffer.from(b)):(R||(R=new TextEncoder),new f(R.encode(b)))}static fromByteArray(b){const M=f.alloc(b.length);for(let T=0,G=b.length;T<G;T++)M.buffer[T]=b[T];return M}static concat(b,M){if(typeof M>"u"){M=0;for(let W=0,U=b.length;W<U;W++)M+=b[W].byteLength}const T=f.alloc(M);let G=0;for(let W=0,U=b.length;W<U;W++){const C=b[W];T.set(C,G),G+=C.byteLength}return T}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=f.alloc(this.byteLength);return b.set(this),b}toString(){return P?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(b,M){return new f(this.buffer.subarray(b,M))}set(b,M){if(b instanceof f)this.buffer.set(b.buffer,M);else if(b instanceof Uint8Array)this.buffer.set(b,M);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),M);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return h(this.buffer,b)}writeUInt32BE(b,M){v(this.buffer,b,M)}readUInt32LE(b){return p(this.buffer,b)}writeUInt32LE(b,M){s(this.buffer,b,M)}readUInt8(b){return o(this.buffer,b)}writeUInt8(b,M){t(this.buffer,b,M)}indexOf(b,M=0){return k(this.buffer,b instanceof f?b.buffer:b,M)}}e.$se=f;function k(w,b,M=0){const T=b.byteLength,G=w.byteLength;if(T===0)return 0;if(T===1)return w.indexOf(b[0]);if(T>G-M)return-1;const W=F.value;W.fill(b.length);for(let V=0;V<b.length;V++)W[b[V]]=b.length-V-1;let U=M+b.length-1,C=U,O=-1;for(;U<G;)if(w[U]===b[C]){if(C===0){O=U;break}U--,C--}else U+=Math.max(b.length-C,W[w[U]]),C=b.length-1;return O}e.$te=k;function A(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0}e.$ue=A;function D(w,b,M){w[M+0]=b&255,b=b>>>8,w[M+1]=b&255}e.$ve=D;function h(w,b){return w[b]*2**24+w[b+1]*2**16+w[b+2]*2**8+w[b+3]}e.$we=h;function v(w,b,M){w[M+3]=b,b=b>>>8,w[M+2]=b,b=b>>>8,w[M+1]=b,b=b>>>8,w[M]=b}e.$xe=v;function p(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0|w[b+2]<<16>>>0|w[b+3]<<24>>>0}e.$ye=p;function s(w,b,M){w[M+0]=b&255,b=b>>>8,w[M+1]=b&255,b=b>>>8,w[M+2]=b&255,b=b>>>8,w[M+3]=b&255}e.$ze=s;function o(w,b){return w[b]}e.$Ae=o;function t(w,b,M){w[M]=b}e.$Be=t;function n(w){return L.$he(w,b=>f.concat(b))}e.$Ce=n;function r(w){return L.$oe(w)}e.$De=r;function u(w){return L.$je(w,b=>f.concat(b))}e.$Ee=u;async function l(w){return w.ended?f.concat(w.buffer):f.concat([...w.buffer,await u(w.stream)])}e.$Fe=l;function i(w){return L.$me(w,b=>f.concat(b))}e.$Ge=i;function $(w){return L.$pe(w,{data:b=>typeof b=="string"?f.fromString(b):f.wrap(b)},b=>f.concat(b))}e.$He=$;function a(w){return L.$ge(b=>f.concat(b),w)}e.$Ie=a;function c(w,b){return L.$qe(w,b,M=>f.concat(M))}e.$Je=c;function E(w,b){return L.$re(w,b,M=>f.concat(M))}e.$Ke=E;function y(w){let b=0,M=0,T=0;const G=new Uint8Array(Math.floor(w.length/4*3)),W=C=>{switch(M){case 3:G[T++]=b|C,M=0;break;case 2:G[T++]=b|C>>>2,b=C<<6,M=3;break;case 1:G[T++]=b|C>>>4,b=C<<4,M=2;break;default:b=C<<2,M=1}};for(let C=0;C<w.length;C++){const O=w.charCodeAt(C);if(O>=65&&O<=90)W(O-65);else if(O>=97&&O<=122)W(O-97+26);else if(O>=48&&O<=57)W(O-48+52);else if(O===43||O===45)W(62);else if(O===47||O===95)W(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${w[C]}`)}}const U=T;for(;M>0;)W(0);return f.wrap(G).slice(0,U)}e.$Le=y;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:w},b=!0,M=!1){const T=M?I:m;let G="";const W=w.byteLength%3;let U=0;for(;U<w.byteLength-W;U+=3){const C=w[U+0],O=w[U+1],V=w[U+2];G+=T[C>>>2],G+=T[(C<<4|O>>>4)&63],G+=T[(O<<2|V>>>6)&63],G+=T[V&63]}if(W===1){const C=w[U+0];G+=T[C>>>2],G+=T[C<<4&63],b&&(G+="==")}else if(W===2){const C=w[U+0],O=w[U+1];G+=T[C>>>2],G+=T[(C<<4|O>>>4)&63],G+=T[O<<2&63],b&&(G+="=")}return G}e.$Me=d}),define(Ae[125],Me([1,0,28,122,13]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.FuzzyScore=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.or=void 0;function F(...me){return function(Ie,Le){for(let ze=0,N=me.length;ze<N;ze++){const j=me[ze](Ie,Le);if(j)return j}return null}}e.or=F,e.$5j=R.bind(void 0,!1),e.$6j=R.bind(void 0,!0);function R(me,Ie,Le){if(!Le||Le.length<Ie.length)return null;let ze;return me?ze=P.$kf(Le,Ie):ze=Le.indexOf(Ie)===0,ze?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function g(me,Ie){const Le=Ie.toLowerCase().indexOf(me.toLowerCase());return Le===-1?null:[{start:Le,end:Le+me.length}]}e.$7j=g;function f(me,Ie){return k(me.toLowerCase(),Ie.toLowerCase(),0,0)}e.$8j=f;function k(me,Ie,Le,ze){if(Le===me.length)return[];if(ze===Ie.length)return null;if(me[Le]===Ie[ze]){let N=null;return(N=k(me,Ie,Le+1,ze+1))?u({start:ze,end:ze+1},N):null}return k(me,Ie,Le,ze+1)}function A(me){return 97<=me&&me<=122}function D(me){return 65<=me&&me<=90}e.$9j=D;function h(me){return 48<=me&&me<=57}function v(me){return me===32||me===9||me===10||me===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(me=>p.add(me.charCodeAt(0)));function s(me){return v(me)||p.has(me)}function o(me,Ie){return me===Ie||s(me)&&s(Ie)}const t=new Map;function n(me){if(t.has(me))return t.get(me);let Ie;const Le=(0,L.$3j)(me);return Le&&(Ie=Le),t.set(me,Ie),Ie}function r(me){return A(me)||D(me)||h(me)}function u(me,Ie){return Ie.length===0?Ie=[me]:me.end===Ie[0].start?Ie[0].start=me.start:Ie.unshift(me),Ie}function l(me,Ie){for(let Le=Ie;Le<me.length;Le++){const ze=me.charCodeAt(Le);if(D(ze)||h(ze)||Le>0&&!r(me.charCodeAt(Le-1)))return Le}return me.length}function i(me,Ie,Le,ze){if(Le===me.length)return[];if(ze===Ie.length)return null;if(me[Le]!==Ie[ze].toLowerCase())return null;{let N=null,j=ze+1;for(N=i(me,Ie,Le+1,ze+1);!N&&(j=l(Ie,j))<Ie.length;)N=i(me,Ie,Le+1,j),j++;return N===null?null:u({start:ze,end:ze+1},N)}}function $(me){let Ie=0,Le=0,ze=0,N=0,j=0;for(let Oe=0;Oe<me.length;Oe++)j=me.charCodeAt(Oe),D(j)&&Ie++,A(j)&&Le++,r(j)&&ze++,h(j)&&N++;const K=Ie/me.length,H=Le/me.length,te=ze/me.length,oe=N/me.length;return{upperPercent:K,lowerPercent:H,alphaPercent:te,numericPercent:oe}}function a(me){const{upperPercent:Ie,lowerPercent:Le}=me;return Le===0&&Ie>.6}function c(me){const{upperPercent:Ie,lowerPercent:Le,alphaPercent:ze,numericPercent:N}=me;return Le>.2&&Ie<.8&&ze>.6&&N<.2}function E(me){let Ie=0,Le=0,ze=0,N=0;for(let j=0;j<me.length;j++)ze=me.charCodeAt(j),D(ze)&&Ie++,A(ze)&&Le++,v(ze)&&N++;return(Ie===0||Le===0)&&N===0?me.length<=30:Ie<=5}function y(me,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!E(me))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Le=$(Ie);if(!c(Le)){if(!a(Le))return null;Ie=Ie.toLowerCase()}let ze=null,N=0;for(me=me.toLowerCase();N<Ie.length&&(ze=i(me,Ie,0,N))===null;)N=l(Ie,N+1);return ze}e.$0j=y;function m(me,Ie,Le=!1){if(!Ie||Ie.length===0)return null;let ze=null,N=0;for(me=me.toLowerCase(),Ie=Ie.toLowerCase();N<Ie.length&&(ze=I(me,Ie,0,N,Le),ze===null);)N=d(Ie,N+1);return ze}e.$$j=m;function I(me,Ie,Le,ze,N){let j=0;if(Le===me.length)return[];if(ze===Ie.length)return null;if(!o(me.charCodeAt(Le),Ie.charCodeAt(ze))){const te=n(me.charCodeAt(Le));if(!te)return null;for(let oe=0;oe<te.length;oe++)if(!o(te[oe],Ie.charCodeAt(ze+oe)))return null;j+=te.length-1}let K=null,H=ze+j+1;if(K=I(me,Ie,Le+1,H,N),!N)for(;!K&&(H=d(Ie,H))<Ie.length;)K=I(me,Ie,Le+1,H,N),H++;if(!K)return null;if(me.charCodeAt(Le)!==Ie.charCodeAt(ze)){const te=n(me.charCodeAt(Le));if(!te)return K;for(let oe=0;oe<te.length;oe++)if(te[oe]!==Ie.charCodeAt(ze+oe))return K}return u({start:ze,end:ze+j+1},K)}function d(me,Ie){for(let Le=Ie;Le<me.length;Le++)if(s(me.charCodeAt(Le))||Le>0&&s(me.charCodeAt(Le-1)))return Le;return me.length}const w=F(e.$6j,y,g),b=F(e.$6j,y,f),M=new S.$Dc(1e4);function T(me,Ie,Le=!1){if(typeof me!="string"||typeof Ie!="string")return null;let ze=M.get(me);ze||(ze=new RegExp(P.$5e(me),"i"),M.set(me,ze));const N=ze.exec(Ie);return N?[{start:N.index,end:N.index+N[0].length}]:Le?b(me,Ie):w(me,Ie)}e.$_j=T;function G(me,Ie){const Le=be(me,me.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Le?U(Le):null}e.$ak=G;function W(me,Ie,Le,ze,N,j){const K=Math.min(13,me.length);for(;Le<K;Le++){const H=be(me,Ie,Le,ze,N,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,j]}e.$bk=W;function U(me){if(typeof me>"u")return[];const Ie=[],Le=me[1];for(let ze=me.length-1;ze>1;ze--){const N=me[ze]+Le,j=Ie[Ie.length-1];j&&j.end===N?j.end=N+1:Ie.push({start:N,end:N+1})}return Ie}e.$ck=U;const C=128;function O(){const me=[],Ie=[];for(let Le=0;Le<=C;Le++)Ie[Le]=0;for(let Le=0;Le<=C;Le++)me.push(Ie.slice(0));return me}function V(me){const Ie=[];for(let Le=0;Le<=me;Le++)Ie[Le]=0;return Ie}const re=V(2*C),ce=V(2*C),ye=O(),De=O(),he=O(),ve=!1;function se(me,Ie,Le,ze,N){function j(H,te,oe=" "){for(;H.length<te;)H=oe+H;return H}let K=` |   |${ze.split("").map(H=>j(H,3)).join("|")}
`;for(let H=0;H<=Le;H++)H===0?K+=" |":K+=`${Ie[H-1]}|`,K+=me[H].slice(0,N+1).map(te=>j(te.toString(),3)).join("|")+`
`;return K}function $e(me,Ie,Le,ze){me=me.substr(Ie),Le=Le.substr(ze),console.log(se(De,me,me.length,Le,Le.length)),console.log(se(he,me,me.length,Le,Le.length)),console.log(se(ye,me,me.length,Le,Le.length))}function ee(me,Ie){if(Ie<0||Ie>=me.length)return!1;const Le=me.codePointAt(Ie);switch(Le){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.$Cf(Le)}}function Y(me,Ie){if(Ie<0||Ie>=me.length)return!1;switch(me.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function q(me,Ie,Le){return Ie[me]!==Le[me]}function ne(me,Ie,Le,ze,N,j,K=!1){for(;Ie<Le&&N<j;)me[Ie]===ze[N]&&(K&&(re[Ie]=N),Ie+=1),N+=1;return Ie===Le}e.$dk=ne;var Se;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Te;(function(me){me.Default=[-100,0];function Ie(Le){return!Le||Le.length===2&&Le[0]===-100&&Le[1]===0}me.isDefault=Ie})(Te||(e.FuzzyScore=Te={}));class Ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Le){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Le}}e.$ek=Ce;function be(me,Ie,Le,ze,N,j,K=Ce.default){const H=me.length>C?C:me.length,te=ze.length>C?C:ze.length;if(Le>=H||j>=te||H-Le>te-j||!ne(Ie,Le,H,N,j,te,!0))return;ge(H,te,Le,j,Ie,N);let oe=1,Oe=1,Ve=Le,He=j;const xe=[!1];for(oe=1,Ve=Le;Ve<H;oe++,Ve++){const ot=re[Ve],Be=ce[Ve],et=Ve+1<H?ce[Ve+1]:te;for(Oe=ot-j+1,He=ot;He<et;Oe++,He++){let Q=Number.MIN_SAFE_INTEGER,Z=!1;He<=Be&&(Q=X(me,Ie,Ve,Le,ze,N,He,te,j,ye[oe-1][Oe-1]===0,xe));let pe=0;Q!==Number.MAX_SAFE_INTEGER&&(Z=!0,pe=Q+De[oe-1][Oe-1]);const We=He>ot,Ye=We?De[oe][Oe-1]+(ye[oe][Oe-1]>0?-5:0):0,st=He>ot+1&&ye[oe][Oe-1]>0,Fe=st?De[oe][Oe-2]+(ye[oe][Oe-2]>0?-5:0):0;if(st&&(!We||Fe>=Ye)&&(!Z||Fe>=pe))De[oe][Oe]=Fe,he[oe][Oe]=3,ye[oe][Oe]=0;else if(We&&(!Z||Ye>=pe))De[oe][Oe]=Ye,he[oe][Oe]=2,ye[oe][Oe]=0;else if(Z)De[oe][Oe]=pe,he[oe][Oe]=1,ye[oe][Oe]=ye[oe-1][Oe-1]+1;else throw new Error("not possible")}}if(ve&&$e(me,Le,ze,j),!xe[0]&&!K.firstMatchCanBeWeak)return;oe--,Oe--;const tt=[De[oe][Oe],j];let lt=0,rt=0;for(;oe>=1;){let ot=Oe;do{const Be=he[oe][ot];if(Be===3)ot=ot-2;else if(Be===2)ot=ot-1;else break}while(ot>=1);lt>1&&Ie[Le+oe-1]===N[j+Oe-1]&&!q(ot+j-1,ze,N)&&lt+1>ye[oe][ot]&&(ot=Oe),ot===Oe?lt++:lt=1,rt||(rt=ot),oe--,Oe=ot-1,tt.push(Oe)}te===H&&K.boostFullMatch&&(tt[0]+=2);const it=rt-H;return tt[0]-=it,tt}e.$fk=be;function ge(me,Ie,Le,ze,N,j){let K=me-1,H=Ie-1;for(;K>=Le&&H>=ze;)N[K]===j[H]&&(ce[K]=H,K--),H--}function X(me,Ie,Le,ze,N,j,K,H,te,oe,Oe){if(Ie[Le]!==j[K])return Number.MIN_SAFE_INTEGER;let Ve=1,He=!1;return K===Le-ze?Ve=me[Le]===N[K]?7:5:q(K,N,j)&&(K===0||!q(K-1,N,j))?(Ve=me[Le]===N[K]?7:5,He=!0):ee(j,K)&&(K===0||!ee(j,K-1))?Ve=5:(ee(j,K-1)||Y(j,K-1))&&(Ve=5,He=!0),Ve>1&&Le===ze&&(Oe[0]=!0),He||(He=q(K,N,j)||ee(j,K-1)||Y(j,K-1)),Le===ze?K>te&&(Ve-=He?3:5):oe?Ve+=He?2:0:Ve+=He?0:1,K+1===H&&(Ve-=He?3:5),Ve}function x(me,Ie,Le,ze,N,j,K){return de(me,Ie,Le,ze,N,j,!0,K)}e.$gk=x;function le(me,Ie,Le,ze,N,j,K){return de(me,Ie,Le,ze,N,j,!1,K)}e.$hk=le;function de(me,Ie,Le,ze,N,j,K,H){let te=be(me,Ie,Le,ze,N,j,H);if(te&&!K)return te;if(me.length>=3){const oe=Math.min(7,me.length-1);for(let Oe=Le+1;Oe<oe;Oe++){const Ve=Pe(me,Oe);if(Ve){const He=be(Ve,Ve.toLowerCase(),Le,ze,N,j,H);He&&(He[0]-=3,(!te||He[0]>te[0])&&(te=He))}}}return te}function Pe(me,Ie){if(Ie+1>=me.length)return;const Le=me[Ie],ze=me[Ie+1];if(Le!==ze)return me.slice(0,Ie)+ze+Le+me.slice(Ie+2)}}),define(Ae[32],Me([1,0,13]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(L||(L={})),function(P){const F="error",R="warning",g="warn",f="info",k="ignore";function A(h){return h?S.$jf(F,h)?P.Error:S.$jf(R,h)||S.$jf(g,h)?P.Warning:S.$jf(f,h)?P.Info:P.Ignore:P.Ignore}P.fromValue=A;function D(h){switch(h){case P.Error:return F;case P.Warning:return R;case P.Info:return f;default:return k}}P.toString=D}(L||(L={})),e.default=L}),define(Ae[126],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0,e.$2d=Symbol("MicrotaskDelay")}),define(Ae[51],Me([1,0,18,13]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=void 0;class P{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const p=v.charCodeAt(0),s=this.b.charCodeAt(this.c);return p-s}value(){return this.b[this.c]}}e.$gi=P;class F{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,L.$df)(v,this.b,0,v.length,this.c,this.d):(0,L.$ff)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$hi=F;class R{constructor(v=!0,p=!0){this.f=v,this.g=p}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let p=v.length-1;p>=0;p--,this.c--){const s=this.b.charCodeAt(p);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,L.$df)(v,this.b,0,v.length,this.d,this.e):(0,L.$ff)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ii=R;var g;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(g||(g={}));class f{constructor(v,p){this.f=v,this.g=p,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,L.$ef)(v,this.c.scheme);if(this.d[this.e]===2)return(0,L.$ef)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,L.$cf)(v,this.c.query);if(this.d[this.e]===5)return(0,L.$cf)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ji=f;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(A||(A={}));class D{static forUris(v=()=>!1,p=()=>!1){return new D(new f(v,p))}static forPaths(v=!1){return new D(new R(void 0,!v))}static forStrings(){return new D(new P)}static forConfigKeys(){return new D(new F)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,p){if(p){const s=p.slice(0);(0,S.$Xb)(s);for(const o of s)this.set(o,v)}else{const s=v.slice(0);(0,S.$Xb)(s);for(const o of s)this.set(o[0],o[1])}}set(v,p){const s=this.b.reset(v);let o;this.c||(this.c=new k,this.c.segment=s.value());const t=[];for(o=this.c;;){const r=s.cmp(o.segment);if(r>0)o.left||(o.left=new k,o.left.segment=s.value()),t.push([-1,o]),o=o.left;else if(r<0)o.right||(o.right=new k,o.right.segment=s.value()),t.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new k,o.mid.segment=s.value()),t.push([0,o]),o=o.mid;else break}const n=o.value;o.value=p,o.key=v;for(let r=t.length-1;r>=0;r--){const u=t[r][1];u.updateHeight();const l=u.balanceFactor();if(l<-1||l>1){const i=t[r][0],$=t[r+1][0];if(i===1&&$===1)t[r][1]=u.rotateLeft();else if(i===-1&&$===-1)t[r][1]=u.rotateRight();else if(i===1&&$===-1)u.right=t[r+1][1]=t[r+1][1].rotateRight(),t[r][1]=u.rotateLeft();else if(i===-1&&$===1)u.left=t[r+1][1]=t[r+1][1].rotateLeft(),t[r][1]=u.rotateRight();else throw new Error;if(r>0)switch(t[r-1][0]){case-1:t[r-1][1].left=t[r][1];break;case 1:t[r-1][1].right=t[r][1];break;case 0:t[r-1][1].mid=t[r][1];break}else this.c=t[0][1]}}return n}get(v){return this.d(v)?.value}d(v){const p=this.b.reset(v);let s=this.c;for(;s;){const o=p.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(p.hasNext())p.next(),s=s.mid;else break}return s}has(v){const p=this.d(v);return!(p?.value===void 0&&p?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,p){const s=this.b.reset(v),o=[];let t=this.c;for(;t;){const n=s.cmp(t.segment);if(n>0)o.push([-1,t]),t=t.left;else if(n<0)o.push([1,t]),t=t.right;else if(s.hasNext())s.next(),o.push([0,t]),t=t.mid;else break}if(t){if(p?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this.f(t.right);if(n.key){const{key:r,value:u,segment:l}=n;this.e(n.key,!1),t.key=r,t.value=u,t.segment=l}}else{const n=t.left??t.right;if(o.length>0){const[r,u]=o[o.length-1];switch(r){case-1:u.left=n;break;case 0:u.mid=n;break;case 1:u.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const r=o[n][1];r.updateHeight();const u=r.balanceFactor();if(u>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),o[n][1]=r.rotateLeft()):u<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),o[n][1]=r.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const p=this.b.reset(v);let s=this.c,o;for(;s;){const t=p.cmp(s.segment);if(t>0)s=s.left;else if(t<0)s=s.right;else if(p.hasNext())p.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(v){return this.g(v,!1)}g(v,p){const s=this.b.reset(v);let o=this.c;for(;o;){const t=s.cmp(o.segment);if(t>0)o=o.left;else if(t<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):p?o.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[p,s]of this)v(s,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const p=[];return this.j(v,p),p[Symbol.iterator]()}j(v,p){v&&(v.left&&this.j(v.left,p),v.value&&p.push([v.key,v.value]),v.mid&&this.j(v.mid,p),v.right&&this.j(v.right,p))}_isBalanced(){const v=p=>{if(!p)return!0;const s=p.balanceFactor();return s<-1||s>1?!1:v(p.left)&&v(p.right)};return v(this.c)}}e.$ki=D}),define(Ae[40],Me([1,0,89]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$lk=e.ThemeColor=void 0;var L;(function(R){function g(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=g})(L||(e.ThemeColor=L={}));function P(R){return{id:R}}e.$lk=P;var F;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(n){const r=g.exec(n.id);if(!r)return f(S.$kk.error);const[,u,l]=r,i=["codicon","codicon-"+u];return l&&i.push("codicon-modifier-"+l.substring(1)),i}R.asClassNameArray=f;function k(n){return f(n).join(" ")}R.asClassName=k;function A(n){return"."+f(n).join(".")}R.asCSSSelector=A;function D(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}R.isThemeIcon=D;const h=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(n){const r=h.exec(n);if(!r)return;const[,u]=r;return{id:u}}R.fromString=v;function p(n){return{id:n}}R.fromId=p;function s(n,r){let u=n.id;const l=u.lastIndexOf("~");return l!==-1&&(u=u.substring(0,l)),r&&(u=`${u}~${r}`),{id:u}}R.modify=s;function o(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}R.getModifier=o;function t(n,r){return n.id===r.id&&n.color?.id===r.color?.id}R.isEqual=t})(F||(e.ThemeIcon=F={}))}),define(Ae[127],Me([1,0,125,13,40]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=void 0;const F="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${R.source}`,"g");function f(t){return t.replace(g,(n,r)=>r?n:`\\${n}`)}e.$mk=f;const k=new RegExp(`\\\\${R.source}`,"g");function A(t){return t.replace(k,n=>`\\${n}`)}e.$nk=A;const D=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function h(t){return t.indexOf(F)===-1?t:t.replace(D,(n,r,u,l)=>u?n:r||l||"")}e.$ok=h;function v(t){return t?t.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}e.$pk=v;const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(t){p.lastIndex=0;let n="";const r=[];let u=0;for(;;){const l=p.lastIndex,i=p.exec(t),$=t.substring(l,i?.index);if($.length>0){n+=$;for(let a=0;a<$.length;a++)r.push(u)}if(!i)break;u+=i[0].length}return{text:n,iconOffsets:r}}e.$qk=s;function o(t,n,r=!1){const{text:u,iconOffsets:l}=n;if(!l||l.length===0)return(0,S.$_j)(t,u,r);const i=(0,L.$3e)(u," "),$=u.length-i.length,a=(0,S.$_j)(t,i,r);if(a)for(const c of a){const E=l[c.start+$]+$;c.start+=E,c.end+=E}return a}e.$rk=o}),define(Ae[33],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ag=e.$zg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(P){return S.test(P)}e.$zg=L,e.$Ag=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(g){for(let f=0;f<g.length;f++)g[f]=Math.floor(Math.random()*256);return g};const F=new Uint8Array(16),R=[];for(let g=0;g<256;g++)R.push(g.toString(16).padStart(2,"0"));return function(){P(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let f=0,k="";return k+=R[F[f++]],k+=R[F[f++]],k+=R[F[f++]],k+=R[F[f++]],k+="-",k+=R[F[f++]],k+=R[F[f++]],k+="-",k+=R[F[f++]],k+=R[F[f++]],k+="-",k+=R[F[f++]],k+=R[F[f++]],k+="-",k+=R[F[f++]],k+=R[F[f++]],k+=R[F[f++]],k+=R[F[f++]],k+=R[F[f++]],k+=R[F[f++]],k}}()}),define(Ae[128],Me([1,0,18,68,33]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.$Bt=e.$At=e.$zt=e.$yt=void 0;function F(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$yt=F;function R(D,h,v){const p={id:(0,P.$Ag)(),name:D,uri:h,data:v};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$zt=R;class g{constructor(){this.a=new Map}get size(){let h=0;for(const v of this.a)h++;return h}has(h){return this.a.has(this.b(h))}matches(h){const v=[...this.a.keys()];return L.Iterable.some(this,([p,s])=>s.asFile())&&v.push("files"),A(f(h),v)}get(h){return this.a.get(this.b(h))?.[0]}append(h,v){const p=this.a.get(h);p?p.push(v):this.a.set(this.b(h),[v])}replace(h,v){this.a.set(this.b(h),[v])}delete(h){this.a.delete(this.b(h))}*[Symbol.iterator](){for(const[h,v]of this.a)for(const p of v)yield[h,p]}b(h){return f(h)}}e.$At=g;function f(D){return D.toLowerCase()}function k(D,h){return A(f(D),h.map(f))}e.$Bt=k;function A(D,h){if(D==="*/*")return h.length>0;if(h.includes(D))return!0;const v=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[p,s,o]=v;return o==="*"?h.some(t=>t.startsWith(s+"/")):!1}e.$Ct=Object.freeze({create:D=>(0,S.$Mb)(D.map(h=>h.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Ct.split(D).filter(h=>!h.startsWith("#"))})}),define(Ae[129],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.StringEOL=void 0;var S;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function L(P){let F=0,R=0,g=0,f=0;for(let k=0,A=P.length;k<A;k++){const D=P.charCodeAt(k);D===13?(F===0&&(R=k),F++,k+1<A&&P.charCodeAt(k+1)===10?(f|=2,k++):f|=3,g=k+1):D===10&&(f|=1,F===0&&(R=k),F++,g=k+1)}return F===0&&(R=P.length),[F,R,P.length-g,f]}e.$Ft=L}),define(Ae[130],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=void 0,e.$Ds={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[131],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5t=e.$4t=e.IndentAction=void 0;var S;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class L{constructor(g){if(this.e=null,this.f=!1,this.open=g.open,this.close=g.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(g.notIn))for(let f=0,k=g.notIn.length;f<k;f++)switch(g.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(g,f){if(g.getTokenCount()===0)return!0;const k=g.findTokenIndexAtOffset(f-2),A=g.getStandardTokenType(k);return this.isOK(A)}g(g,f){for(let k=g;k<=f;k++){const A=String.fromCharCode(k);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$4t=L;class P{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of g)F(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),F(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),F(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),F(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&F(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$5t=P;function F(R,g,f){R.has(g)?R.get(g).push(f):R.set(g,[f])}}),define(Ae[132],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=e.$8B=e.$7B=e.$6B=e.NodeColor=e.$5B=void 0;class S{constructor(o,t){this.piece=o,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$6B)return P(this.right);let o=this;for(;o.parent!==e.$6B&&o.parent.left!==o;)o=o.parent;return o.parent===e.$6B?e.$6B:o.parent}prev(){if(this.left!==e.$6B)return F(this.left);let o=this;for(;o.parent!==e.$6B&&o.parent.right!==o;)o=o.parent;return o.parent===e.$6B?e.$6B:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$5B=S;var L;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$6B=new S(null,0),e.$6B.parent=e.$6B,e.$6B.left=e.$6B,e.$6B.right=e.$6B,e.$6B.color=0;function P(s){for(;s.left!==e.$6B;)s=s.left;return s}e.$7B=P;function F(s){for(;s.right!==e.$6B;)s=s.right;return s}e.$8B=F;function R(s){return s===e.$6B?0:s.size_left+s.piece.length+R(s.right)}function g(s){return s===e.$6B?0:s.lf_left+s.piece.lineFeedCnt+g(s.right)}function f(){e.$6B.parent=e.$6B}function k(s,o){const t=o.right;t.size_left+=o.size_left+(o.piece?o.piece.length:0),t.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=t.left,t.left!==e.$6B&&(t.left.parent=o),t.parent=o.parent,o.parent===e.$6B?s.root=t:o.parent.left===o?o.parent.left=t:o.parent.right=t,t.left=o,o.parent=t}e.$9B=k;function A(s,o){const t=o.left;o.left=t.right,t.right!==e.$6B&&(t.right.parent=o),t.parent=o.parent,o.size_left-=t.size_left+(t.piece?t.piece.length:0),o.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),o.parent===e.$6B?s.root=t:o===o.parent.right?o.parent.right=t:o.parent.left=t,t.right=o,o.parent=t}e.$0B=A;function D(s,o){let t,n;if(o.left===e.$6B?(n=o,t=n.right):o.right===e.$6B?(n=o,t=n.left):(n=P(o.right),t=n.right),n===s.root){s.root=t,t.color=0,o.detach(),f(),s.root.parent=e.$6B;return}const r=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===o?(t.parent=n.parent,p(s,t)):(n.parent===o?t.parent=n:t.parent=n.parent,p(s,t),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===s.root?s.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$6B&&(n.left.parent=n),n.right!==e.$6B&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,p(s,n)),o.detach(),t.parent.left===t){const l=R(t),i=g(t);if(l!==t.parent.size_left||i!==t.parent.lf_left){const $=l-t.parent.size_left,a=i-t.parent.lf_left;t.parent.size_left=l,t.parent.lf_left=i,v(s,t.parent,$,a)}}if(p(s,t.parent),r){f();return}let u;for(;t!==s.root&&t.color===0;)t===t.parent.left?(u=t.parent.right,u.color===1&&(u.color=0,t.parent.color=1,k(s,t.parent),u=t.parent.right),u.left.color===0&&u.right.color===0?(u.color=1,t=t.parent):(u.right.color===0&&(u.left.color=0,u.color=1,A(s,u),u=t.parent.right),u.color=t.parent.color,t.parent.color=0,u.right.color=0,k(s,t.parent),t=s.root)):(u=t.parent.left,u.color===1&&(u.color=0,t.parent.color=1,A(s,t.parent),u=t.parent.left),u.left.color===0&&u.right.color===0?(u.color=1,t=t.parent):(u.left.color===0&&(u.right.color=0,u.color=1,k(s,u),u=t.parent.left),u.color=t.parent.color,t.parent.color=0,u.left.color=0,A(s,t.parent),t=s.root));t.color=0,f()}e.$$B=D;function h(s,o){for(p(s,o);o!==s.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const t=o.parent.parent.right;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,k(s,o)),o.parent.color=0,o.parent.parent.color=1,A(s,o.parent.parent))}else{const t=o.parent.parent.left;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,A(s,o)),o.parent.color=0,o.parent.parent.color=1,k(s,o.parent.parent))}s.root.color=0}e.$_B=h;function v(s,o,t,n){for(;o!==s.root&&o!==e.$6B;)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=n),o=o.parent}e.$aC=v;function p(s,o){let t=0,n=0;if(o!==s.root){for(;o!==s.root&&o===o.parent.right;)o=o.parent;if(o!==s.root)for(o=o.parent,t=R(o.left)-o.size_left,n=g(o.left)-o.lf_left,o.size_left+=t,o.lf_left+=n;o!==s.root&&(t!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=n),o=o.parent}}e.$bC=p}),define(Ae[90],Me([1,0,91,29,92,132,93]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=e.$lC=e.$kC=e.$jC=e.$iC=void 0;const g=65535;function f(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class k{constructor(n,r,u,l,i){this.lineStarts=n,this.cr=r,this.lf=u,this.crlf=l,this.isBasicASCII=i}}function A(t,n=!0){const r=[0];let u=1;for(let l=0,i=t.length;l<i;l++){const $=t.charCodeAt(l);$===13?l+1<i&&t.charCodeAt(l+1)===10?(r[u++]=l+2,l++):r[u++]=l+1:$===10&&(r[u++]=l+1)}return n?f(r):r}e.$iC=A;function D(t,n){t.length=0,t[0]=0;let r=1,u=0,l=0,i=0,$=!0;for(let c=0,E=n.length;c<E;c++){const y=n.charCodeAt(c);y===13?c+1<E&&n.charCodeAt(c+1)===10?(i++,t[r++]=c+2,c++):(u++,t[r++]=c+1):y===10?(l++,t[r++]=c+1):$&&y!==9&&(y<32||y>126)&&($=!1)}const a=new k(f(t),u,l,i,$);return t.length=0,a}e.$jC=D;class h{constructor(n,r,u,l,i){this.bufferIndex=n,this.start=r,this.end=u,this.lineFeedCnt=l,this.length=i}}e.$kC=h;class v{constructor(n,r){this.buffer=n,this.lineStarts=r}}e.$lC=v;class p{constructor(n,r){this.a=[],this.c=n,this.d=r,this.b=0,n.root!==F.$6B&&n.iterate(n.root,u=>(u!==F.$6B&&this.a.push(u.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(n){this.a=n,this.b=[]}get(n){for(let r=this.b.length-1;r>=0;r--){const u=this.b[r];if(u.nodeStartOffset<=n&&u.nodeStartOffset+u.node.piece.length>=n)return u}return null}get2(n){for(let r=this.b.length-1;r>=0;r--){const u=this.b[r];if(u.nodeStartLineNumber&&u.nodeStartLineNumber<n&&u.nodeStartLineNumber+u.node.piece.lineFeedCnt>=n)return u}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let r=!1;const u=this.b;for(let l=0;l<u.length;l++){const i=u[l];if(i.node.parent===null||i.nodeStartOffset>=n){u[l]=null,r=!0;continue}}if(r){const l=[];for(const i of u)i!==null&&l.push(i);this.b=l}}}class o{constructor(n,r,u){this.create(n,r,u)}create(n,r,u){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=F.$6B,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=u;let l=null;for(let i=0,$=n.length;i<$;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=A(n[i].buffer));const a=new h(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),l=this.S(l,a)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const r=g,u=r-Math.floor(r/3),l=u*2;let i="",$=0;const a=[];if(this.iterate(this.root,c=>{const E=this.R(c),y=E.length;if($<=u||$+y<l)return i+=E,$+=y,!0;const m=i.replace(/\r\n|\r|\n/g,n);return a.push(new v(m,A(m))),i=E,$=y,!0}),$>0){const c=i.replace(/\r\n|\r|\n/g,n);a.push(new v(c,A(c)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new p(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let r=0;return this.iterate(this.root,l=>{if(l===F.$6B)return!0;const i=this.R(l),$=i.length,a=n.G(r),c=n.G(r+$),E=n.getValueInRange2(a,c);return r+=$,i===E})}getOffsetAt(n,r){let u=0,l=this.root;for(;l!==F.$6B;)if(l.left!==F.$6B&&l.lf_left+1>=n)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=n){u+=l.size_left;const i=this.B(l,n-l.lf_left-2);return u+=i+r-1}else n-=l.lf_left+l.piece.lineFeedCnt,u+=l.size_left+l.piece.length,l=l.right;return u}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let r=this.root,u=0;const l=n;for(;r!==F.$6B;)if(r.size_left!==0&&r.size_left>=n)r=r.left;else if(r.size_left+r.piece.length>=n){const i=this.A(r,n-r.size_left);if(u+=r.lf_left+i.index,i.index===0){const $=this.getOffsetAt(u+1,1),a=l-$;return new S.$5s(u+1,a+1)}return new S.$5s(u+1,i.remainder+1)}else if(n-=r.size_left+r.piece.length,u+=r.lf_left+r.piece.lineFeedCnt,r.right===F.$6B){const i=this.getOffsetAt(u+1,1),$=l-n-i;return new S.$5s(u+1,$+1)}else r=r.right;return new S.$5s(1,1)}getValueInRange(n,r){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const u=this.H(n.startLineNumber,n.startColumn),l=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(u,l);return r?r!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,r):i}getValueInRange2(n,r){if(n.node===r.node){const a=n.node,c=this.a[a.piece.bufferIndex].buffer,E=this.u(a.piece.bufferIndex,a.piece.start);return c.substring(E+n.remainder,E+r.remainder)}let u=n.node;const l=this.a[u.piece.bufferIndex].buffer,i=this.u(u.piece.bufferIndex,u.piece.start);let $=l.substring(i+n.remainder,i+u.piece.length);for(u=u.next();u!==F.$6B;){const a=this.a[u.piece.bufferIndex].buffer,c=this.u(u.piece.bufferIndex,u.piece.start);if(u===r.node){$+=a.substring(c,c+r.remainder);break}else $+=a.substr(c,u.piece.length);u=u.next()}return $}getLinesContent(){const n=[];let r=0,u="",l=!1;return this.iterate(this.root,i=>{if(i===F.$6B)return!0;const $=i.piece;let a=$.length;if(a===0)return!0;const c=this.a[$.bufferIndex].buffer,E=this.a[$.bufferIndex].lineStarts,y=$.start.line,m=$.end.line;let I=E[y]+$.start.column;if(l&&(c.charCodeAt(I)===10&&(I++,a--),n[r++]=u,u="",l=!1,a===0))return!0;if(y===m)return!this.f&&c.charCodeAt(I+a-1)===13?(l=!0,u+=c.substr(I,a-1)):u+=c.substr(I,a),!0;u+=this.f?c.substring(I,Math.max(I,E[y+1]-this.e)):c.substring(I,E[y+1]).replace(/(\r\n|\r|\n)$/,""),n[r++]=u;for(let d=y+1;d<m;d++)u=this.f?c.substring(E[d],E[d+1]-this.e):c.substring(E[d],E[d+1]).replace(/(\r\n|\r|\n)$/,""),n[r++]=u;return!this.f&&c.charCodeAt(E[m]+$.end.column-1)===13?(l=!0,$.end.column===0?r--:u=c.substr(E[m],$.end.column-1)):u=c.substr(E[m],$.end.column),!0}),l&&(n[r++]=u,u=""),n[r++]=u,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const r=n.node.next();if(!r)return 0;const u=this.a[r.piece.bufferIndex],l=this.u(r.piece.bufferIndex,r.piece.start);return u.buffer.charCodeAt(l)}else{const r=this.a[n.node.piece.bufferIndex],l=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return r.buffer.charCodeAt(l)}}getLineCharCode(n,r){const u=this.H(n,r+1);return this.l(u)}getLineLength(n){if(n===this.getLineCount()){const r=this.getOffsetAt(n,1);return this.getLength()-r}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const r=this.G(n);return this.l(r)}findMatchesInNode(n,r,u,l,i,$,a,c,E,y,m){const I=this.a[n.piece.bufferIndex],d=this.u(n.piece.bufferIndex,n.piece.start),w=this.u(n.piece.bufferIndex,i),b=this.u(n.piece.bufferIndex,$);let M;const T={line:0,column:0};let G,W;r._wordSeparators?(G=I.buffer.substring(w,b),W=U=>U+w,r.reset(0)):(G=I.buffer,W=U=>U,r.reset(w));do if(M=r.next(G),M){if(W(M.index)>=b)return y;this.s(n,W(M.index)-d,T);const U=this.t(n.piece.bufferIndex,i,T),C=T.line===i.line?T.column-i.column+l:T.column+1,O=C+M[0].length;if(m[y++]=(0,R.$eC)(new L.$6s(u+U,C,u+U,O),M,c),W(M.index)+M[0].length>=b||y>=E)return y}while(M);return y}findMatchesLineByLine(n,r,u,l){const i=[];let $=0;const a=new R.$hC(r.wordSeparators,r.regex);let c=this.H(n.startLineNumber,n.startColumn);if(c===null)return[];const E=this.H(n.endLineNumber,n.endColumn);if(E===null)return[];let y=this.s(c.node,c.remainder);const m=this.s(E.node,E.remainder);if(c.node===E.node)return this.findMatchesInNode(c.node,a,n.startLineNumber,n.startColumn,y,m,r,u,l,$,i),i;let I=n.startLineNumber,d=c.node;for(;d!==E.node;){const b=this.t(d.piece.bufferIndex,y,d.piece.end);if(b>=1){const T=this.a[d.piece.bufferIndex].lineStarts,G=this.u(d.piece.bufferIndex,d.piece.start),W=T[y.line+b],U=I===n.startLineNumber?n.startColumn:1;if($=this.findMatchesInNode(d,a,I,U,y,this.s(d,W-G),r,u,l,$,i),$>=l)return i;I+=b}const M=I===n.startLineNumber?n.startColumn-1:0;if(I===n.endLineNumber){const T=this.getLineContent(I).substring(M,n.endColumn-1);return $=this.n(r,a,T,n.endLineNumber,M,$,i,u,l),i}if($=this.n(r,a,this.getLineContent(I).substr(M),I,M,$,i,u,l),$>=l)return i;I++,c=this.H(I,1),d=c.node,y=this.s(c.node,c.remainder)}if(I===n.endLineNumber){const b=I===n.startLineNumber?n.startColumn-1:0,M=this.getLineContent(I).substring(b,n.endColumn-1);return $=this.n(r,a,M,n.endLineNumber,b,$,i,u,l),i}const w=I===n.startLineNumber?n.startColumn:1;return $=this.findMatchesInNode(E.node,a,I,w,y,m,r,u,l,$,i),i}n(n,r,u,l,i,$,a,c,E){const y=n.wordSeparators;if(!c&&n.simpleSearch){const I=n.simpleSearch,d=I.length,w=u.length;let b=-d;for(;(b=u.indexOf(I,b+d))!==-1;)if((!y||(0,R.$gC)(y,u,w,b,d))&&(a[$++]=new P.$mv(new L.$6s(l,b+1+i,l,b+1+d+i),null),$>=E))return $;return $}let m;r.reset(0);do if(m=r.next(u),m&&(a[$++]=(0,R.$eC)(new L.$6s(l,m.index+1+i,l,m.index+1+m[0].length+i),m,c),$>=E))return $;while(m);return $}insert(n,r,u=!1){if(this.f=this.f&&u,this.j.lineNumber=0,this.j.value="",this.root!==F.$6B){const{node:l,remainder:i,nodeStartOffset:$}=this.G(n),a=l.piece,c=a.bufferIndex,E=this.s(l,i);if(l.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&$+a.length===n&&r.length<g){this.F(l,r),this.y();return}if($===n)this.o(r,l),this.h.validate(n);else if($+l.piece.length>n){const y=[];let m=new h(a.bufferIndex,E,a.end,this.t(a.bufferIndex,E,a.end),this.u(c,a.end)-this.u(c,E));if(this.K()&&this.M(r)&&this.I(l,i)===10){const b={line:m.start.line+1,column:0};m=new h(m.bufferIndex,b,m.end,this.t(m.bufferIndex,b,m.end),m.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(l,i-1)===13){const b=this.s(l,i-1);this.C(l,b),r="\r"+r,l.piece.length===0&&y.push(l)}else this.C(l,E);else this.C(l,E);const I=this.w(r);m.length>0&&this.S(l,m);let d=l;for(let w=0;w<I.length;w++)d=this.S(d,I[w]);this.v(y)}else this.q(r,l)}else{const l=this.w(r);let i=this.T(null,l[0]);for(let $=1;$<l.length;$++)i=this.S(i,l[$])}this.y()}delete(n,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===F.$6B)return;const u=this.G(n),l=this.G(n+r),i=u.node,$=l.node;if(i===$){const I=this.s(i,u.remainder),d=this.s(i,l.remainder);if(u.nodeStartOffset===n){if(r===i.piece.length){const w=i.next();(0,F.$$B)(this,i),this.N(w),this.y();return}this.D(i,d),this.h.validate(n),this.N(i),this.y();return}if(u.nodeStartOffset+i.piece.length===n+r){this.C(i,I),this.O(i),this.y();return}this.E(i,I,d),this.y();return}const a=[],c=this.s(i,u.remainder);this.C(i,c),this.h.validate(n),i.piece.length===0&&a.push(i);const E=this.s($,l.remainder);this.D($,E),$.piece.length===0&&a.push($);const y=i.next();for(let I=y;I!==F.$6B&&I!==$;I=I.next())a.push(I);const m=i.piece.length===0?i.prev():i;this.v(a),this.O(m),this.y()}o(n,r){const u=[];if(this.K()&&this.M(n)&&this.L(r)){const $=r.piece,a={line:$.start.line+1,column:0},c=new h($.bufferIndex,a,$.end,this.t($.bufferIndex,a,$.end),$.length-1);r.piece=c,n+=`
`,(0,F.$aC)(this,r,-1,-1),r.piece.length===0&&u.push(r)}const l=this.w(n);let i=this.T(r,l[l.length-1]);for(let $=l.length-2;$>=0;$--)i=this.T(i,l[$]);this.N(i),this.v(u)}q(n,r){this.Q(n,r)&&(n+=`
`);const u=this.w(n),l=this.S(r,u[0]);let i=l;for(let $=1;$<u.length;$++)i=this.S(i,u[$]);this.N(l)}s(n,r,u){const l=n.piece,i=n.piece.bufferIndex,$=this.a[i].lineStarts,c=$[l.start.line]+l.start.column+r;let E=l.start.line,y=l.end.line,m=0,I=0,d=0;for(;E<=y&&(m=E+(y-E)/2|0,d=$[m],m!==y);)if(I=$[m+1],c<d)y=m-1;else if(c>=I)E=m+1;else break;return u?(u.line=m,u.column=c-d,null):{line:m,column:c-d}}t(n,r,u){if(u.column===0)return u.line-r.line;const l=this.a[n].lineStarts;if(u.line===l.length-1)return u.line-r.line;const i=l[u.line+1],$=l[u.line]+u.column;if(i>$+1)return u.line-r.line;const a=$-1;return this.a[n].buffer.charCodeAt(a)===13?u.line-r.line+1:u.line-r.line}u(n,r){return this.a[n].lineStarts[r.line]+r.column}v(n){for(let r=0;r<n.length;r++)(0,F.$$B)(this,n[r])}w(n){if(n.length>g){const y=[];for(;n.length>g;){const I=n.charCodeAt(g-1);let d;I===13||I>=55296&&I<=56319?(d=n.substring(0,g-1),n=n.substring(g-1)):(d=n.substring(0,g),n=n.substring(g));const w=A(d);y.push(new h(this.a.length,{line:0,column:0},{line:w.length-1,column:d.length-w[w.length-1]},w.length-1,d.length)),this.a.push(new v(d,w))}const m=A(n);return y.push(new h(this.a.length,{line:0,column:0},{line:m.length-1,column:n.length-m[m.length-1]},m.length-1,n.length)),this.a.push(new v(n,m)),y}let r=this.a[0].buffer.length;const u=A(n,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let y=0;y<u.length;y++)u[y]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+="_"+n,r+=1}else{if(r!==0)for(let y=0;y<u.length;y++)u[y]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,$=this.a[0].lineStarts.length-1,a=i-this.a[0].lineStarts[$],c={line:$,column:a},E=new h(0,l,c,this.t(0,l,c),i-r);return this.g=c,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,r=0){let u=this.root,l="";const i=this.h.get2(n);if(i){u=i.node;const $=this.B(u,n-i.nodeStartLineNumber-1),a=this.a[u.piece.bufferIndex].buffer,c=this.u(u.piece.bufferIndex,u.piece.start);if(i.nodeStartLineNumber+u.piece.lineFeedCnt===n)l=a.substring(c+$,c+u.piece.length);else{const E=this.B(u,n-i.nodeStartLineNumber);return a.substring(c+$,c+E-r)}}else{let $=0;const a=n;for(;u!==F.$6B;)if(u.left!==F.$6B&&u.lf_left>=n-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>n-1){const c=this.B(u,n-u.lf_left-2),E=this.B(u,n-u.lf_left-1),y=this.a[u.piece.bufferIndex].buffer,m=this.u(u.piece.bufferIndex,u.piece.start);return $+=u.size_left,this.h.set({node:u,nodeStartOffset:$,nodeStartLineNumber:a-(n-1-u.lf_left)}),y.substring(m+c,m+E-r)}else if(u.lf_left+u.piece.lineFeedCnt===n-1){const c=this.B(u,n-u.lf_left-2),E=this.a[u.piece.bufferIndex].buffer,y=this.u(u.piece.bufferIndex,u.piece.start);l=E.substring(y+c,y+u.piece.length);break}else n-=u.lf_left+u.piece.lineFeedCnt,$+=u.size_left+u.piece.length,u=u.right}for(u=u.next();u!==F.$6B;){const $=this.a[u.piece.bufferIndex].buffer;if(u.piece.lineFeedCnt>0){const a=this.B(u,0),c=this.u(u.piece.bufferIndex,u.piece.start);return l+=$.substring(c,c+a-r),l}else{const a=this.u(u.piece.bufferIndex,u.piece.start);l+=$.substr(a,u.piece.length)}u=u.next()}return l}y(){let n=this.root,r=1,u=0;for(;n!==F.$6B;)r+=n.lf_left+n.piece.lineFeedCnt,u+=n.size_left+n.piece.length,n=n.right;this.b=r,this.c=u,this.h.validate(this.c)}A(n,r){const u=n.piece,l=this.s(n,r),i=l.line-u.start.line;if(this.u(u.bufferIndex,u.end)-this.u(u.bufferIndex,u.start)===r){const $=this.t(n.piece.bufferIndex,u.start,l);if($!==i)return{index:$,remainder:0}}return{index:i,remainder:l.column}}B(n,r){if(r<0)return 0;const u=n.piece,l=this.a[u.bufferIndex].lineStarts,i=u.start.line+r+1;return i>u.end.line?l[u.end.line]+u.end.column-l[u.start.line]-u.start.column:l[i]-l[u.start.line]-u.start.column}C(n,r){const u=n.piece,l=u.lineFeedCnt,i=this.u(u.bufferIndex,u.end),$=r,a=this.u(u.bufferIndex,$),c=this.t(u.bufferIndex,u.start,$),E=c-l,y=a-i,m=u.length+y;n.piece=new h(u.bufferIndex,u.start,$,c,m),(0,F.$aC)(this,n,y,E)}D(n,r){const u=n.piece,l=u.lineFeedCnt,i=this.u(u.bufferIndex,u.start),$=r,a=this.t(u.bufferIndex,$,u.end),c=this.u(u.bufferIndex,$),E=a-l,y=i-c,m=u.length+y;n.piece=new h(u.bufferIndex,$,u.end,a,m),(0,F.$aC)(this,n,y,E)}E(n,r,u){const l=n.piece,i=l.start,$=l.end,a=l.length,c=l.lineFeedCnt,E=r,y=this.t(l.bufferIndex,l.start,E),m=this.u(l.bufferIndex,r)-this.u(l.bufferIndex,i);n.piece=new h(l.bufferIndex,l.start,E,y,m),(0,F.$aC)(this,n,m-a,y-c);const I=new h(l.bufferIndex,u,$,this.t(l.bufferIndex,u,$),this.u(l.bufferIndex,$)-this.u(l.bufferIndex,u)),d=this.S(n,I);this.N(d)}F(n,r){this.Q(r,n)&&(r+=`
`);const u=this.K()&&this.L(r)&&this.M(n),l=this.a[0].buffer.length;this.a[0].buffer+=r;const i=A(r,!1);for(let d=0;d<i.length;d++)i[d]+=l;if(u){const d=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-d}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const $=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[$],c={line:$,column:a},E=n.piece.length+r.length,y=n.piece.lineFeedCnt,m=this.t(0,n.piece.start,c),I=m-y;n.piece=new h(n.piece.bufferIndex,n.piece.start,c,m,E),this.g=c,(0,F.$aC)(this,n,r.length,I)}G(n){let r=this.root;const u=this.h.get(n);if(u)return{node:u.node,nodeStartOffset:u.nodeStartOffset,remainder:n-u.nodeStartOffset};let l=0;for(;r!==F.$6B;)if(r.size_left>n)r=r.left;else if(r.size_left+r.piece.length>=n){l+=r.size_left;const i={node:r,remainder:n-r.size_left,nodeStartOffset:l};return this.h.set(i),i}else n-=r.size_left+r.piece.length,l+=r.size_left+r.piece.length,r=r.right;return null}H(n,r){let u=this.root,l=0;for(;u!==F.$6B;)if(u.left!==F.$6B&&u.lf_left>=n-1)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt>n-1){const i=this.B(u,n-u.lf_left-2),$=this.B(u,n-u.lf_left-1);return l+=u.size_left,{node:u,remainder:Math.min(i+r-1,$),nodeStartOffset:l}}else if(u.lf_left+u.piece.lineFeedCnt===n-1){const i=this.B(u,n-u.lf_left-2);if(i+r-1<=u.piece.length)return{node:u,remainder:i+r-1,nodeStartOffset:l};r-=u.piece.length-i;break}else n-=u.lf_left+u.piece.lineFeedCnt,l+=u.size_left+u.piece.length,u=u.right;for(u=u.next();u!==F.$6B;){if(u.piece.lineFeedCnt>0){const i=this.B(u,0),$=this.J(u);return{node:u,remainder:Math.min(r-1,i),nodeStartOffset:$}}else if(u.piece.length>=r-1){const i=this.J(u);return{node:u,remainder:r-1,nodeStartOffset:i}}else r-=u.piece.length;u=u.next()}return null}I(n,r){if(n.piece.lineFeedCnt<1)return-1;const u=this.a[n.piece.bufferIndex],l=this.u(n.piece.bufferIndex,n.piece.start)+r;return u.buffer.charCodeAt(l)}J(n){if(!n)return 0;let r=n.size_left;for(;n!==this.root;)n.parent.right===n&&(r+=n.parent.size_left+n.parent.piece.length),n=n.parent;return r}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===F.$6B||n.piece.lineFeedCnt===0)return!1;const r=n.piece,u=this.a[r.bufferIndex].lineStarts,l=r.start.line,i=u[l]+r.start.column;return l===u.length-1||u[l+1]>i+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===F.$6B||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const r=n.prev();this.M(r)&&this.P(r,n)}}O(n){if(this.K()&&this.M(n)){const r=n.next();this.L(r)&&this.P(n,r)}}P(n,r){const u=[],l=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:l[n.piece.end.line]-l[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const $=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new h(n.piece.bufferIndex,n.piece.start,i,a,$),(0,F.$aC)(this,n,-1,-1),n.piece.length===0&&u.push(n);const c={line:r.piece.start.line+1,column:0},E=r.piece.length-1,y=this.t(r.piece.bufferIndex,c,r.piece.end);r.piece=new h(r.piece.bufferIndex,c,r.piece.end,y,E),(0,F.$aC)(this,r,-1,-1),r.piece.length===0&&u.push(r);const m=this.w(`\r
`);this.S(n,m[0]);for(let I=0;I<u.length;I++)(0,F.$$B)(this,u[I])}Q(n,r){if(this.K()&&this.M(n)){const u=r.next();if(this.L(u)){if(n+=`
`,u.piece.length===1)(0,F.$$B)(this,u);else{const l=u.piece,i={line:l.start.line+1,column:0},$=l.length-1,a=this.t(l.bufferIndex,i,l.end);u.piece=new h(l.bufferIndex,i,l.end,a,$),(0,F.$aC)(this,u,-1,-1)}return!0}}return!1}iterate(n,r){if(n===F.$6B)return r(F.$6B);const u=this.iterate(n.left,r);return u&&r(n)&&this.iterate(n.right,r)}R(n){if(n===F.$6B)return"";const r=this.a[n.piece.bufferIndex],u=n.piece,l=this.u(u.bufferIndex,u.start),i=this.u(u.bufferIndex,u.end);return r.buffer.substring(l,i)}getPieceContent(n){const r=this.a[n.bufferIndex],u=this.u(n.bufferIndex,n.start),l=this.u(n.bufferIndex,n.end);return r.buffer.substring(u,l)}S(n,r){const u=new F.$5B(r,1);if(u.left=F.$6B,u.right=F.$6B,u.parent=F.$6B,u.size_left=0,u.lf_left=0,this.root===F.$6B)this.root=u,u.color=0;else if(n.right===F.$6B)n.right=u,u.parent=n;else{const i=(0,F.$7B)(n.right);i.left=u,u.parent=i}return(0,F.$_B)(this,u),u}T(n,r){const u=new F.$5B(r,1);if(u.left=F.$6B,u.right=F.$6B,u.parent=F.$6B,u.size_left=0,u.lf_left=0,this.root===F.$6B)this.root=u,u.color=0;else if(n.left===F.$6B)n.left=u,u.parent=n;else{const l=(0,F.$8B)(n.left);l.right=u,u.parent=l}return(0,F.$_B)(this,u),u}U(n){let r="";return this.iterate(n,u=>(r+=this.R(u),!0)),r}}e.$mC=o}),define(Ae[133],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B9=e.$A9=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const R=this.a.get(F);return this.a.delete(F),R}}addDragOperationTransfer(F,R){this.a.set(F,R)}}e.$A9=S;class L{constructor(F){this.identifier=F}}e.$B9=L}),define(Ae[134],Me([9,10]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(Ae[135],Me([1,0,5,6,134]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;class F extends L.$Tc{constructor(h,v="",p="",s=!0,o){super(),this.h=this.B(new S.$5d),this.onDidChange=this.h.event,this.w=!0,this.j=h,this.m=v,this.u=p,this.w=s,this.C=o}get id(){return this.j}get label(){return this.m}set label(h){this.D(h)}D(h){this.m!==h&&(this.m=h,this.h.fire({label:h}))}get tooltip(){return this.n||""}set tooltip(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.h.fire({tooltip:h}))}get class(){return this.u}set class(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.h.fire({class:h}))}get enabled(){return this.w}set enabled(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.h.fire({enabled:h}))}get checked(){return this.z}set checked(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.h.fire({checked:h}))}async run(h,v){this.C&&await this.C(h)}}e.$Vi=F;class R extends L.$Tc{constructor(){super(...arguments),this.f=this.B(new S.$5d),this.onWillRun=this.f.event,this.m=this.B(new S.$5d),this.onDidRun=this.m.event}async run(h,v){if(!h.enabled)return;this.f.fire({action:h});let p;try{await this.u(h,v)}catch(s){p=s}this.m.fire({action:h,error:p})}async u(h,v){await h.run(v)}}e.$Wi=R;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let v=[];for(const p of h)p.length&&(v.length?v=[...v,new g,...p]:v=p);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Xi=g;class f{get actions(){return this.a}constructor(h,v,p,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=v,this.class=s,this.a=p}async run(){}}e.$Yi=f;class k extends F{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,P.localize(0,null),void 0,!1)}}e.$Zi=k;function A(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked,run:async(...h)=>D.run(...h),tooltip:D.label}}e.$1i=A}),define(Ae[136],Me([9,10]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(Ae[137],Me([1,0,136]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=e.$Gm=void 0;const L=60,P=L*60,F=P*24,R=F*7,g=F*30,f=F*365;function k(h,v,p,s){typeof h!="number"&&(h=h.getTime());const o=Math.round((new Date().getTime()-h)/1e3);if(o<-30)return(0,S.localize)(0,null,k(new Date().getTime()+o*1e3,!1));if(!s&&o<30)return(0,S.localize)(1,null);let t;return o<L?(t=o,v?t===1?p?(0,S.localize)(2,null,t):(0,S.localize)(3,null,t):p?(0,S.localize)(4,null,t):(0,S.localize)(5,null,t):t===1?p?(0,S.localize)(6,null,t):(0,S.localize)(7,null,t):p?(0,S.localize)(8,null,t):(0,S.localize)(9,null,t)):o<P?(t=Math.floor(o/L),v?t===1?p?(0,S.localize)(10,null,t):(0,S.localize)(11,null,t):p?(0,S.localize)(12,null,t):(0,S.localize)(13,null,t):t===1?p?(0,S.localize)(14,null,t):(0,S.localize)(15,null,t):p?(0,S.localize)(16,null,t):(0,S.localize)(17,null,t)):o<F?(t=Math.floor(o/P),v?t===1?p?(0,S.localize)(18,null,t):(0,S.localize)(19,null,t):p?(0,S.localize)(20,null,t):(0,S.localize)(21,null,t):t===1?p?(0,S.localize)(22,null,t):(0,S.localize)(23,null,t):p?(0,S.localize)(24,null,t):(0,S.localize)(25,null,t)):o<R?(t=Math.floor(o/F),v?t===1?(0,S.localize)(26,null,t):(0,S.localize)(27,null,t):t===1?(0,S.localize)(28,null,t):(0,S.localize)(29,null,t)):o<g?(t=Math.floor(o/R),v?t===1?p?(0,S.localize)(30,null,t):(0,S.localize)(31,null,t):p?(0,S.localize)(32,null,t):(0,S.localize)(33,null,t):t===1?p?(0,S.localize)(34,null,t):(0,S.localize)(35,null,t):p?(0,S.localize)(36,null,t):(0,S.localize)(37,null,t)):o<f?(t=Math.floor(o/g),v?t===1?p?(0,S.localize)(38,null,t):(0,S.localize)(39,null,t):p?(0,S.localize)(40,null,t):(0,S.localize)(41,null,t):t===1?p?(0,S.localize)(42,null,t):(0,S.localize)(43,null,t):p?(0,S.localize)(44,null,t):(0,S.localize)(45,null,t)):(t=Math.floor(o/f),v?t===1?p?(0,S.localize)(46,null,t):(0,S.localize)(47,null,t):p?(0,S.localize)(48,null,t):(0,S.localize)(49,null,t):t===1?p?(0,S.localize)(50,null,t):(0,S.localize)(51,null,t):p?(0,S.localize)(52,null,t):(0,S.localize)(53,null,t))}e.$Gm=k;function A(h,v){const p=Math.abs(h/1e3);return p<1?v?(0,S.localize)(54,null,h):(0,S.localize)(55,null,h):p<L?v?(0,S.localize)(56,null,Math.round(h)/1e3):(0,S.localize)(57,null,Math.round(h)/1e3):p<P?v?(0,S.localize)(58,null,Math.round(h/(1e3*L))):(0,S.localize)(59,null,Math.round(h/(1e3*L))):p<F?v?(0,S.localize)(60,null,Math.round(h/(1e3*P))):(0,S.localize)(61,null,Math.round(h/(1e3*P))):(0,S.localize)(62,null,Math.round(h/(1e3*F)))}e.$Hm=A;function D(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Im=D}),define(Ae[138],Me([9,10]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(Ae[41],Me([1,0,18,16,138]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=void 0;function F(D,h){return h&&(D.stack||D.stacktrace)?P.localize(0,null,g(D),R(D.stack)||R(D.stacktrace)):g(D)}function R(D){return Array.isArray(D)?D.join(`
`):D}function g(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?P.localize(1,null,D.message):D.message||P.localize(2,null)}function f(D=null,h=!1){if(!D)return P.localize(3,null);if(Array.isArray(D)){const v=S.$Hb(D),p=f(v[0],h);return v.length>1?P.localize(4,null,p,v.length):p}if(L.$Sf(D))return D;if(D.detail){const v=D.detail;if(v.error)return F(v.error,h);if(v.exception)return F(v.exception,h)}return D.stack?F(D,h):D.message?D.message:P.localize(5,null)}e.$2i=f;function k(D){const h=D;return h instanceof Error&&Array.isArray(h.actions)}e.$3i=k;function A(D,h){let v;return typeof D=="string"?v=new Error(D):v=D,v.actions=h,v}e.$4i=A}),define(Ae[139],Me([1,0,39,19]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=e.$Uq=e.$Tq=void 0;const P=new S.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),F=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(I,d,w=!1){const b=I||"",M=d||"",T=P.value.collator.compare(b,M);return P.value.collatorIsNumeric&&T===0&&b!==M?b<M?-1:1:T}e.$Tq=g;function f(I,d){const w=F.value.collator;return I=I||"",d=d||"",u(w,I,d)}e.$Uq=f;function k(I,d){const w=F.value.collator;return I=I||"",d=d||"",a(I,d)||u(w,I,d)}e.$Vq=k;function A(I,d){const w=F.value.collator;return I=I||"",d=d||"",$(I,d)||u(w,I,d)}e.$Wq=A;function D(I,d){return I=I||"",d=d||"",I===d?0:I<d?-1:1}e.$Xq=D;function h(I,d){const[w,b]=n(I),[M,T]=n(d);let G=P.value.collator.compare(b,T);if(G===0){if(P.value.collatorIsNumeric&&b!==T)return b<T?-1:1;if(G=P.value.collator.compare(w,M),P.value.collatorIsNumeric&&G===0&&w!==M)return w<M?-1:1}return G}e.$Yq=h;function v(I,d){I=I||"",d=d||"";const w=r(I),b=r(d),M=F.value.collator,T=R.value.collator;return u(T,w,b)||u(M,I,d)}e.$Zq=v;function p(I,d){I=I||"",d=d||"";const w=r(I),b=r(d),M=F.value.collator,T=R.value.collator;return u(T,w,b)||a(I,d)||u(M,I,d)}e.$1q=p;function s(I,d){I=I||"",d=d||"";const w=r(I),b=r(d),M=F.value.collator,T=R.value.collator;return u(T,w,b)||$(I,d)||u(M,I,d)}e.$2q=s;function o(I,d){I=I||"",d=d||"";const w=r(I).toLowerCase(),b=r(d).toLowerCase();return w!==b?w<b?-1:1:I!==d?I<d?-1:1:0}e.$3q=o;const t=/^(.*?)(\.([^.]*))?$/;function n(I,d=!1){const w=I?t.exec(I):[];let b=[w&&w[1]||"",w&&w[3]||""];return d&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function r(I){const d=I?t.exec(I):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function u(I,d,w){const b=I.compare(d,w);return b!==0?b:d.length!==w.length?d.length<w.length?-1:1:0}function l(I){const d=I.charAt(0);return d.toLocaleUpperCase()!==d}function i(I){const d=I.charAt(0);return d.toLocaleLowerCase()!==d}function $(I,d){return l(I)&&i(d)?-1:i(I)&&l(d)?1:0}function a(I,d){return i(I)&&l(d)?-1:l(I)&&i(d)?1:0}function c(I,d,w=!1){return w||(I=I&&I.toLowerCase(),d=d&&d.toLowerCase()),I===d?0:I<d?-1:1}function E(I,d,w=!1){const b=I.split(L.sep),M=d.split(L.sep),T=b.length-1,G=M.length-1;let W,U;for(let C=0;;C++){if(W=T===C,U=G===C,W&&U)return g(b[C],M[C],w);if(W)return-1;if(U)return 1;const O=c(b[C],M[C],w);if(O!==0)return O}}e.$4q=E;function y(I,d,w){const b=I.toLowerCase(),M=d.toLowerCase(),T=m(I,d,w);if(T)return T;const G=b.endsWith(w),W=M.endsWith(w);if(G!==W)return G?-1:1;const U=g(b,M);return U!==0?U:b.localeCompare(M)}e.$5q=y;function m(I,d,w){const b=I.toLowerCase(),M=d.toLowerCase(),T=b.startsWith(w),G=M.startsWith(w);if(T!==G)return T?-1:1;if(T&&G){if(b.length<M.length)return-1;if(b.length>M.length)return 1}return 0}e.$6q=m}),define(Ae[45],Me([1,0,19,20,13,16]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=void 0;function R(y){return y===47||y===92}e.$$f=R;function g(y){return y.replace(/[\\/]/g,S.$gc.sep)}e.$_f=g;function f(y){return y.indexOf("/")===-1&&(y=g(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}e.$ag=f;function k(y,m=S.$gc.sep){if(!y)return"";const I=y.length,d=y.charCodeAt(0);if(R(d)){if(R(y.charCodeAt(1))&&!R(y.charCodeAt(2))){let b=3;const M=b;for(;b<I&&!R(y.charCodeAt(b));b++);if(M!==b&&!R(y.charCodeAt(b+1))){for(b+=1;b<I;b++)if(R(y.charCodeAt(b)))return y.slice(0,b+1).replace(/[\\/]/g,m)}}return m}else if(t(d)&&y.charCodeAt(1)===58)return R(y.charCodeAt(2))?y.slice(0,2)+m:y.slice(0,2);let w=y.indexOf("://");if(w!==-1){for(w+=3;w<I;w++)if(R(y.charCodeAt(w)))return y.slice(0,w+1)}return""}e.$bg=k;function A(y){if(!L.$i||!y||y.length<5)return!1;let m=y.charCodeAt(0);if(m!==92||(m=y.charCodeAt(1),m!==92))return!1;let I=2;const d=I;for(;I<y.length&&(m=y.charCodeAt(I),m!==92);I++);return!(d===I||(m=y.charCodeAt(I+1),isNaN(m)||m===92))}e.$cg=A;const D=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(y,m=L.$i){const I=m?D:h;return!(!y||y.length===0||/^\s+$/.test(y)||(I.lastIndex=0,I.test(y))||m&&v.test(y)||y==="."||y===".."||m&&y[y.length-1]==="."||m&&y.length!==y.trim().length||y.length>255)}e.$dg=p;function s(y,m,I){const d=y===m;return!I||d?d:!y||!m?!1:(0,P.$jf)(y,m)}e.$eg=s;function o(y,m,I,d=S.sep){if(y===m)return!0;if(!y||!m||m.length>y.length)return!1;if(I){if(!(0,P.$kf)(y,m))return!1;if(m.length===y.length)return!0;let b=m.length;return m.charAt(m.length-1)===d&&b--,y.charAt(b)===d}return m.charAt(m.length-1)!==d&&(m+=d),y.indexOf(m)===0}e.$fg=o;function t(y){return y>=65&&y<=90||y>=97&&y<=122}e.$gg=t;function n(y,m){return L.$i&&y.endsWith(":")&&(y+=S.sep),(0,S.$ic)(y)||(y=(0,S.$jc)(m,y)),y=(0,S.$hc)(y),L.$i?(y=(0,P.$4e)(y,S.sep),y.endsWith(":")&&(y+=S.sep)):(y=(0,P.$4e)(y,S.sep),y||(y=S.sep)),y}e.$hg=n;function r(y){const m=(0,S.$hc)(y);return L.$i?y.length>3?!1:u(m)&&(y.length===2||m.charCodeAt(2)===92):m===S.$gc.sep}e.$ig=r;function u(y,m=L.$i){return m?t(y.charCodeAt(0))&&y.charCodeAt(1)===58:!1}e.$jg=u;function l(y,m=L.$i){return u(y,m)?y[0]:void 0}e.$kg=l;function i(y,m,I){return m.length>y.length?-1:y===m?0:(I&&(y=y.toLowerCase(),m=m.toLowerCase()),y.indexOf(m))}e.$lg=i;function $(y){const m=y.split(":");let I,d,w;for(const b of m){const M=Number(b);(0,F.$Wf)(M)?d===void 0?d=M:w===void 0&&(w=M):I=I?[I,b].join(":"):b}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:d!==void 0?d:void 0,column:w!==void 0?w:d!==void 0?1:void 0}}e.$mg=$;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",c="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(y,m,I=8){let d="";for(let b=0;b<I;b++){let M;b===0&&L.$i&&!m&&(I===3||I===4)?M=c:M=a,d+=M.charAt(Math.floor(Math.random()*M.length))}let w;return m?w=`${m}-${d}`:w=d,y?(0,S.$jc)(y,w):w}e.$ng=E}),define(Ae[69],Me([1,0,19]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=e.$ts=e.$ss=e.$rs=e.$qs=void 0,e.$qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(A){const D=(0,S.$oc)(A),h=L[D.toLowerCase()];return h!==void 0?h:R(A)}e.$rs=F;function R(A){const D=(0,S.$oc)(A);return P[D.toLowerCase()]}e.$ss=R;function g(A){for(const D in P)if(P[D]===A)return D}e.$ts=g;const f=/^(.+)\/(.+?)(;.+)?$/;function k(A,D){const h=f.exec(A);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:D?void 0:A}e.$us=k}),define(Ae[52],Me([1,0,24,2]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=void 0;function P(f){return JSON.stringify(f,R)}e.$Lh=P;function F(f){let k=JSON.parse(f);return k=g(k),k}e.$Mh=F;function R(f,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function g(f,k=0){if(!f||k>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return L.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof S.$se||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let A=0;A<f.length;++A)f[A]=g(f[A],k+1);else for(const A in f)Object.hasOwnProperty.call(f,A)&&(f[A]=g(f[A],k+1))}return f}e.$Nh=g}),define(Ae[12],Me([1,0,15,20,13,2]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.Schemas=void 0;var R;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.codeSetting="code-setting",h.codeFeature="code-feature"})(R||(e.Schemas=R={}));function g(h,v){return F.URI.isUri(h)?(0,P.$jf)(h.scheme,v):(0,P.$kf)(h,v+":")}e.$og=g;function f(h,...v){return v.some(p=>g(h,p))}e.$pg=f,e.$qg="vscode-tkn",e.$rg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v){this.f=`${v}/${R.vscodeRemoteResource}`}set(v,p,s){this.a[v]=p,this.b[v]=s}setConnectionToken(v,p){this.c[v]=p}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(r){return S.$1(r),v}const p=v.authority;let s=this.a[p];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const o=this.b[p],t=this.c[p];let n=`path=${encodeURIComponent(v.path)}`;return typeof t=="string"&&(n+=`&${e.$rg}=${encodeURIComponent(t)}`),F.URI.from({scheme:L.$o?this.d:R.vscodeRemoteResource,authority:`${s}:${o}`,path:this.f,query:n})}}e.$sg=new k,e.$tg="vs/../../extensions",e.$ug="vs/../../node_modules",e.$vg="vs/../../node_modules.asar",e.$wg="vs/../../node_modules.asar.unpacked",e.$xg="vscode-app";class A{static{this.a=e.$xg}asBrowserUri(v){const p=this.b(v,fe);return this.uriToBrowserUri(p)}uriToBrowserUri(v){return v.scheme===R.vscodeRemote?e.$sg.rewrite(v):v.scheme===R.file&&(L.$m||L.$q===`${R.vscodeFileResource}://${A.a}`)?v.with({scheme:R.vscodeFileResource,authority:v.authority||A.a,query:null,fragment:null}):v}asFileUri(v){const p=this.b(v,fe);return this.uriToFileUri(p)}uriToFileUri(v){return v.scheme===R.vscodeFileResource?v.with({scheme:R.file,authority:v.authority!==A.a?v.authority:null,query:null,fragment:null}):v}b(v,p){return F.URI.isUri(v)?v:F.URI.parse(p.toUrl(v))}}e.$yg=new A;var D;(function(h){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(v.get("3"));const p="vscode-coi";function s(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:F.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const r=n?.get(p);if(r)return v.get(r)}h.getHeadersFromQuery=s;function o(t,n,r){if(!globalThis.crossOriginIsolated)return;const u=n&&r?"3":r?"2":"1";t instanceof URLSearchParams?t.set(p,u):t[p]=u}h.addSearchParam=o})(D||(e.COI=D={}))}),define(Ae[25],Me([1,0,45,12,19,20,13,2]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=e.DataUri=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function f(v){return(0,g.$wc)(v,!0)}e.$Fg=f;class k{constructor(p){this.a=p}compare(p,s,o=!1){return p===s?0:(0,R.$cf)(this.getComparisonKey(p,o),this.getComparisonKey(s,o))}isEqual(p,s,o=!1){return p===s?!0:!p||!s?!1:this.getComparisonKey(p,o)===this.getComparisonKey(s,o)}getComparisonKey(p,s=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,s,o=!1){if(p.scheme===s.scheme){if(p.scheme===L.Schemas.file)return S.$fg(f(p),f(s),this.a(p))&&p.query===s.query&&(o||p.fragment===s.fragment);if((0,e.$Wg)(p.authority,s.authority))return S.$fg(p.path,s.path,this.a(p),"/")&&p.query===s.query&&(o||p.fragment===s.fragment)}return!1}joinPath(p,...s){return g.URI.joinPath(p,...s)}basenameOrAuthority(p){return(0,e.$Og)(p)||p.authority}basename(p){return P.$gc.basename(p.path)}extname(p){return P.$gc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let s;return p.scheme===L.Schemas.file?s=g.URI.file(P.$mc(f(p))).path:(s=P.$gc.dirname(p.path),p.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),s="/")),p.with({path:s})}normalizePath(p){if(!p.path.length)return p;let s;return p.scheme===L.Schemas.file?s=g.URI.file(P.$hc(f(p))).path:s=P.$gc.normalize(p.path),p.with({path:s})}relativePath(p,s){if(p.scheme!==s.scheme||!(0,e.$Wg)(p.authority,s.authority))return;if(p.scheme===L.Schemas.file){const n=P.$lc(f(p),f(s));return F.$i?S.$_f(n):n}let o=p.path||"/";const t=s.path||"/";if(this.a(p)){let n=0;for(const r=Math.min(o.length,t.length);n<r&&!(o.charCodeAt(n)!==t.charCodeAt(n)&&o.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);o=t.substr(0,n)+o.substr(n)}return P.$gc.relative(o,t)}resolvePath(p,s){if(p.scheme===L.Schemas.file){const o=g.URI.file(P.$kc(f(p),s));return p.with({authority:o.authority,path:o.path})}return s=S.$ag(s),p.with({path:P.$gc.resolve(p.path,s)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,s){return p===s||p!==void 0&&s!==void 0&&(0,R.$jf)(p,s)}hasTrailingPathSeparator(p,s=P.sep){if(p.scheme===L.Schemas.file){const o=f(p);return o.length>S.$bg(o).length&&o[o.length-1]===s}else{const o=p.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,s=P.sep){return(0,e.$Xg)(p,s)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,s=P.sep){let o=!1;if(p.scheme===L.Schemas.file){const t=f(p);o=t!==void 0&&t.length===S.$bg(t).length&&t[t.length-1]===s}else{s="/";const t=p.path;o=t.length===1&&t.charCodeAt(t.length-1)===47}return!o&&!(0,e.$Xg)(p,s)?p.with({path:p.path+"/"}):p}}e.$Gg=k,e.$Hg=new k(()=>!1),e.$Ig=new k(v=>v.scheme===L.Schemas.file?!F.$k:!0),e.$Jg=new k(v=>!0),e.$Kg=e.$Hg.isEqual.bind(e.$Hg),e.$Lg=e.$Hg.isEqualOrParent.bind(e.$Hg),e.$Mg=e.$Hg.getComparisonKey.bind(e.$Hg),e.$Ng=e.$Hg.basenameOrAuthority.bind(e.$Hg),e.$Og=e.$Hg.basename.bind(e.$Hg),e.$Pg=e.$Hg.extname.bind(e.$Hg),e.$Qg=e.$Hg.dirname.bind(e.$Hg),e.$Rg=e.$Hg.joinPath.bind(e.$Hg),e.$Sg=e.$Hg.normalizePath.bind(e.$Hg),e.$Tg=e.$Hg.relativePath.bind(e.$Hg),e.$Ug=e.$Hg.resolvePath.bind(e.$Hg),e.$Vg=e.$Hg.isAbsolutePath.bind(e.$Hg),e.$Wg=e.$Hg.isEqualAuthority.bind(e.$Hg),e.$Xg=e.$Hg.hasTrailingPathSeparator.bind(e.$Hg),e.$Yg=e.$Hg.removeTrailingPathSeparator.bind(e.$Hg),e.$Zg=e.$Hg.addTrailingPathSeparator.bind(e.$Hg);function A(v,p){const s=[];for(let o=0;o<v.length;o++){const t=p(v[o]);v.some((n,r)=>r===o?!1:(0,e.$Lg)(t,p(n)))||s.push(v[o])}return s}e.$1g=A;var D;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function p(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(r=>{const[u,l]=r.split(":");u&&l&&o.set(u,l)});const n=s.path.substring(0,s.path.indexOf(";"));return n&&o.set(v.META_DATA_MIME,n),o}v.parseMetaData=p})(D||(e.DataUri=D={}));function h(v,p,s){if(p){let o=v.path;return o&&o[0]!==P.$gc.sep&&(o=P.$gc.sep+o),v.with({scheme:s,authority:p,path:o})}return v.with({scheme:s})}e.$2g=h}),define(Ae[11],Me([1,0,21,15,5,6,25,20,126,39]),function(fe,e,S,L,P,F,R,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.Promises=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0;function A(ge){return!!ge&&typeof ge.then=="function"}e.$3g=A;function D(ge){const X=new S.$ce,x=ge(X.token),le=new Promise((de,Pe)=>{const me=X.token.onCancellationRequested(()=>{me.dispose(),Pe(new L.$5)});Promise.resolve(x).then(Ie=>{me.dispose(),X.dispose(),de(Ie)},Ie=>{me.dispose(),X.dispose(),Pe(Ie)})});return new class{cancel(){X.cancel(),X.dispose()}then(de,Pe){return le.then(de,Pe)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}e.$4g=D;function h(ge,X,x){return new Promise((le,de)=>{const Pe=X.onCancellationRequested(()=>{Pe.dispose(),le(x)});ge.then(le,de).finally(()=>Pe.dispose())})}e.$5g=h;function v(ge,X){return new Promise((x,le)=>{const de=X.onCancellationRequested(()=>{de.dispose(),le(new L.$5)});ge.then(x,le).finally(()=>de.dispose())})}e.$6g=v;async function p(ge){let X=-1;const x=ge.map((le,de)=>le.then(Pe=>(X=de,Pe)));try{return await Promise.race(x)}finally{ge.forEach((le,de)=>{de!==X&&le.cancel()})}}e.$7g=p;function s(ge,X,x){let le;const de=setTimeout(()=>{le?.(void 0),x?.()},X);return Promise.race([ge.finally(()=>clearTimeout(de)),new Promise(Pe=>le=Pe)])}e.$8g=s;function o(ge){return new Promise((X,x)=>{const le=ge();A(le)?le.then(X,x):X(le)})}e.$9g=o;function t(){let ge,X;return{promise:new Promise((le,de)=>{ge=le,X=de}),resolve:ge,reject:X}}e.$0g=t;class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const x=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(x,x).then(le)})}return new Promise((x,le)=>{this.b.then(x,le)})}return this.a=X(),new Promise((x,le)=>{this.a.then(de=>{this.a=null,x(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$$g=n;class r{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$_g=r;class u{constructor(){this.a=new Map}queue(X,x){const de=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(X)===de&&this.a.delete(X)});return this.a.set(X,de),de}}e.$ah=u;const l=(ge,X)=>{let x=!0;const le=setTimeout(()=>{x=!1,X()},ge);return{isTriggered:()=>x,dispose:()=>{clearTimeout(le),x=!1}}},i=ge=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,ge())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class ${constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,x=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((de,Pe)=>{this.d=de,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=x===f.$2d?i(le):l(x,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$bh=$;class a{constructor(X){this.a=new $(X),this.b=new n}trigger(X,x){return this.a.trigger(()=>this.b.queue(X),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ch=a;class c{constructor(){this.a=!1,this.b=new Promise((X,x)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$dh=c;class E extends c{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$eh=E;function y(ge,X){return X?new Promise((x,le)=>{const de=setTimeout(()=>{Pe.dispose(),x()},ge),Pe=X.onCancellationRequested(()=>{clearTimeout(de),Pe.dispose(),le(new L.$5)})}):D(x=>y(ge,x))}e.$fh=y;function m(ge,X=0,x){const le=setTimeout(()=>{ge(),x&&de.dispose()},X),de=(0,F.$Rc)(()=>{clearTimeout(le),x?.deleteAndLeak(de)});return x?.add(de),de}e.$gh=m;function I(ge){const X=[];let x=0;const le=ge.length;function de(){return x<le?ge[x++]():null}function Pe(me){me!=null&&X.push(me);const Ie=de();return Ie?Ie.then(Pe):Promise.resolve(X)}return Promise.resolve(null).then(Pe)}e.$hh=I;function d(ge,X=le=>!!le,x=null){let le=0;const de=ge.length,Pe=()=>{if(le>=de)return Promise.resolve(x);const me=ge[le++];return Promise.resolve(me()).then(Le=>X(Le)?Promise.resolve(Le):Pe())};return Pe()}e.$ih=d;function w(ge,X=le=>!!le,x=null){if(ge.length===0)return Promise.resolve(x);let le=ge.length;const de=()=>{le=-1;for(const Pe of ge)Pe.cancel?.()};return new Promise((Pe,me)=>{for(const Ie of ge)Ie.then(Le=>{--le>=0&&X(Le)?(de(),Pe(Le)):le===0&&Pe(x)}).catch(Le=>{--le>=0&&(de(),me(Le))})})}e.$jh=w;class b{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new P.$5d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,le)=>{this.g.push({factory:X,c:x,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const x=X.factory();x.then(X.c,X.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$kh=b;class M extends b{constructor(){super(1)}}e.$lh=M;class T{constructor(){this.a=new he,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$mh=T;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new $e;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,x=R.$Hg){const le=x.getComparisonKey(X);return this.a.get(le)?.size??0}queueFor(X,x,le=R.$Hg){const de=le.getComparisonKey(X);let Pe=this.a.get(de);if(!Pe){Pe=new M;const me=this.f++,Ie=P.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$3c),this.d.set(me,Ie),this.a.set(de,Pe)}return Pe.queue(x)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$nh=G;class W{constructor(X,x){this.a=-1,typeof X=="function"&&typeof x=="number"&&this.setIfNotSet(X,x)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,x){this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},x)}setIfNotSet(X,x){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},x))}}e.$oh=W;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,x,le=globalThis){this.cancel();const de=le.setInterval(()=>{X()},x);this.d=(0,F.$Rc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$ph=U;class C{constructor(X,x){this.b=-1,this.a=X,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$qh=C;class O{constructor(X,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=X,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$rh=O;class V extends C{constructor(X,x){super(X,x),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$sh=V;class re extends F.$Tc{constructor(X,x){super(),this.g=X,this.h=x,this.a=[],this.b=this.B(new F.$Uc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of X)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$th=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$vh=(ge,X)=>{(0,g.$B)(()=>{if(x)return;const le=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$vh=(ge,X,x)=>{const le=ge.requestIdleCallback(X,typeof x=="number"?{timeout:x}:void 0);let de=!1;return{dispose(){de||(de=!0,ge.cancelIdleCallback(le))}}},e.$uh=ge=>(0,e.$vh)(globalThis,ge)}();class ce{constructor(X,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$vh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$wh=ce;class ye extends ce{constructor(X){super(globalThis,X)}}e.$xh=ye;async function De(ge,X,x){let le;for(let de=0;de<x;de++)try{return await ge()}catch(Pe){le=Pe,await y(X)}throw le}e.$yh=De;class he{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,x,le){return this.a={taskId:X,cancel:()=>le?.(),promise:x},x.then(()=>this.d(X),()=>this.d(X)),x}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:x,resolve:le,reject:de}=t();this.b={run:X,promise:x,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$zh=he;class ve{constructor(X,x=()=>Date.now()){this.d=X,this.f=x,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$Ah=ve;var se;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(se||(se={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((X,x)=>{this.a=X,this.b=x})}complete(X){return new Promise(x=>{this.a(X),this.d={outcome:0,value:X},x()})}error(X){return new Promise(x=>{this.b(X),this.d={outcome:1,value:X},x()})}cancel(){return this.error(new L.$5)}}e.$Bh=$e;var ee;(function(ge){async function X(le){let de;const Pe=await Promise.all(le.map(me=>me.then(Ie=>Ie,Ie=>{de||(de=Ie)})));if(typeof de<"u")throw de;return Pe}ge.settled=X;function x(le){return new Promise(async(de,Pe)=>{try{await le(de,Pe)}catch(me){Pe(me)}})}ge.withAsyncBody=x})(ee||(e.Promises=ee={}));class Y{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ch=Y;class q{constructor(X){this.b=X,this.a=new k.$V(()=>new Y(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Dh=q;var ne;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(ne||(ne={}));class Se{static fromArray(X){return new Se(x=>{x.emitMany(X)})}static fromPromise(X){return new Se(async x=>{x.emitMany(await X)})}static fromPromises(X){return new Se(async x=>{await Promise.all(X.map(async le=>x.emitOne(await le)))})}static merge(X){return new Se(async x=>{await Promise.all(X.map(async le=>{for await(const de of le)x.emitOne(de)}))})}static{this.EMPTY=Se.fromArray([])}constructor(X){this.a=0,this.b=[],this.d=null,this.f=new P.$5d,queueMicrotask(async()=>{const x={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(X(x)),this.j()}catch(le){this.k(le)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(X,x){return new Se(async le=>{for await(const de of X)le.emitOne(x(de))})}map(X){return Se.map(this,X)}static filter(X,x){return new Se(async le=>{for await(const de of X)x(de)&&le.emitOne(de)})}filter(X){return Se.filter(this,X)}static coalesce(X){return Se.filter(X,x=>!!x)}coalesce(){return Se.coalesce(this)}static async toPromise(X){const x=[];for await(const le of X)x.push(le);return x}toPromise(){return Se.toPromise(this)}g(X){this.a===0&&(this.b.push(X),this.f.fire())}h(X){this.a===0&&(this.b=this.b.concat(X),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(X){this.a===0&&(this.a=2,this.d=X,this.f.fire())}}e.$Eh=Se;class Te extends Se{constructor(X,x){super(x),this.l=X}cancel(){this.l.cancel()}}e.$Fh=Te;function Ce(ge){const X=new S.$ce,x=ge(X.token);return new Te(X,async le=>{const de=X.token.onCancellationRequested(()=>{de.dispose(),X.dispose(),le.reject(new L.$5)});try{for await(const Pe of x){if(X.token.isCancellationRequested)return;le.emitOne(Pe)}de.dispose(),X.dispose()}catch(Pe){de.dispose(),X.dispose(),le.reject(Pe)}})}e.$Gh=Ce;class be{constructor(){this.a=new $e,this.b=new Se(le=>{if(X){le.reject(X);return}return x&&le.emitMany(x),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let X,x;this.f=le=>{x||(x=[]),x.push(le)},this.d=le=>{X||(X=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$Hh=be}),define(Ae[34],Me([1,0,18,11,45,28,19,20,13]),function(fe,e,S,L,P,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;function k(){return Object.create(null)}e.$Sj=k,e.$Tj="**",e.$Uj="/";const A="[/\\\\]",D="[^/\\\\]",h=/\//g;function v(ce,ye){switch(ce){case 0:return"";case 1:return`${D}*?`;default:return`(?:${A}|${D}+${A}${ye?`|${A}${D}+`:""})*?`}}function p(ce,ye){if(!ce)return[];const De=[];let he=!1,ve=!1,se="";for(const $e of ce){switch($e){case ye:if(!he&&!ve){De.push(se),se="";continue}break;case"{":he=!0;break;case"}":he=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}se+=$e}return se&&De.push(se),De}e.$Vj=p;function s(ce){if(!ce)return"";let ye="";const De=p(ce,e.$Uj);if(De.every(he=>he===e.$Tj))ye=".*";else{let he=!1;De.forEach((ve,se)=>{if(ve===e.$Tj){if(he)return;ye+=v(2,se===De.length-1)}else{let $e=!1,ee="",Y=!1,q="";for(const ne of ve){if(ne!=="}"&&$e){ee+=ne;continue}if(Y&&(ne!=="]"||!q)){let Se;ne==="-"?Se=ne:(ne==="^"||ne==="!")&&!q?Se="^":ne===e.$Uj?Se="":Se=(0,f.$Xe)(ne),q+=Se;continue}switch(ne){case"{":$e=!0;continue;case"[":Y=!0;continue;case"}":{const Te=`(?:${p(ee,",").map(Ce=>s(Ce)).join("|")})`;ye+=Te,$e=!1,ee="";break}case"]":{ye+="["+q+"]",Y=!1,q="";break}case"?":ye+=D;continue;case"*":ye+=v(1);continue;default:ye+=(0,f.$Xe)(ne)}}se<De.length-1&&(De[se+1]!==e.$Tj||se+2<De.length)&&(ye+=A)}he=ve===e.$Tj})}return ye}const o=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new F.$Dc(1e4),$=function(){return!1},a=function(){return null};function c(ce,ye){if(!ce)return a;let De;typeof ce!="string"?De=ce.pattern:De=ce,De=De.trim();const he=`${De}_${!!ye.trimForExclusions}`;let ve=i.get(he);if(ve)return E(ve,ce);let se;return o.test(De)?ve=m(De.substr(4),De):(se=t.exec(y(De,ye)))?ve=I(se[1],De):(ye.trimForExclusions?r:n).test(De)?ve=d(De,ye):(se=u.exec(y(De,ye)))?ve=w(se[1].substr(1),De,!0):(se=l.exec(y(De,ye)))?ve=w(se[1],De,!1):ve=b(De),i.set(he,ve),E(ve,ce)}function E(ce,ye){if(typeof ye=="string")return ce;const De=function(he,ve){return(0,P.$fg)(he,ye.base,!g.$k)?ce((0,f.$3e)(he.substr(ye.base.length),R.sep),ve):null};return De.allBasenames=ce.allBasenames,De.allPaths=ce.allPaths,De.basenames=ce.basenames,De.patterns=ce.patterns,De}function y(ce,ye){return ye.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function m(ce,ye){return function(De,he){return typeof De=="string"&&De.endsWith(ce)?ye:null}}function I(ce,ye){const De=`/${ce}`,he=`\\${ce}`,ve=function($e,ee){return typeof $e!="string"?null:ee?ee===ce?ye:null:$e===ce||$e.endsWith(De)||$e.endsWith(he)?ye:null},se=[ce];return ve.basenames=se,ve.patterns=[ye],ve.allBasenames=se,ve}function d(ce,ye){const De=V(ce.slice(1,-1).split(",").map(ee=>c(ee,ye)).filter(ee=>ee!==a),ce),he=De.length;if(!he)return a;if(he===1)return De[0];const ve=function(ee,Y){for(let q=0,ne=De.length;q<ne;q++)if(De[q](ee,Y))return ce;return null},se=De.find(ee=>!!ee.allBasenames);se&&(ve.allBasenames=se.allBasenames);const $e=De.reduce((ee,Y)=>Y.allPaths?ee.concat(Y.allPaths):ee,[]);return $e.length&&(ve.allPaths=$e),ve}function w(ce,ye,De){const he=R.sep===R.$gc.sep,ve=he?ce:ce.replace(h,R.sep),se=R.sep+ve,$e=R.$gc.sep+ce;let ee;return De?ee=function(Y,q){return typeof Y=="string"&&(Y===ve||Y.endsWith(se)||!he&&(Y===ce||Y.endsWith($e)))?ye:null}:ee=function(Y,q){return typeof Y=="string"&&(Y===ve||!he&&Y===ce)?ye:null},ee.allPaths=[(De?"*/":"./")+ce],ee}function b(ce){try{const ye=new RegExp(`^${s(ce)}$`);return function(De){return ye.lastIndex=0,typeof De=="string"&&ye.test(De)?ce:null}}catch{return a}}function M(ce,ye,De){return!ce||typeof ye!="string"?!1:T(ce)(ye,void 0,De)}e.$Wj=M;function T(ce,ye={}){if(!ce)return $;if(typeof ce=="string"||G(ce)){const De=c(ce,ye);if(De===a)return $;const he=function(ve,se){return!!De(ve,se)};return De.allBasenames&&(he.allBasenames=De.allBasenames),De.allPaths&&(he.allPaths=De.allPaths),he}return C(ce,ye)}e.$Xj=T;function G(ce){const ye=ce;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}e.$Yj=G;function W(ce){return ce.allBasenames||[]}e.$Zj=W;function U(ce){return ce.allPaths||[]}e.$1j=U;function C(ce,ye){const De=V(Object.getOwnPropertyNames(ce).map(ee=>O(ee,ce[ee],ye)).filter(ee=>ee!==a)),he=De.length;if(!he)return a;if(!De.some(ee=>!!ee.requiresSiblings)){if(he===1)return De[0];const ee=function(ne,Se){let Te;for(let Ce=0,be=De.length;Ce<be;Ce++){const ge=De[Ce](ne,Se);if(typeof ge=="string")return ge;(0,L.$3g)(ge)&&(Te||(Te=[]),Te.push(ge))}return Te?(async()=>{for(const Ce of Te){const be=await Ce;if(typeof be=="string")return be}return null})():null},Y=De.find(ne=>!!ne.allBasenames);Y&&(ee.allBasenames=Y.allBasenames);const q=De.reduce((ne,Se)=>Se.allPaths?ne.concat(Se.allPaths):ne,[]);return q.length&&(ee.allPaths=q),ee}const ve=function(ee,Y,q){let ne,Se;for(let Te=0,Ce=De.length;Te<Ce;Te++){const be=De[Te];be.requiresSiblings&&q&&(Y||(Y=(0,R.$nc)(ee)),ne||(ne=Y.substr(0,Y.length-(0,R.$oc)(ee).length)));const ge=be(ee,Y,ne,q);if(typeof ge=="string")return ge;(0,L.$3g)(ge)&&(Se||(Se=[]),Se.push(ge))}return Se?(async()=>{for(const Te of Se){const Ce=await Te;if(typeof Ce=="string")return Ce}return null})():null},se=De.find(ee=>!!ee.allBasenames);se&&(ve.allBasenames=se.allBasenames);const $e=De.reduce((ee,Y)=>Y.allPaths?ee.concat(Y.allPaths):ee,[]);return $e.length&&(ve.allPaths=$e),ve}function O(ce,ye,De){if(ye===!1)return a;const he=c(ce,De);if(he===a)return a;if(typeof ye=="boolean")return he;if(ye){const ve=ye.when;if(typeof ve=="string"){const se=($e,ee,Y,q)=>{if(!q||!he($e,ee))return null;const ne=ve.replace("$(basename)",()=>Y),Se=q(ne);return(0,L.$3g)(Se)?Se.then(Te=>Te?ce:null):Se?ce:null};return se.requiresSiblings=!0,se}}return he}function V(ce,ye){const De=ce.filter(ee=>!!ee.basenames);if(De.length<2)return ce;const he=De.reduce((ee,Y)=>{const q=Y.basenames;return q?ee.concat(q):ee},[]);let ve;if(ye){ve=[];for(let ee=0,Y=he.length;ee<Y;ee++)ve.push(ye)}else ve=De.reduce((ee,Y)=>{const q=Y.patterns;return q?ee.concat(q):ee},[]);const se=function(ee,Y){if(typeof ee!="string")return null;if(!Y){let ne;for(ne=ee.length;ne>0;ne--){const Se=ee.charCodeAt(ne-1);if(Se===47||Se===92)break}Y=ee.substr(ne)}const q=he.indexOf(Y);return q!==-1?ve[q]:null};se.basenames=he,se.patterns=ve,se.allBasenames=he;const $e=ce.filter(ee=>!ee.basenames);return $e.push(se),$e}function re(ce,ye){return(0,S.$ub)(ce,ye,(De,he)=>typeof De=="string"&&typeof he=="string"?De===he:typeof De!="string"&&typeof he!="string"?De.base===he.base&&De.pattern===he.pattern:!1)}e.$2j=re}),define(Ae[46],Me([1,0,15,127,25,13,2]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class f{constructor(n="",r=!1){if(this.value=n,typeof this.value!="string")throw(0,S.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(n,r=0){return this.value+=h(this.supportThemeIcons?(0,L.$mk)(n):n).replace(/([ \t]+)/g,(u,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,r){return this.value+=`
${v(r,n)}
`,this}appendLink(n,r,u){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(n),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(n,r){const u=new RegExp((0,F.$Xe)(r),"g");return n.replace(u,(l,i)=>n.charAt(i-1)!=="\\"?`\\${l}`:l)}}e.$sk=f;function k(t){return A(t)?!t.value:Array.isArray(t)?t.every(k):!0}e.$tk=k;function A(t){return t instanceof f?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$uk=A;function D(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,P.$Kg)(R.URI.from(t.baseUri),R.URI.from(n.baseUri)))}e.$vk=D;function h(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$wk=h;function v(t,n){const r=t.match(/^`+/gm)?.reduce((l,i)=>l.length>i.length?l:i).length??0,u=r>=3?r+1:3;return[`${"`".repeat(u)}${n}`,t,`${"`".repeat(u)}`].join(`
`)}e.$xk=v;function p(t){return t.replace(/"/g,"&quot;")}e.$yk=p;function s(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$zk=s;function o(t){const n=[],r=t.split("|").map(l=>l.trim());t=r[0];const u=r[1];if(u){const l=/height=(\d+)/.exec(u),i=/width=(\d+)/.exec(u),$=l?l[1]:"",a=i?i[1]:"",c=isFinite(parseInt(a)),E=isFinite(parseInt($));c&&n.push(`width="${a}"`),E&&n.push(`height="${$}"`)}return{href:t,dimensions:n}}e.$Ak=o}),define(Ae[94],Me([1,0,18,45,19,20,25,13]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=void 0;function f(c,E){const{os:y,tildify:m,relative:I}=E;if(I){const b=k(c,I,y);if(typeof b=="string")return b}let d=c.fsPath;if(y===1&&!F.$i?d=d.replace(/\//g,"\\"):y!==1&&F.$i&&(d=d.replace(/\\/g,"/")),y!==1&&m?.userHome){const b=m.userHome.fsPath;let M;c.scheme!==m.userHome.scheme&&c.path[0]===P.$gc.sep&&c.path[1]!==P.$gc.sep?M=m.userHome.with({path:c.path}).fsPath:M=d,d=h(M,b,y)}return(y===1?P.$fc:P.$gc).normalize(A(d,y===1))}e.$8v=f;function k(c,E,y){const m=y===1?P.$fc:P.$gc,I=y===3?R.$Hg:R.$Jg,d=E.getWorkspace(),w=(0,S.$Ob)(d.folders);if(!w)return;c.scheme!==w.uri.scheme&&c.path[0]===P.$gc.sep&&c.path[1]!==P.$gc.sep&&(c=w.uri.with({path:c.path}));const b=E.getWorkspaceFolder(c);if(!b)return;let M;if(I.isEqual(b.uri,c)?M="":M=I.relativePath(b.uri,c)??"",M&&(M=m.normalize(M)),d.folders.length>1&&!E.noPrefix){const T=b.name?b.name:I.basenameOrAuthority(b.uri);M=M?`${T} \u2022 ${M}`:T}return M}function A(c,E=F.$i){return(0,L.$jg)(c,E)?c.charAt(0).toUpperCase()+c.slice(1):c}e.$9v=A;let D=Object.create(null);function h(c,E,y=F.OS){if(y===1||!c||!E)return c;let m=D.original===E?D.normalized:void 0;m||(m=E,F.$i&&(m=(0,L.$_f)(m)),m=`${(0,g.$4e)(m,P.$gc.sep)}${P.$gc.sep}`,D={original:E,normalized:m});let I=c;return F.$i&&(I=(0,L.$_f)(I)),(y===3?I.startsWith(m):(0,g.$kf)(I,m))?`~/${I.substr(m.length)}`:c}e.$0v=h;function v(c,E){return c.replace(/^~($|\/|\\)/,`${E}$1`)}e.$$v=v;const p="\u2026",s="\\\\",o="~";function t(c,E=P.sep){const y=new Array(c.length);let m=!1;for(let I=0;I<c.length;I++){const d=c[I];if(d===""){y[I]=`.${E}`;continue}if(!d){y[I]=d;continue}m=!0;let w="",b=d;b.indexOf(s)===0?(w=b.substr(0,b.indexOf(s)+s.length),b=b.substr(b.indexOf(s)+s.length)):b.indexOf(E)===0?(w=b.substr(0,b.indexOf(E)+E.length),b=b.substr(b.indexOf(E)+E.length)):b.indexOf(o)===0&&(w=b.substr(0,b.indexOf(o)+o.length),b=b.substr(b.indexOf(o)+o.length));const M=b.split(E);for(let T=1;m&&T<=M.length;T++)for(let G=M.length-T;m&&G>=0;G--){m=!1;let W=M.slice(G,G+T).join(E);for(let U=0;!m&&U<c.length;U++)if(U!==I&&c[U]&&c[U].indexOf(W)>-1){const C=G+T===M.length,O=G>0&&c[U].indexOf(E)>-1?E+W:W,V=c[U].endsWith(O);m=!C||V}if(!m){let U="";(M[0].endsWith(":")||w!=="")&&(G===1&&(G=0,T++,W=M[0]+E+W),G>0&&(U=M[0]+E),U=w+U),G>0&&(U=U+p+E),U=U+W,G+T<M.length&&(U=U+E+p),y[I]=U}}m&&(y[I]=d)}return y}e.$_v=t;var n;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function r(c,E=Object.create(null)){const y=[];let m=!1,I="";for(const d of c)if(d==="$"||m&&d==="{")I&&y.push({value:I,type:n.TEXT}),I="",m=!0;else if(d==="}"&&m){const w=E[I];if(typeof w=="string")w.length&&y.push({value:w,type:n.VARIABLE});else if(w){const b=y[y.length-1];(!b||b.type!==n.SEPARATOR)&&y.push({value:w.label,type:n.SEPARATOR})}I="",m=!1}else I+=d;return I&&!m&&y.push({value:I,type:n.TEXT}),y.filter((d,w)=>{if(d.type===n.SEPARATOR){const b=y[w-1],M=y[w+1];return[b,M].every(T=>T&&(T.type===n.VARIABLE||T.type===n.TEXT)&&T.value.length>0)}return!0}).map(d=>d.value).join("")}e.$aw=r;function u(c,E){return F.$j||E?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$j?"&":"&&"):c.replace(/&&|&/g,y=>y==="&"?"&&":"&")}e.$bw=u;function l(c,E){return F.$j||E?c.replace(/\(&&\w\)|&&/g,""):F.$i?c.replace(/&&|&/g,y=>y==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.$cw=l;function i(c){return c.replace(/&/g,"&&")}e.$dw=i;function $(c){if(c.endsWith("]")){const E=c.lastIndexOf(" [",c.length-2);if(E!==-1){const y=a(c.substring(0,E)),m=c.substring(E);return{name:y.name+m,parentPath:y.parentPath}}}return a(c)}e.$ew=$;function a(c){const E=c.indexOf("/")!==-1?P.$gc:P.$fc,y=E.basename(c),m=E.dirname(c);return y.length?{name:y,parentPath:m}:{name:m,parentPath:""}}}),define(Ae[140],Me([1,0,24,2]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=void 0;function P(D){return D.toJSON()}class F{constructor(h){this.a=h}transformIncoming(h){const v=this.a.transformIncoming(h);return v===h?h:P(L.URI.from(v))}transformOutgoing(h){const v=this.a.transformOutgoing(h);return v===h?h:P(L.URI.from(v))}transformOutgoingURI(h){const v=this.a.transformOutgoing(h);return v===h?h:L.URI.from(v)}transformOutgoingScheme(h){return this.a.transformOutgoingScheme(h)}}e.$dn=F,e.$en=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function R(D,h,v){if(!D||v>200)return null;if(typeof D=="object"){if(D instanceof L.URI)return h.transformOutgoing(D);for(const p in D)if(Object.hasOwnProperty.call(D,p)){const s=R(D[p],h,v+1);s!==null&&(D[p]=s)}}return null}function g(D,h){const v=R(D,h,0);return v===null?D:v}e.$fn=g;function f(D,h,v,p){if(!D||p>200)return null;if(typeof D=="object"){if(D.$mid===1)return v?L.URI.revive(h.transformIncoming(D)):h.transformIncoming(D);if(D instanceof S.$se)return null;for(const s in D)if(Object.hasOwnProperty.call(D,s)){const o=f(D[s],h,v,p+1);o!==null&&(D[s]=o)}}return null}function k(D,h){const v=f(D,h,!1,0);return v===null?D:v}e.$gn=k;function A(D,h){const v=f(D,h,!0,0);return v===null?D:v}e.$hn=A}),define(Ae[141],Me([1,0,13,20,24]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$mt=e.$lt=void 0;let F;function R(){return F||(F=new TextDecoder("UTF-16LE")),F}let g;function f(){return g||(g=new TextDecoder("UTF-16BE")),g}let k;function A(){return k||(k=L.$D()?R():f()),k}e.$lt=A;function D(p,s,o){const t=new Uint16Array(p.buffer,s,o);return o>0&&(t[0]===65279||t[0]===65534)?h(p,s,o):R().decode(t)}e.$mt=D;function h(p,s,o){const t=[];let n=0;for(let r=0;r<o;r++){const u=P.$ue(p,s);s+=2,t[n++]=String.fromCharCode(u)}return t.join("")}class v{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return A().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const o=this.a-this.d;o<=1&&(o===0||S.$nf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const o=s.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=s;return}for(let t=0;t<o;t++)this.b[this.d++]=s.charCodeAt(t)}}e.$nt=v}),define(Ae[142],Me([1,0,24,141]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pt=e.$ot=void 0;function P(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class F{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,A,D,h){this.oldPosition=k,this.oldText=A,this.newPosition=D,this.newText=h}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,A,D){const h=A.length;S.$xe(k,h,D),D+=4;for(let v=0;v<h;v++)S.$ve(k,A.charCodeAt(v),D),D+=2;return D}static d(k,A){const D=S.$we(k,A);return A+=4,(0,L.$mt)(k,A,D)}writeSize(){return 8+F.a(this.oldText)+F.a(this.newText)}write(k,A){return S.$xe(k,this.oldPosition,A),A+=4,S.$xe(k,this.newPosition,A),A+=4,A=F.c(k,this.oldText,A),A=F.c(k,this.newText,A),A}static read(k,A,D){const h=S.$we(k,A);A+=4;const v=S.$we(k,A);A+=4;const p=F.d(k,A);A+=F.a(p);const s=F.d(k,A);return A+=F.a(s),D.push(new F(h,p,v,s)),A}}e.$ot=F;function R(f,k){return f===null||f.length===0?k:new g(f,k).compress()}e.$pt=R;class g{constructor(k,A){this.a=k,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,A=0,D=this.n(k),h=this.l(A);for(;k<this.f||A<this.h;){if(D===null){this.k(h),h=this.l(++A);continue}if(h===null){this.m(D),D=this.n(++k);continue}if(h.oldEnd<=D.newPosition){this.k(h),h=this.l(++A);continue}if(D.newEnd<=h.oldPosition){this.m(D),D=this.n(++k);continue}if(h.oldPosition<D.newPosition){const[t,n]=g.r(h,D.newPosition-h.oldPosition);this.k(t),h=n;continue}if(D.newPosition<h.oldPosition){const[t,n]=g.q(D,h.oldPosition-D.newPosition);this.m(t),D=n;continue}let s,o;if(h.oldEnd===D.newEnd)s=D,o=h,D=this.n(++k),h=this.l(++A);else if(h.oldEnd<D.newEnd){const[t,n]=g.q(D,h.oldLength);s=t,o=h,D=n,h=this.l(++A)}else{const[t,n]=g.r(h,D.newLength);s=D,o=t,D=this.n(++k),h=n}this.d[this.e++]=new F(s.oldPosition,s.oldText,o.newPosition,o.newText),this.g+=s.newLength-s.oldLength,this.j+=o.newLength-o.oldLength}const v=g.s(this.d);return g.t(v)}k(k){this.d[this.e++]=g.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=g.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,A){return new F(A.oldPosition-k,A.oldText,A.newPosition,A.newText)}static p(k,A){return new F(A.oldPosition,A.oldText,A.newPosition+k,A.newText)}static q(k,A){const D=k.newText.substr(0,A),h=k.newText.substr(A);return[new F(k.oldPosition,k.oldText,k.newPosition,D),new F(k.oldEnd,"",k.newPosition+A,h)]}static r(k,A){const D=k.oldText.substr(0,A),h=k.oldText.substr(A);return[new F(k.oldPosition,D,k.newPosition,k.newText),new F(k.oldPosition+A,h,k.newEnd,"")]}static s(k){if(k.length===0)return k;const A=[];let D=0,h=k[0];for(let v=1;v<k.length;v++){const p=k[v];h.oldEnd===p.oldPosition?h=new F(h.oldPosition,h.oldText+p.oldText,h.newPosition,h.newText+p.newText):(A[D++]=h,h=p)}return A[D++]=h,A}static t(k){if(k.length===0)return k;const A=[];let D=0;for(let h=0;h<k.length;h++){const v=k[h];v.oldText!==v.newText&&(A[D++]=v)}return A}}}),define(Ae[143],Me([1,0,34,19]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=e.$Mt=void 0;function P(R,g,f,k,A,D){if(Array.isArray(R)){let h=0;for(const v of R){const p=P(v,g,f,k,A,D);if(p===10)return p;p>h&&(h=p)}return h}else{if(typeof R=="string")return k?R==="*"?5:R===f?10:0:0;if(R){const{language:h,pattern:v,scheme:p,hasAccessToAllModels:s,notebookType:o}=R;if(!k&&!s)return 0;o&&A&&(g=A);let t=0;if(p)if(p===g.scheme)t=10;else if(p==="*")t=5;else return 0;if(h)if(h===f)t=10;else if(h==="*")t=Math.max(t,5);else return 0;if(o)if(o===D)t=10;else if(o==="*"&&D!==void 0)t=Math.max(t,5);else return 0;if(v){let n;if(typeof v=="string"?n=v:n={...v,base:(0,L.$hc)(v.base)},n===g.fsPath||(0,S.$Wj)(n,g.fsPath))t=10;else return 0}return t}else return 0}}e.$Mt=P;function F(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(F):!!R.notebookType}e.$Nt=F}),define(Ae[144],Me([1,0,5,13,29,92,90,129,142,6]),function(fe,e,S,L,P,F,R,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nC=void 0;class A extends k.$Tc{constructor(h,v,p,s,o,t,n){super(),this.m=this.B(new S.$5d),this.onDidChangeContent=this.m.event,this.f=v,this.j=!t,this.g=s,this.h=o,this.c=new R.$mC(h,p,n)}equals(h){return!(h instanceof A)||this.f!==h.f||this.getEOL()!==h.getEOL()?!1:this.c.equal(h.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(h){return this.c.createSnapshot(h?this.f:"")}getOffsetAt(h,v){return this.c.getOffsetAt(h,v)}getPositionAt(h){return this.c.getPositionAt(h)}getRangeAt(h,v){const p=h+v,s=this.getPositionAt(h),o=this.getPositionAt(p);return new P.$6s(s.lineNumber,s.column,o.lineNumber,o.column)}getValueInRange(h,v=0){if(h.isEmpty())return"";const p=this.n(v);return this.c.getValueInRange(h,p)}getValueLengthInRange(h,v=0){if(h.isEmpty())return 0;if(h.startLineNumber===h.endLineNumber)return h.endColumn-h.startColumn;const p=this.getOffsetAt(h.startLineNumber,h.startColumn),s=this.getOffsetAt(h.endLineNumber,h.endColumn);let o=0;const t=this.n(v),n=this.getEOL();if(t.length!==n.length){const r=t.length-n.length,u=h.endLineNumber-h.startLineNumber;o=r*u}return s-p+o}getCharacterCountInRange(h,v=0){if(this.j){let p=0;const s=h.startLineNumber,o=h.endLineNumber;for(let t=s;t<=o;t++){const n=this.getLineContent(t),r=t===s?h.startColumn-1:0,u=t===o?h.endColumn-1:n.length;for(let l=r;l<u;l++)L.$nf(n.charCodeAt(l))?(p=p+1,l=l+1):p=p+1}return p+=this.n(v).length*(o-s),p}return this.getValueLengthInRange(h,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(h){return this.c.getLineContent(h)}getLineCharCode(h,v){return this.c.getLineCharCode(h,v)}getCharCode(h){return this.c.getCharCode(h)}getLineLength(h){return this.c.getLineLength(h)}getLineMinColumn(h){return 1}getLineMaxColumn(h){return this.getLineLength(h)+1}getLineFirstNonWhitespaceColumn(h){const v=L.$$e(this.getLineContent(h));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(h){const v=L.$af(this.getLineContent(h));return v===-1?0:v+2}n(h){switch(h){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(h){this.c.setEOL(h)}applyEdits(h,v,p){let s=this.g,o=this.h,t=this.j,n=!0,r=[];for(let E=0;E<h.length;E++){const y=h[E];n&&y._isTracked&&(n=!1);const m=y.range;if(y.text){let M=!0;t||(M=!L.$yf(y.text),t=M),!s&&M&&(s=L.$xf(y.text)),!o&&M&&(o=L.$Af(y.text))}let I="",d=0,w=0,b=0;if(y.text){let M;[d,w,b,M]=(0,g.$Ft)(y.text);const T=this.getEOL();M===0||M===(T===`\r
`?2:1)?I=y.text:I=y.text.replace(/\r\n|\r|\n/g,T)}r[E]={sortIndex:E,identifier:y.identifier||null,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m),text:I,eolCount:d,firstLineLength:w,lastLineLength:b,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}r.sort(A.u);let u=!1;for(let E=0,y=r.length-1;E<y;E++){const m=r[E].range.getEndPosition(),I=r[E+1].range.getStartPosition();if(I.isBeforeOrEqual(m)){if(I.isBefore(m))throw new Error("Overlapping ranges are not allowed!");u=!0}}n&&(r=this.s(r));const l=p||v?A._getInverseEditRanges(r):[],i=[];if(v)for(let E=0;E<r.length;E++){const y=r[E],m=l[E];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let I=m.startLineNumber;I<=m.endLineNumber;I++){let d="";I===m.startLineNumber&&(d=this.getLineContent(y.range.startLineNumber),L.$$e(d)!==-1)||i.push({lineNumber:I,oldContent:d})}}let $=null;if(p){let E=0;$=[];for(let y=0;y<r.length;y++){const m=r[y],I=l[y],d=this.getValueInRange(m.range),w=m.rangeOffset+E;E+=m.text.length-d.length,$[y]={sortIndex:m.sortIndex,identifier:m.identifier,range:I,text:d,textChange:new f.$ot(m.rangeOffset,d,w,m.text)}}u||$.sort((y,m)=>y.sortIndex-m.sortIndex)}this.g=s,this.h=o,this.j=t;const a=this.t(r);let c=null;if(v&&i.length>0){i.sort((E,y)=>y.lineNumber-E.lineNumber),c=[];for(let E=0,y=i.length;E<y;E++){const m=i[E].lineNumber;if(E>0&&i[E-1].lineNumber===m)continue;const I=i[E].oldContent,d=this.getLineContent(m);d.length===0||d===I||L.$$e(d)!==-1||c.push(m)}}return this.m.fire(),new F.$qv($,a,c)}s(h){return h.length<1e3?h:[this._toSingleEditOperation(h)]}_toSingleEditOperation(h){let v=!1;const p=h[0].range,s=h[h.length-1].range,o=new P.$6s(p.startLineNumber,p.startColumn,s.endLineNumber,s.endColumn);let t=p.startLineNumber,n=p.startColumn;const r=[];for(let a=0,c=h.length;a<c;a++){const E=h[a],y=E.range;v=v||E.forceMoveMarkers,r.push(this.getValueInRange(new P.$6s(t,n,y.startLineNumber,y.startColumn))),E.text.length>0&&r.push(E.text),t=y.endLineNumber,n=y.endColumn}const u=r.join(""),[l,i,$]=(0,g.$Ft)(u);return{sortIndex:0,identifier:h[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:u,eolCount:l,firstLineLength:i,lastLineLength:$,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(h){h.sort(A.w);const v=[];for(let p=0;p<h.length;p++){const s=h[p],o=s.range.startLineNumber,t=s.range.startColumn,n=s.range.endLineNumber,r=s.range.endColumn;if(o===n&&t===r&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const u=new P.$6s(o,t,n,r);v.push({range:u,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return v}findMatchesLineByLine(h,v,p,s){return this.c.findMatchesLineByLine(h,v,p,s)}getPieceTree(){return this.c}static _getInverseEditRange(h,v){const p=h.startLineNumber,s=h.startColumn,[o,t,n]=(0,g.$Ft)(v);let r;if(v.length>0){const u=o+1;u===1?r=new P.$6s(p,s,p,s+t):r=new P.$6s(p,s,p+u-1,n+1)}else r=new P.$6s(p,s,p,s);return r}static _getInverseEditRanges(h){const v=[];let p=0,s=0,o=null;for(let t=0,n=h.length;t<n;t++){const r=h[t];let u,l;o?o.range.endLineNumber===r.range.startLineNumber?(u=p,l=s+(r.range.startColumn-o.range.endColumn)):(u=p+(r.range.startLineNumber-o.range.endLineNumber),l=r.range.startColumn):(u=r.range.startLineNumber,l=r.range.startColumn);let i;if(r.text.length>0){const $=r.eolCount+1;$===1?i=new P.$6s(u,l,u,l+r.firstLineLength):i=new P.$6s(u,l,u+$-1,r.lastLineLength+1)}else i=new P.$6s(u,l,u,l);p=i.endLineNumber,s=i.endColumn,v.push(i),o=r}return v}static u(h,v){const p=P.$6s.compareRangesUsingEnds(h.range,v.range);return p===0?h.sortIndex-v.sortIndex:p}static w(h,v){const p=P.$6s.compareRangesUsingEnds(h.range,v.range);return p===0?v.sortIndex-h.sortIndex:-p}}e.$nC=A}),define(Ae[145],Me([1,0,13,90,144]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oC=void 0;class F{constructor(f,k,A,D,h,v,p,s,o){this.a=f,this.b=k,this.c=A,this.d=D,this.e=h,this.f=v,this.g=p,this.h=s,this.j=o}k(f){const k=this.c+this.d+this.e,A=this.c+this.e;return k===0?f===1?`
`:`\r
`:A>k/2?`\r
`:`
`}create(f){const k=this.k(f),A=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let h=0,v=A.length;h<v;h++){const p=A[h].buffer.replace(/\r\n|\r|\n/g,k),s=(0,L.$iC)(p);A[h]=new L.$lC(p,s)}const D=new P.$nC(A,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&S.$Gf(f)&&(this.b=S.$Ff,f=f.substr(1));const k=f.charCodeAt(f.length-1);k===13||k>=55296&&k<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=k):(this.m(f,!1),this.c=!1,this.d=k)}m(f,k){!k&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const k=(0,L.$jC)(this.e,f);this.a.push(new L.$lC(f,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=S.$xf(f)),this.k||(this.k=S.$Af(f)))}finish(f=!0){return this.o(),new F(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const k=(0,L.$iC)(f.buffer);f.lineStarts=k,this.d===13&&this.f++}}}e.$oC=R}),define(Ae[95],Me([1,0,24,20]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9_=e.$8_=void 0;var P;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(P||(P={}));function F(D){for(let h=0,v=D.length;h<v;h+=4){const p=D[h+0],s=D[h+1],o=D[h+2],t=D[h+3];D[h+0]=t,D[h+1]=o,D[h+2]=s,D[h+3]=p}}function R(D){const h=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return L.$D()||F(h),S.$se.wrap(h)}function g(D){const h=D.buffer;if(L.$D()||F(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const v=new Uint8Array(h.byteLength);return v.set(h),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function f(D){const h=new Uint32Array(k(D));let v=0;if(h[v++]=D.id,D.type==="full")h[v++]=1,h[v++]=D.data.length,h.set(D.data,v),v+=D.data.length;else{h[v++]=2,h[v++]=D.deltas.length;for(const p of D.deltas)h[v++]=p.start,h[v++]=p.deleteCount,p.data?(h[v++]=p.data.length,h.set(p.data,v),v+=p.data.length):h[v++]=0}return R(h)}e.$8_=f;function k(D){let h=0;if(h+=2,D.type==="full")h+=1+D.data.length;else{h+=1,h+=3*D.deltas.length;for(const v of D.deltas)v.data&&(h+=v.data.length)}return h}function A(D){const h=g(D);let v=0;const p=h[v++];if(h[v++]===1){const n=h[v++],r=h.subarray(v,v+n);return v+=n,{id:p,type:"full",data:r}}const o=h[v++],t=[];for(let n=0;n<o;n++){const r=h[v++],u=h[v++],l=h[v++];let i;l>0&&(i=h.subarray(v,v+l),v+=l),t[n]={start:r,deleteCount:u,data:i}}return{id:p,type:"delta",deltas:t}}e.$9_=A}),define(Ae[146],Me([9,10]),function(fe,e){return fe.create("vs/editor/common/config/editorOptions",e)}),define(Ae[147],Me([1,0,18,26,20,130,148,146]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var f;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=k;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class D{constructor(Z,pe,We,Ye){this.id=Z,this.name=pe,this.defaultValue=We,this.schema=Ye}applyUpdate(Z,pe){return v(Z,pe)}compute(Z,pe,We){return We}}class h{constructor(Z,pe){this.newValue=Z,this.didChange=pe}}e.ApplyUpdateResult=h;function v(Q,Z){if(typeof Q!="object"||typeof Z!="object"||!Q||!Z)return new h(Z,Q!==Z);if(Array.isArray(Q)||Array.isArray(Z)){const We=Array.isArray(Q)&&Array.isArray(Z)&&S.$ub(Q,Z);return new h(Z,!We)}let pe=!1;for(const We in Z)if(Z.hasOwnProperty(We)){const Ye=v(Q[We],Z[We]);Ye.didChange&&(Q[We]=Ye.newValue,pe=!0)}return new h(Q,pe)}class p{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,pe){return v(Z,pe)}validate(Z){return this.defaultValue}}class s{constructor(Z,pe,We,Ye){this.id=Z,this.name=pe,this.defaultValue=We,this.schema=Ye}applyUpdate(Z,pe){return v(Z,pe)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,pe,We){return We}}function o(Q,Z){return typeof Q>"u"?Z:Q==="false"?!1:!!Q}e.boolean=o;class t extends s{constructor(Z,pe,We,Ye=void 0){typeof Ye<"u"&&(Ye.type="boolean",Ye.default=We),super(Z,pe,We,Ye)}validate(Z){return o(Z,this.defaultValue)}}function n(Q,Z,pe,We){if(typeof Q>"u")return Z;let Ye=parseInt(Q,10);return isNaN(Ye)?Z:(Ye=Math.max(pe,Ye),Ye=Math.min(We,Ye),Ye|0)}e.clampedInt=n;class r extends s{static clampedInt(Z,pe,We,Ye){return n(Z,pe,We,Ye)}constructor(Z,pe,We,Ye,st,Fe=void 0){typeof Fe<"u"&&(Fe.type="integer",Fe.default=We,Fe.minimum=Ye,Fe.maximum=st),super(Z,pe,We,Fe),this.minimum=Ye,this.maximum=st}validate(Z){return r.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function u(Q,Z,pe,We){if(typeof Q>"u")return Z;const Ye=l.float(Q,Z);return l.clamp(Ye,pe,We)}e.clampedFloat=u;class l extends s{static clamp(Z,pe,We){return Z<pe?pe:Z>We?We:Z}static float(Z,pe){if(typeof Z=="number")return Z;if(typeof Z>"u")return pe;const We=parseFloat(Z);return isNaN(We)?pe:We}constructor(Z,pe,We,Ye,st){typeof st<"u"&&(st.type="number",st.default=We),super(Z,pe,We,st),this.validationFn=Ye}validate(Z){return this.validationFn(l.float(Z,this.defaultValue))}}class i extends s{static string(Z,pe){return typeof Z!="string"?pe:Z}constructor(Z,pe,We,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.default=We),super(Z,pe,We,Ye)}validate(Z){return i.string(Z,this.defaultValue)}}function $(Q,Z,pe,We){return typeof Q!="string"?Z:We&&Q in We?We[Q]:pe.indexOf(Q)===-1?Z:Q}e.stringSet=$;class a extends s{constructor(Z,pe,We,Ye,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Ye,st.default=We),super(Z,pe,We,st),this.c=Ye}validate(Z){return $(Z,this.defaultValue,this.c)}}class c extends D{constructor(Z,pe,We,Ye,st,Fe,St=void 0){typeof St<"u"&&(St.type="string",St.enum=st,St.default=Ye),super(Z,pe,We,St),this.c=st,this.d=Fe}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function E(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class y extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,pe,We){return We===0?Z.accessibilitySupport:We}}class m extends D{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:g.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertSpace:o(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function d(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function b(Q){switch(Q){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function M(Q){switch(Q){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class T extends p{constructor(){super(141)}compute(Z,pe,We){const Ye=["monaco-editor"];return pe.get(39)&&Ye.push(pe.get(39)),Z.extraEditorClassName&&Ye.push(Z.extraEditorClassName),pe.get(74)==="default"?Ye.push("mouse-default"):pe.get(74)==="copy"&&Ye.push("mouse-copy"),pe.get(111)&&Ye.push("showUnused"),pe.get(139)&&Ye.push("showDeprecated"),Ye.join(" ")}}class G extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(Z,pe,We){return We&&Z.emptySelectionClipboard}}class W extends D{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:g.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:g.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{cursorMoveOnType:o(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":$(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":$(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(pe.loop,this.defaultValue.loop)}}}class U extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?U.OFF:Z==="true"?U.ON:Z:Z?U.ON:U.OFF}}e.EditorFontLigatures=U;class C extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?C.OFF:Z==="true"?C.TRANSLATE:Z:Z?C.TRANSLATE:C.OFF}compute(Z,pe,We){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class O extends p{constructor(){super(50)}compute(Z,pe,We){return Z.fontInfo}}class V extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(Z){const pe=l.float(Z,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(pe,6,100)}compute(Z,pe,We){return Z.fontInfo.fontSize}}class re extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.d,maximum:re.e,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(r.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,re.d,re.e))}}class ce extends D{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:We,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:We,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:We,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:We,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:We,description:g.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{multiple:$(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??$(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??$(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??$(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??$(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??$(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends D{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:g.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:g.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:g.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),delay:r.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:o(pe.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(pe.above,this.defaultValue.above)}}}var De;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(De||(e.RenderMinimap=De={}));class he extends p{constructor(){super(144)}compute(Z,pe,We){return he.computeLayout(pe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const pe=Z.height/Z.lineHeight,We=Math.floor(Z.paddingTop/Z.lineHeight);let Ye=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Ye=Math.max(Ye,pe-1));const st=(We+Z.viewLineCount+Ye)/(Z.pixelRatio*Z.height),Fe=Math.floor(Z.viewLineCount/st);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:Ye,desiredRatio:st,minimapLineCount:Fe}}static c(Z,pe){const We=Z.outerWidth,Ye=Z.outerHeight,st=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const Fe=pe.stableMinimapLayoutInput,St=Fe&&Z.outerHeight===Fe.outerHeight&&Z.lineHeight===Fe.lineHeight&&Z.typicalHalfwidthCharacterWidth===Fe.typicalHalfwidthCharacterWidth&&Z.pixelRatio===Fe.pixelRatio&&Z.scrollBeyondLastLine===Fe.scrollBeyondLastLine&&Z.paddingTop===Fe.paddingTop&&Z.paddingBottom===Fe.paddingBottom&&Z.minimap.enabled===Fe.minimap.enabled&&Z.minimap.side===Fe.minimap.side&&Z.minimap.size===Fe.minimap.size&&Z.minimap.showSlider===Fe.minimap.showSlider&&Z.minimap.renderCharacters===Fe.minimap.renderCharacters&&Z.minimap.maxColumn===Fe.minimap.maxColumn&&Z.minimap.scale===Fe.minimap.scale&&Z.verticalScrollbarWidth===Fe.verticalScrollbarWidth&&Z.isViewportWrapping===Fe.isViewportWrapping,Kt=Z.lineHeight,zt=Z.typicalHalfwidthCharacterWidth,Zt=Z.scrollBeyondLastLine,Qt=Z.minimap.renderCharacters;let It=st>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Gt=Z.minimap.maxColumn,Jt=Z.minimap.size,_t=Z.minimap.side,ri=Z.verticalScrollbarWidth,Qe=Z.viewLineCount,jt=Z.remainingWidth,ei=Z.isViewportWrapping,ft=Qt?2:3;let vt=Math.floor(st*Ye);const ti=vt/st;let Wt=!1,Ut=!1,dt=ft*It,Pt=It/st,ii=1;if(Jt==="fill"||Jt==="fit"){const{typicalViewportLineCount:Lt,extraLinesBeforeFirstLine:Ct,extraLinesBeyondLastLine:Ot,desiredRatio:ni,minimapLineCount:Vt}=he.computeContainedMinimapLineCount({viewLineCount:Qe,scrollBeyondLastLine:Zt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Ye,lineHeight:Kt,pixelRatio:st});if(Qe/Vt>1)Wt=!0,Ut=!0,It=1,dt=1,Pt=It/st;else{let Rt=!1,Dt=It+1;if(Jt==="fit"){const $t=Math.ceil((Ct+Qe+Ot)*dt);ei&&St&&jt<=pe.stableFitRemainingWidth?(Rt=!0,Dt=pe.stableFitMaxMinimapScale):Rt=$t>vt}if(Jt==="fill"||Rt){Wt=!0;const $t=It;dt=Math.min(Kt*st,Math.max(1,Math.floor(1/ni))),ei&&St&&jt<=pe.stableFitRemainingWidth&&(Dt=pe.stableFitMaxMinimapScale),It=Math.min(Dt,Math.max(1,Math.floor(dt/ft))),It>$t&&(ii=Math.min(2,It/$t)),Pt=It/st/ii,vt=Math.ceil(Math.max(Lt,Ct+Qe+Ot)*dt),ei?(pe.stableMinimapLayoutInput=Z,pe.stableFitRemainingWidth=jt,pe.stableFitMaxMinimapScale=It):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const xt=Math.floor(Gt*Pt),Ke=Math.min(xt,Math.max(0,Math.floor((jt-ri-2)*Pt/(zt+Pt)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(st*Ke);const Bt=At/st;At=Math.floor(At*ii);const si=Qt?1:2,gt=_t==="left"?0:We-Ke-ri;return{renderMinimap:si,minimapLeft:gt,minimapWidth:Ke,minimapHeightIsEditorHeight:Wt,minimapIsSampling:Ut,minimapScale:It,minimapLineHeight:dt,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:vt,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:ti}}static computeLayout(Z,pe){const We=pe.outerWidth|0,Ye=pe.outerHeight|0,st=pe.lineHeight|0,Fe=pe.lineNumbersDigitCount|0,St=pe.typicalHalfwidthCharacterWidth,Kt=pe.maxDigitWidth,zt=pe.pixelRatio,Zt=pe.viewLineCount,Qt=Z.get(136),It=Qt==="inherit"?Z.get(135):Qt,Gt=It==="inherit"?Z.get(131):It,Jt=Z.get(134),_t=pe.isDominatedByLongLines,ri=Z.get(57),Qe=Z.get(68).renderType!==0,jt=Z.get(69),ei=Z.get(105),ft=Z.get(84),vt=Z.get(73),ti=Z.get(103),Wt=ti.verticalScrollbarSize,Ut=ti.verticalHasArrows,dt=ti.arrowSize,Pt=ti.horizontalScrollbarSize,ii=Z.get(43),xt=Z.get(110)!=="never";let Ke=Z.get(66);ii&&xt&&(Ke+=16);let At=0;if(Qe){const Et=Math.max(Fe,jt);At=Math.round(Et*Kt)}let Bt=0;ri&&(Bt=st*pe.glyphMarginDecorationLaneCount);let si=0,gt=si+Bt,Lt=gt+At,Ct=Lt+Ke;const Ot=We-Bt-At-Ke;let ni=!1,Vt=!1,Tt=-1;It==="inherit"&&_t?(ni=!0,Vt=!0):Gt==="on"||Gt==="bounded"?Vt=!0:Gt==="wordWrapColumn"&&(Tt=Jt);const Rt=he.c({outerWidth:We,outerHeight:Ye,lineHeight:st,typicalHalfwidthCharacterWidth:St,pixelRatio:zt,scrollBeyondLastLine:ei,paddingTop:ft.top,paddingBottom:ft.bottom,minimap:vt,verticalScrollbarWidth:Wt,viewLineCount:Zt,remainingWidth:Ot,isViewportWrapping:Vt},pe.memory||new A);Rt.renderMinimap!==0&&Rt.minimapLeft===0&&(si+=Rt.minimapWidth,gt+=Rt.minimapWidth,Lt+=Rt.minimapWidth,Ct+=Rt.minimapWidth);const Dt=Ot-Rt.minimapWidth,$t=Math.max(1,Math.floor((Dt-Wt-2)/St)),kt=Ut?dt:0;return Vt&&(Tt=Math.max(1,$t),Gt==="bounded"&&(Tt=Math.min(Tt,Jt))),{width:We,height:Ye,glyphMarginLeft:si,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:gt,lineNumbersWidth:At,decorationsLeft:Lt,decorationsWidth:Ke,contentLeft:Ct,contentWidth:Dt,minimap:Rt,viewportColumn:$t,isWordWrapMinified:ni,isViewportWrapping:Vt,wrappingColumn:Tt,verticalScrollbarWidth:Wt,horizontalScrollbarHeight:Pt,overviewRuler:{top:kt,width:Wt,height:Ye-2*kt,right:0}}}}e.EditorLayoutInfoComputer=he;class ve extends D{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(47,null),g.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(49,null)}})}validate(Z){return $(Z,"simple",["simple","advanced"])}compute(Z,pe,We){return pe.get(2)===2?"advanced":We}}var se;(function(Q){Q.Off="off",Q.OnCode="onCode",Q.On="on"})(se||(e.ShowLightbulbIconMode=se={}));class $e extends D{constructor(){const Z={enabled:se.OnCode};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[se.Off,se.OnCode,se.On],default:Z.enabled,enumDescriptions:[g.localize(50,null),g.localize(51,null),g.localize(52,null)],description:g.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:$(Z.enabled,this.defaultValue.enabled,[se.Off,se.OnCode,se.On])}}}class ee extends D{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:g.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:g.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:g.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:g.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:$(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Y extends D{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:g.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(59,null),g.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:g.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:g.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:g.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:$(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(pe.fontFamily,this.defaultValue.fontFamily),padding:o(pe.padding,this.defaultValue.padding)}}}class q extends D{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):r.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,pe,We){return We<0?r.clampedInt(-We*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class ne extends l{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>l.clamp(Z,0,150),{markdownDescription:g.localize(66,null)})}compute(Z,pe,We){return Z.fontInfo.lineHeight}}class Se extends D{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:g.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:g.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(69,null),g.localize(70,null),g.localize(71,null)],default:Z.size,description:g.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:g.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:g.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:g.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:g.localize(77,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),autohide:o(pe.autohide,this.defaultValue.autohide),size:$(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:$(pe.side,this.defaultValue.side,["right","left"]),showSlider:$(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(pe.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(pe.scale,1,1,3),maxColumn:r.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Te(Q){return Q==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class Ce extends D{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(79,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{top:r.clampedInt(pe.top,0,0,1e3),bottom:r.clampedInt(pe.bottom,0,0,1e3)}}}class be extends D{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:g.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:g.localize(81,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),cycle:o(pe.cycle,this.defaultValue.cycle)}}}class ge extends p{constructor(){super(142)}compute(Z,pe,We){return Z.pixelRatio}}class X extends D{constructor(){const Z={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(82,null),g.localize(83,null),g.localize(84,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Z.strings,description:g.localize(85,null)},comments:{anyOf:pe,default:Z.comments,description:g.localize(86,null)},other:{anyOf:pe,default:Z.other,description:g.localize(87,null)}},default:Z,markdownDescription:g.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const zt=Z?"on":"off";return{comments:zt,strings:zt,other:zt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:pe,comments:We,strings:Ye}=Z,st=["on","inline","off"];let Fe,St,Kt;return typeof pe=="boolean"?Fe=pe?"on":"off":Fe=$(pe,this.defaultValue.other,st),typeof We=="boolean"?St=We?"on":"off":St=$(We,this.defaultValue.comments,st),typeof Ye=="boolean"?Kt=Ye?"on":"off":Kt=$(Ye,this.defaultValue.strings,st),{other:Fe,comments:St,strings:Kt}}}var x;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(x||(e.RenderLineNumbersType=x={}));class le extends D{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(89,null),g.localize(90,null),g.localize(91,null),g.localize(92,null)],default:"on",description:g.localize(93,null)})}validate(Z){let pe=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(pe=4,We=Z):Z==="interval"?pe=3:Z==="relative"?pe=2:Z==="on"?pe=1:pe=0),{renderType:pe,renderFn:We}}}function de(Q){const Z=Q.get(98);return Z==="editable"?Q.get(91):Z!=="on"}e.filterValidationDecorations=de;class Pe extends D{constructor(){const Z=[],pe={type:"number",description:g.localize(94,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:g.localize(95,null),format:"color-hex"}}}]},default:Z,description:g.localize(96,null)})}validate(Z){if(Array.isArray(Z)){const pe=[];for(const We of Z)if(typeof We=="number")pe.push({column:r.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Ye=We;pe.push({column:r.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return pe.sort((We,Ye)=>We.column-Ye.column),pe}return this.defaultValue}}class me extends D{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ie(Q,Z){if(typeof Q!="string")return Z;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Le extends D{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(97,null),g.localize(98,null),g.localize(99,null)],default:"auto",description:g.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(101,null),g.localize(102,null),g.localize(103,null)],default:"auto",description:g.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:g.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:g.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:g.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:g.localize(108,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z,We=r.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=r.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:o(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:r.clampedInt(pe.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:r.clampedInt(pe.verticalSliderSize,Ye,0,1e3),scrollByPage:o(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends D{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:g.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:g.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:g.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:g.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:g.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:g.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:g.localize(115,null)}})}applyUpdate(Z,pe){let We=!1;pe.allowedCharacters&&Z&&(L.$Ln(Z.allowedCharacters,pe.allowedCharacters)||(Z={...Z,allowedCharacters:pe.allowedCharacters},We=!0)),pe.allowedLocales&&Z&&(L.$Ln(Z.allowedLocales,pe.allowedLocales)||(Z={...Z,allowedLocales:pe.allowedLocales},We=!0));const Ye=super.applyUpdate(Z,pe);return We?new h(Ye.newValue,!0):Ye}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{nonBasicASCII:te(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:te(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:te(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,pe){if(typeof Z!="object"||!Z)return pe;const We={};for(const[Ye,st]of Object.entries(Z))st===!0&&(We[Ye]=!0);return We}}class N extends D{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:g.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(117,null),g.localize(118,null),g.localize(119,null)],description:g.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:g.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:g.localize(122,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),mode:$(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class j extends D{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:g.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(124,null),g.localize(125,null),g.localize(126,null)],description:g.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:g.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:g.localize(129,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),showToolbar:$(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string(pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class K extends D{constructor(){const Z={enabled:F.$Ds.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$Ds.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:g.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:g.localize(131,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends D{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(132,null),g.localize(133,null),g.localize(134,null)],default:Z.bracketPairs,description:g.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(136,null),g.localize(137,null),g.localize(138,null)],default:Z.bracketPairsHorizontal,description:g.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:g.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:g.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(142,null),g.localize(143,null),g.localize(144,null)],default:Z.highlightActiveIndentation,description:g.localize(145,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{bracketPairs:te(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:te(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:te(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function te(Q,Z,pe){const We=pe.indexOf(Q);return We===-1?Z:pe[We]}class oe extends D{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(146,null),g.localize(147,null)],default:Z.insertMode,description:g.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:g.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:g.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:g.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(152,null),g.localize(153,null),g.localize(154,null),g.localize(155,null)],default:Z.selectionMode,markdownDescription:g.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:g.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:g.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:g.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:g.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:g.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(193,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertMode:$(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(pe.showIcons,this.defaultValue.showIcons),showStatusBar:o(pe.showStatusBar,this.defaultValue.showStatusBar),preview:o(pe.preview,this.defaultValue.preview),previewMode:$(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(pe.showMethods,this.defaultValue.showMethods),showFunctions:o(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(pe.showFields,this.defaultValue.showFields),showVariables:o(pe.showVariables,this.defaultValue.showVariables),showClasses:o(pe.showClasses,this.defaultValue.showClasses),showStructs:o(pe.showStructs,this.defaultValue.showStructs),showInterfaces:o(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(pe.showModules,this.defaultValue.showModules),showProperties:o(pe.showProperties,this.defaultValue.showProperties),showEvents:o(pe.showEvents,this.defaultValue.showEvents),showOperators:o(pe.showOperators,this.defaultValue.showOperators),showUnits:o(pe.showUnits,this.defaultValue.showUnits),showValues:o(pe.showValues,this.defaultValue.showValues),showConstants:o(pe.showConstants,this.defaultValue.showConstants),showEnums:o(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(pe.showKeywords,this.defaultValue.showKeywords),showWords:o(pe.showWords,this.defaultValue.showWords),showColors:o(pe.showColors,this.defaultValue.showColors),showFiles:o(pe.showFiles,this.defaultValue.showFiles),showReferences:o(pe.showReferences,this.defaultValue.showReferences),showFolders:o(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(pe.showSnippets,this.defaultValue.showSnippets),showUsers:o(pe.showUsers,this.defaultValue.showUsers),showIssues:o(pe.showIssues,this.defaultValue.showIssues)}}}class Oe extends D{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(195,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class He extends D{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(196,null),g.localize(197,null),g.localize(198,null),g.localize(199,null)],description:g.localize(200,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,pe,We){return pe.get(2)===2?0:We}}class xe extends p{constructor(){super(145)}compute(Z,pe,We){const Ye=pe.get(144);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}class tt extends D{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:g.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(203,null),g.localize(204,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),showDropSelector:$(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class lt extends D{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:g.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(207,null),g.localize(208,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),showPasteSelector:$(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",ot="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?it:P.$k?ot:rt,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var et;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.ariaRequired=5]="ariaRequired",Q[Q.autoClosingBrackets=6]="autoClosingBrackets",Q[Q.autoClosingComments=7]="autoClosingComments",Q[Q.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Q[Q.autoClosingDelete=9]="autoClosingDelete",Q[Q.autoClosingOvertype=10]="autoClosingOvertype",Q[Q.autoClosingQuotes=11]="autoClosingQuotes",Q[Q.autoIndent=12]="autoIndent",Q[Q.automaticLayout=13]="automaticLayout",Q[Q.autoSurround=14]="autoSurround",Q[Q.bracketPairColorization=15]="bracketPairColorization",Q[Q.guides=16]="guides",Q[Q.codeLens=17]="codeLens",Q[Q.codeLensFontFamily=18]="codeLensFontFamily",Q[Q.codeLensFontSize=19]="codeLensFontSize",Q[Q.colorDecorators=20]="colorDecorators",Q[Q.colorDecoratorsLimit=21]="colorDecoratorsLimit",Q[Q.columnSelection=22]="columnSelection",Q[Q.comments=23]="comments",Q[Q.contextmenu=24]="contextmenu",Q[Q.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=26]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=28]="cursorStyle",Q[Q.cursorSurroundingLines=29]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=31]="cursorWidth",Q[Q.disableLayerHinting=32]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Q[Q.domReadOnly=34]="domReadOnly",Q[Q.dragAndDrop=35]="dragAndDrop",Q[Q.dropIntoEditor=36]="dropIntoEditor",Q[Q.emptySelectionClipboard=37]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=39]="extraEditorClassName",Q[Q.fastScrollSensitivity=40]="fastScrollSensitivity",Q[Q.find=41]="find",Q[Q.fixedOverflowWidgets=42]="fixedOverflowWidgets",Q[Q.folding=43]="folding",Q[Q.foldingStrategy=44]="foldingStrategy",Q[Q.foldingHighlight=45]="foldingHighlight",Q[Q.foldingImportsByDefault=46]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=47]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=49]="fontFamily",Q[Q.fontInfo=50]="fontInfo",Q[Q.fontLigatures=51]="fontLigatures",Q[Q.fontSize=52]="fontSize",Q[Q.fontWeight=53]="fontWeight",Q[Q.fontVariations=54]="fontVariations",Q[Q.formatOnPaste=55]="formatOnPaste",Q[Q.formatOnType=56]="formatOnType",Q[Q.glyphMargin=57]="glyphMargin",Q[Q.gotoLocation=58]="gotoLocation",Q[Q.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Q[Q.hover=60]="hover",Q[Q.inDiffEditor=61]="inDiffEditor",Q[Q.inlineSuggest=62]="inlineSuggest",Q[Q.inlineEdit=63]="inlineEdit",Q[Q.letterSpacing=64]="letterSpacing",Q[Q.lightbulb=65]="lightbulb",Q[Q.lineDecorationsWidth=66]="lineDecorationsWidth",Q[Q.lineHeight=67]="lineHeight",Q[Q.lineNumbers=68]="lineNumbers",Q[Q.lineNumbersMinChars=69]="lineNumbersMinChars",Q[Q.linkedEditing=70]="linkedEditing",Q[Q.links=71]="links",Q[Q.matchBrackets=72]="matchBrackets",Q[Q.minimap=73]="minimap",Q[Q.mouseStyle=74]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=76]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=78]="multiCursorModifier",Q[Q.multiCursorPaste=79]="multiCursorPaste",Q[Q.multiCursorLimit=80]="multiCursorLimit",Q[Q.occurrencesHighlight=81]="occurrencesHighlight",Q[Q.overviewRulerBorder=82]="overviewRulerBorder",Q[Q.overviewRulerLanes=83]="overviewRulerLanes",Q[Q.padding=84]="padding",Q[Q.pasteAs=85]="pasteAs",Q[Q.parameterHints=86]="parameterHints",Q[Q.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=89]="quickSuggestions",Q[Q.quickSuggestionsDelay=90]="quickSuggestionsDelay",Q[Q.readOnly=91]="readOnly",Q[Q.readOnlyMessage=92]="readOnlyMessage",Q[Q.renameOnType=93]="renameOnType",Q[Q.renderControlCharacters=94]="renderControlCharacters",Q[Q.renderFinalNewline=95]="renderFinalNewline",Q[Q.renderLineHighlight=96]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=98]="renderValidationDecorations",Q[Q.renderWhitespace=99]="renderWhitespace",Q[Q.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Q[Q.roundedSelection=101]="roundedSelection",Q[Q.rulers=102]="rulers",Q[Q.scrollbar=103]="scrollbar",Q[Q.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=105]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=106]="scrollPredominantAxis",Q[Q.selectionClipboard=107]="selectionClipboard",Q[Q.selectionHighlight=108]="selectionHighlight",Q[Q.selectOnLineNumbers=109]="selectOnLineNumbers",Q[Q.showFoldingControls=110]="showFoldingControls",Q[Q.showUnused=111]="showUnused",Q[Q.snippetSuggestions=112]="snippetSuggestions",Q[Q.smartSelect=113]="smartSelect",Q[Q.smoothScrolling=114]="smoothScrolling",Q[Q.stickyScroll=115]="stickyScroll",Q[Q.stickyTabStops=116]="stickyTabStops",Q[Q.stopRenderingLineAfter=117]="stopRenderingLineAfter",Q[Q.suggest=118]="suggest",Q[Q.suggestFontSize=119]="suggestFontSize",Q[Q.suggestLineHeight=120]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Q[Q.suggestSelection=122]="suggestSelection",Q[Q.tabCompletion=123]="tabCompletion",Q[Q.tabIndex=124]="tabIndex",Q[Q.unicodeHighlighting=125]="unicodeHighlighting",Q[Q.unusualLineTerminators=126]="unusualLineTerminators",Q[Q.useShadowDOM=127]="useShadowDOM",Q[Q.useTabStops=128]="useTabStops",Q[Q.wordBreak=129]="wordBreak",Q[Q.wordSeparators=130]="wordSeparators",Q[Q.wordWrap=131]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=134]="wordWrapColumn",Q[Q.wordWrapOverride1=135]="wordWrapOverride1",Q[Q.wordWrapOverride2=136]="wordWrapOverride2",Q[Q.wrappingIndent=137]="wrappingIndent",Q[Q.wrappingStrategy=138]="wrappingStrategy",Q[Q.showDeprecated=139]="showDeprecated",Q[Q.inlayHints=140]="inlayHints",Q[Q.editorClassName=141]="editorClassName",Q[Q.pixelRatio=142]="pixelRatio",Q[Q.tabFocusMode=143]="tabFocusMode",Q[Q.layoutInfo=144]="layoutInfo",Q[Q.wrappingInfo=145]="wrappingInfo",Q[Q.defaultColorDecorators=146]="defaultColorDecorators",Q[Q.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",Q[Q.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(et||(e.EditorOption=et={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(209,null)})),acceptSuggestionOnEnter:Be(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(210,null),""],markdownDescription:g.localize(211,null)})),accessibilitySupport:Be(new y),accessibilityPageSize:Be(new r(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(212,null),tags:["accessibility"]})),ariaLabel:Be(new i(4,"ariaLabel",g.localize(213,null))),ariaRequired:Be(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Be(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(215,null),g.localize(216,null),""],description:g.localize(217,null)})),autoClosingComments:Be(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(218,null),g.localize(219,null),""],description:g.localize(220,null)})),autoClosingDelete:Be(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(221,null),""],description:g.localize(222,null)})),autoClosingOvertype:Be(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(223,null),""],description:g.localize(224,null)})),autoClosingQuotes:Be(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(225,null),g.localize(226,null),""],description:g.localize(227,null)})),autoIndent:Be(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],E,{enumDescriptions:[g.localize(228,null),g.localize(229,null),g.localize(230,null),g.localize(231,null),g.localize(232,null)],description:g.localize(233,null)})),automaticLayout:Be(new t(13,"automaticLayout",!1)),autoSurround:Be(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(234,null),g.localize(235,null),g.localize(236,null),""],description:g.localize(237,null)})),bracketPairColorization:Be(new K),bracketPairGuides:Be(new H),stickyTabStops:Be(new t(116,"stickyTabStops",!1,{description:g.localize(238,null)})),codeLens:Be(new t(17,"codeLens",!0,{description:g.localize(239,null)})),codeLensFontFamily:Be(new i(18,"codeLensFontFamily","",{description:g.localize(240,null)})),codeLensFontSize:Be(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(241,null)})),colorDecorators:Be(new t(20,"colorDecorators",!0,{description:g.localize(242,null)})),colorDecoratorActivatedOn:Be(new a(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(243,null),g.localize(244,null),g.localize(245,null)],description:g.localize(246,null)})),colorDecoratorsLimit:Be(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(247,null)})),columnSelection:Be(new t(22,"columnSelection",!1,{description:g.localize(248,null)})),comments:Be(new m),contextmenu:Be(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new t(25,"copyWithSyntaxHighlighting",!0,{description:g.localize(249,null)})),cursorBlinking:Be(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:g.localize(250,null)})),cursorSmoothCaretAnimation:Be(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(251,null),g.localize(252,null),g.localize(253,null)],description:g.localize(254,null)})),cursorStyle:Be(new c(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:g.localize(255,null)})),cursorSurroundingLines:Be(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(256,null)})),cursorSurroundingLinesStyle:Be(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(257,null),g.localize(258,null)],markdownDescription:g.localize(259,null)})),cursorWidth:Be(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(260,null)})),disableLayerHinting:Be(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new t(34,"domReadOnly",!1)),dragAndDrop:Be(new t(35,"dragAndDrop",!0,{description:g.localize(261,null)})),emptySelectionClipboard:Be(new G),dropIntoEditor:Be(new tt),stickyScroll:Be(new ee),experimentalWhitespaceRendering:Be(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(262,null),g.localize(263,null),g.localize(264,null)],description:g.localize(265,null)})),extraEditorClassName:Be(new i(39,"extraEditorClassName","")),fastScrollSensitivity:Be(new l(40,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:g.localize(266,null)})),find:Be(new W),fixedOverflowWidgets:Be(new t(42,"fixedOverflowWidgets",!1)),folding:Be(new t(43,"folding",!0,{description:g.localize(267,null)})),foldingStrategy:Be(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),foldingHighlight:Be(new t(45,"foldingHighlight",!0,{description:g.localize(271,null)})),foldingImportsByDefault:Be(new t(46,"foldingImportsByDefault",!1,{description:g.localize(272,null)})),foldingMaximumRegions:Be(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(273,null)})),unfoldOnClickAfterEndOfLine:Be(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(274,null)})),fontFamily:Be(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(275,null)})),fontInfo:Be(new O),fontLigatures2:Be(new U),fontSize:Be(new V),fontWeight:Be(new re),fontVariations:Be(new C),formatOnPaste:Be(new t(55,"formatOnPaste",!1,{description:g.localize(276,null)})),formatOnType:Be(new t(56,"formatOnType",!1,{description:g.localize(277,null)})),glyphMargin:Be(new t(57,"glyphMargin",!0,{description:g.localize(278,null)})),gotoLocation:Be(new ce),hideCursorInOverviewRuler:Be(new t(59,"hideCursorInOverviewRuler",!1,{description:g.localize(279,null)})),hover:Be(new ye),inDiffEditor:Be(new t(61,"inDiffEditor",!1)),letterSpacing:Be(new l(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>l.clamp(Q,-5,20),{description:g.localize(280,null)})),lightbulb:Be(new $e),lineDecorationsWidth:Be(new q),lineHeight:Be(new ne),lineNumbers:Be(new le),lineNumbersMinChars:Be(new r(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new t(70,"linkedEditing",!1,{description:g.localize(281,null)})),links:Be(new t(71,"links",!0,{description:g.localize(282,null)})),matchBrackets:Be(new a(72,"matchBrackets","always",["always","near","never"],{description:g.localize(283,null)})),minimap:Be(new Se),mouseStyle:Be(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new l(75,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:g.localize(284,null)})),mouseWheelZoom:Be(new t(76,"mouseWheelZoom",!1,{markdownDescription:P.$j?g.localize(285,null):g.localize(286,null)})),multiCursorMergeOverlapping:Be(new t(77,"multiCursorMergeOverlapping",!0,{description:g.localize(287,null)})),multiCursorModifier:Be(new c(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[g.localize(288,null),g.localize(289,null)],markdownDescription:g.localize(290,null)})),multiCursorPaste:Be(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(291,null),g.localize(292,null)],markdownDescription:g.localize(293,null)})),multiCursorLimit:Be(new r(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(294,null)})),occurrencesHighlight:Be(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[g.localize(295,null),g.localize(296,null),g.localize(297,null)],markdownDescription:g.localize(298,null)})),overviewRulerBorder:Be(new t(82,"overviewRulerBorder",!0,{description:g.localize(299,null)})),overviewRulerLanes:Be(new r(83,"overviewRulerLanes",3,0,3)),padding:Be(new Ce),pasteAs:Be(new lt),parameterHints:Be(new be),peekWidgetDefaultFocus:Be(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(300,null),g.localize(301,null)],description:g.localize(302,null)})),definitionLinkOpensInPeek:Be(new t(88,"definitionLinkOpensInPeek",!1,{description:g.localize(303,null)})),quickSuggestions:Be(new X),quickSuggestionsDelay:Be(new r(90,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(304,null)})),readOnly:Be(new t(91,"readOnly",!1)),readOnlyMessage:Be(new me),renameOnType:Be(new t(93,"renameOnType",!1,{description:g.localize(305,null),markdownDeprecationMessage:g.localize(306,null)})),renderControlCharacters:Be(new t(94,"renderControlCharacters",!0,{description:g.localize(307,null),restricted:!0})),renderFinalNewline:Be(new a(95,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:g.localize(308,null)})),renderLineHighlight:Be(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(309,null)],description:g.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Be(new t(97,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(311,null)})),renderValidationDecorations:Be(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(312,null),g.localize(313,null),g.localize(314,null),""],description:g.localize(315,null)})),revealHorizontalRightPadding:Be(new r(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new t(101,"roundedSelection",!0,{description:g.localize(316,null)})),rulers:Be(new Pe),scrollbar:Be(new Le),scrollBeyondLastColumn:Be(new r(104,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(317,null)})),scrollBeyondLastLine:Be(new t(105,"scrollBeyondLastLine",!0,{description:g.localize(318,null)})),scrollPredominantAxis:Be(new t(106,"scrollPredominantAxis",!0,{description:g.localize(319,null)})),selectionClipboard:Be(new t(107,"selectionClipboard",!0,{description:g.localize(320,null),included:P.$k})),selectionHighlight:Be(new t(108,"selectionHighlight",!0,{description:g.localize(321,null)})),selectOnLineNumbers:Be(new t(109,"selectOnLineNumbers",!0)),showFoldingControls:Be(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(322,null),g.localize(323,null),g.localize(324,null)],description:g.localize(325,null)})),showUnused:Be(new t(111,"showUnused",!0,{description:g.localize(326,null)})),showDeprecated:Be(new t(139,"showDeprecated",!0,{description:g.localize(327,null)})),inlayHints:Be(new Y),snippetSuggestions:Be(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(328,null),g.localize(329,null),g.localize(330,null),g.localize(331,null)],description:g.localize(332,null)})),smartSelect:Be(new Oe),smoothScrolling:Be(new t(114,"smoothScrolling",!1,{description:g.localize(333,null)})),stopRenderingLineAfter:Be(new r(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new oe),inlineSuggest:Be(new N),inlineEdit:Be(new j),inlineCompletionsAccessibilityVerbose:Be(new t(148,"inlineCompletionsAccessibilityVerbose",!1,{description:g.localize(334,null)})),suggestFontSize:Be(new r(119,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new r(120,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new t(121,"suggestOnTriggerCharacters",!0,{description:g.localize(337,null)})),suggestSelection:Be(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(338,null),g.localize(339,null),g.localize(340,null)],description:g.localize(341,null)})),tabCompletion:Be(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(342,null),g.localize(343,null),g.localize(344,null)],description:g.localize(345,null)})),tabIndex:Be(new r(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new ze),unusualLineTerminators:Be(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(346,null),g.localize(347,null),g.localize(348,null)],description:g.localize(349,null)})),useShadowDOM:Be(new t(127,"useShadowDOM",!0)),useTabStops:Be(new t(128,"useTabStops",!0,{description:g.localize(350,null)})),wordBreak:Be(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(351,null),g.localize(352,null)],description:g.localize(353,null)})),wordSeparators:Be(new i(130,"wordSeparators",R.$Es,{description:g.localize(354,null)})),wordWrap:Be(new a(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(355,null),g.localize(356,null),g.localize(357,null),g.localize(358,null)],description:g.localize(359,null)})),wordWrapBreakAfterCharacters:Be(new i(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new i(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new r(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(360,null)})),wordWrapOverride1:Be(new a(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new a(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new T),defaultColorDecorators:Be(new t(146,"defaultColorDecorators",!1,{markdownDescription:g.localize(361,null)})),pixelRatio:Be(new ge),tabFocusMode:Be(new t(143,"tabFocusMode",!1,{markdownDescription:g.localize(362,null)})),layoutInfo:Be(new he),wrappingInfo:Be(new xe),wrappingIndent:Be(new He),wrappingStrategy:Be(new ve)}}),define(Ae[149],Me([9,10]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[150],Me([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[151],Me([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[152],Me([9,10]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[153],Me([9,10]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[154],Me([9,10]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(Ae[155],Me([9,10]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(Ae[156],Me([9,10]),function(fe,e){return fe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[157],Me([9,10]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(Ae[158],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ae[159],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatProvider",e)}),define(Ae[160],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[161],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[162],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[163],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[164],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[165],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[166],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[167],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[168],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[169],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[170],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[171],Me([9,10]),function(fe,e){return fe.create("vs/workbench/common/configuration",e)}),define(Ae[172],Me([9,10]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(Ae[173],Me([9,10]),function(fe,e){return fe.create("vs/workbench/common/views",e)}),define(Ae[174],Me([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[175],Me([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[176],Me([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[177],Me([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[178],Me([9,10]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[179],Me([9,10]),function(fe,e){return fe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ae[180],Me([9,10]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[181],Me([9,10]),function(fe,e){return fe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[182],Me([1,0,15,151]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.TokenType=void 0;var P;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(P||(e.TokenType=P={}));function F(...k){switch(k.length){case 1:return(0,L.localize)(0,null,k[0]);case 2:return(0,L.localize)(1,null,k[0],k[1]);case 3:return(0,L.localize)(2,null,k[0],k[1],k[2]);default:return}}const R=(0,L.localize)(3,null),g=(0,L.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const D=this.d,h=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:h};this.g.push({offset:D,lexeme:h,additionalInfo:A}),this.f.push(v)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const D=this.c.substring(this.d,this.e),h=f.b.get(D);h?this.k(h):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,D=!1,h=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(g);return}const p=this.c.charCodeAt(A);if(D)D=!1;else if(p===47&&!h){A++;break}else p===91?h=!0:p===92?D=!0:p===93&&(h=!1);A++}for(;A<this.c.length&&f.a.has(this.c.charCodeAt(A));)A++;this.e=A;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$_i=f}),define(Ae[183],Me([1,0,25,32,153,297]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function f(t){return t=t.trim(),t==="*"||R.test(t)}e.$lp=f;function k(t){if(!f(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$mp=k;function A(t){if(!t)return null;const n=t.majorBase,r=t.majorMustEqual,u=t.minorBase;let l=t.minorMustEqual;const i=t.patchBase;let $=t.patchMustEqual;t.hasCaret&&(n===0||(l=!1),$=!1);let a=0;if(t.preRelease){const c=g.exec(t.preRelease);if(c){const[,E,y,m]=c;a=Date.UTC(Number(E),Number(y)-1,Number(m))}}return{majorBase:n,majorMustEqual:r,minorBase:u,minorMustEqual:l,patchBase:i,patchMustEqual:$,isMinimum:t.hasGreaterEquals,notBefore:a}}e.$np=A;function D(t,n,r){let u;typeof t=="string"?u=A(k(t)):u=t;let l;n instanceof Date?l=n.getTime():typeof n=="string"&&(l=new Date(n).getTime());let i;if(typeof r=="string"?i=A(k(r)):i=r,!u||!i)return!1;const $=u.majorBase,a=u.minorBase,c=u.patchBase;let E=i.majorBase,y=i.minorBase,m=i.patchBase;const I=i.notBefore;let d=i.majorMustEqual,w=i.minorMustEqual,b=i.patchMustEqual;return i.isMinimum?$>E?!0:$<E?!1:a>y?!0:a<y||l&&l<I?!1:c>=m:($===1&&E===0&&(!d||!w||!b)&&(E=1,y=0,m=0,d=!0,w=!1,b=!1),$<E?!1:$>E?!d:a<y?!1:a>y?!w:c<m?!1:c>m?!b:!(l&&l<I))}e.$op=D;function h(t,n,r,u,l){const i=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return i.push([L.default.Error,P.localize(0,null)]),i;if(typeof u.name!="string")return i.push([L.default.Error,P.localize(1,null,"name")]),i;if(typeof u.version!="string")return i.push([L.default.Error,P.localize(2,null,"version")]),i;if(!u.engines)return i.push([L.default.Error,P.localize(3,null,"engines")]),i;if(typeof u.engines.vscode!="string")return i.push([L.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof u.extensionDependencies<"u"&&!o(u.extensionDependencies))return i.push([L.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof u.activationEvents<"u"){if(!o(u.activationEvents))return i.push([L.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof u.main>"u"&&typeof u.browser>"u")return i.push([L.default.Error,P.localize(7,null,"activationEvents","main","browser")]),i}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&i.push([L.default.Warning,P.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return i.push([L.default.Error,P.localize(9,null,"main")]),i;{const c=(0,S.$Rg)(r,u.main);(0,S.$Lg)(c,r)||i.push([L.default.Warning,P.localize(10,null,c.path,r.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return i.push([L.default.Error,P.localize(11,null,"browser")]),i;{const c=(0,S.$Rg)(r,u.browser);(0,S.$Lg)(c,r)||i.push([L.default.Warning,P.localize(12,null,c.path,r.path)])}}if(!F.valid(u.version))return i.push([L.default.Error,P.localize(13,null)]),i;const $=[];if(!v(t,n,u,l,$))for(const c of $)i.push([L.default.Error,c]);return i}e.$pp=h;function v(t,n,r,u,l){return u||typeof r.main>"u"&&typeof r.browser>"u"?!0:s(t,n,r.engines.vscode,l)}e.$qp=v;function p(t,n,r){return t==="*"||s(n,r,t)}e.$rp=p;function s(t,n,r,u=[]){const l=A(k(r));if(!l)return u.push(P.localize(14,null,r)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return u.push(P.localize(15,null,r)),!1}else if(!l.majorMustEqual)return u.push(P.localize(16,null,r)),!1;return D(t,n,l)?!0:(u.push(P.localize(17,null,t,r)),!1)}function o(t){if(!Array.isArray(t))return!1;for(let n=0,r=t.length;n<r;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Ae[70],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=void 0;class S{constructor(P,F=[],R=!1){this.ctor=P,this.staticArguments=F,this.supportsDelayedInstantiation=R}}e.$bi=S}),define(Ae[53],Me([1,0,70]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.InstantiationType=void 0;const L=[];var P;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function F(g,f,k){f instanceof S.$bi||(f=new S.$bi(f,[],!!k)),L.push([g,f])}e.$0r=F;function R(){return L}e.$$r=R}),define(Ae[184],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=void 0;class S{constructor(F,R){this.key=F,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Nq=S;class L{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const R of this.a.values())R.outgoing.size===0&&F.push(R);return F}insertEdge(F,R){const g=this.lookupOrInsertNode(F),f=this.lookupOrInsertNode(R);g.outgoing.set(f.key,f),f.incoming.set(g.key,g)}removeNode(F){const R=this.b(F);this.a.delete(R);for(const g of this.a.values())g.outgoing.delete(R),g.incoming.delete(R)}lookupOrInsertNode(F){const R=this.b(F);let g=this.a.get(R);return g||(g=new S(R,F),this.a.set(R,g)),g}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[R,g]of this.a)F.push(`${R}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,R]of this.a){const g=new Set([F]),f=this.c(R,g);if(f)return f}}c(F,R){for(const[g,f]of F.outgoing){if(R.has(g))return[...R,g].join(" -> ");R.add(g);const k=this.c(f,R);if(k)return k;R.delete(g)}}}e.$Oq=L}),define(Ae[4],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e._util=void 0;var S;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function g(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=g})(S||(e._util=S={})),e.$di=P("instantiationService");function L(R,g,f){g[S.DI_TARGET]===g?g[S.DI_DEPENDENCIES].push({id:R,index:f}):(g[S.DI_DEPENDENCIES]=[{id:R,index:f}],g[S.DI_TARGET]=g)}function P(R){if(S.serviceIds.has(R))return S.serviceIds.get(R);const g=function(f,k,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(g,f,A)};return g.toString=()=>R,S.serviceIds.set(R,g),g}e.$ei=P;function F(R){return R}e.$fi=F}),define(Ae[47],Me([1,0,16,2,4]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ConfigurationTarget=e.$Mi=e.$Li=e.$Ki=void 0,e.$Ki=(0,P.$ei)("configurationService");function F(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof L.URI)}e.$Li=F;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof L.URI)}e.$Mi=R;var g;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function f(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ni=f;function k(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$Oi=k;function A(t,n){const r=Object.create(null);for(const u in t)D(r,u,t[u],n);return r}e.$Pi=A;function D(t,n,r,u){const l=n.split("."),i=l.pop();let $=t;for(let a=0;a<l.length;a++){const c=l[a];let E=$[c];switch(typeof E){case"undefined":E=$[c]=Object.create(null);break;case"object":break;default:u(`Ignoring ${n} as ${l.slice(0,a+1).join(".")} is ${JSON.stringify(E)}`);return}$=E}if(typeof $=="object"&&$!==null)try{$[i]=r}catch{u(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify($)}`)}else u(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify($)}`)}e.$Qi=D;function h(t,n){const r=n.split(".");v(t,r)}e.$Ri=h;function v(t,n){const r=n.shift();if(n.length===0){delete t[r];return}if(Object.keys(t).indexOf(r)!==-1){const u=t[r];typeof u=="object"&&!Array.isArray(u)&&(v(u,n),Object.keys(u).length===0&&delete t[r])}}function p(t,n,r){function u($,a){let c=$;for(const E of a){if(typeof c!="object"||c===null)return;c=c[E]}return c}const l=n.split("."),i=u(t,l);return typeof i>"u"?r:i}e.$Si=p;function s(t,n,r){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in t?S.$Uf(t[u])&&S.$Uf(n[u])?s(t[u],n[u],r):r&&(t[u]=n[u]):t[u]=n[u])})}e.$Ti=s;function o(t){return t.replace(/[\[\]]/g,"")}e.$Ui=o}),define(Ae[35],Me([1,0,20,13,182,4,150,15]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.ContextKeyExprType=e.$aj=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",S.$j),f.set("isLinux",S.$k),f.set("isWindows",S.$i),f.set("isWeb",S.$o),f.set("isMacNative",S.$j&&!S.$o),f.set("isEdge",S.$H),f.set("isFirefox",S.$F),f.set("isChrome",S.$E),f.set("isSafari",S.$G);function k(Y,q){if(f.get(Y)!==void 0)throw(0,g.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(Y,q)}e.$aj=k;const A=Object.prototype.hasOwnProperty;var D;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const h={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),p=(0,R.localize)(1,null),s=(0,R.localize)(2,null),o=(0,R.localize)(3,null),t=(0,R.localize)(4,null),n=(0,R.localize)(5,null),r=(0,R.localize)(6,null),u=(0,R.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=h){this.k=q,this.d=new P.$_i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Se=this.D(),Te=Se.type===17?n:void 0;throw this.h.push({message:t,offset:Se.offset,lexeme:P.$_i.getLexeme(Se),additionalInfo:Te}),l.c}return ne}catch(ne){if(ne!==l.c)throw ne;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(16);){const ne=this.o();q.push(ne)}return q.length===1?q[0]:i.or(...q)}o(){const q=[this.s()];for(;this.y(15);){const ne=this.s();q.push(ne)}return q.length===1?q[0]:i.and(...q)}s(){if(this.y(2)){const q=this.D();switch(q.type){case 11:return this.z(),E.INSTANCE;case 12:return this.z(),y.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,o),ne?.negate()}case 17:return this.z(),M.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ne=this.l();return this.A(1,o),ne}case 17:{const ne=q.lexeme;if(this.z(),this.y(9)){const Te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Te.type!==10)throw this.B("REGEX",Te);const Ce=Te.lexeme,be=Ce.lastIndexOf("/"),ge=be===Ce.length-1?void 0:this.w(Ce.substring(be+1));let X;try{X=new RegExp(Ce.substring(1,be),ge)}catch{throw this.B("REGEX",Te)}return O.create(ne,X)}switch(Te.type){case 10:case 19:{const Ce=[Te.lexeme];this.z();let be=this.D(),ge=0;for(let Pe=0;Pe<Te.lexeme.length;Pe++)Te.lexeme.charCodeAt(Pe)===40?ge++:Te.lexeme.charCodeAt(Pe)===41&&ge--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Pe=0;Pe<be.lexeme.length;Pe++)be.lexeme.charCodeAt(Pe)===40?ge++:Te.lexeme.charCodeAt(Pe)===41&&ge--}if(ge<0)break;Ce.push(P.$_i.getLexeme(be)),this.z(),be=this.D()}const X=Ce.join(""),x=X.lastIndexOf("/"),le=x===X.length-1?void 0:this.w(X.substring(x+1));let de;try{de=new RegExp(X.substring(1,x),le)}catch{throw this.B("REGEX",Te)}return i.regex(ne,de)}case 18:{const Ce=Te.lexeme;this.z();let be=null;if(!(0,L.$Se)(Ce)){const ge=Ce.indexOf("/"),X=Ce.lastIndexOf("/");if(ge!==X&&ge>=0){const x=Ce.slice(ge+1,X),le=Ce[X+1]==="i"?"i":"";try{be=new RegExp(x,le)}catch{throw this.B("REGEX",Te)}}}if(be===null)throw this.B("REGEX",Te);return O.create(ne,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Te=this.u();return i.notIn(ne,Te)}switch(this.D().type){case 3:{this.z();const Te=this.u();if(this.x().type===18)return i.equals(ne,Te);switch(Te){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,Te)}}case 4:{this.z();const Te=this.u();if(this.x().type===18)return i.notEquals(ne,Te);switch(Te){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,Te)}}case 5:return this.z(),U.create(ne,this.u());case 6:return this.z(),C.create(ne,this.u());case 7:return this.z(),G.create(ne,this.u());case 8:return this.z(),W.create(ne,this.u());case 13:return this.z(),i.in(ne,this.u());default:return i.has(ne)}}case 20:throw this.h.push({message:r,offset:q.offset,lexeme:"",additionalInfo:u}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case 17:case 18:return this.z(),q.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,ne){if(this.C(q))return this.z();throw this.B(ne,this.D())}B(q,ne,Se){const Te=(0,R.localize)(8,null,q,P.$_i.getLexeme(ne)),Ce=ne.offset,be=P.$_i.getLexeme(ne);return this.h.push({message:Te,offset:Ce,lexeme:be,additionalInfo:Se}),l.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$bj=l;class i{static false(){return E.INSTANCE}static true(){return y.INSTANCE}static has(q){return m.create(q)}static equals(q,ne){return I.create(q,ne)}static notEquals(q,ne){return b.create(q,ne)}static regex(q,ne){return O.create(q,ne)}static in(q,ne){return d.create(q,ne)}static notIn(q,ne){return w.create(q,ne)}static not(q){return M.create(q)}static and(...q){return ce.create(q,null,!0)}static or(...q){return ye.create(q,null,!0)}static greater(q,ne){return G.create(q,ne)}static greaterEquals(q,ne){return W.create(q,ne)}static smaller(q,ne){return U.create(q,ne)}static smallerEquals(q,ne){return C.create(q,ne)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$cj=i;function $(Y){const q=new l({regexParsingWithErrorRecovery:!1});return Y.map(ne=>(q.parse(ne),q.lexingErrors.length>0?q.lexingErrors.map(Se=>({errorMessage:Se.additionalInfo?(0,R.localize)(9,null,Se.additionalInfo):(0,R.localize)(10,null),offset:Se.offset,length:Se.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(Se=>({errorMessage:Se.additionalInfo?`${Se.message}. ${Se.additionalInfo}`:Se.message,offset:Se.offset,length:Se.lexeme.length})):[]))}e.$dj=$;function a(Y,q){const ne=Y?Y.substituteConstants():void 0,Se=q?q.substituteConstants():void 0;return!ne&&!Se?!0:!ne||!Se?!1:ne.equals(Se)}e.$ej=a;function c(Y,q){return Y.cmp(q)}class E{static{this.INSTANCE=new E}constructor(){this.type=0}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return y.INSTANCE}}e.$fj=E;class y{static{this.INSTANCE=new y}constructor(){this.type=1}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return E.INSTANCE}}e.$gj=y;class m{static create(q,ne=null){const Se=f.get(q);return typeof Se=="boolean"?Se?y.INSTANCE:E.INSTANCE:new m(q,ne)}constructor(q,ne){this.key=q,this.c=ne,this.type=2}cmp(q){return q.type!==this.type?this.type-q.type:he(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=f.get(this.key);return typeof q=="boolean"?q?y.INSTANCE:E.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$hj=m;class I{static create(q,ne,Se=null){if(typeof ne=="boolean")return ne?m.create(q,Se):M.create(q,Se);const Te=f.get(q);return typeof Te=="boolean"?ne===(Te?"true":"false")?y.INSTANCE:E.INSTANCE:new I(q,ne,Se)}constructor(q,ne,Se){this.c=q,this.d=ne,this.f=Se,this.type=4}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=f.get(this.c);if(typeof q=="boolean"){const ne=q?"true":"false";return this.d===ne?y.INSTANCE:E.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$ij=I;class d{static create(q,ne){return new d(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=10,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const ne=q.getValue(this.f),Se=q.getValue(this.d);return Array.isArray(ne)?ne.includes(Se):typeof Se=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,Se):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$jj=d;class w{static create(q,ne){return new w(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=11,this.c=d.create(q,ne)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$kj=w;class b{static create(q,ne,Se=null){if(typeof ne=="boolean")return ne?M.create(q,Se):m.create(q,Se);const Te=f.get(q);return typeof Te=="boolean"?ne===(Te?"true":"false")?E.INSTANCE:y.INSTANCE:new b(q,ne,Se)}constructor(q,ne,Se){this.c=q,this.d=ne,this.f=Se,this.type=5}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=f.get(this.c);if(typeof q=="boolean"){const ne=q?"true":"false";return this.d===ne?E.INSTANCE:y.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$lj=b;class M{static create(q,ne=null){const Se=f.get(q);return typeof Se=="boolean"?Se?E.INSTANCE:y.INSTANCE:new M(q,ne)}constructor(q,ne){this.c=q,this.d=ne,this.type=3}cmp(q){return q.type!==this.type?this.type-q.type:he(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=f.get(this.c);return typeof q=="boolean"?q?E.INSTANCE:y.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$mj=M;function T(Y,q){if(typeof Y=="string"){const ne=parseFloat(Y);isNaN(ne)||(Y=ne)}return typeof Y=="string"||typeof Y=="number"?q(Y):E.INSTANCE}class G{static create(q,ne,Se=null){return T(ne,Te=>new G(q,Te,Se))}constructor(q,ne,Se){this.c=q,this.d=ne,this.f=Se,this.type=12}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$nj=G;class W{static create(q,ne,Se=null){return T(ne,Te=>new W(q,Te,Se))}constructor(q,ne,Se){this.c=q,this.d=ne,this.f=Se,this.type=13}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$oj=W;class U{static create(q,ne,Se=null){return T(ne,Te=>new U(q,Te,Se))}constructor(q,ne,Se){this.c=q,this.d=ne,this.f=Se,this.type=14}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$pj=U;class C{static create(q,ne,Se=null){return T(ne,Te=>new C(q,Te,Se))}constructor(q,ne,Se){this.c=q,this.d=ne,this.f=Se,this.type=15}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$qj=C;class O{static create(q,ne){return new O(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=7,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const ne=this.f?this.f.source:"",Se=q.f?q.f.source:"";return ne<Se?-1:ne>Se?1:0}equals(q){if(q.type===this.type){const ne=this.f?this.f.source:"",Se=q.f?q.f.source:"";return this.d===q.d&&ne===Se}return!1}substituteConstants(){return this}evaluate(q){const ne=q.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$rj=O;class V{static create(q){return new V(q)}constructor(q){this.c=q,this.type=8}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new V(this.c.map(q))}negate(){return this.c}}e.$sj=V;function re(Y){let q=null;for(let ne=0,Se=Y.length;ne<Se;ne++){const Te=Y[ne].substituteConstants();if(Y[ne]!==Te&&q===null){q=[];for(let Ce=0;Ce<ne;Ce++)q[Ce]=Y[Ce]}q!==null&&(q[ne]=Te)}return q===null?Y:q}class ce{static create(q,ne,Se){return ce.d(q,ne,Se)}constructor(q,ne){this.expr=q,this.c=ne,this.type=6}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ne=0,Se=this.expr.length;ne<Se;ne++){const Te=c(this.expr[ne],q.expr[ne]);if(Te!==0)return Te}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ne=0,Se=this.expr.length;ne<Se;ne++)if(!this.expr[ne].equals(q.expr[ne]))return!1;return!0}return!1}substituteConstants(){const q=re(this.expr);return q===this.expr?this:ce.create(q,this.c,!1)}evaluate(q){for(let ne=0,Se=this.expr.length;ne<Se;ne++)if(!this.expr[ne].evaluate(q))return!1;return!0}static d(q,ne,Se){const Te=[];let Ce=!1;for(const be of q)if(be){if(be.type===1){Ce=!0;continue}if(be.type===0)return E.INSTANCE;if(be.type===6){Te.push(...be.expr);continue}Te.push(be)}if(Te.length===0&&Ce)return y.INSTANCE;if(Te.length!==0){if(Te.length===1)return Te[0];Te.sort(c);for(let be=1;be<Te.length;be++)Te[be-1].equals(Te[be])&&(Te.splice(be,1),be--);if(Te.length===1)return Te[0];for(;Te.length>1;){const be=Te[Te.length-1];if(be.type!==9)break;Te.pop();const ge=Te.pop(),X=Te.length===0,x=ye.create(be.expr.map(le=>ce.create([le,ge],null,Se)),null,X);x&&(Te.push(x),Te.sort(c))}if(Te.length===1)return Te[0];if(Se){for(let be=0;be<Te.length;be++)for(let ge=be+1;ge<Te.length;ge++)if(Te[be].negate().equals(Te[ge]))return E.INSTANCE;if(Te.length===1)return Te[0]}return new ce(Te,ne)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const ne of this.expr)q.push(...ne.keys());return q}map(q){return new ce(this.expr.map(ne=>ne.map(q)),null)}negate(){if(!this.c){const q=[];for(const ne of this.expr)q.push(ne.negate());this.c=ye.create(q,this,!0)}return this.c}}e.$tj=ce;class ye{static create(q,ne,Se){return ye.d(q,ne,Se)}constructor(q,ne){this.expr=q,this.c=ne,this.type=9}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ne=0,Se=this.expr.length;ne<Se;ne++){const Te=c(this.expr[ne],q.expr[ne]);if(Te!==0)return Te}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ne=0,Se=this.expr.length;ne<Se;ne++)if(!this.expr[ne].equals(q.expr[ne]))return!1;return!0}return!1}substituteConstants(){const q=re(this.expr);return q===this.expr?this:ye.create(q,this.c,!1)}evaluate(q){for(let ne=0,Se=this.expr.length;ne<Se;ne++)if(this.expr[ne].evaluate(q))return!0;return!1}static d(q,ne,Se){let Te=[],Ce=!1;if(q){for(let be=0,ge=q.length;be<ge;be++){const X=q[be];if(X){if(X.type===0){Ce=!0;continue}if(X.type===1)return y.INSTANCE;if(X.type===9){Te=Te.concat(X.expr);continue}Te.push(X)}}if(Te.length===0&&Ce)return E.INSTANCE;Te.sort(c)}if(Te.length!==0){if(Te.length===1)return Te[0];for(let be=1;be<Te.length;be++)Te[be-1].equals(Te[be])&&(Te.splice(be,1),be--);if(Te.length===1)return Te[0];if(Se){for(let be=0;be<Te.length;be++)for(let ge=be+1;ge<Te.length;ge++)if(Te[be].negate().equals(Te[ge]))return y.INSTANCE;if(Te.length===1)return Te[0]}return new ye(Te,ne)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const ne of this.expr)q.push(...ne.keys());return q}map(q){return new ye(this.expr.map(ne=>ne.map(q)),null)}negate(){if(!this.c){const q=[];for(const ne of this.expr)q.push(ne.negate());for(;q.length>1;){const ne=q.shift(),Se=q.shift(),Te=[];for(const Ce of ee(ne))for(const be of ee(Se))Te.push(ce.create([Ce,be],null,!1));q.unshift(ye.create(Te,null,!1))}this.c=ye.create(q,this,!0)}return this.c}}e.$uj=ye;class De extends m{static{this.d=[]}static all(){return De.d.values()}constructor(q,ne,Se){super(q,null),this.f=ne,typeof Se=="object"?De.d.push({...Se,key:q}):Se!==!0&&De.d.push({key:q,description:Se,type:ne!=null?typeof ne:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return I.create(this.key,q)}notEqualsTo(q){return b.create(this.key,q)}}e.$vj=De,e.$wj=(0,F.$ei)("contextKeyService");function he(Y,q){return Y<q?-1:Y>q?1:0}function ve(Y,q,ne,Se){return Y<ne?-1:Y>ne?1:q<Se?-1:q>Se?1:0}function se(Y,q){if(Y.type===0||q.type===1)return!0;if(Y.type===9)return q.type===9?$e(Y.expr,q.expr):!1;if(q.type===9){for(const ne of q.expr)if(se(Y,ne))return!0;return!1}if(Y.type===6){if(q.type===6)return $e(q.expr,Y.expr);for(const ne of Y.expr)if(se(ne,q))return!0;return!1}return Y.equals(q)}e.$xj=se;function $e(Y,q){let ne=0,Se=0;for(;ne<Y.length&&Se<q.length;){const Te=Y[ne].cmp(q[Se]);if(Te<0)return!1;Te===0&&ne++,Se++}return ne===Y.length}function ee(Y){return Y.type===9?Y.expr:[Y]}}),define(Ae[185],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=void 0,e.$li=(0,S.$ei)("environmentService"),e.$mi=(0,S.$fi)(e.$li)}),define(Ae[96],Me([1,0,152,4]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.ExtensionGalleryErrorCode=e.$Lo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ko=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=void 0,e.$yo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$zo=new RegExp(e.$yo),e.$Ao="__web_extension",e.$Bo="skipWalkthrough",e.$Co="extensionsSync",e.$Do="dependecyOrPackExtensionInstall";function P(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Eo=P;function F(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Fo=F;function R(r,u){switch(r){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Go=R;function g(r,u){return u==="web"&&!r.includes("web")}e.$Ho=g;function f(r,u,l){return g(u,l)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===l}e.$Io=f;function k(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$Jo=k;var A;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var D;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var h;(function(r){r.Install="install",r.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var v;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$Ko=(0,L.$ei)("extensionGalleryService");var p;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Unknown="Unknown",r.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var s;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class o extends Error{constructor(u,l){super(u),this.code=l,this.name=l}}e.$Lo=o;var t;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed"})(t||(e.ExtensionGalleryErrorCode=t={}));class n extends Error{constructor(u,l){super(u),this.code=l,this.name=l}}e.$Mo=n,e.$No=(0,L.$ei)("extensionManagementService"),e.$Oo="extensionsIdentifiers/disabled",e.$Po="extensionsIdentifiers/enabled",e.$Qo=(0,L.$ei)("IGlobalExtensionEnablementService"),e.$Ro=(0,L.$ei)("IExtensionTipsService"),e.$So=(0,S.localize2)(0,"Extensions"),e.$To=(0,S.localize2)(1,"Preferences")}),define(Ae[42],Me([1,0,51,19,13,16,2,154,4,20,12,39]),function(fe,e,S,L,P,F,R,g,f,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.FileKind=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileOperationResult=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.FileChangeType=e.$Tk=e.FileOperation=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileSystemProviderErrorCode=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderCapabilities=e.$Dk=e.FilePermission=e.FileType=e.$Ck=e.$Bk=void 0,e.$Bk=(0,f.$ei)("fileService");function h(se){return se.create===!0}e.$Ck=h;var v;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var p;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function s(se){const $e=se;return!!$e&&typeof $e.onDidChange=="function"}e.$Dk=s;var o;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function t(se){return!!(se.capabilities&2)}e.$Ek=t;function n(se){return!!(se.capabilities&8)}e.$Fk=n;function r(se){return!!(se.capabilities&131072)}e.$Gk=r;function u(se){return!!(se.capabilities&4)}e.$Hk=u;function l(se){return!!(se.capabilities&16)}e.$Ik=l;function i(se){return t(se)?!!(se.capabilities&16384):!1}e.$Jk=i;function $(se){return t(se)?!!(se.capabilities&32768):!1}e.$Kk=$;function a(se){return!!(se.capabilities&65536)}e.$Lk=a;function c(se){return!!(se.capabilities&2048)}e.$Mk=c;var E;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class y extends Error{static create($e,ee){const Y=new y($e.toString(),ee);return d(Y,ee),Y}constructor($e,ee){super($e),this.code=ee}}e.$Nk=y;function m(se,$e){return y.create(se,$e)}e.$Ok=m;function I(se){return se||m((0,g.localize)(0,null),E.Unknown)}e.$Pk=I;function d(se,$e){return se.name=$e?`${$e} (FileSystemError)`:"FileSystemError",se}e.$Qk=d;function w(se){if(!se)return E.Unknown;if(se instanceof y)return se.code;const $e=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!$e)return E.Unknown;switch($e[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.$Rk=w;function b(se){if(se instanceof C)return se.fileOperationResult;switch(w(se)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 9;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileTooLarge:return 7;default:return 10}}e.$Sk=b;var M;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class T{constructor($e,ee,Y){this.resource=$e,this.operation=ee,this.target=Y}isOperation($e){return this.operation===$e}}e.$Tk=T;var G;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class W{static{this.a=null}constructor($e,ee){this.c=ee,this.b=void 0,this.d=new D.$V(()=>{const Y=S.$ki.forUris(()=>this.c);return Y.fill(this.rawAdded.map(q=>[q,!0])),Y}),this.f=new D.$V(()=>{const Y=S.$ki.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(q=>[q,!0])),Y}),this.g=new D.$V(()=>{const Y=S.$ki.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(q=>[q,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of $e){switch(Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}this.b!==W.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains($e,...ee){return this.h($e,{includeChildren:!1},...ee)}affects($e,...ee){return this.h($e,{includeChildren:!0},...ee)}h($e,ee,...Y){if(!$e)return!1;const q=Y.length>0;return!!((!q||Y.includes(1))&&(this.d.value.get($e)||ee.includeChildren&&this.d.value.findSuperstr($e))||(!q||Y.includes(0))&&(this.f.value.get($e)||ee.includeChildren&&this.f.value.findSuperstr($e))||(!q||Y.includes(2))&&(this.g.value.findSubstr($e)||ee.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Uk=W;function U(se,$e,ee){return!se||!$e||se===$e||$e.length>se.length?!1:($e.charAt($e.length-1)!==L.sep&&($e+=L.sep),ee?(0,P.$kf)(se,$e):se.indexOf($e)===0)}e.$Vk=U;class C extends Error{constructor($e,ee,Y){super($e),this.fileOperationResult=ee,this.options=Y}}e.$Wk=C;class O extends C{constructor($e,ee,Y,q){super($e,ee,q),this.fileOperationResult=ee,this.size=Y}}e.$Xk=O;class V extends C{constructor($e,ee,Y){super($e,2,Y),this.stat=ee}}e.$Yk=V;var re;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$Zk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$1k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$2k="files.associations",e.$3k="files.exclude",e.$4k="files.readonlyInclude",e.$5k="files.readonlyExclude",e.$6k="files.readonlyFromPermissions";var ce;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$7k="";function ye(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.$8k=ye;async function De(se,$e){if(!$e.hasProvider(R.URI.from({scheme:se.scheme})))return new Promise(ee=>{const Y=$e.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===se.scheme&&q.added&&(Y.dispose(),ee())})})}e.$9k=De;class he{static{this.KB=1024}static{this.MB=he.KB*he.KB}static{this.GB=he.MB*he.KB}static{this.TB=he.GB*he.KB}static formatSize($e){return(0,F.$Wf)($e)||($e=0),$e<he.KB?(0,g.localize)(1,null,$e.toFixed(0)):$e<he.MB?(0,g.localize)(2,null,($e/he.KB).toFixed(2)):$e<he.GB?(0,g.localize)(3,null,($e/he.MB).toFixed(2)):$e<he.TB?(0,g.localize)(4,null,($e/he.GB).toFixed(2)):(0,g.localize)(5,null,($e/he.TB).toFixed(2))}}e.$0k=he;function ve(se){const $e=typeof se=="string"||se?.scheme===A.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===A.Schemas.file?1024*he.MB:$e?10*he.MB:k.$o?50*he.MB:1024*he.MB}e.$$k=ve}),define(Ae[71],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=void 0;class S{constructor(...P){this.a=new Map;for(const[F,R]of P)this.set(F,R)}set(P,F){const R=this.a.get(P);return this.a.set(P,F),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$ci=S}),define(Ae[186],Me([1,0,11,15,6,70,184,4,71,187]),function(fe,e,S,L,P,F,R,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=void 0;const A=!1;class D extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class h{constructor(o=new f.$ci,t=!1,n,r=A){this.f=o,this.g=t,this.h=n,this.i=r,this.o=new Set,this.f.set(g.$di,this),this._globalGraph=r?n?._globalGraph??new R.$Oq(u=>u):void 0}createChild(o){return new h(o,this.g,this,this.i)}invokeFunction(o,...t){const n=p.traceInvocation(this.i,o);let r=!1;try{return o({get:l=>{if(r)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(l,n);if(!i)throw new Error(`[invokeFunction] unknown service '${l}'`);return i}},...t)}finally{r=!0,n.stop()}}createInstance(o,...t){let n,r;return o instanceof F.$bi?(n=p.traceCreation(this.i,o.ctor),r=this.j(o.ctor,o.staticArguments.concat(t),n)):(n=p.traceCreation(this.i,o),r=this.j(o,t,n)),n.stop(),r}j(o,t=[],n){const r=g._util.getServiceDependencies(o).sort((i,$)=>i.index-$.index),u=[];for(const i of r){const $=this.m(i.id,n);$||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),u.push($)}const l=r.length>0?r[0].index:t.length;if(t.length!==l){console.trace(`[createInstance] First service dependency of ${o.name} at position ${l+1} conflicts with ${t.length} static arguments`);const i=l-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,l)}return Reflect.construct(o,t.concat(u))}k(o,t){if(this.f.get(o)instanceof F.$bi)this.f.set(o,t);else if(this.h)this.h.k(o,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const t=this.f.get(o);return!t&&this.h?this.h.l(o):t}m(o,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof F.$bi?this.q(o,n,t.branch(o,!0)):(t.branch(o,!1),n)}q(o,t,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,t,n)}finally{this.o.delete(o)}}r(o,t,n){const r=new R.$Oq(i=>i.id.toString());let u=0;const l=[{id:o,desc:t,_trace:n}];for(;l.length;){const i=l.pop();if(r.lookupOrInsertNode(i),u++>1e3)throw new D(r);for(const $ of g._util.getServiceDependencies(i.desc.ctor)){const a=this.l($.id);if(a||this.u(`[createInstance] ${o} depends on ${$.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String($.id)),a instanceof F.$bi){const c={id:$.id,desc:a,_trace:i._trace.branch($.id,!0)};r.insertEdge(i,c),l.push(c)}}}for(;;){const i=r.roots();if(i.length===0){if(!r.isEmpty())throw new D(r);break}for(const{data:$}of i){if(this.l($.id)instanceof F.$bi){const c=this.s($.id,$.desc.ctor,$.desc.staticArguments,$.desc.supportsDelayedInstantiation,$._trace);this.k($.id,c)}r.removeNode($)}}return this.l(o)}s(o,t,n=[],r,u){if(this.f.get(o)instanceof F.$bi)return this.t(o,t,n,r,u);if(this.h)return this.h.s(o,t,n,r,u);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(o,t,n=[],r,u){if(r){const l=new h(void 0,this.g,this,this.i);l.c=String(o);const i=new Map,$=new S.$xh(()=>{const a=l.j(t,n,u);for(const[c,E]of i){const y=a[c];if(typeof y=="function")for(const m of E)m.disposable=y.apply(a,m.listener)}return i.clear(),a});return new Proxy(Object.create(null),{get(a,c){if(!$.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let m=i.get(c);return m||(m=new k.$4c,i.set(c,m)),(d,w,b)=>{if($.isInitialized)return $.value[c](d,w,b);{const M={listener:[d,w,b],disposable:void 0},T=m.push(M);return(0,P.$Rc)(()=>{T(),M.disposable?.dispose()})}}}if(c in a)return a[c];const E=$.value;let y=E[c];return typeof y!="function"||(y=y.bind(E),a[c]=y),y},set(a,c,E){return $.value[c]=E,!0},getPrototypeOf(a){return t.prototype}})}else return this.j(t,n,u)}u(o,t){if(t&&console.warn(o),this.g)throw new Error(o)}}e.$Pq=h;var v;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(v||(v={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,t){return o?new p(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(o,t){return o?new p(1,t.name):p.c}static{this.f=0}constructor(o,t){this.type=o,this.name=t,this.g=Date.now(),this.h=[]}branch(o,t){const n=new p(3,o.toString());return this.h.push([o,t,n]),n}stop(){const o=Date.now()-this.g;p.f+=o;let t=!1;function n(u,l){const i=[],$=new Array(u+1).join("	");for(const[a,c,E]of l.h)if(c&&E){t=!0,i.push(`${$}CREATES -> ${a}`);const y=n(u+1,E);y&&i.push(y)}else i.push(`${$}uses -> ${a}`);return i.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(o>2||t)&&p.all.add(r.join(`
`))}}e.$Qq=p}),define(Ae[14],Me([1,0,41,5,97,6,28,20,25,16,2,35,4]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.log=e.$Bj=e.LogLevel=e.$Aj=e.$zj=e.$yj=void 0,e.$yj=(0,h.$ei)("logService"),e.$zj=(0,h.$ei)("loggerService");function v(){return new Date().toISOString()}function p(d){return(0,k.$Wf)(d)}e.$Aj=p;var s;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$Bj=s.Info;function o(d,w,b){switch(w){case s.Trace:d.trace(b);break;case s.Debug:d.debug(b);break;case s.Info:d.info(b);break;case s.Warning:d.warn(b);break;case s.Error:d.error(b);break;case s.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=o;function t(d,w=!1){let b="";for(let M=0;M<d.length;M++){let T=d[M];if(T instanceof Error&&(T=(0,S.$2i)(T,w)),typeof T=="object")try{T=JSON.stringify(T)}catch{}b+=(M>0?" ":"")+T}return b}class n extends F.$Tc{constructor(){super(...arguments),this.b=e.$Bj,this.c=this.B(new L.$5d),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==s.Off&&this.b<=w}}e.$Dj=n;class r extends n{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...b){this.f(s.Trace)&&this.g(s.Trace,t([w,...b],!0))}debug(w,...b){this.f(s.Debug)&&this.g(s.Debug,t([w,...b]))}info(w,...b){this.f(s.Info)&&this.g(s.Info,t([w,...b]))}warn(w,...b){this.f(s.Warning)&&this.g(s.Warning,t([w,...b]))}error(w,...b){if(this.f(s.Error))if(w instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=w.stack,this.g(s.Error,t(M))}else this.g(s.Error,t([w,...b]))}flush(){}}e.$Ej=r;class u extends n{constructor(w=e.$Bj){super(),this.setLevel(w),this.g=!g.$i}trace(w,...b){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...b):console.log(`[main ${v()}]`,w,...b))}debug(w,...b){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...b):console.log(`[main ${v()}]`,w,...b))}info(w,...b){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...b):console.log(`[main ${v()}]`,w,...b))}warn(w,...b){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,w,...b):console.warn(`[main ${v()}]`,w,...b))}error(w,...b){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,w,...b):console.error(`[main ${v()}]`,w,...b))}flush(){}}e.$Fj=u;class l extends n{constructor(w=e.$Bj,b=!0){super(),this.g=b,this.setLevel(w)}trace(w,...b){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...b):console.log(w,...b))}debug(w,...b){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...b):console.log(w,...b))}info(w,...b){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...b):console.log(w,...b))}warn(w,...b){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...b):console.log(w,...b))}error(w,...b){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...b):console.error(w,...b))}flush(){}}e.$Gj=l;class i extends n{constructor(w,b=e.$Bj){super(),this.g=w,this.setLevel(b)}trace(w,...b){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(w),...b])}debug(w,...b){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(w),...b])}info(w,...b){this.f(s.Info)&&this.g.log(s.Info,[this.h(w),...b])}warn(w,...b){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(w),...b])}error(w,...b){this.f(s.Error)&&this.g.log(s.Error,[this.h(w),...b])}h(w){return typeof w=="string"?w:(0,S.$2i)(w,this.f(s.Trace))}flush(){}}e.$Hj=i;class $ extends n{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const b of this.g)b.setLevel(w);super.setLevel(w)}trace(w,...b){for(const M of this.g)M.trace(w,...b)}debug(w,...b){for(const M of this.g)M.debug(w,...b)}info(w,...b){for(const M of this.g)M.info(w,...b)}warn(w,...b){for(const M of this.g)M.warn(w,...b)}error(w,...b){for(const M of this.g)M.error(w,...b)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$Ij=$;class a extends F.$Tc{constructor(w,b,M){if(super(),this.h=w,this.j=b,this.b=new R.$Ac,this.c=this.B(new L.$5d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$5d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$5d),this.onDidChangeVisibility=this.g.event,M)for(const T of M)this.b.set(T.resource,{logger:void 0,info:T})}m(w){return(0,k.$Sf)(w)?[...this.b.values()].find(b=>b.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,b){const M=this.n(w),T=(0,k.$Sf)(w)?w:b?.id??(0,P.$5i)(M.toString()).toString(16);let G=this.b.get(M)?.logger;const W=b?.logLevel==="always"?s.Trace:b?.logLevel;G||(G=this.s(M,W??this.getLogLevel(M)??this.h,{...b,id:T}));const U={logger:G,info:{resource:M,id:T,logLevel:W,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(U.info),this.b.set(M,U),G}n(w){return(0,k.$Sf)(w)?(0,f.$Rg)(this.j,`${w}.log`):w}setLogLevel(w,b){if(A.URI.isUri(w)){const M=w,T=b,G=this.b.get(M);G&&T!==G.info.logLevel&&(G.info.logLevel=T===this.h?void 0:T,G.logger?.setLevel(T),this.b.set(G.info.resource,G),this.f.fire([M,T]))}else{this.h=w;for(const[M,T]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,b){const M=this.m(w);M&&b!==!M.info.hidden&&(M.info.hidden=!b,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,b]))}getLogLevel(w){let b;return w&&(b=this.b.get(w)?.info.logLevel),b??this.h}registerLogger(w){const b=this.b.get(w.resource);b?b.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const b=this.b.get(w);b&&(b.logger&&b.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Jj=a;class c{constructor(){this.onDidChangeLogLevel=new L.$5d().event}setLevel(w){}getLevel(){return s.Info}trace(w,...b){}debug(w,...b){}info(w,...b){}warn(w,...b){}error(w,...b){}critical(w,...b){}dispose(){}flush(){}}e.$Kj=c;class E extends c{}e.$Lj=E;function y(d){if(d.verbose)return s.Trace;if(typeof d.logLevel=="string"){const w=I(d.logLevel.toLowerCase());if(w!==void 0)return w}return e.$Bj}e.$Mj=y;function m(d){switch(d){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}e.$Nj=m;function I(d){switch(d){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$Oj=I,e.$Pj=new D.$vj("logLevel",m(s.Info))}),define(Ae[188],Me([1,0,6,14]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=void 0;class P extends S.$Tc{constructor(R,g=[]){super(),this.a=new L.$Ij([R,...g]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...g){this.a.trace(R,...g)}debug(R,...g){this.a.debug(R,...g)}info(R,...g){this.a.info(R,...g)}warn(R,...g){this.a.warn(R,...g)}error(R,...g){this.a.error(R,...g)}flush(){this.a.flush()}}e.$AP=P}),define(Ae[98],Me([1,0,32,155,4]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var R;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(f){function k(p,s){return s-p}f.compare=k;const A=Object.create(null);A[f.Error]=(0,L.localize)(0,null),A[f.Warning]=(0,L.localize)(1,null),A[f.Info]=(0,L.localize)(2,null);function D(p){return A[p]||""}f.toString=D;function h(p){switch(p){case S.default.Error:return f.Error;case S.default.Warning:return f.Warning;case S.default.Info:return f.Info;case S.default.Ignore:return f.Hint}}f.fromSeverity=h;function v(p){switch(p){case f.Error:return S.default.Error;case f.Warning:return S.default.Warning;case f.Info:return S.default.Info;case f.Hint:return S.default.Ignore}}f.toSeverity=v}(R||(e.MarkerSeverity=R={}));var g;(function(f){const k="";function A(h){return D(h,!0)}f.makeKey=A;function D(h,v){const p=[k];return h.source?p.push(h.source.replace("\xA6","\\\xA6")):p.push(k),h.code?typeof h.code=="string"?p.push(h.code.replace("\xA6","\\\xA6")):p.push(h.code.value.replace("\xA6","\\\xA6")):p.push(k),h.severity!==void 0&&h.severity!==null?p.push(R.toString(h.severity)):p.push(k),h.message&&v?p.push(h.message.replace("\xA6","\\\xA6")):p.push(k),h.startLineNumber!==void 0&&h.startLineNumber!==null?p.push(h.startLineNumber.toString()):p.push(k),h.startColumn!==void 0&&h.startColumn!==null?p.push(h.startColumn.toString()):p.push(k),h.endLineNumber!==void 0&&h.endLineNumber!==null?p.push(h.endLineNumber.toString()):p.push(k),h.endColumn!==void 0&&h.endColumn!==null?p.push(h.endColumn.toString()):p.push(k),p.push(k),p.join("\xA6")}f.makeKeyOptionalMessage=D})(g||(e.IMarkerData=g={})),e.$Lt=(0,P.$ei)("markerService")}),define(Ae[189],Me([1,0,5,32,4]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.NotificationsFilter=e.$Cv=e.NeverShowAgainScope=e.NotificationPriority=e.$Bv=e.Severity=void 0,e.Severity=L.default,e.$Bv=(0,P.$ei)("notificationService");var F;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var R;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function g(D){if(D){const h=D;return typeof h.id=="string"&&typeof h.label=="string"}return!1}e.$Cv=g;var f;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class k{constructor(){this.progress=new A,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(h){}updateMessage(h){}updateActions(h){}close(){}}e.$Dv=k;class A{infinite(){}done(){}total(h){}worked(h){}}e.$Ev=A}),define(Ae[190],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=void 0,e.$Qj=(0,S.$ei)("productService"),e.$Rj="vscode://schemas/vscode-product"});var Xe=this&&this.__decorate||function(fe,e,S,L){var P=arguments.length,F=P<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,S):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(fe,e,S,L);else for(var g=fe.length-1;g>=0;g--)(R=fe[g])&&(F=(P<3?R(F):P>3?R(e,S,F):R(e,S))||F);return P>3&&F&&Object.defineProperty(e,S,F),F},qe=this&&this.__param||function(fe,e){return function(S,L){e(S,L,fe)}};define(Ae[99],Me([1,0,11,21,6,4]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.ProgressLocation=e.$Fv=void 0,e.$Fv=(0,F.$ei)("progressService");var R;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Gv=Object.freeze({total(){},worked(){},done(){}});class g{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(h){this.b=h}report(h){this.a=h,this.b(this.a)}}e.$Hv=g;class f{get value(){return this.a}constructor(h){this.e=h}report(h){this.b?this.b.push(h):this.b=[h],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const h=this.b.shift();this.a=h,await this.e(this.a)}}finally{this.c=!1;const h=this.d;this.d=void 0,h?.()}}drain(){return this.c?new Promise(h=>{const v=this.d;this.d=()=>{v?.(),h()}}):Promise.resolve()}}e.$Iv=f;let k=class extends P.$Tc{constructor(h,v){super(),this.a=new S.$Bh,v.withProgress(h,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,P.$Rc)(()=>this.a.complete()))}report(h){this.b?this.b.report(h):this.c=h}};e.$Jv=k,e.$Jv=k=Xe([qe(1,e.$Fv)],k);class A extends P.$Tc{constructor(h){super(),this.g=h,this.a=0,this.b=this.B(new P.$Sc)}start(h){this.stop();const v=++this.a,p=new L.$ce;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},h),this.b.add((0,P.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Rc)(()=>p.cancel())),this.b.add((0,P.$Rc)(()=>this.c?this.c.done():void 0)),{id:v,token:p.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(h){this.a===h&&this.b.clear()}}e.$Kv=A,e.$Lv=(0,F.$ei)("editorProgressService")}),define(Ae[30],Me([1,0,54,16]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=void 0;class P{constructor(){this.a=new Map}add(R,g){S.ok(L.$Sf(R)),S.ok(L.$Uf(g)),S.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,g)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Tn=new P}),define(Ae[72],Me([1,0,5,30]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=void 0,e.$Un={JSONContribution:"base.contributions.json"};function P(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class F{constructor(){this.b=new S.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,k){this.a[P(f)]=k,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new F;L.$Tn.add(e.$Un.JSONContribution,R)}),define(Ae[55],Me([1,0,18,5,16,149,47,72,30]),function(fe,e,S,L,P,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ConfigurationScope=e.$Yn=e.EditPresentationTypes=void 0;var k;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$Yn={Configuration:"base.contributions.configuration"};var A;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Zn={properties:{},patternProperties:{}},e.$1n={properties:{},patternProperties:{}},e.$2n={properties:{},patternProperties:{}},e.$3n={properties:{},patternProperties:{}},e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n="vscode://schemas/settings/resourceLanguage",e.$7n="vscode://schemas/settings/configurationDefaults";const D=f.$Tn.as(g.$Un.JSONContribution);class h{constructor(){this.h=new Set,this.i=new L.$5d,this.onDidSchemaChange=this.i.event,this.j=new L.$5d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$6n,this.g),this.v()}registerConfiguration(i,$=!0){this.registerConfigurations([i],$)}registerConfigurations(i,$=!0){const a=new Set;this.n(i,$,a),D.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(i){const $=new Set;this.o(i,$),D.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:$})}updateConfigurations({add:i,remove:$}){const a=new Set;this.o($,a),this.n(i,!1,a),D.registerSchema(e.$6n,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(i){const $=new Set;this.k(i,$),this.i.fire(),this.j.fire({properties:$,defaultsOverrides:!0})}k(i,$){const a=[];for(const{overrides:c,source:E}of i)for(const y in c)if($.add(y),e.$9n.test(y)){const m=this.a.get(y),I=m?.valuesSources??new Map;if(E)for(const M of Object.keys(c[y]))I.set(M,E);const d={...m?.value||{},...c[y]};this.a.set(y,{source:E,value:d,valuesSources:I});const w=(0,R.$Ui)(y),b={type:"object",default:d,description:F.localize(1,null,w),$ref:e.$6n,defaultDefaultValue:d,source:P.$Sf(E)?void 0:E,defaultValueSource:E};a.push(...s(y)),this.d[y]=b,this.b.properties[y]=b}else{this.a.set(y,{value:c[y],source:E});const m=this.d[y];m&&(this.w(y,m),this.r(y,m))}this.m(a)}deregisterDefaultConfigurations(i){const $=new Set;this.l(i,$),this.i.fire(),this.j.fire({properties:$,defaultsOverrides:!0})}l(i,$){for(const{overrides:a,source:c}of i)for(const E in a){const y=this.a.get(E),m=P.$Sf(c)?c:c?.id,I=P.$Sf(y?.source)?y?.source:y?.source?.id;if(m===I)if($.add(E),this.a.delete(E),e.$9n.test(E))delete this.d[E],delete this.b.properties[E];else{const d=this.d[E];d&&(this.w(E,d),this.r(E,d))}}this.u()}deltaConfiguration(i){let $=!1;const a=new Set;i.removedDefaults&&(this.l(i.removedDefaults,a),$=!0),i.addedDefaults&&(this.k(i.addedDefaults,a),$=!0),i.removedConfigurations&&this.o(i.removedConfigurations,a),i.addedConfigurations&&this.n(i.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:$})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const $ of i)this.h.add($);this.u()}n(i,$,a){i.forEach(c=>{this.p(c,$,c.extensionInfo,c.restrictedProperties,void 0,a),this.c.push(c),this.q(c)})}o(i,$){const a=c=>{if(c.properties)for(const E in c.properties){$.add(E);const y=this.d[E];y?.policy?.name&&this.e.delete(y.policy.name),delete this.d[E],this.s(E,c.properties[E])}c.allOf?.forEach(E=>a(E))};for(const c of i){a(c);const E=this.c.indexOf(c);E!==-1&&this.c.splice(E,1)}}p(i,$=!0,a,c,E=3,y){E=P.$2f(i.scope)?E:i.scope;const m=i.properties;if(m)for(const d in m){const w=m[d];if($&&r(d,w)){delete m[d];continue}if(w.source=a,w.defaultDefaultValue=m[d].default,this.w(d,w),e.$9n.test(d)?w.scope=void 0:(w.scope=P.$2f(w.scope)?E:w.scope,w.restricted=P.$2f(w.restricted)?!!c?.includes(d):w.restricted),m[d].hasOwnProperty("included")&&!m[d].included){this.f[d]=m[d],delete m[d];continue}else this.d[d]=m[d],m[d].policy?.name&&this.e.set(m[d].policy.name,d);!m[d].deprecationMessage&&m[d].markdownDeprecationMessage&&(m[d].deprecationMessage=m[d].markdownDeprecationMessage),y.add(d)}const I=i.allOf;if(I)for(const d of I)this.p(d,$,a,c,E,y)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const $=a=>{const c=a.properties;if(c)for(const y in c)this.r(y,c[y]);a.allOf?.forEach($)};$(i)}r(i,$){switch(e.$Zn.properties[i]=$,$.scope){case 1:e.$1n.properties[i]=$;break;case 2:e.$2n.properties[i]=$;break;case 6:e.$3n.properties[i]=$;break;case 3:e.$4n.properties[i]=$;break;case 4:e.$5n.properties[i]=$;break;case 5:e.$5n.properties[i]=$,this.g.properties[i]=$;break}}s(i,$){switch(delete e.$Zn.properties[i],$.scope){case 1:delete e.$1n.properties[i];break;case 2:delete e.$2n.properties[i];break;case 6:delete e.$3n.properties[i];break;case 3:delete e.$4n.properties[i];break;case 4:case 5:delete e.$5n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const $=`[${i}]`,a={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$6n};this.w($,a),e.$Zn.properties[$]=a,e.$1n.properties[$]=a,e.$2n.properties[$]=a,e.$3n.properties[$]=a,e.$4n.properties[$]=a,e.$5n.properties[$]=a}}v(){const i={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$6n};e.$Zn.patternProperties[e.$8n]=i,e.$1n.patternProperties[e.$8n]=i,e.$2n.patternProperties[e.$8n]=i,e.$3n.patternProperties[e.$8n]=i,e.$4n.patternProperties[e.$8n]=i,e.$5n.patternProperties[e.$8n]=i,this.i.fire()}w(i,$){const a=this.a.get(i);let c=a?.value,E=a?.source;P.$Zf(c)&&(c=$.defaultDefaultValue,E=void 0),P.$Zf(c)&&(c=t($.type)),$.default=c,$.defaultValueSource=E}}const v="\\[([^\\]]+)\\]",p=new RegExp(v,"g");e.$8n=`^(${v})+$`,e.$9n=new RegExp(e.$8n);function s(l){const i=[];if(e.$9n.test(l)){let $=p.exec(l);for(;$?.length;){const a=$[1].trim();a&&i.push(a),$=p.exec(l)}}return(0,S.$Mb)(i)}e.$0n=s;function o(l){return l.reduce((i,$)=>`${i}[${$}]`,"")}e.$$n=o;function t(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$_n=t;const n=new h;f.$Tn.add(e.$Yn.Configuration,n);function r(l,i){return l.trim()?e.$9n.test(l)?F.localize(7,null,l):n.getConfigurationProperties()[l]!==void 0?F.localize(8,null,l):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?F.localize(9,null,l,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:F.localize(6,null)}e.$ao=r;function u(){const l=[],i=n.getConfigurationProperties();for(const $ of Object.keys(i))l.push([$,i[$].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$bo=u}),define(Ae[191],Me([1,0,18,5,120,6,28,26,16,2,47,55,30]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=void 0;function v($){return Object.isFrozen($)?$:g.$In($)}class p{constructor(a={},c=[],E=[],y){this.b=a,this.c=c,this.d=E,this.raw=y,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(c=>{if(c instanceof p)return c;const E=new s("");return E.parseRaw(c),E.configurationModel});this.f=a.reduce((c,E)=>E===c?E:c.merge(E),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,A.$Si)(this.contents,a):this.contents}inspect(a,c){const E=this;return{get value(){return v(E.rawConfiguration.getValue(a))},get override(){return c?v(E.rawConfiguration.getOverrideValue(a,c)):void 0},get merged(){return v(c?E.rawConfiguration.override(c).getValue(a):E.rawConfiguration.getValue(a))},get overrides(){const y=[];for(const{contents:m,identifiers:I,keys:d}of E.rawConfiguration.overrides){const w=new p(m,d).getValue(a);w!==void 0&&y.push({identifiers:I,value:w})}return y.length?v(y):void 0}}}getOverrideValue(a,c){const E=this.i(c);return E?a?(0,A.$Si)(E,a):E:void 0}getKeysForOverrideIdentifier(a){const c=[];for(const E of this.overrides)E.identifiers.includes(a)&&c.push(...E.keys);return S.$Mb(c)}getAllOverrideIdentifiers(){const a=[];for(const c of this.overrides)a.push(...c.identifiers);return S.$Mb(a)}override(a){let c=this.a.get(a);return c||(c=this.g(a),this.a.set(a,c)),c}merge(...a){const c=g.$Hn(this.contents),E=g.$Hn(this.overrides),y=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const I of a)if(m.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(c,I.contents);for(const d of I.overrides){const[w]=E.filter(b=>S.$ub(b.identifiers,d.identifiers));w?(this.h(w.contents,d.contents),w.keys.push(...d.keys),w.keys=S.$Mb(w.keys)):E.push(g.$Hn(d))}for(const d of I.keys)y.indexOf(d)===-1&&y.push(d)}return new p(c,y,E,m.every(I=>I instanceof p)?void 0:m)}g(a){const c=this.i(a);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const E={};for(const y of S.$Mb([...Object.keys(this.contents),...Object.keys(c)])){let m=this.contents[y];const I=c[y];I&&(typeof m=="object"&&typeof I=="object"?(m=g.$Hn(m),this.h(m,I)):m=I),E[y]=m}return new p(E,this.keys,this.overrides)}h(a,c){for(const E of Object.keys(c)){if(E in a&&f.$Uf(a[E])&&f.$Uf(c[E])){this.h(a[E],c[E]);continue}a[E]=g.$Hn(c[E])}}i(a){let c=null,E=null;const y=m=>{m&&(E?this.h(E,m):E=g.$Hn(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===a?c=m.contents:m.identifiers.includes(a)&&y(m.contents);return y(c),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,c){this.j(a,c,!0)}setValue(a,c){this.j(a,c,!1)}removeValue(a){const c=this.keys.indexOf(a);c!==-1&&(this.keys.splice(c,1),(0,A.$Ri)(this.contents,a),D.$9n.test(a)&&this.overrides.splice(this.overrides.findIndex(E=>S.$ub(E.identifiers,(0,D.$0n)(a))),1))}j(a,c,E){(0,A.$Qi)(this.contents,a,c,y=>console.error(y)),E=E||this.keys.indexOf(a)===-1,E&&this.keys.push(a),D.$9n.test(a)&&this.overrides.push({identifiers:(0,D.$0n)(a),keys:Object.keys(this.contents[a]),contents:(0,A.$Pi)(this.contents[a],y=>console.error(y))})}}e.$co=p;class s{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,c){if(!f.$2f(a)){const E=this.g(a);this.parseRaw(E,c)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,c){this.a=a;const{contents:E,keys:y,overrides:m,restricted:I,hasExcludedProperties:d}=this.h(a,c);this.b=new p(E,y,m,d?[a]:void 0),this.c=I||[]}g(a){let c={},E=null,y=[];const m=[],I=[];function d(b){Array.isArray(y)?y.push(b):E!==null&&(y[E]=b)}const w={onObjectBegin:()=>{const b={};d(b),m.push(y),y=b,E=null},onObjectProperty:b=>{E=b},onObjectEnd:()=>{y=m.pop()},onArrayBegin:()=>{const b=[];d(b),m.push(y),y=b,E=null},onArrayEnd:()=>{y=m.pop()},onLiteralValue:d,onError:(b,M,T)=>{I.push({error:b,offset:M,length:T})}};if(a)try{P.$vn(a,w),c=y[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return c}h(a,c){const E=h.$Tn.as(D.$Yn.Configuration).getConfigurationProperties(),y=this.i(a,E,!0,c);a=y.raw;const m=(0,A.$Pi)(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),I=Object.keys(a),d=this.j(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:m,keys:I,overrides:d,restricted:y.restricted,hasExcludedProperties:y.hasExcludedProperties}}i(a,c,E,y){let m=!1;if(!y?.scopes&&!y?.skipRestricted&&!y?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:m};const I={},d=[];for(const w in a)if(D.$9n.test(w)&&E){const b=this.i(a[w],c,!1,y);I[w]=b.raw,m=m||b.hasExcludedProperties,d.push(...b.restricted)}else{const b=c[w],M=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&d.push(w),!y.exclude?.includes(w)&&(y.include?.includes(w)||(M===void 0||y.scopes===void 0||y.scopes.includes(M))&&!(y.skipRestricted&&b?.restricted))?I[w]=a[w]:m=!0}return{raw:I,restricted:d,hasExcludedProperties:m}}j(a,c){const E=[];for(const y of Object.keys(a))if(D.$9n.test(y)){const m={};for(const I in a[y])m[I]=a[y][I];E.push({identifiers:(0,D.$0n)(y),keys:Object.keys(m),contents:(0,A.$Pi)(m,c)})}return E}}e.$do=s;class o extends F.$Tc{constructor(a,c,E,y){super(),this.c=a,this.f=c,this.g=y,this.b=this.B(new L.$5d),this.onDidChange=this.b.event,this.a=new s(this.c.toString()),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,m=>m.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&E.isEqual(m.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$eo=o;class t{constructor(a,c,E,y,m,I,d,w,b,M,T,G,W){this.a=a,this.b=c,this.c=E,this.overrideIdentifiers=y,this.d=m,this.f=I,this.g=d,this.h=w,this.i=b,this.j=M,this.k=T,this.l=G,this.m=W}get value(){return v(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,c,E,y,m=new p,I=new p,d=new R.$Ac,w=new p,b=new R.$Ac){this.c=a,this.d=c,this.f=E,this.g=y,this.h=m,this.i=I,this.j=d,this.l=w,this.m=b,this.a=null,this.b=new R.$Ac,this.n=null}getValue(a,c,E){return this.p(a,c,E).getValue(a)}updateValue(a,c,E={}){let y;E.resource?(y=this.m.get(E.resource),y||(y=new p,this.m.set(E.resource,y))):y=this.l,c===void 0?y.removeValue(a):y.setValue(a,c),E.resource||(this.a=null)}inspect(a,c,E){const y=this.p(a,c,E),m=this.t(c.resource,E),I=c.resource?this.m.get(c.resource)||this.l:this.l,d=new Set;for(const w of y.overrides)for(const b of w.identifiers)y.getOverrideValue(a,b)!==void 0&&d.add(b);return new t(a,c,y.getValue(a),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.i:void 0,m||void 0,I)}keys(a){const c=this.t(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,c){this.j.set(a,c),this.b.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,c){const E=[];if(!c){const{added:y,updated:m,removed:I}=l(this.c,a);c=[...y,...m,...I]}for(const y of c)for(const m of(0,D.$0n)(y)){const I=this.c.getKeysForOverrideIdentifier(m),d=a.getKeysForOverrideIdentifier(m),w=[...d.filter(b=>I.indexOf(b)===-1),...I.filter(b=>d.indexOf(b)===-1),...I.filter(b=>!g.$Ln(this.c.override(m).getValue(b),a.override(m).getValue(b)))];E.push([m,w])}return this.updateDefaultConfiguration(a),{keys:c,overrides:E}}compareAndUpdatePolicyConfiguration(a){const{added:c,updated:E,removed:y}=l(this.d,a),m=[...c,...E,...y];return m.length&&this.updatePolicyConfiguration(a),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:c,updated:E,removed:y,overrides:m}=l(this.applicationConfiguration,a),I=[...c,...E,...y];return I.length&&this.updateApplicationConfiguration(a),{keys:I,overrides:m}}compareAndUpdateLocalUserConfiguration(a){const{added:c,updated:E,removed:y,overrides:m}=l(this.localUserConfiguration,a),I=[...c,...E,...y];return I.length&&this.updateLocalUserConfiguration(a),{keys:I,overrides:m}}compareAndUpdateRemoteUserConfiguration(a){const{added:c,updated:E,removed:y,overrides:m}=l(this.remoteUserConfiguration,a),I=[...c,...E,...y];return I.length&&this.updateRemoteUserConfiguration(a),{keys:I,overrides:m}}compareAndUpdateWorkspaceConfiguration(a){const{added:c,updated:E,removed:y,overrides:m}=l(this.workspaceConfiguration,a),I=[...c,...E,...y];return I.length&&this.updateWorkspaceConfiguration(a),{keys:I,overrides:m}}compareAndUpdateFolderConfiguration(a,c){const E=this.folderConfigurations.get(a),{added:y,updated:m,removed:I,overrides:d}=l(E,c),w=[...y,...m,...I];return(w.length||!E)&&this.updateFolderConfiguration(a,c),{keys:w,overrides:d}}compareAndDeleteFolderConfiguration(a){const c=this.folderConfigurations.get(a);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:E,updated:y,removed:m,overrides:I}=l(c,void 0);return{keys:[...E,...y,...m],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(a,c,E){let y=this.q(c,E);return c.overrideIdentifier&&(y=y.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(y=y.merge(this.d)),y}q({resource:a},c){let E=this.r();if(c&&a){const y=c.getFolder(a);y&&(E=this.s(y.uri)||E);const m=this.m.get(a);m&&(E=E.merge(m))}return E}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(a){let c=this.b.get(a);if(!c){const E=this.r(),y=this.j.get(a);y?(c=E.merge(y),this.b.set(a,c)):c=E}return c}t(a,c){if(c&&a){const E=c.getFolder(a);if(E)return this.j.get(E.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,c)=>{const{contents:E,overrides:y,keys:m}=this.j.get(c);return a.push([c,{contents:E,overrides:y,keys:m}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(c=>a.add(c)),this.userConfiguration.keys.forEach(c=>a.add(c)),this.i.keys.forEach(c=>a.add(c)),this.j.forEach(c=>c.keys.forEach(E=>a.add(E))),[...a.values()]}u(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>a.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>a.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>a.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(E=>a.add(E))),[...a.values()]}v(a){const c=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(E=>c.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(E=>c.add(E)),this.i.getKeysForOverrideIdentifier(a).forEach(E=>c.add(E)),this.j.forEach(E=>E.getKeysForOverrideIdentifier(a).forEach(y=>c.add(y))),[...c.values()]}static parse(a){const c=this.w(a.defaults),E=this.w(a.policy),y=this.w(a.application),m=this.w(a.user),I=this.w(a.workspace),d=a.folders.reduce((w,b)=>(w.set(k.URI.revive(b[0]),this.w(b[1])),w),new R.$Ac);return new n(c,E,y,m,new p,I,d,new p,new R.$Ac)}static w(a){return new p(a.contents,a.keys,a.overrides)}}e.$fo=n;function r(...$){if($.length===0)return{keys:[],overrides:[]};if($.length===1)return $[0];const a=new Set,c=new Map;for(const y of $)y.keys.forEach(m=>a.add(m)),y.overrides.forEach(([m,I])=>{const d=(0,R.$xc)(c,m,new Set);I.forEach(w=>d.add(w))});const E=[];return c.forEach((y,m)=>E.push([m,[...y.values()]])),{keys:[...a.values()],overrides:E}}e.$go=r;class u{constructor(a,c,E,y){this.change=a,this.f=c,this.g=E,this.h=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const m of a.keys)this.affectedKeys.add(m);for(const[,m]of a.overrides)for(const I of m)this.affectedKeys.add(I);this.d=this.a;for(const m of this.affectedKeys)this.d+=m+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(a,c){const E=this.a+a,y=this.d.indexOf(E);if(y<0)return!1;const m=y+E.length;if(m>=this.d.length)return!1;const I=this.d.charCodeAt(m);if(I!==this.b&&I!==this.c)return!1;if(c){const d=this.previousConfiguration?this.previousConfiguration.getValue(a,c,this.f?.workspace):void 0,w=this.g.getValue(a,c,this.h);return!g.$Ln(d,w)}return!0}}e.$ho=u;function l($,a){const{added:c,removed:E,updated:y}=i(a?.rawConfiguration,$?.rawConfiguration),m=[],I=$?.getAllOverrideIdentifiers()||[],d=a?.getAllOverrideIdentifiers()||[];if(a){const w=d.filter(b=>!I.includes(b));for(const b of w)m.push([b,a.getKeysForOverrideIdentifier(b)])}if($){const w=I.filter(b=>!d.includes(b));for(const b of w)m.push([b,$.getKeysForOverrideIdentifier(b)])}if(a&&$){for(const w of I)if(d.includes(w)){const b=i({contents:$.getOverrideValue(void 0,w)||{},keys:$.getKeysForOverrideIdentifier(w)},{contents:a.getOverrideValue(void 0,w)||{},keys:a.getKeysForOverrideIdentifier(w)});m.push([w,[...b.added,...b.removed,...b.updated]])}}return{added:c,removed:E,updated:y,overrides:m}}function i($,a){const c=$?a?$.keys.filter(m=>a.keys.indexOf(m)===-1):[...$.keys]:[],E=a?$?a.keys.filter(m=>$.keys.indexOf(m)===-1):[...a.keys]:[],y=[];if($&&a){for(const m of a.keys)if($.keys.indexOf(m)!==-1){const I=(0,A.$Si)(a.contents,m),d=(0,A.$Si)($.contents,m);g.$Ln(I,d)||y.push(m)}}return{added:c,removed:E,updated:y}}}),define(Ae[100],Me([1,0,15,4]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.RemoteAuthorityResolverErrorCode=e.$il=e.$hl=e.RemoteConnectionType=e.$gl=void 0,e.$gl=(0,L.$ei)("remoteAuthorityResolverService");var P;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class F{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$hl=F;class R{constructor(D,h){this.host=D,this.port=h,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$il=R;var g;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class f extends S.$bb{static isNotAvailable(D){return D instanceof f&&D._code===g.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof f&&D._code===g.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof f&&D._code===g.NoResolverFound}static isInvalidAuthority(D){return D instanceof f&&D._code===g.InvalidAuthority}static isHandled(D){return D instanceof f&&D.isHandled}constructor(D,h=g.Unknown,v){super(D),this._message=D,this._code=h,this._detail=v,this.isHandled=h===g.NotAvailable&&v===!0,Object.setPrototypeOf(this,f.prototype)}}e.$jl=f;function k(A){const D=A.indexOf("+");return D===-1?A:A.substring(0,D)}e.$kl=k}),define(Ae[56],Me([1,0,12]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=void 0;function L(k){return k.scheme===S.Schemas.vscodeRemote?k.authority:void 0}e.$ll=L;function P(k){if(!k)return;const A=k.indexOf("+");return A<0?k:k.substr(0,A)}e.$ml=P;function F(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.$nl=F;function R(k){const{host:A,port:D}=f(k);if(typeof D>"u")throw new Error(`Invalid remote authority: ${k}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:D}}e.$ol=R;function g(k,A){let{host:D,port:h}=f(k);return typeof h>"u"&&(h=A),{host:D,port:h}}e.$pl=g;function f(k){const A=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const D=k.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const h=k.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:k,port:void 0}}}),define(Ae[22],Me([1,0,13,4,56]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.TargetPlatform=e.ExtensionType=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=e.$qm=void 0,e.$qm="extensions.user.cache",e.$rm="extensions.builtin.cache",e.$sm="undefined_publisher",e.$tm=["ui","workspace","web"];function F(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$um=F,e.$vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(R||(e.ExtensionType=R={}));var g;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class f{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,t){if(typeof o>"u"||o===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof o=="string"||typeof t=="string"){const n=typeof o=="string"?o:o.value,r=typeof t=="string"?t:t.value;return S.$jf(n,r)}return o._lower===t._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$wm=f;class k{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const t of o)this.add(t)}add(o){this.c.add(f.toKey(o))}delete(o){return this.c.delete(f.toKey(o))}has(o){return this.c.has(f.toKey(o))}}e.$xm=k;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(f.toKey(o))}get(o){return this.c.get(f.toKey(o))}has(o){return this.c.has(f.toKey(o))}set(o,t){this.c.set(f.toKey(o),t)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$ym=A;function D(s){return h(s)}e.$zm=D;function h(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.$Am=h;function v(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.$Bm=v;function p(s,o){if(o){const t=`onResolveRemoteAuthority:${(0,P.$ml)(o)}`;return!!s.activationEvents?.includes(t)}return!1}e.$Cm=p,e.$Dm=(0,L.$ei)("IBuiltinExtensionsScannerService")}),define(Ae[101],Me([1,0,15,22]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AF=e.$zF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,g){this.a.set(R,g)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const g=Object.create(null);for(const f of R){const k=this.readActivationEvents(f);k.length>0&&(g[L.$wm.toKey(f.identifier)]=k)}return g}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const g=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let f=0;f<g.length;f++)g[f]==="onUri"&&(g[f]=`onUri:${L.$wm.toKey(R.identifier)}`);if(!R.contributes)return g;for(const f in R.contributes){const k=this.a.get(f);if(!k)continue;const A=R.contributes[f],D=Array.isArray(A)?A:[A];try{k(D,g)}catch(h){(0,S.$1)(h)}}return g}}e.$zF=P,e.$AF=new P}),define(Ae[192],Me([1,0,20,73,33]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=void 0;function F(f){if(S.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function R(f,k,A,D,h,v,p,s,o){const t=Object.create(null);t["common.machineId"]=v,t["common.sqmId"]=p,t.sessionID=(0,P.$Ag)()+Date.now(),t.commitHash=D,t.version=h,t["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,S.$h)(S.$u),t["common.nodePlatform"]=L.$dc,t["common.nodeArch"]=A,t["common.product"]=o||"desktop",s&&(t["common.msftInternal"]=s);let n=0;const r=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),S.$l&&(t["common.snap"]="true");const u=F(k);return u&&(t["common.platformDetail"]=u),t}e.$Uo=R;function g(f){const k=L.env.USERDNSDOMAIN;if(!k)return!1;const A=k.toLowerCase();return f.some(D=>A===D)}e.$Vo=g}),define(Ae[193],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,S.$ei)("telemetryService"),e.$Gl=(0,S.$ei)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var L;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var P;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ae[57],Me([1,0,26,16,56,192,193]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0;class g{constructor($){this.value=$,this.isTrustedTelemetryValue=!0}}e.$Wo=g;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Xo=f,e.$Yo=new f;class k{async publicLog($,a,c){}async publicLogError($,a,c){}}e.$Zo=k,e.$1o="telemetry",e.$2o="extensionTelemetryLog",e.$3o={log:()=>null,flush:()=>Promise.resolve(null)};function A(i,$){return!$.isBuilt&&!$.disableTelemetry?!0:!($.disableTelemetry||!i.enableTelemetry)}e.$4o=A;function D(i,$){return $.extensionTestsLocationURI?!0:!($.isBuilt||$.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$5o=D;function h(i){const $=i.getValue(R.$Nl),a=i.getValue(R.$Ol);if(i.getValue(R.$Pl)===!1||a===!1)return 0;switch($??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$6o=h;function v(i){const $={},a={},c={};o(i,c);for(let E in c){E=E.length>150?E.substr(E.length-149):E;const y=c[E];typeof y=="number"?a[E]=y:typeof y=="boolean"?a[E]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${y.length}`),$[E]=y.substring(0,8191)):typeof y<"u"&&y!==null&&($[E]=y)}return{properties:$,measurements:a}}e.$7o=v;const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const $=(0,P.$ml)(i);return p.has($)?$:"other"}e.$8o=s;function o(i,$,a=0,c){if(i)for(const E of Object.getOwnPropertyNames(i)){const y=i[E],m=c?c+E:E;Array.isArray(y)?$[m]=(0,S.$Mn)(y):y instanceof Date?$[m]=y.toISOString():(0,L.$Uf)(y)?a<2?o(y,$,a+1,m+"."):$[m]=(0,S.$Mn)(y):$[m]=y}}function t(i,$){const a=i.msftInternalDomains||[],c=$.getValue("telemetry.internalTesting");return(0,F.$Vo)(a)||c}e.$9o=t;function n(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$0o=n;function r(i,$){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const c=[];for(const I of $)for(;;){const d=I.exec(i);if(!d)break;c.push([d.index,I.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(a="";;){const I=y.exec(i);if(!I)break;const d=c.some(([w,b])=>I.index<b&&w<y.lastIndex);!E.test(I[0])&&!d&&(a+=i.substring(m,I.index)+"<REDACTED: user-file-path>",m=y.lastIndex)}return m<i.length&&(a+=i.substr(m)),a}function u(i){if(!i)return i;const $=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of $)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function l(i,$){return(0,S.$Jn)(i,a=>{if(a instanceof g||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let c=a.replaceAll("%20"," ");c=r(c,$);for(const E of $)c=c.replace(E,"");return c=u(c),c}})}e.$$o=l}),define(Ae[194],Me([1,0,13,96,22,20,2,15,73,57]),function(fe,e,S,L,P,F,R,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0;function A(a,c){return a.uuid&&c.uuid?a.uuid===c.uuid:a.id===c.id?!0:(0,S.$ef)(a.id,c.id)===0}e.$_o=A;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(c){const E=c.manifest?c.manifest.version:c.version,y=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new h(c.identifier,E,y)}static parse(c){const E=D.exec(c);return E&&E[1]&&E[2]?new h({id:E[1]},E[2],E[4]||void 0):null}constructor(c,E,y="undefined"){this.version=E,this.targetPlatform=y,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof h?A(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$ap=h;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(a){const c=v.exec(a);return c&&c[1]?[o(c[1]),c[2]]:[o(a),void 0]}e.$bp=p;function s(a,c){return`${a}.${c}`}e.$cp=s;function o(a){return a.toLowerCase()}e.$dp=o;function t(a,c){return o(s(a??P.$sm,c))}e.$ep=t;function n(a,c){const E=[],y=m=>{for(const I of E)if(I.some(d=>A(c(d),c(m))))return I;return null};for(const m of a){const I=y(m);I?I.push(m):E.push([m])}return E}e.$fp=n;function r(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$gp=r;function u(a){return{id:new k.$Wo(a.identifier.id),name:new k.$Wo(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$hp=u,e.$ip=new P.$wm("pprice.better-merge");function l(a,c){const E=[],y=c.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const m=y.shift();if(m&&E.every(I=>!A(I.identifier,{id:m}))){const I=a.filter(d=>A(d.identifier,{id:m}));I.length===1&&(E.push(I[0]),y.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.$jp=l;async function i(a,c){if(!F.$k)return!1;let E;try{E=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{E=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){c.debug("Error while getting the os-release file.",(0,g.$0)(m))}}return!!E&&(E.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function $(a,c){const E=await i(a,c),y=(0,L.$Go)(E?"alpine":F.$u,f.$ec);return c.debug("ComputeTargetPlatform:",y),y}e.$kp=$}),define(Ae[195],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=e.$2r=e.$1r=e.$Zr=e.$Yr=e.$Xr=void 0;function S(f){return[...f.entries()]}e.$Xr=S;function L(f){return f?[...f.entries()]:[]}e.$Yr=L;function P(f){return new Map(f)}e.$Zr=P;function F(f){return new Map(f??[])}e.$1r=F;function R(f){return Array.from(f.entries()).map(k=>[k[0],S(k[1].map),L(k[1].descriptionMap)])}e.$2r=R;function g(f){return new Map(f.map(k=>[k[0],{map:P(k[1]),descriptionMap:F(k[2])}]))}e.$3r=g}),define(Ae[196],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Etb=void 0;class S{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,F,R=5){const g=F(f=>{const k=typeof f=="string"?f:f.data;let A=this.a.get(P);if(A){A.data.push(k);return}const D=setTimeout(()=>this.flushBuffer(P),R);A={data:[k],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(P),g.dispose()}},this.a.set(P,A)});return g}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const F=this.a.get(P);F&&(this.a.delete(P),this.b(P,F.data.join("")))}}e.$Etb=S}),define(Ae[197],Me([1,0,11,89,40,5,16,2,156,72,30]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qw=e.$Pw=e.$Ow=e.$Nw=e.$Mw=e.$Lw=e.$Kw=e.$Jw=e.IconFontDefinition=e.IconContribution=e.$Iw=void 0,e.$Iw={IconContribution:"base.contributions.icons"};var D;(function(u){function l(i,$){let a=i.defaults;for(;P.ThemeIcon.isThemeIcon(a);){const c=p.getIcon(a.id);if(!c)return;a=c.defaults}return a}u.getDefinition=l})(D||(e.IconContribution=D={}));var h;(function(u){function l($){return{weight:$.weight,style:$.style,src:$.src.map(a=>({format:a.format,location:a.location.toString()}))}}u.toJSONObject=l;function i($){const a=c=>(0,R.$Sf)(c)?c:void 0;if($&&Array.isArray($.src)&&$.src.every(c=>(0,R.$Sf)(c.format)&&(0,R.$Sf)(c.location)))return{weight:a($.weight),style:a($.style),src:$.src.map(c=>({format:c.format,location:g.URI.parse(c.location)}))}}u.fromJSONObject=i})(h||(e.IconFontDefinition=h={}));class v{constructor(){this.a=new F.$5d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,i,$,a){const c=this.b[l];if(c){if($&&!c.description){c.description=$,this.d.properties[l].markdownDescription=`${$} $(${l})`;const m=this.e.enum.indexOf(l);m!==-1&&(this.e.enumDescriptions[m]=$),this.a.fire()}return c}const E={id:l,description:$,defaults:i,deprecationMessage:a};this.b[l]=E;const y={$ref:"#/definitions/icons"};return a&&(y.deprecationMessage=a),$&&(y.markdownDescription=`${$}: $(${l})`),this.d.properties[l]=y,this.e.enum.push(l),this.e.enumDescriptions.push($||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const i=this.e.enum.indexOf(l);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,i){const $=this.f[l];return $||(this.f[l]=i,this.a.fire(),i)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(c,E)=>c.id.localeCompare(E.id),i=c=>{for(;P.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},$=[];$.push("| preview     | identifier                        | default codicon ID                | description"),$.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(c=>this.b[c]);for(const c of a.filter(E=>!!E.description).sort(l))$.push(`|<i class="${i(c)}"></i>|${c.id}|${P.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);$.push("| preview     | identifier                        "),$.push("| ----------- | --------------------------------- |");for(const c of a.filter(E=>!P.ThemeIcon.isThemeIcon(E.defaults)).sort(l))$.push(`|<i class="${i(c)}"></i>|${c.id}|`);return $.join(`
`)}}const p=new v;A.$Tn.add(e.$Iw.IconContribution,p);function s(u,l,i,$){return p.registerIcon(u,l,i,$)}e.$Jw=s;function o(){return p}e.$Kw=o;function t(){const u=(0,L.$ik)();for(const l in u){const i="\\"+u[l].toString(16);p.registerIcon(l,{fontCharacter:i})}}t(),e.$Lw="vscode://schemas/icons";const n=A.$Tn.as(k.$Un.JSONContribution);n.registerSchema(e.$Lw,p.getIconSchema());const r=new S.$qh(()=>n.notifySchemaChanged(e.$Lw),200);p.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Mw=s("widget-close",L.$kk.close,(0,f.localize)(2,null)),e.$Nw=s("goto-previous-location",L.$kk.arrowUp,(0,f.localize)(3,null)),e.$Ow=s("goto-next-location",L.$kk.arrowDown,(0,f.localize)(4,null)),e.$Pw=P.ThemeIcon.modify(L.$kk.sync,"spin"),e.$Qw=P.ThemeIcon.modify(L.$kk.loading,"spin")}),define(Ae[198],Me([1,0,5,47,4,14]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.$Pv=e.ProvidedOnAutoForward=e.$Ov=e.TunnelPrivacyId=e.TunnelProtocol=e.$Nv=e.$Mv=void 0,e.$Mv=(0,P.$ei)("tunnelService"),e.$Nv=(0,P.$ei)("sharedTunnelsService");var R;(function(o){o.Http="http",o.Https="https"})(R||(e.TunnelProtocol=R={}));var g;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(g||(e.TunnelPrivacyId=g={}));function f(o){return!!o.forwardPort}e.$Ov=f;var k;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(k||(e.ProvidedOnAutoForward=k={}));function A(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}e.$Pv=A,e.$Qv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(o){return e.$Qv.indexOf(o)>=0}e.$Rv=D,e.$Sv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function h(o){return e.$Sv.indexOf(o)>=0}e.$Tv=h;function v(o,t,n,r){if(n===1)return!1;if(n===2&&h(t)){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(u?.length===4&&parseInt(u[1])>=18)return!1}return o<1024}e.$Uv=v;class p{constructor(t,n,r){this.remoteAddress=t,this.localAddress=n,this.b=r,this.a=new S.$5d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Vv=p;let s=class{constructor(t,n){this.k=t,this.l=n,this.a=new S.$5d,this.onTunnelOpened=this.a.event,this.b=new S.$5d,this.onTunnelClosed=this.b.event,this.c=new S.$5d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const t=this.l.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.i=t.privacyOptions,this.h=t.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const t=[],n=Array.from(this.e.values());for(const r of n){const u=Array.from(r.values());for(const l of u){const i=await l.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:n}of t.values())await n.then(r=>typeof r!="string"?r?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,n,r,u,l){this.q(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:r,privacy:u,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(h(t)||D(t))&&(t=e.$Qv[0]);const r=this.s(t,n);if(r)return++r.refcount,r.value}openTunnel(t,n,r,u,l,i=!1,$,a){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${r} on local port ${l}.`);const c=this.f??t;if(!c)return;if(n||(n="localhost"),u||(u=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const E=this.t(c,n,r,u,l,i,$,a);return E?E.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,r),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.o(y);return(y.tunnelRemoteHost!==n||y.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&y.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),E)}o(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.e.get(t.tunnelRemoteHost);if(n){const r=n.get(t.tunnelRemotePort);r&&(r.refcount--,await this.p(t.tunnelRemoteHost,t.tunnelRemotePort,r))}}}}async p(t,n,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const u=r.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(n),u}}async closeTunnel(t,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const r=this.e.get(t);if(r&&r.has(n)){const u=r.get(n);u.refcount=0,await this.p(t,n,u)}}q(t,n,r){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(n,{refcount:1,value:r})}async r(t,n){const r=this.e.get(t);if(r){const u=r.get(n),l=u?await u.value:void 0;(!l||typeof l=="string")&&r.delete(n),r.size===0&&this.e.delete(t)}}s(t,n){const r=[t];D(t)?(r.push(...e.$Qv),r.push(...e.$Sv)):h(t)&&r.push(...e.$Sv);const u=r.map(l=>this.e.get(l));for(const l of u){const i=l?.get(n);if(i)return i}}canTunnel(t){return!!A(t)}u(t,n,r,u,l,i,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${r} on local port ${u}.`);const a=r;this.j.add(a);const c=u===void 0?r:u,E={elevationRequired:l?this.isPortPrivileged(c):!1},y={remoteAddress:{host:n,port:r},localAddressPort:u,privacy:i,public:i?i!==g.Private:void 0,protocol:$},m=t.forwardPort(y,E);return m?(this.q(n,r,m),m.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(a)})):this.j.delete(a),m}};e.$Wv=s,e.$Wv=s=Xe([qe(0,F.$yj),qe(1,L.$Ki)],s)}),define(Ae[199],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Xv=void 0,e.$Xv=(0,S.$ei)("editSessionIdentityService");var L;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Ae[200],Me([1,0,12]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=void 0;function L(f){return f.scheme!==S.Schemas.file&&f.scheme!==S.Schemas.vscodeRemote}e.$uL=L;function P(f){if(f.folders.length)return f.folders.every(k=>L(k.uri))?f.folders[0].uri:void 0;if(f.configuration&&L(f.configuration))return f.configuration}e.$vL=P;function F(f){return P(f)?.scheme}e.$wL=F;function R(f){return P(f)?.authority}e.$xL=R;function g(f){return P(f)!==void 0}e.$yL=g}),define(Ae[48],Me([1,0,157,19,51,25,2,4,12]),function(fe,e,S,L,P,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.WorkbenchState=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0,e.$ni=(0,g.$ei)("contextService");function k(c){const E=c;return typeof E?.id=="string"&&R.URI.isUri(E.uri)}e.$oi=k;function A(c){return typeof c?.id=="string"&&!k(c)&&!h(c)}e.$pi=A,e.$qi={id:"ext-dev"},e.$ri={id:"empty-window"};function D(c,E){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,L.$nc)(c)}:E?e.$qi:e.$ri;const y=c;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}e.$si=D;function h(c){const E=c;return typeof E?.id=="string"&&R.URI.isUri(E.configPath)}e.$ti=h;function v(c){const E=c;if(E?.uri)return{id:E.id,uri:R.URI.revive(E.uri)};const y=c;if(y?.configPath)return{id:y.id,configPath:R.URI.revive(y.configPath)};if(c?.id)return{id:c.id}}e.$ui=v;var p;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function s(c){const E=c;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.$vi=s;function o(c){const E=c;return!!(E&&typeof E=="object"&&R.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.$wi=o;class t{constructor(E,y,m,I,d){this.h=E,this.j=m,this.k=I,this.l=d,this.c=P.$ki.forUris(this.l,()=>!0),this.folders=y}update(E){this.h=E.id,this.k=E.configuration,this.j=E.transient,this.l=E.l,this.folders=E.folders}get folders(){return this.g}set folders(E){this.g=E,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(E){this.k=E}getFolder(E){return E&&this.c.findSubstr(E)||null}n(){this.c=P.$ki.forUris(this.l,()=>!0);for(const E of this.folders)this.c.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$xi=t;class n{constructor(E,y){this.raw=y,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,F.$Rg)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$yi=n;function r(c){return new n({uri:c,index:0,name:(0,F.$Ng)(c)},{uri:c.toString()})}e.$zi=r,e.$Ai="code-workspace",e.$Bi=`.${e.$Ai}`,e.$Ci=[{name:(0,S.localize)(0,null),extensions:[e.$Ai]}],e.$Di="workspace.json";function u(c,E){return F.$Ig.isEqualOrParent(c,E.untitledWorkspacesHome)}e.$Ei=u;function l(c){let E;return R.URI.isUri(c)?E=c:E=c.configuration,E?.scheme===f.Schemas.tmp}e.$Fi=l,e.$Gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(c){return c.id===e.$Gi}e.$Hi=i;function $(c,E){return!u(c,E)&&!l(c)}e.$Ii=$;function a(c){return(typeof c=="string"?(0,L.$oc)(c):(0,F.$Pg)(c))===e.$Bi}e.$Ji=a}),define(Ae[74],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;class S{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const F=this.c++;return this.b.set(F,P),this.e(),F}get(P,F){return this.b.has(P)?this.b.get(P)[F]:void 0}delete(P){this.b.delete(P),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$rhc=S}),define(Ae[43],Me([1,0,12,25,4]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=void 0;class F{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new L.$Gg(g=>{const f=this.b.get(g.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(g,f){f===null?this.b.delete(g.scheme):this.b.set(g.scheme,f)}isFreeScheme(g){return!this.b.has(g)&&!this.a.has(g)}getCapabilities(g){return this.b.get(g)}}e.$whc=F,e.$xhc=(0,P.$ei)("IExtHostFileSystemInfo")}),define(Ae[27],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=void 0,e.$tO=(0,S.$ei)("IExtHostInitDataService")}),define(Ae[201],Me([1,0,163,14,188,27]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=void 0;let R=class extends P.$AP{constructor(f,k,A){const D=A.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",h=A.remote.isRemote?(0,S.localize)(0,null):f?(0,S.localize)(1,null):(0,S.localize)(2,null);super(k.createLogger(D,{name:h}))}};e.$Bjc=R,e.$Bjc=R=Xe([qe(1,L.$zj),qe(2,F.$tO)],R)}),define(Ae[202],Me([1,0,11]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=e.$dic=void 0;class L{constructor(R,g,f){this.h=new Map,this.a=R,this.b=g,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new S.$qh(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of k.values())A.complete()}catch(A){for(const D of k.values())D.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,g){let f=this.f[R];return typeof f>"u"&&(f=g),f}update(R,g){this.f[R]=g;const f=this.h.get(R);if(f!==void 0)return f.p;const k=new S.$Bh;return this.h.set(R,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$dic=L;class P extends L{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,g){super(R.identifier.value,!0,g),this.j=R}}e.$eic=P}),define(Ae[203],Me([1,0,5,2]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;class P{constructor(R){this.c=R,this.a=new S.$5d,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$5d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,g,f,k){const D=this.c.getNotebookDocument(L.URI.revive(R)).acceptModelChanged(g.value,f,k);this.b.fire(D)}$acceptDirtyStateChanged(R,g){this.c.getNotebookDocument(L.URI.revive(R)).acceptDirty(g)}$acceptModelSaved(R){const g=this.c.getNotebookDocument(L.URI.revive(R));this.a.fire(g.apiNotebook)}}e.$4ic=P}),define(Ae[17],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eO=e.$dO=void 0,e.$dO=(0,S.$ei)("IExtHostRpcService");class L{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$eO=L}),define(Ae[204],Me([1,0,22,5]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;class P{#e;constructor(R,g){this.b=new L.$5d,this.onDidChange=this.b.event,this.a=S.$wm.toKey(R.identifier),this.#e=g,this.#e.onDidChangePassword(f=>{f.extensionId===this.a&&this.b.fire({key:f.key})})}get(R){return this.#e.get(this.a,R)}store(R,g){return this.#e.store(this.a,R,g)}delete(R){return this.#e.delete(this.a,R)}}e.$lic=P}),define(Ae[58],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=e.$Nhc=void 0,e.$Nhc=(0,S.$ei)("IURITransformerService");class L{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Ohc=L}),define(Ae[205],Me([1,0,24]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mb=e.$0mb=void 0;class L{constructor(){this.buffers=[]}add(f){let k=this.buffers.indexOf(f);return k<0&&(k=this.buffers.length,this.buffers.push(f)),k}}function P(g,f){if(f.serializeBuffersForPostMessage){const k=new L,D=JSON.stringify(g,(v,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(p)};if(ArrayBuffer.isView(p)){const s=F(p);if(s)return{$$vscode_array_buffer_reference$$:!0,index:k.add(p.buffer),view:{type:s,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),h=k.buffers.map(v=>{const p=new Uint8Array(v);return S.$se.wrap(p)});return{message:D,buffers:h}}else return{message:JSON.stringify(g),buffers:[]}}e.$0mb=P;function F(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(g,f){const k=f.map(h=>{const v=new ArrayBuffer(h.byteLength);return new Uint8Array(v).set(h.buffer),v}),A=f.length?(h,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const p=v,{index:s}=p,o=k[s];if(p.view)switch(p.view.type){case 1:return new Int8Array(o,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return v}:void 0;return{message:JSON.parse(g,A),arrayBuffers:k}}e.$$mb=R}),define(Ae[102],Me([1,0,172,16,2,6,4,30,42,12,41,135,32]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gF=e.$fF=e.$eF=e.EditorsOrder=e.$dF=e.CloseDirection=e.$cF=e.$bF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.EditorInputCapabilities=e.$5E=e.SaveReason=e.Verbosity=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=void 0,e.$RE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$SE={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$TE="workbench.editor.sidebysideEditor",e.$UE="workbench.editors.textDiffEditor",e.$VE="workbench.editors.binaryResourceDiffEditor";var v;(function(ee){ee[ee.PROGRAMMATIC=1]="PROGRAMMATIC",ee[ee.USER=2]="USER",ee[ee.EDIT=3]="EDIT",ee[ee.NAVIGATION=4]="NAVIGATION",ee[ee.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var p;(function(ee){ee[ee.IDENTICAL=1]="IDENTICAL",ee[ee.SIMILAR=2]="SIMILAR",ee[ee.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function s(ee){const Y=ee;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.$WE=s;function o(ee,Y,q){for(const ne of q.visibleEditorPanes)if(ne.group.id===Y&&ee.matches(ne.input))return ne.getViewState()}e.$XE=o;function t(ee){if(m(ee))return!1;const Y=ee;return P.URI.isUri(Y?.resource)}e.$YE=t;function n(ee){if(m(ee))return!1;const Y=ee;return Y?.original!==void 0&&Y.modified!==void 0}e.$ZE=n;function r(ee){if(m(ee))return!1;const Y=ee;return!Y||Y.resources&&!Array.isArray(Y.resources)?!1:!!Y.resources||!!Y.multiDiffSource}e.$1E=r;function u(ee){if(m(ee)||n(ee))return!1;const Y=ee;return Y?.primary!==void 0&&Y.secondary!==void 0}e.$2E=u;function l(ee){if(m(ee))return!1;const Y=ee;return Y?Y.resource===void 0||Y.resource.scheme===k.Schemas.untitled||Y.forceUntitled===!0:!1}e.$3E=l;function i(ee){if(m(ee))return!1;const Y=ee;return P.URI.isUri(Y?.base?.resource)&&P.URI.isUri(Y?.input1?.resource)&&P.URI.isUri(Y?.input2?.resource)&&P.URI.isUri(Y?.result?.resource)}e.$4E=i;var $;(function(ee){ee[ee.SHORT=0]="SHORT",ee[ee.MEDIUM=1]="MEDIUM",ee[ee.LONG=2]="LONG"})($||(e.Verbosity=$={}));var a;(function(ee){ee[ee.EXPLICIT=1]="EXPLICIT",ee[ee.AUTO=2]="AUTO",ee[ee.FOCUS_CHANGE=3]="FOCUS_CHANGE",ee[ee.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class c{constructor(){this.a=new Map}registerSource(Y,q){let ne=this.a.get(Y);return ne||(ne={source:Y,label:q},this.a.set(Y,ne)),ne.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.$5E=new c;var E;(function(ee){ee[ee.None=0]="None",ee[ee.Readonly=2]="Readonly",ee[ee.Untitled=4]="Untitled",ee[ee.Singleton=8]="Singleton",ee[ee.RequiresTrust=16]="RequiresTrust",ee[ee.CanSplitInGroup=32]="CanSplitInGroup",ee[ee.ForceDescription=64]="ForceDescription",ee[ee.CanDropIntoEditor=128]="CanDropIntoEditor",ee[ee.MultipleEditors=256]="MultipleEditors",ee[ee.Scratchpad=512]="Scratchpad",ee[ee.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(E||(e.EditorInputCapabilities=E={}));class y extends F.$Tc{}e.$6E=y;function m(ee){return ee instanceof y}e.$7E=m;function I(ee){const Y=ee;return P.URI.isUri(Y?.preferredResource)}function d(ee){const Y=ee;return m(Y?.primary)&&m(Y?.secondary)}e.$8E=d;function w(ee){const Y=ee;return m(Y?.modified)&&m(Y?.original)}e.$9E=w;function b(ee,Y,q,ne,Se){return $e(ne,[(0,D.$1i)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Te={...q,limits:{size:Number.MAX_VALUE}};ee.openEditor(Y,Te)}}),(0,D.$1i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>Se.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}e.$0E=b;function M(ee){return m(ee?.editor)}e.$$E=M;function T(ee){const Y=ee;return M(ee)&&Y?.group!==void 0}e.$_E=T;function G(ee){const Y=ee;return typeof Y?.groupId=="number"&&m(Y.editor)}e.$aF=G;var W;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.REPLACE=1]="REPLACE",ee[ee.MOVE=2]="MOVE",ee[ee.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var U;(function(ee){ee[ee.GROUP_ACTIVE=0]="GROUP_ACTIVE",ee[ee.GROUP_INDEX=1]="GROUP_INDEX",ee[ee.GROUP_LABEL=2]="GROUP_LABEL",ee[ee.GROUP_LOCKED=3]="GROUP_LOCKED",ee[ee.EDITOR_OPEN=4]="EDITOR_OPEN",ee[ee.EDITOR_CLOSE=5]="EDITOR_CLOSE",ee[ee.EDITOR_MOVE=6]="EDITOR_MOVE",ee[ee.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ee[ee.EDITOR_LABEL=8]="EDITOR_LABEL",ee[ee.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ee[ee.EDITOR_PIN=10]="EDITOR_PIN",ee[ee.EDITOR_STICKY=11]="EDITOR_STICKY",ee[ee.EDITOR_DIRTY=12]="EDITOR_DIRTY",ee[ee.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var C;(function(ee){ee[ee.PRIMARY=1]="PRIMARY",ee[ee.SECONDARY=2]="SECONDARY",ee[ee.BOTH=3]="BOTH",ee[ee.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class O{getOriginalUri(Y,q){if(!Y)return;if(i(Y))return e.$cF.getOriginalUri(Y.result,q);if(q?.supportSideBySide){const{primary:Se,secondary:Te}=this.a(Y);if(Se&&Te){if(q?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Se,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(Te,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===C.ANY)return this.getOriginalUri(Se,{filterByScheme:q.filterByScheme})??this.getOriginalUri(Te,{filterByScheme:q.filterByScheme});Y=q.supportSideBySide===C.PRIMARY?Se:Te}}if(n(Y)||r(Y)||u(Y)||i(Y))return;const ne=I(Y)?Y.preferredResource:Y.resource;return!ne||!q||!q.filterByScheme?ne:this.b(ne,q.filterByScheme)}a(Y){return d(Y)||u(Y)?{primary:Y.primary,secondary:Y.secondary}:w(Y)||n(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,q){if(!Y)return;if(i(Y))return e.$cF.getCanonicalUri(Y.result,q);if(q?.supportSideBySide){const{primary:Se,secondary:Te}=this.a(Y);if(Se&&Te){if(q?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Se,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(Te,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===C.ANY)return this.getCanonicalUri(Se,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(Te,{filterByScheme:q.filterByScheme});Y=q.supportSideBySide===C.PRIMARY?Se:Te}}if(n(Y)||r(Y)||u(Y)||i(Y))return;const ne=Y.resource;return!ne||!q||!q.filterByScheme?ne:this.b(ne,q.filterByScheme)}b(Y,q){if(Array.isArray(q)){if(q.some(ne=>Y.scheme===ne))return Y}else if(q===Y.scheme)return Y}}var V;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.KEYBOARD=1]="KEYBOARD",ee[ee.MOUSE=2]="MOUSE"})(V||(e.EditorCloseMethod=V={}));function re(ee,Y,q,ne){if(!ee.isSticky(Y))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return q===V.MOUSE||q===V.KEYBOARD;case"mouse":return q===V.MOUSE;case"keyboard":return q===V.KEYBOARD}return!1}e.$bF=re,e.$cF=new O;var ce;(function(ee){ee[ee.LEFT=0]="LEFT",ee[ee.RIGHT=1]="RIGHT"})(ce||(e.CloseDirection=ce={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(Y){const q=this.a=Y.get(R.$di);for(const[ne,Se]of this.c)this.e(ne,Se,q);this.c.clear()}e(Y,q,ne){const Se=ne.createInstance(q);this.d.set(Y,Se)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,L.$4f)(this.b)}registerEditorSerializer(Y,q){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,q,this.a):this.c.set(Y,q),(0,F.$Rc)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}g.$Tn.add(e.$RE.EditorFactory,new ye);async function De(ee,Y,q){return!ee||!ee.length?[]:await Promise.all(ee.map(async ne=>{const Se=P.URI.revive(ne.fileUri);if(!Se){q.info("Cannot resolve the path because it is not valid.",ne);return}if(!await Y.canHandleResource(Se)){q.info("Cannot resolve the path because it cannot be handled",ne);return}let Ce=ne.exists,be=ne.type;if(typeof Ce!="boolean"||typeof be!="number")try{be=(await Y.stat(Se)).isDirectory?f.FileType.Directory:f.FileType.Unknown,Ce=!0}catch(X){q.error(X),Ce=!1}if(!Ce&&ne.openOnlyIfExists){q.info("Cannot resolve the path because it does not exist",ne);return}if(be===f.FileType.Directory){q.info("Cannot resolve the path because it is a directory",ne);return}const ge={...ne.options,pinned:!0};return Ce?{resource:Se,options:ge}:{resource:Se,options:ge,forceUntitled:!0}}))}e.$dF=De;var he;(function(ee){ee[ee.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ee[ee.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function ve(ee){const Y=ee;if(!Y)return!1;const q=Y;if(q.modified)return ve(q.modified);const ne=Y;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$eF=ve;function se(ee){return(0,A.$3i)(ee)}e.$fF=se;function $e(ee,Y,q){const ne=(0,A.$4i)(ee,Y);return ne.forceMessage=q?.forceMessage,ne.forceSeverity=q?.forceSeverity,ne.allowDialog=q?.allowDialog,ne}e.$gF=$e}),define(Ae[206],Me([1,0,5,173,4,6,28,30,18,26,89,197]),function(fe,e,S,L,P,F,R,g,f,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oF=e.$nF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$mF=e.ViewContentGroups=e.$lF=e.$kF=e.ViewContainerLocation=e.Extensions=e.$jF=e.$iF=e.$hF=void 0,e.$hF="views",e.$iF=(0,L.localize)(0,null),e.$jF=(0,D.$Jw)("default-view-icon",A.$kk.window,(0,L.localize)(1,null));var h;(function($){$.ViewContainersRegistry="workbench.registry.view.containers",$.ViewsRegistry="workbench.registry.view"})(h||(e.Extensions=h={}));var v;(function($){$[$.Sidebar=0]="Sidebar",$[$.Panel=1]="Panel",$[$.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$kF=[0,1,2];function p($){switch($){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$lF=p;class s extends F.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$5d),this.onDidRegister=this.c.event,this.f=this.B(new S.$5d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(a,c,E){const y=this.get(a.id);if(y)return y;const m=a;return m.openCommandActionDescriptor=E?.doNotRegisterOpenCommand?void 0:m.openCommandActionDescriptor??{id:m.id},(0,R.$xc)(this.g,c,[]).push(m),E?.isDefault&&this.h.push(m),this.c.fire({viewContainer:m,viewContainerLocation:c}),m}deregisterViewContainer(a){for(const c of this.g.keys()){const E=this.g.get(c),y=E?.indexOf(a);if(y!==-1){E?.splice(y,1),E.length===0&&this.g.delete(c),this.f.fire({viewContainer:a,viewContainerLocation:c});return}}}get(a){return this.all.filter(c=>c.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(E=>E?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(c=>this.getViewContainerLocation(c)===a)}}g.$Tn.add(h.ViewContainersRegistry,new s);var o;(function($){$.Open="2_open",$.Debug="4_debug",$.SCM="5_scm",$.More="9_more"})(o||(e.ViewContentGroups=o={}));function t($,a){const c=$.group??o.More,E=a.group??o.More;return c!==E?c.localeCompare(E):($.order??5)-(a.order??5)}class n extends F.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$5d),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$5d),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$5d),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$5d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(a,c){this.registerViews2([{views:a,viewContainer:c}])}registerViews2(a){a.forEach(({views:c,viewContainer:E})=>this.r(c,E)),this.c.fire(a)}deregisterViews(a,c){const E=this.s(a,c);E.length&&this.f.fire({views:E,viewContainer:c})}moveViews(a,c){for(const E of this.m.keys())if(E!==c){const y=this.s(a,E);y.length&&(this.r(y,c),this.g.fire({views:y,from:E,to:c}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const c of this.j){const E=(this.m.get(c)||[]).filter(y=>y.id===a)[0];if(E)return E}return null}getViewContainer(a){for(const c of this.j)if((this.m.get(c)||[]).filter(y=>y.id===a)[0])return c;return null}registerViewWelcomeContent(a,c){return this.n.add(a,c),this.h.fire(a),(0,F.$Rc)(()=>{this.n.delete(a,c),this.h.fire(a)})}registerViewWelcomeContent2(a,c){const E=new Map;for(const[y,m]of c)this.n.add(a,m),E.set(y,(0,F.$Rc)(()=>{this.n.delete(a,m),this.h.fire(a)}));return this.h.fire(a),E}getViewWelcomeContent(a){const c=[];return this.n.forEach(a,E=>c.push(E)),c.sort(t)}r(a,c){let E=this.m.get(c);E||(E=[],this.m.set(c,E),this.j.push(c));for(const y of a){if(this.getView(y.id)!==null)throw new Error((0,L.localize)(2,null,y.id));E.push(y)}}s(a,c){const E=this.m.get(c);if(!E)return[];const y=[],m=[];for(const I of E)a.includes(I)?y.push(I):m.push(I);return y.length&&(m.length?this.m.set(c,m):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),y}}g.$Tn.add(h.ViewsRegistry,new n),e.$mF=(0,P.$ei)("viewDescriptorService");var r;(function($){$[$.Default=0]="Default",$[$.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var u;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(u||(e.TreeItemCollapsibleState=u={}));class l{constructor(a,c){this.c=!1,this.d=!1,(0,k.$Kn)(this,a),this.d=!!c,this.resolve=async E=>{if(c&&!this.c){const y=await c(E);y&&(this.tooltip=this.tooltip??y.tooltip,this.command=this.command??y.command)}E.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$nF=l;class i extends Error{constructor(a){super((0,L.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$oF=i}),define(Ae[207],Me([1,0,2,29,4]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yF=e.$xF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$wF=e.$vF=void 0;function F(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof S.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(L.$6s.isIRange)}e.$vF=F;function R(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(F)}e.$wF=R;var g;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(g||(e.InteractiveSessionVoteDirection=g={}));var f;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(f||(e.ChatAgentCopyKind=f={})),e.$xF=(0,P.$ei)("IChatService"),e.$yF="accessibility.voice.keywordActivation"}),define(Ae[208],Me([1,0,5,11,174]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dnb=void 0;class F{constructor(){this.f=new Map,this.m=[],this.n=new S.$5d,this.o=new S.$5d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(g){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=g}onEvent(g){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=g}onRequest(g){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=g}sendResponse(g){g.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.u("response",g)}sendRequest(g,f,k,A){const D={command:g};if(f&&Object.keys(f).length>0&&(D.arguments=f),this.u("request",D),typeof A=="number"){const h=setTimeout(()=>{clearTimeout(h);const v=this.f.get(D.seq);if(v){this.f.delete(D.seq);const p={type:"response",seq:0,request_seq:D.seq,success:!1,command:g,message:(0,P.localize)(0,null,A,g)};v(p)}},A)}return k&&this.f.set(D.seq,k),D.seq}acceptMessage(g){this.k?this.k(g):(this.m.push(g),this.m.length===1&&this.s())}q(g,f){return g.type!=="event"||f.type!=="event"}async s(){let g;for(;this.m.length;){if((!g||this.q(this.m[0],g))&&await(0,L.$fh)(0),g=this.m.shift(),!g)return;switch(g.type){case"event":this.j?.(g);break;case"request":this.g?.(g);break;case"response":{const f=g,k=this.f.get(f.request_seq);k&&(this.f.delete(f.request_seq),k(f));break}}}}u(g,f){f.type=g,f.seq=this.d++,this.sendMessage(f)}async w(){if(this.f.size===0)return Promise.resolve();const g=new Map;this.f.forEach((f,k)=>g.set(k,f)),await(0,L.$fh)(500),g.forEach((f,k)=>{f({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Dnb=F}),define(Ae[209],Me([1,0,2,175,35,4]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$wI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$vI=e.MemoryRangeType=e.$uI=e.State=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=void 0,e.$lH="workbench.view.debug",e.$mH="workbench.debug.variablesView",e.$nH="workbench.debug.watchExpressionsView",e.$oH="workbench.debug.callStackView",e.$pH="workbench.debug.loadedScriptsView",e.$qH="workbench.debug.breakPointsView",e.$rH="workbench.debug.disassemblyView",e.$sH="workbench.panel.repl",e.$tH="workbench.panel.repl.view",e.$uH=new P.$vj("debugType",void 0,{type:"string",description:L.localize(0,null)}),e.$vH=new P.$vj("debugConfigurationType",void 0,{type:"string",description:L.localize(1,null)}),e.$wH=new P.$vj("debugState","inactive",{type:"string",description:L.localize(2,null)}),e.$xH="debugUx",e.$yH=new P.$vj(e.$xH,"default",{type:"string",description:L.localize(3,null)}),e.$zH=new P.$vj("hasDebugged",!1,{type:"boolean",description:L.localize(4,null)}),e.$AH=new P.$vj("inDebugMode",!1,{type:"boolean",description:L.localize(5,null)}),e.$BH=new P.$vj("inDebugRepl",!1,{type:"boolean",description:L.localize(6,null)}),e.$CH=new P.$vj("breakpointWidgetVisible",!1,{type:"boolean",description:L.localize(7,null)}),e.$DH=new P.$vj("inBreakpointWidget",!1,{type:"boolean",description:L.localize(8,null)}),e.$EH=new P.$vj("breakpointsFocused",!0,{type:"boolean",description:L.localize(9,null)}),e.$FH=new P.$vj("watchExpressionsFocused",!0,{type:"boolean",description:L.localize(10,null)}),e.$GH=new P.$vj("watchExpressionsExist",!1,{type:"boolean",description:L.localize(11,null)}),e.$HH=new P.$vj("variablesFocused",!0,{type:"boolean",description:L.localize(12,null)}),e.$IH=new P.$vj("expressionSelected",!1,{type:"boolean",description:L.localize(13,null)}),e.$JH=new P.$vj("breakpointInputFocused",!1,{type:"boolean",description:L.localize(14,null)}),e.$KH=new P.$vj("callStackItemType",void 0,{type:"string",description:L.localize(15,null)}),e.$LH=new P.$vj("callStackSessionIsAttach",!1,{type:"boolean",description:L.localize(16,null)}),e.$MH=new P.$vj("callStackItemStopped",!1,{type:"boolean",description:L.localize(17,null)}),e.$NH=new P.$vj("callStackSessionHasOneThread",!1,{type:"boolean",description:L.localize(18,null)}),e.$OH=new P.$vj("watchItemType",void 0,{type:"string",description:L.localize(19,null)}),e.$PH=new P.$vj("canViewMemory",void 0,{type:"boolean",description:L.localize(20,null)}),e.$QH=new P.$vj("breakpointItemType",void 0,{type:"string",description:L.localize(21,null)}),e.$RH=new P.$vj("breakpointHasModes",!1,{type:"boolean",description:L.localize(22,null)}),e.$SH=new P.$vj("breakpointSupportsCondition",!1,{type:"boolean",description:L.localize(23,null)}),e.$TH=new P.$vj("loadedScriptsSupported",!1,{type:"boolean",description:L.localize(24,null)}),e.$UH=new P.$vj("loadedScriptsItemType",void 0,{type:"string",description:L.localize(25,null)}),e.$VH=new P.$vj("focusedSessionIsAttach",!1,{type:"boolean",description:L.localize(26,null)}),e.$WH=new P.$vj("focusedSessionIsNoDebug",!1,{type:"boolean",description:L.localize(27,null)}),e.$XH=new P.$vj("stepBackSupported",!1,{type:"boolean",description:L.localize(28,null)}),e.$YH=new P.$vj("restartFrameSupported",!1,{type:"boolean",description:L.localize(29,null)}),e.$ZH=new P.$vj("stackFrameSupportsRestart",!1,{type:"boolean",description:L.localize(30,null)}),e.$1H=new P.$vj("jumpToCursorSupported",!1,{type:"boolean",description:L.localize(31,null)}),e.$2H=new P.$vj("stepIntoTargetsSupported",!1,{type:"boolean",description:L.localize(32,null)}),e.$3H=new P.$vj("breakpointsExist",!1,{type:"boolean",description:L.localize(33,null)}),e.$4H=new P.$vj("debuggersAvailable",!1,{type:"boolean",description:L.localize(34,null)}),e.$5H=new P.$vj("debugExtensionAvailable",!0,{type:"boolean",description:L.localize(35,null)}),e.$6H=new P.$vj("debugProtocolVariableMenuContext",void 0,{type:"string",description:L.localize(36,null)}),e.$7H=new P.$vj("debugSetVariableSupported",!1,{type:"boolean",description:L.localize(37,null)}),e.$8H=new P.$vj("debugSetExpressionSupported",!1,{type:"boolean",description:L.localize(38,null)}),e.$9H=new P.$vj("breakWhenValueChangesSupported",!1,{type:"boolean",description:L.localize(39,null)}),e.$0H=new P.$vj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:L.localize(40,null)}),e.$$H=new P.$vj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:L.localize(41,null)}),e.$_H=new P.$vj("terminateDebuggeeSupported",!1,{type:"boolean",description:L.localize(42,null)}),e.$aI=new P.$vj("suspendDebuggeeSupported",!1,{type:"boolean",description:L.localize(43,null)}),e.$bI=new P.$vj("variableEvaluateNamePresent",!1,{type:"boolean",description:L.localize(44,null)}),e.$cI=new P.$vj("variableIsReadonly",!1,{type:"boolean",description:L.localize(45,null)}),e.$dI=new P.$vj("variableValue",!1,{type:"string",description:L.localize(46,null)}),e.$eI=new P.$vj("variableType",!1,{type:"string",description:L.localize(47,null)}),e.$fI=new P.$vj("variableName",!1,{type:"string",description:L.localize(48,null)}),e.$gI=new P.$vj("variableLanguage",!1,{type:"string",description:L.localize(49,null)}),e.$hI=new P.$vj("variableExtensionId",!1,{type:"string",description:L.localize(50,null)}),e.$iI=new P.$vj("exceptionWidgetVisible",!1,{type:"boolean",description:L.localize(51,null)}),e.$jI=new P.$vj("multiSessionRepl",!1,{type:"boolean",description:L.localize(52,null)}),e.$kI=new P.$vj("multiSessionDebug",!1,{type:"boolean",description:L.localize(53,null)}),e.$lI=new P.$vj("disassembleRequestSupported",!1,{type:"boolean",description:L.localize(54,null)}),e.$mI=new P.$vj("disassemblyViewFocus",!1,{type:"boolean",description:L.localize(55,null)}),e.$nI=new P.$vj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:L.localize(56,null)}),e.$oI=new P.$vj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:L.localize(57,null)});const R=t=>L.localize(58,null,t);e.$pI=R,e.$qI="editor.contrib.debug",e.$rI="editor.contrib.breakpoint",e.$sI="debug",e.$tI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:L.localize(59,null)};var g;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(g||(e.State=g={}));function f(t){switch(t){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$uI=f;var k;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$vI="vscode-debug-memory";var A;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(A||(e.DebugConfigurationProviderTriggerKind=A={}));var D;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(D||(e.DebuggerString=D={})),e.$wI=(0,F.$ei)("debugService");var h;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(h||(e.BreakpointWidgetContext=h={}));var v;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(v||(e.DebugVisualizationType=v={}));var p;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(p||(e.DebugTreeItemCollapsibleState=p={}));var s;(function(t){t.deserialize=n=>n,t.serialize=n=>n})(s||(e.IDebugVisualizationTreeItem=s={}));var o;(function(t){t.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:S.URI.revive(n.iconPath.light),dark:S.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),t.serialize=n=>n})(o||(e.IDebugVisualization=o={}))}),define(Ae[210],Me([1,0,13,2,19,26,12,29,21,18]),function(fe,e,S,L,P,F,R,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=void 0;const A=/{([^}]+)}/g;function D(I,d,w){return I.replace(A,function(b,M){return d&&M.length>0&&M[0]!=="_"?b:w&&w.hasOwnProperty(M)?w[M]:b})}e.$nG=D;function h(I){const d={};for(const w of Object.keys(I))w.startsWith("!")||(d[w]=I[w]);return d}e.$oG=h;function v(I){return I.configuration.request==="attach"&&!p(I)&&(!I.parentSession||v(I.parentSession))}e.$pG=v;function p(I){let d=I.configuration.type;if(d)return d==="vslsShare"&&(d=I.configuration.adapterProxy.configuration.type),(0,S.$jf)(d,"extensionhost")||(0,S.$jf)(d,"pwa-extensionhost")?I:I.parentSession?p(I.parentSession):void 0}e.$qG=p;function s(I){return I.type&&(I.label||I.program||I.runtime)}e.$rG=s;function o(I,d,w){let b,M=0;const T=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=T.exec(I);){const W=G.index+1,U=W+G[0].length;if(W<=d&&U>=w){b=G[0],M=W;break}}if(b){const W=/\w+/g;let U=null;for(;(U=W.exec(b))&&!(U.index+1+M+U[0].length>=w););U&&(b=b.substring(0,W.lastIndex))}return b?{start:M,end:M+b.length-1}:{start:0,end:0}}e.$sG=o;async function t(I,d,w,b){if(I.evaluatableExpressionProvider.has(d)){const M=I.evaluatableExpressionProvider.ordered(d),T=(0,k.$Hb)(await Promise.all(M.map(async G=>{try{return await G.provideEvaluatableExpression(d,w,b??f.CancellationToken.None)}catch{return}})));if(T.length>0){let G=T[0].expression;const W=T[0].range;return G||(G=d.getLineContent(w.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:G}}}else{const M=d.getLineContent(w.lineNumber),{start:T,end:G}=o(M,w.column,w.column),W=M.substring(T-1,G);return{matchingExpression:W,range:new g.$6s(w.lineNumber,T,w.lineNumber,T+W.length)}}return null}e.$tG=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(I){return!!(I&&I.match(n))}e.$uG=r;function u(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(r(I.path))return L.URI.parse(I.path);if((0,P.$ic)(I.path))return L.URI.file(I.path)}return I.path}function l(I){if(typeof I.path=="object"){const d=L.URI.revive(I.path);if(d)return d.scheme===R.Schemas.file?d.fsPath:d.toString()}return I.path}function i(I,d){const w=d?u:l,b=(0,F.$Hn)(I);return a(b,(M,T)=>{M&&T&&(T.path=w(T))}),b}e.$vG=i;function $(I,d){const w=d?u:l,b=(0,F.$Hn)(I);return a(b,(M,T)=>{!M&&T&&(T.path=w(T))}),b}e.$wG=$;function a(I,d){switch(I.type){case"event":{const w=I;switch(w.event){case"output":d(!1,w.body.source);break;case"loadedSource":d(!1,w.body.source);break;case"breakpoint":d(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=I;switch(w.command){case"setBreakpoints":d(!0,w.arguments.source);break;case"breakpointLocations":d(!0,w.arguments.source);break;case"source":d(!0,w.arguments.source);break;case"gotoTargets":d(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(b=>d(!1,b));break;default:break}break}case"response":{const w=I;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(b=>d(!1,b.source));break;case"loadedSources":w.body.sources.forEach(b=>d(!1,b));break;case"scopes":w.body.scopes.forEach(b=>d(!1,b.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(b=>d(!1,b.source));break;case"setBreakpoints":w.body.breakpoints.forEach(b=>d(!1,b.source));break;case"disassemble":w.body?.instructions.forEach(M=>d(!1,M.location));break;default:break}break}}}function c(I){return I.filter(d=>!d.presentation?.hidden).sort((d,w)=>d.presentation?w.presentation?d.presentation.group?w.presentation.group?d.presentation.group!==w.presentation.group?d.presentation.group.localeCompare(w.presentation.group):E(d.presentation.order,w.presentation.order):-1:w.presentation.group?1:E(d.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$xG=c;function E(I,d){return typeof I!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:I-d}async function y(I,d){const w=I.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(w!=="none"&&(await d.saveAll(),w==="allEditorsInActiveGroup")){const b=d.activeEditorPane;b&&b.input.resource?.scheme===R.Schemas.untitled&&await d.save({editor:b.input,groupId:b.group.id})}await I.reloadConfiguration()}e.$yG=y;const m=(I,d)=>!I||!d?I===d:I.name===d.name&&I.path===d.path&&I.sourceReference===d.sourceReference;e.$zG=m}),define(Ae[211],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.CellExecutionUpdateType=void 0;var L;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$5J=(0,S.$ei)("INotebookExecutionService")}),define(Ae[212],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgb=e.$Ygb=e.ProxyKernelState=e.$Xgb=void 0,e.$Xgb=100;var L;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(L||(e.ProxyKernelState=L={})),e.$Ygb=(0,S.$ei)("INotebookKernelService"),e.$Zgb=(0,S.$ei)("INotebookKernelHistoryService")}),define(Ae[213],Me([1,0,6,29,145,93]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Sb=void 0;class R extends S.$Tc{constructor(f,k,A){super(),this._source=f,this.b=k,this.c=A,this.a=void 0}f(f){const k=f.getLineCount();return new L.$6s(1,1,k,this.g(f,k))}g(f,k){if(k<1||k>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const f=new P.$oC;f.acceptChunk(this._source);const k=f.finish(!0),{textBuffer:A,disposable:D}=k.create(1);this.b=A,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const k=new P.$oC;k.acceptChunk(f);const A=k.finish(!0),{textBuffer:D,disposable:h}=A.create(1);return this.B(h),D})),this.a}findInInputs(f){const A=new F.$cC(f,!1,!1,null).parseSearchRequest();if(!A)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,A,!0,5e3)}findInOutputs(f){const A=new F.$cC(f,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(D=>{const h=D.findMatchesLineByLine(this.f(D),A,!0,5e3);if(h.length!==0)return{textBuffer:D,matches:h}}).filter(D=>!!D):[]}}e.$9Sb=R}),define(Ae[49],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(F){F.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var L;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class P{static fromExtHostTestItem(R,g,f=R.parent){if(R._isRoot)return new P([g]);const k=[R.id];for(let A=f;A&&A.id!==g;A=A.parent)k.push(A.id);return k.push(g),new P(k.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const g=R.indexOf("\0");return g===-1?R:R.slice(0,g)}static fromString(R){return new P(R.split("\0"))}static join(R,g){return new P([...R.path,g])}static joinToString(R,g){return R.toString()+"\0"+g}static parentId(R){const g=R.lastIndexOf("\0");return g===-1?void 0:R.slice(0,g)}static localId(R){const g=R.lastIndexOf("\0");return g===-1?R:R.slice(g+1)}static isChild(R,g){return g.startsWith(R)&&g[R.length]==="\0"}static compare(R,g){return R===g?0:P.isChild(R,g)?2:P.isChild(g,R)?3:1}constructor(R,g=R.length){if(this.path=R,this.d=g,R.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let g=0;g<R.d&&g<this.d;g++)if(R.path[g]!==this.path[g])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$OK=P}),define(Ae[59],Me([1,0,2,91,29,49]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$VK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$UK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$TK=e.$SK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$RK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$QK=e.$PK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var g;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(g||(e.ExtTestRunProfileKind=g={}));var f;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$PK=[2,4,8,16,32,64];const k=C=>"runId"in C;e.$QK=k;var A;(function(C){C.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),C.deserialize=(O,V)=>({range:P.$6s.lift(V.range),uri:O.asCanonicalUri(S.URI.revive(V.uri))})})(A||(e.IRichLocation=A={}));var D;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(D||(e.TestMessageType=D={}));var h;(function(C){C.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&A.serialize(O.location)}),C.deserialize=(O,V)=>({message:V.message,type:0,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&A.deserialize(O,V.location)})})(h||(e.ITestErrorMessage=h={}));const v=(C,O)=>`${O?"s":"e"}${C}`;e.$RK=v;var p;(function(C){C.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&A.serialize(O.location)}),C.deserialize=(O,V)=>({message:V.message,type:1,offset:V.offset,length:V.length,location:V.location&&A.deserialize(O,V.location)})})(p||(e.ITestOutputMessage=p={}));var s;(function(C){C.serialize=O=>O.type===0?h.serialize(O):p.serialize(O),C.deserialize=(O,V)=>V.type===0?h.deserialize(O,V):p.deserialize(O,V)})(s||(e.ITestMessage=s={}));var o;(function(C){C.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),C.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(s.serialize)}),C.deserialize=(O,V)=>({state:V.state,duration:V.duration,messages:V.messages.map(re=>s.deserialize(O,re))})})(o||(e.ITestTaskState=o={}));const t="\0",n=(C,O)=>C+t+O;e.$SK=n;const r=C=>{const O=C.indexOf(t);return{ctrlId:C.slice(0,O),tagId:C.slice(O+1)}};e.$TK=r;var u;(function(C){C.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),C.deserialize=(O,V)=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?O.asCanonicalUri(S.URI.revive(V.uri)):void 0,range:V.range?P.$6s.lift(V.range):null,description:V.description,error:V.error,sortText:V.sortText})})(u||(e.ITestItem=u={}));var l;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var i;(function(C){C.serialize=O=>({expand:O.expand,item:u.serialize(O.item)}),C.deserialize=(O,V)=>({controllerId:F.$OK.root(V.item.extId),expand:V.expand,item:u.deserialize(O,V.item)})})(i||(e.InternalTestItem=i={}));var $;(function(C){C.serialize=O=>{let V;return O.item&&(V={},O.item.label!==void 0&&(V.label=O.item.label),O.item.tags!==void 0&&(V.tags=O.item.tags),O.item.busy!==void 0&&(V.busy=O.item.busy),O.item.uri!==void 0&&(V.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(V.range=O.item.range?.toJSON()),O.item.description!==void 0&&(V.description=O.item.description),O.item.error!==void 0&&(V.error=O.item.error),O.item.sortText!==void 0&&(V.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:V}},C.deserialize=O=>{let V;return O.item&&(V={},O.item.label!==void 0&&(V.label=O.item.label),O.item.tags!==void 0&&(V.tags=O.item.tags),O.item.busy!==void 0&&(V.busy=O.item.busy),O.item.range!==void 0&&(V.range=O.item.range?P.$6s.lift(O.item.range):null),O.item.description!==void 0&&(V.description=O.item.description),O.item.error!==void 0&&(V.error=O.item.error),O.item.sortText!==void 0&&(V.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:V}}})($||(e.ITestItemUpdate=$={}));const a=(C,O)=>{O.expand!==void 0&&(C.expand=O.expand),O.item!==void 0&&(C.item=C.item?Object.assign(C.item,O.item):O.item)};e.$UK=a;var c;(function(C){C.serializeWithoutMessages=O=>({...i.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(o.serializeWithoutMessages)}),C.serialize=O=>({...i.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(o.serialize)}),C.deserialize=(O,V)=>({...i.deserialize(O,V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(re=>o.deserialize(O,re)),retired:!0})})(c||(e.TestResultItem=c={}));var E;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(O,V)=>{O.covered+=V.covered,O.total+=V.total}})(E||(e.ICoveredCount=E={}));var y;(function(C){C.serialize=O=>({statement:O.statement,branch:O.branch,declaration:O.declaration,details:O.details?.map(w.serialize),uri:O.uri.toJSON()}),C.deserialize=(O,V)=>({statement:V.statement,branch:V.branch,declaration:V.declaration,details:V.details?.map(w.deserialize),uri:O.asCanonicalUri(S.URI.revive(V.uri))})})(y||(e.IFileCoverage=y={}));function m(C){return{...C,location:C.location?.toJSON()}}function I(C){return C.location=C.location?L.$5s.isIPosition(C.location)?L.$5s.lift(C.location):P.$6s.lift(C.location):void 0,C}e.$VK=3;var d;(function(C){C[C.Declaration=0]="Declaration",C[C.Statement=1]="Statement",C[C.Branch=2]="Branch"})(d||(e.DetailType=d={}));var w;(function(C){C.serialize=O=>O.type===0?M.serialize(O):T.serialize(O),C.deserialize=O=>O.type===0?M.deserialize(O):T.deserialize(O)})(w||(e.CoverageDetails=w={}));var b;(function(C){C.serialize=m,C.deserialize=I})(b||(e.IBranchCoverage=b={}));var M;(function(C){C.serialize=m,C.deserialize=I})(M||(e.IDeclarationCoverage=M={}));var T;(function(C){C.serialize=O=>({...m(O),branches:O.branches?.map(b.serialize)}),C.deserialize=O=>({...I(O),branches:O.branches?.map(b.deserialize)})})(T||(e.IStatementCoverage=T={}));var G;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var W;(function(C){C.deserialize=(O,V)=>V.op===0?{op:V.op,item:i.deserialize(O,V.item)}:V.op===1?{op:V.op,item:$.deserialize(V.item)}:V.op===2?{op:V.op,uri:O.asCanonicalUri(S.URI.revive(V.uri)),docv:V.docv}:V,C.serialize=O=>O.op===0?{op:O.op,item:i.serialize(O.item)}:O.op===1?{op:O.op,item:$.serialize(O.item)}:O})(W||(e.TestsDiffOp=W={}));class U{constructor(O){this.k=O,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(O){const V=this.v();for(const re of O)switch(re.op){case 0:this.l(i.deserialize(this.k,re.item),V);break;case 1:this.o($.deserialize(re.item),V);break;case 3:this.p(re.itemId,V);break;case 5:this.q(re.itemId);break;case 4:this.updatePendingRoots(re.amount);break;case 6:this.c.set(re.tag.id,re.tag);break;case 7:this.c.delete(re.id);break}V.complete?.()}l(O,V){const re=F.$OK.parentId(O.item.extId)?.toString();let ce;if(!re)ce=this.w(O),this.g.add(ce),this.f.set(O.item.extId,ce);else if(this.f.has(re)){const ye=this.f.get(re);ye.children.add(O.item.extId),ce=this.w(O,ye),this.f.set(O.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return V.add?.(ce),O.expand===2&&this.h++,ce}o(O,V){const re=this.f.get(O.extId);if(re)return O.expand!==void 0&&(re.expand===2&&this.h--,O.expand===2&&this.h++),(0,e.$UK)(re,O),V.update?.(re),re}p(O,V){const re=this.f.get(O);if(!re)return;const ce=F.$OK.parentId(re.item.extId)?.toString();ce?this.f.get(ce).children.delete(re.item.extId):this.g.delete(re);const ye=[[O]];for(;ye.length;)for(const De of ye.pop()){const he=this.f.get(De);he&&(ye.push(he.children),this.f.delete(De),V.remove?.(he,he!==re),he.expand===2&&this.h--)}}q(O){}updatePendingRoots(O){this.j+=O}v(){return{}}}e.$WK=U}),define(Ae[75],Me([1,0,11,5,6,54,59,49]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.TestItemEventOp=void 0;var f;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const k=(n,r)=>n===r,D=Object.entries({range:(n,r)=>n===r?!0:!n||!r?!1:n.equalsRange(r),busy:k,label:k,description:k,error:k,sortText:k,tags:(n,r)=>!(n.length!==r.length||n.some(u=>!r.includes(u)))}),h=(n,r)=>{let u;for(const[l,i]of D)i(n[l],r[l])||(u?u[l]=r[l]:u={[l]:r[l]});return u};class v extends P.$Tc{get root(){return this.s.root}constructor(r){super(),this.s=r,this.f=this.B(new S.$qh(()=>this.flushDiff(),200)),this.g=this.B(new L.$5d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(r){this.h=r;for(const u of this.tree.values())this.J(u)}get resolveHandler(){return this.h}collectDiff(){const r=this.m;return this.m=[],r}pushDiff(r){switch(r.op){case 2:{for(const u of this.m)if(u.op===2&&u.uri===r.uri){u.docv=r.docv;return}break}case 1:{const u=this.m[this.m.length-1];if(u){if(u.op===1&&u.item.extId===r.item.extId){(0,R.$UK)(u.item,r.item);return}if(u.op===0&&u.item.item.extId===r.item.extId){(0,R.$UK)(u.item,r.item);return}}break}}this.m.push(r),this.f.isScheduled()||this.f.schedule()}expand(r,u){const l=this.tree.get(r);if(l){if((l.expandLevels===void 0||u>l.expandLevels)&&(l.expandLevels=u),l.expand===1){const i=this.M(l);return i.isOpen()?this.L(l,u-1):i.wait().then(()=>this.L(l,u-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,u-1)):this.L(l,u-1)}}dispose(){for(const r of this.tree.values())this.s.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(r,u){switch(u.op){case 3:this.O(g.$OK.joinToString(r.fullId,u.id));break;case 0:this.z(u.item,r);break;case 5:for(const l of u.ops)this.w(r,l);break;case 1:this.C(u.new,u.old,r.fullId.toString());break;case 2:this.J(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:u.update}});break;case 6:this.y(r.actual.uri);break;default:(0,F.$9c)(u)}}y(r){r&&this.pushDiff({op:2,uri:r,docv:this.s.getDocumentVersion(r)})}z(r,u){const l=g.$OK.fromExtHostTestItem(r,this.root.id,u?.actual),i=this.s.getApiFor(r);i.parent&&i.parent!==u?.actual&&this.s.getChildren(i.parent).delete(r.id);let $=this.tree.get(l.toString());if(!$){$={fullId:l,actual:r,expandLevels:u?.expandLevels?u.expandLevels-1:void 0,expand:0},r.tags.forEach(this.D,this),this.tree.set($.fullId.toString(),$),this.G(r,u),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:$.expand,item:this.s.toITestItem(r)}}),this.I(r,$,u);return}if($.actual===r){this.H(r,$,u);return}if($.actual.uri?.toString()!==r.uri?.toString())return this.O(l.toString()),this.z(r,u);const a=this.s.getChildren($.actual),c=$.actual,E=h(this.s.toITestItem(c),this.s.toITestItem(r));this.s.getApiFor(c).listener=void 0,$.actual=r,$.expand=0,E&&(E.hasOwnProperty("tags")&&(this.C(r.tags,c.tags,l.toString()),delete E.tags),this.w($,{op:4,update:E})),this.I(r,$,u);for(const[y,m]of a)this.s.getChildren(r).get(m.id)||this.O(g.$OK.joinToString(l,m.id));this.y($.actual.uri)}C(r,u,l){const i=new Set(u.map($=>$.id));for(const $ of r)i.delete($.id)||this.D($);this.pushDiff({op:1,item:{extId:l,item:{tags:r.map($=>(0,R.$SK)(this.s.controllerId,$.id))}}}),i.forEach(this.F,this)}D(r){const u=this.j.get(r.id);u?u.refCount++:(this.j.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$SK)(this.s.controllerId,r.id)}}))}F(r){const u=this.j.get(r);u&&!--u.refCount&&(this.j.delete(r),this.pushDiff({op:7,id:(0,R.$SK)(this.s.controllerId,r)}))}G(r,u){this.s.getApiFor(r).parent=u&&u.actual!==this.root?u.actual:void 0}H(r,u,l){this.G(r,l);const i=this.s.getApiFor(r);i.parent=l?.actual,i.listener=$=>this.w(u,$),this.J(u)}I(r,u,l){this.H(r,u,l);for(const[i,$]of this.s.getChildren(r))this.z($,u)}J(r){let u;this.h?r.resolveBarrier?u=r.resolveBarrier.isOpen()?3:2:u=r.actual.canResolveChildren?1:0:u=0,u!==r.expand&&(r.expand=u,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:u}}),u===1&&r.expandLevels!==void 0&&this.M(r))}L(r,u){if(u<0)return;const l=[];for(const[i,$]of this.s.getChildren(r.actual)){const a=this.expand(g.$OK.joinToString(r.fullId,$.id),u);(0,S.$3g)(a)&&l.push(a)}if(l.length)return Promise.all(l).then(()=>{})}M(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this.h){const $=new S.$dh;return $.open(),$}r.expand=2,this.N(r);const u=r.resolveBarrier=new S.$dh,l=$=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,$)};let i;try{i=this.h(r.actual===this.root?void 0:r.actual)}catch($){l($)}return(0,S.$3g)(i)?i.catch(l).then(()=>{u.open(),this.J(r)}):(u.open(),this.J(r)),r.resolveBarrier}N(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}O(r){const u=this.tree.get(r);if(!u)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const l=[u];for(;l.length;){const i=l.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const $ of i.actual.tags)this.F($.id);this.tree.delete(i.fullId.toString());for(const[$,a]of this.s.getChildren(i.actual))l.push(this.tree.get(g.$OK.joinToString(i.fullId,a.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.g.fire(r)}}e.$6N=v;class p extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.$7N=p;class s extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$8N=s;class o extends Error{constructor(r,u,l){super(`TestItem with ID "${r}" is from controller "${u}" and cannot be added as a child of an item from controller "${l}".`)}}e.$9N=o;const t=(n,r,u)=>{let l=new Map;return{get size(){return l.size},forEach(i,$){for(const a of l.values())i.call($,a,this)},[Symbol.iterator](){return l.entries()},replace(i){const $=new Map,a=new Set(l.keys()),c={op:5,ops:[]};for(const E of i){if(!(E instanceof u))throw new s(E.id);const y=r(E).controllerId;if(y!==n.controllerId)throw new o(E.id,y,n.controllerId);if($.has(E.id))throw new p(E.id);$.set(E.id,E),a.delete(E.id),c.ops.push({op:0,item:E})}for(const E of a.keys())c.ops.push({op:3,id:E});n.listener?.(c),l=$},add(i){if(!(i instanceof u))throw new s(i.id);l.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){l.delete(i)&&n.listener?.({op:3,id:i})},get(i){return l.get(i)},toJSON(){return Array.from(l.values())}}};e.$0N=t}),define(Ae[103],Me([1,0,75]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=e.$$N=void 0;const L=new WeakMap,P=(R,g)=>{const f={controllerId:g};return L.set(R,f),f};e.$$N=P;const F=R=>{const g=L.get(R);if(!g)throw new S.$8N(R?.id||"<unknown>");return g};e.$_N=F}),define(Ae[76],Me([1,0,12,2]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vxb=e.$uxb=e.$txb=e.$sxb=e.$rxb=void 0,e.$rxb="vscode-cdn.net",e.$sxb=`vscode-resource.${e.$rxb}`,e.$txb=`'self' https://*.${e.$rxb}`;function P(g,f){return g.scheme===S.Schemas.http||g.scheme===S.Schemas.https?g:(f&&f.authority&&f.isRemote&&g.scheme===S.Schemas.file&&(g=L.URI.from({scheme:S.Schemas.vscodeRemote,authority:f.authority,path:g.path})),L.URI.from({scheme:S.Schemas.https,authority:`${g.scheme}+${F(g.authority)}.${e.$sxb}`,path:g.path,fragment:g.fragment,query:g.query}))}e.$uxb=P;function F(g){return g.replace(/./g,f=>{const k=f.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?f:"-"+k.toString(16).padStart(4,"0")})}function R(g){return g.replace(/-([0-9a-f]{4})/g,(f,k)=>String.fromCharCode(parseInt(k,16)))}e.$vxb=R}),define(Ae[214],Me([1,0,5,6,76]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class F{constructor(g,f,k){this.d=g,this.e=f,this.f=k,this.a=0,this.b=new L.$Sc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const A=f.getVisibleTextEditors();for(const D of this.c.values())A.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(g=>g.inset.dispose()),this.b.dispose()}createWebviewEditorInset(g,f,k,A,D){let h;for(const r of this.e.getVisibleTextEditors(!0))if(r.value===g){h=r;break}if(!h)throw new Error("not a visible editor");const v=this,p=this.a++,s=new S.$5d,o=new S.$5d,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(r){return(0,P.$uxb)(r,v.f)}get cspSource(){return P.$txb}set options(r){this.b=r,v.d.$setOptions(p,r)}get options(){return this.b}set html(r){this.a=r,v.d.$setHtml(p,r)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(r){return v.d.$postMessage(p,r)}},n=new class{constructor(){this.editor=g,this.line=f,this.height=k,this.webview=t,this.onDidDispose=o.event}dispose(){v.c.has(p)&&(v.c.delete(p),v.d.$disposeEditorInset(p),o.fire(),o.dispose(),s.dispose())}};return this.d.$createEditorInset(p,h.id,h.value.document.uri,f+1,k,A||{},D.identifier,D.extensionLocation),this.c.set(p,{editor:g,inset:n,onDidReceiveMessage:s}),n}$onDidDispose(g){const f=this.c.get(g);f&&f.inset.dispose()}$onDidReceiveMessage(g,f){this.c.get(g)?.onDidReceiveMessage.fire(f)}}e.$Lhc=F}),define(Ae[104],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.$4K=void 0,e.$4K="__",e.$5K=(0,S.$ei)("IAuthenticationService")}),define(Ae[215],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=e.VariableKind=e.$2O=void 0,e.$2O=(0,S.$ei)("configurationResolverService");var L;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator",F.PathSeparatorAlias="/"})(L||(e.VariableKind=L={}));class P extends Error{constructor(R,g){super(g),this.variable=R}}e.$3O=P}),define(Ae[216],Me([1,0,19,73,16,26,20,94,178,215,13]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eP=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,p,s,o){this.h=new Map,this.a=v,this.b=p,this.g=s,o&&(this.c=o.then(t=>this.i(t)))}i(v){if(R.$i){const p=Object.create(null);return Object.keys(v).forEach(s=>{p[s.toLowerCase()]=v[s]}),p}return v}resolveWithEnvironment(v,p,s){return this.l({env:this.i(v),userHome:void 0},p?p.uri:void 0,s)}async resolveAsync(v,p){const s={env:await this.c,userHome:await this.g};return this.l(s,v?v.uri:void 0,p)}async j(v,p,s,o){const t=F.$Hn(p);R.$i&&t.windows?Object.keys(t.windows).forEach(r=>t[r]=t.windows[r]):R.$j&&t.osx?Object.keys(t.osx).forEach(r=>t[r]=t.osx[r]):R.$k&&t.linux&&Object.keys(t.linux).forEach(r=>t[r]=t.linux[r]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,v?v.uri:void 0,t,s,o)}async resolveAnyAsync(v,p,s){return this.j(v,p,s)}async resolveAnyMap(v,p,s){const o=new Map;return{newConfig:await this.j(v,p,s,o),resolvedVariables:o}}resolveWithInteractionReplace(v,p,s,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,p,s,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,p){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,p)}async l(v,p,s,o,t){if(P.$Sf(s))return this.m(v,p,s,o,t);if(Array.isArray(s))return Promise.all(s.map(n=>this.l(v,p,n,o,t)));if(P.$Uf(s)){const n=Object.create(null),r=await Promise.all(Object.keys(s).map(async u=>[await this.m(v,p,u,o,t),await this.l(v,p,s[u],o,t)]));for(const[u,l]of r)n[u]=l;return n}return s}m(v,p,s,o,t){return(0,A.$bf)(s,D.VARIABLE_REGEXP,async(n,r)=>{if(r.includes(D.VARIABLE_LHS))return n;let u=await this.o(v,n,r,p,o);return t?.set(r,u),u!==n&&P.$Sf(u)&&u.match(D.VARIABLE_REGEXP)&&(u=await this.m(v,p,u,o,t)),u})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,p,s,o,t){let n;const r=s.split(":");r.length>1&&(s=r[0],n=r[1]);const u=$=>{const a=this.a.getFilePath();if(a)return(0,g.$9v)(a);throw new k.$3O($,(0,f.localize)(0,null,p))},l=$=>{const a=u($);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,g.$9v)(c)}throw new k.$3O($,(0,f.localize)(1,null,p,S.$nc(a)))},i=$=>{if(n){const a=this.a.getFolderUri(n);if(a)return a;throw new k.$3O($,(0,f.localize)(2,null,p,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.$3O($,(0,f.localize)(3,null,p)):new k.$3O($,(0,f.localize)(4,null,p))};switch(s){case"env":if(n){if(v.env){const $=v.env[R.$i?n.toLowerCase():n];if(P.$Sf($))return $}return""}throw new k.$3O(k.VariableKind.Env,(0,f.localize)(5,null,p));case"config":if(n){const $=this.a.getConfigurationValue(o,n);if(P.$2f($))throw new k.$3O(k.VariableKind.Config,(0,f.localize)(6,null,p,n));if(P.$Uf($))throw new k.$3O(k.VariableKind.Config,(0,f.localize)(7,null,p,n));return $}throw new k.$3O(k.VariableKind.Config,(0,f.localize)(8,null,p));case"command":return this.p(k.VariableKind.Command,p,n,t,"command");case"input":return this.p(k.VariableKind.Input,p,n,t,"input");case"extensionInstallFolder":if(n){const $=await this.a.getExtension(n);if(!$)throw new k.$3O(k.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,p,n));return this.n($.extensionLocation)}throw new k.$3O(k.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,p));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,g.$9v)(this.n(i(k.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,g.$9v)(this.n(i(k.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.$9v)(S.$nc(this.n(i(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new k.$3O(k.VariableKind.UserHome,(0,f.localize)(11,null,p))}case"lineNumber":{const $=this.a.getLineNumber();if($)return $;throw new k.$3O(k.VariableKind.LineNumber,(0,f.localize)(12,null,p))}case"selectedText":{const $=this.a.getSelectedText();if($)return $;throw new k.$3O(k.VariableKind.SelectedText,(0,f.localize)(13,null,p))}case"file":return u(k.VariableKind.File);case"fileWorkspaceFolder":return l(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$nc(l(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?S.$lc(this.n(i(k.VariableKind.RelativeFile)),u(k.VariableKind.RelativeFile)):u(k.VariableKind.RelativeFile);case"relativeFileDirname":{const $=S.$mc(u(k.VariableKind.RelativeFileDirname));if(o||n){const a=S.$lc(this.n(i(k.VariableKind.RelativeFileDirname)),$);return a.length===0?".":a}return $}case"fileDirname":return S.$mc(u(k.VariableKind.FileDirname));case"fileExtname":return S.$oc(u(k.VariableKind.FileExtname));case"fileBasename":return S.$nc(u(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const $=S.$nc(u(k.VariableKind.FileBasenameNoExtension));return $.slice(0,$.length-S.$oc($).length)}case"fileDirnameBasename":return S.$nc(S.$mc(u(k.VariableKind.FileDirnameBasename)));case"execPath":{const $=this.a.getExecPath();return $||p}case"execInstallFolder":{const $=this.a.getAppRoot();return $||p}case"pathSeparator":case"/":return S.sep;default:try{const $=n?`${s}:${n}`:s;return this.p(k.VariableKind.Unknown,p,$,t,void 0)}catch{return p}}}}p(v,p,s,o,t){if(s&&o){const n=t===void 0?o[s]:o[t+":"+s];if(typeof n=="string")return n;throw new k.$3O(v,(0,f.localize)(14,null,p))}return p}}e.$eP=D}),define(Ae[105],Me([1,0,4,102]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nD=e.$mD=e.OpenEditorContext=e.GroupsOrder=e.$lD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$kD=void 0,e.$kD=(0,S.$ei)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var F;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var g;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(g||(e.GroupsArrangement=g={}));var f;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function k(p){const s=p;return(0,L.$7E)(s?.editor)&&(0,L.$7E)(s?.replacement)}e.$lD=k;var A;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var D;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function h(p){const s=p;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.$mD=h;function v(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$nD=v}),define(Ae[217],Me([1,0,4,105]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=void 0,e.$oD=(0,S.$ei)("editorService"),e.$pD=-1,e.$qD=-2,e.$rD=-3;function P(F){const R=F;return typeof F=="number"||(0,L.$mD)(R)}e.$sD=P}),define(Ae[218],Me([1,0,4,185]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=void 0,e.$iL=(0,S.$fi)(L.$li)}),define(Ae[106],Me([1,0,22,5,19,6,11]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w9b=e.$v9b=e.$u9b=e.$t9b=e.$s9b=void 0;class g{constructor(n,r){this.versionId=n,this.removedDueToLooping=r}}e.$s9b=g;class f{static isHostExtension(n,r,u){if(r.getExtensionDescription(n))return!1;const l=u.getExtensionDescription(n);return l?!!((l.main||l.browser)&&l.api==="none"):!1}constructor(n,r){this.j=n,this.c=new L.$5d,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(s),this.f=new S.$ym,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const r=this.j.readActivationEvents(n);for(const u of r)this.h.has(u)||this.h.set(u,[]),this.h.get(u).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,r){this.e=o(this.e,r),this.e=this.e.concat(n);const u=f.l(this.e);return this.e=o(this.e,u.map(l=>l.identifier)),this.k(),this.d++,this.c.fire(void 0),new g(this.d,u)}static l(n){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,c){this.addNode(a),this.addNode(c),this.c.has(a)?this.c.get(a).push(c):this.c.set(a,[c])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,c){const E=r.getArcs(a);for(let y=0;y<E.length;y++)if(!c.has(E[y]))return!1;return!0}getNodes(){return this.e}},u=new S.$ym;for(const a of n)if(u.set(a.identifier,a),a.extensionDependencies)for(const c of a.extensionDependencies)r.addArc(S.$wm.toKey(a.identifier),S.$wm.toKey(c));const l=new Set;r.getNodes().filter(a=>r.getArcs(a).length===0).forEach(a=>l.add(a));const i=r.getNodes().filter(a=>!l.has(a));let $;do{$=!1;for(let a=0;a<i.length;a++){const c=i[a];r.hasOnlyGoodArcs(c,l)&&(i.splice(a,1),a--,l.add(c),$=!0)}}while($);return i.map(a=>u.get(a))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const r=this.h.get(n);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const r=this.f.get(n);return r||void 0}getExtensionDescriptionByUUID(n){for(const r of this.g)if(r.uuid===n)return r}getExtensionDescriptionByIdOrUUID(n,r){return this.getExtensionDescription(n)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$t9b=f;class k{constructor(n,r){this.versionId=n,this.extensions=r}}e.$u9b=k;class A{constructor(n){this.d=new v,this.c=new f(n,[])}async acquireLock(n){const r=await this.d.acquire(n);return new D(this,r)}deltaExtensions(n,r,u){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,u)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,r){return this.c.getExtensionDescriptionByIdOrUUID(n,r)}}e.$v9b=A;class D extends F.$Tc{constructor(n,r){super(),this.f=n,this.c=!1,this.B(r)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$w9b=D;class h{constructor(n){this.name=n;const r=(0,R.$0g)();this.promise=r.promise,this.c=r.resolve}resolve(n){this.c(n)}}class v{constructor(){this.c=[],this.d=!1}async acquire(n){const r=new h(n);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let r=!0;const u=setTimeout(()=>{r&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),l=()=>{r&&(clearTimeout(u),r=!1,this.d=!1,this.e())};n.resolve((0,F.$Rc)(l))}}var p;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(p||(p={}));function s(t,n){const r=t.isBuiltin?0:t.isUnderDevelopment?2:1,u=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(r!==u)return r-u;const l=P.$gc.basename(t.extensionLocation.path),i=P.$gc.basename(n.extensionLocation.path);return l<i?-1:l>i?1:0}function o(t,n){const r=new S.$xm(n);return t.filter(u=>!r.has(u.identifier))}}),define(Ae[77],Me([1,0,24]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Fm=e.$Em=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(L||(e.UIKind=L={}));var P;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var F;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function R(k){const A=S.$se.alloc(1);switch(k){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$Em=R;function g(k,A){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$Fm=g;var f;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Ae[60],Me([1,0,4,5,14,27,77,56,57,26,2,6,166]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xO=e.$wO=e.$vO=e.$uO=void 0;let v=class extends D.$Tc{constructor(t,n){super(),this.s=t,this.t=n,this.a=this.B(new L.$5d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$5d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:f.$2o,name:(0,h.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(r=>{(0,P.$Aj)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,n,r){const u=this.getTelemetryDetails(),l=new p(n,r,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(t,n,r){this.f=t,this.g=n,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,g.$ml)((0,f.$8o)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const n=this.getTelemetryDetails();this.r.forEach((r,u)=>{const l=r.filter(i=>!i.isDisposed);l.length===0?this.r.delete(u):this.r.set(u,l)}),this.r.forEach(r=>{for(const u of r)u.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,n){const u=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!u)return this.r.delete(t.value),!1;let l=!1;for(const i of u)i.ignoreUnhandledExtHostErrors||(i.logError(n),l=!0);return l}};e.$uO=v,e.$uO=v=Xe([qe(0,F.$tO),qe(1,P.$zj)],v);class p{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,r,u,l,i,$){this.g=r,this.h=u,this.i=l,this.j=i,this.a=new L.$5d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:$.isUsageEnabled,isErrorsEnabled:$.isErrorsEnabled}}updateTelemetryEnablements(t,n){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,f.$$o)(n,[]),this.c&&(n=(0,k.$Kn)(n,this.c)),this.b||(n=(0,k.$Kn)(n,this.j)),"properties"in t?t.properties=n:t=n,t}k(t,n){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(t,n),this.h.trace(t,n))}logUsage(t,n){this.d.isUsageEnabled&&this.k(t,n)}logError(t,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,n);else{const r={name:t.name,message:t.message,stack:t.stack,cause:t.cause},u=(0,f.$$o)(r,[]),l=new Error(u.message,{cause:u.cause});l.stack=u.stack,l.name=u.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(l,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$vO=p;function s(o){const t=Date.now()-new Date(o).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$wO=s,e.$xO=(0,S.$ei)("IExtHostTelemetry")}),define(Ae[23],Me([1,0,5,2,194,101,22,4]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1F=e.$ZF=e.$YF=e.ActivationKind=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.ExtensionHostStartup=e.$SF=e.$RF=e.$QF=e.$PF=void 0,e.$PF=Object.freeze({identifier:new R.$wm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$QF="extensions.webWorker",e.$RF=(0,g.$ei)("extensionService");class f{constructor(l){this.dependency=l}}e.$SF=f;var k;(function(u){u[u.EagerAutoStart=1]="EagerAutoStart",u[u.EagerManualStart=2]="EagerManualStart",u[u.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,i,$){this.c=l,this.d=i.slice(0),this.e=$.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$AF.createActivationEventsMap(this.d)}}set(l,i,$){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const a=[],c=[],E=[],y=[],m=D(this.d),I=D(i),d=(G,W)=>G.extensionLocation.toString()===W.extensionLocation.toString()||G.isBuiltin===W.isBuiltin||G.isUserBuiltin===W.isUserBuiltin||G.isUnderDevelopment===W.isUnderDevelopment;for(const G of this.d){const W=I.get(G.identifier);if(!W){a.push(G.identifier),m.delete(G.identifier);continue}if(!d(G,W)){a.push(G.identifier),m.delete(G.identifier);continue}}for(const G of i){const W=m.get(G.identifier);if(!W){c.push(G);continue}if(!d(W,G)){a.push(W.identifier),m.delete(W.identifier);continue}}const w=new R.$xm(this.e),b=new R.$xm($);for(const G of this.e)b.has(G)||E.push(G);for(const G of $)w.has(G)||y.push(G);const M=F.$AF.createActivationEventsMap(c),T={versionId:l,toRemove:a,toAdd:c,addActivationEvents:M,myToRemove:E,myToAdd:y};return this.delta(T),T}delta(l){if(this.c>=l.versionId)return null;const{toRemove:i,toAdd:$,myToRemove:a,myToAdd:c}=l,E=new R.$xm(i),y=new R.$xm(a);for(let m=0;m<this.d.length;m++)E.has(this.d[m].identifier)&&(this.d.splice(m,1),m--);for(let m=0;m<this.e.length;m++)y.has(this.e[m])&&(this.e.splice(m,1),m--);for(const m of $)this.d.push(m);for(const m of c)this.e.push(m);return this.f=null,l}containsExtension(l){for(const i of this.e)if(R.$wm.equals(i,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const $=F.$AF.readActivationEvents(i);for(const a of $)l.add(a)}return l}}e.$TF=A;function D(u){const l=new R.$ym;for(const i of u)l.set(i.identifier,i);return l}function h(u,l){return u.enabledApiProposals?u.enabledApiProposals.includes(l):!1}e.$UF=h;function v(u,l){if(!h(u,l))throw new Error(`Extension '${u.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${u.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${u.identifier.value}`)}e.$VF=v;class p{constructor(l,i,$,a){this.codeLoadingTime=l,this.activateCallTime=i,this.activateResolvedTime=$,this.activationReason=a}}e.$WF=p;class s{constructor(l,i){this.description=l,this.value=i}}e.$XF=s;var o;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function t(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,P.$ep)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation,targetPlatform:u.targetPlatform,validations:[],isValid:!0}}e.$YF=t;function n(u,l){return{identifier:new R.$wm((0,P.$cp)(u.manifest.publisher,u.manifest.name)),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!!l,extensionLocation:u.location,...u.manifest,uuid:u.identifier.uuid,targetPlatform:u.targetPlatform}}e.$ZF=n;class r{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,i){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$1F=r}),define(Ae[219],Me([1,0,15,106,22,23,14,11]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=e.$_hc=e.$$hc=e.$0hc=e.$9hc=e.$8hc=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(t,n,r,u){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=r,this.activateResolvedTime=u}}e.$8hc=f;class k{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,n){return t===-1||n===-1?-1:n-t}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$9hc=k;class A{constructor(t,n,r,u,l,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=r,this.module=u,this.exports=l,this.subscriptions=i}}e.$0hc=A;class D extends A{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$$hc=D;class h extends A{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$_hc=h;class v extends A{constructor(t){super(!0,t,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(t,n,r,u){this.g=u,this.a=t,this.b=n,this.c=r,this.d=new P.$ym,this.f=Object.create(null)}dispose(){for(const[t,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,r]of this.d)t.push(r.wait());await Promise.all(t)}isActivated(t){const n=this.d.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this.d.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this.f[t])return;const r=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(r.map(u=>({id:u.identifier,reason:{startup:n,extensionId:u.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,n){const r=this.a.getExtensionDescription(t);if(!r)throw new Error(`Extension '${t}' is not known`);return this.h([{id:r.identifier,reason:n}])}async h(t){const n=t.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(n.map(r=>r.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const n=this.a.getExtensionDescription(t.id);if(!n){const l=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new v(l));return this.c.onExtensionActivationError(t.id,l,new F.$SF(t.id.value)),i}const r=[],u=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const l of u){if(this.m(l))continue;const i=this.d.get(l);if(i){r.push(i);continue}if(this.l(l)){r.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:t.reason}));continue}const $=this.a.getExtensionDescription(l);if($){if(!$.main&&!$.browser)continue;r.push(this.j({id:$.identifier,reason:t.reason}));continue}const a=n.displayName||n.identifier.value,c=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${l}'`),E=this.k(t,n.displayName,[],new v(c));return this.c.onExtensionActivationError(n.identifier,c,new F.$SF(l)),E}return this.k(t,n.displayName,r,null)}k(t,n,r,u){const l=new s(t.id,n,t.reason,r,u,this.c,this.g);return this.d.set(t.id,l),l}l(t){return L.$t9b.isHostExtension(t,this.a,this.b)}m(t){const n=this.b.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.$aic=p,e.$aic=p=Xe([qe(3,R.$yj)],p);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,n,r,u,l,i,$){this.c=t,this.d=n,this.f=r,this.g=u,this.h=l,this.j=i,this.k=$,this.a=new g.$dh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const n=this.g[t];if(n.value&&!n.value.activationFailed){this.g.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);r.detail=n.value.activationFailedError,this.h=new v(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this.h=new v(n),this.b&&S.$4(t))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};s=Xe([qe(6,R.$yj)],s)}),define(Ae[220],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[221],Me([1,0,180,15,32,96,72,30,22,220,190,101]),function(fe,e,S,L,P,F,R,g,f,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=void 0;const h=g.$Tn.as(R.$Un.JSONContribution);class v{constructor(l,i,$){this.a=l,this.b=i,this.c=$}d(l,i){this.a({type:l,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(P.default.Error,l)}warn(l){this.d(P.default.Warning,l)}info(l){this.d(P.default.Info,l)}}e.$JF=v;class p{static a(l){const i=new f.$xm;for(let $=0,a=l.length;$<a;$++)i.add(l[$].description.identifier);return i}static compute(l,i){if(!l||!l.length)return new p(i,[]);if(!i||!i.length)return new p([],l);const $=this.a(l),a=this.a(i),c=i.filter(y=>!$.has(y.description.identifier)),E=l.filter(y=>!a.has(y.description.identifier));return new p(c,E)}constructor(l,i){this.added=l,this.removed=i}}e.$KF=p;class s{constructor(l,i){this.name=l,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=p.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,L.$1)(l)}}}e.$LF=s;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$MF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$vm},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$yo}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$yo}},extensionKind:{description:S.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const i=new s(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,i),l.activationEventsGenerator&&D.$AF.register(l.extensionPoint,l.activationEventsGenerator),e.$MF.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,h.registerSchema(t,e.$MF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$NF=n;const r={ExtensionsRegistry:"ExtensionsRegistry"};g.$Tn.add(r.ExtensionsRegistry,new n),e.$OF=g.$Tn.as(r.ExtensionsRegistry),h.registerSchema(t,e.$MF),h.registerSchema(A.$Rj,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ae[222],Me([1,0,176,16,26,221,35,5]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aH=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var k;(function(h){function v(p,s,o){if(!p)return;const t=L.$Sf(p.type)?p.type:void 0;if(!t||t.length===0){o.error(S.localize(3,null));return}const n=[];if(Array.isArray(p.required))for(const r of p.required)L.$Sf(r)&&n.push(r);return{extensionId:s.value,taskType:t,required:n,properties:p.properties?P.$Hn(p.properties):{},when:p.when?R.$cj.deserialize(p.when):void 0}}h.from=v})(k||(k={}));const A=F.$OF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,v)=>{for(const p of h)p.type&&v.push(`onTaskType:${p.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:f}});class D{constructor(){this.d=new g.$5d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,p)=>{A.setHandler((s,o)=>{this.c=void 0;try{for(const t of o.removed){const n=t.value;for(const r of n)this.a&&r.type&&this.a[r.type]&&delete this.a[r.type]}for(const t of o.added){const n=t.value;for(const r of n){const u=k.from(r,t.description.identifier,t.collector);u&&(this.a[u.taskType]=u)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const p of this.all()){const s={type:"object",additionalProperties:!1};p.required.length>0&&(s.required=p.required.slice(0)),p.properties!==void 0?s.properties=P.$Hn(p.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[p.taskType]},v.push(s)}this.c={oneOf:v}}return this.c}}e.$aH=new D}),define(Ae[223],Me([1,0,177,16,25,26,35,222]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$kH=e.JsonSchemaVersion=e.ExecutionEngine=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$eH=e.ShellQuoting=e.$dH=e.$cH=e.$bH=void 0,e.$bH="settings",e.$cH=new R.$vj("taskRunning",!1,S.localize(0,null)),e.$dH=S.localize2(2,"Tasks");var f;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$eH="$customized",function(C){function O(V){if(!V)return C.Strong;switch(V.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=O}(f||(e.ShellQuoting=f={}));var k;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var A;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(A||(e.RevealKind=A={})),function(C){function O(V){switch(V.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=O}(A||(e.RevealKind=A={}));var D;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(C){function O(V){switch(V.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=O}(D||(e.RevealProblemKind=D={}));var h;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(h||(e.PanelKind=h={})),function(C){function O(V){switch(V.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=O}(h||(e.PanelKind=h={}));var v;(function(C){C.defaults={echo:!0,reveal:A.Always,revealProblems:D.Never,focus:!1,panel:h.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var p;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(C){function O(re){switch(re.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=O;function V(re){switch(re){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=V}(p||(e.RuntimeType=p={}));var s;(function(C){function O(V){return L.$Sf(V)?V:V.value}C.value=O})(s||(e.CommandString=s={}));var o;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function O(re){return re===C.Clean._id||re===C.Build._id||re===C.Rebuild._id||re===C.Test._id}C.is=O;function V(re){if(re!==void 0)return L.$Sf(re)?O(re)?{_id:re,isDefault:!1}:void 0:re}C.from=V})(o||(e.TaskGroup=o={}));var t;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function O(V){switch(V){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=O})(n||(e.TaskSourceKind=n={}));var r;(function(C){C.parallel="parallel",C.sequence="sequence"})(r||(e.DependsOrder=r={}));var u;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(u||(e.RunOnOptions=u={}));var l;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:u.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class i{constructor(O,V,re,ce,ye,De){this._label="",this._id=O,V&&(this._label=V),re&&(this.type=re),this.runOptions=ce,this.configurationProperties=ye,this._source=De}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,V=!1){if(O===void 0)return!1;if(L.$Sf(O))return O===this._label||O===this.configurationProperties.identifier||V&&O===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$fH=i;class $ extends i{constructor(O,V,re,ce,ye,De,he,ve){super(O,re,void 0,he,ve,V),this.command={},this._source=V,this.hasDefinedMatchers=De,ye&&(this.command=ye)}clone(){return new $(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case p.Shell:V="shell";break;case p.Process:V="process";break;case p.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(O){return O instanceof $}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$bH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let V=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(V+=this._source.kind);const re={type:e.$eH,folder:O,id:V};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Og(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new $(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$gH=$;class a extends i{constructor(O,V,re,ce,ye,De,he){super(O,re,ce,De,he,V),this._source=V,this.configures=ye}static is(O){return O instanceof a}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Og(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$bH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let V=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(V+=this._source.kind);const re={type:e.$eH,folder:O,id:V};return JSON.stringify(re)}}e.$hH=a;class c extends i{constructor(O,V,re,ce,ye,De,he,ve,se){super(O,re,ce,ve,se,V),this.defines=ye,this.hasDefinedMatchers=he,this.command=De,this.icon=se.icon,this.hide=se.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof c}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new c(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$iH=c;class E extends i{constructor(O,V,re,ce,ye,De){super(O,re,ce,ye,De,V),this._source=V}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new E(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$jH=E;var y;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(y||(e.ExecutionEngine=y={})),function(C){C._default=C.Terminal}(y||(e.ExecutionEngine=y={}));var m;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})(m||(e.JsonSchemaVersion=m={}));class I{constructor(O){this.c=new Map;for(let V=0;V<O.length;V++)this.c.set(O[V].uri.toString(),V)}compare(O,V){const re=O.getWorkspaceFolder(),ce=V.getWorkspaceFolder();if(re&&ce){let ye=this.c.get(re.uri.toString());ye=ye===void 0?0:ye+1;let De=this.c.get(ce.uri.toString());return De=De===void 0?0:De+1,ye===De?O._label.localeCompare(V._label):ye-De}else return!re&&ce?-1:re&&!ce?1:0}}e.$kH=I;var d;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(d||(e.TaskEventKind=d={}));var w;(function(C){C.SingleRun="singleRun",C.Background="background"})(w||(e.TaskRunType=w={}));var b;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var M;(function(C){function O(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function V(ve,se,$e){return{...O(ve),kind:"start",terminalId:se,resolvedVariables:$e}}C.start=V;function re(ve,se,$e){return{...O(ve),kind:"processStarted",terminalId:se,processId:$e}}C.processStarted=re;function ce(ve,se,$e){return{...O(ve),kind:"processEnded",terminalId:se,exitCode:$e}}C.processEnded=ce;function ye(ve,se,$e){return{...O(ve),kind:"terminated",exitReason:$e,terminalId:se}}C.terminated=ye;function De(ve,se,$e){return{...O(se),kind:ve,terminalId:$e}}C.general=De;function he(){return{kind:"changed"}}C.changed=he})(M||(e.TaskEvent=M={}));var T;(function(C){function O(re){const ce=Object.keys(re).sort();let ye="";for(const De of ce){let he=re[De];he instanceof Object?he=O(he):typeof he=="string"&&(he=he.replace(/,/g,",,")),ye+=De+","+he+","}return ye}function V(re){const ye={_key:O(re),type:re.taskType};return Object.assign(ye,re),ye}C.create=V})(T||(e.KeyedTaskIdentifier=T={}));var G;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var W;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var U;(function(C){function O(V,re){const ce=g.$aH.get(V.type);if(ce===void 0){const ve=F.$Hn(V);return delete ve._key,T.create(ve)}const ye=Object.create(null);ye.type=ce.taskType;const De=new Set;ce.required.forEach(ve=>De.add(ve));const he=ce.properties;for(const ve of Object.keys(he)){const se=V[ve];if(se!=null)ye[ve]=se;else if(De.has(ve)){const $e=he[ve];if($e.default!==void 0)ye[ve]=F.$Hn($e.default);else switch($e.type){case"boolean":ye[ve]=!1;break;case"number":case"integer":ye[ve]=0;break;case"string":ye[ve]="";break;default:re.error(S.localize(1,null,JSON.stringify(V,void 0,0),ve));return}}}return T.create(ye)}C.createTaskIdentifier=O})(U||(e.TaskDefinition=U={}))}),define(Ae[224],Me([1,0,15]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y9b=e.$x9b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,g)=>{this.b=R,this.d=g,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,S.$1)(R))}then(R,g){return this.j().then(R,g)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$x9b=L;class P extends L{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$y9b=P}),define(Ae[50],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.$4v=e.$3v=void 0;class S{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++S.count}}e.$3v=S;const L=[];function P(g){const f=new S(g);return L[f.nid]=f,f}e.$4v=P;function F(g){return L[g].sid}e.$5v=F;class R{constructor(f){this.value=f}}e.$6v=R}),define(Ae[3],Me([1,0,50]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=e.$XL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$WL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var P;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var F;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var R;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var g;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var f;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var k;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var A;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class D{static{this.a=0}static mixin(o){return o._id=D.a++,o}}e.$WL=D;var h;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(h||(e.ISuggestDataDtoField=h={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var p;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$XL={MainThreadAuthentication:(0,S.$4v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$4v)("MainThreadBulkEdits"),MainThreadChatProvider:(0,S.$4v)("MainThreadChatProvider"),MainThreadChatAgents2:(0,S.$4v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$4v)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$4v)("MainThreadClipboard"),MainThreadCommands:(0,S.$4v)("MainThreadCommands"),MainThreadComments:(0,S.$4v)("MainThreadComments"),MainThreadConfiguration:(0,S.$4v)("MainThreadConfiguration"),MainThreadConsole:(0,S.$4v)("MainThreadConsole"),MainThreadDebugService:(0,S.$4v)("MainThreadDebugService"),MainThreadDecorations:(0,S.$4v)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$4v)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$4v)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$4v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$4v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$4v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$4v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$4v)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$4v)("MainThreadErrors"),MainThreadTreeViews:(0,S.$4v)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$4v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$4v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$4v)("MainThreadLanguages"),MainThreadLogger:(0,S.$4v)("MainThreadLogger"),MainThreadMessageService:(0,S.$4v)("MainThreadMessageService"),MainThreadOutputService:(0,S.$4v)("MainThreadOutputService"),MainThreadProgress:(0,S.$4v)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$4v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$4v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$4v)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$4v)("MainThreadSecretState"),MainThreadStorage:(0,S.$4v)("MainThreadStorage"),MainThreadSpeech:(0,S.$4v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$4v)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$4v)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$4v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$4v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$4v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$4v)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$4v)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$4v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$4v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$4v)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$4v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$4v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$4v)("MainThreadExtensionService"),MainThreadSCM:(0,S.$4v)("MainThreadSCM"),MainThreadSearch:(0,S.$4v)("MainThreadSearch"),MainThreadShare:(0,S.$4v)("MainThreadShare"),MainThreadTask:(0,S.$4v)("MainThreadTask"),MainThreadWindow:(0,S.$4v)("MainThreadWindow"),MainThreadLabelService:(0,S.$4v)("MainThreadLabelService"),MainThreadNotebook:(0,S.$4v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$4v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$4v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$4v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$4v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$4v)("MainThreadInteractive"),MainThreadChat:(0,S.$4v)("MainThreadChat"),MainThreadInlineChat:(0,S.$4v)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$4v)("MainThreadTheming"),MainThreadTunnelService:(0,S.$4v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$4v)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$4v)("MainThreadTimeline"),MainThreadTesting:(0,S.$4v)("MainThreadTesting"),MainThreadLocalization:(0,S.$4v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$4v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$4v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$4v)("MainThreadIssueReporter")},e.$YL={ExtHostCommands:(0,S.$4v)("ExtHostCommands"),ExtHostConfiguration:(0,S.$4v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$4v)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$4v)("ExtHostDebugService"),ExtHostDecorations:(0,S.$4v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$4v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$4v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$4v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$4v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$4v)("ExtHostEditors"),ExtHostTreeViews:(0,S.$4v)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$4v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$4v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$4v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$4v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$4v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$4v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$4v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$4v)("ExtHostStatusBar"),ExtHostShare:(0,S.$4v)("ExtHostShare"),ExtHostExtensionService:(0,S.$4v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$4v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$4v)("ExtHostTerminalService"),ExtHostSCM:(0,S.$4v)("ExtHostSCM"),ExtHostSearch:(0,S.$4v)("ExtHostSearch"),ExtHostTask:(0,S.$4v)("ExtHostTask"),ExtHostWorkspace:(0,S.$4v)("ExtHostWorkspace"),ExtHostWindow:(0,S.$4v)("ExtHostWindow"),ExtHostWebviews:(0,S.$4v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$4v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$4v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$4v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$4v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$4v)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$4v)("ExtHostProgress"),ExtHostComments:(0,S.$4v)("ExtHostComments"),ExtHostSecretState:(0,S.$4v)("ExtHostSecretState"),ExtHostStorage:(0,S.$4v)("ExtHostStorage"),ExtHostUrls:(0,S.$4v)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$4v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$4v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$4v)("ExtHostOutputService"),ExtHostLabelService:(0,S.$4v)("ExtHostLabelService"),ExtHostNotebook:(0,S.$4v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$4v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$4v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$4v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$4v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$4v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$4v)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$4v)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$4v)("ExtHostChat"),ExtHostChatAgents2:(0,S.$4v)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$4v)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$4v)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$4v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$4v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$4v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$4v)("ExtHostTheming"),ExtHostTunnelService:(0,S.$4v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$4v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$4v)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$4v)("ExtHostTimeline"),ExtHostTesting:(0,S.$4v)("ExtHostTesting"),ExtHostTelemetry:(0,S.$4v)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$4v)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$4v)("ExtHostIssueReporter")}}),define(Ae[78],Me([1,0,4,14,3,17]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=e.$thc=void 0,e.$thc=(0,S.$ei)("IExtHostApiDeprecationService");let R=class{constructor(f,k){this.c=k,this.a=new Set,this.b=f.getProxy(P.$XL.MainThreadTelemetry)}report(f,k,A){const D=this.d(f,k);this.a.has(D)||(this.a.add(D),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:f}))}d(f,k){return`${f}-${k.identifier.value}`}};e.$uhc=R,e.$uhc=R=Xe([qe(0,F.$dO),qe(1,L.$yj)],R),e.$vhc=Object.freeze(new class{report(g,f,k){}})}),define(Ae[225],Me([1,0,68,6,3]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;class F{static{this.a=0}constructor(f,k){this.extension=f,this.provider=k,this.handle=F.a++}}class R{static{this.a=0}constructor(f){this.b=new Map,this.c=new Map,this.d=f.getProxy(P.$XL.MainThreadChat)}registerChatProvider(f,k,A){const D=new F(f,A);return this.b.set(D.handle,D),this.d.$registerChatProvider(D.handle,k),(0,L.$Rc)(()=>{this.d.$unregisterChatProvider(D.handle),this.b.delete(D.handle)})}transferChatSession(f,k){const A=S.Iterable.find(this.c.keys(),D=>this.c.get(D)===f)??0;typeof A=="number"&&this.d.$transferChatSession(A,k)}sendInteractiveRequestToProvider(f,k){this.d.$sendRequestToProvider(f,k)}async $prepareChat(f,k){const A=this.b.get(f);if(!A)return;const D=await A.provider.prepareSession(k);if(!D)return;const h=R.a++;return this.c.set(h,D),{id:h,requesterUsername:D.requester?.name,requesterAvatarIconUri:D.requester?.icon,responderUsername:D.responder?.name,responderAvatarIconUri:D.responder?.icon,inputPlaceholder:D.inputPlaceholder}}$releaseSession(f){this.c.delete(f)}}e.$Fhc=R}),define(Ae[226],Me([1,0,3]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=void 0;class L{constructor(F){const R=F.getProxy(S.$XL.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(g){return R.$writeText(g)}})}}e.$Jhc=L}),define(Ae[227],Me([1,0,26,3,27,17]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=void 0;let R=class{constructor(A,D){this.a=A.getProxy(L.$XL.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,D){const h=this,v=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){h.e(A,D,v,arguments)}})}e(A,D,h,v){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:f(v,this.b)}),this.c&&this.f(A,h,v)}};e.$Ajc=R,e.$Ajc=R=Xe([qe(0,F.$dO),qe(1,P.$tO)],R);const g=1e5;function f(k,A){const D=[];if(k.length)for(let h=0;h<k.length;h++){let v=k[h];if(typeof v>"u")v="undefined";else if(v instanceof Error){const p=v;p.stack?v=p.stack:v=p.toString()}D.push(v)}if(A){const h=new Error().stack;h&&D.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,S.$Mn)(D);return h.length>g?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(Ae[228],Me([1,0,2,3,23]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;class F{constructor(g){this.a=g.getProxy(L.$XL.MainThreadDialogs)}showOpenDialog(g,f){return f?.allowUIResources&&(0,P.$VF)(g,"showLocal"),this.a.$showOpenDialog(f).then(k=>k?k.map(A=>S.URI.revive(A)):void 0)}showSaveDialog(g){return this.a.$showSaveDialog(g).then(f=>f?S.URI.revive(f):void 0)}}e.$Eic=F}),define(Ae[229],Me([1,0,6,3]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(L.$XL.MainThreadLabelService)}$registerResourceLabelFormatter(R){const g=this.b++;return this.a.$registerResourceLabelFormatter(g,R),(0,S.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(g)})}}e.$Zic=P}),define(Ae[79],Me([1,0,20,13,2,4,14,3,27,17]),function(fe,e,S,L,P,F,R,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=e.$mic=void 0;let A=class{constructor(h,v,p){this.f=p,this.d=new Map,this.a=v.getProxy(g.$XL.MainThreadLocalization),this.b=h.environment.appLanguage,this.c=this.b===S.$g}getMessage(h,v){const{message:p,args:s,comment:o}=v;if(this.c)return(0,L.$Ue)(p,s??{});let t=p;o&&o.length>0&&(t+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(h)?.contents[t];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,L.$Ue)(n??p,s??{})}getBundle(h){return this.d.get(h)?.contents}getBundleUri(h){return this.d.get(h)?.uri}async initializeLocalizedMessages(h){if(this.c||!h.l10n&&!h.isBuiltin||this.d.has(h.identifier.value))return;let v;const p=await this.g(h);if(!p){this.f.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(p),o=JSON.parse(s);v=h.isBuiltin?o.contents?.bundle:o}catch(s){this.f.error(`Failed to load translations for ${h.identifier.value} from ${p}: ${s.message}`);return}v&&this.d.set(h.identifier.value,{contents:v,uri:p})}async g(h){if(h.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(h.identifier.value,this.b);return P.URI.revive(v)}return h.l10n?P.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$mic=A,e.$mic=A=Xe([qe(0,f.$tO),qe(1,k.$dO),qe(2,R.$yj)],A),e.$nic=(0,F.$ei)("IExtHostLocalizationService")}),define(Ae[230],Me([1,0,14,3,27,17,2,52]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0;let f=class extends S.$Jj{constructor(D,h){super(h.logLevel,h.logsLocation,h.loggers.map(v=>(0,g.$Nh)(v))),this.r=D.getProxy(L.$XL.MainThreadLogger)}$setLogLevel(D,h){h?this.setLogLevel(R.URI.revive(h),D):this.setLogLevel(D)}setVisibility(D,h){super.setVisibility(D,h),this.r.$setVisibility(D,h)}s(D,h,v){return new k(this.r,D,h,v)}};e.$zjc=f,e.$zjc=f=Xe([qe(0,F.$dO),qe(1,P.$tO)],f);class k extends S.$Ej{constructor(D,h,v,p){super(p?.logLevel==="always"),this.r=D,this.s=h,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(h,p).then(()=>{this.u(this.n),this.m=!0})}g(D,h){const v=[[D,h]];this.m?this.u(v):this.n.push(...v)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Ae[80],Me([1,0,3,4,6,17,24]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=e.$oic=void 0,e.$oic=(0,L.$ei)("IExtHostManagedSockets");let g=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(S.$XL.MainThreadManagedSockets)}setFactory(D,h){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(D,h),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const h=++this.b,v=await this.c.makeConnection(),p=new P.$Sc;return this.d.set(h,new k(h,v,p)),p.add((0,P.$Rc)(()=>this.d.delete(h))),p.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(h),p.dispose()})),p.add(v.onDidClose(s=>{this.a.$onDidManagedSocketClose(h,s?.stack??s?.message),p.dispose()})),p.add(v.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(h,R.$se.wrap(s)))),h}$remoteSocketWrite(D,h){this.d.get(D)?.actual.send(h.buffer)}$remoteSocketEnd(D){const h=this.d.get(D);h&&(h.actual.end(),h.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$pic=g,e.$pic=g=Xe([qe(0,F.$dO)],g);class f{constructor(D,h){this.socketFactoryId=D,this.makeConnection=h}}class k extends P.$Tc{constructor(D,h,v){super(),this.socketId=D,this.actual=h,this.B(v)}}}),define(Ae[231],Me([1,0,3,14,23]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;function F(g){return g&&g.title}let R=class{constructor(f,k){this.b=k,this.a=f.getProxy(S.$XL.MainThreadMessageService)}showMessage(f,k,A,D,h){const v={source:{identifier:f.identifier,label:f.displayName||f.name}};let p;typeof D=="string"||F(D)?p=[D,...h]:(v.modal=D?.modal,v.useCustom=D?.useCustom,v.detail=D?.detail,p=h),v.useCustom&&(0,P.$VF)(f,"resolvers");const s=[];let o=!1;for(let t=0;t<p.length;t++){const n=p[t];if(typeof n=="string")s.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:r,isCloseAffordance:u}=n;s.push({title:r,isCloseAffordance:!!u,handle:t}),u&&(o?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,n)}return this.a.$showMessage(k,A,v,s).then(t=>{if(typeof t=="number")return p[t]})}};e.$2ic=R,e.$2ic=R=Xe([qe(1,L.$yj)],R)}),define(Ae[232],Me([1,0,6,16,2,23,3]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=void 0;class g{constructor(k){this.b=new Map,this.a=k.getProxy(R.$XL.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,A,D){if((0,F.$VF)(k,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,D),this.a.$registerProfileContentHandler(A,D.name,D.description,k.identifier.value),(0,S.$Rc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(k,A,D,h){const v=this.b.get(k);if(!v)throw new Error(`Unknown handler with id: ${k}`);return v.saveProfile(A,D,h)}async $readProfile(k,A,D){const h=this.b.get(k);if(!h)throw new Error(`Unknown handler with id: ${k}`);return h.readProfile((0,L.$Sf)(A)?A:P.URI.revive(A),D)}}e.$$ic=g}),define(Ae[81],Me([1,0,3,5,4]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=e.$jic=void 0;class F{constructor(g){this.b=new L.$5d,this.onDidChangePassword=this.b.event,this.a=g.getProxy(S.$XL.MainThreadSecretState)}async $onDidChangePassword(g){this.b.fire(g)}get(g,f){return this.a.$getPassword(g,f)}store(g,f,k){return this.a.$setPassword(g,f,k)}delete(g,f){return this.a.$deletePassword(g,f)}}e.$jic=F,e.$kic=(0,P.$ei)("IExtHostSecretState")}),define(Ae[233],Me([1,0,21,6,3]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=void 0;class F{static{this.a=1}constructor(g){this.c=new Map,this.d=new Map,this.b=g.getProxy(P.$XL.MainThreadSpeech)}async $createSpeechToTextSession(g,f){const k=this.c.get(g);if(!k)return;const A=new L.$Sc,D=new S.$ce;this.d.set(f,D);const h=A.add(k.provideSpeechToTextSession(D.token));A.add(h.onDidChange(v=>{D.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,v)})),A.add(D.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}async $createKeywordRecognitionSession(g,f){const k=this.c.get(g);if(!k)return;const A=new L.$Sc,D=new S.$ce;this.d.set(f,D);const h=A.add(k.provideKeywordRecognitionSession(D.token));A.add(h.onDidChange(v=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(f,v)})),A.add(D.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}registerProvider(g,f,k){const A=F.a++;return this.c.set(A,k),this.b.$registerProvider(A,f,{extension:g,displayName:g.value}),(0,L.$Rc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$fjc=F}),define(Ae[82],Me([1,0,3,5,4]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=e.$bic=void 0;class F{constructor(g,f){this.c=f,this.b=new L.$5d,this.onDidChangeStorage=this.b.event,this.a=g.getProxy(S.$XL.MainThreadStorage)}registerExtensionStorageKeysToSync(g,f){this.a.$registerExtensionStorageKeysToSync(g,f)}async initializeExtensionStorage(g,f,k){const A=await this.a.$initializeExtensionStorage(g,f);let D;return A&&(D=this.d(g,f,A)),D||k}setValue(g,f,k){return this.a.$setValue(g,f,k)}$acceptValue(g,f,k){const A=this.d(g,f,k);A&&this.b.fire({shared:g,key:f,value:A})}d(g,f,k){try{return JSON.parse(k)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${g}): ${A}`)}}}e.$bic=F,e.$cic=(0,P.$ei)("IExtHostStorage")}),define(Ae[234],Me([1,0,6,12,2,3]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=void 0;class R{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor(f){this.c=new Map,this.b=f.getProxy(F.$XL.MainThreadUriOpeners)}registerExternalUriOpener(f,k,A,D){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const h=D.schemes.find(v=>!R.a.has(v));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this.c.set(k,A),this.b.$registerUriOpener(k,D.schemes,f,D.label),(0,S.$Rc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(f,k,A){const D=this.c.get(f);if(!D)throw new Error(`Unknown opener with id: ${f}`);const h=P.URI.revive(k);return D.canOpenExternalUri(h,A)}async $openUri(f,k,A){const D=this.c.get(f);if(!D)throw new Error(`Unknown opener id: '${f}'`);return D.openExternalUri(P.URI.revive(k.resolvedUri),{sourceUri:P.URI.revive(k.sourceUri)},A)}}e.$tjc=R}),define(Ae[235],Me([1,0,3,2,6,15,22]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=void 0;class g{static{this.a=0}constructor(k){this.c=new R.$xm,this.d=new Map,this.b=k.getProxy(S.$XL.MainThreadUrls)}registerUriHandler(k,A){const D=k.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const h=g.a++;return this.c.add(D),this.d.set(h,A),this.b.$registerUriHandler(h,D,k.displayName||k.name),(0,P.$Rc)(()=>{this.c.delete(D),this.d.delete(h),this.b.$unregisterUriHandler(h)})}$handleExternalUri(k,A){const D=this.d.get(k);if(!D)return Promise.resolve(void 0);try{D.handleUri(L.URI.revive(A))}catch(h){(0,F.$1)(h)}return Promise.resolve(void 0)}async createAppUri(k){return L.URI.revive(await this.b.$createAppUri(k))}}e.$ujc=g}),define(Ae[61],Me([1,0,5,6,12,26,2,183,205,76,3]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=e.$2hc=e.$1hc=e.$Zhc=e.$Yhc=void 0;class D{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(u,l,i,$,a,c,E){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$5d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$5d,this._onDidDispose=this.#h.event,this.#e=u,this.#t=l,this.#o=i,this.#n=$,this.#s=a,this.#r=c,this.#l=h(c),this.#d=v(c),this.#i=E}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return this.#u=!0,(0,k.$uxb)(u,this.#n)}get cspSource(){const u=this.#r.extensionLocation;if(u.scheme===P.Schemas.https||u.scheme===P.Schemas.http){let l=u.toString();return l.endsWith("/")||(l+="/"),l+" "+k.$txb}return k.$txb}get html(){return this.a(),this.#a}set html(u){this.a(),this.#a!==u&&(this.#a=u,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(u)))}get options(){return this.a(),this.#o}set options(u){this.a(),F.$Ln(this.#o,u)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,u)),this.#o=u}async postMessage(u){if(this.#c)return!1;const l=(0,f.$0mb)(u,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(u){if(!this.#d)return u;const l=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return u.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,($,a,c,E,y,m)=>{const I=R.URI.from({scheme:E||"file",path:decodeURIComponent(y)}),d=(0,k.$uxb)(I,{isRemote:l,authority:i}).toString();return`${a}${d}${m}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,($,a,c,E,y,m)=>{const I=R.URI.from({scheme:E||"file",path:decodeURIComponent(y)}),d=(0,k.$uxb)(I,{isRemote:l,authority:i}).toString();return`${a}${d}${m}`})}}e.$Yhc=D;function h(r){try{const u=(0,g.$np)((0,g.$mp)(r.engines.vscode));return!!u&&u.majorBase>=1&&u.minorBase>=57}catch{return!1}}e.$Zhc=h;function v(r){try{const u=(0,g.$np)((0,g.$mp)(r.engines.vscode));return u?u.majorBase<1||u.majorBase===1&&u.minorBase<60:!1}catch{return!1}}class p extends L.$Tc{constructor(u,l,i,$,a){super(),this.c=l,this.f=i,this.g=$,this.h=a,this.b=new Map,this.a=u.getProxy(A.$XL.MainThreadWebviews)}dispose(){super.dispose();for(const u of this.b.values())u.dispose();this.b.clear()}$onMessage(u,l,i){const $=this.j(u);if($){const{message:a}=(0,f.$$mb)(l,i.value);$._onMessageEmitter.fire(a)}}$onMissingCsp(u,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,l,i){const $=new D(u,this.a,t(l),this.c,this.f,i,this.h);this.b.set(u,$);const a=$._onDidDispose(()=>{a.dispose(),this.deleteWebview(u)});return $}deleteWebview(u){this.b.delete(u)}j(u){return this.b.get(u)}}e.$1hc=p;function s(r){return{id:r.identifier,location:r.extensionLocation}}e.$2hc=s;function o(r,u,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||n(r,u)}}e.$3hc=o;function t(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(u=>R.URI.from(u))}}function n(r,u){return[...(u?.getWorkspaceFolders()||[]).map(l=>l.uri),r.extensionLocation]}}),define(Ae[107],Me([1,0,5,3,2,12,13,4,17,23]),function(fe,e,S,L,P,F,R,g,f,k){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=e.$wjc=void 0;let D=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(v){const p=this.d;return{get focused(){return p.focused},get active(){return(0,k.$VF)(v,"windowActivity"),p.active}}}constructor(v){this.c=new S.$5d,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=v.getProxy(L.$XL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:s})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,p){p!==this.d[v]&&(this.d={...this.d,[v]:p},this.c.fire(this.d))}openUri(v,p){let s;if(typeof v=="string"){s=v;try{v=P.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,R.$Se)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,s,p)}async asExternalUri(v,p){if((0,R.$Se)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(v,p);return P.URI.from(s)}};e.$wjc=D,e.$wjc=D=A=Xe([qe(0,f.$dO)],D),e.$xjc=(0,g.$ei)("IExtHostWindow")}),define(Ae[236],Me([1,0,227,27,17]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=void 0;let F=class extends S.$Ajc{constructor(g,f){super(g,f)}f(g,f,k){f.apply(console,k)}};e.$Ilc=F,e.$Ilc=F=Xe([qe(0,P.$dO),qe(1,L.$tO)],F)}),define(Ae[237],Me([1,0,11,24,21,15,5,6,140,224,50]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$B9b=e.ResponsiveState=e.RequestInitiator=e.$A9b=e.$z9b=void 0;function h(b,M){try{return JSON.stringify(b,M)}catch{return"null"}}const v="$$ref$$",p={[v]:-1};class s{constructor(M,T){this.jsonString=M,this.referencedBuffers=T}}function o(b,M=null,T=!1){const G=[];return{jsonString:(T?h:JSON.stringify)(b,(U,C)=>{if(typeof C>"u")return p;if(typeof C=="object"){if(C instanceof L.$se){const O=G.push(C)-1;return{[v]:O}}if(M)return M(U,C)}return C}),referencedBuffers:G}}e.$z9b=o;function t(b,M,T){return JSON.parse(b,(G,W)=>{if(W){const U=W[v];if(typeof U=="number")return M[U];if(T&&W.$mid===1)return T.transformIncoming(W)}return W})}e.$A9b=t;function n(b,M){return JSON.stringify(b,M)}function r(b){return b?(M,T)=>T&&T.$mid===1?b.transformOutgoing(T):T:null}var u;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));var l;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const i=()=>{},$=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class c extends g.$Tc{static{D=$}static{this.a=3*1e3}constructor(M,T=null,G=null){super(),this[D]=!0,this.b=this.B(new R.$5d),this.onDidChangeResponsiveState=this.b.event,this.c=M,this.f=T,this.g=G,this.h=r(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,U=A.$3v.count;W<U;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$qh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(M=>{const T=this.w[M];delete this.w[M],T.resolveErr(F.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(M){this.z===0&&(this.C=Date.now()+c.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(M){this.C=Date.now()+c.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(M){this.y!==M&&(this.y=M,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(M){return this.g?(0,f.$gn)(M,this.g):M}getProxy(M){const{nid:T,sid:G}=M;return this.s[T]||(this.s[T]=this.J(T,G)),this.s[T]}J(M,T){const G={get:(W,U)=>(typeof U=="string"&&!W[U]&&U.charCodeAt(0)===36&&(W[U]=(...C)=>this.U(M,U,C)),U===a?T:W[U])};return new Proxy(Object.create(null),G)}set(M,T){return this.m[M.nid]=T,T}assertRegistered(M){for(let T=0,G=M.length;T<G;T++){const W=M[T];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(M){if(this.j)return;const T=M.byteLength,G=y.read(M,0),W=G.readUInt8(),U=G.readUInt32();switch(W){case 1:case 2:{let{rpcId:C,method:O,args:V}=I.deserializeRequestJSONArgs(G);this.g&&(V=(0,f.$gn)(V,this.g)),this.M(T,U,C,O,V,W===2);break}case 3:case 4:{let{rpcId:C,method:O,args:V}=I.deserializeRequestMixedArgs(G);this.g&&(V=(0,f.$gn)(V,this.g)),this.M(T,U,C,O,V,W===4);break}case 5:{this.f?.logIncoming(T,U,0,"ack"),this.G(U);break}case 6:{this.N(T,U);break}case 7:{this.O(T,U,void 0);break}case 9:{let C=I.deserializeReplyOKJSON(G);this.g&&(C=(0,f.$gn)(C,this.g)),this.O(T,U,C);break}case 10:{const C=I.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(T,U,C);break}case 8:{const C=I.deserializeReplyOKVSBuffer(G);this.O(T,U,C);break}case 11:{let C=I.deserializeReplyErrError(G);this.g&&(C=(0,f.$gn)(C,this.g)),this.P(T,U,C);break}case 12:{this.P(T,U,void 0);break}default:console.error("received unexpected message"),console.error(M)}}M(M,T,G,W,U,C){this.f?.logIncoming(M,T,1,`receiveRequest ${(0,A.$5v)(G)}.${W}(`,U);const O=String(T);let V,re;if(C){const ye=new P.$ce;U.push(ye.token),V=this.Q(G,W,U),re=()=>ye.cancel()}else V=this.Q(G,W,U),re=i;this.u[O]=re;const ce=I.serializeAcknowledged(T);this.f?.logOutgoing(ce.byteLength,T,1,"ack"),this.c.send(ce),V.then(ye=>{delete this.u[O];const De=I.serializeReplyOK(T,ye,this.h);this.f?.logOutgoing(De.byteLength,T,1,"reply:",ye),this.c.send(De)},ye=>{delete this.u[O];const De=I.serializeReplyErr(T,ye);this.f?.logOutgoing(De.byteLength,T,1,"replyErr:",ye),this.c.send(De)})}N(M,T){this.f?.logIncoming(M,T,1,"receiveCancel");const G=String(T);this.u[G]?.()}O(M,T,G){this.f?.logIncoming(M,T,0,"receiveReply:",G);const W=String(T);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W],U.resolveOk(G)}P(M,T,G){this.f?.logIncoming(M,T,0,"receiveReplyErr:",G);const W=String(T);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W];let C;G&&(G.$isError?(C=new Error,C.name=G.name,C.message=G.message,C.stack=G.stack):C=G),U.resolveErr(C)}Q(M,T,G){try{return Promise.resolve(this.S(M,T,G))}catch(W){return Promise.reject(W)}}S(M,T,G){const W=this.m[M];if(!W)throw new Error("Unknown actor "+(0,A.$5v)(M));const U=W[T];if(typeof U!="function")throw new Error("Unknown method "+T+" on actor "+(0,A.$5v)(M));return U.apply(W,G)}U(M,T,G){if(this.j)return new k.$y9b;let W=null;if(G.length>0&&P.CancellationToken.isCancellationToken(G[G.length-1])&&(W=G.pop()),W&&W.isCancellationRequested)return Promise.reject(F.$6());const U=I.serializeRequestArguments(G,this.h),C=++this.t,O=String(C),V=new k.$x9b,re=new g.$Sc;W&&re.add(W.onCancellationRequested(()=>{const ye=I.serializeCancel(C);this.f?.logOutgoing(ye.byteLength,C,0,"cancel"),this.c.send(I.serializeCancel(C))})),this.w[O]=new E(V,re),this.F(C);const ce=I.serializeRequest(C,M,T,U,!!W);return this.f?.logOutgoing(ce.byteLength,C,0,`request: ${(0,A.$5v)(M)}.${T}(`,G),this.c.send(ce),V}}e.$B9b=c;class E{constructor(M,T){this.a=M,this.b=T}resolveOk(M){this.a.resolveOk(M),this.b.dispose()}resolveErr(M){this.a.resolveErr(M),this.b.dispose()}}class y{static alloc(M,T,G){const W=new y(L.$se.alloc(G+1+4),0);return W.writeUInt8(M),W.writeUInt32(T),W}static read(M,T){return new y(M,T)}get buffer(){return this.a}constructor(M,T){this.a=M,this.b=T}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(M){this.a.writeUInt8(M,this.b),this.b+=1}readUInt8(){const M=this.a.readUInt8(this.b);return this.b+=1,M}writeUInt32(M){this.a.writeUInt32BE(M,this.b),this.b+=4}readUInt32(){const M=this.a.readUInt32BE(this.b);return this.b+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this.a.writeUInt8(M.byteLength,this.b),this.b+=1,this.a.set(M,this.b),this.b+=M.byteLength}readShortString(){const M=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+M).toString();return this.b+=M,G}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readLongString(){const M=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+M).toString();return this.b+=M,G}writeBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readVSBuffer(){const M=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+M);return this.b+=M,T}static sizeMixedArray(M){let T=0;T+=1;for(let G=0,W=M.length;G<W;G++){const U=M[G];switch(T+=1,U.type){case 1:T+=this.sizeLongString(U.value);break;case 2:T+=this.sizeVSBuffer(U.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(U.value);for(let C=0;C<U.buffers.length;++C)T+=this.sizeVSBuffer(U.buffers[C]);break;case 4:break}}return T}writeMixedArray(M){this.a.writeUInt8(M.length,this.b),this.b+=1;for(let T=0,G=M.length;T<G;T++){const W=M[T];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let U=0;U<W.buffers.length;++U)this.writeBuffer(W.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const M=this.a.readUInt8(this.b);this.b+=1;const T=new Array(M);for(let G=0;G<M;G++)switch(this.readUInt8()){case 1:T[G]=this.readLongString();break;case 2:T[G]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),C=this.readLongString(),O=[];for(let V=0;V<U;++V)O.push(this.readVSBuffer());T[G]=new A.$6v(t(C,O,null));break}case 4:T[G]=void 0;break}return T}}var m;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(m||(m={}));class I{static a(M){for(let T=0,G=M.length;T<G;T++)if(M[T]instanceof L.$se||M[T]instanceof A.$6v||typeof M[T]>"u")return!0;return!1}static serializeRequestArguments(M,T){if(this.a(M)){const G=[];for(let W=0,U=M.length;W<U;W++){const C=M[W];if(C instanceof L.$se)G[W]={type:2,value:C};else if(typeof C>"u")G[W]={type:4};else if(C instanceof A.$6v){const{jsonString:O,referencedBuffers:V}=o(C.value,T);G[W]={type:3,value:L.$se.fromString(O),buffers:V}}else G[W]={type:1,value:L.$se.fromString(n(C,T))}}return{type:1,args:G}}return{type:0,args:n(M,T)}}static serializeRequest(M,T,G,W,U){switch(W.type){case 0:return this.b(M,T,G,W.args,U);case 1:return this.c(M,T,G,W.args,U)}}static b(M,T,G,W,U){const C=L.$se.fromString(G),O=L.$se.fromString(W);let V=0;V+=y.sizeUInt8(),V+=y.sizeShortString(C),V+=y.sizeLongString(O);const re=y.alloc(U?2:1,M,V);return re.writeUInt8(T),re.writeShortString(C),re.writeLongString(O),re.buffer}static deserializeRequestJSONArgs(M){const T=M.readUInt8(),G=M.readShortString(),W=M.readLongString();return{rpcId:T,method:G,args:JSON.parse(W)}}static c(M,T,G,W,U){const C=L.$se.fromString(G);let O=0;O+=y.sizeUInt8(),O+=y.sizeShortString(C),O+=y.sizeMixedArray(W);const V=y.alloc(U?4:3,M,O);return V.writeUInt8(T),V.writeShortString(C),V.writeMixedArray(W),V.buffer}static deserializeRequestMixedArgs(M){const T=M.readUInt8(),G=M.readShortString(),W=M.readMixedArray(),U=new Array(W.length);for(let C=0,O=W.length;C<O;C++){const V=W[C];typeof V=="string"?U[C]=JSON.parse(V):U[C]=V}return{rpcId:T,method:G,args:U}}static serializeAcknowledged(M){return y.alloc(5,M,0).buffer}static serializeCancel(M){return y.alloc(6,M,0).buffer}static serializeReplyOK(M,T,G){if(typeof T>"u")return this.d(M);if(T instanceof L.$se)return this.e(M,T);if(T instanceof A.$6v){const{jsonString:W,referencedBuffers:U}=o(T.value,G,!0);return this.g(M,W,U)}else return this.f(M,h(T,G))}static d(M){return y.alloc(7,M,0).buffer}static e(M,T){let G=0;G+=y.sizeVSBuffer(T);const W=y.alloc(8,M,G);return W.writeVSBuffer(T),W.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static f(M,T){const G=L.$se.fromString(T);let W=0;W+=y.sizeLongString(G);const U=y.alloc(9,M,W);return U.writeLongString(G),U.buffer}static g(M,T,G){const W=L.$se.fromString(T);let U=0;U+=y.sizeUInt32,U+=y.sizeLongString(W);for(const O of G)U+=y.sizeVSBuffer(O);const C=y.alloc(10,M,U);C.writeUInt32(G.length),C.writeLongString(W);for(const O of G)C.writeBuffer(O);return C.buffer}static deserializeReplyOKJSON(M){const T=M.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(M,T){const G=M.readUInt32(),W=M.readLongString(),U=[];for(let C=0;C<G;++C)U.push(M.readVSBuffer());return new A.$6v(t(W,U,T))}static serializeReplyErr(M,T){const G=T?h(F.$3(T),null):void 0;if(typeof G!="string")return this.h(M);const W=L.$se.fromString(G);let U=0;U+=y.sizeLongString(W);const C=y.alloc(11,M,U);return C.writeLongString(W),C.buffer}static deserializeReplyErrError(M){const T=M.readLongString();return JSON.parse(T)}static h(M){return y.alloc(12,M,0).buffer}}var d;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var w;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(w||(w={}))}),define(Ae[238],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;const S=function(F){const R=g=>{globalThis.removeEventListener("message",R);const f=g.data;Object.defineProperties(globalThis,{postMessage:{value(k,A){f.postMessage(k,A)}},onmessage:{get(){return f.onmessage},set(k){f.onmessage=k}}}),f.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data,ports:k.ports?[...k.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",R)}.toString();class L extends EventTarget{constructor(F,R,g){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${S})('${R}'))`,k=new Blob([f],{type:"application/javascript"}),A=URL.createObjectURL(k),D=new MessageChannel,h=A,v={type:"_newWorker",id:h,port:D.port2,url:A,options:g};F(v,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{F({type:"_terminateWorker",id:h}),URL.revokeObjectURL(A),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(p){D.port1.onmessage=p}},onmessageerror:{get(){return D.port1.onmessageerror},set(p){D.port1.onmessageerror=p}}}),D.port1.addEventListener("messageerror",p=>{const s=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(s)}),D.port1.addEventListener("message",p=>{const s=new MessageEvent("message",{data:p.data});this.dispatchEvent(s)}),D.port1.start()}}e.$Klc=L}),define(Ae[239],Me([1,0,24,28,12,53,4]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KJ=e.$JJ=e.$IJ=e.$HJ=void 0,e.$HJ=(0,R.$ei)("notebookDocumentService");const g=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${g.join("")}]+`),k=7;function A(v){if(v.scheme!==P.Schemas.vscodeNotebookCell)return;const p=v.fragment.indexOf("s");if(p<0)return;const s=parseInt(v.fragment.substring(0,p).replace(f,""),k),o=(0,S.$Le)(v.fragment.substring(p+1)).toString();if(!isNaN(s))return{handle:s,notebook:v.with({scheme:o,fragment:null})}}e.$IJ=A;function D(v,p){const s=p.toString(k),t=`${s.length<g.length?g[s.length-1]:"z"}${s}s${(0,S.$Me)(S.$se.fromString(v.scheme),!0,!0)}`;return v.with({scheme:P.Schemas.vscodeNotebookCell,fragment:t})}e.$JJ=D;class h{constructor(){this.a=new L.$Ac}getNotebook(p){if(p.scheme===P.Schemas.vscodeNotebookCell){const s=A(p);if(s){const o=this.a.get(s.notebook);if(o)return o}}return this.a.get(p)}addNotebookDocument(p){this.a.set(p.uri,p)}removeNotebookDocument(p){this.a.delete(p.uri)}}e.$KJ=h,(0,F.$0r)(e.$HJ,h,1)}),define(Ae[83],Me([1,0,24,34,68,69,12,19,20,35,239]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3J=e.$2J=e.$1J=e.$ZJ=e.CellStatusbarAlignment=e.$YJ=e.$XJ=e.$WJ=e.NotebookEditorPriority=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.CellKind=e.$NJ=e.$MJ=e.$LJ=void 0,e.$LJ="workbench.editor.notebook",e.$MJ="workbench.editor.notebookTextDiffEditor",e.$NJ="workbench.editor.interactive";var D;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(D||(e.CellKind=D={})),e.$OJ=["application/json","application/javascript","text/html","image/svg+xml",F.$qs.latex,F.$qs.markdown,"image/png","image/jpeg",F.$qs.text],e.$PJ=[F.$qs.latex,F.$qs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$qs.text],e.$QJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$RJ="_notAvailable";var h;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(h||(e.NotebookRunState=h={}));var v;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var p;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var s;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var o;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var t;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var n;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var r;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var u;(function(V){V.scheme=R.Schemas.vscodeNotebookCell;function re(se,$e){return(0,A.$JJ)(se,$e)}V.generate=re;function ce(se){return(0,A.$IJ)(se)}V.parse=ce;function ye(se,$e){return se.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${se.scheme!==R.Schemas.file?se.scheme:""}`})}V.generateCellOutputUri=ye;function De(se){if(se.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!$e)return;const ee=$e[1]&&$e[1]!==""?$e[1]:void 0,Y=$e[2];return{outputId:ee,notebook:se.with({scheme:Y||R.Schemas.file,fragment:null})}}V.parseCellOutputUri=De;function he(se,$e,ee){return V.generate(se,$e).with({scheme:ee})}V.generateCellPropertyUri=he;function ve(se,$e){if(se.scheme===$e)return V.parse(se.with({scheme:V.scheme}))}V.parseCellPropertyUri=ve})(u||(e.CellUri=u={}));const l=V=>f.$i?V.replace(/\//g,"\\"):V;class i{constructor(re=[],ce=e.$OJ){this.e=ce,this.d=[...new Set(re)].map(ye=>({pattern:ye,matches:L.$Xj(l(ye))}))}sort(re){const ce=new Map(P.Iterable.map(re,De=>[De,l(De)]));let ye=[];for(const{matches:De}of this.d)for(const[he,ve]of ce)if(De(ve)){ye.push(he),ce.delete(he);break}return ce.size&&(ye=ye.concat([...ce.keys()].sort((De,he)=>this.e.indexOf(De)-this.e.indexOf(he)))),ye}prioritize(re,ce){const ye=this.f(re);if(ye===-1){this.d.unshift({pattern:re,matches:L.$Xj(l(re))});return}const De=new Set(ce.map(ve=>this.f(ve,ye)));De.delete(-1);const he=Array.from(De).sort();this.d.splice(ye+1,0,...he.map(ve=>this.d[ve]));for(let ve=he.length-1;ve>=0;ve--)this.d.splice(he[ve],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,ce=this.d.length){const ye=l(re);for(let De=0;De<ce;De++)if(this.d[De].matches(ye))return De;return-1}}e.$SJ=i;function $(V,re,ce,ye=(De,he)=>De===he){const De=[];function he($e,ee,Y){if(ee===0&&Y.length===0)return;const q=De[De.length-1];q&&q.start+q.deleteCount===$e?(q.deleteCount+=ee,q.toInsert.push(...Y)):De.push({start:$e,deleteCount:ee,toInsert:Y})}let ve=0,se=0;for(;;){if(ve===V.length){he(ve,0,re.slice(se));break}if(se===re.length){he(ve,V.length-ve,[]);break}const $e=V[ve],ee=re[se];if(ye($e,ee)){ve+=1,se+=1;continue}ce(ee)?(he(ve,1,[]),ve+=1):(he(ve,0,[ee]),se+=1)}return De}e.$TJ=$,e.$UJ=new k.$vj("notebookEditorCursorAtBoundary","none"),e.$VJ=new k.$vj("notebookEditorCursorAtLineBoundary","none");var a;(function(V){V.default="default",V.option="option"})(a||(e.NotebookEditorPriority=a={}));function c(V){const re=V;return!!((typeof re.include=="string"||L.$Yj(re.include))&&(typeof re.exclude=="string"||L.$Yj(re.exclude)))}e.$WJ=c;function E(V,re,ce){if(Array.isArray(V.viewType)&&V.viewType.indexOf(re)>=0||V.viewType===re)return!0;if(V.filenamePattern){const ye=c(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,De=c(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(L.$Wj(ye,(0,g.$nc)(ce.fsPath).toLowerCase()))return!(De&&L.$Wj(De,(0,g.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$XJ=E,e.$YJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var y;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class m{static{this.d="notebook/"}static create(re){return`${m.d}${re}`}static parse(re){if(re.startsWith(m.d))return re.substring(m.d.length)}}e.$ZJ=m;function I(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}e.$1J=I;const d=new TextDecoder;function w(V){const re=[];let ce=!1;for(const ve of V)(re.length===0||ce)&&(re.push(ve),ce=!0);let ye=T(re);const De=S.$se.concat(re.map(ve=>S.$se.wrap(ve))),he=O(De);return ye=ye||he.byteLength!==De.byteLength,{data:he,didCompression:ye}}e.$2J=w,e.$3J="\x1B[A";const b=e.$3J.split("").map(V=>V.charCodeAt(0)),M=10;function T(V){let re=!1;return V.forEach((ce,ye)=>{if(ye===0||ce.length<e.$3J.length)return;const De=V[ye-1],he=ce.subarray(0,e.$3J.length);if(he[0]===b[0]&&he[1]===b[1]&&he[2]===b[2]){const ve=De.lastIndexOf(M);if(ve===-1)return;re=!0,V[ye-1]=De.subarray(0,ve),V[ye]=ce.subarray(e.$3J.length)}}),re}function G(V){let re=V;do V=re,re=V.replace(/[^\n]\x08/gm,"");while(re.length<V.length);return V}function W(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const re=V.match(/^(.*)\r+/m)[1];let ce=V.match(/\r+(.*)$/m)[1];ce=ce+re.slice(ce.length,re.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return V}const U=8,C=13;function O(V){return!V.buffer.includes(U)&&!V.buffer.includes(C)?V:S.$se.fromString(W(G(d.decode(V.buffer))))}}),define(Ae[7],Me([1,0,18,15,46,28,69,13,16,2,33,22,42,100,83]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p){"use strict";var s,o,t,n,r,u,l,i,$,a,c,E,y,m,I,d,w;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$5N=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.ChatAgentResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$RN=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.TestRunProfileKind=e.TestResultState=e.$xN=e.$wN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$vN=e.NotebookVariablesRequestKind=e.$uN=e.$tN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$sN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.ColorThemeKind=e.$mN=e.$lN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$kN=e.$jN=e.DebugConsoleMode=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$dN=e.$cN=e.FileChangeType=e.$bN=e.NewSymbolNameTag=e.$aN=e.$_M=e.$$M=e.$0M=e.InlineCompletionTriggerKind=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.ConfigurationTarget=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$MM=e.ViewBadge=e.ProgressLocation=e.$LM=e.$KM=e.TaskScope=e.ShellQuoting=e.$JM=e.$IM=e.$HM=e.TaskPanelKind=e.TaskRevealKind=e.$GM=e.TerminalLocation=e.$FM=e.$EM=e.$DM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$CM=e.$BM=e.$AM=e.$zM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$yM=e.StatusBarAlignment=e.ViewColumn=e.$xM=e.$wM=e.$vM=e.$uM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$tM=e.$sM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.LanguageStatusSeverity=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.CodeActionTriggerKind=e.$gM=e.$fM=e.SymbolTag=e.SymbolKind=e.$eM=e.$dM=e.DocumentHighlightKind=e.$cM=e.$bM=e.$aM=e.$_L=e.DiagnosticSeverity=e.DiagnosticTag=e.$$L=e.$0L=e.FileEditType=e.$9L=e.$8L=e.$7L=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function b(B){return Object.assign(B,{apply:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const ke=ie.length===1?[]:ie[1];return Reflect.construct(B,ke,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const[ke,...Je]=ie;return Reflect.construct(B,Je,ke.constructor)}}})}var M;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(M||(e.TerminalOutputAnchor=M={}));var T;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(T||(e.TerminalQuickFixType=T={}));let G=s=class{static from(...z){let ie=z;return new s(function(){if(ie){for(const ke of ie)ke&&typeof ke.dispose=="function"&&ke.dispose();ie=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$ZL=G,e.$ZL=G=s=Xe([b],G);let W=o=class{static Min(...z){if(z.length===0)throw new TypeError;let ie=z[0];for(let ke=1;ke<z.length;ke++){const Je=z[ke];Je.isBefore(ie)&&(ie=Je)}return ie}static Max(...z){if(z.length===0)throw new TypeError;let ie=z[0];for(let ke=1;ke<z.length;ke++){const Je=z[ke];Je.isAfter(ie)&&(ie=Je)}return ie}static isPosition(z){if(!z)return!1;if(z instanceof o)return!0;const{line:ie,character:ke}=z;return typeof ie=="number"&&typeof ke=="number"}static of(z){if(z instanceof o)return z;if(this.isPosition(z))return new o(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ie){if(z<0)throw(0,L.$7)("line must be non-negative");if(ie<0)throw(0,L.$7)("character must be non-negative");this.c=z,this.e=ie}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ie=0){if(z===null||ie===null)throw(0,L.$7)();let ke;return typeof z>"u"?ke=0:typeof z=="number"?ke=z:(ke=typeof z.lineDelta=="number"?z.lineDelta:0,ie=typeof z.characterDelta=="number"?z.characterDelta:0),ke===0&&ie===0?this:new o(this.line+ke,this.character+ie)}with(z,ie=this.character){if(z===null||ie===null)throw(0,L.$7)();let ke;return typeof z>"u"?ke=this.line:typeof z=="number"?ke=z:(ke=typeof z.line=="number"?z.line:this.line,ie=typeof z.character=="number"?z.character:this.character),ke===this.line&&ie===this.character?this:new o(ke,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$1L=W,e.$1L=W=o=Xe([b],W);let U=t=class{static isRange(z){return z instanceof t?!0:z?W.isPosition(z.start)&&W.isPosition(z.end):!1}static of(z){if(z instanceof t)return z;if(this.isRange(z))return new t(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ie,ke,Je){let _e,ut;if(typeof z=="number"&&typeof ie=="number"&&typeof ke=="number"&&typeof Je=="number"?(_e=new W(z,ie),ut=new W(ke,Je)):W.isPosition(z)&&W.isPosition(ie)&&(_e=W.of(z),ut=W.of(ie)),!_e||!ut)throw new Error("Invalid arguments");_e.isBefore(ut)?(this.c=_e,this.e=ut):(this.c=ut,this.e=_e)}contains(z){return t.isRange(z)?this.contains(z.start)&&this.contains(z.end):W.isPosition(z)?!(W.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ie=W.Max(z.start,this.c),ke=W.Min(z.end,this.e);if(!ie.isAfter(ke))return new t(ie,ke)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ie=W.Min(z.start,this.c),ke=W.Max(z.end,this.end);return new t(ie,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ie=this.end){if(z===null||ie===null)throw(0,L.$7)();let ke;return z?W.isPosition(z)?ke=z:(ke=z.start||this.start,ie=z.end||this.end):ke=this.start,ke.isEqual(this.c)&&ie.isEqual(this.end)?this:new t(ke,ie)}toJSON(){return[this.start,this.end]}};e.$2L=U,e.$2L=U=t=Xe([b],U);let C=n=class extends U{static isSelection(z){return z instanceof n?!0:z?U.isRange(z)&&W.isPosition(z.anchor)&&W.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ie,ke,Je){let _e,ut;if(typeof z=="number"&&typeof ie=="number"&&typeof ke=="number"&&typeof Je=="number"?(_e=new W(z,ie),ut=new W(ke,Je)):W.isPosition(z)&&W.isPosition(ie)&&(_e=W.of(z),ut=W.of(ie)),!_e||!ut)throw new Error("Invalid arguments");super(_e,ut),this.f=_e,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$3L=C,e.$3L=C=n=Xe([b],C);const O=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,L.$7)("connectionToken")};class V{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ie,ke){if(typeof z!="string"||z.length===0)throw(0,L.$7)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,L.$7)("port");typeof ke<"u"&&O(ke),this.host=z,this.port=Math.round(ie),this.connectionToken=ke}}e.$4L=V;class re{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ie){this.makeConnection=z,this.connectionToken=ie,typeof ie<"u"&&O(ie)}}e.$5L=re;class ce extends Error{static NotAvailable(z,ie){return new ce(z,v.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(z){return new ce(z,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ie=v.RemoteAuthorityResolverErrorCode.Unknown,ke){super(z),this._message=z,this._code=ie,this._detail=ke,Object.setPrototypeOf(this,ce.prototype)}}e.$6L=ce;var ye;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var De;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(De||(e.EnvironmentVariableMutatorType=De={}));let he=r=class{static isTextEdit(z){return z instanceof r?!0:z?U.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ie){return new r(z,ie)}static insert(z,ie){return r.replace(new U(z,z),ie)}static delete(z){return r.replace(z,"")}static setEndOfLine(z){const ie=new r(new U(new W(0,0),new W(0,0)),"");return ie.newEol=z,ie}get range(){return this.c}set range(z){if(z&&!U.isRange(z))throw(0,L.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,L.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,L.$7)("newEol");this.f=z}constructor(z,ie){this.c=z,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$7L=he,e.$7L=he=r=Xe([b],he);let ve=u=class{static isNotebookCellEdit(z){return z instanceof u?!0:z?di.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ie){return new u(z,ie)}static insertCells(z,ie){return new u(new di(z,z),ie)}static deleteCells(z){return new u(z,[])}static updateCellMetadata(z,ie){const ke=new u(new di(z,z),[]);return ke.newCellMetadata=ie,ke}static updateNotebookMetadata(z){const ie=new u(new di(0,0),[]);return ie.newNotebookMetadata=z,ie}constructor(z,ie){this.range=z,this.newCells=ie}};e.$8L=ve,e.$8L=ve=u=Xe([b],ve);class se{static isSnippetTextEdit(z){return z instanceof se?!0:z?U.isRange(z.range)&&Y.isSnippetString(z.snippet):!1}static replace(z,ie){return new se(z,ie)}static insert(z,ie){return se.replace(new U(z,z),ie)}constructor(z,ie){this.range=z,this.snippet=ie}}e.$9L=se;var $e;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ee=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ie,ke,Je){this.c.push({_type:1,from:z,to:ie,options:ke,metadata:Je})}createFile(z,ie,ke){this.c.push({_type:1,from:void 0,to:z,options:ie,metadata:ke})}deleteFile(z,ie,ke){this.c.push({_type:1,from:z,to:void 0,options:ie,metadata:ke})}e(z,ie,ke){this.c.push({_type:3,metadata:ke,uri:z,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(z,ie,ke,Je){const _e=ie.start,ut=ie.end;(_e!==ut||ke.length>0)&&this.c.push({_type:5,uri:z,index:_e,count:ut-_e,cells:ke,metadata:Je})}g(z,ie,ke,Je){this.c.push({_type:3,metadata:Je,uri:z,edit:{editType:3,index:ie,metadata:ke}})}replace(z,ie,ke,Je){this.c.push({_type:2,uri:z,edit:new he(ie,ke),metadata:Je})}insert(z,ie,ke,Je){this.replace(z,new U(ie,ie),ke,Je)}delete(z,ie,ke){this.replace(z,ie,"",ke)}has(z){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===z.toString())}set(z,ie){if(ie)for(const ke of ie){if(!ke)continue;let Je,_e;Array.isArray(ke)?(Je=ke[0],_e=ke[1]):Je=ke,ve.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(z,Je.range.start,Je.newCellMetadata,_e):Je.newNotebookMetadata?this.e(z,Je.newNotebookMetadata,_e):this.f(z,Je.range,Je.newCells,_e):se.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:z,range:Je.range,edit:Je.snippet,metadata:_e}):this.c.push({_type:2,uri:z,edit:Je,metadata:_e})}else{for(let ke=0;ke<this.c.length;ke++){const Je=this.c[ke];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===z.toString()&&(this.c[ke]=void 0);break}}(0,S.$Ib)(this.c)}}get(z){const ie=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===z.toString()&&ie.push(ke.edit);return ie}entries(){const z=new F.$Ac;for(const ie of this.c)if(ie._type===2){let ke=z.get(ie.uri);ke||(ke=[ie.uri,[]],z.set(ie.uri,ke)),ke[1].push(ie.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$0L=ee,e.$0L=ee=Xe([b],ee);let Y=l=class{static isSnippetString(z){return z instanceof l?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=l.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ie=this.e++){if(typeof z=="function"){const ke=new l;ke.e=this.e,z(ke),this.e=ke.e,z=ke.value}else z=l.c(z);return this.value+="${",this.value+=ie,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ie=this.e++){const ke=z.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(z,ie){if(typeof ie=="function"){const ke=new l;ke.e=this.e,ie(ke),this.e=ke.e,ie=ke.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$$L=Y,e.$$L=Y=l=Xe([b],Y);var q;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var ne;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Se=i=class{static isLocation(z){return z instanceof i?!0:z?U.isRange(z.range)&&k.URI.isUri(z.uri):!1}constructor(z,ie){if(this.uri=z,ie)if(U.isRange(ie))this.range=U.of(ie);else if(W.isPosition(ie))this.range=new U(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$_L=Se,e.$_L=Se=i=Xe([b],Se);let Te=class{static is(z){return z?typeof z.message=="string"&&z.location&&U.isRange(z.location.range)&&k.URI.isUri(z.location.uri):!1}constructor(z,ie){this.location=z,this.message=ie}static isEqual(z,ie){return z===ie?!0:!z||!ie?!1:z.message===ie.message&&z.location.range.isEqual(ie.location.range)&&z.location.uri.toString()===ie.location.uri.toString()}};e.$aM=Te,e.$aM=Te=Xe([b],Te);let Ce=class{constructor(z,ie,ke=ne.Error){if(!U.isRange(z))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=z,this.message=ie,this.severity=ke}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ie){return z===ie?!0:!z||!ie?!1:z.message===ie.message&&z.severity===ie.severity&&z.code===ie.code&&z.severity===ie.severity&&z.source===ie.source&&z.range.isEqual(ie.range)&&(0,S.$ub)(z.tags,ie.tags)&&(0,S.$ub)(z.relatedInformation,ie.relatedInformation,Te.isEqual)}};e.$bM=Ce,e.$bM=Ce=Xe([b],Ce);let be=class{constructor(z,ie){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ie}};e.$cM=be,e.$cM=be=Xe([b],be);var ge;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let X=class{constructor(z,ie=ge.Text){this.range=z,this.kind=ie}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$dM=X,e.$dM=X=Xe([b],X);let x=class{constructor(z,ie){this.uri=z,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$eM=x,e.$eM=x=Xe([b],x);var le;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Pe=$=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ie,ke,Je,_e){this.name=z,this.kind=ie,this.containerName=_e,typeof ke=="string"&&(this.containerName=ke),Je instanceof Se?this.location=Je:ke instanceof U&&(this.location=new Se(Je,ke)),$.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$fM=Pe,e.$fM=Pe=$=Xe([b],Pe);let me=a=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(a.validate)}constructor(z,ie,ke,Je,_e){this.name=z,this.detail=ie,this.kind=ke,this.range=Je,this.selectionRange=_e,this.children=[],a.validate(this)}};e.$gM=me,e.$gM=me=a=Xe([b],me);var Ie;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ie||(e.CodeActionTriggerKind=Ie={}));let Le=class{constructor(z,ie){this.title=z,this.kind=ie}};e.$hM=Le,e.$hM=Le=Xe([b],Le);let ze=class{static{c=this}static{this.c="."}constructor(z){this.value=z}append(z){return new c(this.value?this.value+c.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+c.c)}};e.$iM=ze,e.$iM=ze=c=Xe([b],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let N=class{constructor(z,ie){if(this.range=z,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$jM=N,e.$jM=N=Xe([b],N);class j{constructor(z,ie,ke,Je,_e,ut){this.kind=z,this.name=ie,this.detail=ke,this.uri=Je,this.range=_e,this.selectionRange=ut}}e.$kM=j;class K{constructor(z,ie){this.fromRanges=ie,this.from=z}}e.$lM=K;class H{constructor(z,ie){this.fromRanges=ie,this.to=z}}e.$mM=H;var te;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(te||(e.LanguageStatusSeverity=te={}));let oe=class{constructor(z,ie){this.range=z,this.command=ie}get isResolved(){return!!this.command}};e.$nM=oe,e.$nM=oe=Xe([b],oe);let Oe=E=class{#e;static isMarkdownString(z){return z instanceof E?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ie=!1){this.#e=new P.$sk(z,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,ie){return this.#e.appendCodeblock(ie??"",z),this}};e.$oM=Oe,e.$oM=Oe=E=Xe([b],Oe);let Ve=class{constructor(z,ie){this.label=z,this.documentation=ie}};e.$pM=Ve,e.$pM=Ve=Xe([b],Ve);let He=class{constructor(z,ie){this.label=z,this.documentation=ie,this.parameters=[]}};e.$qM=He,e.$qM=He=Xe([b],He);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$rM=xe,e.$rM=xe=Xe([b],xe);var tt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var lt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(lt||(e.InlayHintKind=lt={}));let rt=class{constructor(z){this.value=z}};e.$sM=rt,e.$sM=rt=Xe([b],rt);let it=class{constructor(z,ie,ke){this.position=z,this.label=ie,this.kind=ke}};e.$tM=it,e.$tM=it=Xe([b],it);var ot;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ot||(e.CompletionTriggerKind=ot={}));var Be;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Be||(e.CompletionItemKind=Be={}));var et;(function(B){B[B.Deprecated=1]="Deprecated"})(et||(e.CompletionItemTag=et={}));let Q=class{constructor(z,ie){this.label=z,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$uM=Q,e.$uM=Q=Xe([b],Q);let Z=class{constructor(z=[],ie=!1){this.items=z,this.isIncomplete=ie}};e.$vM=Z,e.$vM=Z=Xe([b],Z);let pe=class{constructor(z,ie,ke){this.insertText=z,this.range=ie,this.command=ke}};e.$wM=pe,e.$wM=pe=Xe([b],pe);let We=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$xM=We,e.$xM=We=Xe([b],We);var Ye;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Ye||(e.ViewColumn=Ye={}));var st;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function Fe(B,z){return`${D.$wm.toKey(B)}.${z}`}e.$yM=Fe;var St;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(St||(e.TextEditorLineNumbersStyle=St={}));var Kt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var zt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(zt||(e.TextEditorRevealType=zt={}));var Zt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Zt||(e.TextEditorSelectionChangeKind=Zt={}));var Qt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Qt||(e.TextDocumentChangeReason=Qt={}));var It;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(It||(e.DecorationRangeBehavior=It={})),function(B){function z(ie){switch(ie){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(Zt||(e.TextEditorSelectionChangeKind=Zt={}));var Gt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(B){function z(ie){switch(ie){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(Gt||(e.SyntaxTokenType=Gt={}));let Jt=class{constructor(z,ie){if(ie&&!k.URI.isUri(ie))throw(0,L.$7)("target");if(!U.isRange(z)||z.isEmpty)throw(0,L.$7)("range");this.range=z,this.target=ie}};e.$zM=Jt,e.$zM=Jt=Xe([b],Jt);let _t=class{constructor(z,ie,ke,Je){this.red=z,this.green=ie,this.blue=ke,this.alpha=Je}};e.$AM=_t,e.$AM=_t=Xe([b],_t);let ri=class{constructor(z,ie){if(ie&&!(ie instanceof _t))throw(0,L.$7)("color");if(!U.isRange(z)||z.isEmpty)throw(0,L.$7)("range");this.range=z,this.color=ie}};e.$BM=ri,e.$BM=ri=Xe([b],ri);let Qe=class{constructor(z){if(!z||typeof z!="string")throw(0,L.$7)("label");this.label=z}};e.$CM=Qe,e.$CM=Qe=Xe([b],Qe);var jt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(jt||(e.ColorFormat=jt={}));var ei;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(ei||(e.SourceControlInputBoxValidationType=ei={}));var ft;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ft||(e.TerminalExitReason=ft={}));class vt{constructor(z,ie,ke){if(this.startIndex=z,this.length=ie,this.tooltip=ke,typeof z!="number"||z<0)throw(0,L.$7)("startIndex");if(typeof ie!="number"||ie<1)throw(0,L.$7)("length");if(ke!==void 0&&typeof ke!="string")throw(0,L.$7)("tooltip")}}e.$DM=vt;class ti{constructor(z){this.uri=z}}e.$EM=ti;class Wt{constructor(z){this.terminalCommand=z}}e.$FM=Wt;var Ut;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Ut||(e.TerminalLocation=Ut={}));class dt{constructor(z){if(this.options=z,typeof z!="object")throw(0,L.$7)("options")}}e.$GM=dt;var Pt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var ii;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ii||(e.TaskPanelKind=ii={}));let xt=class{static{y=this}static{this.Clean=new y("clean","Clean")}static{this.Build=new y("build","Build")}static{this.Rebuild=new y("rebuild","Rebuild")}static{this.Test=new y("test","Test")}static from(z){switch(z){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(z,ie){if(this.label=ie,typeof z!="string"||typeof ie!="string")throw(0,L.$7)("name");this.c=z}get id(){return this.c}};e.$HM=xt,e.$HM=xt=y=Xe([b],xt);function Ke(B){let z="";for(let ie=0;ie<B.length;ie++)z+=B[ie].replace(/,/g,",,")+",";return z}let At=class{constructor(z,ie,ke){if(typeof z!="string")throw(0,L.$7)("process");this.e=[],this.c=z,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=ke):this.f=ie)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,L.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)z.push(ie);return Ke(z)}};e.$IM=At,e.$IM=At=Xe([b],At);let Bt=class{constructor(z,ie,ke){if(this.f=[],Array.isArray(ie)){if(!z)throw(0,L.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,L.$7)("command");this.e=z,this.f=ie,this.g=ke}else{if(typeof z!="string")throw(0,L.$7)("commandLine");this.c=z,this.g=ie}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,L.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,L.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)z.push(typeof ie=="string"?ie:ie.value);return Ke(z)}};e.$JM=Bt,e.$JM=Bt=Xe([b],Bt);var si;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(si||(e.ShellQuoting=si={}));var gt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Lt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,A.$Ag)()}set callback(z){this.c=z}get callback(){return this.c}}e.$KM=Lt;let Ct=class{static{m=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,ie,ke,Je,_e,ut){this.k=!1,this.l=this.definition=z;let mt;typeof ie=="string"?(this.o=this.name=ie,this.w=this.source=ke,this.execution=Je,mt=_e,this.k=!0):ie===gt.Global||ie===gt.Workspace?(this.target=ie,this.o=this.name=ke,this.w=this.source=Je,this.execution=_e,mt=ut):(this.target=ie,this.o=this.name=ke,this.w=this.source=Je,this.execution=_e,mt=ut),typeof mt=="string"?(this.r=[mt],this.t=!0):Array.isArray(mt)?(this.r=mt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof At?this.l={type:m.e,id:this.q.computeId()}:this.q instanceof Bt?this.l={type:m.f,id:this.q.computeId()}:this.q instanceof Lt?this.l={type:m.c,id:this.q.computeId()}:this.l={type:m.g,id:(0,A.$Ag)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,L.$7)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,L.$7)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const ie=this.l.type;(m.g===ie||m.e===ie||m.f===ie||m.c===ie)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,L.$7)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$LM=Ct,e.$LM=Ct=m=Xe([b],Ct);var Ot;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Ot||(e.ProgressLocation=Ot={}));var ni;(function(B){function z(ie){const ke=ie;return(0,f.$Wf)(ke.value)?ke.tooltip&&!(0,f.$Sf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}B.isViewBadge=z})(ni||(e.ViewBadge=ni={}));let Vt=I=class{static isTreeItem(z,ie){const ke=z;if(ke.checkboxState!==void 0){const Je=(0,f.$Wf)(ke.checkboxState)?ke.checkboxState:(0,f.$Uf)(ke.checkboxState)&&(0,f.$Wf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,_e=!(0,f.$Wf)(ke.checkboxState)&&(0,f.$Uf)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Rt.Checked&&Je!==Rt.Unchecked||_e!==void 0&&!(0,f.$Sf)(_e))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(z instanceof I)return!0;if(ke.label!==void 0&&!(0,f.$Sf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,f.$Sf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,f.$Sf)(ke.iconPath)&&!k.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,f.$Sf)(ke.iconPath.id))){const Je=ke.iconPath;if(!Je||!(0,f.$Sf)(Je.light)&&!k.URI.isUri(Je.light)&&!(0,f.$Sf)(Je.dark)&&!k.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,f.$Sf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!k.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,f.$Sf)(ke.tooltip)&&!(ke.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Tt.None&&ke.collapsibleState>Tt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,f.$Sf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(z,ie=Tt.None){this.collapsibleState=ie,k.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$MM=Vt,e.$MM=Vt=I=Xe([b],Vt);var Tt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Tt||(e.TreeItemCollapsibleState=Tt={}));var Rt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Rt||(e.TreeItemCheckboxState=Rt={}));let Dt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$NM=Dt,e.$NM=Dt=Xe([b],Dt);class $t extends Dt{}e.$OM=$t;class kt extends $t{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$PM=kt;class Et{constructor(z,ie,ke,Je){this.name=z,this.uri=ie,this._itemId=ke,this.c=Je}data(){return this.c()}}e.$QM=Et;let ci=class{#e=new Map;constructor(z){for(const[ie,ke]of z??[]){const Je=this.#e.get(this.#t(ie));Je?Je.push(ke):this.#e.set(this.#t(ie),[ke])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,ie){this.#e.set(this.#t(z),[ie])}forEach(z,ie){for(const[ke,Je]of this.#e)for(const _e of Je)z.call(ie,_e,ke,this)}*[Symbol.iterator](){for(const[z,ie]of this.#e)for(const ke of ie)yield[z,ke]}#t(z){return z.toLowerCase()}};e.$RM=ci,e.$RM=ci=Xe([b],ci);let Xt=class{constructor(z){this.insertText=z}};e.$SM=Xt,e.$SM=Xt=Xe([b],Xt);let pi=class{constructor(z,ie){this.label=ie,this.insertText=z}};e.$TM=pi,e.$TM=pi=Xe([b],pi);let qt=class{constructor(z,ie){this.id=z,this.color=ie}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$UM=qt,e.$UM=qt=Xe([b],qt),qt.File=new qt("file"),qt.Folder=new qt("folder");let we=class{constructor(z){this.id=z}};e.$VM=we,e.$VM=we=Xe([b],we);var Re;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Re||(e.ConfigurationTarget=Re={}));let ue=class{get base(){return this.c}set base(z){this.c=z,this.e=k.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ie){if(typeof z!="string"&&(!z||!k.URI.isUri(z)&&!k.URI.isUri(z.uri)))throw(0,L.$7)("base");if(typeof ie!="string")throw(0,L.$7)("pattern");typeof z=="string"?this.baseUri=k.URI.file(z):k.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$WM=ue,e.$WM=ue=Xe([b],ue);const J=new WeakMap;function Ee(B,z){J.set(B,z)}e.$XM=Ee;let Ue=class{constructor(z,ie,ke,Je,_e){this.enabled=typeof z=="boolean"?z:!0,typeof ie=="string"&&(this.condition=ie),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=J.get(this)??(0,A.$Ag)()),this.c}};e.$YM=Ue,e.$YM=Ue=Xe([b],Ue);let Ze=class extends Ue{constructor(z,ie,ke,Je,_e,ut){if(super(ie,ke,Je,_e,ut),z===null)throw(0,L.$7)("location");this.location=z}};e.$ZM=Ze,e.$ZM=Ze=Xe([b],Ze);let Ge=class extends Ue{constructor(z,ie,ke,Je,_e,ut){super(ie,ke,Je,_e,ut),this.functionName=z}};e.$1M=Ge,e.$1M=Ge=Xe([b],Ge);let ct=class extends Ue{constructor(z,ie,ke,Je,_e,ut,mt,Ht){if(super(Je,_e,ut,mt,Ht),!ie)throw(0,L.$7)("dataId");this.label=z,this.dataId=ie,this.canPersist=ke}};e.$2M=ct,e.$2M=ct=Xe([b],ct);let wt=class{constructor(z,ie,ke){this.command=z,this.args=ie||[],this.options=ke}};e.$3M=wt,e.$3M=wt=Xe([b],wt);let yt=class{constructor(z,ie){this.port=z,this.host=ie}};e.$4M=yt,e.$4M=yt=Xe([b],yt);let Yt=class{constructor(z){this.path=z}};e.$5M=Yt,e.$5M=Yt=Xe([b],Yt);let Mt=class{constructor(z){this.implementation=z}};e.$6M=Mt,e.$6M=Mt=Xe([b],Mt);let Nt=class{constructor(z,ie,ke){this.session=z,this.threadId=ie,this.frameId=ke}};e.$7M=Nt,e.$7M=Nt=Xe([b],Nt);let vi=class{constructor(z,ie){this.session=z,this.threadId=ie}};e.$8M=vi,e.$8M=vi=Xe([b],vi);let ht=class{constructor(z,ie){this.range=z,this.expression=ie}};e.$9M=ht,e.$9M=ht=Xe([b],ht);var Zi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Zi||(e.InlineCompletionTriggerKind=Zi={}));let ui=class{constructor(z,ie){this.range=z,this.text=ie}};e.$0M=ui,e.$0M=ui=Xe([b],ui);let gi=class{constructor(z,ie,ke=!0){this.range=z,this.variableName=ie,this.caseSensitiveLookup=ke}};e.$$M=gi,e.$$M=gi=Xe([b],gi);let yi=class{constructor(z,ie){this.range=z,this.expression=ie}};e.$_M=yi,e.$_M=yi=Xe([b],yi);let Ri=class{constructor(z,ie){this.frameId=z,this.stoppedLocation=ie}};e.$aN=Ri,e.$aN=Ri=Xe([b],Ri);var Qi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Qi||(e.NewSymbolNameTag=Qi={}));class hn{constructor(z,ie){this.newSymbolName=z,this.tags=ie}}e.$bN=hn;var Ai;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ai||(e.FileChangeType=Ai={}));let Mi=d=class extends Error{static FileExists(z){return new d(z,h.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(z){return new d(z,h.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(z){return new d(z,h.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(z){return new d(z,h.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(z){return new d(z,h.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(z){return new d(z,h.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}constructor(z,ie=h.FileSystemProviderErrorCode.Unknown,ke){super(k.URI.isUri(z)?z.toString(!0):z),this.code=ke?.name??"Unknown",(0,h.$Qk)(this,ie),Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$cN=Mi,e.$cN=Mi=d=Xe([b],Mi);let Ei=class{constructor(z,ie,ke){this.start=z,this.end=ie,this.kind=ke}};e.$dN=Ei,e.$dN=Ei=Xe([b],Ei);var mi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(mi||(e.FoldingRangeKind=mi={}));var xi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Di;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Di||(e.CommentMode=Di={}));var ki;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(ki||(e.CommentState=ki={}));var _i;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class dn{constructor(z,ie=[]){this.tokenTypes=z,this.tokenModifiers=ie}}e.$eN=dn;function bi(B){return typeof B>"u"||(0,f.$Tf)(B)}class Li{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ie=0,ke=z.tokenTypes.length;ie<ke;ie++)this.k.set(z.tokenTypes[ie],ie);for(let ie=0,ke=z.tokenModifiers.length;ie<ke;ie++)this.l.set(z.tokenModifiers[ie],ie)}}push(z,ie,ke,Je,_e){if(typeof z=="number"&&typeof ie=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(z,ie,ke,Je,_e);if(U.isRange(z)&&typeof ie=="string"&&bi(ke))return this.o(z,ie,ke);throw(0,L.$7)()}o(z,ie,ke){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ie))throw new Error("`tokenType` is not in the provided legend");const Je=z.start.line,_e=z.start.character,ut=z.end.character-z.start.character,mt=this.k.get(ie);let Ht=0;if(ke)for(const ai of ke){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const hi=this.l.get(ai);Ht|=1<<hi>>>0}this.q(Je,_e,ut,mt,Ht)}q(z,ie,ke,Je,_e){if(this.f&&(z<this.c||z===this.c&&ie<this.e)){this.f=!1;const Ht=this.g.length/5|0;let ai=0,hi=0;for(let fi=0;fi<Ht;fi++){let $i=this.g[5*fi],Xi=this.g[5*fi+1];$i===0?($i=ai,Xi+=hi):$i+=ai,this.g[5*fi]=$i,this.g[5*fi+1]=Xi,ai=$i,hi=Xi}}let ut=z,mt=ie;this.f&&this.j>0&&(ut-=this.c,ut===0&&(mt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=mt,this.g[this.j++]=ke,this.g[this.j++]=Je,this.g[this.j++]=_e,this.c=z,this.e=ie}static r(z){const ie=[],ke=z.length/5|0;for(let mt=0;mt<ke;mt++)ie[mt]=mt;ie.sort((mt,Ht)=>{const ai=z[5*mt],hi=z[5*Ht];if(ai===hi){const fi=z[5*mt+1],$i=z[5*Ht+1];return fi-$i}return ai-hi});const Je=new Uint32Array(z.length);let _e=0,ut=0;for(let mt=0;mt<ke;mt++){const Ht=5*ie[mt],ai=z[Ht+0],hi=z[Ht+1],fi=z[Ht+2],$i=z[Ht+3],Xi=z[Ht+4],Pn=ai-_e,_n=Pn===0?hi-ut:hi,Yi=5*mt;Je[Yi+0]=Pn,Je[Yi+1]=_n,Je[Yi+2]=fi,Je[Yi+3]=$i,Je[Yi+4]=Xi,_e=ai,ut=hi}return Je}build(z){return this.f?new Fi(new Uint32Array(this.g),z):new Fi(Li.r(this.g),z)}}e.$fN=Li;class Fi{constructor(z,ie){this.resultId=ie,this.data=z}}e.$gN=Fi;class fn{constructor(z,ie,ke){this.start=z,this.deleteCount=ie,this.data=ke}}e.$hN=fn;class Si{constructor(z,ie){this.resultId=ie,this.edits=z}}e.$iN=Si;var en;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));class gn{constructor(z){this.name=z}}e.$jN=gn;let wi=class{static{this.Back={iconPath:new qt("arrow-left")}}constructor(){}};e.$kN=wi,e.$kN=wi=Xe([b],wi);var Oi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Oi||(e.QuickPickItemKind=Oi={}));var tn;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var Ti;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Ti||(e.ExtensionKind=Ti={}));class nn{static validate(z){if(typeof z.badge=="string"){let ie=(0,g.$tf)(z.badge,0);if(ie<z.badge.length&&(ie+=(0,g.$tf)(z.badge,ie)),z.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!qt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ie,ke){this.badge=z,this.tooltip=ie,this.color=ke}}e.$lN=nn;let Ni=class{constructor(z){this.kind=z}};e.$mN=Ni,e.$mN=Ni=Xe([b],Ni);var rn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class di{static isNotebookRange(z){return z instanceof di?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ie){if(z<0)throw(0,L.$7)("start must be positive");if(ie<0)throw(0,L.$7)("end must be positive");z<=ie?(this.c=z,this.e=ie):(this.c=ie,this.e=z)}with(z){let ie=this.c,ke=this.e;return z.start!==void 0&&(ie=z.start),z.end!==void 0&&(ke=z.end),ie===this.c&&ke===this.e?this:new di(ie,ke)}}e.$nN=di;class Ii{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ie=>Ii.isNotebookCellData(ie))}static isNotebookCellData(z){return!0}constructor(z,ie,ke,Je,_e,ut,mt){this.kind=z,this.value=ie,this.languageId=ke,this.mime=Je,this.outputs=_e??[],this.metadata=ut,this.executionSummary=mt,Ii.validate(this)}}e.$oN=Ii;class zi{constructor(z){this.cells=z}}e.$pN=zi;class oi{static isNotebookCellOutputItem(z){return z instanceof oi?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ie={name:z.name,message:z.message,stack:z.stack};return oi.json(ie,"application/vnd.code.notebook.error")}static stdout(z){return oi.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return oi.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ie="application/octet-stream"){return new oi(z,ie)}static#e=new TextEncoder;static text(z,ie=R.$qs.text){const ke=oi.#e.encode(String(z));return new oi(ke,ie)}static json(z,ie="text/x-json"){const ke=JSON.stringify(z,void 0,"	");return oi.text(ke,ie)}constructor(z,ie){this.data=z,this.mime=ie;const ke=(0,R.$us)(ie,!0);if(!ke)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$qN=oi;class Ne{static isNotebookCellOutput(z){return z instanceof Ne?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ie=!1){const ke=new Set,Je=new Set;for(let _e=0;_e<z.length;_e++){const ut=z[_e],mt=(0,R.$us)(ut.mime);if(!ke.has(mt)||(0,p.$1J)(mt)){ke.add(mt);continue}Je.add(_e),ie&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Je.size===0?z:z.filter((_e,ut)=>!Je.has(ut))}constructor(z,ie,ke){this.items=Ne.ensureUniqueMimeTypes(z,!0),typeof ie=="string"?(this.id=ie,this.metadata=ke):(this.id=(0,A.$Ag)(),this.metadata=ie??ke)}}e.$rN=Ne;var li;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(li||(e.NotebookCellKind=li={}));var ji;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(ji||(e.NotebookCellExecutionState=ji={}));var nt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(nt||(e.NotebookCellStatusBarAlignment=nt={}));var pt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(pt||(e.NotebookEditorRevealType=pt={}));class mn{constructor(z,ie){this.text=z,this.alignment=ie}}e.$sN=mn;var sn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var Ui;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(Ui||(e.NotebookControllerAffinity2=Ui={}));class $n{constructor(z,ie=[]){this.uri=z,this.provides=(0,S.$3b)(ie)}}e.$tN=$n;class Ci{constructor(z){this.label=z}}e.$uN=Ci;var on;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(on||(e.NotebookVariablesRequestKind=on={}));let Bi=class{constructor(z,ie){this.label=z,this.timestamp=ie}};e.$vN=Bi,e.$vN=Bi=Xe([b],Bi);var an;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Vi;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Vi||(e.ExtensionRuntime=Vi={}));var cn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class pn{constructor(z,ie){this.ranges=z,this.wordPattern=ie}}e.$wN=pn;class vn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$xN=vn;var un;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let Wi=class{constructor(z=void 0,ie=void 0,ke=void 0,Je=!1){this.include=z,this.exclude=ie,this.profile=ke,this.continuous=Je}};e.$yN=Wi,e.$yN=Wi=Xe([b],Wi);let qi=w=class{static diff(z,ie,ke){const Je=new w(z);return Je.expectedOutput=ie,Je.actualOutput=ke,Je}constructor(z){this.message=z}};e.$zN=qi,e.$zN=qi=w=Xe([b],qi);let Hi=class{constructor(z){this.id=z}};e.$AN=Hi,e.$AN=Hi=Xe([b],Hi);class Pi{constructor(z,ie){this.covered=z,this.total=ie}}e.$BN=Pi;const Ki=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class Gi{static fromDetails(z,ie){const ke=new Pi(0,0),Je=new Pi(0,0),_e=new Pi(0,0);for(const mt of ie)if("branches"in mt){ke.total+=1,ke.covered+=mt.executed?1:0;for(const Ht of mt.branches)Je.total+=1,Je.covered+=Ht.executed?1:0}else _e.total+=1,_e.covered+=mt.executed?1:0;const ut=new Gi(z,ke,Je.total>0?Je:void 0,_e.total>0?_e:void 0);return ut.detailedCoverage=ie,ut}constructor(z,ie,ke,Je){this.uri=z,this.statementCoverage=ie,this.branchCoverage=ke,this.declarationCoverage=Je,Ki(ie),Ki(ke),Ki(Je)}}e.$CN=Gi;class _{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ie,ke=[]){this.executed=z,this.location=ie,this.branches=ke}}e.$DN=_;class ae{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ie,ke){this.executed=z,this.location=ie,this.label=ke}}e.$EN=ae;class je{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ie,ke){this.name=z,this.executed=ie,this.location=ke}}e.$FN=je;var at;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(at||(e.ExternalUriOpenerPriority=at={}));var bt;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(bt||(e.WorkspaceTrustState=bt={}));var Ft;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ft||(e.PortAutoForwardAction=Ft={}));class Ji{constructor(z,ie,ke,Je,_e,ut){this.kind=z,this.name=ie,this.detail=ke,this.uri=Je,this.range=_e,this.selectionRange=ut}}e.$GN=Ji;class Rn{constructor(z){this.uri=z}}e.$HN=Rn;class An{constructor(z,ie){this.original=z,this.modified=ie}}e.$IN=An;class Mn{constructor(z,ie,ke,Je){this.base=z,this.input1=ie,this.input2=ke,this.result=Je}}e.$JN=Mn;class Ln{constructor(z,ie){this.uri=z,this.viewType=ie}}e.$KN=Ln;class Fn{constructor(z){this.viewType=z}}e.$LN=Fn;class On{constructor(z,ie){this.uri=z,this.notebookType=ie}}e.$MN=On;class Tn{constructor(z,ie,ke){this.original=z,this.modified=ie,this.notebookType=ke}}e.$NN=Tn;class Nn{constructor(){}}e.$ON=Nn;class zn{constructor(z,ie){this.uri=z,this.inputBoxUri=ie}}e.$PN=zn;class jn{constructor(z){this.providerId=z}}e.$QN=jn;var bn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(wn||(e.ChatAgentCopyKind=wn={}));var yn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Un{constructor(z,ie){this.label=z,this.values=ie}}e.$RN=Un;var En;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(En||(e.InteractiveEditorResponseFeedbackKind=En={}));var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Dn||(e.ChatAgentResultFeedbackKind=Dn={}));class Bn{constructor(z){this.value=z}}e.$SN=Bn;class Vn{constructor(z){this.value=typeof z=="string"?new Oe(z):z}}e.$TN=Vn;class Wn{constructor(z,ie){this.value=z,this.baseUri=ie}}e.$UN=Wn;class qn{constructor(z,ie){this.value=z,this.title=ie}}e.$VN=qn;class Hn{constructor(z){this.value=z}}e.$WN=Hn;class Kn{constructor(z){this.value=z}}e.$XN=Kn;class Gn{constructor(z){this.value=z}}e.$YN=Gn;class Jn{constructor(z,ie,ke,Je){this.prompt=z,this.command=ie,this.variables=ke,this.agent=Je}}e.$ZN=Jn;class Xn{constructor(z,ie,ke){this.response=z,this.result=ie,this.agent=ke}}e.$1N=Xn;class Yn{constructor(z){this.content=z}}e.$2N=Yn;class Zn{constructor(z,ie){this.content=z,this.name=ie}}e.$3N=Zn;class Qn{constructor(z){this.content=z}}e.$4N=Qn;var kn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}));var In;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(In||(e.KeywordRecognitionStatus=In={}));class xn{constructor(z,ie){this.text=z,this.range=ie}}e.$5N=xn;var Cn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Cn||(e.InlineEditTriggerKind=Cn={}))}),define(Ae[240],Me([1,0,3,7]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$XL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,g,f){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(R);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(g,f)??[]}getRelatedInformation(R,g,f){return this.c.$getAiRelatedInformation(g,f)}registerRelatedInformationProvider(R,g,f){const k=this.b;return this.b++,this.a.set(k,f),this.c.$registerAiRelatedInformationProvider(k,g),new L.$ZL(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$shc=P}),define(Ae[241],Me([1,0,5,3,7,22,104]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class g{constructor(A){this.b=new Map,this.c=new S.$5d,this.onDidChangeSessions=this.c.event,this.d=new f,this.f=new f,this.a=A.getProxy(L.$XL.MainThreadAuthentication)}async getSession(A,D,h,v={}){const p=F.$wm.toKey(A.identifier),s=[...h].sort().join(" ");return await this.d.getOrCreate(`${p} ${D} ${s}`,async()=>{await this.a.$ensureProvider(D);const o=A.displayName||A.name;return this.a.$getSession(D,h,p,o,v)})}async getSessions(A,D,h){const v=F.$wm.toKey(A.identifier),p=[...h].sort().join(" ");return await this.f.getOrCreate(`${v} ${p}`,async()=>{await this.a.$ensureProvider(D);const s=A.displayName||A.name;return this.a.$getSessions(D,h,v,s)})}async removeSession(A,D){const h=this.b.get(A);return h?h.provider.removeSession(D):this.a.$removeSession(A,D)}registerAuthenticationProvider(A,D,h,v){if(this.b.get(A))throw new Error(`An authentication provider with id '${A}' is already registered.`);this.b.set(A,{label:D,provider:h,options:v??{supportsMultipleAccounts:!1}});const p=h.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(A,s));return this.a.$registerAuthenticationProvider(A,D,v?.supportsMultipleAccounts??!1),new P.$ZL(()=>{p.dispose(),this.b.delete(A),this.a.$unregisterAuthenticationProvider(A)})}$createSession(A,D,h){const v=this.b.get(A);if(v)return Promise.resolve(v.provider.createSession(D,h));throw new Error(`Unable to find authentication provider with handle: ${A}`)}$removeSession(A,D){const h=this.b.get(A);if(h)return Promise.resolve(h.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${A}`)}$getSessions(A,D){const h=this.b.get(A);if(h)return Promise.resolve(h.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${A}`)}$onDidChangeAuthenticationSessions(A,D){return A.startsWith(R.$4K)||this.c.fire({provider:{id:A,label:D}}),Promise.resolve()}}e.$Dhc=g;class f{constructor(){this.a=new Map}getOrCreate(A,D){const h=this.a.get(A);if(h)return h;const v=D().finally(()=>this.a.delete(A));return this.a.set(A,v),v}}}),define(Ae[108],Me([1,0,2,3,7,4,17,14,18,13,19,23]),function(fe,e,S,L,P,F,R,g,f,k,A,D){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=e.$Cic=void 0;let v=class{static{h=this}static{this.c=0}static{this.d=250}constructor(s,o){this.h=o,this.f=new Map,this.g=s.getProxy(L.$XL.MainThreadDecorations)}registerFileDecorationProvider(s,o){const t=h.c++;this.f.set(t,{provider:s,extensionDescription:o}),this.g.$registerDecorationProvider(t,o.identifier.value);const n=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(r=>{if(!r){this.g.$onDidChange(t,null);return}const u=(0,f.$3b)(r);if(u.length<=h.d){this.g.$onDidChange(t,u);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,u.length);const l=u.map(a=>({uri:a,rank:(0,k.$Ye)(a.path,"/")})),i=(0,f.$zb)(l,(a,c)=>a.rank-c.rank||(0,k.$cf)(a.uri.path,c.uri.path)),$=[];e:for(const a of i){let c;for(const E of a){const y=(0,A.$mc)(E.uri.path);if(c!==y&&(c=y,$.push(E.uri)>=h.d))break e}}this.g.$onDidChange(t,$)});return new P.$ZL(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(s,o,t){if(!this.f.has(s))return Object.create(null);const n=Object.create(null),{provider:r,extensionDescription:u}=this.f.get(s);return await Promise.all(o.map(async l=>{try{const{uri:i,id:$}=l,a=await Promise.resolve(r.provideFileDecoration(S.URI.revive(i),t));if(!a)return;try{P.$lN.validate(a),a.badge&&typeof a.badge!="string"&&(0,D.$VF)(u,"codiconDecoration"),n[$]=[a.propagate,a.tooltip,a.badge,a.color]}catch(c){this.h.warn(`INVALID decoration from extension '${u.identifier.value}': ${c}`)}}catch(i){this.h.error(i)}})),n}};e.$Cic=v,e.$Cic=v=h=Xe([qe(0,R.$dO),qe(1,g.$yj)],v),e.$Dic=(0,F.$ei)("IExtHostDecorations")}),define(Ae[242],Me([1,0,15,2,7,3,12,21,13]),function(fe,e,S,L,P,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=void 0;class k{static{this.a=0}constructor(D,h,v){this.d=h,this.e=v,this.b=new Map,this.c=D.getProxy(F.$XL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,h){if(Object.keys(R.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const v=k.a++;this.b.set(v,h),this.c.$registerTextContentProvider(v,D);let p;if(typeof h.onDidChange=="function"){let s;p=h.onDidChange(async o=>{if(o.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;s&&await s;const t=this.$provideTextDocumentContent(v,o).then(async n=>{if(!n&&typeof n!="string")return;const r=this.d.getDocument(o);if(!r)return;const u=(0,f.$9e)(n);if(!r.equalLines(u))return this.c.$onVirtualDocumentChange(o,n)}).catch(S.$1).finally(()=>{s===t&&(s=void 0)});s=t})}return new P.$ZL(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(D,h){const v=this.b.get(D);return v?Promise.resolve(v.provideTextDocumentContent(L.URI.revive(h),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.$Fic=k}),define(Ae[109],Me([1,0,54,12,13,298,148,7,18]),function(fe,e,S,L,P,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hO=e.$gO=e.$fO=void 0;const k=new Map;function A(p,s){s?k.set(p,s):k.delete(p)}e.$fO=A;function D(p){return k.get(p)}class h extends F.$xv{constructor(s,o,t,n,r,u,l){super(o,t,n,r),this.c=s,this.m=u,this.q=l,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,f.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===L.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(o){return o?s.s(o):s.getText()},get eol(){return s.g===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(o){return s.t(o)},offsetAt(o){return s.u(o)},positionAt(o){return s.v(o)},validateRange(o){return s.w(o)},validatePosition(o){return s.x(o)},getWordRangeAtPosition(o,t){return s.y(o,t)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,S.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,S.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const o=this.w(s);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const t=this.g,n=o.start.line,r=o.end.line,u=[];u.push(this.f[n].substring(o.start.character));for(let l=n+1;l<r;l++)u.push(this.f[l]);return u.push(this.f[r].substring(0,o.end.character)),u.join(t)}t(s){let o;if(s instanceof g.$1L?o=s.line:typeof s=="number"&&(o=s),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new v(o,this.f[o],o===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const o=this.j.getIndexOf(s),t=this.f[o.index].length;return new g.$1L(o.index,Math.min(o.remainder,t))}w(s){if(!(s instanceof g.$2L))throw new Error("Invalid argument");const o=this.x(s.start),t=this.x(s.end);return o===s.start&&t===s.end?s:new g.$2L(o.line,o.character,t.line,t.character)}x(s){if(!(s instanceof g.$1L))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:o,character:t}=s,n=!1;if(o<0)o=0,t=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,t=this.f[o].length,n=!0;else{const r=this.f[o].length;t<0?(t=0,n=!0):t>r&&(t=r,n=!0)}return n?new g.$1L(o,t):s}y(s,o){const t=this.x(s);if(!o)o=D(this.m);else if((0,P.$8e)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,R.$Is)(t.character+1,(0,R.$Gs)(o),this.f[t.line],0);if(n)return new g.$2L(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.$gO=h;class v{constructor(s,o,t){this.a=s,this.b=o,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new g.$2L(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new g.$2L(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$hO=v}),define(Ae[243],Me([1,0,3,7]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$XL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,g,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(R);if(!k)throw new Error("Embedding vector provider not found");const A=await k.provideEmbeddingVector(g,f);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,g,f){const k=this.b;return this.b++,this.a.set(k,f),this.c.$registerAiEmbeddingVectorProvider(g,k),new L.$ZL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$Hic=P}),define(Ae[62],Me([1,0,3,42,7,24,4,17,43,6,11,25,12]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=e.$Uhc=void 0;let p=v=class{constructor(o,t){this.b=new Map,this.c=new A.$nh,this.a=o.getProxy(S.$XL.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(r){try{let u;const l=n.b.get(r.scheme);return l?(await n.a.$ensureActivation(r.scheme),u=await l.impl.stat(r)):u=await n.a.$stat(r),{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===L.FilePermission.Readonly?1:void 0}}catch(u){v.e(u)}},async readDirectory(r){try{const u=n.b.get(r.scheme);return u?(await n.a.$ensureActivation(r.scheme),(await u.impl.readDirectory(r)).slice()):await n.a.$readdir(r)}catch(u){return v.e(u)}},async createDirectory(r){try{const u=n.b.get(r.scheme);return u&&!u.isReadonly?(await n.a.$ensureActivation(r.scheme),await n.d(u.impl,u.extUri,r)):await n.a.$mkdir(r)}catch(u){return v.e(u)}},async readFile(r){try{const u=n.b.get(r.scheme);return u?(await n.a.$ensureActivation(r.scheme),(await u.impl.readFile(r)).slice()):(await n.a.$readFile(r)).buffer}catch(u){return v.e(u)}},async writeFile(r,u){try{const l=n.b.get(r.scheme);return l&&!l.isReadonly?(await n.a.$ensureActivation(r.scheme),await n.d(l.impl,l.extUri,l.extUri.dirname(r)),await n.c.queueFor(r,()=>Promise.resolve(l.impl.writeFile(r,u,{create:!0,overwrite:!0})))):await n.a.$writeFile(r,F.$se.wrap(u))}catch(l){return v.e(l)}},async delete(r,u){try{const l=n.b.get(r.scheme);return l&&!l.isReadonly&&!u?.useTrash?(await n.a.$ensureActivation(r.scheme),await l.impl.delete(r,{recursive:!1,...u})):await n.a.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...u})}catch(l){return v.e(l)}},async rename(r,u,l){try{return await n.a.$rename(r,u,{overwrite:!1,...l})}catch(i){return v.e(i)}},async copy(r,u,l){try{return await n.a.$copy(r,u,{overwrite:!1,...l})}catch(i){return v.e(i)}},isWritableFileSystem(r){const u=t.getCapabilities(r);if(typeof u=="number")return!(u&2048)}})}async d(o,t,n){const r=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&L.FileType.Directory))throw P.$cN.FileExists(`Unable to create folder '${n.scheme===h.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(u){if(L.$Rk(u)!==L.FileSystemProviderErrorCode.FileNotFound)throw u;r.push(t.basename(n)),n=t.dirname(n)}for(let u=r.length-1;u>=0;u--){n=t.joinPath(n,r[u]);try{await o.createDirectory(n)}catch(l){if(L.$Rk(l)!==L.FileSystemProviderErrorCode.FileExists)throw l}}}static e(o){if(o instanceof P.$cN)throw o;if(o instanceof L.$Nk)switch(o.code){case L.FileSystemProviderErrorCode.FileExists:throw P.$cN.FileExists(o.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.$cN.FileNotFound(o.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.$cN.FileNotADirectory(o.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.$cN.FileIsADirectory(o.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.$cN.NoPermissions(o.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.$cN.Unavailable(o.message);default:throw new P.$cN(o.message,o.name)}if(!(o instanceof Error))throw new P.$cN(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw P.$cN.Unavailable(o.message);switch(o.name){case L.FileSystemProviderErrorCode.FileExists:throw P.$cN.FileExists(o.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.$cN.FileNotFound(o.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.$cN.FileNotADirectory(o.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.$cN.FileIsADirectory(o.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.$cN.NoPermissions(o.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.$cN.Unavailable(o.message);default:throw new P.$cN(o.message,o.name)}}addFileSystemProvider(o,t,n){return this.b.set(o,{impl:t,extUri:n?.isCaseSensitive?D.$Hg:D.$Jg,isReadonly:!!n?.isReadonly}),(0,k.$Rc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??D.$Hg}};e.$Uhc=p,e.$Uhc=p=v=Xe([qe(0,g.$dO),qe(1,f.$xhc)],p),e.$Vhc=(0,R.$ei)("IExtHostConsumerFileSystem")}),define(Ae[244],Me([1,0,3,7]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;class P{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(S.$XL.MainThreadIssueReporter)}async $getIssueReporterUri(R,g){if(this.a.size===0)throw new Error("No issue request handlers registered");const f=this.a.get(R);if(!f)throw new Error("Issue request handler not found");const k=await f.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(R,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const k=await f.provideIssueData(g);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(R,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const k=await f.provideIssueTemplate(g);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(R,g){const f=R.identifier.value;return this.a.set(f,g),this.c.$registerIssueUriRequestHandler(f),new L.$ZL(()=>{this.c.$unregisterIssueUriRequestHandler(f),this.a.delete(f)})}registerIssueDataProvider(R,g){const f=R.identifier.value;return this.b.set(f,g),this.c.$registerIssueDataProvider(f),new L.$ZL(()=>{this.c.$unregisterIssueDataProvider(f),this.b.delete(f)})}}e.$Yic=P}),define(Ae[84],Me([1,0,4,27,14,62,2]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=e.$Whc=void 0,e.$Whc=(0,S.$ei)("IExtensionStoragePaths");let g=class{constructor(k,A,D){this.d=A,this.f=D,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(h=>this.c=h)}async g(k){return R.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,A=await this.g(k);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(k){if(this.c)return R.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return R.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Xhc=g,e.$Xhc=g=Xe([qe(0,L.$tO),qe(1,P.$yj),qe(2,F.$Vhc)],g)}),define(Ae[245],Me([1,0,7,17,5]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=void 0;let F=class{constructor(g){this.a=new S.$mN(S.ColorThemeKind.Dark),this.b=new P.$5d}get activeColorTheme(){return this.a}$onColorThemeChange(g){let f;switch(g){case"light":f=S.ColorThemeKind.Light;break;case"hcDark":f=S.ColorThemeKind.HighContrast;break;case"hcLight":f=S.ColorThemeKind.HighContrastLight;break;default:f=S.ColorThemeKind.Dark}this.a=new S.$mN(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$pjc=F,e.$pjc=F=Xe([qe(0,L.$dO)],F)}),define(Ae[85],Me([1,0,21,5,6,169,4,14,198,3,27,17,7]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fAb=e.$eAb=e.TunnelDtoConverter=void 0;class v extends f.$Vv{}var p;(function(o){function t(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:r.protocol}}o.fromApiTunnel=t;function n(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==f.TunnelPrivacyId.ConstantPrivate&&r.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}o.fromServiceTunnel=n})(p||(e.TunnelDtoConverter=p={})),e.$eAb=(0,R.$ei)("IExtHostTunnelService");let s=class extends P.$Tc{constructor(t,n,r){super(),this.s=r,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$5d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(k.$XL.MainThreadTunnelService)}async openTunnel(t,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const r=await this.a.$openTunnel(n,t.displayName);if(r){const u=new v(r.remoteAddress,r.localAddress,()=>this.a.$closeTunnel(r.remoteAddress));return this.B(u),u}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,n){const r=this.u();return this.r.set(r,{selector:t,provider:n}),this.a.$registerPortsAttributesProvider(t,r),new h.$ZL(()=>{this.r.delete(r),this.a.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(t,n,r,u,l){const i=[];for(const a of t){const c=this.r.get(a);if(!c)return[];i.push(...await Promise.all(n.map(async E=>{let y;try{y=await c.provider.providePortAttributes({port:E,pid:r,commandLine:u},l)}catch{y=await c.provider.providePortAttributes(E,r,u,l)}return{providedAttributes:y,port:E}})))}const $=i.filter(a=>!!a.providedAttributes);return $.length>0?$.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(u,l)=>await t.provideTunnel(u,l,new S.$ce().token)??void 0;const r=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(r),Promise.resolve((0,P.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const r=t.tunnelFactory??(n?this.w(n):void 0);if(r){this.b=r;let u=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const l=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:u,protocol:!0}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,P.$Rc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,n){if(this.g.has(t.host)){const r=this.g.get(t.host);r.has(t.port)&&(n&&r.get(t.port).disposeListener.dispose(),await r.get(t.port).tunnel.dispose(),r.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this.b(t,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const u=await r;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),u===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const l=this.B(u.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(u.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:u,disposeListener:l}),p.fromApiTunnel(u)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(u=>this.f(u.host,u.port,u.detail??""))),r=t.filter((u,l)=>n[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(u=>u.port).join(", ")} to ${r.map(u=>u.port).join(", ")}`),r}};e.$fAb=s,e.$fAb=s=Xe([qe(0,D.$dO),qe(1,A.$tO),qe(2,g.$yj)],s)}),define(Ae[8],Me([1,0,18,24,128,246,46,28,121,52,69,26,25,16,2,29,86,98,103,102,83,49,59,217,23,7]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r,u,l,i,$,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.ChatResponseTextPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$cO=e.$bO=e.MarkdownString=e.$aO=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var E;(function(we){function Re(J){const{selectionStartLineNumber:Ee,selectionStartColumn:Ue,positionLineNumber:Ze,positionColumn:Ge}=J,ct=new c.$1L(Ee-1,Ue-1),wt=new c.$1L(Ze-1,Ge-1);return new c.$3L(ct,wt)}we.to=Re;function ue(J){const{anchor:Ee,active:Ue}=J;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}we.from=ue})(E||(e.Selection=E={}));var y;(function(we){function Re(J){if(!J)return;const{start:Ee,end:Ue}=J;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}we.from=Re;function ue(J){if(!J)return;const{startLineNumber:Ee,startColumn:Ue,endLineNumber:Ze,endColumn:Ge}=J;return new c.$2L(Ee-1,Ue-1,Ze-1,Ge-1)}we.to=ue})(y||(e.Range=y={}));var m;(function(we){function Re(J){return{uri:J.uri,range:y.from(J.range)}}we.from=Re;function ue(J){return new c.$_L(p.URI.revive(J.uri),y.to(J.range))}we.to=ue})(m||(e.Location=m={}));var I;(function(we){function Re(ue){switch(ue){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}we.to=Re})(I||(e.TokenType=I={}));var d;(function(we){function Re(J){return new c.$1L(J.lineNumber-1,J.column-1)}we.to=Re;function ue(J){return{lineNumber:J.line+1,column:J.character+1}}we.from=ue})(d||(e.Position=d={}));var w;(function(we){function Re(Ee,Ue,Ze){return(0,S.$Hb)((0,S.$3b)(Ee).map(Ge=>ue(Ge,Ue,Ze)))}we.from=Re;function ue(Ee,Ue,Ze){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Ze?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:J(Ee.scheme,Ue),pattern:Z.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Ze?.isBuiltin}}function J(Ee,Ue){return Ue&&typeof Ee=="string"?Ue.transformOutgoingScheme(Ee):Ee}})(w||(e.DocumentSelector=w={}));var b;(function(we){function Re(J){switch(J){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}we.from=Re;function ue(J){switch(J){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}we.to=ue})(b||(e.DiagnosticTag=b={}));var M;(function(we){function Re(J){let Ee;return J.code&&((0,v.$Sf)(J.code)||(0,v.$Wf)(J.code)?Ee=String(J.code):Ee={value:String(J.code.value),target:J.code.target}),{...y.from(J.range),message:J.message,source:J.source,code:Ee,severity:G.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(T.from),tags:Array.isArray(J.tags)?(0,S.$Hb)(J.tags.map(b.from)):void 0}}we.from=Re;function ue(J){const Ee=new c.$bM(y.to(J),J.message,G.to(J.severity));return Ee.source=J.source,Ee.code=(0,v.$Sf)(J.code)?J.code:J.code?.value,Ee.relatedInformation=J.relatedInformation&&J.relatedInformation.map(T.to),Ee.tags=J.tags&&(0,S.$Hb)(J.tags.map(b.to)),Ee}we.to=ue})(M||(e.Diagnostic=M={}));var T;(function(we){function Re(J){return{...y.from(J.location.range),message:J.message,resource:J.location.uri}}we.from=Re;function ue(J){return new c.$aM(new c.$_L(J.resource,y.to(J)),J.message)}we.to=ue})(T||(e.DiagnosticRelatedInformation=T={}));var G;(function(we){function Re(J){switch(J){case c.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}we.from=Re;function ue(J){switch(J){case t.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}we.to=ue})(G||(e.DiagnosticSeverity=G={}));var W;(function(we){function Re(J){return typeof J=="number"&&J>=c.ViewColumn.One?J-1:J===c.ViewColumn.Beside?$.$qD:$.$pD}we.from=Re;function ue(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=ue})(W||(e.ViewColumn=W={}));function U(we){return typeof we.range<"u"}function C(we){return we.length===0?!0:!!U(we[0])}e.$aO=C;var O;(function(we){function Re(Ge){return Ge.map(we.from)}we.fromMany=Re;function ue(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function J(Ge){let ct;if(ue(Ge)){const{language:Mt,value:Nt}=Ge;ct={value:"```"+Mt+`
`+Nt+"\n```\n"}}else c.$oM.isMarkdownString(Ge)?ct={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ct={value:Ge}:ct={value:""};const wt=Object.create(null);ct.uris=wt;const yt=Mt=>{try{let Nt=p.URI.parse(Mt,!0);Nt=Nt.with({query:Ee(Nt.query,wt)}),wt[Mt]=Nt}catch{}return""},Yt=new f.marked.Renderer;return Yt.link=yt,Yt.image=Mt=>typeof Mt=="string"?yt(R.$Ak(Mt).href):"",(0,f.marked)(ct.value,{renderer:Yt}),ct}we.from=J;function Ee(Ge,ct){if(!Ge)return Ge;let wt;try{wt=(0,k.$Mh)(Ge)}catch{}if(!wt)return Ge;let yt=!1;return wt=(0,D.$Jn)(wt,Yt=>{if(p.URI.isUri(Yt)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Mt]=Yt,yt=!0,Mt}else return}),yt?JSON.stringify(wt):Ge}function Ue(Ge){const ct=new c.$oM(Ge.value,Ge.supportThemeIcons);return ct.isTrusted=Ge.isTrusted,ct.supportHtml=Ge.supportHtml,ct.baseUri=Ge.baseUri?p.URI.from(Ge.baseUri):void 0,ct}we.to=Ue;function Ze(Ge){if(Ge)return typeof Ge=="string"?Ge:we.from(Ge)}we.fromStrict=Ze})(O||(e.MarkdownString=O={}));function V(we){return C(we)?we.map(Re=>({range:y.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?O.fromMany(Re.hoverMessage):Re.hoverMessage?O.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):we.map(Re=>({range:y.from(Re)}))}e.$bO=V;function re(we){return typeof we>"u"?we:typeof we=="string"?p.URI.file(we):we}e.$cO=re;var ce;(function(we){function Re(ue){return typeof ue>"u"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?re(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}we.from=Re})(ce||(e.ThemableDecorationAttachmentRenderOptions=ce={}));var ye;(function(we){function Re(ue){return typeof ue>"u"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?re(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?ce.from(ue.before):void 0,after:ue.after?ce.from(ue.after):void 0}}we.from=Re})(ye||(e.ThemableDecorationRenderOptions=ye={}));var De;(function(we){function Re(ue){if(typeof ue>"u")return ue;switch(ue){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Re})(De||(e.DecorationRangeBehavior=De={}));var he;(function(we){function Re(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?De.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?ye.from(ue.light):void 0,dark:ue.dark?ye.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?re(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?ce.from(ue.before):void 0,after:ue.after?ce.from(ue.after):void 0}}we.from=Re})(he||(e.DecorationRenderOptions=he={}));var ve;(function(we){function Re(J){return{text:J.newText,eol:J.newEol&&it.from(J.newEol),range:y.from(J.range)}}we.from=Re;function ue(J){const Ee=new c.$7L(y.to(J.range),J.text);return Ee.newEol=typeof J.eol>"u"?void 0:it.to(J.eol),Ee}we.to=ue})(ve||(e.TextEdit=ve={}));var se;(function(we){function Re(J,Ee){const Ue={edits:[]};if(J instanceof c.$0L){const Ze=new g.$Bc;for(const Ge of J._allEntries())Ge._type===1&&p.URI.isUri(Ge.to)&&Ge.from===void 0&&Ze.add(Ge.to);for(const Ge of J._allEntries())if(Ge._type===1){let ct;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ct={type:"base64",value:(0,L.$Me)(L.$se.wrap(Ge.options.contents))}:ct={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ue.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ct},metadata:Ge.metadata})}else Ge._type===2?Ue.edits.push({resource:Ge.uri,textEdit:ve.from(Ge.edit),versionId:Ze.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ue.edits.push({resource:Ge.uri,textEdit:{range:y.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ue.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ue.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(zt.from)}})}return Ue}we.from=Re;function ue(J){const Ee=new c.$0L,Ue=new g.$Ac;for(const Ze of J.edits)if(Ze.textEdit){const Ge=Ze,ct=p.URI.revive(Ge.resource),wt=y.to(Ge.textEdit.range),yt=Ge.textEdit.text,Yt=Ge.textEdit.insertAsSnippet;let Mt;Yt?Mt=c.$9L.replace(wt,new c.$$L(yt)):Mt=c.$7L.replace(wt,yt);const Nt=Ue.get(ct);Nt?Nt.push(Mt):Ue.set(ct,[Mt])}else Ee.renameFile(p.URI.revive(Ze.oldResource),p.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ge]of Ue)Ee.set(Ze,Ge);return Ee}we.to=ue})(se||(e.WorkspaceEdit=se={}));var $e;(function(we){const Re=Object.create(null);Re[c.SymbolKind.File]=0,Re[c.SymbolKind.Module]=1,Re[c.SymbolKind.Namespace]=2,Re[c.SymbolKind.Package]=3,Re[c.SymbolKind.Class]=4,Re[c.SymbolKind.Method]=5,Re[c.SymbolKind.Property]=6,Re[c.SymbolKind.Field]=7,Re[c.SymbolKind.Constructor]=8,Re[c.SymbolKind.Enum]=9,Re[c.SymbolKind.Interface]=10,Re[c.SymbolKind.Function]=11,Re[c.SymbolKind.Variable]=12,Re[c.SymbolKind.Constant]=13,Re[c.SymbolKind.String]=14,Re[c.SymbolKind.Number]=15,Re[c.SymbolKind.Boolean]=16,Re[c.SymbolKind.Array]=17,Re[c.SymbolKind.Object]=18,Re[c.SymbolKind.Key]=19,Re[c.SymbolKind.Null]=20,Re[c.SymbolKind.EnumMember]=21,Re[c.SymbolKind.Struct]=22,Re[c.SymbolKind.Event]=23,Re[c.SymbolKind.Operator]=24,Re[c.SymbolKind.TypeParameter]=25;function ue(Ee){return typeof Re[Ee]=="number"?Re[Ee]:6}we.from=ue;function J(Ee){for(const Ue in Re)if(Re[Ue]===Ee)return Number(Ue);return c.SymbolKind.Property}we.to=J})($e||(e.SymbolKind=$e={}));var ee;(function(we){function Re(J){switch(J){case c.SymbolTag.Deprecated:return 1}}we.from=Re;function ue(J){switch(J){case 1:return c.SymbolTag.Deprecated}}we.to=ue})(ee||(e.SymbolTag=ee={}));var Y;(function(we){function Re(J){return{name:J.name,kind:$e.from(J.kind),tags:J.tags&&J.tags.map(ee.from),containerName:J.containerName,location:Ce.from(J.location)}}we.from=Re;function ue(J){const Ee=new c.$fM(J.name,$e.to(J.kind),J.containerName,Ce.to(J.location));return Ee.tags=J.tags&&J.tags.map(ee.to),Ee}we.to=ue})(Y||(e.WorkspaceSymbol=Y={}));var q;(function(we){function Re(J){const Ee={name:J.name||"!!MISSING: name!!",detail:J.detail,range:y.from(J.range),selectionRange:y.from(J.selectionRange),kind:$e.from(J.kind),tags:J.tags?.map(ee.from)??[]};return J.children&&(Ee.children=J.children.map(Re)),Ee}we.from=Re;function ue(J){const Ee=new c.$gM(J.name,J.detail,$e.to(J.kind),y.to(J.range),y.to(J.selectionRange));return(0,S.$Lb)(J.tags)&&(Ee.tags=J.tags.map(ee.to)),J.children&&(Ee.children=J.children.map(ue)),Ee}we.to=ue})(q||(e.DocumentSymbol=q={}));var ne;(function(we){function Re(J){const Ee=new c.$kM($e.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Ee._sessionId=J._sessionId,Ee._itemId=J._itemId,Ee}we.to=Re;function ue(J,Ee,Ue){if(Ee=Ee??J._sessionId,Ue=Ue??J._itemId,Ee===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Ue,name:J.name,detail:J.detail,kind:$e.from(J.kind),uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(ee.from)}}we.from=ue})(ne||(e.CallHierarchyItem=ne={}));var Se;(function(we){function Re(ue){return new c.$lM(ne.to(ue.from),ue.fromRanges.map(J=>y.to(J)))}we.to=Re})(Se||(e.CallHierarchyIncomingCall=Se={}));var Te;(function(we){function Re(ue){return new c.$mM(ne.to(ue.to),ue.fromRanges.map(J=>y.to(J)))}we.to=Re})(Te||(e.CallHierarchyOutgoingCall=Te={}));var Ce;(function(we){function Re(J){return{range:J.range&&y.from(J.range),uri:J.uri}}we.from=Re;function ue(J){return new c.$_L(p.URI.revive(J.uri),y.to(J.range))}we.to=ue})(Ce||(e.location=Ce={}));var be;(function(we){function Re(J){const Ee=J,Ue=J;return{originSelectionRange:Ee.originSelectionRange?y.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:Ue.uri,range:y.from(Ee.targetRange?Ee.targetRange:Ue.range),targetSelectionRange:Ee.targetSelectionRange?y.from(Ee.targetSelectionRange):void 0}}we.from=Re;function ue(J){return{targetUri:p.URI.revive(J.uri),targetRange:y.to(J.range),targetSelectionRange:J.targetSelectionRange?y.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?y.to(J.originSelectionRange):void 0}}we.to=ue})(be||(e.DefinitionLink=be={}));var ge;(function(we){function Re(J){return{range:y.from(J.range),contents:O.fromMany(J.contents)}}we.from=Re;function ue(J){return new c.$cM(J.contents.map(O.to),y.to(J.range))}we.to=ue})(ge||(e.Hover=ge={}));var X;(function(we){function Re(J){return{range:y.from(J.range),expression:J.expression}}we.from=Re;function ue(J){return new c.$9M(y.to(J.range),J.expression)}we.to=ue})(X||(e.EvaluatableExpression=X={}));var x;(function(we){function Re(J){if(J instanceof c.$0M)return{type:"text",range:y.from(J.range),text:J.text};if(J instanceof c.$$M)return{type:"variable",range:y.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof c.$_M)return{type:"expression",range:y.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Re;function ue(J){switch(J.type){case"text":return{range:y.to(J.range),text:J.text};case"variable":return{range:y.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:y.to(J.range),expression:J.expression}}}we.to=ue})(x||(e.InlineValue=x={}));var le;(function(we){function Re(J){return{frameId:J.frameId,stoppedLocation:y.from(J.stoppedLocation)}}we.from=Re;function ue(J){return new c.$aN(J.frameId,y.to(J.stoppedLocation))}we.to=ue})(le||(e.InlineValueContext=le={}));var de;(function(we){function Re(J){return{range:y.from(J.range),kind:J.kind}}we.from=Re;function ue(J){return new c.$dM(y.to(J.range),J.kind)}we.to=ue})(de||(e.DocumentHighlight=de={}));var Pe;(function(we){function Re(J){return{uri:J.uri,highlights:J.highlights.map(de.from)}}we.from=Re;function ue(J){return new c.$eM(p.URI.revive(J.uri),J.highlights.map(de.to))}we.to=ue})(Pe||(e.MultiDocumentHighlight=Pe={}));var me;(function(we){function Re(ue){switch(ue){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}we.to=Re})(me||(e.CompletionTriggerKind=me={}));var Ie;(function(we){function Re(ue){return{triggerKind:me.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}we.to=Re})(Ie||(e.CompletionContext=Ie={}));var Le;(function(we){function Re(J){switch(J){case c.CompletionItemTag.Deprecated:return 1}}we.from=Re;function ue(J){switch(J){case 1:return c.CompletionItemTag.Deprecated}}we.to=ue})(Le||(e.CompletionItemTag=Le={}));var ze;(function(we){const Re=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function ue(Ue){return Re.get(Ue)??9}we.from=ue;const J=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Ee(Ue){return J.get(Ue)??c.CompletionItemKind.Property}we.to=Ee})(ze||(e.CompletionItemKind=ze={}));var N;(function(we){function Re(ue,J){const Ee=new c.$uM(ue.label);return Ee.insertText=ue.insertText,Ee.kind=ze.to(ue.kind),Ee.tags=ue.tags?.map(Le.to),Ee.detail=ue.detail,Ee.documentation=R.$uk(ue.documentation)?O.to(ue.documentation):ue.documentation,Ee.sortText=ue.sortText,Ee.filterText=ue.filterText,Ee.preselect=ue.preselect,Ee.commitCharacters=ue.commitCharacters,s.$6s.isIRange(ue.range)?Ee.range=y.to(ue.range):typeof ue.range=="object"&&(Ee.range={inserting:y.to(ue.range.insert),replacing:y.to(ue.range.replace)}),Ee.keepWhitespace=typeof ue.insertTextRules>"u"?!1:!!(ue.insertTextRules&1),typeof ue.insertTextRules<"u"&&ue.insertTextRules&4?Ee.insertText=new c.$$L(ue.insertText):(Ee.insertText=ue.insertText,Ee.textEdit=Ee.range instanceof c.$2L?new c.$7L(Ee.range,Ee.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Ee.additionalTextEdits=ue.additionalTextEdits.map(Ue=>ve.to(Ue))),Ee.command=J&&ue.command?J.fromInternal(ue.command):void 0,Ee}we.to=Re})(N||(e.CompletionItem=N={}));var j;(function(we){function Re(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:O.fromStrict(J.documentation)}}we.from=Re;function ue(J){return{label:J.label,documentation:R.$uk(J.documentation)?O.to(J.documentation):J.documentation}}we.to=ue})(j||(e.ParameterInformation=j={}));var K;(function(we){function Re(J){return{label:J.label,documentation:O.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(j.from):[],activeParameter:J.activeParameter}}we.from=Re;function ue(J){return{label:J.label,documentation:R.$uk(J.documentation)?O.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(j.to):[],activeParameter:J.activeParameter}}we.to=ue})(K||(e.SignatureInformation=K={}));var H;(function(we){function Re(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(K.from):[]}}we.from=Re;function ue(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(K.to):[]}}we.to=ue})(H||(e.SignatureHelp=H={}));var te;(function(we){function Re(ue,J){const Ee=new c.$tM(d.to(J.position),typeof J.label=="string"?J.label:J.label.map(oe.to.bind(void 0,ue)),J.kind&&Oe.to(J.kind));return Ee.textEdits=J.textEdits&&J.textEdits.map(ve.to),Ee.tooltip=R.$uk(J.tooltip)?O.to(J.tooltip):J.tooltip,Ee.paddingLeft=J.paddingLeft,Ee.paddingRight=J.paddingRight,Ee}we.to=Re})(te||(e.InlayHint=te={}));var oe;(function(we){function Re(ue,J){const Ee=new c.$sM(J.label);return Ee.tooltip=R.$uk(J.tooltip)?O.to(J.tooltip):J.tooltip,o.Command.is(J.command)&&(Ee.command=ue.fromInternal(J.command)),J.location&&(Ee.location=Ce.to(J.location)),Ee}we.to=Re})(oe||(e.InlayHintLabelPart=oe={}));var Oe;(function(we){function Re(J){return J}we.from=Re;function ue(J){return J}we.to=ue})(Oe||(e.InlayHintKind=Oe={}));var Ve;(function(we){function Re(J){return{range:y.from(J.range),url:J.target,tooltip:J.tooltip}}we.from=Re;function ue(J){let Ee;if(J.url)try{Ee=typeof J.url=="string"?p.URI.parse(J.url,!0):p.URI.revive(J.url)}catch{}return new c.$zM(y.to(J.range),Ee)}we.to=ue})(Ve||(e.DocumentLink=Ve={}));var He;(function(we){function Re(J){const Ee=new c.$CM(J.label);return J.textEdit&&(Ee.textEdit=ve.to(J.textEdit)),J.additionalTextEdits&&(Ee.additionalTextEdits=J.additionalTextEdits.map(Ue=>ve.to(Ue))),Ee}we.to=Re;function ue(J){return{label:J.label,textEdit:J.textEdit?ve.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Ee=>ve.from(Ee)):void 0}}we.from=ue})(He||(e.ColorPresentation=He={}));var xe;(function(we){function Re(J){return new c.$AM(J[0],J[1],J[2],J[3])}we.to=Re;function ue(J){return[J.red,J.green,J.blue,J.alpha]}we.from=ue})(xe||(e.Color=xe={}));var tt;(function(we){function Re(J){return{range:y.from(J.range)}}we.from=Re;function ue(J){return new c.$jM(y.to(J.range))}we.to=ue})(tt||(e.SelectionRange=tt={}));var lt;(function(we){function Re(ue){switch(ue){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}we.to=Re})(lt||(e.TextDocumentSaveReason=lt={}));var rt;(function(we){function Re(J){switch(J){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.Interval:return 3;case c.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Re;function ue(J){switch(J){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 3:return c.TextEditorLineNumbersStyle.Interval;case 1:default:return c.TextEditorLineNumbersStyle.On}}we.to=ue})(rt||(e.TextEditorLineNumbersStyle=rt={}));var it;(function(we){function Re(J){if(J===c.EndOfLine.CRLF)return 1;if(J===c.EndOfLine.LF)return 0}we.from=Re;function ue(J){if(J===1)return c.EndOfLine.CRLF;if(J===0)return c.EndOfLine.LF}we.to=ue})(it||(e.EndOfLine=it={}));var ot;(function(we){function Re(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Re})(ot||(e.ProgressLocation=ot={}));var Be;(function(we){function Re(J){const Ee={start:J.start+1,end:J.end+1};return J.kind&&(Ee.kind=et.from(J.kind)),Ee}we.from=Re;function ue(J){const Ee={start:J.start-1,end:J.end-1};return J.kind&&(Ee.kind=et.to(J.kind)),Ee}we.to=ue})(Be||(e.FoldingRange=Be={}));var et;(function(we){function Re(J){if(J)switch(J){case c.FoldingRangeKind.Comment:return o.$Wt.Comment;case c.FoldingRangeKind.Imports:return o.$Wt.Imports;case c.FoldingRangeKind.Region:return o.$Wt.Region}}we.from=Re;function ue(J){if(J)switch(J.value){case o.$Wt.Comment.value:return c.FoldingRangeKind.Comment;case o.$Wt.Imports.value:return c.FoldingRangeKind.Imports;case o.$Wt.Region.value:return c.FoldingRangeKind.Region}}we.to=ue})(et||(e.FoldingRangeKind=et={}));var Q;(function(we){function Re(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?y.from(ue.selection):void 0,override:typeof ue.override=="boolean"?r.$SE.id:void 0}}we.from=Re})(Q||(e.TextEditorOpenOptions=Q={}));var Z;(function(we){function Re(Ue){return Ue instanceof c.$WM?Ue.toJSON():typeof Ue=="string"?Ue:ue(Ue)||J(Ue)?new c.$WM(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}we.from=Re;function ue(Ue){const Ze=Ue;return Ze?p.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(Ue){const Ze=Ue;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Ee(Ue){return typeof Ue=="string"?Ue:new c.$WM(p.URI.revive(Ue.baseUri),Ue.pattern)}we.to=Ee})(Z||(e.GlobPattern=Z={}));var pe;(function(we){function Re(ue){if(ue){if(Array.isArray(ue))return ue.map(Re);if(typeof ue=="string")return ue;{const J=ue;return{language:J.language,scheme:J.scheme,pattern:Z.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}we.from=Re})(pe||(e.LanguageSelector=pe={}));var We;(function(we){function Re(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&p.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Ze=>Ze instanceof c.$2L)))}we.is=Re;function ue(J){return{documents:J.documents.map(Ee=>Ee.map(Ue=>({uri:p.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ze=>y.from(Ze))})))}}we.from=ue})(We||(e.MappedEditsContext=We={}));var Ye;(function(we){function Re(J){return{start:J.start,end:J.end}}we.from=Re;function ue(J){return new c.$nN(J.start,J.end)}we.to=ue})(Ye||(e.NotebookRange=Ye={}));var st;(function(we){function Re(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}we.to=Re;function ue(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}we.from=ue})(st||(e.NotebookCellExecutionSummary=st={}));var Fe;(function(we){function Re(ue){if(ue===u.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;if(ue===u.NotebookCellExecutionState.Pending)return;if(ue===u.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ue}`)}we.to=Re})(Fe||(e.NotebookCellExecutionState=Fe={}));var St;(function(we){function Re(J){switch(J){case c.NotebookCellKind.Markup:return u.CellKind.Markup;case c.NotebookCellKind.Code:default:return u.CellKind.Code}}we.from=Re;function ue(J){switch(J){case u.CellKind.Markup:return c.NotebookCellKind.Markup;case u.CellKind.Code:default:return c.NotebookCellKind.Code}}we.to=ue})(St||(e.NotebookCellKind=St={}));var Kt;(function(we){function Re(J){const Ee={metadata:J.metadata??Object.create(null),cells:[]};for(const Ue of J.cells)c.$oN.validate(Ue),Ee.cells.push(zt.from(Ue));return Ee}we.from=Re;function ue(J){const Ee=new c.$pN(J.cells.map(zt.to));return(0,v.$6f)(J.metadata)||(Ee.metadata=J.metadata),Ee}we.to=ue})(Kt||(e.NotebookData=Kt={}));var zt;(function(we){function Re(J){return{cellKind:St.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:st.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Qt.from):[]}}we.from=Re;function ue(J){return new c.$oN(St.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Qt.to):void 0,J.metadata,J.internalMetadata?st.to(J.internalMetadata):void 0)}we.to=ue})(zt||(e.NotebookCellData=zt={}));var Zt;(function(we){function Re(J){return{mime:J.mime,valueBytes:L.$se.wrap(J.data)}}we.from=Re;function ue(J){return new c.$qN(J.valueBytes.buffer,J.mime)}we.to=ue})(Zt||(e.NotebookCellOutputItem=Zt={}));var Qt;(function(we){function Re(J){return{outputId:J.id,items:J.items.map(Zt.from),metadata:J.metadata}}we.from=Re;function ue(J){const Ee=J.items.map(Zt.to);return new c.$rN(Ee,J.outputId,J.metadata)}we.to=ue})(Qt||(e.NotebookCellOutput=Qt={}));var It;(function(we){function Re(Ee){return J(Ee)?{include:Z.from(Ee.include)??void 0,exclude:Z.from(Ee.exclude)??void 0}:Z.from(Ee)??void 0}we.from=Re;function ue(Ee){return J(Ee)?{include:Z.to(Ee.include),exclude:Z.to(Ee.exclude)}:Z.to(Ee)}we.to=ue;function J(Ee){const Ue=Ee;return Ue?!(0,v.$2f)(Ue.include)&&!(0,v.$2f)(Ue.exclude):!1}})(It||(e.NotebookExclusiveDocumentPattern=It={}));var Gt;(function(we){function Re(ue,J,Ee){const Ue=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ue,Ee),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}we.from=Re})(Gt||(e.NotebookStatusBarItem=Gt={}));var Jt;(function(we){function Re(ue,J,Ee){const Ue=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{command:J.toInternal(Ue,Ee),label:ue.label,description:ue.description,detail:ue.detail,documentation:ue.documentation}}we.from=Re})(Jt||(e.NotebookKernelSourceAction=Jt={}));var _t;(function(we){function Re(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{},cellContentMetadata:ue?.cellContentMetadata??{}}}we.from=Re})(_t||(e.NotebookDocumentContentOptions=_t={}));var ri;(function(we){function Re(J){return{uri:J.uri,provides:J.provides}}we.from=Re;function ue(J){return new c.$tN(p.URI.revive(J.uri),J.provides)}we.to=ue})(ri||(e.NotebookRendererScript=ri={}));var Qe;(function(we){function Re(J){return{message:O.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:y.from(J.location.range),uri:J.location.uri}}}we.from=Re;function ue(J){const Ee=new c.$zN(typeof J.message=="string"?J.message:O.to(J.message));return Ee.actualOutput=J.actual,Ee.expectedOutput=J.expected,Ee.contextValue=J.contextValue,Ee.location=J.location?Ce.to(J.location):void 0,Ee}we.to=ue})(Qe||(e.TestMessage=Qe={}));var jt;(function(we){we.namespace=i.$SK,we.denamespace=i.$TK})(jt||(e.TestTag=jt={}));var ei;(function(we){function Re(J){const Ee=(0,n.$_N)(J).controllerId;return{extId:l.$OK.fromExtHostTestItem(J,Ee).toString(),label:J.label,uri:p.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ue=>jt.namespace(Ee,Ue.id)),range:s.$6s.lift(y.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&O.fromStrict(J.error)||null}}we.from=Re;function ue(J){return{parent:void 0,error:void 0,id:l.$OK.fromString(J.extId).localId,label:J.label,uri:p.URI.revive(J.uri),tags:(J.tags||[]).map(Ee=>{const{tagId:Ue}=jt.denamespace(Ee);return new c.$AN(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}we.toPlain=ue})(ei||(e.TestItem=ei={})),function(we){function Re(J){return{id:J.id}}we.from=Re;function ue(J){return new c.$AN(J.id)}we.to=ue}(jt||(e.TestTag=jt={}));var ft;(function(we){const Re=(J,Ee)=>{const Ue=[];for(const[Ge,ct]of Ee)l.$OK.compare(ct.item.extId,Ge)===2&&(Ee.delete(Ge),Ue.push(ct));const Ze={...ei.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ct=>ct.type===0).map(Qe.to)})),children:Ue.map(Ge=>Re(Ge,Ee))};for(const Ge of Ze.children)Ge.parent=Ze;return Ze};function ue(J){const Ee=[],Ue=new Map;for(const Ze of J.items){Ue.set(Ze.item.extId,Ze);const Ge=l.$OK.root(Ze.item.extId);J.request.targets.some(ct=>ct.controllerId===Ge&&ct.testIds.includes(Ze.item.extId))&&Ee.push(Ze)}return{completedAt:J.completedAt,results:Ee.map(Ze=>Re(Ze,Ue))}}we.to=ue})(ft||(e.TestResults=ft={}));var vt;(function(we){function Re(Ue){return{covered:Ue.covered,total:Ue.total}}function ue(Ue){return"line"in Ue?d.from(Ue):y.from(Ue)}function J(Ue){return"branches"in Ue?{count:Ue.executed,location:ue(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ue(Ze.location),label:Ze.label})):void 0}:{type:0,name:Ue.name,count:Ue.executed,location:ue(Ue.location)}}we.fromDetailed=J;function Ee(Ue){return{uri:Ue.uri,statement:Re(Ue.statementCoverage),branch:Ue.branchCoverage&&Re(Ue.branchCoverage),declaration:Ue.declarationCoverage&&Re(Ue.declarationCoverage),details:Ue.detailedCoverage?.map(J)}}we.fromFile=Ee})(vt||(e.TestCoverage=vt={}));var ti;(function(we){function Re(ue){switch(ue){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}we.to=Re})(ti||(e.CodeActionTriggerKind=ti={}));var Wt;(function(we){function Re(J){const Ee=new c.$GN($e.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Ee._sessionId=J._sessionId,Ee._itemId=J._itemId,Ee}we.to=Re;function ue(J,Ee,Ue){if(Ee=Ee??J._sessionId,Ue=Ue??J._itemId,Ee===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Ue,kind:$e.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(ee.from)}}we.from=ue})(Wt||(e.TypeHierarchyItem=Wt={}));var Ut;(function(we){function Re(ue){if(ue)return{value:ue.value,tooltip:ue.tooltip}}we.from=Re})(Ut||(e.ViewBadge=Ut={}));var dt;(function(we){function Re(Ue,Ze,Ge){const ct=Ze.fileData;return ct?new c.$PM(new c.$QM(ct.name,p.URI.revive(ct.uri),ct.id,(0,F.$db)(()=>Ge(ct.id)))):Ue===A.$qs.uriList&&Ze.uriListData?new c.$OM(Ee(Ze.uriListData)):new c.$OM(Ze.asString)}we.to=Re;async function ue(Ue,Ze){const Ge=await Ze.asString();if(Ue===A.$qs.uriList)return{asString:Ge,fileData:void 0,uriListData:J(Ge)};const ct=Ze.asFile();return{asString:Ge,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}we.from=ue;function J(Ue){return P.$Ct.split(Ue).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return p.URI.parse(Ze)}catch{}return Ze})}function Ee(Ue){return P.$Ct.create(Ue.map(Ze=>typeof Ze=="string"?Ze:p.URI.revive(Ze)))}})(dt||(e.DataTransferItem=dt={}));var Pt;(function(we){function Re(J,Ee){const Ue=J.items.map(([Ze,Ge])=>[Ze,dt.to(Ze,Ge,Ee)]);return new c.$RM(Ue)}we.toDataTransfer=Re;async function ue(J){const Ee={items:[]},Ue=[];for(const[Ze,Ge]of J)Ue.push((async()=>{Ee.items.push([Ze,await dt.from(Ze,Ge)])})());return await Promise.all(Ue),Ee}we.from=ue})(Pt||(e.DataTransfer=Pt={}));var ii;(function(we){function Re(J,Ee){return{kind:"reply",agentId:J.agentId??Ee?.agentId??"",subCommand:J.command??Ee?.command,message:J.prompt,title:J.title,tooltip:J.tooltip}}we.from=Re;function ue(J){return{prompt:J.message,title:J.title,agentId:J.agentId,command:J.subCommand,tooltip:J.tooltip}}we.to=ue})(ii||(e.ChatFollowup=ii={}));var xt;(function(we){function Re(ue){return"commandId"in ue?{kind:"command",title:ue.title??"",commandId:ue.commandId??"",when:ue.when??"",args:ue.args}:{kind:"reply",message:ue.message,title:ue.title,tooltip:ue.tooltip}}we.from=Re})(xt||(e.ChatInlineFollowup=xt={}));var Ke;(function(we){function Re(J){switch(J.role){case 0:return new c.$2N(J.content);case 1:return new c.$3N(J.content);case 2:return new c.$4N(J.content)}}we.to=Re;function ue(J){if(J instanceof c.$2N)return{role:0,content:J.content};if(J instanceof c.$3N)return{role:1,content:J.content};if(J instanceof c.$4N)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}we.from=ue})(Ke||(e.LanguageModelMessage=Ke={}));var At;(function(we){function Re(Ee){const Ue={};for(const Ze of Object.keys(Ee))Ue[Ze]=Ee[Ze].map(we.to);return Ue}we.objectTo=Re;function ue(Ee){return{level:Bt.to(Ee.level),kind:Ee.kind,value:(0,p.$vc)(Ee.value)?p.URI.revive(Ee.value):Ee.value,description:Ee.description}}we.to=ue;function J(Ee){return{level:Bt.from(Ee.level),kind:Ee.kind,value:Ee.value,description:Ee.description}}we.from=J})(At||(e.ChatVariable=At={}));var Bt;(function(we){function Re(J){switch(J){case"short":return c.ChatVariableLevel.Short;case"medium":return c.ChatVariableLevel.Medium;case"full":default:return c.ChatVariableLevel.Full}}we.to=Re;function ue(J){switch(J){case c.ChatVariableLevel.Short:return"short";case c.ChatVariableLevel.Medium:return"medium";case c.ChatVariableLevel.Full:default:return"full"}}we.from=ue})(Bt||(e.ChatVariableLevel=Bt={}));var si;(function(we){function Re(ue){switch(ue){case 1:return c.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return c.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return c.InteractiveEditorResponseFeedbackKind.Undone;case 3:return c.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return c.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Re})(si||(e.InteractiveEditorResponseFeedbackKind=si={}));var gt;(function(we){function Re(J){return{kind:"markdownContent",content:O.from(new c.$oM().appendText(J.value))}}we.to=Re;function ue(J){return new c.$SN(J.content.value)}we.from=ue})(gt||(e.ChatResponseTextPart=gt={}));var Lt;(function(we){function Re(J){return{kind:"markdownContent",content:O.from(J.value)}}we.to=Re;function ue(J){return new c.$TN(O.to(J.content))}we.from=ue})(Lt||(e.ChatResponseMarkdownPart=Lt={}));var Ct;(function(we){function Re(J){const{value:Ee,baseUri:Ue}=J;function Ze(Ge,ct){return Ge.map(wt=>{const yt=p.URI.joinPath(ct,wt.name);return{label:wt.name,uri:yt,children:wt.children&&Ze(wt.children,yt)}})}return{kind:"treeData",treeData:{label:(0,h.$Og)(Ue),uri:Ue,children:Ze(Ee,Ue)}}}we.to=Re;function ue(J){const Ee=(0,k.$Nh)(J.treeData);function Ue(ct){return ct.map(wt=>({name:wt.label,children:wt.children&&Ue(wt.children)}))}const Ze=Ee.uri,Ge=Ee.children?Ue(Ee.children):[];return new c.$UN(Ge,Ze)}we.from=ue})(Ct||(e.ChatResponseFilesPart=Ct={}));var Ot;(function(we){function Re(J){return{kind:"inlineReference",name:J.title,inlineReference:p.URI.isUri(J.value)?J.value:m.from(J.value)}}we.to=Re;function ue(J){const Ee=(0,k.$Nh)(J);return new c.$VN(p.URI.isUri(Ee.inlineReference)?Ee.inlineReference:m.to(Ee.inlineReference),J.name)}we.from=ue})(Ot||(e.ChatResponseAnchorPart=Ot={}));var ni;(function(we){function Re(J){return{kind:"progressMessage",content:O.from(J.value)}}we.to=Re;function ue(J){return new c.$WN(J.content.value)}we.from=ue})(ni||(e.ChatResponseProgressPart=ni={}));var Vt;(function(we){function Re(J,Ee,Ue){return{kind:"command",command:Ee.toInternal(J.value,Ue)??{command:J.value.command,title:J.value.title}}}we.to=Re;function ue(J,Ee){return new c.$XN(Ee.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}we.from=ue})(Vt||(e.ChatResponseCommandButtonPart=Vt={}));var Tt;(function(we){function Re(J){return{kind:"reference",reference:p.URI.isUri(J.value)?J.value:m.from(J.value)}}we.to=Re;function ue(J){const Ee=(0,k.$Nh)(J);return new c.$YN(p.URI.isUri(Ee.reference)?Ee.reference:m.to(Ee.reference))}we.from=ue})(Tt||(e.ChatResponseReferencePart=Tt={}));var Rt;(function(we){function Re(J){return J instanceof c.$TN?Lt.to(J):J instanceof c.$VN?Ot.to(J):J instanceof c.$YN?Tt.to(J):J instanceof c.$WN?ni.to(J):J instanceof c.$UN?Ct.to(J):{kind:"content",content:""}}we.to=Re;function ue(J,Ee){switch(J.kind){case"markdownContent":return Lt.from(J);case"inlineReference":return Ot.from(J);case"reference":return Tt.from(J);case"progressMessage":return ni.from(J);case"treeData":return Ct.from(J);case"command":return Vt.from(J,Ee)}}we.from=ue})(Rt||(e.ChatResponsePart=Rt={}));var Dt;(function(we){function Re(Ee,Ue){return"markdownContent"in Ue?((0,a.$VF)(Ee,"chatAgents2Additions"),{content:O.from(Ue.markdownContent),kind:"markdownContent"}):"content"in Ue?"vulnerabilities"in Ue&&Ue.vulnerabilities?((0,a.$VF)(Ee,"chatAgents2Additions"),{content:Ue.content,vulnerabilities:Ue.vulnerabilities,kind:"vulnerability"}):typeof Ue.content=="string"?{content:Ue.content,kind:"content"}:((0,a.$VF)(Ee,"chatAgents2Additions"),{content:O.from(Ue.content),kind:"markdownContent"}):"documents"in Ue?{documents:Ue.documents.map(Ze=>({uri:Ze.uri,version:Ze.version,ranges:Ze.ranges.map(Ge=>y.from(Ge))})),kind:"usedContext"}:"reference"in Ue?{reference:"uri"in Ue.reference?{uri:Ue.reference.uri,range:y.from(Ue.reference.range)}:Ue.reference,kind:"reference"}:"inlineReference"in Ue?{inlineReference:"uri"in Ue.inlineReference?{uri:Ue.inlineReference.uri,range:y.from(Ue.inlineReference.range)}:Ue.inlineReference,name:Ue.title,kind:"inlineReference"}:"agentName"in Ue?((0,a.$VF)(Ee,"chatAgents2Additions"),{agentName:Ue.agentName,command:Ue.command,kind:"agentDetection"}):"message"in Ue?{content:O.from(Ue.message),kind:"progressMessage"}:void 0}we.from=Re;function ue(Ee){switch(Ee.kind){case"markdownContent":case"inlineReference":case"treeData":return we.to(Ee);case"content":return{content:Ee.content};case"usedContext":return{documents:Ee.documents.map(Ue=>({uri:p.URI.revive(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ze=>y.to(Ze))}))};case"reference":return{reference:(0,p.$vc)(Ee.reference)?p.URI.revive(Ee.reference):m.to(Ee.reference)};case"agentDetection":return;case"progressMessage":return{message:Ee.content.value};case"vulnerability":return{content:Ee.content,vulnerabilities:Ee.vulnerabilities};default:return}}we.to=ue;function J(Ee,Ue){switch(Ee.kind){case"markdownContent":return{content:Ee.content.value};case"inlineReference":return{inlineReference:(0,p.$vc)(Ee.inlineReference)?p.URI.revive(Ee.inlineReference):m.to(Ee.inlineReference),title:Ee.name};case"command":return{command:Ue.fromInternal(Ee.command)??{command:Ee.command.id,title:Ee.command.title}};default:return}}we.toProgressContent=J})(Dt||(e.ChatResponseProgress=Dt={}));var $t;(function(we){function Re(ue){return{prompt:ue.message,command:ue.command,variables:ue.variables.variables.map(kt.to)}}we.to=Re})($t||(e.ChatAgentRequest=$t={}));var kt;(function(we){function Re(ue){return{name:ue.name,range:[ue.range.start,ue.range.endExclusive],values:ue.values.map(At.to)}}we.to=Re})(kt||(e.ChatAgentResolvedVariable=kt={}));var Et;(function(we){function Re(ue){return{label:ue.label,values:ue.values.map(At.from),insertText:ue.insertText,detail:ue.detail,documentation:ue.documentation}}we.from=Re})(Et||(e.ChatAgentCompletionItem=Et={}));var ci;(function(we){function Re(ue){return{errorDetails:ue.errorDetails,metadata:ue.metadata}}we.to=Re})(ci||(e.ChatAgentResult=ci={}));var Xt;(function(we){function Re(ue,J,Ee){if(J.action.kind==="vote")return;const Ue=ci.to(ue);return J.action.kind==="command"?{action:{kind:"command",commandButton:Dt.toProgressContent(J.action.commandButton,Ee)},result:Ue}:J.action.kind==="followUp"?{action:{kind:"followUp",followup:ii.to(J.action.followup)},result:Ue}:{action:J.action,result:Ue}}we.to=Re})(Xt||(e.ChatAgentUserActionEvent=Xt={}));var pi;(function(we){function Re(ue,J,Ee){return"terminalCommand"in ue?{terminalCommand:ue.terminalCommand,shouldExecute:ue.shouldExecute}:"uri"in ue?{uri:ue.uri}:J.toInternal(ue,Ee)}we.from=Re})(pi||(e.TerminalQuickFix=pi={}));var qt;(function(we){function Re(ue,J){return{id:J,label:ue.label,description:ue.description,canEdit:ue.canEdit,collapsibleState:ue.collapsibleState||0,contextValue:ue.contextValue}}we.from=Re})(qt||(e.DebugTreeItem=qt={}))}),define(Ae[247],Me([1,0,3,17,8]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=void 0;let F=class{constructor(g,f){this.a=g.getProxy(S.$XL.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>f.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,f,k){const A=P.WorkspaceEdit.from(g,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,k?.isRefactoring??!1)}};e.$Ehc=F,e.$Ehc=F=Xe([qe(0,L.$dO)],F)}),define(Ae[248],Me([1,0,18,11,41,5,46,6,63,16,2,158,3,8,7,207,23]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class t{constructor(l,i,$,a,c,E){this.i=l,this.j=i,this.k=$,this.l=a,this.m=c,this.n=E,this.a=f.$1d.create(!1),this.b=!1}close(){this.b=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.a.elapsed()}}get apiObject(){if(!this.g){let i=function(a){if(l.b){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,a),c}};const l=this;this.a.reset();const $=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.a.elapsed()),this.k.$handleProgressChunk(this.j.requestId,a)};this.g={text(a){return i(this.text),this.markdown(new R.$sk().appendText(a)),this},markdown(a){i(this.markdown);const c=new p.$TN(a),E=v.ChatResponseMarkdownPart.to(c);return $(E),this},filetree(a,c){i(this.filetree);const E=new p.$UN(a,c),y=v.ChatResponseFilesPart.to(E);return $(y),this},anchor(a,c){i(this.anchor);const E=new p.$VN(a,c),y=v.ChatResponseAnchorPart.to(E);return $(y),this},button(a){i(this.anchor);const c=new p.$XN(a),E=v.ChatResponseCommandButtonPart.to(c,l.m,l.n);return $(E),this},progress(a){i(this.progress);const c=new p.$WN(a),E=v.ChatResponseProgressPart.to(c);return $(E),this},reference(a){i(this.reference);const c=new p.$YN(a),E=v.ChatResponseReferencePart.to(c);return $(E),this},push(a){i(this.push);const c=v.ChatResponsePart.to(a);return $(c),this},report(a){if(i(this.report),"placeholder"in a&&"resolvedContent"in a)return;const c=v.ChatResponseProgress.from(l.i,a);if(!c){l.l.error("Unknown progress type: "+JSON.stringify(a));return}return $(c),this}}}return this.g}}class n{static{this.a=0}constructor(l,i,$){this.i=i,this.j=$,this.b=new Map,this.g=new g.$3c,this.d=l.getProxy(h.$XL.MainThreadChatAgents2)}createChatAgent(l,i,$){const a=n.a++,c=new r(l,i,this.d,a,$);return this.b.set(a,c),this.d.$registerAgent(a,l.identifier,i,{}),c.apiAgent}async $invokeAgent(l,i,$,a){const c=this.b.get(l);if(!c)throw new Error(`[CHAT](${l}) CANNOT invoke agent because the agent is not registered`);let E=this.g.get(i.sessionId);E||(E=new g.$Sc,this.g.set(i.sessionId,E));const y=new t(c.extension,i,this.d,this.i,this.j.converter,E);try{const m=await this.k(i,$),I=c.invoke(v.ChatAgentRequest.to(i),{history:m},y.apiObject,a);return await(0,L.$5g)(Promise.resolve(I).then(d=>{if(d?.metadata)try{JSON.stringify(d.metadata)}catch(w){const b=`result.metadata MUST be JSON.stringify-able. Got error: ${w.message}`;return this.i.error(`[${c.extension.identifier.value}] [@${c.id}] ${b}`,c.extension),{errorDetails:{message:b},timings:y.timings}}return{errorDetails:d?.errorDetails,timings:y.timings,metadata:d?.metadata}}),a)}catch(m){return this.i.error(m,c.extension),{errorDetails:{message:(0,D.localize)(0,null,(0,P.$2i)(m)),responseIsIncomplete:!0}}}finally{y.close()}}async k(l,i){const $=[];for(const a of i.history){const c=v.ChatAgentResult.to(a.result),E=l.agentId===a.request.agentId?c:{...c,metadata:void 0};$.push(new p.$ZN(a.request.message,a.request.command,a.request.variables.variables.map(v.ChatAgentResolvedVariable.to),{extensionId:"",agent:a.request.agentId}));const y=(0,S.$Hb)(a.response.map(m=>v.ChatResponsePart.from(m,this.j.converter)));$.push(new p.$1N(y,E,{extensionId:"",agent:a.request.agentId}))}return $}$releaseSession(l){this.g.deleteAndDispose(l)}async $provideSlashCommands(l,i){const $=this.b.get(l);return $?$.provideSlashCommands(i):[]}async $provideFollowups(l,i,$,a){const c=this.b.get(i);if(!c)return Promise.resolve([]);const E=v.ChatAgentResult.to($);return(await c.provideFollowups(E,a)).map(y=>v.ChatFollowup.from(y,l))}$acceptFeedback(l,i,$,a){const c=this.b.get(l);if(!c)return;const E=v.ChatAgentResult.to(i);let y;switch($){case s.InteractiveSessionVoteDirection.Down:y=p.ChatAgentResultFeedbackKind.Unhelpful;break;case s.InteractiveSessionVoteDirection.Up:y=p.ChatAgentResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(a?{result:E,kind:y,reportIssue:a}:{result:E,kind:y}))}$acceptAction(l,i,$){const a=this.b.get(l);if(!a||$.action.kind==="vote")return;const c=v.ChatAgentUserActionEvent.to(i,$,this.j.converter);c&&a.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(l,i,$){const a=this.b.get(l);return a?(await a.invokeCompletionProvider(i,$)).map(v.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(l,i){const $=this.b.get(l);if($)return await $.provideWelcomeMessage(i)}async $provideSampleQuestions(l,i){const $=this.b.get(l);if($)return(await $.provideSampleQuestions(i)).map(a=>v.ChatFollowup.from(a,void 0))}}e.$Ghc=n;class r{constructor(l,i,$,a,c){this.extension=l,this.id=i,this.w=$,this.x=a,this.y=c,this.o=new F.$5d,this.p=new F.$5d}acceptFeedback(l){this.o.fire(l)}acceptAction(l){this.p.fire(l)}async invokeCompletionProvider(l,i){return this.s?await this.s.provider.provideCompletionItems(l,i)??[]:[]}async provideSlashCommands(l){if(!this.a)return[];const i=await this.a.provideCommands(l);return i?i.map($=>("repopulate2"in $&&(0,o.$VF)(this.extension,"chatAgents2Additions"),{name:$.name,description:$.description,followupPlaceholder:$.isSticky2?.placeholder,shouldRepopulate:$.isSticky2?.isSticky??$.isSticky,sampleRequest:$.sampleRequest})):[]}async provideFollowups(l,i){if(!this.b)return[];const $=await this.b.provideFollowups(l,i);return $?$.filter(a=>!(a&&"commandId"in a)).filter(a=>!(a&&"message"in a)):[]}async provideWelcomeMessage(l){if(!this.t)return[];const i=await this.t.provideWelcomeMessage(l);return i?i.map($=>typeof $=="string"?$:v.MarkdownString.from($)):[]}async provideSampleQuestions(l){if(!this.t||!this.t.provideSampleQuestions)return[];const i=await this.t.provideSampleQuestions(l);return i||[]}get apiAgent(){let l=!1,i=!1;const $=()=>{l||i||(i=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{description:this.d??"",fullName:this.g,icon:this.i?this.i instanceof A.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$UM?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.b!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:v.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u}),i=!1}))},a=this;return{get name(){return a.id},get description(){return a.d??""},set description(c){a.d=c,$()},get fullName(){return a.g??a.extension.displayName??a.extension.name},set fullName(c){a.g=c,$()},get iconPath(){return a.i},set iconPath(c){a.i=c,$()},get requestHandler(){return a.y},set requestHandler(c){(0,k.$3f)(typeof c=="function","Invalid request handler"),a.y=c},get commandProvider(){return a.a},set commandProvider(c){a.a=c,$()},get followupProvider(){return a.b},set followupProvider(c){a.b=c,$()},get isDefault(){return(0,o.$VF)(a.extension,"defaultChatAgent"),a.j},set isDefault(c){(0,o.$VF)(a.extension,"defaultChatAgent"),a.j=c,$()},get helpTextPrefix(){return(0,o.$VF)(a.extension,"defaultChatAgent"),a.k},set helpTextPrefix(c){if((0,o.$VF)(a.extension,"defaultChatAgent"),!a.j)throw new Error("helpTextPrefix is only available on the default chat agent");a.k=c,$()},get helpTextPostfix(){return(0,o.$VF)(a.extension,"defaultChatAgent"),a.l},set helpTextPostfix(c){if((0,o.$VF)(a.extension,"defaultChatAgent"),!a.j)throw new Error("helpTextPostfix is only available on the default chat agent");a.l=c,$()},get isSecondary(){return(0,o.$VF)(a.extension,"defaultChatAgent"),a.n},set isSecondary(c){(0,o.$VF)(a.extension,"defaultChatAgent"),a.n=c,$()},get sampleRequest(){return a.m},set sampleRequest(c){a.m=c,$()},get supportIssueReporting(){return(0,o.$VF)(a.extension,"chatAgents2Additions"),a.q},set supportIssueReporting(c){(0,o.$VF)(a.extension,"chatAgents2Additions"),a.q=c,$()},get onDidReceiveFeedback(){return a.o.event},set agentVariableProvider(c){if((0,o.$VF)(a.extension,"chatAgents2Additions"),a.s=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");a.w.$registerAgentCompletionsProvider(a.x,c.triggerCharacters)}else a.w.$unregisterAgentCompletionsProvider(a.x)},get agentVariableProvider(){return(0,o.$VF)(a.extension,"chatAgents2Additions"),a.s},set welcomeMessageProvider(c){(0,o.$VF)(a.extension,"defaultChatAgent"),a.t=c,$()},get welcomeMessageProvider(){return(0,o.$VF)(a.extension,"defaultChatAgent"),a.t},onDidPerformAction:(0,o.$UF)(this.extension,"chatAgents2Additions")?this.p.event:void 0,get isSticky(){return a.u},set isSticky(c){a.u=c,$()},dispose(){l=!0,a.a=void 0,a.b=void 0,a.o.dispose(),a.w.$unregisterAgent(a.x)}}}invoke(l,i,$,a){return this.y(l,i,$,a)}}}),define(Ae[249],Me([1,0,21,6,3,8,99,22,11,5,159,104]),function(fe,e,S,L,P,F,R,g,f,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class h{constructor(o,t){this.option=o,this.stream=new f.$Hh,this.stream=t??new f.$Hh}}class v{constructor(o,t){this.cts=t,this.a=new Map,this.b=new f.$Hh,this.c=!1;const n=this;this.apiObject={result:o,stream:n.b.asyncIterable},o.finally(()=>{if(this.c=!0,this.a.size>0)for(const[,r]of this.a)r.stream.resolve();else this.b.resolve()})}handleFragment(o){if(this.c)return;let t=this.a.get(o.index);t||(this.a.size===0?t=new h(o.index,this.b):t=new h(o.index),this.a.set(o.index,t)),t.stream.emitOne(o.part)}}class p{static{this.a=1}constructor(o,t,n){this.j=t,this.k=n,this.c=new k.$5d,this.d=new k.$5d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Set,this.h=new g.$ym,this.i=new Map,this.b=o.getProxy(P.$XL.MainThreadChatProvider)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(o,t,n,r){const u=p.a++;this.f.set(u,{extension:o.identifier,provider:n});let l;return r.auth&&(l={providerLabel:o.displayName||o.name,accountLabel:typeof r.auth=="object"?r.auth.label:void 0}),this.b.$registerProvider(u,t,{extension:o.identifier,model:r.name??"",auth:l}),(0,L.$Rc)(()=>{this.f.delete(u),this.b.$unregisterProvider(u)})}async $provideLanguageModelResponse(o,t,n,r,u,l){const i=this.f.get(o);if(!i)return;const $=new R.$Hv(async a=>{if(l.isCancellationRequested){this.j.warn(`[CHAT](${i.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(t,{index:a.index,part:a.part})});return i.provider.provideLanguageModelResponse2(r.map(F.LanguageModelMessage.to),u,g.$wm.toKey(n),$,l)}$updateLanguageModels(o){const t=[],n=[];if(o.added)for(const r of o.added)this.g.add(r),t.push(r);if(o.removed)for(const r of o.removed){this.g.delete(r),n.push(r);for(const[u,l]of this.i)l.languageModelId===r&&(l.res.cts.cancel(),this.i.delete(u))}this.d.fire(Object.freeze({added:Object.freeze(t),removed:Object.freeze(n)}))}getLanguageModelIds(){return Array.from(this.g)}$updateModelAccesslist(o){const t=new Array;for(const{from:n,to:r,enabled:u}of o){const l=this.h.get(n)??new g.$xm;if(l.has(r)!==u){u?l.add(r):l.delete(r),this.h.set(n,l);const $={from:n,to:r};t.push($),this.c.fire($)}}}async requestLanguageModelAccess(o,t,n){const r=o.identifier,u=n?.justification,l=await this.b.$prepareChatAccess(r,t,u);if(!l)throw new Error(`Language model '${t}' NOT found`);this.m(r,l)&&await this.l(o,{identifier:l.extension,displayName:l.auth.providerLabel},u);const i=this;return{get model(){return l.model},get isRevoked(){return i.m(r,l)&&!i.h.get(r)?.has(l.extension)||!i.g.has(t)},get onDidChangeAccess(){const $=k.Event.filter(i.d.event,c=>c.removed.includes(t)),a=k.Event.filter(i.c.event,c=>g.$wm.equals(c.from,r)&&g.$wm.equals(c.to,l.extension));return k.Event.signal(k.Event.any($,a))},makeChatRequest($,a,c){if(i.m(r,l)&&!i.h.get(r)?.has(l.extension))throw new Error("Access to chat has been revoked");if(!i.g.has(t))throw new Error("Language Model has been removed");const E=new S.$ce(c),y=Math.random()*1e6|0,m=i.b.$fetchResponse(r,t,y,$.map(F.LanguageModelMessage.from),a??{},E.token),I=new v(m,E);return i.i.set(y,{languageModelId:t,res:I}),m.finally(()=>{i.i.delete(y),E.dispose()}),I.apiObject}}}async $handleResponseFragment(o,t){const n=this.i.get(o);n&&n.res.handleFragment(t)}async l(o,t,n){const r=D.$4K+t.identifier.value;if(!await this.k.getSession(o,r,[],{silent:!0}))try{const l=n?(0,A.localize)(0,null,t.displayName,n):(0,A.localize)(1,null,t.displayName);await this.k.getSession(o,r,[],{forceNewSession:{detail:l}})}catch{throw new Error("Access to language models has not been granted")}this.$updateModelAccesslist([{from:o.identifier,to:t.identifier,enabled:!0}])}m(o,t){return!!t.auth&&!g.$wm.equals(t.extension,o)}}e.$Hhc=p}),define(Ae[250],Me([1,0,15,6,3,8,7,23]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;class f{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(P.$XL.MainThreadChatVariables)}async $resolveVariable(D,h,v,p){const s=this.b.get(D);if(s)try{if(s.resolver.resolve2){(0,g.$VF)(s.extension,"chatAgents2Additions");const o=new k(h,this.c),t=await s.resolver.resolve2(s.data.name,{prompt:v},o.apiObject,p);if(t)return t.map(F.ChatVariable.from)}else{const o=await s.resolver.resolve(s.data.name,{prompt:v},p);if(o)return o.map(F.ChatVariable.from)}}catch(o){(0,S.$2)(o)}}registerVariableResolver(D,h,v,p){const s=f.a++;return this.b.set(s,{extension:D,data:{name:h,description:v},resolver:p}),this.c.$registerVariable(s,{name:h,description:v}),(0,L.$Rc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$Ihc=f;class k{constructor(D,h){this.c=D,this.d=h,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let h=function(p){if(D.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,p),s}};const D=this,v=p=>{this.d.$handleProgressChunk(this.c,p)};this.b={progress(p){h(this.progress);const s=new R.$WN(p),o=F.ChatResponseProgressPart.to(s);return v(o),this},reference(p){h(this.reference);const s=new R.$YN(p),o=F.ChatResponseReferencePart.to(s);return v(o),this},push(p){h(this.push);const s=F.ChatResponsePart.to(p);return v(s),this}}}return this.b}}}),define(Ae[251],Me([1,0,11,67,5,6,2,86,22,8,7,3,23]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;function v(p,s,o){const t=p.getProxy(D.$XL.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new f.$ym,s.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===6){const m=this.b.get(y.handle);return m?m.value:y}else if(y&&y.$mid===7){const m=this.b.get(y.commentControlHandle);if(!m)return y;const I=m.getCommentThread(y.commentThreadHandle);return I?I.value:y}else if(y&&(y.$mid===9||y.$mid===8)){const m=this.b.get(y.thread.commentControlHandle);if(!m)return y;const I=m.getCommentThread(y.thread.commentThreadHandle);return I?y.$mid===8?I.value:{thread:I.value,text:y.text}:y}else if(y&&y.$mid===10){const m=this.b.get(y.thread.commentControlHandle);if(!m)return y;const I=m.getCommentThread(y.thread.commentThreadHandle);if(!I)return y;const d=y.commentUniqueId,w=I.getCommentByUniqueId(d);return w||y}else if(y&&y.$mid===11){const m=this.b.get(y.thread.commentControlHandle);if(!m)return y;const I=m.getCommentThread(y.thread.commentThreadHandle);if(!I)return y;const d=y.text,w=y.commentUniqueId,b=I.getCommentByUniqueId(w);return b?(typeof b.body=="string"?b.body=d:b.body=new A.$oM(d),b):y}return y}})}createCommentController(y,m,I){const d=n.a++,w=new u(y,d,m,I);this.b.set(w.handle,w);const b=this.c.get(y.identifier)||[];return b.push(w),this.c.set(y.identifier,b),w.value}async $createCommentThreadTemplate(y,m,I){const d=this.b.get(y);d&&d.$createCommentThreadTemplate(m,I)}async $setActiveComment(y,m){const I=this.b.get(y);I&&I.$setActiveComment(m??void 0)}async $updateCommentThreadTemplate(y,m,I){const d=this.b.get(y);d&&d.$updateCommentThreadTemplate(m,I)}$deleteCommentThread(y,m){this.b.get(y)?.$deleteCommentThread(m)}$provideCommentingRanges(y,m,I){const d=this.b.get(y);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const w=o.getDocument(R.URI.revive(m));return(0,S.$9g)(async()=>{const b=await d.commentingRangeProvider.provideCommentingRanges(w,I);let M;return Array.isArray(b)?M={ranges:b,fileComments:!1}:b?M={ranges:b.ranges||[],fileComments:b.fileComments||!1}:M=b??void 0,M}).then(b=>{let M;return b&&(M={ranges:b.ranges.map(T=>k.Range.from(T)),fileComments:b.fileComments}),M})}$toggleReaction(y,m,I,d,w){const b=this.b.get(y);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,S.$9g)(()=>{const M=b.getCommentThread(m);if(M){const T=M.getCommentByUniqueId(d.uniqueIdInThread);if(b!==void 0&&T&&b.reactionHandler)return b.reactionHandler(T,$(w))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,m,I,d,w,b,M,T){this.m=m,this.n=I,this.o=d,this.p=w,this.q=b,this.extensionDescription=M,this.r=T,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$5d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Uc,this.l.value=new F.$Sc,this.n===void 0&&(this.n=`${y}.${this.handle}`),t.$createCommentThread(m,this.handle,this.n,this.o,k.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this.i.push({dispose:()=>{t.$deleteCommentThread(m,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(W){G.range=W},get comments(){return G.comments},set comments(W){G.comments=W},get collapsibleState(){return G.collapsibleState},set collapsibleState(W){G.collapsibleState=W},get canReply(){return G.canReply},set canReply(W){G.canReply=W},get contextValue(){return G.contextValue},set contextValue(W){G.contextValue=W},get label(){return G.label},set label(W){G.label=W},get state(){return G.state},set state(W){G.state=W},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Sc);const y=I=>Object.prototype.hasOwnProperty.call(this.b,I),m={};y("range")&&(m.range=k.Range.from(this.p)),y("label")&&(m.label=this.label),y("contextValue")&&(m.contextValue=this.contextValue??null),y("comments")&&(m.comments=this.q.map(I=>l(this,I,this.k,this.extensionDescription))),y("collapsibleState")&&(m.collapseState=a(this.g)),y("canReply")&&(m.canReply=this.canReply),y("state")&&(m.state=c(this.h)),y("isTemplate")&&(m.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,m)}getCommentByUniqueId(y){for(const m of this.k){const I=m[0],d=m[1];if(y===d)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Xe([(0,L.$Jh)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class u{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,h.$VF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,h.$VF)(this.h,"activeComment"),this.f}constructor(y,m,I,d){this.h=y,this.i=m,this.j=I,this.k=d,this.a=new Map,t.$registerCommentController(this.handle,I,d,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(b){w.options=b},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(b){w.commentingRangeProvider=b},get reactionHandler(){return w.reactionHandler},set reactionHandler(b){w.reactionHandler=b},get activeCommentThread(){return w.activeCommentThread},createCommentThread(b,M,T){return w.createCommentThread(b,M,T).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(y,m,I){m===void 0&&(0,h.$VF)(this.h,"fileComments");const d=new r(this.id,this.handle,void 0,y,m,I,this.h,!1);return this.a.set(d.handle,d),d}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const m=this.a.get(y.commentThreadHandle);m&&(this.e=y.uniqueIdInThread?m.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=m)}$createCommentThreadTemplate(y,m){const I=new r(this.id,this.handle,void 0,R.URI.revive(y),k.Range.to(m),[],this.h,!0);return I.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(y,m){const I=this.a.get(y);I&&(I.range=k.Range.to(m))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function l(E,y,m,I){let d=m.get(y);return d||(d=++E.commentHandle,m.set(y,d)),y.state!==void 0&&(0,h.$VF)(I,"commentsDraftState"),y.reactions?.some(w=>w.reactors!==void 0)&&(0,h.$VF)(I,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:d,body:typeof y.body=="string"?y.body:k.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(w=>i(w)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function i(E){return{label:E.label,iconPath:E.iconPath?k.$cO(E.iconPath):void 0,count:E.count,hasReacted:E.authorHasReacted,reactors:E.reactors&&E.reactors.length>0&&typeof E.reactors[0]!="string"?E.reactors.map(y=>y.name):E.reactors}}function $(E){return{label:E.label||"",count:E.count||0,iconPath:E.iconPath?R.URI.revive(E.iconPath):"",authorHasReacted:E.hasReacted||!1,reactors:E.reactors?.map(y=>({name:y}))}}function a(E){if(E!==void 0)switch(E){case A.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function c(E){if(E!==void 0)switch(E){case A.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new n}e.$Mhc=v}),define(Ae[252],Me([1,0,21,97,6,12,25,2,8,61,74,3,7]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;class v{constructor($,a){this.document=$,this.b=a,this.a=1,this.c=new A.$rhc("custom documents")}addEdit($){return this.c.add([$])}async undo($,a){await this.f($).undo(),a||this.disposeBackup()}async redo($,a){await this.f($).redo(),a||this.disposeBackup()}disposeEdits($){for(const a of $)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const $=l(this.document.uri)+this.a++;return(0,R.$Rg)(this.b,$)}updateBackup($){this.d?.delete(),this.d=$}disposeBackup(){this.d?.delete(),this.d=void 0}f($){const a=this.c.get($,0);if(!a)throw new Error("No edit found");return a}}class p{constructor(){this.a=new Map}get($,a){return this.a.get(this.b($,a))}add($,a,c){const E=this.b($,a.uri);if(this.a.has(E))throw new Error(`Document already exists for viewType:${$} resource:${a.uri}`);const y=new v(a,c);return this.a.set(E,y),y}delete($,a){const c=this.b($,a.uri);this.a.delete(c)}b($,a){return`${$}@@@${a}`}}var s;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(s||(s={}));class o{constructor(){this.a=new Map}addTextProvider($,a,c){return this.b(0,$,a,c)}addCustomProvider($,a,c){return this.b(1,$,a,c)}get($){return this.a.get($)}b($,a,c,E){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:$,extension:c,provider:E}),new h.$ZL(()=>this.a.delete(a))}}class t{constructor($,a,c,E,y){this.d=a,this.f=c,this.g=E,this.h=y,this.b=new o,this.c=new p,this.a=$.getProxy(D.$XL.MainThreadCustomEditors)}registerCustomEditorProvider($,a,c,E){const y=new P.$Sc;return r(c)?(y.add(this.b.addTextProvider(a,$,c)),this.a.$registerTextEditorProvider((0,k.$2hc)($),a,E.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,k.$Zhc)($))):(y.add(this.b.addCustomProvider(a,$,c)),n(c)&&y.add(c.onDidChangeCustomDocument(m=>{const I=this.i(a,m.document.uri);if(u(m)){const d=I.addEdit(m);this.a.$onDidEdit(m.document.uri,a,d,m.label)}else this.a.$onContentChange(m.document.uri,a)})),this.a.$registerCustomEditorProvider((0,k.$2hc)($),a,E.webviewOptions||{},!!E.supportsMultipleEditorsPerDocument,(0,k.$Zhc)($))),h.$ZL.from(y,new h.$ZL(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument($,a,c,E,y){const m=this.b.get(a);if(!m)throw new Error(`No provider found for '${a}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${a}'`);const I=g.URI.revive($),d=await m.provider.openCustomDocument(I,{backupId:c,untitledDocumentData:E?.buffer},y);let w;return n(m.provider)&&this.f&&(w=this.f.workspaceValue(m.extension)??this.f.globalValue(m.extension)),this.c.add(a,d,w),{editable:n(m.provider)}}async $disposeCustomDocument($,a){const c=this.b.get(a);if(!c)throw new Error(`No provider found for '${a}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${a}'`);const E=g.URI.revive($),{document:y}=this.i(a,E);this.c.delete(a,y),y.dispose()}async $resolveCustomEditor($,a,c,E,y,m){const I=this.b.get(c);if(!I)throw new Error(`No provider found for '${c}'`);const d=f.ViewColumn.to(y),w=this.g.createNewWebview(a,E.contentOptions,I.extension),b=this.h.createNewWebviewPanel(a,c,E.title,d,E.options,w,E.active),M=g.URI.revive($);switch(I.type){case 1:{const{document:T}=this.i(c,M);return I.provider.resolveCustomEditor(T,b,m)}case 0:{const T=this.d.getDocument(M);return I.provider.resolveCustomTextEditor(T,b,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits($,a,c){this.i(a,$).disposeEdits(c)}async $onMoveCustomEditor($,a,c){const E=this.b.get(c);if(!E)throw new Error(`No provider found for '${c}'`);if(!E.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const y=this.h.getWebviewPanel($);if(!y)throw new Error("No webview found");const m=g.URI.revive(a),I=this.d.getDocument(m);await E.provider.moveCustomTextEditor(I,y,S.CancellationToken.None)}async $undo($,a,c,E){return this.i(a,$).undo(c,E)}async $redo($,a,c,E){return this.i(a,$).redo(c,E)}async $revert($,a,c){const E=this.i(a,$);await this.j(a).revertCustomDocument(E.document,c),E.disposeBackup()}async $onSave($,a,c){const E=this.i(a,$);await this.j(a).saveCustomDocument(E.document,c),E.disposeBackup()}async $onSaveAs($,a,c,E){const y=this.i(a,$);return this.j(a).saveCustomDocumentAs(y.document,g.URI.revive(c),E)}async $backup($,a,c){const E=this.i(a,$),m=await this.j(a).backupCustomDocument(E.document,{destination:E.getNewBackupUri()},c);return E.updateBackup(m),m.id}i($,a){const c=this.c.get($,g.URI.revive(a));if(!c)throw new Error("No custom document found");return c}j($){const c=this.b.get($)?.provider;if(!c||!n(c))throw new Error("Custom document is not editable");return c}}e.$5hc=t;function n(i){return!!i.onDidChangeCustomDocument}function r(i){return typeof i.resolveCustomTextEditor=="function"}function u(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function l(i){const $=i.scheme===F.Schemas.file||i.scheme===F.Schemas.untitled?i.fsPath:i.toString();return(0,L.$5i)($)+""}}),define(Ae[253],Me([1,0,160,98,2,3,7,8,5,14,28,43]),function(fe,e,S,L,P,F,R,g,f,k,A,D){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=e.$yhc=void 0;class v{#e;#t;#i;constructor(o,t,n,r,u,l,i,$){this.d=o,this.e=t,this.f=n,this.g=r,this.h=u,this.c=!1,this.f=Math.max(r,n),this.#i=new A.$Ac(a=>l.getComparisonKey(a)),this.#e=i,this.#t=$}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,t){if(!o){this.clear();return}this.j();let n=[];if(P.URI.isUri(o)){if(!t){this.delete(o);return}this.#i.set(o,t.slice()),n=[o]}else if(Array.isArray(o)){n=[];let l;o=[...o].sort(v.k);for(const i of o){const[$,a]=i;if((!l||$.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=$,n.push($),this.#i.set($,[])),a)this.#i.get($)?.push(...a);else{const c=this.#i.get($);c&&(c.length=0)}}}if(this.#t.fire(n),!this.#e)return;const r=[];let u=0;for(const l of n){let i=[];const $=this.#i.get(l);if($)if($.length>this.g){i=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const E of $)if(E.severity===a[c]&&i.push({...g.Diagnostic.from(E),modelVersionId:this.h(l)})===this.g)break e;i.push({severity:L.MarkerSeverity.Info,message:(0,S.localize)(0,null,$.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=$.map(a=>({...g.Diagnostic.from(a),modelVersionId:this.h(l)}));if(r.push([l,i]),u+=i.length,u>this.f)break}this.#e.$changeMany(this.e,r)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,t){this.j();for(const[n,r]of this)o.call(t,n,r,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const t=this.#i.get(o);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,t){return o[0].toString()<t[0].toString()?-1:o[0].toString()>t[0].toString()?1:0}}e.$yhc=v;let p=class{static{h=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*h.d}static _mapper(o){const t=new A.$Ac;for(const n of o)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(o,t,n,r){this.j=t,this.k=n,this.l=r,this.g=new Map,this.h=new f.$9d({merge:u=>u.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,h._mapper),this.f=o.getProxy(F.$XL.MainThreadDiagnostics)}createDiagnosticCollection(o,t){const{g:n,f:r,h:u,j:l,k:i,l:$}=this,a=new class{$changeMany(y,m){r.$changeMany(y,m),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,y,m.length===0?"CLEARING":m)}$clear(y){r.$clear(y),l.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,y)}dispose(){r.dispose()}};let c;if(!t)t="_generated_diagnostic_collection_name_#"+h.c++,c=t;else if(!n.has(t))c=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do c=t+h.c++;while(n.has(c))}return new class extends v{constructor(){super(t,c,h.e,h.d,y=>$.getDocument(y)?.version,i.extUri,a,u),n.set(c,this)}dispose(){super.dispose(),n.delete(c)}}}getDiagnostics(o){if(o)return this.m(o);{const t=new Map,n=[];for(const r of this.g.values())r.forEach((u,l)=>{let i=t.get(u.toString());typeof i>"u"&&(i=n.length,t.set(u.toString(),i),n.push([u,[]])),n[i][1]=n[i][1].concat(...l)});return n}}m(o){let t=[];for(const n of this.g.values())n.has(o)&&(t=t.concat(n.get(o)));return t}$acceptMarkersChange(o){if(!this.n){const t="_generated_mirror",n=new v(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,r=>{},this.k.extUri,void 0,this.h);this.g.set(t,n),this.n=n}for(const[t,n]of o)this.n.set(P.URI.revive(t),n.map(g.Diagnostic.to))}};e.$zhc=p,e.$zhc=p=h=Xe([qe(1,k.$yj),qe(2,D.$xhc)],p)}),define(Ae[254],Me([1,0,2,15,7,8,187]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=void 0;class g{constructor(k,A,D,h={timeout:1500,errors:3}){this.c=k,this.d=A,this.f=D,this.g=h,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(A,D,h)=>{const p={dispose:this.a.push([A,D,k])};return Array.isArray(h)&&h.push(p),p}}async $participateInSave(k,A){const D=S.URI.revive(k);let h=!1;const v=setTimeout(()=>h=!0,this.g.timeout),p=[];try{for(const s of[...this.a]){if(h)break;const o=this.d.getDocument(D),t=await this.h(s,{document:o,reason:F.TextDocumentSaveReason.to(A)});p.push(t)}}finally{clearTimeout(v)}return p}h([k,A,D],h){const v=this.b.get(k);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(D,k,A,h).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const s=this.b.get(k);this.b.set(k,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,A,D,h){const v=[],p=Date.now(),{document:s,reason:o}=h,{version:t}=s,n=Object.freeze({document:s,reason:o,waitUntil(r){if(Object.isFrozen(v))throw(0,L.$8)("waitUntil can not be called async");v.push(Promise.resolve(r))}});try{A.apply(D,[n])}catch(r){return Promise.reject(r)}return Object.freeze(v),new Promise((r,u)=>{const l=setTimeout(()=>u(new Error("timeout")),this.g.timeout);return Promise.all(v).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(l),r(i)}).catch(i=>{clearTimeout(l),u(i)})}).then(r=>{const u={edits:[]};for(const l of r)if(Array.isArray(l)&&l.every(i=>i instanceof P.$7L))for(const{newText:i,newEol:$,range:a}of l)u.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:a&&F.Range.from(a),text:i,eol:$&&F.EndOfLine.from($)}});if(u.edits.length!==0)return t===s.version?this.f.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.$Gic=g}),define(Ae[255],Me([1,0,5,6,2,3,109,8,16,26,7]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class D{constructor(v,p){this.a=new S.$5d,this.b=new S.$5d,this.c=new S.$5d,this.d=new S.$5d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Sc,this.h=new Map,this.f=v.getProxy(F.$XL.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const p=this.g.getDocument(v);if(p)return p}getDocument(v){const p=this.getDocumentData(v);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return p.document}ensureDocumentData(v){const p=this.g.getDocument(v);if(p)return Promise.resolve(p);let s=this.h.get(v.toString());return s||(s=this.f.$tryOpenDocument(v).then(o=>{this.h.delete(v.toString());const t=P.URI.revive(o);return(0,f.$4f)(this.g.getDocument(t))},o=>(this.h.delete(v.toString()),Promise.reject(o))),this.h.set(v.toString(),s)),s}createDocumentData(v){return this.f.$tryCreateDocument(v).then(p=>P.URI.revive(p))}$acceptModelLanguageChanged(v,p){const s=P.URI.revive(v),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(p),this.a.fire(o.document)}$acceptModelSaved(v){const p=P.URI.revive(v),s=this.g.getDocument(p);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(v,p){const s=P.URI.revive(v),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(p),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,p,s){const o=P.URI.revive(v),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");t._acceptIsDirty(s),t.onEvents(p);let n;p.isUndoing?n=A.TextDocumentChangeReason.Undo:p.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,k.$In)({document:t.document,contentChanges:p.changes.map(r=>({range:g.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:n}))}setWordDefinitionFor(v,p){(0,R.$fO)(v,p)}}e.$Ahc=D}),define(Ae[64],Me([1,0,256,5,16,2,4,3,17,8,7]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=e.$6hc=void 0,e.$6hc=(0,R.$ei)("IExtHostEditorTabs");class D{constructor(o,t,n){this.e=n,this.d=t,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$HN(F.URI.revive(this.b.input.uri));case 2:return new A.$IN(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified));case 3:return new A.$JN(F.URI.revive(this.b.input.base),F.URI.revive(this.b.input.input1),F.URI.revive(this.b.input.input2),F.URI.revive(this.b.input.result));case 6:return new A.$KN(F.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$LN(this.b.input.viewType);case 4:return new A.$MN(F.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$NN(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$ON;case 9:return new A.$PN(F.URI.revive(this.b.input.uri),F.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$QN(this.b.input.providerId);default:return}}}class h{constructor(o,t){this.c=[],this.d="",this.b=o,this.e=t;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new D(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return k.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new D(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const t=this.c.find(n=>n.tabId===o.tabDto.id);if(!t)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(o.tabDto),t}activeTabId(){return this.d}}let v=class{constructor(o){this.b=new L.$5d,this.c=new L.$5d,this.e=[],this.a=o.getProxy(g.$XL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,t={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,P.$4f)(o.e.find(u=>u.groupId===n)?.apiObject)},close:async(n,r)=>{const u=Array.isArray(n)?n:[n];return u.length?p(u[0])?this.j(u,r):this.i(u,r):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(o){const t=new Set(this.e.map(a=>a.groupId)),n=new Set(o.map(a=>a.groupId)),r=(0,S.$L)(t,n),u=this.e.filter(a=>r.removed.includes(a.groupId)).map(a=>a.apiObject),l=[],i=[];this.e=o.map(a=>{const c=new h(a,()=>this.d);return r.added.includes(c.groupId)?l.push(c.apiObject):i.push(c.apiObject),c});const $=(0,P.$4f)(o.find(a=>a.isActive===!0)?.groupId);$!==void 0&&this.d!==$&&(this.d=$),this.c.fire(Object.freeze({opened:l,closed:u,changed:i}))}$acceptTabGroupUpdate(o){const t=this.e.find(n=>n.groupId===o.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const t=this.e.find(r=>r.groupId===o.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const t of this.e)for(const n of t.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(t=>t.apiObject===o)}async i(o,t){const n=[];for(const r of o){const u=this.g(r);if(!u)throw new Error("Tab close: Invalid tab not found!");n.push(u.tabId)}return this.a.$closeTab(n,t)}async j(o,t){const n=[];for(const r of o){const u=this.h(r);if(!u)throw new Error("Group close: Invalid group not found!");n.push(u.groupId)}return this.a.$closeGroup(n,t)}};e.$7hc=v,e.$7hc=v=Xe([qe(0,f.$dO)],v);function p(s){return s.tabs!==void 0}}),define(Ae[257],Me([1,0,2,3,6,7,8,299,13,24,23,46]),function(fe,e,S,L,P,F,R,g,f,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=void 0;class h{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const o=this.a.indexOf(s);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),o=[];let t,n,r=14,u=14;for(const l of s){let i=t?(0,f.$lf)(t,l):0;for(i===0?n=1:n=u;i<l.length;i++)i+1===l.length?(r=u,u=9):u+=1,o.push([n,l.toUpperCase().charCodeAt(i),u]),o.push([n,l.toLowerCase().charCodeAt(i),u]),n=u;t=l,u=r}o.push([9,58,10]),o.push([10,47,12]),this.b=new g.$21(o)}}provideDocumentLinks(s){this.c();const o=[],t=g.$31.computeLinks({getLineContent(n){return s.lineAt(n-1).text},getLineCount(){return s.lineCount}},this.b);for(const n of t){const r=R.DocumentLink.to(n);r.target&&o.push(r)}return o}}class v{constructor(s,o){this.i=o,this.b=new h,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(L.$XL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,o,t,n={}){if(v.j(t),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const r=this.h++;this.b.add(o),this.d.add(o),this.c.set(r,t);let u=2;n.isCaseSensitive&&(u+=1024),n.isReadonly&&(u+=2048),typeof t.copy=="function"&&(u+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,A.$VF)(s,"fsChunks"),u+=4);let l;n.isReadonly&&(0,D.$uk)(n.isReadonly)&&n.isReadonly.value!==""&&(l={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(r,o,u,l).catch($=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${o}`),console.error($)});const i=t.onDidChangeFile($=>{const a=[];for(const c of $){const{uri:E,type:y}=c;if(E.scheme!==o)continue;let m;switch(y){case F.FileChangeType.Changed:m=0;break;case F.FileChangeType.Created:m=1;break;case F.FileChangeType.Deleted:m=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:E,type:m})}this.a.$onFileSystemChange(r,a)});return(0,P.$Rc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(r),this.a.$unregisterProvider(r)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:o,ctime:t,mtime:n,size:r,permissions:u}=s;return{type:o,ctime:t,mtime:n,size:r,permissions:u}}$stat(s,o){return Promise.resolve(this.l(s).stat(S.URI.revive(o))).then(t=>v.k(t))}$readdir(s,o){return Promise.resolve(this.l(s).readDirectory(S.URI.revive(o)))}$readFile(s,o){return Promise.resolve(this.l(s).readFile(S.URI.revive(o))).then(t=>k.$se.wrap(t))}$writeFile(s,o,t,n){return Promise.resolve(this.l(s).writeFile(S.URI.revive(o),t.buffer,n))}$delete(s,o,t){return Promise.resolve(this.l(s).delete(S.URI.revive(o),t))}$rename(s,o,t,n){return Promise.resolve(this.l(s).rename(S.URI.revive(o),S.URI.revive(t),n))}$copy(s,o,t,n){const r=this.l(s);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(S.URI.revive(o),S.URI.revive(t),n))}$mkdir(s,o){return Promise.resolve(this.l(s).createDirectory(S.URI.revive(o)))}$watch(s,o,t,n){const r=this.l(s).watch(S.URI.revive(t),n);this.f.set(o,r)}$unwatch(s,o){const t=this.f.get(o);t&&(t.dispose(),this.f.delete(o))}$open(s,o,t){const n=this.l(s);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(S.URI.revive(o),t))}$close(s,o){const t=this.l(s);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(o))}$read(s,o,t,n){const r=this.l(s);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const u=k.$se.alloc(n);return Promise.resolve(r.read(o,t,u.buffer,0,n)).then(l=>u.slice(0,l))}$write(s,o,t,n){const r=this.l(s);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(o,t,n.buffer,0,n.byteLength))}l(s){const o=this.c.get(s);if(!o){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return o}}e.$Iic=v}),define(Ae[258],Me([1,0,5,34,2,3,8,7,39]),function(fe,e,S,L,P,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,p,s,o,t,n){this.a=Math.random(),this.b=new S.$5d,this.c=new S.$5d,this.d=new S.$5d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const r=(0,L.$Xj)(t),u=typeof t=="string",l=n?.correlate,i=o($=>{if(!(typeof $.session=="number"&&$.session!==this.a)&&!(l&&typeof $.session>"u")){if(!n?.ignoreCreateEvents)for(const a of $.created){const c=P.URI.revive(a);r(c.fsPath)&&(!u||p.getWorkspaceFolder(c))&&this.b.fire(c)}if(!n?.ignoreChangeEvents)for(const a of $.changed){const c=P.URI.revive(a);r(c.fsPath)&&(!u||p.getWorkspaceFolder(c))&&this.c.fire(c)}if(!n?.ignoreDeleteEvents)for(const a of $.deleted){const c=P.URI.revive(a);r(c.fsPath)&&(!u||p.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=g.$ZL.from(this.i(v,s,t,n,n?.correlate),this.b,this.c,this.d,i)}i(v,p,s,o,t){const n=g.$ZL.from();if(typeof s=="string")return n;const r=v.getProxy(F.$XL.MainThreadFileSystemEventService);let u=!1;return(s.pattern.includes(L.$Tj)||s.pattern.includes(L.$Uj))&&(u=!0),r.$watch(p.identifier.value,this.a,s.baseUri,{recursive:u,excludes:o?.excludes??[]},!!t),g.$ZL.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(v){this.a=v,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(P.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(P.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(v,p,s){this.j=v,this.k=p,this.l=s,this.a=new S.$5d,this.b=new S.$5d,this.c=new S.$5d,this.d=new S.$5d,this.g=new S.$7d,this.h=new S.$7d,this.i=new S.$7d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,p,s,o){return new k(this.j,v,p,this.a.event,R.GlobPattern.from(s),o)}$onFileEvent(v){this.a.fire(new A(v))}$onDidRunFileOperation(v,p){switch(v){case 2:this.b.fire(Object.freeze({files:p.map(s=>({oldUri:P.URI.revive(s.source),newUri:P.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(s=>P.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(s=>P.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,p){return(s,o,t)=>{const n=function(u){s.call(o,u)};return n.extension=v,p.event(n,void 0,t)}}async $onWillRunFileOperation(v,p,s,o){switch(v){case 2:return await this.n(this.g,{files:p.map(t=>({oldUri:P.URI.revive(t.source),newUri:P.URI.revive(t.target)}))},s,o);case 1:return await this.n(this.i,{files:p.map(t=>P.URI.revive(t.target))},s,o);case 0:case 3:return await this.n(this.h,{files:p.map(t=>P.URI.revive(t.target))},s,o)}}async n(v,p,s,o){const t=new Set,n=[];if(await v.fireAsync(p,o,async(u,l)=>{const i=Date.now(),$=await Promise.resolve(u);$ instanceof g.$0L&&(n.push([l.extension,$]),t.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-i>s&&this.k.warn("SLOW file-participant",l.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const r={edits:[]};for(const[,u]of n){const{edits:l}=R.WorkspaceEdit.from(u,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(l)}return{edit:r,extensionNames:Array.from(t)}}}e.$Jic=D}),define(Ae[259],Me([1,0,18,11,21,15,88,6,26,63,13,16,2,29,300,86,95,162,22,8,7,23,74,3]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r,u,l,i,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;class a{constructor(N,j){this.d=N,this.e=j}async provideDocumentSymbols(N,j){const K=this.d.getDocument(N),H=await this.e.provideDocumentSymbols(K,j);if(!(0,S.$Kb)(H))return H[0]instanceof u.$gM?H.map(r.DocumentSymbol.from):a.f(H)}static f(N){N=N.slice(0).sort((H,te)=>{let oe=H.location.range.start.compareTo(te.location.range.start);return oe===0&&(oe=te.location.range.end.compareTo(H.location.range.end)),oe});const j=[],K=[];for(const H of N){const te={name:H.name||"!!MISSING: name!!",kind:r.SymbolKind.from(H.kind),tags:H.tags?.map(r.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:r.Range.from(H.location.range),selectionRange:r.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(te),j.push(te);break}const oe=K[K.length-1];if(v.$6s.containsRange(oe.range,te.range)&&!v.$6s.equalsRange(oe.range,te.range)){oe.children?.push(te),K.push(te);break}K.pop()}}return j}}class c{constructor(N,j,K,H,te,oe){this.f=N,this.g=j,this.h=K,this.j=H,this.k=te,this.l=oe,this.d=new i.$rhc("CodeLens"),this.e=new Map}async provideCodeLenses(N,j){const K=this.f.getDocument(N),H=await this.h.provideCodeLenses(K,j);if(!H||j.isCancellationRequested)return;const te=this.d.add(H),oe=new g.$Sc;this.e.set(te,oe);const Oe={cacheId:te,lenses:[]};for(let Ve=0;Ve<H.length;Ve++)Oe.lenses.push({cacheId:[te,Ve],range:r.Range.from(H[Ve].range),command:this.g.toInternal(H[Ve].command,oe)});return Oe}async resolveCodeLens(N,j){const K=N.cacheId&&this.d.get(...N.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,j),H||(H=K),j.isCancellationRequested)return;const te=N.cacheId&&this.e.get(N.cacheId[0]);if(te){if(!H.command){const oe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,oe),this.l.error(oe);return}return N.command=this.g.toInternal(H.command,te),N}}releaseCodeLenses(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}}function E(ze){return Array.isArray(ze)?ze.map(r.DefinitionLink.from):ze?[r.DefinitionLink.from(ze)]:[]}class y{constructor(N,j){this.d=N,this.e=j}async provideDefinition(N,j,K){const H=this.d.getDocument(N),te=r.Position.to(j),oe=await this.e.provideDefinition(H,te,K);return E(oe)}}class m{constructor(N,j){this.d=N,this.e=j}async provideDeclaration(N,j,K){const H=this.d.getDocument(N),te=r.Position.to(j),oe=await this.e.provideDeclaration(H,te,K);return E(oe)}}class I{constructor(N,j){this.d=N,this.e=j}async provideImplementation(N,j,K){const H=this.d.getDocument(N),te=r.Position.to(j),oe=await this.e.provideImplementation(H,te,K);return E(oe)}}class d{constructor(N,j){this.d=N,this.e=j}async provideTypeDefinition(N,j,K){const H=this.d.getDocument(N),te=r.Position.to(j),oe=await this.e.provideTypeDefinition(H,te,K);return E(oe)}}class w{constructor(N,j){this.d=N,this.e=j}async provideHover(N,j,K){const H=this.d.getDocument(N),te=r.Position.to(j),oe=await this.e.provideHover(H,te,K);if(!(!oe||(0,S.$Kb)(oe.contents)))return oe.range||(oe.range=H.getWordRangeAtPosition(te)),oe.range||(oe.range=new u.$2L(te,te)),r.Hover.from(oe)}}class b{constructor(N,j){this.d=N,this.e=j}async provideEvaluatableExpression(N,j,K){const H=this.d.getDocument(N),te=r.Position.to(j),oe=await this.e.provideEvaluatableExpression(H,te,K);if(oe)return r.EvaluatableExpression.from(oe)}}class M{constructor(N,j){this.d=N,this.e=j}async provideInlineValues(N,j,K,H){const te=this.d.getDocument(N),oe=await this.e.provideInlineValues(te,r.Range.to(j),r.InlineValueContext.to(K),H);if(Array.isArray(oe))return oe.map(Oe=>r.InlineValue.from(Oe))}}class T{constructor(N,j){this.d=N,this.e=j}async provideDocumentHighlights(N,j,K){const H=this.d.getDocument(N),te=r.Position.to(j),oe=await this.e.provideDocumentHighlights(H,te,K);if(Array.isArray(oe))return oe.map(r.DocumentHighlight.from)}}class G{constructor(N,j){this.d=N,this.e=j}async provideMultiDocumentHighlights(N,j,K,H){const te=this.d.getDocument(N),oe=K.map(He=>this.d.getDocument(He)),Oe=r.Position.to(j),Ve=await this.e.provideMultiDocumentHighlights(te,Oe,oe,H);if(Array.isArray(Ve))return Ve.map(r.MultiDocumentHighlight.from)}}class W{constructor(N,j){this.d=N,this.e=j}async provideLinkedEditingRanges(N,j,K){const H=this.d.getDocument(N),te=r.Position.to(j),oe=await this.e.provideLinkedEditingRanges(H,te,K);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,S.$Hb)(oe.ranges.map(r.Range.from)),wordPattern:oe.wordPattern}}}class U{constructor(N,j){this.d=N,this.e=j}async provideReferences(N,j,K,H){const te=this.d.getDocument(N),oe=r.Position.to(j),Oe=await this.e.provideReferences(te,oe,K,H);if(Array.isArray(Oe))return Oe.map(r.location.from)}}class C{static{this.d=1e3}constructor(N,j,K,H,te,oe,Oe){this.g=N,this.h=j,this.j=K,this.k=H,this.l=te,this.m=oe,this.n=Oe,this.e=new i.$rhc("CodeAction"),this.f=new Map}async provideCodeActions(N,j,K,H){const te=this.g.getDocument(N),oe=p.$8s.isISelection(j)?r.Selection.to(j):r.Range.to(j),Oe=[];for(const rt of this.j.getDiagnostics(N))if(oe.intersection(rt.range)&&Oe.push(rt)>C.d)break;const Ve={diagnostics:Oe,only:K.only?new u.$iM(K.only):void 0,triggerKind:r.CodeActionTriggerKind.to(K.trigger)},He=await this.k.provideCodeActions(te,oe,Ve,H);if(!(0,S.$Lb)(He)||H.isCancellationRequested)return;const xe=this.e.add(He),tt=new g.$Sc;this.f.set(xe,tt);const lt=[];for(let rt=0;rt<He.length;rt++){const it=He[rt];if(it)if(C.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),lt.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,tt)});else{Ve.only&&(it.kind?Ve.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ot=it.ranges??[];lt.push({cacheId:[xe,rt],title:it.title,command:it.command&&this.h.toInternal(it.command,tt),diagnostics:it.diagnostics&&it.diagnostics.map(r.Diagnostic.from),edit:it.edit&&r.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,l.$UF)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,l.$UF)(this.m,"codeActionRanges")?(0,S.$Hb)(ot.map(r.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:xe,actions:lt}}async resolveCodeAction(N,j){const[K,H]=N,te=this.e.get(K,H);if(!te||C.o(te))return{};if(!this.k.resolveCodeAction)return{};const oe=await this.k.resolveCodeAction(te,j)??te;let Oe;oe.edit&&(Oe=r.WorkspaceEdit.from(oe.edit,void 0));let Ve;if(oe.command){const He=this.f.get(K);He&&(Ve=this.h.toInternal(oe.command,He))}return{edit:Oe,command:Ve}}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}class O{static toInternalProviderId(N,j){return N+"."+j}constructor(N,j,K,H,te){this.d=N,this.e=j,this.f=K,this.g=H,this.h=te}async prepareDocumentPaste(N,j,K,H){if(!this.f.prepareDocumentPaste)return;const te=this.e.getDocument(N),oe=j.map(He=>r.Range.to(He)),Oe=r.DataTransfer.toDataTransfer(K,()=>{throw new F.$$});if(await this.f.prepareDocumentPaste(te,oe,Oe,H),H.isCancellationRequested)return;const Ve=Array.from(Oe).filter(([,He])=>!(He instanceof u.$OM));return r.DataTransfer.from(Ve)}async providePasteEdits(N,j,K,H,te){if(!this.f.provideDocumentPasteEdits)return;const oe=this.e.getDocument(j),Oe=K.map(xe=>r.Range.to(xe)),Ve=r.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolvePasteFileData(this.g,N,xe)).buffer),He=await this.f.provideDocumentPasteEdits(oe,Oe,Ve,te);if(He)return{label:He.label??(0,t.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:O.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?r.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class V{constructor(N,j){this.d=N,this.e=j}async provideDocumentFormattingEdits(N,j,K){const H=this.d.getDocument(N),te=await this.e.provideDocumentFormattingEdits(H,j,K);if(Array.isArray(te))return te.map(r.TextEdit.from)}}class re{constructor(N,j){this.d=N,this.e=j}async provideDocumentRangeFormattingEdits(N,j,K,H){const te=this.d.getDocument(N),oe=r.Range.to(j),Oe=await this.e.provideDocumentRangeFormattingEdits(te,oe,K,H);if(Array.isArray(Oe))return Oe.map(r.TextEdit.from)}async provideDocumentRangesFormattingEdits(N,j,K,H){(0,D.$3f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const te=this.d.getDocument(N),oe=j.map(r.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(te,oe,K,H);if(Array.isArray(Oe))return Oe.map(r.TextEdit.from)}}class ce{constructor(N,j){this.d=N,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,j,K,H,te){const oe=this.d.getDocument(N),Oe=r.Position.to(j),Ve=await this.e.provideOnTypeFormattingEdits(oe,Oe,K,H,te);if(Array.isArray(Ve))return Ve.map(r.TextEdit.from)}}class ye{constructor(N,j){this.e=N,this.f=j,this.d=new i.$rhc("WorkspaceSymbols")}async provideWorkspaceSymbols(N,j){const K=await this.e.provideWorkspaceSymbols(N,j);if(!(0,S.$Lb)(K))return{symbols:[]};const H=this.d.add(K),te={cacheId:H,symbols:[]};for(let oe=0;oe<K.length;oe++){const Oe=K[oe];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}te.symbols.push({...r.WorkspaceSymbol.from(Oe),cacheId:[H,oe]})}return te}async resolveWorkspaceSymbol(N,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const K=this.d.get(...N.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,j);return H&&(0,f.$Kn)(N,r.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class De{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,j,K){this.d=N,this.e=j,this.f=K}async provideRenameEdits(N,j,K,H){const te=this.d.getDocument(N),oe=r.Position.to(j);try{const Oe=await this.e.provideRenameEdits(te,oe,K,H);return Oe?r.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Ve=De.g(Oe);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(N,j,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(N),te=r.Position.to(j);try{const oe=await this.e.prepareRename(H,te,K);let Oe,Ve;if(u.$2L.isRange(oe)?(Oe=oe,Ve=H.getText(oe)):(0,D.$Uf)(oe)&&(Oe=oe.range,Ve=oe.placeholder),!Oe||!Ve)return;if(Oe.start.line>te.line||Oe.end.line<te.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:r.Range.from(Oe),text:Ve}}catch(oe){const Oe=De.g(oe);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(oe)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class he{constructor(N,j,K){this.d=N,this.e=j,this.f=K}async provideNewSymbolNames(N,j,K){const H=this.d.getDocument(N),te=r.Range.to(j);try{const oe=await this.e.provideNewSymbolNames(H,te,K);return oe?oe.map(Oe=>typeof Oe=="string"?{newSymbolName:Oe}:{newSymbolName:Oe.newSymbolName,tags:Oe.tags}):void 0}catch(oe){this.f.error(he.g(oe)??JSON.stringify(oe,null,"	"));return}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class ve{constructor(N,j){this.resultId=N,this.tokens=j}}class se{constructor(N,j){this.f=N,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,j,K){const H=this.f.getDocument(N),te=j!==0?this.d.get(j):null;let oe=typeof te?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,te.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return te&&this.d.delete(j),oe?(oe=se.h(oe),this.o(se.n(te,oe),oe)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return se.j(N)?se.k(N)?N:new u.$gN(new Uint32Array(N.data),N.resultId):se.l(N)?se.m(N)?N:new u.$iN(N.edits.map(j=>new u.$hN(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const j of N.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(N,j){if(!se.j(j)||!N||!N.tokens)return j;const K=N.tokens,H=K.length,te=j.data,oe=te.length;let Oe=0;const Ve=Math.min(H,oe);for(;Oe<Ve&&K[Oe]===te[Oe];)Oe++;if(Oe===H&&Oe===oe)return new u.$iN([],j.resultId);let He=0;const xe=Ve-Oe;for(;He<xe&&K[H-He-1]===te[oe-He-1];)He++;return new u.$iN([{start:Oe,deleteCount:H-Oe-He,data:te.subarray(Oe,oe-He)}],j.resultId)}o(N,j){if(se.j(N)){const K=this.e++;return this.d.set(K,new ve(N.resultId,N.data)),(0,o.$8_)({id:K,type:"full",data:N.data})}if(se.l(N)){const K=this.e++;return se.j(j)?this.d.set(K,new ve(j.resultId,j.data)):this.d.set(K,new ve(N.resultId)),(0,o.$8_)({id:K,type:"delta",deltas:(N.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class $e{constructor(N,j){this.d=N,this.e=j}async provideDocumentRangeSemanticTokens(N,j,K){const H=this.d.getDocument(N),te=await this.e.provideDocumentRangeSemanticTokens(H,r.Range.to(j),K);return te?this.f(te):null}f(N){return(0,o.$8_)({id:0,type:"full",data:N.data})}}class ee{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,j,K,H,te){this.f=N,this.g=j,this.h=K,this.j=H,this.k=te,this.d=new i.$rhc("CompletionItem"),this.e=new Map}async provideCompletionItems(N,j,K,H){const te=this.f.getDocument(N),oe=r.Position.to(j),Oe=te.getWordRangeAtPosition(oe)||new u.$2L(oe,oe),Ve=Oe.with({end:oe}),He=new k.$1d,xe=await this.h.provideCompletionItems(te,oe,H,r.CompletionContext.to(K));if(!xe||H.isCancellationRequested)return;const tt=Array.isArray(xe)?new u.$vM(xe):xe,lt=ee.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),rt=new g.$Sc;this.e.set(lt,rt);const it=[],ot={x:lt,b:it,a:{replace:r.Range.from(Oe),insert:r.Range.from(Ve)},c:tt.isIncomplete||void 0,d:He.elapsed()};for(let Be=0;Be<tt.items.length;Be++){const et=tt.items[Be],Q=this.l(et,[lt,Be],Ve,Oe);it.push(Q)}return ot}async resolveCompletionItem(N,j){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...N);if(!K)return;const H=this.l(K,N),te=await this.h.resolveCompletionItem(K,j);if(!te)return;const oe=this.l(te,N);return(H.h!==oe.h||H.i!==oe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==oe.n||H.o!==oe.o||!(0,f.$Ln)(H.p,oe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:oe.d,c:oe.c,l:oe.l,h:oe.h,i:oe.i,n:oe.n,o:oe.o,p:oe.p}}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,j,K,H){const te=this.e.get(j[0]);if(!te)throw Error("DisposableStore is missing...");const oe=this.g.toInternal(N.command,te),Oe={x:j,a:N.label,b:N.kind!==void 0?r.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(r.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:r.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(r.TextEdit.from),n:oe?.$ident,o:oe?.id,p:oe?.$ident?void 0:oe?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=N.textEdit.newText):typeof N.insertText=="string"?Oe.h=N.insertText:N.insertText instanceof u.$$L&&(Oe.h=N.insertText.value,Oe.i|=4);let Ve;return N.textEdit?Ve=N.textEdit.range:N.range&&(Ve=N.range),u.$2L.isRange(Ve)?Oe.j=r.Range.from(Ve):Ve&&(!K?.isEqual(Ve.inserting)||!H?.isEqual(Ve.replacing))&&(Oe.j={insert:r.Range.from(Ve.inserting),replace:r.Range.from(Ve.replacing)}),Oe}}class Y{async provideInlineCompletions(N,j,K,H){}disposeCompletions(N){}handleDidShowCompletionItem(N,j,K){}handlePartialAccept(N,j,K){}}class q extends Y{constructor(N,j,K,H){super(),this.f=N,this.g=j,this.h=K,this.j=H,this.d=new Se,this.e=(0,l.$UF)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:u.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:u.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,l.$UF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,j,K,H){const te=this.g.getDocument(N),oe=r.Position.to(j),Oe=await this.h.provideInlineCompletionItems(te,oe,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:r.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Oe||H.isCancellationRequested)return;const Ve=Array.isArray(Oe)?Oe:Oe.items,He=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],xe=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ve}),items:Ve.map((rt,it)=>{let ot;rt.command&&(tt||(tt=new g.$Sc),ot=this.j.toInternal(rt.command,tt));const Be=rt.insertText;return{insertText:typeof Be=="string"?Be:{snippet:Be.value},filterText:rt.filterText,range:rt.range?r.Range.from(rt.range):void 0,command:ot,idx:it,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:He.map(rt=>(tt||(tt=new g.$Sc),this.j.toInternal(rt,tt))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,j,K){const H=this.d.get(N)?.items[j];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(N,j,K){const H=this.d.get(N)?.items[j];H&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(H,K)}}class ne{async provideInlineEdits(N,j,K){const H=this.f.getDocument(N),te=await this.g.provideInlineEdit(H,{triggerKind:this.e[j.triggerKind]},K);if(!te||K.isCancellationRequested)return;let oe;const Oe=this.d.createReferenceId({dispose(){oe?.dispose()},item:te});let Ve;te.accepted&&(oe||(oe=new g.$Sc),Ve=this.h.toInternal(te.accepted,oe));let He;return te.rejected&&(oe||(oe=new g.$Sc),He=this.h.toInternal(te.rejected,oe)),{pid:Oe,text:te.text,range:r.Range.from(te.range),accepted:Ve,rejected:He}}disposeEdit(N){this.d.disposeReferenceId(N)?.dispose()}constructor(N,j,K,H){this.f=j,this.g=K,this.h=H,this.d=new Se,this.e={[s.InlineEditTriggerKind.Automatic]:u.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:u.InlineEditTriggerKind.Invoke}}}class Se{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const j=this.e++;return this.d.set(j,N),j}disposeReferenceId(N){const j=this.d.get(N);return this.d.delete(N),j}get(N){return this.d.get(N)}}class Te{constructor(N,j){this.e=N,this.f=j,this.d=new i.$rhc("SignatureHelp")}async provideSignatureHelp(N,j,K,H){const te=this.e.getDocument(N),oe=r.Position.to(j),Oe=this.g(K),Ve=await this.f.provideSignatureHelp(te,oe,H,Oe);if(Ve){const He=this.d.add([Ve]);return{...r.SignatureHelp.from(Ve),id:He}}}g(N){let j;if(N.activeSignatureHelp){const K=r.SignatureHelp.to(N.activeSignatureHelp),H=this.d.get(N.activeSignatureHelp.id,0);H?(j=H,j.activeSignature=K.activeSignature,j.activeParameter=K.activeParameter):j=K}return{...N,activeSignatureHelp:j}}releaseSignatureHelp(N){this.d.delete(N)}}class Ce{constructor(N,j,K,H,te){this.f=N,this.g=j,this.h=K,this.j=H,this.k=te,this.d=new i.$rhc("InlayHints"),this.e=new Map}async provideInlayHints(N,j,K){const H=this.f.getDocument(N),te=r.Range.to(j),oe=await this.h.provideInlayHints(H,te,K);if(!Array.isArray(oe)||oe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(K.isCancellationRequested)return;const Oe=this.d.add(oe);this.e.set(Oe,new g.$Sc);const Ve={hints:[],cacheId:Oe};for(let He=0;He<oe.length;He++)this.l(oe[He],te)&&Ve.hints.push(this.m(oe[He],[Oe,He]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),Ve}async resolveInlayHint(N,j){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...N);if(!K)return;const H=await this.h.resolveInlayHint(K,j);if(H&&this.l(H))return this.m(H,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,j){return N.label.length===0||Array.isArray(N.label)&&N.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(j&&!j.contains(N.position))}m(N,j){const K=this.e.get(j[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:j,tooltip:r.MarkdownString.fromStrict(N.tooltip),position:r.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(r.TextEdit.from),kind:N.kind&&r.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};if(typeof N.label=="string")H.label=N.label;else{const te=[];H.label=te;for(const oe of N.label){if(!oe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:oe.value,tooltip:r.MarkdownString.fromStrict(oe.tooltip)};u.$_L.isLocation(oe.location)&&(Oe.location=r.location.from(oe.location)),oe.command&&(Oe.command=this.g.toInternal(oe.command,K)),te.push(Oe)}}return H}}class be{constructor(N,j){this.e=N,this.f=j,this.d=new i.$rhc("DocumentLink")}async provideLinks(N,j){const K=this.e.getDocument(N),H=await this.f.provideDocumentLinks(K,j);if(!(!Array.isArray(H)||H.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(be.g).map(r.DocumentLink.from)};{const te=this.d.add(H),oe={links:[],cacheId:te};for(let Oe=0;Oe<H.length;Oe++){if(!be.g(H[Oe]))continue;const Ve=r.DocumentLink.from(H[Oe]);Ve.cacheId=[te,Oe],oe.links.push(Ve)}return oe}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,j){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...N);if(!K)return;const H=await this.f.resolveDocumentLink(K,j);if(!(!H||!be.g(H)))return r.DocumentLink.from(H)}releaseLinks(N){this.d.delete(N)}}class ge{constructor(N,j){this.d=N,this.e=j}async provideColors(N,j){const K=this.d.getDocument(N),H=await this.e.provideDocumentColors(K,j);return Array.isArray(H)?H.map(oe=>({color:r.Color.from(oe.color),range:r.Range.from(oe.range)})):[]}async provideColorPresentations(N,j,K){const H=this.d.getDocument(N),te=r.Range.to(j.range),oe=r.Color.to(j.color),Oe=await this.e.provideColorPresentations(oe,{document:H,range:te},K);if(Array.isArray(Oe))return Oe.map(r.ColorPresentation.from)}}class X{constructor(N,j){this.d=N,this.e=j}async provideFoldingRanges(N,j,K){const H=this.d.getDocument(N),te=await this.e.provideFoldingRanges(H,j,K);if(Array.isArray(te))return te.map(r.FoldingRange.from)}}class x{constructor(N,j,K){this.d=N,this.e=j,this.f=K}async provideSelectionRanges(N,j,K){const H=this.d.getDocument(N),te=j.map(r.Position.to),oe=await this.e.provideSelectionRanges(H,te,K);if(!(0,S.$Lb)(oe))return[];if(oe.length!==te.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Ve=0;Ve<te.length;Ve++){const He=[];Oe.push(He);let xe=te[Ve],tt=oe[Ve];for(;;){if(!tt.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(He.push(r.SelectionRange.from(tt)),!tt.parent)break;xe=tt.range,tt=tt.parent}}return Oe}}class le{constructor(N,j){this.f=N,this.g=j,this.d=new R.$iO(""),this.e=new Map}async prepareSession(N,j,K){const H=this.f.getDocument(N),te=r.Position.to(j),oe=await this.g.prepareCallHierarchy(H,te,K);if(!oe)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(oe)?oe.map(Ve=>this.h(Oe,Ve)):[this.h(Oe,oe)]}async provideCallsTo(N,j,K){const H=this.j(N,j);if(!H)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyIncomingCalls(H,K);if(te)return te.map(oe=>({from:this.h(N,oe.from),fromRanges:oe.fromRanges.map(Oe=>r.Range.from(Oe))}))}async provideCallsFrom(N,j,K){const H=this.j(N,j);if(!H)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(te)return te.map(oe=>({to:this.h(N,oe.to),fromRanges:oe.fromRanges.map(Oe=>r.Range.from(Oe))}))}releaseSession(N){this.e.delete(N)}h(N,j){const K=this.e.get(N),H=r.CallHierarchyItem.from(j,N,K.size.toString(36));return K.set(H._itemId,j),H}j(N,j){return this.e.get(N)?.get(j)}}class de{constructor(N,j){this.f=N,this.g=j,this.d=new R.$iO(""),this.e=new Map}async prepareSession(N,j,K){const H=this.f.getDocument(N),te=r.Position.to(j),oe=await this.g.prepareTypeHierarchy(H,te,K);if(!oe)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(oe)?oe.map(Ve=>this.h(Oe,Ve)):[this.h(Oe,oe)]}async provideSupertypes(N,j,K){const H=this.j(N,j);if(!H)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySupertypes(H,K);if(te)return te.map(oe=>this.h(N,oe))}async provideSubtypes(N,j,K){const H=this.j(N,j);if(!H)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySubtypes(H,K);if(te)return te.map(oe=>this.h(N,oe))}releaseSession(N){this.e.delete(N)}h(N,j){const K=this.e.get(N),H=r.TypeHierarchyItem.from(j,N,K.size.toString(36));return K.set(H._itemId,j),H}j(N,j){return this.e.get(N)?.get(j)}}class Pe{static toInternalProviderId(N,j){return N+"."+j}constructor(N,j,K,H,te){this.d=N,this.e=j,this.f=K,this.g=H,this.h=te}async provideDocumentOnDropEdits(N,j,K,H,te){const oe=this.e.getDocument(j),Oe=r.Position.to(K),Ve=r.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,xe)).buffer),He=await this.f.provideDocumentDropEdits(oe,Oe,Ve,te);if(He)return{label:He.label??(0,t.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:Pe.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?r.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class me{constructor(N,j){this.d=N,this.e=j}async provideMappedEdits(N,j,K,H){const te=h.URI.revive(N),oe=this.d.getDocument(te),Oe=K.documents.map(xe=>xe.map(tt=>({uri:h.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(lt=>r.Range.to(lt))}))),Ve={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(oe,j,Ve,H);return He?r.WorkspaceEdit.from(He):null}}class Ie{constructor(N,j){this.adapter=N,this.extension=j}}class Le{static{this.d=0}constructor(N,j,K,H,te,oe,Oe,Ve){this.g=j,this.h=K,this.j=H,this.k=te,this.l=oe,this.m=Oe,this.n=Ve,this.f=new Map,this.e=N.getProxy($.$XL.MainThreadLanguageFeatures)}o(N,j){return r.DocumentSelector.from(N,this.g,j)}p(N){return new u.$ZL(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return Le.d++}async s(N,j,K,H,te,oe=!1){const Oe=this.f.get(N);if(!Oe||!(Oe.adapter instanceof j))return H;const Ve=Date.now();oe||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const He=K(Oe.adapter,Oe.extension);return Promise.resolve(He).catch(xe=>{(0,F.$4)(xe)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Oe.extension.identifier,xe))}).finally(()=>{oe||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),P.CancellationToken.isCancellationToken(te)?(0,L.$6g)(He,te):He}t(N,j){const K=this.q();return this.f.set(K,new Ie(N,j)),K}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,j,K,H){const te=this.t(new a(this.h,K),N),oe=H&&H.label||Le.u(N);return this.e.$registerDocumentSymbolProvider(te,this.o(j,N),oe),this.p(te)}$provideDocumentSymbols(N,j,K){return this.s(N,a,H=>H.provideDocumentSymbols(h.URI.revive(j),K),void 0,K)}registerCodeLensProvider(N,j,K){const H=this.q(),te=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ie(new c(this.h,this.j.converter,K,N,this.n,this.l),N)),this.e.$registerCodeLensSupport(H,this.o(j,N),te);let oe=this.p(H);if(te!==void 0){const Oe=K.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(te));oe=u.$ZL.from(oe,Oe)}return oe}$provideCodeLenses(N,j,K){return this.s(N,c,H=>H.provideCodeLenses(h.URI.revive(j),K),void 0,K)}$resolveCodeLens(N,j,K){return this.s(N,c,H=>H.resolveCodeLens(j,K),void 0,void 0)}$releaseCodeLenses(N,j){this.s(N,c,K=>Promise.resolve(K.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(N,j,K){const H=this.t(new y(this.h,K),N);return this.e.$registerDefinitionSupport(H,this.o(j,N)),this.p(H)}$provideDefinition(N,j,K,H){return this.s(N,y,te=>te.provideDefinition(h.URI.revive(j),K,H),[],H)}registerDeclarationProvider(N,j,K){const H=this.t(new m(this.h,K),N);return this.e.$registerDeclarationSupport(H,this.o(j,N)),this.p(H)}$provideDeclaration(N,j,K,H){return this.s(N,m,te=>te.provideDeclaration(h.URI.revive(j),K,H),[],H)}registerImplementationProvider(N,j,K){const H=this.t(new I(this.h,K),N);return this.e.$registerImplementationSupport(H,this.o(j,N)),this.p(H)}$provideImplementation(N,j,K,H){return this.s(N,I,te=>te.provideImplementation(h.URI.revive(j),K,H),[],H)}registerTypeDefinitionProvider(N,j,K){const H=this.t(new d(this.h,K),N);return this.e.$registerTypeDefinitionSupport(H,this.o(j,N)),this.p(H)}$provideTypeDefinition(N,j,K,H){return this.s(N,d,te=>te.provideTypeDefinition(h.URI.revive(j),K,H),[],H)}registerHoverProvider(N,j,K,H){const te=this.t(new w(this.h,K),N);return this.e.$registerHoverProvider(te,this.o(j,N)),this.p(te)}$provideHover(N,j,K,H){return this.s(N,w,te=>te.provideHover(h.URI.revive(j),K,H),void 0,H)}registerEvaluatableExpressionProvider(N,j,K,H){const te=this.t(new b(this.h,K),N);return this.e.$registerEvaluatableExpressionProvider(te,this.o(j,N)),this.p(te)}$provideEvaluatableExpression(N,j,K,H){return this.s(N,b,te=>te.provideEvaluatableExpression(h.URI.revive(j),K,H),void 0,H)}registerInlineValuesProvider(N,j,K,H){const te=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,oe=this.t(new M(this.h,K),N);this.e.$registerInlineValuesProvider(oe,this.o(j,N),te);let Oe=this.p(oe);if(te!==void 0){const Ve=K.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(te));Oe=u.$ZL.from(Oe,Ve)}return Oe}$provideInlineValues(N,j,K,H,te){return this.s(N,M,oe=>oe.provideInlineValues(h.URI.revive(j),K,H,te),void 0,te)}registerDocumentHighlightProvider(N,j,K){const H=this.t(new T(this.h,K),N);return this.e.$registerDocumentHighlightProvider(H,this.o(j,N)),this.p(H)}registerMultiDocumentHighlightProvider(N,j,K){const H=this.t(new G(this.h,K),N);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(j,N)),this.p(H)}$provideDocumentHighlights(N,j,K,H){return this.s(N,T,te=>te.provideDocumentHighlights(h.URI.revive(j),K,H),void 0,H)}$provideMultiDocumentHighlights(N,j,K,H,te){return this.s(N,G,oe=>oe.provideMultiDocumentHighlights(h.URI.revive(j),K,H.map(Oe=>h.URI.revive(Oe)),te),void 0,te)}registerLinkedEditingRangeProvider(N,j,K){const H=this.t(new W(this.h,K),N);return this.e.$registerLinkedEditingRangeProvider(H,this.o(j,N)),this.p(H)}$provideLinkedEditingRanges(N,j,K,H){return this.s(N,W,async te=>{const oe=await te.provideLinkedEditingRanges(h.URI.revive(j),K,H);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Le.w(oe.wordPattern):void 0}},void 0,H)}registerReferenceProvider(N,j,K){const H=this.t(new U(this.h,K),N);return this.e.$registerReferenceSupport(H,this.o(j,N)),this.p(H)}$provideReferences(N,j,K,H,te){return this.s(N,U,oe=>oe.provideReferences(h.URI.revive(j),K,H,te),void 0,te)}registerCodeActionProvider(N,j,K,H){const te=new g.$Sc,oe=this.t(new C(this.h,this.j.converter,this.k,K,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(oe,this.o(j,N),{providedKinds:H?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:H?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,te)}))},Le.u(N),!!K.resolveCodeAction),te.add(this.p(oe)),te}$provideCodeActions(N,j,K,H,te){return this.s(N,C,oe=>oe.provideCodeActions(h.URI.revive(j),K,H,te),void 0,te)}$resolveCodeAction(N,j,K){return this.s(N,C,H=>H.resolveCodeAction(j,K),{},void 0)}$releaseCodeActions(N,j){this.s(N,C,K=>Promise.resolve(K.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(N,j,K){const H=this.t(new V(this.h,K),N);return this.e.$registerDocumentFormattingSupport(H,this.o(j,N),N.identifier,N.displayName||N.name),this.p(H)}$provideDocumentFormattingEdits(N,j,K,H){return this.s(N,V,te=>te.provideDocumentFormattingEdits(h.URI.revive(j),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(N,j,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",te=this.t(new re(this.h,K),N);return this.e.$registerRangeFormattingSupport(te,this.o(j,N),N.identifier,N.displayName||N.name,H),this.p(te)}$provideDocumentRangeFormattingEdits(N,j,K,H,te){return this.s(N,re,oe=>oe.provideDocumentRangeFormattingEdits(h.URI.revive(j),K,H,te),void 0,te)}$provideDocumentRangesFormattingEdits(N,j,K,H,te){return this.s(N,re,oe=>oe.provideDocumentRangesFormattingEdits(h.URI.revive(j),K,H,te),void 0,te)}registerOnTypeFormattingEditProvider(N,j,K,H){const te=this.t(new ce(this.h,K),N);return this.e.$registerOnTypeFormattingSupport(te,this.o(j,N),H,N.identifier),this.p(te)}$provideOnTypeFormattingEdits(N,j,K,H,te,oe){return this.s(N,ce,Oe=>Oe.provideOnTypeFormattingEdits(h.URI.revive(j),K,H,te,oe),void 0,oe)}registerWorkspaceSymbolProvider(N,j){const K=this.t(new ye(j,this.l),N);return this.e.$registerNavigateTypeSupport(K,typeof j.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(N,j,K){return this.s(N,ye,H=>H.provideWorkspaceSymbols(j,K),{symbols:[]},K)}$resolveWorkspaceSymbol(N,j,K){return this.s(N,ye,H=>H.resolveWorkspaceSymbol(j,K),void 0,void 0)}$releaseWorkspaceSymbols(N,j){this.s(N,ye,K=>K.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(N,j,K){const H=this.t(new De(this.h,K,this.l),N);return this.e.$registerRenameSupport(H,this.o(j,N),De.supportsResolving(K)),this.p(H)}$provideRenameEdits(N,j,K,H,te){return this.s(N,De,oe=>oe.provideRenameEdits(h.URI.revive(j),K,H,te),void 0,te)}$resolveRenameLocation(N,j,K,H){return this.s(N,De,te=>te.resolveRenameLocation(h.URI.revive(j),K,H),void 0,H)}registerNewSymbolNamesProvider(N,j,K){const H=this.t(new he(this.h,K,this.l),N);return this.e.$registerNewSymbolNamesProvider(H,this.o(j,N)),this.p(H)}$provideNewSymbolNames(N,j,K,H){return this.s(N,he,te=>te.provideNewSymbolNames(h.URI.revive(j),K,H),void 0,H)}registerDocumentSemanticTokensProvider(N,j,K,H){const te=this.t(new se(this.h,K),N),oe=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(te,this.o(j,N),H,oe);let Oe=this.p(te);if(oe){const Ve=K.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(oe));Oe=u.$ZL.from(Oe,Ve)}return Oe}$provideDocumentSemanticTokens(N,j,K,H){return this.s(N,se,te=>te.provideDocumentSemanticTokens(h.URI.revive(j),K,H),null,H)}$releaseDocumentSemanticTokens(N,j){this.s(N,se,K=>K.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,j,K,H){const te=this.t(new $e(this.h,K),N);return this.e.$registerDocumentRangeSemanticTokensProvider(te,this.o(j,N),H),this.p(te)}$provideDocumentRangeSemanticTokens(N,j,K,H){return this.s(N,$e,te=>te.provideDocumentRangeSemanticTokens(h.URI.revive(j),K,H),null,H)}registerCompletionItemProvider(N,j,K,H){const te=this.t(new ee(this.h,this.j.converter,K,this.m,N),N);return this.e.$registerCompletionsProvider(te,this.o(j,N),H,ee.supportsResolving(K),N.identifier),this.p(te)}$provideCompletionItems(N,j,K,H,te){return this.s(N,ee,oe=>oe.provideCompletionItems(h.URI.revive(j),K,H,te),void 0,te)}$resolveCompletionItem(N,j,K){return this.s(N,ee,H=>H.resolveCompletionItem(j,K),void 0,K)}$releaseCompletionItems(N,j){this.s(N,ee,K=>K.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(N,j,K,H){const te=new q(N,this.h,K,this.j.converter),oe=this.t(te,N);return this.e.$registerInlineCompletionsSupport(oe,this.o(j,N),te.supportsHandleEvents,n.$wm.toKey(N.identifier.value),H?.yieldTo?.map(Oe=>n.$wm.toKey(Oe))||[]),this.p(oe)}$provideInlineCompletions(N,j,K,H,te){return this.s(N,Y,oe=>oe.provideInlineCompletions(h.URI.revive(j),K,H,te),void 0,te)}$handleInlineCompletionDidShow(N,j,K,H){this.s(N,Y,async te=>{te.handleDidShowCompletionItem(j,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,j,K,H){this.s(N,Y,async te=>{te.handlePartialAccept(j,K,H)},void 0,void 0)}$freeInlineCompletionsList(N,j){this.s(N,Y,async K=>{K.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(N,j,K){const H=new ne(N,this.h,K,this.j.converter),te=this.t(H,N);return this.e.$registerInlineEditProvider(te,this.o(j,N),N.identifier),this.p(te)}$provideInlineEdit(N,j,K,H){return this.s(N,ne,te=>te.provideInlineEdits(h.URI.revive(j),K,H),void 0,H)}$freeInlineEdit(N,j){this.s(N,ne,async K=>{K.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(N,j,K,H){const te=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,oe=this.t(new Te(this.h,K),N);return this.e.$registerSignatureHelpProvider(oe,this.o(j,N),te),this.p(oe)}$provideSignatureHelp(N,j,K,H,te){return this.s(N,Te,oe=>oe.provideSignatureHelp(h.URI.revive(j),K,H,te),void 0,te)}$releaseSignatureHelp(N,j){this.s(N,Te,K=>K.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(N,j,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,te=this.t(new Ce(this.h,this.j.converter,K,this.l,N),N);this.e.$registerInlayHintsProvider(te,this.o(j,N),typeof K.resolveInlayHint=="function",H,Le.u(N));let oe=this.p(te);if(H!==void 0){const Oe=K.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(H));oe=u.$ZL.from(oe,Oe)}return oe}$provideInlayHints(N,j,K,H){return this.s(N,Ce,te=>te.provideInlayHints(h.URI.revive(j),K,H),void 0,H)}$resolveInlayHint(N,j,K){return this.s(N,Ce,H=>H.resolveInlayHint(j,K),void 0,K)}$releaseInlayHints(N,j){this.s(N,Ce,K=>K.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(N,j,K){const H=this.t(new be(this.h,K),N);return this.e.$registerDocumentLinkProvider(H,this.o(j,N),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(N,j,K){return this.s(N,be,H=>H.provideLinks(h.URI.revive(j),K),void 0,K,j.scheme==="output")}$resolveDocumentLink(N,j,K){return this.s(N,be,H=>H.resolveLink(j,K),void 0,void 0,!0)}$releaseDocumentLinks(N,j){this.s(N,be,K=>K.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(N,j,K){const H=this.t(new ge(this.h,K),N);return this.e.$registerDocumentColorProvider(H,this.o(j,N)),this.p(H)}$provideDocumentColors(N,j,K){return this.s(N,ge,H=>H.provideColors(h.URI.revive(j),K),[],K)}$provideColorPresentations(N,j,K,H){return this.s(N,ge,te=>te.provideColorPresentations(h.URI.revive(j),K,H),void 0,H)}registerFoldingRangeProvider(N,j,K){const H=this.q(),te=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ie(new X(this.h,K),N)),this.e.$registerFoldingRangeProvider(H,this.o(j,N),N.identifier,te);let oe=this.p(H);if(te!==void 0){const Oe=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(te));oe=u.$ZL.from(oe,Oe)}return oe}$provideFoldingRanges(N,j,K,H){return this.s(N,X,te=>te.provideFoldingRanges(h.URI.revive(j),K,H),void 0,H)}registerSelectionRangeProvider(N,j,K){const H=this.t(new x(this.h,K,this.l),N);return this.e.$registerSelectionRangeProvider(H,this.o(j,N)),this.p(H)}$provideSelectionRanges(N,j,K,H){return this.s(N,x,te=>te.provideSelectionRanges(h.URI.revive(j),K,H),[],H)}registerCallHierarchyProvider(N,j,K){const H=this.t(new le(this.h,K),N);return this.e.$registerCallHierarchyProvider(H,this.o(j,N)),this.p(H)}$prepareCallHierarchy(N,j,K,H){return this.s(N,le,te=>Promise.resolve(te.prepareSession(h.URI.revive(j),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(N,j,K,H){return this.s(N,le,te=>te.provideCallsTo(j,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(N,j,K,H){return this.s(N,le,te=>te.provideCallsFrom(j,K,H),void 0,H)}$releaseCallHierarchy(N,j){this.s(N,le,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(N,j,K){const H=this.t(new de(this.h,K),N);return this.e.$registerTypeHierarchyProvider(H,this.o(j,N)),this.p(H)}$prepareTypeHierarchy(N,j,K,H){return this.s(N,de,te=>Promise.resolve(te.prepareSession(h.URI.revive(j),K,H)),void 0,H)}$provideTypeHierarchySupertypes(N,j,K,H){return this.s(N,de,te=>te.provideSupertypes(j,K,H),void 0,H)}$provideTypeHierarchySubtypes(N,j,K,H){return this.s(N,de,te=>te.provideSubtypes(j,K,H),void 0,H)}$releaseTypeHierarchy(N,j){this.s(N,de,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(N,j,K,H){const te=this.q();this.f.set(te,new Ie(new Pe(this.e,this.h,K,te,N),N));const oe=(0,l.$UF)(N,"dropMetadata")&&H?Pe.toInternalProviderId(N.identifier.value,H.id):void 0;return this.e.$registerDocumentOnDropEditProvider(te,this.o(j,N),oe,(0,l.$UF)(N,"dropMetadata")?H:void 0),this.p(te)}$provideDocumentOnDropEdits(N,j,K,H,te,oe){return this.s(N,Pe,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(j,h.URI.revive(K),H,te,oe)),void 0,void 0)}registerMappedEditsProvider(N,j,K){const H=this.t(new me(this.h,K),N);return this.e.$registerMappedEditsProvider(H,this.o(j,N)),this.p(H)}$provideMappedEdits(N,j,K,H,te){return this.s(N,me,oe=>Promise.resolve(oe.provideMappedEdits(j,K,H,te)),null,te)}registerDocumentPasteEditProvider(N,j,K,H){const te=this.q();this.f.set(te,new Ie(new O(this.e,this.h,K,te,N),N));const oe=O.toInternalProviderId(N.identifier.value,H.id);return this.e.$registerPasteEditProvider(te,this.o(j,N),oe,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(te)}$prepareDocumentPaste(N,j,K,H,te){return this.s(N,O,oe=>oe.prepareDocumentPaste(h.URI.revive(j),K,H,te),void 0,te)}$providePasteEdits(N,j,K,H,te,oe){return this.s(N,O,Oe=>Oe.providePasteEdits(j,h.URI.revive(K),H,te,oe),void 0,oe)}static w(N){return{pattern:N.source,flags:N.flags}}static y(N){return{decreaseIndentPattern:Le.w(N.decreaseIndentPattern),increaseIndentPattern:Le.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?Le.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?Le.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:Le.w(N.beforeText),afterText:N.afterText?Le.w(N.afterText):void 0,previousLineText:N.previousLineText?Le.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(Le.z)}static C(N){return{open:N.open,close:N.close,notIn:N.notIn?N.notIn.map(j=>u.SyntaxTokenType.toString(j)):void 0}}static D(N){return N.map(Le.C)}setLanguageConfiguration(N,j,K){const{wordPattern:H}=K;if(H&&(0,A.$8e)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(j,H):this.h.setWordDefinitionFor(j,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const te=this.q(),oe={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Le.w(K.wordPattern):void 0,indentationRules:K.indentationRules?Le.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Le.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Le.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(te,j,oe),this.p(te)}$setWordDefinitions(N){for(const j of N)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$Bhc=Le}),define(Ae[260],Me([1,0,3,8,7,32,11,6,23]),function(fe,e,S,L,P,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=void 0;class k{constructor(D,h,v,p){this.c=h,this.d=v,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(S.$XL.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,h){await this.a.$changeLanguage(D,h);const v=this.c.getDocumentData(D);if(!v)throw new Error(`document '${D.toString()}' NOT found`);return v.document}async tokenAtPosition(D,h){const v=D.version,p=L.Position.from(h),s=await this.a.$tokensAtPosition(D.uri,p),o={type:P.StandardTokenType.Other,range:D.getWordRangeAtPosition(h)??new P.$2L(h.line,h.character,h.line,h.character)};if(!s)return o;const t={range:L.Range.to(s.range),type:L.TokenType.to(s.type)};return!t.range.contains(h)||v!==D.version?o:t}createLanguageStatusItem(D,h,v){const p=this.f++,s=this.a,o=this.g,t=`${D.identifier.value}/${h}`;if(o.has(t))throw new Error(`LanguageStatusItem with id '${h}' ALREADY exists`);o.add(t);const n={selector:v,id:h,name:D.displayName??D.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const u=new g.$Sc,l=()=>{if(r?.dispose(),!o.has(t)){console.warn(`LanguageStatusItem (${h}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,R.$gh)(()=>{u.clear(),this.a.$setLanguageStatus(p,{id:t,name:n.name??D.displayName??D.name,source:D.displayName??D.name,selector:L.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===P.LanguageStatusSeverity.Error?F.default.Error:n.severity===P.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:n.command&&this.d.toInternal(n.command,u),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){u.dispose(),r?.dispose(),s.$removeLanguageStatus(p),o.delete(t)},get id(){return n.id},get name(){return n.name},set name($){n.name=$,l()},get selector(){return n.selector},set selector($){n.selector=$,l()},get text(){return n.text},set text($){n.text=$,l()},set text2($){(0,f.$VF)(D,"languageStatusText"),n.text=$,l()},get text2(){return(0,f.$VF)(D,"languageStatusText"),n.text},get detail(){return n.detail},set detail($){n.detail=$,l()},get severity(){return n.severity},set severity($){n.severity=$,l()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation($){n.accessibilityInformation=$,l()},get command(){return n.command},set command($){n.command=$,l()},get busy(){return n.busy},set busy($){n.busy=$,l()}};return l(),i}}e.$1ic=k}),define(Ae[261],Me([1,0,12,2,8,7,83]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=e.$Lic=void 0;class g{constructor(D,h,v,p){this.start=D,this.deletedCount=h,this.deletedItems=v,this.items=p}asApiEvent(){return{range:new F.$nN(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(D){return{EOL:D.eol,lines:D.source,languageId:D.language,uri:D.uri,isDirty:!1,versionId:1}}constructor(D,h,v){this.notebook=D,this.h=h,this.j=v,this.handle=v.handle,this.uri=L.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(P.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,h=this.h.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:h.document,get mime(){return D.g},set mime(p){D.g=p},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(v)}return this.f}setOutputs(D){this.a=D.map(P.NotebookCellOutput.to)}setOutputItems(D,h,v){const p=v.map(P.NotebookCellOutputItem.to),s=this.a.find(o=>o.id===D);if(s&&(h||(s.items.length=0),s.items.push(...p),s.items.length>1&&s.items.every(o=>R.$1J(o.mime)))){const o=new Map,t=[];s.items.forEach(n=>{let r;o.has(n.mime)?r=o.get(n.mime):(r=[],o.set(n.mime,r),t.push(n.mime)),r.push(n.data)}),s.items.length=0,t.forEach(n=>{const r=R.$2J(o.get(n));s.items.push({mime:n,data:r.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$Lic=f;class k{static{this.a=0}constructor(D,h,v,p,s){this.k=D,this.l=h,this.m=v,this.uri=p,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,h={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===S.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(v){return v=D.n(v),D.b[v].apiCell},getCells(v){return(v?D.p(v):D.b).map(s=>s.apiCell)},save(){return D.q()}};this.e=Object.freeze(h)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,h,v){this.g=D.versionId,this.h=h,this.acceptDocumentPropertiesChanged({metadata:v});const p={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},s=[];for(const t of D.rawEvents)t.kind===R.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,p.contentChanges):t.kind===R.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,p.contentChanges):t.kind===R.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),s.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),s.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),s.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===R.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),s.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),s.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const o=new Map;for(let t=0;t<s.length;t++){const n=s[t],r=o.get(n.cell);if(r===void 0){const u=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,u-1)}else p.cellChanges[r]={...p.cellChanges[r],...n}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let h=D.start|0,v=D.end|0;return h<0&&(h=0),v>this.b.length&&(v=this.b.length),D.with({start:h,end:v})}p(D){D=this.o(D);const h=[];for(let v=D.start;v<D.end;v++)h.push(this.b[v]);return h}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,h,v){if(this.j)return;const p=[],s=[],o=[];if(D.reverse().forEach(t=>{const r=t[2].map(i=>{const $=new f(this,this.l,i);return h||s.push(f.asModelAddData(i)),$}),u=new g(t[0],t[1],[],r),l=this.b.splice(t[0],t[1],...r);for(const i of l)o.push(i.uri),u.deletedItems.push(i.apiCell);p.push(u)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:o}),v)for(const t of p)v.push(t.asApiEvent())}s(D,h,v,p){const s=this.b.splice(D,h);this.b.splice(v,0,...s);const o=[new g(D,h,s.map(t=>t.apiCell),[]),new g(v,0,[],s)];for(const t of o)p.push(t.asApiEvent())}t(D,h){this.b[D].setOutputs(h)}u(D,h,v,p){this.b[D].setOutputItems(h,v,p)}v(D,h){const v=this.b[D];v.apiCell.document.languageId!==h&&this.m.$acceptModelLanguageChanged(v.uri,h)}w(D,h){const v=this.b[D];v.apiCell.mime=h}x(D,h){this.b[D].setMetadata(h)}y(D,h){this.b[D].setInternalMetadata(h)}getCellFromApiCell(D){return this.b.find(h=>h.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){if(L.URI.isUri(D)){const h=R.CellUri.parse(D);if(!h||h.notebook.toString()!==this.uri.toString())return;D=h.handle}return this.b.find(h=>h.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$Mic=k}),define(Ae[262],Me([1,0,5,2,8,7]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;class R{constructor(f,k,A,D={timeout:1500,errors:3}){this.b=f,this.c=k,this.d=A,this.f=D,this.a=new S.$7d}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(k,A,D)=>{const h=function(p){k.call(A,p)};return h.extension=f,this.a.event(h,void 0,D)}}async $participateInSave(f,k,A){const D=L.URI.revive(f),h=this.c.getNotebookDocument(D);if(!h)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:h.apiNotebook,reason:P.TextDocumentSaveReason.to(k)},A,async(s,o)=>{const t=Date.now(),n=await await Promise.resolve(s);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof F.$0L?v.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(v.length===0)return!0;const p={edits:[]};for(const s of v){const{edits:o}=P.WorkspaceEdit.from(s);p.edits=p.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$3ic=R}),define(Ae[110],Me([1,0,15,8,7]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(g,f,k,A,D,h){this.id=g,this.f=f,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=A,this.c=h}get apiEditor(){if(!this.e){const g=this;this.e={get notebook(){return g.notebookData.apiNotebook},get selection(){return g.a[0]},set selection(f){this.selections=[f]},get selections(){return g.a},set selections(f){if(!Array.isArray(f)||!f.every(P.$nN.isNotebookRange))throw(0,S.$7)("selections");g.a=f,g.g(f)},get visibleRanges(){return g.b},revealRange(f,k){g.f.$tryRevealRange(g.id,L.NotebookRange.from(f),k??P.NotebookEditorRevealType.Default)},get viewColumn(){return g.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(g){this.d=g}_acceptVisibleRanges(g){this.b=g}_acceptSelections(g){this.a=g}g(g){this.f.$trySetSelections(this.id,g.map(L.NotebookRange.from))}_acceptViewColumn(g){this.c=g}}e.$Nic=F}),define(Ae[263],Me([1,0,5,14,8]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;let F=class{constructor(g,f){this.c=g,this.d=f,this.a=new S.$5d,this.b=new S.$5d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,f);const k=this.d.getEditorById(g);f.visibleRanges&&k._acceptVisibleRanges(f.visibleRanges.ranges.map(P.NotebookRange.to)),f.selections&&k._acceptSelections(f.selections.selections.map(P.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const f in g)this.d.getEditorById(f)._acceptViewColumn(P.ViewColumn.to(g[f]))}};e.$5ic=F,e.$5ic=F=Xe([qe(0,L.$yj)],F)}),define(Ae[264],Me([1,0,5,3,110]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;class F{constructor(g,f){this.c=f,this.a=new Map,this.b=g.getProxy(L.$XL.MainThreadNotebookRenderers)}$postRendererMessage(g,f,k){const A=this.c.getEditorById(g);this.a.get(f)?.fire({editor:A.apiEditor,message:k})}createRendererMessaging(g,f){if(!g.contributes?.notebookRenderer?.some(A=>A.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(A,D,h)=>this.d(f).event(A,D,h),postMessage:(A,D)=>{P.$Nic.apiEditorsToExtHost.has(A)&&([A,D]=[D,A]);const h=D&&P.$Nic.apiEditorsToExtHost.get(D);return this.b.$postMessage(h?.id,f,A)}}}d(g){let f=this.a.get(g);return f||(f=new S.$5d({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(g)}}),this.a.set(g,f),f)}}e.$8ic=F}),define(Ae[265],Me([1,0,8,99,21,67,15]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=void 0;class g{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,h,v){const p=this.b++,{title:s,location:o,cancellable:t}=h,n={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(p,{location:S.ProgressLocation.from(o),title:s,source:n,cancellable:t},D.isUnderDevelopment?void 0:D.identifier.value).catch(R.$2),this.d(p,v,!!t)}d(D,h,v){let p;v&&(p=new P.$ce,this.c.set(D,p));const s=t=>{this.a.$progressEnd(t),this.c.delete(t),p?.dispose()};let o;try{o=h(new k(this.a,D),v&&p?p.token:P.CancellationToken.None)}catch(t){throw s(D),t}return o.then(t=>s(D),t=>s(D)),o}$acceptProgressCanceled(D){const h=this.c.get(D);h&&(h.cancel(),this.c.delete(D))}}e.$_ic=g;function f(A,D){return A.message=D.message,typeof D.increment=="number"&&(typeof A.increment=="number"?A.increment+=D.increment:A.increment=D.increment),A}class k extends L.$Hv{constructor(D,h){super(v=>this.throttledReport(v)),this.c=D,this.d=h}throttledReport(D){this.c.$progressReport(this.d,D)}}Xe([(0,F.$Kh)(100,(A,D)=>f(A,D),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Ae[266],Me([1,0,2,3,11,8]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=void 0;class R{static{this.a=0}constructor(f,k){this.d=k,this.c=new Map,this.b=f.getProxy(L.$XL.MainThreadQuickDiff)}$provideOriginalResource(f,k,A){const D=S.URI.revive(k),h=this.c.get(f);return h?(0,P.$9g)(()=>h.provideOriginalResource(D,A)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(f,k,A,D){const h=R.a++;return this.c.set(h,k),this.b.$registerQuickDiffProvider(h,F.DocumentSelector.from(f,this.d),A,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(h),this.c.delete(h)}}}}e.$ajc=R}),define(Ae[267],Me([1,0,21,5,6,3,2,7,15,18,32,40,23,8]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=void 0;function p(s,o,t){const n=s.getProxy(F.$XL.MainThreadQuickOpen);class r{constructor(m,I){this.e=new Map,this.f=0,this.a=m,this.b=I}showQuickPick(m,I,d,w=S.CancellationToken.None){this.c=void 0;const b=Promise.resolve(I),M=++this.f,T=n.$show(M,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},w),G={},W=T.then(()=>G);return Promise.race([W,b]).then(U=>{if(U===G)return;const C=(0,h.$UF)(m,"quickPickItemTooltip");return b.then(O=>{const V=[];for(let re=0;re<O.length;re++){const ce=O[re];if(typeof ce=="string")V.push({label:ce,handle:re});else if(ce.kind===g.QuickPickItemKind.Separator)V.push({type:"separator",label:ce.label});else{ce.tooltip&&!C&&console.warn(`Extension '${m.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`);const ye=ce.iconPath?a(ce.iconPath):void 0;V.push({label:ce.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:C?v.MarkdownString.fromStrict(ce.tooltip):void 0,handle:re})}}return d&&typeof d.onDidSelectItem=="function"&&(this.c=re=>{d.onDidSelectItem(O[re])}),n.$setItems(M,V),T.then(re=>{if(typeof re=="number")return O[re];if(Array.isArray(re))return re.map(ce=>O[ce])})})}).then(void 0,U=>{if(!(0,f.$4)(U))return n.$setError(M,U),Promise.reject(U)})}$onItemSelected(m){this.c?.(m)}showInput(m,I=S.CancellationToken.None){return this.d=m?.validateInput,n.$input(m,typeof this.d=="function",I).then(void 0,d=>{if(!(0,f.$4)(d))return Promise.reject(d)})}async $validateInput(m){if(!this.d)return;const I=await this.d(m);if(!I||typeof I=="string")return I;let d;switch(I.severity){case g.InputBoxValidationSeverity.Info:d=A.default.Info;break;case g.InputBoxValidationSeverity.Warning:d=A.default.Warning;break;case g.InputBoxValidationSeverity.Error:d=A.default.Error;break;default:d=I.message?A.default.Error:A.default.Ignore;break}return{content:I.message,severity:d}}async showWorkspaceFolderPick(m,I=S.CancellationToken.None){const d=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[m]);if(!d)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(b=>b.uri.toString()===d.uri.toString())}createQuickPick(m){const I=new c(m,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(m){const I=new E(m,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(m,I){this.e.get(m)?._fireDidChangeValue(I)}$onDidAccept(m){this.e.get(m)?._fireDidAccept()}$onDidChangeActive(m,I){const d=this.e.get(m);d instanceof c&&d._fireDidChangeActive(I)}$onDidChangeSelection(m,I){const d=this.e.get(m);d instanceof c&&d._fireDidChangeSelection(I)}$onDidTriggerButton(m,I){this.e.get(m)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(m,I,d){const w=this.e.get(m);w instanceof c&&w._fireDidTriggerItemButton(I,d)}$onDidHide(m){this.e.get(m)?._fireDidHide()}}class u{static{this.a=1}constructor(m,I){this.x=m,this.y=I,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$5d,this.q=new L.$5d,this.r=new L.$5d,this.s=new L.$5d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(m){this.b=m,this.z({title:m})}get step(){return this.c}set step(m){this.c=m,this.z({step:m})}get totalSteps(){return this.d}set totalSteps(m){this.d=m,this.z({totalSteps:m})}get enabled(){return this.g}set enabled(m){this.g=m,this.z({enabled:m})}get busy(){return this.j}set busy(m){this.j=m,this.z({busy:m})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(m){this.k=m,this.z({ignoreFocusOut:m})}get value(){return this.l}set value(m){this.l=m,this.z({value:m})}get placeholder(){return this.m}set placeholder(m){this.m=m,this.z({placeholder:m})}get buttons(){return this.n}set buttons(m){this.n=m.slice(),this.o.clear(),m.forEach((I,d)=>{const w=I===g.$kN.Back?-1:d;this.o.set(w,I)}),this.z({buttons:m.map((I,d)=>({...a(I.iconPath),tooltip:I.tooltip,handle:I===g.$kN.Back?-1:d}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(m){this.l=m,this.q.fire(m)}_fireDidTriggerButton(m){const I=this.o.get(m);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(m){if(!this.v){for(const I of Object.keys(m)){const d=m[I];this.u[I]=d===void 0?null:d}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function l(y){if(y instanceof g.$UM)return{id:y.id};const m=$(y),I=i(y);return{dark:typeof m=="string"?R.URI.file(m):m,light:typeof I=="string"?R.URI.file(I):I}}function i(y){return typeof y=="object"&&"light"in y?y.light:y}function $(y){return typeof y=="object"&&"dark"in y?y.dark:y}function a(y){const m=l(y);let I,d;return"id"in m?d=D.ThemeIcon.asClassName(m):I=m,{iconPath:I,iconClass:d}}class c extends u{constructor(m,I){super(m.identifier,I),this.O=m,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$5d,this.L=[],this.M=new L.$5d,this.N=new L.$5d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(m){this.B=m.slice(),this.C.clear(),this.D.clear(),m.forEach((w,b)=>{this.C.set(b,w),this.D.set(w,b)});const I=(0,h.$UF)(this.O,"quickPickItemTooltip"),d=[];for(let w=0;w<m.length;w++){const b=m[w];if(b.kind===g.QuickPickItemKind.Separator)d.push({type:"separator",label:b.label});else{b.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const M=b.iconPath?a(b.iconPath):void 0;d.push({handle:w,label:b.label,iconPath:M?.iconPath,iconClass:M?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:I?v.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((T,G)=>({...a(T.iconPath),tooltip:T.tooltip,handle:G}))})}}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany(m){this.E=m,this.z({canSelectMany:m})}get matchOnDescription(){return this.F}set matchOnDescription(m){this.F=m,this.z({matchOnDescription:m})}get matchOnDetail(){return this.G}set matchOnDetail(m){this.G=m,this.z({matchOnDetail:m})}get sortByLabel(){return this.H}set sortByLabel(m){this.H=m,this.z({sortByLabel:m})}get keepScrollPosition(){return this.I}set keepScrollPosition(m){this.I=m,this.z({keepScrollPosition:m})}get activeItems(){return this.J}set activeItems(m){this.J=m.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(m){this.L=m.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(m){const I=(0,k.$Hb)(m.map(d=>this.C.get(d)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(m){const I=(0,k.$Hb)(m.map(d=>this.C.get(d)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(m,I){const d=this.C.get(m);if(!d||!d.buttons||!d.buttons.length)return;const w=d.buttons[I];w&&this.N.fire({button:w,item:d})}}class E extends u{constructor(m,I){super(m.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(m){this.B=m,this.z({password:m})}get prompt(){return this.C}set prompt(m){this.C=m,this.z({prompt:m})}get valueSelection(){return this.D}set valueSelection(m){this.D=m,this.z({valueSelection:m})}get validationMessage(){return this.E}set validationMessage(m){this.E=m,m?typeof m=="string"?this.z({validationMessage:m,severity:A.default.Error}):this.z({validationMessage:m.message,severity:m.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new r(o,t)}e.$bjc=p}),define(Ae[268],Me([1,0,2,5,67,6,11,3,18,139,14,22,40,8,23,12,20]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=e.$cjc=void 0;function n(M){return M instanceof S.URI}function r(M,T){return M.scheme===s.Schemas.file&&T.scheme===s.Schemas.file&&o.$k?M.toString()===T.toString():M.toString().toLowerCase()===T.toString().toLowerCase()}function u(M){if(M)return typeof M.iconPath=="string"?S.URI.file(M.iconPath):S.URI.isUri(M.iconPath)||h.ThemeIcon.isThemeIcon(M.iconPath)?M.iconPath:void 0}function l(M){if(M.icon){if(S.URI.isUri(M.icon))return M.icon;if(h.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const T=M.icon;return{light:T.light,dark:T.dark}}}else return}function i(M,T){if(!M.iconPath&&!T.iconPath)return 0;if(M.iconPath){if(!T.iconPath)return 1}else return-1;const G=typeof M.iconPath=="string"?M.iconPath:S.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id,W=typeof T.iconPath=="string"?T.iconPath:S.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,k.$4q)(G,W)}function $(M,T){let G=0;if(M.strikeThrough!==T.strikeThrough)return M.strikeThrough?1:-1;if(M.faded!==T.faded)return M.faded?1:-1;if(M.tooltip!==T.tooltip)return(M.tooltip||"").localeCompare(T.tooltip||"");if(G=i(M,T),G!==0)return G;if(M.light&&T.light)G=i(M.light,T.light);else{if(M.light)return 1;if(T.light)return-1}if(G!==0)return G;if(M.dark&&T.dark)G=i(M.dark,T.dark);else{if(M.dark)return 1;if(T.dark)return-1}return G}function a(M,T){if(M.command!==T.command)return M.command<T.command?-1:1;if(M.title!==T.title)return M.title<T.title?-1:1;if(M.tooltip!==T.tooltip){if(M.tooltip!==void 0&&T.tooltip!==void 0)return M.tooltip<T.tooltip?-1:1;if(M.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(M.arguments===T.arguments)return 0;if(M.arguments)if(T.arguments){if(M.arguments.length!==T.arguments.length)return M.arguments.length-T.arguments.length}else return 1;else return-1;for(let G=0;G<M.arguments.length;G++){const W=M.arguments[G],U=T.arguments[G];if(W!==U&&!(n(W)&&n(U)&&r(W,U)))return W<U?-1:1}return 0}function c(M,T){let G=(0,k.$4q)(M.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(G!==0)return G;if(M.command&&T.command)G=a(M.command,T.command);else{if(M.command)return 1;if(T.command)return-1}if(G!==0)return G;if(M.decorations&&T.decorations)G=$(M.decorations,T.decorations);else{if(M.decorations)return 1;if(T.decorations)return-1}if(M.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)G=(0,k.$4q)(M.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(M.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(M.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)G=(0,k.$4q)(M.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(M.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return G}function E(M,T){for(let G=0;G<M.length;G++)if(M[G]!==T[G])return!1;return!0}function y(M,T){return M.command===T.command&&M.title===T.title&&M.tooltip===T.tooltip&&(M.arguments&&T.arguments?E(M.arguments,T.arguments):M.arguments===T.arguments)}function m(M,T){return(0,f.$ub)(M,T,y)}class I{#e;#t;get value(){return this.d}set value(T){T=T??"",this.#e.$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.#e.$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,p.$VF)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,p.$VF)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.#e.$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.#e.$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.#e.$setInputBoxVisibility(this.l,T))}get document(){return(0,p.$VF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(T,G,W,U,C){this.k=T,this.l=U,this.m=C,this.d="",this.e=new L.$5d,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=W}showValidationMessage(T,G){(0,p.$VF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,T,G)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$cjc=I;class d{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,G,W,U,C,O,V){this.q=T,this.s=G,this.t=W,this.u=U,this.v=C,this.multiDiffEditorEnableViewChanges=O,this.w=V,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$5d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$5d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=d.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,G){const W=this.h.get(T);return W?(0,R.$9g)(()=>this.s.executeCommand(W.command,...W.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(c),W=(0,f.$Db)(this.o,T,c).map(O=>{const V=O.toInsert.map(re=>{const ce=this.e++;this.g.set(ce,re);const ye=re.resourceUri;let De;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const ge=new F.$Sc;De=this.s.converter.toInternal(re.command,ge),this.j.set(ce,ge)}else this.h.set(ce,re.command);const he=(0,p.$UF)(this.w,"scmMultiDiffEditor"),ve=he?re.multiDiffEditorOriginalUri:void 0,se=he?re.multiFileDiffEditorModifiedUri:void 0,$e=u(re.decorations),ee=re.decorations&&u(re.decorations.light)||$e,Y=re.decorations&&u(re.decorations.dark)||$e,q=[ee,Y],ne=re.decorations&&re.decorations.tooltip||"",Se=re.decorations&&!!re.decorations.strikeThrough,Te=re.decorations&&!!re.decorations.faded,Ce=re.contextValue||"";return{rawResource:[ce,ye,q,ne,Se,Te,Ce,De,ve,se],handle:ce}});return{start:O.start,deleteCount:O.deleteCount,toInsert:V}}),U=W.map(({start:O,deleteCount:V,toInsert:re})=>[O,V,re.map(ce=>ce.rawResource)]),C=W.reverse();for(const{start:O,deleteCount:V,toInsert:re}of C){const ce=re.map(De=>De.handle),ye=this.n.splice(O,V,...ce);for(const De of ye)this.g.delete(De),this.h.delete(De),this.j.get(De)?.dispose(),this.j.delete(De)}return this.o=T,U}dispose(){this.l=!0,this.m.fire()}}class w{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,this.#e.$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let G;(0,p.$UF)(this.x,"quickDiffProvider")&&(G=T?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:G})}get historyProvider(){return(0,p.$VF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,p.$VF)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new F.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,this.#e.$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new F.$Sc,this.o=T;const G=this.y.converter.toInternal(T,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,p.$VF)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,p.$VF)(this.x,"scmActionButton"),this.p.value=new F.$Sc,this.q=T;const G=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(W=>W.map(U=>this.y.converter.toInternal(U,this.p.value))),description:T.description,enabled:T.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&m(this.t,T))return;this.s.value=new F.$Sc,this.t=T;const G=(T||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(T,G,W,U,C,O,V){this.x=T,this.y=U,this.z=C,this.A=O,this.B=V,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Uc,this.m=void 0,this.n=new F.$Uc,this.o=void 0,this.p=new F.$Uc,this.s=new F.$Uc,this.t=void 0,this.u=!1,this.v=new L.$5d,this.onDidChangeSelection=this.v.event,this.w=w.d++,this.C=new Map,this.D=new Set,this.#e=W;const re=S.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:V?`rootUri=${encodeURIComponent(V.toString())}`:void 0});this.f=new I(T,G,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,C,O,V,re)}createResourceGroup(T,G,W){const U=(0,p.$UF)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,C=new d(this.#e,this.y,this.w,T,G,U,this.x),O=L.Event.once(C.onDidDispose)(()=>this.C.delete(C));return this.C.set(C,O),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const T=[],G=[];for(const[W,U]of this.C){U.dispose();const C=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});L.Event.once(W.onDidDispose)(()=>{this.D.delete(W),C.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),T.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const O=W._takeResourceStateSnapshot();O.length>0&&G.push([W.handle,O]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,T,G),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(G=>{const W=G._takeResourceStateSnapshot();W.length!==0&&T.push([G.handle,W])}),T.length>0&&this.#e.$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),this.#e.$unregisterSourceControl(this.w)}}Xe([(0,P.$Jh)(100)],w.prototype,"eventuallyAddResourceGroups",null),Xe([(0,P.$Jh)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,G,W,U){this.l=G,this.m=W,this.n=U,this.g=new Map,this.h=new D.$ym,this.j=new L.$5d,this.e=T.getProxy(g.$XL.MainThreadSCM),this.f=T.getProxy(g.$XL.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const O=this.g.get(C.sourceControlHandle);if(!O)return C;const V=O.getResourceGroup(C.groupHandle);return V?V.getResourceState(C.handle):C}else if(C&&C.$mid===4){const O=this.g.get(C.sourceControlHandle);return O?O.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const O=this.g.get(C.handle);return O||C}return C}})}createSourceControl(T,G,W,U){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,G,W,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const C=t.d++,O=new w(T,this.m,this.e,this.l,G,W,U);this.g.set(C,O);const V=this.h.get(T.identifier)||[];return V.push(O),this.h.set(T.identifier,V),O}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const G=this.h.get(T.identifier),W=G&&G[G.length-1];return W&&W.inputBox}$provideOriginalResource(T,G,W){const U=S.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",T,U.toString());const C=this.g.get(T);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$9g)(()=>C.quickDiffProvider.provideOriginalResource(U,W)).then(O=>O||null)}$onInputBoxValueChange(T,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const W=this.g.get(T);return W&&W.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(T,G,W,U){this.n.trace("ExtHostSCM#$executeResourceCommand",T,G,W);const C=this.g.get(T);if(!C)return Promise.resolve(void 0);const O=C.getResourceGroup(G);return O?O.$executeResourceCommand(W,U):Promise.resolve(void 0)}$validateInput(T,G,W){this.n.trace("ExtHostSCM#$validateInput",T);const U=this.g.get(T);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$9g)(()=>U.inputBox.validateInput(G,W)).then(C=>{if(!C)return Promise.resolve(void 0);const O=v.MarkdownString.fromStrict(C.message);return O?Promise.resolve([O,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,G,W,U){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,W,U)??void 0}async $provideHistoryItems(T,G,W,U){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(G,W,U))?.map(V=>({...V,icon:l(V)}))??void 0}async $provideHistoryItemSummary(T,G,W,U){const C=this.g.get(T)?.historyProvider;if(typeof C?.provideHistoryItemSummary!="function")return;const O=await C.provideHistoryItemSummary(G,W,U);return O?{...O,icon:l(O)}:void 0}async $provideHistoryItemChanges(T,G,W,U){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(G,W,U)??void 0}};e.$djc=b,e.$djc=b=t=Xe([qe(3,A.$yj)],b)}),define(Ae[269],Me([1,0,3,8,2]),function(fe,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=void 0;class F{static{this.a=0}constructor(g,f){this.d=f,this.c=new Map,this.b=g.getProxy(S.$XL.MainThreadShare)}async $provideShare(g,f,k){return await this.c.get(g)?.provideShare({selection:L.Range.to(f.selection),resourceUri:P.URI.revive(f.resourceUri)},k)??void 0}registerShareProvider(g,f){const k=F.a++;return this.c.set(k,f),this.b.$registerShareProvider(k,L.DocumentSelector.from(g,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$ejc=F}),define(Ae[270],Me([1,0,7,3,165,6,8,16]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=e.$gjc=void 0;class f{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$VM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$VM("statusBarItem.warningForeground")]])}#e;#t;constructor(h,v,p,s,o,t=S.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new F.$Sc,this.#e=h,this.#t=v,o&&s){this.c=(0,S.$yM)(s.identifier,o);const r=p.get(this.c);r&&(t=r.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,n=r.priority,this.j=!0,this.name=r.name,this.text=r.text,this.tooltip=r.tooltip,this.command=r.command,this.accessibilityInformation=r.accessibilityInformation)}else this.c=String(f.a++);this.e=s,this.f=o,this.g=t,this.h=this.u(n)}u(h){if((0,g.$Wf)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(h){this.k=h,this.v()}set name(h){this.m=h,this.v()}set tooltip(h){this.l=h,this.v()}set color(h){this.n=h,this.v()}set backgroundColor(h){h&&!f.b.has(h.id)&&(h=void 0),this.o=h,this.v()}set command(h){this.r?.fromApi!==h&&(this.p&&this.q.add(this.p),this.p=new F.$Sc,typeof h=="string"?this.r={fromApi:h,internal:this.#t.toInternal({title:"",command:h},this.p)}:h?this.r={fromApi:h,internal:this.#t.toInternal(h,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(h){this.t=h,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let h;this.e?this.f?h=`${this.e.identifier.value}.${this.f}`:h=this.e.identifier.value:h=this.f;let v;this.m?v=this.m:v=(0,P.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=f.b.get(this.o.id));const s=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,h,this.e?.identifier.value,v,this.k,s,this.r?.internal,p,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$gjc=f;class k{constructor(h){this.b=[],this.a=h.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(h){const v={message:h};return this.b.unshift(v),this.c(),new S.$ZL(()=>{const p=this.b.indexOf(v);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(h,v){this.e=new Map,this.a=h.getProxy(L.$XL.MainThreadStatusBar),this.b=v,this.c=new k(this)}$acceptStaticEntries(h){for(const v of h)this.e.set(v.entryId,v)}createStatusBarEntry(h,v,p,s){return new f(this.a,this.b,this.e,h,v,p,s)}setStatusBarMessage(h,v){const p=this.c.setMessage(h);let s;return typeof v=="number"?s=setTimeout(()=>p.dispose(),v):typeof v<"u"&&v.then(()=>p.dispose(),()=>p.dispose()),new S.$ZL(()=>{p.dispose(),clearTimeout(s)})}}e.$hjc=A}),define(Ae[111],Me([1,0,29,103,49,75,59,8,2]),function(fe,e,S,L,P,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sO=e.$rO=e.$qO=e.$pO=void 0;const k=(r,u,l,i)=>{let $=u;return{enumerable:!0,configurable:!1,get(){return $},set(a){if(!l($,a)){const c=$;$=a,r.listener?.(i(a,c))}}}},A=(r,u)=>r===u,D={range:(r,u)=>r===u?!0:!r||!u?!1:r.isEqual(u),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(r,u)=>!(r.length!==u.length||r.some(l=>!u.find(i=>l.id===i.id)))},h=r=>u=>({op:4,update:r(u)}),v=(r,u)=>({range:(()=>{let l;const i=h($=>({range:S.$6s.lift(g.Range.from($))}));return{enumerable:!0,configurable:!1,get(){return l},set($){r.listener?.({op:6}),D.range(l,$)||(l=$,r.listener?.(i($)))}}})(),label:k(r,u,D.label,h(l=>({label:l}))),description:k(r,void 0,D.description,h(l=>({description:l}))),sortText:k(r,void 0,D.sortText,h(l=>({sortText:l}))),canResolveChildren:k(r,!1,D.canResolveChildren,l=>({op:2,state:l})),busy:k(r,!1,D.busy,h(l=>({busy:l}))),error:k(r,void 0,D.error,h(l=>({error:g.MarkdownString.fromStrict(l)||null}))),tags:k(r,[],D.tags,(l,i)=>({op:1,new:l.map(g.TestTag.from),old:i.map(g.TestTag.from)}))}),p=r=>{const u=P.$OK.fromString(r.extId),l=new o(u.controllerId,u.localId,r.label,f.URI.revive(r.uri)||void 0);return l.range=g.Range.to(r.range||void 0),l.description=r.description||void 0,l.sortText=r.sortText||void 0,l.tags=r.tags.map(i=>g.TestTag.to({id:(0,R.$TK)(i).tagId})),l},s=r=>{let u;for(const l of r.tests){const i=p(l.item);(0,L.$_N)(i).parent=u,u=i}return u};e.$pO=s;class o{constructor(u,l,i,$){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const a=(0,L.$$N)(this,u);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:$,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof t?void 0:a.parent}},children:{value:(0,F.$0N)(a,L.$_N,o),enumerable:!0,writable:!1},...v(a,i)})}}e.$qO=o;class t extends o{constructor(u,l){super(u,u,l,void 0),this._isRoot=!0}}e.$rO=t;class n extends F.$6N{constructor(u,l,i){super({controllerId:u,getDocumentVersion:$=>$&&i.getDocument($)?.version,getApiFor:L.$_N,getChildren:$=>$.children,root:new t(u,l),toITestItem:g.TestItem.from})}}e.$sO=n}),define(Ae[31],Me([1,0,16,7,8,26,3,18,14,52,29,91,2,6,4,17,111,24,50,41,63,57,60,33]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r,u,l,i,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=void 0;let a=class{#e;#t;#i;constructor(d,w,b){this.b=new Map,this.c=new Map,this.#e=d.getProxy(R.$XL.MainThreadCommands),this.d=w,this.#i=b,this.#t=d.getProxy(R.$XL.MainThreadTelemetry),this.converter=new c(this,M=>{const T=this.c.get(M);return T?.result===y.Void?T:void 0},w),this.f=[{processArgument(M){return(0,k.$Nh)(M)}},{processArgument(M){return(0,F.$Jn)(M,function(T){if(A.$6s.isIRange(T))return P.Range.to(T);if(D.$5s.isIPosition(T))return P.Position.to(T);if(A.$6s.isIRange(T.range)&&h.URI.isUri(T.uri))return P.location.to(T);if(T instanceof t.$se)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(d){this.f.push(d)}registerApiCommand(d){const w=this.registerCommand(!1,d.id,async(...b)=>{const M=d.args.map((G,W)=>{if(!G.validate(b[W]))throw new Error(`Invalid argument '${G.name}' when running '${d.id}', received: ${typeof b[W]=="object"?JSON.stringify(b[W],null,"	"):b[W]} `);return G.convert(b[W])}),T=await this.executeCommand(d.internalId,...M);return d.result.convert(T,b,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this.c.set(d.id,d),new L.$ZL(()=>{w.dispose(),this.c.delete(d.id)})}registerCommand(d,w,b,M,T,G){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:b,thisArg:M,metadata:T,extension:G}),d&&this.#e.$registerCommand(w),new L.$ZL(()=>{this.b.delete(w)&&d&&this.#e.$unregisterCommand(w)})}executeCommand(d,...w){return this.d.trace("ExtHostCommands#executeCommand",d),this.g(d,w,!0)}async g(d,w,b){if(this.b.has(d))return this.#e.$fireCommandActivationEvent(d),this.h(d,w,!1);{let M=!1;const T=(0,F.$Jn)(w,function(G){if(G instanceof L.$1L)return P.Position.from(G);if(G instanceof L.$2L)return P.Range.from(G);if(G instanceof L.$_L)return P.location.from(G);if(L.$nN.isNotebookRange(G))return P.NotebookRange.from(G);if(G instanceof ArrayBuffer)return M=!0,t.$se.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return M=!0,t.$se.wrap(G);if(G instanceof t.$se)return M=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(d,M?new n.$6v(T):T,b);return(0,k.$Nh)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(d,w,!1);throw G}}}async h(d,w,b){const M=this.b.get(d);if(!M)throw new Error("Unknown command");const{callback:T,thisArg:G,metadata:W}=M;if(W?.args)for(let C=0;C<W.args.length;C++)try{(0,S.$0f)(w[C],W.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${W.args[C].name}' - ${W.args[C].description}`)}const U=u.$1d.create();try{return await T.apply(G,w)}catch(C){if(d===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...w);O&&(d=O.command)}if(this.d.error(C,d,M.extension?.identifier),!b)throw C;if(M.extension?.identifier){const O=this.#i.onExtensionError(M.extension.identifier,C);this.d.trace("forwarded error to extension?",O,M.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.$2i)(C)),this.id=d,this.source=M.extension?.displayName??M.extension?.name}}}finally{this.j(M,d,U.elapsed())}}j(d,w,b){d.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:d.extension.identifier.value,id:new l.$Wo(w),duration:b})}$executeContributedCommand(d,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",d);const b=this.b.get(d);return b?(w=w.map(M=>this.f.reduce((T,G)=>G.processArgument(T,b.extension?.identifier),M)),this.h(d,w,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this.d.trace("ExtHostCommands#getCommands",d),this.#e.$getCommands().then(w=>(d&&(w=w.filter(b=>b[0]!=="_")),w))}$getContributedCommandMetadata(){const d=Object.create(null);for(const[w,b]of this.b){const{metadata:M}=b;M&&(d[w]=M)}return Promise.resolve(d)}};e.$yO=a,e.$yO=a=Xe([qe(0,s.$dO),qe(1,f.$yj),qe(2,i.$xO)],a),e.$zO=(0,p.$ei)("IExtHostCommands");class c{constructor(d,w,b){this.d=d,this.f=w,this.g=b,this.delegatingCommandId=`__vsc${(0,$.$Ag)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(d,w){if(!d)return;const b={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return b;const M=this.f(d.command);if(M)b.id=M.internalId,b.arguments=M.args.map((T,G)=>T.convert(d.arguments&&d.arguments[G]));else if((0,g.$Lb)(d.arguments)){const T=`${d.command} /${++this.c}`;this.b.set(T,d),w.add((0,v.$Rc)(()=>{this.b.delete(T),this.g.trace("CommandsConverter#DISPOSE",T)})),b.$ident=T,b.id=this.delegatingCommandId,b.arguments=[T],this.g.trace("CommandsConverter#CREATE",d.command,T)}return b}fromInternal(d){return typeof d.$ident=="string"?this.b.get(d.$ident):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this.b.get(d[0])}h(...d){const w=this.getActualCommand(...d);return this.g.trace("CommandsConverter#EXECUTE",d[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${d[0]}`)}}e.$AO=c;class E{static{this.Uri=new E("uri","Uri of a text document",d=>h.URI.isUri(d),d=>d)}static{this.Position=new E("position","A position in a text document",d=>L.$1L.isPosition(d),P.Position.from)}static{this.Range=new E("range","A range in a text document",d=>L.$2L.isRange(d),P.Range.from)}static{this.Selection=new E("selection","A selection in a text document",d=>L.$3L.isSelection(d),P.Selection.from)}static{this.Number=new E("number","",d=>typeof d=="number",d=>d)}static{this.String=new E("string","",d=>typeof d=="string",d=>d)}static{this.StringArray=E.Arr(E.String)}static Arr(d){return new E(`${d.name}_array`,`Array of ${d.name}, ${d.description}`,w=>Array.isArray(w)&&w.every(b=>d.validate(b)),w=>w.map(b=>d.convert(b)))}static{this.CallHierarchyItem=new E("item","A call hierarchy item",d=>d instanceof L.$kM,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new E("item","A type hierarchy item",d=>d instanceof L.$GN,P.TypeHierarchyItem.from)}static{this.TestItem=new E("testItem","A VS Code TestItem",d=>d instanceof o.$qO,P.TestItem.from)}constructor(d,w,b,M){this.name=d,this.description=w,this.validate=b,this.convert=M}optional(){return new E(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,w){return new E(d??this.name,w??this.description,this.validate,this.convert)}}e.$BO=E;class y{static{this.Void=new y("no result",d=>d)}constructor(d,w){this.description=d,this.convert=w}}e.$CO=y;class m{constructor(d,w,b,M,T){this.id=d,this.internalId=w,this.description=b,this.args=M,this.result=T}}e.$DO=m}),define(Ae[271],Me([1,0,18,12,2,86,95,35,31,8,7]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;const D=[new f.$DO("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$BO.Uri,f.$BO.Position],new f.$CO("A promise that resolves to an array of DocumentHighlight-instances.",v(k.DocumentHighlight.to))),new f.$DO("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$BO.Uri],new f.$CO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,S.$Kb)(s))return;class t extends A.$fM{static to(r){const u=new t(r.name,k.SymbolKind.to(r.kind),r.containerName||"",new A.$_L(o[0],k.Range.to(r.range)));return u.detail=r.detail,u.range=u.location.range,u.selectionRange=k.Range.to(r.selectionRange),u.children=r.children?r.children.map(t.to):[],u}}return s.map(t.to)})),new f.$DO("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$BO.Uri,new f.$BO("options","Formatting options",s=>!0,s=>s)],new f.$CO("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new f.$DO("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$BO.Uri,f.$BO.Range,new f.$BO("options","Formatting options",s=>!0,s=>s)],new f.$CO("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new f.$DO("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$BO.Uri,f.$BO.Position,new f.$BO("ch","Trigger character",s=>typeof s=="string",s=>s),new f.$BO("options","Formatting options",s=>!0,s=>s)],new f.$CO("A promise that resolves to an array of TextEdits.",v(k.TextEdit.to))),new f.$DO("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$BO.Uri,f.$BO.Position],new f.$CO("A promise that resolves to an array of Location or LocationLink instances.",p)),new f.$DO("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$BO.Uri,f.$BO.Position],new f.$CO("A promise that resolves to an array of Location or LocationLink instances.",p)),new f.$DO("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$BO.Uri,f.$BO.Position],new f.$CO("A promise that resolves to an array of Location or LocationLink instances.",p)),new f.$DO("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$BO.Uri,f.$BO.Position],new f.$CO("A promise that resolves to an array of Location or LocationLink instances.",p)),new f.$DO("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$BO.Uri,f.$BO.Position],new f.$CO("A promise that resolves to an array of Location-instances.",v(k.location.to))),new f.$DO("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$BO.Uri,f.$BO.Position],new f.$CO("A promise that resolves to an array of Hover-instances.",v(k.Hover.to))),new f.$DO("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$BO.Uri,new f.$BO("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>A.$1L.isPosition(o)),s=>s.map(k.Position.from))],new f.$CO("A promise that resolves to an array of ranges.",s=>s.map(o=>{let t;for(const n of o.reverse())t=new A.$jM(k.Range.to(n),t);return t}))),new f.$DO("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$BO.String.with("query","Search string")],new f.$CO("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(k.WorkspaceSymbol.to))),new f.$DO("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$BO.Uri,f.$BO.Position],new f.$CO("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(k.CallHierarchyItem.to))),new f.$DO("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$BO.CallHierarchyItem],new f.$CO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(k.CallHierarchyIncomingCall.to))),new f.$DO("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$BO.CallHierarchyItem],new f.$CO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(k.CallHierarchyOutgoingCall.to))),new f.$DO("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$BO.Uri,f.$BO.Position],new f.$CO("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:k.Range.to(s.range),placeholder:s.text}})),new f.$DO("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$BO.Uri,f.$BO.Position,f.$BO.String.with("newName","The new symbol name")],new f.$CO("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return k.WorkspaceEdit.to(s)}})),new f.$DO("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$BO.Uri,f.$BO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$CO("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(k.DocumentLink.to))),new f.$DO("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$BO.Uri],new f.$CO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new A.$eN(s.tokenTypes,s.tokenModifiers)})),new f.$DO("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$BO.Uri],new f.$CO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,R.$9_)(s);if(o.type==="full")return new A.$gN(o.data,void 0)})),new f.$DO("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$BO.Uri,f.$BO.Range.optional()],new f.$CO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new A.$eN(s.tokenTypes,s.tokenModifiers)})),new f.$DO("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$BO.Uri,f.$BO.Range],new f.$CO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,R.$9_)(s);if(o.type==="full")return new A.$gN(o.data,void 0)})),new f.$DO("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$BO.Uri,f.$BO.Position,f.$BO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$BO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$CO("A promise that resolves to a CompletionList-instance.",(s,o,t)=>{if(!s)return new A.$vM([]);const n=s.suggestions.map(r=>k.CompletionItem.to(r,t));return new A.$vM(n,s.incomplete)})),new f.$DO("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$BO.Uri,f.$BO.Position,f.$BO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$CO("A promise that resolves to SignatureHelp.",s=>{if(s)return k.SignatureHelp.to(s)})),new f.$DO("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$BO.Uri,f.$BO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$CO("A promise that resolves to an array of CodeLens-instances.",(s,o,t)=>v(n=>new A.$nM(k.Range.to(n.range),n.command&&t.fromInternal(n.command)))(s))),new f.$DO("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$BO.Uri,new f.$BO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>A.$2L.isRange(s),s=>A.$3L.isSelection(s)?k.Selection.from(s):k.Range.from(s)),f.$BO.String.with("kind","Code action kind to return code actions for").optional(),f.$BO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$CO("A promise that resolves to an array of Command-instances.",(s,o,t)=>v(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const r=new A.$hM(n.title,n.kind?new A.$iM(n.kind):void 0);return n.edit&&(r.edit=k.WorkspaceEdit.to(n.edit)),n.command&&(r.command=t.fromInternal(n.command)),r.isPreferred=n.isPreferred,r}})(s))),new f.$DO("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$BO.Uri],new f.$CO("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new A.$BM(k.Range.to(o.range),k.Color.to(o.color))):[])),new f.$DO("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$BO("color","The color to show and insert",s=>s instanceof A.$AM,k.Color.from),new f.$BO("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:k.Range.from(s.range)}))],new f.$CO("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(k.ColorPresentation.to):[])),new f.$DO("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$BO.Uri,f.$BO.Range],new f.$CO("A promise that resolves to an array of Inlay objects",(s,o,t)=>s.map(k.InlayHint.to.bind(void 0,t)))),new f.$DO("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$BO.Uri],new f.$CO("A promise that resolves to an array of FoldingRange objects",(s,o)=>{if(s)return s.map(k.FoldingRange.to)})),new f.$DO("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$CO("A promise that resolves to an array of NotebookContentProvider static info objects.",v(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new f.$DO("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$BO.Uri,f.$BO.Range,new f.$BO("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof A.$2L,s=>k.InlineValueContext.from(s))],new f.$CO("A promise that resolves to an array of InlineValue objects",s=>s.map(k.InlineValue.to))),new f.$DO("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$BO("uriOrString","Uri-instance or string (only http/https)",s=>P.URI.isUri(s)||typeof s=="string"&&(0,L.$pg)(s,L.Schemas.http,L.Schemas.https),s=>s),new f.$BO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional(),f.$BO.String.with("label","").optional()],f.$CO.Void),new f.$DO("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$BO.Uri.with("resource","Resource to open"),f.$BO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$BO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional()],f.$CO.Void),new f.$DO("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$BO.Uri.with("left","Left-hand side resource of the diff editor"),f.$BO.Uri.with("right","Right-hand side resource of the diff editor"),f.$BO.String.with("title","Human readable title for the diff editor").optional(),new f.$BO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)]).optional()],f.$CO.Void),new f.$DO("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$BO.String.with("title","Human readable title for the changes editor"),new f.$BO("resourceList","List of resources to compare",s=>{for(const o of s){if(o.length!==3)return!1;const[t,n,r]=o;if(!P.URI.isUri(t)||!P.URI.isUri(n)&&n!==void 0&&n!==null||!P.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},s=>s)],f.$CO.Void),new f.$DO("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$BO.Uri,f.$BO.Position],new f.$CO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new f.$DO("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$BO.TypeHierarchyItem],new f.$CO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new f.$DO("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$BO.TypeHierarchyItem],new f.$CO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new f.$DO("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$BO.TestItem],f.$CO.Void),new f.$DO("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$BO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$CO.Void),new f.$DO("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$BO.String.with("name","The context key name"),new f.$BO("value","The context key value",()=>!0,s=>s)],f.$CO.Void),new f.$DO("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$BO.Uri,f.$BO.StringArray,new f.$BO("MappedEditsContext","Mapped Edits Context",s=>k.MappedEditsContext.is(s),s=>k.MappedEditsContext.from(s))],new f.$CO("A promise that resolves to a workspace edit or null",s=>s?k.WorkspaceEdit.to(s):null))];class h{static register(o){D.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",g.$dj)}}e.$Chc=h;function v(s){return o=>{if(Array.isArray(o))return o.map(s)}}function p(s){if(!Array.isArray(s))return;const o=[];for(const t of s)F.$St(t)?o.push(k.DefinitionLink.to(t)):o.push(k.location.to(t));return o}}),define(Ae[272],Me([1,0,11,6,2,3,31,8,7]),function(fe,e,S,L,P,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;class k{static{this.a=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=k.a++}}class A{constructor(v){this.session=v,this.responses=[]}}class D{static{this.a=0}constructor(v,p,s,o){this.f=s,this.g=o,this.b=new Map,this.d=new Map,this.e=v.getProxy(F.$XL.MainThreadInlineChat),p.registerApiCommand(new R.$DO("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$BO("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?g.Range.from(t.initialRange):void 0,initialSelection:f.$3L.isSelection(t.initialSelection)?g.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?g.Position.from(t.position):void 0}})],R.$CO.Void))}registerProvider(v,p,s){const o=new k(v,p);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,s?.label??v.displayName??v.name,v.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function",typeof p.provideFollowups=="function",s?.supportReportIssue??!1),(0,L.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(v,p,s,o){const t=this.b.get(v);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(P.URI.revive(p)),r=g.Selection.to(s),u=await t.provider.prepareInteractiveEditorSession({document:n,selection:r},o);if(!u)return;if(u.wholeRange&&!u.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=D.a++;return this.d.set(l,new A(u)),{id:l,placeholder:u.placeholder,input:u.input,slashCommands:u.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:g.Range.from(u.wholeRange),message:u.message}}async $provideResponse(v,p,s,o){const t=this.b.get(v);if(!t)return;const n=this.d.get(p.id);if(!n)return;const r={prompt:s.prompt,selection:g.Selection.to(s.selection),wholeRange:g.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(P.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let u=!1;const l={report:async I=>{if(!s.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");u||o.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:I.message,edits:I.edits?.map(g.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:f.$oM.isMarkdownString(I.content)?I.content.value:I.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,r,l,o));let $;try{$=await(0,S.$5g)(i,o)}finally{u=!0}if(!$)return;const a=n.responses.push($)-1,c={wholeRange:g.Range.from($.wholeRange),placeholder:$.placeholder};if(!D.h($))return{...c,id:a,type:"editorEdit",message:g.MarkdownString.from($.contents),edits:[]};const{edits:E,contents:y}=$,m=y!==void 0?g.MarkdownString.from(y):void 0;return E instanceof f.$0L?{...c,id:a,type:"bulkEdit",edits:g.WorkspaceEdit.from(E),message:m}:{...c,id:a,type:"editorEdit",edits:E.map(g.TextEdit.from),message:m}}async $provideFollowups(v,p,s,o){const t=this.b.get(v),n=this.d.get(p),r=n?.responses[s];if(t&&r&&t.provider.provideFollowups){const u=Promise.resolve(t.provider.provideFollowups(n.session,r,o));return(await(0,S.$5g)(u,o))?.map(g.ChatInlineFollowup.from)}}$handleFeedback(v,p,s,o){const t=this.b.get(v),n=this.d.get(p),r=n?.responses[s];if(t&&r){const u=g.InteractiveEditorResponseFeedbackKind.to(o);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,r,u)}}$releaseSession(v,p){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$Kic=D}),define(Ae[273],Me([1,0,2,31]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=void 0;class P{constructor(R,g,f,k,A){this.a=g,this.b=f,this.c=k;const D=new L.$DO("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$BO("showOptions","Show Options",h=>!0,h=>h),new L.$BO("resource","Interactive resource Uri",h=>!0,h=>h),new L.$BO("controllerId","Notebook controller Id",h=>!0,h=>h),new L.$BO("title","Interactive editor title",h=>!0,h=>h)],new L.$CO("Notebook and input URI",h=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const v=this.a.getEditorById(h.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:S.URI.revive(h.notebookUri),inputUri:S.URI.revive(h.inputUri),notebookEditor:v.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:S.URI.revive(h.notebookUri),inputUri:S.URI.revive(h.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(R,g,f,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:f,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,g){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Xic=P}),define(Ae[274],Me([1,0,18,11,21,5,6,28,2,22,14,3,31,8,7,76,211,23,50,212]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=e.$6ic=void 0;let u=class{constructor(m,I,d,w,b){this.m=I,this.n=d,this.o=w,this.q=b,this.b=new g.$Ac,this.c=new g.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new F.$5d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=m.getProxy(D.$XL.MainThreadNotebookKernels);const M=new h.$DO("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new h.$BO("options","Select kernel options",G=>!0,G=>{if(G&&"notebookEditor"in G&&"id"in G){const W=this.n.getIdByEditor(G.notebookEditor);return{id:G.id,extension:G.extension,notebookEditorId:W}}else if(G&&"notebookEditor"in G){const W=this.n.getIdByEditor(G.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${G.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return G})],h.$CO.Void),T=new h.$DO("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[h.$BO.Uri],new h.$CO("A promise that resolves to an array of variables",(G,W)=>G.map(U=>({name:U.name,value:U.value,type:U.type,editable:!1}))));this.o.registerApiCommand(M),this.o.registerApiCommand(T)}createNotebookController(m,I,d,w,b,M){for(const $e of this.j.values())if($e.controller.id===I&&k.$wm.equals(m.identifier,$e.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const T=this.k++,G=this;this.q.trace(`NotebookController[${T}], CREATED by ${m.identifier.value}, ${I}`);const W=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${m.identifier}'`);let U=!1;const C=new F.$5d,O=new F.$5d,V={id:E(m.identifier,I),notebookType:d,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:w||m.identifier.value,preloads:M?M.map(v.NotebookRendererScript.from):[]};let re=b??W,ce,ye;this.a.$addKernel(T,V).catch($e=>{console.log($e),U=!0});let De=0;const he=()=>{if(U)return;const $e=++De;Promise.resolve().then(()=>{$e===De&&this.a.$updateKernel(T,V)})},ve=new g.$Ac,se={get id(){return I},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:C.event,get label(){return V.label},set label($e){V.label=$e??m.displayName??m.name,he()},get detail(){return V.detail??""},set detail($e){V.detail=$e,he()},get description(){return V.description??""},set description($e){V.description=$e,he()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages($e){V.supportedLanguages=$e,he()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder($e){V.supportsExecutionOrder=$e,he()},get rendererScripts(){return V.preloads?V.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler($e){re=$e??W},get interruptHandler(){return ce},set interruptHandler($e){ce=$e,V.supportsInterrupt=!!$e,he()},set variableProvider($e){(0,t.$VF)(m,"notebookVariableProvider"),ye=$e,V.hasVariableProvider=!!$e,$e?.onDidChangeVariables(ee=>G.a.$variablesUpdated(ee.uri)),he()},get variableProvider(){return ye},createNotebookCellExecution($e){if(U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.notebook.uri))throw G.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return G._createNotebookCellExecution($e,E(m.identifier,this.id))},createNotebookExecution($e){if((0,t.$VF)(m,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.uri))throw G.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return G._createNotebookExecution($e,E(m.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${T}], DISPOSED`),U=!0,this.j.delete(T),C.dispose(),O.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity($e,ee){ee===p.NotebookControllerAffinity2.Hidden&&(0,t.$VF)(m,"notebookControllerAffinityHidden"),G.a.$updateNotebookPriority(T,$e.uri,ee)},onDidReceiveMessage:O.event,postMessage($e,ee){return(0,t.$VF)(m,"notebookMessaging"),G.a.$postMessage(T,ee&&G.n.getIdByEditor(ee),$e)},asWebviewUri($e){return(0,t.$VF)(m,"notebookMessaging"),(0,s.$uxb)($e,G.m.remote)}};return this.j.set(T,{extensionId:m.identifier,controller:se,onDidReceiveMessage:O,onDidChangeSelection:C,associatedNotebooks:ve}),se}getIdByController(m){for(const[I,d]of this.j)if(d.controller===m)return E(d.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,I){const d=this.g++,w=this;this.q.trace(`NotebookControllerDetectionTask[${d}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(d,I);const b={dispose:()=>{this.f.delete(d),w.a.$removeKernelDetectionTask(d)}};return this.f.set(d,b),b}registerKernelSourceActionProvider(m,I,d){const w=this.i++,b=typeof d.onDidChangeNotebookKernelSourceActions=="function"?w:void 0,M=this;this.h.set(w,d),this.q.trace(`NotebookKernelSourceActionProvider[${w}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(w,w,I);let T;return b!==void 0&&(T=d.onDidChangeNotebookKernelSourceActions(G=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.h.delete(w),M.a.$removeKernelSourceActionProvider(w,w),T?.dispose()}}}async $provideKernelSourceActions(m,I){const d=this.h.get(m);if(d){const w=new R.$Sc;return(await d.provideNotebookKernelSourceActions(I)??[]).map(M=>v.NotebookKernelSourceAction.from(M,this.o.converter,w))}return[]}$acceptNotebookAssociation(m,I,d){const w=this.j.get(m);if(w){const b=this.n.getNotebookDocument(f.URI.revive(I));d?w.associatedNotebooks.set(b.uri,!0):w.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${m}] ASSOCIATE notebook`,b.uri.toString(),d),w.onDidChangeSelection.fire({selected:d,notebook:b.apiNotebook})}}async $executeCells(m,I,d){const w=this.j.get(m);if(!w)return;const b=this.n.getNotebookDocument(f.URI.revive(I)),M=[];for(const T of d){const G=b.getCell(T);G&&M.push(G.apiCell)}try{this.q.trace(`NotebookController[${m}] EXECUTE cells`,b.uri.toString(),M.length),await w.controller.executeHandler.call(w.controller,M,b.apiNotebook,w.controller)}catch(T){this.q.error(`NotebookController[${m}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(m,I,d){const w=this.j.get(m);if(!w)return;const b=this.n.getNotebookDocument(f.URI.revive(I));if(w.controller.interruptHandler)await w.controller.interruptHandler.call(w.controller,b.apiNotebook);else for(const M of d){const T=b.getCell(M);T&&this.b.get(T.uri)?.cancel()}if(w.controller.interruptHandler){const M=this.c.get(b.uri);d.length&&Array.isArray(M)&&M.length&&M.forEach(T=>T.dispose())}}async $provideVariables(m,I,d,w,b,M,T){const G=this.j.get(m);if(!G)return;const W=this.n.getNotebookDocument(f.URI.revive(d)),U=G.controller.variableProvider;if(!U)return;let C;if(w!==void 0){if(C=this.s[w],!C)return}else this.s={};const O=b==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,V=U.provideVariables(W.apiNotebook,C,O,M,T);let re=0;for await(const ce of V){if(T.isCancellationRequested)return;const ye={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:G.extensionId.value};if(this.s[ye.id]=ce.variable,this.a.$receiveVariable(I,ye),re++>=r.$Xgb)return}}$acceptKernelMessageFromRenderer(m,I,d){const w=this.j.get(m);if(!w)return;const b=this.n.getEditorById(I);w.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:d}))}$cellExecutionChanged(m,I,d){const b=this.n.getNotebookDocument(f.URI.revive(m)).getCell(I);if(b){const M=d?v.NotebookCellExecutionState.to(d):p.NotebookCellExecutionState.Idle;M!==void 0&&this.l.fire({cell:b.apiCell,state:M})}}_createNotebookCellExecution(m,I){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const w=this.n.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!w)throw new Error("invalid cell");if(this.b.has(w.uri))throw new Error(`duplicate execution for ${w.uri}`);const b=new i(I,w,this.a);this.b.set(w.uri,b);const M=b.onDidChangeState(()=>{b.state===l.Resolved&&(b.dispose(),M.dispose(),this.b.delete(w.uri))});return b.asApiObject()}_createNotebookExecution(m,I){const d=this.n.getNotebookDocument(m.uri),w=m.getCells().find(T=>{const G=d.getCellFromApiCell(T);return G&&this.b.has(G.uri)});if(w)throw new Error(`duplicate cell execution for ${w.document.uri}`);if(this.c.has(d.uri))throw new Error(`duplicate notebook execution for ${d.uri}`);const b=new a(I,d,this.a),M=b.onDidChangeState(()=>{b.state===$.Resolved&&(b.dispose(),M.dispose(),this.c.delete(d.uri))});return this.c.set(d.uri,[b,M]),b.asApiObject()}};e.$6ic=u,e.$6ic=u=Xe([qe(4,A.$yj)],u);var l;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(l||(l={}));class i extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(m,I,d){super(),this.m=I,this.n=d,this.b=i.a++,this.c=new F.$5d,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new P.$ce),this.h=new c(10,w=>this.s(w)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const I=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new n.$6v(I))}t(){if(this.f===l.Init)throw new Error("Must call start before modifying cell output");if(this.f===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let I=this.m;if(m&&(I=this.m.notebook.getCellFromApiCell(m)),!I)throw new Error("INVALID cell");return I.handle}y(m){return m.map(I=>{const d=p.$rN.ensureUniqueMimeTypes(I.items,!0);return d===I.items?v.NotebookCellOutput.from(I):v.NotebookCellOutput.from({items:d,id:I.id,metadata:I.metadata})})}async z(m,I,d){const w=this.w(I),b=this.y((0,S.$3b)(m));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:w,append:d,outputs:b})}async C(m,I,d){return m=p.$rN.ensureUniqueMimeTypes((0,S.$3b)(m),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:m.map(v.NotebookCellOutputItem.from),outputId:I.id,append:d})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(d){m.j=d,m.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(d){if(m.f===l.Resolved||m.f===l.Started)throw new Error("Cannot call start again");m.f=l.Started,m.c.fire(),m.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:d})},end(d,w){if(m.f===l.Resolved)throw new Error("Cannot call resolve twice");m.f=l.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new n.$6v({runEndTime:w,lastRunSuccess:d}))},clearOutput(d){return m.t(),m.z([],d,!1)},appendOutput(d,w){return m.t(),m.z(d,w,!0)},replaceOutput(d,w){return m.t(),m.z(d,w,!1)},appendOutputItems(d,w){return m.t(),m.C(d,w,!0)},replaceOutputItems(d,w){return m.t(),m.C(d,w,!1)}})}}var $;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})($||($={}));class a extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(m,I,d){super(),this.h=I,this.j=d,this.b=a.a++,this.c=new F.$5d,this.onDidChangeState=this.c.event,this.f=$.Init,this.g=this.B(new P.$ce),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===$.Resolved||this.f===$.Started)throw new Error("Cannot call start again");this.f=$.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===$.Resolved)throw new Error("Cannot call resolve twice");this.f=$.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(m,I){this.f=m,this.g=I,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new L.$Bh,this.b=Date.now(),(0,L.$fh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>m.complete())}}function E(y,m){return`${y.value}/${m}`}e.$7ic=E}),define(Ae[65],Me([1,0,5,3,4,2,17,6,7,167,15,195,21,33,196,40,11,8,31]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=e.$hic=e.$gic=e.$fic=void 0,e.$fic=(0,P.$ei)("IExtHostTerminalService");class r{constructor(d,w,b,M){this.l=d,this._id=w,this.m=b,this.n=M,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const T=this;this.value={get name(){return T.n||""},get processId(){return T.b},get creationOptions(){return T.m},get exitStatus(){return T.h},get state(){return T.j},get selection(){return T.k},sendText(G,W=!0){T.q(),T.l.$sendText(T._id,G,W)},show(G){T.q(),T.l.$show(T._id,G)},hide(){T.q(),T.l.$hide(T._id)},dispose(){T.a||(T.a=!0,T.l.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create(d,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:d.name,shellPath:d.shellPath??void 0,shellArgs:d.shellArgs??void 0,cwd:d.cwd??w?.cwd??void 0,env:d.env??void 0,icon:E(d.iconPath)??void 0,color:s.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:d.message??void 0,strictEnv:d.strictEnv??void 0,hideFromUser:d.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(d.location,w?.resolvedExtHostIdentifier),isTransient:d.isTransient??void 0})}async createExtensionTerminal(d,w,b,M,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:M,color:s.ThemeColor.isThemeColor(T)?T.id:void 0,location:w?.location||this.o(d,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(d,w){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in d?{viewColumn:t.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus}:void 0:d}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(d){this.n=d}setExitStatus(d,w){this.h=Object.freeze({code:d,reason:w})}setDimensions(d,w){return d===this.d&&w===this.g||d===0||w===0?!1:(this.d=d,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(d){this.k=d}_setProcessId(d){this.f?(this.f(d),this.f=void 0):this.b.then(w=>{w!==d&&(this.b=Promise.resolve(d))})}}e.$gic=r;class u{get onProcessReady(){return this.b.event}constructor(d){this.g=d,this.id=0,this.shouldPersist=!1,this.a=new S.$5d,this.onProcessData=this.a.event,this.b=new S.$5d,this.d=new S.$5d,this.onDidChangeProperty=this.d.event,this.f=new S.$5d,this.onProcessExit=this.f.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(d){this.g.handleInput?.(d)}resize(d,w){this.g.setDimensions?.({columns:d,rows:w})}clearBuffer(){}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(d){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(d||void 0),d&&this.g.setDimensions?.(d),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,i=class extends g.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(d=>d.value)}constructor(d,w,b){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new g.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$5d,this.onDidCloseTerminal=this.H.event,this.I=new S.$5d,this.onDidOpenTerminal=this.I.event,this.J=new S.$5d,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$5d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$5d,this.onDidChangeTerminalState=this.M.event,this.N=new S.$5d,this.onDidChangeShell=this.N.event,this.O=new S.$5d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$5d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=b.getProxy(L.$XL.MainThreadTerminalService),this.y=new p.$Etb(this.a.$sendProcessData),this.a.$registerProcessSupport(d),this.Q.registerArgumentProcessor({processArgument:M=>{const T=G=>{const W=G;return this.W(W.instanceId)?.value};switch(M?.$mid){case 15:return T(M);default:{if(Array.isArray(M))for(let G=0;G<M.length&&M[G].$mid===15;G++)M[G]=T(M[G]);return M}}}}),this.B({dispose:()=>{for(const[M,T]of this.g)T.shutdown(!0)}})}getDefaultShell(d){return(d?this.u:this.s)?.path||""}getDefaultShellArgs(d){return(d?this.u:this.s)?.args||[]}createExtensionTerminal(d,w){const b=new r(this.a,(0,v.$Ag)(),d,d.name),M=new u(d.pty);return b.createExtensionTerminal(d.location,w,this.R(d,w).resolvedExtHostIdentifier,E(d.iconPath),y(d.color)).then(T=>{const G=this.S(T,M);this.h[T]=G}),this.f.push(b),b.value}R(d,w){if(w=w||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const b=d.location.parentTerminal;if(b){const M=this.f.find(T=>T.value===b);M&&(w.resolvedExtHostIdentifier=M._id)}}else d.location&&typeof d.location!="object"?w.location=d.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(d,w){if(!this.W(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const M=new u(w),T=this.S(d,M);this.h[d]=T}async $acceptActiveTerminalChanged(d){const w=this.b;if(d===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const b=this.W(d);b&&(this.b=b,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(d,w){const b=this.W(d);b&&this.O.fire({terminal:b.value,data:w})}async $acceptTerminalDimensions(d,w,b){const M=this.W(d);M&&M.setDimensions(w,b)&&this.L.fire({terminal:M.value,dimensions:M.value.dimensions})}async $acceptDidExecuteCommand(d,w){const b=this.W(d);b&&this.P.fire({terminal:b.value,...w})}async $acceptTerminalMaximumDimensions(d,w,b){this.g.get(d)?.resize(w,b)}async $acceptTerminalTitleChange(d,w){const b=this.W(d);b&&(b.name=w)}async $acceptTerminalClosed(d,w,b){const M=this.Y(this.f,d);if(M!==null){const T=this.f.splice(M,1)[0];T.setExitStatus(w,b),this.H.fire(T.value)}}$acceptTerminalOpened(d,w,b,M){if(w){const W=this.Y(this.f,w);if(W!==null){this.f[W]._id=d,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const T={name:M.name,shellPath:M.executable,shellArgs:M.args,cwd:typeof M.cwd=="string"?M.cwd:F.URI.revive(M.cwd),env:M.env,hideFromUser:M.hideFromUser},G=new r(this.a,d,T,b);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(d,w){this.W(d)?._setProcessId(w)}async $startExtensionTerminal(d,w){const b=this.W(d);if(!b)return{message:(0,k.localize)(0,null,d)};b.isOpen||await new Promise(T=>{const G=this.onDidOpenTerminal(async W=>{W===b.value&&(G.dispose(),T())})});const M=this.g.get(d);M?M.startSendingEvents(w):this.j[d]={initialDimensions:w}}S(d,w){const b=new g.$Sc;b.add(w.onProcessReady(T=>this.a.$sendProcessReady(d,T.pid,T.cwd,T.windowsPty))),b.add(w.onDidChangeProperty(T=>this.a.$sendProcessProperty(d,T))),this.y.startBuffering(d,w.onProcessData),b.add(w.onProcessExit(T=>this.U(d,T))),this.g.set(d,w);const M=this.j[d];return M&&w instanceof u&&(w.startSendingEvents(M.initialDimensions),delete this.j[d]),b}$acceptProcessAckDataEvent(d,w){this.g.get(d)?.acknowledgeDataEvent(w)}$acceptProcessInput(d,w){this.g.get(d)?.input(w)}$acceptTerminalInteraction(d){const w=this.W(d);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(d,w){this.W(d)?.setSelection(w)}$acceptProcessResize(d,w,b){try{this.g.get(d)?.resize(w,b)}catch(M){if(M.code!=="EPIPE"&&M.code!=="ERR_IPC_CHANNEL_CLOSED")throw M}}$acceptProcessShutdown(d,w){this.g.get(d)?.shutdown(w)}$acceptProcessRequestInitialCwd(d){this.g.get(d)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(d,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(d){this.g.get(d)?.getCwd().then(w=>this.a.$sendProcessProperty(d,{type:"cwd",value:w}))}$acceptProcessRequestLatency(d){return Promise.resolve(d)}registerLinkProvider(d){return this.z.add(d),this.z.size===1&&this.a.$startLinkProvider(),new f.$ZL(()=>{this.z.delete(d),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(d,w,b){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,b),this.a.$registerProfileProvider(w,d.identifier.value),new f.$ZL(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(d,w,b){if(this.D.has(d))throw new Error(`Terminal quick fix provider "${d}" is already registered`);return this.D.set(d,b),this.a.$registerQuickFixProvider(d,w),new f.$ZL(()=>{this.D.delete(d),this.a.$unregisterQuickFixProvider(d)})}async $provideTerminalQuickFixes(d,w){const b=new h.$ce().token;if(b.isCancellationRequested)return;const M=this.D.get(d);if(!M)return;const T=await M.provideTerminalQuickFixes(w,b);if(T===null||Array.isArray(T)&&T.length===0)return;const G=new g.$Sc;if(this.w.value=G,!Array.isArray(T))return T?t.TerminalQuickFix.from(T,this.Q.converter,G):void 0;const W=[];for(const U of T){const C=t.TerminalQuickFix.from(U,this.Q.converter,G);C&&W.push(C)}return W}async $createContributedProfileTerminal(d,w){const b=new h.$ce().token;let M=await this.C.get(d)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(M&&!("options"in M)&&(M={options:M}),!M||!("options"in M))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in M.options){this.createExtensionTerminal(M.options,w);return}this.createTerminalFromOptions(M.options,w)}}async $provideLinks(d,w){const b=this.W(d);if(!b)return[];this.F.delete(d),this.G.get(d)?.dispose(!0);const T=new h.$ce;this.G.set(d,T);const G=[],W={terminal:b.value,line:w},U=[];for(const V of this.z)U.push(o.Promises.withAsyncBody(async re=>{T.token.onCancellationRequested(()=>re({provider:V,links:[]}));const ce=await V.provideTerminalLinks(W,T.token)||[];T.token.isCancellationRequested||re({provider:V,links:ce})}));const C=await Promise.all(U);if(T.token.isCancellationRequested)return[];const O=new Map;for(const V of C)V&&V.links.length>0&&G.push(...V.links.map(re=>{const ce={id:l++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return O.set(ce.id,{provider:V.provider,link:re}),ce}));return this.F.set(d,O),G}$activateLink(d,w){const b=this.F.get(d)?.get(w);b&&b.provider.handleTerminalLink(b.link)}U(d,w){this.y.stopBuffering(d),this.g.delete(d),delete this.j[d];const b=this.h[d];b&&(b.dispose(),delete this.h[d]),this.a.$sendProcessExit(d,w)}W(d){return this.X(this.f,d)}X(d,w){const b=this.Y(d,w);return b!==null?d[b]:null}Y(d,w){const b=d.findIndex(M=>M._id===w);return b===-1?null:b}getEnvironmentVariableCollection(d){let w=this.n.get(d.identifier.value);return w||(w=new $,this.$(d.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(d,w){const b=(0,D.$Xr)(w.map),M=(0,D.$Yr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(d,w.persistent,b.length===0?void 0:b,M)}$initEnvironmentVariableCollections(d){d.forEach(w=>{const b=w[0],M=new $(w[1]);this.$(b,M)})}$acceptDefaultProfile(d,w){const b=this.s;this.s=d,this.u=w,b?.path!==d.path&&this.N.fire(d.path)}$(d,w){this.n.set(d,w),w.onDidChangeCollection(()=>{this.Z(d,w)})}};e.$hic=i,e.$hic=i=Xe([qe(1,n.$zO),qe(2,R.$dO)],i);class ${get persistent(){return this.b}set persistent(d){this.b=d,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(d){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$5d,this.map=new Map(d)}getScopedEnvironmentVariableCollection(d){const w=this.h(d);let b=this.a.get(w);return b||(b=new a(this,d),this.a.set(w,b),b.onDidChangeCollection(()=>this.d.fire())),b}replace(d,w,b,M){this.f(d,{value:w,type:f.EnvironmentVariableMutatorType.Replace,options:b??{applyAtProcessCreation:!0},scope:M})}append(d,w,b,M){this.f(d,{value:w,type:f.EnvironmentVariableMutatorType.Append,options:b??{applyAtProcessCreation:!0},scope:M})}prepend(d,w,b,M){this.f(d,{value:w,type:f.EnvironmentVariableMutatorType.Prepend,options:b??{applyAtProcessCreation:!0},scope:M})}f(d,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const b=this.g(d,w.scope),M=this.map.get(b),T=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!M||M.value!==w.value||M.type!==w.type||M.options?.applyAtProcessCreation!==T.applyAtProcessCreation||M.options?.applyAtShellIntegration!==T.applyAtShellIntegration||M.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const G=this.g(d,w.scope),W={variable:d,...w,options:T};this.map.set(G,W),this.d.fire()}}get(d,w){const b=this.g(d,w),M=this.map.get(b);return M?m(M):void 0}g(d,w){const b=this.h(w);return b.length?`${d}:::${b}`:d}h(d){return this.j(d?.workspaceFolder)??""}j(d){return d?d.uri.toString():void 0}getVariableMap(d){const w=new Map;for(const[b,M]of this.map)this.h(M.scope)===this.h(d)&&w.set(M.variable,m(M));return w}delete(d,w){const b=this.g(d,w);this.map.delete(b),this.d.fire()}clear(d){if(d?.workspaceFolder){for(const[w,b]of this.map)b.scope?.workspaceFolder?.index===d.workspaceFolder.index&&this.map.delete(w);this.k(d)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(d,w){const b=this.h(w),M=this.descriptionMap.get(b);if(!M||M.description!==d){let T;typeof d=="string"?T=d:T=d?.value.split(`

`)[0];const G={description:T,scope:w};this.descriptionMap.set(b,G),this.d.fire()}}getDescription(d){const w=this.h(d);return this.descriptionMap.get(w)?.description}k(d){const w=this.h(d);this.descriptionMap.delete(w)}}class a{get persistent(){return this.b.persistent}set persistent(d){this.b.persistent=d}get onDidChangeCollection(){return this.a&&this.a.event}constructor(d,w){this.b=d,this.d=w,this.a=new S.$5d}getScoped(d){return this.b.getScopedEnvironmentVariableCollection(d)}replace(d,w,b){this.b.replace(d,w,b,this.d)}append(d,w,b){this.b.append(d,w,b,this.d)}prepend(d,w,b){this.b.prepend(d,w,b,this.d)}get(d){return this.b.get(d,this.d)}forEach(d,w){this.b.getVariableMap(this.d).forEach((b,M)=>d.call(w,M,b,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(d){this.b.delete(d,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(d){this.b.setDescription(d,this.d)}get description(){return this.b.getDescription(this.d)}}let c=class extends i{constructor(d,w){super(!1,d,w)}createTerminal(d,w,b){throw new A.$_}createTerminalFromOptions(d,w){throw new A.$_}};e.$iic=c,e.$iic=c=Xe([qe(0,n.$zO),qe(1,R.$dO)],c);function E(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function y(I){return s.ThemeColor.isThemeColor(I)?I:void 0}function m(I){const d={...I};return delete d.scope,d.options=d.options??void 0,delete d.variable,d}}),define(Ae[275],Me([1,0,11,24,21,5,246,97,6,26,16,33,14,3,17,111,8,7,49,75,59,23]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=e.$njc=e.$mjc=e.$ljc=void 0;let i=class extends f.$Tc{constructor(U,C,O,V){super(),this.w=V,this.f=this.B(new F.$5d),this.g=new Map,this.s=this.B(new F.$5d),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(v.$XL.MainThreadTesting),this.m=new b(this.h),this.j=new E(this.h,C),O.registerArgumentProcessor({processArgument:re=>{switch(re?.$mid){case 16:{const ce=re,ye=ce.tests[ce.tests.length-1].item.extId;return this.g.get(n.$OK.root(ye))?.collection.tree.get(ye)?.actual??(0,s.$pO)(re)}case 18:{const{extId:ce,message:ye}=re;return{test:this.g.get(n.$OK.root(ce))?.collection.tree.get(ce)?.actual,message:o.TestMessage.to(ye)}}default:return re}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const re=await O.executeCommand("_testing.getExplorerSelection"),ce=ye=>{const De=this.g.get(n.$OK.root(ye));if(De)return n.$OK.isRoot(ye)?De.controller:De.collection.tree.get(ye)?.actual};return{include:re?.include.map(ce).filter(A.$1f)||[],exclude:re?.exclude.map(ce).filter(A.$1f)||[]}})}createTestController(U,C,O,V){if(this.g.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const re=new f.$Sc,ce=re.add(new s.$sO(C,O,this.w));ce.root.label=O;const ye=new Map,De=new Set,he=this.h,ve={items:ce.root.children,get label(){return O},set label($e){O=$e,ce.root.label=$e,he.$updateController(C,{label:O})},get refreshHandler(){return V},set refreshHandler($e){V=$e,he.$updateController(C,{canRefresh:!!$e})},get id(){return C},createRunProfile:($e,ee,Y,q,ne,Se)=>{let Te=(0,g.$5i)($e);for(;ye.has(Te);)Te++;return new T(this.h,ye,De,this.s.event,C,Te,$e,ee,Y,q,ne,Se)},createTestItem($e,ee,Y){return new s.$qO(C,$e,ee,Y)},createTestRun:($e,ee,Y=!0)=>this.j.createTestRun(U,C,ce,$e,ee,Y),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const ee=$e instanceof Array?$e:[$e];this.h.$markTestRetired(ee.map(Y=>n.$OK.fromExtHostTestItem(Y,C).toString()))}},set resolveHandler($e){ce.resolveHandler=$e},get resolveHandler(){return ce.resolveHandler},dispose:()=>{re.dispose()}};he.$registerTestController(C,O,!!V),re.add((0,f.$Rc)(()=>he.$unregisterTestController(C)));const se={controller:ve,collection:ce,profiles:ye,extension:U,activeProfiles:De};return this.g.set(C,se),re.add((0,f.$Rc)(()=>this.g.delete(C))),re.add(ce.onDidGenerateDiff($e=>he.$publishDiff(C,$e.map(u.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(U,C=P.CancellationToken.None){const O=y(U);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.g.get(O.controllerId);if(!V)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(re=>n.$OK.fromExtHostTestItem(re,V.collection.root.id).toString())??[V.collection.root.id],profileGroup:G[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:U.exclude?.map(re=>re.id)},C)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,C,O){return await this.j.getCoverageReport(U,C)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(U,C,O,V){return await this.j.getCoverageReport(U,C)?.resolveFileCoverage(O,V)??[]}$configureRunProfile(U,C){this.g.get(U)?.profiles.get(C)?.configureHandler?.()}$setDefaultRunProfiles(U){const C=new Map;for(const[O,V]of Object.entries(U)){const re=this.g.get(O);if(!re)continue;const ce=new Map,ye=V.filter(he=>!re.activeProfiles.has(he)),De=[...re.activeProfiles].filter(he=>!V.includes(he));for(const he of ye)ce.set(he,!0),re.activeProfiles.add(he);for(const he of De)ce.set(he,!1),re.activeProfiles.delete(he);ce.size&&C.set(O,ce)}this.s.fire(C)}async $refreshTests(U,C){await this.g.get(U)?.controller.refreshHandler?.(C)}$publishTestResults(U){this.results=Object.freeze(U.map(C=>(0,k.$In)(o.TestResults.to(C))).concat(this.results).sort((C,O)=>O.completedAt-C.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,C){const O=this.g.get(n.$OK.fromString(U).controllerId)?.collection;O&&(await O.expand(U,C<0?1/0:C),O.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(C=>u.TestsDiffOp.deserialize({asCanonicalUri:O=>O},C)))}async $runControllerTests(U,C){return Promise.all(U.map(O=>this.y(O,!1,C)))}async $startContinuousRun(U,C){const O=new P.$ce(C),V=await Promise.all(U.map(re=>this.y(re,!0,O.token)));return!C.isCancellationRequested&&!V.some(re=>re.error)&&await new Promise(re=>C.onCancellationRequested(re)),O.dispose(!0),V}async y(U,C,O){const V=this.g.get(U.controllerId);if(!V)return{};const{collection:re,profiles:ce,extension:ye}=V,De=ce.get(U.profileId);if(!De)return{};const he=U.testIds.map(ee=>re.tree.get(ee)).filter(A.$1f),ve=U.excludeExtIds.map(ee=>V.collection.tree.get(ee)).filter(A.$1f).filter(ee=>he.some(Y=>Y.fullId.compare(ee.fullId)===2));if(!he.length)return{};const se=new t.$yN(he.some(ee=>ee.actual instanceof s.$rO)?void 0:he.map(ee=>ee.actual),ve.map(ee=>ee.actual),De,C),$e=(0,u.$QK)(U)&&this.j.prepareForMainThreadTestRun(se,m.fromInternal(U,V.collection),ye,O);try{return await De.runHandler(se,O),{}}catch(ee){return{error:String(ee)}}finally{$e&&($e.hasRunningTasks&&!O.isCancellationRequested&&await F.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$ljc=i,e.$ljc=i=Xe([qe(0,p.$dO),qe(1,h.$yj)],i);const $=1e4;var a;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(a||(a={}));class c extends f.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,C,O,V,re){super(),this.s=U,this.w=C,this.y=O,this.z=V,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new F.$5d),this.m=this.B(new F.$5d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new P.$ce(re));const ce=this.B(new S.$qh(()=>this.C(),$));this.B(this.h.token.onCancellationRequested(()=>ce.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const C=this.s.id,O=this.s.controllerId,V=(0,D.$Ag)(),re=this.y,ce=this.m;let ye;const De=$e=>(ee,...Y)=>{if(ve){this.z.warn(`Setting the state of test "${ee.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ee)&&(this.F(ee),$e(ee,...Y))},he=($e,ee)=>{const Y=ee instanceof Array?ee.map(o.TestMessage.from):[o.TestMessage.from(ee)];if($e.uri&&$e.range){const q={range:o.Range.from($e.range),uri:$e.uri};for(const ne of Y)ne.location=ne.location||q}this.w.$appendTestMessagesInRun(C,V,n.$OK.fromExtHostTestItem($e,O).toString(),Y)};let ve=!1;const se={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return ye?.provider},set coverageProvider($e){(0,l.$VF)(re,"testCoverage"),ye=$e&&new I($e),ce.fire({taskId:V,runId:C,coverage:ye})},enqueued:De($e=>{this.w.$updateTestStateInRun(C,V,n.$OK.fromExtHostTestItem($e,O).toString(),1)}),skipped:De($e=>{this.w.$updateTestStateInRun(C,V,n.$OK.fromExtHostTestItem($e,O).toString(),5)}),started:De($e=>{this.w.$updateTestStateInRun(C,V,n.$OK.fromExtHostTestItem($e,O).toString(),2)}),errored:De(($e,ee,Y)=>{he($e,ee),this.w.$updateTestStateInRun(C,V,n.$OK.fromExtHostTestItem($e,O).toString(),6,Y)}),failed:De(($e,ee,Y)=>{he($e,ee),this.w.$updateTestStateInRun(C,V,n.$OK.fromExtHostTestItem($e,O).toString(),4,Y)}),passed:De(($e,ee)=>{this.w.$updateTestStateInRun(C,V,n.$OK.fromExtHostTestItem($e,this.s.controllerId).toString(),3,ee)}),appendOutput:($e,ee,Y)=>{ve||(Y&&(this.s.isIncluded(Y)?this.F(Y):Y=void 0),this.w.$appendOutputToRun(C,V,L.$se.fromString($e),ee&&o.location.from(ee),Y&&n.$OK.fromExtHostTestItem(Y,O).toString()))},end:()=>{ve||(ve=!0,this.w.$finishedTestRunTask(C,V),this.f.delete(V),this.f.size||this.D())}};return this.f.set(V,{run:se}),this.w.$startedTestRunTask(C,{id:V,name:U,running:!0}),se}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof s.$qO))throw new r.$8N(U.id);if(this.g.has(n.$OK.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const C=[],O=this.s.colllection.root;for(;;){const V=o.TestItem.from(U);if(C.unshift(V),this.g.has(V.extId)||(this.g.add(V.extId),U===O))break;U=U.parent||O}this.w.$addTestsToRun(this.s.controllerId,this.s.id,C)}dispose(){this.D(),super.dispose()}}class E{get trackers(){return this.c.values()}constructor(U,C){this.g=U,this.h=C,this.c=new Map,this.f=[]}getCoverageReport(U,C){return this.f.find(O=>O.runId===U)?.coverage.get(C)}prepareForMainThreadTestRun(U,C,O,V){return this.j(U,C,O,V)}cancelRunById(U){for(const C of this.c.values())if(C.id===U){C.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,C,O,V,re,ce){const ye=this.c.get(V);if(ye)return ye.createRun(re);const De=m.fromPublic(C,O,V,ce),he=y(V);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!V.continuous,profile:he&&{group:G[he.kind],id:he.profileId},exclude:V.exclude?.map(se=>n.$OK.fromExtHostTestItem(se,O.root.id).toString())??[],id:De.id,include:V.include?.map(se=>n.$OK.fromExtHostTestItem(se,O.root.id).toString())??[O.root.id],persist:ce});const ve=this.j(V,De,U);return F.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(De.id),ve.dispose()}),ve.createRun(re)}j(U,C,O,V){const re=new c(C,this.g,O,this.h,V);this.c.set(U,re);let ce;const ye=re.onDidCoverage(({runId:De,taskId:he,coverage:ve})=>{ce||(ce={runId:De,coverage:new Map},this.f.unshift(ce),this.f.length>u.$VK&&this.f.pop()),ce.coverage.set(he,ve),this.g.$signalCoverageAvailable(De,he,!!ve)});return F.Event.once(re.onEnd)(()=>{this.c.delete(U),ye.dispose()}),re}}e.$mjc=E;const y=W=>{if(W.profile){if(!(W.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class m{static fromPublic(U,C,O,V){return new m(U,(0,D.$Ag)(),O.include?.map(re=>n.$OK.fromExtHostTestItem(re,U).toString())??[U],O.exclude?.map(re=>n.$OK.fromExtHostTestItem(re,U).toString())??[],V,C)}static fromInternal(U,C){return new m(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,C)}constructor(U,C,O,V,re,ce){this.controllerId=U,this.id=C,this.isPersisted=re,this.colllection=ce,this.c=O.map(ye=>ye+"\0"),this.f=V.map(ye=>ye+"\0")}isIncluded(U){const C=n.$OK.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const O of this.f)if(C===O||C.startsWith(O))return!1;for(const O of this.c)if(C===O||C.startsWith(O))return!0;return!1}}e.$njc=m;class I{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(o.TestCoverage.fromFile)??[]}catch(C){throw this.c=void 0,C}}async resolveFileCoverage(U,C){const O=await this.c;let V=O?.[U];return!this.provider||!O||!V?[]:(V.detailedCoverage||(V=O[U]=await this.provider.resolveFileCoverage?.(V,C)??V),V.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class d{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,o.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const C=n.$OK.parentId(U.item.extId);if(C&&this.h.has(C.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:C,g:O}=this;return{get added(){return[...U].map(V=>V.revived)},get updated(){return[...C].map(V=>V.revived)},get removed(){return[...O].map(V=>V.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends u.$WK{constructor(){super(...arguments),this.s=new F.$5d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,C){return{...U,revived:o.TestItem.toPlain(U.item),depth:C?C.depth+1:0,children:new Set}}v(){return new d(this.s)}}class b{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(C=>C.revived)},dispose:(0,R.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new w({asCanonicalUri:C=>C});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const M=(W,U,C,O)=>{C?Object.assign(C,O):U.$updateTestRunConfig(W.controllerId,W.profileId,O)};class T{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,M(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,M(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),M(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,M(this,this.#e,this.#n,{tag:U?o.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,M(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return F.Event.chain(this.#i,U=>U.map(C=>C.get(this.controllerId)?.get(this.profileId)).filter(A.$1f))}constructor(U,C,O,V,re,ce,ye,De,he,ve=!1,se=void 0,$e=!1){this.controllerId=re,this.profileId=ce,this.f=ye,this.kind=De,this.runHandler=he,this._tag=se,this.g=$e,this.#e=U,this.#s=C,this.#t=O,this.#i=V,C.set(ce,this);const ee=G[De];if(typeof ee!="number")throw new Error(`Unknown TestRunProfile.group ${De}`);ve&&O.add(ce),this.#n={profileId:ce,controllerId:re,tag:se?o.TestTag.namespace(this.controllerId,se.id):null,label:ye,group:ee,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:$e},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$ojc=T;const G={[t.TestRunProfileKind.Coverage]:8,[t.TestRunProfileKind.Debug]:4,[t.TestRunProfileKind.Run]:2}}),define(Ae[112],Me([1,0,54,15,88,8,7]),function(fe,e,S,L,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mO=e.$lO=e.$kO=void 0;class g{static{this.c=new P.$iO("TextEditorDecorationType")}constructor(h,v,p){const s=g.c.nextId();h.$registerTextEditorDecorationType(v.identifier,s,F.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:s,dispose(){h.$removeTextEditorDecorationType(s)}})}}e.$kO=g;class f{constructor(h,v){this.g=[],this.h=void 0,this.j=!1,this.c=h,this.d=h.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(h,v){this.k();let p=null;if(h instanceof R.$1L)p=new R.$2L(h,h);else if(h instanceof R.$2L)p=h;else throw new Error("Unrecognized location");this.l(p,v,!1)}insert(h,v){this.k(),this.l(new R.$2L(h,h),v,!0)}delete(h){this.k();let v=null;if(h instanceof R.$2L)v=h;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(h,v,p){const s=this.c.validateRange(h);this.g.push({range:s,text:v,forceMoveMarkers:p})}setEndOfLine(h){if(this.k(),h!==R.EndOfLine.LF&&h!==R.EndOfLine.CRLF)throw(0,L.$7)("endOfLine");this.h=h}}class k{constructor(h,v,p,s){this.c=h,this.d=v,this._accept(p),this.e=s;const o=this;this.value={get tabSize(){return o.f},set tabSize(t){o.n(t)},get indentSize(){return o.g},set indentSize(t){o.p(t)},get insertSpaces(){return o.j},set insertSpaces(t){o.s(t)},get cursorStyle(){return o.k},set cursorStyle(t){o.t(t)},get lineNumbers(){return o.l},set lineNumbers(t){o.u(t)}}}_accept(h){this.f=h.tabSize,this.g=h.indentSize,this.h=h.originalIndentSize,this.j=h.insertSpaces,this.k=h.cursorStyle,this.l=F.TextEditorLineNumbersStyle.to(h.lineNumbers)}m(h){if(h==="auto")return"auto";if(typeof h=="number"){const v=Math.floor(h);return v>0?v:null}if(typeof h=="string"){const v=parseInt(h,10);return isNaN(v)?null:v>0?v:null}return null}n(h){const v=this.m(h);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const v=Math.floor(h);return v>0?v:null}if(typeof h=="string"){const v=parseInt(h,10);return isNaN(v)?null:v>0?v:null}return null}p(h){const v=this.o(h);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(h){return h==="auto"?"auto":h==="false"?!1:!!h}s(h){const v=this.q(h);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(h){this.k!==h&&(this.k=h,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:h})))}u(h){this.l!==h&&(this.l=h,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(h)})))}assign(h){const v={};let p=!1;if(typeof h.tabSize<"u"){const s=this.m(h.tabSize);s==="auto"?(p=!0,v.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,p=!0,v.tabSize=s)}if(typeof h.indentSize<"u"){const s=this.o(h.indentSize);s==="tabSize"?(p=!0,v.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,p=!0,v.indentSize=s)}if(typeof h.insertSpaces<"u"){const s=this.q(h.insertSpaces);s==="auto"?(p=!0,v.insertSpaces=s):this.j!==s&&(this.j=s,p=!0,v.insertSpaces=s)}typeof h.cursorStyle<"u"&&this.k!==h.cursorStyle&&(this.k=h.cursorStyle,p=!0,v.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this.l!==h.lineNumbers&&(this.l=h.lineNumbers,p=!0,v.lineNumbers=F.TextEditorLineNumbersStyle.from(h.lineNumbers)),p&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(h,v){v.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this.e.warn(p)})}}e.$lO=k;class A{constructor(h,v,p,s,o,t,n,r){this.id=h,this.j=v,this.k=p,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,t,p),this.e=n,this.f=r;const u=this;this.value=Object.freeze({get document(){return s.value},set document(l){throw new L.$9("document")},get selection(){return u.c&&u.c[0]},set selection(l){if(!(l instanceof R.$3L))throw(0,L.$7)("selection");u.c=[l],u.l()},get selections(){return u.c},set selections(l){if(!Array.isArray(l)||l.some(i=>!(i instanceof R.$3L)))throw(0,L.$7)("selections");u.c=l,u.l()},get visibleRanges(){return u.e},set visibleRanges(l){throw new L.$9("visibleRanges")},get options(){return u.d.value},set options(l){u.g||u.d.assign(l)},get viewColumn(){return u.f},set viewColumn(l){throw new L.$9("viewColumn")},edit(l,i={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const $=new f(s.value,i);return l($),u.m($)},insertSnippet(l,i,$={undoStopBefore:!0,undoStopAfter:!0}){if(u.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=u.c.map(c=>F.Range.from(c));else if(i instanceof R.$1L){const{lineNumber:c,column:E}=F.Position.from(i);a=[{startLineNumber:c,startColumn:E,endLineNumber:c,endColumn:E}]}else if(i instanceof R.$2L)a=[F.Range.from(i)];else{a=[];for(const c of i)if(c instanceof R.$2L)a.push(F.Range.from(c));else{const{lineNumber:E,column:y}=F.Position.from(c);a.push({startLineNumber:E,startColumn:y,endLineNumber:E,endColumn:y})}}return v.$tryInsertSnippet(h,s.value.version,l.value,a,$)},setDecorations(l,i){const $=i.length===0;$&&!u.h.has(l.key)||($?u.h.delete(l.key):u.h.add(l.key),u.n(()=>{if(F.$aO(i))return v.$trySetDecorations(h,l.key,F.$bO(i));{const a=new Array(4*i.length);for(let c=0,E=i.length;c<E;c++){const y=i[c];a[4*c]=y.start.line+1,a[4*c+1]=y.start.character+1,a[4*c+2]=y.end.line+1,a[4*c+3]=y.end.character+1}return v.$trySetDecorationsFast(h,l.key,a)}}))},revealRange(l,i){u.n(()=>v.$tryRevealRange(h,F.Range.from(l),i||R.TextEditorRevealType.Default))},show(l){v.$tryShowEditor(h,F.ViewColumn.from(l))},hide(){v.$tryHideEditor(h)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(h){(0,S.ok)(!this.g),this.d._accept(h)}_acceptVisibleRanges(h){(0,S.ok)(!this.g),this.e=h}_acceptViewColumn(h){(0,S.ok)(!this.g),this.f=h}_acceptSelections(h){(0,S.ok)(!this.g),this.c=h}async l(){const h=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,h)),this.value}m(h){const v=h.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const p=v.edits.map(o=>o.range);p.sort((o,t)=>o.end.line===t.end.line?o.end.character===t.end.character?o.start.line===t.start.line?o.start.character-t.start.character:o.start.line-t.start.line:o.end.character-t.end.character:o.end.line-t.end.line);for(let o=0,t=p.length-1;o<t;o++){const n=p[o].end;if(p[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=v.edits.map(o=>({range:F.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,s,{setEndOfLine:typeof v.setEndOfLine=="number"?F.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(h){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$mO=A}),define(Ae[66],Me([1,0,54,5,6,2,4,3,109,17,112,8,14,28,12,68,39]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oO=e.$nO=void 0;class t{constructor(u){this.value=u,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(u,l){this.h=u,this.i=l,this.a=null,this.b=new Map,this.c=new v.$Ac,this.d=new L.$5d,this.e=new L.$5d,this.f=new L.$5d,this.g=new L.$5d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const l=[],i=[],$=[];if(u.removedDocuments)for(const a of u.removedDocuments){const c=F.URI.revive(a),E=this.c.get(c);E?.unref()&&(this.c.delete(c),l.push(E.value))}if(u.addedDocuments)for(const a of u.addedDocuments){const c=F.URI.revive(a.uri);let E=this.c.get(c);if(E&&c.scheme!==p.Schemas.vscodeNotebookCell&&c.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);E||(E=new t(new f.$gO(this.h.getProxy(g.$XL.MainThreadDocuments),c,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(c,E),i.push(E.value)),E.ref()}if(u.removedEditors)for(const a of u.removedEditors){const c=this.b.get(a);this.b.delete(a),c&&$.push(c)}if(u.addedEditors)for(const a of u.addedEditors){const c=F.URI.revive(a.documentUri);S.ok(this.c.has(c),`document '${c}' does not exist`),S.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const E=this.c.get(c).value,y=new A.$mO(a.id,this.h.getProxy(g.$XL.MainThreadTextEditors),this.i,new o.$V(()=>E.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(m=>D.Range.to(m)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,y)}u.newActiveEditor!==void 0&&(S.ok(u.newActiveEditor===null||this.b.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this.a=u.newActiveEditor),(0,P.$Oc)(l),(0,P.$Oc)($),u.removedDocuments&&this.e.fire(l),u.addedDocuments&&this.d.fire(i),(u.removedEditors||u.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),u.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(u){return this.c.get(u)?.value}allDocuments(){return s.Iterable.map(this.c.values(),u=>u.value)}getEditor(u){return this.b.get(u)}activeEditor(u){if(!this.a)return;const l=this.b.get(this.a);return u?l:l?.value}allEditors(){return[...this.b.values()]}};e.$nO=n,e.$nO=n=Xe([qe(0,k.$dO),qe(1,h.$yj)],n),e.$oO=(0,R.$ei)("IExtHostDocumentsAndEditors")}),define(Ae[276],Me([1,0,18,5,3,112,8,7]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;class f{constructor(A,D){this.i=D,this.a=new L.$5d,this.b=new L.$5d,this.c=new L.$5d,this.d=new L.$5d,this.f=new L.$5d,this.g=new L.$5d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(P.$XL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(h=>this.g.fire(h)),this.i.onDidChangeActiveTextEditor(h=>this.f.fire(h))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const D=this.i.allEditors();return A?D:D.map(h=>h.value)}async showTextDocument(A,D,h){let v;typeof D=="number"?v={position:R.ViewColumn.from(D),preserveFocus:h}:typeof D=="object"?v={position:R.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?R.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:v={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(A.uri,v),s=p&&this.i.getEditor(p);if(s)return s.value;throw p?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,D){return new F.$kO(this.h,A,D).value}$acceptEditorPropertiesChanged(A,D){const h=this.i.getEditor(A);if(!h)throw new Error("unknown text editor");if(D.options&&h._acceptOptions(D.options),D.selections){const v=D.selections.selections.map(R.Selection.to);h._acceptSelections(v)}if(D.visibleRanges){const v=S.$Hb(D.visibleRanges.map(R.Range.to));h._acceptVisibleRanges(v)}if(D.options&&this.b.fire({textEditor:h.value,options:{...D.options,lineNumbers:R.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const v=g.TextEditorSelectionChangeKind.fromValue(D.selections.source),p=D.selections.selections.map(R.Selection.to);this.a.fire({textEditor:h.value,selections:p,kind:v})}if(D.visibleRanges){const v=S.$Hb(D.visibleRanges.map(R.Range.to));this.c.fire({textEditor:h.value,visibleRanges:v})}}$acceptEditorPositionData(A){for(const D in A){const h=this.i.getEditor(D);if(!h)throw new Error("Unknown text editor");const v=R.ViewColumn.to(A[D]);h.value.viewColumn!==v&&(h._acceptViewColumn(v),this.d.fire({textEditor:h.value,viewColumn:v}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$Khc=f}),define(Ae[277],Me([1,0,2,4,3,6,7,8,22,16]),function(fe,e,S,L,P,F,R,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=e.$qjc=void 0,e.$qjc=(0,L.$ei)("IExtHostTimeline");class A{constructor(v,p){this.b=new Map,this.c=new Map,this.a=v.getProxy(P.$XL.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&f.$wm.equals(o,this.b.get(s.source)?.extension)){const t=s.uri===void 0?void 0:S.URI.revive(s.uri);return this.c.get(s.source)?.get(D(t))?.get(s.handle)}else return;return s}})}async $getTimeline(v,p,s,o){return this.b.get(v)?.provider.provideTimeline(S.URI.revive(p),s,o)}registerTimelineProvider(v,p,s,o){const t=new F.$Sc,n=this.d(p.id,o,t).bind(this);let r;p.onDidChange&&(r=p.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:p.id}),this));const u=this.c;return this.f({...p,scheme:v,onDidChange:void 0,async provideTimeline(l,i,$){i?.resetCache&&(t.clear(),u.get(p.id)?.clear());const a=await p.provideTimeline(l,i,$);if(a==null)return;const c=n(l,i);return{...a,source:p.id,items:a.items.map(c)}},dispose(){for(const l of u.values())l.get(p.id)?.clear();r?.dispose(),t.dispose()}},s)}d(v,p,s){return(o,t)=>{let n;if(t?.cacheResults){let r=this.c.get(v);r===void 0&&(r=new Map,this.c.set(v,r));const u=D(o);n=r.get(u),n===void 0&&(n=new Map,r.set(u,n))}return r=>{const{iconPath:u,...l}=r,i=`${v}|${r.id??r.timestamp}`;n?.set(i,r);let $,a,c;r.iconPath&&(u instanceof R.$UM?c={id:u.id,color:u.color}:S.URI.isUri(u)?($=u,a=u):{light:$,dark:a}=u);let E;return R.$oM.isMarkdownString(l.tooltip)?E=g.MarkdownString.from(l.tooltip):(0,k.$Sf)(l.tooltip)?E=l.tooltip:R.$oM.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=g.MarkdownString.from(l.detail)):(0,k.$Sf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=l.detail),{...l,id:l.id??void 0,handle:i,source:v,command:r.command?p.toInternal(r.command,s):void 0,icon:$,iconDark:a,themeIcon:c,tooltip:E,accessibilityInformation:r.accessibilityInformation}}}}f(v,p){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:p}),(0,F.$Rc)(()=>{for(const o of this.c.values())o.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$rjc=A;function D(h){return h?.toString()}}),define(Ae[278],Me([1,0,168,25,2,5,6,206,11,7,16,18,8,46,21,133,23]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=void 0;function t(u,l){if((0,A.$Sf)(u))return{label:u};if(u&&typeof u=="object"&&typeof u.label=="string"){let i;return Array.isArray(u.highlights)&&(i=u.highlights.filter($=>$.length===2&&typeof $[0]=="number"&&typeof $[1]=="number"),i=i.length?i:void 0),{label:u.label,highlights:i}}}class n extends R.$Tc{constructor(l,i,$){super(),this.f=l,this.g=i,this.h=$,this.a=new Map,this.b=new s.$A9;function a(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:c=>a(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(E=>a(E)?this.r(E):E):c})}registerTreeDataProvider(l,i,$){const a=this.createTreeView(l,{treeDataProvider:i},$);return{dispose:()=>a.dispose()}}createTreeView(l,i,$){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=i.dragAndDropController?.dropMimeTypes??[],c=i.dragAndDropController?.dragMimeTypes??[],E=!!i.dragAndDropController?.handleDrag,y=!!i.dragAndDropController?.handleDrop,m=this.m(l,i,$),I={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:a,dragMimeTypes:c,hasHandleDrag:E,hasHandleDrop:y,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},d=this.f.$registerTreeViewDataProvider(l,I),w={get onDidCollapseElement(){return m.onDidCollapseElement},get onDidExpandElement(){return m.onDidExpandElement},get selection(){return m.selectedElements},get onDidChangeSelection(){return m.onDidChangeSelection},get activeItem(){return(0,o.$VF)($,"treeViewActiveItem"),m.focusedElement},get onDidChangeActiveItem(){return(0,o.$VF)($,"treeViewActiveItem"),m.onDidChangeActiveItem},get visible(){return m.visible},get onDidChangeVisibility(){return m.onDidChangeVisibility},get onDidChangeCheckboxState(){return m.onDidChangeCheckboxState},get message(){return m.message},set message(b){(0,v.$uk)(b)&&(0,o.$VF)($,"treeViewMarkdownMessage"),m.message=b},get title(){return m.title},set title(b){m.title=b},get description(){return m.description},set description(b){m.description=b},get badge(){return m.badge},set badge(b){b!==void 0&&k.ViewBadge.isViewBadge(b)?m.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(m.badge=void 0)},reveal:(b,M)=>m.reveal(b,M),dispose:async()=>{await d,this.a.delete(l),m.dispose()}};return this.B(w),w}$getChildren(l,i){const $=this.a.get(l);return $?$.getChildren(i):Promise.reject(new g.$oF(l))}async $handleDrop(l,i,$,a,c,E,y,m){const I=this.a.get(l);if(!I)return Promise.reject(new g.$oF(l));const d=h.DataTransfer.toDataTransfer($,async w=>(await this.f.$resolveDropFileData(l,i,w)).buffer);return y===l&&m&&await this.j(d,I,m,c,E),I.onDrop(d,a,c)}async j(l,i,$,a,c){const E=this.b.removeDragOperationTransfer(c);if(E)(await E)?.forEach((y,m)=>{y&&l.set(m,y)});else if(c&&i.handleDrag){const y=i.handleDrag($,l,a);this.b.addDragOperationTransfer(c,y),await y}return l}async $handleDrag(l,i,$,a){const c=this.a.get(l);if(!c)return Promise.reject(new g.$oF(l));const E=await this.j(new k.$RM,c,i,a,$);if(!(!E||a.isCancellationRequested))return h.DataTransfer.from(E)}async $hasResolve(l){const i=this.a.get(l);if(!i)throw new g.$oF(l);return i.hasResolve}$resolve(l,i,$){const a=this.a.get(l);if(!a)throw new g.$oF(l);return a.resolveTreeItem(i,$)}$setExpanded(l,i,$){const a=this.a.get(l);if(!a)throw new g.$oF(l);a.setExpanded(i,$)}$setSelectionAndFocus(l,i,$){const a=this.a.get(l);if(!a)throw new g.$oF(l);a.setSelectionAndFocus(i,$)}$setVisible(l,i){const $=this.a.get(l);if(!$){if(!i)return;throw new g.$oF(l)}$.setVisible(i)}$changeCheckboxState(l,i){const $=this.a.get(l);if(!$)throw new g.$oF(l);$.setCheckboxState(i)}m(l,i,$){const a=this.B(new r(l,i,this.f,this.g.converter,this.h,$));return this.a.set(l,a),a}r(l){const i=this.a.get(l.$treeViewId);return i&&"$treeItemHandle"in l?i.getExtensionElement(l.$treeItemHandle):i&&"$focusedTreeItem"in l&&l.$focusedTreeItem?i.focusedElement:null}}e.$sjc=n;class r extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,A.$2f)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,i,$,a,c,E){if(super(),this.I=l,this.J=$,this.L=a,this.M=c,this.N=E,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$5d),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$5d),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$5d),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$5d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$5d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$5d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$5d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$ce,E.contributes&&E.contributes.views)for(const d in E.contributes.views)for(const w of E.contributes.views[d])w.id===l&&(this.P=w.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(d=>this.F.fire({message:!1,element:d})));let y,m;const I=F.Event.debounce(this.F.event,(d,w)=>(d||(d={message:!1,elements:[]}),w.element!==!1&&(y||(y=new Promise(b=>m=b),this.G=this.G.then(()=>y)),Array.isArray(w.element)?d.elements.push(...w.element):d.elements.push(w.element)),w.message&&(d.message=!0),d),200,!0);this.B(I(({message:d,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const b=m;return y=null,this.$(w).then(()=>b())})),d&&this.J.$setMessage(this.I,h.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const i=l?this.getExtensionElement(l):void 0;if(l&&!i)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let $=this.X(l);return $||($=await this.Y(i)),$?$.map(a=>a.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,i){i=i||{select:!0,focus:!1};const $=(0,A.$2f)(i.select)?!0:i.select,a=(0,A.$2f)(i.focus)?!1:i.focus,c=(0,A.$2f)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(E=>this.W(l,E[E.length-1]).then(y=>this.J.$reveal(this.I,{item:y.item,parentChain:E.map(m=>m.item)},{select:$,focus:a,expand:c})),E=>this.M.error(E)):this.J.$reveal(this.I,void 0,{select:$,focus:a,expand:c})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=h.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,i){const $=this.getExtensionElement(l);$&&(i?this.u.fire(Object.freeze({element:$})):this.w.fire(Object.freeze({element:$})))}setSelectionAndFocus(l,i){const $=!(0,D.$ub)(this.s,l);this.s=l;const a=this.t!==i;this.t=i,$&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const i=(await Promise.all(l.map(async $=>{const a=this.getExtensionElement($.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:$.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter($=>$!==void 0);i.forEach($=>{$.treeItem.checkboxState=$.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map($=>[$.extensionItem,$.newState])})}async handleDrag(l,i,$){const a=[];for(const c of l){const E=this.getExtensionElement(c);E&&a.push(E)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,i,$),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,i,$){const a=i?this.getExtensionElement(i):void 0;if(!(!a&&i||!this.g?.handleDrop))return(0,f.$9g)(()=>this.g?.handleDrop?this.g.handleDrop(a,l,$):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,i){if(!this.f.resolveTreeItem)return;const $=this.j.get(l);if($){const a=this.m.get($);if(a){const c=await this.f.resolveTreeItem(a.extensionItem,$,i)??a.extensionItem;return this.hb(c),a.item.tooltip=this.eb(c.tooltip),a.item.command=this.fb(a.disposableStore,c.command),a.item}}}S(l){return this.U(l).then(i=>i?this.S(i).then($=>this.W(i,$[$.length-1]).then(a=>($.push(a),$))):Promise.resolve([]))}U(l){const i=this.m.get(l);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,f.$9g)(()=>this.f.getParent(l))}W(l,i){const $=this.m.get(l);return $?Promise.resolve($):(0,f.$9g)(()=>this.f.getTreeItem(l)).then(a=>this.kb(l,a,i,!0)).then(a=>this.getChildren(i?i.item.handle:void 0).then(()=>{const c=this.getExtensionElement(a);if(c){const E=this.m.get(c);if(E)return Promise.resolve(E)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let i;if(typeof l=="string"){const $=this.getExtensionElement(l);i=$?this.m.get($):void 0}else i=l;return i&&i.children||void 0}return this.h}async Y(l){this.rb(l);const i=new p.$ce(this.Z.token);try{const $=l?this.m.get(l):void 0,a=await this.f.getChildren(l);if(i.token.isCancellationRequested)return;const c=(0,D.$Hb)(a||[]),E=await Promise.all((0,D.$Hb)(c).map(m=>this.f.getTreeItem(m)));if(i.token.isCancellationRequested)return;const y=E.map((m,I)=>m?this.db(c[I],m,$):null);return(0,D.$Hb)(y)}finally{i.dispose()}}$(l){if(l.some($=>!$))return this.Z.dispose(!0),this.Z=new p.$ce,this.tb(),this.J.$refresh(this.I);{const $=this.ab(l);if($.length)return this.bb($)}return Promise.resolve(void 0)}ab(l){const i=new Set,$=l.map(c=>this.m.get(c));for(const c of $)if(c&&!i.has(c.item.handle)){let E=c;for(;E&&E.parent&&$.findIndex(y=>E&&E.parent&&y&&y.item.handle===E.parent.item.handle)===-1;){const y=this.j.get(E.parent.item.handle);E=y?this.m.get(y):void 0}E&&!E.parent&&i.add(c.item.handle)}const a=[];return i.forEach(c=>{const E=this.j.get(c);if(E){const y=this.m.get(E);y&&(!y.parent||!i.has(y.parent.item.handle))&&a.push(c)}}),a}bb(l){const i={};return Promise.all(l.map($=>this.cb($).then(a=>{a&&(i[$]=a.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(l){const i=this.getExtensionElement(l);if(i){const $=this.m.get(i);if($)return this.rb(i),(0,f.$9g)(()=>this.f.getTreeItem(i)).then(a=>{if(a){const c=this.ib(i,a,$.parent);return this.pb(i,c,$,$.parent),$.dispose(),c}return null})}return Promise.resolve(null)}db(l,i,$){const a=this.ib(l,i,$);if(i.id&&this.j.has(a.item.handle))throw new Error((0,S.localize)(0,null,i.id));return this.ob(l,a),this.qb(a,$),a}eb(l){return k.$oM.isMarkdownString(l)?h.MarkdownString.from(l):l}fb(l,i){return i?{...this.L.toInternal(i,l),originalId:i.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let i,$,a;return typeof l.checkboxState=="number"?i=l.checkboxState:(i=l.checkboxState.state,$=l.checkboxState.tooltip,a=l.checkboxState.accessibilityInformation),{isChecked:i===k.TreeItemCheckboxState.Checked,tooltip:$,accessibilityInformation:a}}hb(l){if(!k.$MM.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,i,$){this.hb(i);const a=this.B(new R.$Sc),c=this.kb(l,i,$),E=this.lb(i);return{item:{handle:c,parentHandle:$?$.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(a,i.command),contextValue:i.contextValue,icon:E,iconDark:this.mb(i)||E,themeIcon:this.jb(i),collapsibleState:(0,A.$2f)(i.collapsibleState)?k.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:$,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(l){return l.iconPath instanceof k.$UM?l.iconPath:void 0}kb(l,{id:i,label:$,resourceUri:a},c,E){if(i)return`${r.b}/${i}`;const y=t($,this.N),m=c?c.item.handle:r.a;let I=y?y.label:a?(0,L.$Og)(a):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const d=this.m.has(l)?this.m.get(l).item.handle:void 0,w=this.X(c)||[];let b,M=0;do{if(b=`${m}/${M}:${I}`,E||!this.j.has(b)||d===b)break;M++}while(M<=w.length);return b}lb(l){if(l.iconPath&&!(l.iconPath instanceof k.$UM))return typeof l.iconPath=="string"||P.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof k.$UM)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return P.URI.isUri(l)?l:P.URI.file(l)}ob(l,i){this.j.set(i.item.handle,l),this.m.set(l,i)}pb(l,i,$,a){this.j.delete(i.item.handle),this.m.delete(l),i.item.handle!==$.item.handle&&this.j.delete($.item.handle),this.ob(l,i);const c=this.X(a)||[],E=c.filter(y=>y.item.handle===$.item.handle)[0];E&&c.splice(c.indexOf(E),1,i)}qb(l,i){i?(i.children||(i.children=[]),i.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const i=this.m.get(l);if(i){if(i.children)for(const $ of i.children){const a=this.j.get($.item.handle);a&&this.sb(a)}i.children=void 0}}else this.tb()}sb(l){const i=this.m.get(l);if(i){if(i.children)for(const $ of i.children){const a=this.j.get($.item.handle);a&&this.sb(a)}this.m.delete(l),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[279],Me([1,0,5,6,2,33,8,61,3,7]),function(fe,e,S,L,P,F,R,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class A extends L.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(p,s,o,t){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$5d),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$5d),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=s,this.#n=o,this.#i=t.viewType,this.#s=t.panelOptions,this.#o=t.viewColumn,this.#r=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(p){this.c(),this.#r!==p&&(this.#r=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(p){this.#l||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#u=p.active,this.#c=p.visible,this.#o=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:R.ViewColumn.from(p),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends L.$Tc{static c(){return(0,F.$Ag)()}constructor(p,s,o){super(),this.j=s,this.m=o,this.g=new Map,this.h=new Map,this.f=p.getProxy(f.$XL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,s,o,t,n={}){const r=typeof t=="object"?t.viewColumn:t,u={viewColumn:R.ViewColumn.from(r),preserveFocus:typeof t=="object"&&!!t.preserveFocus},l=(0,g.$Zhc)(p),i=D.c();this.f.$createWebviewPanel((0,g.$2hc)(p),i,s,{title:o,panelOptions:h(n),webviewOptions:(0,g.$3hc)(p,this.m,n),serializeBuffersForPostMessage:l},u);const $=this.j.createNewWebview(i,n,p);return this.createNewWebviewPanel(i,s,o,r,n,$,!0)}$onDidChangeWebviewPanelViewStates(p){const s=Object.keys(p);s.sort((o,t)=>{const n=p[o],r=p[t];return n.active?1:r.active?-1:+n.visible-+r.visible});for(const o of s){const t=this.getWebviewPanel(o);if(!t)continue;const n=p[o];t._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,s,o){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:o,extension:p}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,g.$Zhc)(p)}),new k.$ZL(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(p,s,o,t){const n=this.h.get(s);if(!n)throw new Error(`No serializer found for '${s}'`);const{serializer:r,extension:u}=n,l=this.j.createNewWebview(p,o.webviewOptions,u),i=this.createNewWebviewPanel(p,s,o.title,t,o.panelOptions,l,o.active);await r.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(p,s,o,t,n,r,u){const l=new A(p,this.f,r,{viewType:s,title:o,viewColumn:t,panelOptions:n,active:u});return this.g.set(p,l),l}getWebviewPanel(p){return this.g.get(p)}}e.$4hc=D;function h(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ae[280],Me([1,0,5,6,61,8,3,7]),function(fe,e,S,L,P,F,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=void 0;class f extends L.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(D,h,v,p,s,o){super(),this.#s=!1,this.#u=this.B(new S.$5d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$5d),this.onDidDispose=this.#l.event,this.#i=v,this.#a=p,this.#e=D,this.#t=h,this.#n=s,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#o}set description(D){this.a(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=F.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(D,h){this.d=h,this.b=new Map,this.c=new Map,this.a=D.getProxy(R.$XL.MainThreadWebviewViews)}registerWebviewViewProvider(D,h,v,p){if(this.b.has(h))throw new Error(`View provider for '${h}' already registered`);return this.b.set(h,{provider:v,extension:D}),this.a.$registerWebviewViewProvider((0,P.$2hc)(D),h,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$Zhc)(D)}),new g.$ZL(()=>{this.b.delete(h),this.a.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(D,h,v,p,s){const o=this.b.get(h);if(!o)throw new Error(`No view provider found for '${h}'`);const{provider:t,extension:n}=o,r=this.d.createNewWebview(D,{},n),u=new f(D,this.a,h,v,r,!0);this.c.set(D,u),await t.resolveWebviewView(u,{state:p},s)}async $onDidChangeWebviewViewVisibility(D,h){this.e(D)._setVisible(h)}async $disposeWebviewView(D){const h=this.e(D);this.c.delete(D),h.dispose(),this.d.deleteWebview(D)}e(D){const h=this.c.get(D);if(!h)throw new Error("No webview found");return h}}e.$vjc=k}),define(Ae[281],Me([1,0,5,30,35,4]),function(fe,e,S,L,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.$gL=e.OutputChannelUpdateMode=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=void 0,e.$9K="text/x-code-output",e.$0K="output",e.$$K="Log",e.$_K="text/x-code-log-output",e.$aL="log",e.$bL="workbench.panel.output",e.$cL=new P.$vj("inOutput",!1),e.$dL=new P.$vj("activeLogOutput",!1),e.$eL=new P.$vj("outputView.scrollLock",!1),e.$fL=(0,F.$ei)("outputService");var R;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$gL={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.a=new Map,this.b=new S.$5d,this.onDidRegisterChannel=this.b.event,this.c=new S.$5d,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(A=>k.push(A)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}L.$Tn.add(e.$gL.OutputChannels,new g),e.$hL=new P.$vj("activeOutputChannel","")}),define(Ae[113],Me([1,0,3,4,17,22,14,281,62,27,43,137,24,16,42,5,6]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ic=e.$9ic=void 0;class t extends R.$Ej{get disposed(){return this.n}constructor(l,i,$,a,c){super(),this.id=l,this.name=i,this.r=$,this.s=a,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel($.getLevel()),this.B($.onDidChangeLogLevel(E=>this.setLevel(E)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Clear,l)}replace(l){const i=this.m;this.info(l),this.s.$update(this.id,g.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(l,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:i))}hide(){this.s.$close(this.id)}g(l,i){this.m+=h.$se.fromString(i).byteLength,(0,R.log)(this.r,l,i),this.visible&&(this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends t{appendLine(l){this.append(l)}}let r=class{constructor(l,i,$,a,c,E){this.i=i,this.j=$,this.k=a,this.l=c,this.m=E,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(S.$XL.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,D.$Im)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[i,$]of this.g)$.visible=i===this.h}createOutputChannel(l,i,$){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const a=typeof i=="object"&&i.log,c=(0,v.$Sf)(i)?i:void 0;if((0,v.$Sf)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let E;const y=this.i.environment.extensionLogLevel?.find(([I])=>F.$wm.equals($.identifier,I))?.[1];y&&(E=(0,R.$Oj)(y));const m=a?this.o(l,E,$):this.n(l,c,$);return m.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),a?this.r(l,E??this.m.getLevel(),m):this.q(l,m)}async n(l,i,$){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,c=this.k.extUri.joinPath(a,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),E=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.a.$register(l,c,i,$.identifier.value);return new t(y,l,E,this.a,$)}async o(l,i,$){const a=await this.p($),c=l.replace(/[\\/:\*\?"<>\|]/g,""),E=this.k.extUri.joinPath(a,`${c}.log`),y=`${$.identifier.value}.${c}`,m=this.l.createLogger(E,{id:y,name:l,logLevel:i,extensionId:$.identifier.value});return new n(y,l,m,this.a,$)}p(l){let i=this.d.get(l.identifier.value);if(!i){const $=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,i=(async()=>{try{await this.j.value.createDirectory($)}catch(a){if((0,p.$Rk)(a)!==p.FileSystemProviderErrorCode.FileExists)throw a}return $})())}return i}q(l,i){let $=!1;const a=()=>{if($)throw new Error("Channel has been closed")};return{get name(){return l},append(c){a(),i.then(E=>E.append(c))},appendLine(c){a(),i.then(E=>E.appendLine(c))},clear(){a(),i.then(c=>c.clear())},replace(c){a(),i.then(E=>E.replace(c))},show(c,E){a(),i.then(y=>y.show(c,E))},hide(){a(),i.then(c=>c.hide())},dispose(){$=!0,i.then(c=>c.dispose())}}}r(l,i,$){const a=new o.$Sc,c=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},E=a.add(new s.$5d);function y(m){i=m,E.fire(m)}return $.then(m=>{a.add(m),m.logLevel!==i&&y(m.logLevel),a.add(m.onDidChangeLogLevel(I=>y(I)))}),{...this.q(l,$),get logLevel(){return i},onDidChangeLogLevel:E.event,trace(m,...I){c(),$.then(d=>d.trace(m,...I))},debug(m,...I){c(),$.then(d=>d.debug(m,...I))},info(m,...I){c(),$.then(d=>d.info(m,...I))},warn(m,...I){c(),$.then(d=>d.warn(m,...I))},error(m,...I){c(),$.then(d=>d.error(m,...I))},dispose(){a.dispose()}}}};e.$9ic=r,e.$9ic=r=Xe([qe(0,P.$dO),qe(1,k.$tO),qe(2,f.$Vhc),qe(3,A.$xhc),qe(4,R.$zj),qe(5,R.$yj)],r),e.$0ic=(0,L.$ei)("IExtHostOutputService")}),define(Ae[114],Me([1,0,4,11]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Xm=void 0,e.$Xm=(0,S.$ei)("remoteAgentService"),e.$Ym=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let F=1/0;for(let g=0;g<this.maxSampleCount;g++){const f=await P.getRoundTripTime();if(f===void 0)return;F=Math.min(F,f/2),await(0,L.$fh)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(F):R=this.initial.reduce((g,f)=>g+f,0)/this.initial.length,this.lastMeasurement={initial:R,current:F,average:this.average.reduce((g,f)=>g+f,0)/this.average.length,high:typeof R>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ae[282],Me([1,0,171,55,30,48,47,6,5,114,20,26,11]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=void 0,e.$EI=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$FI=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$GI=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$HI=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$II={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new f.$5d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const p=new v;P.$Tn.add(e.$II.ConfigurationMigration,p);let s=class extends g.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,r){super(),this.a=n,this.b=r,this.B(this.b.onDidChangeWorkspaceFolders(async u=>{for(const l of u.added)await this.f(l,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(u=>this.c(u)))}async c(n){await this.f(void 0,n);for(const r of this.b.getWorkspace().folders)await this.f(r,n)}async f(n,r){await Promise.all([r.map(u=>this.g(u,n?.uri))])}async g(n,r){const u=this.a.inspect(n.key,{resource:r}),l=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[i,$]of l){const a=u[i];if(!a)continue;const c=[];if(a.value!==void 0){const E=await this.h(n,i,a.value,r,void 0);for(const y of E??[])c.push([y,[]])}for(const{identifiers:E,value:y}of a.overrides??[])if(y!==void 0){const m=await this.h(n,i,y,r,E);for(const I of m??[])c.push([I,E])}c.length&&await Promise.allSettled(c.map(async([[E,y],m])=>this.a.updateValue(E,y.value,{resource:r,overrideIdentifiers:m},$)))}}async h(n,r,u,l,i){const $=c=>{const y=this.a.inspect(c,{resource:l})[r];if(y)return i?y.overrides?.find(({identifiers:m})=>(0,D.$Ln)(m,i))?.value:y.value},a=await n.migrateFn(u,$);return Array.isArray(a)?a:[[n.key,a]]}};e.$JI=s,e.$JI=s=Xe([qe(0,R.$Ki),qe(1,F.$ni)],s);let o=class extends g.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new h.$Bh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;P.$Tn.as(L.$Yn.Configuration).registerConfiguration({...e.$GI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$KI=o,e.$KI=o=Xe([qe(0,k.$Xm)],o)}),define(Ae[283],Me([1,0,34,12,19,25,179,282,55,4,30]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1eb=e.$Zeb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Yeb=e.$Xeb=void 0,e.$Xeb=(0,k.$ei)("editorResolverService"),e.$Yeb="workbench.editorAssociations";const D=A.$Tn.as(f.$Yn.Configuration),h={...g.$FI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(h);var v;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})(v||(e.RegisteredEditorPriority=v={}));var p;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function s(t){switch(t){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$Zeb=s;function o(t,n){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(n.scheme))return!1;const l=typeof t=="string"&&t.indexOf(P.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,F.$Og)(n);return S.$Wj(typeof t=="string"?t.toLowerCase():t,l.toLowerCase())}e.$1eb=o}),define(Ae[284],Me([1,0,45,12,19,20,25,2,4,200,48,218,114]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$AL=e.$zL=void 0,e.$zL=(0,f.$ei)("pathService");let p=v=class{constructor(o,t,n,r){this.d=o,this.e=t,this.f=n,this.g=r,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const u=await this.e.getEnvironment();return this.c=u?.userHome??o})()}hasValidBasename(o,t,n){return typeof t=="string"||typeof t>"u"?this.a.then(r=>this.h(o,r,t)):this.h(o,t,n)}h(o,t,n){return o.scheme===L.Schemas.file||o.scheme===L.Schemas.vscodeRemote?(0,S.$dg)(n??(0,R.$Og)(o),t===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,t){if(o.remoteAuthority)return L.Schemas.vscodeRemote;const n=(0,k.$wL)(t.getWorkspace());if(n)return n;const r=t.getWorkspace().folders[0];if(r)return r.uri.scheme;const u=t.getWorkspace().configuration;return u?u.scheme:L.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?P.$fc:P.$gc)}async fileURI(o){let t="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const r=o.indexOf("/",2);r===-1?(t=o.substring(2),o="/"):(t=o.substring(2,r),o=o.substring(r)||"/")}return g.URI.from({scheme:L.Schemas.file,authority:t,path:o,query:"",fragment:""})}};e.$AL=p,e.$AL=p=v=Xe([qe(1,h.$Xm),qe(2,D.$iL),qe(3,A.$ni)],p)}),define(Ae[115],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$bK=e.$aK=void 0;class S{constructor(R,g){this.line=R,this.character=g}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,g){return new S(0,0)}with(R){return new S(0,0)}}e.$aK=S;class L{constructor(R,g,f,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(R,g),this.end=new S(f,k)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.$bK=L;var P;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Ae[44],Me([1,0,18,34,26,45,13,4,19,15,115,11]),function(fe,e,S,L,P,F,R,g,f,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.SearchErrorCode=e.$qK=e.$pK=e.SearchSortOrder=e.ViewMode=e.$oK=e.$nK=e.$mK=e.$lK=e.SearchCompletionExitCode=e.$kK=e.$jK=e.$iK=e.QueryType=e.SearchProviderType=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$cK="workbench.view.search",e.$dK="workbench.panel.search",e.$eK="workbench.view.search",e.$fK="search-result",e.$gK="search.exclude";const h="\u27EA ",v=" characters skipped \u27EB",p=(h.length+v.length+5)*2;e.$hK=(0,g.$ei)("searchService");var s;(function(he){he[he.file=0]="file",he[he.text=1]="text"})(s||(e.SearchProviderType=s={}));var o;(function(he){he[he.File=1]="File",he[he.Text=2]="Text"})(o||(e.QueryType=o={}));function t(he){return!!he.preview}e.$iK=t;function n(he){return!!he.resource}e.$jK=n;function r(he){return!!he.message}e.$kK=r;var u;(function(he){he[he.Normal=0]="Normal",he[he.NewSearchStarted=1]="NewSearchStarted"})(u||(e.SearchCompletionExitCode=u={}));class l{constructor(ve){this.resource=ve,this.results=[]}}e.$lK=l;class i{constructor(ve,se,$e,ee){this.ranges=se,this.webviewIndex=ee;const Y=Array.isArray(se)?se:[se];if($e&&$e.matchLines===1&&$(Y)){ve=(0,R.$Lf)(ve,$e.matchLines);let q="",ne=0,Se=0;const Te=Math.floor($e.charsPerLine/5),Ce=[];for(const be of Y){const ge=Math.max(be.startColumn-Te,0),X=be.startColumn+$e.charsPerLine;if(ge>Se+Te+p){const x=h+(ge-Se)+v;q+=x+ve.slice(ge,X),ne+=ge-(Se+x.length)}else q+=ve.slice(Se,X);Ce.push(new c(0,be.startColumn-ne,be.endColumn-ne)),Se=X}this.preview={text:q,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const q=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ve,matches:(0,S.$2b)(se,ne=>new a(ne.startLineNumber-q,ne.startColumn,ne.endLineNumber-q,ne.endColumn))}}}}e.$mK=i;function $(he){const ve=he[0].startLineNumber;for(const se of he)if(se.startLineNumber!==ve||se.endLineNumber!==ve)return!1;return!0}class a{constructor(ve,se,$e,ee){this.startLineNumber=ve,this.startColumn=se,this.endLineNumber=$e,this.endColumn=ee}}e.$nK=a;class c extends a{constructor(ve,se,$e){super(ve,se,ve,$e)}}e.$oK=c;var E;(function(he){he.List="list",he.Tree="tree"})(E||(e.ViewMode=E={}));var y;(function(he){he.Default="default",he.FileNames="fileNames",he.Type="type",he.Modified="modified",he.CountDescending="countDescending",he.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function m(he,ve=!0){const se=he&&he.files&&he.files.exclude,$e=ve&&he&&he.search&&he.search.exclude;if(!se&&!$e)return;if(!se||!$e)return se||$e;let ee=Object.create(null);return ee=P.$Kn(ee,P.$Hn(se)),ee=P.$Kn(ee,P.$Hn($e),!0),ee}e.$pK=m;function I(he,ve){return he.excludePattern&&L.$Wj(he.excludePattern,ve)?!1:he.includePattern||he.usingSearchPaths?he.includePattern&&L.$Wj(he.includePattern,ve)?!0:he.usingSearchPaths?!!he.folderQueries&&he.folderQueries.some(se=>{const $e=se.folder.fsPath;if(F.$fg(ve,$e)){const ee=f.$lc($e,ve);return!se.includePattern||!!L.$Wj(se.includePattern,ee)}else return!1}):!1:!0}e.$qK=I;var d;(function(he){he[he.unknownEncoding=1]="unknownEncoding",he[he.regexParseError=2]="regexParseError",he[he.globParseError=3]="globParseError",he[he.invalidLiteral=4]="invalidLiteral",he[he.rgProcessError=5]="rgProcessError",he[he.other=6]="other",he[he.canceled=7]="canceled"})(d||(e.SearchErrorCode=d={}));class w extends Error{constructor(ve,se){super(ve),this.code=se}}e.$rK=w;function b(he){const ve=he.message;if((0,k.$4)(he))return new w(ve,d.canceled);try{const se=JSON.parse(ve);return new w(se.message,se.code)}catch{return new w(ve,d.other)}}e.$sK=b;function M(he){const ve={message:he.message,code:he.code};return new Error(JSON.stringify(ve))}e.$tK=M;function T(he){return he.type==="error"?!0:he.type==="success"}e.$uK=T;function G(he){return he.type==="success"}e.$vK=G;function W(he){return!!he.path}e.$wK=W;function U(he,ve,se=!0){const $e=he.searchPath?he.searchPath:he.relativePath;return se?(0,R.$If)($e,ve):L.$Wj(ve,$e)}e.$xK=U;class C{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$yK=C;function O(he,ve){const se={...he||{},...ve||{}};return Object.keys(se).filter($e=>{const ee=se[$e];return typeof ee=="boolean"&&ee})}e.$zK=O;class V{constructor(ve,se){this.c=null,this.a={...ve.excludePattern||{},...se.excludePattern||{}},this.b=L.$Xj(this.a);let $e=ve.includePattern;se.includePattern&&($e?$e={...$e,...se.includePattern}:$e=se.includePattern),$e&&(this.c=L.$Xj($e))}matchesExcludesSync(ve,se,$e){return!!(this.b&&this.b(ve,se,$e))}includedInQuerySync(ve,se,$e){return!(this.b&&this.b(ve,se,$e)||this.c&&!this.c(ve,se,$e))}includedInQuery(ve,se,$e){const ee=this.b(ve,se,$e),Y=()=>this.c?!!this.c(ve,se,$e):!0;return(0,D.$3g)(ee)?ee.then(q=>q?!1:Y()):Y()}hasSiblingExcludeClauses(){return re(this.a)}}e.$AK=V;function re(he){for(const ve in he)if(typeof he[ve]!="boolean")return!0;return!1}function ce(he){if(!he)return;let ve;return se=>(ve||(ve=(he()||Promise.resolve([])).then($e=>$e?De($e):{})),ve.then($e=>!!$e[se]))}e.$BK=ce;function ye(he){if(!he)return;let ve;return se=>{if(!ve){const $e=he();ve=$e?De($e):{}}return!!ve[se]}}e.$CK=ye;function De(he){const ve={};for(const se of he)ve[se]=!0;return ve}}),define(Ae[36],Me([1,0,18,11,21,5,6,51,12,123,25,13,2,170,4,14,189,48,43,27,17,8,7,58,44,3,52]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r,u,l,i,$,a,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=e.$Phc=void 0;function y(G,W,U){return new A.$Gg(C=>w(C,U)).isEqual(G,W)}function m(G,W,U){return y(G.uri,W.uri,U)?0:(0,D.$cf)(G.uri.toString(),W.uri.toString())}function I(G,W,U){return G.index!==W.index?G.index<W.index?-1:1:y(G.uri,W.uri,U)?(0,D.$cf)(G.name,W.name):(0,D.$cf)(G.uri.toString(),W.uri.toString())}function d(G,W,U,C){const O=G.slice(0).sort((re,ce)=>U(re,ce,C)),V=W.slice(0).sort((re,ce)=>U(re,ce,C));return(0,S.$Eb)(O,V,(re,ce)=>U(re,ce,C))}function w(G,W){const U=W.getCapabilities(G.scheme);return!(U&&U&1024)}class b extends t.$xi{static toExtHostWorkspace(W,U,C,O){if(!W)return{workspace:null,added:[],removed:[]};const{id:V,name:re,folders:ce,configuration:ye,transient:De,isUntitled:he}=W,ve=[],se=U;U?ce.forEach((q,ne)=>{const Se=h.URI.revive(q.uri),Te=b.o(C||U,Se,O);Te?(Te.name=q.name,Te.index=q.index,ve.push(Te)):ve.push({uri:Se,name:q.name,index:ne})}):ve.push(...ce.map(({uri:q,name:ne,index:Se})=>({uri:h.URI.revive(q),name:ne,index:Se}))),ve.sort((q,ne)=>q.index<ne.index?-1:1);const $e=new b(V,re,ve,!!De,ye?h.URI.revive(ye):null,!!he,q=>w(q,O)),{added:ee,removed:Y}=d(se?se.workspaceFolders:[],$e.workspaceFolders,m,O);return{workspace:$e,added:ee,removed:Y}}static o(W,U,C){for(let O=0;O<W.folders.length;O++){const V=W.workspaceFolders[O];if(y(V.uri,U,C))return V}}constructor(W,U,C,O,V,re,ce){super(W,C.map(ye=>new t.$yi(ye)),O,V,ce),this.t=U,this.u=re,this.q=[],this.s=g.$ki.forUris(ce),C.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,U){return U&&this.s.get(W)&&(W=(0,A.$Qg)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let M=class{constructor(W,U,C,O,V){this.c=new F.$5d,this.onDidChangeWorkspace=this.c.event,this.g=new F.$5d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new F.$7d,this.C=new Map,this.h=O,this.s=C,this.t=V,this.j=new k.$hm,this.k=new L.$dh,this.o=W.getProxy(c.$XL.MainThreadWorkspace),this.q=W.getProxy(c.$XL.MainThreadMessageService);const re=U.workspace;this.l=re?new b(re.id,re.name,[],!!re.transient,re.configuration?h.URI.revive(re.configuration):null,!!re.isUntitled,ce=>w(ce,C)):void 0}$initializeWorkspace(W,U){this.v=U,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?h.URI.from({scheme:f.Schemas.untitled,path:(0,A.$Og)((0,A.$Qg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,U,C,...O){const V=[];if(Array.isArray(O)&&O.forEach(he=>{h.URI.isUri(he.uri)&&!V.some(ve=>y(ve.uri,he.uri,this.s))&&V.push({uri:he.uri,name:he.name||(0,A.$Ng)(he.uri)})}),this.n||[U,C].some(he=>typeof he!="number"||he<0)||C===0&&V.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(U+C>re.length)return!1;const ce=re.slice(0);ce.splice(U,C,...V.map(he=>({uri:he.uri,name:he.name||(0,A.$Ng)(he.uri),index:void 0})));for(let he=0;he<ce.length;he++){const ve=ce[he];if(ce.some((se,$e)=>$e!==he&&y(ve.uri,se.uri,this.s)))return!1}ce.forEach((he,ve)=>he.index=ve);const{added:ye,removed:De}=d(re,ce,I,this.s);if(ye.length===0&&De.length===0)return!1;if(this.o){const he=W.displayName||W.name;this.o.$updateWorkspaceFolders(he,U,C,V).then(void 0,ve=>{this.n=void 0;const se={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(o.Severity.Error,(0,v.localize)(0,null,he,ve.toString()),se,[])})}return this.y(ce),!0}getWorkspaceFolder(W,U){if(this.x)return this.x.getWorkspaceFolder(W,U)}async getWorkspaceFolder2(W,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,U)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,U){let C,O="";if(typeof W=="string"?(C=h.URI.file(W),O=W):typeof W<"u"&&(C=W,O=W.fsPath),!C)return O;const V=this.getWorkspaceFolder(C,!0);if(!V)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let re=(0,A.$Tg)(V.uri,C);return U&&V.name&&(re=`${V.name}/${re}`),re}y(W){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:U,added:C,removed:O}=b.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:O}))}findFiles(W,U,C,O,V=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let re="",ce=!0;return U===null?ce=!1:U!==void 0&&(typeof U=="string"?re=U:re=U.pattern),this.z(W,void 0,{exclude:re,maxResults:C,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},V)}findFiles2(W,U={},C,O=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${C.value}, entryPoint: findFiles2`),this.z(void 0,W,U,O)}async z(W,U,C,O=P.CancellationToken.None){if(O&&O.isCancellationRequested)return Promise.resolve([]);const V=typeof C.exclude=="string"?C.exclude:C.exclude?C.exclude.pattern:void 0,re={ignoreSymlinks:typeof C.followSymlinks=="boolean"?!C.followSymlinks:void 0,disregardIgnoreFiles:typeof C.useIgnoreFiles=="boolean"?!C.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof C.useGlobalIgnoreFiles=="boolean"?!C.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof C.useParentIgnoreFiles=="boolean"?!C.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof C.useDefaultExcludes=="boolean"?!C.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof C.useDefaultSearchExcludes=="boolean"?!C.useDefaultSearchExcludes:!1,maxResults:C.maxResults,excludePattern:V,shouldGlobSearch:typeof C.fuzzy=="boolean"?!C.fuzzy:!0,_reason:"startFileSearch"};let ce;if(W){const{includePattern:ye,folder:De}=T(l.GlobPattern.from(W));ce=De,re.includePattern=ye}else{const{includePattern:ye,folder:De}=T(l.GlobPattern.from(U));ce=De,re.filePattern=ye}return this.o.$startFileSearch(ce??null,re,O).then(ye=>Array.isArray(ye)?ye.map(De=>h.URI.revive(De)):[])}async findTextInFiles(W,U,C,O,V=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),ce=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ye,folder:De}=T(l.GlobPattern.from(U.include)),he=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ve={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ce,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ye,excludePattern:he},se=!1;if(this.u[re]=$e=>{if(se)return;const ee=h.URI.revive($e.resource);$e.results.forEach(Y=>{const q=(0,E.$Nh)(Y);(0,a.$iK)(q)?C({uri:ee,preview:{text:q.preview.text,matches:(0,S.$2b)(q.preview.matches,ne=>new i.$2L(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,S.$2b)(q.ranges,ne=>new i.$2L(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):C({uri:ee,text:q.text,lineNumber:q.lineNumber})})},V.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(W,De??null,ve,re,V);return delete this.u[re],$e||{}}catch($e){throw delete this.u[re],$e}}$handleTextSearchResult(W,U){this.u[U]?.(W)}async save(W){const U=await this.o.$save(W,{saveAs:!1});return h.URI.revive(U)}async saveAs(W){const U=await this.o.$save(W,{saveAs:!0});return h.URI.revive(U)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,U){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,U);const C=this.t.transformOutgoingScheme(W),O=this.A++;return this.o.$registerEditSessionIdentityProvider(O,C),(0,R.$Rc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(W,U){this.h.info("Getting edit session identifier for workspaceFolder",W);const C=await this.resolveWorkspaceFolder(h.URI.revive(W));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const O=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!O),!O)return;const V=await O.provideEditSessionIdentity(C,U);if(this.h.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(W,U,C,O){this.h.info("Getting edit session identifier for workspaceFolder",W);const V=await this.resolveWorkspaceFolder(h.URI.revive(W));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const re=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!re),!re)return;const ce=await re.provideEditSessionIdentityMatch?.(U,C,O);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(W){return(U,C,O)=>{const V=function(ce){U.call(C,ce)};return V.extension=W,this.B.event(V,void 0,O)}}async $onWillCreateEditSessionIdentity(W,U,C){const O=await this.resolveWorkspaceFolder(h.URI.revive(W));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:O},U,async(V,re)=>{const ce=Date.now();await Promise.resolve(V),Date.now()-ce>C&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(W,U){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,U);const C=this.t.transformOutgoingScheme(W),O=this.A++;return this.o.$registerCanonicalUriProvider(O,C),(0,R.$Rc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(W,U,C){const O=this.C.get(W.scheme);if(!O)return;const V=await O.provideCanonicalUri?.(h.URI.revive(W),U,C);if(V)return V}async $provideCanonicalUri(W,U,C){return this.provideCanonicalUri(h.URI.revive(W),{targetScheme:U},C)}};e.$Phc=M,e.$Phc=M=Xe([qe(0,u.$dO),qe(1,r.$tO),qe(2,n.$xhc),qe(3,s.$yj),qe(4,$.$Nhc)],M),e.$Qhc=(0,p.$ei)("IExtHostWorkspace");function T(G){let W,U;return G&&(typeof G=="string"?W=G:(W=G.pattern,U=h.URI.revive(G.baseUri))),{includePattern:W,folder:U}}}),define(Ae[37],Me([1,0,26,5,36,3,7,191,55,16,11,4,17,14,2]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=e.$Shc=e.$Rhc=void 0;function s($,a){if(a){const c=a.split(".");let E=$;for(let y=0;E&&y<c.length;y++)E=E[c[y]];return E}}function o($){return $ instanceof p.URI}function t($){return $&&$.uri instanceof p.URI&&$.languageId&&typeof $.languageId=="string"}function n($){return $&&!$.uri&&$.languageId&&typeof $.languageId=="string"}function r($){return $&&$.uri instanceof p.URI&&(!$.name||typeof $.name=="string")&&(!$.index||typeof $.index=="number")}function u($){if(o($))return{resource:$};if(t($))return{resource:$.uri,overrideIdentifier:$.languageId};if(n($))return{overrideIdentifier:$.languageId};if(r($))return{resource:$.uri};if($===null)return{resource:null}}let l=class{constructor(a,c,E){this.a=a.getProxy(F.$XL.MainThreadConfiguration),this.c=c,this.b=E,this.d=new A.$dh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new i(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,c){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(a,c))}};e.$Rhc=l,e.$Rhc=l=Xe([qe(0,h.$dO),qe(1,P.$Qhc),qe(2,v.$yj)],l);class i{constructor(a,c,E,y){this.a=new L.$5d,this.b=a,this.f=y,this.c=c,this.e=g.$fo.parse(E),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,c){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=g.$fo.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(c,E))}getConfiguration(a,c,E){const y=u(c)||{},m=this.g(a?s(this.e.getValue(void 0,y,this.c.workspace),a):this.e.getValue(void 0,y,this.c.workspace));a&&this.h(a,y,E?.identifier);function I(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(w){return typeof s(m,w)<"u"},get:(w,b)=>{this.h(a?`${a}.${w}`:w,y,E?.identifier);let M=s(m,w);if(typeof M>"u")M=b;else{let T;const G=(W,U)=>{if((0,k.$Uf)(W)){let C;const O=()=>{T=T||(0,S.$Hn)(m),C=C||s(T,U)};return new Proxy(W,{get:(V,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return O(),()=>C;if(T)return C=C||s(T,U),C[re];const ce=V[re];return typeof re=="string"?G(ce,`${U}.${re}`):ce},set:(V,re,ce)=>(O(),C&&(C[re]=ce),!0),deleteProperty:(V,re)=>(O(),C&&delete C[re],!0),defineProperty:(V,re,ce)=>(O(),C&&Object.defineProperty(C,re,ce),!0)})}return Array.isArray(W)?(0,S.$Hn)(W):W};M=G(M,w)}return M},update:(w,b,M,T)=>{w=a?`${a}.${w}`:w;const G=I(M);return b!==void 0?this.b.$updateConfigurationOption(G,w,b,y,T):this.b.$removeConfigurationOption(G,w,y,T)},inspect:w=>{w=a?`${a}.${w}`:w;const b=this.e.inspect(w,y,this.c.workspace);if(b)return{key:w,defaultValue:(0,S.$Hn)(b.policy?.value??b.default?.value),globalValue:(0,S.$Hn)(b.user?.value??b.application?.value),workspaceValue:(0,S.$Hn)(b.workspace?.value),workspaceFolderValue:(0,S.$Hn)(b.workspaceFolder?.value),defaultLanguageValue:(0,S.$Hn)(b.default?.override),globalLanguageValue:(0,S.$Hn)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,S.$Hn)(b.workspace?.override),workspaceFolderLanguageValue:(0,S.$Hn)(b.workspaceFolder?.override),languageIds:(0,S.$Hn)(b.overrideIdentifiers)}}};return typeof m=="object"&&(0,S.$Kn)(d,m,!1),Object.freeze(d)}g(a){const c=E=>(0,k.$Uf)(E)?new Proxy(E,{get:(y,m)=>c(y[m]),set:(y,m,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(y,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(y,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:y=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return c(a)}h(a,c,E){const y=f.$9n.test(a)?4:this.d.get(a),m=E?`[${E.value}] `:"";if(y===4){typeof c?.resource>"u"&&this.f.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(y===3){c?.resource&&this.f.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,c){const E=new g.$ho(a,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(y,m)=>E.affectsConfiguration(y,u(m))})}k(a){return a.reduce((c,E)=>(c.set(E[0],E[1]),c),new Map)}}e.$Shc=i,e.$Thc=(0,D.$ei)("IExtHostConfiguration")}),define(Ae[116],Me([1,0,2,11,5,3,7,36,66,37,21,65,17,27,4,12,20,14,78,223,15]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=e.$jjc=e.$ijc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(l||(l={}));var i;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(i||(i={}));var $;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})($||($={}));var a;(function(G){function W(O){if(O){const V=O;return V&&!!V.process}else return!1}G.is=W;function U(O){if(O==null)return;const V={process:O.process,args:O.args};return O.options&&(V.options=$.from(O.options)),V}G.from=U;function C(O){if(O!=null)return new R.$IM(O.process,O.args,O.options)}G.to=C})(a||(a={}));var c;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(c||(c={}));var E;(function(G){function W(O){if(O){const V=O;return V&&(!!V.commandLine||!!V.command)}else return!1}G.is=W;function U(O){if(O==null)return;const V={};return O.commandLine!==void 0?V.commandLine=O.commandLine:(V.command=O.command,V.args=O.args),O.options&&(V.options=c.from(O.options)),V}G.from=U;function C(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$JM(O.commandLine,O.options):new R.$JM(O.command,O.args?O.args:[],O.options)}G.to=C})(E||(E={}));var y;(function(G){function W(O){if(O){const V=O;return V&&V.customExecution==="customExecution"}else return!1}G.is=W;function U(O){return{customExecution:"customExecution"}}G.from=U;function C(O,V){return V.get(O)}G.to=C})(y||(e.CustomExecutionDTO=y={}));var m;(function(G){function W(U,C){let O;return U.scope!==void 0&&typeof U.scope!="number"?O=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&C&&C.workspaceFile?O=C.workspaceFile:O=r.$bH),{id:U._id,workspaceFolder:O}}G.from=W})(m||(e.TaskHandleDTO=m={}));var I;(function(G){function W(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}G.from=W})(I||(I={}));var d;(function(G){function W(O,V){if(O==null)return[];const re=[];for(const ce of O){const ye=U(ce,V);ye&&re.push(ye)}return re}G.fromMany=W;function U(O,V){if(O==null)return;let re;O.execution instanceof R.$IM?re=a.from(O.execution):O.execution instanceof R.$JM?re=E.from(O.execution):O.execution&&O.execution instanceof R.$KM&&(re=y.from(O.execution));const ce=l.from(O.definition);let ye;return O.scope?typeof O.scope=="number"?ye=O.scope:ye=O.scope.uri:ye=R.TaskScope.Workspace,!ce||!ye?void 0:{_id:O._id,definition:ce,name:O.name,source:{extensionId:V.identifier.value,label:O.source,scope:ye},execution:re,isBackground:O.isBackground,group:I.from(O.group),presentationOptions:i.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}G.from=U;async function C(O,V,re){if(O==null)return;let ce;a.is(O.execution)?ce=a.to(O.execution):E.is(O.execution)?ce=E.to(O.execution):y.is(O.execution)&&(ce=y.to(O._id,re));const ye=l.to(O.definition);let De;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?De=O.source.scope:De=await V.resolveWorkspaceFolder(S.URI.revive(O.source.scope)):De=R.TaskScope.Workspace),!ye||!De)return;const he=new R.$LM(ye,De,O.name,O.source.label,ce,O.problemMatchers);return O.isBackground!==void 0&&(he.isBackground=O.isBackground),O.group!==void 0&&(he.group=R.$HM.from(O.group._id),he.group&&O.group.isDefault&&(he.group=new R.$HM(he.group.id,he.group.label),O.group.isDefault===!0&&(he.group.isDefault=O.group.isDefault))),O.presentationOptions&&(he.presentationOptions=i.to(O.presentationOptions)),O._id&&(he._id=O._id),O.detail&&(he.detail=O.detail),he}G.to=C})(d||(e.TaskDTO=d={}));var w;(function(G){function W(C){return C}G.from=W;function U(C){if(C)return Object.assign(Object.create(null),C)}G.to=U})(w||(w={}));class b{#e;constructor(W,U,C){this._id=U,this.a=C,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let M=class{constructor(W,U,C,O,V,re,ce,ye){this.q=new P.$5d,this.r=new P.$5d,this.s=new P.$5d,this.u=new P.$5d,this.a=W.getProxy(F.$XL.MainThreadTask),this.b=C,this.c=O,this.d=V,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,U,C){if(!C)return new R.$ZL(()=>{});const O=this.x();return this.j.set(O,{type:U,provider:C,extension:W}),this.a.$registerTaskProvider(O,U),new R.$ZL(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(W,U){this.a.$registerTaskSystem(W,U)}fetchTasks(W){return this.a.$fetchTasks(w.from(W)).then(async U=>{const C=[];for(const O of U){const V=await d.to(O,this.b,this.m);V&&C.push(V)}return C})}get taskExecutions(){const W=[];return this.k.forEach(U=>W.push(U)),W}terminateTask(W){if(!(W instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,U,C){const O=this.m.get(W.id);O&&(this.o.set(W.id,O),this.e.attachPtyToTerminal(U,await O.callback(C))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const U=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const U=await this.z(W.id);this.s.fire({execution:U,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const U=await this.z(W.id);this.u.fire({execution:U,exitCode:W.exitCode})}$provideTasks(W,U){const C=this.j.get(W);if(!C)return Promise.reject(new Error("no handler found"));const O=[],V=(0,L.$9g)(()=>C.provider.provideTasks(A.CancellationToken.None)).then(re=>this.v(U,O,C,re));return new Promise(re=>{V.then(ce=>{Promise.all(O).then(()=>{re(ce)})})})}async $resolveTask(W,U){const C=this.j.get(W);if(!C)return Promise.reject(new Error("no handler found"));if(U.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${C.type}].`);const O=await d.to(U,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const V=await C.provider.resolveTask(O,A.CancellationToken.None);if(!V)return;this.A(V,C);const re=d.from(V,C.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(re.execution)&&await this.y(re,V,!0),await this.w(re)}x(){return this.h++}async y(W,U,C){const O=await this.a.$createTaskId(W);!C&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,U.execution)),this.m.set(O,U.execution)}async z(W,U){if(typeof W=="string"){const V=this.l.get(W);if(!V)throw new u.$bb("Unexpected: The specified task is missing an execution");return V}const C=this.l.get(W.id);if(C)return C;let O;return U?O=Promise.resolve(new b(this,W.id,U)):O=d.to(W.task,this.b,this.m).then(V=>{if(!V)throw new u.$bb("Unexpected: Task does not exist.");return new b(this,W.id,V)}),this.l.set(W.id,O),O.then(V=>(this.k.set(W.id,V),V))}A(W,U){W._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const C=this.n.values();let O=C.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=C.next()}};e.$ijc=M,e.$ijc=M=Xe([qe(0,h.$dO),qe(1,v.$tO),qe(2,g.$Qhc),qe(3,f.$oO),qe(4,k.$Thc),qe(5,D.$fic),qe(6,t.$yj),qe(7,n.$thc)],M);let T=class extends M{constructor(W,U,C,O,V,re,ce,ye){super(W,U,C,O,V,re,ce,ye),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(W,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const C=d.from(U,W);if(C===void 0)throw new Error("Task is not valid");if(y.is(C.execution))await this.y(C,U,!1);else throw new u.$_;const O=await this.z(await this.a.$getTaskExecution(C),U);return this.a.$executeTask(C).catch(V=>{throw new Error(V)}),O}v(W,U,C,O){const V=[];if(O)for(const re of O){if(this.A(re,C),!re.definition||!W[re.definition.type]){const ye=re.source?re.source:"No task source";this.f.warn(`The task [${ye}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=d.from(re,C.extension);ce&&y.is(ce.execution)?(V.push(ce),U.push(this.y(ce,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:C.extension}}async w(W){if(y.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,U,C){}};e.$jjc=T,e.$jjc=T=Xe([qe(0,h.$dO),qe(1,v.$tO),qe(2,g.$Qhc),qe(3,f.$oO),qe(4,k.$Thc),qe(5,D.$fic),qe(6,t.$yj),qe(7,n.$thc)],T),e.$kjc=(0,p.$ei)("IExtHostTask")}),define(Ae[285],Me([1,0,44,29]),function(fe,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.$JK=e.$IK=void 0;function P(R){return"cellResults"in R}e.$IK=P,e.$JK="rawCell#";function F(R,g){let f=-1;const k=[];let A=[];return R.forEach(h=>{h.range.startLineNumber!==f&&A.length>0&&(k.push([...A]),A=[]),A.push(h),f=h.range.endLineNumber}),A.length>0&&k.push([...A]),k.map(h=>{const v=[],p=h[0].range.startLineNumber,s=h[h.length-1].range.endLineNumber;for(let o=p;o<=s;o++)v.push(g.getLineContent(o));return new S.$mK(v.join(`
`)+`
`,h.map(o=>new L.$6s(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}e.$KK=F}),define(Ae[286],Me([1,0,164,24,5,6,28,13,16,2,42,74,3,31,8,7,50,261,110,26,12,213,285,283]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r,u,l,i,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,y,m,I,d,w){this.q=m,this.r=I,this.s=d,this.t=w,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new P.$5d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$5d,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$5d,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$5d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$rhc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=E.getProxy(h.$XL.MainThreadNotebook),this.c=E.getProxy(h.$XL.MainThreadNotebookDocuments),this.d=E.getProxy(h.$XL.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===13){const M=b.notebookEditor?.notebookUri,T=b.cell.handle,W=this.g.get(M)?.getCell(T);if(W)return W.apiCell}if(b&&b.$mid===14){const M=b.uri,T=this.g.get(M);if(T)return T.apiNotebook}return b}}),a.B(y)}getEditorById(E){const y=this.h.get(E);if(!y)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(E){for(const[y,m]of this.h)if(m.apiEditor===E)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,y){const m=this.g.get(E);if(!m&&!y)throw new Error(`NO notebook document for '${E}'`);return m}static u(E,y){if(!y)return;const m=y.filenamePattern.map(I=>p.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(y.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:y.displayName,filenamePattern:m,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,y,m){const I=a.a++,d=typeof m.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(I,m),this.b.$registerNotebookCellStatusBarItemProvider(I,d,y);let w;return d!==void 0&&(w=m.onDidChangeCellStatusBarItems(b=>this.b.$emitCellStatusBarEvent(d))),new s.$ZL(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,d),w?.dispose()})}async createNotebookDocument(E){const y=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&p.NotebookData.from(E.content)});return k.URI.revive(y)}async openNotebookDocument(E){const y=this.g.get(E);if(y)return y.apiNotebook;const m=await this.c.$tryOpenNotebook(E),I=this.g.get(k.URI.revive(m));return(0,f.$4f)(I?.apiNotebook)}async showNotebookDocument(E,y){k.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let m;typeof y=="object"?m={position:p.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(p.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:m={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,m),d=I&&this.h.get(I)?.apiEditor;if(d)return d;throw I?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,y,m,I){const d=this.f.get(E),w=k.URI.revive(y),b=this.g.get(w);if(!b||!d)return;const M=b.getCellFromIndex(m);if(!M)return;const T=await d.provideCellStatusBarItems(M.apiCell,I);if(!T)return;const G=new F.$Sc,W=this.p.add([G]),C=(Array.isArray(T)?T:[T]).map(O=>p.NotebookStatusBarItem.from(O,this.i,G));return{cacheId:W,items:C}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,y,m,I,d){if((0,g.$Se)(y))throw new Error("viewType cannot be empty or just whitespace");const w=this.w++;return this.x.set(w,{viewType:y,serializer:m,options:I}),this.b.$registerNotebookSerializer(w,{id:E.identifier,location:E.extensionLocation},y,p.NotebookDocumentContentOptions.from(I),a.u(E,d)),(0,F.$Rc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(E,y,m){const I=this.x.get(E);if(!I)throw new Error("NO serializer found");const d=await I.serializer.deserializeNotebook(y.buffer,m);return new o.$6v(p.NotebookData.from(d))}async $notebookToData(E,y,m){const I=this.x.get(E);if(!I)throw new Error("NO serializer found");const d=await I.serializer.serializeNotebook(p.NotebookData.to(y.value),m);return L.$se.wrap(d)}async $saveNotebook(E,y,m,I,d){const w=k.URI.revive(y),b=this.x.get(E);if(!b)throw new Error("NO serializer found");const M=this.g.get(w);if(!M)throw new Error("Document NOT found");if(M.versionId!==m)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new A.$Wk((0,S.localize)(0,null,this.z(w)),6);await this.y(w,I);const T={metadata:(0,r.$Pn)(M.apiNotebook.metadata,O=>!(b.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of M.apiNotebook.getCells()){const V=new s.$oN(O.kind,O.document.getText(),O.document.languageId,O.mime,b.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);V.metadata=(0,r.$Pn)(O.metadata,re=>!(b.options?.transientCellMetadata??{})[re]),T.cells.push(V)}const G=await b.serializer.serializeNotebook(T,d);await this.s.value.writeFile(w,G);const W=this.s.getFileSystemProviderExtUri(w.scheme),U=await this.s.value.stat(w);return{name:W.basename(w),isFile:(U.type&A.FileType.File)!==0,isDirectory:(U.type&A.FileType.Directory)!==0,isSymbolicLink:(U.type&A.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((U.permissions??0)&A.FilePermission.Locked),etag:A.$8k({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(E,y,m,I,d){const w=this.x.get(E)?.serializer;if(!w)return{limitHit:!1,results:[]};const b=new R.$Bc;await(async(U,C,O)=>{await Promise.all(U.map(async V=>await Promise.all(V.filenamePatterns.map(re=>{const ce={_reason:O._reason,folderQueries:O.folderQueries,includePattern:O.includePattern,excludePattern:O.excludePattern,maxResults:O.maxResults,type:1,filePattern:re};return this.t.doInternalFileSearchWithCustomCallback(ce,C,ye=>{ye.forEach(De=>{b.has(De)||I.some(ve=>V.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(se=>(0,$.$1eb)(se,De)))||b.add(De)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(m,d,y);const T=new R.$Ac;let G=!1;const W=Array.from(b).map(async U=>{const C=[];try{if(d.isCancellationRequested)return;if(y.maxResults&&[...T.values()].reduce((ce,ye)=>ce+ye.cellResults.length,0)>y.maxResults){G=!0;return}const O=[],V=this.g.get(U);if(V)V.apiNotebook.getCells().forEach(ye=>O.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(De=>De.items.map(he=>he.data.toString()))}));else{const ce=await this.s.value.readFile(U),ye=L.$se.fromString(ce.toString()),De=await w.deserializeNotebook(ye.buffer,d);if(d.isCancellationRequested)return;p.NotebookData.from(De).cells.forEach(ve=>O.push({input:ve.source,outputs:ve.outputs.flatMap(se=>se.items.map($e=>$e.valueBytes.toString()))}))}if(d.isCancellationRequested)return;O.forEach((ce,ye)=>{const De=y.contentPattern.pattern,he=new l.$9Sb(ce.input,void 0,ce.outputs),ve=he.findInInputs(De),se=he.findInOutputs(De),$e=se.flatMap(ee=>(0,i.$KK)(ee.matches,ee.textBuffer)).map((ee,Y)=>(ee.webviewIndex=Y,ee));if(ve.length>0||se.length>0){const ee={index:ye,contentResults:(0,i.$KK)(ve,he.inputTextBuffer),webviewResults:$e};C.push(ee)}});const re={resource:U,cellResults:C};T.set(U,re);return}catch{return}});return await Promise.all(W),{limitHit:G,results:[...T.values()]}}async y(E,y){const m=await this.s.value.stat(E);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==A.$7k&&typeof m.mtime=="number"&&typeof m.size=="number"&&y.mtime<m.mtime&&y.etag!==A.$8k({mtime:y.mtime,size:m.size}))throw new A.$Wk((0,S.localize)(1,null),3,y)}z(E){return E.scheme===u.Schemas.file?E.fsPath:E.toString()}A(E,y,m){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const I=new n.$Nic(y,this.d,E,m.visibleRanges.map(p.NotebookRange.to),m.selections.map(p.NotebookRange.to),typeof m.viewColumn=="number"?p.ViewColumn.to(m.viewColumn):void 0);this.h.set(y,I)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const m of E.value.removedDocuments){const I=k.URI.revive(m),d=this.g.get(I);d&&(d.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(d.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===I.toString()&&this.h.delete(w.id)}if(E.value.addedDocuments){const m=[];for(const I of E.value.addedDocuments){const d=k.URI.revive(I.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const w=new t.$Mic(this.c,this.q,this.r,d,I);m.push(...I.cells.map(b=>t.$Lic.asModelAddData(b))),this.g.get(d)?.dispose(),this.g.set(d,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this.m.fire(w.apiNotebook)}}if(E.value.addedEditors)for(const m of E.value.addedEditors){if(this.h.has(m.id))return;const I=k.URI.revive(m.documentUri),d=this.g.get(I);d&&this.A(d,m.id,m)}const y=[];if(E.value.removedEditors)for(const m of E.value.removedEditors){const I=this.h.get(m);I&&(this.h.delete(m),this.k?.id===I.id&&(this.k=void 0),y.push(I))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const m=new Set;this.l.forEach(I=>m.add(I.id));for(const I of this.h.values()){const d=m.has(I.id);I._acceptVisibility(d)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.h.get(E.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${E.value.newActiveEditor}`),this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(E){const y=v.$BO.String.with("notebookType","A notebook type"),m=new v.$DO("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new v.$BO("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>L.$se.wrap(d))],new v.$CO("Notebook Data",d=>p.NotebookData.to(d.value))),I=new v.$DO("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new v.$BO("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new o.$6v(p.NotebookData.from(d)))],new v.$CO("Bytes",d=>d.buffer));E.registerApiCommand(m),E.registerApiCommand(I)}}e.$Wic=a}),define(Ae[287],Me([1,0,19,21,41,34,25,63,44]),function(fe,e,S,L,P,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=void 0;class k{constructor(h,v,p){this.k=h,this.l=v,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=h.filePattern,this.b=h.includePattern&&F.$Xj(h.includePattern),this.c=h.maxResults||void 0,this.d=h.exists,this.h=new Set,this.j=h.excludePattern&&F.$Xj(h.excludePattern)}cancel(){this.g=!0,this.h.forEach(h=>h.cancel()),this.h=new Set}search(h){const v=this.k.folderQueries||[];return new Promise((p,s)=>{const o=t=>{this.f++,h(t)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const n=t.toString(),r=S.$nc(n);this.j&&this.j(n,r)||this.v(o,{base:t,basename:r})}),Promise.all(v.map(t=>this.p(t,o))).then(t=>{p({limitHit:this.e,stats:t[0]||void 0})},t=>{s(new Error((0,P.$2i)(t)))})})}async p(h,v){const p=new L.$ce,s=this.q(h),o=this.r(),t=new f.$AK(this.k,h),n=!t.hasSiblingExcludeClauses();let r;try{this.h.add(p),r=g.$1d.create();const u=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,p.token),l=r.elapsed(),i=g.$1d.create();return this.g&&!this.e||(u&&u.forEach($=>{const a=S.$gc.relative(h.folder.path,$.path);if(n){const c=S.$nc($.path);this.v(v,{base:h.folder,relativePath:a,basename:c});return}this.s(o,h.folder,a,v)}),this.g&&!this.e)?null:(this.u(o,t,v),{providerTime:l,postProcessTime:i.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(h){const v=(0,f.$zK)(this.k.includePattern,h.includePattern),p=(0,f.$zK)(this.k.excludePattern,h.excludePattern);return{folder:h.folder,excludes:p,includes:v,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}s({pathToEntries:h},v,p,s){if(p===this.a){const t=S.$nc(this.a);this.v(s,{base:v,relativePath:this.a,basename:t})}function o(t){const n=S.$nc(t),r=S.$mc(t);let u=h[r];u||(u=h[r]=[],o(r)),u.push({base:v,relativePath:t,basename:n})}o(p)}u({rootEntries:h,pathToEntries:v},p,s){const o=this,t=this.a;function n(r){const u=(0,f.$CK)(()=>r.map(l=>l.basename));for(let l=0,i=r.length;l<i;l++){const $=r[l],{relativePath:a,basename:c}=$;if(p.matchesExcludesSync(a,c,t!==c?u:void 0))continue;const E=v[a];if(E)n(E);else{if(a===t)continue;o.v(s,$)}if(o.e)break}}n(h)}v(h,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||h(v))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(h,v,p,s){const o=this.c(h.cacheKey),t=new k(h,v,o&&o.token);let n=0;const r=u=>{n+=u.length,p(u.map(l=>this.d(l)))};return this.e(t,A.a,r,s).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:u.stats}}))}clearCache(h){this.c(h)?.cancel()}c(h){if(h)return this.b.has(h)||this.b.set(h,new L.$ce),this.b.get(h)}d(h){return h.relativePath?{resource:R.$Rg(h.base,h.relativePath)}:{resource:h.base}}e(h,v,p,s){const o=s.onCancellationRequested(()=>{h.cancel()}),t=r=>{r&&(n.push(r),v>0&&n.length>=v&&(p(n),n=[]))};let n=[];return h.search(t).then(r=>(n.length&&p(n),o.dispose(),r),r=>(n.length&&p(n),o.dispose(),Promise.reject(r)))}}e.$Oic=A}),define(Ae[288],Me([1,0,18,256,34,94,28,12,19,25,13,16,2,93,181,47,14,48,105,284,44]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.$BL=void 0;let l=class{constructor(w,b,M,T,G){this.a=w,this.b=b,this.c=M,this.d=T,this.e=G}text(w,b,M={}){w=this.f(w,M);const T=this.a.getValue(),G=b&&b.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(b?.map(t.$zi),M),type:2,contentPattern:w,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:T.search.usePCRE2||G||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}f(w,b){const M=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const T={...w,wordSeparators:M.editor.wordSeparators};return this.j(w,b)&&(T.isCaseSensitive=!0),this.k(w)&&(T.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),T}file(w,b={}){return{...this.h(w,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey,shouldGlobMatchFilePattern:b.shouldGlobSearch}}g(w,b){return w?(w=Array.isArray(w)?w.map(E):E(w),b?this.parseSearchPaths(w):{pattern:$(...Array.isArray(w)?w:[w])}):{}}h(w=[],b={}){const M=this.g(b.includePattern,b.expandPatterns),T=this.g(b.excludePattern,b.expandPatterns),G=w.length>1,W=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(O=>this.q(O,b,T)):w.map(O=>this.r(O,b,T,G))).filter(O=>!!O),U={_reason:b._reason,folderQueries:W,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:T.pattern,includePattern:M.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const O=S.$Hb(S.$Rb(this.c.groups.map(ce=>ce.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const V=O.filter(ce=>(0,u.$qK)(U,ce.fsPath)),re=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(re)),{...U,...re}}const C=b.extraFileResources&&b.extraFileResources.filter(O=>(0,u.$qK)(U,O.fsPath));return U.extraFileResources=C&&C.length?C:void 0,U}i(w){const b=[],M=new R.$Ac,T={};let G=!1;return w.forEach(W=>{if(W.scheme===g.Schemas.walkThrough)return;if((0,k.$Vg)(W)){const C=this.b.getWorkspaceFolder(W)?.uri??W.with({path:f.$mc(W.fsPath)});let O=M.get(C);O||(G=!0,O={folder:C,includePattern:{}},b.push(O),M.set(C,O));const V=f.$lc(C.fsPath,W.fsPath);(0,D.$4f)(O.includePattern)[V.replace(/\\/g,"/")]=!0}else W.fsPath&&(G=!0,T[W.fsPath]=!0)}),{folderQueries:b,includePattern:T,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(w,b){if(b.isSmartCase){if(w.isRegExp){if(A.$Jf(w.pattern,!0))return!0}else if(A.$Jf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,v.$dC)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const b=re=>f.$ic(re)||/^\.\.?([\/\\]|$)/.test(re),T=(Array.isArray(w)?w:a(w)).map(re=>{const ce=this.e.resolvedUserHome;return ce?(0,F.$$v)(re,ce.scheme===g.Schemas.file?ce.fsPath:ce.path):re}),G=L.$K(T,re=>b(re)?"searchPaths":"exprSegments"),W=(G.exprSegments||[]).map(re=>A.$4e(re,"/")).map(re=>A.$4e(re,"\\")).map(re=>(re[0]==="."&&(re="*"+re),c(re))),U={},C=this.m(G.searchPaths||[]);C&&C.length&&(U.searchPaths=C);const O=S.$Rb(W),V=$(...O);return V&&(U.pattern=V),U}l(w,b){return b.disregardExcludeSettings?void 0:(0,u.$pK)(w,!b.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const b=w.flatMap(T=>{let{pathPortion:G,globPortion:W}=i(T);return W&&(W=y(W)),this.n(G).flatMap(C=>this.o(C,W))}),M=new Map;return b.forEach(T=>{const G=T.searchPath.toString(),W=M.get(G);W?T.pattern&&(W.pattern=W.pattern||{},W.pattern[T.pattern]=!0):M.set(G,{searchPath:T.searchPath,pattern:T.pattern?$(T.pattern):void 0})}),Array.from(M.values())}n(w){if(f.$ic(w)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==g.Schemas.file?[{searchPath:b[0].uri.with({path:w})}]:[{searchPath:h.URI.file(f.$hc(w))}]}if(this.b.getWorkbenchState()===2){const b=this.b.getWorkspace().folders[0].uri;if(w=E(w),w.startsWith("../")||w===".."){const T=f.$gc.resolve(b.path,w);return[{searchPath:b.with({path:T})}]}const M=y(w);return[{searchPath:b,pattern:M}]}else{if(w==="./"||w===".\\")return[];{const b=w.replace(/^\.[\/\\]/,""),T=this.b.getWorkspace().folders.map(G=>{const W=b.match(new RegExp(`^${A.$Xe(G.name)}(?:/(.*)|$)`));return W?{match:W,folder:G}:null}).filter(D.$1f);if(T.length)return T.map(G=>{const W=G.match[1];return{searchPath:G.folder.uri,pattern:W&&y(W)}});{const G=w.match(/\.[\/\\](.+)[\/\\]?/),W=G?G[1]:w,U=p.localize(0,null,W);throw new Error(U)}}}}o(w,b){const M=w.pattern&&b?`${w.pattern}/${b}`:w.pattern||b,T=[{searchPath:w.searchPath,pattern:M}];return M&&!M.endsWith("**")&&T.push({searchPath:w.searchPath,pattern:M+"/**"}),T}q(w,b,M){const T=this.r((0,t.$zi)(w.searchPath),b,M,!1);return T?{...T,includePattern:w.pattern}:null}r(w,b,M,T){let G;const W=h.URI.isUri(w)?w:w.uri;if(M.searchPaths){const re=M.searchPaths.filter(ce=>(0,k.$Kg)(ce.searchPath,W))[0];if(re&&!re.pattern)return null;re&&(G=re.pattern)}const U=this.a.getValue({resource:W}),O={...this.l(U,b)||{},...G||{}},V=h.URI.isUri(w)?(0,k.$Og)(w):w.name;return{folder:W,folderName:T?V:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!U.search.followSymlinks}}};e.$BL=l,e.$BL=l=Xe([qe(0,s.$Ki),qe(1,t.$ni),qe(2,n.$kD),qe(3,o.$yj),qe(4,r.$zL)],l);function i(d){const w=d.match(/[\*\{\}\(\)\[\]\?]/);if(w){const b=w.index,M=d.substr(0,b).match(/[/|\\][^/\\]*$/);if(M){let T=d.substr(0,M.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:d.substr((M.index||0)+1)}}}return{pathPortion:d}}function $(...d){return d.length?d.reduce((w,b)=>(w[b]=!0,w),Object.create(null)):void 0}function a(d){return P.$Vj(d,",").map(w=>w.trim()).filter(w=>!!w.length)}function c(d){return[`**/${d}/**`,`**/${d}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function E(d){return d.replace(/\\/g,"/")}function y(d){return E(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(d){return d.replace(/([?*[\]])/g,"[$1]")}function I(d,w){d=S.$Mb(d,T=>T.toString());const b=[],M=w.getWorkspace();return d&&d.forEach(T=>{let G;if(w.getWorkbenchState()===2)G=(0,k.$Tg)(M.folders[0].uri,T),G&&G!=="."&&(G="./"+G);else{const W=w.getWorkspaceFolder(T);if(W){const U=W.name;if(M.folders.filter(O=>O.name===U).length===1){const O=(0,k.$Tg)(W.uri,T);O===""?G=`./${W.name}`:G=`./${W.name}/${O}`}else G=T.fsPath}}G&&b.push(m(G))}),b}e.$CL=I}),define(Ae[289],Me([1,0,25,2,21,15,4,288,44,48,11]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lub=e.$kub=void 0;const D=7e3;function h(o,t){const n=t.activationEvents;if(!n)return Promise.resolve(void 0);const r=[],u=[];for(const E of n)if(/^workspaceContains:/.test(E)){const y=E.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||o.forceUsingSearch?u.push(y):r.push(y)}if(r.length===0&&u.length===0)return Promise.resolve(void 0);const{promise:l,resolve:i}=(0,A.$0g)(),$=E=>i({activationEvent:E}),a=Promise.all(r.map(E=>v(o,E,$))).then(()=>{}),c=p(o,t.identifier,u,$);return Promise.all([a,c]).then(()=>{i(void 0)}),l}e.$kub=h;async function v(o,t,n){for(const r of o.folders)if(await o.exists(S.$Rg(L.URI.revive(r),t))){n(`workspaceContains:${t}`);return}}async function p(o,t,n,r){if(n.length===0)return Promise.resolve(void 0);const u=new P.$ce,l=o.checkExists(o.folders,n,u.token),i=setTimeout(async()=>{u.cancel(),o.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},D);let $=!1;try{$=await l}catch(a){F.$4(a)||F.$1(a)}u.dispose(),clearTimeout(i),$&&r(`workspaceContains:${n.join(",")}`)}function s(o,t,n,r){const u=o.get(R.$di),l=o.get(f.$hK),$=u.createInstance(g.$BL).file(t.map(a=>(0,k.$zi)(L.URI.revive(a))),{_reason:"checkExists",includePattern:n,exists:!0});return l.fileSearch($,r).then(a=>!!a.limitHit,a=>F.$4(a)?!1:Promise.reject(a))}e.$lub=s}),define(Ae[38],Me([1,0,161,19,87,25,11,6,51,2,14,3,37,219,82,36,23,106,15,22,24,202,7,100,4,27,84,17,71,85,65,5,289,81,204,12,79,63,20,80]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r,u,l,i,$,a,c,E,y,m,I,d,w,b,M,T,G,W,U,C,O){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=e.$sic=e.$ric=e.$qic=void 0,e.$qic=(0,a.$ei)("IHostUtils");let re=V=class extends g.$Tc{constructor(Y,q,ne,Se,Te,Ce,be,ge,X,x,le,de){super(),this.X=de,this.a=this.B(new w.$5d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=q,this.g=ne,this.f=be,this.j=Se,this.m=Te,this.s=Ce,this.t=X,this.u=x,this.w=le,this.y=this.g.getProxy(D.$XL.MainThreadWorkspace),this.z=this.g.getProxy(D.$XL.MainThreadTelemetry),this.C=this.g.getProxy(D.$XL.MainThreadExtensionService),this.D=new R.$dh,this.F=new R.$dh,this.G=new R.$dh,this.H=new R.$dh,this.I=new $e(this.f.extensions.activationEvents),this.L=new t.$t9b(this.I,this.f.extensions.allExtensions);const Pe=new r.$xm(this.f.extensions.myExtensions);this.J=new t.$t9b(this.I,ve(this.L,Pe)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${De(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${De(this.J)}`)),this.M=new p.$bic(this.g,this.s),this.N=new M.$jic(this.g),this.O=ge,this.h=Y.createChild(new m.$ci([p.$cic,this.M],[M.$kic,this.N])),this.P=this.B(new v.$aic(this.J,this.L,{onExtensionActivationError:(me,Ie,Le)=>{this.C.$onExtensionActivationError(me,n.$3(Ie),Le)},actualActivateExtension:async(me,Ie)=>{if(t.$t9b.isHostExtension(me,this.J,this.L))return await this.C.$activateExtension(me,Ie),new v.$_hc;const Le=this.J.getExtensionDescription(me);return this.db(Le,Ie)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Y){n.$1(Y)}}async Y(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(Te=>Te.identifier).filter(Te=>this.isActivated(Te)).map(Te=>this.cb(Te))}catch{}await Promise.all(Y)}terminate(Y,q=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Se=>{this.s.error(Se)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$fh)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const q=await this.C.$getExtension(Y);return q&&{...q,identifier:new r.$wm(q.identifier.value),extensionLocation:k.URI.revive(q.extensionLocation)}}Z(Y,q){return this.P.activateByEvent(Y,q)}$(Y,q){return this.P.activateById(Y,q)}activateByIdWithErrors(Y,q){return this.$(Y,q).then(()=>{const ne=this.P.getActivatedExtension(Y);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async ab(Y){if(Y.scheme===G.Schemas.file&&this.c.fsRealpath){const q=await this.c.fsRealpath(Y.fsPath);return k.URI.file(q)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Y=>new se(Y))),this.Q}async bb(Y){const q=f.$ki.forUris(ne=>F.$Ig.ignorePathCasing(ne));return await Promise.all(Y.map(async ne=>{if(this.ub(ne)){const Se=await this.ab(ne.extensionLocation);q.set(Se,ne)}})),q}cb(Y){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return q;const ne=this.P.getActivatedExtension(Y);if(!ne)return q;try{typeof ne.module.deactivate=="function"&&(q=Promise.resolve(ne.module.deactivate()).then(void 0,Se=>(this.s.error(Se),Promise.resolve(void 0))))}catch(Se){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(Se)}try{(0,g.$Oc)(ne.subscriptions)}catch(Se){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(Se)}return q}async db(Y,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.fb(Y,q).then(ne=>{const Se=ne.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,q),this.eb(Y,q,"success",Se),ne},ne=>{throw this.eb(Y,q,"failure"),ne})}eb(Y,q,ne,Se){const Te=ye(Y,q);this.z.$publicLog2("extensionActivationTimes",{...Te,...Se||{},outcome:ne})}fb(Y,q){const ne=ye(Y,q);this.z.$publicLog2("activatePlugin",ne);const Se=this.ub(Y);if(!Se)return Promise.resolve(new v.$$hc(v.$8hc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${Y.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const Te=new v.$9hc(q.startup);return Promise.all([this.vb(Y,(0,F.$Rg)(Y.extensionLocation,Se),Te),this.gb(Y)]).then(Ce=>(P.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),V.hb(this.s,Y.identifier,Ce[0],Ce[1],Te))).then(Ce=>(P.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),Ce))}gb(Y){const q=new l.$eic(Y,this.M),ne=new l.$dic(Y.identifier.value,!1,this.M),Se=new T.$lic(Y,this.N),Te=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ce=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([q.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const be=this;let ge,X;const x=(0,o.$UF)(Y,"ipc")?this.f.messagePorts?.get(r.$wm.toKey(Y.identifier)):void 0;return Object.freeze({globalState:q,workspaceState:ne,secrets:Se,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(le){return L.$jc(Y.extensionLocation.fsPath,le)},get storagePath(){return be.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return be.O.globalValue(Y).fsPath},get logPath(){return L.$jc(be.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return k.URI.joinPath(be.f.logsLocation,Y.identifier.value)},get storageUri(){return be.O.workspaceValue(Y)},get globalStorageUri(){return be.O.globalValue(Y)},get extensionMode(){return Te},get extension(){return ge===void 0&&(ge=new he(be,Y.identifier,Y,Ce,!1)),ge},get extensionRuntime(){return(0,o.$VF)(Y,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!X){if(!x)return;const le=w.Event.buffer(w.Event.fromDOMEventEmitter(x,"message",de=>de.data));x.start(),X={onDidReceiveMessage:le,postMessage:x.postMessage.bind(x)}}return X}})})}static hb(Y,q,ne,Se,Te){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(Y,q,ne,Se,Te).then(Ce=>new v.$0hc(!1,null,Te.build(),ne,Ce,Se.subscriptions))}static ib(Y,q,ne,Se,Te){if(typeof ne.activate=="function")try{Te.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${q.value}`);const Ce=typeof global=="object"?global:self,be=ne.activate.apply(Ce,[Se]);return Te.activateCallStop(),Te.activateResolveStart(),Promise.resolve(be).then(ge=>(Te.activateResolveStop(),ge))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(ne)}jb(Y,q){this.$(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:q}).then(void 0,ne=>{this.s.error(ne)})}kb(Y,q=0){const Se=Date.now();(0,C.$B)(()=>{for(let Te=q;Te<Y.length;Te+=1){const Ce=Y[Te];for(const be of Ce.activationEvents??[])if(be==="onStartupFinished")if(Date.now()-Se>50){this.kb(Y,Te);break}else this.jb(Ce,be)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Y=>{const q=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(q)this.kb(ne);else for(const Se of ne)if(Se.activationEvents)for(const Te of Se.activationEvents)Te==="onStartupFinished"&&this.jb(Se,Te)})}mb(){const Y=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const q=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(q),Se=this.pb(),Te=Promise.all([Se,Y,ne]).then(()=>{});return Promise.race([Te,(0,R.$fh)(1e4)]).then(()=>{this.lb()}),Te}nb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.ob(Y,q))).then(()=>{})}async ob(Y,q){if(this.isActivated(q.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Se={logService:this.s,folders:Y.map(Ce=>Ce.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,be,ge)=>this.y.$checkExists(Ce,be,ge)},Te=await(0,b.$kub)(Se,q);if(Te)return this.$(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:Te.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Y){throw console.error(Y),Y}}async qb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:q}=this.f.environment;if(!Y||!q)throw new Error(S.localize(0,null));const ne=await this.vb(null,q,new v.$9hc(!1));if(!ne||typeof ne.run!="function")throw new Error(S.localize(1,null,q.toString()));return new Promise((Se,Te)=>{const Ce=(X,x)=>{X?(C.$t&&this.s.error("Test runner called back with error",X),Te(X)):(C.$t&&(x?this.s.info(`Test runner called back with ${x} failures.`):this.s.info("Test runner called back with successful outcome.")),Se(typeof x=="number"&&x>0?1:0))},be=(0,F.$Fg)(q),ge=ne.run(be,Ce);ge&&ge.then&&ge.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Se(0)}).catch(X=>{C.$t&&this.s.error("Test runner finished with error",X),Te(X instanceof Error&&X.stack?X.stack:String(X))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$fh)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,q){return this.R[Y]=q,(0,g.$Rc)(()=>{delete this.R[Y]})}async getRemoteExecServer(Y){const{resolver:q}=await this.sb(Y);return q?.resolveExecServer?.(Y,{resolveAttempt:0})}async sb(Y){const q=Y.indexOf("+");if(q===-1)throw new i.$6L("Not an authority that can be resolved!",$.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Y.substr(0,q);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(Y,q){const ne=U.$1d.create(!1),Se=()=>`[resolveAuthority(${(0,$.$kl)(Y)},${q})][${ne.elapsed()}ms] `,Te=N=>this.s.info(`${Se()}${N}`),Ce=N=>this.s.warn(`${Se()}${N}`),be=(N,j=void 0)=>this.s.error(`${Se()}${N}`,j),ge=N=>{if(N instanceof i.$6L)return{type:"error",error:{code:N._code,message:N._message,detail:N._detail}};throw N},X=async N=>{Te(`activating resolver for ${N}...`);const{resolver:j,authorityPrefix:K}=await this.sb(N);if(!j)throw be(`no resolver for ${K}`),new i.$6L(`No remote extension installed to resolve ${K}.`,$.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:j,authorityPrefix:K,remoteAuthority:N}},x=Y.split(/@|%40/g).reverse();Te(`activating remote resolvers ${x.join(" -> ")}`);let le;try{le=await Promise.all(x.map(X)).catch(async N=>{if(!(N instanceof i.$6L)||N._code!==$.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw N;return Ce(`resolving nested authorities failed: ${N.message}`),[await X(Y)]})}catch(N){return ge(N)}const de=new R.$ph;de.cancelAndSet(()=>Te("waiting..."),1e3);let Pe,me;for(const[N,{authorityPrefix:j,resolver:K,remoteAuthority:H}]of le.entries())try{if(N===le.length-1)Te("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${j}`),Pe=await K.resolve(H,{resolveAttempt:q,execServer:me}),P.mark(`code/extHost/didResolveAuthorityOK/${j}`),Te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(K,i.$5L.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(Te(`invoking resolveExecServer() for ${H}`),P.mark(`code/extHost/willResolveExecServer/${j}`),me=await K.resolveExecServer?.(H,{resolveAttempt:q,execServer:me}),!me)throw new i.$6L(`Exec server was not available for ${H}`,$.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${j}`)}}catch(te){return P.mark(`code/extHost/didResolveAuthorityError/${j}`),be("returned an error",te),de.dispose(),ge(te)}de.dispose();const Ie={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},Le={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};Te(`returned ${i.$5L.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let ze;if(i.$5L.isManagedResolvedAuthority(Pe)){const N=q;this.X.setFactory(N,Pe.makeConnection),ze={authority:Y,connectTo:new $.$hl(N),connectionToken:Pe.connectionToken}}else ze={authority:Y,connectTo:new $.$il(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:ze,options:Le,tunnelInformation:Ie}}}async $getCanonicalURI(Y,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,$.$kl)(Y)})`);const{resolver:ne}=await this.sb(Y);if(!ne)return null;const Se=k.URI.revive(q);if(typeof ne.getCanonicalURI>"u")return Se;const Te=await(0,R.$9g)(()=>ne.getCanonicalURI(Se));return Te||Se}$startExtensionHost(Y){Y.toAdd.forEach(Se=>Se.extensionLocation=k.URI.revive(Se.extensionLocation));const{globalRegistry:q,myExtensions:ne}=ce(this.I,this.L,this.J,Y);return this.L.set(q.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${De(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${De(this.J)}`)),this.rb()}$activateByEvent(Y,q){return q===1?this.D.wait().then(ne=>this.Z(Y,!1)):this.G.wait().then(ne=>this.Z(Y,!1))}async $activate(Y,q){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.$(Y,q),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(Ce=>Ce.extensionLocation=k.URI.revive(Ce.extensionLocation));const{globalRegistry:q,myExtensions:ne}=ce(this.I,this.L,this.J,Y),Se=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Se),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${De(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${De(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const q=u.$se.alloc(Y),ne=Math.random()%256;for(let Se=0;Se<Y;Se++)q.writeUInt8(ne,Se);return q}async $updateRemoteConnectionData(Y){this.W=Y,this.a.fire()}};e.$ric=re,e.$ric=re=V=Xe([qe(0,a.$di),qe(1,e.$qic),qe(2,y.$dO),qe(3,s.$Qhc),qe(4,h.$Thc),qe(5,A.$yj),qe(6,c.$tO),qe(7,E.$Whc),qe(8,I.$eAb),qe(9,d.$fic),qe(10,W.$nic),qe(11,O.$oic)],re);function ce(ee,Y,q,ne){ee.addActivationEvents(ne.addActivationEvents);const Se=new t.$t9b(ee,Y.getAllExtensionDescriptions());Se.deltaExtensions(ne.toAdd,ne.toRemove);const Te=new r.$xm(q.getAllExtensionDescriptions().map(be=>be.identifier));for(const be of ne.myToRemove)Te.delete(be);for(const be of ne.myToAdd)Te.add(be);const Ce=ve(Se,Te);return{globalRegistry:Se,myExtensions:Ce}}function ye(ee,Y){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function De(ee){return ee.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$sic=(0,a.$ei)("IExtHostExtensionService");class he{#e;#t;#i;constructor(Y,q,ne,Se,Te){this.#e=Y,this.#t=q,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=L.$hc((0,F.$Fg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Se,this.isFromDifferentExtensionHost=Te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$tic=he;function ve(ee,Y){return ee.getAllExtensionDescriptions().filter(q=>Y.has(q.identifier))}class se{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$uic=se;class $e{constructor(Y){this.a=new r.$ym,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const q of Object.keys(Y))this.a.set(q,Y[q])}}}),define(Ae[290],Me([1,0,87,2,3,37,23,22,17,27,4,38,14,13]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=void 0;let s=class{constructor(u,l,i,$,a,c,E){this.c=u,this.d=l,this.e=i,this.f=$,this.g=a,this.h=c,this.i=E,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const u=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new t(this.c,l,this.d,u,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,l,this.h.environment.appUriScheme))}register(u){if("nodeModuleName"in u)if(Array.isArray(u.nodeModuleName))for(const l of u.nodeModuleName)this.a.set(l,u);else this.a.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this.b.push(l=>u.alternativeModuleName(l))}};e.$Cjc=s,e.$Cjc=s=Xe([qe(2,A.$di),qe(3,F.$Thc),qe(4,D.$sic),qe(5,k.$tO),qe(6,h.$yj)],s);let o=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(u){if(u.environment.appRoot&&p.a.size){const l=(0,v.$Xe)(this.c(u.environment.appRoot.fsPath)),i="[a-z0-9_.-]",$=`@${i}+\\/${i}+|${i}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${a}\\/)(${$})(.*)$`,"i")}}alternativeModuleName(u){if(!this.b)return;const l=this.b.exec(this.c(u));if(!l)return;const[,i,$,a]=l,c=p.a.get($);if(c!==void 0)return console.warn(`${$} as been renamed to ${c}, please update your imports`),i+c+a}c(u){return u.replace(/\\/g,"/")}};o=p=Xe([qe(0,k.$tO)],o);class t{constructor(u,l,i,$,a){this.c=u,this.d=l,this.e=i,this.f=$,this.g=a,this.nodeModuleName="vscode",this.a=new g.$ym}load(u,l){const i=this.d.findSubstr(l);if(i){let $=this.a.get(i.identifier);return $||($=this.c(i,this.e,this.f),this.a.set(i.identifier,$)),$}if(!this.b){let $="";this.d.forEach((a,c)=>$+=`	${c} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${$}`),this.b=this.c(R.$PF,this.e,this.f)}return this.b}}let n=class{constructor(u,l,i){this.e=u,this.f=l,this.nodeModuleName=["open","opn"],this.d=i.getProxy(P.$XL.MainThreadTelemetry);const $=i.getProxy(P.$XL.MainThreadWindow);this.c=(a,c)=>{const E=L.URI.parse(a);return c?this.g(a,c):E.scheme==="http"||E.scheme==="https"?$.$openUri(E,a,{allowTunneling:!0}):E.scheme==="mailto"||E.scheme===this.f?$.$openUri(E,a,{}):this.g(a,c)}}load(u,l,i){const $=this.e.findSubstr(l);return $&&(this.a=$.identifier.value,this.h()),this.b=i(u),this.c}g(u,l){return this.i(),this.b(u,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Xe([qe(2,f.$dO)],n)}),define(Ae[117],Me([1,0,39,6,19,73,4,66,64,38,7,36,216,37]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=e.$vic=void 0,e.$vic=(0,R.$ei)("IExtHostVariableResolverProvider");class p extends h.$eP{constructor(t,n,r,u,l,i,$){function a(){if(r){const c=r.activeEditor();if(c)return c.document.uri;const E=u.tabGroups.all.find(y=>y.isActive)?.activeTab;if(E!==void 0){if(E.input instanceof A.$IN||E.input instanceof A.$NN)return E.input.modified;if(E.input instanceof A.$HN||E.input instanceof A.$MN||E.input instanceof A.$KN)return E.input.uri}}}super({getFolderUri:c=>{const E=i.folders.filter(y=>y.name===c);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(c,E)=>l.getConfiguration(void 0,c).get(E),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=a();if(c)return P.$hc(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const c=a();if(c){const E=n.getWorkspaceFolder(c);if(E)return P.$hc(E.uri.fsPath)}}},getSelectedText:()=>{if(r){const c=r.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(r){const c=r.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>t.getExtension(c)},void 0,$?Promise.resolve($):void 0,Promise.resolve(F.env))}}let s=class extends L.$Tc{constructor(t,n,r,u,l){super(),this.b=t,this.c=n,this.g=r,this.h=u,this.j=l,this.a=new S.$V(async()=>{const i=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,i,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$wic=s,e.$wic=s=Xe([qe(0,k.$sic),qe(1,D.$Qhc),qe(2,g.$oO),qe(3,v.$Thc),qe(4,f.$6hc)],s)}),define(Ae[118],Me([1,0,11,5,2,22,4,3,64,38,17,7,36,208,210,37,117,6,40,31,8]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=e.$Aic=e.$zic=e.$yic=e.$xic=void 0,e.$xic=(0,R.$ei)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(m,I,d,w,b,M,T){this.N=I,this.O=d,this.P=w,this.Q=b,this.R=M,this.S=T,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new L.$5d,this.o=new L.$5d,this.q=new L.$5d,this.w=new L.$5d,this.l=m.getProxy(g.$XL.MainThreadDebugService),this.A=new L.$5d,this.C=new L.$5d,this.y=new $(this.l),this.z=new Map,this.O.getExtensionRegistry().then(G=>{G.onDidChange(W=>{this.V(G)}),this.V(G)})}async $getVisualizerTreeItem(m,I){const d=this.W(I);if(!d)return;const w=await this.H.get(m)?.getTreeItem?.(d);return w?this.U(m,w):void 0}registerDebugVisualizationTree(m,I,d){const w=F.$wm.toKey(m.identifier),b=this.jb(w,I);if(this.G.has(b))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.H.set(b,d),this.l.$registerDebugVisualizerTree(b,!!d.editItem),(0,t.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(b),this.H.delete(I)})}async $getVisualizerTreeItemChildren(m,I){const d=this.J.get(I)?.item;return d?(await this.H.get(m)?.getChildren?.(d))?.map(b=>this.U(m,b))||[]:[]}async $editVisualizerTreeItem(m,I){const d=this.J.get(m);if(!d)return;const w=await this.H.get(d.provider)?.editItem?.(d.item,I);return this.U(d.provider,w||d.item)}$disposeVisualizedTree(m){const I=this.J.get(m);if(!I)return;const d=[I.children];for(const w of d)if(w)for(const b of w)d.push(this.J.get(b)?.children),this.J.delete(b)}U(m,I){let d=this.I.get(I);return d||(d=this.F++,this.I.set(I,d),this.J.set(d,{provider:m,item:I})),u.DebugTreeItem.from(I,d)}asDebugSourceUri(m,I){const d=m;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let w=`debug:${encodeURIComponent(d.path||"")}`,b="?";return I&&(w+=`${b}session=${encodeURIComponent(I.id)}`,b="&"),w+=`${b}ref=${d.sourceReference}`,P.URI.parse(w)}else{if(d.path)return P.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(m){const I=[];for(const d of m.getAllExtensionDescriptions())if(d.contributes){const w=d.contributes.debuggers;if(w&&w.length>0)for(const b of w)(0,p.$rG)(b)&&I.push(b.type)}this.l.$registerDebugTypes(I)}get stackFrameFocus(){return this.B}get onDidChangeStackFrameFocus(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const m=[];return this.z.forEach(I=>m.push(I)),m}async $resolveDebugVisualizer(m,I){const d=this.L.get(m);if(!d)throw new Error(`No debug visualizer found with id '${m}'`);let{v:w,provider:b,extensionId:M}=d;if(w.visualization||(w=await b.resolveDebugVisualization?.(w,I)||w,d.v=w),!w.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${b}'`);return this.kb(M,w.visualization)}async $executeDebugVisualizerCommand(m){const I=this.L.get(m);if(!I)throw new Error(`No debug visualizer found with id '${m}'`);const d=I.v.visualization;d&&"command"in d&&this.S.executeCommand(d.command,...d.arguments||[])}W(m){const I=this.m.get(m.sessionId);return I&&{session:I.api,variable:m.variable,containerId:m.containerId,frameId:m.frameId,threadId:m.threadId}}async $provideDebugVisualizers(m,I,d,w){const b=this.W(d),M=this.jb(m,I),T=this.G.get(M);if(!b||!T)return[];const G=await T.provideDebugVisualization(b,w);return G?G.map(W=>{const U=++this.M;this.L.set(U,{v:W,provider:T,extensionId:m});const C=W.iconPath?this.lb(W.iconPath):void 0;return{id:U,name:W.name,iconClass:C?.iconClass,iconPath:C?.iconPath,visualization:this.kb(m,W.visualization)}}):[]}$disposeDebugVisualizers(m){for(const I of m)this.L.delete(I)}registerDebugVisualizationProvider(m,I,d){if(!m.contributes?.debugVisualizers?.some(M=>M.id===I))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${I})`);const w=F.$wm.toKey(m.identifier),b=this.jb(w,I);if(this.G.has(b))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.G.set(b,d),this.l.$registerDebugVisualizer(w,I),(0,t.$Rc)(()=>{this.l.$unregisterDebugVisualizer(w,I),this.G.delete(I)})}addBreakpoints(m){const I=m.filter(b=>{const M=b.id;return this.z.has(M)?!1:(this.z.set(M,b),!0)});this.gb(I,[],[]);const d=[],w=new Map;for(const b of I)if(b instanceof D.$ZM){let M=w.get(b.location.uri.toString());M||(M={type:"sourceMulti",uri:b.location.uri,lines:[]},w.set(b.location.uri.toString(),M),d.push(M)),M.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character,mode:b.mode})}else b instanceof D.$1M&&d.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName,mode:b.mode});return this.l.$registerBreakpoints(d)}removeBreakpoints(m){const I=m.filter(M=>this.z.delete(M.id));this.gb([],I,[]);const d=I.filter(M=>M instanceof D.$ZM).map(M=>M.id),w=I.filter(M=>M instanceof D.$1M).map(M=>M.id),b=I.filter(M=>M instanceof D.$2M).map(M=>M.id);return this.l.$unregisterBreakpoints(d,w,b)}startDebugging(m,I,d){return this.l.$startDebugging(m?m.uri:void 0,I,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(m){return this.l.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,I,d){if(!I)return new D.$ZL(()=>{});const w=this.d++;return this.f.push({type:m,handle:w,provider:I}),this.l.$registerDebugConfigurationProvider(m,d,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,w),new D.$ZL(()=>{this.f=this.f.filter(b=>b.provider!==I),this.l.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(m,I,d){if(!d)return new D.$ZL(()=>{});if(!this.cb(m,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.$(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:I,handle:w,factory:d}),this.l.$registerDebugAdapterDescriptorFactory(I,w),new D.$ZL(()=>{this.h=this.h.filter(b=>b.factory!==d),this.l.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(m,I){if(!I)return new D.$ZL(()=>{});const d=this.j++;return this.k.push({type:m,handle:d,factory:I}),new D.$ZL(()=>{this.k=this.k.filter(w=>w.factory!==I)})}async $runInTerminal(m,I){return Promise.resolve(void 0)}async $substituteVariables(m,I){let d;const w=await this.ib(m);return w&&(d={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(d,I)}X(m,I){if(m.type==="implementation")return new c(m.implementation)}Y(){}async $startDASession(m,I){const d=this,w=await this.hb(I);return this.eb(this.$(w.type),w).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const M=this.Z(b),T=this.X(M,w);if(!T)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const G=T;return this.D.set(m,G),this.db(w).then(W=>(W&&this.E.set(m,W),G.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const C=U,O={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const V=await this.K.sign(C.arguments.value);O.body={signature:V},G.sendResponse(O)}else throw new Error("no signer")}catch(V){O.success=!1,O.message=V.message,G.sendResponse(O)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(U),U=(0,p.$wG)(U,!0),d.l.$acceptDAMessage(m,U)}),G.onError(U=>{W&&W.onError&&W.onError(U),this.l.$acceptDAError(m,U.name,U.message,U.stack)}),G.onExit(U=>{W&&W.onExit&&W.onExit(U??void 0,void 0),this.l.$acceptDAExit(m,U??void 0,void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),G.startSession()))})}$sendDAMessage(m,I){I=(0,p.$vG)(I,!1);const d=this.E.get(m);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(I),this.D.get(m)?.sendMessage(I)}$stopDASession(m){const I=this.E.get(m);this.E.delete(m),I&&I.onWillStopSession&&I.onWillStopSession();const d=this.D.get(m);return this.D.delete(m),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const I=[],d=[],w=[];if(m.added)for(const b of m.added){const M=b.id;if(M&&!this.z.has(M)){let T;if(b.type==="function")T=new D.$1M(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage,b.mode);else if(b.type==="data")T=new D.$2M(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage,b.mode);else{const G=P.URI.revive(b.uri);T=new D.$ZM(new D.$_L(G,new D.$1L(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage,b.mode)}(0,D.$XM)(T,M),this.z.set(M,T),I.push(T)}}if(m.removed)for(const b of m.removed){const M=this.z.get(b);M&&(this.z.delete(b),d.push(M))}if(m.changed){for(const b of m.changed)if(b.id){const M=this.z.get(b.id);if(M){if(M instanceof D.$1M&&b.type==="function"){const T=M;T.enabled=b.enabled,T.condition=b.condition,T.hitCondition=b.hitCondition,T.logMessage=b.logMessage,T.functionName=b.functionName}else if(M instanceof D.$ZM&&b.type==="source"){const T=M;T.enabled=b.enabled,T.condition=b.condition,T.hitCondition=b.hitCondition,T.logMessage=b.logMessage,T.location=new D.$_L(P.URI.revive(b.uri),new D.$1L(b.line,b.character))}w.push(M)}}}this.gb(I,d,w)}async $acceptStackFrameFocus(m){let I;const d=m.sessionId?await this.hb(m.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");m.kind==="thread"?I=new D.$8M(d.api,m.threadId):I=new D.$7M(d.api,m.threadId,m.frameId),this.B=I,this.C.fire(this.B)}$provideDebugConfigurations(m,I,d){return(0,S.$9g)(async()=>{const w=this.bb(m);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.ib(I);return w.provideDebugConfigurations(b,d)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(m,I,d,w){return(0,S.$9g)(async()=>{const b=this.bb(m);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.ib(I);return b.resolveDebugConfiguration(M,d,w)})}$resolveDebugConfigurationWithSubstitutedVariables(m,I,d,w){return(0,S.$9g)(async()=>{const b=this.bb(m);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.ib(I);return b.resolveDebugConfigurationWithSubstitutedVariables(M,d,w)})}async $provideDebugAdapter(m,I){const d=this.ab(m);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.hb(I);return this.eb(d,w).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.Z(b)})}async $acceptDebugSessionStarted(m){const I=await this.hb(m);this.n.fire(I.api)}async $acceptDebugSessionTerminated(m){const I=await this.hb(m);I&&(this.o.fire(I.api),this.m.delete(I.id))}async $acceptDebugSessionActiveChanged(m){this.u=m?await this.hb(m):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(m,I){(await this.hb(m))?._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent(m,I){const w={session:(await this.hb(m)).api,event:I.event,body:I.body};this.w.fire(w)}Z(m){if(m instanceof D.$3M)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof D.$4M)return{type:"server",port:m.port,host:m.host};if(m instanceof D.$5M)return{type:"pipeServer",path:m.path};if(m instanceof D.$6M)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}$(m){const I=this.h.filter(d=>d.type===m);if(I.length>0)return I[0].factory}ab(m){const I=this.h.filter(d=>d.handle===m);if(I.length>0)return I[0].factory}bb(m){const I=this.f.filter(d=>d.handle===m);if(I.length>0)return I[0].provider}cb(m,I){if(m.contributes){const d=m.contributes.debuggers;if(d&&d.length>0){for(const w of d)if(w.label&&w.type&&w.type===I)return!0}}return!1}db(m){const d=m.configuration.type,w=this.k.filter(b=>b.type===d||b.type==="*").map(b=>(0,S.$9g)(()=>b.factory.createDebugAdapterTracker(m.api)).then(M=>M,M=>null));return Promise.race([Promise.all(w).then(b=>{const M=b.filter(T=>!!T);if(M.length>0)return new a(M)}),new Promise(b=>setTimeout(()=>b(void 0),1e3))]).catch(b=>{})}async eb(m,I){const d=I.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new D.$4M(d));if(m){const b=await this.O.getExtensionRegistry();return(0,S.$9g)(()=>m.createDebugAdapterDescriptor(I.api,this.fb(I,b))).then(M=>{if(M)return M})}const w=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(I,w))}fb(m,I){}gb(m,I,d){(m.length>0||I.length>0||d.length>0)&&this.A.fire(Object.freeze({added:m,removed:I,changed:d}))}async hb(m){if(m)if(typeof m=="string"){const I=this.m.get(m);if(I)return I}else{let I=this.m.get(m.id);if(!I){const d=await this.ib(m.folderUri),w=m.parent?this.m.get(m.parent):void 0;I=new i(this.l,m.id,m.type,m.name,d,m.configuration,w?.api),this.m.set(I.id,I),this.l.$sessionCached(I.id)}return I}throw new Error("cannot find session")}ib(m){if(m){const I=P.URI.revive(m);return this.N.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}jb(m,I){return`${m}\0${I}`}kb(m,I){if(I){if("title"in I&&"command"in I)return{type:0};if("treeId"in I)return{type:1,id:`${m}\0${I.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(m){const I=this.mb(m);let d,w;return"id"in I?w=n.ThemeIcon.asClassName(I):d=I,{iconPath:d,iconClass:w}}mb(m){if(m instanceof D.$UM)return{id:m.id};const I=typeof m=="object"&&"dark"in m?m.dark:m,d=typeof m=="object"&&"light"in m?m.light:m;return{dark:typeof I=="string"?P.URI.file(I):I,light:typeof d=="string"?P.URI.file(d):d}}};e.$yic=l,e.$yic=l=Xe([qe(0,A.$dO),qe(1,h.$Qhc),qe(2,k.$sic),qe(3,s.$Thc),qe(4,f.$6hc),qe(5,o.$vic),qe(6,r.$zO)],l);class i{constructor(m,I,d,w,b,M,T){this.f=m,this.g=I,this.h=d,this.j=w,this.k=b,this.l=M,this.m=T}get api(){const m=this;return this.d??=Object.freeze({id:m.g,type:m.h,get name(){return m.j},set name(I){m.j=I,m.f.$setDebugSessionName(m.g,I)},parentSession:m.m,workspaceFolder:m.k,configuration:m.l,customRequest(I,d){return m.f.$customDebugAdapterRequest(m.g,I,d)},getDebugProtocolBreakpoint(I){return m.f.$getDebugProtocolBreakpoint(m.g,I.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(m){this.j=m}get configuration(){return this.l}}e.$zic=i;class ${constructor(m){this.value=Object.freeze({append(I){m.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.$Aic=$;class a{constructor(m){this.d=m}onWillStartSession(){this.d.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.d.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.d.forEach(I=>I.onDidSendMessage?I.onDidSendMessage(m):void 0)}onWillStopSession(){this.d.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.d.forEach(I=>I.onError?I.onError(m):void 0)}onExit(m,I){this.d.forEach(d=>d.onExit?d.onExit(m,I):void 0)}}class c extends v.$Dnb{constructor(m){super(),this.h=m,m.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.h.handleMessage(m)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let E=class extends l{constructor(m,I,d,w,b,M,T){super(m,I,d,w,b,M,T)}};e.$Bic=E,e.$Bic=E=Xe([qe(0,A.$dO),qe(1,h.$Qhc),qe(2,k.$sic),qe(3,s.$Thc),qe(4,f.$6hc),qe(5,o.$vic),qe(6,r.$zO)],E)}),define(Ae[291],Me([1,0,15,87,2,3,237,14,53,71,27,186,17,58,38,60]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=e.$Djc=void 0;class o{static async installEarlyHandler(r){Error.stackTraceLimit=100;const u=r.get(g.$yj),i=r.get(h.$dO).getProxy(F.$XL.MainThreadErrors);S.setUnexpectedErrorHandler($=>{u.error($);const a=S.$3($);i.$onUnexpectedError(a)})}static async installFullHandler(r){const u=r.get(g.$yj),l=r.get(h.$dO),i=r.get(p.$sic),$=r.get(s.$xO),a=l.getProxy(F.$XL.MainThreadExtensionService),c=l.getProxy(F.$XL.MainThreadErrors),E=await i.getExtensionPathIndex(),y=new WeakMap;function m(w,b){if(y.has(w))return y.get(w).stack;let M="",T,G;for(const U of b)M+=`
	at ${U.toString()}`,G=U.getFileName(),!T&&G&&(T=E.findSubstr(P.URI.file(G)));const W=`${w.name||"Error"}: ${w.message||""}${M}`;return y.set(w,{extensionIdentifier:T?.identifier,stack:W}),W}const I=Symbol("prepareStackTrace wrapped");let d=m;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return d},set(w){if(w===m||!w||w[I]){d=w||m;return}d=function(b,M){return m(b,M),w.call(Error,b,M)},Object.assign(d,{[I]:!0})}}),S.setUnexpectedErrorHandler(w=>{u.error(w);const b=S.$3(w),M=y.get(w);if(!M?.extensionIdentifier){c.$onUnexpectedError(b);return}a.$onExtensionRuntimeError(M.extensionIdentifier,b);const T=$.onExtensionError(M.extensionIdentifier,w);u.trace("forwarded error to extension?",T,M)})}}e.$Djc=o;class t{constructor(r,u,l,i,$){this.a=l,this.b=new R.$B9b(r,null,i),u=t.e(u,this.b);const a=new k.$ci(...(0,f.$$r)());a.set(A.$tO,{_serviceBrand:void 0,...u,messagePorts:$}),a.set(h.$dO,new h.$eO(this.b)),a.set(v.$Nhc,new v.$Ohc(i)),a.set(p.$qic,l);const c=new D.$Pq(a,!0);c.invokeFunction(o.installEarlyHandler),this.d=c.invokeFunction(E=>E.get(g.$yj)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",u),this.c=c.invokeFunction(E=>E.get(p.$sic)),this.c.initialize(),c.invokeFunction(o.installFullHandler)}async asBrowserUri(r){const u=this.b.getProxy(F.$XL.MainThreadExtensionService);return P.URI.revive(await u.$asBrowserUri(r))}terminate(r){this.c.terminate(r)}static e(r,u){r.extensions.allExtensions.forEach(i=>{i.extensionLocation=P.URI.revive(u.transformIncomingURIs(i.extensionLocation))}),r.environment.appRoot=P.URI.revive(u.transformIncomingURIs(r.environment.appRoot));const l=r.environment.extensionDevelopmentLocationURI;return l&&(r.environment.extensionDevelopmentLocationURI=l.map(i=>P.URI.revive(u.transformIncomingURIs(i)))),r.environment.extensionTestsLocationURI=P.URI.revive(u.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=P.URI.revive(u.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=P.URI.revive(u.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=P.URI.revive(u.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=P.URI.revive(u.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=P.URI.revive(u.transformIncomingURIs(r.logsLocation)),r.workspace=u.transformIncomingURIs(r.workspace),r}}e.$Ejc=t}),define(Ae[292],Me([1,0,18,11,21,41,12,19,25,2,44]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=e.$Ric=e.$Qic=e.$Pic=void 0;class D{constructor(n,r,u,l){this.d=n,this.e=r,this.f=u,this.g=l,this.a=null,this.b=!1,this.c=0}search(n,r){const u=this.d.folderQueries||[],l=new P.$ce(r);return new Promise((i,$)=>{this.a=new v(n);let a=!1;const c=(E,y)=>{if(!a&&!this.b){const m=this.h(E);s(E)&&typeof this.d.maxResults=="number"&&this.c+m>this.d.maxResults&&(this.b=!0,a=!0,l.cancel(),E=this.j(E,this.d.maxResults-this.c));const I=this.h(E);this.c+=I,(I>0||!s(E))&&this.a.add(E,y)}};Promise.all(u.map((E,y)=>this.k(E,m=>c(m,y),l.token))).then(E=>{l.dispose(),this.a.flush();const y=E.some(m=>!!m&&!!m.limitHit);i({limitHit:this.b||y,messages:(0,S.$Rb)(E.map(m=>m?.message?Array.isArray(m.message)?m.message:[m.message]:[])),stats:{type:this.g}})},E=>{l.dispose();const y=(0,F.$2i)(E);$(new Error(y))})})}h(n){return s(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,r){const u=Array.isArray(n.ranges)?n.ranges:[n.ranges],l=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:u.slice(0,r),preview:{matches:l.slice(0,r),text:n.preview.text},uri:n.uri}}async k(n,r,u){const l=new A.$AK(this.d,n),i=[],$={report:E=>{if(!this.l(E))return;const y=n.folder.scheme===R.Schemas.file?(0,A.$BK)(()=>this.f.readdir(f.$Qg(E.uri))):void 0,m=f.$Tg(n.folder,E.uri);if(m){const I=l.includedInQuery(m,g.$nc(m),y);(0,L.$3g)(I)?i.push(I.then(d=>{d&&r(E)})):I&&r(E)}}},a=this.n(n),c=await this.e.provideTextSearchResults(h(this.d.contentPattern),a,$,u);return i.length&&await Promise.all(i),c}l(n){if(s(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const r=(0,A.$zK)(this.d.includePattern,n.includePattern),u=(0,A.$zK)(this.d.excludePattern,n.excludePattern),l={folder:k.URI.from(n.folder),excludes:u,includes:r,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$Pic=D;function h(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class v{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,r=>this.g(r))}add(n,r){this.d&&(this.b!==r||!f.$Kg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=r,this.d={resource:n.uri,results:[]}),this.d.results.push(p(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Qic=v;function p(t){return s(t)?{preview:{matches:(0,S.$2b)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,S.$2b)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function s(t){return!!t.preview}e.$Ric=s;class o{static{this.a=4e3}static{this.b=50}constructor(n,r){this.g=n,this.h=r,this.c=0,this.d=[],this.e=0}addItem(n,r){n&&this.j(n,r)}addItems(n,r){n&&this.k(n,r)}j(n,r){this.d.push(n),this.e+=r,this.l()}k(n,r){this.d=this.d.concat(n),this.e+=r,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Sic=o}),define(Ae[119],Me([1,0,6,3,4,287,17,58,14,2,292]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=e.$Uic=e.$Tic=void 0,e.$Tic=(0,P.$ei)("IExtHostSearch");let D=class{constructor(s,o,t){this.k=s,this.l=o,this.n=t,this.c=this.k.getProxy(L.$XL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new F.$Oic}o(s){return this.l.transformOutgoingScheme(s)}registerTextSearchProvider(s,o){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const t=this.d++;return this.e.set(t,o),this.c.$registerTextSearchProvider(t,this.o(s)),(0,S.$Rc)(()=>{this.g.delete(s),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(s,o){if(this.i.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.i.add(s);const t=this.d++;return this.h.set(t,o),this.c.$registerFileSearchProvider(t,this.o(s)),(0,S.$Rc)(()=>{this.i.delete(s),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(s,o,t,n){const r=h(t),u=this.h.get(s);if(u)return this.j.fileSearch(r,u,l=>{this.c.$handleFileMatch(s,o,l.map(i=>i.resource))},n);throw new Error("unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,o,t){return{messages:[]}}$clearCache(s){return this.j.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,o,t,n){const r=this.e.get(s);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const u=h(t);return this.q(u,r).search(i=>this.c.$handleTextMatch(s,o,i),n)}$enableExtensionHostSearch(){}q(s,o){return new A.$Pic(s,o,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$Uic=D,e.$Uic=D=Xe([qe(0,R.$dO),qe(1,g.$Nhc),qe(2,f.$yj)],D);function h(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(v),extraFileResources:p.extraFileResources&&p.extraFileResources.map(s=>k.URI.revive(s))}}e.$Vic=h;function v(p){return{...p,folder:k.URI.revive(p.folder)}}}),define(Ae[293],Me([1,0,21,15,5,6,12,32,2,147,143,131,92,22,42,14,56,57,199,3,240,271,78,241,247,225,248,249,250,226,214,31,251,37,252,118,108,253,228,242,254,255,66,64,243,38,257,62,258,43,27,272,273,244,229,259,260,79,80,231,286,262,203,263,274,264,113,232,265,266,267,17,268,119,81,269,233,270,82,84,116,60,65,275,276,245,277,278,85,8,7,234,58,235,61,279,280,107,36,209,77,23,115]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r,u,l,i,$,a,c,E,y,m,I,d,w,b,M,T,G,W,U,C,O,V,re,ce,ye,De,he,ve,se,$e,ee,Y,q,ne,Se,Te,Ce,be,ge,X,x,le,de,Pe,me,Ie,Le,ze,N,j,K,H,te,oe,Oe,Ve,He,xe,tt,lt,rt,it,ot,Be,et,Q,Z,pe,We,Ye,st,Fe,St,Kt,zt,Zt,Qt,It,Gt,Jt,_t,ri,Qe,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;function ei(ft){const vt=ft.get(Y.$tO),ti=ft.get(ee.$xhc),Wt=ft.get(se.$Vhc),Ut=ft.get(he.$sic),dt=ft.get(Jt.$Qhc),Pt=ft.get(ot.$xO),ii=ft.get(M.$Thc),xt=ft.get(Kt.$Nhc),Ke=ft.get(te.$dO),At=ft.get(lt.$cic),Bt=ft.get(rt.$Whc),si=ft.get(s.$zj),gt=ft.get(s.$yj),Lt=ft.get(Ye.$eAb),Ct=ft.get(i.$thc),Ot=ft.get(Gt.$xjc),ni=ft.get(Ve.$kic),Vt=ft.get(ye.$6hc),Tt=ft.get(X.$oic);Ke.set(r.$YL.ExtHostFileSystemInfo,ti),Ke.set(r.$YL.ExtHostLogLevelServiceShape,si),Ke.set(r.$YL.ExtHostWorkspace,dt),Ke.set(r.$YL.ExtHostConfiguration,ii),Ke.set(r.$YL.ExtHostExtensionService,Ut),Ke.set(r.$YL.ExtHostStorage,At),Ke.set(r.$YL.ExtHostTunnelService,Lt),Ke.set(r.$YL.ExtHostWindow,Ot),Ke.set(r.$YL.ExtHostSecretState,ni),Ke.set(r.$YL.ExtHostTelemetry,Pt),Ke.set(r.$YL.ExtHostEditorTabs,Vt),Ke.set(r.$YL.ExtHostManagedSockets,Tt);const Rt=Ke.set(r.$YL.ExtHostDecorations,ft.get(W.$Dic)),Dt=Ke.set(r.$YL.ExtHostDocumentsAndEditors,ft.get(ce.$oO)),$t=Ke.set(r.$YL.ExtHostCommands,ft.get(w.$zO)),kt=Ke.set(r.$YL.ExtHostTerminalService,ft.get(Be.$fic)),Et=Ke.set(r.$YL.ExtHostDebugService,ft.get(G.$xic)),ci=Ke.set(r.$YL.ExtHostSearch,ft.get(Oe.$Tic)),Xt=Ke.set(r.$YL.ExtHostTask,ft.get(it.$kjc)),pi=Ke.set(r.$YL.ExtHostOutputService,ft.get(ze.$0ic)),qt=Ke.set(r.$YL.ExtHostLocalization,ft.get(ge.$nic)),we=Ke.set(r.$YL.ExtHostUrls,new zt.$ujc(Ke)),Re=Ke.set(r.$YL.ExtHostDocuments,new re.$Ahc(Ke,Dt)),ue=Ke.set(r.$YL.ExtHostDocumentContentProviders,new O.$Fic(Ke,Dt,gt)),J=Ke.set(r.$YL.ExtHostDocumentSaveParticipant,new V.$Gic(gt,Re,Ke.getProxy(r.$XL.MainThreadBulkEdits))),Ee=Ke.set(r.$YL.ExtHostNotebook,new le.$Wic(Ke,$t,Dt,Re,Wt,ci)),Ue=Ke.set(r.$YL.ExtHostNotebookDocuments,new Pe.$4ic(Ee)),Ze=Ke.set(r.$YL.ExtHostNotebookEditors,new me.$5ic(gt,Ee)),Ge=Ke.set(r.$YL.ExtHostNotebookKernels,new Ie.$6ic(Ke,vt,Ee,$t,gt)),ct=Ke.set(r.$YL.ExtHostNotebookRenderers,new Le.$8ic(Ke,Ee)),wt=Ke.set(r.$YL.ExtHostNotebookDocumentSaveParticipant,new de.$3ic(gt,Ee,Ke.getProxy(r.$XL.MainThreadBulkEdits))),yt=Ke.set(r.$YL.ExtHostEditors,new Q.$Khc(Ke,Dt)),Yt=Ke.set(r.$YL.ExtHostTreeViews,new We.$sjc(Ke.getProxy(r.$XL.MainThreadTreeViews),$t,gt)),Mt=Ke.set(r.$YL.ExtHostEditorInsets,new d.$Lhc(Ke.getProxy(r.$XL.MainThreadEditorInsets),yt,vt.remote)),Nt=Ke.set(r.$YL.ExtHostDiagnostics,new U.$zhc(Ke,gt,ti,Dt)),vi=Ke.set(r.$YL.ExtHostLanguages,new be.$1ic(Ke,Re,$t.converter,xt)),ht=Ke.set(r.$YL.ExtHostLanguageFeatures,new Ce.$Bhc(Ke,xt,Re,$t,Nt,gt,Ct,Pt)),Zi=Ke.set(r.$YL.ExtHostFileSystem,new ve.$Iic(Ke,ht)),ui=Ke.set(r.$YL.ExtHostFileSystemEventService,new $e.$Jic(Ke,gt,Dt)),gi=Ke.set(r.$YL.ExtHostQuickOpen,(0,H.$bjc)(Ke,dt,$t)),yi=Ke.set(r.$YL.ExtHostSCM,new oe.$djc(Ke,$t,Re,gt)),Ri=Ke.set(r.$YL.ExtHostQuickDiff,new K.$ajc(Ke,xt)),Qi=Ke.set(r.$YL.ExtHostShare,new He.$ejc(Ke,xt)),hn=Ke.set(r.$YL.ExtHostComments,(0,b.$Mhc)(Ke,$t,Re)),Ai=Ke.set(r.$YL.ExtHostProgress,new j.$_ic(Ke.getProxy(r.$XL.MainThreadProgress))),Mi=Ke.set(r.$YL.ExtHostLabelService,new Te.$Zic(Ke)),Ei=Ke.set(r.$YL.ExtHostTheming,new Z.$pjc(Ke)),mi=Ke.set(r.$YL.ExtHostAuthentication,new $.$Dhc(Ke)),xi=Ke.set(r.$YL.ExtHostTimeline,new pe.$rjc(Ke,$t)),Di=Ke.set(r.$YL.ExtHostWebviews,new Zt.$1hc(Ke,vt.remote,dt,gt,Ct)),ki=Ke.set(r.$YL.ExtHostWebviewPanels,new Qt.$4hc(Ke,Di,dt)),_i=Ke.set(r.$YL.ExtHostCustomEditors,new T.$5hc(Ke,Re,Bt,Di,ki)),dn=Ke.set(r.$YL.ExtHostWebviewViews,new It.$vjc(Ke,Di)),bi=Ke.set(r.$YL.ExtHostTesting,new et.$ljc(Ke,gt,$t,Dt)),Li=Ke.set(r.$YL.ExtHostUriOpeners,new St.$tjc(Ke)),Fi=Ke.set(r.$YL.ExtHostProfileContentHandlers,new N.$$ic(Ke));Ke.set(r.$YL.ExtHostInteractive,new ne.$Xic(Ke,Ee,Dt,$t,gt));const fn=Ke.set(r.$YL.ExtHostInlineChat,new q.$Kic(Ke,$t,Re,gt)),Si=Ke.set(r.$YL.ExtHostChatProvider,new y.$Hhc(Ke,gt,mi)),en=Ke.set(r.$YL.ExtHostChatAgents2,new E.$Ghc(Ke,gt,$t)),gn=Ke.set(r.$YL.ExtHostChatVariables,new m.$Ihc(Ke)),wi=Ke.set(r.$YL.ExtHostChat,new c.$Fhc(Ke)),Oi=Ke.set(r.$YL.ExtHostAiRelatedInformation,new u.$shc(Ke)),tn=Ke.set(r.$YL.ExtHostAiEmbeddingVector,new De.$Hic(Ke)),Ti=Ke.set(r.$YL.ExtHostIssueReporter,new Se.$Yic(Ke)),nn=Ke.set(r.$YL.ExtHostStatusBar,new tt.$hjc(Ke,$t.converter)),Ni=Ke.set(r.$YL.ExtHostSpeech,new xe.$fjc(Ke)),rn=Object.values(r.$YL);Ke.assertRegistered(rn);const di=new a.$Ehc(Ke,Dt),Ii=new I.$Jhc(Ke),zi=new x.$2ic(Ke,gt),oi=new C.$Eic(Ke);return l.$Chc.register($t),function(Ne,li,ji){function nt(_){return(ae,je,at)=>{const bt=_(Ft=>{try{ae.call(je,Ft)}catch(Ji){L.$2(new Error(`[ExtensionListenerError] Extension '${Ne.identifier.value}' FAILED to handle event: ${Ji.toString()}`,{cause:Ji})),Pt.onExtensionError(Ne.identifier,Ji)}});return at?.push(bt),bt}}const pt=function(){let _=!Ne.isUnderDevelopment;function ae(){_||(gt.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function je(at){if(Array.isArray(at))at.forEach(je);else if(typeof at=="string")ae();else{const bt=at;typeof bt.scheme>"u"&&ae(),typeof bt.exclusive=="boolean"&&(0,Qe.$VF)(Ne,"documentFiltersExclusive")}return at}}(),mn={getSession(_,ae,je){return mi.getSession(Ne,_,ae,je)},getSessions(_,ae){return(0,Qe.$VF)(Ne,"authGetSessions"),mi.getSessions(Ne,_,ae)},async hasSession(_,ae){return(0,Qe.$VF)(Ne,"authSession"),!!await mi.getSession(Ne,_,ae,{silent:!0})},get onDidChangeSessions(){return nt(mi.onDidChangeSessions)},registerAuthenticationProvider(_,ae,je,at){return mi.registerAuthenticationProvider(_,ae,je,at)}},sn={registerCommand(_,ae,je){return $t.registerCommand(!0,_,ae,je,void 0,Ne)},registerTextEditorCommand(_,ae,je){return $t.registerCommand(!0,_,(...at)=>{const bt=yt.getActiveTextEditor();if(!bt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}return bt.edit(Ft=>{ae.apply(je,[bt,Ft,...at])}).then(Ft=>{Ft||gt.warn("Edits from command "+_+" were not applied.")},Ft=>{gt.warn("An error occurred while running command "+_,Ft)})},void 0,void 0,Ne)},registerDiffInformationCommand:(_,ae,je)=>((0,Qe.$VF)(Ne,"diffCommand"),$t.registerCommand(!0,_,async(...at)=>{const bt=Dt.activeEditor(!0);if(!bt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Ft=await yt.getDiffInformation(bt.id);ae.apply(je,[Ft,...at])},void 0,void 0,Ne)),executeCommand(_,...ae){return $t.executeCommand(_,...ae)},getCommands(_=!1){return $t.getCommands(_)}},Ui={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return Ii.value},get shell(){return kt.getDefaultShell(!1)},get onDidChangeShell(){return nt(kt.onDidChangeShell)},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Pt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Qe.$VF)(Ne,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Qe.$VF)(Ne,"telemetry"),nt(Pt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ot.$wO)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,ae){return ot.$vO.validateSender(_),Pt.instantiateLogger(Ne,_,ae)},openExternal(_,ae){return Ot.openUri(_,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===vt.environment.appUriScheme)return we.createAppUri(_);try{return await Ot.asExternalUri(_,{allowTunneling:!!vt.remote.authority})}catch(ae){if((0,R.$og)(_,R.Schemas.http)||(0,R.$og)(_,R.Schemas.https))return _;throw ae}},get remoteName(){return(0,o.$ml)(vt.remote.authority)},get remoteAuthority(){return(0,Qe.$VF)(Ne,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return nt(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler(_){return(0,Qe.$VF)(Ne,"handleIssueUri"),Ti.registerIssueUriRequestHandler(Ne,_)},registerIssueDataProvider(_){return(0,Qe.$VF)(Ne,"handleIssueUri"),Ti.registerIssueDataProvider(Ne,_)},get appQuality(){return(0,Qe.$VF)(Ne,"resolvers"),vt.quality},get appCommit(){return(0,Qe.$VF)(Ne,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(Ui);const $n={createTestController(_,ae,je){return bi.createTestController(Ne,_,ae,je)},createTestObserver(){return(0,Qe.$VF)(Ne,"testObserver"),bi.createTestObserver()},runTests(_){return(0,Qe.$VF)(Ne,"testObserver"),bi.runTests(_)},get onDidChangeTestResults(){return(0,Qe.$VF)(Ne,"testObserver"),nt(bi.onResultsChanged)},get testResults(){return(0,Qe.$VF)(Ne,"testObserver"),bi.results}},Ci=vt.remote.isRemote?Fe.ExtensionKind.Workspace:Fe.ExtensionKind.UI,on={getExtension(_,ae){(0,Qe.$UF)(Ne,"extensionsAny")||(ae=!1);const je=li.mine.getExtensionDescription(_);if(je)return new he.$tic(Ut,Ne.identifier,je,Ci,!1);if(ae){const at=li.all.getExtensionDescription(_);if(at)return new he.$tic(Ut,Ne.identifier,at,Ci,!0)}},get all(){const _=[];for(const ae of li.mine.getAllExtensionDescriptions())_.push(new he.$tic(Ut,Ne.identifier,ae,Ci,!1));return _},get allAcrossExtensionHosts(){(0,Qe.$VF)(Ne,"extensionsAny");const _=new v.$xm(li.mine.getAllExtensionDescriptions().map(je=>je.identifier)),ae=[];for(const je of li.all.getAllExtensionDescriptions()){const at=!_.has(je.identifier);ae.push(new he.$tic(Ut,Ne.identifier,je,Ci,at))}return ae},get onDidChange(){return(0,Qe.$UF)(Ne,"extensionsAny")?nt(P.Event.any(li.mine.onDidChange,li.all.onDidChange)):nt(li.mine.onDidChange)}},Bi={createDiagnosticCollection(_){return Nt.createDiagnosticCollection(Ne.identifier,_)},get onDidChangeDiagnostics(){return nt(Nt.onDidChangeDiagnostics)},getDiagnostics:_=>Nt.getDiagnostics(_),getLanguages(){return vi.getLanguages()},setTextDocumentLanguage(_,ae){return vi.changeLanguage(_.uri,ae)},match(_,ae){const je=st.LanguageSelector.from(_);let at;return(0,A.$Nt)(je)&&(at=Ee.notebookDocuments.find(bt=>!!bt.getCell(ae.uri))?.apiNotebook),(0,A.$Mt)(je,ae.uri,ae.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(_,ae,je){return ht.registerCodeActionProvider(Ne,pt(_),ae,je)},registerDocumentPasteEditProvider(_,ae,je){return(0,Qe.$VF)(Ne,"documentPaste"),ht.registerDocumentPasteEditProvider(Ne,pt(_),ae,je)},registerCodeLensProvider(_,ae){return ht.registerCodeLensProvider(Ne,pt(_),ae)},registerDefinitionProvider(_,ae){return ht.registerDefinitionProvider(Ne,pt(_),ae)},registerDeclarationProvider(_,ae){return ht.registerDeclarationProvider(Ne,pt(_),ae)},registerImplementationProvider(_,ae){return ht.registerImplementationProvider(Ne,pt(_),ae)},registerTypeDefinitionProvider(_,ae){return ht.registerTypeDefinitionProvider(Ne,pt(_),ae)},registerHoverProvider(_,ae){return ht.registerHoverProvider(Ne,pt(_),ae,Ne.identifier)},registerEvaluatableExpressionProvider(_,ae){return ht.registerEvaluatableExpressionProvider(Ne,pt(_),ae,Ne.identifier)},registerInlineValuesProvider(_,ae){return ht.registerInlineValuesProvider(Ne,pt(_),ae,Ne.identifier)},registerDocumentHighlightProvider(_,ae){return ht.registerDocumentHighlightProvider(Ne,pt(_),ae)},registerMultiDocumentHighlightProvider(_,ae){return ht.registerMultiDocumentHighlightProvider(Ne,pt(_),ae)},registerLinkedEditingRangeProvider(_,ae){return ht.registerLinkedEditingRangeProvider(Ne,pt(_),ae)},registerReferenceProvider(_,ae){return ht.registerReferenceProvider(Ne,pt(_),ae)},registerRenameProvider(_,ae){return ht.registerRenameProvider(Ne,pt(_),ae)},registerNewSymbolNamesProvider(_,ae){return(0,Qe.$VF)(Ne,"newSymbolNamesProvider"),ht.registerNewSymbolNamesProvider(Ne,pt(_),ae)},registerDocumentSymbolProvider(_,ae,je){return ht.registerDocumentSymbolProvider(Ne,pt(_),ae,je)},registerWorkspaceSymbolProvider(_){return ht.registerWorkspaceSymbolProvider(Ne,_)},registerDocumentFormattingEditProvider(_,ae){return ht.registerDocumentFormattingEditProvider(Ne,pt(_),ae)},registerDocumentRangeFormattingEditProvider(_,ae){return ht.registerDocumentRangeFormattingEditProvider(Ne,pt(_),ae)},registerOnTypeFormattingEditProvider(_,ae,je,...at){return ht.registerOnTypeFormattingEditProvider(Ne,pt(_),ae,[je].concat(at))},registerDocumentSemanticTokensProvider(_,ae,je){return ht.registerDocumentSemanticTokensProvider(Ne,pt(_),ae,je)},registerDocumentRangeSemanticTokensProvider(_,ae,je){return ht.registerDocumentRangeSemanticTokensProvider(Ne,pt(_),ae,je)},registerSignatureHelpProvider(_,ae,je,...at){return typeof je=="object"?ht.registerSignatureHelpProvider(Ne,pt(_),ae,je):ht.registerSignatureHelpProvider(Ne,pt(_),ae,typeof je>"u"?[]:[je,...at])},registerCompletionItemProvider(_,ae,...je){return ht.registerCompletionItemProvider(Ne,pt(_),ae,je)},registerInlineCompletionItemProvider(_,ae,je){return ae.handleDidShowCompletionItem&&(0,Qe.$VF)(Ne,"inlineCompletionsAdditions"),ae.handleDidPartiallyAcceptCompletionItem&&(0,Qe.$VF)(Ne,"inlineCompletionsAdditions"),je&&(0,Qe.$VF)(Ne,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ne,pt(_),ae,je)},registerInlineEditProvider(_,ae){return(0,Qe.$VF)(Ne,"inlineEdit"),ht.registerInlineEditProvider(Ne,pt(_),ae)},registerDocumentLinkProvider(_,ae){return ht.registerDocumentLinkProvider(Ne,pt(_),ae)},registerColorProvider(_,ae){return ht.registerColorProvider(Ne,pt(_),ae)},registerFoldingRangeProvider(_,ae){return ht.registerFoldingRangeProvider(Ne,pt(_),ae)},registerSelectionRangeProvider(_,ae){return ht.registerSelectionRangeProvider(Ne,_,ae)},registerCallHierarchyProvider(_,ae){return ht.registerCallHierarchyProvider(Ne,_,ae)},registerTypeHierarchyProvider(_,ae){return ht.registerTypeHierarchyProvider(Ne,_,ae)},setLanguageConfiguration:(_,ae)=>ht.setLanguageConfiguration(Ne,_,ae),getTokenInformationAtPosition(_,ae){return(0,Qe.$VF)(Ne,"tokenInformation"),vi.tokenAtPosition(_,ae)},registerInlayHintsProvider(_,ae){return ht.registerInlayHintsProvider(Ne,_,ae)},createLanguageStatusItem(_,ae){return vi.createLanguageStatusItem(Ne,_,ae)},registerDocumentDropEditProvider(_,ae,je){return ht.registerDocumentOnDropEditProvider(Ne,_,ae,(0,Qe.$UF)(Ne,"dropMetadata")?je:void 0)}},an={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return kt.activeTerminal},get terminals(){return kt.terminals},async showTextDocument(_,ae,je){f.URI.isUri(_)&&_.scheme===R.Schemas.vscodeRemote&&!_.authority&&Ct.report("workspace.showTextDocument",Ne,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(f.URI.isUri(_)?Promise.resolve(Vi.openTextDocument(_)):Promise.resolve(_));return yt.showTextDocument(at,ae,je)},createTextEditorDecorationType(_){return yt.createTextEditorDecorationType(Ne,_)},onDidChangeActiveTextEditor(_,ae,je){return nt(yt.onDidChangeActiveTextEditor)(_,ae,je)},onDidChangeVisibleTextEditors(_,ae,je){return nt(yt.onDidChangeVisibleTextEditors)(_,ae,je)},onDidChangeTextEditorSelection(_,ae,je){return nt(yt.onDidChangeTextEditorSelection)(_,ae,je)},onDidChangeTextEditorOptions(_,ae,je){return nt(yt.onDidChangeTextEditorOptions)(_,ae,je)},onDidChangeTextEditorVisibleRanges(_,ae,je){return nt(yt.onDidChangeTextEditorVisibleRanges)(_,ae,je)},onDidChangeTextEditorViewColumn(_,ae,je){return nt(yt.onDidChangeTextEditorViewColumn)(_,ae,je)},onDidCloseTerminal(_,ae,je){return nt(kt.onDidCloseTerminal)(_,ae,je)},onDidOpenTerminal(_,ae,je){return nt(kt.onDidOpenTerminal)(_,ae,je)},onDidChangeActiveTerminal(_,ae,je){return nt(kt.onDidChangeActiveTerminal)(_,ae,je)},onDidChangeTerminalDimensions(_,ae,je){return(0,Qe.$VF)(Ne,"terminalDimensions"),nt(kt.onDidChangeTerminalDimensions)(_,ae,je)},onDidChangeTerminalState(_,ae,je){return nt(kt.onDidChangeTerminalState)(_,ae,je)},onDidWriteTerminalData(_,ae,je){return(0,Qe.$VF)(Ne,"terminalDataWriteEvent"),nt(kt.onDidWriteTerminalData)(_,ae,je)},onDidExecuteTerminalCommand(_,ae,je){return(0,Qe.$VF)(Ne,"terminalExecuteCommandEvent"),nt(kt.onDidExecuteTerminalCommand)(_,ae,je)},get state(){return Ot.getState(Ne)},onDidChangeWindowState(_,ae,je){return nt(Ot.onDidChangeWindowState)(_,ae,je)},showInformationMessage(_,...ae){return zi.showMessage(Ne,g.default.Info,_,ae[0],ae.slice(1))},showWarningMessage(_,...ae){return zi.showMessage(Ne,g.default.Warning,_,ae[0],ae.slice(1))},showErrorMessage(_,...ae){return zi.showMessage(Ne,g.default.Error,_,ae[0],ae.slice(1))},showQuickPick(_,ae,je){return gi.showQuickPick(Ne,_,ae,je)},showWorkspaceFolderPick(_){return gi.showWorkspaceFolderPick(_)},showInputBox(_,ae){return gi.showInput(_,ae)},showOpenDialog(_){return oi.showOpenDialog(Ne,_)},showSaveDialog(_){return oi.showSaveDialog(_)},createStatusBarItem(_,ae,je){let at,bt,Ft;return typeof _=="string"?(at=_,bt=ae,Ft=je):(bt=_,Ft=ae),nn.createStatusBarEntry(Ne,at,bt,Ft)},setStatusBarMessage(_,ae){return nn.setStatusBarMessage(_,ae)},withScmProgress(_){return Ct.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),Ai.withProgress(Ne,{location:Fe.ProgressLocation.SourceControl},(ae,je)=>_({report(at){}}))},withProgress(_,ae){return Ai.withProgress(Ne,_,ae)},createOutputChannel(_,ae){return pi.createOutputChannel(_,ae,Ne)},createWebviewPanel(_,ae,je,at){return ki.createWebviewPanel(Ne,_,ae,je,at)},createWebviewTextEditorInset(_,ae,je,at){return(0,Qe.$VF)(Ne,"editorInsets"),Mt.createWebviewEditorInset(_,ae,je,at,Ne)},createTerminal(_,ae,je){return typeof _=="object"?"pty"in _?kt.createExtensionTerminal(_):kt.createTerminalFromOptions(_):kt.createTerminal(_,ae,je)},registerTerminalLinkProvider(_){return kt.registerLinkProvider(_)},registerTerminalProfileProvider(_,ae){return kt.registerProfileProvider(Ne,_,ae)},registerTerminalQuickFixProvider(_,ae){return(0,Qe.$VF)(Ne,"terminalQuickFixProvider"),kt.registerTerminalQuickFixProvider(_,Ne.identifier.value,ae)},registerTreeDataProvider(_,ae){return Yt.registerTreeDataProvider(_,ae,Ne)},createTreeView(_,ae){return Yt.createTreeView(_,ae,Ne)},registerWebviewPanelSerializer:(_,ae)=>ki.registerWebviewPanelSerializer(Ne,_,ae),registerCustomEditorProvider:(_,ae,je={})=>_i.registerCustomEditorProvider(Ne,_,ae,je),registerFileDecorationProvider(_){return Rt.registerFileDecorationProvider(_,Ne)},registerUriHandler(_){return we.registerUriHandler(Ne,_)},createQuickPick(){return gi.createQuickPick(Ne)},createInputBox(){return gi.createInputBox(Ne)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme(_,ae,je){return nt(Ei.onDidChangeActiveColorTheme)(_,ae,je)},registerWebviewViewProvider(_,ae,je){return dn.registerWebviewViewProvider(Ne,_,ae,je?.webviewOptions)},get activeNotebookEditor(){return Ee.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,ae,je){return nt(Ee.onDidChangeActiveNotebookEditor)(_,ae,je)},get visibleNotebookEditors(){return Ee.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(Ee.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,ae,je){return nt(Ze.onDidChangeNotebookEditorSelection)(_,ae,je)},onDidChangeNotebookEditorVisibleRanges(_,ae,je){return nt(Ze.onDidChangeNotebookEditorVisibleRanges)(_,ae,je)},showNotebookDocument(_,ae){return Ee.showNotebookDocument(_,ae)},registerExternalUriOpener(_,ae,je){return(0,Qe.$VF)(Ne,"externalUriOpener"),Li.registerExternalUriOpener(Ne.identifier,_,ae,je)},registerProfileContentHandler(_,ae){return(0,Qe.$VF)(Ne,"profileContentHandlers"),Fi.registerProfileContentHandler(Ne,_,ae)},registerQuickDiffProvider(_,ae,je,at){return(0,Qe.$VF)(Ne,"quickDiffProvider"),Ri.registerQuickDiffProvider(pt(_),ae,je,at)},get tabGroups(){return Vt.tabGroups},registerShareProvider(_,ae){return(0,Qe.$VF)(Ne,"shareProvider"),Qi.registerShareProvider(pt(_),ae)}},Vi={get rootPath(){return Ct.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(_){throw new L.$9("rootPath")},getWorkspaceFolder(_){return dt.getWorkspaceFolder(_)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(_){throw new L.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(_){throw new L.$9("workspaceFile")},updateWorkspaceFolders:(_,ae,...je)=>dt.updateWorkspaceFolders(Ne,_,ae||0,...je),onDidChangeWorkspaceFolders:function(_,ae,je){return nt(dt.onDidChangeWorkspace)(_,ae,je)},asRelativePath:(_,ae)=>dt.getRelativePath(_,ae),findFiles:(_,ae,je,at)=>dt.findFiles(_,ae,je,Ne.identifier,at),findFiles2:(_,ae,je)=>((0,Qe.$VF)(Ne,"findFiles2"),dt.findFiles2(_,ae,Ne.identifier,je)),findTextInFiles:(_,ae,je,at)=>{(0,Qe.$VF)(Ne,"findTextInFiles");let bt,Ft;return typeof ae=="object"?(bt=ae,Ft=je):(bt={},Ft=ae,at=je),dt.findTextInFiles(_,bt||{},Ft,Ne.identifier,at)},save:_=>dt.save(_),saveAs:_=>dt.saveAs(_),saveAll:_=>dt.saveAll(_),applyEdit(_,ae){return di.applyWorkspaceEdit(_,Ne,ae)},createFileSystemWatcher:(_,ae,je,at)=>{let bt;return typeof ae=="boolean"?bt={ignoreCreateEvents:!!ae,ignoreChangeEvents:!!je,ignoreDeleteEvents:!!at,correlate:!1}:ae&&((0,Qe.$VF)(Ne,"createFileSystemWatcher"),bt={...ae,correlate:!0}),ui.createFileSystemWatcher(dt,Ne,_,bt)},get textDocuments(){return Re.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new L.$9("textDocuments")},openTextDocument(_){let ae;const je=_;if(typeof _=="string")ae=Promise.resolve(f.URI.file(_));else if(f.URI.isUri(_))ae=Promise.resolve(_);else if(!je||typeof je=="object")ae=Re.createDocumentData(je);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(at=>(at.scheme===R.Schemas.vscodeRemote&&!at.authority&&Ct.report("workspace.openTextDocument",Ne,"A URI of 'vscode-remote' scheme requires an authority."),Re.ensureDocumentData(at).then(bt=>bt.document)))},onDidOpenTextDocument:(_,ae,je)=>nt(Re.onDidAddDocument)(_,ae,je),onDidCloseTextDocument:(_,ae,je)=>nt(Re.onDidRemoveDocument)(_,ae,je),onDidChangeTextDocument:(_,ae,je)=>nt(Re.onDidChangeDocument)(_,ae,je),onDidSaveTextDocument:(_,ae,je)=>nt(Re.onDidSaveDocument)(_,ae,je),onWillSaveTextDocument:(_,ae,je)=>nt(J.getOnWillSaveTextDocumentEvent(Ne))(_,ae,je),get notebookDocuments(){return Ee.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,ae){let je;if(f.URI.isUri(_))je=_,await Ee.openNotebookDocument(_);else if(typeof _=="string")je=f.URI.revive(await Ee.createNotebookDocument({viewType:_,content:ae}));else throw new Error("Invalid arguments");return Ee.getNotebookDocument(je).apiNotebook},onDidSaveNotebookDocument(_,ae,je){return nt(Ue.onDidSaveNotebookDocument)(_,ae,je)},onDidChangeNotebookDocument(_,ae,je){return nt(Ue.onDidChangeNotebookDocument)(_,ae,je)},onWillSaveNotebookDocument(_,ae,je){return nt(wt.getOnWillSaveNotebookDocumentEvent(Ne))(_,ae,je)},get onDidOpenNotebookDocument(){return nt(Ee.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(Ee.onDidCloseNotebookDocument)},registerNotebookSerializer(_,ae,je,at){return Ee.registerNotebookSerializer(Ne,_,ae,je,(0,Qe.$UF)(Ne,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(_,ae,je)=>nt(ji.onDidChangeConfiguration)(_,ae,je),getConfiguration(_,ae){return ae=arguments.length===1?void 0:ae,ji.getConfiguration(_,ae,Ne)},registerTextDocumentContentProvider(_,ae){return ue.registerTextDocumentContentProvider(_,ae)},registerTaskProvider:(_,ae)=>(Ct.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Xt.registerTaskProvider(Ne,_,ae)),registerFileSystemProvider(_,ae,je){return(0,F.$Qc)(Zi.registerFileSystemProvider(Ne,_,ae,je),Wt.addFileSystemProvider(_,ae,je))},get fs(){return Wt.value},registerFileSearchProvider:(_,ae)=>((0,Qe.$VF)(Ne,"fileSearchProvider"),ci.registerFileSearchProvider(_,ae)),registerTextSearchProvider:(_,ae)=>((0,Qe.$VF)(Ne,"textSearchProvider"),ci.registerTextSearchProvider(_,ae)),registerRemoteAuthorityResolver:(_,ae)=>((0,Qe.$VF)(Ne,"resolvers"),Ut.registerRemoteAuthorityResolver(_,ae)),registerResourceLabelFormatter:_=>((0,Qe.$VF)(Ne,"resolvers"),Mi.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Qe.$VF)(Ne,"resolvers"),Ut.getRemoteExecServer(_)),onDidCreateFiles:(_,ae,je)=>nt(ui.onDidCreateFile)(_,ae,je),onDidDeleteFiles:(_,ae,je)=>nt(ui.onDidDeleteFile)(_,ae,je),onDidRenameFiles:(_,ae,je)=>nt(ui.onDidRenameFile)(_,ae,je),onWillCreateFiles:(_,ae,je)=>nt(ui.getOnWillCreateFileEvent(Ne))(_,ae,je),onWillDeleteFiles:(_,ae,je)=>nt(ui.getOnWillDeleteFileEvent(Ne))(_,ae,je),onWillRenameFiles:(_,ae,je)=>nt(ui.getOnWillRenameFileEvent(Ne))(_,ae,je),openTunnel:_=>((0,Qe.$VF)(Ne,"tunnels"),Lt.openTunnel(Ne,_).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,Qe.$VF)(Ne,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(_,ae,je)=>((0,Qe.$VF)(Ne,"tunnels"),nt(Lt.onDidChangeTunnels)(_,ae,je)),registerPortAttributesProvider:(_,ae)=>((0,Qe.$VF)(Ne,"portsAttributes"),Lt.registerPortsAttributesProvider(_,ae)),registerTunnelProvider:(_,ae)=>((0,Qe.$VF)(Ne,"tunnelFactory"),Lt.registerTunnelProvider(_,ae)),registerTimelineProvider:(_,ae)=>((0,Qe.$VF)(Ne,"timeline"),xi.registerTimelineProvider(_,ae,Ne.identifier,$t.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:_=>((0,Qe.$VF)(Ne,"workspaceTrust"),dt.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,ae,je)=>nt(dt.onDidGrantWorkspaceTrust)(_,ae,je),registerEditSessionIdentityProvider:(_,ae)=>((0,Qe.$VF)(Ne,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(_,ae)),onWillCreateEditSessionIdentity:(_,ae,je)=>((0,Qe.$VF)(Ne,"editSessionIdentityProvider"),nt(dt.getOnWillCreateEditSessionIdentityEvent(Ne))(_,ae,je)),registerCanonicalUriProvider:(_,ae)=>((0,Qe.$VF)(Ne,"canonicalUriProvider"),dt.registerCanonicalUriProvider(_,ae)),getCanonicalUri:(_,ae,je)=>((0,Qe.$VF)(Ne,"canonicalUriProvider"),dt.provideCanonicalUri(_,ae,je))},cn={get inputBox(){return Ct.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(Ne)},createSourceControl(_,ae,je){return yi.createSourceControl(Ne,_,ae,je)}},pn={createCommentController(_,ae){return hn.createCommentController(Ne,_,ae)}},vn={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get stackFrameFocus(){return Et.stackFrameFocus},registerDebugVisualizationProvider(_,ae){return(0,Qe.$VF)(Ne,"debugVisualization"),Et.registerDebugVisualizationProvider(Ne,_,ae)},registerDebugVisualizationTreeProvider(_,ae){return(0,Qe.$VF)(Ne,"debugVisualization"),Et.registerDebugVisualizationTree(Ne,_,ae)},onDidStartDebugSession(_,ae,je){return nt(Et.onDidStartDebugSession)(_,ae,je)},onDidTerminateDebugSession(_,ae,je){return nt(Et.onDidTerminateDebugSession)(_,ae,je)},onDidChangeActiveDebugSession(_,ae,je){return nt(Et.onDidChangeActiveDebugSession)(_,ae,je)},onDidReceiveDebugSessionCustomEvent(_,ae,je){return nt(Et.onDidReceiveDebugSessionCustomEvent)(_,ae,je)},onDidChangeBreakpoints(_,ae,je){return nt(Et.onDidChangeBreakpoints)(_,ae,je)},onDidChangeStackFrameFocus(_,ae,je){return(0,Qe.$VF)(Ne,"debugFocus"),nt(Et.onDidChangeStackFrameFocus)(_,ae,je)},registerDebugConfigurationProvider(_,ae,je){return Et.registerDebugConfigurationProvider(_,ae,je||_t.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,ae){return Et.registerDebugAdapterDescriptorFactory(Ne,_,ae)},registerDebugAdapterTrackerFactory(_,ae){return Et.registerDebugAdapterTrackerFactory(_,ae)},startDebugging(_,ae,je){return!je||typeof je=="object"&&"configuration"in je?Et.startDebugging(_,ae,{parentSession:je}):Et.startDebugging(_,ae,je||{})},stopDebugging(_){return Et.stopDebugging(_)},addBreakpoints(_){return Et.addBreakpoints(_)},removeBreakpoints(_){return Et.removeBreakpoints(_)},asDebugSourceUri(_,ae){return Et.asDebugSourceUri(_,ae)}},un={registerTaskProvider:(_,ae)=>Xt.registerTaskProvider(Ne,_,ae),fetchTasks:_=>Xt.fetchTasks(_),executeTask:_=>Xt.executeTask(Ne,_),get taskExecutions(){return Xt.taskExecutions},onDidStartTask:(_,ae,je)=>nt(Xt.onDidStartTask)(_,ae,je),onDidEndTask:(_,ae,je)=>nt(Xt.onDidEndTask)(_,ae,je),onDidStartTaskProcess:(_,ae,je)=>nt(Xt.onDidStartTaskProcess)(_,ae,je),onDidEndTaskProcess:(_,ae,je)=>nt(Xt.onDidEndTaskProcess)(_,ae,je)},ln={createNotebookController(_,ae,je,at,bt){return Ge.createNotebookController(Ne,_,ae,je,at,(0,Qe.$UF)(Ne,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(_,ae)=>Ee.registerNotebookCellStatusBarItemProvider(Ne,_,ae),createRendererMessaging(_){return ct.createRendererMessaging(Ne,_)},createNotebookControllerDetectionTask(_){return(0,Qe.$VF)(Ne,"notebookKernelSource"),Ge.createNotebookControllerDetectionTask(Ne,_)},registerKernelSourceActionProvider(_,ae){return(0,Qe.$VF)(Ne,"notebookKernelSource"),Ge.registerKernelSourceActionProvider(Ne,_,ae)},onDidChangeNotebookCellExecutionState(_,ae,je){return(0,Qe.$VF)(Ne,"notebookCellExecutionState"),nt(Ge.onDidChangeNotebookCellExecutionState)(_,ae,je)}},Wi={t(..._){if(typeof _[0]=="string"){const ae=_.shift(),je=!_||typeof _[0]!="object"?_:_[0];return qt.getMessage(Ne.identifier.value,{message:ae,args:je})}return qt.getMessage(Ne.identifier.value,_[0])},get bundle(){return qt.getBundle(Ne.identifier.value)},get uri(){return qt.getBundleUri(Ne.identifier.value)}},qi={_version:1,registerInteractiveEditorSessionProvider(_,ae){return(0,Qe.$VF)(Ne,"interactive"),fn.registerProvider(Ne,_,ae)},registerInteractiveSessionProvider(_,ae){return(0,Qe.$VF)(Ne,"interactive"),wi.registerChatProvider(Ne,_,ae)},sendInteractiveRequestToProvider(_,ae){return(0,Qe.$VF)(Ne,"interactive"),wi.sendInteractiveRequestToProvider(_,ae)},transferChatSession(_,ae){return(0,Qe.$VF)(Ne,"interactive"),wi.transferChatSession(_,ae)}},Hi={getRelatedInformation(_,ae){return(0,Qe.$VF)(Ne,"aiRelatedInformation"),Oi.getRelatedInformation(Ne,_,ae)},registerRelatedInformationProvider(_,ae){return(0,Qe.$VF)(Ne,"aiRelatedInformation"),Oi.registerRelatedInformationProvider(Ne,_,ae)},registerEmbeddingVectorProvider(_,ae){return(0,Qe.$VF)(Ne,"aiRelatedInformation"),tn.registerEmbeddingVectorProvider(Ne,_,ae)}},Pi={registerChatResponseProvider(_,ae,je){return(0,Qe.$VF)(Ne,"chatProvider"),Si.registerLanguageModel(Ne,_,ae,je)},registerVariable(_,ae,je){return(0,Qe.$VF)(Ne,"chatAgents2"),gn.registerVariableResolver(Ne,_,ae,je)},registerMappedEditsProvider(_,ae){return(0,Qe.$VF)(Ne,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ne,_,ae)},createChatAgent(_,ae){return(0,Qe.$VF)(Ne,"chatAgents2"),en.createChatAgent(Ne,_,ae)}},Ki={requestLanguageModelAccess(_,ae){return(0,Qe.$VF)(Ne,"languageModels"),Si.requestLanguageModelAccess(Ne,_,ae)},get languageModels(){return(0,Qe.$VF)(Ne,"languageModels"),Si.getLanguageModelIds()},onDidChangeLanguageModels:(_,ae,je)=>((0,Qe.$VF)(Ne,"languageModels"),Si.onDidChangeProviders(_,ae,je))},Gi={registerSpeechProvider(_,ae){return(0,Qe.$VF)(Ne,"speech"),Ni.registerProvider(Ne.identifier,_,ae)}};return{version:vt.version,ai:Hi,authentication:mn,commands:sn,comments:pn,chat:Pi,debug:vn,env:Ui,extensions:on,interactive:qi,l10n:Wi,languages:Bi,lm:Ki,notebooks:ln,scm:cn,speech:Gi,tasks:un,tests:$n,window:an,workspace:Vi,Breakpoint:Fe.$YM,TerminalOutputAnchor:Fe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Fe.ChatAgentResultFeedbackKind,ChatVariableLevel:Fe.ChatVariableLevel,ChatAgentCompletionItem:Fe.$RN,CallHierarchyIncomingCall:Fe.$lM,CallHierarchyItem:Fe.$kM,CallHierarchyOutgoingCall:Fe.$mM,CancellationError:L.$5,CancellationTokenSource:S.$ce,CandidatePortSource:r.CandidatePortSource,CodeAction:Fe.$hM,CodeActionKind:Fe.$iM,CodeActionTriggerKind:Fe.CodeActionTriggerKind,CodeLens:Fe.$nM,Color:Fe.$AM,ColorInformation:Fe.$BM,ColorPresentation:Fe.$CM,ColorThemeKind:Fe.ColorThemeKind,CommentMode:Fe.CommentMode,CommentState:Fe.CommentState,CommentThreadCollapsibleState:Fe.CommentThreadCollapsibleState,CommentThreadState:Fe.CommentThreadState,CompletionItem:Fe.$uM,CompletionItemKind:Fe.CompletionItemKind,CompletionItemTag:Fe.CompletionItemTag,CompletionList:Fe.$vM,CompletionTriggerKind:Fe.CompletionTriggerKind,ConfigurationTarget:Fe.ConfigurationTarget,CustomExecution:Fe.$KM,DebugAdapterExecutable:Fe.$3M,DebugAdapterInlineImplementation:Fe.$6M,DebugAdapterNamedPipeServer:Fe.$5M,DebugAdapterServer:Fe.$4M,DebugConfigurationProviderTriggerKind:_t.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Fe.DebugConsoleMode,DebugVisualization:Fe.$jN,DecorationRangeBehavior:Fe.DecorationRangeBehavior,Diagnostic:Fe.$bM,DiagnosticRelatedInformation:Fe.$aM,DiagnosticSeverity:Fe.DiagnosticSeverity,DiagnosticTag:Fe.DiagnosticTag,Disposable:Fe.$ZL,DocumentHighlight:Fe.$dM,DocumentHighlightKind:Fe.DocumentHighlightKind,MultiDocumentHighlight:Fe.$eM,DocumentLink:Fe.$zM,DocumentSymbol:Fe.$gM,EndOfLine:Fe.EndOfLine,EnvironmentVariableMutatorType:Fe.EnvironmentVariableMutatorType,EvaluatableExpression:Fe.$9M,InlineValueText:Fe.$0M,InlineValueVariableLookup:Fe.$$M,InlineValueEvaluatableExpression:Fe.$_M,InlineCompletionTriggerKind:Fe.InlineCompletionTriggerKind,EventEmitter:P.$5d,ExtensionKind:Fe.ExtensionKind,ExtensionMode:Fe.ExtensionMode,ExternalUriOpenerPriority:Fe.ExternalUriOpenerPriority,FileChangeType:Fe.FileChangeType,FileDecoration:Fe.$lN,FileDecoration2:Fe.$lN,FileSystemError:Fe.$cN,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Fe.$dN,FoldingRangeKind:Fe.FoldingRangeKind,FunctionBreakpoint:Fe.$1M,InlineCompletionItem:Fe.$wM,InlineCompletionList:Fe.$xM,Hover:Fe.$cM,IndentAction:D.IndentAction,Location:Fe.$_L,MarkdownString:Fe.$oM,OverviewRulerLane:h.OverviewRulerLane,ParameterInformation:Fe.$pM,PortAutoForwardAction:Fe.PortAutoForwardAction,Position:Fe.$1L,ProcessExecution:Fe.$IM,ProgressLocation:Fe.ProgressLocation,QuickInputButtons:Fe.$kN,Range:Fe.$2L,RelativePattern:Fe.$WM,Selection:Fe.$3L,SelectionRange:Fe.$jM,SemanticTokens:Fe.$gN,SemanticTokensBuilder:Fe.$fN,SemanticTokensEdit:Fe.$hN,SemanticTokensEdits:Fe.$iN,SemanticTokensLegend:Fe.$eN,ShellExecution:Fe.$JM,ShellQuoting:Fe.ShellQuoting,SignatureHelp:Fe.$rM,SignatureHelpTriggerKind:Fe.SignatureHelpTriggerKind,SignatureInformation:Fe.$qM,SnippetString:Fe.$$L,SourceBreakpoint:Fe.$ZM,StandardTokenType:Fe.StandardTokenType,StatusBarAlignment:Fe.StatusBarAlignment,SymbolInformation:Fe.$fM,SymbolKind:Fe.SymbolKind,SymbolTag:Fe.SymbolTag,Task:Fe.$LM,TaskGroup:Fe.$HM,TaskPanelKind:Fe.TaskPanelKind,TaskRevealKind:Fe.TaskRevealKind,TaskScope:Fe.TaskScope,TerminalLink:Fe.$DM,TerminalQuickFixTerminalCommand:Fe.$FM,TerminalQuickFixOpener:Fe.$EM,TerminalLocation:Fe.TerminalLocation,TerminalProfile:Fe.$GM,TerminalExitReason:Fe.TerminalExitReason,TextDocumentSaveReason:Fe.TextDocumentSaveReason,TextEdit:Fe.$7L,SnippetTextEdit:Fe.$9L,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Fe.TextEditorLineNumbersStyle,TextEditorRevealType:Fe.TextEditorRevealType,TextEditorSelectionChangeKind:Fe.TextEditorSelectionChangeKind,SyntaxTokenType:Fe.SyntaxTokenType,TextDocumentChangeReason:Fe.TextDocumentChangeReason,ThemeColor:Fe.$VM,ThemeIcon:Fe.$UM,TreeItem:Fe.$MM,TreeItemCheckboxState:Fe.TreeItemCheckboxState,TreeItemCollapsibleState:Fe.TreeItemCollapsibleState,TypeHierarchyItem:Fe.$GN,UIKind:ri.UIKind,Uri:f.URI,ViewColumn:Fe.ViewColumn,WorkspaceEdit:Fe.$0L,DocumentDropEdit:Fe.$SM,DocumentPasteEdit:Fe.$TM,InlayHint:Fe.$tM,InlayHintLabelPart:Fe.$sM,InlayHintKind:Fe.InlayHintKind,RemoteAuthorityResolverError:Fe.$6L,ResolvedAuthority:Fe.$4L,ManagedResolvedAuthority:Fe.$5L,SourceControlInputBoxValidationType:Fe.SourceControlInputBoxValidationType,ExtensionRuntime:Fe.ExtensionRuntime,TimelineItem:Fe.$vN,NotebookRange:Fe.$nN,NotebookCellKind:Fe.NotebookCellKind,NotebookCellExecutionState:Fe.NotebookCellExecutionState,NotebookCellData:Fe.$oN,NotebookData:Fe.$pN,NotebookRendererScript:Fe.$tN,NotebookCellStatusBarAlignment:Fe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Fe.NotebookEditorRevealType,NotebookCellOutput:Fe.$rN,NotebookCellOutputItem:Fe.$qN,NotebookCellStatusBarItem:Fe.$sN,NotebookControllerAffinity:Fe.NotebookControllerAffinity,NotebookControllerAffinity2:Fe.NotebookControllerAffinity2,NotebookEdit:Fe.$8L,NotebookKernelSourceAction:Fe.$uN,NotebookVariablesRequestKind:Fe.NotebookVariablesRequestKind,PortAttributes:Fe.$xN,LinkedEditingRanges:Fe.$wN,TestResultState:Fe.TestResultState,TestRunRequest:Fe.$yN,TestMessage:Fe.$zN,TestTag:Fe.$AN,TestRunProfileKind:Fe.TestRunProfileKind,TextSearchCompleteMessageType:jt.TextSearchCompleteMessageType,DataTransfer:Fe.$RM,DataTransferItem:Fe.$NM,CoveredCount:Fe.$BN,FileCoverage:Fe.$CN,StatementCoverage:Fe.$DN,BranchCoverage:Fe.$EN,DeclarationCoverage:Fe.$FN,FunctionCoverage:Fe.$FN,WorkspaceTrustState:Fe.WorkspaceTrustState,LanguageStatusSeverity:Fe.LanguageStatusSeverity,QuickPickItemKind:Fe.QuickPickItemKind,InputBoxValidationSeverity:Fe.InputBoxValidationSeverity,TabInputText:Fe.$HN,TabInputTextDiff:Fe.$IN,TabInputTextMerge:Fe.$JN,TabInputCustom:Fe.$KN,TabInputNotebook:Fe.$MN,TabInputNotebookDiff:Fe.$NN,TabInputWebview:Fe.$LN,TabInputTerminal:Fe.$ON,TabInputInteractiveWindow:Fe.$PN,TabInputChat:Fe.$QN,TelemetryTrustedValue:t.$Wo,LogLevel:s.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Fe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Fe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Fe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Fe.$7M,ThreadFocus:Fe.$8M,RelatedInformationType:Fe.RelatedInformationType,SpeechToTextStatus:Fe.SpeechToTextStatus,KeywordRecognitionStatus:Fe.KeywordRecognitionStatus,ChatResponseTextPart:Fe.$SN,ChatResponseMarkdownPart:Fe.$TN,ChatResponseFileTreePart:Fe.$UN,ChatResponseAnchorPart:Fe.$VN,ChatResponseProgressPart:Fe.$WN,ChatResponseReferencePart:Fe.$YN,ChatResponseCommandButtonPart:Fe.$XN,ChatAgentRequestTurn:Fe.$ZN,ChatAgentResponseTurn:Fe.$1N,LanguageModelSystemMessage:Fe.$2N,LanguageModelUserMessage:Fe.$3N,LanguageModelAssistantMessage:Fe.$4N,NewSymbolName:Fe.$bN,NewSymbolNameTag:Fe.NewSymbolNameTag,InlineEdit:Fe.$5N,InlineEditTriggerKind:Fe.InlineEditTriggerKind}}}e.$yjc=ei}),define(Ae[294],Me([1,0,53,113,36,108,37,31,66,65,116,118,119,82,85,78,107,62,43,81,60,64,230,14,117,79,80]),function(fe,e,S,L,P,F,R,g,f,k,A,D,h,v,p,s,o,t,n,r,u,l,i,$,a,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$0r)(c.$nic,c.$mic,1),(0,S.$0r)($.$zj,i.$zjc,1),(0,S.$0r)(s.$thc,s.$uhc,1),(0,S.$0r)(g.$zO,g.$yO,0),(0,S.$0r)(R.$Thc,R.$Rhc,0),(0,S.$0r)(t.$Vhc,t.$Uhc,0),(0,S.$0r)(D.$xic,D.$Bic,0),(0,S.$0r)(F.$Dic,F.$Cic,0),(0,S.$0r)(f.$oO,f.$nO,0),(0,S.$0r)(E.$oic,E.$pic,0),(0,S.$0r)(n.$xhc,n.$whc,0),(0,S.$0r)(L.$0ic,L.$9ic,1),(0,S.$0r)(h.$Tic,h.$Uic,0),(0,S.$0r)(v.$cic,v.$bic,0),(0,S.$0r)(A.$kjc,A.$jjc,0),(0,S.$0r)(k.$fic,k.$iic,0),(0,S.$0r)(p.$eAb,p.$fAb,0),(0,S.$0r)(o.$xjc,o.$wjc,0),(0,S.$0r)(P.$Qhc,P.$Phc,0),(0,S.$0r)(r.$kic,r.$jic,0),(0,S.$0r)(u.$xO,u.$uO,0),(0,S.$0r)(l.$6hc,l.$7hc,0),(0,S.$0r)(a.$vic,a.$wic,0)}),define(Ae[295],Me([1,0,293,38,2,290,7,11,236]),function(fe,e,S,L,P,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;class k extends F.$Cjc{j(){}getModule(v,p){for(const s of this.b){const o=s(v);if(o){v=o;break}}if(this.a.has(v))return this.a.get(v).load(v,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends L.$ric{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(f.$Ilc);const v=this.h.invokeFunction(S.$yjc);this.r=this.h.createInstance(k,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(v){return v.browser}async vb(v,p,s){p=p.with({path:D(p.path,".js")});const o=v?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const t=P.URI.revive(await this.C.$asBrowserUri(p)),n=await fetch(t.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const r=await n.text(),u=`${p.toString(!0)}#vscode-extension`,l=`${r}
//# sourceURL=${u}`;let i;try{i=new Function("module","exports","require",l)}catch(E){throw console.error(o?`Loading code for extension ${o} failed: ${E.message}`:`Loading code failed: ${E.message}`),console.error(`${p.toString(!0)}${typeof E.line=="number"?` line ${E.line}`:""}${typeof E.column=="number"?` column ${E.column}`:""}`),console.error(E),E}v&&await this.w.initializeLocalizedMessages(v);const $={},a={exports:$},c=E=>{const y=this.r.getModule(E,p);if(y===void 0)throw new Error(`Cannot load module '${E}'`);return y};try{return s.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(a,$,c),a.exports!==$?a.exports:$}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}}async $setRemoteEnvironment(v){}async zb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+v;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,g.$fh)(10)}}e.$Jlc=A;function D(h,v){return h.endsWith(v)?h:h+v}}),define(Ae[296],Me([1,0,70,53,14,38,201,84,295]),function(fe,e,S,L,P,F,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.$0r)(P.$yj,new S.$bi(R.$Bjc,[!0],!0)),(0,L.$0r)(F.$sic,f.$Jlc,0),(0,L.$0r)(g.$Whc,g.$Xhc,0)}),define(Ae[301],Me([1,0,24,5,77,291,238,19,87,12,2,294,296]),function(fe,e,S,L,P,F,R,g,f,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(i){return/^(file|vscode-remote):/i.test(i)}const p=fetch.bind(self);function s(i){self.fetch=async function($,a){return $ instanceof Request||v(String($))&&($=(await i(A.URI.parse(String($)))).toString(!0)),p($,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open($,a,c,E,y){(async()=>(v(a.toString())&&(a=(await i(A.URI.parse(a.toString()))).toString(!0)),super.open($,a,c??!0,E,y)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function($,a){if(/^file:/i.test($.toString()))$=k.$yg.uriToBrowserUri(A.URI.parse($.toString())).toString(!0);else if(/^vscode-remote:/i.test($.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const E=`(${function(d){function w(T){return typeof T=="string"||T instanceof URL?String(T).replace(/^file:\/\//i,"vscode-file://vscode-app"):T}const b=fetch.bind(self);self.fetch=function(T,G){return T instanceof Request?b(T,G):b(w(T),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(T,G,W,U,C){return super.open(T,w(G),W??!0,U,C)}};const M=importScripts.bind(self);self.importScripts=(...T)=>{M(...T.map(w))},M(d)}.toString()}('${$}'))`;a=a||{},a.name=`${name} -> ${a.name||g.$nc($.toString())}`;const y=new Blob([E],{type:"application/javascript"}),m=URL.createObjectURL(y);return new i(m,a)}}else self.Worker=class extends R.$Klc{constructor(i,$){super(h,i,{name:g.$nc(i.toString()),...$})}};const o=new class{constructor(){this.pid=void 0}exit(i){D()}};class t{constructor(){const $=new MessageChannel,a=new L.$5d;let c=!1;h($.port2,[$.port2]),$.port1.onmessage=E=>{const{data:y}=E;if(!(y instanceof ArrayBuffer)){console.warn("UNKNOWN data received",y);return}const m=S.$se.wrap(new Uint8Array(y,0,y.byteLength));if((0,P.$Fm)(m,2)){c=!0,r("received terminate message from renderer");return}a.fire(m)},this.protocol={onMessage:a.event,send:E=>{if(!c){const y=E.buffer.buffer.slice(E.buffer.byteOffset,E.buffer.byteOffset+E.buffer.byteLength);$.port1.postMessage(y,[y])}}}}}function n(i){return new Promise($=>{const a=i.onMessage(c=>{a.dispose();const E=JSON.parse(c.toString());i.send((0,P.$Em)(0)),$({protocol:i,initData:E})});i.send((0,P.$Em)(1))})}let r=i=>D();function u(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function l(){f.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage($){u($)&&n(i.protocol).then(a=>{f.mark("code/extHost/didWaitForInitData");const c=new F.$Ejc(a.protocol,a.initData,o,null,$.data);s(E=>c.asBrowserUri(E)),r=E=>c.terminate(E)})}}}e.create=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/00124e9e5830e3efc897db71c781899f8a676295/core/vs/workbench/api/worker/extensionHostWorker.js.map
